#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3317
#define LARGE_STATE_COUNT 1722
#define SYMBOL_COUNT 419
#define ALIAS_COUNT 6
#define TOKEN_COUNT 272
#define EXTERNAL_TOKEN_COUNT 33
#define FIELD_COUNT 41
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 138

enum ts_symbol_identifiers {
  sym__identifier = 1,
  anon_sym_LBRACE = 2,
  anon_sym_LBRACE2 = 3,
  anon_sym_RBRACE = 4,
  anon_sym_COLON = 5,
  anon_sym_SEMI = 6,
  anon_sym_package = 7,
  anon_sym_class = 8,
  anon_sym_sub = 9,
  anon_sym_method = 10,
  anon_sym_LPAREN = 11,
  anon_sym_RPAREN = 12,
  anon_sym_continue = 13,
  anon_sym_my = 14,
  anon_sym_state = 15,
  anon_sym_our = 16,
  anon_sym_COMMA = 17,
  anon_sym_try = 18,
  anon_sym_catch = 19,
  anon_sym_finally = 20,
  anon_sym_defer = 21,
  anon_sym_DOT_DOT_DOT = 22,
  anon_sym_else = 23,
  anon_sym_elsif = 24,
  anon_sym_and = 25,
  anon_sym_or = 26,
  anon_sym_DOLLAR = 27,
  anon_sym_LBRACK = 28,
  anon_sym_RBRACK = 29,
  anon_sym_DASH_GT = 30,
  anon_sym_AT = 31,
  anon_sym_PERCENT = 32,
  anon_sym_LT = 33,
  anon_sym_GT = 34,
  anon_sym_LT_LT = 35,
  anon_sym_GT_GT = 36,
  anon_sym_EQ = 37,
  anon_sym_STAR_STAR_EQ = 38,
  anon_sym_PLUS_EQ = 39,
  anon_sym_DASH_EQ = 40,
  anon_sym_DOT_EQ = 41,
  anon_sym_STAR_EQ = 42,
  anon_sym_SLASH_EQ = 43,
  anon_sym_PERCENT_EQ = 44,
  anon_sym_x_EQ = 45,
  anon_sym_AMP_EQ = 46,
  anon_sym_PIPE_EQ = 47,
  anon_sym_CARET_EQ = 48,
  anon_sym_LT_LT_EQ = 49,
  anon_sym_GT_GT_EQ = 50,
  anon_sym_AMP_AMP_EQ = 51,
  anon_sym_PIPE_PIPE_EQ = 52,
  anon_sym_SLASH_SLASH_EQ = 53,
  anon_sym_DOT_DOT = 54,
  anon_sym_STAR_STAR = 55,
  anon_sym_PIPE_PIPE = 56,
  anon_sym_SLASH_SLASH = 57,
  anon_sym_AMP_AMP = 58,
  anon_sym_PIPE = 59,
  anon_sym_AMP = 60,
  anon_sym_GT_GT2 = 61,
  anon_sym_PLUS = 62,
  anon_sym_DASH = 63,
  anon_sym_DOT = 64,
  anon_sym_STAR = 65,
  anon_sym_SLASH = 66,
  anon_sym_x = 67,
  anon_sym_EQ_TILDE = 68,
  anon_sym_BANG_TILDE = 69,
  anon_sym_EQ_EQ = 70,
  anon_sym_BANG_EQ = 71,
  anon_sym_eq = 72,
  anon_sym_ne = 73,
  anon_sym_LT_EQ_GT = 74,
  anon_sym_cmp = 75,
  anon_sym_TILDE_TILDE = 76,
  anon_sym_LT_EQ = 77,
  anon_sym_GT_EQ = 78,
  anon_sym_lt = 79,
  anon_sym_le = 80,
  anon_sym_ge = 81,
  anon_sym_gt = 82,
  anon_sym_isa = 83,
  anon_sym_TILDE = 84,
  anon_sym_BANG = 85,
  anon_sym_PLUS_PLUS = 86,
  anon_sym_DASH_DASH = 87,
  anon_sym_QMARK = 88,
  anon_sym_BSLASH = 89,
  anon_sym_do = 90,
  anon_sym_eval = 91,
  anon_sym_field = 92,
  anon_sym_local = 93,
  anon_sym_require = 94,
  anon_sym_map = 95,
  anon_sym_grep = 96,
  anon_sym_sort = 97,
  anon_sym_goto = 98,
  anon_sym_return = 99,
  anon_sym_undef = 100,
  anon_sym_PERCENT2 = 101,
  anon_sym_DOLLAR_POUND = 102,
  aux_sym__var_indirob_autoquote_token1 = 103,
  anon_sym_EQ_GT = 104,
  anon_sym_use = 105,
  anon_sym_no = 106,
  anon_sym_for = 107,
  anon_sym_foreach = 108,
  anon_sym_last = 109,
  anon_sym_next = 110,
  anon_sym_redo = 111,
  anon_sym_BEGIN = 112,
  anon_sym_INIT = 113,
  anon_sym_CHECK = 114,
  anon_sym_UNITCHECK = 115,
  anon_sym_END = 116,
  anon_sym_ADJUST = 117,
  anon_sym___FILE__ = 118,
  anon_sym___LINE__ = 119,
  anon_sym___PACKAGE__ = 120,
  anon_sym___SUB__ = 121,
  anon_sym_break = 122,
  anon_sym_fork = 123,
  anon_sym_getppid = 124,
  anon_sym_time = 125,
  anon_sym_times = 126,
  anon_sym_wait = 127,
  anon_sym_wantarray = 128,
  anon_sym_abs = 129,
  anon_sym_alarm = 130,
  anon_sym_chop = 131,
  anon_sym_chdir = 132,
  anon_sym_close = 133,
  anon_sym_closedir = 134,
  anon_sym_caller = 135,
  anon_sym_chomp = 136,
  anon_sym_chr = 137,
  anon_sym_cos = 138,
  anon_sym_chroot = 139,
  anon_sym_defined = 140,
  anon_sym_delete = 141,
  anon_sym_dbmclose = 142,
  anon_sym_exists = 143,
  anon_sym_exit = 144,
  anon_sym_eof = 145,
  anon_sym_exp = 146,
  anon_sym_each = 147,
  anon_sym_fc = 148,
  anon_sym_fileno = 149,
  anon_sym_gmtime = 150,
  anon_sym_getc = 151,
  anon_sym_getpgrp = 152,
  anon_sym_getprotobyname = 153,
  anon_sym_getpwname = 154,
  anon_sym_getpwuid = 155,
  anon_sym_getpeername = 156,
  anon_sym_getnetbyname = 157,
  anon_sym_getsockname = 158,
  anon_sym_getgrnam = 159,
  anon_sym_getgrgid = 160,
  anon_sym_hex = 161,
  anon_sym_int = 162,
  anon_sym_keys = 163,
  anon_sym_lc = 164,
  anon_sym_lcfirst = 165,
  anon_sym_length = 166,
  anon_sym_localtime = 167,
  anon_sym_log = 168,
  anon_sym_lock = 169,
  anon_sym_lstat = 170,
  anon_sym_oct = 171,
  anon_sym_ord = 172,
  anon_sym_prototype = 173,
  anon_sym_pop = 174,
  anon_sym_pos = 175,
  anon_sym_quotemeta = 176,
  anon_sym_reset = 177,
  anon_sym_rand = 178,
  anon_sym_rmdir = 179,
  anon_sym_readdir = 180,
  anon_sym_readline = 181,
  anon_sym_readpipe = 182,
  anon_sym_rewinddir = 183,
  anon_sym_readlink = 184,
  anon_sym_ref = 185,
  anon_sym_scalar = 186,
  anon_sym_shift = 187,
  anon_sym_sin = 188,
  anon_sym_sleep = 189,
  anon_sym_sqrt = 190,
  anon_sym_srand = 191,
  anon_sym_stat = 192,
  anon_sym_study = 193,
  anon_sym_tell = 194,
  anon_sym_telldir = 195,
  anon_sym_tied = 196,
  anon_sym_uc = 197,
  anon_sym_ucfirst = 198,
  anon_sym_untie = 199,
  anon_sym_umask = 200,
  anon_sym_values = 201,
  anon_sym_write = 202,
  aux_sym__func1op_token1 = 203,
  sym_comment = 204,
  anon_sym___DATA__ = 205,
  anon_sym___END__ = 206,
  aux_sym___DATA___token1 = 207,
  anon_sym_EOT = 208,
  anon_sym_q = 209,
  anon_sym_qq = 210,
  anon_sym_LBRACK2 = 211,
  anon_sym_DASH_GT_LBRACK = 212,
  anon_sym_LBRACE3 = 213,
  anon_sym_DASH_GT_LBRACE = 214,
  anon_sym_DASH_GT_AT_LBRACK = 215,
  anon_sym_DASH_GT_AT_LBRACE = 216,
  aux_sym__interpolation_fallbacks_token1 = 217,
  anon_sym_qw = 218,
  anon_sym_qx = 219,
  anon_sym_qr = 220,
  anon_sym_m = 221,
  anon_sym_s = 222,
  sym_quoted_regexp_modifiers = 223,
  sym_match_regexp_modifiers = 224,
  sym_substitution_regexp_modifiers = 225,
  sym_transliteration_modifiers = 226,
  aux_sym__interpolated_transliteration_content_token1 = 227,
  anon_sym_tr = 228,
  anon_sym_y = 229,
  sym_version = 230,
  anon_sym_if = 231,
  anon_sym_unless = 232,
  anon_sym_while = 233,
  anon_sym_until = 234,
  aux_sym_autoquoted_bareword_token1 = 235,
  aux_sym__ident_special_token1 = 236,
  aux_sym__bareword_token1 = 237,
  sym_number = 238,
  sym__apostrophe = 239,
  sym__double_quote = 240,
  sym__backtick = 241,
  sym__search_slash = 242,
  sym__PERLY_SEMICOLON = 243,
  sym__PERLY_HEREDOC = 244,
  sym__ctrl_z_hack = 245,
  sym__quotelike_begin = 246,
  sym__quotelike_middle_close = 247,
  sym__quotelike_middle_skip = 248,
  sym__quotelike_end_zw = 249,
  sym__quotelike_end = 250,
  sym__q_string_content = 251,
  sym__qq_string_content = 252,
  sym_escape_sequence = 253,
  sym_escaped_delimiter = 254,
  sym__dollar_in_regexp = 255,
  sym_pod = 256,
  sym__gobbled_content = 257,
  sym__attribute_value_begin = 258,
  sym_attribute_value = 259,
  sym_prototype_or_signature = 260,
  sym__heredoc_delimiter = 261,
  sym__command_heredoc_delimiter = 262,
  sym__heredoc_start = 263,
  sym__heredoc_middle = 264,
  sym_heredoc_end = 265,
  sym__fat_comma_zw = 266,
  sym__brace_end_zw = 267,
  sym__dollar_ident_zw = 268,
  sym__no_interp_whitespace_zw = 269,
  sym__NONASSOC = 270,
  sym__ERROR = 271,
  sym_source_file = 272,
  sym__HASHBRACK = 273,
  sym__PERLY_BRACE_OPEN = 274,
  sym_block = 275,
  sym__fullstmt = 276,
  sym_statement_label = 277,
  sym__semicolon = 278,
  sym__barestmt = 279,
  sym_package_statement = 280,
  sym_class_statement = 281,
  sym_use_version_statement = 282,
  sym_use_statement = 283,
  sym_subroutine_declaration_statement = 284,
  sym_method_declaration_statement = 285,
  sym_phaser_statement = 286,
  sym_conditional_statement = 287,
  sym_loop_statement = 288,
  sym_cstyle_for_statement = 289,
  sym_for_statement = 290,
  sym_try_statement = 291,
  sym_defer_statement = 292,
  sym_expression_statement = 293,
  sym__postfix_expressions = 294,
  sym_postfix_conditional_expression = 295,
  sym_postfix_loop_expression = 296,
  sym_postfix_for_expression = 297,
  sym_yadayada = 298,
  sym__else = 299,
  sym_else = 300,
  sym_elsif = 301,
  sym__expr = 302,
  sym_lowprec_logical_expression = 303,
  sym__listexpr = 304,
  sym__term_rightward = 305,
  sym_list_expression = 306,
  sym__subscripted = 307,
  sym_container_variable = 308,
  sym_array_element_expression = 309,
  sym__hash_key = 310,
  sym_hash_element_expression = 311,
  sym_coderef_call_expression = 312,
  sym_anonymous_slice_expression = 313,
  sym_slice_container_variable = 314,
  sym_slice_expression = 315,
  sym_keyval_container_variable = 316,
  sym_keyval_expression = 317,
  sym__term = 318,
  sym_readline_expression = 319,
  sym_assignment_expression = 320,
  sym_binary_expression = 321,
  sym_equality_expression = 322,
  sym_relational_expression = 323,
  sym_unary_expression = 324,
  sym_preinc_expression = 325,
  sym_postinc_expression = 326,
  sym_conditional_expression = 327,
  sym_refgen_expression = 328,
  sym_anonymous_array_expression = 329,
  sym_anonymous_hash_expression = 330,
  sym_anonymous_subroutine_expression = 331,
  sym_anonymous_method_expression = 332,
  sym_do_expression = 333,
  sym_eval_expression = 334,
  sym_variable_declaration = 335,
  sym__decl_variable_list = 336,
  sym_localization_expression = 337,
  sym_stub_expression = 338,
  sym_scalar_deref_expression = 339,
  sym_array_deref_expression = 340,
  sym_hash_deref_expression = 341,
  sym_amper_deref_expression = 342,
  sym_glob_deref_expression = 343,
  sym_require_expression = 344,
  sym_func0op_call_expression = 345,
  sym_func1op_call_expression = 346,
  sym__tricky_hashref = 347,
  sym_map_grep_expression = 348,
  sym_sort_expression = 349,
  sym__label_arg = 350,
  sym_loopex_expression = 351,
  sym_goto_expression = 352,
  sym_return_expression = 353,
  sym_undef_expression = 354,
  sym__listop = 355,
  sym_function_call_expression = 356,
  sym_indirect_object = 357,
  sym__tricky_indirob_hashref = 358,
  sym_ambiguous_function_call_expression = 359,
  sym_function = 360,
  sym_method_call_expression = 361,
  sym_method = 362,
  sym_scalar = 363,
  sym__declare_scalar = 364,
  sym_array = 365,
  sym__declare_array = 366,
  sym_hash = 367,
  sym__declare_hash = 368,
  sym_arraylen = 369,
  sym_glob = 370,
  sym__indirob = 371,
  sym_varname = 372,
  sym__var_indirob_autoquote = 373,
  sym__var_indirob = 374,
  sym_attrlist = 375,
  sym_attribute = 376,
  sym_attribute_name = 377,
  sym___DATA__ = 378,
  sym__literal = 379,
  sym_string_literal = 380,
  sym_interpolated_string_literal = 381,
  sym__subscripted_interpolations = 382,
  sym__braced_scalar = 383,
  sym__braced_array = 384,
  sym__array_element_interpolation = 385,
  sym__hash_element_interpolation = 386,
  sym__slice_expression_interpolation = 387,
  sym__interpolations = 388,
  aux_sym__noninterpolated_string_content = 389,
  sym__interpolation_fallbacks = 390,
  aux_sym__interpolated_string_content = 391,
  sym_quoted_word_list = 392,
  sym_command_string = 393,
  sym_quoted_regexp = 394,
  sym_match_regexp = 395,
  sym__quotelike_middle = 396,
  sym_substitution_regexp = 397,
  aux_sym__interpolated_regexp_content = 398,
  aux_sym__interpolated_transliteration_content = 399,
  sym_transliteration_expression = 400,
  sym_heredoc_token = 401,
  sym_command_heredoc_token = 402,
  sym_heredoc_content = 403,
  sym_package = 404,
  sym__version = 405,
  sym_autoquoted_bareword = 406,
  sym__fat_comma_autoquoted_bareword = 407,
  sym__brace_autoquoted = 408,
  sym_identifier = 409,
  sym__ident_special = 410,
  sym_bareword = 411,
  sym_primitive = 412,
  aux_sym_source_file_repeat1 = 413,
  aux_sym_for_statement_repeat1 = 414,
  aux_sym__term_rightward_repeat1 = 415,
  aux_sym__decl_variable_list_repeat1 = 416,
  aux_sym_attrlist_repeat1 = 417,
  aux_sym_heredoc_content_repeat1 = 418,
  alias_sym_block_statement = 419,
  alias_sym_data_section = 420,
  alias_sym_label = 421,
  alias_sym_regexp_content = 422,
  alias_sym_replacement = 423,
  alias_sym_transliteration_content = 424,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier] = "_identifier",
  [anon_sym_LBRACE] = "{",
  [anon_sym_LBRACE2] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_COLON] = ":",
  [anon_sym_SEMI] = ";",
  [anon_sym_package] = "package",
  [anon_sym_class] = "class",
  [anon_sym_sub] = "sub",
  [anon_sym_method] = "method",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_continue] = "continue",
  [anon_sym_my] = "my",
  [anon_sym_state] = "state",
  [anon_sym_our] = "our",
  [anon_sym_COMMA] = ",",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_defer] = "defer",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_else] = "else",
  [anon_sym_elsif] = "elsif",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_AT] = "@",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_EQ] = "=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DOT_EQ] = ".=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_x_EQ] = "x=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_GT_GT2] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_DOT] = ".",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_x] = "x",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_eq] = "eq",
  [anon_sym_ne] = "ne",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_cmp] = "cmp",
  [anon_sym_TILDE_TILDE] = "~~",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_lt] = "lt",
  [anon_sym_le] = "le",
  [anon_sym_ge] = "ge",
  [anon_sym_gt] = "gt",
  [anon_sym_isa] = "isa",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_QMARK] = "\?",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_do] = "do",
  [anon_sym_eval] = "eval",
  [anon_sym_field] = "field",
  [anon_sym_local] = "local",
  [anon_sym_require] = "require",
  [anon_sym_map] = "map",
  [anon_sym_grep] = "grep",
  [anon_sym_sort] = "sort",
  [anon_sym_goto] = "goto",
  [anon_sym_return] = "return",
  [anon_sym_undef] = "undef",
  [anon_sym_PERCENT2] = "%",
  [anon_sym_DOLLAR_POUND] = "$#",
  [aux_sym__var_indirob_autoquote_token1] = "varname",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_use] = "use",
  [anon_sym_no] = "no",
  [anon_sym_for] = "for",
  [anon_sym_foreach] = "foreach",
  [anon_sym_last] = "last",
  [anon_sym_next] = "next",
  [anon_sym_redo] = "redo",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_INIT] = "INIT",
  [anon_sym_CHECK] = "CHECK",
  [anon_sym_UNITCHECK] = "UNITCHECK",
  [anon_sym_END] = "END",
  [anon_sym_ADJUST] = "ADJUST",
  [anon_sym___FILE__] = "__FILE__",
  [anon_sym___LINE__] = "__LINE__",
  [anon_sym___PACKAGE__] = "__PACKAGE__",
  [anon_sym___SUB__] = "__SUB__",
  [anon_sym_break] = "break",
  [anon_sym_fork] = "fork",
  [anon_sym_getppid] = "getppid",
  [anon_sym_time] = "time",
  [anon_sym_times] = "times",
  [anon_sym_wait] = "wait",
  [anon_sym_wantarray] = "wantarray",
  [anon_sym_abs] = "abs",
  [anon_sym_alarm] = "alarm",
  [anon_sym_chop] = "chop",
  [anon_sym_chdir] = "chdir",
  [anon_sym_close] = "close",
  [anon_sym_closedir] = "closedir",
  [anon_sym_caller] = "caller",
  [anon_sym_chomp] = "chomp",
  [anon_sym_chr] = "chr",
  [anon_sym_cos] = "cos",
  [anon_sym_chroot] = "chroot",
  [anon_sym_defined] = "defined",
  [anon_sym_delete] = "delete",
  [anon_sym_dbmclose] = "dbmclose",
  [anon_sym_exists] = "exists",
  [anon_sym_exit] = "exit",
  [anon_sym_eof] = "eof",
  [anon_sym_exp] = "exp",
  [anon_sym_each] = "each",
  [anon_sym_fc] = "fc",
  [anon_sym_fileno] = "fileno",
  [anon_sym_gmtime] = "gmtime",
  [anon_sym_getc] = "getc",
  [anon_sym_getpgrp] = "getpgrp",
  [anon_sym_getprotobyname] = "getprotobyname",
  [anon_sym_getpwname] = "getpwname",
  [anon_sym_getpwuid] = "getpwuid",
  [anon_sym_getpeername] = "getpeername",
  [anon_sym_getnetbyname] = "getnetbyname",
  [anon_sym_getsockname] = "getsockname",
  [anon_sym_getgrnam] = "getgrnam",
  [anon_sym_getgrgid] = "getgrgid",
  [anon_sym_hex] = "hex",
  [anon_sym_int] = "int",
  [anon_sym_keys] = "keys",
  [anon_sym_lc] = "lc",
  [anon_sym_lcfirst] = "lcfirst",
  [anon_sym_length] = "length",
  [anon_sym_localtime] = "localtime",
  [anon_sym_log] = "log",
  [anon_sym_lock] = "lock",
  [anon_sym_lstat] = "lstat",
  [anon_sym_oct] = "oct",
  [anon_sym_ord] = "ord",
  [anon_sym_prototype] = "prototype",
  [anon_sym_pop] = "pop",
  [anon_sym_pos] = "pos",
  [anon_sym_quotemeta] = "quotemeta",
  [anon_sym_reset] = "reset",
  [anon_sym_rand] = "rand",
  [anon_sym_rmdir] = "rmdir",
  [anon_sym_readdir] = "readdir",
  [anon_sym_readline] = "readline",
  [anon_sym_readpipe] = "readpipe",
  [anon_sym_rewinddir] = "rewinddir",
  [anon_sym_readlink] = "readlink",
  [anon_sym_ref] = "ref",
  [anon_sym_scalar] = "scalar",
  [anon_sym_shift] = "shift",
  [anon_sym_sin] = "sin",
  [anon_sym_sleep] = "sleep",
  [anon_sym_sqrt] = "sqrt",
  [anon_sym_srand] = "srand",
  [anon_sym_stat] = "stat",
  [anon_sym_study] = "study",
  [anon_sym_tell] = "tell",
  [anon_sym_telldir] = "telldir",
  [anon_sym_tied] = "tied",
  [anon_sym_uc] = "uc",
  [anon_sym_ucfirst] = "ucfirst",
  [anon_sym_untie] = "untie",
  [anon_sym_umask] = "umask",
  [anon_sym_values] = "values",
  [anon_sym_write] = "write",
  [aux_sym__func1op_token1] = "_func1op_token1",
  [sym_comment] = "comment",
  [anon_sym___DATA__] = "__DATA__",
  [anon_sym___END__] = "__END__",
  [aux_sym___DATA___token1] = "__DATA___token1",
  [anon_sym_EOT] = "eof_marker",
  [anon_sym_q] = "q",
  [anon_sym_qq] = "qq",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_DASH_GT_LBRACK] = "->[",
  [anon_sym_LBRACE3] = "{",
  [anon_sym_DASH_GT_LBRACE] = "->{",
  [anon_sym_DASH_GT_AT_LBRACK] = "->@[",
  [anon_sym_DASH_GT_AT_LBRACE] = "->@{",
  [aux_sym__interpolation_fallbacks_token1] = "_interpolation_fallbacks_token1",
  [anon_sym_qw] = "qw",
  [anon_sym_qx] = "qx",
  [anon_sym_qr] = "qr",
  [anon_sym_m] = "m",
  [anon_sym_s] = "s",
  [sym_quoted_regexp_modifiers] = "quoted_regexp_modifiers",
  [sym_match_regexp_modifiers] = "match_regexp_modifiers",
  [sym_substitution_regexp_modifiers] = "substitution_regexp_modifiers",
  [sym_transliteration_modifiers] = "transliteration_modifiers",
  [aux_sym__interpolated_transliteration_content_token1] = "_interpolated_transliteration_content_token1",
  [anon_sym_tr] = "tr",
  [anon_sym_y] = "y",
  [sym_version] = "version",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [aux_sym_autoquoted_bareword_token1] = "autoquoted_bareword_token1",
  [aux_sym__ident_special_token1] = "_ident_special_token1",
  [aux_sym__bareword_token1] = "_bareword_token1",
  [sym_number] = "number",
  [sym__apostrophe] = "_apostrophe",
  [sym__double_quote] = "_double_quote",
  [sym__backtick] = "_backtick",
  [sym__search_slash] = "_search_slash",
  [sym__PERLY_SEMICOLON] = "_PERLY_SEMICOLON",
  [sym__PERLY_HEREDOC] = "_PERLY_HEREDOC",
  [sym__ctrl_z_hack] = "eof_marker",
  [sym__quotelike_begin] = "_quotelike_begin",
  [sym__quotelike_middle_close] = "_quotelike_middle_close",
  [sym__quotelike_middle_skip] = "_quotelike_middle_skip",
  [sym__quotelike_end_zw] = "_quotelike_end_zw",
  [sym__quotelike_end] = "_quotelike_end",
  [sym__q_string_content] = "_q_string_content",
  [sym__qq_string_content] = "_qq_string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_escaped_delimiter] = "escaped_delimiter",
  [sym__dollar_in_regexp] = "_dollar_in_regexp",
  [sym_pod] = "pod",
  [sym__gobbled_content] = "_gobbled_content",
  [sym__attribute_value_begin] = "_attribute_value_begin",
  [sym_attribute_value] = "attribute_value",
  [sym_prototype_or_signature] = "prototype_or_signature",
  [sym__heredoc_delimiter] = "_heredoc_delimiter",
  [sym__command_heredoc_delimiter] = "_command_heredoc_delimiter",
  [sym__heredoc_start] = "_heredoc_start",
  [sym__heredoc_middle] = "_heredoc_middle",
  [sym_heredoc_end] = "heredoc_end",
  [sym__fat_comma_zw] = "_fat_comma_zw",
  [sym__brace_end_zw] = "_brace_end_zw",
  [sym__dollar_ident_zw] = "_dollar_ident_zw",
  [sym__no_interp_whitespace_zw] = "_no_interp_whitespace_zw",
  [sym__NONASSOC] = "_NONASSOC",
  [sym__ERROR] = "_ERROR",
  [sym_source_file] = "source_file",
  [sym__HASHBRACK] = "_HASHBRACK",
  [sym__PERLY_BRACE_OPEN] = "_PERLY_BRACE_OPEN",
  [sym_block] = "block",
  [sym__fullstmt] = "_fullstmt",
  [sym_statement_label] = "statement_label",
  [sym__semicolon] = "_semicolon",
  [sym__barestmt] = "_barestmt",
  [sym_package_statement] = "package_statement",
  [sym_class_statement] = "class_statement",
  [sym_use_version_statement] = "use_version_statement",
  [sym_use_statement] = "use_statement",
  [sym_subroutine_declaration_statement] = "subroutine_declaration_statement",
  [sym_method_declaration_statement] = "method_declaration_statement",
  [sym_phaser_statement] = "phaser_statement",
  [sym_conditional_statement] = "conditional_statement",
  [sym_loop_statement] = "loop_statement",
  [sym_cstyle_for_statement] = "cstyle_for_statement",
  [sym_for_statement] = "for_statement",
  [sym_try_statement] = "try_statement",
  [sym_defer_statement] = "defer_statement",
  [sym_expression_statement] = "expression_statement",
  [sym__postfix_expressions] = "_postfix_expressions",
  [sym_postfix_conditional_expression] = "postfix_conditional_expression",
  [sym_postfix_loop_expression] = "postfix_loop_expression",
  [sym_postfix_for_expression] = "postfix_for_expression",
  [sym_yadayada] = "yadayada",
  [sym__else] = "_else",
  [sym_else] = "else",
  [sym_elsif] = "elsif",
  [sym__expr] = "_expr",
  [sym_lowprec_logical_expression] = "lowprec_logical_expression",
  [sym__listexpr] = "_listexpr",
  [sym__term_rightward] = "_term_rightward",
  [sym_list_expression] = "list_expression",
  [sym__subscripted] = "_subscripted",
  [sym_container_variable] = "container_variable",
  [sym_array_element_expression] = "array_element_expression",
  [sym__hash_key] = "_hash_key",
  [sym_hash_element_expression] = "hash_element_expression",
  [sym_coderef_call_expression] = "coderef_call_expression",
  [sym_anonymous_slice_expression] = "anonymous_slice_expression",
  [sym_slice_container_variable] = "slice_container_variable",
  [sym_slice_expression] = "slice_expression",
  [sym_keyval_container_variable] = "keyval_container_variable",
  [sym_keyval_expression] = "keyval_expression",
  [sym__term] = "_term",
  [sym_readline_expression] = "readline_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_equality_expression] = "equality_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_preinc_expression] = "preinc_expression",
  [sym_postinc_expression] = "postinc_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_refgen_expression] = "refgen_expression",
  [sym_anonymous_array_expression] = "anonymous_array_expression",
  [sym_anonymous_hash_expression] = "anonymous_hash_expression",
  [sym_anonymous_subroutine_expression] = "anonymous_subroutine_expression",
  [sym_anonymous_method_expression] = "anonymous_method_expression",
  [sym_do_expression] = "do_expression",
  [sym_eval_expression] = "eval_expression",
  [sym_variable_declaration] = "variable_declaration",
  [sym__decl_variable_list] = "_decl_variable_list",
  [sym_localization_expression] = "localization_expression",
  [sym_stub_expression] = "stub_expression",
  [sym_scalar_deref_expression] = "scalar_deref_expression",
  [sym_array_deref_expression] = "array_deref_expression",
  [sym_hash_deref_expression] = "hash_deref_expression",
  [sym_amper_deref_expression] = "amper_deref_expression",
  [sym_glob_deref_expression] = "glob_deref_expression",
  [sym_require_expression] = "require_expression",
  [sym_func0op_call_expression] = "func0op_call_expression",
  [sym_func1op_call_expression] = "func1op_call_expression",
  [sym__tricky_hashref] = "anonymous_hash_expression",
  [sym_map_grep_expression] = "map_grep_expression",
  [sym_sort_expression] = "sort_expression",
  [sym__label_arg] = "_label_arg",
  [sym_loopex_expression] = "loopex_expression",
  [sym_goto_expression] = "goto_expression",
  [sym_return_expression] = "return_expression",
  [sym_undef_expression] = "undef_expression",
  [sym__listop] = "_listop",
  [sym_function_call_expression] = "function_call_expression",
  [sym_indirect_object] = "indirect_object",
  [sym__tricky_indirob_hashref] = "anonymous_hash_expression",
  [sym_ambiguous_function_call_expression] = "ambiguous_function_call_expression",
  [sym_function] = "function",
  [sym_method_call_expression] = "method_call_expression",
  [sym_method] = "method",
  [sym_scalar] = "scalar",
  [sym__declare_scalar] = "scalar",
  [sym_array] = "array",
  [sym__declare_array] = "array",
  [sym_hash] = "hash",
  [sym__declare_hash] = "hash",
  [sym_arraylen] = "arraylen",
  [sym_glob] = "glob",
  [sym__indirob] = "filehandle",
  [sym_varname] = "varname",
  [sym__var_indirob_autoquote] = "_var_indirob_autoquote",
  [sym__var_indirob] = "_var_indirob",
  [sym_attrlist] = "attrlist",
  [sym_attribute] = "attribute",
  [sym_attribute_name] = "attribute_name",
  [sym___DATA__] = "__DATA__",
  [sym__literal] = "_literal",
  [sym_string_literal] = "string_literal",
  [sym_interpolated_string_literal] = "interpolated_string_literal",
  [sym__subscripted_interpolations] = "_subscripted_interpolations",
  [sym__braced_scalar] = "scalar",
  [sym__braced_array] = "array",
  [sym__array_element_interpolation] = "array_element_expression",
  [sym__hash_element_interpolation] = "hash_element_expression",
  [sym__slice_expression_interpolation] = "slice_expression",
  [sym__interpolations] = "_interpolations",
  [aux_sym__noninterpolated_string_content] = "_noninterpolated_string_content",
  [sym__interpolation_fallbacks] = "_interpolation_fallbacks",
  [aux_sym__interpolated_string_content] = "_interpolated_string_content",
  [sym_quoted_word_list] = "quoted_word_list",
  [sym_command_string] = "command_string",
  [sym_quoted_regexp] = "quoted_regexp",
  [sym_match_regexp] = "match_regexp",
  [sym__quotelike_middle] = "_quotelike_middle",
  [sym_substitution_regexp] = "substitution_regexp",
  [aux_sym__interpolated_regexp_content] = "_interpolated_regexp_content",
  [aux_sym__interpolated_transliteration_content] = "_interpolated_transliteration_content",
  [sym_transliteration_expression] = "transliteration_expression",
  [sym_heredoc_token] = "heredoc_token",
  [sym_command_heredoc_token] = "command_heredoc_token",
  [sym_heredoc_content] = "heredoc_content",
  [sym_package] = "package",
  [sym__version] = "_version",
  [sym_autoquoted_bareword] = "autoquoted_bareword",
  [sym__fat_comma_autoquoted_bareword] = "_fat_comma_autoquoted_bareword",
  [sym__brace_autoquoted] = "_brace_autoquoted",
  [sym_identifier] = "identifier",
  [sym__ident_special] = "_ident_special",
  [sym_bareword] = "bareword",
  [sym_primitive] = "primitive",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym__term_rightward_repeat1] = "_term_rightward_repeat1",
  [aux_sym__decl_variable_list_repeat1] = "_decl_variable_list_repeat1",
  [aux_sym_attrlist_repeat1] = "attrlist_repeat1",
  [aux_sym_heredoc_content_repeat1] = "heredoc_content_repeat1",
  [alias_sym_block_statement] = "block_statement",
  [alias_sym_data_section] = "data_section",
  [alias_sym_label] = "label",
  [alias_sym_regexp_content] = "regexp_content",
  [alias_sym_replacement] = "replacement",
  [alias_sym_transliteration_content] = "transliteration_content",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier] = sym__identifier,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_method] = anon_sym_method,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_my] = anon_sym_my,
  [anon_sym_state] = anon_sym_state,
  [anon_sym_our] = anon_sym_our,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_elsif] = anon_sym_elsif,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_x_EQ] = anon_sym_x_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_GT_GT2] = anon_sym_GT_GT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_x] = anon_sym_x,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_ne] = anon_sym_ne,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_cmp] = anon_sym_cmp,
  [anon_sym_TILDE_TILDE] = anon_sym_TILDE_TILDE,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_lt] = anon_sym_lt,
  [anon_sym_le] = anon_sym_le,
  [anon_sym_ge] = anon_sym_ge,
  [anon_sym_gt] = anon_sym_gt,
  [anon_sym_isa] = anon_sym_isa,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_eval] = anon_sym_eval,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_map] = anon_sym_map,
  [anon_sym_grep] = anon_sym_grep,
  [anon_sym_sort] = anon_sym_sort,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_PERCENT2] = anon_sym_PERCENT,
  [anon_sym_DOLLAR_POUND] = anon_sym_DOLLAR_POUND,
  [aux_sym__var_indirob_autoquote_token1] = sym_varname,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_no] = anon_sym_no,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_last] = anon_sym_last,
  [anon_sym_next] = anon_sym_next,
  [anon_sym_redo] = anon_sym_redo,
  [anon_sym_BEGIN] = anon_sym_BEGIN,
  [anon_sym_INIT] = anon_sym_INIT,
  [anon_sym_CHECK] = anon_sym_CHECK,
  [anon_sym_UNITCHECK] = anon_sym_UNITCHECK,
  [anon_sym_END] = anon_sym_END,
  [anon_sym_ADJUST] = anon_sym_ADJUST,
  [anon_sym___FILE__] = anon_sym___FILE__,
  [anon_sym___LINE__] = anon_sym___LINE__,
  [anon_sym___PACKAGE__] = anon_sym___PACKAGE__,
  [anon_sym___SUB__] = anon_sym___SUB__,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_fork] = anon_sym_fork,
  [anon_sym_getppid] = anon_sym_getppid,
  [anon_sym_time] = anon_sym_time,
  [anon_sym_times] = anon_sym_times,
  [anon_sym_wait] = anon_sym_wait,
  [anon_sym_wantarray] = anon_sym_wantarray,
  [anon_sym_abs] = anon_sym_abs,
  [anon_sym_alarm] = anon_sym_alarm,
  [anon_sym_chop] = anon_sym_chop,
  [anon_sym_chdir] = anon_sym_chdir,
  [anon_sym_close] = anon_sym_close,
  [anon_sym_closedir] = anon_sym_closedir,
  [anon_sym_caller] = anon_sym_caller,
  [anon_sym_chomp] = anon_sym_chomp,
  [anon_sym_chr] = anon_sym_chr,
  [anon_sym_cos] = anon_sym_cos,
  [anon_sym_chroot] = anon_sym_chroot,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_dbmclose] = anon_sym_dbmclose,
  [anon_sym_exists] = anon_sym_exists,
  [anon_sym_exit] = anon_sym_exit,
  [anon_sym_eof] = anon_sym_eof,
  [anon_sym_exp] = anon_sym_exp,
  [anon_sym_each] = anon_sym_each,
  [anon_sym_fc] = anon_sym_fc,
  [anon_sym_fileno] = anon_sym_fileno,
  [anon_sym_gmtime] = anon_sym_gmtime,
  [anon_sym_getc] = anon_sym_getc,
  [anon_sym_getpgrp] = anon_sym_getpgrp,
  [anon_sym_getprotobyname] = anon_sym_getprotobyname,
  [anon_sym_getpwname] = anon_sym_getpwname,
  [anon_sym_getpwuid] = anon_sym_getpwuid,
  [anon_sym_getpeername] = anon_sym_getpeername,
  [anon_sym_getnetbyname] = anon_sym_getnetbyname,
  [anon_sym_getsockname] = anon_sym_getsockname,
  [anon_sym_getgrnam] = anon_sym_getgrnam,
  [anon_sym_getgrgid] = anon_sym_getgrgid,
  [anon_sym_hex] = anon_sym_hex,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_keys] = anon_sym_keys,
  [anon_sym_lc] = anon_sym_lc,
  [anon_sym_lcfirst] = anon_sym_lcfirst,
  [anon_sym_length] = anon_sym_length,
  [anon_sym_localtime] = anon_sym_localtime,
  [anon_sym_log] = anon_sym_log,
  [anon_sym_lock] = anon_sym_lock,
  [anon_sym_lstat] = anon_sym_lstat,
  [anon_sym_oct] = anon_sym_oct,
  [anon_sym_ord] = anon_sym_ord,
  [anon_sym_prototype] = anon_sym_prototype,
  [anon_sym_pop] = anon_sym_pop,
  [anon_sym_pos] = anon_sym_pos,
  [anon_sym_quotemeta] = anon_sym_quotemeta,
  [anon_sym_reset] = anon_sym_reset,
  [anon_sym_rand] = anon_sym_rand,
  [anon_sym_rmdir] = anon_sym_rmdir,
  [anon_sym_readdir] = anon_sym_readdir,
  [anon_sym_readline] = anon_sym_readline,
  [anon_sym_readpipe] = anon_sym_readpipe,
  [anon_sym_rewinddir] = anon_sym_rewinddir,
  [anon_sym_readlink] = anon_sym_readlink,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_scalar] = anon_sym_scalar,
  [anon_sym_shift] = anon_sym_shift,
  [anon_sym_sin] = anon_sym_sin,
  [anon_sym_sleep] = anon_sym_sleep,
  [anon_sym_sqrt] = anon_sym_sqrt,
  [anon_sym_srand] = anon_sym_srand,
  [anon_sym_stat] = anon_sym_stat,
  [anon_sym_study] = anon_sym_study,
  [anon_sym_tell] = anon_sym_tell,
  [anon_sym_telldir] = anon_sym_telldir,
  [anon_sym_tied] = anon_sym_tied,
  [anon_sym_uc] = anon_sym_uc,
  [anon_sym_ucfirst] = anon_sym_ucfirst,
  [anon_sym_untie] = anon_sym_untie,
  [anon_sym_umask] = anon_sym_umask,
  [anon_sym_values] = anon_sym_values,
  [anon_sym_write] = anon_sym_write,
  [aux_sym__func1op_token1] = aux_sym__func1op_token1,
  [sym_comment] = sym_comment,
  [anon_sym___DATA__] = anon_sym___DATA__,
  [anon_sym___END__] = anon_sym___END__,
  [aux_sym___DATA___token1] = aux_sym___DATA___token1,
  [anon_sym_EOT] = sym__ctrl_z_hack,
  [anon_sym_q] = anon_sym_q,
  [anon_sym_qq] = anon_sym_qq,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [anon_sym_DASH_GT_LBRACK] = anon_sym_DASH_GT_LBRACK,
  [anon_sym_LBRACE3] = anon_sym_LBRACE,
  [anon_sym_DASH_GT_LBRACE] = anon_sym_DASH_GT_LBRACE,
  [anon_sym_DASH_GT_AT_LBRACK] = anon_sym_DASH_GT_AT_LBRACK,
  [anon_sym_DASH_GT_AT_LBRACE] = anon_sym_DASH_GT_AT_LBRACE,
  [aux_sym__interpolation_fallbacks_token1] = aux_sym__interpolation_fallbacks_token1,
  [anon_sym_qw] = anon_sym_qw,
  [anon_sym_qx] = anon_sym_qx,
  [anon_sym_qr] = anon_sym_qr,
  [anon_sym_m] = anon_sym_m,
  [anon_sym_s] = anon_sym_s,
  [sym_quoted_regexp_modifiers] = sym_quoted_regexp_modifiers,
  [sym_match_regexp_modifiers] = sym_match_regexp_modifiers,
  [sym_substitution_regexp_modifiers] = sym_substitution_regexp_modifiers,
  [sym_transliteration_modifiers] = sym_transliteration_modifiers,
  [aux_sym__interpolated_transliteration_content_token1] = aux_sym__interpolated_transliteration_content_token1,
  [anon_sym_tr] = anon_sym_tr,
  [anon_sym_y] = anon_sym_y,
  [sym_version] = sym_version,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_unless] = anon_sym_unless,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_until] = anon_sym_until,
  [aux_sym_autoquoted_bareword_token1] = aux_sym_autoquoted_bareword_token1,
  [aux_sym__ident_special_token1] = aux_sym__ident_special_token1,
  [aux_sym__bareword_token1] = aux_sym__bareword_token1,
  [sym_number] = sym_number,
  [sym__apostrophe] = sym__apostrophe,
  [sym__double_quote] = sym__double_quote,
  [sym__backtick] = sym__backtick,
  [sym__search_slash] = sym__search_slash,
  [sym__PERLY_SEMICOLON] = sym__PERLY_SEMICOLON,
  [sym__PERLY_HEREDOC] = sym__PERLY_HEREDOC,
  [sym__ctrl_z_hack] = sym__ctrl_z_hack,
  [sym__quotelike_begin] = sym__quotelike_begin,
  [sym__quotelike_middle_close] = sym__quotelike_middle_close,
  [sym__quotelike_middle_skip] = sym__quotelike_middle_skip,
  [sym__quotelike_end_zw] = sym__quotelike_end_zw,
  [sym__quotelike_end] = sym__quotelike_end,
  [sym__q_string_content] = sym__q_string_content,
  [sym__qq_string_content] = sym__qq_string_content,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_escaped_delimiter] = sym_escaped_delimiter,
  [sym__dollar_in_regexp] = sym__dollar_in_regexp,
  [sym_pod] = sym_pod,
  [sym__gobbled_content] = sym__gobbled_content,
  [sym__attribute_value_begin] = sym__attribute_value_begin,
  [sym_attribute_value] = sym_attribute_value,
  [sym_prototype_or_signature] = sym_prototype_or_signature,
  [sym__heredoc_delimiter] = sym__heredoc_delimiter,
  [sym__command_heredoc_delimiter] = sym__command_heredoc_delimiter,
  [sym__heredoc_start] = sym__heredoc_start,
  [sym__heredoc_middle] = sym__heredoc_middle,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym__fat_comma_zw] = sym__fat_comma_zw,
  [sym__brace_end_zw] = sym__brace_end_zw,
  [sym__dollar_ident_zw] = sym__dollar_ident_zw,
  [sym__no_interp_whitespace_zw] = sym__no_interp_whitespace_zw,
  [sym__NONASSOC] = sym__NONASSOC,
  [sym__ERROR] = sym__ERROR,
  [sym_source_file] = sym_source_file,
  [sym__HASHBRACK] = sym__HASHBRACK,
  [sym__PERLY_BRACE_OPEN] = sym__PERLY_BRACE_OPEN,
  [sym_block] = sym_block,
  [sym__fullstmt] = sym__fullstmt,
  [sym_statement_label] = sym_statement_label,
  [sym__semicolon] = sym__semicolon,
  [sym__barestmt] = sym__barestmt,
  [sym_package_statement] = sym_package_statement,
  [sym_class_statement] = sym_class_statement,
  [sym_use_version_statement] = sym_use_version_statement,
  [sym_use_statement] = sym_use_statement,
  [sym_subroutine_declaration_statement] = sym_subroutine_declaration_statement,
  [sym_method_declaration_statement] = sym_method_declaration_statement,
  [sym_phaser_statement] = sym_phaser_statement,
  [sym_conditional_statement] = sym_conditional_statement,
  [sym_loop_statement] = sym_loop_statement,
  [sym_cstyle_for_statement] = sym_cstyle_for_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_defer_statement] = sym_defer_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym__postfix_expressions] = sym__postfix_expressions,
  [sym_postfix_conditional_expression] = sym_postfix_conditional_expression,
  [sym_postfix_loop_expression] = sym_postfix_loop_expression,
  [sym_postfix_for_expression] = sym_postfix_for_expression,
  [sym_yadayada] = sym_yadayada,
  [sym__else] = sym__else,
  [sym_else] = sym_else,
  [sym_elsif] = sym_elsif,
  [sym__expr] = sym__expr,
  [sym_lowprec_logical_expression] = sym_lowprec_logical_expression,
  [sym__listexpr] = sym__listexpr,
  [sym__term_rightward] = sym__term_rightward,
  [sym_list_expression] = sym_list_expression,
  [sym__subscripted] = sym__subscripted,
  [sym_container_variable] = sym_container_variable,
  [sym_array_element_expression] = sym_array_element_expression,
  [sym__hash_key] = sym__hash_key,
  [sym_hash_element_expression] = sym_hash_element_expression,
  [sym_coderef_call_expression] = sym_coderef_call_expression,
  [sym_anonymous_slice_expression] = sym_anonymous_slice_expression,
  [sym_slice_container_variable] = sym_slice_container_variable,
  [sym_slice_expression] = sym_slice_expression,
  [sym_keyval_container_variable] = sym_keyval_container_variable,
  [sym_keyval_expression] = sym_keyval_expression,
  [sym__term] = sym__term,
  [sym_readline_expression] = sym_readline_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_equality_expression] = sym_equality_expression,
  [sym_relational_expression] = sym_relational_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_preinc_expression] = sym_preinc_expression,
  [sym_postinc_expression] = sym_postinc_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_refgen_expression] = sym_refgen_expression,
  [sym_anonymous_array_expression] = sym_anonymous_array_expression,
  [sym_anonymous_hash_expression] = sym_anonymous_hash_expression,
  [sym_anonymous_subroutine_expression] = sym_anonymous_subroutine_expression,
  [sym_anonymous_method_expression] = sym_anonymous_method_expression,
  [sym_do_expression] = sym_do_expression,
  [sym_eval_expression] = sym_eval_expression,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__decl_variable_list] = sym__decl_variable_list,
  [sym_localization_expression] = sym_localization_expression,
  [sym_stub_expression] = sym_stub_expression,
  [sym_scalar_deref_expression] = sym_scalar_deref_expression,
  [sym_array_deref_expression] = sym_array_deref_expression,
  [sym_hash_deref_expression] = sym_hash_deref_expression,
  [sym_amper_deref_expression] = sym_amper_deref_expression,
  [sym_glob_deref_expression] = sym_glob_deref_expression,
  [sym_require_expression] = sym_require_expression,
  [sym_func0op_call_expression] = sym_func0op_call_expression,
  [sym_func1op_call_expression] = sym_func1op_call_expression,
  [sym__tricky_hashref] = sym_anonymous_hash_expression,
  [sym_map_grep_expression] = sym_map_grep_expression,
  [sym_sort_expression] = sym_sort_expression,
  [sym__label_arg] = sym__label_arg,
  [sym_loopex_expression] = sym_loopex_expression,
  [sym_goto_expression] = sym_goto_expression,
  [sym_return_expression] = sym_return_expression,
  [sym_undef_expression] = sym_undef_expression,
  [sym__listop] = sym__listop,
  [sym_function_call_expression] = sym_function_call_expression,
  [sym_indirect_object] = sym_indirect_object,
  [sym__tricky_indirob_hashref] = sym_anonymous_hash_expression,
  [sym_ambiguous_function_call_expression] = sym_ambiguous_function_call_expression,
  [sym_function] = sym_function,
  [sym_method_call_expression] = sym_method_call_expression,
  [sym_method] = sym_method,
  [sym_scalar] = sym_scalar,
  [sym__declare_scalar] = sym_scalar,
  [sym_array] = sym_array,
  [sym__declare_array] = sym_array,
  [sym_hash] = sym_hash,
  [sym__declare_hash] = sym_hash,
  [sym_arraylen] = sym_arraylen,
  [sym_glob] = sym_glob,
  [sym__indirob] = sym__indirob,
  [sym_varname] = sym_varname,
  [sym__var_indirob_autoquote] = sym__var_indirob_autoquote,
  [sym__var_indirob] = sym__var_indirob,
  [sym_attrlist] = sym_attrlist,
  [sym_attribute] = sym_attribute,
  [sym_attribute_name] = sym_attribute_name,
  [sym___DATA__] = sym___DATA__,
  [sym__literal] = sym__literal,
  [sym_string_literal] = sym_string_literal,
  [sym_interpolated_string_literal] = sym_interpolated_string_literal,
  [sym__subscripted_interpolations] = sym__subscripted_interpolations,
  [sym__braced_scalar] = sym_scalar,
  [sym__braced_array] = sym_array,
  [sym__array_element_interpolation] = sym_array_element_expression,
  [sym__hash_element_interpolation] = sym_hash_element_expression,
  [sym__slice_expression_interpolation] = sym_slice_expression,
  [sym__interpolations] = sym__interpolations,
  [aux_sym__noninterpolated_string_content] = aux_sym__noninterpolated_string_content,
  [sym__interpolation_fallbacks] = sym__interpolation_fallbacks,
  [aux_sym__interpolated_string_content] = aux_sym__interpolated_string_content,
  [sym_quoted_word_list] = sym_quoted_word_list,
  [sym_command_string] = sym_command_string,
  [sym_quoted_regexp] = sym_quoted_regexp,
  [sym_match_regexp] = sym_match_regexp,
  [sym__quotelike_middle] = sym__quotelike_middle,
  [sym_substitution_regexp] = sym_substitution_regexp,
  [aux_sym__interpolated_regexp_content] = aux_sym__interpolated_regexp_content,
  [aux_sym__interpolated_transliteration_content] = aux_sym__interpolated_transliteration_content,
  [sym_transliteration_expression] = sym_transliteration_expression,
  [sym_heredoc_token] = sym_heredoc_token,
  [sym_command_heredoc_token] = sym_command_heredoc_token,
  [sym_heredoc_content] = sym_heredoc_content,
  [sym_package] = sym_package,
  [sym__version] = sym__version,
  [sym_autoquoted_bareword] = sym_autoquoted_bareword,
  [sym__fat_comma_autoquoted_bareword] = sym__fat_comma_autoquoted_bareword,
  [sym__brace_autoquoted] = sym__brace_autoquoted,
  [sym_identifier] = sym_identifier,
  [sym__ident_special] = sym__ident_special,
  [sym_bareword] = sym_bareword,
  [sym_primitive] = sym_primitive,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym__term_rightward_repeat1] = aux_sym__term_rightward_repeat1,
  [aux_sym__decl_variable_list_repeat1] = aux_sym__decl_variable_list_repeat1,
  [aux_sym_attrlist_repeat1] = aux_sym_attrlist_repeat1,
  [aux_sym_heredoc_content_repeat1] = aux_sym_heredoc_content_repeat1,
  [alias_sym_block_statement] = alias_sym_block_statement,
  [alias_sym_data_section] = alias_sym_data_section,
  [alias_sym_label] = alias_sym_label,
  [alias_sym_regexp_content] = alias_sym_regexp_content,
  [alias_sym_replacement] = alias_sym_replacement,
  [alias_sym_transliteration_content] = alias_sym_transliteration_content,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_method] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_my] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_state] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_our] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ne] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cmp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_le] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isa] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_grep] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__var_indirob_autoquote_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_no] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_last] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_redo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_INIT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CHECK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UNITCHECK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ADJUST] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___FILE__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___LINE__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___PACKAGE__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___SUB__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fork] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getppid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_time] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_times] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_wait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_wantarray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alarm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chdir] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_close] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_closedir] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_caller] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chomp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cos] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chroot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dbmclose] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exists] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_each] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fileno] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gmtime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getpgrp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getprotobyname] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getpwname] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getpwuid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getpeername] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getnetbyname] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getsockname] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getgrnam] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getgrgid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hex] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keys] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lcfirst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_length] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_localtime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lstat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_oct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ord] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prototype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pos] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quotemeta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rmdir] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readdir] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readpipe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rewinddir] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readlink] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_scalar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shift] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sleep] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sqrt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_srand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_study] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tell] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_telldir] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tied] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ucfirst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_untie] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_umask] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_values] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_write] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__func1op_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym___DATA__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [aux_sym___DATA___token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_EOT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_q] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_qq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_AT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpolation_fallbacks_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_qw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_qx] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_qr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_m] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_s] = {
    .visible = true,
    .named = false,
  },
  [sym_quoted_regexp_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_match_regexp_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_substitution_regexp_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_transliteration_modifiers] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpolated_transliteration_content_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_tr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_y] = {
    .visible = true,
    .named = false,
  },
  [sym_version] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_autoquoted_bareword_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__ident_special_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__bareword_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym__apostrophe] = {
    .visible = false,
    .named = true,
  },
  [sym__double_quote] = {
    .visible = false,
    .named = true,
  },
  [sym__backtick] = {
    .visible = false,
    .named = true,
  },
  [sym__search_slash] = {
    .visible = false,
    .named = true,
  },
  [sym__PERLY_SEMICOLON] = {
    .visible = false,
    .named = true,
  },
  [sym__PERLY_HEREDOC] = {
    .visible = false,
    .named = true,
  },
  [sym__ctrl_z_hack] = {
    .visible = true,
    .named = true,
  },
  [sym__quotelike_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__quotelike_middle_close] = {
    .visible = false,
    .named = true,
  },
  [sym__quotelike_middle_skip] = {
    .visible = false,
    .named = true,
  },
  [sym__quotelike_end_zw] = {
    .visible = false,
    .named = true,
  },
  [sym__quotelike_end] = {
    .visible = false,
    .named = true,
  },
  [sym__q_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__qq_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_escaped_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym__dollar_in_regexp] = {
    .visible = false,
    .named = true,
  },
  [sym_pod] = {
    .visible = true,
    .named = true,
  },
  [sym__gobbled_content] = {
    .visible = false,
    .named = true,
  },
  [sym__attribute_value_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_prototype_or_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__heredoc_delimiter] = {
    .visible = false,
    .named = true,
  },
  [sym__command_heredoc_delimiter] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_start] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_middle] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym__fat_comma_zw] = {
    .visible = false,
    .named = true,
  },
  [sym__brace_end_zw] = {
    .visible = false,
    .named = true,
  },
  [sym__dollar_ident_zw] = {
    .visible = false,
    .named = true,
  },
  [sym__no_interp_whitespace_zw] = {
    .visible = false,
    .named = true,
  },
  [sym__NONASSOC] = {
    .visible = false,
    .named = true,
  },
  [sym__ERROR] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__HASHBRACK] = {
    .visible = false,
    .named = true,
  },
  [sym__PERLY_BRACE_OPEN] = {
    .visible = false,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__fullstmt] = {
    .visible = false,
    .named = true,
  },
  [sym_statement_label] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__barestmt] = {
    .visible = false,
    .named = true,
  },
  [sym_package_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_use_version_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_use_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subroutine_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_phaser_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_cstyle_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__postfix_expressions] = {
    .visible = false,
    .named = true,
  },
  [sym_postfix_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_yadayada] = {
    .visible = true,
    .named = true,
  },
  [sym__else] = {
    .visible = false,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
  },
  [sym_lowprec_logical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__listexpr] = {
    .visible = false,
    .named = true,
  },
  [sym__term_rightward] = {
    .visible = false,
    .named = true,
  },
  [sym_list_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__subscripted] = {
    .visible = false,
    .named = true,
  },
  [sym_container_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_array_element_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_key] = {
    .visible = false,
    .named = true,
  },
  [sym_hash_element_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_coderef_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_container_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_keyval_container_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_keyval_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__term] = {
    .visible = false,
    .named = true,
  },
  [sym_readline_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preinc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postinc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_refgen_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_hash_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_subroutine_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_method_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_do_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_eval_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__decl_variable_list] = {
    .visible = false,
    .named = true,
  },
  [sym_localization_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_stub_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scalar_deref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_deref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_deref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_amper_deref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_glob_deref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_func0op_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_func1op_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__tricky_hashref] = {
    .visible = true,
    .named = true,
  },
  [sym_map_grep_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sort_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__label_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_loopex_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_undef_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__listop] = {
    .visible = false,
    .named = true,
  },
  [sym_function_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_indirect_object] = {
    .visible = true,
    .named = true,
  },
  [sym__tricky_indirob_hashref] = {
    .visible = true,
    .named = true,
  },
  [sym_ambiguous_function_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_method_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_scalar] = {
    .visible = true,
    .named = true,
  },
  [sym__declare_scalar] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym__declare_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym__declare_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_arraylen] = {
    .visible = true,
    .named = true,
  },
  [sym_glob] = {
    .visible = true,
    .named = true,
  },
  [sym__indirob] = {
    .visible = true,
    .named = true,
  },
  [sym_varname] = {
    .visible = true,
    .named = true,
  },
  [sym__var_indirob_autoquote] = {
    .visible = false,
    .named = true,
  },
  [sym__var_indirob] = {
    .visible = false,
    .named = true,
  },
  [sym_attrlist] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [sym___DATA__] = {
    .visible = false,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__subscripted_interpolations] = {
    .visible = false,
    .named = true,
  },
  [sym__braced_scalar] = {
    .visible = true,
    .named = true,
  },
  [sym__braced_array] = {
    .visible = true,
    .named = true,
  },
  [sym__array_element_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_element_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__slice_expression_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolations] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__noninterpolated_string_content] = {
    .visible = false,
    .named = false,
  },
  [sym__interpolation_fallbacks] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__interpolated_string_content] = {
    .visible = false,
    .named = false,
  },
  [sym_quoted_word_list] = {
    .visible = true,
    .named = true,
  },
  [sym_command_string] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_regexp] = {
    .visible = true,
    .named = true,
  },
  [sym_match_regexp] = {
    .visible = true,
    .named = true,
  },
  [sym__quotelike_middle] = {
    .visible = false,
    .named = true,
  },
  [sym_substitution_regexp] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpolated_regexp_content] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpolated_transliteration_content] = {
    .visible = false,
    .named = false,
  },
  [sym_transliteration_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_token] = {
    .visible = true,
    .named = true,
  },
  [sym_command_heredoc_token] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_content] = {
    .visible = true,
    .named = true,
  },
  [sym_package] = {
    .visible = true,
    .named = true,
  },
  [sym__version] = {
    .visible = false,
    .named = true,
  },
  [sym_autoquoted_bareword] = {
    .visible = true,
    .named = true,
  },
  [sym__fat_comma_autoquoted_bareword] = {
    .visible = false,
    .named = true,
  },
  [sym__brace_autoquoted] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__ident_special] = {
    .visible = false,
    .named = true,
  },
  [sym_bareword] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__term_rightward_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__decl_variable_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attrlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_block_statement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_data_section] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_label] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_regexp_content] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_replacement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_transliteration_content] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_arguments = 2,
  field_array = 3,
  field_arrayref = 4,
  field_attributes = 5,
  field_block = 6,
  field_body = 7,
  field_callback = 8,
  field_catch_block = 9,
  field_catch_expr = 10,
  field_condition = 11,
  field_consequent = 12,
  field_content = 13,
  field_continue = 14,
  field_finally_block = 15,
  field_function = 16,
  field_hash = 17,
  field_hashref = 18,
  field_index = 19,
  field_initialiser = 20,
  field_invocant = 21,
  field_iterator = 22,
  field_key = 23,
  field_label = 24,
  field_left = 25,
  field_list = 26,
  field_loopex = 27,
  field_method = 28,
  field_modifiers = 29,
  field_module = 30,
  field_name = 31,
  field_operand = 32,
  field_operator = 33,
  field_phase = 34,
  field_right = 35,
  field_statement = 36,
  field_try_block = 37,
  field_value = 38,
  field_variable = 39,
  field_variables = 40,
  field_version = 41,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_array] = "array",
  [field_arrayref] = "arrayref",
  [field_attributes] = "attributes",
  [field_block] = "block",
  [field_body] = "body",
  [field_callback] = "callback",
  [field_catch_block] = "catch_block",
  [field_catch_expr] = "catch_expr",
  [field_condition] = "condition",
  [field_consequent] = "consequent",
  [field_content] = "content",
  [field_continue] = "continue",
  [field_finally_block] = "finally_block",
  [field_function] = "function",
  [field_hash] = "hash",
  [field_hashref] = "hashref",
  [field_index] = "index",
  [field_initialiser] = "initialiser",
  [field_invocant] = "invocant",
  [field_iterator] = "iterator",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_list] = "list",
  [field_loopex] = "loopex",
  [field_method] = "method",
  [field_modifiers] = "modifiers",
  [field_module] = "module",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_phase] = "phase",
  [field_right] = "right",
  [field_statement] = "statement",
  [field_try_block] = "try_block",
  [field_value] = "value",
  [field_variable] = "variable",
  [field_variables] = "variables",
  [field_version] = "version",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 2},
  [6] = {.index = 6, .length = 4},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 1},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 17, .length = 1},
  [17] = {.index = 18, .length = 2},
  [18] = {.index = 20, .length = 2},
  [19] = {.index = 22, .length = 1},
  [21] = {.index = 23, .length = 1},
  [22] = {.index = 24, .length = 2},
  [23] = {.index = 0, .length = 1},
  [24] = {.index = 26, .length = 2},
  [25] = {.index = 28, .length = 1},
  [26] = {.index = 29, .length = 1},
  [27] = {.index = 30, .length = 1},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 1},
  [30] = {.index = 33, .length = 2},
  [31] = {.index = 35, .length = 2},
  [33] = {.index = 37, .length = 2},
  [34] = {.index = 39, .length = 1},
  [35] = {.index = 40, .length = 1},
  [37] = {.index = 41, .length = 1},
  [38] = {.index = 42, .length = 3},
  [39] = {.index = 45, .length = 1},
  [40] = {.index = 46, .length = 1},
  [41] = {.index = 47, .length = 2},
  [42] = {.index = 49, .length = 2},
  [43] = {.index = 51, .length = 2},
  [44] = {.index = 53, .length = 2},
  [45] = {.index = 55, .length = 2},
  [46] = {.index = 57, .length = 1},
  [47] = {.index = 58, .length = 2},
  [48] = {.index = 60, .length = 2},
  [49] = {.index = 62, .length = 2},
  [50] = {.index = 64, .length = 2},
  [51] = {.index = 66, .length = 2},
  [52] = {.index = 68, .length = 2},
  [53] = {.index = 70, .length = 2},
  [54] = {.index = 72, .length = 2},
  [55] = {.index = 74, .length = 1},
  [56] = {.index = 75, .length = 1},
  [57] = {.index = 76, .length = 2},
  [58] = {.index = 78, .length = 2},
  [59] = {.index = 80, .length = 1},
  [60] = {.index = 81, .length = 1},
  [61] = {.index = 82, .length = 1},
  [62] = {.index = 83, .length = 2},
  [63] = {.index = 85, .length = 2},
  [64] = {.index = 87, .length = 1},
  [65] = {.index = 88, .length = 1},
  [66] = {.index = 89, .length = 3},
  [67] = {.index = 92, .length = 1},
  [68] = {.index = 85, .length = 2},
  [69] = {.index = 83, .length = 2},
  [70] = {.index = 93, .length = 1},
  [71] = {.index = 94, .length = 1},
  [72] = {.index = 88, .length = 1},
  [73] = {.index = 87, .length = 1},
  [74] = {.index = 95, .length = 2},
  [75] = {.index = 97, .length = 2},
  [76] = {.index = 99, .length = 2},
  [77] = {.index = 101, .length = 3},
  [79] = {.index = 104, .length = 1},
  [80] = {.index = 105, .length = 2},
  [81] = {.index = 107, .length = 2},
  [82] = {.index = 109, .length = 3},
  [83] = {.index = 112, .length = 2},
  [84] = {.index = 41, .length = 1},
  [85] = {.index = 78, .length = 2},
  [86] = {.index = 114, .length = 2},
  [87] = {.index = 116, .length = 1},
  [88] = {.index = 117, .length = 1},
  [89] = {.index = 118, .length = 1},
  [90] = {.index = 119, .length = 3},
  [91] = {.index = 122, .length = 2},
  [92] = {.index = 124, .length = 3},
  [93] = {.index = 127, .length = 3},
  [94] = {.index = 130, .length = 3},
  [96] = {.index = 133, .length = 2},
  [97] = {.index = 135, .length = 3},
  [98] = {.index = 138, .length = 3},
  [99] = {.index = 78, .length = 2},
  [100] = {.index = 141, .length = 2},
  [101] = {.index = 138, .length = 3},
  [102] = {.index = 78, .length = 2},
  [103] = {.index = 143, .length = 4},
  [104] = {.index = 147, .length = 3},
  [105] = {.index = 150, .length = 2},
  [106] = {.index = 152, .length = 2},
  [107] = {.index = 154, .length = 3},
  [108] = {.index = 157, .length = 2},
  [109] = {.index = 159, .length = 1},
  [110] = {.index = 160, .length = 1},
  [111] = {.index = 161, .length = 1},
  [112] = {.index = 162, .length = 3},
  [113] = {.index = 165, .length = 3},
  [114] = {.index = 168, .length = 3},
  [115] = {.index = 168, .length = 3},
  [116] = {.index = 171, .length = 3},
  [117] = {.index = 174, .length = 1},
  [118] = {.index = 175, .length = 2},
  [119] = {.index = 177, .length = 2},
  [120] = {.index = 179, .length = 2},
  [121] = {.index = 181, .length = 4},
  [122] = {.index = 185, .length = 4},
  [123] = {.index = 189, .length = 4},
  [124] = {.index = 193, .length = 2},
  [125] = {.index = 195, .length = 2},
  [126] = {.index = 197, .length = 2},
  [127] = {.index = 199, .length = 3},
  [128] = {.index = 202, .length = 5},
  [129] = {.index = 207, .length = 4},
  [130] = {.index = 211, .length = 3},
  [131] = {.index = 214, .length = 3},
  [132] = {.index = 217, .length = 3},
  [133] = {.index = 220, .length = 5},
  [134] = {.index = 225, .length = 6},
  [135] = {.index = 231, .length = 4},
  [136] = {.index = 235, .length = 6},
  [137] = {.index = 241, .length = 7},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_function, 0},
  [1] =
    {field_loopex, 0},
  [2] =
    {field_array, 0, .inherited = true},
    {field_index, 0, .inherited = true},
  [4] =
    {field_hash, 0, .inherited = true},
    {field_key, 0, .inherited = true},
  [6] =
    {field_array, 0, .inherited = true},
    {field_arrayref, 0, .inherited = true},
    {field_hash, 0, .inherited = true},
    {field_hashref, 0, .inherited = true},
  [10] =
    {field_body, 1},
  [11] =
    {field_variables, 1},
  [12] =
    {field_variable, 1},
  [13] =
    {field_try_block, 1},
  [14] =
    {field_block, 1},
  [15] =
    {field_operator, 0},
    {field_operator, 1},
  [17] =
    {field_modifiers, 1},
  [18] =
    {field_operand, 1},
    {field_operator, 0},
  [20] =
    {field_function, 0},
    {field_function, 1},
  [22] =
    {field_list, 1},
  [23] =
    {field_phase, 0},
  [24] =
    {field_operand, 0},
    {field_operator, 1},
  [26] =
    {field_arguments, 1},
    {field_function, 0},
  [28] =
    {field_modifiers, 2},
  [29] =
    {field_content, 1},
  [30] =
    {field_name, 1},
  [31] =
    {field_body, 2},
  [32] =
    {field_name, 0},
  [33] =
    {field_body, 2},
    {field_name, 1},
  [35] =
    {field_operator, 0},
    {field_operator, 2},
  [37] =
    {field_callback, 1},
    {field_list, 2},
  [39] =
    {field_module, 1},
  [40] =
    {field_version, 1},
  [41] =
    {field_operator, 0},
  [42] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [45] =
    {field_list, 2},
  [46] =
    {field_condition, 2},
  [47] =
    {field_invocant, 0},
    {field_method, 2},
  [49] =
    {field_arguments, 2},
    {field_function, 0},
  [51] =
    {field_label, 0},
    {field_statement, 2},
  [53] =
    {field_content, 1},
    {field_modifiers, 3},
  [55] =
    {field_name, 1},
    {field_version, 2},
  [57] =
    {field_body, 3},
  [58] =
    {field_attributes, 2},
    {field_body, 3},
  [60] =
    {field_body, 3},
    {field_name, 1},
  [62] =
    {field_attributes, 3},
    {field_variables, 1},
  [64] =
    {field_attributes, 3},
    {field_variable, 1},
  [66] =
    {field_catch_block, 3},
    {field_try_block, 1},
  [68] =
    {field_finally_block, 3},
    {field_try_block, 1},
  [70] =
    {field_callback, 1},
    {field_list, 3},
  [72] =
    {field_module, 1},
    {field_version, 2},
  [74] =
    {field_modifiers, 3},
  [75] =
    {field_content, 2},
  [76] =
    {field_modifiers, 3},
    {field_operator, 0},
  [78] =
    {field_content, 2},
    {field_operator, 0},
  [80] =
    {field_key, 2},
  [81] =
    {field_arguments, 2},
  [82] =
    {field_index, 2},
  [83] =
    {field_hash, 0},
    {field_key, 2},
  [85] =
    {field_array, 0},
    {field_index, 2},
  [87] =
    {field_hash, 0},
  [88] =
    {field_array, 0},
  [89] =
    {field_arguments, 1},
    {field_arguments, 3},
    {field_function, 0},
  [92] =
    {field_list, 0},
  [93] =
    {field_arrayref, 0},
  [94] =
    {field_hashref, 0},
  [95] =
    {field_attributes, 3},
    {field_name, 1},
  [97] =
    {field_attributes, 2},
    {field_body, 4},
  [99] =
    {field_body, 4},
    {field_name, 1},
  [101] =
    {field_attributes, 3},
    {field_body, 4},
    {field_name, 1},
  [104] =
    {field_list, 3},
  [105] =
    {field_block, 4},
    {field_list, 2},
  [107] =
    {field_content, 2},
    {field_modifiers, 4},
  [109] =
    {field_content, 2},
    {field_modifiers, 4},
    {field_operator, 0},
  [112] =
    {field_modifiers, 4},
    {field_operator, 0},
  [114] =
    {field_block, 4},
    {field_condition, 2},
  [116] =
    {field_key, 3},
  [117] =
    {field_arguments, 3},
  [118] =
    {field_index, 3},
  [119] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequent, 2},
  [122] =
    {field_arguments, 3},
    {field_function, 0},
  [124] =
    {field_attributes, 4},
    {field_name, 1},
    {field_version, 2},
  [127] =
    {field_attributes, 3},
    {field_body, 5},
    {field_name, 1},
  [130] =
    {field_catch_block, 3},
    {field_finally_block, 5},
    {field_try_block, 1},
  [133] =
    {field_callback, 3},
    {field_list, 4},
  [135] =
    {field_block, 5},
    {field_list, 3},
    {field_variable, 1},
  [138] =
    {field_content, 2},
    {field_modifiers, 5},
    {field_operator, 0},
  [141] =
    {field_modifiers, 5},
    {field_operator, 0},
  [143] =
    {field_left, 0},
    {field_operator, 1},
    {field_operator, 3},
    {field_right, 2},
  [147] =
    {field_arguments, 4},
    {field_invocant, 0},
    {field_method, 2},
  [150] =
    {field_arguments, 4},
    {field_function, 0},
  [152] =
    {field_name, 0},
    {field_value, 3},
  [154] =
    {field_catch_block, 6},
    {field_catch_expr, 4},
    {field_try_block, 1},
  [157] =
    {field_callback, 3},
    {field_list, 5},
  [159] =
    {field_iterator, 4},
  [160] =
    {field_condition, 3},
  [161] =
    {field_initialiser, 2},
  [162] =
    {field_block, 4},
    {field_continue, 6},
    {field_list, 2},
  [165] =
    {field_block, 6},
    {field_list, 4},
    {field_variable, 2},
  [168] =
    {field_content, 2},
    {field_modifiers, 6},
    {field_operator, 0},
  [171] =
    {field_block, 4},
    {field_condition, 2},
    {field_continue, 6},
  [174] =
    {field_continue, 7},
  [175] =
    {field_condition, 3},
    {field_iterator, 5},
  [177] =
    {field_initialiser, 2},
    {field_iterator, 5},
  [179] =
    {field_condition, 4},
    {field_initialiser, 2},
  [181] =
    {field_block, 7},
    {field_list, 5},
    {field_variables, 2},
    {field_variables, 3},
  [185] =
    {field_block, 5},
    {field_continue, 7},
    {field_list, 3},
    {field_variable, 1},
  [189] =
    {field_catch_block, 6},
    {field_catch_expr, 4},
    {field_finally_block, 8},
    {field_try_block, 1},
  [193] =
    {field_continue, 8},
    {field_iterator, 4},
  [195] =
    {field_condition, 3},
    {field_continue, 8},
  [197] =
    {field_continue, 8},
    {field_initialiser, 2},
  [199] =
    {field_condition, 4},
    {field_initialiser, 2},
    {field_iterator, 6},
  [202] =
    {field_block, 8},
    {field_list, 6},
    {field_variables, 2},
    {field_variables, 3},
    {field_variables, 4},
  [207] =
    {field_block, 6},
    {field_continue, 8},
    {field_list, 4},
    {field_variable, 2},
  [211] =
    {field_condition, 3},
    {field_continue, 9},
    {field_iterator, 5},
  [214] =
    {field_continue, 9},
    {field_initialiser, 2},
    {field_iterator, 5},
  [217] =
    {field_condition, 4},
    {field_continue, 9},
    {field_initialiser, 2},
  [220] =
    {field_block, 7},
    {field_continue, 9},
    {field_list, 5},
    {field_variables, 2},
    {field_variables, 3},
  [225] =
    {field_block, 9},
    {field_list, 7},
    {field_variables, 2},
    {field_variables, 3},
    {field_variables, 4},
    {field_variables, 5},
  [231] =
    {field_condition, 4},
    {field_continue, 10},
    {field_initialiser, 2},
    {field_iterator, 6},
  [235] =
    {field_block, 8},
    {field_continue, 10},
    {field_list, 6},
    {field_variables, 2},
    {field_variables, 3},
    {field_variables, 4},
  [241] =
    {field_block, 9},
    {field_continue, 11},
    {field_list, 7},
    {field_variables, 2},
    {field_variables, 3},
    {field_variables, 4},
    {field_variables, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = alias_sym_block_statement,
  },
  [7] = {
    [0] = sym__ctrl_z_hack,
  },
  [8] = {
    [0] = sym_autoquoted_bareword,
  },
  [14] = {
    [0] = sym_varname,
  },
  [20] = {
    [0] = alias_sym_label,
  },
  [23] = {
    [1] = sym_indirect_object,
  },
  [26] = {
    [1] = alias_sym_regexp_content,
  },
  [32] = {
    [0] = sym_autoquoted_bareword,
    [1] = sym_autoquoted_bareword,
  },
  [36] = {
    [0] = sym__ctrl_z_hack,
    [2] = alias_sym_data_section,
  },
  [44] = {
    [1] = alias_sym_regexp_content,
  },
  [56] = {
    [2] = alias_sym_regexp_content,
  },
  [58] = {
    [2] = alias_sym_regexp_content,
  },
  [68] = {
    [0] = sym_container_variable,
  },
  [69] = {
    [0] = sym_container_variable,
  },
  [72] = {
    [0] = sym_slice_container_variable,
  },
  [73] = {
    [0] = sym_slice_container_variable,
  },
  [78] = {
    [1] = sym_varname,
  },
  [81] = {
    [2] = alias_sym_regexp_content,
  },
  [82] = {
    [2] = alias_sym_regexp_content,
  },
  [84] = {
    [3] = alias_sym_replacement,
  },
  [85] = {
    [2] = alias_sym_transliteration_content,
  },
  [95] = {
    [1] = sym_varname,
    [2] = sym_varname,
  },
  [98] = {
    [2] = alias_sym_regexp_content,
  },
  [99] = {
    [2] = alias_sym_regexp_content,
    [4] = alias_sym_replacement,
  },
  [100] = {
    [3] = alias_sym_replacement,
  },
  [101] = {
    [2] = alias_sym_transliteration_content,
  },
  [102] = {
    [2] = alias_sym_transliteration_content,
    [4] = alias_sym_replacement,
  },
  [114] = {
    [2] = alias_sym_regexp_content,
    [4] = alias_sym_replacement,
  },
  [115] = {
    [2] = alias_sym_transliteration_content,
    [4] = alias_sym_replacement,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_block, 3,
    sym_block,
    alias_sym_block_statement,
    sym_indirect_object,
  sym_scalar, 2,
    sym_scalar,
    sym_container_variable,
  sym_array, 2,
    sym_array,
    sym_slice_container_variable,
  sym__indirob, 2,
    sym__indirob,
    sym_varname,
  aux_sym__noninterpolated_string_content, 4,
    aux_sym__noninterpolated_string_content,
    alias_sym_regexp_content,
    alias_sym_replacement,
    alias_sym_transliteration_content,
  aux_sym__interpolated_string_content, 2,
    aux_sym__interpolated_string_content,
    alias_sym_replacement,
  aux_sym__interpolated_regexp_content, 2,
    aux_sym__interpolated_regexp_content,
    alias_sym_regexp_content,
  aux_sym__interpolated_transliteration_content, 3,
    aux_sym__interpolated_transliteration_content,
    alias_sym_replacement,
    alias_sym_transliteration_content,
  sym_identifier, 2,
    sym_identifier,
    alias_sym_label,
  sym__ident_special, 2,
    sym__ident_special,
    sym_varname,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 3,
  [6] = 2,
  [7] = 3,
  [8] = 8,
  [9] = 9,
  [10] = 9,
  [11] = 9,
  [12] = 9,
  [13] = 9,
  [14] = 8,
  [15] = 9,
  [16] = 9,
  [17] = 9,
  [18] = 9,
  [19] = 8,
  [20] = 9,
  [21] = 9,
  [22] = 9,
  [23] = 9,
  [24] = 9,
  [25] = 9,
  [26] = 26,
  [27] = 26,
  [28] = 26,
  [29] = 26,
  [30] = 26,
  [31] = 26,
  [32] = 32,
  [33] = 2,
  [34] = 3,
  [35] = 26,
  [36] = 36,
  [37] = 26,
  [38] = 36,
  [39] = 26,
  [40] = 26,
  [41] = 26,
  [42] = 26,
  [43] = 26,
  [44] = 32,
  [45] = 26,
  [46] = 26,
  [47] = 36,
  [48] = 32,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 50,
  [54] = 51,
  [55] = 55,
  [56] = 52,
  [57] = 50,
  [58] = 51,
  [59] = 52,
  [60] = 50,
  [61] = 3,
  [62] = 2,
  [63] = 51,
  [64] = 50,
  [65] = 50,
  [66] = 52,
  [67] = 50,
  [68] = 50,
  [69] = 51,
  [70] = 52,
  [71] = 50,
  [72] = 52,
  [73] = 52,
  [74] = 52,
  [75] = 3,
  [76] = 49,
  [77] = 52,
  [78] = 52,
  [79] = 52,
  [80] = 51,
  [81] = 51,
  [82] = 55,
  [83] = 51,
  [84] = 51,
  [85] = 50,
  [86] = 50,
  [87] = 55,
  [88] = 49,
  [89] = 52,
  [90] = 2,
  [91] = 50,
  [92] = 52,
  [93] = 51,
  [94] = 51,
  [95] = 51,
  [96] = 52,
  [97] = 51,
  [98] = 50,
  [99] = 52,
  [100] = 8,
  [101] = 50,
  [102] = 51,
  [103] = 51,
  [104] = 50,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 36,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 3,
  [114] = 8,
  [115] = 111,
  [116] = 112,
  [117] = 117,
  [118] = 106,
  [119] = 111,
  [120] = 32,
  [121] = 112,
  [122] = 106,
  [123] = 105,
  [124] = 2,
  [125] = 107,
  [126] = 109,
  [127] = 107,
  [128] = 109,
  [129] = 117,
  [130] = 8,
  [131] = 117,
  [132] = 105,
  [133] = 3,
  [134] = 134,
  [135] = 135,
  [136] = 32,
  [137] = 55,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 140,
  [142] = 134,
  [143] = 36,
  [144] = 2,
  [145] = 8,
  [146] = 138,
  [147] = 135,
  [148] = 49,
  [149] = 135,
  [150] = 36,
  [151] = 140,
  [152] = 138,
  [153] = 134,
  [154] = 32,
  [155] = 8,
  [156] = 32,
  [157] = 112,
  [158] = 111,
  [159] = 159,
  [160] = 55,
  [161] = 55,
  [162] = 106,
  [163] = 107,
  [164] = 49,
  [165] = 165,
  [166] = 105,
  [167] = 117,
  [168] = 109,
  [169] = 49,
  [170] = 170,
  [171] = 36,
  [172] = 105,
  [173] = 112,
  [174] = 106,
  [175] = 36,
  [176] = 117,
  [177] = 140,
  [178] = 109,
  [179] = 138,
  [180] = 32,
  [181] = 135,
  [182] = 117,
  [183] = 105,
  [184] = 55,
  [185] = 109,
  [186] = 107,
  [187] = 106,
  [188] = 107,
  [189] = 111,
  [190] = 134,
  [191] = 112,
  [192] = 49,
  [193] = 111,
  [194] = 106,
  [195] = 135,
  [196] = 105,
  [197] = 107,
  [198] = 109,
  [199] = 140,
  [200] = 112,
  [201] = 111,
  [202] = 138,
  [203] = 49,
  [204] = 135,
  [205] = 117,
  [206] = 138,
  [207] = 140,
  [208] = 140,
  [209] = 138,
  [210] = 134,
  [211] = 134,
  [212] = 140,
  [213] = 138,
  [214] = 55,
  [215] = 105,
  [216] = 112,
  [217] = 134,
  [218] = 106,
  [219] = 117,
  [220] = 111,
  [221] = 109,
  [222] = 107,
  [223] = 134,
  [224] = 224,
  [225] = 224,
  [226] = 224,
  [227] = 224,
  [228] = 224,
  [229] = 224,
  [230] = 224,
  [231] = 231,
  [232] = 224,
  [233] = 224,
  [234] = 224,
  [235] = 224,
  [236] = 224,
  [237] = 224,
  [238] = 224,
  [239] = 224,
  [240] = 224,
  [241] = 241,
  [242] = 242,
  [243] = 242,
  [244] = 244,
  [245] = 242,
  [246] = 244,
  [247] = 242,
  [248] = 244,
  [249] = 242,
  [250] = 241,
  [251] = 242,
  [252] = 252,
  [253] = 253,
  [254] = 242,
  [255] = 242,
  [256] = 242,
  [257] = 242,
  [258] = 242,
  [259] = 244,
  [260] = 242,
  [261] = 244,
  [262] = 242,
  [263] = 244,
  [264] = 244,
  [265] = 242,
  [266] = 242,
  [267] = 242,
  [268] = 244,
  [269] = 242,
  [270] = 242,
  [271] = 244,
  [272] = 242,
  [273] = 242,
  [274] = 253,
  [275] = 244,
  [276] = 244,
  [277] = 242,
  [278] = 242,
  [279] = 253,
  [280] = 280,
  [281] = 280,
  [282] = 282,
  [283] = 282,
  [284] = 282,
  [285] = 285,
  [286] = 285,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 291,
  [295] = 288,
  [296] = 296,
  [297] = 287,
  [298] = 291,
  [299] = 288,
  [300] = 300,
  [301] = 287,
  [302] = 300,
  [303] = 290,
  [304] = 290,
  [305] = 296,
  [306] = 300,
  [307] = 296,
  [308] = 292,
  [309] = 289,
  [310] = 293,
  [311] = 289,
  [312] = 292,
  [313] = 293,
  [314] = 288,
  [315] = 296,
  [316] = 291,
  [317] = 317,
  [318] = 318,
  [319] = 135,
  [320] = 135,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 324,
  [328] = 318,
  [329] = 138,
  [330] = 135,
  [331] = 331,
  [332] = 323,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 138,
  [339] = 326,
  [340] = 140,
  [341] = 324,
  [342] = 318,
  [343] = 336,
  [344] = 331,
  [345] = 345,
  [346] = 333,
  [347] = 334,
  [348] = 335,
  [349] = 323,
  [350] = 350,
  [351] = 321,
  [352] = 322,
  [353] = 321,
  [354] = 317,
  [355] = 322,
  [356] = 321,
  [357] = 322,
  [358] = 321,
  [359] = 140,
  [360] = 322,
  [361] = 321,
  [362] = 322,
  [363] = 321,
  [364] = 322,
  [365] = 321,
  [366] = 322,
  [367] = 138,
  [368] = 317,
  [369] = 140,
  [370] = 335,
  [371] = 321,
  [372] = 322,
  [373] = 322,
  [374] = 321,
  [375] = 333,
  [376] = 317,
  [377] = 321,
  [378] = 322,
  [379] = 379,
  [380] = 380,
  [381] = 322,
  [382] = 379,
  [383] = 337,
  [384] = 326,
  [385] = 385,
  [386] = 386,
  [387] = 321,
  [388] = 380,
  [389] = 317,
  [390] = 390,
  [391] = 322,
  [392] = 334,
  [393] = 317,
  [394] = 321,
  [395] = 322,
  [396] = 321,
  [397] = 350,
  [398] = 317,
  [399] = 317,
  [400] = 331,
  [401] = 321,
  [402] = 322,
  [403] = 325,
  [404] = 390,
  [405] = 345,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 412,
  [421] = 421,
  [422] = 422,
  [423] = 414,
  [424] = 424,
  [425] = 415,
  [426] = 421,
  [427] = 427,
  [428] = 417,
  [429] = 429,
  [430] = 430,
  [431] = 410,
  [432] = 414,
  [433] = 433,
  [434] = 434,
  [435] = 427,
  [436] = 429,
  [437] = 417,
  [438] = 430,
  [439] = 433,
  [440] = 410,
  [441] = 414,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 411,
  [446] = 409,
  [447] = 416,
  [448] = 418,
  [449] = 427,
  [450] = 419,
  [451] = 451,
  [452] = 407,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 454,
  [457] = 406,
  [458] = 409,
  [459] = 412,
  [460] = 421,
  [461] = 455,
  [462] = 462,
  [463] = 417,
  [464] = 422,
  [465] = 415,
  [466] = 424,
  [467] = 467,
  [468] = 411,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 413,
  [473] = 473,
  [474] = 473,
  [475] = 433,
  [476] = 476,
  [477] = 477,
  [478] = 444,
  [479] = 417,
  [480] = 434,
  [481] = 481,
  [482] = 417,
  [483] = 454,
  [484] = 424,
  [485] = 429,
  [486] = 410,
  [487] = 411,
  [488] = 427,
  [489] = 489,
  [490] = 455,
  [491] = 462,
  [492] = 454,
  [493] = 455,
  [494] = 462,
  [495] = 476,
  [496] = 469,
  [497] = 473,
  [498] = 477,
  [499] = 481,
  [500] = 489,
  [501] = 501,
  [502] = 476,
  [503] = 430,
  [504] = 489,
  [505] = 417,
  [506] = 481,
  [507] = 430,
  [508] = 477,
  [509] = 433,
  [510] = 417,
  [511] = 417,
  [512] = 430,
  [513] = 417,
  [514] = 514,
  [515] = 414,
  [516] = 408,
  [517] = 414,
  [518] = 417,
  [519] = 434,
  [520] = 419,
  [521] = 514,
  [522] = 418,
  [523] = 417,
  [524] = 414,
  [525] = 469,
  [526] = 416,
  [527] = 417,
  [528] = 429,
  [529] = 422,
  [530] = 453,
  [531] = 417,
  [532] = 430,
  [533] = 443,
  [534] = 414,
  [535] = 430,
  [536] = 417,
  [537] = 442,
  [538] = 430,
  [539] = 539,
  [540] = 540,
  [541] = 540,
  [542] = 540,
  [543] = 543,
  [544] = 140,
  [545] = 540,
  [546] = 540,
  [547] = 539,
  [548] = 540,
  [549] = 540,
  [550] = 543,
  [551] = 539,
  [552] = 543,
  [553] = 138,
  [554] = 135,
  [555] = 540,
  [556] = 140,
  [557] = 138,
  [558] = 135,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 561,
  [564] = 559,
  [565] = 559,
  [566] = 559,
  [567] = 567,
  [568] = 559,
  [569] = 560,
  [570] = 567,
  [571] = 561,
  [572] = 559,
  [573] = 559,
  [574] = 560,
  [575] = 567,
  [576] = 562,
  [577] = 567,
  [578] = 562,
  [579] = 567,
  [580] = 567,
  [581] = 581,
  [582] = 560,
  [583] = 583,
  [584] = 562,
  [585] = 560,
  [586] = 561,
  [587] = 559,
  [588] = 560,
  [589] = 562,
  [590] = 567,
  [591] = 560,
  [592] = 559,
  [593] = 561,
  [594] = 561,
  [595] = 559,
  [596] = 567,
  [597] = 567,
  [598] = 567,
  [599] = 559,
  [600] = 562,
  [601] = 562,
  [602] = 567,
  [603] = 560,
  [604] = 561,
  [605] = 559,
  [606] = 559,
  [607] = 567,
  [608] = 561,
  [609] = 567,
  [610] = 567,
  [611] = 562,
  [612] = 567,
  [613] = 559,
  [614] = 559,
  [615] = 134,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 618,
  [621] = 618,
  [622] = 617,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 618,
  [630] = 618,
  [631] = 624,
  [632] = 623,
  [633] = 627,
  [634] = 628,
  [635] = 624,
  [636] = 623,
  [637] = 619,
  [638] = 617,
  [639] = 625,
  [640] = 626,
  [641] = 627,
  [642] = 618,
  [643] = 628,
  [644] = 618,
  [645] = 619,
  [646] = 646,
  [647] = 647,
  [648] = 628,
  [649] = 627,
  [650] = 626,
  [651] = 625,
  [652] = 617,
  [653] = 619,
  [654] = 624,
  [655] = 623,
  [656] = 626,
  [657] = 619,
  [658] = 646,
  [659] = 647,
  [660] = 617,
  [661] = 628,
  [662] = 627,
  [663] = 626,
  [664] = 625,
  [665] = 625,
  [666] = 617,
  [667] = 625,
  [668] = 619,
  [669] = 626,
  [670] = 627,
  [671] = 628,
  [672] = 618,
  [673] = 623,
  [674] = 624,
  [675] = 617,
  [676] = 628,
  [677] = 627,
  [678] = 616,
  [679] = 619,
  [680] = 625,
  [681] = 619,
  [682] = 628,
  [683] = 627,
  [684] = 626,
  [685] = 625,
  [686] = 623,
  [687] = 617,
  [688] = 623,
  [689] = 624,
  [690] = 624,
  [691] = 626,
  [692] = 647,
  [693] = 646,
  [694] = 616,
  [695] = 624,
  [696] = 623,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 699,
  [706] = 700,
  [707] = 701,
  [708] = 702,
  [709] = 703,
  [710] = 702,
  [711] = 701,
  [712] = 703,
  [713] = 700,
  [714] = 714,
  [715] = 699,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 698,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 697,
  [726] = 726,
  [727] = 714,
  [728] = 728,
  [729] = 697,
  [730] = 724,
  [731] = 722,
  [732] = 721,
  [733] = 733,
  [734] = 719,
  [735] = 718,
  [736] = 717,
  [737] = 716,
  [738] = 699,
  [739] = 700,
  [740] = 701,
  [741] = 702,
  [742] = 703,
  [743] = 728,
  [744] = 698,
  [745] = 714,
  [746] = 728,
  [747] = 697,
  [748] = 717,
  [749] = 724,
  [750] = 723,
  [751] = 718,
  [752] = 722,
  [753] = 721,
  [754] = 719,
  [755] = 733,
  [756] = 733,
  [757] = 719,
  [758] = 718,
  [759] = 703,
  [760] = 702,
  [761] = 701,
  [762] = 700,
  [763] = 699,
  [764] = 716,
  [765] = 717,
  [766] = 721,
  [767] = 718,
  [768] = 714,
  [769] = 698,
  [770] = 719,
  [771] = 733,
  [772] = 723,
  [773] = 722,
  [774] = 717,
  [775] = 724,
  [776] = 697,
  [777] = 728,
  [778] = 721,
  [779] = 733,
  [780] = 722,
  [781] = 714,
  [782] = 723,
  [783] = 698,
  [784] = 728,
  [785] = 697,
  [786] = 724,
  [787] = 724,
  [788] = 722,
  [789] = 721,
  [790] = 733,
  [791] = 719,
  [792] = 718,
  [793] = 726,
  [794] = 717,
  [795] = 716,
  [796] = 699,
  [797] = 700,
  [798] = 701,
  [799] = 702,
  [800] = 703,
  [801] = 728,
  [802] = 698,
  [803] = 723,
  [804] = 726,
  [805] = 698,
  [806] = 726,
  [807] = 714,
  [808] = 704,
  [809] = 704,
  [810] = 723,
  [811] = 704,
  [812] = 723,
  [813] = 726,
  [814] = 704,
  [815] = 704,
  [816] = 703,
  [817] = 702,
  [818] = 701,
  [819] = 700,
  [820] = 699,
  [821] = 716,
  [822] = 717,
  [823] = 718,
  [824] = 719,
  [825] = 733,
  [826] = 721,
  [827] = 704,
  [828] = 728,
  [829] = 697,
  [830] = 721,
  [831] = 722,
  [832] = 724,
  [833] = 714,
  [834] = 716,
  [835] = 722,
  [836] = 726,
  [837] = 724,
  [838] = 723,
  [839] = 726,
  [840] = 726,
  [841] = 733,
  [842] = 698,
  [843] = 714,
  [844] = 719,
  [845] = 697,
  [846] = 718,
  [847] = 717,
  [848] = 716,
  [849] = 699,
  [850] = 700,
  [851] = 701,
  [852] = 702,
  [853] = 728,
  [854] = 704,
  [855] = 716,
  [856] = 703,
  [857] = 857,
  [858] = 857,
  [859] = 857,
  [860] = 857,
  [861] = 857,
  [862] = 857,
  [863] = 857,
  [864] = 857,
  [865] = 857,
  [866] = 857,
  [867] = 857,
  [868] = 857,
  [869] = 857,
  [870] = 857,
  [871] = 857,
  [872] = 872,
  [873] = 873,
  [874] = 873,
  [875] = 873,
  [876] = 873,
  [877] = 873,
  [878] = 873,
  [879] = 872,
  [880] = 880,
  [881] = 873,
  [882] = 872,
  [883] = 873,
  [884] = 873,
  [885] = 880,
  [886] = 886,
  [887] = 873,
  [888] = 873,
  [889] = 873,
  [890] = 886,
  [891] = 880,
  [892] = 872,
  [893] = 873,
  [894] = 886,
  [895] = 873,
  [896] = 873,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 903,
  [905] = 905,
  [906] = 901,
  [907] = 907,
  [908] = 908,
  [909] = 901,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 903,
  [914] = 912,
  [915] = 900,
  [916] = 908,
  [917] = 886,
  [918] = 899,
  [919] = 897,
  [920] = 920,
  [921] = 907,
  [922] = 910,
  [923] = 886,
  [924] = 898,
  [925] = 872,
  [926] = 926,
  [927] = 902,
  [928] = 926,
  [929] = 872,
  [930] = 880,
  [931] = 931,
  [932] = 931,
  [933] = 926,
  [934] = 931,
  [935] = 905,
  [936] = 880,
  [937] = 911,
  [938] = 901,
  [939] = 901,
  [940] = 903,
  [941] = 903,
  [942] = 942,
  [943] = 931,
  [944] = 898,
  [945] = 911,
  [946] = 926,
  [947] = 905,
  [948] = 897,
  [949] = 931,
  [950] = 899,
  [951] = 951,
  [952] = 912,
  [953] = 902,
  [954] = 926,
  [955] = 910,
  [956] = 907,
  [957] = 900,
  [958] = 908,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 900,
  [963] = 905,
  [964] = 964,
  [965] = 959,
  [966] = 900,
  [967] = 960,
  [968] = 968,
  [969] = 905,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 900,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 900,
  [990] = 905,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 961,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 905,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 964,
  [1048] = 900,
  [1049] = 905,
  [1050] = 968,
  [1051] = 995,
  [1052] = 974,
  [1053] = 973,
  [1054] = 975,
  [1055] = 1025,
  [1056] = 976,
  [1057] = 977,
  [1058] = 981,
  [1059] = 988,
  [1060] = 992,
  [1061] = 993,
  [1062] = 994,
  [1063] = 997,
  [1064] = 1000,
  [1065] = 1002,
  [1066] = 1005,
  [1067] = 1006,
  [1068] = 1008,
  [1069] = 1009,
  [1070] = 1010,
  [1071] = 971,
  [1072] = 1013,
  [1073] = 1016,
  [1074] = 1033,
  [1075] = 1037,
  [1076] = 999,
  [1077] = 1042,
  [1078] = 970,
  [1079] = 996,
  [1080] = 1001,
  [1081] = 1003,
  [1082] = 1039,
  [1083] = 1004,
  [1084] = 900,
  [1085] = 978,
  [1086] = 1019,
  [1087] = 1018,
  [1088] = 979,
  [1089] = 1014,
  [1090] = 983,
  [1091] = 984,
  [1092] = 1028,
  [1093] = 986,
  [1094] = 1026,
  [1095] = 1038,
  [1096] = 1035,
  [1097] = 1045,
  [1098] = 1011,
  [1099] = 980,
  [1100] = 1043,
  [1101] = 1034,
  [1102] = 1046,
  [1103] = 972,
  [1104] = 1036,
  [1105] = 998,
  [1106] = 1030,
  [1107] = 991,
  [1108] = 985,
  [1109] = 1040,
  [1110] = 1020,
  [1111] = 905,
  [1112] = 1027,
  [1113] = 1031,
  [1114] = 1041,
  [1115] = 1007,
  [1116] = 987,
  [1117] = 1024,
  [1118] = 1012,
  [1119] = 1017,
  [1120] = 1023,
  [1121] = 1022,
  [1122] = 1015,
  [1123] = 1021,
  [1124] = 1044,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 905,
  [1130] = 900,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 907,
  [1141] = 1141,
  [1142] = 902,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1144,
  [1146] = 911,
  [1147] = 910,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1131,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1144,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 899,
  [1157] = 900,
  [1158] = 1144,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1144,
  [1162] = 905,
  [1163] = 1163,
  [1164] = 1144,
  [1165] = 1165,
  [1166] = 897,
  [1167] = 1144,
  [1168] = 1144,
  [1169] = 1169,
  [1170] = 1144,
  [1171] = 1144,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1144,
  [1175] = 1175,
  [1176] = 912,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1144,
  [1183] = 898,
  [1184] = 1184,
  [1185] = 1144,
  [1186] = 1144,
  [1187] = 1187,
  [1188] = 1144,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 908,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1131,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1133,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1296,
  [1297] = 1297,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1134,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1132,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1138,
  [1365] = 1137,
  [1366] = 1132,
  [1367] = 1135,
  [1368] = 1136,
  [1369] = 1141,
  [1370] = 1139,
  [1371] = 1134,
  [1372] = 1133,
  [1373] = 1143,
  [1374] = 1172,
  [1375] = 1138,
  [1376] = 1137,
  [1377] = 1179,
  [1378] = 1159,
  [1379] = 1131,
  [1380] = 897,
  [1381] = 1155,
  [1382] = 1139,
  [1383] = 1175,
  [1384] = 1149,
  [1385] = 1151,
  [1386] = 900,
  [1387] = 1152,
  [1388] = 905,
  [1389] = 1160,
  [1390] = 910,
  [1391] = 1181,
  [1392] = 1184,
  [1393] = 1148,
  [1394] = 1141,
  [1395] = 1131,
  [1396] = 1169,
  [1397] = 912,
  [1398] = 899,
  [1399] = 911,
  [1400] = 1173,
  [1401] = 1187,
  [1402] = 898,
  [1403] = 907,
  [1404] = 1163,
  [1405] = 1131,
  [1406] = 1178,
  [1407] = 902,
  [1408] = 1177,
  [1409] = 1180,
  [1410] = 1165,
  [1411] = 1154,
  [1412] = 1195,
  [1413] = 1212,
  [1414] = 1172,
  [1415] = 1189,
  [1416] = 908,
  [1417] = 1231,
  [1418] = 1191,
  [1419] = 1197,
  [1420] = 1179,
  [1421] = 1218,
  [1422] = 1193,
  [1423] = 1192,
  [1424] = 1194,
  [1425] = 1205,
  [1426] = 1208,
  [1427] = 1159,
  [1428] = 1190,
  [1429] = 1133,
  [1430] = 1232,
  [1431] = 1276,
  [1432] = 1297,
  [1433] = 1313,
  [1434] = 1314,
  [1435] = 1320,
  [1436] = 1356,
  [1437] = 1229,
  [1438] = 1360,
  [1439] = 1226,
  [1440] = 1352,
  [1441] = 1230,
  [1442] = 1235,
  [1443] = 1309,
  [1444] = 1228,
  [1445] = 1237,
  [1446] = 1213,
  [1447] = 1220,
  [1448] = 1203,
  [1449] = 1202,
  [1450] = 1210,
  [1451] = 1217,
  [1452] = 1214,
  [1453] = 1318,
  [1454] = 1204,
  [1455] = 1198,
  [1456] = 1216,
  [1457] = 1240,
  [1458] = 1241,
  [1459] = 1242,
  [1460] = 1243,
  [1461] = 1244,
  [1462] = 1233,
  [1463] = 1225,
  [1464] = 1200,
  [1465] = 1223,
  [1466] = 1201,
  [1467] = 1207,
  [1468] = 1215,
  [1469] = 1227,
  [1470] = 1134,
  [1471] = 1219,
  [1472] = 1254,
  [1473] = 1246,
  [1474] = 1132,
  [1475] = 1245,
  [1476] = 1271,
  [1477] = 1337,
  [1478] = 1199,
  [1479] = 1270,
  [1480] = 1264,
  [1481] = 1273,
  [1482] = 1263,
  [1483] = 1135,
  [1484] = 1136,
  [1485] = 1262,
  [1486] = 1259,
  [1487] = 1258,
  [1488] = 1260,
  [1489] = 1291,
  [1490] = 1358,
  [1491] = 1359,
  [1492] = 1362,
  [1493] = 1363,
  [1494] = 1342,
  [1495] = 1331,
  [1496] = 1265,
  [1497] = 1329,
  [1498] = 1327,
  [1499] = 1322,
  [1500] = 1338,
  [1501] = 1302,
  [1502] = 1238,
  [1503] = 1299,
  [1504] = 1294,
  [1505] = 1293,
  [1506] = 1335,
  [1507] = 1288,
  [1508] = 1255,
  [1509] = 1282,
  [1510] = 1268,
  [1511] = 1269,
  [1512] = 1234,
  [1513] = 1206,
  [1514] = 1236,
  [1515] = 1218,
  [1516] = 1197,
  [1517] = 1222,
  [1518] = 1221,
  [1519] = 1305,
  [1520] = 1321,
  [1521] = 1295,
  [1522] = 1319,
  [1523] = 1311,
  [1524] = 1231,
  [1525] = 1308,
  [1526] = 1328,
  [1527] = 1261,
  [1528] = 1208,
  [1529] = 1205,
  [1530] = 1132,
  [1531] = 1333,
  [1532] = 1272,
  [1533] = 1274,
  [1534] = 1284,
  [1535] = 1286,
  [1536] = 1307,
  [1537] = 1316,
  [1538] = 1280,
  [1539] = 1211,
  [1540] = 1353,
  [1541] = 1133,
  [1542] = 1361,
  [1543] = 1266,
  [1544] = 1334,
  [1545] = 1357,
  [1546] = 1134,
  [1547] = 1257,
  [1548] = 1137,
  [1549] = 1138,
  [1550] = 1341,
  [1551] = 1324,
  [1552] = 1347,
  [1553] = 1336,
  [1554] = 1278,
  [1555] = 1277,
  [1556] = 1212,
  [1557] = 1349,
  [1558] = 1355,
  [1559] = 1249,
  [1560] = 1248,
  [1561] = 1287,
  [1562] = 1290,
  [1563] = 1350,
  [1564] = 1344,
  [1565] = 1310,
  [1566] = 1351,
  [1567] = 1301,
  [1568] = 1300,
  [1569] = 1292,
  [1570] = 1289,
  [1571] = 1285,
  [1572] = 1281,
  [1573] = 1275,
  [1574] = 1250,
  [1575] = 1252,
  [1576] = 1256,
  [1577] = 1315,
  [1578] = 1253,
  [1579] = 1251,
  [1580] = 1348,
  [1581] = 1346,
  [1582] = 1339,
  [1583] = 1239,
  [1584] = 1325,
  [1585] = 1326,
  [1586] = 1306,
  [1587] = 1312,
  [1588] = 1332,
  [1589] = 1345,
  [1590] = 1279,
  [1591] = 1354,
  [1592] = 1343,
  [1593] = 1247,
  [1594] = 1296,
  [1595] = 1323,
  [1596] = 1340,
  [1597] = 1224,
  [1598] = 1267,
  [1599] = 1304,
  [1600] = 1298,
  [1601] = 1244,
  [1602] = 1270,
  [1603] = 1318,
  [1604] = 1240,
  [1605] = 1297,
  [1606] = 1360,
  [1607] = 1241,
  [1608] = 1242,
  [1609] = 1243,
  [1610] = 1135,
  [1611] = 1136,
  [1612] = 1337,
  [1613] = 1352,
  [1614] = 1245,
  [1615] = 1313,
  [1616] = 1138,
  [1617] = 1137,
  [1618] = 1139,
  [1619] = 1619,
  [1620] = 1141,
  [1621] = 1246,
  [1622] = 1309,
  [1623] = 1254,
  [1624] = 1276,
  [1625] = 1134,
  [1626] = 1258,
  [1627] = 1259,
  [1628] = 1262,
  [1629] = 902,
  [1630] = 1263,
  [1631] = 1273,
  [1632] = 1133,
  [1633] = 1264,
  [1634] = 1271,
  [1635] = 1356,
  [1636] = 1320,
  [1637] = 1143,
  [1638] = 1314,
  [1639] = 907,
  [1640] = 1149,
  [1641] = 905,
  [1642] = 1152,
  [1643] = 1179,
  [1644] = 1163,
  [1645] = 1165,
  [1646] = 1180,
  [1647] = 1177,
  [1648] = 1141,
  [1649] = 1151,
  [1650] = 897,
  [1651] = 1172,
  [1652] = 900,
  [1653] = 899,
  [1654] = 1139,
  [1655] = 1154,
  [1656] = 1160,
  [1657] = 1155,
  [1658] = 912,
  [1659] = 1173,
  [1660] = 898,
  [1661] = 1187,
  [1662] = 1169,
  [1663] = 1175,
  [1664] = 911,
  [1665] = 1148,
  [1666] = 1184,
  [1667] = 910,
  [1668] = 1178,
  [1669] = 1181,
  [1670] = 1159,
  [1671] = 1191,
  [1672] = 1195,
  [1673] = 1190,
  [1674] = 1193,
  [1675] = 908,
  [1676] = 1172,
  [1677] = 1194,
  [1678] = 1159,
  [1679] = 1192,
  [1680] = 1189,
  [1681] = 1179,
  [1682] = 1199,
  [1683] = 1220,
  [1684] = 1224,
  [1685] = 1205,
  [1686] = 1208,
  [1687] = 1198,
  [1688] = 1223,
  [1689] = 1232,
  [1690] = 1217,
  [1691] = 1222,
  [1692] = 1201,
  [1693] = 1197,
  [1694] = 1207,
  [1695] = 1228,
  [1696] = 1200,
  [1697] = 1226,
  [1698] = 1229,
  [1699] = 1230,
  [1700] = 1215,
  [1701] = 1233,
  [1702] = 1227,
  [1703] = 1237,
  [1704] = 1212,
  [1705] = 1235,
  [1706] = 1219,
  [1707] = 1211,
  [1708] = 1231,
  [1709] = 1203,
  [1710] = 1213,
  [1711] = 1218,
  [1712] = 1214,
  [1713] = 1202,
  [1714] = 1236,
  [1715] = 1221,
  [1716] = 1210,
  [1717] = 1204,
  [1718] = 1234,
  [1719] = 1225,
  [1720] = 1216,
  [1721] = 1206,
  [1722] = 1311,
  [1723] = 1271,
  [1724] = 1231,
  [1725] = 1231,
  [1726] = 1197,
  [1727] = 1218,
  [1728] = 1337,
  [1729] = 1258,
  [1730] = 1270,
  [1731] = 1264,
  [1732] = 1273,
  [1733] = 1263,
  [1734] = 1262,
  [1735] = 1259,
  [1736] = 1332,
  [1737] = 1254,
  [1738] = 1246,
  [1739] = 1245,
  [1740] = 1244,
  [1741] = 1243,
  [1742] = 1242,
  [1743] = 1241,
  [1744] = 1240,
  [1745] = 1208,
  [1746] = 1318,
  [1747] = 1205,
  [1748] = 1231,
  [1749] = 1231,
  [1750] = 1208,
  [1751] = 1205,
  [1752] = 1231,
  [1753] = 1208,
  [1754] = 1208,
  [1755] = 1360,
  [1756] = 1287,
  [1757] = 1290,
  [1758] = 1350,
  [1759] = 1344,
  [1760] = 1310,
  [1761] = 1351,
  [1762] = 1301,
  [1763] = 1300,
  [1764] = 1292,
  [1765] = 1289,
  [1766] = 1285,
  [1767] = 1281,
  [1768] = 1275,
  [1769] = 1260,
  [1770] = 1256,
  [1771] = 1253,
  [1772] = 1251,
  [1773] = 1348,
  [1774] = 1346,
  [1775] = 1339,
  [1776] = 1306,
  [1777] = 1293,
  [1778] = 1354,
  [1779] = 1247,
  [1780] = 1248,
  [1781] = 1323,
  [1782] = 1267,
  [1783] = 1304,
  [1784] = 1291,
  [1785] = 1345,
  [1786] = 1326,
  [1787] = 1325,
  [1788] = 1239,
  [1789] = 1315,
  [1790] = 1252,
  [1791] = 1250,
  [1792] = 1249,
  [1793] = 1355,
  [1794] = 1349,
  [1795] = 1336,
  [1796] = 1347,
  [1797] = 1324,
  [1798] = 1341,
  [1799] = 1257,
  [1800] = 1334,
  [1801] = 1361,
  [1802] = 1353,
  [1803] = 1316,
  [1804] = 1307,
  [1805] = 1286,
  [1806] = 1284,
  [1807] = 1274,
  [1808] = 1272,
  [1809] = 1261,
  [1810] = 1308,
  [1811] = 1319,
  [1812] = 1321,
  [1813] = 1305,
  [1814] = 1269,
  [1815] = 1282,
  [1816] = 1288,
  [1817] = 1255,
  [1818] = 1294,
  [1819] = 1299,
  [1820] = 1302,
  [1821] = 1309,
  [1822] = 1322,
  [1823] = 1329,
  [1824] = 1342,
  [1825] = 1352,
  [1826] = 1363,
  [1827] = 1362,
  [1828] = 1359,
  [1829] = 1358,
  [1830] = 1357,
  [1831] = 1356,
  [1832] = 1328,
  [1833] = 1320,
  [1834] = 1314,
  [1835] = 1313,
  [1836] = 1312,
  [1837] = 1298,
  [1838] = 1297,
  [1839] = 1296,
  [1840] = 1295,
  [1841] = 1279,
  [1842] = 1276,
  [1843] = 1277,
  [1844] = 1278,
  [1845] = 1280,
  [1846] = 1335,
  [1847] = 1238,
  [1848] = 1338,
  [1849] = 1340,
  [1850] = 1343,
  [1851] = 1333,
  [1852] = 1331,
  [1853] = 1327,
  [1854] = 1268,
  [1855] = 1266,
  [1856] = 1265,
  [1857] = 1258,
  [1858] = 1273,
  [1859] = 1244,
  [1860] = 1243,
  [1861] = 1242,
  [1862] = 1241,
  [1863] = 1318,
  [1864] = 1243,
  [1865] = 1242,
  [1866] = 1337,
  [1867] = 1241,
  [1868] = 1197,
  [1869] = 1218,
  [1870] = 1309,
  [1871] = 1246,
  [1872] = 1318,
  [1873] = 1246,
  [1874] = 1254,
  [1875] = 1271,
  [1876] = 1259,
  [1877] = 1240,
  [1878] = 1244,
  [1879] = 1262,
  [1880] = 1309,
  [1881] = 1263,
  [1882] = 1352,
  [1883] = 1245,
  [1884] = 1273,
  [1885] = 1264,
  [1886] = 1270,
  [1887] = 1360,
  [1888] = 1356,
  [1889] = 1320,
  [1890] = 1271,
  [1891] = 1314,
  [1892] = 1313,
  [1893] = 1297,
  [1894] = 1270,
  [1895] = 1276,
  [1896] = 1264,
  [1897] = 1337,
  [1898] = 1254,
  [1899] = 1245,
  [1900] = 1262,
  [1901] = 1356,
  [1902] = 1259,
  [1903] = 1320,
  [1904] = 1314,
  [1905] = 1240,
  [1906] = 1313,
  [1907] = 1309,
  [1908] = 1297,
  [1909] = 1276,
  [1910] = 1352,
  [1911] = 1258,
  [1912] = 1309,
  [1913] = 1360,
  [1914] = 1263,
  [1915] = 1297,
  [1916] = 1314,
  [1917] = 1917,
  [1918] = 1337,
  [1919] = 1919,
  [1920] = 1271,
  [1921] = 1270,
  [1922] = 1917,
  [1923] = 1919,
  [1924] = 1264,
  [1925] = 1273,
  [1926] = 1263,
  [1927] = 1360,
  [1928] = 1262,
  [1929] = 1917,
  [1930] = 1917,
  [1931] = 1917,
  [1932] = 1259,
  [1933] = 1917,
  [1934] = 1919,
  [1935] = 1917,
  [1936] = 1352,
  [1937] = 1318,
  [1938] = 1360,
  [1939] = 1258,
  [1940] = 1241,
  [1941] = 1242,
  [1942] = 1254,
  [1943] = 1243,
  [1944] = 1313,
  [1945] = 1276,
  [1946] = 1356,
  [1947] = 1917,
  [1948] = 1244,
  [1949] = 1245,
  [1950] = 1246,
  [1951] = 1320,
  [1952] = 1271,
  [1953] = 1241,
  [1954] = 1954,
  [1955] = 1954,
  [1956] = 1258,
  [1957] = 1270,
  [1958] = 1243,
  [1959] = 1244,
  [1960] = 1954,
  [1961] = 1954,
  [1962] = 1352,
  [1963] = 1360,
  [1964] = 1954,
  [1965] = 1246,
  [1966] = 1245,
  [1967] = 1242,
  [1968] = 1356,
  [1969] = 1320,
  [1970] = 1314,
  [1971] = 1276,
  [1972] = 1337,
  [1973] = 1954,
  [1974] = 1264,
  [1975] = 1273,
  [1976] = 1318,
  [1977] = 1254,
  [1978] = 1263,
  [1979] = 1954,
  [1980] = 1313,
  [1981] = 1259,
  [1982] = 1954,
  [1983] = 1297,
  [1984] = 1262,
  [1985] = 1985,
  [1986] = 1985,
  [1987] = 1987,
  [1988] = 1987,
  [1989] = 1985,
  [1990] = 1987,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1992,
  [1995] = 1995,
  [1996] = 1993,
  [1997] = 1995,
  [1998] = 1991,
  [1999] = 1991,
  [2000] = 1993,
  [2001] = 2001,
  [2002] = 1995,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 2004,
  [2006] = 2003,
  [2007] = 2003,
  [2008] = 1992,
  [2009] = 2001,
  [2010] = 2004,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2014,
  [2015] = 2011,
  [2016] = 2016,
  [2017] = 2011,
  [2018] = 2016,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 2020,
  [2022] = 2022,
  [2023] = 2019,
  [2024] = 2014,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2026,
  [2028] = 2013,
  [2029] = 2016,
  [2030] = 2030,
  [2031] = 2031,
  [2032] = 2020,
  [2033] = 2022,
  [2034] = 2034,
  [2035] = 2034,
  [2036] = 2014,
  [2037] = 2022,
  [2038] = 2012,
  [2039] = 2012,
  [2040] = 2031,
  [2041] = 2034,
  [2042] = 2019,
  [2043] = 2026,
  [2044] = 2030,
  [2045] = 2031,
  [2046] = 2030,
  [2047] = 2013,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 897,
  [2052] = 905,
  [2053] = 2053,
  [2054] = 1208,
  [2055] = 2055,
  [2056] = 2055,
  [2057] = 1205,
  [2058] = 897,
  [2059] = 900,
  [2060] = 899,
  [2061] = 905,
  [2062] = 2053,
  [2063] = 900,
  [2064] = 899,
  [2065] = 900,
  [2066] = 900,
  [2067] = 899,
  [2068] = 899,
  [2069] = 897,
  [2070] = 2070,
  [2071] = 2070,
  [2072] = 2053,
  [2073] = 905,
  [2074] = 912,
  [2075] = 897,
  [2076] = 2076,
  [2077] = 899,
  [2078] = 912,
  [2079] = 905,
  [2080] = 2055,
  [2081] = 907,
  [2082] = 911,
  [2083] = 911,
  [2084] = 898,
  [2085] = 898,
  [2086] = 902,
  [2087] = 897,
  [2088] = 900,
  [2089] = 902,
  [2090] = 2076,
  [2091] = 910,
  [2092] = 910,
  [2093] = 905,
  [2094] = 2070,
  [2095] = 2070,
  [2096] = 907,
  [2097] = 905,
  [2098] = 897,
  [2099] = 2076,
  [2100] = 898,
  [2101] = 910,
  [2102] = 902,
  [2103] = 905,
  [2104] = 900,
  [2105] = 912,
  [2106] = 900,
  [2107] = 899,
  [2108] = 2055,
  [2109] = 2053,
  [2110] = 907,
  [2111] = 897,
  [2112] = 899,
  [2113] = 911,
  [2114] = 2114,
  [2115] = 911,
  [2116] = 2114,
  [2117] = 902,
  [2118] = 898,
  [2119] = 2076,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 910,
  [2123] = 912,
  [2124] = 2124,
  [2125] = 2114,
  [2126] = 2126,
  [2127] = 899,
  [2128] = 2128,
  [2129] = 897,
  [2130] = 907,
  [2131] = 905,
  [2132] = 2132,
  [2133] = 900,
  [2134] = 2134,
  [2135] = 2134,
  [2136] = 2136,
  [2137] = 2134,
  [2138] = 2138,
  [2139] = 2134,
  [2140] = 2134,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2136,
  [2144] = 2134,
  [2145] = 2134,
  [2146] = 2146,
  [2147] = 2146,
  [2148] = 2134,
  [2149] = 2134,
  [2150] = 2141,
  [2151] = 2141,
  [2152] = 2134,
  [2153] = 2134,
  [2154] = 2138,
  [2155] = 2134,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2157,
  [2165] = 2165,
  [2166] = 2159,
  [2167] = 2161,
  [2168] = 2138,
  [2169] = 2161,
  [2170] = 2170,
  [2171] = 2156,
  [2172] = 2161,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 2156,
  [2178] = 2178,
  [2179] = 2162,
  [2180] = 2178,
  [2181] = 2170,
  [2182] = 2170,
  [2183] = 2159,
  [2184] = 2162,
  [2185] = 2160,
  [2186] = 2174,
  [2187] = 2157,
  [2188] = 2163,
  [2189] = 2165,
  [2190] = 2146,
  [2191] = 2191,
  [2192] = 2175,
  [2193] = 2161,
  [2194] = 2158,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2158,
  [2199] = 2199,
  [2200] = 2161,
  [2201] = 2160,
  [2202] = 2197,
  [2203] = 2203,
  [2204] = 2191,
  [2205] = 2195,
  [2206] = 2196,
  [2207] = 2173,
  [2208] = 2199,
  [2209] = 2203,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 1208,
  [2215] = 2163,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2199,
  [2219] = 2219,
  [2220] = 2217,
  [2221] = 2221,
  [2222] = 2219,
  [2223] = 2223,
  [2224] = 2203,
  [2225] = 1205,
  [2226] = 2138,
  [2227] = 2146,
  [2228] = 2191,
  [2229] = 2210,
  [2230] = 2174,
  [2231] = 2216,
  [2232] = 2221,
  [2233] = 2213,
  [2234] = 2211,
  [2235] = 2217,
  [2236] = 2236,
  [2237] = 2210,
  [2238] = 2221,
  [2239] = 2239,
  [2240] = 2223,
  [2241] = 2196,
  [2242] = 2173,
  [2243] = 2236,
  [2244] = 2211,
  [2245] = 2165,
  [2246] = 2175,
  [2247] = 2213,
  [2248] = 2178,
  [2249] = 2239,
  [2250] = 2195,
  [2251] = 2236,
  [2252] = 2219,
  [2253] = 2253,
  [2254] = 2253,
  [2255] = 2191,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2253,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2253,
  [2265] = 2260,
  [2266] = 2262,
  [2267] = 2267,
  [2268] = 2174,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2260,
  [2272] = 2253,
  [2273] = 2273,
  [2274] = 2173,
  [2275] = 2165,
  [2276] = 2262,
  [2277] = 2178,
  [2278] = 2175,
  [2279] = 2163,
  [2280] = 2256,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2262,
  [2284] = 2260,
  [2285] = 2253,
  [2286] = 2262,
  [2287] = 2260,
  [2288] = 2258,
  [2289] = 2257,
  [2290] = 2260,
  [2291] = 2253,
  [2292] = 2262,
  [2293] = 2262,
  [2294] = 2253,
  [2295] = 2259,
  [2296] = 2260,
  [2297] = 2253,
  [2298] = 2262,
  [2299] = 2281,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2260,
  [2303] = 2270,
  [2304] = 2304,
  [2305] = 2262,
  [2306] = 2301,
  [2307] = 2253,
  [2308] = 2260,
  [2309] = 2260,
  [2310] = 2260,
  [2311] = 2262,
  [2312] = 2260,
  [2313] = 2253,
  [2314] = 2253,
  [2315] = 2300,
  [2316] = 2262,
  [2317] = 2260,
  [2318] = 2263,
  [2319] = 2260,
  [2320] = 2253,
  [2321] = 2262,
  [2322] = 2282,
  [2323] = 2253,
  [2324] = 2269,
  [2325] = 2262,
  [2326] = 2195,
  [2327] = 2196,
  [2328] = 2262,
  [2329] = 2260,
  [2330] = 2199,
  [2331] = 2253,
  [2332] = 2203,
  [2333] = 2262,
  [2334] = 2267,
  [2335] = 2304,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2337,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2270,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 1205,
  [2346] = 2346,
  [2347] = 2343,
  [2348] = 2348,
  [2349] = 2304,
  [2350] = 2350,
  [2351] = 2270,
  [2352] = 2301,
  [2353] = 2350,
  [2354] = 2348,
  [2355] = 1134,
  [2356] = 1208,
  [2357] = 2344,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 1133,
  [2361] = 2336,
  [2362] = 2281,
  [2363] = 2337,
  [2364] = 2337,
  [2365] = 2256,
  [2366] = 2358,
  [2367] = 2257,
  [2368] = 2258,
  [2369] = 2337,
  [2370] = 2281,
  [2371] = 2339,
  [2372] = 2340,
  [2373] = 2259,
  [2374] = 1132,
  [2375] = 2269,
  [2376] = 2343,
  [2377] = 2267,
  [2378] = 2348,
  [2379] = 2346,
  [2380] = 2337,
  [2381] = 2381,
  [2382] = 2258,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2381,
  [2387] = 2281,
  [2388] = 2388,
  [2389] = 2381,
  [2390] = 2381,
  [2391] = 2384,
  [2392] = 2384,
  [2393] = 2132,
  [2394] = 1134,
  [2395] = 1132,
  [2396] = 2381,
  [2397] = 2397,
  [2398] = 2384,
  [2399] = 2381,
  [2400] = 2381,
  [2401] = 2384,
  [2402] = 2301,
  [2403] = 2384,
  [2404] = 2259,
  [2405] = 2381,
  [2406] = 2406,
  [2407] = 2257,
  [2408] = 2256,
  [2409] = 2384,
  [2410] = 2381,
  [2411] = 2384,
  [2412] = 2384,
  [2413] = 2381,
  [2414] = 2406,
  [2415] = 2267,
  [2416] = 2381,
  [2417] = 2304,
  [2418] = 2384,
  [2419] = 2269,
  [2420] = 2381,
  [2421] = 2384,
  [2422] = 2384,
  [2423] = 2381,
  [2424] = 1133,
  [2425] = 2381,
  [2426] = 2384,
  [2427] = 2381,
  [2428] = 2384,
  [2429] = 2384,
  [2430] = 2270,
  [2431] = 1141,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2432,
  [2435] = 2435,
  [2436] = 2436,
  [2437] = 2437,
  [2438] = 2437,
  [2439] = 1139,
  [2440] = 2433,
  [2441] = 2441,
  [2442] = 2121,
  [2443] = 2443,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2444,
  [2447] = 2124,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2450,
  [2451] = 2132,
  [2452] = 2449,
  [2453] = 1172,
  [2454] = 2454,
  [2455] = 2450,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 1141,
  [2459] = 2443,
  [2460] = 2454,
  [2461] = 2461,
  [2462] = 2444,
  [2463] = 2450,
  [2464] = 2449,
  [2465] = 1179,
  [2466] = 2126,
  [2467] = 1125,
  [2468] = 2468,
  [2469] = 1159,
  [2470] = 2468,
  [2471] = 2441,
  [2472] = 2472,
  [2473] = 2454,
  [2474] = 1139,
  [2475] = 2456,
  [2476] = 2128,
  [2477] = 2456,
  [2478] = 2478,
  [2479] = 2461,
  [2480] = 2441,
  [2481] = 2481,
  [2482] = 2481,
  [2483] = 1172,
  [2484] = 2481,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2481,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2487,
  [2499] = 2488,
  [2500] = 2489,
  [2501] = 2501,
  [2502] = 2481,
  [2503] = 2503,
  [2504] = 2487,
  [2505] = 2493,
  [2506] = 2488,
  [2507] = 2489,
  [2508] = 2486,
  [2509] = 2488,
  [2510] = 2487,
  [2511] = 2481,
  [2512] = 2481,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2489,
  [2517] = 2488,
  [2518] = 2487,
  [2519] = 1205,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 2487,
  [2523] = 2523,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 2488,
  [2527] = 2489,
  [2528] = 2487,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2481,
  [2532] = 2489,
  [2533] = 2481,
  [2534] = 2488,
  [2535] = 2488,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2538,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2489,
  [2542] = 2487,
  [2543] = 2543,
  [2544] = 2497,
  [2545] = 2545,
  [2546] = 2537,
  [2547] = 2496,
  [2548] = 2487,
  [2549] = 2488,
  [2550] = 2489,
  [2551] = 2494,
  [2552] = 2485,
  [2553] = 2545,
  [2554] = 2494,
  [2555] = 2496,
  [2556] = 2489,
  [2557] = 2497,
  [2558] = 2540,
  [2559] = 2539,
  [2560] = 2538,
  [2561] = 2487,
  [2562] = 2501,
  [2563] = 2481,
  [2564] = 2503,
  [2565] = 2537,
  [2566] = 2488,
  [2567] = 1208,
  [2568] = 2489,
  [2569] = 2536,
  [2570] = 2487,
  [2571] = 2488,
  [2572] = 2489,
  [2573] = 2489,
  [2574] = 2488,
  [2575] = 1179,
  [2576] = 2487,
  [2577] = 2487,
  [2578] = 2525,
  [2579] = 2481,
  [2580] = 2481,
  [2581] = 2524,
  [2582] = 2530,
  [2583] = 2492,
  [2584] = 2487,
  [2585] = 2523,
  [2586] = 2529,
  [2587] = 2488,
  [2588] = 2491,
  [2589] = 2489,
  [2590] = 2490,
  [2591] = 2521,
  [2592] = 2520,
  [2593] = 2515,
  [2594] = 2488,
  [2595] = 2514,
  [2596] = 2481,
  [2597] = 2485,
  [2598] = 2481,
  [2599] = 2486,
  [2600] = 2494,
  [2601] = 2601,
  [2602] = 2602,
  [2603] = 2525,
  [2604] = 2496,
  [2605] = 2497,
  [2606] = 2524,
  [2607] = 2523,
  [2608] = 2545,
  [2609] = 2489,
  [2610] = 2610,
  [2611] = 2540,
  [2612] = 2521,
  [2613] = 2539,
  [2614] = 2520,
  [2615] = 2538,
  [2616] = 2489,
  [2617] = 2488,
  [2618] = 2487,
  [2619] = 2515,
  [2620] = 2536,
  [2621] = 1159,
  [2622] = 2493,
  [2623] = 2492,
  [2624] = 2514,
  [2625] = 2491,
  [2626] = 2513,
  [2627] = 2490,
  [2628] = 2602,
  [2629] = 2481,
  [2630] = 2529,
  [2631] = 2543,
  [2632] = 2632,
  [2633] = 905,
  [2634] = 2634,
  [2635] = 2634,
  [2636] = 2636,
  [2637] = 2637,
  [2638] = 2638,
  [2639] = 2639,
  [2640] = 2640,
  [2641] = 2632,
  [2642] = 2642,
  [2643] = 2636,
  [2644] = 2634,
  [2645] = 2638,
  [2646] = 912,
  [2647] = 2632,
  [2648] = 2642,
  [2649] = 2636,
  [2650] = 2639,
  [2651] = 2640,
  [2652] = 2359,
  [2653] = 907,
  [2654] = 2632,
  [2655] = 2642,
  [2656] = 2636,
  [2657] = 2657,
  [2658] = 2658,
  [2659] = 2659,
  [2660] = 2632,
  [2661] = 2642,
  [2662] = 2662,
  [2663] = 2636,
  [2664] = 2664,
  [2665] = 2665,
  [2666] = 2666,
  [2667] = 2632,
  [2668] = 2642,
  [2669] = 2669,
  [2670] = 2636,
  [2671] = 2634,
  [2672] = 2632,
  [2673] = 2642,
  [2674] = 2636,
  [2675] = 2642,
  [2676] = 2676,
  [2677] = 2632,
  [2678] = 2642,
  [2679] = 2636,
  [2680] = 2632,
  [2681] = 2669,
  [2682] = 2642,
  [2683] = 2636,
  [2684] = 2632,
  [2685] = 2642,
  [2686] = 2636,
  [2687] = 2632,
  [2688] = 2642,
  [2689] = 2636,
  [2690] = 902,
  [2691] = 898,
  [2692] = 2692,
  [2693] = 2639,
  [2694] = 2657,
  [2695] = 2632,
  [2696] = 2642,
  [2697] = 2636,
  [2698] = 2632,
  [2699] = 2642,
  [2700] = 2636,
  [2701] = 2676,
  [2702] = 1126,
  [2703] = 2664,
  [2704] = 2665,
  [2705] = 2632,
  [2706] = 2642,
  [2707] = 2636,
  [2708] = 2632,
  [2709] = 2642,
  [2710] = 2636,
  [2711] = 2637,
  [2712] = 2634,
  [2713] = 900,
  [2714] = 2634,
  [2715] = 2664,
  [2716] = 2666,
  [2717] = 1208,
  [2718] = 1205,
  [2719] = 2665,
  [2720] = 2692,
  [2721] = 2634,
  [2722] = 2722,
  [2723] = 2723,
  [2724] = 2724,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2727,
  [2728] = 2728,
  [2729] = 2729,
  [2730] = 2730,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2738,
  [2739] = 2739,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2746,
  [2747] = 2747,
  [2748] = 2748,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2752,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 2758,
  [2763] = 2763,
  [2764] = 2764,
  [2765] = 2765,
  [2766] = 2766,
  [2767] = 2767,
  [2768] = 2768,
  [2769] = 2769,
  [2770] = 2770,
  [2771] = 2771,
  [2772] = 2772,
  [2773] = 2773,
  [2774] = 2774,
  [2775] = 2775,
  [2776] = 2774,
  [2777] = 2777,
  [2778] = 2778,
  [2779] = 2779,
  [2780] = 2780,
  [2781] = 2781,
  [2782] = 2782,
  [2783] = 2783,
  [2784] = 2749,
  [2785] = 2785,
  [2786] = 2786,
  [2787] = 2787,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2790,
  [2791] = 2791,
  [2792] = 2792,
  [2793] = 2740,
  [2794] = 2739,
  [2795] = 2736,
  [2796] = 2735,
  [2797] = 2732,
  [2798] = 2723,
  [2799] = 2799,
  [2800] = 2727,
  [2801] = 2724,
  [2802] = 2802,
  [2803] = 2803,
  [2804] = 2804,
  [2805] = 2767,
  [2806] = 2743,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 2773,
  [2810] = 2737,
  [2811] = 2811,
  [2812] = 2772,
  [2813] = 2773,
  [2814] = 2814,
  [2815] = 2751,
  [2816] = 2816,
  [2817] = 2804,
  [2818] = 2730,
  [2819] = 2787,
  [2820] = 2782,
  [2821] = 2780,
  [2822] = 2734,
  [2823] = 2780,
  [2824] = 2782,
  [2825] = 2773,
  [2826] = 2772,
  [2827] = 2787,
  [2828] = 2803,
  [2829] = 2723,
  [2830] = 2792,
  [2831] = 2741,
  [2832] = 2814,
  [2833] = 2833,
  [2834] = 2834,
  [2835] = 2738,
  [2836] = 2760,
  [2837] = 2731,
  [2838] = 2745,
  [2839] = 2757,
  [2840] = 2764,
  [2841] = 2765,
  [2842] = 2842,
  [2843] = 2843,
  [2844] = 2844,
  [2845] = 2845,
  [2846] = 2772,
  [2847] = 2807,
  [2848] = 2773,
  [2849] = 2783,
  [2850] = 2754,
  [2851] = 2851,
  [2852] = 2852,
  [2853] = 2740,
  [2854] = 2739,
  [2855] = 2736,
  [2856] = 2735,
  [2857] = 2732,
  [2858] = 2858,
  [2859] = 2859,
  [2860] = 2727,
  [2861] = 2724,
  [2862] = 2788,
  [2863] = 2780,
  [2864] = 2782,
  [2865] = 2787,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 2869,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 2872,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2875,
  [2876] = 2876,
  [2877] = 2877,
  [2878] = 2763,
  [2879] = 2787,
  [2880] = 2782,
  [2881] = 2780,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2773,
  [2886] = 2772,
  [2887] = 2799,
  [2888] = 2888,
  [2889] = 2889,
  [2890] = 2890,
  [2891] = 2778,
  [2892] = 2892,
  [2893] = 2777,
  [2894] = 2894,
  [2895] = 2781,
  [2896] = 2896,
  [2897] = 2790,
  [2898] = 2898,
  [2899] = 2772,
  [2900] = 2851,
  [2901] = 2773,
  [2902] = 2728,
  [2903] = 2898,
  [2904] = 2904,
  [2905] = 2888,
  [2906] = 2906,
  [2907] = 2780,
  [2908] = 2782,
  [2909] = 2787,
  [2910] = 2882,
  [2911] = 2843,
  [2912] = 2787,
  [2913] = 2782,
  [2914] = 2780,
  [2915] = 2851,
  [2916] = 2787,
  [2917] = 2782,
  [2918] = 2773,
  [2919] = 2772,
  [2920] = 2858,
  [2921] = 2921,
  [2922] = 2873,
  [2923] = 2790,
  [2924] = 2780,
  [2925] = 2866,
  [2926] = 2845,
  [2927] = 2785,
  [2928] = 2765,
  [2929] = 2764,
  [2930] = 2760,
  [2931] = 2781,
  [2932] = 2779,
  [2933] = 2873,
  [2934] = 2833,
  [2935] = 2771,
  [2936] = 2936,
  [2937] = 2888,
  [2938] = 2772,
  [2939] = 2877,
  [2940] = 2876,
  [2941] = 2772,
  [2942] = 2867,
  [2943] = 2773,
  [2944] = 2868,
  [2945] = 2787,
  [2946] = 2782,
  [2947] = 2780,
  [2948] = 2725,
  [2949] = 2949,
  [2950] = 2869,
  [2951] = 2773,
  [2952] = 2772,
  [2953] = 2953,
  [2954] = 2877,
  [2955] = 2955,
  [2956] = 2780,
  [2957] = 2896,
  [2958] = 2729,
  [2959] = 2959,
  [2960] = 2953,
  [2961] = 2949,
  [2962] = 2904,
  [2963] = 2894,
  [2964] = 2782,
  [2965] = 2884,
  [2966] = 2802,
  [2967] = 2786,
  [2968] = 2746,
  [2969] = 2747,
  [2970] = 2750,
  [2971] = 2753,
  [2972] = 2787,
  [2973] = 2755,
  [2974] = 2756,
  [2975] = 2761,
  [2976] = 2768,
  [2977] = 2775,
  [2978] = 2787,
  [2979] = 2782,
  [2980] = 2780,
  [2981] = 2870,
  [2982] = 2871,
  [2983] = 2872,
  [2984] = 2773,
  [2985] = 2772,
  [2986] = 2874,
  [2987] = 2808,
  [2988] = 2816,
  [2989] = 2872,
  [2990] = 2889,
  [2991] = 2844,
  [2992] = 2921,
  [2993] = 2722,
  [2994] = 2892,
  [2995] = 2890,
  [2996] = 2883,
  [2997] = 2871,
  [2998] = 2875,
  [2999] = 2870,
  [3000] = 2842,
  [3001] = 2869,
  [3002] = 2868,
  [3003] = 2814,
  [3004] = 2845,
  [3005] = 2867,
  [3006] = 2876,
  [3007] = 2804,
  [3008] = 2882,
  [3009] = 2730,
  [3010] = 2803,
  [3011] = 2787,
  [3012] = 2782,
  [3013] = 2780,
  [3014] = 3014,
  [3015] = 3015,
  [3016] = 2874,
  [3017] = 2773,
  [3018] = 2772,
  [3019] = 2788,
  [3020] = 2792,
  [3021] = 2724,
  [3022] = 2770,
  [3023] = 2748,
  [3024] = 3024,
  [3025] = 2727,
  [3026] = 2772,
  [3027] = 2742,
  [3028] = 2773,
  [3029] = 2738,
  [3030] = 2811,
  [3031] = 2726,
  [3032] = 2772,
  [3033] = 2731,
  [3034] = 2745,
  [3035] = 2757,
  [3036] = 2773,
  [3037] = 2959,
  [3038] = 2789,
  [3039] = 2791,
  [3040] = 3014,
  [3041] = 2780,
  [3042] = 2787,
  [3043] = 2782,
  [3044] = 2780,
  [3045] = 2782,
  [3046] = 2787,
  [3047] = 2782,
  [3048] = 2773,
  [3049] = 2772,
  [3050] = 2843,
  [3051] = 2787,
  [3052] = 2866,
  [3053] = 2732,
  [3054] = 2807,
  [3055] = 2780,
  [3056] = 3015,
  [3057] = 2733,
  [3058] = 2783,
  [3059] = 2735,
  [3060] = 2736,
  [3061] = 2955,
  [3062] = 2769,
  [3063] = 2754,
  [3064] = 2739,
  [3065] = 2740,
  [3066] = 3066,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 3069,
  [3070] = 3070,
  [3071] = 3071,
  [3072] = 3072,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 3076,
  [3077] = 3077,
  [3078] = 3078,
  [3079] = 3069,
  [3080] = 3080,
  [3081] = 3081,
  [3082] = 3082,
  [3083] = 3083,
  [3084] = 3084,
  [3085] = 3085,
  [3086] = 3086,
  [3087] = 3075,
  [3088] = 3088,
  [3089] = 3083,
  [3090] = 3069,
  [3091] = 3073,
  [3092] = 3072,
  [3093] = 3067,
  [3094] = 3076,
  [3095] = 3077,
  [3096] = 3078,
  [3097] = 3081,
  [3098] = 3081,
  [3099] = 3069,
  [3100] = 3086,
  [3101] = 3088,
  [3102] = 2126,
  [3103] = 3081,
  [3104] = 3078,
  [3105] = 3069,
  [3106] = 3069,
  [3107] = 3074,
  [3108] = 3074,
  [3109] = 3069,
  [3110] = 3069,
  [3111] = 3081,
  [3112] = 3077,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 3086,
  [3116] = 3113,
  [3117] = 3088,
  [3118] = 3083,
  [3119] = 3081,
  [3120] = 3084,
  [3121] = 3069,
  [3122] = 3076,
  [3123] = 3080,
  [3124] = 3085,
  [3125] = 3069,
  [3126] = 3069,
  [3127] = 3075,
  [3128] = 3069,
  [3129] = 3069,
  [3130] = 3070,
  [3131] = 3085,
  [3132] = 3068,
  [3133] = 2128,
  [3134] = 3069,
  [3135] = 3081,
  [3136] = 3081,
  [3137] = 3080,
  [3138] = 3084,
  [3139] = 3069,
  [3140] = 3070,
  [3141] = 3071,
  [3142] = 3142,
  [3143] = 3143,
  [3144] = 3144,
  [3145] = 3143,
  [3146] = 3142,
  [3147] = 3147,
  [3148] = 3148,
  [3149] = 3149,
  [3150] = 3150,
  [3151] = 3151,
  [3152] = 3143,
  [3153] = 3153,
  [3154] = 3154,
  [3155] = 1040,
  [3156] = 3153,
  [3157] = 3143,
  [3158] = 3158,
  [3159] = 3159,
  [3160] = 3160,
  [3161] = 3161,
  [3162] = 3142,
  [3163] = 3144,
  [3164] = 3149,
  [3165] = 3165,
  [3166] = 3153,
  [3167] = 3143,
  [3168] = 3168,
  [3169] = 3147,
  [3170] = 3143,
  [3171] = 3148,
  [3172] = 3150,
  [3173] = 3173,
  [3174] = 3174,
  [3175] = 3175,
  [3176] = 3165,
  [3177] = 3142,
  [3178] = 3178,
  [3179] = 3150,
  [3180] = 3154,
  [3181] = 3181,
  [3182] = 3182,
  [3183] = 3183,
  [3184] = 3184,
  [3185] = 3185,
  [3186] = 3178,
  [3187] = 3187,
  [3188] = 3188,
  [3189] = 3189,
  [3190] = 3175,
  [3191] = 3143,
  [3192] = 3143,
  [3193] = 3193,
  [3194] = 3194,
  [3195] = 3195,
  [3196] = 3196,
  [3197] = 3187,
  [3198] = 3160,
  [3199] = 3187,
  [3200] = 3194,
  [3201] = 3193,
  [3202] = 3202,
  [3203] = 3143,
  [3204] = 3182,
  [3205] = 3144,
  [3206] = 3143,
  [3207] = 3207,
  [3208] = 3196,
  [3209] = 3209,
  [3210] = 3181,
  [3211] = 3209,
  [3212] = 3212,
  [3213] = 3212,
  [3214] = 910,
  [3215] = 3215,
  [3216] = 3142,
  [3217] = 3207,
  [3218] = 3160,
  [3219] = 3173,
  [3220] = 3174,
  [3221] = 3175,
  [3222] = 3143,
  [3223] = 3195,
  [3224] = 3224,
  [3225] = 3154,
  [3226] = 3187,
  [3227] = 3227,
  [3228] = 3182,
  [3229] = 3229,
  [3230] = 3187,
  [3231] = 3154,
  [3232] = 3187,
  [3233] = 3182,
  [3234] = 3168,
  [3235] = 1044,
  [3236] = 911,
  [3237] = 3142,
  [3238] = 3143,
  [3239] = 3207,
  [3240] = 3182,
  [3241] = 3241,
  [3242] = 3149,
  [3243] = 3243,
  [3244] = 3244,
  [3245] = 3193,
  [3246] = 3143,
  [3247] = 3154,
  [3248] = 3187,
  [3249] = 3244,
  [3250] = 3148,
  [3251] = 3183,
  [3252] = 3252,
  [3253] = 3182,
  [3254] = 3194,
  [3255] = 3154,
  [3256] = 3187,
  [3257] = 3143,
  [3258] = 3154,
  [3259] = 3195,
  [3260] = 3215,
  [3261] = 3188,
  [3262] = 3262,
  [3263] = 3182,
  [3264] = 3154,
  [3265] = 3187,
  [3266] = 3154,
  [3267] = 3187,
  [3268] = 3154,
  [3269] = 3196,
  [3270] = 3215,
  [3271] = 3187,
  [3272] = 3188,
  [3273] = 3209,
  [3274] = 3187,
  [3275] = 3173,
  [3276] = 3187,
  [3277] = 3185,
  [3278] = 3143,
  [3279] = 3202,
  [3280] = 3175,
  [3281] = 3244,
  [3282] = 3160,
  [3283] = 3183,
  [3284] = 3284,
  [3285] = 3244,
  [3286] = 3154,
  [3287] = 3244,
  [3288] = 3185,
  [3289] = 3244,
  [3290] = 3187,
  [3291] = 3244,
  [3292] = 3154,
  [3293] = 3174,
  [3294] = 3154,
  [3295] = 3187,
  [3296] = 3212,
  [3297] = 3181,
  [3298] = 907,
  [3299] = 902,
  [3300] = 897,
  [3301] = 3168,
  [3302] = 3154,
  [3303] = 899,
  [3304] = 3161,
  [3305] = 3151,
  [3306] = 3241,
  [3307] = 3262,
  [3308] = 3159,
  [3309] = 3252,
  [3310] = 3142,
  [3311] = 3173,
  [3312] = 3147,
  [3313] = 3154,
  [3314] = 3174,
  [3315] = 3315,
  [3316] = 3316,
};

static TSCharacterRange extras_character_set_1[] = {
  {'\t', '\r'}, {' ', ' '}, {0x85, 0x85}, {0xa0, 0xa0}, {0x1680, 0x1680}, {0x2000, 0x200a}, {0x2028, 0x2029}, {0x202f, 0x202f},
  {0x205f, 0x205f}, {0x3000, 0x3000},
};

static TSCharacterRange aux_sym__func1op_token1_character_set_1[] = {
  {'A', 'C'}, {'M', 'M'}, {'O', 'O'}, {'R', 'T'}, {'W', 'X'}, {'b', 'g'}, {'k', 'l'}, {'o', 'p'},
  {'r', 'u'}, {'w', 'x'}, {'z', 'z'},
};

static TSCharacterRange aux_sym__interpolation_fallbacks_token1_character_set_1[] = {
  {0, '#'}, {'%', '&'}, {'(', '*'}, {',', ','}, {'.', '/'}, {';', '@'}, {'[', '^'}, {'`', '`'},
  {'{', 0x10ffff},
};

static TSCharacterRange sym_match_regexp_modifiers_character_set_1[] = {
  {'a', 'a'}, {'c', 'd'}, {'g', 'g'}, {'i', 'i'}, {'l', 'n'}, {'p', 'p'}, {'s', 's'}, {'u', 'u'},
  {'x', 'x'},
};

static TSCharacterRange sym_substitution_regexp_modifiers_character_set_1[] = {
  {'a', 'a'}, {'c', 'e'}, {'g', 'g'}, {'i', 'i'}, {'l', 'm'}, {'o', 'p'}, {'r', 's'}, {'u', 'u'},
  {'x', 'x'},
};

static TSCharacterRange sym__identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d},
  {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3},
  {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae},
  {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029},
  {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e},
  {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b},
  {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3},
  {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7},
  {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4},
  {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf},
  {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4},
  {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2},
  {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d},
  {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d},
  {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375},
  {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527},
  {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9},
  {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805},
  {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2},
  {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17},
  {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075},
  {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2},
  {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d},
  {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333},
  {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af},
  {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8},
  {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916},
  {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00},
  {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e},
  {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68},
  {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0},
  {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43},
  {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3},
  {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c},
  {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505},
  {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550},
  {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e},
  {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943},
  {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37},
  {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52},
  {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64},
  {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3},
  {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d},
  {0x30000, 0x3134a},
};

static TSCharacterRange sym__identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6},
  {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377},
  {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf2}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xecd},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1371, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19d9}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115},
  {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096},
  {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e},
  {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff66, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0},
  {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d},
  {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592},
  {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767},
  {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c},
  {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7},
  {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075},
  {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173},
  {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x1123e},
  {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303},
  {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348},
  {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459},
  {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640},
  {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746},
  {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938},
  {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47},
  {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f},
  {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47},
  {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6},
  {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38},
  {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43},
  {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1},
  {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe},
  {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99},
  {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad},
  {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9},
  {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e},
  {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714},
  {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff},
  {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1e000, 0x1e006},
  {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6},
  {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1},
  {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static TSCharacterRange aux_sym__bareword_token1_character_set_1[] = {
  {':', ':'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6},
  {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377},
  {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f},
  {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f},
  {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824},
  {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d},
  {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a},
  {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e},
  {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd},
  {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33},
  {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0},
  {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61},
  {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde},
  {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56},
  {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30},
  {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0},
  {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c},
  {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070},
  {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731},
  {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8},
  {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16},
  {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23},
  {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6},
  {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c},
  {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128},
  {0x212a, 0x212d}, {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288},
  {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330},
  {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461},
  {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa},
  {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913},
  {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3},
  {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08},
  {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65},
  {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f},
  {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1},
  {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122},
  {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange aux_sym__bareword_token1_character_set_2[] = {
  {'0', ':'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6},
  {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377},
  {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf2}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xecd},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1371, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19d9}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115},
  {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096},
  {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e},
  {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff66, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0},
  {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d},
  {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592},
  {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767},
  {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c},
  {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7},
  {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075},
  {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173},
  {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x1123e},
  {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303},
  {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348},
  {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459},
  {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640},
  {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746},
  {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938},
  {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47},
  {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f},
  {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47},
  {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6},
  {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38},
  {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43},
  {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1},
  {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe},
  {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99},
  {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad},
  {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9},
  {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e},
  {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714},
  {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff},
  {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1e000, 0x1e006},
  {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6},
  {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1},
  {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(101);
      ADVANCE_MAP(
        0x04, 246,
        '!', 197,
        '#', 242,
        '$', 124,
        '%', 206,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 172,
        '/', 175,
        '0', 420,
        ':', 106,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '@', 128,
        '[', 247,
        '\\', 201,
        ']', 126,
        '^', 79,
        'a', 264,
        'c', 230,
        'd', 270,
        'e', 230,
        'g', 230,
        'i', 269,
        'l', 270,
        'm', 261,
        'n', 270,
        'o', 230,
        'p', 270,
        'r', 230,
        's', 263,
        'u', 268,
        'v', 388,
        'x', 270,
        '{', 103,
        '|', 161,
        '}', 104,
        '~', 195,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(aux_sym__func1op_token1_character_set_1, 11, lookahead)) ADVANCE(230);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(96);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        0x04, 246,
        '!', 197,
        '#', 242,
        '$', 124,
        '%', 206,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 172,
        '/', 175,
        '0', 420,
        ':', 106,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '@', 128,
        '[', 125,
        '\\', 201,
        ']', 126,
        '^', 78,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        'x', 176,
        '{', 103,
        '|', 161,
        '}', 104,
        '~', 195,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(1);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        0x04, 246,
        '!', 197,
        '#', 242,
        '$', 124,
        '%', 206,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 172,
        '/', 175,
        '0', 420,
        ':', 106,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '@', 128,
        '[', 125,
        '\\', 201,
        ']', 126,
        '^', 78,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        'x', 176,
        '{', 102,
        '|', 161,
        '}', 104,
        '~', 195,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(2);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        0x04, 246,
        '!', 196,
        '#', 242,
        '$', 124,
        '%', 206,
        '(', 109,
        ')', 110,
        '*', 173,
        '+', 165,
        ',', 113,
        '-', 168,
        '.', 92,
        '/', 74,
        '0', 420,
        ':', 75,
        ';', 107,
        '<', 132,
        '=', 80,
        '@', 128,
        '[', 125,
        '\\', 201,
        ']', 126,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        '{', 102,
        '}', 104,
        '~', 194,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(3);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '[', 125,
      );
      if (lookahead == '\\') SKIP(18);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(395);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'o') ADVANCE(397);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(4);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '[', 125,
      );
      if (lookahead == '\\') SKIP(48);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(395);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'o') ADVANCE(397);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(5);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 106,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '[', 125,
      );
      if (lookahead == '\\') SKIP(16);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(361);
      if (lookahead == 'c') ADVANCE(359);
      if (lookahead == 'g') ADVANCE(338);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == 'l') ADVANCE(339);
      if (lookahead == 'o') ADVANCE(381);
      if (lookahead == 'x') ADVANCE(176);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(6);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(395);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'o') ADVANCE(397);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(7);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(395);
      if (lookahead == 'c') ADVANCE(285);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'o') ADVANCE(397);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (lookahead == 'd' ||
          lookahead == 'r' ||
          lookahead == 's') ADVANCE(285);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(7);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(284);
      if (lookahead == 'c') ADVANCE(280);
      if (lookahead == 'g') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(283);
      if (lookahead == 'l') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(282);
      if (lookahead == 'x') ADVANCE(284);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (lookahead == 'd' ||
          lookahead == 'e' ||
          lookahead == 'm' ||
          lookahead == 'p' ||
          lookahead == 'r' ||
          lookahead == 's' ||
          lookahead == 'u') ADVANCE(284);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(7);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(274);
      if (lookahead == 'c') ADVANCE(273);
      if (lookahead == 'g') ADVANCE(277);
      if (lookahead == 'i') ADVANCE(276);
      if (lookahead == 'l') ADVANCE(277);
      if (lookahead == 'o') ADVANCE(397);
      if (lookahead == 'x') ADVANCE(277);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (lookahead == 'd' ||
          ('m' <= lookahead && lookahead <= 'p') ||
          lookahead == 's' ||
          lookahead == 'u') ADVANCE(277);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(7);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(266);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(269);
      if (lookahead == 'l') ADVANCE(270);
      if (lookahead == 'o') ADVANCE(397);
      if (lookahead == 'x') ADVANCE(270);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (lookahead == 'd' ||
          ('m' <= lookahead && lookahead <= 'p') ||
          lookahead == 's' ||
          lookahead == 'u') ADVANCE(270);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(7);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        0x04, 246,
        '#', 242,
        '$', 123,
        '%', 206,
        ')', 110,
        ',', 113,
        '-', 167,
        ';', 107,
        '@', 128,
        '[', 125,
      );
      if (lookahead == '\\') SKIP(34);
      if (lookahead == '{') ADVANCE(102);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(12);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        0x04, 246,
        '#', 242,
        '$', 123,
        '%', 206,
        ')', 110,
        ',', 113,
        '-', 170,
        ';', 107,
        '>', 81,
        '@', 128,
        '[', 247,
      );
      if (lookahead == '\\') SKIP(34);
      if (lookahead == '{') ADVANCE(249);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(12);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        0x04, 246,
        '#', 242,
        '$', 123,
        '(', 109,
        ')', 110,
        '*', 173,
        ',', 113,
        '-', 167,
        ';', 107,
        '=', 80,
        '>', 133,
        '@', 128,
        '[', 125,
      );
      if (lookahead == '\\') SKIP(32);
      if (lookahead == 'a') ADVANCE(395);
      if (lookahead == 'o') ADVANCE(397);
      if (lookahead == '{') ADVANCE(102);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(14);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(6);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(6);
      if (lookahead == '\r') SKIP(15);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(4);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(4);
      if (lookahead == '\r') SKIP(17);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(7);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(7);
      if (lookahead == '\r') SKIP(19);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(53);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(53);
      if (lookahead == '\r') SKIP(21);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(56);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(56);
      if (lookahead == '\r') SKIP(23);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(54);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(54);
      if (lookahead == '\r') SKIP(25);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(55);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(55);
      if (lookahead == '\r') SKIP(27);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(58);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(58);
      if (lookahead == '\r') SKIP(29);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(14);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(14);
      if (lookahead == '\r') SKIP(31);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(12);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(12);
      if (lookahead == '\r') SKIP(33);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(62);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(62);
      if (lookahead == '\r') SKIP(35);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(71);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(71);
      if (lookahead == '\r') SKIP(37);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(69);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(69);
      if (lookahead == '\r') SKIP(39);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(63);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(63);
      if (lookahead == '\r') SKIP(41);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(70);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(70);
      if (lookahead == '\r') SKIP(43);
      END_STATE();
    case 45:
      if (lookahead == '\n') ADVANCE(254);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(253);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(254);
      if (lookahead == '$' ||
          lookahead == '\'' ||
          lookahead == '+' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= ':') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(286);
      if (lookahead != 0) ADVANCE(253);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(46);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(286);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(287);
      if (lookahead != 0) ADVANCE(286);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(5);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(5);
      if (lookahead == '\r') SKIP(47);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '!', 196,
        '#', 242,
        '$', 124,
        '%', 206,
        '(', 109,
        '*', 173,
        '+', 165,
        '-', 168,
        '.', 410,
        '/', 411,
        '0', 408,
        ':', 412,
        ';', 107,
        '<', 132,
        '@', 128,
        '[', 125,
        '\\', 201,
        '^', 415,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        '{', 103,
        '}', 104,
        '~', 194,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(409);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(403);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      if (lookahead != 0) ADVANCE(402);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '!', 196,
        '#', 242,
        '$', 124,
        '%', 206,
        '(', 109,
        '*', 173,
        '+', 165,
        '-', 168,
        '.', 92,
        '/', 74,
        '0', 420,
        ':', 75,
        ';', 107,
        '<', 132,
        '@', 128,
        '[', 125,
        '\\', 201,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        'v', 388,
        '{', 102,
        '~', 194,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(50);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '!', 196,
        '#', 242,
        '$', 124,
        '%', 206,
        '(', 109,
        '*', 173,
        '+', 165,
        '-', 168,
        '.', 92,
        '/', 74,
        '0', 420,
        ':', 75,
        '<', 132,
        '@', 128,
        '[', 125,
        '\\', 201,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        '{', 102,
        '~', 194,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(51);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '!', 196,
        '#', 242,
        '$', 124,
        '%', 206,
        '(', 109,
        '*', 173,
        '+', 165,
        '-', 168,
        '.', 92,
        '/', 74,
        '0', 420,
        ':', 75,
        '<', 132,
        '@', 128,
        '[', 125,
        '\\', 201,
        'a', 353,
        'c', 231,
        'd', 238,
        'e', 237,
        'g', 235,
        'i', 384,
        'l', 232,
        'm', 258,
        'o', 240,
        'p', 239,
        'r', 236,
        's', 234,
        'u', 233,
        '{', 102,
        '~', 194,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(aux_sym__func1op_token1_character_set_1, 11, lookahead)) ADVANCE(241);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(51);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '$', 123,
        '%', 206,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '@', 128,
      );
      if (lookahead == '\\') SKIP(22);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(53);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 54:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '[', 125,
      );
      if (lookahead == '\\') SKIP(26);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(54);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '(', 109,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '[', 125,
      );
      if (lookahead == '\\') SKIP(28);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(55);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 106,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(24);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(359);
      if (lookahead == 'g') ADVANCE(338);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == 'l') ADVANCE(339);
      if (lookahead == 'x') ADVANCE(176);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(56);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(269);
      if (lookahead == 'l') ADVANCE(270);
      if (lookahead == 'x') ADVANCE(270);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (lookahead == 'a' ||
          lookahead == 'd' ||
          lookahead == 'm' ||
          lookahead == 'n' ||
          lookahead == 'p' ||
          lookahead == 's' ||
          lookahead == 'u') ADVANCE(270);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(58);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(58);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(280);
      if (lookahead == 'g') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(283);
      if (lookahead == 'l') ADVANCE(279);
      if (lookahead == 'x') ADVANCE(284);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (lookahead == 'a' ||
          lookahead == 'd' ||
          lookahead == 'e' ||
          lookahead == 'm' ||
          lookahead == 'o' ||
          lookahead == 'p' ||
          lookahead == 'r' ||
          lookahead == 's' ||
          lookahead == 'u') ADVANCE(284);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(58);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 60:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(285);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (lookahead == 'd' ||
          lookahead == 'r' ||
          lookahead == 's') ADVANCE(285);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(58);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 61:
      ADVANCE_MAP(
        '!', 77,
        '#', 242,
        '%', 130,
        '&', 163,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'c') ADVANCE(273);
      if (lookahead == 'g') ADVANCE(277);
      if (lookahead == 'i') ADVANCE(276);
      if (lookahead == 'l') ADVANCE(277);
      if (lookahead == 'x') ADVANCE(277);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '~') ADVANCE(87);
      if (lookahead == 'a' ||
          lookahead == 'd' ||
          lookahead == 'm' ||
          lookahead == 'n' ||
          lookahead == 'p' ||
          lookahead == 's' ||
          lookahead == 'u') ADVANCE(277);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(58);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        '#', 242,
        '$', 123,
        '%', 129,
        '&', 162,
        '(', 109,
        '*', 173,
        ':', 75,
        '@', 128,
        '[', 125,
      );
      if (lookahead == '\\') SKIP(36);
      if (lookahead == '{') ADVANCE(102);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(62);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 63:
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == '(') ADVANCE(109);
      if (lookahead == '\\') SKIP(42);
      if (lookahead == 'o') ADVANCE(400);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(63);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      END_STATE();
    case 64:
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == '*') ADVANCE(173);
      if (lookahead == ':') ADVANCE(412);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == '{') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(404);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      if (lookahead != 0) ADVANCE(402);
      END_STATE();
    case 65:
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == ':') ADVANCE(412);
      if (lookahead == '>') ADVANCE(133);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == '{') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(65);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(405);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      if (lookahead != 0) ADVANCE(402);
      END_STATE();
    case 66:
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == ':') ADVANCE(412);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == '{') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(406);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      if (lookahead != 0) ADVANCE(402);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '#', 242,
        '$', 123,
        ':', 412,
        '\\', 253,
        '^', 257,
        '{', 103,
        '\'', 402,
        '+', 402,
        '-', 402,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(255);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(256);
      if (lookahead != 0) ADVANCE(253);
      END_STATE();
    case 68:
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '^') ADVANCE(417);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(407);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      if (lookahead != 0) ADVANCE(402);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '#', 242,
        ')', 110,
        ',', 113,
        '.', 92,
        '0', 420,
        ':', 105,
        ';', 107,
        '=', 80,
      );
      if (lookahead == '\\') SKIP(40);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == 'a') ADVANCE(85);
      if (lookahead == 'o') ADVANCE(86);
      if (lookahead == 'v') ADVANCE(94);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '}') ADVANCE(104);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(69);
      END_STATE();
    case 70:
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '0') ADVANCE(420);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == '\\') SKIP(44);
      if (lookahead == 'v') ADVANCE(388);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(70);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 71:
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == ':') ADVANCE(106);
      if (lookahead == ';') ADVANCE(107);
      if (lookahead == '\\') SKIP(38);
      if (lookahead == '{') ADVANCE(103);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(71);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 72:
      if (lookahead == '.') ADVANCE(114);
      END_STATE();
    case 73:
      if (lookahead == '.') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(426);
      END_STATE();
    case 74:
      if (lookahead == '/') ADVANCE(158);
      END_STATE();
    case 75:
      if (lookahead == ':') ADVANCE(419);
      END_STATE();
    case 76:
      if (lookahead == ':') ADVANCE(321);
      END_STATE();
    case 77:
      if (lookahead == '=') ADVANCE(181);
      if (lookahead == '~') ADVANCE(179);
      END_STATE();
    case 78:
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 79:
      if (lookahead == '=') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(208);
      END_STATE();
    case 80:
      if (lookahead == '>') ADVANCE(209);
      END_STATE();
    case 81:
      if (lookahead == '>') ADVANCE(137);
      END_STATE();
    case 82:
      if (lookahead == '@') ADVANCE(83);
      if (lookahead == '[') ADVANCE(248);
      if (lookahead == '{') ADVANCE(250);
      END_STATE();
    case 83:
      if (lookahead == '[') ADVANCE(251);
      if (lookahead == '{') ADVANCE(252);
      END_STATE();
    case 84:
      if (lookahead == 'd') ADVANCE(116);
      END_STATE();
    case 85:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 87:
      if (lookahead == '~') ADVANCE(185);
      END_STATE();
    case 88:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(422);
      END_STATE();
    case 89:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(423);
      END_STATE();
    case 90:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(422);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(425);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(421);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(426);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(422);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(288);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(424);
      END_STATE();
    case 96:
      if (eof) ADVANCE(101);
      ADVANCE_MAP(
        0x04, 246,
        '!', 197,
        '#', 242,
        '$', 124,
        '%', 206,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 172,
        '/', 175,
        '0', 420,
        ':', 106,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '@', 128,
        '[', 125,
        '\\', 201,
        ']', 126,
        '^', 79,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        'v', 388,
        'x', 176,
        '{', 103,
        '|', 161,
        '}', 104,
        '~', 195,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(96);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 97:
      if (eof) ADVANCE(101);
      ADVANCE_MAP(
        0x04, 246,
        '!', 196,
        '#', 242,
        '$', 124,
        '%', 206,
        '(', 109,
        ')', 110,
        '*', 173,
        '+', 165,
        '-', 168,
        '.', 73,
        '/', 74,
        '0', 420,
        ':', 75,
        ';', 107,
        '<', 132,
        '@', 128,
        '[', 125,
        '\\', 201,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        '{', 103,
        '}', 104,
        '~', 194,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(421);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(97);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      END_STATE();
    case 98:
      if (eof) ADVANCE(101);
      ADVANCE_MAP(
        0x04, 246,
        '!', 77,
        '#', 242,
        '$', 123,
        '%', 206,
        '&', 163,
        '(', 109,
        ')', 110,
        '*', 174,
        '+', 166,
        ',', 113,
        '-', 169,
        '.', 171,
        '/', 175,
        ':', 105,
        ';', 107,
        '<', 131,
        '=', 138,
        '>', 134,
        '?', 200,
        '@', 128,
      );
      if (lookahead == '\\') SKIP(100);
      if (lookahead == ']') ADVANCE(126);
      if (lookahead == '^') ADVANCE(78);
      if (lookahead == 'a') ADVANCE(395);
      if (lookahead == 'c') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'o') ADVANCE(397);
      if (lookahead == 'x') ADVANCE(177);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(104);
      if (lookahead == '~') ADVANCE(87);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(98);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(401);
      END_STATE();
    case 99:
      if (eof) ADVANCE(101);
      if (lookahead == '\n') SKIP(98);
      END_STATE();
    case 100:
      if (eof) ADVANCE(101);
      if (lookahead == '\n') SKIP(98);
      if (lookahead == '\r') SKIP(99);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(419);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_class);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_our);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_our);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_and);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'd') ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_or);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '#') ADVANCE(207);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(136);
      if (lookahead == '=') ADVANCE(186);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(135);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(187);
      if (lookahead == '>') ADVANCE(164);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(180);
      if (lookahead == '>') ADVANCE(209);
      if (lookahead == '~') ADVANCE(178);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_x_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(114);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(148);
      if (lookahead == '|') ADVANCE(157);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(160);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_GT_GT2);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(198);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(199);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(127);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(82);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '=') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(426);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(159);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_x);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == '=') ADVANCE(146);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_x);
      if (lookahead == '=') ADVANCE(146);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_cmp);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_cmp);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_TILDE_TILDE);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(182);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_le);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_le);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_ge);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_ge);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_isa);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_isa);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '~') ADVANCE(185);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(181);
      if (lookahead == '~') ADVANCE(179);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_local);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_map);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_grep);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_PERCENT2);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_DOLLAR_POUND);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym__var_indirob_autoquote_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_use);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_redo);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_alarm);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_close);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'd') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_closedir);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_caller);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_cos);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_exp);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_lc);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_log);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_ord);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_pop);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_pos);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_rmdir);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_readdir);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_readpipe);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_scalar);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_sin);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_sleep);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_uc);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(307);
      if (lookahead == 'l') ADVANCE(291);
      if (lookahead == 'm') ADVANCE(313);
      if (lookahead == 'o') ADVANCE(317);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'c') ADVANCE(320);
      if (lookahead == 'e') ADVANCE(320);
      if (lookahead == 'o') ADVANCE(294);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'c') ADVANCE(320);
      if (lookahead == 's') ADVANCE(300);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'c') ADVANCE(290);
      if (lookahead == 'i') ADVANCE(310);
      if (lookahead == 'l') ADVANCE(301);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'e') ADVANCE(320);
      if (lookahead == 'r') ADVANCE(299);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'e') ADVANCE(292);
      if (lookahead == 'm') ADVANCE(297);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'l') ADVANCE(318);
      if (lookahead == 'x') ADVANCE(313);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(312);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(295);
      if (lookahead == 'u') ADVANCE(315);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(aux_sym__func1op_token1);
      if (lookahead == ':') ADVANCE(76);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(242);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(aux_sym___DATA___token1);
      if (lookahead == '\r') ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(245);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(aux_sym___DATA___token1);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(243);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n') ADVANCE(244);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(245);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(aux_sym___DATA___token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(245);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_EOT);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_DASH_GT_LBRACK);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_LBRACE3);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_DASH_GT_LBRACE);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_DASH_GT_AT_LBRACK);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_DASH_GT_AT_LBRACE);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym__interpolation_fallbacks_token1);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym__interpolation_fallbacks_token1);
      if (lookahead == '\n') ADVANCE(254);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(253);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(254);
      if ((!eof && set_contains(aux_sym__interpolation_fallbacks_token1_character_set_1, 9, lookahead))) ADVANCE(253);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym__interpolation_fallbacks_token1);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(253);
      if (lookahead == '^') ADVANCE(257);
      if (lookahead == '{') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(255);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(255);
      if ((set_contains(sym__identifier_character_set_1, 657, lookahead)) &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(256);
      if ((!eof && set_contains(aux_sym__interpolation_fallbacks_token1_character_set_1, 9, lookahead))) ADVANCE(253);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(aux_sym__interpolation_fallbacks_token1);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(aux_sym__interpolation_fallbacks_token1);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '^' ||
          lookahead == '_' ||
          lookahead == '|') ADVANCE(402);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_m);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(368);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_s);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'c') ADVANCE(326);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      if (lookahead == 'a') ADVANCE(270);
      if (lookahead == 'd' ||
          lookahead == 'i' ||
          ('l' <= lookahead && lookahead <= 'n') ||
          lookahead == 'p' ||
          lookahead == 's' ||
          lookahead == 'u' ||
          lookahead == 'x') ADVANCE(270);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      if (lookahead == 'a') ADVANCE(267);
      if (lookahead == 'd' ||
          lookahead == 'i' ||
          ('l' <= lookahead && lookahead <= 'n') ||
          lookahead == 'p' ||
          lookahead == 's' ||
          lookahead == 'u' ||
          lookahead == 'x') ADVANCE(270);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      if (lookahead == 'd') ADVANCE(270);
      if (lookahead == 'a' ||
          lookahead == 'i' ||
          ('l' <= lookahead && lookahead <= 'n') ||
          lookahead == 'p' ||
          lookahead == 's' ||
          lookahead == 'u' ||
          lookahead == 'x') ADVANCE(270);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      ADVANCE_MAP(
        'i', 265,
        'l', 270,
        'a', 270,
        'd', 270,
        'm', 270,
        'n', 270,
        'p', 270,
        's', 270,
        'u', 270,
        'x', 270,
      );
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      ADVANCE_MAP(
        'l', 260,
        'n', 262,
        'a', 270,
        'd', 270,
        'i', 270,
        'm', 270,
        'p', 270,
        's', 270,
        'u', 270,
        'x', 270,
      );
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      ADVANCE_MAP(
        'n', 270,
        'a', 270,
        'd', 270,
        'i', 270,
        'l', 270,
        'm', 270,
        'p', 270,
        's', 270,
        'u', 270,
        'x', 270,
      );
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      ADVANCE_MAP(
        'n', 262,
        'a', 270,
        'd', 270,
        'i', 270,
        'l', 270,
        'm', 270,
        'p', 270,
        's', 270,
        'u', 270,
        'x', 270,
      );
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      if (lookahead == 'p') ADVANCE(270);
      if (lookahead == 'a' ||
          lookahead == 'd' ||
          lookahead == 'i' ||
          ('l' <= lookahead && lookahead <= 'n') ||
          lookahead == 's' ||
          lookahead == 'u' ||
          lookahead == 'x') ADVANCE(270);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      if (lookahead == 's') ADVANCE(270);
      if (lookahead == 'a' ||
          lookahead == 'd' ||
          lookahead == 'i' ||
          ('l' <= lookahead && lookahead <= 'n') ||
          lookahead == 'p' ||
          lookahead == 'u' ||
          lookahead == 'x') ADVANCE(270);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      if (lookahead == 's') ADVANCE(260);
      if (lookahead == 'a' ||
          lookahead == 'd' ||
          lookahead == 'i' ||
          ('l' <= lookahead && lookahead <= 'n') ||
          lookahead == 'p' ||
          lookahead == 'u' ||
          lookahead == 'x') ADVANCE(270);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_quoted_regexp_modifiers);
      if ((set_contains(sym_match_regexp_modifiers_character_set_1, 9, lookahead)) &&
          lookahead != 'c' &&
          lookahead != 'g') ADVANCE(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_match_regexp_modifiers);
      if (lookahead == 'a') ADVANCE(277);
      if (set_contains(sym_match_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(277);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_match_regexp_modifiers);
      if (lookahead == 'd') ADVANCE(277);
      if (set_contains(sym_match_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(277);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_match_regexp_modifiers);
      ADVANCE_MAP(
        'm', 275,
        'a', 277,
        'c', 277,
        'd', 277,
        'g', 277,
        'i', 277,
        'l', 277,
        'n', 277,
        'p', 277,
        's', 277,
        'u', 277,
        'x', 277,
      );
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_match_regexp_modifiers);
      ADVANCE_MAP(
        'n', 272,
        'a', 277,
        'c', 277,
        'd', 277,
        'g', 277,
        'i', 277,
        'l', 277,
        'm', 277,
        'p', 277,
        's', 277,
        'u', 277,
        'x', 277,
      );
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_match_regexp_modifiers);
      if (lookahead == 'p') ADVANCE(277);
      if (set_contains(sym_match_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(277);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_match_regexp_modifiers);
      if (lookahead == 's') ADVANCE(271);
      if (set_contains(sym_match_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(277);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_match_regexp_modifiers);
      if (set_contains(sym_match_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(277);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_substitution_regexp_modifiers);
      if (lookahead == 'a') ADVANCE(284);
      if (set_contains(sym_substitution_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(284);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_substitution_regexp_modifiers);
      ADVANCE_MAP(
        'e', 284,
        'a', 284,
        'c', 284,
        'd', 284,
        'g', 284,
        'i', 284,
        'l', 284,
        'm', 284,
        'o', 284,
        'p', 284,
        'r', 284,
        's', 284,
        'u', 284,
        'x', 284,
      );
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_substitution_regexp_modifiers);
      if (lookahead == 'm') ADVANCE(281);
      if (set_contains(sym_substitution_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(284);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_substitution_regexp_modifiers);
      if (lookahead == 'p') ADVANCE(284);
      if (set_contains(sym_substitution_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(284);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_substitution_regexp_modifiers);
      if (lookahead == 'r') ADVANCE(284);
      if (set_contains(sym_substitution_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(284);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_substitution_regexp_modifiers);
      if (lookahead == 's') ADVANCE(278);
      if (set_contains(sym_substitution_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(284);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_substitution_regexp_modifiers);
      if (set_contains(sym_substitution_regexp_modifiers_character_set_1, 9, lookahead)) ADVANCE(284);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_transliteration_modifiers);
      if (lookahead == 'c' ||
          lookahead == 'd' ||
          lookahead == 'r' ||
          lookahead == 's') ADVANCE(285);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym__interpolated_transliteration_content_token1);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym__interpolated_transliteration_content_token1);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '\\') ADVANCE(286);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n') ADVANCE(287);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(286);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_version);
      if (lookahead == '.') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(288);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(315);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(316);
      if (lookahead == 'o') ADVANCE(319);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(298);
      if (lookahead == 'd') ADVANCE(311);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(306);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'c') ADVANCE(293);
      if (lookahead == 'g') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'd') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'd') ADVANCE(304);
      if (lookahead == 'p') ADVANCE(305);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'd') ADVANCE(304);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'd') ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'e') ADVANCE(313);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'e') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'e') ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'e') ADVANCE(315);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'e') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'i') ADVANCE(315);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'i') ADVANCE(314);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'l') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'l') ADVANCE(309);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'l') ADVANCE(289);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'l') ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'n') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'p') ADVANCE(320);
      if (lookahead == 's') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'p') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'p') ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 's') ADVANCE(317);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 's') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 's') ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == 's') ADVANCE(303);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(aux_sym_autoquoted_bareword_token1);
      if (lookahead == ':') ADVANCE(76);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(320);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(355);
      if (lookahead == 'l') ADVANCE(327);
      if (lookahead == 'm') ADVANCE(366);
      if (lookahead == 'o') ADVANCE(382);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(375);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(335);
      if (lookahead == 'd') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(386);
      if (lookahead == 'o') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(354);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'c') ADVANCE(218);
      if (lookahead == 'e') ADVANCE(188);
      if (lookahead == 'o') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'c') ADVANCE(229);
      if (lookahead == 's') ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'c') ADVANCE(328);
      if (lookahead == 'g') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'd') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'd') ADVANCE(349);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'd') ADVANCE(336);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'd') ADVANCE(351);
      if (lookahead == 'p') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(190);
      if (lookahead == 'r') ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(325);
      if (lookahead == 'm') ADVANCE(334);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(210);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(371);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'i') ADVANCE(376);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'i') ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'i') ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'i') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'l') ADVANCE(324);
      if (lookahead == 'n') ADVANCE(333);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'l') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'l') ADVANCE(357);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'l') ADVANCE(385);
      if (lookahead == 'x') ADVANCE(367);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'l') ADVANCE(346);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'l') ADVANCE(329);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'm') ADVANCE(366);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'm') ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'n') ADVANCE(333);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'n') ADVANCE(227);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'o') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'o') ADVANCE(369);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'o') ADVANCE(211);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'p') ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'p') ADVANCE(217);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'p') ADVANCE(204);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'p') ADVANCE(221);
      if (lookahead == 's') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'p') ADVANCE(205);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'p') ADVANCE(228);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'p') ADVANCE(344);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(120);
      if (lookahead == 'u') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(223);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(215);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(226);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 's') ADVANCE(216);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 's') ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 's') ADVANCE(323);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 's') ADVANCE(342);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 's') ADVANCE(383);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == 's') ADVANCE(343);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(288);
      if ((0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(389);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(389);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'a') ADVANCE(193);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'd') ADVANCE(118);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'e') ADVANCE(191);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'e') ADVANCE(189);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'm') ADVANCE(396);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'n') ADVANCE(391);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'p') ADVANCE(184);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'r') ADVANCE(122);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'r') ADVANCE(112);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 's') ADVANCE(390);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'u') ADVANCE(398);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym__identifier);
      if (set_contains(sym__identifier_character_set_2, 764, lookahead)) ADVANCE(401);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      ADVANCE_MAP(
        '!', 196,
        '#', 242,
        '$', 124,
        '%', 206,
        '(', 109,
        '*', 173,
        '+', 165,
        '-', 168,
        '.', 410,
        '/', 411,
        '0', 408,
        ':', 412,
        ';', 107,
        '<', 132,
        '@', 128,
        '[', 125,
        '\\', 201,
        '^', 415,
        'a', 353,
        'c', 322,
        'd', 363,
        'e', 356,
        'g', 337,
        'i', 384,
        'l', 330,
        'm', 258,
        'o', 373,
        'p', 364,
        'r', 340,
        's', 259,
        'u', 331,
        '{', 103,
        '}', 104,
        '~', 194,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(409);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(403);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '!') ADVANCE(402);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == '*') ADVANCE(173);
      if (lookahead == ':') ADVANCE(412);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == '{') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(404);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(402);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == ':') ADVANCE(412);
      if (lookahead == '>') ADVANCE(133);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == '{') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(405);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(402);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == ':') ADVANCE(412);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == '{') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(406);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(389);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(402);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '#') ADVANCE(242);
      if (lookahead == '$') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '^') ADVANCE(417);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(407);
      if (set_contains(sym__identifier_character_set_1, 657, lookahead)) ADVANCE(401);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(402);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      ADVANCE_MAP(
        '.', 427,
        '_', 93,
        'B', 89,
        'b', 89,
        'E', 88,
        'e', 88,
        'X', 95,
        'x', 95,
        '8', 413,
        '9', 413,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(414);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '.') ADVANCE(427);
      if (lookahead == '_') ADVANCE(91);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(409);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '.') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(426);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '/') ADVANCE(158);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == ':') ADVANCE(419);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '_') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(413);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '_') ADVANCE(90);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(414);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '?' ||
          lookahead == '^' ||
          lookahead == '|') ADVANCE(402);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(208);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(208);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(416);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(aux_sym__ident_special_token1);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '^' ||
          lookahead == '_' ||
          lookahead == '|') ADVANCE(402);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(aux_sym__bareword_token1);
      if (lookahead == ':') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          (0x300 <= lookahead && lookahead <= 0x36f) ||
          (0x483 <= lookahead && lookahead <= 0x487) ||
          (0x591 <= lookahead && lookahead <= 0x5bd) ||
          lookahead == 0x5bf ||
          lookahead == 0x5c1 ||
          lookahead == 0x5c2 ||
          lookahead == 0x5c4 ||
          lookahead == 0x5c5 ||
          lookahead == 0x5c7 ||
          (0x610 <= lookahead && lookahead <= 0x61a) ||
          (0x64b <= lookahead && lookahead <= 0x669) ||
          lookahead == 0x670 ||
          (0x6d6 <= lookahead && lookahead <= 0x6dc) ||
          (0x6df <= lookahead && lookahead <= 0x6e4) ||
          lookahead == 0x6e7 ||
          lookahead == 0x6e8 ||
          (0x6ea <= lookahead && lookahead <= 0x6ed) ||
          (0x6f0 <= lookahead && lookahead <= 0x6f9) ||
          lookahead == 0x711 ||
          (0x730 <= lookahead && lookahead <= 0x74a) ||
          (0x7a6 <= lookahead && lookahead <= 0x7b0) ||
          (0x7c0 <= lookahead && lookahead <= 0x7c9) ||
          (0x7eb <= lookahead && lookahead <= 0x7f3) ||
          lookahead == 0x7fd ||
          (0x816 <= lookahead && lookahead <= 0x819) ||
          (0x81b <= lookahead && lookahead <= 0x823) ||
          (0x825 <= lookahead && lookahead <= 0x827) ||
          (0x829 <= lookahead && lookahead <= 0x82d) ||
          (0x859 <= lookahead && lookahead <= 0x85b) ||
          (0x898 <= lookahead && lookahead <= 0x89f) ||
          (0x8ca <= lookahead && lookahead <= 0x8e1) ||
          (0x8e3 <= lookahead && lookahead <= 0x903) ||
          (0x93a <= lookahead && lookahead <= 0x93c) ||
          (0x93e <= lookahead && lookahead <= 0x94f) ||
          (0x951 <= lookahead && lookahead <= 0x957) ||
          lookahead == 0x962 ||
          lookahead == 0x963 ||
          (0x966 <= lookahead && lookahead <= 0x96f) ||
          (0x981 <= lookahead && lookahead <= 0x983) ||
          lookahead == 0x9bc ||
          (0x9be <= lookahead && lookahead <= 0x9c4) ||
          lookahead == 0x9c7 ||
          lookahead == 0x9c8 ||
          (0x9cb <= lookahead && lookahead <= 0x9cd) ||
          lookahead == 0x9d7 ||
          lookahead == 0x9e2 ||
          lookahead == 0x9e3 ||
          (0x9e6 <= lookahead && lookahead <= 0x9ef) ||
          lookahead == 0x9fe ||
          (0xa01 <= lookahead && lookahead <= 0xa03) ||
          lookahead == 0xa3c ||
          (0xa3e <= lookahead && lookahead <= 0xa42) ||
          lookahead == 0xa47 ||
          lookahead == 0xa48 ||
          (0xa4b <= lookahead && lookahead <= 0xa4d) ||
          lookahead == 0xa51 ||
          (0xa66 <= lookahead && lookahead <= 0xa71) ||
          lookahead == 0xa75 ||
          (0xa81 <= lookahead && lookahead <= 0xa83) ||
          lookahead == 0xabc ||
          (0xabe <= lookahead && lookahead <= 0xac5) ||
          (0xac7 <= lookahead && lookahead <= 0xac9) ||
          (0xacb <= lookahead && lookahead <= 0xacd) ||
          lookahead == 0xae2 ||
          lookahead == 0xae3 ||
          (0xae6 <= lookahead && lookahead <= 0xaef) ||
          (0xafa <= lookahead && lookahead <= 0xaff) ||
          (0xb01 <= lookahead && lookahead <= 0xb03) ||
          lookahead == 0xb3c ||
          (0xb3e <= lookahead && lookahead <= 0xb44) ||
          lookahead == 0xb47 ||
          lookahead == 0xb48 ||
          (0xb4b <= lookahead && lookahead <= 0xb4d) ||
          (0xb55 <= lookahead && lookahead <= 0xb57) ||
          lookahead == 0xb62 ||
          lookahead == 0xb63 ||
          (0xb66 <= lookahead && lookahead <= 0xb6f) ||
          lookahead == 0xb82 ||
          (0xbbe <= lookahead && lookahead <= 0xbc2) ||
          (0xbc6 <= lookahead && lookahead <= 0xbc8) ||
          (0xbca <= lookahead && lookahead <= 0xbcd) ||
          lookahead == 0xbd7 ||
          (0xbe6 <= lookahead && lookahead <= 0xbef) ||
          (0xc00 <= lookahead && lookahead <= 0xc04) ||
          lookahead == 0xc3c ||
          (0xc3e <= lookahead && lookahead <= 0xc44) ||
          (0xc46 <= lookahead && lookahead <= 0xc48) ||
          (0xc4a <= lookahead && lookahead <= 0xc4d) ||
          lookahead == 0xc55 ||
          lookahead == 0xc56 ||
          lookahead == 0xc62 ||
          lookahead == 0xc63 ||
          (0xc66 <= lookahead && lookahead <= 0xc6f) ||
          (0xc81 <= lookahead && lookahead <= 0xc83) ||
          lookahead == 0xcbc ||
          (0xcbe <= lookahead && lookahead <= 0xcc4) ||
          (0xcc6 <= lookahead && lookahead <= 0xcc8) ||
          (0xcca <= lookahead && lookahead <= 0xccd) ||
          lookahead == 0xcd5 ||
          lookahead == 0xcd6 ||
          lookahead == 0xce2 ||
          lookahead == 0xce3 ||
          (0xce6 <= lookahead && lookahead <= 0xcef) ||
          (0xd00 <= lookahead && lookahead <= 0xd03) ||
          lookahead == 0xd3b ||
          lookahead == 0xd3c ||
          (0xd3e <= lookahead && lookahead <= 0xd44) ||
          (0xd46 <= lookahead && lookahead <= 0xd48) ||
          (0xd4a <= lookahead && lookahead <= 0xd4d) ||
          lookahead == 0xd57 ||
          lookahead == 0xd62 ||
          lookahead == 0xd63 ||
          (0xd66 <= lookahead && lookahead <= 0xd6f) ||
          (0xd81 <= lookahead && lookahead <= 0xd83) ||
          lookahead == 0xdca ||
          (0xdcf <= lookahead && lookahead <= 0xdd4) ||
          lookahead == 0xdd6 ||
          (0xdd8 <= lookahead && lookahead <= 0xddf) ||
          (0xde6 <= lookahead && lookahead <= 0xdef) ||
          lookahead == 0xdf2 ||
          lookahead == 0xdf3 ||
          lookahead == 0xe31 ||
          (0xe33 <= lookahead && lookahead <= 0xe3a) ||
          (0xe47 <= lookahead && lookahead <= 0xe4e) ||
          (0xe50 <= lookahead && lookahead <= 0xe59) ||
          lookahead == 0xeb1 ||
          (0xeb3 <= lookahead && lookahead <= 0xebc) ||
          (0xec8 <= lookahead && lookahead <= 0xecd) ||
          (0xed0 <= lookahead && lookahead <= 0xed9) ||
          lookahead == 0xf18 ||
          lookahead == 0xf19 ||
          (0xf20 <= lookahead && lookahead <= 0xf29) ||
          lookahead == 0xf35 ||
          lookahead == 0xf37 ||
          lookahead == 0xf39 ||
          lookahead == 0xf3e ||
          lookahead == 0xf3f ||
          (0xf71 <= lookahead && lookahead <= 0xf84) ||
          lookahead == 0xf86 ||
          lookahead == 0xf87 ||
          (0xf8d <= lookahead && lookahead <= 0xf97) ||
          (0xf99 <= lookahead && lookahead <= 0xfbc) ||
          lookahead == 0xfc6 ||
          (0x102b <= lookahead && lookahead <= 0x103e) ||
          (0x1040 <= lookahead && lookahead <= 0x1049) ||
          (0x1056 <= lookahead && lookahead <= 0x1059) ||
          (0x105e <= lookahead && lookahead <= 0x1060) ||
          (0x1062 <= lookahead && lookahead <= 0x1064) ||
          (0x1067 <= lookahead && lookahead <= 0x106d) ||
          (0x1071 <= lookahead && lookahead <= 0x1074) ||
          (0x1082 <= lookahead && lookahead <= 0x108d) ||
          (0x108f <= lookahead && lookahead <= 0x109d) ||
          (0x135d <= lookahead && lookahead <= 0x135f) ||
          lookahead == 0x1371 ||
          (0x1712 <= lookahead && lookahead <= 0x1715) ||
          (0x1732 <= lookahead && lookahead <= 0x1734) ||
          lookahead == 0x1752 ||
          lookahead == 0x1753 ||
          lookahead == 0x1772 ||
          lookahead == 0x1773 ||
          (0x17b4 <= lookahead && lookahead <= 0x17d3) ||
          lookahead == 0x17dd ||
          (0x17e0 <= lookahead && lookahead <= 0x17e9) ||
          (0x180b <= lookahead && lookahead <= 0x180d) ||
          (0x180f <= lookahead && lookahead <= 0x1819) ||
          lookahead == 0x18a9 ||
          (0x1920 <= lookahead && lookahead <= 0x192b) ||
          (0x1930 <= lookahead && lookahead <= 0x193b) ||
          (0x1946 <= lookahead && lookahead <= 0x194f) ||
          (0x19d0 <= lookahead && lookahead <= 0x19d9) ||
          (0x1a17 <= lookahead && lookahead <= 0x1a1b) ||
          (0x1a55 <= lookahead && lookahead <= 0x1a5e) ||
          (0x1a60 <= lookahead && lookahead <= 0x1a7c) ||
          (0x1a7f <= lookahead && lookahead <= 0x1a89) ||
          (0x1a90 <= lookahead && lookahead <= 0x1a99) ||
          (0x1ab0 <= lookahead && lookahead <= 0x1abd) ||
          (0x1abf <= lookahead && lookahead <= 0x1ace) ||
          (0x1b00 <= lookahead && lookahead <= 0x1b04) ||
          (0x1b34 <= lookahead && lookahead <= 0x1b44) ||
          (0x1b50 <= lookahead && lookahead <= 0x1b59) ||
          (0x1b6b <= lookahead && lookahead <= 0x1b73) ||
          (0x1b80 <= lookahead && lookahead <= 0x1b82) ||
          (0x1ba1 <= lookahead && lookahead <= 0x1bad) ||
          (0x1bb0 <= lookahead && lookahead <= 0x1bb9) ||
          (0x1be6 <= lookahead && lookahead <= 0x1bf3) ||
          (0x1c24 <= lookahead && lookahead <= 0x1c37) ||
          (0x1c40 <= lookahead && lookahead <= 0x1c49) ||
          (0x1c50 <= lookahead && lookahead <= 0x1c59) ||
          (0x1cd0 <= lookahead && lookahead <= 0x1cd2) ||
          (0x1cd4 <= lookahead && lookahead <= 0x1ce8) ||
          lookahead == 0x1ced ||
          lookahead == 0x1cf4 ||
          (0x1cf7 <= lookahead && lookahead <= 0x1cf9) ||
          (0x1dc0 <= lookahead && lookahead <= 0x1dff) ||
          lookahead == 0x203f ||
          lookahead == 0x2040 ||
          lookahead == 0x2054 ||
          (0x20d0 <= lookahead && lookahead <= 0x20dc) ||
          lookahead == 0x20e1 ||
          (0x20e5 <= lookahead && lookahead <= 0x20f0) ||
          (0x2cef <= lookahead && lookahead <= 0x2cf1) ||
          lookahead == 0x2d7f ||
          (0x2de0 <= lookahead && lookahead <= 0x2dff) ||
          (0x302a <= lookahead && lookahead <= 0x302f) ||
          lookahead == 0x3099 ||
          lookahead == 0x309a ||
          (0xa620 <= lookahead && lookahead <= 0xa629) ||
          lookahead == 0xa66f ||
          (0xa674 <= lookahead && lookahead <= 0xa67d) ||
          lookahead == 0xa69e ||
          lookahead == 0xa69f ||
          lookahead == 0xa6f0 ||
          lookahead == 0xa6f1 ||
          lookahead == 0xa802 ||
          lookahead == 0xa806 ||
          lookahead == 0xa80b ||
          (0xa823 <= lookahead && lookahead <= 0xa827) ||
          lookahead == 0xa82c ||
          lookahead == 0xa880 ||
          lookahead == 0xa881 ||
          (0xa8b4 <= lookahead && lookahead <= 0xa8c5) ||
          (0xa8d0 <= lookahead && lookahead <= 0xa8d9) ||
          (0xa8e0 <= lookahead && lookahead <= 0xa8f1) ||
          (0xa8ff <= lookahead && lookahead <= 0xa909) ||
          (0xa926 <= lookahead && lookahead <= 0xa92d) ||
          (0xa947 <= lookahead && lookahead <= 0xa953) ||
          (0xa980 <= lookahead && lookahead <= 0xa983) ||
          (0xa9b3 <= lookahead && lookahead <= 0xa9c0) ||
          (0xa9d0 <= lookahead && lookahead <= 0xa9d9) ||
          lookahead == 0xa9e5 ||
          (0xa9f0 <= lookahead && lookahead <= 0xa9f9) ||
          (0xaa29 <= lookahead && lookahead <= 0xaa36) ||
          lookahead == 0xaa43 ||
          lookahead == 0xaa4c ||
          lookahead == 0xaa4d ||
          (0xaa50 <= lookahead && lookahead <= 0xaa59) ||
          (0xaa7b <= lookahead && lookahead <= 0xaa7d) ||
          lookahead == 0xaab0 ||
          (0xaab2 <= lookahead && lookahead <= 0xaab4) ||
          lookahead == 0xaab7 ||
          lookahead == 0xaab8 ||
          lookahead == 0xaabe ||
          lookahead == 0xaabf ||
          lookahead == 0xaac1 ||
          (0xaaeb <= lookahead && lookahead <= 0xaaef) ||
          lookahead == 0xaaf5 ||
          lookahead == 0xaaf6 ||
          (0xabe3 <= lookahead && lookahead <= 0xabea) ||
          lookahead == 0xabec ||
          lookahead == 0xabed ||
          (0xabf0 <= lookahead && lookahead <= 0xabf9) ||
          lookahead == 0xfb1e ||
          (0xfe00 <= lookahead && lookahead <= 0xfe0f) ||
          (0xfe20 <= lookahead && lookahead <= 0xfe2f) ||
          lookahead == 0xfe33 ||
          lookahead == 0xfe34 ||
          (0xfe4d <= lookahead && lookahead <= 0xfe4f) ||
          (0xff10 <= lookahead && lookahead <= 0xff19) ||
          lookahead == 0xff3f ||
          lookahead == 0xff9e ||
          lookahead == 0xff9f ||
          lookahead == 0x101fd ||
          lookahead == 0x102e0 ||
          (0x10376 <= lookahead && lookahead <= 0x1037a) ||
          (0x104a0 <= lookahead && lookahead <= 0x104a9) ||
          (0x10a01 <= lookahead && lookahead <= 0x10a03) ||
          lookahead == 0x10a05 ||
          lookahead == 0x10a06 ||
          (0x10a0c <= lookahead && lookahead <= 0x10a0f) ||
          (0x10a38 <= lookahead && lookahead <= 0x10a3a) ||
          lookahead == 0x10a3f ||
          lookahead == 0x10ae5 ||
          lookahead == 0x10ae6 ||
          (0x10d24 <= lookahead && lookahead <= 0x10d27) ||
          (0x10d30 <= lookahead && lookahead <= 0x10d39) ||
          lookahead == 0x10eab ||
          lookahead == 0x10eac ||
          (0x10f46 <= lookahead && lookahead <= 0x10f50) ||
          (0x10f82 <= lookahead && lookahead <= 0x10f85) ||
          (0x11000 <= lookahead && lookahead <= 0x11002) ||
          (0x11038 <= lookahead && lookahead <= 0x11046) ||
          (0x11066 <= lookahead && lookahead <= 0x11070) ||
          lookahead == 0x11073 ||
          lookahead == 0x11074 ||
          (0x1107f <= lookahead && lookahead <= 0x11082) ||
          (0x110b0 <= lookahead && lookahead <= 0x110ba) ||
          lookahead == 0x110c2 ||
          (0x110f0 <= lookahead && lookahead <= 0x110f9) ||
          (0x11100 <= lookahead && lookahead <= 0x11102) ||
          (0x11127 <= lookahead && lookahead <= 0x11134) ||
          (0x11136 <= lookahead && lookahead <= 0x1113f) ||
          lookahead == 0x11145 ||
          lookahead == 0x11146 ||
          lookahead == 0x11173 ||
          (0x11180 <= lookahead && lookahead <= 0x11182) ||
          (0x111b3 <= lookahead && lookahead <= 0x111c0) ||
          (0x111c9 <= lookahead && lookahead <= 0x111cc) ||
          (0x111ce <= lookahead && lookahead <= 0x111d9) ||
          (0x1122c <= lookahead && lookahead <= 0x11237) ||
          lookahead == 0x1123e ||
          (0x112df <= lookahead && lookahead <= 0x112ea) ||
          (0x112f0 <= lookahead && lookahead <= 0x112f9) ||
          (0x11300 <= lookahead && lookahead <= 0x11303) ||
          lookahead == 0x1133b ||
          lookahead == 0x1133c ||
          (0x1133e <= lookahead && lookahead <= 0x11344) ||
          lookahead == 0x11347 ||
          lookahead == 0x11348 ||
          (0x1134b <= lookahead && lookahead <= 0x1134d) ||
          lookahead == 0x11357 ||
          lookahead == 0x11362 ||
          lookahead == 0x11363 ||
          (0x11366 <= lookahead && lookahead <= 0x1136c) ||
          (0x11370 <= lookahead && lookahead <= 0x11374) ||
          (0x11435 <= lookahead && lookahead <= 0x11446) ||
          (0x11450 <= lookahead && lookahead <= 0x11459) ||
          lookahead == 0x1145e ||
          (0x114b0 <= lookahead && lookahead <= 0x114c3) ||
          (0x114d0 <= lookahead && lookahead <= 0x114d9) ||
          (0x115af <= lookahead && lookahead <= 0x115b5) ||
          (0x115b8 <= lookahead && lookahead <= 0x115c0) ||
          lookahead == 0x115dc ||
          lookahead == 0x115dd ||
          (0x11630 <= lookahead && lookahead <= 0x11640) ||
          (0x11650 <= lookahead && lookahead <= 0x11659) ||
          (0x116ab <= lookahead && lookahead <= 0x116b7) ||
          (0x116c0 <= lookahead && lookahead <= 0x116c9) ||
          (0x1171d <= lookahead && lookahead <= 0x1172b) ||
          (0x11730 <= lookahead && lookahead <= 0x11739) ||
          (0x1182c <= lookahead && lookahead <= 0x1183a) ||
          (0x118e0 <= lookahead && lookahead <= 0x118e9) ||
          (0x11930 <= lookahead && lookahead <= 0x11935) ||
          lookahead == 0x11937 ||
          lookahead == 0x11938 ||
          (0x1193b <= lookahead && lookahead <= 0x1193e) ||
          lookahead == 0x11940 ||
          lookahead == 0x11942 ||
          lookahead == 0x11943 ||
          (0x11950 <= lookahead && lookahead <= 0x11959) ||
          (0x119d1 <= lookahead && lookahead <= 0x119d7) ||
          (0x119da <= lookahead && lookahead <= 0x119e0) ||
          lookahead == 0x119e4 ||
          (0x11a01 <= lookahead && lookahead <= 0x11a0a) ||
          (0x11a33 <= lookahead && lookahead <= 0x11a39) ||
          (0x11a3b <= lookahead && lookahead <= 0x11a3e) ||
          lookahead == 0x11a47 ||
          (0x11a51 <= lookahead && lookahead <= 0x11a5b) ||
          (0x11a8a <= lookahead && lookahead <= 0x11a99) ||
          (0x11c2f <= lookahead && lookahead <= 0x11c36) ||
          (0x11c38 <= lookahead && lookahead <= 0x11c3f) ||
          (0x11c50 <= lookahead && lookahead <= 0x11c59) ||
          (0x11c92 <= lookahead && lookahead <= 0x11ca7) ||
          (0x11ca9 <= lookahead && lookahead <= 0x11cb6) ||
          (0x11d31 <= lookahead && lookahead <= 0x11d36) ||
          lookahead == 0x11d3a ||
          lookahead == 0x11d3c ||
          lookahead == 0x11d3d ||
          (0x11d3f <= lookahead && lookahead <= 0x11d45) ||
          lookahead == 0x11d47 ||
          (0x11d50 <= lookahead && lookahead <= 0x11d59) ||
          (0x11d8a <= lookahead && lookahead <= 0x11d8e) ||
          lookahead == 0x11d90 ||
          lookahead == 0x11d91 ||
          (0x11d93 <= lookahead && lookahead <= 0x11d97) ||
          (0x11da0 <= lookahead && lookahead <= 0x11da9) ||
          (0x11ef3 <= lookahead && lookahead <= 0x11ef6) ||
          (0x16a60 <= lookahead && lookahead <= 0x16a69) ||
          (0x16ac0 <= lookahead && lookahead <= 0x16ac9) ||
          (0x16af0 <= lookahead && lookahead <= 0x16af4) ||
          (0x16b30 <= lookahead && lookahead <= 0x16b36) ||
          (0x16b50 <= lookahead && lookahead <= 0x16b59) ||
          lookahead == 0x16f4f ||
          (0x16f51 <= lookahead && lookahead <= 0x16f87) ||
          (0x16f8f <= lookahead && lookahead <= 0x16f92) ||
          lookahead == 0x16fe4 ||
          lookahead == 0x16ff0 ||
          lookahead == 0x16ff1 ||
          lookahead == 0x1bc9d ||
          lookahead == 0x1bc9e ||
          (0x1cf00 <= lookahead && lookahead <= 0x1cf2d) ||
          (0x1cf30 <= lookahead && lookahead <= 0x1cf46) ||
          (0x1d165 <= lookahead && lookahead <= 0x1d169) ||
          (0x1d16d <= lookahead && lookahead <= 0x1d172) ||
          (0x1d17b <= lookahead && lookahead <= 0x1d182) ||
          (0x1d185 <= lookahead && lookahead <= 0x1d18b) ||
          (0x1d1aa <= lookahead && lookahead <= 0x1d1ad) ||
          (0x1d242 <= lookahead && lookahead <= 0x1d244) ||
          (0x1d7ce <= lookahead && lookahead <= 0x1d7ff) ||
          (0x1da00 <= lookahead && lookahead <= 0x1da36) ||
          (0x1da3b <= lookahead && lookahead <= 0x1da6c) ||
          lookahead == 0x1da75 ||
          lookahead == 0x1da84 ||
          (0x1da9b <= lookahead && lookahead <= 0x1da9f) ||
          (0x1daa1 <= lookahead && lookahead <= 0x1daaf) ||
          (0x1e000 <= lookahead && lookahead <= 0x1e006) ||
          (0x1e008 <= lookahead && lookahead <= 0x1e018) ||
          (0x1e01b <= lookahead && lookahead <= 0x1e021) ||
          lookahead == 0x1e023 ||
          lookahead == 0x1e024 ||
          (0x1e026 <= lookahead && lookahead <= 0x1e02a) ||
          (0x1e130 <= lookahead && lookahead <= 0x1e136) ||
          (0x1e140 <= lookahead && lookahead <= 0x1e149) ||
          lookahead == 0x1e2ae ||
          (0x1e2ec <= lookahead && lookahead <= 0x1e2f9) ||
          (0x1e8d0 <= lookahead && lookahead <= 0x1e8d6) ||
          (0x1e944 <= lookahead && lookahead <= 0x1e94a) ||
          (0x1e950 <= lookahead && lookahead <= 0x1e959) ||
          (0x1fbf0 <= lookahead && lookahead <= 0x1fbf9) ||
          (0xe0100 <= lookahead && lookahead <= 0xe01ef)) ADVANCE(418);
      if (set_contains(aux_sym__bareword_token1_character_set_2, 764, lookahead)) ADVANCE(418);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(aux_sym__bareword_token1);
      if (lookahead == ':') ADVANCE(75);
      if (set_contains(aux_sym__bareword_token1_character_set_1, 658, lookahead)) ADVANCE(418);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_number);
      ADVANCE_MAP(
        '.', 427,
        '_', 93,
        'B', 89,
        'b', 89,
        'E', 88,
        'e', 88,
        'X', 95,
        'x', 95,
        '8', 422,
        '9', 422,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(425);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(427);
      if (lookahead == '_') ADVANCE(91);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(421);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(422);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(89);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(423);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(424);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(90);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(422);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(425);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(92);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(426);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(426);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'B') ADVANCE(2);
      if (lookahead == 'C') ADVANCE(3);
      if (lookahead == 'E') ADVANCE(4);
      if (lookahead == 'I') ADVANCE(5);
      if (lookahead == 'U') ADVANCE(6);
      if (lookahead == '\\') SKIP(7);
      if (lookahead == '_') ADVANCE(8);
      if (lookahead == 'a') ADVANCE(9);
      if (lookahead == 'b') ADVANCE(10);
      if (lookahead == 'c') ADVANCE(11);
      if (lookahead == 'd') ADVANCE(12);
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'f') ADVANCE(14);
      if (lookahead == 'g') ADVANCE(15);
      if (lookahead == 'h') ADVANCE(16);
      if (lookahead == 'i') ADVANCE(17);
      if (lookahead == 'k') ADVANCE(18);
      if (lookahead == 'l') ADVANCE(19);
      if (lookahead == 'm') ADVANCE(20);
      if (lookahead == 'n') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      if (lookahead == 'p') ADVANCE(23);
      if (lookahead == 'q') ADVANCE(24);
      if (lookahead == 'r') ADVANCE(25);
      if (lookahead == 's') ADVANCE(26);
      if (lookahead == 't') ADVANCE(27);
      if (lookahead == 'u') ADVANCE(28);
      if (lookahead == 'v') ADVANCE(29);
      if (lookahead == 'w') ADVANCE(30);
      if (lookahead == 'y') ADVANCE(31);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'D') ADVANCE(32);
      END_STATE();
    case 2:
      if (lookahead == 'E') ADVANCE(33);
      END_STATE();
    case 3:
      if (lookahead == 'H') ADVANCE(34);
      END_STATE();
    case 4:
      if (lookahead == 'N') ADVANCE(35);
      END_STATE();
    case 5:
      if (lookahead == 'N') ADVANCE(36);
      END_STATE();
    case 6:
      if (lookahead == 'N') ADVANCE(37);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(38);
      END_STATE();
    case 8:
      if (lookahead == '_') ADVANCE(39);
      END_STATE();
    case 9:
      if (lookahead == 'b') ADVANCE(40);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(41);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(42);
      if (lookahead == 'h') ADVANCE(43);
      if (lookahead == 'o') ADVANCE(44);
      END_STATE();
    case 12:
      if (lookahead == 'b') ADVANCE(45);
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'l') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      if (lookahead == 'q') ADVANCE(50);
      if (lookahead == 'v') ADVANCE(51);
      if (lookahead == 'x') ADVANCE(52);
      END_STATE();
    case 14:
      if (lookahead == 'c') ADVANCE(53);
      if (lookahead == 'i') ADVANCE(54);
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      if (lookahead == 'm') ADVANCE(57);
      if (lookahead == 'o') ADVANCE(58);
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 17:
      if (lookahead == 'f') ADVANCE(61);
      if (lookahead == 'n') ADVANCE(62);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'c') ADVANCE(65);
      if (lookahead == 'e') ADVANCE(66);
      if (lookahead == 'o') ADVANCE(67);
      if (lookahead == 's') ADVANCE(68);
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(70);
      if (lookahead == 'y') ADVANCE(71);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(72);
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 22:
      if (lookahead == 'c') ADVANCE(74);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(76);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_q);
      if (lookahead == 'q') ADVANCE(77);
      if (lookahead == 'r') ADVANCE(78);
      if (lookahead == 'u') ADVANCE(79);
      if (lookahead == 'w') ADVANCE(80);
      if (lookahead == 'x') ADVANCE(81);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(82);
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 26:
      if (lookahead == 'h') ADVANCE(84);
      if (lookahead == 'o') ADVANCE(85);
      if (lookahead == 'q') ADVANCE(86);
      if (lookahead == 'r') ADVANCE(87);
      if (lookahead == 't') ADVANCE(88);
      if (lookahead == 'u') ADVANCE(89);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(90);
      if (lookahead == 'i') ADVANCE(91);
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 28:
      if (lookahead == 'c') ADVANCE(93);
      if (lookahead == 'm') ADVANCE(94);
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(96);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(97);
      if (lookahead == 'h') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(99);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_y);
      END_STATE();
    case 32:
      if (lookahead == 'J') ADVANCE(100);
      END_STATE();
    case 33:
      if (lookahead == 'G') ADVANCE(101);
      END_STATE();
    case 34:
      if (lookahead == 'E') ADVANCE(102);
      END_STATE();
    case 35:
      if (lookahead == 'D') ADVANCE(103);
      END_STATE();
    case 36:
      if (lookahead == 'I') ADVANCE(104);
      END_STATE();
    case 37:
      if (lookahead == 'I') ADVANCE(105);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 39:
      if (lookahead == 'D') ADVANCE(106);
      if (lookahead == 'E') ADVANCE(107);
      if (lookahead == 'F') ADVANCE(108);
      if (lookahead == 'L') ADVANCE(109);
      if (lookahead == 'P') ADVANCE(110);
      if (lookahead == 'S') ADVANCE(111);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(112);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 43:
      if (lookahead == 'd') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(116);
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 44:
      if (lookahead == 'n') ADVANCE(118);
      END_STATE();
    case 45:
      if (lookahead == 'm') ADVANCE(119);
      END_STATE();
    case 46:
      if (lookahead == 'f') ADVANCE(120);
      if (lookahead == 'l') ADVANCE(121);
      END_STATE();
    case 47:
      if (lookahead == 'c') ADVANCE(122);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(123);
      END_STATE();
    case 49:
      if (lookahead == 'f') ADVANCE(124);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 51:
      if (lookahead == 'a') ADVANCE(125);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_fc);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(127);
      if (lookahead == 'l') ADVANCE(128);
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_gt);
      END_STATE();
    case 60:
      if (lookahead == 'x') ADVANCE(134);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 62:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 63:
      if (lookahead == 'y') ADVANCE(136);
      END_STATE();
    case 64:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 65:
      if (lookahead == 'f') ADVANCE(138);
      END_STATE();
    case 66:
      if (lookahead == 'n') ADVANCE(139);
      END_STATE();
    case 67:
      if (lookahead == 'c') ADVANCE(140);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_lt);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_my);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_ne);
      if (lookahead == 'x') ADVANCE(143);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_no);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 75:
      if (lookahead == 'c') ADVANCE(145);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_qq);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_qr);
      END_STATE();
    case 79:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_qw);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_qx);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(149);
      if (lookahead == 'f') ADVANCE(150);
      if (lookahead == 'q') ADVANCE(151);
      if (lookahead == 's') ADVANCE(152);
      if (lookahead == 't') ADVANCE(153);
      if (lookahead == 'w') ADVANCE(154);
      END_STATE();
    case 84:
      if (lookahead == 'i') ADVANCE(155);
      END_STATE();
    case 85:
      if (lookahead == 'r') ADVANCE(156);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(157);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(158);
      END_STATE();
    case 88:
      if (lookahead == 'a') ADVANCE(159);
      if (lookahead == 'u') ADVANCE(160);
      END_STATE();
    case 89:
      if (lookahead == 'b') ADVANCE(161);
      END_STATE();
    case 90:
      if (lookahead == 'l') ADVANCE(162);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(163);
      if (lookahead == 'm') ADVANCE(164);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_tr);
      if (lookahead == 'y') ADVANCE(165);
      END_STATE();
    case 93:
      if (lookahead == 'f') ADVANCE(166);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(167);
      END_STATE();
    case 95:
      if (lookahead == 'd') ADVANCE(168);
      if (lookahead == 'l') ADVANCE(169);
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(171);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(172);
      if (lookahead == 'n') ADVANCE(173);
      END_STATE();
    case 98:
      if (lookahead == 'i') ADVANCE(174);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(175);
      END_STATE();
    case 100:
      if (lookahead == 'U') ADVANCE(176);
      END_STATE();
    case 101:
      if (lookahead == 'I') ADVANCE(177);
      END_STATE();
    case 102:
      if (lookahead == 'C') ADVANCE(178);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_END);
      END_STATE();
    case 104:
      if (lookahead == 'T') ADVANCE(179);
      END_STATE();
    case 105:
      if (lookahead == 'T') ADVANCE(180);
      END_STATE();
    case 106:
      if (lookahead == 'A') ADVANCE(181);
      END_STATE();
    case 107:
      if (lookahead == 'N') ADVANCE(182);
      END_STATE();
    case 108:
      if (lookahead == 'I') ADVANCE(183);
      END_STATE();
    case 109:
      if (lookahead == 'I') ADVANCE(184);
      END_STATE();
    case 110:
      if (lookahead == 'A') ADVANCE(185);
      END_STATE();
    case 111:
      if (lookahead == 'U') ADVANCE(186);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_abs);
      END_STATE();
    case 113:
      if (lookahead == 'a') ADVANCE(187);
      END_STATE();
    case 114:
      if (lookahead == 'c') ADVANCE(188);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 116:
      if (lookahead == 'm') ADVANCE(190);
      if (lookahead == 'p') ADVANCE(191);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_chr);
      if (lookahead == 'o') ADVANCE(192);
      END_STATE();
    case 118:
      if (lookahead == 't') ADVANCE(193);
      END_STATE();
    case 119:
      if (lookahead == 'c') ADVANCE(194);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(195);
      if (lookahead == 'i') ADVANCE(196);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 122:
      if (lookahead == 'h') ADVANCE(198);
      END_STATE();
    case 123:
      if (lookahead == 'i') ADVANCE(199);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_eof);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 126:
      if (lookahead == 's') ADVANCE(201);
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 127:
      if (lookahead == 'l') ADVANCE(203);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 129:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(206);
      if (lookahead == 'k') ADVANCE(207);
      END_STATE();
    case 131:
      if (lookahead == 'c') ADVANCE(208);
      if (lookahead == 'g') ADVANCE(209);
      if (lookahead == 'n') ADVANCE(210);
      if (lookahead == 'p') ADVANCE(211);
      if (lookahead == 's') ADVANCE(212);
      END_STATE();
    case 132:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 133:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_hex);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 136:
      if (lookahead == 's') ADVANCE(215);
      END_STATE();
    case 137:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 138:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 139:
      if (lookahead == 'g') ADVANCE(218);
      END_STATE();
    case 140:
      if (lookahead == 'a') ADVANCE(219);
      if (lookahead == 'k') ADVANCE(220);
      END_STATE();
    case 141:
      if (lookahead == 'a') ADVANCE(221);
      END_STATE();
    case 142:
      if (lookahead == 'h') ADVANCE(222);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(223);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_oct);
      END_STATE();
    case 145:
      if (lookahead == 'k') ADVANCE(224);
      END_STATE();
    case 146:
      if (lookahead == 't') ADVANCE(225);
      END_STATE();
    case 147:
      if (lookahead == 't') ADVANCE(226);
      END_STATE();
    case 148:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 149:
      if (lookahead == 'd') ADVANCE(228);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 151:
      if (lookahead == 'u') ADVANCE(229);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 153:
      if (lookahead == 'u') ADVANCE(231);
      END_STATE();
    case 154:
      if (lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 155:
      if (lookahead == 'f') ADVANCE(233);
      END_STATE();
    case 156:
      if (lookahead == 't') ADVANCE(234);
      END_STATE();
    case 157:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 158:
      if (lookahead == 'n') ADVANCE(236);
      END_STATE();
    case 159:
      if (lookahead == 't') ADVANCE(237);
      END_STATE();
    case 160:
      if (lookahead == 'd') ADVANCE(238);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_sub);
      END_STATE();
    case 162:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 163:
      if (lookahead == 'd') ADVANCE(240);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 166:
      if (lookahead == 'i') ADVANCE(242);
      END_STATE();
    case 167:
      if (lookahead == 's') ADVANCE(243);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 169:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 170:
      if (lookahead == 'i') ADVANCE(246);
      END_STATE();
    case 171:
      if (lookahead == 'u') ADVANCE(247);
      END_STATE();
    case 172:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 173:
      if (lookahead == 't') ADVANCE(249);
      END_STATE();
    case 174:
      if (lookahead == 'l') ADVANCE(250);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(251);
      END_STATE();
    case 176:
      if (lookahead == 'S') ADVANCE(252);
      END_STATE();
    case 177:
      if (lookahead == 'N') ADVANCE(253);
      END_STATE();
    case 178:
      if (lookahead == 'K') ADVANCE(254);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_INIT);
      END_STATE();
    case 180:
      if (lookahead == 'C') ADVANCE(255);
      END_STATE();
    case 181:
      if (lookahead == 'T') ADVANCE(256);
      END_STATE();
    case 182:
      if (lookahead == 'D') ADVANCE(257);
      END_STATE();
    case 183:
      if (lookahead == 'L') ADVANCE(258);
      END_STATE();
    case 184:
      if (lookahead == 'N') ADVANCE(259);
      END_STATE();
    case 185:
      if (lookahead == 'C') ADVANCE(260);
      END_STATE();
    case 186:
      if (lookahead == 'B') ADVANCE(261);
      END_STATE();
    case 187:
      if (lookahead == 'k') ADVANCE(262);
      END_STATE();
    case 188:
      if (lookahead == 'h') ADVANCE(263);
      END_STATE();
    case 189:
      if (lookahead == 'r') ADVANCE(264);
      END_STATE();
    case 190:
      if (lookahead == 'p') ADVANCE(265);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_chop);
      END_STATE();
    case 192:
      if (lookahead == 'o') ADVANCE(266);
      END_STATE();
    case 193:
      if (lookahead == 'i') ADVANCE(267);
      END_STATE();
    case 194:
      if (lookahead == 'l') ADVANCE(268);
      END_STATE();
    case 195:
      if (lookahead == 'r') ADVANCE(269);
      END_STATE();
    case 196:
      if (lookahead == 'n') ADVANCE(270);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_each);
      END_STATE();
    case 199:
      if (lookahead == 'f') ADVANCE(272);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_eval);
      END_STATE();
    case 201:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_exit);
      END_STATE();
    case 203:
      if (lookahead == 'd') ADVANCE(274);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(275);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(276);
      END_STATE();
    case 206:
      if (lookahead == 'a') ADVANCE(277);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_fork);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_getc);
      END_STATE();
    case 209:
      if (lookahead == 'r') ADVANCE(278);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(280);
      if (lookahead == 'g') ADVANCE(281);
      if (lookahead == 'p') ADVANCE(282);
      if (lookahead == 'r') ADVANCE(283);
      if (lookahead == 'w') ADVANCE(284);
      END_STATE();
    case 212:
      if (lookahead == 'o') ADVANCE(285);
      END_STATE();
    case 213:
      if (lookahead == 'm') ADVANCE(286);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_keys);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_last);
      END_STATE();
    case 217:
      if (lookahead == 'r') ADVANCE(287);
      END_STATE();
    case 218:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 219:
      if (lookahead == 'l') ADVANCE(289);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_lock);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(290);
      END_STATE();
    case 222:
      if (lookahead == 'o') ADVANCE(291);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 224:
      if (lookahead == 'a') ADVANCE(292);
      END_STATE();
    case 225:
      if (lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 226:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_rand);
      END_STATE();
    case 228:
      if (lookahead == 'l') ADVANCE(295);
      END_STATE();
    case 229:
      if (lookahead == 'i') ADVANCE(296);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 231:
      if (lookahead == 'r') ADVANCE(298);
      END_STATE();
    case 232:
      if (lookahead == 'n') ADVANCE(299);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_sort);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_sqrt);
      END_STATE();
    case 236:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_stat);
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 238:
      if (lookahead == 'y') ADVANCE(303);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_tell);
      if (lookahead == 'd') ADVANCE(304);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_tied);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_time);
      if (lookahead == 's') ADVANCE(305);
      END_STATE();
    case 242:
      if (lookahead == 'r') ADVANCE(306);
      END_STATE();
    case 243:
      if (lookahead == 'k') ADVANCE(307);
      END_STATE();
    case 244:
      if (lookahead == 'f') ADVANCE(308);
      END_STATE();
    case 245:
      if (lookahead == 's') ADVANCE(309);
      END_STATE();
    case 246:
      if (lookahead == 'e') ADVANCE(310);
      if (lookahead == 'l') ADVANCE(311);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_wait);
      END_STATE();
    case 249:
      if (lookahead == 'a') ADVANCE(313);
      END_STATE();
    case 250:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(315);
      END_STATE();
    case 252:
      if (lookahead == 'T') ADVANCE(316);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_CHECK);
      END_STATE();
    case 255:
      if (lookahead == 'H') ADVANCE(317);
      END_STATE();
    case 256:
      if (lookahead == 'A') ADVANCE(318);
      END_STATE();
    case 257:
      if (lookahead == '_') ADVANCE(319);
      END_STATE();
    case 258:
      if (lookahead == 'E') ADVANCE(320);
      END_STATE();
    case 259:
      if (lookahead == 'E') ADVANCE(321);
      END_STATE();
    case 260:
      if (lookahead == 'K') ADVANCE(322);
      END_STATE();
    case 261:
      if (lookahead == '_') ADVANCE(323);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_chdir);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_chomp);
      END_STATE();
    case 266:
      if (lookahead == 't') ADVANCE(324);
      END_STATE();
    case 267:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 268:
      if (lookahead == 'o') ADVANCE(326);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 271:
      if (lookahead == 'e') ADVANCE(328);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 273:
      if (lookahead == 's') ADVANCE(329);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 275:
      if (lookahead == 'o') ADVANCE(330);
      END_STATE();
    case 276:
      if (lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 277:
      if (lookahead == 'c') ADVANCE(332);
      END_STATE();
    case 278:
      if (lookahead == 'g') ADVANCE(333);
      if (lookahead == 'n') ADVANCE(334);
      END_STATE();
    case 279:
      if (lookahead == 't') ADVANCE(335);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 281:
      if (lookahead == 'r') ADVANCE(337);
      END_STATE();
    case 282:
      if (lookahead == 'i') ADVANCE(338);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(339);
      END_STATE();
    case 284:
      if (lookahead == 'n') ADVANCE(340);
      if (lookahead == 'u') ADVANCE(341);
      END_STATE();
    case 285:
      if (lookahead == 'c') ADVANCE(342);
      END_STATE();
    case 286:
      if (lookahead == 'e') ADVANCE(343);
      END_STATE();
    case 287:
      if (lookahead == 's') ADVANCE(344);
      END_STATE();
    case 288:
      if (lookahead == 'h') ADVANCE(345);
      END_STATE();
    case 289:
      if (lookahead == 't') ADVANCE(346);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_lstat);
      END_STATE();
    case 291:
      if (lookahead == 'd') ADVANCE(347);
      END_STATE();
    case 292:
      if (lookahead == 'g') ADVANCE(348);
      END_STATE();
    case 293:
      if (lookahead == 't') ADVANCE(349);
      END_STATE();
    case 294:
      if (lookahead == 'm') ADVANCE(350);
      END_STATE();
    case 295:
      if (lookahead == 'i') ADVANCE(351);
      END_STATE();
    case 296:
      if (lookahead == 'r') ADVANCE(352);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_reset);
      END_STATE();
    case 298:
      if (lookahead == 'n') ADVANCE(353);
      END_STATE();
    case 299:
      if (lookahead == 'd') ADVANCE(354);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_shift);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_srand);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_state);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_study);
      END_STATE();
    case 304:
      if (lookahead == 'i') ADVANCE(355);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_times);
      END_STATE();
    case 306:
      if (lookahead == 's') ADVANCE(356);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_umask);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 309:
      if (lookahead == 's') ADVANCE(357);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_untie);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 312:
      if (lookahead == 's') ADVANCE(358);
      END_STATE();
    case 313:
      if (lookahead == 'r') ADVANCE(359);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_write);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_ADJUST);
      END_STATE();
    case 317:
      if (lookahead == 'E') ADVANCE(360);
      END_STATE();
    case 318:
      if (lookahead == '_') ADVANCE(361);
      END_STATE();
    case 319:
      if (lookahead == '_') ADVANCE(362);
      END_STATE();
    case 320:
      if (lookahead == '_') ADVANCE(363);
      END_STATE();
    case 321:
      if (lookahead == '_') ADVANCE(364);
      END_STATE();
    case 322:
      if (lookahead == 'A') ADVANCE(365);
      END_STATE();
    case 323:
      if (lookahead == '_') ADVANCE(366);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_chroot);
      END_STATE();
    case 325:
      if (lookahead == 'u') ADVANCE(367);
      END_STATE();
    case 326:
      if (lookahead == 's') ADVANCE(368);
      END_STATE();
    case 327:
      if (lookahead == 'd') ADVANCE(369);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_exists);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_fileno);
      END_STATE();
    case 331:
      if (lookahead == 'y') ADVANCE(370);
      END_STATE();
    case 332:
      if (lookahead == 'h') ADVANCE(371);
      END_STATE();
    case 333:
      if (lookahead == 'i') ADVANCE(372);
      END_STATE();
    case 334:
      if (lookahead == 'a') ADVANCE(373);
      END_STATE();
    case 335:
      if (lookahead == 'b') ADVANCE(374);
      END_STATE();
    case 336:
      if (lookahead == 'r') ADVANCE(375);
      END_STATE();
    case 337:
      if (lookahead == 'p') ADVANCE(376);
      END_STATE();
    case 338:
      if (lookahead == 'd') ADVANCE(377);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(378);
      END_STATE();
    case 340:
      if (lookahead == 'a') ADVANCE(379);
      END_STATE();
    case 341:
      if (lookahead == 'i') ADVANCE(380);
      END_STATE();
    case 342:
      if (lookahead == 'k') ADVANCE(381);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_gmtime);
      END_STATE();
    case 344:
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_length);
      END_STATE();
    case 346:
      if (lookahead == 'i') ADVANCE(383);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_method);
      END_STATE();
    case 348:
      if (lookahead == 'e') ADVANCE(384);
      END_STATE();
    case 349:
      if (lookahead == 'y') ADVANCE(385);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(386);
      END_STATE();
    case 351:
      if (lookahead == 'n') ADVANCE(387);
      END_STATE();
    case 352:
      if (lookahead == 'e') ADVANCE(388);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 354:
      if (lookahead == 'd') ADVANCE(389);
      END_STATE();
    case 355:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 356:
      if (lookahead == 't') ADVANCE(391);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_values);
      END_STATE();
    case 359:
      if (lookahead == 'r') ADVANCE(392);
      END_STATE();
    case 360:
      if (lookahead == 'C') ADVANCE(393);
      END_STATE();
    case 361:
      if (lookahead == '_') ADVANCE(394);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym___END__);
      END_STATE();
    case 363:
      if (lookahead == '_') ADVANCE(395);
      END_STATE();
    case 364:
      if (lookahead == '_') ADVANCE(396);
      END_STATE();
    case 365:
      if (lookahead == 'G') ADVANCE(397);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym___SUB__);
      END_STATE();
    case 367:
      if (lookahead == 'e') ADVANCE(398);
      END_STATE();
    case 368:
      if (lookahead == 'e') ADVANCE(399);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 372:
      if (lookahead == 'd') ADVANCE(400);
      END_STATE();
    case 373:
      if (lookahead == 'm') ADVANCE(401);
      END_STATE();
    case 374:
      if (lookahead == 'y') ADVANCE(402);
      END_STATE();
    case 375:
      if (lookahead == 'n') ADVANCE(403);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_getpgrp);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_getppid);
      END_STATE();
    case 378:
      if (lookahead == 'o') ADVANCE(404);
      END_STATE();
    case 379:
      if (lookahead == 'm') ADVANCE(405);
      END_STATE();
    case 380:
      if (lookahead == 'd') ADVANCE(406);
      END_STATE();
    case 381:
      if (lookahead == 'n') ADVANCE(407);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_lcfirst);
      END_STATE();
    case 383:
      if (lookahead == 'm') ADVANCE(408);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 385:
      if (lookahead == 'p') ADVANCE(409);
      END_STATE();
    case 386:
      if (lookahead == 't') ADVANCE(410);
      END_STATE();
    case 387:
      if (lookahead == 'e') ADVANCE(411);
      if (lookahead == 'k') ADVANCE(412);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 389:
      if (lookahead == 'i') ADVANCE(413);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_telldir);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_ucfirst);
      END_STATE();
    case 392:
      if (lookahead == 'a') ADVANCE(414);
      END_STATE();
    case 393:
      if (lookahead == 'K') ADVANCE(415);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym___DATA__);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym___FILE__);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym___LINE__);
      END_STATE();
    case 397:
      if (lookahead == 'E') ADVANCE(416);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_dbmclose);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_getgrgid);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_getgrnam);
      END_STATE();
    case 402:
      if (lookahead == 'n') ADVANCE(417);
      END_STATE();
    case 403:
      if (lookahead == 'a') ADVANCE(418);
      END_STATE();
    case 404:
      if (lookahead == 'b') ADVANCE(419);
      END_STATE();
    case 405:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_getpwuid);
      END_STATE();
    case 407:
      if (lookahead == 'a') ADVANCE(421);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(422);
      END_STATE();
    case 409:
      if (lookahead == 'e') ADVANCE(423);
      END_STATE();
    case 410:
      if (lookahead == 'a') ADVANCE(424);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_readline);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_readlink);
      END_STATE();
    case 413:
      if (lookahead == 'r') ADVANCE(425);
      END_STATE();
    case 414:
      if (lookahead == 'y') ADVANCE(426);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_UNITCHECK);
      END_STATE();
    case 416:
      if (lookahead == '_') ADVANCE(427);
      END_STATE();
    case 417:
      if (lookahead == 'a') ADVANCE(428);
      END_STATE();
    case 418:
      if (lookahead == 'm') ADVANCE(429);
      END_STATE();
    case 419:
      if (lookahead == 'y') ADVANCE(430);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_getpwname);
      END_STATE();
    case 421:
      if (lookahead == 'm') ADVANCE(431);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_localtime);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_prototype);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_quotemeta);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_rewinddir);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_wantarray);
      END_STATE();
    case 427:
      if (lookahead == '_') ADVANCE(432);
      END_STATE();
    case 428:
      if (lookahead == 'm') ADVANCE(433);
      END_STATE();
    case 429:
      if (lookahead == 'e') ADVANCE(434);
      END_STATE();
    case 430:
      if (lookahead == 'n') ADVANCE(435);
      END_STATE();
    case 431:
      if (lookahead == 'e') ADVANCE(436);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym___PACKAGE__);
      END_STATE();
    case 433:
      if (lookahead == 'e') ADVANCE(437);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_getpeername);
      END_STATE();
    case 435:
      if (lookahead == 'a') ADVANCE(438);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_getsockname);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_getnetbyname);
      END_STATE();
    case 438:
      if (lookahead == 'm') ADVANCE(439);
      END_STATE();
    case 439:
      if (lookahead == 'e') ADVANCE(440);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_getprotobyname);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 97, .external_lex_state = 2},
  [2] = {.lex_state = 1, .external_lex_state = 3},
  [3] = {.lex_state = 1, .external_lex_state = 4},
  [4] = {.lex_state = 1, .external_lex_state = 4},
  [5] = {.lex_state = 1, .external_lex_state = 3},
  [6] = {.lex_state = 1, .external_lex_state = 4},
  [7] = {.lex_state = 1, .external_lex_state = 4},
  [8] = {.lex_state = 1, .external_lex_state = 4},
  [9] = {.lex_state = 2, .external_lex_state = 5},
  [10] = {.lex_state = 2, .external_lex_state = 5},
  [11] = {.lex_state = 2, .external_lex_state = 5},
  [12] = {.lex_state = 2, .external_lex_state = 5},
  [13] = {.lex_state = 2, .external_lex_state = 5},
  [14] = {.lex_state = 1, .external_lex_state = 4},
  [15] = {.lex_state = 2, .external_lex_state = 5},
  [16] = {.lex_state = 2, .external_lex_state = 5},
  [17] = {.lex_state = 2, .external_lex_state = 5},
  [18] = {.lex_state = 2, .external_lex_state = 5},
  [19] = {.lex_state = 1, .external_lex_state = 3},
  [20] = {.lex_state = 2, .external_lex_state = 5},
  [21] = {.lex_state = 2, .external_lex_state = 5},
  [22] = {.lex_state = 2, .external_lex_state = 5},
  [23] = {.lex_state = 2, .external_lex_state = 5},
  [24] = {.lex_state = 2, .external_lex_state = 5},
  [25] = {.lex_state = 2, .external_lex_state = 5},
  [26] = {.lex_state = 2, .external_lex_state = 5},
  [27] = {.lex_state = 2, .external_lex_state = 5},
  [28] = {.lex_state = 2, .external_lex_state = 5},
  [29] = {.lex_state = 2, .external_lex_state = 5},
  [30] = {.lex_state = 2, .external_lex_state = 5},
  [31] = {.lex_state = 2, .external_lex_state = 5},
  [32] = {.lex_state = 2, .external_lex_state = 3},
  [33] = {.lex_state = 1, .external_lex_state = 6},
  [34] = {.lex_state = 1, .external_lex_state = 6},
  [35] = {.lex_state = 2, .external_lex_state = 5},
  [36] = {.lex_state = 2, .external_lex_state = 3},
  [37] = {.lex_state = 2, .external_lex_state = 5},
  [38] = {.lex_state = 2, .external_lex_state = 4},
  [39] = {.lex_state = 2, .external_lex_state = 5},
  [40] = {.lex_state = 2, .external_lex_state = 5},
  [41] = {.lex_state = 2, .external_lex_state = 5},
  [42] = {.lex_state = 2, .external_lex_state = 5},
  [43] = {.lex_state = 2, .external_lex_state = 5},
  [44] = {.lex_state = 2, .external_lex_state = 4},
  [45] = {.lex_state = 2, .external_lex_state = 5},
  [46] = {.lex_state = 2, .external_lex_state = 5},
  [47] = {.lex_state = 2, .external_lex_state = 4},
  [48] = {.lex_state = 2, .external_lex_state = 4},
  [49] = {.lex_state = 2, .external_lex_state = 4},
  [50] = {.lex_state = 2, .external_lex_state = 5},
  [51] = {.lex_state = 2, .external_lex_state = 5},
  [52] = {.lex_state = 2, .external_lex_state = 5},
  [53] = {.lex_state = 2, .external_lex_state = 5},
  [54] = {.lex_state = 2, .external_lex_state = 5},
  [55] = {.lex_state = 2, .external_lex_state = 4},
  [56] = {.lex_state = 2, .external_lex_state = 5},
  [57] = {.lex_state = 2, .external_lex_state = 5},
  [58] = {.lex_state = 2, .external_lex_state = 5},
  [59] = {.lex_state = 2, .external_lex_state = 5},
  [60] = {.lex_state = 2, .external_lex_state = 5},
  [61] = {.lex_state = 1, .external_lex_state = 3},
  [62] = {.lex_state = 1, .external_lex_state = 3},
  [63] = {.lex_state = 2, .external_lex_state = 5},
  [64] = {.lex_state = 2, .external_lex_state = 5},
  [65] = {.lex_state = 2, .external_lex_state = 5},
  [66] = {.lex_state = 2, .external_lex_state = 5},
  [67] = {.lex_state = 2, .external_lex_state = 5},
  [68] = {.lex_state = 2, .external_lex_state = 5},
  [69] = {.lex_state = 2, .external_lex_state = 5},
  [70] = {.lex_state = 2, .external_lex_state = 5},
  [71] = {.lex_state = 2, .external_lex_state = 5},
  [72] = {.lex_state = 2, .external_lex_state = 5},
  [73] = {.lex_state = 2, .external_lex_state = 5},
  [74] = {.lex_state = 2, .external_lex_state = 5},
  [75] = {.lex_state = 1, .external_lex_state = 3},
  [76] = {.lex_state = 2, .external_lex_state = 4},
  [77] = {.lex_state = 2, .external_lex_state = 5},
  [78] = {.lex_state = 2, .external_lex_state = 5},
  [79] = {.lex_state = 2, .external_lex_state = 5},
  [80] = {.lex_state = 2, .external_lex_state = 5},
  [81] = {.lex_state = 2, .external_lex_state = 5},
  [82] = {.lex_state = 2, .external_lex_state = 4},
  [83] = {.lex_state = 2, .external_lex_state = 5},
  [84] = {.lex_state = 2, .external_lex_state = 5},
  [85] = {.lex_state = 2, .external_lex_state = 5},
  [86] = {.lex_state = 2, .external_lex_state = 5},
  [87] = {.lex_state = 2, .external_lex_state = 3},
  [88] = {.lex_state = 2, .external_lex_state = 3},
  [89] = {.lex_state = 2, .external_lex_state = 5},
  [90] = {.lex_state = 1, .external_lex_state = 3},
  [91] = {.lex_state = 2, .external_lex_state = 5},
  [92] = {.lex_state = 2, .external_lex_state = 5},
  [93] = {.lex_state = 2, .external_lex_state = 5},
  [94] = {.lex_state = 2, .external_lex_state = 5},
  [95] = {.lex_state = 2, .external_lex_state = 5},
  [96] = {.lex_state = 2, .external_lex_state = 5},
  [97] = {.lex_state = 2, .external_lex_state = 5},
  [98] = {.lex_state = 2, .external_lex_state = 5},
  [99] = {.lex_state = 2, .external_lex_state = 5},
  [100] = {.lex_state = 1, .external_lex_state = 6},
  [101] = {.lex_state = 2, .external_lex_state = 5},
  [102] = {.lex_state = 2, .external_lex_state = 5},
  [103] = {.lex_state = 2, .external_lex_state = 5},
  [104] = {.lex_state = 2, .external_lex_state = 5},
  [105] = {.lex_state = 2, .external_lex_state = 4},
  [106] = {.lex_state = 2, .external_lex_state = 4},
  [107] = {.lex_state = 2, .external_lex_state = 4},
  [108] = {.lex_state = 2, .external_lex_state = 6},
  [109] = {.lex_state = 2, .external_lex_state = 4},
  [110] = {.lex_state = 2, .external_lex_state = 7},
  [111] = {.lex_state = 2, .external_lex_state = 3},
  [112] = {.lex_state = 2, .external_lex_state = 3},
  [113] = {.lex_state = 1, .external_lex_state = 3},
  [114] = {.lex_state = 1, .external_lex_state = 3},
  [115] = {.lex_state = 2, .external_lex_state = 4},
  [116] = {.lex_state = 2, .external_lex_state = 4},
  [117] = {.lex_state = 2, .external_lex_state = 4},
  [118] = {.lex_state = 2, .external_lex_state = 4},
  [119] = {.lex_state = 2, .external_lex_state = 4},
  [120] = {.lex_state = 2, .external_lex_state = 6},
  [121] = {.lex_state = 2, .external_lex_state = 4},
  [122] = {.lex_state = 2, .external_lex_state = 3},
  [123] = {.lex_state = 2, .external_lex_state = 4},
  [124] = {.lex_state = 1, .external_lex_state = 3},
  [125] = {.lex_state = 2, .external_lex_state = 4},
  [126] = {.lex_state = 2, .external_lex_state = 4},
  [127] = {.lex_state = 2, .external_lex_state = 3},
  [128] = {.lex_state = 2, .external_lex_state = 3},
  [129] = {.lex_state = 2, .external_lex_state = 3},
  [130] = {.lex_state = 1, .external_lex_state = 3},
  [131] = {.lex_state = 2, .external_lex_state = 4},
  [132] = {.lex_state = 2, .external_lex_state = 3},
  [133] = {.lex_state = 1, .external_lex_state = 3},
  [134] = {.lex_state = 2, .external_lex_state = 8},
  [135] = {.lex_state = 2, .external_lex_state = 9},
  [136] = {.lex_state = 2, .external_lex_state = 3},
  [137] = {.lex_state = 2, .external_lex_state = 6},
  [138] = {.lex_state = 2, .external_lex_state = 8},
  [139] = {.lex_state = 2, .external_lex_state = 7},
  [140] = {.lex_state = 2, .external_lex_state = 8},
  [141] = {.lex_state = 2, .external_lex_state = 9},
  [142] = {.lex_state = 2, .external_lex_state = 9},
  [143] = {.lex_state = 2, .external_lex_state = 3},
  [144] = {.lex_state = 1, .external_lex_state = 3},
  [145] = {.lex_state = 1, .external_lex_state = 3},
  [146] = {.lex_state = 2, .external_lex_state = 8},
  [147] = {.lex_state = 2, .external_lex_state = 8},
  [148] = {.lex_state = 2, .external_lex_state = 6},
  [149] = {.lex_state = 2, .external_lex_state = 8},
  [150] = {.lex_state = 2, .external_lex_state = 3},
  [151] = {.lex_state = 2, .external_lex_state = 8},
  [152] = {.lex_state = 2, .external_lex_state = 9},
  [153] = {.lex_state = 2, .external_lex_state = 8},
  [154] = {.lex_state = 2, .external_lex_state = 3},
  [155] = {.lex_state = 1, .external_lex_state = 3},
  [156] = {.lex_state = 2, .external_lex_state = 3},
  [157] = {.lex_state = 2, .external_lex_state = 6},
  [158] = {.lex_state = 2, .external_lex_state = 6},
  [159] = {.lex_state = 2, .external_lex_state = 7},
  [160] = {.lex_state = 2, .external_lex_state = 3},
  [161] = {.lex_state = 2, .external_lex_state = 3},
  [162] = {.lex_state = 2, .external_lex_state = 6},
  [163] = {.lex_state = 2, .external_lex_state = 6},
  [164] = {.lex_state = 2, .external_lex_state = 3},
  [165] = {.lex_state = 2, .external_lex_state = 7},
  [166] = {.lex_state = 2, .external_lex_state = 6},
  [167] = {.lex_state = 2, .external_lex_state = 6},
  [168] = {.lex_state = 2, .external_lex_state = 6},
  [169] = {.lex_state = 2, .external_lex_state = 3},
  [170] = {.lex_state = 2, .external_lex_state = 7},
  [171] = {.lex_state = 2, .external_lex_state = 3},
  [172] = {.lex_state = 2, .external_lex_state = 3},
  [173] = {.lex_state = 2, .external_lex_state = 3},
  [174] = {.lex_state = 2, .external_lex_state = 3},
  [175] = {.lex_state = 2, .external_lex_state = 3},
  [176] = {.lex_state = 2, .external_lex_state = 3},
  [177] = {.lex_state = 2, .external_lex_state = 10},
  [178] = {.lex_state = 2, .external_lex_state = 3},
  [179] = {.lex_state = 2, .external_lex_state = 10},
  [180] = {.lex_state = 2, .external_lex_state = 3},
  [181] = {.lex_state = 2, .external_lex_state = 10},
  [182] = {.lex_state = 2, .external_lex_state = 3},
  [183] = {.lex_state = 2, .external_lex_state = 3},
  [184] = {.lex_state = 2, .external_lex_state = 3},
  [185] = {.lex_state = 2, .external_lex_state = 3},
  [186] = {.lex_state = 2, .external_lex_state = 3},
  [187] = {.lex_state = 2, .external_lex_state = 3},
  [188] = {.lex_state = 2, .external_lex_state = 3},
  [189] = {.lex_state = 2, .external_lex_state = 3},
  [190] = {.lex_state = 2, .external_lex_state = 10},
  [191] = {.lex_state = 2, .external_lex_state = 3},
  [192] = {.lex_state = 2, .external_lex_state = 3},
  [193] = {.lex_state = 2, .external_lex_state = 3},
  [194] = {.lex_state = 2, .external_lex_state = 3},
  [195] = {.lex_state = 2, .external_lex_state = 9},
  [196] = {.lex_state = 2, .external_lex_state = 3},
  [197] = {.lex_state = 2, .external_lex_state = 3},
  [198] = {.lex_state = 2, .external_lex_state = 3},
  [199] = {.lex_state = 2, .external_lex_state = 9},
  [200] = {.lex_state = 2, .external_lex_state = 3},
  [201] = {.lex_state = 2, .external_lex_state = 3},
  [202] = {.lex_state = 2, .external_lex_state = 9},
  [203] = {.lex_state = 2, .external_lex_state = 3},
  [204] = {.lex_state = 2, .external_lex_state = 9},
  [205] = {.lex_state = 2, .external_lex_state = 3},
  [206] = {.lex_state = 2, .external_lex_state = 9},
  [207] = {.lex_state = 2, .external_lex_state = 9},
  [208] = {.lex_state = 2, .external_lex_state = 9},
  [209] = {.lex_state = 2, .external_lex_state = 9},
  [210] = {.lex_state = 2, .external_lex_state = 9},
  [211] = {.lex_state = 2, .external_lex_state = 9},
  [212] = {.lex_state = 2, .external_lex_state = 9},
  [213] = {.lex_state = 2, .external_lex_state = 9},
  [214] = {.lex_state = 2, .external_lex_state = 3},
  [215] = {.lex_state = 2, .external_lex_state = 3},
  [216] = {.lex_state = 2, .external_lex_state = 3},
  [217] = {.lex_state = 2, .external_lex_state = 9},
  [218] = {.lex_state = 2, .external_lex_state = 3},
  [219] = {.lex_state = 2, .external_lex_state = 3},
  [220] = {.lex_state = 2, .external_lex_state = 3},
  [221] = {.lex_state = 2, .external_lex_state = 3},
  [222] = {.lex_state = 2, .external_lex_state = 3},
  [223] = {.lex_state = 2, .external_lex_state = 9},
  [224] = {.lex_state = 49, .external_lex_state = 9},
  [225] = {.lex_state = 49, .external_lex_state = 9},
  [226] = {.lex_state = 49, .external_lex_state = 9},
  [227] = {.lex_state = 49, .external_lex_state = 9},
  [228] = {.lex_state = 49, .external_lex_state = 9},
  [229] = {.lex_state = 49, .external_lex_state = 9},
  [230] = {.lex_state = 49, .external_lex_state = 9},
  [231] = {.lex_state = 97, .external_lex_state = 2},
  [232] = {.lex_state = 49, .external_lex_state = 9},
  [233] = {.lex_state = 49, .external_lex_state = 9},
  [234] = {.lex_state = 49, .external_lex_state = 9},
  [235] = {.lex_state = 49, .external_lex_state = 9},
  [236] = {.lex_state = 49, .external_lex_state = 9},
  [237] = {.lex_state = 49, .external_lex_state = 9},
  [238] = {.lex_state = 49, .external_lex_state = 9},
  [239] = {.lex_state = 49, .external_lex_state = 9},
  [240] = {.lex_state = 49, .external_lex_state = 9},
  [241] = {.lex_state = 97, .external_lex_state = 2},
  [242] = {.lex_state = 97, .external_lex_state = 9},
  [243] = {.lex_state = 97, .external_lex_state = 9},
  [244] = {.lex_state = 97, .external_lex_state = 9},
  [245] = {.lex_state = 97, .external_lex_state = 9},
  [246] = {.lex_state = 97, .external_lex_state = 9},
  [247] = {.lex_state = 97, .external_lex_state = 9},
  [248] = {.lex_state = 97, .external_lex_state = 9},
  [249] = {.lex_state = 97, .external_lex_state = 9},
  [250] = {.lex_state = 97, .external_lex_state = 9},
  [251] = {.lex_state = 97, .external_lex_state = 9},
  [252] = {.lex_state = 97, .external_lex_state = 9},
  [253] = {.lex_state = 97, .external_lex_state = 9},
  [254] = {.lex_state = 97, .external_lex_state = 9},
  [255] = {.lex_state = 97, .external_lex_state = 9},
  [256] = {.lex_state = 97, .external_lex_state = 9},
  [257] = {.lex_state = 97, .external_lex_state = 9},
  [258] = {.lex_state = 97, .external_lex_state = 9},
  [259] = {.lex_state = 97, .external_lex_state = 9},
  [260] = {.lex_state = 97, .external_lex_state = 9},
  [261] = {.lex_state = 97, .external_lex_state = 9},
  [262] = {.lex_state = 97, .external_lex_state = 9},
  [263] = {.lex_state = 97, .external_lex_state = 9},
  [264] = {.lex_state = 97, .external_lex_state = 9},
  [265] = {.lex_state = 97, .external_lex_state = 9},
  [266] = {.lex_state = 97, .external_lex_state = 9},
  [267] = {.lex_state = 97, .external_lex_state = 9},
  [268] = {.lex_state = 97, .external_lex_state = 9},
  [269] = {.lex_state = 97, .external_lex_state = 9},
  [270] = {.lex_state = 97, .external_lex_state = 9},
  [271] = {.lex_state = 97, .external_lex_state = 9},
  [272] = {.lex_state = 97, .external_lex_state = 9},
  [273] = {.lex_state = 97, .external_lex_state = 9},
  [274] = {.lex_state = 97, .external_lex_state = 9},
  [275] = {.lex_state = 97, .external_lex_state = 9},
  [276] = {.lex_state = 97, .external_lex_state = 9},
  [277] = {.lex_state = 97, .external_lex_state = 9},
  [278] = {.lex_state = 97, .external_lex_state = 9},
  [279] = {.lex_state = 97, .external_lex_state = 9},
  [280] = {.lex_state = 97, .external_lex_state = 9},
  [281] = {.lex_state = 97, .external_lex_state = 9},
  [282] = {.lex_state = 97, .external_lex_state = 9},
  [283] = {.lex_state = 97, .external_lex_state = 9},
  [284] = {.lex_state = 97, .external_lex_state = 9},
  [285] = {.lex_state = 50, .external_lex_state = 10},
  [286] = {.lex_state = 50, .external_lex_state = 10},
  [287] = {.lex_state = 3, .external_lex_state = 9},
  [288] = {.lex_state = 3, .external_lex_state = 9},
  [289] = {.lex_state = 3, .external_lex_state = 11},
  [290] = {.lex_state = 3, .external_lex_state = 11},
  [291] = {.lex_state = 3, .external_lex_state = 9},
  [292] = {.lex_state = 3, .external_lex_state = 9},
  [293] = {.lex_state = 3, .external_lex_state = 9},
  [294] = {.lex_state = 3, .external_lex_state = 9},
  [295] = {.lex_state = 3, .external_lex_state = 9},
  [296] = {.lex_state = 3, .external_lex_state = 9},
  [297] = {.lex_state = 3, .external_lex_state = 9},
  [298] = {.lex_state = 3, .external_lex_state = 9},
  [299] = {.lex_state = 3, .external_lex_state = 9},
  [300] = {.lex_state = 3, .external_lex_state = 11},
  [301] = {.lex_state = 3, .external_lex_state = 9},
  [302] = {.lex_state = 3, .external_lex_state = 11},
  [303] = {.lex_state = 3, .external_lex_state = 11},
  [304] = {.lex_state = 3, .external_lex_state = 11},
  [305] = {.lex_state = 3, .external_lex_state = 9},
  [306] = {.lex_state = 3, .external_lex_state = 11},
  [307] = {.lex_state = 3, .external_lex_state = 9},
  [308] = {.lex_state = 3, .external_lex_state = 9},
  [309] = {.lex_state = 3, .external_lex_state = 11},
  [310] = {.lex_state = 3, .external_lex_state = 9},
  [311] = {.lex_state = 3, .external_lex_state = 11},
  [312] = {.lex_state = 3, .external_lex_state = 9},
  [313] = {.lex_state = 3, .external_lex_state = 9},
  [314] = {.lex_state = 3, .external_lex_state = 9},
  [315] = {.lex_state = 3, .external_lex_state = 9},
  [316] = {.lex_state = 3, .external_lex_state = 9},
  [317] = {.lex_state = 97, .external_lex_state = 9},
  [318] = {.lex_state = 3, .external_lex_state = 9},
  [319] = {.lex_state = 3, .external_lex_state = 8},
  [320] = {.lex_state = 3, .external_lex_state = 8},
  [321] = {.lex_state = 97, .external_lex_state = 7},
  [322] = {.lex_state = 97, .external_lex_state = 7},
  [323] = {.lex_state = 3, .external_lex_state = 9},
  [324] = {.lex_state = 3, .external_lex_state = 9},
  [325] = {.lex_state = 3, .external_lex_state = 10},
  [326] = {.lex_state = 3, .external_lex_state = 9},
  [327] = {.lex_state = 3, .external_lex_state = 9},
  [328] = {.lex_state = 3, .external_lex_state = 9},
  [329] = {.lex_state = 3, .external_lex_state = 9},
  [330] = {.lex_state = 3, .external_lex_state = 9},
  [331] = {.lex_state = 3, .external_lex_state = 9},
  [332] = {.lex_state = 3, .external_lex_state = 9},
  [333] = {.lex_state = 3, .external_lex_state = 9},
  [334] = {.lex_state = 3, .external_lex_state = 9},
  [335] = {.lex_state = 3, .external_lex_state = 9},
  [336] = {.lex_state = 3, .external_lex_state = 9},
  [337] = {.lex_state = 3, .external_lex_state = 9},
  [338] = {.lex_state = 3, .external_lex_state = 8},
  [339] = {.lex_state = 3, .external_lex_state = 9},
  [340] = {.lex_state = 3, .external_lex_state = 8},
  [341] = {.lex_state = 3, .external_lex_state = 9},
  [342] = {.lex_state = 3, .external_lex_state = 9},
  [343] = {.lex_state = 3, .external_lex_state = 9},
  [344] = {.lex_state = 3, .external_lex_state = 9},
  [345] = {.lex_state = 3, .external_lex_state = 9},
  [346] = {.lex_state = 3, .external_lex_state = 9},
  [347] = {.lex_state = 3, .external_lex_state = 9},
  [348] = {.lex_state = 3, .external_lex_state = 9},
  [349] = {.lex_state = 3, .external_lex_state = 9},
  [350] = {.lex_state = 3, .external_lex_state = 9},
  [351] = {.lex_state = 97, .external_lex_state = 7},
  [352] = {.lex_state = 97, .external_lex_state = 7},
  [353] = {.lex_state = 97, .external_lex_state = 7},
  [354] = {.lex_state = 97, .external_lex_state = 9},
  [355] = {.lex_state = 97, .external_lex_state = 7},
  [356] = {.lex_state = 97, .external_lex_state = 7},
  [357] = {.lex_state = 97, .external_lex_state = 7},
  [358] = {.lex_state = 97, .external_lex_state = 7},
  [359] = {.lex_state = 3, .external_lex_state = 8},
  [360] = {.lex_state = 97, .external_lex_state = 7},
  [361] = {.lex_state = 97, .external_lex_state = 7},
  [362] = {.lex_state = 97, .external_lex_state = 7},
  [363] = {.lex_state = 97, .external_lex_state = 7},
  [364] = {.lex_state = 97, .external_lex_state = 7},
  [365] = {.lex_state = 97, .external_lex_state = 7},
  [366] = {.lex_state = 97, .external_lex_state = 7},
  [367] = {.lex_state = 3, .external_lex_state = 8},
  [368] = {.lex_state = 97, .external_lex_state = 9},
  [369] = {.lex_state = 3, .external_lex_state = 9},
  [370] = {.lex_state = 3, .external_lex_state = 9},
  [371] = {.lex_state = 97, .external_lex_state = 7},
  [372] = {.lex_state = 97, .external_lex_state = 7},
  [373] = {.lex_state = 97, .external_lex_state = 7},
  [374] = {.lex_state = 97, .external_lex_state = 7},
  [375] = {.lex_state = 3, .external_lex_state = 9},
  [376] = {.lex_state = 97, .external_lex_state = 9},
  [377] = {.lex_state = 97, .external_lex_state = 7},
  [378] = {.lex_state = 97, .external_lex_state = 7},
  [379] = {.lex_state = 3, .external_lex_state = 9},
  [380] = {.lex_state = 3, .external_lex_state = 9},
  [381] = {.lex_state = 97, .external_lex_state = 7},
  [382] = {.lex_state = 3, .external_lex_state = 9},
  [383] = {.lex_state = 3, .external_lex_state = 9},
  [384] = {.lex_state = 3, .external_lex_state = 9},
  [385] = {.lex_state = 97, .external_lex_state = 7},
  [386] = {.lex_state = 97, .external_lex_state = 7},
  [387] = {.lex_state = 97, .external_lex_state = 7},
  [388] = {.lex_state = 3, .external_lex_state = 9},
  [389] = {.lex_state = 97, .external_lex_state = 9},
  [390] = {.lex_state = 3, .external_lex_state = 9},
  [391] = {.lex_state = 97, .external_lex_state = 7},
  [392] = {.lex_state = 3, .external_lex_state = 9},
  [393] = {.lex_state = 97, .external_lex_state = 9},
  [394] = {.lex_state = 97, .external_lex_state = 7},
  [395] = {.lex_state = 97, .external_lex_state = 7},
  [396] = {.lex_state = 97, .external_lex_state = 7},
  [397] = {.lex_state = 3, .external_lex_state = 9},
  [398] = {.lex_state = 97, .external_lex_state = 9},
  [399] = {.lex_state = 97, .external_lex_state = 9},
  [400] = {.lex_state = 3, .external_lex_state = 9},
  [401] = {.lex_state = 97, .external_lex_state = 7},
  [402] = {.lex_state = 97, .external_lex_state = 7},
  [403] = {.lex_state = 3, .external_lex_state = 10},
  [404] = {.lex_state = 3, .external_lex_state = 9},
  [405] = {.lex_state = 3, .external_lex_state = 9},
  [406] = {.lex_state = 3, .external_lex_state = 9},
  [407] = {.lex_state = 3, .external_lex_state = 9},
  [408] = {.lex_state = 3, .external_lex_state = 9},
  [409] = {.lex_state = 3, .external_lex_state = 9},
  [410] = {.lex_state = 3, .external_lex_state = 9},
  [411] = {.lex_state = 3, .external_lex_state = 9},
  [412] = {.lex_state = 3, .external_lex_state = 9},
  [413] = {.lex_state = 3, .external_lex_state = 9},
  [414] = {.lex_state = 97, .external_lex_state = 3},
  [415] = {.lex_state = 3, .external_lex_state = 9},
  [416] = {.lex_state = 3, .external_lex_state = 9},
  [417] = {.lex_state = 97, .external_lex_state = 7},
  [418] = {.lex_state = 3, .external_lex_state = 9},
  [419] = {.lex_state = 3, .external_lex_state = 9},
  [420] = {.lex_state = 3, .external_lex_state = 9},
  [421] = {.lex_state = 3, .external_lex_state = 9},
  [422] = {.lex_state = 3, .external_lex_state = 9},
  [423] = {.lex_state = 97, .external_lex_state = 3},
  [424] = {.lex_state = 3, .external_lex_state = 9},
  [425] = {.lex_state = 3, .external_lex_state = 9},
  [426] = {.lex_state = 3, .external_lex_state = 9},
  [427] = {.lex_state = 3, .external_lex_state = 9},
  [428] = {.lex_state = 97, .external_lex_state = 7},
  [429] = {.lex_state = 3, .external_lex_state = 9},
  [430] = {.lex_state = 97, .external_lex_state = 3},
  [431] = {.lex_state = 3, .external_lex_state = 9},
  [432] = {.lex_state = 97, .external_lex_state = 3},
  [433] = {.lex_state = 3, .external_lex_state = 9},
  [434] = {.lex_state = 3, .external_lex_state = 9},
  [435] = {.lex_state = 3, .external_lex_state = 9},
  [436] = {.lex_state = 3, .external_lex_state = 9},
  [437] = {.lex_state = 97, .external_lex_state = 7},
  [438] = {.lex_state = 97, .external_lex_state = 3},
  [439] = {.lex_state = 3, .external_lex_state = 9},
  [440] = {.lex_state = 3, .external_lex_state = 9},
  [441] = {.lex_state = 97, .external_lex_state = 3},
  [442] = {.lex_state = 3, .external_lex_state = 9},
  [443] = {.lex_state = 3, .external_lex_state = 9},
  [444] = {.lex_state = 3, .external_lex_state = 9},
  [445] = {.lex_state = 3, .external_lex_state = 9},
  [446] = {.lex_state = 3, .external_lex_state = 9},
  [447] = {.lex_state = 3, .external_lex_state = 9},
  [448] = {.lex_state = 3, .external_lex_state = 9},
  [449] = {.lex_state = 3, .external_lex_state = 9},
  [450] = {.lex_state = 3, .external_lex_state = 9},
  [451] = {.lex_state = 97, .external_lex_state = 7},
  [452] = {.lex_state = 3, .external_lex_state = 9},
  [453] = {.lex_state = 3, .external_lex_state = 9},
  [454] = {.lex_state = 3, .external_lex_state = 9},
  [455] = {.lex_state = 3, .external_lex_state = 9},
  [456] = {.lex_state = 3, .external_lex_state = 9},
  [457] = {.lex_state = 3, .external_lex_state = 9},
  [458] = {.lex_state = 3, .external_lex_state = 9},
  [459] = {.lex_state = 3, .external_lex_state = 9},
  [460] = {.lex_state = 3, .external_lex_state = 9},
  [461] = {.lex_state = 3, .external_lex_state = 9},
  [462] = {.lex_state = 3, .external_lex_state = 9},
  [463] = {.lex_state = 97, .external_lex_state = 7},
  [464] = {.lex_state = 3, .external_lex_state = 9},
  [465] = {.lex_state = 3, .external_lex_state = 9},
  [466] = {.lex_state = 3, .external_lex_state = 9},
  [467] = {.lex_state = 3, .external_lex_state = 9},
  [468] = {.lex_state = 3, .external_lex_state = 9},
  [469] = {.lex_state = 3, .external_lex_state = 9},
  [470] = {.lex_state = 3, .external_lex_state = 9},
  [471] = {.lex_state = 3, .external_lex_state = 9},
  [472] = {.lex_state = 3, .external_lex_state = 9},
  [473] = {.lex_state = 3, .external_lex_state = 9},
  [474] = {.lex_state = 3, .external_lex_state = 9},
  [475] = {.lex_state = 3, .external_lex_state = 9},
  [476] = {.lex_state = 3, .external_lex_state = 9},
  [477] = {.lex_state = 3, .external_lex_state = 9},
  [478] = {.lex_state = 3, .external_lex_state = 9},
  [479] = {.lex_state = 97, .external_lex_state = 7},
  [480] = {.lex_state = 3, .external_lex_state = 9},
  [481] = {.lex_state = 3, .external_lex_state = 9},
  [482] = {.lex_state = 97, .external_lex_state = 7},
  [483] = {.lex_state = 3, .external_lex_state = 9},
  [484] = {.lex_state = 3, .external_lex_state = 9},
  [485] = {.lex_state = 3, .external_lex_state = 9},
  [486] = {.lex_state = 3, .external_lex_state = 9},
  [487] = {.lex_state = 3, .external_lex_state = 9},
  [488] = {.lex_state = 3, .external_lex_state = 9},
  [489] = {.lex_state = 3, .external_lex_state = 9},
  [490] = {.lex_state = 3, .external_lex_state = 9},
  [491] = {.lex_state = 3, .external_lex_state = 9},
  [492] = {.lex_state = 3, .external_lex_state = 9},
  [493] = {.lex_state = 3, .external_lex_state = 9},
  [494] = {.lex_state = 3, .external_lex_state = 9},
  [495] = {.lex_state = 3, .external_lex_state = 9},
  [496] = {.lex_state = 3, .external_lex_state = 9},
  [497] = {.lex_state = 3, .external_lex_state = 9},
  [498] = {.lex_state = 3, .external_lex_state = 9},
  [499] = {.lex_state = 3, .external_lex_state = 9},
  [500] = {.lex_state = 3, .external_lex_state = 9},
  [501] = {.lex_state = 3, .external_lex_state = 9},
  [502] = {.lex_state = 3, .external_lex_state = 9},
  [503] = {.lex_state = 97, .external_lex_state = 3},
  [504] = {.lex_state = 3, .external_lex_state = 9},
  [505] = {.lex_state = 97, .external_lex_state = 7},
  [506] = {.lex_state = 3, .external_lex_state = 9},
  [507] = {.lex_state = 97, .external_lex_state = 3},
  [508] = {.lex_state = 3, .external_lex_state = 9},
  [509] = {.lex_state = 3, .external_lex_state = 9},
  [510] = {.lex_state = 97, .external_lex_state = 7},
  [511] = {.lex_state = 97, .external_lex_state = 7},
  [512] = {.lex_state = 97, .external_lex_state = 3},
  [513] = {.lex_state = 97, .external_lex_state = 7},
  [514] = {.lex_state = 3, .external_lex_state = 9},
  [515] = {.lex_state = 97, .external_lex_state = 3},
  [516] = {.lex_state = 3, .external_lex_state = 9},
  [517] = {.lex_state = 97, .external_lex_state = 3},
  [518] = {.lex_state = 97, .external_lex_state = 7},
  [519] = {.lex_state = 3, .external_lex_state = 9},
  [520] = {.lex_state = 3, .external_lex_state = 9},
  [521] = {.lex_state = 3, .external_lex_state = 9},
  [522] = {.lex_state = 3, .external_lex_state = 9},
  [523] = {.lex_state = 97, .external_lex_state = 7},
  [524] = {.lex_state = 97, .external_lex_state = 3},
  [525] = {.lex_state = 3, .external_lex_state = 9},
  [526] = {.lex_state = 3, .external_lex_state = 9},
  [527] = {.lex_state = 97, .external_lex_state = 7},
  [528] = {.lex_state = 3, .external_lex_state = 9},
  [529] = {.lex_state = 3, .external_lex_state = 9},
  [530] = {.lex_state = 3, .external_lex_state = 9},
  [531] = {.lex_state = 97, .external_lex_state = 7},
  [532] = {.lex_state = 97, .external_lex_state = 3},
  [533] = {.lex_state = 3, .external_lex_state = 9},
  [534] = {.lex_state = 97, .external_lex_state = 3},
  [535] = {.lex_state = 97, .external_lex_state = 3},
  [536] = {.lex_state = 97, .external_lex_state = 7},
  [537] = {.lex_state = 3, .external_lex_state = 9},
  [538] = {.lex_state = 97, .external_lex_state = 3},
  [539] = {.lex_state = 97, .external_lex_state = 9},
  [540] = {.lex_state = 97, .external_lex_state = 3},
  [541] = {.lex_state = 97, .external_lex_state = 3},
  [542] = {.lex_state = 97, .external_lex_state = 3},
  [543] = {.lex_state = 97, .external_lex_state = 9},
  [544] = {.lex_state = 3, .external_lex_state = 10},
  [545] = {.lex_state = 97, .external_lex_state = 3},
  [546] = {.lex_state = 97, .external_lex_state = 3},
  [547] = {.lex_state = 97, .external_lex_state = 9},
  [548] = {.lex_state = 97, .external_lex_state = 3},
  [549] = {.lex_state = 97, .external_lex_state = 3},
  [550] = {.lex_state = 97, .external_lex_state = 9},
  [551] = {.lex_state = 97, .external_lex_state = 9},
  [552] = {.lex_state = 97, .external_lex_state = 9},
  [553] = {.lex_state = 3, .external_lex_state = 10},
  [554] = {.lex_state = 3, .external_lex_state = 10},
  [555] = {.lex_state = 97, .external_lex_state = 3},
  [556] = {.lex_state = 3, .external_lex_state = 9},
  [557] = {.lex_state = 3, .external_lex_state = 9},
  [558] = {.lex_state = 3, .external_lex_state = 9},
  [559] = {.lex_state = 3, .external_lex_state = 7},
  [560] = {.lex_state = 52, .external_lex_state = 9},
  [561] = {.lex_state = 3, .external_lex_state = 9},
  [562] = {.lex_state = 52, .external_lex_state = 9},
  [563] = {.lex_state = 3, .external_lex_state = 9},
  [564] = {.lex_state = 3, .external_lex_state = 7},
  [565] = {.lex_state = 3, .external_lex_state = 7},
  [566] = {.lex_state = 3, .external_lex_state = 7},
  [567] = {.lex_state = 52, .external_lex_state = 9},
  [568] = {.lex_state = 3, .external_lex_state = 7},
  [569] = {.lex_state = 52, .external_lex_state = 9},
  [570] = {.lex_state = 52, .external_lex_state = 9},
  [571] = {.lex_state = 3, .external_lex_state = 9},
  [572] = {.lex_state = 3, .external_lex_state = 7},
  [573] = {.lex_state = 3, .external_lex_state = 7},
  [574] = {.lex_state = 52, .external_lex_state = 9},
  [575] = {.lex_state = 52, .external_lex_state = 9},
  [576] = {.lex_state = 52, .external_lex_state = 9},
  [577] = {.lex_state = 52, .external_lex_state = 9},
  [578] = {.lex_state = 52, .external_lex_state = 9},
  [579] = {.lex_state = 52, .external_lex_state = 9},
  [580] = {.lex_state = 52, .external_lex_state = 9},
  [581] = {.lex_state = 3, .external_lex_state = 7},
  [582] = {.lex_state = 52, .external_lex_state = 9},
  [583] = {.lex_state = 52, .external_lex_state = 9},
  [584] = {.lex_state = 52, .external_lex_state = 9},
  [585] = {.lex_state = 52, .external_lex_state = 9},
  [586] = {.lex_state = 3, .external_lex_state = 9},
  [587] = {.lex_state = 3, .external_lex_state = 7},
  [588] = {.lex_state = 52, .external_lex_state = 9},
  [589] = {.lex_state = 52, .external_lex_state = 9},
  [590] = {.lex_state = 52, .external_lex_state = 9},
  [591] = {.lex_state = 52, .external_lex_state = 9},
  [592] = {.lex_state = 3, .external_lex_state = 7},
  [593] = {.lex_state = 3, .external_lex_state = 9},
  [594] = {.lex_state = 3, .external_lex_state = 9},
  [595] = {.lex_state = 3, .external_lex_state = 7},
  [596] = {.lex_state = 52, .external_lex_state = 9},
  [597] = {.lex_state = 52, .external_lex_state = 9},
  [598] = {.lex_state = 52, .external_lex_state = 9},
  [599] = {.lex_state = 3, .external_lex_state = 7},
  [600] = {.lex_state = 52, .external_lex_state = 9},
  [601] = {.lex_state = 52, .external_lex_state = 9},
  [602] = {.lex_state = 52, .external_lex_state = 9},
  [603] = {.lex_state = 52, .external_lex_state = 9},
  [604] = {.lex_state = 3, .external_lex_state = 9},
  [605] = {.lex_state = 3, .external_lex_state = 7},
  [606] = {.lex_state = 3, .external_lex_state = 7},
  [607] = {.lex_state = 52, .external_lex_state = 9},
  [608] = {.lex_state = 3, .external_lex_state = 9},
  [609] = {.lex_state = 52, .external_lex_state = 9},
  [610] = {.lex_state = 52, .external_lex_state = 9},
  [611] = {.lex_state = 52, .external_lex_state = 9},
  [612] = {.lex_state = 52, .external_lex_state = 9},
  [613] = {.lex_state = 3, .external_lex_state = 7},
  [614] = {.lex_state = 3, .external_lex_state = 7},
  [615] = {.lex_state = 3, .external_lex_state = 9},
  [616] = {.lex_state = 3, .external_lex_state = 9},
  [617] = {.lex_state = 3, .external_lex_state = 9},
  [618] = {.lex_state = 3, .external_lex_state = 3},
  [619] = {.lex_state = 3, .external_lex_state = 9},
  [620] = {.lex_state = 3, .external_lex_state = 3},
  [621] = {.lex_state = 3, .external_lex_state = 3},
  [622] = {.lex_state = 3, .external_lex_state = 9},
  [623] = {.lex_state = 3, .external_lex_state = 9},
  [624] = {.lex_state = 3, .external_lex_state = 9},
  [625] = {.lex_state = 3, .external_lex_state = 9},
  [626] = {.lex_state = 3, .external_lex_state = 11},
  [627] = {.lex_state = 3, .external_lex_state = 11},
  [628] = {.lex_state = 3, .external_lex_state = 11},
  [629] = {.lex_state = 3, .external_lex_state = 3},
  [630] = {.lex_state = 3, .external_lex_state = 3},
  [631] = {.lex_state = 3, .external_lex_state = 9},
  [632] = {.lex_state = 3, .external_lex_state = 9},
  [633] = {.lex_state = 3, .external_lex_state = 11},
  [634] = {.lex_state = 3, .external_lex_state = 11},
  [635] = {.lex_state = 3, .external_lex_state = 9},
  [636] = {.lex_state = 3, .external_lex_state = 9},
  [637] = {.lex_state = 3, .external_lex_state = 9},
  [638] = {.lex_state = 3, .external_lex_state = 9},
  [639] = {.lex_state = 3, .external_lex_state = 9},
  [640] = {.lex_state = 3, .external_lex_state = 11},
  [641] = {.lex_state = 3, .external_lex_state = 11},
  [642] = {.lex_state = 3, .external_lex_state = 3},
  [643] = {.lex_state = 3, .external_lex_state = 11},
  [644] = {.lex_state = 3, .external_lex_state = 3},
  [645] = {.lex_state = 3, .external_lex_state = 9},
  [646] = {.lex_state = 3, .external_lex_state = 9},
  [647] = {.lex_state = 3, .external_lex_state = 9},
  [648] = {.lex_state = 3, .external_lex_state = 11},
  [649] = {.lex_state = 3, .external_lex_state = 11},
  [650] = {.lex_state = 3, .external_lex_state = 11},
  [651] = {.lex_state = 3, .external_lex_state = 9},
  [652] = {.lex_state = 3, .external_lex_state = 9},
  [653] = {.lex_state = 3, .external_lex_state = 9},
  [654] = {.lex_state = 3, .external_lex_state = 9},
  [655] = {.lex_state = 3, .external_lex_state = 9},
  [656] = {.lex_state = 3, .external_lex_state = 11},
  [657] = {.lex_state = 3, .external_lex_state = 9},
  [658] = {.lex_state = 3, .external_lex_state = 9},
  [659] = {.lex_state = 3, .external_lex_state = 9},
  [660] = {.lex_state = 3, .external_lex_state = 9},
  [661] = {.lex_state = 3, .external_lex_state = 11},
  [662] = {.lex_state = 3, .external_lex_state = 11},
  [663] = {.lex_state = 3, .external_lex_state = 11},
  [664] = {.lex_state = 3, .external_lex_state = 9},
  [665] = {.lex_state = 3, .external_lex_state = 9},
  [666] = {.lex_state = 3, .external_lex_state = 9},
  [667] = {.lex_state = 3, .external_lex_state = 9},
  [668] = {.lex_state = 3, .external_lex_state = 9},
  [669] = {.lex_state = 3, .external_lex_state = 11},
  [670] = {.lex_state = 3, .external_lex_state = 11},
  [671] = {.lex_state = 3, .external_lex_state = 11},
  [672] = {.lex_state = 3, .external_lex_state = 3},
  [673] = {.lex_state = 3, .external_lex_state = 9},
  [674] = {.lex_state = 3, .external_lex_state = 9},
  [675] = {.lex_state = 3, .external_lex_state = 9},
  [676] = {.lex_state = 3, .external_lex_state = 11},
  [677] = {.lex_state = 3, .external_lex_state = 11},
  [678] = {.lex_state = 3, .external_lex_state = 9},
  [679] = {.lex_state = 3, .external_lex_state = 9},
  [680] = {.lex_state = 3, .external_lex_state = 9},
  [681] = {.lex_state = 3, .external_lex_state = 9},
  [682] = {.lex_state = 3, .external_lex_state = 11},
  [683] = {.lex_state = 3, .external_lex_state = 11},
  [684] = {.lex_state = 3, .external_lex_state = 11},
  [685] = {.lex_state = 3, .external_lex_state = 9},
  [686] = {.lex_state = 3, .external_lex_state = 9},
  [687] = {.lex_state = 3, .external_lex_state = 9},
  [688] = {.lex_state = 3, .external_lex_state = 9},
  [689] = {.lex_state = 3, .external_lex_state = 9},
  [690] = {.lex_state = 3, .external_lex_state = 9},
  [691] = {.lex_state = 3, .external_lex_state = 11},
  [692] = {.lex_state = 3, .external_lex_state = 9},
  [693] = {.lex_state = 3, .external_lex_state = 9},
  [694] = {.lex_state = 3, .external_lex_state = 9},
  [695] = {.lex_state = 3, .external_lex_state = 9},
  [696] = {.lex_state = 3, .external_lex_state = 9},
  [697] = {.lex_state = 3, .external_lex_state = 9},
  [698] = {.lex_state = 3, .external_lex_state = 9},
  [699] = {.lex_state = 3, .external_lex_state = 9},
  [700] = {.lex_state = 3, .external_lex_state = 9},
  [701] = {.lex_state = 3, .external_lex_state = 9},
  [702] = {.lex_state = 3, .external_lex_state = 9},
  [703] = {.lex_state = 3, .external_lex_state = 9},
  [704] = {.lex_state = 3, .external_lex_state = 9},
  [705] = {.lex_state = 3, .external_lex_state = 9},
  [706] = {.lex_state = 3, .external_lex_state = 9},
  [707] = {.lex_state = 3, .external_lex_state = 9},
  [708] = {.lex_state = 3, .external_lex_state = 9},
  [709] = {.lex_state = 3, .external_lex_state = 9},
  [710] = {.lex_state = 3, .external_lex_state = 9},
  [711] = {.lex_state = 3, .external_lex_state = 9},
  [712] = {.lex_state = 3, .external_lex_state = 9},
  [713] = {.lex_state = 3, .external_lex_state = 9},
  [714] = {.lex_state = 3, .external_lex_state = 9},
  [715] = {.lex_state = 3, .external_lex_state = 9},
  [716] = {.lex_state = 3, .external_lex_state = 9},
  [717] = {.lex_state = 3, .external_lex_state = 9},
  [718] = {.lex_state = 3, .external_lex_state = 9},
  [719] = {.lex_state = 3, .external_lex_state = 9},
  [720] = {.lex_state = 3, .external_lex_state = 9},
  [721] = {.lex_state = 3, .external_lex_state = 9},
  [722] = {.lex_state = 3, .external_lex_state = 9},
  [723] = {.lex_state = 3, .external_lex_state = 9},
  [724] = {.lex_state = 3, .external_lex_state = 9},
  [725] = {.lex_state = 3, .external_lex_state = 9},
  [726] = {.lex_state = 3, .external_lex_state = 9},
  [727] = {.lex_state = 3, .external_lex_state = 9},
  [728] = {.lex_state = 3, .external_lex_state = 9},
  [729] = {.lex_state = 3, .external_lex_state = 9},
  [730] = {.lex_state = 3, .external_lex_state = 9},
  [731] = {.lex_state = 3, .external_lex_state = 9},
  [732] = {.lex_state = 3, .external_lex_state = 9},
  [733] = {.lex_state = 3, .external_lex_state = 9},
  [734] = {.lex_state = 3, .external_lex_state = 9},
  [735] = {.lex_state = 3, .external_lex_state = 9},
  [736] = {.lex_state = 3, .external_lex_state = 9},
  [737] = {.lex_state = 3, .external_lex_state = 9},
  [738] = {.lex_state = 3, .external_lex_state = 9},
  [739] = {.lex_state = 3, .external_lex_state = 9},
  [740] = {.lex_state = 3, .external_lex_state = 9},
  [741] = {.lex_state = 3, .external_lex_state = 9},
  [742] = {.lex_state = 3, .external_lex_state = 9},
  [743] = {.lex_state = 3, .external_lex_state = 9},
  [744] = {.lex_state = 3, .external_lex_state = 9},
  [745] = {.lex_state = 3, .external_lex_state = 9},
  [746] = {.lex_state = 3, .external_lex_state = 9},
  [747] = {.lex_state = 3, .external_lex_state = 9},
  [748] = {.lex_state = 3, .external_lex_state = 9},
  [749] = {.lex_state = 3, .external_lex_state = 9},
  [750] = {.lex_state = 3, .external_lex_state = 9},
  [751] = {.lex_state = 3, .external_lex_state = 9},
  [752] = {.lex_state = 3, .external_lex_state = 9},
  [753] = {.lex_state = 3, .external_lex_state = 9},
  [754] = {.lex_state = 3, .external_lex_state = 9},
  [755] = {.lex_state = 3, .external_lex_state = 9},
  [756] = {.lex_state = 3, .external_lex_state = 9},
  [757] = {.lex_state = 3, .external_lex_state = 9},
  [758] = {.lex_state = 3, .external_lex_state = 9},
  [759] = {.lex_state = 3, .external_lex_state = 9},
  [760] = {.lex_state = 3, .external_lex_state = 9},
  [761] = {.lex_state = 3, .external_lex_state = 9},
  [762] = {.lex_state = 3, .external_lex_state = 9},
  [763] = {.lex_state = 3, .external_lex_state = 9},
  [764] = {.lex_state = 3, .external_lex_state = 9},
  [765] = {.lex_state = 3, .external_lex_state = 9},
  [766] = {.lex_state = 3, .external_lex_state = 9},
  [767] = {.lex_state = 3, .external_lex_state = 9},
  [768] = {.lex_state = 3, .external_lex_state = 9},
  [769] = {.lex_state = 3, .external_lex_state = 9},
  [770] = {.lex_state = 3, .external_lex_state = 9},
  [771] = {.lex_state = 3, .external_lex_state = 9},
  [772] = {.lex_state = 3, .external_lex_state = 9},
  [773] = {.lex_state = 3, .external_lex_state = 9},
  [774] = {.lex_state = 3, .external_lex_state = 9},
  [775] = {.lex_state = 3, .external_lex_state = 9},
  [776] = {.lex_state = 3, .external_lex_state = 9},
  [777] = {.lex_state = 3, .external_lex_state = 9},
  [778] = {.lex_state = 3, .external_lex_state = 9},
  [779] = {.lex_state = 3, .external_lex_state = 9},
  [780] = {.lex_state = 3, .external_lex_state = 9},
  [781] = {.lex_state = 3, .external_lex_state = 9},
  [782] = {.lex_state = 3, .external_lex_state = 9},
  [783] = {.lex_state = 3, .external_lex_state = 9},
  [784] = {.lex_state = 3, .external_lex_state = 9},
  [785] = {.lex_state = 3, .external_lex_state = 9},
  [786] = {.lex_state = 3, .external_lex_state = 9},
  [787] = {.lex_state = 3, .external_lex_state = 9},
  [788] = {.lex_state = 3, .external_lex_state = 9},
  [789] = {.lex_state = 3, .external_lex_state = 9},
  [790] = {.lex_state = 3, .external_lex_state = 9},
  [791] = {.lex_state = 3, .external_lex_state = 9},
  [792] = {.lex_state = 3, .external_lex_state = 9},
  [793] = {.lex_state = 3, .external_lex_state = 9},
  [794] = {.lex_state = 3, .external_lex_state = 9},
  [795] = {.lex_state = 3, .external_lex_state = 9},
  [796] = {.lex_state = 3, .external_lex_state = 9},
  [797] = {.lex_state = 3, .external_lex_state = 9},
  [798] = {.lex_state = 3, .external_lex_state = 9},
  [799] = {.lex_state = 3, .external_lex_state = 9},
  [800] = {.lex_state = 3, .external_lex_state = 9},
  [801] = {.lex_state = 3, .external_lex_state = 9},
  [802] = {.lex_state = 3, .external_lex_state = 9},
  [803] = {.lex_state = 3, .external_lex_state = 9},
  [804] = {.lex_state = 3, .external_lex_state = 9},
  [805] = {.lex_state = 3, .external_lex_state = 9},
  [806] = {.lex_state = 3, .external_lex_state = 9},
  [807] = {.lex_state = 3, .external_lex_state = 9},
  [808] = {.lex_state = 3, .external_lex_state = 9},
  [809] = {.lex_state = 3, .external_lex_state = 9},
  [810] = {.lex_state = 3, .external_lex_state = 9},
  [811] = {.lex_state = 3, .external_lex_state = 9},
  [812] = {.lex_state = 3, .external_lex_state = 9},
  [813] = {.lex_state = 3, .external_lex_state = 9},
  [814] = {.lex_state = 3, .external_lex_state = 9},
  [815] = {.lex_state = 3, .external_lex_state = 9},
  [816] = {.lex_state = 3, .external_lex_state = 9},
  [817] = {.lex_state = 3, .external_lex_state = 9},
  [818] = {.lex_state = 3, .external_lex_state = 9},
  [819] = {.lex_state = 3, .external_lex_state = 9},
  [820] = {.lex_state = 3, .external_lex_state = 9},
  [821] = {.lex_state = 3, .external_lex_state = 9},
  [822] = {.lex_state = 3, .external_lex_state = 9},
  [823] = {.lex_state = 3, .external_lex_state = 9},
  [824] = {.lex_state = 3, .external_lex_state = 9},
  [825] = {.lex_state = 3, .external_lex_state = 9},
  [826] = {.lex_state = 3, .external_lex_state = 9},
  [827] = {.lex_state = 3, .external_lex_state = 9},
  [828] = {.lex_state = 3, .external_lex_state = 9},
  [829] = {.lex_state = 3, .external_lex_state = 9},
  [830] = {.lex_state = 3, .external_lex_state = 9},
  [831] = {.lex_state = 3, .external_lex_state = 9},
  [832] = {.lex_state = 3, .external_lex_state = 9},
  [833] = {.lex_state = 3, .external_lex_state = 9},
  [834] = {.lex_state = 3, .external_lex_state = 9},
  [835] = {.lex_state = 3, .external_lex_state = 9},
  [836] = {.lex_state = 3, .external_lex_state = 9},
  [837] = {.lex_state = 3, .external_lex_state = 9},
  [838] = {.lex_state = 3, .external_lex_state = 9},
  [839] = {.lex_state = 3, .external_lex_state = 9},
  [840] = {.lex_state = 3, .external_lex_state = 9},
  [841] = {.lex_state = 3, .external_lex_state = 9},
  [842] = {.lex_state = 3, .external_lex_state = 9},
  [843] = {.lex_state = 3, .external_lex_state = 9},
  [844] = {.lex_state = 3, .external_lex_state = 9},
  [845] = {.lex_state = 3, .external_lex_state = 9},
  [846] = {.lex_state = 3, .external_lex_state = 9},
  [847] = {.lex_state = 3, .external_lex_state = 9},
  [848] = {.lex_state = 3, .external_lex_state = 9},
  [849] = {.lex_state = 3, .external_lex_state = 9},
  [850] = {.lex_state = 3, .external_lex_state = 9},
  [851] = {.lex_state = 3, .external_lex_state = 9},
  [852] = {.lex_state = 3, .external_lex_state = 9},
  [853] = {.lex_state = 3, .external_lex_state = 9},
  [854] = {.lex_state = 3, .external_lex_state = 9},
  [855] = {.lex_state = 3, .external_lex_state = 9},
  [856] = {.lex_state = 3, .external_lex_state = 9},
  [857] = {.lex_state = 1, .external_lex_state = 5},
  [858] = {.lex_state = 1, .external_lex_state = 5},
  [859] = {.lex_state = 1, .external_lex_state = 5},
  [860] = {.lex_state = 1, .external_lex_state = 5},
  [861] = {.lex_state = 1, .external_lex_state = 5},
  [862] = {.lex_state = 1, .external_lex_state = 5},
  [863] = {.lex_state = 1, .external_lex_state = 5},
  [864] = {.lex_state = 1, .external_lex_state = 5},
  [865] = {.lex_state = 1, .external_lex_state = 5},
  [866] = {.lex_state = 1, .external_lex_state = 5},
  [867] = {.lex_state = 1, .external_lex_state = 5},
  [868] = {.lex_state = 1, .external_lex_state = 5},
  [869] = {.lex_state = 1, .external_lex_state = 5},
  [870] = {.lex_state = 1, .external_lex_state = 5},
  [871] = {.lex_state = 1, .external_lex_state = 5},
  [872] = {.lex_state = 1, .external_lex_state = 4},
  [873] = {.lex_state = 1, .external_lex_state = 12},
  [874] = {.lex_state = 1, .external_lex_state = 12},
  [875] = {.lex_state = 1, .external_lex_state = 12},
  [876] = {.lex_state = 1, .external_lex_state = 12},
  [877] = {.lex_state = 1, .external_lex_state = 12},
  [878] = {.lex_state = 1, .external_lex_state = 12},
  [879] = {.lex_state = 1, .external_lex_state = 4},
  [880] = {.lex_state = 1, .external_lex_state = 3},
  [881] = {.lex_state = 1, .external_lex_state = 12},
  [882] = {.lex_state = 1, .external_lex_state = 3},
  [883] = {.lex_state = 1, .external_lex_state = 12},
  [884] = {.lex_state = 1, .external_lex_state = 12},
  [885] = {.lex_state = 1, .external_lex_state = 4},
  [886] = {.lex_state = 1, .external_lex_state = 4},
  [887] = {.lex_state = 1, .external_lex_state = 12},
  [888] = {.lex_state = 1, .external_lex_state = 12},
  [889] = {.lex_state = 1, .external_lex_state = 12},
  [890] = {.lex_state = 1, .external_lex_state = 3},
  [891] = {.lex_state = 1, .external_lex_state = 4},
  [892] = {.lex_state = 1, .external_lex_state = 4},
  [893] = {.lex_state = 1, .external_lex_state = 12},
  [894] = {.lex_state = 1, .external_lex_state = 4},
  [895] = {.lex_state = 1, .external_lex_state = 12},
  [896] = {.lex_state = 1, .external_lex_state = 12},
  [897] = {.lex_state = 2, .external_lex_state = 9},
  [898] = {.lex_state = 2, .external_lex_state = 9},
  [899] = {.lex_state = 2, .external_lex_state = 9},
  [900] = {.lex_state = 2, .external_lex_state = 9},
  [901] = {.lex_state = 1, .external_lex_state = 8},
  [902] = {.lex_state = 2, .external_lex_state = 9},
  [903] = {.lex_state = 1, .external_lex_state = 9},
  [904] = {.lex_state = 1, .external_lex_state = 8},
  [905] = {.lex_state = 2, .external_lex_state = 9},
  [906] = {.lex_state = 1, .external_lex_state = 8},
  [907] = {.lex_state = 2, .external_lex_state = 9},
  [908] = {.lex_state = 2, .external_lex_state = 9},
  [909] = {.lex_state = 1, .external_lex_state = 9},
  [910] = {.lex_state = 2, .external_lex_state = 9},
  [911] = {.lex_state = 2, .external_lex_state = 9},
  [912] = {.lex_state = 2, .external_lex_state = 9},
  [913] = {.lex_state = 1, .external_lex_state = 8},
  [914] = {.lex_state = 2, .external_lex_state = 8},
  [915] = {.lex_state = 2, .external_lex_state = 8},
  [916] = {.lex_state = 2, .external_lex_state = 8},
  [917] = {.lex_state = 1, .external_lex_state = 3},
  [918] = {.lex_state = 2, .external_lex_state = 8},
  [919] = {.lex_state = 2, .external_lex_state = 8},
  [920] = {.lex_state = 1, .external_lex_state = 7},
  [921] = {.lex_state = 2, .external_lex_state = 8},
  [922] = {.lex_state = 2, .external_lex_state = 8},
  [923] = {.lex_state = 1, .external_lex_state = 6},
  [924] = {.lex_state = 2, .external_lex_state = 8},
  [925] = {.lex_state = 1, .external_lex_state = 3},
  [926] = {.lex_state = 2, .external_lex_state = 8},
  [927] = {.lex_state = 2, .external_lex_state = 8},
  [928] = {.lex_state = 2, .external_lex_state = 8},
  [929] = {.lex_state = 1, .external_lex_state = 6},
  [930] = {.lex_state = 1, .external_lex_state = 6},
  [931] = {.lex_state = 2, .external_lex_state = 8},
  [932] = {.lex_state = 2, .external_lex_state = 8},
  [933] = {.lex_state = 2, .external_lex_state = 9},
  [934] = {.lex_state = 2, .external_lex_state = 9},
  [935] = {.lex_state = 2, .external_lex_state = 8},
  [936] = {.lex_state = 1, .external_lex_state = 3},
  [937] = {.lex_state = 2, .external_lex_state = 8},
  [938] = {.lex_state = 1, .external_lex_state = 9},
  [939] = {.lex_state = 1, .external_lex_state = 10},
  [940] = {.lex_state = 1, .external_lex_state = 10},
  [941] = {.lex_state = 1, .external_lex_state = 9},
  [942] = {.lex_state = 1, .external_lex_state = 13},
  [943] = {.lex_state = 2, .external_lex_state = 10},
  [944] = {.lex_state = 2, .external_lex_state = 10},
  [945] = {.lex_state = 2, .external_lex_state = 10},
  [946] = {.lex_state = 2, .external_lex_state = 10},
  [947] = {.lex_state = 2, .external_lex_state = 10},
  [948] = {.lex_state = 2, .external_lex_state = 10},
  [949] = {.lex_state = 2, .external_lex_state = 9},
  [950] = {.lex_state = 2, .external_lex_state = 10},
  [951] = {.lex_state = 2, .external_lex_state = 10},
  [952] = {.lex_state = 2, .external_lex_state = 10},
  [953] = {.lex_state = 2, .external_lex_state = 10},
  [954] = {.lex_state = 2, .external_lex_state = 9},
  [955] = {.lex_state = 2, .external_lex_state = 10},
  [956] = {.lex_state = 2, .external_lex_state = 10},
  [957] = {.lex_state = 2, .external_lex_state = 10},
  [958] = {.lex_state = 2, .external_lex_state = 10},
  [959] = {.lex_state = 97, .external_lex_state = 2},
  [960] = {.lex_state = 97, .external_lex_state = 2},
  [961] = {.lex_state = 97, .external_lex_state = 2},
  [962] = {.lex_state = 97, .external_lex_state = 2},
  [963] = {.lex_state = 97, .external_lex_state = 2},
  [964] = {.lex_state = 97, .external_lex_state = 2},
  [965] = {.lex_state = 97, .external_lex_state = 9},
  [966] = {.lex_state = 97, .external_lex_state = 2},
  [967] = {.lex_state = 97, .external_lex_state = 9},
  [968] = {.lex_state = 97, .external_lex_state = 2},
  [969] = {.lex_state = 97, .external_lex_state = 2},
  [970] = {.lex_state = 97, .external_lex_state = 2},
  [971] = {.lex_state = 97, .external_lex_state = 2},
  [972] = {.lex_state = 97, .external_lex_state = 2},
  [973] = {.lex_state = 97, .external_lex_state = 2},
  [974] = {.lex_state = 97, .external_lex_state = 2},
  [975] = {.lex_state = 97, .external_lex_state = 2},
  [976] = {.lex_state = 97, .external_lex_state = 2},
  [977] = {.lex_state = 97, .external_lex_state = 2},
  [978] = {.lex_state = 97, .external_lex_state = 2},
  [979] = {.lex_state = 97, .external_lex_state = 2},
  [980] = {.lex_state = 97, .external_lex_state = 2},
  [981] = {.lex_state = 97, .external_lex_state = 2},
  [982] = {.lex_state = 97, .external_lex_state = 2},
  [983] = {.lex_state = 97, .external_lex_state = 2},
  [984] = {.lex_state = 97, .external_lex_state = 2},
  [985] = {.lex_state = 49, .external_lex_state = 9},
  [986] = {.lex_state = 97, .external_lex_state = 2},
  [987] = {.lex_state = 97, .external_lex_state = 2},
  [988] = {.lex_state = 97, .external_lex_state = 2},
  [989] = {.lex_state = 97, .external_lex_state = 9},
  [990] = {.lex_state = 97, .external_lex_state = 9},
  [991] = {.lex_state = 97, .external_lex_state = 2},
  [992] = {.lex_state = 97, .external_lex_state = 2},
  [993] = {.lex_state = 97, .external_lex_state = 2},
  [994] = {.lex_state = 97, .external_lex_state = 2},
  [995] = {.lex_state = 97, .external_lex_state = 2},
  [996] = {.lex_state = 97, .external_lex_state = 2},
  [997] = {.lex_state = 97, .external_lex_state = 2},
  [998] = {.lex_state = 97, .external_lex_state = 2},
  [999] = {.lex_state = 97, .external_lex_state = 2},
  [1000] = {.lex_state = 97, .external_lex_state = 2},
  [1001] = {.lex_state = 97, .external_lex_state = 2},
  [1002] = {.lex_state = 97, .external_lex_state = 2},
  [1003] = {.lex_state = 97, .external_lex_state = 2},
  [1004] = {.lex_state = 97, .external_lex_state = 2},
  [1005] = {.lex_state = 97, .external_lex_state = 2},
  [1006] = {.lex_state = 97, .external_lex_state = 2},
  [1007] = {.lex_state = 97, .external_lex_state = 2},
  [1008] = {.lex_state = 97, .external_lex_state = 2},
  [1009] = {.lex_state = 97, .external_lex_state = 2},
  [1010] = {.lex_state = 97, .external_lex_state = 2},
  [1011] = {.lex_state = 97, .external_lex_state = 2},
  [1012] = {.lex_state = 97, .external_lex_state = 2},
  [1013] = {.lex_state = 97, .external_lex_state = 2},
  [1014] = {.lex_state = 97, .external_lex_state = 2},
  [1015] = {.lex_state = 97, .external_lex_state = 2},
  [1016] = {.lex_state = 97, .external_lex_state = 2},
  [1017] = {.lex_state = 97, .external_lex_state = 2},
  [1018] = {.lex_state = 97, .external_lex_state = 2},
  [1019] = {.lex_state = 97, .external_lex_state = 2},
  [1020] = {.lex_state = 97, .external_lex_state = 2},
  [1021] = {.lex_state = 97, .external_lex_state = 2},
  [1022] = {.lex_state = 97, .external_lex_state = 2},
  [1023] = {.lex_state = 97, .external_lex_state = 2},
  [1024] = {.lex_state = 97, .external_lex_state = 2},
  [1025] = {.lex_state = 97, .external_lex_state = 2},
  [1026] = {.lex_state = 97, .external_lex_state = 2},
  [1027] = {.lex_state = 97, .external_lex_state = 2},
  [1028] = {.lex_state = 97, .external_lex_state = 2},
  [1029] = {.lex_state = 97, .external_lex_state = 9},
  [1030] = {.lex_state = 97, .external_lex_state = 2},
  [1031] = {.lex_state = 97, .external_lex_state = 2},
  [1032] = {.lex_state = 97, .external_lex_state = 2},
  [1033] = {.lex_state = 97, .external_lex_state = 2},
  [1034] = {.lex_state = 97, .external_lex_state = 2},
  [1035] = {.lex_state = 97, .external_lex_state = 2},
  [1036] = {.lex_state = 97, .external_lex_state = 2},
  [1037] = {.lex_state = 97, .external_lex_state = 2},
  [1038] = {.lex_state = 97, .external_lex_state = 2},
  [1039] = {.lex_state = 97, .external_lex_state = 2},
  [1040] = {.lex_state = 97, .external_lex_state = 2},
  [1041] = {.lex_state = 97, .external_lex_state = 2},
  [1042] = {.lex_state = 97, .external_lex_state = 2},
  [1043] = {.lex_state = 97, .external_lex_state = 2},
  [1044] = {.lex_state = 97, .external_lex_state = 2},
  [1045] = {.lex_state = 97, .external_lex_state = 2},
  [1046] = {.lex_state = 97, .external_lex_state = 2},
  [1047] = {.lex_state = 97, .external_lex_state = 9},
  [1048] = {.lex_state = 97, .external_lex_state = 9},
  [1049] = {.lex_state = 97, .external_lex_state = 9},
  [1050] = {.lex_state = 97, .external_lex_state = 9},
  [1051] = {.lex_state = 97, .external_lex_state = 9},
  [1052] = {.lex_state = 97, .external_lex_state = 9},
  [1053] = {.lex_state = 97, .external_lex_state = 9},
  [1054] = {.lex_state = 97, .external_lex_state = 9},
  [1055] = {.lex_state = 97, .external_lex_state = 9},
  [1056] = {.lex_state = 97, .external_lex_state = 9},
  [1057] = {.lex_state = 97, .external_lex_state = 9},
  [1058] = {.lex_state = 97, .external_lex_state = 9},
  [1059] = {.lex_state = 97, .external_lex_state = 9},
  [1060] = {.lex_state = 97, .external_lex_state = 9},
  [1061] = {.lex_state = 97, .external_lex_state = 9},
  [1062] = {.lex_state = 97, .external_lex_state = 9},
  [1063] = {.lex_state = 97, .external_lex_state = 9},
  [1064] = {.lex_state = 97, .external_lex_state = 9},
  [1065] = {.lex_state = 97, .external_lex_state = 9},
  [1066] = {.lex_state = 97, .external_lex_state = 9},
  [1067] = {.lex_state = 97, .external_lex_state = 9},
  [1068] = {.lex_state = 97, .external_lex_state = 9},
  [1069] = {.lex_state = 97, .external_lex_state = 9},
  [1070] = {.lex_state = 97, .external_lex_state = 9},
  [1071] = {.lex_state = 97, .external_lex_state = 9},
  [1072] = {.lex_state = 97, .external_lex_state = 9},
  [1073] = {.lex_state = 97, .external_lex_state = 9},
  [1074] = {.lex_state = 97, .external_lex_state = 9},
  [1075] = {.lex_state = 97, .external_lex_state = 9},
  [1076] = {.lex_state = 97, .external_lex_state = 9},
  [1077] = {.lex_state = 97, .external_lex_state = 9},
  [1078] = {.lex_state = 97, .external_lex_state = 9},
  [1079] = {.lex_state = 97, .external_lex_state = 9},
  [1080] = {.lex_state = 97, .external_lex_state = 9},
  [1081] = {.lex_state = 97, .external_lex_state = 9},
  [1082] = {.lex_state = 97, .external_lex_state = 9},
  [1083] = {.lex_state = 97, .external_lex_state = 9},
  [1084] = {.lex_state = 97, .external_lex_state = 9},
  [1085] = {.lex_state = 97, .external_lex_state = 9},
  [1086] = {.lex_state = 97, .external_lex_state = 9},
  [1087] = {.lex_state = 97, .external_lex_state = 9},
  [1088] = {.lex_state = 97, .external_lex_state = 9},
  [1089] = {.lex_state = 97, .external_lex_state = 9},
  [1090] = {.lex_state = 97, .external_lex_state = 9},
  [1091] = {.lex_state = 97, .external_lex_state = 9},
  [1092] = {.lex_state = 97, .external_lex_state = 9},
  [1093] = {.lex_state = 97, .external_lex_state = 9},
  [1094] = {.lex_state = 97, .external_lex_state = 9},
  [1095] = {.lex_state = 97, .external_lex_state = 9},
  [1096] = {.lex_state = 97, .external_lex_state = 9},
  [1097] = {.lex_state = 97, .external_lex_state = 9},
  [1098] = {.lex_state = 97, .external_lex_state = 9},
  [1099] = {.lex_state = 97, .external_lex_state = 9},
  [1100] = {.lex_state = 97, .external_lex_state = 9},
  [1101] = {.lex_state = 97, .external_lex_state = 9},
  [1102] = {.lex_state = 97, .external_lex_state = 9},
  [1103] = {.lex_state = 97, .external_lex_state = 9},
  [1104] = {.lex_state = 97, .external_lex_state = 9},
  [1105] = {.lex_state = 97, .external_lex_state = 9},
  [1106] = {.lex_state = 97, .external_lex_state = 9},
  [1107] = {.lex_state = 97, .external_lex_state = 9},
  [1108] = {.lex_state = 97, .external_lex_state = 9},
  [1109] = {.lex_state = 97, .external_lex_state = 9},
  [1110] = {.lex_state = 97, .external_lex_state = 9},
  [1111] = {.lex_state = 97, .external_lex_state = 9},
  [1112] = {.lex_state = 97, .external_lex_state = 9},
  [1113] = {.lex_state = 97, .external_lex_state = 9},
  [1114] = {.lex_state = 97, .external_lex_state = 9},
  [1115] = {.lex_state = 97, .external_lex_state = 9},
  [1116] = {.lex_state = 97, .external_lex_state = 9},
  [1117] = {.lex_state = 97, .external_lex_state = 9},
  [1118] = {.lex_state = 97, .external_lex_state = 9},
  [1119] = {.lex_state = 97, .external_lex_state = 9},
  [1120] = {.lex_state = 97, .external_lex_state = 9},
  [1121] = {.lex_state = 97, .external_lex_state = 9},
  [1122] = {.lex_state = 97, .external_lex_state = 9},
  [1123] = {.lex_state = 97, .external_lex_state = 9},
  [1124] = {.lex_state = 97, .external_lex_state = 9},
  [1125] = {.lex_state = 50, .external_lex_state = 10},
  [1126] = {.lex_state = 3, .external_lex_state = 10},
  [1127] = {.lex_state = 3, .external_lex_state = 9},
  [1128] = {.lex_state = 3, .external_lex_state = 9},
  [1129] = {.lex_state = 3, .external_lex_state = 9},
  [1130] = {.lex_state = 3, .external_lex_state = 9},
  [1131] = {.lex_state = 98, .external_lex_state = 14},
  [1132] = {.lex_state = 6, .external_lex_state = 15},
  [1133] = {.lex_state = 6, .external_lex_state = 15},
  [1134] = {.lex_state = 6, .external_lex_state = 15},
  [1135] = {.lex_state = 4, .external_lex_state = 16},
  [1136] = {.lex_state = 4, .external_lex_state = 16},
  [1137] = {.lex_state = 6, .external_lex_state = 15},
  [1138] = {.lex_state = 6, .external_lex_state = 15},
  [1139] = {.lex_state = 6, .external_lex_state = 17},
  [1140] = {.lex_state = 5, .external_lex_state = 15},
  [1141] = {.lex_state = 6, .external_lex_state = 17},
  [1142] = {.lex_state = 5, .external_lex_state = 15},
  [1143] = {.lex_state = 4, .external_lex_state = 14},
  [1144] = {.lex_state = 4, .external_lex_state = 18},
  [1145] = {.lex_state = 4, .external_lex_state = 18},
  [1146] = {.lex_state = 5, .external_lex_state = 15},
  [1147] = {.lex_state = 5, .external_lex_state = 15},
  [1148] = {.lex_state = 5, .external_lex_state = 15},
  [1149] = {.lex_state = 4, .external_lex_state = 19},
  [1150] = {.lex_state = 98, .external_lex_state = 14},
  [1151] = {.lex_state = 4, .external_lex_state = 19},
  [1152] = {.lex_state = 4, .external_lex_state = 19},
  [1153] = {.lex_state = 4, .external_lex_state = 18},
  [1154] = {.lex_state = 5, .external_lex_state = 15},
  [1155] = {.lex_state = 5, .external_lex_state = 15},
  [1156] = {.lex_state = 5, .external_lex_state = 15},
  [1157] = {.lex_state = 5, .external_lex_state = 15},
  [1158] = {.lex_state = 4, .external_lex_state = 18},
  [1159] = {.lex_state = 6, .external_lex_state = 15},
  [1160] = {.lex_state = 5, .external_lex_state = 15},
  [1161] = {.lex_state = 4, .external_lex_state = 18},
  [1162] = {.lex_state = 5, .external_lex_state = 15},
  [1163] = {.lex_state = 5, .external_lex_state = 15},
  [1164] = {.lex_state = 4, .external_lex_state = 18},
  [1165] = {.lex_state = 5, .external_lex_state = 15},
  [1166] = {.lex_state = 5, .external_lex_state = 15},
  [1167] = {.lex_state = 4, .external_lex_state = 18},
  [1168] = {.lex_state = 4, .external_lex_state = 18},
  [1169] = {.lex_state = 5, .external_lex_state = 15},
  [1170] = {.lex_state = 4, .external_lex_state = 18},
  [1171] = {.lex_state = 4, .external_lex_state = 18},
  [1172] = {.lex_state = 6, .external_lex_state = 15},
  [1173] = {.lex_state = 5, .external_lex_state = 15},
  [1174] = {.lex_state = 4, .external_lex_state = 18},
  [1175] = {.lex_state = 5, .external_lex_state = 15},
  [1176] = {.lex_state = 5, .external_lex_state = 15},
  [1177] = {.lex_state = 5, .external_lex_state = 15},
  [1178] = {.lex_state = 5, .external_lex_state = 15},
  [1179] = {.lex_state = 6, .external_lex_state = 15},
  [1180] = {.lex_state = 5, .external_lex_state = 15},
  [1181] = {.lex_state = 5, .external_lex_state = 15},
  [1182] = {.lex_state = 4, .external_lex_state = 18},
  [1183] = {.lex_state = 5, .external_lex_state = 15},
  [1184] = {.lex_state = 5, .external_lex_state = 15},
  [1185] = {.lex_state = 4, .external_lex_state = 18},
  [1186] = {.lex_state = 4, .external_lex_state = 18},
  [1187] = {.lex_state = 5, .external_lex_state = 15},
  [1188] = {.lex_state = 4, .external_lex_state = 18},
  [1189] = {.lex_state = 4, .external_lex_state = 14},
  [1190] = {.lex_state = 4, .external_lex_state = 14},
  [1191] = {.lex_state = 4, .external_lex_state = 20},
  [1192] = {.lex_state = 4, .external_lex_state = 20},
  [1193] = {.lex_state = 5, .external_lex_state = 15},
  [1194] = {.lex_state = 4, .external_lex_state = 20},
  [1195] = {.lex_state = 5, .external_lex_state = 15},
  [1196] = {.lex_state = 5, .external_lex_state = 15},
  [1197] = {.lex_state = 4, .external_lex_state = 15},
  [1198] = {.lex_state = 9, .external_lex_state = 15},
  [1199] = {.lex_state = 4, .external_lex_state = 15},
  [1200] = {.lex_state = 9, .external_lex_state = 15},
  [1201] = {.lex_state = 8, .external_lex_state = 15},
  [1202] = {.lex_state = 4, .external_lex_state = 15},
  [1203] = {.lex_state = 4, .external_lex_state = 15},
  [1204] = {.lex_state = 10, .external_lex_state = 15},
  [1205] = {.lex_state = 4, .external_lex_state = 15},
  [1206] = {.lex_state = 4, .external_lex_state = 15},
  [1207] = {.lex_state = 8, .external_lex_state = 15},
  [1208] = {.lex_state = 4, .external_lex_state = 15},
  [1209] = {.lex_state = 98, .external_lex_state = 21},
  [1210] = {.lex_state = 4, .external_lex_state = 15},
  [1211] = {.lex_state = 4, .external_lex_state = 15},
  [1212] = {.lex_state = 4, .external_lex_state = 15},
  [1213] = {.lex_state = 11, .external_lex_state = 15},
  [1214] = {.lex_state = 11, .external_lex_state = 15},
  [1215] = {.lex_state = 9, .external_lex_state = 15},
  [1216] = {.lex_state = 8, .external_lex_state = 15},
  [1217] = {.lex_state = 4, .external_lex_state = 15},
  [1218] = {.lex_state = 4, .external_lex_state = 15},
  [1219] = {.lex_state = 10, .external_lex_state = 15},
  [1220] = {.lex_state = 10, .external_lex_state = 15},
  [1221] = {.lex_state = 4, .external_lex_state = 15},
  [1222] = {.lex_state = 4, .external_lex_state = 15},
  [1223] = {.lex_state = 9, .external_lex_state = 15},
  [1224] = {.lex_state = 4, .external_lex_state = 15},
  [1225] = {.lex_state = 4, .external_lex_state = 15},
  [1226] = {.lex_state = 10, .external_lex_state = 15},
  [1227] = {.lex_state = 8, .external_lex_state = 15},
  [1228] = {.lex_state = 4, .external_lex_state = 15},
  [1229] = {.lex_state = 10, .external_lex_state = 15},
  [1230] = {.lex_state = 4, .external_lex_state = 15},
  [1231] = {.lex_state = 4, .external_lex_state = 15},
  [1232] = {.lex_state = 4, .external_lex_state = 14},
  [1233] = {.lex_state = 4, .external_lex_state = 15},
  [1234] = {.lex_state = 4, .external_lex_state = 15},
  [1235] = {.lex_state = 4, .external_lex_state = 15},
  [1236] = {.lex_state = 4, .external_lex_state = 15},
  [1237] = {.lex_state = 4, .external_lex_state = 15},
  [1238] = {.lex_state = 4, .external_lex_state = 15},
  [1239] = {.lex_state = 4, .external_lex_state = 15},
  [1240] = {.lex_state = 4, .external_lex_state = 15},
  [1241] = {.lex_state = 4, .external_lex_state = 15},
  [1242] = {.lex_state = 4, .external_lex_state = 15},
  [1243] = {.lex_state = 4, .external_lex_state = 15},
  [1244] = {.lex_state = 4, .external_lex_state = 15},
  [1245] = {.lex_state = 4, .external_lex_state = 15},
  [1246] = {.lex_state = 4, .external_lex_state = 15},
  [1247] = {.lex_state = 4, .external_lex_state = 15},
  [1248] = {.lex_state = 4, .external_lex_state = 15},
  [1249] = {.lex_state = 4, .external_lex_state = 15},
  [1250] = {.lex_state = 4, .external_lex_state = 15},
  [1251] = {.lex_state = 4, .external_lex_state = 15},
  [1252] = {.lex_state = 4, .external_lex_state = 15},
  [1253] = {.lex_state = 4, .external_lex_state = 15},
  [1254] = {.lex_state = 4, .external_lex_state = 15},
  [1255] = {.lex_state = 4, .external_lex_state = 15},
  [1256] = {.lex_state = 4, .external_lex_state = 15},
  [1257] = {.lex_state = 4, .external_lex_state = 15},
  [1258] = {.lex_state = 4, .external_lex_state = 15},
  [1259] = {.lex_state = 4, .external_lex_state = 15},
  [1260] = {.lex_state = 4, .external_lex_state = 15},
  [1261] = {.lex_state = 4, .external_lex_state = 15},
  [1262] = {.lex_state = 4, .external_lex_state = 15},
  [1263] = {.lex_state = 4, .external_lex_state = 15},
  [1264] = {.lex_state = 4, .external_lex_state = 15},
  [1265] = {.lex_state = 4, .external_lex_state = 15},
  [1266] = {.lex_state = 4, .external_lex_state = 15},
  [1267] = {.lex_state = 4, .external_lex_state = 15},
  [1268] = {.lex_state = 4, .external_lex_state = 15},
  [1269] = {.lex_state = 4, .external_lex_state = 15},
  [1270] = {.lex_state = 4, .external_lex_state = 15},
  [1271] = {.lex_state = 4, .external_lex_state = 15},
  [1272] = {.lex_state = 4, .external_lex_state = 15},
  [1273] = {.lex_state = 4, .external_lex_state = 15},
  [1274] = {.lex_state = 4, .external_lex_state = 15},
  [1275] = {.lex_state = 4, .external_lex_state = 15},
  [1276] = {.lex_state = 4, .external_lex_state = 15},
  [1277] = {.lex_state = 4, .external_lex_state = 15},
  [1278] = {.lex_state = 4, .external_lex_state = 15},
  [1279] = {.lex_state = 4, .external_lex_state = 15},
  [1280] = {.lex_state = 4, .external_lex_state = 15},
  [1281] = {.lex_state = 4, .external_lex_state = 15},
  [1282] = {.lex_state = 4, .external_lex_state = 15},
  [1283] = {.lex_state = 6, .external_lex_state = 15},
  [1284] = {.lex_state = 4, .external_lex_state = 15},
  [1285] = {.lex_state = 4, .external_lex_state = 15},
  [1286] = {.lex_state = 4, .external_lex_state = 15},
  [1287] = {.lex_state = 4, .external_lex_state = 15},
  [1288] = {.lex_state = 4, .external_lex_state = 15},
  [1289] = {.lex_state = 4, .external_lex_state = 15},
  [1290] = {.lex_state = 4, .external_lex_state = 15},
  [1291] = {.lex_state = 4, .external_lex_state = 15},
  [1292] = {.lex_state = 4, .external_lex_state = 15},
  [1293] = {.lex_state = 4, .external_lex_state = 15},
  [1294] = {.lex_state = 4, .external_lex_state = 15},
  [1295] = {.lex_state = 4, .external_lex_state = 15},
  [1296] = {.lex_state = 4, .external_lex_state = 15},
  [1297] = {.lex_state = 4, .external_lex_state = 15},
  [1298] = {.lex_state = 4, .external_lex_state = 15},
  [1299] = {.lex_state = 4, .external_lex_state = 15},
  [1300] = {.lex_state = 4, .external_lex_state = 15},
  [1301] = {.lex_state = 4, .external_lex_state = 15},
  [1302] = {.lex_state = 4, .external_lex_state = 15},
  [1303] = {.lex_state = 6, .external_lex_state = 15},
  [1304] = {.lex_state = 4, .external_lex_state = 15},
  [1305] = {.lex_state = 4, .external_lex_state = 15},
  [1306] = {.lex_state = 4, .external_lex_state = 15},
  [1307] = {.lex_state = 4, .external_lex_state = 15},
  [1308] = {.lex_state = 4, .external_lex_state = 15},
  [1309] = {.lex_state = 4, .external_lex_state = 15},
  [1310] = {.lex_state = 4, .external_lex_state = 15},
  [1311] = {.lex_state = 4, .external_lex_state = 15},
  [1312] = {.lex_state = 4, .external_lex_state = 15},
  [1313] = {.lex_state = 4, .external_lex_state = 15},
  [1314] = {.lex_state = 4, .external_lex_state = 15},
  [1315] = {.lex_state = 4, .external_lex_state = 15},
  [1316] = {.lex_state = 4, .external_lex_state = 15},
  [1317] = {.lex_state = 4, .external_lex_state = 15},
  [1318] = {.lex_state = 4, .external_lex_state = 15},
  [1319] = {.lex_state = 4, .external_lex_state = 15},
  [1320] = {.lex_state = 4, .external_lex_state = 15},
  [1321] = {.lex_state = 4, .external_lex_state = 15},
  [1322] = {.lex_state = 4, .external_lex_state = 15},
  [1323] = {.lex_state = 4, .external_lex_state = 15},
  [1324] = {.lex_state = 4, .external_lex_state = 15},
  [1325] = {.lex_state = 4, .external_lex_state = 15},
  [1326] = {.lex_state = 4, .external_lex_state = 15},
  [1327] = {.lex_state = 4, .external_lex_state = 15},
  [1328] = {.lex_state = 4, .external_lex_state = 15},
  [1329] = {.lex_state = 4, .external_lex_state = 15},
  [1330] = {.lex_state = 6, .external_lex_state = 15},
  [1331] = {.lex_state = 4, .external_lex_state = 15},
  [1332] = {.lex_state = 4, .external_lex_state = 15},
  [1333] = {.lex_state = 4, .external_lex_state = 15},
  [1334] = {.lex_state = 4, .external_lex_state = 15},
  [1335] = {.lex_state = 4, .external_lex_state = 15},
  [1336] = {.lex_state = 4, .external_lex_state = 15},
  [1337] = {.lex_state = 4, .external_lex_state = 15},
  [1338] = {.lex_state = 4, .external_lex_state = 15},
  [1339] = {.lex_state = 4, .external_lex_state = 15},
  [1340] = {.lex_state = 4, .external_lex_state = 15},
  [1341] = {.lex_state = 4, .external_lex_state = 15},
  [1342] = {.lex_state = 4, .external_lex_state = 15},
  [1343] = {.lex_state = 4, .external_lex_state = 15},
  [1344] = {.lex_state = 4, .external_lex_state = 15},
  [1345] = {.lex_state = 4, .external_lex_state = 15},
  [1346] = {.lex_state = 4, .external_lex_state = 15},
  [1347] = {.lex_state = 4, .external_lex_state = 15},
  [1348] = {.lex_state = 4, .external_lex_state = 15},
  [1349] = {.lex_state = 4, .external_lex_state = 15},
  [1350] = {.lex_state = 4, .external_lex_state = 15},
  [1351] = {.lex_state = 4, .external_lex_state = 15},
  [1352] = {.lex_state = 4, .external_lex_state = 15},
  [1353] = {.lex_state = 4, .external_lex_state = 15},
  [1354] = {.lex_state = 4, .external_lex_state = 15},
  [1355] = {.lex_state = 4, .external_lex_state = 15},
  [1356] = {.lex_state = 4, .external_lex_state = 15},
  [1357] = {.lex_state = 4, .external_lex_state = 15},
  [1358] = {.lex_state = 4, .external_lex_state = 15},
  [1359] = {.lex_state = 4, .external_lex_state = 15},
  [1360] = {.lex_state = 4, .external_lex_state = 15},
  [1361] = {.lex_state = 4, .external_lex_state = 15},
  [1362] = {.lex_state = 4, .external_lex_state = 15},
  [1363] = {.lex_state = 4, .external_lex_state = 15},
  [1364] = {.lex_state = 6, .external_lex_state = 15},
  [1365] = {.lex_state = 6, .external_lex_state = 15},
  [1366] = {.lex_state = 6, .external_lex_state = 22},
  [1367] = {.lex_state = 4, .external_lex_state = 23},
  [1368] = {.lex_state = 4, .external_lex_state = 23},
  [1369] = {.lex_state = 6, .external_lex_state = 17},
  [1370] = {.lex_state = 6, .external_lex_state = 17},
  [1371] = {.lex_state = 6, .external_lex_state = 22},
  [1372] = {.lex_state = 6, .external_lex_state = 22},
  [1373] = {.lex_state = 4, .external_lex_state = 21},
  [1374] = {.lex_state = 6, .external_lex_state = 15},
  [1375] = {.lex_state = 6, .external_lex_state = 22},
  [1376] = {.lex_state = 6, .external_lex_state = 22},
  [1377] = {.lex_state = 6, .external_lex_state = 15},
  [1378] = {.lex_state = 6, .external_lex_state = 15},
  [1379] = {.lex_state = 53, .external_lex_state = 24},
  [1380] = {.lex_state = 5, .external_lex_state = 22},
  [1381] = {.lex_state = 5, .external_lex_state = 22},
  [1382] = {.lex_state = 6, .external_lex_state = 25},
  [1383] = {.lex_state = 5, .external_lex_state = 22},
  [1384] = {.lex_state = 4, .external_lex_state = 26},
  [1385] = {.lex_state = 4, .external_lex_state = 26},
  [1386] = {.lex_state = 5, .external_lex_state = 22},
  [1387] = {.lex_state = 4, .external_lex_state = 26},
  [1388] = {.lex_state = 5, .external_lex_state = 22},
  [1389] = {.lex_state = 5, .external_lex_state = 22},
  [1390] = {.lex_state = 5, .external_lex_state = 22},
  [1391] = {.lex_state = 5, .external_lex_state = 22},
  [1392] = {.lex_state = 5, .external_lex_state = 22},
  [1393] = {.lex_state = 5, .external_lex_state = 22},
  [1394] = {.lex_state = 6, .external_lex_state = 25},
  [1395] = {.lex_state = 53, .external_lex_state = 21},
  [1396] = {.lex_state = 5, .external_lex_state = 22},
  [1397] = {.lex_state = 5, .external_lex_state = 22},
  [1398] = {.lex_state = 5, .external_lex_state = 22},
  [1399] = {.lex_state = 5, .external_lex_state = 22},
  [1400] = {.lex_state = 5, .external_lex_state = 22},
  [1401] = {.lex_state = 5, .external_lex_state = 22},
  [1402] = {.lex_state = 5, .external_lex_state = 22},
  [1403] = {.lex_state = 5, .external_lex_state = 22},
  [1404] = {.lex_state = 5, .external_lex_state = 22},
  [1405] = {.lex_state = 53, .external_lex_state = 21},
  [1406] = {.lex_state = 5, .external_lex_state = 22},
  [1407] = {.lex_state = 5, .external_lex_state = 22},
  [1408] = {.lex_state = 5, .external_lex_state = 22},
  [1409] = {.lex_state = 5, .external_lex_state = 22},
  [1410] = {.lex_state = 5, .external_lex_state = 22},
  [1411] = {.lex_state = 5, .external_lex_state = 22},
  [1412] = {.lex_state = 5, .external_lex_state = 22},
  [1413] = {.lex_state = 4, .external_lex_state = 15},
  [1414] = {.lex_state = 6, .external_lex_state = 22},
  [1415] = {.lex_state = 4, .external_lex_state = 21},
  [1416] = {.lex_state = 5, .external_lex_state = 22},
  [1417] = {.lex_state = 4, .external_lex_state = 15},
  [1418] = {.lex_state = 4, .external_lex_state = 27},
  [1419] = {.lex_state = 4, .external_lex_state = 15},
  [1420] = {.lex_state = 6, .external_lex_state = 22},
  [1421] = {.lex_state = 4, .external_lex_state = 15},
  [1422] = {.lex_state = 5, .external_lex_state = 22},
  [1423] = {.lex_state = 4, .external_lex_state = 27},
  [1424] = {.lex_state = 4, .external_lex_state = 27},
  [1425] = {.lex_state = 4, .external_lex_state = 15},
  [1426] = {.lex_state = 4, .external_lex_state = 15},
  [1427] = {.lex_state = 6, .external_lex_state = 22},
  [1428] = {.lex_state = 4, .external_lex_state = 21},
  [1429] = {.lex_state = 56, .external_lex_state = 28},
  [1430] = {.lex_state = 4, .external_lex_state = 21},
  [1431] = {.lex_state = 4, .external_lex_state = 15},
  [1432] = {.lex_state = 4, .external_lex_state = 15},
  [1433] = {.lex_state = 4, .external_lex_state = 15},
  [1434] = {.lex_state = 4, .external_lex_state = 15},
  [1435] = {.lex_state = 4, .external_lex_state = 15},
  [1436] = {.lex_state = 4, .external_lex_state = 15},
  [1437] = {.lex_state = 10, .external_lex_state = 22},
  [1438] = {.lex_state = 4, .external_lex_state = 15},
  [1439] = {.lex_state = 10, .external_lex_state = 22},
  [1440] = {.lex_state = 4, .external_lex_state = 15},
  [1441] = {.lex_state = 4, .external_lex_state = 22},
  [1442] = {.lex_state = 4, .external_lex_state = 22},
  [1443] = {.lex_state = 4, .external_lex_state = 15},
  [1444] = {.lex_state = 4, .external_lex_state = 22},
  [1445] = {.lex_state = 4, .external_lex_state = 22},
  [1446] = {.lex_state = 11, .external_lex_state = 22},
  [1447] = {.lex_state = 10, .external_lex_state = 22},
  [1448] = {.lex_state = 4, .external_lex_state = 22},
  [1449] = {.lex_state = 4, .external_lex_state = 22},
  [1450] = {.lex_state = 4, .external_lex_state = 22},
  [1451] = {.lex_state = 4, .external_lex_state = 22},
  [1452] = {.lex_state = 11, .external_lex_state = 22},
  [1453] = {.lex_state = 4, .external_lex_state = 15},
  [1454] = {.lex_state = 10, .external_lex_state = 22},
  [1455] = {.lex_state = 9, .external_lex_state = 22},
  [1456] = {.lex_state = 8, .external_lex_state = 22},
  [1457] = {.lex_state = 4, .external_lex_state = 15},
  [1458] = {.lex_state = 4, .external_lex_state = 15},
  [1459] = {.lex_state = 4, .external_lex_state = 15},
  [1460] = {.lex_state = 4, .external_lex_state = 15},
  [1461] = {.lex_state = 4, .external_lex_state = 15},
  [1462] = {.lex_state = 4, .external_lex_state = 22},
  [1463] = {.lex_state = 4, .external_lex_state = 22},
  [1464] = {.lex_state = 9, .external_lex_state = 22},
  [1465] = {.lex_state = 9, .external_lex_state = 22},
  [1466] = {.lex_state = 8, .external_lex_state = 22},
  [1467] = {.lex_state = 8, .external_lex_state = 22},
  [1468] = {.lex_state = 9, .external_lex_state = 22},
  [1469] = {.lex_state = 8, .external_lex_state = 22},
  [1470] = {.lex_state = 56, .external_lex_state = 28},
  [1471] = {.lex_state = 10, .external_lex_state = 22},
  [1472] = {.lex_state = 4, .external_lex_state = 15},
  [1473] = {.lex_state = 4, .external_lex_state = 15},
  [1474] = {.lex_state = 56, .external_lex_state = 28},
  [1475] = {.lex_state = 4, .external_lex_state = 15},
  [1476] = {.lex_state = 4, .external_lex_state = 15},
  [1477] = {.lex_state = 4, .external_lex_state = 15},
  [1478] = {.lex_state = 4, .external_lex_state = 22},
  [1479] = {.lex_state = 4, .external_lex_state = 15},
  [1480] = {.lex_state = 4, .external_lex_state = 15},
  [1481] = {.lex_state = 4, .external_lex_state = 15},
  [1482] = {.lex_state = 4, .external_lex_state = 15},
  [1483] = {.lex_state = 54, .external_lex_state = 29},
  [1484] = {.lex_state = 54, .external_lex_state = 29},
  [1485] = {.lex_state = 4, .external_lex_state = 15},
  [1486] = {.lex_state = 4, .external_lex_state = 15},
  [1487] = {.lex_state = 4, .external_lex_state = 15},
  [1488] = {.lex_state = 4, .external_lex_state = 22},
  [1489] = {.lex_state = 4, .external_lex_state = 22},
  [1490] = {.lex_state = 4, .external_lex_state = 22},
  [1491] = {.lex_state = 4, .external_lex_state = 22},
  [1492] = {.lex_state = 4, .external_lex_state = 22},
  [1493] = {.lex_state = 4, .external_lex_state = 22},
  [1494] = {.lex_state = 4, .external_lex_state = 22},
  [1495] = {.lex_state = 4, .external_lex_state = 22},
  [1496] = {.lex_state = 4, .external_lex_state = 22},
  [1497] = {.lex_state = 4, .external_lex_state = 22},
  [1498] = {.lex_state = 4, .external_lex_state = 22},
  [1499] = {.lex_state = 4, .external_lex_state = 22},
  [1500] = {.lex_state = 4, .external_lex_state = 22},
  [1501] = {.lex_state = 4, .external_lex_state = 22},
  [1502] = {.lex_state = 4, .external_lex_state = 22},
  [1503] = {.lex_state = 4, .external_lex_state = 22},
  [1504] = {.lex_state = 4, .external_lex_state = 22},
  [1505] = {.lex_state = 4, .external_lex_state = 22},
  [1506] = {.lex_state = 4, .external_lex_state = 22},
  [1507] = {.lex_state = 4, .external_lex_state = 22},
  [1508] = {.lex_state = 4, .external_lex_state = 22},
  [1509] = {.lex_state = 4, .external_lex_state = 22},
  [1510] = {.lex_state = 4, .external_lex_state = 22},
  [1511] = {.lex_state = 4, .external_lex_state = 22},
  [1512] = {.lex_state = 4, .external_lex_state = 22},
  [1513] = {.lex_state = 4, .external_lex_state = 22},
  [1514] = {.lex_state = 4, .external_lex_state = 22},
  [1515] = {.lex_state = 4, .external_lex_state = 22},
  [1516] = {.lex_state = 4, .external_lex_state = 22},
  [1517] = {.lex_state = 4, .external_lex_state = 22},
  [1518] = {.lex_state = 4, .external_lex_state = 22},
  [1519] = {.lex_state = 4, .external_lex_state = 22},
  [1520] = {.lex_state = 4, .external_lex_state = 22},
  [1521] = {.lex_state = 4, .external_lex_state = 22},
  [1522] = {.lex_state = 4, .external_lex_state = 22},
  [1523] = {.lex_state = 4, .external_lex_state = 22},
  [1524] = {.lex_state = 4, .external_lex_state = 22},
  [1525] = {.lex_state = 4, .external_lex_state = 22},
  [1526] = {.lex_state = 4, .external_lex_state = 22},
  [1527] = {.lex_state = 4, .external_lex_state = 22},
  [1528] = {.lex_state = 4, .external_lex_state = 22},
  [1529] = {.lex_state = 4, .external_lex_state = 22},
  [1530] = {.lex_state = 56, .external_lex_state = 22},
  [1531] = {.lex_state = 4, .external_lex_state = 22},
  [1532] = {.lex_state = 4, .external_lex_state = 22},
  [1533] = {.lex_state = 4, .external_lex_state = 22},
  [1534] = {.lex_state = 4, .external_lex_state = 22},
  [1535] = {.lex_state = 4, .external_lex_state = 22},
  [1536] = {.lex_state = 4, .external_lex_state = 22},
  [1537] = {.lex_state = 4, .external_lex_state = 22},
  [1538] = {.lex_state = 4, .external_lex_state = 22},
  [1539] = {.lex_state = 4, .external_lex_state = 22},
  [1540] = {.lex_state = 4, .external_lex_state = 22},
  [1541] = {.lex_state = 56, .external_lex_state = 22},
  [1542] = {.lex_state = 4, .external_lex_state = 22},
  [1543] = {.lex_state = 4, .external_lex_state = 22},
  [1544] = {.lex_state = 4, .external_lex_state = 22},
  [1545] = {.lex_state = 4, .external_lex_state = 22},
  [1546] = {.lex_state = 56, .external_lex_state = 22},
  [1547] = {.lex_state = 4, .external_lex_state = 22},
  [1548] = {.lex_state = 56, .external_lex_state = 28},
  [1549] = {.lex_state = 56, .external_lex_state = 28},
  [1550] = {.lex_state = 4, .external_lex_state = 22},
  [1551] = {.lex_state = 4, .external_lex_state = 22},
  [1552] = {.lex_state = 4, .external_lex_state = 22},
  [1553] = {.lex_state = 4, .external_lex_state = 22},
  [1554] = {.lex_state = 4, .external_lex_state = 22},
  [1555] = {.lex_state = 4, .external_lex_state = 22},
  [1556] = {.lex_state = 4, .external_lex_state = 22},
  [1557] = {.lex_state = 4, .external_lex_state = 22},
  [1558] = {.lex_state = 4, .external_lex_state = 22},
  [1559] = {.lex_state = 4, .external_lex_state = 22},
  [1560] = {.lex_state = 4, .external_lex_state = 22},
  [1561] = {.lex_state = 4, .external_lex_state = 22},
  [1562] = {.lex_state = 4, .external_lex_state = 22},
  [1563] = {.lex_state = 4, .external_lex_state = 22},
  [1564] = {.lex_state = 4, .external_lex_state = 22},
  [1565] = {.lex_state = 4, .external_lex_state = 22},
  [1566] = {.lex_state = 4, .external_lex_state = 22},
  [1567] = {.lex_state = 4, .external_lex_state = 22},
  [1568] = {.lex_state = 4, .external_lex_state = 22},
  [1569] = {.lex_state = 4, .external_lex_state = 22},
  [1570] = {.lex_state = 4, .external_lex_state = 22},
  [1571] = {.lex_state = 4, .external_lex_state = 22},
  [1572] = {.lex_state = 4, .external_lex_state = 22},
  [1573] = {.lex_state = 4, .external_lex_state = 22},
  [1574] = {.lex_state = 4, .external_lex_state = 22},
  [1575] = {.lex_state = 4, .external_lex_state = 22},
  [1576] = {.lex_state = 4, .external_lex_state = 22},
  [1577] = {.lex_state = 4, .external_lex_state = 22},
  [1578] = {.lex_state = 4, .external_lex_state = 22},
  [1579] = {.lex_state = 4, .external_lex_state = 22},
  [1580] = {.lex_state = 4, .external_lex_state = 22},
  [1581] = {.lex_state = 4, .external_lex_state = 22},
  [1582] = {.lex_state = 4, .external_lex_state = 22},
  [1583] = {.lex_state = 4, .external_lex_state = 22},
  [1584] = {.lex_state = 4, .external_lex_state = 22},
  [1585] = {.lex_state = 4, .external_lex_state = 22},
  [1586] = {.lex_state = 4, .external_lex_state = 22},
  [1587] = {.lex_state = 4, .external_lex_state = 22},
  [1588] = {.lex_state = 4, .external_lex_state = 22},
  [1589] = {.lex_state = 4, .external_lex_state = 22},
  [1590] = {.lex_state = 4, .external_lex_state = 22},
  [1591] = {.lex_state = 4, .external_lex_state = 22},
  [1592] = {.lex_state = 4, .external_lex_state = 22},
  [1593] = {.lex_state = 4, .external_lex_state = 22},
  [1594] = {.lex_state = 4, .external_lex_state = 22},
  [1595] = {.lex_state = 4, .external_lex_state = 22},
  [1596] = {.lex_state = 4, .external_lex_state = 22},
  [1597] = {.lex_state = 4, .external_lex_state = 22},
  [1598] = {.lex_state = 4, .external_lex_state = 22},
  [1599] = {.lex_state = 4, .external_lex_state = 22},
  [1600] = {.lex_state = 4, .external_lex_state = 22},
  [1601] = {.lex_state = 4, .external_lex_state = 22},
  [1602] = {.lex_state = 4, .external_lex_state = 22},
  [1603] = {.lex_state = 4, .external_lex_state = 22},
  [1604] = {.lex_state = 4, .external_lex_state = 22},
  [1605] = {.lex_state = 4, .external_lex_state = 22},
  [1606] = {.lex_state = 4, .external_lex_state = 22},
  [1607] = {.lex_state = 4, .external_lex_state = 22},
  [1608] = {.lex_state = 4, .external_lex_state = 22},
  [1609] = {.lex_state = 4, .external_lex_state = 22},
  [1610] = {.lex_state = 54, .external_lex_state = 23},
  [1611] = {.lex_state = 54, .external_lex_state = 23},
  [1612] = {.lex_state = 4, .external_lex_state = 22},
  [1613] = {.lex_state = 4, .external_lex_state = 22},
  [1614] = {.lex_state = 4, .external_lex_state = 22},
  [1615] = {.lex_state = 4, .external_lex_state = 22},
  [1616] = {.lex_state = 56, .external_lex_state = 22},
  [1617] = {.lex_state = 56, .external_lex_state = 22},
  [1618] = {.lex_state = 56, .external_lex_state = 30},
  [1619] = {.lex_state = 4, .external_lex_state = 31},
  [1620] = {.lex_state = 56, .external_lex_state = 30},
  [1621] = {.lex_state = 4, .external_lex_state = 22},
  [1622] = {.lex_state = 4, .external_lex_state = 22},
  [1623] = {.lex_state = 4, .external_lex_state = 22},
  [1624] = {.lex_state = 4, .external_lex_state = 22},
  [1625] = {.lex_state = 56, .external_lex_state = 22},
  [1626] = {.lex_state = 4, .external_lex_state = 22},
  [1627] = {.lex_state = 4, .external_lex_state = 22},
  [1628] = {.lex_state = 4, .external_lex_state = 22},
  [1629] = {.lex_state = 55, .external_lex_state = 28},
  [1630] = {.lex_state = 4, .external_lex_state = 22},
  [1631] = {.lex_state = 4, .external_lex_state = 22},
  [1632] = {.lex_state = 56, .external_lex_state = 22},
  [1633] = {.lex_state = 4, .external_lex_state = 22},
  [1634] = {.lex_state = 4, .external_lex_state = 22},
  [1635] = {.lex_state = 4, .external_lex_state = 22},
  [1636] = {.lex_state = 4, .external_lex_state = 22},
  [1637] = {.lex_state = 54, .external_lex_state = 24},
  [1638] = {.lex_state = 4, .external_lex_state = 22},
  [1639] = {.lex_state = 55, .external_lex_state = 28},
  [1640] = {.lex_state = 54, .external_lex_state = 32},
  [1641] = {.lex_state = 55, .external_lex_state = 28},
  [1642] = {.lex_state = 54, .external_lex_state = 32},
  [1643] = {.lex_state = 56, .external_lex_state = 28},
  [1644] = {.lex_state = 55, .external_lex_state = 28},
  [1645] = {.lex_state = 55, .external_lex_state = 28},
  [1646] = {.lex_state = 55, .external_lex_state = 28},
  [1647] = {.lex_state = 55, .external_lex_state = 28},
  [1648] = {.lex_state = 56, .external_lex_state = 25},
  [1649] = {.lex_state = 54, .external_lex_state = 32},
  [1650] = {.lex_state = 55, .external_lex_state = 28},
  [1651] = {.lex_state = 56, .external_lex_state = 28},
  [1652] = {.lex_state = 55, .external_lex_state = 28},
  [1653] = {.lex_state = 55, .external_lex_state = 28},
  [1654] = {.lex_state = 56, .external_lex_state = 25},
  [1655] = {.lex_state = 55, .external_lex_state = 28},
  [1656] = {.lex_state = 55, .external_lex_state = 28},
  [1657] = {.lex_state = 55, .external_lex_state = 28},
  [1658] = {.lex_state = 55, .external_lex_state = 28},
  [1659] = {.lex_state = 55, .external_lex_state = 28},
  [1660] = {.lex_state = 55, .external_lex_state = 28},
  [1661] = {.lex_state = 55, .external_lex_state = 28},
  [1662] = {.lex_state = 55, .external_lex_state = 28},
  [1663] = {.lex_state = 55, .external_lex_state = 28},
  [1664] = {.lex_state = 55, .external_lex_state = 28},
  [1665] = {.lex_state = 55, .external_lex_state = 28},
  [1666] = {.lex_state = 55, .external_lex_state = 28},
  [1667] = {.lex_state = 55, .external_lex_state = 28},
  [1668] = {.lex_state = 55, .external_lex_state = 28},
  [1669] = {.lex_state = 55, .external_lex_state = 28},
  [1670] = {.lex_state = 56, .external_lex_state = 28},
  [1671] = {.lex_state = 54, .external_lex_state = 33},
  [1672] = {.lex_state = 55, .external_lex_state = 28},
  [1673] = {.lex_state = 54, .external_lex_state = 24},
  [1674] = {.lex_state = 55, .external_lex_state = 28},
  [1675] = {.lex_state = 55, .external_lex_state = 28},
  [1676] = {.lex_state = 56, .external_lex_state = 22},
  [1677] = {.lex_state = 54, .external_lex_state = 33},
  [1678] = {.lex_state = 56, .external_lex_state = 22},
  [1679] = {.lex_state = 54, .external_lex_state = 33},
  [1680] = {.lex_state = 54, .external_lex_state = 24},
  [1681] = {.lex_state = 56, .external_lex_state = 22},
  [1682] = {.lex_state = 54, .external_lex_state = 28},
  [1683] = {.lex_state = 61, .external_lex_state = 28},
  [1684] = {.lex_state = 54, .external_lex_state = 28},
  [1685] = {.lex_state = 54, .external_lex_state = 28},
  [1686] = {.lex_state = 54, .external_lex_state = 28},
  [1687] = {.lex_state = 59, .external_lex_state = 28},
  [1688] = {.lex_state = 59, .external_lex_state = 28},
  [1689] = {.lex_state = 54, .external_lex_state = 24},
  [1690] = {.lex_state = 54, .external_lex_state = 28},
  [1691] = {.lex_state = 54, .external_lex_state = 28},
  [1692] = {.lex_state = 60, .external_lex_state = 28},
  [1693] = {.lex_state = 54, .external_lex_state = 28},
  [1694] = {.lex_state = 60, .external_lex_state = 28},
  [1695] = {.lex_state = 54, .external_lex_state = 28},
  [1696] = {.lex_state = 59, .external_lex_state = 28},
  [1697] = {.lex_state = 61, .external_lex_state = 28},
  [1698] = {.lex_state = 61, .external_lex_state = 28},
  [1699] = {.lex_state = 54, .external_lex_state = 28},
  [1700] = {.lex_state = 59, .external_lex_state = 28},
  [1701] = {.lex_state = 54, .external_lex_state = 28},
  [1702] = {.lex_state = 60, .external_lex_state = 28},
  [1703] = {.lex_state = 54, .external_lex_state = 28},
  [1704] = {.lex_state = 54, .external_lex_state = 28},
  [1705] = {.lex_state = 54, .external_lex_state = 28},
  [1706] = {.lex_state = 61, .external_lex_state = 28},
  [1707] = {.lex_state = 54, .external_lex_state = 28},
  [1708] = {.lex_state = 54, .external_lex_state = 28},
  [1709] = {.lex_state = 54, .external_lex_state = 28},
  [1710] = {.lex_state = 57, .external_lex_state = 28},
  [1711] = {.lex_state = 54, .external_lex_state = 28},
  [1712] = {.lex_state = 57, .external_lex_state = 28},
  [1713] = {.lex_state = 54, .external_lex_state = 28},
  [1714] = {.lex_state = 54, .external_lex_state = 28},
  [1715] = {.lex_state = 54, .external_lex_state = 28},
  [1716] = {.lex_state = 54, .external_lex_state = 28},
  [1717] = {.lex_state = 61, .external_lex_state = 28},
  [1718] = {.lex_state = 54, .external_lex_state = 28},
  [1719] = {.lex_state = 54, .external_lex_state = 28},
  [1720] = {.lex_state = 60, .external_lex_state = 28},
  [1721] = {.lex_state = 54, .external_lex_state = 28},
  [1722] = {.lex_state = 54, .external_lex_state = 28},
  [1723] = {.lex_state = 54, .external_lex_state = 28},
  [1724] = {.lex_state = 54, .external_lex_state = 22},
  [1725] = {.lex_state = 54, .external_lex_state = 22},
  [1726] = {.lex_state = 54, .external_lex_state = 22},
  [1727] = {.lex_state = 54, .external_lex_state = 22},
  [1728] = {.lex_state = 54, .external_lex_state = 28},
  [1729] = {.lex_state = 54, .external_lex_state = 28},
  [1730] = {.lex_state = 54, .external_lex_state = 28},
  [1731] = {.lex_state = 54, .external_lex_state = 28},
  [1732] = {.lex_state = 54, .external_lex_state = 28},
  [1733] = {.lex_state = 54, .external_lex_state = 28},
  [1734] = {.lex_state = 54, .external_lex_state = 28},
  [1735] = {.lex_state = 54, .external_lex_state = 28},
  [1736] = {.lex_state = 54, .external_lex_state = 28},
  [1737] = {.lex_state = 54, .external_lex_state = 28},
  [1738] = {.lex_state = 54, .external_lex_state = 28},
  [1739] = {.lex_state = 54, .external_lex_state = 28},
  [1740] = {.lex_state = 54, .external_lex_state = 28},
  [1741] = {.lex_state = 54, .external_lex_state = 28},
  [1742] = {.lex_state = 54, .external_lex_state = 28},
  [1743] = {.lex_state = 54, .external_lex_state = 28},
  [1744] = {.lex_state = 54, .external_lex_state = 28},
  [1745] = {.lex_state = 54, .external_lex_state = 22},
  [1746] = {.lex_state = 54, .external_lex_state = 28},
  [1747] = {.lex_state = 54, .external_lex_state = 22},
  [1748] = {.lex_state = 54, .external_lex_state = 22},
  [1749] = {.lex_state = 54, .external_lex_state = 22},
  [1750] = {.lex_state = 54, .external_lex_state = 22},
  [1751] = {.lex_state = 54, .external_lex_state = 22},
  [1752] = {.lex_state = 54, .external_lex_state = 22},
  [1753] = {.lex_state = 54, .external_lex_state = 22},
  [1754] = {.lex_state = 54, .external_lex_state = 22},
  [1755] = {.lex_state = 54, .external_lex_state = 28},
  [1756] = {.lex_state = 54, .external_lex_state = 28},
  [1757] = {.lex_state = 54, .external_lex_state = 28},
  [1758] = {.lex_state = 54, .external_lex_state = 28},
  [1759] = {.lex_state = 54, .external_lex_state = 28},
  [1760] = {.lex_state = 54, .external_lex_state = 28},
  [1761] = {.lex_state = 54, .external_lex_state = 28},
  [1762] = {.lex_state = 54, .external_lex_state = 28},
  [1763] = {.lex_state = 54, .external_lex_state = 28},
  [1764] = {.lex_state = 54, .external_lex_state = 28},
  [1765] = {.lex_state = 54, .external_lex_state = 28},
  [1766] = {.lex_state = 54, .external_lex_state = 28},
  [1767] = {.lex_state = 54, .external_lex_state = 28},
  [1768] = {.lex_state = 54, .external_lex_state = 28},
  [1769] = {.lex_state = 54, .external_lex_state = 28},
  [1770] = {.lex_state = 54, .external_lex_state = 28},
  [1771] = {.lex_state = 54, .external_lex_state = 28},
  [1772] = {.lex_state = 54, .external_lex_state = 28},
  [1773] = {.lex_state = 54, .external_lex_state = 28},
  [1774] = {.lex_state = 54, .external_lex_state = 28},
  [1775] = {.lex_state = 54, .external_lex_state = 28},
  [1776] = {.lex_state = 54, .external_lex_state = 28},
  [1777] = {.lex_state = 54, .external_lex_state = 28},
  [1778] = {.lex_state = 54, .external_lex_state = 28},
  [1779] = {.lex_state = 54, .external_lex_state = 28},
  [1780] = {.lex_state = 54, .external_lex_state = 28},
  [1781] = {.lex_state = 54, .external_lex_state = 28},
  [1782] = {.lex_state = 54, .external_lex_state = 28},
  [1783] = {.lex_state = 54, .external_lex_state = 28},
  [1784] = {.lex_state = 54, .external_lex_state = 28},
  [1785] = {.lex_state = 54, .external_lex_state = 28},
  [1786] = {.lex_state = 54, .external_lex_state = 28},
  [1787] = {.lex_state = 54, .external_lex_state = 28},
  [1788] = {.lex_state = 54, .external_lex_state = 28},
  [1789] = {.lex_state = 54, .external_lex_state = 28},
  [1790] = {.lex_state = 54, .external_lex_state = 28},
  [1791] = {.lex_state = 54, .external_lex_state = 28},
  [1792] = {.lex_state = 54, .external_lex_state = 28},
  [1793] = {.lex_state = 54, .external_lex_state = 28},
  [1794] = {.lex_state = 54, .external_lex_state = 28},
  [1795] = {.lex_state = 54, .external_lex_state = 28},
  [1796] = {.lex_state = 54, .external_lex_state = 28},
  [1797] = {.lex_state = 54, .external_lex_state = 28},
  [1798] = {.lex_state = 54, .external_lex_state = 28},
  [1799] = {.lex_state = 54, .external_lex_state = 28},
  [1800] = {.lex_state = 54, .external_lex_state = 28},
  [1801] = {.lex_state = 54, .external_lex_state = 28},
  [1802] = {.lex_state = 54, .external_lex_state = 28},
  [1803] = {.lex_state = 54, .external_lex_state = 28},
  [1804] = {.lex_state = 54, .external_lex_state = 28},
  [1805] = {.lex_state = 54, .external_lex_state = 28},
  [1806] = {.lex_state = 54, .external_lex_state = 28},
  [1807] = {.lex_state = 54, .external_lex_state = 28},
  [1808] = {.lex_state = 54, .external_lex_state = 28},
  [1809] = {.lex_state = 54, .external_lex_state = 28},
  [1810] = {.lex_state = 54, .external_lex_state = 28},
  [1811] = {.lex_state = 54, .external_lex_state = 28},
  [1812] = {.lex_state = 54, .external_lex_state = 28},
  [1813] = {.lex_state = 54, .external_lex_state = 28},
  [1814] = {.lex_state = 54, .external_lex_state = 28},
  [1815] = {.lex_state = 54, .external_lex_state = 28},
  [1816] = {.lex_state = 54, .external_lex_state = 28},
  [1817] = {.lex_state = 54, .external_lex_state = 28},
  [1818] = {.lex_state = 54, .external_lex_state = 28},
  [1819] = {.lex_state = 54, .external_lex_state = 28},
  [1820] = {.lex_state = 54, .external_lex_state = 28},
  [1821] = {.lex_state = 54, .external_lex_state = 28},
  [1822] = {.lex_state = 54, .external_lex_state = 28},
  [1823] = {.lex_state = 54, .external_lex_state = 28},
  [1824] = {.lex_state = 54, .external_lex_state = 28},
  [1825] = {.lex_state = 54, .external_lex_state = 28},
  [1826] = {.lex_state = 54, .external_lex_state = 28},
  [1827] = {.lex_state = 54, .external_lex_state = 28},
  [1828] = {.lex_state = 54, .external_lex_state = 28},
  [1829] = {.lex_state = 54, .external_lex_state = 28},
  [1830] = {.lex_state = 54, .external_lex_state = 28},
  [1831] = {.lex_state = 54, .external_lex_state = 28},
  [1832] = {.lex_state = 54, .external_lex_state = 28},
  [1833] = {.lex_state = 54, .external_lex_state = 28},
  [1834] = {.lex_state = 54, .external_lex_state = 28},
  [1835] = {.lex_state = 54, .external_lex_state = 28},
  [1836] = {.lex_state = 54, .external_lex_state = 28},
  [1837] = {.lex_state = 54, .external_lex_state = 28},
  [1838] = {.lex_state = 54, .external_lex_state = 28},
  [1839] = {.lex_state = 54, .external_lex_state = 28},
  [1840] = {.lex_state = 54, .external_lex_state = 28},
  [1841] = {.lex_state = 54, .external_lex_state = 28},
  [1842] = {.lex_state = 54, .external_lex_state = 28},
  [1843] = {.lex_state = 54, .external_lex_state = 28},
  [1844] = {.lex_state = 54, .external_lex_state = 28},
  [1845] = {.lex_state = 54, .external_lex_state = 28},
  [1846] = {.lex_state = 54, .external_lex_state = 28},
  [1847] = {.lex_state = 54, .external_lex_state = 28},
  [1848] = {.lex_state = 54, .external_lex_state = 28},
  [1849] = {.lex_state = 54, .external_lex_state = 28},
  [1850] = {.lex_state = 54, .external_lex_state = 28},
  [1851] = {.lex_state = 54, .external_lex_state = 28},
  [1852] = {.lex_state = 54, .external_lex_state = 28},
  [1853] = {.lex_state = 54, .external_lex_state = 28},
  [1854] = {.lex_state = 54, .external_lex_state = 28},
  [1855] = {.lex_state = 54, .external_lex_state = 28},
  [1856] = {.lex_state = 54, .external_lex_state = 28},
  [1857] = {.lex_state = 54, .external_lex_state = 22},
  [1858] = {.lex_state = 54, .external_lex_state = 22},
  [1859] = {.lex_state = 54, .external_lex_state = 22},
  [1860] = {.lex_state = 54, .external_lex_state = 22},
  [1861] = {.lex_state = 54, .external_lex_state = 22},
  [1862] = {.lex_state = 54, .external_lex_state = 22},
  [1863] = {.lex_state = 54, .external_lex_state = 22},
  [1864] = {.lex_state = 54, .external_lex_state = 22},
  [1865] = {.lex_state = 54, .external_lex_state = 22},
  [1866] = {.lex_state = 54, .external_lex_state = 22},
  [1867] = {.lex_state = 54, .external_lex_state = 22},
  [1868] = {.lex_state = 54, .external_lex_state = 22},
  [1869] = {.lex_state = 54, .external_lex_state = 22},
  [1870] = {.lex_state = 54, .external_lex_state = 22},
  [1871] = {.lex_state = 54, .external_lex_state = 22},
  [1872] = {.lex_state = 54, .external_lex_state = 22},
  [1873] = {.lex_state = 54, .external_lex_state = 22},
  [1874] = {.lex_state = 54, .external_lex_state = 22},
  [1875] = {.lex_state = 54, .external_lex_state = 22},
  [1876] = {.lex_state = 54, .external_lex_state = 22},
  [1877] = {.lex_state = 54, .external_lex_state = 22},
  [1878] = {.lex_state = 54, .external_lex_state = 22},
  [1879] = {.lex_state = 54, .external_lex_state = 22},
  [1880] = {.lex_state = 54, .external_lex_state = 22},
  [1881] = {.lex_state = 54, .external_lex_state = 22},
  [1882] = {.lex_state = 54, .external_lex_state = 22},
  [1883] = {.lex_state = 54, .external_lex_state = 22},
  [1884] = {.lex_state = 54, .external_lex_state = 22},
  [1885] = {.lex_state = 54, .external_lex_state = 22},
  [1886] = {.lex_state = 54, .external_lex_state = 22},
  [1887] = {.lex_state = 54, .external_lex_state = 22},
  [1888] = {.lex_state = 54, .external_lex_state = 22},
  [1889] = {.lex_state = 54, .external_lex_state = 22},
  [1890] = {.lex_state = 54, .external_lex_state = 22},
  [1891] = {.lex_state = 54, .external_lex_state = 22},
  [1892] = {.lex_state = 54, .external_lex_state = 22},
  [1893] = {.lex_state = 54, .external_lex_state = 22},
  [1894] = {.lex_state = 54, .external_lex_state = 22},
  [1895] = {.lex_state = 54, .external_lex_state = 22},
  [1896] = {.lex_state = 54, .external_lex_state = 22},
  [1897] = {.lex_state = 54, .external_lex_state = 22},
  [1898] = {.lex_state = 54, .external_lex_state = 22},
  [1899] = {.lex_state = 54, .external_lex_state = 22},
  [1900] = {.lex_state = 54, .external_lex_state = 22},
  [1901] = {.lex_state = 54, .external_lex_state = 22},
  [1902] = {.lex_state = 54, .external_lex_state = 22},
  [1903] = {.lex_state = 54, .external_lex_state = 22},
  [1904] = {.lex_state = 54, .external_lex_state = 22},
  [1905] = {.lex_state = 54, .external_lex_state = 22},
  [1906] = {.lex_state = 54, .external_lex_state = 22},
  [1907] = {.lex_state = 54, .external_lex_state = 22},
  [1908] = {.lex_state = 54, .external_lex_state = 22},
  [1909] = {.lex_state = 54, .external_lex_state = 22},
  [1910] = {.lex_state = 54, .external_lex_state = 22},
  [1911] = {.lex_state = 54, .external_lex_state = 22},
  [1912] = {.lex_state = 54, .external_lex_state = 22},
  [1913] = {.lex_state = 54, .external_lex_state = 22},
  [1914] = {.lex_state = 54, .external_lex_state = 22},
  [1915] = {.lex_state = 54, .external_lex_state = 22},
  [1916] = {.lex_state = 54, .external_lex_state = 22},
  [1917] = {.lex_state = 54, .external_lex_state = 22},
  [1918] = {.lex_state = 54, .external_lex_state = 22},
  [1919] = {.lex_state = 54, .external_lex_state = 22},
  [1920] = {.lex_state = 54, .external_lex_state = 22},
  [1921] = {.lex_state = 54, .external_lex_state = 22},
  [1922] = {.lex_state = 54, .external_lex_state = 22},
  [1923] = {.lex_state = 54, .external_lex_state = 22},
  [1924] = {.lex_state = 54, .external_lex_state = 22},
  [1925] = {.lex_state = 54, .external_lex_state = 22},
  [1926] = {.lex_state = 54, .external_lex_state = 22},
  [1927] = {.lex_state = 54, .external_lex_state = 22},
  [1928] = {.lex_state = 54, .external_lex_state = 22},
  [1929] = {.lex_state = 54, .external_lex_state = 22},
  [1930] = {.lex_state = 54, .external_lex_state = 22},
  [1931] = {.lex_state = 54, .external_lex_state = 22},
  [1932] = {.lex_state = 54, .external_lex_state = 22},
  [1933] = {.lex_state = 54, .external_lex_state = 22},
  [1934] = {.lex_state = 54, .external_lex_state = 22},
  [1935] = {.lex_state = 54, .external_lex_state = 22},
  [1936] = {.lex_state = 54, .external_lex_state = 22},
  [1937] = {.lex_state = 54, .external_lex_state = 22},
  [1938] = {.lex_state = 54, .external_lex_state = 22},
  [1939] = {.lex_state = 54, .external_lex_state = 22},
  [1940] = {.lex_state = 54, .external_lex_state = 22},
  [1941] = {.lex_state = 54, .external_lex_state = 22},
  [1942] = {.lex_state = 54, .external_lex_state = 22},
  [1943] = {.lex_state = 54, .external_lex_state = 22},
  [1944] = {.lex_state = 54, .external_lex_state = 22},
  [1945] = {.lex_state = 54, .external_lex_state = 22},
  [1946] = {.lex_state = 54, .external_lex_state = 22},
  [1947] = {.lex_state = 54, .external_lex_state = 22},
  [1948] = {.lex_state = 54, .external_lex_state = 22},
  [1949] = {.lex_state = 54, .external_lex_state = 22},
  [1950] = {.lex_state = 54, .external_lex_state = 22},
  [1951] = {.lex_state = 54, .external_lex_state = 22},
  [1952] = {.lex_state = 54, .external_lex_state = 22},
  [1953] = {.lex_state = 54, .external_lex_state = 22},
  [1954] = {.lex_state = 54, .external_lex_state = 22},
  [1955] = {.lex_state = 54, .external_lex_state = 22},
  [1956] = {.lex_state = 54, .external_lex_state = 22},
  [1957] = {.lex_state = 54, .external_lex_state = 22},
  [1958] = {.lex_state = 54, .external_lex_state = 22},
  [1959] = {.lex_state = 54, .external_lex_state = 22},
  [1960] = {.lex_state = 54, .external_lex_state = 22},
  [1961] = {.lex_state = 54, .external_lex_state = 22},
  [1962] = {.lex_state = 54, .external_lex_state = 22},
  [1963] = {.lex_state = 54, .external_lex_state = 22},
  [1964] = {.lex_state = 54, .external_lex_state = 22},
  [1965] = {.lex_state = 54, .external_lex_state = 22},
  [1966] = {.lex_state = 54, .external_lex_state = 22},
  [1967] = {.lex_state = 54, .external_lex_state = 22},
  [1968] = {.lex_state = 54, .external_lex_state = 22},
  [1969] = {.lex_state = 54, .external_lex_state = 22},
  [1970] = {.lex_state = 54, .external_lex_state = 22},
  [1971] = {.lex_state = 54, .external_lex_state = 22},
  [1972] = {.lex_state = 54, .external_lex_state = 22},
  [1973] = {.lex_state = 54, .external_lex_state = 22},
  [1974] = {.lex_state = 54, .external_lex_state = 22},
  [1975] = {.lex_state = 54, .external_lex_state = 22},
  [1976] = {.lex_state = 54, .external_lex_state = 22},
  [1977] = {.lex_state = 54, .external_lex_state = 22},
  [1978] = {.lex_state = 54, .external_lex_state = 22},
  [1979] = {.lex_state = 54, .external_lex_state = 22},
  [1980] = {.lex_state = 54, .external_lex_state = 22},
  [1981] = {.lex_state = 54, .external_lex_state = 22},
  [1982] = {.lex_state = 54, .external_lex_state = 22},
  [1983] = {.lex_state = 54, .external_lex_state = 22},
  [1984] = {.lex_state = 54, .external_lex_state = 22},
  [1985] = {.lex_state = 14, .external_lex_state = 34},
  [1986] = {.lex_state = 14, .external_lex_state = 34},
  [1987] = {.lex_state = 14, .external_lex_state = 34},
  [1988] = {.lex_state = 14, .external_lex_state = 34},
  [1989] = {.lex_state = 14, .external_lex_state = 34},
  [1990] = {.lex_state = 14, .external_lex_state = 34},
  [1991] = {.lex_state = 14, .external_lex_state = 35},
  [1992] = {.lex_state = 14, .external_lex_state = 35},
  [1993] = {.lex_state = 14, .external_lex_state = 35},
  [1994] = {.lex_state = 14, .external_lex_state = 35},
  [1995] = {.lex_state = 14, .external_lex_state = 35},
  [1996] = {.lex_state = 14, .external_lex_state = 35},
  [1997] = {.lex_state = 14, .external_lex_state = 35},
  [1998] = {.lex_state = 14, .external_lex_state = 35},
  [1999] = {.lex_state = 14, .external_lex_state = 35},
  [2000] = {.lex_state = 14, .external_lex_state = 35},
  [2001] = {.lex_state = 14, .external_lex_state = 34},
  [2002] = {.lex_state = 14, .external_lex_state = 35},
  [2003] = {.lex_state = 14, .external_lex_state = 35},
  [2004] = {.lex_state = 14, .external_lex_state = 35},
  [2005] = {.lex_state = 14, .external_lex_state = 35},
  [2006] = {.lex_state = 14, .external_lex_state = 35},
  [2007] = {.lex_state = 14, .external_lex_state = 35},
  [2008] = {.lex_state = 14, .external_lex_state = 35},
  [2009] = {.lex_state = 14, .external_lex_state = 35},
  [2010] = {.lex_state = 14, .external_lex_state = 35},
  [2011] = {.lex_state = 14, .external_lex_state = 36},
  [2012] = {.lex_state = 14, .external_lex_state = 36},
  [2013] = {.lex_state = 14, .external_lex_state = 36},
  [2014] = {.lex_state = 14, .external_lex_state = 36},
  [2015] = {.lex_state = 14, .external_lex_state = 36},
  [2016] = {.lex_state = 14, .external_lex_state = 36},
  [2017] = {.lex_state = 14, .external_lex_state = 36},
  [2018] = {.lex_state = 14, .external_lex_state = 36},
  [2019] = {.lex_state = 14, .external_lex_state = 36},
  [2020] = {.lex_state = 14, .external_lex_state = 36},
  [2021] = {.lex_state = 14, .external_lex_state = 36},
  [2022] = {.lex_state = 14, .external_lex_state = 36},
  [2023] = {.lex_state = 14, .external_lex_state = 36},
  [2024] = {.lex_state = 14, .external_lex_state = 36},
  [2025] = {.lex_state = 14, .external_lex_state = 36},
  [2026] = {.lex_state = 14, .external_lex_state = 36},
  [2027] = {.lex_state = 14, .external_lex_state = 36},
  [2028] = {.lex_state = 14, .external_lex_state = 36},
  [2029] = {.lex_state = 14, .external_lex_state = 36},
  [2030] = {.lex_state = 14, .external_lex_state = 36},
  [2031] = {.lex_state = 14, .external_lex_state = 36},
  [2032] = {.lex_state = 14, .external_lex_state = 36},
  [2033] = {.lex_state = 14, .external_lex_state = 36},
  [2034] = {.lex_state = 14, .external_lex_state = 36},
  [2035] = {.lex_state = 14, .external_lex_state = 36},
  [2036] = {.lex_state = 14, .external_lex_state = 36},
  [2037] = {.lex_state = 14, .external_lex_state = 36},
  [2038] = {.lex_state = 14, .external_lex_state = 36},
  [2039] = {.lex_state = 14, .external_lex_state = 36},
  [2040] = {.lex_state = 14, .external_lex_state = 36},
  [2041] = {.lex_state = 14, .external_lex_state = 36},
  [2042] = {.lex_state = 14, .external_lex_state = 36},
  [2043] = {.lex_state = 14, .external_lex_state = 36},
  [2044] = {.lex_state = 14, .external_lex_state = 36},
  [2045] = {.lex_state = 14, .external_lex_state = 36},
  [2046] = {.lex_state = 14, .external_lex_state = 36},
  [2047] = {.lex_state = 14, .external_lex_state = 36},
  [2048] = {.lex_state = 14, .external_lex_state = 37},
  [2049] = {.lex_state = 14, .external_lex_state = 37},
  [2050] = {.lex_state = 14, .external_lex_state = 37},
  [2051] = {.lex_state = 13, .external_lex_state = 38},
  [2052] = {.lex_state = 13, .external_lex_state = 38},
  [2053] = {.lex_state = 13, .external_lex_state = 38},
  [2054] = {.lex_state = 14, .external_lex_state = 15},
  [2055] = {.lex_state = 13, .external_lex_state = 38},
  [2056] = {.lex_state = 13, .external_lex_state = 39},
  [2057] = {.lex_state = 14, .external_lex_state = 15},
  [2058] = {.lex_state = 13, .external_lex_state = 39},
  [2059] = {.lex_state = 13, .external_lex_state = 38},
  [2060] = {.lex_state = 13, .external_lex_state = 39},
  [2061] = {.lex_state = 13, .external_lex_state = 39},
  [2062] = {.lex_state = 13, .external_lex_state = 39},
  [2063] = {.lex_state = 13, .external_lex_state = 39},
  [2064] = {.lex_state = 13, .external_lex_state = 38},
  [2065] = {.lex_state = 13, .external_lex_state = 35},
  [2066] = {.lex_state = 13, .external_lex_state = 34},
  [2067] = {.lex_state = 13, .external_lex_state = 40},
  [2068] = {.lex_state = 13, .external_lex_state = 34},
  [2069] = {.lex_state = 13, .external_lex_state = 34},
  [2070] = {.lex_state = 67, .external_lex_state = 41},
  [2071] = {.lex_state = 67, .external_lex_state = 41},
  [2072] = {.lex_state = 13, .external_lex_state = 40},
  [2073] = {.lex_state = 13, .external_lex_state = 35},
  [2074] = {.lex_state = 13, .external_lex_state = 35},
  [2075] = {.lex_state = 13, .external_lex_state = 40},
  [2076] = {.lex_state = 13, .external_lex_state = 34},
  [2077] = {.lex_state = 13, .external_lex_state = 35},
  [2078] = {.lex_state = 13, .external_lex_state = 34},
  [2079] = {.lex_state = 13, .external_lex_state = 34},
  [2080] = {.lex_state = 13, .external_lex_state = 40},
  [2081] = {.lex_state = 13, .external_lex_state = 35},
  [2082] = {.lex_state = 13, .external_lex_state = 35},
  [2083] = {.lex_state = 13, .external_lex_state = 34},
  [2084] = {.lex_state = 13, .external_lex_state = 35},
  [2085] = {.lex_state = 13, .external_lex_state = 34},
  [2086] = {.lex_state = 13, .external_lex_state = 35},
  [2087] = {.lex_state = 13, .external_lex_state = 35},
  [2088] = {.lex_state = 13, .external_lex_state = 40},
  [2089] = {.lex_state = 13, .external_lex_state = 34},
  [2090] = {.lex_state = 13, .external_lex_state = 35},
  [2091] = {.lex_state = 13, .external_lex_state = 35},
  [2092] = {.lex_state = 13, .external_lex_state = 34},
  [2093] = {.lex_state = 13, .external_lex_state = 40},
  [2094] = {.lex_state = 67, .external_lex_state = 41},
  [2095] = {.lex_state = 67, .external_lex_state = 41},
  [2096] = {.lex_state = 13, .external_lex_state = 34},
  [2097] = {.lex_state = 13, .external_lex_state = 42},
  [2098] = {.lex_state = 13, .external_lex_state = 36},
  [2099] = {.lex_state = 13, .external_lex_state = 36},
  [2100] = {.lex_state = 13, .external_lex_state = 36},
  [2101] = {.lex_state = 13, .external_lex_state = 36},
  [2102] = {.lex_state = 13, .external_lex_state = 36},
  [2103] = {.lex_state = 13, .external_lex_state = 36},
  [2104] = {.lex_state = 13, .external_lex_state = 36},
  [2105] = {.lex_state = 13, .external_lex_state = 36},
  [2106] = {.lex_state = 13, .external_lex_state = 42},
  [2107] = {.lex_state = 13, .external_lex_state = 42},
  [2108] = {.lex_state = 13, .external_lex_state = 42},
  [2109] = {.lex_state = 13, .external_lex_state = 42},
  [2110] = {.lex_state = 13, .external_lex_state = 36},
  [2111] = {.lex_state = 13, .external_lex_state = 42},
  [2112] = {.lex_state = 13, .external_lex_state = 36},
  [2113] = {.lex_state = 13, .external_lex_state = 36},
  [2114] = {.lex_state = 14, .external_lex_state = 15},
  [2115] = {.lex_state = 13, .external_lex_state = 37},
  [2116] = {.lex_state = 14, .external_lex_state = 15},
  [2117] = {.lex_state = 13, .external_lex_state = 37},
  [2118] = {.lex_state = 13, .external_lex_state = 37},
  [2119] = {.lex_state = 13, .external_lex_state = 37},
  [2120] = {.lex_state = 14, .external_lex_state = 15},
  [2121] = {.lex_state = 14, .external_lex_state = 15},
  [2122] = {.lex_state = 13, .external_lex_state = 37},
  [2123] = {.lex_state = 13, .external_lex_state = 37},
  [2124] = {.lex_state = 14, .external_lex_state = 15},
  [2125] = {.lex_state = 14, .external_lex_state = 15},
  [2126] = {.lex_state = 14, .external_lex_state = 15},
  [2127] = {.lex_state = 13, .external_lex_state = 37},
  [2128] = {.lex_state = 14, .external_lex_state = 15},
  [2129] = {.lex_state = 13, .external_lex_state = 37},
  [2130] = {.lex_state = 13, .external_lex_state = 37},
  [2131] = {.lex_state = 13, .external_lex_state = 37},
  [2132] = {.lex_state = 14, .external_lex_state = 15},
  [2133] = {.lex_state = 13, .external_lex_state = 37},
  [2134] = {.lex_state = 66, .external_lex_state = 43},
  [2135] = {.lex_state = 66, .external_lex_state = 43},
  [2136] = {.lex_state = 66, .external_lex_state = 44},
  [2137] = {.lex_state = 66, .external_lex_state = 43},
  [2138] = {.lex_state = 13, .external_lex_state = 38},
  [2139] = {.lex_state = 66, .external_lex_state = 43},
  [2140] = {.lex_state = 66, .external_lex_state = 43},
  [2141] = {.lex_state = 64, .external_lex_state = 22},
  [2142] = {.lex_state = 66, .external_lex_state = 43},
  [2143] = {.lex_state = 66, .external_lex_state = 44},
  [2144] = {.lex_state = 66, .external_lex_state = 43},
  [2145] = {.lex_state = 66, .external_lex_state = 43},
  [2146] = {.lex_state = 13, .external_lex_state = 39},
  [2147] = {.lex_state = 13, .external_lex_state = 38},
  [2148] = {.lex_state = 66, .external_lex_state = 43},
  [2149] = {.lex_state = 66, .external_lex_state = 43},
  [2150] = {.lex_state = 64, .external_lex_state = 22},
  [2151] = {.lex_state = 64, .external_lex_state = 22},
  [2152] = {.lex_state = 66, .external_lex_state = 43},
  [2153] = {.lex_state = 66, .external_lex_state = 43},
  [2154] = {.lex_state = 13, .external_lex_state = 39},
  [2155] = {.lex_state = 66, .external_lex_state = 43},
  [2156] = {.lex_state = 14, .external_lex_state = 45},
  [2157] = {.lex_state = 66, .external_lex_state = 22},
  [2158] = {.lex_state = 66, .external_lex_state = 22},
  [2159] = {.lex_state = 14, .external_lex_state = 45},
  [2160] = {.lex_state = 62, .external_lex_state = 22},
  [2161] = {.lex_state = 66, .external_lex_state = 22},
  [2162] = {.lex_state = 66, .external_lex_state = 22},
  [2163] = {.lex_state = 13, .external_lex_state = 34},
  [2164] = {.lex_state = 66, .external_lex_state = 22},
  [2165] = {.lex_state = 13, .external_lex_state = 34},
  [2166] = {.lex_state = 14, .external_lex_state = 45},
  [2167] = {.lex_state = 66, .external_lex_state = 22},
  [2168] = {.lex_state = 13, .external_lex_state = 40},
  [2169] = {.lex_state = 66, .external_lex_state = 22},
  [2170] = {.lex_state = 66, .external_lex_state = 22},
  [2171] = {.lex_state = 14, .external_lex_state = 45},
  [2172] = {.lex_state = 66, .external_lex_state = 22},
  [2173] = {.lex_state = 13, .external_lex_state = 34},
  [2174] = {.lex_state = 13, .external_lex_state = 35},
  [2175] = {.lex_state = 13, .external_lex_state = 34},
  [2176] = {.lex_state = 66, .external_lex_state = 22},
  [2177] = {.lex_state = 14, .external_lex_state = 45},
  [2178] = {.lex_state = 13, .external_lex_state = 35},
  [2179] = {.lex_state = 66, .external_lex_state = 22},
  [2180] = {.lex_state = 13, .external_lex_state = 34},
  [2181] = {.lex_state = 66, .external_lex_state = 22},
  [2182] = {.lex_state = 66, .external_lex_state = 22},
  [2183] = {.lex_state = 14, .external_lex_state = 45},
  [2184] = {.lex_state = 66, .external_lex_state = 22},
  [2185] = {.lex_state = 62, .external_lex_state = 22},
  [2186] = {.lex_state = 13, .external_lex_state = 34},
  [2187] = {.lex_state = 66, .external_lex_state = 22},
  [2188] = {.lex_state = 13, .external_lex_state = 35},
  [2189] = {.lex_state = 13, .external_lex_state = 35},
  [2190] = {.lex_state = 13, .external_lex_state = 40},
  [2191] = {.lex_state = 13, .external_lex_state = 34},
  [2192] = {.lex_state = 13, .external_lex_state = 35},
  [2193] = {.lex_state = 66, .external_lex_state = 22},
  [2194] = {.lex_state = 66, .external_lex_state = 22},
  [2195] = {.lex_state = 13, .external_lex_state = 34},
  [2196] = {.lex_state = 13, .external_lex_state = 34},
  [2197] = {.lex_state = 66, .external_lex_state = 22},
  [2198] = {.lex_state = 66, .external_lex_state = 22},
  [2199] = {.lex_state = 13, .external_lex_state = 34},
  [2200] = {.lex_state = 66, .external_lex_state = 22},
  [2201] = {.lex_state = 62, .external_lex_state = 22},
  [2202] = {.lex_state = 66, .external_lex_state = 22},
  [2203] = {.lex_state = 13, .external_lex_state = 34},
  [2204] = {.lex_state = 13, .external_lex_state = 35},
  [2205] = {.lex_state = 13, .external_lex_state = 35},
  [2206] = {.lex_state = 13, .external_lex_state = 35},
  [2207] = {.lex_state = 13, .external_lex_state = 35},
  [2208] = {.lex_state = 13, .external_lex_state = 35},
  [2209] = {.lex_state = 13, .external_lex_state = 35},
  [2210] = {.lex_state = 14, .external_lex_state = 36},
  [2211] = {.lex_state = 14, .external_lex_state = 36},
  [2212] = {.lex_state = 13, .external_lex_state = 22},
  [2213] = {.lex_state = 14, .external_lex_state = 36},
  [2214] = {.lex_state = 14, .external_lex_state = 15},
  [2215] = {.lex_state = 13, .external_lex_state = 36},
  [2216] = {.lex_state = 71, .external_lex_state = 28},
  [2217] = {.lex_state = 13, .external_lex_state = 22},
  [2218] = {.lex_state = 13, .external_lex_state = 36},
  [2219] = {.lex_state = 65, .external_lex_state = 22},
  [2220] = {.lex_state = 13, .external_lex_state = 22},
  [2221] = {.lex_state = 13, .external_lex_state = 22},
  [2222] = {.lex_state = 65, .external_lex_state = 22},
  [2223] = {.lex_state = 71, .external_lex_state = 28},
  [2224] = {.lex_state = 13, .external_lex_state = 36},
  [2225] = {.lex_state = 14, .external_lex_state = 15},
  [2226] = {.lex_state = 13, .external_lex_state = 42},
  [2227] = {.lex_state = 13, .external_lex_state = 42},
  [2228] = {.lex_state = 13, .external_lex_state = 36},
  [2229] = {.lex_state = 14, .external_lex_state = 36},
  [2230] = {.lex_state = 13, .external_lex_state = 36},
  [2231] = {.lex_state = 71, .external_lex_state = 28},
  [2232] = {.lex_state = 13, .external_lex_state = 22},
  [2233] = {.lex_state = 14, .external_lex_state = 36},
  [2234] = {.lex_state = 14, .external_lex_state = 36},
  [2235] = {.lex_state = 13, .external_lex_state = 22},
  [2236] = {.lex_state = 14, .external_lex_state = 36},
  [2237] = {.lex_state = 14, .external_lex_state = 36},
  [2238] = {.lex_state = 13, .external_lex_state = 22},
  [2239] = {.lex_state = 14, .external_lex_state = 45},
  [2240] = {.lex_state = 71, .external_lex_state = 28},
  [2241] = {.lex_state = 13, .external_lex_state = 36},
  [2242] = {.lex_state = 13, .external_lex_state = 36},
  [2243] = {.lex_state = 14, .external_lex_state = 36},
  [2244] = {.lex_state = 14, .external_lex_state = 36},
  [2245] = {.lex_state = 13, .external_lex_state = 36},
  [2246] = {.lex_state = 13, .external_lex_state = 36},
  [2247] = {.lex_state = 14, .external_lex_state = 36},
  [2248] = {.lex_state = 13, .external_lex_state = 36},
  [2249] = {.lex_state = 14, .external_lex_state = 36},
  [2250] = {.lex_state = 13, .external_lex_state = 36},
  [2251] = {.lex_state = 14, .external_lex_state = 36},
  [2252] = {.lex_state = 65, .external_lex_state = 22},
  [2253] = {.lex_state = 71, .external_lex_state = 46},
  [2254] = {.lex_state = 71, .external_lex_state = 46},
  [2255] = {.lex_state = 13, .external_lex_state = 37},
  [2256] = {.lex_state = 14, .external_lex_state = 34},
  [2257] = {.lex_state = 14, .external_lex_state = 34},
  [2258] = {.lex_state = 14, .external_lex_state = 34},
  [2259] = {.lex_state = 14, .external_lex_state = 34},
  [2260] = {.lex_state = 71, .external_lex_state = 46},
  [2261] = {.lex_state = 71, .external_lex_state = 46},
  [2262] = {.lex_state = 98, .external_lex_state = 31},
  [2263] = {.lex_state = 14, .external_lex_state = 34},
  [2264] = {.lex_state = 71, .external_lex_state = 46},
  [2265] = {.lex_state = 71, .external_lex_state = 46},
  [2266] = {.lex_state = 98, .external_lex_state = 31},
  [2267] = {.lex_state = 14, .external_lex_state = 35},
  [2268] = {.lex_state = 13, .external_lex_state = 37},
  [2269] = {.lex_state = 14, .external_lex_state = 35},
  [2270] = {.lex_state = 14, .external_lex_state = 35},
  [2271] = {.lex_state = 71, .external_lex_state = 46},
  [2272] = {.lex_state = 71, .external_lex_state = 46},
  [2273] = {.lex_state = 98, .external_lex_state = 31},
  [2274] = {.lex_state = 13, .external_lex_state = 37},
  [2275] = {.lex_state = 13, .external_lex_state = 37},
  [2276] = {.lex_state = 98, .external_lex_state = 31},
  [2277] = {.lex_state = 13, .external_lex_state = 37},
  [2278] = {.lex_state = 13, .external_lex_state = 37},
  [2279] = {.lex_state = 13, .external_lex_state = 37},
  [2280] = {.lex_state = 14, .external_lex_state = 35},
  [2281] = {.lex_state = 14, .external_lex_state = 34},
  [2282] = {.lex_state = 14, .external_lex_state = 34},
  [2283] = {.lex_state = 98, .external_lex_state = 31},
  [2284] = {.lex_state = 71, .external_lex_state = 46},
  [2285] = {.lex_state = 71, .external_lex_state = 46},
  [2286] = {.lex_state = 98, .external_lex_state = 31},
  [2287] = {.lex_state = 71, .external_lex_state = 46},
  [2288] = {.lex_state = 14, .external_lex_state = 35},
  [2289] = {.lex_state = 14, .external_lex_state = 35},
  [2290] = {.lex_state = 71, .external_lex_state = 46},
  [2291] = {.lex_state = 71, .external_lex_state = 46},
  [2292] = {.lex_state = 98, .external_lex_state = 31},
  [2293] = {.lex_state = 98, .external_lex_state = 31},
  [2294] = {.lex_state = 71, .external_lex_state = 46},
  [2295] = {.lex_state = 14, .external_lex_state = 35},
  [2296] = {.lex_state = 71, .external_lex_state = 46},
  [2297] = {.lex_state = 71, .external_lex_state = 46},
  [2298] = {.lex_state = 98, .external_lex_state = 31},
  [2299] = {.lex_state = 14, .external_lex_state = 35},
  [2300] = {.lex_state = 69, .external_lex_state = 28},
  [2301] = {.lex_state = 14, .external_lex_state = 34},
  [2302] = {.lex_state = 71, .external_lex_state = 46},
  [2303] = {.lex_state = 14, .external_lex_state = 34},
  [2304] = {.lex_state = 14, .external_lex_state = 35},
  [2305] = {.lex_state = 98, .external_lex_state = 31},
  [2306] = {.lex_state = 14, .external_lex_state = 35},
  [2307] = {.lex_state = 71, .external_lex_state = 46},
  [2308] = {.lex_state = 71, .external_lex_state = 46},
  [2309] = {.lex_state = 71, .external_lex_state = 46},
  [2310] = {.lex_state = 71, .external_lex_state = 46},
  [2311] = {.lex_state = 98, .external_lex_state = 31},
  [2312] = {.lex_state = 71, .external_lex_state = 46},
  [2313] = {.lex_state = 71, .external_lex_state = 46},
  [2314] = {.lex_state = 71, .external_lex_state = 46},
  [2315] = {.lex_state = 69, .external_lex_state = 28},
  [2316] = {.lex_state = 98, .external_lex_state = 31},
  [2317] = {.lex_state = 71, .external_lex_state = 46},
  [2318] = {.lex_state = 14, .external_lex_state = 35},
  [2319] = {.lex_state = 71, .external_lex_state = 46},
  [2320] = {.lex_state = 71, .external_lex_state = 46},
  [2321] = {.lex_state = 98, .external_lex_state = 31},
  [2322] = {.lex_state = 14, .external_lex_state = 35},
  [2323] = {.lex_state = 71, .external_lex_state = 46},
  [2324] = {.lex_state = 14, .external_lex_state = 34},
  [2325] = {.lex_state = 98, .external_lex_state = 31},
  [2326] = {.lex_state = 13, .external_lex_state = 37},
  [2327] = {.lex_state = 13, .external_lex_state = 37},
  [2328] = {.lex_state = 98, .external_lex_state = 31},
  [2329] = {.lex_state = 71, .external_lex_state = 46},
  [2330] = {.lex_state = 13, .external_lex_state = 37},
  [2331] = {.lex_state = 71, .external_lex_state = 46},
  [2332] = {.lex_state = 13, .external_lex_state = 37},
  [2333] = {.lex_state = 98, .external_lex_state = 31},
  [2334] = {.lex_state = 14, .external_lex_state = 34},
  [2335] = {.lex_state = 14, .external_lex_state = 34},
  [2336] = {.lex_state = 14, .external_lex_state = 36},
  [2337] = {.lex_state = 98, .external_lex_state = 21},
  [2338] = {.lex_state = 98, .external_lex_state = 21},
  [2339] = {.lex_state = 71, .external_lex_state = 23},
  [2340] = {.lex_state = 71, .external_lex_state = 23},
  [2341] = {.lex_state = 14, .external_lex_state = 45},
  [2342] = {.lex_state = 14, .external_lex_state = 36},
  [2343] = {.lex_state = 71, .external_lex_state = 47},
  [2344] = {.lex_state = 71, .external_lex_state = 47},
  [2345] = {.lex_state = 69, .external_lex_state = 22},
  [2346] = {.lex_state = 71, .external_lex_state = 47},
  [2347] = {.lex_state = 71, .external_lex_state = 47},
  [2348] = {.lex_state = 71, .external_lex_state = 47},
  [2349] = {.lex_state = 14, .external_lex_state = 36},
  [2350] = {.lex_state = 69, .external_lex_state = 28},
  [2351] = {.lex_state = 14, .external_lex_state = 36},
  [2352] = {.lex_state = 14, .external_lex_state = 36},
  [2353] = {.lex_state = 69, .external_lex_state = 28},
  [2354] = {.lex_state = 71, .external_lex_state = 47},
  [2355] = {.lex_state = 71, .external_lex_state = 28},
  [2356] = {.lex_state = 69, .external_lex_state = 22},
  [2357] = {.lex_state = 71, .external_lex_state = 47},
  [2358] = {.lex_state = 14, .external_lex_state = 36},
  [2359] = {.lex_state = 14, .external_lex_state = 36},
  [2360] = {.lex_state = 71, .external_lex_state = 28},
  [2361] = {.lex_state = 14, .external_lex_state = 45},
  [2362] = {.lex_state = 14, .external_lex_state = 45},
  [2363] = {.lex_state = 98, .external_lex_state = 21},
  [2364] = {.lex_state = 98, .external_lex_state = 21},
  [2365] = {.lex_state = 14, .external_lex_state = 36},
  [2366] = {.lex_state = 14, .external_lex_state = 45},
  [2367] = {.lex_state = 14, .external_lex_state = 36},
  [2368] = {.lex_state = 14, .external_lex_state = 36},
  [2369] = {.lex_state = 98, .external_lex_state = 21},
  [2370] = {.lex_state = 14, .external_lex_state = 36},
  [2371] = {.lex_state = 71, .external_lex_state = 23},
  [2372] = {.lex_state = 71, .external_lex_state = 23},
  [2373] = {.lex_state = 14, .external_lex_state = 36},
  [2374] = {.lex_state = 71, .external_lex_state = 28},
  [2375] = {.lex_state = 14, .external_lex_state = 36},
  [2376] = {.lex_state = 71, .external_lex_state = 47},
  [2377] = {.lex_state = 14, .external_lex_state = 36},
  [2378] = {.lex_state = 71, .external_lex_state = 47},
  [2379] = {.lex_state = 71, .external_lex_state = 47},
  [2380] = {.lex_state = 98, .external_lex_state = 21},
  [2381] = {.lex_state = 63, .external_lex_state = 31},
  [2382] = {.lex_state = 14, .external_lex_state = 37},
  [2383] = {.lex_state = 14, .external_lex_state = 15},
  [2384] = {.lex_state = 70, .external_lex_state = 31},
  [2385] = {.lex_state = 14, .external_lex_state = 37},
  [2386] = {.lex_state = 63, .external_lex_state = 31},
  [2387] = {.lex_state = 14, .external_lex_state = 37},
  [2388] = {.lex_state = 14, .external_lex_state = 15},
  [2389] = {.lex_state = 63, .external_lex_state = 31},
  [2390] = {.lex_state = 63, .external_lex_state = 31},
  [2391] = {.lex_state = 70, .external_lex_state = 31},
  [2392] = {.lex_state = 70, .external_lex_state = 31},
  [2393] = {.lex_state = 14, .external_lex_state = 15},
  [2394] = {.lex_state = 71, .external_lex_state = 47},
  [2395] = {.lex_state = 71, .external_lex_state = 47},
  [2396] = {.lex_state = 63, .external_lex_state = 31},
  [2397] = {.lex_state = 14, .external_lex_state = 15},
  [2398] = {.lex_state = 70, .external_lex_state = 31},
  [2399] = {.lex_state = 63, .external_lex_state = 31},
  [2400] = {.lex_state = 63, .external_lex_state = 31},
  [2401] = {.lex_state = 70, .external_lex_state = 31},
  [2402] = {.lex_state = 14, .external_lex_state = 37},
  [2403] = {.lex_state = 70, .external_lex_state = 31},
  [2404] = {.lex_state = 14, .external_lex_state = 37},
  [2405] = {.lex_state = 63, .external_lex_state = 31},
  [2406] = {.lex_state = 13, .external_lex_state = 15},
  [2407] = {.lex_state = 14, .external_lex_state = 37},
  [2408] = {.lex_state = 14, .external_lex_state = 37},
  [2409] = {.lex_state = 70, .external_lex_state = 31},
  [2410] = {.lex_state = 63, .external_lex_state = 31},
  [2411] = {.lex_state = 70, .external_lex_state = 31},
  [2412] = {.lex_state = 70, .external_lex_state = 31},
  [2413] = {.lex_state = 63, .external_lex_state = 31},
  [2414] = {.lex_state = 13, .external_lex_state = 15},
  [2415] = {.lex_state = 14, .external_lex_state = 37},
  [2416] = {.lex_state = 63, .external_lex_state = 31},
  [2417] = {.lex_state = 14, .external_lex_state = 37},
  [2418] = {.lex_state = 70, .external_lex_state = 31},
  [2419] = {.lex_state = 14, .external_lex_state = 37},
  [2420] = {.lex_state = 63, .external_lex_state = 31},
  [2421] = {.lex_state = 70, .external_lex_state = 31},
  [2422] = {.lex_state = 70, .external_lex_state = 31},
  [2423] = {.lex_state = 63, .external_lex_state = 31},
  [2424] = {.lex_state = 71, .external_lex_state = 47},
  [2425] = {.lex_state = 63, .external_lex_state = 31},
  [2426] = {.lex_state = 70, .external_lex_state = 31},
  [2427] = {.lex_state = 63, .external_lex_state = 31},
  [2428] = {.lex_state = 70, .external_lex_state = 31},
  [2429] = {.lex_state = 70, .external_lex_state = 31},
  [2430] = {.lex_state = 14, .external_lex_state = 37},
  [2431] = {.lex_state = 71, .external_lex_state = 30},
  [2432] = {.lex_state = 63, .external_lex_state = 21},
  [2433] = {.lex_state = 98, .external_lex_state = 28},
  [2434] = {.lex_state = 63, .external_lex_state = 21},
  [2435] = {.lex_state = 98, .external_lex_state = 46},
  [2436] = {.lex_state = 98, .external_lex_state = 46},
  [2437] = {.lex_state = 70, .external_lex_state = 21},
  [2438] = {.lex_state = 70, .external_lex_state = 21},
  [2439] = {.lex_state = 71, .external_lex_state = 30},
  [2440] = {.lex_state = 98, .external_lex_state = 28},
  [2441] = {.lex_state = 98, .external_lex_state = 48},
  [2442] = {.lex_state = 69, .external_lex_state = 22},
  [2443] = {.lex_state = 98, .external_lex_state = 28},
  [2444] = {.lex_state = 98, .external_lex_state = 48},
  [2445] = {.lex_state = 13, .external_lex_state = 15},
  [2446] = {.lex_state = 98, .external_lex_state = 48},
  [2447] = {.lex_state = 69, .external_lex_state = 22},
  [2448] = {.lex_state = 13, .external_lex_state = 15},
  [2449] = {.lex_state = 98, .external_lex_state = 48},
  [2450] = {.lex_state = 98, .external_lex_state = 48},
  [2451] = {.lex_state = 69, .external_lex_state = 22},
  [2452] = {.lex_state = 98, .external_lex_state = 48},
  [2453] = {.lex_state = 71, .external_lex_state = 28},
  [2454] = {.lex_state = 98, .external_lex_state = 23},
  [2455] = {.lex_state = 98, .external_lex_state = 48},
  [2456] = {.lex_state = 98, .external_lex_state = 23},
  [2457] = {.lex_state = 13, .external_lex_state = 15},
  [2458] = {.lex_state = 71, .external_lex_state = 49},
  [2459] = {.lex_state = 98, .external_lex_state = 28},
  [2460] = {.lex_state = 98, .external_lex_state = 23},
  [2461] = {.lex_state = 98, .external_lex_state = 28},
  [2462] = {.lex_state = 98, .external_lex_state = 48},
  [2463] = {.lex_state = 98, .external_lex_state = 48},
  [2464] = {.lex_state = 98, .external_lex_state = 48},
  [2465] = {.lex_state = 71, .external_lex_state = 28},
  [2466] = {.lex_state = 69, .external_lex_state = 22},
  [2467] = {.lex_state = 69, .external_lex_state = 28},
  [2468] = {.lex_state = 98, .external_lex_state = 28},
  [2469] = {.lex_state = 71, .external_lex_state = 28},
  [2470] = {.lex_state = 98, .external_lex_state = 28},
  [2471] = {.lex_state = 98, .external_lex_state = 48},
  [2472] = {.lex_state = 13, .external_lex_state = 22},
  [2473] = {.lex_state = 98, .external_lex_state = 23},
  [2474] = {.lex_state = 71, .external_lex_state = 49},
  [2475] = {.lex_state = 98, .external_lex_state = 23},
  [2476] = {.lex_state = 69, .external_lex_state = 22},
  [2477] = {.lex_state = 98, .external_lex_state = 23},
  [2478] = {.lex_state = 13, .external_lex_state = 22},
  [2479] = {.lex_state = 98, .external_lex_state = 28},
  [2480] = {.lex_state = 98, .external_lex_state = 48},
  [2481] = {.lex_state = 98, .external_lex_state = 31},
  [2482] = {.lex_state = 98, .external_lex_state = 31},
  [2483] = {.lex_state = 71, .external_lex_state = 47},
  [2484] = {.lex_state = 98, .external_lex_state = 31},
  [2485] = {.lex_state = 98, .external_lex_state = 50},
  [2486] = {.lex_state = 98, .external_lex_state = 50},
  [2487] = {.lex_state = 62, .external_lex_state = 31},
  [2488] = {.lex_state = 98, .external_lex_state = 31},
  [2489] = {.lex_state = 98, .external_lex_state = 31},
  [2490] = {.lex_state = 98, .external_lex_state = 50},
  [2491] = {.lex_state = 98, .external_lex_state = 50},
  [2492] = {.lex_state = 98, .external_lex_state = 50},
  [2493] = {.lex_state = 98, .external_lex_state = 50},
  [2494] = {.lex_state = 68, .external_lex_state = 22},
  [2495] = {.lex_state = 98, .external_lex_state = 31},
  [2496] = {.lex_state = 68, .external_lex_state = 22},
  [2497] = {.lex_state = 68, .external_lex_state = 22},
  [2498] = {.lex_state = 62, .external_lex_state = 31},
  [2499] = {.lex_state = 98, .external_lex_state = 31},
  [2500] = {.lex_state = 98, .external_lex_state = 31},
  [2501] = {.lex_state = 98, .external_lex_state = 47},
  [2502] = {.lex_state = 98, .external_lex_state = 31},
  [2503] = {.lex_state = 98, .external_lex_state = 47},
  [2504] = {.lex_state = 62, .external_lex_state = 31},
  [2505] = {.lex_state = 98, .external_lex_state = 50},
  [2506] = {.lex_state = 98, .external_lex_state = 31},
  [2507] = {.lex_state = 98, .external_lex_state = 31},
  [2508] = {.lex_state = 98, .external_lex_state = 50},
  [2509] = {.lex_state = 98, .external_lex_state = 31},
  [2510] = {.lex_state = 62, .external_lex_state = 31},
  [2511] = {.lex_state = 98, .external_lex_state = 31},
  [2512] = {.lex_state = 98, .external_lex_state = 31},
  [2513] = {.lex_state = 45, .external_lex_state = 41},
  [2514] = {.lex_state = 98, .external_lex_state = 50},
  [2515] = {.lex_state = 98, .external_lex_state = 50},
  [2516] = {.lex_state = 98, .external_lex_state = 31},
  [2517] = {.lex_state = 98, .external_lex_state = 31},
  [2518] = {.lex_state = 62, .external_lex_state = 31},
  [2519] = {.lex_state = 98, .external_lex_state = 28},
  [2520] = {.lex_state = 98, .external_lex_state = 50},
  [2521] = {.lex_state = 98, .external_lex_state = 50},
  [2522] = {.lex_state = 62, .external_lex_state = 31},
  [2523] = {.lex_state = 98, .external_lex_state = 50},
  [2524] = {.lex_state = 98, .external_lex_state = 50},
  [2525] = {.lex_state = 98, .external_lex_state = 50},
  [2526] = {.lex_state = 98, .external_lex_state = 31},
  [2527] = {.lex_state = 98, .external_lex_state = 31},
  [2528] = {.lex_state = 62, .external_lex_state = 31},
  [2529] = {.lex_state = 98, .external_lex_state = 50},
  [2530] = {.lex_state = 98, .external_lex_state = 22},
  [2531] = {.lex_state = 98, .external_lex_state = 31},
  [2532] = {.lex_state = 98, .external_lex_state = 31},
  [2533] = {.lex_state = 98, .external_lex_state = 31},
  [2534] = {.lex_state = 98, .external_lex_state = 31},
  [2535] = {.lex_state = 98, .external_lex_state = 31},
  [2536] = {.lex_state = 98, .external_lex_state = 50},
  [2537] = {.lex_state = 98, .external_lex_state = 50},
  [2538] = {.lex_state = 98, .external_lex_state = 50},
  [2539] = {.lex_state = 98, .external_lex_state = 50},
  [2540] = {.lex_state = 98, .external_lex_state = 50},
  [2541] = {.lex_state = 98, .external_lex_state = 31},
  [2542] = {.lex_state = 62, .external_lex_state = 31},
  [2543] = {.lex_state = 98, .external_lex_state = 22},
  [2544] = {.lex_state = 68, .external_lex_state = 22},
  [2545] = {.lex_state = 98, .external_lex_state = 50},
  [2546] = {.lex_state = 98, .external_lex_state = 50},
  [2547] = {.lex_state = 68, .external_lex_state = 22},
  [2548] = {.lex_state = 62, .external_lex_state = 31},
  [2549] = {.lex_state = 98, .external_lex_state = 31},
  [2550] = {.lex_state = 98, .external_lex_state = 31},
  [2551] = {.lex_state = 68, .external_lex_state = 22},
  [2552] = {.lex_state = 98, .external_lex_state = 50},
  [2553] = {.lex_state = 98, .external_lex_state = 50},
  [2554] = {.lex_state = 68, .external_lex_state = 22},
  [2555] = {.lex_state = 68, .external_lex_state = 22},
  [2556] = {.lex_state = 98, .external_lex_state = 31},
  [2557] = {.lex_state = 68, .external_lex_state = 22},
  [2558] = {.lex_state = 98, .external_lex_state = 50},
  [2559] = {.lex_state = 98, .external_lex_state = 50},
  [2560] = {.lex_state = 98, .external_lex_state = 50},
  [2561] = {.lex_state = 62, .external_lex_state = 31},
  [2562] = {.lex_state = 98, .external_lex_state = 47},
  [2563] = {.lex_state = 98, .external_lex_state = 31},
  [2564] = {.lex_state = 98, .external_lex_state = 47},
  [2565] = {.lex_state = 98, .external_lex_state = 50},
  [2566] = {.lex_state = 98, .external_lex_state = 31},
  [2567] = {.lex_state = 98, .external_lex_state = 28},
  [2568] = {.lex_state = 98, .external_lex_state = 31},
  [2569] = {.lex_state = 98, .external_lex_state = 50},
  [2570] = {.lex_state = 62, .external_lex_state = 31},
  [2571] = {.lex_state = 98, .external_lex_state = 31},
  [2572] = {.lex_state = 98, .external_lex_state = 31},
  [2573] = {.lex_state = 98, .external_lex_state = 31},
  [2574] = {.lex_state = 98, .external_lex_state = 31},
  [2575] = {.lex_state = 71, .external_lex_state = 47},
  [2576] = {.lex_state = 62, .external_lex_state = 31},
  [2577] = {.lex_state = 62, .external_lex_state = 31},
  [2578] = {.lex_state = 98, .external_lex_state = 50},
  [2579] = {.lex_state = 98, .external_lex_state = 31},
  [2580] = {.lex_state = 98, .external_lex_state = 31},
  [2581] = {.lex_state = 98, .external_lex_state = 50},
  [2582] = {.lex_state = 98, .external_lex_state = 22},
  [2583] = {.lex_state = 98, .external_lex_state = 50},
  [2584] = {.lex_state = 62, .external_lex_state = 31},
  [2585] = {.lex_state = 98, .external_lex_state = 50},
  [2586] = {.lex_state = 98, .external_lex_state = 50},
  [2587] = {.lex_state = 98, .external_lex_state = 31},
  [2588] = {.lex_state = 98, .external_lex_state = 50},
  [2589] = {.lex_state = 98, .external_lex_state = 31},
  [2590] = {.lex_state = 98, .external_lex_state = 50},
  [2591] = {.lex_state = 98, .external_lex_state = 50},
  [2592] = {.lex_state = 98, .external_lex_state = 50},
  [2593] = {.lex_state = 98, .external_lex_state = 50},
  [2594] = {.lex_state = 98, .external_lex_state = 31},
  [2595] = {.lex_state = 98, .external_lex_state = 50},
  [2596] = {.lex_state = 98, .external_lex_state = 31},
  [2597] = {.lex_state = 98, .external_lex_state = 50},
  [2598] = {.lex_state = 98, .external_lex_state = 31},
  [2599] = {.lex_state = 98, .external_lex_state = 50},
  [2600] = {.lex_state = 68, .external_lex_state = 22},
  [2601] = {.lex_state = 98, .external_lex_state = 22},
  [2602] = {.lex_state = 98, .external_lex_state = 48},
  [2603] = {.lex_state = 98, .external_lex_state = 50},
  [2604] = {.lex_state = 68, .external_lex_state = 22},
  [2605] = {.lex_state = 68, .external_lex_state = 22},
  [2606] = {.lex_state = 98, .external_lex_state = 50},
  [2607] = {.lex_state = 98, .external_lex_state = 50},
  [2608] = {.lex_state = 98, .external_lex_state = 50},
  [2609] = {.lex_state = 98, .external_lex_state = 31},
  [2610] = {.lex_state = 98, .external_lex_state = 31},
  [2611] = {.lex_state = 98, .external_lex_state = 50},
  [2612] = {.lex_state = 98, .external_lex_state = 50},
  [2613] = {.lex_state = 98, .external_lex_state = 50},
  [2614] = {.lex_state = 98, .external_lex_state = 50},
  [2615] = {.lex_state = 98, .external_lex_state = 50},
  [2616] = {.lex_state = 98, .external_lex_state = 31},
  [2617] = {.lex_state = 98, .external_lex_state = 31},
  [2618] = {.lex_state = 62, .external_lex_state = 31},
  [2619] = {.lex_state = 98, .external_lex_state = 50},
  [2620] = {.lex_state = 98, .external_lex_state = 50},
  [2621] = {.lex_state = 71, .external_lex_state = 47},
  [2622] = {.lex_state = 98, .external_lex_state = 50},
  [2623] = {.lex_state = 98, .external_lex_state = 50},
  [2624] = {.lex_state = 98, .external_lex_state = 50},
  [2625] = {.lex_state = 98, .external_lex_state = 50},
  [2626] = {.lex_state = 45, .external_lex_state = 41},
  [2627] = {.lex_state = 98, .external_lex_state = 50},
  [2628] = {.lex_state = 98, .external_lex_state = 50},
  [2629] = {.lex_state = 98, .external_lex_state = 31},
  [2630] = {.lex_state = 98, .external_lex_state = 50},
  [2631] = {.lex_state = 98, .external_lex_state = 22},
  [2632] = {.lex_state = 98, .external_lex_state = 51},
  [2633] = {.lex_state = 14, .external_lex_state = 22},
  [2634] = {.lex_state = 62, .external_lex_state = 22},
  [2635] = {.lex_state = 62, .external_lex_state = 22},
  [2636] = {.lex_state = 98, .external_lex_state = 51},
  [2637] = {.lex_state = 62, .external_lex_state = 21},
  [2638] = {.lex_state = 98, .external_lex_state = 21},
  [2639] = {.lex_state = 98, .external_lex_state = 21},
  [2640] = {.lex_state = 98, .external_lex_state = 21},
  [2641] = {.lex_state = 98, .external_lex_state = 51},
  [2642] = {.lex_state = 98, .external_lex_state = 51},
  [2643] = {.lex_state = 98, .external_lex_state = 51},
  [2644] = {.lex_state = 62, .external_lex_state = 22},
  [2645] = {.lex_state = 98, .external_lex_state = 21},
  [2646] = {.lex_state = 14, .external_lex_state = 22},
  [2647] = {.lex_state = 98, .external_lex_state = 51},
  [2648] = {.lex_state = 98, .external_lex_state = 51},
  [2649] = {.lex_state = 98, .external_lex_state = 51},
  [2650] = {.lex_state = 98, .external_lex_state = 21},
  [2651] = {.lex_state = 98, .external_lex_state = 21},
  [2652] = {.lex_state = 98, .external_lex_state = 50},
  [2653] = {.lex_state = 14, .external_lex_state = 22},
  [2654] = {.lex_state = 98, .external_lex_state = 51},
  [2655] = {.lex_state = 98, .external_lex_state = 51},
  [2656] = {.lex_state = 98, .external_lex_state = 51},
  [2657] = {.lex_state = 98, .external_lex_state = 50},
  [2658] = {.lex_state = 98, .external_lex_state = 51},
  [2659] = {.lex_state = 98, .external_lex_state = 51},
  [2660] = {.lex_state = 98, .external_lex_state = 51},
  [2661] = {.lex_state = 98, .external_lex_state = 51},
  [2662] = {.lex_state = 98, .external_lex_state = 51},
  [2663] = {.lex_state = 98, .external_lex_state = 51},
  [2664] = {.lex_state = 98, .external_lex_state = 47},
  [2665] = {.lex_state = 98, .external_lex_state = 47},
  [2666] = {.lex_state = 98, .external_lex_state = 22},
  [2667] = {.lex_state = 98, .external_lex_state = 51},
  [2668] = {.lex_state = 98, .external_lex_state = 51},
  [2669] = {.lex_state = 69, .external_lex_state = 22},
  [2670] = {.lex_state = 98, .external_lex_state = 51},
  [2671] = {.lex_state = 62, .external_lex_state = 22},
  [2672] = {.lex_state = 98, .external_lex_state = 51},
  [2673] = {.lex_state = 98, .external_lex_state = 51},
  [2674] = {.lex_state = 98, .external_lex_state = 51},
  [2675] = {.lex_state = 98, .external_lex_state = 51},
  [2676] = {.lex_state = 98, .external_lex_state = 47},
  [2677] = {.lex_state = 98, .external_lex_state = 51},
  [2678] = {.lex_state = 98, .external_lex_state = 51},
  [2679] = {.lex_state = 98, .external_lex_state = 51},
  [2680] = {.lex_state = 98, .external_lex_state = 51},
  [2681] = {.lex_state = 69, .external_lex_state = 22},
  [2682] = {.lex_state = 98, .external_lex_state = 51},
  [2683] = {.lex_state = 98, .external_lex_state = 51},
  [2684] = {.lex_state = 98, .external_lex_state = 51},
  [2685] = {.lex_state = 98, .external_lex_state = 51},
  [2686] = {.lex_state = 98, .external_lex_state = 51},
  [2687] = {.lex_state = 98, .external_lex_state = 51},
  [2688] = {.lex_state = 98, .external_lex_state = 51},
  [2689] = {.lex_state = 98, .external_lex_state = 51},
  [2690] = {.lex_state = 14, .external_lex_state = 22},
  [2691] = {.lex_state = 14, .external_lex_state = 22},
  [2692] = {.lex_state = 98, .external_lex_state = 47},
  [2693] = {.lex_state = 98, .external_lex_state = 21},
  [2694] = {.lex_state = 98, .external_lex_state = 48},
  [2695] = {.lex_state = 98, .external_lex_state = 51},
  [2696] = {.lex_state = 98, .external_lex_state = 51},
  [2697] = {.lex_state = 98, .external_lex_state = 51},
  [2698] = {.lex_state = 98, .external_lex_state = 51},
  [2699] = {.lex_state = 98, .external_lex_state = 51},
  [2700] = {.lex_state = 98, .external_lex_state = 51},
  [2701] = {.lex_state = 98, .external_lex_state = 47},
  [2702] = {.lex_state = 98, .external_lex_state = 28},
  [2703] = {.lex_state = 98, .external_lex_state = 47},
  [2704] = {.lex_state = 98, .external_lex_state = 47},
  [2705] = {.lex_state = 98, .external_lex_state = 51},
  [2706] = {.lex_state = 98, .external_lex_state = 51},
  [2707] = {.lex_state = 98, .external_lex_state = 51},
  [2708] = {.lex_state = 98, .external_lex_state = 51},
  [2709] = {.lex_state = 98, .external_lex_state = 51},
  [2710] = {.lex_state = 98, .external_lex_state = 51},
  [2711] = {.lex_state = 62, .external_lex_state = 21},
  [2712] = {.lex_state = 62, .external_lex_state = 22},
  [2713] = {.lex_state = 14, .external_lex_state = 22},
  [2714] = {.lex_state = 62, .external_lex_state = 22},
  [2715] = {.lex_state = 98, .external_lex_state = 47},
  [2716] = {.lex_state = 98, .external_lex_state = 22},
  [2717] = {.lex_state = 98, .external_lex_state = 22},
  [2718] = {.lex_state = 98, .external_lex_state = 22},
  [2719] = {.lex_state = 98, .external_lex_state = 47},
  [2720] = {.lex_state = 98, .external_lex_state = 47},
  [2721] = {.lex_state = 62, .external_lex_state = 22},
  [2722] = {.lex_state = 98, .external_lex_state = 22},
  [2723] = {.lex_state = 69, .external_lex_state = 22},
  [2724] = {.lex_state = 69, .external_lex_state = 22},
  [2725] = {.lex_state = 69, .external_lex_state = 22},
  [2726] = {.lex_state = 98, .external_lex_state = 22},
  [2727] = {.lex_state = 69, .external_lex_state = 22},
  [2728] = {.lex_state = 98, .external_lex_state = 22},
  [2729] = {.lex_state = 98, .external_lex_state = 22},
  [2730] = {.lex_state = 69, .external_lex_state = 22},
  [2731] = {.lex_state = 69, .external_lex_state = 22},
  [2732] = {.lex_state = 69, .external_lex_state = 22},
  [2733] = {.lex_state = 98, .external_lex_state = 22},
  [2734] = {.lex_state = 62, .external_lex_state = 22},
  [2735] = {.lex_state = 69, .external_lex_state = 22},
  [2736] = {.lex_state = 69, .external_lex_state = 22},
  [2737] = {.lex_state = 69, .external_lex_state = 22},
  [2738] = {.lex_state = 69, .external_lex_state = 22},
  [2739] = {.lex_state = 69, .external_lex_state = 22},
  [2740] = {.lex_state = 69, .external_lex_state = 22},
  [2741] = {.lex_state = 69, .external_lex_state = 22},
  [2742] = {.lex_state = 98, .external_lex_state = 22},
  [2743] = {.lex_state = 98, .external_lex_state = 22},
  [2744] = {.lex_state = 69, .external_lex_state = 22},
  [2745] = {.lex_state = 69, .external_lex_state = 22},
  [2746] = {.lex_state = 98, .external_lex_state = 22},
  [2747] = {.lex_state = 98, .external_lex_state = 22},
  [2748] = {.lex_state = 98, .external_lex_state = 22},
  [2749] = {.lex_state = 69, .external_lex_state = 22},
  [2750] = {.lex_state = 98, .external_lex_state = 22},
  [2751] = {.lex_state = 69, .external_lex_state = 22},
  [2752] = {.lex_state = 69, .external_lex_state = 22},
  [2753] = {.lex_state = 98, .external_lex_state = 22},
  [2754] = {.lex_state = 98, .external_lex_state = 22},
  [2755] = {.lex_state = 98, .external_lex_state = 22},
  [2756] = {.lex_state = 98, .external_lex_state = 22},
  [2757] = {.lex_state = 69, .external_lex_state = 22},
  [2758] = {.lex_state = 69, .external_lex_state = 22},
  [2759] = {.lex_state = 69, .external_lex_state = 22},
  [2760] = {.lex_state = 98, .external_lex_state = 26},
  [2761] = {.lex_state = 98, .external_lex_state = 22},
  [2762] = {.lex_state = 69, .external_lex_state = 22},
  [2763] = {.lex_state = 69, .external_lex_state = 22},
  [2764] = {.lex_state = 98, .external_lex_state = 26},
  [2765] = {.lex_state = 98, .external_lex_state = 26},
  [2766] = {.lex_state = 98, .external_lex_state = 22},
  [2767] = {.lex_state = 69, .external_lex_state = 22},
  [2768] = {.lex_state = 98, .external_lex_state = 22},
  [2769] = {.lex_state = 98, .external_lex_state = 22},
  [2770] = {.lex_state = 98, .external_lex_state = 22},
  [2771] = {.lex_state = 98, .external_lex_state = 22},
  [2772] = {.lex_state = 98, .external_lex_state = 31},
  [2773] = {.lex_state = 98, .external_lex_state = 31},
  [2774] = {.lex_state = 69, .external_lex_state = 22},
  [2775] = {.lex_state = 98, .external_lex_state = 22},
  [2776] = {.lex_state = 69, .external_lex_state = 22},
  [2777] = {.lex_state = 69, .external_lex_state = 22},
  [2778] = {.lex_state = 69, .external_lex_state = 22},
  [2779] = {.lex_state = 98, .external_lex_state = 22},
  [2780] = {.lex_state = 98, .external_lex_state = 52},
  [2781] = {.lex_state = 98, .external_lex_state = 22},
  [2782] = {.lex_state = 98, .external_lex_state = 52},
  [2783] = {.lex_state = 98, .external_lex_state = 22},
  [2784] = {.lex_state = 69, .external_lex_state = 22},
  [2785] = {.lex_state = 98, .external_lex_state = 22},
  [2786] = {.lex_state = 98, .external_lex_state = 22},
  [2787] = {.lex_state = 98, .external_lex_state = 52},
  [2788] = {.lex_state = 69, .external_lex_state = 22},
  [2789] = {.lex_state = 98, .external_lex_state = 22},
  [2790] = {.lex_state = 98, .external_lex_state = 22},
  [2791] = {.lex_state = 98, .external_lex_state = 22},
  [2792] = {.lex_state = 69, .external_lex_state = 22},
  [2793] = {.lex_state = 69, .external_lex_state = 22},
  [2794] = {.lex_state = 69, .external_lex_state = 22},
  [2795] = {.lex_state = 69, .external_lex_state = 22},
  [2796] = {.lex_state = 69, .external_lex_state = 22},
  [2797] = {.lex_state = 69, .external_lex_state = 22},
  [2798] = {.lex_state = 69, .external_lex_state = 22},
  [2799] = {.lex_state = 69, .external_lex_state = 22},
  [2800] = {.lex_state = 69, .external_lex_state = 22},
  [2801] = {.lex_state = 69, .external_lex_state = 22},
  [2802] = {.lex_state = 98, .external_lex_state = 22},
  [2803] = {.lex_state = 69, .external_lex_state = 22},
  [2804] = {.lex_state = 69, .external_lex_state = 22},
  [2805] = {.lex_state = 69, .external_lex_state = 22},
  [2806] = {.lex_state = 98, .external_lex_state = 22},
  [2807] = {.lex_state = 69, .external_lex_state = 22},
  [2808] = {.lex_state = 98, .external_lex_state = 22},
  [2809] = {.lex_state = 98, .external_lex_state = 31},
  [2810] = {.lex_state = 69, .external_lex_state = 22},
  [2811] = {.lex_state = 98, .external_lex_state = 22},
  [2812] = {.lex_state = 98, .external_lex_state = 31},
  [2813] = {.lex_state = 98, .external_lex_state = 31},
  [2814] = {.lex_state = 69, .external_lex_state = 22},
  [2815] = {.lex_state = 69, .external_lex_state = 22},
  [2816] = {.lex_state = 98, .external_lex_state = 22},
  [2817] = {.lex_state = 69, .external_lex_state = 22},
  [2818] = {.lex_state = 69, .external_lex_state = 22},
  [2819] = {.lex_state = 98, .external_lex_state = 52},
  [2820] = {.lex_state = 98, .external_lex_state = 52},
  [2821] = {.lex_state = 98, .external_lex_state = 52},
  [2822] = {.lex_state = 62, .external_lex_state = 22},
  [2823] = {.lex_state = 98, .external_lex_state = 52},
  [2824] = {.lex_state = 98, .external_lex_state = 52},
  [2825] = {.lex_state = 98, .external_lex_state = 31},
  [2826] = {.lex_state = 98, .external_lex_state = 31},
  [2827] = {.lex_state = 98, .external_lex_state = 52},
  [2828] = {.lex_state = 69, .external_lex_state = 22},
  [2829] = {.lex_state = 69, .external_lex_state = 22},
  [2830] = {.lex_state = 69, .external_lex_state = 22},
  [2831] = {.lex_state = 69, .external_lex_state = 22},
  [2832] = {.lex_state = 69, .external_lex_state = 22},
  [2833] = {.lex_state = 69, .external_lex_state = 22},
  [2834] = {.lex_state = 98, .external_lex_state = 52},
  [2835] = {.lex_state = 69, .external_lex_state = 22},
  [2836] = {.lex_state = 98, .external_lex_state = 26},
  [2837] = {.lex_state = 69, .external_lex_state = 22},
  [2838] = {.lex_state = 69, .external_lex_state = 22},
  [2839] = {.lex_state = 69, .external_lex_state = 22},
  [2840] = {.lex_state = 98, .external_lex_state = 26},
  [2841] = {.lex_state = 98, .external_lex_state = 26},
  [2842] = {.lex_state = 98, .external_lex_state = 22},
  [2843] = {.lex_state = 69, .external_lex_state = 22},
  [2844] = {.lex_state = 98, .external_lex_state = 22},
  [2845] = {.lex_state = 98, .external_lex_state = 22},
  [2846] = {.lex_state = 98, .external_lex_state = 31},
  [2847] = {.lex_state = 69, .external_lex_state = 22},
  [2848] = {.lex_state = 98, .external_lex_state = 31},
  [2849] = {.lex_state = 98, .external_lex_state = 22},
  [2850] = {.lex_state = 98, .external_lex_state = 22},
  [2851] = {.lex_state = 69, .external_lex_state = 22},
  [2852] = {.lex_state = 98, .external_lex_state = 52},
  [2853] = {.lex_state = 69, .external_lex_state = 22},
  [2854] = {.lex_state = 69, .external_lex_state = 22},
  [2855] = {.lex_state = 69, .external_lex_state = 22},
  [2856] = {.lex_state = 69, .external_lex_state = 22},
  [2857] = {.lex_state = 69, .external_lex_state = 22},
  [2858] = {.lex_state = 69, .external_lex_state = 22},
  [2859] = {.lex_state = 98, .external_lex_state = 52},
  [2860] = {.lex_state = 69, .external_lex_state = 22},
  [2861] = {.lex_state = 69, .external_lex_state = 22},
  [2862] = {.lex_state = 69, .external_lex_state = 22},
  [2863] = {.lex_state = 98, .external_lex_state = 52},
  [2864] = {.lex_state = 98, .external_lex_state = 52},
  [2865] = {.lex_state = 98, .external_lex_state = 52},
  [2866] = {.lex_state = 98, .external_lex_state = 22},
  [2867] = {.lex_state = 14, .external_lex_state = 22},
  [2868] = {.lex_state = 14, .external_lex_state = 22},
  [2869] = {.lex_state = 69, .external_lex_state = 22},
  [2870] = {.lex_state = 69, .external_lex_state = 22},
  [2871] = {.lex_state = 69, .external_lex_state = 22},
  [2872] = {.lex_state = 69, .external_lex_state = 22},
  [2873] = {.lex_state = 69, .external_lex_state = 22},
  [2874] = {.lex_state = 69, .external_lex_state = 22},
  [2875] = {.lex_state = 98, .external_lex_state = 22},
  [2876] = {.lex_state = 69, .external_lex_state = 22},
  [2877] = {.lex_state = 69, .external_lex_state = 22},
  [2878] = {.lex_state = 69, .external_lex_state = 22},
  [2879] = {.lex_state = 98, .external_lex_state = 52},
  [2880] = {.lex_state = 98, .external_lex_state = 52},
  [2881] = {.lex_state = 98, .external_lex_state = 52},
  [2882] = {.lex_state = 69, .external_lex_state = 22},
  [2883] = {.lex_state = 98, .external_lex_state = 22},
  [2884] = {.lex_state = 98, .external_lex_state = 22},
  [2885] = {.lex_state = 98, .external_lex_state = 31},
  [2886] = {.lex_state = 98, .external_lex_state = 31},
  [2887] = {.lex_state = 69, .external_lex_state = 22},
  [2888] = {.lex_state = 69, .external_lex_state = 22},
  [2889] = {.lex_state = 98, .external_lex_state = 22},
  [2890] = {.lex_state = 98, .external_lex_state = 22},
  [2891] = {.lex_state = 69, .external_lex_state = 22},
  [2892] = {.lex_state = 98, .external_lex_state = 22},
  [2893] = {.lex_state = 69, .external_lex_state = 22},
  [2894] = {.lex_state = 98, .external_lex_state = 22},
  [2895] = {.lex_state = 98, .external_lex_state = 22},
  [2896] = {.lex_state = 98, .external_lex_state = 22},
  [2897] = {.lex_state = 98, .external_lex_state = 22},
  [2898] = {.lex_state = 98, .external_lex_state = 28},
  [2899] = {.lex_state = 98, .external_lex_state = 31},
  [2900] = {.lex_state = 69, .external_lex_state = 22},
  [2901] = {.lex_state = 98, .external_lex_state = 31},
  [2902] = {.lex_state = 98, .external_lex_state = 22},
  [2903] = {.lex_state = 98, .external_lex_state = 28},
  [2904] = {.lex_state = 98, .external_lex_state = 22},
  [2905] = {.lex_state = 69, .external_lex_state = 22},
  [2906] = {.lex_state = 69, .external_lex_state = 22},
  [2907] = {.lex_state = 98, .external_lex_state = 52},
  [2908] = {.lex_state = 98, .external_lex_state = 52},
  [2909] = {.lex_state = 98, .external_lex_state = 52},
  [2910] = {.lex_state = 69, .external_lex_state = 22},
  [2911] = {.lex_state = 69, .external_lex_state = 22},
  [2912] = {.lex_state = 98, .external_lex_state = 52},
  [2913] = {.lex_state = 98, .external_lex_state = 52},
  [2914] = {.lex_state = 98, .external_lex_state = 52},
  [2915] = {.lex_state = 69, .external_lex_state = 22},
  [2916] = {.lex_state = 98, .external_lex_state = 52},
  [2917] = {.lex_state = 98, .external_lex_state = 52},
  [2918] = {.lex_state = 98, .external_lex_state = 31},
  [2919] = {.lex_state = 98, .external_lex_state = 31},
  [2920] = {.lex_state = 69, .external_lex_state = 22},
  [2921] = {.lex_state = 98, .external_lex_state = 22},
  [2922] = {.lex_state = 69, .external_lex_state = 22},
  [2923] = {.lex_state = 98, .external_lex_state = 22},
  [2924] = {.lex_state = 98, .external_lex_state = 52},
  [2925] = {.lex_state = 98, .external_lex_state = 22},
  [2926] = {.lex_state = 98, .external_lex_state = 22},
  [2927] = {.lex_state = 98, .external_lex_state = 22},
  [2928] = {.lex_state = 98, .external_lex_state = 26},
  [2929] = {.lex_state = 98, .external_lex_state = 26},
  [2930] = {.lex_state = 98, .external_lex_state = 26},
  [2931] = {.lex_state = 98, .external_lex_state = 22},
  [2932] = {.lex_state = 98, .external_lex_state = 22},
  [2933] = {.lex_state = 69, .external_lex_state = 22},
  [2934] = {.lex_state = 69, .external_lex_state = 22},
  [2935] = {.lex_state = 98, .external_lex_state = 22},
  [2936] = {.lex_state = 98, .external_lex_state = 22},
  [2937] = {.lex_state = 69, .external_lex_state = 22},
  [2938] = {.lex_state = 98, .external_lex_state = 31},
  [2939] = {.lex_state = 69, .external_lex_state = 22},
  [2940] = {.lex_state = 69, .external_lex_state = 22},
  [2941] = {.lex_state = 98, .external_lex_state = 31},
  [2942] = {.lex_state = 14, .external_lex_state = 22},
  [2943] = {.lex_state = 98, .external_lex_state = 31},
  [2944] = {.lex_state = 14, .external_lex_state = 22},
  [2945] = {.lex_state = 98, .external_lex_state = 52},
  [2946] = {.lex_state = 98, .external_lex_state = 52},
  [2947] = {.lex_state = 98, .external_lex_state = 52},
  [2948] = {.lex_state = 69, .external_lex_state = 22},
  [2949] = {.lex_state = 98, .external_lex_state = 22},
  [2950] = {.lex_state = 69, .external_lex_state = 22},
  [2951] = {.lex_state = 98, .external_lex_state = 31},
  [2952] = {.lex_state = 98, .external_lex_state = 31},
  [2953] = {.lex_state = 98, .external_lex_state = 22},
  [2954] = {.lex_state = 69, .external_lex_state = 22},
  [2955] = {.lex_state = 98, .external_lex_state = 28},
  [2956] = {.lex_state = 98, .external_lex_state = 52},
  [2957] = {.lex_state = 98, .external_lex_state = 22},
  [2958] = {.lex_state = 98, .external_lex_state = 22},
  [2959] = {.lex_state = 98, .external_lex_state = 22},
  [2960] = {.lex_state = 98, .external_lex_state = 22},
  [2961] = {.lex_state = 98, .external_lex_state = 22},
  [2962] = {.lex_state = 98, .external_lex_state = 22},
  [2963] = {.lex_state = 98, .external_lex_state = 22},
  [2964] = {.lex_state = 98, .external_lex_state = 52},
  [2965] = {.lex_state = 98, .external_lex_state = 22},
  [2966] = {.lex_state = 98, .external_lex_state = 22},
  [2967] = {.lex_state = 98, .external_lex_state = 22},
  [2968] = {.lex_state = 98, .external_lex_state = 22},
  [2969] = {.lex_state = 98, .external_lex_state = 22},
  [2970] = {.lex_state = 98, .external_lex_state = 22},
  [2971] = {.lex_state = 98, .external_lex_state = 22},
  [2972] = {.lex_state = 98, .external_lex_state = 52},
  [2973] = {.lex_state = 98, .external_lex_state = 22},
  [2974] = {.lex_state = 98, .external_lex_state = 22},
  [2975] = {.lex_state = 98, .external_lex_state = 22},
  [2976] = {.lex_state = 98, .external_lex_state = 22},
  [2977] = {.lex_state = 98, .external_lex_state = 22},
  [2978] = {.lex_state = 98, .external_lex_state = 52},
  [2979] = {.lex_state = 98, .external_lex_state = 52},
  [2980] = {.lex_state = 98, .external_lex_state = 52},
  [2981] = {.lex_state = 69, .external_lex_state = 22},
  [2982] = {.lex_state = 69, .external_lex_state = 22},
  [2983] = {.lex_state = 69, .external_lex_state = 22},
  [2984] = {.lex_state = 98, .external_lex_state = 31},
  [2985] = {.lex_state = 98, .external_lex_state = 31},
  [2986] = {.lex_state = 69, .external_lex_state = 22},
  [2987] = {.lex_state = 98, .external_lex_state = 22},
  [2988] = {.lex_state = 98, .external_lex_state = 22},
  [2989] = {.lex_state = 69, .external_lex_state = 22},
  [2990] = {.lex_state = 98, .external_lex_state = 22},
  [2991] = {.lex_state = 98, .external_lex_state = 22},
  [2992] = {.lex_state = 98, .external_lex_state = 22},
  [2993] = {.lex_state = 98, .external_lex_state = 22},
  [2994] = {.lex_state = 98, .external_lex_state = 22},
  [2995] = {.lex_state = 98, .external_lex_state = 22},
  [2996] = {.lex_state = 98, .external_lex_state = 22},
  [2997] = {.lex_state = 69, .external_lex_state = 22},
  [2998] = {.lex_state = 98, .external_lex_state = 22},
  [2999] = {.lex_state = 69, .external_lex_state = 22},
  [3000] = {.lex_state = 98, .external_lex_state = 22},
  [3001] = {.lex_state = 69, .external_lex_state = 22},
  [3002] = {.lex_state = 14, .external_lex_state = 22},
  [3003] = {.lex_state = 69, .external_lex_state = 22},
  [3004] = {.lex_state = 98, .external_lex_state = 22},
  [3005] = {.lex_state = 14, .external_lex_state = 22},
  [3006] = {.lex_state = 69, .external_lex_state = 22},
  [3007] = {.lex_state = 69, .external_lex_state = 22},
  [3008] = {.lex_state = 69, .external_lex_state = 22},
  [3009] = {.lex_state = 69, .external_lex_state = 22},
  [3010] = {.lex_state = 69, .external_lex_state = 22},
  [3011] = {.lex_state = 98, .external_lex_state = 52},
  [3012] = {.lex_state = 98, .external_lex_state = 52},
  [3013] = {.lex_state = 98, .external_lex_state = 52},
  [3014] = {.lex_state = 98, .external_lex_state = 22},
  [3015] = {.lex_state = 98, .external_lex_state = 28},
  [3016] = {.lex_state = 69, .external_lex_state = 22},
  [3017] = {.lex_state = 98, .external_lex_state = 31},
  [3018] = {.lex_state = 98, .external_lex_state = 31},
  [3019] = {.lex_state = 69, .external_lex_state = 22},
  [3020] = {.lex_state = 69, .external_lex_state = 22},
  [3021] = {.lex_state = 69, .external_lex_state = 22},
  [3022] = {.lex_state = 98, .external_lex_state = 22},
  [3023] = {.lex_state = 98, .external_lex_state = 22},
  [3024] = {.lex_state = 98, .external_lex_state = 47},
  [3025] = {.lex_state = 69, .external_lex_state = 22},
  [3026] = {.lex_state = 98, .external_lex_state = 31},
  [3027] = {.lex_state = 98, .external_lex_state = 22},
  [3028] = {.lex_state = 98, .external_lex_state = 31},
  [3029] = {.lex_state = 69, .external_lex_state = 22},
  [3030] = {.lex_state = 98, .external_lex_state = 22},
  [3031] = {.lex_state = 98, .external_lex_state = 22},
  [3032] = {.lex_state = 98, .external_lex_state = 31},
  [3033] = {.lex_state = 69, .external_lex_state = 22},
  [3034] = {.lex_state = 69, .external_lex_state = 22},
  [3035] = {.lex_state = 69, .external_lex_state = 22},
  [3036] = {.lex_state = 98, .external_lex_state = 31},
  [3037] = {.lex_state = 98, .external_lex_state = 22},
  [3038] = {.lex_state = 98, .external_lex_state = 22},
  [3039] = {.lex_state = 98, .external_lex_state = 22},
  [3040] = {.lex_state = 98, .external_lex_state = 22},
  [3041] = {.lex_state = 98, .external_lex_state = 52},
  [3042] = {.lex_state = 98, .external_lex_state = 52},
  [3043] = {.lex_state = 98, .external_lex_state = 52},
  [3044] = {.lex_state = 98, .external_lex_state = 52},
  [3045] = {.lex_state = 98, .external_lex_state = 52},
  [3046] = {.lex_state = 98, .external_lex_state = 52},
  [3047] = {.lex_state = 98, .external_lex_state = 52},
  [3048] = {.lex_state = 98, .external_lex_state = 31},
  [3049] = {.lex_state = 98, .external_lex_state = 31},
  [3050] = {.lex_state = 69, .external_lex_state = 22},
  [3051] = {.lex_state = 98, .external_lex_state = 52},
  [3052] = {.lex_state = 98, .external_lex_state = 22},
  [3053] = {.lex_state = 69, .external_lex_state = 22},
  [3054] = {.lex_state = 69, .external_lex_state = 22},
  [3055] = {.lex_state = 98, .external_lex_state = 52},
  [3056] = {.lex_state = 98, .external_lex_state = 28},
  [3057] = {.lex_state = 98, .external_lex_state = 22},
  [3058] = {.lex_state = 98, .external_lex_state = 22},
  [3059] = {.lex_state = 69, .external_lex_state = 22},
  [3060] = {.lex_state = 69, .external_lex_state = 22},
  [3061] = {.lex_state = 98, .external_lex_state = 28},
  [3062] = {.lex_state = 98, .external_lex_state = 22},
  [3063] = {.lex_state = 98, .external_lex_state = 22},
  [3064] = {.lex_state = 69, .external_lex_state = 22},
  [3065] = {.lex_state = 69, .external_lex_state = 22},
  [3066] = {.lex_state = 98, .external_lex_state = 22},
  [3067] = {.lex_state = 98, .external_lex_state = 22},
  [3068] = {.lex_state = 98, .external_lex_state = 22},
  [3069] = {.lex_state = 98, .external_lex_state = 31},
  [3070] = {.lex_state = 98, .external_lex_state = 22},
  [3071] = {.lex_state = 98, .external_lex_state = 22},
  [3072] = {.lex_state = 98, .external_lex_state = 21},
  [3073] = {.lex_state = 98, .external_lex_state = 21},
  [3074] = {.lex_state = 98, .external_lex_state = 53},
  [3075] = {.lex_state = 98, .external_lex_state = 22},
  [3076] = {.lex_state = 6, .external_lex_state = 22},
  [3077] = {.lex_state = 6, .external_lex_state = 22},
  [3078] = {.lex_state = 6, .external_lex_state = 22},
  [3079] = {.lex_state = 98, .external_lex_state = 31},
  [3080] = {.lex_state = 98, .external_lex_state = 22},
  [3081] = {.lex_state = 98, .external_lex_state = 22},
  [3082] = {.lex_state = 244, .external_lex_state = 21},
  [3083] = {.lex_state = 98, .external_lex_state = 27},
  [3084] = {.lex_state = 98, .external_lex_state = 27},
  [3085] = {.lex_state = 98, .external_lex_state = 27},
  [3086] = {.lex_state = 98, .external_lex_state = 54},
  [3087] = {.lex_state = 98, .external_lex_state = 22},
  [3088] = {.lex_state = 98, .external_lex_state = 54},
  [3089] = {.lex_state = 98, .external_lex_state = 27},
  [3090] = {.lex_state = 98, .external_lex_state = 31},
  [3091] = {.lex_state = 98, .external_lex_state = 21},
  [3092] = {.lex_state = 98, .external_lex_state = 21},
  [3093] = {.lex_state = 98, .external_lex_state = 22},
  [3094] = {.lex_state = 6, .external_lex_state = 22},
  [3095] = {.lex_state = 6, .external_lex_state = 22},
  [3096] = {.lex_state = 6, .external_lex_state = 22},
  [3097] = {.lex_state = 98, .external_lex_state = 22},
  [3098] = {.lex_state = 98, .external_lex_state = 22},
  [3099] = {.lex_state = 98, .external_lex_state = 31},
  [3100] = {.lex_state = 98, .external_lex_state = 54},
  [3101] = {.lex_state = 98, .external_lex_state = 54},
  [3102] = {.lex_state = 98, .external_lex_state = 28},
  [3103] = {.lex_state = 98, .external_lex_state = 22},
  [3104] = {.lex_state = 6, .external_lex_state = 22},
  [3105] = {.lex_state = 98, .external_lex_state = 31},
  [3106] = {.lex_state = 98, .external_lex_state = 31},
  [3107] = {.lex_state = 98, .external_lex_state = 53},
  [3108] = {.lex_state = 98, .external_lex_state = 53},
  [3109] = {.lex_state = 98, .external_lex_state = 31},
  [3110] = {.lex_state = 98, .external_lex_state = 31},
  [3111] = {.lex_state = 98, .external_lex_state = 22},
  [3112] = {.lex_state = 6, .external_lex_state = 22},
  [3113] = {.lex_state = 98, .external_lex_state = 55},
  [3114] = {.lex_state = 98, .external_lex_state = 31},
  [3115] = {.lex_state = 98, .external_lex_state = 54},
  [3116] = {.lex_state = 98, .external_lex_state = 55},
  [3117] = {.lex_state = 98, .external_lex_state = 54},
  [3118] = {.lex_state = 98, .external_lex_state = 27},
  [3119] = {.lex_state = 98, .external_lex_state = 22},
  [3120] = {.lex_state = 98, .external_lex_state = 27},
  [3121] = {.lex_state = 98, .external_lex_state = 31},
  [3122] = {.lex_state = 6, .external_lex_state = 22},
  [3123] = {.lex_state = 98, .external_lex_state = 22},
  [3124] = {.lex_state = 98, .external_lex_state = 27},
  [3125] = {.lex_state = 98, .external_lex_state = 31},
  [3126] = {.lex_state = 98, .external_lex_state = 31},
  [3127] = {.lex_state = 98, .external_lex_state = 22},
  [3128] = {.lex_state = 98, .external_lex_state = 31},
  [3129] = {.lex_state = 98, .external_lex_state = 31},
  [3130] = {.lex_state = 98, .external_lex_state = 22},
  [3131] = {.lex_state = 98, .external_lex_state = 27},
  [3132] = {.lex_state = 98, .external_lex_state = 22},
  [3133] = {.lex_state = 98, .external_lex_state = 28},
  [3134] = {.lex_state = 98, .external_lex_state = 31},
  [3135] = {.lex_state = 98, .external_lex_state = 22},
  [3136] = {.lex_state = 98, .external_lex_state = 22},
  [3137] = {.lex_state = 98, .external_lex_state = 22},
  [3138] = {.lex_state = 98, .external_lex_state = 27},
  [3139] = {.lex_state = 98, .external_lex_state = 31},
  [3140] = {.lex_state = 98, .external_lex_state = 22},
  [3141] = {.lex_state = 98, .external_lex_state = 22},
  [3142] = {.lex_state = 98, .external_lex_state = 56},
  [3143] = {.lex_state = 98, .external_lex_state = 57},
  [3144] = {.lex_state = 98, .external_lex_state = 22},
  [3145] = {.lex_state = 98, .external_lex_state = 57},
  [3146] = {.lex_state = 98, .external_lex_state = 56},
  [3147] = {.lex_state = 98, .external_lex_state = 22},
  [3148] = {.lex_state = 14, .external_lex_state = 22},
  [3149] = {.lex_state = 14, .external_lex_state = 22},
  [3150] = {.lex_state = 14, .external_lex_state = 22},
  [3151] = {.lex_state = 98, .external_lex_state = 22},
  [3152] = {.lex_state = 98, .external_lex_state = 57},
  [3153] = {.lex_state = 98, .external_lex_state = 58},
  [3154] = {.lex_state = 98, .external_lex_state = 22},
  [3155] = {.lex_state = 98, .external_lex_state = 22},
  [3156] = {.lex_state = 98, .external_lex_state = 58},
  [3157] = {.lex_state = 98, .external_lex_state = 57},
  [3158] = {.lex_state = 98, .external_lex_state = 22},
  [3159] = {.lex_state = 98, .external_lex_state = 22},
  [3160] = {.lex_state = 98, .external_lex_state = 43},
  [3161] = {.lex_state = 98, .external_lex_state = 22},
  [3162] = {.lex_state = 98, .external_lex_state = 56},
  [3163] = {.lex_state = 98, .external_lex_state = 22},
  [3164] = {.lex_state = 14, .external_lex_state = 22},
  [3165] = {.lex_state = 244, .external_lex_state = 22},
  [3166] = {.lex_state = 98, .external_lex_state = 58},
  [3167] = {.lex_state = 98, .external_lex_state = 57},
  [3168] = {.lex_state = 98, .external_lex_state = 22},
  [3169] = {.lex_state = 98, .external_lex_state = 22},
  [3170] = {.lex_state = 98, .external_lex_state = 57},
  [3171] = {.lex_state = 14, .external_lex_state = 22},
  [3172] = {.lex_state = 14, .external_lex_state = 22},
  [3173] = {.lex_state = 98, .external_lex_state = 22},
  [3174] = {.lex_state = 98, .external_lex_state = 22},
  [3175] = {.lex_state = 98, .external_lex_state = 22},
  [3176] = {.lex_state = 244, .external_lex_state = 22},
  [3177] = {.lex_state = 98, .external_lex_state = 56},
  [3178] = {.lex_state = 98, .external_lex_state = 22},
  [3179] = {.lex_state = 14, .external_lex_state = 22},
  [3180] = {.lex_state = 98, .external_lex_state = 22},
  [3181] = {.lex_state = 98, .external_lex_state = 22},
  [3182] = {.lex_state = 98, .external_lex_state = 22},
  [3183] = {.lex_state = 98, .external_lex_state = 22},
  [3184] = {.lex_state = 98, .external_lex_state = 22},
  [3185] = {.lex_state = 98, .external_lex_state = 22},
  [3186] = {.lex_state = 98, .external_lex_state = 22},
  [3187] = {.lex_state = 98, .external_lex_state = 22},
  [3188] = {.lex_state = 98, .external_lex_state = 22},
  [3189] = {.lex_state = 98, .external_lex_state = 22},
  [3190] = {.lex_state = 98, .external_lex_state = 22},
  [3191] = {.lex_state = 98, .external_lex_state = 57},
  [3192] = {.lex_state = 98, .external_lex_state = 57},
  [3193] = {.lex_state = 98, .external_lex_state = 59},
  [3194] = {.lex_state = 98, .external_lex_state = 59},
  [3195] = {.lex_state = 98, .external_lex_state = 59},
  [3196] = {.lex_state = 13, .external_lex_state = 22},
  [3197] = {.lex_state = 98, .external_lex_state = 22},
  [3198] = {.lex_state = 98, .external_lex_state = 43},
  [3199] = {.lex_state = 98, .external_lex_state = 22},
  [3200] = {.lex_state = 98, .external_lex_state = 59},
  [3201] = {.lex_state = 98, .external_lex_state = 59},
  [3202] = {.lex_state = 46, .external_lex_state = 22},
  [3203] = {.lex_state = 98, .external_lex_state = 57},
  [3204] = {.lex_state = 98, .external_lex_state = 22},
  [3205] = {.lex_state = 98, .external_lex_state = 22},
  [3206] = {.lex_state = 98, .external_lex_state = 57},
  [3207] = {.lex_state = 98, .external_lex_state = 22},
  [3208] = {.lex_state = 13, .external_lex_state = 22},
  [3209] = {.lex_state = 98, .external_lex_state = 21},
  [3210] = {.lex_state = 98, .external_lex_state = 22},
  [3211] = {.lex_state = 98, .external_lex_state = 21},
  [3212] = {.lex_state = 98, .external_lex_state = 58},
  [3213] = {.lex_state = 98, .external_lex_state = 58},
  [3214] = {.lex_state = 14, .external_lex_state = 22},
  [3215] = {.lex_state = 98, .external_lex_state = 22},
  [3216] = {.lex_state = 98, .external_lex_state = 56},
  [3217] = {.lex_state = 98, .external_lex_state = 22},
  [3218] = {.lex_state = 98, .external_lex_state = 43},
  [3219] = {.lex_state = 98, .external_lex_state = 22},
  [3220] = {.lex_state = 98, .external_lex_state = 22},
  [3221] = {.lex_state = 98, .external_lex_state = 22},
  [3222] = {.lex_state = 98, .external_lex_state = 57},
  [3223] = {.lex_state = 98, .external_lex_state = 59},
  [3224] = {.lex_state = 98, .external_lex_state = 22},
  [3225] = {.lex_state = 98, .external_lex_state = 22},
  [3226] = {.lex_state = 98, .external_lex_state = 22},
  [3227] = {.lex_state = 98, .external_lex_state = 22},
  [3228] = {.lex_state = 98, .external_lex_state = 22},
  [3229] = {.lex_state = 98, .external_lex_state = 22},
  [3230] = {.lex_state = 98, .external_lex_state = 22},
  [3231] = {.lex_state = 98, .external_lex_state = 22},
  [3232] = {.lex_state = 98, .external_lex_state = 22},
  [3233] = {.lex_state = 98, .external_lex_state = 22},
  [3234] = {.lex_state = 98, .external_lex_state = 22},
  [3235] = {.lex_state = 98, .external_lex_state = 22},
  [3236] = {.lex_state = 14, .external_lex_state = 22},
  [3237] = {.lex_state = 98, .external_lex_state = 56},
  [3238] = {.lex_state = 98, .external_lex_state = 57},
  [3239] = {.lex_state = 98, .external_lex_state = 22},
  [3240] = {.lex_state = 98, .external_lex_state = 22},
  [3241] = {.lex_state = 98, .external_lex_state = 22},
  [3242] = {.lex_state = 14, .external_lex_state = 22},
  [3243] = {.lex_state = 98, .external_lex_state = 22},
  [3244] = {.lex_state = 98, .external_lex_state = 22},
  [3245] = {.lex_state = 98, .external_lex_state = 59},
  [3246] = {.lex_state = 98, .external_lex_state = 57},
  [3247] = {.lex_state = 98, .external_lex_state = 22},
  [3248] = {.lex_state = 98, .external_lex_state = 22},
  [3249] = {.lex_state = 98, .external_lex_state = 22},
  [3250] = {.lex_state = 14, .external_lex_state = 22},
  [3251] = {.lex_state = 98, .external_lex_state = 22},
  [3252] = {.lex_state = 98, .external_lex_state = 22},
  [3253] = {.lex_state = 98, .external_lex_state = 22},
  [3254] = {.lex_state = 98, .external_lex_state = 59},
  [3255] = {.lex_state = 98, .external_lex_state = 22},
  [3256] = {.lex_state = 98, .external_lex_state = 22},
  [3257] = {.lex_state = 98, .external_lex_state = 57},
  [3258] = {.lex_state = 98, .external_lex_state = 22},
  [3259] = {.lex_state = 98, .external_lex_state = 59},
  [3260] = {.lex_state = 98, .external_lex_state = 22},
  [3261] = {.lex_state = 98, .external_lex_state = 22},
  [3262] = {.lex_state = 98, .external_lex_state = 22},
  [3263] = {.lex_state = 98, .external_lex_state = 22},
  [3264] = {.lex_state = 98, .external_lex_state = 22},
  [3265] = {.lex_state = 98, .external_lex_state = 22},
  [3266] = {.lex_state = 98, .external_lex_state = 22},
  [3267] = {.lex_state = 98, .external_lex_state = 22},
  [3268] = {.lex_state = 98, .external_lex_state = 22},
  [3269] = {.lex_state = 13, .external_lex_state = 22},
  [3270] = {.lex_state = 98, .external_lex_state = 22},
  [3271] = {.lex_state = 98, .external_lex_state = 22},
  [3272] = {.lex_state = 98, .external_lex_state = 22},
  [3273] = {.lex_state = 98, .external_lex_state = 21},
  [3274] = {.lex_state = 98, .external_lex_state = 22},
  [3275] = {.lex_state = 98, .external_lex_state = 22},
  [3276] = {.lex_state = 98, .external_lex_state = 22},
  [3277] = {.lex_state = 98, .external_lex_state = 22},
  [3278] = {.lex_state = 98, .external_lex_state = 57},
  [3279] = {.lex_state = 46, .external_lex_state = 22},
  [3280] = {.lex_state = 98, .external_lex_state = 22},
  [3281] = {.lex_state = 98, .external_lex_state = 22},
  [3282] = {.lex_state = 98, .external_lex_state = 43},
  [3283] = {.lex_state = 98, .external_lex_state = 22},
  [3284] = {.lex_state = 98, .external_lex_state = 22},
  [3285] = {.lex_state = 98, .external_lex_state = 22},
  [3286] = {.lex_state = 98, .external_lex_state = 22},
  [3287] = {.lex_state = 98, .external_lex_state = 22},
  [3288] = {.lex_state = 98, .external_lex_state = 22},
  [3289] = {.lex_state = 98, .external_lex_state = 22},
  [3290] = {.lex_state = 98, .external_lex_state = 22},
  [3291] = {.lex_state = 98, .external_lex_state = 22},
  [3292] = {.lex_state = 98, .external_lex_state = 22},
  [3293] = {.lex_state = 98, .external_lex_state = 22},
  [3294] = {.lex_state = 98, .external_lex_state = 22},
  [3295] = {.lex_state = 98, .external_lex_state = 22},
  [3296] = {.lex_state = 98, .external_lex_state = 58},
  [3297] = {.lex_state = 98, .external_lex_state = 22},
  [3298] = {.lex_state = 98, .external_lex_state = 57},
  [3299] = {.lex_state = 98, .external_lex_state = 57},
  [3300] = {.lex_state = 14, .external_lex_state = 22},
  [3301] = {.lex_state = 98, .external_lex_state = 22},
  [3302] = {.lex_state = 98, .external_lex_state = 22},
  [3303] = {.lex_state = 14, .external_lex_state = 22},
  [3304] = {.lex_state = 98, .external_lex_state = 22},
  [3305] = {.lex_state = 98, .external_lex_state = 22},
  [3306] = {.lex_state = 98, .external_lex_state = 22},
  [3307] = {.lex_state = 98, .external_lex_state = 22},
  [3308] = {.lex_state = 98, .external_lex_state = 22},
  [3309] = {.lex_state = 98, .external_lex_state = 22},
  [3310] = {.lex_state = 98, .external_lex_state = 56},
  [3311] = {.lex_state = 98, .external_lex_state = 22},
  [3312] = {.lex_state = 98, .external_lex_state = 22},
  [3313] = {.lex_state = 98, .external_lex_state = 22},
  [3314] = {.lex_state = 98, .external_lex_state = 22},
  [3315] = {(TSStateId)(-1)},
  [3316] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_content] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_method] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_my] = ACTIONS(1),
    [anon_sym_state] = ACTIONS(1),
    [anon_sym_our] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_DOT_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_x_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_GT_GT2] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_x] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_ne] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_cmp] = ACTIONS(1),
    [anon_sym_TILDE_TILDE] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_lt] = ACTIONS(1),
    [anon_sym_le] = ACTIONS(1),
    [anon_sym_ge] = ACTIONS(1),
    [anon_sym_gt] = ACTIONS(1),
    [anon_sym_isa] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_eval] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_map] = ACTIONS(1),
    [anon_sym_grep] = ACTIONS(1),
    [anon_sym_sort] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_PERCENT2] = ACTIONS(1),
    [anon_sym_DOLLAR_POUND] = ACTIONS(1),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_no] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_last] = ACTIONS(1),
    [anon_sym_next] = ACTIONS(1),
    [anon_sym_redo] = ACTIONS(1),
    [anon_sym_BEGIN] = ACTIONS(1),
    [anon_sym_INIT] = ACTIONS(1),
    [anon_sym_CHECK] = ACTIONS(1),
    [anon_sym_UNITCHECK] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(1),
    [anon_sym_ADJUST] = ACTIONS(1),
    [anon_sym___FILE__] = ACTIONS(1),
    [anon_sym___LINE__] = ACTIONS(1),
    [anon_sym___PACKAGE__] = ACTIONS(1),
    [anon_sym___SUB__] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_fork] = ACTIONS(1),
    [anon_sym_getppid] = ACTIONS(1),
    [anon_sym_time] = ACTIONS(1),
    [anon_sym_times] = ACTIONS(1),
    [anon_sym_wait] = ACTIONS(1),
    [anon_sym_wantarray] = ACTIONS(1),
    [anon_sym_abs] = ACTIONS(1),
    [anon_sym_alarm] = ACTIONS(1),
    [anon_sym_chop] = ACTIONS(1),
    [anon_sym_chdir] = ACTIONS(1),
    [anon_sym_close] = ACTIONS(1),
    [anon_sym_closedir] = ACTIONS(1),
    [anon_sym_caller] = ACTIONS(1),
    [anon_sym_chomp] = ACTIONS(1),
    [anon_sym_chr] = ACTIONS(1),
    [anon_sym_cos] = ACTIONS(1),
    [anon_sym_chroot] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_dbmclose] = ACTIONS(1),
    [anon_sym_exists] = ACTIONS(1),
    [anon_sym_exit] = ACTIONS(1),
    [anon_sym_eof] = ACTIONS(1),
    [anon_sym_exp] = ACTIONS(1),
    [anon_sym_each] = ACTIONS(1),
    [anon_sym_fc] = ACTIONS(1),
    [anon_sym_fileno] = ACTIONS(1),
    [anon_sym_gmtime] = ACTIONS(1),
    [anon_sym_getc] = ACTIONS(1),
    [anon_sym_getpgrp] = ACTIONS(1),
    [anon_sym_getprotobyname] = ACTIONS(1),
    [anon_sym_getpwname] = ACTIONS(1),
    [anon_sym_getpwuid] = ACTIONS(1),
    [anon_sym_getpeername] = ACTIONS(1),
    [anon_sym_getnetbyname] = ACTIONS(1),
    [anon_sym_getsockname] = ACTIONS(1),
    [anon_sym_getgrnam] = ACTIONS(1),
    [anon_sym_getgrgid] = ACTIONS(1),
    [anon_sym_hex] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_keys] = ACTIONS(1),
    [anon_sym_lc] = ACTIONS(1),
    [anon_sym_lcfirst] = ACTIONS(1),
    [anon_sym_length] = ACTIONS(1),
    [anon_sym_localtime] = ACTIONS(1),
    [anon_sym_log] = ACTIONS(1),
    [anon_sym_lock] = ACTIONS(1),
    [anon_sym_lstat] = ACTIONS(1),
    [anon_sym_oct] = ACTIONS(1),
    [anon_sym_ord] = ACTIONS(1),
    [anon_sym_prototype] = ACTIONS(1),
    [anon_sym_pop] = ACTIONS(1),
    [anon_sym_pos] = ACTIONS(1),
    [anon_sym_quotemeta] = ACTIONS(1),
    [anon_sym_reset] = ACTIONS(1),
    [anon_sym_rand] = ACTIONS(1),
    [anon_sym_rmdir] = ACTIONS(1),
    [anon_sym_readdir] = ACTIONS(1),
    [anon_sym_readline] = ACTIONS(1),
    [anon_sym_readpipe] = ACTIONS(1),
    [anon_sym_rewinddir] = ACTIONS(1),
    [anon_sym_readlink] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_scalar] = ACTIONS(1),
    [anon_sym_shift] = ACTIONS(1),
    [anon_sym_sin] = ACTIONS(1),
    [anon_sym_sleep] = ACTIONS(1),
    [anon_sym_sqrt] = ACTIONS(1),
    [anon_sym_srand] = ACTIONS(1),
    [anon_sym_stat] = ACTIONS(1),
    [anon_sym_study] = ACTIONS(1),
    [anon_sym_tell] = ACTIONS(1),
    [anon_sym_telldir] = ACTIONS(1),
    [anon_sym_tied] = ACTIONS(1),
    [anon_sym_uc] = ACTIONS(1),
    [anon_sym_ucfirst] = ACTIONS(1),
    [anon_sym_untie] = ACTIONS(1),
    [anon_sym_umask] = ACTIONS(1),
    [anon_sym_values] = ACTIONS(1),
    [anon_sym_write] = ACTIONS(1),
    [aux_sym__func1op_token1] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(1),
    [anon_sym_EOT] = ACTIONS(1),
    [anon_sym_q] = ACTIONS(1),
    [anon_sym_qq] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [anon_sym_LBRACE3] = ACTIONS(1),
    [anon_sym_qw] = ACTIONS(1),
    [anon_sym_qx] = ACTIONS(1),
    [anon_sym_qr] = ACTIONS(1),
    [anon_sym_m] = ACTIONS(1),
    [anon_sym_s] = ACTIONS(1),
    [sym_quoted_regexp_modifiers] = ACTIONS(1),
    [anon_sym_tr] = ACTIONS(1),
    [anon_sym_y] = ACTIONS(1),
    [sym_version] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_unless] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [aux_sym__bareword_token1] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym__apostrophe] = ACTIONS(1),
    [sym__double_quote] = ACTIONS(1),
    [sym__backtick] = ACTIONS(1),
    [sym__search_slash] = ACTIONS(1),
    [sym__PERLY_SEMICOLON] = ACTIONS(1),
    [sym__PERLY_HEREDOC] = ACTIONS(1),
    [sym__ctrl_z_hack] = ACTIONS(1),
    [sym__quotelike_begin] = ACTIONS(1),
    [sym__quotelike_middle_close] = ACTIONS(1),
    [sym__quotelike_middle_skip] = ACTIONS(1),
    [sym__quotelike_end_zw] = ACTIONS(1),
    [sym__quotelike_end] = ACTIONS(1),
    [sym__q_string_content] = ACTIONS(1),
    [sym__qq_string_content] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_escaped_delimiter] = ACTIONS(1),
    [sym__dollar_in_regexp] = ACTIONS(1),
    [sym_pod] = ACTIONS(5),
    [sym__gobbled_content] = ACTIONS(1),
    [sym__attribute_value_begin] = ACTIONS(1),
    [sym_attribute_value] = ACTIONS(1),
    [sym_prototype_or_signature] = ACTIONS(1),
    [sym__heredoc_delimiter] = ACTIONS(1),
    [sym__command_heredoc_delimiter] = ACTIONS(1),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__heredoc_middle] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym__fat_comma_zw] = ACTIONS(1),
    [sym__brace_end_zw] = ACTIONS(1),
    [sym__dollar_ident_zw] = ACTIONS(1),
    [sym__no_interp_whitespace_zw] = ACTIONS(1),
    [sym__NONASSOC] = ACTIONS(1),
    [sym__ERROR] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(3243),
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(276),
    [sym_block] = STATE(995),
    [sym__fullstmt] = STATE(996),
    [sym_statement_label] = STATE(998),
    [sym__barestmt] = STATE(998),
    [sym_package_statement] = STATE(991),
    [sym_class_statement] = STATE(991),
    [sym_use_version_statement] = STATE(991),
    [sym_use_statement] = STATE(991),
    [sym_subroutine_declaration_statement] = STATE(991),
    [sym_method_declaration_statement] = STATE(991),
    [sym_phaser_statement] = STATE(991),
    [sym_conditional_statement] = STATE(991),
    [sym_loop_statement] = STATE(991),
    [sym_cstyle_for_statement] = STATE(991),
    [sym_for_statement] = STATE(991),
    [sym_try_statement] = STATE(991),
    [sym_defer_statement] = STATE(991),
    [sym_expression_statement] = STATE(2414),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym___DATA__] = STATE(3189),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(1),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3186),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(231),
    [ts_builtin_sym_end] = ACTIONS(9),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(19),
    [anon_sym_class] = ACTIONS(21),
    [anon_sym_sub] = ACTIONS(23),
    [anon_sym_method] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_defer] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(85),
    [anon_sym_no] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_foreach] = ACTIONS(87),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(91),
    [anon_sym_INIT] = ACTIONS(91),
    [anon_sym_CHECK] = ACTIONS(91),
    [anon_sym_UNITCHECK] = ACTIONS(91),
    [anon_sym_END] = ACTIONS(91),
    [anon_sym_ADJUST] = ACTIONS(91),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(95),
    [anon_sym___END__] = ACTIONS(95),
    [anon_sym_EOT] = ACTIONS(97),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(117),
    [anon_sym_until] = ACTIONS(117),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(133),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [2] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(624),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1917),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3135),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(2),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [3] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(686),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(3),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [4] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(689),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1929),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3103),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(4),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [5] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(623),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(5),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [6] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(6),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [7] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(7),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [8] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1433),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(8),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [9] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(9),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [10] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(10),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [11] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(11),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [12] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(12),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [13] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(13),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [14] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(14),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [15] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(15),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [16] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(16),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [17] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(17),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [18] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(18),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [19] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1615),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(19),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [20] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(20),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [21] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(21),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [22] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(22),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [23] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(23),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [24] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(24),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [25] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(25),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [26] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(26),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [27] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(27),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [28] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(28),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [29] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(29),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [30] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(30),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [31] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(31),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [32] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1635),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(32),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [33] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(654),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1931),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3111),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(33),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [34] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(655),
    [sym__term_rightward] = STATE(1832),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(34),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [35] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(35),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [36] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1635),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(36),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(297),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [37] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(37),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [38] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1436),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(38),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [39] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(39),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [40] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(40),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [41] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(41),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [42] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(42),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [43] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(43),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [44] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1436),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(44),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [45] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(45),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [46] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(46),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [47] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(47),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_foreach] = ACTIONS(297),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(297),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_EOT] = ACTIONS(297),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(299),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [48] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1363),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(48),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [49] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(49),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [50] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(50),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(457),
  },
  [51] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(51),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [52] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(52),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [53] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(53),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(469),
  },
  [54] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(54),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [55] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(55),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_foreach] = ACTIONS(335),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(335),
    [anon_sym_unless] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(335),
    [anon_sym_until] = ACTIONS(335),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [56] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(56),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [57] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(57),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(471),
  },
  [58] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(58),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [59] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(59),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [60] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(60),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(473),
  },
  [61] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(636),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(61),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [62] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(635),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1935),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3136),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(62),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [63] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(63),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [64] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(64),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(475),
  },
  [65] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(65),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(477),
  },
  [66] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(66),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [67] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(67),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(479),
  },
  [68] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(68),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(481),
  },
  [69] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(69),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [70] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(70),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [71] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(71),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(483),
  },
  [72] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(72),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [73] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(73),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [74] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(74),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [75] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(673),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(75),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [76] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(76),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [77] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(77),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [78] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(78),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [79] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(79),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [80] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(80),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [81] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(81),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [82] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1359),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(82),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(335),
    [anon_sym_or] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(344),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(511),
    [anon_sym_DASH] = ACTIONS(514),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(353),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(335),
    [anon_sym_ne] = ACTIONS(335),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(335),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(335),
    [anon_sym_le] = ACTIONS(335),
    [anon_sym_ge] = ACTIONS(335),
    [anon_sym_gt] = ACTIONS(335),
    [anon_sym_isa] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(517),
    [anon_sym_DASH_DASH] = ACTIONS(517),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(335),
    [anon_sym___END__] = ACTIONS(335),
    [anon_sym_EOT] = ACTIONS(333),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(359),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [83] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(83),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [84] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(84),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [85] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(85),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(520),
  },
  [86] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(86),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(522),
  },
  [87] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(87),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(333),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(524),
    [anon_sym_or] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(333),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(539),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(524),
    [anon_sym_ne] = ACTIONS(524),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(524),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(524),
    [anon_sym_le] = ACTIONS(524),
    [anon_sym_ge] = ACTIONS(524),
    [anon_sym_gt] = ACTIONS(524),
    [anon_sym_isa] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(545),
    [anon_sym_DASH_DASH] = ACTIONS(545),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [88] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(88),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [89] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(89),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [90] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(674),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1947),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3098),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(90),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [91] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(91),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(548),
  },
  [92] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(92),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [93] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(93),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [94] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(94),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [95] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(95),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [96] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(96),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [97] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(97),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [98] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(98),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(550),
  },
  [99] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(99),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [100] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__PERLY_BRACE_OPEN] = STATE(263),
    [sym_block] = STATE(1836),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1835),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(100),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [101] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(101),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(554),
  },
  [102] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(102),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [103] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(103),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [104] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(104),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
    [sym__brace_end_zw] = ACTIONS(556),
  },
  [105] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1453),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(105),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_x_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_DOT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_GT_GT2] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_x] = ACTIONS(558),
    [anon_sym_EQ_TILDE] = ACTIONS(558),
    [anon_sym_BANG_TILDE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_eq] = ACTIONS(558),
    [anon_sym_ne] = ACTIONS(558),
    [anon_sym_LT_EQ_GT] = ACTIONS(558),
    [anon_sym_cmp] = ACTIONS(558),
    [anon_sym_TILDE_TILDE] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_lt] = ACTIONS(558),
    [anon_sym_le] = ACTIONS(558),
    [anon_sym_ge] = ACTIONS(558),
    [anon_sym_gt] = ACTIONS(558),
    [anon_sym_isa] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(558),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(558),
    [anon_sym___END__] = ACTIONS(558),
    [anon_sym_EOT] = ACTIONS(558),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(560),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(560),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
  },
  [106] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1435),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(106),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [107] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(107),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [108] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1831),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym__label_arg] = STATE(1826),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(108),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_identifier] = STATE(1829),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(299),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [109] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(109),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [110] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1635),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(110),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [111] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1603),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(111),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(449),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(449),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [112] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1613),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(112),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [113] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(696),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(113),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [114] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1892),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(114),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [115] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(115),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_foreach] = ACTIONS(449),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_unless] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_until] = ACTIONS(449),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
  },
  [116] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(116),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [117] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1352),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(117),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_foreach] = ACTIONS(463),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_unless] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_until] = ACTIONS(463),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [118] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1320),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(118),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_foreach] = ACTIONS(459),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(459),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_EOT] = ACTIONS(459),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_unless] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_until] = ACTIONS(459),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(461),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [119] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1453),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(119),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(449),
    [anon_sym___END__] = ACTIONS(449),
    [anon_sym_EOT] = ACTIONS(449),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(453),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
  },
  [120] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1831),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym__label_arg] = STATE(1826),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(120),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_identifier] = STATE(1829),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [121] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1440),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(121),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [122] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1636),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(122),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(459),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [123] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1318),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(123),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_x_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_DOT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_GT_GT2] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_x] = ACTIONS(558),
    [anon_sym_EQ_TILDE] = ACTIONS(558),
    [anon_sym_BANG_TILDE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_eq] = ACTIONS(558),
    [anon_sym_ne] = ACTIONS(558),
    [anon_sym_LT_EQ_GT] = ACTIONS(558),
    [anon_sym_cmp] = ACTIONS(558),
    [anon_sym_TILDE_TILDE] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_lt] = ACTIONS(558),
    [anon_sym_le] = ACTIONS(558),
    [anon_sym_ge] = ACTIONS(558),
    [anon_sym_gt] = ACTIONS(558),
    [anon_sym_isa] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(558),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_foreach] = ACTIONS(558),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(558),
    [anon_sym___END__] = ACTIONS(558),
    [anon_sym_EOT] = ACTIONS(558),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_unless] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_until] = ACTIONS(558),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(560),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(560),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(455),
  },
  [124] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(695),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1933),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3081),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(124),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [125] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1435),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(125),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [126] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1434),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(126),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [127] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1636),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(127),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [128] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1638),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(128),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [129] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1613),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(129),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [130] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1906),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(130),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [131] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1440),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(131),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(463),
    [anon_sym_EOT] = ACTIONS(463),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(467),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [132] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1603),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(132),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(558),
    [anon_sym_DASH_GT] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_x_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_DOT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_GT_GT2] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_x] = ACTIONS(558),
    [anon_sym_EQ_TILDE] = ACTIONS(558),
    [anon_sym_BANG_TILDE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_eq] = ACTIONS(558),
    [anon_sym_ne] = ACTIONS(558),
    [anon_sym_LT_EQ_GT] = ACTIONS(558),
    [anon_sym_cmp] = ACTIONS(558),
    [anon_sym_TILDE_TILDE] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_lt] = ACTIONS(558),
    [anon_sym_le] = ACTIONS(558),
    [anon_sym_ge] = ACTIONS(558),
    [anon_sym_gt] = ACTIONS(558),
    [anon_sym_isa] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(558),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [133] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(688),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(133),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [134] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1438),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(134),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(572),
    [anon_sym_or] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_x_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_DOT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_GT_GT2] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_x] = ACTIONS(572),
    [anon_sym_EQ_TILDE] = ACTIONS(572),
    [anon_sym_BANG_TILDE] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG_EQ] = ACTIONS(572),
    [anon_sym_eq] = ACTIONS(572),
    [anon_sym_ne] = ACTIONS(572),
    [anon_sym_LT_EQ_GT] = ACTIONS(572),
    [anon_sym_cmp] = ACTIONS(572),
    [anon_sym_TILDE_TILDE] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_lt] = ACTIONS(572),
    [anon_sym_le] = ACTIONS(572),
    [anon_sym_ge] = ACTIONS(572),
    [anon_sym_gt] = ACTIONS(572),
    [anon_sym_isa] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(572),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(572),
    [anon_sym___END__] = ACTIONS(572),
    [anon_sym_EOT] = ACTIONS(572),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(574),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(574),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [135] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1604),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(135),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(576),
    [anon_sym_DASH_GT] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(584),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [anon_sym_DASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_EQ] = ACTIONS(576),
    [anon_sym_STAR_EQ] = ACTIONS(576),
    [anon_sym_SLASH_EQ] = ACTIONS(576),
    [anon_sym_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_x_EQ] = ACTIONS(576),
    [anon_sym_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_EQ] = ACTIONS(576),
    [anon_sym_CARET_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(576),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_DOT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH_SLASH] = ACTIONS(587),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_GT_GT2] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_x] = ACTIONS(576),
    [anon_sym_EQ_TILDE] = ACTIONS(576),
    [anon_sym_BANG_TILDE] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_eq] = ACTIONS(578),
    [anon_sym_ne] = ACTIONS(578),
    [anon_sym_LT_EQ_GT] = ACTIONS(576),
    [anon_sym_cmp] = ACTIONS(578),
    [anon_sym_TILDE_TILDE] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_lt] = ACTIONS(578),
    [anon_sym_le] = ACTIONS(578),
    [anon_sym_ge] = ACTIONS(578),
    [anon_sym_gt] = ACTIONS(578),
    [anon_sym_isa] = ACTIONS(578),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [136] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1901),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(136),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [137] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__term_rightward] = STATE(1828),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(137),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(607),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(610),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(613),
    [anon_sym_DASH] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(622),
    [anon_sym_ne] = ACTIONS(622),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(622),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(622),
    [anon_sym_le] = ACTIONS(622),
    [anon_sym_ge] = ACTIONS(622),
    [anon_sym_gt] = ACTIONS(622),
    [anon_sym_isa] = ACTIONS(622),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(625),
    [anon_sym_DASH_DASH] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(359),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [138] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1240),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(138),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(631),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(628),
    [anon_sym_DASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_EQ] = ACTIONS(628),
    [anon_sym_STAR_EQ] = ACTIONS(628),
    [anon_sym_SLASH_EQ] = ACTIONS(628),
    [anon_sym_PERCENT_EQ] = ACTIONS(628),
    [anon_sym_x_EQ] = ACTIONS(628),
    [anon_sym_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_EQ] = ACTIONS(628),
    [anon_sym_CARET_EQ] = ACTIONS(628),
    [anon_sym_LT_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_GT_EQ] = ACTIONS(628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(628),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_DOT] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_GT_GT2] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_DOT] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_x] = ACTIONS(628),
    [anon_sym_EQ_TILDE] = ACTIONS(628),
    [anon_sym_BANG_TILDE] = ACTIONS(628),
    [anon_sym_EQ_EQ] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(628),
    [anon_sym_eq] = ACTIONS(631),
    [anon_sym_ne] = ACTIONS(631),
    [anon_sym_LT_EQ_GT] = ACTIONS(628),
    [anon_sym_cmp] = ACTIONS(631),
    [anon_sym_TILDE_TILDE] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(628),
    [anon_sym_lt] = ACTIONS(631),
    [anon_sym_le] = ACTIONS(631),
    [anon_sym_ge] = ACTIONS(631),
    [anon_sym_gt] = ACTIONS(631),
    [anon_sym_isa] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(659),
    [anon_sym_DASH_DASH] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(628),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_foreach] = ACTIONS(631),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(631),
    [anon_sym___END__] = ACTIONS(631),
    [anon_sym_EOT] = ACTIONS(628),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(631),
    [anon_sym_unless] = ACTIONS(631),
    [anon_sym_while] = ACTIONS(631),
    [anon_sym_until] = ACTIONS(631),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(663),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(663),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [139] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(139),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(524),
    [anon_sym_or] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(539),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(524),
    [anon_sym_ne] = ACTIONS(524),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(524),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(524),
    [anon_sym_le] = ACTIONS(524),
    [anon_sym_ge] = ACTIONS(524),
    [anon_sym_gt] = ACTIONS(524),
    [anon_sym_isa] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(545),
    [anon_sym_DASH_DASH] = ACTIONS(545),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [140] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1457),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(140),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_x_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_DOT] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_GT_GT2] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(693),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_x] = ACTIONS(666),
    [anon_sym_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_eq] = ACTIONS(669),
    [anon_sym_ne] = ACTIONS(669),
    [anon_sym_LT_EQ_GT] = ACTIONS(666),
    [anon_sym_cmp] = ACTIONS(669),
    [anon_sym_TILDE_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_lt] = ACTIONS(669),
    [anon_sym_le] = ACTIONS(669),
    [anon_sym_ge] = ACTIONS(669),
    [anon_sym_gt] = ACTIONS(669),
    [anon_sym_isa] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(697),
    [anon_sym_DASH_DASH] = ACTIONS(697),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(669),
    [anon_sym___END__] = ACTIONS(669),
    [anon_sym_EOT] = ACTIONS(666),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(701),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(701),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [141] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1604),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(141),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(704),
    [anon_sym_or] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(712),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_x_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_DOT] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(716),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_GT_GT2] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_x] = ACTIONS(666),
    [anon_sym_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_eq] = ACTIONS(704),
    [anon_sym_ne] = ACTIONS(704),
    [anon_sym_LT_EQ_GT] = ACTIONS(666),
    [anon_sym_cmp] = ACTIONS(704),
    [anon_sym_TILDE_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_lt] = ACTIONS(704),
    [anon_sym_le] = ACTIONS(704),
    [anon_sym_ge] = ACTIONS(704),
    [anon_sym_gt] = ACTIONS(704),
    [anon_sym_isa] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(732),
    [anon_sym_DASH_DASH] = ACTIONS(732),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [142] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1606),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(142),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(572),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(572),
    [anon_sym_or] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(572),
    [anon_sym_DASH_GT] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_x_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_DOT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_GT_GT2] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_x] = ACTIONS(572),
    [anon_sym_EQ_TILDE] = ACTIONS(572),
    [anon_sym_BANG_TILDE] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG_EQ] = ACTIONS(572),
    [anon_sym_eq] = ACTIONS(572),
    [anon_sym_ne] = ACTIONS(572),
    [anon_sym_LT_EQ_GT] = ACTIONS(572),
    [anon_sym_cmp] = ACTIONS(572),
    [anon_sym_TILDE_TILDE] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_lt] = ACTIONS(572),
    [anon_sym_le] = ACTIONS(572),
    [anon_sym_ge] = ACTIONS(572),
    [anon_sym_gt] = ACTIONS(572),
    [anon_sym_isa] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(572),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [143] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1901),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(143),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [144] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(690),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1922),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3097),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(144),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [145] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1944),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(145),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [146] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1457),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(146),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(631),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(628),
    [anon_sym_DASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_EQ] = ACTIONS(628),
    [anon_sym_STAR_EQ] = ACTIONS(628),
    [anon_sym_SLASH_EQ] = ACTIONS(628),
    [anon_sym_PERCENT_EQ] = ACTIONS(628),
    [anon_sym_x_EQ] = ACTIONS(628),
    [anon_sym_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_EQ] = ACTIONS(628),
    [anon_sym_CARET_EQ] = ACTIONS(628),
    [anon_sym_LT_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_GT_EQ] = ACTIONS(628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(628),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_DOT] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_GT_GT2] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(764),
    [anon_sym_DOT] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_x] = ACTIONS(628),
    [anon_sym_EQ_TILDE] = ACTIONS(628),
    [anon_sym_BANG_TILDE] = ACTIONS(628),
    [anon_sym_EQ_EQ] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(628),
    [anon_sym_eq] = ACTIONS(631),
    [anon_sym_ne] = ACTIONS(631),
    [anon_sym_LT_EQ_GT] = ACTIONS(628),
    [anon_sym_cmp] = ACTIONS(631),
    [anon_sym_TILDE_TILDE] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(628),
    [anon_sym_lt] = ACTIONS(631),
    [anon_sym_le] = ACTIONS(631),
    [anon_sym_ge] = ACTIONS(631),
    [anon_sym_gt] = ACTIONS(631),
    [anon_sym_isa] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(768),
    [anon_sym_DASH_DASH] = ACTIONS(768),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(628),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(631),
    [anon_sym___END__] = ACTIONS(631),
    [anon_sym_EOT] = ACTIONS(628),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(663),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(663),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [147] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1457),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(147),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(772),
    [anon_sym_or] = ACTIONS(772),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [anon_sym_DASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_EQ] = ACTIONS(576),
    [anon_sym_STAR_EQ] = ACTIONS(576),
    [anon_sym_SLASH_EQ] = ACTIONS(576),
    [anon_sym_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_x_EQ] = ACTIONS(576),
    [anon_sym_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_EQ] = ACTIONS(576),
    [anon_sym_CARET_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(576),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_DOT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH_SLASH] = ACTIONS(781),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_GT_GT2] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(790),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_x] = ACTIONS(576),
    [anon_sym_EQ_TILDE] = ACTIONS(576),
    [anon_sym_BANG_TILDE] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_eq] = ACTIONS(772),
    [anon_sym_ne] = ACTIONS(772),
    [anon_sym_LT_EQ_GT] = ACTIONS(576),
    [anon_sym_cmp] = ACTIONS(772),
    [anon_sym_TILDE_TILDE] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_lt] = ACTIONS(772),
    [anon_sym_le] = ACTIONS(772),
    [anon_sym_ge] = ACTIONS(772),
    [anon_sym_gt] = ACTIONS(772),
    [anon_sym_isa] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(793),
    [anon_sym_DASH_DASH] = ACTIONS(793),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(772),
    [anon_sym___END__] = ACTIONS(772),
    [anon_sym_EOT] = ACTIONS(576),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(796),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(796),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [148] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__term_rightward] = STATE(1828),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(148),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [149] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1240),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(149),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(772),
    [anon_sym_or] = ACTIONS(772),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [anon_sym_DASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_EQ] = ACTIONS(576),
    [anon_sym_STAR_EQ] = ACTIONS(576),
    [anon_sym_SLASH_EQ] = ACTIONS(576),
    [anon_sym_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_x_EQ] = ACTIONS(576),
    [anon_sym_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_EQ] = ACTIONS(576),
    [anon_sym_CARET_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(576),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_DOT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH_SLASH] = ACTIONS(781),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_GT_GT2] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(790),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_x] = ACTIONS(576),
    [anon_sym_EQ_TILDE] = ACTIONS(576),
    [anon_sym_BANG_TILDE] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_eq] = ACTIONS(772),
    [anon_sym_ne] = ACTIONS(772),
    [anon_sym_LT_EQ_GT] = ACTIONS(576),
    [anon_sym_cmp] = ACTIONS(772),
    [anon_sym_TILDE_TILDE] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_lt] = ACTIONS(772),
    [anon_sym_le] = ACTIONS(772),
    [anon_sym_ge] = ACTIONS(772),
    [anon_sym_gt] = ACTIONS(772),
    [anon_sym_isa] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(772),
    [anon_sym_foreach] = ACTIONS(772),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(772),
    [anon_sym___END__] = ACTIONS(772),
    [anon_sym_EOT] = ACTIONS(576),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(772),
    [anon_sym_unless] = ACTIONS(772),
    [anon_sym_while] = ACTIONS(772),
    [anon_sym_until] = ACTIONS(772),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(796),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(796),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [150] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1888),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(150),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(297),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [151] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1240),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(151),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_x_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_DOT] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_GT_GT2] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(693),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_x] = ACTIONS(666),
    [anon_sym_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_eq] = ACTIONS(669),
    [anon_sym_ne] = ACTIONS(669),
    [anon_sym_LT_EQ_GT] = ACTIONS(666),
    [anon_sym_cmp] = ACTIONS(669),
    [anon_sym_TILDE_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_lt] = ACTIONS(669),
    [anon_sym_le] = ACTIONS(669),
    [anon_sym_ge] = ACTIONS(669),
    [anon_sym_gt] = ACTIONS(669),
    [anon_sym_isa] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_foreach] = ACTIONS(669),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(669),
    [anon_sym___END__] = ACTIONS(669),
    [anon_sym_EOT] = ACTIONS(666),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_unless] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(669),
    [anon_sym_until] = ACTIONS(669),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(701),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(701),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [152] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1604),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(152),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(628),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(628),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(819),
    [anon_sym_or] = ACTIONS(819),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(628),
    [anon_sym_DASH_GT] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(628),
    [anon_sym_DASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_EQ] = ACTIONS(628),
    [anon_sym_STAR_EQ] = ACTIONS(628),
    [anon_sym_SLASH_EQ] = ACTIONS(628),
    [anon_sym_PERCENT_EQ] = ACTIONS(628),
    [anon_sym_x_EQ] = ACTIONS(628),
    [anon_sym_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_EQ] = ACTIONS(628),
    [anon_sym_CARET_EQ] = ACTIONS(628),
    [anon_sym_LT_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_GT_EQ] = ACTIONS(628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(628),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_DOT] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_GT_GT2] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_x] = ACTIONS(628),
    [anon_sym_EQ_TILDE] = ACTIONS(628),
    [anon_sym_BANG_TILDE] = ACTIONS(628),
    [anon_sym_EQ_EQ] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(628),
    [anon_sym_eq] = ACTIONS(819),
    [anon_sym_ne] = ACTIONS(819),
    [anon_sym_LT_EQ_GT] = ACTIONS(628),
    [anon_sym_cmp] = ACTIONS(819),
    [anon_sym_TILDE_TILDE] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(628),
    [anon_sym_lt] = ACTIONS(819),
    [anon_sym_le] = ACTIONS(819),
    [anon_sym_ge] = ACTIONS(819),
    [anon_sym_gt] = ACTIONS(819),
    [anon_sym_isa] = ACTIONS(819),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(847),
    [anon_sym_DASH_DASH] = ACTIONS(847),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(628),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [153] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1360),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(153),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(572),
    [anon_sym_or] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_DASH_GT] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_x_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_DOT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_GT_GT2] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_x] = ACTIONS(572),
    [anon_sym_EQ_TILDE] = ACTIONS(572),
    [anon_sym_BANG_TILDE] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG_EQ] = ACTIONS(572),
    [anon_sym_eq] = ACTIONS(572),
    [anon_sym_ne] = ACTIONS(572),
    [anon_sym_LT_EQ_GT] = ACTIONS(572),
    [anon_sym_cmp] = ACTIONS(572),
    [anon_sym_TILDE_TILDE] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_lt] = ACTIONS(572),
    [anon_sym_le] = ACTIONS(572),
    [anon_sym_ge] = ACTIONS(572),
    [anon_sym_gt] = ACTIONS(572),
    [anon_sym_isa] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(572),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(572),
    [anon_sym_foreach] = ACTIONS(572),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(572),
    [anon_sym___END__] = ACTIONS(572),
    [anon_sym_EOT] = ACTIONS(572),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(572),
    [anon_sym_unless] = ACTIONS(572),
    [anon_sym_while] = ACTIONS(572),
    [anon_sym_until] = ACTIONS(572),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(574),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(574),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [154] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1888),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(154),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [155] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1980),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(155),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [156] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1946),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(156),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [157] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1825),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(157),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [158] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1746),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(158),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(453),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(879),
  },
  [159] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1603),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(159),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
    [sym__brace_end_zw] = ACTIONS(881),
  },
  [160] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(160),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(524),
    [anon_sym_ne] = ACTIONS(524),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(524),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(524),
    [anon_sym_le] = ACTIONS(524),
    [anon_sym_ge] = ACTIONS(524),
    [anon_sym_gt] = ACTIONS(524),
    [anon_sym_isa] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(889),
    [anon_sym_DASH_DASH] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [161] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(161),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(524),
    [anon_sym_ne] = ACTIONS(524),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(524),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(524),
    [anon_sym_le] = ACTIONS(524),
    [anon_sym_ge] = ACTIONS(524),
    [anon_sym_gt] = ACTIONS(524),
    [anon_sym_isa] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(898),
    [anon_sym_DASH_DASH] = ACTIONS(898),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [162] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1833),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(162),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(461),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [163] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1833),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(163),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [164] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(164),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [165] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1613),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(165),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [166] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1746),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(166),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_x_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_DOT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_GT_GT2] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_x] = ACTIONS(558),
    [anon_sym_EQ_TILDE] = ACTIONS(558),
    [anon_sym_BANG_TILDE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_eq] = ACTIONS(558),
    [anon_sym_ne] = ACTIONS(558),
    [anon_sym_LT_EQ_GT] = ACTIONS(558),
    [anon_sym_cmp] = ACTIONS(558),
    [anon_sym_TILDE_TILDE] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_lt] = ACTIONS(558),
    [anon_sym_le] = ACTIONS(558),
    [anon_sym_ge] = ACTIONS(558),
    [anon_sym_gt] = ACTIONS(558),
    [anon_sym_isa] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(558),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(560),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(879),
  },
  [167] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1825),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(167),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(467),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [168] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1834),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(168),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [169] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(169),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [170] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1636),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(170),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [171] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1946),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(171),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [172] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1872),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(172),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_x_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_DOT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_GT_GT2] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_x] = ACTIONS(558),
    [anon_sym_EQ_TILDE] = ACTIONS(558),
    [anon_sym_BANG_TILDE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_eq] = ACTIONS(558),
    [anon_sym_ne] = ACTIONS(558),
    [anon_sym_LT_EQ_GT] = ACTIONS(558),
    [anon_sym_cmp] = ACTIONS(558),
    [anon_sym_TILDE_TILDE] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_lt] = ACTIONS(558),
    [anon_sym_le] = ACTIONS(558),
    [anon_sym_ge] = ACTIONS(558),
    [anon_sym_gt] = ACTIONS(558),
    [anon_sym_isa] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(558),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [173] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1882),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(173),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [174] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1903),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(174),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [175] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1968),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(175),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(297),
    [anon_sym_PLUS_EQ] = ACTIONS(297),
    [anon_sym_DASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_EQ] = ACTIONS(297),
    [anon_sym_STAR_EQ] = ACTIONS(297),
    [anon_sym_SLASH_EQ] = ACTIONS(297),
    [anon_sym_PERCENT_EQ] = ACTIONS(297),
    [anon_sym_x_EQ] = ACTIONS(297),
    [anon_sym_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_EQ] = ACTIONS(297),
    [anon_sym_CARET_EQ] = ACTIONS(297),
    [anon_sym_LT_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_GT_EQ] = ACTIONS(297),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(297),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [anon_sym_SLASH_SLASH] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_GT_GT2] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_x] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [anon_sym_BANG_TILDE] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_eq] = ACTIONS(297),
    [anon_sym_ne] = ACTIONS(297),
    [anon_sym_LT_EQ_GT] = ACTIONS(297),
    [anon_sym_cmp] = ACTIONS(297),
    [anon_sym_TILDE_TILDE] = ACTIONS(297),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_lt] = ACTIONS(297),
    [anon_sym_le] = ACTIONS(297),
    [anon_sym_ge] = ACTIONS(297),
    [anon_sym_gt] = ACTIONS(297),
    [anon_sym_isa] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(297),
    [anon_sym_DASH_DASH] = ACTIONS(297),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [176] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1882),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(176),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [177] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1744),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(177),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_x_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_DOT] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_GT_GT2] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_x] = ACTIONS(666),
    [anon_sym_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_eq] = ACTIONS(925),
    [anon_sym_ne] = ACTIONS(925),
    [anon_sym_LT_EQ_GT] = ACTIONS(666),
    [anon_sym_cmp] = ACTIONS(925),
    [anon_sym_TILDE_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_lt] = ACTIONS(925),
    [anon_sym_le] = ACTIONS(925),
    [anon_sym_ge] = ACTIONS(925),
    [anon_sym_gt] = ACTIONS(925),
    [anon_sym_isa] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(701),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [178] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1891),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(178),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [179] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1744),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(179),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(628),
    [anon_sym_DASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_EQ] = ACTIONS(628),
    [anon_sym_STAR_EQ] = ACTIONS(628),
    [anon_sym_SLASH_EQ] = ACTIONS(628),
    [anon_sym_PERCENT_EQ] = ACTIONS(628),
    [anon_sym_x_EQ] = ACTIONS(628),
    [anon_sym_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_EQ] = ACTIONS(628),
    [anon_sym_CARET_EQ] = ACTIONS(628),
    [anon_sym_LT_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_GT_EQ] = ACTIONS(628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(628),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_DOT] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_GT_GT2] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_DOT] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_x] = ACTIONS(628),
    [anon_sym_EQ_TILDE] = ACTIONS(628),
    [anon_sym_BANG_TILDE] = ACTIONS(628),
    [anon_sym_EQ_EQ] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(628),
    [anon_sym_eq] = ACTIONS(957),
    [anon_sym_ne] = ACTIONS(957),
    [anon_sym_LT_EQ_GT] = ACTIONS(628),
    [anon_sym_cmp] = ACTIONS(957),
    [anon_sym_TILDE_TILDE] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(628),
    [anon_sym_lt] = ACTIONS(957),
    [anon_sym_le] = ACTIONS(957),
    [anon_sym_ge] = ACTIONS(957),
    [anon_sym_gt] = ACTIONS(957),
    [anon_sym_isa] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(628),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(663),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [180] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1968),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1493),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(180),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [181] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1744),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(181),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(968),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [anon_sym_DASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_EQ] = ACTIONS(576),
    [anon_sym_STAR_EQ] = ACTIONS(576),
    [anon_sym_SLASH_EQ] = ACTIONS(576),
    [anon_sym_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_x_EQ] = ACTIONS(576),
    [anon_sym_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_EQ] = ACTIONS(576),
    [anon_sym_CARET_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(576),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_DOT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH_SLASH] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_GT_GT2] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(980),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_x] = ACTIONS(576),
    [anon_sym_EQ_TILDE] = ACTIONS(576),
    [anon_sym_BANG_TILDE] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_eq] = ACTIONS(983),
    [anon_sym_ne] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(576),
    [anon_sym_cmp] = ACTIONS(983),
    [anon_sym_TILDE_TILDE] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_lt] = ACTIONS(983),
    [anon_sym_le] = ACTIONS(983),
    [anon_sym_ge] = ACTIONS(983),
    [anon_sym_gt] = ACTIONS(983),
    [anon_sym_isa] = ACTIONS(983),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(796),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [182] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1910),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(182),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(463),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [183] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1863),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(183),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(558),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_x_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_DOT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_GT_GT2] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_x] = ACTIONS(558),
    [anon_sym_EQ_TILDE] = ACTIONS(558),
    [anon_sym_BANG_TILDE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_eq] = ACTIONS(558),
    [anon_sym_ne] = ACTIONS(558),
    [anon_sym_LT_EQ_GT] = ACTIONS(558),
    [anon_sym_cmp] = ACTIONS(558),
    [anon_sym_TILDE_TILDE] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_lt] = ACTIONS(558),
    [anon_sym_le] = ACTIONS(558),
    [anon_sym_ge] = ACTIONS(558),
    [anon_sym_gt] = ACTIONS(558),
    [anon_sym_isa] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(558),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [184] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(184),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(524),
    [anon_sym_ne] = ACTIONS(524),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(524),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(524),
    [anon_sym_le] = ACTIONS(524),
    [anon_sym_ge] = ACTIONS(524),
    [anon_sym_gt] = ACTIONS(524),
    [anon_sym_isa] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(889),
    [anon_sym_DASH_DASH] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [185] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1904),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(185),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [186] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1903),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(186),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [187] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1889),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(187),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(459),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [188] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1889),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(188),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [189] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1872),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(189),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(449),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [190] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1755),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(190),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_DASH_GT] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_x_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_DOT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_GT_GT2] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_x] = ACTIONS(572),
    [anon_sym_EQ_TILDE] = ACTIONS(572),
    [anon_sym_BANG_TILDE] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG_EQ] = ACTIONS(572),
    [anon_sym_eq] = ACTIONS(572),
    [anon_sym_ne] = ACTIONS(572),
    [anon_sym_LT_EQ_GT] = ACTIONS(572),
    [anon_sym_cmp] = ACTIONS(572),
    [anon_sym_TILDE_TILDE] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_lt] = ACTIONS(572),
    [anon_sym_le] = ACTIONS(572),
    [anon_sym_ge] = ACTIONS(572),
    [anon_sym_gt] = ACTIONS(572),
    [anon_sym_isa] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(572),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(574),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [191] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1910),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(191),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [192] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(192),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [193] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1863),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(193),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [194] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1951),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(194),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [195] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1877),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(195),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(584),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [anon_sym_DASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_EQ] = ACTIONS(576),
    [anon_sym_STAR_EQ] = ACTIONS(576),
    [anon_sym_SLASH_EQ] = ACTIONS(576),
    [anon_sym_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_x_EQ] = ACTIONS(576),
    [anon_sym_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_EQ] = ACTIONS(576),
    [anon_sym_CARET_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(576),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_DOT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH_SLASH] = ACTIONS(587),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_GT_GT2] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_x] = ACTIONS(576),
    [anon_sym_EQ_TILDE] = ACTIONS(576),
    [anon_sym_BANG_TILDE] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_eq] = ACTIONS(578),
    [anon_sym_ne] = ACTIONS(578),
    [anon_sym_LT_EQ_GT] = ACTIONS(576),
    [anon_sym_cmp] = ACTIONS(578),
    [anon_sym_TILDE_TILDE] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_lt] = ACTIONS(578),
    [anon_sym_le] = ACTIONS(578),
    [anon_sym_ge] = ACTIONS(578),
    [anon_sym_gt] = ACTIONS(578),
    [anon_sym_isa] = ACTIONS(578),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [196] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1937),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(196),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_x_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_DOT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_GT_GT2] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_x] = ACTIONS(558),
    [anon_sym_EQ_TILDE] = ACTIONS(558),
    [anon_sym_BANG_TILDE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_eq] = ACTIONS(558),
    [anon_sym_ne] = ACTIONS(558),
    [anon_sym_LT_EQ_GT] = ACTIONS(558),
    [anon_sym_cmp] = ACTIONS(558),
    [anon_sym_TILDE_TILDE] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_lt] = ACTIONS(558),
    [anon_sym_le] = ACTIONS(558),
    [anon_sym_ge] = ACTIONS(558),
    [anon_sym_gt] = ACTIONS(558),
    [anon_sym_isa] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [197] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1951),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(197),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [198] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1916),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(198),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [199] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1905),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(199),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(712),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_x_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_DOT] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(716),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_GT_GT2] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(1002),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_x] = ACTIONS(666),
    [anon_sym_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_eq] = ACTIONS(704),
    [anon_sym_ne] = ACTIONS(704),
    [anon_sym_LT_EQ_GT] = ACTIONS(666),
    [anon_sym_cmp] = ACTIONS(704),
    [anon_sym_TILDE_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_lt] = ACTIONS(704),
    [anon_sym_le] = ACTIONS(704),
    [anon_sym_ge] = ACTIONS(704),
    [anon_sym_gt] = ACTIONS(704),
    [anon_sym_isa] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [200] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1936),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(200),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [201] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1937),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(201),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(449),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [202] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1877),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(202),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(628),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(628),
    [anon_sym_DASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_EQ] = ACTIONS(628),
    [anon_sym_STAR_EQ] = ACTIONS(628),
    [anon_sym_SLASH_EQ] = ACTIONS(628),
    [anon_sym_PERCENT_EQ] = ACTIONS(628),
    [anon_sym_x_EQ] = ACTIONS(628),
    [anon_sym_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_EQ] = ACTIONS(628),
    [anon_sym_CARET_EQ] = ACTIONS(628),
    [anon_sym_LT_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_GT_EQ] = ACTIONS(628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(628),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_DOT] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_GT_GT2] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1014),
    [anon_sym_DOT] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_x] = ACTIONS(628),
    [anon_sym_EQ_TILDE] = ACTIONS(628),
    [anon_sym_BANG_TILDE] = ACTIONS(628),
    [anon_sym_EQ_EQ] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(628),
    [anon_sym_eq] = ACTIONS(819),
    [anon_sym_ne] = ACTIONS(819),
    [anon_sym_LT_EQ_GT] = ACTIONS(628),
    [anon_sym_cmp] = ACTIONS(819),
    [anon_sym_TILDE_TILDE] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(628),
    [anon_sym_lt] = ACTIONS(819),
    [anon_sym_le] = ACTIONS(819),
    [anon_sym_ge] = ACTIONS(819),
    [anon_sym_gt] = ACTIONS(819),
    [anon_sym_isa] = ACTIONS(819),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [203] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(203),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [204] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1905),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(204),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(584),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [anon_sym_DASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_EQ] = ACTIONS(576),
    [anon_sym_STAR_EQ] = ACTIONS(576),
    [anon_sym_SLASH_EQ] = ACTIONS(576),
    [anon_sym_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_x_EQ] = ACTIONS(576),
    [anon_sym_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_EQ] = ACTIONS(576),
    [anon_sym_CARET_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(576),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(576),
    [anon_sym_DOT_DOT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH_SLASH] = ACTIONS(587),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_GT_GT2] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_x] = ACTIONS(576),
    [anon_sym_EQ_TILDE] = ACTIONS(576),
    [anon_sym_BANG_TILDE] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_eq] = ACTIONS(578),
    [anon_sym_ne] = ACTIONS(578),
    [anon_sym_LT_EQ_GT] = ACTIONS(576),
    [anon_sym_cmp] = ACTIONS(578),
    [anon_sym_TILDE_TILDE] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_lt] = ACTIONS(578),
    [anon_sym_le] = ACTIONS(578),
    [anon_sym_ge] = ACTIONS(578),
    [anon_sym_gt] = ACTIONS(578),
    [anon_sym_isa] = ACTIONS(578),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1028),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [205] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1936),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(205),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [206] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1877),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(206),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(628),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(628),
    [anon_sym_DASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_EQ] = ACTIONS(628),
    [anon_sym_STAR_EQ] = ACTIONS(628),
    [anon_sym_SLASH_EQ] = ACTIONS(628),
    [anon_sym_PERCENT_EQ] = ACTIONS(628),
    [anon_sym_x_EQ] = ACTIONS(628),
    [anon_sym_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_EQ] = ACTIONS(628),
    [anon_sym_CARET_EQ] = ACTIONS(628),
    [anon_sym_LT_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_GT_EQ] = ACTIONS(628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(628),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_DOT] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_GT_GT2] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1014),
    [anon_sym_DOT] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_x] = ACTIONS(628),
    [anon_sym_EQ_TILDE] = ACTIONS(628),
    [anon_sym_BANG_TILDE] = ACTIONS(628),
    [anon_sym_EQ_EQ] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(628),
    [anon_sym_eq] = ACTIONS(819),
    [anon_sym_ne] = ACTIONS(819),
    [anon_sym_LT_EQ_GT] = ACTIONS(628),
    [anon_sym_cmp] = ACTIONS(819),
    [anon_sym_TILDE_TILDE] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(628),
    [anon_sym_lt] = ACTIONS(819),
    [anon_sym_le] = ACTIONS(819),
    [anon_sym_ge] = ACTIONS(819),
    [anon_sym_gt] = ACTIONS(819),
    [anon_sym_isa] = ACTIONS(819),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(628),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [207] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1877),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(207),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(712),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_x_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_DOT] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(716),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_GT_GT2] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_x] = ACTIONS(666),
    [anon_sym_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_eq] = ACTIONS(704),
    [anon_sym_ne] = ACTIONS(704),
    [anon_sym_LT_EQ_GT] = ACTIONS(666),
    [anon_sym_cmp] = ACTIONS(704),
    [anon_sym_TILDE_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_lt] = ACTIONS(704),
    [anon_sym_le] = ACTIONS(704),
    [anon_sym_ge] = ACTIONS(704),
    [anon_sym_gt] = ACTIONS(704),
    [anon_sym_isa] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [208] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1905),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(208),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(712),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_x_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_DOT] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(716),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_GT_GT2] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(1002),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_x] = ACTIONS(666),
    [anon_sym_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_eq] = ACTIONS(704),
    [anon_sym_ne] = ACTIONS(704),
    [anon_sym_LT_EQ_GT] = ACTIONS(666),
    [anon_sym_cmp] = ACTIONS(704),
    [anon_sym_TILDE_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_lt] = ACTIONS(704),
    [anon_sym_le] = ACTIONS(704),
    [anon_sym_ge] = ACTIONS(704),
    [anon_sym_gt] = ACTIONS(704),
    [anon_sym_isa] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [209] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1905),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(209),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(628),
    [anon_sym_DASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_EQ] = ACTIONS(628),
    [anon_sym_STAR_EQ] = ACTIONS(628),
    [anon_sym_SLASH_EQ] = ACTIONS(628),
    [anon_sym_PERCENT_EQ] = ACTIONS(628),
    [anon_sym_x_EQ] = ACTIONS(628),
    [anon_sym_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_EQ] = ACTIONS(628),
    [anon_sym_CARET_EQ] = ACTIONS(628),
    [anon_sym_LT_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_GT_EQ] = ACTIONS(628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(628),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_DOT] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_GT_GT2] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DOT] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_x] = ACTIONS(628),
    [anon_sym_EQ_TILDE] = ACTIONS(628),
    [anon_sym_BANG_TILDE] = ACTIONS(628),
    [anon_sym_EQ_EQ] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(628),
    [anon_sym_eq] = ACTIONS(819),
    [anon_sym_ne] = ACTIONS(819),
    [anon_sym_LT_EQ_GT] = ACTIONS(628),
    [anon_sym_cmp] = ACTIONS(819),
    [anon_sym_TILDE_TILDE] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(628),
    [anon_sym_lt] = ACTIONS(819),
    [anon_sym_le] = ACTIONS(819),
    [anon_sym_ge] = ACTIONS(819),
    [anon_sym_gt] = ACTIONS(819),
    [anon_sym_isa] = ACTIONS(819),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1051),
    [anon_sym_DASH_DASH] = ACTIONS(1051),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [210] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1913),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(210),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_x_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_DOT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_GT_GT2] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_x] = ACTIONS(572),
    [anon_sym_EQ_TILDE] = ACTIONS(572),
    [anon_sym_BANG_TILDE] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG_EQ] = ACTIONS(572),
    [anon_sym_eq] = ACTIONS(572),
    [anon_sym_ne] = ACTIONS(572),
    [anon_sym_LT_EQ_GT] = ACTIONS(572),
    [anon_sym_cmp] = ACTIONS(572),
    [anon_sym_TILDE_TILDE] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_lt] = ACTIONS(572),
    [anon_sym_le] = ACTIONS(572),
    [anon_sym_ge] = ACTIONS(572),
    [anon_sym_gt] = ACTIONS(572),
    [anon_sym_isa] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(572),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [211] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1887),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(211),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_x_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_DOT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_GT_GT2] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_x] = ACTIONS(572),
    [anon_sym_EQ_TILDE] = ACTIONS(572),
    [anon_sym_BANG_TILDE] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG_EQ] = ACTIONS(572),
    [anon_sym_eq] = ACTIONS(572),
    [anon_sym_ne] = ACTIONS(572),
    [anon_sym_LT_EQ_GT] = ACTIONS(572),
    [anon_sym_cmp] = ACTIONS(572),
    [anon_sym_TILDE_TILDE] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_lt] = ACTIONS(572),
    [anon_sym_le] = ACTIONS(572),
    [anon_sym_ge] = ACTIONS(572),
    [anon_sym_gt] = ACTIONS(572),
    [anon_sym_isa] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(572),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [212] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1877),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(212),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(712),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_x_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_DOT_DOT] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(716),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_GT_GT2] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_x] = ACTIONS(666),
    [anon_sym_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_eq] = ACTIONS(704),
    [anon_sym_ne] = ACTIONS(704),
    [anon_sym_LT_EQ_GT] = ACTIONS(666),
    [anon_sym_cmp] = ACTIONS(704),
    [anon_sym_TILDE_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_lt] = ACTIONS(704),
    [anon_sym_le] = ACTIONS(704),
    [anon_sym_ge] = ACTIONS(704),
    [anon_sym_gt] = ACTIONS(704),
    [anon_sym_isa] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [213] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1905),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(213),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(628),
    [anon_sym_DASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_EQ] = ACTIONS(628),
    [anon_sym_STAR_EQ] = ACTIONS(628),
    [anon_sym_SLASH_EQ] = ACTIONS(628),
    [anon_sym_PERCENT_EQ] = ACTIONS(628),
    [anon_sym_x_EQ] = ACTIONS(628),
    [anon_sym_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_EQ] = ACTIONS(628),
    [anon_sym_CARET_EQ] = ACTIONS(628),
    [anon_sym_LT_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_GT_EQ] = ACTIONS(628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(628),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(628),
    [anon_sym_DOT_DOT] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_GT_GT2] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DOT] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_x] = ACTIONS(628),
    [anon_sym_EQ_TILDE] = ACTIONS(628),
    [anon_sym_BANG_TILDE] = ACTIONS(628),
    [anon_sym_EQ_EQ] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(628),
    [anon_sym_eq] = ACTIONS(819),
    [anon_sym_ne] = ACTIONS(819),
    [anon_sym_LT_EQ_GT] = ACTIONS(628),
    [anon_sym_cmp] = ACTIONS(819),
    [anon_sym_TILDE_TILDE] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(628),
    [anon_sym_lt] = ACTIONS(819),
    [anon_sym_le] = ACTIONS(819),
    [anon_sym_ge] = ACTIONS(819),
    [anon_sym_gt] = ACTIONS(819),
    [anon_sym_isa] = ACTIONS(819),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1051),
    [anon_sym_DASH_DASH] = ACTIONS(1051),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(628),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [214] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1491),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(214),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_x_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_GT_GT2] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(333),
    [anon_sym_x] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(333),
    [anon_sym_BANG_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_eq] = ACTIONS(524),
    [anon_sym_ne] = ACTIONS(524),
    [anon_sym_LT_EQ_GT] = ACTIONS(333),
    [anon_sym_cmp] = ACTIONS(524),
    [anon_sym_TILDE_TILDE] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_lt] = ACTIONS(524),
    [anon_sym_le] = ACTIONS(524),
    [anon_sym_ge] = ACTIONS(524),
    [anon_sym_gt] = ACTIONS(524),
    [anon_sym_isa] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(898),
    [anon_sym_DASH_DASH] = ACTIONS(898),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [215] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1976),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(215),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(558),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_x_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_DOT_DOT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_GT_GT2] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_x] = ACTIONS(558),
    [anon_sym_EQ_TILDE] = ACTIONS(558),
    [anon_sym_BANG_TILDE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_eq] = ACTIONS(558),
    [anon_sym_ne] = ACTIONS(558),
    [anon_sym_LT_EQ_GT] = ACTIONS(558),
    [anon_sym_cmp] = ACTIONS(558),
    [anon_sym_TILDE_TILDE] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_lt] = ACTIONS(558),
    [anon_sym_le] = ACTIONS(558),
    [anon_sym_ge] = ACTIONS(558),
    [anon_sym_gt] = ACTIONS(558),
    [anon_sym_isa] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [216] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1962),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(216),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [217] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1938),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(217),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_x_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_DOT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_GT_GT2] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_x] = ACTIONS(572),
    [anon_sym_EQ_TILDE] = ACTIONS(572),
    [anon_sym_BANG_TILDE] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG_EQ] = ACTIONS(572),
    [anon_sym_eq] = ACTIONS(572),
    [anon_sym_ne] = ACTIONS(572),
    [anon_sym_LT_EQ_GT] = ACTIONS(572),
    [anon_sym_cmp] = ACTIONS(572),
    [anon_sym_TILDE_TILDE] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_lt] = ACTIONS(572),
    [anon_sym_le] = ACTIONS(572),
    [anon_sym_ge] = ACTIONS(572),
    [anon_sym_gt] = ACTIONS(572),
    [anon_sym_isa] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [218] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1969),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(218),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(459),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_x_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(459),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_GT_GT2] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_x] = ACTIONS(459),
    [anon_sym_EQ_TILDE] = ACTIONS(459),
    [anon_sym_BANG_TILDE] = ACTIONS(459),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_eq] = ACTIONS(459),
    [anon_sym_ne] = ACTIONS(459),
    [anon_sym_LT_EQ_GT] = ACTIONS(459),
    [anon_sym_cmp] = ACTIONS(459),
    [anon_sym_TILDE_TILDE] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_lt] = ACTIONS(459),
    [anon_sym_le] = ACTIONS(459),
    [anon_sym_ge] = ACTIONS(459),
    [anon_sym_gt] = ACTIONS(459),
    [anon_sym_isa] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [219] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1962),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(219),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_x_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_SLASH_SLASH] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_GT_GT2] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(463),
    [anon_sym_x] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(463),
    [anon_sym_BANG_TILDE] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_eq] = ACTIONS(463),
    [anon_sym_ne] = ACTIONS(463),
    [anon_sym_LT_EQ_GT] = ACTIONS(463),
    [anon_sym_cmp] = ACTIONS(463),
    [anon_sym_TILDE_TILDE] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_lt] = ACTIONS(463),
    [anon_sym_le] = ACTIONS(463),
    [anon_sym_ge] = ACTIONS(463),
    [anon_sym_gt] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(463),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [220] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1976),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(220),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_EQ] = ACTIONS(449),
    [anon_sym_STAR_EQ] = ACTIONS(449),
    [anon_sym_SLASH_EQ] = ACTIONS(449),
    [anon_sym_PERCENT_EQ] = ACTIONS(449),
    [anon_sym_x_EQ] = ACTIONS(449),
    [anon_sym_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_EQ] = ACTIONS(449),
    [anon_sym_CARET_EQ] = ACTIONS(449),
    [anon_sym_LT_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_GT_EQ] = ACTIONS(449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(449),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_SLASH_SLASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_GT_GT2] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_x] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_BANG_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_eq] = ACTIONS(449),
    [anon_sym_ne] = ACTIONS(449),
    [anon_sym_LT_EQ_GT] = ACTIONS(449),
    [anon_sym_cmp] = ACTIONS(449),
    [anon_sym_TILDE_TILDE] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_lt] = ACTIONS(449),
    [anon_sym_le] = ACTIONS(449),
    [anon_sym_ge] = ACTIONS(449),
    [anon_sym_gt] = ACTIONS(449),
    [anon_sym_isa] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(568),
  },
  [221] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1970),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(221),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [222] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1969),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(222),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [223] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1963),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(223),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_x_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_DOT_DOT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_GT_GT2] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_x] = ACTIONS(572),
    [anon_sym_EQ_TILDE] = ACTIONS(572),
    [anon_sym_BANG_TILDE] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG_EQ] = ACTIONS(572),
    [anon_sym_eq] = ACTIONS(572),
    [anon_sym_ne] = ACTIONS(572),
    [anon_sym_LT_EQ_GT] = ACTIONS(572),
    [anon_sym_cmp] = ACTIONS(572),
    [anon_sym_TILDE_TILDE] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_lt] = ACTIONS(572),
    [anon_sym_le] = ACTIONS(572),
    [anon_sym_ge] = ACTIONS(572),
    [anon_sym_gt] = ACTIONS(572),
    [anon_sym_isa] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [224] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(224),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3238),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(242),
    [sym__identifier] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1063),
    [anon_sym_sub] = ACTIONS(1065),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_my] = ACTIONS(1071),
    [anon_sym_state] = ACTIONS(1071),
    [anon_sym_our] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1077),
    [anon_sym_elsif] = ACTIONS(1077),
    [anon_sym_and] = ACTIONS(1077),
    [anon_sym_or] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1077),
    [anon_sym_ne] = ACTIONS(1077),
    [anon_sym_cmp] = ACTIONS(1077),
    [anon_sym_lt] = ACTIONS(1077),
    [anon_sym_le] = ACTIONS(1077),
    [anon_sym_ge] = ACTIONS(1077),
    [anon_sym_gt] = ACTIONS(1077),
    [anon_sym_isa] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1085),
    [anon_sym_eval] = ACTIONS(1087),
    [anon_sym_field] = ACTIONS(1071),
    [anon_sym_local] = ACTIONS(1089),
    [anon_sym_require] = ACTIONS(1091),
    [anon_sym_map] = ACTIONS(1093),
    [anon_sym_grep] = ACTIONS(1093),
    [anon_sym_sort] = ACTIONS(1095),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1099),
    [anon_sym_use] = ACTIONS(1101),
    [anon_sym_no] = ACTIONS(1101),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_foreach] = ACTIONS(1103),
    [anon_sym_last] = ACTIONS(1105),
    [anon_sym_next] = ACTIONS(1105),
    [anon_sym_redo] = ACTIONS(1105),
    [anon_sym_BEGIN] = ACTIONS(1107),
    [anon_sym_INIT] = ACTIONS(1107),
    [anon_sym_CHECK] = ACTIONS(1107),
    [anon_sym_UNITCHECK] = ACTIONS(1107),
    [anon_sym_END] = ACTIONS(1107),
    [anon_sym_ADJUST] = ACTIONS(1107),
    [anon_sym___FILE__] = ACTIONS(1069),
    [anon_sym___LINE__] = ACTIONS(1069),
    [anon_sym___PACKAGE__] = ACTIONS(1069),
    [anon_sym___SUB__] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_fork] = ACTIONS(1069),
    [anon_sym_getppid] = ACTIONS(1069),
    [anon_sym_time] = ACTIONS(1069),
    [anon_sym_times] = ACTIONS(1069),
    [anon_sym_wait] = ACTIONS(1069),
    [anon_sym_wantarray] = ACTIONS(1069),
    [anon_sym_abs] = ACTIONS(1109),
    [anon_sym_alarm] = ACTIONS(1109),
    [anon_sym_chop] = ACTIONS(1109),
    [anon_sym_chdir] = ACTIONS(1109),
    [anon_sym_close] = ACTIONS(1109),
    [anon_sym_closedir] = ACTIONS(1109),
    [anon_sym_caller] = ACTIONS(1109),
    [anon_sym_chomp] = ACTIONS(1109),
    [anon_sym_chr] = ACTIONS(1109),
    [anon_sym_cos] = ACTIONS(1109),
    [anon_sym_chroot] = ACTIONS(1109),
    [anon_sym_defined] = ACTIONS(1109),
    [anon_sym_delete] = ACTIONS(1109),
    [anon_sym_dbmclose] = ACTIONS(1109),
    [anon_sym_exists] = ACTIONS(1109),
    [anon_sym_exit] = ACTIONS(1109),
    [anon_sym_eof] = ACTIONS(1109),
    [anon_sym_exp] = ACTIONS(1109),
    [anon_sym_each] = ACTIONS(1109),
    [anon_sym_fc] = ACTIONS(1109),
    [anon_sym_fileno] = ACTIONS(1109),
    [anon_sym_gmtime] = ACTIONS(1109),
    [anon_sym_getc] = ACTIONS(1109),
    [anon_sym_getpgrp] = ACTIONS(1109),
    [anon_sym_getprotobyname] = ACTIONS(1109),
    [anon_sym_getpwname] = ACTIONS(1109),
    [anon_sym_getpwuid] = ACTIONS(1109),
    [anon_sym_getpeername] = ACTIONS(1109),
    [anon_sym_getnetbyname] = ACTIONS(1109),
    [anon_sym_getsockname] = ACTIONS(1109),
    [anon_sym_getgrnam] = ACTIONS(1109),
    [anon_sym_getgrgid] = ACTIONS(1109),
    [anon_sym_hex] = ACTIONS(1109),
    [anon_sym_int] = ACTIONS(1109),
    [anon_sym_keys] = ACTIONS(1109),
    [anon_sym_lc] = ACTIONS(1109),
    [anon_sym_lcfirst] = ACTIONS(1109),
    [anon_sym_length] = ACTIONS(1109),
    [anon_sym_localtime] = ACTIONS(1109),
    [anon_sym_log] = ACTIONS(1109),
    [anon_sym_lock] = ACTIONS(1109),
    [anon_sym_lstat] = ACTIONS(1109),
    [anon_sym_oct] = ACTIONS(1109),
    [anon_sym_ord] = ACTIONS(1109),
    [anon_sym_prototype] = ACTIONS(1109),
    [anon_sym_pop] = ACTIONS(1109),
    [anon_sym_pos] = ACTIONS(1109),
    [anon_sym_quotemeta] = ACTIONS(1109),
    [anon_sym_reset] = ACTIONS(1109),
    [anon_sym_rand] = ACTIONS(1109),
    [anon_sym_rmdir] = ACTIONS(1109),
    [anon_sym_readdir] = ACTIONS(1109),
    [anon_sym_readline] = ACTIONS(1109),
    [anon_sym_readpipe] = ACTIONS(1109),
    [anon_sym_rewinddir] = ACTIONS(1109),
    [anon_sym_readlink] = ACTIONS(1109),
    [anon_sym_ref] = ACTIONS(1109),
    [anon_sym_scalar] = ACTIONS(1109),
    [anon_sym_shift] = ACTIONS(1109),
    [anon_sym_sin] = ACTIONS(1109),
    [anon_sym_sleep] = ACTIONS(1109),
    [anon_sym_sqrt] = ACTIONS(1109),
    [anon_sym_srand] = ACTIONS(1109),
    [anon_sym_stat] = ACTIONS(1109),
    [anon_sym_study] = ACTIONS(1109),
    [anon_sym_tell] = ACTIONS(1109),
    [anon_sym_telldir] = ACTIONS(1109),
    [anon_sym_tied] = ACTIONS(1109),
    [anon_sym_uc] = ACTIONS(1109),
    [anon_sym_ucfirst] = ACTIONS(1109),
    [anon_sym_untie] = ACTIONS(1109),
    [anon_sym_umask] = ACTIONS(1109),
    [anon_sym_values] = ACTIONS(1109),
    [anon_sym_write] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1077),
    [anon_sym___END__] = ACTIONS(1077),
    [anon_sym_q] = ACTIONS(1111),
    [anon_sym_qq] = ACTIONS(1113),
    [anon_sym_qw] = ACTIONS(1115),
    [anon_sym_qx] = ACTIONS(1117),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1119),
    [anon_sym_tr] = ACTIONS(1121),
    [anon_sym_y] = ACTIONS(1121),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1125),
    [anon_sym_until] = ACTIONS(1125),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1129),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [225] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(225),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3167),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(277),
    [sym__identifier] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_sub] = ACTIONS(1137),
    [anon_sym_method] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_my] = ACTIONS(1143),
    [anon_sym_state] = ACTIONS(1143),
    [anon_sym_our] = ACTIONS(1143),
    [anon_sym_try] = ACTIONS(1145),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1147),
    [anon_sym_elsif] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1147),
    [anon_sym_ne] = ACTIONS(1147),
    [anon_sym_cmp] = ACTIONS(1147),
    [anon_sym_lt] = ACTIONS(1147),
    [anon_sym_le] = ACTIONS(1147),
    [anon_sym_ge] = ACTIONS(1147),
    [anon_sym_gt] = ACTIONS(1147),
    [anon_sym_isa] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_eval] = ACTIONS(1153),
    [anon_sym_field] = ACTIONS(1143),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_require] = ACTIONS(1157),
    [anon_sym_map] = ACTIONS(1159),
    [anon_sym_grep] = ACTIONS(1159),
    [anon_sym_sort] = ACTIONS(1161),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_no] = ACTIONS(1167),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_foreach] = ACTIONS(1169),
    [anon_sym_last] = ACTIONS(1171),
    [anon_sym_next] = ACTIONS(1171),
    [anon_sym_redo] = ACTIONS(1171),
    [anon_sym_BEGIN] = ACTIONS(1173),
    [anon_sym_INIT] = ACTIONS(1173),
    [anon_sym_CHECK] = ACTIONS(1173),
    [anon_sym_UNITCHECK] = ACTIONS(1173),
    [anon_sym_END] = ACTIONS(1173),
    [anon_sym_ADJUST] = ACTIONS(1173),
    [anon_sym___FILE__] = ACTIONS(1141),
    [anon_sym___LINE__] = ACTIONS(1141),
    [anon_sym___PACKAGE__] = ACTIONS(1141),
    [anon_sym___SUB__] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_fork] = ACTIONS(1141),
    [anon_sym_getppid] = ACTIONS(1141),
    [anon_sym_time] = ACTIONS(1141),
    [anon_sym_times] = ACTIONS(1141),
    [anon_sym_wait] = ACTIONS(1141),
    [anon_sym_wantarray] = ACTIONS(1141),
    [anon_sym_abs] = ACTIONS(1175),
    [anon_sym_alarm] = ACTIONS(1175),
    [anon_sym_chop] = ACTIONS(1175),
    [anon_sym_chdir] = ACTIONS(1175),
    [anon_sym_close] = ACTIONS(1175),
    [anon_sym_closedir] = ACTIONS(1175),
    [anon_sym_caller] = ACTIONS(1175),
    [anon_sym_chomp] = ACTIONS(1175),
    [anon_sym_chr] = ACTIONS(1175),
    [anon_sym_cos] = ACTIONS(1175),
    [anon_sym_chroot] = ACTIONS(1175),
    [anon_sym_defined] = ACTIONS(1175),
    [anon_sym_delete] = ACTIONS(1175),
    [anon_sym_dbmclose] = ACTIONS(1175),
    [anon_sym_exists] = ACTIONS(1175),
    [anon_sym_exit] = ACTIONS(1175),
    [anon_sym_eof] = ACTIONS(1175),
    [anon_sym_exp] = ACTIONS(1175),
    [anon_sym_each] = ACTIONS(1175),
    [anon_sym_fc] = ACTIONS(1175),
    [anon_sym_fileno] = ACTIONS(1175),
    [anon_sym_gmtime] = ACTIONS(1175),
    [anon_sym_getc] = ACTIONS(1175),
    [anon_sym_getpgrp] = ACTIONS(1175),
    [anon_sym_getprotobyname] = ACTIONS(1175),
    [anon_sym_getpwname] = ACTIONS(1175),
    [anon_sym_getpwuid] = ACTIONS(1175),
    [anon_sym_getpeername] = ACTIONS(1175),
    [anon_sym_getnetbyname] = ACTIONS(1175),
    [anon_sym_getsockname] = ACTIONS(1175),
    [anon_sym_getgrnam] = ACTIONS(1175),
    [anon_sym_getgrgid] = ACTIONS(1175),
    [anon_sym_hex] = ACTIONS(1175),
    [anon_sym_int] = ACTIONS(1175),
    [anon_sym_keys] = ACTIONS(1175),
    [anon_sym_lc] = ACTIONS(1175),
    [anon_sym_lcfirst] = ACTIONS(1175),
    [anon_sym_length] = ACTIONS(1175),
    [anon_sym_localtime] = ACTIONS(1175),
    [anon_sym_log] = ACTIONS(1175),
    [anon_sym_lock] = ACTIONS(1175),
    [anon_sym_lstat] = ACTIONS(1175),
    [anon_sym_oct] = ACTIONS(1175),
    [anon_sym_ord] = ACTIONS(1175),
    [anon_sym_prototype] = ACTIONS(1175),
    [anon_sym_pop] = ACTIONS(1175),
    [anon_sym_pos] = ACTIONS(1175),
    [anon_sym_quotemeta] = ACTIONS(1175),
    [anon_sym_reset] = ACTIONS(1175),
    [anon_sym_rand] = ACTIONS(1175),
    [anon_sym_rmdir] = ACTIONS(1175),
    [anon_sym_readdir] = ACTIONS(1175),
    [anon_sym_readline] = ACTIONS(1175),
    [anon_sym_readpipe] = ACTIONS(1175),
    [anon_sym_rewinddir] = ACTIONS(1175),
    [anon_sym_readlink] = ACTIONS(1175),
    [anon_sym_ref] = ACTIONS(1175),
    [anon_sym_scalar] = ACTIONS(1175),
    [anon_sym_shift] = ACTIONS(1175),
    [anon_sym_sin] = ACTIONS(1175),
    [anon_sym_sleep] = ACTIONS(1175),
    [anon_sym_sqrt] = ACTIONS(1175),
    [anon_sym_srand] = ACTIONS(1175),
    [anon_sym_stat] = ACTIONS(1175),
    [anon_sym_study] = ACTIONS(1175),
    [anon_sym_tell] = ACTIONS(1175),
    [anon_sym_telldir] = ACTIONS(1175),
    [anon_sym_tied] = ACTIONS(1175),
    [anon_sym_uc] = ACTIONS(1175),
    [anon_sym_ucfirst] = ACTIONS(1175),
    [anon_sym_untie] = ACTIONS(1175),
    [anon_sym_umask] = ACTIONS(1175),
    [anon_sym_values] = ACTIONS(1175),
    [anon_sym_write] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1147),
    [anon_sym___END__] = ACTIONS(1147),
    [anon_sym_q] = ACTIONS(1177),
    [anon_sym_qq] = ACTIONS(1179),
    [anon_sym_qw] = ACTIONS(1181),
    [anon_sym_qx] = ACTIONS(1183),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1185),
    [anon_sym_tr] = ACTIONS(1187),
    [anon_sym_y] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_unless] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_until] = ACTIONS(1191),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1193),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [226] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(226),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3206),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(258),
    [sym__identifier] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1199),
    [anon_sym_sub] = ACTIONS(1201),
    [anon_sym_method] = ACTIONS(1203),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_my] = ACTIONS(1207),
    [anon_sym_state] = ACTIONS(1207),
    [anon_sym_our] = ACTIONS(1207),
    [anon_sym_try] = ACTIONS(1209),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_elsif] = ACTIONS(1211),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1211),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1211),
    [anon_sym_ne] = ACTIONS(1211),
    [anon_sym_cmp] = ACTIONS(1211),
    [anon_sym_lt] = ACTIONS(1211),
    [anon_sym_le] = ACTIONS(1211),
    [anon_sym_ge] = ACTIONS(1211),
    [anon_sym_gt] = ACTIONS(1211),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_eval] = ACTIONS(1217),
    [anon_sym_field] = ACTIONS(1207),
    [anon_sym_local] = ACTIONS(1219),
    [anon_sym_require] = ACTIONS(1221),
    [anon_sym_map] = ACTIONS(1223),
    [anon_sym_grep] = ACTIONS(1223),
    [anon_sym_sort] = ACTIONS(1225),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1229),
    [anon_sym_use] = ACTIONS(1231),
    [anon_sym_no] = ACTIONS(1231),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_foreach] = ACTIONS(1233),
    [anon_sym_last] = ACTIONS(1235),
    [anon_sym_next] = ACTIONS(1235),
    [anon_sym_redo] = ACTIONS(1235),
    [anon_sym_BEGIN] = ACTIONS(1237),
    [anon_sym_INIT] = ACTIONS(1237),
    [anon_sym_CHECK] = ACTIONS(1237),
    [anon_sym_UNITCHECK] = ACTIONS(1237),
    [anon_sym_END] = ACTIONS(1237),
    [anon_sym_ADJUST] = ACTIONS(1237),
    [anon_sym___FILE__] = ACTIONS(1205),
    [anon_sym___LINE__] = ACTIONS(1205),
    [anon_sym___PACKAGE__] = ACTIONS(1205),
    [anon_sym___SUB__] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_fork] = ACTIONS(1205),
    [anon_sym_getppid] = ACTIONS(1205),
    [anon_sym_time] = ACTIONS(1205),
    [anon_sym_times] = ACTIONS(1205),
    [anon_sym_wait] = ACTIONS(1205),
    [anon_sym_wantarray] = ACTIONS(1205),
    [anon_sym_abs] = ACTIONS(1239),
    [anon_sym_alarm] = ACTIONS(1239),
    [anon_sym_chop] = ACTIONS(1239),
    [anon_sym_chdir] = ACTIONS(1239),
    [anon_sym_close] = ACTIONS(1239),
    [anon_sym_closedir] = ACTIONS(1239),
    [anon_sym_caller] = ACTIONS(1239),
    [anon_sym_chomp] = ACTIONS(1239),
    [anon_sym_chr] = ACTIONS(1239),
    [anon_sym_cos] = ACTIONS(1239),
    [anon_sym_chroot] = ACTIONS(1239),
    [anon_sym_defined] = ACTIONS(1239),
    [anon_sym_delete] = ACTIONS(1239),
    [anon_sym_dbmclose] = ACTIONS(1239),
    [anon_sym_exists] = ACTIONS(1239),
    [anon_sym_exit] = ACTIONS(1239),
    [anon_sym_eof] = ACTIONS(1239),
    [anon_sym_exp] = ACTIONS(1239),
    [anon_sym_each] = ACTIONS(1239),
    [anon_sym_fc] = ACTIONS(1239),
    [anon_sym_fileno] = ACTIONS(1239),
    [anon_sym_gmtime] = ACTIONS(1239),
    [anon_sym_getc] = ACTIONS(1239),
    [anon_sym_getpgrp] = ACTIONS(1239),
    [anon_sym_getprotobyname] = ACTIONS(1239),
    [anon_sym_getpwname] = ACTIONS(1239),
    [anon_sym_getpwuid] = ACTIONS(1239),
    [anon_sym_getpeername] = ACTIONS(1239),
    [anon_sym_getnetbyname] = ACTIONS(1239),
    [anon_sym_getsockname] = ACTIONS(1239),
    [anon_sym_getgrnam] = ACTIONS(1239),
    [anon_sym_getgrgid] = ACTIONS(1239),
    [anon_sym_hex] = ACTIONS(1239),
    [anon_sym_int] = ACTIONS(1239),
    [anon_sym_keys] = ACTIONS(1239),
    [anon_sym_lc] = ACTIONS(1239),
    [anon_sym_lcfirst] = ACTIONS(1239),
    [anon_sym_length] = ACTIONS(1239),
    [anon_sym_localtime] = ACTIONS(1239),
    [anon_sym_log] = ACTIONS(1239),
    [anon_sym_lock] = ACTIONS(1239),
    [anon_sym_lstat] = ACTIONS(1239),
    [anon_sym_oct] = ACTIONS(1239),
    [anon_sym_ord] = ACTIONS(1239),
    [anon_sym_prototype] = ACTIONS(1239),
    [anon_sym_pop] = ACTIONS(1239),
    [anon_sym_pos] = ACTIONS(1239),
    [anon_sym_quotemeta] = ACTIONS(1239),
    [anon_sym_reset] = ACTIONS(1239),
    [anon_sym_rand] = ACTIONS(1239),
    [anon_sym_rmdir] = ACTIONS(1239),
    [anon_sym_readdir] = ACTIONS(1239),
    [anon_sym_readline] = ACTIONS(1239),
    [anon_sym_readpipe] = ACTIONS(1239),
    [anon_sym_rewinddir] = ACTIONS(1239),
    [anon_sym_readlink] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1239),
    [anon_sym_scalar] = ACTIONS(1239),
    [anon_sym_shift] = ACTIONS(1239),
    [anon_sym_sin] = ACTIONS(1239),
    [anon_sym_sleep] = ACTIONS(1239),
    [anon_sym_sqrt] = ACTIONS(1239),
    [anon_sym_srand] = ACTIONS(1239),
    [anon_sym_stat] = ACTIONS(1239),
    [anon_sym_study] = ACTIONS(1239),
    [anon_sym_tell] = ACTIONS(1239),
    [anon_sym_telldir] = ACTIONS(1239),
    [anon_sym_tied] = ACTIONS(1239),
    [anon_sym_uc] = ACTIONS(1239),
    [anon_sym_ucfirst] = ACTIONS(1239),
    [anon_sym_untie] = ACTIONS(1239),
    [anon_sym_umask] = ACTIONS(1239),
    [anon_sym_values] = ACTIONS(1239),
    [anon_sym_write] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1211),
    [anon_sym___END__] = ACTIONS(1211),
    [anon_sym_q] = ACTIONS(1241),
    [anon_sym_qq] = ACTIONS(1243),
    [anon_sym_qw] = ACTIONS(1245),
    [anon_sym_qx] = ACTIONS(1247),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1249),
    [anon_sym_tr] = ACTIONS(1251),
    [anon_sym_y] = ACTIONS(1251),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_unless] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1255),
    [anon_sym_until] = ACTIONS(1255),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1257),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [227] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(227),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3203),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(265),
    [sym__identifier] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1263),
    [anon_sym_sub] = ACTIONS(1265),
    [anon_sym_method] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_my] = ACTIONS(1271),
    [anon_sym_state] = ACTIONS(1271),
    [anon_sym_our] = ACTIONS(1271),
    [anon_sym_try] = ACTIONS(1273),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1275),
    [anon_sym_elsif] = ACTIONS(1275),
    [anon_sym_and] = ACTIONS(1275),
    [anon_sym_or] = ACTIONS(1275),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1275),
    [anon_sym_ne] = ACTIONS(1275),
    [anon_sym_cmp] = ACTIONS(1275),
    [anon_sym_lt] = ACTIONS(1275),
    [anon_sym_le] = ACTIONS(1275),
    [anon_sym_ge] = ACTIONS(1275),
    [anon_sym_gt] = ACTIONS(1275),
    [anon_sym_isa] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1279),
    [anon_sym_eval] = ACTIONS(1281),
    [anon_sym_field] = ACTIONS(1271),
    [anon_sym_local] = ACTIONS(1283),
    [anon_sym_require] = ACTIONS(1285),
    [anon_sym_map] = ACTIONS(1287),
    [anon_sym_grep] = ACTIONS(1287),
    [anon_sym_sort] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1291),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1293),
    [anon_sym_use] = ACTIONS(1295),
    [anon_sym_no] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_foreach] = ACTIONS(1297),
    [anon_sym_last] = ACTIONS(1299),
    [anon_sym_next] = ACTIONS(1299),
    [anon_sym_redo] = ACTIONS(1299),
    [anon_sym_BEGIN] = ACTIONS(1301),
    [anon_sym_INIT] = ACTIONS(1301),
    [anon_sym_CHECK] = ACTIONS(1301),
    [anon_sym_UNITCHECK] = ACTIONS(1301),
    [anon_sym_END] = ACTIONS(1301),
    [anon_sym_ADJUST] = ACTIONS(1301),
    [anon_sym___FILE__] = ACTIONS(1269),
    [anon_sym___LINE__] = ACTIONS(1269),
    [anon_sym___PACKAGE__] = ACTIONS(1269),
    [anon_sym___SUB__] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_fork] = ACTIONS(1269),
    [anon_sym_getppid] = ACTIONS(1269),
    [anon_sym_time] = ACTIONS(1269),
    [anon_sym_times] = ACTIONS(1269),
    [anon_sym_wait] = ACTIONS(1269),
    [anon_sym_wantarray] = ACTIONS(1269),
    [anon_sym_abs] = ACTIONS(1303),
    [anon_sym_alarm] = ACTIONS(1303),
    [anon_sym_chop] = ACTIONS(1303),
    [anon_sym_chdir] = ACTIONS(1303),
    [anon_sym_close] = ACTIONS(1303),
    [anon_sym_closedir] = ACTIONS(1303),
    [anon_sym_caller] = ACTIONS(1303),
    [anon_sym_chomp] = ACTIONS(1303),
    [anon_sym_chr] = ACTIONS(1303),
    [anon_sym_cos] = ACTIONS(1303),
    [anon_sym_chroot] = ACTIONS(1303),
    [anon_sym_defined] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(1303),
    [anon_sym_dbmclose] = ACTIONS(1303),
    [anon_sym_exists] = ACTIONS(1303),
    [anon_sym_exit] = ACTIONS(1303),
    [anon_sym_eof] = ACTIONS(1303),
    [anon_sym_exp] = ACTIONS(1303),
    [anon_sym_each] = ACTIONS(1303),
    [anon_sym_fc] = ACTIONS(1303),
    [anon_sym_fileno] = ACTIONS(1303),
    [anon_sym_gmtime] = ACTIONS(1303),
    [anon_sym_getc] = ACTIONS(1303),
    [anon_sym_getpgrp] = ACTIONS(1303),
    [anon_sym_getprotobyname] = ACTIONS(1303),
    [anon_sym_getpwname] = ACTIONS(1303),
    [anon_sym_getpwuid] = ACTIONS(1303),
    [anon_sym_getpeername] = ACTIONS(1303),
    [anon_sym_getnetbyname] = ACTIONS(1303),
    [anon_sym_getsockname] = ACTIONS(1303),
    [anon_sym_getgrnam] = ACTIONS(1303),
    [anon_sym_getgrgid] = ACTIONS(1303),
    [anon_sym_hex] = ACTIONS(1303),
    [anon_sym_int] = ACTIONS(1303),
    [anon_sym_keys] = ACTIONS(1303),
    [anon_sym_lc] = ACTIONS(1303),
    [anon_sym_lcfirst] = ACTIONS(1303),
    [anon_sym_length] = ACTIONS(1303),
    [anon_sym_localtime] = ACTIONS(1303),
    [anon_sym_log] = ACTIONS(1303),
    [anon_sym_lock] = ACTIONS(1303),
    [anon_sym_lstat] = ACTIONS(1303),
    [anon_sym_oct] = ACTIONS(1303),
    [anon_sym_ord] = ACTIONS(1303),
    [anon_sym_prototype] = ACTIONS(1303),
    [anon_sym_pop] = ACTIONS(1303),
    [anon_sym_pos] = ACTIONS(1303),
    [anon_sym_quotemeta] = ACTIONS(1303),
    [anon_sym_reset] = ACTIONS(1303),
    [anon_sym_rand] = ACTIONS(1303),
    [anon_sym_rmdir] = ACTIONS(1303),
    [anon_sym_readdir] = ACTIONS(1303),
    [anon_sym_readline] = ACTIONS(1303),
    [anon_sym_readpipe] = ACTIONS(1303),
    [anon_sym_rewinddir] = ACTIONS(1303),
    [anon_sym_readlink] = ACTIONS(1303),
    [anon_sym_ref] = ACTIONS(1303),
    [anon_sym_scalar] = ACTIONS(1303),
    [anon_sym_shift] = ACTIONS(1303),
    [anon_sym_sin] = ACTIONS(1303),
    [anon_sym_sleep] = ACTIONS(1303),
    [anon_sym_sqrt] = ACTIONS(1303),
    [anon_sym_srand] = ACTIONS(1303),
    [anon_sym_stat] = ACTIONS(1303),
    [anon_sym_study] = ACTIONS(1303),
    [anon_sym_tell] = ACTIONS(1303),
    [anon_sym_telldir] = ACTIONS(1303),
    [anon_sym_tied] = ACTIONS(1303),
    [anon_sym_uc] = ACTIONS(1303),
    [anon_sym_ucfirst] = ACTIONS(1303),
    [anon_sym_untie] = ACTIONS(1303),
    [anon_sym_umask] = ACTIONS(1303),
    [anon_sym_values] = ACTIONS(1303),
    [anon_sym_write] = ACTIONS(1303),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1275),
    [anon_sym___END__] = ACTIONS(1275),
    [anon_sym_q] = ACTIONS(1305),
    [anon_sym_qq] = ACTIONS(1307),
    [anon_sym_qw] = ACTIONS(1309),
    [anon_sym_qx] = ACTIONS(1311),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1313),
    [anon_sym_tr] = ACTIONS(1315),
    [anon_sym_y] = ACTIONS(1315),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_unless] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1319),
    [anon_sym_until] = ACTIONS(1319),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1321),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [228] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(228),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3143),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(272),
    [sym__identifier] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_sub] = ACTIONS(1329),
    [anon_sym_method] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_my] = ACTIONS(1335),
    [anon_sym_state] = ACTIONS(1335),
    [anon_sym_our] = ACTIONS(1335),
    [anon_sym_try] = ACTIONS(1337),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1339),
    [anon_sym_elsif] = ACTIONS(1339),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1339),
    [anon_sym_ne] = ACTIONS(1339),
    [anon_sym_cmp] = ACTIONS(1339),
    [anon_sym_lt] = ACTIONS(1339),
    [anon_sym_le] = ACTIONS(1339),
    [anon_sym_ge] = ACTIONS(1339),
    [anon_sym_gt] = ACTIONS(1339),
    [anon_sym_isa] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1343),
    [anon_sym_eval] = ACTIONS(1345),
    [anon_sym_field] = ACTIONS(1335),
    [anon_sym_local] = ACTIONS(1347),
    [anon_sym_require] = ACTIONS(1349),
    [anon_sym_map] = ACTIONS(1351),
    [anon_sym_grep] = ACTIONS(1351),
    [anon_sym_sort] = ACTIONS(1353),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1355),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1357),
    [anon_sym_use] = ACTIONS(1359),
    [anon_sym_no] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_foreach] = ACTIONS(1361),
    [anon_sym_last] = ACTIONS(1363),
    [anon_sym_next] = ACTIONS(1363),
    [anon_sym_redo] = ACTIONS(1363),
    [anon_sym_BEGIN] = ACTIONS(1365),
    [anon_sym_INIT] = ACTIONS(1365),
    [anon_sym_CHECK] = ACTIONS(1365),
    [anon_sym_UNITCHECK] = ACTIONS(1365),
    [anon_sym_END] = ACTIONS(1365),
    [anon_sym_ADJUST] = ACTIONS(1365),
    [anon_sym___FILE__] = ACTIONS(1333),
    [anon_sym___LINE__] = ACTIONS(1333),
    [anon_sym___PACKAGE__] = ACTIONS(1333),
    [anon_sym___SUB__] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_fork] = ACTIONS(1333),
    [anon_sym_getppid] = ACTIONS(1333),
    [anon_sym_time] = ACTIONS(1333),
    [anon_sym_times] = ACTIONS(1333),
    [anon_sym_wait] = ACTIONS(1333),
    [anon_sym_wantarray] = ACTIONS(1333),
    [anon_sym_abs] = ACTIONS(1367),
    [anon_sym_alarm] = ACTIONS(1367),
    [anon_sym_chop] = ACTIONS(1367),
    [anon_sym_chdir] = ACTIONS(1367),
    [anon_sym_close] = ACTIONS(1367),
    [anon_sym_closedir] = ACTIONS(1367),
    [anon_sym_caller] = ACTIONS(1367),
    [anon_sym_chomp] = ACTIONS(1367),
    [anon_sym_chr] = ACTIONS(1367),
    [anon_sym_cos] = ACTIONS(1367),
    [anon_sym_chroot] = ACTIONS(1367),
    [anon_sym_defined] = ACTIONS(1367),
    [anon_sym_delete] = ACTIONS(1367),
    [anon_sym_dbmclose] = ACTIONS(1367),
    [anon_sym_exists] = ACTIONS(1367),
    [anon_sym_exit] = ACTIONS(1367),
    [anon_sym_eof] = ACTIONS(1367),
    [anon_sym_exp] = ACTIONS(1367),
    [anon_sym_each] = ACTIONS(1367),
    [anon_sym_fc] = ACTIONS(1367),
    [anon_sym_fileno] = ACTIONS(1367),
    [anon_sym_gmtime] = ACTIONS(1367),
    [anon_sym_getc] = ACTIONS(1367),
    [anon_sym_getpgrp] = ACTIONS(1367),
    [anon_sym_getprotobyname] = ACTIONS(1367),
    [anon_sym_getpwname] = ACTIONS(1367),
    [anon_sym_getpwuid] = ACTIONS(1367),
    [anon_sym_getpeername] = ACTIONS(1367),
    [anon_sym_getnetbyname] = ACTIONS(1367),
    [anon_sym_getsockname] = ACTIONS(1367),
    [anon_sym_getgrnam] = ACTIONS(1367),
    [anon_sym_getgrgid] = ACTIONS(1367),
    [anon_sym_hex] = ACTIONS(1367),
    [anon_sym_int] = ACTIONS(1367),
    [anon_sym_keys] = ACTIONS(1367),
    [anon_sym_lc] = ACTIONS(1367),
    [anon_sym_lcfirst] = ACTIONS(1367),
    [anon_sym_length] = ACTIONS(1367),
    [anon_sym_localtime] = ACTIONS(1367),
    [anon_sym_log] = ACTIONS(1367),
    [anon_sym_lock] = ACTIONS(1367),
    [anon_sym_lstat] = ACTIONS(1367),
    [anon_sym_oct] = ACTIONS(1367),
    [anon_sym_ord] = ACTIONS(1367),
    [anon_sym_prototype] = ACTIONS(1367),
    [anon_sym_pop] = ACTIONS(1367),
    [anon_sym_pos] = ACTIONS(1367),
    [anon_sym_quotemeta] = ACTIONS(1367),
    [anon_sym_reset] = ACTIONS(1367),
    [anon_sym_rand] = ACTIONS(1367),
    [anon_sym_rmdir] = ACTIONS(1367),
    [anon_sym_readdir] = ACTIONS(1367),
    [anon_sym_readline] = ACTIONS(1367),
    [anon_sym_readpipe] = ACTIONS(1367),
    [anon_sym_rewinddir] = ACTIONS(1367),
    [anon_sym_readlink] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1367),
    [anon_sym_scalar] = ACTIONS(1367),
    [anon_sym_shift] = ACTIONS(1367),
    [anon_sym_sin] = ACTIONS(1367),
    [anon_sym_sleep] = ACTIONS(1367),
    [anon_sym_sqrt] = ACTIONS(1367),
    [anon_sym_srand] = ACTIONS(1367),
    [anon_sym_stat] = ACTIONS(1367),
    [anon_sym_study] = ACTIONS(1367),
    [anon_sym_tell] = ACTIONS(1367),
    [anon_sym_telldir] = ACTIONS(1367),
    [anon_sym_tied] = ACTIONS(1367),
    [anon_sym_uc] = ACTIONS(1367),
    [anon_sym_ucfirst] = ACTIONS(1367),
    [anon_sym_untie] = ACTIONS(1367),
    [anon_sym_umask] = ACTIONS(1367),
    [anon_sym_values] = ACTIONS(1367),
    [anon_sym_write] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1339),
    [anon_sym___END__] = ACTIONS(1339),
    [anon_sym_q] = ACTIONS(1369),
    [anon_sym_qq] = ACTIONS(1371),
    [anon_sym_qw] = ACTIONS(1373),
    [anon_sym_qx] = ACTIONS(1375),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1377),
    [anon_sym_tr] = ACTIONS(1379),
    [anon_sym_y] = ACTIONS(1379),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_unless] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_until] = ACTIONS(1383),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1385),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [229] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(229),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3246),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(247),
    [sym__identifier] = ACTIONS(1387),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1391),
    [anon_sym_sub] = ACTIONS(1393),
    [anon_sym_method] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_my] = ACTIONS(1399),
    [anon_sym_state] = ACTIONS(1399),
    [anon_sym_our] = ACTIONS(1399),
    [anon_sym_try] = ACTIONS(1401),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_elsif] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_or] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1403),
    [anon_sym_ne] = ACTIONS(1403),
    [anon_sym_cmp] = ACTIONS(1403),
    [anon_sym_lt] = ACTIONS(1403),
    [anon_sym_le] = ACTIONS(1403),
    [anon_sym_ge] = ACTIONS(1403),
    [anon_sym_gt] = ACTIONS(1403),
    [anon_sym_isa] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1407),
    [anon_sym_eval] = ACTIONS(1409),
    [anon_sym_field] = ACTIONS(1399),
    [anon_sym_local] = ACTIONS(1411),
    [anon_sym_require] = ACTIONS(1413),
    [anon_sym_map] = ACTIONS(1415),
    [anon_sym_grep] = ACTIONS(1415),
    [anon_sym_sort] = ACTIONS(1417),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1421),
    [anon_sym_use] = ACTIONS(1423),
    [anon_sym_no] = ACTIONS(1423),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_foreach] = ACTIONS(1425),
    [anon_sym_last] = ACTIONS(1427),
    [anon_sym_next] = ACTIONS(1427),
    [anon_sym_redo] = ACTIONS(1427),
    [anon_sym_BEGIN] = ACTIONS(1429),
    [anon_sym_INIT] = ACTIONS(1429),
    [anon_sym_CHECK] = ACTIONS(1429),
    [anon_sym_UNITCHECK] = ACTIONS(1429),
    [anon_sym_END] = ACTIONS(1429),
    [anon_sym_ADJUST] = ACTIONS(1429),
    [anon_sym___FILE__] = ACTIONS(1397),
    [anon_sym___LINE__] = ACTIONS(1397),
    [anon_sym___PACKAGE__] = ACTIONS(1397),
    [anon_sym___SUB__] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_fork] = ACTIONS(1397),
    [anon_sym_getppid] = ACTIONS(1397),
    [anon_sym_time] = ACTIONS(1397),
    [anon_sym_times] = ACTIONS(1397),
    [anon_sym_wait] = ACTIONS(1397),
    [anon_sym_wantarray] = ACTIONS(1397),
    [anon_sym_abs] = ACTIONS(1431),
    [anon_sym_alarm] = ACTIONS(1431),
    [anon_sym_chop] = ACTIONS(1431),
    [anon_sym_chdir] = ACTIONS(1431),
    [anon_sym_close] = ACTIONS(1431),
    [anon_sym_closedir] = ACTIONS(1431),
    [anon_sym_caller] = ACTIONS(1431),
    [anon_sym_chomp] = ACTIONS(1431),
    [anon_sym_chr] = ACTIONS(1431),
    [anon_sym_cos] = ACTIONS(1431),
    [anon_sym_chroot] = ACTIONS(1431),
    [anon_sym_defined] = ACTIONS(1431),
    [anon_sym_delete] = ACTIONS(1431),
    [anon_sym_dbmclose] = ACTIONS(1431),
    [anon_sym_exists] = ACTIONS(1431),
    [anon_sym_exit] = ACTIONS(1431),
    [anon_sym_eof] = ACTIONS(1431),
    [anon_sym_exp] = ACTIONS(1431),
    [anon_sym_each] = ACTIONS(1431),
    [anon_sym_fc] = ACTIONS(1431),
    [anon_sym_fileno] = ACTIONS(1431),
    [anon_sym_gmtime] = ACTIONS(1431),
    [anon_sym_getc] = ACTIONS(1431),
    [anon_sym_getpgrp] = ACTIONS(1431),
    [anon_sym_getprotobyname] = ACTIONS(1431),
    [anon_sym_getpwname] = ACTIONS(1431),
    [anon_sym_getpwuid] = ACTIONS(1431),
    [anon_sym_getpeername] = ACTIONS(1431),
    [anon_sym_getnetbyname] = ACTIONS(1431),
    [anon_sym_getsockname] = ACTIONS(1431),
    [anon_sym_getgrnam] = ACTIONS(1431),
    [anon_sym_getgrgid] = ACTIONS(1431),
    [anon_sym_hex] = ACTIONS(1431),
    [anon_sym_int] = ACTIONS(1431),
    [anon_sym_keys] = ACTIONS(1431),
    [anon_sym_lc] = ACTIONS(1431),
    [anon_sym_lcfirst] = ACTIONS(1431),
    [anon_sym_length] = ACTIONS(1431),
    [anon_sym_localtime] = ACTIONS(1431),
    [anon_sym_log] = ACTIONS(1431),
    [anon_sym_lock] = ACTIONS(1431),
    [anon_sym_lstat] = ACTIONS(1431),
    [anon_sym_oct] = ACTIONS(1431),
    [anon_sym_ord] = ACTIONS(1431),
    [anon_sym_prototype] = ACTIONS(1431),
    [anon_sym_pop] = ACTIONS(1431),
    [anon_sym_pos] = ACTIONS(1431),
    [anon_sym_quotemeta] = ACTIONS(1431),
    [anon_sym_reset] = ACTIONS(1431),
    [anon_sym_rand] = ACTIONS(1431),
    [anon_sym_rmdir] = ACTIONS(1431),
    [anon_sym_readdir] = ACTIONS(1431),
    [anon_sym_readline] = ACTIONS(1431),
    [anon_sym_readpipe] = ACTIONS(1431),
    [anon_sym_rewinddir] = ACTIONS(1431),
    [anon_sym_readlink] = ACTIONS(1431),
    [anon_sym_ref] = ACTIONS(1431),
    [anon_sym_scalar] = ACTIONS(1431),
    [anon_sym_shift] = ACTIONS(1431),
    [anon_sym_sin] = ACTIONS(1431),
    [anon_sym_sleep] = ACTIONS(1431),
    [anon_sym_sqrt] = ACTIONS(1431),
    [anon_sym_srand] = ACTIONS(1431),
    [anon_sym_stat] = ACTIONS(1431),
    [anon_sym_study] = ACTIONS(1431),
    [anon_sym_tell] = ACTIONS(1431),
    [anon_sym_telldir] = ACTIONS(1431),
    [anon_sym_tied] = ACTIONS(1431),
    [anon_sym_uc] = ACTIONS(1431),
    [anon_sym_ucfirst] = ACTIONS(1431),
    [anon_sym_untie] = ACTIONS(1431),
    [anon_sym_umask] = ACTIONS(1431),
    [anon_sym_values] = ACTIONS(1431),
    [anon_sym_write] = ACTIONS(1431),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1403),
    [anon_sym___END__] = ACTIONS(1403),
    [anon_sym_q] = ACTIONS(1433),
    [anon_sym_qq] = ACTIONS(1435),
    [anon_sym_qw] = ACTIONS(1437),
    [anon_sym_qx] = ACTIONS(1439),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1441),
    [anon_sym_tr] = ACTIONS(1443),
    [anon_sym_y] = ACTIONS(1443),
    [anon_sym_if] = ACTIONS(1445),
    [anon_sym_unless] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_until] = ACTIONS(1447),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1449),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [230] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(230),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3152),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(258),
    [sym__identifier] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1453),
    [anon_sym_sub] = ACTIONS(1455),
    [anon_sym_method] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1459),
    [anon_sym_my] = ACTIONS(1461),
    [anon_sym_state] = ACTIONS(1461),
    [anon_sym_our] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1463),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_elsif] = ACTIONS(1465),
    [anon_sym_and] = ACTIONS(1465),
    [anon_sym_or] = ACTIONS(1465),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1467),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1465),
    [anon_sym_ne] = ACTIONS(1465),
    [anon_sym_cmp] = ACTIONS(1465),
    [anon_sym_lt] = ACTIONS(1465),
    [anon_sym_le] = ACTIONS(1465),
    [anon_sym_ge] = ACTIONS(1465),
    [anon_sym_gt] = ACTIONS(1465),
    [anon_sym_isa] = ACTIONS(1465),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_eval] = ACTIONS(1471),
    [anon_sym_field] = ACTIONS(1461),
    [anon_sym_local] = ACTIONS(1473),
    [anon_sym_require] = ACTIONS(1475),
    [anon_sym_map] = ACTIONS(1477),
    [anon_sym_grep] = ACTIONS(1477),
    [anon_sym_sort] = ACTIONS(1479),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1481),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1485),
    [anon_sym_no] = ACTIONS(1485),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_foreach] = ACTIONS(1487),
    [anon_sym_last] = ACTIONS(1489),
    [anon_sym_next] = ACTIONS(1489),
    [anon_sym_redo] = ACTIONS(1489),
    [anon_sym_BEGIN] = ACTIONS(1491),
    [anon_sym_INIT] = ACTIONS(1491),
    [anon_sym_CHECK] = ACTIONS(1491),
    [anon_sym_UNITCHECK] = ACTIONS(1491),
    [anon_sym_END] = ACTIONS(1491),
    [anon_sym_ADJUST] = ACTIONS(1491),
    [anon_sym___FILE__] = ACTIONS(1459),
    [anon_sym___LINE__] = ACTIONS(1459),
    [anon_sym___PACKAGE__] = ACTIONS(1459),
    [anon_sym___SUB__] = ACTIONS(1459),
    [anon_sym_break] = ACTIONS(1459),
    [anon_sym_fork] = ACTIONS(1459),
    [anon_sym_getppid] = ACTIONS(1459),
    [anon_sym_time] = ACTIONS(1459),
    [anon_sym_times] = ACTIONS(1459),
    [anon_sym_wait] = ACTIONS(1459),
    [anon_sym_wantarray] = ACTIONS(1459),
    [anon_sym_abs] = ACTIONS(1493),
    [anon_sym_alarm] = ACTIONS(1493),
    [anon_sym_chop] = ACTIONS(1493),
    [anon_sym_chdir] = ACTIONS(1493),
    [anon_sym_close] = ACTIONS(1493),
    [anon_sym_closedir] = ACTIONS(1493),
    [anon_sym_caller] = ACTIONS(1493),
    [anon_sym_chomp] = ACTIONS(1493),
    [anon_sym_chr] = ACTIONS(1493),
    [anon_sym_cos] = ACTIONS(1493),
    [anon_sym_chroot] = ACTIONS(1493),
    [anon_sym_defined] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1493),
    [anon_sym_dbmclose] = ACTIONS(1493),
    [anon_sym_exists] = ACTIONS(1493),
    [anon_sym_exit] = ACTIONS(1493),
    [anon_sym_eof] = ACTIONS(1493),
    [anon_sym_exp] = ACTIONS(1493),
    [anon_sym_each] = ACTIONS(1493),
    [anon_sym_fc] = ACTIONS(1493),
    [anon_sym_fileno] = ACTIONS(1493),
    [anon_sym_gmtime] = ACTIONS(1493),
    [anon_sym_getc] = ACTIONS(1493),
    [anon_sym_getpgrp] = ACTIONS(1493),
    [anon_sym_getprotobyname] = ACTIONS(1493),
    [anon_sym_getpwname] = ACTIONS(1493),
    [anon_sym_getpwuid] = ACTIONS(1493),
    [anon_sym_getpeername] = ACTIONS(1493),
    [anon_sym_getnetbyname] = ACTIONS(1493),
    [anon_sym_getsockname] = ACTIONS(1493),
    [anon_sym_getgrnam] = ACTIONS(1493),
    [anon_sym_getgrgid] = ACTIONS(1493),
    [anon_sym_hex] = ACTIONS(1493),
    [anon_sym_int] = ACTIONS(1493),
    [anon_sym_keys] = ACTIONS(1493),
    [anon_sym_lc] = ACTIONS(1493),
    [anon_sym_lcfirst] = ACTIONS(1493),
    [anon_sym_length] = ACTIONS(1493),
    [anon_sym_localtime] = ACTIONS(1493),
    [anon_sym_log] = ACTIONS(1493),
    [anon_sym_lock] = ACTIONS(1493),
    [anon_sym_lstat] = ACTIONS(1493),
    [anon_sym_oct] = ACTIONS(1493),
    [anon_sym_ord] = ACTIONS(1493),
    [anon_sym_prototype] = ACTIONS(1493),
    [anon_sym_pop] = ACTIONS(1493),
    [anon_sym_pos] = ACTIONS(1493),
    [anon_sym_quotemeta] = ACTIONS(1493),
    [anon_sym_reset] = ACTIONS(1493),
    [anon_sym_rand] = ACTIONS(1493),
    [anon_sym_rmdir] = ACTIONS(1493),
    [anon_sym_readdir] = ACTIONS(1493),
    [anon_sym_readline] = ACTIONS(1493),
    [anon_sym_readpipe] = ACTIONS(1493),
    [anon_sym_rewinddir] = ACTIONS(1493),
    [anon_sym_readlink] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1493),
    [anon_sym_scalar] = ACTIONS(1493),
    [anon_sym_shift] = ACTIONS(1493),
    [anon_sym_sin] = ACTIONS(1493),
    [anon_sym_sleep] = ACTIONS(1493),
    [anon_sym_sqrt] = ACTIONS(1493),
    [anon_sym_srand] = ACTIONS(1493),
    [anon_sym_stat] = ACTIONS(1493),
    [anon_sym_study] = ACTIONS(1493),
    [anon_sym_tell] = ACTIONS(1493),
    [anon_sym_telldir] = ACTIONS(1493),
    [anon_sym_tied] = ACTIONS(1493),
    [anon_sym_uc] = ACTIONS(1493),
    [anon_sym_ucfirst] = ACTIONS(1493),
    [anon_sym_untie] = ACTIONS(1493),
    [anon_sym_umask] = ACTIONS(1493),
    [anon_sym_values] = ACTIONS(1493),
    [anon_sym_write] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1465),
    [anon_sym___END__] = ACTIONS(1465),
    [anon_sym_q] = ACTIONS(1495),
    [anon_sym_qq] = ACTIONS(1497),
    [anon_sym_qw] = ACTIONS(1499),
    [anon_sym_qx] = ACTIONS(1501),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1503),
    [anon_sym_tr] = ACTIONS(1505),
    [anon_sym_y] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_unless] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1509),
    [anon_sym_until] = ACTIONS(1509),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1511),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [231] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(276),
    [sym_block] = STATE(995),
    [sym__fullstmt] = STATE(996),
    [sym_statement_label] = STATE(998),
    [sym__barestmt] = STATE(998),
    [sym_package_statement] = STATE(991),
    [sym_class_statement] = STATE(991),
    [sym_use_version_statement] = STATE(991),
    [sym_use_statement] = STATE(991),
    [sym_subroutine_declaration_statement] = STATE(991),
    [sym_method_declaration_statement] = STATE(991),
    [sym_phaser_statement] = STATE(991),
    [sym_conditional_statement] = STATE(991),
    [sym_loop_statement] = STATE(991),
    [sym_cstyle_for_statement] = STATE(991),
    [sym_for_statement] = STATE(991),
    [sym_try_statement] = STATE(991),
    [sym_defer_statement] = STATE(991),
    [sym_expression_statement] = STATE(2414),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym___DATA__] = STATE(3184),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(231),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3186),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(241),
    [ts_builtin_sym_end] = ACTIONS(1513),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(19),
    [anon_sym_class] = ACTIONS(21),
    [anon_sym_sub] = ACTIONS(23),
    [anon_sym_method] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_defer] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(85),
    [anon_sym_no] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_foreach] = ACTIONS(87),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(91),
    [anon_sym_INIT] = ACTIONS(91),
    [anon_sym_CHECK] = ACTIONS(91),
    [anon_sym_UNITCHECK] = ACTIONS(91),
    [anon_sym_END] = ACTIONS(91),
    [anon_sym_ADJUST] = ACTIONS(91),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(95),
    [anon_sym___END__] = ACTIONS(95),
    [anon_sym_EOT] = ACTIONS(97),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(117),
    [anon_sym_until] = ACTIONS(117),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(133),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [232] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(232),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3278),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(262),
    [sym__identifier] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1517),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1519),
    [anon_sym_sub] = ACTIONS(1521),
    [anon_sym_method] = ACTIONS(1523),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1525),
    [anon_sym_my] = ACTIONS(1527),
    [anon_sym_state] = ACTIONS(1527),
    [anon_sym_our] = ACTIONS(1527),
    [anon_sym_try] = ACTIONS(1529),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1531),
    [anon_sym_elsif] = ACTIONS(1531),
    [anon_sym_and] = ACTIONS(1531),
    [anon_sym_or] = ACTIONS(1531),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1531),
    [anon_sym_ne] = ACTIONS(1531),
    [anon_sym_cmp] = ACTIONS(1531),
    [anon_sym_lt] = ACTIONS(1531),
    [anon_sym_le] = ACTIONS(1531),
    [anon_sym_ge] = ACTIONS(1531),
    [anon_sym_gt] = ACTIONS(1531),
    [anon_sym_isa] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_eval] = ACTIONS(1537),
    [anon_sym_field] = ACTIONS(1527),
    [anon_sym_local] = ACTIONS(1539),
    [anon_sym_require] = ACTIONS(1541),
    [anon_sym_map] = ACTIONS(1543),
    [anon_sym_grep] = ACTIONS(1543),
    [anon_sym_sort] = ACTIONS(1545),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1547),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1549),
    [anon_sym_use] = ACTIONS(1551),
    [anon_sym_no] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_foreach] = ACTIONS(1553),
    [anon_sym_last] = ACTIONS(1555),
    [anon_sym_next] = ACTIONS(1555),
    [anon_sym_redo] = ACTIONS(1555),
    [anon_sym_BEGIN] = ACTIONS(1557),
    [anon_sym_INIT] = ACTIONS(1557),
    [anon_sym_CHECK] = ACTIONS(1557),
    [anon_sym_UNITCHECK] = ACTIONS(1557),
    [anon_sym_END] = ACTIONS(1557),
    [anon_sym_ADJUST] = ACTIONS(1557),
    [anon_sym___FILE__] = ACTIONS(1525),
    [anon_sym___LINE__] = ACTIONS(1525),
    [anon_sym___PACKAGE__] = ACTIONS(1525),
    [anon_sym___SUB__] = ACTIONS(1525),
    [anon_sym_break] = ACTIONS(1525),
    [anon_sym_fork] = ACTIONS(1525),
    [anon_sym_getppid] = ACTIONS(1525),
    [anon_sym_time] = ACTIONS(1525),
    [anon_sym_times] = ACTIONS(1525),
    [anon_sym_wait] = ACTIONS(1525),
    [anon_sym_wantarray] = ACTIONS(1525),
    [anon_sym_abs] = ACTIONS(1559),
    [anon_sym_alarm] = ACTIONS(1559),
    [anon_sym_chop] = ACTIONS(1559),
    [anon_sym_chdir] = ACTIONS(1559),
    [anon_sym_close] = ACTIONS(1559),
    [anon_sym_closedir] = ACTIONS(1559),
    [anon_sym_caller] = ACTIONS(1559),
    [anon_sym_chomp] = ACTIONS(1559),
    [anon_sym_chr] = ACTIONS(1559),
    [anon_sym_cos] = ACTIONS(1559),
    [anon_sym_chroot] = ACTIONS(1559),
    [anon_sym_defined] = ACTIONS(1559),
    [anon_sym_delete] = ACTIONS(1559),
    [anon_sym_dbmclose] = ACTIONS(1559),
    [anon_sym_exists] = ACTIONS(1559),
    [anon_sym_exit] = ACTIONS(1559),
    [anon_sym_eof] = ACTIONS(1559),
    [anon_sym_exp] = ACTIONS(1559),
    [anon_sym_each] = ACTIONS(1559),
    [anon_sym_fc] = ACTIONS(1559),
    [anon_sym_fileno] = ACTIONS(1559),
    [anon_sym_gmtime] = ACTIONS(1559),
    [anon_sym_getc] = ACTIONS(1559),
    [anon_sym_getpgrp] = ACTIONS(1559),
    [anon_sym_getprotobyname] = ACTIONS(1559),
    [anon_sym_getpwname] = ACTIONS(1559),
    [anon_sym_getpwuid] = ACTIONS(1559),
    [anon_sym_getpeername] = ACTIONS(1559),
    [anon_sym_getnetbyname] = ACTIONS(1559),
    [anon_sym_getsockname] = ACTIONS(1559),
    [anon_sym_getgrnam] = ACTIONS(1559),
    [anon_sym_getgrgid] = ACTIONS(1559),
    [anon_sym_hex] = ACTIONS(1559),
    [anon_sym_int] = ACTIONS(1559),
    [anon_sym_keys] = ACTIONS(1559),
    [anon_sym_lc] = ACTIONS(1559),
    [anon_sym_lcfirst] = ACTIONS(1559),
    [anon_sym_length] = ACTIONS(1559),
    [anon_sym_localtime] = ACTIONS(1559),
    [anon_sym_log] = ACTIONS(1559),
    [anon_sym_lock] = ACTIONS(1559),
    [anon_sym_lstat] = ACTIONS(1559),
    [anon_sym_oct] = ACTIONS(1559),
    [anon_sym_ord] = ACTIONS(1559),
    [anon_sym_prototype] = ACTIONS(1559),
    [anon_sym_pop] = ACTIONS(1559),
    [anon_sym_pos] = ACTIONS(1559),
    [anon_sym_quotemeta] = ACTIONS(1559),
    [anon_sym_reset] = ACTIONS(1559),
    [anon_sym_rand] = ACTIONS(1559),
    [anon_sym_rmdir] = ACTIONS(1559),
    [anon_sym_readdir] = ACTIONS(1559),
    [anon_sym_readline] = ACTIONS(1559),
    [anon_sym_readpipe] = ACTIONS(1559),
    [anon_sym_rewinddir] = ACTIONS(1559),
    [anon_sym_readlink] = ACTIONS(1559),
    [anon_sym_ref] = ACTIONS(1559),
    [anon_sym_scalar] = ACTIONS(1559),
    [anon_sym_shift] = ACTIONS(1559),
    [anon_sym_sin] = ACTIONS(1559),
    [anon_sym_sleep] = ACTIONS(1559),
    [anon_sym_sqrt] = ACTIONS(1559),
    [anon_sym_srand] = ACTIONS(1559),
    [anon_sym_stat] = ACTIONS(1559),
    [anon_sym_study] = ACTIONS(1559),
    [anon_sym_tell] = ACTIONS(1559),
    [anon_sym_telldir] = ACTIONS(1559),
    [anon_sym_tied] = ACTIONS(1559),
    [anon_sym_uc] = ACTIONS(1559),
    [anon_sym_ucfirst] = ACTIONS(1559),
    [anon_sym_untie] = ACTIONS(1559),
    [anon_sym_umask] = ACTIONS(1559),
    [anon_sym_values] = ACTIONS(1559),
    [anon_sym_write] = ACTIONS(1559),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1531),
    [anon_sym___END__] = ACTIONS(1531),
    [anon_sym_q] = ACTIONS(1561),
    [anon_sym_qq] = ACTIONS(1563),
    [anon_sym_qw] = ACTIONS(1565),
    [anon_sym_qx] = ACTIONS(1567),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1569),
    [anon_sym_tr] = ACTIONS(1571),
    [anon_sym_y] = ACTIONS(1571),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_unless] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1575),
    [anon_sym_until] = ACTIONS(1575),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1577),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [233] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(233),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3157),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(251),
    [sym__identifier] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1583),
    [anon_sym_sub] = ACTIONS(1585),
    [anon_sym_method] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1589),
    [anon_sym_my] = ACTIONS(1591),
    [anon_sym_state] = ACTIONS(1591),
    [anon_sym_our] = ACTIONS(1591),
    [anon_sym_try] = ACTIONS(1593),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1595),
    [anon_sym_elsif] = ACTIONS(1595),
    [anon_sym_and] = ACTIONS(1595),
    [anon_sym_or] = ACTIONS(1595),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1595),
    [anon_sym_ne] = ACTIONS(1595),
    [anon_sym_cmp] = ACTIONS(1595),
    [anon_sym_lt] = ACTIONS(1595),
    [anon_sym_le] = ACTIONS(1595),
    [anon_sym_ge] = ACTIONS(1595),
    [anon_sym_gt] = ACTIONS(1595),
    [anon_sym_isa] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_eval] = ACTIONS(1601),
    [anon_sym_field] = ACTIONS(1591),
    [anon_sym_local] = ACTIONS(1603),
    [anon_sym_require] = ACTIONS(1605),
    [anon_sym_map] = ACTIONS(1607),
    [anon_sym_grep] = ACTIONS(1607),
    [anon_sym_sort] = ACTIONS(1609),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1613),
    [anon_sym_use] = ACTIONS(1615),
    [anon_sym_no] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1617),
    [anon_sym_foreach] = ACTIONS(1617),
    [anon_sym_last] = ACTIONS(1619),
    [anon_sym_next] = ACTIONS(1619),
    [anon_sym_redo] = ACTIONS(1619),
    [anon_sym_BEGIN] = ACTIONS(1621),
    [anon_sym_INIT] = ACTIONS(1621),
    [anon_sym_CHECK] = ACTIONS(1621),
    [anon_sym_UNITCHECK] = ACTIONS(1621),
    [anon_sym_END] = ACTIONS(1621),
    [anon_sym_ADJUST] = ACTIONS(1621),
    [anon_sym___FILE__] = ACTIONS(1589),
    [anon_sym___LINE__] = ACTIONS(1589),
    [anon_sym___PACKAGE__] = ACTIONS(1589),
    [anon_sym___SUB__] = ACTIONS(1589),
    [anon_sym_break] = ACTIONS(1589),
    [anon_sym_fork] = ACTIONS(1589),
    [anon_sym_getppid] = ACTIONS(1589),
    [anon_sym_time] = ACTIONS(1589),
    [anon_sym_times] = ACTIONS(1589),
    [anon_sym_wait] = ACTIONS(1589),
    [anon_sym_wantarray] = ACTIONS(1589),
    [anon_sym_abs] = ACTIONS(1623),
    [anon_sym_alarm] = ACTIONS(1623),
    [anon_sym_chop] = ACTIONS(1623),
    [anon_sym_chdir] = ACTIONS(1623),
    [anon_sym_close] = ACTIONS(1623),
    [anon_sym_closedir] = ACTIONS(1623),
    [anon_sym_caller] = ACTIONS(1623),
    [anon_sym_chomp] = ACTIONS(1623),
    [anon_sym_chr] = ACTIONS(1623),
    [anon_sym_cos] = ACTIONS(1623),
    [anon_sym_chroot] = ACTIONS(1623),
    [anon_sym_defined] = ACTIONS(1623),
    [anon_sym_delete] = ACTIONS(1623),
    [anon_sym_dbmclose] = ACTIONS(1623),
    [anon_sym_exists] = ACTIONS(1623),
    [anon_sym_exit] = ACTIONS(1623),
    [anon_sym_eof] = ACTIONS(1623),
    [anon_sym_exp] = ACTIONS(1623),
    [anon_sym_each] = ACTIONS(1623),
    [anon_sym_fc] = ACTIONS(1623),
    [anon_sym_fileno] = ACTIONS(1623),
    [anon_sym_gmtime] = ACTIONS(1623),
    [anon_sym_getc] = ACTIONS(1623),
    [anon_sym_getpgrp] = ACTIONS(1623),
    [anon_sym_getprotobyname] = ACTIONS(1623),
    [anon_sym_getpwname] = ACTIONS(1623),
    [anon_sym_getpwuid] = ACTIONS(1623),
    [anon_sym_getpeername] = ACTIONS(1623),
    [anon_sym_getnetbyname] = ACTIONS(1623),
    [anon_sym_getsockname] = ACTIONS(1623),
    [anon_sym_getgrnam] = ACTIONS(1623),
    [anon_sym_getgrgid] = ACTIONS(1623),
    [anon_sym_hex] = ACTIONS(1623),
    [anon_sym_int] = ACTIONS(1623),
    [anon_sym_keys] = ACTIONS(1623),
    [anon_sym_lc] = ACTIONS(1623),
    [anon_sym_lcfirst] = ACTIONS(1623),
    [anon_sym_length] = ACTIONS(1623),
    [anon_sym_localtime] = ACTIONS(1623),
    [anon_sym_log] = ACTIONS(1623),
    [anon_sym_lock] = ACTIONS(1623),
    [anon_sym_lstat] = ACTIONS(1623),
    [anon_sym_oct] = ACTIONS(1623),
    [anon_sym_ord] = ACTIONS(1623),
    [anon_sym_prototype] = ACTIONS(1623),
    [anon_sym_pop] = ACTIONS(1623),
    [anon_sym_pos] = ACTIONS(1623),
    [anon_sym_quotemeta] = ACTIONS(1623),
    [anon_sym_reset] = ACTIONS(1623),
    [anon_sym_rand] = ACTIONS(1623),
    [anon_sym_rmdir] = ACTIONS(1623),
    [anon_sym_readdir] = ACTIONS(1623),
    [anon_sym_readline] = ACTIONS(1623),
    [anon_sym_readpipe] = ACTIONS(1623),
    [anon_sym_rewinddir] = ACTIONS(1623),
    [anon_sym_readlink] = ACTIONS(1623),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_scalar] = ACTIONS(1623),
    [anon_sym_shift] = ACTIONS(1623),
    [anon_sym_sin] = ACTIONS(1623),
    [anon_sym_sleep] = ACTIONS(1623),
    [anon_sym_sqrt] = ACTIONS(1623),
    [anon_sym_srand] = ACTIONS(1623),
    [anon_sym_stat] = ACTIONS(1623),
    [anon_sym_study] = ACTIONS(1623),
    [anon_sym_tell] = ACTIONS(1623),
    [anon_sym_telldir] = ACTIONS(1623),
    [anon_sym_tied] = ACTIONS(1623),
    [anon_sym_uc] = ACTIONS(1623),
    [anon_sym_ucfirst] = ACTIONS(1623),
    [anon_sym_untie] = ACTIONS(1623),
    [anon_sym_umask] = ACTIONS(1623),
    [anon_sym_values] = ACTIONS(1623),
    [anon_sym_write] = ACTIONS(1623),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1595),
    [anon_sym___END__] = ACTIONS(1595),
    [anon_sym_q] = ACTIONS(1625),
    [anon_sym_qq] = ACTIONS(1627),
    [anon_sym_qw] = ACTIONS(1629),
    [anon_sym_qx] = ACTIONS(1631),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1633),
    [anon_sym_tr] = ACTIONS(1635),
    [anon_sym_y] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1637),
    [anon_sym_unless] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_until] = ACTIONS(1639),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1641),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [234] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(234),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3192),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(266),
    [sym__identifier] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1645),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1647),
    [anon_sym_sub] = ACTIONS(1649),
    [anon_sym_method] = ACTIONS(1651),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1653),
    [anon_sym_my] = ACTIONS(1655),
    [anon_sym_state] = ACTIONS(1655),
    [anon_sym_our] = ACTIONS(1655),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1659),
    [anon_sym_elsif] = ACTIONS(1659),
    [anon_sym_and] = ACTIONS(1659),
    [anon_sym_or] = ACTIONS(1659),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1661),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1659),
    [anon_sym_ne] = ACTIONS(1659),
    [anon_sym_cmp] = ACTIONS(1659),
    [anon_sym_lt] = ACTIONS(1659),
    [anon_sym_le] = ACTIONS(1659),
    [anon_sym_ge] = ACTIONS(1659),
    [anon_sym_gt] = ACTIONS(1659),
    [anon_sym_isa] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1663),
    [anon_sym_eval] = ACTIONS(1665),
    [anon_sym_field] = ACTIONS(1655),
    [anon_sym_local] = ACTIONS(1667),
    [anon_sym_require] = ACTIONS(1669),
    [anon_sym_map] = ACTIONS(1671),
    [anon_sym_grep] = ACTIONS(1671),
    [anon_sym_sort] = ACTIONS(1673),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1677),
    [anon_sym_use] = ACTIONS(1679),
    [anon_sym_no] = ACTIONS(1679),
    [anon_sym_for] = ACTIONS(1681),
    [anon_sym_foreach] = ACTIONS(1681),
    [anon_sym_last] = ACTIONS(1683),
    [anon_sym_next] = ACTIONS(1683),
    [anon_sym_redo] = ACTIONS(1683),
    [anon_sym_BEGIN] = ACTIONS(1685),
    [anon_sym_INIT] = ACTIONS(1685),
    [anon_sym_CHECK] = ACTIONS(1685),
    [anon_sym_UNITCHECK] = ACTIONS(1685),
    [anon_sym_END] = ACTIONS(1685),
    [anon_sym_ADJUST] = ACTIONS(1685),
    [anon_sym___FILE__] = ACTIONS(1653),
    [anon_sym___LINE__] = ACTIONS(1653),
    [anon_sym___PACKAGE__] = ACTIONS(1653),
    [anon_sym___SUB__] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1653),
    [anon_sym_fork] = ACTIONS(1653),
    [anon_sym_getppid] = ACTIONS(1653),
    [anon_sym_time] = ACTIONS(1653),
    [anon_sym_times] = ACTIONS(1653),
    [anon_sym_wait] = ACTIONS(1653),
    [anon_sym_wantarray] = ACTIONS(1653),
    [anon_sym_abs] = ACTIONS(1687),
    [anon_sym_alarm] = ACTIONS(1687),
    [anon_sym_chop] = ACTIONS(1687),
    [anon_sym_chdir] = ACTIONS(1687),
    [anon_sym_close] = ACTIONS(1687),
    [anon_sym_closedir] = ACTIONS(1687),
    [anon_sym_caller] = ACTIONS(1687),
    [anon_sym_chomp] = ACTIONS(1687),
    [anon_sym_chr] = ACTIONS(1687),
    [anon_sym_cos] = ACTIONS(1687),
    [anon_sym_chroot] = ACTIONS(1687),
    [anon_sym_defined] = ACTIONS(1687),
    [anon_sym_delete] = ACTIONS(1687),
    [anon_sym_dbmclose] = ACTIONS(1687),
    [anon_sym_exists] = ACTIONS(1687),
    [anon_sym_exit] = ACTIONS(1687),
    [anon_sym_eof] = ACTIONS(1687),
    [anon_sym_exp] = ACTIONS(1687),
    [anon_sym_each] = ACTIONS(1687),
    [anon_sym_fc] = ACTIONS(1687),
    [anon_sym_fileno] = ACTIONS(1687),
    [anon_sym_gmtime] = ACTIONS(1687),
    [anon_sym_getc] = ACTIONS(1687),
    [anon_sym_getpgrp] = ACTIONS(1687),
    [anon_sym_getprotobyname] = ACTIONS(1687),
    [anon_sym_getpwname] = ACTIONS(1687),
    [anon_sym_getpwuid] = ACTIONS(1687),
    [anon_sym_getpeername] = ACTIONS(1687),
    [anon_sym_getnetbyname] = ACTIONS(1687),
    [anon_sym_getsockname] = ACTIONS(1687),
    [anon_sym_getgrnam] = ACTIONS(1687),
    [anon_sym_getgrgid] = ACTIONS(1687),
    [anon_sym_hex] = ACTIONS(1687),
    [anon_sym_int] = ACTIONS(1687),
    [anon_sym_keys] = ACTIONS(1687),
    [anon_sym_lc] = ACTIONS(1687),
    [anon_sym_lcfirst] = ACTIONS(1687),
    [anon_sym_length] = ACTIONS(1687),
    [anon_sym_localtime] = ACTIONS(1687),
    [anon_sym_log] = ACTIONS(1687),
    [anon_sym_lock] = ACTIONS(1687),
    [anon_sym_lstat] = ACTIONS(1687),
    [anon_sym_oct] = ACTIONS(1687),
    [anon_sym_ord] = ACTIONS(1687),
    [anon_sym_prototype] = ACTIONS(1687),
    [anon_sym_pop] = ACTIONS(1687),
    [anon_sym_pos] = ACTIONS(1687),
    [anon_sym_quotemeta] = ACTIONS(1687),
    [anon_sym_reset] = ACTIONS(1687),
    [anon_sym_rand] = ACTIONS(1687),
    [anon_sym_rmdir] = ACTIONS(1687),
    [anon_sym_readdir] = ACTIONS(1687),
    [anon_sym_readline] = ACTIONS(1687),
    [anon_sym_readpipe] = ACTIONS(1687),
    [anon_sym_rewinddir] = ACTIONS(1687),
    [anon_sym_readlink] = ACTIONS(1687),
    [anon_sym_ref] = ACTIONS(1687),
    [anon_sym_scalar] = ACTIONS(1687),
    [anon_sym_shift] = ACTIONS(1687),
    [anon_sym_sin] = ACTIONS(1687),
    [anon_sym_sleep] = ACTIONS(1687),
    [anon_sym_sqrt] = ACTIONS(1687),
    [anon_sym_srand] = ACTIONS(1687),
    [anon_sym_stat] = ACTIONS(1687),
    [anon_sym_study] = ACTIONS(1687),
    [anon_sym_tell] = ACTIONS(1687),
    [anon_sym_telldir] = ACTIONS(1687),
    [anon_sym_tied] = ACTIONS(1687),
    [anon_sym_uc] = ACTIONS(1687),
    [anon_sym_ucfirst] = ACTIONS(1687),
    [anon_sym_untie] = ACTIONS(1687),
    [anon_sym_umask] = ACTIONS(1687),
    [anon_sym_values] = ACTIONS(1687),
    [anon_sym_write] = ACTIONS(1687),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1659),
    [anon_sym___END__] = ACTIONS(1659),
    [anon_sym_q] = ACTIONS(1689),
    [anon_sym_qq] = ACTIONS(1691),
    [anon_sym_qw] = ACTIONS(1693),
    [anon_sym_qx] = ACTIONS(1695),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1697),
    [anon_sym_tr] = ACTIONS(1699),
    [anon_sym_y] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_unless] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1705),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [235] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(235),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3145),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(270),
    [sym__identifier] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1711),
    [anon_sym_sub] = ACTIONS(1713),
    [anon_sym_method] = ACTIONS(1715),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1717),
    [anon_sym_my] = ACTIONS(1719),
    [anon_sym_state] = ACTIONS(1719),
    [anon_sym_our] = ACTIONS(1719),
    [anon_sym_try] = ACTIONS(1721),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1723),
    [anon_sym_elsif] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1723),
    [anon_sym_ne] = ACTIONS(1723),
    [anon_sym_cmp] = ACTIONS(1723),
    [anon_sym_lt] = ACTIONS(1723),
    [anon_sym_le] = ACTIONS(1723),
    [anon_sym_ge] = ACTIONS(1723),
    [anon_sym_gt] = ACTIONS(1723),
    [anon_sym_isa] = ACTIONS(1723),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_eval] = ACTIONS(1729),
    [anon_sym_field] = ACTIONS(1719),
    [anon_sym_local] = ACTIONS(1731),
    [anon_sym_require] = ACTIONS(1733),
    [anon_sym_map] = ACTIONS(1735),
    [anon_sym_grep] = ACTIONS(1735),
    [anon_sym_sort] = ACTIONS(1737),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1741),
    [anon_sym_use] = ACTIONS(1743),
    [anon_sym_no] = ACTIONS(1743),
    [anon_sym_for] = ACTIONS(1745),
    [anon_sym_foreach] = ACTIONS(1745),
    [anon_sym_last] = ACTIONS(1747),
    [anon_sym_next] = ACTIONS(1747),
    [anon_sym_redo] = ACTIONS(1747),
    [anon_sym_BEGIN] = ACTIONS(1749),
    [anon_sym_INIT] = ACTIONS(1749),
    [anon_sym_CHECK] = ACTIONS(1749),
    [anon_sym_UNITCHECK] = ACTIONS(1749),
    [anon_sym_END] = ACTIONS(1749),
    [anon_sym_ADJUST] = ACTIONS(1749),
    [anon_sym___FILE__] = ACTIONS(1717),
    [anon_sym___LINE__] = ACTIONS(1717),
    [anon_sym___PACKAGE__] = ACTIONS(1717),
    [anon_sym___SUB__] = ACTIONS(1717),
    [anon_sym_break] = ACTIONS(1717),
    [anon_sym_fork] = ACTIONS(1717),
    [anon_sym_getppid] = ACTIONS(1717),
    [anon_sym_time] = ACTIONS(1717),
    [anon_sym_times] = ACTIONS(1717),
    [anon_sym_wait] = ACTIONS(1717),
    [anon_sym_wantarray] = ACTIONS(1717),
    [anon_sym_abs] = ACTIONS(1751),
    [anon_sym_alarm] = ACTIONS(1751),
    [anon_sym_chop] = ACTIONS(1751),
    [anon_sym_chdir] = ACTIONS(1751),
    [anon_sym_close] = ACTIONS(1751),
    [anon_sym_closedir] = ACTIONS(1751),
    [anon_sym_caller] = ACTIONS(1751),
    [anon_sym_chomp] = ACTIONS(1751),
    [anon_sym_chr] = ACTIONS(1751),
    [anon_sym_cos] = ACTIONS(1751),
    [anon_sym_chroot] = ACTIONS(1751),
    [anon_sym_defined] = ACTIONS(1751),
    [anon_sym_delete] = ACTIONS(1751),
    [anon_sym_dbmclose] = ACTIONS(1751),
    [anon_sym_exists] = ACTIONS(1751),
    [anon_sym_exit] = ACTIONS(1751),
    [anon_sym_eof] = ACTIONS(1751),
    [anon_sym_exp] = ACTIONS(1751),
    [anon_sym_each] = ACTIONS(1751),
    [anon_sym_fc] = ACTIONS(1751),
    [anon_sym_fileno] = ACTIONS(1751),
    [anon_sym_gmtime] = ACTIONS(1751),
    [anon_sym_getc] = ACTIONS(1751),
    [anon_sym_getpgrp] = ACTIONS(1751),
    [anon_sym_getprotobyname] = ACTIONS(1751),
    [anon_sym_getpwname] = ACTIONS(1751),
    [anon_sym_getpwuid] = ACTIONS(1751),
    [anon_sym_getpeername] = ACTIONS(1751),
    [anon_sym_getnetbyname] = ACTIONS(1751),
    [anon_sym_getsockname] = ACTIONS(1751),
    [anon_sym_getgrnam] = ACTIONS(1751),
    [anon_sym_getgrgid] = ACTIONS(1751),
    [anon_sym_hex] = ACTIONS(1751),
    [anon_sym_int] = ACTIONS(1751),
    [anon_sym_keys] = ACTIONS(1751),
    [anon_sym_lc] = ACTIONS(1751),
    [anon_sym_lcfirst] = ACTIONS(1751),
    [anon_sym_length] = ACTIONS(1751),
    [anon_sym_localtime] = ACTIONS(1751),
    [anon_sym_log] = ACTIONS(1751),
    [anon_sym_lock] = ACTIONS(1751),
    [anon_sym_lstat] = ACTIONS(1751),
    [anon_sym_oct] = ACTIONS(1751),
    [anon_sym_ord] = ACTIONS(1751),
    [anon_sym_prototype] = ACTIONS(1751),
    [anon_sym_pop] = ACTIONS(1751),
    [anon_sym_pos] = ACTIONS(1751),
    [anon_sym_quotemeta] = ACTIONS(1751),
    [anon_sym_reset] = ACTIONS(1751),
    [anon_sym_rand] = ACTIONS(1751),
    [anon_sym_rmdir] = ACTIONS(1751),
    [anon_sym_readdir] = ACTIONS(1751),
    [anon_sym_readline] = ACTIONS(1751),
    [anon_sym_readpipe] = ACTIONS(1751),
    [anon_sym_rewinddir] = ACTIONS(1751),
    [anon_sym_readlink] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1751),
    [anon_sym_scalar] = ACTIONS(1751),
    [anon_sym_shift] = ACTIONS(1751),
    [anon_sym_sin] = ACTIONS(1751),
    [anon_sym_sleep] = ACTIONS(1751),
    [anon_sym_sqrt] = ACTIONS(1751),
    [anon_sym_srand] = ACTIONS(1751),
    [anon_sym_stat] = ACTIONS(1751),
    [anon_sym_study] = ACTIONS(1751),
    [anon_sym_tell] = ACTIONS(1751),
    [anon_sym_telldir] = ACTIONS(1751),
    [anon_sym_tied] = ACTIONS(1751),
    [anon_sym_uc] = ACTIONS(1751),
    [anon_sym_ucfirst] = ACTIONS(1751),
    [anon_sym_untie] = ACTIONS(1751),
    [anon_sym_umask] = ACTIONS(1751),
    [anon_sym_values] = ACTIONS(1751),
    [anon_sym_write] = ACTIONS(1751),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1723),
    [anon_sym___END__] = ACTIONS(1723),
    [anon_sym_q] = ACTIONS(1753),
    [anon_sym_qq] = ACTIONS(1755),
    [anon_sym_qw] = ACTIONS(1757),
    [anon_sym_qx] = ACTIONS(1759),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1761),
    [anon_sym_tr] = ACTIONS(1763),
    [anon_sym_y] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1765),
    [anon_sym_unless] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [anon_sym_until] = ACTIONS(1767),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1769),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [236] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(236),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3222),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(256),
    [sym__identifier] = ACTIONS(1771),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1773),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1775),
    [anon_sym_sub] = ACTIONS(1777),
    [anon_sym_method] = ACTIONS(1779),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1781),
    [anon_sym_my] = ACTIONS(1783),
    [anon_sym_state] = ACTIONS(1783),
    [anon_sym_our] = ACTIONS(1783),
    [anon_sym_try] = ACTIONS(1785),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1787),
    [anon_sym_elsif] = ACTIONS(1787),
    [anon_sym_and] = ACTIONS(1787),
    [anon_sym_or] = ACTIONS(1787),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1789),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1787),
    [anon_sym_ne] = ACTIONS(1787),
    [anon_sym_cmp] = ACTIONS(1787),
    [anon_sym_lt] = ACTIONS(1787),
    [anon_sym_le] = ACTIONS(1787),
    [anon_sym_ge] = ACTIONS(1787),
    [anon_sym_gt] = ACTIONS(1787),
    [anon_sym_isa] = ACTIONS(1787),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1791),
    [anon_sym_eval] = ACTIONS(1793),
    [anon_sym_field] = ACTIONS(1783),
    [anon_sym_local] = ACTIONS(1795),
    [anon_sym_require] = ACTIONS(1797),
    [anon_sym_map] = ACTIONS(1799),
    [anon_sym_grep] = ACTIONS(1799),
    [anon_sym_sort] = ACTIONS(1801),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1803),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1805),
    [anon_sym_use] = ACTIONS(1807),
    [anon_sym_no] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1809),
    [anon_sym_foreach] = ACTIONS(1809),
    [anon_sym_last] = ACTIONS(1811),
    [anon_sym_next] = ACTIONS(1811),
    [anon_sym_redo] = ACTIONS(1811),
    [anon_sym_BEGIN] = ACTIONS(1813),
    [anon_sym_INIT] = ACTIONS(1813),
    [anon_sym_CHECK] = ACTIONS(1813),
    [anon_sym_UNITCHECK] = ACTIONS(1813),
    [anon_sym_END] = ACTIONS(1813),
    [anon_sym_ADJUST] = ACTIONS(1813),
    [anon_sym___FILE__] = ACTIONS(1781),
    [anon_sym___LINE__] = ACTIONS(1781),
    [anon_sym___PACKAGE__] = ACTIONS(1781),
    [anon_sym___SUB__] = ACTIONS(1781),
    [anon_sym_break] = ACTIONS(1781),
    [anon_sym_fork] = ACTIONS(1781),
    [anon_sym_getppid] = ACTIONS(1781),
    [anon_sym_time] = ACTIONS(1781),
    [anon_sym_times] = ACTIONS(1781),
    [anon_sym_wait] = ACTIONS(1781),
    [anon_sym_wantarray] = ACTIONS(1781),
    [anon_sym_abs] = ACTIONS(1815),
    [anon_sym_alarm] = ACTIONS(1815),
    [anon_sym_chop] = ACTIONS(1815),
    [anon_sym_chdir] = ACTIONS(1815),
    [anon_sym_close] = ACTIONS(1815),
    [anon_sym_closedir] = ACTIONS(1815),
    [anon_sym_caller] = ACTIONS(1815),
    [anon_sym_chomp] = ACTIONS(1815),
    [anon_sym_chr] = ACTIONS(1815),
    [anon_sym_cos] = ACTIONS(1815),
    [anon_sym_chroot] = ACTIONS(1815),
    [anon_sym_defined] = ACTIONS(1815),
    [anon_sym_delete] = ACTIONS(1815),
    [anon_sym_dbmclose] = ACTIONS(1815),
    [anon_sym_exists] = ACTIONS(1815),
    [anon_sym_exit] = ACTIONS(1815),
    [anon_sym_eof] = ACTIONS(1815),
    [anon_sym_exp] = ACTIONS(1815),
    [anon_sym_each] = ACTIONS(1815),
    [anon_sym_fc] = ACTIONS(1815),
    [anon_sym_fileno] = ACTIONS(1815),
    [anon_sym_gmtime] = ACTIONS(1815),
    [anon_sym_getc] = ACTIONS(1815),
    [anon_sym_getpgrp] = ACTIONS(1815),
    [anon_sym_getprotobyname] = ACTIONS(1815),
    [anon_sym_getpwname] = ACTIONS(1815),
    [anon_sym_getpwuid] = ACTIONS(1815),
    [anon_sym_getpeername] = ACTIONS(1815),
    [anon_sym_getnetbyname] = ACTIONS(1815),
    [anon_sym_getsockname] = ACTIONS(1815),
    [anon_sym_getgrnam] = ACTIONS(1815),
    [anon_sym_getgrgid] = ACTIONS(1815),
    [anon_sym_hex] = ACTIONS(1815),
    [anon_sym_int] = ACTIONS(1815),
    [anon_sym_keys] = ACTIONS(1815),
    [anon_sym_lc] = ACTIONS(1815),
    [anon_sym_lcfirst] = ACTIONS(1815),
    [anon_sym_length] = ACTIONS(1815),
    [anon_sym_localtime] = ACTIONS(1815),
    [anon_sym_log] = ACTIONS(1815),
    [anon_sym_lock] = ACTIONS(1815),
    [anon_sym_lstat] = ACTIONS(1815),
    [anon_sym_oct] = ACTIONS(1815),
    [anon_sym_ord] = ACTIONS(1815),
    [anon_sym_prototype] = ACTIONS(1815),
    [anon_sym_pop] = ACTIONS(1815),
    [anon_sym_pos] = ACTIONS(1815),
    [anon_sym_quotemeta] = ACTIONS(1815),
    [anon_sym_reset] = ACTIONS(1815),
    [anon_sym_rand] = ACTIONS(1815),
    [anon_sym_rmdir] = ACTIONS(1815),
    [anon_sym_readdir] = ACTIONS(1815),
    [anon_sym_readline] = ACTIONS(1815),
    [anon_sym_readpipe] = ACTIONS(1815),
    [anon_sym_rewinddir] = ACTIONS(1815),
    [anon_sym_readlink] = ACTIONS(1815),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_scalar] = ACTIONS(1815),
    [anon_sym_shift] = ACTIONS(1815),
    [anon_sym_sin] = ACTIONS(1815),
    [anon_sym_sleep] = ACTIONS(1815),
    [anon_sym_sqrt] = ACTIONS(1815),
    [anon_sym_srand] = ACTIONS(1815),
    [anon_sym_stat] = ACTIONS(1815),
    [anon_sym_study] = ACTIONS(1815),
    [anon_sym_tell] = ACTIONS(1815),
    [anon_sym_telldir] = ACTIONS(1815),
    [anon_sym_tied] = ACTIONS(1815),
    [anon_sym_uc] = ACTIONS(1815),
    [anon_sym_ucfirst] = ACTIONS(1815),
    [anon_sym_untie] = ACTIONS(1815),
    [anon_sym_umask] = ACTIONS(1815),
    [anon_sym_values] = ACTIONS(1815),
    [anon_sym_write] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1787),
    [anon_sym___END__] = ACTIONS(1787),
    [anon_sym_q] = ACTIONS(1817),
    [anon_sym_qq] = ACTIONS(1819),
    [anon_sym_qw] = ACTIONS(1821),
    [anon_sym_qx] = ACTIONS(1823),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1825),
    [anon_sym_tr] = ACTIONS(1827),
    [anon_sym_y] = ACTIONS(1827),
    [anon_sym_if] = ACTIONS(1829),
    [anon_sym_unless] = ACTIONS(1829),
    [anon_sym_while] = ACTIONS(1831),
    [anon_sym_until] = ACTIONS(1831),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1833),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [237] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(237),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3257),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(269),
    [sym__identifier] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1837),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1839),
    [anon_sym_sub] = ACTIONS(1841),
    [anon_sym_method] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1845),
    [anon_sym_my] = ACTIONS(1847),
    [anon_sym_state] = ACTIONS(1847),
    [anon_sym_our] = ACTIONS(1847),
    [anon_sym_try] = ACTIONS(1849),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1851),
    [anon_sym_elsif] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1851),
    [anon_sym_or] = ACTIONS(1851),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1853),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1851),
    [anon_sym_ne] = ACTIONS(1851),
    [anon_sym_cmp] = ACTIONS(1851),
    [anon_sym_lt] = ACTIONS(1851),
    [anon_sym_le] = ACTIONS(1851),
    [anon_sym_ge] = ACTIONS(1851),
    [anon_sym_gt] = ACTIONS(1851),
    [anon_sym_isa] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1855),
    [anon_sym_eval] = ACTIONS(1857),
    [anon_sym_field] = ACTIONS(1847),
    [anon_sym_local] = ACTIONS(1859),
    [anon_sym_require] = ACTIONS(1861),
    [anon_sym_map] = ACTIONS(1863),
    [anon_sym_grep] = ACTIONS(1863),
    [anon_sym_sort] = ACTIONS(1865),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1867),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1869),
    [anon_sym_use] = ACTIONS(1871),
    [anon_sym_no] = ACTIONS(1871),
    [anon_sym_for] = ACTIONS(1873),
    [anon_sym_foreach] = ACTIONS(1873),
    [anon_sym_last] = ACTIONS(1875),
    [anon_sym_next] = ACTIONS(1875),
    [anon_sym_redo] = ACTIONS(1875),
    [anon_sym_BEGIN] = ACTIONS(1877),
    [anon_sym_INIT] = ACTIONS(1877),
    [anon_sym_CHECK] = ACTIONS(1877),
    [anon_sym_UNITCHECK] = ACTIONS(1877),
    [anon_sym_END] = ACTIONS(1877),
    [anon_sym_ADJUST] = ACTIONS(1877),
    [anon_sym___FILE__] = ACTIONS(1845),
    [anon_sym___LINE__] = ACTIONS(1845),
    [anon_sym___PACKAGE__] = ACTIONS(1845),
    [anon_sym___SUB__] = ACTIONS(1845),
    [anon_sym_break] = ACTIONS(1845),
    [anon_sym_fork] = ACTIONS(1845),
    [anon_sym_getppid] = ACTIONS(1845),
    [anon_sym_time] = ACTIONS(1845),
    [anon_sym_times] = ACTIONS(1845),
    [anon_sym_wait] = ACTIONS(1845),
    [anon_sym_wantarray] = ACTIONS(1845),
    [anon_sym_abs] = ACTIONS(1879),
    [anon_sym_alarm] = ACTIONS(1879),
    [anon_sym_chop] = ACTIONS(1879),
    [anon_sym_chdir] = ACTIONS(1879),
    [anon_sym_close] = ACTIONS(1879),
    [anon_sym_closedir] = ACTIONS(1879),
    [anon_sym_caller] = ACTIONS(1879),
    [anon_sym_chomp] = ACTIONS(1879),
    [anon_sym_chr] = ACTIONS(1879),
    [anon_sym_cos] = ACTIONS(1879),
    [anon_sym_chroot] = ACTIONS(1879),
    [anon_sym_defined] = ACTIONS(1879),
    [anon_sym_delete] = ACTIONS(1879),
    [anon_sym_dbmclose] = ACTIONS(1879),
    [anon_sym_exists] = ACTIONS(1879),
    [anon_sym_exit] = ACTIONS(1879),
    [anon_sym_eof] = ACTIONS(1879),
    [anon_sym_exp] = ACTIONS(1879),
    [anon_sym_each] = ACTIONS(1879),
    [anon_sym_fc] = ACTIONS(1879),
    [anon_sym_fileno] = ACTIONS(1879),
    [anon_sym_gmtime] = ACTIONS(1879),
    [anon_sym_getc] = ACTIONS(1879),
    [anon_sym_getpgrp] = ACTIONS(1879),
    [anon_sym_getprotobyname] = ACTIONS(1879),
    [anon_sym_getpwname] = ACTIONS(1879),
    [anon_sym_getpwuid] = ACTIONS(1879),
    [anon_sym_getpeername] = ACTIONS(1879),
    [anon_sym_getnetbyname] = ACTIONS(1879),
    [anon_sym_getsockname] = ACTIONS(1879),
    [anon_sym_getgrnam] = ACTIONS(1879),
    [anon_sym_getgrgid] = ACTIONS(1879),
    [anon_sym_hex] = ACTIONS(1879),
    [anon_sym_int] = ACTIONS(1879),
    [anon_sym_keys] = ACTIONS(1879),
    [anon_sym_lc] = ACTIONS(1879),
    [anon_sym_lcfirst] = ACTIONS(1879),
    [anon_sym_length] = ACTIONS(1879),
    [anon_sym_localtime] = ACTIONS(1879),
    [anon_sym_log] = ACTIONS(1879),
    [anon_sym_lock] = ACTIONS(1879),
    [anon_sym_lstat] = ACTIONS(1879),
    [anon_sym_oct] = ACTIONS(1879),
    [anon_sym_ord] = ACTIONS(1879),
    [anon_sym_prototype] = ACTIONS(1879),
    [anon_sym_pop] = ACTIONS(1879),
    [anon_sym_pos] = ACTIONS(1879),
    [anon_sym_quotemeta] = ACTIONS(1879),
    [anon_sym_reset] = ACTIONS(1879),
    [anon_sym_rand] = ACTIONS(1879),
    [anon_sym_rmdir] = ACTIONS(1879),
    [anon_sym_readdir] = ACTIONS(1879),
    [anon_sym_readline] = ACTIONS(1879),
    [anon_sym_readpipe] = ACTIONS(1879),
    [anon_sym_rewinddir] = ACTIONS(1879),
    [anon_sym_readlink] = ACTIONS(1879),
    [anon_sym_ref] = ACTIONS(1879),
    [anon_sym_scalar] = ACTIONS(1879),
    [anon_sym_shift] = ACTIONS(1879),
    [anon_sym_sin] = ACTIONS(1879),
    [anon_sym_sleep] = ACTIONS(1879),
    [anon_sym_sqrt] = ACTIONS(1879),
    [anon_sym_srand] = ACTIONS(1879),
    [anon_sym_stat] = ACTIONS(1879),
    [anon_sym_study] = ACTIONS(1879),
    [anon_sym_tell] = ACTIONS(1879),
    [anon_sym_telldir] = ACTIONS(1879),
    [anon_sym_tied] = ACTIONS(1879),
    [anon_sym_uc] = ACTIONS(1879),
    [anon_sym_ucfirst] = ACTIONS(1879),
    [anon_sym_untie] = ACTIONS(1879),
    [anon_sym_umask] = ACTIONS(1879),
    [anon_sym_values] = ACTIONS(1879),
    [anon_sym_write] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1851),
    [anon_sym___END__] = ACTIONS(1851),
    [anon_sym_q] = ACTIONS(1881),
    [anon_sym_qq] = ACTIONS(1883),
    [anon_sym_qw] = ACTIONS(1885),
    [anon_sym_qx] = ACTIONS(1887),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1889),
    [anon_sym_tr] = ACTIONS(1891),
    [anon_sym_y] = ACTIONS(1891),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_unless] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1895),
    [anon_sym_until] = ACTIONS(1895),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1897),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [238] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(238),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3170),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(260),
    [sym__identifier] = ACTIONS(1899),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_sub] = ACTIONS(1905),
    [anon_sym_method] = ACTIONS(1907),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_my] = ACTIONS(1911),
    [anon_sym_state] = ACTIONS(1911),
    [anon_sym_our] = ACTIONS(1911),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1915),
    [anon_sym_elsif] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1915),
    [anon_sym_ne] = ACTIONS(1915),
    [anon_sym_cmp] = ACTIONS(1915),
    [anon_sym_lt] = ACTIONS(1915),
    [anon_sym_le] = ACTIONS(1915),
    [anon_sym_ge] = ACTIONS(1915),
    [anon_sym_gt] = ACTIONS(1915),
    [anon_sym_isa] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1919),
    [anon_sym_eval] = ACTIONS(1921),
    [anon_sym_field] = ACTIONS(1911),
    [anon_sym_local] = ACTIONS(1923),
    [anon_sym_require] = ACTIONS(1925),
    [anon_sym_map] = ACTIONS(1927),
    [anon_sym_grep] = ACTIONS(1927),
    [anon_sym_sort] = ACTIONS(1929),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1931),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1933),
    [anon_sym_use] = ACTIONS(1935),
    [anon_sym_no] = ACTIONS(1935),
    [anon_sym_for] = ACTIONS(1937),
    [anon_sym_foreach] = ACTIONS(1937),
    [anon_sym_last] = ACTIONS(1939),
    [anon_sym_next] = ACTIONS(1939),
    [anon_sym_redo] = ACTIONS(1939),
    [anon_sym_BEGIN] = ACTIONS(1941),
    [anon_sym_INIT] = ACTIONS(1941),
    [anon_sym_CHECK] = ACTIONS(1941),
    [anon_sym_UNITCHECK] = ACTIONS(1941),
    [anon_sym_END] = ACTIONS(1941),
    [anon_sym_ADJUST] = ACTIONS(1941),
    [anon_sym___FILE__] = ACTIONS(1909),
    [anon_sym___LINE__] = ACTIONS(1909),
    [anon_sym___PACKAGE__] = ACTIONS(1909),
    [anon_sym___SUB__] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_fork] = ACTIONS(1909),
    [anon_sym_getppid] = ACTIONS(1909),
    [anon_sym_time] = ACTIONS(1909),
    [anon_sym_times] = ACTIONS(1909),
    [anon_sym_wait] = ACTIONS(1909),
    [anon_sym_wantarray] = ACTIONS(1909),
    [anon_sym_abs] = ACTIONS(1943),
    [anon_sym_alarm] = ACTIONS(1943),
    [anon_sym_chop] = ACTIONS(1943),
    [anon_sym_chdir] = ACTIONS(1943),
    [anon_sym_close] = ACTIONS(1943),
    [anon_sym_closedir] = ACTIONS(1943),
    [anon_sym_caller] = ACTIONS(1943),
    [anon_sym_chomp] = ACTIONS(1943),
    [anon_sym_chr] = ACTIONS(1943),
    [anon_sym_cos] = ACTIONS(1943),
    [anon_sym_chroot] = ACTIONS(1943),
    [anon_sym_defined] = ACTIONS(1943),
    [anon_sym_delete] = ACTIONS(1943),
    [anon_sym_dbmclose] = ACTIONS(1943),
    [anon_sym_exists] = ACTIONS(1943),
    [anon_sym_exit] = ACTIONS(1943),
    [anon_sym_eof] = ACTIONS(1943),
    [anon_sym_exp] = ACTIONS(1943),
    [anon_sym_each] = ACTIONS(1943),
    [anon_sym_fc] = ACTIONS(1943),
    [anon_sym_fileno] = ACTIONS(1943),
    [anon_sym_gmtime] = ACTIONS(1943),
    [anon_sym_getc] = ACTIONS(1943),
    [anon_sym_getpgrp] = ACTIONS(1943),
    [anon_sym_getprotobyname] = ACTIONS(1943),
    [anon_sym_getpwname] = ACTIONS(1943),
    [anon_sym_getpwuid] = ACTIONS(1943),
    [anon_sym_getpeername] = ACTIONS(1943),
    [anon_sym_getnetbyname] = ACTIONS(1943),
    [anon_sym_getsockname] = ACTIONS(1943),
    [anon_sym_getgrnam] = ACTIONS(1943),
    [anon_sym_getgrgid] = ACTIONS(1943),
    [anon_sym_hex] = ACTIONS(1943),
    [anon_sym_int] = ACTIONS(1943),
    [anon_sym_keys] = ACTIONS(1943),
    [anon_sym_lc] = ACTIONS(1943),
    [anon_sym_lcfirst] = ACTIONS(1943),
    [anon_sym_length] = ACTIONS(1943),
    [anon_sym_localtime] = ACTIONS(1943),
    [anon_sym_log] = ACTIONS(1943),
    [anon_sym_lock] = ACTIONS(1943),
    [anon_sym_lstat] = ACTIONS(1943),
    [anon_sym_oct] = ACTIONS(1943),
    [anon_sym_ord] = ACTIONS(1943),
    [anon_sym_prototype] = ACTIONS(1943),
    [anon_sym_pop] = ACTIONS(1943),
    [anon_sym_pos] = ACTIONS(1943),
    [anon_sym_quotemeta] = ACTIONS(1943),
    [anon_sym_reset] = ACTIONS(1943),
    [anon_sym_rand] = ACTIONS(1943),
    [anon_sym_rmdir] = ACTIONS(1943),
    [anon_sym_readdir] = ACTIONS(1943),
    [anon_sym_readline] = ACTIONS(1943),
    [anon_sym_readpipe] = ACTIONS(1943),
    [anon_sym_rewinddir] = ACTIONS(1943),
    [anon_sym_readlink] = ACTIONS(1943),
    [anon_sym_ref] = ACTIONS(1943),
    [anon_sym_scalar] = ACTIONS(1943),
    [anon_sym_shift] = ACTIONS(1943),
    [anon_sym_sin] = ACTIONS(1943),
    [anon_sym_sleep] = ACTIONS(1943),
    [anon_sym_sqrt] = ACTIONS(1943),
    [anon_sym_srand] = ACTIONS(1943),
    [anon_sym_stat] = ACTIONS(1943),
    [anon_sym_study] = ACTIONS(1943),
    [anon_sym_tell] = ACTIONS(1943),
    [anon_sym_telldir] = ACTIONS(1943),
    [anon_sym_tied] = ACTIONS(1943),
    [anon_sym_uc] = ACTIONS(1943),
    [anon_sym_ucfirst] = ACTIONS(1943),
    [anon_sym_untie] = ACTIONS(1943),
    [anon_sym_umask] = ACTIONS(1943),
    [anon_sym_values] = ACTIONS(1943),
    [anon_sym_write] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1915),
    [anon_sym___END__] = ACTIONS(1915),
    [anon_sym_q] = ACTIONS(1945),
    [anon_sym_qq] = ACTIONS(1947),
    [anon_sym_qw] = ACTIONS(1949),
    [anon_sym_qx] = ACTIONS(1951),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1953),
    [anon_sym_tr] = ACTIONS(1955),
    [anon_sym_y] = ACTIONS(1955),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_unless] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1959),
    [anon_sym_until] = ACTIONS(1959),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1961),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [239] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(239),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3191),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(273),
    [sym__identifier] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_sub] = ACTIONS(1969),
    [anon_sym_method] = ACTIONS(1971),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1973),
    [anon_sym_my] = ACTIONS(1975),
    [anon_sym_state] = ACTIONS(1975),
    [anon_sym_our] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1977),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_elsif] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1979),
    [anon_sym_ne] = ACTIONS(1979),
    [anon_sym_cmp] = ACTIONS(1979),
    [anon_sym_lt] = ACTIONS(1979),
    [anon_sym_le] = ACTIONS(1979),
    [anon_sym_ge] = ACTIONS(1979),
    [anon_sym_gt] = ACTIONS(1979),
    [anon_sym_isa] = ACTIONS(1979),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_eval] = ACTIONS(1985),
    [anon_sym_field] = ACTIONS(1975),
    [anon_sym_local] = ACTIONS(1987),
    [anon_sym_require] = ACTIONS(1989),
    [anon_sym_map] = ACTIONS(1991),
    [anon_sym_grep] = ACTIONS(1991),
    [anon_sym_sort] = ACTIONS(1993),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1997),
    [anon_sym_use] = ACTIONS(1999),
    [anon_sym_no] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_foreach] = ACTIONS(2001),
    [anon_sym_last] = ACTIONS(2003),
    [anon_sym_next] = ACTIONS(2003),
    [anon_sym_redo] = ACTIONS(2003),
    [anon_sym_BEGIN] = ACTIONS(2005),
    [anon_sym_INIT] = ACTIONS(2005),
    [anon_sym_CHECK] = ACTIONS(2005),
    [anon_sym_UNITCHECK] = ACTIONS(2005),
    [anon_sym_END] = ACTIONS(2005),
    [anon_sym_ADJUST] = ACTIONS(2005),
    [anon_sym___FILE__] = ACTIONS(1973),
    [anon_sym___LINE__] = ACTIONS(1973),
    [anon_sym___PACKAGE__] = ACTIONS(1973),
    [anon_sym___SUB__] = ACTIONS(1973),
    [anon_sym_break] = ACTIONS(1973),
    [anon_sym_fork] = ACTIONS(1973),
    [anon_sym_getppid] = ACTIONS(1973),
    [anon_sym_time] = ACTIONS(1973),
    [anon_sym_times] = ACTIONS(1973),
    [anon_sym_wait] = ACTIONS(1973),
    [anon_sym_wantarray] = ACTIONS(1973),
    [anon_sym_abs] = ACTIONS(2007),
    [anon_sym_alarm] = ACTIONS(2007),
    [anon_sym_chop] = ACTIONS(2007),
    [anon_sym_chdir] = ACTIONS(2007),
    [anon_sym_close] = ACTIONS(2007),
    [anon_sym_closedir] = ACTIONS(2007),
    [anon_sym_caller] = ACTIONS(2007),
    [anon_sym_chomp] = ACTIONS(2007),
    [anon_sym_chr] = ACTIONS(2007),
    [anon_sym_cos] = ACTIONS(2007),
    [anon_sym_chroot] = ACTIONS(2007),
    [anon_sym_defined] = ACTIONS(2007),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_dbmclose] = ACTIONS(2007),
    [anon_sym_exists] = ACTIONS(2007),
    [anon_sym_exit] = ACTIONS(2007),
    [anon_sym_eof] = ACTIONS(2007),
    [anon_sym_exp] = ACTIONS(2007),
    [anon_sym_each] = ACTIONS(2007),
    [anon_sym_fc] = ACTIONS(2007),
    [anon_sym_fileno] = ACTIONS(2007),
    [anon_sym_gmtime] = ACTIONS(2007),
    [anon_sym_getc] = ACTIONS(2007),
    [anon_sym_getpgrp] = ACTIONS(2007),
    [anon_sym_getprotobyname] = ACTIONS(2007),
    [anon_sym_getpwname] = ACTIONS(2007),
    [anon_sym_getpwuid] = ACTIONS(2007),
    [anon_sym_getpeername] = ACTIONS(2007),
    [anon_sym_getnetbyname] = ACTIONS(2007),
    [anon_sym_getsockname] = ACTIONS(2007),
    [anon_sym_getgrnam] = ACTIONS(2007),
    [anon_sym_getgrgid] = ACTIONS(2007),
    [anon_sym_hex] = ACTIONS(2007),
    [anon_sym_int] = ACTIONS(2007),
    [anon_sym_keys] = ACTIONS(2007),
    [anon_sym_lc] = ACTIONS(2007),
    [anon_sym_lcfirst] = ACTIONS(2007),
    [anon_sym_length] = ACTIONS(2007),
    [anon_sym_localtime] = ACTIONS(2007),
    [anon_sym_log] = ACTIONS(2007),
    [anon_sym_lock] = ACTIONS(2007),
    [anon_sym_lstat] = ACTIONS(2007),
    [anon_sym_oct] = ACTIONS(2007),
    [anon_sym_ord] = ACTIONS(2007),
    [anon_sym_prototype] = ACTIONS(2007),
    [anon_sym_pop] = ACTIONS(2007),
    [anon_sym_pos] = ACTIONS(2007),
    [anon_sym_quotemeta] = ACTIONS(2007),
    [anon_sym_reset] = ACTIONS(2007),
    [anon_sym_rand] = ACTIONS(2007),
    [anon_sym_rmdir] = ACTIONS(2007),
    [anon_sym_readdir] = ACTIONS(2007),
    [anon_sym_readline] = ACTIONS(2007),
    [anon_sym_readpipe] = ACTIONS(2007),
    [anon_sym_rewinddir] = ACTIONS(2007),
    [anon_sym_readlink] = ACTIONS(2007),
    [anon_sym_ref] = ACTIONS(2007),
    [anon_sym_scalar] = ACTIONS(2007),
    [anon_sym_shift] = ACTIONS(2007),
    [anon_sym_sin] = ACTIONS(2007),
    [anon_sym_sleep] = ACTIONS(2007),
    [anon_sym_sqrt] = ACTIONS(2007),
    [anon_sym_srand] = ACTIONS(2007),
    [anon_sym_stat] = ACTIONS(2007),
    [anon_sym_study] = ACTIONS(2007),
    [anon_sym_tell] = ACTIONS(2007),
    [anon_sym_telldir] = ACTIONS(2007),
    [anon_sym_tied] = ACTIONS(2007),
    [anon_sym_uc] = ACTIONS(2007),
    [anon_sym_ucfirst] = ACTIONS(2007),
    [anon_sym_untie] = ACTIONS(2007),
    [anon_sym_umask] = ACTIONS(2007),
    [anon_sym_values] = ACTIONS(2007),
    [anon_sym_write] = ACTIONS(2007),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1979),
    [anon_sym___END__] = ACTIONS(1979),
    [anon_sym_q] = ACTIONS(2009),
    [anon_sym_qq] = ACTIONS(2011),
    [anon_sym_qw] = ACTIONS(2013),
    [anon_sym_qx] = ACTIONS(2015),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2017),
    [anon_sym_tr] = ACTIONS(2019),
    [anon_sym_y] = ACTIONS(2019),
    [anon_sym_if] = ACTIONS(2021),
    [anon_sym_unless] = ACTIONS(2021),
    [anon_sym_while] = ACTIONS(2023),
    [anon_sym_until] = ACTIONS(2023),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(2025),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [240] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(240),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym__ident_special] = STATE(3152),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(257),
    [sym__identifier] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1453),
    [anon_sym_sub] = ACTIONS(1455),
    [anon_sym_method] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(1459),
    [anon_sym_my] = ACTIONS(1461),
    [anon_sym_state] = ACTIONS(1461),
    [anon_sym_our] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1463),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_elsif] = ACTIONS(1465),
    [anon_sym_and] = ACTIONS(1465),
    [anon_sym_or] = ACTIONS(1465),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(1467),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(1465),
    [anon_sym_ne] = ACTIONS(1465),
    [anon_sym_cmp] = ACTIONS(1465),
    [anon_sym_lt] = ACTIONS(1465),
    [anon_sym_le] = ACTIONS(1465),
    [anon_sym_ge] = ACTIONS(1465),
    [anon_sym_gt] = ACTIONS(1465),
    [anon_sym_isa] = ACTIONS(1465),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_eval] = ACTIONS(1471),
    [anon_sym_field] = ACTIONS(1461),
    [anon_sym_local] = ACTIONS(1473),
    [anon_sym_require] = ACTIONS(1475),
    [anon_sym_map] = ACTIONS(1477),
    [anon_sym_grep] = ACTIONS(1477),
    [anon_sym_sort] = ACTIONS(1479),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(1481),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1485),
    [anon_sym_no] = ACTIONS(1485),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_foreach] = ACTIONS(1487),
    [anon_sym_last] = ACTIONS(1489),
    [anon_sym_next] = ACTIONS(1489),
    [anon_sym_redo] = ACTIONS(1489),
    [anon_sym_BEGIN] = ACTIONS(1491),
    [anon_sym_INIT] = ACTIONS(1491),
    [anon_sym_CHECK] = ACTIONS(1491),
    [anon_sym_UNITCHECK] = ACTIONS(1491),
    [anon_sym_END] = ACTIONS(1491),
    [anon_sym_ADJUST] = ACTIONS(1491),
    [anon_sym___FILE__] = ACTIONS(1459),
    [anon_sym___LINE__] = ACTIONS(1459),
    [anon_sym___PACKAGE__] = ACTIONS(1459),
    [anon_sym___SUB__] = ACTIONS(1459),
    [anon_sym_break] = ACTIONS(1459),
    [anon_sym_fork] = ACTIONS(1459),
    [anon_sym_getppid] = ACTIONS(1459),
    [anon_sym_time] = ACTIONS(1459),
    [anon_sym_times] = ACTIONS(1459),
    [anon_sym_wait] = ACTIONS(1459),
    [anon_sym_wantarray] = ACTIONS(1459),
    [anon_sym_abs] = ACTIONS(1493),
    [anon_sym_alarm] = ACTIONS(1493),
    [anon_sym_chop] = ACTIONS(1493),
    [anon_sym_chdir] = ACTIONS(1493),
    [anon_sym_close] = ACTIONS(1493),
    [anon_sym_closedir] = ACTIONS(1493),
    [anon_sym_caller] = ACTIONS(1493),
    [anon_sym_chomp] = ACTIONS(1493),
    [anon_sym_chr] = ACTIONS(1493),
    [anon_sym_cos] = ACTIONS(1493),
    [anon_sym_chroot] = ACTIONS(1493),
    [anon_sym_defined] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1493),
    [anon_sym_dbmclose] = ACTIONS(1493),
    [anon_sym_exists] = ACTIONS(1493),
    [anon_sym_exit] = ACTIONS(1493),
    [anon_sym_eof] = ACTIONS(1493),
    [anon_sym_exp] = ACTIONS(1493),
    [anon_sym_each] = ACTIONS(1493),
    [anon_sym_fc] = ACTIONS(1493),
    [anon_sym_fileno] = ACTIONS(1493),
    [anon_sym_gmtime] = ACTIONS(1493),
    [anon_sym_getc] = ACTIONS(1493),
    [anon_sym_getpgrp] = ACTIONS(1493),
    [anon_sym_getprotobyname] = ACTIONS(1493),
    [anon_sym_getpwname] = ACTIONS(1493),
    [anon_sym_getpwuid] = ACTIONS(1493),
    [anon_sym_getpeername] = ACTIONS(1493),
    [anon_sym_getnetbyname] = ACTIONS(1493),
    [anon_sym_getsockname] = ACTIONS(1493),
    [anon_sym_getgrnam] = ACTIONS(1493),
    [anon_sym_getgrgid] = ACTIONS(1493),
    [anon_sym_hex] = ACTIONS(1493),
    [anon_sym_int] = ACTIONS(1493),
    [anon_sym_keys] = ACTIONS(1493),
    [anon_sym_lc] = ACTIONS(1493),
    [anon_sym_lcfirst] = ACTIONS(1493),
    [anon_sym_length] = ACTIONS(1493),
    [anon_sym_localtime] = ACTIONS(1493),
    [anon_sym_log] = ACTIONS(1493),
    [anon_sym_lock] = ACTIONS(1493),
    [anon_sym_lstat] = ACTIONS(1493),
    [anon_sym_oct] = ACTIONS(1493),
    [anon_sym_ord] = ACTIONS(1493),
    [anon_sym_prototype] = ACTIONS(1493),
    [anon_sym_pop] = ACTIONS(1493),
    [anon_sym_pos] = ACTIONS(1493),
    [anon_sym_quotemeta] = ACTIONS(1493),
    [anon_sym_reset] = ACTIONS(1493),
    [anon_sym_rand] = ACTIONS(1493),
    [anon_sym_rmdir] = ACTIONS(1493),
    [anon_sym_readdir] = ACTIONS(1493),
    [anon_sym_readline] = ACTIONS(1493),
    [anon_sym_readpipe] = ACTIONS(1493),
    [anon_sym_rewinddir] = ACTIONS(1493),
    [anon_sym_readlink] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1493),
    [anon_sym_scalar] = ACTIONS(1493),
    [anon_sym_shift] = ACTIONS(1493),
    [anon_sym_sin] = ACTIONS(1493),
    [anon_sym_sleep] = ACTIONS(1493),
    [anon_sym_sqrt] = ACTIONS(1493),
    [anon_sym_srand] = ACTIONS(1493),
    [anon_sym_stat] = ACTIONS(1493),
    [anon_sym_study] = ACTIONS(1493),
    [anon_sym_tell] = ACTIONS(1493),
    [anon_sym_telldir] = ACTIONS(1493),
    [anon_sym_tied] = ACTIONS(1493),
    [anon_sym_uc] = ACTIONS(1493),
    [anon_sym_ucfirst] = ACTIONS(1493),
    [anon_sym_untie] = ACTIONS(1493),
    [anon_sym_umask] = ACTIONS(1493),
    [anon_sym_values] = ACTIONS(1493),
    [anon_sym_write] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(1465),
    [anon_sym___END__] = ACTIONS(1465),
    [anon_sym_q] = ACTIONS(1495),
    [anon_sym_qq] = ACTIONS(1497),
    [anon_sym_qw] = ACTIONS(1499),
    [anon_sym_qx] = ACTIONS(1501),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(1503),
    [anon_sym_tr] = ACTIONS(1505),
    [anon_sym_y] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_unless] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1509),
    [anon_sym_until] = ACTIONS(1509),
    [aux_sym__ident_special_token1] = ACTIONS(1127),
    [aux_sym__bareword_token1] = ACTIONS(1511),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [241] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(276),
    [sym_block] = STATE(995),
    [sym__fullstmt] = STATE(996),
    [sym_statement_label] = STATE(998),
    [sym__barestmt] = STATE(998),
    [sym_package_statement] = STATE(991),
    [sym_class_statement] = STATE(991),
    [sym_use_version_statement] = STATE(991),
    [sym_use_statement] = STATE(991),
    [sym_subroutine_declaration_statement] = STATE(991),
    [sym_method_declaration_statement] = STATE(991),
    [sym_phaser_statement] = STATE(991),
    [sym_conditional_statement] = STATE(991),
    [sym_loop_statement] = STATE(991),
    [sym_cstyle_for_statement] = STATE(991),
    [sym_for_statement] = STATE(991),
    [sym_try_statement] = STATE(991),
    [sym_defer_statement] = STATE(991),
    [sym_expression_statement] = STATE(2414),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(241),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3186),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(241),
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym__identifier] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_LBRACE2] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym_package] = ACTIONS(2043),
    [anon_sym_class] = ACTIONS(2046),
    [anon_sym_sub] = ACTIONS(2049),
    [anon_sym_method] = ACTIONS(2052),
    [anon_sym_LPAREN] = ACTIONS(2055),
    [anon_sym_continue] = ACTIONS(2058),
    [anon_sym_my] = ACTIONS(2061),
    [anon_sym_state] = ACTIONS(2061),
    [anon_sym_our] = ACTIONS(2061),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_defer] = ACTIONS(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_else] = ACTIONS(2073),
    [anon_sym_elsif] = ACTIONS(2073),
    [anon_sym_and] = ACTIONS(2073),
    [anon_sym_or] = ACTIONS(2073),
    [anon_sym_DOLLAR] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2079),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2088),
    [anon_sym_SLASH_SLASH] = ACTIONS(2091),
    [anon_sym_PLUS] = ACTIONS(2094),
    [anon_sym_DASH] = ACTIONS(2097),
    [anon_sym_STAR] = ACTIONS(2100),
    [anon_sym_eq] = ACTIONS(2073),
    [anon_sym_ne] = ACTIONS(2073),
    [anon_sym_cmp] = ACTIONS(2073),
    [anon_sym_lt] = ACTIONS(2073),
    [anon_sym_le] = ACTIONS(2073),
    [anon_sym_ge] = ACTIONS(2073),
    [anon_sym_gt] = ACTIONS(2073),
    [anon_sym_isa] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2094),
    [anon_sym_BANG] = ACTIONS(2094),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [anon_sym_BSLASH] = ACTIONS(2106),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_eval] = ACTIONS(2112),
    [anon_sym_field] = ACTIONS(2061),
    [anon_sym_local] = ACTIONS(2115),
    [anon_sym_require] = ACTIONS(2118),
    [anon_sym_map] = ACTIONS(2121),
    [anon_sym_grep] = ACTIONS(2121),
    [anon_sym_sort] = ACTIONS(2124),
    [anon_sym_goto] = ACTIONS(2127),
    [anon_sym_return] = ACTIONS(2130),
    [anon_sym_undef] = ACTIONS(2133),
    [anon_sym_PERCENT2] = ACTIONS(2136),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2139),
    [anon_sym_use] = ACTIONS(2142),
    [anon_sym_no] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_foreach] = ACTIONS(2145),
    [anon_sym_last] = ACTIONS(2148),
    [anon_sym_next] = ACTIONS(2148),
    [anon_sym_redo] = ACTIONS(2148),
    [anon_sym_BEGIN] = ACTIONS(2151),
    [anon_sym_INIT] = ACTIONS(2151),
    [anon_sym_CHECK] = ACTIONS(2151),
    [anon_sym_UNITCHECK] = ACTIONS(2151),
    [anon_sym_END] = ACTIONS(2151),
    [anon_sym_ADJUST] = ACTIONS(2151),
    [anon_sym___FILE__] = ACTIONS(2058),
    [anon_sym___LINE__] = ACTIONS(2058),
    [anon_sym___PACKAGE__] = ACTIONS(2058),
    [anon_sym___SUB__] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2058),
    [anon_sym_fork] = ACTIONS(2058),
    [anon_sym_getppid] = ACTIONS(2058),
    [anon_sym_time] = ACTIONS(2058),
    [anon_sym_times] = ACTIONS(2058),
    [anon_sym_wait] = ACTIONS(2058),
    [anon_sym_wantarray] = ACTIONS(2058),
    [anon_sym_abs] = ACTIONS(2154),
    [anon_sym_alarm] = ACTIONS(2154),
    [anon_sym_chop] = ACTIONS(2154),
    [anon_sym_chdir] = ACTIONS(2154),
    [anon_sym_close] = ACTIONS(2154),
    [anon_sym_closedir] = ACTIONS(2154),
    [anon_sym_caller] = ACTIONS(2154),
    [anon_sym_chomp] = ACTIONS(2154),
    [anon_sym_chr] = ACTIONS(2154),
    [anon_sym_cos] = ACTIONS(2154),
    [anon_sym_chroot] = ACTIONS(2154),
    [anon_sym_defined] = ACTIONS(2154),
    [anon_sym_delete] = ACTIONS(2154),
    [anon_sym_dbmclose] = ACTIONS(2154),
    [anon_sym_exists] = ACTIONS(2154),
    [anon_sym_exit] = ACTIONS(2154),
    [anon_sym_eof] = ACTIONS(2154),
    [anon_sym_exp] = ACTIONS(2154),
    [anon_sym_each] = ACTIONS(2154),
    [anon_sym_fc] = ACTIONS(2154),
    [anon_sym_fileno] = ACTIONS(2154),
    [anon_sym_gmtime] = ACTIONS(2154),
    [anon_sym_getc] = ACTIONS(2154),
    [anon_sym_getpgrp] = ACTIONS(2154),
    [anon_sym_getprotobyname] = ACTIONS(2154),
    [anon_sym_getpwname] = ACTIONS(2154),
    [anon_sym_getpwuid] = ACTIONS(2154),
    [anon_sym_getpeername] = ACTIONS(2154),
    [anon_sym_getnetbyname] = ACTIONS(2154),
    [anon_sym_getsockname] = ACTIONS(2154),
    [anon_sym_getgrnam] = ACTIONS(2154),
    [anon_sym_getgrgid] = ACTIONS(2154),
    [anon_sym_hex] = ACTIONS(2154),
    [anon_sym_int] = ACTIONS(2154),
    [anon_sym_keys] = ACTIONS(2154),
    [anon_sym_lc] = ACTIONS(2154),
    [anon_sym_lcfirst] = ACTIONS(2154),
    [anon_sym_length] = ACTIONS(2154),
    [anon_sym_localtime] = ACTIONS(2154),
    [anon_sym_log] = ACTIONS(2154),
    [anon_sym_lock] = ACTIONS(2154),
    [anon_sym_lstat] = ACTIONS(2154),
    [anon_sym_oct] = ACTIONS(2154),
    [anon_sym_ord] = ACTIONS(2154),
    [anon_sym_prototype] = ACTIONS(2154),
    [anon_sym_pop] = ACTIONS(2154),
    [anon_sym_pos] = ACTIONS(2154),
    [anon_sym_quotemeta] = ACTIONS(2154),
    [anon_sym_reset] = ACTIONS(2154),
    [anon_sym_rand] = ACTIONS(2154),
    [anon_sym_rmdir] = ACTIONS(2154),
    [anon_sym_readdir] = ACTIONS(2154),
    [anon_sym_readline] = ACTIONS(2154),
    [anon_sym_readpipe] = ACTIONS(2154),
    [anon_sym_rewinddir] = ACTIONS(2154),
    [anon_sym_readlink] = ACTIONS(2154),
    [anon_sym_ref] = ACTIONS(2154),
    [anon_sym_scalar] = ACTIONS(2154),
    [anon_sym_shift] = ACTIONS(2154),
    [anon_sym_sin] = ACTIONS(2154),
    [anon_sym_sleep] = ACTIONS(2154),
    [anon_sym_sqrt] = ACTIONS(2154),
    [anon_sym_srand] = ACTIONS(2154),
    [anon_sym_stat] = ACTIONS(2154),
    [anon_sym_study] = ACTIONS(2154),
    [anon_sym_tell] = ACTIONS(2154),
    [anon_sym_telldir] = ACTIONS(2154),
    [anon_sym_tied] = ACTIONS(2154),
    [anon_sym_uc] = ACTIONS(2154),
    [anon_sym_ucfirst] = ACTIONS(2154),
    [anon_sym_untie] = ACTIONS(2154),
    [anon_sym_umask] = ACTIONS(2154),
    [anon_sym_values] = ACTIONS(2154),
    [anon_sym_write] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2073),
    [anon_sym___END__] = ACTIONS(2073),
    [anon_sym_EOT] = ACTIONS(2157),
    [anon_sym_q] = ACTIONS(2159),
    [anon_sym_qq] = ACTIONS(2162),
    [anon_sym_qw] = ACTIONS(2165),
    [anon_sym_qx] = ACTIONS(2168),
    [anon_sym_qr] = ACTIONS(2171),
    [anon_sym_m] = ACTIONS(2174),
    [anon_sym_s] = ACTIONS(2177),
    [anon_sym_tr] = ACTIONS(2180),
    [anon_sym_y] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_unless] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_until] = ACTIONS(2186),
    [aux_sym__bareword_token1] = ACTIONS(2189),
    [sym_number] = ACTIONS(2192),
    [sym__apostrophe] = ACTIONS(2195),
    [sym__double_quote] = ACTIONS(2198),
    [sym__backtick] = ACTIONS(2201),
    [sym__search_slash] = ACTIONS(2204),
    [sym__PERLY_HEREDOC] = ACTIONS(2207),
    [sym__ctrl_z_hack] = ACTIONS(2029),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [242] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(242),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [243] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(243),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [244] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(244),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(251),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [245] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(245),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [246] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(246),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(254),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [247] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(247),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [248] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(248),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(258),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [249] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(249),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [250] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(250),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_LBRACE2] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2157),
    [anon_sym_SEMI] = ACTIONS(2240),
    [anon_sym_package] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_sub] = ACTIONS(2249),
    [anon_sym_method] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2055),
    [anon_sym_continue] = ACTIONS(2058),
    [anon_sym_my] = ACTIONS(2061),
    [anon_sym_state] = ACTIONS(2061),
    [anon_sym_our] = ACTIONS(2061),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_defer] = ACTIONS(2258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_else] = ACTIONS(2073),
    [anon_sym_elsif] = ACTIONS(2073),
    [anon_sym_and] = ACTIONS(2073),
    [anon_sym_or] = ACTIONS(2073),
    [anon_sym_DOLLAR] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2079),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2088),
    [anon_sym_SLASH_SLASH] = ACTIONS(2091),
    [anon_sym_PLUS] = ACTIONS(2094),
    [anon_sym_DASH] = ACTIONS(2097),
    [anon_sym_STAR] = ACTIONS(2100),
    [anon_sym_eq] = ACTIONS(2073),
    [anon_sym_ne] = ACTIONS(2073),
    [anon_sym_cmp] = ACTIONS(2073),
    [anon_sym_lt] = ACTIONS(2073),
    [anon_sym_le] = ACTIONS(2073),
    [anon_sym_ge] = ACTIONS(2073),
    [anon_sym_gt] = ACTIONS(2073),
    [anon_sym_isa] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2094),
    [anon_sym_BANG] = ACTIONS(2094),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [anon_sym_BSLASH] = ACTIONS(2106),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_eval] = ACTIONS(2112),
    [anon_sym_field] = ACTIONS(2061),
    [anon_sym_local] = ACTIONS(2115),
    [anon_sym_require] = ACTIONS(2118),
    [anon_sym_map] = ACTIONS(2121),
    [anon_sym_grep] = ACTIONS(2121),
    [anon_sym_sort] = ACTIONS(2124),
    [anon_sym_goto] = ACTIONS(2127),
    [anon_sym_return] = ACTIONS(2130),
    [anon_sym_undef] = ACTIONS(2133),
    [anon_sym_PERCENT2] = ACTIONS(2136),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2139),
    [anon_sym_use] = ACTIONS(2261),
    [anon_sym_no] = ACTIONS(2261),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_foreach] = ACTIONS(2264),
    [anon_sym_last] = ACTIONS(2148),
    [anon_sym_next] = ACTIONS(2148),
    [anon_sym_redo] = ACTIONS(2148),
    [anon_sym_BEGIN] = ACTIONS(2267),
    [anon_sym_INIT] = ACTIONS(2267),
    [anon_sym_CHECK] = ACTIONS(2267),
    [anon_sym_UNITCHECK] = ACTIONS(2267),
    [anon_sym_END] = ACTIONS(2267),
    [anon_sym_ADJUST] = ACTIONS(2267),
    [anon_sym___FILE__] = ACTIONS(2058),
    [anon_sym___LINE__] = ACTIONS(2058),
    [anon_sym___PACKAGE__] = ACTIONS(2058),
    [anon_sym___SUB__] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2058),
    [anon_sym_fork] = ACTIONS(2058),
    [anon_sym_getppid] = ACTIONS(2058),
    [anon_sym_time] = ACTIONS(2058),
    [anon_sym_times] = ACTIONS(2058),
    [anon_sym_wait] = ACTIONS(2058),
    [anon_sym_wantarray] = ACTIONS(2058),
    [anon_sym_abs] = ACTIONS(2154),
    [anon_sym_alarm] = ACTIONS(2154),
    [anon_sym_chop] = ACTIONS(2154),
    [anon_sym_chdir] = ACTIONS(2154),
    [anon_sym_close] = ACTIONS(2154),
    [anon_sym_closedir] = ACTIONS(2154),
    [anon_sym_caller] = ACTIONS(2154),
    [anon_sym_chomp] = ACTIONS(2154),
    [anon_sym_chr] = ACTIONS(2154),
    [anon_sym_cos] = ACTIONS(2154),
    [anon_sym_chroot] = ACTIONS(2154),
    [anon_sym_defined] = ACTIONS(2154),
    [anon_sym_delete] = ACTIONS(2154),
    [anon_sym_dbmclose] = ACTIONS(2154),
    [anon_sym_exists] = ACTIONS(2154),
    [anon_sym_exit] = ACTIONS(2154),
    [anon_sym_eof] = ACTIONS(2154),
    [anon_sym_exp] = ACTIONS(2154),
    [anon_sym_each] = ACTIONS(2154),
    [anon_sym_fc] = ACTIONS(2154),
    [anon_sym_fileno] = ACTIONS(2154),
    [anon_sym_gmtime] = ACTIONS(2154),
    [anon_sym_getc] = ACTIONS(2154),
    [anon_sym_getpgrp] = ACTIONS(2154),
    [anon_sym_getprotobyname] = ACTIONS(2154),
    [anon_sym_getpwname] = ACTIONS(2154),
    [anon_sym_getpwuid] = ACTIONS(2154),
    [anon_sym_getpeername] = ACTIONS(2154),
    [anon_sym_getnetbyname] = ACTIONS(2154),
    [anon_sym_getsockname] = ACTIONS(2154),
    [anon_sym_getgrnam] = ACTIONS(2154),
    [anon_sym_getgrgid] = ACTIONS(2154),
    [anon_sym_hex] = ACTIONS(2154),
    [anon_sym_int] = ACTIONS(2154),
    [anon_sym_keys] = ACTIONS(2154),
    [anon_sym_lc] = ACTIONS(2154),
    [anon_sym_lcfirst] = ACTIONS(2154),
    [anon_sym_length] = ACTIONS(2154),
    [anon_sym_localtime] = ACTIONS(2154),
    [anon_sym_log] = ACTIONS(2154),
    [anon_sym_lock] = ACTIONS(2154),
    [anon_sym_lstat] = ACTIONS(2154),
    [anon_sym_oct] = ACTIONS(2154),
    [anon_sym_ord] = ACTIONS(2154),
    [anon_sym_prototype] = ACTIONS(2154),
    [anon_sym_pop] = ACTIONS(2154),
    [anon_sym_pos] = ACTIONS(2154),
    [anon_sym_quotemeta] = ACTIONS(2154),
    [anon_sym_reset] = ACTIONS(2154),
    [anon_sym_rand] = ACTIONS(2154),
    [anon_sym_rmdir] = ACTIONS(2154),
    [anon_sym_readdir] = ACTIONS(2154),
    [anon_sym_readline] = ACTIONS(2154),
    [anon_sym_readpipe] = ACTIONS(2154),
    [anon_sym_rewinddir] = ACTIONS(2154),
    [anon_sym_readlink] = ACTIONS(2154),
    [anon_sym_ref] = ACTIONS(2154),
    [anon_sym_scalar] = ACTIONS(2154),
    [anon_sym_shift] = ACTIONS(2154),
    [anon_sym_sin] = ACTIONS(2154),
    [anon_sym_sleep] = ACTIONS(2154),
    [anon_sym_sqrt] = ACTIONS(2154),
    [anon_sym_srand] = ACTIONS(2154),
    [anon_sym_stat] = ACTIONS(2154),
    [anon_sym_study] = ACTIONS(2154),
    [anon_sym_tell] = ACTIONS(2154),
    [anon_sym_telldir] = ACTIONS(2154),
    [anon_sym_tied] = ACTIONS(2154),
    [anon_sym_uc] = ACTIONS(2154),
    [anon_sym_ucfirst] = ACTIONS(2154),
    [anon_sym_untie] = ACTIONS(2154),
    [anon_sym_umask] = ACTIONS(2154),
    [anon_sym_values] = ACTIONS(2154),
    [anon_sym_write] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2073),
    [anon_sym___END__] = ACTIONS(2073),
    [anon_sym_q] = ACTIONS(2159),
    [anon_sym_qq] = ACTIONS(2162),
    [anon_sym_qw] = ACTIONS(2165),
    [anon_sym_qx] = ACTIONS(2168),
    [anon_sym_qr] = ACTIONS(2171),
    [anon_sym_m] = ACTIONS(2174),
    [anon_sym_s] = ACTIONS(2177),
    [anon_sym_tr] = ACTIONS(2180),
    [anon_sym_y] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2270),
    [anon_sym_unless] = ACTIONS(2270),
    [anon_sym_while] = ACTIONS(2273),
    [anon_sym_until] = ACTIONS(2273),
    [aux_sym__bareword_token1] = ACTIONS(2189),
    [sym_number] = ACTIONS(2192),
    [sym__apostrophe] = ACTIONS(2195),
    [sym__double_quote] = ACTIONS(2198),
    [sym__backtick] = ACTIONS(2201),
    [sym__search_slash] = ACTIONS(2204),
    [sym__PERLY_HEREDOC] = ACTIONS(2207),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [251] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(251),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [252] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1317),
    [sym_interpolated_string_literal] = STATE(1317),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1317),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(252),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(254),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [253] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2116),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(253),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(242),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [254] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(254),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [255] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(255),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [256] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(256),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [257] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(257),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [258] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(258),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [259] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(259),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(255),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [260] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(260),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [261] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(261),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(243),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [262] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(262),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [263] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(263),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(270),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [264] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(264),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(278),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [265] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(265),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [266] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(266),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [267] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(267),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [268] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(268),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(267),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [269] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(269),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [270] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(270),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [271] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(271),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(249),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [272] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(272),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [273] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(273),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [274] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2114),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(274),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(273),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [275] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(275),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(257),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [276] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(276),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(245),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [277] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(277),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [278] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(278),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(250),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [279] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1079),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2125),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(279),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [aux_sym_source_file_repeat1] = STATE(272),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [280] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(261),
    [sym_block] = STATE(1051),
    [sym__fullstmt] = STATE(1076),
    [sym_statement_label] = STATE(1105),
    [sym__barestmt] = STATE(1105),
    [sym_package_statement] = STATE(1107),
    [sym_class_statement] = STATE(1107),
    [sym_use_version_statement] = STATE(1107),
    [sym_use_statement] = STATE(1107),
    [sym_subroutine_declaration_statement] = STATE(1107),
    [sym_method_declaration_statement] = STATE(1107),
    [sym_phaser_statement] = STATE(1107),
    [sym_conditional_statement] = STATE(1107),
    [sym_loop_statement] = STATE(1107),
    [sym_cstyle_for_statement] = STATE(1107),
    [sym_for_statement] = STATE(1107),
    [sym_try_statement] = STATE(1107),
    [sym_defer_statement] = STATE(1107),
    [sym_expression_statement] = STATE(2406),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(280),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3178),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_package] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_sub] = ACTIONS(2214),
    [anon_sym_method] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_defer] = ACTIONS(1075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_no] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_foreach] = ACTIONS(2222),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(2224),
    [anon_sym_INIT] = ACTIONS(2224),
    [anon_sym_CHECK] = ACTIONS(2224),
    [anon_sym_UNITCHECK] = ACTIONS(2224),
    [anon_sym_END] = ACTIONS(2224),
    [anon_sym_ADJUST] = ACTIONS(2224),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_unless] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_until] = ACTIONS(2228),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [281] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(276),
    [sym_block] = STATE(995),
    [sym__fullstmt] = STATE(999),
    [sym_statement_label] = STATE(998),
    [sym__barestmt] = STATE(998),
    [sym_package_statement] = STATE(991),
    [sym_class_statement] = STATE(991),
    [sym_use_version_statement] = STATE(991),
    [sym_use_statement] = STATE(991),
    [sym_subroutine_declaration_statement] = STATE(991),
    [sym_method_declaration_statement] = STATE(991),
    [sym_phaser_statement] = STATE(991),
    [sym_conditional_statement] = STATE(991),
    [sym_loop_statement] = STATE(991),
    [sym_cstyle_for_statement] = STATE(991),
    [sym_for_statement] = STATE(991),
    [sym_try_statement] = STATE(991),
    [sym_defer_statement] = STATE(991),
    [sym_expression_statement] = STATE(2414),
    [sym__postfix_expressions] = STATE(2448),
    [sym_postfix_conditional_expression] = STATE(2445),
    [sym_postfix_loop_expression] = STATE(2445),
    [sym_postfix_for_expression] = STATE(2445),
    [sym_yadayada] = STATE(2448),
    [sym__expr] = STATE(2120),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(281),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(3186),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(19),
    [anon_sym_class] = ACTIONS(21),
    [anon_sym_sub] = ACTIONS(23),
    [anon_sym_method] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_defer] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(85),
    [anon_sym_no] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_foreach] = ACTIONS(87),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(91),
    [anon_sym_INIT] = ACTIONS(91),
    [anon_sym_CHECK] = ACTIONS(91),
    [anon_sym_UNITCHECK] = ACTIONS(91),
    [anon_sym_END] = ACTIONS(91),
    [anon_sym_ADJUST] = ACTIONS(91),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(117),
    [anon_sym_until] = ACTIONS(117),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [282] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(1128),
    [sym__expr] = STATE(2731),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_indirect_object] = STATE(409),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(933),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(282),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2322),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [283] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(1128),
    [sym__expr] = STATE(2837),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_indirect_object] = STATE(458),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(933),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(283),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [284] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(1128),
    [sym__expr] = STATE(3033),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_indirect_object] = STATE(446),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(933),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(284),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [285] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__semicolon] = STATE(1026),
    [sym__listexpr] = STATE(3015),
    [sym__term_rightward] = STATE(3133),
    [sym_list_expression] = STATE(3102),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1704),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(285),
    [sym__version] = STATE(403),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [sym_version] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(2358),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(2360),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [286] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__semicolon] = STATE(1094),
    [sym__listexpr] = STATE(3056),
    [sym__term_rightward] = STATE(3133),
    [sym_list_expression] = STATE(3102),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1704),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(286),
    [sym__version] = STATE(325),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [sym_version] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(2358),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(2364),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [287] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3183),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(287),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [288] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3220),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(288),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [289] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2873),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(289),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2414),
  },
  [290] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2873),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(290),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2416),
  },
  [291] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3173),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(291),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [292] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3205),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(292),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [293] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3234),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(293),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [294] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3275),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(294),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [295] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3314),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(295),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [296] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3190),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(296),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [297] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3251),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(297),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [298] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3311),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(298),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [299] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3293),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(299),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [300] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2873),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(300),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2418),
  },
  [301] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3283),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(301),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [302] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2873),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(302),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2420),
  },
  [303] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2933),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(303),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2424),
  },
  [304] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2922),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(304),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2428),
  },
  [305] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3280),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(305),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [306] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2873),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(306),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2430),
  },
  [307] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3221),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(307),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [308] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3144),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(308),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [309] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2933),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(309),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2432),
  },
  [310] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3168),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(310),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [311] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2922),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(311),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2434),
  },
  [312] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3163),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(312),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [313] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3301),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(313),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [314] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3174),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(314),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [315] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3175),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(315),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [316] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2906),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym__hash_key] = STATE(3219),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(316),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym__brace_autoquoted] = STATE(3229),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_sub] = ACTIONS(2370),
    [anon_sym_method] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_my] = ACTIONS(2376),
    [anon_sym_state] = ACTIONS(2376),
    [anon_sym_our] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_elsif] = ACTIONS(2368),
    [anon_sym_and] = ACTIONS(2368),
    [anon_sym_or] = ACTIONS(2368),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2368),
    [anon_sym_ne] = ACTIONS(2368),
    [anon_sym_cmp] = ACTIONS(2368),
    [anon_sym_lt] = ACTIONS(2368),
    [anon_sym_le] = ACTIONS(2368),
    [anon_sym_ge] = ACTIONS(2368),
    [anon_sym_gt] = ACTIONS(2368),
    [anon_sym_isa] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_eval] = ACTIONS(2382),
    [anon_sym_field] = ACTIONS(2376),
    [anon_sym_local] = ACTIONS(2384),
    [anon_sym_require] = ACTIONS(2386),
    [anon_sym_map] = ACTIONS(2388),
    [anon_sym_grep] = ACTIONS(2388),
    [anon_sym_sort] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_no] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_last] = ACTIONS(2394),
    [anon_sym_next] = ACTIONS(2394),
    [anon_sym_redo] = ACTIONS(2394),
    [anon_sym_BEGIN] = ACTIONS(2368),
    [anon_sym_INIT] = ACTIONS(2368),
    [anon_sym_CHECK] = ACTIONS(2368),
    [anon_sym_UNITCHECK] = ACTIONS(2368),
    [anon_sym_END] = ACTIONS(2368),
    [anon_sym_ADJUST] = ACTIONS(2368),
    [anon_sym___FILE__] = ACTIONS(2374),
    [anon_sym___LINE__] = ACTIONS(2374),
    [anon_sym___PACKAGE__] = ACTIONS(2374),
    [anon_sym___SUB__] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_fork] = ACTIONS(2374),
    [anon_sym_getppid] = ACTIONS(2374),
    [anon_sym_time] = ACTIONS(2374),
    [anon_sym_times] = ACTIONS(2374),
    [anon_sym_wait] = ACTIONS(2374),
    [anon_sym_wantarray] = ACTIONS(2374),
    [anon_sym_abs] = ACTIONS(2396),
    [anon_sym_alarm] = ACTIONS(2396),
    [anon_sym_chop] = ACTIONS(2396),
    [anon_sym_chdir] = ACTIONS(2396),
    [anon_sym_close] = ACTIONS(2396),
    [anon_sym_closedir] = ACTIONS(2396),
    [anon_sym_caller] = ACTIONS(2396),
    [anon_sym_chomp] = ACTIONS(2396),
    [anon_sym_chr] = ACTIONS(2396),
    [anon_sym_cos] = ACTIONS(2396),
    [anon_sym_chroot] = ACTIONS(2396),
    [anon_sym_defined] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_dbmclose] = ACTIONS(2396),
    [anon_sym_exists] = ACTIONS(2396),
    [anon_sym_exit] = ACTIONS(2396),
    [anon_sym_eof] = ACTIONS(2396),
    [anon_sym_exp] = ACTIONS(2396),
    [anon_sym_each] = ACTIONS(2396),
    [anon_sym_fc] = ACTIONS(2396),
    [anon_sym_fileno] = ACTIONS(2396),
    [anon_sym_gmtime] = ACTIONS(2396),
    [anon_sym_getc] = ACTIONS(2396),
    [anon_sym_getpgrp] = ACTIONS(2396),
    [anon_sym_getprotobyname] = ACTIONS(2396),
    [anon_sym_getpwname] = ACTIONS(2396),
    [anon_sym_getpwuid] = ACTIONS(2396),
    [anon_sym_getpeername] = ACTIONS(2396),
    [anon_sym_getnetbyname] = ACTIONS(2396),
    [anon_sym_getsockname] = ACTIONS(2396),
    [anon_sym_getgrnam] = ACTIONS(2396),
    [anon_sym_getgrgid] = ACTIONS(2396),
    [anon_sym_hex] = ACTIONS(2396),
    [anon_sym_int] = ACTIONS(2396),
    [anon_sym_keys] = ACTIONS(2396),
    [anon_sym_lc] = ACTIONS(2396),
    [anon_sym_lcfirst] = ACTIONS(2396),
    [anon_sym_length] = ACTIONS(2396),
    [anon_sym_localtime] = ACTIONS(2396),
    [anon_sym_log] = ACTIONS(2396),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_lstat] = ACTIONS(2396),
    [anon_sym_oct] = ACTIONS(2396),
    [anon_sym_ord] = ACTIONS(2396),
    [anon_sym_prototype] = ACTIONS(2396),
    [anon_sym_pop] = ACTIONS(2396),
    [anon_sym_pos] = ACTIONS(2396),
    [anon_sym_quotemeta] = ACTIONS(2396),
    [anon_sym_reset] = ACTIONS(2396),
    [anon_sym_rand] = ACTIONS(2396),
    [anon_sym_rmdir] = ACTIONS(2396),
    [anon_sym_readdir] = ACTIONS(2396),
    [anon_sym_readline] = ACTIONS(2396),
    [anon_sym_readpipe] = ACTIONS(2396),
    [anon_sym_rewinddir] = ACTIONS(2396),
    [anon_sym_readlink] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_scalar] = ACTIONS(2396),
    [anon_sym_shift] = ACTIONS(2396),
    [anon_sym_sin] = ACTIONS(2396),
    [anon_sym_sleep] = ACTIONS(2396),
    [anon_sym_sqrt] = ACTIONS(2396),
    [anon_sym_srand] = ACTIONS(2396),
    [anon_sym_stat] = ACTIONS(2396),
    [anon_sym_study] = ACTIONS(2396),
    [anon_sym_tell] = ACTIONS(2396),
    [anon_sym_telldir] = ACTIONS(2396),
    [anon_sym_tied] = ACTIONS(2396),
    [anon_sym_uc] = ACTIONS(2396),
    [anon_sym_ucfirst] = ACTIONS(2396),
    [anon_sym_untie] = ACTIONS(2396),
    [anon_sym_umask] = ACTIONS(2396),
    [anon_sym_values] = ACTIONS(2396),
    [anon_sym_write] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2368),
    [anon_sym___END__] = ACTIONS(2368),
    [anon_sym_q] = ACTIONS(2398),
    [anon_sym_qq] = ACTIONS(2400),
    [anon_sym_qw] = ACTIONS(2402),
    [anon_sym_qx] = ACTIONS(2404),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2406),
    [anon_sym_tr] = ACTIONS(2408),
    [anon_sym_y] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_unless] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_until] = ACTIONS(2368),
    [aux_sym__bareword_token1] = ACTIONS(2410),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [317] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(279),
    [sym_block] = STATE(931),
    [sym__term_rightward] = STATE(1322),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_indirect_object] = STATE(645),
    [sym__tricky_indirob_hashref] = STATE(1309),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(926),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(317),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [318] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2851),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(318),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [319] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1240),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(319),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(772),
    [anon_sym_or] = ACTIONS(772),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(772),
    [anon_sym_foreach] = ACTIONS(772),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(772),
    [anon_sym___END__] = ACTIONS(772),
    [anon_sym_EOT] = ACTIONS(576),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(772),
    [anon_sym_unless] = ACTIONS(772),
    [anon_sym_while] = ACTIONS(772),
    [anon_sym_until] = ACTIONS(772),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(796),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(796),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [320] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1457),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(320),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(772),
    [anon_sym_or] = ACTIONS(772),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(772),
    [anon_sym___END__] = ACTIONS(772),
    [anon_sym_EOT] = ACTIONS(576),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(796),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(796),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [321] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(321),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [322] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(322),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [323] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2804),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(323),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [324] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3008),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(324),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [325] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__semicolon] = STATE(1099),
    [sym__listexpr] = STATE(3061),
    [sym__term_rightward] = STATE(3133),
    [sym_list_expression] = STATE(3102),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1704),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(325),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(2364),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [326] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2873),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(326),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [327] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2882),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(327),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [328] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2915),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(328),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [329] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1604),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(329),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(628),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(628),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(819),
    [anon_sym_or] = ACTIONS(819),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [330] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1604),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(330),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [331] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2937),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(331),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [332] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3007),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(332),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2460),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [333] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2939),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(333),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [334] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3050),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(334),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [335] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3035),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(335),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [336] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2752),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(336),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [337] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2751),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(337),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [338] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1457),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(338),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(631),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(631),
    [anon_sym___END__] = ACTIONS(631),
    [anon_sym_EOT] = ACTIONS(628),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(663),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(663),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [339] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2922),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(339),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [340] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1457),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(340),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(669),
    [anon_sym___END__] = ACTIONS(669),
    [anon_sym_EOT] = ACTIONS(666),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(701),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(701),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [341] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2910),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(341),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [342] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2900),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(342),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [343] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2759),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(343),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [344] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2888),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(344),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [345] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2763),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(345),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [346] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2877),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(346),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [347] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2843),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(347),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [348] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2839),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(348),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2486),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [349] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2817),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(349),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [350] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2669),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(350),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [351] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(351),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [352] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(352),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [353] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(353),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [354] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__PERLY_BRACE_OPEN] = STATE(274),
    [sym_block] = STATE(943),
    [sym__term_rightward] = STATE(1822),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_indirect_object] = STATE(657),
    [sym__tricky_indirob_hashref] = STATE(1821),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(946),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(354),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [355] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(355),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [356] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(356),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [357] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(357),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [358] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(358),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [359] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1240),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(359),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_foreach] = ACTIONS(669),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(669),
    [anon_sym___END__] = ACTIONS(669),
    [anon_sym_EOT] = ACTIONS(666),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_unless] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(669),
    [anon_sym_until] = ACTIONS(669),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(701),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(701),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [360] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(360),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [361] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(361),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [362] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(362),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [363] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(363),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [364] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(364),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [365] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(365),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [366] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(366),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [367] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1240),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(367),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(631),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_foreach] = ACTIONS(631),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(631),
    [anon_sym___END__] = ACTIONS(631),
    [anon_sym_EOT] = ACTIONS(628),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(631),
    [anon_sym_unless] = ACTIONS(631),
    [anon_sym_while] = ACTIONS(631),
    [anon_sym_until] = ACTIONS(631),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_SEMICOLON] = ACTIONS(663),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym__ctrl_z_hack] = ACTIONS(663),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [368] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(253),
    [sym_block] = STATE(949),
    [sym__term_rightward] = STATE(1499),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_indirect_object] = STATE(637),
    [sym__tricky_indirob_hashref] = STATE(1880),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(954),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(368),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [369] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1604),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(369),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(704),
    [anon_sym_or] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [370] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2757),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(370),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [371] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(371),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [372] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(372),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [373] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(373),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [374] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(374),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [375] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2954),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(375),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [376] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(279),
    [sym_block] = STATE(932),
    [sym__term_rightward] = STATE(1322),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_indirect_object] = STATE(679),
    [sym__tricky_indirob_hashref] = STATE(1443),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(928),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(376),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [377] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(377),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [378] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(378),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [379] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2887),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(379),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [380] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2891),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(380),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [381] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(381),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [382] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2799),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(382),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [383] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2815),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(383),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [384] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2933),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(384),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [385] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(623),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(385),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [386] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(624),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1917),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3135),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(386),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [387] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(387),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [388] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2778),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(388),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [389] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(253),
    [sym_block] = STATE(949),
    [sym__term_rightward] = STATE(1499),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_indirect_object] = STATE(653),
    [sym__tricky_indirob_hashref] = STATE(1907),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(954),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(389),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [390] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2776),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(390),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [391] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(391),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [392] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2911),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(392),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2518),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [393] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(253),
    [sym_block] = STATE(949),
    [sym__term_rightward] = STATE(1499),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_indirect_object] = STATE(681),
    [sym__tricky_indirob_hashref] = STATE(1912),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(954),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(393),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [394] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(394),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [395] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(395),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [396] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(396),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [397] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2681),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(397),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [398] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(253),
    [sym_block] = STATE(949),
    [sym__term_rightward] = STATE(1499),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_indirect_object] = STATE(668),
    [sym__tricky_indirob_hashref] = STATE(1870),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(954),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(398),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [399] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(253),
    [sym_block] = STATE(934),
    [sym__term_rightward] = STATE(1499),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_indirect_object] = STATE(619),
    [sym__tricky_indirob_hashref] = STATE(1622),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(933),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(399),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [400] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2905),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(400),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [401] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(401),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [402] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(402),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [403] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__semicolon] = STATE(980),
    [sym__listexpr] = STATE(2955),
    [sym__term_rightward] = STATE(3133),
    [sym_list_expression] = STATE(3102),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1704),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(403),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(2360),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [404] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2774),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(404),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [405] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2878),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(405),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [406] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2784),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(406),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [407] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2805),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(407),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [408] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2920),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(408),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [409] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2832),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(409),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [410] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2794),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(410),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [411] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2795),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(411),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [412] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2830),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(412),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [413] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2762),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(413),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [414] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(688),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(414),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [415] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2451),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(415),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [416] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2730),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(416),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [417] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(417),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [418] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2803),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(418),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [419] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2798),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(419),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [420] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2792),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(420),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [421] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2447),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(421),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [422] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2835),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(422),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [423] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(673),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(423),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [424] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2838),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(424),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [425] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__expr] = STATE(2393),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1413),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(425),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [426] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__expr] = STATE(2124),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1413),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(426),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [427] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2735),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(427),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [428] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(428),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [429] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2740),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(429),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [430] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(631),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1930),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3119),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(430),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [431] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2739),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(431),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [432] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(632),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(432),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [433] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2732),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(433),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [434] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2847),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(434),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [435] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2796),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(435),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [436] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2853),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(436),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [437] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(437),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [438] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(624),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1917),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3135),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(438),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [439] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2797),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(439),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [440] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2854),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(440),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [441] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(696),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(441),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [442] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2725),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(442),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [443] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2833),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(443),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [444] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2893),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(444),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [445] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2855),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(445),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [446] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3003),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(446),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [447] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3009),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(447),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [448] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3010),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(448),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [449] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2856),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(449),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [450] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2723),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(450),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [451] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1615),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(451),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [452] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2767),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(452),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [453] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2737),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(453),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [454] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2800),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(454),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [455] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2801),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(455),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [456] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2860),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(456),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [457] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2749),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(457),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [458] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2814),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(458),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [459] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3020),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(459),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [460] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__expr] = STATE(2124),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(460),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [461] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2861),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(461),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [462] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2862),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(462),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [463] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(463),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [464] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3029),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(464),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [465] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__expr] = STATE(2132),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1212),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(465),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [466] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3034),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(466),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [467] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__expr] = STATE(2383),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1413),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(467),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [468] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2736),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(468),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [469] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2869),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(469),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [470] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__expr] = STATE(2388),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1413),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(470),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [471] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__expr] = STATE(2397),
    [sym_lowprec_logical_expression] = STATE(2121),
    [sym__listexpr] = STATE(2121),
    [sym__term_rightward] = STATE(2128),
    [sym_list_expression] = STATE(2126),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1413),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(471),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [472] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2758),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(472),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [473] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2981),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(473),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [474] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2870),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(474),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [475] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2857),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(475),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [476] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3006),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(476),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [477] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2871),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(477),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [478] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2777),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(478),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [479] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(479),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [480] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3054),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(480),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [481] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2872),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(481),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [482] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(482),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [483] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2727),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(483),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [484] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2745),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(484),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [485] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3065),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(485),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [486] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3064),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(486),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [487] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3060),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(487),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [488] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3059),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(488),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [489] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2874),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(489),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [490] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2724),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(490),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [491] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2788),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(491),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [492] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3025),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(492),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [493] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3021),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(493),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [494] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3019),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(494),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [495] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2876),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(495),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [496] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3001),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(496),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [497] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2999),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(497),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [498] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2997),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(498),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [499] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2989),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(499),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [500] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2986),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(500),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [501] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2744),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(501),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [502] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2940),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(502),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [503] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(635),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1935),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3136),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(503),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [504] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3016),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(504),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [505] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(505),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [506] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2983),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(506),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [507] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(674),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1947),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3098),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(507),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [508] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2982),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(508),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [509] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(3053),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(509),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [510] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(510),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [511] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(511),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [512] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(695),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1933),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3081),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(512),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [513] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(513),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [514] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2831),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(514),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [515] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(686),
    [sym__term_rightward] = STATE(1328),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(515),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [516] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2858),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(516),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [517] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(636),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(517),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [518] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(518),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [519] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2807),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(519),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [520] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2829),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(520),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [521] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2741),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(521),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [522] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2828),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(522),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [523] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(523),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [524] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(655),
    [sym__term_rightward] = STATE(1832),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(524),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [525] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2950),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(525),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [526] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2818),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(526),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [527] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(527),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [528] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2793),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(528),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [529] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2738),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(529),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [530] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2810),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(530),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [531] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(531),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [532] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(654),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1931),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3111),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(532),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [533] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2934),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(533),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [534] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(623),
    [sym__term_rightward] = STATE(1526),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(534),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [535] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(689),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1929),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3103),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(535),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [536] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(536),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [537] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__expr] = STATE(2948),
    [sym_lowprec_logical_expression] = STATE(2442),
    [sym__listexpr] = STATE(2442),
    [sym__term_rightward] = STATE(2476),
    [sym_list_expression] = STATE(2466),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1556),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(537),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [538] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(690),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1922),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3097),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(538),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [539] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(647),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1923),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3075),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(539),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [540] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__PERLY_BRACE_OPEN] = STATE(263),
    [sym_block] = STATE(1836),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1835),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(540),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [541] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1906),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(541),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [542] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1892),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(542),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [543] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(658),
    [sym__term_rightward] = STATE(3210),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(543),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [544] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1744),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(544),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(701),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [545] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1944),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(545),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [546] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1313),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(546),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [547] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(659),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1919),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3127),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(547),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [548] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1312),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1433),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(548),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [549] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1615),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(549),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [550] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(693),
    [sym__term_rightward] = STATE(3297),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(550),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [551] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(252),
    [sym_block] = STATE(692),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1934),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym__tricky_hashref] = STATE(3087),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(551),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [552] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(246),
    [sym_block] = STATE(646),
    [sym__term_rightward] = STATE(3181),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(552),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [553] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1744),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(553),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(663),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [554] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1744),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(554),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_SEMICOLON] = ACTIONS(796),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [555] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1587),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1980),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(555),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_LBRACE2] = ACTIONS(15),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [556] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1877),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(556),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [557] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1877),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(557),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(628),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [558] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1877),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(558),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [559] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(559),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [560] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1895),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(560),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2540),
    [anon_sym_method] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2546),
    [anon_sym_state] = ACTIONS(2546),
    [anon_sym_our] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2552),
    [anon_sym_field] = ACTIONS(2546),
    [anon_sym_local] = ACTIONS(2554),
    [anon_sym_require] = ACTIONS(2556),
    [anon_sym_map] = ACTIONS(2558),
    [anon_sym_grep] = ACTIONS(2558),
    [anon_sym_sort] = ACTIONS(2560),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2564),
    [anon_sym_next] = ACTIONS(2564),
    [anon_sym_redo] = ACTIONS(2564),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2566),
    [anon_sym_alarm] = ACTIONS(2566),
    [anon_sym_chop] = ACTIONS(2566),
    [anon_sym_chdir] = ACTIONS(2566),
    [anon_sym_close] = ACTIONS(2566),
    [anon_sym_closedir] = ACTIONS(2566),
    [anon_sym_caller] = ACTIONS(2566),
    [anon_sym_chomp] = ACTIONS(2566),
    [anon_sym_chr] = ACTIONS(2566),
    [anon_sym_cos] = ACTIONS(2566),
    [anon_sym_chroot] = ACTIONS(2566),
    [anon_sym_defined] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_dbmclose] = ACTIONS(2566),
    [anon_sym_exists] = ACTIONS(2566),
    [anon_sym_exit] = ACTIONS(2566),
    [anon_sym_eof] = ACTIONS(2566),
    [anon_sym_exp] = ACTIONS(2566),
    [anon_sym_each] = ACTIONS(2566),
    [anon_sym_fc] = ACTIONS(2566),
    [anon_sym_fileno] = ACTIONS(2566),
    [anon_sym_gmtime] = ACTIONS(2566),
    [anon_sym_getc] = ACTIONS(2566),
    [anon_sym_getpgrp] = ACTIONS(2566),
    [anon_sym_getprotobyname] = ACTIONS(2566),
    [anon_sym_getpwname] = ACTIONS(2566),
    [anon_sym_getpwuid] = ACTIONS(2566),
    [anon_sym_getpeername] = ACTIONS(2566),
    [anon_sym_getnetbyname] = ACTIONS(2566),
    [anon_sym_getsockname] = ACTIONS(2566),
    [anon_sym_getgrnam] = ACTIONS(2566),
    [anon_sym_getgrgid] = ACTIONS(2566),
    [anon_sym_hex] = ACTIONS(2566),
    [anon_sym_int] = ACTIONS(2566),
    [anon_sym_keys] = ACTIONS(2566),
    [anon_sym_lc] = ACTIONS(2566),
    [anon_sym_lcfirst] = ACTIONS(2566),
    [anon_sym_length] = ACTIONS(2566),
    [anon_sym_localtime] = ACTIONS(2566),
    [anon_sym_log] = ACTIONS(2566),
    [anon_sym_lock] = ACTIONS(2566),
    [anon_sym_lstat] = ACTIONS(2566),
    [anon_sym_oct] = ACTIONS(2566),
    [anon_sym_ord] = ACTIONS(2566),
    [anon_sym_prototype] = ACTIONS(2566),
    [anon_sym_pop] = ACTIONS(2566),
    [anon_sym_pos] = ACTIONS(2566),
    [anon_sym_quotemeta] = ACTIONS(2566),
    [anon_sym_reset] = ACTIONS(2566),
    [anon_sym_rand] = ACTIONS(2566),
    [anon_sym_rmdir] = ACTIONS(2566),
    [anon_sym_readdir] = ACTIONS(2566),
    [anon_sym_readline] = ACTIONS(2566),
    [anon_sym_readpipe] = ACTIONS(2566),
    [anon_sym_rewinddir] = ACTIONS(2566),
    [anon_sym_readlink] = ACTIONS(2566),
    [anon_sym_ref] = ACTIONS(2566),
    [anon_sym_scalar] = ACTIONS(2566),
    [anon_sym_shift] = ACTIONS(2566),
    [anon_sym_sin] = ACTIONS(2566),
    [anon_sym_sleep] = ACTIONS(2566),
    [anon_sym_sqrt] = ACTIONS(2566),
    [anon_sym_srand] = ACTIONS(2566),
    [anon_sym_stat] = ACTIONS(2566),
    [anon_sym_study] = ACTIONS(2566),
    [anon_sym_tell] = ACTIONS(2566),
    [anon_sym_telldir] = ACTIONS(2566),
    [anon_sym_tied] = ACTIONS(2566),
    [anon_sym_uc] = ACTIONS(2566),
    [anon_sym_ucfirst] = ACTIONS(2566),
    [anon_sym_untie] = ACTIONS(2566),
    [anon_sym_umask] = ACTIONS(2566),
    [anon_sym_values] = ACTIONS(2566),
    [anon_sym_write] = ACTIONS(2566),
    [aux_sym__func1op_token1] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2584),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [561] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1831),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym__label_arg] = STATE(1830),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(561),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_identifier] = STATE(1829),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [562] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1971),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(562),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2586),
    [anon_sym_method] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2590),
    [anon_sym_state] = ACTIONS(2590),
    [anon_sym_our] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2594),
    [anon_sym_field] = ACTIONS(2590),
    [anon_sym_local] = ACTIONS(2596),
    [anon_sym_require] = ACTIONS(2598),
    [anon_sym_map] = ACTIONS(2600),
    [anon_sym_grep] = ACTIONS(2600),
    [anon_sym_sort] = ACTIONS(2602),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2606),
    [anon_sym_next] = ACTIONS(2606),
    [anon_sym_redo] = ACTIONS(2606),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2608),
    [anon_sym_alarm] = ACTIONS(2608),
    [anon_sym_chop] = ACTIONS(2608),
    [anon_sym_chdir] = ACTIONS(2608),
    [anon_sym_close] = ACTIONS(2608),
    [anon_sym_closedir] = ACTIONS(2608),
    [anon_sym_caller] = ACTIONS(2608),
    [anon_sym_chomp] = ACTIONS(2608),
    [anon_sym_chr] = ACTIONS(2608),
    [anon_sym_cos] = ACTIONS(2608),
    [anon_sym_chroot] = ACTIONS(2608),
    [anon_sym_defined] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_dbmclose] = ACTIONS(2608),
    [anon_sym_exists] = ACTIONS(2608),
    [anon_sym_exit] = ACTIONS(2608),
    [anon_sym_eof] = ACTIONS(2608),
    [anon_sym_exp] = ACTIONS(2608),
    [anon_sym_each] = ACTIONS(2608),
    [anon_sym_fc] = ACTIONS(2608),
    [anon_sym_fileno] = ACTIONS(2608),
    [anon_sym_gmtime] = ACTIONS(2608),
    [anon_sym_getc] = ACTIONS(2608),
    [anon_sym_getpgrp] = ACTIONS(2608),
    [anon_sym_getprotobyname] = ACTIONS(2608),
    [anon_sym_getpwname] = ACTIONS(2608),
    [anon_sym_getpwuid] = ACTIONS(2608),
    [anon_sym_getpeername] = ACTIONS(2608),
    [anon_sym_getnetbyname] = ACTIONS(2608),
    [anon_sym_getsockname] = ACTIONS(2608),
    [anon_sym_getgrnam] = ACTIONS(2608),
    [anon_sym_getgrgid] = ACTIONS(2608),
    [anon_sym_hex] = ACTIONS(2608),
    [anon_sym_int] = ACTIONS(2608),
    [anon_sym_keys] = ACTIONS(2608),
    [anon_sym_lc] = ACTIONS(2608),
    [anon_sym_lcfirst] = ACTIONS(2608),
    [anon_sym_length] = ACTIONS(2608),
    [anon_sym_localtime] = ACTIONS(2608),
    [anon_sym_log] = ACTIONS(2608),
    [anon_sym_lock] = ACTIONS(2608),
    [anon_sym_lstat] = ACTIONS(2608),
    [anon_sym_oct] = ACTIONS(2608),
    [anon_sym_ord] = ACTIONS(2608),
    [anon_sym_prototype] = ACTIONS(2608),
    [anon_sym_pop] = ACTIONS(2608),
    [anon_sym_pos] = ACTIONS(2608),
    [anon_sym_quotemeta] = ACTIONS(2608),
    [anon_sym_reset] = ACTIONS(2608),
    [anon_sym_rand] = ACTIONS(2608),
    [anon_sym_rmdir] = ACTIONS(2608),
    [anon_sym_readdir] = ACTIONS(2608),
    [anon_sym_readline] = ACTIONS(2608),
    [anon_sym_readpipe] = ACTIONS(2608),
    [anon_sym_rewinddir] = ACTIONS(2608),
    [anon_sym_readlink] = ACTIONS(2608),
    [anon_sym_ref] = ACTIONS(2608),
    [anon_sym_scalar] = ACTIONS(2608),
    [anon_sym_shift] = ACTIONS(2608),
    [anon_sym_sin] = ACTIONS(2608),
    [anon_sym_sleep] = ACTIONS(2608),
    [anon_sym_sqrt] = ACTIONS(2608),
    [anon_sym_srand] = ACTIONS(2608),
    [anon_sym_stat] = ACTIONS(2608),
    [anon_sym_study] = ACTIONS(2608),
    [anon_sym_tell] = ACTIONS(2608),
    [anon_sym_telldir] = ACTIONS(2608),
    [anon_sym_tied] = ACTIONS(2608),
    [anon_sym_uc] = ACTIONS(2608),
    [anon_sym_ucfirst] = ACTIONS(2608),
    [anon_sym_untie] = ACTIONS(2608),
    [anon_sym_umask] = ACTIONS(2608),
    [anon_sym_values] = ACTIONS(2608),
    [anon_sym_write] = ACTIONS(2608),
    [aux_sym__func1op_token1] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2584),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [563] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1888),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1545),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(563),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [564] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(564),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [565] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(565),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [566] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(566),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [567] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(567),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [568] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(568),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [569] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1842),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(569),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(2662),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_sub] = ACTIONS(2666),
    [anon_sym_method] = ACTIONS(2668),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(2670),
    [anon_sym_my] = ACTIONS(2672),
    [anon_sym_state] = ACTIONS(2672),
    [anon_sym_our] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_else] = ACTIONS(2664),
    [anon_sym_elsif] = ACTIONS(2664),
    [anon_sym_and] = ACTIONS(2664),
    [anon_sym_or] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(2664),
    [anon_sym_ne] = ACTIONS(2664),
    [anon_sym_cmp] = ACTIONS(2664),
    [anon_sym_lt] = ACTIONS(2664),
    [anon_sym_le] = ACTIONS(2664),
    [anon_sym_ge] = ACTIONS(2664),
    [anon_sym_gt] = ACTIONS(2664),
    [anon_sym_isa] = ACTIONS(2664),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_eval] = ACTIONS(2678),
    [anon_sym_field] = ACTIONS(2672),
    [anon_sym_local] = ACTIONS(2680),
    [anon_sym_require] = ACTIONS(2682),
    [anon_sym_map] = ACTIONS(2684),
    [anon_sym_grep] = ACTIONS(2684),
    [anon_sym_sort] = ACTIONS(2686),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(2664),
    [anon_sym_no] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_foreach] = ACTIONS(2664),
    [anon_sym_last] = ACTIONS(2690),
    [anon_sym_next] = ACTIONS(2690),
    [anon_sym_redo] = ACTIONS(2690),
    [anon_sym_BEGIN] = ACTIONS(2664),
    [anon_sym_INIT] = ACTIONS(2664),
    [anon_sym_CHECK] = ACTIONS(2664),
    [anon_sym_UNITCHECK] = ACTIONS(2664),
    [anon_sym_END] = ACTIONS(2664),
    [anon_sym_ADJUST] = ACTIONS(2664),
    [anon_sym___FILE__] = ACTIONS(2670),
    [anon_sym___LINE__] = ACTIONS(2670),
    [anon_sym___PACKAGE__] = ACTIONS(2670),
    [anon_sym___SUB__] = ACTIONS(2670),
    [anon_sym_break] = ACTIONS(2670),
    [anon_sym_fork] = ACTIONS(2670),
    [anon_sym_getppid] = ACTIONS(2670),
    [anon_sym_time] = ACTIONS(2670),
    [anon_sym_times] = ACTIONS(2670),
    [anon_sym_wait] = ACTIONS(2670),
    [anon_sym_wantarray] = ACTIONS(2670),
    [anon_sym_abs] = ACTIONS(2692),
    [anon_sym_alarm] = ACTIONS(2692),
    [anon_sym_chop] = ACTIONS(2692),
    [anon_sym_chdir] = ACTIONS(2692),
    [anon_sym_close] = ACTIONS(2692),
    [anon_sym_closedir] = ACTIONS(2692),
    [anon_sym_caller] = ACTIONS(2692),
    [anon_sym_chomp] = ACTIONS(2692),
    [anon_sym_chr] = ACTIONS(2692),
    [anon_sym_cos] = ACTIONS(2692),
    [anon_sym_chroot] = ACTIONS(2692),
    [anon_sym_defined] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_dbmclose] = ACTIONS(2692),
    [anon_sym_exists] = ACTIONS(2692),
    [anon_sym_exit] = ACTIONS(2692),
    [anon_sym_eof] = ACTIONS(2692),
    [anon_sym_exp] = ACTIONS(2692),
    [anon_sym_each] = ACTIONS(2692),
    [anon_sym_fc] = ACTIONS(2692),
    [anon_sym_fileno] = ACTIONS(2692),
    [anon_sym_gmtime] = ACTIONS(2692),
    [anon_sym_getc] = ACTIONS(2692),
    [anon_sym_getpgrp] = ACTIONS(2692),
    [anon_sym_getprotobyname] = ACTIONS(2692),
    [anon_sym_getpwname] = ACTIONS(2692),
    [anon_sym_getpwuid] = ACTIONS(2692),
    [anon_sym_getpeername] = ACTIONS(2692),
    [anon_sym_getnetbyname] = ACTIONS(2692),
    [anon_sym_getsockname] = ACTIONS(2692),
    [anon_sym_getgrnam] = ACTIONS(2692),
    [anon_sym_getgrgid] = ACTIONS(2692),
    [anon_sym_hex] = ACTIONS(2692),
    [anon_sym_int] = ACTIONS(2692),
    [anon_sym_keys] = ACTIONS(2692),
    [anon_sym_lc] = ACTIONS(2692),
    [anon_sym_lcfirst] = ACTIONS(2692),
    [anon_sym_length] = ACTIONS(2692),
    [anon_sym_localtime] = ACTIONS(2692),
    [anon_sym_log] = ACTIONS(2692),
    [anon_sym_lock] = ACTIONS(2692),
    [anon_sym_lstat] = ACTIONS(2692),
    [anon_sym_oct] = ACTIONS(2692),
    [anon_sym_ord] = ACTIONS(2692),
    [anon_sym_prototype] = ACTIONS(2692),
    [anon_sym_pop] = ACTIONS(2692),
    [anon_sym_pos] = ACTIONS(2692),
    [anon_sym_quotemeta] = ACTIONS(2692),
    [anon_sym_reset] = ACTIONS(2692),
    [anon_sym_rand] = ACTIONS(2692),
    [anon_sym_rmdir] = ACTIONS(2692),
    [anon_sym_readdir] = ACTIONS(2692),
    [anon_sym_readline] = ACTIONS(2692),
    [anon_sym_readpipe] = ACTIONS(2692),
    [anon_sym_rewinddir] = ACTIONS(2692),
    [anon_sym_readlink] = ACTIONS(2692),
    [anon_sym_ref] = ACTIONS(2692),
    [anon_sym_scalar] = ACTIONS(2692),
    [anon_sym_shift] = ACTIONS(2692),
    [anon_sym_sin] = ACTIONS(2692),
    [anon_sym_sleep] = ACTIONS(2692),
    [anon_sym_sqrt] = ACTIONS(2692),
    [anon_sym_srand] = ACTIONS(2692),
    [anon_sym_stat] = ACTIONS(2692),
    [anon_sym_study] = ACTIONS(2692),
    [anon_sym_tell] = ACTIONS(2692),
    [anon_sym_telldir] = ACTIONS(2692),
    [anon_sym_tied] = ACTIONS(2692),
    [anon_sym_uc] = ACTIONS(2692),
    [anon_sym_ucfirst] = ACTIONS(2692),
    [anon_sym_untie] = ACTIONS(2692),
    [anon_sym_umask] = ACTIONS(2692),
    [anon_sym_values] = ACTIONS(2692),
    [anon_sym_write] = ACTIONS(2692),
    [aux_sym__func1op_token1] = ACTIONS(2694),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2664),
    [anon_sym___END__] = ACTIONS(2664),
    [anon_sym_q] = ACTIONS(2696),
    [anon_sym_qq] = ACTIONS(2698),
    [anon_sym_qw] = ACTIONS(2700),
    [anon_sym_qx] = ACTIONS(2702),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(2704),
    [anon_sym_tr] = ACTIONS(2706),
    [anon_sym_y] = ACTIONS(2706),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_unless] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_until] = ACTIONS(2664),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2708),
    [aux_sym__bareword_token1] = ACTIONS(2710),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [570] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(570),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2712),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [571] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1436),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1357),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(571),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [572] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(572),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [573] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(573),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [574] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1431),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(574),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2716),
    [anon_sym_state] = ACTIONS(2716),
    [anon_sym_our] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2718),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2720),
    [anon_sym_field] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2722),
    [anon_sym_require] = ACTIONS(2724),
    [anon_sym_map] = ACTIONS(2726),
    [anon_sym_grep] = ACTIONS(2726),
    [anon_sym_sort] = ACTIONS(2728),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(2730),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2732),
    [anon_sym_next] = ACTIONS(2732),
    [anon_sym_redo] = ACTIONS(2732),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2734),
    [anon_sym_alarm] = ACTIONS(2734),
    [anon_sym_chop] = ACTIONS(2734),
    [anon_sym_chdir] = ACTIONS(2734),
    [anon_sym_close] = ACTIONS(2734),
    [anon_sym_closedir] = ACTIONS(2734),
    [anon_sym_caller] = ACTIONS(2734),
    [anon_sym_chomp] = ACTIONS(2734),
    [anon_sym_chr] = ACTIONS(2734),
    [anon_sym_cos] = ACTIONS(2734),
    [anon_sym_chroot] = ACTIONS(2734),
    [anon_sym_defined] = ACTIONS(2734),
    [anon_sym_delete] = ACTIONS(2734),
    [anon_sym_dbmclose] = ACTIONS(2734),
    [anon_sym_exists] = ACTIONS(2734),
    [anon_sym_exit] = ACTIONS(2734),
    [anon_sym_eof] = ACTIONS(2734),
    [anon_sym_exp] = ACTIONS(2734),
    [anon_sym_each] = ACTIONS(2734),
    [anon_sym_fc] = ACTIONS(2734),
    [anon_sym_fileno] = ACTIONS(2734),
    [anon_sym_gmtime] = ACTIONS(2734),
    [anon_sym_getc] = ACTIONS(2734),
    [anon_sym_getpgrp] = ACTIONS(2734),
    [anon_sym_getprotobyname] = ACTIONS(2734),
    [anon_sym_getpwname] = ACTIONS(2734),
    [anon_sym_getpwuid] = ACTIONS(2734),
    [anon_sym_getpeername] = ACTIONS(2734),
    [anon_sym_getnetbyname] = ACTIONS(2734),
    [anon_sym_getsockname] = ACTIONS(2734),
    [anon_sym_getgrnam] = ACTIONS(2734),
    [anon_sym_getgrgid] = ACTIONS(2734),
    [anon_sym_hex] = ACTIONS(2734),
    [anon_sym_int] = ACTIONS(2734),
    [anon_sym_keys] = ACTIONS(2734),
    [anon_sym_lc] = ACTIONS(2734),
    [anon_sym_lcfirst] = ACTIONS(2734),
    [anon_sym_length] = ACTIONS(2734),
    [anon_sym_localtime] = ACTIONS(2734),
    [anon_sym_log] = ACTIONS(2734),
    [anon_sym_lock] = ACTIONS(2734),
    [anon_sym_lstat] = ACTIONS(2734),
    [anon_sym_oct] = ACTIONS(2734),
    [anon_sym_ord] = ACTIONS(2734),
    [anon_sym_prototype] = ACTIONS(2734),
    [anon_sym_pop] = ACTIONS(2734),
    [anon_sym_pos] = ACTIONS(2734),
    [anon_sym_quotemeta] = ACTIONS(2734),
    [anon_sym_reset] = ACTIONS(2734),
    [anon_sym_rand] = ACTIONS(2734),
    [anon_sym_rmdir] = ACTIONS(2734),
    [anon_sym_readdir] = ACTIONS(2734),
    [anon_sym_readline] = ACTIONS(2734),
    [anon_sym_readpipe] = ACTIONS(2734),
    [anon_sym_rewinddir] = ACTIONS(2734),
    [anon_sym_readlink] = ACTIONS(2734),
    [anon_sym_ref] = ACTIONS(2734),
    [anon_sym_scalar] = ACTIONS(2734),
    [anon_sym_shift] = ACTIONS(2734),
    [anon_sym_sin] = ACTIONS(2734),
    [anon_sym_sleep] = ACTIONS(2734),
    [anon_sym_sqrt] = ACTIONS(2734),
    [anon_sym_srand] = ACTIONS(2734),
    [anon_sym_stat] = ACTIONS(2734),
    [anon_sym_study] = ACTIONS(2734),
    [anon_sym_tell] = ACTIONS(2734),
    [anon_sym_telldir] = ACTIONS(2734),
    [anon_sym_tied] = ACTIONS(2734),
    [anon_sym_uc] = ACTIONS(2734),
    [anon_sym_ucfirst] = ACTIONS(2734),
    [anon_sym_untie] = ACTIONS(2734),
    [anon_sym_umask] = ACTIONS(2734),
    [anon_sym_values] = ACTIONS(2734),
    [anon_sym_write] = ACTIONS(2734),
    [aux_sym__func1op_token1] = ACTIONS(2736),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2738),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [575] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(575),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [576] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1842),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(576),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(2662),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_sub] = ACTIONS(2666),
    [anon_sym_method] = ACTIONS(2668),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(2670),
    [anon_sym_my] = ACTIONS(2672),
    [anon_sym_state] = ACTIONS(2672),
    [anon_sym_our] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_else] = ACTIONS(2664),
    [anon_sym_elsif] = ACTIONS(2664),
    [anon_sym_and] = ACTIONS(2664),
    [anon_sym_or] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(2664),
    [anon_sym_ne] = ACTIONS(2664),
    [anon_sym_cmp] = ACTIONS(2664),
    [anon_sym_lt] = ACTIONS(2664),
    [anon_sym_le] = ACTIONS(2664),
    [anon_sym_ge] = ACTIONS(2664),
    [anon_sym_gt] = ACTIONS(2664),
    [anon_sym_isa] = ACTIONS(2664),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_eval] = ACTIONS(2678),
    [anon_sym_field] = ACTIONS(2672),
    [anon_sym_local] = ACTIONS(2680),
    [anon_sym_require] = ACTIONS(2682),
    [anon_sym_map] = ACTIONS(2684),
    [anon_sym_grep] = ACTIONS(2684),
    [anon_sym_sort] = ACTIONS(2686),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(2664),
    [anon_sym_no] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_foreach] = ACTIONS(2664),
    [anon_sym_last] = ACTIONS(2690),
    [anon_sym_next] = ACTIONS(2690),
    [anon_sym_redo] = ACTIONS(2690),
    [anon_sym_BEGIN] = ACTIONS(2664),
    [anon_sym_INIT] = ACTIONS(2664),
    [anon_sym_CHECK] = ACTIONS(2664),
    [anon_sym_UNITCHECK] = ACTIONS(2664),
    [anon_sym_END] = ACTIONS(2664),
    [anon_sym_ADJUST] = ACTIONS(2664),
    [anon_sym___FILE__] = ACTIONS(2670),
    [anon_sym___LINE__] = ACTIONS(2670),
    [anon_sym___PACKAGE__] = ACTIONS(2670),
    [anon_sym___SUB__] = ACTIONS(2670),
    [anon_sym_break] = ACTIONS(2670),
    [anon_sym_fork] = ACTIONS(2670),
    [anon_sym_getppid] = ACTIONS(2670),
    [anon_sym_time] = ACTIONS(2670),
    [anon_sym_times] = ACTIONS(2670),
    [anon_sym_wait] = ACTIONS(2670),
    [anon_sym_wantarray] = ACTIONS(2670),
    [anon_sym_abs] = ACTIONS(2692),
    [anon_sym_alarm] = ACTIONS(2692),
    [anon_sym_chop] = ACTIONS(2692),
    [anon_sym_chdir] = ACTIONS(2692),
    [anon_sym_close] = ACTIONS(2692),
    [anon_sym_closedir] = ACTIONS(2692),
    [anon_sym_caller] = ACTIONS(2692),
    [anon_sym_chomp] = ACTIONS(2692),
    [anon_sym_chr] = ACTIONS(2692),
    [anon_sym_cos] = ACTIONS(2692),
    [anon_sym_chroot] = ACTIONS(2692),
    [anon_sym_defined] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_dbmclose] = ACTIONS(2692),
    [anon_sym_exists] = ACTIONS(2692),
    [anon_sym_exit] = ACTIONS(2692),
    [anon_sym_eof] = ACTIONS(2692),
    [anon_sym_exp] = ACTIONS(2692),
    [anon_sym_each] = ACTIONS(2692),
    [anon_sym_fc] = ACTIONS(2692),
    [anon_sym_fileno] = ACTIONS(2692),
    [anon_sym_gmtime] = ACTIONS(2692),
    [anon_sym_getc] = ACTIONS(2692),
    [anon_sym_getpgrp] = ACTIONS(2692),
    [anon_sym_getprotobyname] = ACTIONS(2692),
    [anon_sym_getpwname] = ACTIONS(2692),
    [anon_sym_getpwuid] = ACTIONS(2692),
    [anon_sym_getpeername] = ACTIONS(2692),
    [anon_sym_getnetbyname] = ACTIONS(2692),
    [anon_sym_getsockname] = ACTIONS(2692),
    [anon_sym_getgrnam] = ACTIONS(2692),
    [anon_sym_getgrgid] = ACTIONS(2692),
    [anon_sym_hex] = ACTIONS(2692),
    [anon_sym_int] = ACTIONS(2692),
    [anon_sym_keys] = ACTIONS(2692),
    [anon_sym_lc] = ACTIONS(2692),
    [anon_sym_lcfirst] = ACTIONS(2692),
    [anon_sym_length] = ACTIONS(2692),
    [anon_sym_localtime] = ACTIONS(2692),
    [anon_sym_log] = ACTIONS(2692),
    [anon_sym_lock] = ACTIONS(2692),
    [anon_sym_lstat] = ACTIONS(2692),
    [anon_sym_oct] = ACTIONS(2692),
    [anon_sym_ord] = ACTIONS(2692),
    [anon_sym_prototype] = ACTIONS(2692),
    [anon_sym_pop] = ACTIONS(2692),
    [anon_sym_pos] = ACTIONS(2692),
    [anon_sym_quotemeta] = ACTIONS(2692),
    [anon_sym_reset] = ACTIONS(2692),
    [anon_sym_rand] = ACTIONS(2692),
    [anon_sym_rmdir] = ACTIONS(2692),
    [anon_sym_readdir] = ACTIONS(2692),
    [anon_sym_readline] = ACTIONS(2692),
    [anon_sym_readpipe] = ACTIONS(2692),
    [anon_sym_rewinddir] = ACTIONS(2692),
    [anon_sym_readlink] = ACTIONS(2692),
    [anon_sym_ref] = ACTIONS(2692),
    [anon_sym_scalar] = ACTIONS(2692),
    [anon_sym_shift] = ACTIONS(2692),
    [anon_sym_sin] = ACTIONS(2692),
    [anon_sym_sleep] = ACTIONS(2692),
    [anon_sym_sqrt] = ACTIONS(2692),
    [anon_sym_srand] = ACTIONS(2692),
    [anon_sym_stat] = ACTIONS(2692),
    [anon_sym_study] = ACTIONS(2692),
    [anon_sym_tell] = ACTIONS(2692),
    [anon_sym_telldir] = ACTIONS(2692),
    [anon_sym_tied] = ACTIONS(2692),
    [anon_sym_uc] = ACTIONS(2692),
    [anon_sym_ucfirst] = ACTIONS(2692),
    [anon_sym_untie] = ACTIONS(2692),
    [anon_sym_umask] = ACTIONS(2692),
    [anon_sym_values] = ACTIONS(2692),
    [anon_sym_write] = ACTIONS(2692),
    [aux_sym__func1op_token1] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2664),
    [anon_sym___END__] = ACTIONS(2664),
    [anon_sym_q] = ACTIONS(2696),
    [anon_sym_qq] = ACTIONS(2698),
    [anon_sym_qw] = ACTIONS(2700),
    [anon_sym_qx] = ACTIONS(2702),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(2704),
    [anon_sym_tr] = ACTIONS(2706),
    [anon_sym_y] = ACTIONS(2706),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_unless] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_until] = ACTIONS(2664),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2708),
    [aux_sym__bareword_token1] = ACTIONS(2710),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [577] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(577),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [578] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1624),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(578),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2746),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2540),
    [anon_sym_method] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2748),
    [anon_sym_state] = ACTIONS(2748),
    [anon_sym_our] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2750),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2752),
    [anon_sym_field] = ACTIONS(2748),
    [anon_sym_local] = ACTIONS(2754),
    [anon_sym_require] = ACTIONS(2756),
    [anon_sym_map] = ACTIONS(2758),
    [anon_sym_grep] = ACTIONS(2758),
    [anon_sym_sort] = ACTIONS(2760),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2764),
    [anon_sym_next] = ACTIONS(2764),
    [anon_sym_redo] = ACTIONS(2764),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2766),
    [anon_sym_alarm] = ACTIONS(2766),
    [anon_sym_chop] = ACTIONS(2766),
    [anon_sym_chdir] = ACTIONS(2766),
    [anon_sym_close] = ACTIONS(2766),
    [anon_sym_closedir] = ACTIONS(2766),
    [anon_sym_caller] = ACTIONS(2766),
    [anon_sym_chomp] = ACTIONS(2766),
    [anon_sym_chr] = ACTIONS(2766),
    [anon_sym_cos] = ACTIONS(2766),
    [anon_sym_chroot] = ACTIONS(2766),
    [anon_sym_defined] = ACTIONS(2766),
    [anon_sym_delete] = ACTIONS(2766),
    [anon_sym_dbmclose] = ACTIONS(2766),
    [anon_sym_exists] = ACTIONS(2766),
    [anon_sym_exit] = ACTIONS(2766),
    [anon_sym_eof] = ACTIONS(2766),
    [anon_sym_exp] = ACTIONS(2766),
    [anon_sym_each] = ACTIONS(2766),
    [anon_sym_fc] = ACTIONS(2766),
    [anon_sym_fileno] = ACTIONS(2766),
    [anon_sym_gmtime] = ACTIONS(2766),
    [anon_sym_getc] = ACTIONS(2766),
    [anon_sym_getpgrp] = ACTIONS(2766),
    [anon_sym_getprotobyname] = ACTIONS(2766),
    [anon_sym_getpwname] = ACTIONS(2766),
    [anon_sym_getpwuid] = ACTIONS(2766),
    [anon_sym_getpeername] = ACTIONS(2766),
    [anon_sym_getnetbyname] = ACTIONS(2766),
    [anon_sym_getsockname] = ACTIONS(2766),
    [anon_sym_getgrnam] = ACTIONS(2766),
    [anon_sym_getgrgid] = ACTIONS(2766),
    [anon_sym_hex] = ACTIONS(2766),
    [anon_sym_int] = ACTIONS(2766),
    [anon_sym_keys] = ACTIONS(2766),
    [anon_sym_lc] = ACTIONS(2766),
    [anon_sym_lcfirst] = ACTIONS(2766),
    [anon_sym_length] = ACTIONS(2766),
    [anon_sym_localtime] = ACTIONS(2766),
    [anon_sym_log] = ACTIONS(2766),
    [anon_sym_lock] = ACTIONS(2766),
    [anon_sym_lstat] = ACTIONS(2766),
    [anon_sym_oct] = ACTIONS(2766),
    [anon_sym_ord] = ACTIONS(2766),
    [anon_sym_prototype] = ACTIONS(2766),
    [anon_sym_pop] = ACTIONS(2766),
    [anon_sym_pos] = ACTIONS(2766),
    [anon_sym_quotemeta] = ACTIONS(2766),
    [anon_sym_reset] = ACTIONS(2766),
    [anon_sym_rand] = ACTIONS(2766),
    [anon_sym_rmdir] = ACTIONS(2766),
    [anon_sym_readdir] = ACTIONS(2766),
    [anon_sym_readline] = ACTIONS(2766),
    [anon_sym_readpipe] = ACTIONS(2766),
    [anon_sym_rewinddir] = ACTIONS(2766),
    [anon_sym_readlink] = ACTIONS(2766),
    [anon_sym_ref] = ACTIONS(2766),
    [anon_sym_scalar] = ACTIONS(2766),
    [anon_sym_shift] = ACTIONS(2766),
    [anon_sym_sin] = ACTIONS(2766),
    [anon_sym_sleep] = ACTIONS(2766),
    [anon_sym_sqrt] = ACTIONS(2766),
    [anon_sym_srand] = ACTIONS(2766),
    [anon_sym_stat] = ACTIONS(2766),
    [anon_sym_study] = ACTIONS(2766),
    [anon_sym_tell] = ACTIONS(2766),
    [anon_sym_telldir] = ACTIONS(2766),
    [anon_sym_tied] = ACTIONS(2766),
    [anon_sym_uc] = ACTIONS(2766),
    [anon_sym_ucfirst] = ACTIONS(2766),
    [anon_sym_untie] = ACTIONS(2766),
    [anon_sym_umask] = ACTIONS(2766),
    [anon_sym_values] = ACTIONS(2766),
    [anon_sym_write] = ACTIONS(2766),
    [aux_sym__func1op_token1] = ACTIONS(2768),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2770),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [579] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(579),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2772),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [580] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(580),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [581] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1638),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(581),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [582] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(582),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2776),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [583] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1624),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(583),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2746),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2540),
    [anon_sym_method] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2748),
    [anon_sym_state] = ACTIONS(2748),
    [anon_sym_our] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2750),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2752),
    [anon_sym_field] = ACTIONS(2748),
    [anon_sym_local] = ACTIONS(2754),
    [anon_sym_require] = ACTIONS(2756),
    [anon_sym_map] = ACTIONS(2758),
    [anon_sym_grep] = ACTIONS(2758),
    [anon_sym_sort] = ACTIONS(2760),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2764),
    [anon_sym_next] = ACTIONS(2764),
    [anon_sym_redo] = ACTIONS(2764),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2766),
    [anon_sym_alarm] = ACTIONS(2766),
    [anon_sym_chop] = ACTIONS(2766),
    [anon_sym_chdir] = ACTIONS(2766),
    [anon_sym_close] = ACTIONS(2766),
    [anon_sym_closedir] = ACTIONS(2766),
    [anon_sym_caller] = ACTIONS(2766),
    [anon_sym_chomp] = ACTIONS(2766),
    [anon_sym_chr] = ACTIONS(2766),
    [anon_sym_cos] = ACTIONS(2766),
    [anon_sym_chroot] = ACTIONS(2766),
    [anon_sym_defined] = ACTIONS(2766),
    [anon_sym_delete] = ACTIONS(2766),
    [anon_sym_dbmclose] = ACTIONS(2766),
    [anon_sym_exists] = ACTIONS(2766),
    [anon_sym_exit] = ACTIONS(2766),
    [anon_sym_eof] = ACTIONS(2766),
    [anon_sym_exp] = ACTIONS(2766),
    [anon_sym_each] = ACTIONS(2766),
    [anon_sym_fc] = ACTIONS(2766),
    [anon_sym_fileno] = ACTIONS(2766),
    [anon_sym_gmtime] = ACTIONS(2766),
    [anon_sym_getc] = ACTIONS(2766),
    [anon_sym_getpgrp] = ACTIONS(2766),
    [anon_sym_getprotobyname] = ACTIONS(2766),
    [anon_sym_getpwname] = ACTIONS(2766),
    [anon_sym_getpwuid] = ACTIONS(2766),
    [anon_sym_getpeername] = ACTIONS(2766),
    [anon_sym_getnetbyname] = ACTIONS(2766),
    [anon_sym_getsockname] = ACTIONS(2766),
    [anon_sym_getgrnam] = ACTIONS(2766),
    [anon_sym_getgrgid] = ACTIONS(2766),
    [anon_sym_hex] = ACTIONS(2766),
    [anon_sym_int] = ACTIONS(2766),
    [anon_sym_keys] = ACTIONS(2766),
    [anon_sym_lc] = ACTIONS(2766),
    [anon_sym_lcfirst] = ACTIONS(2766),
    [anon_sym_length] = ACTIONS(2766),
    [anon_sym_localtime] = ACTIONS(2766),
    [anon_sym_log] = ACTIONS(2766),
    [anon_sym_lock] = ACTIONS(2766),
    [anon_sym_lstat] = ACTIONS(2766),
    [anon_sym_oct] = ACTIONS(2766),
    [anon_sym_ord] = ACTIONS(2766),
    [anon_sym_prototype] = ACTIONS(2766),
    [anon_sym_pop] = ACTIONS(2766),
    [anon_sym_pos] = ACTIONS(2766),
    [anon_sym_quotemeta] = ACTIONS(2766),
    [anon_sym_reset] = ACTIONS(2766),
    [anon_sym_rand] = ACTIONS(2766),
    [anon_sym_rmdir] = ACTIONS(2766),
    [anon_sym_readdir] = ACTIONS(2766),
    [anon_sym_readline] = ACTIONS(2766),
    [anon_sym_readpipe] = ACTIONS(2766),
    [anon_sym_rewinddir] = ACTIONS(2766),
    [anon_sym_readlink] = ACTIONS(2766),
    [anon_sym_ref] = ACTIONS(2766),
    [anon_sym_scalar] = ACTIONS(2766),
    [anon_sym_shift] = ACTIONS(2766),
    [anon_sym_sin] = ACTIONS(2766),
    [anon_sym_sleep] = ACTIONS(2766),
    [anon_sym_sqrt] = ACTIONS(2766),
    [anon_sym_srand] = ACTIONS(2766),
    [anon_sym_stat] = ACTIONS(2766),
    [anon_sym_study] = ACTIONS(2766),
    [anon_sym_tell] = ACTIONS(2766),
    [anon_sym_telldir] = ACTIONS(2766),
    [anon_sym_tied] = ACTIONS(2766),
    [anon_sym_uc] = ACTIONS(2766),
    [anon_sym_ucfirst] = ACTIONS(2766),
    [anon_sym_untie] = ACTIONS(2766),
    [anon_sym_umask] = ACTIONS(2766),
    [anon_sym_values] = ACTIONS(2766),
    [anon_sym_write] = ACTIONS(2766),
    [aux_sym__func1op_token1] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2770),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [584] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1945),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(584),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2540),
    [anon_sym_method] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2546),
    [anon_sym_state] = ACTIONS(2546),
    [anon_sym_our] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2782),
    [anon_sym_field] = ACTIONS(2546),
    [anon_sym_local] = ACTIONS(2784),
    [anon_sym_require] = ACTIONS(2786),
    [anon_sym_map] = ACTIONS(2788),
    [anon_sym_grep] = ACTIONS(2788),
    [anon_sym_sort] = ACTIONS(2790),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2794),
    [anon_sym_next] = ACTIONS(2794),
    [anon_sym_redo] = ACTIONS(2794),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2796),
    [anon_sym_alarm] = ACTIONS(2796),
    [anon_sym_chop] = ACTIONS(2796),
    [anon_sym_chdir] = ACTIONS(2796),
    [anon_sym_close] = ACTIONS(2796),
    [anon_sym_closedir] = ACTIONS(2796),
    [anon_sym_caller] = ACTIONS(2796),
    [anon_sym_chomp] = ACTIONS(2796),
    [anon_sym_chr] = ACTIONS(2796),
    [anon_sym_cos] = ACTIONS(2796),
    [anon_sym_chroot] = ACTIONS(2796),
    [anon_sym_defined] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_dbmclose] = ACTIONS(2796),
    [anon_sym_exists] = ACTIONS(2796),
    [anon_sym_exit] = ACTIONS(2796),
    [anon_sym_eof] = ACTIONS(2796),
    [anon_sym_exp] = ACTIONS(2796),
    [anon_sym_each] = ACTIONS(2796),
    [anon_sym_fc] = ACTIONS(2796),
    [anon_sym_fileno] = ACTIONS(2796),
    [anon_sym_gmtime] = ACTIONS(2796),
    [anon_sym_getc] = ACTIONS(2796),
    [anon_sym_getpgrp] = ACTIONS(2796),
    [anon_sym_getprotobyname] = ACTIONS(2796),
    [anon_sym_getpwname] = ACTIONS(2796),
    [anon_sym_getpwuid] = ACTIONS(2796),
    [anon_sym_getpeername] = ACTIONS(2796),
    [anon_sym_getnetbyname] = ACTIONS(2796),
    [anon_sym_getsockname] = ACTIONS(2796),
    [anon_sym_getgrnam] = ACTIONS(2796),
    [anon_sym_getgrgid] = ACTIONS(2796),
    [anon_sym_hex] = ACTIONS(2796),
    [anon_sym_int] = ACTIONS(2796),
    [anon_sym_keys] = ACTIONS(2796),
    [anon_sym_lc] = ACTIONS(2796),
    [anon_sym_lcfirst] = ACTIONS(2796),
    [anon_sym_length] = ACTIONS(2796),
    [anon_sym_localtime] = ACTIONS(2796),
    [anon_sym_log] = ACTIONS(2796),
    [anon_sym_lock] = ACTIONS(2796),
    [anon_sym_lstat] = ACTIONS(2796),
    [anon_sym_oct] = ACTIONS(2796),
    [anon_sym_ord] = ACTIONS(2796),
    [anon_sym_prototype] = ACTIONS(2796),
    [anon_sym_pop] = ACTIONS(2796),
    [anon_sym_pos] = ACTIONS(2796),
    [anon_sym_quotemeta] = ACTIONS(2796),
    [anon_sym_reset] = ACTIONS(2796),
    [anon_sym_rand] = ACTIONS(2796),
    [anon_sym_rmdir] = ACTIONS(2796),
    [anon_sym_readdir] = ACTIONS(2796),
    [anon_sym_readline] = ACTIONS(2796),
    [anon_sym_readpipe] = ACTIONS(2796),
    [anon_sym_rewinddir] = ACTIONS(2796),
    [anon_sym_readlink] = ACTIONS(2796),
    [anon_sym_ref] = ACTIONS(2796),
    [anon_sym_scalar] = ACTIONS(2796),
    [anon_sym_shift] = ACTIONS(2796),
    [anon_sym_sin] = ACTIONS(2796),
    [anon_sym_sleep] = ACTIONS(2796),
    [anon_sym_sqrt] = ACTIONS(2796),
    [anon_sym_srand] = ACTIONS(2796),
    [anon_sym_stat] = ACTIONS(2796),
    [anon_sym_study] = ACTIONS(2796),
    [anon_sym_tell] = ACTIONS(2796),
    [anon_sym_telldir] = ACTIONS(2796),
    [anon_sym_tied] = ACTIONS(2796),
    [anon_sym_uc] = ACTIONS(2796),
    [anon_sym_ucfirst] = ACTIONS(2796),
    [anon_sym_untie] = ACTIONS(2796),
    [anon_sym_umask] = ACTIONS(2796),
    [anon_sym_values] = ACTIONS(2796),
    [anon_sym_write] = ACTIONS(2796),
    [aux_sym__func1op_token1] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2584),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [585] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1909),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(585),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2586),
    [anon_sym_method] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2590),
    [anon_sym_state] = ACTIONS(2590),
    [anon_sym_our] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2802),
    [anon_sym_field] = ACTIONS(2590),
    [anon_sym_local] = ACTIONS(2804),
    [anon_sym_require] = ACTIONS(2806),
    [anon_sym_map] = ACTIONS(2808),
    [anon_sym_grep] = ACTIONS(2808),
    [anon_sym_sort] = ACTIONS(2810),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2814),
    [anon_sym_next] = ACTIONS(2814),
    [anon_sym_redo] = ACTIONS(2814),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2816),
    [anon_sym_alarm] = ACTIONS(2816),
    [anon_sym_chop] = ACTIONS(2816),
    [anon_sym_chdir] = ACTIONS(2816),
    [anon_sym_close] = ACTIONS(2816),
    [anon_sym_closedir] = ACTIONS(2816),
    [anon_sym_caller] = ACTIONS(2816),
    [anon_sym_chomp] = ACTIONS(2816),
    [anon_sym_chr] = ACTIONS(2816),
    [anon_sym_cos] = ACTIONS(2816),
    [anon_sym_chroot] = ACTIONS(2816),
    [anon_sym_defined] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_dbmclose] = ACTIONS(2816),
    [anon_sym_exists] = ACTIONS(2816),
    [anon_sym_exit] = ACTIONS(2816),
    [anon_sym_eof] = ACTIONS(2816),
    [anon_sym_exp] = ACTIONS(2816),
    [anon_sym_each] = ACTIONS(2816),
    [anon_sym_fc] = ACTIONS(2816),
    [anon_sym_fileno] = ACTIONS(2816),
    [anon_sym_gmtime] = ACTIONS(2816),
    [anon_sym_getc] = ACTIONS(2816),
    [anon_sym_getpgrp] = ACTIONS(2816),
    [anon_sym_getprotobyname] = ACTIONS(2816),
    [anon_sym_getpwname] = ACTIONS(2816),
    [anon_sym_getpwuid] = ACTIONS(2816),
    [anon_sym_getpeername] = ACTIONS(2816),
    [anon_sym_getnetbyname] = ACTIONS(2816),
    [anon_sym_getsockname] = ACTIONS(2816),
    [anon_sym_getgrnam] = ACTIONS(2816),
    [anon_sym_getgrgid] = ACTIONS(2816),
    [anon_sym_hex] = ACTIONS(2816),
    [anon_sym_int] = ACTIONS(2816),
    [anon_sym_keys] = ACTIONS(2816),
    [anon_sym_lc] = ACTIONS(2816),
    [anon_sym_lcfirst] = ACTIONS(2816),
    [anon_sym_length] = ACTIONS(2816),
    [anon_sym_localtime] = ACTIONS(2816),
    [anon_sym_log] = ACTIONS(2816),
    [anon_sym_lock] = ACTIONS(2816),
    [anon_sym_lstat] = ACTIONS(2816),
    [anon_sym_oct] = ACTIONS(2816),
    [anon_sym_ord] = ACTIONS(2816),
    [anon_sym_prototype] = ACTIONS(2816),
    [anon_sym_pop] = ACTIONS(2816),
    [anon_sym_pos] = ACTIONS(2816),
    [anon_sym_quotemeta] = ACTIONS(2816),
    [anon_sym_reset] = ACTIONS(2816),
    [anon_sym_rand] = ACTIONS(2816),
    [anon_sym_rmdir] = ACTIONS(2816),
    [anon_sym_readdir] = ACTIONS(2816),
    [anon_sym_readline] = ACTIONS(2816),
    [anon_sym_readpipe] = ACTIONS(2816),
    [anon_sym_rewinddir] = ACTIONS(2816),
    [anon_sym_readlink] = ACTIONS(2816),
    [anon_sym_ref] = ACTIONS(2816),
    [anon_sym_scalar] = ACTIONS(2816),
    [anon_sym_shift] = ACTIONS(2816),
    [anon_sym_sin] = ACTIONS(2816),
    [anon_sym_sleep] = ACTIONS(2816),
    [anon_sym_sqrt] = ACTIONS(2816),
    [anon_sym_srand] = ACTIONS(2816),
    [anon_sym_stat] = ACTIONS(2816),
    [anon_sym_study] = ACTIONS(2816),
    [anon_sym_tell] = ACTIONS(2816),
    [anon_sym_telldir] = ACTIONS(2816),
    [anon_sym_tied] = ACTIONS(2816),
    [anon_sym_uc] = ACTIONS(2816),
    [anon_sym_ucfirst] = ACTIONS(2816),
    [anon_sym_untie] = ACTIONS(2816),
    [anon_sym_umask] = ACTIONS(2816),
    [anon_sym_values] = ACTIONS(2816),
    [anon_sym_write] = ACTIONS(2816),
    [aux_sym__func1op_token1] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2584),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [586] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1946),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1545),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(586),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [587] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(587),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [588] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1624),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(588),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2746),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2540),
    [anon_sym_method] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2748),
    [anon_sym_state] = ACTIONS(2748),
    [anon_sym_our] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2750),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2752),
    [anon_sym_field] = ACTIONS(2748),
    [anon_sym_local] = ACTIONS(2754),
    [anon_sym_require] = ACTIONS(2756),
    [anon_sym_map] = ACTIONS(2758),
    [anon_sym_grep] = ACTIONS(2758),
    [anon_sym_sort] = ACTIONS(2760),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2764),
    [anon_sym_next] = ACTIONS(2764),
    [anon_sym_redo] = ACTIONS(2764),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2766),
    [anon_sym_alarm] = ACTIONS(2766),
    [anon_sym_chop] = ACTIONS(2766),
    [anon_sym_chdir] = ACTIONS(2766),
    [anon_sym_close] = ACTIONS(2766),
    [anon_sym_closedir] = ACTIONS(2766),
    [anon_sym_caller] = ACTIONS(2766),
    [anon_sym_chomp] = ACTIONS(2766),
    [anon_sym_chr] = ACTIONS(2766),
    [anon_sym_cos] = ACTIONS(2766),
    [anon_sym_chroot] = ACTIONS(2766),
    [anon_sym_defined] = ACTIONS(2766),
    [anon_sym_delete] = ACTIONS(2766),
    [anon_sym_dbmclose] = ACTIONS(2766),
    [anon_sym_exists] = ACTIONS(2766),
    [anon_sym_exit] = ACTIONS(2766),
    [anon_sym_eof] = ACTIONS(2766),
    [anon_sym_exp] = ACTIONS(2766),
    [anon_sym_each] = ACTIONS(2766),
    [anon_sym_fc] = ACTIONS(2766),
    [anon_sym_fileno] = ACTIONS(2766),
    [anon_sym_gmtime] = ACTIONS(2766),
    [anon_sym_getc] = ACTIONS(2766),
    [anon_sym_getpgrp] = ACTIONS(2766),
    [anon_sym_getprotobyname] = ACTIONS(2766),
    [anon_sym_getpwname] = ACTIONS(2766),
    [anon_sym_getpwuid] = ACTIONS(2766),
    [anon_sym_getpeername] = ACTIONS(2766),
    [anon_sym_getnetbyname] = ACTIONS(2766),
    [anon_sym_getsockname] = ACTIONS(2766),
    [anon_sym_getgrnam] = ACTIONS(2766),
    [anon_sym_getgrgid] = ACTIONS(2766),
    [anon_sym_hex] = ACTIONS(2766),
    [anon_sym_int] = ACTIONS(2766),
    [anon_sym_keys] = ACTIONS(2766),
    [anon_sym_lc] = ACTIONS(2766),
    [anon_sym_lcfirst] = ACTIONS(2766),
    [anon_sym_length] = ACTIONS(2766),
    [anon_sym_localtime] = ACTIONS(2766),
    [anon_sym_log] = ACTIONS(2766),
    [anon_sym_lock] = ACTIONS(2766),
    [anon_sym_lstat] = ACTIONS(2766),
    [anon_sym_oct] = ACTIONS(2766),
    [anon_sym_ord] = ACTIONS(2766),
    [anon_sym_prototype] = ACTIONS(2766),
    [anon_sym_pop] = ACTIONS(2766),
    [anon_sym_pos] = ACTIONS(2766),
    [anon_sym_quotemeta] = ACTIONS(2766),
    [anon_sym_reset] = ACTIONS(2766),
    [anon_sym_rand] = ACTIONS(2766),
    [anon_sym_rmdir] = ACTIONS(2766),
    [anon_sym_readdir] = ACTIONS(2766),
    [anon_sym_readline] = ACTIONS(2766),
    [anon_sym_readpipe] = ACTIONS(2766),
    [anon_sym_rewinddir] = ACTIONS(2766),
    [anon_sym_readlink] = ACTIONS(2766),
    [anon_sym_ref] = ACTIONS(2766),
    [anon_sym_scalar] = ACTIONS(2766),
    [anon_sym_shift] = ACTIONS(2766),
    [anon_sym_sin] = ACTIONS(2766),
    [anon_sym_sleep] = ACTIONS(2766),
    [anon_sym_sqrt] = ACTIONS(2766),
    [anon_sym_srand] = ACTIONS(2766),
    [anon_sym_stat] = ACTIONS(2766),
    [anon_sym_study] = ACTIONS(2766),
    [anon_sym_tell] = ACTIONS(2766),
    [anon_sym_telldir] = ACTIONS(2766),
    [anon_sym_tied] = ACTIONS(2766),
    [anon_sym_uc] = ACTIONS(2766),
    [anon_sym_ucfirst] = ACTIONS(2766),
    [anon_sym_untie] = ACTIONS(2766),
    [anon_sym_umask] = ACTIONS(2766),
    [anon_sym_values] = ACTIONS(2766),
    [anon_sym_write] = ACTIONS(2766),
    [aux_sym__func1op_token1] = ACTIONS(2820),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2770),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [589] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1431),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(589),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2716),
    [anon_sym_state] = ACTIONS(2716),
    [anon_sym_our] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2718),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2720),
    [anon_sym_field] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2722),
    [anon_sym_require] = ACTIONS(2724),
    [anon_sym_map] = ACTIONS(2726),
    [anon_sym_grep] = ACTIONS(2726),
    [anon_sym_sort] = ACTIONS(2728),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(2730),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2732),
    [anon_sym_next] = ACTIONS(2732),
    [anon_sym_redo] = ACTIONS(2732),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2734),
    [anon_sym_alarm] = ACTIONS(2734),
    [anon_sym_chop] = ACTIONS(2734),
    [anon_sym_chdir] = ACTIONS(2734),
    [anon_sym_close] = ACTIONS(2734),
    [anon_sym_closedir] = ACTIONS(2734),
    [anon_sym_caller] = ACTIONS(2734),
    [anon_sym_chomp] = ACTIONS(2734),
    [anon_sym_chr] = ACTIONS(2734),
    [anon_sym_cos] = ACTIONS(2734),
    [anon_sym_chroot] = ACTIONS(2734),
    [anon_sym_defined] = ACTIONS(2734),
    [anon_sym_delete] = ACTIONS(2734),
    [anon_sym_dbmclose] = ACTIONS(2734),
    [anon_sym_exists] = ACTIONS(2734),
    [anon_sym_exit] = ACTIONS(2734),
    [anon_sym_eof] = ACTIONS(2734),
    [anon_sym_exp] = ACTIONS(2734),
    [anon_sym_each] = ACTIONS(2734),
    [anon_sym_fc] = ACTIONS(2734),
    [anon_sym_fileno] = ACTIONS(2734),
    [anon_sym_gmtime] = ACTIONS(2734),
    [anon_sym_getc] = ACTIONS(2734),
    [anon_sym_getpgrp] = ACTIONS(2734),
    [anon_sym_getprotobyname] = ACTIONS(2734),
    [anon_sym_getpwname] = ACTIONS(2734),
    [anon_sym_getpwuid] = ACTIONS(2734),
    [anon_sym_getpeername] = ACTIONS(2734),
    [anon_sym_getnetbyname] = ACTIONS(2734),
    [anon_sym_getsockname] = ACTIONS(2734),
    [anon_sym_getgrnam] = ACTIONS(2734),
    [anon_sym_getgrgid] = ACTIONS(2734),
    [anon_sym_hex] = ACTIONS(2734),
    [anon_sym_int] = ACTIONS(2734),
    [anon_sym_keys] = ACTIONS(2734),
    [anon_sym_lc] = ACTIONS(2734),
    [anon_sym_lcfirst] = ACTIONS(2734),
    [anon_sym_length] = ACTIONS(2734),
    [anon_sym_localtime] = ACTIONS(2734),
    [anon_sym_log] = ACTIONS(2734),
    [anon_sym_lock] = ACTIONS(2734),
    [anon_sym_lstat] = ACTIONS(2734),
    [anon_sym_oct] = ACTIONS(2734),
    [anon_sym_ord] = ACTIONS(2734),
    [anon_sym_prototype] = ACTIONS(2734),
    [anon_sym_pop] = ACTIONS(2734),
    [anon_sym_pos] = ACTIONS(2734),
    [anon_sym_quotemeta] = ACTIONS(2734),
    [anon_sym_reset] = ACTIONS(2734),
    [anon_sym_rand] = ACTIONS(2734),
    [anon_sym_rmdir] = ACTIONS(2734),
    [anon_sym_readdir] = ACTIONS(2734),
    [anon_sym_readline] = ACTIONS(2734),
    [anon_sym_readpipe] = ACTIONS(2734),
    [anon_sym_rewinddir] = ACTIONS(2734),
    [anon_sym_readlink] = ACTIONS(2734),
    [anon_sym_ref] = ACTIONS(2734),
    [anon_sym_scalar] = ACTIONS(2734),
    [anon_sym_shift] = ACTIONS(2734),
    [anon_sym_sin] = ACTIONS(2734),
    [anon_sym_sleep] = ACTIONS(2734),
    [anon_sym_sqrt] = ACTIONS(2734),
    [anon_sym_srand] = ACTIONS(2734),
    [anon_sym_stat] = ACTIONS(2734),
    [anon_sym_study] = ACTIONS(2734),
    [anon_sym_tell] = ACTIONS(2734),
    [anon_sym_telldir] = ACTIONS(2734),
    [anon_sym_tied] = ACTIONS(2734),
    [anon_sym_uc] = ACTIONS(2734),
    [anon_sym_ucfirst] = ACTIONS(2734),
    [anon_sym_untie] = ACTIONS(2734),
    [anon_sym_umask] = ACTIONS(2734),
    [anon_sym_values] = ACTIONS(2734),
    [anon_sym_write] = ACTIONS(2734),
    [aux_sym__func1op_token1] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2738),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [590] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(590),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2824),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [591] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1945),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(591),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2540),
    [anon_sym_method] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2546),
    [anon_sym_state] = ACTIONS(2546),
    [anon_sym_our] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2782),
    [anon_sym_field] = ACTIONS(2546),
    [anon_sym_local] = ACTIONS(2784),
    [anon_sym_require] = ACTIONS(2786),
    [anon_sym_map] = ACTIONS(2788),
    [anon_sym_grep] = ACTIONS(2788),
    [anon_sym_sort] = ACTIONS(2790),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2794),
    [anon_sym_next] = ACTIONS(2794),
    [anon_sym_redo] = ACTIONS(2794),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2796),
    [anon_sym_alarm] = ACTIONS(2796),
    [anon_sym_chop] = ACTIONS(2796),
    [anon_sym_chdir] = ACTIONS(2796),
    [anon_sym_close] = ACTIONS(2796),
    [anon_sym_closedir] = ACTIONS(2796),
    [anon_sym_caller] = ACTIONS(2796),
    [anon_sym_chomp] = ACTIONS(2796),
    [anon_sym_chr] = ACTIONS(2796),
    [anon_sym_cos] = ACTIONS(2796),
    [anon_sym_chroot] = ACTIONS(2796),
    [anon_sym_defined] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_dbmclose] = ACTIONS(2796),
    [anon_sym_exists] = ACTIONS(2796),
    [anon_sym_exit] = ACTIONS(2796),
    [anon_sym_eof] = ACTIONS(2796),
    [anon_sym_exp] = ACTIONS(2796),
    [anon_sym_each] = ACTIONS(2796),
    [anon_sym_fc] = ACTIONS(2796),
    [anon_sym_fileno] = ACTIONS(2796),
    [anon_sym_gmtime] = ACTIONS(2796),
    [anon_sym_getc] = ACTIONS(2796),
    [anon_sym_getpgrp] = ACTIONS(2796),
    [anon_sym_getprotobyname] = ACTIONS(2796),
    [anon_sym_getpwname] = ACTIONS(2796),
    [anon_sym_getpwuid] = ACTIONS(2796),
    [anon_sym_getpeername] = ACTIONS(2796),
    [anon_sym_getnetbyname] = ACTIONS(2796),
    [anon_sym_getsockname] = ACTIONS(2796),
    [anon_sym_getgrnam] = ACTIONS(2796),
    [anon_sym_getgrgid] = ACTIONS(2796),
    [anon_sym_hex] = ACTIONS(2796),
    [anon_sym_int] = ACTIONS(2796),
    [anon_sym_keys] = ACTIONS(2796),
    [anon_sym_lc] = ACTIONS(2796),
    [anon_sym_lcfirst] = ACTIONS(2796),
    [anon_sym_length] = ACTIONS(2796),
    [anon_sym_localtime] = ACTIONS(2796),
    [anon_sym_log] = ACTIONS(2796),
    [anon_sym_lock] = ACTIONS(2796),
    [anon_sym_lstat] = ACTIONS(2796),
    [anon_sym_oct] = ACTIONS(2796),
    [anon_sym_ord] = ACTIONS(2796),
    [anon_sym_prototype] = ACTIONS(2796),
    [anon_sym_pop] = ACTIONS(2796),
    [anon_sym_pos] = ACTIONS(2796),
    [anon_sym_quotemeta] = ACTIONS(2796),
    [anon_sym_reset] = ACTIONS(2796),
    [anon_sym_rand] = ACTIONS(2796),
    [anon_sym_rmdir] = ACTIONS(2796),
    [anon_sym_readdir] = ACTIONS(2796),
    [anon_sym_readline] = ACTIONS(2796),
    [anon_sym_readpipe] = ACTIONS(2796),
    [anon_sym_rewinddir] = ACTIONS(2796),
    [anon_sym_readlink] = ACTIONS(2796),
    [anon_sym_ref] = ACTIONS(2796),
    [anon_sym_scalar] = ACTIONS(2796),
    [anon_sym_shift] = ACTIONS(2796),
    [anon_sym_sin] = ACTIONS(2796),
    [anon_sym_sleep] = ACTIONS(2796),
    [anon_sym_sqrt] = ACTIONS(2796),
    [anon_sym_srand] = ACTIONS(2796),
    [anon_sym_stat] = ACTIONS(2796),
    [anon_sym_study] = ACTIONS(2796),
    [anon_sym_tell] = ACTIONS(2796),
    [anon_sym_telldir] = ACTIONS(2796),
    [anon_sym_tied] = ACTIONS(2796),
    [anon_sym_uc] = ACTIONS(2796),
    [anon_sym_ucfirst] = ACTIONS(2796),
    [anon_sym_untie] = ACTIONS(2796),
    [anon_sym_umask] = ACTIONS(2796),
    [anon_sym_values] = ACTIONS(2796),
    [anon_sym_write] = ACTIONS(2796),
    [aux_sym__func1op_token1] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2584),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [592] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(592),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [593] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1356),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym__label_arg] = STATE(1357),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(593),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_identifier] = STATE(1358),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [594] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1901),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1545),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(594),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [595] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(595),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [596] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(596),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2828),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [597] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(597),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [598] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(598),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2832),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [599] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(599),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [600] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(600),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [601] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1909),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(601),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2586),
    [anon_sym_method] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2590),
    [anon_sym_state] = ACTIONS(2590),
    [anon_sym_our] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2802),
    [anon_sym_field] = ACTIONS(2590),
    [anon_sym_local] = ACTIONS(2804),
    [anon_sym_require] = ACTIONS(2806),
    [anon_sym_map] = ACTIONS(2808),
    [anon_sym_grep] = ACTIONS(2808),
    [anon_sym_sort] = ACTIONS(2810),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2814),
    [anon_sym_next] = ACTIONS(2814),
    [anon_sym_redo] = ACTIONS(2814),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2816),
    [anon_sym_alarm] = ACTIONS(2816),
    [anon_sym_chop] = ACTIONS(2816),
    [anon_sym_chdir] = ACTIONS(2816),
    [anon_sym_close] = ACTIONS(2816),
    [anon_sym_closedir] = ACTIONS(2816),
    [anon_sym_caller] = ACTIONS(2816),
    [anon_sym_chomp] = ACTIONS(2816),
    [anon_sym_chr] = ACTIONS(2816),
    [anon_sym_cos] = ACTIONS(2816),
    [anon_sym_chroot] = ACTIONS(2816),
    [anon_sym_defined] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_dbmclose] = ACTIONS(2816),
    [anon_sym_exists] = ACTIONS(2816),
    [anon_sym_exit] = ACTIONS(2816),
    [anon_sym_eof] = ACTIONS(2816),
    [anon_sym_exp] = ACTIONS(2816),
    [anon_sym_each] = ACTIONS(2816),
    [anon_sym_fc] = ACTIONS(2816),
    [anon_sym_fileno] = ACTIONS(2816),
    [anon_sym_gmtime] = ACTIONS(2816),
    [anon_sym_getc] = ACTIONS(2816),
    [anon_sym_getpgrp] = ACTIONS(2816),
    [anon_sym_getprotobyname] = ACTIONS(2816),
    [anon_sym_getpwname] = ACTIONS(2816),
    [anon_sym_getpwuid] = ACTIONS(2816),
    [anon_sym_getpeername] = ACTIONS(2816),
    [anon_sym_getnetbyname] = ACTIONS(2816),
    [anon_sym_getsockname] = ACTIONS(2816),
    [anon_sym_getgrnam] = ACTIONS(2816),
    [anon_sym_getgrgid] = ACTIONS(2816),
    [anon_sym_hex] = ACTIONS(2816),
    [anon_sym_int] = ACTIONS(2816),
    [anon_sym_keys] = ACTIONS(2816),
    [anon_sym_lc] = ACTIONS(2816),
    [anon_sym_lcfirst] = ACTIONS(2816),
    [anon_sym_length] = ACTIONS(2816),
    [anon_sym_localtime] = ACTIONS(2816),
    [anon_sym_log] = ACTIONS(2816),
    [anon_sym_lock] = ACTIONS(2816),
    [anon_sym_lstat] = ACTIONS(2816),
    [anon_sym_oct] = ACTIONS(2816),
    [anon_sym_ord] = ACTIONS(2816),
    [anon_sym_prototype] = ACTIONS(2816),
    [anon_sym_pop] = ACTIONS(2816),
    [anon_sym_pos] = ACTIONS(2816),
    [anon_sym_quotemeta] = ACTIONS(2816),
    [anon_sym_reset] = ACTIONS(2816),
    [anon_sym_rand] = ACTIONS(2816),
    [anon_sym_rmdir] = ACTIONS(2816),
    [anon_sym_readdir] = ACTIONS(2816),
    [anon_sym_readline] = ACTIONS(2816),
    [anon_sym_readpipe] = ACTIONS(2816),
    [anon_sym_rewinddir] = ACTIONS(2816),
    [anon_sym_readlink] = ACTIONS(2816),
    [anon_sym_ref] = ACTIONS(2816),
    [anon_sym_scalar] = ACTIONS(2816),
    [anon_sym_shift] = ACTIONS(2816),
    [anon_sym_sin] = ACTIONS(2816),
    [anon_sym_sleep] = ACTIONS(2816),
    [anon_sym_sqrt] = ACTIONS(2816),
    [anon_sym_srand] = ACTIONS(2816),
    [anon_sym_stat] = ACTIONS(2816),
    [anon_sym_study] = ACTIONS(2816),
    [anon_sym_tell] = ACTIONS(2816),
    [anon_sym_telldir] = ACTIONS(2816),
    [anon_sym_tied] = ACTIONS(2816),
    [anon_sym_uc] = ACTIONS(2816),
    [anon_sym_ucfirst] = ACTIONS(2816),
    [anon_sym_untie] = ACTIONS(2816),
    [anon_sym_umask] = ACTIONS(2816),
    [anon_sym_values] = ACTIONS(2816),
    [anon_sym_write] = ACTIONS(2816),
    [aux_sym__func1op_token1] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2584),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [602] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(602),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [603] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1971),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(603),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2586),
    [anon_sym_method] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2590),
    [anon_sym_state] = ACTIONS(2590),
    [anon_sym_our] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2594),
    [anon_sym_field] = ACTIONS(2590),
    [anon_sym_local] = ACTIONS(2596),
    [anon_sym_require] = ACTIONS(2598),
    [anon_sym_map] = ACTIONS(2600),
    [anon_sym_grep] = ACTIONS(2600),
    [anon_sym_sort] = ACTIONS(2602),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2606),
    [anon_sym_next] = ACTIONS(2606),
    [anon_sym_redo] = ACTIONS(2606),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2608),
    [anon_sym_alarm] = ACTIONS(2608),
    [anon_sym_chop] = ACTIONS(2608),
    [anon_sym_chdir] = ACTIONS(2608),
    [anon_sym_close] = ACTIONS(2608),
    [anon_sym_closedir] = ACTIONS(2608),
    [anon_sym_caller] = ACTIONS(2608),
    [anon_sym_chomp] = ACTIONS(2608),
    [anon_sym_chr] = ACTIONS(2608),
    [anon_sym_cos] = ACTIONS(2608),
    [anon_sym_chroot] = ACTIONS(2608),
    [anon_sym_defined] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_dbmclose] = ACTIONS(2608),
    [anon_sym_exists] = ACTIONS(2608),
    [anon_sym_exit] = ACTIONS(2608),
    [anon_sym_eof] = ACTIONS(2608),
    [anon_sym_exp] = ACTIONS(2608),
    [anon_sym_each] = ACTIONS(2608),
    [anon_sym_fc] = ACTIONS(2608),
    [anon_sym_fileno] = ACTIONS(2608),
    [anon_sym_gmtime] = ACTIONS(2608),
    [anon_sym_getc] = ACTIONS(2608),
    [anon_sym_getpgrp] = ACTIONS(2608),
    [anon_sym_getprotobyname] = ACTIONS(2608),
    [anon_sym_getpwname] = ACTIONS(2608),
    [anon_sym_getpwuid] = ACTIONS(2608),
    [anon_sym_getpeername] = ACTIONS(2608),
    [anon_sym_getnetbyname] = ACTIONS(2608),
    [anon_sym_getsockname] = ACTIONS(2608),
    [anon_sym_getgrnam] = ACTIONS(2608),
    [anon_sym_getgrgid] = ACTIONS(2608),
    [anon_sym_hex] = ACTIONS(2608),
    [anon_sym_int] = ACTIONS(2608),
    [anon_sym_keys] = ACTIONS(2608),
    [anon_sym_lc] = ACTIONS(2608),
    [anon_sym_lcfirst] = ACTIONS(2608),
    [anon_sym_length] = ACTIONS(2608),
    [anon_sym_localtime] = ACTIONS(2608),
    [anon_sym_log] = ACTIONS(2608),
    [anon_sym_lock] = ACTIONS(2608),
    [anon_sym_lstat] = ACTIONS(2608),
    [anon_sym_oct] = ACTIONS(2608),
    [anon_sym_ord] = ACTIONS(2608),
    [anon_sym_prototype] = ACTIONS(2608),
    [anon_sym_pop] = ACTIONS(2608),
    [anon_sym_pos] = ACTIONS(2608),
    [anon_sym_quotemeta] = ACTIONS(2608),
    [anon_sym_reset] = ACTIONS(2608),
    [anon_sym_rand] = ACTIONS(2608),
    [anon_sym_rmdir] = ACTIONS(2608),
    [anon_sym_readdir] = ACTIONS(2608),
    [anon_sym_readline] = ACTIONS(2608),
    [anon_sym_readpipe] = ACTIONS(2608),
    [anon_sym_rewinddir] = ACTIONS(2608),
    [anon_sym_readlink] = ACTIONS(2608),
    [anon_sym_ref] = ACTIONS(2608),
    [anon_sym_scalar] = ACTIONS(2608),
    [anon_sym_shift] = ACTIONS(2608),
    [anon_sym_sin] = ACTIONS(2608),
    [anon_sym_sleep] = ACTIONS(2608),
    [anon_sym_sqrt] = ACTIONS(2608),
    [anon_sym_srand] = ACTIONS(2608),
    [anon_sym_stat] = ACTIONS(2608),
    [anon_sym_study] = ACTIONS(2608),
    [anon_sym_tell] = ACTIONS(2608),
    [anon_sym_telldir] = ACTIONS(2608),
    [anon_sym_tied] = ACTIONS(2608),
    [anon_sym_uc] = ACTIONS(2608),
    [anon_sym_ucfirst] = ACTIONS(2608),
    [anon_sym_untie] = ACTIONS(2608),
    [anon_sym_umask] = ACTIONS(2608),
    [anon_sym_values] = ACTIONS(2608),
    [anon_sym_write] = ACTIONS(2608),
    [aux_sym__func1op_token1] = ACTIONS(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2584),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [604] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1635),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1545),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(604),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [605] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(605),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [606] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(606),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [607] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(607),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [608] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1968),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym__label_arg] = STATE(1545),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(608),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_identifier] = STATE(1490),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [609] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(609),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [610] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(610),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [611] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1895),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(611),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_sub] = ACTIONS(2540),
    [anon_sym_method] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_my] = ACTIONS(2546),
    [anon_sym_state] = ACTIONS(2546),
    [anon_sym_our] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_elsif] = ACTIONS(2538),
    [anon_sym_and] = ACTIONS(2538),
    [anon_sym_or] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(2538),
    [anon_sym_ne] = ACTIONS(2538),
    [anon_sym_cmp] = ACTIONS(2538),
    [anon_sym_lt] = ACTIONS(2538),
    [anon_sym_le] = ACTIONS(2538),
    [anon_sym_ge] = ACTIONS(2538),
    [anon_sym_gt] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_eval] = ACTIONS(2552),
    [anon_sym_field] = ACTIONS(2546),
    [anon_sym_local] = ACTIONS(2554),
    [anon_sym_require] = ACTIONS(2556),
    [anon_sym_map] = ACTIONS(2558),
    [anon_sym_grep] = ACTIONS(2558),
    [anon_sym_sort] = ACTIONS(2560),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_no] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_last] = ACTIONS(2564),
    [anon_sym_next] = ACTIONS(2564),
    [anon_sym_redo] = ACTIONS(2564),
    [anon_sym_BEGIN] = ACTIONS(2538),
    [anon_sym_INIT] = ACTIONS(2538),
    [anon_sym_CHECK] = ACTIONS(2538),
    [anon_sym_UNITCHECK] = ACTIONS(2538),
    [anon_sym_END] = ACTIONS(2538),
    [anon_sym_ADJUST] = ACTIONS(2538),
    [anon_sym___FILE__] = ACTIONS(2544),
    [anon_sym___LINE__] = ACTIONS(2544),
    [anon_sym___PACKAGE__] = ACTIONS(2544),
    [anon_sym___SUB__] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_fork] = ACTIONS(2544),
    [anon_sym_getppid] = ACTIONS(2544),
    [anon_sym_time] = ACTIONS(2544),
    [anon_sym_times] = ACTIONS(2544),
    [anon_sym_wait] = ACTIONS(2544),
    [anon_sym_wantarray] = ACTIONS(2544),
    [anon_sym_abs] = ACTIONS(2566),
    [anon_sym_alarm] = ACTIONS(2566),
    [anon_sym_chop] = ACTIONS(2566),
    [anon_sym_chdir] = ACTIONS(2566),
    [anon_sym_close] = ACTIONS(2566),
    [anon_sym_closedir] = ACTIONS(2566),
    [anon_sym_caller] = ACTIONS(2566),
    [anon_sym_chomp] = ACTIONS(2566),
    [anon_sym_chr] = ACTIONS(2566),
    [anon_sym_cos] = ACTIONS(2566),
    [anon_sym_chroot] = ACTIONS(2566),
    [anon_sym_defined] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_dbmclose] = ACTIONS(2566),
    [anon_sym_exists] = ACTIONS(2566),
    [anon_sym_exit] = ACTIONS(2566),
    [anon_sym_eof] = ACTIONS(2566),
    [anon_sym_exp] = ACTIONS(2566),
    [anon_sym_each] = ACTIONS(2566),
    [anon_sym_fc] = ACTIONS(2566),
    [anon_sym_fileno] = ACTIONS(2566),
    [anon_sym_gmtime] = ACTIONS(2566),
    [anon_sym_getc] = ACTIONS(2566),
    [anon_sym_getpgrp] = ACTIONS(2566),
    [anon_sym_getprotobyname] = ACTIONS(2566),
    [anon_sym_getpwname] = ACTIONS(2566),
    [anon_sym_getpwuid] = ACTIONS(2566),
    [anon_sym_getpeername] = ACTIONS(2566),
    [anon_sym_getnetbyname] = ACTIONS(2566),
    [anon_sym_getsockname] = ACTIONS(2566),
    [anon_sym_getgrnam] = ACTIONS(2566),
    [anon_sym_getgrgid] = ACTIONS(2566),
    [anon_sym_hex] = ACTIONS(2566),
    [anon_sym_int] = ACTIONS(2566),
    [anon_sym_keys] = ACTIONS(2566),
    [anon_sym_lc] = ACTIONS(2566),
    [anon_sym_lcfirst] = ACTIONS(2566),
    [anon_sym_length] = ACTIONS(2566),
    [anon_sym_localtime] = ACTIONS(2566),
    [anon_sym_log] = ACTIONS(2566),
    [anon_sym_lock] = ACTIONS(2566),
    [anon_sym_lstat] = ACTIONS(2566),
    [anon_sym_oct] = ACTIONS(2566),
    [anon_sym_ord] = ACTIONS(2566),
    [anon_sym_prototype] = ACTIONS(2566),
    [anon_sym_pop] = ACTIONS(2566),
    [anon_sym_pos] = ACTIONS(2566),
    [anon_sym_quotemeta] = ACTIONS(2566),
    [anon_sym_reset] = ACTIONS(2566),
    [anon_sym_rand] = ACTIONS(2566),
    [anon_sym_rmdir] = ACTIONS(2566),
    [anon_sym_readdir] = ACTIONS(2566),
    [anon_sym_readline] = ACTIONS(2566),
    [anon_sym_readpipe] = ACTIONS(2566),
    [anon_sym_rewinddir] = ACTIONS(2566),
    [anon_sym_readlink] = ACTIONS(2566),
    [anon_sym_ref] = ACTIONS(2566),
    [anon_sym_scalar] = ACTIONS(2566),
    [anon_sym_shift] = ACTIONS(2566),
    [anon_sym_sin] = ACTIONS(2566),
    [anon_sym_sleep] = ACTIONS(2566),
    [anon_sym_sqrt] = ACTIONS(2566),
    [anon_sym_srand] = ACTIONS(2566),
    [anon_sym_stat] = ACTIONS(2566),
    [anon_sym_study] = ACTIONS(2566),
    [anon_sym_tell] = ACTIONS(2566),
    [anon_sym_telldir] = ACTIONS(2566),
    [anon_sym_tied] = ACTIONS(2566),
    [anon_sym_uc] = ACTIONS(2566),
    [anon_sym_ucfirst] = ACTIONS(2566),
    [anon_sym_untie] = ACTIONS(2566),
    [anon_sym_umask] = ACTIONS(2566),
    [anon_sym_values] = ACTIONS(2566),
    [anon_sym_write] = ACTIONS(2566),
    [aux_sym__func1op_token1] = ACTIONS(2848),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2538),
    [anon_sym___END__] = ACTIONS(2538),
    [anon_sym_q] = ACTIONS(2570),
    [anon_sym_qq] = ACTIONS(2572),
    [anon_sym_qw] = ACTIONS(2574),
    [anon_sym_qx] = ACTIONS(2576),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(2578),
    [anon_sym_tr] = ACTIONS(2580),
    [anon_sym_y] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_unless] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_until] = ACTIONS(2538),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2582),
    [aux_sym__bareword_token1] = ACTIONS(2584),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [612] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(612),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_sub] = ACTIONS(2616),
    [anon_sym_method] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_my] = ACTIONS(2622),
    [anon_sym_state] = ACTIONS(2622),
    [anon_sym_our] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_elsif] = ACTIONS(2614),
    [anon_sym_and] = ACTIONS(2614),
    [anon_sym_or] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(2614),
    [anon_sym_ne] = ACTIONS(2614),
    [anon_sym_cmp] = ACTIONS(2614),
    [anon_sym_lt] = ACTIONS(2614),
    [anon_sym_le] = ACTIONS(2614),
    [anon_sym_ge] = ACTIONS(2614),
    [anon_sym_gt] = ACTIONS(2614),
    [anon_sym_isa] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_eval] = ACTIONS(2628),
    [anon_sym_field] = ACTIONS(2622),
    [anon_sym_local] = ACTIONS(2630),
    [anon_sym_require] = ACTIONS(2632),
    [anon_sym_map] = ACTIONS(2634),
    [anon_sym_grep] = ACTIONS(2634),
    [anon_sym_sort] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(2614),
    [anon_sym_no] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_foreach] = ACTIONS(2614),
    [anon_sym_last] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_BEGIN] = ACTIONS(2614),
    [anon_sym_INIT] = ACTIONS(2614),
    [anon_sym_CHECK] = ACTIONS(2614),
    [anon_sym_UNITCHECK] = ACTIONS(2614),
    [anon_sym_END] = ACTIONS(2614),
    [anon_sym_ADJUST] = ACTIONS(2614),
    [anon_sym___FILE__] = ACTIONS(2620),
    [anon_sym___LINE__] = ACTIONS(2620),
    [anon_sym___PACKAGE__] = ACTIONS(2620),
    [anon_sym___SUB__] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_fork] = ACTIONS(2620),
    [anon_sym_getppid] = ACTIONS(2620),
    [anon_sym_time] = ACTIONS(2620),
    [anon_sym_times] = ACTIONS(2620),
    [anon_sym_wait] = ACTIONS(2620),
    [anon_sym_wantarray] = ACTIONS(2620),
    [anon_sym_abs] = ACTIONS(2642),
    [anon_sym_alarm] = ACTIONS(2642),
    [anon_sym_chop] = ACTIONS(2642),
    [anon_sym_chdir] = ACTIONS(2642),
    [anon_sym_close] = ACTIONS(2642),
    [anon_sym_closedir] = ACTIONS(2642),
    [anon_sym_caller] = ACTIONS(2642),
    [anon_sym_chomp] = ACTIONS(2642),
    [anon_sym_chr] = ACTIONS(2642),
    [anon_sym_cos] = ACTIONS(2642),
    [anon_sym_chroot] = ACTIONS(2642),
    [anon_sym_defined] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_dbmclose] = ACTIONS(2642),
    [anon_sym_exists] = ACTIONS(2642),
    [anon_sym_exit] = ACTIONS(2642),
    [anon_sym_eof] = ACTIONS(2642),
    [anon_sym_exp] = ACTIONS(2642),
    [anon_sym_each] = ACTIONS(2642),
    [anon_sym_fc] = ACTIONS(2642),
    [anon_sym_fileno] = ACTIONS(2642),
    [anon_sym_gmtime] = ACTIONS(2642),
    [anon_sym_getc] = ACTIONS(2642),
    [anon_sym_getpgrp] = ACTIONS(2642),
    [anon_sym_getprotobyname] = ACTIONS(2642),
    [anon_sym_getpwname] = ACTIONS(2642),
    [anon_sym_getpwuid] = ACTIONS(2642),
    [anon_sym_getpeername] = ACTIONS(2642),
    [anon_sym_getnetbyname] = ACTIONS(2642),
    [anon_sym_getsockname] = ACTIONS(2642),
    [anon_sym_getgrnam] = ACTIONS(2642),
    [anon_sym_getgrgid] = ACTIONS(2642),
    [anon_sym_hex] = ACTIONS(2642),
    [anon_sym_int] = ACTIONS(2642),
    [anon_sym_keys] = ACTIONS(2642),
    [anon_sym_lc] = ACTIONS(2642),
    [anon_sym_lcfirst] = ACTIONS(2642),
    [anon_sym_length] = ACTIONS(2642),
    [anon_sym_localtime] = ACTIONS(2642),
    [anon_sym_log] = ACTIONS(2642),
    [anon_sym_lock] = ACTIONS(2642),
    [anon_sym_lstat] = ACTIONS(2642),
    [anon_sym_oct] = ACTIONS(2642),
    [anon_sym_ord] = ACTIONS(2642),
    [anon_sym_prototype] = ACTIONS(2642),
    [anon_sym_pop] = ACTIONS(2642),
    [anon_sym_pos] = ACTIONS(2642),
    [anon_sym_quotemeta] = ACTIONS(2642),
    [anon_sym_reset] = ACTIONS(2642),
    [anon_sym_rand] = ACTIONS(2642),
    [anon_sym_rmdir] = ACTIONS(2642),
    [anon_sym_readdir] = ACTIONS(2642),
    [anon_sym_readline] = ACTIONS(2642),
    [anon_sym_readpipe] = ACTIONS(2642),
    [anon_sym_rewinddir] = ACTIONS(2642),
    [anon_sym_readlink] = ACTIONS(2642),
    [anon_sym_ref] = ACTIONS(2642),
    [anon_sym_scalar] = ACTIONS(2642),
    [anon_sym_shift] = ACTIONS(2642),
    [anon_sym_sin] = ACTIONS(2642),
    [anon_sym_sleep] = ACTIONS(2642),
    [anon_sym_sqrt] = ACTIONS(2642),
    [anon_sym_srand] = ACTIONS(2642),
    [anon_sym_stat] = ACTIONS(2642),
    [anon_sym_study] = ACTIONS(2642),
    [anon_sym_tell] = ACTIONS(2642),
    [anon_sym_telldir] = ACTIONS(2642),
    [anon_sym_tied] = ACTIONS(2642),
    [anon_sym_uc] = ACTIONS(2642),
    [anon_sym_ucfirst] = ACTIONS(2642),
    [anon_sym_untie] = ACTIONS(2642),
    [anon_sym_umask] = ACTIONS(2642),
    [anon_sym_values] = ACTIONS(2642),
    [anon_sym_write] = ACTIONS(2642),
    [aux_sym__func1op_token1] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2614),
    [anon_sym___END__] = ACTIONS(2614),
    [anon_sym_q] = ACTIONS(2646),
    [anon_sym_qq] = ACTIONS(2648),
    [anon_sym_qw] = ACTIONS(2650),
    [anon_sym_qx] = ACTIONS(2652),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(2654),
    [anon_sym_tr] = ACTIONS(2656),
    [anon_sym_y] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_unless] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_until] = ACTIONS(2614),
    [aux_sym_autoquoted_bareword_token1] = ACTIONS(2658),
    [aux_sym__bareword_token1] = ACTIONS(2660),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [613] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(613),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [614] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(614),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [615] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1927),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(615),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [616] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3207),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(616),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [617] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1544),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(617),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [618] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1434),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(618),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [619] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1532),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(619),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [620] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1916),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(620),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [621] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1314),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(621),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [622] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1544),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(622),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [623] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1525),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(623),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [624] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1523),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(624),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [625] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1489),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1524),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(625),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [626] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1607),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(626),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2852),
  },
  [627] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1602),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(627),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2854),
  },
  [628] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1634),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(628),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2856),
  },
  [629] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1891),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(629),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [630] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1904),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(630),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [631] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1311),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(631),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [632] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1308),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(632),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [633] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1270),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(633),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2858),
  },
  [634] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1271),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(634),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2860),
  },
  [635] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1523),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(635),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [636] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1525),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(636),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [637] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1532),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(637),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [638] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1544),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(638),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [639] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1489),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1725),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(639),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [640] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1867),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(640),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2852),
  },
  [641] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1894),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(641),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2854),
  },
  [642] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1638),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(642),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [643] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1875),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(643),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2856),
  },
  [644] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1834),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(644),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [645] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1272),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(645),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [646] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3215),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(646),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [647] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3188),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(647),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [648] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1890),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(648),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2856),
  },
  [649] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1886),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(649),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2854),
  },
  [650] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1862),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(650),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2852),
  },
  [651] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1489),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(651),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [652] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1544),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(652),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [653] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1532),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(653),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [654] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__term_rightward] = STATE(1722),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(654),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [655] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__term_rightward] = STATE(1810),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(655),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [656] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1241),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(656),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2862),
  },
  [657] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__term_rightward] = STATE(1808),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(657),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [658] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3270),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(658),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [659] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3272),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(659),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [660] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__term_rightward] = STATE(1800),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(660),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [661] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1952),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(661),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2856),
  },
  [662] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1957),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(662),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2854),
  },
  [663] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1953),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(663),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2852),
  },
  [664] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1489),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(664),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [665] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__term_rightward] = STATE(1784),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1708),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(665),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [666] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1544),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(666),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [667] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1291),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(667),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [668] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1532),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(668),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [669] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1743),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(669),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2864),
  },
  [670] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1730),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(670),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2866),
  },
  [671] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1723),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(671),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2868),
  },
  [672] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1970),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(672),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [673] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1525),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(673),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [674] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1523),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1752),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(674),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [675] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1334),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1231),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(675),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [676] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1920),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(676),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2856),
  },
  [677] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1921),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(677),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2854),
  },
  [678] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3217),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(678),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [679] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1272),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(679),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [680] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1489),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(680),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [681] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1532),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(681),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [682] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1476),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(682),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2860),
  },
  [683] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1479),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(683),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2858),
  },
  [684] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1458),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(684),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2862),
  },
  [685] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1291),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(685),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [686] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1308),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(686),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [687] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1334),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(687),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [688] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1525),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(688),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [689] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__term_rightward] = STATE(1311),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1417),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(689),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [690] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1523),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1748),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(690),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [691] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1940),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(691),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__NONASSOC] = ACTIONS(2852),
  },
  [692] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3261),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(692),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [693] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3260),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(693),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [694] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(3239),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1724),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(694),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [695] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1523),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(695),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [696] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__term_rightward] = STATE(1525),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1749),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(696),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [697] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1886),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(697),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [698] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1839),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(698),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [699] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1966),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(699),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [700] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1959),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(700),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [701] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1958),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(701),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [702] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1967),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(702),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [703] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1953),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(703),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [704] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1973),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(704),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [705] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1614),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(705),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [706] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1601),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(706),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [707] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1609),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(707),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [708] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1608),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(708),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [709] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1940),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(709),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [710] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1941),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(710),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [711] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1943),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(711),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [712] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1607),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(712),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [713] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1948),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(713),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [714] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1908),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(714),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [715] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1949),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(715),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [716] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1950),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(716),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [717] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1942),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(717),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [718] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1939),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(718),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [719] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1932),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(719),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [720] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1594),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(720),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [721] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1926),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(721),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [722] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1925),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(722),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [723] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1477),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(723),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [724] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1924),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(724),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [725] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1921),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(725),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [726] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1276),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(726),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [727] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1432),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(727),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [728] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1476),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(728),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [729] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1479),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(729),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [730] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1480),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(730),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [731] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1481),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(731),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [732] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1482),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(732),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [733] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1485),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(733),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [734] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1486),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(734),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [735] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1487),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(735),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [736] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1472),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(736),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [737] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1473),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(737),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [738] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1475),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(738),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [739] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1461),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(739),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [740] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1460),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(740),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [741] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1459),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(741),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [742] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1458),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(742),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [743] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1920),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(743),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [744] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1296),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(744),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [745] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1297),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(745),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [746] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1634),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(746),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [747] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1602),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(747),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [748] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1977),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(748),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [749] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1633),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(749),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [750] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1918),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(750),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [751] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1956),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(751),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [752] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1631),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(752),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [753] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1630),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(753),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [754] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1981),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(754),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [755] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1628),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(755),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [756] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1984),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(756),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [757] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1627),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(757),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [758] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1626),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(758),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [759] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1862),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(759),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [760] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1861),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(760),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [761] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1860),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(761),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [762] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1859),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(762),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [763] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1899),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(763),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [764] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1873),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(764),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [765] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1874),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(765),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [766] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1978),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(766),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [767] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1857),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(767),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [768] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1983),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(768),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [769] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1594),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(769),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [770] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1876),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(770),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [771] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1879),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(771),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [772] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1728),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(772),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [773] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1975),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(773),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [774] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1623),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(774),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [775] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1974),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(775),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [776] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1957),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(776),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [777] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1952),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(777),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [778] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1881),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(778),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [779] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1928),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(779),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [780] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1884),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(780),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [781] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1915),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(781),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [782] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1972),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(782),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [783] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1594),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(783),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [784] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1723),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(784),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [785] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1730),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(785),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [786] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1731),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(786),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [787] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1885),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(787),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [788] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1732),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(788),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [789] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1733),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(789),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [790] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1734),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(790),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [791] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1735),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(791),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [792] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1729),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(792),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [793] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1945),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(393),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(793),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(740),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(742),
    [anon_sym_require] = ACTIONS(744),
    [anon_sym_map] = ACTIONS(746),
    [anon_sym_grep] = ACTIONS(746),
    [anon_sym_sort] = ACTIONS(748),
    [anon_sym_goto] = ACTIONS(750),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_undef] = ACTIONS(754),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(756),
    [anon_sym_next] = ACTIONS(756),
    [anon_sym_redo] = ACTIONS(756),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(758),
    [anon_sym_alarm] = ACTIONS(758),
    [anon_sym_chop] = ACTIONS(758),
    [anon_sym_chdir] = ACTIONS(758),
    [anon_sym_close] = ACTIONS(758),
    [anon_sym_closedir] = ACTIONS(758),
    [anon_sym_caller] = ACTIONS(758),
    [anon_sym_chomp] = ACTIONS(758),
    [anon_sym_chr] = ACTIONS(758),
    [anon_sym_cos] = ACTIONS(758),
    [anon_sym_chroot] = ACTIONS(758),
    [anon_sym_defined] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(758),
    [anon_sym_dbmclose] = ACTIONS(758),
    [anon_sym_exists] = ACTIONS(758),
    [anon_sym_exit] = ACTIONS(758),
    [anon_sym_eof] = ACTIONS(758),
    [anon_sym_exp] = ACTIONS(758),
    [anon_sym_each] = ACTIONS(758),
    [anon_sym_fc] = ACTIONS(758),
    [anon_sym_fileno] = ACTIONS(758),
    [anon_sym_gmtime] = ACTIONS(758),
    [anon_sym_getc] = ACTIONS(758),
    [anon_sym_getpgrp] = ACTIONS(758),
    [anon_sym_getprotobyname] = ACTIONS(758),
    [anon_sym_getpwname] = ACTIONS(758),
    [anon_sym_getpwuid] = ACTIONS(758),
    [anon_sym_getpeername] = ACTIONS(758),
    [anon_sym_getnetbyname] = ACTIONS(758),
    [anon_sym_getsockname] = ACTIONS(758),
    [anon_sym_getgrnam] = ACTIONS(758),
    [anon_sym_getgrgid] = ACTIONS(758),
    [anon_sym_hex] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_keys] = ACTIONS(758),
    [anon_sym_lc] = ACTIONS(758),
    [anon_sym_lcfirst] = ACTIONS(758),
    [anon_sym_length] = ACTIONS(758),
    [anon_sym_localtime] = ACTIONS(758),
    [anon_sym_log] = ACTIONS(758),
    [anon_sym_lock] = ACTIONS(758),
    [anon_sym_lstat] = ACTIONS(758),
    [anon_sym_oct] = ACTIONS(758),
    [anon_sym_ord] = ACTIONS(758),
    [anon_sym_prototype] = ACTIONS(758),
    [anon_sym_pop] = ACTIONS(758),
    [anon_sym_pos] = ACTIONS(758),
    [anon_sym_quotemeta] = ACTIONS(758),
    [anon_sym_reset] = ACTIONS(758),
    [anon_sym_rand] = ACTIONS(758),
    [anon_sym_rmdir] = ACTIONS(758),
    [anon_sym_readdir] = ACTIONS(758),
    [anon_sym_readline] = ACTIONS(758),
    [anon_sym_readpipe] = ACTIONS(758),
    [anon_sym_rewinddir] = ACTIONS(758),
    [anon_sym_readlink] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(758),
    [anon_sym_scalar] = ACTIONS(758),
    [anon_sym_shift] = ACTIONS(758),
    [anon_sym_sin] = ACTIONS(758),
    [anon_sym_sleep] = ACTIONS(758),
    [anon_sym_sqrt] = ACTIONS(758),
    [anon_sym_srand] = ACTIONS(758),
    [anon_sym_stat] = ACTIONS(758),
    [anon_sym_study] = ACTIONS(758),
    [anon_sym_tell] = ACTIONS(758),
    [anon_sym_telldir] = ACTIONS(758),
    [anon_sym_tied] = ACTIONS(758),
    [anon_sym_uc] = ACTIONS(758),
    [anon_sym_ucfirst] = ACTIONS(758),
    [anon_sym_untie] = ACTIONS(758),
    [anon_sym_umask] = ACTIONS(758),
    [anon_sym_values] = ACTIONS(758),
    [anon_sym_write] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [794] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1737),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(794),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [795] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1738),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(795),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [796] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1739),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(796),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [797] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1740),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(797),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [798] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1741),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(798),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [799] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1742),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(799),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [800] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1743),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(800),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [801] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1890),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(801),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [802] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1296),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(802),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [803] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1612),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(803),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [804] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1895),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(804),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [805] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1594),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(805),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [806] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1971),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(806),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [807] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1893),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(807),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [808] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1955),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(808),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [809] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1979),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(809),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [810] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1337),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(810),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [811] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1982),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(811),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [812] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1897),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(812),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [813] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1909),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(389),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(813),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(491),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(493),
    [anon_sym_require] = ACTIONS(495),
    [anon_sym_map] = ACTIONS(497),
    [anon_sym_grep] = ACTIONS(497),
    [anon_sym_sort] = ACTIONS(499),
    [anon_sym_goto] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_undef] = ACTIONS(505),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(507),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(507),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(509),
    [anon_sym_alarm] = ACTIONS(509),
    [anon_sym_chop] = ACTIONS(509),
    [anon_sym_chdir] = ACTIONS(509),
    [anon_sym_close] = ACTIONS(509),
    [anon_sym_closedir] = ACTIONS(509),
    [anon_sym_caller] = ACTIONS(509),
    [anon_sym_chomp] = ACTIONS(509),
    [anon_sym_chr] = ACTIONS(509),
    [anon_sym_cos] = ACTIONS(509),
    [anon_sym_chroot] = ACTIONS(509),
    [anon_sym_defined] = ACTIONS(509),
    [anon_sym_delete] = ACTIONS(509),
    [anon_sym_dbmclose] = ACTIONS(509),
    [anon_sym_exists] = ACTIONS(509),
    [anon_sym_exit] = ACTIONS(509),
    [anon_sym_eof] = ACTIONS(509),
    [anon_sym_exp] = ACTIONS(509),
    [anon_sym_each] = ACTIONS(509),
    [anon_sym_fc] = ACTIONS(509),
    [anon_sym_fileno] = ACTIONS(509),
    [anon_sym_gmtime] = ACTIONS(509),
    [anon_sym_getc] = ACTIONS(509),
    [anon_sym_getpgrp] = ACTIONS(509),
    [anon_sym_getprotobyname] = ACTIONS(509),
    [anon_sym_getpwname] = ACTIONS(509),
    [anon_sym_getpwuid] = ACTIONS(509),
    [anon_sym_getpeername] = ACTIONS(509),
    [anon_sym_getnetbyname] = ACTIONS(509),
    [anon_sym_getsockname] = ACTIONS(509),
    [anon_sym_getgrnam] = ACTIONS(509),
    [anon_sym_getgrgid] = ACTIONS(509),
    [anon_sym_hex] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_keys] = ACTIONS(509),
    [anon_sym_lc] = ACTIONS(509),
    [anon_sym_lcfirst] = ACTIONS(509),
    [anon_sym_length] = ACTIONS(509),
    [anon_sym_localtime] = ACTIONS(509),
    [anon_sym_log] = ACTIONS(509),
    [anon_sym_lock] = ACTIONS(509),
    [anon_sym_lstat] = ACTIONS(509),
    [anon_sym_oct] = ACTIONS(509),
    [anon_sym_ord] = ACTIONS(509),
    [anon_sym_prototype] = ACTIONS(509),
    [anon_sym_pop] = ACTIONS(509),
    [anon_sym_pos] = ACTIONS(509),
    [anon_sym_quotemeta] = ACTIONS(509),
    [anon_sym_reset] = ACTIONS(509),
    [anon_sym_rand] = ACTIONS(509),
    [anon_sym_rmdir] = ACTIONS(509),
    [anon_sym_readdir] = ACTIONS(509),
    [anon_sym_readline] = ACTIONS(509),
    [anon_sym_readpipe] = ACTIONS(509),
    [anon_sym_rewinddir] = ACTIONS(509),
    [anon_sym_readlink] = ACTIONS(509),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_scalar] = ACTIONS(509),
    [anon_sym_shift] = ACTIONS(509),
    [anon_sym_sin] = ACTIONS(509),
    [anon_sym_sleep] = ACTIONS(509),
    [anon_sym_sqrt] = ACTIONS(509),
    [anon_sym_srand] = ACTIONS(509),
    [anon_sym_stat] = ACTIONS(509),
    [anon_sym_study] = ACTIONS(509),
    [anon_sym_tell] = ACTIONS(509),
    [anon_sym_telldir] = ACTIONS(509),
    [anon_sym_tied] = ACTIONS(509),
    [anon_sym_uc] = ACTIONS(509),
    [anon_sym_ucfirst] = ACTIONS(509),
    [anon_sym_untie] = ACTIONS(509),
    [anon_sym_umask] = ACTIONS(509),
    [anon_sym_values] = ACTIONS(509),
    [anon_sym_write] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [814] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1964),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(814),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [815] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1954),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(815),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [816] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1867),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(816),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [817] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1865),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(817),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [818] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1864),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(818),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [819] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1878),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(819),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [820] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1883),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(820),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [821] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1871),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(821),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [822] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1898),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(822),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [823] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1911),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(823),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [824] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1902),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(824),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [825] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1900),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(825),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [826] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1263),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(826),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [827] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1960),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(827),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [828] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1271),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(828),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [829] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1270),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(829),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [830] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1914),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(830),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [831] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1858),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(831),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [832] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1264),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(832),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [833] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1838),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(833),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [834] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1965),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(834),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [835] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1273),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(835),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [836] = {
    [sym__HASHBRACK] = STATE(342),
    [sym__subscripted] = STATE(1656),
    [sym_container_variable] = STATE(3078),
    [sym_array_element_expression] = STATE(1657),
    [sym_hash_element_expression] = STATE(1657),
    [sym_coderef_call_expression] = STATE(1657),
    [sym_anonymous_slice_expression] = STATE(1657),
    [sym_slice_container_variable] = STATE(3077),
    [sym_slice_expression] = STATE(1856),
    [sym_keyval_container_variable] = STATE(3076),
    [sym_keyval_expression] = STATE(1856),
    [sym__term] = STATE(1842),
    [sym_readline_expression] = STATE(1856),
    [sym_assignment_expression] = STATE(1856),
    [sym_binary_expression] = STATE(1856),
    [sym_equality_expression] = STATE(1856),
    [sym_relational_expression] = STATE(1856),
    [sym_unary_expression] = STATE(1856),
    [sym_preinc_expression] = STATE(1856),
    [sym_postinc_expression] = STATE(1856),
    [sym_conditional_expression] = STATE(1856),
    [sym_refgen_expression] = STATE(1856),
    [sym_anonymous_array_expression] = STATE(1856),
    [sym_anonymous_hash_expression] = STATE(1856),
    [sym_anonymous_subroutine_expression] = STATE(1856),
    [sym_anonymous_method_expression] = STATE(1856),
    [sym_do_expression] = STATE(1856),
    [sym_eval_expression] = STATE(1856),
    [sym_variable_declaration] = STATE(1856),
    [sym_localization_expression] = STATE(1856),
    [sym_stub_expression] = STATE(1856),
    [sym_scalar_deref_expression] = STATE(1856),
    [sym_array_deref_expression] = STATE(1856),
    [sym_hash_deref_expression] = STATE(1856),
    [sym_amper_deref_expression] = STATE(1856),
    [sym_glob_deref_expression] = STATE(1856),
    [sym_require_expression] = STATE(1856),
    [sym_func0op_call_expression] = STATE(1856),
    [sym_func1op_call_expression] = STATE(1856),
    [sym_map_grep_expression] = STATE(1856),
    [sym_sort_expression] = STATE(1856),
    [sym_loopex_expression] = STATE(1856),
    [sym_goto_expression] = STATE(1856),
    [sym_return_expression] = STATE(1856),
    [sym_undef_expression] = STATE(1856),
    [sym__listop] = STATE(1856),
    [sym_function_call_expression] = STATE(1855),
    [sym_ambiguous_function_call_expression] = STATE(1855),
    [sym_function] = STATE(354),
    [sym_method_call_expression] = STATE(1855),
    [sym_scalar] = STATE(1856),
    [sym_array] = STATE(1856),
    [sym_hash] = STATE(1856),
    [sym_arraylen] = STATE(1856),
    [sym_glob] = STATE(1856),
    [sym__literal] = STATE(1856),
    [sym_string_literal] = STATE(1854),
    [sym_interpolated_string_literal] = STATE(1854),
    [sym_quoted_word_list] = STATE(1699),
    [sym_command_string] = STATE(1854),
    [sym_quoted_regexp] = STATE(1854),
    [sym_match_regexp] = STATE(1854),
    [sym_substitution_regexp] = STATE(1854),
    [sym_transliteration_expression] = STATE(1854),
    [sym_heredoc_token] = STATE(1856),
    [sym_command_heredoc_token] = STATE(1856),
    [sym_heredoc_content] = STATE(836),
    [sym_autoquoted_bareword] = STATE(1856),
    [sym__fat_comma_autoquoted_bareword] = STATE(1856),
    [sym_bareword] = STATE(1856),
    [sym_primitive] = STATE(1856),
    [sym__identifier] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_method] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_my] = ACTIONS(379),
    [anon_sym_state] = ACTIONS(379),
    [anon_sym_our] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_elsif] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_eq] = ACTIONS(369),
    [anon_sym_ne] = ACTIONS(369),
    [anon_sym_cmp] = ACTIONS(369),
    [anon_sym_lt] = ACTIONS(369),
    [anon_sym_le] = ACTIONS(369),
    [anon_sym_ge] = ACTIONS(369),
    [anon_sym_gt] = ACTIONS(369),
    [anon_sym_isa] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_BSLASH] = ACTIONS(389),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_eval] = ACTIONS(393),
    [anon_sym_field] = ACTIONS(379),
    [anon_sym_local] = ACTIONS(395),
    [anon_sym_require] = ACTIONS(397),
    [anon_sym_map] = ACTIONS(399),
    [anon_sym_grep] = ACTIONS(399),
    [anon_sym_sort] = ACTIONS(401),
    [anon_sym_goto] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_undef] = ACTIONS(407),
    [anon_sym_PERCENT2] = ACTIONS(409),
    [anon_sym_DOLLAR_POUND] = ACTIONS(411),
    [anon_sym_use] = ACTIONS(369),
    [anon_sym_no] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_foreach] = ACTIONS(369),
    [anon_sym_last] = ACTIONS(413),
    [anon_sym_next] = ACTIONS(413),
    [anon_sym_redo] = ACTIONS(413),
    [anon_sym_BEGIN] = ACTIONS(369),
    [anon_sym_INIT] = ACTIONS(369),
    [anon_sym_CHECK] = ACTIONS(369),
    [anon_sym_UNITCHECK] = ACTIONS(369),
    [anon_sym_END] = ACTIONS(369),
    [anon_sym_ADJUST] = ACTIONS(369),
    [anon_sym___FILE__] = ACTIONS(377),
    [anon_sym___LINE__] = ACTIONS(377),
    [anon_sym___PACKAGE__] = ACTIONS(377),
    [anon_sym___SUB__] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_fork] = ACTIONS(377),
    [anon_sym_getppid] = ACTIONS(377),
    [anon_sym_time] = ACTIONS(377),
    [anon_sym_times] = ACTIONS(377),
    [anon_sym_wait] = ACTIONS(377),
    [anon_sym_wantarray] = ACTIONS(377),
    [anon_sym_abs] = ACTIONS(415),
    [anon_sym_alarm] = ACTIONS(415),
    [anon_sym_chop] = ACTIONS(415),
    [anon_sym_chdir] = ACTIONS(415),
    [anon_sym_close] = ACTIONS(415),
    [anon_sym_closedir] = ACTIONS(415),
    [anon_sym_caller] = ACTIONS(415),
    [anon_sym_chomp] = ACTIONS(415),
    [anon_sym_chr] = ACTIONS(415),
    [anon_sym_cos] = ACTIONS(415),
    [anon_sym_chroot] = ACTIONS(415),
    [anon_sym_defined] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(415),
    [anon_sym_dbmclose] = ACTIONS(415),
    [anon_sym_exists] = ACTIONS(415),
    [anon_sym_exit] = ACTIONS(415),
    [anon_sym_eof] = ACTIONS(415),
    [anon_sym_exp] = ACTIONS(415),
    [anon_sym_each] = ACTIONS(415),
    [anon_sym_fc] = ACTIONS(415),
    [anon_sym_fileno] = ACTIONS(415),
    [anon_sym_gmtime] = ACTIONS(415),
    [anon_sym_getc] = ACTIONS(415),
    [anon_sym_getpgrp] = ACTIONS(415),
    [anon_sym_getprotobyname] = ACTIONS(415),
    [anon_sym_getpwname] = ACTIONS(415),
    [anon_sym_getpwuid] = ACTIONS(415),
    [anon_sym_getpeername] = ACTIONS(415),
    [anon_sym_getnetbyname] = ACTIONS(415),
    [anon_sym_getsockname] = ACTIONS(415),
    [anon_sym_getgrnam] = ACTIONS(415),
    [anon_sym_getgrgid] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_keys] = ACTIONS(415),
    [anon_sym_lc] = ACTIONS(415),
    [anon_sym_lcfirst] = ACTIONS(415),
    [anon_sym_length] = ACTIONS(415),
    [anon_sym_localtime] = ACTIONS(415),
    [anon_sym_log] = ACTIONS(415),
    [anon_sym_lock] = ACTIONS(415),
    [anon_sym_lstat] = ACTIONS(415),
    [anon_sym_oct] = ACTIONS(415),
    [anon_sym_ord] = ACTIONS(415),
    [anon_sym_prototype] = ACTIONS(415),
    [anon_sym_pop] = ACTIONS(415),
    [anon_sym_pos] = ACTIONS(415),
    [anon_sym_quotemeta] = ACTIONS(415),
    [anon_sym_reset] = ACTIONS(415),
    [anon_sym_rand] = ACTIONS(415),
    [anon_sym_rmdir] = ACTIONS(415),
    [anon_sym_readdir] = ACTIONS(415),
    [anon_sym_readline] = ACTIONS(415),
    [anon_sym_readpipe] = ACTIONS(415),
    [anon_sym_rewinddir] = ACTIONS(415),
    [anon_sym_readlink] = ACTIONS(415),
    [anon_sym_ref] = ACTIONS(415),
    [anon_sym_scalar] = ACTIONS(415),
    [anon_sym_shift] = ACTIONS(415),
    [anon_sym_sin] = ACTIONS(415),
    [anon_sym_sleep] = ACTIONS(415),
    [anon_sym_sqrt] = ACTIONS(415),
    [anon_sym_srand] = ACTIONS(415),
    [anon_sym_stat] = ACTIONS(415),
    [anon_sym_study] = ACTIONS(415),
    [anon_sym_tell] = ACTIONS(415),
    [anon_sym_telldir] = ACTIONS(415),
    [anon_sym_tied] = ACTIONS(415),
    [anon_sym_uc] = ACTIONS(415),
    [anon_sym_ucfirst] = ACTIONS(415),
    [anon_sym_untie] = ACTIONS(415),
    [anon_sym_umask] = ACTIONS(415),
    [anon_sym_values] = ACTIONS(415),
    [anon_sym_write] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(369),
    [anon_sym___END__] = ACTIONS(369),
    [anon_sym_q] = ACTIONS(417),
    [anon_sym_qq] = ACTIONS(419),
    [anon_sym_qw] = ACTIONS(421),
    [anon_sym_qx] = ACTIONS(423),
    [anon_sym_qr] = ACTIONS(425),
    [anon_sym_m] = ACTIONS(427),
    [anon_sym_s] = ACTIONS(429),
    [anon_sym_tr] = ACTIONS(431),
    [anon_sym_y] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_unless] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_until] = ACTIONS(369),
    [aux_sym__bareword_token1] = ACTIONS(433),
    [sym_number] = ACTIONS(435),
    [sym__apostrophe] = ACTIONS(437),
    [sym__double_quote] = ACTIONS(439),
    [sym__backtick] = ACTIONS(441),
    [sym__search_slash] = ACTIONS(443),
    [sym__PERLY_HEREDOC] = ACTIONS(445),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [837] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1896),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(837),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [838] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1866),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(838),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [839] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1431),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(376),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(839),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(227),
    [anon_sym_state] = ACTIONS(227),
    [anon_sym_our] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_BSLASH] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(233),
    [anon_sym_field] = ACTIONS(227),
    [anon_sym_local] = ACTIONS(235),
    [anon_sym_require] = ACTIONS(237),
    [anon_sym_map] = ACTIONS(239),
    [anon_sym_grep] = ACTIONS(239),
    [anon_sym_sort] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(243),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_undef] = ACTIONS(247),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(249),
    [anon_sym_next] = ACTIONS(249),
    [anon_sym_redo] = ACTIONS(249),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(251),
    [anon_sym_alarm] = ACTIONS(251),
    [anon_sym_chop] = ACTIONS(251),
    [anon_sym_chdir] = ACTIONS(251),
    [anon_sym_close] = ACTIONS(251),
    [anon_sym_closedir] = ACTIONS(251),
    [anon_sym_caller] = ACTIONS(251),
    [anon_sym_chomp] = ACTIONS(251),
    [anon_sym_chr] = ACTIONS(251),
    [anon_sym_cos] = ACTIONS(251),
    [anon_sym_chroot] = ACTIONS(251),
    [anon_sym_defined] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(251),
    [anon_sym_dbmclose] = ACTIONS(251),
    [anon_sym_exists] = ACTIONS(251),
    [anon_sym_exit] = ACTIONS(251),
    [anon_sym_eof] = ACTIONS(251),
    [anon_sym_exp] = ACTIONS(251),
    [anon_sym_each] = ACTIONS(251),
    [anon_sym_fc] = ACTIONS(251),
    [anon_sym_fileno] = ACTIONS(251),
    [anon_sym_gmtime] = ACTIONS(251),
    [anon_sym_getc] = ACTIONS(251),
    [anon_sym_getpgrp] = ACTIONS(251),
    [anon_sym_getprotobyname] = ACTIONS(251),
    [anon_sym_getpwname] = ACTIONS(251),
    [anon_sym_getpwuid] = ACTIONS(251),
    [anon_sym_getpeername] = ACTIONS(251),
    [anon_sym_getnetbyname] = ACTIONS(251),
    [anon_sym_getsockname] = ACTIONS(251),
    [anon_sym_getgrnam] = ACTIONS(251),
    [anon_sym_getgrgid] = ACTIONS(251),
    [anon_sym_hex] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_keys] = ACTIONS(251),
    [anon_sym_lc] = ACTIONS(251),
    [anon_sym_lcfirst] = ACTIONS(251),
    [anon_sym_length] = ACTIONS(251),
    [anon_sym_localtime] = ACTIONS(251),
    [anon_sym_log] = ACTIONS(251),
    [anon_sym_lock] = ACTIONS(251),
    [anon_sym_lstat] = ACTIONS(251),
    [anon_sym_oct] = ACTIONS(251),
    [anon_sym_ord] = ACTIONS(251),
    [anon_sym_prototype] = ACTIONS(251),
    [anon_sym_pop] = ACTIONS(251),
    [anon_sym_pos] = ACTIONS(251),
    [anon_sym_quotemeta] = ACTIONS(251),
    [anon_sym_reset] = ACTIONS(251),
    [anon_sym_rand] = ACTIONS(251),
    [anon_sym_rmdir] = ACTIONS(251),
    [anon_sym_readdir] = ACTIONS(251),
    [anon_sym_readline] = ACTIONS(251),
    [anon_sym_readpipe] = ACTIONS(251),
    [anon_sym_rewinddir] = ACTIONS(251),
    [anon_sym_readlink] = ACTIONS(251),
    [anon_sym_ref] = ACTIONS(251),
    [anon_sym_scalar] = ACTIONS(251),
    [anon_sym_shift] = ACTIONS(251),
    [anon_sym_sin] = ACTIONS(251),
    [anon_sym_sleep] = ACTIONS(251),
    [anon_sym_sqrt] = ACTIONS(251),
    [anon_sym_srand] = ACTIONS(251),
    [anon_sym_stat] = ACTIONS(251),
    [anon_sym_study] = ACTIONS(251),
    [anon_sym_tell] = ACTIONS(251),
    [anon_sym_telldir] = ACTIONS(251),
    [anon_sym_tied] = ACTIONS(251),
    [anon_sym_uc] = ACTIONS(251),
    [anon_sym_ucfirst] = ACTIONS(251),
    [anon_sym_untie] = ACTIONS(251),
    [anon_sym_umask] = ACTIONS(251),
    [anon_sym_values] = ACTIONS(251),
    [anon_sym_write] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(253),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [840] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1624),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(840),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [841] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1262),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(841),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [842] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1594),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(842),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [843] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1605),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(843),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [844] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1259),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(844),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [845] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1894),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(845),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [846] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1258),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(846),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [847] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1254),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(847),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [848] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1246),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(848),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [849] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1245),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(849),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [850] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1244),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(850),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [851] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1243),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(851),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [852] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1242),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(852),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [853] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1875),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(368),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(853),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(149),
    [anon_sym_state] = ACTIONS(149),
    [anon_sym_our] = ACTIONS(149),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(163),
    [anon_sym_field] = ACTIONS(149),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(169),
    [anon_sym_grep] = ACTIONS(169),
    [anon_sym_sort] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_undef] = ACTIONS(177),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(183),
    [anon_sym_next] = ACTIONS(183),
    [anon_sym_redo] = ACTIONS(183),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(185),
    [anon_sym_alarm] = ACTIONS(185),
    [anon_sym_chop] = ACTIONS(185),
    [anon_sym_chdir] = ACTIONS(185),
    [anon_sym_close] = ACTIONS(185),
    [anon_sym_closedir] = ACTIONS(185),
    [anon_sym_caller] = ACTIONS(185),
    [anon_sym_chomp] = ACTIONS(185),
    [anon_sym_chr] = ACTIONS(185),
    [anon_sym_cos] = ACTIONS(185),
    [anon_sym_chroot] = ACTIONS(185),
    [anon_sym_defined] = ACTIONS(185),
    [anon_sym_delete] = ACTIONS(185),
    [anon_sym_dbmclose] = ACTIONS(185),
    [anon_sym_exists] = ACTIONS(185),
    [anon_sym_exit] = ACTIONS(185),
    [anon_sym_eof] = ACTIONS(185),
    [anon_sym_exp] = ACTIONS(185),
    [anon_sym_each] = ACTIONS(185),
    [anon_sym_fc] = ACTIONS(185),
    [anon_sym_fileno] = ACTIONS(185),
    [anon_sym_gmtime] = ACTIONS(185),
    [anon_sym_getc] = ACTIONS(185),
    [anon_sym_getpgrp] = ACTIONS(185),
    [anon_sym_getprotobyname] = ACTIONS(185),
    [anon_sym_getpwname] = ACTIONS(185),
    [anon_sym_getpwuid] = ACTIONS(185),
    [anon_sym_getpeername] = ACTIONS(185),
    [anon_sym_getnetbyname] = ACTIONS(185),
    [anon_sym_getsockname] = ACTIONS(185),
    [anon_sym_getgrnam] = ACTIONS(185),
    [anon_sym_getgrgid] = ACTIONS(185),
    [anon_sym_hex] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_keys] = ACTIONS(185),
    [anon_sym_lc] = ACTIONS(185),
    [anon_sym_lcfirst] = ACTIONS(185),
    [anon_sym_length] = ACTIONS(185),
    [anon_sym_localtime] = ACTIONS(185),
    [anon_sym_log] = ACTIONS(185),
    [anon_sym_lock] = ACTIONS(185),
    [anon_sym_lstat] = ACTIONS(185),
    [anon_sym_oct] = ACTIONS(185),
    [anon_sym_ord] = ACTIONS(185),
    [anon_sym_prototype] = ACTIONS(185),
    [anon_sym_pop] = ACTIONS(185),
    [anon_sym_pos] = ACTIONS(185),
    [anon_sym_quotemeta] = ACTIONS(185),
    [anon_sym_reset] = ACTIONS(185),
    [anon_sym_rand] = ACTIONS(185),
    [anon_sym_rmdir] = ACTIONS(185),
    [anon_sym_readdir] = ACTIONS(185),
    [anon_sym_readline] = ACTIONS(185),
    [anon_sym_readpipe] = ACTIONS(185),
    [anon_sym_rewinddir] = ACTIONS(185),
    [anon_sym_readlink] = ACTIONS(185),
    [anon_sym_ref] = ACTIONS(185),
    [anon_sym_scalar] = ACTIONS(185),
    [anon_sym_shift] = ACTIONS(185),
    [anon_sym_sin] = ACTIONS(185),
    [anon_sym_sleep] = ACTIONS(185),
    [anon_sym_sqrt] = ACTIONS(185),
    [anon_sym_srand] = ACTIONS(185),
    [anon_sym_stat] = ACTIONS(185),
    [anon_sym_study] = ACTIONS(185),
    [anon_sym_tell] = ACTIONS(185),
    [anon_sym_telldir] = ACTIONS(185),
    [anon_sym_tied] = ACTIONS(185),
    [anon_sym_uc] = ACTIONS(185),
    [anon_sym_ucfirst] = ACTIONS(185),
    [anon_sym_untie] = ACTIONS(185),
    [anon_sym_umask] = ACTIONS(185),
    [anon_sym_values] = ACTIONS(185),
    [anon_sym_write] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [854] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1961),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(398),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(854),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(485),
    [anon_sym_state] = ACTIONS(485),
    [anon_sym_our] = ACTIONS(485),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(855),
    [anon_sym_field] = ACTIONS(485),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_map] = ACTIONS(861),
    [anon_sym_grep] = ACTIONS(861),
    [anon_sym_sort] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_undef] = ACTIONS(869),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(871),
    [anon_sym_next] = ACTIONS(871),
    [anon_sym_redo] = ACTIONS(871),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(873),
    [anon_sym_alarm] = ACTIONS(873),
    [anon_sym_chop] = ACTIONS(873),
    [anon_sym_chdir] = ACTIONS(873),
    [anon_sym_close] = ACTIONS(873),
    [anon_sym_closedir] = ACTIONS(873),
    [anon_sym_caller] = ACTIONS(873),
    [anon_sym_chomp] = ACTIONS(873),
    [anon_sym_chr] = ACTIONS(873),
    [anon_sym_cos] = ACTIONS(873),
    [anon_sym_chroot] = ACTIONS(873),
    [anon_sym_defined] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(873),
    [anon_sym_dbmclose] = ACTIONS(873),
    [anon_sym_exists] = ACTIONS(873),
    [anon_sym_exit] = ACTIONS(873),
    [anon_sym_eof] = ACTIONS(873),
    [anon_sym_exp] = ACTIONS(873),
    [anon_sym_each] = ACTIONS(873),
    [anon_sym_fc] = ACTIONS(873),
    [anon_sym_fileno] = ACTIONS(873),
    [anon_sym_gmtime] = ACTIONS(873),
    [anon_sym_getc] = ACTIONS(873),
    [anon_sym_getpgrp] = ACTIONS(873),
    [anon_sym_getprotobyname] = ACTIONS(873),
    [anon_sym_getpwname] = ACTIONS(873),
    [anon_sym_getpwuid] = ACTIONS(873),
    [anon_sym_getpeername] = ACTIONS(873),
    [anon_sym_getnetbyname] = ACTIONS(873),
    [anon_sym_getsockname] = ACTIONS(873),
    [anon_sym_getgrnam] = ACTIONS(873),
    [anon_sym_getgrgid] = ACTIONS(873),
    [anon_sym_hex] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_keys] = ACTIONS(873),
    [anon_sym_lc] = ACTIONS(873),
    [anon_sym_lcfirst] = ACTIONS(873),
    [anon_sym_length] = ACTIONS(873),
    [anon_sym_localtime] = ACTIONS(873),
    [anon_sym_log] = ACTIONS(873),
    [anon_sym_lock] = ACTIONS(873),
    [anon_sym_lstat] = ACTIONS(873),
    [anon_sym_oct] = ACTIONS(873),
    [anon_sym_ord] = ACTIONS(873),
    [anon_sym_prototype] = ACTIONS(873),
    [anon_sym_pop] = ACTIONS(873),
    [anon_sym_pos] = ACTIONS(873),
    [anon_sym_quotemeta] = ACTIONS(873),
    [anon_sym_reset] = ACTIONS(873),
    [anon_sym_rand] = ACTIONS(873),
    [anon_sym_rmdir] = ACTIONS(873),
    [anon_sym_readdir] = ACTIONS(873),
    [anon_sym_readline] = ACTIONS(873),
    [anon_sym_readpipe] = ACTIONS(873),
    [anon_sym_rewinddir] = ACTIONS(873),
    [anon_sym_readlink] = ACTIONS(873),
    [anon_sym_ref] = ACTIONS(873),
    [anon_sym_scalar] = ACTIONS(873),
    [anon_sym_shift] = ACTIONS(873),
    [anon_sym_sin] = ACTIONS(873),
    [anon_sym_sleep] = ACTIONS(873),
    [anon_sym_sqrt] = ACTIONS(873),
    [anon_sym_srand] = ACTIONS(873),
    [anon_sym_stat] = ACTIONS(873),
    [anon_sym_study] = ACTIONS(873),
    [anon_sym_tell] = ACTIONS(873),
    [anon_sym_telldir] = ACTIONS(873),
    [anon_sym_tied] = ACTIONS(873),
    [anon_sym_uc] = ACTIONS(873),
    [anon_sym_ucfirst] = ACTIONS(873),
    [anon_sym_untie] = ACTIONS(873),
    [anon_sym_umask] = ACTIONS(873),
    [anon_sym_values] = ACTIONS(873),
    [anon_sym_write] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(203),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [855] = {
    [sym__HASHBRACK] = STATE(328),
    [sym__subscripted] = STATE(1389),
    [sym_container_variable] = STATE(3096),
    [sym_array_element_expression] = STATE(1381),
    [sym_hash_element_expression] = STATE(1381),
    [sym_coderef_call_expression] = STATE(1381),
    [sym_anonymous_slice_expression] = STATE(1381),
    [sym_slice_container_variable] = STATE(3095),
    [sym_slice_expression] = STATE(1496),
    [sym_keyval_container_variable] = STATE(3094),
    [sym_keyval_expression] = STATE(1496),
    [sym__term] = STATE(1621),
    [sym_readline_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_binary_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_unary_expression] = STATE(1496),
    [sym_preinc_expression] = STATE(1496),
    [sym_postinc_expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_refgen_expression] = STATE(1496),
    [sym_anonymous_array_expression] = STATE(1496),
    [sym_anonymous_hash_expression] = STATE(1496),
    [sym_anonymous_subroutine_expression] = STATE(1496),
    [sym_anonymous_method_expression] = STATE(1496),
    [sym_do_expression] = STATE(1496),
    [sym_eval_expression] = STATE(1496),
    [sym_variable_declaration] = STATE(1496),
    [sym_localization_expression] = STATE(1496),
    [sym_stub_expression] = STATE(1496),
    [sym_scalar_deref_expression] = STATE(1496),
    [sym_array_deref_expression] = STATE(1496),
    [sym_hash_deref_expression] = STATE(1496),
    [sym_amper_deref_expression] = STATE(1496),
    [sym_glob_deref_expression] = STATE(1496),
    [sym_require_expression] = STATE(1496),
    [sym_func0op_call_expression] = STATE(1496),
    [sym_func1op_call_expression] = STATE(1496),
    [sym_map_grep_expression] = STATE(1496),
    [sym_sort_expression] = STATE(1496),
    [sym_loopex_expression] = STATE(1496),
    [sym_goto_expression] = STATE(1496),
    [sym_return_expression] = STATE(1496),
    [sym_undef_expression] = STATE(1496),
    [sym__listop] = STATE(1496),
    [sym_function_call_expression] = STATE(1543),
    [sym_ambiguous_function_call_expression] = STATE(1543),
    [sym_function] = STATE(399),
    [sym_method_call_expression] = STATE(1543),
    [sym_scalar] = STATE(1496),
    [sym_array] = STATE(1496),
    [sym_hash] = STATE(1496),
    [sym_arraylen] = STATE(1496),
    [sym_glob] = STATE(1496),
    [sym__literal] = STATE(1496),
    [sym_string_literal] = STATE(1510),
    [sym_interpolated_string_literal] = STATE(1510),
    [sym_quoted_word_list] = STATE(1441),
    [sym_command_string] = STATE(1510),
    [sym_quoted_regexp] = STATE(1510),
    [sym_match_regexp] = STATE(1510),
    [sym_substitution_regexp] = STATE(1510),
    [sym_transliteration_expression] = STATE(1510),
    [sym_heredoc_token] = STATE(1496),
    [sym_command_heredoc_token] = STATE(1496),
    [sym_heredoc_content] = STATE(855),
    [sym_autoquoted_bareword] = STATE(1496),
    [sym__fat_comma_autoquoted_bareword] = STATE(1496),
    [sym_bareword] = STATE(1496),
    [sym_primitive] = STATE(1496),
    [sym__identifier] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_sub] = ACTIONS(141),
    [anon_sym_method] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(147),
    [anon_sym_my] = ACTIONS(265),
    [anon_sym_state] = ACTIONS(265),
    [anon_sym_our] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_else] = ACTIONS(139),
    [anon_sym_elsif] = ACTIONS(139),
    [anon_sym_and] = ACTIONS(139),
    [anon_sym_or] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_eq] = ACTIONS(139),
    [anon_sym_ne] = ACTIONS(139),
    [anon_sym_cmp] = ACTIONS(139),
    [anon_sym_lt] = ACTIONS(139),
    [anon_sym_le] = ACTIONS(139),
    [anon_sym_ge] = ACTIONS(139),
    [anon_sym_gt] = ACTIONS(139),
    [anon_sym_isa] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASH] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_eval] = ACTIONS(271),
    [anon_sym_field] = ACTIONS(265),
    [anon_sym_local] = ACTIONS(273),
    [anon_sym_require] = ACTIONS(275),
    [anon_sym_map] = ACTIONS(277),
    [anon_sym_grep] = ACTIONS(277),
    [anon_sym_sort] = ACTIONS(279),
    [anon_sym_goto] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_PERCENT2] = ACTIONS(179),
    [anon_sym_DOLLAR_POUND] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(139),
    [anon_sym_no] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_foreach] = ACTIONS(139),
    [anon_sym_last] = ACTIONS(287),
    [anon_sym_next] = ACTIONS(287),
    [anon_sym_redo] = ACTIONS(287),
    [anon_sym_BEGIN] = ACTIONS(139),
    [anon_sym_INIT] = ACTIONS(139),
    [anon_sym_CHECK] = ACTIONS(139),
    [anon_sym_UNITCHECK] = ACTIONS(139),
    [anon_sym_END] = ACTIONS(139),
    [anon_sym_ADJUST] = ACTIONS(139),
    [anon_sym___FILE__] = ACTIONS(147),
    [anon_sym___LINE__] = ACTIONS(147),
    [anon_sym___PACKAGE__] = ACTIONS(147),
    [anon_sym___SUB__] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_fork] = ACTIONS(147),
    [anon_sym_getppid] = ACTIONS(147),
    [anon_sym_time] = ACTIONS(147),
    [anon_sym_times] = ACTIONS(147),
    [anon_sym_wait] = ACTIONS(147),
    [anon_sym_wantarray] = ACTIONS(147),
    [anon_sym_abs] = ACTIONS(289),
    [anon_sym_alarm] = ACTIONS(289),
    [anon_sym_chop] = ACTIONS(289),
    [anon_sym_chdir] = ACTIONS(289),
    [anon_sym_close] = ACTIONS(289),
    [anon_sym_closedir] = ACTIONS(289),
    [anon_sym_caller] = ACTIONS(289),
    [anon_sym_chomp] = ACTIONS(289),
    [anon_sym_chr] = ACTIONS(289),
    [anon_sym_cos] = ACTIONS(289),
    [anon_sym_chroot] = ACTIONS(289),
    [anon_sym_defined] = ACTIONS(289),
    [anon_sym_delete] = ACTIONS(289),
    [anon_sym_dbmclose] = ACTIONS(289),
    [anon_sym_exists] = ACTIONS(289),
    [anon_sym_exit] = ACTIONS(289),
    [anon_sym_eof] = ACTIONS(289),
    [anon_sym_exp] = ACTIONS(289),
    [anon_sym_each] = ACTIONS(289),
    [anon_sym_fc] = ACTIONS(289),
    [anon_sym_fileno] = ACTIONS(289),
    [anon_sym_gmtime] = ACTIONS(289),
    [anon_sym_getc] = ACTIONS(289),
    [anon_sym_getpgrp] = ACTIONS(289),
    [anon_sym_getprotobyname] = ACTIONS(289),
    [anon_sym_getpwname] = ACTIONS(289),
    [anon_sym_getpwuid] = ACTIONS(289),
    [anon_sym_getpeername] = ACTIONS(289),
    [anon_sym_getnetbyname] = ACTIONS(289),
    [anon_sym_getsockname] = ACTIONS(289),
    [anon_sym_getgrnam] = ACTIONS(289),
    [anon_sym_getgrgid] = ACTIONS(289),
    [anon_sym_hex] = ACTIONS(289),
    [anon_sym_int] = ACTIONS(289),
    [anon_sym_keys] = ACTIONS(289),
    [anon_sym_lc] = ACTIONS(289),
    [anon_sym_lcfirst] = ACTIONS(289),
    [anon_sym_length] = ACTIONS(289),
    [anon_sym_localtime] = ACTIONS(289),
    [anon_sym_log] = ACTIONS(289),
    [anon_sym_lock] = ACTIONS(289),
    [anon_sym_lstat] = ACTIONS(289),
    [anon_sym_oct] = ACTIONS(289),
    [anon_sym_ord] = ACTIONS(289),
    [anon_sym_prototype] = ACTIONS(289),
    [anon_sym_pop] = ACTIONS(289),
    [anon_sym_pos] = ACTIONS(289),
    [anon_sym_quotemeta] = ACTIONS(289),
    [anon_sym_reset] = ACTIONS(289),
    [anon_sym_rand] = ACTIONS(289),
    [anon_sym_rmdir] = ACTIONS(289),
    [anon_sym_readdir] = ACTIONS(289),
    [anon_sym_readline] = ACTIONS(289),
    [anon_sym_readpipe] = ACTIONS(289),
    [anon_sym_rewinddir] = ACTIONS(289),
    [anon_sym_readlink] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(289),
    [anon_sym_scalar] = ACTIONS(289),
    [anon_sym_shift] = ACTIONS(289),
    [anon_sym_sin] = ACTIONS(289),
    [anon_sym_sleep] = ACTIONS(289),
    [anon_sym_sqrt] = ACTIONS(289),
    [anon_sym_srand] = ACTIONS(289),
    [anon_sym_stat] = ACTIONS(289),
    [anon_sym_study] = ACTIONS(289),
    [anon_sym_tell] = ACTIONS(289),
    [anon_sym_telldir] = ACTIONS(289),
    [anon_sym_tied] = ACTIONS(289),
    [anon_sym_uc] = ACTIONS(289),
    [anon_sym_ucfirst] = ACTIONS(289),
    [anon_sym_untie] = ACTIONS(289),
    [anon_sym_umask] = ACTIONS(289),
    [anon_sym_values] = ACTIONS(289),
    [anon_sym_write] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(139),
    [anon_sym___END__] = ACTIONS(139),
    [anon_sym_q] = ACTIONS(187),
    [anon_sym_qq] = ACTIONS(189),
    [anon_sym_qw] = ACTIONS(191),
    [anon_sym_qx] = ACTIONS(193),
    [anon_sym_qr] = ACTIONS(195),
    [anon_sym_m] = ACTIONS(197),
    [anon_sym_s] = ACTIONS(199),
    [anon_sym_tr] = ACTIONS(201),
    [anon_sym_y] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_unless] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_until] = ACTIONS(139),
    [aux_sym__bareword_token1] = ACTIONS(291),
    [sym_number] = ACTIONS(205),
    [sym__apostrophe] = ACTIONS(207),
    [sym__double_quote] = ACTIONS(209),
    [sym__backtick] = ACTIONS(211),
    [sym__search_slash] = ACTIONS(213),
    [sym__PERLY_HEREDOC] = ACTIONS(215),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [856] = {
    [sym__HASHBRACK] = STATE(318),
    [sym__subscripted] = STATE(1160),
    [sym_container_variable] = STATE(3104),
    [sym_array_element_expression] = STATE(1155),
    [sym_hash_element_expression] = STATE(1155),
    [sym_coderef_call_expression] = STATE(1155),
    [sym_anonymous_slice_expression] = STATE(1155),
    [sym_slice_container_variable] = STATE(3112),
    [sym_slice_expression] = STATE(1265),
    [sym_keyval_container_variable] = STATE(3122),
    [sym_keyval_expression] = STATE(1265),
    [sym__term] = STATE(1241),
    [sym_readline_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_preinc_expression] = STATE(1265),
    [sym_postinc_expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_refgen_expression] = STATE(1265),
    [sym_anonymous_array_expression] = STATE(1265),
    [sym_anonymous_hash_expression] = STATE(1265),
    [sym_anonymous_subroutine_expression] = STATE(1265),
    [sym_anonymous_method_expression] = STATE(1265),
    [sym_do_expression] = STATE(1265),
    [sym_eval_expression] = STATE(1265),
    [sym_variable_declaration] = STATE(1265),
    [sym_localization_expression] = STATE(1265),
    [sym_stub_expression] = STATE(1265),
    [sym_scalar_deref_expression] = STATE(1265),
    [sym_array_deref_expression] = STATE(1265),
    [sym_hash_deref_expression] = STATE(1265),
    [sym_amper_deref_expression] = STATE(1265),
    [sym_glob_deref_expression] = STATE(1265),
    [sym_require_expression] = STATE(1265),
    [sym_func0op_call_expression] = STATE(1265),
    [sym_func1op_call_expression] = STATE(1265),
    [sym_map_grep_expression] = STATE(1265),
    [sym_sort_expression] = STATE(1265),
    [sym_loopex_expression] = STATE(1265),
    [sym_goto_expression] = STATE(1265),
    [sym_return_expression] = STATE(1265),
    [sym_undef_expression] = STATE(1265),
    [sym__listop] = STATE(1265),
    [sym_function_call_expression] = STATE(1266),
    [sym_ambiguous_function_call_expression] = STATE(1266),
    [sym_function] = STATE(317),
    [sym_method_call_expression] = STATE(1266),
    [sym_scalar] = STATE(1265),
    [sym_array] = STATE(1265),
    [sym_hash] = STATE(1265),
    [sym_arraylen] = STATE(1265),
    [sym_glob] = STATE(1265),
    [sym__literal] = STATE(1265),
    [sym_string_literal] = STATE(1268),
    [sym_interpolated_string_literal] = STATE(1268),
    [sym_quoted_word_list] = STATE(1230),
    [sym_command_string] = STATE(1268),
    [sym_quoted_regexp] = STATE(1268),
    [sym_match_regexp] = STATE(1268),
    [sym_substitution_regexp] = STATE(1268),
    [sym_transliteration_expression] = STATE(1268),
    [sym_heredoc_token] = STATE(1265),
    [sym_command_heredoc_token] = STATE(1265),
    [sym_heredoc_content] = STATE(856),
    [sym_autoquoted_bareword] = STATE(1265),
    [sym__fat_comma_autoquoted_bareword] = STATE(1265),
    [sym_bareword] = STATE(1265),
    [sym_primitive] = STATE(1265),
    [sym__identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(39),
    [anon_sym_sub] = ACTIONS(221),
    [anon_sym_method] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_my] = ACTIONS(31),
    [anon_sym_state] = ACTIONS(31),
    [anon_sym_our] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_else] = ACTIONS(39),
    [anon_sym_elsif] = ACTIONS(39),
    [anon_sym_and] = ACTIONS(39),
    [anon_sym_or] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_AT] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(47),
    [anon_sym_LT_LT] = ACTIONS(49),
    [anon_sym_SLASH_SLASH] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(57),
    [anon_sym_eq] = ACTIONS(39),
    [anon_sym_ne] = ACTIONS(39),
    [anon_sym_cmp] = ACTIONS(39),
    [anon_sym_lt] = ACTIONS(39),
    [anon_sym_le] = ACTIONS(39),
    [anon_sym_ge] = ACTIONS(39),
    [anon_sym_gt] = ACTIONS(39),
    [anon_sym_isa] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(63),
    [anon_sym_eval] = ACTIONS(65),
    [anon_sym_field] = ACTIONS(31),
    [anon_sym_local] = ACTIONS(67),
    [anon_sym_require] = ACTIONS(69),
    [anon_sym_map] = ACTIONS(71),
    [anon_sym_grep] = ACTIONS(71),
    [anon_sym_sort] = ACTIONS(73),
    [anon_sym_goto] = ACTIONS(75),
    [anon_sym_return] = ACTIONS(77),
    [anon_sym_undef] = ACTIONS(79),
    [anon_sym_PERCENT2] = ACTIONS(81),
    [anon_sym_DOLLAR_POUND] = ACTIONS(83),
    [anon_sym_use] = ACTIONS(39),
    [anon_sym_no] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_foreach] = ACTIONS(39),
    [anon_sym_last] = ACTIONS(89),
    [anon_sym_next] = ACTIONS(89),
    [anon_sym_redo] = ACTIONS(89),
    [anon_sym_BEGIN] = ACTIONS(39),
    [anon_sym_INIT] = ACTIONS(39),
    [anon_sym_CHECK] = ACTIONS(39),
    [anon_sym_UNITCHECK] = ACTIONS(39),
    [anon_sym_END] = ACTIONS(39),
    [anon_sym_ADJUST] = ACTIONS(39),
    [anon_sym___FILE__] = ACTIONS(29),
    [anon_sym___LINE__] = ACTIONS(29),
    [anon_sym___PACKAGE__] = ACTIONS(29),
    [anon_sym___SUB__] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_fork] = ACTIONS(29),
    [anon_sym_getppid] = ACTIONS(29),
    [anon_sym_time] = ACTIONS(29),
    [anon_sym_times] = ACTIONS(29),
    [anon_sym_wait] = ACTIONS(29),
    [anon_sym_wantarray] = ACTIONS(29),
    [anon_sym_abs] = ACTIONS(93),
    [anon_sym_alarm] = ACTIONS(93),
    [anon_sym_chop] = ACTIONS(93),
    [anon_sym_chdir] = ACTIONS(93),
    [anon_sym_close] = ACTIONS(93),
    [anon_sym_closedir] = ACTIONS(93),
    [anon_sym_caller] = ACTIONS(93),
    [anon_sym_chomp] = ACTIONS(93),
    [anon_sym_chr] = ACTIONS(93),
    [anon_sym_cos] = ACTIONS(93),
    [anon_sym_chroot] = ACTIONS(93),
    [anon_sym_defined] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(93),
    [anon_sym_dbmclose] = ACTIONS(93),
    [anon_sym_exists] = ACTIONS(93),
    [anon_sym_exit] = ACTIONS(93),
    [anon_sym_eof] = ACTIONS(93),
    [anon_sym_exp] = ACTIONS(93),
    [anon_sym_each] = ACTIONS(93),
    [anon_sym_fc] = ACTIONS(93),
    [anon_sym_fileno] = ACTIONS(93),
    [anon_sym_gmtime] = ACTIONS(93),
    [anon_sym_getc] = ACTIONS(93),
    [anon_sym_getpgrp] = ACTIONS(93),
    [anon_sym_getprotobyname] = ACTIONS(93),
    [anon_sym_getpwname] = ACTIONS(93),
    [anon_sym_getpwuid] = ACTIONS(93),
    [anon_sym_getpeername] = ACTIONS(93),
    [anon_sym_getnetbyname] = ACTIONS(93),
    [anon_sym_getsockname] = ACTIONS(93),
    [anon_sym_getgrnam] = ACTIONS(93),
    [anon_sym_getgrgid] = ACTIONS(93),
    [anon_sym_hex] = ACTIONS(93),
    [anon_sym_int] = ACTIONS(93),
    [anon_sym_keys] = ACTIONS(93),
    [anon_sym_lc] = ACTIONS(93),
    [anon_sym_lcfirst] = ACTIONS(93),
    [anon_sym_length] = ACTIONS(93),
    [anon_sym_localtime] = ACTIONS(93),
    [anon_sym_log] = ACTIONS(93),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_lstat] = ACTIONS(93),
    [anon_sym_oct] = ACTIONS(93),
    [anon_sym_ord] = ACTIONS(93),
    [anon_sym_prototype] = ACTIONS(93),
    [anon_sym_pop] = ACTIONS(93),
    [anon_sym_pos] = ACTIONS(93),
    [anon_sym_quotemeta] = ACTIONS(93),
    [anon_sym_reset] = ACTIONS(93),
    [anon_sym_rand] = ACTIONS(93),
    [anon_sym_rmdir] = ACTIONS(93),
    [anon_sym_readdir] = ACTIONS(93),
    [anon_sym_readline] = ACTIONS(93),
    [anon_sym_readpipe] = ACTIONS(93),
    [anon_sym_rewinddir] = ACTIONS(93),
    [anon_sym_readlink] = ACTIONS(93),
    [anon_sym_ref] = ACTIONS(93),
    [anon_sym_scalar] = ACTIONS(93),
    [anon_sym_shift] = ACTIONS(93),
    [anon_sym_sin] = ACTIONS(93),
    [anon_sym_sleep] = ACTIONS(93),
    [anon_sym_sqrt] = ACTIONS(93),
    [anon_sym_srand] = ACTIONS(93),
    [anon_sym_stat] = ACTIONS(93),
    [anon_sym_study] = ACTIONS(93),
    [anon_sym_tell] = ACTIONS(93),
    [anon_sym_telldir] = ACTIONS(93),
    [anon_sym_tied] = ACTIONS(93),
    [anon_sym_uc] = ACTIONS(93),
    [anon_sym_ucfirst] = ACTIONS(93),
    [anon_sym_untie] = ACTIONS(93),
    [anon_sym_umask] = ACTIONS(93),
    [anon_sym_values] = ACTIONS(93),
    [anon_sym_write] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(39),
    [anon_sym___END__] = ACTIONS(39),
    [anon_sym_q] = ACTIONS(99),
    [anon_sym_qq] = ACTIONS(101),
    [anon_sym_qw] = ACTIONS(103),
    [anon_sym_qx] = ACTIONS(105),
    [anon_sym_qr] = ACTIONS(107),
    [anon_sym_m] = ACTIONS(109),
    [anon_sym_s] = ACTIONS(111),
    [anon_sym_tr] = ACTIONS(113),
    [anon_sym_y] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_unless] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_until] = ACTIONS(39),
    [aux_sym__bareword_token1] = ACTIONS(119),
    [sym_number] = ACTIONS(121),
    [sym__apostrophe] = ACTIONS(123),
    [sym__double_quote] = ACTIONS(125),
    [sym__backtick] = ACTIONS(127),
    [sym__search_slash] = ACTIONS(129),
    [sym__PERLY_HEREDOC] = ACTIONS(131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [857] = {
    [sym_heredoc_content] = STATE(857),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [858] = {
    [sym_heredoc_content] = STATE(858),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [859] = {
    [sym_heredoc_content] = STATE(859),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [860] = {
    [sym_heredoc_content] = STATE(860),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [861] = {
    [sym_heredoc_content] = STATE(861),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [862] = {
    [sym_heredoc_content] = STATE(862),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [863] = {
    [sym_heredoc_content] = STATE(863),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [864] = {
    [sym_heredoc_content] = STATE(864),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [865] = {
    [sym_heredoc_content] = STATE(865),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [866] = {
    [sym_heredoc_content] = STATE(866),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [867] = {
    [sym_heredoc_content] = STATE(867),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [868] = {
    [sym_heredoc_content] = STATE(868),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [869] = {
    [sym_heredoc_content] = STATE(869),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [870] = {
    [sym_heredoc_content] = STATE(870),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [871] = {
    [sym_heredoc_content] = STATE(871),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [872] = {
    [sym_heredoc_content] = STATE(872),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [873] = {
    [sym_heredoc_content] = STATE(873),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [874] = {
    [sym_heredoc_content] = STATE(874),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [875] = {
    [sym_heredoc_content] = STATE(875),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [876] = {
    [sym_heredoc_content] = STATE(876),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [877] = {
    [sym_heredoc_content] = STATE(877),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [878] = {
    [sym_heredoc_content] = STATE(878),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [879] = {
    [sym_heredoc_content] = STATE(879),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2872),
    [anon_sym_or] = ACTIONS(2872),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2872),
    [anon_sym_GT] = ACTIONS(2872),
    [anon_sym_LT_LT] = ACTIONS(2872),
    [anon_sym_EQ] = ACTIONS(2872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2872),
    [anon_sym_PLUS_EQ] = ACTIONS(2872),
    [anon_sym_DASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_EQ] = ACTIONS(2872),
    [anon_sym_STAR_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_PERCENT_EQ] = ACTIONS(2872),
    [anon_sym_x_EQ] = ACTIONS(2872),
    [anon_sym_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_CARET_EQ] = ACTIONS(2872),
    [anon_sym_LT_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_GT_EQ] = ACTIONS(2872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [anon_sym_STAR_STAR] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH] = ACTIONS(2872),
    [anon_sym_AMP_AMP] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(2872),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_GT_GT2] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_DOT] = ACTIONS(2872),
    [anon_sym_STAR] = ACTIONS(2872),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_x] = ACTIONS(2872),
    [anon_sym_EQ_TILDE] = ACTIONS(2872),
    [anon_sym_BANG_TILDE] = ACTIONS(2872),
    [anon_sym_EQ_EQ] = ACTIONS(2872),
    [anon_sym_BANG_EQ] = ACTIONS(2872),
    [anon_sym_eq] = ACTIONS(2872),
    [anon_sym_ne] = ACTIONS(2872),
    [anon_sym_LT_EQ_GT] = ACTIONS(2872),
    [anon_sym_cmp] = ACTIONS(2872),
    [anon_sym_TILDE_TILDE] = ACTIONS(2872),
    [anon_sym_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_EQ] = ACTIONS(2872),
    [anon_sym_lt] = ACTIONS(2872),
    [anon_sym_le] = ACTIONS(2872),
    [anon_sym_ge] = ACTIONS(2872),
    [anon_sym_gt] = ACTIONS(2872),
    [anon_sym_isa] = ACTIONS(2872),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2872),
    [anon_sym_DASH_DASH] = ACTIONS(2872),
    [anon_sym_QMARK] = ACTIONS(2872),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2872),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2872),
    [anon_sym_foreach] = ACTIONS(2872),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2872),
    [anon_sym___END__] = ACTIONS(2872),
    [anon_sym_EOT] = ACTIONS(2872),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2872),
    [anon_sym_unless] = ACTIONS(2872),
    [anon_sym_while] = ACTIONS(2872),
    [anon_sym_until] = ACTIONS(2872),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2883),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2883),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [880] = {
    [sym_heredoc_content] = STATE(880),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [881] = {
    [sym_heredoc_content] = STATE(881),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [882] = {
    [sym_heredoc_content] = STATE(882),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2872),
    [anon_sym_or] = ACTIONS(2872),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2872),
    [anon_sym_DASH_GT] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2872),
    [anon_sym_GT] = ACTIONS(2872),
    [anon_sym_LT_LT] = ACTIONS(2872),
    [anon_sym_EQ] = ACTIONS(2872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2872),
    [anon_sym_PLUS_EQ] = ACTIONS(2872),
    [anon_sym_DASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_EQ] = ACTIONS(2872),
    [anon_sym_STAR_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_PERCENT_EQ] = ACTIONS(2872),
    [anon_sym_x_EQ] = ACTIONS(2872),
    [anon_sym_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_CARET_EQ] = ACTIONS(2872),
    [anon_sym_LT_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_GT_EQ] = ACTIONS(2872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [anon_sym_STAR_STAR] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH] = ACTIONS(2872),
    [anon_sym_AMP_AMP] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(2872),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_GT_GT2] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_DOT] = ACTIONS(2872),
    [anon_sym_STAR] = ACTIONS(2872),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_x] = ACTIONS(2872),
    [anon_sym_EQ_TILDE] = ACTIONS(2872),
    [anon_sym_BANG_TILDE] = ACTIONS(2872),
    [anon_sym_EQ_EQ] = ACTIONS(2872),
    [anon_sym_BANG_EQ] = ACTIONS(2872),
    [anon_sym_eq] = ACTIONS(2872),
    [anon_sym_ne] = ACTIONS(2872),
    [anon_sym_LT_EQ_GT] = ACTIONS(2872),
    [anon_sym_cmp] = ACTIONS(2872),
    [anon_sym_TILDE_TILDE] = ACTIONS(2872),
    [anon_sym_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_EQ] = ACTIONS(2872),
    [anon_sym_lt] = ACTIONS(2872),
    [anon_sym_le] = ACTIONS(2872),
    [anon_sym_ge] = ACTIONS(2872),
    [anon_sym_gt] = ACTIONS(2872),
    [anon_sym_isa] = ACTIONS(2872),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2872),
    [anon_sym_DASH_DASH] = ACTIONS(2872),
    [anon_sym_QMARK] = ACTIONS(2872),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2872),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [883] = {
    [sym_heredoc_content] = STATE(883),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [884] = {
    [sym_heredoc_content] = STATE(884),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [885] = {
    [sym_heredoc_content] = STATE(885),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [886] = {
    [sym_heredoc_content] = STATE(886),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [887] = {
    [sym_heredoc_content] = STATE(887),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [888] = {
    [sym_heredoc_content] = STATE(888),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [889] = {
    [sym_heredoc_content] = STATE(889),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [890] = {
    [sym_heredoc_content] = STATE(890),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(2874),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2874),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [891] = {
    [sym_heredoc_content] = STATE(891),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [892] = {
    [sym_heredoc_content] = STATE(892),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2872),
    [anon_sym_or] = ACTIONS(2872),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2872),
    [anon_sym_GT] = ACTIONS(2872),
    [anon_sym_LT_LT] = ACTIONS(2872),
    [anon_sym_EQ] = ACTIONS(2872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2872),
    [anon_sym_PLUS_EQ] = ACTIONS(2872),
    [anon_sym_DASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_EQ] = ACTIONS(2872),
    [anon_sym_STAR_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_PERCENT_EQ] = ACTIONS(2872),
    [anon_sym_x_EQ] = ACTIONS(2872),
    [anon_sym_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_CARET_EQ] = ACTIONS(2872),
    [anon_sym_LT_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_GT_EQ] = ACTIONS(2872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [anon_sym_STAR_STAR] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH] = ACTIONS(2872),
    [anon_sym_AMP_AMP] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(2872),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_GT_GT2] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_DOT] = ACTIONS(2872),
    [anon_sym_STAR] = ACTIONS(2872),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_x] = ACTIONS(2872),
    [anon_sym_EQ_TILDE] = ACTIONS(2872),
    [anon_sym_BANG_TILDE] = ACTIONS(2872),
    [anon_sym_EQ_EQ] = ACTIONS(2872),
    [anon_sym_BANG_EQ] = ACTIONS(2872),
    [anon_sym_eq] = ACTIONS(2872),
    [anon_sym_ne] = ACTIONS(2872),
    [anon_sym_LT_EQ_GT] = ACTIONS(2872),
    [anon_sym_cmp] = ACTIONS(2872),
    [anon_sym_TILDE_TILDE] = ACTIONS(2872),
    [anon_sym_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_EQ] = ACTIONS(2872),
    [anon_sym_lt] = ACTIONS(2872),
    [anon_sym_le] = ACTIONS(2872),
    [anon_sym_ge] = ACTIONS(2872),
    [anon_sym_gt] = ACTIONS(2872),
    [anon_sym_isa] = ACTIONS(2872),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2872),
    [anon_sym_DASH_DASH] = ACTIONS(2872),
    [anon_sym_QMARK] = ACTIONS(2872),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2872),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2872),
    [anon_sym___END__] = ACTIONS(2872),
    [anon_sym_EOT] = ACTIONS(2872),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2883),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2883),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [893] = {
    [sym_heredoc_content] = STATE(893),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [894] = {
    [sym_heredoc_content] = STATE(894),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [895] = {
    [sym_heredoc_content] = STATE(895),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [896] = {
    [sym_heredoc_content] = STATE(896),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [897] = {
    [sym_heredoc_content] = STATE(897),
    [sym__identifier] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_sub] = ACTIONS(2885),
    [anon_sym_method] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_my] = ACTIONS(2885),
    [anon_sym_state] = ACTIONS(2885),
    [anon_sym_our] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_elsif] = ACTIONS(2885),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_RBRACK] = ACTIONS(2885),
    [anon_sym_DASH_GT] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_DOT_EQ] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_x_EQ] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_GT_GT2] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_x] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_eq] = ACTIONS(2885),
    [anon_sym_ne] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_cmp] = ACTIONS(2885),
    [anon_sym_TILDE_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_lt] = ACTIONS(2885),
    [anon_sym_le] = ACTIONS(2885),
    [anon_sym_ge] = ACTIONS(2885),
    [anon_sym_gt] = ACTIONS(2885),
    [anon_sym_isa] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BSLASH] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_eval] = ACTIONS(2885),
    [anon_sym_field] = ACTIONS(2885),
    [anon_sym_local] = ACTIONS(2885),
    [anon_sym_require] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(2885),
    [anon_sym_grep] = ACTIONS(2885),
    [anon_sym_sort] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_undef] = ACTIONS(2885),
    [anon_sym_PERCENT2] = ACTIONS(2885),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2885),
    [anon_sym_no] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_foreach] = ACTIONS(2885),
    [anon_sym_last] = ACTIONS(2885),
    [anon_sym_next] = ACTIONS(2885),
    [anon_sym_redo] = ACTIONS(2885),
    [anon_sym_BEGIN] = ACTIONS(2885),
    [anon_sym_INIT] = ACTIONS(2885),
    [anon_sym_CHECK] = ACTIONS(2885),
    [anon_sym_UNITCHECK] = ACTIONS(2885),
    [anon_sym_END] = ACTIONS(2885),
    [anon_sym_ADJUST] = ACTIONS(2885),
    [anon_sym___FILE__] = ACTIONS(2885),
    [anon_sym___LINE__] = ACTIONS(2885),
    [anon_sym___PACKAGE__] = ACTIONS(2885),
    [anon_sym___SUB__] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_fork] = ACTIONS(2885),
    [anon_sym_getppid] = ACTIONS(2885),
    [anon_sym_time] = ACTIONS(2885),
    [anon_sym_times] = ACTIONS(2885),
    [anon_sym_wait] = ACTIONS(2885),
    [anon_sym_wantarray] = ACTIONS(2885),
    [anon_sym_abs] = ACTIONS(2885),
    [anon_sym_alarm] = ACTIONS(2885),
    [anon_sym_chop] = ACTIONS(2885),
    [anon_sym_chdir] = ACTIONS(2885),
    [anon_sym_close] = ACTIONS(2885),
    [anon_sym_closedir] = ACTIONS(2885),
    [anon_sym_caller] = ACTIONS(2885),
    [anon_sym_chomp] = ACTIONS(2885),
    [anon_sym_chr] = ACTIONS(2885),
    [anon_sym_cos] = ACTIONS(2885),
    [anon_sym_chroot] = ACTIONS(2885),
    [anon_sym_defined] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_dbmclose] = ACTIONS(2885),
    [anon_sym_exists] = ACTIONS(2885),
    [anon_sym_exit] = ACTIONS(2885),
    [anon_sym_eof] = ACTIONS(2885),
    [anon_sym_exp] = ACTIONS(2885),
    [anon_sym_each] = ACTIONS(2885),
    [anon_sym_fc] = ACTIONS(2885),
    [anon_sym_fileno] = ACTIONS(2885),
    [anon_sym_gmtime] = ACTIONS(2885),
    [anon_sym_getc] = ACTIONS(2885),
    [anon_sym_getpgrp] = ACTIONS(2885),
    [anon_sym_getprotobyname] = ACTIONS(2885),
    [anon_sym_getpwname] = ACTIONS(2885),
    [anon_sym_getpwuid] = ACTIONS(2885),
    [anon_sym_getpeername] = ACTIONS(2885),
    [anon_sym_getnetbyname] = ACTIONS(2885),
    [anon_sym_getsockname] = ACTIONS(2885),
    [anon_sym_getgrnam] = ACTIONS(2885),
    [anon_sym_getgrgid] = ACTIONS(2885),
    [anon_sym_hex] = ACTIONS(2885),
    [anon_sym_int] = ACTIONS(2885),
    [anon_sym_keys] = ACTIONS(2885),
    [anon_sym_lc] = ACTIONS(2885),
    [anon_sym_lcfirst] = ACTIONS(2885),
    [anon_sym_length] = ACTIONS(2885),
    [anon_sym_localtime] = ACTIONS(2885),
    [anon_sym_log] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_lstat] = ACTIONS(2885),
    [anon_sym_oct] = ACTIONS(2885),
    [anon_sym_ord] = ACTIONS(2885),
    [anon_sym_prototype] = ACTIONS(2885),
    [anon_sym_pop] = ACTIONS(2885),
    [anon_sym_pos] = ACTIONS(2885),
    [anon_sym_quotemeta] = ACTIONS(2885),
    [anon_sym_reset] = ACTIONS(2885),
    [anon_sym_rand] = ACTIONS(2885),
    [anon_sym_rmdir] = ACTIONS(2885),
    [anon_sym_readdir] = ACTIONS(2885),
    [anon_sym_readline] = ACTIONS(2885),
    [anon_sym_readpipe] = ACTIONS(2885),
    [anon_sym_rewinddir] = ACTIONS(2885),
    [anon_sym_readlink] = ACTIONS(2885),
    [anon_sym_ref] = ACTIONS(2885),
    [anon_sym_scalar] = ACTIONS(2885),
    [anon_sym_shift] = ACTIONS(2885),
    [anon_sym_sin] = ACTIONS(2885),
    [anon_sym_sleep] = ACTIONS(2885),
    [anon_sym_sqrt] = ACTIONS(2885),
    [anon_sym_srand] = ACTIONS(2885),
    [anon_sym_stat] = ACTIONS(2885),
    [anon_sym_study] = ACTIONS(2885),
    [anon_sym_tell] = ACTIONS(2885),
    [anon_sym_telldir] = ACTIONS(2885),
    [anon_sym_tied] = ACTIONS(2885),
    [anon_sym_uc] = ACTIONS(2885),
    [anon_sym_ucfirst] = ACTIONS(2885),
    [anon_sym_untie] = ACTIONS(2885),
    [anon_sym_umask] = ACTIONS(2885),
    [anon_sym_values] = ACTIONS(2885),
    [anon_sym_write] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2885),
    [anon_sym___END__] = ACTIONS(2885),
    [anon_sym_q] = ACTIONS(2885),
    [anon_sym_qq] = ACTIONS(2885),
    [anon_sym_qw] = ACTIONS(2885),
    [anon_sym_qx] = ACTIONS(2885),
    [anon_sym_qr] = ACTIONS(2885),
    [anon_sym_m] = ACTIONS(2885),
    [anon_sym_s] = ACTIONS(2885),
    [anon_sym_tr] = ACTIONS(2885),
    [anon_sym_y] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [aux_sym__bareword_token1] = ACTIONS(2885),
    [sym_number] = ACTIONS(2885),
    [sym__apostrophe] = ACTIONS(2887),
    [sym__double_quote] = ACTIONS(2887),
    [sym__backtick] = ACTIONS(2887),
    [sym__search_slash] = ACTIONS(2887),
    [sym__PERLY_HEREDOC] = ACTIONS(2887),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [898] = {
    [sym_heredoc_content] = STATE(898),
    [sym__identifier] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_sub] = ACTIONS(2889),
    [anon_sym_method] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_my] = ACTIONS(2889),
    [anon_sym_state] = ACTIONS(2889),
    [anon_sym_our] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2889),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_elsif] = ACTIONS(2889),
    [anon_sym_and] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2889),
    [anon_sym_RBRACK] = ACTIONS(2889),
    [anon_sym_DASH_GT] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2889),
    [anon_sym_PLUS_EQ] = ACTIONS(2889),
    [anon_sym_DASH_EQ] = ACTIONS(2889),
    [anon_sym_DOT_EQ] = ACTIONS(2889),
    [anon_sym_STAR_EQ] = ACTIONS(2889),
    [anon_sym_SLASH_EQ] = ACTIONS(2889),
    [anon_sym_PERCENT_EQ] = ACTIONS(2889),
    [anon_sym_x_EQ] = ACTIONS(2889),
    [anon_sym_AMP_EQ] = ACTIONS(2889),
    [anon_sym_PIPE_EQ] = ACTIONS(2889),
    [anon_sym_CARET_EQ] = ACTIONS(2889),
    [anon_sym_LT_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_GT_EQ] = ACTIONS(2889),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT] = ACTIONS(2889),
    [anon_sym_STAR_STAR] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_GT_GT2] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_x] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2889),
    [anon_sym_BANG_TILDE] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2889),
    [anon_sym_eq] = ACTIONS(2889),
    [anon_sym_ne] = ACTIONS(2889),
    [anon_sym_LT_EQ_GT] = ACTIONS(2889),
    [anon_sym_cmp] = ACTIONS(2889),
    [anon_sym_TILDE_TILDE] = ACTIONS(2889),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2889),
    [anon_sym_lt] = ACTIONS(2889),
    [anon_sym_le] = ACTIONS(2889),
    [anon_sym_ge] = ACTIONS(2889),
    [anon_sym_gt] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BSLASH] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_eval] = ACTIONS(2889),
    [anon_sym_field] = ACTIONS(2889),
    [anon_sym_local] = ACTIONS(2889),
    [anon_sym_require] = ACTIONS(2889),
    [anon_sym_map] = ACTIONS(2889),
    [anon_sym_grep] = ACTIONS(2889),
    [anon_sym_sort] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_undef] = ACTIONS(2889),
    [anon_sym_PERCENT2] = ACTIONS(2889),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2889),
    [anon_sym_EQ_GT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2889),
    [anon_sym_no] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_foreach] = ACTIONS(2889),
    [anon_sym_last] = ACTIONS(2889),
    [anon_sym_next] = ACTIONS(2889),
    [anon_sym_redo] = ACTIONS(2889),
    [anon_sym_BEGIN] = ACTIONS(2889),
    [anon_sym_INIT] = ACTIONS(2889),
    [anon_sym_CHECK] = ACTIONS(2889),
    [anon_sym_UNITCHECK] = ACTIONS(2889),
    [anon_sym_END] = ACTIONS(2889),
    [anon_sym_ADJUST] = ACTIONS(2889),
    [anon_sym___FILE__] = ACTIONS(2889),
    [anon_sym___LINE__] = ACTIONS(2889),
    [anon_sym___PACKAGE__] = ACTIONS(2889),
    [anon_sym___SUB__] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_fork] = ACTIONS(2889),
    [anon_sym_getppid] = ACTIONS(2889),
    [anon_sym_time] = ACTIONS(2889),
    [anon_sym_times] = ACTIONS(2889),
    [anon_sym_wait] = ACTIONS(2889),
    [anon_sym_wantarray] = ACTIONS(2889),
    [anon_sym_abs] = ACTIONS(2889),
    [anon_sym_alarm] = ACTIONS(2889),
    [anon_sym_chop] = ACTIONS(2889),
    [anon_sym_chdir] = ACTIONS(2889),
    [anon_sym_close] = ACTIONS(2889),
    [anon_sym_closedir] = ACTIONS(2889),
    [anon_sym_caller] = ACTIONS(2889),
    [anon_sym_chomp] = ACTIONS(2889),
    [anon_sym_chr] = ACTIONS(2889),
    [anon_sym_cos] = ACTIONS(2889),
    [anon_sym_chroot] = ACTIONS(2889),
    [anon_sym_defined] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_dbmclose] = ACTIONS(2889),
    [anon_sym_exists] = ACTIONS(2889),
    [anon_sym_exit] = ACTIONS(2889),
    [anon_sym_eof] = ACTIONS(2889),
    [anon_sym_exp] = ACTIONS(2889),
    [anon_sym_each] = ACTIONS(2889),
    [anon_sym_fc] = ACTIONS(2889),
    [anon_sym_fileno] = ACTIONS(2889),
    [anon_sym_gmtime] = ACTIONS(2889),
    [anon_sym_getc] = ACTIONS(2889),
    [anon_sym_getpgrp] = ACTIONS(2889),
    [anon_sym_getprotobyname] = ACTIONS(2889),
    [anon_sym_getpwname] = ACTIONS(2889),
    [anon_sym_getpwuid] = ACTIONS(2889),
    [anon_sym_getpeername] = ACTIONS(2889),
    [anon_sym_getnetbyname] = ACTIONS(2889),
    [anon_sym_getsockname] = ACTIONS(2889),
    [anon_sym_getgrnam] = ACTIONS(2889),
    [anon_sym_getgrgid] = ACTIONS(2889),
    [anon_sym_hex] = ACTIONS(2889),
    [anon_sym_int] = ACTIONS(2889),
    [anon_sym_keys] = ACTIONS(2889),
    [anon_sym_lc] = ACTIONS(2889),
    [anon_sym_lcfirst] = ACTIONS(2889),
    [anon_sym_length] = ACTIONS(2889),
    [anon_sym_localtime] = ACTIONS(2889),
    [anon_sym_log] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_lstat] = ACTIONS(2889),
    [anon_sym_oct] = ACTIONS(2889),
    [anon_sym_ord] = ACTIONS(2889),
    [anon_sym_prototype] = ACTIONS(2889),
    [anon_sym_pop] = ACTIONS(2889),
    [anon_sym_pos] = ACTIONS(2889),
    [anon_sym_quotemeta] = ACTIONS(2889),
    [anon_sym_reset] = ACTIONS(2889),
    [anon_sym_rand] = ACTIONS(2889),
    [anon_sym_rmdir] = ACTIONS(2889),
    [anon_sym_readdir] = ACTIONS(2889),
    [anon_sym_readline] = ACTIONS(2889),
    [anon_sym_readpipe] = ACTIONS(2889),
    [anon_sym_rewinddir] = ACTIONS(2889),
    [anon_sym_readlink] = ACTIONS(2889),
    [anon_sym_ref] = ACTIONS(2889),
    [anon_sym_scalar] = ACTIONS(2889),
    [anon_sym_shift] = ACTIONS(2889),
    [anon_sym_sin] = ACTIONS(2889),
    [anon_sym_sleep] = ACTIONS(2889),
    [anon_sym_sqrt] = ACTIONS(2889),
    [anon_sym_srand] = ACTIONS(2889),
    [anon_sym_stat] = ACTIONS(2889),
    [anon_sym_study] = ACTIONS(2889),
    [anon_sym_tell] = ACTIONS(2889),
    [anon_sym_telldir] = ACTIONS(2889),
    [anon_sym_tied] = ACTIONS(2889),
    [anon_sym_uc] = ACTIONS(2889),
    [anon_sym_ucfirst] = ACTIONS(2889),
    [anon_sym_untie] = ACTIONS(2889),
    [anon_sym_umask] = ACTIONS(2889),
    [anon_sym_values] = ACTIONS(2889),
    [anon_sym_write] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2889),
    [anon_sym___END__] = ACTIONS(2889),
    [anon_sym_q] = ACTIONS(2889),
    [anon_sym_qq] = ACTIONS(2889),
    [anon_sym_qw] = ACTIONS(2889),
    [anon_sym_qx] = ACTIONS(2889),
    [anon_sym_qr] = ACTIONS(2889),
    [anon_sym_m] = ACTIONS(2889),
    [anon_sym_s] = ACTIONS(2889),
    [anon_sym_tr] = ACTIONS(2889),
    [anon_sym_y] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_unless] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_until] = ACTIONS(2889),
    [aux_sym__bareword_token1] = ACTIONS(2889),
    [sym_number] = ACTIONS(2889),
    [sym__apostrophe] = ACTIONS(2891),
    [sym__double_quote] = ACTIONS(2891),
    [sym__backtick] = ACTIONS(2891),
    [sym__search_slash] = ACTIONS(2891),
    [sym__PERLY_HEREDOC] = ACTIONS(2891),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [899] = {
    [sym_heredoc_content] = STATE(899),
    [sym__identifier] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_sub] = ACTIONS(2893),
    [anon_sym_method] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_RPAREN] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_my] = ACTIONS(2893),
    [anon_sym_state] = ACTIONS(2893),
    [anon_sym_our] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_elsif] = ACTIONS(2893),
    [anon_sym_and] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_RBRACK] = ACTIONS(2893),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2893),
    [anon_sym_PLUS_EQ] = ACTIONS(2893),
    [anon_sym_DASH_EQ] = ACTIONS(2893),
    [anon_sym_DOT_EQ] = ACTIONS(2893),
    [anon_sym_STAR_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_PERCENT_EQ] = ACTIONS(2893),
    [anon_sym_x_EQ] = ACTIONS(2893),
    [anon_sym_AMP_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_CARET_EQ] = ACTIONS(2893),
    [anon_sym_LT_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_DOT_DOT] = ACTIONS(2893),
    [anon_sym_STAR_STAR] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_GT_GT2] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_x] = ACTIONS(2893),
    [anon_sym_EQ_TILDE] = ACTIONS(2893),
    [anon_sym_BANG_TILDE] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_eq] = ACTIONS(2893),
    [anon_sym_ne] = ACTIONS(2893),
    [anon_sym_LT_EQ_GT] = ACTIONS(2893),
    [anon_sym_cmp] = ACTIONS(2893),
    [anon_sym_TILDE_TILDE] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_lt] = ACTIONS(2893),
    [anon_sym_le] = ACTIONS(2893),
    [anon_sym_ge] = ACTIONS(2893),
    [anon_sym_gt] = ACTIONS(2893),
    [anon_sym_isa] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BSLASH] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_eval] = ACTIONS(2893),
    [anon_sym_field] = ACTIONS(2893),
    [anon_sym_local] = ACTIONS(2893),
    [anon_sym_require] = ACTIONS(2893),
    [anon_sym_map] = ACTIONS(2893),
    [anon_sym_grep] = ACTIONS(2893),
    [anon_sym_sort] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_undef] = ACTIONS(2893),
    [anon_sym_PERCENT2] = ACTIONS(2893),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2893),
    [anon_sym_EQ_GT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2893),
    [anon_sym_no] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_foreach] = ACTIONS(2893),
    [anon_sym_last] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2893),
    [anon_sym_redo] = ACTIONS(2893),
    [anon_sym_BEGIN] = ACTIONS(2893),
    [anon_sym_INIT] = ACTIONS(2893),
    [anon_sym_CHECK] = ACTIONS(2893),
    [anon_sym_UNITCHECK] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2893),
    [anon_sym_ADJUST] = ACTIONS(2893),
    [anon_sym___FILE__] = ACTIONS(2893),
    [anon_sym___LINE__] = ACTIONS(2893),
    [anon_sym___PACKAGE__] = ACTIONS(2893),
    [anon_sym___SUB__] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_fork] = ACTIONS(2893),
    [anon_sym_getppid] = ACTIONS(2893),
    [anon_sym_time] = ACTIONS(2893),
    [anon_sym_times] = ACTIONS(2893),
    [anon_sym_wait] = ACTIONS(2893),
    [anon_sym_wantarray] = ACTIONS(2893),
    [anon_sym_abs] = ACTIONS(2893),
    [anon_sym_alarm] = ACTIONS(2893),
    [anon_sym_chop] = ACTIONS(2893),
    [anon_sym_chdir] = ACTIONS(2893),
    [anon_sym_close] = ACTIONS(2893),
    [anon_sym_closedir] = ACTIONS(2893),
    [anon_sym_caller] = ACTIONS(2893),
    [anon_sym_chomp] = ACTIONS(2893),
    [anon_sym_chr] = ACTIONS(2893),
    [anon_sym_cos] = ACTIONS(2893),
    [anon_sym_chroot] = ACTIONS(2893),
    [anon_sym_defined] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_dbmclose] = ACTIONS(2893),
    [anon_sym_exists] = ACTIONS(2893),
    [anon_sym_exit] = ACTIONS(2893),
    [anon_sym_eof] = ACTIONS(2893),
    [anon_sym_exp] = ACTIONS(2893),
    [anon_sym_each] = ACTIONS(2893),
    [anon_sym_fc] = ACTIONS(2893),
    [anon_sym_fileno] = ACTIONS(2893),
    [anon_sym_gmtime] = ACTIONS(2893),
    [anon_sym_getc] = ACTIONS(2893),
    [anon_sym_getpgrp] = ACTIONS(2893),
    [anon_sym_getprotobyname] = ACTIONS(2893),
    [anon_sym_getpwname] = ACTIONS(2893),
    [anon_sym_getpwuid] = ACTIONS(2893),
    [anon_sym_getpeername] = ACTIONS(2893),
    [anon_sym_getnetbyname] = ACTIONS(2893),
    [anon_sym_getsockname] = ACTIONS(2893),
    [anon_sym_getgrnam] = ACTIONS(2893),
    [anon_sym_getgrgid] = ACTIONS(2893),
    [anon_sym_hex] = ACTIONS(2893),
    [anon_sym_int] = ACTIONS(2893),
    [anon_sym_keys] = ACTIONS(2893),
    [anon_sym_lc] = ACTIONS(2893),
    [anon_sym_lcfirst] = ACTIONS(2893),
    [anon_sym_length] = ACTIONS(2893),
    [anon_sym_localtime] = ACTIONS(2893),
    [anon_sym_log] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_lstat] = ACTIONS(2893),
    [anon_sym_oct] = ACTIONS(2893),
    [anon_sym_ord] = ACTIONS(2893),
    [anon_sym_prototype] = ACTIONS(2893),
    [anon_sym_pop] = ACTIONS(2893),
    [anon_sym_pos] = ACTIONS(2893),
    [anon_sym_quotemeta] = ACTIONS(2893),
    [anon_sym_reset] = ACTIONS(2893),
    [anon_sym_rand] = ACTIONS(2893),
    [anon_sym_rmdir] = ACTIONS(2893),
    [anon_sym_readdir] = ACTIONS(2893),
    [anon_sym_readline] = ACTIONS(2893),
    [anon_sym_readpipe] = ACTIONS(2893),
    [anon_sym_rewinddir] = ACTIONS(2893),
    [anon_sym_readlink] = ACTIONS(2893),
    [anon_sym_ref] = ACTIONS(2893),
    [anon_sym_scalar] = ACTIONS(2893),
    [anon_sym_shift] = ACTIONS(2893),
    [anon_sym_sin] = ACTIONS(2893),
    [anon_sym_sleep] = ACTIONS(2893),
    [anon_sym_sqrt] = ACTIONS(2893),
    [anon_sym_srand] = ACTIONS(2893),
    [anon_sym_stat] = ACTIONS(2893),
    [anon_sym_study] = ACTIONS(2893),
    [anon_sym_tell] = ACTIONS(2893),
    [anon_sym_telldir] = ACTIONS(2893),
    [anon_sym_tied] = ACTIONS(2893),
    [anon_sym_uc] = ACTIONS(2893),
    [anon_sym_ucfirst] = ACTIONS(2893),
    [anon_sym_untie] = ACTIONS(2893),
    [anon_sym_umask] = ACTIONS(2893),
    [anon_sym_values] = ACTIONS(2893),
    [anon_sym_write] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2893),
    [anon_sym___END__] = ACTIONS(2893),
    [anon_sym_q] = ACTIONS(2893),
    [anon_sym_qq] = ACTIONS(2893),
    [anon_sym_qw] = ACTIONS(2893),
    [anon_sym_qx] = ACTIONS(2893),
    [anon_sym_qr] = ACTIONS(2893),
    [anon_sym_m] = ACTIONS(2893),
    [anon_sym_s] = ACTIONS(2893),
    [anon_sym_tr] = ACTIONS(2893),
    [anon_sym_y] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_until] = ACTIONS(2893),
    [aux_sym__bareword_token1] = ACTIONS(2893),
    [sym_number] = ACTIONS(2893),
    [sym__apostrophe] = ACTIONS(2895),
    [sym__double_quote] = ACTIONS(2895),
    [sym__backtick] = ACTIONS(2895),
    [sym__search_slash] = ACTIONS(2895),
    [sym__PERLY_HEREDOC] = ACTIONS(2895),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [900] = {
    [sym_heredoc_content] = STATE(900),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_RBRACK] = ACTIONS(2897),
    [anon_sym_DASH_GT] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2897),
    [anon_sym_PLUS_EQ] = ACTIONS(2897),
    [anon_sym_DASH_EQ] = ACTIONS(2897),
    [anon_sym_DOT_EQ] = ACTIONS(2897),
    [anon_sym_STAR_EQ] = ACTIONS(2897),
    [anon_sym_SLASH_EQ] = ACTIONS(2897),
    [anon_sym_PERCENT_EQ] = ACTIONS(2897),
    [anon_sym_x_EQ] = ACTIONS(2897),
    [anon_sym_AMP_EQ] = ACTIONS(2897),
    [anon_sym_PIPE_EQ] = ACTIONS(2897),
    [anon_sym_CARET_EQ] = ACTIONS(2897),
    [anon_sym_LT_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_GT_EQ] = ACTIONS(2897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_GT_GT2] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_x] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2897),
    [anon_sym_BANG_TILDE] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_LT_EQ_GT] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_TILDE_TILDE] = ACTIONS(2897),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_QMARK] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_EQ_GT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [901] = {
    [sym_heredoc_content] = STATE(901),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [902] = {
    [sym_heredoc_content] = STATE(902),
    [sym__identifier] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_COLON] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_sub] = ACTIONS(2901),
    [anon_sym_method] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_my] = ACTIONS(2901),
    [anon_sym_state] = ACTIONS(2901),
    [anon_sym_our] = ACTIONS(2901),
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_elsif] = ACTIONS(2901),
    [anon_sym_and] = ACTIONS(2901),
    [anon_sym_or] = ACTIONS(2901),
    [anon_sym_DOLLAR] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_DASH_GT] = ACTIONS(2901),
    [anon_sym_AT] = ACTIONS(2901),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2901),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_DOT_EQ] = ACTIONS(2901),
    [anon_sym_STAR_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_PERCENT_EQ] = ACTIONS(2901),
    [anon_sym_x_EQ] = ACTIONS(2901),
    [anon_sym_AMP_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_CARET_EQ] = ACTIONS(2901),
    [anon_sym_LT_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_GT_EQ] = ACTIONS(2901),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_GT_GT2] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_x] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_BANG_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_eq] = ACTIONS(2901),
    [anon_sym_ne] = ACTIONS(2901),
    [anon_sym_LT_EQ_GT] = ACTIONS(2901),
    [anon_sym_cmp] = ACTIONS(2901),
    [anon_sym_TILDE_TILDE] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_lt] = ACTIONS(2901),
    [anon_sym_le] = ACTIONS(2901),
    [anon_sym_ge] = ACTIONS(2901),
    [anon_sym_gt] = ACTIONS(2901),
    [anon_sym_isa] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_QMARK] = ACTIONS(2901),
    [anon_sym_BSLASH] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_eval] = ACTIONS(2901),
    [anon_sym_field] = ACTIONS(2901),
    [anon_sym_local] = ACTIONS(2901),
    [anon_sym_require] = ACTIONS(2901),
    [anon_sym_map] = ACTIONS(2901),
    [anon_sym_grep] = ACTIONS(2901),
    [anon_sym_sort] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_undef] = ACTIONS(2901),
    [anon_sym_PERCENT2] = ACTIONS(2901),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(2901),
    [anon_sym_use] = ACTIONS(2901),
    [anon_sym_no] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_foreach] = ACTIONS(2901),
    [anon_sym_last] = ACTIONS(2901),
    [anon_sym_next] = ACTIONS(2901),
    [anon_sym_redo] = ACTIONS(2901),
    [anon_sym_BEGIN] = ACTIONS(2901),
    [anon_sym_INIT] = ACTIONS(2901),
    [anon_sym_CHECK] = ACTIONS(2901),
    [anon_sym_UNITCHECK] = ACTIONS(2901),
    [anon_sym_END] = ACTIONS(2901),
    [anon_sym_ADJUST] = ACTIONS(2901),
    [anon_sym___FILE__] = ACTIONS(2901),
    [anon_sym___LINE__] = ACTIONS(2901),
    [anon_sym___PACKAGE__] = ACTIONS(2901),
    [anon_sym___SUB__] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_fork] = ACTIONS(2901),
    [anon_sym_getppid] = ACTIONS(2901),
    [anon_sym_time] = ACTIONS(2901),
    [anon_sym_times] = ACTIONS(2901),
    [anon_sym_wait] = ACTIONS(2901),
    [anon_sym_wantarray] = ACTIONS(2901),
    [anon_sym_abs] = ACTIONS(2901),
    [anon_sym_alarm] = ACTIONS(2901),
    [anon_sym_chop] = ACTIONS(2901),
    [anon_sym_chdir] = ACTIONS(2901),
    [anon_sym_close] = ACTIONS(2901),
    [anon_sym_closedir] = ACTIONS(2901),
    [anon_sym_caller] = ACTIONS(2901),
    [anon_sym_chomp] = ACTIONS(2901),
    [anon_sym_chr] = ACTIONS(2901),
    [anon_sym_cos] = ACTIONS(2901),
    [anon_sym_chroot] = ACTIONS(2901),
    [anon_sym_defined] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_dbmclose] = ACTIONS(2901),
    [anon_sym_exists] = ACTIONS(2901),
    [anon_sym_exit] = ACTIONS(2901),
    [anon_sym_eof] = ACTIONS(2901),
    [anon_sym_exp] = ACTIONS(2901),
    [anon_sym_each] = ACTIONS(2901),
    [anon_sym_fc] = ACTIONS(2901),
    [anon_sym_fileno] = ACTIONS(2901),
    [anon_sym_gmtime] = ACTIONS(2901),
    [anon_sym_getc] = ACTIONS(2901),
    [anon_sym_getpgrp] = ACTIONS(2901),
    [anon_sym_getprotobyname] = ACTIONS(2901),
    [anon_sym_getpwname] = ACTIONS(2901),
    [anon_sym_getpwuid] = ACTIONS(2901),
    [anon_sym_getpeername] = ACTIONS(2901),
    [anon_sym_getnetbyname] = ACTIONS(2901),
    [anon_sym_getsockname] = ACTIONS(2901),
    [anon_sym_getgrnam] = ACTIONS(2901),
    [anon_sym_getgrgid] = ACTIONS(2901),
    [anon_sym_hex] = ACTIONS(2901),
    [anon_sym_int] = ACTIONS(2901),
    [anon_sym_keys] = ACTIONS(2901),
    [anon_sym_lc] = ACTIONS(2901),
    [anon_sym_lcfirst] = ACTIONS(2901),
    [anon_sym_length] = ACTIONS(2901),
    [anon_sym_localtime] = ACTIONS(2901),
    [anon_sym_log] = ACTIONS(2901),
    [anon_sym_lock] = ACTIONS(2901),
    [anon_sym_lstat] = ACTIONS(2901),
    [anon_sym_oct] = ACTIONS(2901),
    [anon_sym_ord] = ACTIONS(2901),
    [anon_sym_prototype] = ACTIONS(2901),
    [anon_sym_pop] = ACTIONS(2901),
    [anon_sym_pos] = ACTIONS(2901),
    [anon_sym_quotemeta] = ACTIONS(2901),
    [anon_sym_reset] = ACTIONS(2901),
    [anon_sym_rand] = ACTIONS(2901),
    [anon_sym_rmdir] = ACTIONS(2901),
    [anon_sym_readdir] = ACTIONS(2901),
    [anon_sym_readline] = ACTIONS(2901),
    [anon_sym_readpipe] = ACTIONS(2901),
    [anon_sym_rewinddir] = ACTIONS(2901),
    [anon_sym_readlink] = ACTIONS(2901),
    [anon_sym_ref] = ACTIONS(2901),
    [anon_sym_scalar] = ACTIONS(2901),
    [anon_sym_shift] = ACTIONS(2901),
    [anon_sym_sin] = ACTIONS(2901),
    [anon_sym_sleep] = ACTIONS(2901),
    [anon_sym_sqrt] = ACTIONS(2901),
    [anon_sym_srand] = ACTIONS(2901),
    [anon_sym_stat] = ACTIONS(2901),
    [anon_sym_study] = ACTIONS(2901),
    [anon_sym_tell] = ACTIONS(2901),
    [anon_sym_telldir] = ACTIONS(2901),
    [anon_sym_tied] = ACTIONS(2901),
    [anon_sym_uc] = ACTIONS(2901),
    [anon_sym_ucfirst] = ACTIONS(2901),
    [anon_sym_untie] = ACTIONS(2901),
    [anon_sym_umask] = ACTIONS(2901),
    [anon_sym_values] = ACTIONS(2901),
    [anon_sym_write] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2901),
    [anon_sym___END__] = ACTIONS(2901),
    [anon_sym_q] = ACTIONS(2901),
    [anon_sym_qq] = ACTIONS(2901),
    [anon_sym_qw] = ACTIONS(2901),
    [anon_sym_qx] = ACTIONS(2901),
    [anon_sym_qr] = ACTIONS(2901),
    [anon_sym_m] = ACTIONS(2901),
    [anon_sym_s] = ACTIONS(2901),
    [anon_sym_tr] = ACTIONS(2901),
    [anon_sym_y] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_unless] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_until] = ACTIONS(2901),
    [aux_sym__bareword_token1] = ACTIONS(2901),
    [sym_number] = ACTIONS(2901),
    [sym__apostrophe] = ACTIONS(2903),
    [sym__double_quote] = ACTIONS(2903),
    [sym__backtick] = ACTIONS(2903),
    [sym__search_slash] = ACTIONS(2903),
    [sym__PERLY_HEREDOC] = ACTIONS(2903),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [903] = {
    [sym_heredoc_content] = STATE(903),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(2874),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2874),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [904] = {
    [sym_heredoc_content] = STATE(904),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [905] = {
    [sym_heredoc_content] = STATE(905),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_COMMA] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_RBRACK] = ACTIONS(2905),
    [anon_sym_DASH_GT] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_PERCENT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2905),
    [anon_sym_PLUS_EQ] = ACTIONS(2905),
    [anon_sym_DASH_EQ] = ACTIONS(2905),
    [anon_sym_DOT_EQ] = ACTIONS(2905),
    [anon_sym_STAR_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_PERCENT_EQ] = ACTIONS(2905),
    [anon_sym_x_EQ] = ACTIONS(2905),
    [anon_sym_AMP_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_CARET_EQ] = ACTIONS(2905),
    [anon_sym_LT_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_GT_EQ] = ACTIONS(2905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_STAR_STAR] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_GT_GT2] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_DOT] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_x] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2905),
    [anon_sym_BANG_TILDE] = ACTIONS(2905),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_LT_EQ_GT] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_TILDE_TILDE] = ACTIONS(2905),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_QMARK] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [906] = {
    [sym_heredoc_content] = STATE(906),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(137),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(137),
    [anon_sym___END__] = ACTIONS(137),
    [anon_sym_EOT] = ACTIONS(137),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_unless] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(137),
    [anon_sym_until] = ACTIONS(137),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [907] = {
    [sym_heredoc_content] = STATE(907),
    [sym__identifier] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_COLON] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym_class] = ACTIONS(2909),
    [anon_sym_sub] = ACTIONS(2909),
    [anon_sym_method] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_RPAREN] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_my] = ACTIONS(2909),
    [anon_sym_state] = ACTIONS(2909),
    [anon_sym_our] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2909),
    [anon_sym_try] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2909),
    [anon_sym_else] = ACTIONS(2909),
    [anon_sym_elsif] = ACTIONS(2909),
    [anon_sym_and] = ACTIONS(2909),
    [anon_sym_or] = ACTIONS(2909),
    [anon_sym_DOLLAR] = ACTIONS(2909),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_RBRACK] = ACTIONS(2909),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_AT] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2909),
    [anon_sym_PLUS_EQ] = ACTIONS(2909),
    [anon_sym_DASH_EQ] = ACTIONS(2909),
    [anon_sym_DOT_EQ] = ACTIONS(2909),
    [anon_sym_STAR_EQ] = ACTIONS(2909),
    [anon_sym_SLASH_EQ] = ACTIONS(2909),
    [anon_sym_PERCENT_EQ] = ACTIONS(2909),
    [anon_sym_x_EQ] = ACTIONS(2909),
    [anon_sym_AMP_EQ] = ACTIONS(2909),
    [anon_sym_PIPE_EQ] = ACTIONS(2909),
    [anon_sym_CARET_EQ] = ACTIONS(2909),
    [anon_sym_LT_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_GT_EQ] = ACTIONS(2909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2909),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_GT_GT2] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_x] = ACTIONS(2909),
    [anon_sym_EQ_TILDE] = ACTIONS(2909),
    [anon_sym_BANG_TILDE] = ACTIONS(2909),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2909),
    [anon_sym_eq] = ACTIONS(2909),
    [anon_sym_ne] = ACTIONS(2909),
    [anon_sym_LT_EQ_GT] = ACTIONS(2909),
    [anon_sym_cmp] = ACTIONS(2909),
    [anon_sym_TILDE_TILDE] = ACTIONS(2909),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2909),
    [anon_sym_lt] = ACTIONS(2909),
    [anon_sym_le] = ACTIONS(2909),
    [anon_sym_ge] = ACTIONS(2909),
    [anon_sym_gt] = ACTIONS(2909),
    [anon_sym_isa] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_QMARK] = ACTIONS(2909),
    [anon_sym_BSLASH] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2909),
    [anon_sym_eval] = ACTIONS(2909),
    [anon_sym_field] = ACTIONS(2909),
    [anon_sym_local] = ACTIONS(2909),
    [anon_sym_require] = ACTIONS(2909),
    [anon_sym_map] = ACTIONS(2909),
    [anon_sym_grep] = ACTIONS(2909),
    [anon_sym_sort] = ACTIONS(2909),
    [anon_sym_goto] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_undef] = ACTIONS(2909),
    [anon_sym_PERCENT2] = ACTIONS(2909),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2909),
    [anon_sym_EQ_GT] = ACTIONS(2909),
    [anon_sym_use] = ACTIONS(2909),
    [anon_sym_no] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_foreach] = ACTIONS(2909),
    [anon_sym_last] = ACTIONS(2909),
    [anon_sym_next] = ACTIONS(2909),
    [anon_sym_redo] = ACTIONS(2909),
    [anon_sym_BEGIN] = ACTIONS(2909),
    [anon_sym_INIT] = ACTIONS(2909),
    [anon_sym_CHECK] = ACTIONS(2909),
    [anon_sym_UNITCHECK] = ACTIONS(2909),
    [anon_sym_END] = ACTIONS(2909),
    [anon_sym_ADJUST] = ACTIONS(2909),
    [anon_sym___FILE__] = ACTIONS(2909),
    [anon_sym___LINE__] = ACTIONS(2909),
    [anon_sym___PACKAGE__] = ACTIONS(2909),
    [anon_sym___SUB__] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_fork] = ACTIONS(2909),
    [anon_sym_getppid] = ACTIONS(2909),
    [anon_sym_time] = ACTIONS(2909),
    [anon_sym_times] = ACTIONS(2909),
    [anon_sym_wait] = ACTIONS(2909),
    [anon_sym_wantarray] = ACTIONS(2909),
    [anon_sym_abs] = ACTIONS(2909),
    [anon_sym_alarm] = ACTIONS(2909),
    [anon_sym_chop] = ACTIONS(2909),
    [anon_sym_chdir] = ACTIONS(2909),
    [anon_sym_close] = ACTIONS(2909),
    [anon_sym_closedir] = ACTIONS(2909),
    [anon_sym_caller] = ACTIONS(2909),
    [anon_sym_chomp] = ACTIONS(2909),
    [anon_sym_chr] = ACTIONS(2909),
    [anon_sym_cos] = ACTIONS(2909),
    [anon_sym_chroot] = ACTIONS(2909),
    [anon_sym_defined] = ACTIONS(2909),
    [anon_sym_delete] = ACTIONS(2909),
    [anon_sym_dbmclose] = ACTIONS(2909),
    [anon_sym_exists] = ACTIONS(2909),
    [anon_sym_exit] = ACTIONS(2909),
    [anon_sym_eof] = ACTIONS(2909),
    [anon_sym_exp] = ACTIONS(2909),
    [anon_sym_each] = ACTIONS(2909),
    [anon_sym_fc] = ACTIONS(2909),
    [anon_sym_fileno] = ACTIONS(2909),
    [anon_sym_gmtime] = ACTIONS(2909),
    [anon_sym_getc] = ACTIONS(2909),
    [anon_sym_getpgrp] = ACTIONS(2909),
    [anon_sym_getprotobyname] = ACTIONS(2909),
    [anon_sym_getpwname] = ACTIONS(2909),
    [anon_sym_getpwuid] = ACTIONS(2909),
    [anon_sym_getpeername] = ACTIONS(2909),
    [anon_sym_getnetbyname] = ACTIONS(2909),
    [anon_sym_getsockname] = ACTIONS(2909),
    [anon_sym_getgrnam] = ACTIONS(2909),
    [anon_sym_getgrgid] = ACTIONS(2909),
    [anon_sym_hex] = ACTIONS(2909),
    [anon_sym_int] = ACTIONS(2909),
    [anon_sym_keys] = ACTIONS(2909),
    [anon_sym_lc] = ACTIONS(2909),
    [anon_sym_lcfirst] = ACTIONS(2909),
    [anon_sym_length] = ACTIONS(2909),
    [anon_sym_localtime] = ACTIONS(2909),
    [anon_sym_log] = ACTIONS(2909),
    [anon_sym_lock] = ACTIONS(2909),
    [anon_sym_lstat] = ACTIONS(2909),
    [anon_sym_oct] = ACTIONS(2909),
    [anon_sym_ord] = ACTIONS(2909),
    [anon_sym_prototype] = ACTIONS(2909),
    [anon_sym_pop] = ACTIONS(2909),
    [anon_sym_pos] = ACTIONS(2909),
    [anon_sym_quotemeta] = ACTIONS(2909),
    [anon_sym_reset] = ACTIONS(2909),
    [anon_sym_rand] = ACTIONS(2909),
    [anon_sym_rmdir] = ACTIONS(2909),
    [anon_sym_readdir] = ACTIONS(2909),
    [anon_sym_readline] = ACTIONS(2909),
    [anon_sym_readpipe] = ACTIONS(2909),
    [anon_sym_rewinddir] = ACTIONS(2909),
    [anon_sym_readlink] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(2909),
    [anon_sym_scalar] = ACTIONS(2909),
    [anon_sym_shift] = ACTIONS(2909),
    [anon_sym_sin] = ACTIONS(2909),
    [anon_sym_sleep] = ACTIONS(2909),
    [anon_sym_sqrt] = ACTIONS(2909),
    [anon_sym_srand] = ACTIONS(2909),
    [anon_sym_stat] = ACTIONS(2909),
    [anon_sym_study] = ACTIONS(2909),
    [anon_sym_tell] = ACTIONS(2909),
    [anon_sym_telldir] = ACTIONS(2909),
    [anon_sym_tied] = ACTIONS(2909),
    [anon_sym_uc] = ACTIONS(2909),
    [anon_sym_ucfirst] = ACTIONS(2909),
    [anon_sym_untie] = ACTIONS(2909),
    [anon_sym_umask] = ACTIONS(2909),
    [anon_sym_values] = ACTIONS(2909),
    [anon_sym_write] = ACTIONS(2909),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2909),
    [anon_sym___END__] = ACTIONS(2909),
    [anon_sym_q] = ACTIONS(2909),
    [anon_sym_qq] = ACTIONS(2909),
    [anon_sym_qw] = ACTIONS(2909),
    [anon_sym_qx] = ACTIONS(2909),
    [anon_sym_qr] = ACTIONS(2909),
    [anon_sym_m] = ACTIONS(2909),
    [anon_sym_s] = ACTIONS(2909),
    [anon_sym_tr] = ACTIONS(2909),
    [anon_sym_y] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_unless] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_until] = ACTIONS(2909),
    [aux_sym__bareword_token1] = ACTIONS(2909),
    [sym_number] = ACTIONS(2909),
    [sym__apostrophe] = ACTIONS(2911),
    [sym__double_quote] = ACTIONS(2911),
    [sym__backtick] = ACTIONS(2911),
    [sym__search_slash] = ACTIONS(2911),
    [sym__PERLY_HEREDOC] = ACTIONS(2911),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [908] = {
    [sym_heredoc_content] = STATE(908),
    [sym__identifier] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_COLON] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_sub] = ACTIONS(2913),
    [anon_sym_method] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_my] = ACTIONS(2913),
    [anon_sym_state] = ACTIONS(2913),
    [anon_sym_our] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_else] = ACTIONS(2913),
    [anon_sym_elsif] = ACTIONS(2913),
    [anon_sym_and] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_RBRACK] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_EQ] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_x_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_BANG_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_eq] = ACTIONS(2913),
    [anon_sym_ne] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_cmp] = ACTIONS(2913),
    [anon_sym_TILDE_TILDE] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_lt] = ACTIONS(2913),
    [anon_sym_le] = ACTIONS(2913),
    [anon_sym_ge] = ACTIONS(2913),
    [anon_sym_gt] = ACTIONS(2913),
    [anon_sym_isa] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_BSLASH] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_eval] = ACTIONS(2913),
    [anon_sym_field] = ACTIONS(2913),
    [anon_sym_local] = ACTIONS(2913),
    [anon_sym_require] = ACTIONS(2913),
    [anon_sym_map] = ACTIONS(2913),
    [anon_sym_grep] = ACTIONS(2913),
    [anon_sym_sort] = ACTIONS(2913),
    [anon_sym_goto] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_undef] = ACTIONS(2913),
    [anon_sym_PERCENT2] = ACTIONS(2913),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2913),
    [anon_sym_EQ_GT] = ACTIONS(2913),
    [anon_sym_use] = ACTIONS(2913),
    [anon_sym_no] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_foreach] = ACTIONS(2913),
    [anon_sym_last] = ACTIONS(2913),
    [anon_sym_next] = ACTIONS(2913),
    [anon_sym_redo] = ACTIONS(2913),
    [anon_sym_BEGIN] = ACTIONS(2913),
    [anon_sym_INIT] = ACTIONS(2913),
    [anon_sym_CHECK] = ACTIONS(2913),
    [anon_sym_UNITCHECK] = ACTIONS(2913),
    [anon_sym_END] = ACTIONS(2913),
    [anon_sym_ADJUST] = ACTIONS(2913),
    [anon_sym___FILE__] = ACTIONS(2913),
    [anon_sym___LINE__] = ACTIONS(2913),
    [anon_sym___PACKAGE__] = ACTIONS(2913),
    [anon_sym___SUB__] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_fork] = ACTIONS(2913),
    [anon_sym_getppid] = ACTIONS(2913),
    [anon_sym_time] = ACTIONS(2913),
    [anon_sym_times] = ACTIONS(2913),
    [anon_sym_wait] = ACTIONS(2913),
    [anon_sym_wantarray] = ACTIONS(2913),
    [anon_sym_abs] = ACTIONS(2913),
    [anon_sym_alarm] = ACTIONS(2913),
    [anon_sym_chop] = ACTIONS(2913),
    [anon_sym_chdir] = ACTIONS(2913),
    [anon_sym_close] = ACTIONS(2913),
    [anon_sym_closedir] = ACTIONS(2913),
    [anon_sym_caller] = ACTIONS(2913),
    [anon_sym_chomp] = ACTIONS(2913),
    [anon_sym_chr] = ACTIONS(2913),
    [anon_sym_cos] = ACTIONS(2913),
    [anon_sym_chroot] = ACTIONS(2913),
    [anon_sym_defined] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_dbmclose] = ACTIONS(2913),
    [anon_sym_exists] = ACTIONS(2913),
    [anon_sym_exit] = ACTIONS(2913),
    [anon_sym_eof] = ACTIONS(2913),
    [anon_sym_exp] = ACTIONS(2913),
    [anon_sym_each] = ACTIONS(2913),
    [anon_sym_fc] = ACTIONS(2913),
    [anon_sym_fileno] = ACTIONS(2913),
    [anon_sym_gmtime] = ACTIONS(2913),
    [anon_sym_getc] = ACTIONS(2913),
    [anon_sym_getpgrp] = ACTIONS(2913),
    [anon_sym_getprotobyname] = ACTIONS(2913),
    [anon_sym_getpwname] = ACTIONS(2913),
    [anon_sym_getpwuid] = ACTIONS(2913),
    [anon_sym_getpeername] = ACTIONS(2913),
    [anon_sym_getnetbyname] = ACTIONS(2913),
    [anon_sym_getsockname] = ACTIONS(2913),
    [anon_sym_getgrnam] = ACTIONS(2913),
    [anon_sym_getgrgid] = ACTIONS(2913),
    [anon_sym_hex] = ACTIONS(2913),
    [anon_sym_int] = ACTIONS(2913),
    [anon_sym_keys] = ACTIONS(2913),
    [anon_sym_lc] = ACTIONS(2913),
    [anon_sym_lcfirst] = ACTIONS(2913),
    [anon_sym_length] = ACTIONS(2913),
    [anon_sym_localtime] = ACTIONS(2913),
    [anon_sym_log] = ACTIONS(2913),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_lstat] = ACTIONS(2913),
    [anon_sym_oct] = ACTIONS(2913),
    [anon_sym_ord] = ACTIONS(2913),
    [anon_sym_prototype] = ACTIONS(2913),
    [anon_sym_pop] = ACTIONS(2913),
    [anon_sym_pos] = ACTIONS(2913),
    [anon_sym_quotemeta] = ACTIONS(2913),
    [anon_sym_reset] = ACTIONS(2913),
    [anon_sym_rand] = ACTIONS(2913),
    [anon_sym_rmdir] = ACTIONS(2913),
    [anon_sym_readdir] = ACTIONS(2913),
    [anon_sym_readline] = ACTIONS(2913),
    [anon_sym_readpipe] = ACTIONS(2913),
    [anon_sym_rewinddir] = ACTIONS(2913),
    [anon_sym_readlink] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(2913),
    [anon_sym_scalar] = ACTIONS(2913),
    [anon_sym_shift] = ACTIONS(2913),
    [anon_sym_sin] = ACTIONS(2913),
    [anon_sym_sleep] = ACTIONS(2913),
    [anon_sym_sqrt] = ACTIONS(2913),
    [anon_sym_srand] = ACTIONS(2913),
    [anon_sym_stat] = ACTIONS(2913),
    [anon_sym_study] = ACTIONS(2913),
    [anon_sym_tell] = ACTIONS(2913),
    [anon_sym_telldir] = ACTIONS(2913),
    [anon_sym_tied] = ACTIONS(2913),
    [anon_sym_uc] = ACTIONS(2913),
    [anon_sym_ucfirst] = ACTIONS(2913),
    [anon_sym_untie] = ACTIONS(2913),
    [anon_sym_umask] = ACTIONS(2913),
    [anon_sym_values] = ACTIONS(2913),
    [anon_sym_write] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2913),
    [anon_sym___END__] = ACTIONS(2913),
    [anon_sym_q] = ACTIONS(2913),
    [anon_sym_qq] = ACTIONS(2913),
    [anon_sym_qw] = ACTIONS(2913),
    [anon_sym_qx] = ACTIONS(2913),
    [anon_sym_qr] = ACTIONS(2913),
    [anon_sym_m] = ACTIONS(2913),
    [anon_sym_s] = ACTIONS(2913),
    [anon_sym_tr] = ACTIONS(2913),
    [anon_sym_y] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_unless] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_until] = ACTIONS(2913),
    [aux_sym__bareword_token1] = ACTIONS(2913),
    [sym_number] = ACTIONS(2913),
    [sym__apostrophe] = ACTIONS(2917),
    [sym__double_quote] = ACTIONS(2917),
    [sym__backtick] = ACTIONS(2917),
    [sym__search_slash] = ACTIONS(2917),
    [sym__PERLY_HEREDOC] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [909] = {
    [sym_heredoc_content] = STATE(909),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(137),
    [anon_sym_or] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [910] = {
    [sym_heredoc_content] = STATE(910),
    [sym__identifier] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2919),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_sub] = ACTIONS(2919),
    [anon_sym_method] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2919),
    [anon_sym_RPAREN] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_my] = ACTIONS(2919),
    [anon_sym_state] = ACTIONS(2919),
    [anon_sym_our] = ACTIONS(2919),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2919),
    [anon_sym_else] = ACTIONS(2919),
    [anon_sym_elsif] = ACTIONS(2919),
    [anon_sym_and] = ACTIONS(2919),
    [anon_sym_or] = ACTIONS(2919),
    [anon_sym_DOLLAR] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [anon_sym_DASH_GT] = ACTIONS(2919),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_PERCENT] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(2919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2919),
    [anon_sym_PLUS_EQ] = ACTIONS(2919),
    [anon_sym_DASH_EQ] = ACTIONS(2919),
    [anon_sym_DOT_EQ] = ACTIONS(2919),
    [anon_sym_STAR_EQ] = ACTIONS(2919),
    [anon_sym_SLASH_EQ] = ACTIONS(2919),
    [anon_sym_PERCENT_EQ] = ACTIONS(2919),
    [anon_sym_x_EQ] = ACTIONS(2919),
    [anon_sym_AMP_EQ] = ACTIONS(2919),
    [anon_sym_PIPE_EQ] = ACTIONS(2919),
    [anon_sym_CARET_EQ] = ACTIONS(2919),
    [anon_sym_LT_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_GT_EQ] = ACTIONS(2919),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2919),
    [anon_sym_DOT_DOT] = ACTIONS(2919),
    [anon_sym_STAR_STAR] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_GT_GT2] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2919),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_x] = ACTIONS(2919),
    [anon_sym_EQ_TILDE] = ACTIONS(2919),
    [anon_sym_BANG_TILDE] = ACTIONS(2919),
    [anon_sym_EQ_EQ] = ACTIONS(2919),
    [anon_sym_BANG_EQ] = ACTIONS(2919),
    [anon_sym_eq] = ACTIONS(2919),
    [anon_sym_ne] = ACTIONS(2919),
    [anon_sym_LT_EQ_GT] = ACTIONS(2919),
    [anon_sym_cmp] = ACTIONS(2919),
    [anon_sym_TILDE_TILDE] = ACTIONS(2919),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2919),
    [anon_sym_lt] = ACTIONS(2919),
    [anon_sym_le] = ACTIONS(2919),
    [anon_sym_ge] = ACTIONS(2919),
    [anon_sym_gt] = ACTIONS(2919),
    [anon_sym_isa] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2919),
    [anon_sym_BANG] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2919),
    [anon_sym_QMARK] = ACTIONS(2919),
    [anon_sym_BSLASH] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_eval] = ACTIONS(2919),
    [anon_sym_field] = ACTIONS(2919),
    [anon_sym_local] = ACTIONS(2919),
    [anon_sym_require] = ACTIONS(2919),
    [anon_sym_map] = ACTIONS(2919),
    [anon_sym_grep] = ACTIONS(2919),
    [anon_sym_sort] = ACTIONS(2919),
    [anon_sym_goto] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_undef] = ACTIONS(2919),
    [anon_sym_PERCENT2] = ACTIONS(2919),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2919),
    [anon_sym_EQ_GT] = ACTIONS(2919),
    [anon_sym_use] = ACTIONS(2919),
    [anon_sym_no] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_foreach] = ACTIONS(2919),
    [anon_sym_last] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2919),
    [anon_sym_redo] = ACTIONS(2919),
    [anon_sym_BEGIN] = ACTIONS(2919),
    [anon_sym_INIT] = ACTIONS(2919),
    [anon_sym_CHECK] = ACTIONS(2919),
    [anon_sym_UNITCHECK] = ACTIONS(2919),
    [anon_sym_END] = ACTIONS(2919),
    [anon_sym_ADJUST] = ACTIONS(2919),
    [anon_sym___FILE__] = ACTIONS(2919),
    [anon_sym___LINE__] = ACTIONS(2919),
    [anon_sym___PACKAGE__] = ACTIONS(2919),
    [anon_sym___SUB__] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_fork] = ACTIONS(2919),
    [anon_sym_getppid] = ACTIONS(2919),
    [anon_sym_time] = ACTIONS(2919),
    [anon_sym_times] = ACTIONS(2919),
    [anon_sym_wait] = ACTIONS(2919),
    [anon_sym_wantarray] = ACTIONS(2919),
    [anon_sym_abs] = ACTIONS(2919),
    [anon_sym_alarm] = ACTIONS(2919),
    [anon_sym_chop] = ACTIONS(2919),
    [anon_sym_chdir] = ACTIONS(2919),
    [anon_sym_close] = ACTIONS(2919),
    [anon_sym_closedir] = ACTIONS(2919),
    [anon_sym_caller] = ACTIONS(2919),
    [anon_sym_chomp] = ACTIONS(2919),
    [anon_sym_chr] = ACTIONS(2919),
    [anon_sym_cos] = ACTIONS(2919),
    [anon_sym_chroot] = ACTIONS(2919),
    [anon_sym_defined] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_dbmclose] = ACTIONS(2919),
    [anon_sym_exists] = ACTIONS(2919),
    [anon_sym_exit] = ACTIONS(2919),
    [anon_sym_eof] = ACTIONS(2919),
    [anon_sym_exp] = ACTIONS(2919),
    [anon_sym_each] = ACTIONS(2919),
    [anon_sym_fc] = ACTIONS(2919),
    [anon_sym_fileno] = ACTIONS(2919),
    [anon_sym_gmtime] = ACTIONS(2919),
    [anon_sym_getc] = ACTIONS(2919),
    [anon_sym_getpgrp] = ACTIONS(2919),
    [anon_sym_getprotobyname] = ACTIONS(2919),
    [anon_sym_getpwname] = ACTIONS(2919),
    [anon_sym_getpwuid] = ACTIONS(2919),
    [anon_sym_getpeername] = ACTIONS(2919),
    [anon_sym_getnetbyname] = ACTIONS(2919),
    [anon_sym_getsockname] = ACTIONS(2919),
    [anon_sym_getgrnam] = ACTIONS(2919),
    [anon_sym_getgrgid] = ACTIONS(2919),
    [anon_sym_hex] = ACTIONS(2919),
    [anon_sym_int] = ACTIONS(2919),
    [anon_sym_keys] = ACTIONS(2919),
    [anon_sym_lc] = ACTIONS(2919),
    [anon_sym_lcfirst] = ACTIONS(2919),
    [anon_sym_length] = ACTIONS(2919),
    [anon_sym_localtime] = ACTIONS(2919),
    [anon_sym_log] = ACTIONS(2919),
    [anon_sym_lock] = ACTIONS(2919),
    [anon_sym_lstat] = ACTIONS(2919),
    [anon_sym_oct] = ACTIONS(2919),
    [anon_sym_ord] = ACTIONS(2919),
    [anon_sym_prototype] = ACTIONS(2919),
    [anon_sym_pop] = ACTIONS(2919),
    [anon_sym_pos] = ACTIONS(2919),
    [anon_sym_quotemeta] = ACTIONS(2919),
    [anon_sym_reset] = ACTIONS(2919),
    [anon_sym_rand] = ACTIONS(2919),
    [anon_sym_rmdir] = ACTIONS(2919),
    [anon_sym_readdir] = ACTIONS(2919),
    [anon_sym_readline] = ACTIONS(2919),
    [anon_sym_readpipe] = ACTIONS(2919),
    [anon_sym_rewinddir] = ACTIONS(2919),
    [anon_sym_readlink] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(2919),
    [anon_sym_scalar] = ACTIONS(2919),
    [anon_sym_shift] = ACTIONS(2919),
    [anon_sym_sin] = ACTIONS(2919),
    [anon_sym_sleep] = ACTIONS(2919),
    [anon_sym_sqrt] = ACTIONS(2919),
    [anon_sym_srand] = ACTIONS(2919),
    [anon_sym_stat] = ACTIONS(2919),
    [anon_sym_study] = ACTIONS(2919),
    [anon_sym_tell] = ACTIONS(2919),
    [anon_sym_telldir] = ACTIONS(2919),
    [anon_sym_tied] = ACTIONS(2919),
    [anon_sym_uc] = ACTIONS(2919),
    [anon_sym_ucfirst] = ACTIONS(2919),
    [anon_sym_untie] = ACTIONS(2919),
    [anon_sym_umask] = ACTIONS(2919),
    [anon_sym_values] = ACTIONS(2919),
    [anon_sym_write] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2919),
    [anon_sym___END__] = ACTIONS(2919),
    [anon_sym_q] = ACTIONS(2919),
    [anon_sym_qq] = ACTIONS(2919),
    [anon_sym_qw] = ACTIONS(2919),
    [anon_sym_qx] = ACTIONS(2919),
    [anon_sym_qr] = ACTIONS(2919),
    [anon_sym_m] = ACTIONS(2919),
    [anon_sym_s] = ACTIONS(2919),
    [anon_sym_tr] = ACTIONS(2919),
    [anon_sym_y] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_unless] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_until] = ACTIONS(2919),
    [aux_sym__bareword_token1] = ACTIONS(2919),
    [sym_number] = ACTIONS(2919),
    [sym__apostrophe] = ACTIONS(2921),
    [sym__double_quote] = ACTIONS(2921),
    [sym__backtick] = ACTIONS(2921),
    [sym__search_slash] = ACTIONS(2921),
    [sym__PERLY_HEREDOC] = ACTIONS(2921),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [911] = {
    [sym_heredoc_content] = STATE(911),
    [sym__identifier] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_sub] = ACTIONS(2923),
    [anon_sym_method] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_my] = ACTIONS(2923),
    [anon_sym_state] = ACTIONS(2923),
    [anon_sym_our] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2923),
    [anon_sym_elsif] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2923),
    [anon_sym_DOLLAR] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_AT] = ACTIONS(2923),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2923),
    [anon_sym_PLUS_EQ] = ACTIONS(2923),
    [anon_sym_DASH_EQ] = ACTIONS(2923),
    [anon_sym_DOT_EQ] = ACTIONS(2923),
    [anon_sym_STAR_EQ] = ACTIONS(2923),
    [anon_sym_SLASH_EQ] = ACTIONS(2923),
    [anon_sym_PERCENT_EQ] = ACTIONS(2923),
    [anon_sym_x_EQ] = ACTIONS(2923),
    [anon_sym_AMP_EQ] = ACTIONS(2923),
    [anon_sym_PIPE_EQ] = ACTIONS(2923),
    [anon_sym_CARET_EQ] = ACTIONS(2923),
    [anon_sym_LT_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_GT_EQ] = ACTIONS(2923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_GT_GT2] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_x] = ACTIONS(2923),
    [anon_sym_EQ_TILDE] = ACTIONS(2923),
    [anon_sym_BANG_TILDE] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_eq] = ACTIONS(2923),
    [anon_sym_ne] = ACTIONS(2923),
    [anon_sym_LT_EQ_GT] = ACTIONS(2923),
    [anon_sym_cmp] = ACTIONS(2923),
    [anon_sym_TILDE_TILDE] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_lt] = ACTIONS(2923),
    [anon_sym_le] = ACTIONS(2923),
    [anon_sym_ge] = ACTIONS(2923),
    [anon_sym_gt] = ACTIONS(2923),
    [anon_sym_isa] = ACTIONS(2923),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2923),
    [anon_sym_BSLASH] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_eval] = ACTIONS(2923),
    [anon_sym_field] = ACTIONS(2923),
    [anon_sym_local] = ACTIONS(2923),
    [anon_sym_require] = ACTIONS(2923),
    [anon_sym_map] = ACTIONS(2923),
    [anon_sym_grep] = ACTIONS(2923),
    [anon_sym_sort] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_undef] = ACTIONS(2923),
    [anon_sym_PERCENT2] = ACTIONS(2923),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_use] = ACTIONS(2923),
    [anon_sym_no] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_foreach] = ACTIONS(2923),
    [anon_sym_last] = ACTIONS(2923),
    [anon_sym_next] = ACTIONS(2923),
    [anon_sym_redo] = ACTIONS(2923),
    [anon_sym_BEGIN] = ACTIONS(2923),
    [anon_sym_INIT] = ACTIONS(2923),
    [anon_sym_CHECK] = ACTIONS(2923),
    [anon_sym_UNITCHECK] = ACTIONS(2923),
    [anon_sym_END] = ACTIONS(2923),
    [anon_sym_ADJUST] = ACTIONS(2923),
    [anon_sym___FILE__] = ACTIONS(2923),
    [anon_sym___LINE__] = ACTIONS(2923),
    [anon_sym___PACKAGE__] = ACTIONS(2923),
    [anon_sym___SUB__] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_fork] = ACTIONS(2923),
    [anon_sym_getppid] = ACTIONS(2923),
    [anon_sym_time] = ACTIONS(2923),
    [anon_sym_times] = ACTIONS(2923),
    [anon_sym_wait] = ACTIONS(2923),
    [anon_sym_wantarray] = ACTIONS(2923),
    [anon_sym_abs] = ACTIONS(2923),
    [anon_sym_alarm] = ACTIONS(2923),
    [anon_sym_chop] = ACTIONS(2923),
    [anon_sym_chdir] = ACTIONS(2923),
    [anon_sym_close] = ACTIONS(2923),
    [anon_sym_closedir] = ACTIONS(2923),
    [anon_sym_caller] = ACTIONS(2923),
    [anon_sym_chomp] = ACTIONS(2923),
    [anon_sym_chr] = ACTIONS(2923),
    [anon_sym_cos] = ACTIONS(2923),
    [anon_sym_chroot] = ACTIONS(2923),
    [anon_sym_defined] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_dbmclose] = ACTIONS(2923),
    [anon_sym_exists] = ACTIONS(2923),
    [anon_sym_exit] = ACTIONS(2923),
    [anon_sym_eof] = ACTIONS(2923),
    [anon_sym_exp] = ACTIONS(2923),
    [anon_sym_each] = ACTIONS(2923),
    [anon_sym_fc] = ACTIONS(2923),
    [anon_sym_fileno] = ACTIONS(2923),
    [anon_sym_gmtime] = ACTIONS(2923),
    [anon_sym_getc] = ACTIONS(2923),
    [anon_sym_getpgrp] = ACTIONS(2923),
    [anon_sym_getprotobyname] = ACTIONS(2923),
    [anon_sym_getpwname] = ACTIONS(2923),
    [anon_sym_getpwuid] = ACTIONS(2923),
    [anon_sym_getpeername] = ACTIONS(2923),
    [anon_sym_getnetbyname] = ACTIONS(2923),
    [anon_sym_getsockname] = ACTIONS(2923),
    [anon_sym_getgrnam] = ACTIONS(2923),
    [anon_sym_getgrgid] = ACTIONS(2923),
    [anon_sym_hex] = ACTIONS(2923),
    [anon_sym_int] = ACTIONS(2923),
    [anon_sym_keys] = ACTIONS(2923),
    [anon_sym_lc] = ACTIONS(2923),
    [anon_sym_lcfirst] = ACTIONS(2923),
    [anon_sym_length] = ACTIONS(2923),
    [anon_sym_localtime] = ACTIONS(2923),
    [anon_sym_log] = ACTIONS(2923),
    [anon_sym_lock] = ACTIONS(2923),
    [anon_sym_lstat] = ACTIONS(2923),
    [anon_sym_oct] = ACTIONS(2923),
    [anon_sym_ord] = ACTIONS(2923),
    [anon_sym_prototype] = ACTIONS(2923),
    [anon_sym_pop] = ACTIONS(2923),
    [anon_sym_pos] = ACTIONS(2923),
    [anon_sym_quotemeta] = ACTIONS(2923),
    [anon_sym_reset] = ACTIONS(2923),
    [anon_sym_rand] = ACTIONS(2923),
    [anon_sym_rmdir] = ACTIONS(2923),
    [anon_sym_readdir] = ACTIONS(2923),
    [anon_sym_readline] = ACTIONS(2923),
    [anon_sym_readpipe] = ACTIONS(2923),
    [anon_sym_rewinddir] = ACTIONS(2923),
    [anon_sym_readlink] = ACTIONS(2923),
    [anon_sym_ref] = ACTIONS(2923),
    [anon_sym_scalar] = ACTIONS(2923),
    [anon_sym_shift] = ACTIONS(2923),
    [anon_sym_sin] = ACTIONS(2923),
    [anon_sym_sleep] = ACTIONS(2923),
    [anon_sym_sqrt] = ACTIONS(2923),
    [anon_sym_srand] = ACTIONS(2923),
    [anon_sym_stat] = ACTIONS(2923),
    [anon_sym_study] = ACTIONS(2923),
    [anon_sym_tell] = ACTIONS(2923),
    [anon_sym_telldir] = ACTIONS(2923),
    [anon_sym_tied] = ACTIONS(2923),
    [anon_sym_uc] = ACTIONS(2923),
    [anon_sym_ucfirst] = ACTIONS(2923),
    [anon_sym_untie] = ACTIONS(2923),
    [anon_sym_umask] = ACTIONS(2923),
    [anon_sym_values] = ACTIONS(2923),
    [anon_sym_write] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2923),
    [anon_sym___END__] = ACTIONS(2923),
    [anon_sym_q] = ACTIONS(2923),
    [anon_sym_qq] = ACTIONS(2923),
    [anon_sym_qw] = ACTIONS(2923),
    [anon_sym_qx] = ACTIONS(2923),
    [anon_sym_qr] = ACTIONS(2923),
    [anon_sym_m] = ACTIONS(2923),
    [anon_sym_s] = ACTIONS(2923),
    [anon_sym_tr] = ACTIONS(2923),
    [anon_sym_y] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_unless] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_until] = ACTIONS(2923),
    [aux_sym__bareword_token1] = ACTIONS(2923),
    [sym_number] = ACTIONS(2923),
    [sym__apostrophe] = ACTIONS(2925),
    [sym__double_quote] = ACTIONS(2925),
    [sym__backtick] = ACTIONS(2925),
    [sym__search_slash] = ACTIONS(2925),
    [sym__PERLY_HEREDOC] = ACTIONS(2925),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [912] = {
    [sym_heredoc_content] = STATE(912),
    [sym__identifier] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_COLON] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_sub] = ACTIONS(2913),
    [anon_sym_method] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_my] = ACTIONS(2913),
    [anon_sym_state] = ACTIONS(2913),
    [anon_sym_our] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_else] = ACTIONS(2913),
    [anon_sym_elsif] = ACTIONS(2913),
    [anon_sym_and] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_RBRACK] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_EQ] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_x_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_BANG_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_eq] = ACTIONS(2913),
    [anon_sym_ne] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_cmp] = ACTIONS(2913),
    [anon_sym_TILDE_TILDE] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_lt] = ACTIONS(2913),
    [anon_sym_le] = ACTIONS(2913),
    [anon_sym_ge] = ACTIONS(2913),
    [anon_sym_gt] = ACTIONS(2913),
    [anon_sym_isa] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_BSLASH] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_eval] = ACTIONS(2913),
    [anon_sym_field] = ACTIONS(2913),
    [anon_sym_local] = ACTIONS(2913),
    [anon_sym_require] = ACTIONS(2913),
    [anon_sym_map] = ACTIONS(2913),
    [anon_sym_grep] = ACTIONS(2913),
    [anon_sym_sort] = ACTIONS(2913),
    [anon_sym_goto] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_undef] = ACTIONS(2913),
    [anon_sym_PERCENT2] = ACTIONS(2913),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2913),
    [anon_sym_EQ_GT] = ACTIONS(2913),
    [anon_sym_use] = ACTIONS(2913),
    [anon_sym_no] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_foreach] = ACTIONS(2913),
    [anon_sym_last] = ACTIONS(2913),
    [anon_sym_next] = ACTIONS(2913),
    [anon_sym_redo] = ACTIONS(2913),
    [anon_sym_BEGIN] = ACTIONS(2913),
    [anon_sym_INIT] = ACTIONS(2913),
    [anon_sym_CHECK] = ACTIONS(2913),
    [anon_sym_UNITCHECK] = ACTIONS(2913),
    [anon_sym_END] = ACTIONS(2913),
    [anon_sym_ADJUST] = ACTIONS(2913),
    [anon_sym___FILE__] = ACTIONS(2913),
    [anon_sym___LINE__] = ACTIONS(2913),
    [anon_sym___PACKAGE__] = ACTIONS(2913),
    [anon_sym___SUB__] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_fork] = ACTIONS(2913),
    [anon_sym_getppid] = ACTIONS(2913),
    [anon_sym_time] = ACTIONS(2913),
    [anon_sym_times] = ACTIONS(2913),
    [anon_sym_wait] = ACTIONS(2913),
    [anon_sym_wantarray] = ACTIONS(2913),
    [anon_sym_abs] = ACTIONS(2913),
    [anon_sym_alarm] = ACTIONS(2913),
    [anon_sym_chop] = ACTIONS(2913),
    [anon_sym_chdir] = ACTIONS(2913),
    [anon_sym_close] = ACTIONS(2913),
    [anon_sym_closedir] = ACTIONS(2913),
    [anon_sym_caller] = ACTIONS(2913),
    [anon_sym_chomp] = ACTIONS(2913),
    [anon_sym_chr] = ACTIONS(2913),
    [anon_sym_cos] = ACTIONS(2913),
    [anon_sym_chroot] = ACTIONS(2913),
    [anon_sym_defined] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_dbmclose] = ACTIONS(2913),
    [anon_sym_exists] = ACTIONS(2913),
    [anon_sym_exit] = ACTIONS(2913),
    [anon_sym_eof] = ACTIONS(2913),
    [anon_sym_exp] = ACTIONS(2913),
    [anon_sym_each] = ACTIONS(2913),
    [anon_sym_fc] = ACTIONS(2913),
    [anon_sym_fileno] = ACTIONS(2913),
    [anon_sym_gmtime] = ACTIONS(2913),
    [anon_sym_getc] = ACTIONS(2913),
    [anon_sym_getpgrp] = ACTIONS(2913),
    [anon_sym_getprotobyname] = ACTIONS(2913),
    [anon_sym_getpwname] = ACTIONS(2913),
    [anon_sym_getpwuid] = ACTIONS(2913),
    [anon_sym_getpeername] = ACTIONS(2913),
    [anon_sym_getnetbyname] = ACTIONS(2913),
    [anon_sym_getsockname] = ACTIONS(2913),
    [anon_sym_getgrnam] = ACTIONS(2913),
    [anon_sym_getgrgid] = ACTIONS(2913),
    [anon_sym_hex] = ACTIONS(2913),
    [anon_sym_int] = ACTIONS(2913),
    [anon_sym_keys] = ACTIONS(2913),
    [anon_sym_lc] = ACTIONS(2913),
    [anon_sym_lcfirst] = ACTIONS(2913),
    [anon_sym_length] = ACTIONS(2913),
    [anon_sym_localtime] = ACTIONS(2913),
    [anon_sym_log] = ACTIONS(2913),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_lstat] = ACTIONS(2913),
    [anon_sym_oct] = ACTIONS(2913),
    [anon_sym_ord] = ACTIONS(2913),
    [anon_sym_prototype] = ACTIONS(2913),
    [anon_sym_pop] = ACTIONS(2913),
    [anon_sym_pos] = ACTIONS(2913),
    [anon_sym_quotemeta] = ACTIONS(2913),
    [anon_sym_reset] = ACTIONS(2913),
    [anon_sym_rand] = ACTIONS(2913),
    [anon_sym_rmdir] = ACTIONS(2913),
    [anon_sym_readdir] = ACTIONS(2913),
    [anon_sym_readline] = ACTIONS(2913),
    [anon_sym_readpipe] = ACTIONS(2913),
    [anon_sym_rewinddir] = ACTIONS(2913),
    [anon_sym_readlink] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(2913),
    [anon_sym_scalar] = ACTIONS(2913),
    [anon_sym_shift] = ACTIONS(2913),
    [anon_sym_sin] = ACTIONS(2913),
    [anon_sym_sleep] = ACTIONS(2913),
    [anon_sym_sqrt] = ACTIONS(2913),
    [anon_sym_srand] = ACTIONS(2913),
    [anon_sym_stat] = ACTIONS(2913),
    [anon_sym_study] = ACTIONS(2913),
    [anon_sym_tell] = ACTIONS(2913),
    [anon_sym_telldir] = ACTIONS(2913),
    [anon_sym_tied] = ACTIONS(2913),
    [anon_sym_uc] = ACTIONS(2913),
    [anon_sym_ucfirst] = ACTIONS(2913),
    [anon_sym_untie] = ACTIONS(2913),
    [anon_sym_umask] = ACTIONS(2913),
    [anon_sym_values] = ACTIONS(2913),
    [anon_sym_write] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2913),
    [anon_sym___END__] = ACTIONS(2913),
    [anon_sym_q] = ACTIONS(2913),
    [anon_sym_qq] = ACTIONS(2913),
    [anon_sym_qw] = ACTIONS(2913),
    [anon_sym_qx] = ACTIONS(2913),
    [anon_sym_qr] = ACTIONS(2913),
    [anon_sym_m] = ACTIONS(2913),
    [anon_sym_s] = ACTIONS(2913),
    [anon_sym_tr] = ACTIONS(2913),
    [anon_sym_y] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_unless] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_until] = ACTIONS(2913),
    [aux_sym__bareword_token1] = ACTIONS(2913),
    [sym_number] = ACTIONS(2913),
    [sym__apostrophe] = ACTIONS(2917),
    [sym__double_quote] = ACTIONS(2917),
    [sym__backtick] = ACTIONS(2917),
    [sym__search_slash] = ACTIONS(2917),
    [sym__PERLY_HEREDOC] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [913] = {
    [sym_heredoc_content] = STATE(913),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_foreach] = ACTIONS(2876),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2876),
    [anon_sym___END__] = ACTIONS(2876),
    [anon_sym_EOT] = ACTIONS(2874),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_unless] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_until] = ACTIONS(2876),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym__ctrl_z_hack] = ACTIONS(2881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [914] = {
    [sym_heredoc_content] = STATE(914),
    [sym__identifier] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_sub] = ACTIONS(2913),
    [anon_sym_method] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_my] = ACTIONS(2913),
    [anon_sym_state] = ACTIONS(2913),
    [anon_sym_our] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_else] = ACTIONS(2913),
    [anon_sym_elsif] = ACTIONS(2913),
    [anon_sym_and] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_EQ] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_x_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_BANG_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_eq] = ACTIONS(2913),
    [anon_sym_ne] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_cmp] = ACTIONS(2913),
    [anon_sym_TILDE_TILDE] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_lt] = ACTIONS(2913),
    [anon_sym_le] = ACTIONS(2913),
    [anon_sym_ge] = ACTIONS(2913),
    [anon_sym_gt] = ACTIONS(2913),
    [anon_sym_isa] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_BSLASH] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_eval] = ACTIONS(2913),
    [anon_sym_field] = ACTIONS(2913),
    [anon_sym_local] = ACTIONS(2913),
    [anon_sym_require] = ACTIONS(2913),
    [anon_sym_map] = ACTIONS(2913),
    [anon_sym_grep] = ACTIONS(2913),
    [anon_sym_sort] = ACTIONS(2913),
    [anon_sym_goto] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_undef] = ACTIONS(2913),
    [anon_sym_PERCENT2] = ACTIONS(2913),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2913),
    [anon_sym_EQ_GT] = ACTIONS(2913),
    [anon_sym_use] = ACTIONS(2913),
    [anon_sym_no] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_foreach] = ACTIONS(2913),
    [anon_sym_last] = ACTIONS(2913),
    [anon_sym_next] = ACTIONS(2913),
    [anon_sym_redo] = ACTIONS(2913),
    [anon_sym_BEGIN] = ACTIONS(2913),
    [anon_sym_INIT] = ACTIONS(2913),
    [anon_sym_CHECK] = ACTIONS(2913),
    [anon_sym_UNITCHECK] = ACTIONS(2913),
    [anon_sym_END] = ACTIONS(2913),
    [anon_sym_ADJUST] = ACTIONS(2913),
    [anon_sym___FILE__] = ACTIONS(2913),
    [anon_sym___LINE__] = ACTIONS(2913),
    [anon_sym___PACKAGE__] = ACTIONS(2913),
    [anon_sym___SUB__] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_fork] = ACTIONS(2913),
    [anon_sym_getppid] = ACTIONS(2913),
    [anon_sym_time] = ACTIONS(2913),
    [anon_sym_times] = ACTIONS(2913),
    [anon_sym_wait] = ACTIONS(2913),
    [anon_sym_wantarray] = ACTIONS(2913),
    [anon_sym_abs] = ACTIONS(2913),
    [anon_sym_alarm] = ACTIONS(2913),
    [anon_sym_chop] = ACTIONS(2913),
    [anon_sym_chdir] = ACTIONS(2913),
    [anon_sym_close] = ACTIONS(2913),
    [anon_sym_closedir] = ACTIONS(2913),
    [anon_sym_caller] = ACTIONS(2913),
    [anon_sym_chomp] = ACTIONS(2913),
    [anon_sym_chr] = ACTIONS(2913),
    [anon_sym_cos] = ACTIONS(2913),
    [anon_sym_chroot] = ACTIONS(2913),
    [anon_sym_defined] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_dbmclose] = ACTIONS(2913),
    [anon_sym_exists] = ACTIONS(2913),
    [anon_sym_exit] = ACTIONS(2913),
    [anon_sym_eof] = ACTIONS(2913),
    [anon_sym_exp] = ACTIONS(2913),
    [anon_sym_each] = ACTIONS(2913),
    [anon_sym_fc] = ACTIONS(2913),
    [anon_sym_fileno] = ACTIONS(2913),
    [anon_sym_gmtime] = ACTIONS(2913),
    [anon_sym_getc] = ACTIONS(2913),
    [anon_sym_getpgrp] = ACTIONS(2913),
    [anon_sym_getprotobyname] = ACTIONS(2913),
    [anon_sym_getpwname] = ACTIONS(2913),
    [anon_sym_getpwuid] = ACTIONS(2913),
    [anon_sym_getpeername] = ACTIONS(2913),
    [anon_sym_getnetbyname] = ACTIONS(2913),
    [anon_sym_getsockname] = ACTIONS(2913),
    [anon_sym_getgrnam] = ACTIONS(2913),
    [anon_sym_getgrgid] = ACTIONS(2913),
    [anon_sym_hex] = ACTIONS(2913),
    [anon_sym_int] = ACTIONS(2913),
    [anon_sym_keys] = ACTIONS(2913),
    [anon_sym_lc] = ACTIONS(2913),
    [anon_sym_lcfirst] = ACTIONS(2913),
    [anon_sym_length] = ACTIONS(2913),
    [anon_sym_localtime] = ACTIONS(2913),
    [anon_sym_log] = ACTIONS(2913),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_lstat] = ACTIONS(2913),
    [anon_sym_oct] = ACTIONS(2913),
    [anon_sym_ord] = ACTIONS(2913),
    [anon_sym_prototype] = ACTIONS(2913),
    [anon_sym_pop] = ACTIONS(2913),
    [anon_sym_pos] = ACTIONS(2913),
    [anon_sym_quotemeta] = ACTIONS(2913),
    [anon_sym_reset] = ACTIONS(2913),
    [anon_sym_rand] = ACTIONS(2913),
    [anon_sym_rmdir] = ACTIONS(2913),
    [anon_sym_readdir] = ACTIONS(2913),
    [anon_sym_readline] = ACTIONS(2913),
    [anon_sym_readpipe] = ACTIONS(2913),
    [anon_sym_rewinddir] = ACTIONS(2913),
    [anon_sym_readlink] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(2913),
    [anon_sym_scalar] = ACTIONS(2913),
    [anon_sym_shift] = ACTIONS(2913),
    [anon_sym_sin] = ACTIONS(2913),
    [anon_sym_sleep] = ACTIONS(2913),
    [anon_sym_sqrt] = ACTIONS(2913),
    [anon_sym_srand] = ACTIONS(2913),
    [anon_sym_stat] = ACTIONS(2913),
    [anon_sym_study] = ACTIONS(2913),
    [anon_sym_tell] = ACTIONS(2913),
    [anon_sym_telldir] = ACTIONS(2913),
    [anon_sym_tied] = ACTIONS(2913),
    [anon_sym_uc] = ACTIONS(2913),
    [anon_sym_ucfirst] = ACTIONS(2913),
    [anon_sym_untie] = ACTIONS(2913),
    [anon_sym_umask] = ACTIONS(2913),
    [anon_sym_values] = ACTIONS(2913),
    [anon_sym_write] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2913),
    [anon_sym___END__] = ACTIONS(2913),
    [anon_sym_EOT] = ACTIONS(2913),
    [anon_sym_q] = ACTIONS(2913),
    [anon_sym_qq] = ACTIONS(2913),
    [anon_sym_qw] = ACTIONS(2913),
    [anon_sym_qx] = ACTIONS(2913),
    [anon_sym_qr] = ACTIONS(2913),
    [anon_sym_m] = ACTIONS(2913),
    [anon_sym_s] = ACTIONS(2913),
    [anon_sym_tr] = ACTIONS(2913),
    [anon_sym_y] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_unless] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_until] = ACTIONS(2913),
    [aux_sym__bareword_token1] = ACTIONS(2913),
    [sym_number] = ACTIONS(2913),
    [sym__apostrophe] = ACTIONS(2917),
    [sym__double_quote] = ACTIONS(2917),
    [sym__backtick] = ACTIONS(2917),
    [sym__search_slash] = ACTIONS(2917),
    [sym__PERLY_SEMICOLON] = ACTIONS(2917),
    [sym__PERLY_HEREDOC] = ACTIONS(2917),
    [sym__ctrl_z_hack] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [915] = {
    [sym_heredoc_content] = STATE(915),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_DASH_GT] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2897),
    [anon_sym_PLUS_EQ] = ACTIONS(2897),
    [anon_sym_DASH_EQ] = ACTIONS(2897),
    [anon_sym_DOT_EQ] = ACTIONS(2897),
    [anon_sym_STAR_EQ] = ACTIONS(2897),
    [anon_sym_SLASH_EQ] = ACTIONS(2897),
    [anon_sym_PERCENT_EQ] = ACTIONS(2897),
    [anon_sym_x_EQ] = ACTIONS(2897),
    [anon_sym_AMP_EQ] = ACTIONS(2897),
    [anon_sym_PIPE_EQ] = ACTIONS(2897),
    [anon_sym_CARET_EQ] = ACTIONS(2897),
    [anon_sym_LT_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_GT_EQ] = ACTIONS(2897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_GT_GT2] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_x] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2897),
    [anon_sym_BANG_TILDE] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_LT_EQ_GT] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_TILDE_TILDE] = ACTIONS(2897),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_QMARK] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_EQ_GT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_EOT] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_SEMICOLON] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym__ctrl_z_hack] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [916] = {
    [sym_heredoc_content] = STATE(916),
    [sym__identifier] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_sub] = ACTIONS(2913),
    [anon_sym_method] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_my] = ACTIONS(2913),
    [anon_sym_state] = ACTIONS(2913),
    [anon_sym_our] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_else] = ACTIONS(2913),
    [anon_sym_elsif] = ACTIONS(2913),
    [anon_sym_and] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_EQ] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_x_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_BANG_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_eq] = ACTIONS(2913),
    [anon_sym_ne] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_cmp] = ACTIONS(2913),
    [anon_sym_TILDE_TILDE] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_lt] = ACTIONS(2913),
    [anon_sym_le] = ACTIONS(2913),
    [anon_sym_ge] = ACTIONS(2913),
    [anon_sym_gt] = ACTIONS(2913),
    [anon_sym_isa] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_BSLASH] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_eval] = ACTIONS(2913),
    [anon_sym_field] = ACTIONS(2913),
    [anon_sym_local] = ACTIONS(2913),
    [anon_sym_require] = ACTIONS(2913),
    [anon_sym_map] = ACTIONS(2913),
    [anon_sym_grep] = ACTIONS(2913),
    [anon_sym_sort] = ACTIONS(2913),
    [anon_sym_goto] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_undef] = ACTIONS(2913),
    [anon_sym_PERCENT2] = ACTIONS(2913),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2913),
    [anon_sym_EQ_GT] = ACTIONS(2913),
    [anon_sym_use] = ACTIONS(2913),
    [anon_sym_no] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_foreach] = ACTIONS(2913),
    [anon_sym_last] = ACTIONS(2913),
    [anon_sym_next] = ACTIONS(2913),
    [anon_sym_redo] = ACTIONS(2913),
    [anon_sym_BEGIN] = ACTIONS(2913),
    [anon_sym_INIT] = ACTIONS(2913),
    [anon_sym_CHECK] = ACTIONS(2913),
    [anon_sym_UNITCHECK] = ACTIONS(2913),
    [anon_sym_END] = ACTIONS(2913),
    [anon_sym_ADJUST] = ACTIONS(2913),
    [anon_sym___FILE__] = ACTIONS(2913),
    [anon_sym___LINE__] = ACTIONS(2913),
    [anon_sym___PACKAGE__] = ACTIONS(2913),
    [anon_sym___SUB__] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_fork] = ACTIONS(2913),
    [anon_sym_getppid] = ACTIONS(2913),
    [anon_sym_time] = ACTIONS(2913),
    [anon_sym_times] = ACTIONS(2913),
    [anon_sym_wait] = ACTIONS(2913),
    [anon_sym_wantarray] = ACTIONS(2913),
    [anon_sym_abs] = ACTIONS(2913),
    [anon_sym_alarm] = ACTIONS(2913),
    [anon_sym_chop] = ACTIONS(2913),
    [anon_sym_chdir] = ACTIONS(2913),
    [anon_sym_close] = ACTIONS(2913),
    [anon_sym_closedir] = ACTIONS(2913),
    [anon_sym_caller] = ACTIONS(2913),
    [anon_sym_chomp] = ACTIONS(2913),
    [anon_sym_chr] = ACTIONS(2913),
    [anon_sym_cos] = ACTIONS(2913),
    [anon_sym_chroot] = ACTIONS(2913),
    [anon_sym_defined] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_dbmclose] = ACTIONS(2913),
    [anon_sym_exists] = ACTIONS(2913),
    [anon_sym_exit] = ACTIONS(2913),
    [anon_sym_eof] = ACTIONS(2913),
    [anon_sym_exp] = ACTIONS(2913),
    [anon_sym_each] = ACTIONS(2913),
    [anon_sym_fc] = ACTIONS(2913),
    [anon_sym_fileno] = ACTIONS(2913),
    [anon_sym_gmtime] = ACTIONS(2913),
    [anon_sym_getc] = ACTIONS(2913),
    [anon_sym_getpgrp] = ACTIONS(2913),
    [anon_sym_getprotobyname] = ACTIONS(2913),
    [anon_sym_getpwname] = ACTIONS(2913),
    [anon_sym_getpwuid] = ACTIONS(2913),
    [anon_sym_getpeername] = ACTIONS(2913),
    [anon_sym_getnetbyname] = ACTIONS(2913),
    [anon_sym_getsockname] = ACTIONS(2913),
    [anon_sym_getgrnam] = ACTIONS(2913),
    [anon_sym_getgrgid] = ACTIONS(2913),
    [anon_sym_hex] = ACTIONS(2913),
    [anon_sym_int] = ACTIONS(2913),
    [anon_sym_keys] = ACTIONS(2913),
    [anon_sym_lc] = ACTIONS(2913),
    [anon_sym_lcfirst] = ACTIONS(2913),
    [anon_sym_length] = ACTIONS(2913),
    [anon_sym_localtime] = ACTIONS(2913),
    [anon_sym_log] = ACTIONS(2913),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_lstat] = ACTIONS(2913),
    [anon_sym_oct] = ACTIONS(2913),
    [anon_sym_ord] = ACTIONS(2913),
    [anon_sym_prototype] = ACTIONS(2913),
    [anon_sym_pop] = ACTIONS(2913),
    [anon_sym_pos] = ACTIONS(2913),
    [anon_sym_quotemeta] = ACTIONS(2913),
    [anon_sym_reset] = ACTIONS(2913),
    [anon_sym_rand] = ACTIONS(2913),
    [anon_sym_rmdir] = ACTIONS(2913),
    [anon_sym_readdir] = ACTIONS(2913),
    [anon_sym_readline] = ACTIONS(2913),
    [anon_sym_readpipe] = ACTIONS(2913),
    [anon_sym_rewinddir] = ACTIONS(2913),
    [anon_sym_readlink] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(2913),
    [anon_sym_scalar] = ACTIONS(2913),
    [anon_sym_shift] = ACTIONS(2913),
    [anon_sym_sin] = ACTIONS(2913),
    [anon_sym_sleep] = ACTIONS(2913),
    [anon_sym_sqrt] = ACTIONS(2913),
    [anon_sym_srand] = ACTIONS(2913),
    [anon_sym_stat] = ACTIONS(2913),
    [anon_sym_study] = ACTIONS(2913),
    [anon_sym_tell] = ACTIONS(2913),
    [anon_sym_telldir] = ACTIONS(2913),
    [anon_sym_tied] = ACTIONS(2913),
    [anon_sym_uc] = ACTIONS(2913),
    [anon_sym_ucfirst] = ACTIONS(2913),
    [anon_sym_untie] = ACTIONS(2913),
    [anon_sym_umask] = ACTIONS(2913),
    [anon_sym_values] = ACTIONS(2913),
    [anon_sym_write] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2913),
    [anon_sym___END__] = ACTIONS(2913),
    [anon_sym_EOT] = ACTIONS(2913),
    [anon_sym_q] = ACTIONS(2913),
    [anon_sym_qq] = ACTIONS(2913),
    [anon_sym_qw] = ACTIONS(2913),
    [anon_sym_qx] = ACTIONS(2913),
    [anon_sym_qr] = ACTIONS(2913),
    [anon_sym_m] = ACTIONS(2913),
    [anon_sym_s] = ACTIONS(2913),
    [anon_sym_tr] = ACTIONS(2913),
    [anon_sym_y] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_unless] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_until] = ACTIONS(2913),
    [aux_sym__bareword_token1] = ACTIONS(2913),
    [sym_number] = ACTIONS(2913),
    [sym__apostrophe] = ACTIONS(2917),
    [sym__double_quote] = ACTIONS(2917),
    [sym__backtick] = ACTIONS(2917),
    [sym__search_slash] = ACTIONS(2917),
    [sym__PERLY_SEMICOLON] = ACTIONS(2917),
    [sym__PERLY_HEREDOC] = ACTIONS(2917),
    [sym__ctrl_z_hack] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [917] = {
    [sym_heredoc_content] = STATE(917),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(2874),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [918] = {
    [sym_heredoc_content] = STATE(918),
    [sym__identifier] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_sub] = ACTIONS(2893),
    [anon_sym_method] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_my] = ACTIONS(2893),
    [anon_sym_state] = ACTIONS(2893),
    [anon_sym_our] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_elsif] = ACTIONS(2893),
    [anon_sym_and] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2893),
    [anon_sym_PLUS_EQ] = ACTIONS(2893),
    [anon_sym_DASH_EQ] = ACTIONS(2893),
    [anon_sym_DOT_EQ] = ACTIONS(2893),
    [anon_sym_STAR_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_PERCENT_EQ] = ACTIONS(2893),
    [anon_sym_x_EQ] = ACTIONS(2893),
    [anon_sym_AMP_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_CARET_EQ] = ACTIONS(2893),
    [anon_sym_LT_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_DOT_DOT] = ACTIONS(2893),
    [anon_sym_STAR_STAR] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_GT_GT2] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_x] = ACTIONS(2893),
    [anon_sym_EQ_TILDE] = ACTIONS(2893),
    [anon_sym_BANG_TILDE] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_eq] = ACTIONS(2893),
    [anon_sym_ne] = ACTIONS(2893),
    [anon_sym_LT_EQ_GT] = ACTIONS(2893),
    [anon_sym_cmp] = ACTIONS(2893),
    [anon_sym_TILDE_TILDE] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_lt] = ACTIONS(2893),
    [anon_sym_le] = ACTIONS(2893),
    [anon_sym_ge] = ACTIONS(2893),
    [anon_sym_gt] = ACTIONS(2893),
    [anon_sym_isa] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BSLASH] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_eval] = ACTIONS(2893),
    [anon_sym_field] = ACTIONS(2893),
    [anon_sym_local] = ACTIONS(2893),
    [anon_sym_require] = ACTIONS(2893),
    [anon_sym_map] = ACTIONS(2893),
    [anon_sym_grep] = ACTIONS(2893),
    [anon_sym_sort] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_undef] = ACTIONS(2893),
    [anon_sym_PERCENT2] = ACTIONS(2893),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2893),
    [anon_sym_EQ_GT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2893),
    [anon_sym_no] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_foreach] = ACTIONS(2893),
    [anon_sym_last] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2893),
    [anon_sym_redo] = ACTIONS(2893),
    [anon_sym_BEGIN] = ACTIONS(2893),
    [anon_sym_INIT] = ACTIONS(2893),
    [anon_sym_CHECK] = ACTIONS(2893),
    [anon_sym_UNITCHECK] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2893),
    [anon_sym_ADJUST] = ACTIONS(2893),
    [anon_sym___FILE__] = ACTIONS(2893),
    [anon_sym___LINE__] = ACTIONS(2893),
    [anon_sym___PACKAGE__] = ACTIONS(2893),
    [anon_sym___SUB__] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_fork] = ACTIONS(2893),
    [anon_sym_getppid] = ACTIONS(2893),
    [anon_sym_time] = ACTIONS(2893),
    [anon_sym_times] = ACTIONS(2893),
    [anon_sym_wait] = ACTIONS(2893),
    [anon_sym_wantarray] = ACTIONS(2893),
    [anon_sym_abs] = ACTIONS(2893),
    [anon_sym_alarm] = ACTIONS(2893),
    [anon_sym_chop] = ACTIONS(2893),
    [anon_sym_chdir] = ACTIONS(2893),
    [anon_sym_close] = ACTIONS(2893),
    [anon_sym_closedir] = ACTIONS(2893),
    [anon_sym_caller] = ACTIONS(2893),
    [anon_sym_chomp] = ACTIONS(2893),
    [anon_sym_chr] = ACTIONS(2893),
    [anon_sym_cos] = ACTIONS(2893),
    [anon_sym_chroot] = ACTIONS(2893),
    [anon_sym_defined] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_dbmclose] = ACTIONS(2893),
    [anon_sym_exists] = ACTIONS(2893),
    [anon_sym_exit] = ACTIONS(2893),
    [anon_sym_eof] = ACTIONS(2893),
    [anon_sym_exp] = ACTIONS(2893),
    [anon_sym_each] = ACTIONS(2893),
    [anon_sym_fc] = ACTIONS(2893),
    [anon_sym_fileno] = ACTIONS(2893),
    [anon_sym_gmtime] = ACTIONS(2893),
    [anon_sym_getc] = ACTIONS(2893),
    [anon_sym_getpgrp] = ACTIONS(2893),
    [anon_sym_getprotobyname] = ACTIONS(2893),
    [anon_sym_getpwname] = ACTIONS(2893),
    [anon_sym_getpwuid] = ACTIONS(2893),
    [anon_sym_getpeername] = ACTIONS(2893),
    [anon_sym_getnetbyname] = ACTIONS(2893),
    [anon_sym_getsockname] = ACTIONS(2893),
    [anon_sym_getgrnam] = ACTIONS(2893),
    [anon_sym_getgrgid] = ACTIONS(2893),
    [anon_sym_hex] = ACTIONS(2893),
    [anon_sym_int] = ACTIONS(2893),
    [anon_sym_keys] = ACTIONS(2893),
    [anon_sym_lc] = ACTIONS(2893),
    [anon_sym_lcfirst] = ACTIONS(2893),
    [anon_sym_length] = ACTIONS(2893),
    [anon_sym_localtime] = ACTIONS(2893),
    [anon_sym_log] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_lstat] = ACTIONS(2893),
    [anon_sym_oct] = ACTIONS(2893),
    [anon_sym_ord] = ACTIONS(2893),
    [anon_sym_prototype] = ACTIONS(2893),
    [anon_sym_pop] = ACTIONS(2893),
    [anon_sym_pos] = ACTIONS(2893),
    [anon_sym_quotemeta] = ACTIONS(2893),
    [anon_sym_reset] = ACTIONS(2893),
    [anon_sym_rand] = ACTIONS(2893),
    [anon_sym_rmdir] = ACTIONS(2893),
    [anon_sym_readdir] = ACTIONS(2893),
    [anon_sym_readline] = ACTIONS(2893),
    [anon_sym_readpipe] = ACTIONS(2893),
    [anon_sym_rewinddir] = ACTIONS(2893),
    [anon_sym_readlink] = ACTIONS(2893),
    [anon_sym_ref] = ACTIONS(2893),
    [anon_sym_scalar] = ACTIONS(2893),
    [anon_sym_shift] = ACTIONS(2893),
    [anon_sym_sin] = ACTIONS(2893),
    [anon_sym_sleep] = ACTIONS(2893),
    [anon_sym_sqrt] = ACTIONS(2893),
    [anon_sym_srand] = ACTIONS(2893),
    [anon_sym_stat] = ACTIONS(2893),
    [anon_sym_study] = ACTIONS(2893),
    [anon_sym_tell] = ACTIONS(2893),
    [anon_sym_telldir] = ACTIONS(2893),
    [anon_sym_tied] = ACTIONS(2893),
    [anon_sym_uc] = ACTIONS(2893),
    [anon_sym_ucfirst] = ACTIONS(2893),
    [anon_sym_untie] = ACTIONS(2893),
    [anon_sym_umask] = ACTIONS(2893),
    [anon_sym_values] = ACTIONS(2893),
    [anon_sym_write] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2893),
    [anon_sym___END__] = ACTIONS(2893),
    [anon_sym_EOT] = ACTIONS(2893),
    [anon_sym_q] = ACTIONS(2893),
    [anon_sym_qq] = ACTIONS(2893),
    [anon_sym_qw] = ACTIONS(2893),
    [anon_sym_qx] = ACTIONS(2893),
    [anon_sym_qr] = ACTIONS(2893),
    [anon_sym_m] = ACTIONS(2893),
    [anon_sym_s] = ACTIONS(2893),
    [anon_sym_tr] = ACTIONS(2893),
    [anon_sym_y] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_until] = ACTIONS(2893),
    [aux_sym__bareword_token1] = ACTIONS(2893),
    [sym_number] = ACTIONS(2893),
    [sym__apostrophe] = ACTIONS(2895),
    [sym__double_quote] = ACTIONS(2895),
    [sym__backtick] = ACTIONS(2895),
    [sym__search_slash] = ACTIONS(2895),
    [sym__PERLY_SEMICOLON] = ACTIONS(2895),
    [sym__PERLY_HEREDOC] = ACTIONS(2895),
    [sym__ctrl_z_hack] = ACTIONS(2895),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [919] = {
    [sym_heredoc_content] = STATE(919),
    [sym__identifier] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_sub] = ACTIONS(2885),
    [anon_sym_method] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_my] = ACTIONS(2885),
    [anon_sym_state] = ACTIONS(2885),
    [anon_sym_our] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_elsif] = ACTIONS(2885),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_DASH_GT] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_DOT_EQ] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_x_EQ] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_GT_GT2] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_x] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_eq] = ACTIONS(2885),
    [anon_sym_ne] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_cmp] = ACTIONS(2885),
    [anon_sym_TILDE_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_lt] = ACTIONS(2885),
    [anon_sym_le] = ACTIONS(2885),
    [anon_sym_ge] = ACTIONS(2885),
    [anon_sym_gt] = ACTIONS(2885),
    [anon_sym_isa] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BSLASH] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_eval] = ACTIONS(2885),
    [anon_sym_field] = ACTIONS(2885),
    [anon_sym_local] = ACTIONS(2885),
    [anon_sym_require] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(2885),
    [anon_sym_grep] = ACTIONS(2885),
    [anon_sym_sort] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_undef] = ACTIONS(2885),
    [anon_sym_PERCENT2] = ACTIONS(2885),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2885),
    [anon_sym_no] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_foreach] = ACTIONS(2885),
    [anon_sym_last] = ACTIONS(2885),
    [anon_sym_next] = ACTIONS(2885),
    [anon_sym_redo] = ACTIONS(2885),
    [anon_sym_BEGIN] = ACTIONS(2885),
    [anon_sym_INIT] = ACTIONS(2885),
    [anon_sym_CHECK] = ACTIONS(2885),
    [anon_sym_UNITCHECK] = ACTIONS(2885),
    [anon_sym_END] = ACTIONS(2885),
    [anon_sym_ADJUST] = ACTIONS(2885),
    [anon_sym___FILE__] = ACTIONS(2885),
    [anon_sym___LINE__] = ACTIONS(2885),
    [anon_sym___PACKAGE__] = ACTIONS(2885),
    [anon_sym___SUB__] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_fork] = ACTIONS(2885),
    [anon_sym_getppid] = ACTIONS(2885),
    [anon_sym_time] = ACTIONS(2885),
    [anon_sym_times] = ACTIONS(2885),
    [anon_sym_wait] = ACTIONS(2885),
    [anon_sym_wantarray] = ACTIONS(2885),
    [anon_sym_abs] = ACTIONS(2885),
    [anon_sym_alarm] = ACTIONS(2885),
    [anon_sym_chop] = ACTIONS(2885),
    [anon_sym_chdir] = ACTIONS(2885),
    [anon_sym_close] = ACTIONS(2885),
    [anon_sym_closedir] = ACTIONS(2885),
    [anon_sym_caller] = ACTIONS(2885),
    [anon_sym_chomp] = ACTIONS(2885),
    [anon_sym_chr] = ACTIONS(2885),
    [anon_sym_cos] = ACTIONS(2885),
    [anon_sym_chroot] = ACTIONS(2885),
    [anon_sym_defined] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_dbmclose] = ACTIONS(2885),
    [anon_sym_exists] = ACTIONS(2885),
    [anon_sym_exit] = ACTIONS(2885),
    [anon_sym_eof] = ACTIONS(2885),
    [anon_sym_exp] = ACTIONS(2885),
    [anon_sym_each] = ACTIONS(2885),
    [anon_sym_fc] = ACTIONS(2885),
    [anon_sym_fileno] = ACTIONS(2885),
    [anon_sym_gmtime] = ACTIONS(2885),
    [anon_sym_getc] = ACTIONS(2885),
    [anon_sym_getpgrp] = ACTIONS(2885),
    [anon_sym_getprotobyname] = ACTIONS(2885),
    [anon_sym_getpwname] = ACTIONS(2885),
    [anon_sym_getpwuid] = ACTIONS(2885),
    [anon_sym_getpeername] = ACTIONS(2885),
    [anon_sym_getnetbyname] = ACTIONS(2885),
    [anon_sym_getsockname] = ACTIONS(2885),
    [anon_sym_getgrnam] = ACTIONS(2885),
    [anon_sym_getgrgid] = ACTIONS(2885),
    [anon_sym_hex] = ACTIONS(2885),
    [anon_sym_int] = ACTIONS(2885),
    [anon_sym_keys] = ACTIONS(2885),
    [anon_sym_lc] = ACTIONS(2885),
    [anon_sym_lcfirst] = ACTIONS(2885),
    [anon_sym_length] = ACTIONS(2885),
    [anon_sym_localtime] = ACTIONS(2885),
    [anon_sym_log] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_lstat] = ACTIONS(2885),
    [anon_sym_oct] = ACTIONS(2885),
    [anon_sym_ord] = ACTIONS(2885),
    [anon_sym_prototype] = ACTIONS(2885),
    [anon_sym_pop] = ACTIONS(2885),
    [anon_sym_pos] = ACTIONS(2885),
    [anon_sym_quotemeta] = ACTIONS(2885),
    [anon_sym_reset] = ACTIONS(2885),
    [anon_sym_rand] = ACTIONS(2885),
    [anon_sym_rmdir] = ACTIONS(2885),
    [anon_sym_readdir] = ACTIONS(2885),
    [anon_sym_readline] = ACTIONS(2885),
    [anon_sym_readpipe] = ACTIONS(2885),
    [anon_sym_rewinddir] = ACTIONS(2885),
    [anon_sym_readlink] = ACTIONS(2885),
    [anon_sym_ref] = ACTIONS(2885),
    [anon_sym_scalar] = ACTIONS(2885),
    [anon_sym_shift] = ACTIONS(2885),
    [anon_sym_sin] = ACTIONS(2885),
    [anon_sym_sleep] = ACTIONS(2885),
    [anon_sym_sqrt] = ACTIONS(2885),
    [anon_sym_srand] = ACTIONS(2885),
    [anon_sym_stat] = ACTIONS(2885),
    [anon_sym_study] = ACTIONS(2885),
    [anon_sym_tell] = ACTIONS(2885),
    [anon_sym_telldir] = ACTIONS(2885),
    [anon_sym_tied] = ACTIONS(2885),
    [anon_sym_uc] = ACTIONS(2885),
    [anon_sym_ucfirst] = ACTIONS(2885),
    [anon_sym_untie] = ACTIONS(2885),
    [anon_sym_umask] = ACTIONS(2885),
    [anon_sym_values] = ACTIONS(2885),
    [anon_sym_write] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2885),
    [anon_sym___END__] = ACTIONS(2885),
    [anon_sym_EOT] = ACTIONS(2885),
    [anon_sym_q] = ACTIONS(2885),
    [anon_sym_qq] = ACTIONS(2885),
    [anon_sym_qw] = ACTIONS(2885),
    [anon_sym_qx] = ACTIONS(2885),
    [anon_sym_qr] = ACTIONS(2885),
    [anon_sym_m] = ACTIONS(2885),
    [anon_sym_s] = ACTIONS(2885),
    [anon_sym_tr] = ACTIONS(2885),
    [anon_sym_y] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [aux_sym__bareword_token1] = ACTIONS(2885),
    [sym_number] = ACTIONS(2885),
    [sym__apostrophe] = ACTIONS(2887),
    [sym__double_quote] = ACTIONS(2887),
    [sym__backtick] = ACTIONS(2887),
    [sym__search_slash] = ACTIONS(2887),
    [sym__PERLY_SEMICOLON] = ACTIONS(2887),
    [sym__PERLY_HEREDOC] = ACTIONS(2887),
    [sym__ctrl_z_hack] = ACTIONS(2887),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [920] = {
    [sym_heredoc_content] = STATE(920),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [921] = {
    [sym_heredoc_content] = STATE(921),
    [sym__identifier] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym_class] = ACTIONS(2909),
    [anon_sym_sub] = ACTIONS(2909),
    [anon_sym_method] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_my] = ACTIONS(2909),
    [anon_sym_state] = ACTIONS(2909),
    [anon_sym_our] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2909),
    [anon_sym_try] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2909),
    [anon_sym_else] = ACTIONS(2909),
    [anon_sym_elsif] = ACTIONS(2909),
    [anon_sym_and] = ACTIONS(2909),
    [anon_sym_or] = ACTIONS(2909),
    [anon_sym_DOLLAR] = ACTIONS(2909),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_AT] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2909),
    [anon_sym_PLUS_EQ] = ACTIONS(2909),
    [anon_sym_DASH_EQ] = ACTIONS(2909),
    [anon_sym_DOT_EQ] = ACTIONS(2909),
    [anon_sym_STAR_EQ] = ACTIONS(2909),
    [anon_sym_SLASH_EQ] = ACTIONS(2909),
    [anon_sym_PERCENT_EQ] = ACTIONS(2909),
    [anon_sym_x_EQ] = ACTIONS(2909),
    [anon_sym_AMP_EQ] = ACTIONS(2909),
    [anon_sym_PIPE_EQ] = ACTIONS(2909),
    [anon_sym_CARET_EQ] = ACTIONS(2909),
    [anon_sym_LT_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_GT_EQ] = ACTIONS(2909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2909),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_GT_GT2] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_x] = ACTIONS(2909),
    [anon_sym_EQ_TILDE] = ACTIONS(2909),
    [anon_sym_BANG_TILDE] = ACTIONS(2909),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2909),
    [anon_sym_eq] = ACTIONS(2909),
    [anon_sym_ne] = ACTIONS(2909),
    [anon_sym_LT_EQ_GT] = ACTIONS(2909),
    [anon_sym_cmp] = ACTIONS(2909),
    [anon_sym_TILDE_TILDE] = ACTIONS(2909),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2909),
    [anon_sym_lt] = ACTIONS(2909),
    [anon_sym_le] = ACTIONS(2909),
    [anon_sym_ge] = ACTIONS(2909),
    [anon_sym_gt] = ACTIONS(2909),
    [anon_sym_isa] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_QMARK] = ACTIONS(2909),
    [anon_sym_BSLASH] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2909),
    [anon_sym_eval] = ACTIONS(2909),
    [anon_sym_field] = ACTIONS(2909),
    [anon_sym_local] = ACTIONS(2909),
    [anon_sym_require] = ACTIONS(2909),
    [anon_sym_map] = ACTIONS(2909),
    [anon_sym_grep] = ACTIONS(2909),
    [anon_sym_sort] = ACTIONS(2909),
    [anon_sym_goto] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_undef] = ACTIONS(2909),
    [anon_sym_PERCENT2] = ACTIONS(2909),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2909),
    [anon_sym_EQ_GT] = ACTIONS(2909),
    [anon_sym_use] = ACTIONS(2909),
    [anon_sym_no] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_foreach] = ACTIONS(2909),
    [anon_sym_last] = ACTIONS(2909),
    [anon_sym_next] = ACTIONS(2909),
    [anon_sym_redo] = ACTIONS(2909),
    [anon_sym_BEGIN] = ACTIONS(2909),
    [anon_sym_INIT] = ACTIONS(2909),
    [anon_sym_CHECK] = ACTIONS(2909),
    [anon_sym_UNITCHECK] = ACTIONS(2909),
    [anon_sym_END] = ACTIONS(2909),
    [anon_sym_ADJUST] = ACTIONS(2909),
    [anon_sym___FILE__] = ACTIONS(2909),
    [anon_sym___LINE__] = ACTIONS(2909),
    [anon_sym___PACKAGE__] = ACTIONS(2909),
    [anon_sym___SUB__] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_fork] = ACTIONS(2909),
    [anon_sym_getppid] = ACTIONS(2909),
    [anon_sym_time] = ACTIONS(2909),
    [anon_sym_times] = ACTIONS(2909),
    [anon_sym_wait] = ACTIONS(2909),
    [anon_sym_wantarray] = ACTIONS(2909),
    [anon_sym_abs] = ACTIONS(2909),
    [anon_sym_alarm] = ACTIONS(2909),
    [anon_sym_chop] = ACTIONS(2909),
    [anon_sym_chdir] = ACTIONS(2909),
    [anon_sym_close] = ACTIONS(2909),
    [anon_sym_closedir] = ACTIONS(2909),
    [anon_sym_caller] = ACTIONS(2909),
    [anon_sym_chomp] = ACTIONS(2909),
    [anon_sym_chr] = ACTIONS(2909),
    [anon_sym_cos] = ACTIONS(2909),
    [anon_sym_chroot] = ACTIONS(2909),
    [anon_sym_defined] = ACTIONS(2909),
    [anon_sym_delete] = ACTIONS(2909),
    [anon_sym_dbmclose] = ACTIONS(2909),
    [anon_sym_exists] = ACTIONS(2909),
    [anon_sym_exit] = ACTIONS(2909),
    [anon_sym_eof] = ACTIONS(2909),
    [anon_sym_exp] = ACTIONS(2909),
    [anon_sym_each] = ACTIONS(2909),
    [anon_sym_fc] = ACTIONS(2909),
    [anon_sym_fileno] = ACTIONS(2909),
    [anon_sym_gmtime] = ACTIONS(2909),
    [anon_sym_getc] = ACTIONS(2909),
    [anon_sym_getpgrp] = ACTIONS(2909),
    [anon_sym_getprotobyname] = ACTIONS(2909),
    [anon_sym_getpwname] = ACTIONS(2909),
    [anon_sym_getpwuid] = ACTIONS(2909),
    [anon_sym_getpeername] = ACTIONS(2909),
    [anon_sym_getnetbyname] = ACTIONS(2909),
    [anon_sym_getsockname] = ACTIONS(2909),
    [anon_sym_getgrnam] = ACTIONS(2909),
    [anon_sym_getgrgid] = ACTIONS(2909),
    [anon_sym_hex] = ACTIONS(2909),
    [anon_sym_int] = ACTIONS(2909),
    [anon_sym_keys] = ACTIONS(2909),
    [anon_sym_lc] = ACTIONS(2909),
    [anon_sym_lcfirst] = ACTIONS(2909),
    [anon_sym_length] = ACTIONS(2909),
    [anon_sym_localtime] = ACTIONS(2909),
    [anon_sym_log] = ACTIONS(2909),
    [anon_sym_lock] = ACTIONS(2909),
    [anon_sym_lstat] = ACTIONS(2909),
    [anon_sym_oct] = ACTIONS(2909),
    [anon_sym_ord] = ACTIONS(2909),
    [anon_sym_prototype] = ACTIONS(2909),
    [anon_sym_pop] = ACTIONS(2909),
    [anon_sym_pos] = ACTIONS(2909),
    [anon_sym_quotemeta] = ACTIONS(2909),
    [anon_sym_reset] = ACTIONS(2909),
    [anon_sym_rand] = ACTIONS(2909),
    [anon_sym_rmdir] = ACTIONS(2909),
    [anon_sym_readdir] = ACTIONS(2909),
    [anon_sym_readline] = ACTIONS(2909),
    [anon_sym_readpipe] = ACTIONS(2909),
    [anon_sym_rewinddir] = ACTIONS(2909),
    [anon_sym_readlink] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(2909),
    [anon_sym_scalar] = ACTIONS(2909),
    [anon_sym_shift] = ACTIONS(2909),
    [anon_sym_sin] = ACTIONS(2909),
    [anon_sym_sleep] = ACTIONS(2909),
    [anon_sym_sqrt] = ACTIONS(2909),
    [anon_sym_srand] = ACTIONS(2909),
    [anon_sym_stat] = ACTIONS(2909),
    [anon_sym_study] = ACTIONS(2909),
    [anon_sym_tell] = ACTIONS(2909),
    [anon_sym_telldir] = ACTIONS(2909),
    [anon_sym_tied] = ACTIONS(2909),
    [anon_sym_uc] = ACTIONS(2909),
    [anon_sym_ucfirst] = ACTIONS(2909),
    [anon_sym_untie] = ACTIONS(2909),
    [anon_sym_umask] = ACTIONS(2909),
    [anon_sym_values] = ACTIONS(2909),
    [anon_sym_write] = ACTIONS(2909),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2909),
    [anon_sym___END__] = ACTIONS(2909),
    [anon_sym_EOT] = ACTIONS(2909),
    [anon_sym_q] = ACTIONS(2909),
    [anon_sym_qq] = ACTIONS(2909),
    [anon_sym_qw] = ACTIONS(2909),
    [anon_sym_qx] = ACTIONS(2909),
    [anon_sym_qr] = ACTIONS(2909),
    [anon_sym_m] = ACTIONS(2909),
    [anon_sym_s] = ACTIONS(2909),
    [anon_sym_tr] = ACTIONS(2909),
    [anon_sym_y] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_unless] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_until] = ACTIONS(2909),
    [aux_sym__bareword_token1] = ACTIONS(2909),
    [sym_number] = ACTIONS(2909),
    [sym__apostrophe] = ACTIONS(2911),
    [sym__double_quote] = ACTIONS(2911),
    [sym__backtick] = ACTIONS(2911),
    [sym__search_slash] = ACTIONS(2911),
    [sym__PERLY_SEMICOLON] = ACTIONS(2911),
    [sym__PERLY_HEREDOC] = ACTIONS(2911),
    [sym__ctrl_z_hack] = ACTIONS(2911),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [922] = {
    [sym_heredoc_content] = STATE(922),
    [sym__identifier] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_sub] = ACTIONS(2919),
    [anon_sym_method] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_my] = ACTIONS(2919),
    [anon_sym_state] = ACTIONS(2919),
    [anon_sym_our] = ACTIONS(2919),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2919),
    [anon_sym_else] = ACTIONS(2919),
    [anon_sym_elsif] = ACTIONS(2919),
    [anon_sym_and] = ACTIONS(2919),
    [anon_sym_or] = ACTIONS(2919),
    [anon_sym_DOLLAR] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_DASH_GT] = ACTIONS(2919),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_PERCENT] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(2919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2919),
    [anon_sym_PLUS_EQ] = ACTIONS(2919),
    [anon_sym_DASH_EQ] = ACTIONS(2919),
    [anon_sym_DOT_EQ] = ACTIONS(2919),
    [anon_sym_STAR_EQ] = ACTIONS(2919),
    [anon_sym_SLASH_EQ] = ACTIONS(2919),
    [anon_sym_PERCENT_EQ] = ACTIONS(2919),
    [anon_sym_x_EQ] = ACTIONS(2919),
    [anon_sym_AMP_EQ] = ACTIONS(2919),
    [anon_sym_PIPE_EQ] = ACTIONS(2919),
    [anon_sym_CARET_EQ] = ACTIONS(2919),
    [anon_sym_LT_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_GT_EQ] = ACTIONS(2919),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2919),
    [anon_sym_DOT_DOT] = ACTIONS(2919),
    [anon_sym_STAR_STAR] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_GT_GT2] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2919),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_x] = ACTIONS(2919),
    [anon_sym_EQ_TILDE] = ACTIONS(2919),
    [anon_sym_BANG_TILDE] = ACTIONS(2919),
    [anon_sym_EQ_EQ] = ACTIONS(2919),
    [anon_sym_BANG_EQ] = ACTIONS(2919),
    [anon_sym_eq] = ACTIONS(2919),
    [anon_sym_ne] = ACTIONS(2919),
    [anon_sym_LT_EQ_GT] = ACTIONS(2919),
    [anon_sym_cmp] = ACTIONS(2919),
    [anon_sym_TILDE_TILDE] = ACTIONS(2919),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2919),
    [anon_sym_lt] = ACTIONS(2919),
    [anon_sym_le] = ACTIONS(2919),
    [anon_sym_ge] = ACTIONS(2919),
    [anon_sym_gt] = ACTIONS(2919),
    [anon_sym_isa] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2919),
    [anon_sym_BANG] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2919),
    [anon_sym_QMARK] = ACTIONS(2919),
    [anon_sym_BSLASH] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_eval] = ACTIONS(2919),
    [anon_sym_field] = ACTIONS(2919),
    [anon_sym_local] = ACTIONS(2919),
    [anon_sym_require] = ACTIONS(2919),
    [anon_sym_map] = ACTIONS(2919),
    [anon_sym_grep] = ACTIONS(2919),
    [anon_sym_sort] = ACTIONS(2919),
    [anon_sym_goto] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_undef] = ACTIONS(2919),
    [anon_sym_PERCENT2] = ACTIONS(2919),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2919),
    [anon_sym_EQ_GT] = ACTIONS(2919),
    [anon_sym_use] = ACTIONS(2919),
    [anon_sym_no] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_foreach] = ACTIONS(2919),
    [anon_sym_last] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2919),
    [anon_sym_redo] = ACTIONS(2919),
    [anon_sym_BEGIN] = ACTIONS(2919),
    [anon_sym_INIT] = ACTIONS(2919),
    [anon_sym_CHECK] = ACTIONS(2919),
    [anon_sym_UNITCHECK] = ACTIONS(2919),
    [anon_sym_END] = ACTIONS(2919),
    [anon_sym_ADJUST] = ACTIONS(2919),
    [anon_sym___FILE__] = ACTIONS(2919),
    [anon_sym___LINE__] = ACTIONS(2919),
    [anon_sym___PACKAGE__] = ACTIONS(2919),
    [anon_sym___SUB__] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_fork] = ACTIONS(2919),
    [anon_sym_getppid] = ACTIONS(2919),
    [anon_sym_time] = ACTIONS(2919),
    [anon_sym_times] = ACTIONS(2919),
    [anon_sym_wait] = ACTIONS(2919),
    [anon_sym_wantarray] = ACTIONS(2919),
    [anon_sym_abs] = ACTIONS(2919),
    [anon_sym_alarm] = ACTIONS(2919),
    [anon_sym_chop] = ACTIONS(2919),
    [anon_sym_chdir] = ACTIONS(2919),
    [anon_sym_close] = ACTIONS(2919),
    [anon_sym_closedir] = ACTIONS(2919),
    [anon_sym_caller] = ACTIONS(2919),
    [anon_sym_chomp] = ACTIONS(2919),
    [anon_sym_chr] = ACTIONS(2919),
    [anon_sym_cos] = ACTIONS(2919),
    [anon_sym_chroot] = ACTIONS(2919),
    [anon_sym_defined] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_dbmclose] = ACTIONS(2919),
    [anon_sym_exists] = ACTIONS(2919),
    [anon_sym_exit] = ACTIONS(2919),
    [anon_sym_eof] = ACTIONS(2919),
    [anon_sym_exp] = ACTIONS(2919),
    [anon_sym_each] = ACTIONS(2919),
    [anon_sym_fc] = ACTIONS(2919),
    [anon_sym_fileno] = ACTIONS(2919),
    [anon_sym_gmtime] = ACTIONS(2919),
    [anon_sym_getc] = ACTIONS(2919),
    [anon_sym_getpgrp] = ACTIONS(2919),
    [anon_sym_getprotobyname] = ACTIONS(2919),
    [anon_sym_getpwname] = ACTIONS(2919),
    [anon_sym_getpwuid] = ACTIONS(2919),
    [anon_sym_getpeername] = ACTIONS(2919),
    [anon_sym_getnetbyname] = ACTIONS(2919),
    [anon_sym_getsockname] = ACTIONS(2919),
    [anon_sym_getgrnam] = ACTIONS(2919),
    [anon_sym_getgrgid] = ACTIONS(2919),
    [anon_sym_hex] = ACTIONS(2919),
    [anon_sym_int] = ACTIONS(2919),
    [anon_sym_keys] = ACTIONS(2919),
    [anon_sym_lc] = ACTIONS(2919),
    [anon_sym_lcfirst] = ACTIONS(2919),
    [anon_sym_length] = ACTIONS(2919),
    [anon_sym_localtime] = ACTIONS(2919),
    [anon_sym_log] = ACTIONS(2919),
    [anon_sym_lock] = ACTIONS(2919),
    [anon_sym_lstat] = ACTIONS(2919),
    [anon_sym_oct] = ACTIONS(2919),
    [anon_sym_ord] = ACTIONS(2919),
    [anon_sym_prototype] = ACTIONS(2919),
    [anon_sym_pop] = ACTIONS(2919),
    [anon_sym_pos] = ACTIONS(2919),
    [anon_sym_quotemeta] = ACTIONS(2919),
    [anon_sym_reset] = ACTIONS(2919),
    [anon_sym_rand] = ACTIONS(2919),
    [anon_sym_rmdir] = ACTIONS(2919),
    [anon_sym_readdir] = ACTIONS(2919),
    [anon_sym_readline] = ACTIONS(2919),
    [anon_sym_readpipe] = ACTIONS(2919),
    [anon_sym_rewinddir] = ACTIONS(2919),
    [anon_sym_readlink] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(2919),
    [anon_sym_scalar] = ACTIONS(2919),
    [anon_sym_shift] = ACTIONS(2919),
    [anon_sym_sin] = ACTIONS(2919),
    [anon_sym_sleep] = ACTIONS(2919),
    [anon_sym_sqrt] = ACTIONS(2919),
    [anon_sym_srand] = ACTIONS(2919),
    [anon_sym_stat] = ACTIONS(2919),
    [anon_sym_study] = ACTIONS(2919),
    [anon_sym_tell] = ACTIONS(2919),
    [anon_sym_telldir] = ACTIONS(2919),
    [anon_sym_tied] = ACTIONS(2919),
    [anon_sym_uc] = ACTIONS(2919),
    [anon_sym_ucfirst] = ACTIONS(2919),
    [anon_sym_untie] = ACTIONS(2919),
    [anon_sym_umask] = ACTIONS(2919),
    [anon_sym_values] = ACTIONS(2919),
    [anon_sym_write] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2919),
    [anon_sym___END__] = ACTIONS(2919),
    [anon_sym_EOT] = ACTIONS(2919),
    [anon_sym_q] = ACTIONS(2919),
    [anon_sym_qq] = ACTIONS(2919),
    [anon_sym_qw] = ACTIONS(2919),
    [anon_sym_qx] = ACTIONS(2919),
    [anon_sym_qr] = ACTIONS(2919),
    [anon_sym_m] = ACTIONS(2919),
    [anon_sym_s] = ACTIONS(2919),
    [anon_sym_tr] = ACTIONS(2919),
    [anon_sym_y] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_unless] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_until] = ACTIONS(2919),
    [aux_sym__bareword_token1] = ACTIONS(2919),
    [sym_number] = ACTIONS(2919),
    [sym__apostrophe] = ACTIONS(2921),
    [sym__double_quote] = ACTIONS(2921),
    [sym__backtick] = ACTIONS(2921),
    [sym__search_slash] = ACTIONS(2921),
    [sym__PERLY_SEMICOLON] = ACTIONS(2921),
    [sym__PERLY_HEREDOC] = ACTIONS(2921),
    [sym__ctrl_z_hack] = ACTIONS(2921),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [923] = {
    [sym_heredoc_content] = STATE(923),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [924] = {
    [sym_heredoc_content] = STATE(924),
    [sym__identifier] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_sub] = ACTIONS(2889),
    [anon_sym_method] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_my] = ACTIONS(2889),
    [anon_sym_state] = ACTIONS(2889),
    [anon_sym_our] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2889),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_elsif] = ACTIONS(2889),
    [anon_sym_and] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2889),
    [anon_sym_DASH_GT] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2889),
    [anon_sym_PLUS_EQ] = ACTIONS(2889),
    [anon_sym_DASH_EQ] = ACTIONS(2889),
    [anon_sym_DOT_EQ] = ACTIONS(2889),
    [anon_sym_STAR_EQ] = ACTIONS(2889),
    [anon_sym_SLASH_EQ] = ACTIONS(2889),
    [anon_sym_PERCENT_EQ] = ACTIONS(2889),
    [anon_sym_x_EQ] = ACTIONS(2889),
    [anon_sym_AMP_EQ] = ACTIONS(2889),
    [anon_sym_PIPE_EQ] = ACTIONS(2889),
    [anon_sym_CARET_EQ] = ACTIONS(2889),
    [anon_sym_LT_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_GT_EQ] = ACTIONS(2889),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT] = ACTIONS(2889),
    [anon_sym_STAR_STAR] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_GT_GT2] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_x] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2889),
    [anon_sym_BANG_TILDE] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2889),
    [anon_sym_eq] = ACTIONS(2889),
    [anon_sym_ne] = ACTIONS(2889),
    [anon_sym_LT_EQ_GT] = ACTIONS(2889),
    [anon_sym_cmp] = ACTIONS(2889),
    [anon_sym_TILDE_TILDE] = ACTIONS(2889),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2889),
    [anon_sym_lt] = ACTIONS(2889),
    [anon_sym_le] = ACTIONS(2889),
    [anon_sym_ge] = ACTIONS(2889),
    [anon_sym_gt] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BSLASH] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_eval] = ACTIONS(2889),
    [anon_sym_field] = ACTIONS(2889),
    [anon_sym_local] = ACTIONS(2889),
    [anon_sym_require] = ACTIONS(2889),
    [anon_sym_map] = ACTIONS(2889),
    [anon_sym_grep] = ACTIONS(2889),
    [anon_sym_sort] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_undef] = ACTIONS(2889),
    [anon_sym_PERCENT2] = ACTIONS(2889),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2889),
    [anon_sym_EQ_GT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2889),
    [anon_sym_no] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_foreach] = ACTIONS(2889),
    [anon_sym_last] = ACTIONS(2889),
    [anon_sym_next] = ACTIONS(2889),
    [anon_sym_redo] = ACTIONS(2889),
    [anon_sym_BEGIN] = ACTIONS(2889),
    [anon_sym_INIT] = ACTIONS(2889),
    [anon_sym_CHECK] = ACTIONS(2889),
    [anon_sym_UNITCHECK] = ACTIONS(2889),
    [anon_sym_END] = ACTIONS(2889),
    [anon_sym_ADJUST] = ACTIONS(2889),
    [anon_sym___FILE__] = ACTIONS(2889),
    [anon_sym___LINE__] = ACTIONS(2889),
    [anon_sym___PACKAGE__] = ACTIONS(2889),
    [anon_sym___SUB__] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_fork] = ACTIONS(2889),
    [anon_sym_getppid] = ACTIONS(2889),
    [anon_sym_time] = ACTIONS(2889),
    [anon_sym_times] = ACTIONS(2889),
    [anon_sym_wait] = ACTIONS(2889),
    [anon_sym_wantarray] = ACTIONS(2889),
    [anon_sym_abs] = ACTIONS(2889),
    [anon_sym_alarm] = ACTIONS(2889),
    [anon_sym_chop] = ACTIONS(2889),
    [anon_sym_chdir] = ACTIONS(2889),
    [anon_sym_close] = ACTIONS(2889),
    [anon_sym_closedir] = ACTIONS(2889),
    [anon_sym_caller] = ACTIONS(2889),
    [anon_sym_chomp] = ACTIONS(2889),
    [anon_sym_chr] = ACTIONS(2889),
    [anon_sym_cos] = ACTIONS(2889),
    [anon_sym_chroot] = ACTIONS(2889),
    [anon_sym_defined] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_dbmclose] = ACTIONS(2889),
    [anon_sym_exists] = ACTIONS(2889),
    [anon_sym_exit] = ACTIONS(2889),
    [anon_sym_eof] = ACTIONS(2889),
    [anon_sym_exp] = ACTIONS(2889),
    [anon_sym_each] = ACTIONS(2889),
    [anon_sym_fc] = ACTIONS(2889),
    [anon_sym_fileno] = ACTIONS(2889),
    [anon_sym_gmtime] = ACTIONS(2889),
    [anon_sym_getc] = ACTIONS(2889),
    [anon_sym_getpgrp] = ACTIONS(2889),
    [anon_sym_getprotobyname] = ACTIONS(2889),
    [anon_sym_getpwname] = ACTIONS(2889),
    [anon_sym_getpwuid] = ACTIONS(2889),
    [anon_sym_getpeername] = ACTIONS(2889),
    [anon_sym_getnetbyname] = ACTIONS(2889),
    [anon_sym_getsockname] = ACTIONS(2889),
    [anon_sym_getgrnam] = ACTIONS(2889),
    [anon_sym_getgrgid] = ACTIONS(2889),
    [anon_sym_hex] = ACTIONS(2889),
    [anon_sym_int] = ACTIONS(2889),
    [anon_sym_keys] = ACTIONS(2889),
    [anon_sym_lc] = ACTIONS(2889),
    [anon_sym_lcfirst] = ACTIONS(2889),
    [anon_sym_length] = ACTIONS(2889),
    [anon_sym_localtime] = ACTIONS(2889),
    [anon_sym_log] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_lstat] = ACTIONS(2889),
    [anon_sym_oct] = ACTIONS(2889),
    [anon_sym_ord] = ACTIONS(2889),
    [anon_sym_prototype] = ACTIONS(2889),
    [anon_sym_pop] = ACTIONS(2889),
    [anon_sym_pos] = ACTIONS(2889),
    [anon_sym_quotemeta] = ACTIONS(2889),
    [anon_sym_reset] = ACTIONS(2889),
    [anon_sym_rand] = ACTIONS(2889),
    [anon_sym_rmdir] = ACTIONS(2889),
    [anon_sym_readdir] = ACTIONS(2889),
    [anon_sym_readline] = ACTIONS(2889),
    [anon_sym_readpipe] = ACTIONS(2889),
    [anon_sym_rewinddir] = ACTIONS(2889),
    [anon_sym_readlink] = ACTIONS(2889),
    [anon_sym_ref] = ACTIONS(2889),
    [anon_sym_scalar] = ACTIONS(2889),
    [anon_sym_shift] = ACTIONS(2889),
    [anon_sym_sin] = ACTIONS(2889),
    [anon_sym_sleep] = ACTIONS(2889),
    [anon_sym_sqrt] = ACTIONS(2889),
    [anon_sym_srand] = ACTIONS(2889),
    [anon_sym_stat] = ACTIONS(2889),
    [anon_sym_study] = ACTIONS(2889),
    [anon_sym_tell] = ACTIONS(2889),
    [anon_sym_telldir] = ACTIONS(2889),
    [anon_sym_tied] = ACTIONS(2889),
    [anon_sym_uc] = ACTIONS(2889),
    [anon_sym_ucfirst] = ACTIONS(2889),
    [anon_sym_untie] = ACTIONS(2889),
    [anon_sym_umask] = ACTIONS(2889),
    [anon_sym_values] = ACTIONS(2889),
    [anon_sym_write] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2889),
    [anon_sym___END__] = ACTIONS(2889),
    [anon_sym_EOT] = ACTIONS(2889),
    [anon_sym_q] = ACTIONS(2889),
    [anon_sym_qq] = ACTIONS(2889),
    [anon_sym_qw] = ACTIONS(2889),
    [anon_sym_qx] = ACTIONS(2889),
    [anon_sym_qr] = ACTIONS(2889),
    [anon_sym_m] = ACTIONS(2889),
    [anon_sym_s] = ACTIONS(2889),
    [anon_sym_tr] = ACTIONS(2889),
    [anon_sym_y] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_unless] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_until] = ACTIONS(2889),
    [aux_sym__bareword_token1] = ACTIONS(2889),
    [sym_number] = ACTIONS(2889),
    [sym__apostrophe] = ACTIONS(2891),
    [sym__double_quote] = ACTIONS(2891),
    [sym__backtick] = ACTIONS(2891),
    [sym__search_slash] = ACTIONS(2891),
    [sym__PERLY_SEMICOLON] = ACTIONS(2891),
    [sym__PERLY_HEREDOC] = ACTIONS(2891),
    [sym__ctrl_z_hack] = ACTIONS(2891),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [925] = {
    [sym_heredoc_content] = STATE(925),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2872),
    [anon_sym_GT] = ACTIONS(2872),
    [anon_sym_LT_LT] = ACTIONS(2872),
    [anon_sym_EQ] = ACTIONS(2872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2872),
    [anon_sym_PLUS_EQ] = ACTIONS(2872),
    [anon_sym_DASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_EQ] = ACTIONS(2872),
    [anon_sym_STAR_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_PERCENT_EQ] = ACTIONS(2872),
    [anon_sym_x_EQ] = ACTIONS(2872),
    [anon_sym_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_CARET_EQ] = ACTIONS(2872),
    [anon_sym_LT_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_GT_EQ] = ACTIONS(2872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [anon_sym_STAR_STAR] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH] = ACTIONS(2872),
    [anon_sym_AMP_AMP] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(2872),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_GT_GT2] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_DOT] = ACTIONS(2872),
    [anon_sym_STAR] = ACTIONS(2872),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_x] = ACTIONS(2872),
    [anon_sym_EQ_TILDE] = ACTIONS(2872),
    [anon_sym_BANG_TILDE] = ACTIONS(2872),
    [anon_sym_EQ_EQ] = ACTIONS(2872),
    [anon_sym_BANG_EQ] = ACTIONS(2872),
    [anon_sym_eq] = ACTIONS(2872),
    [anon_sym_ne] = ACTIONS(2872),
    [anon_sym_LT_EQ_GT] = ACTIONS(2872),
    [anon_sym_cmp] = ACTIONS(2872),
    [anon_sym_TILDE_TILDE] = ACTIONS(2872),
    [anon_sym_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_EQ] = ACTIONS(2872),
    [anon_sym_lt] = ACTIONS(2872),
    [anon_sym_le] = ACTIONS(2872),
    [anon_sym_ge] = ACTIONS(2872),
    [anon_sym_gt] = ACTIONS(2872),
    [anon_sym_isa] = ACTIONS(2872),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2872),
    [anon_sym_DASH_DASH] = ACTIONS(2872),
    [anon_sym_QMARK] = ACTIONS(2872),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2872),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [926] = {
    [sym_heredoc_content] = STATE(926),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_EQ] = ACTIONS(2929),
    [anon_sym_STAR_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_PERCENT_EQ] = ACTIONS(2929),
    [anon_sym_x_EQ] = ACTIONS(2929),
    [anon_sym_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_CARET_EQ] = ACTIONS(2929),
    [anon_sym_LT_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_BANG_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_eq] = ACTIONS(2931),
    [anon_sym_ne] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2929),
    [anon_sym_cmp] = ACTIONS(2931),
    [anon_sym_TILDE_TILDE] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_lt] = ACTIONS(2931),
    [anon_sym_le] = ACTIONS(2931),
    [anon_sym_ge] = ACTIONS(2931),
    [anon_sym_gt] = ACTIONS(2931),
    [anon_sym_isa] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2929),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_foreach] = ACTIONS(2931),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2931),
    [anon_sym___END__] = ACTIONS(2931),
    [anon_sym_EOT] = ACTIONS(2929),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_unless] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_until] = ACTIONS(2931),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_SEMICOLON] = ACTIONS(2936),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym__ctrl_z_hack] = ACTIONS(2936),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [927] = {
    [sym_heredoc_content] = STATE(927),
    [sym__identifier] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_sub] = ACTIONS(2901),
    [anon_sym_method] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_my] = ACTIONS(2901),
    [anon_sym_state] = ACTIONS(2901),
    [anon_sym_our] = ACTIONS(2901),
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_elsif] = ACTIONS(2901),
    [anon_sym_and] = ACTIONS(2901),
    [anon_sym_or] = ACTIONS(2901),
    [anon_sym_DOLLAR] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_DASH_GT] = ACTIONS(2901),
    [anon_sym_AT] = ACTIONS(2901),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2901),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_DOT_EQ] = ACTIONS(2901),
    [anon_sym_STAR_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_PERCENT_EQ] = ACTIONS(2901),
    [anon_sym_x_EQ] = ACTIONS(2901),
    [anon_sym_AMP_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_CARET_EQ] = ACTIONS(2901),
    [anon_sym_LT_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_GT_EQ] = ACTIONS(2901),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_GT_GT2] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_x] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_BANG_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_eq] = ACTIONS(2901),
    [anon_sym_ne] = ACTIONS(2901),
    [anon_sym_LT_EQ_GT] = ACTIONS(2901),
    [anon_sym_cmp] = ACTIONS(2901),
    [anon_sym_TILDE_TILDE] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_lt] = ACTIONS(2901),
    [anon_sym_le] = ACTIONS(2901),
    [anon_sym_ge] = ACTIONS(2901),
    [anon_sym_gt] = ACTIONS(2901),
    [anon_sym_isa] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_QMARK] = ACTIONS(2901),
    [anon_sym_BSLASH] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_eval] = ACTIONS(2901),
    [anon_sym_field] = ACTIONS(2901),
    [anon_sym_local] = ACTIONS(2901),
    [anon_sym_require] = ACTIONS(2901),
    [anon_sym_map] = ACTIONS(2901),
    [anon_sym_grep] = ACTIONS(2901),
    [anon_sym_sort] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_undef] = ACTIONS(2901),
    [anon_sym_PERCENT2] = ACTIONS(2901),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(2901),
    [anon_sym_use] = ACTIONS(2901),
    [anon_sym_no] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_foreach] = ACTIONS(2901),
    [anon_sym_last] = ACTIONS(2901),
    [anon_sym_next] = ACTIONS(2901),
    [anon_sym_redo] = ACTIONS(2901),
    [anon_sym_BEGIN] = ACTIONS(2901),
    [anon_sym_INIT] = ACTIONS(2901),
    [anon_sym_CHECK] = ACTIONS(2901),
    [anon_sym_UNITCHECK] = ACTIONS(2901),
    [anon_sym_END] = ACTIONS(2901),
    [anon_sym_ADJUST] = ACTIONS(2901),
    [anon_sym___FILE__] = ACTIONS(2901),
    [anon_sym___LINE__] = ACTIONS(2901),
    [anon_sym___PACKAGE__] = ACTIONS(2901),
    [anon_sym___SUB__] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_fork] = ACTIONS(2901),
    [anon_sym_getppid] = ACTIONS(2901),
    [anon_sym_time] = ACTIONS(2901),
    [anon_sym_times] = ACTIONS(2901),
    [anon_sym_wait] = ACTIONS(2901),
    [anon_sym_wantarray] = ACTIONS(2901),
    [anon_sym_abs] = ACTIONS(2901),
    [anon_sym_alarm] = ACTIONS(2901),
    [anon_sym_chop] = ACTIONS(2901),
    [anon_sym_chdir] = ACTIONS(2901),
    [anon_sym_close] = ACTIONS(2901),
    [anon_sym_closedir] = ACTIONS(2901),
    [anon_sym_caller] = ACTIONS(2901),
    [anon_sym_chomp] = ACTIONS(2901),
    [anon_sym_chr] = ACTIONS(2901),
    [anon_sym_cos] = ACTIONS(2901),
    [anon_sym_chroot] = ACTIONS(2901),
    [anon_sym_defined] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_dbmclose] = ACTIONS(2901),
    [anon_sym_exists] = ACTIONS(2901),
    [anon_sym_exit] = ACTIONS(2901),
    [anon_sym_eof] = ACTIONS(2901),
    [anon_sym_exp] = ACTIONS(2901),
    [anon_sym_each] = ACTIONS(2901),
    [anon_sym_fc] = ACTIONS(2901),
    [anon_sym_fileno] = ACTIONS(2901),
    [anon_sym_gmtime] = ACTIONS(2901),
    [anon_sym_getc] = ACTIONS(2901),
    [anon_sym_getpgrp] = ACTIONS(2901),
    [anon_sym_getprotobyname] = ACTIONS(2901),
    [anon_sym_getpwname] = ACTIONS(2901),
    [anon_sym_getpwuid] = ACTIONS(2901),
    [anon_sym_getpeername] = ACTIONS(2901),
    [anon_sym_getnetbyname] = ACTIONS(2901),
    [anon_sym_getsockname] = ACTIONS(2901),
    [anon_sym_getgrnam] = ACTIONS(2901),
    [anon_sym_getgrgid] = ACTIONS(2901),
    [anon_sym_hex] = ACTIONS(2901),
    [anon_sym_int] = ACTIONS(2901),
    [anon_sym_keys] = ACTIONS(2901),
    [anon_sym_lc] = ACTIONS(2901),
    [anon_sym_lcfirst] = ACTIONS(2901),
    [anon_sym_length] = ACTIONS(2901),
    [anon_sym_localtime] = ACTIONS(2901),
    [anon_sym_log] = ACTIONS(2901),
    [anon_sym_lock] = ACTIONS(2901),
    [anon_sym_lstat] = ACTIONS(2901),
    [anon_sym_oct] = ACTIONS(2901),
    [anon_sym_ord] = ACTIONS(2901),
    [anon_sym_prototype] = ACTIONS(2901),
    [anon_sym_pop] = ACTIONS(2901),
    [anon_sym_pos] = ACTIONS(2901),
    [anon_sym_quotemeta] = ACTIONS(2901),
    [anon_sym_reset] = ACTIONS(2901),
    [anon_sym_rand] = ACTIONS(2901),
    [anon_sym_rmdir] = ACTIONS(2901),
    [anon_sym_readdir] = ACTIONS(2901),
    [anon_sym_readline] = ACTIONS(2901),
    [anon_sym_readpipe] = ACTIONS(2901),
    [anon_sym_rewinddir] = ACTIONS(2901),
    [anon_sym_readlink] = ACTIONS(2901),
    [anon_sym_ref] = ACTIONS(2901),
    [anon_sym_scalar] = ACTIONS(2901),
    [anon_sym_shift] = ACTIONS(2901),
    [anon_sym_sin] = ACTIONS(2901),
    [anon_sym_sleep] = ACTIONS(2901),
    [anon_sym_sqrt] = ACTIONS(2901),
    [anon_sym_srand] = ACTIONS(2901),
    [anon_sym_stat] = ACTIONS(2901),
    [anon_sym_study] = ACTIONS(2901),
    [anon_sym_tell] = ACTIONS(2901),
    [anon_sym_telldir] = ACTIONS(2901),
    [anon_sym_tied] = ACTIONS(2901),
    [anon_sym_uc] = ACTIONS(2901),
    [anon_sym_ucfirst] = ACTIONS(2901),
    [anon_sym_untie] = ACTIONS(2901),
    [anon_sym_umask] = ACTIONS(2901),
    [anon_sym_values] = ACTIONS(2901),
    [anon_sym_write] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2901),
    [anon_sym___END__] = ACTIONS(2901),
    [anon_sym_EOT] = ACTIONS(2901),
    [anon_sym_q] = ACTIONS(2901),
    [anon_sym_qq] = ACTIONS(2901),
    [anon_sym_qw] = ACTIONS(2901),
    [anon_sym_qx] = ACTIONS(2901),
    [anon_sym_qr] = ACTIONS(2901),
    [anon_sym_m] = ACTIONS(2901),
    [anon_sym_s] = ACTIONS(2901),
    [anon_sym_tr] = ACTIONS(2901),
    [anon_sym_y] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_unless] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_until] = ACTIONS(2901),
    [aux_sym__bareword_token1] = ACTIONS(2901),
    [sym_number] = ACTIONS(2901),
    [sym__apostrophe] = ACTIONS(2903),
    [sym__double_quote] = ACTIONS(2903),
    [sym__backtick] = ACTIONS(2903),
    [sym__search_slash] = ACTIONS(2903),
    [sym__PERLY_SEMICOLON] = ACTIONS(2903),
    [sym__PERLY_HEREDOC] = ACTIONS(2903),
    [sym__ctrl_z_hack] = ACTIONS(2903),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [928] = {
    [sym_heredoc_content] = STATE(928),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_EQ] = ACTIONS(2929),
    [anon_sym_STAR_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_PERCENT_EQ] = ACTIONS(2929),
    [anon_sym_x_EQ] = ACTIONS(2929),
    [anon_sym_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_CARET_EQ] = ACTIONS(2929),
    [anon_sym_LT_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_BANG_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_eq] = ACTIONS(2931),
    [anon_sym_ne] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2929),
    [anon_sym_cmp] = ACTIONS(2931),
    [anon_sym_TILDE_TILDE] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_lt] = ACTIONS(2931),
    [anon_sym_le] = ACTIONS(2931),
    [anon_sym_ge] = ACTIONS(2931),
    [anon_sym_gt] = ACTIONS(2931),
    [anon_sym_isa] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2929),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2931),
    [anon_sym___END__] = ACTIONS(2931),
    [anon_sym_EOT] = ACTIONS(2929),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_SEMICOLON] = ACTIONS(2936),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym__ctrl_z_hack] = ACTIONS(2936),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [929] = {
    [sym_heredoc_content] = STATE(929),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2872),
    [anon_sym_GT] = ACTIONS(2872),
    [anon_sym_LT_LT] = ACTIONS(2872),
    [anon_sym_EQ] = ACTIONS(2872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2872),
    [anon_sym_PLUS_EQ] = ACTIONS(2872),
    [anon_sym_DASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_EQ] = ACTIONS(2872),
    [anon_sym_STAR_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_PERCENT_EQ] = ACTIONS(2872),
    [anon_sym_x_EQ] = ACTIONS(2872),
    [anon_sym_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_CARET_EQ] = ACTIONS(2872),
    [anon_sym_LT_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_GT_EQ] = ACTIONS(2872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2872),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [anon_sym_STAR_STAR] = ACTIONS(2872),
    [anon_sym_PIPE_PIPE] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH] = ACTIONS(2872),
    [anon_sym_AMP_AMP] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(2872),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_GT_GT2] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_DOT] = ACTIONS(2872),
    [anon_sym_STAR] = ACTIONS(2872),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_x] = ACTIONS(2872),
    [anon_sym_EQ_TILDE] = ACTIONS(2872),
    [anon_sym_BANG_TILDE] = ACTIONS(2872),
    [anon_sym_EQ_EQ] = ACTIONS(2872),
    [anon_sym_BANG_EQ] = ACTIONS(2872),
    [anon_sym_eq] = ACTIONS(2872),
    [anon_sym_ne] = ACTIONS(2872),
    [anon_sym_LT_EQ_GT] = ACTIONS(2872),
    [anon_sym_cmp] = ACTIONS(2872),
    [anon_sym_TILDE_TILDE] = ACTIONS(2872),
    [anon_sym_LT_EQ] = ACTIONS(2872),
    [anon_sym_GT_EQ] = ACTIONS(2872),
    [anon_sym_lt] = ACTIONS(2872),
    [anon_sym_le] = ACTIONS(2872),
    [anon_sym_ge] = ACTIONS(2872),
    [anon_sym_gt] = ACTIONS(2872),
    [anon_sym_isa] = ACTIONS(2872),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2872),
    [anon_sym_DASH_DASH] = ACTIONS(2872),
    [anon_sym_QMARK] = ACTIONS(2872),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2872),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2883),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [930] = {
    [sym_heredoc_content] = STATE(930),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [931] = {
    [sym_heredoc_content] = STATE(931),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2938),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2938),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2938),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2938),
    [anon_sym_PLUS_EQ] = ACTIONS(2938),
    [anon_sym_DASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_EQ] = ACTIONS(2938),
    [anon_sym_STAR_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_PERCENT_EQ] = ACTIONS(2938),
    [anon_sym_x_EQ] = ACTIONS(2938),
    [anon_sym_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_CARET_EQ] = ACTIONS(2938),
    [anon_sym_LT_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_GT_EQ] = ACTIONS(2938),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [anon_sym_STAR_STAR] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_GT_GT2] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_x] = ACTIONS(2938),
    [anon_sym_EQ_TILDE] = ACTIONS(2938),
    [anon_sym_BANG_TILDE] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_eq] = ACTIONS(2938),
    [anon_sym_ne] = ACTIONS(2938),
    [anon_sym_LT_EQ_GT] = ACTIONS(2938),
    [anon_sym_cmp] = ACTIONS(2938),
    [anon_sym_TILDE_TILDE] = ACTIONS(2938),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2938),
    [anon_sym_lt] = ACTIONS(2938),
    [anon_sym_le] = ACTIONS(2938),
    [anon_sym_ge] = ACTIONS(2938),
    [anon_sym_gt] = ACTIONS(2938),
    [anon_sym_isa] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2938),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_foreach] = ACTIONS(2938),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2938),
    [anon_sym___END__] = ACTIONS(2938),
    [anon_sym_EOT] = ACTIONS(2938),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_unless] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_until] = ACTIONS(2938),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_SEMICOLON] = ACTIONS(2940),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym__ctrl_z_hack] = ACTIONS(2940),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [932] = {
    [sym_heredoc_content] = STATE(932),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2938),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2938),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2938),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2938),
    [anon_sym_PLUS_EQ] = ACTIONS(2938),
    [anon_sym_DASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_EQ] = ACTIONS(2938),
    [anon_sym_STAR_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_PERCENT_EQ] = ACTIONS(2938),
    [anon_sym_x_EQ] = ACTIONS(2938),
    [anon_sym_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_CARET_EQ] = ACTIONS(2938),
    [anon_sym_LT_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_GT_EQ] = ACTIONS(2938),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [anon_sym_STAR_STAR] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_GT_GT2] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_x] = ACTIONS(2938),
    [anon_sym_EQ_TILDE] = ACTIONS(2938),
    [anon_sym_BANG_TILDE] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_eq] = ACTIONS(2938),
    [anon_sym_ne] = ACTIONS(2938),
    [anon_sym_LT_EQ_GT] = ACTIONS(2938),
    [anon_sym_cmp] = ACTIONS(2938),
    [anon_sym_TILDE_TILDE] = ACTIONS(2938),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2938),
    [anon_sym_lt] = ACTIONS(2938),
    [anon_sym_le] = ACTIONS(2938),
    [anon_sym_ge] = ACTIONS(2938),
    [anon_sym_gt] = ACTIONS(2938),
    [anon_sym_isa] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2938),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2938),
    [anon_sym___END__] = ACTIONS(2938),
    [anon_sym_EOT] = ACTIONS(2938),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_SEMICOLON] = ACTIONS(2940),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym__ctrl_z_hack] = ACTIONS(2940),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [933] = {
    [sym_heredoc_content] = STATE(933),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2929),
    [anon_sym_DASH_GT] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_EQ] = ACTIONS(2929),
    [anon_sym_STAR_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_PERCENT_EQ] = ACTIONS(2929),
    [anon_sym_x_EQ] = ACTIONS(2929),
    [anon_sym_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_CARET_EQ] = ACTIONS(2929),
    [anon_sym_LT_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_BANG_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_eq] = ACTIONS(2931),
    [anon_sym_ne] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2929),
    [anon_sym_cmp] = ACTIONS(2931),
    [anon_sym_TILDE_TILDE] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_lt] = ACTIONS(2931),
    [anon_sym_le] = ACTIONS(2931),
    [anon_sym_ge] = ACTIONS(2931),
    [anon_sym_gt] = ACTIONS(2931),
    [anon_sym_isa] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2929),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2927),
    [anon_sym___END__] = ACTIONS(2927),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [934] = {
    [sym_heredoc_content] = STATE(934),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2938),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2938),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2938),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2938),
    [anon_sym_DASH_GT] = ACTIONS(2938),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2938),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2938),
    [anon_sym_PLUS_EQ] = ACTIONS(2938),
    [anon_sym_DASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_EQ] = ACTIONS(2938),
    [anon_sym_STAR_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_PERCENT_EQ] = ACTIONS(2938),
    [anon_sym_x_EQ] = ACTIONS(2938),
    [anon_sym_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_CARET_EQ] = ACTIONS(2938),
    [anon_sym_LT_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_GT_EQ] = ACTIONS(2938),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [anon_sym_STAR_STAR] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_GT_GT2] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_x] = ACTIONS(2938),
    [anon_sym_EQ_TILDE] = ACTIONS(2938),
    [anon_sym_BANG_TILDE] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_eq] = ACTIONS(2938),
    [anon_sym_ne] = ACTIONS(2938),
    [anon_sym_LT_EQ_GT] = ACTIONS(2938),
    [anon_sym_cmp] = ACTIONS(2938),
    [anon_sym_TILDE_TILDE] = ACTIONS(2938),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2938),
    [anon_sym_lt] = ACTIONS(2938),
    [anon_sym_le] = ACTIONS(2938),
    [anon_sym_ge] = ACTIONS(2938),
    [anon_sym_gt] = ACTIONS(2938),
    [anon_sym_isa] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2938),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2927),
    [anon_sym___END__] = ACTIONS(2927),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [935] = {
    [sym_heredoc_content] = STATE(935),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_COMMA] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_DASH_GT] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_PERCENT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2905),
    [anon_sym_PLUS_EQ] = ACTIONS(2905),
    [anon_sym_DASH_EQ] = ACTIONS(2905),
    [anon_sym_DOT_EQ] = ACTIONS(2905),
    [anon_sym_STAR_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_PERCENT_EQ] = ACTIONS(2905),
    [anon_sym_x_EQ] = ACTIONS(2905),
    [anon_sym_AMP_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_CARET_EQ] = ACTIONS(2905),
    [anon_sym_LT_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_GT_EQ] = ACTIONS(2905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_STAR_STAR] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_GT_GT2] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_DOT] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_x] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2905),
    [anon_sym_BANG_TILDE] = ACTIONS(2905),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_LT_EQ_GT] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_TILDE_TILDE] = ACTIONS(2905),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_QMARK] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_EOT] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_SEMICOLON] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym__ctrl_z_hack] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [936] = {
    [sym_heredoc_content] = STATE(936),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [937] = {
    [sym_heredoc_content] = STATE(937),
    [sym__identifier] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_sub] = ACTIONS(2923),
    [anon_sym_method] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_my] = ACTIONS(2923),
    [anon_sym_state] = ACTIONS(2923),
    [anon_sym_our] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2923),
    [anon_sym_elsif] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2923),
    [anon_sym_DOLLAR] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_AT] = ACTIONS(2923),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2923),
    [anon_sym_PLUS_EQ] = ACTIONS(2923),
    [anon_sym_DASH_EQ] = ACTIONS(2923),
    [anon_sym_DOT_EQ] = ACTIONS(2923),
    [anon_sym_STAR_EQ] = ACTIONS(2923),
    [anon_sym_SLASH_EQ] = ACTIONS(2923),
    [anon_sym_PERCENT_EQ] = ACTIONS(2923),
    [anon_sym_x_EQ] = ACTIONS(2923),
    [anon_sym_AMP_EQ] = ACTIONS(2923),
    [anon_sym_PIPE_EQ] = ACTIONS(2923),
    [anon_sym_CARET_EQ] = ACTIONS(2923),
    [anon_sym_LT_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_GT_EQ] = ACTIONS(2923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_GT_GT2] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_x] = ACTIONS(2923),
    [anon_sym_EQ_TILDE] = ACTIONS(2923),
    [anon_sym_BANG_TILDE] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_eq] = ACTIONS(2923),
    [anon_sym_ne] = ACTIONS(2923),
    [anon_sym_LT_EQ_GT] = ACTIONS(2923),
    [anon_sym_cmp] = ACTIONS(2923),
    [anon_sym_TILDE_TILDE] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_lt] = ACTIONS(2923),
    [anon_sym_le] = ACTIONS(2923),
    [anon_sym_ge] = ACTIONS(2923),
    [anon_sym_gt] = ACTIONS(2923),
    [anon_sym_isa] = ACTIONS(2923),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2923),
    [anon_sym_BSLASH] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_eval] = ACTIONS(2923),
    [anon_sym_field] = ACTIONS(2923),
    [anon_sym_local] = ACTIONS(2923),
    [anon_sym_require] = ACTIONS(2923),
    [anon_sym_map] = ACTIONS(2923),
    [anon_sym_grep] = ACTIONS(2923),
    [anon_sym_sort] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_undef] = ACTIONS(2923),
    [anon_sym_PERCENT2] = ACTIONS(2923),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_use] = ACTIONS(2923),
    [anon_sym_no] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_foreach] = ACTIONS(2923),
    [anon_sym_last] = ACTIONS(2923),
    [anon_sym_next] = ACTIONS(2923),
    [anon_sym_redo] = ACTIONS(2923),
    [anon_sym_BEGIN] = ACTIONS(2923),
    [anon_sym_INIT] = ACTIONS(2923),
    [anon_sym_CHECK] = ACTIONS(2923),
    [anon_sym_UNITCHECK] = ACTIONS(2923),
    [anon_sym_END] = ACTIONS(2923),
    [anon_sym_ADJUST] = ACTIONS(2923),
    [anon_sym___FILE__] = ACTIONS(2923),
    [anon_sym___LINE__] = ACTIONS(2923),
    [anon_sym___PACKAGE__] = ACTIONS(2923),
    [anon_sym___SUB__] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_fork] = ACTIONS(2923),
    [anon_sym_getppid] = ACTIONS(2923),
    [anon_sym_time] = ACTIONS(2923),
    [anon_sym_times] = ACTIONS(2923),
    [anon_sym_wait] = ACTIONS(2923),
    [anon_sym_wantarray] = ACTIONS(2923),
    [anon_sym_abs] = ACTIONS(2923),
    [anon_sym_alarm] = ACTIONS(2923),
    [anon_sym_chop] = ACTIONS(2923),
    [anon_sym_chdir] = ACTIONS(2923),
    [anon_sym_close] = ACTIONS(2923),
    [anon_sym_closedir] = ACTIONS(2923),
    [anon_sym_caller] = ACTIONS(2923),
    [anon_sym_chomp] = ACTIONS(2923),
    [anon_sym_chr] = ACTIONS(2923),
    [anon_sym_cos] = ACTIONS(2923),
    [anon_sym_chroot] = ACTIONS(2923),
    [anon_sym_defined] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_dbmclose] = ACTIONS(2923),
    [anon_sym_exists] = ACTIONS(2923),
    [anon_sym_exit] = ACTIONS(2923),
    [anon_sym_eof] = ACTIONS(2923),
    [anon_sym_exp] = ACTIONS(2923),
    [anon_sym_each] = ACTIONS(2923),
    [anon_sym_fc] = ACTIONS(2923),
    [anon_sym_fileno] = ACTIONS(2923),
    [anon_sym_gmtime] = ACTIONS(2923),
    [anon_sym_getc] = ACTIONS(2923),
    [anon_sym_getpgrp] = ACTIONS(2923),
    [anon_sym_getprotobyname] = ACTIONS(2923),
    [anon_sym_getpwname] = ACTIONS(2923),
    [anon_sym_getpwuid] = ACTIONS(2923),
    [anon_sym_getpeername] = ACTIONS(2923),
    [anon_sym_getnetbyname] = ACTIONS(2923),
    [anon_sym_getsockname] = ACTIONS(2923),
    [anon_sym_getgrnam] = ACTIONS(2923),
    [anon_sym_getgrgid] = ACTIONS(2923),
    [anon_sym_hex] = ACTIONS(2923),
    [anon_sym_int] = ACTIONS(2923),
    [anon_sym_keys] = ACTIONS(2923),
    [anon_sym_lc] = ACTIONS(2923),
    [anon_sym_lcfirst] = ACTIONS(2923),
    [anon_sym_length] = ACTIONS(2923),
    [anon_sym_localtime] = ACTIONS(2923),
    [anon_sym_log] = ACTIONS(2923),
    [anon_sym_lock] = ACTIONS(2923),
    [anon_sym_lstat] = ACTIONS(2923),
    [anon_sym_oct] = ACTIONS(2923),
    [anon_sym_ord] = ACTIONS(2923),
    [anon_sym_prototype] = ACTIONS(2923),
    [anon_sym_pop] = ACTIONS(2923),
    [anon_sym_pos] = ACTIONS(2923),
    [anon_sym_quotemeta] = ACTIONS(2923),
    [anon_sym_reset] = ACTIONS(2923),
    [anon_sym_rand] = ACTIONS(2923),
    [anon_sym_rmdir] = ACTIONS(2923),
    [anon_sym_readdir] = ACTIONS(2923),
    [anon_sym_readline] = ACTIONS(2923),
    [anon_sym_readpipe] = ACTIONS(2923),
    [anon_sym_rewinddir] = ACTIONS(2923),
    [anon_sym_readlink] = ACTIONS(2923),
    [anon_sym_ref] = ACTIONS(2923),
    [anon_sym_scalar] = ACTIONS(2923),
    [anon_sym_shift] = ACTIONS(2923),
    [anon_sym_sin] = ACTIONS(2923),
    [anon_sym_sleep] = ACTIONS(2923),
    [anon_sym_sqrt] = ACTIONS(2923),
    [anon_sym_srand] = ACTIONS(2923),
    [anon_sym_stat] = ACTIONS(2923),
    [anon_sym_study] = ACTIONS(2923),
    [anon_sym_tell] = ACTIONS(2923),
    [anon_sym_telldir] = ACTIONS(2923),
    [anon_sym_tied] = ACTIONS(2923),
    [anon_sym_uc] = ACTIONS(2923),
    [anon_sym_ucfirst] = ACTIONS(2923),
    [anon_sym_untie] = ACTIONS(2923),
    [anon_sym_umask] = ACTIONS(2923),
    [anon_sym_values] = ACTIONS(2923),
    [anon_sym_write] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2923),
    [anon_sym___END__] = ACTIONS(2923),
    [anon_sym_EOT] = ACTIONS(2923),
    [anon_sym_q] = ACTIONS(2923),
    [anon_sym_qq] = ACTIONS(2923),
    [anon_sym_qw] = ACTIONS(2923),
    [anon_sym_qx] = ACTIONS(2923),
    [anon_sym_qr] = ACTIONS(2923),
    [anon_sym_m] = ACTIONS(2923),
    [anon_sym_s] = ACTIONS(2923),
    [anon_sym_tr] = ACTIONS(2923),
    [anon_sym_y] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_unless] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_until] = ACTIONS(2923),
    [aux_sym__bareword_token1] = ACTIONS(2923),
    [sym_number] = ACTIONS(2923),
    [sym__apostrophe] = ACTIONS(2925),
    [sym__double_quote] = ACTIONS(2925),
    [sym__backtick] = ACTIONS(2925),
    [sym__search_slash] = ACTIONS(2925),
    [sym__PERLY_SEMICOLON] = ACTIONS(2925),
    [sym__PERLY_HEREDOC] = ACTIONS(2925),
    [sym__ctrl_z_hack] = ACTIONS(2925),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [938] = {
    [sym_heredoc_content] = STATE(938),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [939] = {
    [sym_heredoc_content] = STATE(939),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_EQ] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(137),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(137),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(137),
    [anon_sym_BANG_TILDE] = ACTIONS(137),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_eq] = ACTIONS(137),
    [anon_sym_ne] = ACTIONS(137),
    [anon_sym_LT_EQ_GT] = ACTIONS(137),
    [anon_sym_cmp] = ACTIONS(137),
    [anon_sym_TILDE_TILDE] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(137),
    [anon_sym_lt] = ACTIONS(137),
    [anon_sym_le] = ACTIONS(137),
    [anon_sym_ge] = ACTIONS(137),
    [anon_sym_gt] = ACTIONS(137),
    [anon_sym_isa] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [940] = {
    [sym_heredoc_content] = STATE(940),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_SEMICOLON] = ACTIONS(2881),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [941] = {
    [sym_heredoc_content] = STATE(941),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_COLON] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_RPAREN] = ACTIONS(2874),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2870),
    [anon_sym_or] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [942] = {
    [sym_heredoc_content] = STATE(942),
    [sym__identifier] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_LBRACE2] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_sub] = ACTIONS(2870),
    [anon_sym_method] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_my] = ACTIONS(2870),
    [anon_sym_state] = ACTIONS(2870),
    [anon_sym_our] = ACTIONS(2870),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_elsif] = ACTIONS(2870),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DASH_GT] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2874),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2874),
    [anon_sym_PLUS_EQ] = ACTIONS(2874),
    [anon_sym_DASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_EQ] = ACTIONS(2874),
    [anon_sym_STAR_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_PERCENT_EQ] = ACTIONS(2874),
    [anon_sym_x_EQ] = ACTIONS(2874),
    [anon_sym_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_CARET_EQ] = ACTIONS(2874),
    [anon_sym_LT_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_GT_EQ] = ACTIONS(2874),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR_STAR] = ACTIONS(2874),
    [anon_sym_PIPE_PIPE] = ACTIONS(2874),
    [anon_sym_SLASH_SLASH] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_GT_GT2] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_x] = ACTIONS(2874),
    [anon_sym_EQ_TILDE] = ACTIONS(2874),
    [anon_sym_BANG_TILDE] = ACTIONS(2874),
    [anon_sym_EQ_EQ] = ACTIONS(2874),
    [anon_sym_BANG_EQ] = ACTIONS(2874),
    [anon_sym_eq] = ACTIONS(2876),
    [anon_sym_ne] = ACTIONS(2876),
    [anon_sym_LT_EQ_GT] = ACTIONS(2874),
    [anon_sym_cmp] = ACTIONS(2876),
    [anon_sym_TILDE_TILDE] = ACTIONS(2874),
    [anon_sym_LT_EQ] = ACTIONS(2874),
    [anon_sym_GT_EQ] = ACTIONS(2874),
    [anon_sym_lt] = ACTIONS(2876),
    [anon_sym_le] = ACTIONS(2876),
    [anon_sym_ge] = ACTIONS(2876),
    [anon_sym_gt] = ACTIONS(2876),
    [anon_sym_isa] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_eval] = ACTIONS(2870),
    [anon_sym_field] = ACTIONS(2870),
    [anon_sym_local] = ACTIONS(2870),
    [anon_sym_require] = ACTIONS(2870),
    [anon_sym_map] = ACTIONS(2870),
    [anon_sym_grep] = ACTIONS(2870),
    [anon_sym_sort] = ACTIONS(2870),
    [anon_sym_goto] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_PERCENT2] = ACTIONS(2870),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2870),
    [anon_sym_no] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_foreach] = ACTIONS(2870),
    [anon_sym_last] = ACTIONS(2870),
    [anon_sym_next] = ACTIONS(2870),
    [anon_sym_redo] = ACTIONS(2870),
    [anon_sym_BEGIN] = ACTIONS(2870),
    [anon_sym_INIT] = ACTIONS(2870),
    [anon_sym_CHECK] = ACTIONS(2870),
    [anon_sym_UNITCHECK] = ACTIONS(2870),
    [anon_sym_END] = ACTIONS(2870),
    [anon_sym_ADJUST] = ACTIONS(2870),
    [anon_sym___FILE__] = ACTIONS(2870),
    [anon_sym___LINE__] = ACTIONS(2870),
    [anon_sym___PACKAGE__] = ACTIONS(2870),
    [anon_sym___SUB__] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_fork] = ACTIONS(2870),
    [anon_sym_getppid] = ACTIONS(2870),
    [anon_sym_time] = ACTIONS(2870),
    [anon_sym_times] = ACTIONS(2870),
    [anon_sym_wait] = ACTIONS(2870),
    [anon_sym_wantarray] = ACTIONS(2870),
    [anon_sym_abs] = ACTIONS(2870),
    [anon_sym_alarm] = ACTIONS(2870),
    [anon_sym_chop] = ACTIONS(2870),
    [anon_sym_chdir] = ACTIONS(2870),
    [anon_sym_close] = ACTIONS(2870),
    [anon_sym_closedir] = ACTIONS(2870),
    [anon_sym_caller] = ACTIONS(2870),
    [anon_sym_chomp] = ACTIONS(2870),
    [anon_sym_chr] = ACTIONS(2870),
    [anon_sym_cos] = ACTIONS(2870),
    [anon_sym_chroot] = ACTIONS(2870),
    [anon_sym_defined] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_dbmclose] = ACTIONS(2870),
    [anon_sym_exists] = ACTIONS(2870),
    [anon_sym_exit] = ACTIONS(2870),
    [anon_sym_eof] = ACTIONS(2870),
    [anon_sym_exp] = ACTIONS(2870),
    [anon_sym_each] = ACTIONS(2870),
    [anon_sym_fc] = ACTIONS(2870),
    [anon_sym_fileno] = ACTIONS(2870),
    [anon_sym_gmtime] = ACTIONS(2870),
    [anon_sym_getc] = ACTIONS(2870),
    [anon_sym_getpgrp] = ACTIONS(2870),
    [anon_sym_getprotobyname] = ACTIONS(2870),
    [anon_sym_getpwname] = ACTIONS(2870),
    [anon_sym_getpwuid] = ACTIONS(2870),
    [anon_sym_getpeername] = ACTIONS(2870),
    [anon_sym_getnetbyname] = ACTIONS(2870),
    [anon_sym_getsockname] = ACTIONS(2870),
    [anon_sym_getgrnam] = ACTIONS(2870),
    [anon_sym_getgrgid] = ACTIONS(2870),
    [anon_sym_hex] = ACTIONS(2870),
    [anon_sym_int] = ACTIONS(2870),
    [anon_sym_keys] = ACTIONS(2870),
    [anon_sym_lc] = ACTIONS(2870),
    [anon_sym_lcfirst] = ACTIONS(2870),
    [anon_sym_length] = ACTIONS(2870),
    [anon_sym_localtime] = ACTIONS(2870),
    [anon_sym_log] = ACTIONS(2870),
    [anon_sym_lock] = ACTIONS(2870),
    [anon_sym_lstat] = ACTIONS(2870),
    [anon_sym_oct] = ACTIONS(2870),
    [anon_sym_ord] = ACTIONS(2870),
    [anon_sym_prototype] = ACTIONS(2870),
    [anon_sym_pop] = ACTIONS(2870),
    [anon_sym_pos] = ACTIONS(2870),
    [anon_sym_quotemeta] = ACTIONS(2870),
    [anon_sym_reset] = ACTIONS(2870),
    [anon_sym_rand] = ACTIONS(2870),
    [anon_sym_rmdir] = ACTIONS(2870),
    [anon_sym_readdir] = ACTIONS(2870),
    [anon_sym_readline] = ACTIONS(2870),
    [anon_sym_readpipe] = ACTIONS(2870),
    [anon_sym_rewinddir] = ACTIONS(2870),
    [anon_sym_readlink] = ACTIONS(2870),
    [anon_sym_ref] = ACTIONS(2870),
    [anon_sym_scalar] = ACTIONS(2870),
    [anon_sym_shift] = ACTIONS(2870),
    [anon_sym_sin] = ACTIONS(2870),
    [anon_sym_sleep] = ACTIONS(2870),
    [anon_sym_sqrt] = ACTIONS(2870),
    [anon_sym_srand] = ACTIONS(2870),
    [anon_sym_stat] = ACTIONS(2870),
    [anon_sym_study] = ACTIONS(2870),
    [anon_sym_tell] = ACTIONS(2870),
    [anon_sym_telldir] = ACTIONS(2870),
    [anon_sym_tied] = ACTIONS(2870),
    [anon_sym_uc] = ACTIONS(2870),
    [anon_sym_ucfirst] = ACTIONS(2870),
    [anon_sym_untie] = ACTIONS(2870),
    [anon_sym_umask] = ACTIONS(2870),
    [anon_sym_values] = ACTIONS(2870),
    [anon_sym_write] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2870),
    [anon_sym___END__] = ACTIONS(2870),
    [anon_sym_q] = ACTIONS(2870),
    [anon_sym_qq] = ACTIONS(2870),
    [anon_sym_qw] = ACTIONS(2870),
    [anon_sym_qx] = ACTIONS(2870),
    [anon_sym_qr] = ACTIONS(2870),
    [anon_sym_m] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2870),
    [anon_sym_tr] = ACTIONS(2870),
    [anon_sym_y] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_unless] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_until] = ACTIONS(2870),
    [aux_sym__bareword_token1] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym__apostrophe] = ACTIONS(2879),
    [sym__double_quote] = ACTIONS(2879),
    [sym__backtick] = ACTIONS(2879),
    [sym__search_slash] = ACTIONS(2879),
    [sym__PERLY_HEREDOC] = ACTIONS(2879),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [943] = {
    [sym_heredoc_content] = STATE(943),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2938),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2927),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2938),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2938),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2938),
    [anon_sym_PLUS_EQ] = ACTIONS(2938),
    [anon_sym_DASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_EQ] = ACTIONS(2938),
    [anon_sym_STAR_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_PERCENT_EQ] = ACTIONS(2938),
    [anon_sym_x_EQ] = ACTIONS(2938),
    [anon_sym_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_CARET_EQ] = ACTIONS(2938),
    [anon_sym_LT_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_GT_EQ] = ACTIONS(2938),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [anon_sym_STAR_STAR] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_GT_GT2] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_x] = ACTIONS(2938),
    [anon_sym_EQ_TILDE] = ACTIONS(2938),
    [anon_sym_BANG_TILDE] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_eq] = ACTIONS(2938),
    [anon_sym_ne] = ACTIONS(2938),
    [anon_sym_LT_EQ_GT] = ACTIONS(2938),
    [anon_sym_cmp] = ACTIONS(2938),
    [anon_sym_TILDE_TILDE] = ACTIONS(2938),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2938),
    [anon_sym_lt] = ACTIONS(2938),
    [anon_sym_le] = ACTIONS(2938),
    [anon_sym_ge] = ACTIONS(2938),
    [anon_sym_gt] = ACTIONS(2938),
    [anon_sym_isa] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2938),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2927),
    [anon_sym___END__] = ACTIONS(2927),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_SEMICOLON] = ACTIONS(2940),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [944] = {
    [sym_heredoc_content] = STATE(944),
    [sym__identifier] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_sub] = ACTIONS(2889),
    [anon_sym_method] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_my] = ACTIONS(2889),
    [anon_sym_state] = ACTIONS(2889),
    [anon_sym_our] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2889),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_elsif] = ACTIONS(2889),
    [anon_sym_and] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2889),
    [anon_sym_DASH_GT] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2889),
    [anon_sym_PLUS_EQ] = ACTIONS(2889),
    [anon_sym_DASH_EQ] = ACTIONS(2889),
    [anon_sym_DOT_EQ] = ACTIONS(2889),
    [anon_sym_STAR_EQ] = ACTIONS(2889),
    [anon_sym_SLASH_EQ] = ACTIONS(2889),
    [anon_sym_PERCENT_EQ] = ACTIONS(2889),
    [anon_sym_x_EQ] = ACTIONS(2889),
    [anon_sym_AMP_EQ] = ACTIONS(2889),
    [anon_sym_PIPE_EQ] = ACTIONS(2889),
    [anon_sym_CARET_EQ] = ACTIONS(2889),
    [anon_sym_LT_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_GT_EQ] = ACTIONS(2889),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT] = ACTIONS(2889),
    [anon_sym_STAR_STAR] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_GT_GT2] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_x] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2889),
    [anon_sym_BANG_TILDE] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2889),
    [anon_sym_eq] = ACTIONS(2889),
    [anon_sym_ne] = ACTIONS(2889),
    [anon_sym_LT_EQ_GT] = ACTIONS(2889),
    [anon_sym_cmp] = ACTIONS(2889),
    [anon_sym_TILDE_TILDE] = ACTIONS(2889),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2889),
    [anon_sym_lt] = ACTIONS(2889),
    [anon_sym_le] = ACTIONS(2889),
    [anon_sym_ge] = ACTIONS(2889),
    [anon_sym_gt] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BSLASH] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_eval] = ACTIONS(2889),
    [anon_sym_field] = ACTIONS(2889),
    [anon_sym_local] = ACTIONS(2889),
    [anon_sym_require] = ACTIONS(2889),
    [anon_sym_map] = ACTIONS(2889),
    [anon_sym_grep] = ACTIONS(2889),
    [anon_sym_sort] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_undef] = ACTIONS(2889),
    [anon_sym_PERCENT2] = ACTIONS(2889),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2889),
    [anon_sym_EQ_GT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2889),
    [anon_sym_no] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_foreach] = ACTIONS(2889),
    [anon_sym_last] = ACTIONS(2889),
    [anon_sym_next] = ACTIONS(2889),
    [anon_sym_redo] = ACTIONS(2889),
    [anon_sym_BEGIN] = ACTIONS(2889),
    [anon_sym_INIT] = ACTIONS(2889),
    [anon_sym_CHECK] = ACTIONS(2889),
    [anon_sym_UNITCHECK] = ACTIONS(2889),
    [anon_sym_END] = ACTIONS(2889),
    [anon_sym_ADJUST] = ACTIONS(2889),
    [anon_sym___FILE__] = ACTIONS(2889),
    [anon_sym___LINE__] = ACTIONS(2889),
    [anon_sym___PACKAGE__] = ACTIONS(2889),
    [anon_sym___SUB__] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_fork] = ACTIONS(2889),
    [anon_sym_getppid] = ACTIONS(2889),
    [anon_sym_time] = ACTIONS(2889),
    [anon_sym_times] = ACTIONS(2889),
    [anon_sym_wait] = ACTIONS(2889),
    [anon_sym_wantarray] = ACTIONS(2889),
    [anon_sym_abs] = ACTIONS(2889),
    [anon_sym_alarm] = ACTIONS(2889),
    [anon_sym_chop] = ACTIONS(2889),
    [anon_sym_chdir] = ACTIONS(2889),
    [anon_sym_close] = ACTIONS(2889),
    [anon_sym_closedir] = ACTIONS(2889),
    [anon_sym_caller] = ACTIONS(2889),
    [anon_sym_chomp] = ACTIONS(2889),
    [anon_sym_chr] = ACTIONS(2889),
    [anon_sym_cos] = ACTIONS(2889),
    [anon_sym_chroot] = ACTIONS(2889),
    [anon_sym_defined] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_dbmclose] = ACTIONS(2889),
    [anon_sym_exists] = ACTIONS(2889),
    [anon_sym_exit] = ACTIONS(2889),
    [anon_sym_eof] = ACTIONS(2889),
    [anon_sym_exp] = ACTIONS(2889),
    [anon_sym_each] = ACTIONS(2889),
    [anon_sym_fc] = ACTIONS(2889),
    [anon_sym_fileno] = ACTIONS(2889),
    [anon_sym_gmtime] = ACTIONS(2889),
    [anon_sym_getc] = ACTIONS(2889),
    [anon_sym_getpgrp] = ACTIONS(2889),
    [anon_sym_getprotobyname] = ACTIONS(2889),
    [anon_sym_getpwname] = ACTIONS(2889),
    [anon_sym_getpwuid] = ACTIONS(2889),
    [anon_sym_getpeername] = ACTIONS(2889),
    [anon_sym_getnetbyname] = ACTIONS(2889),
    [anon_sym_getsockname] = ACTIONS(2889),
    [anon_sym_getgrnam] = ACTIONS(2889),
    [anon_sym_getgrgid] = ACTIONS(2889),
    [anon_sym_hex] = ACTIONS(2889),
    [anon_sym_int] = ACTIONS(2889),
    [anon_sym_keys] = ACTIONS(2889),
    [anon_sym_lc] = ACTIONS(2889),
    [anon_sym_lcfirst] = ACTIONS(2889),
    [anon_sym_length] = ACTIONS(2889),
    [anon_sym_localtime] = ACTIONS(2889),
    [anon_sym_log] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_lstat] = ACTIONS(2889),
    [anon_sym_oct] = ACTIONS(2889),
    [anon_sym_ord] = ACTIONS(2889),
    [anon_sym_prototype] = ACTIONS(2889),
    [anon_sym_pop] = ACTIONS(2889),
    [anon_sym_pos] = ACTIONS(2889),
    [anon_sym_quotemeta] = ACTIONS(2889),
    [anon_sym_reset] = ACTIONS(2889),
    [anon_sym_rand] = ACTIONS(2889),
    [anon_sym_rmdir] = ACTIONS(2889),
    [anon_sym_readdir] = ACTIONS(2889),
    [anon_sym_readline] = ACTIONS(2889),
    [anon_sym_readpipe] = ACTIONS(2889),
    [anon_sym_rewinddir] = ACTIONS(2889),
    [anon_sym_readlink] = ACTIONS(2889),
    [anon_sym_ref] = ACTIONS(2889),
    [anon_sym_scalar] = ACTIONS(2889),
    [anon_sym_shift] = ACTIONS(2889),
    [anon_sym_sin] = ACTIONS(2889),
    [anon_sym_sleep] = ACTIONS(2889),
    [anon_sym_sqrt] = ACTIONS(2889),
    [anon_sym_srand] = ACTIONS(2889),
    [anon_sym_stat] = ACTIONS(2889),
    [anon_sym_study] = ACTIONS(2889),
    [anon_sym_tell] = ACTIONS(2889),
    [anon_sym_telldir] = ACTIONS(2889),
    [anon_sym_tied] = ACTIONS(2889),
    [anon_sym_uc] = ACTIONS(2889),
    [anon_sym_ucfirst] = ACTIONS(2889),
    [anon_sym_untie] = ACTIONS(2889),
    [anon_sym_umask] = ACTIONS(2889),
    [anon_sym_values] = ACTIONS(2889),
    [anon_sym_write] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2889),
    [anon_sym___END__] = ACTIONS(2889),
    [anon_sym_q] = ACTIONS(2889),
    [anon_sym_qq] = ACTIONS(2889),
    [anon_sym_qw] = ACTIONS(2889),
    [anon_sym_qx] = ACTIONS(2889),
    [anon_sym_qr] = ACTIONS(2889),
    [anon_sym_m] = ACTIONS(2889),
    [anon_sym_s] = ACTIONS(2889),
    [anon_sym_tr] = ACTIONS(2889),
    [anon_sym_y] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_unless] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_until] = ACTIONS(2889),
    [aux_sym__bareword_token1] = ACTIONS(2889),
    [sym_number] = ACTIONS(2889),
    [sym__apostrophe] = ACTIONS(2891),
    [sym__double_quote] = ACTIONS(2891),
    [sym__backtick] = ACTIONS(2891),
    [sym__search_slash] = ACTIONS(2891),
    [sym__PERLY_SEMICOLON] = ACTIONS(2891),
    [sym__PERLY_HEREDOC] = ACTIONS(2891),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [945] = {
    [sym_heredoc_content] = STATE(945),
    [sym__identifier] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_sub] = ACTIONS(2923),
    [anon_sym_method] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_my] = ACTIONS(2923),
    [anon_sym_state] = ACTIONS(2923),
    [anon_sym_our] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2923),
    [anon_sym_elsif] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2923),
    [anon_sym_DOLLAR] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_AT] = ACTIONS(2923),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2923),
    [anon_sym_PLUS_EQ] = ACTIONS(2923),
    [anon_sym_DASH_EQ] = ACTIONS(2923),
    [anon_sym_DOT_EQ] = ACTIONS(2923),
    [anon_sym_STAR_EQ] = ACTIONS(2923),
    [anon_sym_SLASH_EQ] = ACTIONS(2923),
    [anon_sym_PERCENT_EQ] = ACTIONS(2923),
    [anon_sym_x_EQ] = ACTIONS(2923),
    [anon_sym_AMP_EQ] = ACTIONS(2923),
    [anon_sym_PIPE_EQ] = ACTIONS(2923),
    [anon_sym_CARET_EQ] = ACTIONS(2923),
    [anon_sym_LT_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_GT_EQ] = ACTIONS(2923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_GT_GT2] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_x] = ACTIONS(2923),
    [anon_sym_EQ_TILDE] = ACTIONS(2923),
    [anon_sym_BANG_TILDE] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_eq] = ACTIONS(2923),
    [anon_sym_ne] = ACTIONS(2923),
    [anon_sym_LT_EQ_GT] = ACTIONS(2923),
    [anon_sym_cmp] = ACTIONS(2923),
    [anon_sym_TILDE_TILDE] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_lt] = ACTIONS(2923),
    [anon_sym_le] = ACTIONS(2923),
    [anon_sym_ge] = ACTIONS(2923),
    [anon_sym_gt] = ACTIONS(2923),
    [anon_sym_isa] = ACTIONS(2923),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2923),
    [anon_sym_BSLASH] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_eval] = ACTIONS(2923),
    [anon_sym_field] = ACTIONS(2923),
    [anon_sym_local] = ACTIONS(2923),
    [anon_sym_require] = ACTIONS(2923),
    [anon_sym_map] = ACTIONS(2923),
    [anon_sym_grep] = ACTIONS(2923),
    [anon_sym_sort] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_undef] = ACTIONS(2923),
    [anon_sym_PERCENT2] = ACTIONS(2923),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_use] = ACTIONS(2923),
    [anon_sym_no] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_foreach] = ACTIONS(2923),
    [anon_sym_last] = ACTIONS(2923),
    [anon_sym_next] = ACTIONS(2923),
    [anon_sym_redo] = ACTIONS(2923),
    [anon_sym_BEGIN] = ACTIONS(2923),
    [anon_sym_INIT] = ACTIONS(2923),
    [anon_sym_CHECK] = ACTIONS(2923),
    [anon_sym_UNITCHECK] = ACTIONS(2923),
    [anon_sym_END] = ACTIONS(2923),
    [anon_sym_ADJUST] = ACTIONS(2923),
    [anon_sym___FILE__] = ACTIONS(2923),
    [anon_sym___LINE__] = ACTIONS(2923),
    [anon_sym___PACKAGE__] = ACTIONS(2923),
    [anon_sym___SUB__] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_fork] = ACTIONS(2923),
    [anon_sym_getppid] = ACTIONS(2923),
    [anon_sym_time] = ACTIONS(2923),
    [anon_sym_times] = ACTIONS(2923),
    [anon_sym_wait] = ACTIONS(2923),
    [anon_sym_wantarray] = ACTIONS(2923),
    [anon_sym_abs] = ACTIONS(2923),
    [anon_sym_alarm] = ACTIONS(2923),
    [anon_sym_chop] = ACTIONS(2923),
    [anon_sym_chdir] = ACTIONS(2923),
    [anon_sym_close] = ACTIONS(2923),
    [anon_sym_closedir] = ACTIONS(2923),
    [anon_sym_caller] = ACTIONS(2923),
    [anon_sym_chomp] = ACTIONS(2923),
    [anon_sym_chr] = ACTIONS(2923),
    [anon_sym_cos] = ACTIONS(2923),
    [anon_sym_chroot] = ACTIONS(2923),
    [anon_sym_defined] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_dbmclose] = ACTIONS(2923),
    [anon_sym_exists] = ACTIONS(2923),
    [anon_sym_exit] = ACTIONS(2923),
    [anon_sym_eof] = ACTIONS(2923),
    [anon_sym_exp] = ACTIONS(2923),
    [anon_sym_each] = ACTIONS(2923),
    [anon_sym_fc] = ACTIONS(2923),
    [anon_sym_fileno] = ACTIONS(2923),
    [anon_sym_gmtime] = ACTIONS(2923),
    [anon_sym_getc] = ACTIONS(2923),
    [anon_sym_getpgrp] = ACTIONS(2923),
    [anon_sym_getprotobyname] = ACTIONS(2923),
    [anon_sym_getpwname] = ACTIONS(2923),
    [anon_sym_getpwuid] = ACTIONS(2923),
    [anon_sym_getpeername] = ACTIONS(2923),
    [anon_sym_getnetbyname] = ACTIONS(2923),
    [anon_sym_getsockname] = ACTIONS(2923),
    [anon_sym_getgrnam] = ACTIONS(2923),
    [anon_sym_getgrgid] = ACTIONS(2923),
    [anon_sym_hex] = ACTIONS(2923),
    [anon_sym_int] = ACTIONS(2923),
    [anon_sym_keys] = ACTIONS(2923),
    [anon_sym_lc] = ACTIONS(2923),
    [anon_sym_lcfirst] = ACTIONS(2923),
    [anon_sym_length] = ACTIONS(2923),
    [anon_sym_localtime] = ACTIONS(2923),
    [anon_sym_log] = ACTIONS(2923),
    [anon_sym_lock] = ACTIONS(2923),
    [anon_sym_lstat] = ACTIONS(2923),
    [anon_sym_oct] = ACTIONS(2923),
    [anon_sym_ord] = ACTIONS(2923),
    [anon_sym_prototype] = ACTIONS(2923),
    [anon_sym_pop] = ACTIONS(2923),
    [anon_sym_pos] = ACTIONS(2923),
    [anon_sym_quotemeta] = ACTIONS(2923),
    [anon_sym_reset] = ACTIONS(2923),
    [anon_sym_rand] = ACTIONS(2923),
    [anon_sym_rmdir] = ACTIONS(2923),
    [anon_sym_readdir] = ACTIONS(2923),
    [anon_sym_readline] = ACTIONS(2923),
    [anon_sym_readpipe] = ACTIONS(2923),
    [anon_sym_rewinddir] = ACTIONS(2923),
    [anon_sym_readlink] = ACTIONS(2923),
    [anon_sym_ref] = ACTIONS(2923),
    [anon_sym_scalar] = ACTIONS(2923),
    [anon_sym_shift] = ACTIONS(2923),
    [anon_sym_sin] = ACTIONS(2923),
    [anon_sym_sleep] = ACTIONS(2923),
    [anon_sym_sqrt] = ACTIONS(2923),
    [anon_sym_srand] = ACTIONS(2923),
    [anon_sym_stat] = ACTIONS(2923),
    [anon_sym_study] = ACTIONS(2923),
    [anon_sym_tell] = ACTIONS(2923),
    [anon_sym_telldir] = ACTIONS(2923),
    [anon_sym_tied] = ACTIONS(2923),
    [anon_sym_uc] = ACTIONS(2923),
    [anon_sym_ucfirst] = ACTIONS(2923),
    [anon_sym_untie] = ACTIONS(2923),
    [anon_sym_umask] = ACTIONS(2923),
    [anon_sym_values] = ACTIONS(2923),
    [anon_sym_write] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2923),
    [anon_sym___END__] = ACTIONS(2923),
    [anon_sym_q] = ACTIONS(2923),
    [anon_sym_qq] = ACTIONS(2923),
    [anon_sym_qw] = ACTIONS(2923),
    [anon_sym_qx] = ACTIONS(2923),
    [anon_sym_qr] = ACTIONS(2923),
    [anon_sym_m] = ACTIONS(2923),
    [anon_sym_s] = ACTIONS(2923),
    [anon_sym_tr] = ACTIONS(2923),
    [anon_sym_y] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_unless] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_until] = ACTIONS(2923),
    [aux_sym__bareword_token1] = ACTIONS(2923),
    [sym_number] = ACTIONS(2923),
    [sym__apostrophe] = ACTIONS(2925),
    [sym__double_quote] = ACTIONS(2925),
    [sym__backtick] = ACTIONS(2925),
    [sym__search_slash] = ACTIONS(2925),
    [sym__PERLY_SEMICOLON] = ACTIONS(2925),
    [sym__PERLY_HEREDOC] = ACTIONS(2925),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [946] = {
    [sym_heredoc_content] = STATE(946),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2927),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_EQ] = ACTIONS(2929),
    [anon_sym_STAR_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_PERCENT_EQ] = ACTIONS(2929),
    [anon_sym_x_EQ] = ACTIONS(2929),
    [anon_sym_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_CARET_EQ] = ACTIONS(2929),
    [anon_sym_LT_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_BANG_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_eq] = ACTIONS(2931),
    [anon_sym_ne] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2929),
    [anon_sym_cmp] = ACTIONS(2931),
    [anon_sym_TILDE_TILDE] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_lt] = ACTIONS(2931),
    [anon_sym_le] = ACTIONS(2931),
    [anon_sym_ge] = ACTIONS(2931),
    [anon_sym_gt] = ACTIONS(2931),
    [anon_sym_isa] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2929),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2927),
    [anon_sym___END__] = ACTIONS(2927),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_SEMICOLON] = ACTIONS(2936),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [947] = {
    [sym_heredoc_content] = STATE(947),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_COMMA] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_DASH_GT] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_PERCENT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2905),
    [anon_sym_PLUS_EQ] = ACTIONS(2905),
    [anon_sym_DASH_EQ] = ACTIONS(2905),
    [anon_sym_DOT_EQ] = ACTIONS(2905),
    [anon_sym_STAR_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_PERCENT_EQ] = ACTIONS(2905),
    [anon_sym_x_EQ] = ACTIONS(2905),
    [anon_sym_AMP_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_CARET_EQ] = ACTIONS(2905),
    [anon_sym_LT_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_GT_EQ] = ACTIONS(2905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_STAR_STAR] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_GT_GT2] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_DOT] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_x] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2905),
    [anon_sym_BANG_TILDE] = ACTIONS(2905),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_LT_EQ_GT] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_TILDE_TILDE] = ACTIONS(2905),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_QMARK] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_SEMICOLON] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [948] = {
    [sym_heredoc_content] = STATE(948),
    [sym__identifier] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_sub] = ACTIONS(2885),
    [anon_sym_method] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_my] = ACTIONS(2885),
    [anon_sym_state] = ACTIONS(2885),
    [anon_sym_our] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_elsif] = ACTIONS(2885),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_DASH_GT] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_DOT_EQ] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_x_EQ] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_GT_GT2] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_x] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_eq] = ACTIONS(2885),
    [anon_sym_ne] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_cmp] = ACTIONS(2885),
    [anon_sym_TILDE_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_lt] = ACTIONS(2885),
    [anon_sym_le] = ACTIONS(2885),
    [anon_sym_ge] = ACTIONS(2885),
    [anon_sym_gt] = ACTIONS(2885),
    [anon_sym_isa] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BSLASH] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_eval] = ACTIONS(2885),
    [anon_sym_field] = ACTIONS(2885),
    [anon_sym_local] = ACTIONS(2885),
    [anon_sym_require] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(2885),
    [anon_sym_grep] = ACTIONS(2885),
    [anon_sym_sort] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_undef] = ACTIONS(2885),
    [anon_sym_PERCENT2] = ACTIONS(2885),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2885),
    [anon_sym_no] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_foreach] = ACTIONS(2885),
    [anon_sym_last] = ACTIONS(2885),
    [anon_sym_next] = ACTIONS(2885),
    [anon_sym_redo] = ACTIONS(2885),
    [anon_sym_BEGIN] = ACTIONS(2885),
    [anon_sym_INIT] = ACTIONS(2885),
    [anon_sym_CHECK] = ACTIONS(2885),
    [anon_sym_UNITCHECK] = ACTIONS(2885),
    [anon_sym_END] = ACTIONS(2885),
    [anon_sym_ADJUST] = ACTIONS(2885),
    [anon_sym___FILE__] = ACTIONS(2885),
    [anon_sym___LINE__] = ACTIONS(2885),
    [anon_sym___PACKAGE__] = ACTIONS(2885),
    [anon_sym___SUB__] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_fork] = ACTIONS(2885),
    [anon_sym_getppid] = ACTIONS(2885),
    [anon_sym_time] = ACTIONS(2885),
    [anon_sym_times] = ACTIONS(2885),
    [anon_sym_wait] = ACTIONS(2885),
    [anon_sym_wantarray] = ACTIONS(2885),
    [anon_sym_abs] = ACTIONS(2885),
    [anon_sym_alarm] = ACTIONS(2885),
    [anon_sym_chop] = ACTIONS(2885),
    [anon_sym_chdir] = ACTIONS(2885),
    [anon_sym_close] = ACTIONS(2885),
    [anon_sym_closedir] = ACTIONS(2885),
    [anon_sym_caller] = ACTIONS(2885),
    [anon_sym_chomp] = ACTIONS(2885),
    [anon_sym_chr] = ACTIONS(2885),
    [anon_sym_cos] = ACTIONS(2885),
    [anon_sym_chroot] = ACTIONS(2885),
    [anon_sym_defined] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_dbmclose] = ACTIONS(2885),
    [anon_sym_exists] = ACTIONS(2885),
    [anon_sym_exit] = ACTIONS(2885),
    [anon_sym_eof] = ACTIONS(2885),
    [anon_sym_exp] = ACTIONS(2885),
    [anon_sym_each] = ACTIONS(2885),
    [anon_sym_fc] = ACTIONS(2885),
    [anon_sym_fileno] = ACTIONS(2885),
    [anon_sym_gmtime] = ACTIONS(2885),
    [anon_sym_getc] = ACTIONS(2885),
    [anon_sym_getpgrp] = ACTIONS(2885),
    [anon_sym_getprotobyname] = ACTIONS(2885),
    [anon_sym_getpwname] = ACTIONS(2885),
    [anon_sym_getpwuid] = ACTIONS(2885),
    [anon_sym_getpeername] = ACTIONS(2885),
    [anon_sym_getnetbyname] = ACTIONS(2885),
    [anon_sym_getsockname] = ACTIONS(2885),
    [anon_sym_getgrnam] = ACTIONS(2885),
    [anon_sym_getgrgid] = ACTIONS(2885),
    [anon_sym_hex] = ACTIONS(2885),
    [anon_sym_int] = ACTIONS(2885),
    [anon_sym_keys] = ACTIONS(2885),
    [anon_sym_lc] = ACTIONS(2885),
    [anon_sym_lcfirst] = ACTIONS(2885),
    [anon_sym_length] = ACTIONS(2885),
    [anon_sym_localtime] = ACTIONS(2885),
    [anon_sym_log] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_lstat] = ACTIONS(2885),
    [anon_sym_oct] = ACTIONS(2885),
    [anon_sym_ord] = ACTIONS(2885),
    [anon_sym_prototype] = ACTIONS(2885),
    [anon_sym_pop] = ACTIONS(2885),
    [anon_sym_pos] = ACTIONS(2885),
    [anon_sym_quotemeta] = ACTIONS(2885),
    [anon_sym_reset] = ACTIONS(2885),
    [anon_sym_rand] = ACTIONS(2885),
    [anon_sym_rmdir] = ACTIONS(2885),
    [anon_sym_readdir] = ACTIONS(2885),
    [anon_sym_readline] = ACTIONS(2885),
    [anon_sym_readpipe] = ACTIONS(2885),
    [anon_sym_rewinddir] = ACTIONS(2885),
    [anon_sym_readlink] = ACTIONS(2885),
    [anon_sym_ref] = ACTIONS(2885),
    [anon_sym_scalar] = ACTIONS(2885),
    [anon_sym_shift] = ACTIONS(2885),
    [anon_sym_sin] = ACTIONS(2885),
    [anon_sym_sleep] = ACTIONS(2885),
    [anon_sym_sqrt] = ACTIONS(2885),
    [anon_sym_srand] = ACTIONS(2885),
    [anon_sym_stat] = ACTIONS(2885),
    [anon_sym_study] = ACTIONS(2885),
    [anon_sym_tell] = ACTIONS(2885),
    [anon_sym_telldir] = ACTIONS(2885),
    [anon_sym_tied] = ACTIONS(2885),
    [anon_sym_uc] = ACTIONS(2885),
    [anon_sym_ucfirst] = ACTIONS(2885),
    [anon_sym_untie] = ACTIONS(2885),
    [anon_sym_umask] = ACTIONS(2885),
    [anon_sym_values] = ACTIONS(2885),
    [anon_sym_write] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2885),
    [anon_sym___END__] = ACTIONS(2885),
    [anon_sym_q] = ACTIONS(2885),
    [anon_sym_qq] = ACTIONS(2885),
    [anon_sym_qw] = ACTIONS(2885),
    [anon_sym_qx] = ACTIONS(2885),
    [anon_sym_qr] = ACTIONS(2885),
    [anon_sym_m] = ACTIONS(2885),
    [anon_sym_s] = ACTIONS(2885),
    [anon_sym_tr] = ACTIONS(2885),
    [anon_sym_y] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [aux_sym__bareword_token1] = ACTIONS(2885),
    [sym_number] = ACTIONS(2885),
    [sym__apostrophe] = ACTIONS(2887),
    [sym__double_quote] = ACTIONS(2887),
    [sym__backtick] = ACTIONS(2887),
    [sym__search_slash] = ACTIONS(2887),
    [sym__PERLY_SEMICOLON] = ACTIONS(2887),
    [sym__PERLY_HEREDOC] = ACTIONS(2887),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [949] = {
    [sym_heredoc_content] = STATE(949),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2938),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2938),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2927),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2938),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2938),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2938),
    [anon_sym_PLUS_EQ] = ACTIONS(2938),
    [anon_sym_DASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_EQ] = ACTIONS(2938),
    [anon_sym_STAR_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_PERCENT_EQ] = ACTIONS(2938),
    [anon_sym_x_EQ] = ACTIONS(2938),
    [anon_sym_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_CARET_EQ] = ACTIONS(2938),
    [anon_sym_LT_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_GT_EQ] = ACTIONS(2938),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [anon_sym_STAR_STAR] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_SLASH_SLASH] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_GT_GT2] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_x] = ACTIONS(2938),
    [anon_sym_EQ_TILDE] = ACTIONS(2938),
    [anon_sym_BANG_TILDE] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_eq] = ACTIONS(2938),
    [anon_sym_ne] = ACTIONS(2938),
    [anon_sym_LT_EQ_GT] = ACTIONS(2938),
    [anon_sym_cmp] = ACTIONS(2938),
    [anon_sym_TILDE_TILDE] = ACTIONS(2938),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2938),
    [anon_sym_lt] = ACTIONS(2938),
    [anon_sym_le] = ACTIONS(2938),
    [anon_sym_ge] = ACTIONS(2938),
    [anon_sym_gt] = ACTIONS(2938),
    [anon_sym_isa] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2938),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2927),
    [anon_sym___END__] = ACTIONS(2927),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [950] = {
    [sym_heredoc_content] = STATE(950),
    [sym__identifier] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_sub] = ACTIONS(2893),
    [anon_sym_method] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_my] = ACTIONS(2893),
    [anon_sym_state] = ACTIONS(2893),
    [anon_sym_our] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_elsif] = ACTIONS(2893),
    [anon_sym_and] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2893),
    [anon_sym_PLUS_EQ] = ACTIONS(2893),
    [anon_sym_DASH_EQ] = ACTIONS(2893),
    [anon_sym_DOT_EQ] = ACTIONS(2893),
    [anon_sym_STAR_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_PERCENT_EQ] = ACTIONS(2893),
    [anon_sym_x_EQ] = ACTIONS(2893),
    [anon_sym_AMP_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_CARET_EQ] = ACTIONS(2893),
    [anon_sym_LT_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_DOT_DOT] = ACTIONS(2893),
    [anon_sym_STAR_STAR] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_GT_GT2] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_x] = ACTIONS(2893),
    [anon_sym_EQ_TILDE] = ACTIONS(2893),
    [anon_sym_BANG_TILDE] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_eq] = ACTIONS(2893),
    [anon_sym_ne] = ACTIONS(2893),
    [anon_sym_LT_EQ_GT] = ACTIONS(2893),
    [anon_sym_cmp] = ACTIONS(2893),
    [anon_sym_TILDE_TILDE] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_lt] = ACTIONS(2893),
    [anon_sym_le] = ACTIONS(2893),
    [anon_sym_ge] = ACTIONS(2893),
    [anon_sym_gt] = ACTIONS(2893),
    [anon_sym_isa] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BSLASH] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_eval] = ACTIONS(2893),
    [anon_sym_field] = ACTIONS(2893),
    [anon_sym_local] = ACTIONS(2893),
    [anon_sym_require] = ACTIONS(2893),
    [anon_sym_map] = ACTIONS(2893),
    [anon_sym_grep] = ACTIONS(2893),
    [anon_sym_sort] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_undef] = ACTIONS(2893),
    [anon_sym_PERCENT2] = ACTIONS(2893),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2893),
    [anon_sym_EQ_GT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2893),
    [anon_sym_no] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_foreach] = ACTIONS(2893),
    [anon_sym_last] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2893),
    [anon_sym_redo] = ACTIONS(2893),
    [anon_sym_BEGIN] = ACTIONS(2893),
    [anon_sym_INIT] = ACTIONS(2893),
    [anon_sym_CHECK] = ACTIONS(2893),
    [anon_sym_UNITCHECK] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2893),
    [anon_sym_ADJUST] = ACTIONS(2893),
    [anon_sym___FILE__] = ACTIONS(2893),
    [anon_sym___LINE__] = ACTIONS(2893),
    [anon_sym___PACKAGE__] = ACTIONS(2893),
    [anon_sym___SUB__] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_fork] = ACTIONS(2893),
    [anon_sym_getppid] = ACTIONS(2893),
    [anon_sym_time] = ACTIONS(2893),
    [anon_sym_times] = ACTIONS(2893),
    [anon_sym_wait] = ACTIONS(2893),
    [anon_sym_wantarray] = ACTIONS(2893),
    [anon_sym_abs] = ACTIONS(2893),
    [anon_sym_alarm] = ACTIONS(2893),
    [anon_sym_chop] = ACTIONS(2893),
    [anon_sym_chdir] = ACTIONS(2893),
    [anon_sym_close] = ACTIONS(2893),
    [anon_sym_closedir] = ACTIONS(2893),
    [anon_sym_caller] = ACTIONS(2893),
    [anon_sym_chomp] = ACTIONS(2893),
    [anon_sym_chr] = ACTIONS(2893),
    [anon_sym_cos] = ACTIONS(2893),
    [anon_sym_chroot] = ACTIONS(2893),
    [anon_sym_defined] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_dbmclose] = ACTIONS(2893),
    [anon_sym_exists] = ACTIONS(2893),
    [anon_sym_exit] = ACTIONS(2893),
    [anon_sym_eof] = ACTIONS(2893),
    [anon_sym_exp] = ACTIONS(2893),
    [anon_sym_each] = ACTIONS(2893),
    [anon_sym_fc] = ACTIONS(2893),
    [anon_sym_fileno] = ACTIONS(2893),
    [anon_sym_gmtime] = ACTIONS(2893),
    [anon_sym_getc] = ACTIONS(2893),
    [anon_sym_getpgrp] = ACTIONS(2893),
    [anon_sym_getprotobyname] = ACTIONS(2893),
    [anon_sym_getpwname] = ACTIONS(2893),
    [anon_sym_getpwuid] = ACTIONS(2893),
    [anon_sym_getpeername] = ACTIONS(2893),
    [anon_sym_getnetbyname] = ACTIONS(2893),
    [anon_sym_getsockname] = ACTIONS(2893),
    [anon_sym_getgrnam] = ACTIONS(2893),
    [anon_sym_getgrgid] = ACTIONS(2893),
    [anon_sym_hex] = ACTIONS(2893),
    [anon_sym_int] = ACTIONS(2893),
    [anon_sym_keys] = ACTIONS(2893),
    [anon_sym_lc] = ACTIONS(2893),
    [anon_sym_lcfirst] = ACTIONS(2893),
    [anon_sym_length] = ACTIONS(2893),
    [anon_sym_localtime] = ACTIONS(2893),
    [anon_sym_log] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_lstat] = ACTIONS(2893),
    [anon_sym_oct] = ACTIONS(2893),
    [anon_sym_ord] = ACTIONS(2893),
    [anon_sym_prototype] = ACTIONS(2893),
    [anon_sym_pop] = ACTIONS(2893),
    [anon_sym_pos] = ACTIONS(2893),
    [anon_sym_quotemeta] = ACTIONS(2893),
    [anon_sym_reset] = ACTIONS(2893),
    [anon_sym_rand] = ACTIONS(2893),
    [anon_sym_rmdir] = ACTIONS(2893),
    [anon_sym_readdir] = ACTIONS(2893),
    [anon_sym_readline] = ACTIONS(2893),
    [anon_sym_readpipe] = ACTIONS(2893),
    [anon_sym_rewinddir] = ACTIONS(2893),
    [anon_sym_readlink] = ACTIONS(2893),
    [anon_sym_ref] = ACTIONS(2893),
    [anon_sym_scalar] = ACTIONS(2893),
    [anon_sym_shift] = ACTIONS(2893),
    [anon_sym_sin] = ACTIONS(2893),
    [anon_sym_sleep] = ACTIONS(2893),
    [anon_sym_sqrt] = ACTIONS(2893),
    [anon_sym_srand] = ACTIONS(2893),
    [anon_sym_stat] = ACTIONS(2893),
    [anon_sym_study] = ACTIONS(2893),
    [anon_sym_tell] = ACTIONS(2893),
    [anon_sym_telldir] = ACTIONS(2893),
    [anon_sym_tied] = ACTIONS(2893),
    [anon_sym_uc] = ACTIONS(2893),
    [anon_sym_ucfirst] = ACTIONS(2893),
    [anon_sym_untie] = ACTIONS(2893),
    [anon_sym_umask] = ACTIONS(2893),
    [anon_sym_values] = ACTIONS(2893),
    [anon_sym_write] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2893),
    [anon_sym___END__] = ACTIONS(2893),
    [anon_sym_q] = ACTIONS(2893),
    [anon_sym_qq] = ACTIONS(2893),
    [anon_sym_qw] = ACTIONS(2893),
    [anon_sym_qx] = ACTIONS(2893),
    [anon_sym_qr] = ACTIONS(2893),
    [anon_sym_m] = ACTIONS(2893),
    [anon_sym_s] = ACTIONS(2893),
    [anon_sym_tr] = ACTIONS(2893),
    [anon_sym_y] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_until] = ACTIONS(2893),
    [aux_sym__bareword_token1] = ACTIONS(2893),
    [sym_number] = ACTIONS(2893),
    [sym__apostrophe] = ACTIONS(2895),
    [sym__double_quote] = ACTIONS(2895),
    [sym__backtick] = ACTIONS(2895),
    [sym__search_slash] = ACTIONS(2895),
    [sym__PERLY_SEMICOLON] = ACTIONS(2895),
    [sym__PERLY_HEREDOC] = ACTIONS(2895),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [951] = {
    [sym_heredoc_content] = STATE(951),
    [sym__identifier] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym_class] = ACTIONS(2942),
    [anon_sym_sub] = ACTIONS(2942),
    [anon_sym_method] = ACTIONS(2942),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_continue] = ACTIONS(2942),
    [anon_sym_my] = ACTIONS(2942),
    [anon_sym_state] = ACTIONS(2942),
    [anon_sym_our] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2944),
    [anon_sym_else] = ACTIONS(2942),
    [anon_sym_elsif] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_DASH_GT] = ACTIONS(2944),
    [anon_sym_AT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2944),
    [anon_sym_PLUS_EQ] = ACTIONS(2944),
    [anon_sym_DASH_EQ] = ACTIONS(2944),
    [anon_sym_DOT_EQ] = ACTIONS(2944),
    [anon_sym_STAR_EQ] = ACTIONS(2944),
    [anon_sym_SLASH_EQ] = ACTIONS(2944),
    [anon_sym_PERCENT_EQ] = ACTIONS(2944),
    [anon_sym_x_EQ] = ACTIONS(2944),
    [anon_sym_AMP_EQ] = ACTIONS(2944),
    [anon_sym_PIPE_EQ] = ACTIONS(2944),
    [anon_sym_CARET_EQ] = ACTIONS(2944),
    [anon_sym_LT_LT_EQ] = ACTIONS(2944),
    [anon_sym_GT_GT_EQ] = ACTIONS(2944),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2944),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2944),
    [anon_sym_DOT_DOT] = ACTIONS(2944),
    [anon_sym_STAR_STAR] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_SLASH_SLASH] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_GT_GT2] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2944),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2944),
    [anon_sym_x] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(2944),
    [anon_sym_BANG_TILDE] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2944),
    [anon_sym_BANG_EQ] = ACTIONS(2944),
    [anon_sym_eq] = ACTIONS(2942),
    [anon_sym_ne] = ACTIONS(2942),
    [anon_sym_LT_EQ_GT] = ACTIONS(2944),
    [anon_sym_cmp] = ACTIONS(2942),
    [anon_sym_TILDE_TILDE] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [anon_sym_lt] = ACTIONS(2942),
    [anon_sym_le] = ACTIONS(2942),
    [anon_sym_ge] = ACTIONS(2942),
    [anon_sym_gt] = ACTIONS(2942),
    [anon_sym_isa] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2942),
    [anon_sym_BANG] = ACTIONS(2942),
    [anon_sym_PLUS_PLUS] = ACTIONS(2942),
    [anon_sym_DASH_DASH] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2944),
    [anon_sym_BSLASH] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_eval] = ACTIONS(2942),
    [anon_sym_field] = ACTIONS(2942),
    [anon_sym_local] = ACTIONS(2942),
    [anon_sym_require] = ACTIONS(2942),
    [anon_sym_map] = ACTIONS(2942),
    [anon_sym_grep] = ACTIONS(2942),
    [anon_sym_sort] = ACTIONS(2942),
    [anon_sym_goto] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_undef] = ACTIONS(2942),
    [anon_sym_PERCENT2] = ACTIONS(2942),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2942),
    [anon_sym_EQ_GT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_no] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_foreach] = ACTIONS(2942),
    [anon_sym_last] = ACTIONS(2942),
    [anon_sym_next] = ACTIONS(2942),
    [anon_sym_redo] = ACTIONS(2942),
    [anon_sym_BEGIN] = ACTIONS(2942),
    [anon_sym_INIT] = ACTIONS(2942),
    [anon_sym_CHECK] = ACTIONS(2942),
    [anon_sym_UNITCHECK] = ACTIONS(2942),
    [anon_sym_END] = ACTIONS(2942),
    [anon_sym_ADJUST] = ACTIONS(2942),
    [anon_sym___FILE__] = ACTIONS(2942),
    [anon_sym___LINE__] = ACTIONS(2942),
    [anon_sym___PACKAGE__] = ACTIONS(2942),
    [anon_sym___SUB__] = ACTIONS(2942),
    [anon_sym_break] = ACTIONS(2942),
    [anon_sym_fork] = ACTIONS(2942),
    [anon_sym_getppid] = ACTIONS(2942),
    [anon_sym_time] = ACTIONS(2942),
    [anon_sym_times] = ACTIONS(2942),
    [anon_sym_wait] = ACTIONS(2942),
    [anon_sym_wantarray] = ACTIONS(2942),
    [anon_sym_abs] = ACTIONS(2942),
    [anon_sym_alarm] = ACTIONS(2942),
    [anon_sym_chop] = ACTIONS(2942),
    [anon_sym_chdir] = ACTIONS(2942),
    [anon_sym_close] = ACTIONS(2942),
    [anon_sym_closedir] = ACTIONS(2942),
    [anon_sym_caller] = ACTIONS(2942),
    [anon_sym_chomp] = ACTIONS(2942),
    [anon_sym_chr] = ACTIONS(2942),
    [anon_sym_cos] = ACTIONS(2942),
    [anon_sym_chroot] = ACTIONS(2942),
    [anon_sym_defined] = ACTIONS(2942),
    [anon_sym_delete] = ACTIONS(2942),
    [anon_sym_dbmclose] = ACTIONS(2942),
    [anon_sym_exists] = ACTIONS(2942),
    [anon_sym_exit] = ACTIONS(2942),
    [anon_sym_eof] = ACTIONS(2942),
    [anon_sym_exp] = ACTIONS(2942),
    [anon_sym_each] = ACTIONS(2942),
    [anon_sym_fc] = ACTIONS(2942),
    [anon_sym_fileno] = ACTIONS(2942),
    [anon_sym_gmtime] = ACTIONS(2942),
    [anon_sym_getc] = ACTIONS(2942),
    [anon_sym_getpgrp] = ACTIONS(2942),
    [anon_sym_getprotobyname] = ACTIONS(2942),
    [anon_sym_getpwname] = ACTIONS(2942),
    [anon_sym_getpwuid] = ACTIONS(2942),
    [anon_sym_getpeername] = ACTIONS(2942),
    [anon_sym_getnetbyname] = ACTIONS(2942),
    [anon_sym_getsockname] = ACTIONS(2942),
    [anon_sym_getgrnam] = ACTIONS(2942),
    [anon_sym_getgrgid] = ACTIONS(2942),
    [anon_sym_hex] = ACTIONS(2942),
    [anon_sym_int] = ACTIONS(2942),
    [anon_sym_keys] = ACTIONS(2942),
    [anon_sym_lc] = ACTIONS(2942),
    [anon_sym_lcfirst] = ACTIONS(2942),
    [anon_sym_length] = ACTIONS(2942),
    [anon_sym_localtime] = ACTIONS(2942),
    [anon_sym_log] = ACTIONS(2942),
    [anon_sym_lock] = ACTIONS(2942),
    [anon_sym_lstat] = ACTIONS(2942),
    [anon_sym_oct] = ACTIONS(2942),
    [anon_sym_ord] = ACTIONS(2942),
    [anon_sym_prototype] = ACTIONS(2942),
    [anon_sym_pop] = ACTIONS(2942),
    [anon_sym_pos] = ACTIONS(2942),
    [anon_sym_quotemeta] = ACTIONS(2942),
    [anon_sym_reset] = ACTIONS(2942),
    [anon_sym_rand] = ACTIONS(2942),
    [anon_sym_rmdir] = ACTIONS(2942),
    [anon_sym_readdir] = ACTIONS(2942),
    [anon_sym_readline] = ACTIONS(2942),
    [anon_sym_readpipe] = ACTIONS(2942),
    [anon_sym_rewinddir] = ACTIONS(2942),
    [anon_sym_readlink] = ACTIONS(2942),
    [anon_sym_ref] = ACTIONS(2942),
    [anon_sym_scalar] = ACTIONS(2942),
    [anon_sym_shift] = ACTIONS(2942),
    [anon_sym_sin] = ACTIONS(2942),
    [anon_sym_sleep] = ACTIONS(2942),
    [anon_sym_sqrt] = ACTIONS(2942),
    [anon_sym_srand] = ACTIONS(2942),
    [anon_sym_stat] = ACTIONS(2942),
    [anon_sym_study] = ACTIONS(2942),
    [anon_sym_tell] = ACTIONS(2942),
    [anon_sym_telldir] = ACTIONS(2942),
    [anon_sym_tied] = ACTIONS(2942),
    [anon_sym_uc] = ACTIONS(2942),
    [anon_sym_ucfirst] = ACTIONS(2942),
    [anon_sym_untie] = ACTIONS(2942),
    [anon_sym_umask] = ACTIONS(2942),
    [anon_sym_values] = ACTIONS(2942),
    [anon_sym_write] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2942),
    [anon_sym___END__] = ACTIONS(2942),
    [anon_sym_q] = ACTIONS(2942),
    [anon_sym_qq] = ACTIONS(2942),
    [anon_sym_qw] = ACTIONS(2942),
    [anon_sym_qx] = ACTIONS(2942),
    [anon_sym_qr] = ACTIONS(2942),
    [anon_sym_m] = ACTIONS(2942),
    [anon_sym_s] = ACTIONS(2942),
    [anon_sym_tr] = ACTIONS(2942),
    [anon_sym_y] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_unless] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_until] = ACTIONS(2942),
    [aux_sym__bareword_token1] = ACTIONS(2942),
    [sym_number] = ACTIONS(2942),
    [sym__apostrophe] = ACTIONS(2946),
    [sym__double_quote] = ACTIONS(2946),
    [sym__backtick] = ACTIONS(2946),
    [sym__search_slash] = ACTIONS(2946),
    [sym__PERLY_SEMICOLON] = ACTIONS(2946),
    [sym__PERLY_HEREDOC] = ACTIONS(2946),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [952] = {
    [sym_heredoc_content] = STATE(952),
    [sym__identifier] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_sub] = ACTIONS(2913),
    [anon_sym_method] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_my] = ACTIONS(2913),
    [anon_sym_state] = ACTIONS(2913),
    [anon_sym_our] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_else] = ACTIONS(2913),
    [anon_sym_elsif] = ACTIONS(2913),
    [anon_sym_and] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_EQ] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_x_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_BANG_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_eq] = ACTIONS(2913),
    [anon_sym_ne] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_cmp] = ACTIONS(2913),
    [anon_sym_TILDE_TILDE] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_lt] = ACTIONS(2913),
    [anon_sym_le] = ACTIONS(2913),
    [anon_sym_ge] = ACTIONS(2913),
    [anon_sym_gt] = ACTIONS(2913),
    [anon_sym_isa] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_BSLASH] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_eval] = ACTIONS(2913),
    [anon_sym_field] = ACTIONS(2913),
    [anon_sym_local] = ACTIONS(2913),
    [anon_sym_require] = ACTIONS(2913),
    [anon_sym_map] = ACTIONS(2913),
    [anon_sym_grep] = ACTIONS(2913),
    [anon_sym_sort] = ACTIONS(2913),
    [anon_sym_goto] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_undef] = ACTIONS(2913),
    [anon_sym_PERCENT2] = ACTIONS(2913),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2913),
    [anon_sym_EQ_GT] = ACTIONS(2913),
    [anon_sym_use] = ACTIONS(2913),
    [anon_sym_no] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_foreach] = ACTIONS(2913),
    [anon_sym_last] = ACTIONS(2913),
    [anon_sym_next] = ACTIONS(2913),
    [anon_sym_redo] = ACTIONS(2913),
    [anon_sym_BEGIN] = ACTIONS(2913),
    [anon_sym_INIT] = ACTIONS(2913),
    [anon_sym_CHECK] = ACTIONS(2913),
    [anon_sym_UNITCHECK] = ACTIONS(2913),
    [anon_sym_END] = ACTIONS(2913),
    [anon_sym_ADJUST] = ACTIONS(2913),
    [anon_sym___FILE__] = ACTIONS(2913),
    [anon_sym___LINE__] = ACTIONS(2913),
    [anon_sym___PACKAGE__] = ACTIONS(2913),
    [anon_sym___SUB__] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_fork] = ACTIONS(2913),
    [anon_sym_getppid] = ACTIONS(2913),
    [anon_sym_time] = ACTIONS(2913),
    [anon_sym_times] = ACTIONS(2913),
    [anon_sym_wait] = ACTIONS(2913),
    [anon_sym_wantarray] = ACTIONS(2913),
    [anon_sym_abs] = ACTIONS(2913),
    [anon_sym_alarm] = ACTIONS(2913),
    [anon_sym_chop] = ACTIONS(2913),
    [anon_sym_chdir] = ACTIONS(2913),
    [anon_sym_close] = ACTIONS(2913),
    [anon_sym_closedir] = ACTIONS(2913),
    [anon_sym_caller] = ACTIONS(2913),
    [anon_sym_chomp] = ACTIONS(2913),
    [anon_sym_chr] = ACTIONS(2913),
    [anon_sym_cos] = ACTIONS(2913),
    [anon_sym_chroot] = ACTIONS(2913),
    [anon_sym_defined] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_dbmclose] = ACTIONS(2913),
    [anon_sym_exists] = ACTIONS(2913),
    [anon_sym_exit] = ACTIONS(2913),
    [anon_sym_eof] = ACTIONS(2913),
    [anon_sym_exp] = ACTIONS(2913),
    [anon_sym_each] = ACTIONS(2913),
    [anon_sym_fc] = ACTIONS(2913),
    [anon_sym_fileno] = ACTIONS(2913),
    [anon_sym_gmtime] = ACTIONS(2913),
    [anon_sym_getc] = ACTIONS(2913),
    [anon_sym_getpgrp] = ACTIONS(2913),
    [anon_sym_getprotobyname] = ACTIONS(2913),
    [anon_sym_getpwname] = ACTIONS(2913),
    [anon_sym_getpwuid] = ACTIONS(2913),
    [anon_sym_getpeername] = ACTIONS(2913),
    [anon_sym_getnetbyname] = ACTIONS(2913),
    [anon_sym_getsockname] = ACTIONS(2913),
    [anon_sym_getgrnam] = ACTIONS(2913),
    [anon_sym_getgrgid] = ACTIONS(2913),
    [anon_sym_hex] = ACTIONS(2913),
    [anon_sym_int] = ACTIONS(2913),
    [anon_sym_keys] = ACTIONS(2913),
    [anon_sym_lc] = ACTIONS(2913),
    [anon_sym_lcfirst] = ACTIONS(2913),
    [anon_sym_length] = ACTIONS(2913),
    [anon_sym_localtime] = ACTIONS(2913),
    [anon_sym_log] = ACTIONS(2913),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_lstat] = ACTIONS(2913),
    [anon_sym_oct] = ACTIONS(2913),
    [anon_sym_ord] = ACTIONS(2913),
    [anon_sym_prototype] = ACTIONS(2913),
    [anon_sym_pop] = ACTIONS(2913),
    [anon_sym_pos] = ACTIONS(2913),
    [anon_sym_quotemeta] = ACTIONS(2913),
    [anon_sym_reset] = ACTIONS(2913),
    [anon_sym_rand] = ACTIONS(2913),
    [anon_sym_rmdir] = ACTIONS(2913),
    [anon_sym_readdir] = ACTIONS(2913),
    [anon_sym_readline] = ACTIONS(2913),
    [anon_sym_readpipe] = ACTIONS(2913),
    [anon_sym_rewinddir] = ACTIONS(2913),
    [anon_sym_readlink] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(2913),
    [anon_sym_scalar] = ACTIONS(2913),
    [anon_sym_shift] = ACTIONS(2913),
    [anon_sym_sin] = ACTIONS(2913),
    [anon_sym_sleep] = ACTIONS(2913),
    [anon_sym_sqrt] = ACTIONS(2913),
    [anon_sym_srand] = ACTIONS(2913),
    [anon_sym_stat] = ACTIONS(2913),
    [anon_sym_study] = ACTIONS(2913),
    [anon_sym_tell] = ACTIONS(2913),
    [anon_sym_telldir] = ACTIONS(2913),
    [anon_sym_tied] = ACTIONS(2913),
    [anon_sym_uc] = ACTIONS(2913),
    [anon_sym_ucfirst] = ACTIONS(2913),
    [anon_sym_untie] = ACTIONS(2913),
    [anon_sym_umask] = ACTIONS(2913),
    [anon_sym_values] = ACTIONS(2913),
    [anon_sym_write] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2913),
    [anon_sym___END__] = ACTIONS(2913),
    [anon_sym_q] = ACTIONS(2913),
    [anon_sym_qq] = ACTIONS(2913),
    [anon_sym_qw] = ACTIONS(2913),
    [anon_sym_qx] = ACTIONS(2913),
    [anon_sym_qr] = ACTIONS(2913),
    [anon_sym_m] = ACTIONS(2913),
    [anon_sym_s] = ACTIONS(2913),
    [anon_sym_tr] = ACTIONS(2913),
    [anon_sym_y] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_unless] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_until] = ACTIONS(2913),
    [aux_sym__bareword_token1] = ACTIONS(2913),
    [sym_number] = ACTIONS(2913),
    [sym__apostrophe] = ACTIONS(2917),
    [sym__double_quote] = ACTIONS(2917),
    [sym__backtick] = ACTIONS(2917),
    [sym__search_slash] = ACTIONS(2917),
    [sym__PERLY_SEMICOLON] = ACTIONS(2917),
    [sym__PERLY_HEREDOC] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [953] = {
    [sym_heredoc_content] = STATE(953),
    [sym__identifier] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_sub] = ACTIONS(2901),
    [anon_sym_method] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_my] = ACTIONS(2901),
    [anon_sym_state] = ACTIONS(2901),
    [anon_sym_our] = ACTIONS(2901),
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_elsif] = ACTIONS(2901),
    [anon_sym_and] = ACTIONS(2901),
    [anon_sym_or] = ACTIONS(2901),
    [anon_sym_DOLLAR] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_DASH_GT] = ACTIONS(2901),
    [anon_sym_AT] = ACTIONS(2901),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2901),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_DOT_EQ] = ACTIONS(2901),
    [anon_sym_STAR_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_PERCENT_EQ] = ACTIONS(2901),
    [anon_sym_x_EQ] = ACTIONS(2901),
    [anon_sym_AMP_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_CARET_EQ] = ACTIONS(2901),
    [anon_sym_LT_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_GT_EQ] = ACTIONS(2901),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_GT_GT2] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_x] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_BANG_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_eq] = ACTIONS(2901),
    [anon_sym_ne] = ACTIONS(2901),
    [anon_sym_LT_EQ_GT] = ACTIONS(2901),
    [anon_sym_cmp] = ACTIONS(2901),
    [anon_sym_TILDE_TILDE] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_lt] = ACTIONS(2901),
    [anon_sym_le] = ACTIONS(2901),
    [anon_sym_ge] = ACTIONS(2901),
    [anon_sym_gt] = ACTIONS(2901),
    [anon_sym_isa] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_QMARK] = ACTIONS(2901),
    [anon_sym_BSLASH] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_eval] = ACTIONS(2901),
    [anon_sym_field] = ACTIONS(2901),
    [anon_sym_local] = ACTIONS(2901),
    [anon_sym_require] = ACTIONS(2901),
    [anon_sym_map] = ACTIONS(2901),
    [anon_sym_grep] = ACTIONS(2901),
    [anon_sym_sort] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_undef] = ACTIONS(2901),
    [anon_sym_PERCENT2] = ACTIONS(2901),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(2901),
    [anon_sym_use] = ACTIONS(2901),
    [anon_sym_no] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_foreach] = ACTIONS(2901),
    [anon_sym_last] = ACTIONS(2901),
    [anon_sym_next] = ACTIONS(2901),
    [anon_sym_redo] = ACTIONS(2901),
    [anon_sym_BEGIN] = ACTIONS(2901),
    [anon_sym_INIT] = ACTIONS(2901),
    [anon_sym_CHECK] = ACTIONS(2901),
    [anon_sym_UNITCHECK] = ACTIONS(2901),
    [anon_sym_END] = ACTIONS(2901),
    [anon_sym_ADJUST] = ACTIONS(2901),
    [anon_sym___FILE__] = ACTIONS(2901),
    [anon_sym___LINE__] = ACTIONS(2901),
    [anon_sym___PACKAGE__] = ACTIONS(2901),
    [anon_sym___SUB__] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_fork] = ACTIONS(2901),
    [anon_sym_getppid] = ACTIONS(2901),
    [anon_sym_time] = ACTIONS(2901),
    [anon_sym_times] = ACTIONS(2901),
    [anon_sym_wait] = ACTIONS(2901),
    [anon_sym_wantarray] = ACTIONS(2901),
    [anon_sym_abs] = ACTIONS(2901),
    [anon_sym_alarm] = ACTIONS(2901),
    [anon_sym_chop] = ACTIONS(2901),
    [anon_sym_chdir] = ACTIONS(2901),
    [anon_sym_close] = ACTIONS(2901),
    [anon_sym_closedir] = ACTIONS(2901),
    [anon_sym_caller] = ACTIONS(2901),
    [anon_sym_chomp] = ACTIONS(2901),
    [anon_sym_chr] = ACTIONS(2901),
    [anon_sym_cos] = ACTIONS(2901),
    [anon_sym_chroot] = ACTIONS(2901),
    [anon_sym_defined] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_dbmclose] = ACTIONS(2901),
    [anon_sym_exists] = ACTIONS(2901),
    [anon_sym_exit] = ACTIONS(2901),
    [anon_sym_eof] = ACTIONS(2901),
    [anon_sym_exp] = ACTIONS(2901),
    [anon_sym_each] = ACTIONS(2901),
    [anon_sym_fc] = ACTIONS(2901),
    [anon_sym_fileno] = ACTIONS(2901),
    [anon_sym_gmtime] = ACTIONS(2901),
    [anon_sym_getc] = ACTIONS(2901),
    [anon_sym_getpgrp] = ACTIONS(2901),
    [anon_sym_getprotobyname] = ACTIONS(2901),
    [anon_sym_getpwname] = ACTIONS(2901),
    [anon_sym_getpwuid] = ACTIONS(2901),
    [anon_sym_getpeername] = ACTIONS(2901),
    [anon_sym_getnetbyname] = ACTIONS(2901),
    [anon_sym_getsockname] = ACTIONS(2901),
    [anon_sym_getgrnam] = ACTIONS(2901),
    [anon_sym_getgrgid] = ACTIONS(2901),
    [anon_sym_hex] = ACTIONS(2901),
    [anon_sym_int] = ACTIONS(2901),
    [anon_sym_keys] = ACTIONS(2901),
    [anon_sym_lc] = ACTIONS(2901),
    [anon_sym_lcfirst] = ACTIONS(2901),
    [anon_sym_length] = ACTIONS(2901),
    [anon_sym_localtime] = ACTIONS(2901),
    [anon_sym_log] = ACTIONS(2901),
    [anon_sym_lock] = ACTIONS(2901),
    [anon_sym_lstat] = ACTIONS(2901),
    [anon_sym_oct] = ACTIONS(2901),
    [anon_sym_ord] = ACTIONS(2901),
    [anon_sym_prototype] = ACTIONS(2901),
    [anon_sym_pop] = ACTIONS(2901),
    [anon_sym_pos] = ACTIONS(2901),
    [anon_sym_quotemeta] = ACTIONS(2901),
    [anon_sym_reset] = ACTIONS(2901),
    [anon_sym_rand] = ACTIONS(2901),
    [anon_sym_rmdir] = ACTIONS(2901),
    [anon_sym_readdir] = ACTIONS(2901),
    [anon_sym_readline] = ACTIONS(2901),
    [anon_sym_readpipe] = ACTIONS(2901),
    [anon_sym_rewinddir] = ACTIONS(2901),
    [anon_sym_readlink] = ACTIONS(2901),
    [anon_sym_ref] = ACTIONS(2901),
    [anon_sym_scalar] = ACTIONS(2901),
    [anon_sym_shift] = ACTIONS(2901),
    [anon_sym_sin] = ACTIONS(2901),
    [anon_sym_sleep] = ACTIONS(2901),
    [anon_sym_sqrt] = ACTIONS(2901),
    [anon_sym_srand] = ACTIONS(2901),
    [anon_sym_stat] = ACTIONS(2901),
    [anon_sym_study] = ACTIONS(2901),
    [anon_sym_tell] = ACTIONS(2901),
    [anon_sym_telldir] = ACTIONS(2901),
    [anon_sym_tied] = ACTIONS(2901),
    [anon_sym_uc] = ACTIONS(2901),
    [anon_sym_ucfirst] = ACTIONS(2901),
    [anon_sym_untie] = ACTIONS(2901),
    [anon_sym_umask] = ACTIONS(2901),
    [anon_sym_values] = ACTIONS(2901),
    [anon_sym_write] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2901),
    [anon_sym___END__] = ACTIONS(2901),
    [anon_sym_q] = ACTIONS(2901),
    [anon_sym_qq] = ACTIONS(2901),
    [anon_sym_qw] = ACTIONS(2901),
    [anon_sym_qx] = ACTIONS(2901),
    [anon_sym_qr] = ACTIONS(2901),
    [anon_sym_m] = ACTIONS(2901),
    [anon_sym_s] = ACTIONS(2901),
    [anon_sym_tr] = ACTIONS(2901),
    [anon_sym_y] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_unless] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_until] = ACTIONS(2901),
    [aux_sym__bareword_token1] = ACTIONS(2901),
    [sym_number] = ACTIONS(2901),
    [sym__apostrophe] = ACTIONS(2903),
    [sym__double_quote] = ACTIONS(2903),
    [sym__backtick] = ACTIONS(2903),
    [sym__search_slash] = ACTIONS(2903),
    [sym__PERLY_SEMICOLON] = ACTIONS(2903),
    [sym__PERLY_HEREDOC] = ACTIONS(2903),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [954] = {
    [sym_heredoc_content] = STATE(954),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2927),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_EQ] = ACTIONS(2929),
    [anon_sym_STAR_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_PERCENT_EQ] = ACTIONS(2929),
    [anon_sym_x_EQ] = ACTIONS(2929),
    [anon_sym_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_CARET_EQ] = ACTIONS(2929),
    [anon_sym_LT_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_BANG_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_eq] = ACTIONS(2931),
    [anon_sym_ne] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2929),
    [anon_sym_cmp] = ACTIONS(2931),
    [anon_sym_TILDE_TILDE] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_lt] = ACTIONS(2931),
    [anon_sym_le] = ACTIONS(2931),
    [anon_sym_ge] = ACTIONS(2931),
    [anon_sym_gt] = ACTIONS(2931),
    [anon_sym_isa] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2929),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2927),
    [anon_sym___END__] = ACTIONS(2927),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [955] = {
    [sym_heredoc_content] = STATE(955),
    [sym__identifier] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_sub] = ACTIONS(2919),
    [anon_sym_method] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_my] = ACTIONS(2919),
    [anon_sym_state] = ACTIONS(2919),
    [anon_sym_our] = ACTIONS(2919),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2919),
    [anon_sym_else] = ACTIONS(2919),
    [anon_sym_elsif] = ACTIONS(2919),
    [anon_sym_and] = ACTIONS(2919),
    [anon_sym_or] = ACTIONS(2919),
    [anon_sym_DOLLAR] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_DASH_GT] = ACTIONS(2919),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_PERCENT] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(2919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2919),
    [anon_sym_PLUS_EQ] = ACTIONS(2919),
    [anon_sym_DASH_EQ] = ACTIONS(2919),
    [anon_sym_DOT_EQ] = ACTIONS(2919),
    [anon_sym_STAR_EQ] = ACTIONS(2919),
    [anon_sym_SLASH_EQ] = ACTIONS(2919),
    [anon_sym_PERCENT_EQ] = ACTIONS(2919),
    [anon_sym_x_EQ] = ACTIONS(2919),
    [anon_sym_AMP_EQ] = ACTIONS(2919),
    [anon_sym_PIPE_EQ] = ACTIONS(2919),
    [anon_sym_CARET_EQ] = ACTIONS(2919),
    [anon_sym_LT_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_GT_EQ] = ACTIONS(2919),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2919),
    [anon_sym_DOT_DOT] = ACTIONS(2919),
    [anon_sym_STAR_STAR] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_GT_GT2] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2919),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_x] = ACTIONS(2919),
    [anon_sym_EQ_TILDE] = ACTIONS(2919),
    [anon_sym_BANG_TILDE] = ACTIONS(2919),
    [anon_sym_EQ_EQ] = ACTIONS(2919),
    [anon_sym_BANG_EQ] = ACTIONS(2919),
    [anon_sym_eq] = ACTIONS(2919),
    [anon_sym_ne] = ACTIONS(2919),
    [anon_sym_LT_EQ_GT] = ACTIONS(2919),
    [anon_sym_cmp] = ACTIONS(2919),
    [anon_sym_TILDE_TILDE] = ACTIONS(2919),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2919),
    [anon_sym_lt] = ACTIONS(2919),
    [anon_sym_le] = ACTIONS(2919),
    [anon_sym_ge] = ACTIONS(2919),
    [anon_sym_gt] = ACTIONS(2919),
    [anon_sym_isa] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2919),
    [anon_sym_BANG] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2919),
    [anon_sym_QMARK] = ACTIONS(2919),
    [anon_sym_BSLASH] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_eval] = ACTIONS(2919),
    [anon_sym_field] = ACTIONS(2919),
    [anon_sym_local] = ACTIONS(2919),
    [anon_sym_require] = ACTIONS(2919),
    [anon_sym_map] = ACTIONS(2919),
    [anon_sym_grep] = ACTIONS(2919),
    [anon_sym_sort] = ACTIONS(2919),
    [anon_sym_goto] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_undef] = ACTIONS(2919),
    [anon_sym_PERCENT2] = ACTIONS(2919),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2919),
    [anon_sym_EQ_GT] = ACTIONS(2919),
    [anon_sym_use] = ACTIONS(2919),
    [anon_sym_no] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_foreach] = ACTIONS(2919),
    [anon_sym_last] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2919),
    [anon_sym_redo] = ACTIONS(2919),
    [anon_sym_BEGIN] = ACTIONS(2919),
    [anon_sym_INIT] = ACTIONS(2919),
    [anon_sym_CHECK] = ACTIONS(2919),
    [anon_sym_UNITCHECK] = ACTIONS(2919),
    [anon_sym_END] = ACTIONS(2919),
    [anon_sym_ADJUST] = ACTIONS(2919),
    [anon_sym___FILE__] = ACTIONS(2919),
    [anon_sym___LINE__] = ACTIONS(2919),
    [anon_sym___PACKAGE__] = ACTIONS(2919),
    [anon_sym___SUB__] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_fork] = ACTIONS(2919),
    [anon_sym_getppid] = ACTIONS(2919),
    [anon_sym_time] = ACTIONS(2919),
    [anon_sym_times] = ACTIONS(2919),
    [anon_sym_wait] = ACTIONS(2919),
    [anon_sym_wantarray] = ACTIONS(2919),
    [anon_sym_abs] = ACTIONS(2919),
    [anon_sym_alarm] = ACTIONS(2919),
    [anon_sym_chop] = ACTIONS(2919),
    [anon_sym_chdir] = ACTIONS(2919),
    [anon_sym_close] = ACTIONS(2919),
    [anon_sym_closedir] = ACTIONS(2919),
    [anon_sym_caller] = ACTIONS(2919),
    [anon_sym_chomp] = ACTIONS(2919),
    [anon_sym_chr] = ACTIONS(2919),
    [anon_sym_cos] = ACTIONS(2919),
    [anon_sym_chroot] = ACTIONS(2919),
    [anon_sym_defined] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_dbmclose] = ACTIONS(2919),
    [anon_sym_exists] = ACTIONS(2919),
    [anon_sym_exit] = ACTIONS(2919),
    [anon_sym_eof] = ACTIONS(2919),
    [anon_sym_exp] = ACTIONS(2919),
    [anon_sym_each] = ACTIONS(2919),
    [anon_sym_fc] = ACTIONS(2919),
    [anon_sym_fileno] = ACTIONS(2919),
    [anon_sym_gmtime] = ACTIONS(2919),
    [anon_sym_getc] = ACTIONS(2919),
    [anon_sym_getpgrp] = ACTIONS(2919),
    [anon_sym_getprotobyname] = ACTIONS(2919),
    [anon_sym_getpwname] = ACTIONS(2919),
    [anon_sym_getpwuid] = ACTIONS(2919),
    [anon_sym_getpeername] = ACTIONS(2919),
    [anon_sym_getnetbyname] = ACTIONS(2919),
    [anon_sym_getsockname] = ACTIONS(2919),
    [anon_sym_getgrnam] = ACTIONS(2919),
    [anon_sym_getgrgid] = ACTIONS(2919),
    [anon_sym_hex] = ACTIONS(2919),
    [anon_sym_int] = ACTIONS(2919),
    [anon_sym_keys] = ACTIONS(2919),
    [anon_sym_lc] = ACTIONS(2919),
    [anon_sym_lcfirst] = ACTIONS(2919),
    [anon_sym_length] = ACTIONS(2919),
    [anon_sym_localtime] = ACTIONS(2919),
    [anon_sym_log] = ACTIONS(2919),
    [anon_sym_lock] = ACTIONS(2919),
    [anon_sym_lstat] = ACTIONS(2919),
    [anon_sym_oct] = ACTIONS(2919),
    [anon_sym_ord] = ACTIONS(2919),
    [anon_sym_prototype] = ACTIONS(2919),
    [anon_sym_pop] = ACTIONS(2919),
    [anon_sym_pos] = ACTIONS(2919),
    [anon_sym_quotemeta] = ACTIONS(2919),
    [anon_sym_reset] = ACTIONS(2919),
    [anon_sym_rand] = ACTIONS(2919),
    [anon_sym_rmdir] = ACTIONS(2919),
    [anon_sym_readdir] = ACTIONS(2919),
    [anon_sym_readline] = ACTIONS(2919),
    [anon_sym_readpipe] = ACTIONS(2919),
    [anon_sym_rewinddir] = ACTIONS(2919),
    [anon_sym_readlink] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(2919),
    [anon_sym_scalar] = ACTIONS(2919),
    [anon_sym_shift] = ACTIONS(2919),
    [anon_sym_sin] = ACTIONS(2919),
    [anon_sym_sleep] = ACTIONS(2919),
    [anon_sym_sqrt] = ACTIONS(2919),
    [anon_sym_srand] = ACTIONS(2919),
    [anon_sym_stat] = ACTIONS(2919),
    [anon_sym_study] = ACTIONS(2919),
    [anon_sym_tell] = ACTIONS(2919),
    [anon_sym_telldir] = ACTIONS(2919),
    [anon_sym_tied] = ACTIONS(2919),
    [anon_sym_uc] = ACTIONS(2919),
    [anon_sym_ucfirst] = ACTIONS(2919),
    [anon_sym_untie] = ACTIONS(2919),
    [anon_sym_umask] = ACTIONS(2919),
    [anon_sym_values] = ACTIONS(2919),
    [anon_sym_write] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2919),
    [anon_sym___END__] = ACTIONS(2919),
    [anon_sym_q] = ACTIONS(2919),
    [anon_sym_qq] = ACTIONS(2919),
    [anon_sym_qw] = ACTIONS(2919),
    [anon_sym_qx] = ACTIONS(2919),
    [anon_sym_qr] = ACTIONS(2919),
    [anon_sym_m] = ACTIONS(2919),
    [anon_sym_s] = ACTIONS(2919),
    [anon_sym_tr] = ACTIONS(2919),
    [anon_sym_y] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_unless] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_until] = ACTIONS(2919),
    [aux_sym__bareword_token1] = ACTIONS(2919),
    [sym_number] = ACTIONS(2919),
    [sym__apostrophe] = ACTIONS(2921),
    [sym__double_quote] = ACTIONS(2921),
    [sym__backtick] = ACTIONS(2921),
    [sym__search_slash] = ACTIONS(2921),
    [sym__PERLY_SEMICOLON] = ACTIONS(2921),
    [sym__PERLY_HEREDOC] = ACTIONS(2921),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [956] = {
    [sym_heredoc_content] = STATE(956),
    [sym__identifier] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym_class] = ACTIONS(2909),
    [anon_sym_sub] = ACTIONS(2909),
    [anon_sym_method] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_my] = ACTIONS(2909),
    [anon_sym_state] = ACTIONS(2909),
    [anon_sym_our] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2909),
    [anon_sym_try] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2909),
    [anon_sym_else] = ACTIONS(2909),
    [anon_sym_elsif] = ACTIONS(2909),
    [anon_sym_and] = ACTIONS(2909),
    [anon_sym_or] = ACTIONS(2909),
    [anon_sym_DOLLAR] = ACTIONS(2909),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_AT] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2909),
    [anon_sym_PLUS_EQ] = ACTIONS(2909),
    [anon_sym_DASH_EQ] = ACTIONS(2909),
    [anon_sym_DOT_EQ] = ACTIONS(2909),
    [anon_sym_STAR_EQ] = ACTIONS(2909),
    [anon_sym_SLASH_EQ] = ACTIONS(2909),
    [anon_sym_PERCENT_EQ] = ACTIONS(2909),
    [anon_sym_x_EQ] = ACTIONS(2909),
    [anon_sym_AMP_EQ] = ACTIONS(2909),
    [anon_sym_PIPE_EQ] = ACTIONS(2909),
    [anon_sym_CARET_EQ] = ACTIONS(2909),
    [anon_sym_LT_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_GT_EQ] = ACTIONS(2909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2909),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_GT_GT2] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_x] = ACTIONS(2909),
    [anon_sym_EQ_TILDE] = ACTIONS(2909),
    [anon_sym_BANG_TILDE] = ACTIONS(2909),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2909),
    [anon_sym_eq] = ACTIONS(2909),
    [anon_sym_ne] = ACTIONS(2909),
    [anon_sym_LT_EQ_GT] = ACTIONS(2909),
    [anon_sym_cmp] = ACTIONS(2909),
    [anon_sym_TILDE_TILDE] = ACTIONS(2909),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2909),
    [anon_sym_lt] = ACTIONS(2909),
    [anon_sym_le] = ACTIONS(2909),
    [anon_sym_ge] = ACTIONS(2909),
    [anon_sym_gt] = ACTIONS(2909),
    [anon_sym_isa] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_QMARK] = ACTIONS(2909),
    [anon_sym_BSLASH] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2909),
    [anon_sym_eval] = ACTIONS(2909),
    [anon_sym_field] = ACTIONS(2909),
    [anon_sym_local] = ACTIONS(2909),
    [anon_sym_require] = ACTIONS(2909),
    [anon_sym_map] = ACTIONS(2909),
    [anon_sym_grep] = ACTIONS(2909),
    [anon_sym_sort] = ACTIONS(2909),
    [anon_sym_goto] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_undef] = ACTIONS(2909),
    [anon_sym_PERCENT2] = ACTIONS(2909),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2909),
    [anon_sym_EQ_GT] = ACTIONS(2909),
    [anon_sym_use] = ACTIONS(2909),
    [anon_sym_no] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_foreach] = ACTIONS(2909),
    [anon_sym_last] = ACTIONS(2909),
    [anon_sym_next] = ACTIONS(2909),
    [anon_sym_redo] = ACTIONS(2909),
    [anon_sym_BEGIN] = ACTIONS(2909),
    [anon_sym_INIT] = ACTIONS(2909),
    [anon_sym_CHECK] = ACTIONS(2909),
    [anon_sym_UNITCHECK] = ACTIONS(2909),
    [anon_sym_END] = ACTIONS(2909),
    [anon_sym_ADJUST] = ACTIONS(2909),
    [anon_sym___FILE__] = ACTIONS(2909),
    [anon_sym___LINE__] = ACTIONS(2909),
    [anon_sym___PACKAGE__] = ACTIONS(2909),
    [anon_sym___SUB__] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_fork] = ACTIONS(2909),
    [anon_sym_getppid] = ACTIONS(2909),
    [anon_sym_time] = ACTIONS(2909),
    [anon_sym_times] = ACTIONS(2909),
    [anon_sym_wait] = ACTIONS(2909),
    [anon_sym_wantarray] = ACTIONS(2909),
    [anon_sym_abs] = ACTIONS(2909),
    [anon_sym_alarm] = ACTIONS(2909),
    [anon_sym_chop] = ACTIONS(2909),
    [anon_sym_chdir] = ACTIONS(2909),
    [anon_sym_close] = ACTIONS(2909),
    [anon_sym_closedir] = ACTIONS(2909),
    [anon_sym_caller] = ACTIONS(2909),
    [anon_sym_chomp] = ACTIONS(2909),
    [anon_sym_chr] = ACTIONS(2909),
    [anon_sym_cos] = ACTIONS(2909),
    [anon_sym_chroot] = ACTIONS(2909),
    [anon_sym_defined] = ACTIONS(2909),
    [anon_sym_delete] = ACTIONS(2909),
    [anon_sym_dbmclose] = ACTIONS(2909),
    [anon_sym_exists] = ACTIONS(2909),
    [anon_sym_exit] = ACTIONS(2909),
    [anon_sym_eof] = ACTIONS(2909),
    [anon_sym_exp] = ACTIONS(2909),
    [anon_sym_each] = ACTIONS(2909),
    [anon_sym_fc] = ACTIONS(2909),
    [anon_sym_fileno] = ACTIONS(2909),
    [anon_sym_gmtime] = ACTIONS(2909),
    [anon_sym_getc] = ACTIONS(2909),
    [anon_sym_getpgrp] = ACTIONS(2909),
    [anon_sym_getprotobyname] = ACTIONS(2909),
    [anon_sym_getpwname] = ACTIONS(2909),
    [anon_sym_getpwuid] = ACTIONS(2909),
    [anon_sym_getpeername] = ACTIONS(2909),
    [anon_sym_getnetbyname] = ACTIONS(2909),
    [anon_sym_getsockname] = ACTIONS(2909),
    [anon_sym_getgrnam] = ACTIONS(2909),
    [anon_sym_getgrgid] = ACTIONS(2909),
    [anon_sym_hex] = ACTIONS(2909),
    [anon_sym_int] = ACTIONS(2909),
    [anon_sym_keys] = ACTIONS(2909),
    [anon_sym_lc] = ACTIONS(2909),
    [anon_sym_lcfirst] = ACTIONS(2909),
    [anon_sym_length] = ACTIONS(2909),
    [anon_sym_localtime] = ACTIONS(2909),
    [anon_sym_log] = ACTIONS(2909),
    [anon_sym_lock] = ACTIONS(2909),
    [anon_sym_lstat] = ACTIONS(2909),
    [anon_sym_oct] = ACTIONS(2909),
    [anon_sym_ord] = ACTIONS(2909),
    [anon_sym_prototype] = ACTIONS(2909),
    [anon_sym_pop] = ACTIONS(2909),
    [anon_sym_pos] = ACTIONS(2909),
    [anon_sym_quotemeta] = ACTIONS(2909),
    [anon_sym_reset] = ACTIONS(2909),
    [anon_sym_rand] = ACTIONS(2909),
    [anon_sym_rmdir] = ACTIONS(2909),
    [anon_sym_readdir] = ACTIONS(2909),
    [anon_sym_readline] = ACTIONS(2909),
    [anon_sym_readpipe] = ACTIONS(2909),
    [anon_sym_rewinddir] = ACTIONS(2909),
    [anon_sym_readlink] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(2909),
    [anon_sym_scalar] = ACTIONS(2909),
    [anon_sym_shift] = ACTIONS(2909),
    [anon_sym_sin] = ACTIONS(2909),
    [anon_sym_sleep] = ACTIONS(2909),
    [anon_sym_sqrt] = ACTIONS(2909),
    [anon_sym_srand] = ACTIONS(2909),
    [anon_sym_stat] = ACTIONS(2909),
    [anon_sym_study] = ACTIONS(2909),
    [anon_sym_tell] = ACTIONS(2909),
    [anon_sym_telldir] = ACTIONS(2909),
    [anon_sym_tied] = ACTIONS(2909),
    [anon_sym_uc] = ACTIONS(2909),
    [anon_sym_ucfirst] = ACTIONS(2909),
    [anon_sym_untie] = ACTIONS(2909),
    [anon_sym_umask] = ACTIONS(2909),
    [anon_sym_values] = ACTIONS(2909),
    [anon_sym_write] = ACTIONS(2909),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2909),
    [anon_sym___END__] = ACTIONS(2909),
    [anon_sym_q] = ACTIONS(2909),
    [anon_sym_qq] = ACTIONS(2909),
    [anon_sym_qw] = ACTIONS(2909),
    [anon_sym_qx] = ACTIONS(2909),
    [anon_sym_qr] = ACTIONS(2909),
    [anon_sym_m] = ACTIONS(2909),
    [anon_sym_s] = ACTIONS(2909),
    [anon_sym_tr] = ACTIONS(2909),
    [anon_sym_y] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_unless] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_until] = ACTIONS(2909),
    [aux_sym__bareword_token1] = ACTIONS(2909),
    [sym_number] = ACTIONS(2909),
    [sym__apostrophe] = ACTIONS(2911),
    [sym__double_quote] = ACTIONS(2911),
    [sym__backtick] = ACTIONS(2911),
    [sym__search_slash] = ACTIONS(2911),
    [sym__PERLY_SEMICOLON] = ACTIONS(2911),
    [sym__PERLY_HEREDOC] = ACTIONS(2911),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [957] = {
    [sym_heredoc_content] = STATE(957),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_DASH_GT] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2897),
    [anon_sym_PLUS_EQ] = ACTIONS(2897),
    [anon_sym_DASH_EQ] = ACTIONS(2897),
    [anon_sym_DOT_EQ] = ACTIONS(2897),
    [anon_sym_STAR_EQ] = ACTIONS(2897),
    [anon_sym_SLASH_EQ] = ACTIONS(2897),
    [anon_sym_PERCENT_EQ] = ACTIONS(2897),
    [anon_sym_x_EQ] = ACTIONS(2897),
    [anon_sym_AMP_EQ] = ACTIONS(2897),
    [anon_sym_PIPE_EQ] = ACTIONS(2897),
    [anon_sym_CARET_EQ] = ACTIONS(2897),
    [anon_sym_LT_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_GT_EQ] = ACTIONS(2897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_GT_GT2] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_x] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2897),
    [anon_sym_BANG_TILDE] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_LT_EQ_GT] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_TILDE_TILDE] = ACTIONS(2897),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_QMARK] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_EQ_GT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_SEMICOLON] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [958] = {
    [sym_heredoc_content] = STATE(958),
    [sym__identifier] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_sub] = ACTIONS(2913),
    [anon_sym_method] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_my] = ACTIONS(2913),
    [anon_sym_state] = ACTIONS(2913),
    [anon_sym_our] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_else] = ACTIONS(2913),
    [anon_sym_elsif] = ACTIONS(2913),
    [anon_sym_and] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_EQ] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_x_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_BANG_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_eq] = ACTIONS(2913),
    [anon_sym_ne] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_cmp] = ACTIONS(2913),
    [anon_sym_TILDE_TILDE] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_lt] = ACTIONS(2913),
    [anon_sym_le] = ACTIONS(2913),
    [anon_sym_ge] = ACTIONS(2913),
    [anon_sym_gt] = ACTIONS(2913),
    [anon_sym_isa] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_BSLASH] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_eval] = ACTIONS(2913),
    [anon_sym_field] = ACTIONS(2913),
    [anon_sym_local] = ACTIONS(2913),
    [anon_sym_require] = ACTIONS(2913),
    [anon_sym_map] = ACTIONS(2913),
    [anon_sym_grep] = ACTIONS(2913),
    [anon_sym_sort] = ACTIONS(2913),
    [anon_sym_goto] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_undef] = ACTIONS(2913),
    [anon_sym_PERCENT2] = ACTIONS(2913),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2913),
    [anon_sym_EQ_GT] = ACTIONS(2913),
    [anon_sym_use] = ACTIONS(2913),
    [anon_sym_no] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_foreach] = ACTIONS(2913),
    [anon_sym_last] = ACTIONS(2913),
    [anon_sym_next] = ACTIONS(2913),
    [anon_sym_redo] = ACTIONS(2913),
    [anon_sym_BEGIN] = ACTIONS(2913),
    [anon_sym_INIT] = ACTIONS(2913),
    [anon_sym_CHECK] = ACTIONS(2913),
    [anon_sym_UNITCHECK] = ACTIONS(2913),
    [anon_sym_END] = ACTIONS(2913),
    [anon_sym_ADJUST] = ACTIONS(2913),
    [anon_sym___FILE__] = ACTIONS(2913),
    [anon_sym___LINE__] = ACTIONS(2913),
    [anon_sym___PACKAGE__] = ACTIONS(2913),
    [anon_sym___SUB__] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_fork] = ACTIONS(2913),
    [anon_sym_getppid] = ACTIONS(2913),
    [anon_sym_time] = ACTIONS(2913),
    [anon_sym_times] = ACTIONS(2913),
    [anon_sym_wait] = ACTIONS(2913),
    [anon_sym_wantarray] = ACTIONS(2913),
    [anon_sym_abs] = ACTIONS(2913),
    [anon_sym_alarm] = ACTIONS(2913),
    [anon_sym_chop] = ACTIONS(2913),
    [anon_sym_chdir] = ACTIONS(2913),
    [anon_sym_close] = ACTIONS(2913),
    [anon_sym_closedir] = ACTIONS(2913),
    [anon_sym_caller] = ACTIONS(2913),
    [anon_sym_chomp] = ACTIONS(2913),
    [anon_sym_chr] = ACTIONS(2913),
    [anon_sym_cos] = ACTIONS(2913),
    [anon_sym_chroot] = ACTIONS(2913),
    [anon_sym_defined] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_dbmclose] = ACTIONS(2913),
    [anon_sym_exists] = ACTIONS(2913),
    [anon_sym_exit] = ACTIONS(2913),
    [anon_sym_eof] = ACTIONS(2913),
    [anon_sym_exp] = ACTIONS(2913),
    [anon_sym_each] = ACTIONS(2913),
    [anon_sym_fc] = ACTIONS(2913),
    [anon_sym_fileno] = ACTIONS(2913),
    [anon_sym_gmtime] = ACTIONS(2913),
    [anon_sym_getc] = ACTIONS(2913),
    [anon_sym_getpgrp] = ACTIONS(2913),
    [anon_sym_getprotobyname] = ACTIONS(2913),
    [anon_sym_getpwname] = ACTIONS(2913),
    [anon_sym_getpwuid] = ACTIONS(2913),
    [anon_sym_getpeername] = ACTIONS(2913),
    [anon_sym_getnetbyname] = ACTIONS(2913),
    [anon_sym_getsockname] = ACTIONS(2913),
    [anon_sym_getgrnam] = ACTIONS(2913),
    [anon_sym_getgrgid] = ACTIONS(2913),
    [anon_sym_hex] = ACTIONS(2913),
    [anon_sym_int] = ACTIONS(2913),
    [anon_sym_keys] = ACTIONS(2913),
    [anon_sym_lc] = ACTIONS(2913),
    [anon_sym_lcfirst] = ACTIONS(2913),
    [anon_sym_length] = ACTIONS(2913),
    [anon_sym_localtime] = ACTIONS(2913),
    [anon_sym_log] = ACTIONS(2913),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_lstat] = ACTIONS(2913),
    [anon_sym_oct] = ACTIONS(2913),
    [anon_sym_ord] = ACTIONS(2913),
    [anon_sym_prototype] = ACTIONS(2913),
    [anon_sym_pop] = ACTIONS(2913),
    [anon_sym_pos] = ACTIONS(2913),
    [anon_sym_quotemeta] = ACTIONS(2913),
    [anon_sym_reset] = ACTIONS(2913),
    [anon_sym_rand] = ACTIONS(2913),
    [anon_sym_rmdir] = ACTIONS(2913),
    [anon_sym_readdir] = ACTIONS(2913),
    [anon_sym_readline] = ACTIONS(2913),
    [anon_sym_readpipe] = ACTIONS(2913),
    [anon_sym_rewinddir] = ACTIONS(2913),
    [anon_sym_readlink] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(2913),
    [anon_sym_scalar] = ACTIONS(2913),
    [anon_sym_shift] = ACTIONS(2913),
    [anon_sym_sin] = ACTIONS(2913),
    [anon_sym_sleep] = ACTIONS(2913),
    [anon_sym_sqrt] = ACTIONS(2913),
    [anon_sym_srand] = ACTIONS(2913),
    [anon_sym_stat] = ACTIONS(2913),
    [anon_sym_study] = ACTIONS(2913),
    [anon_sym_tell] = ACTIONS(2913),
    [anon_sym_telldir] = ACTIONS(2913),
    [anon_sym_tied] = ACTIONS(2913),
    [anon_sym_uc] = ACTIONS(2913),
    [anon_sym_ucfirst] = ACTIONS(2913),
    [anon_sym_untie] = ACTIONS(2913),
    [anon_sym_umask] = ACTIONS(2913),
    [anon_sym_values] = ACTIONS(2913),
    [anon_sym_write] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2913),
    [anon_sym___END__] = ACTIONS(2913),
    [anon_sym_q] = ACTIONS(2913),
    [anon_sym_qq] = ACTIONS(2913),
    [anon_sym_qw] = ACTIONS(2913),
    [anon_sym_qx] = ACTIONS(2913),
    [anon_sym_qr] = ACTIONS(2913),
    [anon_sym_m] = ACTIONS(2913),
    [anon_sym_s] = ACTIONS(2913),
    [anon_sym_tr] = ACTIONS(2913),
    [anon_sym_y] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_unless] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_until] = ACTIONS(2913),
    [aux_sym__bareword_token1] = ACTIONS(2913),
    [sym_number] = ACTIONS(2913),
    [sym__apostrophe] = ACTIONS(2917),
    [sym__double_quote] = ACTIONS(2917),
    [sym__backtick] = ACTIONS(2917),
    [sym__search_slash] = ACTIONS(2917),
    [sym__PERLY_SEMICOLON] = ACTIONS(2917),
    [sym__PERLY_HEREDOC] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [959] = {
    [sym__else] = STATE(1018),
    [sym_else] = STATE(1019),
    [sym_elsif] = STATE(1019),
    [sym_heredoc_content] = STATE(959),
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym__identifier] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LBRACE2] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_package] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_sub] = ACTIONS(2950),
    [anon_sym_method] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_my] = ACTIONS(2950),
    [anon_sym_state] = ACTIONS(2950),
    [anon_sym_our] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_defer] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2952),
    [anon_sym_elsif] = ACTIONS(2955),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_AT] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_SLASH_SLASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_eq] = ACTIONS(2950),
    [anon_sym_ne] = ACTIONS(2950),
    [anon_sym_cmp] = ACTIONS(2950),
    [anon_sym_lt] = ACTIONS(2950),
    [anon_sym_le] = ACTIONS(2950),
    [anon_sym_ge] = ACTIONS(2950),
    [anon_sym_gt] = ACTIONS(2950),
    [anon_sym_isa] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2950),
    [anon_sym_BSLASH] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_eval] = ACTIONS(2950),
    [anon_sym_field] = ACTIONS(2950),
    [anon_sym_local] = ACTIONS(2950),
    [anon_sym_require] = ACTIONS(2950),
    [anon_sym_map] = ACTIONS(2950),
    [anon_sym_grep] = ACTIONS(2950),
    [anon_sym_sort] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_undef] = ACTIONS(2950),
    [anon_sym_PERCENT2] = ACTIONS(2950),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2950),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_no] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_foreach] = ACTIONS(2950),
    [anon_sym_last] = ACTIONS(2950),
    [anon_sym_next] = ACTIONS(2950),
    [anon_sym_redo] = ACTIONS(2950),
    [anon_sym_BEGIN] = ACTIONS(2950),
    [anon_sym_INIT] = ACTIONS(2950),
    [anon_sym_CHECK] = ACTIONS(2950),
    [anon_sym_UNITCHECK] = ACTIONS(2950),
    [anon_sym_END] = ACTIONS(2950),
    [anon_sym_ADJUST] = ACTIONS(2950),
    [anon_sym___FILE__] = ACTIONS(2950),
    [anon_sym___LINE__] = ACTIONS(2950),
    [anon_sym___PACKAGE__] = ACTIONS(2950),
    [anon_sym___SUB__] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_fork] = ACTIONS(2950),
    [anon_sym_getppid] = ACTIONS(2950),
    [anon_sym_time] = ACTIONS(2950),
    [anon_sym_times] = ACTIONS(2950),
    [anon_sym_wait] = ACTIONS(2950),
    [anon_sym_wantarray] = ACTIONS(2950),
    [anon_sym_abs] = ACTIONS(2950),
    [anon_sym_alarm] = ACTIONS(2950),
    [anon_sym_chop] = ACTIONS(2950),
    [anon_sym_chdir] = ACTIONS(2950),
    [anon_sym_close] = ACTIONS(2950),
    [anon_sym_closedir] = ACTIONS(2950),
    [anon_sym_caller] = ACTIONS(2950),
    [anon_sym_chomp] = ACTIONS(2950),
    [anon_sym_chr] = ACTIONS(2950),
    [anon_sym_cos] = ACTIONS(2950),
    [anon_sym_chroot] = ACTIONS(2950),
    [anon_sym_defined] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_dbmclose] = ACTIONS(2950),
    [anon_sym_exists] = ACTIONS(2950),
    [anon_sym_exit] = ACTIONS(2950),
    [anon_sym_eof] = ACTIONS(2950),
    [anon_sym_exp] = ACTIONS(2950),
    [anon_sym_each] = ACTIONS(2950),
    [anon_sym_fc] = ACTIONS(2950),
    [anon_sym_fileno] = ACTIONS(2950),
    [anon_sym_gmtime] = ACTIONS(2950),
    [anon_sym_getc] = ACTIONS(2950),
    [anon_sym_getpgrp] = ACTIONS(2950),
    [anon_sym_getprotobyname] = ACTIONS(2950),
    [anon_sym_getpwname] = ACTIONS(2950),
    [anon_sym_getpwuid] = ACTIONS(2950),
    [anon_sym_getpeername] = ACTIONS(2950),
    [anon_sym_getnetbyname] = ACTIONS(2950),
    [anon_sym_getsockname] = ACTIONS(2950),
    [anon_sym_getgrnam] = ACTIONS(2950),
    [anon_sym_getgrgid] = ACTIONS(2950),
    [anon_sym_hex] = ACTIONS(2950),
    [anon_sym_int] = ACTIONS(2950),
    [anon_sym_keys] = ACTIONS(2950),
    [anon_sym_lc] = ACTIONS(2950),
    [anon_sym_lcfirst] = ACTIONS(2950),
    [anon_sym_length] = ACTIONS(2950),
    [anon_sym_localtime] = ACTIONS(2950),
    [anon_sym_log] = ACTIONS(2950),
    [anon_sym_lock] = ACTIONS(2950),
    [anon_sym_lstat] = ACTIONS(2950),
    [anon_sym_oct] = ACTIONS(2950),
    [anon_sym_ord] = ACTIONS(2950),
    [anon_sym_prototype] = ACTIONS(2950),
    [anon_sym_pop] = ACTIONS(2950),
    [anon_sym_pos] = ACTIONS(2950),
    [anon_sym_quotemeta] = ACTIONS(2950),
    [anon_sym_reset] = ACTIONS(2950),
    [anon_sym_rand] = ACTIONS(2950),
    [anon_sym_rmdir] = ACTIONS(2950),
    [anon_sym_readdir] = ACTIONS(2950),
    [anon_sym_readline] = ACTIONS(2950),
    [anon_sym_readpipe] = ACTIONS(2950),
    [anon_sym_rewinddir] = ACTIONS(2950),
    [anon_sym_readlink] = ACTIONS(2950),
    [anon_sym_ref] = ACTIONS(2950),
    [anon_sym_scalar] = ACTIONS(2950),
    [anon_sym_shift] = ACTIONS(2950),
    [anon_sym_sin] = ACTIONS(2950),
    [anon_sym_sleep] = ACTIONS(2950),
    [anon_sym_sqrt] = ACTIONS(2950),
    [anon_sym_srand] = ACTIONS(2950),
    [anon_sym_stat] = ACTIONS(2950),
    [anon_sym_study] = ACTIONS(2950),
    [anon_sym_tell] = ACTIONS(2950),
    [anon_sym_telldir] = ACTIONS(2950),
    [anon_sym_tied] = ACTIONS(2950),
    [anon_sym_uc] = ACTIONS(2950),
    [anon_sym_ucfirst] = ACTIONS(2950),
    [anon_sym_untie] = ACTIONS(2950),
    [anon_sym_umask] = ACTIONS(2950),
    [anon_sym_values] = ACTIONS(2950),
    [anon_sym_write] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2950),
    [anon_sym___END__] = ACTIONS(2950),
    [anon_sym_EOT] = ACTIONS(2950),
    [anon_sym_q] = ACTIONS(2950),
    [anon_sym_qq] = ACTIONS(2950),
    [anon_sym_qw] = ACTIONS(2950),
    [anon_sym_qx] = ACTIONS(2950),
    [anon_sym_qr] = ACTIONS(2950),
    [anon_sym_m] = ACTIONS(2950),
    [anon_sym_s] = ACTIONS(2950),
    [anon_sym_tr] = ACTIONS(2950),
    [anon_sym_y] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [aux_sym__bareword_token1] = ACTIONS(2950),
    [sym_number] = ACTIONS(2950),
    [sym__apostrophe] = ACTIONS(2948),
    [sym__double_quote] = ACTIONS(2948),
    [sym__backtick] = ACTIONS(2948),
    [sym__search_slash] = ACTIONS(2948),
    [sym__PERLY_HEREDOC] = ACTIONS(2948),
    [sym__ctrl_z_hack] = ACTIONS(2948),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [960] = {
    [sym__else] = STATE(983),
    [sym_else] = STATE(1019),
    [sym_elsif] = STATE(1019),
    [sym_heredoc_content] = STATE(960),
    [ts_builtin_sym_end] = ACTIONS(2958),
    [sym__identifier] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_LBRACE2] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_package] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_sub] = ACTIONS(2960),
    [anon_sym_method] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_my] = ACTIONS(2960),
    [anon_sym_state] = ACTIONS(2960),
    [anon_sym_our] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_defer] = ACTIONS(2960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_elsif] = ACTIONS(2965),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_AT] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_LT_LT] = ACTIONS(2960),
    [anon_sym_SLASH_SLASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_eq] = ACTIONS(2960),
    [anon_sym_ne] = ACTIONS(2960),
    [anon_sym_cmp] = ACTIONS(2960),
    [anon_sym_lt] = ACTIONS(2960),
    [anon_sym_le] = ACTIONS(2960),
    [anon_sym_ge] = ACTIONS(2960),
    [anon_sym_gt] = ACTIONS(2960),
    [anon_sym_isa] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_BSLASH] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_eval] = ACTIONS(2960),
    [anon_sym_field] = ACTIONS(2960),
    [anon_sym_local] = ACTIONS(2960),
    [anon_sym_require] = ACTIONS(2960),
    [anon_sym_map] = ACTIONS(2960),
    [anon_sym_grep] = ACTIONS(2960),
    [anon_sym_sort] = ACTIONS(2960),
    [anon_sym_goto] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_undef] = ACTIONS(2960),
    [anon_sym_PERCENT2] = ACTIONS(2960),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2960),
    [anon_sym_no] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_foreach] = ACTIONS(2960),
    [anon_sym_last] = ACTIONS(2960),
    [anon_sym_next] = ACTIONS(2960),
    [anon_sym_redo] = ACTIONS(2960),
    [anon_sym_BEGIN] = ACTIONS(2960),
    [anon_sym_INIT] = ACTIONS(2960),
    [anon_sym_CHECK] = ACTIONS(2960),
    [anon_sym_UNITCHECK] = ACTIONS(2960),
    [anon_sym_END] = ACTIONS(2960),
    [anon_sym_ADJUST] = ACTIONS(2960),
    [anon_sym___FILE__] = ACTIONS(2960),
    [anon_sym___LINE__] = ACTIONS(2960),
    [anon_sym___PACKAGE__] = ACTIONS(2960),
    [anon_sym___SUB__] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_fork] = ACTIONS(2960),
    [anon_sym_getppid] = ACTIONS(2960),
    [anon_sym_time] = ACTIONS(2960),
    [anon_sym_times] = ACTIONS(2960),
    [anon_sym_wait] = ACTIONS(2960),
    [anon_sym_wantarray] = ACTIONS(2960),
    [anon_sym_abs] = ACTIONS(2960),
    [anon_sym_alarm] = ACTIONS(2960),
    [anon_sym_chop] = ACTIONS(2960),
    [anon_sym_chdir] = ACTIONS(2960),
    [anon_sym_close] = ACTIONS(2960),
    [anon_sym_closedir] = ACTIONS(2960),
    [anon_sym_caller] = ACTIONS(2960),
    [anon_sym_chomp] = ACTIONS(2960),
    [anon_sym_chr] = ACTIONS(2960),
    [anon_sym_cos] = ACTIONS(2960),
    [anon_sym_chroot] = ACTIONS(2960),
    [anon_sym_defined] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_dbmclose] = ACTIONS(2960),
    [anon_sym_exists] = ACTIONS(2960),
    [anon_sym_exit] = ACTIONS(2960),
    [anon_sym_eof] = ACTIONS(2960),
    [anon_sym_exp] = ACTIONS(2960),
    [anon_sym_each] = ACTIONS(2960),
    [anon_sym_fc] = ACTIONS(2960),
    [anon_sym_fileno] = ACTIONS(2960),
    [anon_sym_gmtime] = ACTIONS(2960),
    [anon_sym_getc] = ACTIONS(2960),
    [anon_sym_getpgrp] = ACTIONS(2960),
    [anon_sym_getprotobyname] = ACTIONS(2960),
    [anon_sym_getpwname] = ACTIONS(2960),
    [anon_sym_getpwuid] = ACTIONS(2960),
    [anon_sym_getpeername] = ACTIONS(2960),
    [anon_sym_getnetbyname] = ACTIONS(2960),
    [anon_sym_getsockname] = ACTIONS(2960),
    [anon_sym_getgrnam] = ACTIONS(2960),
    [anon_sym_getgrgid] = ACTIONS(2960),
    [anon_sym_hex] = ACTIONS(2960),
    [anon_sym_int] = ACTIONS(2960),
    [anon_sym_keys] = ACTIONS(2960),
    [anon_sym_lc] = ACTIONS(2960),
    [anon_sym_lcfirst] = ACTIONS(2960),
    [anon_sym_length] = ACTIONS(2960),
    [anon_sym_localtime] = ACTIONS(2960),
    [anon_sym_log] = ACTIONS(2960),
    [anon_sym_lock] = ACTIONS(2960),
    [anon_sym_lstat] = ACTIONS(2960),
    [anon_sym_oct] = ACTIONS(2960),
    [anon_sym_ord] = ACTIONS(2960),
    [anon_sym_prototype] = ACTIONS(2960),
    [anon_sym_pop] = ACTIONS(2960),
    [anon_sym_pos] = ACTIONS(2960),
    [anon_sym_quotemeta] = ACTIONS(2960),
    [anon_sym_reset] = ACTIONS(2960),
    [anon_sym_rand] = ACTIONS(2960),
    [anon_sym_rmdir] = ACTIONS(2960),
    [anon_sym_readdir] = ACTIONS(2960),
    [anon_sym_readline] = ACTIONS(2960),
    [anon_sym_readpipe] = ACTIONS(2960),
    [anon_sym_rewinddir] = ACTIONS(2960),
    [anon_sym_readlink] = ACTIONS(2960),
    [anon_sym_ref] = ACTIONS(2960),
    [anon_sym_scalar] = ACTIONS(2960),
    [anon_sym_shift] = ACTIONS(2960),
    [anon_sym_sin] = ACTIONS(2960),
    [anon_sym_sleep] = ACTIONS(2960),
    [anon_sym_sqrt] = ACTIONS(2960),
    [anon_sym_srand] = ACTIONS(2960),
    [anon_sym_stat] = ACTIONS(2960),
    [anon_sym_study] = ACTIONS(2960),
    [anon_sym_tell] = ACTIONS(2960),
    [anon_sym_telldir] = ACTIONS(2960),
    [anon_sym_tied] = ACTIONS(2960),
    [anon_sym_uc] = ACTIONS(2960),
    [anon_sym_ucfirst] = ACTIONS(2960),
    [anon_sym_untie] = ACTIONS(2960),
    [anon_sym_umask] = ACTIONS(2960),
    [anon_sym_values] = ACTIONS(2960),
    [anon_sym_write] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2960),
    [anon_sym___END__] = ACTIONS(2960),
    [anon_sym_EOT] = ACTIONS(2960),
    [anon_sym_q] = ACTIONS(2960),
    [anon_sym_qq] = ACTIONS(2960),
    [anon_sym_qw] = ACTIONS(2960),
    [anon_sym_qx] = ACTIONS(2960),
    [anon_sym_qr] = ACTIONS(2960),
    [anon_sym_m] = ACTIONS(2960),
    [anon_sym_s] = ACTIONS(2960),
    [anon_sym_tr] = ACTIONS(2960),
    [anon_sym_y] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [aux_sym__bareword_token1] = ACTIONS(2960),
    [sym_number] = ACTIONS(2960),
    [sym__apostrophe] = ACTIONS(2958),
    [sym__double_quote] = ACTIONS(2958),
    [sym__backtick] = ACTIONS(2958),
    [sym__search_slash] = ACTIONS(2958),
    [sym__PERLY_HEREDOC] = ACTIONS(2958),
    [sym__ctrl_z_hack] = ACTIONS(2958),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [961] = {
    [sym_heredoc_content] = STATE(961),
    [ts_builtin_sym_end] = ACTIONS(2968),
    [sym__identifier] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LBRACE2] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym_package] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_sub] = ACTIONS(2970),
    [anon_sym_method] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_my] = ACTIONS(2970),
    [anon_sym_state] = ACTIONS(2970),
    [anon_sym_our] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_catch] = ACTIONS(2972),
    [anon_sym_finally] = ACTIONS(2974),
    [anon_sym_defer] = ACTIONS(2970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_elsif] = ACTIONS(2970),
    [anon_sym_and] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_AT] = ACTIONS(2970),
    [anon_sym_LT] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2970),
    [anon_sym_SLASH_SLASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_eq] = ACTIONS(2970),
    [anon_sym_ne] = ACTIONS(2970),
    [anon_sym_cmp] = ACTIONS(2970),
    [anon_sym_lt] = ACTIONS(2970),
    [anon_sym_le] = ACTIONS(2970),
    [anon_sym_ge] = ACTIONS(2970),
    [anon_sym_gt] = ACTIONS(2970),
    [anon_sym_isa] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_BSLASH] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_eval] = ACTIONS(2970),
    [anon_sym_field] = ACTIONS(2970),
    [anon_sym_local] = ACTIONS(2970),
    [anon_sym_require] = ACTIONS(2970),
    [anon_sym_map] = ACTIONS(2970),
    [anon_sym_grep] = ACTIONS(2970),
    [anon_sym_sort] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_undef] = ACTIONS(2970),
    [anon_sym_PERCENT2] = ACTIONS(2970),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2970),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_no] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_foreach] = ACTIONS(2970),
    [anon_sym_last] = ACTIONS(2970),
    [anon_sym_next] = ACTIONS(2970),
    [anon_sym_redo] = ACTIONS(2970),
    [anon_sym_BEGIN] = ACTIONS(2970),
    [anon_sym_INIT] = ACTIONS(2970),
    [anon_sym_CHECK] = ACTIONS(2970),
    [anon_sym_UNITCHECK] = ACTIONS(2970),
    [anon_sym_END] = ACTIONS(2970),
    [anon_sym_ADJUST] = ACTIONS(2970),
    [anon_sym___FILE__] = ACTIONS(2970),
    [anon_sym___LINE__] = ACTIONS(2970),
    [anon_sym___PACKAGE__] = ACTIONS(2970),
    [anon_sym___SUB__] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_fork] = ACTIONS(2970),
    [anon_sym_getppid] = ACTIONS(2970),
    [anon_sym_time] = ACTIONS(2970),
    [anon_sym_times] = ACTIONS(2970),
    [anon_sym_wait] = ACTIONS(2970),
    [anon_sym_wantarray] = ACTIONS(2970),
    [anon_sym_abs] = ACTIONS(2970),
    [anon_sym_alarm] = ACTIONS(2970),
    [anon_sym_chop] = ACTIONS(2970),
    [anon_sym_chdir] = ACTIONS(2970),
    [anon_sym_close] = ACTIONS(2970),
    [anon_sym_closedir] = ACTIONS(2970),
    [anon_sym_caller] = ACTIONS(2970),
    [anon_sym_chomp] = ACTIONS(2970),
    [anon_sym_chr] = ACTIONS(2970),
    [anon_sym_cos] = ACTIONS(2970),
    [anon_sym_chroot] = ACTIONS(2970),
    [anon_sym_defined] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_dbmclose] = ACTIONS(2970),
    [anon_sym_exists] = ACTIONS(2970),
    [anon_sym_exit] = ACTIONS(2970),
    [anon_sym_eof] = ACTIONS(2970),
    [anon_sym_exp] = ACTIONS(2970),
    [anon_sym_each] = ACTIONS(2970),
    [anon_sym_fc] = ACTIONS(2970),
    [anon_sym_fileno] = ACTIONS(2970),
    [anon_sym_gmtime] = ACTIONS(2970),
    [anon_sym_getc] = ACTIONS(2970),
    [anon_sym_getpgrp] = ACTIONS(2970),
    [anon_sym_getprotobyname] = ACTIONS(2970),
    [anon_sym_getpwname] = ACTIONS(2970),
    [anon_sym_getpwuid] = ACTIONS(2970),
    [anon_sym_getpeername] = ACTIONS(2970),
    [anon_sym_getnetbyname] = ACTIONS(2970),
    [anon_sym_getsockname] = ACTIONS(2970),
    [anon_sym_getgrnam] = ACTIONS(2970),
    [anon_sym_getgrgid] = ACTIONS(2970),
    [anon_sym_hex] = ACTIONS(2970),
    [anon_sym_int] = ACTIONS(2970),
    [anon_sym_keys] = ACTIONS(2970),
    [anon_sym_lc] = ACTIONS(2970),
    [anon_sym_lcfirst] = ACTIONS(2970),
    [anon_sym_length] = ACTIONS(2970),
    [anon_sym_localtime] = ACTIONS(2970),
    [anon_sym_log] = ACTIONS(2970),
    [anon_sym_lock] = ACTIONS(2970),
    [anon_sym_lstat] = ACTIONS(2970),
    [anon_sym_oct] = ACTIONS(2970),
    [anon_sym_ord] = ACTIONS(2970),
    [anon_sym_prototype] = ACTIONS(2970),
    [anon_sym_pop] = ACTIONS(2970),
    [anon_sym_pos] = ACTIONS(2970),
    [anon_sym_quotemeta] = ACTIONS(2970),
    [anon_sym_reset] = ACTIONS(2970),
    [anon_sym_rand] = ACTIONS(2970),
    [anon_sym_rmdir] = ACTIONS(2970),
    [anon_sym_readdir] = ACTIONS(2970),
    [anon_sym_readline] = ACTIONS(2970),
    [anon_sym_readpipe] = ACTIONS(2970),
    [anon_sym_rewinddir] = ACTIONS(2970),
    [anon_sym_readlink] = ACTIONS(2970),
    [anon_sym_ref] = ACTIONS(2970),
    [anon_sym_scalar] = ACTIONS(2970),
    [anon_sym_shift] = ACTIONS(2970),
    [anon_sym_sin] = ACTIONS(2970),
    [anon_sym_sleep] = ACTIONS(2970),
    [anon_sym_sqrt] = ACTIONS(2970),
    [anon_sym_srand] = ACTIONS(2970),
    [anon_sym_stat] = ACTIONS(2970),
    [anon_sym_study] = ACTIONS(2970),
    [anon_sym_tell] = ACTIONS(2970),
    [anon_sym_telldir] = ACTIONS(2970),
    [anon_sym_tied] = ACTIONS(2970),
    [anon_sym_uc] = ACTIONS(2970),
    [anon_sym_ucfirst] = ACTIONS(2970),
    [anon_sym_untie] = ACTIONS(2970),
    [anon_sym_umask] = ACTIONS(2970),
    [anon_sym_values] = ACTIONS(2970),
    [anon_sym_write] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2970),
    [anon_sym___END__] = ACTIONS(2970),
    [anon_sym_EOT] = ACTIONS(2970),
    [anon_sym_q] = ACTIONS(2970),
    [anon_sym_qq] = ACTIONS(2970),
    [anon_sym_qw] = ACTIONS(2970),
    [anon_sym_qx] = ACTIONS(2970),
    [anon_sym_qr] = ACTIONS(2970),
    [anon_sym_m] = ACTIONS(2970),
    [anon_sym_s] = ACTIONS(2970),
    [anon_sym_tr] = ACTIONS(2970),
    [anon_sym_y] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_unless] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_until] = ACTIONS(2970),
    [aux_sym__bareword_token1] = ACTIONS(2970),
    [sym_number] = ACTIONS(2970),
    [sym__apostrophe] = ACTIONS(2968),
    [sym__double_quote] = ACTIONS(2968),
    [sym__backtick] = ACTIONS(2968),
    [sym__search_slash] = ACTIONS(2968),
    [sym__PERLY_HEREDOC] = ACTIONS(2968),
    [sym__ctrl_z_hack] = ACTIONS(2968),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [962] = {
    [sym_heredoc_content] = STATE(962),
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_LBRACE2] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_package] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_catch] = ACTIONS(2897),
    [anon_sym_finally] = ACTIONS(2897),
    [anon_sym_defer] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_EOT] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym__ctrl_z_hack] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [963] = {
    [sym_heredoc_content] = STATE(963),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_LBRACE2] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_package] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_catch] = ACTIONS(2905),
    [anon_sym_finally] = ACTIONS(2905),
    [anon_sym_defer] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_EOT] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym__ctrl_z_hack] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [964] = {
    [sym_heredoc_content] = STATE(964),
    [ts_builtin_sym_end] = ACTIONS(2976),
    [sym__identifier] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LBRACE2] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym_package] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_sub] = ACTIONS(2978),
    [anon_sym_method] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_my] = ACTIONS(2978),
    [anon_sym_state] = ACTIONS(2978),
    [anon_sym_our] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_finally] = ACTIONS(2980),
    [anon_sym_defer] = ACTIONS(2978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_elsif] = ACTIONS(2978),
    [anon_sym_and] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_AT] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2978),
    [anon_sym_LT_LT] = ACTIONS(2978),
    [anon_sym_SLASH_SLASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_eq] = ACTIONS(2978),
    [anon_sym_ne] = ACTIONS(2978),
    [anon_sym_cmp] = ACTIONS(2978),
    [anon_sym_lt] = ACTIONS(2978),
    [anon_sym_le] = ACTIONS(2978),
    [anon_sym_ge] = ACTIONS(2978),
    [anon_sym_gt] = ACTIONS(2978),
    [anon_sym_isa] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_BSLASH] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_eval] = ACTIONS(2978),
    [anon_sym_field] = ACTIONS(2978),
    [anon_sym_local] = ACTIONS(2978),
    [anon_sym_require] = ACTIONS(2978),
    [anon_sym_map] = ACTIONS(2978),
    [anon_sym_grep] = ACTIONS(2978),
    [anon_sym_sort] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_undef] = ACTIONS(2978),
    [anon_sym_PERCENT2] = ACTIONS(2978),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2978),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_no] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_foreach] = ACTIONS(2978),
    [anon_sym_last] = ACTIONS(2978),
    [anon_sym_next] = ACTIONS(2978),
    [anon_sym_redo] = ACTIONS(2978),
    [anon_sym_BEGIN] = ACTIONS(2978),
    [anon_sym_INIT] = ACTIONS(2978),
    [anon_sym_CHECK] = ACTIONS(2978),
    [anon_sym_UNITCHECK] = ACTIONS(2978),
    [anon_sym_END] = ACTIONS(2978),
    [anon_sym_ADJUST] = ACTIONS(2978),
    [anon_sym___FILE__] = ACTIONS(2978),
    [anon_sym___LINE__] = ACTIONS(2978),
    [anon_sym___PACKAGE__] = ACTIONS(2978),
    [anon_sym___SUB__] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_fork] = ACTIONS(2978),
    [anon_sym_getppid] = ACTIONS(2978),
    [anon_sym_time] = ACTIONS(2978),
    [anon_sym_times] = ACTIONS(2978),
    [anon_sym_wait] = ACTIONS(2978),
    [anon_sym_wantarray] = ACTIONS(2978),
    [anon_sym_abs] = ACTIONS(2978),
    [anon_sym_alarm] = ACTIONS(2978),
    [anon_sym_chop] = ACTIONS(2978),
    [anon_sym_chdir] = ACTIONS(2978),
    [anon_sym_close] = ACTIONS(2978),
    [anon_sym_closedir] = ACTIONS(2978),
    [anon_sym_caller] = ACTIONS(2978),
    [anon_sym_chomp] = ACTIONS(2978),
    [anon_sym_chr] = ACTIONS(2978),
    [anon_sym_cos] = ACTIONS(2978),
    [anon_sym_chroot] = ACTIONS(2978),
    [anon_sym_defined] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_dbmclose] = ACTIONS(2978),
    [anon_sym_exists] = ACTIONS(2978),
    [anon_sym_exit] = ACTIONS(2978),
    [anon_sym_eof] = ACTIONS(2978),
    [anon_sym_exp] = ACTIONS(2978),
    [anon_sym_each] = ACTIONS(2978),
    [anon_sym_fc] = ACTIONS(2978),
    [anon_sym_fileno] = ACTIONS(2978),
    [anon_sym_gmtime] = ACTIONS(2978),
    [anon_sym_getc] = ACTIONS(2978),
    [anon_sym_getpgrp] = ACTIONS(2978),
    [anon_sym_getprotobyname] = ACTIONS(2978),
    [anon_sym_getpwname] = ACTIONS(2978),
    [anon_sym_getpwuid] = ACTIONS(2978),
    [anon_sym_getpeername] = ACTIONS(2978),
    [anon_sym_getnetbyname] = ACTIONS(2978),
    [anon_sym_getsockname] = ACTIONS(2978),
    [anon_sym_getgrnam] = ACTIONS(2978),
    [anon_sym_getgrgid] = ACTIONS(2978),
    [anon_sym_hex] = ACTIONS(2978),
    [anon_sym_int] = ACTIONS(2978),
    [anon_sym_keys] = ACTIONS(2978),
    [anon_sym_lc] = ACTIONS(2978),
    [anon_sym_lcfirst] = ACTIONS(2978),
    [anon_sym_length] = ACTIONS(2978),
    [anon_sym_localtime] = ACTIONS(2978),
    [anon_sym_log] = ACTIONS(2978),
    [anon_sym_lock] = ACTIONS(2978),
    [anon_sym_lstat] = ACTIONS(2978),
    [anon_sym_oct] = ACTIONS(2978),
    [anon_sym_ord] = ACTIONS(2978),
    [anon_sym_prototype] = ACTIONS(2978),
    [anon_sym_pop] = ACTIONS(2978),
    [anon_sym_pos] = ACTIONS(2978),
    [anon_sym_quotemeta] = ACTIONS(2978),
    [anon_sym_reset] = ACTIONS(2978),
    [anon_sym_rand] = ACTIONS(2978),
    [anon_sym_rmdir] = ACTIONS(2978),
    [anon_sym_readdir] = ACTIONS(2978),
    [anon_sym_readline] = ACTIONS(2978),
    [anon_sym_readpipe] = ACTIONS(2978),
    [anon_sym_rewinddir] = ACTIONS(2978),
    [anon_sym_readlink] = ACTIONS(2978),
    [anon_sym_ref] = ACTIONS(2978),
    [anon_sym_scalar] = ACTIONS(2978),
    [anon_sym_shift] = ACTIONS(2978),
    [anon_sym_sin] = ACTIONS(2978),
    [anon_sym_sleep] = ACTIONS(2978),
    [anon_sym_sqrt] = ACTIONS(2978),
    [anon_sym_srand] = ACTIONS(2978),
    [anon_sym_stat] = ACTIONS(2978),
    [anon_sym_study] = ACTIONS(2978),
    [anon_sym_tell] = ACTIONS(2978),
    [anon_sym_telldir] = ACTIONS(2978),
    [anon_sym_tied] = ACTIONS(2978),
    [anon_sym_uc] = ACTIONS(2978),
    [anon_sym_ucfirst] = ACTIONS(2978),
    [anon_sym_untie] = ACTIONS(2978),
    [anon_sym_umask] = ACTIONS(2978),
    [anon_sym_values] = ACTIONS(2978),
    [anon_sym_write] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2978),
    [anon_sym___END__] = ACTIONS(2978),
    [anon_sym_EOT] = ACTIONS(2978),
    [anon_sym_q] = ACTIONS(2978),
    [anon_sym_qq] = ACTIONS(2978),
    [anon_sym_qw] = ACTIONS(2978),
    [anon_sym_qx] = ACTIONS(2978),
    [anon_sym_qr] = ACTIONS(2978),
    [anon_sym_m] = ACTIONS(2978),
    [anon_sym_s] = ACTIONS(2978),
    [anon_sym_tr] = ACTIONS(2978),
    [anon_sym_y] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_unless] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_until] = ACTIONS(2978),
    [aux_sym__bareword_token1] = ACTIONS(2978),
    [sym_number] = ACTIONS(2978),
    [sym__apostrophe] = ACTIONS(2976),
    [sym__double_quote] = ACTIONS(2976),
    [sym__backtick] = ACTIONS(2976),
    [sym__search_slash] = ACTIONS(2976),
    [sym__PERLY_HEREDOC] = ACTIONS(2976),
    [sym__ctrl_z_hack] = ACTIONS(2976),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [965] = {
    [sym__else] = STATE(1087),
    [sym_else] = STATE(1086),
    [sym_elsif] = STATE(1086),
    [sym_heredoc_content] = STATE(965),
    [sym__identifier] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LBRACE2] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_package] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_sub] = ACTIONS(2950),
    [anon_sym_method] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_my] = ACTIONS(2950),
    [anon_sym_state] = ACTIONS(2950),
    [anon_sym_our] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_defer] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2982),
    [anon_sym_elsif] = ACTIONS(2985),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_AT] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_SLASH_SLASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_eq] = ACTIONS(2950),
    [anon_sym_ne] = ACTIONS(2950),
    [anon_sym_cmp] = ACTIONS(2950),
    [anon_sym_lt] = ACTIONS(2950),
    [anon_sym_le] = ACTIONS(2950),
    [anon_sym_ge] = ACTIONS(2950),
    [anon_sym_gt] = ACTIONS(2950),
    [anon_sym_isa] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2950),
    [anon_sym_BSLASH] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_eval] = ACTIONS(2950),
    [anon_sym_field] = ACTIONS(2950),
    [anon_sym_local] = ACTIONS(2950),
    [anon_sym_require] = ACTIONS(2950),
    [anon_sym_map] = ACTIONS(2950),
    [anon_sym_grep] = ACTIONS(2950),
    [anon_sym_sort] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_undef] = ACTIONS(2950),
    [anon_sym_PERCENT2] = ACTIONS(2950),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2950),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_no] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_foreach] = ACTIONS(2950),
    [anon_sym_last] = ACTIONS(2950),
    [anon_sym_next] = ACTIONS(2950),
    [anon_sym_redo] = ACTIONS(2950),
    [anon_sym_BEGIN] = ACTIONS(2950),
    [anon_sym_INIT] = ACTIONS(2950),
    [anon_sym_CHECK] = ACTIONS(2950),
    [anon_sym_UNITCHECK] = ACTIONS(2950),
    [anon_sym_END] = ACTIONS(2950),
    [anon_sym_ADJUST] = ACTIONS(2950),
    [anon_sym___FILE__] = ACTIONS(2950),
    [anon_sym___LINE__] = ACTIONS(2950),
    [anon_sym___PACKAGE__] = ACTIONS(2950),
    [anon_sym___SUB__] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_fork] = ACTIONS(2950),
    [anon_sym_getppid] = ACTIONS(2950),
    [anon_sym_time] = ACTIONS(2950),
    [anon_sym_times] = ACTIONS(2950),
    [anon_sym_wait] = ACTIONS(2950),
    [anon_sym_wantarray] = ACTIONS(2950),
    [anon_sym_abs] = ACTIONS(2950),
    [anon_sym_alarm] = ACTIONS(2950),
    [anon_sym_chop] = ACTIONS(2950),
    [anon_sym_chdir] = ACTIONS(2950),
    [anon_sym_close] = ACTIONS(2950),
    [anon_sym_closedir] = ACTIONS(2950),
    [anon_sym_caller] = ACTIONS(2950),
    [anon_sym_chomp] = ACTIONS(2950),
    [anon_sym_chr] = ACTIONS(2950),
    [anon_sym_cos] = ACTIONS(2950),
    [anon_sym_chroot] = ACTIONS(2950),
    [anon_sym_defined] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_dbmclose] = ACTIONS(2950),
    [anon_sym_exists] = ACTIONS(2950),
    [anon_sym_exit] = ACTIONS(2950),
    [anon_sym_eof] = ACTIONS(2950),
    [anon_sym_exp] = ACTIONS(2950),
    [anon_sym_each] = ACTIONS(2950),
    [anon_sym_fc] = ACTIONS(2950),
    [anon_sym_fileno] = ACTIONS(2950),
    [anon_sym_gmtime] = ACTIONS(2950),
    [anon_sym_getc] = ACTIONS(2950),
    [anon_sym_getpgrp] = ACTIONS(2950),
    [anon_sym_getprotobyname] = ACTIONS(2950),
    [anon_sym_getpwname] = ACTIONS(2950),
    [anon_sym_getpwuid] = ACTIONS(2950),
    [anon_sym_getpeername] = ACTIONS(2950),
    [anon_sym_getnetbyname] = ACTIONS(2950),
    [anon_sym_getsockname] = ACTIONS(2950),
    [anon_sym_getgrnam] = ACTIONS(2950),
    [anon_sym_getgrgid] = ACTIONS(2950),
    [anon_sym_hex] = ACTIONS(2950),
    [anon_sym_int] = ACTIONS(2950),
    [anon_sym_keys] = ACTIONS(2950),
    [anon_sym_lc] = ACTIONS(2950),
    [anon_sym_lcfirst] = ACTIONS(2950),
    [anon_sym_length] = ACTIONS(2950),
    [anon_sym_localtime] = ACTIONS(2950),
    [anon_sym_log] = ACTIONS(2950),
    [anon_sym_lock] = ACTIONS(2950),
    [anon_sym_lstat] = ACTIONS(2950),
    [anon_sym_oct] = ACTIONS(2950),
    [anon_sym_ord] = ACTIONS(2950),
    [anon_sym_prototype] = ACTIONS(2950),
    [anon_sym_pop] = ACTIONS(2950),
    [anon_sym_pos] = ACTIONS(2950),
    [anon_sym_quotemeta] = ACTIONS(2950),
    [anon_sym_reset] = ACTIONS(2950),
    [anon_sym_rand] = ACTIONS(2950),
    [anon_sym_rmdir] = ACTIONS(2950),
    [anon_sym_readdir] = ACTIONS(2950),
    [anon_sym_readline] = ACTIONS(2950),
    [anon_sym_readpipe] = ACTIONS(2950),
    [anon_sym_rewinddir] = ACTIONS(2950),
    [anon_sym_readlink] = ACTIONS(2950),
    [anon_sym_ref] = ACTIONS(2950),
    [anon_sym_scalar] = ACTIONS(2950),
    [anon_sym_shift] = ACTIONS(2950),
    [anon_sym_sin] = ACTIONS(2950),
    [anon_sym_sleep] = ACTIONS(2950),
    [anon_sym_sqrt] = ACTIONS(2950),
    [anon_sym_srand] = ACTIONS(2950),
    [anon_sym_stat] = ACTIONS(2950),
    [anon_sym_study] = ACTIONS(2950),
    [anon_sym_tell] = ACTIONS(2950),
    [anon_sym_telldir] = ACTIONS(2950),
    [anon_sym_tied] = ACTIONS(2950),
    [anon_sym_uc] = ACTIONS(2950),
    [anon_sym_ucfirst] = ACTIONS(2950),
    [anon_sym_untie] = ACTIONS(2950),
    [anon_sym_umask] = ACTIONS(2950),
    [anon_sym_values] = ACTIONS(2950),
    [anon_sym_write] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2950),
    [anon_sym___END__] = ACTIONS(2950),
    [anon_sym_q] = ACTIONS(2950),
    [anon_sym_qq] = ACTIONS(2950),
    [anon_sym_qw] = ACTIONS(2950),
    [anon_sym_qx] = ACTIONS(2950),
    [anon_sym_qr] = ACTIONS(2950),
    [anon_sym_m] = ACTIONS(2950),
    [anon_sym_s] = ACTIONS(2950),
    [anon_sym_tr] = ACTIONS(2950),
    [anon_sym_y] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [aux_sym__bareword_token1] = ACTIONS(2950),
    [sym_number] = ACTIONS(2950),
    [sym__apostrophe] = ACTIONS(2948),
    [sym__double_quote] = ACTIONS(2948),
    [sym__backtick] = ACTIONS(2948),
    [sym__search_slash] = ACTIONS(2948),
    [sym__PERLY_HEREDOC] = ACTIONS(2948),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [966] = {
    [sym_heredoc_content] = STATE(966),
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_LBRACE2] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_package] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_finally] = ACTIONS(2897),
    [anon_sym_defer] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_EOT] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym__ctrl_z_hack] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [967] = {
    [sym__else] = STATE(1090),
    [sym_else] = STATE(1086),
    [sym_elsif] = STATE(1086),
    [sym_heredoc_content] = STATE(967),
    [sym__identifier] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_LBRACE2] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_package] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_sub] = ACTIONS(2960),
    [anon_sym_method] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_my] = ACTIONS(2960),
    [anon_sym_state] = ACTIONS(2960),
    [anon_sym_our] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_defer] = ACTIONS(2960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_else] = ACTIONS(2988),
    [anon_sym_elsif] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_AT] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_LT_LT] = ACTIONS(2960),
    [anon_sym_SLASH_SLASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_eq] = ACTIONS(2960),
    [anon_sym_ne] = ACTIONS(2960),
    [anon_sym_cmp] = ACTIONS(2960),
    [anon_sym_lt] = ACTIONS(2960),
    [anon_sym_le] = ACTIONS(2960),
    [anon_sym_ge] = ACTIONS(2960),
    [anon_sym_gt] = ACTIONS(2960),
    [anon_sym_isa] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_BSLASH] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_eval] = ACTIONS(2960),
    [anon_sym_field] = ACTIONS(2960),
    [anon_sym_local] = ACTIONS(2960),
    [anon_sym_require] = ACTIONS(2960),
    [anon_sym_map] = ACTIONS(2960),
    [anon_sym_grep] = ACTIONS(2960),
    [anon_sym_sort] = ACTIONS(2960),
    [anon_sym_goto] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_undef] = ACTIONS(2960),
    [anon_sym_PERCENT2] = ACTIONS(2960),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2960),
    [anon_sym_no] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_foreach] = ACTIONS(2960),
    [anon_sym_last] = ACTIONS(2960),
    [anon_sym_next] = ACTIONS(2960),
    [anon_sym_redo] = ACTIONS(2960),
    [anon_sym_BEGIN] = ACTIONS(2960),
    [anon_sym_INIT] = ACTIONS(2960),
    [anon_sym_CHECK] = ACTIONS(2960),
    [anon_sym_UNITCHECK] = ACTIONS(2960),
    [anon_sym_END] = ACTIONS(2960),
    [anon_sym_ADJUST] = ACTIONS(2960),
    [anon_sym___FILE__] = ACTIONS(2960),
    [anon_sym___LINE__] = ACTIONS(2960),
    [anon_sym___PACKAGE__] = ACTIONS(2960),
    [anon_sym___SUB__] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_fork] = ACTIONS(2960),
    [anon_sym_getppid] = ACTIONS(2960),
    [anon_sym_time] = ACTIONS(2960),
    [anon_sym_times] = ACTIONS(2960),
    [anon_sym_wait] = ACTIONS(2960),
    [anon_sym_wantarray] = ACTIONS(2960),
    [anon_sym_abs] = ACTIONS(2960),
    [anon_sym_alarm] = ACTIONS(2960),
    [anon_sym_chop] = ACTIONS(2960),
    [anon_sym_chdir] = ACTIONS(2960),
    [anon_sym_close] = ACTIONS(2960),
    [anon_sym_closedir] = ACTIONS(2960),
    [anon_sym_caller] = ACTIONS(2960),
    [anon_sym_chomp] = ACTIONS(2960),
    [anon_sym_chr] = ACTIONS(2960),
    [anon_sym_cos] = ACTIONS(2960),
    [anon_sym_chroot] = ACTIONS(2960),
    [anon_sym_defined] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_dbmclose] = ACTIONS(2960),
    [anon_sym_exists] = ACTIONS(2960),
    [anon_sym_exit] = ACTIONS(2960),
    [anon_sym_eof] = ACTIONS(2960),
    [anon_sym_exp] = ACTIONS(2960),
    [anon_sym_each] = ACTIONS(2960),
    [anon_sym_fc] = ACTIONS(2960),
    [anon_sym_fileno] = ACTIONS(2960),
    [anon_sym_gmtime] = ACTIONS(2960),
    [anon_sym_getc] = ACTIONS(2960),
    [anon_sym_getpgrp] = ACTIONS(2960),
    [anon_sym_getprotobyname] = ACTIONS(2960),
    [anon_sym_getpwname] = ACTIONS(2960),
    [anon_sym_getpwuid] = ACTIONS(2960),
    [anon_sym_getpeername] = ACTIONS(2960),
    [anon_sym_getnetbyname] = ACTIONS(2960),
    [anon_sym_getsockname] = ACTIONS(2960),
    [anon_sym_getgrnam] = ACTIONS(2960),
    [anon_sym_getgrgid] = ACTIONS(2960),
    [anon_sym_hex] = ACTIONS(2960),
    [anon_sym_int] = ACTIONS(2960),
    [anon_sym_keys] = ACTIONS(2960),
    [anon_sym_lc] = ACTIONS(2960),
    [anon_sym_lcfirst] = ACTIONS(2960),
    [anon_sym_length] = ACTIONS(2960),
    [anon_sym_localtime] = ACTIONS(2960),
    [anon_sym_log] = ACTIONS(2960),
    [anon_sym_lock] = ACTIONS(2960),
    [anon_sym_lstat] = ACTIONS(2960),
    [anon_sym_oct] = ACTIONS(2960),
    [anon_sym_ord] = ACTIONS(2960),
    [anon_sym_prototype] = ACTIONS(2960),
    [anon_sym_pop] = ACTIONS(2960),
    [anon_sym_pos] = ACTIONS(2960),
    [anon_sym_quotemeta] = ACTIONS(2960),
    [anon_sym_reset] = ACTIONS(2960),
    [anon_sym_rand] = ACTIONS(2960),
    [anon_sym_rmdir] = ACTIONS(2960),
    [anon_sym_readdir] = ACTIONS(2960),
    [anon_sym_readline] = ACTIONS(2960),
    [anon_sym_readpipe] = ACTIONS(2960),
    [anon_sym_rewinddir] = ACTIONS(2960),
    [anon_sym_readlink] = ACTIONS(2960),
    [anon_sym_ref] = ACTIONS(2960),
    [anon_sym_scalar] = ACTIONS(2960),
    [anon_sym_shift] = ACTIONS(2960),
    [anon_sym_sin] = ACTIONS(2960),
    [anon_sym_sleep] = ACTIONS(2960),
    [anon_sym_sqrt] = ACTIONS(2960),
    [anon_sym_srand] = ACTIONS(2960),
    [anon_sym_stat] = ACTIONS(2960),
    [anon_sym_study] = ACTIONS(2960),
    [anon_sym_tell] = ACTIONS(2960),
    [anon_sym_telldir] = ACTIONS(2960),
    [anon_sym_tied] = ACTIONS(2960),
    [anon_sym_uc] = ACTIONS(2960),
    [anon_sym_ucfirst] = ACTIONS(2960),
    [anon_sym_untie] = ACTIONS(2960),
    [anon_sym_umask] = ACTIONS(2960),
    [anon_sym_values] = ACTIONS(2960),
    [anon_sym_write] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2960),
    [anon_sym___END__] = ACTIONS(2960),
    [anon_sym_q] = ACTIONS(2960),
    [anon_sym_qq] = ACTIONS(2960),
    [anon_sym_qw] = ACTIONS(2960),
    [anon_sym_qx] = ACTIONS(2960),
    [anon_sym_qr] = ACTIONS(2960),
    [anon_sym_m] = ACTIONS(2960),
    [anon_sym_s] = ACTIONS(2960),
    [anon_sym_tr] = ACTIONS(2960),
    [anon_sym_y] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [aux_sym__bareword_token1] = ACTIONS(2960),
    [sym_number] = ACTIONS(2960),
    [sym__apostrophe] = ACTIONS(2958),
    [sym__double_quote] = ACTIONS(2958),
    [sym__backtick] = ACTIONS(2958),
    [sym__search_slash] = ACTIONS(2958),
    [sym__PERLY_HEREDOC] = ACTIONS(2958),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [968] = {
    [sym_heredoc_content] = STATE(968),
    [ts_builtin_sym_end] = ACTIONS(2994),
    [sym__identifier] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LBRACE2] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_package] = ACTIONS(2996),
    [anon_sym_class] = ACTIONS(2996),
    [anon_sym_sub] = ACTIONS(2996),
    [anon_sym_method] = ACTIONS(2996),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_continue] = ACTIONS(2996),
    [anon_sym_my] = ACTIONS(2996),
    [anon_sym_state] = ACTIONS(2996),
    [anon_sym_our] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_defer] = ACTIONS(2996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_else] = ACTIONS(2996),
    [anon_sym_elsif] = ACTIONS(2996),
    [anon_sym_and] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2996),
    [anon_sym_LT] = ACTIONS(2996),
    [anon_sym_LT_LT] = ACTIONS(2996),
    [anon_sym_SLASH_SLASH] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_eq] = ACTIONS(2996),
    [anon_sym_ne] = ACTIONS(2996),
    [anon_sym_cmp] = ACTIONS(2996),
    [anon_sym_lt] = ACTIONS(2996),
    [anon_sym_le] = ACTIONS(2996),
    [anon_sym_ge] = ACTIONS(2996),
    [anon_sym_gt] = ACTIONS(2996),
    [anon_sym_isa] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_BSLASH] = ACTIONS(2994),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_eval] = ACTIONS(2996),
    [anon_sym_field] = ACTIONS(2996),
    [anon_sym_local] = ACTIONS(2996),
    [anon_sym_require] = ACTIONS(2996),
    [anon_sym_map] = ACTIONS(2996),
    [anon_sym_grep] = ACTIONS(2996),
    [anon_sym_sort] = ACTIONS(2996),
    [anon_sym_goto] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_undef] = ACTIONS(2996),
    [anon_sym_PERCENT2] = ACTIONS(2996),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2996),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_no] = ACTIONS(2996),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_foreach] = ACTIONS(2996),
    [anon_sym_last] = ACTIONS(2996),
    [anon_sym_next] = ACTIONS(2996),
    [anon_sym_redo] = ACTIONS(2996),
    [anon_sym_BEGIN] = ACTIONS(2996),
    [anon_sym_INIT] = ACTIONS(2996),
    [anon_sym_CHECK] = ACTIONS(2996),
    [anon_sym_UNITCHECK] = ACTIONS(2996),
    [anon_sym_END] = ACTIONS(2996),
    [anon_sym_ADJUST] = ACTIONS(2996),
    [anon_sym___FILE__] = ACTIONS(2996),
    [anon_sym___LINE__] = ACTIONS(2996),
    [anon_sym___PACKAGE__] = ACTIONS(2996),
    [anon_sym___SUB__] = ACTIONS(2996),
    [anon_sym_break] = ACTIONS(2996),
    [anon_sym_fork] = ACTIONS(2996),
    [anon_sym_getppid] = ACTIONS(2996),
    [anon_sym_time] = ACTIONS(2996),
    [anon_sym_times] = ACTIONS(2996),
    [anon_sym_wait] = ACTIONS(2996),
    [anon_sym_wantarray] = ACTIONS(2996),
    [anon_sym_abs] = ACTIONS(2996),
    [anon_sym_alarm] = ACTIONS(2996),
    [anon_sym_chop] = ACTIONS(2996),
    [anon_sym_chdir] = ACTIONS(2996),
    [anon_sym_close] = ACTIONS(2996),
    [anon_sym_closedir] = ACTIONS(2996),
    [anon_sym_caller] = ACTIONS(2996),
    [anon_sym_chomp] = ACTIONS(2996),
    [anon_sym_chr] = ACTIONS(2996),
    [anon_sym_cos] = ACTIONS(2996),
    [anon_sym_chroot] = ACTIONS(2996),
    [anon_sym_defined] = ACTIONS(2996),
    [anon_sym_delete] = ACTIONS(2996),
    [anon_sym_dbmclose] = ACTIONS(2996),
    [anon_sym_exists] = ACTIONS(2996),
    [anon_sym_exit] = ACTIONS(2996),
    [anon_sym_eof] = ACTIONS(2996),
    [anon_sym_exp] = ACTIONS(2996),
    [anon_sym_each] = ACTIONS(2996),
    [anon_sym_fc] = ACTIONS(2996),
    [anon_sym_fileno] = ACTIONS(2996),
    [anon_sym_gmtime] = ACTIONS(2996),
    [anon_sym_getc] = ACTIONS(2996),
    [anon_sym_getpgrp] = ACTIONS(2996),
    [anon_sym_getprotobyname] = ACTIONS(2996),
    [anon_sym_getpwname] = ACTIONS(2996),
    [anon_sym_getpwuid] = ACTIONS(2996),
    [anon_sym_getpeername] = ACTIONS(2996),
    [anon_sym_getnetbyname] = ACTIONS(2996),
    [anon_sym_getsockname] = ACTIONS(2996),
    [anon_sym_getgrnam] = ACTIONS(2996),
    [anon_sym_getgrgid] = ACTIONS(2996),
    [anon_sym_hex] = ACTIONS(2996),
    [anon_sym_int] = ACTIONS(2996),
    [anon_sym_keys] = ACTIONS(2996),
    [anon_sym_lc] = ACTIONS(2996),
    [anon_sym_lcfirst] = ACTIONS(2996),
    [anon_sym_length] = ACTIONS(2996),
    [anon_sym_localtime] = ACTIONS(2996),
    [anon_sym_log] = ACTIONS(2996),
    [anon_sym_lock] = ACTIONS(2996),
    [anon_sym_lstat] = ACTIONS(2996),
    [anon_sym_oct] = ACTIONS(2996),
    [anon_sym_ord] = ACTIONS(2996),
    [anon_sym_prototype] = ACTIONS(2996),
    [anon_sym_pop] = ACTIONS(2996),
    [anon_sym_pos] = ACTIONS(2996),
    [anon_sym_quotemeta] = ACTIONS(2996),
    [anon_sym_reset] = ACTIONS(2996),
    [anon_sym_rand] = ACTIONS(2996),
    [anon_sym_rmdir] = ACTIONS(2996),
    [anon_sym_readdir] = ACTIONS(2996),
    [anon_sym_readline] = ACTIONS(2996),
    [anon_sym_readpipe] = ACTIONS(2996),
    [anon_sym_rewinddir] = ACTIONS(2996),
    [anon_sym_readlink] = ACTIONS(2996),
    [anon_sym_ref] = ACTIONS(2996),
    [anon_sym_scalar] = ACTIONS(2996),
    [anon_sym_shift] = ACTIONS(2996),
    [anon_sym_sin] = ACTIONS(2996),
    [anon_sym_sleep] = ACTIONS(2996),
    [anon_sym_sqrt] = ACTIONS(2996),
    [anon_sym_srand] = ACTIONS(2996),
    [anon_sym_stat] = ACTIONS(2996),
    [anon_sym_study] = ACTIONS(2996),
    [anon_sym_tell] = ACTIONS(2996),
    [anon_sym_telldir] = ACTIONS(2996),
    [anon_sym_tied] = ACTIONS(2996),
    [anon_sym_uc] = ACTIONS(2996),
    [anon_sym_ucfirst] = ACTIONS(2996),
    [anon_sym_untie] = ACTIONS(2996),
    [anon_sym_umask] = ACTIONS(2996),
    [anon_sym_values] = ACTIONS(2996),
    [anon_sym_write] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2996),
    [anon_sym___END__] = ACTIONS(2996),
    [anon_sym_EOT] = ACTIONS(2996),
    [anon_sym_q] = ACTIONS(2996),
    [anon_sym_qq] = ACTIONS(2996),
    [anon_sym_qw] = ACTIONS(2996),
    [anon_sym_qx] = ACTIONS(2996),
    [anon_sym_qr] = ACTIONS(2996),
    [anon_sym_m] = ACTIONS(2996),
    [anon_sym_s] = ACTIONS(2996),
    [anon_sym_tr] = ACTIONS(2996),
    [anon_sym_y] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_unless] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_until] = ACTIONS(2996),
    [aux_sym__bareword_token1] = ACTIONS(2996),
    [sym_number] = ACTIONS(2996),
    [sym__apostrophe] = ACTIONS(2994),
    [sym__double_quote] = ACTIONS(2994),
    [sym__backtick] = ACTIONS(2994),
    [sym__search_slash] = ACTIONS(2994),
    [sym__PERLY_HEREDOC] = ACTIONS(2994),
    [sym__ctrl_z_hack] = ACTIONS(2994),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [969] = {
    [sym_heredoc_content] = STATE(969),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_LBRACE2] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_package] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_finally] = ACTIONS(2905),
    [anon_sym_defer] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_EOT] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym__ctrl_z_hack] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [970] = {
    [sym_heredoc_content] = STATE(970),
    [ts_builtin_sym_end] = ACTIONS(3000),
    [sym__identifier] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_LBRACE2] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_package] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_sub] = ACTIONS(3002),
    [anon_sym_method] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3004),
    [anon_sym_my] = ACTIONS(3002),
    [anon_sym_state] = ACTIONS(3002),
    [anon_sym_our] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_defer] = ACTIONS(3002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_elsif] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_DOLLAR] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_AT] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_SLASH_SLASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3002),
    [anon_sym_eq] = ACTIONS(3002),
    [anon_sym_ne] = ACTIONS(3002),
    [anon_sym_cmp] = ACTIONS(3002),
    [anon_sym_lt] = ACTIONS(3002),
    [anon_sym_le] = ACTIONS(3002),
    [anon_sym_ge] = ACTIONS(3002),
    [anon_sym_gt] = ACTIONS(3002),
    [anon_sym_isa] = ACTIONS(3002),
    [anon_sym_TILDE] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(3002),
    [anon_sym_PLUS_PLUS] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3002),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_eval] = ACTIONS(3002),
    [anon_sym_field] = ACTIONS(3002),
    [anon_sym_local] = ACTIONS(3002),
    [anon_sym_require] = ACTIONS(3002),
    [anon_sym_map] = ACTIONS(3002),
    [anon_sym_grep] = ACTIONS(3002),
    [anon_sym_sort] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_undef] = ACTIONS(3002),
    [anon_sym_PERCENT2] = ACTIONS(3002),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3002),
    [anon_sym_use] = ACTIONS(3002),
    [anon_sym_no] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_foreach] = ACTIONS(3002),
    [anon_sym_last] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3002),
    [anon_sym_redo] = ACTIONS(3002),
    [anon_sym_BEGIN] = ACTIONS(3002),
    [anon_sym_INIT] = ACTIONS(3002),
    [anon_sym_CHECK] = ACTIONS(3002),
    [anon_sym_UNITCHECK] = ACTIONS(3002),
    [anon_sym_END] = ACTIONS(3002),
    [anon_sym_ADJUST] = ACTIONS(3002),
    [anon_sym___FILE__] = ACTIONS(3002),
    [anon_sym___LINE__] = ACTIONS(3002),
    [anon_sym___PACKAGE__] = ACTIONS(3002),
    [anon_sym___SUB__] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_fork] = ACTIONS(3002),
    [anon_sym_getppid] = ACTIONS(3002),
    [anon_sym_time] = ACTIONS(3002),
    [anon_sym_times] = ACTIONS(3002),
    [anon_sym_wait] = ACTIONS(3002),
    [anon_sym_wantarray] = ACTIONS(3002),
    [anon_sym_abs] = ACTIONS(3002),
    [anon_sym_alarm] = ACTIONS(3002),
    [anon_sym_chop] = ACTIONS(3002),
    [anon_sym_chdir] = ACTIONS(3002),
    [anon_sym_close] = ACTIONS(3002),
    [anon_sym_closedir] = ACTIONS(3002),
    [anon_sym_caller] = ACTIONS(3002),
    [anon_sym_chomp] = ACTIONS(3002),
    [anon_sym_chr] = ACTIONS(3002),
    [anon_sym_cos] = ACTIONS(3002),
    [anon_sym_chroot] = ACTIONS(3002),
    [anon_sym_defined] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_dbmclose] = ACTIONS(3002),
    [anon_sym_exists] = ACTIONS(3002),
    [anon_sym_exit] = ACTIONS(3002),
    [anon_sym_eof] = ACTIONS(3002),
    [anon_sym_exp] = ACTIONS(3002),
    [anon_sym_each] = ACTIONS(3002),
    [anon_sym_fc] = ACTIONS(3002),
    [anon_sym_fileno] = ACTIONS(3002),
    [anon_sym_gmtime] = ACTIONS(3002),
    [anon_sym_getc] = ACTIONS(3002),
    [anon_sym_getpgrp] = ACTIONS(3002),
    [anon_sym_getprotobyname] = ACTIONS(3002),
    [anon_sym_getpwname] = ACTIONS(3002),
    [anon_sym_getpwuid] = ACTIONS(3002),
    [anon_sym_getpeername] = ACTIONS(3002),
    [anon_sym_getnetbyname] = ACTIONS(3002),
    [anon_sym_getsockname] = ACTIONS(3002),
    [anon_sym_getgrnam] = ACTIONS(3002),
    [anon_sym_getgrgid] = ACTIONS(3002),
    [anon_sym_hex] = ACTIONS(3002),
    [anon_sym_int] = ACTIONS(3002),
    [anon_sym_keys] = ACTIONS(3002),
    [anon_sym_lc] = ACTIONS(3002),
    [anon_sym_lcfirst] = ACTIONS(3002),
    [anon_sym_length] = ACTIONS(3002),
    [anon_sym_localtime] = ACTIONS(3002),
    [anon_sym_log] = ACTIONS(3002),
    [anon_sym_lock] = ACTIONS(3002),
    [anon_sym_lstat] = ACTIONS(3002),
    [anon_sym_oct] = ACTIONS(3002),
    [anon_sym_ord] = ACTIONS(3002),
    [anon_sym_prototype] = ACTIONS(3002),
    [anon_sym_pop] = ACTIONS(3002),
    [anon_sym_pos] = ACTIONS(3002),
    [anon_sym_quotemeta] = ACTIONS(3002),
    [anon_sym_reset] = ACTIONS(3002),
    [anon_sym_rand] = ACTIONS(3002),
    [anon_sym_rmdir] = ACTIONS(3002),
    [anon_sym_readdir] = ACTIONS(3002),
    [anon_sym_readline] = ACTIONS(3002),
    [anon_sym_readpipe] = ACTIONS(3002),
    [anon_sym_rewinddir] = ACTIONS(3002),
    [anon_sym_readlink] = ACTIONS(3002),
    [anon_sym_ref] = ACTIONS(3002),
    [anon_sym_scalar] = ACTIONS(3002),
    [anon_sym_shift] = ACTIONS(3002),
    [anon_sym_sin] = ACTIONS(3002),
    [anon_sym_sleep] = ACTIONS(3002),
    [anon_sym_sqrt] = ACTIONS(3002),
    [anon_sym_srand] = ACTIONS(3002),
    [anon_sym_stat] = ACTIONS(3002),
    [anon_sym_study] = ACTIONS(3002),
    [anon_sym_tell] = ACTIONS(3002),
    [anon_sym_telldir] = ACTIONS(3002),
    [anon_sym_tied] = ACTIONS(3002),
    [anon_sym_uc] = ACTIONS(3002),
    [anon_sym_ucfirst] = ACTIONS(3002),
    [anon_sym_untie] = ACTIONS(3002),
    [anon_sym_umask] = ACTIONS(3002),
    [anon_sym_values] = ACTIONS(3002),
    [anon_sym_write] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3002),
    [anon_sym___END__] = ACTIONS(3002),
    [anon_sym_EOT] = ACTIONS(3002),
    [anon_sym_q] = ACTIONS(3002),
    [anon_sym_qq] = ACTIONS(3002),
    [anon_sym_qw] = ACTIONS(3002),
    [anon_sym_qx] = ACTIONS(3002),
    [anon_sym_qr] = ACTIONS(3002),
    [anon_sym_m] = ACTIONS(3002),
    [anon_sym_s] = ACTIONS(3002),
    [anon_sym_tr] = ACTIONS(3002),
    [anon_sym_y] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [aux_sym__bareword_token1] = ACTIONS(3002),
    [sym_number] = ACTIONS(3002),
    [sym__apostrophe] = ACTIONS(3000),
    [sym__double_quote] = ACTIONS(3000),
    [sym__backtick] = ACTIONS(3000),
    [sym__search_slash] = ACTIONS(3000),
    [sym__PERLY_HEREDOC] = ACTIONS(3000),
    [sym__ctrl_z_hack] = ACTIONS(3000),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [971] = {
    [sym_heredoc_content] = STATE(971),
    [ts_builtin_sym_end] = ACTIONS(3007),
    [sym__identifier] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3009),
    [anon_sym_LBRACE2] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3009),
    [anon_sym_package] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_sub] = ACTIONS(3009),
    [anon_sym_method] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_my] = ACTIONS(3009),
    [anon_sym_state] = ACTIONS(3009),
    [anon_sym_our] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_defer] = ACTIONS(3009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3009),
    [anon_sym_else] = ACTIONS(3009),
    [anon_sym_elsif] = ACTIONS(3009),
    [anon_sym_and] = ACTIONS(3009),
    [anon_sym_or] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_AT] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_LT_LT] = ACTIONS(3009),
    [anon_sym_SLASH_SLASH] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3009),
    [anon_sym_eq] = ACTIONS(3009),
    [anon_sym_ne] = ACTIONS(3009),
    [anon_sym_cmp] = ACTIONS(3009),
    [anon_sym_lt] = ACTIONS(3009),
    [anon_sym_le] = ACTIONS(3009),
    [anon_sym_ge] = ACTIONS(3009),
    [anon_sym_gt] = ACTIONS(3009),
    [anon_sym_isa] = ACTIONS(3009),
    [anon_sym_TILDE] = ACTIONS(3009),
    [anon_sym_BANG] = ACTIONS(3009),
    [anon_sym_PLUS_PLUS] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3009),
    [anon_sym_BSLASH] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_eval] = ACTIONS(3009),
    [anon_sym_field] = ACTIONS(3009),
    [anon_sym_local] = ACTIONS(3009),
    [anon_sym_require] = ACTIONS(3009),
    [anon_sym_map] = ACTIONS(3009),
    [anon_sym_grep] = ACTIONS(3009),
    [anon_sym_sort] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_undef] = ACTIONS(3009),
    [anon_sym_PERCENT2] = ACTIONS(3009),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3009),
    [anon_sym_no] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_foreach] = ACTIONS(3009),
    [anon_sym_last] = ACTIONS(3009),
    [anon_sym_next] = ACTIONS(3009),
    [anon_sym_redo] = ACTIONS(3009),
    [anon_sym_BEGIN] = ACTIONS(3009),
    [anon_sym_INIT] = ACTIONS(3009),
    [anon_sym_CHECK] = ACTIONS(3009),
    [anon_sym_UNITCHECK] = ACTIONS(3009),
    [anon_sym_END] = ACTIONS(3009),
    [anon_sym_ADJUST] = ACTIONS(3009),
    [anon_sym___FILE__] = ACTIONS(3009),
    [anon_sym___LINE__] = ACTIONS(3009),
    [anon_sym___PACKAGE__] = ACTIONS(3009),
    [anon_sym___SUB__] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_fork] = ACTIONS(3009),
    [anon_sym_getppid] = ACTIONS(3009),
    [anon_sym_time] = ACTIONS(3009),
    [anon_sym_times] = ACTIONS(3009),
    [anon_sym_wait] = ACTIONS(3009),
    [anon_sym_wantarray] = ACTIONS(3009),
    [anon_sym_abs] = ACTIONS(3009),
    [anon_sym_alarm] = ACTIONS(3009),
    [anon_sym_chop] = ACTIONS(3009),
    [anon_sym_chdir] = ACTIONS(3009),
    [anon_sym_close] = ACTIONS(3009),
    [anon_sym_closedir] = ACTIONS(3009),
    [anon_sym_caller] = ACTIONS(3009),
    [anon_sym_chomp] = ACTIONS(3009),
    [anon_sym_chr] = ACTIONS(3009),
    [anon_sym_cos] = ACTIONS(3009),
    [anon_sym_chroot] = ACTIONS(3009),
    [anon_sym_defined] = ACTIONS(3009),
    [anon_sym_delete] = ACTIONS(3009),
    [anon_sym_dbmclose] = ACTIONS(3009),
    [anon_sym_exists] = ACTIONS(3009),
    [anon_sym_exit] = ACTIONS(3009),
    [anon_sym_eof] = ACTIONS(3009),
    [anon_sym_exp] = ACTIONS(3009),
    [anon_sym_each] = ACTIONS(3009),
    [anon_sym_fc] = ACTIONS(3009),
    [anon_sym_fileno] = ACTIONS(3009),
    [anon_sym_gmtime] = ACTIONS(3009),
    [anon_sym_getc] = ACTIONS(3009),
    [anon_sym_getpgrp] = ACTIONS(3009),
    [anon_sym_getprotobyname] = ACTIONS(3009),
    [anon_sym_getpwname] = ACTIONS(3009),
    [anon_sym_getpwuid] = ACTIONS(3009),
    [anon_sym_getpeername] = ACTIONS(3009),
    [anon_sym_getnetbyname] = ACTIONS(3009),
    [anon_sym_getsockname] = ACTIONS(3009),
    [anon_sym_getgrnam] = ACTIONS(3009),
    [anon_sym_getgrgid] = ACTIONS(3009),
    [anon_sym_hex] = ACTIONS(3009),
    [anon_sym_int] = ACTIONS(3009),
    [anon_sym_keys] = ACTIONS(3009),
    [anon_sym_lc] = ACTIONS(3009),
    [anon_sym_lcfirst] = ACTIONS(3009),
    [anon_sym_length] = ACTIONS(3009),
    [anon_sym_localtime] = ACTIONS(3009),
    [anon_sym_log] = ACTIONS(3009),
    [anon_sym_lock] = ACTIONS(3009),
    [anon_sym_lstat] = ACTIONS(3009),
    [anon_sym_oct] = ACTIONS(3009),
    [anon_sym_ord] = ACTIONS(3009),
    [anon_sym_prototype] = ACTIONS(3009),
    [anon_sym_pop] = ACTIONS(3009),
    [anon_sym_pos] = ACTIONS(3009),
    [anon_sym_quotemeta] = ACTIONS(3009),
    [anon_sym_reset] = ACTIONS(3009),
    [anon_sym_rand] = ACTIONS(3009),
    [anon_sym_rmdir] = ACTIONS(3009),
    [anon_sym_readdir] = ACTIONS(3009),
    [anon_sym_readline] = ACTIONS(3009),
    [anon_sym_readpipe] = ACTIONS(3009),
    [anon_sym_rewinddir] = ACTIONS(3009),
    [anon_sym_readlink] = ACTIONS(3009),
    [anon_sym_ref] = ACTIONS(3009),
    [anon_sym_scalar] = ACTIONS(3009),
    [anon_sym_shift] = ACTIONS(3009),
    [anon_sym_sin] = ACTIONS(3009),
    [anon_sym_sleep] = ACTIONS(3009),
    [anon_sym_sqrt] = ACTIONS(3009),
    [anon_sym_srand] = ACTIONS(3009),
    [anon_sym_stat] = ACTIONS(3009),
    [anon_sym_study] = ACTIONS(3009),
    [anon_sym_tell] = ACTIONS(3009),
    [anon_sym_telldir] = ACTIONS(3009),
    [anon_sym_tied] = ACTIONS(3009),
    [anon_sym_uc] = ACTIONS(3009),
    [anon_sym_ucfirst] = ACTIONS(3009),
    [anon_sym_untie] = ACTIONS(3009),
    [anon_sym_umask] = ACTIONS(3009),
    [anon_sym_values] = ACTIONS(3009),
    [anon_sym_write] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3009),
    [anon_sym___END__] = ACTIONS(3009),
    [anon_sym_EOT] = ACTIONS(3009),
    [anon_sym_q] = ACTIONS(3009),
    [anon_sym_qq] = ACTIONS(3009),
    [anon_sym_qw] = ACTIONS(3009),
    [anon_sym_qx] = ACTIONS(3009),
    [anon_sym_qr] = ACTIONS(3009),
    [anon_sym_m] = ACTIONS(3009),
    [anon_sym_s] = ACTIONS(3009),
    [anon_sym_tr] = ACTIONS(3009),
    [anon_sym_y] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_unless] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_until] = ACTIONS(3009),
    [aux_sym__bareword_token1] = ACTIONS(3009),
    [sym_number] = ACTIONS(3009),
    [sym__apostrophe] = ACTIONS(3007),
    [sym__double_quote] = ACTIONS(3007),
    [sym__backtick] = ACTIONS(3007),
    [sym__search_slash] = ACTIONS(3007),
    [sym__PERLY_HEREDOC] = ACTIONS(3007),
    [sym__ctrl_z_hack] = ACTIONS(3007),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [972] = {
    [sym_heredoc_content] = STATE(972),
    [ts_builtin_sym_end] = ACTIONS(3011),
    [sym__identifier] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_LBRACE2] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3013),
    [anon_sym_package] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_sub] = ACTIONS(3013),
    [anon_sym_method] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_my] = ACTIONS(3013),
    [anon_sym_state] = ACTIONS(3013),
    [anon_sym_our] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_defer] = ACTIONS(3013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3013),
    [anon_sym_else] = ACTIONS(3013),
    [anon_sym_elsif] = ACTIONS(3013),
    [anon_sym_and] = ACTIONS(3013),
    [anon_sym_or] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_LT_LT] = ACTIONS(3013),
    [anon_sym_SLASH_SLASH] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3013),
    [anon_sym_eq] = ACTIONS(3013),
    [anon_sym_ne] = ACTIONS(3013),
    [anon_sym_cmp] = ACTIONS(3013),
    [anon_sym_lt] = ACTIONS(3013),
    [anon_sym_le] = ACTIONS(3013),
    [anon_sym_ge] = ACTIONS(3013),
    [anon_sym_gt] = ACTIONS(3013),
    [anon_sym_isa] = ACTIONS(3013),
    [anon_sym_TILDE] = ACTIONS(3013),
    [anon_sym_BANG] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3013),
    [anon_sym_BSLASH] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_eval] = ACTIONS(3013),
    [anon_sym_field] = ACTIONS(3013),
    [anon_sym_local] = ACTIONS(3013),
    [anon_sym_require] = ACTIONS(3013),
    [anon_sym_map] = ACTIONS(3013),
    [anon_sym_grep] = ACTIONS(3013),
    [anon_sym_sort] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_undef] = ACTIONS(3013),
    [anon_sym_PERCENT2] = ACTIONS(3013),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3013),
    [anon_sym_no] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_foreach] = ACTIONS(3013),
    [anon_sym_last] = ACTIONS(3013),
    [anon_sym_next] = ACTIONS(3013),
    [anon_sym_redo] = ACTIONS(3013),
    [anon_sym_BEGIN] = ACTIONS(3013),
    [anon_sym_INIT] = ACTIONS(3013),
    [anon_sym_CHECK] = ACTIONS(3013),
    [anon_sym_UNITCHECK] = ACTIONS(3013),
    [anon_sym_END] = ACTIONS(3013),
    [anon_sym_ADJUST] = ACTIONS(3013),
    [anon_sym___FILE__] = ACTIONS(3013),
    [anon_sym___LINE__] = ACTIONS(3013),
    [anon_sym___PACKAGE__] = ACTIONS(3013),
    [anon_sym___SUB__] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_fork] = ACTIONS(3013),
    [anon_sym_getppid] = ACTIONS(3013),
    [anon_sym_time] = ACTIONS(3013),
    [anon_sym_times] = ACTIONS(3013),
    [anon_sym_wait] = ACTIONS(3013),
    [anon_sym_wantarray] = ACTIONS(3013),
    [anon_sym_abs] = ACTIONS(3013),
    [anon_sym_alarm] = ACTIONS(3013),
    [anon_sym_chop] = ACTIONS(3013),
    [anon_sym_chdir] = ACTIONS(3013),
    [anon_sym_close] = ACTIONS(3013),
    [anon_sym_closedir] = ACTIONS(3013),
    [anon_sym_caller] = ACTIONS(3013),
    [anon_sym_chomp] = ACTIONS(3013),
    [anon_sym_chr] = ACTIONS(3013),
    [anon_sym_cos] = ACTIONS(3013),
    [anon_sym_chroot] = ACTIONS(3013),
    [anon_sym_defined] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_dbmclose] = ACTIONS(3013),
    [anon_sym_exists] = ACTIONS(3013),
    [anon_sym_exit] = ACTIONS(3013),
    [anon_sym_eof] = ACTIONS(3013),
    [anon_sym_exp] = ACTIONS(3013),
    [anon_sym_each] = ACTIONS(3013),
    [anon_sym_fc] = ACTIONS(3013),
    [anon_sym_fileno] = ACTIONS(3013),
    [anon_sym_gmtime] = ACTIONS(3013),
    [anon_sym_getc] = ACTIONS(3013),
    [anon_sym_getpgrp] = ACTIONS(3013),
    [anon_sym_getprotobyname] = ACTIONS(3013),
    [anon_sym_getpwname] = ACTIONS(3013),
    [anon_sym_getpwuid] = ACTIONS(3013),
    [anon_sym_getpeername] = ACTIONS(3013),
    [anon_sym_getnetbyname] = ACTIONS(3013),
    [anon_sym_getsockname] = ACTIONS(3013),
    [anon_sym_getgrnam] = ACTIONS(3013),
    [anon_sym_getgrgid] = ACTIONS(3013),
    [anon_sym_hex] = ACTIONS(3013),
    [anon_sym_int] = ACTIONS(3013),
    [anon_sym_keys] = ACTIONS(3013),
    [anon_sym_lc] = ACTIONS(3013),
    [anon_sym_lcfirst] = ACTIONS(3013),
    [anon_sym_length] = ACTIONS(3013),
    [anon_sym_localtime] = ACTIONS(3013),
    [anon_sym_log] = ACTIONS(3013),
    [anon_sym_lock] = ACTIONS(3013),
    [anon_sym_lstat] = ACTIONS(3013),
    [anon_sym_oct] = ACTIONS(3013),
    [anon_sym_ord] = ACTIONS(3013),
    [anon_sym_prototype] = ACTIONS(3013),
    [anon_sym_pop] = ACTIONS(3013),
    [anon_sym_pos] = ACTIONS(3013),
    [anon_sym_quotemeta] = ACTIONS(3013),
    [anon_sym_reset] = ACTIONS(3013),
    [anon_sym_rand] = ACTIONS(3013),
    [anon_sym_rmdir] = ACTIONS(3013),
    [anon_sym_readdir] = ACTIONS(3013),
    [anon_sym_readline] = ACTIONS(3013),
    [anon_sym_readpipe] = ACTIONS(3013),
    [anon_sym_rewinddir] = ACTIONS(3013),
    [anon_sym_readlink] = ACTIONS(3013),
    [anon_sym_ref] = ACTIONS(3013),
    [anon_sym_scalar] = ACTIONS(3013),
    [anon_sym_shift] = ACTIONS(3013),
    [anon_sym_sin] = ACTIONS(3013),
    [anon_sym_sleep] = ACTIONS(3013),
    [anon_sym_sqrt] = ACTIONS(3013),
    [anon_sym_srand] = ACTIONS(3013),
    [anon_sym_stat] = ACTIONS(3013),
    [anon_sym_study] = ACTIONS(3013),
    [anon_sym_tell] = ACTIONS(3013),
    [anon_sym_telldir] = ACTIONS(3013),
    [anon_sym_tied] = ACTIONS(3013),
    [anon_sym_uc] = ACTIONS(3013),
    [anon_sym_ucfirst] = ACTIONS(3013),
    [anon_sym_untie] = ACTIONS(3013),
    [anon_sym_umask] = ACTIONS(3013),
    [anon_sym_values] = ACTIONS(3013),
    [anon_sym_write] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3013),
    [anon_sym___END__] = ACTIONS(3013),
    [anon_sym_EOT] = ACTIONS(3013),
    [anon_sym_q] = ACTIONS(3013),
    [anon_sym_qq] = ACTIONS(3013),
    [anon_sym_qw] = ACTIONS(3013),
    [anon_sym_qx] = ACTIONS(3013),
    [anon_sym_qr] = ACTIONS(3013),
    [anon_sym_m] = ACTIONS(3013),
    [anon_sym_s] = ACTIONS(3013),
    [anon_sym_tr] = ACTIONS(3013),
    [anon_sym_y] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_unless] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_until] = ACTIONS(3013),
    [aux_sym__bareword_token1] = ACTIONS(3013),
    [sym_number] = ACTIONS(3013),
    [sym__apostrophe] = ACTIONS(3011),
    [sym__double_quote] = ACTIONS(3011),
    [sym__backtick] = ACTIONS(3011),
    [sym__search_slash] = ACTIONS(3011),
    [sym__PERLY_HEREDOC] = ACTIONS(3011),
    [sym__ctrl_z_hack] = ACTIONS(3011),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [973] = {
    [sym_heredoc_content] = STATE(973),
    [ts_builtin_sym_end] = ACTIONS(3015),
    [sym__identifier] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3017),
    [anon_sym_LBRACE2] = ACTIONS(3017),
    [anon_sym_SEMI] = ACTIONS(3017),
    [anon_sym_package] = ACTIONS(3017),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_sub] = ACTIONS(3017),
    [anon_sym_method] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3017),
    [anon_sym_continue] = ACTIONS(3017),
    [anon_sym_my] = ACTIONS(3017),
    [anon_sym_state] = ACTIONS(3017),
    [anon_sym_our] = ACTIONS(3017),
    [anon_sym_try] = ACTIONS(3017),
    [anon_sym_defer] = ACTIONS(3017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3017),
    [anon_sym_else] = ACTIONS(3017),
    [anon_sym_elsif] = ACTIONS(3017),
    [anon_sym_and] = ACTIONS(3017),
    [anon_sym_or] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3017),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_AT] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_LT_LT] = ACTIONS(3017),
    [anon_sym_SLASH_SLASH] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3017),
    [anon_sym_DASH] = ACTIONS(3017),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_eq] = ACTIONS(3017),
    [anon_sym_ne] = ACTIONS(3017),
    [anon_sym_cmp] = ACTIONS(3017),
    [anon_sym_lt] = ACTIONS(3017),
    [anon_sym_le] = ACTIONS(3017),
    [anon_sym_ge] = ACTIONS(3017),
    [anon_sym_gt] = ACTIONS(3017),
    [anon_sym_isa] = ACTIONS(3017),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_BANG] = ACTIONS(3017),
    [anon_sym_PLUS_PLUS] = ACTIONS(3017),
    [anon_sym_DASH_DASH] = ACTIONS(3017),
    [anon_sym_BSLASH] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3017),
    [anon_sym_eval] = ACTIONS(3017),
    [anon_sym_field] = ACTIONS(3017),
    [anon_sym_local] = ACTIONS(3017),
    [anon_sym_require] = ACTIONS(3017),
    [anon_sym_map] = ACTIONS(3017),
    [anon_sym_grep] = ACTIONS(3017),
    [anon_sym_sort] = ACTIONS(3017),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_undef] = ACTIONS(3017),
    [anon_sym_PERCENT2] = ACTIONS(3017),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3017),
    [anon_sym_no] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3017),
    [anon_sym_foreach] = ACTIONS(3017),
    [anon_sym_last] = ACTIONS(3017),
    [anon_sym_next] = ACTIONS(3017),
    [anon_sym_redo] = ACTIONS(3017),
    [anon_sym_BEGIN] = ACTIONS(3017),
    [anon_sym_INIT] = ACTIONS(3017),
    [anon_sym_CHECK] = ACTIONS(3017),
    [anon_sym_UNITCHECK] = ACTIONS(3017),
    [anon_sym_END] = ACTIONS(3017),
    [anon_sym_ADJUST] = ACTIONS(3017),
    [anon_sym___FILE__] = ACTIONS(3017),
    [anon_sym___LINE__] = ACTIONS(3017),
    [anon_sym___PACKAGE__] = ACTIONS(3017),
    [anon_sym___SUB__] = ACTIONS(3017),
    [anon_sym_break] = ACTIONS(3017),
    [anon_sym_fork] = ACTIONS(3017),
    [anon_sym_getppid] = ACTIONS(3017),
    [anon_sym_time] = ACTIONS(3017),
    [anon_sym_times] = ACTIONS(3017),
    [anon_sym_wait] = ACTIONS(3017),
    [anon_sym_wantarray] = ACTIONS(3017),
    [anon_sym_abs] = ACTIONS(3017),
    [anon_sym_alarm] = ACTIONS(3017),
    [anon_sym_chop] = ACTIONS(3017),
    [anon_sym_chdir] = ACTIONS(3017),
    [anon_sym_close] = ACTIONS(3017),
    [anon_sym_closedir] = ACTIONS(3017),
    [anon_sym_caller] = ACTIONS(3017),
    [anon_sym_chomp] = ACTIONS(3017),
    [anon_sym_chr] = ACTIONS(3017),
    [anon_sym_cos] = ACTIONS(3017),
    [anon_sym_chroot] = ACTIONS(3017),
    [anon_sym_defined] = ACTIONS(3017),
    [anon_sym_delete] = ACTIONS(3017),
    [anon_sym_dbmclose] = ACTIONS(3017),
    [anon_sym_exists] = ACTIONS(3017),
    [anon_sym_exit] = ACTIONS(3017),
    [anon_sym_eof] = ACTIONS(3017),
    [anon_sym_exp] = ACTIONS(3017),
    [anon_sym_each] = ACTIONS(3017),
    [anon_sym_fc] = ACTIONS(3017),
    [anon_sym_fileno] = ACTIONS(3017),
    [anon_sym_gmtime] = ACTIONS(3017),
    [anon_sym_getc] = ACTIONS(3017),
    [anon_sym_getpgrp] = ACTIONS(3017),
    [anon_sym_getprotobyname] = ACTIONS(3017),
    [anon_sym_getpwname] = ACTIONS(3017),
    [anon_sym_getpwuid] = ACTIONS(3017),
    [anon_sym_getpeername] = ACTIONS(3017),
    [anon_sym_getnetbyname] = ACTIONS(3017),
    [anon_sym_getsockname] = ACTIONS(3017),
    [anon_sym_getgrnam] = ACTIONS(3017),
    [anon_sym_getgrgid] = ACTIONS(3017),
    [anon_sym_hex] = ACTIONS(3017),
    [anon_sym_int] = ACTIONS(3017),
    [anon_sym_keys] = ACTIONS(3017),
    [anon_sym_lc] = ACTIONS(3017),
    [anon_sym_lcfirst] = ACTIONS(3017),
    [anon_sym_length] = ACTIONS(3017),
    [anon_sym_localtime] = ACTIONS(3017),
    [anon_sym_log] = ACTIONS(3017),
    [anon_sym_lock] = ACTIONS(3017),
    [anon_sym_lstat] = ACTIONS(3017),
    [anon_sym_oct] = ACTIONS(3017),
    [anon_sym_ord] = ACTIONS(3017),
    [anon_sym_prototype] = ACTIONS(3017),
    [anon_sym_pop] = ACTIONS(3017),
    [anon_sym_pos] = ACTIONS(3017),
    [anon_sym_quotemeta] = ACTIONS(3017),
    [anon_sym_reset] = ACTIONS(3017),
    [anon_sym_rand] = ACTIONS(3017),
    [anon_sym_rmdir] = ACTIONS(3017),
    [anon_sym_readdir] = ACTIONS(3017),
    [anon_sym_readline] = ACTIONS(3017),
    [anon_sym_readpipe] = ACTIONS(3017),
    [anon_sym_rewinddir] = ACTIONS(3017),
    [anon_sym_readlink] = ACTIONS(3017),
    [anon_sym_ref] = ACTIONS(3017),
    [anon_sym_scalar] = ACTIONS(3017),
    [anon_sym_shift] = ACTIONS(3017),
    [anon_sym_sin] = ACTIONS(3017),
    [anon_sym_sleep] = ACTIONS(3017),
    [anon_sym_sqrt] = ACTIONS(3017),
    [anon_sym_srand] = ACTIONS(3017),
    [anon_sym_stat] = ACTIONS(3017),
    [anon_sym_study] = ACTIONS(3017),
    [anon_sym_tell] = ACTIONS(3017),
    [anon_sym_telldir] = ACTIONS(3017),
    [anon_sym_tied] = ACTIONS(3017),
    [anon_sym_uc] = ACTIONS(3017),
    [anon_sym_ucfirst] = ACTIONS(3017),
    [anon_sym_untie] = ACTIONS(3017),
    [anon_sym_umask] = ACTIONS(3017),
    [anon_sym_values] = ACTIONS(3017),
    [anon_sym_write] = ACTIONS(3017),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3017),
    [anon_sym___END__] = ACTIONS(3017),
    [anon_sym_EOT] = ACTIONS(3017),
    [anon_sym_q] = ACTIONS(3017),
    [anon_sym_qq] = ACTIONS(3017),
    [anon_sym_qw] = ACTIONS(3017),
    [anon_sym_qx] = ACTIONS(3017),
    [anon_sym_qr] = ACTIONS(3017),
    [anon_sym_m] = ACTIONS(3017),
    [anon_sym_s] = ACTIONS(3017),
    [anon_sym_tr] = ACTIONS(3017),
    [anon_sym_y] = ACTIONS(3017),
    [anon_sym_if] = ACTIONS(3017),
    [anon_sym_unless] = ACTIONS(3017),
    [anon_sym_while] = ACTIONS(3017),
    [anon_sym_until] = ACTIONS(3017),
    [aux_sym__bareword_token1] = ACTIONS(3017),
    [sym_number] = ACTIONS(3017),
    [sym__apostrophe] = ACTIONS(3015),
    [sym__double_quote] = ACTIONS(3015),
    [sym__backtick] = ACTIONS(3015),
    [sym__search_slash] = ACTIONS(3015),
    [sym__PERLY_HEREDOC] = ACTIONS(3015),
    [sym__ctrl_z_hack] = ACTIONS(3015),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [974] = {
    [sym_heredoc_content] = STATE(974),
    [ts_builtin_sym_end] = ACTIONS(3019),
    [sym__identifier] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3021),
    [anon_sym_LBRACE2] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3021),
    [anon_sym_package] = ACTIONS(3021),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_sub] = ACTIONS(3021),
    [anon_sym_method] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_my] = ACTIONS(3021),
    [anon_sym_state] = ACTIONS(3021),
    [anon_sym_our] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_defer] = ACTIONS(3021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3021),
    [anon_sym_else] = ACTIONS(3021),
    [anon_sym_elsif] = ACTIONS(3021),
    [anon_sym_and] = ACTIONS(3021),
    [anon_sym_or] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_LT_LT] = ACTIONS(3021),
    [anon_sym_SLASH_SLASH] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_STAR] = ACTIONS(3021),
    [anon_sym_eq] = ACTIONS(3021),
    [anon_sym_ne] = ACTIONS(3021),
    [anon_sym_cmp] = ACTIONS(3021),
    [anon_sym_lt] = ACTIONS(3021),
    [anon_sym_le] = ACTIONS(3021),
    [anon_sym_ge] = ACTIONS(3021),
    [anon_sym_gt] = ACTIONS(3021),
    [anon_sym_isa] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3021),
    [anon_sym_DASH_DASH] = ACTIONS(3021),
    [anon_sym_BSLASH] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_eval] = ACTIONS(3021),
    [anon_sym_field] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3021),
    [anon_sym_require] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(3021),
    [anon_sym_grep] = ACTIONS(3021),
    [anon_sym_sort] = ACTIONS(3021),
    [anon_sym_goto] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_undef] = ACTIONS(3021),
    [anon_sym_PERCENT2] = ACTIONS(3021),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3021),
    [anon_sym_no] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_foreach] = ACTIONS(3021),
    [anon_sym_last] = ACTIONS(3021),
    [anon_sym_next] = ACTIONS(3021),
    [anon_sym_redo] = ACTIONS(3021),
    [anon_sym_BEGIN] = ACTIONS(3021),
    [anon_sym_INIT] = ACTIONS(3021),
    [anon_sym_CHECK] = ACTIONS(3021),
    [anon_sym_UNITCHECK] = ACTIONS(3021),
    [anon_sym_END] = ACTIONS(3021),
    [anon_sym_ADJUST] = ACTIONS(3021),
    [anon_sym___FILE__] = ACTIONS(3021),
    [anon_sym___LINE__] = ACTIONS(3021),
    [anon_sym___PACKAGE__] = ACTIONS(3021),
    [anon_sym___SUB__] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_fork] = ACTIONS(3021),
    [anon_sym_getppid] = ACTIONS(3021),
    [anon_sym_time] = ACTIONS(3021),
    [anon_sym_times] = ACTIONS(3021),
    [anon_sym_wait] = ACTIONS(3021),
    [anon_sym_wantarray] = ACTIONS(3021),
    [anon_sym_abs] = ACTIONS(3021),
    [anon_sym_alarm] = ACTIONS(3021),
    [anon_sym_chop] = ACTIONS(3021),
    [anon_sym_chdir] = ACTIONS(3021),
    [anon_sym_close] = ACTIONS(3021),
    [anon_sym_closedir] = ACTIONS(3021),
    [anon_sym_caller] = ACTIONS(3021),
    [anon_sym_chomp] = ACTIONS(3021),
    [anon_sym_chr] = ACTIONS(3021),
    [anon_sym_cos] = ACTIONS(3021),
    [anon_sym_chroot] = ACTIONS(3021),
    [anon_sym_defined] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_dbmclose] = ACTIONS(3021),
    [anon_sym_exists] = ACTIONS(3021),
    [anon_sym_exit] = ACTIONS(3021),
    [anon_sym_eof] = ACTIONS(3021),
    [anon_sym_exp] = ACTIONS(3021),
    [anon_sym_each] = ACTIONS(3021),
    [anon_sym_fc] = ACTIONS(3021),
    [anon_sym_fileno] = ACTIONS(3021),
    [anon_sym_gmtime] = ACTIONS(3021),
    [anon_sym_getc] = ACTIONS(3021),
    [anon_sym_getpgrp] = ACTIONS(3021),
    [anon_sym_getprotobyname] = ACTIONS(3021),
    [anon_sym_getpwname] = ACTIONS(3021),
    [anon_sym_getpwuid] = ACTIONS(3021),
    [anon_sym_getpeername] = ACTIONS(3021),
    [anon_sym_getnetbyname] = ACTIONS(3021),
    [anon_sym_getsockname] = ACTIONS(3021),
    [anon_sym_getgrnam] = ACTIONS(3021),
    [anon_sym_getgrgid] = ACTIONS(3021),
    [anon_sym_hex] = ACTIONS(3021),
    [anon_sym_int] = ACTIONS(3021),
    [anon_sym_keys] = ACTIONS(3021),
    [anon_sym_lc] = ACTIONS(3021),
    [anon_sym_lcfirst] = ACTIONS(3021),
    [anon_sym_length] = ACTIONS(3021),
    [anon_sym_localtime] = ACTIONS(3021),
    [anon_sym_log] = ACTIONS(3021),
    [anon_sym_lock] = ACTIONS(3021),
    [anon_sym_lstat] = ACTIONS(3021),
    [anon_sym_oct] = ACTIONS(3021),
    [anon_sym_ord] = ACTIONS(3021),
    [anon_sym_prototype] = ACTIONS(3021),
    [anon_sym_pop] = ACTIONS(3021),
    [anon_sym_pos] = ACTIONS(3021),
    [anon_sym_quotemeta] = ACTIONS(3021),
    [anon_sym_reset] = ACTIONS(3021),
    [anon_sym_rand] = ACTIONS(3021),
    [anon_sym_rmdir] = ACTIONS(3021),
    [anon_sym_readdir] = ACTIONS(3021),
    [anon_sym_readline] = ACTIONS(3021),
    [anon_sym_readpipe] = ACTIONS(3021),
    [anon_sym_rewinddir] = ACTIONS(3021),
    [anon_sym_readlink] = ACTIONS(3021),
    [anon_sym_ref] = ACTIONS(3021),
    [anon_sym_scalar] = ACTIONS(3021),
    [anon_sym_shift] = ACTIONS(3021),
    [anon_sym_sin] = ACTIONS(3021),
    [anon_sym_sleep] = ACTIONS(3021),
    [anon_sym_sqrt] = ACTIONS(3021),
    [anon_sym_srand] = ACTIONS(3021),
    [anon_sym_stat] = ACTIONS(3021),
    [anon_sym_study] = ACTIONS(3021),
    [anon_sym_tell] = ACTIONS(3021),
    [anon_sym_telldir] = ACTIONS(3021),
    [anon_sym_tied] = ACTIONS(3021),
    [anon_sym_uc] = ACTIONS(3021),
    [anon_sym_ucfirst] = ACTIONS(3021),
    [anon_sym_untie] = ACTIONS(3021),
    [anon_sym_umask] = ACTIONS(3021),
    [anon_sym_values] = ACTIONS(3021),
    [anon_sym_write] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3021),
    [anon_sym___END__] = ACTIONS(3021),
    [anon_sym_EOT] = ACTIONS(3021),
    [anon_sym_q] = ACTIONS(3021),
    [anon_sym_qq] = ACTIONS(3021),
    [anon_sym_qw] = ACTIONS(3021),
    [anon_sym_qx] = ACTIONS(3021),
    [anon_sym_qr] = ACTIONS(3021),
    [anon_sym_m] = ACTIONS(3021),
    [anon_sym_s] = ACTIONS(3021),
    [anon_sym_tr] = ACTIONS(3021),
    [anon_sym_y] = ACTIONS(3021),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_unless] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_until] = ACTIONS(3021),
    [aux_sym__bareword_token1] = ACTIONS(3021),
    [sym_number] = ACTIONS(3021),
    [sym__apostrophe] = ACTIONS(3019),
    [sym__double_quote] = ACTIONS(3019),
    [sym__backtick] = ACTIONS(3019),
    [sym__search_slash] = ACTIONS(3019),
    [sym__PERLY_HEREDOC] = ACTIONS(3019),
    [sym__ctrl_z_hack] = ACTIONS(3019),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [975] = {
    [sym_heredoc_content] = STATE(975),
    [ts_builtin_sym_end] = ACTIONS(3026),
    [sym__identifier] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_LBRACE2] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_package] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_sub] = ACTIONS(3028),
    [anon_sym_method] = ACTIONS(3028),
    [anon_sym_LPAREN] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_my] = ACTIONS(3028),
    [anon_sym_state] = ACTIONS(3028),
    [anon_sym_our] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_defer] = ACTIONS(3028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_else] = ACTIONS(3028),
    [anon_sym_elsif] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3028),
    [anon_sym_or] = ACTIONS(3028),
    [anon_sym_DOLLAR] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_AT] = ACTIONS(3028),
    [anon_sym_LT] = ACTIONS(3028),
    [anon_sym_LT_LT] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_eq] = ACTIONS(3028),
    [anon_sym_ne] = ACTIONS(3028),
    [anon_sym_cmp] = ACTIONS(3028),
    [anon_sym_lt] = ACTIONS(3028),
    [anon_sym_le] = ACTIONS(3028),
    [anon_sym_ge] = ACTIONS(3028),
    [anon_sym_gt] = ACTIONS(3028),
    [anon_sym_isa] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_BSLASH] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_eval] = ACTIONS(3028),
    [anon_sym_field] = ACTIONS(3028),
    [anon_sym_local] = ACTIONS(3028),
    [anon_sym_require] = ACTIONS(3028),
    [anon_sym_map] = ACTIONS(3028),
    [anon_sym_grep] = ACTIONS(3028),
    [anon_sym_sort] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_undef] = ACTIONS(3028),
    [anon_sym_PERCENT2] = ACTIONS(3028),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3028),
    [anon_sym_use] = ACTIONS(3028),
    [anon_sym_no] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_foreach] = ACTIONS(3028),
    [anon_sym_last] = ACTIONS(3028),
    [anon_sym_next] = ACTIONS(3028),
    [anon_sym_redo] = ACTIONS(3028),
    [anon_sym_BEGIN] = ACTIONS(3028),
    [anon_sym_INIT] = ACTIONS(3028),
    [anon_sym_CHECK] = ACTIONS(3028),
    [anon_sym_UNITCHECK] = ACTIONS(3028),
    [anon_sym_END] = ACTIONS(3028),
    [anon_sym_ADJUST] = ACTIONS(3028),
    [anon_sym___FILE__] = ACTIONS(3028),
    [anon_sym___LINE__] = ACTIONS(3028),
    [anon_sym___PACKAGE__] = ACTIONS(3028),
    [anon_sym___SUB__] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_fork] = ACTIONS(3028),
    [anon_sym_getppid] = ACTIONS(3028),
    [anon_sym_time] = ACTIONS(3028),
    [anon_sym_times] = ACTIONS(3028),
    [anon_sym_wait] = ACTIONS(3028),
    [anon_sym_wantarray] = ACTIONS(3028),
    [anon_sym_abs] = ACTIONS(3028),
    [anon_sym_alarm] = ACTIONS(3028),
    [anon_sym_chop] = ACTIONS(3028),
    [anon_sym_chdir] = ACTIONS(3028),
    [anon_sym_close] = ACTIONS(3028),
    [anon_sym_closedir] = ACTIONS(3028),
    [anon_sym_caller] = ACTIONS(3028),
    [anon_sym_chomp] = ACTIONS(3028),
    [anon_sym_chr] = ACTIONS(3028),
    [anon_sym_cos] = ACTIONS(3028),
    [anon_sym_chroot] = ACTIONS(3028),
    [anon_sym_defined] = ACTIONS(3028),
    [anon_sym_delete] = ACTIONS(3028),
    [anon_sym_dbmclose] = ACTIONS(3028),
    [anon_sym_exists] = ACTIONS(3028),
    [anon_sym_exit] = ACTIONS(3028),
    [anon_sym_eof] = ACTIONS(3028),
    [anon_sym_exp] = ACTIONS(3028),
    [anon_sym_each] = ACTIONS(3028),
    [anon_sym_fc] = ACTIONS(3028),
    [anon_sym_fileno] = ACTIONS(3028),
    [anon_sym_gmtime] = ACTIONS(3028),
    [anon_sym_getc] = ACTIONS(3028),
    [anon_sym_getpgrp] = ACTIONS(3028),
    [anon_sym_getprotobyname] = ACTIONS(3028),
    [anon_sym_getpwname] = ACTIONS(3028),
    [anon_sym_getpwuid] = ACTIONS(3028),
    [anon_sym_getpeername] = ACTIONS(3028),
    [anon_sym_getnetbyname] = ACTIONS(3028),
    [anon_sym_getsockname] = ACTIONS(3028),
    [anon_sym_getgrnam] = ACTIONS(3028),
    [anon_sym_getgrgid] = ACTIONS(3028),
    [anon_sym_hex] = ACTIONS(3028),
    [anon_sym_int] = ACTIONS(3028),
    [anon_sym_keys] = ACTIONS(3028),
    [anon_sym_lc] = ACTIONS(3028),
    [anon_sym_lcfirst] = ACTIONS(3028),
    [anon_sym_length] = ACTIONS(3028),
    [anon_sym_localtime] = ACTIONS(3028),
    [anon_sym_log] = ACTIONS(3028),
    [anon_sym_lock] = ACTIONS(3028),
    [anon_sym_lstat] = ACTIONS(3028),
    [anon_sym_oct] = ACTIONS(3028),
    [anon_sym_ord] = ACTIONS(3028),
    [anon_sym_prototype] = ACTIONS(3028),
    [anon_sym_pop] = ACTIONS(3028),
    [anon_sym_pos] = ACTIONS(3028),
    [anon_sym_quotemeta] = ACTIONS(3028),
    [anon_sym_reset] = ACTIONS(3028),
    [anon_sym_rand] = ACTIONS(3028),
    [anon_sym_rmdir] = ACTIONS(3028),
    [anon_sym_readdir] = ACTIONS(3028),
    [anon_sym_readline] = ACTIONS(3028),
    [anon_sym_readpipe] = ACTIONS(3028),
    [anon_sym_rewinddir] = ACTIONS(3028),
    [anon_sym_readlink] = ACTIONS(3028),
    [anon_sym_ref] = ACTIONS(3028),
    [anon_sym_scalar] = ACTIONS(3028),
    [anon_sym_shift] = ACTIONS(3028),
    [anon_sym_sin] = ACTIONS(3028),
    [anon_sym_sleep] = ACTIONS(3028),
    [anon_sym_sqrt] = ACTIONS(3028),
    [anon_sym_srand] = ACTIONS(3028),
    [anon_sym_stat] = ACTIONS(3028),
    [anon_sym_study] = ACTIONS(3028),
    [anon_sym_tell] = ACTIONS(3028),
    [anon_sym_telldir] = ACTIONS(3028),
    [anon_sym_tied] = ACTIONS(3028),
    [anon_sym_uc] = ACTIONS(3028),
    [anon_sym_ucfirst] = ACTIONS(3028),
    [anon_sym_untie] = ACTIONS(3028),
    [anon_sym_umask] = ACTIONS(3028),
    [anon_sym_values] = ACTIONS(3028),
    [anon_sym_write] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3028),
    [anon_sym___END__] = ACTIONS(3028),
    [anon_sym_EOT] = ACTIONS(3028),
    [anon_sym_q] = ACTIONS(3028),
    [anon_sym_qq] = ACTIONS(3028),
    [anon_sym_qw] = ACTIONS(3028),
    [anon_sym_qx] = ACTIONS(3028),
    [anon_sym_qr] = ACTIONS(3028),
    [anon_sym_m] = ACTIONS(3028),
    [anon_sym_s] = ACTIONS(3028),
    [anon_sym_tr] = ACTIONS(3028),
    [anon_sym_y] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_unless] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_until] = ACTIONS(3028),
    [aux_sym__bareword_token1] = ACTIONS(3028),
    [sym_number] = ACTIONS(3028),
    [sym__apostrophe] = ACTIONS(3026),
    [sym__double_quote] = ACTIONS(3026),
    [sym__backtick] = ACTIONS(3026),
    [sym__search_slash] = ACTIONS(3026),
    [sym__PERLY_HEREDOC] = ACTIONS(3026),
    [sym__ctrl_z_hack] = ACTIONS(3026),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [976] = {
    [sym_heredoc_content] = STATE(976),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [sym__identifier] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LBRACE2] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_package] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_sub] = ACTIONS(3032),
    [anon_sym_method] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_my] = ACTIONS(3032),
    [anon_sym_state] = ACTIONS(3032),
    [anon_sym_our] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_defer] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3032),
    [anon_sym_else] = ACTIONS(3032),
    [anon_sym_elsif] = ACTIONS(3032),
    [anon_sym_and] = ACTIONS(3032),
    [anon_sym_or] = ACTIONS(3032),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_AT] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_SLASH_SLASH] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_eq] = ACTIONS(3032),
    [anon_sym_ne] = ACTIONS(3032),
    [anon_sym_cmp] = ACTIONS(3032),
    [anon_sym_lt] = ACTIONS(3032),
    [anon_sym_le] = ACTIONS(3032),
    [anon_sym_ge] = ACTIONS(3032),
    [anon_sym_gt] = ACTIONS(3032),
    [anon_sym_isa] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_BSLASH] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_eval] = ACTIONS(3032),
    [anon_sym_field] = ACTIONS(3032),
    [anon_sym_local] = ACTIONS(3032),
    [anon_sym_require] = ACTIONS(3032),
    [anon_sym_map] = ACTIONS(3032),
    [anon_sym_grep] = ACTIONS(3032),
    [anon_sym_sort] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_undef] = ACTIONS(3032),
    [anon_sym_PERCENT2] = ACTIONS(3032),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_no] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_foreach] = ACTIONS(3032),
    [anon_sym_last] = ACTIONS(3032),
    [anon_sym_next] = ACTIONS(3032),
    [anon_sym_redo] = ACTIONS(3032),
    [anon_sym_BEGIN] = ACTIONS(3032),
    [anon_sym_INIT] = ACTIONS(3032),
    [anon_sym_CHECK] = ACTIONS(3032),
    [anon_sym_UNITCHECK] = ACTIONS(3032),
    [anon_sym_END] = ACTIONS(3032),
    [anon_sym_ADJUST] = ACTIONS(3032),
    [anon_sym___FILE__] = ACTIONS(3032),
    [anon_sym___LINE__] = ACTIONS(3032),
    [anon_sym___PACKAGE__] = ACTIONS(3032),
    [anon_sym___SUB__] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_fork] = ACTIONS(3032),
    [anon_sym_getppid] = ACTIONS(3032),
    [anon_sym_time] = ACTIONS(3032),
    [anon_sym_times] = ACTIONS(3032),
    [anon_sym_wait] = ACTIONS(3032),
    [anon_sym_wantarray] = ACTIONS(3032),
    [anon_sym_abs] = ACTIONS(3032),
    [anon_sym_alarm] = ACTIONS(3032),
    [anon_sym_chop] = ACTIONS(3032),
    [anon_sym_chdir] = ACTIONS(3032),
    [anon_sym_close] = ACTIONS(3032),
    [anon_sym_closedir] = ACTIONS(3032),
    [anon_sym_caller] = ACTIONS(3032),
    [anon_sym_chomp] = ACTIONS(3032),
    [anon_sym_chr] = ACTIONS(3032),
    [anon_sym_cos] = ACTIONS(3032),
    [anon_sym_chroot] = ACTIONS(3032),
    [anon_sym_defined] = ACTIONS(3032),
    [anon_sym_delete] = ACTIONS(3032),
    [anon_sym_dbmclose] = ACTIONS(3032),
    [anon_sym_exists] = ACTIONS(3032),
    [anon_sym_exit] = ACTIONS(3032),
    [anon_sym_eof] = ACTIONS(3032),
    [anon_sym_exp] = ACTIONS(3032),
    [anon_sym_each] = ACTIONS(3032),
    [anon_sym_fc] = ACTIONS(3032),
    [anon_sym_fileno] = ACTIONS(3032),
    [anon_sym_gmtime] = ACTIONS(3032),
    [anon_sym_getc] = ACTIONS(3032),
    [anon_sym_getpgrp] = ACTIONS(3032),
    [anon_sym_getprotobyname] = ACTIONS(3032),
    [anon_sym_getpwname] = ACTIONS(3032),
    [anon_sym_getpwuid] = ACTIONS(3032),
    [anon_sym_getpeername] = ACTIONS(3032),
    [anon_sym_getnetbyname] = ACTIONS(3032),
    [anon_sym_getsockname] = ACTIONS(3032),
    [anon_sym_getgrnam] = ACTIONS(3032),
    [anon_sym_getgrgid] = ACTIONS(3032),
    [anon_sym_hex] = ACTIONS(3032),
    [anon_sym_int] = ACTIONS(3032),
    [anon_sym_keys] = ACTIONS(3032),
    [anon_sym_lc] = ACTIONS(3032),
    [anon_sym_lcfirst] = ACTIONS(3032),
    [anon_sym_length] = ACTIONS(3032),
    [anon_sym_localtime] = ACTIONS(3032),
    [anon_sym_log] = ACTIONS(3032),
    [anon_sym_lock] = ACTIONS(3032),
    [anon_sym_lstat] = ACTIONS(3032),
    [anon_sym_oct] = ACTIONS(3032),
    [anon_sym_ord] = ACTIONS(3032),
    [anon_sym_prototype] = ACTIONS(3032),
    [anon_sym_pop] = ACTIONS(3032),
    [anon_sym_pos] = ACTIONS(3032),
    [anon_sym_quotemeta] = ACTIONS(3032),
    [anon_sym_reset] = ACTIONS(3032),
    [anon_sym_rand] = ACTIONS(3032),
    [anon_sym_rmdir] = ACTIONS(3032),
    [anon_sym_readdir] = ACTIONS(3032),
    [anon_sym_readline] = ACTIONS(3032),
    [anon_sym_readpipe] = ACTIONS(3032),
    [anon_sym_rewinddir] = ACTIONS(3032),
    [anon_sym_readlink] = ACTIONS(3032),
    [anon_sym_ref] = ACTIONS(3032),
    [anon_sym_scalar] = ACTIONS(3032),
    [anon_sym_shift] = ACTIONS(3032),
    [anon_sym_sin] = ACTIONS(3032),
    [anon_sym_sleep] = ACTIONS(3032),
    [anon_sym_sqrt] = ACTIONS(3032),
    [anon_sym_srand] = ACTIONS(3032),
    [anon_sym_stat] = ACTIONS(3032),
    [anon_sym_study] = ACTIONS(3032),
    [anon_sym_tell] = ACTIONS(3032),
    [anon_sym_telldir] = ACTIONS(3032),
    [anon_sym_tied] = ACTIONS(3032),
    [anon_sym_uc] = ACTIONS(3032),
    [anon_sym_ucfirst] = ACTIONS(3032),
    [anon_sym_untie] = ACTIONS(3032),
    [anon_sym_umask] = ACTIONS(3032),
    [anon_sym_values] = ACTIONS(3032),
    [anon_sym_write] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3032),
    [anon_sym___END__] = ACTIONS(3032),
    [anon_sym_EOT] = ACTIONS(3032),
    [anon_sym_q] = ACTIONS(3032),
    [anon_sym_qq] = ACTIONS(3032),
    [anon_sym_qw] = ACTIONS(3032),
    [anon_sym_qx] = ACTIONS(3032),
    [anon_sym_qr] = ACTIONS(3032),
    [anon_sym_m] = ACTIONS(3032),
    [anon_sym_s] = ACTIONS(3032),
    [anon_sym_tr] = ACTIONS(3032),
    [anon_sym_y] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_unless] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_until] = ACTIONS(3032),
    [aux_sym__bareword_token1] = ACTIONS(3032),
    [sym_number] = ACTIONS(3032),
    [sym__apostrophe] = ACTIONS(3030),
    [sym__double_quote] = ACTIONS(3030),
    [sym__backtick] = ACTIONS(3030),
    [sym__search_slash] = ACTIONS(3030),
    [sym__PERLY_HEREDOC] = ACTIONS(3030),
    [sym__ctrl_z_hack] = ACTIONS(3030),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [977] = {
    [sym_heredoc_content] = STATE(977),
    [ts_builtin_sym_end] = ACTIONS(3034),
    [sym__identifier] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_LBRACE2] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym_package] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_sub] = ACTIONS(3036),
    [anon_sym_method] = ACTIONS(3036),
    [anon_sym_LPAREN] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_my] = ACTIONS(3036),
    [anon_sym_state] = ACTIONS(3036),
    [anon_sym_our] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_defer] = ACTIONS(3036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3036),
    [anon_sym_else] = ACTIONS(3036),
    [anon_sym_elsif] = ACTIONS(3036),
    [anon_sym_and] = ACTIONS(3036),
    [anon_sym_or] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_AT] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3036),
    [anon_sym_SLASH_SLASH] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_eq] = ACTIONS(3036),
    [anon_sym_ne] = ACTIONS(3036),
    [anon_sym_cmp] = ACTIONS(3036),
    [anon_sym_lt] = ACTIONS(3036),
    [anon_sym_le] = ACTIONS(3036),
    [anon_sym_ge] = ACTIONS(3036),
    [anon_sym_gt] = ACTIONS(3036),
    [anon_sym_isa] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_BSLASH] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_eval] = ACTIONS(3036),
    [anon_sym_field] = ACTIONS(3036),
    [anon_sym_local] = ACTIONS(3036),
    [anon_sym_require] = ACTIONS(3036),
    [anon_sym_map] = ACTIONS(3036),
    [anon_sym_grep] = ACTIONS(3036),
    [anon_sym_sort] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_undef] = ACTIONS(3036),
    [anon_sym_PERCENT2] = ACTIONS(3036),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3036),
    [anon_sym_use] = ACTIONS(3036),
    [anon_sym_no] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_foreach] = ACTIONS(3036),
    [anon_sym_last] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3036),
    [anon_sym_redo] = ACTIONS(3036),
    [anon_sym_BEGIN] = ACTIONS(3036),
    [anon_sym_INIT] = ACTIONS(3036),
    [anon_sym_CHECK] = ACTIONS(3036),
    [anon_sym_UNITCHECK] = ACTIONS(3036),
    [anon_sym_END] = ACTIONS(3036),
    [anon_sym_ADJUST] = ACTIONS(3036),
    [anon_sym___FILE__] = ACTIONS(3036),
    [anon_sym___LINE__] = ACTIONS(3036),
    [anon_sym___PACKAGE__] = ACTIONS(3036),
    [anon_sym___SUB__] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_fork] = ACTIONS(3036),
    [anon_sym_getppid] = ACTIONS(3036),
    [anon_sym_time] = ACTIONS(3036),
    [anon_sym_times] = ACTIONS(3036),
    [anon_sym_wait] = ACTIONS(3036),
    [anon_sym_wantarray] = ACTIONS(3036),
    [anon_sym_abs] = ACTIONS(3036),
    [anon_sym_alarm] = ACTIONS(3036),
    [anon_sym_chop] = ACTIONS(3036),
    [anon_sym_chdir] = ACTIONS(3036),
    [anon_sym_close] = ACTIONS(3036),
    [anon_sym_closedir] = ACTIONS(3036),
    [anon_sym_caller] = ACTIONS(3036),
    [anon_sym_chomp] = ACTIONS(3036),
    [anon_sym_chr] = ACTIONS(3036),
    [anon_sym_cos] = ACTIONS(3036),
    [anon_sym_chroot] = ACTIONS(3036),
    [anon_sym_defined] = ACTIONS(3036),
    [anon_sym_delete] = ACTIONS(3036),
    [anon_sym_dbmclose] = ACTIONS(3036),
    [anon_sym_exists] = ACTIONS(3036),
    [anon_sym_exit] = ACTIONS(3036),
    [anon_sym_eof] = ACTIONS(3036),
    [anon_sym_exp] = ACTIONS(3036),
    [anon_sym_each] = ACTIONS(3036),
    [anon_sym_fc] = ACTIONS(3036),
    [anon_sym_fileno] = ACTIONS(3036),
    [anon_sym_gmtime] = ACTIONS(3036),
    [anon_sym_getc] = ACTIONS(3036),
    [anon_sym_getpgrp] = ACTIONS(3036),
    [anon_sym_getprotobyname] = ACTIONS(3036),
    [anon_sym_getpwname] = ACTIONS(3036),
    [anon_sym_getpwuid] = ACTIONS(3036),
    [anon_sym_getpeername] = ACTIONS(3036),
    [anon_sym_getnetbyname] = ACTIONS(3036),
    [anon_sym_getsockname] = ACTIONS(3036),
    [anon_sym_getgrnam] = ACTIONS(3036),
    [anon_sym_getgrgid] = ACTIONS(3036),
    [anon_sym_hex] = ACTIONS(3036),
    [anon_sym_int] = ACTIONS(3036),
    [anon_sym_keys] = ACTIONS(3036),
    [anon_sym_lc] = ACTIONS(3036),
    [anon_sym_lcfirst] = ACTIONS(3036),
    [anon_sym_length] = ACTIONS(3036),
    [anon_sym_localtime] = ACTIONS(3036),
    [anon_sym_log] = ACTIONS(3036),
    [anon_sym_lock] = ACTIONS(3036),
    [anon_sym_lstat] = ACTIONS(3036),
    [anon_sym_oct] = ACTIONS(3036),
    [anon_sym_ord] = ACTIONS(3036),
    [anon_sym_prototype] = ACTIONS(3036),
    [anon_sym_pop] = ACTIONS(3036),
    [anon_sym_pos] = ACTIONS(3036),
    [anon_sym_quotemeta] = ACTIONS(3036),
    [anon_sym_reset] = ACTIONS(3036),
    [anon_sym_rand] = ACTIONS(3036),
    [anon_sym_rmdir] = ACTIONS(3036),
    [anon_sym_readdir] = ACTIONS(3036),
    [anon_sym_readline] = ACTIONS(3036),
    [anon_sym_readpipe] = ACTIONS(3036),
    [anon_sym_rewinddir] = ACTIONS(3036),
    [anon_sym_readlink] = ACTIONS(3036),
    [anon_sym_ref] = ACTIONS(3036),
    [anon_sym_scalar] = ACTIONS(3036),
    [anon_sym_shift] = ACTIONS(3036),
    [anon_sym_sin] = ACTIONS(3036),
    [anon_sym_sleep] = ACTIONS(3036),
    [anon_sym_sqrt] = ACTIONS(3036),
    [anon_sym_srand] = ACTIONS(3036),
    [anon_sym_stat] = ACTIONS(3036),
    [anon_sym_study] = ACTIONS(3036),
    [anon_sym_tell] = ACTIONS(3036),
    [anon_sym_telldir] = ACTIONS(3036),
    [anon_sym_tied] = ACTIONS(3036),
    [anon_sym_uc] = ACTIONS(3036),
    [anon_sym_ucfirst] = ACTIONS(3036),
    [anon_sym_untie] = ACTIONS(3036),
    [anon_sym_umask] = ACTIONS(3036),
    [anon_sym_values] = ACTIONS(3036),
    [anon_sym_write] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3036),
    [anon_sym___END__] = ACTIONS(3036),
    [anon_sym_EOT] = ACTIONS(3036),
    [anon_sym_q] = ACTIONS(3036),
    [anon_sym_qq] = ACTIONS(3036),
    [anon_sym_qw] = ACTIONS(3036),
    [anon_sym_qx] = ACTIONS(3036),
    [anon_sym_qr] = ACTIONS(3036),
    [anon_sym_m] = ACTIONS(3036),
    [anon_sym_s] = ACTIONS(3036),
    [anon_sym_tr] = ACTIONS(3036),
    [anon_sym_y] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_unless] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_until] = ACTIONS(3036),
    [aux_sym__bareword_token1] = ACTIONS(3036),
    [sym_number] = ACTIONS(3036),
    [sym__apostrophe] = ACTIONS(3034),
    [sym__double_quote] = ACTIONS(3034),
    [sym__backtick] = ACTIONS(3034),
    [sym__search_slash] = ACTIONS(3034),
    [sym__PERLY_HEREDOC] = ACTIONS(3034),
    [sym__ctrl_z_hack] = ACTIONS(3034),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [978] = {
    [sym_heredoc_content] = STATE(978),
    [ts_builtin_sym_end] = ACTIONS(3038),
    [sym__identifier] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_LBRACE2] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym_package] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_sub] = ACTIONS(3040),
    [anon_sym_method] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_my] = ACTIONS(3040),
    [anon_sym_state] = ACTIONS(3040),
    [anon_sym_our] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_defer] = ACTIONS(3040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_else] = ACTIONS(3040),
    [anon_sym_elsif] = ACTIONS(3040),
    [anon_sym_and] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_AT] = ACTIONS(3040),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3040),
    [anon_sym_SLASH_SLASH] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_eq] = ACTIONS(3040),
    [anon_sym_ne] = ACTIONS(3040),
    [anon_sym_cmp] = ACTIONS(3040),
    [anon_sym_lt] = ACTIONS(3040),
    [anon_sym_le] = ACTIONS(3040),
    [anon_sym_ge] = ACTIONS(3040),
    [anon_sym_gt] = ACTIONS(3040),
    [anon_sym_isa] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_BSLASH] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_eval] = ACTIONS(3040),
    [anon_sym_field] = ACTIONS(3040),
    [anon_sym_local] = ACTIONS(3040),
    [anon_sym_require] = ACTIONS(3040),
    [anon_sym_map] = ACTIONS(3040),
    [anon_sym_grep] = ACTIONS(3040),
    [anon_sym_sort] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_undef] = ACTIONS(3040),
    [anon_sym_PERCENT2] = ACTIONS(3040),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3040),
    [anon_sym_use] = ACTIONS(3040),
    [anon_sym_no] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_foreach] = ACTIONS(3040),
    [anon_sym_last] = ACTIONS(3040),
    [anon_sym_next] = ACTIONS(3040),
    [anon_sym_redo] = ACTIONS(3040),
    [anon_sym_BEGIN] = ACTIONS(3040),
    [anon_sym_INIT] = ACTIONS(3040),
    [anon_sym_CHECK] = ACTIONS(3040),
    [anon_sym_UNITCHECK] = ACTIONS(3040),
    [anon_sym_END] = ACTIONS(3040),
    [anon_sym_ADJUST] = ACTIONS(3040),
    [anon_sym___FILE__] = ACTIONS(3040),
    [anon_sym___LINE__] = ACTIONS(3040),
    [anon_sym___PACKAGE__] = ACTIONS(3040),
    [anon_sym___SUB__] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_fork] = ACTIONS(3040),
    [anon_sym_getppid] = ACTIONS(3040),
    [anon_sym_time] = ACTIONS(3040),
    [anon_sym_times] = ACTIONS(3040),
    [anon_sym_wait] = ACTIONS(3040),
    [anon_sym_wantarray] = ACTIONS(3040),
    [anon_sym_abs] = ACTIONS(3040),
    [anon_sym_alarm] = ACTIONS(3040),
    [anon_sym_chop] = ACTIONS(3040),
    [anon_sym_chdir] = ACTIONS(3040),
    [anon_sym_close] = ACTIONS(3040),
    [anon_sym_closedir] = ACTIONS(3040),
    [anon_sym_caller] = ACTIONS(3040),
    [anon_sym_chomp] = ACTIONS(3040),
    [anon_sym_chr] = ACTIONS(3040),
    [anon_sym_cos] = ACTIONS(3040),
    [anon_sym_chroot] = ACTIONS(3040),
    [anon_sym_defined] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3040),
    [anon_sym_dbmclose] = ACTIONS(3040),
    [anon_sym_exists] = ACTIONS(3040),
    [anon_sym_exit] = ACTIONS(3040),
    [anon_sym_eof] = ACTIONS(3040),
    [anon_sym_exp] = ACTIONS(3040),
    [anon_sym_each] = ACTIONS(3040),
    [anon_sym_fc] = ACTIONS(3040),
    [anon_sym_fileno] = ACTIONS(3040),
    [anon_sym_gmtime] = ACTIONS(3040),
    [anon_sym_getc] = ACTIONS(3040),
    [anon_sym_getpgrp] = ACTIONS(3040),
    [anon_sym_getprotobyname] = ACTIONS(3040),
    [anon_sym_getpwname] = ACTIONS(3040),
    [anon_sym_getpwuid] = ACTIONS(3040),
    [anon_sym_getpeername] = ACTIONS(3040),
    [anon_sym_getnetbyname] = ACTIONS(3040),
    [anon_sym_getsockname] = ACTIONS(3040),
    [anon_sym_getgrnam] = ACTIONS(3040),
    [anon_sym_getgrgid] = ACTIONS(3040),
    [anon_sym_hex] = ACTIONS(3040),
    [anon_sym_int] = ACTIONS(3040),
    [anon_sym_keys] = ACTIONS(3040),
    [anon_sym_lc] = ACTIONS(3040),
    [anon_sym_lcfirst] = ACTIONS(3040),
    [anon_sym_length] = ACTIONS(3040),
    [anon_sym_localtime] = ACTIONS(3040),
    [anon_sym_log] = ACTIONS(3040),
    [anon_sym_lock] = ACTIONS(3040),
    [anon_sym_lstat] = ACTIONS(3040),
    [anon_sym_oct] = ACTIONS(3040),
    [anon_sym_ord] = ACTIONS(3040),
    [anon_sym_prototype] = ACTIONS(3040),
    [anon_sym_pop] = ACTIONS(3040),
    [anon_sym_pos] = ACTIONS(3040),
    [anon_sym_quotemeta] = ACTIONS(3040),
    [anon_sym_reset] = ACTIONS(3040),
    [anon_sym_rand] = ACTIONS(3040),
    [anon_sym_rmdir] = ACTIONS(3040),
    [anon_sym_readdir] = ACTIONS(3040),
    [anon_sym_readline] = ACTIONS(3040),
    [anon_sym_readpipe] = ACTIONS(3040),
    [anon_sym_rewinddir] = ACTIONS(3040),
    [anon_sym_readlink] = ACTIONS(3040),
    [anon_sym_ref] = ACTIONS(3040),
    [anon_sym_scalar] = ACTIONS(3040),
    [anon_sym_shift] = ACTIONS(3040),
    [anon_sym_sin] = ACTIONS(3040),
    [anon_sym_sleep] = ACTIONS(3040),
    [anon_sym_sqrt] = ACTIONS(3040),
    [anon_sym_srand] = ACTIONS(3040),
    [anon_sym_stat] = ACTIONS(3040),
    [anon_sym_study] = ACTIONS(3040),
    [anon_sym_tell] = ACTIONS(3040),
    [anon_sym_telldir] = ACTIONS(3040),
    [anon_sym_tied] = ACTIONS(3040),
    [anon_sym_uc] = ACTIONS(3040),
    [anon_sym_ucfirst] = ACTIONS(3040),
    [anon_sym_untie] = ACTIONS(3040),
    [anon_sym_umask] = ACTIONS(3040),
    [anon_sym_values] = ACTIONS(3040),
    [anon_sym_write] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3040),
    [anon_sym___END__] = ACTIONS(3040),
    [anon_sym_EOT] = ACTIONS(3040),
    [anon_sym_q] = ACTIONS(3040),
    [anon_sym_qq] = ACTIONS(3040),
    [anon_sym_qw] = ACTIONS(3040),
    [anon_sym_qx] = ACTIONS(3040),
    [anon_sym_qr] = ACTIONS(3040),
    [anon_sym_m] = ACTIONS(3040),
    [anon_sym_s] = ACTIONS(3040),
    [anon_sym_tr] = ACTIONS(3040),
    [anon_sym_y] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_unless] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_until] = ACTIONS(3040),
    [aux_sym__bareword_token1] = ACTIONS(3040),
    [sym_number] = ACTIONS(3040),
    [sym__apostrophe] = ACTIONS(3038),
    [sym__double_quote] = ACTIONS(3038),
    [sym__backtick] = ACTIONS(3038),
    [sym__search_slash] = ACTIONS(3038),
    [sym__PERLY_HEREDOC] = ACTIONS(3038),
    [sym__ctrl_z_hack] = ACTIONS(3038),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [979] = {
    [sym_heredoc_content] = STATE(979),
    [ts_builtin_sym_end] = ACTIONS(3042),
    [sym__identifier] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_LBRACE2] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym_package] = ACTIONS(3044),
    [anon_sym_class] = ACTIONS(3044),
    [anon_sym_sub] = ACTIONS(3044),
    [anon_sym_method] = ACTIONS(3044),
    [anon_sym_LPAREN] = ACTIONS(3044),
    [anon_sym_continue] = ACTIONS(3044),
    [anon_sym_my] = ACTIONS(3044),
    [anon_sym_state] = ACTIONS(3044),
    [anon_sym_our] = ACTIONS(3044),
    [anon_sym_try] = ACTIONS(3044),
    [anon_sym_defer] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3044),
    [anon_sym_else] = ACTIONS(3044),
    [anon_sym_elsif] = ACTIONS(3044),
    [anon_sym_and] = ACTIONS(3044),
    [anon_sym_or] = ACTIONS(3044),
    [anon_sym_DOLLAR] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_AT] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_LT_LT] = ACTIONS(3044),
    [anon_sym_SLASH_SLASH] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_eq] = ACTIONS(3044),
    [anon_sym_ne] = ACTIONS(3044),
    [anon_sym_cmp] = ACTIONS(3044),
    [anon_sym_lt] = ACTIONS(3044),
    [anon_sym_le] = ACTIONS(3044),
    [anon_sym_ge] = ACTIONS(3044),
    [anon_sym_gt] = ACTIONS(3044),
    [anon_sym_isa] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_BSLASH] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3044),
    [anon_sym_eval] = ACTIONS(3044),
    [anon_sym_field] = ACTIONS(3044),
    [anon_sym_local] = ACTIONS(3044),
    [anon_sym_require] = ACTIONS(3044),
    [anon_sym_map] = ACTIONS(3044),
    [anon_sym_grep] = ACTIONS(3044),
    [anon_sym_sort] = ACTIONS(3044),
    [anon_sym_goto] = ACTIONS(3044),
    [anon_sym_return] = ACTIONS(3044),
    [anon_sym_undef] = ACTIONS(3044),
    [anon_sym_PERCENT2] = ACTIONS(3044),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3044),
    [anon_sym_use] = ACTIONS(3044),
    [anon_sym_no] = ACTIONS(3044),
    [anon_sym_for] = ACTIONS(3044),
    [anon_sym_foreach] = ACTIONS(3044),
    [anon_sym_last] = ACTIONS(3044),
    [anon_sym_next] = ACTIONS(3044),
    [anon_sym_redo] = ACTIONS(3044),
    [anon_sym_BEGIN] = ACTIONS(3044),
    [anon_sym_INIT] = ACTIONS(3044),
    [anon_sym_CHECK] = ACTIONS(3044),
    [anon_sym_UNITCHECK] = ACTIONS(3044),
    [anon_sym_END] = ACTIONS(3044),
    [anon_sym_ADJUST] = ACTIONS(3044),
    [anon_sym___FILE__] = ACTIONS(3044),
    [anon_sym___LINE__] = ACTIONS(3044),
    [anon_sym___PACKAGE__] = ACTIONS(3044),
    [anon_sym___SUB__] = ACTIONS(3044),
    [anon_sym_break] = ACTIONS(3044),
    [anon_sym_fork] = ACTIONS(3044),
    [anon_sym_getppid] = ACTIONS(3044),
    [anon_sym_time] = ACTIONS(3044),
    [anon_sym_times] = ACTIONS(3044),
    [anon_sym_wait] = ACTIONS(3044),
    [anon_sym_wantarray] = ACTIONS(3044),
    [anon_sym_abs] = ACTIONS(3044),
    [anon_sym_alarm] = ACTIONS(3044),
    [anon_sym_chop] = ACTIONS(3044),
    [anon_sym_chdir] = ACTIONS(3044),
    [anon_sym_close] = ACTIONS(3044),
    [anon_sym_closedir] = ACTIONS(3044),
    [anon_sym_caller] = ACTIONS(3044),
    [anon_sym_chomp] = ACTIONS(3044),
    [anon_sym_chr] = ACTIONS(3044),
    [anon_sym_cos] = ACTIONS(3044),
    [anon_sym_chroot] = ACTIONS(3044),
    [anon_sym_defined] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3044),
    [anon_sym_dbmclose] = ACTIONS(3044),
    [anon_sym_exists] = ACTIONS(3044),
    [anon_sym_exit] = ACTIONS(3044),
    [anon_sym_eof] = ACTIONS(3044),
    [anon_sym_exp] = ACTIONS(3044),
    [anon_sym_each] = ACTIONS(3044),
    [anon_sym_fc] = ACTIONS(3044),
    [anon_sym_fileno] = ACTIONS(3044),
    [anon_sym_gmtime] = ACTIONS(3044),
    [anon_sym_getc] = ACTIONS(3044),
    [anon_sym_getpgrp] = ACTIONS(3044),
    [anon_sym_getprotobyname] = ACTIONS(3044),
    [anon_sym_getpwname] = ACTIONS(3044),
    [anon_sym_getpwuid] = ACTIONS(3044),
    [anon_sym_getpeername] = ACTIONS(3044),
    [anon_sym_getnetbyname] = ACTIONS(3044),
    [anon_sym_getsockname] = ACTIONS(3044),
    [anon_sym_getgrnam] = ACTIONS(3044),
    [anon_sym_getgrgid] = ACTIONS(3044),
    [anon_sym_hex] = ACTIONS(3044),
    [anon_sym_int] = ACTIONS(3044),
    [anon_sym_keys] = ACTIONS(3044),
    [anon_sym_lc] = ACTIONS(3044),
    [anon_sym_lcfirst] = ACTIONS(3044),
    [anon_sym_length] = ACTIONS(3044),
    [anon_sym_localtime] = ACTIONS(3044),
    [anon_sym_log] = ACTIONS(3044),
    [anon_sym_lock] = ACTIONS(3044),
    [anon_sym_lstat] = ACTIONS(3044),
    [anon_sym_oct] = ACTIONS(3044),
    [anon_sym_ord] = ACTIONS(3044),
    [anon_sym_prototype] = ACTIONS(3044),
    [anon_sym_pop] = ACTIONS(3044),
    [anon_sym_pos] = ACTIONS(3044),
    [anon_sym_quotemeta] = ACTIONS(3044),
    [anon_sym_reset] = ACTIONS(3044),
    [anon_sym_rand] = ACTIONS(3044),
    [anon_sym_rmdir] = ACTIONS(3044),
    [anon_sym_readdir] = ACTIONS(3044),
    [anon_sym_readline] = ACTIONS(3044),
    [anon_sym_readpipe] = ACTIONS(3044),
    [anon_sym_rewinddir] = ACTIONS(3044),
    [anon_sym_readlink] = ACTIONS(3044),
    [anon_sym_ref] = ACTIONS(3044),
    [anon_sym_scalar] = ACTIONS(3044),
    [anon_sym_shift] = ACTIONS(3044),
    [anon_sym_sin] = ACTIONS(3044),
    [anon_sym_sleep] = ACTIONS(3044),
    [anon_sym_sqrt] = ACTIONS(3044),
    [anon_sym_srand] = ACTIONS(3044),
    [anon_sym_stat] = ACTIONS(3044),
    [anon_sym_study] = ACTIONS(3044),
    [anon_sym_tell] = ACTIONS(3044),
    [anon_sym_telldir] = ACTIONS(3044),
    [anon_sym_tied] = ACTIONS(3044),
    [anon_sym_uc] = ACTIONS(3044),
    [anon_sym_ucfirst] = ACTIONS(3044),
    [anon_sym_untie] = ACTIONS(3044),
    [anon_sym_umask] = ACTIONS(3044),
    [anon_sym_values] = ACTIONS(3044),
    [anon_sym_write] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3044),
    [anon_sym___END__] = ACTIONS(3044),
    [anon_sym_EOT] = ACTIONS(3044),
    [anon_sym_q] = ACTIONS(3044),
    [anon_sym_qq] = ACTIONS(3044),
    [anon_sym_qw] = ACTIONS(3044),
    [anon_sym_qx] = ACTIONS(3044),
    [anon_sym_qr] = ACTIONS(3044),
    [anon_sym_m] = ACTIONS(3044),
    [anon_sym_s] = ACTIONS(3044),
    [anon_sym_tr] = ACTIONS(3044),
    [anon_sym_y] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_unless] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_until] = ACTIONS(3044),
    [aux_sym__bareword_token1] = ACTIONS(3044),
    [sym_number] = ACTIONS(3044),
    [sym__apostrophe] = ACTIONS(3042),
    [sym__double_quote] = ACTIONS(3042),
    [sym__backtick] = ACTIONS(3042),
    [sym__search_slash] = ACTIONS(3042),
    [sym__PERLY_HEREDOC] = ACTIONS(3042),
    [sym__ctrl_z_hack] = ACTIONS(3042),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [980] = {
    [sym_heredoc_content] = STATE(980),
    [ts_builtin_sym_end] = ACTIONS(3046),
    [sym__identifier] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_LBRACE2] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_package] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_sub] = ACTIONS(3048),
    [anon_sym_method] = ACTIONS(3048),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_my] = ACTIONS(3048),
    [anon_sym_state] = ACTIONS(3048),
    [anon_sym_our] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_defer] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3048),
    [anon_sym_else] = ACTIONS(3048),
    [anon_sym_elsif] = ACTIONS(3048),
    [anon_sym_and] = ACTIONS(3048),
    [anon_sym_or] = ACTIONS(3048),
    [anon_sym_DOLLAR] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_AT] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_SLASH_SLASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_eq] = ACTIONS(3048),
    [anon_sym_ne] = ACTIONS(3048),
    [anon_sym_cmp] = ACTIONS(3048),
    [anon_sym_lt] = ACTIONS(3048),
    [anon_sym_le] = ACTIONS(3048),
    [anon_sym_ge] = ACTIONS(3048),
    [anon_sym_gt] = ACTIONS(3048),
    [anon_sym_isa] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_BSLASH] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_eval] = ACTIONS(3048),
    [anon_sym_field] = ACTIONS(3048),
    [anon_sym_local] = ACTIONS(3048),
    [anon_sym_require] = ACTIONS(3048),
    [anon_sym_map] = ACTIONS(3048),
    [anon_sym_grep] = ACTIONS(3048),
    [anon_sym_sort] = ACTIONS(3048),
    [anon_sym_goto] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_undef] = ACTIONS(3048),
    [anon_sym_PERCENT2] = ACTIONS(3048),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3048),
    [anon_sym_use] = ACTIONS(3048),
    [anon_sym_no] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_foreach] = ACTIONS(3048),
    [anon_sym_last] = ACTIONS(3048),
    [anon_sym_next] = ACTIONS(3048),
    [anon_sym_redo] = ACTIONS(3048),
    [anon_sym_BEGIN] = ACTIONS(3048),
    [anon_sym_INIT] = ACTIONS(3048),
    [anon_sym_CHECK] = ACTIONS(3048),
    [anon_sym_UNITCHECK] = ACTIONS(3048),
    [anon_sym_END] = ACTIONS(3048),
    [anon_sym_ADJUST] = ACTIONS(3048),
    [anon_sym___FILE__] = ACTIONS(3048),
    [anon_sym___LINE__] = ACTIONS(3048),
    [anon_sym___PACKAGE__] = ACTIONS(3048),
    [anon_sym___SUB__] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_fork] = ACTIONS(3048),
    [anon_sym_getppid] = ACTIONS(3048),
    [anon_sym_time] = ACTIONS(3048),
    [anon_sym_times] = ACTIONS(3048),
    [anon_sym_wait] = ACTIONS(3048),
    [anon_sym_wantarray] = ACTIONS(3048),
    [anon_sym_abs] = ACTIONS(3048),
    [anon_sym_alarm] = ACTIONS(3048),
    [anon_sym_chop] = ACTIONS(3048),
    [anon_sym_chdir] = ACTIONS(3048),
    [anon_sym_close] = ACTIONS(3048),
    [anon_sym_closedir] = ACTIONS(3048),
    [anon_sym_caller] = ACTIONS(3048),
    [anon_sym_chomp] = ACTIONS(3048),
    [anon_sym_chr] = ACTIONS(3048),
    [anon_sym_cos] = ACTIONS(3048),
    [anon_sym_chroot] = ACTIONS(3048),
    [anon_sym_defined] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_dbmclose] = ACTIONS(3048),
    [anon_sym_exists] = ACTIONS(3048),
    [anon_sym_exit] = ACTIONS(3048),
    [anon_sym_eof] = ACTIONS(3048),
    [anon_sym_exp] = ACTIONS(3048),
    [anon_sym_each] = ACTIONS(3048),
    [anon_sym_fc] = ACTIONS(3048),
    [anon_sym_fileno] = ACTIONS(3048),
    [anon_sym_gmtime] = ACTIONS(3048),
    [anon_sym_getc] = ACTIONS(3048),
    [anon_sym_getpgrp] = ACTIONS(3048),
    [anon_sym_getprotobyname] = ACTIONS(3048),
    [anon_sym_getpwname] = ACTIONS(3048),
    [anon_sym_getpwuid] = ACTIONS(3048),
    [anon_sym_getpeername] = ACTIONS(3048),
    [anon_sym_getnetbyname] = ACTIONS(3048),
    [anon_sym_getsockname] = ACTIONS(3048),
    [anon_sym_getgrnam] = ACTIONS(3048),
    [anon_sym_getgrgid] = ACTIONS(3048),
    [anon_sym_hex] = ACTIONS(3048),
    [anon_sym_int] = ACTIONS(3048),
    [anon_sym_keys] = ACTIONS(3048),
    [anon_sym_lc] = ACTIONS(3048),
    [anon_sym_lcfirst] = ACTIONS(3048),
    [anon_sym_length] = ACTIONS(3048),
    [anon_sym_localtime] = ACTIONS(3048),
    [anon_sym_log] = ACTIONS(3048),
    [anon_sym_lock] = ACTIONS(3048),
    [anon_sym_lstat] = ACTIONS(3048),
    [anon_sym_oct] = ACTIONS(3048),
    [anon_sym_ord] = ACTIONS(3048),
    [anon_sym_prototype] = ACTIONS(3048),
    [anon_sym_pop] = ACTIONS(3048),
    [anon_sym_pos] = ACTIONS(3048),
    [anon_sym_quotemeta] = ACTIONS(3048),
    [anon_sym_reset] = ACTIONS(3048),
    [anon_sym_rand] = ACTIONS(3048),
    [anon_sym_rmdir] = ACTIONS(3048),
    [anon_sym_readdir] = ACTIONS(3048),
    [anon_sym_readline] = ACTIONS(3048),
    [anon_sym_readpipe] = ACTIONS(3048),
    [anon_sym_rewinddir] = ACTIONS(3048),
    [anon_sym_readlink] = ACTIONS(3048),
    [anon_sym_ref] = ACTIONS(3048),
    [anon_sym_scalar] = ACTIONS(3048),
    [anon_sym_shift] = ACTIONS(3048),
    [anon_sym_sin] = ACTIONS(3048),
    [anon_sym_sleep] = ACTIONS(3048),
    [anon_sym_sqrt] = ACTIONS(3048),
    [anon_sym_srand] = ACTIONS(3048),
    [anon_sym_stat] = ACTIONS(3048),
    [anon_sym_study] = ACTIONS(3048),
    [anon_sym_tell] = ACTIONS(3048),
    [anon_sym_telldir] = ACTIONS(3048),
    [anon_sym_tied] = ACTIONS(3048),
    [anon_sym_uc] = ACTIONS(3048),
    [anon_sym_ucfirst] = ACTIONS(3048),
    [anon_sym_untie] = ACTIONS(3048),
    [anon_sym_umask] = ACTIONS(3048),
    [anon_sym_values] = ACTIONS(3048),
    [anon_sym_write] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3048),
    [anon_sym___END__] = ACTIONS(3048),
    [anon_sym_EOT] = ACTIONS(3048),
    [anon_sym_q] = ACTIONS(3048),
    [anon_sym_qq] = ACTIONS(3048),
    [anon_sym_qw] = ACTIONS(3048),
    [anon_sym_qx] = ACTIONS(3048),
    [anon_sym_qr] = ACTIONS(3048),
    [anon_sym_m] = ACTIONS(3048),
    [anon_sym_s] = ACTIONS(3048),
    [anon_sym_tr] = ACTIONS(3048),
    [anon_sym_y] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_unless] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_until] = ACTIONS(3048),
    [aux_sym__bareword_token1] = ACTIONS(3048),
    [sym_number] = ACTIONS(3048),
    [sym__apostrophe] = ACTIONS(3046),
    [sym__double_quote] = ACTIONS(3046),
    [sym__backtick] = ACTIONS(3046),
    [sym__search_slash] = ACTIONS(3046),
    [sym__PERLY_HEREDOC] = ACTIONS(3046),
    [sym__ctrl_z_hack] = ACTIONS(3046),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [981] = {
    [sym_heredoc_content] = STATE(981),
    [ts_builtin_sym_end] = ACTIONS(3050),
    [sym__identifier] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_LBRACE2] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_package] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_sub] = ACTIONS(3052),
    [anon_sym_method] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_my] = ACTIONS(3052),
    [anon_sym_state] = ACTIONS(3052),
    [anon_sym_our] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_defer] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3052),
    [anon_sym_elsif] = ACTIONS(3052),
    [anon_sym_and] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3052),
    [anon_sym_DOLLAR] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_SLASH_SLASH] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_eq] = ACTIONS(3052),
    [anon_sym_ne] = ACTIONS(3052),
    [anon_sym_cmp] = ACTIONS(3052),
    [anon_sym_lt] = ACTIONS(3052),
    [anon_sym_le] = ACTIONS(3052),
    [anon_sym_ge] = ACTIONS(3052),
    [anon_sym_gt] = ACTIONS(3052),
    [anon_sym_isa] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_BSLASH] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_eval] = ACTIONS(3052),
    [anon_sym_field] = ACTIONS(3052),
    [anon_sym_local] = ACTIONS(3052),
    [anon_sym_require] = ACTIONS(3052),
    [anon_sym_map] = ACTIONS(3052),
    [anon_sym_grep] = ACTIONS(3052),
    [anon_sym_sort] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_undef] = ACTIONS(3052),
    [anon_sym_PERCENT2] = ACTIONS(3052),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3052),
    [anon_sym_use] = ACTIONS(3052),
    [anon_sym_no] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_foreach] = ACTIONS(3052),
    [anon_sym_last] = ACTIONS(3052),
    [anon_sym_next] = ACTIONS(3052),
    [anon_sym_redo] = ACTIONS(3052),
    [anon_sym_BEGIN] = ACTIONS(3052),
    [anon_sym_INIT] = ACTIONS(3052),
    [anon_sym_CHECK] = ACTIONS(3052),
    [anon_sym_UNITCHECK] = ACTIONS(3052),
    [anon_sym_END] = ACTIONS(3052),
    [anon_sym_ADJUST] = ACTIONS(3052),
    [anon_sym___FILE__] = ACTIONS(3052),
    [anon_sym___LINE__] = ACTIONS(3052),
    [anon_sym___PACKAGE__] = ACTIONS(3052),
    [anon_sym___SUB__] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_fork] = ACTIONS(3052),
    [anon_sym_getppid] = ACTIONS(3052),
    [anon_sym_time] = ACTIONS(3052),
    [anon_sym_times] = ACTIONS(3052),
    [anon_sym_wait] = ACTIONS(3052),
    [anon_sym_wantarray] = ACTIONS(3052),
    [anon_sym_abs] = ACTIONS(3052),
    [anon_sym_alarm] = ACTIONS(3052),
    [anon_sym_chop] = ACTIONS(3052),
    [anon_sym_chdir] = ACTIONS(3052),
    [anon_sym_close] = ACTIONS(3052),
    [anon_sym_closedir] = ACTIONS(3052),
    [anon_sym_caller] = ACTIONS(3052),
    [anon_sym_chomp] = ACTIONS(3052),
    [anon_sym_chr] = ACTIONS(3052),
    [anon_sym_cos] = ACTIONS(3052),
    [anon_sym_chroot] = ACTIONS(3052),
    [anon_sym_defined] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_dbmclose] = ACTIONS(3052),
    [anon_sym_exists] = ACTIONS(3052),
    [anon_sym_exit] = ACTIONS(3052),
    [anon_sym_eof] = ACTIONS(3052),
    [anon_sym_exp] = ACTIONS(3052),
    [anon_sym_each] = ACTIONS(3052),
    [anon_sym_fc] = ACTIONS(3052),
    [anon_sym_fileno] = ACTIONS(3052),
    [anon_sym_gmtime] = ACTIONS(3052),
    [anon_sym_getc] = ACTIONS(3052),
    [anon_sym_getpgrp] = ACTIONS(3052),
    [anon_sym_getprotobyname] = ACTIONS(3052),
    [anon_sym_getpwname] = ACTIONS(3052),
    [anon_sym_getpwuid] = ACTIONS(3052),
    [anon_sym_getpeername] = ACTIONS(3052),
    [anon_sym_getnetbyname] = ACTIONS(3052),
    [anon_sym_getsockname] = ACTIONS(3052),
    [anon_sym_getgrnam] = ACTIONS(3052),
    [anon_sym_getgrgid] = ACTIONS(3052),
    [anon_sym_hex] = ACTIONS(3052),
    [anon_sym_int] = ACTIONS(3052),
    [anon_sym_keys] = ACTIONS(3052),
    [anon_sym_lc] = ACTIONS(3052),
    [anon_sym_lcfirst] = ACTIONS(3052),
    [anon_sym_length] = ACTIONS(3052),
    [anon_sym_localtime] = ACTIONS(3052),
    [anon_sym_log] = ACTIONS(3052),
    [anon_sym_lock] = ACTIONS(3052),
    [anon_sym_lstat] = ACTIONS(3052),
    [anon_sym_oct] = ACTIONS(3052),
    [anon_sym_ord] = ACTIONS(3052),
    [anon_sym_prototype] = ACTIONS(3052),
    [anon_sym_pop] = ACTIONS(3052),
    [anon_sym_pos] = ACTIONS(3052),
    [anon_sym_quotemeta] = ACTIONS(3052),
    [anon_sym_reset] = ACTIONS(3052),
    [anon_sym_rand] = ACTIONS(3052),
    [anon_sym_rmdir] = ACTIONS(3052),
    [anon_sym_readdir] = ACTIONS(3052),
    [anon_sym_readline] = ACTIONS(3052),
    [anon_sym_readpipe] = ACTIONS(3052),
    [anon_sym_rewinddir] = ACTIONS(3052),
    [anon_sym_readlink] = ACTIONS(3052),
    [anon_sym_ref] = ACTIONS(3052),
    [anon_sym_scalar] = ACTIONS(3052),
    [anon_sym_shift] = ACTIONS(3052),
    [anon_sym_sin] = ACTIONS(3052),
    [anon_sym_sleep] = ACTIONS(3052),
    [anon_sym_sqrt] = ACTIONS(3052),
    [anon_sym_srand] = ACTIONS(3052),
    [anon_sym_stat] = ACTIONS(3052),
    [anon_sym_study] = ACTIONS(3052),
    [anon_sym_tell] = ACTIONS(3052),
    [anon_sym_telldir] = ACTIONS(3052),
    [anon_sym_tied] = ACTIONS(3052),
    [anon_sym_uc] = ACTIONS(3052),
    [anon_sym_ucfirst] = ACTIONS(3052),
    [anon_sym_untie] = ACTIONS(3052),
    [anon_sym_umask] = ACTIONS(3052),
    [anon_sym_values] = ACTIONS(3052),
    [anon_sym_write] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3052),
    [anon_sym___END__] = ACTIONS(3052),
    [anon_sym_EOT] = ACTIONS(3052),
    [anon_sym_q] = ACTIONS(3052),
    [anon_sym_qq] = ACTIONS(3052),
    [anon_sym_qw] = ACTIONS(3052),
    [anon_sym_qx] = ACTIONS(3052),
    [anon_sym_qr] = ACTIONS(3052),
    [anon_sym_m] = ACTIONS(3052),
    [anon_sym_s] = ACTIONS(3052),
    [anon_sym_tr] = ACTIONS(3052),
    [anon_sym_y] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_unless] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_until] = ACTIONS(3052),
    [aux_sym__bareword_token1] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [sym__apostrophe] = ACTIONS(3050),
    [sym__double_quote] = ACTIONS(3050),
    [sym__backtick] = ACTIONS(3050),
    [sym__search_slash] = ACTIONS(3050),
    [sym__PERLY_HEREDOC] = ACTIONS(3050),
    [sym__ctrl_z_hack] = ACTIONS(3050),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [982] = {
    [sym_heredoc_content] = STATE(982),
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_LBRACE2] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_package] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_defer] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_EOT] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym__ctrl_z_hack] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [983] = {
    [sym_heredoc_content] = STATE(983),
    [ts_builtin_sym_end] = ACTIONS(3057),
    [sym__identifier] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LBRACE2] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_package] = ACTIONS(3059),
    [anon_sym_class] = ACTIONS(3059),
    [anon_sym_sub] = ACTIONS(3059),
    [anon_sym_method] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_continue] = ACTIONS(3059),
    [anon_sym_my] = ACTIONS(3059),
    [anon_sym_state] = ACTIONS(3059),
    [anon_sym_our] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_defer] = ACTIONS(3059),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3059),
    [anon_sym_else] = ACTIONS(3059),
    [anon_sym_elsif] = ACTIONS(3059),
    [anon_sym_and] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_SLASH_SLASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_eq] = ACTIONS(3059),
    [anon_sym_ne] = ACTIONS(3059),
    [anon_sym_cmp] = ACTIONS(3059),
    [anon_sym_lt] = ACTIONS(3059),
    [anon_sym_le] = ACTIONS(3059),
    [anon_sym_ge] = ACTIONS(3059),
    [anon_sym_gt] = ACTIONS(3059),
    [anon_sym_isa] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3057),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_eval] = ACTIONS(3059),
    [anon_sym_field] = ACTIONS(3059),
    [anon_sym_local] = ACTIONS(3059),
    [anon_sym_require] = ACTIONS(3059),
    [anon_sym_map] = ACTIONS(3059),
    [anon_sym_grep] = ACTIONS(3059),
    [anon_sym_sort] = ACTIONS(3059),
    [anon_sym_goto] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_undef] = ACTIONS(3059),
    [anon_sym_PERCENT2] = ACTIONS(3059),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3059),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_no] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_foreach] = ACTIONS(3059),
    [anon_sym_last] = ACTIONS(3059),
    [anon_sym_next] = ACTIONS(3059),
    [anon_sym_redo] = ACTIONS(3059),
    [anon_sym_BEGIN] = ACTIONS(3059),
    [anon_sym_INIT] = ACTIONS(3059),
    [anon_sym_CHECK] = ACTIONS(3059),
    [anon_sym_UNITCHECK] = ACTIONS(3059),
    [anon_sym_END] = ACTIONS(3059),
    [anon_sym_ADJUST] = ACTIONS(3059),
    [anon_sym___FILE__] = ACTIONS(3059),
    [anon_sym___LINE__] = ACTIONS(3059),
    [anon_sym___PACKAGE__] = ACTIONS(3059),
    [anon_sym___SUB__] = ACTIONS(3059),
    [anon_sym_break] = ACTIONS(3059),
    [anon_sym_fork] = ACTIONS(3059),
    [anon_sym_getppid] = ACTIONS(3059),
    [anon_sym_time] = ACTIONS(3059),
    [anon_sym_times] = ACTIONS(3059),
    [anon_sym_wait] = ACTIONS(3059),
    [anon_sym_wantarray] = ACTIONS(3059),
    [anon_sym_abs] = ACTIONS(3059),
    [anon_sym_alarm] = ACTIONS(3059),
    [anon_sym_chop] = ACTIONS(3059),
    [anon_sym_chdir] = ACTIONS(3059),
    [anon_sym_close] = ACTIONS(3059),
    [anon_sym_closedir] = ACTIONS(3059),
    [anon_sym_caller] = ACTIONS(3059),
    [anon_sym_chomp] = ACTIONS(3059),
    [anon_sym_chr] = ACTIONS(3059),
    [anon_sym_cos] = ACTIONS(3059),
    [anon_sym_chroot] = ACTIONS(3059),
    [anon_sym_defined] = ACTIONS(3059),
    [anon_sym_delete] = ACTIONS(3059),
    [anon_sym_dbmclose] = ACTIONS(3059),
    [anon_sym_exists] = ACTIONS(3059),
    [anon_sym_exit] = ACTIONS(3059),
    [anon_sym_eof] = ACTIONS(3059),
    [anon_sym_exp] = ACTIONS(3059),
    [anon_sym_each] = ACTIONS(3059),
    [anon_sym_fc] = ACTIONS(3059),
    [anon_sym_fileno] = ACTIONS(3059),
    [anon_sym_gmtime] = ACTIONS(3059),
    [anon_sym_getc] = ACTIONS(3059),
    [anon_sym_getpgrp] = ACTIONS(3059),
    [anon_sym_getprotobyname] = ACTIONS(3059),
    [anon_sym_getpwname] = ACTIONS(3059),
    [anon_sym_getpwuid] = ACTIONS(3059),
    [anon_sym_getpeername] = ACTIONS(3059),
    [anon_sym_getnetbyname] = ACTIONS(3059),
    [anon_sym_getsockname] = ACTIONS(3059),
    [anon_sym_getgrnam] = ACTIONS(3059),
    [anon_sym_getgrgid] = ACTIONS(3059),
    [anon_sym_hex] = ACTIONS(3059),
    [anon_sym_int] = ACTIONS(3059),
    [anon_sym_keys] = ACTIONS(3059),
    [anon_sym_lc] = ACTIONS(3059),
    [anon_sym_lcfirst] = ACTIONS(3059),
    [anon_sym_length] = ACTIONS(3059),
    [anon_sym_localtime] = ACTIONS(3059),
    [anon_sym_log] = ACTIONS(3059),
    [anon_sym_lock] = ACTIONS(3059),
    [anon_sym_lstat] = ACTIONS(3059),
    [anon_sym_oct] = ACTIONS(3059),
    [anon_sym_ord] = ACTIONS(3059),
    [anon_sym_prototype] = ACTIONS(3059),
    [anon_sym_pop] = ACTIONS(3059),
    [anon_sym_pos] = ACTIONS(3059),
    [anon_sym_quotemeta] = ACTIONS(3059),
    [anon_sym_reset] = ACTIONS(3059),
    [anon_sym_rand] = ACTIONS(3059),
    [anon_sym_rmdir] = ACTIONS(3059),
    [anon_sym_readdir] = ACTIONS(3059),
    [anon_sym_readline] = ACTIONS(3059),
    [anon_sym_readpipe] = ACTIONS(3059),
    [anon_sym_rewinddir] = ACTIONS(3059),
    [anon_sym_readlink] = ACTIONS(3059),
    [anon_sym_ref] = ACTIONS(3059),
    [anon_sym_scalar] = ACTIONS(3059),
    [anon_sym_shift] = ACTIONS(3059),
    [anon_sym_sin] = ACTIONS(3059),
    [anon_sym_sleep] = ACTIONS(3059),
    [anon_sym_sqrt] = ACTIONS(3059),
    [anon_sym_srand] = ACTIONS(3059),
    [anon_sym_stat] = ACTIONS(3059),
    [anon_sym_study] = ACTIONS(3059),
    [anon_sym_tell] = ACTIONS(3059),
    [anon_sym_telldir] = ACTIONS(3059),
    [anon_sym_tied] = ACTIONS(3059),
    [anon_sym_uc] = ACTIONS(3059),
    [anon_sym_ucfirst] = ACTIONS(3059),
    [anon_sym_untie] = ACTIONS(3059),
    [anon_sym_umask] = ACTIONS(3059),
    [anon_sym_values] = ACTIONS(3059),
    [anon_sym_write] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3059),
    [anon_sym___END__] = ACTIONS(3059),
    [anon_sym_EOT] = ACTIONS(3059),
    [anon_sym_q] = ACTIONS(3059),
    [anon_sym_qq] = ACTIONS(3059),
    [anon_sym_qw] = ACTIONS(3059),
    [anon_sym_qx] = ACTIONS(3059),
    [anon_sym_qr] = ACTIONS(3059),
    [anon_sym_m] = ACTIONS(3059),
    [anon_sym_s] = ACTIONS(3059),
    [anon_sym_tr] = ACTIONS(3059),
    [anon_sym_y] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_unless] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_until] = ACTIONS(3059),
    [aux_sym__bareword_token1] = ACTIONS(3059),
    [sym_number] = ACTIONS(3059),
    [sym__apostrophe] = ACTIONS(3057),
    [sym__double_quote] = ACTIONS(3057),
    [sym__backtick] = ACTIONS(3057),
    [sym__search_slash] = ACTIONS(3057),
    [sym__PERLY_HEREDOC] = ACTIONS(3057),
    [sym__ctrl_z_hack] = ACTIONS(3057),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [984] = {
    [sym_heredoc_content] = STATE(984),
    [ts_builtin_sym_end] = ACTIONS(3061),
    [sym__identifier] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LBRACE2] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_package] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_sub] = ACTIONS(3063),
    [anon_sym_method] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_my] = ACTIONS(3063),
    [anon_sym_state] = ACTIONS(3063),
    [anon_sym_our] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_defer] = ACTIONS(3063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3063),
    [anon_sym_else] = ACTIONS(3063),
    [anon_sym_elsif] = ACTIONS(3063),
    [anon_sym_and] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_eq] = ACTIONS(3063),
    [anon_sym_ne] = ACTIONS(3063),
    [anon_sym_cmp] = ACTIONS(3063),
    [anon_sym_lt] = ACTIONS(3063),
    [anon_sym_le] = ACTIONS(3063),
    [anon_sym_ge] = ACTIONS(3063),
    [anon_sym_gt] = ACTIONS(3063),
    [anon_sym_isa] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_eval] = ACTIONS(3063),
    [anon_sym_field] = ACTIONS(3063),
    [anon_sym_local] = ACTIONS(3063),
    [anon_sym_require] = ACTIONS(3063),
    [anon_sym_map] = ACTIONS(3063),
    [anon_sym_grep] = ACTIONS(3063),
    [anon_sym_sort] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_undef] = ACTIONS(3063),
    [anon_sym_PERCENT2] = ACTIONS(3063),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3063),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_no] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_foreach] = ACTIONS(3063),
    [anon_sym_last] = ACTIONS(3063),
    [anon_sym_next] = ACTIONS(3063),
    [anon_sym_redo] = ACTIONS(3063),
    [anon_sym_BEGIN] = ACTIONS(3063),
    [anon_sym_INIT] = ACTIONS(3063),
    [anon_sym_CHECK] = ACTIONS(3063),
    [anon_sym_UNITCHECK] = ACTIONS(3063),
    [anon_sym_END] = ACTIONS(3063),
    [anon_sym_ADJUST] = ACTIONS(3063),
    [anon_sym___FILE__] = ACTIONS(3063),
    [anon_sym___LINE__] = ACTIONS(3063),
    [anon_sym___PACKAGE__] = ACTIONS(3063),
    [anon_sym___SUB__] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_fork] = ACTIONS(3063),
    [anon_sym_getppid] = ACTIONS(3063),
    [anon_sym_time] = ACTIONS(3063),
    [anon_sym_times] = ACTIONS(3063),
    [anon_sym_wait] = ACTIONS(3063),
    [anon_sym_wantarray] = ACTIONS(3063),
    [anon_sym_abs] = ACTIONS(3063),
    [anon_sym_alarm] = ACTIONS(3063),
    [anon_sym_chop] = ACTIONS(3063),
    [anon_sym_chdir] = ACTIONS(3063),
    [anon_sym_close] = ACTIONS(3063),
    [anon_sym_closedir] = ACTIONS(3063),
    [anon_sym_caller] = ACTIONS(3063),
    [anon_sym_chomp] = ACTIONS(3063),
    [anon_sym_chr] = ACTIONS(3063),
    [anon_sym_cos] = ACTIONS(3063),
    [anon_sym_chroot] = ACTIONS(3063),
    [anon_sym_defined] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_dbmclose] = ACTIONS(3063),
    [anon_sym_exists] = ACTIONS(3063),
    [anon_sym_exit] = ACTIONS(3063),
    [anon_sym_eof] = ACTIONS(3063),
    [anon_sym_exp] = ACTIONS(3063),
    [anon_sym_each] = ACTIONS(3063),
    [anon_sym_fc] = ACTIONS(3063),
    [anon_sym_fileno] = ACTIONS(3063),
    [anon_sym_gmtime] = ACTIONS(3063),
    [anon_sym_getc] = ACTIONS(3063),
    [anon_sym_getpgrp] = ACTIONS(3063),
    [anon_sym_getprotobyname] = ACTIONS(3063),
    [anon_sym_getpwname] = ACTIONS(3063),
    [anon_sym_getpwuid] = ACTIONS(3063),
    [anon_sym_getpeername] = ACTIONS(3063),
    [anon_sym_getnetbyname] = ACTIONS(3063),
    [anon_sym_getsockname] = ACTIONS(3063),
    [anon_sym_getgrnam] = ACTIONS(3063),
    [anon_sym_getgrgid] = ACTIONS(3063),
    [anon_sym_hex] = ACTIONS(3063),
    [anon_sym_int] = ACTIONS(3063),
    [anon_sym_keys] = ACTIONS(3063),
    [anon_sym_lc] = ACTIONS(3063),
    [anon_sym_lcfirst] = ACTIONS(3063),
    [anon_sym_length] = ACTIONS(3063),
    [anon_sym_localtime] = ACTIONS(3063),
    [anon_sym_log] = ACTIONS(3063),
    [anon_sym_lock] = ACTIONS(3063),
    [anon_sym_lstat] = ACTIONS(3063),
    [anon_sym_oct] = ACTIONS(3063),
    [anon_sym_ord] = ACTIONS(3063),
    [anon_sym_prototype] = ACTIONS(3063),
    [anon_sym_pop] = ACTIONS(3063),
    [anon_sym_pos] = ACTIONS(3063),
    [anon_sym_quotemeta] = ACTIONS(3063),
    [anon_sym_reset] = ACTIONS(3063),
    [anon_sym_rand] = ACTIONS(3063),
    [anon_sym_rmdir] = ACTIONS(3063),
    [anon_sym_readdir] = ACTIONS(3063),
    [anon_sym_readline] = ACTIONS(3063),
    [anon_sym_readpipe] = ACTIONS(3063),
    [anon_sym_rewinddir] = ACTIONS(3063),
    [anon_sym_readlink] = ACTIONS(3063),
    [anon_sym_ref] = ACTIONS(3063),
    [anon_sym_scalar] = ACTIONS(3063),
    [anon_sym_shift] = ACTIONS(3063),
    [anon_sym_sin] = ACTIONS(3063),
    [anon_sym_sleep] = ACTIONS(3063),
    [anon_sym_sqrt] = ACTIONS(3063),
    [anon_sym_srand] = ACTIONS(3063),
    [anon_sym_stat] = ACTIONS(3063),
    [anon_sym_study] = ACTIONS(3063),
    [anon_sym_tell] = ACTIONS(3063),
    [anon_sym_telldir] = ACTIONS(3063),
    [anon_sym_tied] = ACTIONS(3063),
    [anon_sym_uc] = ACTIONS(3063),
    [anon_sym_ucfirst] = ACTIONS(3063),
    [anon_sym_untie] = ACTIONS(3063),
    [anon_sym_umask] = ACTIONS(3063),
    [anon_sym_values] = ACTIONS(3063),
    [anon_sym_write] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3063),
    [anon_sym___END__] = ACTIONS(3063),
    [anon_sym_EOT] = ACTIONS(3063),
    [anon_sym_q] = ACTIONS(3063),
    [anon_sym_qq] = ACTIONS(3063),
    [anon_sym_qw] = ACTIONS(3063),
    [anon_sym_qx] = ACTIONS(3063),
    [anon_sym_qr] = ACTIONS(3063),
    [anon_sym_m] = ACTIONS(3063),
    [anon_sym_s] = ACTIONS(3063),
    [anon_sym_tr] = ACTIONS(3063),
    [anon_sym_y] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_unless] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_until] = ACTIONS(3063),
    [aux_sym__bareword_token1] = ACTIONS(3063),
    [sym_number] = ACTIONS(3063),
    [sym__apostrophe] = ACTIONS(3061),
    [sym__double_quote] = ACTIONS(3061),
    [sym__backtick] = ACTIONS(3061),
    [sym__search_slash] = ACTIONS(3061),
    [sym__PERLY_HEREDOC] = ACTIONS(3061),
    [sym__ctrl_z_hack] = ACTIONS(3061),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [985] = {
    [sym_heredoc_content] = STATE(985),
    [sym__identifier] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_LBRACE2] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_package] = ACTIONS(3065),
    [anon_sym_class] = ACTIONS(3065),
    [anon_sym_sub] = ACTIONS(3065),
    [anon_sym_method] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_my] = ACTIONS(3065),
    [anon_sym_state] = ACTIONS(3065),
    [anon_sym_our] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_defer] = ACTIONS(3065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3065),
    [anon_sym_else] = ACTIONS(3065),
    [anon_sym_elsif] = ACTIONS(3065),
    [anon_sym_and] = ACTIONS(3065),
    [anon_sym_or] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_AT] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_eq] = ACTIONS(3065),
    [anon_sym_ne] = ACTIONS(3065),
    [anon_sym_cmp] = ACTIONS(3065),
    [anon_sym_lt] = ACTIONS(3065),
    [anon_sym_le] = ACTIONS(3065),
    [anon_sym_ge] = ACTIONS(3065),
    [anon_sym_gt] = ACTIONS(3065),
    [anon_sym_isa] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_BSLASH] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_eval] = ACTIONS(3065),
    [anon_sym_field] = ACTIONS(3065),
    [anon_sym_local] = ACTIONS(3065),
    [anon_sym_require] = ACTIONS(3065),
    [anon_sym_map] = ACTIONS(3065),
    [anon_sym_grep] = ACTIONS(3065),
    [anon_sym_sort] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_undef] = ACTIONS(3065),
    [anon_sym_PERCENT2] = ACTIONS(3065),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3065),
    [aux_sym__var_indirob_autoquote_token1] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3065),
    [anon_sym_no] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_foreach] = ACTIONS(3065),
    [anon_sym_last] = ACTIONS(3065),
    [anon_sym_next] = ACTIONS(3065),
    [anon_sym_redo] = ACTIONS(3065),
    [anon_sym_BEGIN] = ACTIONS(3065),
    [anon_sym_INIT] = ACTIONS(3065),
    [anon_sym_CHECK] = ACTIONS(3065),
    [anon_sym_UNITCHECK] = ACTIONS(3065),
    [anon_sym_END] = ACTIONS(3065),
    [anon_sym_ADJUST] = ACTIONS(3065),
    [anon_sym___FILE__] = ACTIONS(3065),
    [anon_sym___LINE__] = ACTIONS(3065),
    [anon_sym___PACKAGE__] = ACTIONS(3065),
    [anon_sym___SUB__] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_fork] = ACTIONS(3065),
    [anon_sym_getppid] = ACTIONS(3065),
    [anon_sym_time] = ACTIONS(3065),
    [anon_sym_times] = ACTIONS(3065),
    [anon_sym_wait] = ACTIONS(3065),
    [anon_sym_wantarray] = ACTIONS(3065),
    [anon_sym_abs] = ACTIONS(3065),
    [anon_sym_alarm] = ACTIONS(3065),
    [anon_sym_chop] = ACTIONS(3065),
    [anon_sym_chdir] = ACTIONS(3065),
    [anon_sym_close] = ACTIONS(3065),
    [anon_sym_closedir] = ACTIONS(3065),
    [anon_sym_caller] = ACTIONS(3065),
    [anon_sym_chomp] = ACTIONS(3065),
    [anon_sym_chr] = ACTIONS(3065),
    [anon_sym_cos] = ACTIONS(3065),
    [anon_sym_chroot] = ACTIONS(3065),
    [anon_sym_defined] = ACTIONS(3065),
    [anon_sym_delete] = ACTIONS(3065),
    [anon_sym_dbmclose] = ACTIONS(3065),
    [anon_sym_exists] = ACTIONS(3065),
    [anon_sym_exit] = ACTIONS(3065),
    [anon_sym_eof] = ACTIONS(3065),
    [anon_sym_exp] = ACTIONS(3065),
    [anon_sym_each] = ACTIONS(3065),
    [anon_sym_fc] = ACTIONS(3065),
    [anon_sym_fileno] = ACTIONS(3065),
    [anon_sym_gmtime] = ACTIONS(3065),
    [anon_sym_getc] = ACTIONS(3065),
    [anon_sym_getpgrp] = ACTIONS(3065),
    [anon_sym_getprotobyname] = ACTIONS(3065),
    [anon_sym_getpwname] = ACTIONS(3065),
    [anon_sym_getpwuid] = ACTIONS(3065),
    [anon_sym_getpeername] = ACTIONS(3065),
    [anon_sym_getnetbyname] = ACTIONS(3065),
    [anon_sym_getsockname] = ACTIONS(3065),
    [anon_sym_getgrnam] = ACTIONS(3065),
    [anon_sym_getgrgid] = ACTIONS(3065),
    [anon_sym_hex] = ACTIONS(3065),
    [anon_sym_int] = ACTIONS(3065),
    [anon_sym_keys] = ACTIONS(3065),
    [anon_sym_lc] = ACTIONS(3065),
    [anon_sym_lcfirst] = ACTIONS(3065),
    [anon_sym_length] = ACTIONS(3065),
    [anon_sym_localtime] = ACTIONS(3065),
    [anon_sym_log] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_lstat] = ACTIONS(3065),
    [anon_sym_oct] = ACTIONS(3065),
    [anon_sym_ord] = ACTIONS(3065),
    [anon_sym_prototype] = ACTIONS(3065),
    [anon_sym_pop] = ACTIONS(3065),
    [anon_sym_pos] = ACTIONS(3065),
    [anon_sym_quotemeta] = ACTIONS(3065),
    [anon_sym_reset] = ACTIONS(3065),
    [anon_sym_rand] = ACTIONS(3065),
    [anon_sym_rmdir] = ACTIONS(3065),
    [anon_sym_readdir] = ACTIONS(3065),
    [anon_sym_readline] = ACTIONS(3065),
    [anon_sym_readpipe] = ACTIONS(3065),
    [anon_sym_rewinddir] = ACTIONS(3065),
    [anon_sym_readlink] = ACTIONS(3065),
    [anon_sym_ref] = ACTIONS(3065),
    [anon_sym_scalar] = ACTIONS(3065),
    [anon_sym_shift] = ACTIONS(3065),
    [anon_sym_sin] = ACTIONS(3065),
    [anon_sym_sleep] = ACTIONS(3065),
    [anon_sym_sqrt] = ACTIONS(3065),
    [anon_sym_srand] = ACTIONS(3065),
    [anon_sym_stat] = ACTIONS(3065),
    [anon_sym_study] = ACTIONS(3065),
    [anon_sym_tell] = ACTIONS(3065),
    [anon_sym_telldir] = ACTIONS(3065),
    [anon_sym_tied] = ACTIONS(3065),
    [anon_sym_uc] = ACTIONS(3065),
    [anon_sym_ucfirst] = ACTIONS(3065),
    [anon_sym_untie] = ACTIONS(3065),
    [anon_sym_umask] = ACTIONS(3065),
    [anon_sym_values] = ACTIONS(3065),
    [anon_sym_write] = ACTIONS(3065),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3065),
    [anon_sym___END__] = ACTIONS(3065),
    [anon_sym_q] = ACTIONS(3065),
    [anon_sym_qq] = ACTIONS(3065),
    [anon_sym_qw] = ACTIONS(3065),
    [anon_sym_qx] = ACTIONS(3065),
    [anon_sym_qr] = ACTIONS(3065),
    [anon_sym_m] = ACTIONS(3065),
    [anon_sym_s] = ACTIONS(3065),
    [anon_sym_tr] = ACTIONS(3065),
    [anon_sym_y] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_unless] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_until] = ACTIONS(3065),
    [aux_sym__ident_special_token1] = ACTIONS(3065),
    [aux_sym__bareword_token1] = ACTIONS(3065),
    [sym_number] = ACTIONS(3065),
    [sym__apostrophe] = ACTIONS(3067),
    [sym__double_quote] = ACTIONS(3067),
    [sym__backtick] = ACTIONS(3067),
    [sym__search_slash] = ACTIONS(3067),
    [sym__PERLY_HEREDOC] = ACTIONS(3067),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [986] = {
    [sym_heredoc_content] = STATE(986),
    [ts_builtin_sym_end] = ACTIONS(3069),
    [sym__identifier] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LBRACE2] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_package] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_sub] = ACTIONS(3071),
    [anon_sym_method] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3073),
    [anon_sym_my] = ACTIONS(3071),
    [anon_sym_state] = ACTIONS(3071),
    [anon_sym_our] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_defer] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_elsif] = ACTIONS(3071),
    [anon_sym_and] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3071),
    [anon_sym_SLASH_SLASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_eq] = ACTIONS(3071),
    [anon_sym_ne] = ACTIONS(3071),
    [anon_sym_cmp] = ACTIONS(3071),
    [anon_sym_lt] = ACTIONS(3071),
    [anon_sym_le] = ACTIONS(3071),
    [anon_sym_ge] = ACTIONS(3071),
    [anon_sym_gt] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3071),
    [anon_sym_BANG] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_BSLASH] = ACTIONS(3069),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_eval] = ACTIONS(3071),
    [anon_sym_field] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_require] = ACTIONS(3071),
    [anon_sym_map] = ACTIONS(3071),
    [anon_sym_grep] = ACTIONS(3071),
    [anon_sym_sort] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_undef] = ACTIONS(3071),
    [anon_sym_PERCENT2] = ACTIONS(3071),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3071),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_no] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_foreach] = ACTIONS(3071),
    [anon_sym_last] = ACTIONS(3071),
    [anon_sym_next] = ACTIONS(3071),
    [anon_sym_redo] = ACTIONS(3071),
    [anon_sym_BEGIN] = ACTIONS(3071),
    [anon_sym_INIT] = ACTIONS(3071),
    [anon_sym_CHECK] = ACTIONS(3071),
    [anon_sym_UNITCHECK] = ACTIONS(3071),
    [anon_sym_END] = ACTIONS(3071),
    [anon_sym_ADJUST] = ACTIONS(3071),
    [anon_sym___FILE__] = ACTIONS(3071),
    [anon_sym___LINE__] = ACTIONS(3071),
    [anon_sym___PACKAGE__] = ACTIONS(3071),
    [anon_sym___SUB__] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_fork] = ACTIONS(3071),
    [anon_sym_getppid] = ACTIONS(3071),
    [anon_sym_time] = ACTIONS(3071),
    [anon_sym_times] = ACTIONS(3071),
    [anon_sym_wait] = ACTIONS(3071),
    [anon_sym_wantarray] = ACTIONS(3071),
    [anon_sym_abs] = ACTIONS(3071),
    [anon_sym_alarm] = ACTIONS(3071),
    [anon_sym_chop] = ACTIONS(3071),
    [anon_sym_chdir] = ACTIONS(3071),
    [anon_sym_close] = ACTIONS(3071),
    [anon_sym_closedir] = ACTIONS(3071),
    [anon_sym_caller] = ACTIONS(3071),
    [anon_sym_chomp] = ACTIONS(3071),
    [anon_sym_chr] = ACTIONS(3071),
    [anon_sym_cos] = ACTIONS(3071),
    [anon_sym_chroot] = ACTIONS(3071),
    [anon_sym_defined] = ACTIONS(3071),
    [anon_sym_delete] = ACTIONS(3071),
    [anon_sym_dbmclose] = ACTIONS(3071),
    [anon_sym_exists] = ACTIONS(3071),
    [anon_sym_exit] = ACTIONS(3071),
    [anon_sym_eof] = ACTIONS(3071),
    [anon_sym_exp] = ACTIONS(3071),
    [anon_sym_each] = ACTIONS(3071),
    [anon_sym_fc] = ACTIONS(3071),
    [anon_sym_fileno] = ACTIONS(3071),
    [anon_sym_gmtime] = ACTIONS(3071),
    [anon_sym_getc] = ACTIONS(3071),
    [anon_sym_getpgrp] = ACTIONS(3071),
    [anon_sym_getprotobyname] = ACTIONS(3071),
    [anon_sym_getpwname] = ACTIONS(3071),
    [anon_sym_getpwuid] = ACTIONS(3071),
    [anon_sym_getpeername] = ACTIONS(3071),
    [anon_sym_getnetbyname] = ACTIONS(3071),
    [anon_sym_getsockname] = ACTIONS(3071),
    [anon_sym_getgrnam] = ACTIONS(3071),
    [anon_sym_getgrgid] = ACTIONS(3071),
    [anon_sym_hex] = ACTIONS(3071),
    [anon_sym_int] = ACTIONS(3071),
    [anon_sym_keys] = ACTIONS(3071),
    [anon_sym_lc] = ACTIONS(3071),
    [anon_sym_lcfirst] = ACTIONS(3071),
    [anon_sym_length] = ACTIONS(3071),
    [anon_sym_localtime] = ACTIONS(3071),
    [anon_sym_log] = ACTIONS(3071),
    [anon_sym_lock] = ACTIONS(3071),
    [anon_sym_lstat] = ACTIONS(3071),
    [anon_sym_oct] = ACTIONS(3071),
    [anon_sym_ord] = ACTIONS(3071),
    [anon_sym_prototype] = ACTIONS(3071),
    [anon_sym_pop] = ACTIONS(3071),
    [anon_sym_pos] = ACTIONS(3071),
    [anon_sym_quotemeta] = ACTIONS(3071),
    [anon_sym_reset] = ACTIONS(3071),
    [anon_sym_rand] = ACTIONS(3071),
    [anon_sym_rmdir] = ACTIONS(3071),
    [anon_sym_readdir] = ACTIONS(3071),
    [anon_sym_readline] = ACTIONS(3071),
    [anon_sym_readpipe] = ACTIONS(3071),
    [anon_sym_rewinddir] = ACTIONS(3071),
    [anon_sym_readlink] = ACTIONS(3071),
    [anon_sym_ref] = ACTIONS(3071),
    [anon_sym_scalar] = ACTIONS(3071),
    [anon_sym_shift] = ACTIONS(3071),
    [anon_sym_sin] = ACTIONS(3071),
    [anon_sym_sleep] = ACTIONS(3071),
    [anon_sym_sqrt] = ACTIONS(3071),
    [anon_sym_srand] = ACTIONS(3071),
    [anon_sym_stat] = ACTIONS(3071),
    [anon_sym_study] = ACTIONS(3071),
    [anon_sym_tell] = ACTIONS(3071),
    [anon_sym_telldir] = ACTIONS(3071),
    [anon_sym_tied] = ACTIONS(3071),
    [anon_sym_uc] = ACTIONS(3071),
    [anon_sym_ucfirst] = ACTIONS(3071),
    [anon_sym_untie] = ACTIONS(3071),
    [anon_sym_umask] = ACTIONS(3071),
    [anon_sym_values] = ACTIONS(3071),
    [anon_sym_write] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3071),
    [anon_sym___END__] = ACTIONS(3071),
    [anon_sym_EOT] = ACTIONS(3071),
    [anon_sym_q] = ACTIONS(3071),
    [anon_sym_qq] = ACTIONS(3071),
    [anon_sym_qw] = ACTIONS(3071),
    [anon_sym_qx] = ACTIONS(3071),
    [anon_sym_qr] = ACTIONS(3071),
    [anon_sym_m] = ACTIONS(3071),
    [anon_sym_s] = ACTIONS(3071),
    [anon_sym_tr] = ACTIONS(3071),
    [anon_sym_y] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_unless] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_until] = ACTIONS(3071),
    [aux_sym__bareword_token1] = ACTIONS(3071),
    [sym_number] = ACTIONS(3071),
    [sym__apostrophe] = ACTIONS(3069),
    [sym__double_quote] = ACTIONS(3069),
    [sym__backtick] = ACTIONS(3069),
    [sym__search_slash] = ACTIONS(3069),
    [sym__PERLY_HEREDOC] = ACTIONS(3069),
    [sym__ctrl_z_hack] = ACTIONS(3069),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [987] = {
    [sym_heredoc_content] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(3076),
    [sym__identifier] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_LBRACE2] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym_package] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_sub] = ACTIONS(3078),
    [anon_sym_method] = ACTIONS(3078),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_my] = ACTIONS(3078),
    [anon_sym_state] = ACTIONS(3078),
    [anon_sym_our] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_defer] = ACTIONS(3078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_elsif] = ACTIONS(3078),
    [anon_sym_and] = ACTIONS(3078),
    [anon_sym_or] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_AT] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_LT_LT] = ACTIONS(3078),
    [anon_sym_SLASH_SLASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_eq] = ACTIONS(3078),
    [anon_sym_ne] = ACTIONS(3078),
    [anon_sym_cmp] = ACTIONS(3078),
    [anon_sym_lt] = ACTIONS(3078),
    [anon_sym_le] = ACTIONS(3078),
    [anon_sym_ge] = ACTIONS(3078),
    [anon_sym_gt] = ACTIONS(3078),
    [anon_sym_isa] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_BSLASH] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_eval] = ACTIONS(3078),
    [anon_sym_field] = ACTIONS(3078),
    [anon_sym_local] = ACTIONS(3078),
    [anon_sym_require] = ACTIONS(3078),
    [anon_sym_map] = ACTIONS(3078),
    [anon_sym_grep] = ACTIONS(3078),
    [anon_sym_sort] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_undef] = ACTIONS(3078),
    [anon_sym_PERCENT2] = ACTIONS(3078),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3078),
    [anon_sym_use] = ACTIONS(3078),
    [anon_sym_no] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_foreach] = ACTIONS(3078),
    [anon_sym_last] = ACTIONS(3078),
    [anon_sym_next] = ACTIONS(3078),
    [anon_sym_redo] = ACTIONS(3078),
    [anon_sym_BEGIN] = ACTIONS(3078),
    [anon_sym_INIT] = ACTIONS(3078),
    [anon_sym_CHECK] = ACTIONS(3078),
    [anon_sym_UNITCHECK] = ACTIONS(3078),
    [anon_sym_END] = ACTIONS(3078),
    [anon_sym_ADJUST] = ACTIONS(3078),
    [anon_sym___FILE__] = ACTIONS(3078),
    [anon_sym___LINE__] = ACTIONS(3078),
    [anon_sym___PACKAGE__] = ACTIONS(3078),
    [anon_sym___SUB__] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_fork] = ACTIONS(3078),
    [anon_sym_getppid] = ACTIONS(3078),
    [anon_sym_time] = ACTIONS(3078),
    [anon_sym_times] = ACTIONS(3078),
    [anon_sym_wait] = ACTIONS(3078),
    [anon_sym_wantarray] = ACTIONS(3078),
    [anon_sym_abs] = ACTIONS(3078),
    [anon_sym_alarm] = ACTIONS(3078),
    [anon_sym_chop] = ACTIONS(3078),
    [anon_sym_chdir] = ACTIONS(3078),
    [anon_sym_close] = ACTIONS(3078),
    [anon_sym_closedir] = ACTIONS(3078),
    [anon_sym_caller] = ACTIONS(3078),
    [anon_sym_chomp] = ACTIONS(3078),
    [anon_sym_chr] = ACTIONS(3078),
    [anon_sym_cos] = ACTIONS(3078),
    [anon_sym_chroot] = ACTIONS(3078),
    [anon_sym_defined] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_dbmclose] = ACTIONS(3078),
    [anon_sym_exists] = ACTIONS(3078),
    [anon_sym_exit] = ACTIONS(3078),
    [anon_sym_eof] = ACTIONS(3078),
    [anon_sym_exp] = ACTIONS(3078),
    [anon_sym_each] = ACTIONS(3078),
    [anon_sym_fc] = ACTIONS(3078),
    [anon_sym_fileno] = ACTIONS(3078),
    [anon_sym_gmtime] = ACTIONS(3078),
    [anon_sym_getc] = ACTIONS(3078),
    [anon_sym_getpgrp] = ACTIONS(3078),
    [anon_sym_getprotobyname] = ACTIONS(3078),
    [anon_sym_getpwname] = ACTIONS(3078),
    [anon_sym_getpwuid] = ACTIONS(3078),
    [anon_sym_getpeername] = ACTIONS(3078),
    [anon_sym_getnetbyname] = ACTIONS(3078),
    [anon_sym_getsockname] = ACTIONS(3078),
    [anon_sym_getgrnam] = ACTIONS(3078),
    [anon_sym_getgrgid] = ACTIONS(3078),
    [anon_sym_hex] = ACTIONS(3078),
    [anon_sym_int] = ACTIONS(3078),
    [anon_sym_keys] = ACTIONS(3078),
    [anon_sym_lc] = ACTIONS(3078),
    [anon_sym_lcfirst] = ACTIONS(3078),
    [anon_sym_length] = ACTIONS(3078),
    [anon_sym_localtime] = ACTIONS(3078),
    [anon_sym_log] = ACTIONS(3078),
    [anon_sym_lock] = ACTIONS(3078),
    [anon_sym_lstat] = ACTIONS(3078),
    [anon_sym_oct] = ACTIONS(3078),
    [anon_sym_ord] = ACTIONS(3078),
    [anon_sym_prototype] = ACTIONS(3078),
    [anon_sym_pop] = ACTIONS(3078),
    [anon_sym_pos] = ACTIONS(3078),
    [anon_sym_quotemeta] = ACTIONS(3078),
    [anon_sym_reset] = ACTIONS(3078),
    [anon_sym_rand] = ACTIONS(3078),
    [anon_sym_rmdir] = ACTIONS(3078),
    [anon_sym_readdir] = ACTIONS(3078),
    [anon_sym_readline] = ACTIONS(3078),
    [anon_sym_readpipe] = ACTIONS(3078),
    [anon_sym_rewinddir] = ACTIONS(3078),
    [anon_sym_readlink] = ACTIONS(3078),
    [anon_sym_ref] = ACTIONS(3078),
    [anon_sym_scalar] = ACTIONS(3078),
    [anon_sym_shift] = ACTIONS(3078),
    [anon_sym_sin] = ACTIONS(3078),
    [anon_sym_sleep] = ACTIONS(3078),
    [anon_sym_sqrt] = ACTIONS(3078),
    [anon_sym_srand] = ACTIONS(3078),
    [anon_sym_stat] = ACTIONS(3078),
    [anon_sym_study] = ACTIONS(3078),
    [anon_sym_tell] = ACTIONS(3078),
    [anon_sym_telldir] = ACTIONS(3078),
    [anon_sym_tied] = ACTIONS(3078),
    [anon_sym_uc] = ACTIONS(3078),
    [anon_sym_ucfirst] = ACTIONS(3078),
    [anon_sym_untie] = ACTIONS(3078),
    [anon_sym_umask] = ACTIONS(3078),
    [anon_sym_values] = ACTIONS(3078),
    [anon_sym_write] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3078),
    [anon_sym___END__] = ACTIONS(3078),
    [anon_sym_EOT] = ACTIONS(3078),
    [anon_sym_q] = ACTIONS(3078),
    [anon_sym_qq] = ACTIONS(3078),
    [anon_sym_qw] = ACTIONS(3078),
    [anon_sym_qx] = ACTIONS(3078),
    [anon_sym_qr] = ACTIONS(3078),
    [anon_sym_m] = ACTIONS(3078),
    [anon_sym_s] = ACTIONS(3078),
    [anon_sym_tr] = ACTIONS(3078),
    [anon_sym_y] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_unless] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_until] = ACTIONS(3078),
    [aux_sym__bareword_token1] = ACTIONS(3078),
    [sym_number] = ACTIONS(3078),
    [sym__apostrophe] = ACTIONS(3076),
    [sym__double_quote] = ACTIONS(3076),
    [sym__backtick] = ACTIONS(3076),
    [sym__search_slash] = ACTIONS(3076),
    [sym__PERLY_HEREDOC] = ACTIONS(3076),
    [sym__ctrl_z_hack] = ACTIONS(3076),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [988] = {
    [sym_heredoc_content] = STATE(988),
    [ts_builtin_sym_end] = ACTIONS(3080),
    [sym__identifier] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_LBRACE2] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_package] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_sub] = ACTIONS(3082),
    [anon_sym_method] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_my] = ACTIONS(3082),
    [anon_sym_state] = ACTIONS(3082),
    [anon_sym_our] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_defer] = ACTIONS(3082),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_elsif] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3082),
    [anon_sym_or] = ACTIONS(3082),
    [anon_sym_DOLLAR] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_LT_LT] = ACTIONS(3082),
    [anon_sym_SLASH_SLASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3082),
    [anon_sym_eq] = ACTIONS(3082),
    [anon_sym_ne] = ACTIONS(3082),
    [anon_sym_cmp] = ACTIONS(3082),
    [anon_sym_lt] = ACTIONS(3082),
    [anon_sym_le] = ACTIONS(3082),
    [anon_sym_ge] = ACTIONS(3082),
    [anon_sym_gt] = ACTIONS(3082),
    [anon_sym_isa] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [anon_sym_BSLASH] = ACTIONS(3080),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_eval] = ACTIONS(3082),
    [anon_sym_field] = ACTIONS(3082),
    [anon_sym_local] = ACTIONS(3082),
    [anon_sym_require] = ACTIONS(3082),
    [anon_sym_map] = ACTIONS(3082),
    [anon_sym_grep] = ACTIONS(3082),
    [anon_sym_sort] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_undef] = ACTIONS(3082),
    [anon_sym_PERCENT2] = ACTIONS(3082),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3082),
    [anon_sym_use] = ACTIONS(3082),
    [anon_sym_no] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_foreach] = ACTIONS(3082),
    [anon_sym_last] = ACTIONS(3082),
    [anon_sym_next] = ACTIONS(3082),
    [anon_sym_redo] = ACTIONS(3082),
    [anon_sym_BEGIN] = ACTIONS(3082),
    [anon_sym_INIT] = ACTIONS(3082),
    [anon_sym_CHECK] = ACTIONS(3082),
    [anon_sym_UNITCHECK] = ACTIONS(3082),
    [anon_sym_END] = ACTIONS(3082),
    [anon_sym_ADJUST] = ACTIONS(3082),
    [anon_sym___FILE__] = ACTIONS(3082),
    [anon_sym___LINE__] = ACTIONS(3082),
    [anon_sym___PACKAGE__] = ACTIONS(3082),
    [anon_sym___SUB__] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_fork] = ACTIONS(3082),
    [anon_sym_getppid] = ACTIONS(3082),
    [anon_sym_time] = ACTIONS(3082),
    [anon_sym_times] = ACTIONS(3082),
    [anon_sym_wait] = ACTIONS(3082),
    [anon_sym_wantarray] = ACTIONS(3082),
    [anon_sym_abs] = ACTIONS(3082),
    [anon_sym_alarm] = ACTIONS(3082),
    [anon_sym_chop] = ACTIONS(3082),
    [anon_sym_chdir] = ACTIONS(3082),
    [anon_sym_close] = ACTIONS(3082),
    [anon_sym_closedir] = ACTIONS(3082),
    [anon_sym_caller] = ACTIONS(3082),
    [anon_sym_chomp] = ACTIONS(3082),
    [anon_sym_chr] = ACTIONS(3082),
    [anon_sym_cos] = ACTIONS(3082),
    [anon_sym_chroot] = ACTIONS(3082),
    [anon_sym_defined] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_dbmclose] = ACTIONS(3082),
    [anon_sym_exists] = ACTIONS(3082),
    [anon_sym_exit] = ACTIONS(3082),
    [anon_sym_eof] = ACTIONS(3082),
    [anon_sym_exp] = ACTIONS(3082),
    [anon_sym_each] = ACTIONS(3082),
    [anon_sym_fc] = ACTIONS(3082),
    [anon_sym_fileno] = ACTIONS(3082),
    [anon_sym_gmtime] = ACTIONS(3082),
    [anon_sym_getc] = ACTIONS(3082),
    [anon_sym_getpgrp] = ACTIONS(3082),
    [anon_sym_getprotobyname] = ACTIONS(3082),
    [anon_sym_getpwname] = ACTIONS(3082),
    [anon_sym_getpwuid] = ACTIONS(3082),
    [anon_sym_getpeername] = ACTIONS(3082),
    [anon_sym_getnetbyname] = ACTIONS(3082),
    [anon_sym_getsockname] = ACTIONS(3082),
    [anon_sym_getgrnam] = ACTIONS(3082),
    [anon_sym_getgrgid] = ACTIONS(3082),
    [anon_sym_hex] = ACTIONS(3082),
    [anon_sym_int] = ACTIONS(3082),
    [anon_sym_keys] = ACTIONS(3082),
    [anon_sym_lc] = ACTIONS(3082),
    [anon_sym_lcfirst] = ACTIONS(3082),
    [anon_sym_length] = ACTIONS(3082),
    [anon_sym_localtime] = ACTIONS(3082),
    [anon_sym_log] = ACTIONS(3082),
    [anon_sym_lock] = ACTIONS(3082),
    [anon_sym_lstat] = ACTIONS(3082),
    [anon_sym_oct] = ACTIONS(3082),
    [anon_sym_ord] = ACTIONS(3082),
    [anon_sym_prototype] = ACTIONS(3082),
    [anon_sym_pop] = ACTIONS(3082),
    [anon_sym_pos] = ACTIONS(3082),
    [anon_sym_quotemeta] = ACTIONS(3082),
    [anon_sym_reset] = ACTIONS(3082),
    [anon_sym_rand] = ACTIONS(3082),
    [anon_sym_rmdir] = ACTIONS(3082),
    [anon_sym_readdir] = ACTIONS(3082),
    [anon_sym_readline] = ACTIONS(3082),
    [anon_sym_readpipe] = ACTIONS(3082),
    [anon_sym_rewinddir] = ACTIONS(3082),
    [anon_sym_readlink] = ACTIONS(3082),
    [anon_sym_ref] = ACTIONS(3082),
    [anon_sym_scalar] = ACTIONS(3082),
    [anon_sym_shift] = ACTIONS(3082),
    [anon_sym_sin] = ACTIONS(3082),
    [anon_sym_sleep] = ACTIONS(3082),
    [anon_sym_sqrt] = ACTIONS(3082),
    [anon_sym_srand] = ACTIONS(3082),
    [anon_sym_stat] = ACTIONS(3082),
    [anon_sym_study] = ACTIONS(3082),
    [anon_sym_tell] = ACTIONS(3082),
    [anon_sym_telldir] = ACTIONS(3082),
    [anon_sym_tied] = ACTIONS(3082),
    [anon_sym_uc] = ACTIONS(3082),
    [anon_sym_ucfirst] = ACTIONS(3082),
    [anon_sym_untie] = ACTIONS(3082),
    [anon_sym_umask] = ACTIONS(3082),
    [anon_sym_values] = ACTIONS(3082),
    [anon_sym_write] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3082),
    [anon_sym___END__] = ACTIONS(3082),
    [anon_sym_EOT] = ACTIONS(3082),
    [anon_sym_q] = ACTIONS(3082),
    [anon_sym_qq] = ACTIONS(3082),
    [anon_sym_qw] = ACTIONS(3082),
    [anon_sym_qx] = ACTIONS(3082),
    [anon_sym_qr] = ACTIONS(3082),
    [anon_sym_m] = ACTIONS(3082),
    [anon_sym_s] = ACTIONS(3082),
    [anon_sym_tr] = ACTIONS(3082),
    [anon_sym_y] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_unless] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_until] = ACTIONS(3082),
    [aux_sym__bareword_token1] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym__apostrophe] = ACTIONS(3080),
    [sym__double_quote] = ACTIONS(3080),
    [sym__backtick] = ACTIONS(3080),
    [sym__search_slash] = ACTIONS(3080),
    [sym__PERLY_HEREDOC] = ACTIONS(3080),
    [sym__ctrl_z_hack] = ACTIONS(3080),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [989] = {
    [sym_heredoc_content] = STATE(989),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_LBRACE2] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_package] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_catch] = ACTIONS(2897),
    [anon_sym_finally] = ACTIONS(2897),
    [anon_sym_defer] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [990] = {
    [sym_heredoc_content] = STATE(990),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_LBRACE2] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_package] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_catch] = ACTIONS(2905),
    [anon_sym_finally] = ACTIONS(2905),
    [anon_sym_defer] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [991] = {
    [sym_heredoc_content] = STATE(991),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [sym__identifier] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LBRACE2] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_package] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_sub] = ACTIONS(3089),
    [anon_sym_method] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_my] = ACTIONS(3089),
    [anon_sym_state] = ACTIONS(3089),
    [anon_sym_our] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_defer] = ACTIONS(3089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3089),
    [anon_sym_else] = ACTIONS(3089),
    [anon_sym_elsif] = ACTIONS(3089),
    [anon_sym_and] = ACTIONS(3089),
    [anon_sym_or] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_AT] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_LT_LT] = ACTIONS(3089),
    [anon_sym_SLASH_SLASH] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_eq] = ACTIONS(3089),
    [anon_sym_ne] = ACTIONS(3089),
    [anon_sym_cmp] = ACTIONS(3089),
    [anon_sym_lt] = ACTIONS(3089),
    [anon_sym_le] = ACTIONS(3089),
    [anon_sym_ge] = ACTIONS(3089),
    [anon_sym_gt] = ACTIONS(3089),
    [anon_sym_isa] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_BSLASH] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_eval] = ACTIONS(3089),
    [anon_sym_field] = ACTIONS(3089),
    [anon_sym_local] = ACTIONS(3089),
    [anon_sym_require] = ACTIONS(3089),
    [anon_sym_map] = ACTIONS(3089),
    [anon_sym_grep] = ACTIONS(3089),
    [anon_sym_sort] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_undef] = ACTIONS(3089),
    [anon_sym_PERCENT2] = ACTIONS(3089),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3089),
    [anon_sym_no] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_foreach] = ACTIONS(3089),
    [anon_sym_last] = ACTIONS(3089),
    [anon_sym_next] = ACTIONS(3089),
    [anon_sym_redo] = ACTIONS(3089),
    [anon_sym_BEGIN] = ACTIONS(3089),
    [anon_sym_INIT] = ACTIONS(3089),
    [anon_sym_CHECK] = ACTIONS(3089),
    [anon_sym_UNITCHECK] = ACTIONS(3089),
    [anon_sym_END] = ACTIONS(3089),
    [anon_sym_ADJUST] = ACTIONS(3089),
    [anon_sym___FILE__] = ACTIONS(3089),
    [anon_sym___LINE__] = ACTIONS(3089),
    [anon_sym___PACKAGE__] = ACTIONS(3089),
    [anon_sym___SUB__] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_fork] = ACTIONS(3089),
    [anon_sym_getppid] = ACTIONS(3089),
    [anon_sym_time] = ACTIONS(3089),
    [anon_sym_times] = ACTIONS(3089),
    [anon_sym_wait] = ACTIONS(3089),
    [anon_sym_wantarray] = ACTIONS(3089),
    [anon_sym_abs] = ACTIONS(3089),
    [anon_sym_alarm] = ACTIONS(3089),
    [anon_sym_chop] = ACTIONS(3089),
    [anon_sym_chdir] = ACTIONS(3089),
    [anon_sym_close] = ACTIONS(3089),
    [anon_sym_closedir] = ACTIONS(3089),
    [anon_sym_caller] = ACTIONS(3089),
    [anon_sym_chomp] = ACTIONS(3089),
    [anon_sym_chr] = ACTIONS(3089),
    [anon_sym_cos] = ACTIONS(3089),
    [anon_sym_chroot] = ACTIONS(3089),
    [anon_sym_defined] = ACTIONS(3089),
    [anon_sym_delete] = ACTIONS(3089),
    [anon_sym_dbmclose] = ACTIONS(3089),
    [anon_sym_exists] = ACTIONS(3089),
    [anon_sym_exit] = ACTIONS(3089),
    [anon_sym_eof] = ACTIONS(3089),
    [anon_sym_exp] = ACTIONS(3089),
    [anon_sym_each] = ACTIONS(3089),
    [anon_sym_fc] = ACTIONS(3089),
    [anon_sym_fileno] = ACTIONS(3089),
    [anon_sym_gmtime] = ACTIONS(3089),
    [anon_sym_getc] = ACTIONS(3089),
    [anon_sym_getpgrp] = ACTIONS(3089),
    [anon_sym_getprotobyname] = ACTIONS(3089),
    [anon_sym_getpwname] = ACTIONS(3089),
    [anon_sym_getpwuid] = ACTIONS(3089),
    [anon_sym_getpeername] = ACTIONS(3089),
    [anon_sym_getnetbyname] = ACTIONS(3089),
    [anon_sym_getsockname] = ACTIONS(3089),
    [anon_sym_getgrnam] = ACTIONS(3089),
    [anon_sym_getgrgid] = ACTIONS(3089),
    [anon_sym_hex] = ACTIONS(3089),
    [anon_sym_int] = ACTIONS(3089),
    [anon_sym_keys] = ACTIONS(3089),
    [anon_sym_lc] = ACTIONS(3089),
    [anon_sym_lcfirst] = ACTIONS(3089),
    [anon_sym_length] = ACTIONS(3089),
    [anon_sym_localtime] = ACTIONS(3089),
    [anon_sym_log] = ACTIONS(3089),
    [anon_sym_lock] = ACTIONS(3089),
    [anon_sym_lstat] = ACTIONS(3089),
    [anon_sym_oct] = ACTIONS(3089),
    [anon_sym_ord] = ACTIONS(3089),
    [anon_sym_prototype] = ACTIONS(3089),
    [anon_sym_pop] = ACTIONS(3089),
    [anon_sym_pos] = ACTIONS(3089),
    [anon_sym_quotemeta] = ACTIONS(3089),
    [anon_sym_reset] = ACTIONS(3089),
    [anon_sym_rand] = ACTIONS(3089),
    [anon_sym_rmdir] = ACTIONS(3089),
    [anon_sym_readdir] = ACTIONS(3089),
    [anon_sym_readline] = ACTIONS(3089),
    [anon_sym_readpipe] = ACTIONS(3089),
    [anon_sym_rewinddir] = ACTIONS(3089),
    [anon_sym_readlink] = ACTIONS(3089),
    [anon_sym_ref] = ACTIONS(3089),
    [anon_sym_scalar] = ACTIONS(3089),
    [anon_sym_shift] = ACTIONS(3089),
    [anon_sym_sin] = ACTIONS(3089),
    [anon_sym_sleep] = ACTIONS(3089),
    [anon_sym_sqrt] = ACTIONS(3089),
    [anon_sym_srand] = ACTIONS(3089),
    [anon_sym_stat] = ACTIONS(3089),
    [anon_sym_study] = ACTIONS(3089),
    [anon_sym_tell] = ACTIONS(3089),
    [anon_sym_telldir] = ACTIONS(3089),
    [anon_sym_tied] = ACTIONS(3089),
    [anon_sym_uc] = ACTIONS(3089),
    [anon_sym_ucfirst] = ACTIONS(3089),
    [anon_sym_untie] = ACTIONS(3089),
    [anon_sym_umask] = ACTIONS(3089),
    [anon_sym_values] = ACTIONS(3089),
    [anon_sym_write] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3089),
    [anon_sym___END__] = ACTIONS(3089),
    [anon_sym_EOT] = ACTIONS(3089),
    [anon_sym_q] = ACTIONS(3089),
    [anon_sym_qq] = ACTIONS(3089),
    [anon_sym_qw] = ACTIONS(3089),
    [anon_sym_qx] = ACTIONS(3089),
    [anon_sym_qr] = ACTIONS(3089),
    [anon_sym_m] = ACTIONS(3089),
    [anon_sym_s] = ACTIONS(3089),
    [anon_sym_tr] = ACTIONS(3089),
    [anon_sym_y] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_unless] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_until] = ACTIONS(3089),
    [aux_sym__bareword_token1] = ACTIONS(3089),
    [sym_number] = ACTIONS(3089),
    [sym__apostrophe] = ACTIONS(3087),
    [sym__double_quote] = ACTIONS(3087),
    [sym__backtick] = ACTIONS(3087),
    [sym__search_slash] = ACTIONS(3087),
    [sym__PERLY_HEREDOC] = ACTIONS(3087),
    [sym__ctrl_z_hack] = ACTIONS(3087),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [992] = {
    [sym_heredoc_content] = STATE(992),
    [ts_builtin_sym_end] = ACTIONS(3091),
    [sym__identifier] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_LBRACE2] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_package] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_sub] = ACTIONS(3093),
    [anon_sym_method] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_my] = ACTIONS(3093),
    [anon_sym_state] = ACTIONS(3093),
    [anon_sym_our] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_defer] = ACTIONS(3093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3093),
    [anon_sym_else] = ACTIONS(3093),
    [anon_sym_elsif] = ACTIONS(3093),
    [anon_sym_and] = ACTIONS(3093),
    [anon_sym_or] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_SLASH_SLASH] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_eq] = ACTIONS(3093),
    [anon_sym_ne] = ACTIONS(3093),
    [anon_sym_cmp] = ACTIONS(3093),
    [anon_sym_lt] = ACTIONS(3093),
    [anon_sym_le] = ACTIONS(3093),
    [anon_sym_ge] = ACTIONS(3093),
    [anon_sym_gt] = ACTIONS(3093),
    [anon_sym_isa] = ACTIONS(3093),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [anon_sym_BSLASH] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_eval] = ACTIONS(3093),
    [anon_sym_field] = ACTIONS(3093),
    [anon_sym_local] = ACTIONS(3093),
    [anon_sym_require] = ACTIONS(3093),
    [anon_sym_map] = ACTIONS(3093),
    [anon_sym_grep] = ACTIONS(3093),
    [anon_sym_sort] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_undef] = ACTIONS(3093),
    [anon_sym_PERCENT2] = ACTIONS(3093),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3093),
    [anon_sym_no] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_foreach] = ACTIONS(3093),
    [anon_sym_last] = ACTIONS(3093),
    [anon_sym_next] = ACTIONS(3093),
    [anon_sym_redo] = ACTIONS(3093),
    [anon_sym_BEGIN] = ACTIONS(3093),
    [anon_sym_INIT] = ACTIONS(3093),
    [anon_sym_CHECK] = ACTIONS(3093),
    [anon_sym_UNITCHECK] = ACTIONS(3093),
    [anon_sym_END] = ACTIONS(3093),
    [anon_sym_ADJUST] = ACTIONS(3093),
    [anon_sym___FILE__] = ACTIONS(3093),
    [anon_sym___LINE__] = ACTIONS(3093),
    [anon_sym___PACKAGE__] = ACTIONS(3093),
    [anon_sym___SUB__] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_fork] = ACTIONS(3093),
    [anon_sym_getppid] = ACTIONS(3093),
    [anon_sym_time] = ACTIONS(3093),
    [anon_sym_times] = ACTIONS(3093),
    [anon_sym_wait] = ACTIONS(3093),
    [anon_sym_wantarray] = ACTIONS(3093),
    [anon_sym_abs] = ACTIONS(3093),
    [anon_sym_alarm] = ACTIONS(3093),
    [anon_sym_chop] = ACTIONS(3093),
    [anon_sym_chdir] = ACTIONS(3093),
    [anon_sym_close] = ACTIONS(3093),
    [anon_sym_closedir] = ACTIONS(3093),
    [anon_sym_caller] = ACTIONS(3093),
    [anon_sym_chomp] = ACTIONS(3093),
    [anon_sym_chr] = ACTIONS(3093),
    [anon_sym_cos] = ACTIONS(3093),
    [anon_sym_chroot] = ACTIONS(3093),
    [anon_sym_defined] = ACTIONS(3093),
    [anon_sym_delete] = ACTIONS(3093),
    [anon_sym_dbmclose] = ACTIONS(3093),
    [anon_sym_exists] = ACTIONS(3093),
    [anon_sym_exit] = ACTIONS(3093),
    [anon_sym_eof] = ACTIONS(3093),
    [anon_sym_exp] = ACTIONS(3093),
    [anon_sym_each] = ACTIONS(3093),
    [anon_sym_fc] = ACTIONS(3093),
    [anon_sym_fileno] = ACTIONS(3093),
    [anon_sym_gmtime] = ACTIONS(3093),
    [anon_sym_getc] = ACTIONS(3093),
    [anon_sym_getpgrp] = ACTIONS(3093),
    [anon_sym_getprotobyname] = ACTIONS(3093),
    [anon_sym_getpwname] = ACTIONS(3093),
    [anon_sym_getpwuid] = ACTIONS(3093),
    [anon_sym_getpeername] = ACTIONS(3093),
    [anon_sym_getnetbyname] = ACTIONS(3093),
    [anon_sym_getsockname] = ACTIONS(3093),
    [anon_sym_getgrnam] = ACTIONS(3093),
    [anon_sym_getgrgid] = ACTIONS(3093),
    [anon_sym_hex] = ACTIONS(3093),
    [anon_sym_int] = ACTIONS(3093),
    [anon_sym_keys] = ACTIONS(3093),
    [anon_sym_lc] = ACTIONS(3093),
    [anon_sym_lcfirst] = ACTIONS(3093),
    [anon_sym_length] = ACTIONS(3093),
    [anon_sym_localtime] = ACTIONS(3093),
    [anon_sym_log] = ACTIONS(3093),
    [anon_sym_lock] = ACTIONS(3093),
    [anon_sym_lstat] = ACTIONS(3093),
    [anon_sym_oct] = ACTIONS(3093),
    [anon_sym_ord] = ACTIONS(3093),
    [anon_sym_prototype] = ACTIONS(3093),
    [anon_sym_pop] = ACTIONS(3093),
    [anon_sym_pos] = ACTIONS(3093),
    [anon_sym_quotemeta] = ACTIONS(3093),
    [anon_sym_reset] = ACTIONS(3093),
    [anon_sym_rand] = ACTIONS(3093),
    [anon_sym_rmdir] = ACTIONS(3093),
    [anon_sym_readdir] = ACTIONS(3093),
    [anon_sym_readline] = ACTIONS(3093),
    [anon_sym_readpipe] = ACTIONS(3093),
    [anon_sym_rewinddir] = ACTIONS(3093),
    [anon_sym_readlink] = ACTIONS(3093),
    [anon_sym_ref] = ACTIONS(3093),
    [anon_sym_scalar] = ACTIONS(3093),
    [anon_sym_shift] = ACTIONS(3093),
    [anon_sym_sin] = ACTIONS(3093),
    [anon_sym_sleep] = ACTIONS(3093),
    [anon_sym_sqrt] = ACTIONS(3093),
    [anon_sym_srand] = ACTIONS(3093),
    [anon_sym_stat] = ACTIONS(3093),
    [anon_sym_study] = ACTIONS(3093),
    [anon_sym_tell] = ACTIONS(3093),
    [anon_sym_telldir] = ACTIONS(3093),
    [anon_sym_tied] = ACTIONS(3093),
    [anon_sym_uc] = ACTIONS(3093),
    [anon_sym_ucfirst] = ACTIONS(3093),
    [anon_sym_untie] = ACTIONS(3093),
    [anon_sym_umask] = ACTIONS(3093),
    [anon_sym_values] = ACTIONS(3093),
    [anon_sym_write] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3093),
    [anon_sym___END__] = ACTIONS(3093),
    [anon_sym_EOT] = ACTIONS(3093),
    [anon_sym_q] = ACTIONS(3093),
    [anon_sym_qq] = ACTIONS(3093),
    [anon_sym_qw] = ACTIONS(3093),
    [anon_sym_qx] = ACTIONS(3093),
    [anon_sym_qr] = ACTIONS(3093),
    [anon_sym_m] = ACTIONS(3093),
    [anon_sym_s] = ACTIONS(3093),
    [anon_sym_tr] = ACTIONS(3093),
    [anon_sym_y] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_unless] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_until] = ACTIONS(3093),
    [aux_sym__bareword_token1] = ACTIONS(3093),
    [sym_number] = ACTIONS(3093),
    [sym__apostrophe] = ACTIONS(3091),
    [sym__double_quote] = ACTIONS(3091),
    [sym__backtick] = ACTIONS(3091),
    [sym__search_slash] = ACTIONS(3091),
    [sym__PERLY_HEREDOC] = ACTIONS(3091),
    [sym__ctrl_z_hack] = ACTIONS(3091),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [993] = {
    [sym_heredoc_content] = STATE(993),
    [ts_builtin_sym_end] = ACTIONS(3095),
    [sym__identifier] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3097),
    [anon_sym_LBRACE2] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_package] = ACTIONS(3097),
    [anon_sym_class] = ACTIONS(3097),
    [anon_sym_sub] = ACTIONS(3097),
    [anon_sym_method] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3097),
    [anon_sym_continue] = ACTIONS(3097),
    [anon_sym_my] = ACTIONS(3097),
    [anon_sym_state] = ACTIONS(3097),
    [anon_sym_our] = ACTIONS(3097),
    [anon_sym_try] = ACTIONS(3097),
    [anon_sym_defer] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(3097),
    [anon_sym_elsif] = ACTIONS(3097),
    [anon_sym_and] = ACTIONS(3097),
    [anon_sym_or] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3097),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_AT] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_SLASH_SLASH] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_eq] = ACTIONS(3097),
    [anon_sym_ne] = ACTIONS(3097),
    [anon_sym_cmp] = ACTIONS(3097),
    [anon_sym_lt] = ACTIONS(3097),
    [anon_sym_le] = ACTIONS(3097),
    [anon_sym_ge] = ACTIONS(3097),
    [anon_sym_gt] = ACTIONS(3097),
    [anon_sym_isa] = ACTIONS(3097),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_PLUS_PLUS] = ACTIONS(3097),
    [anon_sym_DASH_DASH] = ACTIONS(3097),
    [anon_sym_BSLASH] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3097),
    [anon_sym_eval] = ACTIONS(3097),
    [anon_sym_field] = ACTIONS(3097),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_require] = ACTIONS(3097),
    [anon_sym_map] = ACTIONS(3097),
    [anon_sym_grep] = ACTIONS(3097),
    [anon_sym_sort] = ACTIONS(3097),
    [anon_sym_goto] = ACTIONS(3097),
    [anon_sym_return] = ACTIONS(3097),
    [anon_sym_undef] = ACTIONS(3097),
    [anon_sym_PERCENT2] = ACTIONS(3097),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3097),
    [anon_sym_no] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3097),
    [anon_sym_foreach] = ACTIONS(3097),
    [anon_sym_last] = ACTIONS(3097),
    [anon_sym_next] = ACTIONS(3097),
    [anon_sym_redo] = ACTIONS(3097),
    [anon_sym_BEGIN] = ACTIONS(3097),
    [anon_sym_INIT] = ACTIONS(3097),
    [anon_sym_CHECK] = ACTIONS(3097),
    [anon_sym_UNITCHECK] = ACTIONS(3097),
    [anon_sym_END] = ACTIONS(3097),
    [anon_sym_ADJUST] = ACTIONS(3097),
    [anon_sym___FILE__] = ACTIONS(3097),
    [anon_sym___LINE__] = ACTIONS(3097),
    [anon_sym___PACKAGE__] = ACTIONS(3097),
    [anon_sym___SUB__] = ACTIONS(3097),
    [anon_sym_break] = ACTIONS(3097),
    [anon_sym_fork] = ACTIONS(3097),
    [anon_sym_getppid] = ACTIONS(3097),
    [anon_sym_time] = ACTIONS(3097),
    [anon_sym_times] = ACTIONS(3097),
    [anon_sym_wait] = ACTIONS(3097),
    [anon_sym_wantarray] = ACTIONS(3097),
    [anon_sym_abs] = ACTIONS(3097),
    [anon_sym_alarm] = ACTIONS(3097),
    [anon_sym_chop] = ACTIONS(3097),
    [anon_sym_chdir] = ACTIONS(3097),
    [anon_sym_close] = ACTIONS(3097),
    [anon_sym_closedir] = ACTIONS(3097),
    [anon_sym_caller] = ACTIONS(3097),
    [anon_sym_chomp] = ACTIONS(3097),
    [anon_sym_chr] = ACTIONS(3097),
    [anon_sym_cos] = ACTIONS(3097),
    [anon_sym_chroot] = ACTIONS(3097),
    [anon_sym_defined] = ACTIONS(3097),
    [anon_sym_delete] = ACTIONS(3097),
    [anon_sym_dbmclose] = ACTIONS(3097),
    [anon_sym_exists] = ACTIONS(3097),
    [anon_sym_exit] = ACTIONS(3097),
    [anon_sym_eof] = ACTIONS(3097),
    [anon_sym_exp] = ACTIONS(3097),
    [anon_sym_each] = ACTIONS(3097),
    [anon_sym_fc] = ACTIONS(3097),
    [anon_sym_fileno] = ACTIONS(3097),
    [anon_sym_gmtime] = ACTIONS(3097),
    [anon_sym_getc] = ACTIONS(3097),
    [anon_sym_getpgrp] = ACTIONS(3097),
    [anon_sym_getprotobyname] = ACTIONS(3097),
    [anon_sym_getpwname] = ACTIONS(3097),
    [anon_sym_getpwuid] = ACTIONS(3097),
    [anon_sym_getpeername] = ACTIONS(3097),
    [anon_sym_getnetbyname] = ACTIONS(3097),
    [anon_sym_getsockname] = ACTIONS(3097),
    [anon_sym_getgrnam] = ACTIONS(3097),
    [anon_sym_getgrgid] = ACTIONS(3097),
    [anon_sym_hex] = ACTIONS(3097),
    [anon_sym_int] = ACTIONS(3097),
    [anon_sym_keys] = ACTIONS(3097),
    [anon_sym_lc] = ACTIONS(3097),
    [anon_sym_lcfirst] = ACTIONS(3097),
    [anon_sym_length] = ACTIONS(3097),
    [anon_sym_localtime] = ACTIONS(3097),
    [anon_sym_log] = ACTIONS(3097),
    [anon_sym_lock] = ACTIONS(3097),
    [anon_sym_lstat] = ACTIONS(3097),
    [anon_sym_oct] = ACTIONS(3097),
    [anon_sym_ord] = ACTIONS(3097),
    [anon_sym_prototype] = ACTIONS(3097),
    [anon_sym_pop] = ACTIONS(3097),
    [anon_sym_pos] = ACTIONS(3097),
    [anon_sym_quotemeta] = ACTIONS(3097),
    [anon_sym_reset] = ACTIONS(3097),
    [anon_sym_rand] = ACTIONS(3097),
    [anon_sym_rmdir] = ACTIONS(3097),
    [anon_sym_readdir] = ACTIONS(3097),
    [anon_sym_readline] = ACTIONS(3097),
    [anon_sym_readpipe] = ACTIONS(3097),
    [anon_sym_rewinddir] = ACTIONS(3097),
    [anon_sym_readlink] = ACTIONS(3097),
    [anon_sym_ref] = ACTIONS(3097),
    [anon_sym_scalar] = ACTIONS(3097),
    [anon_sym_shift] = ACTIONS(3097),
    [anon_sym_sin] = ACTIONS(3097),
    [anon_sym_sleep] = ACTIONS(3097),
    [anon_sym_sqrt] = ACTIONS(3097),
    [anon_sym_srand] = ACTIONS(3097),
    [anon_sym_stat] = ACTIONS(3097),
    [anon_sym_study] = ACTIONS(3097),
    [anon_sym_tell] = ACTIONS(3097),
    [anon_sym_telldir] = ACTIONS(3097),
    [anon_sym_tied] = ACTIONS(3097),
    [anon_sym_uc] = ACTIONS(3097),
    [anon_sym_ucfirst] = ACTIONS(3097),
    [anon_sym_untie] = ACTIONS(3097),
    [anon_sym_umask] = ACTIONS(3097),
    [anon_sym_values] = ACTIONS(3097),
    [anon_sym_write] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3097),
    [anon_sym___END__] = ACTIONS(3097),
    [anon_sym_EOT] = ACTIONS(3097),
    [anon_sym_q] = ACTIONS(3097),
    [anon_sym_qq] = ACTIONS(3097),
    [anon_sym_qw] = ACTIONS(3097),
    [anon_sym_qx] = ACTIONS(3097),
    [anon_sym_qr] = ACTIONS(3097),
    [anon_sym_m] = ACTIONS(3097),
    [anon_sym_s] = ACTIONS(3097),
    [anon_sym_tr] = ACTIONS(3097),
    [anon_sym_y] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3097),
    [anon_sym_unless] = ACTIONS(3097),
    [anon_sym_while] = ACTIONS(3097),
    [anon_sym_until] = ACTIONS(3097),
    [aux_sym__bareword_token1] = ACTIONS(3097),
    [sym_number] = ACTIONS(3097),
    [sym__apostrophe] = ACTIONS(3095),
    [sym__double_quote] = ACTIONS(3095),
    [sym__backtick] = ACTIONS(3095),
    [sym__search_slash] = ACTIONS(3095),
    [sym__PERLY_HEREDOC] = ACTIONS(3095),
    [sym__ctrl_z_hack] = ACTIONS(3095),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [994] = {
    [sym_heredoc_content] = STATE(994),
    [ts_builtin_sym_end] = ACTIONS(3099),
    [sym__identifier] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_LBRACE2] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym_package] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_sub] = ACTIONS(3101),
    [anon_sym_method] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_my] = ACTIONS(3101),
    [anon_sym_state] = ACTIONS(3101),
    [anon_sym_our] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_defer] = ACTIONS(3101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3101),
    [anon_sym_else] = ACTIONS(3101),
    [anon_sym_elsif] = ACTIONS(3101),
    [anon_sym_and] = ACTIONS(3101),
    [anon_sym_or] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_AT] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_LT_LT] = ACTIONS(3101),
    [anon_sym_SLASH_SLASH] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_eq] = ACTIONS(3101),
    [anon_sym_ne] = ACTIONS(3101),
    [anon_sym_cmp] = ACTIONS(3101),
    [anon_sym_lt] = ACTIONS(3101),
    [anon_sym_le] = ACTIONS(3101),
    [anon_sym_ge] = ACTIONS(3101),
    [anon_sym_gt] = ACTIONS(3101),
    [anon_sym_isa] = ACTIONS(3101),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_PLUS_PLUS] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3101),
    [anon_sym_BSLASH] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_eval] = ACTIONS(3101),
    [anon_sym_field] = ACTIONS(3101),
    [anon_sym_local] = ACTIONS(3101),
    [anon_sym_require] = ACTIONS(3101),
    [anon_sym_map] = ACTIONS(3101),
    [anon_sym_grep] = ACTIONS(3101),
    [anon_sym_sort] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_undef] = ACTIONS(3101),
    [anon_sym_PERCENT2] = ACTIONS(3101),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3101),
    [anon_sym_no] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_foreach] = ACTIONS(3101),
    [anon_sym_last] = ACTIONS(3101),
    [anon_sym_next] = ACTIONS(3101),
    [anon_sym_redo] = ACTIONS(3101),
    [anon_sym_BEGIN] = ACTIONS(3101),
    [anon_sym_INIT] = ACTIONS(3101),
    [anon_sym_CHECK] = ACTIONS(3101),
    [anon_sym_UNITCHECK] = ACTIONS(3101),
    [anon_sym_END] = ACTIONS(3101),
    [anon_sym_ADJUST] = ACTIONS(3101),
    [anon_sym___FILE__] = ACTIONS(3101),
    [anon_sym___LINE__] = ACTIONS(3101),
    [anon_sym___PACKAGE__] = ACTIONS(3101),
    [anon_sym___SUB__] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_fork] = ACTIONS(3101),
    [anon_sym_getppid] = ACTIONS(3101),
    [anon_sym_time] = ACTIONS(3101),
    [anon_sym_times] = ACTIONS(3101),
    [anon_sym_wait] = ACTIONS(3101),
    [anon_sym_wantarray] = ACTIONS(3101),
    [anon_sym_abs] = ACTIONS(3101),
    [anon_sym_alarm] = ACTIONS(3101),
    [anon_sym_chop] = ACTIONS(3101),
    [anon_sym_chdir] = ACTIONS(3101),
    [anon_sym_close] = ACTIONS(3101),
    [anon_sym_closedir] = ACTIONS(3101),
    [anon_sym_caller] = ACTIONS(3101),
    [anon_sym_chomp] = ACTIONS(3101),
    [anon_sym_chr] = ACTIONS(3101),
    [anon_sym_cos] = ACTIONS(3101),
    [anon_sym_chroot] = ACTIONS(3101),
    [anon_sym_defined] = ACTIONS(3101),
    [anon_sym_delete] = ACTIONS(3101),
    [anon_sym_dbmclose] = ACTIONS(3101),
    [anon_sym_exists] = ACTIONS(3101),
    [anon_sym_exit] = ACTIONS(3101),
    [anon_sym_eof] = ACTIONS(3101),
    [anon_sym_exp] = ACTIONS(3101),
    [anon_sym_each] = ACTIONS(3101),
    [anon_sym_fc] = ACTIONS(3101),
    [anon_sym_fileno] = ACTIONS(3101),
    [anon_sym_gmtime] = ACTIONS(3101),
    [anon_sym_getc] = ACTIONS(3101),
    [anon_sym_getpgrp] = ACTIONS(3101),
    [anon_sym_getprotobyname] = ACTIONS(3101),
    [anon_sym_getpwname] = ACTIONS(3101),
    [anon_sym_getpwuid] = ACTIONS(3101),
    [anon_sym_getpeername] = ACTIONS(3101),
    [anon_sym_getnetbyname] = ACTIONS(3101),
    [anon_sym_getsockname] = ACTIONS(3101),
    [anon_sym_getgrnam] = ACTIONS(3101),
    [anon_sym_getgrgid] = ACTIONS(3101),
    [anon_sym_hex] = ACTIONS(3101),
    [anon_sym_int] = ACTIONS(3101),
    [anon_sym_keys] = ACTIONS(3101),
    [anon_sym_lc] = ACTIONS(3101),
    [anon_sym_lcfirst] = ACTIONS(3101),
    [anon_sym_length] = ACTIONS(3101),
    [anon_sym_localtime] = ACTIONS(3101),
    [anon_sym_log] = ACTIONS(3101),
    [anon_sym_lock] = ACTIONS(3101),
    [anon_sym_lstat] = ACTIONS(3101),
    [anon_sym_oct] = ACTIONS(3101),
    [anon_sym_ord] = ACTIONS(3101),
    [anon_sym_prototype] = ACTIONS(3101),
    [anon_sym_pop] = ACTIONS(3101),
    [anon_sym_pos] = ACTIONS(3101),
    [anon_sym_quotemeta] = ACTIONS(3101),
    [anon_sym_reset] = ACTIONS(3101),
    [anon_sym_rand] = ACTIONS(3101),
    [anon_sym_rmdir] = ACTIONS(3101),
    [anon_sym_readdir] = ACTIONS(3101),
    [anon_sym_readline] = ACTIONS(3101),
    [anon_sym_readpipe] = ACTIONS(3101),
    [anon_sym_rewinddir] = ACTIONS(3101),
    [anon_sym_readlink] = ACTIONS(3101),
    [anon_sym_ref] = ACTIONS(3101),
    [anon_sym_scalar] = ACTIONS(3101),
    [anon_sym_shift] = ACTIONS(3101),
    [anon_sym_sin] = ACTIONS(3101),
    [anon_sym_sleep] = ACTIONS(3101),
    [anon_sym_sqrt] = ACTIONS(3101),
    [anon_sym_srand] = ACTIONS(3101),
    [anon_sym_stat] = ACTIONS(3101),
    [anon_sym_study] = ACTIONS(3101),
    [anon_sym_tell] = ACTIONS(3101),
    [anon_sym_telldir] = ACTIONS(3101),
    [anon_sym_tied] = ACTIONS(3101),
    [anon_sym_uc] = ACTIONS(3101),
    [anon_sym_ucfirst] = ACTIONS(3101),
    [anon_sym_untie] = ACTIONS(3101),
    [anon_sym_umask] = ACTIONS(3101),
    [anon_sym_values] = ACTIONS(3101),
    [anon_sym_write] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3101),
    [anon_sym___END__] = ACTIONS(3101),
    [anon_sym_EOT] = ACTIONS(3101),
    [anon_sym_q] = ACTIONS(3101),
    [anon_sym_qq] = ACTIONS(3101),
    [anon_sym_qw] = ACTIONS(3101),
    [anon_sym_qx] = ACTIONS(3101),
    [anon_sym_qr] = ACTIONS(3101),
    [anon_sym_m] = ACTIONS(3101),
    [anon_sym_s] = ACTIONS(3101),
    [anon_sym_tr] = ACTIONS(3101),
    [anon_sym_y] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_unless] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_until] = ACTIONS(3101),
    [aux_sym__bareword_token1] = ACTIONS(3101),
    [sym_number] = ACTIONS(3101),
    [sym__apostrophe] = ACTIONS(3099),
    [sym__double_quote] = ACTIONS(3099),
    [sym__backtick] = ACTIONS(3099),
    [sym__search_slash] = ACTIONS(3099),
    [sym__PERLY_HEREDOC] = ACTIONS(3099),
    [sym__ctrl_z_hack] = ACTIONS(3099),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [995] = {
    [sym_heredoc_content] = STATE(995),
    [ts_builtin_sym_end] = ACTIONS(3103),
    [sym__identifier] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3105),
    [anon_sym_LBRACE2] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_package] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_sub] = ACTIONS(3105),
    [anon_sym_method] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_my] = ACTIONS(3105),
    [anon_sym_state] = ACTIONS(3105),
    [anon_sym_our] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_defer] = ACTIONS(3105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3105),
    [anon_sym_elsif] = ACTIONS(3105),
    [anon_sym_and] = ACTIONS(3105),
    [anon_sym_or] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_AT] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_LT_LT] = ACTIONS(3105),
    [anon_sym_SLASH_SLASH] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_eq] = ACTIONS(3105),
    [anon_sym_ne] = ACTIONS(3105),
    [anon_sym_cmp] = ACTIONS(3105),
    [anon_sym_lt] = ACTIONS(3105),
    [anon_sym_le] = ACTIONS(3105),
    [anon_sym_ge] = ACTIONS(3105),
    [anon_sym_gt] = ACTIONS(3105),
    [anon_sym_isa] = ACTIONS(3105),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_PLUS_PLUS] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3105),
    [anon_sym_BSLASH] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_eval] = ACTIONS(3105),
    [anon_sym_field] = ACTIONS(3105),
    [anon_sym_local] = ACTIONS(3105),
    [anon_sym_require] = ACTIONS(3105),
    [anon_sym_map] = ACTIONS(3105),
    [anon_sym_grep] = ACTIONS(3105),
    [anon_sym_sort] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_undef] = ACTIONS(3105),
    [anon_sym_PERCENT2] = ACTIONS(3105),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3105),
    [anon_sym_no] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_foreach] = ACTIONS(3105),
    [anon_sym_last] = ACTIONS(3105),
    [anon_sym_next] = ACTIONS(3105),
    [anon_sym_redo] = ACTIONS(3105),
    [anon_sym_BEGIN] = ACTIONS(3105),
    [anon_sym_INIT] = ACTIONS(3105),
    [anon_sym_CHECK] = ACTIONS(3105),
    [anon_sym_UNITCHECK] = ACTIONS(3105),
    [anon_sym_END] = ACTIONS(3105),
    [anon_sym_ADJUST] = ACTIONS(3105),
    [anon_sym___FILE__] = ACTIONS(3105),
    [anon_sym___LINE__] = ACTIONS(3105),
    [anon_sym___PACKAGE__] = ACTIONS(3105),
    [anon_sym___SUB__] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_fork] = ACTIONS(3105),
    [anon_sym_getppid] = ACTIONS(3105),
    [anon_sym_time] = ACTIONS(3105),
    [anon_sym_times] = ACTIONS(3105),
    [anon_sym_wait] = ACTIONS(3105),
    [anon_sym_wantarray] = ACTIONS(3105),
    [anon_sym_abs] = ACTIONS(3105),
    [anon_sym_alarm] = ACTIONS(3105),
    [anon_sym_chop] = ACTIONS(3105),
    [anon_sym_chdir] = ACTIONS(3105),
    [anon_sym_close] = ACTIONS(3105),
    [anon_sym_closedir] = ACTIONS(3105),
    [anon_sym_caller] = ACTIONS(3105),
    [anon_sym_chomp] = ACTIONS(3105),
    [anon_sym_chr] = ACTIONS(3105),
    [anon_sym_cos] = ACTIONS(3105),
    [anon_sym_chroot] = ACTIONS(3105),
    [anon_sym_defined] = ACTIONS(3105),
    [anon_sym_delete] = ACTIONS(3105),
    [anon_sym_dbmclose] = ACTIONS(3105),
    [anon_sym_exists] = ACTIONS(3105),
    [anon_sym_exit] = ACTIONS(3105),
    [anon_sym_eof] = ACTIONS(3105),
    [anon_sym_exp] = ACTIONS(3105),
    [anon_sym_each] = ACTIONS(3105),
    [anon_sym_fc] = ACTIONS(3105),
    [anon_sym_fileno] = ACTIONS(3105),
    [anon_sym_gmtime] = ACTIONS(3105),
    [anon_sym_getc] = ACTIONS(3105),
    [anon_sym_getpgrp] = ACTIONS(3105),
    [anon_sym_getprotobyname] = ACTIONS(3105),
    [anon_sym_getpwname] = ACTIONS(3105),
    [anon_sym_getpwuid] = ACTIONS(3105),
    [anon_sym_getpeername] = ACTIONS(3105),
    [anon_sym_getnetbyname] = ACTIONS(3105),
    [anon_sym_getsockname] = ACTIONS(3105),
    [anon_sym_getgrnam] = ACTIONS(3105),
    [anon_sym_getgrgid] = ACTIONS(3105),
    [anon_sym_hex] = ACTIONS(3105),
    [anon_sym_int] = ACTIONS(3105),
    [anon_sym_keys] = ACTIONS(3105),
    [anon_sym_lc] = ACTIONS(3105),
    [anon_sym_lcfirst] = ACTIONS(3105),
    [anon_sym_length] = ACTIONS(3105),
    [anon_sym_localtime] = ACTIONS(3105),
    [anon_sym_log] = ACTIONS(3105),
    [anon_sym_lock] = ACTIONS(3105),
    [anon_sym_lstat] = ACTIONS(3105),
    [anon_sym_oct] = ACTIONS(3105),
    [anon_sym_ord] = ACTIONS(3105),
    [anon_sym_prototype] = ACTIONS(3105),
    [anon_sym_pop] = ACTIONS(3105),
    [anon_sym_pos] = ACTIONS(3105),
    [anon_sym_quotemeta] = ACTIONS(3105),
    [anon_sym_reset] = ACTIONS(3105),
    [anon_sym_rand] = ACTIONS(3105),
    [anon_sym_rmdir] = ACTIONS(3105),
    [anon_sym_readdir] = ACTIONS(3105),
    [anon_sym_readline] = ACTIONS(3105),
    [anon_sym_readpipe] = ACTIONS(3105),
    [anon_sym_rewinddir] = ACTIONS(3105),
    [anon_sym_readlink] = ACTIONS(3105),
    [anon_sym_ref] = ACTIONS(3105),
    [anon_sym_scalar] = ACTIONS(3105),
    [anon_sym_shift] = ACTIONS(3105),
    [anon_sym_sin] = ACTIONS(3105),
    [anon_sym_sleep] = ACTIONS(3105),
    [anon_sym_sqrt] = ACTIONS(3105),
    [anon_sym_srand] = ACTIONS(3105),
    [anon_sym_stat] = ACTIONS(3105),
    [anon_sym_study] = ACTIONS(3105),
    [anon_sym_tell] = ACTIONS(3105),
    [anon_sym_telldir] = ACTIONS(3105),
    [anon_sym_tied] = ACTIONS(3105),
    [anon_sym_uc] = ACTIONS(3105),
    [anon_sym_ucfirst] = ACTIONS(3105),
    [anon_sym_untie] = ACTIONS(3105),
    [anon_sym_umask] = ACTIONS(3105),
    [anon_sym_values] = ACTIONS(3105),
    [anon_sym_write] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3105),
    [anon_sym___END__] = ACTIONS(3105),
    [anon_sym_EOT] = ACTIONS(3105),
    [anon_sym_q] = ACTIONS(3105),
    [anon_sym_qq] = ACTIONS(3105),
    [anon_sym_qw] = ACTIONS(3105),
    [anon_sym_qx] = ACTIONS(3105),
    [anon_sym_qr] = ACTIONS(3105),
    [anon_sym_m] = ACTIONS(3105),
    [anon_sym_s] = ACTIONS(3105),
    [anon_sym_tr] = ACTIONS(3105),
    [anon_sym_y] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_unless] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_until] = ACTIONS(3105),
    [aux_sym__bareword_token1] = ACTIONS(3105),
    [sym_number] = ACTIONS(3105),
    [sym__apostrophe] = ACTIONS(3103),
    [sym__double_quote] = ACTIONS(3103),
    [sym__backtick] = ACTIONS(3103),
    [sym__search_slash] = ACTIONS(3103),
    [sym__PERLY_HEREDOC] = ACTIONS(3103),
    [sym__ctrl_z_hack] = ACTIONS(3103),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [996] = {
    [sym_heredoc_content] = STATE(996),
    [ts_builtin_sym_end] = ACTIONS(3107),
    [sym__identifier] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_LBRACE2] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(3109),
    [anon_sym_package] = ACTIONS(3109),
    [anon_sym_class] = ACTIONS(3109),
    [anon_sym_sub] = ACTIONS(3109),
    [anon_sym_method] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3109),
    [anon_sym_continue] = ACTIONS(3109),
    [anon_sym_my] = ACTIONS(3109),
    [anon_sym_state] = ACTIONS(3109),
    [anon_sym_our] = ACTIONS(3109),
    [anon_sym_try] = ACTIONS(3109),
    [anon_sym_defer] = ACTIONS(3109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3109),
    [anon_sym_else] = ACTIONS(3109),
    [anon_sym_elsif] = ACTIONS(3109),
    [anon_sym_and] = ACTIONS(3109),
    [anon_sym_or] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_LBRACK] = ACTIONS(3109),
    [anon_sym_AT] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(3109),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_DASH] = ACTIONS(3109),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_eq] = ACTIONS(3109),
    [anon_sym_ne] = ACTIONS(3109),
    [anon_sym_cmp] = ACTIONS(3109),
    [anon_sym_lt] = ACTIONS(3109),
    [anon_sym_le] = ACTIONS(3109),
    [anon_sym_ge] = ACTIONS(3109),
    [anon_sym_gt] = ACTIONS(3109),
    [anon_sym_isa] = ACTIONS(3109),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_PLUS_PLUS] = ACTIONS(3109),
    [anon_sym_DASH_DASH] = ACTIONS(3109),
    [anon_sym_BSLASH] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3109),
    [anon_sym_eval] = ACTIONS(3109),
    [anon_sym_field] = ACTIONS(3109),
    [anon_sym_local] = ACTIONS(3109),
    [anon_sym_require] = ACTIONS(3109),
    [anon_sym_map] = ACTIONS(3109),
    [anon_sym_grep] = ACTIONS(3109),
    [anon_sym_sort] = ACTIONS(3109),
    [anon_sym_goto] = ACTIONS(3109),
    [anon_sym_return] = ACTIONS(3109),
    [anon_sym_undef] = ACTIONS(3109),
    [anon_sym_PERCENT2] = ACTIONS(3109),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3109),
    [anon_sym_no] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3109),
    [anon_sym_foreach] = ACTIONS(3109),
    [anon_sym_last] = ACTIONS(3109),
    [anon_sym_next] = ACTIONS(3109),
    [anon_sym_redo] = ACTIONS(3109),
    [anon_sym_BEGIN] = ACTIONS(3109),
    [anon_sym_INIT] = ACTIONS(3109),
    [anon_sym_CHECK] = ACTIONS(3109),
    [anon_sym_UNITCHECK] = ACTIONS(3109),
    [anon_sym_END] = ACTIONS(3109),
    [anon_sym_ADJUST] = ACTIONS(3109),
    [anon_sym___FILE__] = ACTIONS(3109),
    [anon_sym___LINE__] = ACTIONS(3109),
    [anon_sym___PACKAGE__] = ACTIONS(3109),
    [anon_sym___SUB__] = ACTIONS(3109),
    [anon_sym_break] = ACTIONS(3109),
    [anon_sym_fork] = ACTIONS(3109),
    [anon_sym_getppid] = ACTIONS(3109),
    [anon_sym_time] = ACTIONS(3109),
    [anon_sym_times] = ACTIONS(3109),
    [anon_sym_wait] = ACTIONS(3109),
    [anon_sym_wantarray] = ACTIONS(3109),
    [anon_sym_abs] = ACTIONS(3109),
    [anon_sym_alarm] = ACTIONS(3109),
    [anon_sym_chop] = ACTIONS(3109),
    [anon_sym_chdir] = ACTIONS(3109),
    [anon_sym_close] = ACTIONS(3109),
    [anon_sym_closedir] = ACTIONS(3109),
    [anon_sym_caller] = ACTIONS(3109),
    [anon_sym_chomp] = ACTIONS(3109),
    [anon_sym_chr] = ACTIONS(3109),
    [anon_sym_cos] = ACTIONS(3109),
    [anon_sym_chroot] = ACTIONS(3109),
    [anon_sym_defined] = ACTIONS(3109),
    [anon_sym_delete] = ACTIONS(3109),
    [anon_sym_dbmclose] = ACTIONS(3109),
    [anon_sym_exists] = ACTIONS(3109),
    [anon_sym_exit] = ACTIONS(3109),
    [anon_sym_eof] = ACTIONS(3109),
    [anon_sym_exp] = ACTIONS(3109),
    [anon_sym_each] = ACTIONS(3109),
    [anon_sym_fc] = ACTIONS(3109),
    [anon_sym_fileno] = ACTIONS(3109),
    [anon_sym_gmtime] = ACTIONS(3109),
    [anon_sym_getc] = ACTIONS(3109),
    [anon_sym_getpgrp] = ACTIONS(3109),
    [anon_sym_getprotobyname] = ACTIONS(3109),
    [anon_sym_getpwname] = ACTIONS(3109),
    [anon_sym_getpwuid] = ACTIONS(3109),
    [anon_sym_getpeername] = ACTIONS(3109),
    [anon_sym_getnetbyname] = ACTIONS(3109),
    [anon_sym_getsockname] = ACTIONS(3109),
    [anon_sym_getgrnam] = ACTIONS(3109),
    [anon_sym_getgrgid] = ACTIONS(3109),
    [anon_sym_hex] = ACTIONS(3109),
    [anon_sym_int] = ACTIONS(3109),
    [anon_sym_keys] = ACTIONS(3109),
    [anon_sym_lc] = ACTIONS(3109),
    [anon_sym_lcfirst] = ACTIONS(3109),
    [anon_sym_length] = ACTIONS(3109),
    [anon_sym_localtime] = ACTIONS(3109),
    [anon_sym_log] = ACTIONS(3109),
    [anon_sym_lock] = ACTIONS(3109),
    [anon_sym_lstat] = ACTIONS(3109),
    [anon_sym_oct] = ACTIONS(3109),
    [anon_sym_ord] = ACTIONS(3109),
    [anon_sym_prototype] = ACTIONS(3109),
    [anon_sym_pop] = ACTIONS(3109),
    [anon_sym_pos] = ACTIONS(3109),
    [anon_sym_quotemeta] = ACTIONS(3109),
    [anon_sym_reset] = ACTIONS(3109),
    [anon_sym_rand] = ACTIONS(3109),
    [anon_sym_rmdir] = ACTIONS(3109),
    [anon_sym_readdir] = ACTIONS(3109),
    [anon_sym_readline] = ACTIONS(3109),
    [anon_sym_readpipe] = ACTIONS(3109),
    [anon_sym_rewinddir] = ACTIONS(3109),
    [anon_sym_readlink] = ACTIONS(3109),
    [anon_sym_ref] = ACTIONS(3109),
    [anon_sym_scalar] = ACTIONS(3109),
    [anon_sym_shift] = ACTIONS(3109),
    [anon_sym_sin] = ACTIONS(3109),
    [anon_sym_sleep] = ACTIONS(3109),
    [anon_sym_sqrt] = ACTIONS(3109),
    [anon_sym_srand] = ACTIONS(3109),
    [anon_sym_stat] = ACTIONS(3109),
    [anon_sym_study] = ACTIONS(3109),
    [anon_sym_tell] = ACTIONS(3109),
    [anon_sym_telldir] = ACTIONS(3109),
    [anon_sym_tied] = ACTIONS(3109),
    [anon_sym_uc] = ACTIONS(3109),
    [anon_sym_ucfirst] = ACTIONS(3109),
    [anon_sym_untie] = ACTIONS(3109),
    [anon_sym_umask] = ACTIONS(3109),
    [anon_sym_values] = ACTIONS(3109),
    [anon_sym_write] = ACTIONS(3109),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3109),
    [anon_sym___END__] = ACTIONS(3109),
    [anon_sym_EOT] = ACTIONS(3109),
    [anon_sym_q] = ACTIONS(3109),
    [anon_sym_qq] = ACTIONS(3109),
    [anon_sym_qw] = ACTIONS(3109),
    [anon_sym_qx] = ACTIONS(3109),
    [anon_sym_qr] = ACTIONS(3109),
    [anon_sym_m] = ACTIONS(3109),
    [anon_sym_s] = ACTIONS(3109),
    [anon_sym_tr] = ACTIONS(3109),
    [anon_sym_y] = ACTIONS(3109),
    [anon_sym_if] = ACTIONS(3109),
    [anon_sym_unless] = ACTIONS(3109),
    [anon_sym_while] = ACTIONS(3109),
    [anon_sym_until] = ACTIONS(3109),
    [aux_sym__bareword_token1] = ACTIONS(3109),
    [sym_number] = ACTIONS(3109),
    [sym__apostrophe] = ACTIONS(3107),
    [sym__double_quote] = ACTIONS(3107),
    [sym__backtick] = ACTIONS(3107),
    [sym__search_slash] = ACTIONS(3107),
    [sym__PERLY_HEREDOC] = ACTIONS(3107),
    [sym__ctrl_z_hack] = ACTIONS(3107),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [997] = {
    [sym_heredoc_content] = STATE(997),
    [ts_builtin_sym_end] = ACTIONS(3111),
    [sym__identifier] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_LBRACE2] = ACTIONS(3113),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym_package] = ACTIONS(3113),
    [anon_sym_class] = ACTIONS(3113),
    [anon_sym_sub] = ACTIONS(3113),
    [anon_sym_method] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3113),
    [anon_sym_continue] = ACTIONS(3113),
    [anon_sym_my] = ACTIONS(3113),
    [anon_sym_state] = ACTIONS(3113),
    [anon_sym_our] = ACTIONS(3113),
    [anon_sym_try] = ACTIONS(3113),
    [anon_sym_defer] = ACTIONS(3113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3113),
    [anon_sym_else] = ACTIONS(3113),
    [anon_sym_elsif] = ACTIONS(3113),
    [anon_sym_and] = ACTIONS(3113),
    [anon_sym_or] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3113),
    [anon_sym_LBRACK] = ACTIONS(3113),
    [anon_sym_AT] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_LT_LT] = ACTIONS(3113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_DASH] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_eq] = ACTIONS(3113),
    [anon_sym_ne] = ACTIONS(3113),
    [anon_sym_cmp] = ACTIONS(3113),
    [anon_sym_lt] = ACTIONS(3113),
    [anon_sym_le] = ACTIONS(3113),
    [anon_sym_ge] = ACTIONS(3113),
    [anon_sym_gt] = ACTIONS(3113),
    [anon_sym_isa] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_BSLASH] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3113),
    [anon_sym_eval] = ACTIONS(3113),
    [anon_sym_field] = ACTIONS(3113),
    [anon_sym_local] = ACTIONS(3113),
    [anon_sym_require] = ACTIONS(3113),
    [anon_sym_map] = ACTIONS(3113),
    [anon_sym_grep] = ACTIONS(3113),
    [anon_sym_sort] = ACTIONS(3113),
    [anon_sym_goto] = ACTIONS(3113),
    [anon_sym_return] = ACTIONS(3113),
    [anon_sym_undef] = ACTIONS(3113),
    [anon_sym_PERCENT2] = ACTIONS(3113),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3113),
    [anon_sym_no] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3113),
    [anon_sym_foreach] = ACTIONS(3113),
    [anon_sym_last] = ACTIONS(3113),
    [anon_sym_next] = ACTIONS(3113),
    [anon_sym_redo] = ACTIONS(3113),
    [anon_sym_BEGIN] = ACTIONS(3113),
    [anon_sym_INIT] = ACTIONS(3113),
    [anon_sym_CHECK] = ACTIONS(3113),
    [anon_sym_UNITCHECK] = ACTIONS(3113),
    [anon_sym_END] = ACTIONS(3113),
    [anon_sym_ADJUST] = ACTIONS(3113),
    [anon_sym___FILE__] = ACTIONS(3113),
    [anon_sym___LINE__] = ACTIONS(3113),
    [anon_sym___PACKAGE__] = ACTIONS(3113),
    [anon_sym___SUB__] = ACTIONS(3113),
    [anon_sym_break] = ACTIONS(3113),
    [anon_sym_fork] = ACTIONS(3113),
    [anon_sym_getppid] = ACTIONS(3113),
    [anon_sym_time] = ACTIONS(3113),
    [anon_sym_times] = ACTIONS(3113),
    [anon_sym_wait] = ACTIONS(3113),
    [anon_sym_wantarray] = ACTIONS(3113),
    [anon_sym_abs] = ACTIONS(3113),
    [anon_sym_alarm] = ACTIONS(3113),
    [anon_sym_chop] = ACTIONS(3113),
    [anon_sym_chdir] = ACTIONS(3113),
    [anon_sym_close] = ACTIONS(3113),
    [anon_sym_closedir] = ACTIONS(3113),
    [anon_sym_caller] = ACTIONS(3113),
    [anon_sym_chomp] = ACTIONS(3113),
    [anon_sym_chr] = ACTIONS(3113),
    [anon_sym_cos] = ACTIONS(3113),
    [anon_sym_chroot] = ACTIONS(3113),
    [anon_sym_defined] = ACTIONS(3113),
    [anon_sym_delete] = ACTIONS(3113),
    [anon_sym_dbmclose] = ACTIONS(3113),
    [anon_sym_exists] = ACTIONS(3113),
    [anon_sym_exit] = ACTIONS(3113),
    [anon_sym_eof] = ACTIONS(3113),
    [anon_sym_exp] = ACTIONS(3113),
    [anon_sym_each] = ACTIONS(3113),
    [anon_sym_fc] = ACTIONS(3113),
    [anon_sym_fileno] = ACTIONS(3113),
    [anon_sym_gmtime] = ACTIONS(3113),
    [anon_sym_getc] = ACTIONS(3113),
    [anon_sym_getpgrp] = ACTIONS(3113),
    [anon_sym_getprotobyname] = ACTIONS(3113),
    [anon_sym_getpwname] = ACTIONS(3113),
    [anon_sym_getpwuid] = ACTIONS(3113),
    [anon_sym_getpeername] = ACTIONS(3113),
    [anon_sym_getnetbyname] = ACTIONS(3113),
    [anon_sym_getsockname] = ACTIONS(3113),
    [anon_sym_getgrnam] = ACTIONS(3113),
    [anon_sym_getgrgid] = ACTIONS(3113),
    [anon_sym_hex] = ACTIONS(3113),
    [anon_sym_int] = ACTIONS(3113),
    [anon_sym_keys] = ACTIONS(3113),
    [anon_sym_lc] = ACTIONS(3113),
    [anon_sym_lcfirst] = ACTIONS(3113),
    [anon_sym_length] = ACTIONS(3113),
    [anon_sym_localtime] = ACTIONS(3113),
    [anon_sym_log] = ACTIONS(3113),
    [anon_sym_lock] = ACTIONS(3113),
    [anon_sym_lstat] = ACTIONS(3113),
    [anon_sym_oct] = ACTIONS(3113),
    [anon_sym_ord] = ACTIONS(3113),
    [anon_sym_prototype] = ACTIONS(3113),
    [anon_sym_pop] = ACTIONS(3113),
    [anon_sym_pos] = ACTIONS(3113),
    [anon_sym_quotemeta] = ACTIONS(3113),
    [anon_sym_reset] = ACTIONS(3113),
    [anon_sym_rand] = ACTIONS(3113),
    [anon_sym_rmdir] = ACTIONS(3113),
    [anon_sym_readdir] = ACTIONS(3113),
    [anon_sym_readline] = ACTIONS(3113),
    [anon_sym_readpipe] = ACTIONS(3113),
    [anon_sym_rewinddir] = ACTIONS(3113),
    [anon_sym_readlink] = ACTIONS(3113),
    [anon_sym_ref] = ACTIONS(3113),
    [anon_sym_scalar] = ACTIONS(3113),
    [anon_sym_shift] = ACTIONS(3113),
    [anon_sym_sin] = ACTIONS(3113),
    [anon_sym_sleep] = ACTIONS(3113),
    [anon_sym_sqrt] = ACTIONS(3113),
    [anon_sym_srand] = ACTIONS(3113),
    [anon_sym_stat] = ACTIONS(3113),
    [anon_sym_study] = ACTIONS(3113),
    [anon_sym_tell] = ACTIONS(3113),
    [anon_sym_telldir] = ACTIONS(3113),
    [anon_sym_tied] = ACTIONS(3113),
    [anon_sym_uc] = ACTIONS(3113),
    [anon_sym_ucfirst] = ACTIONS(3113),
    [anon_sym_untie] = ACTIONS(3113),
    [anon_sym_umask] = ACTIONS(3113),
    [anon_sym_values] = ACTIONS(3113),
    [anon_sym_write] = ACTIONS(3113),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3113),
    [anon_sym___END__] = ACTIONS(3113),
    [anon_sym_EOT] = ACTIONS(3113),
    [anon_sym_q] = ACTIONS(3113),
    [anon_sym_qq] = ACTIONS(3113),
    [anon_sym_qw] = ACTIONS(3113),
    [anon_sym_qx] = ACTIONS(3113),
    [anon_sym_qr] = ACTIONS(3113),
    [anon_sym_m] = ACTIONS(3113),
    [anon_sym_s] = ACTIONS(3113),
    [anon_sym_tr] = ACTIONS(3113),
    [anon_sym_y] = ACTIONS(3113),
    [anon_sym_if] = ACTIONS(3113),
    [anon_sym_unless] = ACTIONS(3113),
    [anon_sym_while] = ACTIONS(3113),
    [anon_sym_until] = ACTIONS(3113),
    [aux_sym__bareword_token1] = ACTIONS(3113),
    [sym_number] = ACTIONS(3113),
    [sym__apostrophe] = ACTIONS(3111),
    [sym__double_quote] = ACTIONS(3111),
    [sym__backtick] = ACTIONS(3111),
    [sym__search_slash] = ACTIONS(3111),
    [sym__PERLY_HEREDOC] = ACTIONS(3111),
    [sym__ctrl_z_hack] = ACTIONS(3111),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [998] = {
    [sym_heredoc_content] = STATE(998),
    [ts_builtin_sym_end] = ACTIONS(3115),
    [sym__identifier] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LBRACE2] = ACTIONS(3117),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_package] = ACTIONS(3117),
    [anon_sym_class] = ACTIONS(3117),
    [anon_sym_sub] = ACTIONS(3117),
    [anon_sym_method] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_continue] = ACTIONS(3117),
    [anon_sym_my] = ACTIONS(3117),
    [anon_sym_state] = ACTIONS(3117),
    [anon_sym_our] = ACTIONS(3117),
    [anon_sym_try] = ACTIONS(3117),
    [anon_sym_defer] = ACTIONS(3117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3117),
    [anon_sym_else] = ACTIONS(3117),
    [anon_sym_elsif] = ACTIONS(3117),
    [anon_sym_and] = ACTIONS(3117),
    [anon_sym_or] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_AT] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_LT_LT] = ACTIONS(3117),
    [anon_sym_SLASH_SLASH] = ACTIONS(3117),
    [anon_sym_PLUS] = ACTIONS(3117),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_eq] = ACTIONS(3117),
    [anon_sym_ne] = ACTIONS(3117),
    [anon_sym_cmp] = ACTIONS(3117),
    [anon_sym_lt] = ACTIONS(3117),
    [anon_sym_le] = ACTIONS(3117),
    [anon_sym_ge] = ACTIONS(3117),
    [anon_sym_gt] = ACTIONS(3117),
    [anon_sym_isa] = ACTIONS(3117),
    [anon_sym_TILDE] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [anon_sym_BSLASH] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3117),
    [anon_sym_eval] = ACTIONS(3117),
    [anon_sym_field] = ACTIONS(3117),
    [anon_sym_local] = ACTIONS(3117),
    [anon_sym_require] = ACTIONS(3117),
    [anon_sym_map] = ACTIONS(3117),
    [anon_sym_grep] = ACTIONS(3117),
    [anon_sym_sort] = ACTIONS(3117),
    [anon_sym_goto] = ACTIONS(3117),
    [anon_sym_return] = ACTIONS(3117),
    [anon_sym_undef] = ACTIONS(3117),
    [anon_sym_PERCENT2] = ACTIONS(3117),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3117),
    [anon_sym_no] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_foreach] = ACTIONS(3117),
    [anon_sym_last] = ACTIONS(3117),
    [anon_sym_next] = ACTIONS(3117),
    [anon_sym_redo] = ACTIONS(3117),
    [anon_sym_BEGIN] = ACTIONS(3117),
    [anon_sym_INIT] = ACTIONS(3117),
    [anon_sym_CHECK] = ACTIONS(3117),
    [anon_sym_UNITCHECK] = ACTIONS(3117),
    [anon_sym_END] = ACTIONS(3117),
    [anon_sym_ADJUST] = ACTIONS(3117),
    [anon_sym___FILE__] = ACTIONS(3117),
    [anon_sym___LINE__] = ACTIONS(3117),
    [anon_sym___PACKAGE__] = ACTIONS(3117),
    [anon_sym___SUB__] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3117),
    [anon_sym_fork] = ACTIONS(3117),
    [anon_sym_getppid] = ACTIONS(3117),
    [anon_sym_time] = ACTIONS(3117),
    [anon_sym_times] = ACTIONS(3117),
    [anon_sym_wait] = ACTIONS(3117),
    [anon_sym_wantarray] = ACTIONS(3117),
    [anon_sym_abs] = ACTIONS(3117),
    [anon_sym_alarm] = ACTIONS(3117),
    [anon_sym_chop] = ACTIONS(3117),
    [anon_sym_chdir] = ACTIONS(3117),
    [anon_sym_close] = ACTIONS(3117),
    [anon_sym_closedir] = ACTIONS(3117),
    [anon_sym_caller] = ACTIONS(3117),
    [anon_sym_chomp] = ACTIONS(3117),
    [anon_sym_chr] = ACTIONS(3117),
    [anon_sym_cos] = ACTIONS(3117),
    [anon_sym_chroot] = ACTIONS(3117),
    [anon_sym_defined] = ACTIONS(3117),
    [anon_sym_delete] = ACTIONS(3117),
    [anon_sym_dbmclose] = ACTIONS(3117),
    [anon_sym_exists] = ACTIONS(3117),
    [anon_sym_exit] = ACTIONS(3117),
    [anon_sym_eof] = ACTIONS(3117),
    [anon_sym_exp] = ACTIONS(3117),
    [anon_sym_each] = ACTIONS(3117),
    [anon_sym_fc] = ACTIONS(3117),
    [anon_sym_fileno] = ACTIONS(3117),
    [anon_sym_gmtime] = ACTIONS(3117),
    [anon_sym_getc] = ACTIONS(3117),
    [anon_sym_getpgrp] = ACTIONS(3117),
    [anon_sym_getprotobyname] = ACTIONS(3117),
    [anon_sym_getpwname] = ACTIONS(3117),
    [anon_sym_getpwuid] = ACTIONS(3117),
    [anon_sym_getpeername] = ACTIONS(3117),
    [anon_sym_getnetbyname] = ACTIONS(3117),
    [anon_sym_getsockname] = ACTIONS(3117),
    [anon_sym_getgrnam] = ACTIONS(3117),
    [anon_sym_getgrgid] = ACTIONS(3117),
    [anon_sym_hex] = ACTIONS(3117),
    [anon_sym_int] = ACTIONS(3117),
    [anon_sym_keys] = ACTIONS(3117),
    [anon_sym_lc] = ACTIONS(3117),
    [anon_sym_lcfirst] = ACTIONS(3117),
    [anon_sym_length] = ACTIONS(3117),
    [anon_sym_localtime] = ACTIONS(3117),
    [anon_sym_log] = ACTIONS(3117),
    [anon_sym_lock] = ACTIONS(3117),
    [anon_sym_lstat] = ACTIONS(3117),
    [anon_sym_oct] = ACTIONS(3117),
    [anon_sym_ord] = ACTIONS(3117),
    [anon_sym_prototype] = ACTIONS(3117),
    [anon_sym_pop] = ACTIONS(3117),
    [anon_sym_pos] = ACTIONS(3117),
    [anon_sym_quotemeta] = ACTIONS(3117),
    [anon_sym_reset] = ACTIONS(3117),
    [anon_sym_rand] = ACTIONS(3117),
    [anon_sym_rmdir] = ACTIONS(3117),
    [anon_sym_readdir] = ACTIONS(3117),
    [anon_sym_readline] = ACTIONS(3117),
    [anon_sym_readpipe] = ACTIONS(3117),
    [anon_sym_rewinddir] = ACTIONS(3117),
    [anon_sym_readlink] = ACTIONS(3117),
    [anon_sym_ref] = ACTIONS(3117),
    [anon_sym_scalar] = ACTIONS(3117),
    [anon_sym_shift] = ACTIONS(3117),
    [anon_sym_sin] = ACTIONS(3117),
    [anon_sym_sleep] = ACTIONS(3117),
    [anon_sym_sqrt] = ACTIONS(3117),
    [anon_sym_srand] = ACTIONS(3117),
    [anon_sym_stat] = ACTIONS(3117),
    [anon_sym_study] = ACTIONS(3117),
    [anon_sym_tell] = ACTIONS(3117),
    [anon_sym_telldir] = ACTIONS(3117),
    [anon_sym_tied] = ACTIONS(3117),
    [anon_sym_uc] = ACTIONS(3117),
    [anon_sym_ucfirst] = ACTIONS(3117),
    [anon_sym_untie] = ACTIONS(3117),
    [anon_sym_umask] = ACTIONS(3117),
    [anon_sym_values] = ACTIONS(3117),
    [anon_sym_write] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3117),
    [anon_sym___END__] = ACTIONS(3117),
    [anon_sym_EOT] = ACTIONS(3117),
    [anon_sym_q] = ACTIONS(3117),
    [anon_sym_qq] = ACTIONS(3117),
    [anon_sym_qw] = ACTIONS(3117),
    [anon_sym_qx] = ACTIONS(3117),
    [anon_sym_qr] = ACTIONS(3117),
    [anon_sym_m] = ACTIONS(3117),
    [anon_sym_s] = ACTIONS(3117),
    [anon_sym_tr] = ACTIONS(3117),
    [anon_sym_y] = ACTIONS(3117),
    [anon_sym_if] = ACTIONS(3117),
    [anon_sym_unless] = ACTIONS(3117),
    [anon_sym_while] = ACTIONS(3117),
    [anon_sym_until] = ACTIONS(3117),
    [aux_sym__bareword_token1] = ACTIONS(3117),
    [sym_number] = ACTIONS(3117),
    [sym__apostrophe] = ACTIONS(3115),
    [sym__double_quote] = ACTIONS(3115),
    [sym__backtick] = ACTIONS(3115),
    [sym__search_slash] = ACTIONS(3115),
    [sym__PERLY_HEREDOC] = ACTIONS(3115),
    [sym__ctrl_z_hack] = ACTIONS(3115),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [999] = {
    [sym_heredoc_content] = STATE(999),
    [ts_builtin_sym_end] = ACTIONS(3119),
    [sym__identifier] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_LBRACE2] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_package] = ACTIONS(3121),
    [anon_sym_class] = ACTIONS(3121),
    [anon_sym_sub] = ACTIONS(3121),
    [anon_sym_method] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_continue] = ACTIONS(3121),
    [anon_sym_my] = ACTIONS(3121),
    [anon_sym_state] = ACTIONS(3121),
    [anon_sym_our] = ACTIONS(3121),
    [anon_sym_try] = ACTIONS(3121),
    [anon_sym_defer] = ACTIONS(3121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3121),
    [anon_sym_else] = ACTIONS(3121),
    [anon_sym_elsif] = ACTIONS(3121),
    [anon_sym_and] = ACTIONS(3121),
    [anon_sym_or] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_AT] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_eq] = ACTIONS(3121),
    [anon_sym_ne] = ACTIONS(3121),
    [anon_sym_cmp] = ACTIONS(3121),
    [anon_sym_lt] = ACTIONS(3121),
    [anon_sym_le] = ACTIONS(3121),
    [anon_sym_ge] = ACTIONS(3121),
    [anon_sym_gt] = ACTIONS(3121),
    [anon_sym_isa] = ACTIONS(3121),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [anon_sym_BSLASH] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3121),
    [anon_sym_eval] = ACTIONS(3121),
    [anon_sym_field] = ACTIONS(3121),
    [anon_sym_local] = ACTIONS(3121),
    [anon_sym_require] = ACTIONS(3121),
    [anon_sym_map] = ACTIONS(3121),
    [anon_sym_grep] = ACTIONS(3121),
    [anon_sym_sort] = ACTIONS(3121),
    [anon_sym_goto] = ACTIONS(3121),
    [anon_sym_return] = ACTIONS(3121),
    [anon_sym_undef] = ACTIONS(3121),
    [anon_sym_PERCENT2] = ACTIONS(3121),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3121),
    [anon_sym_no] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3121),
    [anon_sym_foreach] = ACTIONS(3121),
    [anon_sym_last] = ACTIONS(3121),
    [anon_sym_next] = ACTIONS(3121),
    [anon_sym_redo] = ACTIONS(3121),
    [anon_sym_BEGIN] = ACTIONS(3121),
    [anon_sym_INIT] = ACTIONS(3121),
    [anon_sym_CHECK] = ACTIONS(3121),
    [anon_sym_UNITCHECK] = ACTIONS(3121),
    [anon_sym_END] = ACTIONS(3121),
    [anon_sym_ADJUST] = ACTIONS(3121),
    [anon_sym___FILE__] = ACTIONS(3121),
    [anon_sym___LINE__] = ACTIONS(3121),
    [anon_sym___PACKAGE__] = ACTIONS(3121),
    [anon_sym___SUB__] = ACTIONS(3121),
    [anon_sym_break] = ACTIONS(3121),
    [anon_sym_fork] = ACTIONS(3121),
    [anon_sym_getppid] = ACTIONS(3121),
    [anon_sym_time] = ACTIONS(3121),
    [anon_sym_times] = ACTIONS(3121),
    [anon_sym_wait] = ACTIONS(3121),
    [anon_sym_wantarray] = ACTIONS(3121),
    [anon_sym_abs] = ACTIONS(3121),
    [anon_sym_alarm] = ACTIONS(3121),
    [anon_sym_chop] = ACTIONS(3121),
    [anon_sym_chdir] = ACTIONS(3121),
    [anon_sym_close] = ACTIONS(3121),
    [anon_sym_closedir] = ACTIONS(3121),
    [anon_sym_caller] = ACTIONS(3121),
    [anon_sym_chomp] = ACTIONS(3121),
    [anon_sym_chr] = ACTIONS(3121),
    [anon_sym_cos] = ACTIONS(3121),
    [anon_sym_chroot] = ACTIONS(3121),
    [anon_sym_defined] = ACTIONS(3121),
    [anon_sym_delete] = ACTIONS(3121),
    [anon_sym_dbmclose] = ACTIONS(3121),
    [anon_sym_exists] = ACTIONS(3121),
    [anon_sym_exit] = ACTIONS(3121),
    [anon_sym_eof] = ACTIONS(3121),
    [anon_sym_exp] = ACTIONS(3121),
    [anon_sym_each] = ACTIONS(3121),
    [anon_sym_fc] = ACTIONS(3121),
    [anon_sym_fileno] = ACTIONS(3121),
    [anon_sym_gmtime] = ACTIONS(3121),
    [anon_sym_getc] = ACTIONS(3121),
    [anon_sym_getpgrp] = ACTIONS(3121),
    [anon_sym_getprotobyname] = ACTIONS(3121),
    [anon_sym_getpwname] = ACTIONS(3121),
    [anon_sym_getpwuid] = ACTIONS(3121),
    [anon_sym_getpeername] = ACTIONS(3121),
    [anon_sym_getnetbyname] = ACTIONS(3121),
    [anon_sym_getsockname] = ACTIONS(3121),
    [anon_sym_getgrnam] = ACTIONS(3121),
    [anon_sym_getgrgid] = ACTIONS(3121),
    [anon_sym_hex] = ACTIONS(3121),
    [anon_sym_int] = ACTIONS(3121),
    [anon_sym_keys] = ACTIONS(3121),
    [anon_sym_lc] = ACTIONS(3121),
    [anon_sym_lcfirst] = ACTIONS(3121),
    [anon_sym_length] = ACTIONS(3121),
    [anon_sym_localtime] = ACTIONS(3121),
    [anon_sym_log] = ACTIONS(3121),
    [anon_sym_lock] = ACTIONS(3121),
    [anon_sym_lstat] = ACTIONS(3121),
    [anon_sym_oct] = ACTIONS(3121),
    [anon_sym_ord] = ACTIONS(3121),
    [anon_sym_prototype] = ACTIONS(3121),
    [anon_sym_pop] = ACTIONS(3121),
    [anon_sym_pos] = ACTIONS(3121),
    [anon_sym_quotemeta] = ACTIONS(3121),
    [anon_sym_reset] = ACTIONS(3121),
    [anon_sym_rand] = ACTIONS(3121),
    [anon_sym_rmdir] = ACTIONS(3121),
    [anon_sym_readdir] = ACTIONS(3121),
    [anon_sym_readline] = ACTIONS(3121),
    [anon_sym_readpipe] = ACTIONS(3121),
    [anon_sym_rewinddir] = ACTIONS(3121),
    [anon_sym_readlink] = ACTIONS(3121),
    [anon_sym_ref] = ACTIONS(3121),
    [anon_sym_scalar] = ACTIONS(3121),
    [anon_sym_shift] = ACTIONS(3121),
    [anon_sym_sin] = ACTIONS(3121),
    [anon_sym_sleep] = ACTIONS(3121),
    [anon_sym_sqrt] = ACTIONS(3121),
    [anon_sym_srand] = ACTIONS(3121),
    [anon_sym_stat] = ACTIONS(3121),
    [anon_sym_study] = ACTIONS(3121),
    [anon_sym_tell] = ACTIONS(3121),
    [anon_sym_telldir] = ACTIONS(3121),
    [anon_sym_tied] = ACTIONS(3121),
    [anon_sym_uc] = ACTIONS(3121),
    [anon_sym_ucfirst] = ACTIONS(3121),
    [anon_sym_untie] = ACTIONS(3121),
    [anon_sym_umask] = ACTIONS(3121),
    [anon_sym_values] = ACTIONS(3121),
    [anon_sym_write] = ACTIONS(3121),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3121),
    [anon_sym___END__] = ACTIONS(3121),
    [anon_sym_EOT] = ACTIONS(3121),
    [anon_sym_q] = ACTIONS(3121),
    [anon_sym_qq] = ACTIONS(3121),
    [anon_sym_qw] = ACTIONS(3121),
    [anon_sym_qx] = ACTIONS(3121),
    [anon_sym_qr] = ACTIONS(3121),
    [anon_sym_m] = ACTIONS(3121),
    [anon_sym_s] = ACTIONS(3121),
    [anon_sym_tr] = ACTIONS(3121),
    [anon_sym_y] = ACTIONS(3121),
    [anon_sym_if] = ACTIONS(3121),
    [anon_sym_unless] = ACTIONS(3121),
    [anon_sym_while] = ACTIONS(3121),
    [anon_sym_until] = ACTIONS(3121),
    [aux_sym__bareword_token1] = ACTIONS(3121),
    [sym_number] = ACTIONS(3121),
    [sym__apostrophe] = ACTIONS(3119),
    [sym__double_quote] = ACTIONS(3119),
    [sym__backtick] = ACTIONS(3119),
    [sym__search_slash] = ACTIONS(3119),
    [sym__PERLY_HEREDOC] = ACTIONS(3119),
    [sym__ctrl_z_hack] = ACTIONS(3119),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1000] = {
    [sym_heredoc_content] = STATE(1000),
    [ts_builtin_sym_end] = ACTIONS(3123),
    [sym__identifier] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_LBRACE2] = ACTIONS(3125),
    [anon_sym_SEMI] = ACTIONS(3125),
    [anon_sym_package] = ACTIONS(3125),
    [anon_sym_class] = ACTIONS(3125),
    [anon_sym_sub] = ACTIONS(3125),
    [anon_sym_method] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3125),
    [anon_sym_continue] = ACTIONS(3125),
    [anon_sym_my] = ACTIONS(3125),
    [anon_sym_state] = ACTIONS(3125),
    [anon_sym_our] = ACTIONS(3125),
    [anon_sym_try] = ACTIONS(3125),
    [anon_sym_defer] = ACTIONS(3125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_else] = ACTIONS(3125),
    [anon_sym_elsif] = ACTIONS(3125),
    [anon_sym_and] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_AT] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_LT_LT] = ACTIONS(3125),
    [anon_sym_SLASH_SLASH] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(3125),
    [anon_sym_DASH] = ACTIONS(3125),
    [anon_sym_STAR] = ACTIONS(3125),
    [anon_sym_eq] = ACTIONS(3125),
    [anon_sym_ne] = ACTIONS(3125),
    [anon_sym_cmp] = ACTIONS(3125),
    [anon_sym_lt] = ACTIONS(3125),
    [anon_sym_le] = ACTIONS(3125),
    [anon_sym_ge] = ACTIONS(3125),
    [anon_sym_gt] = ACTIONS(3125),
    [anon_sym_isa] = ACTIONS(3125),
    [anon_sym_TILDE] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3125),
    [anon_sym_PLUS_PLUS] = ACTIONS(3125),
    [anon_sym_DASH_DASH] = ACTIONS(3125),
    [anon_sym_BSLASH] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3125),
    [anon_sym_eval] = ACTIONS(3125),
    [anon_sym_field] = ACTIONS(3125),
    [anon_sym_local] = ACTIONS(3125),
    [anon_sym_require] = ACTIONS(3125),
    [anon_sym_map] = ACTIONS(3125),
    [anon_sym_grep] = ACTIONS(3125),
    [anon_sym_sort] = ACTIONS(3125),
    [anon_sym_goto] = ACTIONS(3125),
    [anon_sym_return] = ACTIONS(3125),
    [anon_sym_undef] = ACTIONS(3125),
    [anon_sym_PERCENT2] = ACTIONS(3125),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3125),
    [anon_sym_no] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3125),
    [anon_sym_foreach] = ACTIONS(3125),
    [anon_sym_last] = ACTIONS(3125),
    [anon_sym_next] = ACTIONS(3125),
    [anon_sym_redo] = ACTIONS(3125),
    [anon_sym_BEGIN] = ACTIONS(3125),
    [anon_sym_INIT] = ACTIONS(3125),
    [anon_sym_CHECK] = ACTIONS(3125),
    [anon_sym_UNITCHECK] = ACTIONS(3125),
    [anon_sym_END] = ACTIONS(3125),
    [anon_sym_ADJUST] = ACTIONS(3125),
    [anon_sym___FILE__] = ACTIONS(3125),
    [anon_sym___LINE__] = ACTIONS(3125),
    [anon_sym___PACKAGE__] = ACTIONS(3125),
    [anon_sym___SUB__] = ACTIONS(3125),
    [anon_sym_break] = ACTIONS(3125),
    [anon_sym_fork] = ACTIONS(3125),
    [anon_sym_getppid] = ACTIONS(3125),
    [anon_sym_time] = ACTIONS(3125),
    [anon_sym_times] = ACTIONS(3125),
    [anon_sym_wait] = ACTIONS(3125),
    [anon_sym_wantarray] = ACTIONS(3125),
    [anon_sym_abs] = ACTIONS(3125),
    [anon_sym_alarm] = ACTIONS(3125),
    [anon_sym_chop] = ACTIONS(3125),
    [anon_sym_chdir] = ACTIONS(3125),
    [anon_sym_close] = ACTIONS(3125),
    [anon_sym_closedir] = ACTIONS(3125),
    [anon_sym_caller] = ACTIONS(3125),
    [anon_sym_chomp] = ACTIONS(3125),
    [anon_sym_chr] = ACTIONS(3125),
    [anon_sym_cos] = ACTIONS(3125),
    [anon_sym_chroot] = ACTIONS(3125),
    [anon_sym_defined] = ACTIONS(3125),
    [anon_sym_delete] = ACTIONS(3125),
    [anon_sym_dbmclose] = ACTIONS(3125),
    [anon_sym_exists] = ACTIONS(3125),
    [anon_sym_exit] = ACTIONS(3125),
    [anon_sym_eof] = ACTIONS(3125),
    [anon_sym_exp] = ACTIONS(3125),
    [anon_sym_each] = ACTIONS(3125),
    [anon_sym_fc] = ACTIONS(3125),
    [anon_sym_fileno] = ACTIONS(3125),
    [anon_sym_gmtime] = ACTIONS(3125),
    [anon_sym_getc] = ACTIONS(3125),
    [anon_sym_getpgrp] = ACTIONS(3125),
    [anon_sym_getprotobyname] = ACTIONS(3125),
    [anon_sym_getpwname] = ACTIONS(3125),
    [anon_sym_getpwuid] = ACTIONS(3125),
    [anon_sym_getpeername] = ACTIONS(3125),
    [anon_sym_getnetbyname] = ACTIONS(3125),
    [anon_sym_getsockname] = ACTIONS(3125),
    [anon_sym_getgrnam] = ACTIONS(3125),
    [anon_sym_getgrgid] = ACTIONS(3125),
    [anon_sym_hex] = ACTIONS(3125),
    [anon_sym_int] = ACTIONS(3125),
    [anon_sym_keys] = ACTIONS(3125),
    [anon_sym_lc] = ACTIONS(3125),
    [anon_sym_lcfirst] = ACTIONS(3125),
    [anon_sym_length] = ACTIONS(3125),
    [anon_sym_localtime] = ACTIONS(3125),
    [anon_sym_log] = ACTIONS(3125),
    [anon_sym_lock] = ACTIONS(3125),
    [anon_sym_lstat] = ACTIONS(3125),
    [anon_sym_oct] = ACTIONS(3125),
    [anon_sym_ord] = ACTIONS(3125),
    [anon_sym_prototype] = ACTIONS(3125),
    [anon_sym_pop] = ACTIONS(3125),
    [anon_sym_pos] = ACTIONS(3125),
    [anon_sym_quotemeta] = ACTIONS(3125),
    [anon_sym_reset] = ACTIONS(3125),
    [anon_sym_rand] = ACTIONS(3125),
    [anon_sym_rmdir] = ACTIONS(3125),
    [anon_sym_readdir] = ACTIONS(3125),
    [anon_sym_readline] = ACTIONS(3125),
    [anon_sym_readpipe] = ACTIONS(3125),
    [anon_sym_rewinddir] = ACTIONS(3125),
    [anon_sym_readlink] = ACTIONS(3125),
    [anon_sym_ref] = ACTIONS(3125),
    [anon_sym_scalar] = ACTIONS(3125),
    [anon_sym_shift] = ACTIONS(3125),
    [anon_sym_sin] = ACTIONS(3125),
    [anon_sym_sleep] = ACTIONS(3125),
    [anon_sym_sqrt] = ACTIONS(3125),
    [anon_sym_srand] = ACTIONS(3125),
    [anon_sym_stat] = ACTIONS(3125),
    [anon_sym_study] = ACTIONS(3125),
    [anon_sym_tell] = ACTIONS(3125),
    [anon_sym_telldir] = ACTIONS(3125),
    [anon_sym_tied] = ACTIONS(3125),
    [anon_sym_uc] = ACTIONS(3125),
    [anon_sym_ucfirst] = ACTIONS(3125),
    [anon_sym_untie] = ACTIONS(3125),
    [anon_sym_umask] = ACTIONS(3125),
    [anon_sym_values] = ACTIONS(3125),
    [anon_sym_write] = ACTIONS(3125),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3125),
    [anon_sym___END__] = ACTIONS(3125),
    [anon_sym_EOT] = ACTIONS(3125),
    [anon_sym_q] = ACTIONS(3125),
    [anon_sym_qq] = ACTIONS(3125),
    [anon_sym_qw] = ACTIONS(3125),
    [anon_sym_qx] = ACTIONS(3125),
    [anon_sym_qr] = ACTIONS(3125),
    [anon_sym_m] = ACTIONS(3125),
    [anon_sym_s] = ACTIONS(3125),
    [anon_sym_tr] = ACTIONS(3125),
    [anon_sym_y] = ACTIONS(3125),
    [anon_sym_if] = ACTIONS(3125),
    [anon_sym_unless] = ACTIONS(3125),
    [anon_sym_while] = ACTIONS(3125),
    [anon_sym_until] = ACTIONS(3125),
    [aux_sym__bareword_token1] = ACTIONS(3125),
    [sym_number] = ACTIONS(3125),
    [sym__apostrophe] = ACTIONS(3123),
    [sym__double_quote] = ACTIONS(3123),
    [sym__backtick] = ACTIONS(3123),
    [sym__search_slash] = ACTIONS(3123),
    [sym__PERLY_HEREDOC] = ACTIONS(3123),
    [sym__ctrl_z_hack] = ACTIONS(3123),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1001] = {
    [sym_heredoc_content] = STATE(1001),
    [ts_builtin_sym_end] = ACTIONS(3127),
    [sym__identifier] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE2] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_package] = ACTIONS(3129),
    [anon_sym_class] = ACTIONS(3129),
    [anon_sym_sub] = ACTIONS(3129),
    [anon_sym_method] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_continue] = ACTIONS(3129),
    [anon_sym_my] = ACTIONS(3129),
    [anon_sym_state] = ACTIONS(3129),
    [anon_sym_our] = ACTIONS(3129),
    [anon_sym_try] = ACTIONS(3129),
    [anon_sym_defer] = ACTIONS(3129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3129),
    [anon_sym_else] = ACTIONS(3129),
    [anon_sym_elsif] = ACTIONS(3129),
    [anon_sym_and] = ACTIONS(3129),
    [anon_sym_or] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_SLASH_SLASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_eq] = ACTIONS(3129),
    [anon_sym_ne] = ACTIONS(3129),
    [anon_sym_cmp] = ACTIONS(3129),
    [anon_sym_lt] = ACTIONS(3129),
    [anon_sym_le] = ACTIONS(3129),
    [anon_sym_ge] = ACTIONS(3129),
    [anon_sym_gt] = ACTIONS(3129),
    [anon_sym_isa] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_BSLASH] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3129),
    [anon_sym_eval] = ACTIONS(3129),
    [anon_sym_field] = ACTIONS(3129),
    [anon_sym_local] = ACTIONS(3129),
    [anon_sym_require] = ACTIONS(3129),
    [anon_sym_map] = ACTIONS(3129),
    [anon_sym_grep] = ACTIONS(3129),
    [anon_sym_sort] = ACTIONS(3129),
    [anon_sym_goto] = ACTIONS(3129),
    [anon_sym_return] = ACTIONS(3129),
    [anon_sym_undef] = ACTIONS(3129),
    [anon_sym_PERCENT2] = ACTIONS(3129),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3129),
    [anon_sym_no] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3129),
    [anon_sym_foreach] = ACTIONS(3129),
    [anon_sym_last] = ACTIONS(3129),
    [anon_sym_next] = ACTIONS(3129),
    [anon_sym_redo] = ACTIONS(3129),
    [anon_sym_BEGIN] = ACTIONS(3129),
    [anon_sym_INIT] = ACTIONS(3129),
    [anon_sym_CHECK] = ACTIONS(3129),
    [anon_sym_UNITCHECK] = ACTIONS(3129),
    [anon_sym_END] = ACTIONS(3129),
    [anon_sym_ADJUST] = ACTIONS(3129),
    [anon_sym___FILE__] = ACTIONS(3129),
    [anon_sym___LINE__] = ACTIONS(3129),
    [anon_sym___PACKAGE__] = ACTIONS(3129),
    [anon_sym___SUB__] = ACTIONS(3129),
    [anon_sym_break] = ACTIONS(3129),
    [anon_sym_fork] = ACTIONS(3129),
    [anon_sym_getppid] = ACTIONS(3129),
    [anon_sym_time] = ACTIONS(3129),
    [anon_sym_times] = ACTIONS(3129),
    [anon_sym_wait] = ACTIONS(3129),
    [anon_sym_wantarray] = ACTIONS(3129),
    [anon_sym_abs] = ACTIONS(3129),
    [anon_sym_alarm] = ACTIONS(3129),
    [anon_sym_chop] = ACTIONS(3129),
    [anon_sym_chdir] = ACTIONS(3129),
    [anon_sym_close] = ACTIONS(3129),
    [anon_sym_closedir] = ACTIONS(3129),
    [anon_sym_caller] = ACTIONS(3129),
    [anon_sym_chomp] = ACTIONS(3129),
    [anon_sym_chr] = ACTIONS(3129),
    [anon_sym_cos] = ACTIONS(3129),
    [anon_sym_chroot] = ACTIONS(3129),
    [anon_sym_defined] = ACTIONS(3129),
    [anon_sym_delete] = ACTIONS(3129),
    [anon_sym_dbmclose] = ACTIONS(3129),
    [anon_sym_exists] = ACTIONS(3129),
    [anon_sym_exit] = ACTIONS(3129),
    [anon_sym_eof] = ACTIONS(3129),
    [anon_sym_exp] = ACTIONS(3129),
    [anon_sym_each] = ACTIONS(3129),
    [anon_sym_fc] = ACTIONS(3129),
    [anon_sym_fileno] = ACTIONS(3129),
    [anon_sym_gmtime] = ACTIONS(3129),
    [anon_sym_getc] = ACTIONS(3129),
    [anon_sym_getpgrp] = ACTIONS(3129),
    [anon_sym_getprotobyname] = ACTIONS(3129),
    [anon_sym_getpwname] = ACTIONS(3129),
    [anon_sym_getpwuid] = ACTIONS(3129),
    [anon_sym_getpeername] = ACTIONS(3129),
    [anon_sym_getnetbyname] = ACTIONS(3129),
    [anon_sym_getsockname] = ACTIONS(3129),
    [anon_sym_getgrnam] = ACTIONS(3129),
    [anon_sym_getgrgid] = ACTIONS(3129),
    [anon_sym_hex] = ACTIONS(3129),
    [anon_sym_int] = ACTIONS(3129),
    [anon_sym_keys] = ACTIONS(3129),
    [anon_sym_lc] = ACTIONS(3129),
    [anon_sym_lcfirst] = ACTIONS(3129),
    [anon_sym_length] = ACTIONS(3129),
    [anon_sym_localtime] = ACTIONS(3129),
    [anon_sym_log] = ACTIONS(3129),
    [anon_sym_lock] = ACTIONS(3129),
    [anon_sym_lstat] = ACTIONS(3129),
    [anon_sym_oct] = ACTIONS(3129),
    [anon_sym_ord] = ACTIONS(3129),
    [anon_sym_prototype] = ACTIONS(3129),
    [anon_sym_pop] = ACTIONS(3129),
    [anon_sym_pos] = ACTIONS(3129),
    [anon_sym_quotemeta] = ACTIONS(3129),
    [anon_sym_reset] = ACTIONS(3129),
    [anon_sym_rand] = ACTIONS(3129),
    [anon_sym_rmdir] = ACTIONS(3129),
    [anon_sym_readdir] = ACTIONS(3129),
    [anon_sym_readline] = ACTIONS(3129),
    [anon_sym_readpipe] = ACTIONS(3129),
    [anon_sym_rewinddir] = ACTIONS(3129),
    [anon_sym_readlink] = ACTIONS(3129),
    [anon_sym_ref] = ACTIONS(3129),
    [anon_sym_scalar] = ACTIONS(3129),
    [anon_sym_shift] = ACTIONS(3129),
    [anon_sym_sin] = ACTIONS(3129),
    [anon_sym_sleep] = ACTIONS(3129),
    [anon_sym_sqrt] = ACTIONS(3129),
    [anon_sym_srand] = ACTIONS(3129),
    [anon_sym_stat] = ACTIONS(3129),
    [anon_sym_study] = ACTIONS(3129),
    [anon_sym_tell] = ACTIONS(3129),
    [anon_sym_telldir] = ACTIONS(3129),
    [anon_sym_tied] = ACTIONS(3129),
    [anon_sym_uc] = ACTIONS(3129),
    [anon_sym_ucfirst] = ACTIONS(3129),
    [anon_sym_untie] = ACTIONS(3129),
    [anon_sym_umask] = ACTIONS(3129),
    [anon_sym_values] = ACTIONS(3129),
    [anon_sym_write] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3129),
    [anon_sym___END__] = ACTIONS(3129),
    [anon_sym_EOT] = ACTIONS(3129),
    [anon_sym_q] = ACTIONS(3129),
    [anon_sym_qq] = ACTIONS(3129),
    [anon_sym_qw] = ACTIONS(3129),
    [anon_sym_qx] = ACTIONS(3129),
    [anon_sym_qr] = ACTIONS(3129),
    [anon_sym_m] = ACTIONS(3129),
    [anon_sym_s] = ACTIONS(3129),
    [anon_sym_tr] = ACTIONS(3129),
    [anon_sym_y] = ACTIONS(3129),
    [anon_sym_if] = ACTIONS(3129),
    [anon_sym_unless] = ACTIONS(3129),
    [anon_sym_while] = ACTIONS(3129),
    [anon_sym_until] = ACTIONS(3129),
    [aux_sym__bareword_token1] = ACTIONS(3129),
    [sym_number] = ACTIONS(3129),
    [sym__apostrophe] = ACTIONS(3127),
    [sym__double_quote] = ACTIONS(3127),
    [sym__backtick] = ACTIONS(3127),
    [sym__search_slash] = ACTIONS(3127),
    [sym__PERLY_HEREDOC] = ACTIONS(3127),
    [sym__ctrl_z_hack] = ACTIONS(3127),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1002] = {
    [sym_heredoc_content] = STATE(1002),
    [ts_builtin_sym_end] = ACTIONS(3131),
    [sym__identifier] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_LBRACE2] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_package] = ACTIONS(3133),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_sub] = ACTIONS(3133),
    [anon_sym_method] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3135),
    [anon_sym_my] = ACTIONS(3133),
    [anon_sym_state] = ACTIONS(3133),
    [anon_sym_our] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_defer] = ACTIONS(3133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_elsif] = ACTIONS(3133),
    [anon_sym_and] = ACTIONS(3133),
    [anon_sym_or] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3133),
    [anon_sym_AT] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_LT_LT] = ACTIONS(3133),
    [anon_sym_SLASH_SLASH] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3133),
    [anon_sym_eq] = ACTIONS(3133),
    [anon_sym_ne] = ACTIONS(3133),
    [anon_sym_cmp] = ACTIONS(3133),
    [anon_sym_lt] = ACTIONS(3133),
    [anon_sym_le] = ACTIONS(3133),
    [anon_sym_ge] = ACTIONS(3133),
    [anon_sym_gt] = ACTIONS(3133),
    [anon_sym_isa] = ACTIONS(3133),
    [anon_sym_TILDE] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3133),
    [anon_sym_PLUS_PLUS] = ACTIONS(3133),
    [anon_sym_DASH_DASH] = ACTIONS(3133),
    [anon_sym_BSLASH] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_eval] = ACTIONS(3133),
    [anon_sym_field] = ACTIONS(3133),
    [anon_sym_local] = ACTIONS(3133),
    [anon_sym_require] = ACTIONS(3133),
    [anon_sym_map] = ACTIONS(3133),
    [anon_sym_grep] = ACTIONS(3133),
    [anon_sym_sort] = ACTIONS(3133),
    [anon_sym_goto] = ACTIONS(3133),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_undef] = ACTIONS(3133),
    [anon_sym_PERCENT2] = ACTIONS(3133),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3133),
    [anon_sym_no] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_foreach] = ACTIONS(3133),
    [anon_sym_last] = ACTIONS(3133),
    [anon_sym_next] = ACTIONS(3133),
    [anon_sym_redo] = ACTIONS(3133),
    [anon_sym_BEGIN] = ACTIONS(3133),
    [anon_sym_INIT] = ACTIONS(3133),
    [anon_sym_CHECK] = ACTIONS(3133),
    [anon_sym_UNITCHECK] = ACTIONS(3133),
    [anon_sym_END] = ACTIONS(3133),
    [anon_sym_ADJUST] = ACTIONS(3133),
    [anon_sym___FILE__] = ACTIONS(3133),
    [anon_sym___LINE__] = ACTIONS(3133),
    [anon_sym___PACKAGE__] = ACTIONS(3133),
    [anon_sym___SUB__] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_fork] = ACTIONS(3133),
    [anon_sym_getppid] = ACTIONS(3133),
    [anon_sym_time] = ACTIONS(3133),
    [anon_sym_times] = ACTIONS(3133),
    [anon_sym_wait] = ACTIONS(3133),
    [anon_sym_wantarray] = ACTIONS(3133),
    [anon_sym_abs] = ACTIONS(3133),
    [anon_sym_alarm] = ACTIONS(3133),
    [anon_sym_chop] = ACTIONS(3133),
    [anon_sym_chdir] = ACTIONS(3133),
    [anon_sym_close] = ACTIONS(3133),
    [anon_sym_closedir] = ACTIONS(3133),
    [anon_sym_caller] = ACTIONS(3133),
    [anon_sym_chomp] = ACTIONS(3133),
    [anon_sym_chr] = ACTIONS(3133),
    [anon_sym_cos] = ACTIONS(3133),
    [anon_sym_chroot] = ACTIONS(3133),
    [anon_sym_defined] = ACTIONS(3133),
    [anon_sym_delete] = ACTIONS(3133),
    [anon_sym_dbmclose] = ACTIONS(3133),
    [anon_sym_exists] = ACTIONS(3133),
    [anon_sym_exit] = ACTIONS(3133),
    [anon_sym_eof] = ACTIONS(3133),
    [anon_sym_exp] = ACTIONS(3133),
    [anon_sym_each] = ACTIONS(3133),
    [anon_sym_fc] = ACTIONS(3133),
    [anon_sym_fileno] = ACTIONS(3133),
    [anon_sym_gmtime] = ACTIONS(3133),
    [anon_sym_getc] = ACTIONS(3133),
    [anon_sym_getpgrp] = ACTIONS(3133),
    [anon_sym_getprotobyname] = ACTIONS(3133),
    [anon_sym_getpwname] = ACTIONS(3133),
    [anon_sym_getpwuid] = ACTIONS(3133),
    [anon_sym_getpeername] = ACTIONS(3133),
    [anon_sym_getnetbyname] = ACTIONS(3133),
    [anon_sym_getsockname] = ACTIONS(3133),
    [anon_sym_getgrnam] = ACTIONS(3133),
    [anon_sym_getgrgid] = ACTIONS(3133),
    [anon_sym_hex] = ACTIONS(3133),
    [anon_sym_int] = ACTIONS(3133),
    [anon_sym_keys] = ACTIONS(3133),
    [anon_sym_lc] = ACTIONS(3133),
    [anon_sym_lcfirst] = ACTIONS(3133),
    [anon_sym_length] = ACTIONS(3133),
    [anon_sym_localtime] = ACTIONS(3133),
    [anon_sym_log] = ACTIONS(3133),
    [anon_sym_lock] = ACTIONS(3133),
    [anon_sym_lstat] = ACTIONS(3133),
    [anon_sym_oct] = ACTIONS(3133),
    [anon_sym_ord] = ACTIONS(3133),
    [anon_sym_prototype] = ACTIONS(3133),
    [anon_sym_pop] = ACTIONS(3133),
    [anon_sym_pos] = ACTIONS(3133),
    [anon_sym_quotemeta] = ACTIONS(3133),
    [anon_sym_reset] = ACTIONS(3133),
    [anon_sym_rand] = ACTIONS(3133),
    [anon_sym_rmdir] = ACTIONS(3133),
    [anon_sym_readdir] = ACTIONS(3133),
    [anon_sym_readline] = ACTIONS(3133),
    [anon_sym_readpipe] = ACTIONS(3133),
    [anon_sym_rewinddir] = ACTIONS(3133),
    [anon_sym_readlink] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3133),
    [anon_sym_scalar] = ACTIONS(3133),
    [anon_sym_shift] = ACTIONS(3133),
    [anon_sym_sin] = ACTIONS(3133),
    [anon_sym_sleep] = ACTIONS(3133),
    [anon_sym_sqrt] = ACTIONS(3133),
    [anon_sym_srand] = ACTIONS(3133),
    [anon_sym_stat] = ACTIONS(3133),
    [anon_sym_study] = ACTIONS(3133),
    [anon_sym_tell] = ACTIONS(3133),
    [anon_sym_telldir] = ACTIONS(3133),
    [anon_sym_tied] = ACTIONS(3133),
    [anon_sym_uc] = ACTIONS(3133),
    [anon_sym_ucfirst] = ACTIONS(3133),
    [anon_sym_untie] = ACTIONS(3133),
    [anon_sym_umask] = ACTIONS(3133),
    [anon_sym_values] = ACTIONS(3133),
    [anon_sym_write] = ACTIONS(3133),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3133),
    [anon_sym___END__] = ACTIONS(3133),
    [anon_sym_EOT] = ACTIONS(3133),
    [anon_sym_q] = ACTIONS(3133),
    [anon_sym_qq] = ACTIONS(3133),
    [anon_sym_qw] = ACTIONS(3133),
    [anon_sym_qx] = ACTIONS(3133),
    [anon_sym_qr] = ACTIONS(3133),
    [anon_sym_m] = ACTIONS(3133),
    [anon_sym_s] = ACTIONS(3133),
    [anon_sym_tr] = ACTIONS(3133),
    [anon_sym_y] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_unless] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_until] = ACTIONS(3133),
    [aux_sym__bareword_token1] = ACTIONS(3133),
    [sym_number] = ACTIONS(3133),
    [sym__apostrophe] = ACTIONS(3131),
    [sym__double_quote] = ACTIONS(3131),
    [sym__backtick] = ACTIONS(3131),
    [sym__search_slash] = ACTIONS(3131),
    [sym__PERLY_HEREDOC] = ACTIONS(3131),
    [sym__ctrl_z_hack] = ACTIONS(3131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1003] = {
    [sym_heredoc_content] = STATE(1003),
    [ts_builtin_sym_end] = ACTIONS(3138),
    [sym__identifier] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_LBRACE2] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym_package] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_sub] = ACTIONS(3140),
    [anon_sym_method] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3140),
    [anon_sym_continue] = ACTIONS(3140),
    [anon_sym_my] = ACTIONS(3140),
    [anon_sym_state] = ACTIONS(3140),
    [anon_sym_our] = ACTIONS(3140),
    [anon_sym_try] = ACTIONS(3140),
    [anon_sym_defer] = ACTIONS(3140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3140),
    [anon_sym_else] = ACTIONS(3140),
    [anon_sym_elsif] = ACTIONS(3140),
    [anon_sym_and] = ACTIONS(3140),
    [anon_sym_or] = ACTIONS(3140),
    [anon_sym_DOLLAR] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3140),
    [anon_sym_AT] = ACTIONS(3140),
    [anon_sym_LT] = ACTIONS(3140),
    [anon_sym_LT_LT] = ACTIONS(3140),
    [anon_sym_SLASH_SLASH] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3140),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_eq] = ACTIONS(3140),
    [anon_sym_ne] = ACTIONS(3140),
    [anon_sym_cmp] = ACTIONS(3140),
    [anon_sym_lt] = ACTIONS(3140),
    [anon_sym_le] = ACTIONS(3140),
    [anon_sym_ge] = ACTIONS(3140),
    [anon_sym_gt] = ACTIONS(3140),
    [anon_sym_isa] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_BSLASH] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3140),
    [anon_sym_eval] = ACTIONS(3140),
    [anon_sym_field] = ACTIONS(3140),
    [anon_sym_local] = ACTIONS(3140),
    [anon_sym_require] = ACTIONS(3140),
    [anon_sym_map] = ACTIONS(3140),
    [anon_sym_grep] = ACTIONS(3140),
    [anon_sym_sort] = ACTIONS(3140),
    [anon_sym_goto] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_undef] = ACTIONS(3140),
    [anon_sym_PERCENT2] = ACTIONS(3140),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3140),
    [anon_sym_use] = ACTIONS(3140),
    [anon_sym_no] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_foreach] = ACTIONS(3140),
    [anon_sym_last] = ACTIONS(3140),
    [anon_sym_next] = ACTIONS(3140),
    [anon_sym_redo] = ACTIONS(3140),
    [anon_sym_BEGIN] = ACTIONS(3140),
    [anon_sym_INIT] = ACTIONS(3140),
    [anon_sym_CHECK] = ACTIONS(3140),
    [anon_sym_UNITCHECK] = ACTIONS(3140),
    [anon_sym_END] = ACTIONS(3140),
    [anon_sym_ADJUST] = ACTIONS(3140),
    [anon_sym___FILE__] = ACTIONS(3140),
    [anon_sym___LINE__] = ACTIONS(3140),
    [anon_sym___PACKAGE__] = ACTIONS(3140),
    [anon_sym___SUB__] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_fork] = ACTIONS(3140),
    [anon_sym_getppid] = ACTIONS(3140),
    [anon_sym_time] = ACTIONS(3140),
    [anon_sym_times] = ACTIONS(3140),
    [anon_sym_wait] = ACTIONS(3140),
    [anon_sym_wantarray] = ACTIONS(3140),
    [anon_sym_abs] = ACTIONS(3140),
    [anon_sym_alarm] = ACTIONS(3140),
    [anon_sym_chop] = ACTIONS(3140),
    [anon_sym_chdir] = ACTIONS(3140),
    [anon_sym_close] = ACTIONS(3140),
    [anon_sym_closedir] = ACTIONS(3140),
    [anon_sym_caller] = ACTIONS(3140),
    [anon_sym_chomp] = ACTIONS(3140),
    [anon_sym_chr] = ACTIONS(3140),
    [anon_sym_cos] = ACTIONS(3140),
    [anon_sym_chroot] = ACTIONS(3140),
    [anon_sym_defined] = ACTIONS(3140),
    [anon_sym_delete] = ACTIONS(3140),
    [anon_sym_dbmclose] = ACTIONS(3140),
    [anon_sym_exists] = ACTIONS(3140),
    [anon_sym_exit] = ACTIONS(3140),
    [anon_sym_eof] = ACTIONS(3140),
    [anon_sym_exp] = ACTIONS(3140),
    [anon_sym_each] = ACTIONS(3140),
    [anon_sym_fc] = ACTIONS(3140),
    [anon_sym_fileno] = ACTIONS(3140),
    [anon_sym_gmtime] = ACTIONS(3140),
    [anon_sym_getc] = ACTIONS(3140),
    [anon_sym_getpgrp] = ACTIONS(3140),
    [anon_sym_getprotobyname] = ACTIONS(3140),
    [anon_sym_getpwname] = ACTIONS(3140),
    [anon_sym_getpwuid] = ACTIONS(3140),
    [anon_sym_getpeername] = ACTIONS(3140),
    [anon_sym_getnetbyname] = ACTIONS(3140),
    [anon_sym_getsockname] = ACTIONS(3140),
    [anon_sym_getgrnam] = ACTIONS(3140),
    [anon_sym_getgrgid] = ACTIONS(3140),
    [anon_sym_hex] = ACTIONS(3140),
    [anon_sym_int] = ACTIONS(3140),
    [anon_sym_keys] = ACTIONS(3140),
    [anon_sym_lc] = ACTIONS(3140),
    [anon_sym_lcfirst] = ACTIONS(3140),
    [anon_sym_length] = ACTIONS(3140),
    [anon_sym_localtime] = ACTIONS(3140),
    [anon_sym_log] = ACTIONS(3140),
    [anon_sym_lock] = ACTIONS(3140),
    [anon_sym_lstat] = ACTIONS(3140),
    [anon_sym_oct] = ACTIONS(3140),
    [anon_sym_ord] = ACTIONS(3140),
    [anon_sym_prototype] = ACTIONS(3140),
    [anon_sym_pop] = ACTIONS(3140),
    [anon_sym_pos] = ACTIONS(3140),
    [anon_sym_quotemeta] = ACTIONS(3140),
    [anon_sym_reset] = ACTIONS(3140),
    [anon_sym_rand] = ACTIONS(3140),
    [anon_sym_rmdir] = ACTIONS(3140),
    [anon_sym_readdir] = ACTIONS(3140),
    [anon_sym_readline] = ACTIONS(3140),
    [anon_sym_readpipe] = ACTIONS(3140),
    [anon_sym_rewinddir] = ACTIONS(3140),
    [anon_sym_readlink] = ACTIONS(3140),
    [anon_sym_ref] = ACTIONS(3140),
    [anon_sym_scalar] = ACTIONS(3140),
    [anon_sym_shift] = ACTIONS(3140),
    [anon_sym_sin] = ACTIONS(3140),
    [anon_sym_sleep] = ACTIONS(3140),
    [anon_sym_sqrt] = ACTIONS(3140),
    [anon_sym_srand] = ACTIONS(3140),
    [anon_sym_stat] = ACTIONS(3140),
    [anon_sym_study] = ACTIONS(3140),
    [anon_sym_tell] = ACTIONS(3140),
    [anon_sym_telldir] = ACTIONS(3140),
    [anon_sym_tied] = ACTIONS(3140),
    [anon_sym_uc] = ACTIONS(3140),
    [anon_sym_ucfirst] = ACTIONS(3140),
    [anon_sym_untie] = ACTIONS(3140),
    [anon_sym_umask] = ACTIONS(3140),
    [anon_sym_values] = ACTIONS(3140),
    [anon_sym_write] = ACTIONS(3140),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3140),
    [anon_sym___END__] = ACTIONS(3140),
    [anon_sym_EOT] = ACTIONS(3140),
    [anon_sym_q] = ACTIONS(3140),
    [anon_sym_qq] = ACTIONS(3140),
    [anon_sym_qw] = ACTIONS(3140),
    [anon_sym_qx] = ACTIONS(3140),
    [anon_sym_qr] = ACTIONS(3140),
    [anon_sym_m] = ACTIONS(3140),
    [anon_sym_s] = ACTIONS(3140),
    [anon_sym_tr] = ACTIONS(3140),
    [anon_sym_y] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_unless] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_until] = ACTIONS(3140),
    [aux_sym__bareword_token1] = ACTIONS(3140),
    [sym_number] = ACTIONS(3140),
    [sym__apostrophe] = ACTIONS(3138),
    [sym__double_quote] = ACTIONS(3138),
    [sym__backtick] = ACTIONS(3138),
    [sym__search_slash] = ACTIONS(3138),
    [sym__PERLY_HEREDOC] = ACTIONS(3138),
    [sym__ctrl_z_hack] = ACTIONS(3138),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1004] = {
    [sym_heredoc_content] = STATE(1004),
    [ts_builtin_sym_end] = ACTIONS(3142),
    [sym__identifier] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_LBRACE2] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym_package] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_sub] = ACTIONS(3144),
    [anon_sym_method] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_my] = ACTIONS(3144),
    [anon_sym_state] = ACTIONS(3144),
    [anon_sym_our] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_defer] = ACTIONS(3144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_elsif] = ACTIONS(3144),
    [anon_sym_and] = ACTIONS(3144),
    [anon_sym_or] = ACTIONS(3144),
    [anon_sym_DOLLAR] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_AT] = ACTIONS(3144),
    [anon_sym_LT] = ACTIONS(3144),
    [anon_sym_LT_LT] = ACTIONS(3144),
    [anon_sym_SLASH_SLASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_eq] = ACTIONS(3144),
    [anon_sym_ne] = ACTIONS(3144),
    [anon_sym_cmp] = ACTIONS(3144),
    [anon_sym_lt] = ACTIONS(3144),
    [anon_sym_le] = ACTIONS(3144),
    [anon_sym_ge] = ACTIONS(3144),
    [anon_sym_gt] = ACTIONS(3144),
    [anon_sym_isa] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [anon_sym_BSLASH] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_eval] = ACTIONS(3144),
    [anon_sym_field] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3144),
    [anon_sym_require] = ACTIONS(3144),
    [anon_sym_map] = ACTIONS(3144),
    [anon_sym_grep] = ACTIONS(3144),
    [anon_sym_sort] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_undef] = ACTIONS(3144),
    [anon_sym_PERCENT2] = ACTIONS(3144),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3144),
    [anon_sym_use] = ACTIONS(3144),
    [anon_sym_no] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_foreach] = ACTIONS(3144),
    [anon_sym_last] = ACTIONS(3144),
    [anon_sym_next] = ACTIONS(3144),
    [anon_sym_redo] = ACTIONS(3144),
    [anon_sym_BEGIN] = ACTIONS(3144),
    [anon_sym_INIT] = ACTIONS(3144),
    [anon_sym_CHECK] = ACTIONS(3144),
    [anon_sym_UNITCHECK] = ACTIONS(3144),
    [anon_sym_END] = ACTIONS(3144),
    [anon_sym_ADJUST] = ACTIONS(3144),
    [anon_sym___FILE__] = ACTIONS(3144),
    [anon_sym___LINE__] = ACTIONS(3144),
    [anon_sym___PACKAGE__] = ACTIONS(3144),
    [anon_sym___SUB__] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_fork] = ACTIONS(3144),
    [anon_sym_getppid] = ACTIONS(3144),
    [anon_sym_time] = ACTIONS(3144),
    [anon_sym_times] = ACTIONS(3144),
    [anon_sym_wait] = ACTIONS(3144),
    [anon_sym_wantarray] = ACTIONS(3144),
    [anon_sym_abs] = ACTIONS(3144),
    [anon_sym_alarm] = ACTIONS(3144),
    [anon_sym_chop] = ACTIONS(3144),
    [anon_sym_chdir] = ACTIONS(3144),
    [anon_sym_close] = ACTIONS(3144),
    [anon_sym_closedir] = ACTIONS(3144),
    [anon_sym_caller] = ACTIONS(3144),
    [anon_sym_chomp] = ACTIONS(3144),
    [anon_sym_chr] = ACTIONS(3144),
    [anon_sym_cos] = ACTIONS(3144),
    [anon_sym_chroot] = ACTIONS(3144),
    [anon_sym_defined] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_dbmclose] = ACTIONS(3144),
    [anon_sym_exists] = ACTIONS(3144),
    [anon_sym_exit] = ACTIONS(3144),
    [anon_sym_eof] = ACTIONS(3144),
    [anon_sym_exp] = ACTIONS(3144),
    [anon_sym_each] = ACTIONS(3144),
    [anon_sym_fc] = ACTIONS(3144),
    [anon_sym_fileno] = ACTIONS(3144),
    [anon_sym_gmtime] = ACTIONS(3144),
    [anon_sym_getc] = ACTIONS(3144),
    [anon_sym_getpgrp] = ACTIONS(3144),
    [anon_sym_getprotobyname] = ACTIONS(3144),
    [anon_sym_getpwname] = ACTIONS(3144),
    [anon_sym_getpwuid] = ACTIONS(3144),
    [anon_sym_getpeername] = ACTIONS(3144),
    [anon_sym_getnetbyname] = ACTIONS(3144),
    [anon_sym_getsockname] = ACTIONS(3144),
    [anon_sym_getgrnam] = ACTIONS(3144),
    [anon_sym_getgrgid] = ACTIONS(3144),
    [anon_sym_hex] = ACTIONS(3144),
    [anon_sym_int] = ACTIONS(3144),
    [anon_sym_keys] = ACTIONS(3144),
    [anon_sym_lc] = ACTIONS(3144),
    [anon_sym_lcfirst] = ACTIONS(3144),
    [anon_sym_length] = ACTIONS(3144),
    [anon_sym_localtime] = ACTIONS(3144),
    [anon_sym_log] = ACTIONS(3144),
    [anon_sym_lock] = ACTIONS(3144),
    [anon_sym_lstat] = ACTIONS(3144),
    [anon_sym_oct] = ACTIONS(3144),
    [anon_sym_ord] = ACTIONS(3144),
    [anon_sym_prototype] = ACTIONS(3144),
    [anon_sym_pop] = ACTIONS(3144),
    [anon_sym_pos] = ACTIONS(3144),
    [anon_sym_quotemeta] = ACTIONS(3144),
    [anon_sym_reset] = ACTIONS(3144),
    [anon_sym_rand] = ACTIONS(3144),
    [anon_sym_rmdir] = ACTIONS(3144),
    [anon_sym_readdir] = ACTIONS(3144),
    [anon_sym_readline] = ACTIONS(3144),
    [anon_sym_readpipe] = ACTIONS(3144),
    [anon_sym_rewinddir] = ACTIONS(3144),
    [anon_sym_readlink] = ACTIONS(3144),
    [anon_sym_ref] = ACTIONS(3144),
    [anon_sym_scalar] = ACTIONS(3144),
    [anon_sym_shift] = ACTIONS(3144),
    [anon_sym_sin] = ACTIONS(3144),
    [anon_sym_sleep] = ACTIONS(3144),
    [anon_sym_sqrt] = ACTIONS(3144),
    [anon_sym_srand] = ACTIONS(3144),
    [anon_sym_stat] = ACTIONS(3144),
    [anon_sym_study] = ACTIONS(3144),
    [anon_sym_tell] = ACTIONS(3144),
    [anon_sym_telldir] = ACTIONS(3144),
    [anon_sym_tied] = ACTIONS(3144),
    [anon_sym_uc] = ACTIONS(3144),
    [anon_sym_ucfirst] = ACTIONS(3144),
    [anon_sym_untie] = ACTIONS(3144),
    [anon_sym_umask] = ACTIONS(3144),
    [anon_sym_values] = ACTIONS(3144),
    [anon_sym_write] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3144),
    [anon_sym___END__] = ACTIONS(3144),
    [anon_sym_EOT] = ACTIONS(3144),
    [anon_sym_q] = ACTIONS(3144),
    [anon_sym_qq] = ACTIONS(3144),
    [anon_sym_qw] = ACTIONS(3144),
    [anon_sym_qx] = ACTIONS(3144),
    [anon_sym_qr] = ACTIONS(3144),
    [anon_sym_m] = ACTIONS(3144),
    [anon_sym_s] = ACTIONS(3144),
    [anon_sym_tr] = ACTIONS(3144),
    [anon_sym_y] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_unless] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_until] = ACTIONS(3144),
    [aux_sym__bareword_token1] = ACTIONS(3144),
    [sym_number] = ACTIONS(3144),
    [sym__apostrophe] = ACTIONS(3142),
    [sym__double_quote] = ACTIONS(3142),
    [sym__backtick] = ACTIONS(3142),
    [sym__search_slash] = ACTIONS(3142),
    [sym__PERLY_HEREDOC] = ACTIONS(3142),
    [sym__ctrl_z_hack] = ACTIONS(3142),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1005] = {
    [sym_heredoc_content] = STATE(1005),
    [ts_builtin_sym_end] = ACTIONS(3146),
    [sym__identifier] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_LBRACE2] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_package] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_sub] = ACTIONS(3148),
    [anon_sym_method] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_my] = ACTIONS(3148),
    [anon_sym_state] = ACTIONS(3148),
    [anon_sym_our] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_defer] = ACTIONS(3148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_elsif] = ACTIONS(3148),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_DOLLAR] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_LT_LT] = ACTIONS(3148),
    [anon_sym_SLASH_SLASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_eq] = ACTIONS(3148),
    [anon_sym_ne] = ACTIONS(3148),
    [anon_sym_cmp] = ACTIONS(3148),
    [anon_sym_lt] = ACTIONS(3148),
    [anon_sym_le] = ACTIONS(3148),
    [anon_sym_ge] = ACTIONS(3148),
    [anon_sym_gt] = ACTIONS(3148),
    [anon_sym_isa] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_BSLASH] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_eval] = ACTIONS(3148),
    [anon_sym_field] = ACTIONS(3148),
    [anon_sym_local] = ACTIONS(3148),
    [anon_sym_require] = ACTIONS(3148),
    [anon_sym_map] = ACTIONS(3148),
    [anon_sym_grep] = ACTIONS(3148),
    [anon_sym_sort] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_undef] = ACTIONS(3148),
    [anon_sym_PERCENT2] = ACTIONS(3148),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3148),
    [anon_sym_use] = ACTIONS(3148),
    [anon_sym_no] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_foreach] = ACTIONS(3148),
    [anon_sym_last] = ACTIONS(3148),
    [anon_sym_next] = ACTIONS(3148),
    [anon_sym_redo] = ACTIONS(3148),
    [anon_sym_BEGIN] = ACTIONS(3148),
    [anon_sym_INIT] = ACTIONS(3148),
    [anon_sym_CHECK] = ACTIONS(3148),
    [anon_sym_UNITCHECK] = ACTIONS(3148),
    [anon_sym_END] = ACTIONS(3148),
    [anon_sym_ADJUST] = ACTIONS(3148),
    [anon_sym___FILE__] = ACTIONS(3148),
    [anon_sym___LINE__] = ACTIONS(3148),
    [anon_sym___PACKAGE__] = ACTIONS(3148),
    [anon_sym___SUB__] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_fork] = ACTIONS(3148),
    [anon_sym_getppid] = ACTIONS(3148),
    [anon_sym_time] = ACTIONS(3148),
    [anon_sym_times] = ACTIONS(3148),
    [anon_sym_wait] = ACTIONS(3148),
    [anon_sym_wantarray] = ACTIONS(3148),
    [anon_sym_abs] = ACTIONS(3148),
    [anon_sym_alarm] = ACTIONS(3148),
    [anon_sym_chop] = ACTIONS(3148),
    [anon_sym_chdir] = ACTIONS(3148),
    [anon_sym_close] = ACTIONS(3148),
    [anon_sym_closedir] = ACTIONS(3148),
    [anon_sym_caller] = ACTIONS(3148),
    [anon_sym_chomp] = ACTIONS(3148),
    [anon_sym_chr] = ACTIONS(3148),
    [anon_sym_cos] = ACTIONS(3148),
    [anon_sym_chroot] = ACTIONS(3148),
    [anon_sym_defined] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_dbmclose] = ACTIONS(3148),
    [anon_sym_exists] = ACTIONS(3148),
    [anon_sym_exit] = ACTIONS(3148),
    [anon_sym_eof] = ACTIONS(3148),
    [anon_sym_exp] = ACTIONS(3148),
    [anon_sym_each] = ACTIONS(3148),
    [anon_sym_fc] = ACTIONS(3148),
    [anon_sym_fileno] = ACTIONS(3148),
    [anon_sym_gmtime] = ACTIONS(3148),
    [anon_sym_getc] = ACTIONS(3148),
    [anon_sym_getpgrp] = ACTIONS(3148),
    [anon_sym_getprotobyname] = ACTIONS(3148),
    [anon_sym_getpwname] = ACTIONS(3148),
    [anon_sym_getpwuid] = ACTIONS(3148),
    [anon_sym_getpeername] = ACTIONS(3148),
    [anon_sym_getnetbyname] = ACTIONS(3148),
    [anon_sym_getsockname] = ACTIONS(3148),
    [anon_sym_getgrnam] = ACTIONS(3148),
    [anon_sym_getgrgid] = ACTIONS(3148),
    [anon_sym_hex] = ACTIONS(3148),
    [anon_sym_int] = ACTIONS(3148),
    [anon_sym_keys] = ACTIONS(3148),
    [anon_sym_lc] = ACTIONS(3148),
    [anon_sym_lcfirst] = ACTIONS(3148),
    [anon_sym_length] = ACTIONS(3148),
    [anon_sym_localtime] = ACTIONS(3148),
    [anon_sym_log] = ACTIONS(3148),
    [anon_sym_lock] = ACTIONS(3148),
    [anon_sym_lstat] = ACTIONS(3148),
    [anon_sym_oct] = ACTIONS(3148),
    [anon_sym_ord] = ACTIONS(3148),
    [anon_sym_prototype] = ACTIONS(3148),
    [anon_sym_pop] = ACTIONS(3148),
    [anon_sym_pos] = ACTIONS(3148),
    [anon_sym_quotemeta] = ACTIONS(3148),
    [anon_sym_reset] = ACTIONS(3148),
    [anon_sym_rand] = ACTIONS(3148),
    [anon_sym_rmdir] = ACTIONS(3148),
    [anon_sym_readdir] = ACTIONS(3148),
    [anon_sym_readline] = ACTIONS(3148),
    [anon_sym_readpipe] = ACTIONS(3148),
    [anon_sym_rewinddir] = ACTIONS(3148),
    [anon_sym_readlink] = ACTIONS(3148),
    [anon_sym_ref] = ACTIONS(3148),
    [anon_sym_scalar] = ACTIONS(3148),
    [anon_sym_shift] = ACTIONS(3148),
    [anon_sym_sin] = ACTIONS(3148),
    [anon_sym_sleep] = ACTIONS(3148),
    [anon_sym_sqrt] = ACTIONS(3148),
    [anon_sym_srand] = ACTIONS(3148),
    [anon_sym_stat] = ACTIONS(3148),
    [anon_sym_study] = ACTIONS(3148),
    [anon_sym_tell] = ACTIONS(3148),
    [anon_sym_telldir] = ACTIONS(3148),
    [anon_sym_tied] = ACTIONS(3148),
    [anon_sym_uc] = ACTIONS(3148),
    [anon_sym_ucfirst] = ACTIONS(3148),
    [anon_sym_untie] = ACTIONS(3148),
    [anon_sym_umask] = ACTIONS(3148),
    [anon_sym_values] = ACTIONS(3148),
    [anon_sym_write] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3148),
    [anon_sym___END__] = ACTIONS(3148),
    [anon_sym_EOT] = ACTIONS(3148),
    [anon_sym_q] = ACTIONS(3148),
    [anon_sym_qq] = ACTIONS(3148),
    [anon_sym_qw] = ACTIONS(3148),
    [anon_sym_qx] = ACTIONS(3148),
    [anon_sym_qr] = ACTIONS(3148),
    [anon_sym_m] = ACTIONS(3148),
    [anon_sym_s] = ACTIONS(3148),
    [anon_sym_tr] = ACTIONS(3148),
    [anon_sym_y] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [aux_sym__bareword_token1] = ACTIONS(3148),
    [sym_number] = ACTIONS(3148),
    [sym__apostrophe] = ACTIONS(3146),
    [sym__double_quote] = ACTIONS(3146),
    [sym__backtick] = ACTIONS(3146),
    [sym__search_slash] = ACTIONS(3146),
    [sym__PERLY_HEREDOC] = ACTIONS(3146),
    [sym__ctrl_z_hack] = ACTIONS(3146),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1006] = {
    [sym_heredoc_content] = STATE(1006),
    [ts_builtin_sym_end] = ACTIONS(3153),
    [sym__identifier] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_LBRACE2] = ACTIONS(3155),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym_package] = ACTIONS(3155),
    [anon_sym_class] = ACTIONS(3155),
    [anon_sym_sub] = ACTIONS(3155),
    [anon_sym_method] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_continue] = ACTIONS(3157),
    [anon_sym_my] = ACTIONS(3155),
    [anon_sym_state] = ACTIONS(3155),
    [anon_sym_our] = ACTIONS(3155),
    [anon_sym_try] = ACTIONS(3155),
    [anon_sym_defer] = ACTIONS(3155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3155),
    [anon_sym_else] = ACTIONS(3155),
    [anon_sym_elsif] = ACTIONS(3155),
    [anon_sym_and] = ACTIONS(3155),
    [anon_sym_or] = ACTIONS(3155),
    [anon_sym_DOLLAR] = ACTIONS(3155),
    [anon_sym_LBRACK] = ACTIONS(3155),
    [anon_sym_AT] = ACTIONS(3155),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_LT_LT] = ACTIONS(3155),
    [anon_sym_SLASH_SLASH] = ACTIONS(3155),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [anon_sym_STAR] = ACTIONS(3155),
    [anon_sym_eq] = ACTIONS(3155),
    [anon_sym_ne] = ACTIONS(3155),
    [anon_sym_cmp] = ACTIONS(3155),
    [anon_sym_lt] = ACTIONS(3155),
    [anon_sym_le] = ACTIONS(3155),
    [anon_sym_ge] = ACTIONS(3155),
    [anon_sym_gt] = ACTIONS(3155),
    [anon_sym_isa] = ACTIONS(3155),
    [anon_sym_TILDE] = ACTIONS(3155),
    [anon_sym_BANG] = ACTIONS(3155),
    [anon_sym_PLUS_PLUS] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3155),
    [anon_sym_BSLASH] = ACTIONS(3153),
    [anon_sym_do] = ACTIONS(3155),
    [anon_sym_eval] = ACTIONS(3155),
    [anon_sym_field] = ACTIONS(3155),
    [anon_sym_local] = ACTIONS(3155),
    [anon_sym_require] = ACTIONS(3155),
    [anon_sym_map] = ACTIONS(3155),
    [anon_sym_grep] = ACTIONS(3155),
    [anon_sym_sort] = ACTIONS(3155),
    [anon_sym_goto] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_undef] = ACTIONS(3155),
    [anon_sym_PERCENT2] = ACTIONS(3155),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3155),
    [anon_sym_use] = ACTIONS(3155),
    [anon_sym_no] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_foreach] = ACTIONS(3155),
    [anon_sym_last] = ACTIONS(3155),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_redo] = ACTIONS(3155),
    [anon_sym_BEGIN] = ACTIONS(3155),
    [anon_sym_INIT] = ACTIONS(3155),
    [anon_sym_CHECK] = ACTIONS(3155),
    [anon_sym_UNITCHECK] = ACTIONS(3155),
    [anon_sym_END] = ACTIONS(3155),
    [anon_sym_ADJUST] = ACTIONS(3155),
    [anon_sym___FILE__] = ACTIONS(3155),
    [anon_sym___LINE__] = ACTIONS(3155),
    [anon_sym___PACKAGE__] = ACTIONS(3155),
    [anon_sym___SUB__] = ACTIONS(3155),
    [anon_sym_break] = ACTIONS(3155),
    [anon_sym_fork] = ACTIONS(3155),
    [anon_sym_getppid] = ACTIONS(3155),
    [anon_sym_time] = ACTIONS(3155),
    [anon_sym_times] = ACTIONS(3155),
    [anon_sym_wait] = ACTIONS(3155),
    [anon_sym_wantarray] = ACTIONS(3155),
    [anon_sym_abs] = ACTIONS(3155),
    [anon_sym_alarm] = ACTIONS(3155),
    [anon_sym_chop] = ACTIONS(3155),
    [anon_sym_chdir] = ACTIONS(3155),
    [anon_sym_close] = ACTIONS(3155),
    [anon_sym_closedir] = ACTIONS(3155),
    [anon_sym_caller] = ACTIONS(3155),
    [anon_sym_chomp] = ACTIONS(3155),
    [anon_sym_chr] = ACTIONS(3155),
    [anon_sym_cos] = ACTIONS(3155),
    [anon_sym_chroot] = ACTIONS(3155),
    [anon_sym_defined] = ACTIONS(3155),
    [anon_sym_delete] = ACTIONS(3155),
    [anon_sym_dbmclose] = ACTIONS(3155),
    [anon_sym_exists] = ACTIONS(3155),
    [anon_sym_exit] = ACTIONS(3155),
    [anon_sym_eof] = ACTIONS(3155),
    [anon_sym_exp] = ACTIONS(3155),
    [anon_sym_each] = ACTIONS(3155),
    [anon_sym_fc] = ACTIONS(3155),
    [anon_sym_fileno] = ACTIONS(3155),
    [anon_sym_gmtime] = ACTIONS(3155),
    [anon_sym_getc] = ACTIONS(3155),
    [anon_sym_getpgrp] = ACTIONS(3155),
    [anon_sym_getprotobyname] = ACTIONS(3155),
    [anon_sym_getpwname] = ACTIONS(3155),
    [anon_sym_getpwuid] = ACTIONS(3155),
    [anon_sym_getpeername] = ACTIONS(3155),
    [anon_sym_getnetbyname] = ACTIONS(3155),
    [anon_sym_getsockname] = ACTIONS(3155),
    [anon_sym_getgrnam] = ACTIONS(3155),
    [anon_sym_getgrgid] = ACTIONS(3155),
    [anon_sym_hex] = ACTIONS(3155),
    [anon_sym_int] = ACTIONS(3155),
    [anon_sym_keys] = ACTIONS(3155),
    [anon_sym_lc] = ACTIONS(3155),
    [anon_sym_lcfirst] = ACTIONS(3155),
    [anon_sym_length] = ACTIONS(3155),
    [anon_sym_localtime] = ACTIONS(3155),
    [anon_sym_log] = ACTIONS(3155),
    [anon_sym_lock] = ACTIONS(3155),
    [anon_sym_lstat] = ACTIONS(3155),
    [anon_sym_oct] = ACTIONS(3155),
    [anon_sym_ord] = ACTIONS(3155),
    [anon_sym_prototype] = ACTIONS(3155),
    [anon_sym_pop] = ACTIONS(3155),
    [anon_sym_pos] = ACTIONS(3155),
    [anon_sym_quotemeta] = ACTIONS(3155),
    [anon_sym_reset] = ACTIONS(3155),
    [anon_sym_rand] = ACTIONS(3155),
    [anon_sym_rmdir] = ACTIONS(3155),
    [anon_sym_readdir] = ACTIONS(3155),
    [anon_sym_readline] = ACTIONS(3155),
    [anon_sym_readpipe] = ACTIONS(3155),
    [anon_sym_rewinddir] = ACTIONS(3155),
    [anon_sym_readlink] = ACTIONS(3155),
    [anon_sym_ref] = ACTIONS(3155),
    [anon_sym_scalar] = ACTIONS(3155),
    [anon_sym_shift] = ACTIONS(3155),
    [anon_sym_sin] = ACTIONS(3155),
    [anon_sym_sleep] = ACTIONS(3155),
    [anon_sym_sqrt] = ACTIONS(3155),
    [anon_sym_srand] = ACTIONS(3155),
    [anon_sym_stat] = ACTIONS(3155),
    [anon_sym_study] = ACTIONS(3155),
    [anon_sym_tell] = ACTIONS(3155),
    [anon_sym_telldir] = ACTIONS(3155),
    [anon_sym_tied] = ACTIONS(3155),
    [anon_sym_uc] = ACTIONS(3155),
    [anon_sym_ucfirst] = ACTIONS(3155),
    [anon_sym_untie] = ACTIONS(3155),
    [anon_sym_umask] = ACTIONS(3155),
    [anon_sym_values] = ACTIONS(3155),
    [anon_sym_write] = ACTIONS(3155),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3155),
    [anon_sym___END__] = ACTIONS(3155),
    [anon_sym_EOT] = ACTIONS(3155),
    [anon_sym_q] = ACTIONS(3155),
    [anon_sym_qq] = ACTIONS(3155),
    [anon_sym_qw] = ACTIONS(3155),
    [anon_sym_qx] = ACTIONS(3155),
    [anon_sym_qr] = ACTIONS(3155),
    [anon_sym_m] = ACTIONS(3155),
    [anon_sym_s] = ACTIONS(3155),
    [anon_sym_tr] = ACTIONS(3155),
    [anon_sym_y] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_unless] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [anon_sym_until] = ACTIONS(3155),
    [aux_sym__bareword_token1] = ACTIONS(3155),
    [sym_number] = ACTIONS(3155),
    [sym__apostrophe] = ACTIONS(3153),
    [sym__double_quote] = ACTIONS(3153),
    [sym__backtick] = ACTIONS(3153),
    [sym__search_slash] = ACTIONS(3153),
    [sym__PERLY_HEREDOC] = ACTIONS(3153),
    [sym__ctrl_z_hack] = ACTIONS(3153),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1007] = {
    [sym_heredoc_content] = STATE(1007),
    [ts_builtin_sym_end] = ACTIONS(3160),
    [sym__identifier] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_LBRACE2] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_package] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_sub] = ACTIONS(3162),
    [anon_sym_method] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_my] = ACTIONS(3162),
    [anon_sym_state] = ACTIONS(3162),
    [anon_sym_our] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_defer] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_elsif] = ACTIONS(3162),
    [anon_sym_and] = ACTIONS(3162),
    [anon_sym_or] = ACTIONS(3162),
    [anon_sym_DOLLAR] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3162),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_LT_LT] = ACTIONS(3162),
    [anon_sym_SLASH_SLASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_eq] = ACTIONS(3162),
    [anon_sym_ne] = ACTIONS(3162),
    [anon_sym_cmp] = ACTIONS(3162),
    [anon_sym_lt] = ACTIONS(3162),
    [anon_sym_le] = ACTIONS(3162),
    [anon_sym_ge] = ACTIONS(3162),
    [anon_sym_gt] = ACTIONS(3162),
    [anon_sym_isa] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [anon_sym_BSLASH] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_eval] = ACTIONS(3162),
    [anon_sym_field] = ACTIONS(3162),
    [anon_sym_local] = ACTIONS(3162),
    [anon_sym_require] = ACTIONS(3162),
    [anon_sym_map] = ACTIONS(3162),
    [anon_sym_grep] = ACTIONS(3162),
    [anon_sym_sort] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_undef] = ACTIONS(3162),
    [anon_sym_PERCENT2] = ACTIONS(3162),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3162),
    [anon_sym_use] = ACTIONS(3162),
    [anon_sym_no] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_foreach] = ACTIONS(3162),
    [anon_sym_last] = ACTIONS(3162),
    [anon_sym_next] = ACTIONS(3162),
    [anon_sym_redo] = ACTIONS(3162),
    [anon_sym_BEGIN] = ACTIONS(3162),
    [anon_sym_INIT] = ACTIONS(3162),
    [anon_sym_CHECK] = ACTIONS(3162),
    [anon_sym_UNITCHECK] = ACTIONS(3162),
    [anon_sym_END] = ACTIONS(3162),
    [anon_sym_ADJUST] = ACTIONS(3162),
    [anon_sym___FILE__] = ACTIONS(3162),
    [anon_sym___LINE__] = ACTIONS(3162),
    [anon_sym___PACKAGE__] = ACTIONS(3162),
    [anon_sym___SUB__] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_fork] = ACTIONS(3162),
    [anon_sym_getppid] = ACTIONS(3162),
    [anon_sym_time] = ACTIONS(3162),
    [anon_sym_times] = ACTIONS(3162),
    [anon_sym_wait] = ACTIONS(3162),
    [anon_sym_wantarray] = ACTIONS(3162),
    [anon_sym_abs] = ACTIONS(3162),
    [anon_sym_alarm] = ACTIONS(3162),
    [anon_sym_chop] = ACTIONS(3162),
    [anon_sym_chdir] = ACTIONS(3162),
    [anon_sym_close] = ACTIONS(3162),
    [anon_sym_closedir] = ACTIONS(3162),
    [anon_sym_caller] = ACTIONS(3162),
    [anon_sym_chomp] = ACTIONS(3162),
    [anon_sym_chr] = ACTIONS(3162),
    [anon_sym_cos] = ACTIONS(3162),
    [anon_sym_chroot] = ACTIONS(3162),
    [anon_sym_defined] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_dbmclose] = ACTIONS(3162),
    [anon_sym_exists] = ACTIONS(3162),
    [anon_sym_exit] = ACTIONS(3162),
    [anon_sym_eof] = ACTIONS(3162),
    [anon_sym_exp] = ACTIONS(3162),
    [anon_sym_each] = ACTIONS(3162),
    [anon_sym_fc] = ACTIONS(3162),
    [anon_sym_fileno] = ACTIONS(3162),
    [anon_sym_gmtime] = ACTIONS(3162),
    [anon_sym_getc] = ACTIONS(3162),
    [anon_sym_getpgrp] = ACTIONS(3162),
    [anon_sym_getprotobyname] = ACTIONS(3162),
    [anon_sym_getpwname] = ACTIONS(3162),
    [anon_sym_getpwuid] = ACTIONS(3162),
    [anon_sym_getpeername] = ACTIONS(3162),
    [anon_sym_getnetbyname] = ACTIONS(3162),
    [anon_sym_getsockname] = ACTIONS(3162),
    [anon_sym_getgrnam] = ACTIONS(3162),
    [anon_sym_getgrgid] = ACTIONS(3162),
    [anon_sym_hex] = ACTIONS(3162),
    [anon_sym_int] = ACTIONS(3162),
    [anon_sym_keys] = ACTIONS(3162),
    [anon_sym_lc] = ACTIONS(3162),
    [anon_sym_lcfirst] = ACTIONS(3162),
    [anon_sym_length] = ACTIONS(3162),
    [anon_sym_localtime] = ACTIONS(3162),
    [anon_sym_log] = ACTIONS(3162),
    [anon_sym_lock] = ACTIONS(3162),
    [anon_sym_lstat] = ACTIONS(3162),
    [anon_sym_oct] = ACTIONS(3162),
    [anon_sym_ord] = ACTIONS(3162),
    [anon_sym_prototype] = ACTIONS(3162),
    [anon_sym_pop] = ACTIONS(3162),
    [anon_sym_pos] = ACTIONS(3162),
    [anon_sym_quotemeta] = ACTIONS(3162),
    [anon_sym_reset] = ACTIONS(3162),
    [anon_sym_rand] = ACTIONS(3162),
    [anon_sym_rmdir] = ACTIONS(3162),
    [anon_sym_readdir] = ACTIONS(3162),
    [anon_sym_readline] = ACTIONS(3162),
    [anon_sym_readpipe] = ACTIONS(3162),
    [anon_sym_rewinddir] = ACTIONS(3162),
    [anon_sym_readlink] = ACTIONS(3162),
    [anon_sym_ref] = ACTIONS(3162),
    [anon_sym_scalar] = ACTIONS(3162),
    [anon_sym_shift] = ACTIONS(3162),
    [anon_sym_sin] = ACTIONS(3162),
    [anon_sym_sleep] = ACTIONS(3162),
    [anon_sym_sqrt] = ACTIONS(3162),
    [anon_sym_srand] = ACTIONS(3162),
    [anon_sym_stat] = ACTIONS(3162),
    [anon_sym_study] = ACTIONS(3162),
    [anon_sym_tell] = ACTIONS(3162),
    [anon_sym_telldir] = ACTIONS(3162),
    [anon_sym_tied] = ACTIONS(3162),
    [anon_sym_uc] = ACTIONS(3162),
    [anon_sym_ucfirst] = ACTIONS(3162),
    [anon_sym_untie] = ACTIONS(3162),
    [anon_sym_umask] = ACTIONS(3162),
    [anon_sym_values] = ACTIONS(3162),
    [anon_sym_write] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3162),
    [anon_sym___END__] = ACTIONS(3162),
    [anon_sym_EOT] = ACTIONS(3162),
    [anon_sym_q] = ACTIONS(3162),
    [anon_sym_qq] = ACTIONS(3162),
    [anon_sym_qw] = ACTIONS(3162),
    [anon_sym_qx] = ACTIONS(3162),
    [anon_sym_qr] = ACTIONS(3162),
    [anon_sym_m] = ACTIONS(3162),
    [anon_sym_s] = ACTIONS(3162),
    [anon_sym_tr] = ACTIONS(3162),
    [anon_sym_y] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_unless] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_until] = ACTIONS(3162),
    [aux_sym__bareword_token1] = ACTIONS(3162),
    [sym_number] = ACTIONS(3162),
    [sym__apostrophe] = ACTIONS(3160),
    [sym__double_quote] = ACTIONS(3160),
    [sym__backtick] = ACTIONS(3160),
    [sym__search_slash] = ACTIONS(3160),
    [sym__PERLY_HEREDOC] = ACTIONS(3160),
    [sym__ctrl_z_hack] = ACTIONS(3160),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1008] = {
    [sym_heredoc_content] = STATE(1008),
    [ts_builtin_sym_end] = ACTIONS(3164),
    [sym__identifier] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_LBRACE2] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_package] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_sub] = ACTIONS(3166),
    [anon_sym_method] = ACTIONS(3166),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_my] = ACTIONS(3166),
    [anon_sym_state] = ACTIONS(3166),
    [anon_sym_our] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_defer] = ACTIONS(3166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3166),
    [anon_sym_else] = ACTIONS(3166),
    [anon_sym_elsif] = ACTIONS(3166),
    [anon_sym_and] = ACTIONS(3166),
    [anon_sym_or] = ACTIONS(3166),
    [anon_sym_DOLLAR] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_AT] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_LT_LT] = ACTIONS(3166),
    [anon_sym_SLASH_SLASH] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_eq] = ACTIONS(3166),
    [anon_sym_ne] = ACTIONS(3166),
    [anon_sym_cmp] = ACTIONS(3166),
    [anon_sym_lt] = ACTIONS(3166),
    [anon_sym_le] = ACTIONS(3166),
    [anon_sym_ge] = ACTIONS(3166),
    [anon_sym_gt] = ACTIONS(3166),
    [anon_sym_isa] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [anon_sym_BSLASH] = ACTIONS(3164),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_eval] = ACTIONS(3166),
    [anon_sym_field] = ACTIONS(3166),
    [anon_sym_local] = ACTIONS(3166),
    [anon_sym_require] = ACTIONS(3166),
    [anon_sym_map] = ACTIONS(3166),
    [anon_sym_grep] = ACTIONS(3166),
    [anon_sym_sort] = ACTIONS(3166),
    [anon_sym_goto] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_undef] = ACTIONS(3166),
    [anon_sym_PERCENT2] = ACTIONS(3166),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3166),
    [anon_sym_use] = ACTIONS(3166),
    [anon_sym_no] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_foreach] = ACTIONS(3166),
    [anon_sym_last] = ACTIONS(3166),
    [anon_sym_next] = ACTIONS(3166),
    [anon_sym_redo] = ACTIONS(3166),
    [anon_sym_BEGIN] = ACTIONS(3166),
    [anon_sym_INIT] = ACTIONS(3166),
    [anon_sym_CHECK] = ACTIONS(3166),
    [anon_sym_UNITCHECK] = ACTIONS(3166),
    [anon_sym_END] = ACTIONS(3166),
    [anon_sym_ADJUST] = ACTIONS(3166),
    [anon_sym___FILE__] = ACTIONS(3166),
    [anon_sym___LINE__] = ACTIONS(3166),
    [anon_sym___PACKAGE__] = ACTIONS(3166),
    [anon_sym___SUB__] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_fork] = ACTIONS(3166),
    [anon_sym_getppid] = ACTIONS(3166),
    [anon_sym_time] = ACTIONS(3166),
    [anon_sym_times] = ACTIONS(3166),
    [anon_sym_wait] = ACTIONS(3166),
    [anon_sym_wantarray] = ACTIONS(3166),
    [anon_sym_abs] = ACTIONS(3166),
    [anon_sym_alarm] = ACTIONS(3166),
    [anon_sym_chop] = ACTIONS(3166),
    [anon_sym_chdir] = ACTIONS(3166),
    [anon_sym_close] = ACTIONS(3166),
    [anon_sym_closedir] = ACTIONS(3166),
    [anon_sym_caller] = ACTIONS(3166),
    [anon_sym_chomp] = ACTIONS(3166),
    [anon_sym_chr] = ACTIONS(3166),
    [anon_sym_cos] = ACTIONS(3166),
    [anon_sym_chroot] = ACTIONS(3166),
    [anon_sym_defined] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_dbmclose] = ACTIONS(3166),
    [anon_sym_exists] = ACTIONS(3166),
    [anon_sym_exit] = ACTIONS(3166),
    [anon_sym_eof] = ACTIONS(3166),
    [anon_sym_exp] = ACTIONS(3166),
    [anon_sym_each] = ACTIONS(3166),
    [anon_sym_fc] = ACTIONS(3166),
    [anon_sym_fileno] = ACTIONS(3166),
    [anon_sym_gmtime] = ACTIONS(3166),
    [anon_sym_getc] = ACTIONS(3166),
    [anon_sym_getpgrp] = ACTIONS(3166),
    [anon_sym_getprotobyname] = ACTIONS(3166),
    [anon_sym_getpwname] = ACTIONS(3166),
    [anon_sym_getpwuid] = ACTIONS(3166),
    [anon_sym_getpeername] = ACTIONS(3166),
    [anon_sym_getnetbyname] = ACTIONS(3166),
    [anon_sym_getsockname] = ACTIONS(3166),
    [anon_sym_getgrnam] = ACTIONS(3166),
    [anon_sym_getgrgid] = ACTIONS(3166),
    [anon_sym_hex] = ACTIONS(3166),
    [anon_sym_int] = ACTIONS(3166),
    [anon_sym_keys] = ACTIONS(3166),
    [anon_sym_lc] = ACTIONS(3166),
    [anon_sym_lcfirst] = ACTIONS(3166),
    [anon_sym_length] = ACTIONS(3166),
    [anon_sym_localtime] = ACTIONS(3166),
    [anon_sym_log] = ACTIONS(3166),
    [anon_sym_lock] = ACTIONS(3166),
    [anon_sym_lstat] = ACTIONS(3166),
    [anon_sym_oct] = ACTIONS(3166),
    [anon_sym_ord] = ACTIONS(3166),
    [anon_sym_prototype] = ACTIONS(3166),
    [anon_sym_pop] = ACTIONS(3166),
    [anon_sym_pos] = ACTIONS(3166),
    [anon_sym_quotemeta] = ACTIONS(3166),
    [anon_sym_reset] = ACTIONS(3166),
    [anon_sym_rand] = ACTIONS(3166),
    [anon_sym_rmdir] = ACTIONS(3166),
    [anon_sym_readdir] = ACTIONS(3166),
    [anon_sym_readline] = ACTIONS(3166),
    [anon_sym_readpipe] = ACTIONS(3166),
    [anon_sym_rewinddir] = ACTIONS(3166),
    [anon_sym_readlink] = ACTIONS(3166),
    [anon_sym_ref] = ACTIONS(3166),
    [anon_sym_scalar] = ACTIONS(3166),
    [anon_sym_shift] = ACTIONS(3166),
    [anon_sym_sin] = ACTIONS(3166),
    [anon_sym_sleep] = ACTIONS(3166),
    [anon_sym_sqrt] = ACTIONS(3166),
    [anon_sym_srand] = ACTIONS(3166),
    [anon_sym_stat] = ACTIONS(3166),
    [anon_sym_study] = ACTIONS(3166),
    [anon_sym_tell] = ACTIONS(3166),
    [anon_sym_telldir] = ACTIONS(3166),
    [anon_sym_tied] = ACTIONS(3166),
    [anon_sym_uc] = ACTIONS(3166),
    [anon_sym_ucfirst] = ACTIONS(3166),
    [anon_sym_untie] = ACTIONS(3166),
    [anon_sym_umask] = ACTIONS(3166),
    [anon_sym_values] = ACTIONS(3166),
    [anon_sym_write] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3166),
    [anon_sym___END__] = ACTIONS(3166),
    [anon_sym_EOT] = ACTIONS(3166),
    [anon_sym_q] = ACTIONS(3166),
    [anon_sym_qq] = ACTIONS(3166),
    [anon_sym_qw] = ACTIONS(3166),
    [anon_sym_qx] = ACTIONS(3166),
    [anon_sym_qr] = ACTIONS(3166),
    [anon_sym_m] = ACTIONS(3166),
    [anon_sym_s] = ACTIONS(3166),
    [anon_sym_tr] = ACTIONS(3166),
    [anon_sym_y] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_unless] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_until] = ACTIONS(3166),
    [aux_sym__bareword_token1] = ACTIONS(3166),
    [sym_number] = ACTIONS(3166),
    [sym__apostrophe] = ACTIONS(3164),
    [sym__double_quote] = ACTIONS(3164),
    [sym__backtick] = ACTIONS(3164),
    [sym__search_slash] = ACTIONS(3164),
    [sym__PERLY_HEREDOC] = ACTIONS(3164),
    [sym__ctrl_z_hack] = ACTIONS(3164),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1009] = {
    [sym_heredoc_content] = STATE(1009),
    [ts_builtin_sym_end] = ACTIONS(3171),
    [sym__identifier] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3173),
    [anon_sym_LBRACE2] = ACTIONS(3173),
    [anon_sym_SEMI] = ACTIONS(3173),
    [anon_sym_package] = ACTIONS(3173),
    [anon_sym_class] = ACTIONS(3173),
    [anon_sym_sub] = ACTIONS(3173),
    [anon_sym_method] = ACTIONS(3173),
    [anon_sym_LPAREN] = ACTIONS(3173),
    [anon_sym_continue] = ACTIONS(3173),
    [anon_sym_my] = ACTIONS(3173),
    [anon_sym_state] = ACTIONS(3173),
    [anon_sym_our] = ACTIONS(3173),
    [anon_sym_try] = ACTIONS(3173),
    [anon_sym_defer] = ACTIONS(3173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3173),
    [anon_sym_else] = ACTIONS(3173),
    [anon_sym_elsif] = ACTIONS(3173),
    [anon_sym_and] = ACTIONS(3173),
    [anon_sym_or] = ACTIONS(3173),
    [anon_sym_DOLLAR] = ACTIONS(3173),
    [anon_sym_LBRACK] = ACTIONS(3173),
    [anon_sym_AT] = ACTIONS(3173),
    [anon_sym_LT] = ACTIONS(3173),
    [anon_sym_LT_LT] = ACTIONS(3173),
    [anon_sym_SLASH_SLASH] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3173),
    [anon_sym_DASH] = ACTIONS(3173),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_eq] = ACTIONS(3173),
    [anon_sym_ne] = ACTIONS(3173),
    [anon_sym_cmp] = ACTIONS(3173),
    [anon_sym_lt] = ACTIONS(3173),
    [anon_sym_le] = ACTIONS(3173),
    [anon_sym_ge] = ACTIONS(3173),
    [anon_sym_gt] = ACTIONS(3173),
    [anon_sym_isa] = ACTIONS(3173),
    [anon_sym_TILDE] = ACTIONS(3173),
    [anon_sym_BANG] = ACTIONS(3173),
    [anon_sym_PLUS_PLUS] = ACTIONS(3173),
    [anon_sym_DASH_DASH] = ACTIONS(3173),
    [anon_sym_BSLASH] = ACTIONS(3171),
    [anon_sym_do] = ACTIONS(3173),
    [anon_sym_eval] = ACTIONS(3173),
    [anon_sym_field] = ACTIONS(3173),
    [anon_sym_local] = ACTIONS(3173),
    [anon_sym_require] = ACTIONS(3173),
    [anon_sym_map] = ACTIONS(3173),
    [anon_sym_grep] = ACTIONS(3173),
    [anon_sym_sort] = ACTIONS(3173),
    [anon_sym_goto] = ACTIONS(3173),
    [anon_sym_return] = ACTIONS(3173),
    [anon_sym_undef] = ACTIONS(3173),
    [anon_sym_PERCENT2] = ACTIONS(3173),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3173),
    [anon_sym_use] = ACTIONS(3173),
    [anon_sym_no] = ACTIONS(3173),
    [anon_sym_for] = ACTIONS(3173),
    [anon_sym_foreach] = ACTIONS(3173),
    [anon_sym_last] = ACTIONS(3173),
    [anon_sym_next] = ACTIONS(3173),
    [anon_sym_redo] = ACTIONS(3173),
    [anon_sym_BEGIN] = ACTIONS(3173),
    [anon_sym_INIT] = ACTIONS(3173),
    [anon_sym_CHECK] = ACTIONS(3173),
    [anon_sym_UNITCHECK] = ACTIONS(3173),
    [anon_sym_END] = ACTIONS(3173),
    [anon_sym_ADJUST] = ACTIONS(3173),
    [anon_sym___FILE__] = ACTIONS(3173),
    [anon_sym___LINE__] = ACTIONS(3173),
    [anon_sym___PACKAGE__] = ACTIONS(3173),
    [anon_sym___SUB__] = ACTIONS(3173),
    [anon_sym_break] = ACTIONS(3173),
    [anon_sym_fork] = ACTIONS(3173),
    [anon_sym_getppid] = ACTIONS(3173),
    [anon_sym_time] = ACTIONS(3173),
    [anon_sym_times] = ACTIONS(3173),
    [anon_sym_wait] = ACTIONS(3173),
    [anon_sym_wantarray] = ACTIONS(3173),
    [anon_sym_abs] = ACTIONS(3173),
    [anon_sym_alarm] = ACTIONS(3173),
    [anon_sym_chop] = ACTIONS(3173),
    [anon_sym_chdir] = ACTIONS(3173),
    [anon_sym_close] = ACTIONS(3173),
    [anon_sym_closedir] = ACTIONS(3173),
    [anon_sym_caller] = ACTIONS(3173),
    [anon_sym_chomp] = ACTIONS(3173),
    [anon_sym_chr] = ACTIONS(3173),
    [anon_sym_cos] = ACTIONS(3173),
    [anon_sym_chroot] = ACTIONS(3173),
    [anon_sym_defined] = ACTIONS(3173),
    [anon_sym_delete] = ACTIONS(3173),
    [anon_sym_dbmclose] = ACTIONS(3173),
    [anon_sym_exists] = ACTIONS(3173),
    [anon_sym_exit] = ACTIONS(3173),
    [anon_sym_eof] = ACTIONS(3173),
    [anon_sym_exp] = ACTIONS(3173),
    [anon_sym_each] = ACTIONS(3173),
    [anon_sym_fc] = ACTIONS(3173),
    [anon_sym_fileno] = ACTIONS(3173),
    [anon_sym_gmtime] = ACTIONS(3173),
    [anon_sym_getc] = ACTIONS(3173),
    [anon_sym_getpgrp] = ACTIONS(3173),
    [anon_sym_getprotobyname] = ACTIONS(3173),
    [anon_sym_getpwname] = ACTIONS(3173),
    [anon_sym_getpwuid] = ACTIONS(3173),
    [anon_sym_getpeername] = ACTIONS(3173),
    [anon_sym_getnetbyname] = ACTIONS(3173),
    [anon_sym_getsockname] = ACTIONS(3173),
    [anon_sym_getgrnam] = ACTIONS(3173),
    [anon_sym_getgrgid] = ACTIONS(3173),
    [anon_sym_hex] = ACTIONS(3173),
    [anon_sym_int] = ACTIONS(3173),
    [anon_sym_keys] = ACTIONS(3173),
    [anon_sym_lc] = ACTIONS(3173),
    [anon_sym_lcfirst] = ACTIONS(3173),
    [anon_sym_length] = ACTIONS(3173),
    [anon_sym_localtime] = ACTIONS(3173),
    [anon_sym_log] = ACTIONS(3173),
    [anon_sym_lock] = ACTIONS(3173),
    [anon_sym_lstat] = ACTIONS(3173),
    [anon_sym_oct] = ACTIONS(3173),
    [anon_sym_ord] = ACTIONS(3173),
    [anon_sym_prototype] = ACTIONS(3173),
    [anon_sym_pop] = ACTIONS(3173),
    [anon_sym_pos] = ACTIONS(3173),
    [anon_sym_quotemeta] = ACTIONS(3173),
    [anon_sym_reset] = ACTIONS(3173),
    [anon_sym_rand] = ACTIONS(3173),
    [anon_sym_rmdir] = ACTIONS(3173),
    [anon_sym_readdir] = ACTIONS(3173),
    [anon_sym_readline] = ACTIONS(3173),
    [anon_sym_readpipe] = ACTIONS(3173),
    [anon_sym_rewinddir] = ACTIONS(3173),
    [anon_sym_readlink] = ACTIONS(3173),
    [anon_sym_ref] = ACTIONS(3173),
    [anon_sym_scalar] = ACTIONS(3173),
    [anon_sym_shift] = ACTIONS(3173),
    [anon_sym_sin] = ACTIONS(3173),
    [anon_sym_sleep] = ACTIONS(3173),
    [anon_sym_sqrt] = ACTIONS(3173),
    [anon_sym_srand] = ACTIONS(3173),
    [anon_sym_stat] = ACTIONS(3173),
    [anon_sym_study] = ACTIONS(3173),
    [anon_sym_tell] = ACTIONS(3173),
    [anon_sym_telldir] = ACTIONS(3173),
    [anon_sym_tied] = ACTIONS(3173),
    [anon_sym_uc] = ACTIONS(3173),
    [anon_sym_ucfirst] = ACTIONS(3173),
    [anon_sym_untie] = ACTIONS(3173),
    [anon_sym_umask] = ACTIONS(3173),
    [anon_sym_values] = ACTIONS(3173),
    [anon_sym_write] = ACTIONS(3173),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3173),
    [anon_sym___END__] = ACTIONS(3173),
    [anon_sym_EOT] = ACTIONS(3173),
    [anon_sym_q] = ACTIONS(3173),
    [anon_sym_qq] = ACTIONS(3173),
    [anon_sym_qw] = ACTIONS(3173),
    [anon_sym_qx] = ACTIONS(3173),
    [anon_sym_qr] = ACTIONS(3173),
    [anon_sym_m] = ACTIONS(3173),
    [anon_sym_s] = ACTIONS(3173),
    [anon_sym_tr] = ACTIONS(3173),
    [anon_sym_y] = ACTIONS(3173),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_unless] = ACTIONS(3173),
    [anon_sym_while] = ACTIONS(3173),
    [anon_sym_until] = ACTIONS(3173),
    [aux_sym__bareword_token1] = ACTIONS(3173),
    [sym_number] = ACTIONS(3173),
    [sym__apostrophe] = ACTIONS(3171),
    [sym__double_quote] = ACTIONS(3171),
    [sym__backtick] = ACTIONS(3171),
    [sym__search_slash] = ACTIONS(3171),
    [sym__PERLY_HEREDOC] = ACTIONS(3171),
    [sym__ctrl_z_hack] = ACTIONS(3171),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1010] = {
    [sym_heredoc_content] = STATE(1010),
    [ts_builtin_sym_end] = ACTIONS(3175),
    [sym__identifier] = ACTIONS(3177),
    [anon_sym_LBRACE] = ACTIONS(3177),
    [anon_sym_LBRACE2] = ACTIONS(3177),
    [anon_sym_SEMI] = ACTIONS(3177),
    [anon_sym_package] = ACTIONS(3177),
    [anon_sym_class] = ACTIONS(3177),
    [anon_sym_sub] = ACTIONS(3177),
    [anon_sym_method] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3177),
    [anon_sym_continue] = ACTIONS(3177),
    [anon_sym_my] = ACTIONS(3177),
    [anon_sym_state] = ACTIONS(3177),
    [anon_sym_our] = ACTIONS(3177),
    [anon_sym_try] = ACTIONS(3177),
    [anon_sym_defer] = ACTIONS(3177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3177),
    [anon_sym_else] = ACTIONS(3177),
    [anon_sym_elsif] = ACTIONS(3177),
    [anon_sym_and] = ACTIONS(3177),
    [anon_sym_or] = ACTIONS(3177),
    [anon_sym_DOLLAR] = ACTIONS(3177),
    [anon_sym_LBRACK] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3177),
    [anon_sym_LT] = ACTIONS(3177),
    [anon_sym_LT_LT] = ACTIONS(3177),
    [anon_sym_SLASH_SLASH] = ACTIONS(3177),
    [anon_sym_PLUS] = ACTIONS(3177),
    [anon_sym_DASH] = ACTIONS(3177),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_eq] = ACTIONS(3177),
    [anon_sym_ne] = ACTIONS(3177),
    [anon_sym_cmp] = ACTIONS(3177),
    [anon_sym_lt] = ACTIONS(3177),
    [anon_sym_le] = ACTIONS(3177),
    [anon_sym_ge] = ACTIONS(3177),
    [anon_sym_gt] = ACTIONS(3177),
    [anon_sym_isa] = ACTIONS(3177),
    [anon_sym_TILDE] = ACTIONS(3177),
    [anon_sym_BANG] = ACTIONS(3177),
    [anon_sym_PLUS_PLUS] = ACTIONS(3177),
    [anon_sym_DASH_DASH] = ACTIONS(3177),
    [anon_sym_BSLASH] = ACTIONS(3175),
    [anon_sym_do] = ACTIONS(3177),
    [anon_sym_eval] = ACTIONS(3177),
    [anon_sym_field] = ACTIONS(3177),
    [anon_sym_local] = ACTIONS(3177),
    [anon_sym_require] = ACTIONS(3177),
    [anon_sym_map] = ACTIONS(3177),
    [anon_sym_grep] = ACTIONS(3177),
    [anon_sym_sort] = ACTIONS(3177),
    [anon_sym_goto] = ACTIONS(3177),
    [anon_sym_return] = ACTIONS(3177),
    [anon_sym_undef] = ACTIONS(3177),
    [anon_sym_PERCENT2] = ACTIONS(3177),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3177),
    [anon_sym_use] = ACTIONS(3177),
    [anon_sym_no] = ACTIONS(3177),
    [anon_sym_for] = ACTIONS(3177),
    [anon_sym_foreach] = ACTIONS(3177),
    [anon_sym_last] = ACTIONS(3177),
    [anon_sym_next] = ACTIONS(3177),
    [anon_sym_redo] = ACTIONS(3177),
    [anon_sym_BEGIN] = ACTIONS(3177),
    [anon_sym_INIT] = ACTIONS(3177),
    [anon_sym_CHECK] = ACTIONS(3177),
    [anon_sym_UNITCHECK] = ACTIONS(3177),
    [anon_sym_END] = ACTIONS(3177),
    [anon_sym_ADJUST] = ACTIONS(3177),
    [anon_sym___FILE__] = ACTIONS(3177),
    [anon_sym___LINE__] = ACTIONS(3177),
    [anon_sym___PACKAGE__] = ACTIONS(3177),
    [anon_sym___SUB__] = ACTIONS(3177),
    [anon_sym_break] = ACTIONS(3177),
    [anon_sym_fork] = ACTIONS(3177),
    [anon_sym_getppid] = ACTIONS(3177),
    [anon_sym_time] = ACTIONS(3177),
    [anon_sym_times] = ACTIONS(3177),
    [anon_sym_wait] = ACTIONS(3177),
    [anon_sym_wantarray] = ACTIONS(3177),
    [anon_sym_abs] = ACTIONS(3177),
    [anon_sym_alarm] = ACTIONS(3177),
    [anon_sym_chop] = ACTIONS(3177),
    [anon_sym_chdir] = ACTIONS(3177),
    [anon_sym_close] = ACTIONS(3177),
    [anon_sym_closedir] = ACTIONS(3177),
    [anon_sym_caller] = ACTIONS(3177),
    [anon_sym_chomp] = ACTIONS(3177),
    [anon_sym_chr] = ACTIONS(3177),
    [anon_sym_cos] = ACTIONS(3177),
    [anon_sym_chroot] = ACTIONS(3177),
    [anon_sym_defined] = ACTIONS(3177),
    [anon_sym_delete] = ACTIONS(3177),
    [anon_sym_dbmclose] = ACTIONS(3177),
    [anon_sym_exists] = ACTIONS(3177),
    [anon_sym_exit] = ACTIONS(3177),
    [anon_sym_eof] = ACTIONS(3177),
    [anon_sym_exp] = ACTIONS(3177),
    [anon_sym_each] = ACTIONS(3177),
    [anon_sym_fc] = ACTIONS(3177),
    [anon_sym_fileno] = ACTIONS(3177),
    [anon_sym_gmtime] = ACTIONS(3177),
    [anon_sym_getc] = ACTIONS(3177),
    [anon_sym_getpgrp] = ACTIONS(3177),
    [anon_sym_getprotobyname] = ACTIONS(3177),
    [anon_sym_getpwname] = ACTIONS(3177),
    [anon_sym_getpwuid] = ACTIONS(3177),
    [anon_sym_getpeername] = ACTIONS(3177),
    [anon_sym_getnetbyname] = ACTIONS(3177),
    [anon_sym_getsockname] = ACTIONS(3177),
    [anon_sym_getgrnam] = ACTIONS(3177),
    [anon_sym_getgrgid] = ACTIONS(3177),
    [anon_sym_hex] = ACTIONS(3177),
    [anon_sym_int] = ACTIONS(3177),
    [anon_sym_keys] = ACTIONS(3177),
    [anon_sym_lc] = ACTIONS(3177),
    [anon_sym_lcfirst] = ACTIONS(3177),
    [anon_sym_length] = ACTIONS(3177),
    [anon_sym_localtime] = ACTIONS(3177),
    [anon_sym_log] = ACTIONS(3177),
    [anon_sym_lock] = ACTIONS(3177),
    [anon_sym_lstat] = ACTIONS(3177),
    [anon_sym_oct] = ACTIONS(3177),
    [anon_sym_ord] = ACTIONS(3177),
    [anon_sym_prototype] = ACTIONS(3177),
    [anon_sym_pop] = ACTIONS(3177),
    [anon_sym_pos] = ACTIONS(3177),
    [anon_sym_quotemeta] = ACTIONS(3177),
    [anon_sym_reset] = ACTIONS(3177),
    [anon_sym_rand] = ACTIONS(3177),
    [anon_sym_rmdir] = ACTIONS(3177),
    [anon_sym_readdir] = ACTIONS(3177),
    [anon_sym_readline] = ACTIONS(3177),
    [anon_sym_readpipe] = ACTIONS(3177),
    [anon_sym_rewinddir] = ACTIONS(3177),
    [anon_sym_readlink] = ACTIONS(3177),
    [anon_sym_ref] = ACTIONS(3177),
    [anon_sym_scalar] = ACTIONS(3177),
    [anon_sym_shift] = ACTIONS(3177),
    [anon_sym_sin] = ACTIONS(3177),
    [anon_sym_sleep] = ACTIONS(3177),
    [anon_sym_sqrt] = ACTIONS(3177),
    [anon_sym_srand] = ACTIONS(3177),
    [anon_sym_stat] = ACTIONS(3177),
    [anon_sym_study] = ACTIONS(3177),
    [anon_sym_tell] = ACTIONS(3177),
    [anon_sym_telldir] = ACTIONS(3177),
    [anon_sym_tied] = ACTIONS(3177),
    [anon_sym_uc] = ACTIONS(3177),
    [anon_sym_ucfirst] = ACTIONS(3177),
    [anon_sym_untie] = ACTIONS(3177),
    [anon_sym_umask] = ACTIONS(3177),
    [anon_sym_values] = ACTIONS(3177),
    [anon_sym_write] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3177),
    [anon_sym___END__] = ACTIONS(3177),
    [anon_sym_EOT] = ACTIONS(3177),
    [anon_sym_q] = ACTIONS(3177),
    [anon_sym_qq] = ACTIONS(3177),
    [anon_sym_qw] = ACTIONS(3177),
    [anon_sym_qx] = ACTIONS(3177),
    [anon_sym_qr] = ACTIONS(3177),
    [anon_sym_m] = ACTIONS(3177),
    [anon_sym_s] = ACTIONS(3177),
    [anon_sym_tr] = ACTIONS(3177),
    [anon_sym_y] = ACTIONS(3177),
    [anon_sym_if] = ACTIONS(3177),
    [anon_sym_unless] = ACTIONS(3177),
    [anon_sym_while] = ACTIONS(3177),
    [anon_sym_until] = ACTIONS(3177),
    [aux_sym__bareword_token1] = ACTIONS(3177),
    [sym_number] = ACTIONS(3177),
    [sym__apostrophe] = ACTIONS(3175),
    [sym__double_quote] = ACTIONS(3175),
    [sym__backtick] = ACTIONS(3175),
    [sym__search_slash] = ACTIONS(3175),
    [sym__PERLY_HEREDOC] = ACTIONS(3175),
    [sym__ctrl_z_hack] = ACTIONS(3175),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1011] = {
    [sym_heredoc_content] = STATE(1011),
    [ts_builtin_sym_end] = ACTIONS(3179),
    [sym__identifier] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LBRACE2] = ACTIONS(3181),
    [anon_sym_SEMI] = ACTIONS(3181),
    [anon_sym_package] = ACTIONS(3181),
    [anon_sym_class] = ACTIONS(3181),
    [anon_sym_sub] = ACTIONS(3181),
    [anon_sym_method] = ACTIONS(3181),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_continue] = ACTIONS(3181),
    [anon_sym_my] = ACTIONS(3181),
    [anon_sym_state] = ACTIONS(3181),
    [anon_sym_our] = ACTIONS(3181),
    [anon_sym_try] = ACTIONS(3181),
    [anon_sym_defer] = ACTIONS(3181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3181),
    [anon_sym_else] = ACTIONS(3181),
    [anon_sym_elsif] = ACTIONS(3181),
    [anon_sym_and] = ACTIONS(3181),
    [anon_sym_or] = ACTIONS(3181),
    [anon_sym_DOLLAR] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(3181),
    [anon_sym_LT_LT] = ACTIONS(3181),
    [anon_sym_SLASH_SLASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(3181),
    [anon_sym_eq] = ACTIONS(3181),
    [anon_sym_ne] = ACTIONS(3181),
    [anon_sym_cmp] = ACTIONS(3181),
    [anon_sym_lt] = ACTIONS(3181),
    [anon_sym_le] = ACTIONS(3181),
    [anon_sym_ge] = ACTIONS(3181),
    [anon_sym_gt] = ACTIONS(3181),
    [anon_sym_isa] = ACTIONS(3181),
    [anon_sym_TILDE] = ACTIONS(3181),
    [anon_sym_BANG] = ACTIONS(3181),
    [anon_sym_PLUS_PLUS] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(3181),
    [anon_sym_BSLASH] = ACTIONS(3179),
    [anon_sym_do] = ACTIONS(3181),
    [anon_sym_eval] = ACTIONS(3181),
    [anon_sym_field] = ACTIONS(3181),
    [anon_sym_local] = ACTIONS(3181),
    [anon_sym_require] = ACTIONS(3181),
    [anon_sym_map] = ACTIONS(3181),
    [anon_sym_grep] = ACTIONS(3181),
    [anon_sym_sort] = ACTIONS(3181),
    [anon_sym_goto] = ACTIONS(3181),
    [anon_sym_return] = ACTIONS(3181),
    [anon_sym_undef] = ACTIONS(3181),
    [anon_sym_PERCENT2] = ACTIONS(3181),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3181),
    [anon_sym_use] = ACTIONS(3181),
    [anon_sym_no] = ACTIONS(3181),
    [anon_sym_for] = ACTIONS(3181),
    [anon_sym_foreach] = ACTIONS(3181),
    [anon_sym_last] = ACTIONS(3181),
    [anon_sym_next] = ACTIONS(3181),
    [anon_sym_redo] = ACTIONS(3181),
    [anon_sym_BEGIN] = ACTIONS(3181),
    [anon_sym_INIT] = ACTIONS(3181),
    [anon_sym_CHECK] = ACTIONS(3181),
    [anon_sym_UNITCHECK] = ACTIONS(3181),
    [anon_sym_END] = ACTIONS(3181),
    [anon_sym_ADJUST] = ACTIONS(3181),
    [anon_sym___FILE__] = ACTIONS(3181),
    [anon_sym___LINE__] = ACTIONS(3181),
    [anon_sym___PACKAGE__] = ACTIONS(3181),
    [anon_sym___SUB__] = ACTIONS(3181),
    [anon_sym_break] = ACTIONS(3181),
    [anon_sym_fork] = ACTIONS(3181),
    [anon_sym_getppid] = ACTIONS(3181),
    [anon_sym_time] = ACTIONS(3181),
    [anon_sym_times] = ACTIONS(3181),
    [anon_sym_wait] = ACTIONS(3181),
    [anon_sym_wantarray] = ACTIONS(3181),
    [anon_sym_abs] = ACTIONS(3181),
    [anon_sym_alarm] = ACTIONS(3181),
    [anon_sym_chop] = ACTIONS(3181),
    [anon_sym_chdir] = ACTIONS(3181),
    [anon_sym_close] = ACTIONS(3181),
    [anon_sym_closedir] = ACTIONS(3181),
    [anon_sym_caller] = ACTIONS(3181),
    [anon_sym_chomp] = ACTIONS(3181),
    [anon_sym_chr] = ACTIONS(3181),
    [anon_sym_cos] = ACTIONS(3181),
    [anon_sym_chroot] = ACTIONS(3181),
    [anon_sym_defined] = ACTIONS(3181),
    [anon_sym_delete] = ACTIONS(3181),
    [anon_sym_dbmclose] = ACTIONS(3181),
    [anon_sym_exists] = ACTIONS(3181),
    [anon_sym_exit] = ACTIONS(3181),
    [anon_sym_eof] = ACTIONS(3181),
    [anon_sym_exp] = ACTIONS(3181),
    [anon_sym_each] = ACTIONS(3181),
    [anon_sym_fc] = ACTIONS(3181),
    [anon_sym_fileno] = ACTIONS(3181),
    [anon_sym_gmtime] = ACTIONS(3181),
    [anon_sym_getc] = ACTIONS(3181),
    [anon_sym_getpgrp] = ACTIONS(3181),
    [anon_sym_getprotobyname] = ACTIONS(3181),
    [anon_sym_getpwname] = ACTIONS(3181),
    [anon_sym_getpwuid] = ACTIONS(3181),
    [anon_sym_getpeername] = ACTIONS(3181),
    [anon_sym_getnetbyname] = ACTIONS(3181),
    [anon_sym_getsockname] = ACTIONS(3181),
    [anon_sym_getgrnam] = ACTIONS(3181),
    [anon_sym_getgrgid] = ACTIONS(3181),
    [anon_sym_hex] = ACTIONS(3181),
    [anon_sym_int] = ACTIONS(3181),
    [anon_sym_keys] = ACTIONS(3181),
    [anon_sym_lc] = ACTIONS(3181),
    [anon_sym_lcfirst] = ACTIONS(3181),
    [anon_sym_length] = ACTIONS(3181),
    [anon_sym_localtime] = ACTIONS(3181),
    [anon_sym_log] = ACTIONS(3181),
    [anon_sym_lock] = ACTIONS(3181),
    [anon_sym_lstat] = ACTIONS(3181),
    [anon_sym_oct] = ACTIONS(3181),
    [anon_sym_ord] = ACTIONS(3181),
    [anon_sym_prototype] = ACTIONS(3181),
    [anon_sym_pop] = ACTIONS(3181),
    [anon_sym_pos] = ACTIONS(3181),
    [anon_sym_quotemeta] = ACTIONS(3181),
    [anon_sym_reset] = ACTIONS(3181),
    [anon_sym_rand] = ACTIONS(3181),
    [anon_sym_rmdir] = ACTIONS(3181),
    [anon_sym_readdir] = ACTIONS(3181),
    [anon_sym_readline] = ACTIONS(3181),
    [anon_sym_readpipe] = ACTIONS(3181),
    [anon_sym_rewinddir] = ACTIONS(3181),
    [anon_sym_readlink] = ACTIONS(3181),
    [anon_sym_ref] = ACTIONS(3181),
    [anon_sym_scalar] = ACTIONS(3181),
    [anon_sym_shift] = ACTIONS(3181),
    [anon_sym_sin] = ACTIONS(3181),
    [anon_sym_sleep] = ACTIONS(3181),
    [anon_sym_sqrt] = ACTIONS(3181),
    [anon_sym_srand] = ACTIONS(3181),
    [anon_sym_stat] = ACTIONS(3181),
    [anon_sym_study] = ACTIONS(3181),
    [anon_sym_tell] = ACTIONS(3181),
    [anon_sym_telldir] = ACTIONS(3181),
    [anon_sym_tied] = ACTIONS(3181),
    [anon_sym_uc] = ACTIONS(3181),
    [anon_sym_ucfirst] = ACTIONS(3181),
    [anon_sym_untie] = ACTIONS(3181),
    [anon_sym_umask] = ACTIONS(3181),
    [anon_sym_values] = ACTIONS(3181),
    [anon_sym_write] = ACTIONS(3181),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3181),
    [anon_sym___END__] = ACTIONS(3181),
    [anon_sym_EOT] = ACTIONS(3181),
    [anon_sym_q] = ACTIONS(3181),
    [anon_sym_qq] = ACTIONS(3181),
    [anon_sym_qw] = ACTIONS(3181),
    [anon_sym_qx] = ACTIONS(3181),
    [anon_sym_qr] = ACTIONS(3181),
    [anon_sym_m] = ACTIONS(3181),
    [anon_sym_s] = ACTIONS(3181),
    [anon_sym_tr] = ACTIONS(3181),
    [anon_sym_y] = ACTIONS(3181),
    [anon_sym_if] = ACTIONS(3181),
    [anon_sym_unless] = ACTIONS(3181),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_until] = ACTIONS(3181),
    [aux_sym__bareword_token1] = ACTIONS(3181),
    [sym_number] = ACTIONS(3181),
    [sym__apostrophe] = ACTIONS(3179),
    [sym__double_quote] = ACTIONS(3179),
    [sym__backtick] = ACTIONS(3179),
    [sym__search_slash] = ACTIONS(3179),
    [sym__PERLY_HEREDOC] = ACTIONS(3179),
    [sym__ctrl_z_hack] = ACTIONS(3179),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1012] = {
    [sym_heredoc_content] = STATE(1012),
    [ts_builtin_sym_end] = ACTIONS(3183),
    [sym__identifier] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(3185),
    [anon_sym_LBRACE2] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(3185),
    [anon_sym_package] = ACTIONS(3185),
    [anon_sym_class] = ACTIONS(3185),
    [anon_sym_sub] = ACTIONS(3185),
    [anon_sym_method] = ACTIONS(3185),
    [anon_sym_LPAREN] = ACTIONS(3185),
    [anon_sym_continue] = ACTIONS(3185),
    [anon_sym_my] = ACTIONS(3185),
    [anon_sym_state] = ACTIONS(3185),
    [anon_sym_our] = ACTIONS(3185),
    [anon_sym_try] = ACTIONS(3185),
    [anon_sym_defer] = ACTIONS(3185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3185),
    [anon_sym_else] = ACTIONS(3185),
    [anon_sym_elsif] = ACTIONS(3185),
    [anon_sym_and] = ACTIONS(3185),
    [anon_sym_or] = ACTIONS(3185),
    [anon_sym_DOLLAR] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(3185),
    [anon_sym_AT] = ACTIONS(3185),
    [anon_sym_LT] = ACTIONS(3185),
    [anon_sym_LT_LT] = ACTIONS(3185),
    [anon_sym_SLASH_SLASH] = ACTIONS(3185),
    [anon_sym_PLUS] = ACTIONS(3185),
    [anon_sym_DASH] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3185),
    [anon_sym_eq] = ACTIONS(3185),
    [anon_sym_ne] = ACTIONS(3185),
    [anon_sym_cmp] = ACTIONS(3185),
    [anon_sym_lt] = ACTIONS(3185),
    [anon_sym_le] = ACTIONS(3185),
    [anon_sym_ge] = ACTIONS(3185),
    [anon_sym_gt] = ACTIONS(3185),
    [anon_sym_isa] = ACTIONS(3185),
    [anon_sym_TILDE] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_PLUS_PLUS] = ACTIONS(3185),
    [anon_sym_DASH_DASH] = ACTIONS(3185),
    [anon_sym_BSLASH] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3185),
    [anon_sym_eval] = ACTIONS(3185),
    [anon_sym_field] = ACTIONS(3185),
    [anon_sym_local] = ACTIONS(3185),
    [anon_sym_require] = ACTIONS(3185),
    [anon_sym_map] = ACTIONS(3185),
    [anon_sym_grep] = ACTIONS(3185),
    [anon_sym_sort] = ACTIONS(3185),
    [anon_sym_goto] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3185),
    [anon_sym_undef] = ACTIONS(3185),
    [anon_sym_PERCENT2] = ACTIONS(3185),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3185),
    [anon_sym_use] = ACTIONS(3185),
    [anon_sym_no] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_foreach] = ACTIONS(3185),
    [anon_sym_last] = ACTIONS(3185),
    [anon_sym_next] = ACTIONS(3185),
    [anon_sym_redo] = ACTIONS(3185),
    [anon_sym_BEGIN] = ACTIONS(3185),
    [anon_sym_INIT] = ACTIONS(3185),
    [anon_sym_CHECK] = ACTIONS(3185),
    [anon_sym_UNITCHECK] = ACTIONS(3185),
    [anon_sym_END] = ACTIONS(3185),
    [anon_sym_ADJUST] = ACTIONS(3185),
    [anon_sym___FILE__] = ACTIONS(3185),
    [anon_sym___LINE__] = ACTIONS(3185),
    [anon_sym___PACKAGE__] = ACTIONS(3185),
    [anon_sym___SUB__] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3185),
    [anon_sym_fork] = ACTIONS(3185),
    [anon_sym_getppid] = ACTIONS(3185),
    [anon_sym_time] = ACTIONS(3185),
    [anon_sym_times] = ACTIONS(3185),
    [anon_sym_wait] = ACTIONS(3185),
    [anon_sym_wantarray] = ACTIONS(3185),
    [anon_sym_abs] = ACTIONS(3185),
    [anon_sym_alarm] = ACTIONS(3185),
    [anon_sym_chop] = ACTIONS(3185),
    [anon_sym_chdir] = ACTIONS(3185),
    [anon_sym_close] = ACTIONS(3185),
    [anon_sym_closedir] = ACTIONS(3185),
    [anon_sym_caller] = ACTIONS(3185),
    [anon_sym_chomp] = ACTIONS(3185),
    [anon_sym_chr] = ACTIONS(3185),
    [anon_sym_cos] = ACTIONS(3185),
    [anon_sym_chroot] = ACTIONS(3185),
    [anon_sym_defined] = ACTIONS(3185),
    [anon_sym_delete] = ACTIONS(3185),
    [anon_sym_dbmclose] = ACTIONS(3185),
    [anon_sym_exists] = ACTIONS(3185),
    [anon_sym_exit] = ACTIONS(3185),
    [anon_sym_eof] = ACTIONS(3185),
    [anon_sym_exp] = ACTIONS(3185),
    [anon_sym_each] = ACTIONS(3185),
    [anon_sym_fc] = ACTIONS(3185),
    [anon_sym_fileno] = ACTIONS(3185),
    [anon_sym_gmtime] = ACTIONS(3185),
    [anon_sym_getc] = ACTIONS(3185),
    [anon_sym_getpgrp] = ACTIONS(3185),
    [anon_sym_getprotobyname] = ACTIONS(3185),
    [anon_sym_getpwname] = ACTIONS(3185),
    [anon_sym_getpwuid] = ACTIONS(3185),
    [anon_sym_getpeername] = ACTIONS(3185),
    [anon_sym_getnetbyname] = ACTIONS(3185),
    [anon_sym_getsockname] = ACTIONS(3185),
    [anon_sym_getgrnam] = ACTIONS(3185),
    [anon_sym_getgrgid] = ACTIONS(3185),
    [anon_sym_hex] = ACTIONS(3185),
    [anon_sym_int] = ACTIONS(3185),
    [anon_sym_keys] = ACTIONS(3185),
    [anon_sym_lc] = ACTIONS(3185),
    [anon_sym_lcfirst] = ACTIONS(3185),
    [anon_sym_length] = ACTIONS(3185),
    [anon_sym_localtime] = ACTIONS(3185),
    [anon_sym_log] = ACTIONS(3185),
    [anon_sym_lock] = ACTIONS(3185),
    [anon_sym_lstat] = ACTIONS(3185),
    [anon_sym_oct] = ACTIONS(3185),
    [anon_sym_ord] = ACTIONS(3185),
    [anon_sym_prototype] = ACTIONS(3185),
    [anon_sym_pop] = ACTIONS(3185),
    [anon_sym_pos] = ACTIONS(3185),
    [anon_sym_quotemeta] = ACTIONS(3185),
    [anon_sym_reset] = ACTIONS(3185),
    [anon_sym_rand] = ACTIONS(3185),
    [anon_sym_rmdir] = ACTIONS(3185),
    [anon_sym_readdir] = ACTIONS(3185),
    [anon_sym_readline] = ACTIONS(3185),
    [anon_sym_readpipe] = ACTIONS(3185),
    [anon_sym_rewinddir] = ACTIONS(3185),
    [anon_sym_readlink] = ACTIONS(3185),
    [anon_sym_ref] = ACTIONS(3185),
    [anon_sym_scalar] = ACTIONS(3185),
    [anon_sym_shift] = ACTIONS(3185),
    [anon_sym_sin] = ACTIONS(3185),
    [anon_sym_sleep] = ACTIONS(3185),
    [anon_sym_sqrt] = ACTIONS(3185),
    [anon_sym_srand] = ACTIONS(3185),
    [anon_sym_stat] = ACTIONS(3185),
    [anon_sym_study] = ACTIONS(3185),
    [anon_sym_tell] = ACTIONS(3185),
    [anon_sym_telldir] = ACTIONS(3185),
    [anon_sym_tied] = ACTIONS(3185),
    [anon_sym_uc] = ACTIONS(3185),
    [anon_sym_ucfirst] = ACTIONS(3185),
    [anon_sym_untie] = ACTIONS(3185),
    [anon_sym_umask] = ACTIONS(3185),
    [anon_sym_values] = ACTIONS(3185),
    [anon_sym_write] = ACTIONS(3185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3185),
    [anon_sym___END__] = ACTIONS(3185),
    [anon_sym_EOT] = ACTIONS(3185),
    [anon_sym_q] = ACTIONS(3185),
    [anon_sym_qq] = ACTIONS(3185),
    [anon_sym_qw] = ACTIONS(3185),
    [anon_sym_qx] = ACTIONS(3185),
    [anon_sym_qr] = ACTIONS(3185),
    [anon_sym_m] = ACTIONS(3185),
    [anon_sym_s] = ACTIONS(3185),
    [anon_sym_tr] = ACTIONS(3185),
    [anon_sym_y] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3185),
    [anon_sym_unless] = ACTIONS(3185),
    [anon_sym_while] = ACTIONS(3185),
    [anon_sym_until] = ACTIONS(3185),
    [aux_sym__bareword_token1] = ACTIONS(3185),
    [sym_number] = ACTIONS(3185),
    [sym__apostrophe] = ACTIONS(3183),
    [sym__double_quote] = ACTIONS(3183),
    [sym__backtick] = ACTIONS(3183),
    [sym__search_slash] = ACTIONS(3183),
    [sym__PERLY_HEREDOC] = ACTIONS(3183),
    [sym__ctrl_z_hack] = ACTIONS(3183),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1013] = {
    [sym_heredoc_content] = STATE(1013),
    [ts_builtin_sym_end] = ACTIONS(3187),
    [sym__identifier] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_LBRACE2] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_package] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_sub] = ACTIONS(3189),
    [anon_sym_method] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_my] = ACTIONS(3189),
    [anon_sym_state] = ACTIONS(3189),
    [anon_sym_our] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_defer] = ACTIONS(3189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_elsif] = ACTIONS(3189),
    [anon_sym_and] = ACTIONS(3189),
    [anon_sym_or] = ACTIONS(3189),
    [anon_sym_DOLLAR] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3189),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_LT_LT] = ACTIONS(3189),
    [anon_sym_SLASH_SLASH] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3189),
    [anon_sym_eq] = ACTIONS(3189),
    [anon_sym_ne] = ACTIONS(3189),
    [anon_sym_cmp] = ACTIONS(3189),
    [anon_sym_lt] = ACTIONS(3189),
    [anon_sym_le] = ACTIONS(3189),
    [anon_sym_ge] = ACTIONS(3189),
    [anon_sym_gt] = ACTIONS(3189),
    [anon_sym_isa] = ACTIONS(3189),
    [anon_sym_TILDE] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3189),
    [anon_sym_PLUS_PLUS] = ACTIONS(3189),
    [anon_sym_DASH_DASH] = ACTIONS(3189),
    [anon_sym_BSLASH] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_eval] = ACTIONS(3189),
    [anon_sym_field] = ACTIONS(3189),
    [anon_sym_local] = ACTIONS(3189),
    [anon_sym_require] = ACTIONS(3189),
    [anon_sym_map] = ACTIONS(3189),
    [anon_sym_grep] = ACTIONS(3189),
    [anon_sym_sort] = ACTIONS(3189),
    [anon_sym_goto] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_undef] = ACTIONS(3189),
    [anon_sym_PERCENT2] = ACTIONS(3189),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3189),
    [anon_sym_use] = ACTIONS(3189),
    [anon_sym_no] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_foreach] = ACTIONS(3189),
    [anon_sym_last] = ACTIONS(3189),
    [anon_sym_next] = ACTIONS(3189),
    [anon_sym_redo] = ACTIONS(3189),
    [anon_sym_BEGIN] = ACTIONS(3189),
    [anon_sym_INIT] = ACTIONS(3189),
    [anon_sym_CHECK] = ACTIONS(3189),
    [anon_sym_UNITCHECK] = ACTIONS(3189),
    [anon_sym_END] = ACTIONS(3189),
    [anon_sym_ADJUST] = ACTIONS(3189),
    [anon_sym___FILE__] = ACTIONS(3189),
    [anon_sym___LINE__] = ACTIONS(3189),
    [anon_sym___PACKAGE__] = ACTIONS(3189),
    [anon_sym___SUB__] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_fork] = ACTIONS(3189),
    [anon_sym_getppid] = ACTIONS(3189),
    [anon_sym_time] = ACTIONS(3189),
    [anon_sym_times] = ACTIONS(3189),
    [anon_sym_wait] = ACTIONS(3189),
    [anon_sym_wantarray] = ACTIONS(3189),
    [anon_sym_abs] = ACTIONS(3189),
    [anon_sym_alarm] = ACTIONS(3189),
    [anon_sym_chop] = ACTIONS(3189),
    [anon_sym_chdir] = ACTIONS(3189),
    [anon_sym_close] = ACTIONS(3189),
    [anon_sym_closedir] = ACTIONS(3189),
    [anon_sym_caller] = ACTIONS(3189),
    [anon_sym_chomp] = ACTIONS(3189),
    [anon_sym_chr] = ACTIONS(3189),
    [anon_sym_cos] = ACTIONS(3189),
    [anon_sym_chroot] = ACTIONS(3189),
    [anon_sym_defined] = ACTIONS(3189),
    [anon_sym_delete] = ACTIONS(3189),
    [anon_sym_dbmclose] = ACTIONS(3189),
    [anon_sym_exists] = ACTIONS(3189),
    [anon_sym_exit] = ACTIONS(3189),
    [anon_sym_eof] = ACTIONS(3189),
    [anon_sym_exp] = ACTIONS(3189),
    [anon_sym_each] = ACTIONS(3189),
    [anon_sym_fc] = ACTIONS(3189),
    [anon_sym_fileno] = ACTIONS(3189),
    [anon_sym_gmtime] = ACTIONS(3189),
    [anon_sym_getc] = ACTIONS(3189),
    [anon_sym_getpgrp] = ACTIONS(3189),
    [anon_sym_getprotobyname] = ACTIONS(3189),
    [anon_sym_getpwname] = ACTIONS(3189),
    [anon_sym_getpwuid] = ACTIONS(3189),
    [anon_sym_getpeername] = ACTIONS(3189),
    [anon_sym_getnetbyname] = ACTIONS(3189),
    [anon_sym_getsockname] = ACTIONS(3189),
    [anon_sym_getgrnam] = ACTIONS(3189),
    [anon_sym_getgrgid] = ACTIONS(3189),
    [anon_sym_hex] = ACTIONS(3189),
    [anon_sym_int] = ACTIONS(3189),
    [anon_sym_keys] = ACTIONS(3189),
    [anon_sym_lc] = ACTIONS(3189),
    [anon_sym_lcfirst] = ACTIONS(3189),
    [anon_sym_length] = ACTIONS(3189),
    [anon_sym_localtime] = ACTIONS(3189),
    [anon_sym_log] = ACTIONS(3189),
    [anon_sym_lock] = ACTIONS(3189),
    [anon_sym_lstat] = ACTIONS(3189),
    [anon_sym_oct] = ACTIONS(3189),
    [anon_sym_ord] = ACTIONS(3189),
    [anon_sym_prototype] = ACTIONS(3189),
    [anon_sym_pop] = ACTIONS(3189),
    [anon_sym_pos] = ACTIONS(3189),
    [anon_sym_quotemeta] = ACTIONS(3189),
    [anon_sym_reset] = ACTIONS(3189),
    [anon_sym_rand] = ACTIONS(3189),
    [anon_sym_rmdir] = ACTIONS(3189),
    [anon_sym_readdir] = ACTIONS(3189),
    [anon_sym_readline] = ACTIONS(3189),
    [anon_sym_readpipe] = ACTIONS(3189),
    [anon_sym_rewinddir] = ACTIONS(3189),
    [anon_sym_readlink] = ACTIONS(3189),
    [anon_sym_ref] = ACTIONS(3189),
    [anon_sym_scalar] = ACTIONS(3189),
    [anon_sym_shift] = ACTIONS(3189),
    [anon_sym_sin] = ACTIONS(3189),
    [anon_sym_sleep] = ACTIONS(3189),
    [anon_sym_sqrt] = ACTIONS(3189),
    [anon_sym_srand] = ACTIONS(3189),
    [anon_sym_stat] = ACTIONS(3189),
    [anon_sym_study] = ACTIONS(3189),
    [anon_sym_tell] = ACTIONS(3189),
    [anon_sym_telldir] = ACTIONS(3189),
    [anon_sym_tied] = ACTIONS(3189),
    [anon_sym_uc] = ACTIONS(3189),
    [anon_sym_ucfirst] = ACTIONS(3189),
    [anon_sym_untie] = ACTIONS(3189),
    [anon_sym_umask] = ACTIONS(3189),
    [anon_sym_values] = ACTIONS(3189),
    [anon_sym_write] = ACTIONS(3189),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3189),
    [anon_sym___END__] = ACTIONS(3189),
    [anon_sym_EOT] = ACTIONS(3189),
    [anon_sym_q] = ACTIONS(3189),
    [anon_sym_qq] = ACTIONS(3189),
    [anon_sym_qw] = ACTIONS(3189),
    [anon_sym_qx] = ACTIONS(3189),
    [anon_sym_qr] = ACTIONS(3189),
    [anon_sym_m] = ACTIONS(3189),
    [anon_sym_s] = ACTIONS(3189),
    [anon_sym_tr] = ACTIONS(3189),
    [anon_sym_y] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_until] = ACTIONS(3189),
    [aux_sym__bareword_token1] = ACTIONS(3189),
    [sym_number] = ACTIONS(3189),
    [sym__apostrophe] = ACTIONS(3187),
    [sym__double_quote] = ACTIONS(3187),
    [sym__backtick] = ACTIONS(3187),
    [sym__search_slash] = ACTIONS(3187),
    [sym__PERLY_HEREDOC] = ACTIONS(3187),
    [sym__ctrl_z_hack] = ACTIONS(3187),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1014] = {
    [sym_heredoc_content] = STATE(1014),
    [ts_builtin_sym_end] = ACTIONS(3194),
    [sym__identifier] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3196),
    [anon_sym_LBRACE2] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3196),
    [anon_sym_package] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_sub] = ACTIONS(3196),
    [anon_sym_method] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_my] = ACTIONS(3196),
    [anon_sym_state] = ACTIONS(3196),
    [anon_sym_our] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_defer] = ACTIONS(3196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_elsif] = ACTIONS(3196),
    [anon_sym_and] = ACTIONS(3196),
    [anon_sym_or] = ACTIONS(3196),
    [anon_sym_DOLLAR] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_AT] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3196),
    [anon_sym_LT_LT] = ACTIONS(3196),
    [anon_sym_SLASH_SLASH] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_eq] = ACTIONS(3196),
    [anon_sym_ne] = ACTIONS(3196),
    [anon_sym_cmp] = ACTIONS(3196),
    [anon_sym_lt] = ACTIONS(3196),
    [anon_sym_le] = ACTIONS(3196),
    [anon_sym_ge] = ACTIONS(3196),
    [anon_sym_gt] = ACTIONS(3196),
    [anon_sym_isa] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_PLUS_PLUS] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3196),
    [anon_sym_BSLASH] = ACTIONS(3194),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_eval] = ACTIONS(3196),
    [anon_sym_field] = ACTIONS(3196),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_require] = ACTIONS(3196),
    [anon_sym_map] = ACTIONS(3196),
    [anon_sym_grep] = ACTIONS(3196),
    [anon_sym_sort] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_undef] = ACTIONS(3196),
    [anon_sym_PERCENT2] = ACTIONS(3196),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3196),
    [anon_sym_use] = ACTIONS(3196),
    [anon_sym_no] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_foreach] = ACTIONS(3196),
    [anon_sym_last] = ACTIONS(3196),
    [anon_sym_next] = ACTIONS(3196),
    [anon_sym_redo] = ACTIONS(3196),
    [anon_sym_BEGIN] = ACTIONS(3196),
    [anon_sym_INIT] = ACTIONS(3196),
    [anon_sym_CHECK] = ACTIONS(3196),
    [anon_sym_UNITCHECK] = ACTIONS(3196),
    [anon_sym_END] = ACTIONS(3196),
    [anon_sym_ADJUST] = ACTIONS(3196),
    [anon_sym___FILE__] = ACTIONS(3196),
    [anon_sym___LINE__] = ACTIONS(3196),
    [anon_sym___PACKAGE__] = ACTIONS(3196),
    [anon_sym___SUB__] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_fork] = ACTIONS(3196),
    [anon_sym_getppid] = ACTIONS(3196),
    [anon_sym_time] = ACTIONS(3196),
    [anon_sym_times] = ACTIONS(3196),
    [anon_sym_wait] = ACTIONS(3196),
    [anon_sym_wantarray] = ACTIONS(3196),
    [anon_sym_abs] = ACTIONS(3196),
    [anon_sym_alarm] = ACTIONS(3196),
    [anon_sym_chop] = ACTIONS(3196),
    [anon_sym_chdir] = ACTIONS(3196),
    [anon_sym_close] = ACTIONS(3196),
    [anon_sym_closedir] = ACTIONS(3196),
    [anon_sym_caller] = ACTIONS(3196),
    [anon_sym_chomp] = ACTIONS(3196),
    [anon_sym_chr] = ACTIONS(3196),
    [anon_sym_cos] = ACTIONS(3196),
    [anon_sym_chroot] = ACTIONS(3196),
    [anon_sym_defined] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_dbmclose] = ACTIONS(3196),
    [anon_sym_exists] = ACTIONS(3196),
    [anon_sym_exit] = ACTIONS(3196),
    [anon_sym_eof] = ACTIONS(3196),
    [anon_sym_exp] = ACTIONS(3196),
    [anon_sym_each] = ACTIONS(3196),
    [anon_sym_fc] = ACTIONS(3196),
    [anon_sym_fileno] = ACTIONS(3196),
    [anon_sym_gmtime] = ACTIONS(3196),
    [anon_sym_getc] = ACTIONS(3196),
    [anon_sym_getpgrp] = ACTIONS(3196),
    [anon_sym_getprotobyname] = ACTIONS(3196),
    [anon_sym_getpwname] = ACTIONS(3196),
    [anon_sym_getpwuid] = ACTIONS(3196),
    [anon_sym_getpeername] = ACTIONS(3196),
    [anon_sym_getnetbyname] = ACTIONS(3196),
    [anon_sym_getsockname] = ACTIONS(3196),
    [anon_sym_getgrnam] = ACTIONS(3196),
    [anon_sym_getgrgid] = ACTIONS(3196),
    [anon_sym_hex] = ACTIONS(3196),
    [anon_sym_int] = ACTIONS(3196),
    [anon_sym_keys] = ACTIONS(3196),
    [anon_sym_lc] = ACTIONS(3196),
    [anon_sym_lcfirst] = ACTIONS(3196),
    [anon_sym_length] = ACTIONS(3196),
    [anon_sym_localtime] = ACTIONS(3196),
    [anon_sym_log] = ACTIONS(3196),
    [anon_sym_lock] = ACTIONS(3196),
    [anon_sym_lstat] = ACTIONS(3196),
    [anon_sym_oct] = ACTIONS(3196),
    [anon_sym_ord] = ACTIONS(3196),
    [anon_sym_prototype] = ACTIONS(3196),
    [anon_sym_pop] = ACTIONS(3196),
    [anon_sym_pos] = ACTIONS(3196),
    [anon_sym_quotemeta] = ACTIONS(3196),
    [anon_sym_reset] = ACTIONS(3196),
    [anon_sym_rand] = ACTIONS(3196),
    [anon_sym_rmdir] = ACTIONS(3196),
    [anon_sym_readdir] = ACTIONS(3196),
    [anon_sym_readline] = ACTIONS(3196),
    [anon_sym_readpipe] = ACTIONS(3196),
    [anon_sym_rewinddir] = ACTIONS(3196),
    [anon_sym_readlink] = ACTIONS(3196),
    [anon_sym_ref] = ACTIONS(3196),
    [anon_sym_scalar] = ACTIONS(3196),
    [anon_sym_shift] = ACTIONS(3196),
    [anon_sym_sin] = ACTIONS(3196),
    [anon_sym_sleep] = ACTIONS(3196),
    [anon_sym_sqrt] = ACTIONS(3196),
    [anon_sym_srand] = ACTIONS(3196),
    [anon_sym_stat] = ACTIONS(3196),
    [anon_sym_study] = ACTIONS(3196),
    [anon_sym_tell] = ACTIONS(3196),
    [anon_sym_telldir] = ACTIONS(3196),
    [anon_sym_tied] = ACTIONS(3196),
    [anon_sym_uc] = ACTIONS(3196),
    [anon_sym_ucfirst] = ACTIONS(3196),
    [anon_sym_untie] = ACTIONS(3196),
    [anon_sym_umask] = ACTIONS(3196),
    [anon_sym_values] = ACTIONS(3196),
    [anon_sym_write] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3196),
    [anon_sym___END__] = ACTIONS(3196),
    [anon_sym_EOT] = ACTIONS(3196),
    [anon_sym_q] = ACTIONS(3196),
    [anon_sym_qq] = ACTIONS(3196),
    [anon_sym_qw] = ACTIONS(3196),
    [anon_sym_qx] = ACTIONS(3196),
    [anon_sym_qr] = ACTIONS(3196),
    [anon_sym_m] = ACTIONS(3196),
    [anon_sym_s] = ACTIONS(3196),
    [anon_sym_tr] = ACTIONS(3196),
    [anon_sym_y] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_unless] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_until] = ACTIONS(3196),
    [aux_sym__bareword_token1] = ACTIONS(3196),
    [sym_number] = ACTIONS(3196),
    [sym__apostrophe] = ACTIONS(3194),
    [sym__double_quote] = ACTIONS(3194),
    [sym__backtick] = ACTIONS(3194),
    [sym__search_slash] = ACTIONS(3194),
    [sym__PERLY_HEREDOC] = ACTIONS(3194),
    [sym__ctrl_z_hack] = ACTIONS(3194),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1015] = {
    [sym_heredoc_content] = STATE(1015),
    [ts_builtin_sym_end] = ACTIONS(3198),
    [sym__identifier] = ACTIONS(3200),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_LBRACE2] = ACTIONS(3200),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym_package] = ACTIONS(3200),
    [anon_sym_class] = ACTIONS(3200),
    [anon_sym_sub] = ACTIONS(3200),
    [anon_sym_method] = ACTIONS(3200),
    [anon_sym_LPAREN] = ACTIONS(3200),
    [anon_sym_continue] = ACTIONS(3200),
    [anon_sym_my] = ACTIONS(3200),
    [anon_sym_state] = ACTIONS(3200),
    [anon_sym_our] = ACTIONS(3200),
    [anon_sym_try] = ACTIONS(3200),
    [anon_sym_defer] = ACTIONS(3200),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3200),
    [anon_sym_else] = ACTIONS(3200),
    [anon_sym_elsif] = ACTIONS(3200),
    [anon_sym_and] = ACTIONS(3200),
    [anon_sym_or] = ACTIONS(3200),
    [anon_sym_DOLLAR] = ACTIONS(3200),
    [anon_sym_LBRACK] = ACTIONS(3200),
    [anon_sym_AT] = ACTIONS(3200),
    [anon_sym_LT] = ACTIONS(3200),
    [anon_sym_LT_LT] = ACTIONS(3200),
    [anon_sym_SLASH_SLASH] = ACTIONS(3200),
    [anon_sym_PLUS] = ACTIONS(3200),
    [anon_sym_DASH] = ACTIONS(3200),
    [anon_sym_STAR] = ACTIONS(3200),
    [anon_sym_eq] = ACTIONS(3200),
    [anon_sym_ne] = ACTIONS(3200),
    [anon_sym_cmp] = ACTIONS(3200),
    [anon_sym_lt] = ACTIONS(3200),
    [anon_sym_le] = ACTIONS(3200),
    [anon_sym_ge] = ACTIONS(3200),
    [anon_sym_gt] = ACTIONS(3200),
    [anon_sym_isa] = ACTIONS(3200),
    [anon_sym_TILDE] = ACTIONS(3200),
    [anon_sym_BANG] = ACTIONS(3200),
    [anon_sym_PLUS_PLUS] = ACTIONS(3200),
    [anon_sym_DASH_DASH] = ACTIONS(3200),
    [anon_sym_BSLASH] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3200),
    [anon_sym_eval] = ACTIONS(3200),
    [anon_sym_field] = ACTIONS(3200),
    [anon_sym_local] = ACTIONS(3200),
    [anon_sym_require] = ACTIONS(3200),
    [anon_sym_map] = ACTIONS(3200),
    [anon_sym_grep] = ACTIONS(3200),
    [anon_sym_sort] = ACTIONS(3200),
    [anon_sym_goto] = ACTIONS(3200),
    [anon_sym_return] = ACTIONS(3200),
    [anon_sym_undef] = ACTIONS(3200),
    [anon_sym_PERCENT2] = ACTIONS(3200),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3200),
    [anon_sym_use] = ACTIONS(3200),
    [anon_sym_no] = ACTIONS(3200),
    [anon_sym_for] = ACTIONS(3200),
    [anon_sym_foreach] = ACTIONS(3200),
    [anon_sym_last] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3200),
    [anon_sym_redo] = ACTIONS(3200),
    [anon_sym_BEGIN] = ACTIONS(3200),
    [anon_sym_INIT] = ACTIONS(3200),
    [anon_sym_CHECK] = ACTIONS(3200),
    [anon_sym_UNITCHECK] = ACTIONS(3200),
    [anon_sym_END] = ACTIONS(3200),
    [anon_sym_ADJUST] = ACTIONS(3200),
    [anon_sym___FILE__] = ACTIONS(3200),
    [anon_sym___LINE__] = ACTIONS(3200),
    [anon_sym___PACKAGE__] = ACTIONS(3200),
    [anon_sym___SUB__] = ACTIONS(3200),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_fork] = ACTIONS(3200),
    [anon_sym_getppid] = ACTIONS(3200),
    [anon_sym_time] = ACTIONS(3200),
    [anon_sym_times] = ACTIONS(3200),
    [anon_sym_wait] = ACTIONS(3200),
    [anon_sym_wantarray] = ACTIONS(3200),
    [anon_sym_abs] = ACTIONS(3200),
    [anon_sym_alarm] = ACTIONS(3200),
    [anon_sym_chop] = ACTIONS(3200),
    [anon_sym_chdir] = ACTIONS(3200),
    [anon_sym_close] = ACTIONS(3200),
    [anon_sym_closedir] = ACTIONS(3200),
    [anon_sym_caller] = ACTIONS(3200),
    [anon_sym_chomp] = ACTIONS(3200),
    [anon_sym_chr] = ACTIONS(3200),
    [anon_sym_cos] = ACTIONS(3200),
    [anon_sym_chroot] = ACTIONS(3200),
    [anon_sym_defined] = ACTIONS(3200),
    [anon_sym_delete] = ACTIONS(3200),
    [anon_sym_dbmclose] = ACTIONS(3200),
    [anon_sym_exists] = ACTIONS(3200),
    [anon_sym_exit] = ACTIONS(3200),
    [anon_sym_eof] = ACTIONS(3200),
    [anon_sym_exp] = ACTIONS(3200),
    [anon_sym_each] = ACTIONS(3200),
    [anon_sym_fc] = ACTIONS(3200),
    [anon_sym_fileno] = ACTIONS(3200),
    [anon_sym_gmtime] = ACTIONS(3200),
    [anon_sym_getc] = ACTIONS(3200),
    [anon_sym_getpgrp] = ACTIONS(3200),
    [anon_sym_getprotobyname] = ACTIONS(3200),
    [anon_sym_getpwname] = ACTIONS(3200),
    [anon_sym_getpwuid] = ACTIONS(3200),
    [anon_sym_getpeername] = ACTIONS(3200),
    [anon_sym_getnetbyname] = ACTIONS(3200),
    [anon_sym_getsockname] = ACTIONS(3200),
    [anon_sym_getgrnam] = ACTIONS(3200),
    [anon_sym_getgrgid] = ACTIONS(3200),
    [anon_sym_hex] = ACTIONS(3200),
    [anon_sym_int] = ACTIONS(3200),
    [anon_sym_keys] = ACTIONS(3200),
    [anon_sym_lc] = ACTIONS(3200),
    [anon_sym_lcfirst] = ACTIONS(3200),
    [anon_sym_length] = ACTIONS(3200),
    [anon_sym_localtime] = ACTIONS(3200),
    [anon_sym_log] = ACTIONS(3200),
    [anon_sym_lock] = ACTIONS(3200),
    [anon_sym_lstat] = ACTIONS(3200),
    [anon_sym_oct] = ACTIONS(3200),
    [anon_sym_ord] = ACTIONS(3200),
    [anon_sym_prototype] = ACTIONS(3200),
    [anon_sym_pop] = ACTIONS(3200),
    [anon_sym_pos] = ACTIONS(3200),
    [anon_sym_quotemeta] = ACTIONS(3200),
    [anon_sym_reset] = ACTIONS(3200),
    [anon_sym_rand] = ACTIONS(3200),
    [anon_sym_rmdir] = ACTIONS(3200),
    [anon_sym_readdir] = ACTIONS(3200),
    [anon_sym_readline] = ACTIONS(3200),
    [anon_sym_readpipe] = ACTIONS(3200),
    [anon_sym_rewinddir] = ACTIONS(3200),
    [anon_sym_readlink] = ACTIONS(3200),
    [anon_sym_ref] = ACTIONS(3200),
    [anon_sym_scalar] = ACTIONS(3200),
    [anon_sym_shift] = ACTIONS(3200),
    [anon_sym_sin] = ACTIONS(3200),
    [anon_sym_sleep] = ACTIONS(3200),
    [anon_sym_sqrt] = ACTIONS(3200),
    [anon_sym_srand] = ACTIONS(3200),
    [anon_sym_stat] = ACTIONS(3200),
    [anon_sym_study] = ACTIONS(3200),
    [anon_sym_tell] = ACTIONS(3200),
    [anon_sym_telldir] = ACTIONS(3200),
    [anon_sym_tied] = ACTIONS(3200),
    [anon_sym_uc] = ACTIONS(3200),
    [anon_sym_ucfirst] = ACTIONS(3200),
    [anon_sym_untie] = ACTIONS(3200),
    [anon_sym_umask] = ACTIONS(3200),
    [anon_sym_values] = ACTIONS(3200),
    [anon_sym_write] = ACTIONS(3200),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3200),
    [anon_sym___END__] = ACTIONS(3200),
    [anon_sym_EOT] = ACTIONS(3200),
    [anon_sym_q] = ACTIONS(3200),
    [anon_sym_qq] = ACTIONS(3200),
    [anon_sym_qw] = ACTIONS(3200),
    [anon_sym_qx] = ACTIONS(3200),
    [anon_sym_qr] = ACTIONS(3200),
    [anon_sym_m] = ACTIONS(3200),
    [anon_sym_s] = ACTIONS(3200),
    [anon_sym_tr] = ACTIONS(3200),
    [anon_sym_y] = ACTIONS(3200),
    [anon_sym_if] = ACTIONS(3200),
    [anon_sym_unless] = ACTIONS(3200),
    [anon_sym_while] = ACTIONS(3200),
    [anon_sym_until] = ACTIONS(3200),
    [aux_sym__bareword_token1] = ACTIONS(3200),
    [sym_number] = ACTIONS(3200),
    [sym__apostrophe] = ACTIONS(3198),
    [sym__double_quote] = ACTIONS(3198),
    [sym__backtick] = ACTIONS(3198),
    [sym__search_slash] = ACTIONS(3198),
    [sym__PERLY_HEREDOC] = ACTIONS(3198),
    [sym__ctrl_z_hack] = ACTIONS(3198),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1016] = {
    [sym_heredoc_content] = STATE(1016),
    [ts_builtin_sym_end] = ACTIONS(3202),
    [sym__identifier] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LBRACE2] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_package] = ACTIONS(3204),
    [anon_sym_class] = ACTIONS(3204),
    [anon_sym_sub] = ACTIONS(3204),
    [anon_sym_method] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3204),
    [anon_sym_continue] = ACTIONS(3204),
    [anon_sym_my] = ACTIONS(3204),
    [anon_sym_state] = ACTIONS(3204),
    [anon_sym_our] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3204),
    [anon_sym_defer] = ACTIONS(3204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_elsif] = ACTIONS(3204),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_LT_LT] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_eq] = ACTIONS(3204),
    [anon_sym_ne] = ACTIONS(3204),
    [anon_sym_cmp] = ACTIONS(3204),
    [anon_sym_lt] = ACTIONS(3204),
    [anon_sym_le] = ACTIONS(3204),
    [anon_sym_ge] = ACTIONS(3204),
    [anon_sym_gt] = ACTIONS(3204),
    [anon_sym_isa] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [anon_sym_BSLASH] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_eval] = ACTIONS(3204),
    [anon_sym_field] = ACTIONS(3204),
    [anon_sym_local] = ACTIONS(3204),
    [anon_sym_require] = ACTIONS(3204),
    [anon_sym_map] = ACTIONS(3204),
    [anon_sym_grep] = ACTIONS(3204),
    [anon_sym_sort] = ACTIONS(3204),
    [anon_sym_goto] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3204),
    [anon_sym_undef] = ACTIONS(3204),
    [anon_sym_PERCENT2] = ACTIONS(3204),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3204),
    [anon_sym_no] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3204),
    [anon_sym_foreach] = ACTIONS(3204),
    [anon_sym_last] = ACTIONS(3204),
    [anon_sym_next] = ACTIONS(3204),
    [anon_sym_redo] = ACTIONS(3204),
    [anon_sym_BEGIN] = ACTIONS(3204),
    [anon_sym_INIT] = ACTIONS(3204),
    [anon_sym_CHECK] = ACTIONS(3204),
    [anon_sym_UNITCHECK] = ACTIONS(3204),
    [anon_sym_END] = ACTIONS(3204),
    [anon_sym_ADJUST] = ACTIONS(3204),
    [anon_sym___FILE__] = ACTIONS(3204),
    [anon_sym___LINE__] = ACTIONS(3204),
    [anon_sym___PACKAGE__] = ACTIONS(3204),
    [anon_sym___SUB__] = ACTIONS(3204),
    [anon_sym_break] = ACTIONS(3204),
    [anon_sym_fork] = ACTIONS(3204),
    [anon_sym_getppid] = ACTIONS(3204),
    [anon_sym_time] = ACTIONS(3204),
    [anon_sym_times] = ACTIONS(3204),
    [anon_sym_wait] = ACTIONS(3204),
    [anon_sym_wantarray] = ACTIONS(3204),
    [anon_sym_abs] = ACTIONS(3204),
    [anon_sym_alarm] = ACTIONS(3204),
    [anon_sym_chop] = ACTIONS(3204),
    [anon_sym_chdir] = ACTIONS(3204),
    [anon_sym_close] = ACTIONS(3204),
    [anon_sym_closedir] = ACTIONS(3204),
    [anon_sym_caller] = ACTIONS(3204),
    [anon_sym_chomp] = ACTIONS(3204),
    [anon_sym_chr] = ACTIONS(3204),
    [anon_sym_cos] = ACTIONS(3204),
    [anon_sym_chroot] = ACTIONS(3204),
    [anon_sym_defined] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3204),
    [anon_sym_dbmclose] = ACTIONS(3204),
    [anon_sym_exists] = ACTIONS(3204),
    [anon_sym_exit] = ACTIONS(3204),
    [anon_sym_eof] = ACTIONS(3204),
    [anon_sym_exp] = ACTIONS(3204),
    [anon_sym_each] = ACTIONS(3204),
    [anon_sym_fc] = ACTIONS(3204),
    [anon_sym_fileno] = ACTIONS(3204),
    [anon_sym_gmtime] = ACTIONS(3204),
    [anon_sym_getc] = ACTIONS(3204),
    [anon_sym_getpgrp] = ACTIONS(3204),
    [anon_sym_getprotobyname] = ACTIONS(3204),
    [anon_sym_getpwname] = ACTIONS(3204),
    [anon_sym_getpwuid] = ACTIONS(3204),
    [anon_sym_getpeername] = ACTIONS(3204),
    [anon_sym_getnetbyname] = ACTIONS(3204),
    [anon_sym_getsockname] = ACTIONS(3204),
    [anon_sym_getgrnam] = ACTIONS(3204),
    [anon_sym_getgrgid] = ACTIONS(3204),
    [anon_sym_hex] = ACTIONS(3204),
    [anon_sym_int] = ACTIONS(3204),
    [anon_sym_keys] = ACTIONS(3204),
    [anon_sym_lc] = ACTIONS(3204),
    [anon_sym_lcfirst] = ACTIONS(3204),
    [anon_sym_length] = ACTIONS(3204),
    [anon_sym_localtime] = ACTIONS(3204),
    [anon_sym_log] = ACTIONS(3204),
    [anon_sym_lock] = ACTIONS(3204),
    [anon_sym_lstat] = ACTIONS(3204),
    [anon_sym_oct] = ACTIONS(3204),
    [anon_sym_ord] = ACTIONS(3204),
    [anon_sym_prototype] = ACTIONS(3204),
    [anon_sym_pop] = ACTIONS(3204),
    [anon_sym_pos] = ACTIONS(3204),
    [anon_sym_quotemeta] = ACTIONS(3204),
    [anon_sym_reset] = ACTIONS(3204),
    [anon_sym_rand] = ACTIONS(3204),
    [anon_sym_rmdir] = ACTIONS(3204),
    [anon_sym_readdir] = ACTIONS(3204),
    [anon_sym_readline] = ACTIONS(3204),
    [anon_sym_readpipe] = ACTIONS(3204),
    [anon_sym_rewinddir] = ACTIONS(3204),
    [anon_sym_readlink] = ACTIONS(3204),
    [anon_sym_ref] = ACTIONS(3204),
    [anon_sym_scalar] = ACTIONS(3204),
    [anon_sym_shift] = ACTIONS(3204),
    [anon_sym_sin] = ACTIONS(3204),
    [anon_sym_sleep] = ACTIONS(3204),
    [anon_sym_sqrt] = ACTIONS(3204),
    [anon_sym_srand] = ACTIONS(3204),
    [anon_sym_stat] = ACTIONS(3204),
    [anon_sym_study] = ACTIONS(3204),
    [anon_sym_tell] = ACTIONS(3204),
    [anon_sym_telldir] = ACTIONS(3204),
    [anon_sym_tied] = ACTIONS(3204),
    [anon_sym_uc] = ACTIONS(3204),
    [anon_sym_ucfirst] = ACTIONS(3204),
    [anon_sym_untie] = ACTIONS(3204),
    [anon_sym_umask] = ACTIONS(3204),
    [anon_sym_values] = ACTIONS(3204),
    [anon_sym_write] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3204),
    [anon_sym___END__] = ACTIONS(3204),
    [anon_sym_EOT] = ACTIONS(3204),
    [anon_sym_q] = ACTIONS(3204),
    [anon_sym_qq] = ACTIONS(3204),
    [anon_sym_qw] = ACTIONS(3204),
    [anon_sym_qx] = ACTIONS(3204),
    [anon_sym_qr] = ACTIONS(3204),
    [anon_sym_m] = ACTIONS(3204),
    [anon_sym_s] = ACTIONS(3204),
    [anon_sym_tr] = ACTIONS(3204),
    [anon_sym_y] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [aux_sym__bareword_token1] = ACTIONS(3204),
    [sym_number] = ACTIONS(3204),
    [sym__apostrophe] = ACTIONS(3202),
    [sym__double_quote] = ACTIONS(3202),
    [sym__backtick] = ACTIONS(3202),
    [sym__search_slash] = ACTIONS(3202),
    [sym__PERLY_HEREDOC] = ACTIONS(3202),
    [sym__ctrl_z_hack] = ACTIONS(3202),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1017] = {
    [sym_heredoc_content] = STATE(1017),
    [ts_builtin_sym_end] = ACTIONS(3206),
    [sym__identifier] = ACTIONS(3208),
    [anon_sym_LBRACE] = ACTIONS(3208),
    [anon_sym_LBRACE2] = ACTIONS(3208),
    [anon_sym_SEMI] = ACTIONS(3208),
    [anon_sym_package] = ACTIONS(3208),
    [anon_sym_class] = ACTIONS(3208),
    [anon_sym_sub] = ACTIONS(3208),
    [anon_sym_method] = ACTIONS(3208),
    [anon_sym_LPAREN] = ACTIONS(3208),
    [anon_sym_continue] = ACTIONS(3208),
    [anon_sym_my] = ACTIONS(3208),
    [anon_sym_state] = ACTIONS(3208),
    [anon_sym_our] = ACTIONS(3208),
    [anon_sym_try] = ACTIONS(3208),
    [anon_sym_defer] = ACTIONS(3208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3208),
    [anon_sym_else] = ACTIONS(3208),
    [anon_sym_elsif] = ACTIONS(3208),
    [anon_sym_and] = ACTIONS(3208),
    [anon_sym_or] = ACTIONS(3208),
    [anon_sym_DOLLAR] = ACTIONS(3208),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_AT] = ACTIONS(3208),
    [anon_sym_LT] = ACTIONS(3208),
    [anon_sym_LT_LT] = ACTIONS(3208),
    [anon_sym_SLASH_SLASH] = ACTIONS(3208),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_eq] = ACTIONS(3208),
    [anon_sym_ne] = ACTIONS(3208),
    [anon_sym_cmp] = ACTIONS(3208),
    [anon_sym_lt] = ACTIONS(3208),
    [anon_sym_le] = ACTIONS(3208),
    [anon_sym_ge] = ACTIONS(3208),
    [anon_sym_gt] = ACTIONS(3208),
    [anon_sym_isa] = ACTIONS(3208),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3208),
    [anon_sym_PLUS_PLUS] = ACTIONS(3208),
    [anon_sym_DASH_DASH] = ACTIONS(3208),
    [anon_sym_BSLASH] = ACTIONS(3206),
    [anon_sym_do] = ACTIONS(3208),
    [anon_sym_eval] = ACTIONS(3208),
    [anon_sym_field] = ACTIONS(3208),
    [anon_sym_local] = ACTIONS(3208),
    [anon_sym_require] = ACTIONS(3208),
    [anon_sym_map] = ACTIONS(3208),
    [anon_sym_grep] = ACTIONS(3208),
    [anon_sym_sort] = ACTIONS(3208),
    [anon_sym_goto] = ACTIONS(3208),
    [anon_sym_return] = ACTIONS(3208),
    [anon_sym_undef] = ACTIONS(3208),
    [anon_sym_PERCENT2] = ACTIONS(3208),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3208),
    [anon_sym_use] = ACTIONS(3208),
    [anon_sym_no] = ACTIONS(3208),
    [anon_sym_for] = ACTIONS(3208),
    [anon_sym_foreach] = ACTIONS(3208),
    [anon_sym_last] = ACTIONS(3208),
    [anon_sym_next] = ACTIONS(3208),
    [anon_sym_redo] = ACTIONS(3208),
    [anon_sym_BEGIN] = ACTIONS(3208),
    [anon_sym_INIT] = ACTIONS(3208),
    [anon_sym_CHECK] = ACTIONS(3208),
    [anon_sym_UNITCHECK] = ACTIONS(3208),
    [anon_sym_END] = ACTIONS(3208),
    [anon_sym_ADJUST] = ACTIONS(3208),
    [anon_sym___FILE__] = ACTIONS(3208),
    [anon_sym___LINE__] = ACTIONS(3208),
    [anon_sym___PACKAGE__] = ACTIONS(3208),
    [anon_sym___SUB__] = ACTIONS(3208),
    [anon_sym_break] = ACTIONS(3208),
    [anon_sym_fork] = ACTIONS(3208),
    [anon_sym_getppid] = ACTIONS(3208),
    [anon_sym_time] = ACTIONS(3208),
    [anon_sym_times] = ACTIONS(3208),
    [anon_sym_wait] = ACTIONS(3208),
    [anon_sym_wantarray] = ACTIONS(3208),
    [anon_sym_abs] = ACTIONS(3208),
    [anon_sym_alarm] = ACTIONS(3208),
    [anon_sym_chop] = ACTIONS(3208),
    [anon_sym_chdir] = ACTIONS(3208),
    [anon_sym_close] = ACTIONS(3208),
    [anon_sym_closedir] = ACTIONS(3208),
    [anon_sym_caller] = ACTIONS(3208),
    [anon_sym_chomp] = ACTIONS(3208),
    [anon_sym_chr] = ACTIONS(3208),
    [anon_sym_cos] = ACTIONS(3208),
    [anon_sym_chroot] = ACTIONS(3208),
    [anon_sym_defined] = ACTIONS(3208),
    [anon_sym_delete] = ACTIONS(3208),
    [anon_sym_dbmclose] = ACTIONS(3208),
    [anon_sym_exists] = ACTIONS(3208),
    [anon_sym_exit] = ACTIONS(3208),
    [anon_sym_eof] = ACTIONS(3208),
    [anon_sym_exp] = ACTIONS(3208),
    [anon_sym_each] = ACTIONS(3208),
    [anon_sym_fc] = ACTIONS(3208),
    [anon_sym_fileno] = ACTIONS(3208),
    [anon_sym_gmtime] = ACTIONS(3208),
    [anon_sym_getc] = ACTIONS(3208),
    [anon_sym_getpgrp] = ACTIONS(3208),
    [anon_sym_getprotobyname] = ACTIONS(3208),
    [anon_sym_getpwname] = ACTIONS(3208),
    [anon_sym_getpwuid] = ACTIONS(3208),
    [anon_sym_getpeername] = ACTIONS(3208),
    [anon_sym_getnetbyname] = ACTIONS(3208),
    [anon_sym_getsockname] = ACTIONS(3208),
    [anon_sym_getgrnam] = ACTIONS(3208),
    [anon_sym_getgrgid] = ACTIONS(3208),
    [anon_sym_hex] = ACTIONS(3208),
    [anon_sym_int] = ACTIONS(3208),
    [anon_sym_keys] = ACTIONS(3208),
    [anon_sym_lc] = ACTIONS(3208),
    [anon_sym_lcfirst] = ACTIONS(3208),
    [anon_sym_length] = ACTIONS(3208),
    [anon_sym_localtime] = ACTIONS(3208),
    [anon_sym_log] = ACTIONS(3208),
    [anon_sym_lock] = ACTIONS(3208),
    [anon_sym_lstat] = ACTIONS(3208),
    [anon_sym_oct] = ACTIONS(3208),
    [anon_sym_ord] = ACTIONS(3208),
    [anon_sym_prototype] = ACTIONS(3208),
    [anon_sym_pop] = ACTIONS(3208),
    [anon_sym_pos] = ACTIONS(3208),
    [anon_sym_quotemeta] = ACTIONS(3208),
    [anon_sym_reset] = ACTIONS(3208),
    [anon_sym_rand] = ACTIONS(3208),
    [anon_sym_rmdir] = ACTIONS(3208),
    [anon_sym_readdir] = ACTIONS(3208),
    [anon_sym_readline] = ACTIONS(3208),
    [anon_sym_readpipe] = ACTIONS(3208),
    [anon_sym_rewinddir] = ACTIONS(3208),
    [anon_sym_readlink] = ACTIONS(3208),
    [anon_sym_ref] = ACTIONS(3208),
    [anon_sym_scalar] = ACTIONS(3208),
    [anon_sym_shift] = ACTIONS(3208),
    [anon_sym_sin] = ACTIONS(3208),
    [anon_sym_sleep] = ACTIONS(3208),
    [anon_sym_sqrt] = ACTIONS(3208),
    [anon_sym_srand] = ACTIONS(3208),
    [anon_sym_stat] = ACTIONS(3208),
    [anon_sym_study] = ACTIONS(3208),
    [anon_sym_tell] = ACTIONS(3208),
    [anon_sym_telldir] = ACTIONS(3208),
    [anon_sym_tied] = ACTIONS(3208),
    [anon_sym_uc] = ACTIONS(3208),
    [anon_sym_ucfirst] = ACTIONS(3208),
    [anon_sym_untie] = ACTIONS(3208),
    [anon_sym_umask] = ACTIONS(3208),
    [anon_sym_values] = ACTIONS(3208),
    [anon_sym_write] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3208),
    [anon_sym___END__] = ACTIONS(3208),
    [anon_sym_EOT] = ACTIONS(3208),
    [anon_sym_q] = ACTIONS(3208),
    [anon_sym_qq] = ACTIONS(3208),
    [anon_sym_qw] = ACTIONS(3208),
    [anon_sym_qx] = ACTIONS(3208),
    [anon_sym_qr] = ACTIONS(3208),
    [anon_sym_m] = ACTIONS(3208),
    [anon_sym_s] = ACTIONS(3208),
    [anon_sym_tr] = ACTIONS(3208),
    [anon_sym_y] = ACTIONS(3208),
    [anon_sym_if] = ACTIONS(3208),
    [anon_sym_unless] = ACTIONS(3208),
    [anon_sym_while] = ACTIONS(3208),
    [anon_sym_until] = ACTIONS(3208),
    [aux_sym__bareword_token1] = ACTIONS(3208),
    [sym_number] = ACTIONS(3208),
    [sym__apostrophe] = ACTIONS(3206),
    [sym__double_quote] = ACTIONS(3206),
    [sym__backtick] = ACTIONS(3206),
    [sym__search_slash] = ACTIONS(3206),
    [sym__PERLY_HEREDOC] = ACTIONS(3206),
    [sym__ctrl_z_hack] = ACTIONS(3206),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1018] = {
    [sym_heredoc_content] = STATE(1018),
    [ts_builtin_sym_end] = ACTIONS(3210),
    [sym__identifier] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LBRACE2] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym_package] = ACTIONS(3212),
    [anon_sym_class] = ACTIONS(3212),
    [anon_sym_sub] = ACTIONS(3212),
    [anon_sym_method] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_continue] = ACTIONS(3212),
    [anon_sym_my] = ACTIONS(3212),
    [anon_sym_state] = ACTIONS(3212),
    [anon_sym_our] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_defer] = ACTIONS(3212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3212),
    [anon_sym_else] = ACTIONS(3212),
    [anon_sym_elsif] = ACTIONS(3212),
    [anon_sym_and] = ACTIONS(3212),
    [anon_sym_or] = ACTIONS(3212),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_LT_LT] = ACTIONS(3212),
    [anon_sym_SLASH_SLASH] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_eq] = ACTIONS(3212),
    [anon_sym_ne] = ACTIONS(3212),
    [anon_sym_cmp] = ACTIONS(3212),
    [anon_sym_lt] = ACTIONS(3212),
    [anon_sym_le] = ACTIONS(3212),
    [anon_sym_ge] = ACTIONS(3212),
    [anon_sym_gt] = ACTIONS(3212),
    [anon_sym_isa] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_BSLASH] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_eval] = ACTIONS(3212),
    [anon_sym_field] = ACTIONS(3212),
    [anon_sym_local] = ACTIONS(3212),
    [anon_sym_require] = ACTIONS(3212),
    [anon_sym_map] = ACTIONS(3212),
    [anon_sym_grep] = ACTIONS(3212),
    [anon_sym_sort] = ACTIONS(3212),
    [anon_sym_goto] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_undef] = ACTIONS(3212),
    [anon_sym_PERCENT2] = ACTIONS(3212),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_no] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_foreach] = ACTIONS(3212),
    [anon_sym_last] = ACTIONS(3212),
    [anon_sym_next] = ACTIONS(3212),
    [anon_sym_redo] = ACTIONS(3212),
    [anon_sym_BEGIN] = ACTIONS(3212),
    [anon_sym_INIT] = ACTIONS(3212),
    [anon_sym_CHECK] = ACTIONS(3212),
    [anon_sym_UNITCHECK] = ACTIONS(3212),
    [anon_sym_END] = ACTIONS(3212),
    [anon_sym_ADJUST] = ACTIONS(3212),
    [anon_sym___FILE__] = ACTIONS(3212),
    [anon_sym___LINE__] = ACTIONS(3212),
    [anon_sym___PACKAGE__] = ACTIONS(3212),
    [anon_sym___SUB__] = ACTIONS(3212),
    [anon_sym_break] = ACTIONS(3212),
    [anon_sym_fork] = ACTIONS(3212),
    [anon_sym_getppid] = ACTIONS(3212),
    [anon_sym_time] = ACTIONS(3212),
    [anon_sym_times] = ACTIONS(3212),
    [anon_sym_wait] = ACTIONS(3212),
    [anon_sym_wantarray] = ACTIONS(3212),
    [anon_sym_abs] = ACTIONS(3212),
    [anon_sym_alarm] = ACTIONS(3212),
    [anon_sym_chop] = ACTIONS(3212),
    [anon_sym_chdir] = ACTIONS(3212),
    [anon_sym_close] = ACTIONS(3212),
    [anon_sym_closedir] = ACTIONS(3212),
    [anon_sym_caller] = ACTIONS(3212),
    [anon_sym_chomp] = ACTIONS(3212),
    [anon_sym_chr] = ACTIONS(3212),
    [anon_sym_cos] = ACTIONS(3212),
    [anon_sym_chroot] = ACTIONS(3212),
    [anon_sym_defined] = ACTIONS(3212),
    [anon_sym_delete] = ACTIONS(3212),
    [anon_sym_dbmclose] = ACTIONS(3212),
    [anon_sym_exists] = ACTIONS(3212),
    [anon_sym_exit] = ACTIONS(3212),
    [anon_sym_eof] = ACTIONS(3212),
    [anon_sym_exp] = ACTIONS(3212),
    [anon_sym_each] = ACTIONS(3212),
    [anon_sym_fc] = ACTIONS(3212),
    [anon_sym_fileno] = ACTIONS(3212),
    [anon_sym_gmtime] = ACTIONS(3212),
    [anon_sym_getc] = ACTIONS(3212),
    [anon_sym_getpgrp] = ACTIONS(3212),
    [anon_sym_getprotobyname] = ACTIONS(3212),
    [anon_sym_getpwname] = ACTIONS(3212),
    [anon_sym_getpwuid] = ACTIONS(3212),
    [anon_sym_getpeername] = ACTIONS(3212),
    [anon_sym_getnetbyname] = ACTIONS(3212),
    [anon_sym_getsockname] = ACTIONS(3212),
    [anon_sym_getgrnam] = ACTIONS(3212),
    [anon_sym_getgrgid] = ACTIONS(3212),
    [anon_sym_hex] = ACTIONS(3212),
    [anon_sym_int] = ACTIONS(3212),
    [anon_sym_keys] = ACTIONS(3212),
    [anon_sym_lc] = ACTIONS(3212),
    [anon_sym_lcfirst] = ACTIONS(3212),
    [anon_sym_length] = ACTIONS(3212),
    [anon_sym_localtime] = ACTIONS(3212),
    [anon_sym_log] = ACTIONS(3212),
    [anon_sym_lock] = ACTIONS(3212),
    [anon_sym_lstat] = ACTIONS(3212),
    [anon_sym_oct] = ACTIONS(3212),
    [anon_sym_ord] = ACTIONS(3212),
    [anon_sym_prototype] = ACTIONS(3212),
    [anon_sym_pop] = ACTIONS(3212),
    [anon_sym_pos] = ACTIONS(3212),
    [anon_sym_quotemeta] = ACTIONS(3212),
    [anon_sym_reset] = ACTIONS(3212),
    [anon_sym_rand] = ACTIONS(3212),
    [anon_sym_rmdir] = ACTIONS(3212),
    [anon_sym_readdir] = ACTIONS(3212),
    [anon_sym_readline] = ACTIONS(3212),
    [anon_sym_readpipe] = ACTIONS(3212),
    [anon_sym_rewinddir] = ACTIONS(3212),
    [anon_sym_readlink] = ACTIONS(3212),
    [anon_sym_ref] = ACTIONS(3212),
    [anon_sym_scalar] = ACTIONS(3212),
    [anon_sym_shift] = ACTIONS(3212),
    [anon_sym_sin] = ACTIONS(3212),
    [anon_sym_sleep] = ACTIONS(3212),
    [anon_sym_sqrt] = ACTIONS(3212),
    [anon_sym_srand] = ACTIONS(3212),
    [anon_sym_stat] = ACTIONS(3212),
    [anon_sym_study] = ACTIONS(3212),
    [anon_sym_tell] = ACTIONS(3212),
    [anon_sym_telldir] = ACTIONS(3212),
    [anon_sym_tied] = ACTIONS(3212),
    [anon_sym_uc] = ACTIONS(3212),
    [anon_sym_ucfirst] = ACTIONS(3212),
    [anon_sym_untie] = ACTIONS(3212),
    [anon_sym_umask] = ACTIONS(3212),
    [anon_sym_values] = ACTIONS(3212),
    [anon_sym_write] = ACTIONS(3212),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3212),
    [anon_sym___END__] = ACTIONS(3212),
    [anon_sym_EOT] = ACTIONS(3212),
    [anon_sym_q] = ACTIONS(3212),
    [anon_sym_qq] = ACTIONS(3212),
    [anon_sym_qw] = ACTIONS(3212),
    [anon_sym_qx] = ACTIONS(3212),
    [anon_sym_qr] = ACTIONS(3212),
    [anon_sym_m] = ACTIONS(3212),
    [anon_sym_s] = ACTIONS(3212),
    [anon_sym_tr] = ACTIONS(3212),
    [anon_sym_y] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_unless] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_until] = ACTIONS(3212),
    [aux_sym__bareword_token1] = ACTIONS(3212),
    [sym_number] = ACTIONS(3212),
    [sym__apostrophe] = ACTIONS(3210),
    [sym__double_quote] = ACTIONS(3210),
    [sym__backtick] = ACTIONS(3210),
    [sym__search_slash] = ACTIONS(3210),
    [sym__PERLY_HEREDOC] = ACTIONS(3210),
    [sym__ctrl_z_hack] = ACTIONS(3210),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1019] = {
    [sym_heredoc_content] = STATE(1019),
    [ts_builtin_sym_end] = ACTIONS(3214),
    [sym__identifier] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_LBRACE2] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_package] = ACTIONS(3216),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_sub] = ACTIONS(3216),
    [anon_sym_method] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_continue] = ACTIONS(3216),
    [anon_sym_my] = ACTIONS(3216),
    [anon_sym_state] = ACTIONS(3216),
    [anon_sym_our] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(3216),
    [anon_sym_defer] = ACTIONS(3216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3216),
    [anon_sym_else] = ACTIONS(3216),
    [anon_sym_elsif] = ACTIONS(3216),
    [anon_sym_and] = ACTIONS(3216),
    [anon_sym_or] = ACTIONS(3216),
    [anon_sym_DOLLAR] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_LT_LT] = ACTIONS(3216),
    [anon_sym_SLASH_SLASH] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_eq] = ACTIONS(3216),
    [anon_sym_ne] = ACTIONS(3216),
    [anon_sym_cmp] = ACTIONS(3216),
    [anon_sym_lt] = ACTIONS(3216),
    [anon_sym_le] = ACTIONS(3216),
    [anon_sym_ge] = ACTIONS(3216),
    [anon_sym_gt] = ACTIONS(3216),
    [anon_sym_isa] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_BSLASH] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3216),
    [anon_sym_eval] = ACTIONS(3216),
    [anon_sym_field] = ACTIONS(3216),
    [anon_sym_local] = ACTIONS(3216),
    [anon_sym_require] = ACTIONS(3216),
    [anon_sym_map] = ACTIONS(3216),
    [anon_sym_grep] = ACTIONS(3216),
    [anon_sym_sort] = ACTIONS(3216),
    [anon_sym_goto] = ACTIONS(3216),
    [anon_sym_return] = ACTIONS(3216),
    [anon_sym_undef] = ACTIONS(3216),
    [anon_sym_PERCENT2] = ACTIONS(3216),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3216),
    [anon_sym_use] = ACTIONS(3216),
    [anon_sym_no] = ACTIONS(3216),
    [anon_sym_for] = ACTIONS(3216),
    [anon_sym_foreach] = ACTIONS(3216),
    [anon_sym_last] = ACTIONS(3216),
    [anon_sym_next] = ACTIONS(3216),
    [anon_sym_redo] = ACTIONS(3216),
    [anon_sym_BEGIN] = ACTIONS(3216),
    [anon_sym_INIT] = ACTIONS(3216),
    [anon_sym_CHECK] = ACTIONS(3216),
    [anon_sym_UNITCHECK] = ACTIONS(3216),
    [anon_sym_END] = ACTIONS(3216),
    [anon_sym_ADJUST] = ACTIONS(3216),
    [anon_sym___FILE__] = ACTIONS(3216),
    [anon_sym___LINE__] = ACTIONS(3216),
    [anon_sym___PACKAGE__] = ACTIONS(3216),
    [anon_sym___SUB__] = ACTIONS(3216),
    [anon_sym_break] = ACTIONS(3216),
    [anon_sym_fork] = ACTIONS(3216),
    [anon_sym_getppid] = ACTIONS(3216),
    [anon_sym_time] = ACTIONS(3216),
    [anon_sym_times] = ACTIONS(3216),
    [anon_sym_wait] = ACTIONS(3216),
    [anon_sym_wantarray] = ACTIONS(3216),
    [anon_sym_abs] = ACTIONS(3216),
    [anon_sym_alarm] = ACTIONS(3216),
    [anon_sym_chop] = ACTIONS(3216),
    [anon_sym_chdir] = ACTIONS(3216),
    [anon_sym_close] = ACTIONS(3216),
    [anon_sym_closedir] = ACTIONS(3216),
    [anon_sym_caller] = ACTIONS(3216),
    [anon_sym_chomp] = ACTIONS(3216),
    [anon_sym_chr] = ACTIONS(3216),
    [anon_sym_cos] = ACTIONS(3216),
    [anon_sym_chroot] = ACTIONS(3216),
    [anon_sym_defined] = ACTIONS(3216),
    [anon_sym_delete] = ACTIONS(3216),
    [anon_sym_dbmclose] = ACTIONS(3216),
    [anon_sym_exists] = ACTIONS(3216),
    [anon_sym_exit] = ACTIONS(3216),
    [anon_sym_eof] = ACTIONS(3216),
    [anon_sym_exp] = ACTIONS(3216),
    [anon_sym_each] = ACTIONS(3216),
    [anon_sym_fc] = ACTIONS(3216),
    [anon_sym_fileno] = ACTIONS(3216),
    [anon_sym_gmtime] = ACTIONS(3216),
    [anon_sym_getc] = ACTIONS(3216),
    [anon_sym_getpgrp] = ACTIONS(3216),
    [anon_sym_getprotobyname] = ACTIONS(3216),
    [anon_sym_getpwname] = ACTIONS(3216),
    [anon_sym_getpwuid] = ACTIONS(3216),
    [anon_sym_getpeername] = ACTIONS(3216),
    [anon_sym_getnetbyname] = ACTIONS(3216),
    [anon_sym_getsockname] = ACTIONS(3216),
    [anon_sym_getgrnam] = ACTIONS(3216),
    [anon_sym_getgrgid] = ACTIONS(3216),
    [anon_sym_hex] = ACTIONS(3216),
    [anon_sym_int] = ACTIONS(3216),
    [anon_sym_keys] = ACTIONS(3216),
    [anon_sym_lc] = ACTIONS(3216),
    [anon_sym_lcfirst] = ACTIONS(3216),
    [anon_sym_length] = ACTIONS(3216),
    [anon_sym_localtime] = ACTIONS(3216),
    [anon_sym_log] = ACTIONS(3216),
    [anon_sym_lock] = ACTIONS(3216),
    [anon_sym_lstat] = ACTIONS(3216),
    [anon_sym_oct] = ACTIONS(3216),
    [anon_sym_ord] = ACTIONS(3216),
    [anon_sym_prototype] = ACTIONS(3216),
    [anon_sym_pop] = ACTIONS(3216),
    [anon_sym_pos] = ACTIONS(3216),
    [anon_sym_quotemeta] = ACTIONS(3216),
    [anon_sym_reset] = ACTIONS(3216),
    [anon_sym_rand] = ACTIONS(3216),
    [anon_sym_rmdir] = ACTIONS(3216),
    [anon_sym_readdir] = ACTIONS(3216),
    [anon_sym_readline] = ACTIONS(3216),
    [anon_sym_readpipe] = ACTIONS(3216),
    [anon_sym_rewinddir] = ACTIONS(3216),
    [anon_sym_readlink] = ACTIONS(3216),
    [anon_sym_ref] = ACTIONS(3216),
    [anon_sym_scalar] = ACTIONS(3216),
    [anon_sym_shift] = ACTIONS(3216),
    [anon_sym_sin] = ACTIONS(3216),
    [anon_sym_sleep] = ACTIONS(3216),
    [anon_sym_sqrt] = ACTIONS(3216),
    [anon_sym_srand] = ACTIONS(3216),
    [anon_sym_stat] = ACTIONS(3216),
    [anon_sym_study] = ACTIONS(3216),
    [anon_sym_tell] = ACTIONS(3216),
    [anon_sym_telldir] = ACTIONS(3216),
    [anon_sym_tied] = ACTIONS(3216),
    [anon_sym_uc] = ACTIONS(3216),
    [anon_sym_ucfirst] = ACTIONS(3216),
    [anon_sym_untie] = ACTIONS(3216),
    [anon_sym_umask] = ACTIONS(3216),
    [anon_sym_values] = ACTIONS(3216),
    [anon_sym_write] = ACTIONS(3216),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3216),
    [anon_sym___END__] = ACTIONS(3216),
    [anon_sym_EOT] = ACTIONS(3216),
    [anon_sym_q] = ACTIONS(3216),
    [anon_sym_qq] = ACTIONS(3216),
    [anon_sym_qw] = ACTIONS(3216),
    [anon_sym_qx] = ACTIONS(3216),
    [anon_sym_qr] = ACTIONS(3216),
    [anon_sym_m] = ACTIONS(3216),
    [anon_sym_s] = ACTIONS(3216),
    [anon_sym_tr] = ACTIONS(3216),
    [anon_sym_y] = ACTIONS(3216),
    [anon_sym_if] = ACTIONS(3216),
    [anon_sym_unless] = ACTIONS(3216),
    [anon_sym_while] = ACTIONS(3216),
    [anon_sym_until] = ACTIONS(3216),
    [aux_sym__bareword_token1] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [sym__apostrophe] = ACTIONS(3214),
    [sym__double_quote] = ACTIONS(3214),
    [sym__backtick] = ACTIONS(3214),
    [sym__search_slash] = ACTIONS(3214),
    [sym__PERLY_HEREDOC] = ACTIONS(3214),
    [sym__ctrl_z_hack] = ACTIONS(3214),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1020] = {
    [sym_heredoc_content] = STATE(1020),
    [ts_builtin_sym_end] = ACTIONS(3218),
    [sym__identifier] = ACTIONS(3220),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_LBRACE2] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_package] = ACTIONS(3220),
    [anon_sym_class] = ACTIONS(3220),
    [anon_sym_sub] = ACTIONS(3220),
    [anon_sym_method] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [anon_sym_continue] = ACTIONS(3220),
    [anon_sym_my] = ACTIONS(3220),
    [anon_sym_state] = ACTIONS(3220),
    [anon_sym_our] = ACTIONS(3220),
    [anon_sym_try] = ACTIONS(3220),
    [anon_sym_defer] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3220),
    [anon_sym_else] = ACTIONS(3220),
    [anon_sym_elsif] = ACTIONS(3220),
    [anon_sym_and] = ACTIONS(3220),
    [anon_sym_or] = ACTIONS(3220),
    [anon_sym_DOLLAR] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [anon_sym_AT] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_LT_LT] = ACTIONS(3220),
    [anon_sym_SLASH_SLASH] = ACTIONS(3220),
    [anon_sym_PLUS] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3220),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_eq] = ACTIONS(3220),
    [anon_sym_ne] = ACTIONS(3220),
    [anon_sym_cmp] = ACTIONS(3220),
    [anon_sym_lt] = ACTIONS(3220),
    [anon_sym_le] = ACTIONS(3220),
    [anon_sym_ge] = ACTIONS(3220),
    [anon_sym_gt] = ACTIONS(3220),
    [anon_sym_isa] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_BSLASH] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3220),
    [anon_sym_eval] = ACTIONS(3220),
    [anon_sym_field] = ACTIONS(3220),
    [anon_sym_local] = ACTIONS(3220),
    [anon_sym_require] = ACTIONS(3220),
    [anon_sym_map] = ACTIONS(3220),
    [anon_sym_grep] = ACTIONS(3220),
    [anon_sym_sort] = ACTIONS(3220),
    [anon_sym_goto] = ACTIONS(3220),
    [anon_sym_return] = ACTIONS(3220),
    [anon_sym_undef] = ACTIONS(3220),
    [anon_sym_PERCENT2] = ACTIONS(3220),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3220),
    [anon_sym_use] = ACTIONS(3220),
    [anon_sym_no] = ACTIONS(3220),
    [anon_sym_for] = ACTIONS(3220),
    [anon_sym_foreach] = ACTIONS(3220),
    [anon_sym_last] = ACTIONS(3220),
    [anon_sym_next] = ACTIONS(3220),
    [anon_sym_redo] = ACTIONS(3220),
    [anon_sym_BEGIN] = ACTIONS(3220),
    [anon_sym_INIT] = ACTIONS(3220),
    [anon_sym_CHECK] = ACTIONS(3220),
    [anon_sym_UNITCHECK] = ACTIONS(3220),
    [anon_sym_END] = ACTIONS(3220),
    [anon_sym_ADJUST] = ACTIONS(3220),
    [anon_sym___FILE__] = ACTIONS(3220),
    [anon_sym___LINE__] = ACTIONS(3220),
    [anon_sym___PACKAGE__] = ACTIONS(3220),
    [anon_sym___SUB__] = ACTIONS(3220),
    [anon_sym_break] = ACTIONS(3220),
    [anon_sym_fork] = ACTIONS(3220),
    [anon_sym_getppid] = ACTIONS(3220),
    [anon_sym_time] = ACTIONS(3220),
    [anon_sym_times] = ACTIONS(3220),
    [anon_sym_wait] = ACTIONS(3220),
    [anon_sym_wantarray] = ACTIONS(3220),
    [anon_sym_abs] = ACTIONS(3220),
    [anon_sym_alarm] = ACTIONS(3220),
    [anon_sym_chop] = ACTIONS(3220),
    [anon_sym_chdir] = ACTIONS(3220),
    [anon_sym_close] = ACTIONS(3220),
    [anon_sym_closedir] = ACTIONS(3220),
    [anon_sym_caller] = ACTIONS(3220),
    [anon_sym_chomp] = ACTIONS(3220),
    [anon_sym_chr] = ACTIONS(3220),
    [anon_sym_cos] = ACTIONS(3220),
    [anon_sym_chroot] = ACTIONS(3220),
    [anon_sym_defined] = ACTIONS(3220),
    [anon_sym_delete] = ACTIONS(3220),
    [anon_sym_dbmclose] = ACTIONS(3220),
    [anon_sym_exists] = ACTIONS(3220),
    [anon_sym_exit] = ACTIONS(3220),
    [anon_sym_eof] = ACTIONS(3220),
    [anon_sym_exp] = ACTIONS(3220),
    [anon_sym_each] = ACTIONS(3220),
    [anon_sym_fc] = ACTIONS(3220),
    [anon_sym_fileno] = ACTIONS(3220),
    [anon_sym_gmtime] = ACTIONS(3220),
    [anon_sym_getc] = ACTIONS(3220),
    [anon_sym_getpgrp] = ACTIONS(3220),
    [anon_sym_getprotobyname] = ACTIONS(3220),
    [anon_sym_getpwname] = ACTIONS(3220),
    [anon_sym_getpwuid] = ACTIONS(3220),
    [anon_sym_getpeername] = ACTIONS(3220),
    [anon_sym_getnetbyname] = ACTIONS(3220),
    [anon_sym_getsockname] = ACTIONS(3220),
    [anon_sym_getgrnam] = ACTIONS(3220),
    [anon_sym_getgrgid] = ACTIONS(3220),
    [anon_sym_hex] = ACTIONS(3220),
    [anon_sym_int] = ACTIONS(3220),
    [anon_sym_keys] = ACTIONS(3220),
    [anon_sym_lc] = ACTIONS(3220),
    [anon_sym_lcfirst] = ACTIONS(3220),
    [anon_sym_length] = ACTIONS(3220),
    [anon_sym_localtime] = ACTIONS(3220),
    [anon_sym_log] = ACTIONS(3220),
    [anon_sym_lock] = ACTIONS(3220),
    [anon_sym_lstat] = ACTIONS(3220),
    [anon_sym_oct] = ACTIONS(3220),
    [anon_sym_ord] = ACTIONS(3220),
    [anon_sym_prototype] = ACTIONS(3220),
    [anon_sym_pop] = ACTIONS(3220),
    [anon_sym_pos] = ACTIONS(3220),
    [anon_sym_quotemeta] = ACTIONS(3220),
    [anon_sym_reset] = ACTIONS(3220),
    [anon_sym_rand] = ACTIONS(3220),
    [anon_sym_rmdir] = ACTIONS(3220),
    [anon_sym_readdir] = ACTIONS(3220),
    [anon_sym_readline] = ACTIONS(3220),
    [anon_sym_readpipe] = ACTIONS(3220),
    [anon_sym_rewinddir] = ACTIONS(3220),
    [anon_sym_readlink] = ACTIONS(3220),
    [anon_sym_ref] = ACTIONS(3220),
    [anon_sym_scalar] = ACTIONS(3220),
    [anon_sym_shift] = ACTIONS(3220),
    [anon_sym_sin] = ACTIONS(3220),
    [anon_sym_sleep] = ACTIONS(3220),
    [anon_sym_sqrt] = ACTIONS(3220),
    [anon_sym_srand] = ACTIONS(3220),
    [anon_sym_stat] = ACTIONS(3220),
    [anon_sym_study] = ACTIONS(3220),
    [anon_sym_tell] = ACTIONS(3220),
    [anon_sym_telldir] = ACTIONS(3220),
    [anon_sym_tied] = ACTIONS(3220),
    [anon_sym_uc] = ACTIONS(3220),
    [anon_sym_ucfirst] = ACTIONS(3220),
    [anon_sym_untie] = ACTIONS(3220),
    [anon_sym_umask] = ACTIONS(3220),
    [anon_sym_values] = ACTIONS(3220),
    [anon_sym_write] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3220),
    [anon_sym___END__] = ACTIONS(3220),
    [anon_sym_EOT] = ACTIONS(3220),
    [anon_sym_q] = ACTIONS(3220),
    [anon_sym_qq] = ACTIONS(3220),
    [anon_sym_qw] = ACTIONS(3220),
    [anon_sym_qx] = ACTIONS(3220),
    [anon_sym_qr] = ACTIONS(3220),
    [anon_sym_m] = ACTIONS(3220),
    [anon_sym_s] = ACTIONS(3220),
    [anon_sym_tr] = ACTIONS(3220),
    [anon_sym_y] = ACTIONS(3220),
    [anon_sym_if] = ACTIONS(3220),
    [anon_sym_unless] = ACTIONS(3220),
    [anon_sym_while] = ACTIONS(3220),
    [anon_sym_until] = ACTIONS(3220),
    [aux_sym__bareword_token1] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [sym__apostrophe] = ACTIONS(3218),
    [sym__double_quote] = ACTIONS(3218),
    [sym__backtick] = ACTIONS(3218),
    [sym__search_slash] = ACTIONS(3218),
    [sym__PERLY_HEREDOC] = ACTIONS(3218),
    [sym__ctrl_z_hack] = ACTIONS(3218),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1021] = {
    [sym_heredoc_content] = STATE(1021),
    [ts_builtin_sym_end] = ACTIONS(3222),
    [sym__identifier] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_LBRACE2] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_package] = ACTIONS(3224),
    [anon_sym_class] = ACTIONS(3224),
    [anon_sym_sub] = ACTIONS(3224),
    [anon_sym_method] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_continue] = ACTIONS(3224),
    [anon_sym_my] = ACTIONS(3224),
    [anon_sym_state] = ACTIONS(3224),
    [anon_sym_our] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(3224),
    [anon_sym_defer] = ACTIONS(3224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3224),
    [anon_sym_else] = ACTIONS(3224),
    [anon_sym_elsif] = ACTIONS(3224),
    [anon_sym_and] = ACTIONS(3224),
    [anon_sym_or] = ACTIONS(3224),
    [anon_sym_DOLLAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(3224),
    [anon_sym_SLASH_SLASH] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_eq] = ACTIONS(3224),
    [anon_sym_ne] = ACTIONS(3224),
    [anon_sym_cmp] = ACTIONS(3224),
    [anon_sym_lt] = ACTIONS(3224),
    [anon_sym_le] = ACTIONS(3224),
    [anon_sym_ge] = ACTIONS(3224),
    [anon_sym_gt] = ACTIONS(3224),
    [anon_sym_isa] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_BSLASH] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3224),
    [anon_sym_eval] = ACTIONS(3224),
    [anon_sym_field] = ACTIONS(3224),
    [anon_sym_local] = ACTIONS(3224),
    [anon_sym_require] = ACTIONS(3224),
    [anon_sym_map] = ACTIONS(3224),
    [anon_sym_grep] = ACTIONS(3224),
    [anon_sym_sort] = ACTIONS(3224),
    [anon_sym_goto] = ACTIONS(3224),
    [anon_sym_return] = ACTIONS(3224),
    [anon_sym_undef] = ACTIONS(3224),
    [anon_sym_PERCENT2] = ACTIONS(3224),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3224),
    [anon_sym_use] = ACTIONS(3224),
    [anon_sym_no] = ACTIONS(3224),
    [anon_sym_for] = ACTIONS(3224),
    [anon_sym_foreach] = ACTIONS(3224),
    [anon_sym_last] = ACTIONS(3224),
    [anon_sym_next] = ACTIONS(3224),
    [anon_sym_redo] = ACTIONS(3224),
    [anon_sym_BEGIN] = ACTIONS(3224),
    [anon_sym_INIT] = ACTIONS(3224),
    [anon_sym_CHECK] = ACTIONS(3224),
    [anon_sym_UNITCHECK] = ACTIONS(3224),
    [anon_sym_END] = ACTIONS(3224),
    [anon_sym_ADJUST] = ACTIONS(3224),
    [anon_sym___FILE__] = ACTIONS(3224),
    [anon_sym___LINE__] = ACTIONS(3224),
    [anon_sym___PACKAGE__] = ACTIONS(3224),
    [anon_sym___SUB__] = ACTIONS(3224),
    [anon_sym_break] = ACTIONS(3224),
    [anon_sym_fork] = ACTIONS(3224),
    [anon_sym_getppid] = ACTIONS(3224),
    [anon_sym_time] = ACTIONS(3224),
    [anon_sym_times] = ACTIONS(3224),
    [anon_sym_wait] = ACTIONS(3224),
    [anon_sym_wantarray] = ACTIONS(3224),
    [anon_sym_abs] = ACTIONS(3224),
    [anon_sym_alarm] = ACTIONS(3224),
    [anon_sym_chop] = ACTIONS(3224),
    [anon_sym_chdir] = ACTIONS(3224),
    [anon_sym_close] = ACTIONS(3224),
    [anon_sym_closedir] = ACTIONS(3224),
    [anon_sym_caller] = ACTIONS(3224),
    [anon_sym_chomp] = ACTIONS(3224),
    [anon_sym_chr] = ACTIONS(3224),
    [anon_sym_cos] = ACTIONS(3224),
    [anon_sym_chroot] = ACTIONS(3224),
    [anon_sym_defined] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3224),
    [anon_sym_dbmclose] = ACTIONS(3224),
    [anon_sym_exists] = ACTIONS(3224),
    [anon_sym_exit] = ACTIONS(3224),
    [anon_sym_eof] = ACTIONS(3224),
    [anon_sym_exp] = ACTIONS(3224),
    [anon_sym_each] = ACTIONS(3224),
    [anon_sym_fc] = ACTIONS(3224),
    [anon_sym_fileno] = ACTIONS(3224),
    [anon_sym_gmtime] = ACTIONS(3224),
    [anon_sym_getc] = ACTIONS(3224),
    [anon_sym_getpgrp] = ACTIONS(3224),
    [anon_sym_getprotobyname] = ACTIONS(3224),
    [anon_sym_getpwname] = ACTIONS(3224),
    [anon_sym_getpwuid] = ACTIONS(3224),
    [anon_sym_getpeername] = ACTIONS(3224),
    [anon_sym_getnetbyname] = ACTIONS(3224),
    [anon_sym_getsockname] = ACTIONS(3224),
    [anon_sym_getgrnam] = ACTIONS(3224),
    [anon_sym_getgrgid] = ACTIONS(3224),
    [anon_sym_hex] = ACTIONS(3224),
    [anon_sym_int] = ACTIONS(3224),
    [anon_sym_keys] = ACTIONS(3224),
    [anon_sym_lc] = ACTIONS(3224),
    [anon_sym_lcfirst] = ACTIONS(3224),
    [anon_sym_length] = ACTIONS(3224),
    [anon_sym_localtime] = ACTIONS(3224),
    [anon_sym_log] = ACTIONS(3224),
    [anon_sym_lock] = ACTIONS(3224),
    [anon_sym_lstat] = ACTIONS(3224),
    [anon_sym_oct] = ACTIONS(3224),
    [anon_sym_ord] = ACTIONS(3224),
    [anon_sym_prototype] = ACTIONS(3224),
    [anon_sym_pop] = ACTIONS(3224),
    [anon_sym_pos] = ACTIONS(3224),
    [anon_sym_quotemeta] = ACTIONS(3224),
    [anon_sym_reset] = ACTIONS(3224),
    [anon_sym_rand] = ACTIONS(3224),
    [anon_sym_rmdir] = ACTIONS(3224),
    [anon_sym_readdir] = ACTIONS(3224),
    [anon_sym_readline] = ACTIONS(3224),
    [anon_sym_readpipe] = ACTIONS(3224),
    [anon_sym_rewinddir] = ACTIONS(3224),
    [anon_sym_readlink] = ACTIONS(3224),
    [anon_sym_ref] = ACTIONS(3224),
    [anon_sym_scalar] = ACTIONS(3224),
    [anon_sym_shift] = ACTIONS(3224),
    [anon_sym_sin] = ACTIONS(3224),
    [anon_sym_sleep] = ACTIONS(3224),
    [anon_sym_sqrt] = ACTIONS(3224),
    [anon_sym_srand] = ACTIONS(3224),
    [anon_sym_stat] = ACTIONS(3224),
    [anon_sym_study] = ACTIONS(3224),
    [anon_sym_tell] = ACTIONS(3224),
    [anon_sym_telldir] = ACTIONS(3224),
    [anon_sym_tied] = ACTIONS(3224),
    [anon_sym_uc] = ACTIONS(3224),
    [anon_sym_ucfirst] = ACTIONS(3224),
    [anon_sym_untie] = ACTIONS(3224),
    [anon_sym_umask] = ACTIONS(3224),
    [anon_sym_values] = ACTIONS(3224),
    [anon_sym_write] = ACTIONS(3224),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3224),
    [anon_sym___END__] = ACTIONS(3224),
    [anon_sym_EOT] = ACTIONS(3224),
    [anon_sym_q] = ACTIONS(3224),
    [anon_sym_qq] = ACTIONS(3224),
    [anon_sym_qw] = ACTIONS(3224),
    [anon_sym_qx] = ACTIONS(3224),
    [anon_sym_qr] = ACTIONS(3224),
    [anon_sym_m] = ACTIONS(3224),
    [anon_sym_s] = ACTIONS(3224),
    [anon_sym_tr] = ACTIONS(3224),
    [anon_sym_y] = ACTIONS(3224),
    [anon_sym_if] = ACTIONS(3224),
    [anon_sym_unless] = ACTIONS(3224),
    [anon_sym_while] = ACTIONS(3224),
    [anon_sym_until] = ACTIONS(3224),
    [aux_sym__bareword_token1] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [sym__apostrophe] = ACTIONS(3222),
    [sym__double_quote] = ACTIONS(3222),
    [sym__backtick] = ACTIONS(3222),
    [sym__search_slash] = ACTIONS(3222),
    [sym__PERLY_HEREDOC] = ACTIONS(3222),
    [sym__ctrl_z_hack] = ACTIONS(3222),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1022] = {
    [sym_heredoc_content] = STATE(1022),
    [ts_builtin_sym_end] = ACTIONS(3226),
    [sym__identifier] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_LBRACE2] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_package] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_sub] = ACTIONS(3228),
    [anon_sym_method] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_continue] = ACTIONS(3228),
    [anon_sym_my] = ACTIONS(3228),
    [anon_sym_state] = ACTIONS(3228),
    [anon_sym_our] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_defer] = ACTIONS(3228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3228),
    [anon_sym_else] = ACTIONS(3228),
    [anon_sym_elsif] = ACTIONS(3228),
    [anon_sym_and] = ACTIONS(3228),
    [anon_sym_or] = ACTIONS(3228),
    [anon_sym_DOLLAR] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3228),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_SLASH_SLASH] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3228),
    [anon_sym_STAR] = ACTIONS(3228),
    [anon_sym_eq] = ACTIONS(3228),
    [anon_sym_ne] = ACTIONS(3228),
    [anon_sym_cmp] = ACTIONS(3228),
    [anon_sym_lt] = ACTIONS(3228),
    [anon_sym_le] = ACTIONS(3228),
    [anon_sym_ge] = ACTIONS(3228),
    [anon_sym_gt] = ACTIONS(3228),
    [anon_sym_isa] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_BSLASH] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3228),
    [anon_sym_eval] = ACTIONS(3228),
    [anon_sym_field] = ACTIONS(3228),
    [anon_sym_local] = ACTIONS(3228),
    [anon_sym_require] = ACTIONS(3228),
    [anon_sym_map] = ACTIONS(3228),
    [anon_sym_grep] = ACTIONS(3228),
    [anon_sym_sort] = ACTIONS(3228),
    [anon_sym_goto] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_undef] = ACTIONS(3228),
    [anon_sym_PERCENT2] = ACTIONS(3228),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3228),
    [anon_sym_use] = ACTIONS(3228),
    [anon_sym_no] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_foreach] = ACTIONS(3228),
    [anon_sym_last] = ACTIONS(3228),
    [anon_sym_next] = ACTIONS(3228),
    [anon_sym_redo] = ACTIONS(3228),
    [anon_sym_BEGIN] = ACTIONS(3228),
    [anon_sym_INIT] = ACTIONS(3228),
    [anon_sym_CHECK] = ACTIONS(3228),
    [anon_sym_UNITCHECK] = ACTIONS(3228),
    [anon_sym_END] = ACTIONS(3228),
    [anon_sym_ADJUST] = ACTIONS(3228),
    [anon_sym___FILE__] = ACTIONS(3228),
    [anon_sym___LINE__] = ACTIONS(3228),
    [anon_sym___PACKAGE__] = ACTIONS(3228),
    [anon_sym___SUB__] = ACTIONS(3228),
    [anon_sym_break] = ACTIONS(3228),
    [anon_sym_fork] = ACTIONS(3228),
    [anon_sym_getppid] = ACTIONS(3228),
    [anon_sym_time] = ACTIONS(3228),
    [anon_sym_times] = ACTIONS(3228),
    [anon_sym_wait] = ACTIONS(3228),
    [anon_sym_wantarray] = ACTIONS(3228),
    [anon_sym_abs] = ACTIONS(3228),
    [anon_sym_alarm] = ACTIONS(3228),
    [anon_sym_chop] = ACTIONS(3228),
    [anon_sym_chdir] = ACTIONS(3228),
    [anon_sym_close] = ACTIONS(3228),
    [anon_sym_closedir] = ACTIONS(3228),
    [anon_sym_caller] = ACTIONS(3228),
    [anon_sym_chomp] = ACTIONS(3228),
    [anon_sym_chr] = ACTIONS(3228),
    [anon_sym_cos] = ACTIONS(3228),
    [anon_sym_chroot] = ACTIONS(3228),
    [anon_sym_defined] = ACTIONS(3228),
    [anon_sym_delete] = ACTIONS(3228),
    [anon_sym_dbmclose] = ACTIONS(3228),
    [anon_sym_exists] = ACTIONS(3228),
    [anon_sym_exit] = ACTIONS(3228),
    [anon_sym_eof] = ACTIONS(3228),
    [anon_sym_exp] = ACTIONS(3228),
    [anon_sym_each] = ACTIONS(3228),
    [anon_sym_fc] = ACTIONS(3228),
    [anon_sym_fileno] = ACTIONS(3228),
    [anon_sym_gmtime] = ACTIONS(3228),
    [anon_sym_getc] = ACTIONS(3228),
    [anon_sym_getpgrp] = ACTIONS(3228),
    [anon_sym_getprotobyname] = ACTIONS(3228),
    [anon_sym_getpwname] = ACTIONS(3228),
    [anon_sym_getpwuid] = ACTIONS(3228),
    [anon_sym_getpeername] = ACTIONS(3228),
    [anon_sym_getnetbyname] = ACTIONS(3228),
    [anon_sym_getsockname] = ACTIONS(3228),
    [anon_sym_getgrnam] = ACTIONS(3228),
    [anon_sym_getgrgid] = ACTIONS(3228),
    [anon_sym_hex] = ACTIONS(3228),
    [anon_sym_int] = ACTIONS(3228),
    [anon_sym_keys] = ACTIONS(3228),
    [anon_sym_lc] = ACTIONS(3228),
    [anon_sym_lcfirst] = ACTIONS(3228),
    [anon_sym_length] = ACTIONS(3228),
    [anon_sym_localtime] = ACTIONS(3228),
    [anon_sym_log] = ACTIONS(3228),
    [anon_sym_lock] = ACTIONS(3228),
    [anon_sym_lstat] = ACTIONS(3228),
    [anon_sym_oct] = ACTIONS(3228),
    [anon_sym_ord] = ACTIONS(3228),
    [anon_sym_prototype] = ACTIONS(3228),
    [anon_sym_pop] = ACTIONS(3228),
    [anon_sym_pos] = ACTIONS(3228),
    [anon_sym_quotemeta] = ACTIONS(3228),
    [anon_sym_reset] = ACTIONS(3228),
    [anon_sym_rand] = ACTIONS(3228),
    [anon_sym_rmdir] = ACTIONS(3228),
    [anon_sym_readdir] = ACTIONS(3228),
    [anon_sym_readline] = ACTIONS(3228),
    [anon_sym_readpipe] = ACTIONS(3228),
    [anon_sym_rewinddir] = ACTIONS(3228),
    [anon_sym_readlink] = ACTIONS(3228),
    [anon_sym_ref] = ACTIONS(3228),
    [anon_sym_scalar] = ACTIONS(3228),
    [anon_sym_shift] = ACTIONS(3228),
    [anon_sym_sin] = ACTIONS(3228),
    [anon_sym_sleep] = ACTIONS(3228),
    [anon_sym_sqrt] = ACTIONS(3228),
    [anon_sym_srand] = ACTIONS(3228),
    [anon_sym_stat] = ACTIONS(3228),
    [anon_sym_study] = ACTIONS(3228),
    [anon_sym_tell] = ACTIONS(3228),
    [anon_sym_telldir] = ACTIONS(3228),
    [anon_sym_tied] = ACTIONS(3228),
    [anon_sym_uc] = ACTIONS(3228),
    [anon_sym_ucfirst] = ACTIONS(3228),
    [anon_sym_untie] = ACTIONS(3228),
    [anon_sym_umask] = ACTIONS(3228),
    [anon_sym_values] = ACTIONS(3228),
    [anon_sym_write] = ACTIONS(3228),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3228),
    [anon_sym___END__] = ACTIONS(3228),
    [anon_sym_EOT] = ACTIONS(3228),
    [anon_sym_q] = ACTIONS(3228),
    [anon_sym_qq] = ACTIONS(3228),
    [anon_sym_qw] = ACTIONS(3228),
    [anon_sym_qx] = ACTIONS(3228),
    [anon_sym_qr] = ACTIONS(3228),
    [anon_sym_m] = ACTIONS(3228),
    [anon_sym_s] = ACTIONS(3228),
    [anon_sym_tr] = ACTIONS(3228),
    [anon_sym_y] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_unless] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_until] = ACTIONS(3228),
    [aux_sym__bareword_token1] = ACTIONS(3228),
    [sym_number] = ACTIONS(3228),
    [sym__apostrophe] = ACTIONS(3226),
    [sym__double_quote] = ACTIONS(3226),
    [sym__backtick] = ACTIONS(3226),
    [sym__search_slash] = ACTIONS(3226),
    [sym__PERLY_HEREDOC] = ACTIONS(3226),
    [sym__ctrl_z_hack] = ACTIONS(3226),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1023] = {
    [sym_heredoc_content] = STATE(1023),
    [ts_builtin_sym_end] = ACTIONS(3230),
    [sym__identifier] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_LBRACE2] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym_package] = ACTIONS(3232),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_sub] = ACTIONS(3232),
    [anon_sym_method] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3232),
    [anon_sym_continue] = ACTIONS(3232),
    [anon_sym_my] = ACTIONS(3232),
    [anon_sym_state] = ACTIONS(3232),
    [anon_sym_our] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3232),
    [anon_sym_defer] = ACTIONS(3232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3232),
    [anon_sym_else] = ACTIONS(3232),
    [anon_sym_elsif] = ACTIONS(3232),
    [anon_sym_and] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(3232),
    [anon_sym_AT] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_LT_LT] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_eq] = ACTIONS(3232),
    [anon_sym_ne] = ACTIONS(3232),
    [anon_sym_cmp] = ACTIONS(3232),
    [anon_sym_lt] = ACTIONS(3232),
    [anon_sym_le] = ACTIONS(3232),
    [anon_sym_ge] = ACTIONS(3232),
    [anon_sym_gt] = ACTIONS(3232),
    [anon_sym_isa] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [anon_sym_BSLASH] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3232),
    [anon_sym_eval] = ACTIONS(3232),
    [anon_sym_field] = ACTIONS(3232),
    [anon_sym_local] = ACTIONS(3232),
    [anon_sym_require] = ACTIONS(3232),
    [anon_sym_map] = ACTIONS(3232),
    [anon_sym_grep] = ACTIONS(3232),
    [anon_sym_sort] = ACTIONS(3232),
    [anon_sym_goto] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3232),
    [anon_sym_undef] = ACTIONS(3232),
    [anon_sym_PERCENT2] = ACTIONS(3232),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3232),
    [anon_sym_no] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3232),
    [anon_sym_foreach] = ACTIONS(3232),
    [anon_sym_last] = ACTIONS(3232),
    [anon_sym_next] = ACTIONS(3232),
    [anon_sym_redo] = ACTIONS(3232),
    [anon_sym_BEGIN] = ACTIONS(3232),
    [anon_sym_INIT] = ACTIONS(3232),
    [anon_sym_CHECK] = ACTIONS(3232),
    [anon_sym_UNITCHECK] = ACTIONS(3232),
    [anon_sym_END] = ACTIONS(3232),
    [anon_sym_ADJUST] = ACTIONS(3232),
    [anon_sym___FILE__] = ACTIONS(3232),
    [anon_sym___LINE__] = ACTIONS(3232),
    [anon_sym___PACKAGE__] = ACTIONS(3232),
    [anon_sym___SUB__] = ACTIONS(3232),
    [anon_sym_break] = ACTIONS(3232),
    [anon_sym_fork] = ACTIONS(3232),
    [anon_sym_getppid] = ACTIONS(3232),
    [anon_sym_time] = ACTIONS(3232),
    [anon_sym_times] = ACTIONS(3232),
    [anon_sym_wait] = ACTIONS(3232),
    [anon_sym_wantarray] = ACTIONS(3232),
    [anon_sym_abs] = ACTIONS(3232),
    [anon_sym_alarm] = ACTIONS(3232),
    [anon_sym_chop] = ACTIONS(3232),
    [anon_sym_chdir] = ACTIONS(3232),
    [anon_sym_close] = ACTIONS(3232),
    [anon_sym_closedir] = ACTIONS(3232),
    [anon_sym_caller] = ACTIONS(3232),
    [anon_sym_chomp] = ACTIONS(3232),
    [anon_sym_chr] = ACTIONS(3232),
    [anon_sym_cos] = ACTIONS(3232),
    [anon_sym_chroot] = ACTIONS(3232),
    [anon_sym_defined] = ACTIONS(3232),
    [anon_sym_delete] = ACTIONS(3232),
    [anon_sym_dbmclose] = ACTIONS(3232),
    [anon_sym_exists] = ACTIONS(3232),
    [anon_sym_exit] = ACTIONS(3232),
    [anon_sym_eof] = ACTIONS(3232),
    [anon_sym_exp] = ACTIONS(3232),
    [anon_sym_each] = ACTIONS(3232),
    [anon_sym_fc] = ACTIONS(3232),
    [anon_sym_fileno] = ACTIONS(3232),
    [anon_sym_gmtime] = ACTIONS(3232),
    [anon_sym_getc] = ACTIONS(3232),
    [anon_sym_getpgrp] = ACTIONS(3232),
    [anon_sym_getprotobyname] = ACTIONS(3232),
    [anon_sym_getpwname] = ACTIONS(3232),
    [anon_sym_getpwuid] = ACTIONS(3232),
    [anon_sym_getpeername] = ACTIONS(3232),
    [anon_sym_getnetbyname] = ACTIONS(3232),
    [anon_sym_getsockname] = ACTIONS(3232),
    [anon_sym_getgrnam] = ACTIONS(3232),
    [anon_sym_getgrgid] = ACTIONS(3232),
    [anon_sym_hex] = ACTIONS(3232),
    [anon_sym_int] = ACTIONS(3232),
    [anon_sym_keys] = ACTIONS(3232),
    [anon_sym_lc] = ACTIONS(3232),
    [anon_sym_lcfirst] = ACTIONS(3232),
    [anon_sym_length] = ACTIONS(3232),
    [anon_sym_localtime] = ACTIONS(3232),
    [anon_sym_log] = ACTIONS(3232),
    [anon_sym_lock] = ACTIONS(3232),
    [anon_sym_lstat] = ACTIONS(3232),
    [anon_sym_oct] = ACTIONS(3232),
    [anon_sym_ord] = ACTIONS(3232),
    [anon_sym_prototype] = ACTIONS(3232),
    [anon_sym_pop] = ACTIONS(3232),
    [anon_sym_pos] = ACTIONS(3232),
    [anon_sym_quotemeta] = ACTIONS(3232),
    [anon_sym_reset] = ACTIONS(3232),
    [anon_sym_rand] = ACTIONS(3232),
    [anon_sym_rmdir] = ACTIONS(3232),
    [anon_sym_readdir] = ACTIONS(3232),
    [anon_sym_readline] = ACTIONS(3232),
    [anon_sym_readpipe] = ACTIONS(3232),
    [anon_sym_rewinddir] = ACTIONS(3232),
    [anon_sym_readlink] = ACTIONS(3232),
    [anon_sym_ref] = ACTIONS(3232),
    [anon_sym_scalar] = ACTIONS(3232),
    [anon_sym_shift] = ACTIONS(3232),
    [anon_sym_sin] = ACTIONS(3232),
    [anon_sym_sleep] = ACTIONS(3232),
    [anon_sym_sqrt] = ACTIONS(3232),
    [anon_sym_srand] = ACTIONS(3232),
    [anon_sym_stat] = ACTIONS(3232),
    [anon_sym_study] = ACTIONS(3232),
    [anon_sym_tell] = ACTIONS(3232),
    [anon_sym_telldir] = ACTIONS(3232),
    [anon_sym_tied] = ACTIONS(3232),
    [anon_sym_uc] = ACTIONS(3232),
    [anon_sym_ucfirst] = ACTIONS(3232),
    [anon_sym_untie] = ACTIONS(3232),
    [anon_sym_umask] = ACTIONS(3232),
    [anon_sym_values] = ACTIONS(3232),
    [anon_sym_write] = ACTIONS(3232),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3232),
    [anon_sym___END__] = ACTIONS(3232),
    [anon_sym_EOT] = ACTIONS(3232),
    [anon_sym_q] = ACTIONS(3232),
    [anon_sym_qq] = ACTIONS(3232),
    [anon_sym_qw] = ACTIONS(3232),
    [anon_sym_qx] = ACTIONS(3232),
    [anon_sym_qr] = ACTIONS(3232),
    [anon_sym_m] = ACTIONS(3232),
    [anon_sym_s] = ACTIONS(3232),
    [anon_sym_tr] = ACTIONS(3232),
    [anon_sym_y] = ACTIONS(3232),
    [anon_sym_if] = ACTIONS(3232),
    [anon_sym_unless] = ACTIONS(3232),
    [anon_sym_while] = ACTIONS(3232),
    [anon_sym_until] = ACTIONS(3232),
    [aux_sym__bareword_token1] = ACTIONS(3232),
    [sym_number] = ACTIONS(3232),
    [sym__apostrophe] = ACTIONS(3230),
    [sym__double_quote] = ACTIONS(3230),
    [sym__backtick] = ACTIONS(3230),
    [sym__search_slash] = ACTIONS(3230),
    [sym__PERLY_HEREDOC] = ACTIONS(3230),
    [sym__ctrl_z_hack] = ACTIONS(3230),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1024] = {
    [sym_heredoc_content] = STATE(1024),
    [ts_builtin_sym_end] = ACTIONS(3234),
    [sym__identifier] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_LBRACE2] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym_package] = ACTIONS(3236),
    [anon_sym_class] = ACTIONS(3236),
    [anon_sym_sub] = ACTIONS(3236),
    [anon_sym_method] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(3236),
    [anon_sym_continue] = ACTIONS(3236),
    [anon_sym_my] = ACTIONS(3236),
    [anon_sym_state] = ACTIONS(3236),
    [anon_sym_our] = ACTIONS(3236),
    [anon_sym_try] = ACTIONS(3236),
    [anon_sym_defer] = ACTIONS(3236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3236),
    [anon_sym_else] = ACTIONS(3236),
    [anon_sym_elsif] = ACTIONS(3236),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(3236),
    [anon_sym_DOLLAR] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3236),
    [anon_sym_AT] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_LT_LT] = ACTIONS(3236),
    [anon_sym_SLASH_SLASH] = ACTIONS(3236),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_eq] = ACTIONS(3236),
    [anon_sym_ne] = ACTIONS(3236),
    [anon_sym_cmp] = ACTIONS(3236),
    [anon_sym_lt] = ACTIONS(3236),
    [anon_sym_le] = ACTIONS(3236),
    [anon_sym_ge] = ACTIONS(3236),
    [anon_sym_gt] = ACTIONS(3236),
    [anon_sym_isa] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [anon_sym_BSLASH] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3236),
    [anon_sym_eval] = ACTIONS(3236),
    [anon_sym_field] = ACTIONS(3236),
    [anon_sym_local] = ACTIONS(3236),
    [anon_sym_require] = ACTIONS(3236),
    [anon_sym_map] = ACTIONS(3236),
    [anon_sym_grep] = ACTIONS(3236),
    [anon_sym_sort] = ACTIONS(3236),
    [anon_sym_goto] = ACTIONS(3236),
    [anon_sym_return] = ACTIONS(3236),
    [anon_sym_undef] = ACTIONS(3236),
    [anon_sym_PERCENT2] = ACTIONS(3236),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3236),
    [anon_sym_use] = ACTIONS(3236),
    [anon_sym_no] = ACTIONS(3236),
    [anon_sym_for] = ACTIONS(3236),
    [anon_sym_foreach] = ACTIONS(3236),
    [anon_sym_last] = ACTIONS(3236),
    [anon_sym_next] = ACTIONS(3236),
    [anon_sym_redo] = ACTIONS(3236),
    [anon_sym_BEGIN] = ACTIONS(3236),
    [anon_sym_INIT] = ACTIONS(3236),
    [anon_sym_CHECK] = ACTIONS(3236),
    [anon_sym_UNITCHECK] = ACTIONS(3236),
    [anon_sym_END] = ACTIONS(3236),
    [anon_sym_ADJUST] = ACTIONS(3236),
    [anon_sym___FILE__] = ACTIONS(3236),
    [anon_sym___LINE__] = ACTIONS(3236),
    [anon_sym___PACKAGE__] = ACTIONS(3236),
    [anon_sym___SUB__] = ACTIONS(3236),
    [anon_sym_break] = ACTIONS(3236),
    [anon_sym_fork] = ACTIONS(3236),
    [anon_sym_getppid] = ACTIONS(3236),
    [anon_sym_time] = ACTIONS(3236),
    [anon_sym_times] = ACTIONS(3236),
    [anon_sym_wait] = ACTIONS(3236),
    [anon_sym_wantarray] = ACTIONS(3236),
    [anon_sym_abs] = ACTIONS(3236),
    [anon_sym_alarm] = ACTIONS(3236),
    [anon_sym_chop] = ACTIONS(3236),
    [anon_sym_chdir] = ACTIONS(3236),
    [anon_sym_close] = ACTIONS(3236),
    [anon_sym_closedir] = ACTIONS(3236),
    [anon_sym_caller] = ACTIONS(3236),
    [anon_sym_chomp] = ACTIONS(3236),
    [anon_sym_chr] = ACTIONS(3236),
    [anon_sym_cos] = ACTIONS(3236),
    [anon_sym_chroot] = ACTIONS(3236),
    [anon_sym_defined] = ACTIONS(3236),
    [anon_sym_delete] = ACTIONS(3236),
    [anon_sym_dbmclose] = ACTIONS(3236),
    [anon_sym_exists] = ACTIONS(3236),
    [anon_sym_exit] = ACTIONS(3236),
    [anon_sym_eof] = ACTIONS(3236),
    [anon_sym_exp] = ACTIONS(3236),
    [anon_sym_each] = ACTIONS(3236),
    [anon_sym_fc] = ACTIONS(3236),
    [anon_sym_fileno] = ACTIONS(3236),
    [anon_sym_gmtime] = ACTIONS(3236),
    [anon_sym_getc] = ACTIONS(3236),
    [anon_sym_getpgrp] = ACTIONS(3236),
    [anon_sym_getprotobyname] = ACTIONS(3236),
    [anon_sym_getpwname] = ACTIONS(3236),
    [anon_sym_getpwuid] = ACTIONS(3236),
    [anon_sym_getpeername] = ACTIONS(3236),
    [anon_sym_getnetbyname] = ACTIONS(3236),
    [anon_sym_getsockname] = ACTIONS(3236),
    [anon_sym_getgrnam] = ACTIONS(3236),
    [anon_sym_getgrgid] = ACTIONS(3236),
    [anon_sym_hex] = ACTIONS(3236),
    [anon_sym_int] = ACTIONS(3236),
    [anon_sym_keys] = ACTIONS(3236),
    [anon_sym_lc] = ACTIONS(3236),
    [anon_sym_lcfirst] = ACTIONS(3236),
    [anon_sym_length] = ACTIONS(3236),
    [anon_sym_localtime] = ACTIONS(3236),
    [anon_sym_log] = ACTIONS(3236),
    [anon_sym_lock] = ACTIONS(3236),
    [anon_sym_lstat] = ACTIONS(3236),
    [anon_sym_oct] = ACTIONS(3236),
    [anon_sym_ord] = ACTIONS(3236),
    [anon_sym_prototype] = ACTIONS(3236),
    [anon_sym_pop] = ACTIONS(3236),
    [anon_sym_pos] = ACTIONS(3236),
    [anon_sym_quotemeta] = ACTIONS(3236),
    [anon_sym_reset] = ACTIONS(3236),
    [anon_sym_rand] = ACTIONS(3236),
    [anon_sym_rmdir] = ACTIONS(3236),
    [anon_sym_readdir] = ACTIONS(3236),
    [anon_sym_readline] = ACTIONS(3236),
    [anon_sym_readpipe] = ACTIONS(3236),
    [anon_sym_rewinddir] = ACTIONS(3236),
    [anon_sym_readlink] = ACTIONS(3236),
    [anon_sym_ref] = ACTIONS(3236),
    [anon_sym_scalar] = ACTIONS(3236),
    [anon_sym_shift] = ACTIONS(3236),
    [anon_sym_sin] = ACTIONS(3236),
    [anon_sym_sleep] = ACTIONS(3236),
    [anon_sym_sqrt] = ACTIONS(3236),
    [anon_sym_srand] = ACTIONS(3236),
    [anon_sym_stat] = ACTIONS(3236),
    [anon_sym_study] = ACTIONS(3236),
    [anon_sym_tell] = ACTIONS(3236),
    [anon_sym_telldir] = ACTIONS(3236),
    [anon_sym_tied] = ACTIONS(3236),
    [anon_sym_uc] = ACTIONS(3236),
    [anon_sym_ucfirst] = ACTIONS(3236),
    [anon_sym_untie] = ACTIONS(3236),
    [anon_sym_umask] = ACTIONS(3236),
    [anon_sym_values] = ACTIONS(3236),
    [anon_sym_write] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3236),
    [anon_sym___END__] = ACTIONS(3236),
    [anon_sym_EOT] = ACTIONS(3236),
    [anon_sym_q] = ACTIONS(3236),
    [anon_sym_qq] = ACTIONS(3236),
    [anon_sym_qw] = ACTIONS(3236),
    [anon_sym_qx] = ACTIONS(3236),
    [anon_sym_qr] = ACTIONS(3236),
    [anon_sym_m] = ACTIONS(3236),
    [anon_sym_s] = ACTIONS(3236),
    [anon_sym_tr] = ACTIONS(3236),
    [anon_sym_y] = ACTIONS(3236),
    [anon_sym_if] = ACTIONS(3236),
    [anon_sym_unless] = ACTIONS(3236),
    [anon_sym_while] = ACTIONS(3236),
    [anon_sym_until] = ACTIONS(3236),
    [aux_sym__bareword_token1] = ACTIONS(3236),
    [sym_number] = ACTIONS(3236),
    [sym__apostrophe] = ACTIONS(3234),
    [sym__double_quote] = ACTIONS(3234),
    [sym__backtick] = ACTIONS(3234),
    [sym__search_slash] = ACTIONS(3234),
    [sym__PERLY_HEREDOC] = ACTIONS(3234),
    [sym__ctrl_z_hack] = ACTIONS(3234),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1025] = {
    [sym_heredoc_content] = STATE(1025),
    [ts_builtin_sym_end] = ACTIONS(3238),
    [sym__identifier] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_LBRACE2] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_package] = ACTIONS(3240),
    [anon_sym_class] = ACTIONS(3240),
    [anon_sym_sub] = ACTIONS(3240),
    [anon_sym_method] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_my] = ACTIONS(3240),
    [anon_sym_state] = ACTIONS(3240),
    [anon_sym_our] = ACTIONS(3240),
    [anon_sym_try] = ACTIONS(3240),
    [anon_sym_defer] = ACTIONS(3240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_else] = ACTIONS(3240),
    [anon_sym_elsif] = ACTIONS(3240),
    [anon_sym_and] = ACTIONS(3240),
    [anon_sym_or] = ACTIONS(3240),
    [anon_sym_DOLLAR] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_AT] = ACTIONS(3240),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_eq] = ACTIONS(3240),
    [anon_sym_ne] = ACTIONS(3240),
    [anon_sym_cmp] = ACTIONS(3240),
    [anon_sym_lt] = ACTIONS(3240),
    [anon_sym_le] = ACTIONS(3240),
    [anon_sym_ge] = ACTIONS(3240),
    [anon_sym_gt] = ACTIONS(3240),
    [anon_sym_isa] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_BSLASH] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3240),
    [anon_sym_eval] = ACTIONS(3240),
    [anon_sym_field] = ACTIONS(3240),
    [anon_sym_local] = ACTIONS(3240),
    [anon_sym_require] = ACTIONS(3240),
    [anon_sym_map] = ACTIONS(3240),
    [anon_sym_grep] = ACTIONS(3240),
    [anon_sym_sort] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_undef] = ACTIONS(3240),
    [anon_sym_PERCENT2] = ACTIONS(3240),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3240),
    [anon_sym_use] = ACTIONS(3240),
    [anon_sym_no] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_foreach] = ACTIONS(3240),
    [anon_sym_last] = ACTIONS(3240),
    [anon_sym_next] = ACTIONS(3240),
    [anon_sym_redo] = ACTIONS(3240),
    [anon_sym_BEGIN] = ACTIONS(3240),
    [anon_sym_INIT] = ACTIONS(3240),
    [anon_sym_CHECK] = ACTIONS(3240),
    [anon_sym_UNITCHECK] = ACTIONS(3240),
    [anon_sym_END] = ACTIONS(3240),
    [anon_sym_ADJUST] = ACTIONS(3240),
    [anon_sym___FILE__] = ACTIONS(3240),
    [anon_sym___LINE__] = ACTIONS(3240),
    [anon_sym___PACKAGE__] = ACTIONS(3240),
    [anon_sym___SUB__] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_fork] = ACTIONS(3240),
    [anon_sym_getppid] = ACTIONS(3240),
    [anon_sym_time] = ACTIONS(3240),
    [anon_sym_times] = ACTIONS(3240),
    [anon_sym_wait] = ACTIONS(3240),
    [anon_sym_wantarray] = ACTIONS(3240),
    [anon_sym_abs] = ACTIONS(3240),
    [anon_sym_alarm] = ACTIONS(3240),
    [anon_sym_chop] = ACTIONS(3240),
    [anon_sym_chdir] = ACTIONS(3240),
    [anon_sym_close] = ACTIONS(3240),
    [anon_sym_closedir] = ACTIONS(3240),
    [anon_sym_caller] = ACTIONS(3240),
    [anon_sym_chomp] = ACTIONS(3240),
    [anon_sym_chr] = ACTIONS(3240),
    [anon_sym_cos] = ACTIONS(3240),
    [anon_sym_chroot] = ACTIONS(3240),
    [anon_sym_defined] = ACTIONS(3240),
    [anon_sym_delete] = ACTIONS(3240),
    [anon_sym_dbmclose] = ACTIONS(3240),
    [anon_sym_exists] = ACTIONS(3240),
    [anon_sym_exit] = ACTIONS(3240),
    [anon_sym_eof] = ACTIONS(3240),
    [anon_sym_exp] = ACTIONS(3240),
    [anon_sym_each] = ACTIONS(3240),
    [anon_sym_fc] = ACTIONS(3240),
    [anon_sym_fileno] = ACTIONS(3240),
    [anon_sym_gmtime] = ACTIONS(3240),
    [anon_sym_getc] = ACTIONS(3240),
    [anon_sym_getpgrp] = ACTIONS(3240),
    [anon_sym_getprotobyname] = ACTIONS(3240),
    [anon_sym_getpwname] = ACTIONS(3240),
    [anon_sym_getpwuid] = ACTIONS(3240),
    [anon_sym_getpeername] = ACTIONS(3240),
    [anon_sym_getnetbyname] = ACTIONS(3240),
    [anon_sym_getsockname] = ACTIONS(3240),
    [anon_sym_getgrnam] = ACTIONS(3240),
    [anon_sym_getgrgid] = ACTIONS(3240),
    [anon_sym_hex] = ACTIONS(3240),
    [anon_sym_int] = ACTIONS(3240),
    [anon_sym_keys] = ACTIONS(3240),
    [anon_sym_lc] = ACTIONS(3240),
    [anon_sym_lcfirst] = ACTIONS(3240),
    [anon_sym_length] = ACTIONS(3240),
    [anon_sym_localtime] = ACTIONS(3240),
    [anon_sym_log] = ACTIONS(3240),
    [anon_sym_lock] = ACTIONS(3240),
    [anon_sym_lstat] = ACTIONS(3240),
    [anon_sym_oct] = ACTIONS(3240),
    [anon_sym_ord] = ACTIONS(3240),
    [anon_sym_prototype] = ACTIONS(3240),
    [anon_sym_pop] = ACTIONS(3240),
    [anon_sym_pos] = ACTIONS(3240),
    [anon_sym_quotemeta] = ACTIONS(3240),
    [anon_sym_reset] = ACTIONS(3240),
    [anon_sym_rand] = ACTIONS(3240),
    [anon_sym_rmdir] = ACTIONS(3240),
    [anon_sym_readdir] = ACTIONS(3240),
    [anon_sym_readline] = ACTIONS(3240),
    [anon_sym_readpipe] = ACTIONS(3240),
    [anon_sym_rewinddir] = ACTIONS(3240),
    [anon_sym_readlink] = ACTIONS(3240),
    [anon_sym_ref] = ACTIONS(3240),
    [anon_sym_scalar] = ACTIONS(3240),
    [anon_sym_shift] = ACTIONS(3240),
    [anon_sym_sin] = ACTIONS(3240),
    [anon_sym_sleep] = ACTIONS(3240),
    [anon_sym_sqrt] = ACTIONS(3240),
    [anon_sym_srand] = ACTIONS(3240),
    [anon_sym_stat] = ACTIONS(3240),
    [anon_sym_study] = ACTIONS(3240),
    [anon_sym_tell] = ACTIONS(3240),
    [anon_sym_telldir] = ACTIONS(3240),
    [anon_sym_tied] = ACTIONS(3240),
    [anon_sym_uc] = ACTIONS(3240),
    [anon_sym_ucfirst] = ACTIONS(3240),
    [anon_sym_untie] = ACTIONS(3240),
    [anon_sym_umask] = ACTIONS(3240),
    [anon_sym_values] = ACTIONS(3240),
    [anon_sym_write] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3240),
    [anon_sym___END__] = ACTIONS(3240),
    [anon_sym_EOT] = ACTIONS(3240),
    [anon_sym_q] = ACTIONS(3240),
    [anon_sym_qq] = ACTIONS(3240),
    [anon_sym_qw] = ACTIONS(3240),
    [anon_sym_qx] = ACTIONS(3240),
    [anon_sym_qr] = ACTIONS(3240),
    [anon_sym_m] = ACTIONS(3240),
    [anon_sym_s] = ACTIONS(3240),
    [anon_sym_tr] = ACTIONS(3240),
    [anon_sym_y] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_unless] = ACTIONS(3240),
    [anon_sym_while] = ACTIONS(3240),
    [anon_sym_until] = ACTIONS(3240),
    [aux_sym__bareword_token1] = ACTIONS(3240),
    [sym_number] = ACTIONS(3240),
    [sym__apostrophe] = ACTIONS(3238),
    [sym__double_quote] = ACTIONS(3238),
    [sym__backtick] = ACTIONS(3238),
    [sym__search_slash] = ACTIONS(3238),
    [sym__PERLY_HEREDOC] = ACTIONS(3238),
    [sym__ctrl_z_hack] = ACTIONS(3238),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1026] = {
    [sym_heredoc_content] = STATE(1026),
    [ts_builtin_sym_end] = ACTIONS(3242),
    [sym__identifier] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_LBRACE2] = ACTIONS(3244),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym_package] = ACTIONS(3244),
    [anon_sym_class] = ACTIONS(3244),
    [anon_sym_sub] = ACTIONS(3244),
    [anon_sym_method] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3244),
    [anon_sym_continue] = ACTIONS(3244),
    [anon_sym_my] = ACTIONS(3244),
    [anon_sym_state] = ACTIONS(3244),
    [anon_sym_our] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3244),
    [anon_sym_defer] = ACTIONS(3244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3244),
    [anon_sym_else] = ACTIONS(3244),
    [anon_sym_elsif] = ACTIONS(3244),
    [anon_sym_and] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3244),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_AT] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_LT_LT] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_eq] = ACTIONS(3244),
    [anon_sym_ne] = ACTIONS(3244),
    [anon_sym_cmp] = ACTIONS(3244),
    [anon_sym_lt] = ACTIONS(3244),
    [anon_sym_le] = ACTIONS(3244),
    [anon_sym_ge] = ACTIONS(3244),
    [anon_sym_gt] = ACTIONS(3244),
    [anon_sym_isa] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_BSLASH] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3244),
    [anon_sym_eval] = ACTIONS(3244),
    [anon_sym_field] = ACTIONS(3244),
    [anon_sym_local] = ACTIONS(3244),
    [anon_sym_require] = ACTIONS(3244),
    [anon_sym_map] = ACTIONS(3244),
    [anon_sym_grep] = ACTIONS(3244),
    [anon_sym_sort] = ACTIONS(3244),
    [anon_sym_goto] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3244),
    [anon_sym_undef] = ACTIONS(3244),
    [anon_sym_PERCENT2] = ACTIONS(3244),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3244),
    [anon_sym_no] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3244),
    [anon_sym_foreach] = ACTIONS(3244),
    [anon_sym_last] = ACTIONS(3244),
    [anon_sym_next] = ACTIONS(3244),
    [anon_sym_redo] = ACTIONS(3244),
    [anon_sym_BEGIN] = ACTIONS(3244),
    [anon_sym_INIT] = ACTIONS(3244),
    [anon_sym_CHECK] = ACTIONS(3244),
    [anon_sym_UNITCHECK] = ACTIONS(3244),
    [anon_sym_END] = ACTIONS(3244),
    [anon_sym_ADJUST] = ACTIONS(3244),
    [anon_sym___FILE__] = ACTIONS(3244),
    [anon_sym___LINE__] = ACTIONS(3244),
    [anon_sym___PACKAGE__] = ACTIONS(3244),
    [anon_sym___SUB__] = ACTIONS(3244),
    [anon_sym_break] = ACTIONS(3244),
    [anon_sym_fork] = ACTIONS(3244),
    [anon_sym_getppid] = ACTIONS(3244),
    [anon_sym_time] = ACTIONS(3244),
    [anon_sym_times] = ACTIONS(3244),
    [anon_sym_wait] = ACTIONS(3244),
    [anon_sym_wantarray] = ACTIONS(3244),
    [anon_sym_abs] = ACTIONS(3244),
    [anon_sym_alarm] = ACTIONS(3244),
    [anon_sym_chop] = ACTIONS(3244),
    [anon_sym_chdir] = ACTIONS(3244),
    [anon_sym_close] = ACTIONS(3244),
    [anon_sym_closedir] = ACTIONS(3244),
    [anon_sym_caller] = ACTIONS(3244),
    [anon_sym_chomp] = ACTIONS(3244),
    [anon_sym_chr] = ACTIONS(3244),
    [anon_sym_cos] = ACTIONS(3244),
    [anon_sym_chroot] = ACTIONS(3244),
    [anon_sym_defined] = ACTIONS(3244),
    [anon_sym_delete] = ACTIONS(3244),
    [anon_sym_dbmclose] = ACTIONS(3244),
    [anon_sym_exists] = ACTIONS(3244),
    [anon_sym_exit] = ACTIONS(3244),
    [anon_sym_eof] = ACTIONS(3244),
    [anon_sym_exp] = ACTIONS(3244),
    [anon_sym_each] = ACTIONS(3244),
    [anon_sym_fc] = ACTIONS(3244),
    [anon_sym_fileno] = ACTIONS(3244),
    [anon_sym_gmtime] = ACTIONS(3244),
    [anon_sym_getc] = ACTIONS(3244),
    [anon_sym_getpgrp] = ACTIONS(3244),
    [anon_sym_getprotobyname] = ACTIONS(3244),
    [anon_sym_getpwname] = ACTIONS(3244),
    [anon_sym_getpwuid] = ACTIONS(3244),
    [anon_sym_getpeername] = ACTIONS(3244),
    [anon_sym_getnetbyname] = ACTIONS(3244),
    [anon_sym_getsockname] = ACTIONS(3244),
    [anon_sym_getgrnam] = ACTIONS(3244),
    [anon_sym_getgrgid] = ACTIONS(3244),
    [anon_sym_hex] = ACTIONS(3244),
    [anon_sym_int] = ACTIONS(3244),
    [anon_sym_keys] = ACTIONS(3244),
    [anon_sym_lc] = ACTIONS(3244),
    [anon_sym_lcfirst] = ACTIONS(3244),
    [anon_sym_length] = ACTIONS(3244),
    [anon_sym_localtime] = ACTIONS(3244),
    [anon_sym_log] = ACTIONS(3244),
    [anon_sym_lock] = ACTIONS(3244),
    [anon_sym_lstat] = ACTIONS(3244),
    [anon_sym_oct] = ACTIONS(3244),
    [anon_sym_ord] = ACTIONS(3244),
    [anon_sym_prototype] = ACTIONS(3244),
    [anon_sym_pop] = ACTIONS(3244),
    [anon_sym_pos] = ACTIONS(3244),
    [anon_sym_quotemeta] = ACTIONS(3244),
    [anon_sym_reset] = ACTIONS(3244),
    [anon_sym_rand] = ACTIONS(3244),
    [anon_sym_rmdir] = ACTIONS(3244),
    [anon_sym_readdir] = ACTIONS(3244),
    [anon_sym_readline] = ACTIONS(3244),
    [anon_sym_readpipe] = ACTIONS(3244),
    [anon_sym_rewinddir] = ACTIONS(3244),
    [anon_sym_readlink] = ACTIONS(3244),
    [anon_sym_ref] = ACTIONS(3244),
    [anon_sym_scalar] = ACTIONS(3244),
    [anon_sym_shift] = ACTIONS(3244),
    [anon_sym_sin] = ACTIONS(3244),
    [anon_sym_sleep] = ACTIONS(3244),
    [anon_sym_sqrt] = ACTIONS(3244),
    [anon_sym_srand] = ACTIONS(3244),
    [anon_sym_stat] = ACTIONS(3244),
    [anon_sym_study] = ACTIONS(3244),
    [anon_sym_tell] = ACTIONS(3244),
    [anon_sym_telldir] = ACTIONS(3244),
    [anon_sym_tied] = ACTIONS(3244),
    [anon_sym_uc] = ACTIONS(3244),
    [anon_sym_ucfirst] = ACTIONS(3244),
    [anon_sym_untie] = ACTIONS(3244),
    [anon_sym_umask] = ACTIONS(3244),
    [anon_sym_values] = ACTIONS(3244),
    [anon_sym_write] = ACTIONS(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3244),
    [anon_sym___END__] = ACTIONS(3244),
    [anon_sym_EOT] = ACTIONS(3244),
    [anon_sym_q] = ACTIONS(3244),
    [anon_sym_qq] = ACTIONS(3244),
    [anon_sym_qw] = ACTIONS(3244),
    [anon_sym_qx] = ACTIONS(3244),
    [anon_sym_qr] = ACTIONS(3244),
    [anon_sym_m] = ACTIONS(3244),
    [anon_sym_s] = ACTIONS(3244),
    [anon_sym_tr] = ACTIONS(3244),
    [anon_sym_y] = ACTIONS(3244),
    [anon_sym_if] = ACTIONS(3244),
    [anon_sym_unless] = ACTIONS(3244),
    [anon_sym_while] = ACTIONS(3244),
    [anon_sym_until] = ACTIONS(3244),
    [aux_sym__bareword_token1] = ACTIONS(3244),
    [sym_number] = ACTIONS(3244),
    [sym__apostrophe] = ACTIONS(3242),
    [sym__double_quote] = ACTIONS(3242),
    [sym__backtick] = ACTIONS(3242),
    [sym__search_slash] = ACTIONS(3242),
    [sym__PERLY_HEREDOC] = ACTIONS(3242),
    [sym__ctrl_z_hack] = ACTIONS(3242),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1027] = {
    [sym_heredoc_content] = STATE(1027),
    [ts_builtin_sym_end] = ACTIONS(3246),
    [sym__identifier] = ACTIONS(3248),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_LBRACE2] = ACTIONS(3248),
    [anon_sym_SEMI] = ACTIONS(3248),
    [anon_sym_package] = ACTIONS(3248),
    [anon_sym_class] = ACTIONS(3248),
    [anon_sym_sub] = ACTIONS(3248),
    [anon_sym_method] = ACTIONS(3248),
    [anon_sym_LPAREN] = ACTIONS(3248),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_my] = ACTIONS(3248),
    [anon_sym_state] = ACTIONS(3248),
    [anon_sym_our] = ACTIONS(3248),
    [anon_sym_try] = ACTIONS(3248),
    [anon_sym_defer] = ACTIONS(3248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3248),
    [anon_sym_else] = ACTIONS(3248),
    [anon_sym_elsif] = ACTIONS(3248),
    [anon_sym_and] = ACTIONS(3248),
    [anon_sym_or] = ACTIONS(3248),
    [anon_sym_DOLLAR] = ACTIONS(3248),
    [anon_sym_LBRACK] = ACTIONS(3248),
    [anon_sym_AT] = ACTIONS(3248),
    [anon_sym_LT] = ACTIONS(3248),
    [anon_sym_LT_LT] = ACTIONS(3248),
    [anon_sym_SLASH_SLASH] = ACTIONS(3248),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3248),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_eq] = ACTIONS(3248),
    [anon_sym_ne] = ACTIONS(3248),
    [anon_sym_cmp] = ACTIONS(3248),
    [anon_sym_lt] = ACTIONS(3248),
    [anon_sym_le] = ACTIONS(3248),
    [anon_sym_ge] = ACTIONS(3248),
    [anon_sym_gt] = ACTIONS(3248),
    [anon_sym_isa] = ACTIONS(3248),
    [anon_sym_TILDE] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3248),
    [anon_sym_DASH_DASH] = ACTIONS(3248),
    [anon_sym_BSLASH] = ACTIONS(3246),
    [anon_sym_do] = ACTIONS(3248),
    [anon_sym_eval] = ACTIONS(3248),
    [anon_sym_field] = ACTIONS(3248),
    [anon_sym_local] = ACTIONS(3248),
    [anon_sym_require] = ACTIONS(3248),
    [anon_sym_map] = ACTIONS(3248),
    [anon_sym_grep] = ACTIONS(3248),
    [anon_sym_sort] = ACTIONS(3248),
    [anon_sym_goto] = ACTIONS(3248),
    [anon_sym_return] = ACTIONS(3248),
    [anon_sym_undef] = ACTIONS(3248),
    [anon_sym_PERCENT2] = ACTIONS(3248),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3248),
    [anon_sym_use] = ACTIONS(3248),
    [anon_sym_no] = ACTIONS(3248),
    [anon_sym_for] = ACTIONS(3248),
    [anon_sym_foreach] = ACTIONS(3248),
    [anon_sym_last] = ACTIONS(3248),
    [anon_sym_next] = ACTIONS(3248),
    [anon_sym_redo] = ACTIONS(3248),
    [anon_sym_BEGIN] = ACTIONS(3248),
    [anon_sym_INIT] = ACTIONS(3248),
    [anon_sym_CHECK] = ACTIONS(3248),
    [anon_sym_UNITCHECK] = ACTIONS(3248),
    [anon_sym_END] = ACTIONS(3248),
    [anon_sym_ADJUST] = ACTIONS(3248),
    [anon_sym___FILE__] = ACTIONS(3248),
    [anon_sym___LINE__] = ACTIONS(3248),
    [anon_sym___PACKAGE__] = ACTIONS(3248),
    [anon_sym___SUB__] = ACTIONS(3248),
    [anon_sym_break] = ACTIONS(3248),
    [anon_sym_fork] = ACTIONS(3248),
    [anon_sym_getppid] = ACTIONS(3248),
    [anon_sym_time] = ACTIONS(3248),
    [anon_sym_times] = ACTIONS(3248),
    [anon_sym_wait] = ACTIONS(3248),
    [anon_sym_wantarray] = ACTIONS(3248),
    [anon_sym_abs] = ACTIONS(3248),
    [anon_sym_alarm] = ACTIONS(3248),
    [anon_sym_chop] = ACTIONS(3248),
    [anon_sym_chdir] = ACTIONS(3248),
    [anon_sym_close] = ACTIONS(3248),
    [anon_sym_closedir] = ACTIONS(3248),
    [anon_sym_caller] = ACTIONS(3248),
    [anon_sym_chomp] = ACTIONS(3248),
    [anon_sym_chr] = ACTIONS(3248),
    [anon_sym_cos] = ACTIONS(3248),
    [anon_sym_chroot] = ACTIONS(3248),
    [anon_sym_defined] = ACTIONS(3248),
    [anon_sym_delete] = ACTIONS(3248),
    [anon_sym_dbmclose] = ACTIONS(3248),
    [anon_sym_exists] = ACTIONS(3248),
    [anon_sym_exit] = ACTIONS(3248),
    [anon_sym_eof] = ACTIONS(3248),
    [anon_sym_exp] = ACTIONS(3248),
    [anon_sym_each] = ACTIONS(3248),
    [anon_sym_fc] = ACTIONS(3248),
    [anon_sym_fileno] = ACTIONS(3248),
    [anon_sym_gmtime] = ACTIONS(3248),
    [anon_sym_getc] = ACTIONS(3248),
    [anon_sym_getpgrp] = ACTIONS(3248),
    [anon_sym_getprotobyname] = ACTIONS(3248),
    [anon_sym_getpwname] = ACTIONS(3248),
    [anon_sym_getpwuid] = ACTIONS(3248),
    [anon_sym_getpeername] = ACTIONS(3248),
    [anon_sym_getnetbyname] = ACTIONS(3248),
    [anon_sym_getsockname] = ACTIONS(3248),
    [anon_sym_getgrnam] = ACTIONS(3248),
    [anon_sym_getgrgid] = ACTIONS(3248),
    [anon_sym_hex] = ACTIONS(3248),
    [anon_sym_int] = ACTIONS(3248),
    [anon_sym_keys] = ACTIONS(3248),
    [anon_sym_lc] = ACTIONS(3248),
    [anon_sym_lcfirst] = ACTIONS(3248),
    [anon_sym_length] = ACTIONS(3248),
    [anon_sym_localtime] = ACTIONS(3248),
    [anon_sym_log] = ACTIONS(3248),
    [anon_sym_lock] = ACTIONS(3248),
    [anon_sym_lstat] = ACTIONS(3248),
    [anon_sym_oct] = ACTIONS(3248),
    [anon_sym_ord] = ACTIONS(3248),
    [anon_sym_prototype] = ACTIONS(3248),
    [anon_sym_pop] = ACTIONS(3248),
    [anon_sym_pos] = ACTIONS(3248),
    [anon_sym_quotemeta] = ACTIONS(3248),
    [anon_sym_reset] = ACTIONS(3248),
    [anon_sym_rand] = ACTIONS(3248),
    [anon_sym_rmdir] = ACTIONS(3248),
    [anon_sym_readdir] = ACTIONS(3248),
    [anon_sym_readline] = ACTIONS(3248),
    [anon_sym_readpipe] = ACTIONS(3248),
    [anon_sym_rewinddir] = ACTIONS(3248),
    [anon_sym_readlink] = ACTIONS(3248),
    [anon_sym_ref] = ACTIONS(3248),
    [anon_sym_scalar] = ACTIONS(3248),
    [anon_sym_shift] = ACTIONS(3248),
    [anon_sym_sin] = ACTIONS(3248),
    [anon_sym_sleep] = ACTIONS(3248),
    [anon_sym_sqrt] = ACTIONS(3248),
    [anon_sym_srand] = ACTIONS(3248),
    [anon_sym_stat] = ACTIONS(3248),
    [anon_sym_study] = ACTIONS(3248),
    [anon_sym_tell] = ACTIONS(3248),
    [anon_sym_telldir] = ACTIONS(3248),
    [anon_sym_tied] = ACTIONS(3248),
    [anon_sym_uc] = ACTIONS(3248),
    [anon_sym_ucfirst] = ACTIONS(3248),
    [anon_sym_untie] = ACTIONS(3248),
    [anon_sym_umask] = ACTIONS(3248),
    [anon_sym_values] = ACTIONS(3248),
    [anon_sym_write] = ACTIONS(3248),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3248),
    [anon_sym___END__] = ACTIONS(3248),
    [anon_sym_EOT] = ACTIONS(3248),
    [anon_sym_q] = ACTIONS(3248),
    [anon_sym_qq] = ACTIONS(3248),
    [anon_sym_qw] = ACTIONS(3248),
    [anon_sym_qx] = ACTIONS(3248),
    [anon_sym_qr] = ACTIONS(3248),
    [anon_sym_m] = ACTIONS(3248),
    [anon_sym_s] = ACTIONS(3248),
    [anon_sym_tr] = ACTIONS(3248),
    [anon_sym_y] = ACTIONS(3248),
    [anon_sym_if] = ACTIONS(3248),
    [anon_sym_unless] = ACTIONS(3248),
    [anon_sym_while] = ACTIONS(3248),
    [anon_sym_until] = ACTIONS(3248),
    [aux_sym__bareword_token1] = ACTIONS(3248),
    [sym_number] = ACTIONS(3248),
    [sym__apostrophe] = ACTIONS(3246),
    [sym__double_quote] = ACTIONS(3246),
    [sym__backtick] = ACTIONS(3246),
    [sym__search_slash] = ACTIONS(3246),
    [sym__PERLY_HEREDOC] = ACTIONS(3246),
    [sym__ctrl_z_hack] = ACTIONS(3246),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1028] = {
    [sym_heredoc_content] = STATE(1028),
    [ts_builtin_sym_end] = ACTIONS(3253),
    [sym__identifier] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_LBRACE2] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_package] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_sub] = ACTIONS(3255),
    [anon_sym_method] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_my] = ACTIONS(3255),
    [anon_sym_state] = ACTIONS(3255),
    [anon_sym_our] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_defer] = ACTIONS(3255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_elsif] = ACTIONS(3255),
    [anon_sym_and] = ACTIONS(3255),
    [anon_sym_or] = ACTIONS(3255),
    [anon_sym_DOLLAR] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_LT_LT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_eq] = ACTIONS(3255),
    [anon_sym_ne] = ACTIONS(3255),
    [anon_sym_cmp] = ACTIONS(3255),
    [anon_sym_lt] = ACTIONS(3255),
    [anon_sym_le] = ACTIONS(3255),
    [anon_sym_ge] = ACTIONS(3255),
    [anon_sym_gt] = ACTIONS(3255),
    [anon_sym_isa] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [anon_sym_BSLASH] = ACTIONS(3253),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_eval] = ACTIONS(3255),
    [anon_sym_field] = ACTIONS(3255),
    [anon_sym_local] = ACTIONS(3255),
    [anon_sym_require] = ACTIONS(3255),
    [anon_sym_map] = ACTIONS(3255),
    [anon_sym_grep] = ACTIONS(3255),
    [anon_sym_sort] = ACTIONS(3255),
    [anon_sym_goto] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_undef] = ACTIONS(3255),
    [anon_sym_PERCENT2] = ACTIONS(3255),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3255),
    [anon_sym_use] = ACTIONS(3255),
    [anon_sym_no] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_foreach] = ACTIONS(3255),
    [anon_sym_last] = ACTIONS(3255),
    [anon_sym_next] = ACTIONS(3255),
    [anon_sym_redo] = ACTIONS(3255),
    [anon_sym_BEGIN] = ACTIONS(3255),
    [anon_sym_INIT] = ACTIONS(3255),
    [anon_sym_CHECK] = ACTIONS(3255),
    [anon_sym_UNITCHECK] = ACTIONS(3255),
    [anon_sym_END] = ACTIONS(3255),
    [anon_sym_ADJUST] = ACTIONS(3255),
    [anon_sym___FILE__] = ACTIONS(3255),
    [anon_sym___LINE__] = ACTIONS(3255),
    [anon_sym___PACKAGE__] = ACTIONS(3255),
    [anon_sym___SUB__] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_fork] = ACTIONS(3255),
    [anon_sym_getppid] = ACTIONS(3255),
    [anon_sym_time] = ACTIONS(3255),
    [anon_sym_times] = ACTIONS(3255),
    [anon_sym_wait] = ACTIONS(3255),
    [anon_sym_wantarray] = ACTIONS(3255),
    [anon_sym_abs] = ACTIONS(3255),
    [anon_sym_alarm] = ACTIONS(3255),
    [anon_sym_chop] = ACTIONS(3255),
    [anon_sym_chdir] = ACTIONS(3255),
    [anon_sym_close] = ACTIONS(3255),
    [anon_sym_closedir] = ACTIONS(3255),
    [anon_sym_caller] = ACTIONS(3255),
    [anon_sym_chomp] = ACTIONS(3255),
    [anon_sym_chr] = ACTIONS(3255),
    [anon_sym_cos] = ACTIONS(3255),
    [anon_sym_chroot] = ACTIONS(3255),
    [anon_sym_defined] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_dbmclose] = ACTIONS(3255),
    [anon_sym_exists] = ACTIONS(3255),
    [anon_sym_exit] = ACTIONS(3255),
    [anon_sym_eof] = ACTIONS(3255),
    [anon_sym_exp] = ACTIONS(3255),
    [anon_sym_each] = ACTIONS(3255),
    [anon_sym_fc] = ACTIONS(3255),
    [anon_sym_fileno] = ACTIONS(3255),
    [anon_sym_gmtime] = ACTIONS(3255),
    [anon_sym_getc] = ACTIONS(3255),
    [anon_sym_getpgrp] = ACTIONS(3255),
    [anon_sym_getprotobyname] = ACTIONS(3255),
    [anon_sym_getpwname] = ACTIONS(3255),
    [anon_sym_getpwuid] = ACTIONS(3255),
    [anon_sym_getpeername] = ACTIONS(3255),
    [anon_sym_getnetbyname] = ACTIONS(3255),
    [anon_sym_getsockname] = ACTIONS(3255),
    [anon_sym_getgrnam] = ACTIONS(3255),
    [anon_sym_getgrgid] = ACTIONS(3255),
    [anon_sym_hex] = ACTIONS(3255),
    [anon_sym_int] = ACTIONS(3255),
    [anon_sym_keys] = ACTIONS(3255),
    [anon_sym_lc] = ACTIONS(3255),
    [anon_sym_lcfirst] = ACTIONS(3255),
    [anon_sym_length] = ACTIONS(3255),
    [anon_sym_localtime] = ACTIONS(3255),
    [anon_sym_log] = ACTIONS(3255),
    [anon_sym_lock] = ACTIONS(3255),
    [anon_sym_lstat] = ACTIONS(3255),
    [anon_sym_oct] = ACTIONS(3255),
    [anon_sym_ord] = ACTIONS(3255),
    [anon_sym_prototype] = ACTIONS(3255),
    [anon_sym_pop] = ACTIONS(3255),
    [anon_sym_pos] = ACTIONS(3255),
    [anon_sym_quotemeta] = ACTIONS(3255),
    [anon_sym_reset] = ACTIONS(3255),
    [anon_sym_rand] = ACTIONS(3255),
    [anon_sym_rmdir] = ACTIONS(3255),
    [anon_sym_readdir] = ACTIONS(3255),
    [anon_sym_readline] = ACTIONS(3255),
    [anon_sym_readpipe] = ACTIONS(3255),
    [anon_sym_rewinddir] = ACTIONS(3255),
    [anon_sym_readlink] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_scalar] = ACTIONS(3255),
    [anon_sym_shift] = ACTIONS(3255),
    [anon_sym_sin] = ACTIONS(3255),
    [anon_sym_sleep] = ACTIONS(3255),
    [anon_sym_sqrt] = ACTIONS(3255),
    [anon_sym_srand] = ACTIONS(3255),
    [anon_sym_stat] = ACTIONS(3255),
    [anon_sym_study] = ACTIONS(3255),
    [anon_sym_tell] = ACTIONS(3255),
    [anon_sym_telldir] = ACTIONS(3255),
    [anon_sym_tied] = ACTIONS(3255),
    [anon_sym_uc] = ACTIONS(3255),
    [anon_sym_ucfirst] = ACTIONS(3255),
    [anon_sym_untie] = ACTIONS(3255),
    [anon_sym_umask] = ACTIONS(3255),
    [anon_sym_values] = ACTIONS(3255),
    [anon_sym_write] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3255),
    [anon_sym___END__] = ACTIONS(3255),
    [anon_sym_EOT] = ACTIONS(3255),
    [anon_sym_q] = ACTIONS(3255),
    [anon_sym_qq] = ACTIONS(3255),
    [anon_sym_qw] = ACTIONS(3255),
    [anon_sym_qx] = ACTIONS(3255),
    [anon_sym_qr] = ACTIONS(3255),
    [anon_sym_m] = ACTIONS(3255),
    [anon_sym_s] = ACTIONS(3255),
    [anon_sym_tr] = ACTIONS(3255),
    [anon_sym_y] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_unless] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_until] = ACTIONS(3255),
    [aux_sym__bareword_token1] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym__apostrophe] = ACTIONS(3253),
    [sym__double_quote] = ACTIONS(3253),
    [sym__backtick] = ACTIONS(3253),
    [sym__search_slash] = ACTIONS(3253),
    [sym__PERLY_HEREDOC] = ACTIONS(3253),
    [sym__ctrl_z_hack] = ACTIONS(3253),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1029] = {
    [sym_heredoc_content] = STATE(1029),
    [sym__identifier] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LBRACE2] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym_package] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_sub] = ACTIONS(2970),
    [anon_sym_method] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_my] = ACTIONS(2970),
    [anon_sym_state] = ACTIONS(2970),
    [anon_sym_our] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_catch] = ACTIONS(3257),
    [anon_sym_finally] = ACTIONS(3259),
    [anon_sym_defer] = ACTIONS(2970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_elsif] = ACTIONS(2970),
    [anon_sym_and] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_AT] = ACTIONS(2970),
    [anon_sym_LT] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2970),
    [anon_sym_SLASH_SLASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_eq] = ACTIONS(2970),
    [anon_sym_ne] = ACTIONS(2970),
    [anon_sym_cmp] = ACTIONS(2970),
    [anon_sym_lt] = ACTIONS(2970),
    [anon_sym_le] = ACTIONS(2970),
    [anon_sym_ge] = ACTIONS(2970),
    [anon_sym_gt] = ACTIONS(2970),
    [anon_sym_isa] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_BSLASH] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_eval] = ACTIONS(2970),
    [anon_sym_field] = ACTIONS(2970),
    [anon_sym_local] = ACTIONS(2970),
    [anon_sym_require] = ACTIONS(2970),
    [anon_sym_map] = ACTIONS(2970),
    [anon_sym_grep] = ACTIONS(2970),
    [anon_sym_sort] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_undef] = ACTIONS(2970),
    [anon_sym_PERCENT2] = ACTIONS(2970),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2970),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_no] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_foreach] = ACTIONS(2970),
    [anon_sym_last] = ACTIONS(2970),
    [anon_sym_next] = ACTIONS(2970),
    [anon_sym_redo] = ACTIONS(2970),
    [anon_sym_BEGIN] = ACTIONS(2970),
    [anon_sym_INIT] = ACTIONS(2970),
    [anon_sym_CHECK] = ACTIONS(2970),
    [anon_sym_UNITCHECK] = ACTIONS(2970),
    [anon_sym_END] = ACTIONS(2970),
    [anon_sym_ADJUST] = ACTIONS(2970),
    [anon_sym___FILE__] = ACTIONS(2970),
    [anon_sym___LINE__] = ACTIONS(2970),
    [anon_sym___PACKAGE__] = ACTIONS(2970),
    [anon_sym___SUB__] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_fork] = ACTIONS(2970),
    [anon_sym_getppid] = ACTIONS(2970),
    [anon_sym_time] = ACTIONS(2970),
    [anon_sym_times] = ACTIONS(2970),
    [anon_sym_wait] = ACTIONS(2970),
    [anon_sym_wantarray] = ACTIONS(2970),
    [anon_sym_abs] = ACTIONS(2970),
    [anon_sym_alarm] = ACTIONS(2970),
    [anon_sym_chop] = ACTIONS(2970),
    [anon_sym_chdir] = ACTIONS(2970),
    [anon_sym_close] = ACTIONS(2970),
    [anon_sym_closedir] = ACTIONS(2970),
    [anon_sym_caller] = ACTIONS(2970),
    [anon_sym_chomp] = ACTIONS(2970),
    [anon_sym_chr] = ACTIONS(2970),
    [anon_sym_cos] = ACTIONS(2970),
    [anon_sym_chroot] = ACTIONS(2970),
    [anon_sym_defined] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_dbmclose] = ACTIONS(2970),
    [anon_sym_exists] = ACTIONS(2970),
    [anon_sym_exit] = ACTIONS(2970),
    [anon_sym_eof] = ACTIONS(2970),
    [anon_sym_exp] = ACTIONS(2970),
    [anon_sym_each] = ACTIONS(2970),
    [anon_sym_fc] = ACTIONS(2970),
    [anon_sym_fileno] = ACTIONS(2970),
    [anon_sym_gmtime] = ACTIONS(2970),
    [anon_sym_getc] = ACTIONS(2970),
    [anon_sym_getpgrp] = ACTIONS(2970),
    [anon_sym_getprotobyname] = ACTIONS(2970),
    [anon_sym_getpwname] = ACTIONS(2970),
    [anon_sym_getpwuid] = ACTIONS(2970),
    [anon_sym_getpeername] = ACTIONS(2970),
    [anon_sym_getnetbyname] = ACTIONS(2970),
    [anon_sym_getsockname] = ACTIONS(2970),
    [anon_sym_getgrnam] = ACTIONS(2970),
    [anon_sym_getgrgid] = ACTIONS(2970),
    [anon_sym_hex] = ACTIONS(2970),
    [anon_sym_int] = ACTIONS(2970),
    [anon_sym_keys] = ACTIONS(2970),
    [anon_sym_lc] = ACTIONS(2970),
    [anon_sym_lcfirst] = ACTIONS(2970),
    [anon_sym_length] = ACTIONS(2970),
    [anon_sym_localtime] = ACTIONS(2970),
    [anon_sym_log] = ACTIONS(2970),
    [anon_sym_lock] = ACTIONS(2970),
    [anon_sym_lstat] = ACTIONS(2970),
    [anon_sym_oct] = ACTIONS(2970),
    [anon_sym_ord] = ACTIONS(2970),
    [anon_sym_prototype] = ACTIONS(2970),
    [anon_sym_pop] = ACTIONS(2970),
    [anon_sym_pos] = ACTIONS(2970),
    [anon_sym_quotemeta] = ACTIONS(2970),
    [anon_sym_reset] = ACTIONS(2970),
    [anon_sym_rand] = ACTIONS(2970),
    [anon_sym_rmdir] = ACTIONS(2970),
    [anon_sym_readdir] = ACTIONS(2970),
    [anon_sym_readline] = ACTIONS(2970),
    [anon_sym_readpipe] = ACTIONS(2970),
    [anon_sym_rewinddir] = ACTIONS(2970),
    [anon_sym_readlink] = ACTIONS(2970),
    [anon_sym_ref] = ACTIONS(2970),
    [anon_sym_scalar] = ACTIONS(2970),
    [anon_sym_shift] = ACTIONS(2970),
    [anon_sym_sin] = ACTIONS(2970),
    [anon_sym_sleep] = ACTIONS(2970),
    [anon_sym_sqrt] = ACTIONS(2970),
    [anon_sym_srand] = ACTIONS(2970),
    [anon_sym_stat] = ACTIONS(2970),
    [anon_sym_study] = ACTIONS(2970),
    [anon_sym_tell] = ACTIONS(2970),
    [anon_sym_telldir] = ACTIONS(2970),
    [anon_sym_tied] = ACTIONS(2970),
    [anon_sym_uc] = ACTIONS(2970),
    [anon_sym_ucfirst] = ACTIONS(2970),
    [anon_sym_untie] = ACTIONS(2970),
    [anon_sym_umask] = ACTIONS(2970),
    [anon_sym_values] = ACTIONS(2970),
    [anon_sym_write] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2970),
    [anon_sym___END__] = ACTIONS(2970),
    [anon_sym_q] = ACTIONS(2970),
    [anon_sym_qq] = ACTIONS(2970),
    [anon_sym_qw] = ACTIONS(2970),
    [anon_sym_qx] = ACTIONS(2970),
    [anon_sym_qr] = ACTIONS(2970),
    [anon_sym_m] = ACTIONS(2970),
    [anon_sym_s] = ACTIONS(2970),
    [anon_sym_tr] = ACTIONS(2970),
    [anon_sym_y] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_unless] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_until] = ACTIONS(2970),
    [aux_sym__bareword_token1] = ACTIONS(2970),
    [sym_number] = ACTIONS(2970),
    [sym__apostrophe] = ACTIONS(2968),
    [sym__double_quote] = ACTIONS(2968),
    [sym__backtick] = ACTIONS(2968),
    [sym__search_slash] = ACTIONS(2968),
    [sym__PERLY_HEREDOC] = ACTIONS(2968),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1030] = {
    [sym_heredoc_content] = STATE(1030),
    [ts_builtin_sym_end] = ACTIONS(3261),
    [sym__identifier] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3263),
    [anon_sym_LBRACE2] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_package] = ACTIONS(3263),
    [anon_sym_class] = ACTIONS(3263),
    [anon_sym_sub] = ACTIONS(3263),
    [anon_sym_method] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3265),
    [anon_sym_my] = ACTIONS(3263),
    [anon_sym_state] = ACTIONS(3263),
    [anon_sym_our] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_defer] = ACTIONS(3263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_elsif] = ACTIONS(3263),
    [anon_sym_and] = ACTIONS(3263),
    [anon_sym_or] = ACTIONS(3263),
    [anon_sym_DOLLAR] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_AT] = ACTIONS(3263),
    [anon_sym_LT] = ACTIONS(3263),
    [anon_sym_LT_LT] = ACTIONS(3263),
    [anon_sym_SLASH_SLASH] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3263),
    [anon_sym_eq] = ACTIONS(3263),
    [anon_sym_ne] = ACTIONS(3263),
    [anon_sym_cmp] = ACTIONS(3263),
    [anon_sym_lt] = ACTIONS(3263),
    [anon_sym_le] = ACTIONS(3263),
    [anon_sym_ge] = ACTIONS(3263),
    [anon_sym_gt] = ACTIONS(3263),
    [anon_sym_isa] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3263),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [anon_sym_BSLASH] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_eval] = ACTIONS(3263),
    [anon_sym_field] = ACTIONS(3263),
    [anon_sym_local] = ACTIONS(3263),
    [anon_sym_require] = ACTIONS(3263),
    [anon_sym_map] = ACTIONS(3263),
    [anon_sym_grep] = ACTIONS(3263),
    [anon_sym_sort] = ACTIONS(3263),
    [anon_sym_goto] = ACTIONS(3263),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_undef] = ACTIONS(3263),
    [anon_sym_PERCENT2] = ACTIONS(3263),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3263),
    [anon_sym_use] = ACTIONS(3263),
    [anon_sym_no] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_foreach] = ACTIONS(3263),
    [anon_sym_last] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3263),
    [anon_sym_redo] = ACTIONS(3263),
    [anon_sym_BEGIN] = ACTIONS(3263),
    [anon_sym_INIT] = ACTIONS(3263),
    [anon_sym_CHECK] = ACTIONS(3263),
    [anon_sym_UNITCHECK] = ACTIONS(3263),
    [anon_sym_END] = ACTIONS(3263),
    [anon_sym_ADJUST] = ACTIONS(3263),
    [anon_sym___FILE__] = ACTIONS(3263),
    [anon_sym___LINE__] = ACTIONS(3263),
    [anon_sym___PACKAGE__] = ACTIONS(3263),
    [anon_sym___SUB__] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_fork] = ACTIONS(3263),
    [anon_sym_getppid] = ACTIONS(3263),
    [anon_sym_time] = ACTIONS(3263),
    [anon_sym_times] = ACTIONS(3263),
    [anon_sym_wait] = ACTIONS(3263),
    [anon_sym_wantarray] = ACTIONS(3263),
    [anon_sym_abs] = ACTIONS(3263),
    [anon_sym_alarm] = ACTIONS(3263),
    [anon_sym_chop] = ACTIONS(3263),
    [anon_sym_chdir] = ACTIONS(3263),
    [anon_sym_close] = ACTIONS(3263),
    [anon_sym_closedir] = ACTIONS(3263),
    [anon_sym_caller] = ACTIONS(3263),
    [anon_sym_chomp] = ACTIONS(3263),
    [anon_sym_chr] = ACTIONS(3263),
    [anon_sym_cos] = ACTIONS(3263),
    [anon_sym_chroot] = ACTIONS(3263),
    [anon_sym_defined] = ACTIONS(3263),
    [anon_sym_delete] = ACTIONS(3263),
    [anon_sym_dbmclose] = ACTIONS(3263),
    [anon_sym_exists] = ACTIONS(3263),
    [anon_sym_exit] = ACTIONS(3263),
    [anon_sym_eof] = ACTIONS(3263),
    [anon_sym_exp] = ACTIONS(3263),
    [anon_sym_each] = ACTIONS(3263),
    [anon_sym_fc] = ACTIONS(3263),
    [anon_sym_fileno] = ACTIONS(3263),
    [anon_sym_gmtime] = ACTIONS(3263),
    [anon_sym_getc] = ACTIONS(3263),
    [anon_sym_getpgrp] = ACTIONS(3263),
    [anon_sym_getprotobyname] = ACTIONS(3263),
    [anon_sym_getpwname] = ACTIONS(3263),
    [anon_sym_getpwuid] = ACTIONS(3263),
    [anon_sym_getpeername] = ACTIONS(3263),
    [anon_sym_getnetbyname] = ACTIONS(3263),
    [anon_sym_getsockname] = ACTIONS(3263),
    [anon_sym_getgrnam] = ACTIONS(3263),
    [anon_sym_getgrgid] = ACTIONS(3263),
    [anon_sym_hex] = ACTIONS(3263),
    [anon_sym_int] = ACTIONS(3263),
    [anon_sym_keys] = ACTIONS(3263),
    [anon_sym_lc] = ACTIONS(3263),
    [anon_sym_lcfirst] = ACTIONS(3263),
    [anon_sym_length] = ACTIONS(3263),
    [anon_sym_localtime] = ACTIONS(3263),
    [anon_sym_log] = ACTIONS(3263),
    [anon_sym_lock] = ACTIONS(3263),
    [anon_sym_lstat] = ACTIONS(3263),
    [anon_sym_oct] = ACTIONS(3263),
    [anon_sym_ord] = ACTIONS(3263),
    [anon_sym_prototype] = ACTIONS(3263),
    [anon_sym_pop] = ACTIONS(3263),
    [anon_sym_pos] = ACTIONS(3263),
    [anon_sym_quotemeta] = ACTIONS(3263),
    [anon_sym_reset] = ACTIONS(3263),
    [anon_sym_rand] = ACTIONS(3263),
    [anon_sym_rmdir] = ACTIONS(3263),
    [anon_sym_readdir] = ACTIONS(3263),
    [anon_sym_readline] = ACTIONS(3263),
    [anon_sym_readpipe] = ACTIONS(3263),
    [anon_sym_rewinddir] = ACTIONS(3263),
    [anon_sym_readlink] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_scalar] = ACTIONS(3263),
    [anon_sym_shift] = ACTIONS(3263),
    [anon_sym_sin] = ACTIONS(3263),
    [anon_sym_sleep] = ACTIONS(3263),
    [anon_sym_sqrt] = ACTIONS(3263),
    [anon_sym_srand] = ACTIONS(3263),
    [anon_sym_stat] = ACTIONS(3263),
    [anon_sym_study] = ACTIONS(3263),
    [anon_sym_tell] = ACTIONS(3263),
    [anon_sym_telldir] = ACTIONS(3263),
    [anon_sym_tied] = ACTIONS(3263),
    [anon_sym_uc] = ACTIONS(3263),
    [anon_sym_ucfirst] = ACTIONS(3263),
    [anon_sym_untie] = ACTIONS(3263),
    [anon_sym_umask] = ACTIONS(3263),
    [anon_sym_values] = ACTIONS(3263),
    [anon_sym_write] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3263),
    [anon_sym___END__] = ACTIONS(3263),
    [anon_sym_EOT] = ACTIONS(3263),
    [anon_sym_q] = ACTIONS(3263),
    [anon_sym_qq] = ACTIONS(3263),
    [anon_sym_qw] = ACTIONS(3263),
    [anon_sym_qx] = ACTIONS(3263),
    [anon_sym_qr] = ACTIONS(3263),
    [anon_sym_m] = ACTIONS(3263),
    [anon_sym_s] = ACTIONS(3263),
    [anon_sym_tr] = ACTIONS(3263),
    [anon_sym_y] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_unless] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_until] = ACTIONS(3263),
    [aux_sym__bareword_token1] = ACTIONS(3263),
    [sym_number] = ACTIONS(3263),
    [sym__apostrophe] = ACTIONS(3261),
    [sym__double_quote] = ACTIONS(3261),
    [sym__backtick] = ACTIONS(3261),
    [sym__search_slash] = ACTIONS(3261),
    [sym__PERLY_HEREDOC] = ACTIONS(3261),
    [sym__ctrl_z_hack] = ACTIONS(3261),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1031] = {
    [sym_heredoc_content] = STATE(1031),
    [ts_builtin_sym_end] = ACTIONS(3268),
    [sym__identifier] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_LBRACE2] = ACTIONS(3270),
    [anon_sym_SEMI] = ACTIONS(3270),
    [anon_sym_package] = ACTIONS(3270),
    [anon_sym_class] = ACTIONS(3270),
    [anon_sym_sub] = ACTIONS(3270),
    [anon_sym_method] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_my] = ACTIONS(3270),
    [anon_sym_state] = ACTIONS(3270),
    [anon_sym_our] = ACTIONS(3270),
    [anon_sym_try] = ACTIONS(3270),
    [anon_sym_defer] = ACTIONS(3270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3270),
    [anon_sym_else] = ACTIONS(3270),
    [anon_sym_elsif] = ACTIONS(3270),
    [anon_sym_and] = ACTIONS(3270),
    [anon_sym_or] = ACTIONS(3270),
    [anon_sym_DOLLAR] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_AT] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_eq] = ACTIONS(3270),
    [anon_sym_ne] = ACTIONS(3270),
    [anon_sym_cmp] = ACTIONS(3270),
    [anon_sym_lt] = ACTIONS(3270),
    [anon_sym_le] = ACTIONS(3270),
    [anon_sym_ge] = ACTIONS(3270),
    [anon_sym_gt] = ACTIONS(3270),
    [anon_sym_isa] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_BSLASH] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3270),
    [anon_sym_eval] = ACTIONS(3270),
    [anon_sym_field] = ACTIONS(3270),
    [anon_sym_local] = ACTIONS(3270),
    [anon_sym_require] = ACTIONS(3270),
    [anon_sym_map] = ACTIONS(3270),
    [anon_sym_grep] = ACTIONS(3270),
    [anon_sym_sort] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_undef] = ACTIONS(3270),
    [anon_sym_PERCENT2] = ACTIONS(3270),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3270),
    [anon_sym_use] = ACTIONS(3270),
    [anon_sym_no] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_foreach] = ACTIONS(3270),
    [anon_sym_last] = ACTIONS(3270),
    [anon_sym_next] = ACTIONS(3270),
    [anon_sym_redo] = ACTIONS(3270),
    [anon_sym_BEGIN] = ACTIONS(3270),
    [anon_sym_INIT] = ACTIONS(3270),
    [anon_sym_CHECK] = ACTIONS(3270),
    [anon_sym_UNITCHECK] = ACTIONS(3270),
    [anon_sym_END] = ACTIONS(3270),
    [anon_sym_ADJUST] = ACTIONS(3270),
    [anon_sym___FILE__] = ACTIONS(3270),
    [anon_sym___LINE__] = ACTIONS(3270),
    [anon_sym___PACKAGE__] = ACTIONS(3270),
    [anon_sym___SUB__] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_fork] = ACTIONS(3270),
    [anon_sym_getppid] = ACTIONS(3270),
    [anon_sym_time] = ACTIONS(3270),
    [anon_sym_times] = ACTIONS(3270),
    [anon_sym_wait] = ACTIONS(3270),
    [anon_sym_wantarray] = ACTIONS(3270),
    [anon_sym_abs] = ACTIONS(3270),
    [anon_sym_alarm] = ACTIONS(3270),
    [anon_sym_chop] = ACTIONS(3270),
    [anon_sym_chdir] = ACTIONS(3270),
    [anon_sym_close] = ACTIONS(3270),
    [anon_sym_closedir] = ACTIONS(3270),
    [anon_sym_caller] = ACTIONS(3270),
    [anon_sym_chomp] = ACTIONS(3270),
    [anon_sym_chr] = ACTIONS(3270),
    [anon_sym_cos] = ACTIONS(3270),
    [anon_sym_chroot] = ACTIONS(3270),
    [anon_sym_defined] = ACTIONS(3270),
    [anon_sym_delete] = ACTIONS(3270),
    [anon_sym_dbmclose] = ACTIONS(3270),
    [anon_sym_exists] = ACTIONS(3270),
    [anon_sym_exit] = ACTIONS(3270),
    [anon_sym_eof] = ACTIONS(3270),
    [anon_sym_exp] = ACTIONS(3270),
    [anon_sym_each] = ACTIONS(3270),
    [anon_sym_fc] = ACTIONS(3270),
    [anon_sym_fileno] = ACTIONS(3270),
    [anon_sym_gmtime] = ACTIONS(3270),
    [anon_sym_getc] = ACTIONS(3270),
    [anon_sym_getpgrp] = ACTIONS(3270),
    [anon_sym_getprotobyname] = ACTIONS(3270),
    [anon_sym_getpwname] = ACTIONS(3270),
    [anon_sym_getpwuid] = ACTIONS(3270),
    [anon_sym_getpeername] = ACTIONS(3270),
    [anon_sym_getnetbyname] = ACTIONS(3270),
    [anon_sym_getsockname] = ACTIONS(3270),
    [anon_sym_getgrnam] = ACTIONS(3270),
    [anon_sym_getgrgid] = ACTIONS(3270),
    [anon_sym_hex] = ACTIONS(3270),
    [anon_sym_int] = ACTIONS(3270),
    [anon_sym_keys] = ACTIONS(3270),
    [anon_sym_lc] = ACTIONS(3270),
    [anon_sym_lcfirst] = ACTIONS(3270),
    [anon_sym_length] = ACTIONS(3270),
    [anon_sym_localtime] = ACTIONS(3270),
    [anon_sym_log] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_lstat] = ACTIONS(3270),
    [anon_sym_oct] = ACTIONS(3270),
    [anon_sym_ord] = ACTIONS(3270),
    [anon_sym_prototype] = ACTIONS(3270),
    [anon_sym_pop] = ACTIONS(3270),
    [anon_sym_pos] = ACTIONS(3270),
    [anon_sym_quotemeta] = ACTIONS(3270),
    [anon_sym_reset] = ACTIONS(3270),
    [anon_sym_rand] = ACTIONS(3270),
    [anon_sym_rmdir] = ACTIONS(3270),
    [anon_sym_readdir] = ACTIONS(3270),
    [anon_sym_readline] = ACTIONS(3270),
    [anon_sym_readpipe] = ACTIONS(3270),
    [anon_sym_rewinddir] = ACTIONS(3270),
    [anon_sym_readlink] = ACTIONS(3270),
    [anon_sym_ref] = ACTIONS(3270),
    [anon_sym_scalar] = ACTIONS(3270),
    [anon_sym_shift] = ACTIONS(3270),
    [anon_sym_sin] = ACTIONS(3270),
    [anon_sym_sleep] = ACTIONS(3270),
    [anon_sym_sqrt] = ACTIONS(3270),
    [anon_sym_srand] = ACTIONS(3270),
    [anon_sym_stat] = ACTIONS(3270),
    [anon_sym_study] = ACTIONS(3270),
    [anon_sym_tell] = ACTIONS(3270),
    [anon_sym_telldir] = ACTIONS(3270),
    [anon_sym_tied] = ACTIONS(3270),
    [anon_sym_uc] = ACTIONS(3270),
    [anon_sym_ucfirst] = ACTIONS(3270),
    [anon_sym_untie] = ACTIONS(3270),
    [anon_sym_umask] = ACTIONS(3270),
    [anon_sym_values] = ACTIONS(3270),
    [anon_sym_write] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3270),
    [anon_sym___END__] = ACTIONS(3270),
    [anon_sym_EOT] = ACTIONS(3270),
    [anon_sym_q] = ACTIONS(3270),
    [anon_sym_qq] = ACTIONS(3270),
    [anon_sym_qw] = ACTIONS(3270),
    [anon_sym_qx] = ACTIONS(3270),
    [anon_sym_qr] = ACTIONS(3270),
    [anon_sym_m] = ACTIONS(3270),
    [anon_sym_s] = ACTIONS(3270),
    [anon_sym_tr] = ACTIONS(3270),
    [anon_sym_y] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_unless] = ACTIONS(3270),
    [anon_sym_while] = ACTIONS(3270),
    [anon_sym_until] = ACTIONS(3270),
    [aux_sym__bareword_token1] = ACTIONS(3270),
    [sym_number] = ACTIONS(3270),
    [sym__apostrophe] = ACTIONS(3268),
    [sym__double_quote] = ACTIONS(3268),
    [sym__backtick] = ACTIONS(3268),
    [sym__search_slash] = ACTIONS(3268),
    [sym__PERLY_HEREDOC] = ACTIONS(3268),
    [sym__ctrl_z_hack] = ACTIONS(3268),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1032] = {
    [sym_heredoc_content] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_LBRACE2] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_package] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_defer] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_EOT] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym__ctrl_z_hack] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1033] = {
    [sym_heredoc_content] = STATE(1033),
    [ts_builtin_sym_end] = ACTIONS(3272),
    [sym__identifier] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LBRACE2] = ACTIONS(3274),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_package] = ACTIONS(3274),
    [anon_sym_class] = ACTIONS(3274),
    [anon_sym_sub] = ACTIONS(3274),
    [anon_sym_method] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_my] = ACTIONS(3274),
    [anon_sym_state] = ACTIONS(3274),
    [anon_sym_our] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_defer] = ACTIONS(3274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3274),
    [anon_sym_else] = ACTIONS(3274),
    [anon_sym_elsif] = ACTIONS(3274),
    [anon_sym_and] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_AT] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_SLASH_SLASH] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_eq] = ACTIONS(3274),
    [anon_sym_ne] = ACTIONS(3274),
    [anon_sym_cmp] = ACTIONS(3274),
    [anon_sym_lt] = ACTIONS(3274),
    [anon_sym_le] = ACTIONS(3274),
    [anon_sym_ge] = ACTIONS(3274),
    [anon_sym_gt] = ACTIONS(3274),
    [anon_sym_isa] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_BSLASH] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_eval] = ACTIONS(3274),
    [anon_sym_field] = ACTIONS(3274),
    [anon_sym_local] = ACTIONS(3274),
    [anon_sym_require] = ACTIONS(3274),
    [anon_sym_map] = ACTIONS(3274),
    [anon_sym_grep] = ACTIONS(3274),
    [anon_sym_sort] = ACTIONS(3274),
    [anon_sym_goto] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_undef] = ACTIONS(3274),
    [anon_sym_PERCENT2] = ACTIONS(3274),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_no] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_foreach] = ACTIONS(3274),
    [anon_sym_last] = ACTIONS(3274),
    [anon_sym_next] = ACTIONS(3274),
    [anon_sym_redo] = ACTIONS(3274),
    [anon_sym_BEGIN] = ACTIONS(3274),
    [anon_sym_INIT] = ACTIONS(3274),
    [anon_sym_CHECK] = ACTIONS(3274),
    [anon_sym_UNITCHECK] = ACTIONS(3274),
    [anon_sym_END] = ACTIONS(3274),
    [anon_sym_ADJUST] = ACTIONS(3274),
    [anon_sym___FILE__] = ACTIONS(3274),
    [anon_sym___LINE__] = ACTIONS(3274),
    [anon_sym___PACKAGE__] = ACTIONS(3274),
    [anon_sym___SUB__] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_fork] = ACTIONS(3274),
    [anon_sym_getppid] = ACTIONS(3274),
    [anon_sym_time] = ACTIONS(3274),
    [anon_sym_times] = ACTIONS(3274),
    [anon_sym_wait] = ACTIONS(3274),
    [anon_sym_wantarray] = ACTIONS(3274),
    [anon_sym_abs] = ACTIONS(3274),
    [anon_sym_alarm] = ACTIONS(3274),
    [anon_sym_chop] = ACTIONS(3274),
    [anon_sym_chdir] = ACTIONS(3274),
    [anon_sym_close] = ACTIONS(3274),
    [anon_sym_closedir] = ACTIONS(3274),
    [anon_sym_caller] = ACTIONS(3274),
    [anon_sym_chomp] = ACTIONS(3274),
    [anon_sym_chr] = ACTIONS(3274),
    [anon_sym_cos] = ACTIONS(3274),
    [anon_sym_chroot] = ACTIONS(3274),
    [anon_sym_defined] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3274),
    [anon_sym_dbmclose] = ACTIONS(3274),
    [anon_sym_exists] = ACTIONS(3274),
    [anon_sym_exit] = ACTIONS(3274),
    [anon_sym_eof] = ACTIONS(3274),
    [anon_sym_exp] = ACTIONS(3274),
    [anon_sym_each] = ACTIONS(3274),
    [anon_sym_fc] = ACTIONS(3274),
    [anon_sym_fileno] = ACTIONS(3274),
    [anon_sym_gmtime] = ACTIONS(3274),
    [anon_sym_getc] = ACTIONS(3274),
    [anon_sym_getpgrp] = ACTIONS(3274),
    [anon_sym_getprotobyname] = ACTIONS(3274),
    [anon_sym_getpwname] = ACTIONS(3274),
    [anon_sym_getpwuid] = ACTIONS(3274),
    [anon_sym_getpeername] = ACTIONS(3274),
    [anon_sym_getnetbyname] = ACTIONS(3274),
    [anon_sym_getsockname] = ACTIONS(3274),
    [anon_sym_getgrnam] = ACTIONS(3274),
    [anon_sym_getgrgid] = ACTIONS(3274),
    [anon_sym_hex] = ACTIONS(3274),
    [anon_sym_int] = ACTIONS(3274),
    [anon_sym_keys] = ACTIONS(3274),
    [anon_sym_lc] = ACTIONS(3274),
    [anon_sym_lcfirst] = ACTIONS(3274),
    [anon_sym_length] = ACTIONS(3274),
    [anon_sym_localtime] = ACTIONS(3274),
    [anon_sym_log] = ACTIONS(3274),
    [anon_sym_lock] = ACTIONS(3274),
    [anon_sym_lstat] = ACTIONS(3274),
    [anon_sym_oct] = ACTIONS(3274),
    [anon_sym_ord] = ACTIONS(3274),
    [anon_sym_prototype] = ACTIONS(3274),
    [anon_sym_pop] = ACTIONS(3274),
    [anon_sym_pos] = ACTIONS(3274),
    [anon_sym_quotemeta] = ACTIONS(3274),
    [anon_sym_reset] = ACTIONS(3274),
    [anon_sym_rand] = ACTIONS(3274),
    [anon_sym_rmdir] = ACTIONS(3274),
    [anon_sym_readdir] = ACTIONS(3274),
    [anon_sym_readline] = ACTIONS(3274),
    [anon_sym_readpipe] = ACTIONS(3274),
    [anon_sym_rewinddir] = ACTIONS(3274),
    [anon_sym_readlink] = ACTIONS(3274),
    [anon_sym_ref] = ACTIONS(3274),
    [anon_sym_scalar] = ACTIONS(3274),
    [anon_sym_shift] = ACTIONS(3274),
    [anon_sym_sin] = ACTIONS(3274),
    [anon_sym_sleep] = ACTIONS(3274),
    [anon_sym_sqrt] = ACTIONS(3274),
    [anon_sym_srand] = ACTIONS(3274),
    [anon_sym_stat] = ACTIONS(3274),
    [anon_sym_study] = ACTIONS(3274),
    [anon_sym_tell] = ACTIONS(3274),
    [anon_sym_telldir] = ACTIONS(3274),
    [anon_sym_tied] = ACTIONS(3274),
    [anon_sym_uc] = ACTIONS(3274),
    [anon_sym_ucfirst] = ACTIONS(3274),
    [anon_sym_untie] = ACTIONS(3274),
    [anon_sym_umask] = ACTIONS(3274),
    [anon_sym_values] = ACTIONS(3274),
    [anon_sym_write] = ACTIONS(3274),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3274),
    [anon_sym___END__] = ACTIONS(3274),
    [anon_sym_EOT] = ACTIONS(3274),
    [anon_sym_q] = ACTIONS(3274),
    [anon_sym_qq] = ACTIONS(3274),
    [anon_sym_qw] = ACTIONS(3274),
    [anon_sym_qx] = ACTIONS(3274),
    [anon_sym_qr] = ACTIONS(3274),
    [anon_sym_m] = ACTIONS(3274),
    [anon_sym_s] = ACTIONS(3274),
    [anon_sym_tr] = ACTIONS(3274),
    [anon_sym_y] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_unless] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_until] = ACTIONS(3274),
    [aux_sym__bareword_token1] = ACTIONS(3274),
    [sym_number] = ACTIONS(3274),
    [sym__apostrophe] = ACTIONS(3272),
    [sym__double_quote] = ACTIONS(3272),
    [sym__backtick] = ACTIONS(3272),
    [sym__search_slash] = ACTIONS(3272),
    [sym__PERLY_HEREDOC] = ACTIONS(3272),
    [sym__ctrl_z_hack] = ACTIONS(3272),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1034] = {
    [sym_heredoc_content] = STATE(1034),
    [ts_builtin_sym_end] = ACTIONS(3279),
    [sym__identifier] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LBRACE2] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_package] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_sub] = ACTIONS(3281),
    [anon_sym_method] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_my] = ACTIONS(3281),
    [anon_sym_state] = ACTIONS(3281),
    [anon_sym_our] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_defer] = ACTIONS(3281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_elsif] = ACTIONS(3281),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_AT] = ACTIONS(3281),
    [anon_sym_LT] = ACTIONS(3281),
    [anon_sym_LT_LT] = ACTIONS(3281),
    [anon_sym_SLASH_SLASH] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_eq] = ACTIONS(3281),
    [anon_sym_ne] = ACTIONS(3281),
    [anon_sym_cmp] = ACTIONS(3281),
    [anon_sym_lt] = ACTIONS(3281),
    [anon_sym_le] = ACTIONS(3281),
    [anon_sym_ge] = ACTIONS(3281),
    [anon_sym_gt] = ACTIONS(3281),
    [anon_sym_isa] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_BSLASH] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_eval] = ACTIONS(3281),
    [anon_sym_field] = ACTIONS(3281),
    [anon_sym_local] = ACTIONS(3281),
    [anon_sym_require] = ACTIONS(3281),
    [anon_sym_map] = ACTIONS(3281),
    [anon_sym_grep] = ACTIONS(3281),
    [anon_sym_sort] = ACTIONS(3281),
    [anon_sym_goto] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_undef] = ACTIONS(3281),
    [anon_sym_PERCENT2] = ACTIONS(3281),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3281),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_no] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_foreach] = ACTIONS(3281),
    [anon_sym_last] = ACTIONS(3281),
    [anon_sym_next] = ACTIONS(3281),
    [anon_sym_redo] = ACTIONS(3281),
    [anon_sym_BEGIN] = ACTIONS(3281),
    [anon_sym_INIT] = ACTIONS(3281),
    [anon_sym_CHECK] = ACTIONS(3281),
    [anon_sym_UNITCHECK] = ACTIONS(3281),
    [anon_sym_END] = ACTIONS(3281),
    [anon_sym_ADJUST] = ACTIONS(3281),
    [anon_sym___FILE__] = ACTIONS(3281),
    [anon_sym___LINE__] = ACTIONS(3281),
    [anon_sym___PACKAGE__] = ACTIONS(3281),
    [anon_sym___SUB__] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_fork] = ACTIONS(3281),
    [anon_sym_getppid] = ACTIONS(3281),
    [anon_sym_time] = ACTIONS(3281),
    [anon_sym_times] = ACTIONS(3281),
    [anon_sym_wait] = ACTIONS(3281),
    [anon_sym_wantarray] = ACTIONS(3281),
    [anon_sym_abs] = ACTIONS(3281),
    [anon_sym_alarm] = ACTIONS(3281),
    [anon_sym_chop] = ACTIONS(3281),
    [anon_sym_chdir] = ACTIONS(3281),
    [anon_sym_close] = ACTIONS(3281),
    [anon_sym_closedir] = ACTIONS(3281),
    [anon_sym_caller] = ACTIONS(3281),
    [anon_sym_chomp] = ACTIONS(3281),
    [anon_sym_chr] = ACTIONS(3281),
    [anon_sym_cos] = ACTIONS(3281),
    [anon_sym_chroot] = ACTIONS(3281),
    [anon_sym_defined] = ACTIONS(3281),
    [anon_sym_delete] = ACTIONS(3281),
    [anon_sym_dbmclose] = ACTIONS(3281),
    [anon_sym_exists] = ACTIONS(3281),
    [anon_sym_exit] = ACTIONS(3281),
    [anon_sym_eof] = ACTIONS(3281),
    [anon_sym_exp] = ACTIONS(3281),
    [anon_sym_each] = ACTIONS(3281),
    [anon_sym_fc] = ACTIONS(3281),
    [anon_sym_fileno] = ACTIONS(3281),
    [anon_sym_gmtime] = ACTIONS(3281),
    [anon_sym_getc] = ACTIONS(3281),
    [anon_sym_getpgrp] = ACTIONS(3281),
    [anon_sym_getprotobyname] = ACTIONS(3281),
    [anon_sym_getpwname] = ACTIONS(3281),
    [anon_sym_getpwuid] = ACTIONS(3281),
    [anon_sym_getpeername] = ACTIONS(3281),
    [anon_sym_getnetbyname] = ACTIONS(3281),
    [anon_sym_getsockname] = ACTIONS(3281),
    [anon_sym_getgrnam] = ACTIONS(3281),
    [anon_sym_getgrgid] = ACTIONS(3281),
    [anon_sym_hex] = ACTIONS(3281),
    [anon_sym_int] = ACTIONS(3281),
    [anon_sym_keys] = ACTIONS(3281),
    [anon_sym_lc] = ACTIONS(3281),
    [anon_sym_lcfirst] = ACTIONS(3281),
    [anon_sym_length] = ACTIONS(3281),
    [anon_sym_localtime] = ACTIONS(3281),
    [anon_sym_log] = ACTIONS(3281),
    [anon_sym_lock] = ACTIONS(3281),
    [anon_sym_lstat] = ACTIONS(3281),
    [anon_sym_oct] = ACTIONS(3281),
    [anon_sym_ord] = ACTIONS(3281),
    [anon_sym_prototype] = ACTIONS(3281),
    [anon_sym_pop] = ACTIONS(3281),
    [anon_sym_pos] = ACTIONS(3281),
    [anon_sym_quotemeta] = ACTIONS(3281),
    [anon_sym_reset] = ACTIONS(3281),
    [anon_sym_rand] = ACTIONS(3281),
    [anon_sym_rmdir] = ACTIONS(3281),
    [anon_sym_readdir] = ACTIONS(3281),
    [anon_sym_readline] = ACTIONS(3281),
    [anon_sym_readpipe] = ACTIONS(3281),
    [anon_sym_rewinddir] = ACTIONS(3281),
    [anon_sym_readlink] = ACTIONS(3281),
    [anon_sym_ref] = ACTIONS(3281),
    [anon_sym_scalar] = ACTIONS(3281),
    [anon_sym_shift] = ACTIONS(3281),
    [anon_sym_sin] = ACTIONS(3281),
    [anon_sym_sleep] = ACTIONS(3281),
    [anon_sym_sqrt] = ACTIONS(3281),
    [anon_sym_srand] = ACTIONS(3281),
    [anon_sym_stat] = ACTIONS(3281),
    [anon_sym_study] = ACTIONS(3281),
    [anon_sym_tell] = ACTIONS(3281),
    [anon_sym_telldir] = ACTIONS(3281),
    [anon_sym_tied] = ACTIONS(3281),
    [anon_sym_uc] = ACTIONS(3281),
    [anon_sym_ucfirst] = ACTIONS(3281),
    [anon_sym_untie] = ACTIONS(3281),
    [anon_sym_umask] = ACTIONS(3281),
    [anon_sym_values] = ACTIONS(3281),
    [anon_sym_write] = ACTIONS(3281),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3281),
    [anon_sym___END__] = ACTIONS(3281),
    [anon_sym_EOT] = ACTIONS(3281),
    [anon_sym_q] = ACTIONS(3281),
    [anon_sym_qq] = ACTIONS(3281),
    [anon_sym_qw] = ACTIONS(3281),
    [anon_sym_qx] = ACTIONS(3281),
    [anon_sym_qr] = ACTIONS(3281),
    [anon_sym_m] = ACTIONS(3281),
    [anon_sym_s] = ACTIONS(3281),
    [anon_sym_tr] = ACTIONS(3281),
    [anon_sym_y] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [aux_sym__bareword_token1] = ACTIONS(3281),
    [sym_number] = ACTIONS(3281),
    [sym__apostrophe] = ACTIONS(3279),
    [sym__double_quote] = ACTIONS(3279),
    [sym__backtick] = ACTIONS(3279),
    [sym__search_slash] = ACTIONS(3279),
    [sym__PERLY_HEREDOC] = ACTIONS(3279),
    [sym__ctrl_z_hack] = ACTIONS(3279),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1035] = {
    [sym_heredoc_content] = STATE(1035),
    [ts_builtin_sym_end] = ACTIONS(3283),
    [sym__identifier] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LBRACE2] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_package] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_sub] = ACTIONS(3285),
    [anon_sym_method] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_my] = ACTIONS(3285),
    [anon_sym_state] = ACTIONS(3285),
    [anon_sym_our] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_defer] = ACTIONS(3285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_elsif] = ACTIONS(3285),
    [anon_sym_and] = ACTIONS(3285),
    [anon_sym_or] = ACTIONS(3285),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_LT_LT] = ACTIONS(3285),
    [anon_sym_SLASH_SLASH] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_eq] = ACTIONS(3285),
    [anon_sym_ne] = ACTIONS(3285),
    [anon_sym_cmp] = ACTIONS(3285),
    [anon_sym_lt] = ACTIONS(3285),
    [anon_sym_le] = ACTIONS(3285),
    [anon_sym_ge] = ACTIONS(3285),
    [anon_sym_gt] = ACTIONS(3285),
    [anon_sym_isa] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_BSLASH] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_eval] = ACTIONS(3285),
    [anon_sym_field] = ACTIONS(3285),
    [anon_sym_local] = ACTIONS(3285),
    [anon_sym_require] = ACTIONS(3285),
    [anon_sym_map] = ACTIONS(3285),
    [anon_sym_grep] = ACTIONS(3285),
    [anon_sym_sort] = ACTIONS(3285),
    [anon_sym_goto] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_undef] = ACTIONS(3285),
    [anon_sym_PERCENT2] = ACTIONS(3285),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_no] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_foreach] = ACTIONS(3285),
    [anon_sym_last] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3285),
    [anon_sym_redo] = ACTIONS(3285),
    [anon_sym_BEGIN] = ACTIONS(3285),
    [anon_sym_INIT] = ACTIONS(3285),
    [anon_sym_CHECK] = ACTIONS(3285),
    [anon_sym_UNITCHECK] = ACTIONS(3285),
    [anon_sym_END] = ACTIONS(3285),
    [anon_sym_ADJUST] = ACTIONS(3285),
    [anon_sym___FILE__] = ACTIONS(3285),
    [anon_sym___LINE__] = ACTIONS(3285),
    [anon_sym___PACKAGE__] = ACTIONS(3285),
    [anon_sym___SUB__] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_fork] = ACTIONS(3285),
    [anon_sym_getppid] = ACTIONS(3285),
    [anon_sym_time] = ACTIONS(3285),
    [anon_sym_times] = ACTIONS(3285),
    [anon_sym_wait] = ACTIONS(3285),
    [anon_sym_wantarray] = ACTIONS(3285),
    [anon_sym_abs] = ACTIONS(3285),
    [anon_sym_alarm] = ACTIONS(3285),
    [anon_sym_chop] = ACTIONS(3285),
    [anon_sym_chdir] = ACTIONS(3285),
    [anon_sym_close] = ACTIONS(3285),
    [anon_sym_closedir] = ACTIONS(3285),
    [anon_sym_caller] = ACTIONS(3285),
    [anon_sym_chomp] = ACTIONS(3285),
    [anon_sym_chr] = ACTIONS(3285),
    [anon_sym_cos] = ACTIONS(3285),
    [anon_sym_chroot] = ACTIONS(3285),
    [anon_sym_defined] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_dbmclose] = ACTIONS(3285),
    [anon_sym_exists] = ACTIONS(3285),
    [anon_sym_exit] = ACTIONS(3285),
    [anon_sym_eof] = ACTIONS(3285),
    [anon_sym_exp] = ACTIONS(3285),
    [anon_sym_each] = ACTIONS(3285),
    [anon_sym_fc] = ACTIONS(3285),
    [anon_sym_fileno] = ACTIONS(3285),
    [anon_sym_gmtime] = ACTIONS(3285),
    [anon_sym_getc] = ACTIONS(3285),
    [anon_sym_getpgrp] = ACTIONS(3285),
    [anon_sym_getprotobyname] = ACTIONS(3285),
    [anon_sym_getpwname] = ACTIONS(3285),
    [anon_sym_getpwuid] = ACTIONS(3285),
    [anon_sym_getpeername] = ACTIONS(3285),
    [anon_sym_getnetbyname] = ACTIONS(3285),
    [anon_sym_getsockname] = ACTIONS(3285),
    [anon_sym_getgrnam] = ACTIONS(3285),
    [anon_sym_getgrgid] = ACTIONS(3285),
    [anon_sym_hex] = ACTIONS(3285),
    [anon_sym_int] = ACTIONS(3285),
    [anon_sym_keys] = ACTIONS(3285),
    [anon_sym_lc] = ACTIONS(3285),
    [anon_sym_lcfirst] = ACTIONS(3285),
    [anon_sym_length] = ACTIONS(3285),
    [anon_sym_localtime] = ACTIONS(3285),
    [anon_sym_log] = ACTIONS(3285),
    [anon_sym_lock] = ACTIONS(3285),
    [anon_sym_lstat] = ACTIONS(3285),
    [anon_sym_oct] = ACTIONS(3285),
    [anon_sym_ord] = ACTIONS(3285),
    [anon_sym_prototype] = ACTIONS(3285),
    [anon_sym_pop] = ACTIONS(3285),
    [anon_sym_pos] = ACTIONS(3285),
    [anon_sym_quotemeta] = ACTIONS(3285),
    [anon_sym_reset] = ACTIONS(3285),
    [anon_sym_rand] = ACTIONS(3285),
    [anon_sym_rmdir] = ACTIONS(3285),
    [anon_sym_readdir] = ACTIONS(3285),
    [anon_sym_readline] = ACTIONS(3285),
    [anon_sym_readpipe] = ACTIONS(3285),
    [anon_sym_rewinddir] = ACTIONS(3285),
    [anon_sym_readlink] = ACTIONS(3285),
    [anon_sym_ref] = ACTIONS(3285),
    [anon_sym_scalar] = ACTIONS(3285),
    [anon_sym_shift] = ACTIONS(3285),
    [anon_sym_sin] = ACTIONS(3285),
    [anon_sym_sleep] = ACTIONS(3285),
    [anon_sym_sqrt] = ACTIONS(3285),
    [anon_sym_srand] = ACTIONS(3285),
    [anon_sym_stat] = ACTIONS(3285),
    [anon_sym_study] = ACTIONS(3285),
    [anon_sym_tell] = ACTIONS(3285),
    [anon_sym_telldir] = ACTIONS(3285),
    [anon_sym_tied] = ACTIONS(3285),
    [anon_sym_uc] = ACTIONS(3285),
    [anon_sym_ucfirst] = ACTIONS(3285),
    [anon_sym_untie] = ACTIONS(3285),
    [anon_sym_umask] = ACTIONS(3285),
    [anon_sym_values] = ACTIONS(3285),
    [anon_sym_write] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3285),
    [anon_sym___END__] = ACTIONS(3285),
    [anon_sym_EOT] = ACTIONS(3285),
    [anon_sym_q] = ACTIONS(3285),
    [anon_sym_qq] = ACTIONS(3285),
    [anon_sym_qw] = ACTIONS(3285),
    [anon_sym_qx] = ACTIONS(3285),
    [anon_sym_qr] = ACTIONS(3285),
    [anon_sym_m] = ACTIONS(3285),
    [anon_sym_s] = ACTIONS(3285),
    [anon_sym_tr] = ACTIONS(3285),
    [anon_sym_y] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_unless] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_until] = ACTIONS(3285),
    [aux_sym__bareword_token1] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym__apostrophe] = ACTIONS(3283),
    [sym__double_quote] = ACTIONS(3283),
    [sym__backtick] = ACTIONS(3283),
    [sym__search_slash] = ACTIONS(3283),
    [sym__PERLY_HEREDOC] = ACTIONS(3283),
    [sym__ctrl_z_hack] = ACTIONS(3283),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1036] = {
    [sym_heredoc_content] = STATE(1036),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym__identifier] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_LBRACE2] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_package] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_sub] = ACTIONS(3289),
    [anon_sym_method] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_my] = ACTIONS(3289),
    [anon_sym_state] = ACTIONS(3289),
    [anon_sym_our] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_defer] = ACTIONS(3289),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_elsif] = ACTIONS(3289),
    [anon_sym_and] = ACTIONS(3289),
    [anon_sym_or] = ACTIONS(3289),
    [anon_sym_DOLLAR] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_LT_LT] = ACTIONS(3289),
    [anon_sym_SLASH_SLASH] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_eq] = ACTIONS(3289),
    [anon_sym_ne] = ACTIONS(3289),
    [anon_sym_cmp] = ACTIONS(3289),
    [anon_sym_lt] = ACTIONS(3289),
    [anon_sym_le] = ACTIONS(3289),
    [anon_sym_ge] = ACTIONS(3289),
    [anon_sym_gt] = ACTIONS(3289),
    [anon_sym_isa] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_BSLASH] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_eval] = ACTIONS(3289),
    [anon_sym_field] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3289),
    [anon_sym_require] = ACTIONS(3289),
    [anon_sym_map] = ACTIONS(3289),
    [anon_sym_grep] = ACTIONS(3289),
    [anon_sym_sort] = ACTIONS(3289),
    [anon_sym_goto] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_undef] = ACTIONS(3289),
    [anon_sym_PERCENT2] = ACTIONS(3289),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3289),
    [anon_sym_use] = ACTIONS(3289),
    [anon_sym_no] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_foreach] = ACTIONS(3289),
    [anon_sym_last] = ACTIONS(3289),
    [anon_sym_next] = ACTIONS(3289),
    [anon_sym_redo] = ACTIONS(3289),
    [anon_sym_BEGIN] = ACTIONS(3289),
    [anon_sym_INIT] = ACTIONS(3289),
    [anon_sym_CHECK] = ACTIONS(3289),
    [anon_sym_UNITCHECK] = ACTIONS(3289),
    [anon_sym_END] = ACTIONS(3289),
    [anon_sym_ADJUST] = ACTIONS(3289),
    [anon_sym___FILE__] = ACTIONS(3289),
    [anon_sym___LINE__] = ACTIONS(3289),
    [anon_sym___PACKAGE__] = ACTIONS(3289),
    [anon_sym___SUB__] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_fork] = ACTIONS(3289),
    [anon_sym_getppid] = ACTIONS(3289),
    [anon_sym_time] = ACTIONS(3289),
    [anon_sym_times] = ACTIONS(3289),
    [anon_sym_wait] = ACTIONS(3289),
    [anon_sym_wantarray] = ACTIONS(3289),
    [anon_sym_abs] = ACTIONS(3289),
    [anon_sym_alarm] = ACTIONS(3289),
    [anon_sym_chop] = ACTIONS(3289),
    [anon_sym_chdir] = ACTIONS(3289),
    [anon_sym_close] = ACTIONS(3289),
    [anon_sym_closedir] = ACTIONS(3289),
    [anon_sym_caller] = ACTIONS(3289),
    [anon_sym_chomp] = ACTIONS(3289),
    [anon_sym_chr] = ACTIONS(3289),
    [anon_sym_cos] = ACTIONS(3289),
    [anon_sym_chroot] = ACTIONS(3289),
    [anon_sym_defined] = ACTIONS(3289),
    [anon_sym_delete] = ACTIONS(3289),
    [anon_sym_dbmclose] = ACTIONS(3289),
    [anon_sym_exists] = ACTIONS(3289),
    [anon_sym_exit] = ACTIONS(3289),
    [anon_sym_eof] = ACTIONS(3289),
    [anon_sym_exp] = ACTIONS(3289),
    [anon_sym_each] = ACTIONS(3289),
    [anon_sym_fc] = ACTIONS(3289),
    [anon_sym_fileno] = ACTIONS(3289),
    [anon_sym_gmtime] = ACTIONS(3289),
    [anon_sym_getc] = ACTIONS(3289),
    [anon_sym_getpgrp] = ACTIONS(3289),
    [anon_sym_getprotobyname] = ACTIONS(3289),
    [anon_sym_getpwname] = ACTIONS(3289),
    [anon_sym_getpwuid] = ACTIONS(3289),
    [anon_sym_getpeername] = ACTIONS(3289),
    [anon_sym_getnetbyname] = ACTIONS(3289),
    [anon_sym_getsockname] = ACTIONS(3289),
    [anon_sym_getgrnam] = ACTIONS(3289),
    [anon_sym_getgrgid] = ACTIONS(3289),
    [anon_sym_hex] = ACTIONS(3289),
    [anon_sym_int] = ACTIONS(3289),
    [anon_sym_keys] = ACTIONS(3289),
    [anon_sym_lc] = ACTIONS(3289),
    [anon_sym_lcfirst] = ACTIONS(3289),
    [anon_sym_length] = ACTIONS(3289),
    [anon_sym_localtime] = ACTIONS(3289),
    [anon_sym_log] = ACTIONS(3289),
    [anon_sym_lock] = ACTIONS(3289),
    [anon_sym_lstat] = ACTIONS(3289),
    [anon_sym_oct] = ACTIONS(3289),
    [anon_sym_ord] = ACTIONS(3289),
    [anon_sym_prototype] = ACTIONS(3289),
    [anon_sym_pop] = ACTIONS(3289),
    [anon_sym_pos] = ACTIONS(3289),
    [anon_sym_quotemeta] = ACTIONS(3289),
    [anon_sym_reset] = ACTIONS(3289),
    [anon_sym_rand] = ACTIONS(3289),
    [anon_sym_rmdir] = ACTIONS(3289),
    [anon_sym_readdir] = ACTIONS(3289),
    [anon_sym_readline] = ACTIONS(3289),
    [anon_sym_readpipe] = ACTIONS(3289),
    [anon_sym_rewinddir] = ACTIONS(3289),
    [anon_sym_readlink] = ACTIONS(3289),
    [anon_sym_ref] = ACTIONS(3289),
    [anon_sym_scalar] = ACTIONS(3289),
    [anon_sym_shift] = ACTIONS(3289),
    [anon_sym_sin] = ACTIONS(3289),
    [anon_sym_sleep] = ACTIONS(3289),
    [anon_sym_sqrt] = ACTIONS(3289),
    [anon_sym_srand] = ACTIONS(3289),
    [anon_sym_stat] = ACTIONS(3289),
    [anon_sym_study] = ACTIONS(3289),
    [anon_sym_tell] = ACTIONS(3289),
    [anon_sym_telldir] = ACTIONS(3289),
    [anon_sym_tied] = ACTIONS(3289),
    [anon_sym_uc] = ACTIONS(3289),
    [anon_sym_ucfirst] = ACTIONS(3289),
    [anon_sym_untie] = ACTIONS(3289),
    [anon_sym_umask] = ACTIONS(3289),
    [anon_sym_values] = ACTIONS(3289),
    [anon_sym_write] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3289),
    [anon_sym___END__] = ACTIONS(3289),
    [anon_sym_EOT] = ACTIONS(3289),
    [anon_sym_q] = ACTIONS(3289),
    [anon_sym_qq] = ACTIONS(3289),
    [anon_sym_qw] = ACTIONS(3289),
    [anon_sym_qx] = ACTIONS(3289),
    [anon_sym_qr] = ACTIONS(3289),
    [anon_sym_m] = ACTIONS(3289),
    [anon_sym_s] = ACTIONS(3289),
    [anon_sym_tr] = ACTIONS(3289),
    [anon_sym_y] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_unless] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_until] = ACTIONS(3289),
    [aux_sym__bareword_token1] = ACTIONS(3289),
    [sym_number] = ACTIONS(3289),
    [sym__apostrophe] = ACTIONS(3287),
    [sym__double_quote] = ACTIONS(3287),
    [sym__backtick] = ACTIONS(3287),
    [sym__search_slash] = ACTIONS(3287),
    [sym__PERLY_HEREDOC] = ACTIONS(3287),
    [sym__ctrl_z_hack] = ACTIONS(3287),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1037] = {
    [sym_heredoc_content] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(3291),
    [sym__identifier] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_LBRACE2] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_package] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_sub] = ACTIONS(3293),
    [anon_sym_method] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_my] = ACTIONS(3293),
    [anon_sym_state] = ACTIONS(3293),
    [anon_sym_our] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_defer] = ACTIONS(3293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_elsif] = ACTIONS(3293),
    [anon_sym_and] = ACTIONS(3293),
    [anon_sym_or] = ACTIONS(3293),
    [anon_sym_DOLLAR] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_LT_LT] = ACTIONS(3293),
    [anon_sym_SLASH_SLASH] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_eq] = ACTIONS(3293),
    [anon_sym_ne] = ACTIONS(3293),
    [anon_sym_cmp] = ACTIONS(3293),
    [anon_sym_lt] = ACTIONS(3293),
    [anon_sym_le] = ACTIONS(3293),
    [anon_sym_ge] = ACTIONS(3293),
    [anon_sym_gt] = ACTIONS(3293),
    [anon_sym_isa] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_BSLASH] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_eval] = ACTIONS(3293),
    [anon_sym_field] = ACTIONS(3293),
    [anon_sym_local] = ACTIONS(3293),
    [anon_sym_require] = ACTIONS(3293),
    [anon_sym_map] = ACTIONS(3293),
    [anon_sym_grep] = ACTIONS(3293),
    [anon_sym_sort] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_undef] = ACTIONS(3293),
    [anon_sym_PERCENT2] = ACTIONS(3293),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3293),
    [anon_sym_use] = ACTIONS(3293),
    [anon_sym_no] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_foreach] = ACTIONS(3293),
    [anon_sym_last] = ACTIONS(3293),
    [anon_sym_next] = ACTIONS(3293),
    [anon_sym_redo] = ACTIONS(3293),
    [anon_sym_BEGIN] = ACTIONS(3293),
    [anon_sym_INIT] = ACTIONS(3293),
    [anon_sym_CHECK] = ACTIONS(3293),
    [anon_sym_UNITCHECK] = ACTIONS(3293),
    [anon_sym_END] = ACTIONS(3293),
    [anon_sym_ADJUST] = ACTIONS(3293),
    [anon_sym___FILE__] = ACTIONS(3293),
    [anon_sym___LINE__] = ACTIONS(3293),
    [anon_sym___PACKAGE__] = ACTIONS(3293),
    [anon_sym___SUB__] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_fork] = ACTIONS(3293),
    [anon_sym_getppid] = ACTIONS(3293),
    [anon_sym_time] = ACTIONS(3293),
    [anon_sym_times] = ACTIONS(3293),
    [anon_sym_wait] = ACTIONS(3293),
    [anon_sym_wantarray] = ACTIONS(3293),
    [anon_sym_abs] = ACTIONS(3293),
    [anon_sym_alarm] = ACTIONS(3293),
    [anon_sym_chop] = ACTIONS(3293),
    [anon_sym_chdir] = ACTIONS(3293),
    [anon_sym_close] = ACTIONS(3293),
    [anon_sym_closedir] = ACTIONS(3293),
    [anon_sym_caller] = ACTIONS(3293),
    [anon_sym_chomp] = ACTIONS(3293),
    [anon_sym_chr] = ACTIONS(3293),
    [anon_sym_cos] = ACTIONS(3293),
    [anon_sym_chroot] = ACTIONS(3293),
    [anon_sym_defined] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_dbmclose] = ACTIONS(3293),
    [anon_sym_exists] = ACTIONS(3293),
    [anon_sym_exit] = ACTIONS(3293),
    [anon_sym_eof] = ACTIONS(3293),
    [anon_sym_exp] = ACTIONS(3293),
    [anon_sym_each] = ACTIONS(3293),
    [anon_sym_fc] = ACTIONS(3293),
    [anon_sym_fileno] = ACTIONS(3293),
    [anon_sym_gmtime] = ACTIONS(3293),
    [anon_sym_getc] = ACTIONS(3293),
    [anon_sym_getpgrp] = ACTIONS(3293),
    [anon_sym_getprotobyname] = ACTIONS(3293),
    [anon_sym_getpwname] = ACTIONS(3293),
    [anon_sym_getpwuid] = ACTIONS(3293),
    [anon_sym_getpeername] = ACTIONS(3293),
    [anon_sym_getnetbyname] = ACTIONS(3293),
    [anon_sym_getsockname] = ACTIONS(3293),
    [anon_sym_getgrnam] = ACTIONS(3293),
    [anon_sym_getgrgid] = ACTIONS(3293),
    [anon_sym_hex] = ACTIONS(3293),
    [anon_sym_int] = ACTIONS(3293),
    [anon_sym_keys] = ACTIONS(3293),
    [anon_sym_lc] = ACTIONS(3293),
    [anon_sym_lcfirst] = ACTIONS(3293),
    [anon_sym_length] = ACTIONS(3293),
    [anon_sym_localtime] = ACTIONS(3293),
    [anon_sym_log] = ACTIONS(3293),
    [anon_sym_lock] = ACTIONS(3293),
    [anon_sym_lstat] = ACTIONS(3293),
    [anon_sym_oct] = ACTIONS(3293),
    [anon_sym_ord] = ACTIONS(3293),
    [anon_sym_prototype] = ACTIONS(3293),
    [anon_sym_pop] = ACTIONS(3293),
    [anon_sym_pos] = ACTIONS(3293),
    [anon_sym_quotemeta] = ACTIONS(3293),
    [anon_sym_reset] = ACTIONS(3293),
    [anon_sym_rand] = ACTIONS(3293),
    [anon_sym_rmdir] = ACTIONS(3293),
    [anon_sym_readdir] = ACTIONS(3293),
    [anon_sym_readline] = ACTIONS(3293),
    [anon_sym_readpipe] = ACTIONS(3293),
    [anon_sym_rewinddir] = ACTIONS(3293),
    [anon_sym_readlink] = ACTIONS(3293),
    [anon_sym_ref] = ACTIONS(3293),
    [anon_sym_scalar] = ACTIONS(3293),
    [anon_sym_shift] = ACTIONS(3293),
    [anon_sym_sin] = ACTIONS(3293),
    [anon_sym_sleep] = ACTIONS(3293),
    [anon_sym_sqrt] = ACTIONS(3293),
    [anon_sym_srand] = ACTIONS(3293),
    [anon_sym_stat] = ACTIONS(3293),
    [anon_sym_study] = ACTIONS(3293),
    [anon_sym_tell] = ACTIONS(3293),
    [anon_sym_telldir] = ACTIONS(3293),
    [anon_sym_tied] = ACTIONS(3293),
    [anon_sym_uc] = ACTIONS(3293),
    [anon_sym_ucfirst] = ACTIONS(3293),
    [anon_sym_untie] = ACTIONS(3293),
    [anon_sym_umask] = ACTIONS(3293),
    [anon_sym_values] = ACTIONS(3293),
    [anon_sym_write] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3293),
    [anon_sym___END__] = ACTIONS(3293),
    [anon_sym_EOT] = ACTIONS(3293),
    [anon_sym_q] = ACTIONS(3293),
    [anon_sym_qq] = ACTIONS(3293),
    [anon_sym_qw] = ACTIONS(3293),
    [anon_sym_qx] = ACTIONS(3293),
    [anon_sym_qr] = ACTIONS(3293),
    [anon_sym_m] = ACTIONS(3293),
    [anon_sym_s] = ACTIONS(3293),
    [anon_sym_tr] = ACTIONS(3293),
    [anon_sym_y] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_unless] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_until] = ACTIONS(3293),
    [aux_sym__bareword_token1] = ACTIONS(3293),
    [sym_number] = ACTIONS(3293),
    [sym__apostrophe] = ACTIONS(3291),
    [sym__double_quote] = ACTIONS(3291),
    [sym__backtick] = ACTIONS(3291),
    [sym__search_slash] = ACTIONS(3291),
    [sym__PERLY_HEREDOC] = ACTIONS(3291),
    [sym__ctrl_z_hack] = ACTIONS(3291),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1038] = {
    [sym_heredoc_content] = STATE(1038),
    [ts_builtin_sym_end] = ACTIONS(3298),
    [sym__identifier] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LBRACE2] = ACTIONS(3300),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_package] = ACTIONS(3300),
    [anon_sym_class] = ACTIONS(3300),
    [anon_sym_sub] = ACTIONS(3300),
    [anon_sym_method] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_my] = ACTIONS(3300),
    [anon_sym_state] = ACTIONS(3300),
    [anon_sym_our] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_defer] = ACTIONS(3300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3300),
    [anon_sym_else] = ACTIONS(3300),
    [anon_sym_elsif] = ACTIONS(3300),
    [anon_sym_and] = ACTIONS(3300),
    [anon_sym_or] = ACTIONS(3300),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_AT] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_eq] = ACTIONS(3300),
    [anon_sym_ne] = ACTIONS(3300),
    [anon_sym_cmp] = ACTIONS(3300),
    [anon_sym_lt] = ACTIONS(3300),
    [anon_sym_le] = ACTIONS(3300),
    [anon_sym_ge] = ACTIONS(3300),
    [anon_sym_gt] = ACTIONS(3300),
    [anon_sym_isa] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_BSLASH] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_eval] = ACTIONS(3300),
    [anon_sym_field] = ACTIONS(3300),
    [anon_sym_local] = ACTIONS(3300),
    [anon_sym_require] = ACTIONS(3300),
    [anon_sym_map] = ACTIONS(3300),
    [anon_sym_grep] = ACTIONS(3300),
    [anon_sym_sort] = ACTIONS(3300),
    [anon_sym_goto] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_undef] = ACTIONS(3300),
    [anon_sym_PERCENT2] = ACTIONS(3300),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_no] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_foreach] = ACTIONS(3300),
    [anon_sym_last] = ACTIONS(3300),
    [anon_sym_next] = ACTIONS(3300),
    [anon_sym_redo] = ACTIONS(3300),
    [anon_sym_BEGIN] = ACTIONS(3300),
    [anon_sym_INIT] = ACTIONS(3300),
    [anon_sym_CHECK] = ACTIONS(3300),
    [anon_sym_UNITCHECK] = ACTIONS(3300),
    [anon_sym_END] = ACTIONS(3300),
    [anon_sym_ADJUST] = ACTIONS(3300),
    [anon_sym___FILE__] = ACTIONS(3300),
    [anon_sym___LINE__] = ACTIONS(3300),
    [anon_sym___PACKAGE__] = ACTIONS(3300),
    [anon_sym___SUB__] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_fork] = ACTIONS(3300),
    [anon_sym_getppid] = ACTIONS(3300),
    [anon_sym_time] = ACTIONS(3300),
    [anon_sym_times] = ACTIONS(3300),
    [anon_sym_wait] = ACTIONS(3300),
    [anon_sym_wantarray] = ACTIONS(3300),
    [anon_sym_abs] = ACTIONS(3300),
    [anon_sym_alarm] = ACTIONS(3300),
    [anon_sym_chop] = ACTIONS(3300),
    [anon_sym_chdir] = ACTIONS(3300),
    [anon_sym_close] = ACTIONS(3300),
    [anon_sym_closedir] = ACTIONS(3300),
    [anon_sym_caller] = ACTIONS(3300),
    [anon_sym_chomp] = ACTIONS(3300),
    [anon_sym_chr] = ACTIONS(3300),
    [anon_sym_cos] = ACTIONS(3300),
    [anon_sym_chroot] = ACTIONS(3300),
    [anon_sym_defined] = ACTIONS(3300),
    [anon_sym_delete] = ACTIONS(3300),
    [anon_sym_dbmclose] = ACTIONS(3300),
    [anon_sym_exists] = ACTIONS(3300),
    [anon_sym_exit] = ACTIONS(3300),
    [anon_sym_eof] = ACTIONS(3300),
    [anon_sym_exp] = ACTIONS(3300),
    [anon_sym_each] = ACTIONS(3300),
    [anon_sym_fc] = ACTIONS(3300),
    [anon_sym_fileno] = ACTIONS(3300),
    [anon_sym_gmtime] = ACTIONS(3300),
    [anon_sym_getc] = ACTIONS(3300),
    [anon_sym_getpgrp] = ACTIONS(3300),
    [anon_sym_getprotobyname] = ACTIONS(3300),
    [anon_sym_getpwname] = ACTIONS(3300),
    [anon_sym_getpwuid] = ACTIONS(3300),
    [anon_sym_getpeername] = ACTIONS(3300),
    [anon_sym_getnetbyname] = ACTIONS(3300),
    [anon_sym_getsockname] = ACTIONS(3300),
    [anon_sym_getgrnam] = ACTIONS(3300),
    [anon_sym_getgrgid] = ACTIONS(3300),
    [anon_sym_hex] = ACTIONS(3300),
    [anon_sym_int] = ACTIONS(3300),
    [anon_sym_keys] = ACTIONS(3300),
    [anon_sym_lc] = ACTIONS(3300),
    [anon_sym_lcfirst] = ACTIONS(3300),
    [anon_sym_length] = ACTIONS(3300),
    [anon_sym_localtime] = ACTIONS(3300),
    [anon_sym_log] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_lstat] = ACTIONS(3300),
    [anon_sym_oct] = ACTIONS(3300),
    [anon_sym_ord] = ACTIONS(3300),
    [anon_sym_prototype] = ACTIONS(3300),
    [anon_sym_pop] = ACTIONS(3300),
    [anon_sym_pos] = ACTIONS(3300),
    [anon_sym_quotemeta] = ACTIONS(3300),
    [anon_sym_reset] = ACTIONS(3300),
    [anon_sym_rand] = ACTIONS(3300),
    [anon_sym_rmdir] = ACTIONS(3300),
    [anon_sym_readdir] = ACTIONS(3300),
    [anon_sym_readline] = ACTIONS(3300),
    [anon_sym_readpipe] = ACTIONS(3300),
    [anon_sym_rewinddir] = ACTIONS(3300),
    [anon_sym_readlink] = ACTIONS(3300),
    [anon_sym_ref] = ACTIONS(3300),
    [anon_sym_scalar] = ACTIONS(3300),
    [anon_sym_shift] = ACTIONS(3300),
    [anon_sym_sin] = ACTIONS(3300),
    [anon_sym_sleep] = ACTIONS(3300),
    [anon_sym_sqrt] = ACTIONS(3300),
    [anon_sym_srand] = ACTIONS(3300),
    [anon_sym_stat] = ACTIONS(3300),
    [anon_sym_study] = ACTIONS(3300),
    [anon_sym_tell] = ACTIONS(3300),
    [anon_sym_telldir] = ACTIONS(3300),
    [anon_sym_tied] = ACTIONS(3300),
    [anon_sym_uc] = ACTIONS(3300),
    [anon_sym_ucfirst] = ACTIONS(3300),
    [anon_sym_untie] = ACTIONS(3300),
    [anon_sym_umask] = ACTIONS(3300),
    [anon_sym_values] = ACTIONS(3300),
    [anon_sym_write] = ACTIONS(3300),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3300),
    [anon_sym___END__] = ACTIONS(3300),
    [anon_sym_EOT] = ACTIONS(3300),
    [anon_sym_q] = ACTIONS(3300),
    [anon_sym_qq] = ACTIONS(3300),
    [anon_sym_qw] = ACTIONS(3300),
    [anon_sym_qx] = ACTIONS(3300),
    [anon_sym_qr] = ACTIONS(3300),
    [anon_sym_m] = ACTIONS(3300),
    [anon_sym_s] = ACTIONS(3300),
    [anon_sym_tr] = ACTIONS(3300),
    [anon_sym_y] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_unless] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_until] = ACTIONS(3300),
    [aux_sym__bareword_token1] = ACTIONS(3300),
    [sym_number] = ACTIONS(3300),
    [sym__apostrophe] = ACTIONS(3298),
    [sym__double_quote] = ACTIONS(3298),
    [sym__backtick] = ACTIONS(3298),
    [sym__search_slash] = ACTIONS(3298),
    [sym__PERLY_HEREDOC] = ACTIONS(3298),
    [sym__ctrl_z_hack] = ACTIONS(3298),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1039] = {
    [sym_heredoc_content] = STATE(1039),
    [ts_builtin_sym_end] = ACTIONS(3302),
    [sym__identifier] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LBRACE2] = ACTIONS(3304),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_package] = ACTIONS(3304),
    [anon_sym_class] = ACTIONS(3304),
    [anon_sym_sub] = ACTIONS(3304),
    [anon_sym_method] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_my] = ACTIONS(3304),
    [anon_sym_state] = ACTIONS(3304),
    [anon_sym_our] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_defer] = ACTIONS(3304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3304),
    [anon_sym_else] = ACTIONS(3304),
    [anon_sym_elsif] = ACTIONS(3304),
    [anon_sym_and] = ACTIONS(3304),
    [anon_sym_or] = ACTIONS(3304),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_AT] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_eq] = ACTIONS(3304),
    [anon_sym_ne] = ACTIONS(3304),
    [anon_sym_cmp] = ACTIONS(3304),
    [anon_sym_lt] = ACTIONS(3304),
    [anon_sym_le] = ACTIONS(3304),
    [anon_sym_ge] = ACTIONS(3304),
    [anon_sym_gt] = ACTIONS(3304),
    [anon_sym_isa] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_BSLASH] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_eval] = ACTIONS(3304),
    [anon_sym_field] = ACTIONS(3304),
    [anon_sym_local] = ACTIONS(3304),
    [anon_sym_require] = ACTIONS(3304),
    [anon_sym_map] = ACTIONS(3304),
    [anon_sym_grep] = ACTIONS(3304),
    [anon_sym_sort] = ACTIONS(3304),
    [anon_sym_goto] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_undef] = ACTIONS(3304),
    [anon_sym_PERCENT2] = ACTIONS(3304),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_no] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_foreach] = ACTIONS(3304),
    [anon_sym_last] = ACTIONS(3304),
    [anon_sym_next] = ACTIONS(3304),
    [anon_sym_redo] = ACTIONS(3304),
    [anon_sym_BEGIN] = ACTIONS(3304),
    [anon_sym_INIT] = ACTIONS(3304),
    [anon_sym_CHECK] = ACTIONS(3304),
    [anon_sym_UNITCHECK] = ACTIONS(3304),
    [anon_sym_END] = ACTIONS(3304),
    [anon_sym_ADJUST] = ACTIONS(3304),
    [anon_sym___FILE__] = ACTIONS(3304),
    [anon_sym___LINE__] = ACTIONS(3304),
    [anon_sym___PACKAGE__] = ACTIONS(3304),
    [anon_sym___SUB__] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_fork] = ACTIONS(3304),
    [anon_sym_getppid] = ACTIONS(3304),
    [anon_sym_time] = ACTIONS(3304),
    [anon_sym_times] = ACTIONS(3304),
    [anon_sym_wait] = ACTIONS(3304),
    [anon_sym_wantarray] = ACTIONS(3304),
    [anon_sym_abs] = ACTIONS(3304),
    [anon_sym_alarm] = ACTIONS(3304),
    [anon_sym_chop] = ACTIONS(3304),
    [anon_sym_chdir] = ACTIONS(3304),
    [anon_sym_close] = ACTIONS(3304),
    [anon_sym_closedir] = ACTIONS(3304),
    [anon_sym_caller] = ACTIONS(3304),
    [anon_sym_chomp] = ACTIONS(3304),
    [anon_sym_chr] = ACTIONS(3304),
    [anon_sym_cos] = ACTIONS(3304),
    [anon_sym_chroot] = ACTIONS(3304),
    [anon_sym_defined] = ACTIONS(3304),
    [anon_sym_delete] = ACTIONS(3304),
    [anon_sym_dbmclose] = ACTIONS(3304),
    [anon_sym_exists] = ACTIONS(3304),
    [anon_sym_exit] = ACTIONS(3304),
    [anon_sym_eof] = ACTIONS(3304),
    [anon_sym_exp] = ACTIONS(3304),
    [anon_sym_each] = ACTIONS(3304),
    [anon_sym_fc] = ACTIONS(3304),
    [anon_sym_fileno] = ACTIONS(3304),
    [anon_sym_gmtime] = ACTIONS(3304),
    [anon_sym_getc] = ACTIONS(3304),
    [anon_sym_getpgrp] = ACTIONS(3304),
    [anon_sym_getprotobyname] = ACTIONS(3304),
    [anon_sym_getpwname] = ACTIONS(3304),
    [anon_sym_getpwuid] = ACTIONS(3304),
    [anon_sym_getpeername] = ACTIONS(3304),
    [anon_sym_getnetbyname] = ACTIONS(3304),
    [anon_sym_getsockname] = ACTIONS(3304),
    [anon_sym_getgrnam] = ACTIONS(3304),
    [anon_sym_getgrgid] = ACTIONS(3304),
    [anon_sym_hex] = ACTIONS(3304),
    [anon_sym_int] = ACTIONS(3304),
    [anon_sym_keys] = ACTIONS(3304),
    [anon_sym_lc] = ACTIONS(3304),
    [anon_sym_lcfirst] = ACTIONS(3304),
    [anon_sym_length] = ACTIONS(3304),
    [anon_sym_localtime] = ACTIONS(3304),
    [anon_sym_log] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_lstat] = ACTIONS(3304),
    [anon_sym_oct] = ACTIONS(3304),
    [anon_sym_ord] = ACTIONS(3304),
    [anon_sym_prototype] = ACTIONS(3304),
    [anon_sym_pop] = ACTIONS(3304),
    [anon_sym_pos] = ACTIONS(3304),
    [anon_sym_quotemeta] = ACTIONS(3304),
    [anon_sym_reset] = ACTIONS(3304),
    [anon_sym_rand] = ACTIONS(3304),
    [anon_sym_rmdir] = ACTIONS(3304),
    [anon_sym_readdir] = ACTIONS(3304),
    [anon_sym_readline] = ACTIONS(3304),
    [anon_sym_readpipe] = ACTIONS(3304),
    [anon_sym_rewinddir] = ACTIONS(3304),
    [anon_sym_readlink] = ACTIONS(3304),
    [anon_sym_ref] = ACTIONS(3304),
    [anon_sym_scalar] = ACTIONS(3304),
    [anon_sym_shift] = ACTIONS(3304),
    [anon_sym_sin] = ACTIONS(3304),
    [anon_sym_sleep] = ACTIONS(3304),
    [anon_sym_sqrt] = ACTIONS(3304),
    [anon_sym_srand] = ACTIONS(3304),
    [anon_sym_stat] = ACTIONS(3304),
    [anon_sym_study] = ACTIONS(3304),
    [anon_sym_tell] = ACTIONS(3304),
    [anon_sym_telldir] = ACTIONS(3304),
    [anon_sym_tied] = ACTIONS(3304),
    [anon_sym_uc] = ACTIONS(3304),
    [anon_sym_ucfirst] = ACTIONS(3304),
    [anon_sym_untie] = ACTIONS(3304),
    [anon_sym_umask] = ACTIONS(3304),
    [anon_sym_values] = ACTIONS(3304),
    [anon_sym_write] = ACTIONS(3304),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3304),
    [anon_sym___END__] = ACTIONS(3304),
    [anon_sym_EOT] = ACTIONS(3304),
    [anon_sym_q] = ACTIONS(3304),
    [anon_sym_qq] = ACTIONS(3304),
    [anon_sym_qw] = ACTIONS(3304),
    [anon_sym_qx] = ACTIONS(3304),
    [anon_sym_qr] = ACTIONS(3304),
    [anon_sym_m] = ACTIONS(3304),
    [anon_sym_s] = ACTIONS(3304),
    [anon_sym_tr] = ACTIONS(3304),
    [anon_sym_y] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_unless] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_until] = ACTIONS(3304),
    [aux_sym__bareword_token1] = ACTIONS(3304),
    [sym_number] = ACTIONS(3304),
    [sym__apostrophe] = ACTIONS(3302),
    [sym__double_quote] = ACTIONS(3302),
    [sym__backtick] = ACTIONS(3302),
    [sym__search_slash] = ACTIONS(3302),
    [sym__PERLY_HEREDOC] = ACTIONS(3302),
    [sym__ctrl_z_hack] = ACTIONS(3302),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1040] = {
    [sym_heredoc_content] = STATE(1040),
    [ts_builtin_sym_end] = ACTIONS(3306),
    [sym__identifier] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LBRACE2] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_package] = ACTIONS(3308),
    [anon_sym_class] = ACTIONS(3308),
    [anon_sym_sub] = ACTIONS(3308),
    [anon_sym_method] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_my] = ACTIONS(3308),
    [anon_sym_state] = ACTIONS(3308),
    [anon_sym_our] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_defer] = ACTIONS(3308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3308),
    [anon_sym_else] = ACTIONS(3308),
    [anon_sym_elsif] = ACTIONS(3308),
    [anon_sym_and] = ACTIONS(3308),
    [anon_sym_or] = ACTIONS(3308),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_AT] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_eq] = ACTIONS(3308),
    [anon_sym_ne] = ACTIONS(3308),
    [anon_sym_cmp] = ACTIONS(3308),
    [anon_sym_lt] = ACTIONS(3308),
    [anon_sym_le] = ACTIONS(3308),
    [anon_sym_ge] = ACTIONS(3308),
    [anon_sym_gt] = ACTIONS(3308),
    [anon_sym_isa] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [anon_sym_BSLASH] = ACTIONS(3306),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_eval] = ACTIONS(3308),
    [anon_sym_field] = ACTIONS(3308),
    [anon_sym_local] = ACTIONS(3308),
    [anon_sym_require] = ACTIONS(3308),
    [anon_sym_map] = ACTIONS(3308),
    [anon_sym_grep] = ACTIONS(3308),
    [anon_sym_sort] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_undef] = ACTIONS(3308),
    [anon_sym_PERCENT2] = ACTIONS(3308),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_no] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_foreach] = ACTIONS(3308),
    [anon_sym_last] = ACTIONS(3308),
    [anon_sym_next] = ACTIONS(3308),
    [anon_sym_redo] = ACTIONS(3308),
    [anon_sym_BEGIN] = ACTIONS(3308),
    [anon_sym_INIT] = ACTIONS(3308),
    [anon_sym_CHECK] = ACTIONS(3308),
    [anon_sym_UNITCHECK] = ACTIONS(3308),
    [anon_sym_END] = ACTIONS(3308),
    [anon_sym_ADJUST] = ACTIONS(3308),
    [anon_sym___FILE__] = ACTIONS(3308),
    [anon_sym___LINE__] = ACTIONS(3308),
    [anon_sym___PACKAGE__] = ACTIONS(3308),
    [anon_sym___SUB__] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_fork] = ACTIONS(3308),
    [anon_sym_getppid] = ACTIONS(3308),
    [anon_sym_time] = ACTIONS(3308),
    [anon_sym_times] = ACTIONS(3308),
    [anon_sym_wait] = ACTIONS(3308),
    [anon_sym_wantarray] = ACTIONS(3308),
    [anon_sym_abs] = ACTIONS(3308),
    [anon_sym_alarm] = ACTIONS(3308),
    [anon_sym_chop] = ACTIONS(3308),
    [anon_sym_chdir] = ACTIONS(3308),
    [anon_sym_close] = ACTIONS(3308),
    [anon_sym_closedir] = ACTIONS(3308),
    [anon_sym_caller] = ACTIONS(3308),
    [anon_sym_chomp] = ACTIONS(3308),
    [anon_sym_chr] = ACTIONS(3308),
    [anon_sym_cos] = ACTIONS(3308),
    [anon_sym_chroot] = ACTIONS(3308),
    [anon_sym_defined] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_dbmclose] = ACTIONS(3308),
    [anon_sym_exists] = ACTIONS(3308),
    [anon_sym_exit] = ACTIONS(3308),
    [anon_sym_eof] = ACTIONS(3308),
    [anon_sym_exp] = ACTIONS(3308),
    [anon_sym_each] = ACTIONS(3308),
    [anon_sym_fc] = ACTIONS(3308),
    [anon_sym_fileno] = ACTIONS(3308),
    [anon_sym_gmtime] = ACTIONS(3308),
    [anon_sym_getc] = ACTIONS(3308),
    [anon_sym_getpgrp] = ACTIONS(3308),
    [anon_sym_getprotobyname] = ACTIONS(3308),
    [anon_sym_getpwname] = ACTIONS(3308),
    [anon_sym_getpwuid] = ACTIONS(3308),
    [anon_sym_getpeername] = ACTIONS(3308),
    [anon_sym_getnetbyname] = ACTIONS(3308),
    [anon_sym_getsockname] = ACTIONS(3308),
    [anon_sym_getgrnam] = ACTIONS(3308),
    [anon_sym_getgrgid] = ACTIONS(3308),
    [anon_sym_hex] = ACTIONS(3308),
    [anon_sym_int] = ACTIONS(3308),
    [anon_sym_keys] = ACTIONS(3308),
    [anon_sym_lc] = ACTIONS(3308),
    [anon_sym_lcfirst] = ACTIONS(3308),
    [anon_sym_length] = ACTIONS(3308),
    [anon_sym_localtime] = ACTIONS(3308),
    [anon_sym_log] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_lstat] = ACTIONS(3308),
    [anon_sym_oct] = ACTIONS(3308),
    [anon_sym_ord] = ACTIONS(3308),
    [anon_sym_prototype] = ACTIONS(3308),
    [anon_sym_pop] = ACTIONS(3308),
    [anon_sym_pos] = ACTIONS(3308),
    [anon_sym_quotemeta] = ACTIONS(3308),
    [anon_sym_reset] = ACTIONS(3308),
    [anon_sym_rand] = ACTIONS(3308),
    [anon_sym_rmdir] = ACTIONS(3308),
    [anon_sym_readdir] = ACTIONS(3308),
    [anon_sym_readline] = ACTIONS(3308),
    [anon_sym_readpipe] = ACTIONS(3308),
    [anon_sym_rewinddir] = ACTIONS(3308),
    [anon_sym_readlink] = ACTIONS(3308),
    [anon_sym_ref] = ACTIONS(3308),
    [anon_sym_scalar] = ACTIONS(3308),
    [anon_sym_shift] = ACTIONS(3308),
    [anon_sym_sin] = ACTIONS(3308),
    [anon_sym_sleep] = ACTIONS(3308),
    [anon_sym_sqrt] = ACTIONS(3308),
    [anon_sym_srand] = ACTIONS(3308),
    [anon_sym_stat] = ACTIONS(3308),
    [anon_sym_study] = ACTIONS(3308),
    [anon_sym_tell] = ACTIONS(3308),
    [anon_sym_telldir] = ACTIONS(3308),
    [anon_sym_tied] = ACTIONS(3308),
    [anon_sym_uc] = ACTIONS(3308),
    [anon_sym_ucfirst] = ACTIONS(3308),
    [anon_sym_untie] = ACTIONS(3308),
    [anon_sym_umask] = ACTIONS(3308),
    [anon_sym_values] = ACTIONS(3308),
    [anon_sym_write] = ACTIONS(3308),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3308),
    [anon_sym___END__] = ACTIONS(3308),
    [anon_sym_EOT] = ACTIONS(3308),
    [anon_sym_q] = ACTIONS(3308),
    [anon_sym_qq] = ACTIONS(3308),
    [anon_sym_qw] = ACTIONS(3308),
    [anon_sym_qx] = ACTIONS(3308),
    [anon_sym_qr] = ACTIONS(3308),
    [anon_sym_m] = ACTIONS(3308),
    [anon_sym_s] = ACTIONS(3308),
    [anon_sym_tr] = ACTIONS(3308),
    [anon_sym_y] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_unless] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_until] = ACTIONS(3308),
    [aux_sym__bareword_token1] = ACTIONS(3308),
    [sym_number] = ACTIONS(3308),
    [sym__apostrophe] = ACTIONS(3306),
    [sym__double_quote] = ACTIONS(3306),
    [sym__backtick] = ACTIONS(3306),
    [sym__search_slash] = ACTIONS(3306),
    [sym__PERLY_HEREDOC] = ACTIONS(3306),
    [sym__ctrl_z_hack] = ACTIONS(3306),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1041] = {
    [sym_heredoc_content] = STATE(1041),
    [ts_builtin_sym_end] = ACTIONS(3310),
    [sym__identifier] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_LBRACE2] = ACTIONS(3312),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_package] = ACTIONS(3312),
    [anon_sym_class] = ACTIONS(3312),
    [anon_sym_sub] = ACTIONS(3312),
    [anon_sym_method] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_my] = ACTIONS(3312),
    [anon_sym_state] = ACTIONS(3312),
    [anon_sym_our] = ACTIONS(3312),
    [anon_sym_try] = ACTIONS(3312),
    [anon_sym_defer] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3312),
    [anon_sym_else] = ACTIONS(3312),
    [anon_sym_elsif] = ACTIONS(3312),
    [anon_sym_and] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3312),
    [anon_sym_AT] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_eq] = ACTIONS(3312),
    [anon_sym_ne] = ACTIONS(3312),
    [anon_sym_cmp] = ACTIONS(3312),
    [anon_sym_lt] = ACTIONS(3312),
    [anon_sym_le] = ACTIONS(3312),
    [anon_sym_ge] = ACTIONS(3312),
    [anon_sym_gt] = ACTIONS(3312),
    [anon_sym_isa] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_BSLASH] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3312),
    [anon_sym_eval] = ACTIONS(3312),
    [anon_sym_field] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3312),
    [anon_sym_require] = ACTIONS(3312),
    [anon_sym_map] = ACTIONS(3312),
    [anon_sym_grep] = ACTIONS(3312),
    [anon_sym_sort] = ACTIONS(3312),
    [anon_sym_goto] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_undef] = ACTIONS(3312),
    [anon_sym_PERCENT2] = ACTIONS(3312),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3312),
    [anon_sym_no] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_foreach] = ACTIONS(3312),
    [anon_sym_last] = ACTIONS(3312),
    [anon_sym_next] = ACTIONS(3312),
    [anon_sym_redo] = ACTIONS(3312),
    [anon_sym_BEGIN] = ACTIONS(3312),
    [anon_sym_INIT] = ACTIONS(3312),
    [anon_sym_CHECK] = ACTIONS(3312),
    [anon_sym_UNITCHECK] = ACTIONS(3312),
    [anon_sym_END] = ACTIONS(3312),
    [anon_sym_ADJUST] = ACTIONS(3312),
    [anon_sym___FILE__] = ACTIONS(3312),
    [anon_sym___LINE__] = ACTIONS(3312),
    [anon_sym___PACKAGE__] = ACTIONS(3312),
    [anon_sym___SUB__] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_fork] = ACTIONS(3312),
    [anon_sym_getppid] = ACTIONS(3312),
    [anon_sym_time] = ACTIONS(3312),
    [anon_sym_times] = ACTIONS(3312),
    [anon_sym_wait] = ACTIONS(3312),
    [anon_sym_wantarray] = ACTIONS(3312),
    [anon_sym_abs] = ACTIONS(3312),
    [anon_sym_alarm] = ACTIONS(3312),
    [anon_sym_chop] = ACTIONS(3312),
    [anon_sym_chdir] = ACTIONS(3312),
    [anon_sym_close] = ACTIONS(3312),
    [anon_sym_closedir] = ACTIONS(3312),
    [anon_sym_caller] = ACTIONS(3312),
    [anon_sym_chomp] = ACTIONS(3312),
    [anon_sym_chr] = ACTIONS(3312),
    [anon_sym_cos] = ACTIONS(3312),
    [anon_sym_chroot] = ACTIONS(3312),
    [anon_sym_defined] = ACTIONS(3312),
    [anon_sym_delete] = ACTIONS(3312),
    [anon_sym_dbmclose] = ACTIONS(3312),
    [anon_sym_exists] = ACTIONS(3312),
    [anon_sym_exit] = ACTIONS(3312),
    [anon_sym_eof] = ACTIONS(3312),
    [anon_sym_exp] = ACTIONS(3312),
    [anon_sym_each] = ACTIONS(3312),
    [anon_sym_fc] = ACTIONS(3312),
    [anon_sym_fileno] = ACTIONS(3312),
    [anon_sym_gmtime] = ACTIONS(3312),
    [anon_sym_getc] = ACTIONS(3312),
    [anon_sym_getpgrp] = ACTIONS(3312),
    [anon_sym_getprotobyname] = ACTIONS(3312),
    [anon_sym_getpwname] = ACTIONS(3312),
    [anon_sym_getpwuid] = ACTIONS(3312),
    [anon_sym_getpeername] = ACTIONS(3312),
    [anon_sym_getnetbyname] = ACTIONS(3312),
    [anon_sym_getsockname] = ACTIONS(3312),
    [anon_sym_getgrnam] = ACTIONS(3312),
    [anon_sym_getgrgid] = ACTIONS(3312),
    [anon_sym_hex] = ACTIONS(3312),
    [anon_sym_int] = ACTIONS(3312),
    [anon_sym_keys] = ACTIONS(3312),
    [anon_sym_lc] = ACTIONS(3312),
    [anon_sym_lcfirst] = ACTIONS(3312),
    [anon_sym_length] = ACTIONS(3312),
    [anon_sym_localtime] = ACTIONS(3312),
    [anon_sym_log] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_lstat] = ACTIONS(3312),
    [anon_sym_oct] = ACTIONS(3312),
    [anon_sym_ord] = ACTIONS(3312),
    [anon_sym_prototype] = ACTIONS(3312),
    [anon_sym_pop] = ACTIONS(3312),
    [anon_sym_pos] = ACTIONS(3312),
    [anon_sym_quotemeta] = ACTIONS(3312),
    [anon_sym_reset] = ACTIONS(3312),
    [anon_sym_rand] = ACTIONS(3312),
    [anon_sym_rmdir] = ACTIONS(3312),
    [anon_sym_readdir] = ACTIONS(3312),
    [anon_sym_readline] = ACTIONS(3312),
    [anon_sym_readpipe] = ACTIONS(3312),
    [anon_sym_rewinddir] = ACTIONS(3312),
    [anon_sym_readlink] = ACTIONS(3312),
    [anon_sym_ref] = ACTIONS(3312),
    [anon_sym_scalar] = ACTIONS(3312),
    [anon_sym_shift] = ACTIONS(3312),
    [anon_sym_sin] = ACTIONS(3312),
    [anon_sym_sleep] = ACTIONS(3312),
    [anon_sym_sqrt] = ACTIONS(3312),
    [anon_sym_srand] = ACTIONS(3312),
    [anon_sym_stat] = ACTIONS(3312),
    [anon_sym_study] = ACTIONS(3312),
    [anon_sym_tell] = ACTIONS(3312),
    [anon_sym_telldir] = ACTIONS(3312),
    [anon_sym_tied] = ACTIONS(3312),
    [anon_sym_uc] = ACTIONS(3312),
    [anon_sym_ucfirst] = ACTIONS(3312),
    [anon_sym_untie] = ACTIONS(3312),
    [anon_sym_umask] = ACTIONS(3312),
    [anon_sym_values] = ACTIONS(3312),
    [anon_sym_write] = ACTIONS(3312),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3312),
    [anon_sym___END__] = ACTIONS(3312),
    [anon_sym_EOT] = ACTIONS(3312),
    [anon_sym_q] = ACTIONS(3312),
    [anon_sym_qq] = ACTIONS(3312),
    [anon_sym_qw] = ACTIONS(3312),
    [anon_sym_qx] = ACTIONS(3312),
    [anon_sym_qr] = ACTIONS(3312),
    [anon_sym_m] = ACTIONS(3312),
    [anon_sym_s] = ACTIONS(3312),
    [anon_sym_tr] = ACTIONS(3312),
    [anon_sym_y] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_unless] = ACTIONS(3312),
    [anon_sym_while] = ACTIONS(3312),
    [anon_sym_until] = ACTIONS(3312),
    [aux_sym__bareword_token1] = ACTIONS(3312),
    [sym_number] = ACTIONS(3312),
    [sym__apostrophe] = ACTIONS(3310),
    [sym__double_quote] = ACTIONS(3310),
    [sym__backtick] = ACTIONS(3310),
    [sym__search_slash] = ACTIONS(3310),
    [sym__PERLY_HEREDOC] = ACTIONS(3310),
    [sym__ctrl_z_hack] = ACTIONS(3310),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1042] = {
    [sym_heredoc_content] = STATE(1042),
    [ts_builtin_sym_end] = ACTIONS(3314),
    [sym__identifier] = ACTIONS(3316),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_LBRACE2] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_package] = ACTIONS(3316),
    [anon_sym_class] = ACTIONS(3316),
    [anon_sym_sub] = ACTIONS(3316),
    [anon_sym_method] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_my] = ACTIONS(3316),
    [anon_sym_state] = ACTIONS(3316),
    [anon_sym_our] = ACTIONS(3316),
    [anon_sym_try] = ACTIONS(3316),
    [anon_sym_defer] = ACTIONS(3316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3316),
    [anon_sym_else] = ACTIONS(3316),
    [anon_sym_elsif] = ACTIONS(3316),
    [anon_sym_and] = ACTIONS(3316),
    [anon_sym_or] = ACTIONS(3316),
    [anon_sym_DOLLAR] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_AT] = ACTIONS(3316),
    [anon_sym_LT] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3316),
    [anon_sym_SLASH_SLASH] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3316),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_eq] = ACTIONS(3316),
    [anon_sym_ne] = ACTIONS(3316),
    [anon_sym_cmp] = ACTIONS(3316),
    [anon_sym_lt] = ACTIONS(3316),
    [anon_sym_le] = ACTIONS(3316),
    [anon_sym_ge] = ACTIONS(3316),
    [anon_sym_gt] = ACTIONS(3316),
    [anon_sym_isa] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_BSLASH] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3316),
    [anon_sym_eval] = ACTIONS(3316),
    [anon_sym_field] = ACTIONS(3316),
    [anon_sym_local] = ACTIONS(3316),
    [anon_sym_require] = ACTIONS(3316),
    [anon_sym_map] = ACTIONS(3316),
    [anon_sym_grep] = ACTIONS(3316),
    [anon_sym_sort] = ACTIONS(3316),
    [anon_sym_goto] = ACTIONS(3316),
    [anon_sym_return] = ACTIONS(3316),
    [anon_sym_undef] = ACTIONS(3316),
    [anon_sym_PERCENT2] = ACTIONS(3316),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3316),
    [anon_sym_use] = ACTIONS(3316),
    [anon_sym_no] = ACTIONS(3316),
    [anon_sym_for] = ACTIONS(3316),
    [anon_sym_foreach] = ACTIONS(3316),
    [anon_sym_last] = ACTIONS(3316),
    [anon_sym_next] = ACTIONS(3316),
    [anon_sym_redo] = ACTIONS(3316),
    [anon_sym_BEGIN] = ACTIONS(3316),
    [anon_sym_INIT] = ACTIONS(3316),
    [anon_sym_CHECK] = ACTIONS(3316),
    [anon_sym_UNITCHECK] = ACTIONS(3316),
    [anon_sym_END] = ACTIONS(3316),
    [anon_sym_ADJUST] = ACTIONS(3316),
    [anon_sym___FILE__] = ACTIONS(3316),
    [anon_sym___LINE__] = ACTIONS(3316),
    [anon_sym___PACKAGE__] = ACTIONS(3316),
    [anon_sym___SUB__] = ACTIONS(3316),
    [anon_sym_break] = ACTIONS(3316),
    [anon_sym_fork] = ACTIONS(3316),
    [anon_sym_getppid] = ACTIONS(3316),
    [anon_sym_time] = ACTIONS(3316),
    [anon_sym_times] = ACTIONS(3316),
    [anon_sym_wait] = ACTIONS(3316),
    [anon_sym_wantarray] = ACTIONS(3316),
    [anon_sym_abs] = ACTIONS(3316),
    [anon_sym_alarm] = ACTIONS(3316),
    [anon_sym_chop] = ACTIONS(3316),
    [anon_sym_chdir] = ACTIONS(3316),
    [anon_sym_close] = ACTIONS(3316),
    [anon_sym_closedir] = ACTIONS(3316),
    [anon_sym_caller] = ACTIONS(3316),
    [anon_sym_chomp] = ACTIONS(3316),
    [anon_sym_chr] = ACTIONS(3316),
    [anon_sym_cos] = ACTIONS(3316),
    [anon_sym_chroot] = ACTIONS(3316),
    [anon_sym_defined] = ACTIONS(3316),
    [anon_sym_delete] = ACTIONS(3316),
    [anon_sym_dbmclose] = ACTIONS(3316),
    [anon_sym_exists] = ACTIONS(3316),
    [anon_sym_exit] = ACTIONS(3316),
    [anon_sym_eof] = ACTIONS(3316),
    [anon_sym_exp] = ACTIONS(3316),
    [anon_sym_each] = ACTIONS(3316),
    [anon_sym_fc] = ACTIONS(3316),
    [anon_sym_fileno] = ACTIONS(3316),
    [anon_sym_gmtime] = ACTIONS(3316),
    [anon_sym_getc] = ACTIONS(3316),
    [anon_sym_getpgrp] = ACTIONS(3316),
    [anon_sym_getprotobyname] = ACTIONS(3316),
    [anon_sym_getpwname] = ACTIONS(3316),
    [anon_sym_getpwuid] = ACTIONS(3316),
    [anon_sym_getpeername] = ACTIONS(3316),
    [anon_sym_getnetbyname] = ACTIONS(3316),
    [anon_sym_getsockname] = ACTIONS(3316),
    [anon_sym_getgrnam] = ACTIONS(3316),
    [anon_sym_getgrgid] = ACTIONS(3316),
    [anon_sym_hex] = ACTIONS(3316),
    [anon_sym_int] = ACTIONS(3316),
    [anon_sym_keys] = ACTIONS(3316),
    [anon_sym_lc] = ACTIONS(3316),
    [anon_sym_lcfirst] = ACTIONS(3316),
    [anon_sym_length] = ACTIONS(3316),
    [anon_sym_localtime] = ACTIONS(3316),
    [anon_sym_log] = ACTIONS(3316),
    [anon_sym_lock] = ACTIONS(3316),
    [anon_sym_lstat] = ACTIONS(3316),
    [anon_sym_oct] = ACTIONS(3316),
    [anon_sym_ord] = ACTIONS(3316),
    [anon_sym_prototype] = ACTIONS(3316),
    [anon_sym_pop] = ACTIONS(3316),
    [anon_sym_pos] = ACTIONS(3316),
    [anon_sym_quotemeta] = ACTIONS(3316),
    [anon_sym_reset] = ACTIONS(3316),
    [anon_sym_rand] = ACTIONS(3316),
    [anon_sym_rmdir] = ACTIONS(3316),
    [anon_sym_readdir] = ACTIONS(3316),
    [anon_sym_readline] = ACTIONS(3316),
    [anon_sym_readpipe] = ACTIONS(3316),
    [anon_sym_rewinddir] = ACTIONS(3316),
    [anon_sym_readlink] = ACTIONS(3316),
    [anon_sym_ref] = ACTIONS(3316),
    [anon_sym_scalar] = ACTIONS(3316),
    [anon_sym_shift] = ACTIONS(3316),
    [anon_sym_sin] = ACTIONS(3316),
    [anon_sym_sleep] = ACTIONS(3316),
    [anon_sym_sqrt] = ACTIONS(3316),
    [anon_sym_srand] = ACTIONS(3316),
    [anon_sym_stat] = ACTIONS(3316),
    [anon_sym_study] = ACTIONS(3316),
    [anon_sym_tell] = ACTIONS(3316),
    [anon_sym_telldir] = ACTIONS(3316),
    [anon_sym_tied] = ACTIONS(3316),
    [anon_sym_uc] = ACTIONS(3316),
    [anon_sym_ucfirst] = ACTIONS(3316),
    [anon_sym_untie] = ACTIONS(3316),
    [anon_sym_umask] = ACTIONS(3316),
    [anon_sym_values] = ACTIONS(3316),
    [anon_sym_write] = ACTIONS(3316),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3316),
    [anon_sym___END__] = ACTIONS(3316),
    [anon_sym_EOT] = ACTIONS(3316),
    [anon_sym_q] = ACTIONS(3316),
    [anon_sym_qq] = ACTIONS(3316),
    [anon_sym_qw] = ACTIONS(3316),
    [anon_sym_qx] = ACTIONS(3316),
    [anon_sym_qr] = ACTIONS(3316),
    [anon_sym_m] = ACTIONS(3316),
    [anon_sym_s] = ACTIONS(3316),
    [anon_sym_tr] = ACTIONS(3316),
    [anon_sym_y] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(3316),
    [anon_sym_unless] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(3316),
    [anon_sym_until] = ACTIONS(3316),
    [aux_sym__bareword_token1] = ACTIONS(3316),
    [sym_number] = ACTIONS(3316),
    [sym__apostrophe] = ACTIONS(3314),
    [sym__double_quote] = ACTIONS(3314),
    [sym__backtick] = ACTIONS(3314),
    [sym__search_slash] = ACTIONS(3314),
    [sym__PERLY_HEREDOC] = ACTIONS(3314),
    [sym__ctrl_z_hack] = ACTIONS(3314),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1043] = {
    [sym_heredoc_content] = STATE(1043),
    [ts_builtin_sym_end] = ACTIONS(3321),
    [sym__identifier] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_LBRACE2] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_package] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_sub] = ACTIONS(3323),
    [anon_sym_method] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_my] = ACTIONS(3323),
    [anon_sym_state] = ACTIONS(3323),
    [anon_sym_our] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_defer] = ACTIONS(3323),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_elsif] = ACTIONS(3323),
    [anon_sym_and] = ACTIONS(3323),
    [anon_sym_or] = ACTIONS(3323),
    [anon_sym_DOLLAR] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_AT] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_LT_LT] = ACTIONS(3323),
    [anon_sym_SLASH_SLASH] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3323),
    [anon_sym_eq] = ACTIONS(3323),
    [anon_sym_ne] = ACTIONS(3323),
    [anon_sym_cmp] = ACTIONS(3323),
    [anon_sym_lt] = ACTIONS(3323),
    [anon_sym_le] = ACTIONS(3323),
    [anon_sym_ge] = ACTIONS(3323),
    [anon_sym_gt] = ACTIONS(3323),
    [anon_sym_isa] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [anon_sym_BSLASH] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_eval] = ACTIONS(3323),
    [anon_sym_field] = ACTIONS(3323),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_require] = ACTIONS(3323),
    [anon_sym_map] = ACTIONS(3323),
    [anon_sym_grep] = ACTIONS(3323),
    [anon_sym_sort] = ACTIONS(3323),
    [anon_sym_goto] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_undef] = ACTIONS(3323),
    [anon_sym_PERCENT2] = ACTIONS(3323),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3323),
    [anon_sym_use] = ACTIONS(3323),
    [anon_sym_no] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_foreach] = ACTIONS(3323),
    [anon_sym_last] = ACTIONS(3323),
    [anon_sym_next] = ACTIONS(3323),
    [anon_sym_redo] = ACTIONS(3323),
    [anon_sym_BEGIN] = ACTIONS(3323),
    [anon_sym_INIT] = ACTIONS(3323),
    [anon_sym_CHECK] = ACTIONS(3323),
    [anon_sym_UNITCHECK] = ACTIONS(3323),
    [anon_sym_END] = ACTIONS(3323),
    [anon_sym_ADJUST] = ACTIONS(3323),
    [anon_sym___FILE__] = ACTIONS(3323),
    [anon_sym___LINE__] = ACTIONS(3323),
    [anon_sym___PACKAGE__] = ACTIONS(3323),
    [anon_sym___SUB__] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_fork] = ACTIONS(3323),
    [anon_sym_getppid] = ACTIONS(3323),
    [anon_sym_time] = ACTIONS(3323),
    [anon_sym_times] = ACTIONS(3323),
    [anon_sym_wait] = ACTIONS(3323),
    [anon_sym_wantarray] = ACTIONS(3323),
    [anon_sym_abs] = ACTIONS(3323),
    [anon_sym_alarm] = ACTIONS(3323),
    [anon_sym_chop] = ACTIONS(3323),
    [anon_sym_chdir] = ACTIONS(3323),
    [anon_sym_close] = ACTIONS(3323),
    [anon_sym_closedir] = ACTIONS(3323),
    [anon_sym_caller] = ACTIONS(3323),
    [anon_sym_chomp] = ACTIONS(3323),
    [anon_sym_chr] = ACTIONS(3323),
    [anon_sym_cos] = ACTIONS(3323),
    [anon_sym_chroot] = ACTIONS(3323),
    [anon_sym_defined] = ACTIONS(3323),
    [anon_sym_delete] = ACTIONS(3323),
    [anon_sym_dbmclose] = ACTIONS(3323),
    [anon_sym_exists] = ACTIONS(3323),
    [anon_sym_exit] = ACTIONS(3323),
    [anon_sym_eof] = ACTIONS(3323),
    [anon_sym_exp] = ACTIONS(3323),
    [anon_sym_each] = ACTIONS(3323),
    [anon_sym_fc] = ACTIONS(3323),
    [anon_sym_fileno] = ACTIONS(3323),
    [anon_sym_gmtime] = ACTIONS(3323),
    [anon_sym_getc] = ACTIONS(3323),
    [anon_sym_getpgrp] = ACTIONS(3323),
    [anon_sym_getprotobyname] = ACTIONS(3323),
    [anon_sym_getpwname] = ACTIONS(3323),
    [anon_sym_getpwuid] = ACTIONS(3323),
    [anon_sym_getpeername] = ACTIONS(3323),
    [anon_sym_getnetbyname] = ACTIONS(3323),
    [anon_sym_getsockname] = ACTIONS(3323),
    [anon_sym_getgrnam] = ACTIONS(3323),
    [anon_sym_getgrgid] = ACTIONS(3323),
    [anon_sym_hex] = ACTIONS(3323),
    [anon_sym_int] = ACTIONS(3323),
    [anon_sym_keys] = ACTIONS(3323),
    [anon_sym_lc] = ACTIONS(3323),
    [anon_sym_lcfirst] = ACTIONS(3323),
    [anon_sym_length] = ACTIONS(3323),
    [anon_sym_localtime] = ACTIONS(3323),
    [anon_sym_log] = ACTIONS(3323),
    [anon_sym_lock] = ACTIONS(3323),
    [anon_sym_lstat] = ACTIONS(3323),
    [anon_sym_oct] = ACTIONS(3323),
    [anon_sym_ord] = ACTIONS(3323),
    [anon_sym_prototype] = ACTIONS(3323),
    [anon_sym_pop] = ACTIONS(3323),
    [anon_sym_pos] = ACTIONS(3323),
    [anon_sym_quotemeta] = ACTIONS(3323),
    [anon_sym_reset] = ACTIONS(3323),
    [anon_sym_rand] = ACTIONS(3323),
    [anon_sym_rmdir] = ACTIONS(3323),
    [anon_sym_readdir] = ACTIONS(3323),
    [anon_sym_readline] = ACTIONS(3323),
    [anon_sym_readpipe] = ACTIONS(3323),
    [anon_sym_rewinddir] = ACTIONS(3323),
    [anon_sym_readlink] = ACTIONS(3323),
    [anon_sym_ref] = ACTIONS(3323),
    [anon_sym_scalar] = ACTIONS(3323),
    [anon_sym_shift] = ACTIONS(3323),
    [anon_sym_sin] = ACTIONS(3323),
    [anon_sym_sleep] = ACTIONS(3323),
    [anon_sym_sqrt] = ACTIONS(3323),
    [anon_sym_srand] = ACTIONS(3323),
    [anon_sym_stat] = ACTIONS(3323),
    [anon_sym_study] = ACTIONS(3323),
    [anon_sym_tell] = ACTIONS(3323),
    [anon_sym_telldir] = ACTIONS(3323),
    [anon_sym_tied] = ACTIONS(3323),
    [anon_sym_uc] = ACTIONS(3323),
    [anon_sym_ucfirst] = ACTIONS(3323),
    [anon_sym_untie] = ACTIONS(3323),
    [anon_sym_umask] = ACTIONS(3323),
    [anon_sym_values] = ACTIONS(3323),
    [anon_sym_write] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3323),
    [anon_sym___END__] = ACTIONS(3323),
    [anon_sym_EOT] = ACTIONS(3323),
    [anon_sym_q] = ACTIONS(3323),
    [anon_sym_qq] = ACTIONS(3323),
    [anon_sym_qw] = ACTIONS(3323),
    [anon_sym_qx] = ACTIONS(3323),
    [anon_sym_qr] = ACTIONS(3323),
    [anon_sym_m] = ACTIONS(3323),
    [anon_sym_s] = ACTIONS(3323),
    [anon_sym_tr] = ACTIONS(3323),
    [anon_sym_y] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_unless] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_until] = ACTIONS(3323),
    [aux_sym__bareword_token1] = ACTIONS(3323),
    [sym_number] = ACTIONS(3323),
    [sym__apostrophe] = ACTIONS(3321),
    [sym__double_quote] = ACTIONS(3321),
    [sym__backtick] = ACTIONS(3321),
    [sym__search_slash] = ACTIONS(3321),
    [sym__PERLY_HEREDOC] = ACTIONS(3321),
    [sym__ctrl_z_hack] = ACTIONS(3321),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1044] = {
    [sym_heredoc_content] = STATE(1044),
    [ts_builtin_sym_end] = ACTIONS(3325),
    [sym__identifier] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_LBRACE2] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_package] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_sub] = ACTIONS(3327),
    [anon_sym_method] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_my] = ACTIONS(3327),
    [anon_sym_state] = ACTIONS(3327),
    [anon_sym_our] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_defer] = ACTIONS(3327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_elsif] = ACTIONS(3327),
    [anon_sym_and] = ACTIONS(3327),
    [anon_sym_or] = ACTIONS(3327),
    [anon_sym_DOLLAR] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_AT] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(3327),
    [anon_sym_LT_LT] = ACTIONS(3327),
    [anon_sym_SLASH_SLASH] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_STAR] = ACTIONS(3327),
    [anon_sym_eq] = ACTIONS(3327),
    [anon_sym_ne] = ACTIONS(3327),
    [anon_sym_cmp] = ACTIONS(3327),
    [anon_sym_lt] = ACTIONS(3327),
    [anon_sym_le] = ACTIONS(3327),
    [anon_sym_ge] = ACTIONS(3327),
    [anon_sym_gt] = ACTIONS(3327),
    [anon_sym_isa] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [anon_sym_BSLASH] = ACTIONS(3325),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_eval] = ACTIONS(3327),
    [anon_sym_field] = ACTIONS(3327),
    [anon_sym_local] = ACTIONS(3327),
    [anon_sym_require] = ACTIONS(3327),
    [anon_sym_map] = ACTIONS(3327),
    [anon_sym_grep] = ACTIONS(3327),
    [anon_sym_sort] = ACTIONS(3327),
    [anon_sym_goto] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_undef] = ACTIONS(3327),
    [anon_sym_PERCENT2] = ACTIONS(3327),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3327),
    [anon_sym_use] = ACTIONS(3327),
    [anon_sym_no] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_foreach] = ACTIONS(3327),
    [anon_sym_last] = ACTIONS(3327),
    [anon_sym_next] = ACTIONS(3327),
    [anon_sym_redo] = ACTIONS(3327),
    [anon_sym_BEGIN] = ACTIONS(3327),
    [anon_sym_INIT] = ACTIONS(3327),
    [anon_sym_CHECK] = ACTIONS(3327),
    [anon_sym_UNITCHECK] = ACTIONS(3327),
    [anon_sym_END] = ACTIONS(3327),
    [anon_sym_ADJUST] = ACTIONS(3327),
    [anon_sym___FILE__] = ACTIONS(3327),
    [anon_sym___LINE__] = ACTIONS(3327),
    [anon_sym___PACKAGE__] = ACTIONS(3327),
    [anon_sym___SUB__] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_fork] = ACTIONS(3327),
    [anon_sym_getppid] = ACTIONS(3327),
    [anon_sym_time] = ACTIONS(3327),
    [anon_sym_times] = ACTIONS(3327),
    [anon_sym_wait] = ACTIONS(3327),
    [anon_sym_wantarray] = ACTIONS(3327),
    [anon_sym_abs] = ACTIONS(3327),
    [anon_sym_alarm] = ACTIONS(3327),
    [anon_sym_chop] = ACTIONS(3327),
    [anon_sym_chdir] = ACTIONS(3327),
    [anon_sym_close] = ACTIONS(3327),
    [anon_sym_closedir] = ACTIONS(3327),
    [anon_sym_caller] = ACTIONS(3327),
    [anon_sym_chomp] = ACTIONS(3327),
    [anon_sym_chr] = ACTIONS(3327),
    [anon_sym_cos] = ACTIONS(3327),
    [anon_sym_chroot] = ACTIONS(3327),
    [anon_sym_defined] = ACTIONS(3327),
    [anon_sym_delete] = ACTIONS(3327),
    [anon_sym_dbmclose] = ACTIONS(3327),
    [anon_sym_exists] = ACTIONS(3327),
    [anon_sym_exit] = ACTIONS(3327),
    [anon_sym_eof] = ACTIONS(3327),
    [anon_sym_exp] = ACTIONS(3327),
    [anon_sym_each] = ACTIONS(3327),
    [anon_sym_fc] = ACTIONS(3327),
    [anon_sym_fileno] = ACTIONS(3327),
    [anon_sym_gmtime] = ACTIONS(3327),
    [anon_sym_getc] = ACTIONS(3327),
    [anon_sym_getpgrp] = ACTIONS(3327),
    [anon_sym_getprotobyname] = ACTIONS(3327),
    [anon_sym_getpwname] = ACTIONS(3327),
    [anon_sym_getpwuid] = ACTIONS(3327),
    [anon_sym_getpeername] = ACTIONS(3327),
    [anon_sym_getnetbyname] = ACTIONS(3327),
    [anon_sym_getsockname] = ACTIONS(3327),
    [anon_sym_getgrnam] = ACTIONS(3327),
    [anon_sym_getgrgid] = ACTIONS(3327),
    [anon_sym_hex] = ACTIONS(3327),
    [anon_sym_int] = ACTIONS(3327),
    [anon_sym_keys] = ACTIONS(3327),
    [anon_sym_lc] = ACTIONS(3327),
    [anon_sym_lcfirst] = ACTIONS(3327),
    [anon_sym_length] = ACTIONS(3327),
    [anon_sym_localtime] = ACTIONS(3327),
    [anon_sym_log] = ACTIONS(3327),
    [anon_sym_lock] = ACTIONS(3327),
    [anon_sym_lstat] = ACTIONS(3327),
    [anon_sym_oct] = ACTIONS(3327),
    [anon_sym_ord] = ACTIONS(3327),
    [anon_sym_prototype] = ACTIONS(3327),
    [anon_sym_pop] = ACTIONS(3327),
    [anon_sym_pos] = ACTIONS(3327),
    [anon_sym_quotemeta] = ACTIONS(3327),
    [anon_sym_reset] = ACTIONS(3327),
    [anon_sym_rand] = ACTIONS(3327),
    [anon_sym_rmdir] = ACTIONS(3327),
    [anon_sym_readdir] = ACTIONS(3327),
    [anon_sym_readline] = ACTIONS(3327),
    [anon_sym_readpipe] = ACTIONS(3327),
    [anon_sym_rewinddir] = ACTIONS(3327),
    [anon_sym_readlink] = ACTIONS(3327),
    [anon_sym_ref] = ACTIONS(3327),
    [anon_sym_scalar] = ACTIONS(3327),
    [anon_sym_shift] = ACTIONS(3327),
    [anon_sym_sin] = ACTIONS(3327),
    [anon_sym_sleep] = ACTIONS(3327),
    [anon_sym_sqrt] = ACTIONS(3327),
    [anon_sym_srand] = ACTIONS(3327),
    [anon_sym_stat] = ACTIONS(3327),
    [anon_sym_study] = ACTIONS(3327),
    [anon_sym_tell] = ACTIONS(3327),
    [anon_sym_telldir] = ACTIONS(3327),
    [anon_sym_tied] = ACTIONS(3327),
    [anon_sym_uc] = ACTIONS(3327),
    [anon_sym_ucfirst] = ACTIONS(3327),
    [anon_sym_untie] = ACTIONS(3327),
    [anon_sym_umask] = ACTIONS(3327),
    [anon_sym_values] = ACTIONS(3327),
    [anon_sym_write] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3327),
    [anon_sym___END__] = ACTIONS(3327),
    [anon_sym_EOT] = ACTIONS(3327),
    [anon_sym_q] = ACTIONS(3327),
    [anon_sym_qq] = ACTIONS(3327),
    [anon_sym_qw] = ACTIONS(3327),
    [anon_sym_qx] = ACTIONS(3327),
    [anon_sym_qr] = ACTIONS(3327),
    [anon_sym_m] = ACTIONS(3327),
    [anon_sym_s] = ACTIONS(3327),
    [anon_sym_tr] = ACTIONS(3327),
    [anon_sym_y] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_unless] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_until] = ACTIONS(3327),
    [aux_sym__bareword_token1] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [sym__apostrophe] = ACTIONS(3325),
    [sym__double_quote] = ACTIONS(3325),
    [sym__backtick] = ACTIONS(3325),
    [sym__search_slash] = ACTIONS(3325),
    [sym__PERLY_HEREDOC] = ACTIONS(3325),
    [sym__ctrl_z_hack] = ACTIONS(3325),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1045] = {
    [sym_heredoc_content] = STATE(1045),
    [ts_builtin_sym_end] = ACTIONS(3329),
    [sym__identifier] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_LBRACE2] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_package] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_sub] = ACTIONS(3331),
    [anon_sym_method] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_my] = ACTIONS(3331),
    [anon_sym_state] = ACTIONS(3331),
    [anon_sym_our] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_defer] = ACTIONS(3331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_elsif] = ACTIONS(3331),
    [anon_sym_and] = ACTIONS(3331),
    [anon_sym_or] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_AT] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_LT_LT] = ACTIONS(3331),
    [anon_sym_SLASH_SLASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3331),
    [anon_sym_eq] = ACTIONS(3331),
    [anon_sym_ne] = ACTIONS(3331),
    [anon_sym_cmp] = ACTIONS(3331),
    [anon_sym_lt] = ACTIONS(3331),
    [anon_sym_le] = ACTIONS(3331),
    [anon_sym_ge] = ACTIONS(3331),
    [anon_sym_gt] = ACTIONS(3331),
    [anon_sym_isa] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [anon_sym_BSLASH] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_eval] = ACTIONS(3331),
    [anon_sym_field] = ACTIONS(3331),
    [anon_sym_local] = ACTIONS(3331),
    [anon_sym_require] = ACTIONS(3331),
    [anon_sym_map] = ACTIONS(3331),
    [anon_sym_grep] = ACTIONS(3331),
    [anon_sym_sort] = ACTIONS(3331),
    [anon_sym_goto] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_undef] = ACTIONS(3331),
    [anon_sym_PERCENT2] = ACTIONS(3331),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3331),
    [anon_sym_use] = ACTIONS(3331),
    [anon_sym_no] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_foreach] = ACTIONS(3331),
    [anon_sym_last] = ACTIONS(3331),
    [anon_sym_next] = ACTIONS(3331),
    [anon_sym_redo] = ACTIONS(3331),
    [anon_sym_BEGIN] = ACTIONS(3331),
    [anon_sym_INIT] = ACTIONS(3331),
    [anon_sym_CHECK] = ACTIONS(3331),
    [anon_sym_UNITCHECK] = ACTIONS(3331),
    [anon_sym_END] = ACTIONS(3331),
    [anon_sym_ADJUST] = ACTIONS(3331),
    [anon_sym___FILE__] = ACTIONS(3331),
    [anon_sym___LINE__] = ACTIONS(3331),
    [anon_sym___PACKAGE__] = ACTIONS(3331),
    [anon_sym___SUB__] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_fork] = ACTIONS(3331),
    [anon_sym_getppid] = ACTIONS(3331),
    [anon_sym_time] = ACTIONS(3331),
    [anon_sym_times] = ACTIONS(3331),
    [anon_sym_wait] = ACTIONS(3331),
    [anon_sym_wantarray] = ACTIONS(3331),
    [anon_sym_abs] = ACTIONS(3331),
    [anon_sym_alarm] = ACTIONS(3331),
    [anon_sym_chop] = ACTIONS(3331),
    [anon_sym_chdir] = ACTIONS(3331),
    [anon_sym_close] = ACTIONS(3331),
    [anon_sym_closedir] = ACTIONS(3331),
    [anon_sym_caller] = ACTIONS(3331),
    [anon_sym_chomp] = ACTIONS(3331),
    [anon_sym_chr] = ACTIONS(3331),
    [anon_sym_cos] = ACTIONS(3331),
    [anon_sym_chroot] = ACTIONS(3331),
    [anon_sym_defined] = ACTIONS(3331),
    [anon_sym_delete] = ACTIONS(3331),
    [anon_sym_dbmclose] = ACTIONS(3331),
    [anon_sym_exists] = ACTIONS(3331),
    [anon_sym_exit] = ACTIONS(3331),
    [anon_sym_eof] = ACTIONS(3331),
    [anon_sym_exp] = ACTIONS(3331),
    [anon_sym_each] = ACTIONS(3331),
    [anon_sym_fc] = ACTIONS(3331),
    [anon_sym_fileno] = ACTIONS(3331),
    [anon_sym_gmtime] = ACTIONS(3331),
    [anon_sym_getc] = ACTIONS(3331),
    [anon_sym_getpgrp] = ACTIONS(3331),
    [anon_sym_getprotobyname] = ACTIONS(3331),
    [anon_sym_getpwname] = ACTIONS(3331),
    [anon_sym_getpwuid] = ACTIONS(3331),
    [anon_sym_getpeername] = ACTIONS(3331),
    [anon_sym_getnetbyname] = ACTIONS(3331),
    [anon_sym_getsockname] = ACTIONS(3331),
    [anon_sym_getgrnam] = ACTIONS(3331),
    [anon_sym_getgrgid] = ACTIONS(3331),
    [anon_sym_hex] = ACTIONS(3331),
    [anon_sym_int] = ACTIONS(3331),
    [anon_sym_keys] = ACTIONS(3331),
    [anon_sym_lc] = ACTIONS(3331),
    [anon_sym_lcfirst] = ACTIONS(3331),
    [anon_sym_length] = ACTIONS(3331),
    [anon_sym_localtime] = ACTIONS(3331),
    [anon_sym_log] = ACTIONS(3331),
    [anon_sym_lock] = ACTIONS(3331),
    [anon_sym_lstat] = ACTIONS(3331),
    [anon_sym_oct] = ACTIONS(3331),
    [anon_sym_ord] = ACTIONS(3331),
    [anon_sym_prototype] = ACTIONS(3331),
    [anon_sym_pop] = ACTIONS(3331),
    [anon_sym_pos] = ACTIONS(3331),
    [anon_sym_quotemeta] = ACTIONS(3331),
    [anon_sym_reset] = ACTIONS(3331),
    [anon_sym_rand] = ACTIONS(3331),
    [anon_sym_rmdir] = ACTIONS(3331),
    [anon_sym_readdir] = ACTIONS(3331),
    [anon_sym_readline] = ACTIONS(3331),
    [anon_sym_readpipe] = ACTIONS(3331),
    [anon_sym_rewinddir] = ACTIONS(3331),
    [anon_sym_readlink] = ACTIONS(3331),
    [anon_sym_ref] = ACTIONS(3331),
    [anon_sym_scalar] = ACTIONS(3331),
    [anon_sym_shift] = ACTIONS(3331),
    [anon_sym_sin] = ACTIONS(3331),
    [anon_sym_sleep] = ACTIONS(3331),
    [anon_sym_sqrt] = ACTIONS(3331),
    [anon_sym_srand] = ACTIONS(3331),
    [anon_sym_stat] = ACTIONS(3331),
    [anon_sym_study] = ACTIONS(3331),
    [anon_sym_tell] = ACTIONS(3331),
    [anon_sym_telldir] = ACTIONS(3331),
    [anon_sym_tied] = ACTIONS(3331),
    [anon_sym_uc] = ACTIONS(3331),
    [anon_sym_ucfirst] = ACTIONS(3331),
    [anon_sym_untie] = ACTIONS(3331),
    [anon_sym_umask] = ACTIONS(3331),
    [anon_sym_values] = ACTIONS(3331),
    [anon_sym_write] = ACTIONS(3331),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3331),
    [anon_sym___END__] = ACTIONS(3331),
    [anon_sym_EOT] = ACTIONS(3331),
    [anon_sym_q] = ACTIONS(3331),
    [anon_sym_qq] = ACTIONS(3331),
    [anon_sym_qw] = ACTIONS(3331),
    [anon_sym_qx] = ACTIONS(3331),
    [anon_sym_qr] = ACTIONS(3331),
    [anon_sym_m] = ACTIONS(3331),
    [anon_sym_s] = ACTIONS(3331),
    [anon_sym_tr] = ACTIONS(3331),
    [anon_sym_y] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_unless] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_until] = ACTIONS(3331),
    [aux_sym__bareword_token1] = ACTIONS(3331),
    [sym_number] = ACTIONS(3331),
    [sym__apostrophe] = ACTIONS(3329),
    [sym__double_quote] = ACTIONS(3329),
    [sym__backtick] = ACTIONS(3329),
    [sym__search_slash] = ACTIONS(3329),
    [sym__PERLY_HEREDOC] = ACTIONS(3329),
    [sym__ctrl_z_hack] = ACTIONS(3329),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1046] = {
    [sym_heredoc_content] = STATE(1046),
    [ts_builtin_sym_end] = ACTIONS(3333),
    [sym__identifier] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3335),
    [anon_sym_LBRACE2] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3335),
    [anon_sym_package] = ACTIONS(3335),
    [anon_sym_class] = ACTIONS(3335),
    [anon_sym_sub] = ACTIONS(3335),
    [anon_sym_method] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_my] = ACTIONS(3335),
    [anon_sym_state] = ACTIONS(3335),
    [anon_sym_our] = ACTIONS(3335),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_defer] = ACTIONS(3335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_elsif] = ACTIONS(3335),
    [anon_sym_and] = ACTIONS(3335),
    [anon_sym_or] = ACTIONS(3335),
    [anon_sym_DOLLAR] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3335),
    [anon_sym_AT] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3335),
    [anon_sym_LT_LT] = ACTIONS(3335),
    [anon_sym_SLASH_SLASH] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3335),
    [anon_sym_eq] = ACTIONS(3335),
    [anon_sym_ne] = ACTIONS(3335),
    [anon_sym_cmp] = ACTIONS(3335),
    [anon_sym_lt] = ACTIONS(3335),
    [anon_sym_le] = ACTIONS(3335),
    [anon_sym_ge] = ACTIONS(3335),
    [anon_sym_gt] = ACTIONS(3335),
    [anon_sym_isa] = ACTIONS(3335),
    [anon_sym_TILDE] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3335),
    [anon_sym_DASH_DASH] = ACTIONS(3335),
    [anon_sym_BSLASH] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_eval] = ACTIONS(3335),
    [anon_sym_field] = ACTIONS(3335),
    [anon_sym_local] = ACTIONS(3335),
    [anon_sym_require] = ACTIONS(3335),
    [anon_sym_map] = ACTIONS(3335),
    [anon_sym_grep] = ACTIONS(3335),
    [anon_sym_sort] = ACTIONS(3335),
    [anon_sym_goto] = ACTIONS(3335),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_undef] = ACTIONS(3335),
    [anon_sym_PERCENT2] = ACTIONS(3335),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3335),
    [anon_sym_use] = ACTIONS(3335),
    [anon_sym_no] = ACTIONS(3335),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_foreach] = ACTIONS(3335),
    [anon_sym_last] = ACTIONS(3335),
    [anon_sym_next] = ACTIONS(3335),
    [anon_sym_redo] = ACTIONS(3335),
    [anon_sym_BEGIN] = ACTIONS(3335),
    [anon_sym_INIT] = ACTIONS(3335),
    [anon_sym_CHECK] = ACTIONS(3335),
    [anon_sym_UNITCHECK] = ACTIONS(3335),
    [anon_sym_END] = ACTIONS(3335),
    [anon_sym_ADJUST] = ACTIONS(3335),
    [anon_sym___FILE__] = ACTIONS(3335),
    [anon_sym___LINE__] = ACTIONS(3335),
    [anon_sym___PACKAGE__] = ACTIONS(3335),
    [anon_sym___SUB__] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_fork] = ACTIONS(3335),
    [anon_sym_getppid] = ACTIONS(3335),
    [anon_sym_time] = ACTIONS(3335),
    [anon_sym_times] = ACTIONS(3335),
    [anon_sym_wait] = ACTIONS(3335),
    [anon_sym_wantarray] = ACTIONS(3335),
    [anon_sym_abs] = ACTIONS(3335),
    [anon_sym_alarm] = ACTIONS(3335),
    [anon_sym_chop] = ACTIONS(3335),
    [anon_sym_chdir] = ACTIONS(3335),
    [anon_sym_close] = ACTIONS(3335),
    [anon_sym_closedir] = ACTIONS(3335),
    [anon_sym_caller] = ACTIONS(3335),
    [anon_sym_chomp] = ACTIONS(3335),
    [anon_sym_chr] = ACTIONS(3335),
    [anon_sym_cos] = ACTIONS(3335),
    [anon_sym_chroot] = ACTIONS(3335),
    [anon_sym_defined] = ACTIONS(3335),
    [anon_sym_delete] = ACTIONS(3335),
    [anon_sym_dbmclose] = ACTIONS(3335),
    [anon_sym_exists] = ACTIONS(3335),
    [anon_sym_exit] = ACTIONS(3335),
    [anon_sym_eof] = ACTIONS(3335),
    [anon_sym_exp] = ACTIONS(3335),
    [anon_sym_each] = ACTIONS(3335),
    [anon_sym_fc] = ACTIONS(3335),
    [anon_sym_fileno] = ACTIONS(3335),
    [anon_sym_gmtime] = ACTIONS(3335),
    [anon_sym_getc] = ACTIONS(3335),
    [anon_sym_getpgrp] = ACTIONS(3335),
    [anon_sym_getprotobyname] = ACTIONS(3335),
    [anon_sym_getpwname] = ACTIONS(3335),
    [anon_sym_getpwuid] = ACTIONS(3335),
    [anon_sym_getpeername] = ACTIONS(3335),
    [anon_sym_getnetbyname] = ACTIONS(3335),
    [anon_sym_getsockname] = ACTIONS(3335),
    [anon_sym_getgrnam] = ACTIONS(3335),
    [anon_sym_getgrgid] = ACTIONS(3335),
    [anon_sym_hex] = ACTIONS(3335),
    [anon_sym_int] = ACTIONS(3335),
    [anon_sym_keys] = ACTIONS(3335),
    [anon_sym_lc] = ACTIONS(3335),
    [anon_sym_lcfirst] = ACTIONS(3335),
    [anon_sym_length] = ACTIONS(3335),
    [anon_sym_localtime] = ACTIONS(3335),
    [anon_sym_log] = ACTIONS(3335),
    [anon_sym_lock] = ACTIONS(3335),
    [anon_sym_lstat] = ACTIONS(3335),
    [anon_sym_oct] = ACTIONS(3335),
    [anon_sym_ord] = ACTIONS(3335),
    [anon_sym_prototype] = ACTIONS(3335),
    [anon_sym_pop] = ACTIONS(3335),
    [anon_sym_pos] = ACTIONS(3335),
    [anon_sym_quotemeta] = ACTIONS(3335),
    [anon_sym_reset] = ACTIONS(3335),
    [anon_sym_rand] = ACTIONS(3335),
    [anon_sym_rmdir] = ACTIONS(3335),
    [anon_sym_readdir] = ACTIONS(3335),
    [anon_sym_readline] = ACTIONS(3335),
    [anon_sym_readpipe] = ACTIONS(3335),
    [anon_sym_rewinddir] = ACTIONS(3335),
    [anon_sym_readlink] = ACTIONS(3335),
    [anon_sym_ref] = ACTIONS(3335),
    [anon_sym_scalar] = ACTIONS(3335),
    [anon_sym_shift] = ACTIONS(3335),
    [anon_sym_sin] = ACTIONS(3335),
    [anon_sym_sleep] = ACTIONS(3335),
    [anon_sym_sqrt] = ACTIONS(3335),
    [anon_sym_srand] = ACTIONS(3335),
    [anon_sym_stat] = ACTIONS(3335),
    [anon_sym_study] = ACTIONS(3335),
    [anon_sym_tell] = ACTIONS(3335),
    [anon_sym_telldir] = ACTIONS(3335),
    [anon_sym_tied] = ACTIONS(3335),
    [anon_sym_uc] = ACTIONS(3335),
    [anon_sym_ucfirst] = ACTIONS(3335),
    [anon_sym_untie] = ACTIONS(3335),
    [anon_sym_umask] = ACTIONS(3335),
    [anon_sym_values] = ACTIONS(3335),
    [anon_sym_write] = ACTIONS(3335),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3335),
    [anon_sym___END__] = ACTIONS(3335),
    [anon_sym_EOT] = ACTIONS(3335),
    [anon_sym_q] = ACTIONS(3335),
    [anon_sym_qq] = ACTIONS(3335),
    [anon_sym_qw] = ACTIONS(3335),
    [anon_sym_qx] = ACTIONS(3335),
    [anon_sym_qr] = ACTIONS(3335),
    [anon_sym_m] = ACTIONS(3335),
    [anon_sym_s] = ACTIONS(3335),
    [anon_sym_tr] = ACTIONS(3335),
    [anon_sym_y] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_unless] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_until] = ACTIONS(3335),
    [aux_sym__bareword_token1] = ACTIONS(3335),
    [sym_number] = ACTIONS(3335),
    [sym__apostrophe] = ACTIONS(3333),
    [sym__double_quote] = ACTIONS(3333),
    [sym__backtick] = ACTIONS(3333),
    [sym__search_slash] = ACTIONS(3333),
    [sym__PERLY_HEREDOC] = ACTIONS(3333),
    [sym__ctrl_z_hack] = ACTIONS(3333),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1047] = {
    [sym_heredoc_content] = STATE(1047),
    [sym__identifier] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LBRACE2] = ACTIONS(2978),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym_package] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_sub] = ACTIONS(2978),
    [anon_sym_method] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_my] = ACTIONS(2978),
    [anon_sym_state] = ACTIONS(2978),
    [anon_sym_our] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_finally] = ACTIONS(3337),
    [anon_sym_defer] = ACTIONS(2978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_elsif] = ACTIONS(2978),
    [anon_sym_and] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_AT] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2978),
    [anon_sym_LT_LT] = ACTIONS(2978),
    [anon_sym_SLASH_SLASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_eq] = ACTIONS(2978),
    [anon_sym_ne] = ACTIONS(2978),
    [anon_sym_cmp] = ACTIONS(2978),
    [anon_sym_lt] = ACTIONS(2978),
    [anon_sym_le] = ACTIONS(2978),
    [anon_sym_ge] = ACTIONS(2978),
    [anon_sym_gt] = ACTIONS(2978),
    [anon_sym_isa] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_BSLASH] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_eval] = ACTIONS(2978),
    [anon_sym_field] = ACTIONS(2978),
    [anon_sym_local] = ACTIONS(2978),
    [anon_sym_require] = ACTIONS(2978),
    [anon_sym_map] = ACTIONS(2978),
    [anon_sym_grep] = ACTIONS(2978),
    [anon_sym_sort] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_undef] = ACTIONS(2978),
    [anon_sym_PERCENT2] = ACTIONS(2978),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2978),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_no] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_foreach] = ACTIONS(2978),
    [anon_sym_last] = ACTIONS(2978),
    [anon_sym_next] = ACTIONS(2978),
    [anon_sym_redo] = ACTIONS(2978),
    [anon_sym_BEGIN] = ACTIONS(2978),
    [anon_sym_INIT] = ACTIONS(2978),
    [anon_sym_CHECK] = ACTIONS(2978),
    [anon_sym_UNITCHECK] = ACTIONS(2978),
    [anon_sym_END] = ACTIONS(2978),
    [anon_sym_ADJUST] = ACTIONS(2978),
    [anon_sym___FILE__] = ACTIONS(2978),
    [anon_sym___LINE__] = ACTIONS(2978),
    [anon_sym___PACKAGE__] = ACTIONS(2978),
    [anon_sym___SUB__] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_fork] = ACTIONS(2978),
    [anon_sym_getppid] = ACTIONS(2978),
    [anon_sym_time] = ACTIONS(2978),
    [anon_sym_times] = ACTIONS(2978),
    [anon_sym_wait] = ACTIONS(2978),
    [anon_sym_wantarray] = ACTIONS(2978),
    [anon_sym_abs] = ACTIONS(2978),
    [anon_sym_alarm] = ACTIONS(2978),
    [anon_sym_chop] = ACTIONS(2978),
    [anon_sym_chdir] = ACTIONS(2978),
    [anon_sym_close] = ACTIONS(2978),
    [anon_sym_closedir] = ACTIONS(2978),
    [anon_sym_caller] = ACTIONS(2978),
    [anon_sym_chomp] = ACTIONS(2978),
    [anon_sym_chr] = ACTIONS(2978),
    [anon_sym_cos] = ACTIONS(2978),
    [anon_sym_chroot] = ACTIONS(2978),
    [anon_sym_defined] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_dbmclose] = ACTIONS(2978),
    [anon_sym_exists] = ACTIONS(2978),
    [anon_sym_exit] = ACTIONS(2978),
    [anon_sym_eof] = ACTIONS(2978),
    [anon_sym_exp] = ACTIONS(2978),
    [anon_sym_each] = ACTIONS(2978),
    [anon_sym_fc] = ACTIONS(2978),
    [anon_sym_fileno] = ACTIONS(2978),
    [anon_sym_gmtime] = ACTIONS(2978),
    [anon_sym_getc] = ACTIONS(2978),
    [anon_sym_getpgrp] = ACTIONS(2978),
    [anon_sym_getprotobyname] = ACTIONS(2978),
    [anon_sym_getpwname] = ACTIONS(2978),
    [anon_sym_getpwuid] = ACTIONS(2978),
    [anon_sym_getpeername] = ACTIONS(2978),
    [anon_sym_getnetbyname] = ACTIONS(2978),
    [anon_sym_getsockname] = ACTIONS(2978),
    [anon_sym_getgrnam] = ACTIONS(2978),
    [anon_sym_getgrgid] = ACTIONS(2978),
    [anon_sym_hex] = ACTIONS(2978),
    [anon_sym_int] = ACTIONS(2978),
    [anon_sym_keys] = ACTIONS(2978),
    [anon_sym_lc] = ACTIONS(2978),
    [anon_sym_lcfirst] = ACTIONS(2978),
    [anon_sym_length] = ACTIONS(2978),
    [anon_sym_localtime] = ACTIONS(2978),
    [anon_sym_log] = ACTIONS(2978),
    [anon_sym_lock] = ACTIONS(2978),
    [anon_sym_lstat] = ACTIONS(2978),
    [anon_sym_oct] = ACTIONS(2978),
    [anon_sym_ord] = ACTIONS(2978),
    [anon_sym_prototype] = ACTIONS(2978),
    [anon_sym_pop] = ACTIONS(2978),
    [anon_sym_pos] = ACTIONS(2978),
    [anon_sym_quotemeta] = ACTIONS(2978),
    [anon_sym_reset] = ACTIONS(2978),
    [anon_sym_rand] = ACTIONS(2978),
    [anon_sym_rmdir] = ACTIONS(2978),
    [anon_sym_readdir] = ACTIONS(2978),
    [anon_sym_readline] = ACTIONS(2978),
    [anon_sym_readpipe] = ACTIONS(2978),
    [anon_sym_rewinddir] = ACTIONS(2978),
    [anon_sym_readlink] = ACTIONS(2978),
    [anon_sym_ref] = ACTIONS(2978),
    [anon_sym_scalar] = ACTIONS(2978),
    [anon_sym_shift] = ACTIONS(2978),
    [anon_sym_sin] = ACTIONS(2978),
    [anon_sym_sleep] = ACTIONS(2978),
    [anon_sym_sqrt] = ACTIONS(2978),
    [anon_sym_srand] = ACTIONS(2978),
    [anon_sym_stat] = ACTIONS(2978),
    [anon_sym_study] = ACTIONS(2978),
    [anon_sym_tell] = ACTIONS(2978),
    [anon_sym_telldir] = ACTIONS(2978),
    [anon_sym_tied] = ACTIONS(2978),
    [anon_sym_uc] = ACTIONS(2978),
    [anon_sym_ucfirst] = ACTIONS(2978),
    [anon_sym_untie] = ACTIONS(2978),
    [anon_sym_umask] = ACTIONS(2978),
    [anon_sym_values] = ACTIONS(2978),
    [anon_sym_write] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2978),
    [anon_sym___END__] = ACTIONS(2978),
    [anon_sym_q] = ACTIONS(2978),
    [anon_sym_qq] = ACTIONS(2978),
    [anon_sym_qw] = ACTIONS(2978),
    [anon_sym_qx] = ACTIONS(2978),
    [anon_sym_qr] = ACTIONS(2978),
    [anon_sym_m] = ACTIONS(2978),
    [anon_sym_s] = ACTIONS(2978),
    [anon_sym_tr] = ACTIONS(2978),
    [anon_sym_y] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_unless] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_until] = ACTIONS(2978),
    [aux_sym__bareword_token1] = ACTIONS(2978),
    [sym_number] = ACTIONS(2978),
    [sym__apostrophe] = ACTIONS(2976),
    [sym__double_quote] = ACTIONS(2976),
    [sym__backtick] = ACTIONS(2976),
    [sym__search_slash] = ACTIONS(2976),
    [sym__PERLY_HEREDOC] = ACTIONS(2976),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1048] = {
    [sym_heredoc_content] = STATE(1048),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_LBRACE2] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_package] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_finally] = ACTIONS(2897),
    [anon_sym_defer] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1049] = {
    [sym_heredoc_content] = STATE(1049),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_LBRACE2] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_package] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_finally] = ACTIONS(2905),
    [anon_sym_defer] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1050] = {
    [sym_heredoc_content] = STATE(1050),
    [sym__identifier] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LBRACE2] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_package] = ACTIONS(2996),
    [anon_sym_class] = ACTIONS(2996),
    [anon_sym_sub] = ACTIONS(2996),
    [anon_sym_method] = ACTIONS(2996),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_continue] = ACTIONS(2996),
    [anon_sym_my] = ACTIONS(2996),
    [anon_sym_state] = ACTIONS(2996),
    [anon_sym_our] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_finally] = ACTIONS(3339),
    [anon_sym_defer] = ACTIONS(2996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_else] = ACTIONS(2996),
    [anon_sym_elsif] = ACTIONS(2996),
    [anon_sym_and] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2996),
    [anon_sym_LT] = ACTIONS(2996),
    [anon_sym_LT_LT] = ACTIONS(2996),
    [anon_sym_SLASH_SLASH] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_eq] = ACTIONS(2996),
    [anon_sym_ne] = ACTIONS(2996),
    [anon_sym_cmp] = ACTIONS(2996),
    [anon_sym_lt] = ACTIONS(2996),
    [anon_sym_le] = ACTIONS(2996),
    [anon_sym_ge] = ACTIONS(2996),
    [anon_sym_gt] = ACTIONS(2996),
    [anon_sym_isa] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_BSLASH] = ACTIONS(2994),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_eval] = ACTIONS(2996),
    [anon_sym_field] = ACTIONS(2996),
    [anon_sym_local] = ACTIONS(2996),
    [anon_sym_require] = ACTIONS(2996),
    [anon_sym_map] = ACTIONS(2996),
    [anon_sym_grep] = ACTIONS(2996),
    [anon_sym_sort] = ACTIONS(2996),
    [anon_sym_goto] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_undef] = ACTIONS(2996),
    [anon_sym_PERCENT2] = ACTIONS(2996),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2996),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_no] = ACTIONS(2996),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_foreach] = ACTIONS(2996),
    [anon_sym_last] = ACTIONS(2996),
    [anon_sym_next] = ACTIONS(2996),
    [anon_sym_redo] = ACTIONS(2996),
    [anon_sym_BEGIN] = ACTIONS(2996),
    [anon_sym_INIT] = ACTIONS(2996),
    [anon_sym_CHECK] = ACTIONS(2996),
    [anon_sym_UNITCHECK] = ACTIONS(2996),
    [anon_sym_END] = ACTIONS(2996),
    [anon_sym_ADJUST] = ACTIONS(2996),
    [anon_sym___FILE__] = ACTIONS(2996),
    [anon_sym___LINE__] = ACTIONS(2996),
    [anon_sym___PACKAGE__] = ACTIONS(2996),
    [anon_sym___SUB__] = ACTIONS(2996),
    [anon_sym_break] = ACTIONS(2996),
    [anon_sym_fork] = ACTIONS(2996),
    [anon_sym_getppid] = ACTIONS(2996),
    [anon_sym_time] = ACTIONS(2996),
    [anon_sym_times] = ACTIONS(2996),
    [anon_sym_wait] = ACTIONS(2996),
    [anon_sym_wantarray] = ACTIONS(2996),
    [anon_sym_abs] = ACTIONS(2996),
    [anon_sym_alarm] = ACTIONS(2996),
    [anon_sym_chop] = ACTIONS(2996),
    [anon_sym_chdir] = ACTIONS(2996),
    [anon_sym_close] = ACTIONS(2996),
    [anon_sym_closedir] = ACTIONS(2996),
    [anon_sym_caller] = ACTIONS(2996),
    [anon_sym_chomp] = ACTIONS(2996),
    [anon_sym_chr] = ACTIONS(2996),
    [anon_sym_cos] = ACTIONS(2996),
    [anon_sym_chroot] = ACTIONS(2996),
    [anon_sym_defined] = ACTIONS(2996),
    [anon_sym_delete] = ACTIONS(2996),
    [anon_sym_dbmclose] = ACTIONS(2996),
    [anon_sym_exists] = ACTIONS(2996),
    [anon_sym_exit] = ACTIONS(2996),
    [anon_sym_eof] = ACTIONS(2996),
    [anon_sym_exp] = ACTIONS(2996),
    [anon_sym_each] = ACTIONS(2996),
    [anon_sym_fc] = ACTIONS(2996),
    [anon_sym_fileno] = ACTIONS(2996),
    [anon_sym_gmtime] = ACTIONS(2996),
    [anon_sym_getc] = ACTIONS(2996),
    [anon_sym_getpgrp] = ACTIONS(2996),
    [anon_sym_getprotobyname] = ACTIONS(2996),
    [anon_sym_getpwname] = ACTIONS(2996),
    [anon_sym_getpwuid] = ACTIONS(2996),
    [anon_sym_getpeername] = ACTIONS(2996),
    [anon_sym_getnetbyname] = ACTIONS(2996),
    [anon_sym_getsockname] = ACTIONS(2996),
    [anon_sym_getgrnam] = ACTIONS(2996),
    [anon_sym_getgrgid] = ACTIONS(2996),
    [anon_sym_hex] = ACTIONS(2996),
    [anon_sym_int] = ACTIONS(2996),
    [anon_sym_keys] = ACTIONS(2996),
    [anon_sym_lc] = ACTIONS(2996),
    [anon_sym_lcfirst] = ACTIONS(2996),
    [anon_sym_length] = ACTIONS(2996),
    [anon_sym_localtime] = ACTIONS(2996),
    [anon_sym_log] = ACTIONS(2996),
    [anon_sym_lock] = ACTIONS(2996),
    [anon_sym_lstat] = ACTIONS(2996),
    [anon_sym_oct] = ACTIONS(2996),
    [anon_sym_ord] = ACTIONS(2996),
    [anon_sym_prototype] = ACTIONS(2996),
    [anon_sym_pop] = ACTIONS(2996),
    [anon_sym_pos] = ACTIONS(2996),
    [anon_sym_quotemeta] = ACTIONS(2996),
    [anon_sym_reset] = ACTIONS(2996),
    [anon_sym_rand] = ACTIONS(2996),
    [anon_sym_rmdir] = ACTIONS(2996),
    [anon_sym_readdir] = ACTIONS(2996),
    [anon_sym_readline] = ACTIONS(2996),
    [anon_sym_readpipe] = ACTIONS(2996),
    [anon_sym_rewinddir] = ACTIONS(2996),
    [anon_sym_readlink] = ACTIONS(2996),
    [anon_sym_ref] = ACTIONS(2996),
    [anon_sym_scalar] = ACTIONS(2996),
    [anon_sym_shift] = ACTIONS(2996),
    [anon_sym_sin] = ACTIONS(2996),
    [anon_sym_sleep] = ACTIONS(2996),
    [anon_sym_sqrt] = ACTIONS(2996),
    [anon_sym_srand] = ACTIONS(2996),
    [anon_sym_stat] = ACTIONS(2996),
    [anon_sym_study] = ACTIONS(2996),
    [anon_sym_tell] = ACTIONS(2996),
    [anon_sym_telldir] = ACTIONS(2996),
    [anon_sym_tied] = ACTIONS(2996),
    [anon_sym_uc] = ACTIONS(2996),
    [anon_sym_ucfirst] = ACTIONS(2996),
    [anon_sym_untie] = ACTIONS(2996),
    [anon_sym_umask] = ACTIONS(2996),
    [anon_sym_values] = ACTIONS(2996),
    [anon_sym_write] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2996),
    [anon_sym___END__] = ACTIONS(2996),
    [anon_sym_q] = ACTIONS(2996),
    [anon_sym_qq] = ACTIONS(2996),
    [anon_sym_qw] = ACTIONS(2996),
    [anon_sym_qx] = ACTIONS(2996),
    [anon_sym_qr] = ACTIONS(2996),
    [anon_sym_m] = ACTIONS(2996),
    [anon_sym_s] = ACTIONS(2996),
    [anon_sym_tr] = ACTIONS(2996),
    [anon_sym_y] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_unless] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_until] = ACTIONS(2996),
    [aux_sym__bareword_token1] = ACTIONS(2996),
    [sym_number] = ACTIONS(2996),
    [sym__apostrophe] = ACTIONS(2994),
    [sym__double_quote] = ACTIONS(2994),
    [sym__backtick] = ACTIONS(2994),
    [sym__search_slash] = ACTIONS(2994),
    [sym__PERLY_HEREDOC] = ACTIONS(2994),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1051] = {
    [sym_heredoc_content] = STATE(1051),
    [sym__identifier] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3105),
    [anon_sym_LBRACE2] = ACTIONS(3105),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_package] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_sub] = ACTIONS(3105),
    [anon_sym_method] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_my] = ACTIONS(3105),
    [anon_sym_state] = ACTIONS(3105),
    [anon_sym_our] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_defer] = ACTIONS(3105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3105),
    [anon_sym_elsif] = ACTIONS(3105),
    [anon_sym_and] = ACTIONS(3105),
    [anon_sym_or] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_AT] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_LT_LT] = ACTIONS(3105),
    [anon_sym_SLASH_SLASH] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_eq] = ACTIONS(3105),
    [anon_sym_ne] = ACTIONS(3105),
    [anon_sym_cmp] = ACTIONS(3105),
    [anon_sym_lt] = ACTIONS(3105),
    [anon_sym_le] = ACTIONS(3105),
    [anon_sym_ge] = ACTIONS(3105),
    [anon_sym_gt] = ACTIONS(3105),
    [anon_sym_isa] = ACTIONS(3105),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_PLUS_PLUS] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3105),
    [anon_sym_BSLASH] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_eval] = ACTIONS(3105),
    [anon_sym_field] = ACTIONS(3105),
    [anon_sym_local] = ACTIONS(3105),
    [anon_sym_require] = ACTIONS(3105),
    [anon_sym_map] = ACTIONS(3105),
    [anon_sym_grep] = ACTIONS(3105),
    [anon_sym_sort] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_undef] = ACTIONS(3105),
    [anon_sym_PERCENT2] = ACTIONS(3105),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3105),
    [anon_sym_no] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_foreach] = ACTIONS(3105),
    [anon_sym_last] = ACTIONS(3105),
    [anon_sym_next] = ACTIONS(3105),
    [anon_sym_redo] = ACTIONS(3105),
    [anon_sym_BEGIN] = ACTIONS(3105),
    [anon_sym_INIT] = ACTIONS(3105),
    [anon_sym_CHECK] = ACTIONS(3105),
    [anon_sym_UNITCHECK] = ACTIONS(3105),
    [anon_sym_END] = ACTIONS(3105),
    [anon_sym_ADJUST] = ACTIONS(3105),
    [anon_sym___FILE__] = ACTIONS(3105),
    [anon_sym___LINE__] = ACTIONS(3105),
    [anon_sym___PACKAGE__] = ACTIONS(3105),
    [anon_sym___SUB__] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_fork] = ACTIONS(3105),
    [anon_sym_getppid] = ACTIONS(3105),
    [anon_sym_time] = ACTIONS(3105),
    [anon_sym_times] = ACTIONS(3105),
    [anon_sym_wait] = ACTIONS(3105),
    [anon_sym_wantarray] = ACTIONS(3105),
    [anon_sym_abs] = ACTIONS(3105),
    [anon_sym_alarm] = ACTIONS(3105),
    [anon_sym_chop] = ACTIONS(3105),
    [anon_sym_chdir] = ACTIONS(3105),
    [anon_sym_close] = ACTIONS(3105),
    [anon_sym_closedir] = ACTIONS(3105),
    [anon_sym_caller] = ACTIONS(3105),
    [anon_sym_chomp] = ACTIONS(3105),
    [anon_sym_chr] = ACTIONS(3105),
    [anon_sym_cos] = ACTIONS(3105),
    [anon_sym_chroot] = ACTIONS(3105),
    [anon_sym_defined] = ACTIONS(3105),
    [anon_sym_delete] = ACTIONS(3105),
    [anon_sym_dbmclose] = ACTIONS(3105),
    [anon_sym_exists] = ACTIONS(3105),
    [anon_sym_exit] = ACTIONS(3105),
    [anon_sym_eof] = ACTIONS(3105),
    [anon_sym_exp] = ACTIONS(3105),
    [anon_sym_each] = ACTIONS(3105),
    [anon_sym_fc] = ACTIONS(3105),
    [anon_sym_fileno] = ACTIONS(3105),
    [anon_sym_gmtime] = ACTIONS(3105),
    [anon_sym_getc] = ACTIONS(3105),
    [anon_sym_getpgrp] = ACTIONS(3105),
    [anon_sym_getprotobyname] = ACTIONS(3105),
    [anon_sym_getpwname] = ACTIONS(3105),
    [anon_sym_getpwuid] = ACTIONS(3105),
    [anon_sym_getpeername] = ACTIONS(3105),
    [anon_sym_getnetbyname] = ACTIONS(3105),
    [anon_sym_getsockname] = ACTIONS(3105),
    [anon_sym_getgrnam] = ACTIONS(3105),
    [anon_sym_getgrgid] = ACTIONS(3105),
    [anon_sym_hex] = ACTIONS(3105),
    [anon_sym_int] = ACTIONS(3105),
    [anon_sym_keys] = ACTIONS(3105),
    [anon_sym_lc] = ACTIONS(3105),
    [anon_sym_lcfirst] = ACTIONS(3105),
    [anon_sym_length] = ACTIONS(3105),
    [anon_sym_localtime] = ACTIONS(3105),
    [anon_sym_log] = ACTIONS(3105),
    [anon_sym_lock] = ACTIONS(3105),
    [anon_sym_lstat] = ACTIONS(3105),
    [anon_sym_oct] = ACTIONS(3105),
    [anon_sym_ord] = ACTIONS(3105),
    [anon_sym_prototype] = ACTIONS(3105),
    [anon_sym_pop] = ACTIONS(3105),
    [anon_sym_pos] = ACTIONS(3105),
    [anon_sym_quotemeta] = ACTIONS(3105),
    [anon_sym_reset] = ACTIONS(3105),
    [anon_sym_rand] = ACTIONS(3105),
    [anon_sym_rmdir] = ACTIONS(3105),
    [anon_sym_readdir] = ACTIONS(3105),
    [anon_sym_readline] = ACTIONS(3105),
    [anon_sym_readpipe] = ACTIONS(3105),
    [anon_sym_rewinddir] = ACTIONS(3105),
    [anon_sym_readlink] = ACTIONS(3105),
    [anon_sym_ref] = ACTIONS(3105),
    [anon_sym_scalar] = ACTIONS(3105),
    [anon_sym_shift] = ACTIONS(3105),
    [anon_sym_sin] = ACTIONS(3105),
    [anon_sym_sleep] = ACTIONS(3105),
    [anon_sym_sqrt] = ACTIONS(3105),
    [anon_sym_srand] = ACTIONS(3105),
    [anon_sym_stat] = ACTIONS(3105),
    [anon_sym_study] = ACTIONS(3105),
    [anon_sym_tell] = ACTIONS(3105),
    [anon_sym_telldir] = ACTIONS(3105),
    [anon_sym_tied] = ACTIONS(3105),
    [anon_sym_uc] = ACTIONS(3105),
    [anon_sym_ucfirst] = ACTIONS(3105),
    [anon_sym_untie] = ACTIONS(3105),
    [anon_sym_umask] = ACTIONS(3105),
    [anon_sym_values] = ACTIONS(3105),
    [anon_sym_write] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3105),
    [anon_sym___END__] = ACTIONS(3105),
    [anon_sym_q] = ACTIONS(3105),
    [anon_sym_qq] = ACTIONS(3105),
    [anon_sym_qw] = ACTIONS(3105),
    [anon_sym_qx] = ACTIONS(3105),
    [anon_sym_qr] = ACTIONS(3105),
    [anon_sym_m] = ACTIONS(3105),
    [anon_sym_s] = ACTIONS(3105),
    [anon_sym_tr] = ACTIONS(3105),
    [anon_sym_y] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_unless] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_until] = ACTIONS(3105),
    [aux_sym__bareword_token1] = ACTIONS(3105),
    [sym_number] = ACTIONS(3105),
    [sym__apostrophe] = ACTIONS(3103),
    [sym__double_quote] = ACTIONS(3103),
    [sym__backtick] = ACTIONS(3103),
    [sym__search_slash] = ACTIONS(3103),
    [sym__PERLY_HEREDOC] = ACTIONS(3103),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1052] = {
    [sym_heredoc_content] = STATE(1052),
    [sym__identifier] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3021),
    [anon_sym_LBRACE2] = ACTIONS(3021),
    [anon_sym_RBRACE] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3021),
    [anon_sym_package] = ACTIONS(3021),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_sub] = ACTIONS(3021),
    [anon_sym_method] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3341),
    [anon_sym_my] = ACTIONS(3021),
    [anon_sym_state] = ACTIONS(3021),
    [anon_sym_our] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_defer] = ACTIONS(3021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3021),
    [anon_sym_else] = ACTIONS(3021),
    [anon_sym_elsif] = ACTIONS(3021),
    [anon_sym_and] = ACTIONS(3021),
    [anon_sym_or] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_LT_LT] = ACTIONS(3021),
    [anon_sym_SLASH_SLASH] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_STAR] = ACTIONS(3021),
    [anon_sym_eq] = ACTIONS(3021),
    [anon_sym_ne] = ACTIONS(3021),
    [anon_sym_cmp] = ACTIONS(3021),
    [anon_sym_lt] = ACTIONS(3021),
    [anon_sym_le] = ACTIONS(3021),
    [anon_sym_ge] = ACTIONS(3021),
    [anon_sym_gt] = ACTIONS(3021),
    [anon_sym_isa] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3021),
    [anon_sym_DASH_DASH] = ACTIONS(3021),
    [anon_sym_BSLASH] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_eval] = ACTIONS(3021),
    [anon_sym_field] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3021),
    [anon_sym_require] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(3021),
    [anon_sym_grep] = ACTIONS(3021),
    [anon_sym_sort] = ACTIONS(3021),
    [anon_sym_goto] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_undef] = ACTIONS(3021),
    [anon_sym_PERCENT2] = ACTIONS(3021),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3021),
    [anon_sym_no] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_foreach] = ACTIONS(3021),
    [anon_sym_last] = ACTIONS(3021),
    [anon_sym_next] = ACTIONS(3021),
    [anon_sym_redo] = ACTIONS(3021),
    [anon_sym_BEGIN] = ACTIONS(3021),
    [anon_sym_INIT] = ACTIONS(3021),
    [anon_sym_CHECK] = ACTIONS(3021),
    [anon_sym_UNITCHECK] = ACTIONS(3021),
    [anon_sym_END] = ACTIONS(3021),
    [anon_sym_ADJUST] = ACTIONS(3021),
    [anon_sym___FILE__] = ACTIONS(3021),
    [anon_sym___LINE__] = ACTIONS(3021),
    [anon_sym___PACKAGE__] = ACTIONS(3021),
    [anon_sym___SUB__] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_fork] = ACTIONS(3021),
    [anon_sym_getppid] = ACTIONS(3021),
    [anon_sym_time] = ACTIONS(3021),
    [anon_sym_times] = ACTIONS(3021),
    [anon_sym_wait] = ACTIONS(3021),
    [anon_sym_wantarray] = ACTIONS(3021),
    [anon_sym_abs] = ACTIONS(3021),
    [anon_sym_alarm] = ACTIONS(3021),
    [anon_sym_chop] = ACTIONS(3021),
    [anon_sym_chdir] = ACTIONS(3021),
    [anon_sym_close] = ACTIONS(3021),
    [anon_sym_closedir] = ACTIONS(3021),
    [anon_sym_caller] = ACTIONS(3021),
    [anon_sym_chomp] = ACTIONS(3021),
    [anon_sym_chr] = ACTIONS(3021),
    [anon_sym_cos] = ACTIONS(3021),
    [anon_sym_chroot] = ACTIONS(3021),
    [anon_sym_defined] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_dbmclose] = ACTIONS(3021),
    [anon_sym_exists] = ACTIONS(3021),
    [anon_sym_exit] = ACTIONS(3021),
    [anon_sym_eof] = ACTIONS(3021),
    [anon_sym_exp] = ACTIONS(3021),
    [anon_sym_each] = ACTIONS(3021),
    [anon_sym_fc] = ACTIONS(3021),
    [anon_sym_fileno] = ACTIONS(3021),
    [anon_sym_gmtime] = ACTIONS(3021),
    [anon_sym_getc] = ACTIONS(3021),
    [anon_sym_getpgrp] = ACTIONS(3021),
    [anon_sym_getprotobyname] = ACTIONS(3021),
    [anon_sym_getpwname] = ACTIONS(3021),
    [anon_sym_getpwuid] = ACTIONS(3021),
    [anon_sym_getpeername] = ACTIONS(3021),
    [anon_sym_getnetbyname] = ACTIONS(3021),
    [anon_sym_getsockname] = ACTIONS(3021),
    [anon_sym_getgrnam] = ACTIONS(3021),
    [anon_sym_getgrgid] = ACTIONS(3021),
    [anon_sym_hex] = ACTIONS(3021),
    [anon_sym_int] = ACTIONS(3021),
    [anon_sym_keys] = ACTIONS(3021),
    [anon_sym_lc] = ACTIONS(3021),
    [anon_sym_lcfirst] = ACTIONS(3021),
    [anon_sym_length] = ACTIONS(3021),
    [anon_sym_localtime] = ACTIONS(3021),
    [anon_sym_log] = ACTIONS(3021),
    [anon_sym_lock] = ACTIONS(3021),
    [anon_sym_lstat] = ACTIONS(3021),
    [anon_sym_oct] = ACTIONS(3021),
    [anon_sym_ord] = ACTIONS(3021),
    [anon_sym_prototype] = ACTIONS(3021),
    [anon_sym_pop] = ACTIONS(3021),
    [anon_sym_pos] = ACTIONS(3021),
    [anon_sym_quotemeta] = ACTIONS(3021),
    [anon_sym_reset] = ACTIONS(3021),
    [anon_sym_rand] = ACTIONS(3021),
    [anon_sym_rmdir] = ACTIONS(3021),
    [anon_sym_readdir] = ACTIONS(3021),
    [anon_sym_readline] = ACTIONS(3021),
    [anon_sym_readpipe] = ACTIONS(3021),
    [anon_sym_rewinddir] = ACTIONS(3021),
    [anon_sym_readlink] = ACTIONS(3021),
    [anon_sym_ref] = ACTIONS(3021),
    [anon_sym_scalar] = ACTIONS(3021),
    [anon_sym_shift] = ACTIONS(3021),
    [anon_sym_sin] = ACTIONS(3021),
    [anon_sym_sleep] = ACTIONS(3021),
    [anon_sym_sqrt] = ACTIONS(3021),
    [anon_sym_srand] = ACTIONS(3021),
    [anon_sym_stat] = ACTIONS(3021),
    [anon_sym_study] = ACTIONS(3021),
    [anon_sym_tell] = ACTIONS(3021),
    [anon_sym_telldir] = ACTIONS(3021),
    [anon_sym_tied] = ACTIONS(3021),
    [anon_sym_uc] = ACTIONS(3021),
    [anon_sym_ucfirst] = ACTIONS(3021),
    [anon_sym_untie] = ACTIONS(3021),
    [anon_sym_umask] = ACTIONS(3021),
    [anon_sym_values] = ACTIONS(3021),
    [anon_sym_write] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3021),
    [anon_sym___END__] = ACTIONS(3021),
    [anon_sym_q] = ACTIONS(3021),
    [anon_sym_qq] = ACTIONS(3021),
    [anon_sym_qw] = ACTIONS(3021),
    [anon_sym_qx] = ACTIONS(3021),
    [anon_sym_qr] = ACTIONS(3021),
    [anon_sym_m] = ACTIONS(3021),
    [anon_sym_s] = ACTIONS(3021),
    [anon_sym_tr] = ACTIONS(3021),
    [anon_sym_y] = ACTIONS(3021),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_unless] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_until] = ACTIONS(3021),
    [aux_sym__bareword_token1] = ACTIONS(3021),
    [sym_number] = ACTIONS(3021),
    [sym__apostrophe] = ACTIONS(3019),
    [sym__double_quote] = ACTIONS(3019),
    [sym__backtick] = ACTIONS(3019),
    [sym__search_slash] = ACTIONS(3019),
    [sym__PERLY_HEREDOC] = ACTIONS(3019),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1053] = {
    [sym_heredoc_content] = STATE(1053),
    [sym__identifier] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3017),
    [anon_sym_LBRACE2] = ACTIONS(3017),
    [anon_sym_RBRACE] = ACTIONS(3017),
    [anon_sym_SEMI] = ACTIONS(3017),
    [anon_sym_package] = ACTIONS(3017),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_sub] = ACTIONS(3017),
    [anon_sym_method] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3017),
    [anon_sym_continue] = ACTIONS(3017),
    [anon_sym_my] = ACTIONS(3017),
    [anon_sym_state] = ACTIONS(3017),
    [anon_sym_our] = ACTIONS(3017),
    [anon_sym_try] = ACTIONS(3017),
    [anon_sym_defer] = ACTIONS(3017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3017),
    [anon_sym_else] = ACTIONS(3017),
    [anon_sym_elsif] = ACTIONS(3017),
    [anon_sym_and] = ACTIONS(3017),
    [anon_sym_or] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3017),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_AT] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_LT_LT] = ACTIONS(3017),
    [anon_sym_SLASH_SLASH] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3017),
    [anon_sym_DASH] = ACTIONS(3017),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_eq] = ACTIONS(3017),
    [anon_sym_ne] = ACTIONS(3017),
    [anon_sym_cmp] = ACTIONS(3017),
    [anon_sym_lt] = ACTIONS(3017),
    [anon_sym_le] = ACTIONS(3017),
    [anon_sym_ge] = ACTIONS(3017),
    [anon_sym_gt] = ACTIONS(3017),
    [anon_sym_isa] = ACTIONS(3017),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_BANG] = ACTIONS(3017),
    [anon_sym_PLUS_PLUS] = ACTIONS(3017),
    [anon_sym_DASH_DASH] = ACTIONS(3017),
    [anon_sym_BSLASH] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3017),
    [anon_sym_eval] = ACTIONS(3017),
    [anon_sym_field] = ACTIONS(3017),
    [anon_sym_local] = ACTIONS(3017),
    [anon_sym_require] = ACTIONS(3017),
    [anon_sym_map] = ACTIONS(3017),
    [anon_sym_grep] = ACTIONS(3017),
    [anon_sym_sort] = ACTIONS(3017),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_undef] = ACTIONS(3017),
    [anon_sym_PERCENT2] = ACTIONS(3017),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3017),
    [anon_sym_no] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3017),
    [anon_sym_foreach] = ACTIONS(3017),
    [anon_sym_last] = ACTIONS(3017),
    [anon_sym_next] = ACTIONS(3017),
    [anon_sym_redo] = ACTIONS(3017),
    [anon_sym_BEGIN] = ACTIONS(3017),
    [anon_sym_INIT] = ACTIONS(3017),
    [anon_sym_CHECK] = ACTIONS(3017),
    [anon_sym_UNITCHECK] = ACTIONS(3017),
    [anon_sym_END] = ACTIONS(3017),
    [anon_sym_ADJUST] = ACTIONS(3017),
    [anon_sym___FILE__] = ACTIONS(3017),
    [anon_sym___LINE__] = ACTIONS(3017),
    [anon_sym___PACKAGE__] = ACTIONS(3017),
    [anon_sym___SUB__] = ACTIONS(3017),
    [anon_sym_break] = ACTIONS(3017),
    [anon_sym_fork] = ACTIONS(3017),
    [anon_sym_getppid] = ACTIONS(3017),
    [anon_sym_time] = ACTIONS(3017),
    [anon_sym_times] = ACTIONS(3017),
    [anon_sym_wait] = ACTIONS(3017),
    [anon_sym_wantarray] = ACTIONS(3017),
    [anon_sym_abs] = ACTIONS(3017),
    [anon_sym_alarm] = ACTIONS(3017),
    [anon_sym_chop] = ACTIONS(3017),
    [anon_sym_chdir] = ACTIONS(3017),
    [anon_sym_close] = ACTIONS(3017),
    [anon_sym_closedir] = ACTIONS(3017),
    [anon_sym_caller] = ACTIONS(3017),
    [anon_sym_chomp] = ACTIONS(3017),
    [anon_sym_chr] = ACTIONS(3017),
    [anon_sym_cos] = ACTIONS(3017),
    [anon_sym_chroot] = ACTIONS(3017),
    [anon_sym_defined] = ACTIONS(3017),
    [anon_sym_delete] = ACTIONS(3017),
    [anon_sym_dbmclose] = ACTIONS(3017),
    [anon_sym_exists] = ACTIONS(3017),
    [anon_sym_exit] = ACTIONS(3017),
    [anon_sym_eof] = ACTIONS(3017),
    [anon_sym_exp] = ACTIONS(3017),
    [anon_sym_each] = ACTIONS(3017),
    [anon_sym_fc] = ACTIONS(3017),
    [anon_sym_fileno] = ACTIONS(3017),
    [anon_sym_gmtime] = ACTIONS(3017),
    [anon_sym_getc] = ACTIONS(3017),
    [anon_sym_getpgrp] = ACTIONS(3017),
    [anon_sym_getprotobyname] = ACTIONS(3017),
    [anon_sym_getpwname] = ACTIONS(3017),
    [anon_sym_getpwuid] = ACTIONS(3017),
    [anon_sym_getpeername] = ACTIONS(3017),
    [anon_sym_getnetbyname] = ACTIONS(3017),
    [anon_sym_getsockname] = ACTIONS(3017),
    [anon_sym_getgrnam] = ACTIONS(3017),
    [anon_sym_getgrgid] = ACTIONS(3017),
    [anon_sym_hex] = ACTIONS(3017),
    [anon_sym_int] = ACTIONS(3017),
    [anon_sym_keys] = ACTIONS(3017),
    [anon_sym_lc] = ACTIONS(3017),
    [anon_sym_lcfirst] = ACTIONS(3017),
    [anon_sym_length] = ACTIONS(3017),
    [anon_sym_localtime] = ACTIONS(3017),
    [anon_sym_log] = ACTIONS(3017),
    [anon_sym_lock] = ACTIONS(3017),
    [anon_sym_lstat] = ACTIONS(3017),
    [anon_sym_oct] = ACTIONS(3017),
    [anon_sym_ord] = ACTIONS(3017),
    [anon_sym_prototype] = ACTIONS(3017),
    [anon_sym_pop] = ACTIONS(3017),
    [anon_sym_pos] = ACTIONS(3017),
    [anon_sym_quotemeta] = ACTIONS(3017),
    [anon_sym_reset] = ACTIONS(3017),
    [anon_sym_rand] = ACTIONS(3017),
    [anon_sym_rmdir] = ACTIONS(3017),
    [anon_sym_readdir] = ACTIONS(3017),
    [anon_sym_readline] = ACTIONS(3017),
    [anon_sym_readpipe] = ACTIONS(3017),
    [anon_sym_rewinddir] = ACTIONS(3017),
    [anon_sym_readlink] = ACTIONS(3017),
    [anon_sym_ref] = ACTIONS(3017),
    [anon_sym_scalar] = ACTIONS(3017),
    [anon_sym_shift] = ACTIONS(3017),
    [anon_sym_sin] = ACTIONS(3017),
    [anon_sym_sleep] = ACTIONS(3017),
    [anon_sym_sqrt] = ACTIONS(3017),
    [anon_sym_srand] = ACTIONS(3017),
    [anon_sym_stat] = ACTIONS(3017),
    [anon_sym_study] = ACTIONS(3017),
    [anon_sym_tell] = ACTIONS(3017),
    [anon_sym_telldir] = ACTIONS(3017),
    [anon_sym_tied] = ACTIONS(3017),
    [anon_sym_uc] = ACTIONS(3017),
    [anon_sym_ucfirst] = ACTIONS(3017),
    [anon_sym_untie] = ACTIONS(3017),
    [anon_sym_umask] = ACTIONS(3017),
    [anon_sym_values] = ACTIONS(3017),
    [anon_sym_write] = ACTIONS(3017),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3017),
    [anon_sym___END__] = ACTIONS(3017),
    [anon_sym_q] = ACTIONS(3017),
    [anon_sym_qq] = ACTIONS(3017),
    [anon_sym_qw] = ACTIONS(3017),
    [anon_sym_qx] = ACTIONS(3017),
    [anon_sym_qr] = ACTIONS(3017),
    [anon_sym_m] = ACTIONS(3017),
    [anon_sym_s] = ACTIONS(3017),
    [anon_sym_tr] = ACTIONS(3017),
    [anon_sym_y] = ACTIONS(3017),
    [anon_sym_if] = ACTIONS(3017),
    [anon_sym_unless] = ACTIONS(3017),
    [anon_sym_while] = ACTIONS(3017),
    [anon_sym_until] = ACTIONS(3017),
    [aux_sym__bareword_token1] = ACTIONS(3017),
    [sym_number] = ACTIONS(3017),
    [sym__apostrophe] = ACTIONS(3015),
    [sym__double_quote] = ACTIONS(3015),
    [sym__backtick] = ACTIONS(3015),
    [sym__search_slash] = ACTIONS(3015),
    [sym__PERLY_HEREDOC] = ACTIONS(3015),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1054] = {
    [sym_heredoc_content] = STATE(1054),
    [sym__identifier] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_LBRACE2] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_package] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_sub] = ACTIONS(3028),
    [anon_sym_method] = ACTIONS(3028),
    [anon_sym_LPAREN] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_my] = ACTIONS(3028),
    [anon_sym_state] = ACTIONS(3028),
    [anon_sym_our] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_defer] = ACTIONS(3028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_else] = ACTIONS(3028),
    [anon_sym_elsif] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3028),
    [anon_sym_or] = ACTIONS(3028),
    [anon_sym_DOLLAR] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_AT] = ACTIONS(3028),
    [anon_sym_LT] = ACTIONS(3028),
    [anon_sym_LT_LT] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_eq] = ACTIONS(3028),
    [anon_sym_ne] = ACTIONS(3028),
    [anon_sym_cmp] = ACTIONS(3028),
    [anon_sym_lt] = ACTIONS(3028),
    [anon_sym_le] = ACTIONS(3028),
    [anon_sym_ge] = ACTIONS(3028),
    [anon_sym_gt] = ACTIONS(3028),
    [anon_sym_isa] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_BSLASH] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_eval] = ACTIONS(3028),
    [anon_sym_field] = ACTIONS(3028),
    [anon_sym_local] = ACTIONS(3028),
    [anon_sym_require] = ACTIONS(3028),
    [anon_sym_map] = ACTIONS(3028),
    [anon_sym_grep] = ACTIONS(3028),
    [anon_sym_sort] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_undef] = ACTIONS(3028),
    [anon_sym_PERCENT2] = ACTIONS(3028),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3028),
    [anon_sym_use] = ACTIONS(3028),
    [anon_sym_no] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_foreach] = ACTIONS(3028),
    [anon_sym_last] = ACTIONS(3028),
    [anon_sym_next] = ACTIONS(3028),
    [anon_sym_redo] = ACTIONS(3028),
    [anon_sym_BEGIN] = ACTIONS(3028),
    [anon_sym_INIT] = ACTIONS(3028),
    [anon_sym_CHECK] = ACTIONS(3028),
    [anon_sym_UNITCHECK] = ACTIONS(3028),
    [anon_sym_END] = ACTIONS(3028),
    [anon_sym_ADJUST] = ACTIONS(3028),
    [anon_sym___FILE__] = ACTIONS(3028),
    [anon_sym___LINE__] = ACTIONS(3028),
    [anon_sym___PACKAGE__] = ACTIONS(3028),
    [anon_sym___SUB__] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_fork] = ACTIONS(3028),
    [anon_sym_getppid] = ACTIONS(3028),
    [anon_sym_time] = ACTIONS(3028),
    [anon_sym_times] = ACTIONS(3028),
    [anon_sym_wait] = ACTIONS(3028),
    [anon_sym_wantarray] = ACTIONS(3028),
    [anon_sym_abs] = ACTIONS(3028),
    [anon_sym_alarm] = ACTIONS(3028),
    [anon_sym_chop] = ACTIONS(3028),
    [anon_sym_chdir] = ACTIONS(3028),
    [anon_sym_close] = ACTIONS(3028),
    [anon_sym_closedir] = ACTIONS(3028),
    [anon_sym_caller] = ACTIONS(3028),
    [anon_sym_chomp] = ACTIONS(3028),
    [anon_sym_chr] = ACTIONS(3028),
    [anon_sym_cos] = ACTIONS(3028),
    [anon_sym_chroot] = ACTIONS(3028),
    [anon_sym_defined] = ACTIONS(3028),
    [anon_sym_delete] = ACTIONS(3028),
    [anon_sym_dbmclose] = ACTIONS(3028),
    [anon_sym_exists] = ACTIONS(3028),
    [anon_sym_exit] = ACTIONS(3028),
    [anon_sym_eof] = ACTIONS(3028),
    [anon_sym_exp] = ACTIONS(3028),
    [anon_sym_each] = ACTIONS(3028),
    [anon_sym_fc] = ACTIONS(3028),
    [anon_sym_fileno] = ACTIONS(3028),
    [anon_sym_gmtime] = ACTIONS(3028),
    [anon_sym_getc] = ACTIONS(3028),
    [anon_sym_getpgrp] = ACTIONS(3028),
    [anon_sym_getprotobyname] = ACTIONS(3028),
    [anon_sym_getpwname] = ACTIONS(3028),
    [anon_sym_getpwuid] = ACTIONS(3028),
    [anon_sym_getpeername] = ACTIONS(3028),
    [anon_sym_getnetbyname] = ACTIONS(3028),
    [anon_sym_getsockname] = ACTIONS(3028),
    [anon_sym_getgrnam] = ACTIONS(3028),
    [anon_sym_getgrgid] = ACTIONS(3028),
    [anon_sym_hex] = ACTIONS(3028),
    [anon_sym_int] = ACTIONS(3028),
    [anon_sym_keys] = ACTIONS(3028),
    [anon_sym_lc] = ACTIONS(3028),
    [anon_sym_lcfirst] = ACTIONS(3028),
    [anon_sym_length] = ACTIONS(3028),
    [anon_sym_localtime] = ACTIONS(3028),
    [anon_sym_log] = ACTIONS(3028),
    [anon_sym_lock] = ACTIONS(3028),
    [anon_sym_lstat] = ACTIONS(3028),
    [anon_sym_oct] = ACTIONS(3028),
    [anon_sym_ord] = ACTIONS(3028),
    [anon_sym_prototype] = ACTIONS(3028),
    [anon_sym_pop] = ACTIONS(3028),
    [anon_sym_pos] = ACTIONS(3028),
    [anon_sym_quotemeta] = ACTIONS(3028),
    [anon_sym_reset] = ACTIONS(3028),
    [anon_sym_rand] = ACTIONS(3028),
    [anon_sym_rmdir] = ACTIONS(3028),
    [anon_sym_readdir] = ACTIONS(3028),
    [anon_sym_readline] = ACTIONS(3028),
    [anon_sym_readpipe] = ACTIONS(3028),
    [anon_sym_rewinddir] = ACTIONS(3028),
    [anon_sym_readlink] = ACTIONS(3028),
    [anon_sym_ref] = ACTIONS(3028),
    [anon_sym_scalar] = ACTIONS(3028),
    [anon_sym_shift] = ACTIONS(3028),
    [anon_sym_sin] = ACTIONS(3028),
    [anon_sym_sleep] = ACTIONS(3028),
    [anon_sym_sqrt] = ACTIONS(3028),
    [anon_sym_srand] = ACTIONS(3028),
    [anon_sym_stat] = ACTIONS(3028),
    [anon_sym_study] = ACTIONS(3028),
    [anon_sym_tell] = ACTIONS(3028),
    [anon_sym_telldir] = ACTIONS(3028),
    [anon_sym_tied] = ACTIONS(3028),
    [anon_sym_uc] = ACTIONS(3028),
    [anon_sym_ucfirst] = ACTIONS(3028),
    [anon_sym_untie] = ACTIONS(3028),
    [anon_sym_umask] = ACTIONS(3028),
    [anon_sym_values] = ACTIONS(3028),
    [anon_sym_write] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3028),
    [anon_sym___END__] = ACTIONS(3028),
    [anon_sym_q] = ACTIONS(3028),
    [anon_sym_qq] = ACTIONS(3028),
    [anon_sym_qw] = ACTIONS(3028),
    [anon_sym_qx] = ACTIONS(3028),
    [anon_sym_qr] = ACTIONS(3028),
    [anon_sym_m] = ACTIONS(3028),
    [anon_sym_s] = ACTIONS(3028),
    [anon_sym_tr] = ACTIONS(3028),
    [anon_sym_y] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_unless] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_until] = ACTIONS(3028),
    [aux_sym__bareword_token1] = ACTIONS(3028),
    [sym_number] = ACTIONS(3028),
    [sym__apostrophe] = ACTIONS(3026),
    [sym__double_quote] = ACTIONS(3026),
    [sym__backtick] = ACTIONS(3026),
    [sym__search_slash] = ACTIONS(3026),
    [sym__PERLY_HEREDOC] = ACTIONS(3026),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1055] = {
    [sym_heredoc_content] = STATE(1055),
    [sym__identifier] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_LBRACE2] = ACTIONS(3240),
    [anon_sym_RBRACE] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_package] = ACTIONS(3240),
    [anon_sym_class] = ACTIONS(3240),
    [anon_sym_sub] = ACTIONS(3240),
    [anon_sym_method] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_my] = ACTIONS(3240),
    [anon_sym_state] = ACTIONS(3240),
    [anon_sym_our] = ACTIONS(3240),
    [anon_sym_try] = ACTIONS(3240),
    [anon_sym_defer] = ACTIONS(3240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_else] = ACTIONS(3240),
    [anon_sym_elsif] = ACTIONS(3240),
    [anon_sym_and] = ACTIONS(3240),
    [anon_sym_or] = ACTIONS(3240),
    [anon_sym_DOLLAR] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_AT] = ACTIONS(3240),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_eq] = ACTIONS(3240),
    [anon_sym_ne] = ACTIONS(3240),
    [anon_sym_cmp] = ACTIONS(3240),
    [anon_sym_lt] = ACTIONS(3240),
    [anon_sym_le] = ACTIONS(3240),
    [anon_sym_ge] = ACTIONS(3240),
    [anon_sym_gt] = ACTIONS(3240),
    [anon_sym_isa] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_BSLASH] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3240),
    [anon_sym_eval] = ACTIONS(3240),
    [anon_sym_field] = ACTIONS(3240),
    [anon_sym_local] = ACTIONS(3240),
    [anon_sym_require] = ACTIONS(3240),
    [anon_sym_map] = ACTIONS(3240),
    [anon_sym_grep] = ACTIONS(3240),
    [anon_sym_sort] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_undef] = ACTIONS(3240),
    [anon_sym_PERCENT2] = ACTIONS(3240),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3240),
    [anon_sym_use] = ACTIONS(3240),
    [anon_sym_no] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_foreach] = ACTIONS(3240),
    [anon_sym_last] = ACTIONS(3240),
    [anon_sym_next] = ACTIONS(3240),
    [anon_sym_redo] = ACTIONS(3240),
    [anon_sym_BEGIN] = ACTIONS(3240),
    [anon_sym_INIT] = ACTIONS(3240),
    [anon_sym_CHECK] = ACTIONS(3240),
    [anon_sym_UNITCHECK] = ACTIONS(3240),
    [anon_sym_END] = ACTIONS(3240),
    [anon_sym_ADJUST] = ACTIONS(3240),
    [anon_sym___FILE__] = ACTIONS(3240),
    [anon_sym___LINE__] = ACTIONS(3240),
    [anon_sym___PACKAGE__] = ACTIONS(3240),
    [anon_sym___SUB__] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_fork] = ACTIONS(3240),
    [anon_sym_getppid] = ACTIONS(3240),
    [anon_sym_time] = ACTIONS(3240),
    [anon_sym_times] = ACTIONS(3240),
    [anon_sym_wait] = ACTIONS(3240),
    [anon_sym_wantarray] = ACTIONS(3240),
    [anon_sym_abs] = ACTIONS(3240),
    [anon_sym_alarm] = ACTIONS(3240),
    [anon_sym_chop] = ACTIONS(3240),
    [anon_sym_chdir] = ACTIONS(3240),
    [anon_sym_close] = ACTIONS(3240),
    [anon_sym_closedir] = ACTIONS(3240),
    [anon_sym_caller] = ACTIONS(3240),
    [anon_sym_chomp] = ACTIONS(3240),
    [anon_sym_chr] = ACTIONS(3240),
    [anon_sym_cos] = ACTIONS(3240),
    [anon_sym_chroot] = ACTIONS(3240),
    [anon_sym_defined] = ACTIONS(3240),
    [anon_sym_delete] = ACTIONS(3240),
    [anon_sym_dbmclose] = ACTIONS(3240),
    [anon_sym_exists] = ACTIONS(3240),
    [anon_sym_exit] = ACTIONS(3240),
    [anon_sym_eof] = ACTIONS(3240),
    [anon_sym_exp] = ACTIONS(3240),
    [anon_sym_each] = ACTIONS(3240),
    [anon_sym_fc] = ACTIONS(3240),
    [anon_sym_fileno] = ACTIONS(3240),
    [anon_sym_gmtime] = ACTIONS(3240),
    [anon_sym_getc] = ACTIONS(3240),
    [anon_sym_getpgrp] = ACTIONS(3240),
    [anon_sym_getprotobyname] = ACTIONS(3240),
    [anon_sym_getpwname] = ACTIONS(3240),
    [anon_sym_getpwuid] = ACTIONS(3240),
    [anon_sym_getpeername] = ACTIONS(3240),
    [anon_sym_getnetbyname] = ACTIONS(3240),
    [anon_sym_getsockname] = ACTIONS(3240),
    [anon_sym_getgrnam] = ACTIONS(3240),
    [anon_sym_getgrgid] = ACTIONS(3240),
    [anon_sym_hex] = ACTIONS(3240),
    [anon_sym_int] = ACTIONS(3240),
    [anon_sym_keys] = ACTIONS(3240),
    [anon_sym_lc] = ACTIONS(3240),
    [anon_sym_lcfirst] = ACTIONS(3240),
    [anon_sym_length] = ACTIONS(3240),
    [anon_sym_localtime] = ACTIONS(3240),
    [anon_sym_log] = ACTIONS(3240),
    [anon_sym_lock] = ACTIONS(3240),
    [anon_sym_lstat] = ACTIONS(3240),
    [anon_sym_oct] = ACTIONS(3240),
    [anon_sym_ord] = ACTIONS(3240),
    [anon_sym_prototype] = ACTIONS(3240),
    [anon_sym_pop] = ACTIONS(3240),
    [anon_sym_pos] = ACTIONS(3240),
    [anon_sym_quotemeta] = ACTIONS(3240),
    [anon_sym_reset] = ACTIONS(3240),
    [anon_sym_rand] = ACTIONS(3240),
    [anon_sym_rmdir] = ACTIONS(3240),
    [anon_sym_readdir] = ACTIONS(3240),
    [anon_sym_readline] = ACTIONS(3240),
    [anon_sym_readpipe] = ACTIONS(3240),
    [anon_sym_rewinddir] = ACTIONS(3240),
    [anon_sym_readlink] = ACTIONS(3240),
    [anon_sym_ref] = ACTIONS(3240),
    [anon_sym_scalar] = ACTIONS(3240),
    [anon_sym_shift] = ACTIONS(3240),
    [anon_sym_sin] = ACTIONS(3240),
    [anon_sym_sleep] = ACTIONS(3240),
    [anon_sym_sqrt] = ACTIONS(3240),
    [anon_sym_srand] = ACTIONS(3240),
    [anon_sym_stat] = ACTIONS(3240),
    [anon_sym_study] = ACTIONS(3240),
    [anon_sym_tell] = ACTIONS(3240),
    [anon_sym_telldir] = ACTIONS(3240),
    [anon_sym_tied] = ACTIONS(3240),
    [anon_sym_uc] = ACTIONS(3240),
    [anon_sym_ucfirst] = ACTIONS(3240),
    [anon_sym_untie] = ACTIONS(3240),
    [anon_sym_umask] = ACTIONS(3240),
    [anon_sym_values] = ACTIONS(3240),
    [anon_sym_write] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3240),
    [anon_sym___END__] = ACTIONS(3240),
    [anon_sym_q] = ACTIONS(3240),
    [anon_sym_qq] = ACTIONS(3240),
    [anon_sym_qw] = ACTIONS(3240),
    [anon_sym_qx] = ACTIONS(3240),
    [anon_sym_qr] = ACTIONS(3240),
    [anon_sym_m] = ACTIONS(3240),
    [anon_sym_s] = ACTIONS(3240),
    [anon_sym_tr] = ACTIONS(3240),
    [anon_sym_y] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_unless] = ACTIONS(3240),
    [anon_sym_while] = ACTIONS(3240),
    [anon_sym_until] = ACTIONS(3240),
    [aux_sym__bareword_token1] = ACTIONS(3240),
    [sym_number] = ACTIONS(3240),
    [sym__apostrophe] = ACTIONS(3238),
    [sym__double_quote] = ACTIONS(3238),
    [sym__backtick] = ACTIONS(3238),
    [sym__search_slash] = ACTIONS(3238),
    [sym__PERLY_HEREDOC] = ACTIONS(3238),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1056] = {
    [sym_heredoc_content] = STATE(1056),
    [sym__identifier] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LBRACE2] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_package] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_sub] = ACTIONS(3032),
    [anon_sym_method] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_my] = ACTIONS(3032),
    [anon_sym_state] = ACTIONS(3032),
    [anon_sym_our] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_defer] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3032),
    [anon_sym_else] = ACTIONS(3032),
    [anon_sym_elsif] = ACTIONS(3032),
    [anon_sym_and] = ACTIONS(3032),
    [anon_sym_or] = ACTIONS(3032),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_AT] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_SLASH_SLASH] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_eq] = ACTIONS(3032),
    [anon_sym_ne] = ACTIONS(3032),
    [anon_sym_cmp] = ACTIONS(3032),
    [anon_sym_lt] = ACTIONS(3032),
    [anon_sym_le] = ACTIONS(3032),
    [anon_sym_ge] = ACTIONS(3032),
    [anon_sym_gt] = ACTIONS(3032),
    [anon_sym_isa] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_BSLASH] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_eval] = ACTIONS(3032),
    [anon_sym_field] = ACTIONS(3032),
    [anon_sym_local] = ACTIONS(3032),
    [anon_sym_require] = ACTIONS(3032),
    [anon_sym_map] = ACTIONS(3032),
    [anon_sym_grep] = ACTIONS(3032),
    [anon_sym_sort] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_undef] = ACTIONS(3032),
    [anon_sym_PERCENT2] = ACTIONS(3032),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_no] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_foreach] = ACTIONS(3032),
    [anon_sym_last] = ACTIONS(3032),
    [anon_sym_next] = ACTIONS(3032),
    [anon_sym_redo] = ACTIONS(3032),
    [anon_sym_BEGIN] = ACTIONS(3032),
    [anon_sym_INIT] = ACTIONS(3032),
    [anon_sym_CHECK] = ACTIONS(3032),
    [anon_sym_UNITCHECK] = ACTIONS(3032),
    [anon_sym_END] = ACTIONS(3032),
    [anon_sym_ADJUST] = ACTIONS(3032),
    [anon_sym___FILE__] = ACTIONS(3032),
    [anon_sym___LINE__] = ACTIONS(3032),
    [anon_sym___PACKAGE__] = ACTIONS(3032),
    [anon_sym___SUB__] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_fork] = ACTIONS(3032),
    [anon_sym_getppid] = ACTIONS(3032),
    [anon_sym_time] = ACTIONS(3032),
    [anon_sym_times] = ACTIONS(3032),
    [anon_sym_wait] = ACTIONS(3032),
    [anon_sym_wantarray] = ACTIONS(3032),
    [anon_sym_abs] = ACTIONS(3032),
    [anon_sym_alarm] = ACTIONS(3032),
    [anon_sym_chop] = ACTIONS(3032),
    [anon_sym_chdir] = ACTIONS(3032),
    [anon_sym_close] = ACTIONS(3032),
    [anon_sym_closedir] = ACTIONS(3032),
    [anon_sym_caller] = ACTIONS(3032),
    [anon_sym_chomp] = ACTIONS(3032),
    [anon_sym_chr] = ACTIONS(3032),
    [anon_sym_cos] = ACTIONS(3032),
    [anon_sym_chroot] = ACTIONS(3032),
    [anon_sym_defined] = ACTIONS(3032),
    [anon_sym_delete] = ACTIONS(3032),
    [anon_sym_dbmclose] = ACTIONS(3032),
    [anon_sym_exists] = ACTIONS(3032),
    [anon_sym_exit] = ACTIONS(3032),
    [anon_sym_eof] = ACTIONS(3032),
    [anon_sym_exp] = ACTIONS(3032),
    [anon_sym_each] = ACTIONS(3032),
    [anon_sym_fc] = ACTIONS(3032),
    [anon_sym_fileno] = ACTIONS(3032),
    [anon_sym_gmtime] = ACTIONS(3032),
    [anon_sym_getc] = ACTIONS(3032),
    [anon_sym_getpgrp] = ACTIONS(3032),
    [anon_sym_getprotobyname] = ACTIONS(3032),
    [anon_sym_getpwname] = ACTIONS(3032),
    [anon_sym_getpwuid] = ACTIONS(3032),
    [anon_sym_getpeername] = ACTIONS(3032),
    [anon_sym_getnetbyname] = ACTIONS(3032),
    [anon_sym_getsockname] = ACTIONS(3032),
    [anon_sym_getgrnam] = ACTIONS(3032),
    [anon_sym_getgrgid] = ACTIONS(3032),
    [anon_sym_hex] = ACTIONS(3032),
    [anon_sym_int] = ACTIONS(3032),
    [anon_sym_keys] = ACTIONS(3032),
    [anon_sym_lc] = ACTIONS(3032),
    [anon_sym_lcfirst] = ACTIONS(3032),
    [anon_sym_length] = ACTIONS(3032),
    [anon_sym_localtime] = ACTIONS(3032),
    [anon_sym_log] = ACTIONS(3032),
    [anon_sym_lock] = ACTIONS(3032),
    [anon_sym_lstat] = ACTIONS(3032),
    [anon_sym_oct] = ACTIONS(3032),
    [anon_sym_ord] = ACTIONS(3032),
    [anon_sym_prototype] = ACTIONS(3032),
    [anon_sym_pop] = ACTIONS(3032),
    [anon_sym_pos] = ACTIONS(3032),
    [anon_sym_quotemeta] = ACTIONS(3032),
    [anon_sym_reset] = ACTIONS(3032),
    [anon_sym_rand] = ACTIONS(3032),
    [anon_sym_rmdir] = ACTIONS(3032),
    [anon_sym_readdir] = ACTIONS(3032),
    [anon_sym_readline] = ACTIONS(3032),
    [anon_sym_readpipe] = ACTIONS(3032),
    [anon_sym_rewinddir] = ACTIONS(3032),
    [anon_sym_readlink] = ACTIONS(3032),
    [anon_sym_ref] = ACTIONS(3032),
    [anon_sym_scalar] = ACTIONS(3032),
    [anon_sym_shift] = ACTIONS(3032),
    [anon_sym_sin] = ACTIONS(3032),
    [anon_sym_sleep] = ACTIONS(3032),
    [anon_sym_sqrt] = ACTIONS(3032),
    [anon_sym_srand] = ACTIONS(3032),
    [anon_sym_stat] = ACTIONS(3032),
    [anon_sym_study] = ACTIONS(3032),
    [anon_sym_tell] = ACTIONS(3032),
    [anon_sym_telldir] = ACTIONS(3032),
    [anon_sym_tied] = ACTIONS(3032),
    [anon_sym_uc] = ACTIONS(3032),
    [anon_sym_ucfirst] = ACTIONS(3032),
    [anon_sym_untie] = ACTIONS(3032),
    [anon_sym_umask] = ACTIONS(3032),
    [anon_sym_values] = ACTIONS(3032),
    [anon_sym_write] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3032),
    [anon_sym___END__] = ACTIONS(3032),
    [anon_sym_q] = ACTIONS(3032),
    [anon_sym_qq] = ACTIONS(3032),
    [anon_sym_qw] = ACTIONS(3032),
    [anon_sym_qx] = ACTIONS(3032),
    [anon_sym_qr] = ACTIONS(3032),
    [anon_sym_m] = ACTIONS(3032),
    [anon_sym_s] = ACTIONS(3032),
    [anon_sym_tr] = ACTIONS(3032),
    [anon_sym_y] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_unless] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_until] = ACTIONS(3032),
    [aux_sym__bareword_token1] = ACTIONS(3032),
    [sym_number] = ACTIONS(3032),
    [sym__apostrophe] = ACTIONS(3030),
    [sym__double_quote] = ACTIONS(3030),
    [sym__backtick] = ACTIONS(3030),
    [sym__search_slash] = ACTIONS(3030),
    [sym__PERLY_HEREDOC] = ACTIONS(3030),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1057] = {
    [sym_heredoc_content] = STATE(1057),
    [sym__identifier] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_LBRACE2] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym_package] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_sub] = ACTIONS(3036),
    [anon_sym_method] = ACTIONS(3036),
    [anon_sym_LPAREN] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_my] = ACTIONS(3036),
    [anon_sym_state] = ACTIONS(3036),
    [anon_sym_our] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_defer] = ACTIONS(3036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3036),
    [anon_sym_else] = ACTIONS(3036),
    [anon_sym_elsif] = ACTIONS(3036),
    [anon_sym_and] = ACTIONS(3036),
    [anon_sym_or] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_AT] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3036),
    [anon_sym_SLASH_SLASH] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_eq] = ACTIONS(3036),
    [anon_sym_ne] = ACTIONS(3036),
    [anon_sym_cmp] = ACTIONS(3036),
    [anon_sym_lt] = ACTIONS(3036),
    [anon_sym_le] = ACTIONS(3036),
    [anon_sym_ge] = ACTIONS(3036),
    [anon_sym_gt] = ACTIONS(3036),
    [anon_sym_isa] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_BSLASH] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_eval] = ACTIONS(3036),
    [anon_sym_field] = ACTIONS(3036),
    [anon_sym_local] = ACTIONS(3036),
    [anon_sym_require] = ACTIONS(3036),
    [anon_sym_map] = ACTIONS(3036),
    [anon_sym_grep] = ACTIONS(3036),
    [anon_sym_sort] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_undef] = ACTIONS(3036),
    [anon_sym_PERCENT2] = ACTIONS(3036),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3036),
    [anon_sym_use] = ACTIONS(3036),
    [anon_sym_no] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_foreach] = ACTIONS(3036),
    [anon_sym_last] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3036),
    [anon_sym_redo] = ACTIONS(3036),
    [anon_sym_BEGIN] = ACTIONS(3036),
    [anon_sym_INIT] = ACTIONS(3036),
    [anon_sym_CHECK] = ACTIONS(3036),
    [anon_sym_UNITCHECK] = ACTIONS(3036),
    [anon_sym_END] = ACTIONS(3036),
    [anon_sym_ADJUST] = ACTIONS(3036),
    [anon_sym___FILE__] = ACTIONS(3036),
    [anon_sym___LINE__] = ACTIONS(3036),
    [anon_sym___PACKAGE__] = ACTIONS(3036),
    [anon_sym___SUB__] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_fork] = ACTIONS(3036),
    [anon_sym_getppid] = ACTIONS(3036),
    [anon_sym_time] = ACTIONS(3036),
    [anon_sym_times] = ACTIONS(3036),
    [anon_sym_wait] = ACTIONS(3036),
    [anon_sym_wantarray] = ACTIONS(3036),
    [anon_sym_abs] = ACTIONS(3036),
    [anon_sym_alarm] = ACTIONS(3036),
    [anon_sym_chop] = ACTIONS(3036),
    [anon_sym_chdir] = ACTIONS(3036),
    [anon_sym_close] = ACTIONS(3036),
    [anon_sym_closedir] = ACTIONS(3036),
    [anon_sym_caller] = ACTIONS(3036),
    [anon_sym_chomp] = ACTIONS(3036),
    [anon_sym_chr] = ACTIONS(3036),
    [anon_sym_cos] = ACTIONS(3036),
    [anon_sym_chroot] = ACTIONS(3036),
    [anon_sym_defined] = ACTIONS(3036),
    [anon_sym_delete] = ACTIONS(3036),
    [anon_sym_dbmclose] = ACTIONS(3036),
    [anon_sym_exists] = ACTIONS(3036),
    [anon_sym_exit] = ACTIONS(3036),
    [anon_sym_eof] = ACTIONS(3036),
    [anon_sym_exp] = ACTIONS(3036),
    [anon_sym_each] = ACTIONS(3036),
    [anon_sym_fc] = ACTIONS(3036),
    [anon_sym_fileno] = ACTIONS(3036),
    [anon_sym_gmtime] = ACTIONS(3036),
    [anon_sym_getc] = ACTIONS(3036),
    [anon_sym_getpgrp] = ACTIONS(3036),
    [anon_sym_getprotobyname] = ACTIONS(3036),
    [anon_sym_getpwname] = ACTIONS(3036),
    [anon_sym_getpwuid] = ACTIONS(3036),
    [anon_sym_getpeername] = ACTIONS(3036),
    [anon_sym_getnetbyname] = ACTIONS(3036),
    [anon_sym_getsockname] = ACTIONS(3036),
    [anon_sym_getgrnam] = ACTIONS(3036),
    [anon_sym_getgrgid] = ACTIONS(3036),
    [anon_sym_hex] = ACTIONS(3036),
    [anon_sym_int] = ACTIONS(3036),
    [anon_sym_keys] = ACTIONS(3036),
    [anon_sym_lc] = ACTIONS(3036),
    [anon_sym_lcfirst] = ACTIONS(3036),
    [anon_sym_length] = ACTIONS(3036),
    [anon_sym_localtime] = ACTIONS(3036),
    [anon_sym_log] = ACTIONS(3036),
    [anon_sym_lock] = ACTIONS(3036),
    [anon_sym_lstat] = ACTIONS(3036),
    [anon_sym_oct] = ACTIONS(3036),
    [anon_sym_ord] = ACTIONS(3036),
    [anon_sym_prototype] = ACTIONS(3036),
    [anon_sym_pop] = ACTIONS(3036),
    [anon_sym_pos] = ACTIONS(3036),
    [anon_sym_quotemeta] = ACTIONS(3036),
    [anon_sym_reset] = ACTIONS(3036),
    [anon_sym_rand] = ACTIONS(3036),
    [anon_sym_rmdir] = ACTIONS(3036),
    [anon_sym_readdir] = ACTIONS(3036),
    [anon_sym_readline] = ACTIONS(3036),
    [anon_sym_readpipe] = ACTIONS(3036),
    [anon_sym_rewinddir] = ACTIONS(3036),
    [anon_sym_readlink] = ACTIONS(3036),
    [anon_sym_ref] = ACTIONS(3036),
    [anon_sym_scalar] = ACTIONS(3036),
    [anon_sym_shift] = ACTIONS(3036),
    [anon_sym_sin] = ACTIONS(3036),
    [anon_sym_sleep] = ACTIONS(3036),
    [anon_sym_sqrt] = ACTIONS(3036),
    [anon_sym_srand] = ACTIONS(3036),
    [anon_sym_stat] = ACTIONS(3036),
    [anon_sym_study] = ACTIONS(3036),
    [anon_sym_tell] = ACTIONS(3036),
    [anon_sym_telldir] = ACTIONS(3036),
    [anon_sym_tied] = ACTIONS(3036),
    [anon_sym_uc] = ACTIONS(3036),
    [anon_sym_ucfirst] = ACTIONS(3036),
    [anon_sym_untie] = ACTIONS(3036),
    [anon_sym_umask] = ACTIONS(3036),
    [anon_sym_values] = ACTIONS(3036),
    [anon_sym_write] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3036),
    [anon_sym___END__] = ACTIONS(3036),
    [anon_sym_q] = ACTIONS(3036),
    [anon_sym_qq] = ACTIONS(3036),
    [anon_sym_qw] = ACTIONS(3036),
    [anon_sym_qx] = ACTIONS(3036),
    [anon_sym_qr] = ACTIONS(3036),
    [anon_sym_m] = ACTIONS(3036),
    [anon_sym_s] = ACTIONS(3036),
    [anon_sym_tr] = ACTIONS(3036),
    [anon_sym_y] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_unless] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_until] = ACTIONS(3036),
    [aux_sym__bareword_token1] = ACTIONS(3036),
    [sym_number] = ACTIONS(3036),
    [sym__apostrophe] = ACTIONS(3034),
    [sym__double_quote] = ACTIONS(3034),
    [sym__backtick] = ACTIONS(3034),
    [sym__search_slash] = ACTIONS(3034),
    [sym__PERLY_HEREDOC] = ACTIONS(3034),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1058] = {
    [sym_heredoc_content] = STATE(1058),
    [sym__identifier] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_LBRACE2] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_package] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_sub] = ACTIONS(3052),
    [anon_sym_method] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_my] = ACTIONS(3052),
    [anon_sym_state] = ACTIONS(3052),
    [anon_sym_our] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_defer] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3052),
    [anon_sym_elsif] = ACTIONS(3052),
    [anon_sym_and] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3052),
    [anon_sym_DOLLAR] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_SLASH_SLASH] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_eq] = ACTIONS(3052),
    [anon_sym_ne] = ACTIONS(3052),
    [anon_sym_cmp] = ACTIONS(3052),
    [anon_sym_lt] = ACTIONS(3052),
    [anon_sym_le] = ACTIONS(3052),
    [anon_sym_ge] = ACTIONS(3052),
    [anon_sym_gt] = ACTIONS(3052),
    [anon_sym_isa] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_BSLASH] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_eval] = ACTIONS(3052),
    [anon_sym_field] = ACTIONS(3052),
    [anon_sym_local] = ACTIONS(3052),
    [anon_sym_require] = ACTIONS(3052),
    [anon_sym_map] = ACTIONS(3052),
    [anon_sym_grep] = ACTIONS(3052),
    [anon_sym_sort] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_undef] = ACTIONS(3052),
    [anon_sym_PERCENT2] = ACTIONS(3052),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3052),
    [anon_sym_use] = ACTIONS(3052),
    [anon_sym_no] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_foreach] = ACTIONS(3052),
    [anon_sym_last] = ACTIONS(3052),
    [anon_sym_next] = ACTIONS(3052),
    [anon_sym_redo] = ACTIONS(3052),
    [anon_sym_BEGIN] = ACTIONS(3052),
    [anon_sym_INIT] = ACTIONS(3052),
    [anon_sym_CHECK] = ACTIONS(3052),
    [anon_sym_UNITCHECK] = ACTIONS(3052),
    [anon_sym_END] = ACTIONS(3052),
    [anon_sym_ADJUST] = ACTIONS(3052),
    [anon_sym___FILE__] = ACTIONS(3052),
    [anon_sym___LINE__] = ACTIONS(3052),
    [anon_sym___PACKAGE__] = ACTIONS(3052),
    [anon_sym___SUB__] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_fork] = ACTIONS(3052),
    [anon_sym_getppid] = ACTIONS(3052),
    [anon_sym_time] = ACTIONS(3052),
    [anon_sym_times] = ACTIONS(3052),
    [anon_sym_wait] = ACTIONS(3052),
    [anon_sym_wantarray] = ACTIONS(3052),
    [anon_sym_abs] = ACTIONS(3052),
    [anon_sym_alarm] = ACTIONS(3052),
    [anon_sym_chop] = ACTIONS(3052),
    [anon_sym_chdir] = ACTIONS(3052),
    [anon_sym_close] = ACTIONS(3052),
    [anon_sym_closedir] = ACTIONS(3052),
    [anon_sym_caller] = ACTIONS(3052),
    [anon_sym_chomp] = ACTIONS(3052),
    [anon_sym_chr] = ACTIONS(3052),
    [anon_sym_cos] = ACTIONS(3052),
    [anon_sym_chroot] = ACTIONS(3052),
    [anon_sym_defined] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_dbmclose] = ACTIONS(3052),
    [anon_sym_exists] = ACTIONS(3052),
    [anon_sym_exit] = ACTIONS(3052),
    [anon_sym_eof] = ACTIONS(3052),
    [anon_sym_exp] = ACTIONS(3052),
    [anon_sym_each] = ACTIONS(3052),
    [anon_sym_fc] = ACTIONS(3052),
    [anon_sym_fileno] = ACTIONS(3052),
    [anon_sym_gmtime] = ACTIONS(3052),
    [anon_sym_getc] = ACTIONS(3052),
    [anon_sym_getpgrp] = ACTIONS(3052),
    [anon_sym_getprotobyname] = ACTIONS(3052),
    [anon_sym_getpwname] = ACTIONS(3052),
    [anon_sym_getpwuid] = ACTIONS(3052),
    [anon_sym_getpeername] = ACTIONS(3052),
    [anon_sym_getnetbyname] = ACTIONS(3052),
    [anon_sym_getsockname] = ACTIONS(3052),
    [anon_sym_getgrnam] = ACTIONS(3052),
    [anon_sym_getgrgid] = ACTIONS(3052),
    [anon_sym_hex] = ACTIONS(3052),
    [anon_sym_int] = ACTIONS(3052),
    [anon_sym_keys] = ACTIONS(3052),
    [anon_sym_lc] = ACTIONS(3052),
    [anon_sym_lcfirst] = ACTIONS(3052),
    [anon_sym_length] = ACTIONS(3052),
    [anon_sym_localtime] = ACTIONS(3052),
    [anon_sym_log] = ACTIONS(3052),
    [anon_sym_lock] = ACTIONS(3052),
    [anon_sym_lstat] = ACTIONS(3052),
    [anon_sym_oct] = ACTIONS(3052),
    [anon_sym_ord] = ACTIONS(3052),
    [anon_sym_prototype] = ACTIONS(3052),
    [anon_sym_pop] = ACTIONS(3052),
    [anon_sym_pos] = ACTIONS(3052),
    [anon_sym_quotemeta] = ACTIONS(3052),
    [anon_sym_reset] = ACTIONS(3052),
    [anon_sym_rand] = ACTIONS(3052),
    [anon_sym_rmdir] = ACTIONS(3052),
    [anon_sym_readdir] = ACTIONS(3052),
    [anon_sym_readline] = ACTIONS(3052),
    [anon_sym_readpipe] = ACTIONS(3052),
    [anon_sym_rewinddir] = ACTIONS(3052),
    [anon_sym_readlink] = ACTIONS(3052),
    [anon_sym_ref] = ACTIONS(3052),
    [anon_sym_scalar] = ACTIONS(3052),
    [anon_sym_shift] = ACTIONS(3052),
    [anon_sym_sin] = ACTIONS(3052),
    [anon_sym_sleep] = ACTIONS(3052),
    [anon_sym_sqrt] = ACTIONS(3052),
    [anon_sym_srand] = ACTIONS(3052),
    [anon_sym_stat] = ACTIONS(3052),
    [anon_sym_study] = ACTIONS(3052),
    [anon_sym_tell] = ACTIONS(3052),
    [anon_sym_telldir] = ACTIONS(3052),
    [anon_sym_tied] = ACTIONS(3052),
    [anon_sym_uc] = ACTIONS(3052),
    [anon_sym_ucfirst] = ACTIONS(3052),
    [anon_sym_untie] = ACTIONS(3052),
    [anon_sym_umask] = ACTIONS(3052),
    [anon_sym_values] = ACTIONS(3052),
    [anon_sym_write] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3052),
    [anon_sym___END__] = ACTIONS(3052),
    [anon_sym_q] = ACTIONS(3052),
    [anon_sym_qq] = ACTIONS(3052),
    [anon_sym_qw] = ACTIONS(3052),
    [anon_sym_qx] = ACTIONS(3052),
    [anon_sym_qr] = ACTIONS(3052),
    [anon_sym_m] = ACTIONS(3052),
    [anon_sym_s] = ACTIONS(3052),
    [anon_sym_tr] = ACTIONS(3052),
    [anon_sym_y] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_unless] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_until] = ACTIONS(3052),
    [aux_sym__bareword_token1] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [sym__apostrophe] = ACTIONS(3050),
    [sym__double_quote] = ACTIONS(3050),
    [sym__backtick] = ACTIONS(3050),
    [sym__search_slash] = ACTIONS(3050),
    [sym__PERLY_HEREDOC] = ACTIONS(3050),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1059] = {
    [sym_heredoc_content] = STATE(1059),
    [sym__identifier] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_LBRACE2] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_package] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_sub] = ACTIONS(3082),
    [anon_sym_method] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_my] = ACTIONS(3082),
    [anon_sym_state] = ACTIONS(3082),
    [anon_sym_our] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_defer] = ACTIONS(3082),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_elsif] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3082),
    [anon_sym_or] = ACTIONS(3082),
    [anon_sym_DOLLAR] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_LT_LT] = ACTIONS(3082),
    [anon_sym_SLASH_SLASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3082),
    [anon_sym_eq] = ACTIONS(3082),
    [anon_sym_ne] = ACTIONS(3082),
    [anon_sym_cmp] = ACTIONS(3082),
    [anon_sym_lt] = ACTIONS(3082),
    [anon_sym_le] = ACTIONS(3082),
    [anon_sym_ge] = ACTIONS(3082),
    [anon_sym_gt] = ACTIONS(3082),
    [anon_sym_isa] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [anon_sym_BSLASH] = ACTIONS(3080),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_eval] = ACTIONS(3082),
    [anon_sym_field] = ACTIONS(3082),
    [anon_sym_local] = ACTIONS(3082),
    [anon_sym_require] = ACTIONS(3082),
    [anon_sym_map] = ACTIONS(3082),
    [anon_sym_grep] = ACTIONS(3082),
    [anon_sym_sort] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_undef] = ACTIONS(3082),
    [anon_sym_PERCENT2] = ACTIONS(3082),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3082),
    [anon_sym_use] = ACTIONS(3082),
    [anon_sym_no] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_foreach] = ACTIONS(3082),
    [anon_sym_last] = ACTIONS(3082),
    [anon_sym_next] = ACTIONS(3082),
    [anon_sym_redo] = ACTIONS(3082),
    [anon_sym_BEGIN] = ACTIONS(3082),
    [anon_sym_INIT] = ACTIONS(3082),
    [anon_sym_CHECK] = ACTIONS(3082),
    [anon_sym_UNITCHECK] = ACTIONS(3082),
    [anon_sym_END] = ACTIONS(3082),
    [anon_sym_ADJUST] = ACTIONS(3082),
    [anon_sym___FILE__] = ACTIONS(3082),
    [anon_sym___LINE__] = ACTIONS(3082),
    [anon_sym___PACKAGE__] = ACTIONS(3082),
    [anon_sym___SUB__] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_fork] = ACTIONS(3082),
    [anon_sym_getppid] = ACTIONS(3082),
    [anon_sym_time] = ACTIONS(3082),
    [anon_sym_times] = ACTIONS(3082),
    [anon_sym_wait] = ACTIONS(3082),
    [anon_sym_wantarray] = ACTIONS(3082),
    [anon_sym_abs] = ACTIONS(3082),
    [anon_sym_alarm] = ACTIONS(3082),
    [anon_sym_chop] = ACTIONS(3082),
    [anon_sym_chdir] = ACTIONS(3082),
    [anon_sym_close] = ACTIONS(3082),
    [anon_sym_closedir] = ACTIONS(3082),
    [anon_sym_caller] = ACTIONS(3082),
    [anon_sym_chomp] = ACTIONS(3082),
    [anon_sym_chr] = ACTIONS(3082),
    [anon_sym_cos] = ACTIONS(3082),
    [anon_sym_chroot] = ACTIONS(3082),
    [anon_sym_defined] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_dbmclose] = ACTIONS(3082),
    [anon_sym_exists] = ACTIONS(3082),
    [anon_sym_exit] = ACTIONS(3082),
    [anon_sym_eof] = ACTIONS(3082),
    [anon_sym_exp] = ACTIONS(3082),
    [anon_sym_each] = ACTIONS(3082),
    [anon_sym_fc] = ACTIONS(3082),
    [anon_sym_fileno] = ACTIONS(3082),
    [anon_sym_gmtime] = ACTIONS(3082),
    [anon_sym_getc] = ACTIONS(3082),
    [anon_sym_getpgrp] = ACTIONS(3082),
    [anon_sym_getprotobyname] = ACTIONS(3082),
    [anon_sym_getpwname] = ACTIONS(3082),
    [anon_sym_getpwuid] = ACTIONS(3082),
    [anon_sym_getpeername] = ACTIONS(3082),
    [anon_sym_getnetbyname] = ACTIONS(3082),
    [anon_sym_getsockname] = ACTIONS(3082),
    [anon_sym_getgrnam] = ACTIONS(3082),
    [anon_sym_getgrgid] = ACTIONS(3082),
    [anon_sym_hex] = ACTIONS(3082),
    [anon_sym_int] = ACTIONS(3082),
    [anon_sym_keys] = ACTIONS(3082),
    [anon_sym_lc] = ACTIONS(3082),
    [anon_sym_lcfirst] = ACTIONS(3082),
    [anon_sym_length] = ACTIONS(3082),
    [anon_sym_localtime] = ACTIONS(3082),
    [anon_sym_log] = ACTIONS(3082),
    [anon_sym_lock] = ACTIONS(3082),
    [anon_sym_lstat] = ACTIONS(3082),
    [anon_sym_oct] = ACTIONS(3082),
    [anon_sym_ord] = ACTIONS(3082),
    [anon_sym_prototype] = ACTIONS(3082),
    [anon_sym_pop] = ACTIONS(3082),
    [anon_sym_pos] = ACTIONS(3082),
    [anon_sym_quotemeta] = ACTIONS(3082),
    [anon_sym_reset] = ACTIONS(3082),
    [anon_sym_rand] = ACTIONS(3082),
    [anon_sym_rmdir] = ACTIONS(3082),
    [anon_sym_readdir] = ACTIONS(3082),
    [anon_sym_readline] = ACTIONS(3082),
    [anon_sym_readpipe] = ACTIONS(3082),
    [anon_sym_rewinddir] = ACTIONS(3082),
    [anon_sym_readlink] = ACTIONS(3082),
    [anon_sym_ref] = ACTIONS(3082),
    [anon_sym_scalar] = ACTIONS(3082),
    [anon_sym_shift] = ACTIONS(3082),
    [anon_sym_sin] = ACTIONS(3082),
    [anon_sym_sleep] = ACTIONS(3082),
    [anon_sym_sqrt] = ACTIONS(3082),
    [anon_sym_srand] = ACTIONS(3082),
    [anon_sym_stat] = ACTIONS(3082),
    [anon_sym_study] = ACTIONS(3082),
    [anon_sym_tell] = ACTIONS(3082),
    [anon_sym_telldir] = ACTIONS(3082),
    [anon_sym_tied] = ACTIONS(3082),
    [anon_sym_uc] = ACTIONS(3082),
    [anon_sym_ucfirst] = ACTIONS(3082),
    [anon_sym_untie] = ACTIONS(3082),
    [anon_sym_umask] = ACTIONS(3082),
    [anon_sym_values] = ACTIONS(3082),
    [anon_sym_write] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3082),
    [anon_sym___END__] = ACTIONS(3082),
    [anon_sym_q] = ACTIONS(3082),
    [anon_sym_qq] = ACTIONS(3082),
    [anon_sym_qw] = ACTIONS(3082),
    [anon_sym_qx] = ACTIONS(3082),
    [anon_sym_qr] = ACTIONS(3082),
    [anon_sym_m] = ACTIONS(3082),
    [anon_sym_s] = ACTIONS(3082),
    [anon_sym_tr] = ACTIONS(3082),
    [anon_sym_y] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_unless] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_until] = ACTIONS(3082),
    [aux_sym__bareword_token1] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym__apostrophe] = ACTIONS(3080),
    [sym__double_quote] = ACTIONS(3080),
    [sym__backtick] = ACTIONS(3080),
    [sym__search_slash] = ACTIONS(3080),
    [sym__PERLY_HEREDOC] = ACTIONS(3080),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1060] = {
    [sym_heredoc_content] = STATE(1060),
    [sym__identifier] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_LBRACE2] = ACTIONS(3093),
    [anon_sym_RBRACE] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_package] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_sub] = ACTIONS(3093),
    [anon_sym_method] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_my] = ACTIONS(3093),
    [anon_sym_state] = ACTIONS(3093),
    [anon_sym_our] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_defer] = ACTIONS(3093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3093),
    [anon_sym_else] = ACTIONS(3093),
    [anon_sym_elsif] = ACTIONS(3093),
    [anon_sym_and] = ACTIONS(3093),
    [anon_sym_or] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_SLASH_SLASH] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_eq] = ACTIONS(3093),
    [anon_sym_ne] = ACTIONS(3093),
    [anon_sym_cmp] = ACTIONS(3093),
    [anon_sym_lt] = ACTIONS(3093),
    [anon_sym_le] = ACTIONS(3093),
    [anon_sym_ge] = ACTIONS(3093),
    [anon_sym_gt] = ACTIONS(3093),
    [anon_sym_isa] = ACTIONS(3093),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [anon_sym_BSLASH] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_eval] = ACTIONS(3093),
    [anon_sym_field] = ACTIONS(3093),
    [anon_sym_local] = ACTIONS(3093),
    [anon_sym_require] = ACTIONS(3093),
    [anon_sym_map] = ACTIONS(3093),
    [anon_sym_grep] = ACTIONS(3093),
    [anon_sym_sort] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_undef] = ACTIONS(3093),
    [anon_sym_PERCENT2] = ACTIONS(3093),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3093),
    [anon_sym_no] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_foreach] = ACTIONS(3093),
    [anon_sym_last] = ACTIONS(3093),
    [anon_sym_next] = ACTIONS(3093),
    [anon_sym_redo] = ACTIONS(3093),
    [anon_sym_BEGIN] = ACTIONS(3093),
    [anon_sym_INIT] = ACTIONS(3093),
    [anon_sym_CHECK] = ACTIONS(3093),
    [anon_sym_UNITCHECK] = ACTIONS(3093),
    [anon_sym_END] = ACTIONS(3093),
    [anon_sym_ADJUST] = ACTIONS(3093),
    [anon_sym___FILE__] = ACTIONS(3093),
    [anon_sym___LINE__] = ACTIONS(3093),
    [anon_sym___PACKAGE__] = ACTIONS(3093),
    [anon_sym___SUB__] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_fork] = ACTIONS(3093),
    [anon_sym_getppid] = ACTIONS(3093),
    [anon_sym_time] = ACTIONS(3093),
    [anon_sym_times] = ACTIONS(3093),
    [anon_sym_wait] = ACTIONS(3093),
    [anon_sym_wantarray] = ACTIONS(3093),
    [anon_sym_abs] = ACTIONS(3093),
    [anon_sym_alarm] = ACTIONS(3093),
    [anon_sym_chop] = ACTIONS(3093),
    [anon_sym_chdir] = ACTIONS(3093),
    [anon_sym_close] = ACTIONS(3093),
    [anon_sym_closedir] = ACTIONS(3093),
    [anon_sym_caller] = ACTIONS(3093),
    [anon_sym_chomp] = ACTIONS(3093),
    [anon_sym_chr] = ACTIONS(3093),
    [anon_sym_cos] = ACTIONS(3093),
    [anon_sym_chroot] = ACTIONS(3093),
    [anon_sym_defined] = ACTIONS(3093),
    [anon_sym_delete] = ACTIONS(3093),
    [anon_sym_dbmclose] = ACTIONS(3093),
    [anon_sym_exists] = ACTIONS(3093),
    [anon_sym_exit] = ACTIONS(3093),
    [anon_sym_eof] = ACTIONS(3093),
    [anon_sym_exp] = ACTIONS(3093),
    [anon_sym_each] = ACTIONS(3093),
    [anon_sym_fc] = ACTIONS(3093),
    [anon_sym_fileno] = ACTIONS(3093),
    [anon_sym_gmtime] = ACTIONS(3093),
    [anon_sym_getc] = ACTIONS(3093),
    [anon_sym_getpgrp] = ACTIONS(3093),
    [anon_sym_getprotobyname] = ACTIONS(3093),
    [anon_sym_getpwname] = ACTIONS(3093),
    [anon_sym_getpwuid] = ACTIONS(3093),
    [anon_sym_getpeername] = ACTIONS(3093),
    [anon_sym_getnetbyname] = ACTIONS(3093),
    [anon_sym_getsockname] = ACTIONS(3093),
    [anon_sym_getgrnam] = ACTIONS(3093),
    [anon_sym_getgrgid] = ACTIONS(3093),
    [anon_sym_hex] = ACTIONS(3093),
    [anon_sym_int] = ACTIONS(3093),
    [anon_sym_keys] = ACTIONS(3093),
    [anon_sym_lc] = ACTIONS(3093),
    [anon_sym_lcfirst] = ACTIONS(3093),
    [anon_sym_length] = ACTIONS(3093),
    [anon_sym_localtime] = ACTIONS(3093),
    [anon_sym_log] = ACTIONS(3093),
    [anon_sym_lock] = ACTIONS(3093),
    [anon_sym_lstat] = ACTIONS(3093),
    [anon_sym_oct] = ACTIONS(3093),
    [anon_sym_ord] = ACTIONS(3093),
    [anon_sym_prototype] = ACTIONS(3093),
    [anon_sym_pop] = ACTIONS(3093),
    [anon_sym_pos] = ACTIONS(3093),
    [anon_sym_quotemeta] = ACTIONS(3093),
    [anon_sym_reset] = ACTIONS(3093),
    [anon_sym_rand] = ACTIONS(3093),
    [anon_sym_rmdir] = ACTIONS(3093),
    [anon_sym_readdir] = ACTIONS(3093),
    [anon_sym_readline] = ACTIONS(3093),
    [anon_sym_readpipe] = ACTIONS(3093),
    [anon_sym_rewinddir] = ACTIONS(3093),
    [anon_sym_readlink] = ACTIONS(3093),
    [anon_sym_ref] = ACTIONS(3093),
    [anon_sym_scalar] = ACTIONS(3093),
    [anon_sym_shift] = ACTIONS(3093),
    [anon_sym_sin] = ACTIONS(3093),
    [anon_sym_sleep] = ACTIONS(3093),
    [anon_sym_sqrt] = ACTIONS(3093),
    [anon_sym_srand] = ACTIONS(3093),
    [anon_sym_stat] = ACTIONS(3093),
    [anon_sym_study] = ACTIONS(3093),
    [anon_sym_tell] = ACTIONS(3093),
    [anon_sym_telldir] = ACTIONS(3093),
    [anon_sym_tied] = ACTIONS(3093),
    [anon_sym_uc] = ACTIONS(3093),
    [anon_sym_ucfirst] = ACTIONS(3093),
    [anon_sym_untie] = ACTIONS(3093),
    [anon_sym_umask] = ACTIONS(3093),
    [anon_sym_values] = ACTIONS(3093),
    [anon_sym_write] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3093),
    [anon_sym___END__] = ACTIONS(3093),
    [anon_sym_q] = ACTIONS(3093),
    [anon_sym_qq] = ACTIONS(3093),
    [anon_sym_qw] = ACTIONS(3093),
    [anon_sym_qx] = ACTIONS(3093),
    [anon_sym_qr] = ACTIONS(3093),
    [anon_sym_m] = ACTIONS(3093),
    [anon_sym_s] = ACTIONS(3093),
    [anon_sym_tr] = ACTIONS(3093),
    [anon_sym_y] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_unless] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_until] = ACTIONS(3093),
    [aux_sym__bareword_token1] = ACTIONS(3093),
    [sym_number] = ACTIONS(3093),
    [sym__apostrophe] = ACTIONS(3091),
    [sym__double_quote] = ACTIONS(3091),
    [sym__backtick] = ACTIONS(3091),
    [sym__search_slash] = ACTIONS(3091),
    [sym__PERLY_HEREDOC] = ACTIONS(3091),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1061] = {
    [sym_heredoc_content] = STATE(1061),
    [sym__identifier] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3097),
    [anon_sym_LBRACE2] = ACTIONS(3097),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_package] = ACTIONS(3097),
    [anon_sym_class] = ACTIONS(3097),
    [anon_sym_sub] = ACTIONS(3097),
    [anon_sym_method] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3097),
    [anon_sym_continue] = ACTIONS(3097),
    [anon_sym_my] = ACTIONS(3097),
    [anon_sym_state] = ACTIONS(3097),
    [anon_sym_our] = ACTIONS(3097),
    [anon_sym_try] = ACTIONS(3097),
    [anon_sym_defer] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(3097),
    [anon_sym_elsif] = ACTIONS(3097),
    [anon_sym_and] = ACTIONS(3097),
    [anon_sym_or] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3097),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_AT] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_SLASH_SLASH] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_eq] = ACTIONS(3097),
    [anon_sym_ne] = ACTIONS(3097),
    [anon_sym_cmp] = ACTIONS(3097),
    [anon_sym_lt] = ACTIONS(3097),
    [anon_sym_le] = ACTIONS(3097),
    [anon_sym_ge] = ACTIONS(3097),
    [anon_sym_gt] = ACTIONS(3097),
    [anon_sym_isa] = ACTIONS(3097),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_PLUS_PLUS] = ACTIONS(3097),
    [anon_sym_DASH_DASH] = ACTIONS(3097),
    [anon_sym_BSLASH] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3097),
    [anon_sym_eval] = ACTIONS(3097),
    [anon_sym_field] = ACTIONS(3097),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_require] = ACTIONS(3097),
    [anon_sym_map] = ACTIONS(3097),
    [anon_sym_grep] = ACTIONS(3097),
    [anon_sym_sort] = ACTIONS(3097),
    [anon_sym_goto] = ACTIONS(3097),
    [anon_sym_return] = ACTIONS(3097),
    [anon_sym_undef] = ACTIONS(3097),
    [anon_sym_PERCENT2] = ACTIONS(3097),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3097),
    [anon_sym_no] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3097),
    [anon_sym_foreach] = ACTIONS(3097),
    [anon_sym_last] = ACTIONS(3097),
    [anon_sym_next] = ACTIONS(3097),
    [anon_sym_redo] = ACTIONS(3097),
    [anon_sym_BEGIN] = ACTIONS(3097),
    [anon_sym_INIT] = ACTIONS(3097),
    [anon_sym_CHECK] = ACTIONS(3097),
    [anon_sym_UNITCHECK] = ACTIONS(3097),
    [anon_sym_END] = ACTIONS(3097),
    [anon_sym_ADJUST] = ACTIONS(3097),
    [anon_sym___FILE__] = ACTIONS(3097),
    [anon_sym___LINE__] = ACTIONS(3097),
    [anon_sym___PACKAGE__] = ACTIONS(3097),
    [anon_sym___SUB__] = ACTIONS(3097),
    [anon_sym_break] = ACTIONS(3097),
    [anon_sym_fork] = ACTIONS(3097),
    [anon_sym_getppid] = ACTIONS(3097),
    [anon_sym_time] = ACTIONS(3097),
    [anon_sym_times] = ACTIONS(3097),
    [anon_sym_wait] = ACTIONS(3097),
    [anon_sym_wantarray] = ACTIONS(3097),
    [anon_sym_abs] = ACTIONS(3097),
    [anon_sym_alarm] = ACTIONS(3097),
    [anon_sym_chop] = ACTIONS(3097),
    [anon_sym_chdir] = ACTIONS(3097),
    [anon_sym_close] = ACTIONS(3097),
    [anon_sym_closedir] = ACTIONS(3097),
    [anon_sym_caller] = ACTIONS(3097),
    [anon_sym_chomp] = ACTIONS(3097),
    [anon_sym_chr] = ACTIONS(3097),
    [anon_sym_cos] = ACTIONS(3097),
    [anon_sym_chroot] = ACTIONS(3097),
    [anon_sym_defined] = ACTIONS(3097),
    [anon_sym_delete] = ACTIONS(3097),
    [anon_sym_dbmclose] = ACTIONS(3097),
    [anon_sym_exists] = ACTIONS(3097),
    [anon_sym_exit] = ACTIONS(3097),
    [anon_sym_eof] = ACTIONS(3097),
    [anon_sym_exp] = ACTIONS(3097),
    [anon_sym_each] = ACTIONS(3097),
    [anon_sym_fc] = ACTIONS(3097),
    [anon_sym_fileno] = ACTIONS(3097),
    [anon_sym_gmtime] = ACTIONS(3097),
    [anon_sym_getc] = ACTIONS(3097),
    [anon_sym_getpgrp] = ACTIONS(3097),
    [anon_sym_getprotobyname] = ACTIONS(3097),
    [anon_sym_getpwname] = ACTIONS(3097),
    [anon_sym_getpwuid] = ACTIONS(3097),
    [anon_sym_getpeername] = ACTIONS(3097),
    [anon_sym_getnetbyname] = ACTIONS(3097),
    [anon_sym_getsockname] = ACTIONS(3097),
    [anon_sym_getgrnam] = ACTIONS(3097),
    [anon_sym_getgrgid] = ACTIONS(3097),
    [anon_sym_hex] = ACTIONS(3097),
    [anon_sym_int] = ACTIONS(3097),
    [anon_sym_keys] = ACTIONS(3097),
    [anon_sym_lc] = ACTIONS(3097),
    [anon_sym_lcfirst] = ACTIONS(3097),
    [anon_sym_length] = ACTIONS(3097),
    [anon_sym_localtime] = ACTIONS(3097),
    [anon_sym_log] = ACTIONS(3097),
    [anon_sym_lock] = ACTIONS(3097),
    [anon_sym_lstat] = ACTIONS(3097),
    [anon_sym_oct] = ACTIONS(3097),
    [anon_sym_ord] = ACTIONS(3097),
    [anon_sym_prototype] = ACTIONS(3097),
    [anon_sym_pop] = ACTIONS(3097),
    [anon_sym_pos] = ACTIONS(3097),
    [anon_sym_quotemeta] = ACTIONS(3097),
    [anon_sym_reset] = ACTIONS(3097),
    [anon_sym_rand] = ACTIONS(3097),
    [anon_sym_rmdir] = ACTIONS(3097),
    [anon_sym_readdir] = ACTIONS(3097),
    [anon_sym_readline] = ACTIONS(3097),
    [anon_sym_readpipe] = ACTIONS(3097),
    [anon_sym_rewinddir] = ACTIONS(3097),
    [anon_sym_readlink] = ACTIONS(3097),
    [anon_sym_ref] = ACTIONS(3097),
    [anon_sym_scalar] = ACTIONS(3097),
    [anon_sym_shift] = ACTIONS(3097),
    [anon_sym_sin] = ACTIONS(3097),
    [anon_sym_sleep] = ACTIONS(3097),
    [anon_sym_sqrt] = ACTIONS(3097),
    [anon_sym_srand] = ACTIONS(3097),
    [anon_sym_stat] = ACTIONS(3097),
    [anon_sym_study] = ACTIONS(3097),
    [anon_sym_tell] = ACTIONS(3097),
    [anon_sym_telldir] = ACTIONS(3097),
    [anon_sym_tied] = ACTIONS(3097),
    [anon_sym_uc] = ACTIONS(3097),
    [anon_sym_ucfirst] = ACTIONS(3097),
    [anon_sym_untie] = ACTIONS(3097),
    [anon_sym_umask] = ACTIONS(3097),
    [anon_sym_values] = ACTIONS(3097),
    [anon_sym_write] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3097),
    [anon_sym___END__] = ACTIONS(3097),
    [anon_sym_q] = ACTIONS(3097),
    [anon_sym_qq] = ACTIONS(3097),
    [anon_sym_qw] = ACTIONS(3097),
    [anon_sym_qx] = ACTIONS(3097),
    [anon_sym_qr] = ACTIONS(3097),
    [anon_sym_m] = ACTIONS(3097),
    [anon_sym_s] = ACTIONS(3097),
    [anon_sym_tr] = ACTIONS(3097),
    [anon_sym_y] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3097),
    [anon_sym_unless] = ACTIONS(3097),
    [anon_sym_while] = ACTIONS(3097),
    [anon_sym_until] = ACTIONS(3097),
    [aux_sym__bareword_token1] = ACTIONS(3097),
    [sym_number] = ACTIONS(3097),
    [sym__apostrophe] = ACTIONS(3095),
    [sym__double_quote] = ACTIONS(3095),
    [sym__backtick] = ACTIONS(3095),
    [sym__search_slash] = ACTIONS(3095),
    [sym__PERLY_HEREDOC] = ACTIONS(3095),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1062] = {
    [sym_heredoc_content] = STATE(1062),
    [sym__identifier] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_LBRACE2] = ACTIONS(3101),
    [anon_sym_RBRACE] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym_package] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_sub] = ACTIONS(3101),
    [anon_sym_method] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_my] = ACTIONS(3101),
    [anon_sym_state] = ACTIONS(3101),
    [anon_sym_our] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_defer] = ACTIONS(3101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3101),
    [anon_sym_else] = ACTIONS(3101),
    [anon_sym_elsif] = ACTIONS(3101),
    [anon_sym_and] = ACTIONS(3101),
    [anon_sym_or] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_AT] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_LT_LT] = ACTIONS(3101),
    [anon_sym_SLASH_SLASH] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_eq] = ACTIONS(3101),
    [anon_sym_ne] = ACTIONS(3101),
    [anon_sym_cmp] = ACTIONS(3101),
    [anon_sym_lt] = ACTIONS(3101),
    [anon_sym_le] = ACTIONS(3101),
    [anon_sym_ge] = ACTIONS(3101),
    [anon_sym_gt] = ACTIONS(3101),
    [anon_sym_isa] = ACTIONS(3101),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_PLUS_PLUS] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3101),
    [anon_sym_BSLASH] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_eval] = ACTIONS(3101),
    [anon_sym_field] = ACTIONS(3101),
    [anon_sym_local] = ACTIONS(3101),
    [anon_sym_require] = ACTIONS(3101),
    [anon_sym_map] = ACTIONS(3101),
    [anon_sym_grep] = ACTIONS(3101),
    [anon_sym_sort] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_undef] = ACTIONS(3101),
    [anon_sym_PERCENT2] = ACTIONS(3101),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3101),
    [anon_sym_no] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_foreach] = ACTIONS(3101),
    [anon_sym_last] = ACTIONS(3101),
    [anon_sym_next] = ACTIONS(3101),
    [anon_sym_redo] = ACTIONS(3101),
    [anon_sym_BEGIN] = ACTIONS(3101),
    [anon_sym_INIT] = ACTIONS(3101),
    [anon_sym_CHECK] = ACTIONS(3101),
    [anon_sym_UNITCHECK] = ACTIONS(3101),
    [anon_sym_END] = ACTIONS(3101),
    [anon_sym_ADJUST] = ACTIONS(3101),
    [anon_sym___FILE__] = ACTIONS(3101),
    [anon_sym___LINE__] = ACTIONS(3101),
    [anon_sym___PACKAGE__] = ACTIONS(3101),
    [anon_sym___SUB__] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_fork] = ACTIONS(3101),
    [anon_sym_getppid] = ACTIONS(3101),
    [anon_sym_time] = ACTIONS(3101),
    [anon_sym_times] = ACTIONS(3101),
    [anon_sym_wait] = ACTIONS(3101),
    [anon_sym_wantarray] = ACTIONS(3101),
    [anon_sym_abs] = ACTIONS(3101),
    [anon_sym_alarm] = ACTIONS(3101),
    [anon_sym_chop] = ACTIONS(3101),
    [anon_sym_chdir] = ACTIONS(3101),
    [anon_sym_close] = ACTIONS(3101),
    [anon_sym_closedir] = ACTIONS(3101),
    [anon_sym_caller] = ACTIONS(3101),
    [anon_sym_chomp] = ACTIONS(3101),
    [anon_sym_chr] = ACTIONS(3101),
    [anon_sym_cos] = ACTIONS(3101),
    [anon_sym_chroot] = ACTIONS(3101),
    [anon_sym_defined] = ACTIONS(3101),
    [anon_sym_delete] = ACTIONS(3101),
    [anon_sym_dbmclose] = ACTIONS(3101),
    [anon_sym_exists] = ACTIONS(3101),
    [anon_sym_exit] = ACTIONS(3101),
    [anon_sym_eof] = ACTIONS(3101),
    [anon_sym_exp] = ACTIONS(3101),
    [anon_sym_each] = ACTIONS(3101),
    [anon_sym_fc] = ACTIONS(3101),
    [anon_sym_fileno] = ACTIONS(3101),
    [anon_sym_gmtime] = ACTIONS(3101),
    [anon_sym_getc] = ACTIONS(3101),
    [anon_sym_getpgrp] = ACTIONS(3101),
    [anon_sym_getprotobyname] = ACTIONS(3101),
    [anon_sym_getpwname] = ACTIONS(3101),
    [anon_sym_getpwuid] = ACTIONS(3101),
    [anon_sym_getpeername] = ACTIONS(3101),
    [anon_sym_getnetbyname] = ACTIONS(3101),
    [anon_sym_getsockname] = ACTIONS(3101),
    [anon_sym_getgrnam] = ACTIONS(3101),
    [anon_sym_getgrgid] = ACTIONS(3101),
    [anon_sym_hex] = ACTIONS(3101),
    [anon_sym_int] = ACTIONS(3101),
    [anon_sym_keys] = ACTIONS(3101),
    [anon_sym_lc] = ACTIONS(3101),
    [anon_sym_lcfirst] = ACTIONS(3101),
    [anon_sym_length] = ACTIONS(3101),
    [anon_sym_localtime] = ACTIONS(3101),
    [anon_sym_log] = ACTIONS(3101),
    [anon_sym_lock] = ACTIONS(3101),
    [anon_sym_lstat] = ACTIONS(3101),
    [anon_sym_oct] = ACTIONS(3101),
    [anon_sym_ord] = ACTIONS(3101),
    [anon_sym_prototype] = ACTIONS(3101),
    [anon_sym_pop] = ACTIONS(3101),
    [anon_sym_pos] = ACTIONS(3101),
    [anon_sym_quotemeta] = ACTIONS(3101),
    [anon_sym_reset] = ACTIONS(3101),
    [anon_sym_rand] = ACTIONS(3101),
    [anon_sym_rmdir] = ACTIONS(3101),
    [anon_sym_readdir] = ACTIONS(3101),
    [anon_sym_readline] = ACTIONS(3101),
    [anon_sym_readpipe] = ACTIONS(3101),
    [anon_sym_rewinddir] = ACTIONS(3101),
    [anon_sym_readlink] = ACTIONS(3101),
    [anon_sym_ref] = ACTIONS(3101),
    [anon_sym_scalar] = ACTIONS(3101),
    [anon_sym_shift] = ACTIONS(3101),
    [anon_sym_sin] = ACTIONS(3101),
    [anon_sym_sleep] = ACTIONS(3101),
    [anon_sym_sqrt] = ACTIONS(3101),
    [anon_sym_srand] = ACTIONS(3101),
    [anon_sym_stat] = ACTIONS(3101),
    [anon_sym_study] = ACTIONS(3101),
    [anon_sym_tell] = ACTIONS(3101),
    [anon_sym_telldir] = ACTIONS(3101),
    [anon_sym_tied] = ACTIONS(3101),
    [anon_sym_uc] = ACTIONS(3101),
    [anon_sym_ucfirst] = ACTIONS(3101),
    [anon_sym_untie] = ACTIONS(3101),
    [anon_sym_umask] = ACTIONS(3101),
    [anon_sym_values] = ACTIONS(3101),
    [anon_sym_write] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3101),
    [anon_sym___END__] = ACTIONS(3101),
    [anon_sym_q] = ACTIONS(3101),
    [anon_sym_qq] = ACTIONS(3101),
    [anon_sym_qw] = ACTIONS(3101),
    [anon_sym_qx] = ACTIONS(3101),
    [anon_sym_qr] = ACTIONS(3101),
    [anon_sym_m] = ACTIONS(3101),
    [anon_sym_s] = ACTIONS(3101),
    [anon_sym_tr] = ACTIONS(3101),
    [anon_sym_y] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_unless] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_until] = ACTIONS(3101),
    [aux_sym__bareword_token1] = ACTIONS(3101),
    [sym_number] = ACTIONS(3101),
    [sym__apostrophe] = ACTIONS(3099),
    [sym__double_quote] = ACTIONS(3099),
    [sym__backtick] = ACTIONS(3099),
    [sym__search_slash] = ACTIONS(3099),
    [sym__PERLY_HEREDOC] = ACTIONS(3099),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1063] = {
    [sym_heredoc_content] = STATE(1063),
    [sym__identifier] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_LBRACE2] = ACTIONS(3113),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym_package] = ACTIONS(3113),
    [anon_sym_class] = ACTIONS(3113),
    [anon_sym_sub] = ACTIONS(3113),
    [anon_sym_method] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3113),
    [anon_sym_continue] = ACTIONS(3113),
    [anon_sym_my] = ACTIONS(3113),
    [anon_sym_state] = ACTIONS(3113),
    [anon_sym_our] = ACTIONS(3113),
    [anon_sym_try] = ACTIONS(3113),
    [anon_sym_defer] = ACTIONS(3113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3113),
    [anon_sym_else] = ACTIONS(3113),
    [anon_sym_elsif] = ACTIONS(3113),
    [anon_sym_and] = ACTIONS(3113),
    [anon_sym_or] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3113),
    [anon_sym_LBRACK] = ACTIONS(3113),
    [anon_sym_AT] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_LT_LT] = ACTIONS(3113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_DASH] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_eq] = ACTIONS(3113),
    [anon_sym_ne] = ACTIONS(3113),
    [anon_sym_cmp] = ACTIONS(3113),
    [anon_sym_lt] = ACTIONS(3113),
    [anon_sym_le] = ACTIONS(3113),
    [anon_sym_ge] = ACTIONS(3113),
    [anon_sym_gt] = ACTIONS(3113),
    [anon_sym_isa] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_BSLASH] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3113),
    [anon_sym_eval] = ACTIONS(3113),
    [anon_sym_field] = ACTIONS(3113),
    [anon_sym_local] = ACTIONS(3113),
    [anon_sym_require] = ACTIONS(3113),
    [anon_sym_map] = ACTIONS(3113),
    [anon_sym_grep] = ACTIONS(3113),
    [anon_sym_sort] = ACTIONS(3113),
    [anon_sym_goto] = ACTIONS(3113),
    [anon_sym_return] = ACTIONS(3113),
    [anon_sym_undef] = ACTIONS(3113),
    [anon_sym_PERCENT2] = ACTIONS(3113),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3113),
    [anon_sym_no] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3113),
    [anon_sym_foreach] = ACTIONS(3113),
    [anon_sym_last] = ACTIONS(3113),
    [anon_sym_next] = ACTIONS(3113),
    [anon_sym_redo] = ACTIONS(3113),
    [anon_sym_BEGIN] = ACTIONS(3113),
    [anon_sym_INIT] = ACTIONS(3113),
    [anon_sym_CHECK] = ACTIONS(3113),
    [anon_sym_UNITCHECK] = ACTIONS(3113),
    [anon_sym_END] = ACTIONS(3113),
    [anon_sym_ADJUST] = ACTIONS(3113),
    [anon_sym___FILE__] = ACTIONS(3113),
    [anon_sym___LINE__] = ACTIONS(3113),
    [anon_sym___PACKAGE__] = ACTIONS(3113),
    [anon_sym___SUB__] = ACTIONS(3113),
    [anon_sym_break] = ACTIONS(3113),
    [anon_sym_fork] = ACTIONS(3113),
    [anon_sym_getppid] = ACTIONS(3113),
    [anon_sym_time] = ACTIONS(3113),
    [anon_sym_times] = ACTIONS(3113),
    [anon_sym_wait] = ACTIONS(3113),
    [anon_sym_wantarray] = ACTIONS(3113),
    [anon_sym_abs] = ACTIONS(3113),
    [anon_sym_alarm] = ACTIONS(3113),
    [anon_sym_chop] = ACTIONS(3113),
    [anon_sym_chdir] = ACTIONS(3113),
    [anon_sym_close] = ACTIONS(3113),
    [anon_sym_closedir] = ACTIONS(3113),
    [anon_sym_caller] = ACTIONS(3113),
    [anon_sym_chomp] = ACTIONS(3113),
    [anon_sym_chr] = ACTIONS(3113),
    [anon_sym_cos] = ACTIONS(3113),
    [anon_sym_chroot] = ACTIONS(3113),
    [anon_sym_defined] = ACTIONS(3113),
    [anon_sym_delete] = ACTIONS(3113),
    [anon_sym_dbmclose] = ACTIONS(3113),
    [anon_sym_exists] = ACTIONS(3113),
    [anon_sym_exit] = ACTIONS(3113),
    [anon_sym_eof] = ACTIONS(3113),
    [anon_sym_exp] = ACTIONS(3113),
    [anon_sym_each] = ACTIONS(3113),
    [anon_sym_fc] = ACTIONS(3113),
    [anon_sym_fileno] = ACTIONS(3113),
    [anon_sym_gmtime] = ACTIONS(3113),
    [anon_sym_getc] = ACTIONS(3113),
    [anon_sym_getpgrp] = ACTIONS(3113),
    [anon_sym_getprotobyname] = ACTIONS(3113),
    [anon_sym_getpwname] = ACTIONS(3113),
    [anon_sym_getpwuid] = ACTIONS(3113),
    [anon_sym_getpeername] = ACTIONS(3113),
    [anon_sym_getnetbyname] = ACTIONS(3113),
    [anon_sym_getsockname] = ACTIONS(3113),
    [anon_sym_getgrnam] = ACTIONS(3113),
    [anon_sym_getgrgid] = ACTIONS(3113),
    [anon_sym_hex] = ACTIONS(3113),
    [anon_sym_int] = ACTIONS(3113),
    [anon_sym_keys] = ACTIONS(3113),
    [anon_sym_lc] = ACTIONS(3113),
    [anon_sym_lcfirst] = ACTIONS(3113),
    [anon_sym_length] = ACTIONS(3113),
    [anon_sym_localtime] = ACTIONS(3113),
    [anon_sym_log] = ACTIONS(3113),
    [anon_sym_lock] = ACTIONS(3113),
    [anon_sym_lstat] = ACTIONS(3113),
    [anon_sym_oct] = ACTIONS(3113),
    [anon_sym_ord] = ACTIONS(3113),
    [anon_sym_prototype] = ACTIONS(3113),
    [anon_sym_pop] = ACTIONS(3113),
    [anon_sym_pos] = ACTIONS(3113),
    [anon_sym_quotemeta] = ACTIONS(3113),
    [anon_sym_reset] = ACTIONS(3113),
    [anon_sym_rand] = ACTIONS(3113),
    [anon_sym_rmdir] = ACTIONS(3113),
    [anon_sym_readdir] = ACTIONS(3113),
    [anon_sym_readline] = ACTIONS(3113),
    [anon_sym_readpipe] = ACTIONS(3113),
    [anon_sym_rewinddir] = ACTIONS(3113),
    [anon_sym_readlink] = ACTIONS(3113),
    [anon_sym_ref] = ACTIONS(3113),
    [anon_sym_scalar] = ACTIONS(3113),
    [anon_sym_shift] = ACTIONS(3113),
    [anon_sym_sin] = ACTIONS(3113),
    [anon_sym_sleep] = ACTIONS(3113),
    [anon_sym_sqrt] = ACTIONS(3113),
    [anon_sym_srand] = ACTIONS(3113),
    [anon_sym_stat] = ACTIONS(3113),
    [anon_sym_study] = ACTIONS(3113),
    [anon_sym_tell] = ACTIONS(3113),
    [anon_sym_telldir] = ACTIONS(3113),
    [anon_sym_tied] = ACTIONS(3113),
    [anon_sym_uc] = ACTIONS(3113),
    [anon_sym_ucfirst] = ACTIONS(3113),
    [anon_sym_untie] = ACTIONS(3113),
    [anon_sym_umask] = ACTIONS(3113),
    [anon_sym_values] = ACTIONS(3113),
    [anon_sym_write] = ACTIONS(3113),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3113),
    [anon_sym___END__] = ACTIONS(3113),
    [anon_sym_q] = ACTIONS(3113),
    [anon_sym_qq] = ACTIONS(3113),
    [anon_sym_qw] = ACTIONS(3113),
    [anon_sym_qx] = ACTIONS(3113),
    [anon_sym_qr] = ACTIONS(3113),
    [anon_sym_m] = ACTIONS(3113),
    [anon_sym_s] = ACTIONS(3113),
    [anon_sym_tr] = ACTIONS(3113),
    [anon_sym_y] = ACTIONS(3113),
    [anon_sym_if] = ACTIONS(3113),
    [anon_sym_unless] = ACTIONS(3113),
    [anon_sym_while] = ACTIONS(3113),
    [anon_sym_until] = ACTIONS(3113),
    [aux_sym__bareword_token1] = ACTIONS(3113),
    [sym_number] = ACTIONS(3113),
    [sym__apostrophe] = ACTIONS(3111),
    [sym__double_quote] = ACTIONS(3111),
    [sym__backtick] = ACTIONS(3111),
    [sym__search_slash] = ACTIONS(3111),
    [sym__PERLY_HEREDOC] = ACTIONS(3111),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1064] = {
    [sym_heredoc_content] = STATE(1064),
    [sym__identifier] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_LBRACE2] = ACTIONS(3125),
    [anon_sym_RBRACE] = ACTIONS(3125),
    [anon_sym_SEMI] = ACTIONS(3125),
    [anon_sym_package] = ACTIONS(3125),
    [anon_sym_class] = ACTIONS(3125),
    [anon_sym_sub] = ACTIONS(3125),
    [anon_sym_method] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3125),
    [anon_sym_continue] = ACTIONS(3125),
    [anon_sym_my] = ACTIONS(3125),
    [anon_sym_state] = ACTIONS(3125),
    [anon_sym_our] = ACTIONS(3125),
    [anon_sym_try] = ACTIONS(3125),
    [anon_sym_defer] = ACTIONS(3125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_else] = ACTIONS(3125),
    [anon_sym_elsif] = ACTIONS(3125),
    [anon_sym_and] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_AT] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_LT_LT] = ACTIONS(3125),
    [anon_sym_SLASH_SLASH] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(3125),
    [anon_sym_DASH] = ACTIONS(3125),
    [anon_sym_STAR] = ACTIONS(3125),
    [anon_sym_eq] = ACTIONS(3125),
    [anon_sym_ne] = ACTIONS(3125),
    [anon_sym_cmp] = ACTIONS(3125),
    [anon_sym_lt] = ACTIONS(3125),
    [anon_sym_le] = ACTIONS(3125),
    [anon_sym_ge] = ACTIONS(3125),
    [anon_sym_gt] = ACTIONS(3125),
    [anon_sym_isa] = ACTIONS(3125),
    [anon_sym_TILDE] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3125),
    [anon_sym_PLUS_PLUS] = ACTIONS(3125),
    [anon_sym_DASH_DASH] = ACTIONS(3125),
    [anon_sym_BSLASH] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3125),
    [anon_sym_eval] = ACTIONS(3125),
    [anon_sym_field] = ACTIONS(3125),
    [anon_sym_local] = ACTIONS(3125),
    [anon_sym_require] = ACTIONS(3125),
    [anon_sym_map] = ACTIONS(3125),
    [anon_sym_grep] = ACTIONS(3125),
    [anon_sym_sort] = ACTIONS(3125),
    [anon_sym_goto] = ACTIONS(3125),
    [anon_sym_return] = ACTIONS(3125),
    [anon_sym_undef] = ACTIONS(3125),
    [anon_sym_PERCENT2] = ACTIONS(3125),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3125),
    [anon_sym_no] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3125),
    [anon_sym_foreach] = ACTIONS(3125),
    [anon_sym_last] = ACTIONS(3125),
    [anon_sym_next] = ACTIONS(3125),
    [anon_sym_redo] = ACTIONS(3125),
    [anon_sym_BEGIN] = ACTIONS(3125),
    [anon_sym_INIT] = ACTIONS(3125),
    [anon_sym_CHECK] = ACTIONS(3125),
    [anon_sym_UNITCHECK] = ACTIONS(3125),
    [anon_sym_END] = ACTIONS(3125),
    [anon_sym_ADJUST] = ACTIONS(3125),
    [anon_sym___FILE__] = ACTIONS(3125),
    [anon_sym___LINE__] = ACTIONS(3125),
    [anon_sym___PACKAGE__] = ACTIONS(3125),
    [anon_sym___SUB__] = ACTIONS(3125),
    [anon_sym_break] = ACTIONS(3125),
    [anon_sym_fork] = ACTIONS(3125),
    [anon_sym_getppid] = ACTIONS(3125),
    [anon_sym_time] = ACTIONS(3125),
    [anon_sym_times] = ACTIONS(3125),
    [anon_sym_wait] = ACTIONS(3125),
    [anon_sym_wantarray] = ACTIONS(3125),
    [anon_sym_abs] = ACTIONS(3125),
    [anon_sym_alarm] = ACTIONS(3125),
    [anon_sym_chop] = ACTIONS(3125),
    [anon_sym_chdir] = ACTIONS(3125),
    [anon_sym_close] = ACTIONS(3125),
    [anon_sym_closedir] = ACTIONS(3125),
    [anon_sym_caller] = ACTIONS(3125),
    [anon_sym_chomp] = ACTIONS(3125),
    [anon_sym_chr] = ACTIONS(3125),
    [anon_sym_cos] = ACTIONS(3125),
    [anon_sym_chroot] = ACTIONS(3125),
    [anon_sym_defined] = ACTIONS(3125),
    [anon_sym_delete] = ACTIONS(3125),
    [anon_sym_dbmclose] = ACTIONS(3125),
    [anon_sym_exists] = ACTIONS(3125),
    [anon_sym_exit] = ACTIONS(3125),
    [anon_sym_eof] = ACTIONS(3125),
    [anon_sym_exp] = ACTIONS(3125),
    [anon_sym_each] = ACTIONS(3125),
    [anon_sym_fc] = ACTIONS(3125),
    [anon_sym_fileno] = ACTIONS(3125),
    [anon_sym_gmtime] = ACTIONS(3125),
    [anon_sym_getc] = ACTIONS(3125),
    [anon_sym_getpgrp] = ACTIONS(3125),
    [anon_sym_getprotobyname] = ACTIONS(3125),
    [anon_sym_getpwname] = ACTIONS(3125),
    [anon_sym_getpwuid] = ACTIONS(3125),
    [anon_sym_getpeername] = ACTIONS(3125),
    [anon_sym_getnetbyname] = ACTIONS(3125),
    [anon_sym_getsockname] = ACTIONS(3125),
    [anon_sym_getgrnam] = ACTIONS(3125),
    [anon_sym_getgrgid] = ACTIONS(3125),
    [anon_sym_hex] = ACTIONS(3125),
    [anon_sym_int] = ACTIONS(3125),
    [anon_sym_keys] = ACTIONS(3125),
    [anon_sym_lc] = ACTIONS(3125),
    [anon_sym_lcfirst] = ACTIONS(3125),
    [anon_sym_length] = ACTIONS(3125),
    [anon_sym_localtime] = ACTIONS(3125),
    [anon_sym_log] = ACTIONS(3125),
    [anon_sym_lock] = ACTIONS(3125),
    [anon_sym_lstat] = ACTIONS(3125),
    [anon_sym_oct] = ACTIONS(3125),
    [anon_sym_ord] = ACTIONS(3125),
    [anon_sym_prototype] = ACTIONS(3125),
    [anon_sym_pop] = ACTIONS(3125),
    [anon_sym_pos] = ACTIONS(3125),
    [anon_sym_quotemeta] = ACTIONS(3125),
    [anon_sym_reset] = ACTIONS(3125),
    [anon_sym_rand] = ACTIONS(3125),
    [anon_sym_rmdir] = ACTIONS(3125),
    [anon_sym_readdir] = ACTIONS(3125),
    [anon_sym_readline] = ACTIONS(3125),
    [anon_sym_readpipe] = ACTIONS(3125),
    [anon_sym_rewinddir] = ACTIONS(3125),
    [anon_sym_readlink] = ACTIONS(3125),
    [anon_sym_ref] = ACTIONS(3125),
    [anon_sym_scalar] = ACTIONS(3125),
    [anon_sym_shift] = ACTIONS(3125),
    [anon_sym_sin] = ACTIONS(3125),
    [anon_sym_sleep] = ACTIONS(3125),
    [anon_sym_sqrt] = ACTIONS(3125),
    [anon_sym_srand] = ACTIONS(3125),
    [anon_sym_stat] = ACTIONS(3125),
    [anon_sym_study] = ACTIONS(3125),
    [anon_sym_tell] = ACTIONS(3125),
    [anon_sym_telldir] = ACTIONS(3125),
    [anon_sym_tied] = ACTIONS(3125),
    [anon_sym_uc] = ACTIONS(3125),
    [anon_sym_ucfirst] = ACTIONS(3125),
    [anon_sym_untie] = ACTIONS(3125),
    [anon_sym_umask] = ACTIONS(3125),
    [anon_sym_values] = ACTIONS(3125),
    [anon_sym_write] = ACTIONS(3125),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3125),
    [anon_sym___END__] = ACTIONS(3125),
    [anon_sym_q] = ACTIONS(3125),
    [anon_sym_qq] = ACTIONS(3125),
    [anon_sym_qw] = ACTIONS(3125),
    [anon_sym_qx] = ACTIONS(3125),
    [anon_sym_qr] = ACTIONS(3125),
    [anon_sym_m] = ACTIONS(3125),
    [anon_sym_s] = ACTIONS(3125),
    [anon_sym_tr] = ACTIONS(3125),
    [anon_sym_y] = ACTIONS(3125),
    [anon_sym_if] = ACTIONS(3125),
    [anon_sym_unless] = ACTIONS(3125),
    [anon_sym_while] = ACTIONS(3125),
    [anon_sym_until] = ACTIONS(3125),
    [aux_sym__bareword_token1] = ACTIONS(3125),
    [sym_number] = ACTIONS(3125),
    [sym__apostrophe] = ACTIONS(3123),
    [sym__double_quote] = ACTIONS(3123),
    [sym__backtick] = ACTIONS(3123),
    [sym__search_slash] = ACTIONS(3123),
    [sym__PERLY_HEREDOC] = ACTIONS(3123),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1065] = {
    [sym_heredoc_content] = STATE(1065),
    [sym__identifier] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_LBRACE2] = ACTIONS(3133),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_package] = ACTIONS(3133),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_sub] = ACTIONS(3133),
    [anon_sym_method] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_my] = ACTIONS(3133),
    [anon_sym_state] = ACTIONS(3133),
    [anon_sym_our] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_defer] = ACTIONS(3133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_elsif] = ACTIONS(3133),
    [anon_sym_and] = ACTIONS(3133),
    [anon_sym_or] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3133),
    [anon_sym_AT] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_LT_LT] = ACTIONS(3133),
    [anon_sym_SLASH_SLASH] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3133),
    [anon_sym_eq] = ACTIONS(3133),
    [anon_sym_ne] = ACTIONS(3133),
    [anon_sym_cmp] = ACTIONS(3133),
    [anon_sym_lt] = ACTIONS(3133),
    [anon_sym_le] = ACTIONS(3133),
    [anon_sym_ge] = ACTIONS(3133),
    [anon_sym_gt] = ACTIONS(3133),
    [anon_sym_isa] = ACTIONS(3133),
    [anon_sym_TILDE] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3133),
    [anon_sym_PLUS_PLUS] = ACTIONS(3133),
    [anon_sym_DASH_DASH] = ACTIONS(3133),
    [anon_sym_BSLASH] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_eval] = ACTIONS(3133),
    [anon_sym_field] = ACTIONS(3133),
    [anon_sym_local] = ACTIONS(3133),
    [anon_sym_require] = ACTIONS(3133),
    [anon_sym_map] = ACTIONS(3133),
    [anon_sym_grep] = ACTIONS(3133),
    [anon_sym_sort] = ACTIONS(3133),
    [anon_sym_goto] = ACTIONS(3133),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_undef] = ACTIONS(3133),
    [anon_sym_PERCENT2] = ACTIONS(3133),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3133),
    [anon_sym_no] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_foreach] = ACTIONS(3133),
    [anon_sym_last] = ACTIONS(3133),
    [anon_sym_next] = ACTIONS(3133),
    [anon_sym_redo] = ACTIONS(3133),
    [anon_sym_BEGIN] = ACTIONS(3133),
    [anon_sym_INIT] = ACTIONS(3133),
    [anon_sym_CHECK] = ACTIONS(3133),
    [anon_sym_UNITCHECK] = ACTIONS(3133),
    [anon_sym_END] = ACTIONS(3133),
    [anon_sym_ADJUST] = ACTIONS(3133),
    [anon_sym___FILE__] = ACTIONS(3133),
    [anon_sym___LINE__] = ACTIONS(3133),
    [anon_sym___PACKAGE__] = ACTIONS(3133),
    [anon_sym___SUB__] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_fork] = ACTIONS(3133),
    [anon_sym_getppid] = ACTIONS(3133),
    [anon_sym_time] = ACTIONS(3133),
    [anon_sym_times] = ACTIONS(3133),
    [anon_sym_wait] = ACTIONS(3133),
    [anon_sym_wantarray] = ACTIONS(3133),
    [anon_sym_abs] = ACTIONS(3133),
    [anon_sym_alarm] = ACTIONS(3133),
    [anon_sym_chop] = ACTIONS(3133),
    [anon_sym_chdir] = ACTIONS(3133),
    [anon_sym_close] = ACTIONS(3133),
    [anon_sym_closedir] = ACTIONS(3133),
    [anon_sym_caller] = ACTIONS(3133),
    [anon_sym_chomp] = ACTIONS(3133),
    [anon_sym_chr] = ACTIONS(3133),
    [anon_sym_cos] = ACTIONS(3133),
    [anon_sym_chroot] = ACTIONS(3133),
    [anon_sym_defined] = ACTIONS(3133),
    [anon_sym_delete] = ACTIONS(3133),
    [anon_sym_dbmclose] = ACTIONS(3133),
    [anon_sym_exists] = ACTIONS(3133),
    [anon_sym_exit] = ACTIONS(3133),
    [anon_sym_eof] = ACTIONS(3133),
    [anon_sym_exp] = ACTIONS(3133),
    [anon_sym_each] = ACTIONS(3133),
    [anon_sym_fc] = ACTIONS(3133),
    [anon_sym_fileno] = ACTIONS(3133),
    [anon_sym_gmtime] = ACTIONS(3133),
    [anon_sym_getc] = ACTIONS(3133),
    [anon_sym_getpgrp] = ACTIONS(3133),
    [anon_sym_getprotobyname] = ACTIONS(3133),
    [anon_sym_getpwname] = ACTIONS(3133),
    [anon_sym_getpwuid] = ACTIONS(3133),
    [anon_sym_getpeername] = ACTIONS(3133),
    [anon_sym_getnetbyname] = ACTIONS(3133),
    [anon_sym_getsockname] = ACTIONS(3133),
    [anon_sym_getgrnam] = ACTIONS(3133),
    [anon_sym_getgrgid] = ACTIONS(3133),
    [anon_sym_hex] = ACTIONS(3133),
    [anon_sym_int] = ACTIONS(3133),
    [anon_sym_keys] = ACTIONS(3133),
    [anon_sym_lc] = ACTIONS(3133),
    [anon_sym_lcfirst] = ACTIONS(3133),
    [anon_sym_length] = ACTIONS(3133),
    [anon_sym_localtime] = ACTIONS(3133),
    [anon_sym_log] = ACTIONS(3133),
    [anon_sym_lock] = ACTIONS(3133),
    [anon_sym_lstat] = ACTIONS(3133),
    [anon_sym_oct] = ACTIONS(3133),
    [anon_sym_ord] = ACTIONS(3133),
    [anon_sym_prototype] = ACTIONS(3133),
    [anon_sym_pop] = ACTIONS(3133),
    [anon_sym_pos] = ACTIONS(3133),
    [anon_sym_quotemeta] = ACTIONS(3133),
    [anon_sym_reset] = ACTIONS(3133),
    [anon_sym_rand] = ACTIONS(3133),
    [anon_sym_rmdir] = ACTIONS(3133),
    [anon_sym_readdir] = ACTIONS(3133),
    [anon_sym_readline] = ACTIONS(3133),
    [anon_sym_readpipe] = ACTIONS(3133),
    [anon_sym_rewinddir] = ACTIONS(3133),
    [anon_sym_readlink] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3133),
    [anon_sym_scalar] = ACTIONS(3133),
    [anon_sym_shift] = ACTIONS(3133),
    [anon_sym_sin] = ACTIONS(3133),
    [anon_sym_sleep] = ACTIONS(3133),
    [anon_sym_sqrt] = ACTIONS(3133),
    [anon_sym_srand] = ACTIONS(3133),
    [anon_sym_stat] = ACTIONS(3133),
    [anon_sym_study] = ACTIONS(3133),
    [anon_sym_tell] = ACTIONS(3133),
    [anon_sym_telldir] = ACTIONS(3133),
    [anon_sym_tied] = ACTIONS(3133),
    [anon_sym_uc] = ACTIONS(3133),
    [anon_sym_ucfirst] = ACTIONS(3133),
    [anon_sym_untie] = ACTIONS(3133),
    [anon_sym_umask] = ACTIONS(3133),
    [anon_sym_values] = ACTIONS(3133),
    [anon_sym_write] = ACTIONS(3133),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3133),
    [anon_sym___END__] = ACTIONS(3133),
    [anon_sym_q] = ACTIONS(3133),
    [anon_sym_qq] = ACTIONS(3133),
    [anon_sym_qw] = ACTIONS(3133),
    [anon_sym_qx] = ACTIONS(3133),
    [anon_sym_qr] = ACTIONS(3133),
    [anon_sym_m] = ACTIONS(3133),
    [anon_sym_s] = ACTIONS(3133),
    [anon_sym_tr] = ACTIONS(3133),
    [anon_sym_y] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_unless] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_until] = ACTIONS(3133),
    [aux_sym__bareword_token1] = ACTIONS(3133),
    [sym_number] = ACTIONS(3133),
    [sym__apostrophe] = ACTIONS(3131),
    [sym__double_quote] = ACTIONS(3131),
    [sym__backtick] = ACTIONS(3131),
    [sym__search_slash] = ACTIONS(3131),
    [sym__PERLY_HEREDOC] = ACTIONS(3131),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1066] = {
    [sym_heredoc_content] = STATE(1066),
    [sym__identifier] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_LBRACE2] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_package] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_sub] = ACTIONS(3148),
    [anon_sym_method] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_my] = ACTIONS(3148),
    [anon_sym_state] = ACTIONS(3148),
    [anon_sym_our] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_defer] = ACTIONS(3148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_elsif] = ACTIONS(3148),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_DOLLAR] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_LT_LT] = ACTIONS(3148),
    [anon_sym_SLASH_SLASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_eq] = ACTIONS(3148),
    [anon_sym_ne] = ACTIONS(3148),
    [anon_sym_cmp] = ACTIONS(3148),
    [anon_sym_lt] = ACTIONS(3148),
    [anon_sym_le] = ACTIONS(3148),
    [anon_sym_ge] = ACTIONS(3148),
    [anon_sym_gt] = ACTIONS(3148),
    [anon_sym_isa] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_BSLASH] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_eval] = ACTIONS(3148),
    [anon_sym_field] = ACTIONS(3148),
    [anon_sym_local] = ACTIONS(3148),
    [anon_sym_require] = ACTIONS(3148),
    [anon_sym_map] = ACTIONS(3148),
    [anon_sym_grep] = ACTIONS(3148),
    [anon_sym_sort] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_undef] = ACTIONS(3148),
    [anon_sym_PERCENT2] = ACTIONS(3148),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3148),
    [anon_sym_use] = ACTIONS(3148),
    [anon_sym_no] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_foreach] = ACTIONS(3148),
    [anon_sym_last] = ACTIONS(3148),
    [anon_sym_next] = ACTIONS(3148),
    [anon_sym_redo] = ACTIONS(3148),
    [anon_sym_BEGIN] = ACTIONS(3148),
    [anon_sym_INIT] = ACTIONS(3148),
    [anon_sym_CHECK] = ACTIONS(3148),
    [anon_sym_UNITCHECK] = ACTIONS(3148),
    [anon_sym_END] = ACTIONS(3148),
    [anon_sym_ADJUST] = ACTIONS(3148),
    [anon_sym___FILE__] = ACTIONS(3148),
    [anon_sym___LINE__] = ACTIONS(3148),
    [anon_sym___PACKAGE__] = ACTIONS(3148),
    [anon_sym___SUB__] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_fork] = ACTIONS(3148),
    [anon_sym_getppid] = ACTIONS(3148),
    [anon_sym_time] = ACTIONS(3148),
    [anon_sym_times] = ACTIONS(3148),
    [anon_sym_wait] = ACTIONS(3148),
    [anon_sym_wantarray] = ACTIONS(3148),
    [anon_sym_abs] = ACTIONS(3148),
    [anon_sym_alarm] = ACTIONS(3148),
    [anon_sym_chop] = ACTIONS(3148),
    [anon_sym_chdir] = ACTIONS(3148),
    [anon_sym_close] = ACTIONS(3148),
    [anon_sym_closedir] = ACTIONS(3148),
    [anon_sym_caller] = ACTIONS(3148),
    [anon_sym_chomp] = ACTIONS(3148),
    [anon_sym_chr] = ACTIONS(3148),
    [anon_sym_cos] = ACTIONS(3148),
    [anon_sym_chroot] = ACTIONS(3148),
    [anon_sym_defined] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_dbmclose] = ACTIONS(3148),
    [anon_sym_exists] = ACTIONS(3148),
    [anon_sym_exit] = ACTIONS(3148),
    [anon_sym_eof] = ACTIONS(3148),
    [anon_sym_exp] = ACTIONS(3148),
    [anon_sym_each] = ACTIONS(3148),
    [anon_sym_fc] = ACTIONS(3148),
    [anon_sym_fileno] = ACTIONS(3148),
    [anon_sym_gmtime] = ACTIONS(3148),
    [anon_sym_getc] = ACTIONS(3148),
    [anon_sym_getpgrp] = ACTIONS(3148),
    [anon_sym_getprotobyname] = ACTIONS(3148),
    [anon_sym_getpwname] = ACTIONS(3148),
    [anon_sym_getpwuid] = ACTIONS(3148),
    [anon_sym_getpeername] = ACTIONS(3148),
    [anon_sym_getnetbyname] = ACTIONS(3148),
    [anon_sym_getsockname] = ACTIONS(3148),
    [anon_sym_getgrnam] = ACTIONS(3148),
    [anon_sym_getgrgid] = ACTIONS(3148),
    [anon_sym_hex] = ACTIONS(3148),
    [anon_sym_int] = ACTIONS(3148),
    [anon_sym_keys] = ACTIONS(3148),
    [anon_sym_lc] = ACTIONS(3148),
    [anon_sym_lcfirst] = ACTIONS(3148),
    [anon_sym_length] = ACTIONS(3148),
    [anon_sym_localtime] = ACTIONS(3148),
    [anon_sym_log] = ACTIONS(3148),
    [anon_sym_lock] = ACTIONS(3148),
    [anon_sym_lstat] = ACTIONS(3148),
    [anon_sym_oct] = ACTIONS(3148),
    [anon_sym_ord] = ACTIONS(3148),
    [anon_sym_prototype] = ACTIONS(3148),
    [anon_sym_pop] = ACTIONS(3148),
    [anon_sym_pos] = ACTIONS(3148),
    [anon_sym_quotemeta] = ACTIONS(3148),
    [anon_sym_reset] = ACTIONS(3148),
    [anon_sym_rand] = ACTIONS(3148),
    [anon_sym_rmdir] = ACTIONS(3148),
    [anon_sym_readdir] = ACTIONS(3148),
    [anon_sym_readline] = ACTIONS(3148),
    [anon_sym_readpipe] = ACTIONS(3148),
    [anon_sym_rewinddir] = ACTIONS(3148),
    [anon_sym_readlink] = ACTIONS(3148),
    [anon_sym_ref] = ACTIONS(3148),
    [anon_sym_scalar] = ACTIONS(3148),
    [anon_sym_shift] = ACTIONS(3148),
    [anon_sym_sin] = ACTIONS(3148),
    [anon_sym_sleep] = ACTIONS(3148),
    [anon_sym_sqrt] = ACTIONS(3148),
    [anon_sym_srand] = ACTIONS(3148),
    [anon_sym_stat] = ACTIONS(3148),
    [anon_sym_study] = ACTIONS(3148),
    [anon_sym_tell] = ACTIONS(3148),
    [anon_sym_telldir] = ACTIONS(3148),
    [anon_sym_tied] = ACTIONS(3148),
    [anon_sym_uc] = ACTIONS(3148),
    [anon_sym_ucfirst] = ACTIONS(3148),
    [anon_sym_untie] = ACTIONS(3148),
    [anon_sym_umask] = ACTIONS(3148),
    [anon_sym_values] = ACTIONS(3148),
    [anon_sym_write] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3148),
    [anon_sym___END__] = ACTIONS(3148),
    [anon_sym_q] = ACTIONS(3148),
    [anon_sym_qq] = ACTIONS(3148),
    [anon_sym_qw] = ACTIONS(3148),
    [anon_sym_qx] = ACTIONS(3148),
    [anon_sym_qr] = ACTIONS(3148),
    [anon_sym_m] = ACTIONS(3148),
    [anon_sym_s] = ACTIONS(3148),
    [anon_sym_tr] = ACTIONS(3148),
    [anon_sym_y] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [aux_sym__bareword_token1] = ACTIONS(3148),
    [sym_number] = ACTIONS(3148),
    [sym__apostrophe] = ACTIONS(3146),
    [sym__double_quote] = ACTIONS(3146),
    [sym__backtick] = ACTIONS(3146),
    [sym__search_slash] = ACTIONS(3146),
    [sym__PERLY_HEREDOC] = ACTIONS(3146),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1067] = {
    [sym_heredoc_content] = STATE(1067),
    [sym__identifier] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_LBRACE2] = ACTIONS(3155),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym_package] = ACTIONS(3155),
    [anon_sym_class] = ACTIONS(3155),
    [anon_sym_sub] = ACTIONS(3155),
    [anon_sym_method] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_my] = ACTIONS(3155),
    [anon_sym_state] = ACTIONS(3155),
    [anon_sym_our] = ACTIONS(3155),
    [anon_sym_try] = ACTIONS(3155),
    [anon_sym_defer] = ACTIONS(3155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3155),
    [anon_sym_else] = ACTIONS(3155),
    [anon_sym_elsif] = ACTIONS(3155),
    [anon_sym_and] = ACTIONS(3155),
    [anon_sym_or] = ACTIONS(3155),
    [anon_sym_DOLLAR] = ACTIONS(3155),
    [anon_sym_LBRACK] = ACTIONS(3155),
    [anon_sym_AT] = ACTIONS(3155),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_LT_LT] = ACTIONS(3155),
    [anon_sym_SLASH_SLASH] = ACTIONS(3155),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [anon_sym_STAR] = ACTIONS(3155),
    [anon_sym_eq] = ACTIONS(3155),
    [anon_sym_ne] = ACTIONS(3155),
    [anon_sym_cmp] = ACTIONS(3155),
    [anon_sym_lt] = ACTIONS(3155),
    [anon_sym_le] = ACTIONS(3155),
    [anon_sym_ge] = ACTIONS(3155),
    [anon_sym_gt] = ACTIONS(3155),
    [anon_sym_isa] = ACTIONS(3155),
    [anon_sym_TILDE] = ACTIONS(3155),
    [anon_sym_BANG] = ACTIONS(3155),
    [anon_sym_PLUS_PLUS] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3155),
    [anon_sym_BSLASH] = ACTIONS(3153),
    [anon_sym_do] = ACTIONS(3155),
    [anon_sym_eval] = ACTIONS(3155),
    [anon_sym_field] = ACTIONS(3155),
    [anon_sym_local] = ACTIONS(3155),
    [anon_sym_require] = ACTIONS(3155),
    [anon_sym_map] = ACTIONS(3155),
    [anon_sym_grep] = ACTIONS(3155),
    [anon_sym_sort] = ACTIONS(3155),
    [anon_sym_goto] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_undef] = ACTIONS(3155),
    [anon_sym_PERCENT2] = ACTIONS(3155),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3155),
    [anon_sym_use] = ACTIONS(3155),
    [anon_sym_no] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_foreach] = ACTIONS(3155),
    [anon_sym_last] = ACTIONS(3155),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_redo] = ACTIONS(3155),
    [anon_sym_BEGIN] = ACTIONS(3155),
    [anon_sym_INIT] = ACTIONS(3155),
    [anon_sym_CHECK] = ACTIONS(3155),
    [anon_sym_UNITCHECK] = ACTIONS(3155),
    [anon_sym_END] = ACTIONS(3155),
    [anon_sym_ADJUST] = ACTIONS(3155),
    [anon_sym___FILE__] = ACTIONS(3155),
    [anon_sym___LINE__] = ACTIONS(3155),
    [anon_sym___PACKAGE__] = ACTIONS(3155),
    [anon_sym___SUB__] = ACTIONS(3155),
    [anon_sym_break] = ACTIONS(3155),
    [anon_sym_fork] = ACTIONS(3155),
    [anon_sym_getppid] = ACTIONS(3155),
    [anon_sym_time] = ACTIONS(3155),
    [anon_sym_times] = ACTIONS(3155),
    [anon_sym_wait] = ACTIONS(3155),
    [anon_sym_wantarray] = ACTIONS(3155),
    [anon_sym_abs] = ACTIONS(3155),
    [anon_sym_alarm] = ACTIONS(3155),
    [anon_sym_chop] = ACTIONS(3155),
    [anon_sym_chdir] = ACTIONS(3155),
    [anon_sym_close] = ACTIONS(3155),
    [anon_sym_closedir] = ACTIONS(3155),
    [anon_sym_caller] = ACTIONS(3155),
    [anon_sym_chomp] = ACTIONS(3155),
    [anon_sym_chr] = ACTIONS(3155),
    [anon_sym_cos] = ACTIONS(3155),
    [anon_sym_chroot] = ACTIONS(3155),
    [anon_sym_defined] = ACTIONS(3155),
    [anon_sym_delete] = ACTIONS(3155),
    [anon_sym_dbmclose] = ACTIONS(3155),
    [anon_sym_exists] = ACTIONS(3155),
    [anon_sym_exit] = ACTIONS(3155),
    [anon_sym_eof] = ACTIONS(3155),
    [anon_sym_exp] = ACTIONS(3155),
    [anon_sym_each] = ACTIONS(3155),
    [anon_sym_fc] = ACTIONS(3155),
    [anon_sym_fileno] = ACTIONS(3155),
    [anon_sym_gmtime] = ACTIONS(3155),
    [anon_sym_getc] = ACTIONS(3155),
    [anon_sym_getpgrp] = ACTIONS(3155),
    [anon_sym_getprotobyname] = ACTIONS(3155),
    [anon_sym_getpwname] = ACTIONS(3155),
    [anon_sym_getpwuid] = ACTIONS(3155),
    [anon_sym_getpeername] = ACTIONS(3155),
    [anon_sym_getnetbyname] = ACTIONS(3155),
    [anon_sym_getsockname] = ACTIONS(3155),
    [anon_sym_getgrnam] = ACTIONS(3155),
    [anon_sym_getgrgid] = ACTIONS(3155),
    [anon_sym_hex] = ACTIONS(3155),
    [anon_sym_int] = ACTIONS(3155),
    [anon_sym_keys] = ACTIONS(3155),
    [anon_sym_lc] = ACTIONS(3155),
    [anon_sym_lcfirst] = ACTIONS(3155),
    [anon_sym_length] = ACTIONS(3155),
    [anon_sym_localtime] = ACTIONS(3155),
    [anon_sym_log] = ACTIONS(3155),
    [anon_sym_lock] = ACTIONS(3155),
    [anon_sym_lstat] = ACTIONS(3155),
    [anon_sym_oct] = ACTIONS(3155),
    [anon_sym_ord] = ACTIONS(3155),
    [anon_sym_prototype] = ACTIONS(3155),
    [anon_sym_pop] = ACTIONS(3155),
    [anon_sym_pos] = ACTIONS(3155),
    [anon_sym_quotemeta] = ACTIONS(3155),
    [anon_sym_reset] = ACTIONS(3155),
    [anon_sym_rand] = ACTIONS(3155),
    [anon_sym_rmdir] = ACTIONS(3155),
    [anon_sym_readdir] = ACTIONS(3155),
    [anon_sym_readline] = ACTIONS(3155),
    [anon_sym_readpipe] = ACTIONS(3155),
    [anon_sym_rewinddir] = ACTIONS(3155),
    [anon_sym_readlink] = ACTIONS(3155),
    [anon_sym_ref] = ACTIONS(3155),
    [anon_sym_scalar] = ACTIONS(3155),
    [anon_sym_shift] = ACTIONS(3155),
    [anon_sym_sin] = ACTIONS(3155),
    [anon_sym_sleep] = ACTIONS(3155),
    [anon_sym_sqrt] = ACTIONS(3155),
    [anon_sym_srand] = ACTIONS(3155),
    [anon_sym_stat] = ACTIONS(3155),
    [anon_sym_study] = ACTIONS(3155),
    [anon_sym_tell] = ACTIONS(3155),
    [anon_sym_telldir] = ACTIONS(3155),
    [anon_sym_tied] = ACTIONS(3155),
    [anon_sym_uc] = ACTIONS(3155),
    [anon_sym_ucfirst] = ACTIONS(3155),
    [anon_sym_untie] = ACTIONS(3155),
    [anon_sym_umask] = ACTIONS(3155),
    [anon_sym_values] = ACTIONS(3155),
    [anon_sym_write] = ACTIONS(3155),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3155),
    [anon_sym___END__] = ACTIONS(3155),
    [anon_sym_q] = ACTIONS(3155),
    [anon_sym_qq] = ACTIONS(3155),
    [anon_sym_qw] = ACTIONS(3155),
    [anon_sym_qx] = ACTIONS(3155),
    [anon_sym_qr] = ACTIONS(3155),
    [anon_sym_m] = ACTIONS(3155),
    [anon_sym_s] = ACTIONS(3155),
    [anon_sym_tr] = ACTIONS(3155),
    [anon_sym_y] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_unless] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [anon_sym_until] = ACTIONS(3155),
    [aux_sym__bareword_token1] = ACTIONS(3155),
    [sym_number] = ACTIONS(3155),
    [sym__apostrophe] = ACTIONS(3153),
    [sym__double_quote] = ACTIONS(3153),
    [sym__backtick] = ACTIONS(3153),
    [sym__search_slash] = ACTIONS(3153),
    [sym__PERLY_HEREDOC] = ACTIONS(3153),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1068] = {
    [sym_heredoc_content] = STATE(1068),
    [sym__identifier] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_LBRACE2] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_package] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_sub] = ACTIONS(3166),
    [anon_sym_method] = ACTIONS(3166),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_my] = ACTIONS(3166),
    [anon_sym_state] = ACTIONS(3166),
    [anon_sym_our] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_defer] = ACTIONS(3166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3166),
    [anon_sym_else] = ACTIONS(3166),
    [anon_sym_elsif] = ACTIONS(3166),
    [anon_sym_and] = ACTIONS(3166),
    [anon_sym_or] = ACTIONS(3166),
    [anon_sym_DOLLAR] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_AT] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_LT_LT] = ACTIONS(3166),
    [anon_sym_SLASH_SLASH] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_eq] = ACTIONS(3166),
    [anon_sym_ne] = ACTIONS(3166),
    [anon_sym_cmp] = ACTIONS(3166),
    [anon_sym_lt] = ACTIONS(3166),
    [anon_sym_le] = ACTIONS(3166),
    [anon_sym_ge] = ACTIONS(3166),
    [anon_sym_gt] = ACTIONS(3166),
    [anon_sym_isa] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [anon_sym_BSLASH] = ACTIONS(3164),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_eval] = ACTIONS(3166),
    [anon_sym_field] = ACTIONS(3166),
    [anon_sym_local] = ACTIONS(3166),
    [anon_sym_require] = ACTIONS(3166),
    [anon_sym_map] = ACTIONS(3166),
    [anon_sym_grep] = ACTIONS(3166),
    [anon_sym_sort] = ACTIONS(3166),
    [anon_sym_goto] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_undef] = ACTIONS(3166),
    [anon_sym_PERCENT2] = ACTIONS(3166),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3166),
    [anon_sym_use] = ACTIONS(3166),
    [anon_sym_no] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_foreach] = ACTIONS(3166),
    [anon_sym_last] = ACTIONS(3166),
    [anon_sym_next] = ACTIONS(3166),
    [anon_sym_redo] = ACTIONS(3166),
    [anon_sym_BEGIN] = ACTIONS(3166),
    [anon_sym_INIT] = ACTIONS(3166),
    [anon_sym_CHECK] = ACTIONS(3166),
    [anon_sym_UNITCHECK] = ACTIONS(3166),
    [anon_sym_END] = ACTIONS(3166),
    [anon_sym_ADJUST] = ACTIONS(3166),
    [anon_sym___FILE__] = ACTIONS(3166),
    [anon_sym___LINE__] = ACTIONS(3166),
    [anon_sym___PACKAGE__] = ACTIONS(3166),
    [anon_sym___SUB__] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_fork] = ACTIONS(3166),
    [anon_sym_getppid] = ACTIONS(3166),
    [anon_sym_time] = ACTIONS(3166),
    [anon_sym_times] = ACTIONS(3166),
    [anon_sym_wait] = ACTIONS(3166),
    [anon_sym_wantarray] = ACTIONS(3166),
    [anon_sym_abs] = ACTIONS(3166),
    [anon_sym_alarm] = ACTIONS(3166),
    [anon_sym_chop] = ACTIONS(3166),
    [anon_sym_chdir] = ACTIONS(3166),
    [anon_sym_close] = ACTIONS(3166),
    [anon_sym_closedir] = ACTIONS(3166),
    [anon_sym_caller] = ACTIONS(3166),
    [anon_sym_chomp] = ACTIONS(3166),
    [anon_sym_chr] = ACTIONS(3166),
    [anon_sym_cos] = ACTIONS(3166),
    [anon_sym_chroot] = ACTIONS(3166),
    [anon_sym_defined] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_dbmclose] = ACTIONS(3166),
    [anon_sym_exists] = ACTIONS(3166),
    [anon_sym_exit] = ACTIONS(3166),
    [anon_sym_eof] = ACTIONS(3166),
    [anon_sym_exp] = ACTIONS(3166),
    [anon_sym_each] = ACTIONS(3166),
    [anon_sym_fc] = ACTIONS(3166),
    [anon_sym_fileno] = ACTIONS(3166),
    [anon_sym_gmtime] = ACTIONS(3166),
    [anon_sym_getc] = ACTIONS(3166),
    [anon_sym_getpgrp] = ACTIONS(3166),
    [anon_sym_getprotobyname] = ACTIONS(3166),
    [anon_sym_getpwname] = ACTIONS(3166),
    [anon_sym_getpwuid] = ACTIONS(3166),
    [anon_sym_getpeername] = ACTIONS(3166),
    [anon_sym_getnetbyname] = ACTIONS(3166),
    [anon_sym_getsockname] = ACTIONS(3166),
    [anon_sym_getgrnam] = ACTIONS(3166),
    [anon_sym_getgrgid] = ACTIONS(3166),
    [anon_sym_hex] = ACTIONS(3166),
    [anon_sym_int] = ACTIONS(3166),
    [anon_sym_keys] = ACTIONS(3166),
    [anon_sym_lc] = ACTIONS(3166),
    [anon_sym_lcfirst] = ACTIONS(3166),
    [anon_sym_length] = ACTIONS(3166),
    [anon_sym_localtime] = ACTIONS(3166),
    [anon_sym_log] = ACTIONS(3166),
    [anon_sym_lock] = ACTIONS(3166),
    [anon_sym_lstat] = ACTIONS(3166),
    [anon_sym_oct] = ACTIONS(3166),
    [anon_sym_ord] = ACTIONS(3166),
    [anon_sym_prototype] = ACTIONS(3166),
    [anon_sym_pop] = ACTIONS(3166),
    [anon_sym_pos] = ACTIONS(3166),
    [anon_sym_quotemeta] = ACTIONS(3166),
    [anon_sym_reset] = ACTIONS(3166),
    [anon_sym_rand] = ACTIONS(3166),
    [anon_sym_rmdir] = ACTIONS(3166),
    [anon_sym_readdir] = ACTIONS(3166),
    [anon_sym_readline] = ACTIONS(3166),
    [anon_sym_readpipe] = ACTIONS(3166),
    [anon_sym_rewinddir] = ACTIONS(3166),
    [anon_sym_readlink] = ACTIONS(3166),
    [anon_sym_ref] = ACTIONS(3166),
    [anon_sym_scalar] = ACTIONS(3166),
    [anon_sym_shift] = ACTIONS(3166),
    [anon_sym_sin] = ACTIONS(3166),
    [anon_sym_sleep] = ACTIONS(3166),
    [anon_sym_sqrt] = ACTIONS(3166),
    [anon_sym_srand] = ACTIONS(3166),
    [anon_sym_stat] = ACTIONS(3166),
    [anon_sym_study] = ACTIONS(3166),
    [anon_sym_tell] = ACTIONS(3166),
    [anon_sym_telldir] = ACTIONS(3166),
    [anon_sym_tied] = ACTIONS(3166),
    [anon_sym_uc] = ACTIONS(3166),
    [anon_sym_ucfirst] = ACTIONS(3166),
    [anon_sym_untie] = ACTIONS(3166),
    [anon_sym_umask] = ACTIONS(3166),
    [anon_sym_values] = ACTIONS(3166),
    [anon_sym_write] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3166),
    [anon_sym___END__] = ACTIONS(3166),
    [anon_sym_q] = ACTIONS(3166),
    [anon_sym_qq] = ACTIONS(3166),
    [anon_sym_qw] = ACTIONS(3166),
    [anon_sym_qx] = ACTIONS(3166),
    [anon_sym_qr] = ACTIONS(3166),
    [anon_sym_m] = ACTIONS(3166),
    [anon_sym_s] = ACTIONS(3166),
    [anon_sym_tr] = ACTIONS(3166),
    [anon_sym_y] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_unless] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_until] = ACTIONS(3166),
    [aux_sym__bareword_token1] = ACTIONS(3166),
    [sym_number] = ACTIONS(3166),
    [sym__apostrophe] = ACTIONS(3164),
    [sym__double_quote] = ACTIONS(3164),
    [sym__backtick] = ACTIONS(3164),
    [sym__search_slash] = ACTIONS(3164),
    [sym__PERLY_HEREDOC] = ACTIONS(3164),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1069] = {
    [sym_heredoc_content] = STATE(1069),
    [sym__identifier] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3173),
    [anon_sym_LBRACE2] = ACTIONS(3173),
    [anon_sym_RBRACE] = ACTIONS(3173),
    [anon_sym_SEMI] = ACTIONS(3173),
    [anon_sym_package] = ACTIONS(3173),
    [anon_sym_class] = ACTIONS(3173),
    [anon_sym_sub] = ACTIONS(3173),
    [anon_sym_method] = ACTIONS(3173),
    [anon_sym_LPAREN] = ACTIONS(3173),
    [anon_sym_continue] = ACTIONS(3173),
    [anon_sym_my] = ACTIONS(3173),
    [anon_sym_state] = ACTIONS(3173),
    [anon_sym_our] = ACTIONS(3173),
    [anon_sym_try] = ACTIONS(3173),
    [anon_sym_defer] = ACTIONS(3173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3173),
    [anon_sym_else] = ACTIONS(3173),
    [anon_sym_elsif] = ACTIONS(3173),
    [anon_sym_and] = ACTIONS(3173),
    [anon_sym_or] = ACTIONS(3173),
    [anon_sym_DOLLAR] = ACTIONS(3173),
    [anon_sym_LBRACK] = ACTIONS(3173),
    [anon_sym_AT] = ACTIONS(3173),
    [anon_sym_LT] = ACTIONS(3173),
    [anon_sym_LT_LT] = ACTIONS(3173),
    [anon_sym_SLASH_SLASH] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3173),
    [anon_sym_DASH] = ACTIONS(3173),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_eq] = ACTIONS(3173),
    [anon_sym_ne] = ACTIONS(3173),
    [anon_sym_cmp] = ACTIONS(3173),
    [anon_sym_lt] = ACTIONS(3173),
    [anon_sym_le] = ACTIONS(3173),
    [anon_sym_ge] = ACTIONS(3173),
    [anon_sym_gt] = ACTIONS(3173),
    [anon_sym_isa] = ACTIONS(3173),
    [anon_sym_TILDE] = ACTIONS(3173),
    [anon_sym_BANG] = ACTIONS(3173),
    [anon_sym_PLUS_PLUS] = ACTIONS(3173),
    [anon_sym_DASH_DASH] = ACTIONS(3173),
    [anon_sym_BSLASH] = ACTIONS(3171),
    [anon_sym_do] = ACTIONS(3173),
    [anon_sym_eval] = ACTIONS(3173),
    [anon_sym_field] = ACTIONS(3173),
    [anon_sym_local] = ACTIONS(3173),
    [anon_sym_require] = ACTIONS(3173),
    [anon_sym_map] = ACTIONS(3173),
    [anon_sym_grep] = ACTIONS(3173),
    [anon_sym_sort] = ACTIONS(3173),
    [anon_sym_goto] = ACTIONS(3173),
    [anon_sym_return] = ACTIONS(3173),
    [anon_sym_undef] = ACTIONS(3173),
    [anon_sym_PERCENT2] = ACTIONS(3173),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3173),
    [anon_sym_use] = ACTIONS(3173),
    [anon_sym_no] = ACTIONS(3173),
    [anon_sym_for] = ACTIONS(3173),
    [anon_sym_foreach] = ACTIONS(3173),
    [anon_sym_last] = ACTIONS(3173),
    [anon_sym_next] = ACTIONS(3173),
    [anon_sym_redo] = ACTIONS(3173),
    [anon_sym_BEGIN] = ACTIONS(3173),
    [anon_sym_INIT] = ACTIONS(3173),
    [anon_sym_CHECK] = ACTIONS(3173),
    [anon_sym_UNITCHECK] = ACTIONS(3173),
    [anon_sym_END] = ACTIONS(3173),
    [anon_sym_ADJUST] = ACTIONS(3173),
    [anon_sym___FILE__] = ACTIONS(3173),
    [anon_sym___LINE__] = ACTIONS(3173),
    [anon_sym___PACKAGE__] = ACTIONS(3173),
    [anon_sym___SUB__] = ACTIONS(3173),
    [anon_sym_break] = ACTIONS(3173),
    [anon_sym_fork] = ACTIONS(3173),
    [anon_sym_getppid] = ACTIONS(3173),
    [anon_sym_time] = ACTIONS(3173),
    [anon_sym_times] = ACTIONS(3173),
    [anon_sym_wait] = ACTIONS(3173),
    [anon_sym_wantarray] = ACTIONS(3173),
    [anon_sym_abs] = ACTIONS(3173),
    [anon_sym_alarm] = ACTIONS(3173),
    [anon_sym_chop] = ACTIONS(3173),
    [anon_sym_chdir] = ACTIONS(3173),
    [anon_sym_close] = ACTIONS(3173),
    [anon_sym_closedir] = ACTIONS(3173),
    [anon_sym_caller] = ACTIONS(3173),
    [anon_sym_chomp] = ACTIONS(3173),
    [anon_sym_chr] = ACTIONS(3173),
    [anon_sym_cos] = ACTIONS(3173),
    [anon_sym_chroot] = ACTIONS(3173),
    [anon_sym_defined] = ACTIONS(3173),
    [anon_sym_delete] = ACTIONS(3173),
    [anon_sym_dbmclose] = ACTIONS(3173),
    [anon_sym_exists] = ACTIONS(3173),
    [anon_sym_exit] = ACTIONS(3173),
    [anon_sym_eof] = ACTIONS(3173),
    [anon_sym_exp] = ACTIONS(3173),
    [anon_sym_each] = ACTIONS(3173),
    [anon_sym_fc] = ACTIONS(3173),
    [anon_sym_fileno] = ACTIONS(3173),
    [anon_sym_gmtime] = ACTIONS(3173),
    [anon_sym_getc] = ACTIONS(3173),
    [anon_sym_getpgrp] = ACTIONS(3173),
    [anon_sym_getprotobyname] = ACTIONS(3173),
    [anon_sym_getpwname] = ACTIONS(3173),
    [anon_sym_getpwuid] = ACTIONS(3173),
    [anon_sym_getpeername] = ACTIONS(3173),
    [anon_sym_getnetbyname] = ACTIONS(3173),
    [anon_sym_getsockname] = ACTIONS(3173),
    [anon_sym_getgrnam] = ACTIONS(3173),
    [anon_sym_getgrgid] = ACTIONS(3173),
    [anon_sym_hex] = ACTIONS(3173),
    [anon_sym_int] = ACTIONS(3173),
    [anon_sym_keys] = ACTIONS(3173),
    [anon_sym_lc] = ACTIONS(3173),
    [anon_sym_lcfirst] = ACTIONS(3173),
    [anon_sym_length] = ACTIONS(3173),
    [anon_sym_localtime] = ACTIONS(3173),
    [anon_sym_log] = ACTIONS(3173),
    [anon_sym_lock] = ACTIONS(3173),
    [anon_sym_lstat] = ACTIONS(3173),
    [anon_sym_oct] = ACTIONS(3173),
    [anon_sym_ord] = ACTIONS(3173),
    [anon_sym_prototype] = ACTIONS(3173),
    [anon_sym_pop] = ACTIONS(3173),
    [anon_sym_pos] = ACTIONS(3173),
    [anon_sym_quotemeta] = ACTIONS(3173),
    [anon_sym_reset] = ACTIONS(3173),
    [anon_sym_rand] = ACTIONS(3173),
    [anon_sym_rmdir] = ACTIONS(3173),
    [anon_sym_readdir] = ACTIONS(3173),
    [anon_sym_readline] = ACTIONS(3173),
    [anon_sym_readpipe] = ACTIONS(3173),
    [anon_sym_rewinddir] = ACTIONS(3173),
    [anon_sym_readlink] = ACTIONS(3173),
    [anon_sym_ref] = ACTIONS(3173),
    [anon_sym_scalar] = ACTIONS(3173),
    [anon_sym_shift] = ACTIONS(3173),
    [anon_sym_sin] = ACTIONS(3173),
    [anon_sym_sleep] = ACTIONS(3173),
    [anon_sym_sqrt] = ACTIONS(3173),
    [anon_sym_srand] = ACTIONS(3173),
    [anon_sym_stat] = ACTIONS(3173),
    [anon_sym_study] = ACTIONS(3173),
    [anon_sym_tell] = ACTIONS(3173),
    [anon_sym_telldir] = ACTIONS(3173),
    [anon_sym_tied] = ACTIONS(3173),
    [anon_sym_uc] = ACTIONS(3173),
    [anon_sym_ucfirst] = ACTIONS(3173),
    [anon_sym_untie] = ACTIONS(3173),
    [anon_sym_umask] = ACTIONS(3173),
    [anon_sym_values] = ACTIONS(3173),
    [anon_sym_write] = ACTIONS(3173),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3173),
    [anon_sym___END__] = ACTIONS(3173),
    [anon_sym_q] = ACTIONS(3173),
    [anon_sym_qq] = ACTIONS(3173),
    [anon_sym_qw] = ACTIONS(3173),
    [anon_sym_qx] = ACTIONS(3173),
    [anon_sym_qr] = ACTIONS(3173),
    [anon_sym_m] = ACTIONS(3173),
    [anon_sym_s] = ACTIONS(3173),
    [anon_sym_tr] = ACTIONS(3173),
    [anon_sym_y] = ACTIONS(3173),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_unless] = ACTIONS(3173),
    [anon_sym_while] = ACTIONS(3173),
    [anon_sym_until] = ACTIONS(3173),
    [aux_sym__bareword_token1] = ACTIONS(3173),
    [sym_number] = ACTIONS(3173),
    [sym__apostrophe] = ACTIONS(3171),
    [sym__double_quote] = ACTIONS(3171),
    [sym__backtick] = ACTIONS(3171),
    [sym__search_slash] = ACTIONS(3171),
    [sym__PERLY_HEREDOC] = ACTIONS(3171),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1070] = {
    [sym_heredoc_content] = STATE(1070),
    [sym__identifier] = ACTIONS(3177),
    [anon_sym_LBRACE] = ACTIONS(3177),
    [anon_sym_LBRACE2] = ACTIONS(3177),
    [anon_sym_RBRACE] = ACTIONS(3177),
    [anon_sym_SEMI] = ACTIONS(3177),
    [anon_sym_package] = ACTIONS(3177),
    [anon_sym_class] = ACTIONS(3177),
    [anon_sym_sub] = ACTIONS(3177),
    [anon_sym_method] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3177),
    [anon_sym_continue] = ACTIONS(3177),
    [anon_sym_my] = ACTIONS(3177),
    [anon_sym_state] = ACTIONS(3177),
    [anon_sym_our] = ACTIONS(3177),
    [anon_sym_try] = ACTIONS(3177),
    [anon_sym_defer] = ACTIONS(3177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3177),
    [anon_sym_else] = ACTIONS(3177),
    [anon_sym_elsif] = ACTIONS(3177),
    [anon_sym_and] = ACTIONS(3177),
    [anon_sym_or] = ACTIONS(3177),
    [anon_sym_DOLLAR] = ACTIONS(3177),
    [anon_sym_LBRACK] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3177),
    [anon_sym_LT] = ACTIONS(3177),
    [anon_sym_LT_LT] = ACTIONS(3177),
    [anon_sym_SLASH_SLASH] = ACTIONS(3177),
    [anon_sym_PLUS] = ACTIONS(3177),
    [anon_sym_DASH] = ACTIONS(3177),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_eq] = ACTIONS(3177),
    [anon_sym_ne] = ACTIONS(3177),
    [anon_sym_cmp] = ACTIONS(3177),
    [anon_sym_lt] = ACTIONS(3177),
    [anon_sym_le] = ACTIONS(3177),
    [anon_sym_ge] = ACTIONS(3177),
    [anon_sym_gt] = ACTIONS(3177),
    [anon_sym_isa] = ACTIONS(3177),
    [anon_sym_TILDE] = ACTIONS(3177),
    [anon_sym_BANG] = ACTIONS(3177),
    [anon_sym_PLUS_PLUS] = ACTIONS(3177),
    [anon_sym_DASH_DASH] = ACTIONS(3177),
    [anon_sym_BSLASH] = ACTIONS(3175),
    [anon_sym_do] = ACTIONS(3177),
    [anon_sym_eval] = ACTIONS(3177),
    [anon_sym_field] = ACTIONS(3177),
    [anon_sym_local] = ACTIONS(3177),
    [anon_sym_require] = ACTIONS(3177),
    [anon_sym_map] = ACTIONS(3177),
    [anon_sym_grep] = ACTIONS(3177),
    [anon_sym_sort] = ACTIONS(3177),
    [anon_sym_goto] = ACTIONS(3177),
    [anon_sym_return] = ACTIONS(3177),
    [anon_sym_undef] = ACTIONS(3177),
    [anon_sym_PERCENT2] = ACTIONS(3177),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3177),
    [anon_sym_use] = ACTIONS(3177),
    [anon_sym_no] = ACTIONS(3177),
    [anon_sym_for] = ACTIONS(3177),
    [anon_sym_foreach] = ACTIONS(3177),
    [anon_sym_last] = ACTIONS(3177),
    [anon_sym_next] = ACTIONS(3177),
    [anon_sym_redo] = ACTIONS(3177),
    [anon_sym_BEGIN] = ACTIONS(3177),
    [anon_sym_INIT] = ACTIONS(3177),
    [anon_sym_CHECK] = ACTIONS(3177),
    [anon_sym_UNITCHECK] = ACTIONS(3177),
    [anon_sym_END] = ACTIONS(3177),
    [anon_sym_ADJUST] = ACTIONS(3177),
    [anon_sym___FILE__] = ACTIONS(3177),
    [anon_sym___LINE__] = ACTIONS(3177),
    [anon_sym___PACKAGE__] = ACTIONS(3177),
    [anon_sym___SUB__] = ACTIONS(3177),
    [anon_sym_break] = ACTIONS(3177),
    [anon_sym_fork] = ACTIONS(3177),
    [anon_sym_getppid] = ACTIONS(3177),
    [anon_sym_time] = ACTIONS(3177),
    [anon_sym_times] = ACTIONS(3177),
    [anon_sym_wait] = ACTIONS(3177),
    [anon_sym_wantarray] = ACTIONS(3177),
    [anon_sym_abs] = ACTIONS(3177),
    [anon_sym_alarm] = ACTIONS(3177),
    [anon_sym_chop] = ACTIONS(3177),
    [anon_sym_chdir] = ACTIONS(3177),
    [anon_sym_close] = ACTIONS(3177),
    [anon_sym_closedir] = ACTIONS(3177),
    [anon_sym_caller] = ACTIONS(3177),
    [anon_sym_chomp] = ACTIONS(3177),
    [anon_sym_chr] = ACTIONS(3177),
    [anon_sym_cos] = ACTIONS(3177),
    [anon_sym_chroot] = ACTIONS(3177),
    [anon_sym_defined] = ACTIONS(3177),
    [anon_sym_delete] = ACTIONS(3177),
    [anon_sym_dbmclose] = ACTIONS(3177),
    [anon_sym_exists] = ACTIONS(3177),
    [anon_sym_exit] = ACTIONS(3177),
    [anon_sym_eof] = ACTIONS(3177),
    [anon_sym_exp] = ACTIONS(3177),
    [anon_sym_each] = ACTIONS(3177),
    [anon_sym_fc] = ACTIONS(3177),
    [anon_sym_fileno] = ACTIONS(3177),
    [anon_sym_gmtime] = ACTIONS(3177),
    [anon_sym_getc] = ACTIONS(3177),
    [anon_sym_getpgrp] = ACTIONS(3177),
    [anon_sym_getprotobyname] = ACTIONS(3177),
    [anon_sym_getpwname] = ACTIONS(3177),
    [anon_sym_getpwuid] = ACTIONS(3177),
    [anon_sym_getpeername] = ACTIONS(3177),
    [anon_sym_getnetbyname] = ACTIONS(3177),
    [anon_sym_getsockname] = ACTIONS(3177),
    [anon_sym_getgrnam] = ACTIONS(3177),
    [anon_sym_getgrgid] = ACTIONS(3177),
    [anon_sym_hex] = ACTIONS(3177),
    [anon_sym_int] = ACTIONS(3177),
    [anon_sym_keys] = ACTIONS(3177),
    [anon_sym_lc] = ACTIONS(3177),
    [anon_sym_lcfirst] = ACTIONS(3177),
    [anon_sym_length] = ACTIONS(3177),
    [anon_sym_localtime] = ACTIONS(3177),
    [anon_sym_log] = ACTIONS(3177),
    [anon_sym_lock] = ACTIONS(3177),
    [anon_sym_lstat] = ACTIONS(3177),
    [anon_sym_oct] = ACTIONS(3177),
    [anon_sym_ord] = ACTIONS(3177),
    [anon_sym_prototype] = ACTIONS(3177),
    [anon_sym_pop] = ACTIONS(3177),
    [anon_sym_pos] = ACTIONS(3177),
    [anon_sym_quotemeta] = ACTIONS(3177),
    [anon_sym_reset] = ACTIONS(3177),
    [anon_sym_rand] = ACTIONS(3177),
    [anon_sym_rmdir] = ACTIONS(3177),
    [anon_sym_readdir] = ACTIONS(3177),
    [anon_sym_readline] = ACTIONS(3177),
    [anon_sym_readpipe] = ACTIONS(3177),
    [anon_sym_rewinddir] = ACTIONS(3177),
    [anon_sym_readlink] = ACTIONS(3177),
    [anon_sym_ref] = ACTIONS(3177),
    [anon_sym_scalar] = ACTIONS(3177),
    [anon_sym_shift] = ACTIONS(3177),
    [anon_sym_sin] = ACTIONS(3177),
    [anon_sym_sleep] = ACTIONS(3177),
    [anon_sym_sqrt] = ACTIONS(3177),
    [anon_sym_srand] = ACTIONS(3177),
    [anon_sym_stat] = ACTIONS(3177),
    [anon_sym_study] = ACTIONS(3177),
    [anon_sym_tell] = ACTIONS(3177),
    [anon_sym_telldir] = ACTIONS(3177),
    [anon_sym_tied] = ACTIONS(3177),
    [anon_sym_uc] = ACTIONS(3177),
    [anon_sym_ucfirst] = ACTIONS(3177),
    [anon_sym_untie] = ACTIONS(3177),
    [anon_sym_umask] = ACTIONS(3177),
    [anon_sym_values] = ACTIONS(3177),
    [anon_sym_write] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3177),
    [anon_sym___END__] = ACTIONS(3177),
    [anon_sym_q] = ACTIONS(3177),
    [anon_sym_qq] = ACTIONS(3177),
    [anon_sym_qw] = ACTIONS(3177),
    [anon_sym_qx] = ACTIONS(3177),
    [anon_sym_qr] = ACTIONS(3177),
    [anon_sym_m] = ACTIONS(3177),
    [anon_sym_s] = ACTIONS(3177),
    [anon_sym_tr] = ACTIONS(3177),
    [anon_sym_y] = ACTIONS(3177),
    [anon_sym_if] = ACTIONS(3177),
    [anon_sym_unless] = ACTIONS(3177),
    [anon_sym_while] = ACTIONS(3177),
    [anon_sym_until] = ACTIONS(3177),
    [aux_sym__bareword_token1] = ACTIONS(3177),
    [sym_number] = ACTIONS(3177),
    [sym__apostrophe] = ACTIONS(3175),
    [sym__double_quote] = ACTIONS(3175),
    [sym__backtick] = ACTIONS(3175),
    [sym__search_slash] = ACTIONS(3175),
    [sym__PERLY_HEREDOC] = ACTIONS(3175),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1071] = {
    [sym_heredoc_content] = STATE(1071),
    [sym__identifier] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3009),
    [anon_sym_LBRACE2] = ACTIONS(3009),
    [anon_sym_RBRACE] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3009),
    [anon_sym_package] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_sub] = ACTIONS(3009),
    [anon_sym_method] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_my] = ACTIONS(3009),
    [anon_sym_state] = ACTIONS(3009),
    [anon_sym_our] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_defer] = ACTIONS(3009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3009),
    [anon_sym_else] = ACTIONS(3009),
    [anon_sym_elsif] = ACTIONS(3009),
    [anon_sym_and] = ACTIONS(3009),
    [anon_sym_or] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_AT] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_LT_LT] = ACTIONS(3009),
    [anon_sym_SLASH_SLASH] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3009),
    [anon_sym_eq] = ACTIONS(3009),
    [anon_sym_ne] = ACTIONS(3009),
    [anon_sym_cmp] = ACTIONS(3009),
    [anon_sym_lt] = ACTIONS(3009),
    [anon_sym_le] = ACTIONS(3009),
    [anon_sym_ge] = ACTIONS(3009),
    [anon_sym_gt] = ACTIONS(3009),
    [anon_sym_isa] = ACTIONS(3009),
    [anon_sym_TILDE] = ACTIONS(3009),
    [anon_sym_BANG] = ACTIONS(3009),
    [anon_sym_PLUS_PLUS] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3009),
    [anon_sym_BSLASH] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_eval] = ACTIONS(3009),
    [anon_sym_field] = ACTIONS(3009),
    [anon_sym_local] = ACTIONS(3009),
    [anon_sym_require] = ACTIONS(3009),
    [anon_sym_map] = ACTIONS(3009),
    [anon_sym_grep] = ACTIONS(3009),
    [anon_sym_sort] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_undef] = ACTIONS(3009),
    [anon_sym_PERCENT2] = ACTIONS(3009),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3009),
    [anon_sym_no] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_foreach] = ACTIONS(3009),
    [anon_sym_last] = ACTIONS(3009),
    [anon_sym_next] = ACTIONS(3009),
    [anon_sym_redo] = ACTIONS(3009),
    [anon_sym_BEGIN] = ACTIONS(3009),
    [anon_sym_INIT] = ACTIONS(3009),
    [anon_sym_CHECK] = ACTIONS(3009),
    [anon_sym_UNITCHECK] = ACTIONS(3009),
    [anon_sym_END] = ACTIONS(3009),
    [anon_sym_ADJUST] = ACTIONS(3009),
    [anon_sym___FILE__] = ACTIONS(3009),
    [anon_sym___LINE__] = ACTIONS(3009),
    [anon_sym___PACKAGE__] = ACTIONS(3009),
    [anon_sym___SUB__] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_fork] = ACTIONS(3009),
    [anon_sym_getppid] = ACTIONS(3009),
    [anon_sym_time] = ACTIONS(3009),
    [anon_sym_times] = ACTIONS(3009),
    [anon_sym_wait] = ACTIONS(3009),
    [anon_sym_wantarray] = ACTIONS(3009),
    [anon_sym_abs] = ACTIONS(3009),
    [anon_sym_alarm] = ACTIONS(3009),
    [anon_sym_chop] = ACTIONS(3009),
    [anon_sym_chdir] = ACTIONS(3009),
    [anon_sym_close] = ACTIONS(3009),
    [anon_sym_closedir] = ACTIONS(3009),
    [anon_sym_caller] = ACTIONS(3009),
    [anon_sym_chomp] = ACTIONS(3009),
    [anon_sym_chr] = ACTIONS(3009),
    [anon_sym_cos] = ACTIONS(3009),
    [anon_sym_chroot] = ACTIONS(3009),
    [anon_sym_defined] = ACTIONS(3009),
    [anon_sym_delete] = ACTIONS(3009),
    [anon_sym_dbmclose] = ACTIONS(3009),
    [anon_sym_exists] = ACTIONS(3009),
    [anon_sym_exit] = ACTIONS(3009),
    [anon_sym_eof] = ACTIONS(3009),
    [anon_sym_exp] = ACTIONS(3009),
    [anon_sym_each] = ACTIONS(3009),
    [anon_sym_fc] = ACTIONS(3009),
    [anon_sym_fileno] = ACTIONS(3009),
    [anon_sym_gmtime] = ACTIONS(3009),
    [anon_sym_getc] = ACTIONS(3009),
    [anon_sym_getpgrp] = ACTIONS(3009),
    [anon_sym_getprotobyname] = ACTIONS(3009),
    [anon_sym_getpwname] = ACTIONS(3009),
    [anon_sym_getpwuid] = ACTIONS(3009),
    [anon_sym_getpeername] = ACTIONS(3009),
    [anon_sym_getnetbyname] = ACTIONS(3009),
    [anon_sym_getsockname] = ACTIONS(3009),
    [anon_sym_getgrnam] = ACTIONS(3009),
    [anon_sym_getgrgid] = ACTIONS(3009),
    [anon_sym_hex] = ACTIONS(3009),
    [anon_sym_int] = ACTIONS(3009),
    [anon_sym_keys] = ACTIONS(3009),
    [anon_sym_lc] = ACTIONS(3009),
    [anon_sym_lcfirst] = ACTIONS(3009),
    [anon_sym_length] = ACTIONS(3009),
    [anon_sym_localtime] = ACTIONS(3009),
    [anon_sym_log] = ACTIONS(3009),
    [anon_sym_lock] = ACTIONS(3009),
    [anon_sym_lstat] = ACTIONS(3009),
    [anon_sym_oct] = ACTIONS(3009),
    [anon_sym_ord] = ACTIONS(3009),
    [anon_sym_prototype] = ACTIONS(3009),
    [anon_sym_pop] = ACTIONS(3009),
    [anon_sym_pos] = ACTIONS(3009),
    [anon_sym_quotemeta] = ACTIONS(3009),
    [anon_sym_reset] = ACTIONS(3009),
    [anon_sym_rand] = ACTIONS(3009),
    [anon_sym_rmdir] = ACTIONS(3009),
    [anon_sym_readdir] = ACTIONS(3009),
    [anon_sym_readline] = ACTIONS(3009),
    [anon_sym_readpipe] = ACTIONS(3009),
    [anon_sym_rewinddir] = ACTIONS(3009),
    [anon_sym_readlink] = ACTIONS(3009),
    [anon_sym_ref] = ACTIONS(3009),
    [anon_sym_scalar] = ACTIONS(3009),
    [anon_sym_shift] = ACTIONS(3009),
    [anon_sym_sin] = ACTIONS(3009),
    [anon_sym_sleep] = ACTIONS(3009),
    [anon_sym_sqrt] = ACTIONS(3009),
    [anon_sym_srand] = ACTIONS(3009),
    [anon_sym_stat] = ACTIONS(3009),
    [anon_sym_study] = ACTIONS(3009),
    [anon_sym_tell] = ACTIONS(3009),
    [anon_sym_telldir] = ACTIONS(3009),
    [anon_sym_tied] = ACTIONS(3009),
    [anon_sym_uc] = ACTIONS(3009),
    [anon_sym_ucfirst] = ACTIONS(3009),
    [anon_sym_untie] = ACTIONS(3009),
    [anon_sym_umask] = ACTIONS(3009),
    [anon_sym_values] = ACTIONS(3009),
    [anon_sym_write] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3009),
    [anon_sym___END__] = ACTIONS(3009),
    [anon_sym_q] = ACTIONS(3009),
    [anon_sym_qq] = ACTIONS(3009),
    [anon_sym_qw] = ACTIONS(3009),
    [anon_sym_qx] = ACTIONS(3009),
    [anon_sym_qr] = ACTIONS(3009),
    [anon_sym_m] = ACTIONS(3009),
    [anon_sym_s] = ACTIONS(3009),
    [anon_sym_tr] = ACTIONS(3009),
    [anon_sym_y] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_unless] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_until] = ACTIONS(3009),
    [aux_sym__bareword_token1] = ACTIONS(3009),
    [sym_number] = ACTIONS(3009),
    [sym__apostrophe] = ACTIONS(3007),
    [sym__double_quote] = ACTIONS(3007),
    [sym__backtick] = ACTIONS(3007),
    [sym__search_slash] = ACTIONS(3007),
    [sym__PERLY_HEREDOC] = ACTIONS(3007),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1072] = {
    [sym_heredoc_content] = STATE(1072),
    [sym__identifier] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_LBRACE2] = ACTIONS(3189),
    [anon_sym_RBRACE] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_package] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_sub] = ACTIONS(3189),
    [anon_sym_method] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3362),
    [anon_sym_my] = ACTIONS(3189),
    [anon_sym_state] = ACTIONS(3189),
    [anon_sym_our] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_defer] = ACTIONS(3189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_elsif] = ACTIONS(3189),
    [anon_sym_and] = ACTIONS(3189),
    [anon_sym_or] = ACTIONS(3189),
    [anon_sym_DOLLAR] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3189),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_LT_LT] = ACTIONS(3189),
    [anon_sym_SLASH_SLASH] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3189),
    [anon_sym_eq] = ACTIONS(3189),
    [anon_sym_ne] = ACTIONS(3189),
    [anon_sym_cmp] = ACTIONS(3189),
    [anon_sym_lt] = ACTIONS(3189),
    [anon_sym_le] = ACTIONS(3189),
    [anon_sym_ge] = ACTIONS(3189),
    [anon_sym_gt] = ACTIONS(3189),
    [anon_sym_isa] = ACTIONS(3189),
    [anon_sym_TILDE] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3189),
    [anon_sym_PLUS_PLUS] = ACTIONS(3189),
    [anon_sym_DASH_DASH] = ACTIONS(3189),
    [anon_sym_BSLASH] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_eval] = ACTIONS(3189),
    [anon_sym_field] = ACTIONS(3189),
    [anon_sym_local] = ACTIONS(3189),
    [anon_sym_require] = ACTIONS(3189),
    [anon_sym_map] = ACTIONS(3189),
    [anon_sym_grep] = ACTIONS(3189),
    [anon_sym_sort] = ACTIONS(3189),
    [anon_sym_goto] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_undef] = ACTIONS(3189),
    [anon_sym_PERCENT2] = ACTIONS(3189),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3189),
    [anon_sym_use] = ACTIONS(3189),
    [anon_sym_no] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_foreach] = ACTIONS(3189),
    [anon_sym_last] = ACTIONS(3189),
    [anon_sym_next] = ACTIONS(3189),
    [anon_sym_redo] = ACTIONS(3189),
    [anon_sym_BEGIN] = ACTIONS(3189),
    [anon_sym_INIT] = ACTIONS(3189),
    [anon_sym_CHECK] = ACTIONS(3189),
    [anon_sym_UNITCHECK] = ACTIONS(3189),
    [anon_sym_END] = ACTIONS(3189),
    [anon_sym_ADJUST] = ACTIONS(3189),
    [anon_sym___FILE__] = ACTIONS(3189),
    [anon_sym___LINE__] = ACTIONS(3189),
    [anon_sym___PACKAGE__] = ACTIONS(3189),
    [anon_sym___SUB__] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_fork] = ACTIONS(3189),
    [anon_sym_getppid] = ACTIONS(3189),
    [anon_sym_time] = ACTIONS(3189),
    [anon_sym_times] = ACTIONS(3189),
    [anon_sym_wait] = ACTIONS(3189),
    [anon_sym_wantarray] = ACTIONS(3189),
    [anon_sym_abs] = ACTIONS(3189),
    [anon_sym_alarm] = ACTIONS(3189),
    [anon_sym_chop] = ACTIONS(3189),
    [anon_sym_chdir] = ACTIONS(3189),
    [anon_sym_close] = ACTIONS(3189),
    [anon_sym_closedir] = ACTIONS(3189),
    [anon_sym_caller] = ACTIONS(3189),
    [anon_sym_chomp] = ACTIONS(3189),
    [anon_sym_chr] = ACTIONS(3189),
    [anon_sym_cos] = ACTIONS(3189),
    [anon_sym_chroot] = ACTIONS(3189),
    [anon_sym_defined] = ACTIONS(3189),
    [anon_sym_delete] = ACTIONS(3189),
    [anon_sym_dbmclose] = ACTIONS(3189),
    [anon_sym_exists] = ACTIONS(3189),
    [anon_sym_exit] = ACTIONS(3189),
    [anon_sym_eof] = ACTIONS(3189),
    [anon_sym_exp] = ACTIONS(3189),
    [anon_sym_each] = ACTIONS(3189),
    [anon_sym_fc] = ACTIONS(3189),
    [anon_sym_fileno] = ACTIONS(3189),
    [anon_sym_gmtime] = ACTIONS(3189),
    [anon_sym_getc] = ACTIONS(3189),
    [anon_sym_getpgrp] = ACTIONS(3189),
    [anon_sym_getprotobyname] = ACTIONS(3189),
    [anon_sym_getpwname] = ACTIONS(3189),
    [anon_sym_getpwuid] = ACTIONS(3189),
    [anon_sym_getpeername] = ACTIONS(3189),
    [anon_sym_getnetbyname] = ACTIONS(3189),
    [anon_sym_getsockname] = ACTIONS(3189),
    [anon_sym_getgrnam] = ACTIONS(3189),
    [anon_sym_getgrgid] = ACTIONS(3189),
    [anon_sym_hex] = ACTIONS(3189),
    [anon_sym_int] = ACTIONS(3189),
    [anon_sym_keys] = ACTIONS(3189),
    [anon_sym_lc] = ACTIONS(3189),
    [anon_sym_lcfirst] = ACTIONS(3189),
    [anon_sym_length] = ACTIONS(3189),
    [anon_sym_localtime] = ACTIONS(3189),
    [anon_sym_log] = ACTIONS(3189),
    [anon_sym_lock] = ACTIONS(3189),
    [anon_sym_lstat] = ACTIONS(3189),
    [anon_sym_oct] = ACTIONS(3189),
    [anon_sym_ord] = ACTIONS(3189),
    [anon_sym_prototype] = ACTIONS(3189),
    [anon_sym_pop] = ACTIONS(3189),
    [anon_sym_pos] = ACTIONS(3189),
    [anon_sym_quotemeta] = ACTIONS(3189),
    [anon_sym_reset] = ACTIONS(3189),
    [anon_sym_rand] = ACTIONS(3189),
    [anon_sym_rmdir] = ACTIONS(3189),
    [anon_sym_readdir] = ACTIONS(3189),
    [anon_sym_readline] = ACTIONS(3189),
    [anon_sym_readpipe] = ACTIONS(3189),
    [anon_sym_rewinddir] = ACTIONS(3189),
    [anon_sym_readlink] = ACTIONS(3189),
    [anon_sym_ref] = ACTIONS(3189),
    [anon_sym_scalar] = ACTIONS(3189),
    [anon_sym_shift] = ACTIONS(3189),
    [anon_sym_sin] = ACTIONS(3189),
    [anon_sym_sleep] = ACTIONS(3189),
    [anon_sym_sqrt] = ACTIONS(3189),
    [anon_sym_srand] = ACTIONS(3189),
    [anon_sym_stat] = ACTIONS(3189),
    [anon_sym_study] = ACTIONS(3189),
    [anon_sym_tell] = ACTIONS(3189),
    [anon_sym_telldir] = ACTIONS(3189),
    [anon_sym_tied] = ACTIONS(3189),
    [anon_sym_uc] = ACTIONS(3189),
    [anon_sym_ucfirst] = ACTIONS(3189),
    [anon_sym_untie] = ACTIONS(3189),
    [anon_sym_umask] = ACTIONS(3189),
    [anon_sym_values] = ACTIONS(3189),
    [anon_sym_write] = ACTIONS(3189),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3189),
    [anon_sym___END__] = ACTIONS(3189),
    [anon_sym_q] = ACTIONS(3189),
    [anon_sym_qq] = ACTIONS(3189),
    [anon_sym_qw] = ACTIONS(3189),
    [anon_sym_qx] = ACTIONS(3189),
    [anon_sym_qr] = ACTIONS(3189),
    [anon_sym_m] = ACTIONS(3189),
    [anon_sym_s] = ACTIONS(3189),
    [anon_sym_tr] = ACTIONS(3189),
    [anon_sym_y] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_until] = ACTIONS(3189),
    [aux_sym__bareword_token1] = ACTIONS(3189),
    [sym_number] = ACTIONS(3189),
    [sym__apostrophe] = ACTIONS(3187),
    [sym__double_quote] = ACTIONS(3187),
    [sym__backtick] = ACTIONS(3187),
    [sym__search_slash] = ACTIONS(3187),
    [sym__PERLY_HEREDOC] = ACTIONS(3187),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1073] = {
    [sym_heredoc_content] = STATE(1073),
    [sym__identifier] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LBRACE2] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_package] = ACTIONS(3204),
    [anon_sym_class] = ACTIONS(3204),
    [anon_sym_sub] = ACTIONS(3204),
    [anon_sym_method] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3204),
    [anon_sym_continue] = ACTIONS(3204),
    [anon_sym_my] = ACTIONS(3204),
    [anon_sym_state] = ACTIONS(3204),
    [anon_sym_our] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3204),
    [anon_sym_defer] = ACTIONS(3204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_elsif] = ACTIONS(3204),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_LT_LT] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_eq] = ACTIONS(3204),
    [anon_sym_ne] = ACTIONS(3204),
    [anon_sym_cmp] = ACTIONS(3204),
    [anon_sym_lt] = ACTIONS(3204),
    [anon_sym_le] = ACTIONS(3204),
    [anon_sym_ge] = ACTIONS(3204),
    [anon_sym_gt] = ACTIONS(3204),
    [anon_sym_isa] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [anon_sym_BSLASH] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_eval] = ACTIONS(3204),
    [anon_sym_field] = ACTIONS(3204),
    [anon_sym_local] = ACTIONS(3204),
    [anon_sym_require] = ACTIONS(3204),
    [anon_sym_map] = ACTIONS(3204),
    [anon_sym_grep] = ACTIONS(3204),
    [anon_sym_sort] = ACTIONS(3204),
    [anon_sym_goto] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3204),
    [anon_sym_undef] = ACTIONS(3204),
    [anon_sym_PERCENT2] = ACTIONS(3204),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3204),
    [anon_sym_no] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3204),
    [anon_sym_foreach] = ACTIONS(3204),
    [anon_sym_last] = ACTIONS(3204),
    [anon_sym_next] = ACTIONS(3204),
    [anon_sym_redo] = ACTIONS(3204),
    [anon_sym_BEGIN] = ACTIONS(3204),
    [anon_sym_INIT] = ACTIONS(3204),
    [anon_sym_CHECK] = ACTIONS(3204),
    [anon_sym_UNITCHECK] = ACTIONS(3204),
    [anon_sym_END] = ACTIONS(3204),
    [anon_sym_ADJUST] = ACTIONS(3204),
    [anon_sym___FILE__] = ACTIONS(3204),
    [anon_sym___LINE__] = ACTIONS(3204),
    [anon_sym___PACKAGE__] = ACTIONS(3204),
    [anon_sym___SUB__] = ACTIONS(3204),
    [anon_sym_break] = ACTIONS(3204),
    [anon_sym_fork] = ACTIONS(3204),
    [anon_sym_getppid] = ACTIONS(3204),
    [anon_sym_time] = ACTIONS(3204),
    [anon_sym_times] = ACTIONS(3204),
    [anon_sym_wait] = ACTIONS(3204),
    [anon_sym_wantarray] = ACTIONS(3204),
    [anon_sym_abs] = ACTIONS(3204),
    [anon_sym_alarm] = ACTIONS(3204),
    [anon_sym_chop] = ACTIONS(3204),
    [anon_sym_chdir] = ACTIONS(3204),
    [anon_sym_close] = ACTIONS(3204),
    [anon_sym_closedir] = ACTIONS(3204),
    [anon_sym_caller] = ACTIONS(3204),
    [anon_sym_chomp] = ACTIONS(3204),
    [anon_sym_chr] = ACTIONS(3204),
    [anon_sym_cos] = ACTIONS(3204),
    [anon_sym_chroot] = ACTIONS(3204),
    [anon_sym_defined] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3204),
    [anon_sym_dbmclose] = ACTIONS(3204),
    [anon_sym_exists] = ACTIONS(3204),
    [anon_sym_exit] = ACTIONS(3204),
    [anon_sym_eof] = ACTIONS(3204),
    [anon_sym_exp] = ACTIONS(3204),
    [anon_sym_each] = ACTIONS(3204),
    [anon_sym_fc] = ACTIONS(3204),
    [anon_sym_fileno] = ACTIONS(3204),
    [anon_sym_gmtime] = ACTIONS(3204),
    [anon_sym_getc] = ACTIONS(3204),
    [anon_sym_getpgrp] = ACTIONS(3204),
    [anon_sym_getprotobyname] = ACTIONS(3204),
    [anon_sym_getpwname] = ACTIONS(3204),
    [anon_sym_getpwuid] = ACTIONS(3204),
    [anon_sym_getpeername] = ACTIONS(3204),
    [anon_sym_getnetbyname] = ACTIONS(3204),
    [anon_sym_getsockname] = ACTIONS(3204),
    [anon_sym_getgrnam] = ACTIONS(3204),
    [anon_sym_getgrgid] = ACTIONS(3204),
    [anon_sym_hex] = ACTIONS(3204),
    [anon_sym_int] = ACTIONS(3204),
    [anon_sym_keys] = ACTIONS(3204),
    [anon_sym_lc] = ACTIONS(3204),
    [anon_sym_lcfirst] = ACTIONS(3204),
    [anon_sym_length] = ACTIONS(3204),
    [anon_sym_localtime] = ACTIONS(3204),
    [anon_sym_log] = ACTIONS(3204),
    [anon_sym_lock] = ACTIONS(3204),
    [anon_sym_lstat] = ACTIONS(3204),
    [anon_sym_oct] = ACTIONS(3204),
    [anon_sym_ord] = ACTIONS(3204),
    [anon_sym_prototype] = ACTIONS(3204),
    [anon_sym_pop] = ACTIONS(3204),
    [anon_sym_pos] = ACTIONS(3204),
    [anon_sym_quotemeta] = ACTIONS(3204),
    [anon_sym_reset] = ACTIONS(3204),
    [anon_sym_rand] = ACTIONS(3204),
    [anon_sym_rmdir] = ACTIONS(3204),
    [anon_sym_readdir] = ACTIONS(3204),
    [anon_sym_readline] = ACTIONS(3204),
    [anon_sym_readpipe] = ACTIONS(3204),
    [anon_sym_rewinddir] = ACTIONS(3204),
    [anon_sym_readlink] = ACTIONS(3204),
    [anon_sym_ref] = ACTIONS(3204),
    [anon_sym_scalar] = ACTIONS(3204),
    [anon_sym_shift] = ACTIONS(3204),
    [anon_sym_sin] = ACTIONS(3204),
    [anon_sym_sleep] = ACTIONS(3204),
    [anon_sym_sqrt] = ACTIONS(3204),
    [anon_sym_srand] = ACTIONS(3204),
    [anon_sym_stat] = ACTIONS(3204),
    [anon_sym_study] = ACTIONS(3204),
    [anon_sym_tell] = ACTIONS(3204),
    [anon_sym_telldir] = ACTIONS(3204),
    [anon_sym_tied] = ACTIONS(3204),
    [anon_sym_uc] = ACTIONS(3204),
    [anon_sym_ucfirst] = ACTIONS(3204),
    [anon_sym_untie] = ACTIONS(3204),
    [anon_sym_umask] = ACTIONS(3204),
    [anon_sym_values] = ACTIONS(3204),
    [anon_sym_write] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3204),
    [anon_sym___END__] = ACTIONS(3204),
    [anon_sym_q] = ACTIONS(3204),
    [anon_sym_qq] = ACTIONS(3204),
    [anon_sym_qw] = ACTIONS(3204),
    [anon_sym_qx] = ACTIONS(3204),
    [anon_sym_qr] = ACTIONS(3204),
    [anon_sym_m] = ACTIONS(3204),
    [anon_sym_s] = ACTIONS(3204),
    [anon_sym_tr] = ACTIONS(3204),
    [anon_sym_y] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [aux_sym__bareword_token1] = ACTIONS(3204),
    [sym_number] = ACTIONS(3204),
    [sym__apostrophe] = ACTIONS(3202),
    [sym__double_quote] = ACTIONS(3202),
    [sym__backtick] = ACTIONS(3202),
    [sym__search_slash] = ACTIONS(3202),
    [sym__PERLY_HEREDOC] = ACTIONS(3202),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1074] = {
    [sym_heredoc_content] = STATE(1074),
    [sym__identifier] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LBRACE2] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_package] = ACTIONS(3274),
    [anon_sym_class] = ACTIONS(3274),
    [anon_sym_sub] = ACTIONS(3274),
    [anon_sym_method] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_my] = ACTIONS(3274),
    [anon_sym_state] = ACTIONS(3274),
    [anon_sym_our] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_defer] = ACTIONS(3274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3274),
    [anon_sym_else] = ACTIONS(3274),
    [anon_sym_elsif] = ACTIONS(3274),
    [anon_sym_and] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_AT] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_SLASH_SLASH] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_eq] = ACTIONS(3274),
    [anon_sym_ne] = ACTIONS(3274),
    [anon_sym_cmp] = ACTIONS(3274),
    [anon_sym_lt] = ACTIONS(3274),
    [anon_sym_le] = ACTIONS(3274),
    [anon_sym_ge] = ACTIONS(3274),
    [anon_sym_gt] = ACTIONS(3274),
    [anon_sym_isa] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_BSLASH] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_eval] = ACTIONS(3274),
    [anon_sym_field] = ACTIONS(3274),
    [anon_sym_local] = ACTIONS(3274),
    [anon_sym_require] = ACTIONS(3274),
    [anon_sym_map] = ACTIONS(3274),
    [anon_sym_grep] = ACTIONS(3274),
    [anon_sym_sort] = ACTIONS(3274),
    [anon_sym_goto] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_undef] = ACTIONS(3274),
    [anon_sym_PERCENT2] = ACTIONS(3274),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_no] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_foreach] = ACTIONS(3274),
    [anon_sym_last] = ACTIONS(3274),
    [anon_sym_next] = ACTIONS(3274),
    [anon_sym_redo] = ACTIONS(3274),
    [anon_sym_BEGIN] = ACTIONS(3274),
    [anon_sym_INIT] = ACTIONS(3274),
    [anon_sym_CHECK] = ACTIONS(3274),
    [anon_sym_UNITCHECK] = ACTIONS(3274),
    [anon_sym_END] = ACTIONS(3274),
    [anon_sym_ADJUST] = ACTIONS(3274),
    [anon_sym___FILE__] = ACTIONS(3274),
    [anon_sym___LINE__] = ACTIONS(3274),
    [anon_sym___PACKAGE__] = ACTIONS(3274),
    [anon_sym___SUB__] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_fork] = ACTIONS(3274),
    [anon_sym_getppid] = ACTIONS(3274),
    [anon_sym_time] = ACTIONS(3274),
    [anon_sym_times] = ACTIONS(3274),
    [anon_sym_wait] = ACTIONS(3274),
    [anon_sym_wantarray] = ACTIONS(3274),
    [anon_sym_abs] = ACTIONS(3274),
    [anon_sym_alarm] = ACTIONS(3274),
    [anon_sym_chop] = ACTIONS(3274),
    [anon_sym_chdir] = ACTIONS(3274),
    [anon_sym_close] = ACTIONS(3274),
    [anon_sym_closedir] = ACTIONS(3274),
    [anon_sym_caller] = ACTIONS(3274),
    [anon_sym_chomp] = ACTIONS(3274),
    [anon_sym_chr] = ACTIONS(3274),
    [anon_sym_cos] = ACTIONS(3274),
    [anon_sym_chroot] = ACTIONS(3274),
    [anon_sym_defined] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3274),
    [anon_sym_dbmclose] = ACTIONS(3274),
    [anon_sym_exists] = ACTIONS(3274),
    [anon_sym_exit] = ACTIONS(3274),
    [anon_sym_eof] = ACTIONS(3274),
    [anon_sym_exp] = ACTIONS(3274),
    [anon_sym_each] = ACTIONS(3274),
    [anon_sym_fc] = ACTIONS(3274),
    [anon_sym_fileno] = ACTIONS(3274),
    [anon_sym_gmtime] = ACTIONS(3274),
    [anon_sym_getc] = ACTIONS(3274),
    [anon_sym_getpgrp] = ACTIONS(3274),
    [anon_sym_getprotobyname] = ACTIONS(3274),
    [anon_sym_getpwname] = ACTIONS(3274),
    [anon_sym_getpwuid] = ACTIONS(3274),
    [anon_sym_getpeername] = ACTIONS(3274),
    [anon_sym_getnetbyname] = ACTIONS(3274),
    [anon_sym_getsockname] = ACTIONS(3274),
    [anon_sym_getgrnam] = ACTIONS(3274),
    [anon_sym_getgrgid] = ACTIONS(3274),
    [anon_sym_hex] = ACTIONS(3274),
    [anon_sym_int] = ACTIONS(3274),
    [anon_sym_keys] = ACTIONS(3274),
    [anon_sym_lc] = ACTIONS(3274),
    [anon_sym_lcfirst] = ACTIONS(3274),
    [anon_sym_length] = ACTIONS(3274),
    [anon_sym_localtime] = ACTIONS(3274),
    [anon_sym_log] = ACTIONS(3274),
    [anon_sym_lock] = ACTIONS(3274),
    [anon_sym_lstat] = ACTIONS(3274),
    [anon_sym_oct] = ACTIONS(3274),
    [anon_sym_ord] = ACTIONS(3274),
    [anon_sym_prototype] = ACTIONS(3274),
    [anon_sym_pop] = ACTIONS(3274),
    [anon_sym_pos] = ACTIONS(3274),
    [anon_sym_quotemeta] = ACTIONS(3274),
    [anon_sym_reset] = ACTIONS(3274),
    [anon_sym_rand] = ACTIONS(3274),
    [anon_sym_rmdir] = ACTIONS(3274),
    [anon_sym_readdir] = ACTIONS(3274),
    [anon_sym_readline] = ACTIONS(3274),
    [anon_sym_readpipe] = ACTIONS(3274),
    [anon_sym_rewinddir] = ACTIONS(3274),
    [anon_sym_readlink] = ACTIONS(3274),
    [anon_sym_ref] = ACTIONS(3274),
    [anon_sym_scalar] = ACTIONS(3274),
    [anon_sym_shift] = ACTIONS(3274),
    [anon_sym_sin] = ACTIONS(3274),
    [anon_sym_sleep] = ACTIONS(3274),
    [anon_sym_sqrt] = ACTIONS(3274),
    [anon_sym_srand] = ACTIONS(3274),
    [anon_sym_stat] = ACTIONS(3274),
    [anon_sym_study] = ACTIONS(3274),
    [anon_sym_tell] = ACTIONS(3274),
    [anon_sym_telldir] = ACTIONS(3274),
    [anon_sym_tied] = ACTIONS(3274),
    [anon_sym_uc] = ACTIONS(3274),
    [anon_sym_ucfirst] = ACTIONS(3274),
    [anon_sym_untie] = ACTIONS(3274),
    [anon_sym_umask] = ACTIONS(3274),
    [anon_sym_values] = ACTIONS(3274),
    [anon_sym_write] = ACTIONS(3274),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3274),
    [anon_sym___END__] = ACTIONS(3274),
    [anon_sym_q] = ACTIONS(3274),
    [anon_sym_qq] = ACTIONS(3274),
    [anon_sym_qw] = ACTIONS(3274),
    [anon_sym_qx] = ACTIONS(3274),
    [anon_sym_qr] = ACTIONS(3274),
    [anon_sym_m] = ACTIONS(3274),
    [anon_sym_s] = ACTIONS(3274),
    [anon_sym_tr] = ACTIONS(3274),
    [anon_sym_y] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_unless] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_until] = ACTIONS(3274),
    [aux_sym__bareword_token1] = ACTIONS(3274),
    [sym_number] = ACTIONS(3274),
    [sym__apostrophe] = ACTIONS(3272),
    [sym__double_quote] = ACTIONS(3272),
    [sym__backtick] = ACTIONS(3272),
    [sym__search_slash] = ACTIONS(3272),
    [sym__PERLY_HEREDOC] = ACTIONS(3272),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1075] = {
    [sym_heredoc_content] = STATE(1075),
    [sym__identifier] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_LBRACE2] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_package] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_sub] = ACTIONS(3293),
    [anon_sym_method] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_my] = ACTIONS(3293),
    [anon_sym_state] = ACTIONS(3293),
    [anon_sym_our] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_defer] = ACTIONS(3293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_elsif] = ACTIONS(3293),
    [anon_sym_and] = ACTIONS(3293),
    [anon_sym_or] = ACTIONS(3293),
    [anon_sym_DOLLAR] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_LT_LT] = ACTIONS(3293),
    [anon_sym_SLASH_SLASH] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_eq] = ACTIONS(3293),
    [anon_sym_ne] = ACTIONS(3293),
    [anon_sym_cmp] = ACTIONS(3293),
    [anon_sym_lt] = ACTIONS(3293),
    [anon_sym_le] = ACTIONS(3293),
    [anon_sym_ge] = ACTIONS(3293),
    [anon_sym_gt] = ACTIONS(3293),
    [anon_sym_isa] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_BSLASH] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_eval] = ACTIONS(3293),
    [anon_sym_field] = ACTIONS(3293),
    [anon_sym_local] = ACTIONS(3293),
    [anon_sym_require] = ACTIONS(3293),
    [anon_sym_map] = ACTIONS(3293),
    [anon_sym_grep] = ACTIONS(3293),
    [anon_sym_sort] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_undef] = ACTIONS(3293),
    [anon_sym_PERCENT2] = ACTIONS(3293),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3293),
    [anon_sym_use] = ACTIONS(3293),
    [anon_sym_no] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_foreach] = ACTIONS(3293),
    [anon_sym_last] = ACTIONS(3293),
    [anon_sym_next] = ACTIONS(3293),
    [anon_sym_redo] = ACTIONS(3293),
    [anon_sym_BEGIN] = ACTIONS(3293),
    [anon_sym_INIT] = ACTIONS(3293),
    [anon_sym_CHECK] = ACTIONS(3293),
    [anon_sym_UNITCHECK] = ACTIONS(3293),
    [anon_sym_END] = ACTIONS(3293),
    [anon_sym_ADJUST] = ACTIONS(3293),
    [anon_sym___FILE__] = ACTIONS(3293),
    [anon_sym___LINE__] = ACTIONS(3293),
    [anon_sym___PACKAGE__] = ACTIONS(3293),
    [anon_sym___SUB__] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_fork] = ACTIONS(3293),
    [anon_sym_getppid] = ACTIONS(3293),
    [anon_sym_time] = ACTIONS(3293),
    [anon_sym_times] = ACTIONS(3293),
    [anon_sym_wait] = ACTIONS(3293),
    [anon_sym_wantarray] = ACTIONS(3293),
    [anon_sym_abs] = ACTIONS(3293),
    [anon_sym_alarm] = ACTIONS(3293),
    [anon_sym_chop] = ACTIONS(3293),
    [anon_sym_chdir] = ACTIONS(3293),
    [anon_sym_close] = ACTIONS(3293),
    [anon_sym_closedir] = ACTIONS(3293),
    [anon_sym_caller] = ACTIONS(3293),
    [anon_sym_chomp] = ACTIONS(3293),
    [anon_sym_chr] = ACTIONS(3293),
    [anon_sym_cos] = ACTIONS(3293),
    [anon_sym_chroot] = ACTIONS(3293),
    [anon_sym_defined] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_dbmclose] = ACTIONS(3293),
    [anon_sym_exists] = ACTIONS(3293),
    [anon_sym_exit] = ACTIONS(3293),
    [anon_sym_eof] = ACTIONS(3293),
    [anon_sym_exp] = ACTIONS(3293),
    [anon_sym_each] = ACTIONS(3293),
    [anon_sym_fc] = ACTIONS(3293),
    [anon_sym_fileno] = ACTIONS(3293),
    [anon_sym_gmtime] = ACTIONS(3293),
    [anon_sym_getc] = ACTIONS(3293),
    [anon_sym_getpgrp] = ACTIONS(3293),
    [anon_sym_getprotobyname] = ACTIONS(3293),
    [anon_sym_getpwname] = ACTIONS(3293),
    [anon_sym_getpwuid] = ACTIONS(3293),
    [anon_sym_getpeername] = ACTIONS(3293),
    [anon_sym_getnetbyname] = ACTIONS(3293),
    [anon_sym_getsockname] = ACTIONS(3293),
    [anon_sym_getgrnam] = ACTIONS(3293),
    [anon_sym_getgrgid] = ACTIONS(3293),
    [anon_sym_hex] = ACTIONS(3293),
    [anon_sym_int] = ACTIONS(3293),
    [anon_sym_keys] = ACTIONS(3293),
    [anon_sym_lc] = ACTIONS(3293),
    [anon_sym_lcfirst] = ACTIONS(3293),
    [anon_sym_length] = ACTIONS(3293),
    [anon_sym_localtime] = ACTIONS(3293),
    [anon_sym_log] = ACTIONS(3293),
    [anon_sym_lock] = ACTIONS(3293),
    [anon_sym_lstat] = ACTIONS(3293),
    [anon_sym_oct] = ACTIONS(3293),
    [anon_sym_ord] = ACTIONS(3293),
    [anon_sym_prototype] = ACTIONS(3293),
    [anon_sym_pop] = ACTIONS(3293),
    [anon_sym_pos] = ACTIONS(3293),
    [anon_sym_quotemeta] = ACTIONS(3293),
    [anon_sym_reset] = ACTIONS(3293),
    [anon_sym_rand] = ACTIONS(3293),
    [anon_sym_rmdir] = ACTIONS(3293),
    [anon_sym_readdir] = ACTIONS(3293),
    [anon_sym_readline] = ACTIONS(3293),
    [anon_sym_readpipe] = ACTIONS(3293),
    [anon_sym_rewinddir] = ACTIONS(3293),
    [anon_sym_readlink] = ACTIONS(3293),
    [anon_sym_ref] = ACTIONS(3293),
    [anon_sym_scalar] = ACTIONS(3293),
    [anon_sym_shift] = ACTIONS(3293),
    [anon_sym_sin] = ACTIONS(3293),
    [anon_sym_sleep] = ACTIONS(3293),
    [anon_sym_sqrt] = ACTIONS(3293),
    [anon_sym_srand] = ACTIONS(3293),
    [anon_sym_stat] = ACTIONS(3293),
    [anon_sym_study] = ACTIONS(3293),
    [anon_sym_tell] = ACTIONS(3293),
    [anon_sym_telldir] = ACTIONS(3293),
    [anon_sym_tied] = ACTIONS(3293),
    [anon_sym_uc] = ACTIONS(3293),
    [anon_sym_ucfirst] = ACTIONS(3293),
    [anon_sym_untie] = ACTIONS(3293),
    [anon_sym_umask] = ACTIONS(3293),
    [anon_sym_values] = ACTIONS(3293),
    [anon_sym_write] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3293),
    [anon_sym___END__] = ACTIONS(3293),
    [anon_sym_q] = ACTIONS(3293),
    [anon_sym_qq] = ACTIONS(3293),
    [anon_sym_qw] = ACTIONS(3293),
    [anon_sym_qx] = ACTIONS(3293),
    [anon_sym_qr] = ACTIONS(3293),
    [anon_sym_m] = ACTIONS(3293),
    [anon_sym_s] = ACTIONS(3293),
    [anon_sym_tr] = ACTIONS(3293),
    [anon_sym_y] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_unless] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_until] = ACTIONS(3293),
    [aux_sym__bareword_token1] = ACTIONS(3293),
    [sym_number] = ACTIONS(3293),
    [sym__apostrophe] = ACTIONS(3291),
    [sym__double_quote] = ACTIONS(3291),
    [sym__backtick] = ACTIONS(3291),
    [sym__search_slash] = ACTIONS(3291),
    [sym__PERLY_HEREDOC] = ACTIONS(3291),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1076] = {
    [sym_heredoc_content] = STATE(1076),
    [sym__identifier] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_LBRACE2] = ACTIONS(3121),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_package] = ACTIONS(3121),
    [anon_sym_class] = ACTIONS(3121),
    [anon_sym_sub] = ACTIONS(3121),
    [anon_sym_method] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_continue] = ACTIONS(3121),
    [anon_sym_my] = ACTIONS(3121),
    [anon_sym_state] = ACTIONS(3121),
    [anon_sym_our] = ACTIONS(3121),
    [anon_sym_try] = ACTIONS(3121),
    [anon_sym_defer] = ACTIONS(3121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3121),
    [anon_sym_else] = ACTIONS(3121),
    [anon_sym_elsif] = ACTIONS(3121),
    [anon_sym_and] = ACTIONS(3121),
    [anon_sym_or] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_AT] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_eq] = ACTIONS(3121),
    [anon_sym_ne] = ACTIONS(3121),
    [anon_sym_cmp] = ACTIONS(3121),
    [anon_sym_lt] = ACTIONS(3121),
    [anon_sym_le] = ACTIONS(3121),
    [anon_sym_ge] = ACTIONS(3121),
    [anon_sym_gt] = ACTIONS(3121),
    [anon_sym_isa] = ACTIONS(3121),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [anon_sym_BSLASH] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3121),
    [anon_sym_eval] = ACTIONS(3121),
    [anon_sym_field] = ACTIONS(3121),
    [anon_sym_local] = ACTIONS(3121),
    [anon_sym_require] = ACTIONS(3121),
    [anon_sym_map] = ACTIONS(3121),
    [anon_sym_grep] = ACTIONS(3121),
    [anon_sym_sort] = ACTIONS(3121),
    [anon_sym_goto] = ACTIONS(3121),
    [anon_sym_return] = ACTIONS(3121),
    [anon_sym_undef] = ACTIONS(3121),
    [anon_sym_PERCENT2] = ACTIONS(3121),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3121),
    [anon_sym_no] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3121),
    [anon_sym_foreach] = ACTIONS(3121),
    [anon_sym_last] = ACTIONS(3121),
    [anon_sym_next] = ACTIONS(3121),
    [anon_sym_redo] = ACTIONS(3121),
    [anon_sym_BEGIN] = ACTIONS(3121),
    [anon_sym_INIT] = ACTIONS(3121),
    [anon_sym_CHECK] = ACTIONS(3121),
    [anon_sym_UNITCHECK] = ACTIONS(3121),
    [anon_sym_END] = ACTIONS(3121),
    [anon_sym_ADJUST] = ACTIONS(3121),
    [anon_sym___FILE__] = ACTIONS(3121),
    [anon_sym___LINE__] = ACTIONS(3121),
    [anon_sym___PACKAGE__] = ACTIONS(3121),
    [anon_sym___SUB__] = ACTIONS(3121),
    [anon_sym_break] = ACTIONS(3121),
    [anon_sym_fork] = ACTIONS(3121),
    [anon_sym_getppid] = ACTIONS(3121),
    [anon_sym_time] = ACTIONS(3121),
    [anon_sym_times] = ACTIONS(3121),
    [anon_sym_wait] = ACTIONS(3121),
    [anon_sym_wantarray] = ACTIONS(3121),
    [anon_sym_abs] = ACTIONS(3121),
    [anon_sym_alarm] = ACTIONS(3121),
    [anon_sym_chop] = ACTIONS(3121),
    [anon_sym_chdir] = ACTIONS(3121),
    [anon_sym_close] = ACTIONS(3121),
    [anon_sym_closedir] = ACTIONS(3121),
    [anon_sym_caller] = ACTIONS(3121),
    [anon_sym_chomp] = ACTIONS(3121),
    [anon_sym_chr] = ACTIONS(3121),
    [anon_sym_cos] = ACTIONS(3121),
    [anon_sym_chroot] = ACTIONS(3121),
    [anon_sym_defined] = ACTIONS(3121),
    [anon_sym_delete] = ACTIONS(3121),
    [anon_sym_dbmclose] = ACTIONS(3121),
    [anon_sym_exists] = ACTIONS(3121),
    [anon_sym_exit] = ACTIONS(3121),
    [anon_sym_eof] = ACTIONS(3121),
    [anon_sym_exp] = ACTIONS(3121),
    [anon_sym_each] = ACTIONS(3121),
    [anon_sym_fc] = ACTIONS(3121),
    [anon_sym_fileno] = ACTIONS(3121),
    [anon_sym_gmtime] = ACTIONS(3121),
    [anon_sym_getc] = ACTIONS(3121),
    [anon_sym_getpgrp] = ACTIONS(3121),
    [anon_sym_getprotobyname] = ACTIONS(3121),
    [anon_sym_getpwname] = ACTIONS(3121),
    [anon_sym_getpwuid] = ACTIONS(3121),
    [anon_sym_getpeername] = ACTIONS(3121),
    [anon_sym_getnetbyname] = ACTIONS(3121),
    [anon_sym_getsockname] = ACTIONS(3121),
    [anon_sym_getgrnam] = ACTIONS(3121),
    [anon_sym_getgrgid] = ACTIONS(3121),
    [anon_sym_hex] = ACTIONS(3121),
    [anon_sym_int] = ACTIONS(3121),
    [anon_sym_keys] = ACTIONS(3121),
    [anon_sym_lc] = ACTIONS(3121),
    [anon_sym_lcfirst] = ACTIONS(3121),
    [anon_sym_length] = ACTIONS(3121),
    [anon_sym_localtime] = ACTIONS(3121),
    [anon_sym_log] = ACTIONS(3121),
    [anon_sym_lock] = ACTIONS(3121),
    [anon_sym_lstat] = ACTIONS(3121),
    [anon_sym_oct] = ACTIONS(3121),
    [anon_sym_ord] = ACTIONS(3121),
    [anon_sym_prototype] = ACTIONS(3121),
    [anon_sym_pop] = ACTIONS(3121),
    [anon_sym_pos] = ACTIONS(3121),
    [anon_sym_quotemeta] = ACTIONS(3121),
    [anon_sym_reset] = ACTIONS(3121),
    [anon_sym_rand] = ACTIONS(3121),
    [anon_sym_rmdir] = ACTIONS(3121),
    [anon_sym_readdir] = ACTIONS(3121),
    [anon_sym_readline] = ACTIONS(3121),
    [anon_sym_readpipe] = ACTIONS(3121),
    [anon_sym_rewinddir] = ACTIONS(3121),
    [anon_sym_readlink] = ACTIONS(3121),
    [anon_sym_ref] = ACTIONS(3121),
    [anon_sym_scalar] = ACTIONS(3121),
    [anon_sym_shift] = ACTIONS(3121),
    [anon_sym_sin] = ACTIONS(3121),
    [anon_sym_sleep] = ACTIONS(3121),
    [anon_sym_sqrt] = ACTIONS(3121),
    [anon_sym_srand] = ACTIONS(3121),
    [anon_sym_stat] = ACTIONS(3121),
    [anon_sym_study] = ACTIONS(3121),
    [anon_sym_tell] = ACTIONS(3121),
    [anon_sym_telldir] = ACTIONS(3121),
    [anon_sym_tied] = ACTIONS(3121),
    [anon_sym_uc] = ACTIONS(3121),
    [anon_sym_ucfirst] = ACTIONS(3121),
    [anon_sym_untie] = ACTIONS(3121),
    [anon_sym_umask] = ACTIONS(3121),
    [anon_sym_values] = ACTIONS(3121),
    [anon_sym_write] = ACTIONS(3121),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3121),
    [anon_sym___END__] = ACTIONS(3121),
    [anon_sym_q] = ACTIONS(3121),
    [anon_sym_qq] = ACTIONS(3121),
    [anon_sym_qw] = ACTIONS(3121),
    [anon_sym_qx] = ACTIONS(3121),
    [anon_sym_qr] = ACTIONS(3121),
    [anon_sym_m] = ACTIONS(3121),
    [anon_sym_s] = ACTIONS(3121),
    [anon_sym_tr] = ACTIONS(3121),
    [anon_sym_y] = ACTIONS(3121),
    [anon_sym_if] = ACTIONS(3121),
    [anon_sym_unless] = ACTIONS(3121),
    [anon_sym_while] = ACTIONS(3121),
    [anon_sym_until] = ACTIONS(3121),
    [aux_sym__bareword_token1] = ACTIONS(3121),
    [sym_number] = ACTIONS(3121),
    [sym__apostrophe] = ACTIONS(3119),
    [sym__double_quote] = ACTIONS(3119),
    [sym__backtick] = ACTIONS(3119),
    [sym__search_slash] = ACTIONS(3119),
    [sym__PERLY_HEREDOC] = ACTIONS(3119),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1077] = {
    [sym_heredoc_content] = STATE(1077),
    [sym__identifier] = ACTIONS(3316),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_LBRACE2] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_package] = ACTIONS(3316),
    [anon_sym_class] = ACTIONS(3316),
    [anon_sym_sub] = ACTIONS(3316),
    [anon_sym_method] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_my] = ACTIONS(3316),
    [anon_sym_state] = ACTIONS(3316),
    [anon_sym_our] = ACTIONS(3316),
    [anon_sym_try] = ACTIONS(3316),
    [anon_sym_defer] = ACTIONS(3316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3316),
    [anon_sym_else] = ACTIONS(3316),
    [anon_sym_elsif] = ACTIONS(3316),
    [anon_sym_and] = ACTIONS(3316),
    [anon_sym_or] = ACTIONS(3316),
    [anon_sym_DOLLAR] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_AT] = ACTIONS(3316),
    [anon_sym_LT] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3316),
    [anon_sym_SLASH_SLASH] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3316),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_eq] = ACTIONS(3316),
    [anon_sym_ne] = ACTIONS(3316),
    [anon_sym_cmp] = ACTIONS(3316),
    [anon_sym_lt] = ACTIONS(3316),
    [anon_sym_le] = ACTIONS(3316),
    [anon_sym_ge] = ACTIONS(3316),
    [anon_sym_gt] = ACTIONS(3316),
    [anon_sym_isa] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_BSLASH] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3316),
    [anon_sym_eval] = ACTIONS(3316),
    [anon_sym_field] = ACTIONS(3316),
    [anon_sym_local] = ACTIONS(3316),
    [anon_sym_require] = ACTIONS(3316),
    [anon_sym_map] = ACTIONS(3316),
    [anon_sym_grep] = ACTIONS(3316),
    [anon_sym_sort] = ACTIONS(3316),
    [anon_sym_goto] = ACTIONS(3316),
    [anon_sym_return] = ACTIONS(3316),
    [anon_sym_undef] = ACTIONS(3316),
    [anon_sym_PERCENT2] = ACTIONS(3316),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3316),
    [anon_sym_use] = ACTIONS(3316),
    [anon_sym_no] = ACTIONS(3316),
    [anon_sym_for] = ACTIONS(3316),
    [anon_sym_foreach] = ACTIONS(3316),
    [anon_sym_last] = ACTIONS(3316),
    [anon_sym_next] = ACTIONS(3316),
    [anon_sym_redo] = ACTIONS(3316),
    [anon_sym_BEGIN] = ACTIONS(3316),
    [anon_sym_INIT] = ACTIONS(3316),
    [anon_sym_CHECK] = ACTIONS(3316),
    [anon_sym_UNITCHECK] = ACTIONS(3316),
    [anon_sym_END] = ACTIONS(3316),
    [anon_sym_ADJUST] = ACTIONS(3316),
    [anon_sym___FILE__] = ACTIONS(3316),
    [anon_sym___LINE__] = ACTIONS(3316),
    [anon_sym___PACKAGE__] = ACTIONS(3316),
    [anon_sym___SUB__] = ACTIONS(3316),
    [anon_sym_break] = ACTIONS(3316),
    [anon_sym_fork] = ACTIONS(3316),
    [anon_sym_getppid] = ACTIONS(3316),
    [anon_sym_time] = ACTIONS(3316),
    [anon_sym_times] = ACTIONS(3316),
    [anon_sym_wait] = ACTIONS(3316),
    [anon_sym_wantarray] = ACTIONS(3316),
    [anon_sym_abs] = ACTIONS(3316),
    [anon_sym_alarm] = ACTIONS(3316),
    [anon_sym_chop] = ACTIONS(3316),
    [anon_sym_chdir] = ACTIONS(3316),
    [anon_sym_close] = ACTIONS(3316),
    [anon_sym_closedir] = ACTIONS(3316),
    [anon_sym_caller] = ACTIONS(3316),
    [anon_sym_chomp] = ACTIONS(3316),
    [anon_sym_chr] = ACTIONS(3316),
    [anon_sym_cos] = ACTIONS(3316),
    [anon_sym_chroot] = ACTIONS(3316),
    [anon_sym_defined] = ACTIONS(3316),
    [anon_sym_delete] = ACTIONS(3316),
    [anon_sym_dbmclose] = ACTIONS(3316),
    [anon_sym_exists] = ACTIONS(3316),
    [anon_sym_exit] = ACTIONS(3316),
    [anon_sym_eof] = ACTIONS(3316),
    [anon_sym_exp] = ACTIONS(3316),
    [anon_sym_each] = ACTIONS(3316),
    [anon_sym_fc] = ACTIONS(3316),
    [anon_sym_fileno] = ACTIONS(3316),
    [anon_sym_gmtime] = ACTIONS(3316),
    [anon_sym_getc] = ACTIONS(3316),
    [anon_sym_getpgrp] = ACTIONS(3316),
    [anon_sym_getprotobyname] = ACTIONS(3316),
    [anon_sym_getpwname] = ACTIONS(3316),
    [anon_sym_getpwuid] = ACTIONS(3316),
    [anon_sym_getpeername] = ACTIONS(3316),
    [anon_sym_getnetbyname] = ACTIONS(3316),
    [anon_sym_getsockname] = ACTIONS(3316),
    [anon_sym_getgrnam] = ACTIONS(3316),
    [anon_sym_getgrgid] = ACTIONS(3316),
    [anon_sym_hex] = ACTIONS(3316),
    [anon_sym_int] = ACTIONS(3316),
    [anon_sym_keys] = ACTIONS(3316),
    [anon_sym_lc] = ACTIONS(3316),
    [anon_sym_lcfirst] = ACTIONS(3316),
    [anon_sym_length] = ACTIONS(3316),
    [anon_sym_localtime] = ACTIONS(3316),
    [anon_sym_log] = ACTIONS(3316),
    [anon_sym_lock] = ACTIONS(3316),
    [anon_sym_lstat] = ACTIONS(3316),
    [anon_sym_oct] = ACTIONS(3316),
    [anon_sym_ord] = ACTIONS(3316),
    [anon_sym_prototype] = ACTIONS(3316),
    [anon_sym_pop] = ACTIONS(3316),
    [anon_sym_pos] = ACTIONS(3316),
    [anon_sym_quotemeta] = ACTIONS(3316),
    [anon_sym_reset] = ACTIONS(3316),
    [anon_sym_rand] = ACTIONS(3316),
    [anon_sym_rmdir] = ACTIONS(3316),
    [anon_sym_readdir] = ACTIONS(3316),
    [anon_sym_readline] = ACTIONS(3316),
    [anon_sym_readpipe] = ACTIONS(3316),
    [anon_sym_rewinddir] = ACTIONS(3316),
    [anon_sym_readlink] = ACTIONS(3316),
    [anon_sym_ref] = ACTIONS(3316),
    [anon_sym_scalar] = ACTIONS(3316),
    [anon_sym_shift] = ACTIONS(3316),
    [anon_sym_sin] = ACTIONS(3316),
    [anon_sym_sleep] = ACTIONS(3316),
    [anon_sym_sqrt] = ACTIONS(3316),
    [anon_sym_srand] = ACTIONS(3316),
    [anon_sym_stat] = ACTIONS(3316),
    [anon_sym_study] = ACTIONS(3316),
    [anon_sym_tell] = ACTIONS(3316),
    [anon_sym_telldir] = ACTIONS(3316),
    [anon_sym_tied] = ACTIONS(3316),
    [anon_sym_uc] = ACTIONS(3316),
    [anon_sym_ucfirst] = ACTIONS(3316),
    [anon_sym_untie] = ACTIONS(3316),
    [anon_sym_umask] = ACTIONS(3316),
    [anon_sym_values] = ACTIONS(3316),
    [anon_sym_write] = ACTIONS(3316),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3316),
    [anon_sym___END__] = ACTIONS(3316),
    [anon_sym_q] = ACTIONS(3316),
    [anon_sym_qq] = ACTIONS(3316),
    [anon_sym_qw] = ACTIONS(3316),
    [anon_sym_qx] = ACTIONS(3316),
    [anon_sym_qr] = ACTIONS(3316),
    [anon_sym_m] = ACTIONS(3316),
    [anon_sym_s] = ACTIONS(3316),
    [anon_sym_tr] = ACTIONS(3316),
    [anon_sym_y] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(3316),
    [anon_sym_unless] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(3316),
    [anon_sym_until] = ACTIONS(3316),
    [aux_sym__bareword_token1] = ACTIONS(3316),
    [sym_number] = ACTIONS(3316),
    [sym__apostrophe] = ACTIONS(3314),
    [sym__double_quote] = ACTIONS(3314),
    [sym__backtick] = ACTIONS(3314),
    [sym__search_slash] = ACTIONS(3314),
    [sym__PERLY_HEREDOC] = ACTIONS(3314),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1078] = {
    [sym_heredoc_content] = STATE(1078),
    [sym__identifier] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_LBRACE2] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_package] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_sub] = ACTIONS(3002),
    [anon_sym_method] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3374),
    [anon_sym_my] = ACTIONS(3002),
    [anon_sym_state] = ACTIONS(3002),
    [anon_sym_our] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_defer] = ACTIONS(3002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_elsif] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_DOLLAR] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_AT] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_SLASH_SLASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3002),
    [anon_sym_eq] = ACTIONS(3002),
    [anon_sym_ne] = ACTIONS(3002),
    [anon_sym_cmp] = ACTIONS(3002),
    [anon_sym_lt] = ACTIONS(3002),
    [anon_sym_le] = ACTIONS(3002),
    [anon_sym_ge] = ACTIONS(3002),
    [anon_sym_gt] = ACTIONS(3002),
    [anon_sym_isa] = ACTIONS(3002),
    [anon_sym_TILDE] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(3002),
    [anon_sym_PLUS_PLUS] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3002),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_eval] = ACTIONS(3002),
    [anon_sym_field] = ACTIONS(3002),
    [anon_sym_local] = ACTIONS(3002),
    [anon_sym_require] = ACTIONS(3002),
    [anon_sym_map] = ACTIONS(3002),
    [anon_sym_grep] = ACTIONS(3002),
    [anon_sym_sort] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_undef] = ACTIONS(3002),
    [anon_sym_PERCENT2] = ACTIONS(3002),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3002),
    [anon_sym_use] = ACTIONS(3002),
    [anon_sym_no] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_foreach] = ACTIONS(3002),
    [anon_sym_last] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3002),
    [anon_sym_redo] = ACTIONS(3002),
    [anon_sym_BEGIN] = ACTIONS(3002),
    [anon_sym_INIT] = ACTIONS(3002),
    [anon_sym_CHECK] = ACTIONS(3002),
    [anon_sym_UNITCHECK] = ACTIONS(3002),
    [anon_sym_END] = ACTIONS(3002),
    [anon_sym_ADJUST] = ACTIONS(3002),
    [anon_sym___FILE__] = ACTIONS(3002),
    [anon_sym___LINE__] = ACTIONS(3002),
    [anon_sym___PACKAGE__] = ACTIONS(3002),
    [anon_sym___SUB__] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_fork] = ACTIONS(3002),
    [anon_sym_getppid] = ACTIONS(3002),
    [anon_sym_time] = ACTIONS(3002),
    [anon_sym_times] = ACTIONS(3002),
    [anon_sym_wait] = ACTIONS(3002),
    [anon_sym_wantarray] = ACTIONS(3002),
    [anon_sym_abs] = ACTIONS(3002),
    [anon_sym_alarm] = ACTIONS(3002),
    [anon_sym_chop] = ACTIONS(3002),
    [anon_sym_chdir] = ACTIONS(3002),
    [anon_sym_close] = ACTIONS(3002),
    [anon_sym_closedir] = ACTIONS(3002),
    [anon_sym_caller] = ACTIONS(3002),
    [anon_sym_chomp] = ACTIONS(3002),
    [anon_sym_chr] = ACTIONS(3002),
    [anon_sym_cos] = ACTIONS(3002),
    [anon_sym_chroot] = ACTIONS(3002),
    [anon_sym_defined] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_dbmclose] = ACTIONS(3002),
    [anon_sym_exists] = ACTIONS(3002),
    [anon_sym_exit] = ACTIONS(3002),
    [anon_sym_eof] = ACTIONS(3002),
    [anon_sym_exp] = ACTIONS(3002),
    [anon_sym_each] = ACTIONS(3002),
    [anon_sym_fc] = ACTIONS(3002),
    [anon_sym_fileno] = ACTIONS(3002),
    [anon_sym_gmtime] = ACTIONS(3002),
    [anon_sym_getc] = ACTIONS(3002),
    [anon_sym_getpgrp] = ACTIONS(3002),
    [anon_sym_getprotobyname] = ACTIONS(3002),
    [anon_sym_getpwname] = ACTIONS(3002),
    [anon_sym_getpwuid] = ACTIONS(3002),
    [anon_sym_getpeername] = ACTIONS(3002),
    [anon_sym_getnetbyname] = ACTIONS(3002),
    [anon_sym_getsockname] = ACTIONS(3002),
    [anon_sym_getgrnam] = ACTIONS(3002),
    [anon_sym_getgrgid] = ACTIONS(3002),
    [anon_sym_hex] = ACTIONS(3002),
    [anon_sym_int] = ACTIONS(3002),
    [anon_sym_keys] = ACTIONS(3002),
    [anon_sym_lc] = ACTIONS(3002),
    [anon_sym_lcfirst] = ACTIONS(3002),
    [anon_sym_length] = ACTIONS(3002),
    [anon_sym_localtime] = ACTIONS(3002),
    [anon_sym_log] = ACTIONS(3002),
    [anon_sym_lock] = ACTIONS(3002),
    [anon_sym_lstat] = ACTIONS(3002),
    [anon_sym_oct] = ACTIONS(3002),
    [anon_sym_ord] = ACTIONS(3002),
    [anon_sym_prototype] = ACTIONS(3002),
    [anon_sym_pop] = ACTIONS(3002),
    [anon_sym_pos] = ACTIONS(3002),
    [anon_sym_quotemeta] = ACTIONS(3002),
    [anon_sym_reset] = ACTIONS(3002),
    [anon_sym_rand] = ACTIONS(3002),
    [anon_sym_rmdir] = ACTIONS(3002),
    [anon_sym_readdir] = ACTIONS(3002),
    [anon_sym_readline] = ACTIONS(3002),
    [anon_sym_readpipe] = ACTIONS(3002),
    [anon_sym_rewinddir] = ACTIONS(3002),
    [anon_sym_readlink] = ACTIONS(3002),
    [anon_sym_ref] = ACTIONS(3002),
    [anon_sym_scalar] = ACTIONS(3002),
    [anon_sym_shift] = ACTIONS(3002),
    [anon_sym_sin] = ACTIONS(3002),
    [anon_sym_sleep] = ACTIONS(3002),
    [anon_sym_sqrt] = ACTIONS(3002),
    [anon_sym_srand] = ACTIONS(3002),
    [anon_sym_stat] = ACTIONS(3002),
    [anon_sym_study] = ACTIONS(3002),
    [anon_sym_tell] = ACTIONS(3002),
    [anon_sym_telldir] = ACTIONS(3002),
    [anon_sym_tied] = ACTIONS(3002),
    [anon_sym_uc] = ACTIONS(3002),
    [anon_sym_ucfirst] = ACTIONS(3002),
    [anon_sym_untie] = ACTIONS(3002),
    [anon_sym_umask] = ACTIONS(3002),
    [anon_sym_values] = ACTIONS(3002),
    [anon_sym_write] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3002),
    [anon_sym___END__] = ACTIONS(3002),
    [anon_sym_q] = ACTIONS(3002),
    [anon_sym_qq] = ACTIONS(3002),
    [anon_sym_qw] = ACTIONS(3002),
    [anon_sym_qx] = ACTIONS(3002),
    [anon_sym_qr] = ACTIONS(3002),
    [anon_sym_m] = ACTIONS(3002),
    [anon_sym_s] = ACTIONS(3002),
    [anon_sym_tr] = ACTIONS(3002),
    [anon_sym_y] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [aux_sym__bareword_token1] = ACTIONS(3002),
    [sym_number] = ACTIONS(3002),
    [sym__apostrophe] = ACTIONS(3000),
    [sym__double_quote] = ACTIONS(3000),
    [sym__backtick] = ACTIONS(3000),
    [sym__search_slash] = ACTIONS(3000),
    [sym__PERLY_HEREDOC] = ACTIONS(3000),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1079] = {
    [sym_heredoc_content] = STATE(1079),
    [sym__identifier] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_LBRACE2] = ACTIONS(3109),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(3109),
    [anon_sym_package] = ACTIONS(3109),
    [anon_sym_class] = ACTIONS(3109),
    [anon_sym_sub] = ACTIONS(3109),
    [anon_sym_method] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3109),
    [anon_sym_continue] = ACTIONS(3109),
    [anon_sym_my] = ACTIONS(3109),
    [anon_sym_state] = ACTIONS(3109),
    [anon_sym_our] = ACTIONS(3109),
    [anon_sym_try] = ACTIONS(3109),
    [anon_sym_defer] = ACTIONS(3109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3109),
    [anon_sym_else] = ACTIONS(3109),
    [anon_sym_elsif] = ACTIONS(3109),
    [anon_sym_and] = ACTIONS(3109),
    [anon_sym_or] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_LBRACK] = ACTIONS(3109),
    [anon_sym_AT] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(3109),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_DASH] = ACTIONS(3109),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_eq] = ACTIONS(3109),
    [anon_sym_ne] = ACTIONS(3109),
    [anon_sym_cmp] = ACTIONS(3109),
    [anon_sym_lt] = ACTIONS(3109),
    [anon_sym_le] = ACTIONS(3109),
    [anon_sym_ge] = ACTIONS(3109),
    [anon_sym_gt] = ACTIONS(3109),
    [anon_sym_isa] = ACTIONS(3109),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_PLUS_PLUS] = ACTIONS(3109),
    [anon_sym_DASH_DASH] = ACTIONS(3109),
    [anon_sym_BSLASH] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3109),
    [anon_sym_eval] = ACTIONS(3109),
    [anon_sym_field] = ACTIONS(3109),
    [anon_sym_local] = ACTIONS(3109),
    [anon_sym_require] = ACTIONS(3109),
    [anon_sym_map] = ACTIONS(3109),
    [anon_sym_grep] = ACTIONS(3109),
    [anon_sym_sort] = ACTIONS(3109),
    [anon_sym_goto] = ACTIONS(3109),
    [anon_sym_return] = ACTIONS(3109),
    [anon_sym_undef] = ACTIONS(3109),
    [anon_sym_PERCENT2] = ACTIONS(3109),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3109),
    [anon_sym_no] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3109),
    [anon_sym_foreach] = ACTIONS(3109),
    [anon_sym_last] = ACTIONS(3109),
    [anon_sym_next] = ACTIONS(3109),
    [anon_sym_redo] = ACTIONS(3109),
    [anon_sym_BEGIN] = ACTIONS(3109),
    [anon_sym_INIT] = ACTIONS(3109),
    [anon_sym_CHECK] = ACTIONS(3109),
    [anon_sym_UNITCHECK] = ACTIONS(3109),
    [anon_sym_END] = ACTIONS(3109),
    [anon_sym_ADJUST] = ACTIONS(3109),
    [anon_sym___FILE__] = ACTIONS(3109),
    [anon_sym___LINE__] = ACTIONS(3109),
    [anon_sym___PACKAGE__] = ACTIONS(3109),
    [anon_sym___SUB__] = ACTIONS(3109),
    [anon_sym_break] = ACTIONS(3109),
    [anon_sym_fork] = ACTIONS(3109),
    [anon_sym_getppid] = ACTIONS(3109),
    [anon_sym_time] = ACTIONS(3109),
    [anon_sym_times] = ACTIONS(3109),
    [anon_sym_wait] = ACTIONS(3109),
    [anon_sym_wantarray] = ACTIONS(3109),
    [anon_sym_abs] = ACTIONS(3109),
    [anon_sym_alarm] = ACTIONS(3109),
    [anon_sym_chop] = ACTIONS(3109),
    [anon_sym_chdir] = ACTIONS(3109),
    [anon_sym_close] = ACTIONS(3109),
    [anon_sym_closedir] = ACTIONS(3109),
    [anon_sym_caller] = ACTIONS(3109),
    [anon_sym_chomp] = ACTIONS(3109),
    [anon_sym_chr] = ACTIONS(3109),
    [anon_sym_cos] = ACTIONS(3109),
    [anon_sym_chroot] = ACTIONS(3109),
    [anon_sym_defined] = ACTIONS(3109),
    [anon_sym_delete] = ACTIONS(3109),
    [anon_sym_dbmclose] = ACTIONS(3109),
    [anon_sym_exists] = ACTIONS(3109),
    [anon_sym_exit] = ACTIONS(3109),
    [anon_sym_eof] = ACTIONS(3109),
    [anon_sym_exp] = ACTIONS(3109),
    [anon_sym_each] = ACTIONS(3109),
    [anon_sym_fc] = ACTIONS(3109),
    [anon_sym_fileno] = ACTIONS(3109),
    [anon_sym_gmtime] = ACTIONS(3109),
    [anon_sym_getc] = ACTIONS(3109),
    [anon_sym_getpgrp] = ACTIONS(3109),
    [anon_sym_getprotobyname] = ACTIONS(3109),
    [anon_sym_getpwname] = ACTIONS(3109),
    [anon_sym_getpwuid] = ACTIONS(3109),
    [anon_sym_getpeername] = ACTIONS(3109),
    [anon_sym_getnetbyname] = ACTIONS(3109),
    [anon_sym_getsockname] = ACTIONS(3109),
    [anon_sym_getgrnam] = ACTIONS(3109),
    [anon_sym_getgrgid] = ACTIONS(3109),
    [anon_sym_hex] = ACTIONS(3109),
    [anon_sym_int] = ACTIONS(3109),
    [anon_sym_keys] = ACTIONS(3109),
    [anon_sym_lc] = ACTIONS(3109),
    [anon_sym_lcfirst] = ACTIONS(3109),
    [anon_sym_length] = ACTIONS(3109),
    [anon_sym_localtime] = ACTIONS(3109),
    [anon_sym_log] = ACTIONS(3109),
    [anon_sym_lock] = ACTIONS(3109),
    [anon_sym_lstat] = ACTIONS(3109),
    [anon_sym_oct] = ACTIONS(3109),
    [anon_sym_ord] = ACTIONS(3109),
    [anon_sym_prototype] = ACTIONS(3109),
    [anon_sym_pop] = ACTIONS(3109),
    [anon_sym_pos] = ACTIONS(3109),
    [anon_sym_quotemeta] = ACTIONS(3109),
    [anon_sym_reset] = ACTIONS(3109),
    [anon_sym_rand] = ACTIONS(3109),
    [anon_sym_rmdir] = ACTIONS(3109),
    [anon_sym_readdir] = ACTIONS(3109),
    [anon_sym_readline] = ACTIONS(3109),
    [anon_sym_readpipe] = ACTIONS(3109),
    [anon_sym_rewinddir] = ACTIONS(3109),
    [anon_sym_readlink] = ACTIONS(3109),
    [anon_sym_ref] = ACTIONS(3109),
    [anon_sym_scalar] = ACTIONS(3109),
    [anon_sym_shift] = ACTIONS(3109),
    [anon_sym_sin] = ACTIONS(3109),
    [anon_sym_sleep] = ACTIONS(3109),
    [anon_sym_sqrt] = ACTIONS(3109),
    [anon_sym_srand] = ACTIONS(3109),
    [anon_sym_stat] = ACTIONS(3109),
    [anon_sym_study] = ACTIONS(3109),
    [anon_sym_tell] = ACTIONS(3109),
    [anon_sym_telldir] = ACTIONS(3109),
    [anon_sym_tied] = ACTIONS(3109),
    [anon_sym_uc] = ACTIONS(3109),
    [anon_sym_ucfirst] = ACTIONS(3109),
    [anon_sym_untie] = ACTIONS(3109),
    [anon_sym_umask] = ACTIONS(3109),
    [anon_sym_values] = ACTIONS(3109),
    [anon_sym_write] = ACTIONS(3109),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3109),
    [anon_sym___END__] = ACTIONS(3109),
    [anon_sym_q] = ACTIONS(3109),
    [anon_sym_qq] = ACTIONS(3109),
    [anon_sym_qw] = ACTIONS(3109),
    [anon_sym_qx] = ACTIONS(3109),
    [anon_sym_qr] = ACTIONS(3109),
    [anon_sym_m] = ACTIONS(3109),
    [anon_sym_s] = ACTIONS(3109),
    [anon_sym_tr] = ACTIONS(3109),
    [anon_sym_y] = ACTIONS(3109),
    [anon_sym_if] = ACTIONS(3109),
    [anon_sym_unless] = ACTIONS(3109),
    [anon_sym_while] = ACTIONS(3109),
    [anon_sym_until] = ACTIONS(3109),
    [aux_sym__bareword_token1] = ACTIONS(3109),
    [sym_number] = ACTIONS(3109),
    [sym__apostrophe] = ACTIONS(3107),
    [sym__double_quote] = ACTIONS(3107),
    [sym__backtick] = ACTIONS(3107),
    [sym__search_slash] = ACTIONS(3107),
    [sym__PERLY_HEREDOC] = ACTIONS(3107),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1080] = {
    [sym_heredoc_content] = STATE(1080),
    [sym__identifier] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE2] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_package] = ACTIONS(3129),
    [anon_sym_class] = ACTIONS(3129),
    [anon_sym_sub] = ACTIONS(3129),
    [anon_sym_method] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_continue] = ACTIONS(3129),
    [anon_sym_my] = ACTIONS(3129),
    [anon_sym_state] = ACTIONS(3129),
    [anon_sym_our] = ACTIONS(3129),
    [anon_sym_try] = ACTIONS(3129),
    [anon_sym_defer] = ACTIONS(3129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3129),
    [anon_sym_else] = ACTIONS(3129),
    [anon_sym_elsif] = ACTIONS(3129),
    [anon_sym_and] = ACTIONS(3129),
    [anon_sym_or] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_SLASH_SLASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_eq] = ACTIONS(3129),
    [anon_sym_ne] = ACTIONS(3129),
    [anon_sym_cmp] = ACTIONS(3129),
    [anon_sym_lt] = ACTIONS(3129),
    [anon_sym_le] = ACTIONS(3129),
    [anon_sym_ge] = ACTIONS(3129),
    [anon_sym_gt] = ACTIONS(3129),
    [anon_sym_isa] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_BSLASH] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3129),
    [anon_sym_eval] = ACTIONS(3129),
    [anon_sym_field] = ACTIONS(3129),
    [anon_sym_local] = ACTIONS(3129),
    [anon_sym_require] = ACTIONS(3129),
    [anon_sym_map] = ACTIONS(3129),
    [anon_sym_grep] = ACTIONS(3129),
    [anon_sym_sort] = ACTIONS(3129),
    [anon_sym_goto] = ACTIONS(3129),
    [anon_sym_return] = ACTIONS(3129),
    [anon_sym_undef] = ACTIONS(3129),
    [anon_sym_PERCENT2] = ACTIONS(3129),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3129),
    [anon_sym_no] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3129),
    [anon_sym_foreach] = ACTIONS(3129),
    [anon_sym_last] = ACTIONS(3129),
    [anon_sym_next] = ACTIONS(3129),
    [anon_sym_redo] = ACTIONS(3129),
    [anon_sym_BEGIN] = ACTIONS(3129),
    [anon_sym_INIT] = ACTIONS(3129),
    [anon_sym_CHECK] = ACTIONS(3129),
    [anon_sym_UNITCHECK] = ACTIONS(3129),
    [anon_sym_END] = ACTIONS(3129),
    [anon_sym_ADJUST] = ACTIONS(3129),
    [anon_sym___FILE__] = ACTIONS(3129),
    [anon_sym___LINE__] = ACTIONS(3129),
    [anon_sym___PACKAGE__] = ACTIONS(3129),
    [anon_sym___SUB__] = ACTIONS(3129),
    [anon_sym_break] = ACTIONS(3129),
    [anon_sym_fork] = ACTIONS(3129),
    [anon_sym_getppid] = ACTIONS(3129),
    [anon_sym_time] = ACTIONS(3129),
    [anon_sym_times] = ACTIONS(3129),
    [anon_sym_wait] = ACTIONS(3129),
    [anon_sym_wantarray] = ACTIONS(3129),
    [anon_sym_abs] = ACTIONS(3129),
    [anon_sym_alarm] = ACTIONS(3129),
    [anon_sym_chop] = ACTIONS(3129),
    [anon_sym_chdir] = ACTIONS(3129),
    [anon_sym_close] = ACTIONS(3129),
    [anon_sym_closedir] = ACTIONS(3129),
    [anon_sym_caller] = ACTIONS(3129),
    [anon_sym_chomp] = ACTIONS(3129),
    [anon_sym_chr] = ACTIONS(3129),
    [anon_sym_cos] = ACTIONS(3129),
    [anon_sym_chroot] = ACTIONS(3129),
    [anon_sym_defined] = ACTIONS(3129),
    [anon_sym_delete] = ACTIONS(3129),
    [anon_sym_dbmclose] = ACTIONS(3129),
    [anon_sym_exists] = ACTIONS(3129),
    [anon_sym_exit] = ACTIONS(3129),
    [anon_sym_eof] = ACTIONS(3129),
    [anon_sym_exp] = ACTIONS(3129),
    [anon_sym_each] = ACTIONS(3129),
    [anon_sym_fc] = ACTIONS(3129),
    [anon_sym_fileno] = ACTIONS(3129),
    [anon_sym_gmtime] = ACTIONS(3129),
    [anon_sym_getc] = ACTIONS(3129),
    [anon_sym_getpgrp] = ACTIONS(3129),
    [anon_sym_getprotobyname] = ACTIONS(3129),
    [anon_sym_getpwname] = ACTIONS(3129),
    [anon_sym_getpwuid] = ACTIONS(3129),
    [anon_sym_getpeername] = ACTIONS(3129),
    [anon_sym_getnetbyname] = ACTIONS(3129),
    [anon_sym_getsockname] = ACTIONS(3129),
    [anon_sym_getgrnam] = ACTIONS(3129),
    [anon_sym_getgrgid] = ACTIONS(3129),
    [anon_sym_hex] = ACTIONS(3129),
    [anon_sym_int] = ACTIONS(3129),
    [anon_sym_keys] = ACTIONS(3129),
    [anon_sym_lc] = ACTIONS(3129),
    [anon_sym_lcfirst] = ACTIONS(3129),
    [anon_sym_length] = ACTIONS(3129),
    [anon_sym_localtime] = ACTIONS(3129),
    [anon_sym_log] = ACTIONS(3129),
    [anon_sym_lock] = ACTIONS(3129),
    [anon_sym_lstat] = ACTIONS(3129),
    [anon_sym_oct] = ACTIONS(3129),
    [anon_sym_ord] = ACTIONS(3129),
    [anon_sym_prototype] = ACTIONS(3129),
    [anon_sym_pop] = ACTIONS(3129),
    [anon_sym_pos] = ACTIONS(3129),
    [anon_sym_quotemeta] = ACTIONS(3129),
    [anon_sym_reset] = ACTIONS(3129),
    [anon_sym_rand] = ACTIONS(3129),
    [anon_sym_rmdir] = ACTIONS(3129),
    [anon_sym_readdir] = ACTIONS(3129),
    [anon_sym_readline] = ACTIONS(3129),
    [anon_sym_readpipe] = ACTIONS(3129),
    [anon_sym_rewinddir] = ACTIONS(3129),
    [anon_sym_readlink] = ACTIONS(3129),
    [anon_sym_ref] = ACTIONS(3129),
    [anon_sym_scalar] = ACTIONS(3129),
    [anon_sym_shift] = ACTIONS(3129),
    [anon_sym_sin] = ACTIONS(3129),
    [anon_sym_sleep] = ACTIONS(3129),
    [anon_sym_sqrt] = ACTIONS(3129),
    [anon_sym_srand] = ACTIONS(3129),
    [anon_sym_stat] = ACTIONS(3129),
    [anon_sym_study] = ACTIONS(3129),
    [anon_sym_tell] = ACTIONS(3129),
    [anon_sym_telldir] = ACTIONS(3129),
    [anon_sym_tied] = ACTIONS(3129),
    [anon_sym_uc] = ACTIONS(3129),
    [anon_sym_ucfirst] = ACTIONS(3129),
    [anon_sym_untie] = ACTIONS(3129),
    [anon_sym_umask] = ACTIONS(3129),
    [anon_sym_values] = ACTIONS(3129),
    [anon_sym_write] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3129),
    [anon_sym___END__] = ACTIONS(3129),
    [anon_sym_q] = ACTIONS(3129),
    [anon_sym_qq] = ACTIONS(3129),
    [anon_sym_qw] = ACTIONS(3129),
    [anon_sym_qx] = ACTIONS(3129),
    [anon_sym_qr] = ACTIONS(3129),
    [anon_sym_m] = ACTIONS(3129),
    [anon_sym_s] = ACTIONS(3129),
    [anon_sym_tr] = ACTIONS(3129),
    [anon_sym_y] = ACTIONS(3129),
    [anon_sym_if] = ACTIONS(3129),
    [anon_sym_unless] = ACTIONS(3129),
    [anon_sym_while] = ACTIONS(3129),
    [anon_sym_until] = ACTIONS(3129),
    [aux_sym__bareword_token1] = ACTIONS(3129),
    [sym_number] = ACTIONS(3129),
    [sym__apostrophe] = ACTIONS(3127),
    [sym__double_quote] = ACTIONS(3127),
    [sym__backtick] = ACTIONS(3127),
    [sym__search_slash] = ACTIONS(3127),
    [sym__PERLY_HEREDOC] = ACTIONS(3127),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1081] = {
    [sym_heredoc_content] = STATE(1081),
    [sym__identifier] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_LBRACE2] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym_package] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_sub] = ACTIONS(3140),
    [anon_sym_method] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3140),
    [anon_sym_continue] = ACTIONS(3140),
    [anon_sym_my] = ACTIONS(3140),
    [anon_sym_state] = ACTIONS(3140),
    [anon_sym_our] = ACTIONS(3140),
    [anon_sym_try] = ACTIONS(3140),
    [anon_sym_defer] = ACTIONS(3140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3140),
    [anon_sym_else] = ACTIONS(3140),
    [anon_sym_elsif] = ACTIONS(3140),
    [anon_sym_and] = ACTIONS(3140),
    [anon_sym_or] = ACTIONS(3140),
    [anon_sym_DOLLAR] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3140),
    [anon_sym_AT] = ACTIONS(3140),
    [anon_sym_LT] = ACTIONS(3140),
    [anon_sym_LT_LT] = ACTIONS(3140),
    [anon_sym_SLASH_SLASH] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3140),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_eq] = ACTIONS(3140),
    [anon_sym_ne] = ACTIONS(3140),
    [anon_sym_cmp] = ACTIONS(3140),
    [anon_sym_lt] = ACTIONS(3140),
    [anon_sym_le] = ACTIONS(3140),
    [anon_sym_ge] = ACTIONS(3140),
    [anon_sym_gt] = ACTIONS(3140),
    [anon_sym_isa] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_BSLASH] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3140),
    [anon_sym_eval] = ACTIONS(3140),
    [anon_sym_field] = ACTIONS(3140),
    [anon_sym_local] = ACTIONS(3140),
    [anon_sym_require] = ACTIONS(3140),
    [anon_sym_map] = ACTIONS(3140),
    [anon_sym_grep] = ACTIONS(3140),
    [anon_sym_sort] = ACTIONS(3140),
    [anon_sym_goto] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_undef] = ACTIONS(3140),
    [anon_sym_PERCENT2] = ACTIONS(3140),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3140),
    [anon_sym_use] = ACTIONS(3140),
    [anon_sym_no] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_foreach] = ACTIONS(3140),
    [anon_sym_last] = ACTIONS(3140),
    [anon_sym_next] = ACTIONS(3140),
    [anon_sym_redo] = ACTIONS(3140),
    [anon_sym_BEGIN] = ACTIONS(3140),
    [anon_sym_INIT] = ACTIONS(3140),
    [anon_sym_CHECK] = ACTIONS(3140),
    [anon_sym_UNITCHECK] = ACTIONS(3140),
    [anon_sym_END] = ACTIONS(3140),
    [anon_sym_ADJUST] = ACTIONS(3140),
    [anon_sym___FILE__] = ACTIONS(3140),
    [anon_sym___LINE__] = ACTIONS(3140),
    [anon_sym___PACKAGE__] = ACTIONS(3140),
    [anon_sym___SUB__] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_fork] = ACTIONS(3140),
    [anon_sym_getppid] = ACTIONS(3140),
    [anon_sym_time] = ACTIONS(3140),
    [anon_sym_times] = ACTIONS(3140),
    [anon_sym_wait] = ACTIONS(3140),
    [anon_sym_wantarray] = ACTIONS(3140),
    [anon_sym_abs] = ACTIONS(3140),
    [anon_sym_alarm] = ACTIONS(3140),
    [anon_sym_chop] = ACTIONS(3140),
    [anon_sym_chdir] = ACTIONS(3140),
    [anon_sym_close] = ACTIONS(3140),
    [anon_sym_closedir] = ACTIONS(3140),
    [anon_sym_caller] = ACTIONS(3140),
    [anon_sym_chomp] = ACTIONS(3140),
    [anon_sym_chr] = ACTIONS(3140),
    [anon_sym_cos] = ACTIONS(3140),
    [anon_sym_chroot] = ACTIONS(3140),
    [anon_sym_defined] = ACTIONS(3140),
    [anon_sym_delete] = ACTIONS(3140),
    [anon_sym_dbmclose] = ACTIONS(3140),
    [anon_sym_exists] = ACTIONS(3140),
    [anon_sym_exit] = ACTIONS(3140),
    [anon_sym_eof] = ACTIONS(3140),
    [anon_sym_exp] = ACTIONS(3140),
    [anon_sym_each] = ACTIONS(3140),
    [anon_sym_fc] = ACTIONS(3140),
    [anon_sym_fileno] = ACTIONS(3140),
    [anon_sym_gmtime] = ACTIONS(3140),
    [anon_sym_getc] = ACTIONS(3140),
    [anon_sym_getpgrp] = ACTIONS(3140),
    [anon_sym_getprotobyname] = ACTIONS(3140),
    [anon_sym_getpwname] = ACTIONS(3140),
    [anon_sym_getpwuid] = ACTIONS(3140),
    [anon_sym_getpeername] = ACTIONS(3140),
    [anon_sym_getnetbyname] = ACTIONS(3140),
    [anon_sym_getsockname] = ACTIONS(3140),
    [anon_sym_getgrnam] = ACTIONS(3140),
    [anon_sym_getgrgid] = ACTIONS(3140),
    [anon_sym_hex] = ACTIONS(3140),
    [anon_sym_int] = ACTIONS(3140),
    [anon_sym_keys] = ACTIONS(3140),
    [anon_sym_lc] = ACTIONS(3140),
    [anon_sym_lcfirst] = ACTIONS(3140),
    [anon_sym_length] = ACTIONS(3140),
    [anon_sym_localtime] = ACTIONS(3140),
    [anon_sym_log] = ACTIONS(3140),
    [anon_sym_lock] = ACTIONS(3140),
    [anon_sym_lstat] = ACTIONS(3140),
    [anon_sym_oct] = ACTIONS(3140),
    [anon_sym_ord] = ACTIONS(3140),
    [anon_sym_prototype] = ACTIONS(3140),
    [anon_sym_pop] = ACTIONS(3140),
    [anon_sym_pos] = ACTIONS(3140),
    [anon_sym_quotemeta] = ACTIONS(3140),
    [anon_sym_reset] = ACTIONS(3140),
    [anon_sym_rand] = ACTIONS(3140),
    [anon_sym_rmdir] = ACTIONS(3140),
    [anon_sym_readdir] = ACTIONS(3140),
    [anon_sym_readline] = ACTIONS(3140),
    [anon_sym_readpipe] = ACTIONS(3140),
    [anon_sym_rewinddir] = ACTIONS(3140),
    [anon_sym_readlink] = ACTIONS(3140),
    [anon_sym_ref] = ACTIONS(3140),
    [anon_sym_scalar] = ACTIONS(3140),
    [anon_sym_shift] = ACTIONS(3140),
    [anon_sym_sin] = ACTIONS(3140),
    [anon_sym_sleep] = ACTIONS(3140),
    [anon_sym_sqrt] = ACTIONS(3140),
    [anon_sym_srand] = ACTIONS(3140),
    [anon_sym_stat] = ACTIONS(3140),
    [anon_sym_study] = ACTIONS(3140),
    [anon_sym_tell] = ACTIONS(3140),
    [anon_sym_telldir] = ACTIONS(3140),
    [anon_sym_tied] = ACTIONS(3140),
    [anon_sym_uc] = ACTIONS(3140),
    [anon_sym_ucfirst] = ACTIONS(3140),
    [anon_sym_untie] = ACTIONS(3140),
    [anon_sym_umask] = ACTIONS(3140),
    [anon_sym_values] = ACTIONS(3140),
    [anon_sym_write] = ACTIONS(3140),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3140),
    [anon_sym___END__] = ACTIONS(3140),
    [anon_sym_q] = ACTIONS(3140),
    [anon_sym_qq] = ACTIONS(3140),
    [anon_sym_qw] = ACTIONS(3140),
    [anon_sym_qx] = ACTIONS(3140),
    [anon_sym_qr] = ACTIONS(3140),
    [anon_sym_m] = ACTIONS(3140),
    [anon_sym_s] = ACTIONS(3140),
    [anon_sym_tr] = ACTIONS(3140),
    [anon_sym_y] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_unless] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_until] = ACTIONS(3140),
    [aux_sym__bareword_token1] = ACTIONS(3140),
    [sym_number] = ACTIONS(3140),
    [sym__apostrophe] = ACTIONS(3138),
    [sym__double_quote] = ACTIONS(3138),
    [sym__backtick] = ACTIONS(3138),
    [sym__search_slash] = ACTIONS(3138),
    [sym__PERLY_HEREDOC] = ACTIONS(3138),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1082] = {
    [sym_heredoc_content] = STATE(1082),
    [sym__identifier] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LBRACE2] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_package] = ACTIONS(3304),
    [anon_sym_class] = ACTIONS(3304),
    [anon_sym_sub] = ACTIONS(3304),
    [anon_sym_method] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_my] = ACTIONS(3304),
    [anon_sym_state] = ACTIONS(3304),
    [anon_sym_our] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_defer] = ACTIONS(3304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3304),
    [anon_sym_else] = ACTIONS(3304),
    [anon_sym_elsif] = ACTIONS(3304),
    [anon_sym_and] = ACTIONS(3304),
    [anon_sym_or] = ACTIONS(3304),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_AT] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_eq] = ACTIONS(3304),
    [anon_sym_ne] = ACTIONS(3304),
    [anon_sym_cmp] = ACTIONS(3304),
    [anon_sym_lt] = ACTIONS(3304),
    [anon_sym_le] = ACTIONS(3304),
    [anon_sym_ge] = ACTIONS(3304),
    [anon_sym_gt] = ACTIONS(3304),
    [anon_sym_isa] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_BSLASH] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_eval] = ACTIONS(3304),
    [anon_sym_field] = ACTIONS(3304),
    [anon_sym_local] = ACTIONS(3304),
    [anon_sym_require] = ACTIONS(3304),
    [anon_sym_map] = ACTIONS(3304),
    [anon_sym_grep] = ACTIONS(3304),
    [anon_sym_sort] = ACTIONS(3304),
    [anon_sym_goto] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_undef] = ACTIONS(3304),
    [anon_sym_PERCENT2] = ACTIONS(3304),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_no] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_foreach] = ACTIONS(3304),
    [anon_sym_last] = ACTIONS(3304),
    [anon_sym_next] = ACTIONS(3304),
    [anon_sym_redo] = ACTIONS(3304),
    [anon_sym_BEGIN] = ACTIONS(3304),
    [anon_sym_INIT] = ACTIONS(3304),
    [anon_sym_CHECK] = ACTIONS(3304),
    [anon_sym_UNITCHECK] = ACTIONS(3304),
    [anon_sym_END] = ACTIONS(3304),
    [anon_sym_ADJUST] = ACTIONS(3304),
    [anon_sym___FILE__] = ACTIONS(3304),
    [anon_sym___LINE__] = ACTIONS(3304),
    [anon_sym___PACKAGE__] = ACTIONS(3304),
    [anon_sym___SUB__] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_fork] = ACTIONS(3304),
    [anon_sym_getppid] = ACTIONS(3304),
    [anon_sym_time] = ACTIONS(3304),
    [anon_sym_times] = ACTIONS(3304),
    [anon_sym_wait] = ACTIONS(3304),
    [anon_sym_wantarray] = ACTIONS(3304),
    [anon_sym_abs] = ACTIONS(3304),
    [anon_sym_alarm] = ACTIONS(3304),
    [anon_sym_chop] = ACTIONS(3304),
    [anon_sym_chdir] = ACTIONS(3304),
    [anon_sym_close] = ACTIONS(3304),
    [anon_sym_closedir] = ACTIONS(3304),
    [anon_sym_caller] = ACTIONS(3304),
    [anon_sym_chomp] = ACTIONS(3304),
    [anon_sym_chr] = ACTIONS(3304),
    [anon_sym_cos] = ACTIONS(3304),
    [anon_sym_chroot] = ACTIONS(3304),
    [anon_sym_defined] = ACTIONS(3304),
    [anon_sym_delete] = ACTIONS(3304),
    [anon_sym_dbmclose] = ACTIONS(3304),
    [anon_sym_exists] = ACTIONS(3304),
    [anon_sym_exit] = ACTIONS(3304),
    [anon_sym_eof] = ACTIONS(3304),
    [anon_sym_exp] = ACTIONS(3304),
    [anon_sym_each] = ACTIONS(3304),
    [anon_sym_fc] = ACTIONS(3304),
    [anon_sym_fileno] = ACTIONS(3304),
    [anon_sym_gmtime] = ACTIONS(3304),
    [anon_sym_getc] = ACTIONS(3304),
    [anon_sym_getpgrp] = ACTIONS(3304),
    [anon_sym_getprotobyname] = ACTIONS(3304),
    [anon_sym_getpwname] = ACTIONS(3304),
    [anon_sym_getpwuid] = ACTIONS(3304),
    [anon_sym_getpeername] = ACTIONS(3304),
    [anon_sym_getnetbyname] = ACTIONS(3304),
    [anon_sym_getsockname] = ACTIONS(3304),
    [anon_sym_getgrnam] = ACTIONS(3304),
    [anon_sym_getgrgid] = ACTIONS(3304),
    [anon_sym_hex] = ACTIONS(3304),
    [anon_sym_int] = ACTIONS(3304),
    [anon_sym_keys] = ACTIONS(3304),
    [anon_sym_lc] = ACTIONS(3304),
    [anon_sym_lcfirst] = ACTIONS(3304),
    [anon_sym_length] = ACTIONS(3304),
    [anon_sym_localtime] = ACTIONS(3304),
    [anon_sym_log] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_lstat] = ACTIONS(3304),
    [anon_sym_oct] = ACTIONS(3304),
    [anon_sym_ord] = ACTIONS(3304),
    [anon_sym_prototype] = ACTIONS(3304),
    [anon_sym_pop] = ACTIONS(3304),
    [anon_sym_pos] = ACTIONS(3304),
    [anon_sym_quotemeta] = ACTIONS(3304),
    [anon_sym_reset] = ACTIONS(3304),
    [anon_sym_rand] = ACTIONS(3304),
    [anon_sym_rmdir] = ACTIONS(3304),
    [anon_sym_readdir] = ACTIONS(3304),
    [anon_sym_readline] = ACTIONS(3304),
    [anon_sym_readpipe] = ACTIONS(3304),
    [anon_sym_rewinddir] = ACTIONS(3304),
    [anon_sym_readlink] = ACTIONS(3304),
    [anon_sym_ref] = ACTIONS(3304),
    [anon_sym_scalar] = ACTIONS(3304),
    [anon_sym_shift] = ACTIONS(3304),
    [anon_sym_sin] = ACTIONS(3304),
    [anon_sym_sleep] = ACTIONS(3304),
    [anon_sym_sqrt] = ACTIONS(3304),
    [anon_sym_srand] = ACTIONS(3304),
    [anon_sym_stat] = ACTIONS(3304),
    [anon_sym_study] = ACTIONS(3304),
    [anon_sym_tell] = ACTIONS(3304),
    [anon_sym_telldir] = ACTIONS(3304),
    [anon_sym_tied] = ACTIONS(3304),
    [anon_sym_uc] = ACTIONS(3304),
    [anon_sym_ucfirst] = ACTIONS(3304),
    [anon_sym_untie] = ACTIONS(3304),
    [anon_sym_umask] = ACTIONS(3304),
    [anon_sym_values] = ACTIONS(3304),
    [anon_sym_write] = ACTIONS(3304),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3304),
    [anon_sym___END__] = ACTIONS(3304),
    [anon_sym_q] = ACTIONS(3304),
    [anon_sym_qq] = ACTIONS(3304),
    [anon_sym_qw] = ACTIONS(3304),
    [anon_sym_qx] = ACTIONS(3304),
    [anon_sym_qr] = ACTIONS(3304),
    [anon_sym_m] = ACTIONS(3304),
    [anon_sym_s] = ACTIONS(3304),
    [anon_sym_tr] = ACTIONS(3304),
    [anon_sym_y] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_unless] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_until] = ACTIONS(3304),
    [aux_sym__bareword_token1] = ACTIONS(3304),
    [sym_number] = ACTIONS(3304),
    [sym__apostrophe] = ACTIONS(3302),
    [sym__double_quote] = ACTIONS(3302),
    [sym__backtick] = ACTIONS(3302),
    [sym__search_slash] = ACTIONS(3302),
    [sym__PERLY_HEREDOC] = ACTIONS(3302),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1083] = {
    [sym_heredoc_content] = STATE(1083),
    [sym__identifier] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_LBRACE2] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym_package] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_sub] = ACTIONS(3144),
    [anon_sym_method] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_my] = ACTIONS(3144),
    [anon_sym_state] = ACTIONS(3144),
    [anon_sym_our] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_defer] = ACTIONS(3144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_elsif] = ACTIONS(3144),
    [anon_sym_and] = ACTIONS(3144),
    [anon_sym_or] = ACTIONS(3144),
    [anon_sym_DOLLAR] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_AT] = ACTIONS(3144),
    [anon_sym_LT] = ACTIONS(3144),
    [anon_sym_LT_LT] = ACTIONS(3144),
    [anon_sym_SLASH_SLASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_eq] = ACTIONS(3144),
    [anon_sym_ne] = ACTIONS(3144),
    [anon_sym_cmp] = ACTIONS(3144),
    [anon_sym_lt] = ACTIONS(3144),
    [anon_sym_le] = ACTIONS(3144),
    [anon_sym_ge] = ACTIONS(3144),
    [anon_sym_gt] = ACTIONS(3144),
    [anon_sym_isa] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [anon_sym_BSLASH] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_eval] = ACTIONS(3144),
    [anon_sym_field] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3144),
    [anon_sym_require] = ACTIONS(3144),
    [anon_sym_map] = ACTIONS(3144),
    [anon_sym_grep] = ACTIONS(3144),
    [anon_sym_sort] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_undef] = ACTIONS(3144),
    [anon_sym_PERCENT2] = ACTIONS(3144),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3144),
    [anon_sym_use] = ACTIONS(3144),
    [anon_sym_no] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_foreach] = ACTIONS(3144),
    [anon_sym_last] = ACTIONS(3144),
    [anon_sym_next] = ACTIONS(3144),
    [anon_sym_redo] = ACTIONS(3144),
    [anon_sym_BEGIN] = ACTIONS(3144),
    [anon_sym_INIT] = ACTIONS(3144),
    [anon_sym_CHECK] = ACTIONS(3144),
    [anon_sym_UNITCHECK] = ACTIONS(3144),
    [anon_sym_END] = ACTIONS(3144),
    [anon_sym_ADJUST] = ACTIONS(3144),
    [anon_sym___FILE__] = ACTIONS(3144),
    [anon_sym___LINE__] = ACTIONS(3144),
    [anon_sym___PACKAGE__] = ACTIONS(3144),
    [anon_sym___SUB__] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_fork] = ACTIONS(3144),
    [anon_sym_getppid] = ACTIONS(3144),
    [anon_sym_time] = ACTIONS(3144),
    [anon_sym_times] = ACTIONS(3144),
    [anon_sym_wait] = ACTIONS(3144),
    [anon_sym_wantarray] = ACTIONS(3144),
    [anon_sym_abs] = ACTIONS(3144),
    [anon_sym_alarm] = ACTIONS(3144),
    [anon_sym_chop] = ACTIONS(3144),
    [anon_sym_chdir] = ACTIONS(3144),
    [anon_sym_close] = ACTIONS(3144),
    [anon_sym_closedir] = ACTIONS(3144),
    [anon_sym_caller] = ACTIONS(3144),
    [anon_sym_chomp] = ACTIONS(3144),
    [anon_sym_chr] = ACTIONS(3144),
    [anon_sym_cos] = ACTIONS(3144),
    [anon_sym_chroot] = ACTIONS(3144),
    [anon_sym_defined] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_dbmclose] = ACTIONS(3144),
    [anon_sym_exists] = ACTIONS(3144),
    [anon_sym_exit] = ACTIONS(3144),
    [anon_sym_eof] = ACTIONS(3144),
    [anon_sym_exp] = ACTIONS(3144),
    [anon_sym_each] = ACTIONS(3144),
    [anon_sym_fc] = ACTIONS(3144),
    [anon_sym_fileno] = ACTIONS(3144),
    [anon_sym_gmtime] = ACTIONS(3144),
    [anon_sym_getc] = ACTIONS(3144),
    [anon_sym_getpgrp] = ACTIONS(3144),
    [anon_sym_getprotobyname] = ACTIONS(3144),
    [anon_sym_getpwname] = ACTIONS(3144),
    [anon_sym_getpwuid] = ACTIONS(3144),
    [anon_sym_getpeername] = ACTIONS(3144),
    [anon_sym_getnetbyname] = ACTIONS(3144),
    [anon_sym_getsockname] = ACTIONS(3144),
    [anon_sym_getgrnam] = ACTIONS(3144),
    [anon_sym_getgrgid] = ACTIONS(3144),
    [anon_sym_hex] = ACTIONS(3144),
    [anon_sym_int] = ACTIONS(3144),
    [anon_sym_keys] = ACTIONS(3144),
    [anon_sym_lc] = ACTIONS(3144),
    [anon_sym_lcfirst] = ACTIONS(3144),
    [anon_sym_length] = ACTIONS(3144),
    [anon_sym_localtime] = ACTIONS(3144),
    [anon_sym_log] = ACTIONS(3144),
    [anon_sym_lock] = ACTIONS(3144),
    [anon_sym_lstat] = ACTIONS(3144),
    [anon_sym_oct] = ACTIONS(3144),
    [anon_sym_ord] = ACTIONS(3144),
    [anon_sym_prototype] = ACTIONS(3144),
    [anon_sym_pop] = ACTIONS(3144),
    [anon_sym_pos] = ACTIONS(3144),
    [anon_sym_quotemeta] = ACTIONS(3144),
    [anon_sym_reset] = ACTIONS(3144),
    [anon_sym_rand] = ACTIONS(3144),
    [anon_sym_rmdir] = ACTIONS(3144),
    [anon_sym_readdir] = ACTIONS(3144),
    [anon_sym_readline] = ACTIONS(3144),
    [anon_sym_readpipe] = ACTIONS(3144),
    [anon_sym_rewinddir] = ACTIONS(3144),
    [anon_sym_readlink] = ACTIONS(3144),
    [anon_sym_ref] = ACTIONS(3144),
    [anon_sym_scalar] = ACTIONS(3144),
    [anon_sym_shift] = ACTIONS(3144),
    [anon_sym_sin] = ACTIONS(3144),
    [anon_sym_sleep] = ACTIONS(3144),
    [anon_sym_sqrt] = ACTIONS(3144),
    [anon_sym_srand] = ACTIONS(3144),
    [anon_sym_stat] = ACTIONS(3144),
    [anon_sym_study] = ACTIONS(3144),
    [anon_sym_tell] = ACTIONS(3144),
    [anon_sym_telldir] = ACTIONS(3144),
    [anon_sym_tied] = ACTIONS(3144),
    [anon_sym_uc] = ACTIONS(3144),
    [anon_sym_ucfirst] = ACTIONS(3144),
    [anon_sym_untie] = ACTIONS(3144),
    [anon_sym_umask] = ACTIONS(3144),
    [anon_sym_values] = ACTIONS(3144),
    [anon_sym_write] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3144),
    [anon_sym___END__] = ACTIONS(3144),
    [anon_sym_q] = ACTIONS(3144),
    [anon_sym_qq] = ACTIONS(3144),
    [anon_sym_qw] = ACTIONS(3144),
    [anon_sym_qx] = ACTIONS(3144),
    [anon_sym_qr] = ACTIONS(3144),
    [anon_sym_m] = ACTIONS(3144),
    [anon_sym_s] = ACTIONS(3144),
    [anon_sym_tr] = ACTIONS(3144),
    [anon_sym_y] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_unless] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_until] = ACTIONS(3144),
    [aux_sym__bareword_token1] = ACTIONS(3144),
    [sym_number] = ACTIONS(3144),
    [sym__apostrophe] = ACTIONS(3142),
    [sym__double_quote] = ACTIONS(3142),
    [sym__backtick] = ACTIONS(3142),
    [sym__search_slash] = ACTIONS(3142),
    [sym__PERLY_HEREDOC] = ACTIONS(3142),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1084] = {
    [sym_heredoc_content] = STATE(1084),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_LBRACE2] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_package] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_defer] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1085] = {
    [sym_heredoc_content] = STATE(1085),
    [sym__identifier] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_LBRACE2] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym_package] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_sub] = ACTIONS(3040),
    [anon_sym_method] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_my] = ACTIONS(3040),
    [anon_sym_state] = ACTIONS(3040),
    [anon_sym_our] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_defer] = ACTIONS(3040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_else] = ACTIONS(3040),
    [anon_sym_elsif] = ACTIONS(3040),
    [anon_sym_and] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_AT] = ACTIONS(3040),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3040),
    [anon_sym_SLASH_SLASH] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_eq] = ACTIONS(3040),
    [anon_sym_ne] = ACTIONS(3040),
    [anon_sym_cmp] = ACTIONS(3040),
    [anon_sym_lt] = ACTIONS(3040),
    [anon_sym_le] = ACTIONS(3040),
    [anon_sym_ge] = ACTIONS(3040),
    [anon_sym_gt] = ACTIONS(3040),
    [anon_sym_isa] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_BSLASH] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_eval] = ACTIONS(3040),
    [anon_sym_field] = ACTIONS(3040),
    [anon_sym_local] = ACTIONS(3040),
    [anon_sym_require] = ACTIONS(3040),
    [anon_sym_map] = ACTIONS(3040),
    [anon_sym_grep] = ACTIONS(3040),
    [anon_sym_sort] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_undef] = ACTIONS(3040),
    [anon_sym_PERCENT2] = ACTIONS(3040),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3040),
    [anon_sym_use] = ACTIONS(3040),
    [anon_sym_no] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_foreach] = ACTIONS(3040),
    [anon_sym_last] = ACTIONS(3040),
    [anon_sym_next] = ACTIONS(3040),
    [anon_sym_redo] = ACTIONS(3040),
    [anon_sym_BEGIN] = ACTIONS(3040),
    [anon_sym_INIT] = ACTIONS(3040),
    [anon_sym_CHECK] = ACTIONS(3040),
    [anon_sym_UNITCHECK] = ACTIONS(3040),
    [anon_sym_END] = ACTIONS(3040),
    [anon_sym_ADJUST] = ACTIONS(3040),
    [anon_sym___FILE__] = ACTIONS(3040),
    [anon_sym___LINE__] = ACTIONS(3040),
    [anon_sym___PACKAGE__] = ACTIONS(3040),
    [anon_sym___SUB__] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_fork] = ACTIONS(3040),
    [anon_sym_getppid] = ACTIONS(3040),
    [anon_sym_time] = ACTIONS(3040),
    [anon_sym_times] = ACTIONS(3040),
    [anon_sym_wait] = ACTIONS(3040),
    [anon_sym_wantarray] = ACTIONS(3040),
    [anon_sym_abs] = ACTIONS(3040),
    [anon_sym_alarm] = ACTIONS(3040),
    [anon_sym_chop] = ACTIONS(3040),
    [anon_sym_chdir] = ACTIONS(3040),
    [anon_sym_close] = ACTIONS(3040),
    [anon_sym_closedir] = ACTIONS(3040),
    [anon_sym_caller] = ACTIONS(3040),
    [anon_sym_chomp] = ACTIONS(3040),
    [anon_sym_chr] = ACTIONS(3040),
    [anon_sym_cos] = ACTIONS(3040),
    [anon_sym_chroot] = ACTIONS(3040),
    [anon_sym_defined] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3040),
    [anon_sym_dbmclose] = ACTIONS(3040),
    [anon_sym_exists] = ACTIONS(3040),
    [anon_sym_exit] = ACTIONS(3040),
    [anon_sym_eof] = ACTIONS(3040),
    [anon_sym_exp] = ACTIONS(3040),
    [anon_sym_each] = ACTIONS(3040),
    [anon_sym_fc] = ACTIONS(3040),
    [anon_sym_fileno] = ACTIONS(3040),
    [anon_sym_gmtime] = ACTIONS(3040),
    [anon_sym_getc] = ACTIONS(3040),
    [anon_sym_getpgrp] = ACTIONS(3040),
    [anon_sym_getprotobyname] = ACTIONS(3040),
    [anon_sym_getpwname] = ACTIONS(3040),
    [anon_sym_getpwuid] = ACTIONS(3040),
    [anon_sym_getpeername] = ACTIONS(3040),
    [anon_sym_getnetbyname] = ACTIONS(3040),
    [anon_sym_getsockname] = ACTIONS(3040),
    [anon_sym_getgrnam] = ACTIONS(3040),
    [anon_sym_getgrgid] = ACTIONS(3040),
    [anon_sym_hex] = ACTIONS(3040),
    [anon_sym_int] = ACTIONS(3040),
    [anon_sym_keys] = ACTIONS(3040),
    [anon_sym_lc] = ACTIONS(3040),
    [anon_sym_lcfirst] = ACTIONS(3040),
    [anon_sym_length] = ACTIONS(3040),
    [anon_sym_localtime] = ACTIONS(3040),
    [anon_sym_log] = ACTIONS(3040),
    [anon_sym_lock] = ACTIONS(3040),
    [anon_sym_lstat] = ACTIONS(3040),
    [anon_sym_oct] = ACTIONS(3040),
    [anon_sym_ord] = ACTIONS(3040),
    [anon_sym_prototype] = ACTIONS(3040),
    [anon_sym_pop] = ACTIONS(3040),
    [anon_sym_pos] = ACTIONS(3040),
    [anon_sym_quotemeta] = ACTIONS(3040),
    [anon_sym_reset] = ACTIONS(3040),
    [anon_sym_rand] = ACTIONS(3040),
    [anon_sym_rmdir] = ACTIONS(3040),
    [anon_sym_readdir] = ACTIONS(3040),
    [anon_sym_readline] = ACTIONS(3040),
    [anon_sym_readpipe] = ACTIONS(3040),
    [anon_sym_rewinddir] = ACTIONS(3040),
    [anon_sym_readlink] = ACTIONS(3040),
    [anon_sym_ref] = ACTIONS(3040),
    [anon_sym_scalar] = ACTIONS(3040),
    [anon_sym_shift] = ACTIONS(3040),
    [anon_sym_sin] = ACTIONS(3040),
    [anon_sym_sleep] = ACTIONS(3040),
    [anon_sym_sqrt] = ACTIONS(3040),
    [anon_sym_srand] = ACTIONS(3040),
    [anon_sym_stat] = ACTIONS(3040),
    [anon_sym_study] = ACTIONS(3040),
    [anon_sym_tell] = ACTIONS(3040),
    [anon_sym_telldir] = ACTIONS(3040),
    [anon_sym_tied] = ACTIONS(3040),
    [anon_sym_uc] = ACTIONS(3040),
    [anon_sym_ucfirst] = ACTIONS(3040),
    [anon_sym_untie] = ACTIONS(3040),
    [anon_sym_umask] = ACTIONS(3040),
    [anon_sym_values] = ACTIONS(3040),
    [anon_sym_write] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3040),
    [anon_sym___END__] = ACTIONS(3040),
    [anon_sym_q] = ACTIONS(3040),
    [anon_sym_qq] = ACTIONS(3040),
    [anon_sym_qw] = ACTIONS(3040),
    [anon_sym_qx] = ACTIONS(3040),
    [anon_sym_qr] = ACTIONS(3040),
    [anon_sym_m] = ACTIONS(3040),
    [anon_sym_s] = ACTIONS(3040),
    [anon_sym_tr] = ACTIONS(3040),
    [anon_sym_y] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_unless] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_until] = ACTIONS(3040),
    [aux_sym__bareword_token1] = ACTIONS(3040),
    [sym_number] = ACTIONS(3040),
    [sym__apostrophe] = ACTIONS(3038),
    [sym__double_quote] = ACTIONS(3038),
    [sym__backtick] = ACTIONS(3038),
    [sym__search_slash] = ACTIONS(3038),
    [sym__PERLY_HEREDOC] = ACTIONS(3038),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1086] = {
    [sym_heredoc_content] = STATE(1086),
    [sym__identifier] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_LBRACE2] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_package] = ACTIONS(3216),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_sub] = ACTIONS(3216),
    [anon_sym_method] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_continue] = ACTIONS(3216),
    [anon_sym_my] = ACTIONS(3216),
    [anon_sym_state] = ACTIONS(3216),
    [anon_sym_our] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(3216),
    [anon_sym_defer] = ACTIONS(3216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3216),
    [anon_sym_else] = ACTIONS(3216),
    [anon_sym_elsif] = ACTIONS(3216),
    [anon_sym_and] = ACTIONS(3216),
    [anon_sym_or] = ACTIONS(3216),
    [anon_sym_DOLLAR] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_LT_LT] = ACTIONS(3216),
    [anon_sym_SLASH_SLASH] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_eq] = ACTIONS(3216),
    [anon_sym_ne] = ACTIONS(3216),
    [anon_sym_cmp] = ACTIONS(3216),
    [anon_sym_lt] = ACTIONS(3216),
    [anon_sym_le] = ACTIONS(3216),
    [anon_sym_ge] = ACTIONS(3216),
    [anon_sym_gt] = ACTIONS(3216),
    [anon_sym_isa] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_BSLASH] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3216),
    [anon_sym_eval] = ACTIONS(3216),
    [anon_sym_field] = ACTIONS(3216),
    [anon_sym_local] = ACTIONS(3216),
    [anon_sym_require] = ACTIONS(3216),
    [anon_sym_map] = ACTIONS(3216),
    [anon_sym_grep] = ACTIONS(3216),
    [anon_sym_sort] = ACTIONS(3216),
    [anon_sym_goto] = ACTIONS(3216),
    [anon_sym_return] = ACTIONS(3216),
    [anon_sym_undef] = ACTIONS(3216),
    [anon_sym_PERCENT2] = ACTIONS(3216),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3216),
    [anon_sym_use] = ACTIONS(3216),
    [anon_sym_no] = ACTIONS(3216),
    [anon_sym_for] = ACTIONS(3216),
    [anon_sym_foreach] = ACTIONS(3216),
    [anon_sym_last] = ACTIONS(3216),
    [anon_sym_next] = ACTIONS(3216),
    [anon_sym_redo] = ACTIONS(3216),
    [anon_sym_BEGIN] = ACTIONS(3216),
    [anon_sym_INIT] = ACTIONS(3216),
    [anon_sym_CHECK] = ACTIONS(3216),
    [anon_sym_UNITCHECK] = ACTIONS(3216),
    [anon_sym_END] = ACTIONS(3216),
    [anon_sym_ADJUST] = ACTIONS(3216),
    [anon_sym___FILE__] = ACTIONS(3216),
    [anon_sym___LINE__] = ACTIONS(3216),
    [anon_sym___PACKAGE__] = ACTIONS(3216),
    [anon_sym___SUB__] = ACTIONS(3216),
    [anon_sym_break] = ACTIONS(3216),
    [anon_sym_fork] = ACTIONS(3216),
    [anon_sym_getppid] = ACTIONS(3216),
    [anon_sym_time] = ACTIONS(3216),
    [anon_sym_times] = ACTIONS(3216),
    [anon_sym_wait] = ACTIONS(3216),
    [anon_sym_wantarray] = ACTIONS(3216),
    [anon_sym_abs] = ACTIONS(3216),
    [anon_sym_alarm] = ACTIONS(3216),
    [anon_sym_chop] = ACTIONS(3216),
    [anon_sym_chdir] = ACTIONS(3216),
    [anon_sym_close] = ACTIONS(3216),
    [anon_sym_closedir] = ACTIONS(3216),
    [anon_sym_caller] = ACTIONS(3216),
    [anon_sym_chomp] = ACTIONS(3216),
    [anon_sym_chr] = ACTIONS(3216),
    [anon_sym_cos] = ACTIONS(3216),
    [anon_sym_chroot] = ACTIONS(3216),
    [anon_sym_defined] = ACTIONS(3216),
    [anon_sym_delete] = ACTIONS(3216),
    [anon_sym_dbmclose] = ACTIONS(3216),
    [anon_sym_exists] = ACTIONS(3216),
    [anon_sym_exit] = ACTIONS(3216),
    [anon_sym_eof] = ACTIONS(3216),
    [anon_sym_exp] = ACTIONS(3216),
    [anon_sym_each] = ACTIONS(3216),
    [anon_sym_fc] = ACTIONS(3216),
    [anon_sym_fileno] = ACTIONS(3216),
    [anon_sym_gmtime] = ACTIONS(3216),
    [anon_sym_getc] = ACTIONS(3216),
    [anon_sym_getpgrp] = ACTIONS(3216),
    [anon_sym_getprotobyname] = ACTIONS(3216),
    [anon_sym_getpwname] = ACTIONS(3216),
    [anon_sym_getpwuid] = ACTIONS(3216),
    [anon_sym_getpeername] = ACTIONS(3216),
    [anon_sym_getnetbyname] = ACTIONS(3216),
    [anon_sym_getsockname] = ACTIONS(3216),
    [anon_sym_getgrnam] = ACTIONS(3216),
    [anon_sym_getgrgid] = ACTIONS(3216),
    [anon_sym_hex] = ACTIONS(3216),
    [anon_sym_int] = ACTIONS(3216),
    [anon_sym_keys] = ACTIONS(3216),
    [anon_sym_lc] = ACTIONS(3216),
    [anon_sym_lcfirst] = ACTIONS(3216),
    [anon_sym_length] = ACTIONS(3216),
    [anon_sym_localtime] = ACTIONS(3216),
    [anon_sym_log] = ACTIONS(3216),
    [anon_sym_lock] = ACTIONS(3216),
    [anon_sym_lstat] = ACTIONS(3216),
    [anon_sym_oct] = ACTIONS(3216),
    [anon_sym_ord] = ACTIONS(3216),
    [anon_sym_prototype] = ACTIONS(3216),
    [anon_sym_pop] = ACTIONS(3216),
    [anon_sym_pos] = ACTIONS(3216),
    [anon_sym_quotemeta] = ACTIONS(3216),
    [anon_sym_reset] = ACTIONS(3216),
    [anon_sym_rand] = ACTIONS(3216),
    [anon_sym_rmdir] = ACTIONS(3216),
    [anon_sym_readdir] = ACTIONS(3216),
    [anon_sym_readline] = ACTIONS(3216),
    [anon_sym_readpipe] = ACTIONS(3216),
    [anon_sym_rewinddir] = ACTIONS(3216),
    [anon_sym_readlink] = ACTIONS(3216),
    [anon_sym_ref] = ACTIONS(3216),
    [anon_sym_scalar] = ACTIONS(3216),
    [anon_sym_shift] = ACTIONS(3216),
    [anon_sym_sin] = ACTIONS(3216),
    [anon_sym_sleep] = ACTIONS(3216),
    [anon_sym_sqrt] = ACTIONS(3216),
    [anon_sym_srand] = ACTIONS(3216),
    [anon_sym_stat] = ACTIONS(3216),
    [anon_sym_study] = ACTIONS(3216),
    [anon_sym_tell] = ACTIONS(3216),
    [anon_sym_telldir] = ACTIONS(3216),
    [anon_sym_tied] = ACTIONS(3216),
    [anon_sym_uc] = ACTIONS(3216),
    [anon_sym_ucfirst] = ACTIONS(3216),
    [anon_sym_untie] = ACTIONS(3216),
    [anon_sym_umask] = ACTIONS(3216),
    [anon_sym_values] = ACTIONS(3216),
    [anon_sym_write] = ACTIONS(3216),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3216),
    [anon_sym___END__] = ACTIONS(3216),
    [anon_sym_q] = ACTIONS(3216),
    [anon_sym_qq] = ACTIONS(3216),
    [anon_sym_qw] = ACTIONS(3216),
    [anon_sym_qx] = ACTIONS(3216),
    [anon_sym_qr] = ACTIONS(3216),
    [anon_sym_m] = ACTIONS(3216),
    [anon_sym_s] = ACTIONS(3216),
    [anon_sym_tr] = ACTIONS(3216),
    [anon_sym_y] = ACTIONS(3216),
    [anon_sym_if] = ACTIONS(3216),
    [anon_sym_unless] = ACTIONS(3216),
    [anon_sym_while] = ACTIONS(3216),
    [anon_sym_until] = ACTIONS(3216),
    [aux_sym__bareword_token1] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [sym__apostrophe] = ACTIONS(3214),
    [sym__double_quote] = ACTIONS(3214),
    [sym__backtick] = ACTIONS(3214),
    [sym__search_slash] = ACTIONS(3214),
    [sym__PERLY_HEREDOC] = ACTIONS(3214),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1087] = {
    [sym_heredoc_content] = STATE(1087),
    [sym__identifier] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LBRACE2] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym_package] = ACTIONS(3212),
    [anon_sym_class] = ACTIONS(3212),
    [anon_sym_sub] = ACTIONS(3212),
    [anon_sym_method] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_continue] = ACTIONS(3212),
    [anon_sym_my] = ACTIONS(3212),
    [anon_sym_state] = ACTIONS(3212),
    [anon_sym_our] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_defer] = ACTIONS(3212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3212),
    [anon_sym_else] = ACTIONS(3212),
    [anon_sym_elsif] = ACTIONS(3212),
    [anon_sym_and] = ACTIONS(3212),
    [anon_sym_or] = ACTIONS(3212),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_LT_LT] = ACTIONS(3212),
    [anon_sym_SLASH_SLASH] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_eq] = ACTIONS(3212),
    [anon_sym_ne] = ACTIONS(3212),
    [anon_sym_cmp] = ACTIONS(3212),
    [anon_sym_lt] = ACTIONS(3212),
    [anon_sym_le] = ACTIONS(3212),
    [anon_sym_ge] = ACTIONS(3212),
    [anon_sym_gt] = ACTIONS(3212),
    [anon_sym_isa] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_BSLASH] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_eval] = ACTIONS(3212),
    [anon_sym_field] = ACTIONS(3212),
    [anon_sym_local] = ACTIONS(3212),
    [anon_sym_require] = ACTIONS(3212),
    [anon_sym_map] = ACTIONS(3212),
    [anon_sym_grep] = ACTIONS(3212),
    [anon_sym_sort] = ACTIONS(3212),
    [anon_sym_goto] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_undef] = ACTIONS(3212),
    [anon_sym_PERCENT2] = ACTIONS(3212),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_no] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_foreach] = ACTIONS(3212),
    [anon_sym_last] = ACTIONS(3212),
    [anon_sym_next] = ACTIONS(3212),
    [anon_sym_redo] = ACTIONS(3212),
    [anon_sym_BEGIN] = ACTIONS(3212),
    [anon_sym_INIT] = ACTIONS(3212),
    [anon_sym_CHECK] = ACTIONS(3212),
    [anon_sym_UNITCHECK] = ACTIONS(3212),
    [anon_sym_END] = ACTIONS(3212),
    [anon_sym_ADJUST] = ACTIONS(3212),
    [anon_sym___FILE__] = ACTIONS(3212),
    [anon_sym___LINE__] = ACTIONS(3212),
    [anon_sym___PACKAGE__] = ACTIONS(3212),
    [anon_sym___SUB__] = ACTIONS(3212),
    [anon_sym_break] = ACTIONS(3212),
    [anon_sym_fork] = ACTIONS(3212),
    [anon_sym_getppid] = ACTIONS(3212),
    [anon_sym_time] = ACTIONS(3212),
    [anon_sym_times] = ACTIONS(3212),
    [anon_sym_wait] = ACTIONS(3212),
    [anon_sym_wantarray] = ACTIONS(3212),
    [anon_sym_abs] = ACTIONS(3212),
    [anon_sym_alarm] = ACTIONS(3212),
    [anon_sym_chop] = ACTIONS(3212),
    [anon_sym_chdir] = ACTIONS(3212),
    [anon_sym_close] = ACTIONS(3212),
    [anon_sym_closedir] = ACTIONS(3212),
    [anon_sym_caller] = ACTIONS(3212),
    [anon_sym_chomp] = ACTIONS(3212),
    [anon_sym_chr] = ACTIONS(3212),
    [anon_sym_cos] = ACTIONS(3212),
    [anon_sym_chroot] = ACTIONS(3212),
    [anon_sym_defined] = ACTIONS(3212),
    [anon_sym_delete] = ACTIONS(3212),
    [anon_sym_dbmclose] = ACTIONS(3212),
    [anon_sym_exists] = ACTIONS(3212),
    [anon_sym_exit] = ACTIONS(3212),
    [anon_sym_eof] = ACTIONS(3212),
    [anon_sym_exp] = ACTIONS(3212),
    [anon_sym_each] = ACTIONS(3212),
    [anon_sym_fc] = ACTIONS(3212),
    [anon_sym_fileno] = ACTIONS(3212),
    [anon_sym_gmtime] = ACTIONS(3212),
    [anon_sym_getc] = ACTIONS(3212),
    [anon_sym_getpgrp] = ACTIONS(3212),
    [anon_sym_getprotobyname] = ACTIONS(3212),
    [anon_sym_getpwname] = ACTIONS(3212),
    [anon_sym_getpwuid] = ACTIONS(3212),
    [anon_sym_getpeername] = ACTIONS(3212),
    [anon_sym_getnetbyname] = ACTIONS(3212),
    [anon_sym_getsockname] = ACTIONS(3212),
    [anon_sym_getgrnam] = ACTIONS(3212),
    [anon_sym_getgrgid] = ACTIONS(3212),
    [anon_sym_hex] = ACTIONS(3212),
    [anon_sym_int] = ACTIONS(3212),
    [anon_sym_keys] = ACTIONS(3212),
    [anon_sym_lc] = ACTIONS(3212),
    [anon_sym_lcfirst] = ACTIONS(3212),
    [anon_sym_length] = ACTIONS(3212),
    [anon_sym_localtime] = ACTIONS(3212),
    [anon_sym_log] = ACTIONS(3212),
    [anon_sym_lock] = ACTIONS(3212),
    [anon_sym_lstat] = ACTIONS(3212),
    [anon_sym_oct] = ACTIONS(3212),
    [anon_sym_ord] = ACTIONS(3212),
    [anon_sym_prototype] = ACTIONS(3212),
    [anon_sym_pop] = ACTIONS(3212),
    [anon_sym_pos] = ACTIONS(3212),
    [anon_sym_quotemeta] = ACTIONS(3212),
    [anon_sym_reset] = ACTIONS(3212),
    [anon_sym_rand] = ACTIONS(3212),
    [anon_sym_rmdir] = ACTIONS(3212),
    [anon_sym_readdir] = ACTIONS(3212),
    [anon_sym_readline] = ACTIONS(3212),
    [anon_sym_readpipe] = ACTIONS(3212),
    [anon_sym_rewinddir] = ACTIONS(3212),
    [anon_sym_readlink] = ACTIONS(3212),
    [anon_sym_ref] = ACTIONS(3212),
    [anon_sym_scalar] = ACTIONS(3212),
    [anon_sym_shift] = ACTIONS(3212),
    [anon_sym_sin] = ACTIONS(3212),
    [anon_sym_sleep] = ACTIONS(3212),
    [anon_sym_sqrt] = ACTIONS(3212),
    [anon_sym_srand] = ACTIONS(3212),
    [anon_sym_stat] = ACTIONS(3212),
    [anon_sym_study] = ACTIONS(3212),
    [anon_sym_tell] = ACTIONS(3212),
    [anon_sym_telldir] = ACTIONS(3212),
    [anon_sym_tied] = ACTIONS(3212),
    [anon_sym_uc] = ACTIONS(3212),
    [anon_sym_ucfirst] = ACTIONS(3212),
    [anon_sym_untie] = ACTIONS(3212),
    [anon_sym_umask] = ACTIONS(3212),
    [anon_sym_values] = ACTIONS(3212),
    [anon_sym_write] = ACTIONS(3212),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3212),
    [anon_sym___END__] = ACTIONS(3212),
    [anon_sym_q] = ACTIONS(3212),
    [anon_sym_qq] = ACTIONS(3212),
    [anon_sym_qw] = ACTIONS(3212),
    [anon_sym_qx] = ACTIONS(3212),
    [anon_sym_qr] = ACTIONS(3212),
    [anon_sym_m] = ACTIONS(3212),
    [anon_sym_s] = ACTIONS(3212),
    [anon_sym_tr] = ACTIONS(3212),
    [anon_sym_y] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_unless] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_until] = ACTIONS(3212),
    [aux_sym__bareword_token1] = ACTIONS(3212),
    [sym_number] = ACTIONS(3212),
    [sym__apostrophe] = ACTIONS(3210),
    [sym__double_quote] = ACTIONS(3210),
    [sym__backtick] = ACTIONS(3210),
    [sym__search_slash] = ACTIONS(3210),
    [sym__PERLY_HEREDOC] = ACTIONS(3210),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1088] = {
    [sym_heredoc_content] = STATE(1088),
    [sym__identifier] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_LBRACE2] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym_package] = ACTIONS(3044),
    [anon_sym_class] = ACTIONS(3044),
    [anon_sym_sub] = ACTIONS(3044),
    [anon_sym_method] = ACTIONS(3044),
    [anon_sym_LPAREN] = ACTIONS(3044),
    [anon_sym_continue] = ACTIONS(3044),
    [anon_sym_my] = ACTIONS(3044),
    [anon_sym_state] = ACTIONS(3044),
    [anon_sym_our] = ACTIONS(3044),
    [anon_sym_try] = ACTIONS(3044),
    [anon_sym_defer] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3044),
    [anon_sym_else] = ACTIONS(3044),
    [anon_sym_elsif] = ACTIONS(3044),
    [anon_sym_and] = ACTIONS(3044),
    [anon_sym_or] = ACTIONS(3044),
    [anon_sym_DOLLAR] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_AT] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_LT_LT] = ACTIONS(3044),
    [anon_sym_SLASH_SLASH] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_eq] = ACTIONS(3044),
    [anon_sym_ne] = ACTIONS(3044),
    [anon_sym_cmp] = ACTIONS(3044),
    [anon_sym_lt] = ACTIONS(3044),
    [anon_sym_le] = ACTIONS(3044),
    [anon_sym_ge] = ACTIONS(3044),
    [anon_sym_gt] = ACTIONS(3044),
    [anon_sym_isa] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_BSLASH] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3044),
    [anon_sym_eval] = ACTIONS(3044),
    [anon_sym_field] = ACTIONS(3044),
    [anon_sym_local] = ACTIONS(3044),
    [anon_sym_require] = ACTIONS(3044),
    [anon_sym_map] = ACTIONS(3044),
    [anon_sym_grep] = ACTIONS(3044),
    [anon_sym_sort] = ACTIONS(3044),
    [anon_sym_goto] = ACTIONS(3044),
    [anon_sym_return] = ACTIONS(3044),
    [anon_sym_undef] = ACTIONS(3044),
    [anon_sym_PERCENT2] = ACTIONS(3044),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3044),
    [anon_sym_use] = ACTIONS(3044),
    [anon_sym_no] = ACTIONS(3044),
    [anon_sym_for] = ACTIONS(3044),
    [anon_sym_foreach] = ACTIONS(3044),
    [anon_sym_last] = ACTIONS(3044),
    [anon_sym_next] = ACTIONS(3044),
    [anon_sym_redo] = ACTIONS(3044),
    [anon_sym_BEGIN] = ACTIONS(3044),
    [anon_sym_INIT] = ACTIONS(3044),
    [anon_sym_CHECK] = ACTIONS(3044),
    [anon_sym_UNITCHECK] = ACTIONS(3044),
    [anon_sym_END] = ACTIONS(3044),
    [anon_sym_ADJUST] = ACTIONS(3044),
    [anon_sym___FILE__] = ACTIONS(3044),
    [anon_sym___LINE__] = ACTIONS(3044),
    [anon_sym___PACKAGE__] = ACTIONS(3044),
    [anon_sym___SUB__] = ACTIONS(3044),
    [anon_sym_break] = ACTIONS(3044),
    [anon_sym_fork] = ACTIONS(3044),
    [anon_sym_getppid] = ACTIONS(3044),
    [anon_sym_time] = ACTIONS(3044),
    [anon_sym_times] = ACTIONS(3044),
    [anon_sym_wait] = ACTIONS(3044),
    [anon_sym_wantarray] = ACTIONS(3044),
    [anon_sym_abs] = ACTIONS(3044),
    [anon_sym_alarm] = ACTIONS(3044),
    [anon_sym_chop] = ACTIONS(3044),
    [anon_sym_chdir] = ACTIONS(3044),
    [anon_sym_close] = ACTIONS(3044),
    [anon_sym_closedir] = ACTIONS(3044),
    [anon_sym_caller] = ACTIONS(3044),
    [anon_sym_chomp] = ACTIONS(3044),
    [anon_sym_chr] = ACTIONS(3044),
    [anon_sym_cos] = ACTIONS(3044),
    [anon_sym_chroot] = ACTIONS(3044),
    [anon_sym_defined] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3044),
    [anon_sym_dbmclose] = ACTIONS(3044),
    [anon_sym_exists] = ACTIONS(3044),
    [anon_sym_exit] = ACTIONS(3044),
    [anon_sym_eof] = ACTIONS(3044),
    [anon_sym_exp] = ACTIONS(3044),
    [anon_sym_each] = ACTIONS(3044),
    [anon_sym_fc] = ACTIONS(3044),
    [anon_sym_fileno] = ACTIONS(3044),
    [anon_sym_gmtime] = ACTIONS(3044),
    [anon_sym_getc] = ACTIONS(3044),
    [anon_sym_getpgrp] = ACTIONS(3044),
    [anon_sym_getprotobyname] = ACTIONS(3044),
    [anon_sym_getpwname] = ACTIONS(3044),
    [anon_sym_getpwuid] = ACTIONS(3044),
    [anon_sym_getpeername] = ACTIONS(3044),
    [anon_sym_getnetbyname] = ACTIONS(3044),
    [anon_sym_getsockname] = ACTIONS(3044),
    [anon_sym_getgrnam] = ACTIONS(3044),
    [anon_sym_getgrgid] = ACTIONS(3044),
    [anon_sym_hex] = ACTIONS(3044),
    [anon_sym_int] = ACTIONS(3044),
    [anon_sym_keys] = ACTIONS(3044),
    [anon_sym_lc] = ACTIONS(3044),
    [anon_sym_lcfirst] = ACTIONS(3044),
    [anon_sym_length] = ACTIONS(3044),
    [anon_sym_localtime] = ACTIONS(3044),
    [anon_sym_log] = ACTIONS(3044),
    [anon_sym_lock] = ACTIONS(3044),
    [anon_sym_lstat] = ACTIONS(3044),
    [anon_sym_oct] = ACTIONS(3044),
    [anon_sym_ord] = ACTIONS(3044),
    [anon_sym_prototype] = ACTIONS(3044),
    [anon_sym_pop] = ACTIONS(3044),
    [anon_sym_pos] = ACTIONS(3044),
    [anon_sym_quotemeta] = ACTIONS(3044),
    [anon_sym_reset] = ACTIONS(3044),
    [anon_sym_rand] = ACTIONS(3044),
    [anon_sym_rmdir] = ACTIONS(3044),
    [anon_sym_readdir] = ACTIONS(3044),
    [anon_sym_readline] = ACTIONS(3044),
    [anon_sym_readpipe] = ACTIONS(3044),
    [anon_sym_rewinddir] = ACTIONS(3044),
    [anon_sym_readlink] = ACTIONS(3044),
    [anon_sym_ref] = ACTIONS(3044),
    [anon_sym_scalar] = ACTIONS(3044),
    [anon_sym_shift] = ACTIONS(3044),
    [anon_sym_sin] = ACTIONS(3044),
    [anon_sym_sleep] = ACTIONS(3044),
    [anon_sym_sqrt] = ACTIONS(3044),
    [anon_sym_srand] = ACTIONS(3044),
    [anon_sym_stat] = ACTIONS(3044),
    [anon_sym_study] = ACTIONS(3044),
    [anon_sym_tell] = ACTIONS(3044),
    [anon_sym_telldir] = ACTIONS(3044),
    [anon_sym_tied] = ACTIONS(3044),
    [anon_sym_uc] = ACTIONS(3044),
    [anon_sym_ucfirst] = ACTIONS(3044),
    [anon_sym_untie] = ACTIONS(3044),
    [anon_sym_umask] = ACTIONS(3044),
    [anon_sym_values] = ACTIONS(3044),
    [anon_sym_write] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3044),
    [anon_sym___END__] = ACTIONS(3044),
    [anon_sym_q] = ACTIONS(3044),
    [anon_sym_qq] = ACTIONS(3044),
    [anon_sym_qw] = ACTIONS(3044),
    [anon_sym_qx] = ACTIONS(3044),
    [anon_sym_qr] = ACTIONS(3044),
    [anon_sym_m] = ACTIONS(3044),
    [anon_sym_s] = ACTIONS(3044),
    [anon_sym_tr] = ACTIONS(3044),
    [anon_sym_y] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_unless] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_until] = ACTIONS(3044),
    [aux_sym__bareword_token1] = ACTIONS(3044),
    [sym_number] = ACTIONS(3044),
    [sym__apostrophe] = ACTIONS(3042),
    [sym__double_quote] = ACTIONS(3042),
    [sym__backtick] = ACTIONS(3042),
    [sym__search_slash] = ACTIONS(3042),
    [sym__PERLY_HEREDOC] = ACTIONS(3042),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1089] = {
    [sym_heredoc_content] = STATE(1089),
    [sym__identifier] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3196),
    [anon_sym_LBRACE2] = ACTIONS(3196),
    [anon_sym_RBRACE] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3196),
    [anon_sym_package] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_sub] = ACTIONS(3196),
    [anon_sym_method] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_my] = ACTIONS(3196),
    [anon_sym_state] = ACTIONS(3196),
    [anon_sym_our] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_defer] = ACTIONS(3196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_elsif] = ACTIONS(3196),
    [anon_sym_and] = ACTIONS(3196),
    [anon_sym_or] = ACTIONS(3196),
    [anon_sym_DOLLAR] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_AT] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3196),
    [anon_sym_LT_LT] = ACTIONS(3196),
    [anon_sym_SLASH_SLASH] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_eq] = ACTIONS(3196),
    [anon_sym_ne] = ACTIONS(3196),
    [anon_sym_cmp] = ACTIONS(3196),
    [anon_sym_lt] = ACTIONS(3196),
    [anon_sym_le] = ACTIONS(3196),
    [anon_sym_ge] = ACTIONS(3196),
    [anon_sym_gt] = ACTIONS(3196),
    [anon_sym_isa] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_PLUS_PLUS] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3196),
    [anon_sym_BSLASH] = ACTIONS(3194),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_eval] = ACTIONS(3196),
    [anon_sym_field] = ACTIONS(3196),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_require] = ACTIONS(3196),
    [anon_sym_map] = ACTIONS(3196),
    [anon_sym_grep] = ACTIONS(3196),
    [anon_sym_sort] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_undef] = ACTIONS(3196),
    [anon_sym_PERCENT2] = ACTIONS(3196),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3196),
    [anon_sym_use] = ACTIONS(3196),
    [anon_sym_no] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_foreach] = ACTIONS(3196),
    [anon_sym_last] = ACTIONS(3196),
    [anon_sym_next] = ACTIONS(3196),
    [anon_sym_redo] = ACTIONS(3196),
    [anon_sym_BEGIN] = ACTIONS(3196),
    [anon_sym_INIT] = ACTIONS(3196),
    [anon_sym_CHECK] = ACTIONS(3196),
    [anon_sym_UNITCHECK] = ACTIONS(3196),
    [anon_sym_END] = ACTIONS(3196),
    [anon_sym_ADJUST] = ACTIONS(3196),
    [anon_sym___FILE__] = ACTIONS(3196),
    [anon_sym___LINE__] = ACTIONS(3196),
    [anon_sym___PACKAGE__] = ACTIONS(3196),
    [anon_sym___SUB__] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_fork] = ACTIONS(3196),
    [anon_sym_getppid] = ACTIONS(3196),
    [anon_sym_time] = ACTIONS(3196),
    [anon_sym_times] = ACTIONS(3196),
    [anon_sym_wait] = ACTIONS(3196),
    [anon_sym_wantarray] = ACTIONS(3196),
    [anon_sym_abs] = ACTIONS(3196),
    [anon_sym_alarm] = ACTIONS(3196),
    [anon_sym_chop] = ACTIONS(3196),
    [anon_sym_chdir] = ACTIONS(3196),
    [anon_sym_close] = ACTIONS(3196),
    [anon_sym_closedir] = ACTIONS(3196),
    [anon_sym_caller] = ACTIONS(3196),
    [anon_sym_chomp] = ACTIONS(3196),
    [anon_sym_chr] = ACTIONS(3196),
    [anon_sym_cos] = ACTIONS(3196),
    [anon_sym_chroot] = ACTIONS(3196),
    [anon_sym_defined] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_dbmclose] = ACTIONS(3196),
    [anon_sym_exists] = ACTIONS(3196),
    [anon_sym_exit] = ACTIONS(3196),
    [anon_sym_eof] = ACTIONS(3196),
    [anon_sym_exp] = ACTIONS(3196),
    [anon_sym_each] = ACTIONS(3196),
    [anon_sym_fc] = ACTIONS(3196),
    [anon_sym_fileno] = ACTIONS(3196),
    [anon_sym_gmtime] = ACTIONS(3196),
    [anon_sym_getc] = ACTIONS(3196),
    [anon_sym_getpgrp] = ACTIONS(3196),
    [anon_sym_getprotobyname] = ACTIONS(3196),
    [anon_sym_getpwname] = ACTIONS(3196),
    [anon_sym_getpwuid] = ACTIONS(3196),
    [anon_sym_getpeername] = ACTIONS(3196),
    [anon_sym_getnetbyname] = ACTIONS(3196),
    [anon_sym_getsockname] = ACTIONS(3196),
    [anon_sym_getgrnam] = ACTIONS(3196),
    [anon_sym_getgrgid] = ACTIONS(3196),
    [anon_sym_hex] = ACTIONS(3196),
    [anon_sym_int] = ACTIONS(3196),
    [anon_sym_keys] = ACTIONS(3196),
    [anon_sym_lc] = ACTIONS(3196),
    [anon_sym_lcfirst] = ACTIONS(3196),
    [anon_sym_length] = ACTIONS(3196),
    [anon_sym_localtime] = ACTIONS(3196),
    [anon_sym_log] = ACTIONS(3196),
    [anon_sym_lock] = ACTIONS(3196),
    [anon_sym_lstat] = ACTIONS(3196),
    [anon_sym_oct] = ACTIONS(3196),
    [anon_sym_ord] = ACTIONS(3196),
    [anon_sym_prototype] = ACTIONS(3196),
    [anon_sym_pop] = ACTIONS(3196),
    [anon_sym_pos] = ACTIONS(3196),
    [anon_sym_quotemeta] = ACTIONS(3196),
    [anon_sym_reset] = ACTIONS(3196),
    [anon_sym_rand] = ACTIONS(3196),
    [anon_sym_rmdir] = ACTIONS(3196),
    [anon_sym_readdir] = ACTIONS(3196),
    [anon_sym_readline] = ACTIONS(3196),
    [anon_sym_readpipe] = ACTIONS(3196),
    [anon_sym_rewinddir] = ACTIONS(3196),
    [anon_sym_readlink] = ACTIONS(3196),
    [anon_sym_ref] = ACTIONS(3196),
    [anon_sym_scalar] = ACTIONS(3196),
    [anon_sym_shift] = ACTIONS(3196),
    [anon_sym_sin] = ACTIONS(3196),
    [anon_sym_sleep] = ACTIONS(3196),
    [anon_sym_sqrt] = ACTIONS(3196),
    [anon_sym_srand] = ACTIONS(3196),
    [anon_sym_stat] = ACTIONS(3196),
    [anon_sym_study] = ACTIONS(3196),
    [anon_sym_tell] = ACTIONS(3196),
    [anon_sym_telldir] = ACTIONS(3196),
    [anon_sym_tied] = ACTIONS(3196),
    [anon_sym_uc] = ACTIONS(3196),
    [anon_sym_ucfirst] = ACTIONS(3196),
    [anon_sym_untie] = ACTIONS(3196),
    [anon_sym_umask] = ACTIONS(3196),
    [anon_sym_values] = ACTIONS(3196),
    [anon_sym_write] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3196),
    [anon_sym___END__] = ACTIONS(3196),
    [anon_sym_q] = ACTIONS(3196),
    [anon_sym_qq] = ACTIONS(3196),
    [anon_sym_qw] = ACTIONS(3196),
    [anon_sym_qx] = ACTIONS(3196),
    [anon_sym_qr] = ACTIONS(3196),
    [anon_sym_m] = ACTIONS(3196),
    [anon_sym_s] = ACTIONS(3196),
    [anon_sym_tr] = ACTIONS(3196),
    [anon_sym_y] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_unless] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_until] = ACTIONS(3196),
    [aux_sym__bareword_token1] = ACTIONS(3196),
    [sym_number] = ACTIONS(3196),
    [sym__apostrophe] = ACTIONS(3194),
    [sym__double_quote] = ACTIONS(3194),
    [sym__backtick] = ACTIONS(3194),
    [sym__search_slash] = ACTIONS(3194),
    [sym__PERLY_HEREDOC] = ACTIONS(3194),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1090] = {
    [sym_heredoc_content] = STATE(1090),
    [sym__identifier] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LBRACE2] = ACTIONS(3059),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_package] = ACTIONS(3059),
    [anon_sym_class] = ACTIONS(3059),
    [anon_sym_sub] = ACTIONS(3059),
    [anon_sym_method] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_continue] = ACTIONS(3059),
    [anon_sym_my] = ACTIONS(3059),
    [anon_sym_state] = ACTIONS(3059),
    [anon_sym_our] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_defer] = ACTIONS(3059),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3059),
    [anon_sym_else] = ACTIONS(3059),
    [anon_sym_elsif] = ACTIONS(3059),
    [anon_sym_and] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_SLASH_SLASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_eq] = ACTIONS(3059),
    [anon_sym_ne] = ACTIONS(3059),
    [anon_sym_cmp] = ACTIONS(3059),
    [anon_sym_lt] = ACTIONS(3059),
    [anon_sym_le] = ACTIONS(3059),
    [anon_sym_ge] = ACTIONS(3059),
    [anon_sym_gt] = ACTIONS(3059),
    [anon_sym_isa] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3057),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_eval] = ACTIONS(3059),
    [anon_sym_field] = ACTIONS(3059),
    [anon_sym_local] = ACTIONS(3059),
    [anon_sym_require] = ACTIONS(3059),
    [anon_sym_map] = ACTIONS(3059),
    [anon_sym_grep] = ACTIONS(3059),
    [anon_sym_sort] = ACTIONS(3059),
    [anon_sym_goto] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_undef] = ACTIONS(3059),
    [anon_sym_PERCENT2] = ACTIONS(3059),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3059),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_no] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_foreach] = ACTIONS(3059),
    [anon_sym_last] = ACTIONS(3059),
    [anon_sym_next] = ACTIONS(3059),
    [anon_sym_redo] = ACTIONS(3059),
    [anon_sym_BEGIN] = ACTIONS(3059),
    [anon_sym_INIT] = ACTIONS(3059),
    [anon_sym_CHECK] = ACTIONS(3059),
    [anon_sym_UNITCHECK] = ACTIONS(3059),
    [anon_sym_END] = ACTIONS(3059),
    [anon_sym_ADJUST] = ACTIONS(3059),
    [anon_sym___FILE__] = ACTIONS(3059),
    [anon_sym___LINE__] = ACTIONS(3059),
    [anon_sym___PACKAGE__] = ACTIONS(3059),
    [anon_sym___SUB__] = ACTIONS(3059),
    [anon_sym_break] = ACTIONS(3059),
    [anon_sym_fork] = ACTIONS(3059),
    [anon_sym_getppid] = ACTIONS(3059),
    [anon_sym_time] = ACTIONS(3059),
    [anon_sym_times] = ACTIONS(3059),
    [anon_sym_wait] = ACTIONS(3059),
    [anon_sym_wantarray] = ACTIONS(3059),
    [anon_sym_abs] = ACTIONS(3059),
    [anon_sym_alarm] = ACTIONS(3059),
    [anon_sym_chop] = ACTIONS(3059),
    [anon_sym_chdir] = ACTIONS(3059),
    [anon_sym_close] = ACTIONS(3059),
    [anon_sym_closedir] = ACTIONS(3059),
    [anon_sym_caller] = ACTIONS(3059),
    [anon_sym_chomp] = ACTIONS(3059),
    [anon_sym_chr] = ACTIONS(3059),
    [anon_sym_cos] = ACTIONS(3059),
    [anon_sym_chroot] = ACTIONS(3059),
    [anon_sym_defined] = ACTIONS(3059),
    [anon_sym_delete] = ACTIONS(3059),
    [anon_sym_dbmclose] = ACTIONS(3059),
    [anon_sym_exists] = ACTIONS(3059),
    [anon_sym_exit] = ACTIONS(3059),
    [anon_sym_eof] = ACTIONS(3059),
    [anon_sym_exp] = ACTIONS(3059),
    [anon_sym_each] = ACTIONS(3059),
    [anon_sym_fc] = ACTIONS(3059),
    [anon_sym_fileno] = ACTIONS(3059),
    [anon_sym_gmtime] = ACTIONS(3059),
    [anon_sym_getc] = ACTIONS(3059),
    [anon_sym_getpgrp] = ACTIONS(3059),
    [anon_sym_getprotobyname] = ACTIONS(3059),
    [anon_sym_getpwname] = ACTIONS(3059),
    [anon_sym_getpwuid] = ACTIONS(3059),
    [anon_sym_getpeername] = ACTIONS(3059),
    [anon_sym_getnetbyname] = ACTIONS(3059),
    [anon_sym_getsockname] = ACTIONS(3059),
    [anon_sym_getgrnam] = ACTIONS(3059),
    [anon_sym_getgrgid] = ACTIONS(3059),
    [anon_sym_hex] = ACTIONS(3059),
    [anon_sym_int] = ACTIONS(3059),
    [anon_sym_keys] = ACTIONS(3059),
    [anon_sym_lc] = ACTIONS(3059),
    [anon_sym_lcfirst] = ACTIONS(3059),
    [anon_sym_length] = ACTIONS(3059),
    [anon_sym_localtime] = ACTIONS(3059),
    [anon_sym_log] = ACTIONS(3059),
    [anon_sym_lock] = ACTIONS(3059),
    [anon_sym_lstat] = ACTIONS(3059),
    [anon_sym_oct] = ACTIONS(3059),
    [anon_sym_ord] = ACTIONS(3059),
    [anon_sym_prototype] = ACTIONS(3059),
    [anon_sym_pop] = ACTIONS(3059),
    [anon_sym_pos] = ACTIONS(3059),
    [anon_sym_quotemeta] = ACTIONS(3059),
    [anon_sym_reset] = ACTIONS(3059),
    [anon_sym_rand] = ACTIONS(3059),
    [anon_sym_rmdir] = ACTIONS(3059),
    [anon_sym_readdir] = ACTIONS(3059),
    [anon_sym_readline] = ACTIONS(3059),
    [anon_sym_readpipe] = ACTIONS(3059),
    [anon_sym_rewinddir] = ACTIONS(3059),
    [anon_sym_readlink] = ACTIONS(3059),
    [anon_sym_ref] = ACTIONS(3059),
    [anon_sym_scalar] = ACTIONS(3059),
    [anon_sym_shift] = ACTIONS(3059),
    [anon_sym_sin] = ACTIONS(3059),
    [anon_sym_sleep] = ACTIONS(3059),
    [anon_sym_sqrt] = ACTIONS(3059),
    [anon_sym_srand] = ACTIONS(3059),
    [anon_sym_stat] = ACTIONS(3059),
    [anon_sym_study] = ACTIONS(3059),
    [anon_sym_tell] = ACTIONS(3059),
    [anon_sym_telldir] = ACTIONS(3059),
    [anon_sym_tied] = ACTIONS(3059),
    [anon_sym_uc] = ACTIONS(3059),
    [anon_sym_ucfirst] = ACTIONS(3059),
    [anon_sym_untie] = ACTIONS(3059),
    [anon_sym_umask] = ACTIONS(3059),
    [anon_sym_values] = ACTIONS(3059),
    [anon_sym_write] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3059),
    [anon_sym___END__] = ACTIONS(3059),
    [anon_sym_q] = ACTIONS(3059),
    [anon_sym_qq] = ACTIONS(3059),
    [anon_sym_qw] = ACTIONS(3059),
    [anon_sym_qx] = ACTIONS(3059),
    [anon_sym_qr] = ACTIONS(3059),
    [anon_sym_m] = ACTIONS(3059),
    [anon_sym_s] = ACTIONS(3059),
    [anon_sym_tr] = ACTIONS(3059),
    [anon_sym_y] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_unless] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_until] = ACTIONS(3059),
    [aux_sym__bareword_token1] = ACTIONS(3059),
    [sym_number] = ACTIONS(3059),
    [sym__apostrophe] = ACTIONS(3057),
    [sym__double_quote] = ACTIONS(3057),
    [sym__backtick] = ACTIONS(3057),
    [sym__search_slash] = ACTIONS(3057),
    [sym__PERLY_HEREDOC] = ACTIONS(3057),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1091] = {
    [sym_heredoc_content] = STATE(1091),
    [sym__identifier] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LBRACE2] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_package] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_sub] = ACTIONS(3063),
    [anon_sym_method] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_my] = ACTIONS(3063),
    [anon_sym_state] = ACTIONS(3063),
    [anon_sym_our] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_defer] = ACTIONS(3063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3063),
    [anon_sym_else] = ACTIONS(3063),
    [anon_sym_elsif] = ACTIONS(3063),
    [anon_sym_and] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_eq] = ACTIONS(3063),
    [anon_sym_ne] = ACTIONS(3063),
    [anon_sym_cmp] = ACTIONS(3063),
    [anon_sym_lt] = ACTIONS(3063),
    [anon_sym_le] = ACTIONS(3063),
    [anon_sym_ge] = ACTIONS(3063),
    [anon_sym_gt] = ACTIONS(3063),
    [anon_sym_isa] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_eval] = ACTIONS(3063),
    [anon_sym_field] = ACTIONS(3063),
    [anon_sym_local] = ACTIONS(3063),
    [anon_sym_require] = ACTIONS(3063),
    [anon_sym_map] = ACTIONS(3063),
    [anon_sym_grep] = ACTIONS(3063),
    [anon_sym_sort] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_undef] = ACTIONS(3063),
    [anon_sym_PERCENT2] = ACTIONS(3063),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3063),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_no] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_foreach] = ACTIONS(3063),
    [anon_sym_last] = ACTIONS(3063),
    [anon_sym_next] = ACTIONS(3063),
    [anon_sym_redo] = ACTIONS(3063),
    [anon_sym_BEGIN] = ACTIONS(3063),
    [anon_sym_INIT] = ACTIONS(3063),
    [anon_sym_CHECK] = ACTIONS(3063),
    [anon_sym_UNITCHECK] = ACTIONS(3063),
    [anon_sym_END] = ACTIONS(3063),
    [anon_sym_ADJUST] = ACTIONS(3063),
    [anon_sym___FILE__] = ACTIONS(3063),
    [anon_sym___LINE__] = ACTIONS(3063),
    [anon_sym___PACKAGE__] = ACTIONS(3063),
    [anon_sym___SUB__] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_fork] = ACTIONS(3063),
    [anon_sym_getppid] = ACTIONS(3063),
    [anon_sym_time] = ACTIONS(3063),
    [anon_sym_times] = ACTIONS(3063),
    [anon_sym_wait] = ACTIONS(3063),
    [anon_sym_wantarray] = ACTIONS(3063),
    [anon_sym_abs] = ACTIONS(3063),
    [anon_sym_alarm] = ACTIONS(3063),
    [anon_sym_chop] = ACTIONS(3063),
    [anon_sym_chdir] = ACTIONS(3063),
    [anon_sym_close] = ACTIONS(3063),
    [anon_sym_closedir] = ACTIONS(3063),
    [anon_sym_caller] = ACTIONS(3063),
    [anon_sym_chomp] = ACTIONS(3063),
    [anon_sym_chr] = ACTIONS(3063),
    [anon_sym_cos] = ACTIONS(3063),
    [anon_sym_chroot] = ACTIONS(3063),
    [anon_sym_defined] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_dbmclose] = ACTIONS(3063),
    [anon_sym_exists] = ACTIONS(3063),
    [anon_sym_exit] = ACTIONS(3063),
    [anon_sym_eof] = ACTIONS(3063),
    [anon_sym_exp] = ACTIONS(3063),
    [anon_sym_each] = ACTIONS(3063),
    [anon_sym_fc] = ACTIONS(3063),
    [anon_sym_fileno] = ACTIONS(3063),
    [anon_sym_gmtime] = ACTIONS(3063),
    [anon_sym_getc] = ACTIONS(3063),
    [anon_sym_getpgrp] = ACTIONS(3063),
    [anon_sym_getprotobyname] = ACTIONS(3063),
    [anon_sym_getpwname] = ACTIONS(3063),
    [anon_sym_getpwuid] = ACTIONS(3063),
    [anon_sym_getpeername] = ACTIONS(3063),
    [anon_sym_getnetbyname] = ACTIONS(3063),
    [anon_sym_getsockname] = ACTIONS(3063),
    [anon_sym_getgrnam] = ACTIONS(3063),
    [anon_sym_getgrgid] = ACTIONS(3063),
    [anon_sym_hex] = ACTIONS(3063),
    [anon_sym_int] = ACTIONS(3063),
    [anon_sym_keys] = ACTIONS(3063),
    [anon_sym_lc] = ACTIONS(3063),
    [anon_sym_lcfirst] = ACTIONS(3063),
    [anon_sym_length] = ACTIONS(3063),
    [anon_sym_localtime] = ACTIONS(3063),
    [anon_sym_log] = ACTIONS(3063),
    [anon_sym_lock] = ACTIONS(3063),
    [anon_sym_lstat] = ACTIONS(3063),
    [anon_sym_oct] = ACTIONS(3063),
    [anon_sym_ord] = ACTIONS(3063),
    [anon_sym_prototype] = ACTIONS(3063),
    [anon_sym_pop] = ACTIONS(3063),
    [anon_sym_pos] = ACTIONS(3063),
    [anon_sym_quotemeta] = ACTIONS(3063),
    [anon_sym_reset] = ACTIONS(3063),
    [anon_sym_rand] = ACTIONS(3063),
    [anon_sym_rmdir] = ACTIONS(3063),
    [anon_sym_readdir] = ACTIONS(3063),
    [anon_sym_readline] = ACTIONS(3063),
    [anon_sym_readpipe] = ACTIONS(3063),
    [anon_sym_rewinddir] = ACTIONS(3063),
    [anon_sym_readlink] = ACTIONS(3063),
    [anon_sym_ref] = ACTIONS(3063),
    [anon_sym_scalar] = ACTIONS(3063),
    [anon_sym_shift] = ACTIONS(3063),
    [anon_sym_sin] = ACTIONS(3063),
    [anon_sym_sleep] = ACTIONS(3063),
    [anon_sym_sqrt] = ACTIONS(3063),
    [anon_sym_srand] = ACTIONS(3063),
    [anon_sym_stat] = ACTIONS(3063),
    [anon_sym_study] = ACTIONS(3063),
    [anon_sym_tell] = ACTIONS(3063),
    [anon_sym_telldir] = ACTIONS(3063),
    [anon_sym_tied] = ACTIONS(3063),
    [anon_sym_uc] = ACTIONS(3063),
    [anon_sym_ucfirst] = ACTIONS(3063),
    [anon_sym_untie] = ACTIONS(3063),
    [anon_sym_umask] = ACTIONS(3063),
    [anon_sym_values] = ACTIONS(3063),
    [anon_sym_write] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3063),
    [anon_sym___END__] = ACTIONS(3063),
    [anon_sym_q] = ACTIONS(3063),
    [anon_sym_qq] = ACTIONS(3063),
    [anon_sym_qw] = ACTIONS(3063),
    [anon_sym_qx] = ACTIONS(3063),
    [anon_sym_qr] = ACTIONS(3063),
    [anon_sym_m] = ACTIONS(3063),
    [anon_sym_s] = ACTIONS(3063),
    [anon_sym_tr] = ACTIONS(3063),
    [anon_sym_y] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_unless] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_until] = ACTIONS(3063),
    [aux_sym__bareword_token1] = ACTIONS(3063),
    [sym_number] = ACTIONS(3063),
    [sym__apostrophe] = ACTIONS(3061),
    [sym__double_quote] = ACTIONS(3061),
    [sym__backtick] = ACTIONS(3061),
    [sym__search_slash] = ACTIONS(3061),
    [sym__PERLY_HEREDOC] = ACTIONS(3061),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1092] = {
    [sym_heredoc_content] = STATE(1092),
    [sym__identifier] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_LBRACE2] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_package] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_sub] = ACTIONS(3255),
    [anon_sym_method] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_my] = ACTIONS(3255),
    [anon_sym_state] = ACTIONS(3255),
    [anon_sym_our] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_defer] = ACTIONS(3255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_elsif] = ACTIONS(3255),
    [anon_sym_and] = ACTIONS(3255),
    [anon_sym_or] = ACTIONS(3255),
    [anon_sym_DOLLAR] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_LT_LT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_eq] = ACTIONS(3255),
    [anon_sym_ne] = ACTIONS(3255),
    [anon_sym_cmp] = ACTIONS(3255),
    [anon_sym_lt] = ACTIONS(3255),
    [anon_sym_le] = ACTIONS(3255),
    [anon_sym_ge] = ACTIONS(3255),
    [anon_sym_gt] = ACTIONS(3255),
    [anon_sym_isa] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [anon_sym_BSLASH] = ACTIONS(3253),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_eval] = ACTIONS(3255),
    [anon_sym_field] = ACTIONS(3255),
    [anon_sym_local] = ACTIONS(3255),
    [anon_sym_require] = ACTIONS(3255),
    [anon_sym_map] = ACTIONS(3255),
    [anon_sym_grep] = ACTIONS(3255),
    [anon_sym_sort] = ACTIONS(3255),
    [anon_sym_goto] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_undef] = ACTIONS(3255),
    [anon_sym_PERCENT2] = ACTIONS(3255),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3255),
    [anon_sym_use] = ACTIONS(3255),
    [anon_sym_no] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_foreach] = ACTIONS(3255),
    [anon_sym_last] = ACTIONS(3255),
    [anon_sym_next] = ACTIONS(3255),
    [anon_sym_redo] = ACTIONS(3255),
    [anon_sym_BEGIN] = ACTIONS(3255),
    [anon_sym_INIT] = ACTIONS(3255),
    [anon_sym_CHECK] = ACTIONS(3255),
    [anon_sym_UNITCHECK] = ACTIONS(3255),
    [anon_sym_END] = ACTIONS(3255),
    [anon_sym_ADJUST] = ACTIONS(3255),
    [anon_sym___FILE__] = ACTIONS(3255),
    [anon_sym___LINE__] = ACTIONS(3255),
    [anon_sym___PACKAGE__] = ACTIONS(3255),
    [anon_sym___SUB__] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_fork] = ACTIONS(3255),
    [anon_sym_getppid] = ACTIONS(3255),
    [anon_sym_time] = ACTIONS(3255),
    [anon_sym_times] = ACTIONS(3255),
    [anon_sym_wait] = ACTIONS(3255),
    [anon_sym_wantarray] = ACTIONS(3255),
    [anon_sym_abs] = ACTIONS(3255),
    [anon_sym_alarm] = ACTIONS(3255),
    [anon_sym_chop] = ACTIONS(3255),
    [anon_sym_chdir] = ACTIONS(3255),
    [anon_sym_close] = ACTIONS(3255),
    [anon_sym_closedir] = ACTIONS(3255),
    [anon_sym_caller] = ACTIONS(3255),
    [anon_sym_chomp] = ACTIONS(3255),
    [anon_sym_chr] = ACTIONS(3255),
    [anon_sym_cos] = ACTIONS(3255),
    [anon_sym_chroot] = ACTIONS(3255),
    [anon_sym_defined] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_dbmclose] = ACTIONS(3255),
    [anon_sym_exists] = ACTIONS(3255),
    [anon_sym_exit] = ACTIONS(3255),
    [anon_sym_eof] = ACTIONS(3255),
    [anon_sym_exp] = ACTIONS(3255),
    [anon_sym_each] = ACTIONS(3255),
    [anon_sym_fc] = ACTIONS(3255),
    [anon_sym_fileno] = ACTIONS(3255),
    [anon_sym_gmtime] = ACTIONS(3255),
    [anon_sym_getc] = ACTIONS(3255),
    [anon_sym_getpgrp] = ACTIONS(3255),
    [anon_sym_getprotobyname] = ACTIONS(3255),
    [anon_sym_getpwname] = ACTIONS(3255),
    [anon_sym_getpwuid] = ACTIONS(3255),
    [anon_sym_getpeername] = ACTIONS(3255),
    [anon_sym_getnetbyname] = ACTIONS(3255),
    [anon_sym_getsockname] = ACTIONS(3255),
    [anon_sym_getgrnam] = ACTIONS(3255),
    [anon_sym_getgrgid] = ACTIONS(3255),
    [anon_sym_hex] = ACTIONS(3255),
    [anon_sym_int] = ACTIONS(3255),
    [anon_sym_keys] = ACTIONS(3255),
    [anon_sym_lc] = ACTIONS(3255),
    [anon_sym_lcfirst] = ACTIONS(3255),
    [anon_sym_length] = ACTIONS(3255),
    [anon_sym_localtime] = ACTIONS(3255),
    [anon_sym_log] = ACTIONS(3255),
    [anon_sym_lock] = ACTIONS(3255),
    [anon_sym_lstat] = ACTIONS(3255),
    [anon_sym_oct] = ACTIONS(3255),
    [anon_sym_ord] = ACTIONS(3255),
    [anon_sym_prototype] = ACTIONS(3255),
    [anon_sym_pop] = ACTIONS(3255),
    [anon_sym_pos] = ACTIONS(3255),
    [anon_sym_quotemeta] = ACTIONS(3255),
    [anon_sym_reset] = ACTIONS(3255),
    [anon_sym_rand] = ACTIONS(3255),
    [anon_sym_rmdir] = ACTIONS(3255),
    [anon_sym_readdir] = ACTIONS(3255),
    [anon_sym_readline] = ACTIONS(3255),
    [anon_sym_readpipe] = ACTIONS(3255),
    [anon_sym_rewinddir] = ACTIONS(3255),
    [anon_sym_readlink] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_scalar] = ACTIONS(3255),
    [anon_sym_shift] = ACTIONS(3255),
    [anon_sym_sin] = ACTIONS(3255),
    [anon_sym_sleep] = ACTIONS(3255),
    [anon_sym_sqrt] = ACTIONS(3255),
    [anon_sym_srand] = ACTIONS(3255),
    [anon_sym_stat] = ACTIONS(3255),
    [anon_sym_study] = ACTIONS(3255),
    [anon_sym_tell] = ACTIONS(3255),
    [anon_sym_telldir] = ACTIONS(3255),
    [anon_sym_tied] = ACTIONS(3255),
    [anon_sym_uc] = ACTIONS(3255),
    [anon_sym_ucfirst] = ACTIONS(3255),
    [anon_sym_untie] = ACTIONS(3255),
    [anon_sym_umask] = ACTIONS(3255),
    [anon_sym_values] = ACTIONS(3255),
    [anon_sym_write] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3255),
    [anon_sym___END__] = ACTIONS(3255),
    [anon_sym_q] = ACTIONS(3255),
    [anon_sym_qq] = ACTIONS(3255),
    [anon_sym_qw] = ACTIONS(3255),
    [anon_sym_qx] = ACTIONS(3255),
    [anon_sym_qr] = ACTIONS(3255),
    [anon_sym_m] = ACTIONS(3255),
    [anon_sym_s] = ACTIONS(3255),
    [anon_sym_tr] = ACTIONS(3255),
    [anon_sym_y] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_unless] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_until] = ACTIONS(3255),
    [aux_sym__bareword_token1] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym__apostrophe] = ACTIONS(3253),
    [sym__double_quote] = ACTIONS(3253),
    [sym__backtick] = ACTIONS(3253),
    [sym__search_slash] = ACTIONS(3253),
    [sym__PERLY_HEREDOC] = ACTIONS(3253),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1093] = {
    [sym_heredoc_content] = STATE(1093),
    [sym__identifier] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LBRACE2] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_package] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_sub] = ACTIONS(3071),
    [anon_sym_method] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_my] = ACTIONS(3071),
    [anon_sym_state] = ACTIONS(3071),
    [anon_sym_our] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_defer] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_elsif] = ACTIONS(3071),
    [anon_sym_and] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3071),
    [anon_sym_SLASH_SLASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_eq] = ACTIONS(3071),
    [anon_sym_ne] = ACTIONS(3071),
    [anon_sym_cmp] = ACTIONS(3071),
    [anon_sym_lt] = ACTIONS(3071),
    [anon_sym_le] = ACTIONS(3071),
    [anon_sym_ge] = ACTIONS(3071),
    [anon_sym_gt] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3071),
    [anon_sym_BANG] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_BSLASH] = ACTIONS(3069),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_eval] = ACTIONS(3071),
    [anon_sym_field] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_require] = ACTIONS(3071),
    [anon_sym_map] = ACTIONS(3071),
    [anon_sym_grep] = ACTIONS(3071),
    [anon_sym_sort] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_undef] = ACTIONS(3071),
    [anon_sym_PERCENT2] = ACTIONS(3071),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3071),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_no] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_foreach] = ACTIONS(3071),
    [anon_sym_last] = ACTIONS(3071),
    [anon_sym_next] = ACTIONS(3071),
    [anon_sym_redo] = ACTIONS(3071),
    [anon_sym_BEGIN] = ACTIONS(3071),
    [anon_sym_INIT] = ACTIONS(3071),
    [anon_sym_CHECK] = ACTIONS(3071),
    [anon_sym_UNITCHECK] = ACTIONS(3071),
    [anon_sym_END] = ACTIONS(3071),
    [anon_sym_ADJUST] = ACTIONS(3071),
    [anon_sym___FILE__] = ACTIONS(3071),
    [anon_sym___LINE__] = ACTIONS(3071),
    [anon_sym___PACKAGE__] = ACTIONS(3071),
    [anon_sym___SUB__] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_fork] = ACTIONS(3071),
    [anon_sym_getppid] = ACTIONS(3071),
    [anon_sym_time] = ACTIONS(3071),
    [anon_sym_times] = ACTIONS(3071),
    [anon_sym_wait] = ACTIONS(3071),
    [anon_sym_wantarray] = ACTIONS(3071),
    [anon_sym_abs] = ACTIONS(3071),
    [anon_sym_alarm] = ACTIONS(3071),
    [anon_sym_chop] = ACTIONS(3071),
    [anon_sym_chdir] = ACTIONS(3071),
    [anon_sym_close] = ACTIONS(3071),
    [anon_sym_closedir] = ACTIONS(3071),
    [anon_sym_caller] = ACTIONS(3071),
    [anon_sym_chomp] = ACTIONS(3071),
    [anon_sym_chr] = ACTIONS(3071),
    [anon_sym_cos] = ACTIONS(3071),
    [anon_sym_chroot] = ACTIONS(3071),
    [anon_sym_defined] = ACTIONS(3071),
    [anon_sym_delete] = ACTIONS(3071),
    [anon_sym_dbmclose] = ACTIONS(3071),
    [anon_sym_exists] = ACTIONS(3071),
    [anon_sym_exit] = ACTIONS(3071),
    [anon_sym_eof] = ACTIONS(3071),
    [anon_sym_exp] = ACTIONS(3071),
    [anon_sym_each] = ACTIONS(3071),
    [anon_sym_fc] = ACTIONS(3071),
    [anon_sym_fileno] = ACTIONS(3071),
    [anon_sym_gmtime] = ACTIONS(3071),
    [anon_sym_getc] = ACTIONS(3071),
    [anon_sym_getpgrp] = ACTIONS(3071),
    [anon_sym_getprotobyname] = ACTIONS(3071),
    [anon_sym_getpwname] = ACTIONS(3071),
    [anon_sym_getpwuid] = ACTIONS(3071),
    [anon_sym_getpeername] = ACTIONS(3071),
    [anon_sym_getnetbyname] = ACTIONS(3071),
    [anon_sym_getsockname] = ACTIONS(3071),
    [anon_sym_getgrnam] = ACTIONS(3071),
    [anon_sym_getgrgid] = ACTIONS(3071),
    [anon_sym_hex] = ACTIONS(3071),
    [anon_sym_int] = ACTIONS(3071),
    [anon_sym_keys] = ACTIONS(3071),
    [anon_sym_lc] = ACTIONS(3071),
    [anon_sym_lcfirst] = ACTIONS(3071),
    [anon_sym_length] = ACTIONS(3071),
    [anon_sym_localtime] = ACTIONS(3071),
    [anon_sym_log] = ACTIONS(3071),
    [anon_sym_lock] = ACTIONS(3071),
    [anon_sym_lstat] = ACTIONS(3071),
    [anon_sym_oct] = ACTIONS(3071),
    [anon_sym_ord] = ACTIONS(3071),
    [anon_sym_prototype] = ACTIONS(3071),
    [anon_sym_pop] = ACTIONS(3071),
    [anon_sym_pos] = ACTIONS(3071),
    [anon_sym_quotemeta] = ACTIONS(3071),
    [anon_sym_reset] = ACTIONS(3071),
    [anon_sym_rand] = ACTIONS(3071),
    [anon_sym_rmdir] = ACTIONS(3071),
    [anon_sym_readdir] = ACTIONS(3071),
    [anon_sym_readline] = ACTIONS(3071),
    [anon_sym_readpipe] = ACTIONS(3071),
    [anon_sym_rewinddir] = ACTIONS(3071),
    [anon_sym_readlink] = ACTIONS(3071),
    [anon_sym_ref] = ACTIONS(3071),
    [anon_sym_scalar] = ACTIONS(3071),
    [anon_sym_shift] = ACTIONS(3071),
    [anon_sym_sin] = ACTIONS(3071),
    [anon_sym_sleep] = ACTIONS(3071),
    [anon_sym_sqrt] = ACTIONS(3071),
    [anon_sym_srand] = ACTIONS(3071),
    [anon_sym_stat] = ACTIONS(3071),
    [anon_sym_study] = ACTIONS(3071),
    [anon_sym_tell] = ACTIONS(3071),
    [anon_sym_telldir] = ACTIONS(3071),
    [anon_sym_tied] = ACTIONS(3071),
    [anon_sym_uc] = ACTIONS(3071),
    [anon_sym_ucfirst] = ACTIONS(3071),
    [anon_sym_untie] = ACTIONS(3071),
    [anon_sym_umask] = ACTIONS(3071),
    [anon_sym_values] = ACTIONS(3071),
    [anon_sym_write] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3071),
    [anon_sym___END__] = ACTIONS(3071),
    [anon_sym_q] = ACTIONS(3071),
    [anon_sym_qq] = ACTIONS(3071),
    [anon_sym_qw] = ACTIONS(3071),
    [anon_sym_qx] = ACTIONS(3071),
    [anon_sym_qr] = ACTIONS(3071),
    [anon_sym_m] = ACTIONS(3071),
    [anon_sym_s] = ACTIONS(3071),
    [anon_sym_tr] = ACTIONS(3071),
    [anon_sym_y] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_unless] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_until] = ACTIONS(3071),
    [aux_sym__bareword_token1] = ACTIONS(3071),
    [sym_number] = ACTIONS(3071),
    [sym__apostrophe] = ACTIONS(3069),
    [sym__double_quote] = ACTIONS(3069),
    [sym__backtick] = ACTIONS(3069),
    [sym__search_slash] = ACTIONS(3069),
    [sym__PERLY_HEREDOC] = ACTIONS(3069),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1094] = {
    [sym_heredoc_content] = STATE(1094),
    [sym__identifier] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_LBRACE2] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym_package] = ACTIONS(3244),
    [anon_sym_class] = ACTIONS(3244),
    [anon_sym_sub] = ACTIONS(3244),
    [anon_sym_method] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3244),
    [anon_sym_continue] = ACTIONS(3244),
    [anon_sym_my] = ACTIONS(3244),
    [anon_sym_state] = ACTIONS(3244),
    [anon_sym_our] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3244),
    [anon_sym_defer] = ACTIONS(3244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3244),
    [anon_sym_else] = ACTIONS(3244),
    [anon_sym_elsif] = ACTIONS(3244),
    [anon_sym_and] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3244),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_AT] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_LT_LT] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_eq] = ACTIONS(3244),
    [anon_sym_ne] = ACTIONS(3244),
    [anon_sym_cmp] = ACTIONS(3244),
    [anon_sym_lt] = ACTIONS(3244),
    [anon_sym_le] = ACTIONS(3244),
    [anon_sym_ge] = ACTIONS(3244),
    [anon_sym_gt] = ACTIONS(3244),
    [anon_sym_isa] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_BSLASH] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3244),
    [anon_sym_eval] = ACTIONS(3244),
    [anon_sym_field] = ACTIONS(3244),
    [anon_sym_local] = ACTIONS(3244),
    [anon_sym_require] = ACTIONS(3244),
    [anon_sym_map] = ACTIONS(3244),
    [anon_sym_grep] = ACTIONS(3244),
    [anon_sym_sort] = ACTIONS(3244),
    [anon_sym_goto] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3244),
    [anon_sym_undef] = ACTIONS(3244),
    [anon_sym_PERCENT2] = ACTIONS(3244),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3244),
    [anon_sym_no] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3244),
    [anon_sym_foreach] = ACTIONS(3244),
    [anon_sym_last] = ACTIONS(3244),
    [anon_sym_next] = ACTIONS(3244),
    [anon_sym_redo] = ACTIONS(3244),
    [anon_sym_BEGIN] = ACTIONS(3244),
    [anon_sym_INIT] = ACTIONS(3244),
    [anon_sym_CHECK] = ACTIONS(3244),
    [anon_sym_UNITCHECK] = ACTIONS(3244),
    [anon_sym_END] = ACTIONS(3244),
    [anon_sym_ADJUST] = ACTIONS(3244),
    [anon_sym___FILE__] = ACTIONS(3244),
    [anon_sym___LINE__] = ACTIONS(3244),
    [anon_sym___PACKAGE__] = ACTIONS(3244),
    [anon_sym___SUB__] = ACTIONS(3244),
    [anon_sym_break] = ACTIONS(3244),
    [anon_sym_fork] = ACTIONS(3244),
    [anon_sym_getppid] = ACTIONS(3244),
    [anon_sym_time] = ACTIONS(3244),
    [anon_sym_times] = ACTIONS(3244),
    [anon_sym_wait] = ACTIONS(3244),
    [anon_sym_wantarray] = ACTIONS(3244),
    [anon_sym_abs] = ACTIONS(3244),
    [anon_sym_alarm] = ACTIONS(3244),
    [anon_sym_chop] = ACTIONS(3244),
    [anon_sym_chdir] = ACTIONS(3244),
    [anon_sym_close] = ACTIONS(3244),
    [anon_sym_closedir] = ACTIONS(3244),
    [anon_sym_caller] = ACTIONS(3244),
    [anon_sym_chomp] = ACTIONS(3244),
    [anon_sym_chr] = ACTIONS(3244),
    [anon_sym_cos] = ACTIONS(3244),
    [anon_sym_chroot] = ACTIONS(3244),
    [anon_sym_defined] = ACTIONS(3244),
    [anon_sym_delete] = ACTIONS(3244),
    [anon_sym_dbmclose] = ACTIONS(3244),
    [anon_sym_exists] = ACTIONS(3244),
    [anon_sym_exit] = ACTIONS(3244),
    [anon_sym_eof] = ACTIONS(3244),
    [anon_sym_exp] = ACTIONS(3244),
    [anon_sym_each] = ACTIONS(3244),
    [anon_sym_fc] = ACTIONS(3244),
    [anon_sym_fileno] = ACTIONS(3244),
    [anon_sym_gmtime] = ACTIONS(3244),
    [anon_sym_getc] = ACTIONS(3244),
    [anon_sym_getpgrp] = ACTIONS(3244),
    [anon_sym_getprotobyname] = ACTIONS(3244),
    [anon_sym_getpwname] = ACTIONS(3244),
    [anon_sym_getpwuid] = ACTIONS(3244),
    [anon_sym_getpeername] = ACTIONS(3244),
    [anon_sym_getnetbyname] = ACTIONS(3244),
    [anon_sym_getsockname] = ACTIONS(3244),
    [anon_sym_getgrnam] = ACTIONS(3244),
    [anon_sym_getgrgid] = ACTIONS(3244),
    [anon_sym_hex] = ACTIONS(3244),
    [anon_sym_int] = ACTIONS(3244),
    [anon_sym_keys] = ACTIONS(3244),
    [anon_sym_lc] = ACTIONS(3244),
    [anon_sym_lcfirst] = ACTIONS(3244),
    [anon_sym_length] = ACTIONS(3244),
    [anon_sym_localtime] = ACTIONS(3244),
    [anon_sym_log] = ACTIONS(3244),
    [anon_sym_lock] = ACTIONS(3244),
    [anon_sym_lstat] = ACTIONS(3244),
    [anon_sym_oct] = ACTIONS(3244),
    [anon_sym_ord] = ACTIONS(3244),
    [anon_sym_prototype] = ACTIONS(3244),
    [anon_sym_pop] = ACTIONS(3244),
    [anon_sym_pos] = ACTIONS(3244),
    [anon_sym_quotemeta] = ACTIONS(3244),
    [anon_sym_reset] = ACTIONS(3244),
    [anon_sym_rand] = ACTIONS(3244),
    [anon_sym_rmdir] = ACTIONS(3244),
    [anon_sym_readdir] = ACTIONS(3244),
    [anon_sym_readline] = ACTIONS(3244),
    [anon_sym_readpipe] = ACTIONS(3244),
    [anon_sym_rewinddir] = ACTIONS(3244),
    [anon_sym_readlink] = ACTIONS(3244),
    [anon_sym_ref] = ACTIONS(3244),
    [anon_sym_scalar] = ACTIONS(3244),
    [anon_sym_shift] = ACTIONS(3244),
    [anon_sym_sin] = ACTIONS(3244),
    [anon_sym_sleep] = ACTIONS(3244),
    [anon_sym_sqrt] = ACTIONS(3244),
    [anon_sym_srand] = ACTIONS(3244),
    [anon_sym_stat] = ACTIONS(3244),
    [anon_sym_study] = ACTIONS(3244),
    [anon_sym_tell] = ACTIONS(3244),
    [anon_sym_telldir] = ACTIONS(3244),
    [anon_sym_tied] = ACTIONS(3244),
    [anon_sym_uc] = ACTIONS(3244),
    [anon_sym_ucfirst] = ACTIONS(3244),
    [anon_sym_untie] = ACTIONS(3244),
    [anon_sym_umask] = ACTIONS(3244),
    [anon_sym_values] = ACTIONS(3244),
    [anon_sym_write] = ACTIONS(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3244),
    [anon_sym___END__] = ACTIONS(3244),
    [anon_sym_q] = ACTIONS(3244),
    [anon_sym_qq] = ACTIONS(3244),
    [anon_sym_qw] = ACTIONS(3244),
    [anon_sym_qx] = ACTIONS(3244),
    [anon_sym_qr] = ACTIONS(3244),
    [anon_sym_m] = ACTIONS(3244),
    [anon_sym_s] = ACTIONS(3244),
    [anon_sym_tr] = ACTIONS(3244),
    [anon_sym_y] = ACTIONS(3244),
    [anon_sym_if] = ACTIONS(3244),
    [anon_sym_unless] = ACTIONS(3244),
    [anon_sym_while] = ACTIONS(3244),
    [anon_sym_until] = ACTIONS(3244),
    [aux_sym__bareword_token1] = ACTIONS(3244),
    [sym_number] = ACTIONS(3244),
    [sym__apostrophe] = ACTIONS(3242),
    [sym__double_quote] = ACTIONS(3242),
    [sym__backtick] = ACTIONS(3242),
    [sym__search_slash] = ACTIONS(3242),
    [sym__PERLY_HEREDOC] = ACTIONS(3242),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1095] = {
    [sym_heredoc_content] = STATE(1095),
    [sym__identifier] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LBRACE2] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_package] = ACTIONS(3300),
    [anon_sym_class] = ACTIONS(3300),
    [anon_sym_sub] = ACTIONS(3300),
    [anon_sym_method] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_my] = ACTIONS(3300),
    [anon_sym_state] = ACTIONS(3300),
    [anon_sym_our] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_defer] = ACTIONS(3300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3300),
    [anon_sym_else] = ACTIONS(3300),
    [anon_sym_elsif] = ACTIONS(3300),
    [anon_sym_and] = ACTIONS(3300),
    [anon_sym_or] = ACTIONS(3300),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_AT] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_eq] = ACTIONS(3300),
    [anon_sym_ne] = ACTIONS(3300),
    [anon_sym_cmp] = ACTIONS(3300),
    [anon_sym_lt] = ACTIONS(3300),
    [anon_sym_le] = ACTIONS(3300),
    [anon_sym_ge] = ACTIONS(3300),
    [anon_sym_gt] = ACTIONS(3300),
    [anon_sym_isa] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_BSLASH] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_eval] = ACTIONS(3300),
    [anon_sym_field] = ACTIONS(3300),
    [anon_sym_local] = ACTIONS(3300),
    [anon_sym_require] = ACTIONS(3300),
    [anon_sym_map] = ACTIONS(3300),
    [anon_sym_grep] = ACTIONS(3300),
    [anon_sym_sort] = ACTIONS(3300),
    [anon_sym_goto] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_undef] = ACTIONS(3300),
    [anon_sym_PERCENT2] = ACTIONS(3300),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_no] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_foreach] = ACTIONS(3300),
    [anon_sym_last] = ACTIONS(3300),
    [anon_sym_next] = ACTIONS(3300),
    [anon_sym_redo] = ACTIONS(3300),
    [anon_sym_BEGIN] = ACTIONS(3300),
    [anon_sym_INIT] = ACTIONS(3300),
    [anon_sym_CHECK] = ACTIONS(3300),
    [anon_sym_UNITCHECK] = ACTIONS(3300),
    [anon_sym_END] = ACTIONS(3300),
    [anon_sym_ADJUST] = ACTIONS(3300),
    [anon_sym___FILE__] = ACTIONS(3300),
    [anon_sym___LINE__] = ACTIONS(3300),
    [anon_sym___PACKAGE__] = ACTIONS(3300),
    [anon_sym___SUB__] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_fork] = ACTIONS(3300),
    [anon_sym_getppid] = ACTIONS(3300),
    [anon_sym_time] = ACTIONS(3300),
    [anon_sym_times] = ACTIONS(3300),
    [anon_sym_wait] = ACTIONS(3300),
    [anon_sym_wantarray] = ACTIONS(3300),
    [anon_sym_abs] = ACTIONS(3300),
    [anon_sym_alarm] = ACTIONS(3300),
    [anon_sym_chop] = ACTIONS(3300),
    [anon_sym_chdir] = ACTIONS(3300),
    [anon_sym_close] = ACTIONS(3300),
    [anon_sym_closedir] = ACTIONS(3300),
    [anon_sym_caller] = ACTIONS(3300),
    [anon_sym_chomp] = ACTIONS(3300),
    [anon_sym_chr] = ACTIONS(3300),
    [anon_sym_cos] = ACTIONS(3300),
    [anon_sym_chroot] = ACTIONS(3300),
    [anon_sym_defined] = ACTIONS(3300),
    [anon_sym_delete] = ACTIONS(3300),
    [anon_sym_dbmclose] = ACTIONS(3300),
    [anon_sym_exists] = ACTIONS(3300),
    [anon_sym_exit] = ACTIONS(3300),
    [anon_sym_eof] = ACTIONS(3300),
    [anon_sym_exp] = ACTIONS(3300),
    [anon_sym_each] = ACTIONS(3300),
    [anon_sym_fc] = ACTIONS(3300),
    [anon_sym_fileno] = ACTIONS(3300),
    [anon_sym_gmtime] = ACTIONS(3300),
    [anon_sym_getc] = ACTIONS(3300),
    [anon_sym_getpgrp] = ACTIONS(3300),
    [anon_sym_getprotobyname] = ACTIONS(3300),
    [anon_sym_getpwname] = ACTIONS(3300),
    [anon_sym_getpwuid] = ACTIONS(3300),
    [anon_sym_getpeername] = ACTIONS(3300),
    [anon_sym_getnetbyname] = ACTIONS(3300),
    [anon_sym_getsockname] = ACTIONS(3300),
    [anon_sym_getgrnam] = ACTIONS(3300),
    [anon_sym_getgrgid] = ACTIONS(3300),
    [anon_sym_hex] = ACTIONS(3300),
    [anon_sym_int] = ACTIONS(3300),
    [anon_sym_keys] = ACTIONS(3300),
    [anon_sym_lc] = ACTIONS(3300),
    [anon_sym_lcfirst] = ACTIONS(3300),
    [anon_sym_length] = ACTIONS(3300),
    [anon_sym_localtime] = ACTIONS(3300),
    [anon_sym_log] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_lstat] = ACTIONS(3300),
    [anon_sym_oct] = ACTIONS(3300),
    [anon_sym_ord] = ACTIONS(3300),
    [anon_sym_prototype] = ACTIONS(3300),
    [anon_sym_pop] = ACTIONS(3300),
    [anon_sym_pos] = ACTIONS(3300),
    [anon_sym_quotemeta] = ACTIONS(3300),
    [anon_sym_reset] = ACTIONS(3300),
    [anon_sym_rand] = ACTIONS(3300),
    [anon_sym_rmdir] = ACTIONS(3300),
    [anon_sym_readdir] = ACTIONS(3300),
    [anon_sym_readline] = ACTIONS(3300),
    [anon_sym_readpipe] = ACTIONS(3300),
    [anon_sym_rewinddir] = ACTIONS(3300),
    [anon_sym_readlink] = ACTIONS(3300),
    [anon_sym_ref] = ACTIONS(3300),
    [anon_sym_scalar] = ACTIONS(3300),
    [anon_sym_shift] = ACTIONS(3300),
    [anon_sym_sin] = ACTIONS(3300),
    [anon_sym_sleep] = ACTIONS(3300),
    [anon_sym_sqrt] = ACTIONS(3300),
    [anon_sym_srand] = ACTIONS(3300),
    [anon_sym_stat] = ACTIONS(3300),
    [anon_sym_study] = ACTIONS(3300),
    [anon_sym_tell] = ACTIONS(3300),
    [anon_sym_telldir] = ACTIONS(3300),
    [anon_sym_tied] = ACTIONS(3300),
    [anon_sym_uc] = ACTIONS(3300),
    [anon_sym_ucfirst] = ACTIONS(3300),
    [anon_sym_untie] = ACTIONS(3300),
    [anon_sym_umask] = ACTIONS(3300),
    [anon_sym_values] = ACTIONS(3300),
    [anon_sym_write] = ACTIONS(3300),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3300),
    [anon_sym___END__] = ACTIONS(3300),
    [anon_sym_q] = ACTIONS(3300),
    [anon_sym_qq] = ACTIONS(3300),
    [anon_sym_qw] = ACTIONS(3300),
    [anon_sym_qx] = ACTIONS(3300),
    [anon_sym_qr] = ACTIONS(3300),
    [anon_sym_m] = ACTIONS(3300),
    [anon_sym_s] = ACTIONS(3300),
    [anon_sym_tr] = ACTIONS(3300),
    [anon_sym_y] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_unless] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_until] = ACTIONS(3300),
    [aux_sym__bareword_token1] = ACTIONS(3300),
    [sym_number] = ACTIONS(3300),
    [sym__apostrophe] = ACTIONS(3298),
    [sym__double_quote] = ACTIONS(3298),
    [sym__backtick] = ACTIONS(3298),
    [sym__search_slash] = ACTIONS(3298),
    [sym__PERLY_HEREDOC] = ACTIONS(3298),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1096] = {
    [sym_heredoc_content] = STATE(1096),
    [sym__identifier] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LBRACE2] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_package] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_sub] = ACTIONS(3285),
    [anon_sym_method] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_my] = ACTIONS(3285),
    [anon_sym_state] = ACTIONS(3285),
    [anon_sym_our] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_defer] = ACTIONS(3285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_elsif] = ACTIONS(3285),
    [anon_sym_and] = ACTIONS(3285),
    [anon_sym_or] = ACTIONS(3285),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_LT_LT] = ACTIONS(3285),
    [anon_sym_SLASH_SLASH] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_eq] = ACTIONS(3285),
    [anon_sym_ne] = ACTIONS(3285),
    [anon_sym_cmp] = ACTIONS(3285),
    [anon_sym_lt] = ACTIONS(3285),
    [anon_sym_le] = ACTIONS(3285),
    [anon_sym_ge] = ACTIONS(3285),
    [anon_sym_gt] = ACTIONS(3285),
    [anon_sym_isa] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_BSLASH] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_eval] = ACTIONS(3285),
    [anon_sym_field] = ACTIONS(3285),
    [anon_sym_local] = ACTIONS(3285),
    [anon_sym_require] = ACTIONS(3285),
    [anon_sym_map] = ACTIONS(3285),
    [anon_sym_grep] = ACTIONS(3285),
    [anon_sym_sort] = ACTIONS(3285),
    [anon_sym_goto] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_undef] = ACTIONS(3285),
    [anon_sym_PERCENT2] = ACTIONS(3285),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_no] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_foreach] = ACTIONS(3285),
    [anon_sym_last] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3285),
    [anon_sym_redo] = ACTIONS(3285),
    [anon_sym_BEGIN] = ACTIONS(3285),
    [anon_sym_INIT] = ACTIONS(3285),
    [anon_sym_CHECK] = ACTIONS(3285),
    [anon_sym_UNITCHECK] = ACTIONS(3285),
    [anon_sym_END] = ACTIONS(3285),
    [anon_sym_ADJUST] = ACTIONS(3285),
    [anon_sym___FILE__] = ACTIONS(3285),
    [anon_sym___LINE__] = ACTIONS(3285),
    [anon_sym___PACKAGE__] = ACTIONS(3285),
    [anon_sym___SUB__] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_fork] = ACTIONS(3285),
    [anon_sym_getppid] = ACTIONS(3285),
    [anon_sym_time] = ACTIONS(3285),
    [anon_sym_times] = ACTIONS(3285),
    [anon_sym_wait] = ACTIONS(3285),
    [anon_sym_wantarray] = ACTIONS(3285),
    [anon_sym_abs] = ACTIONS(3285),
    [anon_sym_alarm] = ACTIONS(3285),
    [anon_sym_chop] = ACTIONS(3285),
    [anon_sym_chdir] = ACTIONS(3285),
    [anon_sym_close] = ACTIONS(3285),
    [anon_sym_closedir] = ACTIONS(3285),
    [anon_sym_caller] = ACTIONS(3285),
    [anon_sym_chomp] = ACTIONS(3285),
    [anon_sym_chr] = ACTIONS(3285),
    [anon_sym_cos] = ACTIONS(3285),
    [anon_sym_chroot] = ACTIONS(3285),
    [anon_sym_defined] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_dbmclose] = ACTIONS(3285),
    [anon_sym_exists] = ACTIONS(3285),
    [anon_sym_exit] = ACTIONS(3285),
    [anon_sym_eof] = ACTIONS(3285),
    [anon_sym_exp] = ACTIONS(3285),
    [anon_sym_each] = ACTIONS(3285),
    [anon_sym_fc] = ACTIONS(3285),
    [anon_sym_fileno] = ACTIONS(3285),
    [anon_sym_gmtime] = ACTIONS(3285),
    [anon_sym_getc] = ACTIONS(3285),
    [anon_sym_getpgrp] = ACTIONS(3285),
    [anon_sym_getprotobyname] = ACTIONS(3285),
    [anon_sym_getpwname] = ACTIONS(3285),
    [anon_sym_getpwuid] = ACTIONS(3285),
    [anon_sym_getpeername] = ACTIONS(3285),
    [anon_sym_getnetbyname] = ACTIONS(3285),
    [anon_sym_getsockname] = ACTIONS(3285),
    [anon_sym_getgrnam] = ACTIONS(3285),
    [anon_sym_getgrgid] = ACTIONS(3285),
    [anon_sym_hex] = ACTIONS(3285),
    [anon_sym_int] = ACTIONS(3285),
    [anon_sym_keys] = ACTIONS(3285),
    [anon_sym_lc] = ACTIONS(3285),
    [anon_sym_lcfirst] = ACTIONS(3285),
    [anon_sym_length] = ACTIONS(3285),
    [anon_sym_localtime] = ACTIONS(3285),
    [anon_sym_log] = ACTIONS(3285),
    [anon_sym_lock] = ACTIONS(3285),
    [anon_sym_lstat] = ACTIONS(3285),
    [anon_sym_oct] = ACTIONS(3285),
    [anon_sym_ord] = ACTIONS(3285),
    [anon_sym_prototype] = ACTIONS(3285),
    [anon_sym_pop] = ACTIONS(3285),
    [anon_sym_pos] = ACTIONS(3285),
    [anon_sym_quotemeta] = ACTIONS(3285),
    [anon_sym_reset] = ACTIONS(3285),
    [anon_sym_rand] = ACTIONS(3285),
    [anon_sym_rmdir] = ACTIONS(3285),
    [anon_sym_readdir] = ACTIONS(3285),
    [anon_sym_readline] = ACTIONS(3285),
    [anon_sym_readpipe] = ACTIONS(3285),
    [anon_sym_rewinddir] = ACTIONS(3285),
    [anon_sym_readlink] = ACTIONS(3285),
    [anon_sym_ref] = ACTIONS(3285),
    [anon_sym_scalar] = ACTIONS(3285),
    [anon_sym_shift] = ACTIONS(3285),
    [anon_sym_sin] = ACTIONS(3285),
    [anon_sym_sleep] = ACTIONS(3285),
    [anon_sym_sqrt] = ACTIONS(3285),
    [anon_sym_srand] = ACTIONS(3285),
    [anon_sym_stat] = ACTIONS(3285),
    [anon_sym_study] = ACTIONS(3285),
    [anon_sym_tell] = ACTIONS(3285),
    [anon_sym_telldir] = ACTIONS(3285),
    [anon_sym_tied] = ACTIONS(3285),
    [anon_sym_uc] = ACTIONS(3285),
    [anon_sym_ucfirst] = ACTIONS(3285),
    [anon_sym_untie] = ACTIONS(3285),
    [anon_sym_umask] = ACTIONS(3285),
    [anon_sym_values] = ACTIONS(3285),
    [anon_sym_write] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3285),
    [anon_sym___END__] = ACTIONS(3285),
    [anon_sym_q] = ACTIONS(3285),
    [anon_sym_qq] = ACTIONS(3285),
    [anon_sym_qw] = ACTIONS(3285),
    [anon_sym_qx] = ACTIONS(3285),
    [anon_sym_qr] = ACTIONS(3285),
    [anon_sym_m] = ACTIONS(3285),
    [anon_sym_s] = ACTIONS(3285),
    [anon_sym_tr] = ACTIONS(3285),
    [anon_sym_y] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_unless] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_until] = ACTIONS(3285),
    [aux_sym__bareword_token1] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym__apostrophe] = ACTIONS(3283),
    [sym__double_quote] = ACTIONS(3283),
    [sym__backtick] = ACTIONS(3283),
    [sym__search_slash] = ACTIONS(3283),
    [sym__PERLY_HEREDOC] = ACTIONS(3283),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1097] = {
    [sym_heredoc_content] = STATE(1097),
    [sym__identifier] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_LBRACE2] = ACTIONS(3331),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_package] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_sub] = ACTIONS(3331),
    [anon_sym_method] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_my] = ACTIONS(3331),
    [anon_sym_state] = ACTIONS(3331),
    [anon_sym_our] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_defer] = ACTIONS(3331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_elsif] = ACTIONS(3331),
    [anon_sym_and] = ACTIONS(3331),
    [anon_sym_or] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_AT] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_LT_LT] = ACTIONS(3331),
    [anon_sym_SLASH_SLASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3331),
    [anon_sym_eq] = ACTIONS(3331),
    [anon_sym_ne] = ACTIONS(3331),
    [anon_sym_cmp] = ACTIONS(3331),
    [anon_sym_lt] = ACTIONS(3331),
    [anon_sym_le] = ACTIONS(3331),
    [anon_sym_ge] = ACTIONS(3331),
    [anon_sym_gt] = ACTIONS(3331),
    [anon_sym_isa] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [anon_sym_BSLASH] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_eval] = ACTIONS(3331),
    [anon_sym_field] = ACTIONS(3331),
    [anon_sym_local] = ACTIONS(3331),
    [anon_sym_require] = ACTIONS(3331),
    [anon_sym_map] = ACTIONS(3331),
    [anon_sym_grep] = ACTIONS(3331),
    [anon_sym_sort] = ACTIONS(3331),
    [anon_sym_goto] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_undef] = ACTIONS(3331),
    [anon_sym_PERCENT2] = ACTIONS(3331),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3331),
    [anon_sym_use] = ACTIONS(3331),
    [anon_sym_no] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_foreach] = ACTIONS(3331),
    [anon_sym_last] = ACTIONS(3331),
    [anon_sym_next] = ACTIONS(3331),
    [anon_sym_redo] = ACTIONS(3331),
    [anon_sym_BEGIN] = ACTIONS(3331),
    [anon_sym_INIT] = ACTIONS(3331),
    [anon_sym_CHECK] = ACTIONS(3331),
    [anon_sym_UNITCHECK] = ACTIONS(3331),
    [anon_sym_END] = ACTIONS(3331),
    [anon_sym_ADJUST] = ACTIONS(3331),
    [anon_sym___FILE__] = ACTIONS(3331),
    [anon_sym___LINE__] = ACTIONS(3331),
    [anon_sym___PACKAGE__] = ACTIONS(3331),
    [anon_sym___SUB__] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_fork] = ACTIONS(3331),
    [anon_sym_getppid] = ACTIONS(3331),
    [anon_sym_time] = ACTIONS(3331),
    [anon_sym_times] = ACTIONS(3331),
    [anon_sym_wait] = ACTIONS(3331),
    [anon_sym_wantarray] = ACTIONS(3331),
    [anon_sym_abs] = ACTIONS(3331),
    [anon_sym_alarm] = ACTIONS(3331),
    [anon_sym_chop] = ACTIONS(3331),
    [anon_sym_chdir] = ACTIONS(3331),
    [anon_sym_close] = ACTIONS(3331),
    [anon_sym_closedir] = ACTIONS(3331),
    [anon_sym_caller] = ACTIONS(3331),
    [anon_sym_chomp] = ACTIONS(3331),
    [anon_sym_chr] = ACTIONS(3331),
    [anon_sym_cos] = ACTIONS(3331),
    [anon_sym_chroot] = ACTIONS(3331),
    [anon_sym_defined] = ACTIONS(3331),
    [anon_sym_delete] = ACTIONS(3331),
    [anon_sym_dbmclose] = ACTIONS(3331),
    [anon_sym_exists] = ACTIONS(3331),
    [anon_sym_exit] = ACTIONS(3331),
    [anon_sym_eof] = ACTIONS(3331),
    [anon_sym_exp] = ACTIONS(3331),
    [anon_sym_each] = ACTIONS(3331),
    [anon_sym_fc] = ACTIONS(3331),
    [anon_sym_fileno] = ACTIONS(3331),
    [anon_sym_gmtime] = ACTIONS(3331),
    [anon_sym_getc] = ACTIONS(3331),
    [anon_sym_getpgrp] = ACTIONS(3331),
    [anon_sym_getprotobyname] = ACTIONS(3331),
    [anon_sym_getpwname] = ACTIONS(3331),
    [anon_sym_getpwuid] = ACTIONS(3331),
    [anon_sym_getpeername] = ACTIONS(3331),
    [anon_sym_getnetbyname] = ACTIONS(3331),
    [anon_sym_getsockname] = ACTIONS(3331),
    [anon_sym_getgrnam] = ACTIONS(3331),
    [anon_sym_getgrgid] = ACTIONS(3331),
    [anon_sym_hex] = ACTIONS(3331),
    [anon_sym_int] = ACTIONS(3331),
    [anon_sym_keys] = ACTIONS(3331),
    [anon_sym_lc] = ACTIONS(3331),
    [anon_sym_lcfirst] = ACTIONS(3331),
    [anon_sym_length] = ACTIONS(3331),
    [anon_sym_localtime] = ACTIONS(3331),
    [anon_sym_log] = ACTIONS(3331),
    [anon_sym_lock] = ACTIONS(3331),
    [anon_sym_lstat] = ACTIONS(3331),
    [anon_sym_oct] = ACTIONS(3331),
    [anon_sym_ord] = ACTIONS(3331),
    [anon_sym_prototype] = ACTIONS(3331),
    [anon_sym_pop] = ACTIONS(3331),
    [anon_sym_pos] = ACTIONS(3331),
    [anon_sym_quotemeta] = ACTIONS(3331),
    [anon_sym_reset] = ACTIONS(3331),
    [anon_sym_rand] = ACTIONS(3331),
    [anon_sym_rmdir] = ACTIONS(3331),
    [anon_sym_readdir] = ACTIONS(3331),
    [anon_sym_readline] = ACTIONS(3331),
    [anon_sym_readpipe] = ACTIONS(3331),
    [anon_sym_rewinddir] = ACTIONS(3331),
    [anon_sym_readlink] = ACTIONS(3331),
    [anon_sym_ref] = ACTIONS(3331),
    [anon_sym_scalar] = ACTIONS(3331),
    [anon_sym_shift] = ACTIONS(3331),
    [anon_sym_sin] = ACTIONS(3331),
    [anon_sym_sleep] = ACTIONS(3331),
    [anon_sym_sqrt] = ACTIONS(3331),
    [anon_sym_srand] = ACTIONS(3331),
    [anon_sym_stat] = ACTIONS(3331),
    [anon_sym_study] = ACTIONS(3331),
    [anon_sym_tell] = ACTIONS(3331),
    [anon_sym_telldir] = ACTIONS(3331),
    [anon_sym_tied] = ACTIONS(3331),
    [anon_sym_uc] = ACTIONS(3331),
    [anon_sym_ucfirst] = ACTIONS(3331),
    [anon_sym_untie] = ACTIONS(3331),
    [anon_sym_umask] = ACTIONS(3331),
    [anon_sym_values] = ACTIONS(3331),
    [anon_sym_write] = ACTIONS(3331),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3331),
    [anon_sym___END__] = ACTIONS(3331),
    [anon_sym_q] = ACTIONS(3331),
    [anon_sym_qq] = ACTIONS(3331),
    [anon_sym_qw] = ACTIONS(3331),
    [anon_sym_qx] = ACTIONS(3331),
    [anon_sym_qr] = ACTIONS(3331),
    [anon_sym_m] = ACTIONS(3331),
    [anon_sym_s] = ACTIONS(3331),
    [anon_sym_tr] = ACTIONS(3331),
    [anon_sym_y] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_unless] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_until] = ACTIONS(3331),
    [aux_sym__bareword_token1] = ACTIONS(3331),
    [sym_number] = ACTIONS(3331),
    [sym__apostrophe] = ACTIONS(3329),
    [sym__double_quote] = ACTIONS(3329),
    [sym__backtick] = ACTIONS(3329),
    [sym__search_slash] = ACTIONS(3329),
    [sym__PERLY_HEREDOC] = ACTIONS(3329),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1098] = {
    [sym_heredoc_content] = STATE(1098),
    [sym__identifier] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LBRACE2] = ACTIONS(3181),
    [anon_sym_RBRACE] = ACTIONS(3181),
    [anon_sym_SEMI] = ACTIONS(3181),
    [anon_sym_package] = ACTIONS(3181),
    [anon_sym_class] = ACTIONS(3181),
    [anon_sym_sub] = ACTIONS(3181),
    [anon_sym_method] = ACTIONS(3181),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_continue] = ACTIONS(3181),
    [anon_sym_my] = ACTIONS(3181),
    [anon_sym_state] = ACTIONS(3181),
    [anon_sym_our] = ACTIONS(3181),
    [anon_sym_try] = ACTIONS(3181),
    [anon_sym_defer] = ACTIONS(3181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3181),
    [anon_sym_else] = ACTIONS(3181),
    [anon_sym_elsif] = ACTIONS(3181),
    [anon_sym_and] = ACTIONS(3181),
    [anon_sym_or] = ACTIONS(3181),
    [anon_sym_DOLLAR] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(3181),
    [anon_sym_LT_LT] = ACTIONS(3181),
    [anon_sym_SLASH_SLASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(3181),
    [anon_sym_eq] = ACTIONS(3181),
    [anon_sym_ne] = ACTIONS(3181),
    [anon_sym_cmp] = ACTIONS(3181),
    [anon_sym_lt] = ACTIONS(3181),
    [anon_sym_le] = ACTIONS(3181),
    [anon_sym_ge] = ACTIONS(3181),
    [anon_sym_gt] = ACTIONS(3181),
    [anon_sym_isa] = ACTIONS(3181),
    [anon_sym_TILDE] = ACTIONS(3181),
    [anon_sym_BANG] = ACTIONS(3181),
    [anon_sym_PLUS_PLUS] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(3181),
    [anon_sym_BSLASH] = ACTIONS(3179),
    [anon_sym_do] = ACTIONS(3181),
    [anon_sym_eval] = ACTIONS(3181),
    [anon_sym_field] = ACTIONS(3181),
    [anon_sym_local] = ACTIONS(3181),
    [anon_sym_require] = ACTIONS(3181),
    [anon_sym_map] = ACTIONS(3181),
    [anon_sym_grep] = ACTIONS(3181),
    [anon_sym_sort] = ACTIONS(3181),
    [anon_sym_goto] = ACTIONS(3181),
    [anon_sym_return] = ACTIONS(3181),
    [anon_sym_undef] = ACTIONS(3181),
    [anon_sym_PERCENT2] = ACTIONS(3181),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3181),
    [anon_sym_use] = ACTIONS(3181),
    [anon_sym_no] = ACTIONS(3181),
    [anon_sym_for] = ACTIONS(3181),
    [anon_sym_foreach] = ACTIONS(3181),
    [anon_sym_last] = ACTIONS(3181),
    [anon_sym_next] = ACTIONS(3181),
    [anon_sym_redo] = ACTIONS(3181),
    [anon_sym_BEGIN] = ACTIONS(3181),
    [anon_sym_INIT] = ACTIONS(3181),
    [anon_sym_CHECK] = ACTIONS(3181),
    [anon_sym_UNITCHECK] = ACTIONS(3181),
    [anon_sym_END] = ACTIONS(3181),
    [anon_sym_ADJUST] = ACTIONS(3181),
    [anon_sym___FILE__] = ACTIONS(3181),
    [anon_sym___LINE__] = ACTIONS(3181),
    [anon_sym___PACKAGE__] = ACTIONS(3181),
    [anon_sym___SUB__] = ACTIONS(3181),
    [anon_sym_break] = ACTIONS(3181),
    [anon_sym_fork] = ACTIONS(3181),
    [anon_sym_getppid] = ACTIONS(3181),
    [anon_sym_time] = ACTIONS(3181),
    [anon_sym_times] = ACTIONS(3181),
    [anon_sym_wait] = ACTIONS(3181),
    [anon_sym_wantarray] = ACTIONS(3181),
    [anon_sym_abs] = ACTIONS(3181),
    [anon_sym_alarm] = ACTIONS(3181),
    [anon_sym_chop] = ACTIONS(3181),
    [anon_sym_chdir] = ACTIONS(3181),
    [anon_sym_close] = ACTIONS(3181),
    [anon_sym_closedir] = ACTIONS(3181),
    [anon_sym_caller] = ACTIONS(3181),
    [anon_sym_chomp] = ACTIONS(3181),
    [anon_sym_chr] = ACTIONS(3181),
    [anon_sym_cos] = ACTIONS(3181),
    [anon_sym_chroot] = ACTIONS(3181),
    [anon_sym_defined] = ACTIONS(3181),
    [anon_sym_delete] = ACTIONS(3181),
    [anon_sym_dbmclose] = ACTIONS(3181),
    [anon_sym_exists] = ACTIONS(3181),
    [anon_sym_exit] = ACTIONS(3181),
    [anon_sym_eof] = ACTIONS(3181),
    [anon_sym_exp] = ACTIONS(3181),
    [anon_sym_each] = ACTIONS(3181),
    [anon_sym_fc] = ACTIONS(3181),
    [anon_sym_fileno] = ACTIONS(3181),
    [anon_sym_gmtime] = ACTIONS(3181),
    [anon_sym_getc] = ACTIONS(3181),
    [anon_sym_getpgrp] = ACTIONS(3181),
    [anon_sym_getprotobyname] = ACTIONS(3181),
    [anon_sym_getpwname] = ACTIONS(3181),
    [anon_sym_getpwuid] = ACTIONS(3181),
    [anon_sym_getpeername] = ACTIONS(3181),
    [anon_sym_getnetbyname] = ACTIONS(3181),
    [anon_sym_getsockname] = ACTIONS(3181),
    [anon_sym_getgrnam] = ACTIONS(3181),
    [anon_sym_getgrgid] = ACTIONS(3181),
    [anon_sym_hex] = ACTIONS(3181),
    [anon_sym_int] = ACTIONS(3181),
    [anon_sym_keys] = ACTIONS(3181),
    [anon_sym_lc] = ACTIONS(3181),
    [anon_sym_lcfirst] = ACTIONS(3181),
    [anon_sym_length] = ACTIONS(3181),
    [anon_sym_localtime] = ACTIONS(3181),
    [anon_sym_log] = ACTIONS(3181),
    [anon_sym_lock] = ACTIONS(3181),
    [anon_sym_lstat] = ACTIONS(3181),
    [anon_sym_oct] = ACTIONS(3181),
    [anon_sym_ord] = ACTIONS(3181),
    [anon_sym_prototype] = ACTIONS(3181),
    [anon_sym_pop] = ACTIONS(3181),
    [anon_sym_pos] = ACTIONS(3181),
    [anon_sym_quotemeta] = ACTIONS(3181),
    [anon_sym_reset] = ACTIONS(3181),
    [anon_sym_rand] = ACTIONS(3181),
    [anon_sym_rmdir] = ACTIONS(3181),
    [anon_sym_readdir] = ACTIONS(3181),
    [anon_sym_readline] = ACTIONS(3181),
    [anon_sym_readpipe] = ACTIONS(3181),
    [anon_sym_rewinddir] = ACTIONS(3181),
    [anon_sym_readlink] = ACTIONS(3181),
    [anon_sym_ref] = ACTIONS(3181),
    [anon_sym_scalar] = ACTIONS(3181),
    [anon_sym_shift] = ACTIONS(3181),
    [anon_sym_sin] = ACTIONS(3181),
    [anon_sym_sleep] = ACTIONS(3181),
    [anon_sym_sqrt] = ACTIONS(3181),
    [anon_sym_srand] = ACTIONS(3181),
    [anon_sym_stat] = ACTIONS(3181),
    [anon_sym_study] = ACTIONS(3181),
    [anon_sym_tell] = ACTIONS(3181),
    [anon_sym_telldir] = ACTIONS(3181),
    [anon_sym_tied] = ACTIONS(3181),
    [anon_sym_uc] = ACTIONS(3181),
    [anon_sym_ucfirst] = ACTIONS(3181),
    [anon_sym_untie] = ACTIONS(3181),
    [anon_sym_umask] = ACTIONS(3181),
    [anon_sym_values] = ACTIONS(3181),
    [anon_sym_write] = ACTIONS(3181),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3181),
    [anon_sym___END__] = ACTIONS(3181),
    [anon_sym_q] = ACTIONS(3181),
    [anon_sym_qq] = ACTIONS(3181),
    [anon_sym_qw] = ACTIONS(3181),
    [anon_sym_qx] = ACTIONS(3181),
    [anon_sym_qr] = ACTIONS(3181),
    [anon_sym_m] = ACTIONS(3181),
    [anon_sym_s] = ACTIONS(3181),
    [anon_sym_tr] = ACTIONS(3181),
    [anon_sym_y] = ACTIONS(3181),
    [anon_sym_if] = ACTIONS(3181),
    [anon_sym_unless] = ACTIONS(3181),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_until] = ACTIONS(3181),
    [aux_sym__bareword_token1] = ACTIONS(3181),
    [sym_number] = ACTIONS(3181),
    [sym__apostrophe] = ACTIONS(3179),
    [sym__double_quote] = ACTIONS(3179),
    [sym__backtick] = ACTIONS(3179),
    [sym__search_slash] = ACTIONS(3179),
    [sym__PERLY_HEREDOC] = ACTIONS(3179),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1099] = {
    [sym_heredoc_content] = STATE(1099),
    [sym__identifier] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_LBRACE2] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_package] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_sub] = ACTIONS(3048),
    [anon_sym_method] = ACTIONS(3048),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_my] = ACTIONS(3048),
    [anon_sym_state] = ACTIONS(3048),
    [anon_sym_our] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_defer] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3048),
    [anon_sym_else] = ACTIONS(3048),
    [anon_sym_elsif] = ACTIONS(3048),
    [anon_sym_and] = ACTIONS(3048),
    [anon_sym_or] = ACTIONS(3048),
    [anon_sym_DOLLAR] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_AT] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_SLASH_SLASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_eq] = ACTIONS(3048),
    [anon_sym_ne] = ACTIONS(3048),
    [anon_sym_cmp] = ACTIONS(3048),
    [anon_sym_lt] = ACTIONS(3048),
    [anon_sym_le] = ACTIONS(3048),
    [anon_sym_ge] = ACTIONS(3048),
    [anon_sym_gt] = ACTIONS(3048),
    [anon_sym_isa] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_BSLASH] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_eval] = ACTIONS(3048),
    [anon_sym_field] = ACTIONS(3048),
    [anon_sym_local] = ACTIONS(3048),
    [anon_sym_require] = ACTIONS(3048),
    [anon_sym_map] = ACTIONS(3048),
    [anon_sym_grep] = ACTIONS(3048),
    [anon_sym_sort] = ACTIONS(3048),
    [anon_sym_goto] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_undef] = ACTIONS(3048),
    [anon_sym_PERCENT2] = ACTIONS(3048),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3048),
    [anon_sym_use] = ACTIONS(3048),
    [anon_sym_no] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_foreach] = ACTIONS(3048),
    [anon_sym_last] = ACTIONS(3048),
    [anon_sym_next] = ACTIONS(3048),
    [anon_sym_redo] = ACTIONS(3048),
    [anon_sym_BEGIN] = ACTIONS(3048),
    [anon_sym_INIT] = ACTIONS(3048),
    [anon_sym_CHECK] = ACTIONS(3048),
    [anon_sym_UNITCHECK] = ACTIONS(3048),
    [anon_sym_END] = ACTIONS(3048),
    [anon_sym_ADJUST] = ACTIONS(3048),
    [anon_sym___FILE__] = ACTIONS(3048),
    [anon_sym___LINE__] = ACTIONS(3048),
    [anon_sym___PACKAGE__] = ACTIONS(3048),
    [anon_sym___SUB__] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_fork] = ACTIONS(3048),
    [anon_sym_getppid] = ACTIONS(3048),
    [anon_sym_time] = ACTIONS(3048),
    [anon_sym_times] = ACTIONS(3048),
    [anon_sym_wait] = ACTIONS(3048),
    [anon_sym_wantarray] = ACTIONS(3048),
    [anon_sym_abs] = ACTIONS(3048),
    [anon_sym_alarm] = ACTIONS(3048),
    [anon_sym_chop] = ACTIONS(3048),
    [anon_sym_chdir] = ACTIONS(3048),
    [anon_sym_close] = ACTIONS(3048),
    [anon_sym_closedir] = ACTIONS(3048),
    [anon_sym_caller] = ACTIONS(3048),
    [anon_sym_chomp] = ACTIONS(3048),
    [anon_sym_chr] = ACTIONS(3048),
    [anon_sym_cos] = ACTIONS(3048),
    [anon_sym_chroot] = ACTIONS(3048),
    [anon_sym_defined] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_dbmclose] = ACTIONS(3048),
    [anon_sym_exists] = ACTIONS(3048),
    [anon_sym_exit] = ACTIONS(3048),
    [anon_sym_eof] = ACTIONS(3048),
    [anon_sym_exp] = ACTIONS(3048),
    [anon_sym_each] = ACTIONS(3048),
    [anon_sym_fc] = ACTIONS(3048),
    [anon_sym_fileno] = ACTIONS(3048),
    [anon_sym_gmtime] = ACTIONS(3048),
    [anon_sym_getc] = ACTIONS(3048),
    [anon_sym_getpgrp] = ACTIONS(3048),
    [anon_sym_getprotobyname] = ACTIONS(3048),
    [anon_sym_getpwname] = ACTIONS(3048),
    [anon_sym_getpwuid] = ACTIONS(3048),
    [anon_sym_getpeername] = ACTIONS(3048),
    [anon_sym_getnetbyname] = ACTIONS(3048),
    [anon_sym_getsockname] = ACTIONS(3048),
    [anon_sym_getgrnam] = ACTIONS(3048),
    [anon_sym_getgrgid] = ACTIONS(3048),
    [anon_sym_hex] = ACTIONS(3048),
    [anon_sym_int] = ACTIONS(3048),
    [anon_sym_keys] = ACTIONS(3048),
    [anon_sym_lc] = ACTIONS(3048),
    [anon_sym_lcfirst] = ACTIONS(3048),
    [anon_sym_length] = ACTIONS(3048),
    [anon_sym_localtime] = ACTIONS(3048),
    [anon_sym_log] = ACTIONS(3048),
    [anon_sym_lock] = ACTIONS(3048),
    [anon_sym_lstat] = ACTIONS(3048),
    [anon_sym_oct] = ACTIONS(3048),
    [anon_sym_ord] = ACTIONS(3048),
    [anon_sym_prototype] = ACTIONS(3048),
    [anon_sym_pop] = ACTIONS(3048),
    [anon_sym_pos] = ACTIONS(3048),
    [anon_sym_quotemeta] = ACTIONS(3048),
    [anon_sym_reset] = ACTIONS(3048),
    [anon_sym_rand] = ACTIONS(3048),
    [anon_sym_rmdir] = ACTIONS(3048),
    [anon_sym_readdir] = ACTIONS(3048),
    [anon_sym_readline] = ACTIONS(3048),
    [anon_sym_readpipe] = ACTIONS(3048),
    [anon_sym_rewinddir] = ACTIONS(3048),
    [anon_sym_readlink] = ACTIONS(3048),
    [anon_sym_ref] = ACTIONS(3048),
    [anon_sym_scalar] = ACTIONS(3048),
    [anon_sym_shift] = ACTIONS(3048),
    [anon_sym_sin] = ACTIONS(3048),
    [anon_sym_sleep] = ACTIONS(3048),
    [anon_sym_sqrt] = ACTIONS(3048),
    [anon_sym_srand] = ACTIONS(3048),
    [anon_sym_stat] = ACTIONS(3048),
    [anon_sym_study] = ACTIONS(3048),
    [anon_sym_tell] = ACTIONS(3048),
    [anon_sym_telldir] = ACTIONS(3048),
    [anon_sym_tied] = ACTIONS(3048),
    [anon_sym_uc] = ACTIONS(3048),
    [anon_sym_ucfirst] = ACTIONS(3048),
    [anon_sym_untie] = ACTIONS(3048),
    [anon_sym_umask] = ACTIONS(3048),
    [anon_sym_values] = ACTIONS(3048),
    [anon_sym_write] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3048),
    [anon_sym___END__] = ACTIONS(3048),
    [anon_sym_q] = ACTIONS(3048),
    [anon_sym_qq] = ACTIONS(3048),
    [anon_sym_qw] = ACTIONS(3048),
    [anon_sym_qx] = ACTIONS(3048),
    [anon_sym_qr] = ACTIONS(3048),
    [anon_sym_m] = ACTIONS(3048),
    [anon_sym_s] = ACTIONS(3048),
    [anon_sym_tr] = ACTIONS(3048),
    [anon_sym_y] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_unless] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_until] = ACTIONS(3048),
    [aux_sym__bareword_token1] = ACTIONS(3048),
    [sym_number] = ACTIONS(3048),
    [sym__apostrophe] = ACTIONS(3046),
    [sym__double_quote] = ACTIONS(3046),
    [sym__backtick] = ACTIONS(3046),
    [sym__search_slash] = ACTIONS(3046),
    [sym__PERLY_HEREDOC] = ACTIONS(3046),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1100] = {
    [sym_heredoc_content] = STATE(1100),
    [sym__identifier] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_LBRACE2] = ACTIONS(3323),
    [anon_sym_RBRACE] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_package] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_sub] = ACTIONS(3323),
    [anon_sym_method] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_my] = ACTIONS(3323),
    [anon_sym_state] = ACTIONS(3323),
    [anon_sym_our] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_defer] = ACTIONS(3323),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_elsif] = ACTIONS(3323),
    [anon_sym_and] = ACTIONS(3323),
    [anon_sym_or] = ACTIONS(3323),
    [anon_sym_DOLLAR] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_AT] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_LT_LT] = ACTIONS(3323),
    [anon_sym_SLASH_SLASH] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3323),
    [anon_sym_eq] = ACTIONS(3323),
    [anon_sym_ne] = ACTIONS(3323),
    [anon_sym_cmp] = ACTIONS(3323),
    [anon_sym_lt] = ACTIONS(3323),
    [anon_sym_le] = ACTIONS(3323),
    [anon_sym_ge] = ACTIONS(3323),
    [anon_sym_gt] = ACTIONS(3323),
    [anon_sym_isa] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [anon_sym_BSLASH] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_eval] = ACTIONS(3323),
    [anon_sym_field] = ACTIONS(3323),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_require] = ACTIONS(3323),
    [anon_sym_map] = ACTIONS(3323),
    [anon_sym_grep] = ACTIONS(3323),
    [anon_sym_sort] = ACTIONS(3323),
    [anon_sym_goto] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_undef] = ACTIONS(3323),
    [anon_sym_PERCENT2] = ACTIONS(3323),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3323),
    [anon_sym_use] = ACTIONS(3323),
    [anon_sym_no] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_foreach] = ACTIONS(3323),
    [anon_sym_last] = ACTIONS(3323),
    [anon_sym_next] = ACTIONS(3323),
    [anon_sym_redo] = ACTIONS(3323),
    [anon_sym_BEGIN] = ACTIONS(3323),
    [anon_sym_INIT] = ACTIONS(3323),
    [anon_sym_CHECK] = ACTIONS(3323),
    [anon_sym_UNITCHECK] = ACTIONS(3323),
    [anon_sym_END] = ACTIONS(3323),
    [anon_sym_ADJUST] = ACTIONS(3323),
    [anon_sym___FILE__] = ACTIONS(3323),
    [anon_sym___LINE__] = ACTIONS(3323),
    [anon_sym___PACKAGE__] = ACTIONS(3323),
    [anon_sym___SUB__] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_fork] = ACTIONS(3323),
    [anon_sym_getppid] = ACTIONS(3323),
    [anon_sym_time] = ACTIONS(3323),
    [anon_sym_times] = ACTIONS(3323),
    [anon_sym_wait] = ACTIONS(3323),
    [anon_sym_wantarray] = ACTIONS(3323),
    [anon_sym_abs] = ACTIONS(3323),
    [anon_sym_alarm] = ACTIONS(3323),
    [anon_sym_chop] = ACTIONS(3323),
    [anon_sym_chdir] = ACTIONS(3323),
    [anon_sym_close] = ACTIONS(3323),
    [anon_sym_closedir] = ACTIONS(3323),
    [anon_sym_caller] = ACTIONS(3323),
    [anon_sym_chomp] = ACTIONS(3323),
    [anon_sym_chr] = ACTIONS(3323),
    [anon_sym_cos] = ACTIONS(3323),
    [anon_sym_chroot] = ACTIONS(3323),
    [anon_sym_defined] = ACTIONS(3323),
    [anon_sym_delete] = ACTIONS(3323),
    [anon_sym_dbmclose] = ACTIONS(3323),
    [anon_sym_exists] = ACTIONS(3323),
    [anon_sym_exit] = ACTIONS(3323),
    [anon_sym_eof] = ACTIONS(3323),
    [anon_sym_exp] = ACTIONS(3323),
    [anon_sym_each] = ACTIONS(3323),
    [anon_sym_fc] = ACTIONS(3323),
    [anon_sym_fileno] = ACTIONS(3323),
    [anon_sym_gmtime] = ACTIONS(3323),
    [anon_sym_getc] = ACTIONS(3323),
    [anon_sym_getpgrp] = ACTIONS(3323),
    [anon_sym_getprotobyname] = ACTIONS(3323),
    [anon_sym_getpwname] = ACTIONS(3323),
    [anon_sym_getpwuid] = ACTIONS(3323),
    [anon_sym_getpeername] = ACTIONS(3323),
    [anon_sym_getnetbyname] = ACTIONS(3323),
    [anon_sym_getsockname] = ACTIONS(3323),
    [anon_sym_getgrnam] = ACTIONS(3323),
    [anon_sym_getgrgid] = ACTIONS(3323),
    [anon_sym_hex] = ACTIONS(3323),
    [anon_sym_int] = ACTIONS(3323),
    [anon_sym_keys] = ACTIONS(3323),
    [anon_sym_lc] = ACTIONS(3323),
    [anon_sym_lcfirst] = ACTIONS(3323),
    [anon_sym_length] = ACTIONS(3323),
    [anon_sym_localtime] = ACTIONS(3323),
    [anon_sym_log] = ACTIONS(3323),
    [anon_sym_lock] = ACTIONS(3323),
    [anon_sym_lstat] = ACTIONS(3323),
    [anon_sym_oct] = ACTIONS(3323),
    [anon_sym_ord] = ACTIONS(3323),
    [anon_sym_prototype] = ACTIONS(3323),
    [anon_sym_pop] = ACTIONS(3323),
    [anon_sym_pos] = ACTIONS(3323),
    [anon_sym_quotemeta] = ACTIONS(3323),
    [anon_sym_reset] = ACTIONS(3323),
    [anon_sym_rand] = ACTIONS(3323),
    [anon_sym_rmdir] = ACTIONS(3323),
    [anon_sym_readdir] = ACTIONS(3323),
    [anon_sym_readline] = ACTIONS(3323),
    [anon_sym_readpipe] = ACTIONS(3323),
    [anon_sym_rewinddir] = ACTIONS(3323),
    [anon_sym_readlink] = ACTIONS(3323),
    [anon_sym_ref] = ACTIONS(3323),
    [anon_sym_scalar] = ACTIONS(3323),
    [anon_sym_shift] = ACTIONS(3323),
    [anon_sym_sin] = ACTIONS(3323),
    [anon_sym_sleep] = ACTIONS(3323),
    [anon_sym_sqrt] = ACTIONS(3323),
    [anon_sym_srand] = ACTIONS(3323),
    [anon_sym_stat] = ACTIONS(3323),
    [anon_sym_study] = ACTIONS(3323),
    [anon_sym_tell] = ACTIONS(3323),
    [anon_sym_telldir] = ACTIONS(3323),
    [anon_sym_tied] = ACTIONS(3323),
    [anon_sym_uc] = ACTIONS(3323),
    [anon_sym_ucfirst] = ACTIONS(3323),
    [anon_sym_untie] = ACTIONS(3323),
    [anon_sym_umask] = ACTIONS(3323),
    [anon_sym_values] = ACTIONS(3323),
    [anon_sym_write] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3323),
    [anon_sym___END__] = ACTIONS(3323),
    [anon_sym_q] = ACTIONS(3323),
    [anon_sym_qq] = ACTIONS(3323),
    [anon_sym_qw] = ACTIONS(3323),
    [anon_sym_qx] = ACTIONS(3323),
    [anon_sym_qr] = ACTIONS(3323),
    [anon_sym_m] = ACTIONS(3323),
    [anon_sym_s] = ACTIONS(3323),
    [anon_sym_tr] = ACTIONS(3323),
    [anon_sym_y] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_unless] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_until] = ACTIONS(3323),
    [aux_sym__bareword_token1] = ACTIONS(3323),
    [sym_number] = ACTIONS(3323),
    [sym__apostrophe] = ACTIONS(3321),
    [sym__double_quote] = ACTIONS(3321),
    [sym__backtick] = ACTIONS(3321),
    [sym__search_slash] = ACTIONS(3321),
    [sym__PERLY_HEREDOC] = ACTIONS(3321),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1101] = {
    [sym_heredoc_content] = STATE(1101),
    [sym__identifier] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LBRACE2] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_package] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_sub] = ACTIONS(3281),
    [anon_sym_method] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_my] = ACTIONS(3281),
    [anon_sym_state] = ACTIONS(3281),
    [anon_sym_our] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_defer] = ACTIONS(3281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_elsif] = ACTIONS(3281),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_AT] = ACTIONS(3281),
    [anon_sym_LT] = ACTIONS(3281),
    [anon_sym_LT_LT] = ACTIONS(3281),
    [anon_sym_SLASH_SLASH] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_eq] = ACTIONS(3281),
    [anon_sym_ne] = ACTIONS(3281),
    [anon_sym_cmp] = ACTIONS(3281),
    [anon_sym_lt] = ACTIONS(3281),
    [anon_sym_le] = ACTIONS(3281),
    [anon_sym_ge] = ACTIONS(3281),
    [anon_sym_gt] = ACTIONS(3281),
    [anon_sym_isa] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_BSLASH] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_eval] = ACTIONS(3281),
    [anon_sym_field] = ACTIONS(3281),
    [anon_sym_local] = ACTIONS(3281),
    [anon_sym_require] = ACTIONS(3281),
    [anon_sym_map] = ACTIONS(3281),
    [anon_sym_grep] = ACTIONS(3281),
    [anon_sym_sort] = ACTIONS(3281),
    [anon_sym_goto] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_undef] = ACTIONS(3281),
    [anon_sym_PERCENT2] = ACTIONS(3281),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3281),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_no] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_foreach] = ACTIONS(3281),
    [anon_sym_last] = ACTIONS(3281),
    [anon_sym_next] = ACTIONS(3281),
    [anon_sym_redo] = ACTIONS(3281),
    [anon_sym_BEGIN] = ACTIONS(3281),
    [anon_sym_INIT] = ACTIONS(3281),
    [anon_sym_CHECK] = ACTIONS(3281),
    [anon_sym_UNITCHECK] = ACTIONS(3281),
    [anon_sym_END] = ACTIONS(3281),
    [anon_sym_ADJUST] = ACTIONS(3281),
    [anon_sym___FILE__] = ACTIONS(3281),
    [anon_sym___LINE__] = ACTIONS(3281),
    [anon_sym___PACKAGE__] = ACTIONS(3281),
    [anon_sym___SUB__] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_fork] = ACTIONS(3281),
    [anon_sym_getppid] = ACTIONS(3281),
    [anon_sym_time] = ACTIONS(3281),
    [anon_sym_times] = ACTIONS(3281),
    [anon_sym_wait] = ACTIONS(3281),
    [anon_sym_wantarray] = ACTIONS(3281),
    [anon_sym_abs] = ACTIONS(3281),
    [anon_sym_alarm] = ACTIONS(3281),
    [anon_sym_chop] = ACTIONS(3281),
    [anon_sym_chdir] = ACTIONS(3281),
    [anon_sym_close] = ACTIONS(3281),
    [anon_sym_closedir] = ACTIONS(3281),
    [anon_sym_caller] = ACTIONS(3281),
    [anon_sym_chomp] = ACTIONS(3281),
    [anon_sym_chr] = ACTIONS(3281),
    [anon_sym_cos] = ACTIONS(3281),
    [anon_sym_chroot] = ACTIONS(3281),
    [anon_sym_defined] = ACTIONS(3281),
    [anon_sym_delete] = ACTIONS(3281),
    [anon_sym_dbmclose] = ACTIONS(3281),
    [anon_sym_exists] = ACTIONS(3281),
    [anon_sym_exit] = ACTIONS(3281),
    [anon_sym_eof] = ACTIONS(3281),
    [anon_sym_exp] = ACTIONS(3281),
    [anon_sym_each] = ACTIONS(3281),
    [anon_sym_fc] = ACTIONS(3281),
    [anon_sym_fileno] = ACTIONS(3281),
    [anon_sym_gmtime] = ACTIONS(3281),
    [anon_sym_getc] = ACTIONS(3281),
    [anon_sym_getpgrp] = ACTIONS(3281),
    [anon_sym_getprotobyname] = ACTIONS(3281),
    [anon_sym_getpwname] = ACTIONS(3281),
    [anon_sym_getpwuid] = ACTIONS(3281),
    [anon_sym_getpeername] = ACTIONS(3281),
    [anon_sym_getnetbyname] = ACTIONS(3281),
    [anon_sym_getsockname] = ACTIONS(3281),
    [anon_sym_getgrnam] = ACTIONS(3281),
    [anon_sym_getgrgid] = ACTIONS(3281),
    [anon_sym_hex] = ACTIONS(3281),
    [anon_sym_int] = ACTIONS(3281),
    [anon_sym_keys] = ACTIONS(3281),
    [anon_sym_lc] = ACTIONS(3281),
    [anon_sym_lcfirst] = ACTIONS(3281),
    [anon_sym_length] = ACTIONS(3281),
    [anon_sym_localtime] = ACTIONS(3281),
    [anon_sym_log] = ACTIONS(3281),
    [anon_sym_lock] = ACTIONS(3281),
    [anon_sym_lstat] = ACTIONS(3281),
    [anon_sym_oct] = ACTIONS(3281),
    [anon_sym_ord] = ACTIONS(3281),
    [anon_sym_prototype] = ACTIONS(3281),
    [anon_sym_pop] = ACTIONS(3281),
    [anon_sym_pos] = ACTIONS(3281),
    [anon_sym_quotemeta] = ACTIONS(3281),
    [anon_sym_reset] = ACTIONS(3281),
    [anon_sym_rand] = ACTIONS(3281),
    [anon_sym_rmdir] = ACTIONS(3281),
    [anon_sym_readdir] = ACTIONS(3281),
    [anon_sym_readline] = ACTIONS(3281),
    [anon_sym_readpipe] = ACTIONS(3281),
    [anon_sym_rewinddir] = ACTIONS(3281),
    [anon_sym_readlink] = ACTIONS(3281),
    [anon_sym_ref] = ACTIONS(3281),
    [anon_sym_scalar] = ACTIONS(3281),
    [anon_sym_shift] = ACTIONS(3281),
    [anon_sym_sin] = ACTIONS(3281),
    [anon_sym_sleep] = ACTIONS(3281),
    [anon_sym_sqrt] = ACTIONS(3281),
    [anon_sym_srand] = ACTIONS(3281),
    [anon_sym_stat] = ACTIONS(3281),
    [anon_sym_study] = ACTIONS(3281),
    [anon_sym_tell] = ACTIONS(3281),
    [anon_sym_telldir] = ACTIONS(3281),
    [anon_sym_tied] = ACTIONS(3281),
    [anon_sym_uc] = ACTIONS(3281),
    [anon_sym_ucfirst] = ACTIONS(3281),
    [anon_sym_untie] = ACTIONS(3281),
    [anon_sym_umask] = ACTIONS(3281),
    [anon_sym_values] = ACTIONS(3281),
    [anon_sym_write] = ACTIONS(3281),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3281),
    [anon_sym___END__] = ACTIONS(3281),
    [anon_sym_q] = ACTIONS(3281),
    [anon_sym_qq] = ACTIONS(3281),
    [anon_sym_qw] = ACTIONS(3281),
    [anon_sym_qx] = ACTIONS(3281),
    [anon_sym_qr] = ACTIONS(3281),
    [anon_sym_m] = ACTIONS(3281),
    [anon_sym_s] = ACTIONS(3281),
    [anon_sym_tr] = ACTIONS(3281),
    [anon_sym_y] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [aux_sym__bareword_token1] = ACTIONS(3281),
    [sym_number] = ACTIONS(3281),
    [sym__apostrophe] = ACTIONS(3279),
    [sym__double_quote] = ACTIONS(3279),
    [sym__backtick] = ACTIONS(3279),
    [sym__search_slash] = ACTIONS(3279),
    [sym__PERLY_HEREDOC] = ACTIONS(3279),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1102] = {
    [sym_heredoc_content] = STATE(1102),
    [sym__identifier] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3335),
    [anon_sym_LBRACE2] = ACTIONS(3335),
    [anon_sym_RBRACE] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3335),
    [anon_sym_package] = ACTIONS(3335),
    [anon_sym_class] = ACTIONS(3335),
    [anon_sym_sub] = ACTIONS(3335),
    [anon_sym_method] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_my] = ACTIONS(3335),
    [anon_sym_state] = ACTIONS(3335),
    [anon_sym_our] = ACTIONS(3335),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_defer] = ACTIONS(3335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_elsif] = ACTIONS(3335),
    [anon_sym_and] = ACTIONS(3335),
    [anon_sym_or] = ACTIONS(3335),
    [anon_sym_DOLLAR] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3335),
    [anon_sym_AT] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3335),
    [anon_sym_LT_LT] = ACTIONS(3335),
    [anon_sym_SLASH_SLASH] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3335),
    [anon_sym_eq] = ACTIONS(3335),
    [anon_sym_ne] = ACTIONS(3335),
    [anon_sym_cmp] = ACTIONS(3335),
    [anon_sym_lt] = ACTIONS(3335),
    [anon_sym_le] = ACTIONS(3335),
    [anon_sym_ge] = ACTIONS(3335),
    [anon_sym_gt] = ACTIONS(3335),
    [anon_sym_isa] = ACTIONS(3335),
    [anon_sym_TILDE] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3335),
    [anon_sym_DASH_DASH] = ACTIONS(3335),
    [anon_sym_BSLASH] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_eval] = ACTIONS(3335),
    [anon_sym_field] = ACTIONS(3335),
    [anon_sym_local] = ACTIONS(3335),
    [anon_sym_require] = ACTIONS(3335),
    [anon_sym_map] = ACTIONS(3335),
    [anon_sym_grep] = ACTIONS(3335),
    [anon_sym_sort] = ACTIONS(3335),
    [anon_sym_goto] = ACTIONS(3335),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_undef] = ACTIONS(3335),
    [anon_sym_PERCENT2] = ACTIONS(3335),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3335),
    [anon_sym_use] = ACTIONS(3335),
    [anon_sym_no] = ACTIONS(3335),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_foreach] = ACTIONS(3335),
    [anon_sym_last] = ACTIONS(3335),
    [anon_sym_next] = ACTIONS(3335),
    [anon_sym_redo] = ACTIONS(3335),
    [anon_sym_BEGIN] = ACTIONS(3335),
    [anon_sym_INIT] = ACTIONS(3335),
    [anon_sym_CHECK] = ACTIONS(3335),
    [anon_sym_UNITCHECK] = ACTIONS(3335),
    [anon_sym_END] = ACTIONS(3335),
    [anon_sym_ADJUST] = ACTIONS(3335),
    [anon_sym___FILE__] = ACTIONS(3335),
    [anon_sym___LINE__] = ACTIONS(3335),
    [anon_sym___PACKAGE__] = ACTIONS(3335),
    [anon_sym___SUB__] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_fork] = ACTIONS(3335),
    [anon_sym_getppid] = ACTIONS(3335),
    [anon_sym_time] = ACTIONS(3335),
    [anon_sym_times] = ACTIONS(3335),
    [anon_sym_wait] = ACTIONS(3335),
    [anon_sym_wantarray] = ACTIONS(3335),
    [anon_sym_abs] = ACTIONS(3335),
    [anon_sym_alarm] = ACTIONS(3335),
    [anon_sym_chop] = ACTIONS(3335),
    [anon_sym_chdir] = ACTIONS(3335),
    [anon_sym_close] = ACTIONS(3335),
    [anon_sym_closedir] = ACTIONS(3335),
    [anon_sym_caller] = ACTIONS(3335),
    [anon_sym_chomp] = ACTIONS(3335),
    [anon_sym_chr] = ACTIONS(3335),
    [anon_sym_cos] = ACTIONS(3335),
    [anon_sym_chroot] = ACTIONS(3335),
    [anon_sym_defined] = ACTIONS(3335),
    [anon_sym_delete] = ACTIONS(3335),
    [anon_sym_dbmclose] = ACTIONS(3335),
    [anon_sym_exists] = ACTIONS(3335),
    [anon_sym_exit] = ACTIONS(3335),
    [anon_sym_eof] = ACTIONS(3335),
    [anon_sym_exp] = ACTIONS(3335),
    [anon_sym_each] = ACTIONS(3335),
    [anon_sym_fc] = ACTIONS(3335),
    [anon_sym_fileno] = ACTIONS(3335),
    [anon_sym_gmtime] = ACTIONS(3335),
    [anon_sym_getc] = ACTIONS(3335),
    [anon_sym_getpgrp] = ACTIONS(3335),
    [anon_sym_getprotobyname] = ACTIONS(3335),
    [anon_sym_getpwname] = ACTIONS(3335),
    [anon_sym_getpwuid] = ACTIONS(3335),
    [anon_sym_getpeername] = ACTIONS(3335),
    [anon_sym_getnetbyname] = ACTIONS(3335),
    [anon_sym_getsockname] = ACTIONS(3335),
    [anon_sym_getgrnam] = ACTIONS(3335),
    [anon_sym_getgrgid] = ACTIONS(3335),
    [anon_sym_hex] = ACTIONS(3335),
    [anon_sym_int] = ACTIONS(3335),
    [anon_sym_keys] = ACTIONS(3335),
    [anon_sym_lc] = ACTIONS(3335),
    [anon_sym_lcfirst] = ACTIONS(3335),
    [anon_sym_length] = ACTIONS(3335),
    [anon_sym_localtime] = ACTIONS(3335),
    [anon_sym_log] = ACTIONS(3335),
    [anon_sym_lock] = ACTIONS(3335),
    [anon_sym_lstat] = ACTIONS(3335),
    [anon_sym_oct] = ACTIONS(3335),
    [anon_sym_ord] = ACTIONS(3335),
    [anon_sym_prototype] = ACTIONS(3335),
    [anon_sym_pop] = ACTIONS(3335),
    [anon_sym_pos] = ACTIONS(3335),
    [anon_sym_quotemeta] = ACTIONS(3335),
    [anon_sym_reset] = ACTIONS(3335),
    [anon_sym_rand] = ACTIONS(3335),
    [anon_sym_rmdir] = ACTIONS(3335),
    [anon_sym_readdir] = ACTIONS(3335),
    [anon_sym_readline] = ACTIONS(3335),
    [anon_sym_readpipe] = ACTIONS(3335),
    [anon_sym_rewinddir] = ACTIONS(3335),
    [anon_sym_readlink] = ACTIONS(3335),
    [anon_sym_ref] = ACTIONS(3335),
    [anon_sym_scalar] = ACTIONS(3335),
    [anon_sym_shift] = ACTIONS(3335),
    [anon_sym_sin] = ACTIONS(3335),
    [anon_sym_sleep] = ACTIONS(3335),
    [anon_sym_sqrt] = ACTIONS(3335),
    [anon_sym_srand] = ACTIONS(3335),
    [anon_sym_stat] = ACTIONS(3335),
    [anon_sym_study] = ACTIONS(3335),
    [anon_sym_tell] = ACTIONS(3335),
    [anon_sym_telldir] = ACTIONS(3335),
    [anon_sym_tied] = ACTIONS(3335),
    [anon_sym_uc] = ACTIONS(3335),
    [anon_sym_ucfirst] = ACTIONS(3335),
    [anon_sym_untie] = ACTIONS(3335),
    [anon_sym_umask] = ACTIONS(3335),
    [anon_sym_values] = ACTIONS(3335),
    [anon_sym_write] = ACTIONS(3335),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3335),
    [anon_sym___END__] = ACTIONS(3335),
    [anon_sym_q] = ACTIONS(3335),
    [anon_sym_qq] = ACTIONS(3335),
    [anon_sym_qw] = ACTIONS(3335),
    [anon_sym_qx] = ACTIONS(3335),
    [anon_sym_qr] = ACTIONS(3335),
    [anon_sym_m] = ACTIONS(3335),
    [anon_sym_s] = ACTIONS(3335),
    [anon_sym_tr] = ACTIONS(3335),
    [anon_sym_y] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_unless] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_until] = ACTIONS(3335),
    [aux_sym__bareword_token1] = ACTIONS(3335),
    [sym_number] = ACTIONS(3335),
    [sym__apostrophe] = ACTIONS(3333),
    [sym__double_quote] = ACTIONS(3333),
    [sym__backtick] = ACTIONS(3333),
    [sym__search_slash] = ACTIONS(3333),
    [sym__PERLY_HEREDOC] = ACTIONS(3333),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1103] = {
    [sym_heredoc_content] = STATE(1103),
    [sym__identifier] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_LBRACE2] = ACTIONS(3013),
    [anon_sym_RBRACE] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3013),
    [anon_sym_package] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_sub] = ACTIONS(3013),
    [anon_sym_method] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_my] = ACTIONS(3013),
    [anon_sym_state] = ACTIONS(3013),
    [anon_sym_our] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_defer] = ACTIONS(3013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3013),
    [anon_sym_else] = ACTIONS(3013),
    [anon_sym_elsif] = ACTIONS(3013),
    [anon_sym_and] = ACTIONS(3013),
    [anon_sym_or] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_LT_LT] = ACTIONS(3013),
    [anon_sym_SLASH_SLASH] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3013),
    [anon_sym_eq] = ACTIONS(3013),
    [anon_sym_ne] = ACTIONS(3013),
    [anon_sym_cmp] = ACTIONS(3013),
    [anon_sym_lt] = ACTIONS(3013),
    [anon_sym_le] = ACTIONS(3013),
    [anon_sym_ge] = ACTIONS(3013),
    [anon_sym_gt] = ACTIONS(3013),
    [anon_sym_isa] = ACTIONS(3013),
    [anon_sym_TILDE] = ACTIONS(3013),
    [anon_sym_BANG] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3013),
    [anon_sym_BSLASH] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_eval] = ACTIONS(3013),
    [anon_sym_field] = ACTIONS(3013),
    [anon_sym_local] = ACTIONS(3013),
    [anon_sym_require] = ACTIONS(3013),
    [anon_sym_map] = ACTIONS(3013),
    [anon_sym_grep] = ACTIONS(3013),
    [anon_sym_sort] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_undef] = ACTIONS(3013),
    [anon_sym_PERCENT2] = ACTIONS(3013),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3013),
    [anon_sym_no] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_foreach] = ACTIONS(3013),
    [anon_sym_last] = ACTIONS(3013),
    [anon_sym_next] = ACTIONS(3013),
    [anon_sym_redo] = ACTIONS(3013),
    [anon_sym_BEGIN] = ACTIONS(3013),
    [anon_sym_INIT] = ACTIONS(3013),
    [anon_sym_CHECK] = ACTIONS(3013),
    [anon_sym_UNITCHECK] = ACTIONS(3013),
    [anon_sym_END] = ACTIONS(3013),
    [anon_sym_ADJUST] = ACTIONS(3013),
    [anon_sym___FILE__] = ACTIONS(3013),
    [anon_sym___LINE__] = ACTIONS(3013),
    [anon_sym___PACKAGE__] = ACTIONS(3013),
    [anon_sym___SUB__] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_fork] = ACTIONS(3013),
    [anon_sym_getppid] = ACTIONS(3013),
    [anon_sym_time] = ACTIONS(3013),
    [anon_sym_times] = ACTIONS(3013),
    [anon_sym_wait] = ACTIONS(3013),
    [anon_sym_wantarray] = ACTIONS(3013),
    [anon_sym_abs] = ACTIONS(3013),
    [anon_sym_alarm] = ACTIONS(3013),
    [anon_sym_chop] = ACTIONS(3013),
    [anon_sym_chdir] = ACTIONS(3013),
    [anon_sym_close] = ACTIONS(3013),
    [anon_sym_closedir] = ACTIONS(3013),
    [anon_sym_caller] = ACTIONS(3013),
    [anon_sym_chomp] = ACTIONS(3013),
    [anon_sym_chr] = ACTIONS(3013),
    [anon_sym_cos] = ACTIONS(3013),
    [anon_sym_chroot] = ACTIONS(3013),
    [anon_sym_defined] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_dbmclose] = ACTIONS(3013),
    [anon_sym_exists] = ACTIONS(3013),
    [anon_sym_exit] = ACTIONS(3013),
    [anon_sym_eof] = ACTIONS(3013),
    [anon_sym_exp] = ACTIONS(3013),
    [anon_sym_each] = ACTIONS(3013),
    [anon_sym_fc] = ACTIONS(3013),
    [anon_sym_fileno] = ACTIONS(3013),
    [anon_sym_gmtime] = ACTIONS(3013),
    [anon_sym_getc] = ACTIONS(3013),
    [anon_sym_getpgrp] = ACTIONS(3013),
    [anon_sym_getprotobyname] = ACTIONS(3013),
    [anon_sym_getpwname] = ACTIONS(3013),
    [anon_sym_getpwuid] = ACTIONS(3013),
    [anon_sym_getpeername] = ACTIONS(3013),
    [anon_sym_getnetbyname] = ACTIONS(3013),
    [anon_sym_getsockname] = ACTIONS(3013),
    [anon_sym_getgrnam] = ACTIONS(3013),
    [anon_sym_getgrgid] = ACTIONS(3013),
    [anon_sym_hex] = ACTIONS(3013),
    [anon_sym_int] = ACTIONS(3013),
    [anon_sym_keys] = ACTIONS(3013),
    [anon_sym_lc] = ACTIONS(3013),
    [anon_sym_lcfirst] = ACTIONS(3013),
    [anon_sym_length] = ACTIONS(3013),
    [anon_sym_localtime] = ACTIONS(3013),
    [anon_sym_log] = ACTIONS(3013),
    [anon_sym_lock] = ACTIONS(3013),
    [anon_sym_lstat] = ACTIONS(3013),
    [anon_sym_oct] = ACTIONS(3013),
    [anon_sym_ord] = ACTIONS(3013),
    [anon_sym_prototype] = ACTIONS(3013),
    [anon_sym_pop] = ACTIONS(3013),
    [anon_sym_pos] = ACTIONS(3013),
    [anon_sym_quotemeta] = ACTIONS(3013),
    [anon_sym_reset] = ACTIONS(3013),
    [anon_sym_rand] = ACTIONS(3013),
    [anon_sym_rmdir] = ACTIONS(3013),
    [anon_sym_readdir] = ACTIONS(3013),
    [anon_sym_readline] = ACTIONS(3013),
    [anon_sym_readpipe] = ACTIONS(3013),
    [anon_sym_rewinddir] = ACTIONS(3013),
    [anon_sym_readlink] = ACTIONS(3013),
    [anon_sym_ref] = ACTIONS(3013),
    [anon_sym_scalar] = ACTIONS(3013),
    [anon_sym_shift] = ACTIONS(3013),
    [anon_sym_sin] = ACTIONS(3013),
    [anon_sym_sleep] = ACTIONS(3013),
    [anon_sym_sqrt] = ACTIONS(3013),
    [anon_sym_srand] = ACTIONS(3013),
    [anon_sym_stat] = ACTIONS(3013),
    [anon_sym_study] = ACTIONS(3013),
    [anon_sym_tell] = ACTIONS(3013),
    [anon_sym_telldir] = ACTIONS(3013),
    [anon_sym_tied] = ACTIONS(3013),
    [anon_sym_uc] = ACTIONS(3013),
    [anon_sym_ucfirst] = ACTIONS(3013),
    [anon_sym_untie] = ACTIONS(3013),
    [anon_sym_umask] = ACTIONS(3013),
    [anon_sym_values] = ACTIONS(3013),
    [anon_sym_write] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3013),
    [anon_sym___END__] = ACTIONS(3013),
    [anon_sym_q] = ACTIONS(3013),
    [anon_sym_qq] = ACTIONS(3013),
    [anon_sym_qw] = ACTIONS(3013),
    [anon_sym_qx] = ACTIONS(3013),
    [anon_sym_qr] = ACTIONS(3013),
    [anon_sym_m] = ACTIONS(3013),
    [anon_sym_s] = ACTIONS(3013),
    [anon_sym_tr] = ACTIONS(3013),
    [anon_sym_y] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_unless] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_until] = ACTIONS(3013),
    [aux_sym__bareword_token1] = ACTIONS(3013),
    [sym_number] = ACTIONS(3013),
    [sym__apostrophe] = ACTIONS(3011),
    [sym__double_quote] = ACTIONS(3011),
    [sym__backtick] = ACTIONS(3011),
    [sym__search_slash] = ACTIONS(3011),
    [sym__PERLY_HEREDOC] = ACTIONS(3011),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1104] = {
    [sym_heredoc_content] = STATE(1104),
    [sym__identifier] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_LBRACE2] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_package] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_sub] = ACTIONS(3289),
    [anon_sym_method] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_my] = ACTIONS(3289),
    [anon_sym_state] = ACTIONS(3289),
    [anon_sym_our] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_defer] = ACTIONS(3289),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_elsif] = ACTIONS(3289),
    [anon_sym_and] = ACTIONS(3289),
    [anon_sym_or] = ACTIONS(3289),
    [anon_sym_DOLLAR] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_LT_LT] = ACTIONS(3289),
    [anon_sym_SLASH_SLASH] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_eq] = ACTIONS(3289),
    [anon_sym_ne] = ACTIONS(3289),
    [anon_sym_cmp] = ACTIONS(3289),
    [anon_sym_lt] = ACTIONS(3289),
    [anon_sym_le] = ACTIONS(3289),
    [anon_sym_ge] = ACTIONS(3289),
    [anon_sym_gt] = ACTIONS(3289),
    [anon_sym_isa] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_BSLASH] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_eval] = ACTIONS(3289),
    [anon_sym_field] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3289),
    [anon_sym_require] = ACTIONS(3289),
    [anon_sym_map] = ACTIONS(3289),
    [anon_sym_grep] = ACTIONS(3289),
    [anon_sym_sort] = ACTIONS(3289),
    [anon_sym_goto] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_undef] = ACTIONS(3289),
    [anon_sym_PERCENT2] = ACTIONS(3289),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3289),
    [anon_sym_use] = ACTIONS(3289),
    [anon_sym_no] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_foreach] = ACTIONS(3289),
    [anon_sym_last] = ACTIONS(3289),
    [anon_sym_next] = ACTIONS(3289),
    [anon_sym_redo] = ACTIONS(3289),
    [anon_sym_BEGIN] = ACTIONS(3289),
    [anon_sym_INIT] = ACTIONS(3289),
    [anon_sym_CHECK] = ACTIONS(3289),
    [anon_sym_UNITCHECK] = ACTIONS(3289),
    [anon_sym_END] = ACTIONS(3289),
    [anon_sym_ADJUST] = ACTIONS(3289),
    [anon_sym___FILE__] = ACTIONS(3289),
    [anon_sym___LINE__] = ACTIONS(3289),
    [anon_sym___PACKAGE__] = ACTIONS(3289),
    [anon_sym___SUB__] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_fork] = ACTIONS(3289),
    [anon_sym_getppid] = ACTIONS(3289),
    [anon_sym_time] = ACTIONS(3289),
    [anon_sym_times] = ACTIONS(3289),
    [anon_sym_wait] = ACTIONS(3289),
    [anon_sym_wantarray] = ACTIONS(3289),
    [anon_sym_abs] = ACTIONS(3289),
    [anon_sym_alarm] = ACTIONS(3289),
    [anon_sym_chop] = ACTIONS(3289),
    [anon_sym_chdir] = ACTIONS(3289),
    [anon_sym_close] = ACTIONS(3289),
    [anon_sym_closedir] = ACTIONS(3289),
    [anon_sym_caller] = ACTIONS(3289),
    [anon_sym_chomp] = ACTIONS(3289),
    [anon_sym_chr] = ACTIONS(3289),
    [anon_sym_cos] = ACTIONS(3289),
    [anon_sym_chroot] = ACTIONS(3289),
    [anon_sym_defined] = ACTIONS(3289),
    [anon_sym_delete] = ACTIONS(3289),
    [anon_sym_dbmclose] = ACTIONS(3289),
    [anon_sym_exists] = ACTIONS(3289),
    [anon_sym_exit] = ACTIONS(3289),
    [anon_sym_eof] = ACTIONS(3289),
    [anon_sym_exp] = ACTIONS(3289),
    [anon_sym_each] = ACTIONS(3289),
    [anon_sym_fc] = ACTIONS(3289),
    [anon_sym_fileno] = ACTIONS(3289),
    [anon_sym_gmtime] = ACTIONS(3289),
    [anon_sym_getc] = ACTIONS(3289),
    [anon_sym_getpgrp] = ACTIONS(3289),
    [anon_sym_getprotobyname] = ACTIONS(3289),
    [anon_sym_getpwname] = ACTIONS(3289),
    [anon_sym_getpwuid] = ACTIONS(3289),
    [anon_sym_getpeername] = ACTIONS(3289),
    [anon_sym_getnetbyname] = ACTIONS(3289),
    [anon_sym_getsockname] = ACTIONS(3289),
    [anon_sym_getgrnam] = ACTIONS(3289),
    [anon_sym_getgrgid] = ACTIONS(3289),
    [anon_sym_hex] = ACTIONS(3289),
    [anon_sym_int] = ACTIONS(3289),
    [anon_sym_keys] = ACTIONS(3289),
    [anon_sym_lc] = ACTIONS(3289),
    [anon_sym_lcfirst] = ACTIONS(3289),
    [anon_sym_length] = ACTIONS(3289),
    [anon_sym_localtime] = ACTIONS(3289),
    [anon_sym_log] = ACTIONS(3289),
    [anon_sym_lock] = ACTIONS(3289),
    [anon_sym_lstat] = ACTIONS(3289),
    [anon_sym_oct] = ACTIONS(3289),
    [anon_sym_ord] = ACTIONS(3289),
    [anon_sym_prototype] = ACTIONS(3289),
    [anon_sym_pop] = ACTIONS(3289),
    [anon_sym_pos] = ACTIONS(3289),
    [anon_sym_quotemeta] = ACTIONS(3289),
    [anon_sym_reset] = ACTIONS(3289),
    [anon_sym_rand] = ACTIONS(3289),
    [anon_sym_rmdir] = ACTIONS(3289),
    [anon_sym_readdir] = ACTIONS(3289),
    [anon_sym_readline] = ACTIONS(3289),
    [anon_sym_readpipe] = ACTIONS(3289),
    [anon_sym_rewinddir] = ACTIONS(3289),
    [anon_sym_readlink] = ACTIONS(3289),
    [anon_sym_ref] = ACTIONS(3289),
    [anon_sym_scalar] = ACTIONS(3289),
    [anon_sym_shift] = ACTIONS(3289),
    [anon_sym_sin] = ACTIONS(3289),
    [anon_sym_sleep] = ACTIONS(3289),
    [anon_sym_sqrt] = ACTIONS(3289),
    [anon_sym_srand] = ACTIONS(3289),
    [anon_sym_stat] = ACTIONS(3289),
    [anon_sym_study] = ACTIONS(3289),
    [anon_sym_tell] = ACTIONS(3289),
    [anon_sym_telldir] = ACTIONS(3289),
    [anon_sym_tied] = ACTIONS(3289),
    [anon_sym_uc] = ACTIONS(3289),
    [anon_sym_ucfirst] = ACTIONS(3289),
    [anon_sym_untie] = ACTIONS(3289),
    [anon_sym_umask] = ACTIONS(3289),
    [anon_sym_values] = ACTIONS(3289),
    [anon_sym_write] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3289),
    [anon_sym___END__] = ACTIONS(3289),
    [anon_sym_q] = ACTIONS(3289),
    [anon_sym_qq] = ACTIONS(3289),
    [anon_sym_qw] = ACTIONS(3289),
    [anon_sym_qx] = ACTIONS(3289),
    [anon_sym_qr] = ACTIONS(3289),
    [anon_sym_m] = ACTIONS(3289),
    [anon_sym_s] = ACTIONS(3289),
    [anon_sym_tr] = ACTIONS(3289),
    [anon_sym_y] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_unless] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_until] = ACTIONS(3289),
    [aux_sym__bareword_token1] = ACTIONS(3289),
    [sym_number] = ACTIONS(3289),
    [sym__apostrophe] = ACTIONS(3287),
    [sym__double_quote] = ACTIONS(3287),
    [sym__backtick] = ACTIONS(3287),
    [sym__search_slash] = ACTIONS(3287),
    [sym__PERLY_HEREDOC] = ACTIONS(3287),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1105] = {
    [sym_heredoc_content] = STATE(1105),
    [sym__identifier] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LBRACE2] = ACTIONS(3117),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_package] = ACTIONS(3117),
    [anon_sym_class] = ACTIONS(3117),
    [anon_sym_sub] = ACTIONS(3117),
    [anon_sym_method] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_continue] = ACTIONS(3117),
    [anon_sym_my] = ACTIONS(3117),
    [anon_sym_state] = ACTIONS(3117),
    [anon_sym_our] = ACTIONS(3117),
    [anon_sym_try] = ACTIONS(3117),
    [anon_sym_defer] = ACTIONS(3117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3117),
    [anon_sym_else] = ACTIONS(3117),
    [anon_sym_elsif] = ACTIONS(3117),
    [anon_sym_and] = ACTIONS(3117),
    [anon_sym_or] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_AT] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_LT_LT] = ACTIONS(3117),
    [anon_sym_SLASH_SLASH] = ACTIONS(3117),
    [anon_sym_PLUS] = ACTIONS(3117),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_eq] = ACTIONS(3117),
    [anon_sym_ne] = ACTIONS(3117),
    [anon_sym_cmp] = ACTIONS(3117),
    [anon_sym_lt] = ACTIONS(3117),
    [anon_sym_le] = ACTIONS(3117),
    [anon_sym_ge] = ACTIONS(3117),
    [anon_sym_gt] = ACTIONS(3117),
    [anon_sym_isa] = ACTIONS(3117),
    [anon_sym_TILDE] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [anon_sym_BSLASH] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3117),
    [anon_sym_eval] = ACTIONS(3117),
    [anon_sym_field] = ACTIONS(3117),
    [anon_sym_local] = ACTIONS(3117),
    [anon_sym_require] = ACTIONS(3117),
    [anon_sym_map] = ACTIONS(3117),
    [anon_sym_grep] = ACTIONS(3117),
    [anon_sym_sort] = ACTIONS(3117),
    [anon_sym_goto] = ACTIONS(3117),
    [anon_sym_return] = ACTIONS(3117),
    [anon_sym_undef] = ACTIONS(3117),
    [anon_sym_PERCENT2] = ACTIONS(3117),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3117),
    [anon_sym_no] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_foreach] = ACTIONS(3117),
    [anon_sym_last] = ACTIONS(3117),
    [anon_sym_next] = ACTIONS(3117),
    [anon_sym_redo] = ACTIONS(3117),
    [anon_sym_BEGIN] = ACTIONS(3117),
    [anon_sym_INIT] = ACTIONS(3117),
    [anon_sym_CHECK] = ACTIONS(3117),
    [anon_sym_UNITCHECK] = ACTIONS(3117),
    [anon_sym_END] = ACTIONS(3117),
    [anon_sym_ADJUST] = ACTIONS(3117),
    [anon_sym___FILE__] = ACTIONS(3117),
    [anon_sym___LINE__] = ACTIONS(3117),
    [anon_sym___PACKAGE__] = ACTIONS(3117),
    [anon_sym___SUB__] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3117),
    [anon_sym_fork] = ACTIONS(3117),
    [anon_sym_getppid] = ACTIONS(3117),
    [anon_sym_time] = ACTIONS(3117),
    [anon_sym_times] = ACTIONS(3117),
    [anon_sym_wait] = ACTIONS(3117),
    [anon_sym_wantarray] = ACTIONS(3117),
    [anon_sym_abs] = ACTIONS(3117),
    [anon_sym_alarm] = ACTIONS(3117),
    [anon_sym_chop] = ACTIONS(3117),
    [anon_sym_chdir] = ACTIONS(3117),
    [anon_sym_close] = ACTIONS(3117),
    [anon_sym_closedir] = ACTIONS(3117),
    [anon_sym_caller] = ACTIONS(3117),
    [anon_sym_chomp] = ACTIONS(3117),
    [anon_sym_chr] = ACTIONS(3117),
    [anon_sym_cos] = ACTIONS(3117),
    [anon_sym_chroot] = ACTIONS(3117),
    [anon_sym_defined] = ACTIONS(3117),
    [anon_sym_delete] = ACTIONS(3117),
    [anon_sym_dbmclose] = ACTIONS(3117),
    [anon_sym_exists] = ACTIONS(3117),
    [anon_sym_exit] = ACTIONS(3117),
    [anon_sym_eof] = ACTIONS(3117),
    [anon_sym_exp] = ACTIONS(3117),
    [anon_sym_each] = ACTIONS(3117),
    [anon_sym_fc] = ACTIONS(3117),
    [anon_sym_fileno] = ACTIONS(3117),
    [anon_sym_gmtime] = ACTIONS(3117),
    [anon_sym_getc] = ACTIONS(3117),
    [anon_sym_getpgrp] = ACTIONS(3117),
    [anon_sym_getprotobyname] = ACTIONS(3117),
    [anon_sym_getpwname] = ACTIONS(3117),
    [anon_sym_getpwuid] = ACTIONS(3117),
    [anon_sym_getpeername] = ACTIONS(3117),
    [anon_sym_getnetbyname] = ACTIONS(3117),
    [anon_sym_getsockname] = ACTIONS(3117),
    [anon_sym_getgrnam] = ACTIONS(3117),
    [anon_sym_getgrgid] = ACTIONS(3117),
    [anon_sym_hex] = ACTIONS(3117),
    [anon_sym_int] = ACTIONS(3117),
    [anon_sym_keys] = ACTIONS(3117),
    [anon_sym_lc] = ACTIONS(3117),
    [anon_sym_lcfirst] = ACTIONS(3117),
    [anon_sym_length] = ACTIONS(3117),
    [anon_sym_localtime] = ACTIONS(3117),
    [anon_sym_log] = ACTIONS(3117),
    [anon_sym_lock] = ACTIONS(3117),
    [anon_sym_lstat] = ACTIONS(3117),
    [anon_sym_oct] = ACTIONS(3117),
    [anon_sym_ord] = ACTIONS(3117),
    [anon_sym_prototype] = ACTIONS(3117),
    [anon_sym_pop] = ACTIONS(3117),
    [anon_sym_pos] = ACTIONS(3117),
    [anon_sym_quotemeta] = ACTIONS(3117),
    [anon_sym_reset] = ACTIONS(3117),
    [anon_sym_rand] = ACTIONS(3117),
    [anon_sym_rmdir] = ACTIONS(3117),
    [anon_sym_readdir] = ACTIONS(3117),
    [anon_sym_readline] = ACTIONS(3117),
    [anon_sym_readpipe] = ACTIONS(3117),
    [anon_sym_rewinddir] = ACTIONS(3117),
    [anon_sym_readlink] = ACTIONS(3117),
    [anon_sym_ref] = ACTIONS(3117),
    [anon_sym_scalar] = ACTIONS(3117),
    [anon_sym_shift] = ACTIONS(3117),
    [anon_sym_sin] = ACTIONS(3117),
    [anon_sym_sleep] = ACTIONS(3117),
    [anon_sym_sqrt] = ACTIONS(3117),
    [anon_sym_srand] = ACTIONS(3117),
    [anon_sym_stat] = ACTIONS(3117),
    [anon_sym_study] = ACTIONS(3117),
    [anon_sym_tell] = ACTIONS(3117),
    [anon_sym_telldir] = ACTIONS(3117),
    [anon_sym_tied] = ACTIONS(3117),
    [anon_sym_uc] = ACTIONS(3117),
    [anon_sym_ucfirst] = ACTIONS(3117),
    [anon_sym_untie] = ACTIONS(3117),
    [anon_sym_umask] = ACTIONS(3117),
    [anon_sym_values] = ACTIONS(3117),
    [anon_sym_write] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3117),
    [anon_sym___END__] = ACTIONS(3117),
    [anon_sym_q] = ACTIONS(3117),
    [anon_sym_qq] = ACTIONS(3117),
    [anon_sym_qw] = ACTIONS(3117),
    [anon_sym_qx] = ACTIONS(3117),
    [anon_sym_qr] = ACTIONS(3117),
    [anon_sym_m] = ACTIONS(3117),
    [anon_sym_s] = ACTIONS(3117),
    [anon_sym_tr] = ACTIONS(3117),
    [anon_sym_y] = ACTIONS(3117),
    [anon_sym_if] = ACTIONS(3117),
    [anon_sym_unless] = ACTIONS(3117),
    [anon_sym_while] = ACTIONS(3117),
    [anon_sym_until] = ACTIONS(3117),
    [aux_sym__bareword_token1] = ACTIONS(3117),
    [sym_number] = ACTIONS(3117),
    [sym__apostrophe] = ACTIONS(3115),
    [sym__double_quote] = ACTIONS(3115),
    [sym__backtick] = ACTIONS(3115),
    [sym__search_slash] = ACTIONS(3115),
    [sym__PERLY_HEREDOC] = ACTIONS(3115),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1106] = {
    [sym_heredoc_content] = STATE(1106),
    [sym__identifier] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3263),
    [anon_sym_LBRACE2] = ACTIONS(3263),
    [anon_sym_RBRACE] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_package] = ACTIONS(3263),
    [anon_sym_class] = ACTIONS(3263),
    [anon_sym_sub] = ACTIONS(3263),
    [anon_sym_method] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3380),
    [anon_sym_my] = ACTIONS(3263),
    [anon_sym_state] = ACTIONS(3263),
    [anon_sym_our] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_defer] = ACTIONS(3263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_elsif] = ACTIONS(3263),
    [anon_sym_and] = ACTIONS(3263),
    [anon_sym_or] = ACTIONS(3263),
    [anon_sym_DOLLAR] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_AT] = ACTIONS(3263),
    [anon_sym_LT] = ACTIONS(3263),
    [anon_sym_LT_LT] = ACTIONS(3263),
    [anon_sym_SLASH_SLASH] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3263),
    [anon_sym_eq] = ACTIONS(3263),
    [anon_sym_ne] = ACTIONS(3263),
    [anon_sym_cmp] = ACTIONS(3263),
    [anon_sym_lt] = ACTIONS(3263),
    [anon_sym_le] = ACTIONS(3263),
    [anon_sym_ge] = ACTIONS(3263),
    [anon_sym_gt] = ACTIONS(3263),
    [anon_sym_isa] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3263),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [anon_sym_BSLASH] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_eval] = ACTIONS(3263),
    [anon_sym_field] = ACTIONS(3263),
    [anon_sym_local] = ACTIONS(3263),
    [anon_sym_require] = ACTIONS(3263),
    [anon_sym_map] = ACTIONS(3263),
    [anon_sym_grep] = ACTIONS(3263),
    [anon_sym_sort] = ACTIONS(3263),
    [anon_sym_goto] = ACTIONS(3263),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_undef] = ACTIONS(3263),
    [anon_sym_PERCENT2] = ACTIONS(3263),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3263),
    [anon_sym_use] = ACTIONS(3263),
    [anon_sym_no] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_foreach] = ACTIONS(3263),
    [anon_sym_last] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3263),
    [anon_sym_redo] = ACTIONS(3263),
    [anon_sym_BEGIN] = ACTIONS(3263),
    [anon_sym_INIT] = ACTIONS(3263),
    [anon_sym_CHECK] = ACTIONS(3263),
    [anon_sym_UNITCHECK] = ACTIONS(3263),
    [anon_sym_END] = ACTIONS(3263),
    [anon_sym_ADJUST] = ACTIONS(3263),
    [anon_sym___FILE__] = ACTIONS(3263),
    [anon_sym___LINE__] = ACTIONS(3263),
    [anon_sym___PACKAGE__] = ACTIONS(3263),
    [anon_sym___SUB__] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_fork] = ACTIONS(3263),
    [anon_sym_getppid] = ACTIONS(3263),
    [anon_sym_time] = ACTIONS(3263),
    [anon_sym_times] = ACTIONS(3263),
    [anon_sym_wait] = ACTIONS(3263),
    [anon_sym_wantarray] = ACTIONS(3263),
    [anon_sym_abs] = ACTIONS(3263),
    [anon_sym_alarm] = ACTIONS(3263),
    [anon_sym_chop] = ACTIONS(3263),
    [anon_sym_chdir] = ACTIONS(3263),
    [anon_sym_close] = ACTIONS(3263),
    [anon_sym_closedir] = ACTIONS(3263),
    [anon_sym_caller] = ACTIONS(3263),
    [anon_sym_chomp] = ACTIONS(3263),
    [anon_sym_chr] = ACTIONS(3263),
    [anon_sym_cos] = ACTIONS(3263),
    [anon_sym_chroot] = ACTIONS(3263),
    [anon_sym_defined] = ACTIONS(3263),
    [anon_sym_delete] = ACTIONS(3263),
    [anon_sym_dbmclose] = ACTIONS(3263),
    [anon_sym_exists] = ACTIONS(3263),
    [anon_sym_exit] = ACTIONS(3263),
    [anon_sym_eof] = ACTIONS(3263),
    [anon_sym_exp] = ACTIONS(3263),
    [anon_sym_each] = ACTIONS(3263),
    [anon_sym_fc] = ACTIONS(3263),
    [anon_sym_fileno] = ACTIONS(3263),
    [anon_sym_gmtime] = ACTIONS(3263),
    [anon_sym_getc] = ACTIONS(3263),
    [anon_sym_getpgrp] = ACTIONS(3263),
    [anon_sym_getprotobyname] = ACTIONS(3263),
    [anon_sym_getpwname] = ACTIONS(3263),
    [anon_sym_getpwuid] = ACTIONS(3263),
    [anon_sym_getpeername] = ACTIONS(3263),
    [anon_sym_getnetbyname] = ACTIONS(3263),
    [anon_sym_getsockname] = ACTIONS(3263),
    [anon_sym_getgrnam] = ACTIONS(3263),
    [anon_sym_getgrgid] = ACTIONS(3263),
    [anon_sym_hex] = ACTIONS(3263),
    [anon_sym_int] = ACTIONS(3263),
    [anon_sym_keys] = ACTIONS(3263),
    [anon_sym_lc] = ACTIONS(3263),
    [anon_sym_lcfirst] = ACTIONS(3263),
    [anon_sym_length] = ACTIONS(3263),
    [anon_sym_localtime] = ACTIONS(3263),
    [anon_sym_log] = ACTIONS(3263),
    [anon_sym_lock] = ACTIONS(3263),
    [anon_sym_lstat] = ACTIONS(3263),
    [anon_sym_oct] = ACTIONS(3263),
    [anon_sym_ord] = ACTIONS(3263),
    [anon_sym_prototype] = ACTIONS(3263),
    [anon_sym_pop] = ACTIONS(3263),
    [anon_sym_pos] = ACTIONS(3263),
    [anon_sym_quotemeta] = ACTIONS(3263),
    [anon_sym_reset] = ACTIONS(3263),
    [anon_sym_rand] = ACTIONS(3263),
    [anon_sym_rmdir] = ACTIONS(3263),
    [anon_sym_readdir] = ACTIONS(3263),
    [anon_sym_readline] = ACTIONS(3263),
    [anon_sym_readpipe] = ACTIONS(3263),
    [anon_sym_rewinddir] = ACTIONS(3263),
    [anon_sym_readlink] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_scalar] = ACTIONS(3263),
    [anon_sym_shift] = ACTIONS(3263),
    [anon_sym_sin] = ACTIONS(3263),
    [anon_sym_sleep] = ACTIONS(3263),
    [anon_sym_sqrt] = ACTIONS(3263),
    [anon_sym_srand] = ACTIONS(3263),
    [anon_sym_stat] = ACTIONS(3263),
    [anon_sym_study] = ACTIONS(3263),
    [anon_sym_tell] = ACTIONS(3263),
    [anon_sym_telldir] = ACTIONS(3263),
    [anon_sym_tied] = ACTIONS(3263),
    [anon_sym_uc] = ACTIONS(3263),
    [anon_sym_ucfirst] = ACTIONS(3263),
    [anon_sym_untie] = ACTIONS(3263),
    [anon_sym_umask] = ACTIONS(3263),
    [anon_sym_values] = ACTIONS(3263),
    [anon_sym_write] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3263),
    [anon_sym___END__] = ACTIONS(3263),
    [anon_sym_q] = ACTIONS(3263),
    [anon_sym_qq] = ACTIONS(3263),
    [anon_sym_qw] = ACTIONS(3263),
    [anon_sym_qx] = ACTIONS(3263),
    [anon_sym_qr] = ACTIONS(3263),
    [anon_sym_m] = ACTIONS(3263),
    [anon_sym_s] = ACTIONS(3263),
    [anon_sym_tr] = ACTIONS(3263),
    [anon_sym_y] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_unless] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_until] = ACTIONS(3263),
    [aux_sym__bareword_token1] = ACTIONS(3263),
    [sym_number] = ACTIONS(3263),
    [sym__apostrophe] = ACTIONS(3261),
    [sym__double_quote] = ACTIONS(3261),
    [sym__backtick] = ACTIONS(3261),
    [sym__search_slash] = ACTIONS(3261),
    [sym__PERLY_HEREDOC] = ACTIONS(3261),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1107] = {
    [sym_heredoc_content] = STATE(1107),
    [sym__identifier] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LBRACE2] = ACTIONS(3089),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_package] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_sub] = ACTIONS(3089),
    [anon_sym_method] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_my] = ACTIONS(3089),
    [anon_sym_state] = ACTIONS(3089),
    [anon_sym_our] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_defer] = ACTIONS(3089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3089),
    [anon_sym_else] = ACTIONS(3089),
    [anon_sym_elsif] = ACTIONS(3089),
    [anon_sym_and] = ACTIONS(3089),
    [anon_sym_or] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_AT] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_LT_LT] = ACTIONS(3089),
    [anon_sym_SLASH_SLASH] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_eq] = ACTIONS(3089),
    [anon_sym_ne] = ACTIONS(3089),
    [anon_sym_cmp] = ACTIONS(3089),
    [anon_sym_lt] = ACTIONS(3089),
    [anon_sym_le] = ACTIONS(3089),
    [anon_sym_ge] = ACTIONS(3089),
    [anon_sym_gt] = ACTIONS(3089),
    [anon_sym_isa] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_BSLASH] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_eval] = ACTIONS(3089),
    [anon_sym_field] = ACTIONS(3089),
    [anon_sym_local] = ACTIONS(3089),
    [anon_sym_require] = ACTIONS(3089),
    [anon_sym_map] = ACTIONS(3089),
    [anon_sym_grep] = ACTIONS(3089),
    [anon_sym_sort] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_undef] = ACTIONS(3089),
    [anon_sym_PERCENT2] = ACTIONS(3089),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3089),
    [anon_sym_no] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_foreach] = ACTIONS(3089),
    [anon_sym_last] = ACTIONS(3089),
    [anon_sym_next] = ACTIONS(3089),
    [anon_sym_redo] = ACTIONS(3089),
    [anon_sym_BEGIN] = ACTIONS(3089),
    [anon_sym_INIT] = ACTIONS(3089),
    [anon_sym_CHECK] = ACTIONS(3089),
    [anon_sym_UNITCHECK] = ACTIONS(3089),
    [anon_sym_END] = ACTIONS(3089),
    [anon_sym_ADJUST] = ACTIONS(3089),
    [anon_sym___FILE__] = ACTIONS(3089),
    [anon_sym___LINE__] = ACTIONS(3089),
    [anon_sym___PACKAGE__] = ACTIONS(3089),
    [anon_sym___SUB__] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_fork] = ACTIONS(3089),
    [anon_sym_getppid] = ACTIONS(3089),
    [anon_sym_time] = ACTIONS(3089),
    [anon_sym_times] = ACTIONS(3089),
    [anon_sym_wait] = ACTIONS(3089),
    [anon_sym_wantarray] = ACTIONS(3089),
    [anon_sym_abs] = ACTIONS(3089),
    [anon_sym_alarm] = ACTIONS(3089),
    [anon_sym_chop] = ACTIONS(3089),
    [anon_sym_chdir] = ACTIONS(3089),
    [anon_sym_close] = ACTIONS(3089),
    [anon_sym_closedir] = ACTIONS(3089),
    [anon_sym_caller] = ACTIONS(3089),
    [anon_sym_chomp] = ACTIONS(3089),
    [anon_sym_chr] = ACTIONS(3089),
    [anon_sym_cos] = ACTIONS(3089),
    [anon_sym_chroot] = ACTIONS(3089),
    [anon_sym_defined] = ACTIONS(3089),
    [anon_sym_delete] = ACTIONS(3089),
    [anon_sym_dbmclose] = ACTIONS(3089),
    [anon_sym_exists] = ACTIONS(3089),
    [anon_sym_exit] = ACTIONS(3089),
    [anon_sym_eof] = ACTIONS(3089),
    [anon_sym_exp] = ACTIONS(3089),
    [anon_sym_each] = ACTIONS(3089),
    [anon_sym_fc] = ACTIONS(3089),
    [anon_sym_fileno] = ACTIONS(3089),
    [anon_sym_gmtime] = ACTIONS(3089),
    [anon_sym_getc] = ACTIONS(3089),
    [anon_sym_getpgrp] = ACTIONS(3089),
    [anon_sym_getprotobyname] = ACTIONS(3089),
    [anon_sym_getpwname] = ACTIONS(3089),
    [anon_sym_getpwuid] = ACTIONS(3089),
    [anon_sym_getpeername] = ACTIONS(3089),
    [anon_sym_getnetbyname] = ACTIONS(3089),
    [anon_sym_getsockname] = ACTIONS(3089),
    [anon_sym_getgrnam] = ACTIONS(3089),
    [anon_sym_getgrgid] = ACTIONS(3089),
    [anon_sym_hex] = ACTIONS(3089),
    [anon_sym_int] = ACTIONS(3089),
    [anon_sym_keys] = ACTIONS(3089),
    [anon_sym_lc] = ACTIONS(3089),
    [anon_sym_lcfirst] = ACTIONS(3089),
    [anon_sym_length] = ACTIONS(3089),
    [anon_sym_localtime] = ACTIONS(3089),
    [anon_sym_log] = ACTIONS(3089),
    [anon_sym_lock] = ACTIONS(3089),
    [anon_sym_lstat] = ACTIONS(3089),
    [anon_sym_oct] = ACTIONS(3089),
    [anon_sym_ord] = ACTIONS(3089),
    [anon_sym_prototype] = ACTIONS(3089),
    [anon_sym_pop] = ACTIONS(3089),
    [anon_sym_pos] = ACTIONS(3089),
    [anon_sym_quotemeta] = ACTIONS(3089),
    [anon_sym_reset] = ACTIONS(3089),
    [anon_sym_rand] = ACTIONS(3089),
    [anon_sym_rmdir] = ACTIONS(3089),
    [anon_sym_readdir] = ACTIONS(3089),
    [anon_sym_readline] = ACTIONS(3089),
    [anon_sym_readpipe] = ACTIONS(3089),
    [anon_sym_rewinddir] = ACTIONS(3089),
    [anon_sym_readlink] = ACTIONS(3089),
    [anon_sym_ref] = ACTIONS(3089),
    [anon_sym_scalar] = ACTIONS(3089),
    [anon_sym_shift] = ACTIONS(3089),
    [anon_sym_sin] = ACTIONS(3089),
    [anon_sym_sleep] = ACTIONS(3089),
    [anon_sym_sqrt] = ACTIONS(3089),
    [anon_sym_srand] = ACTIONS(3089),
    [anon_sym_stat] = ACTIONS(3089),
    [anon_sym_study] = ACTIONS(3089),
    [anon_sym_tell] = ACTIONS(3089),
    [anon_sym_telldir] = ACTIONS(3089),
    [anon_sym_tied] = ACTIONS(3089),
    [anon_sym_uc] = ACTIONS(3089),
    [anon_sym_ucfirst] = ACTIONS(3089),
    [anon_sym_untie] = ACTIONS(3089),
    [anon_sym_umask] = ACTIONS(3089),
    [anon_sym_values] = ACTIONS(3089),
    [anon_sym_write] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3089),
    [anon_sym___END__] = ACTIONS(3089),
    [anon_sym_q] = ACTIONS(3089),
    [anon_sym_qq] = ACTIONS(3089),
    [anon_sym_qw] = ACTIONS(3089),
    [anon_sym_qx] = ACTIONS(3089),
    [anon_sym_qr] = ACTIONS(3089),
    [anon_sym_m] = ACTIONS(3089),
    [anon_sym_s] = ACTIONS(3089),
    [anon_sym_tr] = ACTIONS(3089),
    [anon_sym_y] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_unless] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_until] = ACTIONS(3089),
    [aux_sym__bareword_token1] = ACTIONS(3089),
    [sym_number] = ACTIONS(3089),
    [sym__apostrophe] = ACTIONS(3087),
    [sym__double_quote] = ACTIONS(3087),
    [sym__backtick] = ACTIONS(3087),
    [sym__search_slash] = ACTIONS(3087),
    [sym__PERLY_HEREDOC] = ACTIONS(3087),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1108] = {
    [sym_heredoc_content] = STATE(1108),
    [sym__identifier] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_LBRACE2] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_package] = ACTIONS(3065),
    [anon_sym_class] = ACTIONS(3065),
    [anon_sym_sub] = ACTIONS(3065),
    [anon_sym_method] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_my] = ACTIONS(3065),
    [anon_sym_state] = ACTIONS(3065),
    [anon_sym_our] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_defer] = ACTIONS(3065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3065),
    [anon_sym_else] = ACTIONS(3065),
    [anon_sym_elsif] = ACTIONS(3065),
    [anon_sym_and] = ACTIONS(3065),
    [anon_sym_or] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_AT] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_eq] = ACTIONS(3065),
    [anon_sym_ne] = ACTIONS(3065),
    [anon_sym_cmp] = ACTIONS(3065),
    [anon_sym_lt] = ACTIONS(3065),
    [anon_sym_le] = ACTIONS(3065),
    [anon_sym_ge] = ACTIONS(3065),
    [anon_sym_gt] = ACTIONS(3065),
    [anon_sym_isa] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_BSLASH] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_eval] = ACTIONS(3065),
    [anon_sym_field] = ACTIONS(3065),
    [anon_sym_local] = ACTIONS(3065),
    [anon_sym_require] = ACTIONS(3065),
    [anon_sym_map] = ACTIONS(3065),
    [anon_sym_grep] = ACTIONS(3065),
    [anon_sym_sort] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_undef] = ACTIONS(3065),
    [anon_sym_PERCENT2] = ACTIONS(3065),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3065),
    [anon_sym_no] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_foreach] = ACTIONS(3065),
    [anon_sym_last] = ACTIONS(3065),
    [anon_sym_next] = ACTIONS(3065),
    [anon_sym_redo] = ACTIONS(3065),
    [anon_sym_BEGIN] = ACTIONS(3065),
    [anon_sym_INIT] = ACTIONS(3065),
    [anon_sym_CHECK] = ACTIONS(3065),
    [anon_sym_UNITCHECK] = ACTIONS(3065),
    [anon_sym_END] = ACTIONS(3065),
    [anon_sym_ADJUST] = ACTIONS(3065),
    [anon_sym___FILE__] = ACTIONS(3065),
    [anon_sym___LINE__] = ACTIONS(3065),
    [anon_sym___PACKAGE__] = ACTIONS(3065),
    [anon_sym___SUB__] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_fork] = ACTIONS(3065),
    [anon_sym_getppid] = ACTIONS(3065),
    [anon_sym_time] = ACTIONS(3065),
    [anon_sym_times] = ACTIONS(3065),
    [anon_sym_wait] = ACTIONS(3065),
    [anon_sym_wantarray] = ACTIONS(3065),
    [anon_sym_abs] = ACTIONS(3065),
    [anon_sym_alarm] = ACTIONS(3065),
    [anon_sym_chop] = ACTIONS(3065),
    [anon_sym_chdir] = ACTIONS(3065),
    [anon_sym_close] = ACTIONS(3065),
    [anon_sym_closedir] = ACTIONS(3065),
    [anon_sym_caller] = ACTIONS(3065),
    [anon_sym_chomp] = ACTIONS(3065),
    [anon_sym_chr] = ACTIONS(3065),
    [anon_sym_cos] = ACTIONS(3065),
    [anon_sym_chroot] = ACTIONS(3065),
    [anon_sym_defined] = ACTIONS(3065),
    [anon_sym_delete] = ACTIONS(3065),
    [anon_sym_dbmclose] = ACTIONS(3065),
    [anon_sym_exists] = ACTIONS(3065),
    [anon_sym_exit] = ACTIONS(3065),
    [anon_sym_eof] = ACTIONS(3065),
    [anon_sym_exp] = ACTIONS(3065),
    [anon_sym_each] = ACTIONS(3065),
    [anon_sym_fc] = ACTIONS(3065),
    [anon_sym_fileno] = ACTIONS(3065),
    [anon_sym_gmtime] = ACTIONS(3065),
    [anon_sym_getc] = ACTIONS(3065),
    [anon_sym_getpgrp] = ACTIONS(3065),
    [anon_sym_getprotobyname] = ACTIONS(3065),
    [anon_sym_getpwname] = ACTIONS(3065),
    [anon_sym_getpwuid] = ACTIONS(3065),
    [anon_sym_getpeername] = ACTIONS(3065),
    [anon_sym_getnetbyname] = ACTIONS(3065),
    [anon_sym_getsockname] = ACTIONS(3065),
    [anon_sym_getgrnam] = ACTIONS(3065),
    [anon_sym_getgrgid] = ACTIONS(3065),
    [anon_sym_hex] = ACTIONS(3065),
    [anon_sym_int] = ACTIONS(3065),
    [anon_sym_keys] = ACTIONS(3065),
    [anon_sym_lc] = ACTIONS(3065),
    [anon_sym_lcfirst] = ACTIONS(3065),
    [anon_sym_length] = ACTIONS(3065),
    [anon_sym_localtime] = ACTIONS(3065),
    [anon_sym_log] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_lstat] = ACTIONS(3065),
    [anon_sym_oct] = ACTIONS(3065),
    [anon_sym_ord] = ACTIONS(3065),
    [anon_sym_prototype] = ACTIONS(3065),
    [anon_sym_pop] = ACTIONS(3065),
    [anon_sym_pos] = ACTIONS(3065),
    [anon_sym_quotemeta] = ACTIONS(3065),
    [anon_sym_reset] = ACTIONS(3065),
    [anon_sym_rand] = ACTIONS(3065),
    [anon_sym_rmdir] = ACTIONS(3065),
    [anon_sym_readdir] = ACTIONS(3065),
    [anon_sym_readline] = ACTIONS(3065),
    [anon_sym_readpipe] = ACTIONS(3065),
    [anon_sym_rewinddir] = ACTIONS(3065),
    [anon_sym_readlink] = ACTIONS(3065),
    [anon_sym_ref] = ACTIONS(3065),
    [anon_sym_scalar] = ACTIONS(3065),
    [anon_sym_shift] = ACTIONS(3065),
    [anon_sym_sin] = ACTIONS(3065),
    [anon_sym_sleep] = ACTIONS(3065),
    [anon_sym_sqrt] = ACTIONS(3065),
    [anon_sym_srand] = ACTIONS(3065),
    [anon_sym_stat] = ACTIONS(3065),
    [anon_sym_study] = ACTIONS(3065),
    [anon_sym_tell] = ACTIONS(3065),
    [anon_sym_telldir] = ACTIONS(3065),
    [anon_sym_tied] = ACTIONS(3065),
    [anon_sym_uc] = ACTIONS(3065),
    [anon_sym_ucfirst] = ACTIONS(3065),
    [anon_sym_untie] = ACTIONS(3065),
    [anon_sym_umask] = ACTIONS(3065),
    [anon_sym_values] = ACTIONS(3065),
    [anon_sym_write] = ACTIONS(3065),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3065),
    [anon_sym___END__] = ACTIONS(3065),
    [anon_sym_q] = ACTIONS(3065),
    [anon_sym_qq] = ACTIONS(3065),
    [anon_sym_qw] = ACTIONS(3065),
    [anon_sym_qx] = ACTIONS(3065),
    [anon_sym_qr] = ACTIONS(3065),
    [anon_sym_m] = ACTIONS(3065),
    [anon_sym_s] = ACTIONS(3065),
    [anon_sym_tr] = ACTIONS(3065),
    [anon_sym_y] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_unless] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_until] = ACTIONS(3065),
    [aux_sym__bareword_token1] = ACTIONS(3065),
    [sym_number] = ACTIONS(3065),
    [sym__apostrophe] = ACTIONS(3067),
    [sym__double_quote] = ACTIONS(3067),
    [sym__backtick] = ACTIONS(3067),
    [sym__search_slash] = ACTIONS(3067),
    [sym__PERLY_HEREDOC] = ACTIONS(3067),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1109] = {
    [sym_heredoc_content] = STATE(1109),
    [sym__identifier] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LBRACE2] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_package] = ACTIONS(3308),
    [anon_sym_class] = ACTIONS(3308),
    [anon_sym_sub] = ACTIONS(3308),
    [anon_sym_method] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_my] = ACTIONS(3308),
    [anon_sym_state] = ACTIONS(3308),
    [anon_sym_our] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_defer] = ACTIONS(3308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3308),
    [anon_sym_else] = ACTIONS(3308),
    [anon_sym_elsif] = ACTIONS(3308),
    [anon_sym_and] = ACTIONS(3308),
    [anon_sym_or] = ACTIONS(3308),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_AT] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_eq] = ACTIONS(3308),
    [anon_sym_ne] = ACTIONS(3308),
    [anon_sym_cmp] = ACTIONS(3308),
    [anon_sym_lt] = ACTIONS(3308),
    [anon_sym_le] = ACTIONS(3308),
    [anon_sym_ge] = ACTIONS(3308),
    [anon_sym_gt] = ACTIONS(3308),
    [anon_sym_isa] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [anon_sym_BSLASH] = ACTIONS(3306),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_eval] = ACTIONS(3308),
    [anon_sym_field] = ACTIONS(3308),
    [anon_sym_local] = ACTIONS(3308),
    [anon_sym_require] = ACTIONS(3308),
    [anon_sym_map] = ACTIONS(3308),
    [anon_sym_grep] = ACTIONS(3308),
    [anon_sym_sort] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_undef] = ACTIONS(3308),
    [anon_sym_PERCENT2] = ACTIONS(3308),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_no] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_foreach] = ACTIONS(3308),
    [anon_sym_last] = ACTIONS(3308),
    [anon_sym_next] = ACTIONS(3308),
    [anon_sym_redo] = ACTIONS(3308),
    [anon_sym_BEGIN] = ACTIONS(3308),
    [anon_sym_INIT] = ACTIONS(3308),
    [anon_sym_CHECK] = ACTIONS(3308),
    [anon_sym_UNITCHECK] = ACTIONS(3308),
    [anon_sym_END] = ACTIONS(3308),
    [anon_sym_ADJUST] = ACTIONS(3308),
    [anon_sym___FILE__] = ACTIONS(3308),
    [anon_sym___LINE__] = ACTIONS(3308),
    [anon_sym___PACKAGE__] = ACTIONS(3308),
    [anon_sym___SUB__] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_fork] = ACTIONS(3308),
    [anon_sym_getppid] = ACTIONS(3308),
    [anon_sym_time] = ACTIONS(3308),
    [anon_sym_times] = ACTIONS(3308),
    [anon_sym_wait] = ACTIONS(3308),
    [anon_sym_wantarray] = ACTIONS(3308),
    [anon_sym_abs] = ACTIONS(3308),
    [anon_sym_alarm] = ACTIONS(3308),
    [anon_sym_chop] = ACTIONS(3308),
    [anon_sym_chdir] = ACTIONS(3308),
    [anon_sym_close] = ACTIONS(3308),
    [anon_sym_closedir] = ACTIONS(3308),
    [anon_sym_caller] = ACTIONS(3308),
    [anon_sym_chomp] = ACTIONS(3308),
    [anon_sym_chr] = ACTIONS(3308),
    [anon_sym_cos] = ACTIONS(3308),
    [anon_sym_chroot] = ACTIONS(3308),
    [anon_sym_defined] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_dbmclose] = ACTIONS(3308),
    [anon_sym_exists] = ACTIONS(3308),
    [anon_sym_exit] = ACTIONS(3308),
    [anon_sym_eof] = ACTIONS(3308),
    [anon_sym_exp] = ACTIONS(3308),
    [anon_sym_each] = ACTIONS(3308),
    [anon_sym_fc] = ACTIONS(3308),
    [anon_sym_fileno] = ACTIONS(3308),
    [anon_sym_gmtime] = ACTIONS(3308),
    [anon_sym_getc] = ACTIONS(3308),
    [anon_sym_getpgrp] = ACTIONS(3308),
    [anon_sym_getprotobyname] = ACTIONS(3308),
    [anon_sym_getpwname] = ACTIONS(3308),
    [anon_sym_getpwuid] = ACTIONS(3308),
    [anon_sym_getpeername] = ACTIONS(3308),
    [anon_sym_getnetbyname] = ACTIONS(3308),
    [anon_sym_getsockname] = ACTIONS(3308),
    [anon_sym_getgrnam] = ACTIONS(3308),
    [anon_sym_getgrgid] = ACTIONS(3308),
    [anon_sym_hex] = ACTIONS(3308),
    [anon_sym_int] = ACTIONS(3308),
    [anon_sym_keys] = ACTIONS(3308),
    [anon_sym_lc] = ACTIONS(3308),
    [anon_sym_lcfirst] = ACTIONS(3308),
    [anon_sym_length] = ACTIONS(3308),
    [anon_sym_localtime] = ACTIONS(3308),
    [anon_sym_log] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_lstat] = ACTIONS(3308),
    [anon_sym_oct] = ACTIONS(3308),
    [anon_sym_ord] = ACTIONS(3308),
    [anon_sym_prototype] = ACTIONS(3308),
    [anon_sym_pop] = ACTIONS(3308),
    [anon_sym_pos] = ACTIONS(3308),
    [anon_sym_quotemeta] = ACTIONS(3308),
    [anon_sym_reset] = ACTIONS(3308),
    [anon_sym_rand] = ACTIONS(3308),
    [anon_sym_rmdir] = ACTIONS(3308),
    [anon_sym_readdir] = ACTIONS(3308),
    [anon_sym_readline] = ACTIONS(3308),
    [anon_sym_readpipe] = ACTIONS(3308),
    [anon_sym_rewinddir] = ACTIONS(3308),
    [anon_sym_readlink] = ACTIONS(3308),
    [anon_sym_ref] = ACTIONS(3308),
    [anon_sym_scalar] = ACTIONS(3308),
    [anon_sym_shift] = ACTIONS(3308),
    [anon_sym_sin] = ACTIONS(3308),
    [anon_sym_sleep] = ACTIONS(3308),
    [anon_sym_sqrt] = ACTIONS(3308),
    [anon_sym_srand] = ACTIONS(3308),
    [anon_sym_stat] = ACTIONS(3308),
    [anon_sym_study] = ACTIONS(3308),
    [anon_sym_tell] = ACTIONS(3308),
    [anon_sym_telldir] = ACTIONS(3308),
    [anon_sym_tied] = ACTIONS(3308),
    [anon_sym_uc] = ACTIONS(3308),
    [anon_sym_ucfirst] = ACTIONS(3308),
    [anon_sym_untie] = ACTIONS(3308),
    [anon_sym_umask] = ACTIONS(3308),
    [anon_sym_values] = ACTIONS(3308),
    [anon_sym_write] = ACTIONS(3308),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3308),
    [anon_sym___END__] = ACTIONS(3308),
    [anon_sym_q] = ACTIONS(3308),
    [anon_sym_qq] = ACTIONS(3308),
    [anon_sym_qw] = ACTIONS(3308),
    [anon_sym_qx] = ACTIONS(3308),
    [anon_sym_qr] = ACTIONS(3308),
    [anon_sym_m] = ACTIONS(3308),
    [anon_sym_s] = ACTIONS(3308),
    [anon_sym_tr] = ACTIONS(3308),
    [anon_sym_y] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_unless] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_until] = ACTIONS(3308),
    [aux_sym__bareword_token1] = ACTIONS(3308),
    [sym_number] = ACTIONS(3308),
    [sym__apostrophe] = ACTIONS(3306),
    [sym__double_quote] = ACTIONS(3306),
    [sym__backtick] = ACTIONS(3306),
    [sym__search_slash] = ACTIONS(3306),
    [sym__PERLY_HEREDOC] = ACTIONS(3306),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1110] = {
    [sym_heredoc_content] = STATE(1110),
    [sym__identifier] = ACTIONS(3220),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_LBRACE2] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_package] = ACTIONS(3220),
    [anon_sym_class] = ACTIONS(3220),
    [anon_sym_sub] = ACTIONS(3220),
    [anon_sym_method] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [anon_sym_continue] = ACTIONS(3220),
    [anon_sym_my] = ACTIONS(3220),
    [anon_sym_state] = ACTIONS(3220),
    [anon_sym_our] = ACTIONS(3220),
    [anon_sym_try] = ACTIONS(3220),
    [anon_sym_defer] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3220),
    [anon_sym_else] = ACTIONS(3220),
    [anon_sym_elsif] = ACTIONS(3220),
    [anon_sym_and] = ACTIONS(3220),
    [anon_sym_or] = ACTIONS(3220),
    [anon_sym_DOLLAR] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [anon_sym_AT] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_LT_LT] = ACTIONS(3220),
    [anon_sym_SLASH_SLASH] = ACTIONS(3220),
    [anon_sym_PLUS] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3220),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_eq] = ACTIONS(3220),
    [anon_sym_ne] = ACTIONS(3220),
    [anon_sym_cmp] = ACTIONS(3220),
    [anon_sym_lt] = ACTIONS(3220),
    [anon_sym_le] = ACTIONS(3220),
    [anon_sym_ge] = ACTIONS(3220),
    [anon_sym_gt] = ACTIONS(3220),
    [anon_sym_isa] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_BSLASH] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3220),
    [anon_sym_eval] = ACTIONS(3220),
    [anon_sym_field] = ACTIONS(3220),
    [anon_sym_local] = ACTIONS(3220),
    [anon_sym_require] = ACTIONS(3220),
    [anon_sym_map] = ACTIONS(3220),
    [anon_sym_grep] = ACTIONS(3220),
    [anon_sym_sort] = ACTIONS(3220),
    [anon_sym_goto] = ACTIONS(3220),
    [anon_sym_return] = ACTIONS(3220),
    [anon_sym_undef] = ACTIONS(3220),
    [anon_sym_PERCENT2] = ACTIONS(3220),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3220),
    [anon_sym_use] = ACTIONS(3220),
    [anon_sym_no] = ACTIONS(3220),
    [anon_sym_for] = ACTIONS(3220),
    [anon_sym_foreach] = ACTIONS(3220),
    [anon_sym_last] = ACTIONS(3220),
    [anon_sym_next] = ACTIONS(3220),
    [anon_sym_redo] = ACTIONS(3220),
    [anon_sym_BEGIN] = ACTIONS(3220),
    [anon_sym_INIT] = ACTIONS(3220),
    [anon_sym_CHECK] = ACTIONS(3220),
    [anon_sym_UNITCHECK] = ACTIONS(3220),
    [anon_sym_END] = ACTIONS(3220),
    [anon_sym_ADJUST] = ACTIONS(3220),
    [anon_sym___FILE__] = ACTIONS(3220),
    [anon_sym___LINE__] = ACTIONS(3220),
    [anon_sym___PACKAGE__] = ACTIONS(3220),
    [anon_sym___SUB__] = ACTIONS(3220),
    [anon_sym_break] = ACTIONS(3220),
    [anon_sym_fork] = ACTIONS(3220),
    [anon_sym_getppid] = ACTIONS(3220),
    [anon_sym_time] = ACTIONS(3220),
    [anon_sym_times] = ACTIONS(3220),
    [anon_sym_wait] = ACTIONS(3220),
    [anon_sym_wantarray] = ACTIONS(3220),
    [anon_sym_abs] = ACTIONS(3220),
    [anon_sym_alarm] = ACTIONS(3220),
    [anon_sym_chop] = ACTIONS(3220),
    [anon_sym_chdir] = ACTIONS(3220),
    [anon_sym_close] = ACTIONS(3220),
    [anon_sym_closedir] = ACTIONS(3220),
    [anon_sym_caller] = ACTIONS(3220),
    [anon_sym_chomp] = ACTIONS(3220),
    [anon_sym_chr] = ACTIONS(3220),
    [anon_sym_cos] = ACTIONS(3220),
    [anon_sym_chroot] = ACTIONS(3220),
    [anon_sym_defined] = ACTIONS(3220),
    [anon_sym_delete] = ACTIONS(3220),
    [anon_sym_dbmclose] = ACTIONS(3220),
    [anon_sym_exists] = ACTIONS(3220),
    [anon_sym_exit] = ACTIONS(3220),
    [anon_sym_eof] = ACTIONS(3220),
    [anon_sym_exp] = ACTIONS(3220),
    [anon_sym_each] = ACTIONS(3220),
    [anon_sym_fc] = ACTIONS(3220),
    [anon_sym_fileno] = ACTIONS(3220),
    [anon_sym_gmtime] = ACTIONS(3220),
    [anon_sym_getc] = ACTIONS(3220),
    [anon_sym_getpgrp] = ACTIONS(3220),
    [anon_sym_getprotobyname] = ACTIONS(3220),
    [anon_sym_getpwname] = ACTIONS(3220),
    [anon_sym_getpwuid] = ACTIONS(3220),
    [anon_sym_getpeername] = ACTIONS(3220),
    [anon_sym_getnetbyname] = ACTIONS(3220),
    [anon_sym_getsockname] = ACTIONS(3220),
    [anon_sym_getgrnam] = ACTIONS(3220),
    [anon_sym_getgrgid] = ACTIONS(3220),
    [anon_sym_hex] = ACTIONS(3220),
    [anon_sym_int] = ACTIONS(3220),
    [anon_sym_keys] = ACTIONS(3220),
    [anon_sym_lc] = ACTIONS(3220),
    [anon_sym_lcfirst] = ACTIONS(3220),
    [anon_sym_length] = ACTIONS(3220),
    [anon_sym_localtime] = ACTIONS(3220),
    [anon_sym_log] = ACTIONS(3220),
    [anon_sym_lock] = ACTIONS(3220),
    [anon_sym_lstat] = ACTIONS(3220),
    [anon_sym_oct] = ACTIONS(3220),
    [anon_sym_ord] = ACTIONS(3220),
    [anon_sym_prototype] = ACTIONS(3220),
    [anon_sym_pop] = ACTIONS(3220),
    [anon_sym_pos] = ACTIONS(3220),
    [anon_sym_quotemeta] = ACTIONS(3220),
    [anon_sym_reset] = ACTIONS(3220),
    [anon_sym_rand] = ACTIONS(3220),
    [anon_sym_rmdir] = ACTIONS(3220),
    [anon_sym_readdir] = ACTIONS(3220),
    [anon_sym_readline] = ACTIONS(3220),
    [anon_sym_readpipe] = ACTIONS(3220),
    [anon_sym_rewinddir] = ACTIONS(3220),
    [anon_sym_readlink] = ACTIONS(3220),
    [anon_sym_ref] = ACTIONS(3220),
    [anon_sym_scalar] = ACTIONS(3220),
    [anon_sym_shift] = ACTIONS(3220),
    [anon_sym_sin] = ACTIONS(3220),
    [anon_sym_sleep] = ACTIONS(3220),
    [anon_sym_sqrt] = ACTIONS(3220),
    [anon_sym_srand] = ACTIONS(3220),
    [anon_sym_stat] = ACTIONS(3220),
    [anon_sym_study] = ACTIONS(3220),
    [anon_sym_tell] = ACTIONS(3220),
    [anon_sym_telldir] = ACTIONS(3220),
    [anon_sym_tied] = ACTIONS(3220),
    [anon_sym_uc] = ACTIONS(3220),
    [anon_sym_ucfirst] = ACTIONS(3220),
    [anon_sym_untie] = ACTIONS(3220),
    [anon_sym_umask] = ACTIONS(3220),
    [anon_sym_values] = ACTIONS(3220),
    [anon_sym_write] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3220),
    [anon_sym___END__] = ACTIONS(3220),
    [anon_sym_q] = ACTIONS(3220),
    [anon_sym_qq] = ACTIONS(3220),
    [anon_sym_qw] = ACTIONS(3220),
    [anon_sym_qx] = ACTIONS(3220),
    [anon_sym_qr] = ACTIONS(3220),
    [anon_sym_m] = ACTIONS(3220),
    [anon_sym_s] = ACTIONS(3220),
    [anon_sym_tr] = ACTIONS(3220),
    [anon_sym_y] = ACTIONS(3220),
    [anon_sym_if] = ACTIONS(3220),
    [anon_sym_unless] = ACTIONS(3220),
    [anon_sym_while] = ACTIONS(3220),
    [anon_sym_until] = ACTIONS(3220),
    [aux_sym__bareword_token1] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [sym__apostrophe] = ACTIONS(3218),
    [sym__double_quote] = ACTIONS(3218),
    [sym__backtick] = ACTIONS(3218),
    [sym__search_slash] = ACTIONS(3218),
    [sym__PERLY_HEREDOC] = ACTIONS(3218),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1111] = {
    [sym_heredoc_content] = STATE(1111),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_LBRACE2] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_package] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_defer] = ACTIONS(2905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1112] = {
    [sym_heredoc_content] = STATE(1112),
    [sym__identifier] = ACTIONS(3248),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_LBRACE2] = ACTIONS(3248),
    [anon_sym_RBRACE] = ACTIONS(3248),
    [anon_sym_SEMI] = ACTIONS(3248),
    [anon_sym_package] = ACTIONS(3248),
    [anon_sym_class] = ACTIONS(3248),
    [anon_sym_sub] = ACTIONS(3248),
    [anon_sym_method] = ACTIONS(3248),
    [anon_sym_LPAREN] = ACTIONS(3248),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_my] = ACTIONS(3248),
    [anon_sym_state] = ACTIONS(3248),
    [anon_sym_our] = ACTIONS(3248),
    [anon_sym_try] = ACTIONS(3248),
    [anon_sym_defer] = ACTIONS(3248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3248),
    [anon_sym_else] = ACTIONS(3248),
    [anon_sym_elsif] = ACTIONS(3248),
    [anon_sym_and] = ACTIONS(3248),
    [anon_sym_or] = ACTIONS(3248),
    [anon_sym_DOLLAR] = ACTIONS(3248),
    [anon_sym_LBRACK] = ACTIONS(3248),
    [anon_sym_AT] = ACTIONS(3248),
    [anon_sym_LT] = ACTIONS(3248),
    [anon_sym_LT_LT] = ACTIONS(3248),
    [anon_sym_SLASH_SLASH] = ACTIONS(3248),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3248),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_eq] = ACTIONS(3248),
    [anon_sym_ne] = ACTIONS(3248),
    [anon_sym_cmp] = ACTIONS(3248),
    [anon_sym_lt] = ACTIONS(3248),
    [anon_sym_le] = ACTIONS(3248),
    [anon_sym_ge] = ACTIONS(3248),
    [anon_sym_gt] = ACTIONS(3248),
    [anon_sym_isa] = ACTIONS(3248),
    [anon_sym_TILDE] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3248),
    [anon_sym_DASH_DASH] = ACTIONS(3248),
    [anon_sym_BSLASH] = ACTIONS(3246),
    [anon_sym_do] = ACTIONS(3248),
    [anon_sym_eval] = ACTIONS(3248),
    [anon_sym_field] = ACTIONS(3248),
    [anon_sym_local] = ACTIONS(3248),
    [anon_sym_require] = ACTIONS(3248),
    [anon_sym_map] = ACTIONS(3248),
    [anon_sym_grep] = ACTIONS(3248),
    [anon_sym_sort] = ACTIONS(3248),
    [anon_sym_goto] = ACTIONS(3248),
    [anon_sym_return] = ACTIONS(3248),
    [anon_sym_undef] = ACTIONS(3248),
    [anon_sym_PERCENT2] = ACTIONS(3248),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3248),
    [anon_sym_use] = ACTIONS(3248),
    [anon_sym_no] = ACTIONS(3248),
    [anon_sym_for] = ACTIONS(3248),
    [anon_sym_foreach] = ACTIONS(3248),
    [anon_sym_last] = ACTIONS(3248),
    [anon_sym_next] = ACTIONS(3248),
    [anon_sym_redo] = ACTIONS(3248),
    [anon_sym_BEGIN] = ACTIONS(3248),
    [anon_sym_INIT] = ACTIONS(3248),
    [anon_sym_CHECK] = ACTIONS(3248),
    [anon_sym_UNITCHECK] = ACTIONS(3248),
    [anon_sym_END] = ACTIONS(3248),
    [anon_sym_ADJUST] = ACTIONS(3248),
    [anon_sym___FILE__] = ACTIONS(3248),
    [anon_sym___LINE__] = ACTIONS(3248),
    [anon_sym___PACKAGE__] = ACTIONS(3248),
    [anon_sym___SUB__] = ACTIONS(3248),
    [anon_sym_break] = ACTIONS(3248),
    [anon_sym_fork] = ACTIONS(3248),
    [anon_sym_getppid] = ACTIONS(3248),
    [anon_sym_time] = ACTIONS(3248),
    [anon_sym_times] = ACTIONS(3248),
    [anon_sym_wait] = ACTIONS(3248),
    [anon_sym_wantarray] = ACTIONS(3248),
    [anon_sym_abs] = ACTIONS(3248),
    [anon_sym_alarm] = ACTIONS(3248),
    [anon_sym_chop] = ACTIONS(3248),
    [anon_sym_chdir] = ACTIONS(3248),
    [anon_sym_close] = ACTIONS(3248),
    [anon_sym_closedir] = ACTIONS(3248),
    [anon_sym_caller] = ACTIONS(3248),
    [anon_sym_chomp] = ACTIONS(3248),
    [anon_sym_chr] = ACTIONS(3248),
    [anon_sym_cos] = ACTIONS(3248),
    [anon_sym_chroot] = ACTIONS(3248),
    [anon_sym_defined] = ACTIONS(3248),
    [anon_sym_delete] = ACTIONS(3248),
    [anon_sym_dbmclose] = ACTIONS(3248),
    [anon_sym_exists] = ACTIONS(3248),
    [anon_sym_exit] = ACTIONS(3248),
    [anon_sym_eof] = ACTIONS(3248),
    [anon_sym_exp] = ACTIONS(3248),
    [anon_sym_each] = ACTIONS(3248),
    [anon_sym_fc] = ACTIONS(3248),
    [anon_sym_fileno] = ACTIONS(3248),
    [anon_sym_gmtime] = ACTIONS(3248),
    [anon_sym_getc] = ACTIONS(3248),
    [anon_sym_getpgrp] = ACTIONS(3248),
    [anon_sym_getprotobyname] = ACTIONS(3248),
    [anon_sym_getpwname] = ACTIONS(3248),
    [anon_sym_getpwuid] = ACTIONS(3248),
    [anon_sym_getpeername] = ACTIONS(3248),
    [anon_sym_getnetbyname] = ACTIONS(3248),
    [anon_sym_getsockname] = ACTIONS(3248),
    [anon_sym_getgrnam] = ACTIONS(3248),
    [anon_sym_getgrgid] = ACTIONS(3248),
    [anon_sym_hex] = ACTIONS(3248),
    [anon_sym_int] = ACTIONS(3248),
    [anon_sym_keys] = ACTIONS(3248),
    [anon_sym_lc] = ACTIONS(3248),
    [anon_sym_lcfirst] = ACTIONS(3248),
    [anon_sym_length] = ACTIONS(3248),
    [anon_sym_localtime] = ACTIONS(3248),
    [anon_sym_log] = ACTIONS(3248),
    [anon_sym_lock] = ACTIONS(3248),
    [anon_sym_lstat] = ACTIONS(3248),
    [anon_sym_oct] = ACTIONS(3248),
    [anon_sym_ord] = ACTIONS(3248),
    [anon_sym_prototype] = ACTIONS(3248),
    [anon_sym_pop] = ACTIONS(3248),
    [anon_sym_pos] = ACTIONS(3248),
    [anon_sym_quotemeta] = ACTIONS(3248),
    [anon_sym_reset] = ACTIONS(3248),
    [anon_sym_rand] = ACTIONS(3248),
    [anon_sym_rmdir] = ACTIONS(3248),
    [anon_sym_readdir] = ACTIONS(3248),
    [anon_sym_readline] = ACTIONS(3248),
    [anon_sym_readpipe] = ACTIONS(3248),
    [anon_sym_rewinddir] = ACTIONS(3248),
    [anon_sym_readlink] = ACTIONS(3248),
    [anon_sym_ref] = ACTIONS(3248),
    [anon_sym_scalar] = ACTIONS(3248),
    [anon_sym_shift] = ACTIONS(3248),
    [anon_sym_sin] = ACTIONS(3248),
    [anon_sym_sleep] = ACTIONS(3248),
    [anon_sym_sqrt] = ACTIONS(3248),
    [anon_sym_srand] = ACTIONS(3248),
    [anon_sym_stat] = ACTIONS(3248),
    [anon_sym_study] = ACTIONS(3248),
    [anon_sym_tell] = ACTIONS(3248),
    [anon_sym_telldir] = ACTIONS(3248),
    [anon_sym_tied] = ACTIONS(3248),
    [anon_sym_uc] = ACTIONS(3248),
    [anon_sym_ucfirst] = ACTIONS(3248),
    [anon_sym_untie] = ACTIONS(3248),
    [anon_sym_umask] = ACTIONS(3248),
    [anon_sym_values] = ACTIONS(3248),
    [anon_sym_write] = ACTIONS(3248),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3248),
    [anon_sym___END__] = ACTIONS(3248),
    [anon_sym_q] = ACTIONS(3248),
    [anon_sym_qq] = ACTIONS(3248),
    [anon_sym_qw] = ACTIONS(3248),
    [anon_sym_qx] = ACTIONS(3248),
    [anon_sym_qr] = ACTIONS(3248),
    [anon_sym_m] = ACTIONS(3248),
    [anon_sym_s] = ACTIONS(3248),
    [anon_sym_tr] = ACTIONS(3248),
    [anon_sym_y] = ACTIONS(3248),
    [anon_sym_if] = ACTIONS(3248),
    [anon_sym_unless] = ACTIONS(3248),
    [anon_sym_while] = ACTIONS(3248),
    [anon_sym_until] = ACTIONS(3248),
    [aux_sym__bareword_token1] = ACTIONS(3248),
    [sym_number] = ACTIONS(3248),
    [sym__apostrophe] = ACTIONS(3246),
    [sym__double_quote] = ACTIONS(3246),
    [sym__backtick] = ACTIONS(3246),
    [sym__search_slash] = ACTIONS(3246),
    [sym__PERLY_HEREDOC] = ACTIONS(3246),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1113] = {
    [sym_heredoc_content] = STATE(1113),
    [sym__identifier] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_LBRACE2] = ACTIONS(3270),
    [anon_sym_RBRACE] = ACTIONS(3270),
    [anon_sym_SEMI] = ACTIONS(3270),
    [anon_sym_package] = ACTIONS(3270),
    [anon_sym_class] = ACTIONS(3270),
    [anon_sym_sub] = ACTIONS(3270),
    [anon_sym_method] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_my] = ACTIONS(3270),
    [anon_sym_state] = ACTIONS(3270),
    [anon_sym_our] = ACTIONS(3270),
    [anon_sym_try] = ACTIONS(3270),
    [anon_sym_defer] = ACTIONS(3270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3270),
    [anon_sym_else] = ACTIONS(3270),
    [anon_sym_elsif] = ACTIONS(3270),
    [anon_sym_and] = ACTIONS(3270),
    [anon_sym_or] = ACTIONS(3270),
    [anon_sym_DOLLAR] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_AT] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_eq] = ACTIONS(3270),
    [anon_sym_ne] = ACTIONS(3270),
    [anon_sym_cmp] = ACTIONS(3270),
    [anon_sym_lt] = ACTIONS(3270),
    [anon_sym_le] = ACTIONS(3270),
    [anon_sym_ge] = ACTIONS(3270),
    [anon_sym_gt] = ACTIONS(3270),
    [anon_sym_isa] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_BSLASH] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3270),
    [anon_sym_eval] = ACTIONS(3270),
    [anon_sym_field] = ACTIONS(3270),
    [anon_sym_local] = ACTIONS(3270),
    [anon_sym_require] = ACTIONS(3270),
    [anon_sym_map] = ACTIONS(3270),
    [anon_sym_grep] = ACTIONS(3270),
    [anon_sym_sort] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_undef] = ACTIONS(3270),
    [anon_sym_PERCENT2] = ACTIONS(3270),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3270),
    [anon_sym_use] = ACTIONS(3270),
    [anon_sym_no] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_foreach] = ACTIONS(3270),
    [anon_sym_last] = ACTIONS(3270),
    [anon_sym_next] = ACTIONS(3270),
    [anon_sym_redo] = ACTIONS(3270),
    [anon_sym_BEGIN] = ACTIONS(3270),
    [anon_sym_INIT] = ACTIONS(3270),
    [anon_sym_CHECK] = ACTIONS(3270),
    [anon_sym_UNITCHECK] = ACTIONS(3270),
    [anon_sym_END] = ACTIONS(3270),
    [anon_sym_ADJUST] = ACTIONS(3270),
    [anon_sym___FILE__] = ACTIONS(3270),
    [anon_sym___LINE__] = ACTIONS(3270),
    [anon_sym___PACKAGE__] = ACTIONS(3270),
    [anon_sym___SUB__] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_fork] = ACTIONS(3270),
    [anon_sym_getppid] = ACTIONS(3270),
    [anon_sym_time] = ACTIONS(3270),
    [anon_sym_times] = ACTIONS(3270),
    [anon_sym_wait] = ACTIONS(3270),
    [anon_sym_wantarray] = ACTIONS(3270),
    [anon_sym_abs] = ACTIONS(3270),
    [anon_sym_alarm] = ACTIONS(3270),
    [anon_sym_chop] = ACTIONS(3270),
    [anon_sym_chdir] = ACTIONS(3270),
    [anon_sym_close] = ACTIONS(3270),
    [anon_sym_closedir] = ACTIONS(3270),
    [anon_sym_caller] = ACTIONS(3270),
    [anon_sym_chomp] = ACTIONS(3270),
    [anon_sym_chr] = ACTIONS(3270),
    [anon_sym_cos] = ACTIONS(3270),
    [anon_sym_chroot] = ACTIONS(3270),
    [anon_sym_defined] = ACTIONS(3270),
    [anon_sym_delete] = ACTIONS(3270),
    [anon_sym_dbmclose] = ACTIONS(3270),
    [anon_sym_exists] = ACTIONS(3270),
    [anon_sym_exit] = ACTIONS(3270),
    [anon_sym_eof] = ACTIONS(3270),
    [anon_sym_exp] = ACTIONS(3270),
    [anon_sym_each] = ACTIONS(3270),
    [anon_sym_fc] = ACTIONS(3270),
    [anon_sym_fileno] = ACTIONS(3270),
    [anon_sym_gmtime] = ACTIONS(3270),
    [anon_sym_getc] = ACTIONS(3270),
    [anon_sym_getpgrp] = ACTIONS(3270),
    [anon_sym_getprotobyname] = ACTIONS(3270),
    [anon_sym_getpwname] = ACTIONS(3270),
    [anon_sym_getpwuid] = ACTIONS(3270),
    [anon_sym_getpeername] = ACTIONS(3270),
    [anon_sym_getnetbyname] = ACTIONS(3270),
    [anon_sym_getsockname] = ACTIONS(3270),
    [anon_sym_getgrnam] = ACTIONS(3270),
    [anon_sym_getgrgid] = ACTIONS(3270),
    [anon_sym_hex] = ACTIONS(3270),
    [anon_sym_int] = ACTIONS(3270),
    [anon_sym_keys] = ACTIONS(3270),
    [anon_sym_lc] = ACTIONS(3270),
    [anon_sym_lcfirst] = ACTIONS(3270),
    [anon_sym_length] = ACTIONS(3270),
    [anon_sym_localtime] = ACTIONS(3270),
    [anon_sym_log] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_lstat] = ACTIONS(3270),
    [anon_sym_oct] = ACTIONS(3270),
    [anon_sym_ord] = ACTIONS(3270),
    [anon_sym_prototype] = ACTIONS(3270),
    [anon_sym_pop] = ACTIONS(3270),
    [anon_sym_pos] = ACTIONS(3270),
    [anon_sym_quotemeta] = ACTIONS(3270),
    [anon_sym_reset] = ACTIONS(3270),
    [anon_sym_rand] = ACTIONS(3270),
    [anon_sym_rmdir] = ACTIONS(3270),
    [anon_sym_readdir] = ACTIONS(3270),
    [anon_sym_readline] = ACTIONS(3270),
    [anon_sym_readpipe] = ACTIONS(3270),
    [anon_sym_rewinddir] = ACTIONS(3270),
    [anon_sym_readlink] = ACTIONS(3270),
    [anon_sym_ref] = ACTIONS(3270),
    [anon_sym_scalar] = ACTIONS(3270),
    [anon_sym_shift] = ACTIONS(3270),
    [anon_sym_sin] = ACTIONS(3270),
    [anon_sym_sleep] = ACTIONS(3270),
    [anon_sym_sqrt] = ACTIONS(3270),
    [anon_sym_srand] = ACTIONS(3270),
    [anon_sym_stat] = ACTIONS(3270),
    [anon_sym_study] = ACTIONS(3270),
    [anon_sym_tell] = ACTIONS(3270),
    [anon_sym_telldir] = ACTIONS(3270),
    [anon_sym_tied] = ACTIONS(3270),
    [anon_sym_uc] = ACTIONS(3270),
    [anon_sym_ucfirst] = ACTIONS(3270),
    [anon_sym_untie] = ACTIONS(3270),
    [anon_sym_umask] = ACTIONS(3270),
    [anon_sym_values] = ACTIONS(3270),
    [anon_sym_write] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3270),
    [anon_sym___END__] = ACTIONS(3270),
    [anon_sym_q] = ACTIONS(3270),
    [anon_sym_qq] = ACTIONS(3270),
    [anon_sym_qw] = ACTIONS(3270),
    [anon_sym_qx] = ACTIONS(3270),
    [anon_sym_qr] = ACTIONS(3270),
    [anon_sym_m] = ACTIONS(3270),
    [anon_sym_s] = ACTIONS(3270),
    [anon_sym_tr] = ACTIONS(3270),
    [anon_sym_y] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_unless] = ACTIONS(3270),
    [anon_sym_while] = ACTIONS(3270),
    [anon_sym_until] = ACTIONS(3270),
    [aux_sym__bareword_token1] = ACTIONS(3270),
    [sym_number] = ACTIONS(3270),
    [sym__apostrophe] = ACTIONS(3268),
    [sym__double_quote] = ACTIONS(3268),
    [sym__backtick] = ACTIONS(3268),
    [sym__search_slash] = ACTIONS(3268),
    [sym__PERLY_HEREDOC] = ACTIONS(3268),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1114] = {
    [sym_heredoc_content] = STATE(1114),
    [sym__identifier] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_LBRACE2] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_package] = ACTIONS(3312),
    [anon_sym_class] = ACTIONS(3312),
    [anon_sym_sub] = ACTIONS(3312),
    [anon_sym_method] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_my] = ACTIONS(3312),
    [anon_sym_state] = ACTIONS(3312),
    [anon_sym_our] = ACTIONS(3312),
    [anon_sym_try] = ACTIONS(3312),
    [anon_sym_defer] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3312),
    [anon_sym_else] = ACTIONS(3312),
    [anon_sym_elsif] = ACTIONS(3312),
    [anon_sym_and] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3312),
    [anon_sym_AT] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_eq] = ACTIONS(3312),
    [anon_sym_ne] = ACTIONS(3312),
    [anon_sym_cmp] = ACTIONS(3312),
    [anon_sym_lt] = ACTIONS(3312),
    [anon_sym_le] = ACTIONS(3312),
    [anon_sym_ge] = ACTIONS(3312),
    [anon_sym_gt] = ACTIONS(3312),
    [anon_sym_isa] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_BSLASH] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3312),
    [anon_sym_eval] = ACTIONS(3312),
    [anon_sym_field] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3312),
    [anon_sym_require] = ACTIONS(3312),
    [anon_sym_map] = ACTIONS(3312),
    [anon_sym_grep] = ACTIONS(3312),
    [anon_sym_sort] = ACTIONS(3312),
    [anon_sym_goto] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_undef] = ACTIONS(3312),
    [anon_sym_PERCENT2] = ACTIONS(3312),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3312),
    [anon_sym_no] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_foreach] = ACTIONS(3312),
    [anon_sym_last] = ACTIONS(3312),
    [anon_sym_next] = ACTIONS(3312),
    [anon_sym_redo] = ACTIONS(3312),
    [anon_sym_BEGIN] = ACTIONS(3312),
    [anon_sym_INIT] = ACTIONS(3312),
    [anon_sym_CHECK] = ACTIONS(3312),
    [anon_sym_UNITCHECK] = ACTIONS(3312),
    [anon_sym_END] = ACTIONS(3312),
    [anon_sym_ADJUST] = ACTIONS(3312),
    [anon_sym___FILE__] = ACTIONS(3312),
    [anon_sym___LINE__] = ACTIONS(3312),
    [anon_sym___PACKAGE__] = ACTIONS(3312),
    [anon_sym___SUB__] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_fork] = ACTIONS(3312),
    [anon_sym_getppid] = ACTIONS(3312),
    [anon_sym_time] = ACTIONS(3312),
    [anon_sym_times] = ACTIONS(3312),
    [anon_sym_wait] = ACTIONS(3312),
    [anon_sym_wantarray] = ACTIONS(3312),
    [anon_sym_abs] = ACTIONS(3312),
    [anon_sym_alarm] = ACTIONS(3312),
    [anon_sym_chop] = ACTIONS(3312),
    [anon_sym_chdir] = ACTIONS(3312),
    [anon_sym_close] = ACTIONS(3312),
    [anon_sym_closedir] = ACTIONS(3312),
    [anon_sym_caller] = ACTIONS(3312),
    [anon_sym_chomp] = ACTIONS(3312),
    [anon_sym_chr] = ACTIONS(3312),
    [anon_sym_cos] = ACTIONS(3312),
    [anon_sym_chroot] = ACTIONS(3312),
    [anon_sym_defined] = ACTIONS(3312),
    [anon_sym_delete] = ACTIONS(3312),
    [anon_sym_dbmclose] = ACTIONS(3312),
    [anon_sym_exists] = ACTIONS(3312),
    [anon_sym_exit] = ACTIONS(3312),
    [anon_sym_eof] = ACTIONS(3312),
    [anon_sym_exp] = ACTIONS(3312),
    [anon_sym_each] = ACTIONS(3312),
    [anon_sym_fc] = ACTIONS(3312),
    [anon_sym_fileno] = ACTIONS(3312),
    [anon_sym_gmtime] = ACTIONS(3312),
    [anon_sym_getc] = ACTIONS(3312),
    [anon_sym_getpgrp] = ACTIONS(3312),
    [anon_sym_getprotobyname] = ACTIONS(3312),
    [anon_sym_getpwname] = ACTIONS(3312),
    [anon_sym_getpwuid] = ACTIONS(3312),
    [anon_sym_getpeername] = ACTIONS(3312),
    [anon_sym_getnetbyname] = ACTIONS(3312),
    [anon_sym_getsockname] = ACTIONS(3312),
    [anon_sym_getgrnam] = ACTIONS(3312),
    [anon_sym_getgrgid] = ACTIONS(3312),
    [anon_sym_hex] = ACTIONS(3312),
    [anon_sym_int] = ACTIONS(3312),
    [anon_sym_keys] = ACTIONS(3312),
    [anon_sym_lc] = ACTIONS(3312),
    [anon_sym_lcfirst] = ACTIONS(3312),
    [anon_sym_length] = ACTIONS(3312),
    [anon_sym_localtime] = ACTIONS(3312),
    [anon_sym_log] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_lstat] = ACTIONS(3312),
    [anon_sym_oct] = ACTIONS(3312),
    [anon_sym_ord] = ACTIONS(3312),
    [anon_sym_prototype] = ACTIONS(3312),
    [anon_sym_pop] = ACTIONS(3312),
    [anon_sym_pos] = ACTIONS(3312),
    [anon_sym_quotemeta] = ACTIONS(3312),
    [anon_sym_reset] = ACTIONS(3312),
    [anon_sym_rand] = ACTIONS(3312),
    [anon_sym_rmdir] = ACTIONS(3312),
    [anon_sym_readdir] = ACTIONS(3312),
    [anon_sym_readline] = ACTIONS(3312),
    [anon_sym_readpipe] = ACTIONS(3312),
    [anon_sym_rewinddir] = ACTIONS(3312),
    [anon_sym_readlink] = ACTIONS(3312),
    [anon_sym_ref] = ACTIONS(3312),
    [anon_sym_scalar] = ACTIONS(3312),
    [anon_sym_shift] = ACTIONS(3312),
    [anon_sym_sin] = ACTIONS(3312),
    [anon_sym_sleep] = ACTIONS(3312),
    [anon_sym_sqrt] = ACTIONS(3312),
    [anon_sym_srand] = ACTIONS(3312),
    [anon_sym_stat] = ACTIONS(3312),
    [anon_sym_study] = ACTIONS(3312),
    [anon_sym_tell] = ACTIONS(3312),
    [anon_sym_telldir] = ACTIONS(3312),
    [anon_sym_tied] = ACTIONS(3312),
    [anon_sym_uc] = ACTIONS(3312),
    [anon_sym_ucfirst] = ACTIONS(3312),
    [anon_sym_untie] = ACTIONS(3312),
    [anon_sym_umask] = ACTIONS(3312),
    [anon_sym_values] = ACTIONS(3312),
    [anon_sym_write] = ACTIONS(3312),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3312),
    [anon_sym___END__] = ACTIONS(3312),
    [anon_sym_q] = ACTIONS(3312),
    [anon_sym_qq] = ACTIONS(3312),
    [anon_sym_qw] = ACTIONS(3312),
    [anon_sym_qx] = ACTIONS(3312),
    [anon_sym_qr] = ACTIONS(3312),
    [anon_sym_m] = ACTIONS(3312),
    [anon_sym_s] = ACTIONS(3312),
    [anon_sym_tr] = ACTIONS(3312),
    [anon_sym_y] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_unless] = ACTIONS(3312),
    [anon_sym_while] = ACTIONS(3312),
    [anon_sym_until] = ACTIONS(3312),
    [aux_sym__bareword_token1] = ACTIONS(3312),
    [sym_number] = ACTIONS(3312),
    [sym__apostrophe] = ACTIONS(3310),
    [sym__double_quote] = ACTIONS(3310),
    [sym__backtick] = ACTIONS(3310),
    [sym__search_slash] = ACTIONS(3310),
    [sym__PERLY_HEREDOC] = ACTIONS(3310),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1115] = {
    [sym_heredoc_content] = STATE(1115),
    [sym__identifier] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_LBRACE2] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_package] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_sub] = ACTIONS(3162),
    [anon_sym_method] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_my] = ACTIONS(3162),
    [anon_sym_state] = ACTIONS(3162),
    [anon_sym_our] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_defer] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_elsif] = ACTIONS(3162),
    [anon_sym_and] = ACTIONS(3162),
    [anon_sym_or] = ACTIONS(3162),
    [anon_sym_DOLLAR] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3162),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_LT_LT] = ACTIONS(3162),
    [anon_sym_SLASH_SLASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_eq] = ACTIONS(3162),
    [anon_sym_ne] = ACTIONS(3162),
    [anon_sym_cmp] = ACTIONS(3162),
    [anon_sym_lt] = ACTIONS(3162),
    [anon_sym_le] = ACTIONS(3162),
    [anon_sym_ge] = ACTIONS(3162),
    [anon_sym_gt] = ACTIONS(3162),
    [anon_sym_isa] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [anon_sym_BSLASH] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_eval] = ACTIONS(3162),
    [anon_sym_field] = ACTIONS(3162),
    [anon_sym_local] = ACTIONS(3162),
    [anon_sym_require] = ACTIONS(3162),
    [anon_sym_map] = ACTIONS(3162),
    [anon_sym_grep] = ACTIONS(3162),
    [anon_sym_sort] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_undef] = ACTIONS(3162),
    [anon_sym_PERCENT2] = ACTIONS(3162),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3162),
    [anon_sym_use] = ACTIONS(3162),
    [anon_sym_no] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_foreach] = ACTIONS(3162),
    [anon_sym_last] = ACTIONS(3162),
    [anon_sym_next] = ACTIONS(3162),
    [anon_sym_redo] = ACTIONS(3162),
    [anon_sym_BEGIN] = ACTIONS(3162),
    [anon_sym_INIT] = ACTIONS(3162),
    [anon_sym_CHECK] = ACTIONS(3162),
    [anon_sym_UNITCHECK] = ACTIONS(3162),
    [anon_sym_END] = ACTIONS(3162),
    [anon_sym_ADJUST] = ACTIONS(3162),
    [anon_sym___FILE__] = ACTIONS(3162),
    [anon_sym___LINE__] = ACTIONS(3162),
    [anon_sym___PACKAGE__] = ACTIONS(3162),
    [anon_sym___SUB__] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_fork] = ACTIONS(3162),
    [anon_sym_getppid] = ACTIONS(3162),
    [anon_sym_time] = ACTIONS(3162),
    [anon_sym_times] = ACTIONS(3162),
    [anon_sym_wait] = ACTIONS(3162),
    [anon_sym_wantarray] = ACTIONS(3162),
    [anon_sym_abs] = ACTIONS(3162),
    [anon_sym_alarm] = ACTIONS(3162),
    [anon_sym_chop] = ACTIONS(3162),
    [anon_sym_chdir] = ACTIONS(3162),
    [anon_sym_close] = ACTIONS(3162),
    [anon_sym_closedir] = ACTIONS(3162),
    [anon_sym_caller] = ACTIONS(3162),
    [anon_sym_chomp] = ACTIONS(3162),
    [anon_sym_chr] = ACTIONS(3162),
    [anon_sym_cos] = ACTIONS(3162),
    [anon_sym_chroot] = ACTIONS(3162),
    [anon_sym_defined] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_dbmclose] = ACTIONS(3162),
    [anon_sym_exists] = ACTIONS(3162),
    [anon_sym_exit] = ACTIONS(3162),
    [anon_sym_eof] = ACTIONS(3162),
    [anon_sym_exp] = ACTIONS(3162),
    [anon_sym_each] = ACTIONS(3162),
    [anon_sym_fc] = ACTIONS(3162),
    [anon_sym_fileno] = ACTIONS(3162),
    [anon_sym_gmtime] = ACTIONS(3162),
    [anon_sym_getc] = ACTIONS(3162),
    [anon_sym_getpgrp] = ACTIONS(3162),
    [anon_sym_getprotobyname] = ACTIONS(3162),
    [anon_sym_getpwname] = ACTIONS(3162),
    [anon_sym_getpwuid] = ACTIONS(3162),
    [anon_sym_getpeername] = ACTIONS(3162),
    [anon_sym_getnetbyname] = ACTIONS(3162),
    [anon_sym_getsockname] = ACTIONS(3162),
    [anon_sym_getgrnam] = ACTIONS(3162),
    [anon_sym_getgrgid] = ACTIONS(3162),
    [anon_sym_hex] = ACTIONS(3162),
    [anon_sym_int] = ACTIONS(3162),
    [anon_sym_keys] = ACTIONS(3162),
    [anon_sym_lc] = ACTIONS(3162),
    [anon_sym_lcfirst] = ACTIONS(3162),
    [anon_sym_length] = ACTIONS(3162),
    [anon_sym_localtime] = ACTIONS(3162),
    [anon_sym_log] = ACTIONS(3162),
    [anon_sym_lock] = ACTIONS(3162),
    [anon_sym_lstat] = ACTIONS(3162),
    [anon_sym_oct] = ACTIONS(3162),
    [anon_sym_ord] = ACTIONS(3162),
    [anon_sym_prototype] = ACTIONS(3162),
    [anon_sym_pop] = ACTIONS(3162),
    [anon_sym_pos] = ACTIONS(3162),
    [anon_sym_quotemeta] = ACTIONS(3162),
    [anon_sym_reset] = ACTIONS(3162),
    [anon_sym_rand] = ACTIONS(3162),
    [anon_sym_rmdir] = ACTIONS(3162),
    [anon_sym_readdir] = ACTIONS(3162),
    [anon_sym_readline] = ACTIONS(3162),
    [anon_sym_readpipe] = ACTIONS(3162),
    [anon_sym_rewinddir] = ACTIONS(3162),
    [anon_sym_readlink] = ACTIONS(3162),
    [anon_sym_ref] = ACTIONS(3162),
    [anon_sym_scalar] = ACTIONS(3162),
    [anon_sym_shift] = ACTIONS(3162),
    [anon_sym_sin] = ACTIONS(3162),
    [anon_sym_sleep] = ACTIONS(3162),
    [anon_sym_sqrt] = ACTIONS(3162),
    [anon_sym_srand] = ACTIONS(3162),
    [anon_sym_stat] = ACTIONS(3162),
    [anon_sym_study] = ACTIONS(3162),
    [anon_sym_tell] = ACTIONS(3162),
    [anon_sym_telldir] = ACTIONS(3162),
    [anon_sym_tied] = ACTIONS(3162),
    [anon_sym_uc] = ACTIONS(3162),
    [anon_sym_ucfirst] = ACTIONS(3162),
    [anon_sym_untie] = ACTIONS(3162),
    [anon_sym_umask] = ACTIONS(3162),
    [anon_sym_values] = ACTIONS(3162),
    [anon_sym_write] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3162),
    [anon_sym___END__] = ACTIONS(3162),
    [anon_sym_q] = ACTIONS(3162),
    [anon_sym_qq] = ACTIONS(3162),
    [anon_sym_qw] = ACTIONS(3162),
    [anon_sym_qx] = ACTIONS(3162),
    [anon_sym_qr] = ACTIONS(3162),
    [anon_sym_m] = ACTIONS(3162),
    [anon_sym_s] = ACTIONS(3162),
    [anon_sym_tr] = ACTIONS(3162),
    [anon_sym_y] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_unless] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_until] = ACTIONS(3162),
    [aux_sym__bareword_token1] = ACTIONS(3162),
    [sym_number] = ACTIONS(3162),
    [sym__apostrophe] = ACTIONS(3160),
    [sym__double_quote] = ACTIONS(3160),
    [sym__backtick] = ACTIONS(3160),
    [sym__search_slash] = ACTIONS(3160),
    [sym__PERLY_HEREDOC] = ACTIONS(3160),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1116] = {
    [sym_heredoc_content] = STATE(1116),
    [sym__identifier] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_LBRACE2] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym_package] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_sub] = ACTIONS(3078),
    [anon_sym_method] = ACTIONS(3078),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_my] = ACTIONS(3078),
    [anon_sym_state] = ACTIONS(3078),
    [anon_sym_our] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_defer] = ACTIONS(3078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_elsif] = ACTIONS(3078),
    [anon_sym_and] = ACTIONS(3078),
    [anon_sym_or] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_AT] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_LT_LT] = ACTIONS(3078),
    [anon_sym_SLASH_SLASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_eq] = ACTIONS(3078),
    [anon_sym_ne] = ACTIONS(3078),
    [anon_sym_cmp] = ACTIONS(3078),
    [anon_sym_lt] = ACTIONS(3078),
    [anon_sym_le] = ACTIONS(3078),
    [anon_sym_ge] = ACTIONS(3078),
    [anon_sym_gt] = ACTIONS(3078),
    [anon_sym_isa] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_BSLASH] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_eval] = ACTIONS(3078),
    [anon_sym_field] = ACTIONS(3078),
    [anon_sym_local] = ACTIONS(3078),
    [anon_sym_require] = ACTIONS(3078),
    [anon_sym_map] = ACTIONS(3078),
    [anon_sym_grep] = ACTIONS(3078),
    [anon_sym_sort] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_undef] = ACTIONS(3078),
    [anon_sym_PERCENT2] = ACTIONS(3078),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3078),
    [anon_sym_use] = ACTIONS(3078),
    [anon_sym_no] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_foreach] = ACTIONS(3078),
    [anon_sym_last] = ACTIONS(3078),
    [anon_sym_next] = ACTIONS(3078),
    [anon_sym_redo] = ACTIONS(3078),
    [anon_sym_BEGIN] = ACTIONS(3078),
    [anon_sym_INIT] = ACTIONS(3078),
    [anon_sym_CHECK] = ACTIONS(3078),
    [anon_sym_UNITCHECK] = ACTIONS(3078),
    [anon_sym_END] = ACTIONS(3078),
    [anon_sym_ADJUST] = ACTIONS(3078),
    [anon_sym___FILE__] = ACTIONS(3078),
    [anon_sym___LINE__] = ACTIONS(3078),
    [anon_sym___PACKAGE__] = ACTIONS(3078),
    [anon_sym___SUB__] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_fork] = ACTIONS(3078),
    [anon_sym_getppid] = ACTIONS(3078),
    [anon_sym_time] = ACTIONS(3078),
    [anon_sym_times] = ACTIONS(3078),
    [anon_sym_wait] = ACTIONS(3078),
    [anon_sym_wantarray] = ACTIONS(3078),
    [anon_sym_abs] = ACTIONS(3078),
    [anon_sym_alarm] = ACTIONS(3078),
    [anon_sym_chop] = ACTIONS(3078),
    [anon_sym_chdir] = ACTIONS(3078),
    [anon_sym_close] = ACTIONS(3078),
    [anon_sym_closedir] = ACTIONS(3078),
    [anon_sym_caller] = ACTIONS(3078),
    [anon_sym_chomp] = ACTIONS(3078),
    [anon_sym_chr] = ACTIONS(3078),
    [anon_sym_cos] = ACTIONS(3078),
    [anon_sym_chroot] = ACTIONS(3078),
    [anon_sym_defined] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_dbmclose] = ACTIONS(3078),
    [anon_sym_exists] = ACTIONS(3078),
    [anon_sym_exit] = ACTIONS(3078),
    [anon_sym_eof] = ACTIONS(3078),
    [anon_sym_exp] = ACTIONS(3078),
    [anon_sym_each] = ACTIONS(3078),
    [anon_sym_fc] = ACTIONS(3078),
    [anon_sym_fileno] = ACTIONS(3078),
    [anon_sym_gmtime] = ACTIONS(3078),
    [anon_sym_getc] = ACTIONS(3078),
    [anon_sym_getpgrp] = ACTIONS(3078),
    [anon_sym_getprotobyname] = ACTIONS(3078),
    [anon_sym_getpwname] = ACTIONS(3078),
    [anon_sym_getpwuid] = ACTIONS(3078),
    [anon_sym_getpeername] = ACTIONS(3078),
    [anon_sym_getnetbyname] = ACTIONS(3078),
    [anon_sym_getsockname] = ACTIONS(3078),
    [anon_sym_getgrnam] = ACTIONS(3078),
    [anon_sym_getgrgid] = ACTIONS(3078),
    [anon_sym_hex] = ACTIONS(3078),
    [anon_sym_int] = ACTIONS(3078),
    [anon_sym_keys] = ACTIONS(3078),
    [anon_sym_lc] = ACTIONS(3078),
    [anon_sym_lcfirst] = ACTIONS(3078),
    [anon_sym_length] = ACTIONS(3078),
    [anon_sym_localtime] = ACTIONS(3078),
    [anon_sym_log] = ACTIONS(3078),
    [anon_sym_lock] = ACTIONS(3078),
    [anon_sym_lstat] = ACTIONS(3078),
    [anon_sym_oct] = ACTIONS(3078),
    [anon_sym_ord] = ACTIONS(3078),
    [anon_sym_prototype] = ACTIONS(3078),
    [anon_sym_pop] = ACTIONS(3078),
    [anon_sym_pos] = ACTIONS(3078),
    [anon_sym_quotemeta] = ACTIONS(3078),
    [anon_sym_reset] = ACTIONS(3078),
    [anon_sym_rand] = ACTIONS(3078),
    [anon_sym_rmdir] = ACTIONS(3078),
    [anon_sym_readdir] = ACTIONS(3078),
    [anon_sym_readline] = ACTIONS(3078),
    [anon_sym_readpipe] = ACTIONS(3078),
    [anon_sym_rewinddir] = ACTIONS(3078),
    [anon_sym_readlink] = ACTIONS(3078),
    [anon_sym_ref] = ACTIONS(3078),
    [anon_sym_scalar] = ACTIONS(3078),
    [anon_sym_shift] = ACTIONS(3078),
    [anon_sym_sin] = ACTIONS(3078),
    [anon_sym_sleep] = ACTIONS(3078),
    [anon_sym_sqrt] = ACTIONS(3078),
    [anon_sym_srand] = ACTIONS(3078),
    [anon_sym_stat] = ACTIONS(3078),
    [anon_sym_study] = ACTIONS(3078),
    [anon_sym_tell] = ACTIONS(3078),
    [anon_sym_telldir] = ACTIONS(3078),
    [anon_sym_tied] = ACTIONS(3078),
    [anon_sym_uc] = ACTIONS(3078),
    [anon_sym_ucfirst] = ACTIONS(3078),
    [anon_sym_untie] = ACTIONS(3078),
    [anon_sym_umask] = ACTIONS(3078),
    [anon_sym_values] = ACTIONS(3078),
    [anon_sym_write] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3078),
    [anon_sym___END__] = ACTIONS(3078),
    [anon_sym_q] = ACTIONS(3078),
    [anon_sym_qq] = ACTIONS(3078),
    [anon_sym_qw] = ACTIONS(3078),
    [anon_sym_qx] = ACTIONS(3078),
    [anon_sym_qr] = ACTIONS(3078),
    [anon_sym_m] = ACTIONS(3078),
    [anon_sym_s] = ACTIONS(3078),
    [anon_sym_tr] = ACTIONS(3078),
    [anon_sym_y] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_unless] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_until] = ACTIONS(3078),
    [aux_sym__bareword_token1] = ACTIONS(3078),
    [sym_number] = ACTIONS(3078),
    [sym__apostrophe] = ACTIONS(3076),
    [sym__double_quote] = ACTIONS(3076),
    [sym__backtick] = ACTIONS(3076),
    [sym__search_slash] = ACTIONS(3076),
    [sym__PERLY_HEREDOC] = ACTIONS(3076),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1117] = {
    [sym_heredoc_content] = STATE(1117),
    [sym__identifier] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_LBRACE2] = ACTIONS(3236),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym_package] = ACTIONS(3236),
    [anon_sym_class] = ACTIONS(3236),
    [anon_sym_sub] = ACTIONS(3236),
    [anon_sym_method] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(3236),
    [anon_sym_continue] = ACTIONS(3236),
    [anon_sym_my] = ACTIONS(3236),
    [anon_sym_state] = ACTIONS(3236),
    [anon_sym_our] = ACTIONS(3236),
    [anon_sym_try] = ACTIONS(3236),
    [anon_sym_defer] = ACTIONS(3236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3236),
    [anon_sym_else] = ACTIONS(3236),
    [anon_sym_elsif] = ACTIONS(3236),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(3236),
    [anon_sym_DOLLAR] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3236),
    [anon_sym_AT] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_LT_LT] = ACTIONS(3236),
    [anon_sym_SLASH_SLASH] = ACTIONS(3236),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_eq] = ACTIONS(3236),
    [anon_sym_ne] = ACTIONS(3236),
    [anon_sym_cmp] = ACTIONS(3236),
    [anon_sym_lt] = ACTIONS(3236),
    [anon_sym_le] = ACTIONS(3236),
    [anon_sym_ge] = ACTIONS(3236),
    [anon_sym_gt] = ACTIONS(3236),
    [anon_sym_isa] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [anon_sym_BSLASH] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3236),
    [anon_sym_eval] = ACTIONS(3236),
    [anon_sym_field] = ACTIONS(3236),
    [anon_sym_local] = ACTIONS(3236),
    [anon_sym_require] = ACTIONS(3236),
    [anon_sym_map] = ACTIONS(3236),
    [anon_sym_grep] = ACTIONS(3236),
    [anon_sym_sort] = ACTIONS(3236),
    [anon_sym_goto] = ACTIONS(3236),
    [anon_sym_return] = ACTIONS(3236),
    [anon_sym_undef] = ACTIONS(3236),
    [anon_sym_PERCENT2] = ACTIONS(3236),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3236),
    [anon_sym_use] = ACTIONS(3236),
    [anon_sym_no] = ACTIONS(3236),
    [anon_sym_for] = ACTIONS(3236),
    [anon_sym_foreach] = ACTIONS(3236),
    [anon_sym_last] = ACTIONS(3236),
    [anon_sym_next] = ACTIONS(3236),
    [anon_sym_redo] = ACTIONS(3236),
    [anon_sym_BEGIN] = ACTIONS(3236),
    [anon_sym_INIT] = ACTIONS(3236),
    [anon_sym_CHECK] = ACTIONS(3236),
    [anon_sym_UNITCHECK] = ACTIONS(3236),
    [anon_sym_END] = ACTIONS(3236),
    [anon_sym_ADJUST] = ACTIONS(3236),
    [anon_sym___FILE__] = ACTIONS(3236),
    [anon_sym___LINE__] = ACTIONS(3236),
    [anon_sym___PACKAGE__] = ACTIONS(3236),
    [anon_sym___SUB__] = ACTIONS(3236),
    [anon_sym_break] = ACTIONS(3236),
    [anon_sym_fork] = ACTIONS(3236),
    [anon_sym_getppid] = ACTIONS(3236),
    [anon_sym_time] = ACTIONS(3236),
    [anon_sym_times] = ACTIONS(3236),
    [anon_sym_wait] = ACTIONS(3236),
    [anon_sym_wantarray] = ACTIONS(3236),
    [anon_sym_abs] = ACTIONS(3236),
    [anon_sym_alarm] = ACTIONS(3236),
    [anon_sym_chop] = ACTIONS(3236),
    [anon_sym_chdir] = ACTIONS(3236),
    [anon_sym_close] = ACTIONS(3236),
    [anon_sym_closedir] = ACTIONS(3236),
    [anon_sym_caller] = ACTIONS(3236),
    [anon_sym_chomp] = ACTIONS(3236),
    [anon_sym_chr] = ACTIONS(3236),
    [anon_sym_cos] = ACTIONS(3236),
    [anon_sym_chroot] = ACTIONS(3236),
    [anon_sym_defined] = ACTIONS(3236),
    [anon_sym_delete] = ACTIONS(3236),
    [anon_sym_dbmclose] = ACTIONS(3236),
    [anon_sym_exists] = ACTIONS(3236),
    [anon_sym_exit] = ACTIONS(3236),
    [anon_sym_eof] = ACTIONS(3236),
    [anon_sym_exp] = ACTIONS(3236),
    [anon_sym_each] = ACTIONS(3236),
    [anon_sym_fc] = ACTIONS(3236),
    [anon_sym_fileno] = ACTIONS(3236),
    [anon_sym_gmtime] = ACTIONS(3236),
    [anon_sym_getc] = ACTIONS(3236),
    [anon_sym_getpgrp] = ACTIONS(3236),
    [anon_sym_getprotobyname] = ACTIONS(3236),
    [anon_sym_getpwname] = ACTIONS(3236),
    [anon_sym_getpwuid] = ACTIONS(3236),
    [anon_sym_getpeername] = ACTIONS(3236),
    [anon_sym_getnetbyname] = ACTIONS(3236),
    [anon_sym_getsockname] = ACTIONS(3236),
    [anon_sym_getgrnam] = ACTIONS(3236),
    [anon_sym_getgrgid] = ACTIONS(3236),
    [anon_sym_hex] = ACTIONS(3236),
    [anon_sym_int] = ACTIONS(3236),
    [anon_sym_keys] = ACTIONS(3236),
    [anon_sym_lc] = ACTIONS(3236),
    [anon_sym_lcfirst] = ACTIONS(3236),
    [anon_sym_length] = ACTIONS(3236),
    [anon_sym_localtime] = ACTIONS(3236),
    [anon_sym_log] = ACTIONS(3236),
    [anon_sym_lock] = ACTIONS(3236),
    [anon_sym_lstat] = ACTIONS(3236),
    [anon_sym_oct] = ACTIONS(3236),
    [anon_sym_ord] = ACTIONS(3236),
    [anon_sym_prototype] = ACTIONS(3236),
    [anon_sym_pop] = ACTIONS(3236),
    [anon_sym_pos] = ACTIONS(3236),
    [anon_sym_quotemeta] = ACTIONS(3236),
    [anon_sym_reset] = ACTIONS(3236),
    [anon_sym_rand] = ACTIONS(3236),
    [anon_sym_rmdir] = ACTIONS(3236),
    [anon_sym_readdir] = ACTIONS(3236),
    [anon_sym_readline] = ACTIONS(3236),
    [anon_sym_readpipe] = ACTIONS(3236),
    [anon_sym_rewinddir] = ACTIONS(3236),
    [anon_sym_readlink] = ACTIONS(3236),
    [anon_sym_ref] = ACTIONS(3236),
    [anon_sym_scalar] = ACTIONS(3236),
    [anon_sym_shift] = ACTIONS(3236),
    [anon_sym_sin] = ACTIONS(3236),
    [anon_sym_sleep] = ACTIONS(3236),
    [anon_sym_sqrt] = ACTIONS(3236),
    [anon_sym_srand] = ACTIONS(3236),
    [anon_sym_stat] = ACTIONS(3236),
    [anon_sym_study] = ACTIONS(3236),
    [anon_sym_tell] = ACTIONS(3236),
    [anon_sym_telldir] = ACTIONS(3236),
    [anon_sym_tied] = ACTIONS(3236),
    [anon_sym_uc] = ACTIONS(3236),
    [anon_sym_ucfirst] = ACTIONS(3236),
    [anon_sym_untie] = ACTIONS(3236),
    [anon_sym_umask] = ACTIONS(3236),
    [anon_sym_values] = ACTIONS(3236),
    [anon_sym_write] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3236),
    [anon_sym___END__] = ACTIONS(3236),
    [anon_sym_q] = ACTIONS(3236),
    [anon_sym_qq] = ACTIONS(3236),
    [anon_sym_qw] = ACTIONS(3236),
    [anon_sym_qx] = ACTIONS(3236),
    [anon_sym_qr] = ACTIONS(3236),
    [anon_sym_m] = ACTIONS(3236),
    [anon_sym_s] = ACTIONS(3236),
    [anon_sym_tr] = ACTIONS(3236),
    [anon_sym_y] = ACTIONS(3236),
    [anon_sym_if] = ACTIONS(3236),
    [anon_sym_unless] = ACTIONS(3236),
    [anon_sym_while] = ACTIONS(3236),
    [anon_sym_until] = ACTIONS(3236),
    [aux_sym__bareword_token1] = ACTIONS(3236),
    [sym_number] = ACTIONS(3236),
    [sym__apostrophe] = ACTIONS(3234),
    [sym__double_quote] = ACTIONS(3234),
    [sym__backtick] = ACTIONS(3234),
    [sym__search_slash] = ACTIONS(3234),
    [sym__PERLY_HEREDOC] = ACTIONS(3234),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1118] = {
    [sym_heredoc_content] = STATE(1118),
    [sym__identifier] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(3185),
    [anon_sym_LBRACE2] = ACTIONS(3185),
    [anon_sym_RBRACE] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(3185),
    [anon_sym_package] = ACTIONS(3185),
    [anon_sym_class] = ACTIONS(3185),
    [anon_sym_sub] = ACTIONS(3185),
    [anon_sym_method] = ACTIONS(3185),
    [anon_sym_LPAREN] = ACTIONS(3185),
    [anon_sym_continue] = ACTIONS(3185),
    [anon_sym_my] = ACTIONS(3185),
    [anon_sym_state] = ACTIONS(3185),
    [anon_sym_our] = ACTIONS(3185),
    [anon_sym_try] = ACTIONS(3185),
    [anon_sym_defer] = ACTIONS(3185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3185),
    [anon_sym_else] = ACTIONS(3185),
    [anon_sym_elsif] = ACTIONS(3185),
    [anon_sym_and] = ACTIONS(3185),
    [anon_sym_or] = ACTIONS(3185),
    [anon_sym_DOLLAR] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(3185),
    [anon_sym_AT] = ACTIONS(3185),
    [anon_sym_LT] = ACTIONS(3185),
    [anon_sym_LT_LT] = ACTIONS(3185),
    [anon_sym_SLASH_SLASH] = ACTIONS(3185),
    [anon_sym_PLUS] = ACTIONS(3185),
    [anon_sym_DASH] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3185),
    [anon_sym_eq] = ACTIONS(3185),
    [anon_sym_ne] = ACTIONS(3185),
    [anon_sym_cmp] = ACTIONS(3185),
    [anon_sym_lt] = ACTIONS(3185),
    [anon_sym_le] = ACTIONS(3185),
    [anon_sym_ge] = ACTIONS(3185),
    [anon_sym_gt] = ACTIONS(3185),
    [anon_sym_isa] = ACTIONS(3185),
    [anon_sym_TILDE] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_PLUS_PLUS] = ACTIONS(3185),
    [anon_sym_DASH_DASH] = ACTIONS(3185),
    [anon_sym_BSLASH] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3185),
    [anon_sym_eval] = ACTIONS(3185),
    [anon_sym_field] = ACTIONS(3185),
    [anon_sym_local] = ACTIONS(3185),
    [anon_sym_require] = ACTIONS(3185),
    [anon_sym_map] = ACTIONS(3185),
    [anon_sym_grep] = ACTIONS(3185),
    [anon_sym_sort] = ACTIONS(3185),
    [anon_sym_goto] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3185),
    [anon_sym_undef] = ACTIONS(3185),
    [anon_sym_PERCENT2] = ACTIONS(3185),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3185),
    [anon_sym_use] = ACTIONS(3185),
    [anon_sym_no] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_foreach] = ACTIONS(3185),
    [anon_sym_last] = ACTIONS(3185),
    [anon_sym_next] = ACTIONS(3185),
    [anon_sym_redo] = ACTIONS(3185),
    [anon_sym_BEGIN] = ACTIONS(3185),
    [anon_sym_INIT] = ACTIONS(3185),
    [anon_sym_CHECK] = ACTIONS(3185),
    [anon_sym_UNITCHECK] = ACTIONS(3185),
    [anon_sym_END] = ACTIONS(3185),
    [anon_sym_ADJUST] = ACTIONS(3185),
    [anon_sym___FILE__] = ACTIONS(3185),
    [anon_sym___LINE__] = ACTIONS(3185),
    [anon_sym___PACKAGE__] = ACTIONS(3185),
    [anon_sym___SUB__] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3185),
    [anon_sym_fork] = ACTIONS(3185),
    [anon_sym_getppid] = ACTIONS(3185),
    [anon_sym_time] = ACTIONS(3185),
    [anon_sym_times] = ACTIONS(3185),
    [anon_sym_wait] = ACTIONS(3185),
    [anon_sym_wantarray] = ACTIONS(3185),
    [anon_sym_abs] = ACTIONS(3185),
    [anon_sym_alarm] = ACTIONS(3185),
    [anon_sym_chop] = ACTIONS(3185),
    [anon_sym_chdir] = ACTIONS(3185),
    [anon_sym_close] = ACTIONS(3185),
    [anon_sym_closedir] = ACTIONS(3185),
    [anon_sym_caller] = ACTIONS(3185),
    [anon_sym_chomp] = ACTIONS(3185),
    [anon_sym_chr] = ACTIONS(3185),
    [anon_sym_cos] = ACTIONS(3185),
    [anon_sym_chroot] = ACTIONS(3185),
    [anon_sym_defined] = ACTIONS(3185),
    [anon_sym_delete] = ACTIONS(3185),
    [anon_sym_dbmclose] = ACTIONS(3185),
    [anon_sym_exists] = ACTIONS(3185),
    [anon_sym_exit] = ACTIONS(3185),
    [anon_sym_eof] = ACTIONS(3185),
    [anon_sym_exp] = ACTIONS(3185),
    [anon_sym_each] = ACTIONS(3185),
    [anon_sym_fc] = ACTIONS(3185),
    [anon_sym_fileno] = ACTIONS(3185),
    [anon_sym_gmtime] = ACTIONS(3185),
    [anon_sym_getc] = ACTIONS(3185),
    [anon_sym_getpgrp] = ACTIONS(3185),
    [anon_sym_getprotobyname] = ACTIONS(3185),
    [anon_sym_getpwname] = ACTIONS(3185),
    [anon_sym_getpwuid] = ACTIONS(3185),
    [anon_sym_getpeername] = ACTIONS(3185),
    [anon_sym_getnetbyname] = ACTIONS(3185),
    [anon_sym_getsockname] = ACTIONS(3185),
    [anon_sym_getgrnam] = ACTIONS(3185),
    [anon_sym_getgrgid] = ACTIONS(3185),
    [anon_sym_hex] = ACTIONS(3185),
    [anon_sym_int] = ACTIONS(3185),
    [anon_sym_keys] = ACTIONS(3185),
    [anon_sym_lc] = ACTIONS(3185),
    [anon_sym_lcfirst] = ACTIONS(3185),
    [anon_sym_length] = ACTIONS(3185),
    [anon_sym_localtime] = ACTIONS(3185),
    [anon_sym_log] = ACTIONS(3185),
    [anon_sym_lock] = ACTIONS(3185),
    [anon_sym_lstat] = ACTIONS(3185),
    [anon_sym_oct] = ACTIONS(3185),
    [anon_sym_ord] = ACTIONS(3185),
    [anon_sym_prototype] = ACTIONS(3185),
    [anon_sym_pop] = ACTIONS(3185),
    [anon_sym_pos] = ACTIONS(3185),
    [anon_sym_quotemeta] = ACTIONS(3185),
    [anon_sym_reset] = ACTIONS(3185),
    [anon_sym_rand] = ACTIONS(3185),
    [anon_sym_rmdir] = ACTIONS(3185),
    [anon_sym_readdir] = ACTIONS(3185),
    [anon_sym_readline] = ACTIONS(3185),
    [anon_sym_readpipe] = ACTIONS(3185),
    [anon_sym_rewinddir] = ACTIONS(3185),
    [anon_sym_readlink] = ACTIONS(3185),
    [anon_sym_ref] = ACTIONS(3185),
    [anon_sym_scalar] = ACTIONS(3185),
    [anon_sym_shift] = ACTIONS(3185),
    [anon_sym_sin] = ACTIONS(3185),
    [anon_sym_sleep] = ACTIONS(3185),
    [anon_sym_sqrt] = ACTIONS(3185),
    [anon_sym_srand] = ACTIONS(3185),
    [anon_sym_stat] = ACTIONS(3185),
    [anon_sym_study] = ACTIONS(3185),
    [anon_sym_tell] = ACTIONS(3185),
    [anon_sym_telldir] = ACTIONS(3185),
    [anon_sym_tied] = ACTIONS(3185),
    [anon_sym_uc] = ACTIONS(3185),
    [anon_sym_ucfirst] = ACTIONS(3185),
    [anon_sym_untie] = ACTIONS(3185),
    [anon_sym_umask] = ACTIONS(3185),
    [anon_sym_values] = ACTIONS(3185),
    [anon_sym_write] = ACTIONS(3185),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3185),
    [anon_sym___END__] = ACTIONS(3185),
    [anon_sym_q] = ACTIONS(3185),
    [anon_sym_qq] = ACTIONS(3185),
    [anon_sym_qw] = ACTIONS(3185),
    [anon_sym_qx] = ACTIONS(3185),
    [anon_sym_qr] = ACTIONS(3185),
    [anon_sym_m] = ACTIONS(3185),
    [anon_sym_s] = ACTIONS(3185),
    [anon_sym_tr] = ACTIONS(3185),
    [anon_sym_y] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3185),
    [anon_sym_unless] = ACTIONS(3185),
    [anon_sym_while] = ACTIONS(3185),
    [anon_sym_until] = ACTIONS(3185),
    [aux_sym__bareword_token1] = ACTIONS(3185),
    [sym_number] = ACTIONS(3185),
    [sym__apostrophe] = ACTIONS(3183),
    [sym__double_quote] = ACTIONS(3183),
    [sym__backtick] = ACTIONS(3183),
    [sym__search_slash] = ACTIONS(3183),
    [sym__PERLY_HEREDOC] = ACTIONS(3183),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1119] = {
    [sym_heredoc_content] = STATE(1119),
    [sym__identifier] = ACTIONS(3208),
    [anon_sym_LBRACE] = ACTIONS(3208),
    [anon_sym_LBRACE2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(3208),
    [anon_sym_SEMI] = ACTIONS(3208),
    [anon_sym_package] = ACTIONS(3208),
    [anon_sym_class] = ACTIONS(3208),
    [anon_sym_sub] = ACTIONS(3208),
    [anon_sym_method] = ACTIONS(3208),
    [anon_sym_LPAREN] = ACTIONS(3208),
    [anon_sym_continue] = ACTIONS(3208),
    [anon_sym_my] = ACTIONS(3208),
    [anon_sym_state] = ACTIONS(3208),
    [anon_sym_our] = ACTIONS(3208),
    [anon_sym_try] = ACTIONS(3208),
    [anon_sym_defer] = ACTIONS(3208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3208),
    [anon_sym_else] = ACTIONS(3208),
    [anon_sym_elsif] = ACTIONS(3208),
    [anon_sym_and] = ACTIONS(3208),
    [anon_sym_or] = ACTIONS(3208),
    [anon_sym_DOLLAR] = ACTIONS(3208),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_AT] = ACTIONS(3208),
    [anon_sym_LT] = ACTIONS(3208),
    [anon_sym_LT_LT] = ACTIONS(3208),
    [anon_sym_SLASH_SLASH] = ACTIONS(3208),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_eq] = ACTIONS(3208),
    [anon_sym_ne] = ACTIONS(3208),
    [anon_sym_cmp] = ACTIONS(3208),
    [anon_sym_lt] = ACTIONS(3208),
    [anon_sym_le] = ACTIONS(3208),
    [anon_sym_ge] = ACTIONS(3208),
    [anon_sym_gt] = ACTIONS(3208),
    [anon_sym_isa] = ACTIONS(3208),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3208),
    [anon_sym_PLUS_PLUS] = ACTIONS(3208),
    [anon_sym_DASH_DASH] = ACTIONS(3208),
    [anon_sym_BSLASH] = ACTIONS(3206),
    [anon_sym_do] = ACTIONS(3208),
    [anon_sym_eval] = ACTIONS(3208),
    [anon_sym_field] = ACTIONS(3208),
    [anon_sym_local] = ACTIONS(3208),
    [anon_sym_require] = ACTIONS(3208),
    [anon_sym_map] = ACTIONS(3208),
    [anon_sym_grep] = ACTIONS(3208),
    [anon_sym_sort] = ACTIONS(3208),
    [anon_sym_goto] = ACTIONS(3208),
    [anon_sym_return] = ACTIONS(3208),
    [anon_sym_undef] = ACTIONS(3208),
    [anon_sym_PERCENT2] = ACTIONS(3208),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3208),
    [anon_sym_use] = ACTIONS(3208),
    [anon_sym_no] = ACTIONS(3208),
    [anon_sym_for] = ACTIONS(3208),
    [anon_sym_foreach] = ACTIONS(3208),
    [anon_sym_last] = ACTIONS(3208),
    [anon_sym_next] = ACTIONS(3208),
    [anon_sym_redo] = ACTIONS(3208),
    [anon_sym_BEGIN] = ACTIONS(3208),
    [anon_sym_INIT] = ACTIONS(3208),
    [anon_sym_CHECK] = ACTIONS(3208),
    [anon_sym_UNITCHECK] = ACTIONS(3208),
    [anon_sym_END] = ACTIONS(3208),
    [anon_sym_ADJUST] = ACTIONS(3208),
    [anon_sym___FILE__] = ACTIONS(3208),
    [anon_sym___LINE__] = ACTIONS(3208),
    [anon_sym___PACKAGE__] = ACTIONS(3208),
    [anon_sym___SUB__] = ACTIONS(3208),
    [anon_sym_break] = ACTIONS(3208),
    [anon_sym_fork] = ACTIONS(3208),
    [anon_sym_getppid] = ACTIONS(3208),
    [anon_sym_time] = ACTIONS(3208),
    [anon_sym_times] = ACTIONS(3208),
    [anon_sym_wait] = ACTIONS(3208),
    [anon_sym_wantarray] = ACTIONS(3208),
    [anon_sym_abs] = ACTIONS(3208),
    [anon_sym_alarm] = ACTIONS(3208),
    [anon_sym_chop] = ACTIONS(3208),
    [anon_sym_chdir] = ACTIONS(3208),
    [anon_sym_close] = ACTIONS(3208),
    [anon_sym_closedir] = ACTIONS(3208),
    [anon_sym_caller] = ACTIONS(3208),
    [anon_sym_chomp] = ACTIONS(3208),
    [anon_sym_chr] = ACTIONS(3208),
    [anon_sym_cos] = ACTIONS(3208),
    [anon_sym_chroot] = ACTIONS(3208),
    [anon_sym_defined] = ACTIONS(3208),
    [anon_sym_delete] = ACTIONS(3208),
    [anon_sym_dbmclose] = ACTIONS(3208),
    [anon_sym_exists] = ACTIONS(3208),
    [anon_sym_exit] = ACTIONS(3208),
    [anon_sym_eof] = ACTIONS(3208),
    [anon_sym_exp] = ACTIONS(3208),
    [anon_sym_each] = ACTIONS(3208),
    [anon_sym_fc] = ACTIONS(3208),
    [anon_sym_fileno] = ACTIONS(3208),
    [anon_sym_gmtime] = ACTIONS(3208),
    [anon_sym_getc] = ACTIONS(3208),
    [anon_sym_getpgrp] = ACTIONS(3208),
    [anon_sym_getprotobyname] = ACTIONS(3208),
    [anon_sym_getpwname] = ACTIONS(3208),
    [anon_sym_getpwuid] = ACTIONS(3208),
    [anon_sym_getpeername] = ACTIONS(3208),
    [anon_sym_getnetbyname] = ACTIONS(3208),
    [anon_sym_getsockname] = ACTIONS(3208),
    [anon_sym_getgrnam] = ACTIONS(3208),
    [anon_sym_getgrgid] = ACTIONS(3208),
    [anon_sym_hex] = ACTIONS(3208),
    [anon_sym_int] = ACTIONS(3208),
    [anon_sym_keys] = ACTIONS(3208),
    [anon_sym_lc] = ACTIONS(3208),
    [anon_sym_lcfirst] = ACTIONS(3208),
    [anon_sym_length] = ACTIONS(3208),
    [anon_sym_localtime] = ACTIONS(3208),
    [anon_sym_log] = ACTIONS(3208),
    [anon_sym_lock] = ACTIONS(3208),
    [anon_sym_lstat] = ACTIONS(3208),
    [anon_sym_oct] = ACTIONS(3208),
    [anon_sym_ord] = ACTIONS(3208),
    [anon_sym_prototype] = ACTIONS(3208),
    [anon_sym_pop] = ACTIONS(3208),
    [anon_sym_pos] = ACTIONS(3208),
    [anon_sym_quotemeta] = ACTIONS(3208),
    [anon_sym_reset] = ACTIONS(3208),
    [anon_sym_rand] = ACTIONS(3208),
    [anon_sym_rmdir] = ACTIONS(3208),
    [anon_sym_readdir] = ACTIONS(3208),
    [anon_sym_readline] = ACTIONS(3208),
    [anon_sym_readpipe] = ACTIONS(3208),
    [anon_sym_rewinddir] = ACTIONS(3208),
    [anon_sym_readlink] = ACTIONS(3208),
    [anon_sym_ref] = ACTIONS(3208),
    [anon_sym_scalar] = ACTIONS(3208),
    [anon_sym_shift] = ACTIONS(3208),
    [anon_sym_sin] = ACTIONS(3208),
    [anon_sym_sleep] = ACTIONS(3208),
    [anon_sym_sqrt] = ACTIONS(3208),
    [anon_sym_srand] = ACTIONS(3208),
    [anon_sym_stat] = ACTIONS(3208),
    [anon_sym_study] = ACTIONS(3208),
    [anon_sym_tell] = ACTIONS(3208),
    [anon_sym_telldir] = ACTIONS(3208),
    [anon_sym_tied] = ACTIONS(3208),
    [anon_sym_uc] = ACTIONS(3208),
    [anon_sym_ucfirst] = ACTIONS(3208),
    [anon_sym_untie] = ACTIONS(3208),
    [anon_sym_umask] = ACTIONS(3208),
    [anon_sym_values] = ACTIONS(3208),
    [anon_sym_write] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3208),
    [anon_sym___END__] = ACTIONS(3208),
    [anon_sym_q] = ACTIONS(3208),
    [anon_sym_qq] = ACTIONS(3208),
    [anon_sym_qw] = ACTIONS(3208),
    [anon_sym_qx] = ACTIONS(3208),
    [anon_sym_qr] = ACTIONS(3208),
    [anon_sym_m] = ACTIONS(3208),
    [anon_sym_s] = ACTIONS(3208),
    [anon_sym_tr] = ACTIONS(3208),
    [anon_sym_y] = ACTIONS(3208),
    [anon_sym_if] = ACTIONS(3208),
    [anon_sym_unless] = ACTIONS(3208),
    [anon_sym_while] = ACTIONS(3208),
    [anon_sym_until] = ACTIONS(3208),
    [aux_sym__bareword_token1] = ACTIONS(3208),
    [sym_number] = ACTIONS(3208),
    [sym__apostrophe] = ACTIONS(3206),
    [sym__double_quote] = ACTIONS(3206),
    [sym__backtick] = ACTIONS(3206),
    [sym__search_slash] = ACTIONS(3206),
    [sym__PERLY_HEREDOC] = ACTIONS(3206),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1120] = {
    [sym_heredoc_content] = STATE(1120),
    [sym__identifier] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_LBRACE2] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym_package] = ACTIONS(3232),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_sub] = ACTIONS(3232),
    [anon_sym_method] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3232),
    [anon_sym_continue] = ACTIONS(3232),
    [anon_sym_my] = ACTIONS(3232),
    [anon_sym_state] = ACTIONS(3232),
    [anon_sym_our] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3232),
    [anon_sym_defer] = ACTIONS(3232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3232),
    [anon_sym_else] = ACTIONS(3232),
    [anon_sym_elsif] = ACTIONS(3232),
    [anon_sym_and] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(3232),
    [anon_sym_AT] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_LT_LT] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_eq] = ACTIONS(3232),
    [anon_sym_ne] = ACTIONS(3232),
    [anon_sym_cmp] = ACTIONS(3232),
    [anon_sym_lt] = ACTIONS(3232),
    [anon_sym_le] = ACTIONS(3232),
    [anon_sym_ge] = ACTIONS(3232),
    [anon_sym_gt] = ACTIONS(3232),
    [anon_sym_isa] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [anon_sym_BSLASH] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3232),
    [anon_sym_eval] = ACTIONS(3232),
    [anon_sym_field] = ACTIONS(3232),
    [anon_sym_local] = ACTIONS(3232),
    [anon_sym_require] = ACTIONS(3232),
    [anon_sym_map] = ACTIONS(3232),
    [anon_sym_grep] = ACTIONS(3232),
    [anon_sym_sort] = ACTIONS(3232),
    [anon_sym_goto] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3232),
    [anon_sym_undef] = ACTIONS(3232),
    [anon_sym_PERCENT2] = ACTIONS(3232),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3232),
    [anon_sym_no] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3232),
    [anon_sym_foreach] = ACTIONS(3232),
    [anon_sym_last] = ACTIONS(3232),
    [anon_sym_next] = ACTIONS(3232),
    [anon_sym_redo] = ACTIONS(3232),
    [anon_sym_BEGIN] = ACTIONS(3232),
    [anon_sym_INIT] = ACTIONS(3232),
    [anon_sym_CHECK] = ACTIONS(3232),
    [anon_sym_UNITCHECK] = ACTIONS(3232),
    [anon_sym_END] = ACTIONS(3232),
    [anon_sym_ADJUST] = ACTIONS(3232),
    [anon_sym___FILE__] = ACTIONS(3232),
    [anon_sym___LINE__] = ACTIONS(3232),
    [anon_sym___PACKAGE__] = ACTIONS(3232),
    [anon_sym___SUB__] = ACTIONS(3232),
    [anon_sym_break] = ACTIONS(3232),
    [anon_sym_fork] = ACTIONS(3232),
    [anon_sym_getppid] = ACTIONS(3232),
    [anon_sym_time] = ACTIONS(3232),
    [anon_sym_times] = ACTIONS(3232),
    [anon_sym_wait] = ACTIONS(3232),
    [anon_sym_wantarray] = ACTIONS(3232),
    [anon_sym_abs] = ACTIONS(3232),
    [anon_sym_alarm] = ACTIONS(3232),
    [anon_sym_chop] = ACTIONS(3232),
    [anon_sym_chdir] = ACTIONS(3232),
    [anon_sym_close] = ACTIONS(3232),
    [anon_sym_closedir] = ACTIONS(3232),
    [anon_sym_caller] = ACTIONS(3232),
    [anon_sym_chomp] = ACTIONS(3232),
    [anon_sym_chr] = ACTIONS(3232),
    [anon_sym_cos] = ACTIONS(3232),
    [anon_sym_chroot] = ACTIONS(3232),
    [anon_sym_defined] = ACTIONS(3232),
    [anon_sym_delete] = ACTIONS(3232),
    [anon_sym_dbmclose] = ACTIONS(3232),
    [anon_sym_exists] = ACTIONS(3232),
    [anon_sym_exit] = ACTIONS(3232),
    [anon_sym_eof] = ACTIONS(3232),
    [anon_sym_exp] = ACTIONS(3232),
    [anon_sym_each] = ACTIONS(3232),
    [anon_sym_fc] = ACTIONS(3232),
    [anon_sym_fileno] = ACTIONS(3232),
    [anon_sym_gmtime] = ACTIONS(3232),
    [anon_sym_getc] = ACTIONS(3232),
    [anon_sym_getpgrp] = ACTIONS(3232),
    [anon_sym_getprotobyname] = ACTIONS(3232),
    [anon_sym_getpwname] = ACTIONS(3232),
    [anon_sym_getpwuid] = ACTIONS(3232),
    [anon_sym_getpeername] = ACTIONS(3232),
    [anon_sym_getnetbyname] = ACTIONS(3232),
    [anon_sym_getsockname] = ACTIONS(3232),
    [anon_sym_getgrnam] = ACTIONS(3232),
    [anon_sym_getgrgid] = ACTIONS(3232),
    [anon_sym_hex] = ACTIONS(3232),
    [anon_sym_int] = ACTIONS(3232),
    [anon_sym_keys] = ACTIONS(3232),
    [anon_sym_lc] = ACTIONS(3232),
    [anon_sym_lcfirst] = ACTIONS(3232),
    [anon_sym_length] = ACTIONS(3232),
    [anon_sym_localtime] = ACTIONS(3232),
    [anon_sym_log] = ACTIONS(3232),
    [anon_sym_lock] = ACTIONS(3232),
    [anon_sym_lstat] = ACTIONS(3232),
    [anon_sym_oct] = ACTIONS(3232),
    [anon_sym_ord] = ACTIONS(3232),
    [anon_sym_prototype] = ACTIONS(3232),
    [anon_sym_pop] = ACTIONS(3232),
    [anon_sym_pos] = ACTIONS(3232),
    [anon_sym_quotemeta] = ACTIONS(3232),
    [anon_sym_reset] = ACTIONS(3232),
    [anon_sym_rand] = ACTIONS(3232),
    [anon_sym_rmdir] = ACTIONS(3232),
    [anon_sym_readdir] = ACTIONS(3232),
    [anon_sym_readline] = ACTIONS(3232),
    [anon_sym_readpipe] = ACTIONS(3232),
    [anon_sym_rewinddir] = ACTIONS(3232),
    [anon_sym_readlink] = ACTIONS(3232),
    [anon_sym_ref] = ACTIONS(3232),
    [anon_sym_scalar] = ACTIONS(3232),
    [anon_sym_shift] = ACTIONS(3232),
    [anon_sym_sin] = ACTIONS(3232),
    [anon_sym_sleep] = ACTIONS(3232),
    [anon_sym_sqrt] = ACTIONS(3232),
    [anon_sym_srand] = ACTIONS(3232),
    [anon_sym_stat] = ACTIONS(3232),
    [anon_sym_study] = ACTIONS(3232),
    [anon_sym_tell] = ACTIONS(3232),
    [anon_sym_telldir] = ACTIONS(3232),
    [anon_sym_tied] = ACTIONS(3232),
    [anon_sym_uc] = ACTIONS(3232),
    [anon_sym_ucfirst] = ACTIONS(3232),
    [anon_sym_untie] = ACTIONS(3232),
    [anon_sym_umask] = ACTIONS(3232),
    [anon_sym_values] = ACTIONS(3232),
    [anon_sym_write] = ACTIONS(3232),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3232),
    [anon_sym___END__] = ACTIONS(3232),
    [anon_sym_q] = ACTIONS(3232),
    [anon_sym_qq] = ACTIONS(3232),
    [anon_sym_qw] = ACTIONS(3232),
    [anon_sym_qx] = ACTIONS(3232),
    [anon_sym_qr] = ACTIONS(3232),
    [anon_sym_m] = ACTIONS(3232),
    [anon_sym_s] = ACTIONS(3232),
    [anon_sym_tr] = ACTIONS(3232),
    [anon_sym_y] = ACTIONS(3232),
    [anon_sym_if] = ACTIONS(3232),
    [anon_sym_unless] = ACTIONS(3232),
    [anon_sym_while] = ACTIONS(3232),
    [anon_sym_until] = ACTIONS(3232),
    [aux_sym__bareword_token1] = ACTIONS(3232),
    [sym_number] = ACTIONS(3232),
    [sym__apostrophe] = ACTIONS(3230),
    [sym__double_quote] = ACTIONS(3230),
    [sym__backtick] = ACTIONS(3230),
    [sym__search_slash] = ACTIONS(3230),
    [sym__PERLY_HEREDOC] = ACTIONS(3230),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1121] = {
    [sym_heredoc_content] = STATE(1121),
    [sym__identifier] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_LBRACE2] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_package] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_sub] = ACTIONS(3228),
    [anon_sym_method] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_continue] = ACTIONS(3228),
    [anon_sym_my] = ACTIONS(3228),
    [anon_sym_state] = ACTIONS(3228),
    [anon_sym_our] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_defer] = ACTIONS(3228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3228),
    [anon_sym_else] = ACTIONS(3228),
    [anon_sym_elsif] = ACTIONS(3228),
    [anon_sym_and] = ACTIONS(3228),
    [anon_sym_or] = ACTIONS(3228),
    [anon_sym_DOLLAR] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3228),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_SLASH_SLASH] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3228),
    [anon_sym_STAR] = ACTIONS(3228),
    [anon_sym_eq] = ACTIONS(3228),
    [anon_sym_ne] = ACTIONS(3228),
    [anon_sym_cmp] = ACTIONS(3228),
    [anon_sym_lt] = ACTIONS(3228),
    [anon_sym_le] = ACTIONS(3228),
    [anon_sym_ge] = ACTIONS(3228),
    [anon_sym_gt] = ACTIONS(3228),
    [anon_sym_isa] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_BSLASH] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3228),
    [anon_sym_eval] = ACTIONS(3228),
    [anon_sym_field] = ACTIONS(3228),
    [anon_sym_local] = ACTIONS(3228),
    [anon_sym_require] = ACTIONS(3228),
    [anon_sym_map] = ACTIONS(3228),
    [anon_sym_grep] = ACTIONS(3228),
    [anon_sym_sort] = ACTIONS(3228),
    [anon_sym_goto] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_undef] = ACTIONS(3228),
    [anon_sym_PERCENT2] = ACTIONS(3228),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3228),
    [anon_sym_use] = ACTIONS(3228),
    [anon_sym_no] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_foreach] = ACTIONS(3228),
    [anon_sym_last] = ACTIONS(3228),
    [anon_sym_next] = ACTIONS(3228),
    [anon_sym_redo] = ACTIONS(3228),
    [anon_sym_BEGIN] = ACTIONS(3228),
    [anon_sym_INIT] = ACTIONS(3228),
    [anon_sym_CHECK] = ACTIONS(3228),
    [anon_sym_UNITCHECK] = ACTIONS(3228),
    [anon_sym_END] = ACTIONS(3228),
    [anon_sym_ADJUST] = ACTIONS(3228),
    [anon_sym___FILE__] = ACTIONS(3228),
    [anon_sym___LINE__] = ACTIONS(3228),
    [anon_sym___PACKAGE__] = ACTIONS(3228),
    [anon_sym___SUB__] = ACTIONS(3228),
    [anon_sym_break] = ACTIONS(3228),
    [anon_sym_fork] = ACTIONS(3228),
    [anon_sym_getppid] = ACTIONS(3228),
    [anon_sym_time] = ACTIONS(3228),
    [anon_sym_times] = ACTIONS(3228),
    [anon_sym_wait] = ACTIONS(3228),
    [anon_sym_wantarray] = ACTIONS(3228),
    [anon_sym_abs] = ACTIONS(3228),
    [anon_sym_alarm] = ACTIONS(3228),
    [anon_sym_chop] = ACTIONS(3228),
    [anon_sym_chdir] = ACTIONS(3228),
    [anon_sym_close] = ACTIONS(3228),
    [anon_sym_closedir] = ACTIONS(3228),
    [anon_sym_caller] = ACTIONS(3228),
    [anon_sym_chomp] = ACTIONS(3228),
    [anon_sym_chr] = ACTIONS(3228),
    [anon_sym_cos] = ACTIONS(3228),
    [anon_sym_chroot] = ACTIONS(3228),
    [anon_sym_defined] = ACTIONS(3228),
    [anon_sym_delete] = ACTIONS(3228),
    [anon_sym_dbmclose] = ACTIONS(3228),
    [anon_sym_exists] = ACTIONS(3228),
    [anon_sym_exit] = ACTIONS(3228),
    [anon_sym_eof] = ACTIONS(3228),
    [anon_sym_exp] = ACTIONS(3228),
    [anon_sym_each] = ACTIONS(3228),
    [anon_sym_fc] = ACTIONS(3228),
    [anon_sym_fileno] = ACTIONS(3228),
    [anon_sym_gmtime] = ACTIONS(3228),
    [anon_sym_getc] = ACTIONS(3228),
    [anon_sym_getpgrp] = ACTIONS(3228),
    [anon_sym_getprotobyname] = ACTIONS(3228),
    [anon_sym_getpwname] = ACTIONS(3228),
    [anon_sym_getpwuid] = ACTIONS(3228),
    [anon_sym_getpeername] = ACTIONS(3228),
    [anon_sym_getnetbyname] = ACTIONS(3228),
    [anon_sym_getsockname] = ACTIONS(3228),
    [anon_sym_getgrnam] = ACTIONS(3228),
    [anon_sym_getgrgid] = ACTIONS(3228),
    [anon_sym_hex] = ACTIONS(3228),
    [anon_sym_int] = ACTIONS(3228),
    [anon_sym_keys] = ACTIONS(3228),
    [anon_sym_lc] = ACTIONS(3228),
    [anon_sym_lcfirst] = ACTIONS(3228),
    [anon_sym_length] = ACTIONS(3228),
    [anon_sym_localtime] = ACTIONS(3228),
    [anon_sym_log] = ACTIONS(3228),
    [anon_sym_lock] = ACTIONS(3228),
    [anon_sym_lstat] = ACTIONS(3228),
    [anon_sym_oct] = ACTIONS(3228),
    [anon_sym_ord] = ACTIONS(3228),
    [anon_sym_prototype] = ACTIONS(3228),
    [anon_sym_pop] = ACTIONS(3228),
    [anon_sym_pos] = ACTIONS(3228),
    [anon_sym_quotemeta] = ACTIONS(3228),
    [anon_sym_reset] = ACTIONS(3228),
    [anon_sym_rand] = ACTIONS(3228),
    [anon_sym_rmdir] = ACTIONS(3228),
    [anon_sym_readdir] = ACTIONS(3228),
    [anon_sym_readline] = ACTIONS(3228),
    [anon_sym_readpipe] = ACTIONS(3228),
    [anon_sym_rewinddir] = ACTIONS(3228),
    [anon_sym_readlink] = ACTIONS(3228),
    [anon_sym_ref] = ACTIONS(3228),
    [anon_sym_scalar] = ACTIONS(3228),
    [anon_sym_shift] = ACTIONS(3228),
    [anon_sym_sin] = ACTIONS(3228),
    [anon_sym_sleep] = ACTIONS(3228),
    [anon_sym_sqrt] = ACTIONS(3228),
    [anon_sym_srand] = ACTIONS(3228),
    [anon_sym_stat] = ACTIONS(3228),
    [anon_sym_study] = ACTIONS(3228),
    [anon_sym_tell] = ACTIONS(3228),
    [anon_sym_telldir] = ACTIONS(3228),
    [anon_sym_tied] = ACTIONS(3228),
    [anon_sym_uc] = ACTIONS(3228),
    [anon_sym_ucfirst] = ACTIONS(3228),
    [anon_sym_untie] = ACTIONS(3228),
    [anon_sym_umask] = ACTIONS(3228),
    [anon_sym_values] = ACTIONS(3228),
    [anon_sym_write] = ACTIONS(3228),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3228),
    [anon_sym___END__] = ACTIONS(3228),
    [anon_sym_q] = ACTIONS(3228),
    [anon_sym_qq] = ACTIONS(3228),
    [anon_sym_qw] = ACTIONS(3228),
    [anon_sym_qx] = ACTIONS(3228),
    [anon_sym_qr] = ACTIONS(3228),
    [anon_sym_m] = ACTIONS(3228),
    [anon_sym_s] = ACTIONS(3228),
    [anon_sym_tr] = ACTIONS(3228),
    [anon_sym_y] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_unless] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_until] = ACTIONS(3228),
    [aux_sym__bareword_token1] = ACTIONS(3228),
    [sym_number] = ACTIONS(3228),
    [sym__apostrophe] = ACTIONS(3226),
    [sym__double_quote] = ACTIONS(3226),
    [sym__backtick] = ACTIONS(3226),
    [sym__search_slash] = ACTIONS(3226),
    [sym__PERLY_HEREDOC] = ACTIONS(3226),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1122] = {
    [sym_heredoc_content] = STATE(1122),
    [sym__identifier] = ACTIONS(3200),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_LBRACE2] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym_package] = ACTIONS(3200),
    [anon_sym_class] = ACTIONS(3200),
    [anon_sym_sub] = ACTIONS(3200),
    [anon_sym_method] = ACTIONS(3200),
    [anon_sym_LPAREN] = ACTIONS(3200),
    [anon_sym_continue] = ACTIONS(3200),
    [anon_sym_my] = ACTIONS(3200),
    [anon_sym_state] = ACTIONS(3200),
    [anon_sym_our] = ACTIONS(3200),
    [anon_sym_try] = ACTIONS(3200),
    [anon_sym_defer] = ACTIONS(3200),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3200),
    [anon_sym_else] = ACTIONS(3200),
    [anon_sym_elsif] = ACTIONS(3200),
    [anon_sym_and] = ACTIONS(3200),
    [anon_sym_or] = ACTIONS(3200),
    [anon_sym_DOLLAR] = ACTIONS(3200),
    [anon_sym_LBRACK] = ACTIONS(3200),
    [anon_sym_AT] = ACTIONS(3200),
    [anon_sym_LT] = ACTIONS(3200),
    [anon_sym_LT_LT] = ACTIONS(3200),
    [anon_sym_SLASH_SLASH] = ACTIONS(3200),
    [anon_sym_PLUS] = ACTIONS(3200),
    [anon_sym_DASH] = ACTIONS(3200),
    [anon_sym_STAR] = ACTIONS(3200),
    [anon_sym_eq] = ACTIONS(3200),
    [anon_sym_ne] = ACTIONS(3200),
    [anon_sym_cmp] = ACTIONS(3200),
    [anon_sym_lt] = ACTIONS(3200),
    [anon_sym_le] = ACTIONS(3200),
    [anon_sym_ge] = ACTIONS(3200),
    [anon_sym_gt] = ACTIONS(3200),
    [anon_sym_isa] = ACTIONS(3200),
    [anon_sym_TILDE] = ACTIONS(3200),
    [anon_sym_BANG] = ACTIONS(3200),
    [anon_sym_PLUS_PLUS] = ACTIONS(3200),
    [anon_sym_DASH_DASH] = ACTIONS(3200),
    [anon_sym_BSLASH] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3200),
    [anon_sym_eval] = ACTIONS(3200),
    [anon_sym_field] = ACTIONS(3200),
    [anon_sym_local] = ACTIONS(3200),
    [anon_sym_require] = ACTIONS(3200),
    [anon_sym_map] = ACTIONS(3200),
    [anon_sym_grep] = ACTIONS(3200),
    [anon_sym_sort] = ACTIONS(3200),
    [anon_sym_goto] = ACTIONS(3200),
    [anon_sym_return] = ACTIONS(3200),
    [anon_sym_undef] = ACTIONS(3200),
    [anon_sym_PERCENT2] = ACTIONS(3200),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3200),
    [anon_sym_use] = ACTIONS(3200),
    [anon_sym_no] = ACTIONS(3200),
    [anon_sym_for] = ACTIONS(3200),
    [anon_sym_foreach] = ACTIONS(3200),
    [anon_sym_last] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3200),
    [anon_sym_redo] = ACTIONS(3200),
    [anon_sym_BEGIN] = ACTIONS(3200),
    [anon_sym_INIT] = ACTIONS(3200),
    [anon_sym_CHECK] = ACTIONS(3200),
    [anon_sym_UNITCHECK] = ACTIONS(3200),
    [anon_sym_END] = ACTIONS(3200),
    [anon_sym_ADJUST] = ACTIONS(3200),
    [anon_sym___FILE__] = ACTIONS(3200),
    [anon_sym___LINE__] = ACTIONS(3200),
    [anon_sym___PACKAGE__] = ACTIONS(3200),
    [anon_sym___SUB__] = ACTIONS(3200),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_fork] = ACTIONS(3200),
    [anon_sym_getppid] = ACTIONS(3200),
    [anon_sym_time] = ACTIONS(3200),
    [anon_sym_times] = ACTIONS(3200),
    [anon_sym_wait] = ACTIONS(3200),
    [anon_sym_wantarray] = ACTIONS(3200),
    [anon_sym_abs] = ACTIONS(3200),
    [anon_sym_alarm] = ACTIONS(3200),
    [anon_sym_chop] = ACTIONS(3200),
    [anon_sym_chdir] = ACTIONS(3200),
    [anon_sym_close] = ACTIONS(3200),
    [anon_sym_closedir] = ACTIONS(3200),
    [anon_sym_caller] = ACTIONS(3200),
    [anon_sym_chomp] = ACTIONS(3200),
    [anon_sym_chr] = ACTIONS(3200),
    [anon_sym_cos] = ACTIONS(3200),
    [anon_sym_chroot] = ACTIONS(3200),
    [anon_sym_defined] = ACTIONS(3200),
    [anon_sym_delete] = ACTIONS(3200),
    [anon_sym_dbmclose] = ACTIONS(3200),
    [anon_sym_exists] = ACTIONS(3200),
    [anon_sym_exit] = ACTIONS(3200),
    [anon_sym_eof] = ACTIONS(3200),
    [anon_sym_exp] = ACTIONS(3200),
    [anon_sym_each] = ACTIONS(3200),
    [anon_sym_fc] = ACTIONS(3200),
    [anon_sym_fileno] = ACTIONS(3200),
    [anon_sym_gmtime] = ACTIONS(3200),
    [anon_sym_getc] = ACTIONS(3200),
    [anon_sym_getpgrp] = ACTIONS(3200),
    [anon_sym_getprotobyname] = ACTIONS(3200),
    [anon_sym_getpwname] = ACTIONS(3200),
    [anon_sym_getpwuid] = ACTIONS(3200),
    [anon_sym_getpeername] = ACTIONS(3200),
    [anon_sym_getnetbyname] = ACTIONS(3200),
    [anon_sym_getsockname] = ACTIONS(3200),
    [anon_sym_getgrnam] = ACTIONS(3200),
    [anon_sym_getgrgid] = ACTIONS(3200),
    [anon_sym_hex] = ACTIONS(3200),
    [anon_sym_int] = ACTIONS(3200),
    [anon_sym_keys] = ACTIONS(3200),
    [anon_sym_lc] = ACTIONS(3200),
    [anon_sym_lcfirst] = ACTIONS(3200),
    [anon_sym_length] = ACTIONS(3200),
    [anon_sym_localtime] = ACTIONS(3200),
    [anon_sym_log] = ACTIONS(3200),
    [anon_sym_lock] = ACTIONS(3200),
    [anon_sym_lstat] = ACTIONS(3200),
    [anon_sym_oct] = ACTIONS(3200),
    [anon_sym_ord] = ACTIONS(3200),
    [anon_sym_prototype] = ACTIONS(3200),
    [anon_sym_pop] = ACTIONS(3200),
    [anon_sym_pos] = ACTIONS(3200),
    [anon_sym_quotemeta] = ACTIONS(3200),
    [anon_sym_reset] = ACTIONS(3200),
    [anon_sym_rand] = ACTIONS(3200),
    [anon_sym_rmdir] = ACTIONS(3200),
    [anon_sym_readdir] = ACTIONS(3200),
    [anon_sym_readline] = ACTIONS(3200),
    [anon_sym_readpipe] = ACTIONS(3200),
    [anon_sym_rewinddir] = ACTIONS(3200),
    [anon_sym_readlink] = ACTIONS(3200),
    [anon_sym_ref] = ACTIONS(3200),
    [anon_sym_scalar] = ACTIONS(3200),
    [anon_sym_shift] = ACTIONS(3200),
    [anon_sym_sin] = ACTIONS(3200),
    [anon_sym_sleep] = ACTIONS(3200),
    [anon_sym_sqrt] = ACTIONS(3200),
    [anon_sym_srand] = ACTIONS(3200),
    [anon_sym_stat] = ACTIONS(3200),
    [anon_sym_study] = ACTIONS(3200),
    [anon_sym_tell] = ACTIONS(3200),
    [anon_sym_telldir] = ACTIONS(3200),
    [anon_sym_tied] = ACTIONS(3200),
    [anon_sym_uc] = ACTIONS(3200),
    [anon_sym_ucfirst] = ACTIONS(3200),
    [anon_sym_untie] = ACTIONS(3200),
    [anon_sym_umask] = ACTIONS(3200),
    [anon_sym_values] = ACTIONS(3200),
    [anon_sym_write] = ACTIONS(3200),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3200),
    [anon_sym___END__] = ACTIONS(3200),
    [anon_sym_q] = ACTIONS(3200),
    [anon_sym_qq] = ACTIONS(3200),
    [anon_sym_qw] = ACTIONS(3200),
    [anon_sym_qx] = ACTIONS(3200),
    [anon_sym_qr] = ACTIONS(3200),
    [anon_sym_m] = ACTIONS(3200),
    [anon_sym_s] = ACTIONS(3200),
    [anon_sym_tr] = ACTIONS(3200),
    [anon_sym_y] = ACTIONS(3200),
    [anon_sym_if] = ACTIONS(3200),
    [anon_sym_unless] = ACTIONS(3200),
    [anon_sym_while] = ACTIONS(3200),
    [anon_sym_until] = ACTIONS(3200),
    [aux_sym__bareword_token1] = ACTIONS(3200),
    [sym_number] = ACTIONS(3200),
    [sym__apostrophe] = ACTIONS(3198),
    [sym__double_quote] = ACTIONS(3198),
    [sym__backtick] = ACTIONS(3198),
    [sym__search_slash] = ACTIONS(3198),
    [sym__PERLY_HEREDOC] = ACTIONS(3198),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1123] = {
    [sym_heredoc_content] = STATE(1123),
    [sym__identifier] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_LBRACE2] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_package] = ACTIONS(3224),
    [anon_sym_class] = ACTIONS(3224),
    [anon_sym_sub] = ACTIONS(3224),
    [anon_sym_method] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_continue] = ACTIONS(3224),
    [anon_sym_my] = ACTIONS(3224),
    [anon_sym_state] = ACTIONS(3224),
    [anon_sym_our] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(3224),
    [anon_sym_defer] = ACTIONS(3224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3224),
    [anon_sym_else] = ACTIONS(3224),
    [anon_sym_elsif] = ACTIONS(3224),
    [anon_sym_and] = ACTIONS(3224),
    [anon_sym_or] = ACTIONS(3224),
    [anon_sym_DOLLAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(3224),
    [anon_sym_SLASH_SLASH] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_eq] = ACTIONS(3224),
    [anon_sym_ne] = ACTIONS(3224),
    [anon_sym_cmp] = ACTIONS(3224),
    [anon_sym_lt] = ACTIONS(3224),
    [anon_sym_le] = ACTIONS(3224),
    [anon_sym_ge] = ACTIONS(3224),
    [anon_sym_gt] = ACTIONS(3224),
    [anon_sym_isa] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_BSLASH] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3224),
    [anon_sym_eval] = ACTIONS(3224),
    [anon_sym_field] = ACTIONS(3224),
    [anon_sym_local] = ACTIONS(3224),
    [anon_sym_require] = ACTIONS(3224),
    [anon_sym_map] = ACTIONS(3224),
    [anon_sym_grep] = ACTIONS(3224),
    [anon_sym_sort] = ACTIONS(3224),
    [anon_sym_goto] = ACTIONS(3224),
    [anon_sym_return] = ACTIONS(3224),
    [anon_sym_undef] = ACTIONS(3224),
    [anon_sym_PERCENT2] = ACTIONS(3224),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3224),
    [anon_sym_use] = ACTIONS(3224),
    [anon_sym_no] = ACTIONS(3224),
    [anon_sym_for] = ACTIONS(3224),
    [anon_sym_foreach] = ACTIONS(3224),
    [anon_sym_last] = ACTIONS(3224),
    [anon_sym_next] = ACTIONS(3224),
    [anon_sym_redo] = ACTIONS(3224),
    [anon_sym_BEGIN] = ACTIONS(3224),
    [anon_sym_INIT] = ACTIONS(3224),
    [anon_sym_CHECK] = ACTIONS(3224),
    [anon_sym_UNITCHECK] = ACTIONS(3224),
    [anon_sym_END] = ACTIONS(3224),
    [anon_sym_ADJUST] = ACTIONS(3224),
    [anon_sym___FILE__] = ACTIONS(3224),
    [anon_sym___LINE__] = ACTIONS(3224),
    [anon_sym___PACKAGE__] = ACTIONS(3224),
    [anon_sym___SUB__] = ACTIONS(3224),
    [anon_sym_break] = ACTIONS(3224),
    [anon_sym_fork] = ACTIONS(3224),
    [anon_sym_getppid] = ACTIONS(3224),
    [anon_sym_time] = ACTIONS(3224),
    [anon_sym_times] = ACTIONS(3224),
    [anon_sym_wait] = ACTIONS(3224),
    [anon_sym_wantarray] = ACTIONS(3224),
    [anon_sym_abs] = ACTIONS(3224),
    [anon_sym_alarm] = ACTIONS(3224),
    [anon_sym_chop] = ACTIONS(3224),
    [anon_sym_chdir] = ACTIONS(3224),
    [anon_sym_close] = ACTIONS(3224),
    [anon_sym_closedir] = ACTIONS(3224),
    [anon_sym_caller] = ACTIONS(3224),
    [anon_sym_chomp] = ACTIONS(3224),
    [anon_sym_chr] = ACTIONS(3224),
    [anon_sym_cos] = ACTIONS(3224),
    [anon_sym_chroot] = ACTIONS(3224),
    [anon_sym_defined] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3224),
    [anon_sym_dbmclose] = ACTIONS(3224),
    [anon_sym_exists] = ACTIONS(3224),
    [anon_sym_exit] = ACTIONS(3224),
    [anon_sym_eof] = ACTIONS(3224),
    [anon_sym_exp] = ACTIONS(3224),
    [anon_sym_each] = ACTIONS(3224),
    [anon_sym_fc] = ACTIONS(3224),
    [anon_sym_fileno] = ACTIONS(3224),
    [anon_sym_gmtime] = ACTIONS(3224),
    [anon_sym_getc] = ACTIONS(3224),
    [anon_sym_getpgrp] = ACTIONS(3224),
    [anon_sym_getprotobyname] = ACTIONS(3224),
    [anon_sym_getpwname] = ACTIONS(3224),
    [anon_sym_getpwuid] = ACTIONS(3224),
    [anon_sym_getpeername] = ACTIONS(3224),
    [anon_sym_getnetbyname] = ACTIONS(3224),
    [anon_sym_getsockname] = ACTIONS(3224),
    [anon_sym_getgrnam] = ACTIONS(3224),
    [anon_sym_getgrgid] = ACTIONS(3224),
    [anon_sym_hex] = ACTIONS(3224),
    [anon_sym_int] = ACTIONS(3224),
    [anon_sym_keys] = ACTIONS(3224),
    [anon_sym_lc] = ACTIONS(3224),
    [anon_sym_lcfirst] = ACTIONS(3224),
    [anon_sym_length] = ACTIONS(3224),
    [anon_sym_localtime] = ACTIONS(3224),
    [anon_sym_log] = ACTIONS(3224),
    [anon_sym_lock] = ACTIONS(3224),
    [anon_sym_lstat] = ACTIONS(3224),
    [anon_sym_oct] = ACTIONS(3224),
    [anon_sym_ord] = ACTIONS(3224),
    [anon_sym_prototype] = ACTIONS(3224),
    [anon_sym_pop] = ACTIONS(3224),
    [anon_sym_pos] = ACTIONS(3224),
    [anon_sym_quotemeta] = ACTIONS(3224),
    [anon_sym_reset] = ACTIONS(3224),
    [anon_sym_rand] = ACTIONS(3224),
    [anon_sym_rmdir] = ACTIONS(3224),
    [anon_sym_readdir] = ACTIONS(3224),
    [anon_sym_readline] = ACTIONS(3224),
    [anon_sym_readpipe] = ACTIONS(3224),
    [anon_sym_rewinddir] = ACTIONS(3224),
    [anon_sym_readlink] = ACTIONS(3224),
    [anon_sym_ref] = ACTIONS(3224),
    [anon_sym_scalar] = ACTIONS(3224),
    [anon_sym_shift] = ACTIONS(3224),
    [anon_sym_sin] = ACTIONS(3224),
    [anon_sym_sleep] = ACTIONS(3224),
    [anon_sym_sqrt] = ACTIONS(3224),
    [anon_sym_srand] = ACTIONS(3224),
    [anon_sym_stat] = ACTIONS(3224),
    [anon_sym_study] = ACTIONS(3224),
    [anon_sym_tell] = ACTIONS(3224),
    [anon_sym_telldir] = ACTIONS(3224),
    [anon_sym_tied] = ACTIONS(3224),
    [anon_sym_uc] = ACTIONS(3224),
    [anon_sym_ucfirst] = ACTIONS(3224),
    [anon_sym_untie] = ACTIONS(3224),
    [anon_sym_umask] = ACTIONS(3224),
    [anon_sym_values] = ACTIONS(3224),
    [anon_sym_write] = ACTIONS(3224),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3224),
    [anon_sym___END__] = ACTIONS(3224),
    [anon_sym_q] = ACTIONS(3224),
    [anon_sym_qq] = ACTIONS(3224),
    [anon_sym_qw] = ACTIONS(3224),
    [anon_sym_qx] = ACTIONS(3224),
    [anon_sym_qr] = ACTIONS(3224),
    [anon_sym_m] = ACTIONS(3224),
    [anon_sym_s] = ACTIONS(3224),
    [anon_sym_tr] = ACTIONS(3224),
    [anon_sym_y] = ACTIONS(3224),
    [anon_sym_if] = ACTIONS(3224),
    [anon_sym_unless] = ACTIONS(3224),
    [anon_sym_while] = ACTIONS(3224),
    [anon_sym_until] = ACTIONS(3224),
    [aux_sym__bareword_token1] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [sym__apostrophe] = ACTIONS(3222),
    [sym__double_quote] = ACTIONS(3222),
    [sym__backtick] = ACTIONS(3222),
    [sym__search_slash] = ACTIONS(3222),
    [sym__PERLY_HEREDOC] = ACTIONS(3222),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1124] = {
    [sym_heredoc_content] = STATE(1124),
    [sym__identifier] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_LBRACE2] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_package] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_sub] = ACTIONS(3327),
    [anon_sym_method] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_my] = ACTIONS(3327),
    [anon_sym_state] = ACTIONS(3327),
    [anon_sym_our] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_defer] = ACTIONS(3327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_elsif] = ACTIONS(3327),
    [anon_sym_and] = ACTIONS(3327),
    [anon_sym_or] = ACTIONS(3327),
    [anon_sym_DOLLAR] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_AT] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(3327),
    [anon_sym_LT_LT] = ACTIONS(3327),
    [anon_sym_SLASH_SLASH] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_STAR] = ACTIONS(3327),
    [anon_sym_eq] = ACTIONS(3327),
    [anon_sym_ne] = ACTIONS(3327),
    [anon_sym_cmp] = ACTIONS(3327),
    [anon_sym_lt] = ACTIONS(3327),
    [anon_sym_le] = ACTIONS(3327),
    [anon_sym_ge] = ACTIONS(3327),
    [anon_sym_gt] = ACTIONS(3327),
    [anon_sym_isa] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [anon_sym_BSLASH] = ACTIONS(3325),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_eval] = ACTIONS(3327),
    [anon_sym_field] = ACTIONS(3327),
    [anon_sym_local] = ACTIONS(3327),
    [anon_sym_require] = ACTIONS(3327),
    [anon_sym_map] = ACTIONS(3327),
    [anon_sym_grep] = ACTIONS(3327),
    [anon_sym_sort] = ACTIONS(3327),
    [anon_sym_goto] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_undef] = ACTIONS(3327),
    [anon_sym_PERCENT2] = ACTIONS(3327),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3327),
    [anon_sym_use] = ACTIONS(3327),
    [anon_sym_no] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_foreach] = ACTIONS(3327),
    [anon_sym_last] = ACTIONS(3327),
    [anon_sym_next] = ACTIONS(3327),
    [anon_sym_redo] = ACTIONS(3327),
    [anon_sym_BEGIN] = ACTIONS(3327),
    [anon_sym_INIT] = ACTIONS(3327),
    [anon_sym_CHECK] = ACTIONS(3327),
    [anon_sym_UNITCHECK] = ACTIONS(3327),
    [anon_sym_END] = ACTIONS(3327),
    [anon_sym_ADJUST] = ACTIONS(3327),
    [anon_sym___FILE__] = ACTIONS(3327),
    [anon_sym___LINE__] = ACTIONS(3327),
    [anon_sym___PACKAGE__] = ACTIONS(3327),
    [anon_sym___SUB__] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_fork] = ACTIONS(3327),
    [anon_sym_getppid] = ACTIONS(3327),
    [anon_sym_time] = ACTIONS(3327),
    [anon_sym_times] = ACTIONS(3327),
    [anon_sym_wait] = ACTIONS(3327),
    [anon_sym_wantarray] = ACTIONS(3327),
    [anon_sym_abs] = ACTIONS(3327),
    [anon_sym_alarm] = ACTIONS(3327),
    [anon_sym_chop] = ACTIONS(3327),
    [anon_sym_chdir] = ACTIONS(3327),
    [anon_sym_close] = ACTIONS(3327),
    [anon_sym_closedir] = ACTIONS(3327),
    [anon_sym_caller] = ACTIONS(3327),
    [anon_sym_chomp] = ACTIONS(3327),
    [anon_sym_chr] = ACTIONS(3327),
    [anon_sym_cos] = ACTIONS(3327),
    [anon_sym_chroot] = ACTIONS(3327),
    [anon_sym_defined] = ACTIONS(3327),
    [anon_sym_delete] = ACTIONS(3327),
    [anon_sym_dbmclose] = ACTIONS(3327),
    [anon_sym_exists] = ACTIONS(3327),
    [anon_sym_exit] = ACTIONS(3327),
    [anon_sym_eof] = ACTIONS(3327),
    [anon_sym_exp] = ACTIONS(3327),
    [anon_sym_each] = ACTIONS(3327),
    [anon_sym_fc] = ACTIONS(3327),
    [anon_sym_fileno] = ACTIONS(3327),
    [anon_sym_gmtime] = ACTIONS(3327),
    [anon_sym_getc] = ACTIONS(3327),
    [anon_sym_getpgrp] = ACTIONS(3327),
    [anon_sym_getprotobyname] = ACTIONS(3327),
    [anon_sym_getpwname] = ACTIONS(3327),
    [anon_sym_getpwuid] = ACTIONS(3327),
    [anon_sym_getpeername] = ACTIONS(3327),
    [anon_sym_getnetbyname] = ACTIONS(3327),
    [anon_sym_getsockname] = ACTIONS(3327),
    [anon_sym_getgrnam] = ACTIONS(3327),
    [anon_sym_getgrgid] = ACTIONS(3327),
    [anon_sym_hex] = ACTIONS(3327),
    [anon_sym_int] = ACTIONS(3327),
    [anon_sym_keys] = ACTIONS(3327),
    [anon_sym_lc] = ACTIONS(3327),
    [anon_sym_lcfirst] = ACTIONS(3327),
    [anon_sym_length] = ACTIONS(3327),
    [anon_sym_localtime] = ACTIONS(3327),
    [anon_sym_log] = ACTIONS(3327),
    [anon_sym_lock] = ACTIONS(3327),
    [anon_sym_lstat] = ACTIONS(3327),
    [anon_sym_oct] = ACTIONS(3327),
    [anon_sym_ord] = ACTIONS(3327),
    [anon_sym_prototype] = ACTIONS(3327),
    [anon_sym_pop] = ACTIONS(3327),
    [anon_sym_pos] = ACTIONS(3327),
    [anon_sym_quotemeta] = ACTIONS(3327),
    [anon_sym_reset] = ACTIONS(3327),
    [anon_sym_rand] = ACTIONS(3327),
    [anon_sym_rmdir] = ACTIONS(3327),
    [anon_sym_readdir] = ACTIONS(3327),
    [anon_sym_readline] = ACTIONS(3327),
    [anon_sym_readpipe] = ACTIONS(3327),
    [anon_sym_rewinddir] = ACTIONS(3327),
    [anon_sym_readlink] = ACTIONS(3327),
    [anon_sym_ref] = ACTIONS(3327),
    [anon_sym_scalar] = ACTIONS(3327),
    [anon_sym_shift] = ACTIONS(3327),
    [anon_sym_sin] = ACTIONS(3327),
    [anon_sym_sleep] = ACTIONS(3327),
    [anon_sym_sqrt] = ACTIONS(3327),
    [anon_sym_srand] = ACTIONS(3327),
    [anon_sym_stat] = ACTIONS(3327),
    [anon_sym_study] = ACTIONS(3327),
    [anon_sym_tell] = ACTIONS(3327),
    [anon_sym_telldir] = ACTIONS(3327),
    [anon_sym_tied] = ACTIONS(3327),
    [anon_sym_uc] = ACTIONS(3327),
    [anon_sym_ucfirst] = ACTIONS(3327),
    [anon_sym_untie] = ACTIONS(3327),
    [anon_sym_umask] = ACTIONS(3327),
    [anon_sym_values] = ACTIONS(3327),
    [anon_sym_write] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3327),
    [anon_sym___END__] = ACTIONS(3327),
    [anon_sym_q] = ACTIONS(3327),
    [anon_sym_qq] = ACTIONS(3327),
    [anon_sym_qw] = ACTIONS(3327),
    [anon_sym_qx] = ACTIONS(3327),
    [anon_sym_qr] = ACTIONS(3327),
    [anon_sym_m] = ACTIONS(3327),
    [anon_sym_s] = ACTIONS(3327),
    [anon_sym_tr] = ACTIONS(3327),
    [anon_sym_y] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_unless] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_until] = ACTIONS(3327),
    [aux_sym__bareword_token1] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [sym__apostrophe] = ACTIONS(3325),
    [sym__double_quote] = ACTIONS(3325),
    [sym__backtick] = ACTIONS(3325),
    [sym__search_slash] = ACTIONS(3325),
    [sym__PERLY_HEREDOC] = ACTIONS(3325),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1125] = {
    [sym_heredoc_content] = STATE(1125),
    [sym__identifier] = ACTIONS(3386),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_SEMI] = ACTIONS(3386),
    [anon_sym_class] = ACTIONS(3386),
    [anon_sym_sub] = ACTIONS(3386),
    [anon_sym_method] = ACTIONS(3386),
    [anon_sym_LPAREN] = ACTIONS(3386),
    [anon_sym_continue] = ACTIONS(3386),
    [anon_sym_my] = ACTIONS(3386),
    [anon_sym_state] = ACTIONS(3386),
    [anon_sym_our] = ACTIONS(3386),
    [anon_sym_try] = ACTIONS(3386),
    [anon_sym_else] = ACTIONS(3386),
    [anon_sym_elsif] = ACTIONS(3386),
    [anon_sym_and] = ACTIONS(3386),
    [anon_sym_or] = ACTIONS(3386),
    [anon_sym_DOLLAR] = ACTIONS(3386),
    [anon_sym_LBRACK] = ACTIONS(3386),
    [anon_sym_AT] = ACTIONS(3386),
    [anon_sym_LT] = ACTIONS(3386),
    [anon_sym_LT_LT] = ACTIONS(3386),
    [anon_sym_SLASH_SLASH] = ACTIONS(3386),
    [anon_sym_PLUS] = ACTIONS(3386),
    [anon_sym_DASH] = ACTIONS(3386),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_eq] = ACTIONS(3386),
    [anon_sym_ne] = ACTIONS(3386),
    [anon_sym_cmp] = ACTIONS(3386),
    [anon_sym_lt] = ACTIONS(3386),
    [anon_sym_le] = ACTIONS(3386),
    [anon_sym_ge] = ACTIONS(3386),
    [anon_sym_gt] = ACTIONS(3386),
    [anon_sym_isa] = ACTIONS(3386),
    [anon_sym_TILDE] = ACTIONS(3386),
    [anon_sym_BANG] = ACTIONS(3386),
    [anon_sym_PLUS_PLUS] = ACTIONS(3386),
    [anon_sym_DASH_DASH] = ACTIONS(3386),
    [anon_sym_BSLASH] = ACTIONS(3388),
    [anon_sym_do] = ACTIONS(3386),
    [anon_sym_eval] = ACTIONS(3386),
    [anon_sym_field] = ACTIONS(3386),
    [anon_sym_local] = ACTIONS(3386),
    [anon_sym_require] = ACTIONS(3386),
    [anon_sym_map] = ACTIONS(3386),
    [anon_sym_grep] = ACTIONS(3386),
    [anon_sym_sort] = ACTIONS(3386),
    [anon_sym_goto] = ACTIONS(3386),
    [anon_sym_return] = ACTIONS(3386),
    [anon_sym_undef] = ACTIONS(3386),
    [anon_sym_PERCENT2] = ACTIONS(3386),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3386),
    [anon_sym_use] = ACTIONS(3386),
    [anon_sym_no] = ACTIONS(3386),
    [anon_sym_for] = ACTIONS(3386),
    [anon_sym_foreach] = ACTIONS(3386),
    [anon_sym_last] = ACTIONS(3386),
    [anon_sym_next] = ACTIONS(3386),
    [anon_sym_redo] = ACTIONS(3386),
    [anon_sym_BEGIN] = ACTIONS(3386),
    [anon_sym_INIT] = ACTIONS(3386),
    [anon_sym_CHECK] = ACTIONS(3386),
    [anon_sym_UNITCHECK] = ACTIONS(3386),
    [anon_sym_END] = ACTIONS(3386),
    [anon_sym_ADJUST] = ACTIONS(3386),
    [anon_sym___FILE__] = ACTIONS(3386),
    [anon_sym___LINE__] = ACTIONS(3386),
    [anon_sym___PACKAGE__] = ACTIONS(3386),
    [anon_sym___SUB__] = ACTIONS(3386),
    [anon_sym_break] = ACTIONS(3386),
    [anon_sym_fork] = ACTIONS(3386),
    [anon_sym_getppid] = ACTIONS(3386),
    [anon_sym_time] = ACTIONS(3386),
    [anon_sym_times] = ACTIONS(3386),
    [anon_sym_wait] = ACTIONS(3386),
    [anon_sym_wantarray] = ACTIONS(3386),
    [anon_sym_abs] = ACTIONS(3386),
    [anon_sym_alarm] = ACTIONS(3386),
    [anon_sym_chop] = ACTIONS(3386),
    [anon_sym_chdir] = ACTIONS(3386),
    [anon_sym_close] = ACTIONS(3386),
    [anon_sym_closedir] = ACTIONS(3386),
    [anon_sym_caller] = ACTIONS(3386),
    [anon_sym_chomp] = ACTIONS(3386),
    [anon_sym_chr] = ACTIONS(3386),
    [anon_sym_cos] = ACTIONS(3386),
    [anon_sym_chroot] = ACTIONS(3386),
    [anon_sym_defined] = ACTIONS(3386),
    [anon_sym_delete] = ACTIONS(3386),
    [anon_sym_dbmclose] = ACTIONS(3386),
    [anon_sym_exists] = ACTIONS(3386),
    [anon_sym_exit] = ACTIONS(3386),
    [anon_sym_eof] = ACTIONS(3386),
    [anon_sym_exp] = ACTIONS(3386),
    [anon_sym_each] = ACTIONS(3386),
    [anon_sym_fc] = ACTIONS(3386),
    [anon_sym_fileno] = ACTIONS(3386),
    [anon_sym_gmtime] = ACTIONS(3386),
    [anon_sym_getc] = ACTIONS(3386),
    [anon_sym_getpgrp] = ACTIONS(3386),
    [anon_sym_getprotobyname] = ACTIONS(3386),
    [anon_sym_getpwname] = ACTIONS(3386),
    [anon_sym_getpwuid] = ACTIONS(3386),
    [anon_sym_getpeername] = ACTIONS(3386),
    [anon_sym_getnetbyname] = ACTIONS(3386),
    [anon_sym_getsockname] = ACTIONS(3386),
    [anon_sym_getgrnam] = ACTIONS(3386),
    [anon_sym_getgrgid] = ACTIONS(3386),
    [anon_sym_hex] = ACTIONS(3386),
    [anon_sym_int] = ACTIONS(3386),
    [anon_sym_keys] = ACTIONS(3386),
    [anon_sym_lc] = ACTIONS(3386),
    [anon_sym_lcfirst] = ACTIONS(3386),
    [anon_sym_length] = ACTIONS(3386),
    [anon_sym_localtime] = ACTIONS(3386),
    [anon_sym_log] = ACTIONS(3386),
    [anon_sym_lock] = ACTIONS(3386),
    [anon_sym_lstat] = ACTIONS(3386),
    [anon_sym_oct] = ACTIONS(3386),
    [anon_sym_ord] = ACTIONS(3386),
    [anon_sym_prototype] = ACTIONS(3386),
    [anon_sym_pop] = ACTIONS(3386),
    [anon_sym_pos] = ACTIONS(3386),
    [anon_sym_quotemeta] = ACTIONS(3386),
    [anon_sym_reset] = ACTIONS(3386),
    [anon_sym_rand] = ACTIONS(3386),
    [anon_sym_rmdir] = ACTIONS(3386),
    [anon_sym_readdir] = ACTIONS(3386),
    [anon_sym_readline] = ACTIONS(3386),
    [anon_sym_readpipe] = ACTIONS(3386),
    [anon_sym_rewinddir] = ACTIONS(3386),
    [anon_sym_readlink] = ACTIONS(3386),
    [anon_sym_ref] = ACTIONS(3386),
    [anon_sym_scalar] = ACTIONS(3386),
    [anon_sym_shift] = ACTIONS(3386),
    [anon_sym_sin] = ACTIONS(3386),
    [anon_sym_sleep] = ACTIONS(3386),
    [anon_sym_sqrt] = ACTIONS(3386),
    [anon_sym_srand] = ACTIONS(3386),
    [anon_sym_stat] = ACTIONS(3386),
    [anon_sym_study] = ACTIONS(3386),
    [anon_sym_tell] = ACTIONS(3386),
    [anon_sym_telldir] = ACTIONS(3386),
    [anon_sym_tied] = ACTIONS(3386),
    [anon_sym_uc] = ACTIONS(3386),
    [anon_sym_ucfirst] = ACTIONS(3386),
    [anon_sym_untie] = ACTIONS(3386),
    [anon_sym_umask] = ACTIONS(3386),
    [anon_sym_values] = ACTIONS(3386),
    [anon_sym_write] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3386),
    [anon_sym___END__] = ACTIONS(3386),
    [anon_sym_q] = ACTIONS(3386),
    [anon_sym_qq] = ACTIONS(3386),
    [anon_sym_qw] = ACTIONS(3386),
    [anon_sym_qx] = ACTIONS(3386),
    [anon_sym_qr] = ACTIONS(3386),
    [anon_sym_m] = ACTIONS(3386),
    [anon_sym_s] = ACTIONS(3386),
    [anon_sym_tr] = ACTIONS(3386),
    [anon_sym_y] = ACTIONS(3386),
    [sym_version] = ACTIONS(3386),
    [anon_sym_if] = ACTIONS(3386),
    [anon_sym_unless] = ACTIONS(3386),
    [anon_sym_while] = ACTIONS(3386),
    [anon_sym_until] = ACTIONS(3386),
    [aux_sym__bareword_token1] = ACTIONS(3386),
    [sym_number] = ACTIONS(3386),
    [sym__apostrophe] = ACTIONS(3388),
    [sym__double_quote] = ACTIONS(3388),
    [sym__backtick] = ACTIONS(3388),
    [sym__search_slash] = ACTIONS(3388),
    [sym__PERLY_SEMICOLON] = ACTIONS(3388),
    [sym__PERLY_HEREDOC] = ACTIONS(3388),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1126] = {
    [sym_heredoc_content] = STATE(1126),
    [sym__identifier] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym_class] = ACTIONS(2942),
    [anon_sym_sub] = ACTIONS(2942),
    [anon_sym_method] = ACTIONS(2942),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_continue] = ACTIONS(2942),
    [anon_sym_my] = ACTIONS(2942),
    [anon_sym_state] = ACTIONS(2942),
    [anon_sym_our] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_else] = ACTIONS(2942),
    [anon_sym_elsif] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(2942),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_LT_LT] = ACTIONS(2942),
    [anon_sym_SLASH_SLASH] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_eq] = ACTIONS(2942),
    [anon_sym_ne] = ACTIONS(2942),
    [anon_sym_cmp] = ACTIONS(2942),
    [anon_sym_lt] = ACTIONS(2942),
    [anon_sym_le] = ACTIONS(2942),
    [anon_sym_ge] = ACTIONS(2942),
    [anon_sym_gt] = ACTIONS(2942),
    [anon_sym_isa] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2942),
    [anon_sym_BANG] = ACTIONS(2942),
    [anon_sym_PLUS_PLUS] = ACTIONS(2942),
    [anon_sym_DASH_DASH] = ACTIONS(2942),
    [anon_sym_BSLASH] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_eval] = ACTIONS(2942),
    [anon_sym_field] = ACTIONS(2942),
    [anon_sym_local] = ACTIONS(2942),
    [anon_sym_require] = ACTIONS(2942),
    [anon_sym_map] = ACTIONS(2942),
    [anon_sym_grep] = ACTIONS(2942),
    [anon_sym_sort] = ACTIONS(2942),
    [anon_sym_goto] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_undef] = ACTIONS(2942),
    [anon_sym_PERCENT2] = ACTIONS(2942),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2942),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_no] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_foreach] = ACTIONS(2942),
    [anon_sym_last] = ACTIONS(2942),
    [anon_sym_next] = ACTIONS(2942),
    [anon_sym_redo] = ACTIONS(2942),
    [anon_sym_BEGIN] = ACTIONS(2942),
    [anon_sym_INIT] = ACTIONS(2942),
    [anon_sym_CHECK] = ACTIONS(2942),
    [anon_sym_UNITCHECK] = ACTIONS(2942),
    [anon_sym_END] = ACTIONS(2942),
    [anon_sym_ADJUST] = ACTIONS(2942),
    [anon_sym___FILE__] = ACTIONS(2942),
    [anon_sym___LINE__] = ACTIONS(2942),
    [anon_sym___PACKAGE__] = ACTIONS(2942),
    [anon_sym___SUB__] = ACTIONS(2942),
    [anon_sym_break] = ACTIONS(2942),
    [anon_sym_fork] = ACTIONS(2942),
    [anon_sym_getppid] = ACTIONS(2942),
    [anon_sym_time] = ACTIONS(2942),
    [anon_sym_times] = ACTIONS(2942),
    [anon_sym_wait] = ACTIONS(2942),
    [anon_sym_wantarray] = ACTIONS(2942),
    [anon_sym_abs] = ACTIONS(2942),
    [anon_sym_alarm] = ACTIONS(2942),
    [anon_sym_chop] = ACTIONS(2942),
    [anon_sym_chdir] = ACTIONS(2942),
    [anon_sym_close] = ACTIONS(2942),
    [anon_sym_closedir] = ACTIONS(2942),
    [anon_sym_caller] = ACTIONS(2942),
    [anon_sym_chomp] = ACTIONS(2942),
    [anon_sym_chr] = ACTIONS(2942),
    [anon_sym_cos] = ACTIONS(2942),
    [anon_sym_chroot] = ACTIONS(2942),
    [anon_sym_defined] = ACTIONS(2942),
    [anon_sym_delete] = ACTIONS(2942),
    [anon_sym_dbmclose] = ACTIONS(2942),
    [anon_sym_exists] = ACTIONS(2942),
    [anon_sym_exit] = ACTIONS(2942),
    [anon_sym_eof] = ACTIONS(2942),
    [anon_sym_exp] = ACTIONS(2942),
    [anon_sym_each] = ACTIONS(2942),
    [anon_sym_fc] = ACTIONS(2942),
    [anon_sym_fileno] = ACTIONS(2942),
    [anon_sym_gmtime] = ACTIONS(2942),
    [anon_sym_getc] = ACTIONS(2942),
    [anon_sym_getpgrp] = ACTIONS(2942),
    [anon_sym_getprotobyname] = ACTIONS(2942),
    [anon_sym_getpwname] = ACTIONS(2942),
    [anon_sym_getpwuid] = ACTIONS(2942),
    [anon_sym_getpeername] = ACTIONS(2942),
    [anon_sym_getnetbyname] = ACTIONS(2942),
    [anon_sym_getsockname] = ACTIONS(2942),
    [anon_sym_getgrnam] = ACTIONS(2942),
    [anon_sym_getgrgid] = ACTIONS(2942),
    [anon_sym_hex] = ACTIONS(2942),
    [anon_sym_int] = ACTIONS(2942),
    [anon_sym_keys] = ACTIONS(2942),
    [anon_sym_lc] = ACTIONS(2942),
    [anon_sym_lcfirst] = ACTIONS(2942),
    [anon_sym_length] = ACTIONS(2942),
    [anon_sym_localtime] = ACTIONS(2942),
    [anon_sym_log] = ACTIONS(2942),
    [anon_sym_lock] = ACTIONS(2942),
    [anon_sym_lstat] = ACTIONS(2942),
    [anon_sym_oct] = ACTIONS(2942),
    [anon_sym_ord] = ACTIONS(2942),
    [anon_sym_prototype] = ACTIONS(2942),
    [anon_sym_pop] = ACTIONS(2942),
    [anon_sym_pos] = ACTIONS(2942),
    [anon_sym_quotemeta] = ACTIONS(2942),
    [anon_sym_reset] = ACTIONS(2942),
    [anon_sym_rand] = ACTIONS(2942),
    [anon_sym_rmdir] = ACTIONS(2942),
    [anon_sym_readdir] = ACTIONS(2942),
    [anon_sym_readline] = ACTIONS(2942),
    [anon_sym_readpipe] = ACTIONS(2942),
    [anon_sym_rewinddir] = ACTIONS(2942),
    [anon_sym_readlink] = ACTIONS(2942),
    [anon_sym_ref] = ACTIONS(2942),
    [anon_sym_scalar] = ACTIONS(2942),
    [anon_sym_shift] = ACTIONS(2942),
    [anon_sym_sin] = ACTIONS(2942),
    [anon_sym_sleep] = ACTIONS(2942),
    [anon_sym_sqrt] = ACTIONS(2942),
    [anon_sym_srand] = ACTIONS(2942),
    [anon_sym_stat] = ACTIONS(2942),
    [anon_sym_study] = ACTIONS(2942),
    [anon_sym_tell] = ACTIONS(2942),
    [anon_sym_telldir] = ACTIONS(2942),
    [anon_sym_tied] = ACTIONS(2942),
    [anon_sym_uc] = ACTIONS(2942),
    [anon_sym_ucfirst] = ACTIONS(2942),
    [anon_sym_untie] = ACTIONS(2942),
    [anon_sym_umask] = ACTIONS(2942),
    [anon_sym_values] = ACTIONS(2942),
    [anon_sym_write] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2942),
    [anon_sym___END__] = ACTIONS(2942),
    [anon_sym_q] = ACTIONS(2942),
    [anon_sym_qq] = ACTIONS(2942),
    [anon_sym_qw] = ACTIONS(2942),
    [anon_sym_qx] = ACTIONS(2942),
    [anon_sym_qr] = ACTIONS(2942),
    [anon_sym_m] = ACTIONS(2942),
    [anon_sym_s] = ACTIONS(2942),
    [anon_sym_tr] = ACTIONS(2942),
    [anon_sym_y] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_unless] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_until] = ACTIONS(2942),
    [aux_sym__bareword_token1] = ACTIONS(2942),
    [sym_number] = ACTIONS(2942),
    [sym__apostrophe] = ACTIONS(2946),
    [sym__double_quote] = ACTIONS(2946),
    [sym__backtick] = ACTIONS(2946),
    [sym__search_slash] = ACTIONS(2946),
    [sym__PERLY_SEMICOLON] = ACTIONS(2946),
    [sym__PERLY_HEREDOC] = ACTIONS(2946),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1127] = {
    [sym_heredoc_content] = STATE(1127),
    [sym__identifier] = ACTIONS(3390),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_class] = ACTIONS(3390),
    [anon_sym_sub] = ACTIONS(3390),
    [anon_sym_method] = ACTIONS(3390),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_continue] = ACTIONS(3390),
    [anon_sym_my] = ACTIONS(3390),
    [anon_sym_state] = ACTIONS(3390),
    [anon_sym_our] = ACTIONS(3390),
    [anon_sym_try] = ACTIONS(3390),
    [anon_sym_else] = ACTIONS(3390),
    [anon_sym_elsif] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(3390),
    [anon_sym_or] = ACTIONS(3390),
    [anon_sym_DOLLAR] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3390),
    [anon_sym_AT] = ACTIONS(3390),
    [anon_sym_LT] = ACTIONS(3390),
    [anon_sym_LT_LT] = ACTIONS(3390),
    [anon_sym_SLASH_SLASH] = ACTIONS(3390),
    [anon_sym_PLUS] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3390),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_eq] = ACTIONS(3390),
    [anon_sym_ne] = ACTIONS(3390),
    [anon_sym_cmp] = ACTIONS(3390),
    [anon_sym_lt] = ACTIONS(3390),
    [anon_sym_le] = ACTIONS(3390),
    [anon_sym_ge] = ACTIONS(3390),
    [anon_sym_gt] = ACTIONS(3390),
    [anon_sym_isa] = ACTIONS(3390),
    [anon_sym_TILDE] = ACTIONS(3390),
    [anon_sym_BANG] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_BSLASH] = ACTIONS(3392),
    [anon_sym_do] = ACTIONS(3390),
    [anon_sym_eval] = ACTIONS(3390),
    [anon_sym_field] = ACTIONS(3390),
    [anon_sym_local] = ACTIONS(3390),
    [anon_sym_require] = ACTIONS(3390),
    [anon_sym_map] = ACTIONS(3390),
    [anon_sym_grep] = ACTIONS(3390),
    [anon_sym_sort] = ACTIONS(3390),
    [anon_sym_goto] = ACTIONS(3390),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_undef] = ACTIONS(3390),
    [anon_sym_PERCENT2] = ACTIONS(3390),
    [anon_sym_DOLLAR_POUND] = ACTIONS(3390),
    [anon_sym_use] = ACTIONS(3390),
    [anon_sym_no] = ACTIONS(3390),
    [anon_sym_for] = ACTIONS(3390),
    [anon_sym_foreach] = ACTIONS(3390),
    [anon_sym_last] = ACTIONS(3390),
    [anon_sym_next] = ACTIONS(3390),
    [anon_sym_redo] = ACTIONS(3390),
    [anon_sym_BEGIN] = ACTIONS(3390),
    [anon_sym_INIT] = ACTIONS(3390),
    [anon_sym_CHECK] = ACTIONS(3390),
    [anon_sym_UNITCHECK] = ACTIONS(3390),
    [anon_sym_END] = ACTIONS(3390),
    [anon_sym_ADJUST] = ACTIONS(3390),
    [anon_sym___FILE__] = ACTIONS(3390),
    [anon_sym___LINE__] = ACTIONS(3390),
    [anon_sym___PACKAGE__] = ACTIONS(3390),
    [anon_sym___SUB__] = ACTIONS(3390),
    [anon_sym_break] = ACTIONS(3390),
    [anon_sym_fork] = ACTIONS(3390),
    [anon_sym_getppid] = ACTIONS(3390),
    [anon_sym_time] = ACTIONS(3390),
    [anon_sym_times] = ACTIONS(3390),
    [anon_sym_wait] = ACTIONS(3390),
    [anon_sym_wantarray] = ACTIONS(3390),
    [anon_sym_abs] = ACTIONS(3390),
    [anon_sym_alarm] = ACTIONS(3390),
    [anon_sym_chop] = ACTIONS(3390),
    [anon_sym_chdir] = ACTIONS(3390),
    [anon_sym_close] = ACTIONS(3390),
    [anon_sym_closedir] = ACTIONS(3390),
    [anon_sym_caller] = ACTIONS(3390),
    [anon_sym_chomp] = ACTIONS(3390),
    [anon_sym_chr] = ACTIONS(3390),
    [anon_sym_cos] = ACTIONS(3390),
    [anon_sym_chroot] = ACTIONS(3390),
    [anon_sym_defined] = ACTIONS(3390),
    [anon_sym_delete] = ACTIONS(3390),
    [anon_sym_dbmclose] = ACTIONS(3390),
    [anon_sym_exists] = ACTIONS(3390),
    [anon_sym_exit] = ACTIONS(3390),
    [anon_sym_eof] = ACTIONS(3390),
    [anon_sym_exp] = ACTIONS(3390),
    [anon_sym_each] = ACTIONS(3390),
    [anon_sym_fc] = ACTIONS(3390),
    [anon_sym_fileno] = ACTIONS(3390),
    [anon_sym_gmtime] = ACTIONS(3390),
    [anon_sym_getc] = ACTIONS(3390),
    [anon_sym_getpgrp] = ACTIONS(3390),
    [anon_sym_getprotobyname] = ACTIONS(3390),
    [anon_sym_getpwname] = ACTIONS(3390),
    [anon_sym_getpwuid] = ACTIONS(3390),
    [anon_sym_getpeername] = ACTIONS(3390),
    [anon_sym_getnetbyname] = ACTIONS(3390),
    [anon_sym_getsockname] = ACTIONS(3390),
    [anon_sym_getgrnam] = ACTIONS(3390),
    [anon_sym_getgrgid] = ACTIONS(3390),
    [anon_sym_hex] = ACTIONS(3390),
    [anon_sym_int] = ACTIONS(3390),
    [anon_sym_keys] = ACTIONS(3390),
    [anon_sym_lc] = ACTIONS(3390),
    [anon_sym_lcfirst] = ACTIONS(3390),
    [anon_sym_length] = ACTIONS(3390),
    [anon_sym_localtime] = ACTIONS(3390),
    [anon_sym_log] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3390),
    [anon_sym_lstat] = ACTIONS(3390),
    [anon_sym_oct] = ACTIONS(3390),
    [anon_sym_ord] = ACTIONS(3390),
    [anon_sym_prototype] = ACTIONS(3390),
    [anon_sym_pop] = ACTIONS(3390),
    [anon_sym_pos] = ACTIONS(3390),
    [anon_sym_quotemeta] = ACTIONS(3390),
    [anon_sym_reset] = ACTIONS(3390),
    [anon_sym_rand] = ACTIONS(3390),
    [anon_sym_rmdir] = ACTIONS(3390),
    [anon_sym_readdir] = ACTIONS(3390),
    [anon_sym_readline] = ACTIONS(3390),
    [anon_sym_readpipe] = ACTIONS(3390),
    [anon_sym_rewinddir] = ACTIONS(3390),
    [anon_sym_readlink] = ACTIONS(3390),
    [anon_sym_ref] = ACTIONS(3390),
    [anon_sym_scalar] = ACTIONS(3390),
    [anon_sym_shift] = ACTIONS(3390),
    [anon_sym_sin] = ACTIONS(3390),
    [anon_sym_sleep] = ACTIONS(3390),
    [anon_sym_sqrt] = ACTIONS(3390),
    [anon_sym_srand] = ACTIONS(3390),
    [anon_sym_stat] = ACTIONS(3390),
    [anon_sym_study] = ACTIONS(3390),
    [anon_sym_tell] = ACTIONS(3390),
    [anon_sym_telldir] = ACTIONS(3390),
    [anon_sym_tied] = ACTIONS(3390),
    [anon_sym_uc] = ACTIONS(3390),
    [anon_sym_ucfirst] = ACTIONS(3390),
    [anon_sym_untie] = ACTIONS(3390),
    [anon_sym_umask] = ACTIONS(3390),
    [anon_sym_values] = ACTIONS(3390),
    [anon_sym_write] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(3390),
    [anon_sym___END__] = ACTIONS(3390),
    [anon_sym_q] = ACTIONS(3390),
    [anon_sym_qq] = ACTIONS(3390),
    [anon_sym_qw] = ACTIONS(3390),
    [anon_sym_qx] = ACTIONS(3390),
    [anon_sym_qr] = ACTIONS(3390),
    [anon_sym_m] = ACTIONS(3390),
    [anon_sym_s] = ACTIONS(3390),
    [anon_sym_tr] = ACTIONS(3390),
    [anon_sym_y] = ACTIONS(3390),
    [anon_sym_if] = ACTIONS(3390),
    [anon_sym_unless] = ACTIONS(3390),
    [anon_sym_while] = ACTIONS(3390),
    [anon_sym_until] = ACTIONS(3390),
    [aux_sym__bareword_token1] = ACTIONS(3390),
    [sym_number] = ACTIONS(3390),
    [sym__apostrophe] = ACTIONS(3392),
    [sym__double_quote] = ACTIONS(3392),
    [sym__backtick] = ACTIONS(3392),
    [sym__search_slash] = ACTIONS(3392),
    [sym__PERLY_HEREDOC] = ACTIONS(3392),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1128] = {
    [sym_heredoc_content] = STATE(1128),
    [sym__identifier] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_sub] = ACTIONS(2927),
    [anon_sym_method] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_my] = ACTIONS(2927),
    [anon_sym_state] = ACTIONS(2927),
    [anon_sym_our] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_elsif] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2927),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_LT] = ACTIONS(2927),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_SLASH_SLASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_eq] = ACTIONS(2927),
    [anon_sym_ne] = ACTIONS(2927),
    [anon_sym_cmp] = ACTIONS(2927),
    [anon_sym_lt] = ACTIONS(2927),
    [anon_sym_le] = ACTIONS(2927),
    [anon_sym_ge] = ACTIONS(2927),
    [anon_sym_gt] = ACTIONS(2927),
    [anon_sym_isa] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_BSLASH] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_eval] = ACTIONS(2927),
    [anon_sym_field] = ACTIONS(2927),
    [anon_sym_local] = ACTIONS(2927),
    [anon_sym_require] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(2927),
    [anon_sym_grep] = ACTIONS(2927),
    [anon_sym_sort] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_undef] = ACTIONS(2927),
    [anon_sym_PERCENT2] = ACTIONS(2927),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2927),
    [anon_sym_use] = ACTIONS(2927),
    [anon_sym_no] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_foreach] = ACTIONS(2927),
    [anon_sym_last] = ACTIONS(2927),
    [anon_sym_next] = ACTIONS(2927),
    [anon_sym_redo] = ACTIONS(2927),
    [anon_sym_BEGIN] = ACTIONS(2927),
    [anon_sym_INIT] = ACTIONS(2927),
    [anon_sym_CHECK] = ACTIONS(2927),
    [anon_sym_UNITCHECK] = ACTIONS(2927),
    [anon_sym_END] = ACTIONS(2927),
    [anon_sym_ADJUST] = ACTIONS(2927),
    [anon_sym___FILE__] = ACTIONS(2927),
    [anon_sym___LINE__] = ACTIONS(2927),
    [anon_sym___PACKAGE__] = ACTIONS(2927),
    [anon_sym___SUB__] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_fork] = ACTIONS(2927),
    [anon_sym_getppid] = ACTIONS(2927),
    [anon_sym_time] = ACTIONS(2927),
    [anon_sym_times] = ACTIONS(2927),
    [anon_sym_wait] = ACTIONS(2927),
    [anon_sym_wantarray] = ACTIONS(2927),
    [anon_sym_abs] = ACTIONS(2927),
    [anon_sym_alarm] = ACTIONS(2927),
    [anon_sym_chop] = ACTIONS(2927),
    [anon_sym_chdir] = ACTIONS(2927),
    [anon_sym_close] = ACTIONS(2927),
    [anon_sym_closedir] = ACTIONS(2927),
    [anon_sym_caller] = ACTIONS(2927),
    [anon_sym_chomp] = ACTIONS(2927),
    [anon_sym_chr] = ACTIONS(2927),
    [anon_sym_cos] = ACTIONS(2927),
    [anon_sym_chroot] = ACTIONS(2927),
    [anon_sym_defined] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_dbmclose] = ACTIONS(2927),
    [anon_sym_exists] = ACTIONS(2927),
    [anon_sym_exit] = ACTIONS(2927),
    [anon_sym_eof] = ACTIONS(2927),
    [anon_sym_exp] = ACTIONS(2927),
    [anon_sym_each] = ACTIONS(2927),
    [anon_sym_fc] = ACTIONS(2927),
    [anon_sym_fileno] = ACTIONS(2927),
    [anon_sym_gmtime] = ACTIONS(2927),
    [anon_sym_getc] = ACTIONS(2927),
    [anon_sym_getpgrp] = ACTIONS(2927),
    [anon_sym_getprotobyname] = ACTIONS(2927),
    [anon_sym_getpwname] = ACTIONS(2927),
    [anon_sym_getpwuid] = ACTIONS(2927),
    [anon_sym_getpeername] = ACTIONS(2927),
    [anon_sym_getnetbyname] = ACTIONS(2927),
    [anon_sym_getsockname] = ACTIONS(2927),
    [anon_sym_getgrnam] = ACTIONS(2927),
    [anon_sym_getgrgid] = ACTIONS(2927),
    [anon_sym_hex] = ACTIONS(2927),
    [anon_sym_int] = ACTIONS(2927),
    [anon_sym_keys] = ACTIONS(2927),
    [anon_sym_lc] = ACTIONS(2927),
    [anon_sym_lcfirst] = ACTIONS(2927),
    [anon_sym_length] = ACTIONS(2927),
    [anon_sym_localtime] = ACTIONS(2927),
    [anon_sym_log] = ACTIONS(2927),
    [anon_sym_lock] = ACTIONS(2927),
    [anon_sym_lstat] = ACTIONS(2927),
    [anon_sym_oct] = ACTIONS(2927),
    [anon_sym_ord] = ACTIONS(2927),
    [anon_sym_prototype] = ACTIONS(2927),
    [anon_sym_pop] = ACTIONS(2927),
    [anon_sym_pos] = ACTIONS(2927),
    [anon_sym_quotemeta] = ACTIONS(2927),
    [anon_sym_reset] = ACTIONS(2927),
    [anon_sym_rand] = ACTIONS(2927),
    [anon_sym_rmdir] = ACTIONS(2927),
    [anon_sym_readdir] = ACTIONS(2927),
    [anon_sym_readline] = ACTIONS(2927),
    [anon_sym_readpipe] = ACTIONS(2927),
    [anon_sym_rewinddir] = ACTIONS(2927),
    [anon_sym_readlink] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(2927),
    [anon_sym_scalar] = ACTIONS(2927),
    [anon_sym_shift] = ACTIONS(2927),
    [anon_sym_sin] = ACTIONS(2927),
    [anon_sym_sleep] = ACTIONS(2927),
    [anon_sym_sqrt] = ACTIONS(2927),
    [anon_sym_srand] = ACTIONS(2927),
    [anon_sym_stat] = ACTIONS(2927),
    [anon_sym_study] = ACTIONS(2927),
    [anon_sym_tell] = ACTIONS(2927),
    [anon_sym_telldir] = ACTIONS(2927),
    [anon_sym_tied] = ACTIONS(2927),
    [anon_sym_uc] = ACTIONS(2927),
    [anon_sym_ucfirst] = ACTIONS(2927),
    [anon_sym_untie] = ACTIONS(2927),
    [anon_sym_umask] = ACTIONS(2927),
    [anon_sym_values] = ACTIONS(2927),
    [anon_sym_write] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2927),
    [anon_sym___END__] = ACTIONS(2927),
    [anon_sym_q] = ACTIONS(2927),
    [anon_sym_qq] = ACTIONS(2927),
    [anon_sym_qw] = ACTIONS(2927),
    [anon_sym_qx] = ACTIONS(2927),
    [anon_sym_qr] = ACTIONS(2927),
    [anon_sym_m] = ACTIONS(2927),
    [anon_sym_s] = ACTIONS(2927),
    [anon_sym_tr] = ACTIONS(2927),
    [anon_sym_y] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_unless] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_until] = ACTIONS(2927),
    [aux_sym__bareword_token1] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym__apostrophe] = ACTIONS(2934),
    [sym__double_quote] = ACTIONS(2934),
    [sym__backtick] = ACTIONS(2934),
    [sym__search_slash] = ACTIONS(2934),
    [sym__PERLY_HEREDOC] = ACTIONS(2934),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1129] = {
    [sym_heredoc_content] = STATE(1129),
    [sym__identifier] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_sub] = ACTIONS(2905),
    [anon_sym_method] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_my] = ACTIONS(2905),
    [anon_sym_state] = ACTIONS(2905),
    [anon_sym_our] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_elsif] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_eq] = ACTIONS(2905),
    [anon_sym_ne] = ACTIONS(2905),
    [anon_sym_cmp] = ACTIONS(2905),
    [anon_sym_lt] = ACTIONS(2905),
    [anon_sym_le] = ACTIONS(2905),
    [anon_sym_ge] = ACTIONS(2905),
    [anon_sym_gt] = ACTIONS(2905),
    [anon_sym_isa] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_BSLASH] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_eval] = ACTIONS(2905),
    [anon_sym_field] = ACTIONS(2905),
    [anon_sym_local] = ACTIONS(2905),
    [anon_sym_require] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(2905),
    [anon_sym_grep] = ACTIONS(2905),
    [anon_sym_sort] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_undef] = ACTIONS(2905),
    [anon_sym_PERCENT2] = ACTIONS(2905),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_no] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2905),
    [anon_sym_last] = ACTIONS(2905),
    [anon_sym_next] = ACTIONS(2905),
    [anon_sym_redo] = ACTIONS(2905),
    [anon_sym_BEGIN] = ACTIONS(2905),
    [anon_sym_INIT] = ACTIONS(2905),
    [anon_sym_CHECK] = ACTIONS(2905),
    [anon_sym_UNITCHECK] = ACTIONS(2905),
    [anon_sym_END] = ACTIONS(2905),
    [anon_sym_ADJUST] = ACTIONS(2905),
    [anon_sym___FILE__] = ACTIONS(2905),
    [anon_sym___LINE__] = ACTIONS(2905),
    [anon_sym___PACKAGE__] = ACTIONS(2905),
    [anon_sym___SUB__] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_fork] = ACTIONS(2905),
    [anon_sym_getppid] = ACTIONS(2905),
    [anon_sym_time] = ACTIONS(2905),
    [anon_sym_times] = ACTIONS(2905),
    [anon_sym_wait] = ACTIONS(2905),
    [anon_sym_wantarray] = ACTIONS(2905),
    [anon_sym_abs] = ACTIONS(2905),
    [anon_sym_alarm] = ACTIONS(2905),
    [anon_sym_chop] = ACTIONS(2905),
    [anon_sym_chdir] = ACTIONS(2905),
    [anon_sym_close] = ACTIONS(2905),
    [anon_sym_closedir] = ACTIONS(2905),
    [anon_sym_caller] = ACTIONS(2905),
    [anon_sym_chomp] = ACTIONS(2905),
    [anon_sym_chr] = ACTIONS(2905),
    [anon_sym_cos] = ACTIONS(2905),
    [anon_sym_chroot] = ACTIONS(2905),
    [anon_sym_defined] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_dbmclose] = ACTIONS(2905),
    [anon_sym_exists] = ACTIONS(2905),
    [anon_sym_exit] = ACTIONS(2905),
    [anon_sym_eof] = ACTIONS(2905),
    [anon_sym_exp] = ACTIONS(2905),
    [anon_sym_each] = ACTIONS(2905),
    [anon_sym_fc] = ACTIONS(2905),
    [anon_sym_fileno] = ACTIONS(2905),
    [anon_sym_gmtime] = ACTIONS(2905),
    [anon_sym_getc] = ACTIONS(2905),
    [anon_sym_getpgrp] = ACTIONS(2905),
    [anon_sym_getprotobyname] = ACTIONS(2905),
    [anon_sym_getpwname] = ACTIONS(2905),
    [anon_sym_getpwuid] = ACTIONS(2905),
    [anon_sym_getpeername] = ACTIONS(2905),
    [anon_sym_getnetbyname] = ACTIONS(2905),
    [anon_sym_getsockname] = ACTIONS(2905),
    [anon_sym_getgrnam] = ACTIONS(2905),
    [anon_sym_getgrgid] = ACTIONS(2905),
    [anon_sym_hex] = ACTIONS(2905),
    [anon_sym_int] = ACTIONS(2905),
    [anon_sym_keys] = ACTIONS(2905),
    [anon_sym_lc] = ACTIONS(2905),
    [anon_sym_lcfirst] = ACTIONS(2905),
    [anon_sym_length] = ACTIONS(2905),
    [anon_sym_localtime] = ACTIONS(2905),
    [anon_sym_log] = ACTIONS(2905),
    [anon_sym_lock] = ACTIONS(2905),
    [anon_sym_lstat] = ACTIONS(2905),
    [anon_sym_oct] = ACTIONS(2905),
    [anon_sym_ord] = ACTIONS(2905),
    [anon_sym_prototype] = ACTIONS(2905),
    [anon_sym_pop] = ACTIONS(2905),
    [anon_sym_pos] = ACTIONS(2905),
    [anon_sym_quotemeta] = ACTIONS(2905),
    [anon_sym_reset] = ACTIONS(2905),
    [anon_sym_rand] = ACTIONS(2905),
    [anon_sym_rmdir] = ACTIONS(2905),
    [anon_sym_readdir] = ACTIONS(2905),
    [anon_sym_readline] = ACTIONS(2905),
    [anon_sym_readpipe] = ACTIONS(2905),
    [anon_sym_rewinddir] = ACTIONS(2905),
    [anon_sym_readlink] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2905),
    [anon_sym_scalar] = ACTIONS(2905),
    [anon_sym_shift] = ACTIONS(2905),
    [anon_sym_sin] = ACTIONS(2905),
    [anon_sym_sleep] = ACTIONS(2905),
    [anon_sym_sqrt] = ACTIONS(2905),
    [anon_sym_srand] = ACTIONS(2905),
    [anon_sym_stat] = ACTIONS(2905),
    [anon_sym_study] = ACTIONS(2905),
    [anon_sym_tell] = ACTIONS(2905),
    [anon_sym_telldir] = ACTIONS(2905),
    [anon_sym_tied] = ACTIONS(2905),
    [anon_sym_uc] = ACTIONS(2905),
    [anon_sym_ucfirst] = ACTIONS(2905),
    [anon_sym_untie] = ACTIONS(2905),
    [anon_sym_umask] = ACTIONS(2905),
    [anon_sym_values] = ACTIONS(2905),
    [anon_sym_write] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2905),
    [anon_sym___END__] = ACTIONS(2905),
    [anon_sym_q] = ACTIONS(2905),
    [anon_sym_qq] = ACTIONS(2905),
    [anon_sym_qw] = ACTIONS(2905),
    [anon_sym_qx] = ACTIONS(2905),
    [anon_sym_qr] = ACTIONS(2905),
    [anon_sym_m] = ACTIONS(2905),
    [anon_sym_s] = ACTIONS(2905),
    [anon_sym_tr] = ACTIONS(2905),
    [anon_sym_y] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_unless] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_until] = ACTIONS(2905),
    [aux_sym__bareword_token1] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym__apostrophe] = ACTIONS(2907),
    [sym__double_quote] = ACTIONS(2907),
    [sym__backtick] = ACTIONS(2907),
    [sym__search_slash] = ACTIONS(2907),
    [sym__PERLY_HEREDOC] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1130] = {
    [sym_heredoc_content] = STATE(1130),
    [sym__identifier] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_sub] = ACTIONS(2897),
    [anon_sym_method] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_my] = ACTIONS(2897),
    [anon_sym_state] = ACTIONS(2897),
    [anon_sym_our] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_elsif] = ACTIONS(2897),
    [anon_sym_and] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_eq] = ACTIONS(2897),
    [anon_sym_ne] = ACTIONS(2897),
    [anon_sym_cmp] = ACTIONS(2897),
    [anon_sym_lt] = ACTIONS(2897),
    [anon_sym_le] = ACTIONS(2897),
    [anon_sym_ge] = ACTIONS(2897),
    [anon_sym_gt] = ACTIONS(2897),
    [anon_sym_isa] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_BSLASH] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_eval] = ACTIONS(2897),
    [anon_sym_field] = ACTIONS(2897),
    [anon_sym_local] = ACTIONS(2897),
    [anon_sym_require] = ACTIONS(2897),
    [anon_sym_map] = ACTIONS(2897),
    [anon_sym_grep] = ACTIONS(2897),
    [anon_sym_sort] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_undef] = ACTIONS(2897),
    [anon_sym_PERCENT2] = ACTIONS(2897),
    [anon_sym_DOLLAR_POUND] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_no] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2897),
    [anon_sym_last] = ACTIONS(2897),
    [anon_sym_next] = ACTIONS(2897),
    [anon_sym_redo] = ACTIONS(2897),
    [anon_sym_BEGIN] = ACTIONS(2897),
    [anon_sym_INIT] = ACTIONS(2897),
    [anon_sym_CHECK] = ACTIONS(2897),
    [anon_sym_UNITCHECK] = ACTIONS(2897),
    [anon_sym_END] = ACTIONS(2897),
    [anon_sym_ADJUST] = ACTIONS(2897),
    [anon_sym___FILE__] = ACTIONS(2897),
    [anon_sym___LINE__] = ACTIONS(2897),
    [anon_sym___PACKAGE__] = ACTIONS(2897),
    [anon_sym___SUB__] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_fork] = ACTIONS(2897),
    [anon_sym_getppid] = ACTIONS(2897),
    [anon_sym_time] = ACTIONS(2897),
    [anon_sym_times] = ACTIONS(2897),
    [anon_sym_wait] = ACTIONS(2897),
    [anon_sym_wantarray] = ACTIONS(2897),
    [anon_sym_abs] = ACTIONS(2897),
    [anon_sym_alarm] = ACTIONS(2897),
    [anon_sym_chop] = ACTIONS(2897),
    [anon_sym_chdir] = ACTIONS(2897),
    [anon_sym_close] = ACTIONS(2897),
    [anon_sym_closedir] = ACTIONS(2897),
    [anon_sym_caller] = ACTIONS(2897),
    [anon_sym_chomp] = ACTIONS(2897),
    [anon_sym_chr] = ACTIONS(2897),
    [anon_sym_cos] = ACTIONS(2897),
    [anon_sym_chroot] = ACTIONS(2897),
    [anon_sym_defined] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_dbmclose] = ACTIONS(2897),
    [anon_sym_exists] = ACTIONS(2897),
    [anon_sym_exit] = ACTIONS(2897),
    [anon_sym_eof] = ACTIONS(2897),
    [anon_sym_exp] = ACTIONS(2897),
    [anon_sym_each] = ACTIONS(2897),
    [anon_sym_fc] = ACTIONS(2897),
    [anon_sym_fileno] = ACTIONS(2897),
    [anon_sym_gmtime] = ACTIONS(2897),
    [anon_sym_getc] = ACTIONS(2897),
    [anon_sym_getpgrp] = ACTIONS(2897),
    [anon_sym_getprotobyname] = ACTIONS(2897),
    [anon_sym_getpwname] = ACTIONS(2897),
    [anon_sym_getpwuid] = ACTIONS(2897),
    [anon_sym_getpeername] = ACTIONS(2897),
    [anon_sym_getnetbyname] = ACTIONS(2897),
    [anon_sym_getsockname] = ACTIONS(2897),
    [anon_sym_getgrnam] = ACTIONS(2897),
    [anon_sym_getgrgid] = ACTIONS(2897),
    [anon_sym_hex] = ACTIONS(2897),
    [anon_sym_int] = ACTIONS(2897),
    [anon_sym_keys] = ACTIONS(2897),
    [anon_sym_lc] = ACTIONS(2897),
    [anon_sym_lcfirst] = ACTIONS(2897),
    [anon_sym_length] = ACTIONS(2897),
    [anon_sym_localtime] = ACTIONS(2897),
    [anon_sym_log] = ACTIONS(2897),
    [anon_sym_lock] = ACTIONS(2897),
    [anon_sym_lstat] = ACTIONS(2897),
    [anon_sym_oct] = ACTIONS(2897),
    [anon_sym_ord] = ACTIONS(2897),
    [anon_sym_prototype] = ACTIONS(2897),
    [anon_sym_pop] = ACTIONS(2897),
    [anon_sym_pos] = ACTIONS(2897),
    [anon_sym_quotemeta] = ACTIONS(2897),
    [anon_sym_reset] = ACTIONS(2897),
    [anon_sym_rand] = ACTIONS(2897),
    [anon_sym_rmdir] = ACTIONS(2897),
    [anon_sym_readdir] = ACTIONS(2897),
    [anon_sym_readline] = ACTIONS(2897),
    [anon_sym_readpipe] = ACTIONS(2897),
    [anon_sym_rewinddir] = ACTIONS(2897),
    [anon_sym_readlink] = ACTIONS(2897),
    [anon_sym_ref] = ACTIONS(2897),
    [anon_sym_scalar] = ACTIONS(2897),
    [anon_sym_shift] = ACTIONS(2897),
    [anon_sym_sin] = ACTIONS(2897),
    [anon_sym_sleep] = ACTIONS(2897),
    [anon_sym_sqrt] = ACTIONS(2897),
    [anon_sym_srand] = ACTIONS(2897),
    [anon_sym_stat] = ACTIONS(2897),
    [anon_sym_study] = ACTIONS(2897),
    [anon_sym_tell] = ACTIONS(2897),
    [anon_sym_telldir] = ACTIONS(2897),
    [anon_sym_tied] = ACTIONS(2897),
    [anon_sym_uc] = ACTIONS(2897),
    [anon_sym_ucfirst] = ACTIONS(2897),
    [anon_sym_untie] = ACTIONS(2897),
    [anon_sym_umask] = ACTIONS(2897),
    [anon_sym_values] = ACTIONS(2897),
    [anon_sym_write] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym___DATA__] = ACTIONS(2897),
    [anon_sym___END__] = ACTIONS(2897),
    [anon_sym_q] = ACTIONS(2897),
    [anon_sym_qq] = ACTIONS(2897),
    [anon_sym_qw] = ACTIONS(2897),
    [anon_sym_qx] = ACTIONS(2897),
    [anon_sym_qr] = ACTIONS(2897),
    [anon_sym_m] = ACTIONS(2897),
    [anon_sym_s] = ACTIONS(2897),
    [anon_sym_tr] = ACTIONS(2897),
    [anon_sym_y] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_unless] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_until] = ACTIONS(2897),
    [aux_sym__bareword_token1] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym__apostrophe] = ACTIONS(2899),
    [sym__double_quote] = ACTIONS(2899),
    [sym__backtick] = ACTIONS(2899),
    [sym__search_slash] = ACTIONS(2899),
    [sym__PERLY_HEREDOC] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1131] = {
    [sym__decl_variable_list] = STATE(1218),
    [sym__declare_scalar] = STATE(1197),
    [sym__declare_array] = STATE(1197),
    [sym__declare_hash] = STATE(1197),
    [sym_heredoc_content] = STATE(1131),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DOLLAR] = ACTIONS(3396),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_AT] = ACTIONS(3398),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_PERCENT2] = ACTIONS(3400),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1132] = {
    [sym_attribute] = STATE(1172),
    [sym_attribute_name] = STATE(1141),
    [sym_heredoc_content] = STATE(1132),
    [aux_sym_attrlist_repeat1] = STATE(1132),
    [sym__identifier] = ACTIONS(3402),
    [anon_sym_COLON] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_and] = ACTIONS(3410),
    [anon_sym_or] = ACTIONS(3410),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_foreach] = ACTIONS(3410),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3410),
    [anon_sym___END__] = ACTIONS(3410),
    [anon_sym_EOT] = ACTIONS(3408),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_unless] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_until] = ACTIONS(3410),
    [aux_sym__bareword_token1] = ACTIONS(3402),
    [sym__PERLY_SEMICOLON] = ACTIONS(3408),
    [sym__ctrl_z_hack] = ACTIONS(3408),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1133] = {
    [sym_attribute] = STATE(1172),
    [sym_attribute_name] = STATE(1141),
    [sym_heredoc_content] = STATE(1133),
    [aux_sym_attrlist_repeat1] = STATE(1134),
    [sym__identifier] = ACTIONS(3412),
    [anon_sym_COLON] = ACTIONS(3414),
    [anon_sym_SEMI] = ACTIONS(3416),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3416),
    [anon_sym_and] = ACTIONS(3418),
    [anon_sym_or] = ACTIONS(3418),
    [anon_sym_DASH_GT] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(3418),
    [anon_sym_GT] = ACTIONS(3418),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3416),
    [anon_sym_PLUS_EQ] = ACTIONS(3416),
    [anon_sym_DASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_EQ] = ACTIONS(3416),
    [anon_sym_STAR_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_PERCENT_EQ] = ACTIONS(3416),
    [anon_sym_x_EQ] = ACTIONS(3416),
    [anon_sym_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_CARET_EQ] = ACTIONS(3416),
    [anon_sym_LT_LT_EQ] = ACTIONS(3416),
    [anon_sym_GT_GT_EQ] = ACTIONS(3416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_DOT] = ACTIONS(3418),
    [anon_sym_STAR_STAR] = ACTIONS(3418),
    [anon_sym_PIPE_PIPE] = ACTIONS(3418),
    [anon_sym_SLASH_SLASH] = ACTIONS(3418),
    [anon_sym_AMP_AMP] = ACTIONS(3418),
    [anon_sym_PIPE] = ACTIONS(3418),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_GT_GT2] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_DOT] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3418),
    [anon_sym_SLASH] = ACTIONS(3418),
    [anon_sym_x] = ACTIONS(3418),
    [anon_sym_EQ_TILDE] = ACTIONS(3416),
    [anon_sym_BANG_TILDE] = ACTIONS(3416),
    [anon_sym_EQ_EQ] = ACTIONS(3416),
    [anon_sym_BANG_EQ] = ACTIONS(3416),
    [anon_sym_eq] = ACTIONS(3418),
    [anon_sym_ne] = ACTIONS(3418),
    [anon_sym_LT_EQ_GT] = ACTIONS(3416),
    [anon_sym_cmp] = ACTIONS(3418),
    [anon_sym_TILDE_TILDE] = ACTIONS(3416),
    [anon_sym_LT_EQ] = ACTIONS(3418),
    [anon_sym_GT_EQ] = ACTIONS(3416),
    [anon_sym_lt] = ACTIONS(3418),
    [anon_sym_le] = ACTIONS(3418),
    [anon_sym_ge] = ACTIONS(3418),
    [anon_sym_gt] = ACTIONS(3418),
    [anon_sym_isa] = ACTIONS(3418),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3416),
    [anon_sym_for] = ACTIONS(3418),
    [anon_sym_foreach] = ACTIONS(3418),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3418),
    [anon_sym___END__] = ACTIONS(3418),
    [anon_sym_EOT] = ACTIONS(3416),
    [anon_sym_if] = ACTIONS(3418),
    [anon_sym_unless] = ACTIONS(3418),
    [anon_sym_while] = ACTIONS(3418),
    [anon_sym_until] = ACTIONS(3418),
    [aux_sym__bareword_token1] = ACTIONS(3412),
    [sym__PERLY_SEMICOLON] = ACTIONS(3416),
    [sym__ctrl_z_hack] = ACTIONS(3416),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1134] = {
    [sym_attribute] = STATE(1172),
    [sym_attribute_name] = STATE(1141),
    [sym_heredoc_content] = STATE(1134),
    [aux_sym_attrlist_repeat1] = STATE(1132),
    [sym__identifier] = ACTIONS(3412),
    [anon_sym_COLON] = ACTIONS(3414),
    [anon_sym_SEMI] = ACTIONS(3420),
    [anon_sym_COMMA] = ACTIONS(3420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3420),
    [anon_sym_and] = ACTIONS(3422),
    [anon_sym_or] = ACTIONS(3422),
    [anon_sym_DASH_GT] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3422),
    [anon_sym_GT] = ACTIONS(3422),
    [anon_sym_LT_LT] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3422),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_x_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_DOT] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3422),
    [anon_sym_PIPE_PIPE] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_AMP_AMP] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(3422),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_GT_GT2] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_DASH] = ACTIONS(3422),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_STAR] = ACTIONS(3422),
    [anon_sym_SLASH] = ACTIONS(3422),
    [anon_sym_x] = ACTIONS(3422),
    [anon_sym_EQ_TILDE] = ACTIONS(3420),
    [anon_sym_BANG_TILDE] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3420),
    [anon_sym_BANG_EQ] = ACTIONS(3420),
    [anon_sym_eq] = ACTIONS(3422),
    [anon_sym_ne] = ACTIONS(3422),
    [anon_sym_LT_EQ_GT] = ACTIONS(3420),
    [anon_sym_cmp] = ACTIONS(3422),
    [anon_sym_TILDE_TILDE] = ACTIONS(3420),
    [anon_sym_LT_EQ] = ACTIONS(3422),
    [anon_sym_GT_EQ] = ACTIONS(3420),
    [anon_sym_lt] = ACTIONS(3422),
    [anon_sym_le] = ACTIONS(3422),
    [anon_sym_ge] = ACTIONS(3422),
    [anon_sym_gt] = ACTIONS(3422),
    [anon_sym_isa] = ACTIONS(3422),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_EQ_GT] = ACTIONS(3420),
    [anon_sym_for] = ACTIONS(3422),
    [anon_sym_foreach] = ACTIONS(3422),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3422),
    [anon_sym___END__] = ACTIONS(3422),
    [anon_sym_EOT] = ACTIONS(3420),
    [anon_sym_if] = ACTIONS(3422),
    [anon_sym_unless] = ACTIONS(3422),
    [anon_sym_while] = ACTIONS(3422),
    [anon_sym_until] = ACTIONS(3422),
    [aux_sym__bareword_token1] = ACTIONS(3412),
    [sym__PERLY_SEMICOLON] = ACTIONS(3420),
    [sym__ctrl_z_hack] = ACTIONS(3420),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1135] = {
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1335),
    [sym_heredoc_content] = STATE(1135),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_COLON] = ACTIONS(3426),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym_prototype_or_signature] = ACTIONS(3428),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1136] = {
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1238),
    [sym_heredoc_content] = STATE(1136),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_COLON] = ACTIONS(3430),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym_prototype_or_signature] = ACTIONS(3432),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1137] = {
    [sym_attrlist] = STATE(1361),
    [sym_attribute] = STATE(1133),
    [sym_attribute_name] = STATE(1141),
    [sym_heredoc_content] = STATE(1137),
    [sym__identifier] = ACTIONS(3412),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_COMMA] = ACTIONS(3434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3434),
    [anon_sym_and] = ACTIONS(3436),
    [anon_sym_or] = ACTIONS(3436),
    [anon_sym_DASH_GT] = ACTIONS(3434),
    [anon_sym_PERCENT] = ACTIONS(3436),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_LT_LT] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3434),
    [anon_sym_DASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_EQ] = ACTIONS(3434),
    [anon_sym_STAR_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_PERCENT_EQ] = ACTIONS(3434),
    [anon_sym_x_EQ] = ACTIONS(3434),
    [anon_sym_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_CARET_EQ] = ACTIONS(3434),
    [anon_sym_LT_LT_EQ] = ACTIONS(3434),
    [anon_sym_GT_GT_EQ] = ACTIONS(3434),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_DOT] = ACTIONS(3436),
    [anon_sym_STAR_STAR] = ACTIONS(3436),
    [anon_sym_PIPE_PIPE] = ACTIONS(3436),
    [anon_sym_SLASH_SLASH] = ACTIONS(3436),
    [anon_sym_AMP_AMP] = ACTIONS(3436),
    [anon_sym_PIPE] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_GT_GT2] = ACTIONS(3436),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_DOT] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3436),
    [anon_sym_SLASH] = ACTIONS(3436),
    [anon_sym_x] = ACTIONS(3436),
    [anon_sym_EQ_TILDE] = ACTIONS(3434),
    [anon_sym_BANG_TILDE] = ACTIONS(3434),
    [anon_sym_EQ_EQ] = ACTIONS(3434),
    [anon_sym_BANG_EQ] = ACTIONS(3434),
    [anon_sym_eq] = ACTIONS(3436),
    [anon_sym_ne] = ACTIONS(3436),
    [anon_sym_LT_EQ_GT] = ACTIONS(3434),
    [anon_sym_cmp] = ACTIONS(3436),
    [anon_sym_TILDE_TILDE] = ACTIONS(3434),
    [anon_sym_LT_EQ] = ACTIONS(3436),
    [anon_sym_GT_EQ] = ACTIONS(3434),
    [anon_sym_lt] = ACTIONS(3436),
    [anon_sym_le] = ACTIONS(3436),
    [anon_sym_ge] = ACTIONS(3436),
    [anon_sym_gt] = ACTIONS(3436),
    [anon_sym_isa] = ACTIONS(3436),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_QMARK] = ACTIONS(3434),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_for] = ACTIONS(3436),
    [anon_sym_foreach] = ACTIONS(3436),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3436),
    [anon_sym___END__] = ACTIONS(3436),
    [anon_sym_EOT] = ACTIONS(3434),
    [anon_sym_if] = ACTIONS(3436),
    [anon_sym_unless] = ACTIONS(3436),
    [anon_sym_while] = ACTIONS(3436),
    [anon_sym_until] = ACTIONS(3436),
    [aux_sym__bareword_token1] = ACTIONS(3412),
    [sym__PERLY_SEMICOLON] = ACTIONS(3434),
    [sym__ctrl_z_hack] = ACTIONS(3434),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1138] = {
    [sym_attrlist] = STATE(1353),
    [sym_attribute] = STATE(1133),
    [sym_attribute_name] = STATE(1141),
    [sym_heredoc_content] = STATE(1138),
    [sym__identifier] = ACTIONS(3412),
    [anon_sym_SEMI] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3438),
    [anon_sym_PLUS_EQ] = ACTIONS(3438),
    [anon_sym_DASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_EQ] = ACTIONS(3438),
    [anon_sym_STAR_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_PERCENT_EQ] = ACTIONS(3438),
    [anon_sym_x_EQ] = ACTIONS(3438),
    [anon_sym_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_CARET_EQ] = ACTIONS(3438),
    [anon_sym_LT_LT_EQ] = ACTIONS(3438),
    [anon_sym_GT_GT_EQ] = ACTIONS(3438),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3440),
    [anon_sym_GT_GT2] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_x] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3438),
    [anon_sym_BANG_TILDE] = ACTIONS(3438),
    [anon_sym_EQ_EQ] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_eq] = ACTIONS(3440),
    [anon_sym_ne] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3438),
    [anon_sym_cmp] = ACTIONS(3440),
    [anon_sym_TILDE_TILDE] = ACTIONS(3438),
    [anon_sym_LT_EQ] = ACTIONS(3440),
    [anon_sym_GT_EQ] = ACTIONS(3438),
    [anon_sym_lt] = ACTIONS(3440),
    [anon_sym_le] = ACTIONS(3440),
    [anon_sym_ge] = ACTIONS(3440),
    [anon_sym_gt] = ACTIONS(3440),
    [anon_sym_isa] = ACTIONS(3440),
    [anon_sym_PLUS_PLUS] = ACTIONS(3438),
    [anon_sym_DASH_DASH] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3438),
    [anon_sym_for] = ACTIONS(3440),
    [anon_sym_foreach] = ACTIONS(3440),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3440),
    [anon_sym___END__] = ACTIONS(3440),
    [anon_sym_EOT] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3440),
    [anon_sym_while] = ACTIONS(3440),
    [anon_sym_until] = ACTIONS(3440),
    [aux_sym__bareword_token1] = ACTIONS(3412),
    [sym__PERLY_SEMICOLON] = ACTIONS(3438),
    [sym__ctrl_z_hack] = ACTIONS(3438),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1139] = {
    [sym_heredoc_content] = STATE(1139),
    [sym__identifier] = ACTIONS(3442),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3444),
    [anon_sym_and] = ACTIONS(3442),
    [anon_sym_or] = ACTIONS(3442),
    [anon_sym_DASH_GT] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3444),
    [anon_sym_PLUS_EQ] = ACTIONS(3444),
    [anon_sym_DASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_EQ] = ACTIONS(3444),
    [anon_sym_STAR_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_PERCENT_EQ] = ACTIONS(3444),
    [anon_sym_x_EQ] = ACTIONS(3444),
    [anon_sym_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_CARET_EQ] = ACTIONS(3444),
    [anon_sym_LT_LT_EQ] = ACTIONS(3444),
    [anon_sym_GT_GT_EQ] = ACTIONS(3444),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_SLASH_SLASH] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_GT_GT2] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_x] = ACTIONS(3442),
    [anon_sym_EQ_TILDE] = ACTIONS(3444),
    [anon_sym_BANG_TILDE] = ACTIONS(3444),
    [anon_sym_EQ_EQ] = ACTIONS(3444),
    [anon_sym_BANG_EQ] = ACTIONS(3444),
    [anon_sym_eq] = ACTIONS(3442),
    [anon_sym_ne] = ACTIONS(3442),
    [anon_sym_LT_EQ_GT] = ACTIONS(3444),
    [anon_sym_cmp] = ACTIONS(3442),
    [anon_sym_TILDE_TILDE] = ACTIONS(3444),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3444),
    [anon_sym_lt] = ACTIONS(3442),
    [anon_sym_le] = ACTIONS(3442),
    [anon_sym_ge] = ACTIONS(3442),
    [anon_sym_gt] = ACTIONS(3442),
    [anon_sym_isa] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_EQ_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_foreach] = ACTIONS(3442),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3442),
    [anon_sym___END__] = ACTIONS(3442),
    [anon_sym_EOT] = ACTIONS(3444),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_unless] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_until] = ACTIONS(3442),
    [aux_sym__bareword_token1] = ACTIONS(3442),
    [sym__PERLY_SEMICOLON] = ACTIONS(3444),
    [sym__ctrl_z_hack] = ACTIONS(3444),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(3444),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1140] = {
    [sym_heredoc_content] = STATE(1140),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_COLON] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_DASH_GT] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2911),
    [anon_sym_DASH_EQ] = ACTIONS(2911),
    [anon_sym_DOT_EQ] = ACTIONS(2911),
    [anon_sym_STAR_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_PERCENT_EQ] = ACTIONS(2911),
    [anon_sym_x_EQ] = ACTIONS(2911),
    [anon_sym_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_CARET_EQ] = ACTIONS(2911),
    [anon_sym_LT_LT_EQ] = ACTIONS(2911),
    [anon_sym_GT_GT_EQ] = ACTIONS(2911),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_GT_GT2] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_x] = ACTIONS(2909),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2911),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_eq] = ACTIONS(2911),
    [anon_sym_ne] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_cmp] = ACTIONS(2911),
    [anon_sym_TILDE_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_lt] = ACTIONS(2911),
    [anon_sym_le] = ACTIONS(2911),
    [anon_sym_ge] = ACTIONS(2911),
    [anon_sym_gt] = ACTIONS(2911),
    [anon_sym_isa] = ACTIONS(2911),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_EQ_GT] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_foreach] = ACTIONS(2911),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2911),
    [anon_sym___END__] = ACTIONS(2911),
    [anon_sym_EOT] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_unless] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_until] = ACTIONS(2911),
    [sym__PERLY_SEMICOLON] = ACTIONS(2911),
    [sym__ctrl_z_hack] = ACTIONS(2911),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1141] = {
    [sym_heredoc_content] = STATE(1141),
    [sym__identifier] = ACTIONS(3446),
    [anon_sym_COLON] = ACTIONS(3446),
    [anon_sym_SEMI] = ACTIONS(3448),
    [anon_sym_COMMA] = ACTIONS(3448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3448),
    [anon_sym_and] = ACTIONS(3446),
    [anon_sym_or] = ACTIONS(3446),
    [anon_sym_DASH_GT] = ACTIONS(3448),
    [anon_sym_PERCENT] = ACTIONS(3446),
    [anon_sym_LT] = ACTIONS(3446),
    [anon_sym_GT] = ACTIONS(3446),
    [anon_sym_LT_LT] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(3446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_x_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_DOT] = ACTIONS(3446),
    [anon_sym_STAR_STAR] = ACTIONS(3446),
    [anon_sym_PIPE_PIPE] = ACTIONS(3446),
    [anon_sym_SLASH_SLASH] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_PIPE] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_GT_GT2] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3446),
    [anon_sym_DOT] = ACTIONS(3446),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_SLASH] = ACTIONS(3446),
    [anon_sym_x] = ACTIONS(3446),
    [anon_sym_EQ_TILDE] = ACTIONS(3448),
    [anon_sym_BANG_TILDE] = ACTIONS(3448),
    [anon_sym_EQ_EQ] = ACTIONS(3448),
    [anon_sym_BANG_EQ] = ACTIONS(3448),
    [anon_sym_eq] = ACTIONS(3446),
    [anon_sym_ne] = ACTIONS(3446),
    [anon_sym_LT_EQ_GT] = ACTIONS(3448),
    [anon_sym_cmp] = ACTIONS(3446),
    [anon_sym_TILDE_TILDE] = ACTIONS(3448),
    [anon_sym_LT_EQ] = ACTIONS(3446),
    [anon_sym_GT_EQ] = ACTIONS(3448),
    [anon_sym_lt] = ACTIONS(3446),
    [anon_sym_le] = ACTIONS(3446),
    [anon_sym_ge] = ACTIONS(3446),
    [anon_sym_gt] = ACTIONS(3446),
    [anon_sym_isa] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(3448),
    [anon_sym_EQ_GT] = ACTIONS(3448),
    [anon_sym_for] = ACTIONS(3446),
    [anon_sym_foreach] = ACTIONS(3446),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3446),
    [anon_sym___END__] = ACTIONS(3446),
    [anon_sym_EOT] = ACTIONS(3448),
    [anon_sym_if] = ACTIONS(3446),
    [anon_sym_unless] = ACTIONS(3446),
    [anon_sym_while] = ACTIONS(3446),
    [anon_sym_until] = ACTIONS(3446),
    [aux_sym__bareword_token1] = ACTIONS(3446),
    [sym__PERLY_SEMICOLON] = ACTIONS(3448),
    [sym__ctrl_z_hack] = ACTIONS(3448),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(3450),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1142] = {
    [sym_heredoc_content] = STATE(1142),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_COLON] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2903),
    [anon_sym_and] = ACTIONS(2903),
    [anon_sym_or] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_DASH_GT] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2901),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2903),
    [anon_sym_DOT_EQ] = ACTIONS(2903),
    [anon_sym_STAR_EQ] = ACTIONS(2903),
    [anon_sym_SLASH_EQ] = ACTIONS(2903),
    [anon_sym_PERCENT_EQ] = ACTIONS(2903),
    [anon_sym_x_EQ] = ACTIONS(2903),
    [anon_sym_AMP_EQ] = ACTIONS(2903),
    [anon_sym_PIPE_EQ] = ACTIONS(2903),
    [anon_sym_CARET_EQ] = ACTIONS(2903),
    [anon_sym_LT_LT_EQ] = ACTIONS(2903),
    [anon_sym_GT_GT_EQ] = ACTIONS(2903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2903),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2903),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_GT_GT2] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_x] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2903),
    [anon_sym_BANG_TILDE] = ACTIONS(2903),
    [anon_sym_EQ_EQ] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2903),
    [anon_sym_eq] = ACTIONS(2903),
    [anon_sym_ne] = ACTIONS(2903),
    [anon_sym_LT_EQ_GT] = ACTIONS(2903),
    [anon_sym_cmp] = ACTIONS(2903),
    [anon_sym_TILDE_TILDE] = ACTIONS(2903),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2903),
    [anon_sym_lt] = ACTIONS(2903),
    [anon_sym_le] = ACTIONS(2903),
    [anon_sym_ge] = ACTIONS(2903),
    [anon_sym_gt] = ACTIONS(2903),
    [anon_sym_isa] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_QMARK] = ACTIONS(2903),
    [anon_sym_EQ_GT] = ACTIONS(2903),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_foreach] = ACTIONS(2903),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2903),
    [anon_sym___END__] = ACTIONS(2903),
    [anon_sym_EOT] = ACTIONS(2903),
    [anon_sym_if] = ACTIONS(2903),
    [anon_sym_unless] = ACTIONS(2903),
    [anon_sym_while] = ACTIONS(2903),
    [anon_sym_until] = ACTIONS(2903),
    [sym__PERLY_SEMICOLON] = ACTIONS(2903),
    [sym__ctrl_z_hack] = ACTIONS(2903),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1143] = {
    [sym__PERLY_BRACE_OPEN] = STATE(244),
    [sym_block] = STATE(1298),
    [sym_heredoc_content] = STATE(1143),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1144] = {
    [sym_heredoc_content] = STATE(1144),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(313),
  },
  [1145] = {
    [sym_heredoc_content] = STATE(1145),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(321),
  },
  [1146] = {
    [sym_heredoc_content] = STATE(1146),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2925),
    [anon_sym_and] = ACTIONS(2925),
    [anon_sym_or] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_DASH_GT] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(2925),
    [anon_sym_DASH_EQ] = ACTIONS(2925),
    [anon_sym_DOT_EQ] = ACTIONS(2925),
    [anon_sym_STAR_EQ] = ACTIONS(2925),
    [anon_sym_SLASH_EQ] = ACTIONS(2925),
    [anon_sym_PERCENT_EQ] = ACTIONS(2925),
    [anon_sym_x_EQ] = ACTIONS(2925),
    [anon_sym_AMP_EQ] = ACTIONS(2925),
    [anon_sym_PIPE_EQ] = ACTIONS(2925),
    [anon_sym_CARET_EQ] = ACTIONS(2925),
    [anon_sym_LT_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_GT_EQ] = ACTIONS(2925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2925),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_GT_GT2] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_x] = ACTIONS(2923),
    [anon_sym_EQ_TILDE] = ACTIONS(2925),
    [anon_sym_BANG_TILDE] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_eq] = ACTIONS(2925),
    [anon_sym_ne] = ACTIONS(2925),
    [anon_sym_LT_EQ_GT] = ACTIONS(2925),
    [anon_sym_cmp] = ACTIONS(2925),
    [anon_sym_TILDE_TILDE] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2925),
    [anon_sym_lt] = ACTIONS(2925),
    [anon_sym_le] = ACTIONS(2925),
    [anon_sym_ge] = ACTIONS(2925),
    [anon_sym_gt] = ACTIONS(2925),
    [anon_sym_isa] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_foreach] = ACTIONS(2925),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2925),
    [anon_sym___END__] = ACTIONS(2925),
    [anon_sym_EOT] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_unless] = ACTIONS(2925),
    [anon_sym_while] = ACTIONS(2925),
    [anon_sym_until] = ACTIONS(2925),
    [sym__PERLY_SEMICOLON] = ACTIONS(2925),
    [sym__ctrl_z_hack] = ACTIONS(2925),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1147] = {
    [sym_heredoc_content] = STATE(1147),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_DASH_GT] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(2919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_DOT_EQ] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_x_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2919),
    [anon_sym_STAR_STAR] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_GT_GT2] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2919),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_x] = ACTIONS(2919),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_eq] = ACTIONS(2921),
    [anon_sym_ne] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_cmp] = ACTIONS(2921),
    [anon_sym_TILDE_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_lt] = ACTIONS(2921),
    [anon_sym_le] = ACTIONS(2921),
    [anon_sym_ge] = ACTIONS(2921),
    [anon_sym_gt] = ACTIONS(2921),
    [anon_sym_isa] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_foreach] = ACTIONS(2921),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2921),
    [anon_sym___END__] = ACTIONS(2921),
    [anon_sym_EOT] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_unless] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_until] = ACTIONS(2921),
    [sym__PERLY_SEMICOLON] = ACTIONS(2921),
    [sym__ctrl_z_hack] = ACTIONS(2921),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1148] = {
    [sym_heredoc_content] = STATE(1148),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3458),
    [anon_sym_and] = ACTIONS(3458),
    [anon_sym_or] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3458),
    [anon_sym_DASH_GT] = ACTIONS(3458),
    [anon_sym_PERCENT] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_LT_LT] = ACTIONS(3460),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3458),
    [anon_sym_PLUS_EQ] = ACTIONS(3458),
    [anon_sym_DASH_EQ] = ACTIONS(3458),
    [anon_sym_DOT_EQ] = ACTIONS(3458),
    [anon_sym_STAR_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_PERCENT_EQ] = ACTIONS(3458),
    [anon_sym_x_EQ] = ACTIONS(3458),
    [anon_sym_AMP_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_CARET_EQ] = ACTIONS(3458),
    [anon_sym_LT_LT_EQ] = ACTIONS(3458),
    [anon_sym_GT_GT_EQ] = ACTIONS(3458),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_DOT_DOT] = ACTIONS(3460),
    [anon_sym_STAR_STAR] = ACTIONS(3460),
    [anon_sym_PIPE_PIPE] = ACTIONS(3460),
    [anon_sym_SLASH_SLASH] = ACTIONS(3460),
    [anon_sym_AMP_AMP] = ACTIONS(3460),
    [anon_sym_PIPE] = ACTIONS(3460),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_GT_GT2] = ACTIONS(3460),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_DOT] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_SLASH] = ACTIONS(3460),
    [anon_sym_x] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3458),
    [anon_sym_BANG_TILDE] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3458),
    [anon_sym_BANG_EQ] = ACTIONS(3458),
    [anon_sym_eq] = ACTIONS(3458),
    [anon_sym_ne] = ACTIONS(3458),
    [anon_sym_LT_EQ_GT] = ACTIONS(3458),
    [anon_sym_cmp] = ACTIONS(3458),
    [anon_sym_TILDE_TILDE] = ACTIONS(3458),
    [anon_sym_LT_EQ] = ACTIONS(3460),
    [anon_sym_GT_EQ] = ACTIONS(3458),
    [anon_sym_lt] = ACTIONS(3458),
    [anon_sym_le] = ACTIONS(3458),
    [anon_sym_ge] = ACTIONS(3458),
    [anon_sym_gt] = ACTIONS(3458),
    [anon_sym_isa] = ACTIONS(3458),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3458),
    [anon_sym_EQ_GT] = ACTIONS(3458),
    [anon_sym_for] = ACTIONS(3460),
    [anon_sym_foreach] = ACTIONS(3458),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3458),
    [anon_sym___END__] = ACTIONS(3458),
    [anon_sym_EOT] = ACTIONS(3458),
    [anon_sym_if] = ACTIONS(3458),
    [anon_sym_unless] = ACTIONS(3458),
    [anon_sym_while] = ACTIONS(3458),
    [anon_sym_until] = ACTIONS(3458),
    [sym__PERLY_SEMICOLON] = ACTIONS(3458),
    [sym__ctrl_z_hack] = ACTIONS(3458),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1149] = {
    [sym_heredoc_content] = STATE(1149),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__apostrophe] = ACTIONS(3462),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(3464),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1150] = {
    [sym__decl_variable_list] = STATE(1421),
    [sym__declare_scalar] = STATE(1419),
    [sym__declare_array] = STATE(1419),
    [sym__declare_hash] = STATE(1419),
    [sym_heredoc_content] = STATE(1150),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DOLLAR] = ACTIONS(3396),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_AT] = ACTIONS(3398),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_PERCENT2] = ACTIONS(3400),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1151] = {
    [sym_heredoc_content] = STATE(1151),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__apostrophe] = ACTIONS(3466),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(3468),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1152] = {
    [sym_heredoc_content] = STATE(1152),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__apostrophe] = ACTIONS(3470),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(3472),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1153] = {
    [sym_heredoc_content] = STATE(1153),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(317),
  },
  [1154] = {
    [sym_heredoc_content] = STATE(1154),
    [anon_sym_LBRACE] = ACTIONS(3474),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3474),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3474),
    [anon_sym_and] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_LT] = ACTIONS(3476),
    [anon_sym_GT] = ACTIONS(3476),
    [anon_sym_LT_LT] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3476),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3474),
    [anon_sym_PLUS_EQ] = ACTIONS(3474),
    [anon_sym_DASH_EQ] = ACTIONS(3474),
    [anon_sym_DOT_EQ] = ACTIONS(3474),
    [anon_sym_STAR_EQ] = ACTIONS(3474),
    [anon_sym_SLASH_EQ] = ACTIONS(3474),
    [anon_sym_PERCENT_EQ] = ACTIONS(3474),
    [anon_sym_x_EQ] = ACTIONS(3474),
    [anon_sym_AMP_EQ] = ACTIONS(3474),
    [anon_sym_PIPE_EQ] = ACTIONS(3474),
    [anon_sym_CARET_EQ] = ACTIONS(3474),
    [anon_sym_LT_LT_EQ] = ACTIONS(3474),
    [anon_sym_GT_GT_EQ] = ACTIONS(3474),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3474),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3474),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3474),
    [anon_sym_DOT_DOT] = ACTIONS(3476),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_SLASH_SLASH] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_PIPE] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_GT_GT2] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_x] = ACTIONS(3476),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [anon_sym_EQ_EQ] = ACTIONS(3474),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_eq] = ACTIONS(3474),
    [anon_sym_ne] = ACTIONS(3474),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_cmp] = ACTIONS(3474),
    [anon_sym_TILDE_TILDE] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3476),
    [anon_sym_GT_EQ] = ACTIONS(3474),
    [anon_sym_lt] = ACTIONS(3474),
    [anon_sym_le] = ACTIONS(3474),
    [anon_sym_ge] = ACTIONS(3474),
    [anon_sym_gt] = ACTIONS(3474),
    [anon_sym_isa] = ACTIONS(3474),
    [anon_sym_PLUS_PLUS] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3474),
    [anon_sym_QMARK] = ACTIONS(3474),
    [anon_sym_EQ_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_foreach] = ACTIONS(3474),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3474),
    [anon_sym___END__] = ACTIONS(3474),
    [anon_sym_EOT] = ACTIONS(3474),
    [anon_sym_if] = ACTIONS(3474),
    [anon_sym_unless] = ACTIONS(3474),
    [anon_sym_while] = ACTIONS(3474),
    [anon_sym_until] = ACTIONS(3474),
    [sym__PERLY_SEMICOLON] = ACTIONS(3474),
    [sym__ctrl_z_hack] = ACTIONS(3474),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1155] = {
    [sym_heredoc_content] = STATE(1155),
    [anon_sym_LBRACE] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3478),
    [anon_sym_and] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3478),
    [anon_sym_PLUS_EQ] = ACTIONS(3478),
    [anon_sym_DASH_EQ] = ACTIONS(3478),
    [anon_sym_DOT_EQ] = ACTIONS(3478),
    [anon_sym_STAR_EQ] = ACTIONS(3478),
    [anon_sym_SLASH_EQ] = ACTIONS(3478),
    [anon_sym_PERCENT_EQ] = ACTIONS(3478),
    [anon_sym_x_EQ] = ACTIONS(3478),
    [anon_sym_AMP_EQ] = ACTIONS(3478),
    [anon_sym_PIPE_EQ] = ACTIONS(3478),
    [anon_sym_CARET_EQ] = ACTIONS(3478),
    [anon_sym_LT_LT_EQ] = ACTIONS(3478),
    [anon_sym_GT_GT_EQ] = ACTIONS(3478),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3478),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3478),
    [anon_sym_DOT_DOT] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_SLASH_SLASH] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_GT_GT2] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3480),
    [anon_sym_x] = ACTIONS(3480),
    [anon_sym_EQ_TILDE] = ACTIONS(3478),
    [anon_sym_BANG_TILDE] = ACTIONS(3478),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_eq] = ACTIONS(3478),
    [anon_sym_ne] = ACTIONS(3478),
    [anon_sym_LT_EQ_GT] = ACTIONS(3478),
    [anon_sym_cmp] = ACTIONS(3478),
    [anon_sym_TILDE_TILDE] = ACTIONS(3478),
    [anon_sym_LT_EQ] = ACTIONS(3480),
    [anon_sym_GT_EQ] = ACTIONS(3478),
    [anon_sym_lt] = ACTIONS(3478),
    [anon_sym_le] = ACTIONS(3478),
    [anon_sym_ge] = ACTIONS(3478),
    [anon_sym_gt] = ACTIONS(3478),
    [anon_sym_isa] = ACTIONS(3478),
    [anon_sym_PLUS_PLUS] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3478),
    [anon_sym_EQ_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_foreach] = ACTIONS(3478),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3478),
    [anon_sym___END__] = ACTIONS(3478),
    [anon_sym_EOT] = ACTIONS(3478),
    [anon_sym_if] = ACTIONS(3478),
    [anon_sym_unless] = ACTIONS(3478),
    [anon_sym_while] = ACTIONS(3478),
    [anon_sym_until] = ACTIONS(3478),
    [sym__PERLY_SEMICOLON] = ACTIONS(3478),
    [sym__ctrl_z_hack] = ACTIONS(3478),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1156] = {
    [sym_heredoc_content] = STATE(1156),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_DOT_EQ] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_x_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2893),
    [anon_sym_STAR_STAR] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_GT_GT2] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_x] = ACTIONS(2893),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_eq] = ACTIONS(2895),
    [anon_sym_ne] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_cmp] = ACTIONS(2895),
    [anon_sym_TILDE_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_lt] = ACTIONS(2895),
    [anon_sym_le] = ACTIONS(2895),
    [anon_sym_ge] = ACTIONS(2895),
    [anon_sym_gt] = ACTIONS(2895),
    [anon_sym_isa] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_foreach] = ACTIONS(2895),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2895),
    [anon_sym___END__] = ACTIONS(2895),
    [anon_sym_EOT] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_unless] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_until] = ACTIONS(2895),
    [sym__PERLY_SEMICOLON] = ACTIONS(2895),
    [sym__ctrl_z_hack] = ACTIONS(2895),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1157] = {
    [sym_heredoc_content] = STATE(1157),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_COMMA] = ACTIONS(2899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2899),
    [anon_sym_and] = ACTIONS(2899),
    [anon_sym_or] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_DASH_GT] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2899),
    [anon_sym_PLUS_EQ] = ACTIONS(2899),
    [anon_sym_DASH_EQ] = ACTIONS(2899),
    [anon_sym_DOT_EQ] = ACTIONS(2899),
    [anon_sym_STAR_EQ] = ACTIONS(2899),
    [anon_sym_SLASH_EQ] = ACTIONS(2899),
    [anon_sym_PERCENT_EQ] = ACTIONS(2899),
    [anon_sym_x_EQ] = ACTIONS(2899),
    [anon_sym_AMP_EQ] = ACTIONS(2899),
    [anon_sym_PIPE_EQ] = ACTIONS(2899),
    [anon_sym_CARET_EQ] = ACTIONS(2899),
    [anon_sym_LT_LT_EQ] = ACTIONS(2899),
    [anon_sym_GT_GT_EQ] = ACTIONS(2899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2899),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2899),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_GT_GT2] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_x] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2899),
    [anon_sym_BANG_TILDE] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2899),
    [anon_sym_BANG_EQ] = ACTIONS(2899),
    [anon_sym_eq] = ACTIONS(2899),
    [anon_sym_ne] = ACTIONS(2899),
    [anon_sym_LT_EQ_GT] = ACTIONS(2899),
    [anon_sym_cmp] = ACTIONS(2899),
    [anon_sym_TILDE_TILDE] = ACTIONS(2899),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2899),
    [anon_sym_lt] = ACTIONS(2899),
    [anon_sym_le] = ACTIONS(2899),
    [anon_sym_ge] = ACTIONS(2899),
    [anon_sym_gt] = ACTIONS(2899),
    [anon_sym_isa] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_QMARK] = ACTIONS(2899),
    [anon_sym_EQ_GT] = ACTIONS(2899),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_foreach] = ACTIONS(2899),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2899),
    [anon_sym___END__] = ACTIONS(2899),
    [anon_sym_EOT] = ACTIONS(2899),
    [anon_sym_if] = ACTIONS(2899),
    [anon_sym_unless] = ACTIONS(2899),
    [anon_sym_while] = ACTIONS(2899),
    [anon_sym_until] = ACTIONS(2899),
    [sym__PERLY_SEMICOLON] = ACTIONS(2899),
    [sym__ctrl_z_hack] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1158] = {
    [sym_heredoc_content] = STATE(1158),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(303),
  },
  [1159] = {
    [sym_heredoc_content] = STATE(1159),
    [sym__identifier] = ACTIONS(3410),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_and] = ACTIONS(3410),
    [anon_sym_or] = ACTIONS(3410),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_foreach] = ACTIONS(3410),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3410),
    [anon_sym___END__] = ACTIONS(3410),
    [anon_sym_EOT] = ACTIONS(3408),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_unless] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_until] = ACTIONS(3410),
    [aux_sym__bareword_token1] = ACTIONS(3410),
    [sym__PERLY_SEMICOLON] = ACTIONS(3408),
    [sym__ctrl_z_hack] = ACTIONS(3408),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1160] = {
    [sym_heredoc_content] = STATE(1160),
    [anon_sym_LBRACE] = ACTIONS(3482),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(3484),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_and] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(3486),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_EQ] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_x_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2936),
    [anon_sym_BANG_TILDE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_eq] = ACTIONS(2936),
    [anon_sym_ne] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_cmp] = ACTIONS(2936),
    [anon_sym_TILDE_TILDE] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_lt] = ACTIONS(2936),
    [anon_sym_le] = ACTIONS(2936),
    [anon_sym_ge] = ACTIONS(2936),
    [anon_sym_gt] = ACTIONS(2936),
    [anon_sym_isa] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_foreach] = ACTIONS(2936),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2936),
    [anon_sym___END__] = ACTIONS(2936),
    [anon_sym_EOT] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_unless] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_until] = ACTIONS(2936),
    [sym__PERLY_SEMICOLON] = ACTIONS(2936),
    [sym__ctrl_z_hack] = ACTIONS(2936),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1161] = {
    [sym_heredoc_content] = STATE(1161),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(305),
  },
  [1162] = {
    [sym_heredoc_content] = STATE(1162),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_DASH_GT] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2907),
    [anon_sym_PLUS_EQ] = ACTIONS(2907),
    [anon_sym_DASH_EQ] = ACTIONS(2907),
    [anon_sym_DOT_EQ] = ACTIONS(2907),
    [anon_sym_STAR_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_PERCENT_EQ] = ACTIONS(2907),
    [anon_sym_x_EQ] = ACTIONS(2907),
    [anon_sym_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_CARET_EQ] = ACTIONS(2907),
    [anon_sym_LT_LT_EQ] = ACTIONS(2907),
    [anon_sym_GT_GT_EQ] = ACTIONS(2907),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_STAR_STAR] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_GT_GT2] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_DOT] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_x] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2907),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_eq] = ACTIONS(2907),
    [anon_sym_ne] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_cmp] = ACTIONS(2907),
    [anon_sym_TILDE_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_lt] = ACTIONS(2907),
    [anon_sym_le] = ACTIONS(2907),
    [anon_sym_ge] = ACTIONS(2907),
    [anon_sym_gt] = ACTIONS(2907),
    [anon_sym_isa] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_EQ_GT] = ACTIONS(2907),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_foreach] = ACTIONS(2907),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2907),
    [anon_sym___END__] = ACTIONS(2907),
    [anon_sym_EOT] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [sym__PERLY_SEMICOLON] = ACTIONS(2907),
    [sym__ctrl_z_hack] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1163] = {
    [sym_heredoc_content] = STATE(1163),
    [anon_sym_LBRACE] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3488),
    [anon_sym_and] = ACTIONS(3488),
    [anon_sym_or] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_DASH_GT] = ACTIONS(3488),
    [anon_sym_PERCENT] = ACTIONS(3490),
    [anon_sym_LT] = ACTIONS(3490),
    [anon_sym_GT] = ACTIONS(3490),
    [anon_sym_LT_LT] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(3490),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3488),
    [anon_sym_PLUS_EQ] = ACTIONS(3488),
    [anon_sym_DASH_EQ] = ACTIONS(3488),
    [anon_sym_DOT_EQ] = ACTIONS(3488),
    [anon_sym_STAR_EQ] = ACTIONS(3488),
    [anon_sym_SLASH_EQ] = ACTIONS(3488),
    [anon_sym_PERCENT_EQ] = ACTIONS(3488),
    [anon_sym_x_EQ] = ACTIONS(3488),
    [anon_sym_AMP_EQ] = ACTIONS(3488),
    [anon_sym_PIPE_EQ] = ACTIONS(3488),
    [anon_sym_CARET_EQ] = ACTIONS(3488),
    [anon_sym_LT_LT_EQ] = ACTIONS(3488),
    [anon_sym_GT_GT_EQ] = ACTIONS(3488),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3488),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3488),
    [anon_sym_DOT_DOT] = ACTIONS(3490),
    [anon_sym_STAR_STAR] = ACTIONS(3490),
    [anon_sym_PIPE_PIPE] = ACTIONS(3490),
    [anon_sym_SLASH_SLASH] = ACTIONS(3490),
    [anon_sym_AMP_AMP] = ACTIONS(3490),
    [anon_sym_PIPE] = ACTIONS(3490),
    [anon_sym_AMP] = ACTIONS(3490),
    [anon_sym_GT_GT2] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3490),
    [anon_sym_DASH] = ACTIONS(3490),
    [anon_sym_DOT] = ACTIONS(3490),
    [anon_sym_STAR] = ACTIONS(3490),
    [anon_sym_SLASH] = ACTIONS(3490),
    [anon_sym_x] = ACTIONS(3490),
    [anon_sym_EQ_TILDE] = ACTIONS(3488),
    [anon_sym_BANG_TILDE] = ACTIONS(3488),
    [anon_sym_EQ_EQ] = ACTIONS(3488),
    [anon_sym_BANG_EQ] = ACTIONS(3488),
    [anon_sym_eq] = ACTIONS(3488),
    [anon_sym_ne] = ACTIONS(3488),
    [anon_sym_LT_EQ_GT] = ACTIONS(3488),
    [anon_sym_cmp] = ACTIONS(3488),
    [anon_sym_TILDE_TILDE] = ACTIONS(3488),
    [anon_sym_LT_EQ] = ACTIONS(3490),
    [anon_sym_GT_EQ] = ACTIONS(3488),
    [anon_sym_lt] = ACTIONS(3488),
    [anon_sym_le] = ACTIONS(3488),
    [anon_sym_ge] = ACTIONS(3488),
    [anon_sym_gt] = ACTIONS(3488),
    [anon_sym_isa] = ACTIONS(3488),
    [anon_sym_PLUS_PLUS] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_EQ_GT] = ACTIONS(3488),
    [anon_sym_for] = ACTIONS(3490),
    [anon_sym_foreach] = ACTIONS(3488),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3488),
    [anon_sym___END__] = ACTIONS(3488),
    [anon_sym_EOT] = ACTIONS(3488),
    [anon_sym_if] = ACTIONS(3488),
    [anon_sym_unless] = ACTIONS(3488),
    [anon_sym_while] = ACTIONS(3488),
    [anon_sym_until] = ACTIONS(3488),
    [sym__PERLY_SEMICOLON] = ACTIONS(3488),
    [sym__ctrl_z_hack] = ACTIONS(3488),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1164] = {
    [sym_heredoc_content] = STATE(1164),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(323),
  },
  [1165] = {
    [sym_heredoc_content] = STATE(1165),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3492),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3492),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3492),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3494),
    [anon_sym_GT] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3492),
    [anon_sym_PLUS_EQ] = ACTIONS(3492),
    [anon_sym_DASH_EQ] = ACTIONS(3492),
    [anon_sym_DOT_EQ] = ACTIONS(3492),
    [anon_sym_STAR_EQ] = ACTIONS(3492),
    [anon_sym_SLASH_EQ] = ACTIONS(3492),
    [anon_sym_PERCENT_EQ] = ACTIONS(3492),
    [anon_sym_x_EQ] = ACTIONS(3492),
    [anon_sym_AMP_EQ] = ACTIONS(3492),
    [anon_sym_PIPE_EQ] = ACTIONS(3492),
    [anon_sym_CARET_EQ] = ACTIONS(3492),
    [anon_sym_LT_LT_EQ] = ACTIONS(3492),
    [anon_sym_GT_GT_EQ] = ACTIONS(3492),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3492),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3492),
    [anon_sym_DOT_DOT] = ACTIONS(3494),
    [anon_sym_STAR_STAR] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_SLASH_SLASH] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_PIPE] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_GT_GT2] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_SLASH] = ACTIONS(3494),
    [anon_sym_x] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3492),
    [anon_sym_BANG_TILDE] = ACTIONS(3492),
    [anon_sym_EQ_EQ] = ACTIONS(3492),
    [anon_sym_BANG_EQ] = ACTIONS(3492),
    [anon_sym_eq] = ACTIONS(3492),
    [anon_sym_ne] = ACTIONS(3492),
    [anon_sym_LT_EQ_GT] = ACTIONS(3492),
    [anon_sym_cmp] = ACTIONS(3492),
    [anon_sym_TILDE_TILDE] = ACTIONS(3492),
    [anon_sym_LT_EQ] = ACTIONS(3494),
    [anon_sym_GT_EQ] = ACTIONS(3492),
    [anon_sym_lt] = ACTIONS(3492),
    [anon_sym_le] = ACTIONS(3492),
    [anon_sym_ge] = ACTIONS(3492),
    [anon_sym_gt] = ACTIONS(3492),
    [anon_sym_isa] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_QMARK] = ACTIONS(3492),
    [anon_sym_EQ_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_foreach] = ACTIONS(3492),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3492),
    [anon_sym___END__] = ACTIONS(3492),
    [anon_sym_EOT] = ACTIONS(3492),
    [anon_sym_if] = ACTIONS(3492),
    [anon_sym_unless] = ACTIONS(3492),
    [anon_sym_while] = ACTIONS(3492),
    [anon_sym_until] = ACTIONS(3492),
    [sym__PERLY_SEMICOLON] = ACTIONS(3492),
    [sym__ctrl_z_hack] = ACTIONS(3492),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1166] = {
    [sym_heredoc_content] = STATE(1166),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2887),
    [anon_sym_and] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_DASH_GT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2887),
    [anon_sym_PLUS_EQ] = ACTIONS(2887),
    [anon_sym_DASH_EQ] = ACTIONS(2887),
    [anon_sym_DOT_EQ] = ACTIONS(2887),
    [anon_sym_STAR_EQ] = ACTIONS(2887),
    [anon_sym_SLASH_EQ] = ACTIONS(2887),
    [anon_sym_PERCENT_EQ] = ACTIONS(2887),
    [anon_sym_x_EQ] = ACTIONS(2887),
    [anon_sym_AMP_EQ] = ACTIONS(2887),
    [anon_sym_PIPE_EQ] = ACTIONS(2887),
    [anon_sym_CARET_EQ] = ACTIONS(2887),
    [anon_sym_LT_LT_EQ] = ACTIONS(2887),
    [anon_sym_GT_GT_EQ] = ACTIONS(2887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2887),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2887),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_GT_GT2] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_x] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2887),
    [anon_sym_BANG_TILDE] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_eq] = ACTIONS(2887),
    [anon_sym_ne] = ACTIONS(2887),
    [anon_sym_LT_EQ_GT] = ACTIONS(2887),
    [anon_sym_cmp] = ACTIONS(2887),
    [anon_sym_TILDE_TILDE] = ACTIONS(2887),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2887),
    [anon_sym_lt] = ACTIONS(2887),
    [anon_sym_le] = ACTIONS(2887),
    [anon_sym_ge] = ACTIONS(2887),
    [anon_sym_gt] = ACTIONS(2887),
    [anon_sym_isa] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_EQ_GT] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_foreach] = ACTIONS(2887),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2887),
    [anon_sym___END__] = ACTIONS(2887),
    [anon_sym_EOT] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_unless] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_until] = ACTIONS(2887),
    [sym__PERLY_SEMICOLON] = ACTIONS(2887),
    [sym__ctrl_z_hack] = ACTIONS(2887),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1167] = {
    [sym_heredoc_content] = STATE(1167),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(315),
  },
  [1168] = {
    [sym_heredoc_content] = STATE(1168),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(301),
  },
  [1169] = {
    [sym_heredoc_content] = STATE(1169),
    [anon_sym_LBRACE] = ACTIONS(3496),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3496),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3496),
    [anon_sym_and] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3496),
    [anon_sym_LBRACK] = ACTIONS(3496),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_LT] = ACTIONS(3498),
    [anon_sym_GT] = ACTIONS(3498),
    [anon_sym_LT_LT] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3496),
    [anon_sym_PLUS_EQ] = ACTIONS(3496),
    [anon_sym_DASH_EQ] = ACTIONS(3496),
    [anon_sym_DOT_EQ] = ACTIONS(3496),
    [anon_sym_STAR_EQ] = ACTIONS(3496),
    [anon_sym_SLASH_EQ] = ACTIONS(3496),
    [anon_sym_PERCENT_EQ] = ACTIONS(3496),
    [anon_sym_x_EQ] = ACTIONS(3496),
    [anon_sym_AMP_EQ] = ACTIONS(3496),
    [anon_sym_PIPE_EQ] = ACTIONS(3496),
    [anon_sym_CARET_EQ] = ACTIONS(3496),
    [anon_sym_LT_LT_EQ] = ACTIONS(3496),
    [anon_sym_GT_GT_EQ] = ACTIONS(3496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3496),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3496),
    [anon_sym_DOT_DOT] = ACTIONS(3498),
    [anon_sym_STAR_STAR] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_SLASH_SLASH] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_PIPE] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_GT_GT2] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_SLASH] = ACTIONS(3498),
    [anon_sym_x] = ACTIONS(3498),
    [anon_sym_EQ_TILDE] = ACTIONS(3496),
    [anon_sym_BANG_TILDE] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3496),
    [anon_sym_BANG_EQ] = ACTIONS(3496),
    [anon_sym_eq] = ACTIONS(3496),
    [anon_sym_ne] = ACTIONS(3496),
    [anon_sym_LT_EQ_GT] = ACTIONS(3496),
    [anon_sym_cmp] = ACTIONS(3496),
    [anon_sym_TILDE_TILDE] = ACTIONS(3496),
    [anon_sym_LT_EQ] = ACTIONS(3498),
    [anon_sym_GT_EQ] = ACTIONS(3496),
    [anon_sym_lt] = ACTIONS(3496),
    [anon_sym_le] = ACTIONS(3496),
    [anon_sym_ge] = ACTIONS(3496),
    [anon_sym_gt] = ACTIONS(3496),
    [anon_sym_isa] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(3496),
    [anon_sym_QMARK] = ACTIONS(3496),
    [anon_sym_EQ_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_foreach] = ACTIONS(3496),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3496),
    [anon_sym___END__] = ACTIONS(3496),
    [anon_sym_EOT] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [sym__PERLY_SEMICOLON] = ACTIONS(3496),
    [sym__ctrl_z_hack] = ACTIONS(3496),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1170] = {
    [sym_heredoc_content] = STATE(1170),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(307),
  },
  [1171] = {
    [sym_heredoc_content] = STATE(1171),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(309),
  },
  [1172] = {
    [sym_heredoc_content] = STATE(1172),
    [sym__identifier] = ACTIONS(3500),
    [anon_sym_COLON] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3502),
    [anon_sym_and] = ACTIONS(3500),
    [anon_sym_or] = ACTIONS(3500),
    [anon_sym_DASH_GT] = ACTIONS(3502),
    [anon_sym_PERCENT] = ACTIONS(3500),
    [anon_sym_LT] = ACTIONS(3500),
    [anon_sym_GT] = ACTIONS(3500),
    [anon_sym_LT_LT] = ACTIONS(3500),
    [anon_sym_EQ] = ACTIONS(3500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3502),
    [anon_sym_PLUS_EQ] = ACTIONS(3502),
    [anon_sym_DASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_EQ] = ACTIONS(3502),
    [anon_sym_STAR_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_PERCENT_EQ] = ACTIONS(3502),
    [anon_sym_x_EQ] = ACTIONS(3502),
    [anon_sym_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_CARET_EQ] = ACTIONS(3502),
    [anon_sym_LT_LT_EQ] = ACTIONS(3502),
    [anon_sym_GT_GT_EQ] = ACTIONS(3502),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_DOT] = ACTIONS(3500),
    [anon_sym_STAR_STAR] = ACTIONS(3500),
    [anon_sym_PIPE_PIPE] = ACTIONS(3500),
    [anon_sym_SLASH_SLASH] = ACTIONS(3500),
    [anon_sym_AMP_AMP] = ACTIONS(3500),
    [anon_sym_PIPE] = ACTIONS(3500),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_GT_GT2] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_DOT] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3500),
    [anon_sym_SLASH] = ACTIONS(3500),
    [anon_sym_x] = ACTIONS(3500),
    [anon_sym_EQ_TILDE] = ACTIONS(3502),
    [anon_sym_BANG_TILDE] = ACTIONS(3502),
    [anon_sym_EQ_EQ] = ACTIONS(3502),
    [anon_sym_BANG_EQ] = ACTIONS(3502),
    [anon_sym_eq] = ACTIONS(3500),
    [anon_sym_ne] = ACTIONS(3500),
    [anon_sym_LT_EQ_GT] = ACTIONS(3502),
    [anon_sym_cmp] = ACTIONS(3500),
    [anon_sym_TILDE_TILDE] = ACTIONS(3502),
    [anon_sym_LT_EQ] = ACTIONS(3500),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [anon_sym_lt] = ACTIONS(3500),
    [anon_sym_le] = ACTIONS(3500),
    [anon_sym_ge] = ACTIONS(3500),
    [anon_sym_gt] = ACTIONS(3500),
    [anon_sym_isa] = ACTIONS(3500),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3502),
    [anon_sym_EQ_GT] = ACTIONS(3502),
    [anon_sym_for] = ACTIONS(3500),
    [anon_sym_foreach] = ACTIONS(3500),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3500),
    [anon_sym___END__] = ACTIONS(3500),
    [anon_sym_EOT] = ACTIONS(3502),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [aux_sym__bareword_token1] = ACTIONS(3500),
    [sym__PERLY_SEMICOLON] = ACTIONS(3502),
    [sym__ctrl_z_hack] = ACTIONS(3502),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1173] = {
    [sym_heredoc_content] = STATE(1173),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_LPAREN] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_DASH_GT] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_LT_LT] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_DOT_EQ] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_x_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_STAR_STAR] = ACTIONS(3506),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_SLASH_SLASH] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_GT_GT2] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_DASH] = ACTIONS(3506),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_STAR] = ACTIONS(3506),
    [anon_sym_SLASH] = ACTIONS(3506),
    [anon_sym_x] = ACTIONS(3506),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3504),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_eq] = ACTIONS(3504),
    [anon_sym_ne] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_cmp] = ACTIONS(3504),
    [anon_sym_TILDE_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_lt] = ACTIONS(3504),
    [anon_sym_le] = ACTIONS(3504),
    [anon_sym_ge] = ACTIONS(3504),
    [anon_sym_gt] = ACTIONS(3504),
    [anon_sym_isa] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3504),
    [anon_sym_DASH_DASH] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_EQ_GT] = ACTIONS(3504),
    [anon_sym_for] = ACTIONS(3506),
    [anon_sym_foreach] = ACTIONS(3504),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3504),
    [anon_sym___END__] = ACTIONS(3504),
    [anon_sym_EOT] = ACTIONS(3504),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [sym__PERLY_SEMICOLON] = ACTIONS(3504),
    [sym__ctrl_z_hack] = ACTIONS(3504),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1174] = {
    [sym_heredoc_content] = STATE(1174),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(325),
  },
  [1175] = {
    [sym_heredoc_content] = STATE(1175),
    [anon_sym_LBRACE] = ACTIONS(3508),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym_LPAREN] = ACTIONS(3508),
    [anon_sym_COMMA] = ACTIONS(3508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3508),
    [anon_sym_and] = ACTIONS(3508),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_LBRACK] = ACTIONS(3508),
    [anon_sym_DASH_GT] = ACTIONS(3508),
    [anon_sym_PERCENT] = ACTIONS(3510),
    [anon_sym_LT] = ACTIONS(3510),
    [anon_sym_GT] = ACTIONS(3510),
    [anon_sym_LT_LT] = ACTIONS(3510),
    [anon_sym_EQ] = ACTIONS(3510),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3508),
    [anon_sym_PLUS_EQ] = ACTIONS(3508),
    [anon_sym_DASH_EQ] = ACTIONS(3508),
    [anon_sym_DOT_EQ] = ACTIONS(3508),
    [anon_sym_STAR_EQ] = ACTIONS(3508),
    [anon_sym_SLASH_EQ] = ACTIONS(3508),
    [anon_sym_PERCENT_EQ] = ACTIONS(3508),
    [anon_sym_x_EQ] = ACTIONS(3508),
    [anon_sym_AMP_EQ] = ACTIONS(3508),
    [anon_sym_PIPE_EQ] = ACTIONS(3508),
    [anon_sym_CARET_EQ] = ACTIONS(3508),
    [anon_sym_LT_LT_EQ] = ACTIONS(3508),
    [anon_sym_GT_GT_EQ] = ACTIONS(3508),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3508),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3508),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3508),
    [anon_sym_DOT_DOT] = ACTIONS(3510),
    [anon_sym_STAR_STAR] = ACTIONS(3510),
    [anon_sym_PIPE_PIPE] = ACTIONS(3510),
    [anon_sym_SLASH_SLASH] = ACTIONS(3510),
    [anon_sym_AMP_AMP] = ACTIONS(3510),
    [anon_sym_PIPE] = ACTIONS(3510),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_GT_GT2] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3510),
    [anon_sym_DASH] = ACTIONS(3510),
    [anon_sym_DOT] = ACTIONS(3510),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_x] = ACTIONS(3510),
    [anon_sym_EQ_TILDE] = ACTIONS(3508),
    [anon_sym_BANG_TILDE] = ACTIONS(3508),
    [anon_sym_EQ_EQ] = ACTIONS(3508),
    [anon_sym_BANG_EQ] = ACTIONS(3508),
    [anon_sym_eq] = ACTIONS(3508),
    [anon_sym_ne] = ACTIONS(3508),
    [anon_sym_LT_EQ_GT] = ACTIONS(3508),
    [anon_sym_cmp] = ACTIONS(3508),
    [anon_sym_TILDE_TILDE] = ACTIONS(3508),
    [anon_sym_LT_EQ] = ACTIONS(3510),
    [anon_sym_GT_EQ] = ACTIONS(3508),
    [anon_sym_lt] = ACTIONS(3508),
    [anon_sym_le] = ACTIONS(3508),
    [anon_sym_ge] = ACTIONS(3508),
    [anon_sym_gt] = ACTIONS(3508),
    [anon_sym_isa] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3508),
    [anon_sym_DASH_DASH] = ACTIONS(3508),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_EQ_GT] = ACTIONS(3508),
    [anon_sym_for] = ACTIONS(3510),
    [anon_sym_foreach] = ACTIONS(3508),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3508),
    [anon_sym___END__] = ACTIONS(3508),
    [anon_sym_EOT] = ACTIONS(3508),
    [anon_sym_if] = ACTIONS(3508),
    [anon_sym_unless] = ACTIONS(3508),
    [anon_sym_while] = ACTIONS(3508),
    [anon_sym_until] = ACTIONS(3508),
    [sym__PERLY_SEMICOLON] = ACTIONS(3508),
    [sym__ctrl_z_hack] = ACTIONS(3508),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1176] = {
    [sym_heredoc_content] = STATE(1176),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2917),
    [anon_sym_and] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2917),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_x_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2917),
    [anon_sym_BANG_TILDE] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_eq] = ACTIONS(2917),
    [anon_sym_ne] = ACTIONS(2917),
    [anon_sym_LT_EQ_GT] = ACTIONS(2917),
    [anon_sym_cmp] = ACTIONS(2917),
    [anon_sym_TILDE_TILDE] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_lt] = ACTIONS(2917),
    [anon_sym_le] = ACTIONS(2917),
    [anon_sym_ge] = ACTIONS(2917),
    [anon_sym_gt] = ACTIONS(2917),
    [anon_sym_isa] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_foreach] = ACTIONS(2917),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2917),
    [anon_sym___END__] = ACTIONS(2917),
    [anon_sym_EOT] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_unless] = ACTIONS(2917),
    [anon_sym_while] = ACTIONS(2917),
    [anon_sym_until] = ACTIONS(2917),
    [sym__PERLY_SEMICOLON] = ACTIONS(2917),
    [sym__ctrl_z_hack] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1177] = {
    [sym_heredoc_content] = STATE(1177),
    [anon_sym_LBRACE] = ACTIONS(3512),
    [anon_sym_SEMI] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_COMMA] = ACTIONS(3512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3512),
    [anon_sym_and] = ACTIONS(3512),
    [anon_sym_or] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3512),
    [anon_sym_DASH_GT] = ACTIONS(3512),
    [anon_sym_PERCENT] = ACTIONS(3514),
    [anon_sym_LT] = ACTIONS(3514),
    [anon_sym_GT] = ACTIONS(3514),
    [anon_sym_LT_LT] = ACTIONS(3514),
    [anon_sym_EQ] = ACTIONS(3514),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_DOT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_x_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_DOT_DOT] = ACTIONS(3514),
    [anon_sym_STAR_STAR] = ACTIONS(3514),
    [anon_sym_PIPE_PIPE] = ACTIONS(3514),
    [anon_sym_SLASH_SLASH] = ACTIONS(3514),
    [anon_sym_AMP_AMP] = ACTIONS(3514),
    [anon_sym_PIPE] = ACTIONS(3514),
    [anon_sym_AMP] = ACTIONS(3514),
    [anon_sym_GT_GT2] = ACTIONS(3514),
    [anon_sym_PLUS] = ACTIONS(3514),
    [anon_sym_DASH] = ACTIONS(3514),
    [anon_sym_DOT] = ACTIONS(3514),
    [anon_sym_STAR] = ACTIONS(3514),
    [anon_sym_SLASH] = ACTIONS(3514),
    [anon_sym_x] = ACTIONS(3514),
    [anon_sym_EQ_TILDE] = ACTIONS(3512),
    [anon_sym_BANG_TILDE] = ACTIONS(3512),
    [anon_sym_EQ_EQ] = ACTIONS(3512),
    [anon_sym_BANG_EQ] = ACTIONS(3512),
    [anon_sym_eq] = ACTIONS(3512),
    [anon_sym_ne] = ACTIONS(3512),
    [anon_sym_LT_EQ_GT] = ACTIONS(3512),
    [anon_sym_cmp] = ACTIONS(3512),
    [anon_sym_TILDE_TILDE] = ACTIONS(3512),
    [anon_sym_LT_EQ] = ACTIONS(3514),
    [anon_sym_GT_EQ] = ACTIONS(3512),
    [anon_sym_lt] = ACTIONS(3512),
    [anon_sym_le] = ACTIONS(3512),
    [anon_sym_ge] = ACTIONS(3512),
    [anon_sym_gt] = ACTIONS(3512),
    [anon_sym_isa] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3512),
    [anon_sym_DASH_DASH] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(3512),
    [anon_sym_EQ_GT] = ACTIONS(3512),
    [anon_sym_for] = ACTIONS(3514),
    [anon_sym_foreach] = ACTIONS(3512),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3512),
    [anon_sym___END__] = ACTIONS(3512),
    [anon_sym_EOT] = ACTIONS(3512),
    [anon_sym_if] = ACTIONS(3512),
    [anon_sym_unless] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(3512),
    [anon_sym_until] = ACTIONS(3512),
    [sym__PERLY_SEMICOLON] = ACTIONS(3512),
    [sym__ctrl_z_hack] = ACTIONS(3512),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1178] = {
    [sym_heredoc_content] = STATE(1178),
    [anon_sym_LBRACE] = ACTIONS(3516),
    [anon_sym_SEMI] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3516),
    [anon_sym_and] = ACTIONS(3516),
    [anon_sym_or] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3516),
    [anon_sym_DASH_GT] = ACTIONS(3516),
    [anon_sym_PERCENT] = ACTIONS(3518),
    [anon_sym_LT] = ACTIONS(3518),
    [anon_sym_GT] = ACTIONS(3518),
    [anon_sym_LT_LT] = ACTIONS(3518),
    [anon_sym_EQ] = ACTIONS(3518),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3516),
    [anon_sym_PLUS_EQ] = ACTIONS(3516),
    [anon_sym_DASH_EQ] = ACTIONS(3516),
    [anon_sym_DOT_EQ] = ACTIONS(3516),
    [anon_sym_STAR_EQ] = ACTIONS(3516),
    [anon_sym_SLASH_EQ] = ACTIONS(3516),
    [anon_sym_PERCENT_EQ] = ACTIONS(3516),
    [anon_sym_x_EQ] = ACTIONS(3516),
    [anon_sym_AMP_EQ] = ACTIONS(3516),
    [anon_sym_PIPE_EQ] = ACTIONS(3516),
    [anon_sym_CARET_EQ] = ACTIONS(3516),
    [anon_sym_LT_LT_EQ] = ACTIONS(3516),
    [anon_sym_GT_GT_EQ] = ACTIONS(3516),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3516),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3516),
    [anon_sym_DOT_DOT] = ACTIONS(3518),
    [anon_sym_STAR_STAR] = ACTIONS(3518),
    [anon_sym_PIPE_PIPE] = ACTIONS(3518),
    [anon_sym_SLASH_SLASH] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3518),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_GT_GT2] = ACTIONS(3518),
    [anon_sym_PLUS] = ACTIONS(3518),
    [anon_sym_DASH] = ACTIONS(3518),
    [anon_sym_DOT] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3518),
    [anon_sym_SLASH] = ACTIONS(3518),
    [anon_sym_x] = ACTIONS(3518),
    [anon_sym_EQ_TILDE] = ACTIONS(3516),
    [anon_sym_BANG_TILDE] = ACTIONS(3516),
    [anon_sym_EQ_EQ] = ACTIONS(3516),
    [anon_sym_BANG_EQ] = ACTIONS(3516),
    [anon_sym_eq] = ACTIONS(3516),
    [anon_sym_ne] = ACTIONS(3516),
    [anon_sym_LT_EQ_GT] = ACTIONS(3516),
    [anon_sym_cmp] = ACTIONS(3516),
    [anon_sym_TILDE_TILDE] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(3518),
    [anon_sym_GT_EQ] = ACTIONS(3516),
    [anon_sym_lt] = ACTIONS(3516),
    [anon_sym_le] = ACTIONS(3516),
    [anon_sym_ge] = ACTIONS(3516),
    [anon_sym_gt] = ACTIONS(3516),
    [anon_sym_isa] = ACTIONS(3516),
    [anon_sym_PLUS_PLUS] = ACTIONS(3516),
    [anon_sym_DASH_DASH] = ACTIONS(3516),
    [anon_sym_QMARK] = ACTIONS(3516),
    [anon_sym_EQ_GT] = ACTIONS(3516),
    [anon_sym_for] = ACTIONS(3518),
    [anon_sym_foreach] = ACTIONS(3516),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3516),
    [anon_sym___END__] = ACTIONS(3516),
    [anon_sym_EOT] = ACTIONS(3516),
    [anon_sym_if] = ACTIONS(3516),
    [anon_sym_unless] = ACTIONS(3516),
    [anon_sym_while] = ACTIONS(3516),
    [anon_sym_until] = ACTIONS(3516),
    [sym__PERLY_SEMICOLON] = ACTIONS(3516),
    [sym__ctrl_z_hack] = ACTIONS(3516),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1179] = {
    [sym_heredoc_content] = STATE(1179),
    [sym__identifier] = ACTIONS(3520),
    [anon_sym_COLON] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_COMMA] = ACTIONS(3522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3522),
    [anon_sym_and] = ACTIONS(3520),
    [anon_sym_or] = ACTIONS(3520),
    [anon_sym_DASH_GT] = ACTIONS(3522),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3520),
    [anon_sym_GT] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3522),
    [anon_sym_PLUS_EQ] = ACTIONS(3522),
    [anon_sym_DASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_EQ] = ACTIONS(3522),
    [anon_sym_STAR_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_PERCENT_EQ] = ACTIONS(3522),
    [anon_sym_x_EQ] = ACTIONS(3522),
    [anon_sym_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_CARET_EQ] = ACTIONS(3522),
    [anon_sym_LT_LT_EQ] = ACTIONS(3522),
    [anon_sym_GT_GT_EQ] = ACTIONS(3522),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_DOT] = ACTIONS(3520),
    [anon_sym_STAR_STAR] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_SLASH_SLASH] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_GT_GT2] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3520),
    [anon_sym_x] = ACTIONS(3520),
    [anon_sym_EQ_TILDE] = ACTIONS(3522),
    [anon_sym_BANG_TILDE] = ACTIONS(3522),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_eq] = ACTIONS(3520),
    [anon_sym_ne] = ACTIONS(3520),
    [anon_sym_LT_EQ_GT] = ACTIONS(3522),
    [anon_sym_cmp] = ACTIONS(3520),
    [anon_sym_TILDE_TILDE] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3520),
    [anon_sym_GT_EQ] = ACTIONS(3522),
    [anon_sym_lt] = ACTIONS(3520),
    [anon_sym_le] = ACTIONS(3520),
    [anon_sym_ge] = ACTIONS(3520),
    [anon_sym_gt] = ACTIONS(3520),
    [anon_sym_isa] = ACTIONS(3520),
    [anon_sym_PLUS_PLUS] = ACTIONS(3522),
    [anon_sym_DASH_DASH] = ACTIONS(3522),
    [anon_sym_QMARK] = ACTIONS(3522),
    [anon_sym_EQ_GT] = ACTIONS(3522),
    [anon_sym_for] = ACTIONS(3520),
    [anon_sym_foreach] = ACTIONS(3520),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3520),
    [anon_sym___END__] = ACTIONS(3520),
    [anon_sym_EOT] = ACTIONS(3522),
    [anon_sym_if] = ACTIONS(3520),
    [anon_sym_unless] = ACTIONS(3520),
    [anon_sym_while] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(3520),
    [aux_sym__bareword_token1] = ACTIONS(3520),
    [sym__PERLY_SEMICOLON] = ACTIONS(3522),
    [sym__ctrl_z_hack] = ACTIONS(3522),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1180] = {
    [sym_heredoc_content] = STATE(1180),
    [anon_sym_LBRACE] = ACTIONS(3524),
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(3524),
    [anon_sym_COMMA] = ACTIONS(3524),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3524),
    [anon_sym_and] = ACTIONS(3524),
    [anon_sym_or] = ACTIONS(3524),
    [anon_sym_LBRACK] = ACTIONS(3524),
    [anon_sym_DASH_GT] = ACTIONS(3524),
    [anon_sym_PERCENT] = ACTIONS(3526),
    [anon_sym_LT] = ACTIONS(3526),
    [anon_sym_GT] = ACTIONS(3526),
    [anon_sym_LT_LT] = ACTIONS(3526),
    [anon_sym_EQ] = ACTIONS(3526),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3524),
    [anon_sym_PLUS_EQ] = ACTIONS(3524),
    [anon_sym_DASH_EQ] = ACTIONS(3524),
    [anon_sym_DOT_EQ] = ACTIONS(3524),
    [anon_sym_STAR_EQ] = ACTIONS(3524),
    [anon_sym_SLASH_EQ] = ACTIONS(3524),
    [anon_sym_PERCENT_EQ] = ACTIONS(3524),
    [anon_sym_x_EQ] = ACTIONS(3524),
    [anon_sym_AMP_EQ] = ACTIONS(3524),
    [anon_sym_PIPE_EQ] = ACTIONS(3524),
    [anon_sym_CARET_EQ] = ACTIONS(3524),
    [anon_sym_LT_LT_EQ] = ACTIONS(3524),
    [anon_sym_GT_GT_EQ] = ACTIONS(3524),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3524),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3524),
    [anon_sym_DOT_DOT] = ACTIONS(3526),
    [anon_sym_STAR_STAR] = ACTIONS(3526),
    [anon_sym_PIPE_PIPE] = ACTIONS(3526),
    [anon_sym_SLASH_SLASH] = ACTIONS(3526),
    [anon_sym_AMP_AMP] = ACTIONS(3526),
    [anon_sym_PIPE] = ACTIONS(3526),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_GT_GT2] = ACTIONS(3526),
    [anon_sym_PLUS] = ACTIONS(3526),
    [anon_sym_DASH] = ACTIONS(3526),
    [anon_sym_DOT] = ACTIONS(3526),
    [anon_sym_STAR] = ACTIONS(3526),
    [anon_sym_SLASH] = ACTIONS(3526),
    [anon_sym_x] = ACTIONS(3526),
    [anon_sym_EQ_TILDE] = ACTIONS(3524),
    [anon_sym_BANG_TILDE] = ACTIONS(3524),
    [anon_sym_EQ_EQ] = ACTIONS(3524),
    [anon_sym_BANG_EQ] = ACTIONS(3524),
    [anon_sym_eq] = ACTIONS(3524),
    [anon_sym_ne] = ACTIONS(3524),
    [anon_sym_LT_EQ_GT] = ACTIONS(3524),
    [anon_sym_cmp] = ACTIONS(3524),
    [anon_sym_TILDE_TILDE] = ACTIONS(3524),
    [anon_sym_LT_EQ] = ACTIONS(3526),
    [anon_sym_GT_EQ] = ACTIONS(3524),
    [anon_sym_lt] = ACTIONS(3524),
    [anon_sym_le] = ACTIONS(3524),
    [anon_sym_ge] = ACTIONS(3524),
    [anon_sym_gt] = ACTIONS(3524),
    [anon_sym_isa] = ACTIONS(3524),
    [anon_sym_PLUS_PLUS] = ACTIONS(3524),
    [anon_sym_DASH_DASH] = ACTIONS(3524),
    [anon_sym_QMARK] = ACTIONS(3524),
    [anon_sym_EQ_GT] = ACTIONS(3524),
    [anon_sym_for] = ACTIONS(3526),
    [anon_sym_foreach] = ACTIONS(3524),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3524),
    [anon_sym___END__] = ACTIONS(3524),
    [anon_sym_EOT] = ACTIONS(3524),
    [anon_sym_if] = ACTIONS(3524),
    [anon_sym_unless] = ACTIONS(3524),
    [anon_sym_while] = ACTIONS(3524),
    [anon_sym_until] = ACTIONS(3524),
    [sym__PERLY_SEMICOLON] = ACTIONS(3524),
    [sym__ctrl_z_hack] = ACTIONS(3524),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1181] = {
    [sym_heredoc_content] = STATE(1181),
    [anon_sym_LBRACE] = ACTIONS(3528),
    [anon_sym_SEMI] = ACTIONS(3528),
    [anon_sym_LPAREN] = ACTIONS(3528),
    [anon_sym_COMMA] = ACTIONS(3528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3528),
    [anon_sym_and] = ACTIONS(3528),
    [anon_sym_or] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(3528),
    [anon_sym_DASH_GT] = ACTIONS(3528),
    [anon_sym_PERCENT] = ACTIONS(3530),
    [anon_sym_LT] = ACTIONS(3530),
    [anon_sym_GT] = ACTIONS(3530),
    [anon_sym_LT_LT] = ACTIONS(3530),
    [anon_sym_EQ] = ACTIONS(3530),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3528),
    [anon_sym_PLUS_EQ] = ACTIONS(3528),
    [anon_sym_DASH_EQ] = ACTIONS(3528),
    [anon_sym_DOT_EQ] = ACTIONS(3528),
    [anon_sym_STAR_EQ] = ACTIONS(3528),
    [anon_sym_SLASH_EQ] = ACTIONS(3528),
    [anon_sym_PERCENT_EQ] = ACTIONS(3528),
    [anon_sym_x_EQ] = ACTIONS(3528),
    [anon_sym_AMP_EQ] = ACTIONS(3528),
    [anon_sym_PIPE_EQ] = ACTIONS(3528),
    [anon_sym_CARET_EQ] = ACTIONS(3528),
    [anon_sym_LT_LT_EQ] = ACTIONS(3528),
    [anon_sym_GT_GT_EQ] = ACTIONS(3528),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3528),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3528),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3528),
    [anon_sym_DOT_DOT] = ACTIONS(3530),
    [anon_sym_STAR_STAR] = ACTIONS(3530),
    [anon_sym_PIPE_PIPE] = ACTIONS(3530),
    [anon_sym_SLASH_SLASH] = ACTIONS(3530),
    [anon_sym_AMP_AMP] = ACTIONS(3530),
    [anon_sym_PIPE] = ACTIONS(3530),
    [anon_sym_AMP] = ACTIONS(3530),
    [anon_sym_GT_GT2] = ACTIONS(3530),
    [anon_sym_PLUS] = ACTIONS(3530),
    [anon_sym_DASH] = ACTIONS(3530),
    [anon_sym_DOT] = ACTIONS(3530),
    [anon_sym_STAR] = ACTIONS(3530),
    [anon_sym_SLASH] = ACTIONS(3530),
    [anon_sym_x] = ACTIONS(3530),
    [anon_sym_EQ_TILDE] = ACTIONS(3528),
    [anon_sym_BANG_TILDE] = ACTIONS(3528),
    [anon_sym_EQ_EQ] = ACTIONS(3528),
    [anon_sym_BANG_EQ] = ACTIONS(3528),
    [anon_sym_eq] = ACTIONS(3528),
    [anon_sym_ne] = ACTIONS(3528),
    [anon_sym_LT_EQ_GT] = ACTIONS(3528),
    [anon_sym_cmp] = ACTIONS(3528),
    [anon_sym_TILDE_TILDE] = ACTIONS(3528),
    [anon_sym_LT_EQ] = ACTIONS(3530),
    [anon_sym_GT_EQ] = ACTIONS(3528),
    [anon_sym_lt] = ACTIONS(3528),
    [anon_sym_le] = ACTIONS(3528),
    [anon_sym_ge] = ACTIONS(3528),
    [anon_sym_gt] = ACTIONS(3528),
    [anon_sym_isa] = ACTIONS(3528),
    [anon_sym_PLUS_PLUS] = ACTIONS(3528),
    [anon_sym_DASH_DASH] = ACTIONS(3528),
    [anon_sym_QMARK] = ACTIONS(3528),
    [anon_sym_EQ_GT] = ACTIONS(3528),
    [anon_sym_for] = ACTIONS(3530),
    [anon_sym_foreach] = ACTIONS(3528),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3528),
    [anon_sym___END__] = ACTIONS(3528),
    [anon_sym_EOT] = ACTIONS(3528),
    [anon_sym_if] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(3528),
    [anon_sym_while] = ACTIONS(3528),
    [anon_sym_until] = ACTIONS(3528),
    [sym__PERLY_SEMICOLON] = ACTIONS(3528),
    [sym__ctrl_z_hack] = ACTIONS(3528),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1182] = {
    [sym_heredoc_content] = STATE(1182),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(329),
  },
  [1183] = {
    [sym_heredoc_content] = STATE(1183),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2891),
    [anon_sym_and] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_DASH_GT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2891),
    [anon_sym_PLUS_EQ] = ACTIONS(2891),
    [anon_sym_DASH_EQ] = ACTIONS(2891),
    [anon_sym_DOT_EQ] = ACTIONS(2891),
    [anon_sym_STAR_EQ] = ACTIONS(2891),
    [anon_sym_SLASH_EQ] = ACTIONS(2891),
    [anon_sym_PERCENT_EQ] = ACTIONS(2891),
    [anon_sym_x_EQ] = ACTIONS(2891),
    [anon_sym_AMP_EQ] = ACTIONS(2891),
    [anon_sym_PIPE_EQ] = ACTIONS(2891),
    [anon_sym_CARET_EQ] = ACTIONS(2891),
    [anon_sym_LT_LT_EQ] = ACTIONS(2891),
    [anon_sym_GT_GT_EQ] = ACTIONS(2891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2891),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2891),
    [anon_sym_DOT_DOT] = ACTIONS(2889),
    [anon_sym_STAR_STAR] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_GT_GT2] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_x] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2891),
    [anon_sym_BANG_TILDE] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_eq] = ACTIONS(2891),
    [anon_sym_ne] = ACTIONS(2891),
    [anon_sym_LT_EQ_GT] = ACTIONS(2891),
    [anon_sym_cmp] = ACTIONS(2891),
    [anon_sym_TILDE_TILDE] = ACTIONS(2891),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_lt] = ACTIONS(2891),
    [anon_sym_le] = ACTIONS(2891),
    [anon_sym_ge] = ACTIONS(2891),
    [anon_sym_gt] = ACTIONS(2891),
    [anon_sym_isa] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_EQ_GT] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_foreach] = ACTIONS(2891),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2891),
    [anon_sym___END__] = ACTIONS(2891),
    [anon_sym_EOT] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [sym__PERLY_SEMICOLON] = ACTIONS(2891),
    [sym__ctrl_z_hack] = ACTIONS(2891),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1184] = {
    [sym_heredoc_content] = STATE(1184),
    [anon_sym_LBRACE] = ACTIONS(3532),
    [anon_sym_SEMI] = ACTIONS(3532),
    [anon_sym_LPAREN] = ACTIONS(3532),
    [anon_sym_COMMA] = ACTIONS(3532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3532),
    [anon_sym_and] = ACTIONS(3532),
    [anon_sym_or] = ACTIONS(3532),
    [anon_sym_LBRACK] = ACTIONS(3532),
    [anon_sym_DASH_GT] = ACTIONS(3532),
    [anon_sym_PERCENT] = ACTIONS(3534),
    [anon_sym_LT] = ACTIONS(3534),
    [anon_sym_GT] = ACTIONS(3534),
    [anon_sym_LT_LT] = ACTIONS(3534),
    [anon_sym_EQ] = ACTIONS(3534),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3532),
    [anon_sym_PLUS_EQ] = ACTIONS(3532),
    [anon_sym_DASH_EQ] = ACTIONS(3532),
    [anon_sym_DOT_EQ] = ACTIONS(3532),
    [anon_sym_STAR_EQ] = ACTIONS(3532),
    [anon_sym_SLASH_EQ] = ACTIONS(3532),
    [anon_sym_PERCENT_EQ] = ACTIONS(3532),
    [anon_sym_x_EQ] = ACTIONS(3532),
    [anon_sym_AMP_EQ] = ACTIONS(3532),
    [anon_sym_PIPE_EQ] = ACTIONS(3532),
    [anon_sym_CARET_EQ] = ACTIONS(3532),
    [anon_sym_LT_LT_EQ] = ACTIONS(3532),
    [anon_sym_GT_GT_EQ] = ACTIONS(3532),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3532),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3532),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3532),
    [anon_sym_DOT_DOT] = ACTIONS(3534),
    [anon_sym_STAR_STAR] = ACTIONS(3534),
    [anon_sym_PIPE_PIPE] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3534),
    [anon_sym_AMP_AMP] = ACTIONS(3534),
    [anon_sym_PIPE] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(3534),
    [anon_sym_GT_GT2] = ACTIONS(3534),
    [anon_sym_PLUS] = ACTIONS(3534),
    [anon_sym_DASH] = ACTIONS(3534),
    [anon_sym_DOT] = ACTIONS(3534),
    [anon_sym_STAR] = ACTIONS(3534),
    [anon_sym_SLASH] = ACTIONS(3534),
    [anon_sym_x] = ACTIONS(3534),
    [anon_sym_EQ_TILDE] = ACTIONS(3532),
    [anon_sym_BANG_TILDE] = ACTIONS(3532),
    [anon_sym_EQ_EQ] = ACTIONS(3532),
    [anon_sym_BANG_EQ] = ACTIONS(3532),
    [anon_sym_eq] = ACTIONS(3532),
    [anon_sym_ne] = ACTIONS(3532),
    [anon_sym_LT_EQ_GT] = ACTIONS(3532),
    [anon_sym_cmp] = ACTIONS(3532),
    [anon_sym_TILDE_TILDE] = ACTIONS(3532),
    [anon_sym_LT_EQ] = ACTIONS(3534),
    [anon_sym_GT_EQ] = ACTIONS(3532),
    [anon_sym_lt] = ACTIONS(3532),
    [anon_sym_le] = ACTIONS(3532),
    [anon_sym_ge] = ACTIONS(3532),
    [anon_sym_gt] = ACTIONS(3532),
    [anon_sym_isa] = ACTIONS(3532),
    [anon_sym_PLUS_PLUS] = ACTIONS(3532),
    [anon_sym_DASH_DASH] = ACTIONS(3532),
    [anon_sym_QMARK] = ACTIONS(3532),
    [anon_sym_EQ_GT] = ACTIONS(3532),
    [anon_sym_for] = ACTIONS(3534),
    [anon_sym_foreach] = ACTIONS(3532),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3532),
    [anon_sym___END__] = ACTIONS(3532),
    [anon_sym_EOT] = ACTIONS(3532),
    [anon_sym_if] = ACTIONS(3532),
    [anon_sym_unless] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(3532),
    [anon_sym_until] = ACTIONS(3532),
    [sym__PERLY_SEMICOLON] = ACTIONS(3532),
    [sym__ctrl_z_hack] = ACTIONS(3532),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1185] = {
    [sym_heredoc_content] = STATE(1185),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(327),
  },
  [1186] = {
    [sym_heredoc_content] = STATE(1186),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(331),
  },
  [1187] = {
    [sym_heredoc_content] = STATE(1187),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_SEMI] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(3536),
    [anon_sym_COMMA] = ACTIONS(3536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3536),
    [anon_sym_and] = ACTIONS(3536),
    [anon_sym_or] = ACTIONS(3536),
    [anon_sym_LBRACK] = ACTIONS(3536),
    [anon_sym_DASH_GT] = ACTIONS(3536),
    [anon_sym_PERCENT] = ACTIONS(3538),
    [anon_sym_LT] = ACTIONS(3538),
    [anon_sym_GT] = ACTIONS(3538),
    [anon_sym_LT_LT] = ACTIONS(3538),
    [anon_sym_EQ] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3536),
    [anon_sym_DASH_EQ] = ACTIONS(3536),
    [anon_sym_DOT_EQ] = ACTIONS(3536),
    [anon_sym_STAR_EQ] = ACTIONS(3536),
    [anon_sym_SLASH_EQ] = ACTIONS(3536),
    [anon_sym_PERCENT_EQ] = ACTIONS(3536),
    [anon_sym_x_EQ] = ACTIONS(3536),
    [anon_sym_AMP_EQ] = ACTIONS(3536),
    [anon_sym_PIPE_EQ] = ACTIONS(3536),
    [anon_sym_CARET_EQ] = ACTIONS(3536),
    [anon_sym_LT_LT_EQ] = ACTIONS(3536),
    [anon_sym_GT_GT_EQ] = ACTIONS(3536),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3536),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3536),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3536),
    [anon_sym_DOT_DOT] = ACTIONS(3538),
    [anon_sym_STAR_STAR] = ACTIONS(3538),
    [anon_sym_PIPE_PIPE] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3538),
    [anon_sym_AMP_AMP] = ACTIONS(3538),
    [anon_sym_PIPE] = ACTIONS(3538),
    [anon_sym_AMP] = ACTIONS(3538),
    [anon_sym_GT_GT2] = ACTIONS(3538),
    [anon_sym_PLUS] = ACTIONS(3538),
    [anon_sym_DASH] = ACTIONS(3538),
    [anon_sym_DOT] = ACTIONS(3538),
    [anon_sym_STAR] = ACTIONS(3538),
    [anon_sym_SLASH] = ACTIONS(3538),
    [anon_sym_x] = ACTIONS(3538),
    [anon_sym_EQ_TILDE] = ACTIONS(3536),
    [anon_sym_BANG_TILDE] = ACTIONS(3536),
    [anon_sym_EQ_EQ] = ACTIONS(3536),
    [anon_sym_BANG_EQ] = ACTIONS(3536),
    [anon_sym_eq] = ACTIONS(3536),
    [anon_sym_ne] = ACTIONS(3536),
    [anon_sym_LT_EQ_GT] = ACTIONS(3536),
    [anon_sym_cmp] = ACTIONS(3536),
    [anon_sym_TILDE_TILDE] = ACTIONS(3536),
    [anon_sym_LT_EQ] = ACTIONS(3538),
    [anon_sym_GT_EQ] = ACTIONS(3536),
    [anon_sym_lt] = ACTIONS(3536),
    [anon_sym_le] = ACTIONS(3536),
    [anon_sym_ge] = ACTIONS(3536),
    [anon_sym_gt] = ACTIONS(3536),
    [anon_sym_isa] = ACTIONS(3536),
    [anon_sym_PLUS_PLUS] = ACTIONS(3536),
    [anon_sym_DASH_DASH] = ACTIONS(3536),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_EQ_GT] = ACTIONS(3536),
    [anon_sym_for] = ACTIONS(3538),
    [anon_sym_foreach] = ACTIONS(3536),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3536),
    [anon_sym___END__] = ACTIONS(3536),
    [anon_sym_EOT] = ACTIONS(3536),
    [anon_sym_if] = ACTIONS(3536),
    [anon_sym_unless] = ACTIONS(3536),
    [anon_sym_while] = ACTIONS(3536),
    [anon_sym_until] = ACTIONS(3536),
    [sym__PERLY_SEMICOLON] = ACTIONS(3536),
    [sym__ctrl_z_hack] = ACTIONS(3536),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1188] = {
    [sym_heredoc_content] = STATE(1188),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
    [sym__brace_end_zw] = ACTIONS(311),
  },
  [1189] = {
    [sym_heredoc_content] = STATE(1189),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1190] = {
    [sym_heredoc_content] = STATE(1190),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_foreach] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3452),
    [anon_sym___END__] = ACTIONS(3452),
    [anon_sym_EOT] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_unless] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_until] = ACTIONS(3452),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym__ctrl_z_hack] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1191] = {
    [sym_heredoc_content] = STATE(1191),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(3540),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1192] = {
    [sym_heredoc_content] = STATE(1192),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(3542),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1193] = {
    [sym_heredoc_content] = STATE(1193),
    [anon_sym_LBRACE] = ACTIONS(3544),
    [anon_sym_SEMI] = ACTIONS(3546),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3546),
    [anon_sym_and] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3546),
    [anon_sym_LBRACK] = ACTIONS(3544),
    [anon_sym_DASH_GT] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3548),
    [anon_sym_GT] = ACTIONS(3548),
    [anon_sym_LT_LT] = ACTIONS(3548),
    [anon_sym_EQ] = ACTIONS(3548),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3546),
    [anon_sym_PLUS_EQ] = ACTIONS(3546),
    [anon_sym_DASH_EQ] = ACTIONS(3546),
    [anon_sym_DOT_EQ] = ACTIONS(3546),
    [anon_sym_STAR_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_PERCENT_EQ] = ACTIONS(3546),
    [anon_sym_x_EQ] = ACTIONS(3546),
    [anon_sym_AMP_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_CARET_EQ] = ACTIONS(3546),
    [anon_sym_LT_LT_EQ] = ACTIONS(3546),
    [anon_sym_GT_GT_EQ] = ACTIONS(3546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_DOT_DOT] = ACTIONS(3548),
    [anon_sym_STAR_STAR] = ACTIONS(3548),
    [anon_sym_PIPE_PIPE] = ACTIONS(3548),
    [anon_sym_SLASH_SLASH] = ACTIONS(3548),
    [anon_sym_AMP_AMP] = ACTIONS(3548),
    [anon_sym_PIPE] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_GT_GT2] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_DOT] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_SLASH] = ACTIONS(3548),
    [anon_sym_x] = ACTIONS(3548),
    [anon_sym_EQ_TILDE] = ACTIONS(3546),
    [anon_sym_BANG_TILDE] = ACTIONS(3546),
    [anon_sym_EQ_EQ] = ACTIONS(3546),
    [anon_sym_BANG_EQ] = ACTIONS(3546),
    [anon_sym_eq] = ACTIONS(3546),
    [anon_sym_ne] = ACTIONS(3546),
    [anon_sym_LT_EQ_GT] = ACTIONS(3546),
    [anon_sym_cmp] = ACTIONS(3546),
    [anon_sym_TILDE_TILDE] = ACTIONS(3546),
    [anon_sym_LT_EQ] = ACTIONS(3548),
    [anon_sym_GT_EQ] = ACTIONS(3546),
    [anon_sym_lt] = ACTIONS(3546),
    [anon_sym_le] = ACTIONS(3546),
    [anon_sym_ge] = ACTIONS(3546),
    [anon_sym_gt] = ACTIONS(3546),
    [anon_sym_isa] = ACTIONS(3546),
    [anon_sym_PLUS_PLUS] = ACTIONS(3546),
    [anon_sym_DASH_DASH] = ACTIONS(3546),
    [anon_sym_QMARK] = ACTIONS(3546),
    [anon_sym_EQ_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3548),
    [anon_sym_foreach] = ACTIONS(3546),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3546),
    [anon_sym___END__] = ACTIONS(3546),
    [anon_sym_EOT] = ACTIONS(3546),
    [anon_sym_if] = ACTIONS(3546),
    [anon_sym_unless] = ACTIONS(3546),
    [anon_sym_while] = ACTIONS(3546),
    [anon_sym_until] = ACTIONS(3546),
    [sym__PERLY_SEMICOLON] = ACTIONS(3546),
    [sym__ctrl_z_hack] = ACTIONS(3546),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1194] = {
    [sym_heredoc_content] = STATE(1194),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(3550),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1195] = {
    [sym_heredoc_content] = STATE(1195),
    [anon_sym_LBRACE] = ACTIONS(3552),
    [anon_sym_SEMI] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3554),
    [anon_sym_and] = ACTIONS(3554),
    [anon_sym_or] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3552),
    [anon_sym_DASH_GT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_GT] = ACTIONS(3556),
    [anon_sym_LT_LT] = ACTIONS(3556),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3554),
    [anon_sym_PLUS_EQ] = ACTIONS(3554),
    [anon_sym_DASH_EQ] = ACTIONS(3554),
    [anon_sym_DOT_EQ] = ACTIONS(3554),
    [anon_sym_STAR_EQ] = ACTIONS(3554),
    [anon_sym_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_PERCENT_EQ] = ACTIONS(3554),
    [anon_sym_x_EQ] = ACTIONS(3554),
    [anon_sym_AMP_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_CARET_EQ] = ACTIONS(3554),
    [anon_sym_LT_LT_EQ] = ACTIONS(3554),
    [anon_sym_GT_GT_EQ] = ACTIONS(3554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_DOT_DOT] = ACTIONS(3556),
    [anon_sym_STAR_STAR] = ACTIONS(3556),
    [anon_sym_PIPE_PIPE] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH] = ACTIONS(3556),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_PIPE] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym_GT_GT2] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3556),
    [anon_sym_DOT] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_SLASH] = ACTIONS(3556),
    [anon_sym_x] = ACTIONS(3556),
    [anon_sym_EQ_TILDE] = ACTIONS(3554),
    [anon_sym_BANG_TILDE] = ACTIONS(3554),
    [anon_sym_EQ_EQ] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_eq] = ACTIONS(3554),
    [anon_sym_ne] = ACTIONS(3554),
    [anon_sym_LT_EQ_GT] = ACTIONS(3554),
    [anon_sym_cmp] = ACTIONS(3554),
    [anon_sym_TILDE_TILDE] = ACTIONS(3554),
    [anon_sym_LT_EQ] = ACTIONS(3556),
    [anon_sym_GT_EQ] = ACTIONS(3554),
    [anon_sym_lt] = ACTIONS(3554),
    [anon_sym_le] = ACTIONS(3554),
    [anon_sym_ge] = ACTIONS(3554),
    [anon_sym_gt] = ACTIONS(3554),
    [anon_sym_isa] = ACTIONS(3554),
    [anon_sym_PLUS_PLUS] = ACTIONS(3554),
    [anon_sym_DASH_DASH] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_EQ_GT] = ACTIONS(3554),
    [anon_sym_for] = ACTIONS(3556),
    [anon_sym_foreach] = ACTIONS(3554),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3554),
    [anon_sym___END__] = ACTIONS(3554),
    [anon_sym_EOT] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_unless] = ACTIONS(3554),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_until] = ACTIONS(3554),
    [sym__PERLY_SEMICOLON] = ACTIONS(3554),
    [sym__ctrl_z_hack] = ACTIONS(3554),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1196] = {
    [sym_heredoc_content] = STATE(1196),
    [anon_sym_LBRACE] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2917),
    [anon_sym_and] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(3558),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2917),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_x_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2917),
    [anon_sym_BANG_TILDE] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_eq] = ACTIONS(2917),
    [anon_sym_ne] = ACTIONS(2917),
    [anon_sym_LT_EQ_GT] = ACTIONS(2917),
    [anon_sym_cmp] = ACTIONS(2917),
    [anon_sym_TILDE_TILDE] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_lt] = ACTIONS(2917),
    [anon_sym_le] = ACTIONS(2917),
    [anon_sym_ge] = ACTIONS(2917),
    [anon_sym_gt] = ACTIONS(2917),
    [anon_sym_isa] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_foreach] = ACTIONS(2917),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2917),
    [anon_sym___END__] = ACTIONS(2917),
    [anon_sym_EOT] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_unless] = ACTIONS(2917),
    [anon_sym_while] = ACTIONS(2917),
    [anon_sym_until] = ACTIONS(2917),
    [sym__PERLY_SEMICOLON] = ACTIONS(2917),
    [sym__ctrl_z_hack] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1197] = {
    [sym_heredoc_content] = STATE(1197),
    [anon_sym_COLON] = ACTIONS(3560),
    [anon_sym_SEMI] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3562),
    [anon_sym_and] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3564),
    [anon_sym_LT] = ACTIONS(3564),
    [anon_sym_GT] = ACTIONS(3564),
    [anon_sym_LT_LT] = ACTIONS(3564),
    [anon_sym_EQ] = ACTIONS(3564),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3562),
    [anon_sym_PLUS_EQ] = ACTIONS(3562),
    [anon_sym_DASH_EQ] = ACTIONS(3562),
    [anon_sym_DOT_EQ] = ACTIONS(3562),
    [anon_sym_STAR_EQ] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(3562),
    [anon_sym_PERCENT_EQ] = ACTIONS(3562),
    [anon_sym_x_EQ] = ACTIONS(3562),
    [anon_sym_AMP_EQ] = ACTIONS(3562),
    [anon_sym_PIPE_EQ] = ACTIONS(3562),
    [anon_sym_CARET_EQ] = ACTIONS(3562),
    [anon_sym_LT_LT_EQ] = ACTIONS(3562),
    [anon_sym_GT_GT_EQ] = ACTIONS(3562),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3562),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(3564),
    [anon_sym_STAR_STAR] = ACTIONS(3564),
    [anon_sym_PIPE_PIPE] = ACTIONS(3564),
    [anon_sym_SLASH_SLASH] = ACTIONS(3564),
    [anon_sym_AMP_AMP] = ACTIONS(3564),
    [anon_sym_PIPE] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_GT_GT2] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(3564),
    [anon_sym_DASH] = ACTIONS(3564),
    [anon_sym_DOT] = ACTIONS(3564),
    [anon_sym_STAR] = ACTIONS(3564),
    [anon_sym_SLASH] = ACTIONS(3564),
    [anon_sym_x] = ACTIONS(3564),
    [anon_sym_EQ_TILDE] = ACTIONS(3562),
    [anon_sym_BANG_TILDE] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_eq] = ACTIONS(3562),
    [anon_sym_ne] = ACTIONS(3562),
    [anon_sym_LT_EQ_GT] = ACTIONS(3562),
    [anon_sym_cmp] = ACTIONS(3562),
    [anon_sym_TILDE_TILDE] = ACTIONS(3562),
    [anon_sym_LT_EQ] = ACTIONS(3564),
    [anon_sym_GT_EQ] = ACTIONS(3562),
    [anon_sym_lt] = ACTIONS(3562),
    [anon_sym_le] = ACTIONS(3562),
    [anon_sym_ge] = ACTIONS(3562),
    [anon_sym_gt] = ACTIONS(3562),
    [anon_sym_isa] = ACTIONS(3562),
    [anon_sym_PLUS_PLUS] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_EQ_GT] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3564),
    [anon_sym_foreach] = ACTIONS(3562),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3562),
    [anon_sym___END__] = ACTIONS(3562),
    [anon_sym_EOT] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_unless] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_until] = ACTIONS(3562),
    [sym__PERLY_SEMICOLON] = ACTIONS(3562),
    [sym__ctrl_z_hack] = ACTIONS(3562),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1198] = {
    [sym_heredoc_content] = STATE(1198),
    [anon_sym_SEMI] = ACTIONS(3566),
    [anon_sym_COMMA] = ACTIONS(3566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3566),
    [anon_sym_and] = ACTIONS(3568),
    [anon_sym_or] = ACTIONS(3568),
    [anon_sym_DASH_GT] = ACTIONS(3566),
    [anon_sym_PERCENT] = ACTIONS(3568),
    [anon_sym_LT] = ACTIONS(3568),
    [anon_sym_GT] = ACTIONS(3568),
    [anon_sym_LT_LT] = ACTIONS(3568),
    [anon_sym_EQ] = ACTIONS(3568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3566),
    [anon_sym_PLUS_EQ] = ACTIONS(3566),
    [anon_sym_DASH_EQ] = ACTIONS(3566),
    [anon_sym_DOT_EQ] = ACTIONS(3566),
    [anon_sym_STAR_EQ] = ACTIONS(3566),
    [anon_sym_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_PERCENT_EQ] = ACTIONS(3566),
    [anon_sym_x_EQ] = ACTIONS(3568),
    [anon_sym_AMP_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_CARET_EQ] = ACTIONS(3566),
    [anon_sym_LT_LT_EQ] = ACTIONS(3566),
    [anon_sym_GT_GT_EQ] = ACTIONS(3566),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_DOT_DOT] = ACTIONS(3568),
    [anon_sym_STAR_STAR] = ACTIONS(3568),
    [anon_sym_PIPE_PIPE] = ACTIONS(3568),
    [anon_sym_SLASH_SLASH] = ACTIONS(3568),
    [anon_sym_AMP_AMP] = ACTIONS(3568),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_AMP] = ACTIONS(3568),
    [anon_sym_GT_GT2] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3568),
    [anon_sym_DASH] = ACTIONS(3568),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(3568),
    [anon_sym_SLASH] = ACTIONS(3568),
    [anon_sym_x] = ACTIONS(3568),
    [anon_sym_EQ_TILDE] = ACTIONS(3566),
    [anon_sym_BANG_TILDE] = ACTIONS(3566),
    [anon_sym_EQ_EQ] = ACTIONS(3566),
    [anon_sym_BANG_EQ] = ACTIONS(3566),
    [anon_sym_eq] = ACTIONS(3568),
    [anon_sym_ne] = ACTIONS(3566),
    [anon_sym_LT_EQ_GT] = ACTIONS(3566),
    [anon_sym_cmp] = ACTIONS(3568),
    [anon_sym_TILDE_TILDE] = ACTIONS(3566),
    [anon_sym_LT_EQ] = ACTIONS(3568),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_lt] = ACTIONS(3568),
    [anon_sym_le] = ACTIONS(3568),
    [anon_sym_ge] = ACTIONS(3568),
    [anon_sym_gt] = ACTIONS(3568),
    [anon_sym_isa] = ACTIONS(3568),
    [anon_sym_PLUS_PLUS] = ACTIONS(3566),
    [anon_sym_DASH_DASH] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3566),
    [anon_sym_EQ_GT] = ACTIONS(3566),
    [anon_sym_for] = ACTIONS(3568),
    [anon_sym_foreach] = ACTIONS(3566),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3566),
    [anon_sym___END__] = ACTIONS(3566),
    [anon_sym_EOT] = ACTIONS(3566),
    [sym_substitution_regexp_modifiers] = ACTIONS(3570),
    [anon_sym_if] = ACTIONS(3568),
    [anon_sym_unless] = ACTIONS(3568),
    [anon_sym_while] = ACTIONS(3566),
    [anon_sym_until] = ACTIONS(3568),
    [sym__PERLY_SEMICOLON] = ACTIONS(3566),
    [sym__ctrl_z_hack] = ACTIONS(3566),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1199] = {
    [sym_heredoc_content] = STATE(1199),
    [anon_sym_SEMI] = ACTIONS(3572),
    [anon_sym_COMMA] = ACTIONS(3572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3572),
    [anon_sym_and] = ACTIONS(3572),
    [anon_sym_or] = ACTIONS(3572),
    [anon_sym_LBRACK] = ACTIONS(3574),
    [anon_sym_DASH_GT] = ACTIONS(3572),
    [anon_sym_PERCENT] = ACTIONS(3576),
    [anon_sym_LT] = ACTIONS(3576),
    [anon_sym_GT] = ACTIONS(3576),
    [anon_sym_LT_LT] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(3576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3572),
    [anon_sym_PLUS_EQ] = ACTIONS(3572),
    [anon_sym_DASH_EQ] = ACTIONS(3572),
    [anon_sym_DOT_EQ] = ACTIONS(3572),
    [anon_sym_STAR_EQ] = ACTIONS(3572),
    [anon_sym_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_PERCENT_EQ] = ACTIONS(3572),
    [anon_sym_x_EQ] = ACTIONS(3572),
    [anon_sym_AMP_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_CARET_EQ] = ACTIONS(3572),
    [anon_sym_LT_LT_EQ] = ACTIONS(3572),
    [anon_sym_GT_GT_EQ] = ACTIONS(3572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_DOT_DOT] = ACTIONS(3576),
    [anon_sym_STAR_STAR] = ACTIONS(3576),
    [anon_sym_PIPE_PIPE] = ACTIONS(3576),
    [anon_sym_SLASH_SLASH] = ACTIONS(3576),
    [anon_sym_AMP_AMP] = ACTIONS(3576),
    [anon_sym_PIPE] = ACTIONS(3576),
    [anon_sym_AMP] = ACTIONS(3576),
    [anon_sym_GT_GT2] = ACTIONS(3576),
    [anon_sym_PLUS] = ACTIONS(3576),
    [anon_sym_DASH] = ACTIONS(3576),
    [anon_sym_DOT] = ACTIONS(3576),
    [anon_sym_STAR] = ACTIONS(3576),
    [anon_sym_SLASH] = ACTIONS(3576),
    [anon_sym_x] = ACTIONS(3576),
    [anon_sym_EQ_TILDE] = ACTIONS(3572),
    [anon_sym_BANG_TILDE] = ACTIONS(3572),
    [anon_sym_EQ_EQ] = ACTIONS(3572),
    [anon_sym_BANG_EQ] = ACTIONS(3572),
    [anon_sym_eq] = ACTIONS(3572),
    [anon_sym_ne] = ACTIONS(3572),
    [anon_sym_LT_EQ_GT] = ACTIONS(3572),
    [anon_sym_cmp] = ACTIONS(3572),
    [anon_sym_TILDE_TILDE] = ACTIONS(3572),
    [anon_sym_LT_EQ] = ACTIONS(3576),
    [anon_sym_GT_EQ] = ACTIONS(3572),
    [anon_sym_lt] = ACTIONS(3572),
    [anon_sym_le] = ACTIONS(3572),
    [anon_sym_ge] = ACTIONS(3572),
    [anon_sym_gt] = ACTIONS(3572),
    [anon_sym_isa] = ACTIONS(3572),
    [anon_sym_PLUS_PLUS] = ACTIONS(3572),
    [anon_sym_DASH_DASH] = ACTIONS(3572),
    [anon_sym_QMARK] = ACTIONS(3572),
    [anon_sym_EQ_GT] = ACTIONS(3572),
    [anon_sym_for] = ACTIONS(3576),
    [anon_sym_foreach] = ACTIONS(3572),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3572),
    [anon_sym___END__] = ACTIONS(3572),
    [anon_sym_EOT] = ACTIONS(3572),
    [anon_sym_if] = ACTIONS(3572),
    [anon_sym_unless] = ACTIONS(3572),
    [anon_sym_while] = ACTIONS(3572),
    [anon_sym_until] = ACTIONS(3572),
    [sym__PERLY_SEMICOLON] = ACTIONS(3572),
    [sym__ctrl_z_hack] = ACTIONS(3572),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1200] = {
    [sym_heredoc_content] = STATE(1200),
    [anon_sym_SEMI] = ACTIONS(3578),
    [anon_sym_COMMA] = ACTIONS(3578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3578),
    [anon_sym_and] = ACTIONS(3580),
    [anon_sym_or] = ACTIONS(3580),
    [anon_sym_DASH_GT] = ACTIONS(3578),
    [anon_sym_PERCENT] = ACTIONS(3580),
    [anon_sym_LT] = ACTIONS(3580),
    [anon_sym_GT] = ACTIONS(3580),
    [anon_sym_LT_LT] = ACTIONS(3580),
    [anon_sym_EQ] = ACTIONS(3580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3578),
    [anon_sym_PLUS_EQ] = ACTIONS(3578),
    [anon_sym_DASH_EQ] = ACTIONS(3578),
    [anon_sym_DOT_EQ] = ACTIONS(3578),
    [anon_sym_STAR_EQ] = ACTIONS(3578),
    [anon_sym_SLASH_EQ] = ACTIONS(3578),
    [anon_sym_PERCENT_EQ] = ACTIONS(3578),
    [anon_sym_x_EQ] = ACTIONS(3580),
    [anon_sym_AMP_EQ] = ACTIONS(3578),
    [anon_sym_PIPE_EQ] = ACTIONS(3578),
    [anon_sym_CARET_EQ] = ACTIONS(3578),
    [anon_sym_LT_LT_EQ] = ACTIONS(3578),
    [anon_sym_GT_GT_EQ] = ACTIONS(3578),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3578),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3578),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3578),
    [anon_sym_DOT_DOT] = ACTIONS(3580),
    [anon_sym_STAR_STAR] = ACTIONS(3580),
    [anon_sym_PIPE_PIPE] = ACTIONS(3580),
    [anon_sym_SLASH_SLASH] = ACTIONS(3580),
    [anon_sym_AMP_AMP] = ACTIONS(3580),
    [anon_sym_PIPE] = ACTIONS(3580),
    [anon_sym_AMP] = ACTIONS(3580),
    [anon_sym_GT_GT2] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_DOT] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(3580),
    [anon_sym_SLASH] = ACTIONS(3580),
    [anon_sym_x] = ACTIONS(3580),
    [anon_sym_EQ_TILDE] = ACTIONS(3578),
    [anon_sym_BANG_TILDE] = ACTIONS(3578),
    [anon_sym_EQ_EQ] = ACTIONS(3578),
    [anon_sym_BANG_EQ] = ACTIONS(3578),
    [anon_sym_eq] = ACTIONS(3580),
    [anon_sym_ne] = ACTIONS(3578),
    [anon_sym_LT_EQ_GT] = ACTIONS(3578),
    [anon_sym_cmp] = ACTIONS(3580),
    [anon_sym_TILDE_TILDE] = ACTIONS(3578),
    [anon_sym_LT_EQ] = ACTIONS(3580),
    [anon_sym_GT_EQ] = ACTIONS(3578),
    [anon_sym_lt] = ACTIONS(3580),
    [anon_sym_le] = ACTIONS(3580),
    [anon_sym_ge] = ACTIONS(3580),
    [anon_sym_gt] = ACTIONS(3580),
    [anon_sym_isa] = ACTIONS(3580),
    [anon_sym_PLUS_PLUS] = ACTIONS(3578),
    [anon_sym_DASH_DASH] = ACTIONS(3578),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_EQ_GT] = ACTIONS(3578),
    [anon_sym_for] = ACTIONS(3580),
    [anon_sym_foreach] = ACTIONS(3578),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3578),
    [anon_sym___END__] = ACTIONS(3578),
    [anon_sym_EOT] = ACTIONS(3578),
    [sym_substitution_regexp_modifiers] = ACTIONS(3582),
    [anon_sym_if] = ACTIONS(3580),
    [anon_sym_unless] = ACTIONS(3580),
    [anon_sym_while] = ACTIONS(3578),
    [anon_sym_until] = ACTIONS(3580),
    [sym__PERLY_SEMICOLON] = ACTIONS(3578),
    [sym__ctrl_z_hack] = ACTIONS(3578),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1201] = {
    [sym_heredoc_content] = STATE(1201),
    [anon_sym_SEMI] = ACTIONS(3584),
    [anon_sym_COMMA] = ACTIONS(3584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3584),
    [anon_sym_and] = ACTIONS(3584),
    [anon_sym_or] = ACTIONS(3584),
    [anon_sym_DASH_GT] = ACTIONS(3584),
    [anon_sym_PERCENT] = ACTIONS(3586),
    [anon_sym_LT] = ACTIONS(3586),
    [anon_sym_GT] = ACTIONS(3586),
    [anon_sym_LT_LT] = ACTIONS(3586),
    [anon_sym_EQ] = ACTIONS(3586),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3584),
    [anon_sym_PLUS_EQ] = ACTIONS(3584),
    [anon_sym_DASH_EQ] = ACTIONS(3584),
    [anon_sym_DOT_EQ] = ACTIONS(3584),
    [anon_sym_STAR_EQ] = ACTIONS(3584),
    [anon_sym_SLASH_EQ] = ACTIONS(3584),
    [anon_sym_PERCENT_EQ] = ACTIONS(3584),
    [anon_sym_x_EQ] = ACTIONS(3584),
    [anon_sym_AMP_EQ] = ACTIONS(3584),
    [anon_sym_PIPE_EQ] = ACTIONS(3584),
    [anon_sym_CARET_EQ] = ACTIONS(3584),
    [anon_sym_LT_LT_EQ] = ACTIONS(3584),
    [anon_sym_GT_GT_EQ] = ACTIONS(3584),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3584),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3584),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3584),
    [anon_sym_DOT_DOT] = ACTIONS(3586),
    [anon_sym_STAR_STAR] = ACTIONS(3586),
    [anon_sym_PIPE_PIPE] = ACTIONS(3586),
    [anon_sym_SLASH_SLASH] = ACTIONS(3586),
    [anon_sym_AMP_AMP] = ACTIONS(3586),
    [anon_sym_PIPE] = ACTIONS(3586),
    [anon_sym_AMP] = ACTIONS(3586),
    [anon_sym_GT_GT2] = ACTIONS(3586),
    [anon_sym_PLUS] = ACTIONS(3586),
    [anon_sym_DASH] = ACTIONS(3586),
    [anon_sym_DOT] = ACTIONS(3586),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_SLASH] = ACTIONS(3586),
    [anon_sym_x] = ACTIONS(3586),
    [anon_sym_EQ_TILDE] = ACTIONS(3584),
    [anon_sym_BANG_TILDE] = ACTIONS(3584),
    [anon_sym_EQ_EQ] = ACTIONS(3584),
    [anon_sym_BANG_EQ] = ACTIONS(3584),
    [anon_sym_eq] = ACTIONS(3584),
    [anon_sym_ne] = ACTIONS(3584),
    [anon_sym_LT_EQ_GT] = ACTIONS(3584),
    [anon_sym_cmp] = ACTIONS(3586),
    [anon_sym_TILDE_TILDE] = ACTIONS(3584),
    [anon_sym_LT_EQ] = ACTIONS(3586),
    [anon_sym_GT_EQ] = ACTIONS(3584),
    [anon_sym_lt] = ACTIONS(3584),
    [anon_sym_le] = ACTIONS(3584),
    [anon_sym_ge] = ACTIONS(3584),
    [anon_sym_gt] = ACTIONS(3584),
    [anon_sym_isa] = ACTIONS(3584),
    [anon_sym_PLUS_PLUS] = ACTIONS(3584),
    [anon_sym_DASH_DASH] = ACTIONS(3584),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_EQ_GT] = ACTIONS(3584),
    [anon_sym_for] = ACTIONS(3586),
    [anon_sym_foreach] = ACTIONS(3584),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3584),
    [anon_sym___END__] = ACTIONS(3584),
    [anon_sym_EOT] = ACTIONS(3584),
    [sym_transliteration_modifiers] = ACTIONS(3588),
    [anon_sym_if] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(3584),
    [anon_sym_while] = ACTIONS(3584),
    [anon_sym_until] = ACTIONS(3584),
    [sym__PERLY_SEMICOLON] = ACTIONS(3584),
    [sym__ctrl_z_hack] = ACTIONS(3584),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1202] = {
    [sym_heredoc_content] = STATE(1202),
    [anon_sym_SEMI] = ACTIONS(3590),
    [anon_sym_LPAREN] = ACTIONS(3592),
    [anon_sym_COMMA] = ACTIONS(3590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3590),
    [anon_sym_and] = ACTIONS(3590),
    [anon_sym_or] = ACTIONS(3590),
    [anon_sym_DASH_GT] = ACTIONS(3590),
    [anon_sym_PERCENT] = ACTIONS(3594),
    [anon_sym_LT] = ACTIONS(3594),
    [anon_sym_GT] = ACTIONS(3594),
    [anon_sym_LT_LT] = ACTIONS(3594),
    [anon_sym_EQ] = ACTIONS(3594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3590),
    [anon_sym_PLUS_EQ] = ACTIONS(3590),
    [anon_sym_DASH_EQ] = ACTIONS(3590),
    [anon_sym_DOT_EQ] = ACTIONS(3590),
    [anon_sym_STAR_EQ] = ACTIONS(3590),
    [anon_sym_SLASH_EQ] = ACTIONS(3590),
    [anon_sym_PERCENT_EQ] = ACTIONS(3590),
    [anon_sym_x_EQ] = ACTIONS(3590),
    [anon_sym_AMP_EQ] = ACTIONS(3590),
    [anon_sym_PIPE_EQ] = ACTIONS(3590),
    [anon_sym_CARET_EQ] = ACTIONS(3590),
    [anon_sym_LT_LT_EQ] = ACTIONS(3590),
    [anon_sym_GT_GT_EQ] = ACTIONS(3590),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3590),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3590),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3590),
    [anon_sym_DOT_DOT] = ACTIONS(3594),
    [anon_sym_STAR_STAR] = ACTIONS(3594),
    [anon_sym_PIPE_PIPE] = ACTIONS(3594),
    [anon_sym_SLASH_SLASH] = ACTIONS(3594),
    [anon_sym_AMP_AMP] = ACTIONS(3594),
    [anon_sym_PIPE] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(3594),
    [anon_sym_GT_GT2] = ACTIONS(3594),
    [anon_sym_PLUS] = ACTIONS(3594),
    [anon_sym_DASH] = ACTIONS(3594),
    [anon_sym_DOT] = ACTIONS(3594),
    [anon_sym_STAR] = ACTIONS(3594),
    [anon_sym_SLASH] = ACTIONS(3594),
    [anon_sym_x] = ACTIONS(3594),
    [anon_sym_EQ_TILDE] = ACTIONS(3590),
    [anon_sym_BANG_TILDE] = ACTIONS(3590),
    [anon_sym_EQ_EQ] = ACTIONS(3590),
    [anon_sym_BANG_EQ] = ACTIONS(3590),
    [anon_sym_eq] = ACTIONS(3590),
    [anon_sym_ne] = ACTIONS(3590),
    [anon_sym_LT_EQ_GT] = ACTIONS(3590),
    [anon_sym_cmp] = ACTIONS(3590),
    [anon_sym_TILDE_TILDE] = ACTIONS(3590),
    [anon_sym_LT_EQ] = ACTIONS(3594),
    [anon_sym_GT_EQ] = ACTIONS(3590),
    [anon_sym_lt] = ACTIONS(3590),
    [anon_sym_le] = ACTIONS(3590),
    [anon_sym_ge] = ACTIONS(3590),
    [anon_sym_gt] = ACTIONS(3590),
    [anon_sym_isa] = ACTIONS(3590),
    [anon_sym_PLUS_PLUS] = ACTIONS(3590),
    [anon_sym_DASH_DASH] = ACTIONS(3590),
    [anon_sym_QMARK] = ACTIONS(3590),
    [anon_sym_EQ_GT] = ACTIONS(3590),
    [anon_sym_for] = ACTIONS(3594),
    [anon_sym_foreach] = ACTIONS(3590),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3590),
    [anon_sym___END__] = ACTIONS(3590),
    [anon_sym_EOT] = ACTIONS(3590),
    [anon_sym_if] = ACTIONS(3590),
    [anon_sym_unless] = ACTIONS(3590),
    [anon_sym_while] = ACTIONS(3590),
    [anon_sym_until] = ACTIONS(3590),
    [sym__PERLY_SEMICOLON] = ACTIONS(3590),
    [sym__ctrl_z_hack] = ACTIONS(3590),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1203] = {
    [sym_heredoc_content] = STATE(1203),
    [anon_sym_SEMI] = ACTIONS(3596),
    [anon_sym_LPAREN] = ACTIONS(3596),
    [anon_sym_COMMA] = ACTIONS(3596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_and] = ACTIONS(3596),
    [anon_sym_or] = ACTIONS(3596),
    [anon_sym_DASH_GT] = ACTIONS(3596),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_LT] = ACTIONS(3598),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_LT_LT] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3598),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3596),
    [anon_sym_PLUS_EQ] = ACTIONS(3596),
    [anon_sym_DASH_EQ] = ACTIONS(3596),
    [anon_sym_DOT_EQ] = ACTIONS(3596),
    [anon_sym_STAR_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_PERCENT_EQ] = ACTIONS(3596),
    [anon_sym_x_EQ] = ACTIONS(3596),
    [anon_sym_AMP_EQ] = ACTIONS(3596),
    [anon_sym_PIPE_EQ] = ACTIONS(3596),
    [anon_sym_CARET_EQ] = ACTIONS(3596),
    [anon_sym_LT_LT_EQ] = ACTIONS(3596),
    [anon_sym_GT_GT_EQ] = ACTIONS(3596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_DOT_DOT] = ACTIONS(3598),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_SLASH_SLASH] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3598),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_GT_GT2] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_STAR] = ACTIONS(3598),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_x] = ACTIONS(3598),
    [anon_sym_EQ_TILDE] = ACTIONS(3596),
    [anon_sym_BANG_TILDE] = ACTIONS(3596),
    [anon_sym_EQ_EQ] = ACTIONS(3596),
    [anon_sym_BANG_EQ] = ACTIONS(3596),
    [anon_sym_eq] = ACTIONS(3596),
    [anon_sym_ne] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3596),
    [anon_sym_cmp] = ACTIONS(3596),
    [anon_sym_TILDE_TILDE] = ACTIONS(3596),
    [anon_sym_LT_EQ] = ACTIONS(3598),
    [anon_sym_GT_EQ] = ACTIONS(3596),
    [anon_sym_lt] = ACTIONS(3596),
    [anon_sym_le] = ACTIONS(3596),
    [anon_sym_ge] = ACTIONS(3596),
    [anon_sym_gt] = ACTIONS(3596),
    [anon_sym_isa] = ACTIONS(3596),
    [anon_sym_PLUS_PLUS] = ACTIONS(3596),
    [anon_sym_DASH_DASH] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3596),
    [anon_sym_EQ_GT] = ACTIONS(3596),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_foreach] = ACTIONS(3596),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3596),
    [anon_sym___END__] = ACTIONS(3596),
    [anon_sym_EOT] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(3596),
    [anon_sym_unless] = ACTIONS(3596),
    [anon_sym_while] = ACTIONS(3596),
    [anon_sym_until] = ACTIONS(3596),
    [sym__PERLY_SEMICOLON] = ACTIONS(3596),
    [sym__ctrl_z_hack] = ACTIONS(3596),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1204] = {
    [sym_heredoc_content] = STATE(1204),
    [anon_sym_SEMI] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3600),
    [anon_sym_and] = ACTIONS(3602),
    [anon_sym_or] = ACTIONS(3600),
    [anon_sym_DASH_GT] = ACTIONS(3600),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_LT_LT] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3600),
    [anon_sym_PLUS_EQ] = ACTIONS(3600),
    [anon_sym_DASH_EQ] = ACTIONS(3600),
    [anon_sym_DOT_EQ] = ACTIONS(3600),
    [anon_sym_STAR_EQ] = ACTIONS(3600),
    [anon_sym_SLASH_EQ] = ACTIONS(3600),
    [anon_sym_PERCENT_EQ] = ACTIONS(3600),
    [anon_sym_x_EQ] = ACTIONS(3602),
    [anon_sym_AMP_EQ] = ACTIONS(3600),
    [anon_sym_PIPE_EQ] = ACTIONS(3600),
    [anon_sym_CARET_EQ] = ACTIONS(3600),
    [anon_sym_LT_LT_EQ] = ACTIONS(3600),
    [anon_sym_GT_GT_EQ] = ACTIONS(3600),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3600),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3600),
    [anon_sym_DOT_DOT] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_SLASH_SLASH] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_GT_GT2] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_STAR] = ACTIONS(3602),
    [anon_sym_SLASH] = ACTIONS(3602),
    [anon_sym_x] = ACTIONS(3602),
    [anon_sym_EQ_TILDE] = ACTIONS(3600),
    [anon_sym_BANG_TILDE] = ACTIONS(3600),
    [anon_sym_EQ_EQ] = ACTIONS(3600),
    [anon_sym_BANG_EQ] = ACTIONS(3600),
    [anon_sym_eq] = ACTIONS(3600),
    [anon_sym_ne] = ACTIONS(3602),
    [anon_sym_LT_EQ_GT] = ACTIONS(3600),
    [anon_sym_cmp] = ACTIONS(3602),
    [anon_sym_TILDE_TILDE] = ACTIONS(3600),
    [anon_sym_LT_EQ] = ACTIONS(3602),
    [anon_sym_GT_EQ] = ACTIONS(3600),
    [anon_sym_lt] = ACTIONS(3602),
    [anon_sym_le] = ACTIONS(3602),
    [anon_sym_ge] = ACTIONS(3602),
    [anon_sym_gt] = ACTIONS(3602),
    [anon_sym_isa] = ACTIONS(3602),
    [anon_sym_PLUS_PLUS] = ACTIONS(3600),
    [anon_sym_DASH_DASH] = ACTIONS(3600),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_foreach] = ACTIONS(3600),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3600),
    [anon_sym___END__] = ACTIONS(3600),
    [anon_sym_EOT] = ACTIONS(3600),
    [sym_match_regexp_modifiers] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_unless] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3600),
    [anon_sym_until] = ACTIONS(3602),
    [sym__PERLY_SEMICOLON] = ACTIONS(3600),
    [sym__ctrl_z_hack] = ACTIONS(3600),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1205] = {
    [sym_heredoc_content] = STATE(1205),
    [aux_sym__term_rightward_repeat1] = STATE(1205),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_COMMA] = ACTIONS(3608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_and] = ACTIONS(3606),
    [anon_sym_or] = ACTIONS(3606),
    [anon_sym_DASH_GT] = ACTIONS(3606),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_LT_LT] = ACTIONS(3611),
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3606),
    [anon_sym_PLUS_EQ] = ACTIONS(3606),
    [anon_sym_DASH_EQ] = ACTIONS(3606),
    [anon_sym_DOT_EQ] = ACTIONS(3606),
    [anon_sym_STAR_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_PERCENT_EQ] = ACTIONS(3606),
    [anon_sym_x_EQ] = ACTIONS(3606),
    [anon_sym_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_CARET_EQ] = ACTIONS(3606),
    [anon_sym_LT_LT_EQ] = ACTIONS(3606),
    [anon_sym_GT_GT_EQ] = ACTIONS(3606),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_DOT_DOT] = ACTIONS(3611),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(3611),
    [anon_sym_SLASH_SLASH] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_GT_GT2] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_x] = ACTIONS(3611),
    [anon_sym_EQ_TILDE] = ACTIONS(3606),
    [anon_sym_BANG_TILDE] = ACTIONS(3606),
    [anon_sym_EQ_EQ] = ACTIONS(3606),
    [anon_sym_BANG_EQ] = ACTIONS(3606),
    [anon_sym_eq] = ACTIONS(3606),
    [anon_sym_ne] = ACTIONS(3606),
    [anon_sym_LT_EQ_GT] = ACTIONS(3606),
    [anon_sym_cmp] = ACTIONS(3606),
    [anon_sym_TILDE_TILDE] = ACTIONS(3606),
    [anon_sym_LT_EQ] = ACTIONS(3611),
    [anon_sym_GT_EQ] = ACTIONS(3606),
    [anon_sym_lt] = ACTIONS(3606),
    [anon_sym_le] = ACTIONS(3606),
    [anon_sym_ge] = ACTIONS(3606),
    [anon_sym_gt] = ACTIONS(3606),
    [anon_sym_isa] = ACTIONS(3606),
    [anon_sym_PLUS_PLUS] = ACTIONS(3606),
    [anon_sym_DASH_DASH] = ACTIONS(3606),
    [anon_sym_QMARK] = ACTIONS(3606),
    [anon_sym_EQ_GT] = ACTIONS(3608),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_foreach] = ACTIONS(3606),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3606),
    [anon_sym___END__] = ACTIONS(3606),
    [anon_sym_EOT] = ACTIONS(3606),
    [anon_sym_if] = ACTIONS(3606),
    [anon_sym_unless] = ACTIONS(3606),
    [anon_sym_while] = ACTIONS(3606),
    [anon_sym_until] = ACTIONS(3606),
    [sym__PERLY_SEMICOLON] = ACTIONS(3606),
    [sym__ctrl_z_hack] = ACTIONS(3606),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1206] = {
    [sym_heredoc_content] = STATE(1206),
    [anon_sym_COLON] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_COMMA] = ACTIONS(3613),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3613),
    [anon_sym_and] = ACTIONS(3613),
    [anon_sym_or] = ACTIONS(3613),
    [anon_sym_DASH_GT] = ACTIONS(3613),
    [anon_sym_PERCENT] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_LT_LT] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3615),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3613),
    [anon_sym_PLUS_EQ] = ACTIONS(3613),
    [anon_sym_DASH_EQ] = ACTIONS(3613),
    [anon_sym_DOT_EQ] = ACTIONS(3613),
    [anon_sym_STAR_EQ] = ACTIONS(3613),
    [anon_sym_SLASH_EQ] = ACTIONS(3613),
    [anon_sym_PERCENT_EQ] = ACTIONS(3613),
    [anon_sym_x_EQ] = ACTIONS(3613),
    [anon_sym_AMP_EQ] = ACTIONS(3613),
    [anon_sym_PIPE_EQ] = ACTIONS(3613),
    [anon_sym_CARET_EQ] = ACTIONS(3613),
    [anon_sym_LT_LT_EQ] = ACTIONS(3613),
    [anon_sym_GT_GT_EQ] = ACTIONS(3613),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3613),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3613),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3613),
    [anon_sym_DOT_DOT] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3615),
    [anon_sym_PIPE_PIPE] = ACTIONS(3615),
    [anon_sym_SLASH_SLASH] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_GT_GT2] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DOT] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_SLASH] = ACTIONS(3615),
    [anon_sym_x] = ACTIONS(3615),
    [anon_sym_EQ_TILDE] = ACTIONS(3613),
    [anon_sym_BANG_TILDE] = ACTIONS(3613),
    [anon_sym_EQ_EQ] = ACTIONS(3613),
    [anon_sym_BANG_EQ] = ACTIONS(3613),
    [anon_sym_eq] = ACTIONS(3613),
    [anon_sym_ne] = ACTIONS(3613),
    [anon_sym_LT_EQ_GT] = ACTIONS(3613),
    [anon_sym_cmp] = ACTIONS(3613),
    [anon_sym_TILDE_TILDE] = ACTIONS(3613),
    [anon_sym_LT_EQ] = ACTIONS(3615),
    [anon_sym_GT_EQ] = ACTIONS(3613),
    [anon_sym_lt] = ACTIONS(3613),
    [anon_sym_le] = ACTIONS(3613),
    [anon_sym_ge] = ACTIONS(3613),
    [anon_sym_gt] = ACTIONS(3613),
    [anon_sym_isa] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_EQ_GT] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_foreach] = ACTIONS(3613),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3613),
    [anon_sym___END__] = ACTIONS(3613),
    [anon_sym_EOT] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_unless] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_until] = ACTIONS(3613),
    [sym__PERLY_SEMICOLON] = ACTIONS(3613),
    [sym__ctrl_z_hack] = ACTIONS(3613),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1207] = {
    [sym_heredoc_content] = STATE(1207),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_and] = ACTIONS(3617),
    [anon_sym_or] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3619),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_LT_LT] = ACTIONS(3619),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DOT_EQ] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_x_EQ] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_DOT_DOT] = ACTIONS(3619),
    [anon_sym_STAR_STAR] = ACTIONS(3619),
    [anon_sym_PIPE_PIPE] = ACTIONS(3619),
    [anon_sym_SLASH_SLASH] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_PIPE] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_GT_GT2] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_DOT] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(3619),
    [anon_sym_x] = ACTIONS(3619),
    [anon_sym_EQ_TILDE] = ACTIONS(3617),
    [anon_sym_BANG_TILDE] = ACTIONS(3617),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_eq] = ACTIONS(3617),
    [anon_sym_ne] = ACTIONS(3617),
    [anon_sym_LT_EQ_GT] = ACTIONS(3617),
    [anon_sym_cmp] = ACTIONS(3619),
    [anon_sym_TILDE_TILDE] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_lt] = ACTIONS(3617),
    [anon_sym_le] = ACTIONS(3617),
    [anon_sym_ge] = ACTIONS(3617),
    [anon_sym_gt] = ACTIONS(3617),
    [anon_sym_isa] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_foreach] = ACTIONS(3617),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3617),
    [anon_sym___END__] = ACTIONS(3617),
    [anon_sym_EOT] = ACTIONS(3617),
    [sym_transliteration_modifiers] = ACTIONS(3621),
    [anon_sym_if] = ACTIONS(3617),
    [anon_sym_unless] = ACTIONS(3617),
    [anon_sym_while] = ACTIONS(3617),
    [anon_sym_until] = ACTIONS(3617),
    [sym__PERLY_SEMICOLON] = ACTIONS(3617),
    [sym__ctrl_z_hack] = ACTIONS(3617),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1208] = {
    [sym_heredoc_content] = STATE(1208),
    [aux_sym__term_rightward_repeat1] = STATE(1205),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym_COMMA] = ACTIONS(3625),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3623),
    [anon_sym_and] = ACTIONS(3623),
    [anon_sym_or] = ACTIONS(3623),
    [anon_sym_DASH_GT] = ACTIONS(3623),
    [anon_sym_PERCENT] = ACTIONS(3627),
    [anon_sym_LT] = ACTIONS(3627),
    [anon_sym_GT] = ACTIONS(3627),
    [anon_sym_LT_LT] = ACTIONS(3627),
    [anon_sym_EQ] = ACTIONS(3627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3623),
    [anon_sym_PLUS_EQ] = ACTIONS(3623),
    [anon_sym_DASH_EQ] = ACTIONS(3623),
    [anon_sym_DOT_EQ] = ACTIONS(3623),
    [anon_sym_STAR_EQ] = ACTIONS(3623),
    [anon_sym_SLASH_EQ] = ACTIONS(3623),
    [anon_sym_PERCENT_EQ] = ACTIONS(3623),
    [anon_sym_x_EQ] = ACTIONS(3623),
    [anon_sym_AMP_EQ] = ACTIONS(3623),
    [anon_sym_PIPE_EQ] = ACTIONS(3623),
    [anon_sym_CARET_EQ] = ACTIONS(3623),
    [anon_sym_LT_LT_EQ] = ACTIONS(3623),
    [anon_sym_GT_GT_EQ] = ACTIONS(3623),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3623),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3623),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3623),
    [anon_sym_DOT_DOT] = ACTIONS(3627),
    [anon_sym_STAR_STAR] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3627),
    [anon_sym_SLASH_SLASH] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_PIPE] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_GT_GT2] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DOT] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(3627),
    [anon_sym_x] = ACTIONS(3627),
    [anon_sym_EQ_TILDE] = ACTIONS(3623),
    [anon_sym_BANG_TILDE] = ACTIONS(3623),
    [anon_sym_EQ_EQ] = ACTIONS(3623),
    [anon_sym_BANG_EQ] = ACTIONS(3623),
    [anon_sym_eq] = ACTIONS(3623),
    [anon_sym_ne] = ACTIONS(3623),
    [anon_sym_LT_EQ_GT] = ACTIONS(3623),
    [anon_sym_cmp] = ACTIONS(3623),
    [anon_sym_TILDE_TILDE] = ACTIONS(3623),
    [anon_sym_LT_EQ] = ACTIONS(3627),
    [anon_sym_GT_EQ] = ACTIONS(3623),
    [anon_sym_lt] = ACTIONS(3623),
    [anon_sym_le] = ACTIONS(3623),
    [anon_sym_ge] = ACTIONS(3623),
    [anon_sym_gt] = ACTIONS(3623),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_QMARK] = ACTIONS(3623),
    [anon_sym_EQ_GT] = ACTIONS(3625),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_foreach] = ACTIONS(3623),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3623),
    [anon_sym___END__] = ACTIONS(3623),
    [anon_sym_EOT] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_unless] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_until] = ACTIONS(3623),
    [sym__PERLY_SEMICOLON] = ACTIONS(3623),
    [sym__ctrl_z_hack] = ACTIONS(3623),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1209] = {
    [sym__decl_variable_list] = STATE(1515),
    [sym__declare_scalar] = STATE(1516),
    [sym__declare_array] = STATE(1516),
    [sym__declare_hash] = STATE(1516),
    [sym_heredoc_content] = STATE(1209),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DOLLAR] = ACTIONS(3631),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_AT] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_PERCENT2] = ACTIONS(3635),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1210] = {
    [sym_heredoc_content] = STATE(1210),
    [anon_sym_SEMI] = ACTIONS(3637),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3637),
    [anon_sym_and] = ACTIONS(3637),
    [anon_sym_or] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3574),
    [anon_sym_DASH_GT] = ACTIONS(3637),
    [anon_sym_PERCENT] = ACTIONS(3639),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_LT_LT] = ACTIONS(3639),
    [anon_sym_EQ] = ACTIONS(3639),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3637),
    [anon_sym_PLUS_EQ] = ACTIONS(3637),
    [anon_sym_DASH_EQ] = ACTIONS(3637),
    [anon_sym_DOT_EQ] = ACTIONS(3637),
    [anon_sym_STAR_EQ] = ACTIONS(3637),
    [anon_sym_SLASH_EQ] = ACTIONS(3637),
    [anon_sym_PERCENT_EQ] = ACTIONS(3637),
    [anon_sym_x_EQ] = ACTIONS(3637),
    [anon_sym_AMP_EQ] = ACTIONS(3637),
    [anon_sym_PIPE_EQ] = ACTIONS(3637),
    [anon_sym_CARET_EQ] = ACTIONS(3637),
    [anon_sym_LT_LT_EQ] = ACTIONS(3637),
    [anon_sym_GT_GT_EQ] = ACTIONS(3637),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3637),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3637),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3637),
    [anon_sym_DOT_DOT] = ACTIONS(3639),
    [anon_sym_STAR_STAR] = ACTIONS(3639),
    [anon_sym_PIPE_PIPE] = ACTIONS(3639),
    [anon_sym_SLASH_SLASH] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_GT_GT2] = ACTIONS(3639),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_DOT] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [anon_sym_x] = ACTIONS(3639),
    [anon_sym_EQ_TILDE] = ACTIONS(3637),
    [anon_sym_BANG_TILDE] = ACTIONS(3637),
    [anon_sym_EQ_EQ] = ACTIONS(3637),
    [anon_sym_BANG_EQ] = ACTIONS(3637),
    [anon_sym_eq] = ACTIONS(3637),
    [anon_sym_ne] = ACTIONS(3637),
    [anon_sym_LT_EQ_GT] = ACTIONS(3637),
    [anon_sym_cmp] = ACTIONS(3637),
    [anon_sym_TILDE_TILDE] = ACTIONS(3637),
    [anon_sym_LT_EQ] = ACTIONS(3639),
    [anon_sym_GT_EQ] = ACTIONS(3637),
    [anon_sym_lt] = ACTIONS(3637),
    [anon_sym_le] = ACTIONS(3637),
    [anon_sym_ge] = ACTIONS(3637),
    [anon_sym_gt] = ACTIONS(3637),
    [anon_sym_isa] = ACTIONS(3637),
    [anon_sym_PLUS_PLUS] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3637),
    [anon_sym_QMARK] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3639),
    [anon_sym_foreach] = ACTIONS(3637),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3637),
    [anon_sym___END__] = ACTIONS(3637),
    [anon_sym_EOT] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_unless] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_until] = ACTIONS(3637),
    [sym__PERLY_SEMICOLON] = ACTIONS(3637),
    [sym__ctrl_z_hack] = ACTIONS(3637),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1211] = {
    [sym_heredoc_content] = STATE(1211),
    [anon_sym_COLON] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3641),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3641),
    [anon_sym_and] = ACTIONS(3641),
    [anon_sym_or] = ACTIONS(3641),
    [anon_sym_DASH_GT] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3643),
    [anon_sym_LT] = ACTIONS(3643),
    [anon_sym_GT] = ACTIONS(3643),
    [anon_sym_LT_LT] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(3643),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3641),
    [anon_sym_PLUS_EQ] = ACTIONS(3641),
    [anon_sym_DASH_EQ] = ACTIONS(3641),
    [anon_sym_DOT_EQ] = ACTIONS(3641),
    [anon_sym_STAR_EQ] = ACTIONS(3641),
    [anon_sym_SLASH_EQ] = ACTIONS(3641),
    [anon_sym_PERCENT_EQ] = ACTIONS(3641),
    [anon_sym_x_EQ] = ACTIONS(3641),
    [anon_sym_AMP_EQ] = ACTIONS(3641),
    [anon_sym_PIPE_EQ] = ACTIONS(3641),
    [anon_sym_CARET_EQ] = ACTIONS(3641),
    [anon_sym_LT_LT_EQ] = ACTIONS(3641),
    [anon_sym_GT_GT_EQ] = ACTIONS(3641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3641),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3641),
    [anon_sym_DOT_DOT] = ACTIONS(3643),
    [anon_sym_STAR_STAR] = ACTIONS(3643),
    [anon_sym_PIPE_PIPE] = ACTIONS(3643),
    [anon_sym_SLASH_SLASH] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_PIPE] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_GT_GT2] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3643),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_SLASH] = ACTIONS(3643),
    [anon_sym_x] = ACTIONS(3643),
    [anon_sym_EQ_TILDE] = ACTIONS(3641),
    [anon_sym_BANG_TILDE] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BANG_EQ] = ACTIONS(3641),
    [anon_sym_eq] = ACTIONS(3641),
    [anon_sym_ne] = ACTIONS(3641),
    [anon_sym_LT_EQ_GT] = ACTIONS(3641),
    [anon_sym_cmp] = ACTIONS(3641),
    [anon_sym_TILDE_TILDE] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3643),
    [anon_sym_GT_EQ] = ACTIONS(3641),
    [anon_sym_lt] = ACTIONS(3641),
    [anon_sym_le] = ACTIONS(3641),
    [anon_sym_ge] = ACTIONS(3641),
    [anon_sym_gt] = ACTIONS(3641),
    [anon_sym_isa] = ACTIONS(3641),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_EQ_GT] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3643),
    [anon_sym_foreach] = ACTIONS(3641),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3641),
    [anon_sym___END__] = ACTIONS(3641),
    [anon_sym_EOT] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_unless] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_until] = ACTIONS(3641),
    [sym__PERLY_SEMICOLON] = ACTIONS(3641),
    [sym__ctrl_z_hack] = ACTIONS(3641),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1212] = {
    [sym_heredoc_content] = STATE(1212),
    [aux_sym__term_rightward_repeat1] = STATE(2054),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3650),
    [anon_sym_and] = ACTIONS(3645),
    [anon_sym_or] = ACTIONS(3645),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3662),
    [anon_sym_DASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_EQ] = ACTIONS(3662),
    [anon_sym_STAR_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_PERCENT_EQ] = ACTIONS(3662),
    [anon_sym_x_EQ] = ACTIONS(3662),
    [anon_sym_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_CARET_EQ] = ACTIONS(3662),
    [anon_sym_LT_LT_EQ] = ACTIONS(3662),
    [anon_sym_GT_GT_EQ] = ACTIONS(3662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_SLASH_SLASH] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3690),
    [anon_sym_EQ_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3692),
    [anon_sym_foreach] = ACTIONS(3645),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3645),
    [anon_sym___END__] = ACTIONS(3645),
    [anon_sym_EOT] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_unless] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_until] = ACTIONS(3645),
    [sym__PERLY_SEMICOLON] = ACTIONS(3645),
    [sym__ctrl_z_hack] = ACTIONS(3645),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1213] = {
    [sym_heredoc_content] = STATE(1213),
    [anon_sym_SEMI] = ACTIONS(3695),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3695),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3695),
    [anon_sym_DASH_GT] = ACTIONS(3695),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3695),
    [anon_sym_PLUS_EQ] = ACTIONS(3695),
    [anon_sym_DASH_EQ] = ACTIONS(3695),
    [anon_sym_DOT_EQ] = ACTIONS(3695),
    [anon_sym_STAR_EQ] = ACTIONS(3695),
    [anon_sym_SLASH_EQ] = ACTIONS(3695),
    [anon_sym_PERCENT_EQ] = ACTIONS(3695),
    [anon_sym_x_EQ] = ACTIONS(3697),
    [anon_sym_AMP_EQ] = ACTIONS(3695),
    [anon_sym_PIPE_EQ] = ACTIONS(3695),
    [anon_sym_CARET_EQ] = ACTIONS(3695),
    [anon_sym_LT_LT_EQ] = ACTIONS(3695),
    [anon_sym_GT_GT_EQ] = ACTIONS(3695),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3695),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3695),
    [anon_sym_DOT_DOT] = ACTIONS(3697),
    [anon_sym_STAR_STAR] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_SLASH_SLASH] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_GT_GT2] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_x] = ACTIONS(3697),
    [anon_sym_EQ_TILDE] = ACTIONS(3695),
    [anon_sym_BANG_TILDE] = ACTIONS(3695),
    [anon_sym_EQ_EQ] = ACTIONS(3695),
    [anon_sym_BANG_EQ] = ACTIONS(3695),
    [anon_sym_eq] = ACTIONS(3695),
    [anon_sym_ne] = ACTIONS(3697),
    [anon_sym_LT_EQ_GT] = ACTIONS(3695),
    [anon_sym_cmp] = ACTIONS(3695),
    [anon_sym_TILDE_TILDE] = ACTIONS(3695),
    [anon_sym_LT_EQ] = ACTIONS(3697),
    [anon_sym_GT_EQ] = ACTIONS(3695),
    [anon_sym_lt] = ACTIONS(3697),
    [anon_sym_le] = ACTIONS(3697),
    [anon_sym_ge] = ACTIONS(3695),
    [anon_sym_gt] = ACTIONS(3695),
    [anon_sym_isa] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3695),
    [anon_sym_QMARK] = ACTIONS(3695),
    [anon_sym_EQ_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_foreach] = ACTIONS(3695),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3695),
    [anon_sym___END__] = ACTIONS(3695),
    [anon_sym_EOT] = ACTIONS(3695),
    [sym_quoted_regexp_modifiers] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_unless] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_until] = ACTIONS(3697),
    [sym__PERLY_SEMICOLON] = ACTIONS(3695),
    [sym__ctrl_z_hack] = ACTIONS(3695),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1214] = {
    [sym_heredoc_content] = STATE(1214),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3701),
    [anon_sym_and] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(3703),
    [anon_sym_LT_LT] = ACTIONS(3703),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3701),
    [anon_sym_DASH_EQ] = ACTIONS(3701),
    [anon_sym_DOT_EQ] = ACTIONS(3701),
    [anon_sym_STAR_EQ] = ACTIONS(3701),
    [anon_sym_SLASH_EQ] = ACTIONS(3701),
    [anon_sym_PERCENT_EQ] = ACTIONS(3701),
    [anon_sym_x_EQ] = ACTIONS(3703),
    [anon_sym_AMP_EQ] = ACTIONS(3701),
    [anon_sym_PIPE_EQ] = ACTIONS(3701),
    [anon_sym_CARET_EQ] = ACTIONS(3701),
    [anon_sym_LT_LT_EQ] = ACTIONS(3701),
    [anon_sym_GT_GT_EQ] = ACTIONS(3701),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3701),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3701),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_STAR_STAR] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH] = ACTIONS(3703),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_GT_GT2] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3703),
    [anon_sym_SLASH] = ACTIONS(3703),
    [anon_sym_x] = ACTIONS(3703),
    [anon_sym_EQ_TILDE] = ACTIONS(3701),
    [anon_sym_BANG_TILDE] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_eq] = ACTIONS(3701),
    [anon_sym_ne] = ACTIONS(3703),
    [anon_sym_LT_EQ_GT] = ACTIONS(3701),
    [anon_sym_cmp] = ACTIONS(3701),
    [anon_sym_TILDE_TILDE] = ACTIONS(3701),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3701),
    [anon_sym_lt] = ACTIONS(3703),
    [anon_sym_le] = ACTIONS(3703),
    [anon_sym_ge] = ACTIONS(3701),
    [anon_sym_gt] = ACTIONS(3701),
    [anon_sym_isa] = ACTIONS(3703),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_EQ_GT] = ACTIONS(3701),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_foreach] = ACTIONS(3701),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3701),
    [anon_sym___END__] = ACTIONS(3701),
    [anon_sym_EOT] = ACTIONS(3701),
    [sym_quoted_regexp_modifiers] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_unless] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_until] = ACTIONS(3703),
    [sym__PERLY_SEMICOLON] = ACTIONS(3701),
    [sym__ctrl_z_hack] = ACTIONS(3701),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1215] = {
    [sym_heredoc_content] = STATE(1215),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3707),
    [anon_sym_and] = ACTIONS(3709),
    [anon_sym_or] = ACTIONS(3709),
    [anon_sym_DASH_GT] = ACTIONS(3707),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3709),
    [anon_sym_GT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3707),
    [anon_sym_PLUS_EQ] = ACTIONS(3707),
    [anon_sym_DASH_EQ] = ACTIONS(3707),
    [anon_sym_DOT_EQ] = ACTIONS(3707),
    [anon_sym_STAR_EQ] = ACTIONS(3707),
    [anon_sym_SLASH_EQ] = ACTIONS(3707),
    [anon_sym_PERCENT_EQ] = ACTIONS(3707),
    [anon_sym_x_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3707),
    [anon_sym_PIPE_EQ] = ACTIONS(3707),
    [anon_sym_CARET_EQ] = ACTIONS(3707),
    [anon_sym_LT_LT_EQ] = ACTIONS(3707),
    [anon_sym_GT_GT_EQ] = ACTIONS(3707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_SLASH_SLASH] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_GT_GT2] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_SLASH] = ACTIONS(3709),
    [anon_sym_x] = ACTIONS(3709),
    [anon_sym_EQ_TILDE] = ACTIONS(3707),
    [anon_sym_BANG_TILDE] = ACTIONS(3707),
    [anon_sym_EQ_EQ] = ACTIONS(3707),
    [anon_sym_BANG_EQ] = ACTIONS(3707),
    [anon_sym_eq] = ACTIONS(3709),
    [anon_sym_ne] = ACTIONS(3707),
    [anon_sym_LT_EQ_GT] = ACTIONS(3707),
    [anon_sym_cmp] = ACTIONS(3709),
    [anon_sym_TILDE_TILDE] = ACTIONS(3707),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3707),
    [anon_sym_lt] = ACTIONS(3709),
    [anon_sym_le] = ACTIONS(3709),
    [anon_sym_ge] = ACTIONS(3709),
    [anon_sym_gt] = ACTIONS(3709),
    [anon_sym_isa] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_QMARK] = ACTIONS(3707),
    [anon_sym_EQ_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_foreach] = ACTIONS(3707),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3707),
    [anon_sym___END__] = ACTIONS(3707),
    [anon_sym_EOT] = ACTIONS(3707),
    [sym_substitution_regexp_modifiers] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_unless] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3707),
    [anon_sym_until] = ACTIONS(3709),
    [sym__PERLY_SEMICOLON] = ACTIONS(3707),
    [sym__ctrl_z_hack] = ACTIONS(3707),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1216] = {
    [sym_heredoc_content] = STATE(1216),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3713),
    [anon_sym_and] = ACTIONS(3713),
    [anon_sym_or] = ACTIONS(3713),
    [anon_sym_DASH_GT] = ACTIONS(3713),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3713),
    [anon_sym_PLUS_EQ] = ACTIONS(3713),
    [anon_sym_DASH_EQ] = ACTIONS(3713),
    [anon_sym_DOT_EQ] = ACTIONS(3713),
    [anon_sym_STAR_EQ] = ACTIONS(3713),
    [anon_sym_SLASH_EQ] = ACTIONS(3713),
    [anon_sym_PERCENT_EQ] = ACTIONS(3713),
    [anon_sym_x_EQ] = ACTIONS(3713),
    [anon_sym_AMP_EQ] = ACTIONS(3713),
    [anon_sym_PIPE_EQ] = ACTIONS(3713),
    [anon_sym_CARET_EQ] = ACTIONS(3713),
    [anon_sym_LT_LT_EQ] = ACTIONS(3713),
    [anon_sym_GT_GT_EQ] = ACTIONS(3713),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3713),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3713),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3713),
    [anon_sym_DOT_DOT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_SLASH_SLASH] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_GT_GT2] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_x] = ACTIONS(3715),
    [anon_sym_EQ_TILDE] = ACTIONS(3713),
    [anon_sym_BANG_TILDE] = ACTIONS(3713),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_eq] = ACTIONS(3713),
    [anon_sym_ne] = ACTIONS(3713),
    [anon_sym_LT_EQ_GT] = ACTIONS(3713),
    [anon_sym_cmp] = ACTIONS(3715),
    [anon_sym_TILDE_TILDE] = ACTIONS(3713),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3713),
    [anon_sym_lt] = ACTIONS(3713),
    [anon_sym_le] = ACTIONS(3713),
    [anon_sym_ge] = ACTIONS(3713),
    [anon_sym_gt] = ACTIONS(3713),
    [anon_sym_isa] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_EQ_GT] = ACTIONS(3713),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_foreach] = ACTIONS(3713),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3713),
    [anon_sym___END__] = ACTIONS(3713),
    [anon_sym_EOT] = ACTIONS(3713),
    [sym_transliteration_modifiers] = ACTIONS(3717),
    [anon_sym_if] = ACTIONS(3713),
    [anon_sym_unless] = ACTIONS(3713),
    [anon_sym_while] = ACTIONS(3713),
    [anon_sym_until] = ACTIONS(3713),
    [sym__PERLY_SEMICOLON] = ACTIONS(3713),
    [sym__ctrl_z_hack] = ACTIONS(3713),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1217] = {
    [sym_heredoc_content] = STATE(1217),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_DOT_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_x_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3721),
    [anon_sym_STAR_STAR] = ACTIONS(3721),
    [anon_sym_PIPE_PIPE] = ACTIONS(3721),
    [anon_sym_SLASH_SLASH] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_GT_GT2] = ACTIONS(3721),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_x] = ACTIONS(3721),
    [anon_sym_EQ_TILDE] = ACTIONS(3719),
    [anon_sym_BANG_TILDE] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_eq] = ACTIONS(3719),
    [anon_sym_ne] = ACTIONS(3719),
    [anon_sym_LT_EQ_GT] = ACTIONS(3719),
    [anon_sym_cmp] = ACTIONS(3719),
    [anon_sym_TILDE_TILDE] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3721),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_lt] = ACTIONS(3719),
    [anon_sym_le] = ACTIONS(3719),
    [anon_sym_ge] = ACTIONS(3719),
    [anon_sym_gt] = ACTIONS(3719),
    [anon_sym_isa] = ACTIONS(3719),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3721),
    [anon_sym_foreach] = ACTIONS(3719),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3719),
    [anon_sym___END__] = ACTIONS(3719),
    [anon_sym_EOT] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_unless] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_until] = ACTIONS(3719),
    [sym__PERLY_SEMICOLON] = ACTIONS(3719),
    [sym__ctrl_z_hack] = ACTIONS(3719),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1218] = {
    [sym_heredoc_content] = STATE(1218),
    [anon_sym_COLON] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_COMMA] = ACTIONS(3725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3725),
    [anon_sym_and] = ACTIONS(3725),
    [anon_sym_or] = ACTIONS(3725),
    [anon_sym_DASH_GT] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_EQ] = ACTIONS(3727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3725),
    [anon_sym_PLUS_EQ] = ACTIONS(3725),
    [anon_sym_DASH_EQ] = ACTIONS(3725),
    [anon_sym_DOT_EQ] = ACTIONS(3725),
    [anon_sym_STAR_EQ] = ACTIONS(3725),
    [anon_sym_SLASH_EQ] = ACTIONS(3725),
    [anon_sym_PERCENT_EQ] = ACTIONS(3725),
    [anon_sym_x_EQ] = ACTIONS(3725),
    [anon_sym_AMP_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_EQ] = ACTIONS(3725),
    [anon_sym_CARET_EQ] = ACTIONS(3725),
    [anon_sym_LT_LT_EQ] = ACTIONS(3725),
    [anon_sym_GT_GT_EQ] = ACTIONS(3725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3725),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3725),
    [anon_sym_DOT_DOT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_SLASH_SLASH] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3727),
    [anon_sym_GT_GT2] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_SLASH] = ACTIONS(3727),
    [anon_sym_x] = ACTIONS(3727),
    [anon_sym_EQ_TILDE] = ACTIONS(3725),
    [anon_sym_BANG_TILDE] = ACTIONS(3725),
    [anon_sym_EQ_EQ] = ACTIONS(3725),
    [anon_sym_BANG_EQ] = ACTIONS(3725),
    [anon_sym_eq] = ACTIONS(3725),
    [anon_sym_ne] = ACTIONS(3725),
    [anon_sym_LT_EQ_GT] = ACTIONS(3725),
    [anon_sym_cmp] = ACTIONS(3725),
    [anon_sym_TILDE_TILDE] = ACTIONS(3725),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3725),
    [anon_sym_lt] = ACTIONS(3725),
    [anon_sym_le] = ACTIONS(3725),
    [anon_sym_ge] = ACTIONS(3725),
    [anon_sym_gt] = ACTIONS(3725),
    [anon_sym_isa] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3725),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_foreach] = ACTIONS(3725),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3725),
    [anon_sym___END__] = ACTIONS(3725),
    [anon_sym_EOT] = ACTIONS(3725),
    [anon_sym_if] = ACTIONS(3725),
    [anon_sym_unless] = ACTIONS(3725),
    [anon_sym_while] = ACTIONS(3725),
    [anon_sym_until] = ACTIONS(3725),
    [sym__PERLY_SEMICOLON] = ACTIONS(3725),
    [sym__ctrl_z_hack] = ACTIONS(3725),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1219] = {
    [sym_heredoc_content] = STATE(1219),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3729),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_or] = ACTIONS(3729),
    [anon_sym_DASH_GT] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3731),
    [anon_sym_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3731),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3729),
    [anon_sym_PLUS_EQ] = ACTIONS(3729),
    [anon_sym_DASH_EQ] = ACTIONS(3729),
    [anon_sym_DOT_EQ] = ACTIONS(3729),
    [anon_sym_STAR_EQ] = ACTIONS(3729),
    [anon_sym_SLASH_EQ] = ACTIONS(3729),
    [anon_sym_PERCENT_EQ] = ACTIONS(3729),
    [anon_sym_x_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3729),
    [anon_sym_PIPE_EQ] = ACTIONS(3729),
    [anon_sym_CARET_EQ] = ACTIONS(3729),
    [anon_sym_LT_LT_EQ] = ACTIONS(3729),
    [anon_sym_GT_GT_EQ] = ACTIONS(3729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3729),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3729),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3729),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_SLASH_SLASH] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_GT_GT2] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3731),
    [anon_sym_SLASH] = ACTIONS(3731),
    [anon_sym_x] = ACTIONS(3731),
    [anon_sym_EQ_TILDE] = ACTIONS(3729),
    [anon_sym_BANG_TILDE] = ACTIONS(3729),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_eq] = ACTIONS(3729),
    [anon_sym_ne] = ACTIONS(3731),
    [anon_sym_LT_EQ_GT] = ACTIONS(3729),
    [anon_sym_cmp] = ACTIONS(3731),
    [anon_sym_TILDE_TILDE] = ACTIONS(3729),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3729),
    [anon_sym_lt] = ACTIONS(3731),
    [anon_sym_le] = ACTIONS(3731),
    [anon_sym_ge] = ACTIONS(3731),
    [anon_sym_gt] = ACTIONS(3731),
    [anon_sym_isa] = ACTIONS(3731),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_QMARK] = ACTIONS(3729),
    [anon_sym_EQ_GT] = ACTIONS(3729),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_foreach] = ACTIONS(3729),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3729),
    [anon_sym___END__] = ACTIONS(3729),
    [anon_sym_EOT] = ACTIONS(3729),
    [sym_match_regexp_modifiers] = ACTIONS(3733),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_unless] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3729),
    [anon_sym_until] = ACTIONS(3731),
    [sym__PERLY_SEMICOLON] = ACTIONS(3729),
    [sym__ctrl_z_hack] = ACTIONS(3729),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1220] = {
    [sym_heredoc_content] = STATE(1220),
    [anon_sym_SEMI] = ACTIONS(3735),
    [anon_sym_COMMA] = ACTIONS(3735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3735),
    [anon_sym_and] = ACTIONS(3737),
    [anon_sym_or] = ACTIONS(3735),
    [anon_sym_DASH_GT] = ACTIONS(3735),
    [anon_sym_PERCENT] = ACTIONS(3737),
    [anon_sym_LT] = ACTIONS(3737),
    [anon_sym_GT] = ACTIONS(3737),
    [anon_sym_LT_LT] = ACTIONS(3737),
    [anon_sym_EQ] = ACTIONS(3737),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3735),
    [anon_sym_PLUS_EQ] = ACTIONS(3735),
    [anon_sym_DASH_EQ] = ACTIONS(3735),
    [anon_sym_DOT_EQ] = ACTIONS(3735),
    [anon_sym_STAR_EQ] = ACTIONS(3735),
    [anon_sym_SLASH_EQ] = ACTIONS(3735),
    [anon_sym_PERCENT_EQ] = ACTIONS(3735),
    [anon_sym_x_EQ] = ACTIONS(3737),
    [anon_sym_AMP_EQ] = ACTIONS(3735),
    [anon_sym_PIPE_EQ] = ACTIONS(3735),
    [anon_sym_CARET_EQ] = ACTIONS(3735),
    [anon_sym_LT_LT_EQ] = ACTIONS(3735),
    [anon_sym_GT_GT_EQ] = ACTIONS(3735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3735),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3735),
    [anon_sym_DOT_DOT] = ACTIONS(3737),
    [anon_sym_STAR_STAR] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(3737),
    [anon_sym_SLASH_SLASH] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_PIPE] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3737),
    [anon_sym_GT_GT2] = ACTIONS(3737),
    [anon_sym_PLUS] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3737),
    [anon_sym_DOT] = ACTIONS(3737),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_SLASH] = ACTIONS(3737),
    [anon_sym_x] = ACTIONS(3737),
    [anon_sym_EQ_TILDE] = ACTIONS(3735),
    [anon_sym_BANG_TILDE] = ACTIONS(3735),
    [anon_sym_EQ_EQ] = ACTIONS(3735),
    [anon_sym_BANG_EQ] = ACTIONS(3735),
    [anon_sym_eq] = ACTIONS(3735),
    [anon_sym_ne] = ACTIONS(3737),
    [anon_sym_LT_EQ_GT] = ACTIONS(3735),
    [anon_sym_cmp] = ACTIONS(3737),
    [anon_sym_TILDE_TILDE] = ACTIONS(3735),
    [anon_sym_LT_EQ] = ACTIONS(3737),
    [anon_sym_GT_EQ] = ACTIONS(3735),
    [anon_sym_lt] = ACTIONS(3737),
    [anon_sym_le] = ACTIONS(3737),
    [anon_sym_ge] = ACTIONS(3737),
    [anon_sym_gt] = ACTIONS(3737),
    [anon_sym_isa] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3735),
    [anon_sym_QMARK] = ACTIONS(3735),
    [anon_sym_EQ_GT] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3737),
    [anon_sym_foreach] = ACTIONS(3735),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3735),
    [anon_sym___END__] = ACTIONS(3735),
    [anon_sym_EOT] = ACTIONS(3735),
    [sym_match_regexp_modifiers] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3737),
    [anon_sym_unless] = ACTIONS(3737),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_until] = ACTIONS(3737),
    [sym__PERLY_SEMICOLON] = ACTIONS(3735),
    [sym__ctrl_z_hack] = ACTIONS(3735),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1221] = {
    [sym_heredoc_content] = STATE(1221),
    [anon_sym_COLON] = ACTIONS(3741),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3741),
    [anon_sym_and] = ACTIONS(3741),
    [anon_sym_or] = ACTIONS(3741),
    [anon_sym_DASH_GT] = ACTIONS(3741),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_LT] = ACTIONS(3743),
    [anon_sym_GT] = ACTIONS(3743),
    [anon_sym_LT_LT] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3741),
    [anon_sym_PLUS_EQ] = ACTIONS(3741),
    [anon_sym_DASH_EQ] = ACTIONS(3741),
    [anon_sym_DOT_EQ] = ACTIONS(3741),
    [anon_sym_STAR_EQ] = ACTIONS(3741),
    [anon_sym_SLASH_EQ] = ACTIONS(3741),
    [anon_sym_PERCENT_EQ] = ACTIONS(3741),
    [anon_sym_x_EQ] = ACTIONS(3741),
    [anon_sym_AMP_EQ] = ACTIONS(3741),
    [anon_sym_PIPE_EQ] = ACTIONS(3741),
    [anon_sym_CARET_EQ] = ACTIONS(3741),
    [anon_sym_LT_LT_EQ] = ACTIONS(3741),
    [anon_sym_GT_GT_EQ] = ACTIONS(3741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3741),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3741),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3741),
    [anon_sym_DOT_DOT] = ACTIONS(3743),
    [anon_sym_STAR_STAR] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_SLASH_SLASH] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_GT_GT2] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_SLASH] = ACTIONS(3743),
    [anon_sym_x] = ACTIONS(3743),
    [anon_sym_EQ_TILDE] = ACTIONS(3741),
    [anon_sym_BANG_TILDE] = ACTIONS(3741),
    [anon_sym_EQ_EQ] = ACTIONS(3741),
    [anon_sym_BANG_EQ] = ACTIONS(3741),
    [anon_sym_eq] = ACTIONS(3741),
    [anon_sym_ne] = ACTIONS(3741),
    [anon_sym_LT_EQ_GT] = ACTIONS(3741),
    [anon_sym_cmp] = ACTIONS(3741),
    [anon_sym_TILDE_TILDE] = ACTIONS(3741),
    [anon_sym_LT_EQ] = ACTIONS(3743),
    [anon_sym_GT_EQ] = ACTIONS(3741),
    [anon_sym_lt] = ACTIONS(3741),
    [anon_sym_le] = ACTIONS(3741),
    [anon_sym_ge] = ACTIONS(3741),
    [anon_sym_gt] = ACTIONS(3741),
    [anon_sym_isa] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(3741),
    [anon_sym_EQ_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_foreach] = ACTIONS(3741),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3741),
    [anon_sym___END__] = ACTIONS(3741),
    [anon_sym_EOT] = ACTIONS(3741),
    [anon_sym_if] = ACTIONS(3741),
    [anon_sym_unless] = ACTIONS(3741),
    [anon_sym_while] = ACTIONS(3741),
    [anon_sym_until] = ACTIONS(3741),
    [sym__PERLY_SEMICOLON] = ACTIONS(3741),
    [sym__ctrl_z_hack] = ACTIONS(3741),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1222] = {
    [sym_heredoc_content] = STATE(1222),
    [anon_sym_COLON] = ACTIONS(3745),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym_COMMA] = ACTIONS(3745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3745),
    [anon_sym_and] = ACTIONS(3745),
    [anon_sym_or] = ACTIONS(3745),
    [anon_sym_DASH_GT] = ACTIONS(3745),
    [anon_sym_PERCENT] = ACTIONS(3747),
    [anon_sym_LT] = ACTIONS(3747),
    [anon_sym_GT] = ACTIONS(3747),
    [anon_sym_LT_LT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3747),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3745),
    [anon_sym_PLUS_EQ] = ACTIONS(3745),
    [anon_sym_DASH_EQ] = ACTIONS(3745),
    [anon_sym_DOT_EQ] = ACTIONS(3745),
    [anon_sym_STAR_EQ] = ACTIONS(3745),
    [anon_sym_SLASH_EQ] = ACTIONS(3745),
    [anon_sym_PERCENT_EQ] = ACTIONS(3745),
    [anon_sym_x_EQ] = ACTIONS(3745),
    [anon_sym_AMP_EQ] = ACTIONS(3745),
    [anon_sym_PIPE_EQ] = ACTIONS(3745),
    [anon_sym_CARET_EQ] = ACTIONS(3745),
    [anon_sym_LT_LT_EQ] = ACTIONS(3745),
    [anon_sym_GT_GT_EQ] = ACTIONS(3745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3745),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3745),
    [anon_sym_DOT_DOT] = ACTIONS(3747),
    [anon_sym_STAR_STAR] = ACTIONS(3747),
    [anon_sym_PIPE_PIPE] = ACTIONS(3747),
    [anon_sym_SLASH_SLASH] = ACTIONS(3747),
    [anon_sym_AMP_AMP] = ACTIONS(3747),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_AMP] = ACTIONS(3747),
    [anon_sym_GT_GT2] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3747),
    [anon_sym_SLASH] = ACTIONS(3747),
    [anon_sym_x] = ACTIONS(3747),
    [anon_sym_EQ_TILDE] = ACTIONS(3745),
    [anon_sym_BANG_TILDE] = ACTIONS(3745),
    [anon_sym_EQ_EQ] = ACTIONS(3745),
    [anon_sym_BANG_EQ] = ACTIONS(3745),
    [anon_sym_eq] = ACTIONS(3745),
    [anon_sym_ne] = ACTIONS(3745),
    [anon_sym_LT_EQ_GT] = ACTIONS(3745),
    [anon_sym_cmp] = ACTIONS(3745),
    [anon_sym_TILDE_TILDE] = ACTIONS(3745),
    [anon_sym_LT_EQ] = ACTIONS(3747),
    [anon_sym_GT_EQ] = ACTIONS(3745),
    [anon_sym_lt] = ACTIONS(3745),
    [anon_sym_le] = ACTIONS(3745),
    [anon_sym_ge] = ACTIONS(3745),
    [anon_sym_gt] = ACTIONS(3745),
    [anon_sym_isa] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_EQ_GT] = ACTIONS(3745),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_foreach] = ACTIONS(3745),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3745),
    [anon_sym___END__] = ACTIONS(3745),
    [anon_sym_EOT] = ACTIONS(3745),
    [anon_sym_if] = ACTIONS(3745),
    [anon_sym_unless] = ACTIONS(3745),
    [anon_sym_while] = ACTIONS(3745),
    [anon_sym_until] = ACTIONS(3745),
    [sym__PERLY_SEMICOLON] = ACTIONS(3745),
    [sym__ctrl_z_hack] = ACTIONS(3745),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1223] = {
    [sym_heredoc_content] = STATE(1223),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3749),
    [anon_sym_and] = ACTIONS(3751),
    [anon_sym_or] = ACTIONS(3751),
    [anon_sym_DASH_GT] = ACTIONS(3749),
    [anon_sym_PERCENT] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_GT] = ACTIONS(3751),
    [anon_sym_LT_LT] = ACTIONS(3751),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3749),
    [anon_sym_PLUS_EQ] = ACTIONS(3749),
    [anon_sym_DASH_EQ] = ACTIONS(3749),
    [anon_sym_DOT_EQ] = ACTIONS(3749),
    [anon_sym_STAR_EQ] = ACTIONS(3749),
    [anon_sym_SLASH_EQ] = ACTIONS(3749),
    [anon_sym_PERCENT_EQ] = ACTIONS(3749),
    [anon_sym_x_EQ] = ACTIONS(3751),
    [anon_sym_AMP_EQ] = ACTIONS(3749),
    [anon_sym_PIPE_EQ] = ACTIONS(3749),
    [anon_sym_CARET_EQ] = ACTIONS(3749),
    [anon_sym_LT_LT_EQ] = ACTIONS(3749),
    [anon_sym_GT_GT_EQ] = ACTIONS(3749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3749),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3749),
    [anon_sym_DOT_DOT] = ACTIONS(3751),
    [anon_sym_STAR_STAR] = ACTIONS(3751),
    [anon_sym_PIPE_PIPE] = ACTIONS(3751),
    [anon_sym_SLASH_SLASH] = ACTIONS(3751),
    [anon_sym_AMP_AMP] = ACTIONS(3751),
    [anon_sym_PIPE] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_GT_GT2] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_DOT] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3751),
    [anon_sym_SLASH] = ACTIONS(3751),
    [anon_sym_x] = ACTIONS(3751),
    [anon_sym_EQ_TILDE] = ACTIONS(3749),
    [anon_sym_BANG_TILDE] = ACTIONS(3749),
    [anon_sym_EQ_EQ] = ACTIONS(3749),
    [anon_sym_BANG_EQ] = ACTIONS(3749),
    [anon_sym_eq] = ACTIONS(3751),
    [anon_sym_ne] = ACTIONS(3749),
    [anon_sym_LT_EQ_GT] = ACTIONS(3749),
    [anon_sym_cmp] = ACTIONS(3751),
    [anon_sym_TILDE_TILDE] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(3751),
    [anon_sym_GT_EQ] = ACTIONS(3749),
    [anon_sym_lt] = ACTIONS(3751),
    [anon_sym_le] = ACTIONS(3751),
    [anon_sym_ge] = ACTIONS(3751),
    [anon_sym_gt] = ACTIONS(3751),
    [anon_sym_isa] = ACTIONS(3751),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_QMARK] = ACTIONS(3749),
    [anon_sym_EQ_GT] = ACTIONS(3749),
    [anon_sym_for] = ACTIONS(3751),
    [anon_sym_foreach] = ACTIONS(3749),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3749),
    [anon_sym___END__] = ACTIONS(3749),
    [anon_sym_EOT] = ACTIONS(3749),
    [sym_substitution_regexp_modifiers] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3751),
    [anon_sym_unless] = ACTIONS(3751),
    [anon_sym_while] = ACTIONS(3749),
    [anon_sym_until] = ACTIONS(3751),
    [sym__PERLY_SEMICOLON] = ACTIONS(3749),
    [sym__ctrl_z_hack] = ACTIONS(3749),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1224] = {
    [sym_heredoc_content] = STATE(1224),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3755),
    [anon_sym_and] = ACTIONS(3755),
    [anon_sym_or] = ACTIONS(3755),
    [anon_sym_DASH_GT] = ACTIONS(3755),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_GT] = ACTIONS(3757),
    [anon_sym_LT_LT] = ACTIONS(3757),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3755),
    [anon_sym_PLUS_EQ] = ACTIONS(3755),
    [anon_sym_DASH_EQ] = ACTIONS(3755),
    [anon_sym_DOT_EQ] = ACTIONS(3755),
    [anon_sym_STAR_EQ] = ACTIONS(3755),
    [anon_sym_SLASH_EQ] = ACTIONS(3755),
    [anon_sym_PERCENT_EQ] = ACTIONS(3755),
    [anon_sym_x_EQ] = ACTIONS(3755),
    [anon_sym_AMP_EQ] = ACTIONS(3755),
    [anon_sym_PIPE_EQ] = ACTIONS(3755),
    [anon_sym_CARET_EQ] = ACTIONS(3755),
    [anon_sym_LT_LT_EQ] = ACTIONS(3755),
    [anon_sym_GT_GT_EQ] = ACTIONS(3755),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3755),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3755),
    [anon_sym_DOT_DOT] = ACTIONS(3757),
    [anon_sym_STAR_STAR] = ACTIONS(3757),
    [anon_sym_PIPE_PIPE] = ACTIONS(3757),
    [anon_sym_SLASH_SLASH] = ACTIONS(3757),
    [anon_sym_AMP_AMP] = ACTIONS(3757),
    [anon_sym_PIPE] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_GT_GT2] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_DOT] = ACTIONS(3757),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_SLASH] = ACTIONS(3757),
    [anon_sym_x] = ACTIONS(3757),
    [anon_sym_EQ_TILDE] = ACTIONS(3755),
    [anon_sym_BANG_TILDE] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3755),
    [anon_sym_eq] = ACTIONS(3755),
    [anon_sym_ne] = ACTIONS(3755),
    [anon_sym_LT_EQ_GT] = ACTIONS(3755),
    [anon_sym_cmp] = ACTIONS(3755),
    [anon_sym_TILDE_TILDE] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3757),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_lt] = ACTIONS(3755),
    [anon_sym_le] = ACTIONS(3755),
    [anon_sym_ge] = ACTIONS(3755),
    [anon_sym_gt] = ACTIONS(3755),
    [anon_sym_isa] = ACTIONS(3755),
    [anon_sym_PLUS_PLUS] = ACTIONS(3755),
    [anon_sym_DASH_DASH] = ACTIONS(3755),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_EQ_GT] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3757),
    [anon_sym_foreach] = ACTIONS(3755),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3755),
    [anon_sym___END__] = ACTIONS(3755),
    [anon_sym_EOT] = ACTIONS(3755),
    [anon_sym_if] = ACTIONS(3755),
    [anon_sym_unless] = ACTIONS(3755),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_until] = ACTIONS(3755),
    [sym__PERLY_SEMICOLON] = ACTIONS(3755),
    [sym__ctrl_z_hack] = ACTIONS(3755),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1225] = {
    [sym_heredoc_content] = STATE(1225),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [anon_sym_LT] = ACTIONS(3763),
    [anon_sym_GT] = ACTIONS(3763),
    [anon_sym_LT_LT] = ACTIONS(3763),
    [anon_sym_EQ] = ACTIONS(3763),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_DOT_EQ] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_x_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_DOT_DOT] = ACTIONS(3763),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_PIPE_PIPE] = ACTIONS(3763),
    [anon_sym_SLASH_SLASH] = ACTIONS(3763),
    [anon_sym_AMP_AMP] = ACTIONS(3763),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_GT_GT2] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_DOT] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3763),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_x] = ACTIONS(3763),
    [anon_sym_EQ_TILDE] = ACTIONS(3759),
    [anon_sym_BANG_TILDE] = ACTIONS(3759),
    [anon_sym_EQ_EQ] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_eq] = ACTIONS(3759),
    [anon_sym_ne] = ACTIONS(3759),
    [anon_sym_LT_EQ_GT] = ACTIONS(3759),
    [anon_sym_cmp] = ACTIONS(3759),
    [anon_sym_TILDE_TILDE] = ACTIONS(3759),
    [anon_sym_LT_EQ] = ACTIONS(3763),
    [anon_sym_GT_EQ] = ACTIONS(3759),
    [anon_sym_lt] = ACTIONS(3759),
    [anon_sym_le] = ACTIONS(3759),
    [anon_sym_ge] = ACTIONS(3759),
    [anon_sym_gt] = ACTIONS(3759),
    [anon_sym_isa] = ACTIONS(3759),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_EQ_GT] = ACTIONS(3759),
    [anon_sym_for] = ACTIONS(3763),
    [anon_sym_foreach] = ACTIONS(3759),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3759),
    [anon_sym___END__] = ACTIONS(3759),
    [anon_sym_EOT] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_unless] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_until] = ACTIONS(3759),
    [sym__PERLY_SEMICOLON] = ACTIONS(3759),
    [sym__ctrl_z_hack] = ACTIONS(3759),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1226] = {
    [sym_heredoc_content] = STATE(1226),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3765),
    [anon_sym_and] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3765),
    [anon_sym_DASH_GT] = ACTIONS(3765),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3767),
    [anon_sym_GT] = ACTIONS(3767),
    [anon_sym_LT_LT] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3767),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3765),
    [anon_sym_PLUS_EQ] = ACTIONS(3765),
    [anon_sym_DASH_EQ] = ACTIONS(3765),
    [anon_sym_DOT_EQ] = ACTIONS(3765),
    [anon_sym_STAR_EQ] = ACTIONS(3765),
    [anon_sym_SLASH_EQ] = ACTIONS(3765),
    [anon_sym_PERCENT_EQ] = ACTIONS(3765),
    [anon_sym_x_EQ] = ACTIONS(3767),
    [anon_sym_AMP_EQ] = ACTIONS(3765),
    [anon_sym_PIPE_EQ] = ACTIONS(3765),
    [anon_sym_CARET_EQ] = ACTIONS(3765),
    [anon_sym_LT_LT_EQ] = ACTIONS(3765),
    [anon_sym_GT_GT_EQ] = ACTIONS(3765),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3765),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3765),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3765),
    [anon_sym_DOT_DOT] = ACTIONS(3767),
    [anon_sym_STAR_STAR] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_SLASH_SLASH] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(3767),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_GT_GT2] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3767),
    [anon_sym_SLASH] = ACTIONS(3767),
    [anon_sym_x] = ACTIONS(3767),
    [anon_sym_EQ_TILDE] = ACTIONS(3765),
    [anon_sym_BANG_TILDE] = ACTIONS(3765),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_eq] = ACTIONS(3765),
    [anon_sym_ne] = ACTIONS(3767),
    [anon_sym_LT_EQ_GT] = ACTIONS(3765),
    [anon_sym_cmp] = ACTIONS(3767),
    [anon_sym_TILDE_TILDE] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3767),
    [anon_sym_GT_EQ] = ACTIONS(3765),
    [anon_sym_lt] = ACTIONS(3767),
    [anon_sym_le] = ACTIONS(3767),
    [anon_sym_ge] = ACTIONS(3767),
    [anon_sym_gt] = ACTIONS(3767),
    [anon_sym_isa] = ACTIONS(3767),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_QMARK] = ACTIONS(3765),
    [anon_sym_EQ_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_foreach] = ACTIONS(3765),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3765),
    [anon_sym___END__] = ACTIONS(3765),
    [anon_sym_EOT] = ACTIONS(3765),
    [sym_match_regexp_modifiers] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_unless] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3765),
    [anon_sym_until] = ACTIONS(3767),
    [sym__PERLY_SEMICOLON] = ACTIONS(3765),
    [sym__ctrl_z_hack] = ACTIONS(3765),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1227] = {
    [sym_heredoc_content] = STATE(1227),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym_COMMA] = ACTIONS(3771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3771),
    [anon_sym_and] = ACTIONS(3771),
    [anon_sym_or] = ACTIONS(3771),
    [anon_sym_DASH_GT] = ACTIONS(3771),
    [anon_sym_PERCENT] = ACTIONS(3773),
    [anon_sym_LT] = ACTIONS(3773),
    [anon_sym_GT] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(3773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3771),
    [anon_sym_PLUS_EQ] = ACTIONS(3771),
    [anon_sym_DASH_EQ] = ACTIONS(3771),
    [anon_sym_DOT_EQ] = ACTIONS(3771),
    [anon_sym_STAR_EQ] = ACTIONS(3771),
    [anon_sym_SLASH_EQ] = ACTIONS(3771),
    [anon_sym_PERCENT_EQ] = ACTIONS(3771),
    [anon_sym_x_EQ] = ACTIONS(3771),
    [anon_sym_AMP_EQ] = ACTIONS(3771),
    [anon_sym_PIPE_EQ] = ACTIONS(3771),
    [anon_sym_CARET_EQ] = ACTIONS(3771),
    [anon_sym_LT_LT_EQ] = ACTIONS(3771),
    [anon_sym_GT_GT_EQ] = ACTIONS(3771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3771),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_STAR_STAR] = ACTIONS(3773),
    [anon_sym_PIPE_PIPE] = ACTIONS(3773),
    [anon_sym_SLASH_SLASH] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_PIPE] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3773),
    [anon_sym_GT_GT2] = ACTIONS(3773),
    [anon_sym_PLUS] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3773),
    [anon_sym_DOT] = ACTIONS(3773),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_SLASH] = ACTIONS(3773),
    [anon_sym_x] = ACTIONS(3773),
    [anon_sym_EQ_TILDE] = ACTIONS(3771),
    [anon_sym_BANG_TILDE] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3771),
    [anon_sym_BANG_EQ] = ACTIONS(3771),
    [anon_sym_eq] = ACTIONS(3771),
    [anon_sym_ne] = ACTIONS(3771),
    [anon_sym_LT_EQ_GT] = ACTIONS(3771),
    [anon_sym_cmp] = ACTIONS(3773),
    [anon_sym_TILDE_TILDE] = ACTIONS(3771),
    [anon_sym_LT_EQ] = ACTIONS(3773),
    [anon_sym_GT_EQ] = ACTIONS(3771),
    [anon_sym_lt] = ACTIONS(3771),
    [anon_sym_le] = ACTIONS(3771),
    [anon_sym_ge] = ACTIONS(3771),
    [anon_sym_gt] = ACTIONS(3771),
    [anon_sym_isa] = ACTIONS(3771),
    [anon_sym_PLUS_PLUS] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_EQ_GT] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3773),
    [anon_sym_foreach] = ACTIONS(3771),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3771),
    [anon_sym___END__] = ACTIONS(3771),
    [anon_sym_EOT] = ACTIONS(3771),
    [sym_transliteration_modifiers] = ACTIONS(3775),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_unless] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_until] = ACTIONS(3771),
    [sym__PERLY_SEMICOLON] = ACTIONS(3771),
    [sym__ctrl_z_hack] = ACTIONS(3771),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1228] = {
    [sym_heredoc_content] = STATE(1228),
    [anon_sym_SEMI] = ACTIONS(3777),
    [anon_sym_COMMA] = ACTIONS(3777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3777),
    [anon_sym_and] = ACTIONS(3777),
    [anon_sym_or] = ACTIONS(3777),
    [anon_sym_LBRACK] = ACTIONS(3574),
    [anon_sym_DASH_GT] = ACTIONS(3777),
    [anon_sym_PERCENT] = ACTIONS(3779),
    [anon_sym_LT] = ACTIONS(3779),
    [anon_sym_GT] = ACTIONS(3779),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_EQ] = ACTIONS(3779),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3777),
    [anon_sym_PLUS_EQ] = ACTIONS(3777),
    [anon_sym_DASH_EQ] = ACTIONS(3777),
    [anon_sym_DOT_EQ] = ACTIONS(3777),
    [anon_sym_STAR_EQ] = ACTIONS(3777),
    [anon_sym_SLASH_EQ] = ACTIONS(3777),
    [anon_sym_PERCENT_EQ] = ACTIONS(3777),
    [anon_sym_x_EQ] = ACTIONS(3777),
    [anon_sym_AMP_EQ] = ACTIONS(3777),
    [anon_sym_PIPE_EQ] = ACTIONS(3777),
    [anon_sym_CARET_EQ] = ACTIONS(3777),
    [anon_sym_LT_LT_EQ] = ACTIONS(3777),
    [anon_sym_GT_GT_EQ] = ACTIONS(3777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3777),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3777),
    [anon_sym_DOT_DOT] = ACTIONS(3779),
    [anon_sym_STAR_STAR] = ACTIONS(3779),
    [anon_sym_PIPE_PIPE] = ACTIONS(3779),
    [anon_sym_SLASH_SLASH] = ACTIONS(3779),
    [anon_sym_AMP_AMP] = ACTIONS(3779),
    [anon_sym_PIPE] = ACTIONS(3779),
    [anon_sym_AMP] = ACTIONS(3779),
    [anon_sym_GT_GT2] = ACTIONS(3779),
    [anon_sym_PLUS] = ACTIONS(3779),
    [anon_sym_DASH] = ACTIONS(3779),
    [anon_sym_DOT] = ACTIONS(3779),
    [anon_sym_STAR] = ACTIONS(3779),
    [anon_sym_SLASH] = ACTIONS(3779),
    [anon_sym_x] = ACTIONS(3779),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_EQ_EQ] = ACTIONS(3777),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_eq] = ACTIONS(3777),
    [anon_sym_ne] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_cmp] = ACTIONS(3777),
    [anon_sym_TILDE_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3779),
    [anon_sym_GT_EQ] = ACTIONS(3777),
    [anon_sym_lt] = ACTIONS(3777),
    [anon_sym_le] = ACTIONS(3777),
    [anon_sym_ge] = ACTIONS(3777),
    [anon_sym_gt] = ACTIONS(3777),
    [anon_sym_isa] = ACTIONS(3777),
    [anon_sym_PLUS_PLUS] = ACTIONS(3777),
    [anon_sym_DASH_DASH] = ACTIONS(3777),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_EQ_GT] = ACTIONS(3777),
    [anon_sym_for] = ACTIONS(3779),
    [anon_sym_foreach] = ACTIONS(3777),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3777),
    [anon_sym___END__] = ACTIONS(3777),
    [anon_sym_EOT] = ACTIONS(3777),
    [anon_sym_if] = ACTIONS(3777),
    [anon_sym_unless] = ACTIONS(3777),
    [anon_sym_while] = ACTIONS(3777),
    [anon_sym_until] = ACTIONS(3777),
    [sym__PERLY_SEMICOLON] = ACTIONS(3777),
    [sym__ctrl_z_hack] = ACTIONS(3777),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1229] = {
    [sym_heredoc_content] = STATE(1229),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_and] = ACTIONS(3783),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3783),
    [anon_sym_LT] = ACTIONS(3783),
    [anon_sym_GT] = ACTIONS(3783),
    [anon_sym_LT_LT] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(3783),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_DOT_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_x_EQ] = ACTIONS(3783),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT] = ACTIONS(3783),
    [anon_sym_STAR_STAR] = ACTIONS(3783),
    [anon_sym_PIPE_PIPE] = ACTIONS(3783),
    [anon_sym_SLASH_SLASH] = ACTIONS(3783),
    [anon_sym_AMP_AMP] = ACTIONS(3783),
    [anon_sym_PIPE] = ACTIONS(3783),
    [anon_sym_AMP] = ACTIONS(3783),
    [anon_sym_GT_GT2] = ACTIONS(3783),
    [anon_sym_PLUS] = ACTIONS(3783),
    [anon_sym_DASH] = ACTIONS(3783),
    [anon_sym_DOT] = ACTIONS(3783),
    [anon_sym_STAR] = ACTIONS(3783),
    [anon_sym_SLASH] = ACTIONS(3783),
    [anon_sym_x] = ACTIONS(3783),
    [anon_sym_EQ_TILDE] = ACTIONS(3781),
    [anon_sym_BANG_TILDE] = ACTIONS(3781),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_eq] = ACTIONS(3781),
    [anon_sym_ne] = ACTIONS(3783),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_cmp] = ACTIONS(3783),
    [anon_sym_TILDE_TILDE] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3783),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_lt] = ACTIONS(3783),
    [anon_sym_le] = ACTIONS(3783),
    [anon_sym_ge] = ACTIONS(3783),
    [anon_sym_gt] = ACTIONS(3783),
    [anon_sym_isa] = ACTIONS(3783),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_EQ_GT] = ACTIONS(3781),
    [anon_sym_for] = ACTIONS(3783),
    [anon_sym_foreach] = ACTIONS(3781),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3781),
    [anon_sym___END__] = ACTIONS(3781),
    [anon_sym_EOT] = ACTIONS(3781),
    [sym_match_regexp_modifiers] = ACTIONS(3785),
    [anon_sym_if] = ACTIONS(3783),
    [anon_sym_unless] = ACTIONS(3783),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_until] = ACTIONS(3783),
    [sym__PERLY_SEMICOLON] = ACTIONS(3781),
    [sym__ctrl_z_hack] = ACTIONS(3781),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1230] = {
    [sym_heredoc_content] = STATE(1230),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_and] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(3787),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_EQ] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_x_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2936),
    [anon_sym_BANG_TILDE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_eq] = ACTIONS(2936),
    [anon_sym_ne] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_cmp] = ACTIONS(2936),
    [anon_sym_TILDE_TILDE] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_lt] = ACTIONS(2936),
    [anon_sym_le] = ACTIONS(2936),
    [anon_sym_ge] = ACTIONS(2936),
    [anon_sym_gt] = ACTIONS(2936),
    [anon_sym_isa] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_foreach] = ACTIONS(2936),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2936),
    [anon_sym___END__] = ACTIONS(2936),
    [anon_sym_EOT] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_unless] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_until] = ACTIONS(2936),
    [sym__PERLY_SEMICOLON] = ACTIONS(2936),
    [sym__ctrl_z_hack] = ACTIONS(2936),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1231] = {
    [sym_heredoc_content] = STATE(1231),
    [aux_sym__term_rightward_repeat1] = STATE(1208),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3650),
    [anon_sym_and] = ACTIONS(3789),
    [anon_sym_or] = ACTIONS(3789),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3662),
    [anon_sym_DASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_EQ] = ACTIONS(3662),
    [anon_sym_STAR_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_PERCENT_EQ] = ACTIONS(3662),
    [anon_sym_x_EQ] = ACTIONS(3662),
    [anon_sym_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_CARET_EQ] = ACTIONS(3662),
    [anon_sym_LT_LT_EQ] = ACTIONS(3662),
    [anon_sym_GT_GT_EQ] = ACTIONS(3662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_SLASH_SLASH] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3690),
    [anon_sym_EQ_GT] = ACTIONS(3791),
    [anon_sym_for] = ACTIONS(3793),
    [anon_sym_foreach] = ACTIONS(3789),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3789),
    [anon_sym___END__] = ACTIONS(3789),
    [anon_sym_EOT] = ACTIONS(3789),
    [anon_sym_if] = ACTIONS(3789),
    [anon_sym_unless] = ACTIONS(3789),
    [anon_sym_while] = ACTIONS(3789),
    [anon_sym_until] = ACTIONS(3789),
    [sym__PERLY_SEMICOLON] = ACTIONS(3789),
    [sym__ctrl_z_hack] = ACTIONS(3789),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1232] = {
    [sym_heredoc_content] = STATE(1232),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(257),
  },
  [1233] = {
    [sym_heredoc_content] = STATE(1233),
    [anon_sym_SEMI] = ACTIONS(3795),
    [anon_sym_COMMA] = ACTIONS(3795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3795),
    [anon_sym_and] = ACTIONS(3795),
    [anon_sym_or] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3795),
    [anon_sym_PERCENT] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3797),
    [anon_sym_GT] = ACTIONS(3797),
    [anon_sym_LT_LT] = ACTIONS(3797),
    [anon_sym_EQ] = ACTIONS(3797),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3795),
    [anon_sym_PLUS_EQ] = ACTIONS(3795),
    [anon_sym_DASH_EQ] = ACTIONS(3795),
    [anon_sym_DOT_EQ] = ACTIONS(3795),
    [anon_sym_STAR_EQ] = ACTIONS(3795),
    [anon_sym_SLASH_EQ] = ACTIONS(3795),
    [anon_sym_PERCENT_EQ] = ACTIONS(3795),
    [anon_sym_x_EQ] = ACTIONS(3795),
    [anon_sym_AMP_EQ] = ACTIONS(3795),
    [anon_sym_PIPE_EQ] = ACTIONS(3795),
    [anon_sym_CARET_EQ] = ACTIONS(3795),
    [anon_sym_LT_LT_EQ] = ACTIONS(3795),
    [anon_sym_GT_GT_EQ] = ACTIONS(3795),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3795),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3795),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3795),
    [anon_sym_DOT_DOT] = ACTIONS(3797),
    [anon_sym_STAR_STAR] = ACTIONS(3797),
    [anon_sym_PIPE_PIPE] = ACTIONS(3797),
    [anon_sym_SLASH_SLASH] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(3797),
    [anon_sym_PIPE] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3797),
    [anon_sym_GT_GT2] = ACTIONS(3797),
    [anon_sym_PLUS] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3797),
    [anon_sym_DOT] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_SLASH] = ACTIONS(3797),
    [anon_sym_x] = ACTIONS(3797),
    [anon_sym_EQ_TILDE] = ACTIONS(3795),
    [anon_sym_BANG_TILDE] = ACTIONS(3795),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_eq] = ACTIONS(3795),
    [anon_sym_ne] = ACTIONS(3795),
    [anon_sym_LT_EQ_GT] = ACTIONS(3795),
    [anon_sym_cmp] = ACTIONS(3795),
    [anon_sym_TILDE_TILDE] = ACTIONS(3795),
    [anon_sym_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_EQ] = ACTIONS(3795),
    [anon_sym_lt] = ACTIONS(3795),
    [anon_sym_le] = ACTIONS(3795),
    [anon_sym_ge] = ACTIONS(3795),
    [anon_sym_gt] = ACTIONS(3795),
    [anon_sym_isa] = ACTIONS(3795),
    [anon_sym_PLUS_PLUS] = ACTIONS(3795),
    [anon_sym_DASH_DASH] = ACTIONS(3795),
    [anon_sym_QMARK] = ACTIONS(3795),
    [anon_sym_EQ_GT] = ACTIONS(3795),
    [anon_sym_for] = ACTIONS(3797),
    [anon_sym_foreach] = ACTIONS(3795),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3795),
    [anon_sym___END__] = ACTIONS(3795),
    [anon_sym_EOT] = ACTIONS(3795),
    [anon_sym_if] = ACTIONS(3795),
    [anon_sym_unless] = ACTIONS(3795),
    [anon_sym_while] = ACTIONS(3795),
    [anon_sym_until] = ACTIONS(3795),
    [sym__PERLY_SEMICOLON] = ACTIONS(3795),
    [sym__ctrl_z_hack] = ACTIONS(3795),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1234] = {
    [sym_heredoc_content] = STATE(1234),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3799),
    [anon_sym_COMMA] = ACTIONS(3799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3799),
    [anon_sym_and] = ACTIONS(3799),
    [anon_sym_or] = ACTIONS(3799),
    [anon_sym_DASH_GT] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(3801),
    [anon_sym_LT] = ACTIONS(3801),
    [anon_sym_GT] = ACTIONS(3801),
    [anon_sym_LT_LT] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(3801),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3799),
    [anon_sym_PLUS_EQ] = ACTIONS(3799),
    [anon_sym_DASH_EQ] = ACTIONS(3799),
    [anon_sym_DOT_EQ] = ACTIONS(3799),
    [anon_sym_STAR_EQ] = ACTIONS(3799),
    [anon_sym_SLASH_EQ] = ACTIONS(3799),
    [anon_sym_PERCENT_EQ] = ACTIONS(3799),
    [anon_sym_x_EQ] = ACTIONS(3799),
    [anon_sym_AMP_EQ] = ACTIONS(3799),
    [anon_sym_PIPE_EQ] = ACTIONS(3799),
    [anon_sym_CARET_EQ] = ACTIONS(3799),
    [anon_sym_LT_LT_EQ] = ACTIONS(3799),
    [anon_sym_GT_GT_EQ] = ACTIONS(3799),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3799),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3799),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3799),
    [anon_sym_DOT_DOT] = ACTIONS(3801),
    [anon_sym_STAR_STAR] = ACTIONS(3801),
    [anon_sym_PIPE_PIPE] = ACTIONS(3801),
    [anon_sym_SLASH_SLASH] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_PIPE] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3801),
    [anon_sym_GT_GT2] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_DOT] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_SLASH] = ACTIONS(3801),
    [anon_sym_x] = ACTIONS(3801),
    [anon_sym_EQ_TILDE] = ACTIONS(3799),
    [anon_sym_BANG_TILDE] = ACTIONS(3799),
    [anon_sym_EQ_EQ] = ACTIONS(3799),
    [anon_sym_BANG_EQ] = ACTIONS(3799),
    [anon_sym_eq] = ACTIONS(3799),
    [anon_sym_ne] = ACTIONS(3799),
    [anon_sym_LT_EQ_GT] = ACTIONS(3799),
    [anon_sym_cmp] = ACTIONS(3799),
    [anon_sym_TILDE_TILDE] = ACTIONS(3799),
    [anon_sym_LT_EQ] = ACTIONS(3801),
    [anon_sym_GT_EQ] = ACTIONS(3799),
    [anon_sym_lt] = ACTIONS(3799),
    [anon_sym_le] = ACTIONS(3799),
    [anon_sym_ge] = ACTIONS(3799),
    [anon_sym_gt] = ACTIONS(3799),
    [anon_sym_isa] = ACTIONS(3799),
    [anon_sym_PLUS_PLUS] = ACTIONS(3799),
    [anon_sym_DASH_DASH] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3799),
    [anon_sym_EQ_GT] = ACTIONS(3799),
    [anon_sym_for] = ACTIONS(3801),
    [anon_sym_foreach] = ACTIONS(3799),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3799),
    [anon_sym___END__] = ACTIONS(3799),
    [anon_sym_EOT] = ACTIONS(3799),
    [anon_sym_if] = ACTIONS(3799),
    [anon_sym_unless] = ACTIONS(3799),
    [anon_sym_while] = ACTIONS(3799),
    [anon_sym_until] = ACTIONS(3799),
    [sym__PERLY_SEMICOLON] = ACTIONS(3799),
    [sym__ctrl_z_hack] = ACTIONS(3799),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1235] = {
    [sym_heredoc_content] = STATE(1235),
    [anon_sym_SEMI] = ACTIONS(3803),
    [anon_sym_COMMA] = ACTIONS(3803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3803),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_or] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3805),
    [anon_sym_LT_LT] = ACTIONS(3805),
    [anon_sym_EQ] = ACTIONS(3805),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3803),
    [anon_sym_PLUS_EQ] = ACTIONS(3803),
    [anon_sym_DASH_EQ] = ACTIONS(3803),
    [anon_sym_DOT_EQ] = ACTIONS(3803),
    [anon_sym_STAR_EQ] = ACTIONS(3803),
    [anon_sym_SLASH_EQ] = ACTIONS(3803),
    [anon_sym_PERCENT_EQ] = ACTIONS(3803),
    [anon_sym_x_EQ] = ACTIONS(3803),
    [anon_sym_AMP_EQ] = ACTIONS(3803),
    [anon_sym_PIPE_EQ] = ACTIONS(3803),
    [anon_sym_CARET_EQ] = ACTIONS(3803),
    [anon_sym_LT_LT_EQ] = ACTIONS(3803),
    [anon_sym_GT_GT_EQ] = ACTIONS(3803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3803),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3803),
    [anon_sym_DOT_DOT] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_SLASH_SLASH] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3805),
    [anon_sym_GT_GT2] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3805),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_SLASH] = ACTIONS(3805),
    [anon_sym_x] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3803),
    [anon_sym_BANG_TILDE] = ACTIONS(3803),
    [anon_sym_EQ_EQ] = ACTIONS(3803),
    [anon_sym_BANG_EQ] = ACTIONS(3803),
    [anon_sym_eq] = ACTIONS(3803),
    [anon_sym_ne] = ACTIONS(3803),
    [anon_sym_LT_EQ_GT] = ACTIONS(3803),
    [anon_sym_cmp] = ACTIONS(3803),
    [anon_sym_TILDE_TILDE] = ACTIONS(3803),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_GT_EQ] = ACTIONS(3803),
    [anon_sym_lt] = ACTIONS(3803),
    [anon_sym_le] = ACTIONS(3803),
    [anon_sym_ge] = ACTIONS(3803),
    [anon_sym_gt] = ACTIONS(3803),
    [anon_sym_isa] = ACTIONS(3803),
    [anon_sym_PLUS_PLUS] = ACTIONS(3803),
    [anon_sym_DASH_DASH] = ACTIONS(3803),
    [anon_sym_QMARK] = ACTIONS(3803),
    [anon_sym_EQ_GT] = ACTIONS(3803),
    [anon_sym_for] = ACTIONS(3805),
    [anon_sym_foreach] = ACTIONS(3803),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3803),
    [anon_sym___END__] = ACTIONS(3803),
    [anon_sym_EOT] = ACTIONS(3803),
    [anon_sym_if] = ACTIONS(3803),
    [anon_sym_unless] = ACTIONS(3803),
    [anon_sym_while] = ACTIONS(3803),
    [anon_sym_until] = ACTIONS(3803),
    [sym__PERLY_SEMICOLON] = ACTIONS(3803),
    [sym__ctrl_z_hack] = ACTIONS(3803),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1236] = {
    [sym_heredoc_content] = STATE(1236),
    [anon_sym_COLON] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3807),
    [anon_sym_and] = ACTIONS(3807),
    [anon_sym_or] = ACTIONS(3807),
    [anon_sym_DASH_GT] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(3809),
    [anon_sym_GT] = ACTIONS(3809),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_EQ] = ACTIONS(3809),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3807),
    [anon_sym_PLUS_EQ] = ACTIONS(3807),
    [anon_sym_DASH_EQ] = ACTIONS(3807),
    [anon_sym_DOT_EQ] = ACTIONS(3807),
    [anon_sym_STAR_EQ] = ACTIONS(3807),
    [anon_sym_SLASH_EQ] = ACTIONS(3807),
    [anon_sym_PERCENT_EQ] = ACTIONS(3807),
    [anon_sym_x_EQ] = ACTIONS(3807),
    [anon_sym_AMP_EQ] = ACTIONS(3807),
    [anon_sym_PIPE_EQ] = ACTIONS(3807),
    [anon_sym_CARET_EQ] = ACTIONS(3807),
    [anon_sym_LT_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT_GT_EQ] = ACTIONS(3807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3807),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3809),
    [anon_sym_STAR_STAR] = ACTIONS(3809),
    [anon_sym_PIPE_PIPE] = ACTIONS(3809),
    [anon_sym_SLASH_SLASH] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3809),
    [anon_sym_PIPE] = ACTIONS(3809),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_GT_GT2] = ACTIONS(3809),
    [anon_sym_PLUS] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3809),
    [anon_sym_DOT] = ACTIONS(3809),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_SLASH] = ACTIONS(3809),
    [anon_sym_x] = ACTIONS(3809),
    [anon_sym_EQ_TILDE] = ACTIONS(3807),
    [anon_sym_BANG_TILDE] = ACTIONS(3807),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3807),
    [anon_sym_eq] = ACTIONS(3807),
    [anon_sym_ne] = ACTIONS(3807),
    [anon_sym_LT_EQ_GT] = ACTIONS(3807),
    [anon_sym_cmp] = ACTIONS(3807),
    [anon_sym_TILDE_TILDE] = ACTIONS(3807),
    [anon_sym_LT_EQ] = ACTIONS(3809),
    [anon_sym_GT_EQ] = ACTIONS(3807),
    [anon_sym_lt] = ACTIONS(3807),
    [anon_sym_le] = ACTIONS(3807),
    [anon_sym_ge] = ACTIONS(3807),
    [anon_sym_gt] = ACTIONS(3807),
    [anon_sym_isa] = ACTIONS(3807),
    [anon_sym_PLUS_PLUS] = ACTIONS(3807),
    [anon_sym_DASH_DASH] = ACTIONS(3807),
    [anon_sym_QMARK] = ACTIONS(3807),
    [anon_sym_EQ_GT] = ACTIONS(3807),
    [anon_sym_for] = ACTIONS(3809),
    [anon_sym_foreach] = ACTIONS(3807),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3807),
    [anon_sym___END__] = ACTIONS(3807),
    [anon_sym_EOT] = ACTIONS(3807),
    [anon_sym_if] = ACTIONS(3807),
    [anon_sym_unless] = ACTIONS(3807),
    [anon_sym_while] = ACTIONS(3807),
    [anon_sym_until] = ACTIONS(3807),
    [sym__PERLY_SEMICOLON] = ACTIONS(3807),
    [sym__ctrl_z_hack] = ACTIONS(3807),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1237] = {
    [sym_heredoc_content] = STATE(1237),
    [anon_sym_SEMI] = ACTIONS(3811),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3811),
    [anon_sym_and] = ACTIONS(3811),
    [anon_sym_or] = ACTIONS(3811),
    [anon_sym_LBRACK] = ACTIONS(3811),
    [anon_sym_DASH_GT] = ACTIONS(3811),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_LT] = ACTIONS(3813),
    [anon_sym_GT] = ACTIONS(3813),
    [anon_sym_LT_LT] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3811),
    [anon_sym_PLUS_EQ] = ACTIONS(3811),
    [anon_sym_DASH_EQ] = ACTIONS(3811),
    [anon_sym_DOT_EQ] = ACTIONS(3811),
    [anon_sym_STAR_EQ] = ACTIONS(3811),
    [anon_sym_SLASH_EQ] = ACTIONS(3811),
    [anon_sym_PERCENT_EQ] = ACTIONS(3811),
    [anon_sym_x_EQ] = ACTIONS(3811),
    [anon_sym_AMP_EQ] = ACTIONS(3811),
    [anon_sym_PIPE_EQ] = ACTIONS(3811),
    [anon_sym_CARET_EQ] = ACTIONS(3811),
    [anon_sym_LT_LT_EQ] = ACTIONS(3811),
    [anon_sym_GT_GT_EQ] = ACTIONS(3811),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3811),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3811),
    [anon_sym_DOT_DOT] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_PIPE] = ACTIONS(3813),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_GT_GT2] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_SLASH] = ACTIONS(3813),
    [anon_sym_x] = ACTIONS(3813),
    [anon_sym_EQ_TILDE] = ACTIONS(3811),
    [anon_sym_BANG_TILDE] = ACTIONS(3811),
    [anon_sym_EQ_EQ] = ACTIONS(3811),
    [anon_sym_BANG_EQ] = ACTIONS(3811),
    [anon_sym_eq] = ACTIONS(3811),
    [anon_sym_ne] = ACTIONS(3811),
    [anon_sym_LT_EQ_GT] = ACTIONS(3811),
    [anon_sym_cmp] = ACTIONS(3811),
    [anon_sym_TILDE_TILDE] = ACTIONS(3811),
    [anon_sym_LT_EQ] = ACTIONS(3813),
    [anon_sym_GT_EQ] = ACTIONS(3811),
    [anon_sym_lt] = ACTIONS(3811),
    [anon_sym_le] = ACTIONS(3811),
    [anon_sym_ge] = ACTIONS(3811),
    [anon_sym_gt] = ACTIONS(3811),
    [anon_sym_isa] = ACTIONS(3811),
    [anon_sym_PLUS_PLUS] = ACTIONS(3811),
    [anon_sym_DASH_DASH] = ACTIONS(3811),
    [anon_sym_QMARK] = ACTIONS(3811),
    [anon_sym_EQ_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_foreach] = ACTIONS(3811),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3811),
    [anon_sym___END__] = ACTIONS(3811),
    [anon_sym_EOT] = ACTIONS(3811),
    [anon_sym_if] = ACTIONS(3811),
    [anon_sym_unless] = ACTIONS(3811),
    [anon_sym_while] = ACTIONS(3811),
    [anon_sym_until] = ACTIONS(3811),
    [sym__PERLY_SEMICOLON] = ACTIONS(3811),
    [sym__ctrl_z_hack] = ACTIONS(3811),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1238] = {
    [sym_heredoc_content] = STATE(1238),
    [anon_sym_SEMI] = ACTIONS(3815),
    [anon_sym_COMMA] = ACTIONS(3815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3815),
    [anon_sym_and] = ACTIONS(3815),
    [anon_sym_or] = ACTIONS(3815),
    [anon_sym_DASH_GT] = ACTIONS(3815),
    [anon_sym_PERCENT] = ACTIONS(3817),
    [anon_sym_LT] = ACTIONS(3817),
    [anon_sym_GT] = ACTIONS(3817),
    [anon_sym_LT_LT] = ACTIONS(3817),
    [anon_sym_EQ] = ACTIONS(3817),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3815),
    [anon_sym_PLUS_EQ] = ACTIONS(3815),
    [anon_sym_DASH_EQ] = ACTIONS(3815),
    [anon_sym_DOT_EQ] = ACTIONS(3815),
    [anon_sym_STAR_EQ] = ACTIONS(3815),
    [anon_sym_SLASH_EQ] = ACTIONS(3815),
    [anon_sym_PERCENT_EQ] = ACTIONS(3815),
    [anon_sym_x_EQ] = ACTIONS(3815),
    [anon_sym_AMP_EQ] = ACTIONS(3815),
    [anon_sym_PIPE_EQ] = ACTIONS(3815),
    [anon_sym_CARET_EQ] = ACTIONS(3815),
    [anon_sym_LT_LT_EQ] = ACTIONS(3815),
    [anon_sym_GT_GT_EQ] = ACTIONS(3815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3815),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3815),
    [anon_sym_DOT_DOT] = ACTIONS(3817),
    [anon_sym_STAR_STAR] = ACTIONS(3817),
    [anon_sym_PIPE_PIPE] = ACTIONS(3817),
    [anon_sym_SLASH_SLASH] = ACTIONS(3817),
    [anon_sym_AMP_AMP] = ACTIONS(3817),
    [anon_sym_PIPE] = ACTIONS(3817),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_GT_GT2] = ACTIONS(3817),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_DOT] = ACTIONS(3817),
    [anon_sym_STAR] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3817),
    [anon_sym_x] = ACTIONS(3817),
    [anon_sym_EQ_TILDE] = ACTIONS(3815),
    [anon_sym_BANG_TILDE] = ACTIONS(3815),
    [anon_sym_EQ_EQ] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3815),
    [anon_sym_eq] = ACTIONS(3815),
    [anon_sym_ne] = ACTIONS(3815),
    [anon_sym_LT_EQ_GT] = ACTIONS(3815),
    [anon_sym_cmp] = ACTIONS(3815),
    [anon_sym_TILDE_TILDE] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3815),
    [anon_sym_lt] = ACTIONS(3815),
    [anon_sym_le] = ACTIONS(3815),
    [anon_sym_ge] = ACTIONS(3815),
    [anon_sym_gt] = ACTIONS(3815),
    [anon_sym_isa] = ACTIONS(3815),
    [anon_sym_PLUS_PLUS] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3815),
    [anon_sym_QMARK] = ACTIONS(3815),
    [anon_sym_EQ_GT] = ACTIONS(3815),
    [anon_sym_for] = ACTIONS(3817),
    [anon_sym_foreach] = ACTIONS(3815),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3815),
    [anon_sym___END__] = ACTIONS(3815),
    [anon_sym_EOT] = ACTIONS(3815),
    [anon_sym_if] = ACTIONS(3815),
    [anon_sym_unless] = ACTIONS(3815),
    [anon_sym_while] = ACTIONS(3815),
    [anon_sym_until] = ACTIONS(3815),
    [sym__PERLY_SEMICOLON] = ACTIONS(3815),
    [sym__ctrl_z_hack] = ACTIONS(3815),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1239] = {
    [sym_heredoc_content] = STATE(1239),
    [anon_sym_SEMI] = ACTIONS(3819),
    [anon_sym_COMMA] = ACTIONS(3819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3819),
    [anon_sym_and] = ACTIONS(3819),
    [anon_sym_or] = ACTIONS(3819),
    [anon_sym_DASH_GT] = ACTIONS(3819),
    [anon_sym_PERCENT] = ACTIONS(3821),
    [anon_sym_LT] = ACTIONS(3821),
    [anon_sym_GT] = ACTIONS(3821),
    [anon_sym_LT_LT] = ACTIONS(3821),
    [anon_sym_EQ] = ACTIONS(3821),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3819),
    [anon_sym_PLUS_EQ] = ACTIONS(3819),
    [anon_sym_DASH_EQ] = ACTIONS(3819),
    [anon_sym_DOT_EQ] = ACTIONS(3819),
    [anon_sym_STAR_EQ] = ACTIONS(3819),
    [anon_sym_SLASH_EQ] = ACTIONS(3819),
    [anon_sym_PERCENT_EQ] = ACTIONS(3819),
    [anon_sym_x_EQ] = ACTIONS(3819),
    [anon_sym_AMP_EQ] = ACTIONS(3819),
    [anon_sym_PIPE_EQ] = ACTIONS(3819),
    [anon_sym_CARET_EQ] = ACTIONS(3819),
    [anon_sym_LT_LT_EQ] = ACTIONS(3819),
    [anon_sym_GT_GT_EQ] = ACTIONS(3819),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3819),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3819),
    [anon_sym_DOT_DOT] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3821),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_SLASH_SLASH] = ACTIONS(3821),
    [anon_sym_AMP_AMP] = ACTIONS(3821),
    [anon_sym_PIPE] = ACTIONS(3821),
    [anon_sym_AMP] = ACTIONS(3821),
    [anon_sym_GT_GT2] = ACTIONS(3821),
    [anon_sym_PLUS] = ACTIONS(3821),
    [anon_sym_DASH] = ACTIONS(3821),
    [anon_sym_DOT] = ACTIONS(3821),
    [anon_sym_STAR] = ACTIONS(3821),
    [anon_sym_SLASH] = ACTIONS(3821),
    [anon_sym_x] = ACTIONS(3821),
    [anon_sym_EQ_TILDE] = ACTIONS(3819),
    [anon_sym_BANG_TILDE] = ACTIONS(3819),
    [anon_sym_EQ_EQ] = ACTIONS(3819),
    [anon_sym_BANG_EQ] = ACTIONS(3819),
    [anon_sym_eq] = ACTIONS(3819),
    [anon_sym_ne] = ACTIONS(3819),
    [anon_sym_LT_EQ_GT] = ACTIONS(3819),
    [anon_sym_cmp] = ACTIONS(3819),
    [anon_sym_TILDE_TILDE] = ACTIONS(3819),
    [anon_sym_LT_EQ] = ACTIONS(3821),
    [anon_sym_GT_EQ] = ACTIONS(3819),
    [anon_sym_lt] = ACTIONS(3819),
    [anon_sym_le] = ACTIONS(3819),
    [anon_sym_ge] = ACTIONS(3819),
    [anon_sym_gt] = ACTIONS(3819),
    [anon_sym_isa] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3819),
    [anon_sym_DASH_DASH] = ACTIONS(3819),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_EQ_GT] = ACTIONS(3819),
    [anon_sym_for] = ACTIONS(3821),
    [anon_sym_foreach] = ACTIONS(3819),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3819),
    [anon_sym___END__] = ACTIONS(3819),
    [anon_sym_EOT] = ACTIONS(3819),
    [anon_sym_if] = ACTIONS(3819),
    [anon_sym_unless] = ACTIONS(3819),
    [anon_sym_while] = ACTIONS(3819),
    [anon_sym_until] = ACTIONS(3819),
    [sym__PERLY_SEMICOLON] = ACTIONS(3819),
    [sym__ctrl_z_hack] = ACTIONS(3819),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1240] = {
    [sym_heredoc_content] = STATE(1240),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_COMMA] = ACTIONS(3606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3650),
    [anon_sym_and] = ACTIONS(3606),
    [anon_sym_or] = ACTIONS(3606),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3662),
    [anon_sym_DASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_EQ] = ACTIONS(3662),
    [anon_sym_STAR_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_PERCENT_EQ] = ACTIONS(3662),
    [anon_sym_x_EQ] = ACTIONS(3662),
    [anon_sym_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_CARET_EQ] = ACTIONS(3662),
    [anon_sym_LT_LT_EQ] = ACTIONS(3662),
    [anon_sym_GT_GT_EQ] = ACTIONS(3662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_SLASH_SLASH] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3690),
    [anon_sym_EQ_GT] = ACTIONS(3606),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_foreach] = ACTIONS(3606),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3606),
    [anon_sym___END__] = ACTIONS(3606),
    [anon_sym_EOT] = ACTIONS(3606),
    [anon_sym_if] = ACTIONS(3606),
    [anon_sym_unless] = ACTIONS(3606),
    [anon_sym_while] = ACTIONS(3606),
    [anon_sym_until] = ACTIONS(3606),
    [sym__PERLY_SEMICOLON] = ACTIONS(3606),
    [sym__ctrl_z_hack] = ACTIONS(3606),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1241] = {
    [sym_heredoc_content] = STATE(1241),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3825),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3829),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_SLASH_SLASH] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1242] = {
    [sym_heredoc_content] = STATE(1242),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1243] = {
    [sym_heredoc_content] = STATE(1243),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3831),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3833),
    [anon_sym_GT] = ACTIONS(3833),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3833),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3831),
    [anon_sym_PLUS_EQ] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_EQ] = ACTIONS(3831),
    [anon_sym_STAR_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3831),
    [anon_sym_x_EQ] = ACTIONS(3831),
    [anon_sym_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3833),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3833),
    [anon_sym_SLASH_SLASH] = ACTIONS(3833),
    [anon_sym_AMP_AMP] = ACTIONS(3833),
    [anon_sym_PIPE] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(3833),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3831),
    [anon_sym_BANG_EQ] = ACTIONS(3831),
    [anon_sym_eq] = ACTIONS(3831),
    [anon_sym_ne] = ACTIONS(3831),
    [anon_sym_LT_EQ_GT] = ACTIONS(3831),
    [anon_sym_cmp] = ACTIONS(3831),
    [anon_sym_TILDE_TILDE] = ACTIONS(3831),
    [anon_sym_LT_EQ] = ACTIONS(3833),
    [anon_sym_GT_EQ] = ACTIONS(3831),
    [anon_sym_lt] = ACTIONS(3831),
    [anon_sym_le] = ACTIONS(3831),
    [anon_sym_ge] = ACTIONS(3831),
    [anon_sym_gt] = ACTIONS(3831),
    [anon_sym_isa] = ACTIONS(3831),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3831),
    [anon_sym_EQ_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3833),
    [anon_sym_foreach] = ACTIONS(3831),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3831),
    [anon_sym___END__] = ACTIONS(3831),
    [anon_sym_EOT] = ACTIONS(3831),
    [anon_sym_if] = ACTIONS(3831),
    [anon_sym_unless] = ACTIONS(3831),
    [anon_sym_while] = ACTIONS(3831),
    [anon_sym_until] = ACTIONS(3831),
    [sym__PERLY_SEMICOLON] = ACTIONS(3831),
    [sym__ctrl_z_hack] = ACTIONS(3831),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1244] = {
    [sym_heredoc_content] = STATE(1244),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1245] = {
    [sym_heredoc_content] = STATE(1245),
    [anon_sym_SEMI] = ACTIONS(3835),
    [anon_sym_COMMA] = ACTIONS(3835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3650),
    [anon_sym_and] = ACTIONS(3835),
    [anon_sym_or] = ACTIONS(3835),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3662),
    [anon_sym_DASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_EQ] = ACTIONS(3662),
    [anon_sym_STAR_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_PERCENT_EQ] = ACTIONS(3662),
    [anon_sym_x_EQ] = ACTIONS(3662),
    [anon_sym_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_CARET_EQ] = ACTIONS(3662),
    [anon_sym_LT_LT_EQ] = ACTIONS(3662),
    [anon_sym_GT_GT_EQ] = ACTIONS(3662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_SLASH_SLASH] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3690),
    [anon_sym_EQ_GT] = ACTIONS(3835),
    [anon_sym_for] = ACTIONS(3837),
    [anon_sym_foreach] = ACTIONS(3835),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3835),
    [anon_sym___END__] = ACTIONS(3835),
    [anon_sym_EOT] = ACTIONS(3835),
    [anon_sym_if] = ACTIONS(3835),
    [anon_sym_unless] = ACTIONS(3835),
    [anon_sym_while] = ACTIONS(3835),
    [anon_sym_until] = ACTIONS(3835),
    [sym__PERLY_SEMICOLON] = ACTIONS(3835),
    [sym__ctrl_z_hack] = ACTIONS(3835),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1246] = {
    [sym_heredoc_content] = STATE(1246),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(3823),
    [anon_sym_BANG_TILDE] = ACTIONS(3823),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1247] = {
    [sym_heredoc_content] = STATE(1247),
    [anon_sym_SEMI] = ACTIONS(3839),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3839),
    [anon_sym_and] = ACTIONS(3839),
    [anon_sym_or] = ACTIONS(3839),
    [anon_sym_DASH_GT] = ACTIONS(3839),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3841),
    [anon_sym_GT] = ACTIONS(3841),
    [anon_sym_LT_LT] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3841),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3839),
    [anon_sym_PLUS_EQ] = ACTIONS(3839),
    [anon_sym_DASH_EQ] = ACTIONS(3839),
    [anon_sym_DOT_EQ] = ACTIONS(3839),
    [anon_sym_STAR_EQ] = ACTIONS(3839),
    [anon_sym_SLASH_EQ] = ACTIONS(3839),
    [anon_sym_PERCENT_EQ] = ACTIONS(3839),
    [anon_sym_x_EQ] = ACTIONS(3839),
    [anon_sym_AMP_EQ] = ACTIONS(3839),
    [anon_sym_PIPE_EQ] = ACTIONS(3839),
    [anon_sym_CARET_EQ] = ACTIONS(3839),
    [anon_sym_LT_LT_EQ] = ACTIONS(3839),
    [anon_sym_GT_GT_EQ] = ACTIONS(3839),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3839),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3839),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3839),
    [anon_sym_DOT_DOT] = ACTIONS(3841),
    [anon_sym_STAR_STAR] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_SLASH_SLASH] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_GT_GT2] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_STAR] = ACTIONS(3841),
    [anon_sym_SLASH] = ACTIONS(3841),
    [anon_sym_x] = ACTIONS(3841),
    [anon_sym_EQ_TILDE] = ACTIONS(3839),
    [anon_sym_BANG_TILDE] = ACTIONS(3839),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_eq] = ACTIONS(3839),
    [anon_sym_ne] = ACTIONS(3839),
    [anon_sym_LT_EQ_GT] = ACTIONS(3839),
    [anon_sym_cmp] = ACTIONS(3839),
    [anon_sym_TILDE_TILDE] = ACTIONS(3839),
    [anon_sym_LT_EQ] = ACTIONS(3841),
    [anon_sym_GT_EQ] = ACTIONS(3839),
    [anon_sym_lt] = ACTIONS(3839),
    [anon_sym_le] = ACTIONS(3839),
    [anon_sym_ge] = ACTIONS(3839),
    [anon_sym_gt] = ACTIONS(3839),
    [anon_sym_isa] = ACTIONS(3839),
    [anon_sym_PLUS_PLUS] = ACTIONS(3839),
    [anon_sym_DASH_DASH] = ACTIONS(3839),
    [anon_sym_QMARK] = ACTIONS(3839),
    [anon_sym_EQ_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_foreach] = ACTIONS(3839),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3839),
    [anon_sym___END__] = ACTIONS(3839),
    [anon_sym_EOT] = ACTIONS(3839),
    [anon_sym_if] = ACTIONS(3839),
    [anon_sym_unless] = ACTIONS(3839),
    [anon_sym_while] = ACTIONS(3839),
    [anon_sym_until] = ACTIONS(3839),
    [sym__PERLY_SEMICOLON] = ACTIONS(3839),
    [sym__ctrl_z_hack] = ACTIONS(3839),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1248] = {
    [sym_heredoc_content] = STATE(1248),
    [anon_sym_SEMI] = ACTIONS(3843),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3843),
    [anon_sym_and] = ACTIONS(3843),
    [anon_sym_or] = ACTIONS(3843),
    [anon_sym_DASH_GT] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_LT] = ACTIONS(3845),
    [anon_sym_GT] = ACTIONS(3845),
    [anon_sym_LT_LT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3843),
    [anon_sym_PLUS_EQ] = ACTIONS(3843),
    [anon_sym_DASH_EQ] = ACTIONS(3843),
    [anon_sym_DOT_EQ] = ACTIONS(3843),
    [anon_sym_STAR_EQ] = ACTIONS(3843),
    [anon_sym_SLASH_EQ] = ACTIONS(3843),
    [anon_sym_PERCENT_EQ] = ACTIONS(3843),
    [anon_sym_x_EQ] = ACTIONS(3843),
    [anon_sym_AMP_EQ] = ACTIONS(3843),
    [anon_sym_PIPE_EQ] = ACTIONS(3843),
    [anon_sym_CARET_EQ] = ACTIONS(3843),
    [anon_sym_LT_LT_EQ] = ACTIONS(3843),
    [anon_sym_GT_GT_EQ] = ACTIONS(3843),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3843),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3843),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3843),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_STAR_STAR] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_SLASH_SLASH] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_PIPE] = ACTIONS(3845),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_GT_GT2] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3845),
    [anon_sym_SLASH] = ACTIONS(3845),
    [anon_sym_x] = ACTIONS(3845),
    [anon_sym_EQ_TILDE] = ACTIONS(3843),
    [anon_sym_BANG_TILDE] = ACTIONS(3843),
    [anon_sym_EQ_EQ] = ACTIONS(3843),
    [anon_sym_BANG_EQ] = ACTIONS(3843),
    [anon_sym_eq] = ACTIONS(3843),
    [anon_sym_ne] = ACTIONS(3843),
    [anon_sym_LT_EQ_GT] = ACTIONS(3843),
    [anon_sym_cmp] = ACTIONS(3843),
    [anon_sym_TILDE_TILDE] = ACTIONS(3843),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_GT_EQ] = ACTIONS(3843),
    [anon_sym_lt] = ACTIONS(3843),
    [anon_sym_le] = ACTIONS(3843),
    [anon_sym_ge] = ACTIONS(3843),
    [anon_sym_gt] = ACTIONS(3843),
    [anon_sym_isa] = ACTIONS(3843),
    [anon_sym_PLUS_PLUS] = ACTIONS(3843),
    [anon_sym_DASH_DASH] = ACTIONS(3843),
    [anon_sym_QMARK] = ACTIONS(3843),
    [anon_sym_EQ_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_foreach] = ACTIONS(3843),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3843),
    [anon_sym___END__] = ACTIONS(3843),
    [anon_sym_EOT] = ACTIONS(3843),
    [anon_sym_if] = ACTIONS(3843),
    [anon_sym_unless] = ACTIONS(3843),
    [anon_sym_while] = ACTIONS(3843),
    [anon_sym_until] = ACTIONS(3843),
    [sym__PERLY_SEMICOLON] = ACTIONS(3843),
    [sym__ctrl_z_hack] = ACTIONS(3843),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1249] = {
    [sym_heredoc_content] = STATE(1249),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3847),
    [anon_sym_and] = ACTIONS(3847),
    [anon_sym_or] = ACTIONS(3847),
    [anon_sym_DASH_GT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_GT] = ACTIONS(3849),
    [anon_sym_LT_LT] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3847),
    [anon_sym_PLUS_EQ] = ACTIONS(3847),
    [anon_sym_DASH_EQ] = ACTIONS(3847),
    [anon_sym_DOT_EQ] = ACTIONS(3847),
    [anon_sym_STAR_EQ] = ACTIONS(3847),
    [anon_sym_SLASH_EQ] = ACTIONS(3847),
    [anon_sym_PERCENT_EQ] = ACTIONS(3847),
    [anon_sym_x_EQ] = ACTIONS(3847),
    [anon_sym_AMP_EQ] = ACTIONS(3847),
    [anon_sym_PIPE_EQ] = ACTIONS(3847),
    [anon_sym_CARET_EQ] = ACTIONS(3847),
    [anon_sym_LT_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT_GT_EQ] = ACTIONS(3847),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3847),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3847),
    [anon_sym_DOT_DOT] = ACTIONS(3849),
    [anon_sym_STAR_STAR] = ACTIONS(3849),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH] = ACTIONS(3849),
    [anon_sym_AMP_AMP] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3849),
    [anon_sym_GT_GT2] = ACTIONS(3849),
    [anon_sym_PLUS] = ACTIONS(3849),
    [anon_sym_DASH] = ACTIONS(3849),
    [anon_sym_DOT] = ACTIONS(3849),
    [anon_sym_STAR] = ACTIONS(3849),
    [anon_sym_SLASH] = ACTIONS(3849),
    [anon_sym_x] = ACTIONS(3849),
    [anon_sym_EQ_TILDE] = ACTIONS(3847),
    [anon_sym_BANG_TILDE] = ACTIONS(3847),
    [anon_sym_EQ_EQ] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_eq] = ACTIONS(3847),
    [anon_sym_ne] = ACTIONS(3847),
    [anon_sym_LT_EQ_GT] = ACTIONS(3847),
    [anon_sym_cmp] = ACTIONS(3847),
    [anon_sym_TILDE_TILDE] = ACTIONS(3847),
    [anon_sym_LT_EQ] = ACTIONS(3849),
    [anon_sym_GT_EQ] = ACTIONS(3847),
    [anon_sym_lt] = ACTIONS(3847),
    [anon_sym_le] = ACTIONS(3847),
    [anon_sym_ge] = ACTIONS(3847),
    [anon_sym_gt] = ACTIONS(3847),
    [anon_sym_isa] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_EQ_GT] = ACTIONS(3847),
    [anon_sym_for] = ACTIONS(3849),
    [anon_sym_foreach] = ACTIONS(3847),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3847),
    [anon_sym___END__] = ACTIONS(3847),
    [anon_sym_EOT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_unless] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_until] = ACTIONS(3847),
    [sym__PERLY_SEMICOLON] = ACTIONS(3847),
    [sym__ctrl_z_hack] = ACTIONS(3847),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1250] = {
    [sym_heredoc_content] = STATE(1250),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3851),
    [anon_sym_and] = ACTIONS(3851),
    [anon_sym_or] = ACTIONS(3851),
    [anon_sym_DASH_GT] = ACTIONS(3851),
    [anon_sym_PERCENT] = ACTIONS(3853),
    [anon_sym_LT] = ACTIONS(3853),
    [anon_sym_GT] = ACTIONS(3853),
    [anon_sym_LT_LT] = ACTIONS(3853),
    [anon_sym_EQ] = ACTIONS(3853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3851),
    [anon_sym_PLUS_EQ] = ACTIONS(3851),
    [anon_sym_DASH_EQ] = ACTIONS(3851),
    [anon_sym_DOT_EQ] = ACTIONS(3851),
    [anon_sym_STAR_EQ] = ACTIONS(3851),
    [anon_sym_SLASH_EQ] = ACTIONS(3851),
    [anon_sym_PERCENT_EQ] = ACTIONS(3851),
    [anon_sym_x_EQ] = ACTIONS(3851),
    [anon_sym_AMP_EQ] = ACTIONS(3851),
    [anon_sym_PIPE_EQ] = ACTIONS(3851),
    [anon_sym_CARET_EQ] = ACTIONS(3851),
    [anon_sym_LT_LT_EQ] = ACTIONS(3851),
    [anon_sym_GT_GT_EQ] = ACTIONS(3851),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3851),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3851),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3851),
    [anon_sym_DOT_DOT] = ACTIONS(3853),
    [anon_sym_STAR_STAR] = ACTIONS(3853),
    [anon_sym_PIPE_PIPE] = ACTIONS(3853),
    [anon_sym_SLASH_SLASH] = ACTIONS(3853),
    [anon_sym_AMP_AMP] = ACTIONS(3853),
    [anon_sym_PIPE] = ACTIONS(3853),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_GT_GT2] = ACTIONS(3853),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_DOT] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3853),
    [anon_sym_SLASH] = ACTIONS(3853),
    [anon_sym_x] = ACTIONS(3853),
    [anon_sym_EQ_TILDE] = ACTIONS(3851),
    [anon_sym_BANG_TILDE] = ACTIONS(3851),
    [anon_sym_EQ_EQ] = ACTIONS(3851),
    [anon_sym_BANG_EQ] = ACTIONS(3851),
    [anon_sym_eq] = ACTIONS(3851),
    [anon_sym_ne] = ACTIONS(3851),
    [anon_sym_LT_EQ_GT] = ACTIONS(3851),
    [anon_sym_cmp] = ACTIONS(3851),
    [anon_sym_TILDE_TILDE] = ACTIONS(3851),
    [anon_sym_LT_EQ] = ACTIONS(3853),
    [anon_sym_GT_EQ] = ACTIONS(3851),
    [anon_sym_lt] = ACTIONS(3851),
    [anon_sym_le] = ACTIONS(3851),
    [anon_sym_ge] = ACTIONS(3851),
    [anon_sym_gt] = ACTIONS(3851),
    [anon_sym_isa] = ACTIONS(3851),
    [anon_sym_PLUS_PLUS] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3851),
    [anon_sym_QMARK] = ACTIONS(3851),
    [anon_sym_EQ_GT] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_foreach] = ACTIONS(3851),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3851),
    [anon_sym___END__] = ACTIONS(3851),
    [anon_sym_EOT] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_unless] = ACTIONS(3851),
    [anon_sym_while] = ACTIONS(3851),
    [anon_sym_until] = ACTIONS(3851),
    [sym__PERLY_SEMICOLON] = ACTIONS(3851),
    [sym__ctrl_z_hack] = ACTIONS(3851),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1251] = {
    [sym_heredoc_content] = STATE(1251),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3855),
    [anon_sym_and] = ACTIONS(3855),
    [anon_sym_or] = ACTIONS(3855),
    [anon_sym_DASH_GT] = ACTIONS(3855),
    [anon_sym_PERCENT] = ACTIONS(3857),
    [anon_sym_LT] = ACTIONS(3857),
    [anon_sym_GT] = ACTIONS(3857),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_EQ] = ACTIONS(3857),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3855),
    [anon_sym_PLUS_EQ] = ACTIONS(3855),
    [anon_sym_DASH_EQ] = ACTIONS(3855),
    [anon_sym_DOT_EQ] = ACTIONS(3855),
    [anon_sym_STAR_EQ] = ACTIONS(3855),
    [anon_sym_SLASH_EQ] = ACTIONS(3855),
    [anon_sym_PERCENT_EQ] = ACTIONS(3855),
    [anon_sym_x_EQ] = ACTIONS(3855),
    [anon_sym_AMP_EQ] = ACTIONS(3855),
    [anon_sym_PIPE_EQ] = ACTIONS(3855),
    [anon_sym_CARET_EQ] = ACTIONS(3855),
    [anon_sym_LT_LT_EQ] = ACTIONS(3855),
    [anon_sym_GT_GT_EQ] = ACTIONS(3855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3855),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3855),
    [anon_sym_DOT_DOT] = ACTIONS(3857),
    [anon_sym_STAR_STAR] = ACTIONS(3857),
    [anon_sym_PIPE_PIPE] = ACTIONS(3857),
    [anon_sym_SLASH_SLASH] = ACTIONS(3857),
    [anon_sym_AMP_AMP] = ACTIONS(3857),
    [anon_sym_PIPE] = ACTIONS(3857),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_GT_GT2] = ACTIONS(3857),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_DOT] = ACTIONS(3857),
    [anon_sym_STAR] = ACTIONS(3857),
    [anon_sym_SLASH] = ACTIONS(3857),
    [anon_sym_x] = ACTIONS(3857),
    [anon_sym_EQ_TILDE] = ACTIONS(3855),
    [anon_sym_BANG_TILDE] = ACTIONS(3855),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3855),
    [anon_sym_eq] = ACTIONS(3855),
    [anon_sym_ne] = ACTIONS(3855),
    [anon_sym_LT_EQ_GT] = ACTIONS(3855),
    [anon_sym_cmp] = ACTIONS(3855),
    [anon_sym_TILDE_TILDE] = ACTIONS(3855),
    [anon_sym_LT_EQ] = ACTIONS(3857),
    [anon_sym_GT_EQ] = ACTIONS(3855),
    [anon_sym_lt] = ACTIONS(3855),
    [anon_sym_le] = ACTIONS(3855),
    [anon_sym_ge] = ACTIONS(3855),
    [anon_sym_gt] = ACTIONS(3855),
    [anon_sym_isa] = ACTIONS(3855),
    [anon_sym_PLUS_PLUS] = ACTIONS(3855),
    [anon_sym_DASH_DASH] = ACTIONS(3855),
    [anon_sym_QMARK] = ACTIONS(3855),
    [anon_sym_EQ_GT] = ACTIONS(3855),
    [anon_sym_for] = ACTIONS(3857),
    [anon_sym_foreach] = ACTIONS(3855),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3855),
    [anon_sym___END__] = ACTIONS(3855),
    [anon_sym_EOT] = ACTIONS(3855),
    [anon_sym_if] = ACTIONS(3855),
    [anon_sym_unless] = ACTIONS(3855),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_until] = ACTIONS(3855),
    [sym__PERLY_SEMICOLON] = ACTIONS(3855),
    [sym__ctrl_z_hack] = ACTIONS(3855),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1252] = {
    [sym_heredoc_content] = STATE(1252),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3859),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3859),
    [anon_sym_and] = ACTIONS(3859),
    [anon_sym_or] = ACTIONS(3859),
    [anon_sym_DASH_GT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_GT] = ACTIONS(3861),
    [anon_sym_LT_LT] = ACTIONS(3861),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3859),
    [anon_sym_PLUS_EQ] = ACTIONS(3859),
    [anon_sym_DASH_EQ] = ACTIONS(3859),
    [anon_sym_DOT_EQ] = ACTIONS(3859),
    [anon_sym_STAR_EQ] = ACTIONS(3859),
    [anon_sym_SLASH_EQ] = ACTIONS(3859),
    [anon_sym_PERCENT_EQ] = ACTIONS(3859),
    [anon_sym_x_EQ] = ACTIONS(3859),
    [anon_sym_AMP_EQ] = ACTIONS(3859),
    [anon_sym_PIPE_EQ] = ACTIONS(3859),
    [anon_sym_CARET_EQ] = ACTIONS(3859),
    [anon_sym_LT_LT_EQ] = ACTIONS(3859),
    [anon_sym_GT_GT_EQ] = ACTIONS(3859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3859),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3859),
    [anon_sym_DOT_DOT] = ACTIONS(3861),
    [anon_sym_STAR_STAR] = ACTIONS(3861),
    [anon_sym_PIPE_PIPE] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH] = ACTIONS(3861),
    [anon_sym_AMP_AMP] = ACTIONS(3861),
    [anon_sym_PIPE] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_GT_GT2] = ACTIONS(3861),
    [anon_sym_PLUS] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3861),
    [anon_sym_DOT] = ACTIONS(3861),
    [anon_sym_STAR] = ACTIONS(3861),
    [anon_sym_SLASH] = ACTIONS(3861),
    [anon_sym_x] = ACTIONS(3861),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_EQ_EQ] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_eq] = ACTIONS(3859),
    [anon_sym_ne] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_cmp] = ACTIONS(3859),
    [anon_sym_TILDE_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3859),
    [anon_sym_lt] = ACTIONS(3859),
    [anon_sym_le] = ACTIONS(3859),
    [anon_sym_ge] = ACTIONS(3859),
    [anon_sym_gt] = ACTIONS(3859),
    [anon_sym_isa] = ACTIONS(3859),
    [anon_sym_PLUS_PLUS] = ACTIONS(3859),
    [anon_sym_DASH_DASH] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_EQ_GT] = ACTIONS(3859),
    [anon_sym_for] = ACTIONS(3861),
    [anon_sym_foreach] = ACTIONS(3859),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3859),
    [anon_sym___END__] = ACTIONS(3859),
    [anon_sym_EOT] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_unless] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_until] = ACTIONS(3859),
    [sym__PERLY_SEMICOLON] = ACTIONS(3859),
    [sym__ctrl_z_hack] = ACTIONS(3859),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1253] = {
    [sym_heredoc_content] = STATE(1253),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3863),
    [anon_sym_and] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_DASH_GT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_LT_LT] = ACTIONS(3865),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3863),
    [anon_sym_PLUS_EQ] = ACTIONS(3863),
    [anon_sym_DASH_EQ] = ACTIONS(3863),
    [anon_sym_DOT_EQ] = ACTIONS(3863),
    [anon_sym_STAR_EQ] = ACTIONS(3863),
    [anon_sym_SLASH_EQ] = ACTIONS(3863),
    [anon_sym_PERCENT_EQ] = ACTIONS(3863),
    [anon_sym_x_EQ] = ACTIONS(3863),
    [anon_sym_AMP_EQ] = ACTIONS(3863),
    [anon_sym_PIPE_EQ] = ACTIONS(3863),
    [anon_sym_CARET_EQ] = ACTIONS(3863),
    [anon_sym_LT_LT_EQ] = ACTIONS(3863),
    [anon_sym_GT_GT_EQ] = ACTIONS(3863),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3863),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3863),
    [anon_sym_DOT_DOT] = ACTIONS(3865),
    [anon_sym_STAR_STAR] = ACTIONS(3865),
    [anon_sym_PIPE_PIPE] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH] = ACTIONS(3865),
    [anon_sym_AMP_AMP] = ACTIONS(3865),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_GT_GT2] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_DOT] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_SLASH] = ACTIONS(3865),
    [anon_sym_x] = ACTIONS(3865),
    [anon_sym_EQ_TILDE] = ACTIONS(3863),
    [anon_sym_BANG_TILDE] = ACTIONS(3863),
    [anon_sym_EQ_EQ] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_eq] = ACTIONS(3863),
    [anon_sym_ne] = ACTIONS(3863),
    [anon_sym_LT_EQ_GT] = ACTIONS(3863),
    [anon_sym_cmp] = ACTIONS(3863),
    [anon_sym_TILDE_TILDE] = ACTIONS(3863),
    [anon_sym_LT_EQ] = ACTIONS(3865),
    [anon_sym_GT_EQ] = ACTIONS(3863),
    [anon_sym_lt] = ACTIONS(3863),
    [anon_sym_le] = ACTIONS(3863),
    [anon_sym_ge] = ACTIONS(3863),
    [anon_sym_gt] = ACTIONS(3863),
    [anon_sym_isa] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3863),
    [anon_sym_DASH_DASH] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_EQ_GT] = ACTIONS(3863),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_foreach] = ACTIONS(3863),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3863),
    [anon_sym___END__] = ACTIONS(3863),
    [anon_sym_EOT] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_unless] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_until] = ACTIONS(3863),
    [sym__PERLY_SEMICOLON] = ACTIONS(3863),
    [sym__ctrl_z_hack] = ACTIONS(3863),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1254] = {
    [sym_heredoc_content] = STATE(1254),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1255] = {
    [sym_heredoc_content] = STATE(1255),
    [anon_sym_SEMI] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3867),
    [anon_sym_and] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_DASH_GT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3867),
    [anon_sym_PLUS_EQ] = ACTIONS(3867),
    [anon_sym_DASH_EQ] = ACTIONS(3867),
    [anon_sym_DOT_EQ] = ACTIONS(3867),
    [anon_sym_STAR_EQ] = ACTIONS(3867),
    [anon_sym_SLASH_EQ] = ACTIONS(3867),
    [anon_sym_PERCENT_EQ] = ACTIONS(3867),
    [anon_sym_x_EQ] = ACTIONS(3867),
    [anon_sym_AMP_EQ] = ACTIONS(3867),
    [anon_sym_PIPE_EQ] = ACTIONS(3867),
    [anon_sym_CARET_EQ] = ACTIONS(3867),
    [anon_sym_LT_LT_EQ] = ACTIONS(3867),
    [anon_sym_GT_GT_EQ] = ACTIONS(3867),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3867),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3867),
    [anon_sym_DOT_DOT] = ACTIONS(2944),
    [anon_sym_STAR_STAR] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_SLASH_SLASH] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_GT_GT2] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2944),
    [anon_sym_DOT] = ACTIONS(2944),
    [anon_sym_STAR] = ACTIONS(2944),
    [anon_sym_SLASH] = ACTIONS(2944),
    [anon_sym_x] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(3867),
    [anon_sym_BANG_TILDE] = ACTIONS(3867),
    [anon_sym_EQ_EQ] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_eq] = ACTIONS(3867),
    [anon_sym_ne] = ACTIONS(3867),
    [anon_sym_LT_EQ_GT] = ACTIONS(3867),
    [anon_sym_cmp] = ACTIONS(3867),
    [anon_sym_TILDE_TILDE] = ACTIONS(3867),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(3867),
    [anon_sym_lt] = ACTIONS(3867),
    [anon_sym_le] = ACTIONS(3867),
    [anon_sym_ge] = ACTIONS(3867),
    [anon_sym_gt] = ACTIONS(3867),
    [anon_sym_isa] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3867),
    [anon_sym_DASH_DASH] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_EQ_GT] = ACTIONS(3867),
    [anon_sym_for] = ACTIONS(2944),
    [anon_sym_foreach] = ACTIONS(3867),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3867),
    [anon_sym___END__] = ACTIONS(3867),
    [anon_sym_EOT] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_unless] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_until] = ACTIONS(3867),
    [sym__PERLY_SEMICOLON] = ACTIONS(3867),
    [sym__ctrl_z_hack] = ACTIONS(3867),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1256] = {
    [sym_heredoc_content] = STATE(1256),
    [anon_sym_SEMI] = ACTIONS(3869),
    [anon_sym_COMMA] = ACTIONS(3869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3869),
    [anon_sym_and] = ACTIONS(3869),
    [anon_sym_or] = ACTIONS(3869),
    [anon_sym_DASH_GT] = ACTIONS(3869),
    [anon_sym_PERCENT] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3871),
    [anon_sym_GT] = ACTIONS(3871),
    [anon_sym_LT_LT] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(3871),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3869),
    [anon_sym_PLUS_EQ] = ACTIONS(3869),
    [anon_sym_DASH_EQ] = ACTIONS(3869),
    [anon_sym_DOT_EQ] = ACTIONS(3869),
    [anon_sym_STAR_EQ] = ACTIONS(3869),
    [anon_sym_SLASH_EQ] = ACTIONS(3869),
    [anon_sym_PERCENT_EQ] = ACTIONS(3869),
    [anon_sym_x_EQ] = ACTIONS(3869),
    [anon_sym_AMP_EQ] = ACTIONS(3869),
    [anon_sym_PIPE_EQ] = ACTIONS(3869),
    [anon_sym_CARET_EQ] = ACTIONS(3869),
    [anon_sym_LT_LT_EQ] = ACTIONS(3869),
    [anon_sym_GT_GT_EQ] = ACTIONS(3869),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3869),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3869),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3869),
    [anon_sym_DOT_DOT] = ACTIONS(3871),
    [anon_sym_STAR_STAR] = ACTIONS(3871),
    [anon_sym_PIPE_PIPE] = ACTIONS(3871),
    [anon_sym_SLASH_SLASH] = ACTIONS(3871),
    [anon_sym_AMP_AMP] = ACTIONS(3871),
    [anon_sym_PIPE] = ACTIONS(3871),
    [anon_sym_AMP] = ACTIONS(3871),
    [anon_sym_GT_GT2] = ACTIONS(3871),
    [anon_sym_PLUS] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3871),
    [anon_sym_DOT] = ACTIONS(3871),
    [anon_sym_STAR] = ACTIONS(3871),
    [anon_sym_SLASH] = ACTIONS(3871),
    [anon_sym_x] = ACTIONS(3871),
    [anon_sym_EQ_TILDE] = ACTIONS(3869),
    [anon_sym_BANG_TILDE] = ACTIONS(3869),
    [anon_sym_EQ_EQ] = ACTIONS(3869),
    [anon_sym_BANG_EQ] = ACTIONS(3869),
    [anon_sym_eq] = ACTIONS(3869),
    [anon_sym_ne] = ACTIONS(3869),
    [anon_sym_LT_EQ_GT] = ACTIONS(3869),
    [anon_sym_cmp] = ACTIONS(3869),
    [anon_sym_TILDE_TILDE] = ACTIONS(3869),
    [anon_sym_LT_EQ] = ACTIONS(3871),
    [anon_sym_GT_EQ] = ACTIONS(3869),
    [anon_sym_lt] = ACTIONS(3869),
    [anon_sym_le] = ACTIONS(3869),
    [anon_sym_ge] = ACTIONS(3869),
    [anon_sym_gt] = ACTIONS(3869),
    [anon_sym_isa] = ACTIONS(3869),
    [anon_sym_PLUS_PLUS] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(3869),
    [anon_sym_QMARK] = ACTIONS(3869),
    [anon_sym_EQ_GT] = ACTIONS(3869),
    [anon_sym_for] = ACTIONS(3871),
    [anon_sym_foreach] = ACTIONS(3869),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3869),
    [anon_sym___END__] = ACTIONS(3869),
    [anon_sym_EOT] = ACTIONS(3869),
    [anon_sym_if] = ACTIONS(3869),
    [anon_sym_unless] = ACTIONS(3869),
    [anon_sym_while] = ACTIONS(3869),
    [anon_sym_until] = ACTIONS(3869),
    [sym__PERLY_SEMICOLON] = ACTIONS(3869),
    [sym__ctrl_z_hack] = ACTIONS(3869),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1257] = {
    [sym_heredoc_content] = STATE(1257),
    [anon_sym_SEMI] = ACTIONS(3873),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3873),
    [anon_sym_and] = ACTIONS(3873),
    [anon_sym_or] = ACTIONS(3873),
    [anon_sym_DASH_GT] = ACTIONS(3873),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_LT] = ACTIONS(3875),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_LT_LT] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3875),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3873),
    [anon_sym_PLUS_EQ] = ACTIONS(3873),
    [anon_sym_DASH_EQ] = ACTIONS(3873),
    [anon_sym_DOT_EQ] = ACTIONS(3873),
    [anon_sym_STAR_EQ] = ACTIONS(3873),
    [anon_sym_SLASH_EQ] = ACTIONS(3873),
    [anon_sym_PERCENT_EQ] = ACTIONS(3873),
    [anon_sym_x_EQ] = ACTIONS(3873),
    [anon_sym_AMP_EQ] = ACTIONS(3873),
    [anon_sym_PIPE_EQ] = ACTIONS(3873),
    [anon_sym_CARET_EQ] = ACTIONS(3873),
    [anon_sym_LT_LT_EQ] = ACTIONS(3873),
    [anon_sym_GT_GT_EQ] = ACTIONS(3873),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3873),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3873),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3873),
    [anon_sym_DOT_DOT] = ACTIONS(3875),
    [anon_sym_STAR_STAR] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_SLASH_SLASH] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_PIPE] = ACTIONS(3875),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_GT_GT2] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_SLASH] = ACTIONS(3875),
    [anon_sym_x] = ACTIONS(3875),
    [anon_sym_EQ_TILDE] = ACTIONS(3873),
    [anon_sym_BANG_TILDE] = ACTIONS(3873),
    [anon_sym_EQ_EQ] = ACTIONS(3873),
    [anon_sym_BANG_EQ] = ACTIONS(3873),
    [anon_sym_eq] = ACTIONS(3873),
    [anon_sym_ne] = ACTIONS(3873),
    [anon_sym_LT_EQ_GT] = ACTIONS(3873),
    [anon_sym_cmp] = ACTIONS(3873),
    [anon_sym_TILDE_TILDE] = ACTIONS(3873),
    [anon_sym_LT_EQ] = ACTIONS(3875),
    [anon_sym_GT_EQ] = ACTIONS(3873),
    [anon_sym_lt] = ACTIONS(3873),
    [anon_sym_le] = ACTIONS(3873),
    [anon_sym_ge] = ACTIONS(3873),
    [anon_sym_gt] = ACTIONS(3873),
    [anon_sym_isa] = ACTIONS(3873),
    [anon_sym_PLUS_PLUS] = ACTIONS(3873),
    [anon_sym_DASH_DASH] = ACTIONS(3873),
    [anon_sym_QMARK] = ACTIONS(3873),
    [anon_sym_EQ_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_foreach] = ACTIONS(3873),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3873),
    [anon_sym___END__] = ACTIONS(3873),
    [anon_sym_EOT] = ACTIONS(3873),
    [anon_sym_if] = ACTIONS(3873),
    [anon_sym_unless] = ACTIONS(3873),
    [anon_sym_while] = ACTIONS(3873),
    [anon_sym_until] = ACTIONS(3873),
    [sym__PERLY_SEMICOLON] = ACTIONS(3873),
    [sym__ctrl_z_hack] = ACTIONS(3873),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1258] = {
    [sym_heredoc_content] = STATE(1258),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1259] = {
    [sym_heredoc_content] = STATE(1259),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1260] = {
    [sym_heredoc_content] = STATE(1260),
    [anon_sym_SEMI] = ACTIONS(3877),
    [anon_sym_COMMA] = ACTIONS(3877),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3877),
    [anon_sym_and] = ACTIONS(3877),
    [anon_sym_or] = ACTIONS(3877),
    [anon_sym_DASH_GT] = ACTIONS(3877),
    [anon_sym_PERCENT] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3877),
    [anon_sym_PLUS_EQ] = ACTIONS(3877),
    [anon_sym_DASH_EQ] = ACTIONS(3877),
    [anon_sym_DOT_EQ] = ACTIONS(3877),
    [anon_sym_STAR_EQ] = ACTIONS(3877),
    [anon_sym_SLASH_EQ] = ACTIONS(3877),
    [anon_sym_PERCENT_EQ] = ACTIONS(3877),
    [anon_sym_x_EQ] = ACTIONS(3877),
    [anon_sym_AMP_EQ] = ACTIONS(3877),
    [anon_sym_PIPE_EQ] = ACTIONS(3877),
    [anon_sym_CARET_EQ] = ACTIONS(3877),
    [anon_sym_LT_LT_EQ] = ACTIONS(3877),
    [anon_sym_GT_GT_EQ] = ACTIONS(3877),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3877),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3877),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3877),
    [anon_sym_DOT_DOT] = ACTIONS(3879),
    [anon_sym_STAR_STAR] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [anon_sym_SLASH_SLASH] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT2] = ACTIONS(3879),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_DOT] = ACTIONS(3879),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_SLASH] = ACTIONS(3879),
    [anon_sym_x] = ACTIONS(3879),
    [anon_sym_EQ_TILDE] = ACTIONS(3877),
    [anon_sym_BANG_TILDE] = ACTIONS(3877),
    [anon_sym_EQ_EQ] = ACTIONS(3877),
    [anon_sym_BANG_EQ] = ACTIONS(3877),
    [anon_sym_eq] = ACTIONS(3877),
    [anon_sym_ne] = ACTIONS(3877),
    [anon_sym_LT_EQ_GT] = ACTIONS(3877),
    [anon_sym_cmp] = ACTIONS(3877),
    [anon_sym_TILDE_TILDE] = ACTIONS(3877),
    [anon_sym_LT_EQ] = ACTIONS(3879),
    [anon_sym_GT_EQ] = ACTIONS(3877),
    [anon_sym_lt] = ACTIONS(3877),
    [anon_sym_le] = ACTIONS(3877),
    [anon_sym_ge] = ACTIONS(3877),
    [anon_sym_gt] = ACTIONS(3877),
    [anon_sym_isa] = ACTIONS(3877),
    [anon_sym_PLUS_PLUS] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3877),
    [anon_sym_QMARK] = ACTIONS(3877),
    [anon_sym_EQ_GT] = ACTIONS(3877),
    [anon_sym_for] = ACTIONS(3879),
    [anon_sym_foreach] = ACTIONS(3877),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3877),
    [anon_sym___END__] = ACTIONS(3877),
    [anon_sym_EOT] = ACTIONS(3877),
    [anon_sym_if] = ACTIONS(3877),
    [anon_sym_unless] = ACTIONS(3877),
    [anon_sym_while] = ACTIONS(3877),
    [anon_sym_until] = ACTIONS(3877),
    [sym__PERLY_SEMICOLON] = ACTIONS(3877),
    [sym__ctrl_z_hack] = ACTIONS(3877),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1261] = {
    [sym_heredoc_content] = STATE(1261),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_GT] = ACTIONS(3883),
    [anon_sym_LT_LT] = ACTIONS(3883),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3881),
    [anon_sym_PLUS_EQ] = ACTIONS(3881),
    [anon_sym_DASH_EQ] = ACTIONS(3881),
    [anon_sym_DOT_EQ] = ACTIONS(3881),
    [anon_sym_STAR_EQ] = ACTIONS(3881),
    [anon_sym_SLASH_EQ] = ACTIONS(3881),
    [anon_sym_PERCENT_EQ] = ACTIONS(3881),
    [anon_sym_x_EQ] = ACTIONS(3881),
    [anon_sym_AMP_EQ] = ACTIONS(3881),
    [anon_sym_PIPE_EQ] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(3881),
    [anon_sym_LT_LT_EQ] = ACTIONS(3881),
    [anon_sym_GT_GT_EQ] = ACTIONS(3881),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3881),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3881),
    [anon_sym_DOT_DOT] = ACTIONS(3883),
    [anon_sym_STAR_STAR] = ACTIONS(3883),
    [anon_sym_PIPE_PIPE] = ACTIONS(3883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(3883),
    [anon_sym_PIPE] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3883),
    [anon_sym_GT_GT2] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3883),
    [anon_sym_DOT] = ACTIONS(3883),
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_SLASH] = ACTIONS(3883),
    [anon_sym_x] = ACTIONS(3883),
    [anon_sym_EQ_TILDE] = ACTIONS(3881),
    [anon_sym_BANG_TILDE] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_eq] = ACTIONS(3881),
    [anon_sym_ne] = ACTIONS(3881),
    [anon_sym_LT_EQ_GT] = ACTIONS(3881),
    [anon_sym_cmp] = ACTIONS(3881),
    [anon_sym_TILDE_TILDE] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3883),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_lt] = ACTIONS(3881),
    [anon_sym_le] = ACTIONS(3881),
    [anon_sym_ge] = ACTIONS(3881),
    [anon_sym_gt] = ACTIONS(3881),
    [anon_sym_isa] = ACTIONS(3881),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_EQ_GT] = ACTIONS(3881),
    [anon_sym_for] = ACTIONS(3883),
    [anon_sym_foreach] = ACTIONS(3881),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3881),
    [anon_sym___END__] = ACTIONS(3881),
    [anon_sym_EOT] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_unless] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_until] = ACTIONS(3881),
    [sym__PERLY_SEMICOLON] = ACTIONS(3881),
    [sym__ctrl_z_hack] = ACTIONS(3881),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1262] = {
    [sym_heredoc_content] = STATE(1262),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1263] = {
    [sym_heredoc_content] = STATE(1263),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1264] = {
    [sym_heredoc_content] = STATE(1264),
    [anon_sym_SEMI] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3885),
    [anon_sym_PLUS_EQ] = ACTIONS(3885),
    [anon_sym_DASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_EQ] = ACTIONS(3885),
    [anon_sym_STAR_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_PERCENT_EQ] = ACTIONS(3885),
    [anon_sym_x_EQ] = ACTIONS(3885),
    [anon_sym_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_CARET_EQ] = ACTIONS(3885),
    [anon_sym_LT_LT_EQ] = ACTIONS(3885),
    [anon_sym_GT_GT_EQ] = ACTIONS(3885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_DOT] = ACTIONS(3887),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3887),
    [anon_sym_SLASH_SLASH] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_eq] = ACTIONS(3885),
    [anon_sym_ne] = ACTIONS(3885),
    [anon_sym_LT_EQ_GT] = ACTIONS(3885),
    [anon_sym_cmp] = ACTIONS(3885),
    [anon_sym_TILDE_TILDE] = ACTIONS(3885),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_EQ_GT] = ACTIONS(3885),
    [anon_sym_for] = ACTIONS(3887),
    [anon_sym_foreach] = ACTIONS(3885),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3885),
    [anon_sym___END__] = ACTIONS(3885),
    [anon_sym_EOT] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_unless] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_until] = ACTIONS(3885),
    [sym__PERLY_SEMICOLON] = ACTIONS(3885),
    [sym__ctrl_z_hack] = ACTIONS(3885),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1265] = {
    [sym_heredoc_content] = STATE(1265),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_and] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2936),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_EQ] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_x_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2936),
    [anon_sym_BANG_TILDE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_eq] = ACTIONS(2936),
    [anon_sym_ne] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_cmp] = ACTIONS(2936),
    [anon_sym_TILDE_TILDE] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_lt] = ACTIONS(2936),
    [anon_sym_le] = ACTIONS(2936),
    [anon_sym_ge] = ACTIONS(2936),
    [anon_sym_gt] = ACTIONS(2936),
    [anon_sym_isa] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_foreach] = ACTIONS(2936),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(2936),
    [anon_sym___END__] = ACTIONS(2936),
    [anon_sym_EOT] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_unless] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_until] = ACTIONS(2936),
    [sym__PERLY_SEMICOLON] = ACTIONS(2936),
    [sym__ctrl_z_hack] = ACTIONS(2936),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1266] = {
    [sym_heredoc_content] = STATE(1266),
    [anon_sym_SEMI] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_DASH_GT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_GT] = ACTIONS(3891),
    [anon_sym_LT_LT] = ACTIONS(3891),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3889),
    [anon_sym_PLUS_EQ] = ACTIONS(3889),
    [anon_sym_DASH_EQ] = ACTIONS(3889),
    [anon_sym_DOT_EQ] = ACTIONS(3889),
    [anon_sym_STAR_EQ] = ACTIONS(3889),
    [anon_sym_SLASH_EQ] = ACTIONS(3889),
    [anon_sym_PERCENT_EQ] = ACTIONS(3889),
    [anon_sym_x_EQ] = ACTIONS(3889),
    [anon_sym_AMP_EQ] = ACTIONS(3889),
    [anon_sym_PIPE_EQ] = ACTIONS(3889),
    [anon_sym_CARET_EQ] = ACTIONS(3889),
    [anon_sym_LT_LT_EQ] = ACTIONS(3889),
    [anon_sym_GT_GT_EQ] = ACTIONS(3889),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3889),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3889),
    [anon_sym_DOT_DOT] = ACTIONS(3891),
    [anon_sym_STAR_STAR] = ACTIONS(3891),
    [anon_sym_PIPE_PIPE] = ACTIONS(3891),
    [anon_sym_SLASH_SLASH] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_PIPE] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3891),
    [anon_sym_GT_GT2] = ACTIONS(3891),
    [anon_sym_PLUS] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3891),
    [anon_sym_DOT] = ACTIONS(3891),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_SLASH] = ACTIONS(3891),
    [anon_sym_x] = ACTIONS(3891),
    [anon_sym_EQ_TILDE] = ACTIONS(3889),
    [anon_sym_BANG_TILDE] = ACTIONS(3889),
    [anon_sym_EQ_EQ] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_eq] = ACTIONS(3889),
    [anon_sym_ne] = ACTIONS(3889),
    [anon_sym_LT_EQ_GT] = ACTIONS(3889),
    [anon_sym_cmp] = ACTIONS(3889),
    [anon_sym_TILDE_TILDE] = ACTIONS(3889),
    [anon_sym_LT_EQ] = ACTIONS(3891),
    [anon_sym_GT_EQ] = ACTIONS(3889),
    [anon_sym_lt] = ACTIONS(3889),
    [anon_sym_le] = ACTIONS(3889),
    [anon_sym_ge] = ACTIONS(3889),
    [anon_sym_gt] = ACTIONS(3889),
    [anon_sym_isa] = ACTIONS(3889),
    [anon_sym_PLUS_PLUS] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_EQ_GT] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3891),
    [anon_sym_foreach] = ACTIONS(3889),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3889),
    [anon_sym___END__] = ACTIONS(3889),
    [anon_sym_EOT] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_unless] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_until] = ACTIONS(3889),
    [sym__PERLY_SEMICOLON] = ACTIONS(3889),
    [sym__ctrl_z_hack] = ACTIONS(3889),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1267] = {
    [sym_heredoc_content] = STATE(1267),
    [anon_sym_SEMI] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3893),
    [anon_sym_and] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_DASH_GT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_LT_LT] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3895),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3893),
    [anon_sym_PLUS_EQ] = ACTIONS(3893),
    [anon_sym_DASH_EQ] = ACTIONS(3893),
    [anon_sym_DOT_EQ] = ACTIONS(3893),
    [anon_sym_STAR_EQ] = ACTIONS(3893),
    [anon_sym_SLASH_EQ] = ACTIONS(3893),
    [anon_sym_PERCENT_EQ] = ACTIONS(3893),
    [anon_sym_x_EQ] = ACTIONS(3893),
    [anon_sym_AMP_EQ] = ACTIONS(3893),
    [anon_sym_PIPE_EQ] = ACTIONS(3893),
    [anon_sym_CARET_EQ] = ACTIONS(3893),
    [anon_sym_LT_LT_EQ] = ACTIONS(3893),
    [anon_sym_GT_GT_EQ] = ACTIONS(3893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3893),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3893),
    [anon_sym_DOT_DOT] = ACTIONS(3895),
    [anon_sym_STAR_STAR] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_SLASH_SLASH] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_GT_GT2] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_SLASH] = ACTIONS(3895),
    [anon_sym_x] = ACTIONS(3895),
    [anon_sym_EQ_TILDE] = ACTIONS(3893),
    [anon_sym_BANG_TILDE] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_eq] = ACTIONS(3893),
    [anon_sym_ne] = ACTIONS(3893),
    [anon_sym_LT_EQ_GT] = ACTIONS(3893),
    [anon_sym_cmp] = ACTIONS(3893),
    [anon_sym_TILDE_TILDE] = ACTIONS(3893),
    [anon_sym_LT_EQ] = ACTIONS(3895),
    [anon_sym_GT_EQ] = ACTIONS(3893),
    [anon_sym_lt] = ACTIONS(3893),
    [anon_sym_le] = ACTIONS(3893),
    [anon_sym_ge] = ACTIONS(3893),
    [anon_sym_gt] = ACTIONS(3893),
    [anon_sym_isa] = ACTIONS(3893),
    [anon_sym_PLUS_PLUS] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_EQ_GT] = ACTIONS(3893),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_foreach] = ACTIONS(3893),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3893),
    [anon_sym___END__] = ACTIONS(3893),
    [anon_sym_EOT] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_unless] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_until] = ACTIONS(3893),
    [sym__PERLY_SEMICOLON] = ACTIONS(3893),
    [sym__ctrl_z_hack] = ACTIONS(3893),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1268] = {
    [sym_heredoc_content] = STATE(1268),
    [anon_sym_SEMI] = ACTIONS(3897),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3897),
    [anon_sym_and] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3897),
    [anon_sym_DASH_GT] = ACTIONS(3897),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3899),
    [anon_sym_GT] = ACTIONS(3899),
    [anon_sym_LT_LT] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3897),
    [anon_sym_PLUS_EQ] = ACTIONS(3897),
    [anon_sym_DASH_EQ] = ACTIONS(3897),
    [anon_sym_DOT_EQ] = ACTIONS(3897),
    [anon_sym_STAR_EQ] = ACTIONS(3897),
    [anon_sym_SLASH_EQ] = ACTIONS(3897),
    [anon_sym_PERCENT_EQ] = ACTIONS(3897),
    [anon_sym_x_EQ] = ACTIONS(3897),
    [anon_sym_AMP_EQ] = ACTIONS(3897),
    [anon_sym_PIPE_EQ] = ACTIONS(3897),
    [anon_sym_CARET_EQ] = ACTIONS(3897),
    [anon_sym_LT_LT_EQ] = ACTIONS(3897),
    [anon_sym_GT_GT_EQ] = ACTIONS(3897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3897),
    [anon_sym_DOT_DOT] = ACTIONS(3899),
    [anon_sym_STAR_STAR] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_SLASH_SLASH] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_GT_GT2] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_SLASH] = ACTIONS(3899),
    [anon_sym_x] = ACTIONS(3899),
    [anon_sym_EQ_TILDE] = ACTIONS(3897),
    [anon_sym_BANG_TILDE] = ACTIONS(3897),
    [anon_sym_EQ_EQ] = ACTIONS(3897),
    [anon_sym_BANG_EQ] = ACTIONS(3897),
    [anon_sym_eq] = ACTIONS(3897),
    [anon_sym_ne] = ACTIONS(3897),
    [anon_sym_LT_EQ_GT] = ACTIONS(3897),
    [anon_sym_cmp] = ACTIONS(3897),
    [anon_sym_TILDE_TILDE] = ACTIONS(3897),
    [anon_sym_LT_EQ] = ACTIONS(3899),
    [anon_sym_GT_EQ] = ACTIONS(3897),
    [anon_sym_lt] = ACTIONS(3897),
    [anon_sym_le] = ACTIONS(3897),
    [anon_sym_ge] = ACTIONS(3897),
    [anon_sym_gt] = ACTIONS(3897),
    [anon_sym_isa] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_QMARK] = ACTIONS(3897),
    [anon_sym_EQ_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_foreach] = ACTIONS(3897),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3897),
    [anon_sym___END__] = ACTIONS(3897),
    [anon_sym_EOT] = ACTIONS(3897),
    [anon_sym_if] = ACTIONS(3897),
    [anon_sym_unless] = ACTIONS(3897),
    [anon_sym_while] = ACTIONS(3897),
    [anon_sym_until] = ACTIONS(3897),
    [sym__PERLY_SEMICOLON] = ACTIONS(3897),
    [sym__ctrl_z_hack] = ACTIONS(3897),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1269] = {
    [sym_heredoc_content] = STATE(1269),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3901),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_PERCENT] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_LT_LT] = ACTIONS(3903),
    [anon_sym_EQ] = ACTIONS(3903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3901),
    [anon_sym_PLUS_EQ] = ACTIONS(3901),
    [anon_sym_DASH_EQ] = ACTIONS(3901),
    [anon_sym_DOT_EQ] = ACTIONS(3901),
    [anon_sym_STAR_EQ] = ACTIONS(3901),
    [anon_sym_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_PERCENT_EQ] = ACTIONS(3901),
    [anon_sym_x_EQ] = ACTIONS(3901),
    [anon_sym_AMP_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_CARET_EQ] = ACTIONS(3901),
    [anon_sym_LT_LT_EQ] = ACTIONS(3901),
    [anon_sym_GT_GT_EQ] = ACTIONS(3901),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_DOT_DOT] = ACTIONS(3903),
    [anon_sym_STAR_STAR] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_SLASH_SLASH] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3903),
    [anon_sym_GT_GT2] = ACTIONS(3903),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_DOT] = ACTIONS(3903),
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_SLASH] = ACTIONS(3903),
    [anon_sym_x] = ACTIONS(3903),
    [anon_sym_EQ_TILDE] = ACTIONS(3901),
    [anon_sym_BANG_TILDE] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_eq] = ACTIONS(3901),
    [anon_sym_ne] = ACTIONS(3901),
    [anon_sym_LT_EQ_GT] = ACTIONS(3901),
    [anon_sym_cmp] = ACTIONS(3901),
    [anon_sym_TILDE_TILDE] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3903),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_lt] = ACTIONS(3901),
    [anon_sym_le] = ACTIONS(3901),
    [anon_sym_ge] = ACTIONS(3901),
    [anon_sym_gt] = ACTIONS(3901),
    [anon_sym_isa] = ACTIONS(3901),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_QMARK] = ACTIONS(3901),
    [anon_sym_EQ_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3903),
    [anon_sym_foreach] = ACTIONS(3901),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3901),
    [anon_sym___END__] = ACTIONS(3901),
    [anon_sym_EOT] = ACTIONS(3901),
    [anon_sym_if] = ACTIONS(3901),
    [anon_sym_unless] = ACTIONS(3901),
    [anon_sym_while] = ACTIONS(3901),
    [anon_sym_until] = ACTIONS(3901),
    [sym__PERLY_SEMICOLON] = ACTIONS(3901),
    [sym__ctrl_z_hack] = ACTIONS(3901),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1270] = {
    [sym_heredoc_content] = STATE(1270),
    [anon_sym_SEMI] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3885),
    [anon_sym_PLUS_EQ] = ACTIONS(3885),
    [anon_sym_DASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_EQ] = ACTIONS(3885),
    [anon_sym_STAR_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_PERCENT_EQ] = ACTIONS(3885),
    [anon_sym_x_EQ] = ACTIONS(3885),
    [anon_sym_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_CARET_EQ] = ACTIONS(3885),
    [anon_sym_LT_LT_EQ] = ACTIONS(3885),
    [anon_sym_GT_GT_EQ] = ACTIONS(3885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_DOT] = ACTIONS(3887),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3887),
    [anon_sym_SLASH_SLASH] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3905),
    [anon_sym_cmp] = ACTIONS(3905),
    [anon_sym_TILDE_TILDE] = ACTIONS(3905),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_EQ_GT] = ACTIONS(3885),
    [anon_sym_for] = ACTIONS(3887),
    [anon_sym_foreach] = ACTIONS(3885),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3885),
    [anon_sym___END__] = ACTIONS(3885),
    [anon_sym_EOT] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_unless] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_until] = ACTIONS(3885),
    [sym__PERLY_SEMICOLON] = ACTIONS(3885),
    [sym__ctrl_z_hack] = ACTIONS(3885),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1271] = {
    [sym_heredoc_content] = STATE(1271),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3831),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3833),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3831),
    [anon_sym_PLUS_EQ] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_EQ] = ACTIONS(3831),
    [anon_sym_STAR_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3831),
    [anon_sym_x_EQ] = ACTIONS(3831),
    [anon_sym_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3833),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3833),
    [anon_sym_SLASH_SLASH] = ACTIONS(3833),
    [anon_sym_AMP_AMP] = ACTIONS(3833),
    [anon_sym_PIPE] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(3833),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3831),
    [anon_sym_BANG_EQ] = ACTIONS(3831),
    [anon_sym_eq] = ACTIONS(3831),
    [anon_sym_ne] = ACTIONS(3831),
    [anon_sym_LT_EQ_GT] = ACTIONS(3831),
    [anon_sym_cmp] = ACTIONS(3831),
    [anon_sym_TILDE_TILDE] = ACTIONS(3831),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3907),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3831),
    [anon_sym_EQ_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3833),
    [anon_sym_foreach] = ACTIONS(3831),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3831),
    [anon_sym___END__] = ACTIONS(3831),
    [anon_sym_EOT] = ACTIONS(3831),
    [anon_sym_if] = ACTIONS(3831),
    [anon_sym_unless] = ACTIONS(3831),
    [anon_sym_while] = ACTIONS(3831),
    [anon_sym_until] = ACTIONS(3831),
    [sym__PERLY_SEMICOLON] = ACTIONS(3831),
    [sym__ctrl_z_hack] = ACTIONS(3831),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1272] = {
    [sym_heredoc_content] = STATE(1272),
    [anon_sym_SEMI] = ACTIONS(3909),
    [anon_sym_COMMA] = ACTIONS(3909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3909),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_EQ] = ACTIONS(3911),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3909),
    [anon_sym_PLUS_EQ] = ACTIONS(3909),
    [anon_sym_DASH_EQ] = ACTIONS(3909),
    [anon_sym_DOT_EQ] = ACTIONS(3909),
    [anon_sym_STAR_EQ] = ACTIONS(3909),
    [anon_sym_SLASH_EQ] = ACTIONS(3909),
    [anon_sym_PERCENT_EQ] = ACTIONS(3909),
    [anon_sym_x_EQ] = ACTIONS(3909),
    [anon_sym_AMP_EQ] = ACTIONS(3909),
    [anon_sym_PIPE_EQ] = ACTIONS(3909),
    [anon_sym_CARET_EQ] = ACTIONS(3909),
    [anon_sym_LT_LT_EQ] = ACTIONS(3909),
    [anon_sym_GT_GT_EQ] = ACTIONS(3909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3909),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3909),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_STAR_STAR] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_SLASH_SLASH] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3911),
    [anon_sym_GT_GT2] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3911),
    [anon_sym_DASH] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3911),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3911),
    [anon_sym_x] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3909),
    [anon_sym_BANG_TILDE] = ACTIONS(3909),
    [anon_sym_EQ_EQ] = ACTIONS(3909),
    [anon_sym_BANG_EQ] = ACTIONS(3909),
    [anon_sym_eq] = ACTIONS(3909),
    [anon_sym_ne] = ACTIONS(3909),
    [anon_sym_LT_EQ_GT] = ACTIONS(3909),
    [anon_sym_cmp] = ACTIONS(3909),
    [anon_sym_TILDE_TILDE] = ACTIONS(3909),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3909),
    [anon_sym_lt] = ACTIONS(3909),
    [anon_sym_le] = ACTIONS(3909),
    [anon_sym_ge] = ACTIONS(3909),
    [anon_sym_gt] = ACTIONS(3909),
    [anon_sym_isa] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3909),
    [anon_sym_DASH_DASH] = ACTIONS(3909),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_EQ_GT] = ACTIONS(3909),
    [anon_sym_for] = ACTIONS(3911),
    [anon_sym_foreach] = ACTIONS(3909),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3909),
    [anon_sym___END__] = ACTIONS(3909),
    [anon_sym_EOT] = ACTIONS(3909),
    [anon_sym_if] = ACTIONS(3909),
    [anon_sym_unless] = ACTIONS(3909),
    [anon_sym_while] = ACTIONS(3909),
    [anon_sym_until] = ACTIONS(3909),
    [sym__PERLY_SEMICOLON] = ACTIONS(3909),
    [sym__ctrl_z_hack] = ACTIONS(3909),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1273] = {
    [sym_heredoc_content] = STATE(1273),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(3823),
    [anon_sym_BANG_TILDE] = ACTIONS(3823),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_unless] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_until] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1274] = {
    [sym_heredoc_content] = STATE(1274),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_COMMA] = ACTIONS(3913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3913),
    [anon_sym_and] = ACTIONS(3913),
    [anon_sym_or] = ACTIONS(3913),
    [anon_sym_DASH_GT] = ACTIONS(3913),
    [anon_sym_PERCENT] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_LT_LT] = ACTIONS(3915),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3913),
    [anon_sym_PLUS_EQ] = ACTIONS(3913),
    [anon_sym_DASH_EQ] = ACTIONS(3913),
    [anon_sym_DOT_EQ] = ACTIONS(3913),
    [anon_sym_STAR_EQ] = ACTIONS(3913),
    [anon_sym_SLASH_EQ] = ACTIONS(3913),
    [anon_sym_PERCENT_EQ] = ACTIONS(3913),
    [anon_sym_x_EQ] = ACTIONS(3913),
    [anon_sym_AMP_EQ] = ACTIONS(3913),
    [anon_sym_PIPE_EQ] = ACTIONS(3913),
    [anon_sym_CARET_EQ] = ACTIONS(3913),
    [anon_sym_LT_LT_EQ] = ACTIONS(3913),
    [anon_sym_GT_GT_EQ] = ACTIONS(3913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3913),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3915),
    [anon_sym_STAR_STAR] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_SLASH_SLASH] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3915),
    [anon_sym_GT_GT2] = ACTIONS(3915),
    [anon_sym_PLUS] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3915),
    [anon_sym_DOT] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_SLASH] = ACTIONS(3915),
    [anon_sym_x] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3913),
    [anon_sym_BANG_TILDE] = ACTIONS(3913),
    [anon_sym_EQ_EQ] = ACTIONS(3913),
    [anon_sym_BANG_EQ] = ACTIONS(3913),
    [anon_sym_eq] = ACTIONS(3913),
    [anon_sym_ne] = ACTIONS(3913),
    [anon_sym_LT_EQ_GT] = ACTIONS(3913),
    [anon_sym_cmp] = ACTIONS(3913),
    [anon_sym_TILDE_TILDE] = ACTIONS(3913),
    [anon_sym_LT_EQ] = ACTIONS(3915),
    [anon_sym_GT_EQ] = ACTIONS(3913),
    [anon_sym_lt] = ACTIONS(3913),
    [anon_sym_le] = ACTIONS(3913),
    [anon_sym_ge] = ACTIONS(3913),
    [anon_sym_gt] = ACTIONS(3913),
    [anon_sym_isa] = ACTIONS(3913),
    [anon_sym_PLUS_PLUS] = ACTIONS(3913),
    [anon_sym_DASH_DASH] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_EQ_GT] = ACTIONS(3913),
    [anon_sym_for] = ACTIONS(3915),
    [anon_sym_foreach] = ACTIONS(3913),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3913),
    [anon_sym___END__] = ACTIONS(3913),
    [anon_sym_EOT] = ACTIONS(3913),
    [anon_sym_if] = ACTIONS(3913),
    [anon_sym_unless] = ACTIONS(3913),
    [anon_sym_while] = ACTIONS(3913),
    [anon_sym_until] = ACTIONS(3913),
    [sym__PERLY_SEMICOLON] = ACTIONS(3913),
    [sym__ctrl_z_hack] = ACTIONS(3913),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1275] = {
    [sym_heredoc_content] = STATE(1275),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3917),
    [anon_sym_and] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_DASH_GT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3917),
    [anon_sym_PLUS_EQ] = ACTIONS(3917),
    [anon_sym_DASH_EQ] = ACTIONS(3917),
    [anon_sym_DOT_EQ] = ACTIONS(3917),
    [anon_sym_STAR_EQ] = ACTIONS(3917),
    [anon_sym_SLASH_EQ] = ACTIONS(3917),
    [anon_sym_PERCENT_EQ] = ACTIONS(3917),
    [anon_sym_x_EQ] = ACTIONS(3917),
    [anon_sym_AMP_EQ] = ACTIONS(3917),
    [anon_sym_PIPE_EQ] = ACTIONS(3917),
    [anon_sym_CARET_EQ] = ACTIONS(3917),
    [anon_sym_LT_LT_EQ] = ACTIONS(3917),
    [anon_sym_GT_GT_EQ] = ACTIONS(3917),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3917),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3917),
    [anon_sym_DOT_DOT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [anon_sym_SLASH_SLASH] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_GT_GT2] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_DOT] = ACTIONS(3919),
    [anon_sym_STAR] = ACTIONS(3919),
    [anon_sym_SLASH] = ACTIONS(3919),
    [anon_sym_x] = ACTIONS(3919),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_BANG_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_eq] = ACTIONS(3917),
    [anon_sym_ne] = ACTIONS(3917),
    [anon_sym_LT_EQ_GT] = ACTIONS(3917),
    [anon_sym_cmp] = ACTIONS(3917),
    [anon_sym_TILDE_TILDE] = ACTIONS(3917),
    [anon_sym_LT_EQ] = ACTIONS(3919),
    [anon_sym_GT_EQ] = ACTIONS(3917),
    [anon_sym_lt] = ACTIONS(3917),
    [anon_sym_le] = ACTIONS(3917),
    [anon_sym_ge] = ACTIONS(3917),
    [anon_sym_gt] = ACTIONS(3917),
    [anon_sym_isa] = ACTIONS(3917),
    [anon_sym_PLUS_PLUS] = ACTIONS(3917),
    [anon_sym_DASH_DASH] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_EQ_GT] = ACTIONS(3917),
    [anon_sym_for] = ACTIONS(3919),
    [anon_sym_foreach] = ACTIONS(3917),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3917),
    [anon_sym___END__] = ACTIONS(3917),
    [anon_sym_EOT] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_unless] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_until] = ACTIONS(3917),
    [sym__PERLY_SEMICOLON] = ACTIONS(3917),
    [sym__ctrl_z_hack] = ACTIONS(3917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1276] = {
    [sym_heredoc_content] = STATE(1276),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3921),
    [anon_sym_and] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3921),
    [anon_sym_PLUS_EQ] = ACTIONS(3921),
    [anon_sym_DASH_EQ] = ACTIONS(3921),
    [anon_sym_DOT_EQ] = ACTIONS(3921),
    [anon_sym_STAR_EQ] = ACTIONS(3921),
    [anon_sym_SLASH_EQ] = ACTIONS(3921),
    [anon_sym_PERCENT_EQ] = ACTIONS(3921),
    [anon_sym_x_EQ] = ACTIONS(3921),
    [anon_sym_AMP_EQ] = ACTIONS(3921),
    [anon_sym_PIPE_EQ] = ACTIONS(3921),
    [anon_sym_CARET_EQ] = ACTIONS(3921),
    [anon_sym_LT_LT_EQ] = ACTIONS(3921),
    [anon_sym_GT_GT_EQ] = ACTIONS(3921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3921),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3921),
    [anon_sym_DOT_DOT] = ACTIONS(3923),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_GT_GT2] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DOT] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(3923),
    [anon_sym_SLASH] = ACTIONS(3923),
    [anon_sym_x] = ACTIONS(3923),
    [anon_sym_EQ_TILDE] = ACTIONS(3921),
    [anon_sym_BANG_TILDE] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_eq] = ACTIONS(3921),
    [anon_sym_ne] = ACTIONS(3921),
    [anon_sym_LT_EQ_GT] = ACTIONS(3921),
    [anon_sym_cmp] = ACTIONS(3921),
    [anon_sym_TILDE_TILDE] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3923),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_lt] = ACTIONS(3921),
    [anon_sym_le] = ACTIONS(3921),
    [anon_sym_ge] = ACTIONS(3921),
    [anon_sym_gt] = ACTIONS(3921),
    [anon_sym_isa] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_EQ_GT] = ACTIONS(3921),
    [anon_sym_for] = ACTIONS(3923),
    [anon_sym_foreach] = ACTIONS(3921),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3921),
    [anon_sym___END__] = ACTIONS(3921),
    [anon_sym_EOT] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_unless] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_until] = ACTIONS(3921),
    [sym__PERLY_SEMICOLON] = ACTIONS(3921),
    [sym__ctrl_z_hack] = ACTIONS(3921),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1277] = {
    [sym_heredoc_content] = STATE(1277),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3925),
    [anon_sym_and] = ACTIONS(3925),
    [anon_sym_or] = ACTIONS(3925),
    [anon_sym_DASH_GT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3925),
    [anon_sym_PLUS_EQ] = ACTIONS(3925),
    [anon_sym_DASH_EQ] = ACTIONS(3925),
    [anon_sym_DOT_EQ] = ACTIONS(3925),
    [anon_sym_STAR_EQ] = ACTIONS(3925),
    [anon_sym_SLASH_EQ] = ACTIONS(3925),
    [anon_sym_PERCENT_EQ] = ACTIONS(3925),
    [anon_sym_x_EQ] = ACTIONS(3925),
    [anon_sym_AMP_EQ] = ACTIONS(3925),
    [anon_sym_PIPE_EQ] = ACTIONS(3925),
    [anon_sym_CARET_EQ] = ACTIONS(3925),
    [anon_sym_LT_LT_EQ] = ACTIONS(3925),
    [anon_sym_GT_GT_EQ] = ACTIONS(3925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3925),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3925),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT2] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3927),
    [anon_sym_x] = ACTIONS(3927),
    [anon_sym_EQ_TILDE] = ACTIONS(3925),
    [anon_sym_BANG_TILDE] = ACTIONS(3925),
    [anon_sym_EQ_EQ] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_eq] = ACTIONS(3925),
    [anon_sym_ne] = ACTIONS(3925),
    [anon_sym_LT_EQ_GT] = ACTIONS(3925),
    [anon_sym_cmp] = ACTIONS(3925),
    [anon_sym_TILDE_TILDE] = ACTIONS(3925),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3925),
    [anon_sym_lt] = ACTIONS(3925),
    [anon_sym_le] = ACTIONS(3925),
    [anon_sym_ge] = ACTIONS(3925),
    [anon_sym_gt] = ACTIONS(3925),
    [anon_sym_isa] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_EQ_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_foreach] = ACTIONS(3925),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3925),
    [anon_sym___END__] = ACTIONS(3925),
    [anon_sym_EOT] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_unless] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_until] = ACTIONS(3925),
    [sym__PERLY_SEMICOLON] = ACTIONS(3925),
    [sym__ctrl_z_hack] = ACTIONS(3925),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1278] = {
    [sym_heredoc_content] = STATE(1278),
    [anon_sym_SEMI] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3929),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3929),
    [anon_sym_PLUS_EQ] = ACTIONS(3929),
    [anon_sym_DASH_EQ] = ACTIONS(3929),
    [anon_sym_DOT_EQ] = ACTIONS(3929),
    [anon_sym_STAR_EQ] = ACTIONS(3929),
    [anon_sym_SLASH_EQ] = ACTIONS(3929),
    [anon_sym_PERCENT_EQ] = ACTIONS(3929),
    [anon_sym_x_EQ] = ACTIONS(3929),
    [anon_sym_AMP_EQ] = ACTIONS(3929),
    [anon_sym_PIPE_EQ] = ACTIONS(3929),
    [anon_sym_CARET_EQ] = ACTIONS(3929),
    [anon_sym_LT_LT_EQ] = ACTIONS(3929),
    [anon_sym_GT_GT_EQ] = ACTIONS(3929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3929),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3929),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_STAR_STAR] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_GT_GT2] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3931),
    [anon_sym_x] = ACTIONS(3931),
    [anon_sym_EQ_TILDE] = ACTIONS(3929),
    [anon_sym_BANG_TILDE] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_eq] = ACTIONS(3929),
    [anon_sym_ne] = ACTIONS(3929),
    [anon_sym_LT_EQ_GT] = ACTIONS(3929),
    [anon_sym_cmp] = ACTIONS(3929),
    [anon_sym_TILDE_TILDE] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_lt] = ACTIONS(3929),
    [anon_sym_le] = ACTIONS(3929),
    [anon_sym_ge] = ACTIONS(3929),
    [anon_sym_gt] = ACTIONS(3929),
    [anon_sym_isa] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_EQ_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_foreach] = ACTIONS(3929),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3929),
    [anon_sym___END__] = ACTIONS(3929),
    [anon_sym_EOT] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_unless] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_until] = ACTIONS(3929),
    [sym__PERLY_SEMICOLON] = ACTIONS(3929),
    [sym__ctrl_z_hack] = ACTIONS(3929),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1279] = {
    [sym_heredoc_content] = STATE(1279),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(137),
    [anon_sym_foreach] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(255),
    [anon_sym___END__] = ACTIONS(255),
    [anon_sym_EOT] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_unless] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_until] = ACTIONS(255),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__ctrl_z_hack] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1280] = {
    [sym_heredoc_content] = STATE(1280),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3933),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_GT] = ACTIONS(3935),
    [anon_sym_LT_LT] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3933),
    [anon_sym_PLUS_EQ] = ACTIONS(3933),
    [anon_sym_DASH_EQ] = ACTIONS(3933),
    [anon_sym_DOT_EQ] = ACTIONS(3933),
    [anon_sym_STAR_EQ] = ACTIONS(3933),
    [anon_sym_SLASH_EQ] = ACTIONS(3933),
    [anon_sym_PERCENT_EQ] = ACTIONS(3933),
    [anon_sym_x_EQ] = ACTIONS(3933),
    [anon_sym_AMP_EQ] = ACTIONS(3933),
    [anon_sym_PIPE_EQ] = ACTIONS(3933),
    [anon_sym_CARET_EQ] = ACTIONS(3933),
    [anon_sym_LT_LT_EQ] = ACTIONS(3933),
    [anon_sym_GT_GT_EQ] = ACTIONS(3933),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3933),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3933),
    [anon_sym_DOT_DOT] = ACTIONS(3935),
    [anon_sym_STAR_STAR] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_GT_GT2] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_STAR] = ACTIONS(3935),
    [anon_sym_SLASH] = ACTIONS(3935),
    [anon_sym_x] = ACTIONS(3935),
    [anon_sym_EQ_TILDE] = ACTIONS(3933),
    [anon_sym_BANG_TILDE] = ACTIONS(3933),
    [anon_sym_EQ_EQ] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_eq] = ACTIONS(3933),
    [anon_sym_ne] = ACTIONS(3933),
    [anon_sym_LT_EQ_GT] = ACTIONS(3933),
    [anon_sym_cmp] = ACTIONS(3933),
    [anon_sym_TILDE_TILDE] = ACTIONS(3933),
    [anon_sym_LT_EQ] = ACTIONS(3935),
    [anon_sym_GT_EQ] = ACTIONS(3933),
    [anon_sym_lt] = ACTIONS(3933),
    [anon_sym_le] = ACTIONS(3933),
    [anon_sym_ge] = ACTIONS(3933),
    [anon_sym_gt] = ACTIONS(3933),
    [anon_sym_isa] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_EQ_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_foreach] = ACTIONS(3933),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3933),
    [anon_sym___END__] = ACTIONS(3933),
    [anon_sym_EOT] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_unless] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_until] = ACTIONS(3933),
    [sym__PERLY_SEMICOLON] = ACTIONS(3933),
    [sym__ctrl_z_hack] = ACTIONS(3933),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1281] = {
    [sym_heredoc_content] = STATE(1281),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3937),
    [anon_sym_and] = ACTIONS(3937),
    [anon_sym_or] = ACTIONS(3937),
    [anon_sym_DASH_GT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3939),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3937),
    [anon_sym_PLUS_EQ] = ACTIONS(3937),
    [anon_sym_DASH_EQ] = ACTIONS(3937),
    [anon_sym_DOT_EQ] = ACTIONS(3937),
    [anon_sym_STAR_EQ] = ACTIONS(3937),
    [anon_sym_SLASH_EQ] = ACTIONS(3937),
    [anon_sym_PERCENT_EQ] = ACTIONS(3937),
    [anon_sym_x_EQ] = ACTIONS(3937),
    [anon_sym_AMP_EQ] = ACTIONS(3937),
    [anon_sym_PIPE_EQ] = ACTIONS(3937),
    [anon_sym_CARET_EQ] = ACTIONS(3937),
    [anon_sym_LT_LT_EQ] = ACTIONS(3937),
    [anon_sym_GT_GT_EQ] = ACTIONS(3937),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3937),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3937),
    [anon_sym_DOT_DOT] = ACTIONS(3939),
    [anon_sym_STAR_STAR] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3939),
    [anon_sym_GT_GT2] = ACTIONS(3939),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_DASH] = ACTIONS(3939),
    [anon_sym_DOT] = ACTIONS(3939),
    [anon_sym_STAR] = ACTIONS(3939),
    [anon_sym_SLASH] = ACTIONS(3939),
    [anon_sym_x] = ACTIONS(3939),
    [anon_sym_EQ_TILDE] = ACTIONS(3937),
    [anon_sym_BANG_TILDE] = ACTIONS(3937),
    [anon_sym_EQ_EQ] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_eq] = ACTIONS(3937),
    [anon_sym_ne] = ACTIONS(3937),
    [anon_sym_LT_EQ_GT] = ACTIONS(3937),
    [anon_sym_cmp] = ACTIONS(3937),
    [anon_sym_TILDE_TILDE] = ACTIONS(3937),
    [anon_sym_LT_EQ] = ACTIONS(3939),
    [anon_sym_GT_EQ] = ACTIONS(3937),
    [anon_sym_lt] = ACTIONS(3937),
    [anon_sym_le] = ACTIONS(3937),
    [anon_sym_ge] = ACTIONS(3937),
    [anon_sym_gt] = ACTIONS(3937),
    [anon_sym_isa] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3937),
    [anon_sym_DASH_DASH] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_EQ_GT] = ACTIONS(3937),
    [anon_sym_for] = ACTIONS(3939),
    [anon_sym_foreach] = ACTIONS(3937),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3937),
    [anon_sym___END__] = ACTIONS(3937),
    [anon_sym_EOT] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_unless] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_until] = ACTIONS(3937),
    [sym__PERLY_SEMICOLON] = ACTIONS(3937),
    [sym__ctrl_z_hack] = ACTIONS(3937),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1282] = {
    [sym_heredoc_content] = STATE(1282),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_and] = ACTIONS(3941),
    [anon_sym_or] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_GT] = ACTIONS(3943),
    [anon_sym_LT_LT] = ACTIONS(3943),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DOT_EQ] = ACTIONS(3941),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_x_EQ] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_DOT_DOT] = ACTIONS(3943),
    [anon_sym_STAR_STAR] = ACTIONS(3943),
    [anon_sym_PIPE_PIPE] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3943),
    [anon_sym_AMP_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_GT_GT2] = ACTIONS(3943),
    [anon_sym_PLUS] = ACTIONS(3943),
    [anon_sym_DASH] = ACTIONS(3943),
    [anon_sym_DOT] = ACTIONS(3943),
    [anon_sym_STAR] = ACTIONS(3943),
    [anon_sym_SLASH] = ACTIONS(3943),
    [anon_sym_x] = ACTIONS(3943),
    [anon_sym_EQ_TILDE] = ACTIONS(3941),
    [anon_sym_BANG_TILDE] = ACTIONS(3941),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_eq] = ACTIONS(3941),
    [anon_sym_ne] = ACTIONS(3941),
    [anon_sym_LT_EQ_GT] = ACTIONS(3941),
    [anon_sym_cmp] = ACTIONS(3941),
    [anon_sym_TILDE_TILDE] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3943),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_lt] = ACTIONS(3941),
    [anon_sym_le] = ACTIONS(3941),
    [anon_sym_ge] = ACTIONS(3941),
    [anon_sym_gt] = ACTIONS(3941),
    [anon_sym_isa] = ACTIONS(3941),
    [anon_sym_PLUS_PLUS] = ACTIONS(3941),
    [anon_sym_DASH_DASH] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_EQ_GT] = ACTIONS(3941),
    [anon_sym_for] = ACTIONS(3943),
    [anon_sym_foreach] = ACTIONS(3941),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3941),
    [anon_sym___END__] = ACTIONS(3941),
    [anon_sym_EOT] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_unless] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_until] = ACTIONS(3941),
    [sym__PERLY_SEMICOLON] = ACTIONS(3941),
    [sym__ctrl_z_hack] = ACTIONS(3941),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1283] = {
    [sym_attribute] = STATE(1374),
    [sym_attribute_name] = STATE(1369),
    [sym_heredoc_content] = STATE(1283),
    [aux_sym_attrlist_repeat1] = STATE(1303),
    [sym__identifier] = ACTIONS(3945),
    [anon_sym_COLON] = ACTIONS(3947),
    [anon_sym_SEMI] = ACTIONS(3416),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3416),
    [anon_sym_and] = ACTIONS(3418),
    [anon_sym_or] = ACTIONS(3418),
    [anon_sym_DASH_GT] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(3418),
    [anon_sym_GT] = ACTIONS(3418),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3416),
    [anon_sym_PLUS_EQ] = ACTIONS(3416),
    [anon_sym_DASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_EQ] = ACTIONS(3416),
    [anon_sym_STAR_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_PERCENT_EQ] = ACTIONS(3416),
    [anon_sym_x_EQ] = ACTIONS(3416),
    [anon_sym_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_CARET_EQ] = ACTIONS(3416),
    [anon_sym_LT_LT_EQ] = ACTIONS(3416),
    [anon_sym_GT_GT_EQ] = ACTIONS(3416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_DOT] = ACTIONS(3418),
    [anon_sym_STAR_STAR] = ACTIONS(3418),
    [anon_sym_PIPE_PIPE] = ACTIONS(3418),
    [anon_sym_SLASH_SLASH] = ACTIONS(3418),
    [anon_sym_AMP_AMP] = ACTIONS(3418),
    [anon_sym_PIPE] = ACTIONS(3418),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_GT_GT2] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_DOT] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3418),
    [anon_sym_SLASH] = ACTIONS(3418),
    [anon_sym_x] = ACTIONS(3418),
    [anon_sym_EQ_TILDE] = ACTIONS(3416),
    [anon_sym_BANG_TILDE] = ACTIONS(3416),
    [anon_sym_EQ_EQ] = ACTIONS(3416),
    [anon_sym_BANG_EQ] = ACTIONS(3416),
    [anon_sym_eq] = ACTIONS(3418),
    [anon_sym_ne] = ACTIONS(3418),
    [anon_sym_LT_EQ_GT] = ACTIONS(3416),
    [anon_sym_cmp] = ACTIONS(3418),
    [anon_sym_TILDE_TILDE] = ACTIONS(3416),
    [anon_sym_LT_EQ] = ACTIONS(3418),
    [anon_sym_GT_EQ] = ACTIONS(3416),
    [anon_sym_lt] = ACTIONS(3418),
    [anon_sym_le] = ACTIONS(3418),
    [anon_sym_ge] = ACTIONS(3418),
    [anon_sym_gt] = ACTIONS(3418),
    [anon_sym_isa] = ACTIONS(3418),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3416),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3418),
    [anon_sym___END__] = ACTIONS(3418),
    [anon_sym_EOT] = ACTIONS(3416),
    [aux_sym__bareword_token1] = ACTIONS(3945),
    [sym__PERLY_SEMICOLON] = ACTIONS(3416),
    [sym__ctrl_z_hack] = ACTIONS(3416),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1284] = {
    [sym_heredoc_content] = STATE(1284),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3949),
    [anon_sym_or] = ACTIONS(3949),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_GT] = ACTIONS(3951),
    [anon_sym_LT_LT] = ACTIONS(3951),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3949),
    [anon_sym_PLUS_EQ] = ACTIONS(3949),
    [anon_sym_DASH_EQ] = ACTIONS(3949),
    [anon_sym_DOT_EQ] = ACTIONS(3949),
    [anon_sym_STAR_EQ] = ACTIONS(3949),
    [anon_sym_SLASH_EQ] = ACTIONS(3949),
    [anon_sym_PERCENT_EQ] = ACTIONS(3949),
    [anon_sym_x_EQ] = ACTIONS(3949),
    [anon_sym_AMP_EQ] = ACTIONS(3949),
    [anon_sym_PIPE_EQ] = ACTIONS(3949),
    [anon_sym_CARET_EQ] = ACTIONS(3949),
    [anon_sym_LT_LT_EQ] = ACTIONS(3949),
    [anon_sym_GT_GT_EQ] = ACTIONS(3949),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3949),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3949),
    [anon_sym_DOT_DOT] = ACTIONS(3951),
    [anon_sym_STAR_STAR] = ACTIONS(3951),
    [anon_sym_PIPE_PIPE] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_PIPE] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_GT_GT2] = ACTIONS(3951),
    [anon_sym_PLUS] = ACTIONS(3951),
    [anon_sym_DASH] = ACTIONS(3951),
    [anon_sym_DOT] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_SLASH] = ACTIONS(3951),
    [anon_sym_x] = ACTIONS(3951),
    [anon_sym_EQ_TILDE] = ACTIONS(3949),
    [anon_sym_BANG_TILDE] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_eq] = ACTIONS(3949),
    [anon_sym_ne] = ACTIONS(3949),
    [anon_sym_LT_EQ_GT] = ACTIONS(3949),
    [anon_sym_cmp] = ACTIONS(3949),
    [anon_sym_TILDE_TILDE] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3951),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_lt] = ACTIONS(3949),
    [anon_sym_le] = ACTIONS(3949),
    [anon_sym_ge] = ACTIONS(3949),
    [anon_sym_gt] = ACTIONS(3949),
    [anon_sym_isa] = ACTIONS(3949),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_EQ_GT] = ACTIONS(3949),
    [anon_sym_for] = ACTIONS(3951),
    [anon_sym_foreach] = ACTIONS(3949),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3949),
    [anon_sym___END__] = ACTIONS(3949),
    [anon_sym_EOT] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_unless] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_until] = ACTIONS(3949),
    [sym__PERLY_SEMICOLON] = ACTIONS(3949),
    [sym__ctrl_z_hack] = ACTIONS(3949),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1285] = {
    [sym_heredoc_content] = STATE(1285),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3953),
    [anon_sym_and] = ACTIONS(3953),
    [anon_sym_or] = ACTIONS(3953),
    [anon_sym_DASH_GT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_GT] = ACTIONS(3955),
    [anon_sym_LT_LT] = ACTIONS(3955),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3953),
    [anon_sym_PLUS_EQ] = ACTIONS(3953),
    [anon_sym_DASH_EQ] = ACTIONS(3953),
    [anon_sym_DOT_EQ] = ACTIONS(3953),
    [anon_sym_STAR_EQ] = ACTIONS(3953),
    [anon_sym_SLASH_EQ] = ACTIONS(3953),
    [anon_sym_PERCENT_EQ] = ACTIONS(3953),
    [anon_sym_x_EQ] = ACTIONS(3953),
    [anon_sym_AMP_EQ] = ACTIONS(3953),
    [anon_sym_PIPE_EQ] = ACTIONS(3953),
    [anon_sym_CARET_EQ] = ACTIONS(3953),
    [anon_sym_LT_LT_EQ] = ACTIONS(3953),
    [anon_sym_GT_GT_EQ] = ACTIONS(3953),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3953),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3953),
    [anon_sym_DOT_DOT] = ACTIONS(3955),
    [anon_sym_STAR_STAR] = ACTIONS(3955),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3955),
    [anon_sym_GT_GT2] = ACTIONS(3955),
    [anon_sym_PLUS] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3955),
    [anon_sym_DOT] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_SLASH] = ACTIONS(3955),
    [anon_sym_x] = ACTIONS(3955),
    [anon_sym_EQ_TILDE] = ACTIONS(3953),
    [anon_sym_BANG_TILDE] = ACTIONS(3953),
    [anon_sym_EQ_EQ] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_eq] = ACTIONS(3953),
    [anon_sym_ne] = ACTIONS(3953),
    [anon_sym_LT_EQ_GT] = ACTIONS(3953),
    [anon_sym_cmp] = ACTIONS(3953),
    [anon_sym_TILDE_TILDE] = ACTIONS(3953),
    [anon_sym_LT_EQ] = ACTIONS(3955),
    [anon_sym_GT_EQ] = ACTIONS(3953),
    [anon_sym_lt] = ACTIONS(3953),
    [anon_sym_le] = ACTIONS(3953),
    [anon_sym_ge] = ACTIONS(3953),
    [anon_sym_gt] = ACTIONS(3953),
    [anon_sym_isa] = ACTIONS(3953),
    [anon_sym_PLUS_PLUS] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_EQ_GT] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3955),
    [anon_sym_foreach] = ACTIONS(3953),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3953),
    [anon_sym___END__] = ACTIONS(3953),
    [anon_sym_EOT] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_unless] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_until] = ACTIONS(3953),
    [sym__PERLY_SEMICOLON] = ACTIONS(3953),
    [sym__ctrl_z_hack] = ACTIONS(3953),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1286] = {
    [sym_heredoc_content] = STATE(1286),
    [anon_sym_SEMI] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3957),
    [anon_sym_and] = ACTIONS(3957),
    [anon_sym_or] = ACTIONS(3957),
    [anon_sym_DASH_GT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_GT] = ACTIONS(3959),
    [anon_sym_LT_LT] = ACTIONS(3959),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3957),
    [anon_sym_PLUS_EQ] = ACTIONS(3957),
    [anon_sym_DASH_EQ] = ACTIONS(3957),
    [anon_sym_DOT_EQ] = ACTIONS(3957),
    [anon_sym_STAR_EQ] = ACTIONS(3957),
    [anon_sym_SLASH_EQ] = ACTIONS(3957),
    [anon_sym_PERCENT_EQ] = ACTIONS(3957),
    [anon_sym_x_EQ] = ACTIONS(3957),
    [anon_sym_AMP_EQ] = ACTIONS(3957),
    [anon_sym_PIPE_EQ] = ACTIONS(3957),
    [anon_sym_CARET_EQ] = ACTIONS(3957),
    [anon_sym_LT_LT_EQ] = ACTIONS(3957),
    [anon_sym_GT_GT_EQ] = ACTIONS(3957),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3957),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3957),
    [anon_sym_DOT_DOT] = ACTIONS(3959),
    [anon_sym_STAR_STAR] = ACTIONS(3959),
    [anon_sym_PIPE_PIPE] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH] = ACTIONS(3959),
    [anon_sym_AMP_AMP] = ACTIONS(3959),
    [anon_sym_PIPE] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_GT_GT2] = ACTIONS(3959),
    [anon_sym_PLUS] = ACTIONS(3959),
    [anon_sym_DASH] = ACTIONS(3959),
    [anon_sym_DOT] = ACTIONS(3959),
    [anon_sym_STAR] = ACTIONS(3959),
    [anon_sym_SLASH] = ACTIONS(3959),
    [anon_sym_x] = ACTIONS(3959),
    [anon_sym_EQ_TILDE] = ACTIONS(3957),
    [anon_sym_BANG_TILDE] = ACTIONS(3957),
    [anon_sym_EQ_EQ] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_eq] = ACTIONS(3957),
    [anon_sym_ne] = ACTIONS(3957),
    [anon_sym_LT_EQ_GT] = ACTIONS(3957),
    [anon_sym_cmp] = ACTIONS(3957),
    [anon_sym_TILDE_TILDE] = ACTIONS(3957),
    [anon_sym_LT_EQ] = ACTIONS(3959),
    [anon_sym_GT_EQ] = ACTIONS(3957),
    [anon_sym_lt] = ACTIONS(3957),
    [anon_sym_le] = ACTIONS(3957),
    [anon_sym_ge] = ACTIONS(3957),
    [anon_sym_gt] = ACTIONS(3957),
    [anon_sym_isa] = ACTIONS(3957),
    [anon_sym_PLUS_PLUS] = ACTIONS(3957),
    [anon_sym_DASH_DASH] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_EQ_GT] = ACTIONS(3957),
    [anon_sym_for] = ACTIONS(3959),
    [anon_sym_foreach] = ACTIONS(3957),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3957),
    [anon_sym___END__] = ACTIONS(3957),
    [anon_sym_EOT] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_unless] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_until] = ACTIONS(3957),
    [sym__PERLY_SEMICOLON] = ACTIONS(3957),
    [sym__ctrl_z_hack] = ACTIONS(3957),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1287] = {
    [sym_heredoc_content] = STATE(1287),
    [anon_sym_SEMI] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3961),
    [anon_sym_and] = ACTIONS(3961),
    [anon_sym_or] = ACTIONS(3961),
    [anon_sym_DASH_GT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_GT] = ACTIONS(3963),
    [anon_sym_LT_LT] = ACTIONS(3963),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3961),
    [anon_sym_PLUS_EQ] = ACTIONS(3961),
    [anon_sym_DASH_EQ] = ACTIONS(3961),
    [anon_sym_DOT_EQ] = ACTIONS(3961),
    [anon_sym_STAR_EQ] = ACTIONS(3961),
    [anon_sym_SLASH_EQ] = ACTIONS(3961),
    [anon_sym_PERCENT_EQ] = ACTIONS(3961),
    [anon_sym_x_EQ] = ACTIONS(3961),
    [anon_sym_AMP_EQ] = ACTIONS(3961),
    [anon_sym_PIPE_EQ] = ACTIONS(3961),
    [anon_sym_CARET_EQ] = ACTIONS(3961),
    [anon_sym_LT_LT_EQ] = ACTIONS(3961),
    [anon_sym_GT_GT_EQ] = ACTIONS(3961),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3961),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3961),
    [anon_sym_DOT_DOT] = ACTIONS(3963),
    [anon_sym_STAR_STAR] = ACTIONS(3963),
    [anon_sym_PIPE_PIPE] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH] = ACTIONS(3963),
    [anon_sym_AMP_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_GT_GT2] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_DOT] = ACTIONS(3963),
    [anon_sym_STAR] = ACTIONS(3963),
    [anon_sym_SLASH] = ACTIONS(3963),
    [anon_sym_x] = ACTIONS(3963),
    [anon_sym_EQ_TILDE] = ACTIONS(3961),
    [anon_sym_BANG_TILDE] = ACTIONS(3961),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_eq] = ACTIONS(3961),
    [anon_sym_ne] = ACTIONS(3961),
    [anon_sym_LT_EQ_GT] = ACTIONS(3961),
    [anon_sym_cmp] = ACTIONS(3961),
    [anon_sym_TILDE_TILDE] = ACTIONS(3961),
    [anon_sym_LT_EQ] = ACTIONS(3963),
    [anon_sym_GT_EQ] = ACTIONS(3961),
    [anon_sym_lt] = ACTIONS(3961),
    [anon_sym_le] = ACTIONS(3961),
    [anon_sym_ge] = ACTIONS(3961),
    [anon_sym_gt] = ACTIONS(3961),
    [anon_sym_isa] = ACTIONS(3961),
    [anon_sym_PLUS_PLUS] = ACTIONS(3961),
    [anon_sym_DASH_DASH] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_EQ_GT] = ACTIONS(3961),
    [anon_sym_for] = ACTIONS(3963),
    [anon_sym_foreach] = ACTIONS(3961),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3961),
    [anon_sym___END__] = ACTIONS(3961),
    [anon_sym_EOT] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_unless] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_until] = ACTIONS(3961),
    [sym__PERLY_SEMICOLON] = ACTIONS(3961),
    [sym__ctrl_z_hack] = ACTIONS(3961),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1288] = {
    [sym_heredoc_content] = STATE(1288),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3965),
    [anon_sym_and] = ACTIONS(3965),
    [anon_sym_or] = ACTIONS(3965),
    [anon_sym_DASH_GT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3967),
    [anon_sym_LT_LT] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3965),
    [anon_sym_PLUS_EQ] = ACTIONS(3965),
    [anon_sym_DASH_EQ] = ACTIONS(3965),
    [anon_sym_DOT_EQ] = ACTIONS(3965),
    [anon_sym_STAR_EQ] = ACTIONS(3965),
    [anon_sym_SLASH_EQ] = ACTIONS(3965),
    [anon_sym_PERCENT_EQ] = ACTIONS(3965),
    [anon_sym_x_EQ] = ACTIONS(3965),
    [anon_sym_AMP_EQ] = ACTIONS(3965),
    [anon_sym_PIPE_EQ] = ACTIONS(3965),
    [anon_sym_CARET_EQ] = ACTIONS(3965),
    [anon_sym_LT_LT_EQ] = ACTIONS(3965),
    [anon_sym_GT_GT_EQ] = ACTIONS(3965),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3965),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3965),
    [anon_sym_DOT_DOT] = ACTIONS(3967),
    [anon_sym_STAR_STAR] = ACTIONS(3967),
    [anon_sym_PIPE_PIPE] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH] = ACTIONS(3967),
    [anon_sym_AMP_AMP] = ACTIONS(3967),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_GT_GT2] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3967),
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3967),
    [anon_sym_x] = ACTIONS(3967),
    [anon_sym_EQ_TILDE] = ACTIONS(3965),
    [anon_sym_BANG_TILDE] = ACTIONS(3965),
    [anon_sym_EQ_EQ] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_eq] = ACTIONS(3965),
    [anon_sym_ne] = ACTIONS(3965),
    [anon_sym_LT_EQ_GT] = ACTIONS(3965),
    [anon_sym_cmp] = ACTIONS(3965),
    [anon_sym_TILDE_TILDE] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3965),
    [anon_sym_lt] = ACTIONS(3965),
    [anon_sym_le] = ACTIONS(3965),
    [anon_sym_ge] = ACTIONS(3965),
    [anon_sym_gt] = ACTIONS(3965),
    [anon_sym_isa] = ACTIONS(3965),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_EQ_GT] = ACTIONS(3965),
    [anon_sym_for] = ACTIONS(3967),
    [anon_sym_foreach] = ACTIONS(3965),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3965),
    [anon_sym___END__] = ACTIONS(3965),
    [anon_sym_EOT] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_unless] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_until] = ACTIONS(3965),
    [sym__PERLY_SEMICOLON] = ACTIONS(3965),
    [sym__ctrl_z_hack] = ACTIONS(3965),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1289] = {
    [sym_heredoc_content] = STATE(1289),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3969),
    [anon_sym_and] = ACTIONS(3969),
    [anon_sym_or] = ACTIONS(3969),
    [anon_sym_DASH_GT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_LT_LT] = ACTIONS(3971),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3969),
    [anon_sym_PLUS_EQ] = ACTIONS(3969),
    [anon_sym_DASH_EQ] = ACTIONS(3969),
    [anon_sym_DOT_EQ] = ACTIONS(3969),
    [anon_sym_STAR_EQ] = ACTIONS(3969),
    [anon_sym_SLASH_EQ] = ACTIONS(3969),
    [anon_sym_PERCENT_EQ] = ACTIONS(3969),
    [anon_sym_x_EQ] = ACTIONS(3969),
    [anon_sym_AMP_EQ] = ACTIONS(3969),
    [anon_sym_PIPE_EQ] = ACTIONS(3969),
    [anon_sym_CARET_EQ] = ACTIONS(3969),
    [anon_sym_LT_LT_EQ] = ACTIONS(3969),
    [anon_sym_GT_GT_EQ] = ACTIONS(3969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3969),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3969),
    [anon_sym_DOT_DOT] = ACTIONS(3971),
    [anon_sym_STAR_STAR] = ACTIONS(3971),
    [anon_sym_PIPE_PIPE] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH] = ACTIONS(3971),
    [anon_sym_AMP_AMP] = ACTIONS(3971),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_GT_GT2] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_x] = ACTIONS(3971),
    [anon_sym_EQ_TILDE] = ACTIONS(3969),
    [anon_sym_BANG_TILDE] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_eq] = ACTIONS(3969),
    [anon_sym_ne] = ACTIONS(3969),
    [anon_sym_LT_EQ_GT] = ACTIONS(3969),
    [anon_sym_cmp] = ACTIONS(3969),
    [anon_sym_TILDE_TILDE] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3971),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_lt] = ACTIONS(3969),
    [anon_sym_le] = ACTIONS(3969),
    [anon_sym_ge] = ACTIONS(3969),
    [anon_sym_gt] = ACTIONS(3969),
    [anon_sym_isa] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_EQ_GT] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3971),
    [anon_sym_foreach] = ACTIONS(3969),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3969),
    [anon_sym___END__] = ACTIONS(3969),
    [anon_sym_EOT] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_unless] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_until] = ACTIONS(3969),
    [sym__PERLY_SEMICOLON] = ACTIONS(3969),
    [sym__ctrl_z_hack] = ACTIONS(3969),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1290] = {
    [sym_heredoc_content] = STATE(1290),
    [anon_sym_SEMI] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3973),
    [anon_sym_and] = ACTIONS(3973),
    [anon_sym_or] = ACTIONS(3973),
    [anon_sym_DASH_GT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3973),
    [anon_sym_PLUS_EQ] = ACTIONS(3973),
    [anon_sym_DASH_EQ] = ACTIONS(3973),
    [anon_sym_DOT_EQ] = ACTIONS(3973),
    [anon_sym_STAR_EQ] = ACTIONS(3973),
    [anon_sym_SLASH_EQ] = ACTIONS(3973),
    [anon_sym_PERCENT_EQ] = ACTIONS(3973),
    [anon_sym_x_EQ] = ACTIONS(3973),
    [anon_sym_AMP_EQ] = ACTIONS(3973),
    [anon_sym_PIPE_EQ] = ACTIONS(3973),
    [anon_sym_CARET_EQ] = ACTIONS(3973),
    [anon_sym_LT_LT_EQ] = ACTIONS(3973),
    [anon_sym_GT_GT_EQ] = ACTIONS(3973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3973),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3973),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_STAR_STAR] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3975),
    [anon_sym_GT_GT2] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3975),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_x] = ACTIONS(3975),
    [anon_sym_EQ_TILDE] = ACTIONS(3973),
    [anon_sym_BANG_TILDE] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_eq] = ACTIONS(3973),
    [anon_sym_ne] = ACTIONS(3973),
    [anon_sym_LT_EQ_GT] = ACTIONS(3973),
    [anon_sym_cmp] = ACTIONS(3973),
    [anon_sym_TILDE_TILDE] = ACTIONS(3973),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_lt] = ACTIONS(3973),
    [anon_sym_le] = ACTIONS(3973),
    [anon_sym_ge] = ACTIONS(3973),
    [anon_sym_gt] = ACTIONS(3973),
    [anon_sym_isa] = ACTIONS(3973),
    [anon_sym_PLUS_PLUS] = ACTIONS(3973),
    [anon_sym_DASH_DASH] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_EQ_GT] = ACTIONS(3973),
    [anon_sym_for] = ACTIONS(3975),
    [anon_sym_foreach] = ACTIONS(3973),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3973),
    [anon_sym___END__] = ACTIONS(3973),
    [anon_sym_EOT] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_unless] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_until] = ACTIONS(3973),
    [sym__PERLY_SEMICOLON] = ACTIONS(3973),
    [sym__ctrl_z_hack] = ACTIONS(3973),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1291] = {
    [sym_heredoc_content] = STATE(1291),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3977),
    [anon_sym_and] = ACTIONS(3977),
    [anon_sym_or] = ACTIONS(3977),
    [anon_sym_DASH_GT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3979),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3977),
    [anon_sym_PLUS_EQ] = ACTIONS(3977),
    [anon_sym_DASH_EQ] = ACTIONS(3977),
    [anon_sym_DOT_EQ] = ACTIONS(3977),
    [anon_sym_STAR_EQ] = ACTIONS(3977),
    [anon_sym_SLASH_EQ] = ACTIONS(3977),
    [anon_sym_PERCENT_EQ] = ACTIONS(3977),
    [anon_sym_x_EQ] = ACTIONS(3977),
    [anon_sym_AMP_EQ] = ACTIONS(3977),
    [anon_sym_PIPE_EQ] = ACTIONS(3977),
    [anon_sym_CARET_EQ] = ACTIONS(3977),
    [anon_sym_LT_LT_EQ] = ACTIONS(3977),
    [anon_sym_GT_GT_EQ] = ACTIONS(3977),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3977),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3977),
    [anon_sym_DOT_DOT] = ACTIONS(3979),
    [anon_sym_STAR_STAR] = ACTIONS(3979),
    [anon_sym_PIPE_PIPE] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3979),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_GT_GT2] = ACTIONS(3979),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_x] = ACTIONS(3979),
    [anon_sym_EQ_TILDE] = ACTIONS(3977),
    [anon_sym_BANG_TILDE] = ACTIONS(3977),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_eq] = ACTIONS(3977),
    [anon_sym_ne] = ACTIONS(3977),
    [anon_sym_LT_EQ_GT] = ACTIONS(3977),
    [anon_sym_cmp] = ACTIONS(3977),
    [anon_sym_TILDE_TILDE] = ACTIONS(3977),
    [anon_sym_LT_EQ] = ACTIONS(3979),
    [anon_sym_GT_EQ] = ACTIONS(3977),
    [anon_sym_lt] = ACTIONS(3977),
    [anon_sym_le] = ACTIONS(3977),
    [anon_sym_ge] = ACTIONS(3977),
    [anon_sym_gt] = ACTIONS(3977),
    [anon_sym_isa] = ACTIONS(3977),
    [anon_sym_PLUS_PLUS] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_EQ_GT] = ACTIONS(3977),
    [anon_sym_for] = ACTIONS(3979),
    [anon_sym_foreach] = ACTIONS(3977),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3977),
    [anon_sym___END__] = ACTIONS(3977),
    [anon_sym_EOT] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_unless] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_until] = ACTIONS(3977),
    [sym__PERLY_SEMICOLON] = ACTIONS(3977),
    [sym__ctrl_z_hack] = ACTIONS(3977),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1292] = {
    [sym_heredoc_content] = STATE(1292),
    [anon_sym_SEMI] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3981),
    [anon_sym_or] = ACTIONS(3981),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3983),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3983),
    [anon_sym_EQ] = ACTIONS(3983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3981),
    [anon_sym_PLUS_EQ] = ACTIONS(3981),
    [anon_sym_DASH_EQ] = ACTIONS(3981),
    [anon_sym_DOT_EQ] = ACTIONS(3981),
    [anon_sym_STAR_EQ] = ACTIONS(3981),
    [anon_sym_SLASH_EQ] = ACTIONS(3981),
    [anon_sym_PERCENT_EQ] = ACTIONS(3981),
    [anon_sym_x_EQ] = ACTIONS(3981),
    [anon_sym_AMP_EQ] = ACTIONS(3981),
    [anon_sym_PIPE_EQ] = ACTIONS(3981),
    [anon_sym_CARET_EQ] = ACTIONS(3981),
    [anon_sym_LT_LT_EQ] = ACTIONS(3981),
    [anon_sym_GT_GT_EQ] = ACTIONS(3981),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3981),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3981),
    [anon_sym_DOT_DOT] = ACTIONS(3983),
    [anon_sym_STAR_STAR] = ACTIONS(3983),
    [anon_sym_PIPE_PIPE] = ACTIONS(3983),
    [anon_sym_SLASH_SLASH] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_GT_GT2] = ACTIONS(3983),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3983),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_x] = ACTIONS(3983),
    [anon_sym_EQ_TILDE] = ACTIONS(3981),
    [anon_sym_BANG_TILDE] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_eq] = ACTIONS(3981),
    [anon_sym_ne] = ACTIONS(3981),
    [anon_sym_LT_EQ_GT] = ACTIONS(3981),
    [anon_sym_cmp] = ACTIONS(3981),
    [anon_sym_TILDE_TILDE] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3983),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_lt] = ACTIONS(3981),
    [anon_sym_le] = ACTIONS(3981),
    [anon_sym_ge] = ACTIONS(3981),
    [anon_sym_gt] = ACTIONS(3981),
    [anon_sym_isa] = ACTIONS(3981),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_EQ_GT] = ACTIONS(3981),
    [anon_sym_for] = ACTIONS(3983),
    [anon_sym_foreach] = ACTIONS(3981),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3981),
    [anon_sym___END__] = ACTIONS(3981),
    [anon_sym_EOT] = ACTIONS(3981),
    [anon_sym_if] = ACTIONS(3981),
    [anon_sym_unless] = ACTIONS(3981),
    [anon_sym_while] = ACTIONS(3981),
    [anon_sym_until] = ACTIONS(3981),
    [sym__PERLY_SEMICOLON] = ACTIONS(3981),
    [sym__ctrl_z_hack] = ACTIONS(3981),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1293] = {
    [sym_heredoc_content] = STATE(1293),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_COMMA] = ACTIONS(3985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3985),
    [anon_sym_or] = ACTIONS(3985),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3985),
    [anon_sym_PLUS_EQ] = ACTIONS(3985),
    [anon_sym_DASH_EQ] = ACTIONS(3985),
    [anon_sym_DOT_EQ] = ACTIONS(3985),
    [anon_sym_STAR_EQ] = ACTIONS(3985),
    [anon_sym_SLASH_EQ] = ACTIONS(3985),
    [anon_sym_PERCENT_EQ] = ACTIONS(3985),
    [anon_sym_x_EQ] = ACTIONS(3985),
    [anon_sym_AMP_EQ] = ACTIONS(3985),
    [anon_sym_PIPE_EQ] = ACTIONS(3985),
    [anon_sym_CARET_EQ] = ACTIONS(3985),
    [anon_sym_LT_LT_EQ] = ACTIONS(3985),
    [anon_sym_GT_GT_EQ] = ACTIONS(3985),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3985),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3985),
    [anon_sym_DOT_DOT] = ACTIONS(3987),
    [anon_sym_STAR_STAR] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_SLASH_SLASH] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_GT_GT2] = ACTIONS(3987),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3987),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_x] = ACTIONS(3987),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_BANG_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_eq] = ACTIONS(3985),
    [anon_sym_ne] = ACTIONS(3985),
    [anon_sym_LT_EQ_GT] = ACTIONS(3985),
    [anon_sym_cmp] = ACTIONS(3985),
    [anon_sym_TILDE_TILDE] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_lt] = ACTIONS(3985),
    [anon_sym_le] = ACTIONS(3985),
    [anon_sym_ge] = ACTIONS(3985),
    [anon_sym_gt] = ACTIONS(3985),
    [anon_sym_isa] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_QMARK] = ACTIONS(3985),
    [anon_sym_EQ_GT] = ACTIONS(3985),
    [anon_sym_for] = ACTIONS(3987),
    [anon_sym_foreach] = ACTIONS(3985),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3985),
    [anon_sym___END__] = ACTIONS(3985),
    [anon_sym_EOT] = ACTIONS(3985),
    [anon_sym_if] = ACTIONS(3985),
    [anon_sym_unless] = ACTIONS(3985),
    [anon_sym_while] = ACTIONS(3985),
    [anon_sym_until] = ACTIONS(3985),
    [sym__PERLY_SEMICOLON] = ACTIONS(3985),
    [sym__ctrl_z_hack] = ACTIONS(3985),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1294] = {
    [sym_heredoc_content] = STATE(1294),
    [anon_sym_SEMI] = ACTIONS(3989),
    [anon_sym_COMMA] = ACTIONS(3989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3989),
    [anon_sym_or] = ACTIONS(3989),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3989),
    [anon_sym_PLUS_EQ] = ACTIONS(3989),
    [anon_sym_DASH_EQ] = ACTIONS(3989),
    [anon_sym_DOT_EQ] = ACTIONS(3989),
    [anon_sym_STAR_EQ] = ACTIONS(3989),
    [anon_sym_SLASH_EQ] = ACTIONS(3989),
    [anon_sym_PERCENT_EQ] = ACTIONS(3989),
    [anon_sym_x_EQ] = ACTIONS(3989),
    [anon_sym_AMP_EQ] = ACTIONS(3989),
    [anon_sym_PIPE_EQ] = ACTIONS(3989),
    [anon_sym_CARET_EQ] = ACTIONS(3989),
    [anon_sym_LT_LT_EQ] = ACTIONS(3989),
    [anon_sym_GT_GT_EQ] = ACTIONS(3989),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3989),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3989),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_STAR_STAR] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_SLASH_SLASH] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_GT_GT2] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_x] = ACTIONS(3991),
    [anon_sym_EQ_TILDE] = ACTIONS(3989),
    [anon_sym_BANG_TILDE] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_eq] = ACTIONS(3989),
    [anon_sym_ne] = ACTIONS(3989),
    [anon_sym_LT_EQ_GT] = ACTIONS(3989),
    [anon_sym_cmp] = ACTIONS(3989),
    [anon_sym_TILDE_TILDE] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_lt] = ACTIONS(3989),
    [anon_sym_le] = ACTIONS(3989),
    [anon_sym_ge] = ACTIONS(3989),
    [anon_sym_gt] = ACTIONS(3989),
    [anon_sym_isa] = ACTIONS(3989),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_QMARK] = ACTIONS(3989),
    [anon_sym_EQ_GT] = ACTIONS(3989),
    [anon_sym_for] = ACTIONS(3991),
    [anon_sym_foreach] = ACTIONS(3989),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3989),
    [anon_sym___END__] = ACTIONS(3989),
    [anon_sym_EOT] = ACTIONS(3989),
    [anon_sym_if] = ACTIONS(3989),
    [anon_sym_unless] = ACTIONS(3989),
    [anon_sym_while] = ACTIONS(3989),
    [anon_sym_until] = ACTIONS(3989),
    [sym__PERLY_SEMICOLON] = ACTIONS(3989),
    [sym__ctrl_z_hack] = ACTIONS(3989),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1295] = {
    [sym_heredoc_content] = STATE(1295),
    [anon_sym_SEMI] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3993),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3995),
    [anon_sym_LT] = ACTIONS(3995),
    [anon_sym_GT] = ACTIONS(3995),
    [anon_sym_LT_LT] = ACTIONS(3995),
    [anon_sym_EQ] = ACTIONS(3995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3993),
    [anon_sym_DASH_EQ] = ACTIONS(3993),
    [anon_sym_DOT_EQ] = ACTIONS(3993),
    [anon_sym_STAR_EQ] = ACTIONS(3993),
    [anon_sym_SLASH_EQ] = ACTIONS(3993),
    [anon_sym_PERCENT_EQ] = ACTIONS(3993),
    [anon_sym_x_EQ] = ACTIONS(3993),
    [anon_sym_AMP_EQ] = ACTIONS(3993),
    [anon_sym_PIPE_EQ] = ACTIONS(3993),
    [anon_sym_CARET_EQ] = ACTIONS(3993),
    [anon_sym_LT_LT_EQ] = ACTIONS(3993),
    [anon_sym_GT_GT_EQ] = ACTIONS(3993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3993),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3995),
    [anon_sym_STAR_STAR] = ACTIONS(3995),
    [anon_sym_PIPE_PIPE] = ACTIONS(3995),
    [anon_sym_SLASH_SLASH] = ACTIONS(3995),
    [anon_sym_AMP_AMP] = ACTIONS(3995),
    [anon_sym_PIPE] = ACTIONS(3995),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_GT_GT2] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_DOT] = ACTIONS(3995),
    [anon_sym_STAR] = ACTIONS(3995),
    [anon_sym_SLASH] = ACTIONS(3995),
    [anon_sym_x] = ACTIONS(3995),
    [anon_sym_EQ_TILDE] = ACTIONS(3993),
    [anon_sym_BANG_TILDE] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3993),
    [anon_sym_BANG_EQ] = ACTIONS(3993),
    [anon_sym_eq] = ACTIONS(3993),
    [anon_sym_ne] = ACTIONS(3993),
    [anon_sym_LT_EQ_GT] = ACTIONS(3993),
    [anon_sym_cmp] = ACTIONS(3993),
    [anon_sym_TILDE_TILDE] = ACTIONS(3993),
    [anon_sym_LT_EQ] = ACTIONS(3995),
    [anon_sym_GT_EQ] = ACTIONS(3993),
    [anon_sym_lt] = ACTIONS(3993),
    [anon_sym_le] = ACTIONS(3993),
    [anon_sym_ge] = ACTIONS(3993),
    [anon_sym_gt] = ACTIONS(3993),
    [anon_sym_isa] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3993),
    [anon_sym_DASH_DASH] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3993),
    [anon_sym_for] = ACTIONS(3995),
    [anon_sym_foreach] = ACTIONS(3993),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3993),
    [anon_sym___END__] = ACTIONS(3993),
    [anon_sym_EOT] = ACTIONS(3993),
    [anon_sym_if] = ACTIONS(3993),
    [anon_sym_unless] = ACTIONS(3993),
    [anon_sym_while] = ACTIONS(3993),
    [anon_sym_until] = ACTIONS(3993),
    [sym__PERLY_SEMICOLON] = ACTIONS(3993),
    [sym__ctrl_z_hack] = ACTIONS(3993),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1296] = {
    [sym_heredoc_content] = STATE(1296),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3997),
    [anon_sym_or] = ACTIONS(3997),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3999),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3999),
    [anon_sym_EQ] = ACTIONS(3999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3997),
    [anon_sym_PLUS_EQ] = ACTIONS(3997),
    [anon_sym_DASH_EQ] = ACTIONS(3997),
    [anon_sym_DOT_EQ] = ACTIONS(3997),
    [anon_sym_STAR_EQ] = ACTIONS(3997),
    [anon_sym_SLASH_EQ] = ACTIONS(3997),
    [anon_sym_PERCENT_EQ] = ACTIONS(3997),
    [anon_sym_x_EQ] = ACTIONS(3997),
    [anon_sym_AMP_EQ] = ACTIONS(3997),
    [anon_sym_PIPE_EQ] = ACTIONS(3997),
    [anon_sym_CARET_EQ] = ACTIONS(3997),
    [anon_sym_LT_LT_EQ] = ACTIONS(3997),
    [anon_sym_GT_GT_EQ] = ACTIONS(3997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3997),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3997),
    [anon_sym_DOT_DOT] = ACTIONS(3999),
    [anon_sym_STAR_STAR] = ACTIONS(3999),
    [anon_sym_PIPE_PIPE] = ACTIONS(3999),
    [anon_sym_SLASH_SLASH] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3999),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_GT_GT2] = ACTIONS(3999),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3999),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_x] = ACTIONS(3999),
    [anon_sym_EQ_TILDE] = ACTIONS(3997),
    [anon_sym_BANG_TILDE] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_eq] = ACTIONS(3997),
    [anon_sym_ne] = ACTIONS(3997),
    [anon_sym_LT_EQ_GT] = ACTIONS(3997),
    [anon_sym_cmp] = ACTIONS(3997),
    [anon_sym_TILDE_TILDE] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_lt] = ACTIONS(3997),
    [anon_sym_le] = ACTIONS(3997),
    [anon_sym_ge] = ACTIONS(3997),
    [anon_sym_gt] = ACTIONS(3997),
    [anon_sym_isa] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_QMARK] = ACTIONS(3997),
    [anon_sym_EQ_GT] = ACTIONS(3997),
    [anon_sym_for] = ACTIONS(3999),
    [anon_sym_foreach] = ACTIONS(3997),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3997),
    [anon_sym___END__] = ACTIONS(3997),
    [anon_sym_EOT] = ACTIONS(3997),
    [anon_sym_if] = ACTIONS(3997),
    [anon_sym_unless] = ACTIONS(3997),
    [anon_sym_while] = ACTIONS(3997),
    [anon_sym_until] = ACTIONS(3997),
    [sym__PERLY_SEMICOLON] = ACTIONS(3997),
    [sym__ctrl_z_hack] = ACTIONS(3997),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1297] = {
    [sym_heredoc_content] = STATE(1297),
    [anon_sym_SEMI] = ACTIONS(4004),
    [anon_sym_COMMA] = ACTIONS(4004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3650),
    [anon_sym_and] = ACTIONS(4004),
    [anon_sym_or] = ACTIONS(4004),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3662),
    [anon_sym_DASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_EQ] = ACTIONS(3662),
    [anon_sym_STAR_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_PERCENT_EQ] = ACTIONS(3662),
    [anon_sym_x_EQ] = ACTIONS(3662),
    [anon_sym_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_CARET_EQ] = ACTIONS(3662),
    [anon_sym_LT_LT_EQ] = ACTIONS(3662),
    [anon_sym_GT_GT_EQ] = ACTIONS(3662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_SLASH_SLASH] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3690),
    [anon_sym_EQ_GT] = ACTIONS(4004),
    [anon_sym_for] = ACTIONS(4006),
    [anon_sym_foreach] = ACTIONS(4004),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4004),
    [anon_sym___END__] = ACTIONS(4004),
    [anon_sym_EOT] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(4004),
    [anon_sym_unless] = ACTIONS(4004),
    [anon_sym_while] = ACTIONS(4004),
    [anon_sym_until] = ACTIONS(4004),
    [sym__PERLY_SEMICOLON] = ACTIONS(4004),
    [sym__ctrl_z_hack] = ACTIONS(4004),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1298] = {
    [sym_heredoc_content] = STATE(1298),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(4008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4008),
    [anon_sym_and] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4008),
    [anon_sym_PERCENT] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_EQ] = ACTIONS(4010),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4008),
    [anon_sym_PLUS_EQ] = ACTIONS(4008),
    [anon_sym_DASH_EQ] = ACTIONS(4008),
    [anon_sym_DOT_EQ] = ACTIONS(4008),
    [anon_sym_STAR_EQ] = ACTIONS(4008),
    [anon_sym_SLASH_EQ] = ACTIONS(4008),
    [anon_sym_PERCENT_EQ] = ACTIONS(4008),
    [anon_sym_x_EQ] = ACTIONS(4008),
    [anon_sym_AMP_EQ] = ACTIONS(4008),
    [anon_sym_PIPE_EQ] = ACTIONS(4008),
    [anon_sym_CARET_EQ] = ACTIONS(4008),
    [anon_sym_LT_LT_EQ] = ACTIONS(4008),
    [anon_sym_GT_GT_EQ] = ACTIONS(4008),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4008),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4008),
    [anon_sym_DOT_DOT] = ACTIONS(4010),
    [anon_sym_STAR_STAR] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [anon_sym_SLASH_SLASH] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_GT_GT2] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_DOT] = ACTIONS(4010),
    [anon_sym_STAR] = ACTIONS(4010),
    [anon_sym_SLASH] = ACTIONS(4010),
    [anon_sym_x] = ACTIONS(4010),
    [anon_sym_EQ_TILDE] = ACTIONS(4008),
    [anon_sym_BANG_TILDE] = ACTIONS(4008),
    [anon_sym_EQ_EQ] = ACTIONS(4008),
    [anon_sym_BANG_EQ] = ACTIONS(4008),
    [anon_sym_eq] = ACTIONS(4008),
    [anon_sym_ne] = ACTIONS(4008),
    [anon_sym_LT_EQ_GT] = ACTIONS(4008),
    [anon_sym_cmp] = ACTIONS(4008),
    [anon_sym_TILDE_TILDE] = ACTIONS(4008),
    [anon_sym_LT_EQ] = ACTIONS(4010),
    [anon_sym_GT_EQ] = ACTIONS(4008),
    [anon_sym_lt] = ACTIONS(4008),
    [anon_sym_le] = ACTIONS(4008),
    [anon_sym_ge] = ACTIONS(4008),
    [anon_sym_gt] = ACTIONS(4008),
    [anon_sym_isa] = ACTIONS(4008),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [anon_sym_QMARK] = ACTIONS(4008),
    [anon_sym_EQ_GT] = ACTIONS(4008),
    [anon_sym_for] = ACTIONS(4010),
    [anon_sym_foreach] = ACTIONS(4008),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4008),
    [anon_sym___END__] = ACTIONS(4008),
    [anon_sym_EOT] = ACTIONS(4008),
    [anon_sym_if] = ACTIONS(4008),
    [anon_sym_unless] = ACTIONS(4008),
    [anon_sym_while] = ACTIONS(4008),
    [anon_sym_until] = ACTIONS(4008),
    [sym__PERLY_SEMICOLON] = ACTIONS(4008),
    [sym__ctrl_z_hack] = ACTIONS(4008),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1299] = {
    [sym_heredoc_content] = STATE(1299),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym_COMMA] = ACTIONS(4012),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4012),
    [anon_sym_and] = ACTIONS(4012),
    [anon_sym_or] = ACTIONS(4012),
    [anon_sym_DASH_GT] = ACTIONS(4012),
    [anon_sym_PERCENT] = ACTIONS(4014),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_GT] = ACTIONS(4014),
    [anon_sym_LT_LT] = ACTIONS(4014),
    [anon_sym_EQ] = ACTIONS(4014),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4012),
    [anon_sym_PLUS_EQ] = ACTIONS(4012),
    [anon_sym_DASH_EQ] = ACTIONS(4012),
    [anon_sym_DOT_EQ] = ACTIONS(4012),
    [anon_sym_STAR_EQ] = ACTIONS(4012),
    [anon_sym_SLASH_EQ] = ACTIONS(4012),
    [anon_sym_PERCENT_EQ] = ACTIONS(4012),
    [anon_sym_x_EQ] = ACTIONS(4012),
    [anon_sym_AMP_EQ] = ACTIONS(4012),
    [anon_sym_PIPE_EQ] = ACTIONS(4012),
    [anon_sym_CARET_EQ] = ACTIONS(4012),
    [anon_sym_LT_LT_EQ] = ACTIONS(4012),
    [anon_sym_GT_GT_EQ] = ACTIONS(4012),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4012),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4012),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4012),
    [anon_sym_DOT_DOT] = ACTIONS(4014),
    [anon_sym_STAR_STAR] = ACTIONS(4014),
    [anon_sym_PIPE_PIPE] = ACTIONS(4014),
    [anon_sym_SLASH_SLASH] = ACTIONS(4014),
    [anon_sym_AMP_AMP] = ACTIONS(4014),
    [anon_sym_PIPE] = ACTIONS(4014),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_GT_GT2] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_DOT] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_SLASH] = ACTIONS(4014),
    [anon_sym_x] = ACTIONS(4014),
    [anon_sym_EQ_TILDE] = ACTIONS(4012),
    [anon_sym_BANG_TILDE] = ACTIONS(4012),
    [anon_sym_EQ_EQ] = ACTIONS(4012),
    [anon_sym_BANG_EQ] = ACTIONS(4012),
    [anon_sym_eq] = ACTIONS(4012),
    [anon_sym_ne] = ACTIONS(4012),
    [anon_sym_LT_EQ_GT] = ACTIONS(4012),
    [anon_sym_cmp] = ACTIONS(4012),
    [anon_sym_TILDE_TILDE] = ACTIONS(4012),
    [anon_sym_LT_EQ] = ACTIONS(4014),
    [anon_sym_GT_EQ] = ACTIONS(4012),
    [anon_sym_lt] = ACTIONS(4012),
    [anon_sym_le] = ACTIONS(4012),
    [anon_sym_ge] = ACTIONS(4012),
    [anon_sym_gt] = ACTIONS(4012),
    [anon_sym_isa] = ACTIONS(4012),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_EQ_GT] = ACTIONS(4012),
    [anon_sym_for] = ACTIONS(4014),
    [anon_sym_foreach] = ACTIONS(4012),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4012),
    [anon_sym___END__] = ACTIONS(4012),
    [anon_sym_EOT] = ACTIONS(4012),
    [anon_sym_if] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_until] = ACTIONS(4012),
    [sym__PERLY_SEMICOLON] = ACTIONS(4012),
    [sym__ctrl_z_hack] = ACTIONS(4012),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1300] = {
    [sym_heredoc_content] = STATE(1300),
    [anon_sym_SEMI] = ACTIONS(4016),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4016),
    [anon_sym_and] = ACTIONS(4016),
    [anon_sym_or] = ACTIONS(4016),
    [anon_sym_DASH_GT] = ACTIONS(4016),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4018),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4016),
    [anon_sym_PLUS_EQ] = ACTIONS(4016),
    [anon_sym_DASH_EQ] = ACTIONS(4016),
    [anon_sym_DOT_EQ] = ACTIONS(4016),
    [anon_sym_STAR_EQ] = ACTIONS(4016),
    [anon_sym_SLASH_EQ] = ACTIONS(4016),
    [anon_sym_PERCENT_EQ] = ACTIONS(4016),
    [anon_sym_x_EQ] = ACTIONS(4016),
    [anon_sym_AMP_EQ] = ACTIONS(4016),
    [anon_sym_PIPE_EQ] = ACTIONS(4016),
    [anon_sym_CARET_EQ] = ACTIONS(4016),
    [anon_sym_LT_LT_EQ] = ACTIONS(4016),
    [anon_sym_GT_GT_EQ] = ACTIONS(4016),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4016),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4016),
    [anon_sym_DOT_DOT] = ACTIONS(4018),
    [anon_sym_STAR_STAR] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_SLASH_SLASH] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_GT_GT2] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4018),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_x] = ACTIONS(4018),
    [anon_sym_EQ_TILDE] = ACTIONS(4016),
    [anon_sym_BANG_TILDE] = ACTIONS(4016),
    [anon_sym_EQ_EQ] = ACTIONS(4016),
    [anon_sym_BANG_EQ] = ACTIONS(4016),
    [anon_sym_eq] = ACTIONS(4016),
    [anon_sym_ne] = ACTIONS(4016),
    [anon_sym_LT_EQ_GT] = ACTIONS(4016),
    [anon_sym_cmp] = ACTIONS(4016),
    [anon_sym_TILDE_TILDE] = ACTIONS(4016),
    [anon_sym_LT_EQ] = ACTIONS(4018),
    [anon_sym_GT_EQ] = ACTIONS(4016),
    [anon_sym_lt] = ACTIONS(4016),
    [anon_sym_le] = ACTIONS(4016),
    [anon_sym_ge] = ACTIONS(4016),
    [anon_sym_gt] = ACTIONS(4016),
    [anon_sym_isa] = ACTIONS(4016),
    [anon_sym_PLUS_PLUS] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4016),
    [anon_sym_QMARK] = ACTIONS(4016),
    [anon_sym_EQ_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_foreach] = ACTIONS(4016),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4016),
    [anon_sym___END__] = ACTIONS(4016),
    [anon_sym_EOT] = ACTIONS(4016),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_unless] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(4016),
    [anon_sym_until] = ACTIONS(4016),
    [sym__PERLY_SEMICOLON] = ACTIONS(4016),
    [sym__ctrl_z_hack] = ACTIONS(4016),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1301] = {
    [sym_heredoc_content] = STATE(1301),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4020),
    [anon_sym_and] = ACTIONS(4020),
    [anon_sym_or] = ACTIONS(4020),
    [anon_sym_DASH_GT] = ACTIONS(4020),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4022),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4020),
    [anon_sym_PLUS_EQ] = ACTIONS(4020),
    [anon_sym_DASH_EQ] = ACTIONS(4020),
    [anon_sym_DOT_EQ] = ACTIONS(4020),
    [anon_sym_STAR_EQ] = ACTIONS(4020),
    [anon_sym_SLASH_EQ] = ACTIONS(4020),
    [anon_sym_PERCENT_EQ] = ACTIONS(4020),
    [anon_sym_x_EQ] = ACTIONS(4020),
    [anon_sym_AMP_EQ] = ACTIONS(4020),
    [anon_sym_PIPE_EQ] = ACTIONS(4020),
    [anon_sym_CARET_EQ] = ACTIONS(4020),
    [anon_sym_LT_LT_EQ] = ACTIONS(4020),
    [anon_sym_GT_GT_EQ] = ACTIONS(4020),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4020),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4022),
    [anon_sym_STAR_STAR] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_SLASH_SLASH] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_GT_GT2] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4022),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_x] = ACTIONS(4022),
    [anon_sym_EQ_TILDE] = ACTIONS(4020),
    [anon_sym_BANG_TILDE] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4020),
    [anon_sym_eq] = ACTIONS(4020),
    [anon_sym_ne] = ACTIONS(4020),
    [anon_sym_LT_EQ_GT] = ACTIONS(4020),
    [anon_sym_cmp] = ACTIONS(4020),
    [anon_sym_TILDE_TILDE] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4022),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_lt] = ACTIONS(4020),
    [anon_sym_le] = ACTIONS(4020),
    [anon_sym_ge] = ACTIONS(4020),
    [anon_sym_gt] = ACTIONS(4020),
    [anon_sym_isa] = ACTIONS(4020),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_EQ_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_foreach] = ACTIONS(4020),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4020),
    [anon_sym___END__] = ACTIONS(4020),
    [anon_sym_EOT] = ACTIONS(4020),
    [anon_sym_if] = ACTIONS(4020),
    [anon_sym_unless] = ACTIONS(4020),
    [anon_sym_while] = ACTIONS(4020),
    [anon_sym_until] = ACTIONS(4020),
    [sym__PERLY_SEMICOLON] = ACTIONS(4020),
    [sym__ctrl_z_hack] = ACTIONS(4020),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1302] = {
    [sym_heredoc_content] = STATE(1302),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4026),
    [anon_sym_EQ] = ACTIONS(4026),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4024),
    [anon_sym_PLUS_EQ] = ACTIONS(4024),
    [anon_sym_DASH_EQ] = ACTIONS(4024),
    [anon_sym_DOT_EQ] = ACTIONS(4024),
    [anon_sym_STAR_EQ] = ACTIONS(4024),
    [anon_sym_SLASH_EQ] = ACTIONS(4024),
    [anon_sym_PERCENT_EQ] = ACTIONS(4024),
    [anon_sym_x_EQ] = ACTIONS(4024),
    [anon_sym_AMP_EQ] = ACTIONS(4024),
    [anon_sym_PIPE_EQ] = ACTIONS(4024),
    [anon_sym_CARET_EQ] = ACTIONS(4024),
    [anon_sym_LT_LT_EQ] = ACTIONS(4024),
    [anon_sym_GT_GT_EQ] = ACTIONS(4024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4024),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4026),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_SLASH_SLASH] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_GT_GT2] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_DOT] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4026),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_x] = ACTIONS(4026),
    [anon_sym_EQ_TILDE] = ACTIONS(4024),
    [anon_sym_BANG_TILDE] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_eq] = ACTIONS(4024),
    [anon_sym_ne] = ACTIONS(4024),
    [anon_sym_LT_EQ_GT] = ACTIONS(4024),
    [anon_sym_cmp] = ACTIONS(4024),
    [anon_sym_TILDE_TILDE] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4026),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_lt] = ACTIONS(4024),
    [anon_sym_le] = ACTIONS(4024),
    [anon_sym_ge] = ACTIONS(4024),
    [anon_sym_gt] = ACTIONS(4024),
    [anon_sym_isa] = ACTIONS(4024),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4024),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_for] = ACTIONS(4026),
    [anon_sym_foreach] = ACTIONS(4024),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4024),
    [anon_sym___END__] = ACTIONS(4024),
    [anon_sym_EOT] = ACTIONS(4024),
    [anon_sym_if] = ACTIONS(4024),
    [anon_sym_unless] = ACTIONS(4024),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_until] = ACTIONS(4024),
    [sym__PERLY_SEMICOLON] = ACTIONS(4024),
    [sym__ctrl_z_hack] = ACTIONS(4024),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1303] = {
    [sym_attribute] = STATE(1374),
    [sym_attribute_name] = STATE(1369),
    [sym_heredoc_content] = STATE(1303),
    [aux_sym_attrlist_repeat1] = STATE(1330),
    [sym__identifier] = ACTIONS(3945),
    [anon_sym_COLON] = ACTIONS(3947),
    [anon_sym_SEMI] = ACTIONS(3420),
    [anon_sym_COMMA] = ACTIONS(3420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3420),
    [anon_sym_and] = ACTIONS(3422),
    [anon_sym_or] = ACTIONS(3422),
    [anon_sym_DASH_GT] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3422),
    [anon_sym_GT] = ACTIONS(3422),
    [anon_sym_LT_LT] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3422),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_x_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_DOT] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3422),
    [anon_sym_PIPE_PIPE] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_AMP_AMP] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(3422),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_GT_GT2] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_DASH] = ACTIONS(3422),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_STAR] = ACTIONS(3422),
    [anon_sym_SLASH] = ACTIONS(3422),
    [anon_sym_x] = ACTIONS(3422),
    [anon_sym_EQ_TILDE] = ACTIONS(3420),
    [anon_sym_BANG_TILDE] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3420),
    [anon_sym_BANG_EQ] = ACTIONS(3420),
    [anon_sym_eq] = ACTIONS(3422),
    [anon_sym_ne] = ACTIONS(3422),
    [anon_sym_LT_EQ_GT] = ACTIONS(3420),
    [anon_sym_cmp] = ACTIONS(3422),
    [anon_sym_TILDE_TILDE] = ACTIONS(3420),
    [anon_sym_LT_EQ] = ACTIONS(3422),
    [anon_sym_GT_EQ] = ACTIONS(3420),
    [anon_sym_lt] = ACTIONS(3422),
    [anon_sym_le] = ACTIONS(3422),
    [anon_sym_ge] = ACTIONS(3422),
    [anon_sym_gt] = ACTIONS(3422),
    [anon_sym_isa] = ACTIONS(3422),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_EQ_GT] = ACTIONS(3420),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3422),
    [anon_sym___END__] = ACTIONS(3422),
    [anon_sym_EOT] = ACTIONS(3420),
    [aux_sym__bareword_token1] = ACTIONS(3945),
    [sym__PERLY_SEMICOLON] = ACTIONS(3420),
    [sym__ctrl_z_hack] = ACTIONS(3420),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1304] = {
    [sym_heredoc_content] = STATE(1304),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_PERCENT] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4030),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4028),
    [anon_sym_PLUS_EQ] = ACTIONS(4028),
    [anon_sym_DASH_EQ] = ACTIONS(4028),
    [anon_sym_DOT_EQ] = ACTIONS(4028),
    [anon_sym_STAR_EQ] = ACTIONS(4028),
    [anon_sym_SLASH_EQ] = ACTIONS(4028),
    [anon_sym_PERCENT_EQ] = ACTIONS(4028),
    [anon_sym_x_EQ] = ACTIONS(4028),
    [anon_sym_AMP_EQ] = ACTIONS(4028),
    [anon_sym_PIPE_EQ] = ACTIONS(4028),
    [anon_sym_CARET_EQ] = ACTIONS(4028),
    [anon_sym_LT_LT_EQ] = ACTIONS(4028),
    [anon_sym_GT_GT_EQ] = ACTIONS(4028),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4028),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4030),
    [anon_sym_STAR_STAR] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_SLASH_SLASH] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_GT_GT2] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_DOT] = ACTIONS(4030),
    [anon_sym_STAR] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_x] = ACTIONS(4030),
    [anon_sym_EQ_TILDE] = ACTIONS(4028),
    [anon_sym_BANG_TILDE] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_eq] = ACTIONS(4028),
    [anon_sym_ne] = ACTIONS(4028),
    [anon_sym_LT_EQ_GT] = ACTIONS(4028),
    [anon_sym_cmp] = ACTIONS(4028),
    [anon_sym_TILDE_TILDE] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4030),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_lt] = ACTIONS(4028),
    [anon_sym_le] = ACTIONS(4028),
    [anon_sym_ge] = ACTIONS(4028),
    [anon_sym_gt] = ACTIONS(4028),
    [anon_sym_isa] = ACTIONS(4028),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_for] = ACTIONS(4030),
    [anon_sym_foreach] = ACTIONS(4028),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4028),
    [anon_sym___END__] = ACTIONS(4028),
    [anon_sym_EOT] = ACTIONS(4028),
    [anon_sym_if] = ACTIONS(4028),
    [anon_sym_unless] = ACTIONS(4028),
    [anon_sym_while] = ACTIONS(4028),
    [anon_sym_until] = ACTIONS(4028),
    [sym__PERLY_SEMICOLON] = ACTIONS(4028),
    [sym__ctrl_z_hack] = ACTIONS(4028),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1305] = {
    [sym_heredoc_content] = STATE(1305),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4032),
    [anon_sym_and] = ACTIONS(4032),
    [anon_sym_or] = ACTIONS(4032),
    [anon_sym_DASH_GT] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(4034),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4032),
    [anon_sym_PLUS_EQ] = ACTIONS(4032),
    [anon_sym_DASH_EQ] = ACTIONS(4032),
    [anon_sym_DOT_EQ] = ACTIONS(4032),
    [anon_sym_STAR_EQ] = ACTIONS(4032),
    [anon_sym_SLASH_EQ] = ACTIONS(4032),
    [anon_sym_PERCENT_EQ] = ACTIONS(4032),
    [anon_sym_x_EQ] = ACTIONS(4032),
    [anon_sym_AMP_EQ] = ACTIONS(4032),
    [anon_sym_PIPE_EQ] = ACTIONS(4032),
    [anon_sym_CARET_EQ] = ACTIONS(4032),
    [anon_sym_LT_LT_EQ] = ACTIONS(4032),
    [anon_sym_GT_GT_EQ] = ACTIONS(4032),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4032),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4032),
    [anon_sym_DOT_DOT] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [anon_sym_SLASH_SLASH] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT2] = ACTIONS(4034),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4034),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_x] = ACTIONS(4034),
    [anon_sym_EQ_TILDE] = ACTIONS(4032),
    [anon_sym_BANG_TILDE] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4032),
    [anon_sym_eq] = ACTIONS(4032),
    [anon_sym_ne] = ACTIONS(4032),
    [anon_sym_LT_EQ_GT] = ACTIONS(4032),
    [anon_sym_cmp] = ACTIONS(4032),
    [anon_sym_TILDE_TILDE] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4034),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_lt] = ACTIONS(4032),
    [anon_sym_le] = ACTIONS(4032),
    [anon_sym_ge] = ACTIONS(4032),
    [anon_sym_gt] = ACTIONS(4032),
    [anon_sym_isa] = ACTIONS(4032),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_QMARK] = ACTIONS(4032),
    [anon_sym_EQ_GT] = ACTIONS(4032),
    [anon_sym_for] = ACTIONS(4034),
    [anon_sym_foreach] = ACTIONS(4032),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4032),
    [anon_sym___END__] = ACTIONS(4032),
    [anon_sym_EOT] = ACTIONS(4032),
    [anon_sym_if] = ACTIONS(4032),
    [anon_sym_unless] = ACTIONS(4032),
    [anon_sym_while] = ACTIONS(4032),
    [anon_sym_until] = ACTIONS(4032),
    [sym__PERLY_SEMICOLON] = ACTIONS(4032),
    [sym__ctrl_z_hack] = ACTIONS(4032),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1306] = {
    [sym_heredoc_content] = STATE(1306),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4036),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_DASH_GT] = ACTIONS(4036),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(4038),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4036),
    [anon_sym_PLUS_EQ] = ACTIONS(4036),
    [anon_sym_DASH_EQ] = ACTIONS(4036),
    [anon_sym_DOT_EQ] = ACTIONS(4036),
    [anon_sym_STAR_EQ] = ACTIONS(4036),
    [anon_sym_SLASH_EQ] = ACTIONS(4036),
    [anon_sym_PERCENT_EQ] = ACTIONS(4036),
    [anon_sym_x_EQ] = ACTIONS(4036),
    [anon_sym_AMP_EQ] = ACTIONS(4036),
    [anon_sym_PIPE_EQ] = ACTIONS(4036),
    [anon_sym_CARET_EQ] = ACTIONS(4036),
    [anon_sym_LT_LT_EQ] = ACTIONS(4036),
    [anon_sym_GT_GT_EQ] = ACTIONS(4036),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4036),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4036),
    [anon_sym_DOT_DOT] = ACTIONS(4038),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_SLASH_SLASH] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT2] = ACTIONS(4038),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4038),
    [anon_sym_SLASH] = ACTIONS(4038),
    [anon_sym_x] = ACTIONS(4038),
    [anon_sym_EQ_TILDE] = ACTIONS(4036),
    [anon_sym_BANG_TILDE] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_eq] = ACTIONS(4036),
    [anon_sym_ne] = ACTIONS(4036),
    [anon_sym_LT_EQ_GT] = ACTIONS(4036),
    [anon_sym_cmp] = ACTIONS(4036),
    [anon_sym_TILDE_TILDE] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [anon_sym_lt] = ACTIONS(4036),
    [anon_sym_le] = ACTIONS(4036),
    [anon_sym_ge] = ACTIONS(4036),
    [anon_sym_gt] = ACTIONS(4036),
    [anon_sym_isa] = ACTIONS(4036),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_QMARK] = ACTIONS(4036),
    [anon_sym_EQ_GT] = ACTIONS(4036),
    [anon_sym_for] = ACTIONS(4038),
    [anon_sym_foreach] = ACTIONS(4036),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4036),
    [anon_sym___END__] = ACTIONS(4036),
    [anon_sym_EOT] = ACTIONS(4036),
    [anon_sym_if] = ACTIONS(4036),
    [anon_sym_unless] = ACTIONS(4036),
    [anon_sym_while] = ACTIONS(4036),
    [anon_sym_until] = ACTIONS(4036),
    [sym__PERLY_SEMICOLON] = ACTIONS(4036),
    [sym__ctrl_z_hack] = ACTIONS(4036),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1307] = {
    [sym_heredoc_content] = STATE(1307),
    [anon_sym_SEMI] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(4040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4040),
    [anon_sym_and] = ACTIONS(4040),
    [anon_sym_or] = ACTIONS(4040),
    [anon_sym_DASH_GT] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4042),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4040),
    [anon_sym_PLUS_EQ] = ACTIONS(4040),
    [anon_sym_DASH_EQ] = ACTIONS(4040),
    [anon_sym_DOT_EQ] = ACTIONS(4040),
    [anon_sym_STAR_EQ] = ACTIONS(4040),
    [anon_sym_SLASH_EQ] = ACTIONS(4040),
    [anon_sym_PERCENT_EQ] = ACTIONS(4040),
    [anon_sym_x_EQ] = ACTIONS(4040),
    [anon_sym_AMP_EQ] = ACTIONS(4040),
    [anon_sym_PIPE_EQ] = ACTIONS(4040),
    [anon_sym_CARET_EQ] = ACTIONS(4040),
    [anon_sym_LT_LT_EQ] = ACTIONS(4040),
    [anon_sym_GT_GT_EQ] = ACTIONS(4040),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4040),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_STAR_STAR] = ACTIONS(4042),
    [anon_sym_PIPE_PIPE] = ACTIONS(4042),
    [anon_sym_SLASH_SLASH] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_GT_GT2] = ACTIONS(4042),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_DOT] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(4042),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_x] = ACTIONS(4042),
    [anon_sym_EQ_TILDE] = ACTIONS(4040),
    [anon_sym_BANG_TILDE] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_eq] = ACTIONS(4040),
    [anon_sym_ne] = ACTIONS(4040),
    [anon_sym_LT_EQ_GT] = ACTIONS(4040),
    [anon_sym_cmp] = ACTIONS(4040),
    [anon_sym_TILDE_TILDE] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4042),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [anon_sym_lt] = ACTIONS(4040),
    [anon_sym_le] = ACTIONS(4040),
    [anon_sym_ge] = ACTIONS(4040),
    [anon_sym_gt] = ACTIONS(4040),
    [anon_sym_isa] = ACTIONS(4040),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [anon_sym_for] = ACTIONS(4042),
    [anon_sym_foreach] = ACTIONS(4040),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4040),
    [anon_sym___END__] = ACTIONS(4040),
    [anon_sym_EOT] = ACTIONS(4040),
    [anon_sym_if] = ACTIONS(4040),
    [anon_sym_unless] = ACTIONS(4040),
    [anon_sym_while] = ACTIONS(4040),
    [anon_sym_until] = ACTIONS(4040),
    [sym__PERLY_SEMICOLON] = ACTIONS(4040),
    [sym__ctrl_z_hack] = ACTIONS(4040),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1308] = {
    [sym_heredoc_content] = STATE(1308),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4044),
    [anon_sym_or] = ACTIONS(4044),
    [anon_sym_DASH_GT] = ACTIONS(4044),
    [anon_sym_PERCENT] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_EQ] = ACTIONS(4046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4044),
    [anon_sym_PLUS_EQ] = ACTIONS(4044),
    [anon_sym_DASH_EQ] = ACTIONS(4044),
    [anon_sym_DOT_EQ] = ACTIONS(4044),
    [anon_sym_STAR_EQ] = ACTIONS(4044),
    [anon_sym_SLASH_EQ] = ACTIONS(4044),
    [anon_sym_PERCENT_EQ] = ACTIONS(4044),
    [anon_sym_x_EQ] = ACTIONS(4044),
    [anon_sym_AMP_EQ] = ACTIONS(4044),
    [anon_sym_PIPE_EQ] = ACTIONS(4044),
    [anon_sym_CARET_EQ] = ACTIONS(4044),
    [anon_sym_LT_LT_EQ] = ACTIONS(4044),
    [anon_sym_GT_GT_EQ] = ACTIONS(4044),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4044),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4044),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_STAR_STAR] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_SLASH_SLASH] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_GT_GT2] = ACTIONS(4046),
    [anon_sym_PLUS] = ACTIONS(4046),
    [anon_sym_DASH] = ACTIONS(4046),
    [anon_sym_DOT] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_SLASH] = ACTIONS(4046),
    [anon_sym_x] = ACTIONS(4046),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_BANG_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_eq] = ACTIONS(4044),
    [anon_sym_ne] = ACTIONS(4044),
    [anon_sym_LT_EQ_GT] = ACTIONS(4044),
    [anon_sym_cmp] = ACTIONS(4044),
    [anon_sym_TILDE_TILDE] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4046),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [anon_sym_lt] = ACTIONS(4044),
    [anon_sym_le] = ACTIONS(4044),
    [anon_sym_ge] = ACTIONS(4044),
    [anon_sym_gt] = ACTIONS(4044),
    [anon_sym_isa] = ACTIONS(4044),
    [anon_sym_PLUS_PLUS] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4044),
    [anon_sym_QMARK] = ACTIONS(4044),
    [anon_sym_EQ_GT] = ACTIONS(4044),
    [anon_sym_for] = ACTIONS(4046),
    [anon_sym_foreach] = ACTIONS(4044),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4044),
    [anon_sym___END__] = ACTIONS(4044),
    [anon_sym_EOT] = ACTIONS(4044),
    [anon_sym_if] = ACTIONS(4044),
    [anon_sym_unless] = ACTIONS(4044),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_until] = ACTIONS(4044),
    [sym__PERLY_SEMICOLON] = ACTIONS(4044),
    [sym__ctrl_z_hack] = ACTIONS(4044),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1309] = {
    [sym_heredoc_content] = STATE(1309),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4048),
    [anon_sym_and] = ACTIONS(4048),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_DASH_GT] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4048),
    [anon_sym_PLUS_EQ] = ACTIONS(4048),
    [anon_sym_DASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_EQ] = ACTIONS(4048),
    [anon_sym_STAR_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_PERCENT_EQ] = ACTIONS(4048),
    [anon_sym_x_EQ] = ACTIONS(4048),
    [anon_sym_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_CARET_EQ] = ACTIONS(4048),
    [anon_sym_LT_LT_EQ] = ACTIONS(4048),
    [anon_sym_GT_GT_EQ] = ACTIONS(4048),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4052),
    [anon_sym_STAR_STAR] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_SLASH_SLASH] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_GT_GT2] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_x] = ACTIONS(4052),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_EQ_EQ] = ACTIONS(4048),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_eq] = ACTIONS(4048),
    [anon_sym_ne] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_cmp] = ACTIONS(4048),
    [anon_sym_TILDE_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4052),
    [anon_sym_GT_EQ] = ACTIONS(4048),
    [anon_sym_lt] = ACTIONS(4048),
    [anon_sym_le] = ACTIONS(4048),
    [anon_sym_ge] = ACTIONS(4048),
    [anon_sym_gt] = ACTIONS(4048),
    [anon_sym_isa] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4048),
    [anon_sym_DASH_DASH] = ACTIONS(4048),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4050),
    [anon_sym_for] = ACTIONS(4052),
    [anon_sym_foreach] = ACTIONS(4048),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4048),
    [anon_sym___END__] = ACTIONS(4048),
    [anon_sym_EOT] = ACTIONS(4048),
    [anon_sym_if] = ACTIONS(4048),
    [anon_sym_unless] = ACTIONS(4048),
    [anon_sym_while] = ACTIONS(4048),
    [anon_sym_until] = ACTIONS(4048),
    [sym__PERLY_SEMICOLON] = ACTIONS(4048),
    [sym__ctrl_z_hack] = ACTIONS(4048),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1310] = {
    [sym_heredoc_content] = STATE(1310),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4054),
    [anon_sym_PLUS_EQ] = ACTIONS(4054),
    [anon_sym_DASH_EQ] = ACTIONS(4054),
    [anon_sym_DOT_EQ] = ACTIONS(4054),
    [anon_sym_STAR_EQ] = ACTIONS(4054),
    [anon_sym_SLASH_EQ] = ACTIONS(4054),
    [anon_sym_PERCENT_EQ] = ACTIONS(4054),
    [anon_sym_x_EQ] = ACTIONS(4054),
    [anon_sym_AMP_EQ] = ACTIONS(4054),
    [anon_sym_PIPE_EQ] = ACTIONS(4054),
    [anon_sym_CARET_EQ] = ACTIONS(4054),
    [anon_sym_LT_LT_EQ] = ACTIONS(4054),
    [anon_sym_GT_GT_EQ] = ACTIONS(4054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4054),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4056),
    [anon_sym_SLASH_SLASH] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_GT_GT2] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_x] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4054),
    [anon_sym_BANG_TILDE] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_eq] = ACTIONS(4054),
    [anon_sym_ne] = ACTIONS(4054),
    [anon_sym_LT_EQ_GT] = ACTIONS(4054),
    [anon_sym_cmp] = ACTIONS(4054),
    [anon_sym_TILDE_TILDE] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4056),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_lt] = ACTIONS(4054),
    [anon_sym_le] = ACTIONS(4054),
    [anon_sym_ge] = ACTIONS(4054),
    [anon_sym_gt] = ACTIONS(4054),
    [anon_sym_isa] = ACTIONS(4054),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_EQ_GT] = ACTIONS(4054),
    [anon_sym_for] = ACTIONS(4056),
    [anon_sym_foreach] = ACTIONS(4054),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4054),
    [anon_sym___END__] = ACTIONS(4054),
    [anon_sym_EOT] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_unless] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_until] = ACTIONS(4054),
    [sym__PERLY_SEMICOLON] = ACTIONS(4054),
    [sym__ctrl_z_hack] = ACTIONS(4054),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1311] = {
    [sym_heredoc_content] = STATE(1311),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4058),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_DOT_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_x_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4060),
    [anon_sym_STAR_STAR] = ACTIONS(4060),
    [anon_sym_PIPE_PIPE] = ACTIONS(4060),
    [anon_sym_SLASH_SLASH] = ACTIONS(4060),
    [anon_sym_AMP_AMP] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_GT_GT2] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_x] = ACTIONS(4060),
    [anon_sym_EQ_TILDE] = ACTIONS(4058),
    [anon_sym_BANG_TILDE] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_eq] = ACTIONS(4058),
    [anon_sym_ne] = ACTIONS(4058),
    [anon_sym_LT_EQ_GT] = ACTIONS(4058),
    [anon_sym_cmp] = ACTIONS(4058),
    [anon_sym_TILDE_TILDE] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4060),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_lt] = ACTIONS(4058),
    [anon_sym_le] = ACTIONS(4058),
    [anon_sym_ge] = ACTIONS(4058),
    [anon_sym_gt] = ACTIONS(4058),
    [anon_sym_isa] = ACTIONS(4058),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_QMARK] = ACTIONS(4058),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_for] = ACTIONS(4060),
    [anon_sym_foreach] = ACTIONS(4058),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4058),
    [anon_sym___END__] = ACTIONS(4058),
    [anon_sym_EOT] = ACTIONS(4058),
    [anon_sym_if] = ACTIONS(4058),
    [anon_sym_unless] = ACTIONS(4058),
    [anon_sym_while] = ACTIONS(4058),
    [anon_sym_until] = ACTIONS(4058),
    [sym__PERLY_SEMICOLON] = ACTIONS(4058),
    [sym__ctrl_z_hack] = ACTIONS(4058),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1312] = {
    [sym_heredoc_content] = STATE(1312),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_x_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4064),
    [anon_sym_STAR_STAR] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_SLASH_SLASH] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_GT_GT2] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_SLASH] = ACTIONS(4064),
    [anon_sym_x] = ACTIONS(4064),
    [anon_sym_EQ_TILDE] = ACTIONS(4062),
    [anon_sym_BANG_TILDE] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_eq] = ACTIONS(4062),
    [anon_sym_ne] = ACTIONS(4062),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_cmp] = ACTIONS(4062),
    [anon_sym_TILDE_TILDE] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_lt] = ACTIONS(4062),
    [anon_sym_le] = ACTIONS(4062),
    [anon_sym_ge] = ACTIONS(4062),
    [anon_sym_gt] = ACTIONS(4062),
    [anon_sym_isa] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_foreach] = ACTIONS(4062),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4062),
    [anon_sym___END__] = ACTIONS(4062),
    [anon_sym_EOT] = ACTIONS(4062),
    [anon_sym_if] = ACTIONS(4062),
    [anon_sym_unless] = ACTIONS(4062),
    [anon_sym_while] = ACTIONS(4062),
    [anon_sym_until] = ACTIONS(4062),
    [sym__PERLY_SEMICOLON] = ACTIONS(4062),
    [sym__ctrl_z_hack] = ACTIONS(4062),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1313] = {
    [sym_heredoc_content] = STATE(1313),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_x_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4064),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_SLASH_SLASH] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_eq] = ACTIONS(4062),
    [anon_sym_ne] = ACTIONS(4062),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_cmp] = ACTIONS(4062),
    [anon_sym_TILDE_TILDE] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_lt] = ACTIONS(4062),
    [anon_sym_le] = ACTIONS(4062),
    [anon_sym_ge] = ACTIONS(4062),
    [anon_sym_gt] = ACTIONS(4062),
    [anon_sym_isa] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_foreach] = ACTIONS(4062),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4062),
    [anon_sym___END__] = ACTIONS(4062),
    [anon_sym_EOT] = ACTIONS(4062),
    [anon_sym_if] = ACTIONS(4062),
    [anon_sym_unless] = ACTIONS(4062),
    [anon_sym_while] = ACTIONS(4062),
    [anon_sym_until] = ACTIONS(4062),
    [sym__PERLY_SEMICOLON] = ACTIONS(4062),
    [sym__ctrl_z_hack] = ACTIONS(4062),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1314] = {
    [sym_heredoc_content] = STATE(1314),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_COMMA] = ACTIONS(4066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4066),
    [anon_sym_and] = ACTIONS(4066),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(4068),
    [anon_sym_GT] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(4068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4066),
    [anon_sym_DASH_EQ] = ACTIONS(4066),
    [anon_sym_DOT_EQ] = ACTIONS(4066),
    [anon_sym_STAR_EQ] = ACTIONS(4066),
    [anon_sym_SLASH_EQ] = ACTIONS(4066),
    [anon_sym_PERCENT_EQ] = ACTIONS(4066),
    [anon_sym_x_EQ] = ACTIONS(4066),
    [anon_sym_AMP_EQ] = ACTIONS(4066),
    [anon_sym_PIPE_EQ] = ACTIONS(4066),
    [anon_sym_CARET_EQ] = ACTIONS(4066),
    [anon_sym_LT_LT_EQ] = ACTIONS(4066),
    [anon_sym_GT_GT_EQ] = ACTIONS(4066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4066),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4066),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_SLASH_SLASH] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4068),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(4066),
    [anon_sym_BANG_EQ] = ACTIONS(4066),
    [anon_sym_eq] = ACTIONS(4066),
    [anon_sym_ne] = ACTIONS(4066),
    [anon_sym_LT_EQ_GT] = ACTIONS(4066),
    [anon_sym_cmp] = ACTIONS(4066),
    [anon_sym_TILDE_TILDE] = ACTIONS(4066),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4066),
    [anon_sym_lt] = ACTIONS(4066),
    [anon_sym_le] = ACTIONS(4066),
    [anon_sym_ge] = ACTIONS(4066),
    [anon_sym_gt] = ACTIONS(4066),
    [anon_sym_isa] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4066),
    [anon_sym_for] = ACTIONS(4068),
    [anon_sym_foreach] = ACTIONS(4066),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4066),
    [anon_sym___END__] = ACTIONS(4066),
    [anon_sym_EOT] = ACTIONS(4066),
    [anon_sym_if] = ACTIONS(4066),
    [anon_sym_unless] = ACTIONS(4066),
    [anon_sym_while] = ACTIONS(4066),
    [anon_sym_until] = ACTIONS(4066),
    [sym__PERLY_SEMICOLON] = ACTIONS(4066),
    [sym__ctrl_z_hack] = ACTIONS(4066),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1315] = {
    [sym_heredoc_content] = STATE(1315),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4070),
    [anon_sym_and] = ACTIONS(4070),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_DASH_GT] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4070),
    [anon_sym_PLUS_EQ] = ACTIONS(4070),
    [anon_sym_DASH_EQ] = ACTIONS(4070),
    [anon_sym_DOT_EQ] = ACTIONS(4070),
    [anon_sym_STAR_EQ] = ACTIONS(4070),
    [anon_sym_SLASH_EQ] = ACTIONS(4070),
    [anon_sym_PERCENT_EQ] = ACTIONS(4070),
    [anon_sym_x_EQ] = ACTIONS(4070),
    [anon_sym_AMP_EQ] = ACTIONS(4070),
    [anon_sym_PIPE_EQ] = ACTIONS(4070),
    [anon_sym_CARET_EQ] = ACTIONS(4070),
    [anon_sym_LT_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT_GT_EQ] = ACTIONS(4070),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4070),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_STAR_STAR] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_SLASH_SLASH] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4072),
    [anon_sym_GT_GT2] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4072),
    [anon_sym_DASH] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4072),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4072),
    [anon_sym_x] = ACTIONS(4072),
    [anon_sym_EQ_TILDE] = ACTIONS(4070),
    [anon_sym_BANG_TILDE] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4070),
    [anon_sym_eq] = ACTIONS(4070),
    [anon_sym_ne] = ACTIONS(4070),
    [anon_sym_LT_EQ_GT] = ACTIONS(4070),
    [anon_sym_cmp] = ACTIONS(4070),
    [anon_sym_TILDE_TILDE] = ACTIONS(4070),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4070),
    [anon_sym_lt] = ACTIONS(4070),
    [anon_sym_le] = ACTIONS(4070),
    [anon_sym_ge] = ACTIONS(4070),
    [anon_sym_gt] = ACTIONS(4070),
    [anon_sym_isa] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4070),
    [anon_sym_DASH_DASH] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4070),
    [anon_sym_for] = ACTIONS(4072),
    [anon_sym_foreach] = ACTIONS(4070),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4070),
    [anon_sym___END__] = ACTIONS(4070),
    [anon_sym_EOT] = ACTIONS(4070),
    [anon_sym_if] = ACTIONS(4070),
    [anon_sym_unless] = ACTIONS(4070),
    [anon_sym_while] = ACTIONS(4070),
    [anon_sym_until] = ACTIONS(4070),
    [sym__PERLY_SEMICOLON] = ACTIONS(4070),
    [sym__ctrl_z_hack] = ACTIONS(4070),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1316] = {
    [sym_heredoc_content] = STATE(1316),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4074),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_DOT_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_x_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_STAR_STAR] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_SLASH_SLASH] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4076),
    [anon_sym_GT_GT2] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_DASH] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4076),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4076),
    [anon_sym_x] = ACTIONS(4076),
    [anon_sym_EQ_TILDE] = ACTIONS(4074),
    [anon_sym_BANG_TILDE] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_eq] = ACTIONS(4074),
    [anon_sym_ne] = ACTIONS(4074),
    [anon_sym_LT_EQ_GT] = ACTIONS(4074),
    [anon_sym_cmp] = ACTIONS(4074),
    [anon_sym_TILDE_TILDE] = ACTIONS(4074),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4074),
    [anon_sym_lt] = ACTIONS(4074),
    [anon_sym_le] = ACTIONS(4074),
    [anon_sym_ge] = ACTIONS(4074),
    [anon_sym_gt] = ACTIONS(4074),
    [anon_sym_isa] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4074),
    [anon_sym_DASH_DASH] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_for] = ACTIONS(4076),
    [anon_sym_foreach] = ACTIONS(4074),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4074),
    [anon_sym___END__] = ACTIONS(4074),
    [anon_sym_EOT] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [sym__PERLY_SEMICOLON] = ACTIONS(4074),
    [sym__ctrl_z_hack] = ACTIONS(4074),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1317] = {
    [sym_heredoc_content] = STATE(1317),
    [anon_sym_SEMI] = ACTIONS(3897),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3897),
    [anon_sym_and] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3897),
    [anon_sym_DASH_GT] = ACTIONS(3897),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3899),
    [anon_sym_GT] = ACTIONS(3899),
    [anon_sym_LT_LT] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3897),
    [anon_sym_PLUS_EQ] = ACTIONS(3897),
    [anon_sym_DASH_EQ] = ACTIONS(3897),
    [anon_sym_DOT_EQ] = ACTIONS(3897),
    [anon_sym_STAR_EQ] = ACTIONS(3897),
    [anon_sym_SLASH_EQ] = ACTIONS(3897),
    [anon_sym_PERCENT_EQ] = ACTIONS(3897),
    [anon_sym_x_EQ] = ACTIONS(3897),
    [anon_sym_AMP_EQ] = ACTIONS(3897),
    [anon_sym_PIPE_EQ] = ACTIONS(3897),
    [anon_sym_CARET_EQ] = ACTIONS(3897),
    [anon_sym_LT_LT_EQ] = ACTIONS(3897),
    [anon_sym_GT_GT_EQ] = ACTIONS(3897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3897),
    [anon_sym_DOT_DOT] = ACTIONS(3899),
    [anon_sym_STAR_STAR] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_SLASH_SLASH] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_GT_GT2] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_SLASH] = ACTIONS(3899),
    [anon_sym_x] = ACTIONS(3899),
    [anon_sym_EQ_TILDE] = ACTIONS(3897),
    [anon_sym_BANG_TILDE] = ACTIONS(3897),
    [anon_sym_EQ_EQ] = ACTIONS(3897),
    [anon_sym_BANG_EQ] = ACTIONS(3897),
    [anon_sym_eq] = ACTIONS(3897),
    [anon_sym_ne] = ACTIONS(3897),
    [anon_sym_LT_EQ_GT] = ACTIONS(3897),
    [anon_sym_cmp] = ACTIONS(3897),
    [anon_sym_TILDE_TILDE] = ACTIONS(3897),
    [anon_sym_LT_EQ] = ACTIONS(3899),
    [anon_sym_GT_EQ] = ACTIONS(3897),
    [anon_sym_lt] = ACTIONS(3897),
    [anon_sym_le] = ACTIONS(3897),
    [anon_sym_ge] = ACTIONS(3897),
    [anon_sym_gt] = ACTIONS(3897),
    [anon_sym_isa] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_QMARK] = ACTIONS(3897),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_foreach] = ACTIONS(3897),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3897),
    [anon_sym___END__] = ACTIONS(3897),
    [anon_sym_EOT] = ACTIONS(3897),
    [anon_sym_if] = ACTIONS(3897),
    [anon_sym_unless] = ACTIONS(3897),
    [anon_sym_while] = ACTIONS(3897),
    [anon_sym_until] = ACTIONS(3897),
    [sym__PERLY_SEMICOLON] = ACTIONS(3897),
    [sym__ctrl_z_hack] = ACTIONS(3897),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1318] = {
    [sym_heredoc_content] = STATE(1318),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4080),
    [anon_sym_and] = ACTIONS(4080),
    [anon_sym_or] = ACTIONS(4080),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(4082),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(4082),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4080),
    [anon_sym_PLUS_EQ] = ACTIONS(4080),
    [anon_sym_DASH_EQ] = ACTIONS(4080),
    [anon_sym_DOT_EQ] = ACTIONS(4080),
    [anon_sym_STAR_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_PERCENT_EQ] = ACTIONS(4080),
    [anon_sym_x_EQ] = ACTIONS(4080),
    [anon_sym_AMP_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_CARET_EQ] = ACTIONS(4080),
    [anon_sym_LT_LT_EQ] = ACTIONS(4080),
    [anon_sym_GT_GT_EQ] = ACTIONS(4080),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(4082),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_SLASH_SLASH] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(4080),
    [anon_sym_BANG_EQ] = ACTIONS(4080),
    [anon_sym_eq] = ACTIONS(4080),
    [anon_sym_ne] = ACTIONS(4080),
    [anon_sym_LT_EQ_GT] = ACTIONS(4080),
    [anon_sym_cmp] = ACTIONS(4080),
    [anon_sym_TILDE_TILDE] = ACTIONS(4080),
    [anon_sym_LT_EQ] = ACTIONS(4082),
    [anon_sym_GT_EQ] = ACTIONS(4080),
    [anon_sym_lt] = ACTIONS(4080),
    [anon_sym_le] = ACTIONS(4080),
    [anon_sym_ge] = ACTIONS(4080),
    [anon_sym_gt] = ACTIONS(4080),
    [anon_sym_isa] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4080),
    [anon_sym_EQ_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_foreach] = ACTIONS(4080),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4080),
    [anon_sym___END__] = ACTIONS(4080),
    [anon_sym_EOT] = ACTIONS(4080),
    [anon_sym_if] = ACTIONS(4080),
    [anon_sym_unless] = ACTIONS(4080),
    [anon_sym_while] = ACTIONS(4080),
    [anon_sym_until] = ACTIONS(4080),
    [sym__PERLY_SEMICOLON] = ACTIONS(4080),
    [sym__ctrl_z_hack] = ACTIONS(4080),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1319] = {
    [sym_heredoc_content] = STATE(1319),
    [anon_sym_SEMI] = ACTIONS(4084),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4084),
    [anon_sym_and] = ACTIONS(4084),
    [anon_sym_or] = ACTIONS(4084),
    [anon_sym_DASH_GT] = ACTIONS(4084),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_LT_LT] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4086),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4084),
    [anon_sym_PLUS_EQ] = ACTIONS(4084),
    [anon_sym_DASH_EQ] = ACTIONS(4084),
    [anon_sym_DOT_EQ] = ACTIONS(4084),
    [anon_sym_STAR_EQ] = ACTIONS(4084),
    [anon_sym_SLASH_EQ] = ACTIONS(4084),
    [anon_sym_PERCENT_EQ] = ACTIONS(4084),
    [anon_sym_x_EQ] = ACTIONS(4084),
    [anon_sym_AMP_EQ] = ACTIONS(4084),
    [anon_sym_PIPE_EQ] = ACTIONS(4084),
    [anon_sym_CARET_EQ] = ACTIONS(4084),
    [anon_sym_LT_LT_EQ] = ACTIONS(4084),
    [anon_sym_GT_GT_EQ] = ACTIONS(4084),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4084),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4084),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4084),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_STAR_STAR] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_SLASH_SLASH] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4086),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_GT_GT2] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_SLASH] = ACTIONS(4086),
    [anon_sym_x] = ACTIONS(4086),
    [anon_sym_EQ_TILDE] = ACTIONS(4084),
    [anon_sym_BANG_TILDE] = ACTIONS(4084),
    [anon_sym_EQ_EQ] = ACTIONS(4084),
    [anon_sym_BANG_EQ] = ACTIONS(4084),
    [anon_sym_eq] = ACTIONS(4084),
    [anon_sym_ne] = ACTIONS(4084),
    [anon_sym_LT_EQ_GT] = ACTIONS(4084),
    [anon_sym_cmp] = ACTIONS(4084),
    [anon_sym_TILDE_TILDE] = ACTIONS(4084),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4084),
    [anon_sym_lt] = ACTIONS(4084),
    [anon_sym_le] = ACTIONS(4084),
    [anon_sym_ge] = ACTIONS(4084),
    [anon_sym_gt] = ACTIONS(4084),
    [anon_sym_isa] = ACTIONS(4084),
    [anon_sym_PLUS_PLUS] = ACTIONS(4084),
    [anon_sym_DASH_DASH] = ACTIONS(4084),
    [anon_sym_QMARK] = ACTIONS(4084),
    [anon_sym_EQ_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_foreach] = ACTIONS(4084),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4084),
    [anon_sym___END__] = ACTIONS(4084),
    [anon_sym_EOT] = ACTIONS(4084),
    [anon_sym_if] = ACTIONS(4084),
    [anon_sym_unless] = ACTIONS(4084),
    [anon_sym_while] = ACTIONS(4084),
    [anon_sym_until] = ACTIONS(4084),
    [sym__PERLY_SEMICOLON] = ACTIONS(4084),
    [sym__ctrl_z_hack] = ACTIONS(4084),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1320] = {
    [sym_heredoc_content] = STATE(1320),
    [anon_sym_SEMI] = ACTIONS(4088),
    [anon_sym_COMMA] = ACTIONS(4088),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4088),
    [anon_sym_and] = ACTIONS(4088),
    [anon_sym_or] = ACTIONS(4088),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(4090),
    [anon_sym_GT] = ACTIONS(4090),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(4090),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4088),
    [anon_sym_PLUS_EQ] = ACTIONS(4088),
    [anon_sym_DASH_EQ] = ACTIONS(4088),
    [anon_sym_DOT_EQ] = ACTIONS(4088),
    [anon_sym_STAR_EQ] = ACTIONS(4088),
    [anon_sym_SLASH_EQ] = ACTIONS(4088),
    [anon_sym_PERCENT_EQ] = ACTIONS(4088),
    [anon_sym_x_EQ] = ACTIONS(4088),
    [anon_sym_AMP_EQ] = ACTIONS(4088),
    [anon_sym_PIPE_EQ] = ACTIONS(4088),
    [anon_sym_CARET_EQ] = ACTIONS(4088),
    [anon_sym_LT_LT_EQ] = ACTIONS(4088),
    [anon_sym_GT_GT_EQ] = ACTIONS(4088),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4088),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4088),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4090),
    [anon_sym_SLASH_SLASH] = ACTIONS(4090),
    [anon_sym_AMP_AMP] = ACTIONS(4090),
    [anon_sym_PIPE] = ACTIONS(4090),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(4088),
    [anon_sym_BANG_EQ] = ACTIONS(4088),
    [anon_sym_eq] = ACTIONS(4088),
    [anon_sym_ne] = ACTIONS(4088),
    [anon_sym_LT_EQ_GT] = ACTIONS(4088),
    [anon_sym_cmp] = ACTIONS(4088),
    [anon_sym_TILDE_TILDE] = ACTIONS(4088),
    [anon_sym_LT_EQ] = ACTIONS(4090),
    [anon_sym_GT_EQ] = ACTIONS(4088),
    [anon_sym_lt] = ACTIONS(4088),
    [anon_sym_le] = ACTIONS(4088),
    [anon_sym_ge] = ACTIONS(4088),
    [anon_sym_gt] = ACTIONS(4088),
    [anon_sym_isa] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_EQ_GT] = ACTIONS(4088),
    [anon_sym_for] = ACTIONS(4090),
    [anon_sym_foreach] = ACTIONS(4088),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4088),
    [anon_sym___END__] = ACTIONS(4088),
    [anon_sym_EOT] = ACTIONS(4088),
    [anon_sym_if] = ACTIONS(4088),
    [anon_sym_unless] = ACTIONS(4088),
    [anon_sym_while] = ACTIONS(4088),
    [anon_sym_until] = ACTIONS(4088),
    [sym__PERLY_SEMICOLON] = ACTIONS(4088),
    [sym__ctrl_z_hack] = ACTIONS(4088),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1321] = {
    [sym_heredoc_content] = STATE(1321),
    [anon_sym_SEMI] = ACTIONS(4092),
    [anon_sym_COMMA] = ACTIONS(4092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(4092),
    [anon_sym_or] = ACTIONS(4092),
    [anon_sym_DASH_GT] = ACTIONS(4092),
    [anon_sym_PERCENT] = ACTIONS(4094),
    [anon_sym_LT] = ACTIONS(4094),
    [anon_sym_GT] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4094),
    [anon_sym_EQ] = ACTIONS(4094),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4092),
    [anon_sym_PLUS_EQ] = ACTIONS(4092),
    [anon_sym_DASH_EQ] = ACTIONS(4092),
    [anon_sym_DOT_EQ] = ACTIONS(4092),
    [anon_sym_STAR_EQ] = ACTIONS(4092),
    [anon_sym_SLASH_EQ] = ACTIONS(4092),
    [anon_sym_PERCENT_EQ] = ACTIONS(4092),
    [anon_sym_x_EQ] = ACTIONS(4092),
    [anon_sym_AMP_EQ] = ACTIONS(4092),
    [anon_sym_PIPE_EQ] = ACTIONS(4092),
    [anon_sym_CARET_EQ] = ACTIONS(4092),
    [anon_sym_LT_LT_EQ] = ACTIONS(4092),
    [anon_sym_GT_GT_EQ] = ACTIONS(4092),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4092),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4092),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(4094),
    [anon_sym_STAR_STAR] = ACTIONS(4094),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_SLASH_SLASH] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_PIPE] = ACTIONS(4094),
    [anon_sym_AMP] = ACTIONS(4094),
    [anon_sym_GT_GT2] = ACTIONS(4094),
    [anon_sym_PLUS] = ACTIONS(4094),
    [anon_sym_DASH] = ACTIONS(4094),
    [anon_sym_DOT] = ACTIONS(4094),
    [anon_sym_STAR] = ACTIONS(4094),
    [anon_sym_SLASH] = ACTIONS(4094),
    [anon_sym_x] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4092),
    [anon_sym_BANG_TILDE] = ACTIONS(4092),
    [anon_sym_EQ_EQ] = ACTIONS(4092),
    [anon_sym_BANG_EQ] = ACTIONS(4092),
    [anon_sym_eq] = ACTIONS(4092),
    [anon_sym_ne] = ACTIONS(4092),
    [anon_sym_LT_EQ_GT] = ACTIONS(4092),
    [anon_sym_cmp] = ACTIONS(4092),
    [anon_sym_TILDE_TILDE] = ACTIONS(4092),
    [anon_sym_LT_EQ] = ACTIONS(4094),
    [anon_sym_GT_EQ] = ACTIONS(4092),
    [anon_sym_lt] = ACTIONS(4092),
    [anon_sym_le] = ACTIONS(4092),
    [anon_sym_ge] = ACTIONS(4092),
    [anon_sym_gt] = ACTIONS(4092),
    [anon_sym_isa] = ACTIONS(4092),
    [anon_sym_PLUS_PLUS] = ACTIONS(4092),
    [anon_sym_DASH_DASH] = ACTIONS(4092),
    [anon_sym_QMARK] = ACTIONS(4092),
    [anon_sym_EQ_GT] = ACTIONS(4092),
    [anon_sym_for] = ACTIONS(4094),
    [anon_sym_foreach] = ACTIONS(4092),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4092),
    [anon_sym___END__] = ACTIONS(4092),
    [anon_sym_EOT] = ACTIONS(4092),
    [anon_sym_if] = ACTIONS(4092),
    [anon_sym_unless] = ACTIONS(4092),
    [anon_sym_while] = ACTIONS(4092),
    [anon_sym_until] = ACTIONS(4092),
    [sym__PERLY_SEMICOLON] = ACTIONS(4092),
    [sym__ctrl_z_hack] = ACTIONS(4092),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1322] = {
    [sym_heredoc_content] = STATE(1322),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4048),
    [anon_sym_and] = ACTIONS(4048),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_DASH_GT] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4048),
    [anon_sym_PLUS_EQ] = ACTIONS(4048),
    [anon_sym_DASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_EQ] = ACTIONS(4048),
    [anon_sym_STAR_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_PERCENT_EQ] = ACTIONS(4048),
    [anon_sym_x_EQ] = ACTIONS(4048),
    [anon_sym_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_CARET_EQ] = ACTIONS(4048),
    [anon_sym_LT_LT_EQ] = ACTIONS(4048),
    [anon_sym_GT_GT_EQ] = ACTIONS(4048),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4052),
    [anon_sym_STAR_STAR] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_SLASH_SLASH] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_GT_GT2] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_x] = ACTIONS(4052),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_EQ_EQ] = ACTIONS(4048),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_eq] = ACTIONS(4048),
    [anon_sym_ne] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_cmp] = ACTIONS(4048),
    [anon_sym_TILDE_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4052),
    [anon_sym_GT_EQ] = ACTIONS(4048),
    [anon_sym_lt] = ACTIONS(4048),
    [anon_sym_le] = ACTIONS(4048),
    [anon_sym_ge] = ACTIONS(4048),
    [anon_sym_gt] = ACTIONS(4048),
    [anon_sym_isa] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4048),
    [anon_sym_DASH_DASH] = ACTIONS(4048),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4048),
    [anon_sym_for] = ACTIONS(4052),
    [anon_sym_foreach] = ACTIONS(4048),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4048),
    [anon_sym___END__] = ACTIONS(4048),
    [anon_sym_EOT] = ACTIONS(4048),
    [anon_sym_if] = ACTIONS(4048),
    [anon_sym_unless] = ACTIONS(4048),
    [anon_sym_while] = ACTIONS(4048),
    [anon_sym_until] = ACTIONS(4048),
    [sym__PERLY_SEMICOLON] = ACTIONS(4048),
    [sym__ctrl_z_hack] = ACTIONS(4048),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1323] = {
    [sym_heredoc_content] = STATE(1323),
    [anon_sym_SEMI] = ACTIONS(4096),
    [anon_sym_COMMA] = ACTIONS(4096),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4096),
    [anon_sym_and] = ACTIONS(4096),
    [anon_sym_or] = ACTIONS(4096),
    [anon_sym_DASH_GT] = ACTIONS(4096),
    [anon_sym_PERCENT] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_GT] = ACTIONS(4098),
    [anon_sym_LT_LT] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4096),
    [anon_sym_PLUS_EQ] = ACTIONS(4096),
    [anon_sym_DASH_EQ] = ACTIONS(4096),
    [anon_sym_DOT_EQ] = ACTIONS(4096),
    [anon_sym_STAR_EQ] = ACTIONS(4096),
    [anon_sym_SLASH_EQ] = ACTIONS(4096),
    [anon_sym_PERCENT_EQ] = ACTIONS(4096),
    [anon_sym_x_EQ] = ACTIONS(4096),
    [anon_sym_AMP_EQ] = ACTIONS(4096),
    [anon_sym_PIPE_EQ] = ACTIONS(4096),
    [anon_sym_CARET_EQ] = ACTIONS(4096),
    [anon_sym_LT_LT_EQ] = ACTIONS(4096),
    [anon_sym_GT_GT_EQ] = ACTIONS(4096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4096),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4096),
    [anon_sym_DOT_DOT] = ACTIONS(4098),
    [anon_sym_STAR_STAR] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_SLASH_SLASH] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4098),
    [anon_sym_GT_GT2] = ACTIONS(4098),
    [anon_sym_PLUS] = ACTIONS(4098),
    [anon_sym_DASH] = ACTIONS(4098),
    [anon_sym_DOT] = ACTIONS(4098),
    [anon_sym_STAR] = ACTIONS(4098),
    [anon_sym_SLASH] = ACTIONS(4098),
    [anon_sym_x] = ACTIONS(4098),
    [anon_sym_EQ_TILDE] = ACTIONS(4096),
    [anon_sym_BANG_TILDE] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4096),
    [anon_sym_BANG_EQ] = ACTIONS(4096),
    [anon_sym_eq] = ACTIONS(4096),
    [anon_sym_ne] = ACTIONS(4096),
    [anon_sym_LT_EQ_GT] = ACTIONS(4096),
    [anon_sym_cmp] = ACTIONS(4096),
    [anon_sym_TILDE_TILDE] = ACTIONS(4096),
    [anon_sym_LT_EQ] = ACTIONS(4098),
    [anon_sym_GT_EQ] = ACTIONS(4096),
    [anon_sym_lt] = ACTIONS(4096),
    [anon_sym_le] = ACTIONS(4096),
    [anon_sym_ge] = ACTIONS(4096),
    [anon_sym_gt] = ACTIONS(4096),
    [anon_sym_isa] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_QMARK] = ACTIONS(4096),
    [anon_sym_EQ_GT] = ACTIONS(4096),
    [anon_sym_for] = ACTIONS(4098),
    [anon_sym_foreach] = ACTIONS(4096),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4096),
    [anon_sym___END__] = ACTIONS(4096),
    [anon_sym_EOT] = ACTIONS(4096),
    [anon_sym_if] = ACTIONS(4096),
    [anon_sym_unless] = ACTIONS(4096),
    [anon_sym_while] = ACTIONS(4096),
    [anon_sym_until] = ACTIONS(4096),
    [sym__PERLY_SEMICOLON] = ACTIONS(4096),
    [sym__ctrl_z_hack] = ACTIONS(4096),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1324] = {
    [sym_heredoc_content] = STATE(1324),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4100),
    [anon_sym_and] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_DASH_GT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_LT_LT] = ACTIONS(4102),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4100),
    [anon_sym_PLUS_EQ] = ACTIONS(4100),
    [anon_sym_DASH_EQ] = ACTIONS(4100),
    [anon_sym_DOT_EQ] = ACTIONS(4100),
    [anon_sym_STAR_EQ] = ACTIONS(4100),
    [anon_sym_SLASH_EQ] = ACTIONS(4100),
    [anon_sym_PERCENT_EQ] = ACTIONS(4100),
    [anon_sym_x_EQ] = ACTIONS(4100),
    [anon_sym_AMP_EQ] = ACTIONS(4100),
    [anon_sym_PIPE_EQ] = ACTIONS(4100),
    [anon_sym_CARET_EQ] = ACTIONS(4100),
    [anon_sym_LT_LT_EQ] = ACTIONS(4100),
    [anon_sym_GT_GT_EQ] = ACTIONS(4100),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4100),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4100),
    [anon_sym_DOT_DOT] = ACTIONS(4102),
    [anon_sym_STAR_STAR] = ACTIONS(4102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4102),
    [anon_sym_SLASH_SLASH] = ACTIONS(4102),
    [anon_sym_AMP_AMP] = ACTIONS(4102),
    [anon_sym_PIPE] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_GT_GT2] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4102),
    [anon_sym_SLASH] = ACTIONS(4102),
    [anon_sym_x] = ACTIONS(4102),
    [anon_sym_EQ_TILDE] = ACTIONS(4100),
    [anon_sym_BANG_TILDE] = ACTIONS(4100),
    [anon_sym_EQ_EQ] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_eq] = ACTIONS(4100),
    [anon_sym_ne] = ACTIONS(4100),
    [anon_sym_LT_EQ_GT] = ACTIONS(4100),
    [anon_sym_cmp] = ACTIONS(4100),
    [anon_sym_TILDE_TILDE] = ACTIONS(4100),
    [anon_sym_LT_EQ] = ACTIONS(4102),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_lt] = ACTIONS(4100),
    [anon_sym_le] = ACTIONS(4100),
    [anon_sym_ge] = ACTIONS(4100),
    [anon_sym_gt] = ACTIONS(4100),
    [anon_sym_isa] = ACTIONS(4100),
    [anon_sym_PLUS_PLUS] = ACTIONS(4100),
    [anon_sym_DASH_DASH] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_EQ_GT] = ACTIONS(4100),
    [anon_sym_for] = ACTIONS(4102),
    [anon_sym_foreach] = ACTIONS(4100),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4100),
    [anon_sym___END__] = ACTIONS(4100),
    [anon_sym_EOT] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_unless] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_until] = ACTIONS(4100),
    [sym__PERLY_SEMICOLON] = ACTIONS(4100),
    [sym__ctrl_z_hack] = ACTIONS(4100),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1325] = {
    [sym_heredoc_content] = STATE(1325),
    [anon_sym_SEMI] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_LT_LT] = ACTIONS(4106),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4104),
    [anon_sym_DASH_EQ] = ACTIONS(4104),
    [anon_sym_DOT_EQ] = ACTIONS(4104),
    [anon_sym_STAR_EQ] = ACTIONS(4104),
    [anon_sym_SLASH_EQ] = ACTIONS(4104),
    [anon_sym_PERCENT_EQ] = ACTIONS(4104),
    [anon_sym_x_EQ] = ACTIONS(4104),
    [anon_sym_AMP_EQ] = ACTIONS(4104),
    [anon_sym_PIPE_EQ] = ACTIONS(4104),
    [anon_sym_CARET_EQ] = ACTIONS(4104),
    [anon_sym_LT_LT_EQ] = ACTIONS(4104),
    [anon_sym_GT_GT_EQ] = ACTIONS(4104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4104),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4104),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_STAR_STAR] = ACTIONS(4106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4106),
    [anon_sym_SLASH_SLASH] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4106),
    [anon_sym_GT_GT2] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_DOT] = ACTIONS(4106),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_SLASH] = ACTIONS(4106),
    [anon_sym_x] = ACTIONS(4106),
    [anon_sym_EQ_TILDE] = ACTIONS(4104),
    [anon_sym_BANG_TILDE] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_eq] = ACTIONS(4104),
    [anon_sym_ne] = ACTIONS(4104),
    [anon_sym_LT_EQ_GT] = ACTIONS(4104),
    [anon_sym_cmp] = ACTIONS(4104),
    [anon_sym_TILDE_TILDE] = ACTIONS(4104),
    [anon_sym_LT_EQ] = ACTIONS(4106),
    [anon_sym_GT_EQ] = ACTIONS(4104),
    [anon_sym_lt] = ACTIONS(4104),
    [anon_sym_le] = ACTIONS(4104),
    [anon_sym_ge] = ACTIONS(4104),
    [anon_sym_gt] = ACTIONS(4104),
    [anon_sym_isa] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4104),
    [anon_sym_DASH_DASH] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_EQ_GT] = ACTIONS(4104),
    [anon_sym_for] = ACTIONS(4106),
    [anon_sym_foreach] = ACTIONS(4104),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4104),
    [anon_sym___END__] = ACTIONS(4104),
    [anon_sym_EOT] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_unless] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_until] = ACTIONS(4104),
    [sym__PERLY_SEMICOLON] = ACTIONS(4104),
    [sym__ctrl_z_hack] = ACTIONS(4104),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1326] = {
    [sym_heredoc_content] = STATE(1326),
    [anon_sym_SEMI] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_GT] = ACTIONS(4110),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4108),
    [anon_sym_DASH_EQ] = ACTIONS(4108),
    [anon_sym_DOT_EQ] = ACTIONS(4108),
    [anon_sym_STAR_EQ] = ACTIONS(4108),
    [anon_sym_SLASH_EQ] = ACTIONS(4108),
    [anon_sym_PERCENT_EQ] = ACTIONS(4108),
    [anon_sym_x_EQ] = ACTIONS(4108),
    [anon_sym_AMP_EQ] = ACTIONS(4108),
    [anon_sym_PIPE_EQ] = ACTIONS(4108),
    [anon_sym_CARET_EQ] = ACTIONS(4108),
    [anon_sym_LT_LT_EQ] = ACTIONS(4108),
    [anon_sym_GT_GT_EQ] = ACTIONS(4108),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4108),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4108),
    [anon_sym_DOT_DOT] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4110),
    [anon_sym_SLASH_SLASH] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_GT_GT2] = ACTIONS(4110),
    [anon_sym_PLUS] = ACTIONS(4110),
    [anon_sym_DASH] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4110),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_x] = ACTIONS(4110),
    [anon_sym_EQ_TILDE] = ACTIONS(4108),
    [anon_sym_BANG_TILDE] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_eq] = ACTIONS(4108),
    [anon_sym_ne] = ACTIONS(4108),
    [anon_sym_LT_EQ_GT] = ACTIONS(4108),
    [anon_sym_cmp] = ACTIONS(4108),
    [anon_sym_TILDE_TILDE] = ACTIONS(4108),
    [anon_sym_LT_EQ] = ACTIONS(4110),
    [anon_sym_GT_EQ] = ACTIONS(4108),
    [anon_sym_lt] = ACTIONS(4108),
    [anon_sym_le] = ACTIONS(4108),
    [anon_sym_ge] = ACTIONS(4108),
    [anon_sym_gt] = ACTIONS(4108),
    [anon_sym_isa] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4108),
    [anon_sym_DASH_DASH] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_EQ_GT] = ACTIONS(4108),
    [anon_sym_for] = ACTIONS(4110),
    [anon_sym_foreach] = ACTIONS(4108),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4108),
    [anon_sym___END__] = ACTIONS(4108),
    [anon_sym_EOT] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_unless] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_until] = ACTIONS(4108),
    [sym__PERLY_SEMICOLON] = ACTIONS(4108),
    [sym__ctrl_z_hack] = ACTIONS(4108),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1327] = {
    [sym_heredoc_content] = STATE(1327),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4112),
    [anon_sym_and] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_DASH_GT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(4114),
    [anon_sym_GT] = ACTIONS(4114),
    [anon_sym_LT_LT] = ACTIONS(4114),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4112),
    [anon_sym_PLUS_EQ] = ACTIONS(4112),
    [anon_sym_DASH_EQ] = ACTIONS(4112),
    [anon_sym_DOT_EQ] = ACTIONS(4112),
    [anon_sym_STAR_EQ] = ACTIONS(4112),
    [anon_sym_SLASH_EQ] = ACTIONS(4112),
    [anon_sym_PERCENT_EQ] = ACTIONS(4112),
    [anon_sym_x_EQ] = ACTIONS(4112),
    [anon_sym_AMP_EQ] = ACTIONS(4112),
    [anon_sym_PIPE_EQ] = ACTIONS(4112),
    [anon_sym_CARET_EQ] = ACTIONS(4112),
    [anon_sym_LT_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_GT_EQ] = ACTIONS(4112),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4112),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT] = ACTIONS(4114),
    [anon_sym_STAR_STAR] = ACTIONS(4114),
    [anon_sym_PIPE_PIPE] = ACTIONS(4114),
    [anon_sym_SLASH_SLASH] = ACTIONS(4114),
    [anon_sym_AMP_AMP] = ACTIONS(4114),
    [anon_sym_PIPE] = ACTIONS(4114),
    [anon_sym_AMP] = ACTIONS(4114),
    [anon_sym_GT_GT2] = ACTIONS(4114),
    [anon_sym_PLUS] = ACTIONS(4114),
    [anon_sym_DASH] = ACTIONS(4114),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_STAR] = ACTIONS(4114),
    [anon_sym_SLASH] = ACTIONS(4114),
    [anon_sym_x] = ACTIONS(4114),
    [anon_sym_EQ_TILDE] = ACTIONS(4112),
    [anon_sym_BANG_TILDE] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_eq] = ACTIONS(4112),
    [anon_sym_ne] = ACTIONS(4112),
    [anon_sym_LT_EQ_GT] = ACTIONS(4112),
    [anon_sym_cmp] = ACTIONS(4112),
    [anon_sym_TILDE_TILDE] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4114),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_lt] = ACTIONS(4112),
    [anon_sym_le] = ACTIONS(4112),
    [anon_sym_ge] = ACTIONS(4112),
    [anon_sym_gt] = ACTIONS(4112),
    [anon_sym_isa] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_EQ_GT] = ACTIONS(4112),
    [anon_sym_for] = ACTIONS(4114),
    [anon_sym_foreach] = ACTIONS(4112),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4112),
    [anon_sym___END__] = ACTIONS(4112),
    [anon_sym_EOT] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_unless] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_until] = ACTIONS(4112),
    [sym__PERLY_SEMICOLON] = ACTIONS(4112),
    [sym__ctrl_z_hack] = ACTIONS(4112),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1328] = {
    [sym_heredoc_content] = STATE(1328),
    [anon_sym_SEMI] = ACTIONS(4116),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4116),
    [anon_sym_and] = ACTIONS(4116),
    [anon_sym_or] = ACTIONS(4116),
    [anon_sym_DASH_GT] = ACTIONS(4116),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4116),
    [anon_sym_PLUS_EQ] = ACTIONS(4116),
    [anon_sym_DASH_EQ] = ACTIONS(4116),
    [anon_sym_DOT_EQ] = ACTIONS(4116),
    [anon_sym_STAR_EQ] = ACTIONS(4116),
    [anon_sym_SLASH_EQ] = ACTIONS(4116),
    [anon_sym_PERCENT_EQ] = ACTIONS(4116),
    [anon_sym_x_EQ] = ACTIONS(4116),
    [anon_sym_AMP_EQ] = ACTIONS(4116),
    [anon_sym_PIPE_EQ] = ACTIONS(4116),
    [anon_sym_CARET_EQ] = ACTIONS(4116),
    [anon_sym_LT_LT_EQ] = ACTIONS(4116),
    [anon_sym_GT_GT_EQ] = ACTIONS(4116),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4116),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4116),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_SLASH_SLASH] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_GT_GT2] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_x] = ACTIONS(4118),
    [anon_sym_EQ_TILDE] = ACTIONS(4116),
    [anon_sym_BANG_TILDE] = ACTIONS(4116),
    [anon_sym_EQ_EQ] = ACTIONS(4116),
    [anon_sym_BANG_EQ] = ACTIONS(4116),
    [anon_sym_eq] = ACTIONS(4116),
    [anon_sym_ne] = ACTIONS(4116),
    [anon_sym_LT_EQ_GT] = ACTIONS(4116),
    [anon_sym_cmp] = ACTIONS(4116),
    [anon_sym_TILDE_TILDE] = ACTIONS(4116),
    [anon_sym_LT_EQ] = ACTIONS(4118),
    [anon_sym_GT_EQ] = ACTIONS(4116),
    [anon_sym_lt] = ACTIONS(4116),
    [anon_sym_le] = ACTIONS(4116),
    [anon_sym_ge] = ACTIONS(4116),
    [anon_sym_gt] = ACTIONS(4116),
    [anon_sym_isa] = ACTIONS(4116),
    [anon_sym_PLUS_PLUS] = ACTIONS(4116),
    [anon_sym_DASH_DASH] = ACTIONS(4116),
    [anon_sym_QMARK] = ACTIONS(4116),
    [anon_sym_EQ_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_foreach] = ACTIONS(4116),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4116),
    [anon_sym___END__] = ACTIONS(4116),
    [anon_sym_EOT] = ACTIONS(4116),
    [anon_sym_if] = ACTIONS(4116),
    [anon_sym_unless] = ACTIONS(4116),
    [anon_sym_while] = ACTIONS(4116),
    [anon_sym_until] = ACTIONS(4116),
    [sym__PERLY_SEMICOLON] = ACTIONS(4116),
    [sym__ctrl_z_hack] = ACTIONS(4116),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1329] = {
    [sym_heredoc_content] = STATE(1329),
    [anon_sym_SEMI] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4122),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4120),
    [anon_sym_PLUS_EQ] = ACTIONS(4120),
    [anon_sym_DASH_EQ] = ACTIONS(4120),
    [anon_sym_DOT_EQ] = ACTIONS(4120),
    [anon_sym_STAR_EQ] = ACTIONS(4120),
    [anon_sym_SLASH_EQ] = ACTIONS(4120),
    [anon_sym_PERCENT_EQ] = ACTIONS(4120),
    [anon_sym_x_EQ] = ACTIONS(4120),
    [anon_sym_AMP_EQ] = ACTIONS(4120),
    [anon_sym_PIPE_EQ] = ACTIONS(4120),
    [anon_sym_CARET_EQ] = ACTIONS(4120),
    [anon_sym_LT_LT_EQ] = ACTIONS(4120),
    [anon_sym_GT_GT_EQ] = ACTIONS(4120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4120),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_STAR_STAR] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_SLASH_SLASH] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4122),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_GT_GT2] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4122),
    [anon_sym_x] = ACTIONS(4122),
    [anon_sym_EQ_TILDE] = ACTIONS(4120),
    [anon_sym_BANG_TILDE] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_eq] = ACTIONS(4120),
    [anon_sym_ne] = ACTIONS(4120),
    [anon_sym_LT_EQ_GT] = ACTIONS(4120),
    [anon_sym_cmp] = ACTIONS(4120),
    [anon_sym_TILDE_TILDE] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_lt] = ACTIONS(4120),
    [anon_sym_le] = ACTIONS(4120),
    [anon_sym_ge] = ACTIONS(4120),
    [anon_sym_gt] = ACTIONS(4120),
    [anon_sym_isa] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_foreach] = ACTIONS(4120),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4120),
    [anon_sym___END__] = ACTIONS(4120),
    [anon_sym_EOT] = ACTIONS(4120),
    [anon_sym_if] = ACTIONS(4120),
    [anon_sym_unless] = ACTIONS(4120),
    [anon_sym_while] = ACTIONS(4120),
    [anon_sym_until] = ACTIONS(4120),
    [sym__PERLY_SEMICOLON] = ACTIONS(4120),
    [sym__ctrl_z_hack] = ACTIONS(4120),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1330] = {
    [sym_attribute] = STATE(1374),
    [sym_attribute_name] = STATE(1369),
    [sym_heredoc_content] = STATE(1330),
    [aux_sym_attrlist_repeat1] = STATE(1330),
    [sym__identifier] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4127),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_and] = ACTIONS(3410),
    [anon_sym_or] = ACTIONS(3410),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3410),
    [anon_sym___END__] = ACTIONS(3410),
    [anon_sym_EOT] = ACTIONS(3408),
    [aux_sym__bareword_token1] = ACTIONS(4124),
    [sym__PERLY_SEMICOLON] = ACTIONS(3408),
    [sym__ctrl_z_hack] = ACTIONS(3408),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1331] = {
    [sym_heredoc_content] = STATE(1331),
    [anon_sym_SEMI] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_DASH_GT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4132),
    [anon_sym_GT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(4132),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4130),
    [anon_sym_DASH_EQ] = ACTIONS(4130),
    [anon_sym_DOT_EQ] = ACTIONS(4130),
    [anon_sym_STAR_EQ] = ACTIONS(4130),
    [anon_sym_SLASH_EQ] = ACTIONS(4130),
    [anon_sym_PERCENT_EQ] = ACTIONS(4130),
    [anon_sym_x_EQ] = ACTIONS(4130),
    [anon_sym_AMP_EQ] = ACTIONS(4130),
    [anon_sym_PIPE_EQ] = ACTIONS(4130),
    [anon_sym_CARET_EQ] = ACTIONS(4130),
    [anon_sym_LT_LT_EQ] = ACTIONS(4130),
    [anon_sym_GT_GT_EQ] = ACTIONS(4130),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4130),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_STAR_STAR] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_SLASH_SLASH] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4132),
    [anon_sym_AMP] = ACTIONS(4132),
    [anon_sym_GT_GT2] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4132),
    [anon_sym_DASH] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4132),
    [anon_sym_x] = ACTIONS(4132),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_EQ_EQ] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_eq] = ACTIONS(4130),
    [anon_sym_ne] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_cmp] = ACTIONS(4130),
    [anon_sym_TILDE_TILDE] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4130),
    [anon_sym_lt] = ACTIONS(4130),
    [anon_sym_le] = ACTIONS(4130),
    [anon_sym_ge] = ACTIONS(4130),
    [anon_sym_gt] = ACTIONS(4130),
    [anon_sym_isa] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4130),
    [anon_sym_DASH_DASH] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4130),
    [anon_sym_for] = ACTIONS(4132),
    [anon_sym_foreach] = ACTIONS(4130),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4130),
    [anon_sym___END__] = ACTIONS(4130),
    [anon_sym_EOT] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_unless] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_until] = ACTIONS(4130),
    [sym__PERLY_SEMICOLON] = ACTIONS(4130),
    [sym__ctrl_z_hack] = ACTIONS(4130),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1332] = {
    [sym_heredoc_content] = STATE(1332),
    [anon_sym_SEMI] = ACTIONS(4134),
    [anon_sym_COMMA] = ACTIONS(4134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4134),
    [anon_sym_and] = ACTIONS(4134),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_DASH_GT] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4136),
    [anon_sym_EQ] = ACTIONS(4136),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4134),
    [anon_sym_PLUS_EQ] = ACTIONS(4134),
    [anon_sym_DASH_EQ] = ACTIONS(4134),
    [anon_sym_DOT_EQ] = ACTIONS(4134),
    [anon_sym_STAR_EQ] = ACTIONS(4134),
    [anon_sym_SLASH_EQ] = ACTIONS(4134),
    [anon_sym_PERCENT_EQ] = ACTIONS(4134),
    [anon_sym_x_EQ] = ACTIONS(4134),
    [anon_sym_AMP_EQ] = ACTIONS(4134),
    [anon_sym_PIPE_EQ] = ACTIONS(4134),
    [anon_sym_CARET_EQ] = ACTIONS(4134),
    [anon_sym_LT_LT_EQ] = ACTIONS(4134),
    [anon_sym_GT_GT_EQ] = ACTIONS(4134),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4134),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4134),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4134),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_STAR_STAR] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_SLASH_SLASH] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4136),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT_GT2] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4136),
    [anon_sym_DASH] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_STAR] = ACTIONS(4136),
    [anon_sym_SLASH] = ACTIONS(4136),
    [anon_sym_x] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4134),
    [anon_sym_BANG_TILDE] = ACTIONS(4134),
    [anon_sym_EQ_EQ] = ACTIONS(4134),
    [anon_sym_BANG_EQ] = ACTIONS(4134),
    [anon_sym_eq] = ACTIONS(4134),
    [anon_sym_ne] = ACTIONS(4134),
    [anon_sym_LT_EQ_GT] = ACTIONS(4134),
    [anon_sym_cmp] = ACTIONS(4134),
    [anon_sym_TILDE_TILDE] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4134),
    [anon_sym_lt] = ACTIONS(4134),
    [anon_sym_le] = ACTIONS(4134),
    [anon_sym_ge] = ACTIONS(4134),
    [anon_sym_gt] = ACTIONS(4134),
    [anon_sym_isa] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4134),
    [anon_sym_DASH_DASH] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4134),
    [anon_sym_for] = ACTIONS(4136),
    [anon_sym_foreach] = ACTIONS(4134),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4134),
    [anon_sym___END__] = ACTIONS(4134),
    [anon_sym_EOT] = ACTIONS(4134),
    [anon_sym_if] = ACTIONS(4134),
    [anon_sym_unless] = ACTIONS(4134),
    [anon_sym_while] = ACTIONS(4134),
    [anon_sym_until] = ACTIONS(4134),
    [sym__PERLY_SEMICOLON] = ACTIONS(4134),
    [sym__ctrl_z_hack] = ACTIONS(4134),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1333] = {
    [sym_heredoc_content] = STATE(1333),
    [anon_sym_SEMI] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4140),
    [anon_sym_GT] = ACTIONS(4140),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4140),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4138),
    [anon_sym_DASH_EQ] = ACTIONS(4138),
    [anon_sym_DOT_EQ] = ACTIONS(4138),
    [anon_sym_STAR_EQ] = ACTIONS(4138),
    [anon_sym_SLASH_EQ] = ACTIONS(4138),
    [anon_sym_PERCENT_EQ] = ACTIONS(4138),
    [anon_sym_x_EQ] = ACTIONS(4138),
    [anon_sym_AMP_EQ] = ACTIONS(4138),
    [anon_sym_PIPE_EQ] = ACTIONS(4138),
    [anon_sym_CARET_EQ] = ACTIONS(4138),
    [anon_sym_LT_LT_EQ] = ACTIONS(4138),
    [anon_sym_GT_GT_EQ] = ACTIONS(4138),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4138),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4138),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_STAR_STAR] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_SLASH_SLASH] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4140),
    [anon_sym_AMP] = ACTIONS(4140),
    [anon_sym_GT_GT2] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4140),
    [anon_sym_DASH] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4140),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4140),
    [anon_sym_x] = ACTIONS(4140),
    [anon_sym_EQ_TILDE] = ACTIONS(4138),
    [anon_sym_BANG_TILDE] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_BANG_EQ] = ACTIONS(4138),
    [anon_sym_eq] = ACTIONS(4138),
    [anon_sym_ne] = ACTIONS(4138),
    [anon_sym_LT_EQ_GT] = ACTIONS(4138),
    [anon_sym_cmp] = ACTIONS(4138),
    [anon_sym_TILDE_TILDE] = ACTIONS(4138),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4138),
    [anon_sym_lt] = ACTIONS(4138),
    [anon_sym_le] = ACTIONS(4138),
    [anon_sym_ge] = ACTIONS(4138),
    [anon_sym_gt] = ACTIONS(4138),
    [anon_sym_isa] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4138),
    [anon_sym_DASH_DASH] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4138),
    [anon_sym_for] = ACTIONS(4140),
    [anon_sym_foreach] = ACTIONS(4138),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4138),
    [anon_sym___END__] = ACTIONS(4138),
    [anon_sym_EOT] = ACTIONS(4138),
    [anon_sym_if] = ACTIONS(4138),
    [anon_sym_unless] = ACTIONS(4138),
    [anon_sym_while] = ACTIONS(4138),
    [anon_sym_until] = ACTIONS(4138),
    [sym__PERLY_SEMICOLON] = ACTIONS(4138),
    [sym__ctrl_z_hack] = ACTIONS(4138),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1334] = {
    [sym_heredoc_content] = STATE(1334),
    [anon_sym_SEMI] = ACTIONS(4142),
    [anon_sym_COMMA] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4142),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_DASH_GT] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4144),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4144),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4142),
    [anon_sym_PLUS_EQ] = ACTIONS(4142),
    [anon_sym_DASH_EQ] = ACTIONS(4142),
    [anon_sym_DOT_EQ] = ACTIONS(4142),
    [anon_sym_STAR_EQ] = ACTIONS(4142),
    [anon_sym_SLASH_EQ] = ACTIONS(4142),
    [anon_sym_PERCENT_EQ] = ACTIONS(4142),
    [anon_sym_x_EQ] = ACTIONS(4142),
    [anon_sym_AMP_EQ] = ACTIONS(4142),
    [anon_sym_PIPE_EQ] = ACTIONS(4142),
    [anon_sym_CARET_EQ] = ACTIONS(4142),
    [anon_sym_LT_LT_EQ] = ACTIONS(4142),
    [anon_sym_GT_GT_EQ] = ACTIONS(4142),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4142),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4142),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_STAR_STAR] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_SLASH_SLASH] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4144),
    [anon_sym_AMP] = ACTIONS(4144),
    [anon_sym_GT_GT2] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4144),
    [anon_sym_DASH] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4144),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4144),
    [anon_sym_x] = ACTIONS(4144),
    [anon_sym_EQ_TILDE] = ACTIONS(4142),
    [anon_sym_BANG_TILDE] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4142),
    [anon_sym_BANG_EQ] = ACTIONS(4142),
    [anon_sym_eq] = ACTIONS(4142),
    [anon_sym_ne] = ACTIONS(4142),
    [anon_sym_LT_EQ_GT] = ACTIONS(4142),
    [anon_sym_cmp] = ACTIONS(4142),
    [anon_sym_TILDE_TILDE] = ACTIONS(4142),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_lt] = ACTIONS(4142),
    [anon_sym_le] = ACTIONS(4142),
    [anon_sym_ge] = ACTIONS(4142),
    [anon_sym_gt] = ACTIONS(4142),
    [anon_sym_isa] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4142),
    [anon_sym_DASH_DASH] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4142),
    [anon_sym_for] = ACTIONS(4144),
    [anon_sym_foreach] = ACTIONS(4142),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4142),
    [anon_sym___END__] = ACTIONS(4142),
    [anon_sym_EOT] = ACTIONS(4142),
    [anon_sym_if] = ACTIONS(4142),
    [anon_sym_unless] = ACTIONS(4142),
    [anon_sym_while] = ACTIONS(4142),
    [anon_sym_until] = ACTIONS(4142),
    [sym__PERLY_SEMICOLON] = ACTIONS(4142),
    [sym__ctrl_z_hack] = ACTIONS(4142),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1335] = {
    [sym_heredoc_content] = STATE(1335),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_and] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4148),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_DOT_EQ] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_x_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_DOT_DOT] = ACTIONS(4148),
    [anon_sym_STAR_STAR] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_SLASH_SLASH] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4148),
    [anon_sym_AMP] = ACTIONS(4148),
    [anon_sym_GT_GT2] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4148),
    [anon_sym_DASH] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4148),
    [anon_sym_x] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4146),
    [anon_sym_BANG_TILDE] = ACTIONS(4146),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_eq] = ACTIONS(4146),
    [anon_sym_ne] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_cmp] = ACTIONS(4146),
    [anon_sym_TILDE_TILDE] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_lt] = ACTIONS(4146),
    [anon_sym_le] = ACTIONS(4146),
    [anon_sym_ge] = ACTIONS(4146),
    [anon_sym_gt] = ACTIONS(4146),
    [anon_sym_isa] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_EQ_GT] = ACTIONS(4146),
    [anon_sym_for] = ACTIONS(4148),
    [anon_sym_foreach] = ACTIONS(4146),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4146),
    [anon_sym___END__] = ACTIONS(4146),
    [anon_sym_EOT] = ACTIONS(4146),
    [anon_sym_if] = ACTIONS(4146),
    [anon_sym_unless] = ACTIONS(4146),
    [anon_sym_while] = ACTIONS(4146),
    [anon_sym_until] = ACTIONS(4146),
    [sym__PERLY_SEMICOLON] = ACTIONS(4146),
    [sym__ctrl_z_hack] = ACTIONS(4146),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1336] = {
    [sym_heredoc_content] = STATE(1336),
    [anon_sym_SEMI] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4150),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_LT] = ACTIONS(4152),
    [anon_sym_GT] = ACTIONS(4152),
    [anon_sym_LT_LT] = ACTIONS(4152),
    [anon_sym_EQ] = ACTIONS(4152),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4150),
    [anon_sym_PLUS_EQ] = ACTIONS(4150),
    [anon_sym_DASH_EQ] = ACTIONS(4150),
    [anon_sym_DOT_EQ] = ACTIONS(4150),
    [anon_sym_STAR_EQ] = ACTIONS(4150),
    [anon_sym_SLASH_EQ] = ACTIONS(4150),
    [anon_sym_PERCENT_EQ] = ACTIONS(4150),
    [anon_sym_x_EQ] = ACTIONS(4150),
    [anon_sym_AMP_EQ] = ACTIONS(4150),
    [anon_sym_PIPE_EQ] = ACTIONS(4150),
    [anon_sym_CARET_EQ] = ACTIONS(4150),
    [anon_sym_LT_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT_GT_EQ] = ACTIONS(4150),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4150),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4152),
    [anon_sym_STAR_STAR] = ACTIONS(4152),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_SLASH_SLASH] = ACTIONS(4152),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4152),
    [anon_sym_AMP] = ACTIONS(4152),
    [anon_sym_GT_GT2] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4152),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_SLASH] = ACTIONS(4152),
    [anon_sym_x] = ACTIONS(4152),
    [anon_sym_EQ_TILDE] = ACTIONS(4150),
    [anon_sym_BANG_TILDE] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4150),
    [anon_sym_eq] = ACTIONS(4150),
    [anon_sym_ne] = ACTIONS(4150),
    [anon_sym_LT_EQ_GT] = ACTIONS(4150),
    [anon_sym_cmp] = ACTIONS(4150),
    [anon_sym_TILDE_TILDE] = ACTIONS(4150),
    [anon_sym_LT_EQ] = ACTIONS(4152),
    [anon_sym_GT_EQ] = ACTIONS(4150),
    [anon_sym_lt] = ACTIONS(4150),
    [anon_sym_le] = ACTIONS(4150),
    [anon_sym_ge] = ACTIONS(4150),
    [anon_sym_gt] = ACTIONS(4150),
    [anon_sym_isa] = ACTIONS(4150),
    [anon_sym_PLUS_PLUS] = ACTIONS(4150),
    [anon_sym_DASH_DASH] = ACTIONS(4150),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4152),
    [anon_sym_foreach] = ACTIONS(4150),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4150),
    [anon_sym___END__] = ACTIONS(4150),
    [anon_sym_EOT] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [sym__PERLY_SEMICOLON] = ACTIONS(4150),
    [sym__ctrl_z_hack] = ACTIONS(4150),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1337] = {
    [sym_heredoc_content] = STATE(1337),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3650),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4154),
    [anon_sym_PLUS_EQ] = ACTIONS(4154),
    [anon_sym_DASH_EQ] = ACTIONS(4154),
    [anon_sym_DOT_EQ] = ACTIONS(4154),
    [anon_sym_STAR_EQ] = ACTIONS(4154),
    [anon_sym_SLASH_EQ] = ACTIONS(4154),
    [anon_sym_PERCENT_EQ] = ACTIONS(4154),
    [anon_sym_x_EQ] = ACTIONS(4154),
    [anon_sym_AMP_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_CARET_EQ] = ACTIONS(4154),
    [anon_sym_LT_LT_EQ] = ACTIONS(4154),
    [anon_sym_GT_GT_EQ] = ACTIONS(4154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4154),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_SLASH_SLASH] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3690),
    [anon_sym_EQ_GT] = ACTIONS(4154),
    [anon_sym_for] = ACTIONS(4156),
    [anon_sym_foreach] = ACTIONS(4154),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4154),
    [anon_sym___END__] = ACTIONS(4154),
    [anon_sym_EOT] = ACTIONS(4154),
    [anon_sym_if] = ACTIONS(4154),
    [anon_sym_unless] = ACTIONS(4154),
    [anon_sym_while] = ACTIONS(4154),
    [anon_sym_until] = ACTIONS(4154),
    [sym__PERLY_SEMICOLON] = ACTIONS(4154),
    [sym__ctrl_z_hack] = ACTIONS(4154),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1338] = {
    [sym_heredoc_content] = STATE(1338),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_DASH_GT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_LT_LT] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4158),
    [anon_sym_PLUS_EQ] = ACTIONS(4158),
    [anon_sym_DASH_EQ] = ACTIONS(4158),
    [anon_sym_DOT_EQ] = ACTIONS(4158),
    [anon_sym_STAR_EQ] = ACTIONS(4158),
    [anon_sym_SLASH_EQ] = ACTIONS(4158),
    [anon_sym_PERCENT_EQ] = ACTIONS(4158),
    [anon_sym_x_EQ] = ACTIONS(4158),
    [anon_sym_AMP_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_CARET_EQ] = ACTIONS(4158),
    [anon_sym_LT_LT_EQ] = ACTIONS(4158),
    [anon_sym_GT_GT_EQ] = ACTIONS(4158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4158),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_STAR_STAR] = ACTIONS(4160),
    [anon_sym_PIPE_PIPE] = ACTIONS(4160),
    [anon_sym_SLASH_SLASH] = ACTIONS(4160),
    [anon_sym_AMP_AMP] = ACTIONS(4160),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_GT_GT2] = ACTIONS(4160),
    [anon_sym_PLUS] = ACTIONS(4160),
    [anon_sym_DASH] = ACTIONS(4160),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_STAR] = ACTIONS(4160),
    [anon_sym_SLASH] = ACTIONS(4160),
    [anon_sym_x] = ACTIONS(4160),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_EQ_EQ] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_eq] = ACTIONS(4158),
    [anon_sym_ne] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_cmp] = ACTIONS(4158),
    [anon_sym_TILDE_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_lt] = ACTIONS(4158),
    [anon_sym_le] = ACTIONS(4158),
    [anon_sym_ge] = ACTIONS(4158),
    [anon_sym_gt] = ACTIONS(4158),
    [anon_sym_isa] = ACTIONS(4158),
    [anon_sym_PLUS_PLUS] = ACTIONS(4158),
    [anon_sym_DASH_DASH] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4158),
    [anon_sym_for] = ACTIONS(4160),
    [anon_sym_foreach] = ACTIONS(4158),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4158),
    [anon_sym___END__] = ACTIONS(4158),
    [anon_sym_EOT] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_unless] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_until] = ACTIONS(4158),
    [sym__PERLY_SEMICOLON] = ACTIONS(4158),
    [sym__ctrl_z_hack] = ACTIONS(4158),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1339] = {
    [sym_heredoc_content] = STATE(1339),
    [anon_sym_SEMI] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4162),
    [anon_sym_and] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_DASH_GT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4164),
    [anon_sym_GT] = ACTIONS(4164),
    [anon_sym_LT_LT] = ACTIONS(4164),
    [anon_sym_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4162),
    [anon_sym_PLUS_EQ] = ACTIONS(4162),
    [anon_sym_DASH_EQ] = ACTIONS(4162),
    [anon_sym_DOT_EQ] = ACTIONS(4162),
    [anon_sym_STAR_EQ] = ACTIONS(4162),
    [anon_sym_SLASH_EQ] = ACTIONS(4162),
    [anon_sym_PERCENT_EQ] = ACTIONS(4162),
    [anon_sym_x_EQ] = ACTIONS(4162),
    [anon_sym_AMP_EQ] = ACTIONS(4162),
    [anon_sym_PIPE_EQ] = ACTIONS(4162),
    [anon_sym_CARET_EQ] = ACTIONS(4162),
    [anon_sym_LT_LT_EQ] = ACTIONS(4162),
    [anon_sym_GT_GT_EQ] = ACTIONS(4162),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4162),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4162),
    [anon_sym_DOT_DOT] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4164),
    [anon_sym_SLASH_SLASH] = ACTIONS(4164),
    [anon_sym_AMP_AMP] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_GT_GT2] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_x] = ACTIONS(4164),
    [anon_sym_EQ_TILDE] = ACTIONS(4162),
    [anon_sym_BANG_TILDE] = ACTIONS(4162),
    [anon_sym_EQ_EQ] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_eq] = ACTIONS(4162),
    [anon_sym_ne] = ACTIONS(4162),
    [anon_sym_LT_EQ_GT] = ACTIONS(4162),
    [anon_sym_cmp] = ACTIONS(4162),
    [anon_sym_TILDE_TILDE] = ACTIONS(4162),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4162),
    [anon_sym_lt] = ACTIONS(4162),
    [anon_sym_le] = ACTIONS(4162),
    [anon_sym_ge] = ACTIONS(4162),
    [anon_sym_gt] = ACTIONS(4162),
    [anon_sym_isa] = ACTIONS(4162),
    [anon_sym_PLUS_PLUS] = ACTIONS(4162),
    [anon_sym_DASH_DASH] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_EQ_GT] = ACTIONS(4162),
    [anon_sym_for] = ACTIONS(4164),
    [anon_sym_foreach] = ACTIONS(4162),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4162),
    [anon_sym___END__] = ACTIONS(4162),
    [anon_sym_EOT] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_unless] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_until] = ACTIONS(4162),
    [sym__PERLY_SEMICOLON] = ACTIONS(4162),
    [sym__ctrl_z_hack] = ACTIONS(4162),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1340] = {
    [sym_heredoc_content] = STATE(1340),
    [anon_sym_SEMI] = ACTIONS(4166),
    [anon_sym_COMMA] = ACTIONS(4166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4166),
    [anon_sym_and] = ACTIONS(4166),
    [anon_sym_or] = ACTIONS(4166),
    [anon_sym_DASH_GT] = ACTIONS(4166),
    [anon_sym_PERCENT] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_GT] = ACTIONS(4168),
    [anon_sym_LT_LT] = ACTIONS(4168),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4166),
    [anon_sym_PLUS_EQ] = ACTIONS(4166),
    [anon_sym_DASH_EQ] = ACTIONS(4166),
    [anon_sym_DOT_EQ] = ACTIONS(4166),
    [anon_sym_STAR_EQ] = ACTIONS(4166),
    [anon_sym_SLASH_EQ] = ACTIONS(4166),
    [anon_sym_PERCENT_EQ] = ACTIONS(4166),
    [anon_sym_x_EQ] = ACTIONS(4166),
    [anon_sym_AMP_EQ] = ACTIONS(4166),
    [anon_sym_PIPE_EQ] = ACTIONS(4166),
    [anon_sym_CARET_EQ] = ACTIONS(4166),
    [anon_sym_LT_LT_EQ] = ACTIONS(4166),
    [anon_sym_GT_GT_EQ] = ACTIONS(4166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4166),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4166),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_STAR_STAR] = ACTIONS(4168),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_SLASH_SLASH] = ACTIONS(4168),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_PIPE] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_GT_GT2] = ACTIONS(4168),
    [anon_sym_PLUS] = ACTIONS(4168),
    [anon_sym_DASH] = ACTIONS(4168),
    [anon_sym_DOT] = ACTIONS(4168),
    [anon_sym_STAR] = ACTIONS(4168),
    [anon_sym_SLASH] = ACTIONS(4168),
    [anon_sym_x] = ACTIONS(4168),
    [anon_sym_EQ_TILDE] = ACTIONS(4166),
    [anon_sym_BANG_TILDE] = ACTIONS(4166),
    [anon_sym_EQ_EQ] = ACTIONS(4166),
    [anon_sym_BANG_EQ] = ACTIONS(4166),
    [anon_sym_eq] = ACTIONS(4166),
    [anon_sym_ne] = ACTIONS(4166),
    [anon_sym_LT_EQ_GT] = ACTIONS(4166),
    [anon_sym_cmp] = ACTIONS(4166),
    [anon_sym_TILDE_TILDE] = ACTIONS(4166),
    [anon_sym_LT_EQ] = ACTIONS(4168),
    [anon_sym_GT_EQ] = ACTIONS(4166),
    [anon_sym_lt] = ACTIONS(4166),
    [anon_sym_le] = ACTIONS(4166),
    [anon_sym_ge] = ACTIONS(4166),
    [anon_sym_gt] = ACTIONS(4166),
    [anon_sym_isa] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4166),
    [anon_sym_DASH_DASH] = ACTIONS(4166),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_EQ_GT] = ACTIONS(4166),
    [anon_sym_for] = ACTIONS(4168),
    [anon_sym_foreach] = ACTIONS(4166),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4166),
    [anon_sym___END__] = ACTIONS(4166),
    [anon_sym_EOT] = ACTIONS(4166),
    [anon_sym_if] = ACTIONS(4166),
    [anon_sym_unless] = ACTIONS(4166),
    [anon_sym_while] = ACTIONS(4166),
    [anon_sym_until] = ACTIONS(4166),
    [sym__PERLY_SEMICOLON] = ACTIONS(4166),
    [sym__ctrl_z_hack] = ACTIONS(4166),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1341] = {
    [sym_heredoc_content] = STATE(1341),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4170),
    [anon_sym_and] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_DASH_GT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_GT] = ACTIONS(4172),
    [anon_sym_LT_LT] = ACTIONS(4172),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4170),
    [anon_sym_PLUS_EQ] = ACTIONS(4170),
    [anon_sym_DASH_EQ] = ACTIONS(4170),
    [anon_sym_DOT_EQ] = ACTIONS(4170),
    [anon_sym_STAR_EQ] = ACTIONS(4170),
    [anon_sym_SLASH_EQ] = ACTIONS(4170),
    [anon_sym_PERCENT_EQ] = ACTIONS(4170),
    [anon_sym_x_EQ] = ACTIONS(4170),
    [anon_sym_AMP_EQ] = ACTIONS(4170),
    [anon_sym_PIPE_EQ] = ACTIONS(4170),
    [anon_sym_CARET_EQ] = ACTIONS(4170),
    [anon_sym_LT_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT_GT_EQ] = ACTIONS(4170),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4170),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_STAR_STAR] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_SLASH_SLASH] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_GT_GT2] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4172),
    [anon_sym_DASH] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(4172),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_SLASH] = ACTIONS(4172),
    [anon_sym_x] = ACTIONS(4172),
    [anon_sym_EQ_TILDE] = ACTIONS(4170),
    [anon_sym_BANG_TILDE] = ACTIONS(4170),
    [anon_sym_EQ_EQ] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_eq] = ACTIONS(4170),
    [anon_sym_ne] = ACTIONS(4170),
    [anon_sym_LT_EQ_GT] = ACTIONS(4170),
    [anon_sym_cmp] = ACTIONS(4170),
    [anon_sym_TILDE_TILDE] = ACTIONS(4170),
    [anon_sym_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_EQ] = ACTIONS(4170),
    [anon_sym_lt] = ACTIONS(4170),
    [anon_sym_le] = ACTIONS(4170),
    [anon_sym_ge] = ACTIONS(4170),
    [anon_sym_gt] = ACTIONS(4170),
    [anon_sym_isa] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4170),
    [anon_sym_DASH_DASH] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(4170),
    [anon_sym_for] = ACTIONS(4172),
    [anon_sym_foreach] = ACTIONS(4170),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4170),
    [anon_sym___END__] = ACTIONS(4170),
    [anon_sym_EOT] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_unless] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_until] = ACTIONS(4170),
    [sym__PERLY_SEMICOLON] = ACTIONS(4170),
    [sym__ctrl_z_hack] = ACTIONS(4170),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1342] = {
    [sym_heredoc_content] = STATE(1342),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4174),
    [anon_sym_and] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_DASH_GT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4176),
    [anon_sym_GT] = ACTIONS(4176),
    [anon_sym_LT_LT] = ACTIONS(4176),
    [anon_sym_EQ] = ACTIONS(4176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4174),
    [anon_sym_PLUS_EQ] = ACTIONS(4174),
    [anon_sym_DASH_EQ] = ACTIONS(4174),
    [anon_sym_DOT_EQ] = ACTIONS(4174),
    [anon_sym_STAR_EQ] = ACTIONS(4174),
    [anon_sym_SLASH_EQ] = ACTIONS(4174),
    [anon_sym_PERCENT_EQ] = ACTIONS(4174),
    [anon_sym_x_EQ] = ACTIONS(4174),
    [anon_sym_AMP_EQ] = ACTIONS(4174),
    [anon_sym_PIPE_EQ] = ACTIONS(4174),
    [anon_sym_CARET_EQ] = ACTIONS(4174),
    [anon_sym_LT_LT_EQ] = ACTIONS(4174),
    [anon_sym_GT_GT_EQ] = ACTIONS(4174),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4174),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4174),
    [anon_sym_DOT_DOT] = ACTIONS(4176),
    [anon_sym_STAR_STAR] = ACTIONS(4176),
    [anon_sym_PIPE_PIPE] = ACTIONS(4176),
    [anon_sym_SLASH_SLASH] = ACTIONS(4176),
    [anon_sym_AMP_AMP] = ACTIONS(4176),
    [anon_sym_PIPE] = ACTIONS(4176),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_GT_GT2] = ACTIONS(4176),
    [anon_sym_PLUS] = ACTIONS(4176),
    [anon_sym_DASH] = ACTIONS(4176),
    [anon_sym_DOT] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(4176),
    [anon_sym_SLASH] = ACTIONS(4176),
    [anon_sym_x] = ACTIONS(4176),
    [anon_sym_EQ_TILDE] = ACTIONS(4174),
    [anon_sym_BANG_TILDE] = ACTIONS(4174),
    [anon_sym_EQ_EQ] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_eq] = ACTIONS(4174),
    [anon_sym_ne] = ACTIONS(4174),
    [anon_sym_LT_EQ_GT] = ACTIONS(4174),
    [anon_sym_cmp] = ACTIONS(4174),
    [anon_sym_TILDE_TILDE] = ACTIONS(4174),
    [anon_sym_LT_EQ] = ACTIONS(4176),
    [anon_sym_GT_EQ] = ACTIONS(4174),
    [anon_sym_lt] = ACTIONS(4174),
    [anon_sym_le] = ACTIONS(4174),
    [anon_sym_ge] = ACTIONS(4174),
    [anon_sym_gt] = ACTIONS(4174),
    [anon_sym_isa] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4174),
    [anon_sym_DASH_DASH] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_EQ_GT] = ACTIONS(4174),
    [anon_sym_for] = ACTIONS(4176),
    [anon_sym_foreach] = ACTIONS(4174),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4174),
    [anon_sym___END__] = ACTIONS(4174),
    [anon_sym_EOT] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_unless] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_until] = ACTIONS(4174),
    [sym__PERLY_SEMICOLON] = ACTIONS(4174),
    [sym__ctrl_z_hack] = ACTIONS(4174),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1343] = {
    [sym_heredoc_content] = STATE(1343),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_or] = ACTIONS(4178),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4178),
    [anon_sym_PLUS_EQ] = ACTIONS(4178),
    [anon_sym_DASH_EQ] = ACTIONS(4178),
    [anon_sym_DOT_EQ] = ACTIONS(4178),
    [anon_sym_STAR_EQ] = ACTIONS(4178),
    [anon_sym_SLASH_EQ] = ACTIONS(4178),
    [anon_sym_PERCENT_EQ] = ACTIONS(4178),
    [anon_sym_x_EQ] = ACTIONS(4178),
    [anon_sym_AMP_EQ] = ACTIONS(4178),
    [anon_sym_PIPE_EQ] = ACTIONS(4178),
    [anon_sym_CARET_EQ] = ACTIONS(4178),
    [anon_sym_LT_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT_GT_EQ] = ACTIONS(4178),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4178),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4178),
    [anon_sym_DOT_DOT] = ACTIONS(4180),
    [anon_sym_STAR_STAR] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_SLASH_SLASH] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_GT_GT2] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_x] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4178),
    [anon_sym_BANG_TILDE] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_eq] = ACTIONS(4178),
    [anon_sym_ne] = ACTIONS(4178),
    [anon_sym_LT_EQ_GT] = ACTIONS(4178),
    [anon_sym_cmp] = ACTIONS(4178),
    [anon_sym_TILDE_TILDE] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4180),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_lt] = ACTIONS(4178),
    [anon_sym_le] = ACTIONS(4178),
    [anon_sym_ge] = ACTIONS(4178),
    [anon_sym_gt] = ACTIONS(4178),
    [anon_sym_isa] = ACTIONS(4178),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4178),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_foreach] = ACTIONS(4178),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4178),
    [anon_sym___END__] = ACTIONS(4178),
    [anon_sym_EOT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(4178),
    [anon_sym_unless] = ACTIONS(4178),
    [anon_sym_while] = ACTIONS(4178),
    [anon_sym_until] = ACTIONS(4178),
    [sym__PERLY_SEMICOLON] = ACTIONS(4178),
    [sym__ctrl_z_hack] = ACTIONS(4178),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1344] = {
    [sym_heredoc_content] = STATE(1344),
    [anon_sym_SEMI] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4182),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_DASH_GT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_GT] = ACTIONS(4184),
    [anon_sym_LT_LT] = ACTIONS(4184),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_DOT_EQ] = ACTIONS(4182),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_x_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_DOT_DOT] = ACTIONS(4184),
    [anon_sym_STAR_STAR] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(4184),
    [anon_sym_SLASH_SLASH] = ACTIONS(4184),
    [anon_sym_AMP_AMP] = ACTIONS(4184),
    [anon_sym_PIPE] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_GT_GT2] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4184),
    [anon_sym_x] = ACTIONS(4184),
    [anon_sym_EQ_TILDE] = ACTIONS(4182),
    [anon_sym_BANG_TILDE] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_eq] = ACTIONS(4182),
    [anon_sym_ne] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4182),
    [anon_sym_cmp] = ACTIONS(4182),
    [anon_sym_TILDE_TILDE] = ACTIONS(4182),
    [anon_sym_LT_EQ] = ACTIONS(4184),
    [anon_sym_GT_EQ] = ACTIONS(4182),
    [anon_sym_lt] = ACTIONS(4182),
    [anon_sym_le] = ACTIONS(4182),
    [anon_sym_ge] = ACTIONS(4182),
    [anon_sym_gt] = ACTIONS(4182),
    [anon_sym_isa] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_EQ_GT] = ACTIONS(4182),
    [anon_sym_for] = ACTIONS(4184),
    [anon_sym_foreach] = ACTIONS(4182),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4182),
    [anon_sym___END__] = ACTIONS(4182),
    [anon_sym_EOT] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_unless] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_until] = ACTIONS(4182),
    [sym__PERLY_SEMICOLON] = ACTIONS(4182),
    [sym__ctrl_z_hack] = ACTIONS(4182),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1345] = {
    [sym_heredoc_content] = STATE(1345),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(4188),
    [anon_sym_GT] = ACTIONS(4188),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4186),
    [anon_sym_PLUS_EQ] = ACTIONS(4186),
    [anon_sym_DASH_EQ] = ACTIONS(4186),
    [anon_sym_DOT_EQ] = ACTIONS(4186),
    [anon_sym_STAR_EQ] = ACTIONS(4186),
    [anon_sym_SLASH_EQ] = ACTIONS(4186),
    [anon_sym_PERCENT_EQ] = ACTIONS(4186),
    [anon_sym_x_EQ] = ACTIONS(4186),
    [anon_sym_AMP_EQ] = ACTIONS(4186),
    [anon_sym_PIPE_EQ] = ACTIONS(4186),
    [anon_sym_CARET_EQ] = ACTIONS(4186),
    [anon_sym_LT_LT_EQ] = ACTIONS(4186),
    [anon_sym_GT_GT_EQ] = ACTIONS(4186),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4186),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4188),
    [anon_sym_STAR_STAR] = ACTIONS(4188),
    [anon_sym_PIPE_PIPE] = ACTIONS(4188),
    [anon_sym_SLASH_SLASH] = ACTIONS(4188),
    [anon_sym_AMP_AMP] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(4188),
    [anon_sym_AMP] = ACTIONS(4188),
    [anon_sym_GT_GT2] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_DOT] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_SLASH] = ACTIONS(4188),
    [anon_sym_x] = ACTIONS(4188),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_eq] = ACTIONS(4186),
    [anon_sym_ne] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_cmp] = ACTIONS(4186),
    [anon_sym_TILDE_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4188),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_lt] = ACTIONS(4186),
    [anon_sym_le] = ACTIONS(4186),
    [anon_sym_ge] = ACTIONS(4186),
    [anon_sym_gt] = ACTIONS(4186),
    [anon_sym_isa] = ACTIONS(4186),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_EQ_GT] = ACTIONS(4186),
    [anon_sym_for] = ACTIONS(4188),
    [anon_sym_foreach] = ACTIONS(4186),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4186),
    [anon_sym___END__] = ACTIONS(4186),
    [anon_sym_EOT] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_unless] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_until] = ACTIONS(4186),
    [sym__PERLY_SEMICOLON] = ACTIONS(4186),
    [sym__ctrl_z_hack] = ACTIONS(4186),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1346] = {
    [sym_heredoc_content] = STATE(1346),
    [anon_sym_SEMI] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(4190),
    [anon_sym_or] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_EQ] = ACTIONS(4192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4190),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_DOT_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_x_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_DOT_DOT] = ACTIONS(4192),
    [anon_sym_STAR_STAR] = ACTIONS(4192),
    [anon_sym_PIPE_PIPE] = ACTIONS(4192),
    [anon_sym_SLASH_SLASH] = ACTIONS(4192),
    [anon_sym_AMP_AMP] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_GT_GT2] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_x] = ACTIONS(4192),
    [anon_sym_EQ_TILDE] = ACTIONS(4190),
    [anon_sym_BANG_TILDE] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4190),
    [anon_sym_eq] = ACTIONS(4190),
    [anon_sym_ne] = ACTIONS(4190),
    [anon_sym_LT_EQ_GT] = ACTIONS(4190),
    [anon_sym_cmp] = ACTIONS(4190),
    [anon_sym_TILDE_TILDE] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4192),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_lt] = ACTIONS(4190),
    [anon_sym_le] = ACTIONS(4190),
    [anon_sym_ge] = ACTIONS(4190),
    [anon_sym_gt] = ACTIONS(4190),
    [anon_sym_isa] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_EQ_GT] = ACTIONS(4190),
    [anon_sym_for] = ACTIONS(4192),
    [anon_sym_foreach] = ACTIONS(4190),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4190),
    [anon_sym___END__] = ACTIONS(4190),
    [anon_sym_EOT] = ACTIONS(4190),
    [anon_sym_if] = ACTIONS(4190),
    [anon_sym_unless] = ACTIONS(4190),
    [anon_sym_while] = ACTIONS(4190),
    [anon_sym_until] = ACTIONS(4190),
    [sym__PERLY_SEMICOLON] = ACTIONS(4190),
    [sym__ctrl_z_hack] = ACTIONS(4190),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1347] = {
    [sym_heredoc_content] = STATE(1347),
    [anon_sym_SEMI] = ACTIONS(4194),
    [anon_sym_COMMA] = ACTIONS(4194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4194),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_DASH_GT] = ACTIONS(4194),
    [anon_sym_PERCENT] = ACTIONS(4196),
    [anon_sym_LT] = ACTIONS(4196),
    [anon_sym_GT] = ACTIONS(4196),
    [anon_sym_LT_LT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(4196),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4194),
    [anon_sym_DASH_EQ] = ACTIONS(4194),
    [anon_sym_DOT_EQ] = ACTIONS(4194),
    [anon_sym_STAR_EQ] = ACTIONS(4194),
    [anon_sym_SLASH_EQ] = ACTIONS(4194),
    [anon_sym_PERCENT_EQ] = ACTIONS(4194),
    [anon_sym_x_EQ] = ACTIONS(4194),
    [anon_sym_AMP_EQ] = ACTIONS(4194),
    [anon_sym_PIPE_EQ] = ACTIONS(4194),
    [anon_sym_CARET_EQ] = ACTIONS(4194),
    [anon_sym_LT_LT_EQ] = ACTIONS(4194),
    [anon_sym_GT_GT_EQ] = ACTIONS(4194),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4194),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4194),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4194),
    [anon_sym_DOT_DOT] = ACTIONS(4196),
    [anon_sym_STAR_STAR] = ACTIONS(4196),
    [anon_sym_PIPE_PIPE] = ACTIONS(4196),
    [anon_sym_SLASH_SLASH] = ACTIONS(4196),
    [anon_sym_AMP_AMP] = ACTIONS(4196),
    [anon_sym_PIPE] = ACTIONS(4196),
    [anon_sym_AMP] = ACTIONS(4196),
    [anon_sym_GT_GT2] = ACTIONS(4196),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_STAR] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4196),
    [anon_sym_x] = ACTIONS(4196),
    [anon_sym_EQ_TILDE] = ACTIONS(4194),
    [anon_sym_BANG_TILDE] = ACTIONS(4194),
    [anon_sym_EQ_EQ] = ACTIONS(4194),
    [anon_sym_BANG_EQ] = ACTIONS(4194),
    [anon_sym_eq] = ACTIONS(4194),
    [anon_sym_ne] = ACTIONS(4194),
    [anon_sym_LT_EQ_GT] = ACTIONS(4194),
    [anon_sym_cmp] = ACTIONS(4194),
    [anon_sym_TILDE_TILDE] = ACTIONS(4194),
    [anon_sym_LT_EQ] = ACTIONS(4196),
    [anon_sym_GT_EQ] = ACTIONS(4194),
    [anon_sym_lt] = ACTIONS(4194),
    [anon_sym_le] = ACTIONS(4194),
    [anon_sym_ge] = ACTIONS(4194),
    [anon_sym_gt] = ACTIONS(4194),
    [anon_sym_isa] = ACTIONS(4194),
    [anon_sym_PLUS_PLUS] = ACTIONS(4194),
    [anon_sym_DASH_DASH] = ACTIONS(4194),
    [anon_sym_QMARK] = ACTIONS(4194),
    [anon_sym_EQ_GT] = ACTIONS(4194),
    [anon_sym_for] = ACTIONS(4196),
    [anon_sym_foreach] = ACTIONS(4194),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4194),
    [anon_sym___END__] = ACTIONS(4194),
    [anon_sym_EOT] = ACTIONS(4194),
    [anon_sym_if] = ACTIONS(4194),
    [anon_sym_unless] = ACTIONS(4194),
    [anon_sym_while] = ACTIONS(4194),
    [anon_sym_until] = ACTIONS(4194),
    [sym__PERLY_SEMICOLON] = ACTIONS(4194),
    [sym__ctrl_z_hack] = ACTIONS(4194),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1348] = {
    [sym_heredoc_content] = STATE(1348),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym_COMMA] = ACTIONS(4198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4198),
    [anon_sym_and] = ACTIONS(4198),
    [anon_sym_or] = ACTIONS(4198),
    [anon_sym_DASH_GT] = ACTIONS(4198),
    [anon_sym_PERCENT] = ACTIONS(4200),
    [anon_sym_LT] = ACTIONS(4200),
    [anon_sym_GT] = ACTIONS(4200),
    [anon_sym_LT_LT] = ACTIONS(4200),
    [anon_sym_EQ] = ACTIONS(4200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4198),
    [anon_sym_PLUS_EQ] = ACTIONS(4198),
    [anon_sym_DASH_EQ] = ACTIONS(4198),
    [anon_sym_DOT_EQ] = ACTIONS(4198),
    [anon_sym_STAR_EQ] = ACTIONS(4198),
    [anon_sym_SLASH_EQ] = ACTIONS(4198),
    [anon_sym_PERCENT_EQ] = ACTIONS(4198),
    [anon_sym_x_EQ] = ACTIONS(4198),
    [anon_sym_AMP_EQ] = ACTIONS(4198),
    [anon_sym_PIPE_EQ] = ACTIONS(4198),
    [anon_sym_CARET_EQ] = ACTIONS(4198),
    [anon_sym_LT_LT_EQ] = ACTIONS(4198),
    [anon_sym_GT_GT_EQ] = ACTIONS(4198),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4198),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4198),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4198),
    [anon_sym_DOT_DOT] = ACTIONS(4200),
    [anon_sym_STAR_STAR] = ACTIONS(4200),
    [anon_sym_PIPE_PIPE] = ACTIONS(4200),
    [anon_sym_SLASH_SLASH] = ACTIONS(4200),
    [anon_sym_AMP_AMP] = ACTIONS(4200),
    [anon_sym_PIPE] = ACTIONS(4200),
    [anon_sym_AMP] = ACTIONS(4200),
    [anon_sym_GT_GT2] = ACTIONS(4200),
    [anon_sym_PLUS] = ACTIONS(4200),
    [anon_sym_DASH] = ACTIONS(4200),
    [anon_sym_DOT] = ACTIONS(4200),
    [anon_sym_STAR] = ACTIONS(4200),
    [anon_sym_SLASH] = ACTIONS(4200),
    [anon_sym_x] = ACTIONS(4200),
    [anon_sym_EQ_TILDE] = ACTIONS(4198),
    [anon_sym_BANG_TILDE] = ACTIONS(4198),
    [anon_sym_EQ_EQ] = ACTIONS(4198),
    [anon_sym_BANG_EQ] = ACTIONS(4198),
    [anon_sym_eq] = ACTIONS(4198),
    [anon_sym_ne] = ACTIONS(4198),
    [anon_sym_LT_EQ_GT] = ACTIONS(4198),
    [anon_sym_cmp] = ACTIONS(4198),
    [anon_sym_TILDE_TILDE] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(4200),
    [anon_sym_GT_EQ] = ACTIONS(4198),
    [anon_sym_lt] = ACTIONS(4198),
    [anon_sym_le] = ACTIONS(4198),
    [anon_sym_ge] = ACTIONS(4198),
    [anon_sym_gt] = ACTIONS(4198),
    [anon_sym_isa] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_QMARK] = ACTIONS(4198),
    [anon_sym_EQ_GT] = ACTIONS(4198),
    [anon_sym_for] = ACTIONS(4200),
    [anon_sym_foreach] = ACTIONS(4198),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4198),
    [anon_sym___END__] = ACTIONS(4198),
    [anon_sym_EOT] = ACTIONS(4198),
    [anon_sym_if] = ACTIONS(4198),
    [anon_sym_unless] = ACTIONS(4198),
    [anon_sym_while] = ACTIONS(4198),
    [anon_sym_until] = ACTIONS(4198),
    [sym__PERLY_SEMICOLON] = ACTIONS(4198),
    [sym__ctrl_z_hack] = ACTIONS(4198),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1349] = {
    [sym_heredoc_content] = STATE(1349),
    [anon_sym_SEMI] = ACTIONS(4202),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4202),
    [anon_sym_and] = ACTIONS(4202),
    [anon_sym_or] = ACTIONS(4202),
    [anon_sym_DASH_GT] = ACTIONS(4202),
    [anon_sym_PERCENT] = ACTIONS(4204),
    [anon_sym_LT] = ACTIONS(4204),
    [anon_sym_GT] = ACTIONS(4204),
    [anon_sym_LT_LT] = ACTIONS(4204),
    [anon_sym_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4202),
    [anon_sym_PLUS_EQ] = ACTIONS(4202),
    [anon_sym_DASH_EQ] = ACTIONS(4202),
    [anon_sym_DOT_EQ] = ACTIONS(4202),
    [anon_sym_STAR_EQ] = ACTIONS(4202),
    [anon_sym_SLASH_EQ] = ACTIONS(4202),
    [anon_sym_PERCENT_EQ] = ACTIONS(4202),
    [anon_sym_x_EQ] = ACTIONS(4202),
    [anon_sym_AMP_EQ] = ACTIONS(4202),
    [anon_sym_PIPE_EQ] = ACTIONS(4202),
    [anon_sym_CARET_EQ] = ACTIONS(4202),
    [anon_sym_LT_LT_EQ] = ACTIONS(4202),
    [anon_sym_GT_GT_EQ] = ACTIONS(4202),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4202),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4202),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4202),
    [anon_sym_DOT_DOT] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4204),
    [anon_sym_SLASH_SLASH] = ACTIONS(4204),
    [anon_sym_AMP_AMP] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4204),
    [anon_sym_AMP] = ACTIONS(4204),
    [anon_sym_GT_GT2] = ACTIONS(4204),
    [anon_sym_PLUS] = ACTIONS(4204),
    [anon_sym_DASH] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4204),
    [anon_sym_STAR] = ACTIONS(4204),
    [anon_sym_SLASH] = ACTIONS(4204),
    [anon_sym_x] = ACTIONS(4204),
    [anon_sym_EQ_TILDE] = ACTIONS(4202),
    [anon_sym_BANG_TILDE] = ACTIONS(4202),
    [anon_sym_EQ_EQ] = ACTIONS(4202),
    [anon_sym_BANG_EQ] = ACTIONS(4202),
    [anon_sym_eq] = ACTIONS(4202),
    [anon_sym_ne] = ACTIONS(4202),
    [anon_sym_LT_EQ_GT] = ACTIONS(4202),
    [anon_sym_cmp] = ACTIONS(4202),
    [anon_sym_TILDE_TILDE] = ACTIONS(4202),
    [anon_sym_LT_EQ] = ACTIONS(4204),
    [anon_sym_GT_EQ] = ACTIONS(4202),
    [anon_sym_lt] = ACTIONS(4202),
    [anon_sym_le] = ACTIONS(4202),
    [anon_sym_ge] = ACTIONS(4202),
    [anon_sym_gt] = ACTIONS(4202),
    [anon_sym_isa] = ACTIONS(4202),
    [anon_sym_PLUS_PLUS] = ACTIONS(4202),
    [anon_sym_DASH_DASH] = ACTIONS(4202),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_EQ_GT] = ACTIONS(4202),
    [anon_sym_for] = ACTIONS(4204),
    [anon_sym_foreach] = ACTIONS(4202),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4202),
    [anon_sym___END__] = ACTIONS(4202),
    [anon_sym_EOT] = ACTIONS(4202),
    [anon_sym_if] = ACTIONS(4202),
    [anon_sym_unless] = ACTIONS(4202),
    [anon_sym_while] = ACTIONS(4202),
    [anon_sym_until] = ACTIONS(4202),
    [sym__PERLY_SEMICOLON] = ACTIONS(4202),
    [sym__ctrl_z_hack] = ACTIONS(4202),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1350] = {
    [sym_heredoc_content] = STATE(1350),
    [anon_sym_SEMI] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4206),
    [anon_sym_and] = ACTIONS(4206),
    [anon_sym_or] = ACTIONS(4206),
    [anon_sym_DASH_GT] = ACTIONS(4206),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(4208),
    [anon_sym_GT] = ACTIONS(4208),
    [anon_sym_LT_LT] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4206),
    [anon_sym_PLUS_EQ] = ACTIONS(4206),
    [anon_sym_DASH_EQ] = ACTIONS(4206),
    [anon_sym_DOT_EQ] = ACTIONS(4206),
    [anon_sym_STAR_EQ] = ACTIONS(4206),
    [anon_sym_SLASH_EQ] = ACTIONS(4206),
    [anon_sym_PERCENT_EQ] = ACTIONS(4206),
    [anon_sym_x_EQ] = ACTIONS(4206),
    [anon_sym_AMP_EQ] = ACTIONS(4206),
    [anon_sym_PIPE_EQ] = ACTIONS(4206),
    [anon_sym_CARET_EQ] = ACTIONS(4206),
    [anon_sym_LT_LT_EQ] = ACTIONS(4206),
    [anon_sym_GT_GT_EQ] = ACTIONS(4206),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4206),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4206),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4206),
    [anon_sym_DOT_DOT] = ACTIONS(4208),
    [anon_sym_STAR_STAR] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_SLASH_SLASH] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_PIPE] = ACTIONS(4208),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_GT_GT2] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_STAR] = ACTIONS(4208),
    [anon_sym_SLASH] = ACTIONS(4208),
    [anon_sym_x] = ACTIONS(4208),
    [anon_sym_EQ_TILDE] = ACTIONS(4206),
    [anon_sym_BANG_TILDE] = ACTIONS(4206),
    [anon_sym_EQ_EQ] = ACTIONS(4206),
    [anon_sym_BANG_EQ] = ACTIONS(4206),
    [anon_sym_eq] = ACTIONS(4206),
    [anon_sym_ne] = ACTIONS(4206),
    [anon_sym_LT_EQ_GT] = ACTIONS(4206),
    [anon_sym_cmp] = ACTIONS(4206),
    [anon_sym_TILDE_TILDE] = ACTIONS(4206),
    [anon_sym_LT_EQ] = ACTIONS(4208),
    [anon_sym_GT_EQ] = ACTIONS(4206),
    [anon_sym_lt] = ACTIONS(4206),
    [anon_sym_le] = ACTIONS(4206),
    [anon_sym_ge] = ACTIONS(4206),
    [anon_sym_gt] = ACTIONS(4206),
    [anon_sym_isa] = ACTIONS(4206),
    [anon_sym_PLUS_PLUS] = ACTIONS(4206),
    [anon_sym_DASH_DASH] = ACTIONS(4206),
    [anon_sym_QMARK] = ACTIONS(4206),
    [anon_sym_EQ_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_foreach] = ACTIONS(4206),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4206),
    [anon_sym___END__] = ACTIONS(4206),
    [anon_sym_EOT] = ACTIONS(4206),
    [anon_sym_if] = ACTIONS(4206),
    [anon_sym_unless] = ACTIONS(4206),
    [anon_sym_while] = ACTIONS(4206),
    [anon_sym_until] = ACTIONS(4206),
    [sym__PERLY_SEMICOLON] = ACTIONS(4206),
    [sym__ctrl_z_hack] = ACTIONS(4206),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1351] = {
    [sym_heredoc_content] = STATE(1351),
    [anon_sym_SEMI] = ACTIONS(4210),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4210),
    [anon_sym_and] = ACTIONS(4210),
    [anon_sym_or] = ACTIONS(4210),
    [anon_sym_DASH_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_LT] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(4212),
    [anon_sym_LT_LT] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4210),
    [anon_sym_PLUS_EQ] = ACTIONS(4210),
    [anon_sym_DASH_EQ] = ACTIONS(4210),
    [anon_sym_DOT_EQ] = ACTIONS(4210),
    [anon_sym_STAR_EQ] = ACTIONS(4210),
    [anon_sym_SLASH_EQ] = ACTIONS(4210),
    [anon_sym_PERCENT_EQ] = ACTIONS(4210),
    [anon_sym_x_EQ] = ACTIONS(4210),
    [anon_sym_AMP_EQ] = ACTIONS(4210),
    [anon_sym_PIPE_EQ] = ACTIONS(4210),
    [anon_sym_CARET_EQ] = ACTIONS(4210),
    [anon_sym_LT_LT_EQ] = ACTIONS(4210),
    [anon_sym_GT_GT_EQ] = ACTIONS(4210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4210),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4210),
    [anon_sym_DOT_DOT] = ACTIONS(4212),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_SLASH_SLASH] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4212),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_GT_GT2] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_STAR] = ACTIONS(4212),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_x] = ACTIONS(4212),
    [anon_sym_EQ_TILDE] = ACTIONS(4210),
    [anon_sym_BANG_TILDE] = ACTIONS(4210),
    [anon_sym_EQ_EQ] = ACTIONS(4210),
    [anon_sym_BANG_EQ] = ACTIONS(4210),
    [anon_sym_eq] = ACTIONS(4210),
    [anon_sym_ne] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4210),
    [anon_sym_cmp] = ACTIONS(4210),
    [anon_sym_TILDE_TILDE] = ACTIONS(4210),
    [anon_sym_LT_EQ] = ACTIONS(4212),
    [anon_sym_GT_EQ] = ACTIONS(4210),
    [anon_sym_lt] = ACTIONS(4210),
    [anon_sym_le] = ACTIONS(4210),
    [anon_sym_ge] = ACTIONS(4210),
    [anon_sym_gt] = ACTIONS(4210),
    [anon_sym_isa] = ACTIONS(4210),
    [anon_sym_PLUS_PLUS] = ACTIONS(4210),
    [anon_sym_DASH_DASH] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4210),
    [anon_sym_EQ_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_foreach] = ACTIONS(4210),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4210),
    [anon_sym___END__] = ACTIONS(4210),
    [anon_sym_EOT] = ACTIONS(4210),
    [anon_sym_if] = ACTIONS(4210),
    [anon_sym_unless] = ACTIONS(4210),
    [anon_sym_while] = ACTIONS(4210),
    [anon_sym_until] = ACTIONS(4210),
    [sym__PERLY_SEMICOLON] = ACTIONS(4210),
    [sym__ctrl_z_hack] = ACTIONS(4210),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1352] = {
    [sym_heredoc_content] = STATE(1352),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(4216),
    [anon_sym_GT] = ACTIONS(4216),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(4216),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_DOT_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_x_EQ] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_DOT_DOT] = ACTIONS(4216),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_SLASH_SLASH] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_PIPE] = ACTIONS(4216),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4214),
    [anon_sym_eq] = ACTIONS(4214),
    [anon_sym_ne] = ACTIONS(4214),
    [anon_sym_LT_EQ_GT] = ACTIONS(4214),
    [anon_sym_cmp] = ACTIONS(4214),
    [anon_sym_TILDE_TILDE] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(4216),
    [anon_sym_GT_EQ] = ACTIONS(4214),
    [anon_sym_lt] = ACTIONS(4214),
    [anon_sym_le] = ACTIONS(4214),
    [anon_sym_ge] = ACTIONS(4214),
    [anon_sym_gt] = ACTIONS(4214),
    [anon_sym_isa] = ACTIONS(4214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_foreach] = ACTIONS(4214),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4214),
    [anon_sym___END__] = ACTIONS(4214),
    [anon_sym_EOT] = ACTIONS(4214),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [sym__PERLY_SEMICOLON] = ACTIONS(4214),
    [sym__ctrl_z_hack] = ACTIONS(4214),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1353] = {
    [sym_heredoc_content] = STATE(1353),
    [anon_sym_SEMI] = ACTIONS(4218),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(4218),
    [anon_sym_or] = ACTIONS(4218),
    [anon_sym_DASH_GT] = ACTIONS(4218),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_LT] = ACTIONS(4220),
    [anon_sym_GT] = ACTIONS(4220),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4220),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4218),
    [anon_sym_PLUS_EQ] = ACTIONS(4218),
    [anon_sym_DASH_EQ] = ACTIONS(4218),
    [anon_sym_DOT_EQ] = ACTIONS(4218),
    [anon_sym_STAR_EQ] = ACTIONS(4218),
    [anon_sym_SLASH_EQ] = ACTIONS(4218),
    [anon_sym_PERCENT_EQ] = ACTIONS(4218),
    [anon_sym_x_EQ] = ACTIONS(4218),
    [anon_sym_AMP_EQ] = ACTIONS(4218),
    [anon_sym_PIPE_EQ] = ACTIONS(4218),
    [anon_sym_CARET_EQ] = ACTIONS(4218),
    [anon_sym_LT_LT_EQ] = ACTIONS(4218),
    [anon_sym_GT_GT_EQ] = ACTIONS(4218),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4218),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4218),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4220),
    [anon_sym_STAR_STAR] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_SLASH_SLASH] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_PIPE] = ACTIONS(4220),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_GT_GT2] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_STAR] = ACTIONS(4220),
    [anon_sym_SLASH] = ACTIONS(4220),
    [anon_sym_x] = ACTIONS(4220),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_EQ_EQ] = ACTIONS(4218),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_eq] = ACTIONS(4218),
    [anon_sym_ne] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_cmp] = ACTIONS(4218),
    [anon_sym_TILDE_TILDE] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4220),
    [anon_sym_GT_EQ] = ACTIONS(4218),
    [anon_sym_lt] = ACTIONS(4218),
    [anon_sym_le] = ACTIONS(4218),
    [anon_sym_ge] = ACTIONS(4218),
    [anon_sym_gt] = ACTIONS(4218),
    [anon_sym_isa] = ACTIONS(4218),
    [anon_sym_PLUS_PLUS] = ACTIONS(4218),
    [anon_sym_DASH_DASH] = ACTIONS(4218),
    [anon_sym_QMARK] = ACTIONS(4218),
    [anon_sym_EQ_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_foreach] = ACTIONS(4218),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4218),
    [anon_sym___END__] = ACTIONS(4218),
    [anon_sym_EOT] = ACTIONS(4218),
    [anon_sym_if] = ACTIONS(4218),
    [anon_sym_unless] = ACTIONS(4218),
    [anon_sym_while] = ACTIONS(4218),
    [anon_sym_until] = ACTIONS(4218),
    [sym__PERLY_SEMICOLON] = ACTIONS(4218),
    [sym__ctrl_z_hack] = ACTIONS(4218),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1354] = {
    [sym_heredoc_content] = STATE(1354),
    [anon_sym_SEMI] = ACTIONS(4222),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_and] = ACTIONS(4222),
    [anon_sym_or] = ACTIONS(4222),
    [anon_sym_DASH_GT] = ACTIONS(4222),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_LT] = ACTIONS(4224),
    [anon_sym_GT] = ACTIONS(4224),
    [anon_sym_LT_LT] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4222),
    [anon_sym_PLUS_EQ] = ACTIONS(4222),
    [anon_sym_DASH_EQ] = ACTIONS(4222),
    [anon_sym_DOT_EQ] = ACTIONS(4222),
    [anon_sym_STAR_EQ] = ACTIONS(4222),
    [anon_sym_SLASH_EQ] = ACTIONS(4222),
    [anon_sym_PERCENT_EQ] = ACTIONS(4222),
    [anon_sym_x_EQ] = ACTIONS(4222),
    [anon_sym_AMP_EQ] = ACTIONS(4222),
    [anon_sym_PIPE_EQ] = ACTIONS(4222),
    [anon_sym_CARET_EQ] = ACTIONS(4222),
    [anon_sym_LT_LT_EQ] = ACTIONS(4222),
    [anon_sym_GT_GT_EQ] = ACTIONS(4222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4222),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4222),
    [anon_sym_DOT_DOT] = ACTIONS(4224),
    [anon_sym_STAR_STAR] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_SLASH_SLASH] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_PIPE] = ACTIONS(4224),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_GT_GT2] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_STAR] = ACTIONS(4224),
    [anon_sym_SLASH] = ACTIONS(4224),
    [anon_sym_x] = ACTIONS(4224),
    [anon_sym_EQ_TILDE] = ACTIONS(4222),
    [anon_sym_BANG_TILDE] = ACTIONS(4222),
    [anon_sym_EQ_EQ] = ACTIONS(4222),
    [anon_sym_BANG_EQ] = ACTIONS(4222),
    [anon_sym_eq] = ACTIONS(4222),
    [anon_sym_ne] = ACTIONS(4222),
    [anon_sym_LT_EQ_GT] = ACTIONS(4222),
    [anon_sym_cmp] = ACTIONS(4222),
    [anon_sym_TILDE_TILDE] = ACTIONS(4222),
    [anon_sym_LT_EQ] = ACTIONS(4224),
    [anon_sym_GT_EQ] = ACTIONS(4222),
    [anon_sym_lt] = ACTIONS(4222),
    [anon_sym_le] = ACTIONS(4222),
    [anon_sym_ge] = ACTIONS(4222),
    [anon_sym_gt] = ACTIONS(4222),
    [anon_sym_isa] = ACTIONS(4222),
    [anon_sym_PLUS_PLUS] = ACTIONS(4222),
    [anon_sym_DASH_DASH] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4222),
    [anon_sym_EQ_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_foreach] = ACTIONS(4222),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4222),
    [anon_sym___END__] = ACTIONS(4222),
    [anon_sym_EOT] = ACTIONS(4222),
    [anon_sym_if] = ACTIONS(4222),
    [anon_sym_unless] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4222),
    [anon_sym_until] = ACTIONS(4222),
    [sym__PERLY_SEMICOLON] = ACTIONS(4222),
    [sym__ctrl_z_hack] = ACTIONS(4222),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1355] = {
    [sym_heredoc_content] = STATE(1355),
    [anon_sym_SEMI] = ACTIONS(4226),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4226),
    [anon_sym_and] = ACTIONS(4226),
    [anon_sym_or] = ACTIONS(4226),
    [anon_sym_DASH_GT] = ACTIONS(4226),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_LT] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4228),
    [anon_sym_LT_LT] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4228),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4226),
    [anon_sym_PLUS_EQ] = ACTIONS(4226),
    [anon_sym_DASH_EQ] = ACTIONS(4226),
    [anon_sym_DOT_EQ] = ACTIONS(4226),
    [anon_sym_STAR_EQ] = ACTIONS(4226),
    [anon_sym_SLASH_EQ] = ACTIONS(4226),
    [anon_sym_PERCENT_EQ] = ACTIONS(4226),
    [anon_sym_x_EQ] = ACTIONS(4226),
    [anon_sym_AMP_EQ] = ACTIONS(4226),
    [anon_sym_PIPE_EQ] = ACTIONS(4226),
    [anon_sym_CARET_EQ] = ACTIONS(4226),
    [anon_sym_LT_LT_EQ] = ACTIONS(4226),
    [anon_sym_GT_GT_EQ] = ACTIONS(4226),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4226),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4226),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4226),
    [anon_sym_DOT_DOT] = ACTIONS(4228),
    [anon_sym_STAR_STAR] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_SLASH_SLASH] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_PIPE] = ACTIONS(4228),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT_GT2] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_STAR] = ACTIONS(4228),
    [anon_sym_SLASH] = ACTIONS(4228),
    [anon_sym_x] = ACTIONS(4228),
    [anon_sym_EQ_TILDE] = ACTIONS(4226),
    [anon_sym_BANG_TILDE] = ACTIONS(4226),
    [anon_sym_EQ_EQ] = ACTIONS(4226),
    [anon_sym_BANG_EQ] = ACTIONS(4226),
    [anon_sym_eq] = ACTIONS(4226),
    [anon_sym_ne] = ACTIONS(4226),
    [anon_sym_LT_EQ_GT] = ACTIONS(4226),
    [anon_sym_cmp] = ACTIONS(4226),
    [anon_sym_TILDE_TILDE] = ACTIONS(4226),
    [anon_sym_LT_EQ] = ACTIONS(4228),
    [anon_sym_GT_EQ] = ACTIONS(4226),
    [anon_sym_lt] = ACTIONS(4226),
    [anon_sym_le] = ACTIONS(4226),
    [anon_sym_ge] = ACTIONS(4226),
    [anon_sym_gt] = ACTIONS(4226),
    [anon_sym_isa] = ACTIONS(4226),
    [anon_sym_PLUS_PLUS] = ACTIONS(4226),
    [anon_sym_DASH_DASH] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4226),
    [anon_sym_EQ_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_foreach] = ACTIONS(4226),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4226),
    [anon_sym___END__] = ACTIONS(4226),
    [anon_sym_EOT] = ACTIONS(4226),
    [anon_sym_if] = ACTIONS(4226),
    [anon_sym_unless] = ACTIONS(4226),
    [anon_sym_while] = ACTIONS(4226),
    [anon_sym_until] = ACTIONS(4226),
    [sym__PERLY_SEMICOLON] = ACTIONS(4226),
    [sym__ctrl_z_hack] = ACTIONS(4226),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1356] = {
    [sym_heredoc_content] = STATE(1356),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3650),
    [anon_sym_and] = ACTIONS(4230),
    [anon_sym_or] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(3660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3662),
    [anon_sym_DASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_EQ] = ACTIONS(3662),
    [anon_sym_STAR_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_PERCENT_EQ] = ACTIONS(3662),
    [anon_sym_x_EQ] = ACTIONS(3662),
    [anon_sym_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_CARET_EQ] = ACTIONS(3662),
    [anon_sym_LT_LT_EQ] = ACTIONS(3662),
    [anon_sym_GT_GT_EQ] = ACTIONS(3662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_SLASH_SLASH] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_eq] = ACTIONS(3680),
    [anon_sym_ne] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3682),
    [anon_sym_cmp] = ACTIONS(3682),
    [anon_sym_TILDE_TILDE] = ACTIONS(3682),
    [anon_sym_LT_EQ] = ACTIONS(3656),
    [anon_sym_GT_EQ] = ACTIONS(3684),
    [anon_sym_lt] = ACTIONS(3684),
    [anon_sym_le] = ACTIONS(3684),
    [anon_sym_ge] = ACTIONS(3684),
    [anon_sym_gt] = ACTIONS(3684),
    [anon_sym_isa] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3690),
    [anon_sym_EQ_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_foreach] = ACTIONS(4230),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4230),
    [anon_sym___END__] = ACTIONS(4230),
    [anon_sym_EOT] = ACTIONS(4230),
    [anon_sym_if] = ACTIONS(4230),
    [anon_sym_unless] = ACTIONS(4230),
    [anon_sym_while] = ACTIONS(4230),
    [anon_sym_until] = ACTIONS(4230),
    [sym__PERLY_SEMICOLON] = ACTIONS(4230),
    [sym__ctrl_z_hack] = ACTIONS(4230),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1357] = {
    [sym_heredoc_content] = STATE(1357),
    [anon_sym_SEMI] = ACTIONS(4234),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4234),
    [anon_sym_and] = ACTIONS(4234),
    [anon_sym_or] = ACTIONS(4234),
    [anon_sym_DASH_GT] = ACTIONS(4234),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_LT] = ACTIONS(4236),
    [anon_sym_GT] = ACTIONS(4236),
    [anon_sym_LT_LT] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4234),
    [anon_sym_PLUS_EQ] = ACTIONS(4234),
    [anon_sym_DASH_EQ] = ACTIONS(4234),
    [anon_sym_DOT_EQ] = ACTIONS(4234),
    [anon_sym_STAR_EQ] = ACTIONS(4234),
    [anon_sym_SLASH_EQ] = ACTIONS(4234),
    [anon_sym_PERCENT_EQ] = ACTIONS(4234),
    [anon_sym_x_EQ] = ACTIONS(4234),
    [anon_sym_AMP_EQ] = ACTIONS(4234),
    [anon_sym_PIPE_EQ] = ACTIONS(4234),
    [anon_sym_CARET_EQ] = ACTIONS(4234),
    [anon_sym_LT_LT_EQ] = ACTIONS(4234),
    [anon_sym_GT_GT_EQ] = ACTIONS(4234),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4234),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4234),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4234),
    [anon_sym_DOT_DOT] = ACTIONS(4236),
    [anon_sym_STAR_STAR] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_SLASH_SLASH] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_GT_GT2] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_STAR] = ACTIONS(4236),
    [anon_sym_SLASH] = ACTIONS(4236),
    [anon_sym_x] = ACTIONS(4236),
    [anon_sym_EQ_TILDE] = ACTIONS(4234),
    [anon_sym_BANG_TILDE] = ACTIONS(4234),
    [anon_sym_EQ_EQ] = ACTIONS(4234),
    [anon_sym_BANG_EQ] = ACTIONS(4234),
    [anon_sym_eq] = ACTIONS(4234),
    [anon_sym_ne] = ACTIONS(4234),
    [anon_sym_LT_EQ_GT] = ACTIONS(4234),
    [anon_sym_cmp] = ACTIONS(4234),
    [anon_sym_TILDE_TILDE] = ACTIONS(4234),
    [anon_sym_LT_EQ] = ACTIONS(4236),
    [anon_sym_GT_EQ] = ACTIONS(4234),
    [anon_sym_lt] = ACTIONS(4234),
    [anon_sym_le] = ACTIONS(4234),
    [anon_sym_ge] = ACTIONS(4234),
    [anon_sym_gt] = ACTIONS(4234),
    [anon_sym_isa] = ACTIONS(4234),
    [anon_sym_PLUS_PLUS] = ACTIONS(4234),
    [anon_sym_DASH_DASH] = ACTIONS(4234),
    [anon_sym_QMARK] = ACTIONS(4234),
    [anon_sym_EQ_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_foreach] = ACTIONS(4234),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4234),
    [anon_sym___END__] = ACTIONS(4234),
    [anon_sym_EOT] = ACTIONS(4234),
    [anon_sym_if] = ACTIONS(4234),
    [anon_sym_unless] = ACTIONS(4234),
    [anon_sym_while] = ACTIONS(4234),
    [anon_sym_until] = ACTIONS(4234),
    [sym__PERLY_SEMICOLON] = ACTIONS(4234),
    [sym__ctrl_z_hack] = ACTIONS(4234),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1358] = {
    [sym_heredoc_content] = STATE(1358),
    [anon_sym_SEMI] = ACTIONS(4238),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4238),
    [anon_sym_and] = ACTIONS(4238),
    [anon_sym_or] = ACTIONS(4238),
    [anon_sym_DASH_GT] = ACTIONS(4238),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_LT] = ACTIONS(4240),
    [anon_sym_GT] = ACTIONS(4240),
    [anon_sym_LT_LT] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4238),
    [anon_sym_PLUS_EQ] = ACTIONS(4238),
    [anon_sym_DASH_EQ] = ACTIONS(4238),
    [anon_sym_DOT_EQ] = ACTIONS(4238),
    [anon_sym_STAR_EQ] = ACTIONS(4238),
    [anon_sym_SLASH_EQ] = ACTIONS(4238),
    [anon_sym_PERCENT_EQ] = ACTIONS(4238),
    [anon_sym_x_EQ] = ACTIONS(4238),
    [anon_sym_AMP_EQ] = ACTIONS(4238),
    [anon_sym_PIPE_EQ] = ACTIONS(4238),
    [anon_sym_CARET_EQ] = ACTIONS(4238),
    [anon_sym_LT_LT_EQ] = ACTIONS(4238),
    [anon_sym_GT_GT_EQ] = ACTIONS(4238),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4238),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4238),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4238),
    [anon_sym_DOT_DOT] = ACTIONS(4240),
    [anon_sym_STAR_STAR] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_SLASH_SLASH] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_GT_GT2] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_SLASH] = ACTIONS(4240),
    [anon_sym_x] = ACTIONS(4240),
    [anon_sym_EQ_TILDE] = ACTIONS(4238),
    [anon_sym_BANG_TILDE] = ACTIONS(4238),
    [anon_sym_EQ_EQ] = ACTIONS(4238),
    [anon_sym_BANG_EQ] = ACTIONS(4238),
    [anon_sym_eq] = ACTIONS(4238),
    [anon_sym_ne] = ACTIONS(4238),
    [anon_sym_LT_EQ_GT] = ACTIONS(4238),
    [anon_sym_cmp] = ACTIONS(4238),
    [anon_sym_TILDE_TILDE] = ACTIONS(4238),
    [anon_sym_LT_EQ] = ACTIONS(4240),
    [anon_sym_GT_EQ] = ACTIONS(4238),
    [anon_sym_lt] = ACTIONS(4238),
    [anon_sym_le] = ACTIONS(4238),
    [anon_sym_ge] = ACTIONS(4238),
    [anon_sym_gt] = ACTIONS(4238),
    [anon_sym_isa] = ACTIONS(4238),
    [anon_sym_PLUS_PLUS] = ACTIONS(4238),
    [anon_sym_DASH_DASH] = ACTIONS(4238),
    [anon_sym_QMARK] = ACTIONS(4238),
    [anon_sym_EQ_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_foreach] = ACTIONS(4238),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4238),
    [anon_sym___END__] = ACTIONS(4238),
    [anon_sym_EOT] = ACTIONS(4238),
    [anon_sym_if] = ACTIONS(4238),
    [anon_sym_unless] = ACTIONS(4238),
    [anon_sym_while] = ACTIONS(4238),
    [anon_sym_until] = ACTIONS(4238),
    [sym__PERLY_SEMICOLON] = ACTIONS(4238),
    [sym__ctrl_z_hack] = ACTIONS(4238),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1359] = {
    [sym_heredoc_content] = STATE(1359),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_DASH_GT] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_DOT_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_x_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_SLASH_SLASH] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_GT_GT2] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_x] = ACTIONS(4244),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4242),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_eq] = ACTIONS(4242),
    [anon_sym_ne] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_cmp] = ACTIONS(4242),
    [anon_sym_TILDE_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_lt] = ACTIONS(4242),
    [anon_sym_le] = ACTIONS(4242),
    [anon_sym_ge] = ACTIONS(4242),
    [anon_sym_gt] = ACTIONS(4242),
    [anon_sym_isa] = ACTIONS(4242),
    [anon_sym_PLUS_PLUS] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_foreach] = ACTIONS(4242),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4242),
    [anon_sym___END__] = ACTIONS(4242),
    [anon_sym_EOT] = ACTIONS(4242),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_unless] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_until] = ACTIONS(4242),
    [sym__PERLY_SEMICOLON] = ACTIONS(4242),
    [sym__ctrl_z_hack] = ACTIONS(4242),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1360] = {
    [sym_heredoc_content] = STATE(1360),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(3658),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_DOT_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_x_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_SLASH_SLASH] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_GT_GT2] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(3654),
    [anon_sym_x] = ACTIONS(3654),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(4246),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_eq] = ACTIONS(4246),
    [anon_sym_ne] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_cmp] = ACTIONS(4246),
    [anon_sym_TILDE_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_lt] = ACTIONS(4246),
    [anon_sym_le] = ACTIONS(4246),
    [anon_sym_ge] = ACTIONS(4246),
    [anon_sym_gt] = ACTIONS(4246),
    [anon_sym_isa] = ACTIONS(4246),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_foreach] = ACTIONS(4246),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_EOT] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [sym__PERLY_SEMICOLON] = ACTIONS(4246),
    [sym__ctrl_z_hack] = ACTIONS(4246),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1361] = {
    [sym_heredoc_content] = STATE(1361),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym_COMMA] = ACTIONS(4250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4250),
    [anon_sym_and] = ACTIONS(4250),
    [anon_sym_or] = ACTIONS(4250),
    [anon_sym_DASH_GT] = ACTIONS(4250),
    [anon_sym_PERCENT] = ACTIONS(4252),
    [anon_sym_LT] = ACTIONS(4252),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_LT_LT] = ACTIONS(4252),
    [anon_sym_EQ] = ACTIONS(4252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4250),
    [anon_sym_PLUS_EQ] = ACTIONS(4250),
    [anon_sym_DASH_EQ] = ACTIONS(4250),
    [anon_sym_DOT_EQ] = ACTIONS(4250),
    [anon_sym_STAR_EQ] = ACTIONS(4250),
    [anon_sym_SLASH_EQ] = ACTIONS(4250),
    [anon_sym_PERCENT_EQ] = ACTIONS(4250),
    [anon_sym_x_EQ] = ACTIONS(4250),
    [anon_sym_AMP_EQ] = ACTIONS(4250),
    [anon_sym_PIPE_EQ] = ACTIONS(4250),
    [anon_sym_CARET_EQ] = ACTIONS(4250),
    [anon_sym_LT_LT_EQ] = ACTIONS(4250),
    [anon_sym_GT_GT_EQ] = ACTIONS(4250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4250),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4250),
    [anon_sym_DOT_DOT] = ACTIONS(4252),
    [anon_sym_STAR_STAR] = ACTIONS(4252),
    [anon_sym_PIPE_PIPE] = ACTIONS(4252),
    [anon_sym_SLASH_SLASH] = ACTIONS(4252),
    [anon_sym_AMP_AMP] = ACTIONS(4252),
    [anon_sym_PIPE] = ACTIONS(4252),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym_GT_GT2] = ACTIONS(4252),
    [anon_sym_PLUS] = ACTIONS(4252),
    [anon_sym_DASH] = ACTIONS(4252),
    [anon_sym_DOT] = ACTIONS(4252),
    [anon_sym_STAR] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4252),
    [anon_sym_x] = ACTIONS(4252),
    [anon_sym_EQ_TILDE] = ACTIONS(4250),
    [anon_sym_BANG_TILDE] = ACTIONS(4250),
    [anon_sym_EQ_EQ] = ACTIONS(4250),
    [anon_sym_BANG_EQ] = ACTIONS(4250),
    [anon_sym_eq] = ACTIONS(4250),
    [anon_sym_ne] = ACTIONS(4250),
    [anon_sym_LT_EQ_GT] = ACTIONS(4250),
    [anon_sym_cmp] = ACTIONS(4250),
    [anon_sym_TILDE_TILDE] = ACTIONS(4250),
    [anon_sym_LT_EQ] = ACTIONS(4252),
    [anon_sym_GT_EQ] = ACTIONS(4250),
    [anon_sym_lt] = ACTIONS(4250),
    [anon_sym_le] = ACTIONS(4250),
    [anon_sym_ge] = ACTIONS(4250),
    [anon_sym_gt] = ACTIONS(4250),
    [anon_sym_isa] = ACTIONS(4250),
    [anon_sym_PLUS_PLUS] = ACTIONS(4250),
    [anon_sym_DASH_DASH] = ACTIONS(4250),
    [anon_sym_QMARK] = ACTIONS(4250),
    [anon_sym_EQ_GT] = ACTIONS(4250),
    [anon_sym_for] = ACTIONS(4252),
    [anon_sym_foreach] = ACTIONS(4250),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4250),
    [anon_sym___END__] = ACTIONS(4250),
    [anon_sym_EOT] = ACTIONS(4250),
    [anon_sym_if] = ACTIONS(4250),
    [anon_sym_unless] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(4250),
    [anon_sym_until] = ACTIONS(4250),
    [sym__PERLY_SEMICOLON] = ACTIONS(4250),
    [sym__ctrl_z_hack] = ACTIONS(4250),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1362] = {
    [sym_heredoc_content] = STATE(1362),
    [anon_sym_SEMI] = ACTIONS(4254),
    [anon_sym_COMMA] = ACTIONS(4254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4254),
    [anon_sym_and] = ACTIONS(4254),
    [anon_sym_or] = ACTIONS(4254),
    [anon_sym_DASH_GT] = ACTIONS(4254),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4256),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4254),
    [anon_sym_PLUS_EQ] = ACTIONS(4254),
    [anon_sym_DASH_EQ] = ACTIONS(4254),
    [anon_sym_DOT_EQ] = ACTIONS(4254),
    [anon_sym_STAR_EQ] = ACTIONS(4254),
    [anon_sym_SLASH_EQ] = ACTIONS(4254),
    [anon_sym_PERCENT_EQ] = ACTIONS(4254),
    [anon_sym_x_EQ] = ACTIONS(4254),
    [anon_sym_AMP_EQ] = ACTIONS(4254),
    [anon_sym_PIPE_EQ] = ACTIONS(4254),
    [anon_sym_CARET_EQ] = ACTIONS(4254),
    [anon_sym_LT_LT_EQ] = ACTIONS(4254),
    [anon_sym_GT_GT_EQ] = ACTIONS(4254),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4254),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4254),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4254),
    [anon_sym_DOT_DOT] = ACTIONS(4256),
    [anon_sym_STAR_STAR] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4256),
    [anon_sym_SLASH_SLASH] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4256),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_GT_GT2] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_x] = ACTIONS(4256),
    [anon_sym_EQ_TILDE] = ACTIONS(4254),
    [anon_sym_BANG_TILDE] = ACTIONS(4254),
    [anon_sym_EQ_EQ] = ACTIONS(4254),
    [anon_sym_BANG_EQ] = ACTIONS(4254),
    [anon_sym_eq] = ACTIONS(4254),
    [anon_sym_ne] = ACTIONS(4254),
    [anon_sym_LT_EQ_GT] = ACTIONS(4254),
    [anon_sym_cmp] = ACTIONS(4254),
    [anon_sym_TILDE_TILDE] = ACTIONS(4254),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4254),
    [anon_sym_lt] = ACTIONS(4254),
    [anon_sym_le] = ACTIONS(4254),
    [anon_sym_ge] = ACTIONS(4254),
    [anon_sym_gt] = ACTIONS(4254),
    [anon_sym_isa] = ACTIONS(4254),
    [anon_sym_PLUS_PLUS] = ACTIONS(4254),
    [anon_sym_DASH_DASH] = ACTIONS(4254),
    [anon_sym_QMARK] = ACTIONS(4254),
    [anon_sym_EQ_GT] = ACTIONS(4254),
    [anon_sym_for] = ACTIONS(4256),
    [anon_sym_foreach] = ACTIONS(4254),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4254),
    [anon_sym___END__] = ACTIONS(4254),
    [anon_sym_EOT] = ACTIONS(4254),
    [anon_sym_if] = ACTIONS(4254),
    [anon_sym_unless] = ACTIONS(4254),
    [anon_sym_while] = ACTIONS(4254),
    [anon_sym_until] = ACTIONS(4254),
    [sym__PERLY_SEMICOLON] = ACTIONS(4254),
    [sym__ctrl_z_hack] = ACTIONS(4254),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1363] = {
    [sym_heredoc_content] = STATE(1363),
    [anon_sym_SEMI] = ACTIONS(4258),
    [anon_sym_COMMA] = ACTIONS(4258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4258),
    [anon_sym_and] = ACTIONS(4258),
    [anon_sym_or] = ACTIONS(4258),
    [anon_sym_DASH_GT] = ACTIONS(4258),
    [anon_sym_PERCENT] = ACTIONS(4260),
    [anon_sym_LT] = ACTIONS(4260),
    [anon_sym_GT] = ACTIONS(4260),
    [anon_sym_LT_LT] = ACTIONS(4260),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_DOT_EQ] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_x_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_DOT_DOT] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4260),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_SLASH_SLASH] = ACTIONS(4260),
    [anon_sym_AMP_AMP] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_AMP] = ACTIONS(4260),
    [anon_sym_GT_GT2] = ACTIONS(4260),
    [anon_sym_PLUS] = ACTIONS(4260),
    [anon_sym_DASH] = ACTIONS(4260),
    [anon_sym_DOT] = ACTIONS(4260),
    [anon_sym_STAR] = ACTIONS(4260),
    [anon_sym_SLASH] = ACTIONS(4260),
    [anon_sym_x] = ACTIONS(4260),
    [anon_sym_EQ_TILDE] = ACTIONS(4258),
    [anon_sym_BANG_TILDE] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4258),
    [anon_sym_BANG_EQ] = ACTIONS(4258),
    [anon_sym_eq] = ACTIONS(4258),
    [anon_sym_ne] = ACTIONS(4258),
    [anon_sym_LT_EQ_GT] = ACTIONS(4258),
    [anon_sym_cmp] = ACTIONS(4258),
    [anon_sym_TILDE_TILDE] = ACTIONS(4258),
    [anon_sym_LT_EQ] = ACTIONS(4260),
    [anon_sym_GT_EQ] = ACTIONS(4258),
    [anon_sym_lt] = ACTIONS(4258),
    [anon_sym_le] = ACTIONS(4258),
    [anon_sym_ge] = ACTIONS(4258),
    [anon_sym_gt] = ACTIONS(4258),
    [anon_sym_isa] = ACTIONS(4258),
    [anon_sym_PLUS_PLUS] = ACTIONS(4258),
    [anon_sym_DASH_DASH] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_EQ_GT] = ACTIONS(4258),
    [anon_sym_for] = ACTIONS(4260),
    [anon_sym_foreach] = ACTIONS(4258),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4258),
    [anon_sym___END__] = ACTIONS(4258),
    [anon_sym_EOT] = ACTIONS(4258),
    [anon_sym_if] = ACTIONS(4258),
    [anon_sym_unless] = ACTIONS(4258),
    [anon_sym_while] = ACTIONS(4258),
    [anon_sym_until] = ACTIONS(4258),
    [sym__PERLY_SEMICOLON] = ACTIONS(4258),
    [sym__ctrl_z_hack] = ACTIONS(4258),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1364] = {
    [sym_attrlist] = STATE(1353),
    [sym_attribute] = STATE(1283),
    [sym_attribute_name] = STATE(1369),
    [sym_heredoc_content] = STATE(1364),
    [sym__identifier] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3438),
    [anon_sym_PLUS_EQ] = ACTIONS(3438),
    [anon_sym_DASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_EQ] = ACTIONS(3438),
    [anon_sym_STAR_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_PERCENT_EQ] = ACTIONS(3438),
    [anon_sym_x_EQ] = ACTIONS(3438),
    [anon_sym_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_CARET_EQ] = ACTIONS(3438),
    [anon_sym_LT_LT_EQ] = ACTIONS(3438),
    [anon_sym_GT_GT_EQ] = ACTIONS(3438),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3440),
    [anon_sym_GT_GT2] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_x] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3438),
    [anon_sym_BANG_TILDE] = ACTIONS(3438),
    [anon_sym_EQ_EQ] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_eq] = ACTIONS(3440),
    [anon_sym_ne] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3438),
    [anon_sym_cmp] = ACTIONS(3440),
    [anon_sym_TILDE_TILDE] = ACTIONS(3438),
    [anon_sym_LT_EQ] = ACTIONS(3440),
    [anon_sym_GT_EQ] = ACTIONS(3438),
    [anon_sym_lt] = ACTIONS(3440),
    [anon_sym_le] = ACTIONS(3440),
    [anon_sym_ge] = ACTIONS(3440),
    [anon_sym_gt] = ACTIONS(3440),
    [anon_sym_isa] = ACTIONS(3440),
    [anon_sym_PLUS_PLUS] = ACTIONS(3438),
    [anon_sym_DASH_DASH] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3438),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3440),
    [anon_sym___END__] = ACTIONS(3440),
    [anon_sym_EOT] = ACTIONS(3438),
    [aux_sym__bareword_token1] = ACTIONS(3945),
    [sym__PERLY_SEMICOLON] = ACTIONS(3438),
    [sym__ctrl_z_hack] = ACTIONS(3438),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1365] = {
    [sym_attrlist] = STATE(1361),
    [sym_attribute] = STATE(1283),
    [sym_attribute_name] = STATE(1369),
    [sym_heredoc_content] = STATE(1365),
    [sym__identifier] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_COMMA] = ACTIONS(3434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3434),
    [anon_sym_and] = ACTIONS(3436),
    [anon_sym_or] = ACTIONS(3436),
    [anon_sym_DASH_GT] = ACTIONS(3434),
    [anon_sym_PERCENT] = ACTIONS(3436),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_LT_LT] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3434),
    [anon_sym_DASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_EQ] = ACTIONS(3434),
    [anon_sym_STAR_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_PERCENT_EQ] = ACTIONS(3434),
    [anon_sym_x_EQ] = ACTIONS(3434),
    [anon_sym_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_CARET_EQ] = ACTIONS(3434),
    [anon_sym_LT_LT_EQ] = ACTIONS(3434),
    [anon_sym_GT_GT_EQ] = ACTIONS(3434),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_DOT] = ACTIONS(3436),
    [anon_sym_STAR_STAR] = ACTIONS(3436),
    [anon_sym_PIPE_PIPE] = ACTIONS(3436),
    [anon_sym_SLASH_SLASH] = ACTIONS(3436),
    [anon_sym_AMP_AMP] = ACTIONS(3436),
    [anon_sym_PIPE] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_GT_GT2] = ACTIONS(3436),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_DOT] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3436),
    [anon_sym_SLASH] = ACTIONS(3436),
    [anon_sym_x] = ACTIONS(3436),
    [anon_sym_EQ_TILDE] = ACTIONS(3434),
    [anon_sym_BANG_TILDE] = ACTIONS(3434),
    [anon_sym_EQ_EQ] = ACTIONS(3434),
    [anon_sym_BANG_EQ] = ACTIONS(3434),
    [anon_sym_eq] = ACTIONS(3436),
    [anon_sym_ne] = ACTIONS(3436),
    [anon_sym_LT_EQ_GT] = ACTIONS(3434),
    [anon_sym_cmp] = ACTIONS(3436),
    [anon_sym_TILDE_TILDE] = ACTIONS(3434),
    [anon_sym_LT_EQ] = ACTIONS(3436),
    [anon_sym_GT_EQ] = ACTIONS(3434),
    [anon_sym_lt] = ACTIONS(3436),
    [anon_sym_le] = ACTIONS(3436),
    [anon_sym_ge] = ACTIONS(3436),
    [anon_sym_gt] = ACTIONS(3436),
    [anon_sym_isa] = ACTIONS(3436),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_QMARK] = ACTIONS(3434),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3436),
    [anon_sym___END__] = ACTIONS(3436),
    [anon_sym_EOT] = ACTIONS(3434),
    [aux_sym__bareword_token1] = ACTIONS(3945),
    [sym__PERLY_SEMICOLON] = ACTIONS(3434),
    [sym__ctrl_z_hack] = ACTIONS(3434),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1366] = {
    [sym_attribute] = STATE(1414),
    [sym_attribute_name] = STATE(1394),
    [sym_heredoc_content] = STATE(1366),
    [aux_sym_attrlist_repeat1] = STATE(1366),
    [sym__identifier] = ACTIONS(4262),
    [anon_sym_RBRACE] = ACTIONS(3408),
    [anon_sym_COLON] = ACTIONS(4265),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym_RPAREN] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_and] = ACTIONS(3410),
    [anon_sym_or] = ACTIONS(3410),
    [anon_sym_RBRACK] = ACTIONS(3408),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4262),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1367] = {
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1506),
    [sym_heredoc_content] = STATE(1367),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(4268),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym_prototype_or_signature] = ACTIONS(4270),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1368] = {
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1502),
    [sym_heredoc_content] = STATE(1368),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(4272),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym_prototype_or_signature] = ACTIONS(4274),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1369] = {
    [sym_heredoc_content] = STATE(1369),
    [sym__identifier] = ACTIONS(3446),
    [anon_sym_COLON] = ACTIONS(3446),
    [anon_sym_SEMI] = ACTIONS(3448),
    [anon_sym_COMMA] = ACTIONS(3448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3448),
    [anon_sym_and] = ACTIONS(3446),
    [anon_sym_or] = ACTIONS(3446),
    [anon_sym_DASH_GT] = ACTIONS(3448),
    [anon_sym_PERCENT] = ACTIONS(3446),
    [anon_sym_LT] = ACTIONS(3446),
    [anon_sym_GT] = ACTIONS(3446),
    [anon_sym_LT_LT] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(3446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_x_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_DOT] = ACTIONS(3446),
    [anon_sym_STAR_STAR] = ACTIONS(3446),
    [anon_sym_PIPE_PIPE] = ACTIONS(3446),
    [anon_sym_SLASH_SLASH] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_PIPE] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_GT_GT2] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3446),
    [anon_sym_DOT] = ACTIONS(3446),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_SLASH] = ACTIONS(3446),
    [anon_sym_x] = ACTIONS(3446),
    [anon_sym_EQ_TILDE] = ACTIONS(3448),
    [anon_sym_BANG_TILDE] = ACTIONS(3448),
    [anon_sym_EQ_EQ] = ACTIONS(3448),
    [anon_sym_BANG_EQ] = ACTIONS(3448),
    [anon_sym_eq] = ACTIONS(3446),
    [anon_sym_ne] = ACTIONS(3446),
    [anon_sym_LT_EQ_GT] = ACTIONS(3448),
    [anon_sym_cmp] = ACTIONS(3446),
    [anon_sym_TILDE_TILDE] = ACTIONS(3448),
    [anon_sym_LT_EQ] = ACTIONS(3446),
    [anon_sym_GT_EQ] = ACTIONS(3448),
    [anon_sym_lt] = ACTIONS(3446),
    [anon_sym_le] = ACTIONS(3446),
    [anon_sym_ge] = ACTIONS(3446),
    [anon_sym_gt] = ACTIONS(3446),
    [anon_sym_isa] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(3448),
    [anon_sym_EQ_GT] = ACTIONS(3448),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3446),
    [anon_sym___END__] = ACTIONS(3446),
    [anon_sym_EOT] = ACTIONS(3448),
    [aux_sym__bareword_token1] = ACTIONS(3446),
    [sym__PERLY_SEMICOLON] = ACTIONS(3448),
    [sym__ctrl_z_hack] = ACTIONS(3448),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(4276),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1370] = {
    [sym_heredoc_content] = STATE(1370),
    [sym__identifier] = ACTIONS(3442),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3444),
    [anon_sym_and] = ACTIONS(3442),
    [anon_sym_or] = ACTIONS(3442),
    [anon_sym_DASH_GT] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3444),
    [anon_sym_PLUS_EQ] = ACTIONS(3444),
    [anon_sym_DASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_EQ] = ACTIONS(3444),
    [anon_sym_STAR_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_PERCENT_EQ] = ACTIONS(3444),
    [anon_sym_x_EQ] = ACTIONS(3444),
    [anon_sym_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_CARET_EQ] = ACTIONS(3444),
    [anon_sym_LT_LT_EQ] = ACTIONS(3444),
    [anon_sym_GT_GT_EQ] = ACTIONS(3444),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_SLASH_SLASH] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_GT_GT2] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_x] = ACTIONS(3442),
    [anon_sym_EQ_TILDE] = ACTIONS(3444),
    [anon_sym_BANG_TILDE] = ACTIONS(3444),
    [anon_sym_EQ_EQ] = ACTIONS(3444),
    [anon_sym_BANG_EQ] = ACTIONS(3444),
    [anon_sym_eq] = ACTIONS(3442),
    [anon_sym_ne] = ACTIONS(3442),
    [anon_sym_LT_EQ_GT] = ACTIONS(3444),
    [anon_sym_cmp] = ACTIONS(3442),
    [anon_sym_TILDE_TILDE] = ACTIONS(3444),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3444),
    [anon_sym_lt] = ACTIONS(3442),
    [anon_sym_le] = ACTIONS(3442),
    [anon_sym_ge] = ACTIONS(3442),
    [anon_sym_gt] = ACTIONS(3442),
    [anon_sym_isa] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_EQ_GT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3442),
    [anon_sym___END__] = ACTIONS(3442),
    [anon_sym_EOT] = ACTIONS(3444),
    [aux_sym__bareword_token1] = ACTIONS(3442),
    [sym__PERLY_SEMICOLON] = ACTIONS(3444),
    [sym__ctrl_z_hack] = ACTIONS(3444),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(3444),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1371] = {
    [sym_attribute] = STATE(1414),
    [sym_attribute_name] = STATE(1394),
    [sym_heredoc_content] = STATE(1371),
    [aux_sym_attrlist_repeat1] = STATE(1366),
    [sym__identifier] = ACTIONS(4278),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_COLON] = ACTIONS(4280),
    [anon_sym_SEMI] = ACTIONS(3420),
    [anon_sym_RPAREN] = ACTIONS(3420),
    [anon_sym_COMMA] = ACTIONS(3420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3420),
    [anon_sym_and] = ACTIONS(3422),
    [anon_sym_or] = ACTIONS(3422),
    [anon_sym_RBRACK] = ACTIONS(3420),
    [anon_sym_DASH_GT] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3422),
    [anon_sym_GT] = ACTIONS(3422),
    [anon_sym_LT_LT] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3422),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_x_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_DOT] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3422),
    [anon_sym_PIPE_PIPE] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_AMP_AMP] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(3422),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_GT_GT2] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_DASH] = ACTIONS(3422),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_STAR] = ACTIONS(3422),
    [anon_sym_SLASH] = ACTIONS(3422),
    [anon_sym_x] = ACTIONS(3422),
    [anon_sym_EQ_TILDE] = ACTIONS(3420),
    [anon_sym_BANG_TILDE] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3420),
    [anon_sym_BANG_EQ] = ACTIONS(3420),
    [anon_sym_eq] = ACTIONS(3422),
    [anon_sym_ne] = ACTIONS(3422),
    [anon_sym_LT_EQ_GT] = ACTIONS(3420),
    [anon_sym_cmp] = ACTIONS(3422),
    [anon_sym_TILDE_TILDE] = ACTIONS(3420),
    [anon_sym_LT_EQ] = ACTIONS(3422),
    [anon_sym_GT_EQ] = ACTIONS(3420),
    [anon_sym_lt] = ACTIONS(3422),
    [anon_sym_le] = ACTIONS(3422),
    [anon_sym_ge] = ACTIONS(3422),
    [anon_sym_gt] = ACTIONS(3422),
    [anon_sym_isa] = ACTIONS(3422),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_EQ_GT] = ACTIONS(3420),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4278),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1372] = {
    [sym_attribute] = STATE(1414),
    [sym_attribute_name] = STATE(1394),
    [sym_heredoc_content] = STATE(1372),
    [aux_sym_attrlist_repeat1] = STATE(1371),
    [sym__identifier] = ACTIONS(4278),
    [anon_sym_RBRACE] = ACTIONS(3416),
    [anon_sym_COLON] = ACTIONS(4280),
    [anon_sym_SEMI] = ACTIONS(3416),
    [anon_sym_RPAREN] = ACTIONS(3416),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3416),
    [anon_sym_and] = ACTIONS(3418),
    [anon_sym_or] = ACTIONS(3418),
    [anon_sym_RBRACK] = ACTIONS(3416),
    [anon_sym_DASH_GT] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(3418),
    [anon_sym_GT] = ACTIONS(3418),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3416),
    [anon_sym_PLUS_EQ] = ACTIONS(3416),
    [anon_sym_DASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_EQ] = ACTIONS(3416),
    [anon_sym_STAR_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_PERCENT_EQ] = ACTIONS(3416),
    [anon_sym_x_EQ] = ACTIONS(3416),
    [anon_sym_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_CARET_EQ] = ACTIONS(3416),
    [anon_sym_LT_LT_EQ] = ACTIONS(3416),
    [anon_sym_GT_GT_EQ] = ACTIONS(3416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_DOT] = ACTIONS(3418),
    [anon_sym_STAR_STAR] = ACTIONS(3418),
    [anon_sym_PIPE_PIPE] = ACTIONS(3418),
    [anon_sym_SLASH_SLASH] = ACTIONS(3418),
    [anon_sym_AMP_AMP] = ACTIONS(3418),
    [anon_sym_PIPE] = ACTIONS(3418),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_GT_GT2] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_DOT] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3418),
    [anon_sym_SLASH] = ACTIONS(3418),
    [anon_sym_x] = ACTIONS(3418),
    [anon_sym_EQ_TILDE] = ACTIONS(3416),
    [anon_sym_BANG_TILDE] = ACTIONS(3416),
    [anon_sym_EQ_EQ] = ACTIONS(3416),
    [anon_sym_BANG_EQ] = ACTIONS(3416),
    [anon_sym_eq] = ACTIONS(3418),
    [anon_sym_ne] = ACTIONS(3418),
    [anon_sym_LT_EQ_GT] = ACTIONS(3416),
    [anon_sym_cmp] = ACTIONS(3418),
    [anon_sym_TILDE_TILDE] = ACTIONS(3416),
    [anon_sym_LT_EQ] = ACTIONS(3418),
    [anon_sym_GT_EQ] = ACTIONS(3416),
    [anon_sym_lt] = ACTIONS(3418),
    [anon_sym_le] = ACTIONS(3418),
    [anon_sym_ge] = ACTIONS(3418),
    [anon_sym_gt] = ACTIONS(3418),
    [anon_sym_isa] = ACTIONS(3418),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3416),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4278),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1373] = {
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1600),
    [sym_heredoc_content] = STATE(1373),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1374] = {
    [sym_heredoc_content] = STATE(1374),
    [sym__identifier] = ACTIONS(3500),
    [anon_sym_COLON] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3502),
    [anon_sym_and] = ACTIONS(3500),
    [anon_sym_or] = ACTIONS(3500),
    [anon_sym_DASH_GT] = ACTIONS(3502),
    [anon_sym_PERCENT] = ACTIONS(3500),
    [anon_sym_LT] = ACTIONS(3500),
    [anon_sym_GT] = ACTIONS(3500),
    [anon_sym_LT_LT] = ACTIONS(3500),
    [anon_sym_EQ] = ACTIONS(3500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3502),
    [anon_sym_PLUS_EQ] = ACTIONS(3502),
    [anon_sym_DASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_EQ] = ACTIONS(3502),
    [anon_sym_STAR_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_PERCENT_EQ] = ACTIONS(3502),
    [anon_sym_x_EQ] = ACTIONS(3502),
    [anon_sym_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_CARET_EQ] = ACTIONS(3502),
    [anon_sym_LT_LT_EQ] = ACTIONS(3502),
    [anon_sym_GT_GT_EQ] = ACTIONS(3502),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_DOT] = ACTIONS(3500),
    [anon_sym_STAR_STAR] = ACTIONS(3500),
    [anon_sym_PIPE_PIPE] = ACTIONS(3500),
    [anon_sym_SLASH_SLASH] = ACTIONS(3500),
    [anon_sym_AMP_AMP] = ACTIONS(3500),
    [anon_sym_PIPE] = ACTIONS(3500),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_GT_GT2] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_DOT] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3500),
    [anon_sym_SLASH] = ACTIONS(3500),
    [anon_sym_x] = ACTIONS(3500),
    [anon_sym_EQ_TILDE] = ACTIONS(3502),
    [anon_sym_BANG_TILDE] = ACTIONS(3502),
    [anon_sym_EQ_EQ] = ACTIONS(3502),
    [anon_sym_BANG_EQ] = ACTIONS(3502),
    [anon_sym_eq] = ACTIONS(3500),
    [anon_sym_ne] = ACTIONS(3500),
    [anon_sym_LT_EQ_GT] = ACTIONS(3502),
    [anon_sym_cmp] = ACTIONS(3500),
    [anon_sym_TILDE_TILDE] = ACTIONS(3502),
    [anon_sym_LT_EQ] = ACTIONS(3500),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [anon_sym_lt] = ACTIONS(3500),
    [anon_sym_le] = ACTIONS(3500),
    [anon_sym_ge] = ACTIONS(3500),
    [anon_sym_gt] = ACTIONS(3500),
    [anon_sym_isa] = ACTIONS(3500),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3502),
    [anon_sym_EQ_GT] = ACTIONS(3502),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3500),
    [anon_sym___END__] = ACTIONS(3500),
    [anon_sym_EOT] = ACTIONS(3502),
    [aux_sym__bareword_token1] = ACTIONS(3500),
    [sym__PERLY_SEMICOLON] = ACTIONS(3502),
    [sym__ctrl_z_hack] = ACTIONS(3502),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1375] = {
    [sym_attrlist] = STATE(1540),
    [sym_attribute] = STATE(1372),
    [sym_attribute_name] = STATE(1394),
    [sym_heredoc_content] = STATE(1375),
    [sym__identifier] = ACTIONS(4278),
    [anon_sym_RBRACE] = ACTIONS(3438),
    [anon_sym_SEMI] = ACTIONS(3438),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_RBRACK] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3438),
    [anon_sym_PLUS_EQ] = ACTIONS(3438),
    [anon_sym_DASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_EQ] = ACTIONS(3438),
    [anon_sym_STAR_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_PERCENT_EQ] = ACTIONS(3438),
    [anon_sym_x_EQ] = ACTIONS(3438),
    [anon_sym_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_CARET_EQ] = ACTIONS(3438),
    [anon_sym_LT_LT_EQ] = ACTIONS(3438),
    [anon_sym_GT_GT_EQ] = ACTIONS(3438),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3440),
    [anon_sym_GT_GT2] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_x] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3438),
    [anon_sym_BANG_TILDE] = ACTIONS(3438),
    [anon_sym_EQ_EQ] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_eq] = ACTIONS(3440),
    [anon_sym_ne] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3438),
    [anon_sym_cmp] = ACTIONS(3440),
    [anon_sym_TILDE_TILDE] = ACTIONS(3438),
    [anon_sym_LT_EQ] = ACTIONS(3440),
    [anon_sym_GT_EQ] = ACTIONS(3438),
    [anon_sym_lt] = ACTIONS(3440),
    [anon_sym_le] = ACTIONS(3440),
    [anon_sym_ge] = ACTIONS(3440),
    [anon_sym_gt] = ACTIONS(3440),
    [anon_sym_isa] = ACTIONS(3440),
    [anon_sym_PLUS_PLUS] = ACTIONS(3438),
    [anon_sym_DASH_DASH] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3438),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4278),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1376] = {
    [sym_attrlist] = STATE(1542),
    [sym_attribute] = STATE(1372),
    [sym_attribute_name] = STATE(1394),
    [sym_heredoc_content] = STATE(1376),
    [sym__identifier] = ACTIONS(4278),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_RPAREN] = ACTIONS(3434),
    [anon_sym_COMMA] = ACTIONS(3434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3434),
    [anon_sym_and] = ACTIONS(3436),
    [anon_sym_or] = ACTIONS(3436),
    [anon_sym_RBRACK] = ACTIONS(3434),
    [anon_sym_DASH_GT] = ACTIONS(3434),
    [anon_sym_PERCENT] = ACTIONS(3436),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_LT_LT] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3434),
    [anon_sym_DASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_EQ] = ACTIONS(3434),
    [anon_sym_STAR_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_PERCENT_EQ] = ACTIONS(3434),
    [anon_sym_x_EQ] = ACTIONS(3434),
    [anon_sym_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_CARET_EQ] = ACTIONS(3434),
    [anon_sym_LT_LT_EQ] = ACTIONS(3434),
    [anon_sym_GT_GT_EQ] = ACTIONS(3434),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_DOT] = ACTIONS(3436),
    [anon_sym_STAR_STAR] = ACTIONS(3436),
    [anon_sym_PIPE_PIPE] = ACTIONS(3436),
    [anon_sym_SLASH_SLASH] = ACTIONS(3436),
    [anon_sym_AMP_AMP] = ACTIONS(3436),
    [anon_sym_PIPE] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_GT_GT2] = ACTIONS(3436),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_DOT] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3436),
    [anon_sym_SLASH] = ACTIONS(3436),
    [anon_sym_x] = ACTIONS(3436),
    [anon_sym_EQ_TILDE] = ACTIONS(3434),
    [anon_sym_BANG_TILDE] = ACTIONS(3434),
    [anon_sym_EQ_EQ] = ACTIONS(3434),
    [anon_sym_BANG_EQ] = ACTIONS(3434),
    [anon_sym_eq] = ACTIONS(3436),
    [anon_sym_ne] = ACTIONS(3436),
    [anon_sym_LT_EQ_GT] = ACTIONS(3434),
    [anon_sym_cmp] = ACTIONS(3436),
    [anon_sym_TILDE_TILDE] = ACTIONS(3434),
    [anon_sym_LT_EQ] = ACTIONS(3436),
    [anon_sym_GT_EQ] = ACTIONS(3434),
    [anon_sym_lt] = ACTIONS(3436),
    [anon_sym_le] = ACTIONS(3436),
    [anon_sym_ge] = ACTIONS(3436),
    [anon_sym_gt] = ACTIONS(3436),
    [anon_sym_isa] = ACTIONS(3436),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_QMARK] = ACTIONS(3434),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4278),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1377] = {
    [sym_heredoc_content] = STATE(1377),
    [sym__identifier] = ACTIONS(3520),
    [anon_sym_COLON] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_COMMA] = ACTIONS(3522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3522),
    [anon_sym_and] = ACTIONS(3520),
    [anon_sym_or] = ACTIONS(3520),
    [anon_sym_DASH_GT] = ACTIONS(3522),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3520),
    [anon_sym_GT] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3522),
    [anon_sym_PLUS_EQ] = ACTIONS(3522),
    [anon_sym_DASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_EQ] = ACTIONS(3522),
    [anon_sym_STAR_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_PERCENT_EQ] = ACTIONS(3522),
    [anon_sym_x_EQ] = ACTIONS(3522),
    [anon_sym_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_CARET_EQ] = ACTIONS(3522),
    [anon_sym_LT_LT_EQ] = ACTIONS(3522),
    [anon_sym_GT_GT_EQ] = ACTIONS(3522),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_DOT] = ACTIONS(3520),
    [anon_sym_STAR_STAR] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_SLASH_SLASH] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_GT_GT2] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3520),
    [anon_sym_x] = ACTIONS(3520),
    [anon_sym_EQ_TILDE] = ACTIONS(3522),
    [anon_sym_BANG_TILDE] = ACTIONS(3522),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_eq] = ACTIONS(3520),
    [anon_sym_ne] = ACTIONS(3520),
    [anon_sym_LT_EQ_GT] = ACTIONS(3522),
    [anon_sym_cmp] = ACTIONS(3520),
    [anon_sym_TILDE_TILDE] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3520),
    [anon_sym_GT_EQ] = ACTIONS(3522),
    [anon_sym_lt] = ACTIONS(3520),
    [anon_sym_le] = ACTIONS(3520),
    [anon_sym_ge] = ACTIONS(3520),
    [anon_sym_gt] = ACTIONS(3520),
    [anon_sym_isa] = ACTIONS(3520),
    [anon_sym_PLUS_PLUS] = ACTIONS(3522),
    [anon_sym_DASH_DASH] = ACTIONS(3522),
    [anon_sym_QMARK] = ACTIONS(3522),
    [anon_sym_EQ_GT] = ACTIONS(3522),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3520),
    [anon_sym___END__] = ACTIONS(3520),
    [anon_sym_EOT] = ACTIONS(3522),
    [aux_sym__bareword_token1] = ACTIONS(3520),
    [sym__PERLY_SEMICOLON] = ACTIONS(3522),
    [sym__ctrl_z_hack] = ACTIONS(3522),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1378] = {
    [sym_heredoc_content] = STATE(1378),
    [sym__identifier] = ACTIONS(3410),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_and] = ACTIONS(3410),
    [anon_sym_or] = ACTIONS(3410),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3410),
    [anon_sym___END__] = ACTIONS(3410),
    [anon_sym_EOT] = ACTIONS(3408),
    [aux_sym__bareword_token1] = ACTIONS(3410),
    [sym__PERLY_SEMICOLON] = ACTIONS(3408),
    [sym__ctrl_z_hack] = ACTIONS(3408),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1379] = {
    [sym__decl_variable_list] = STATE(1711),
    [sym__declare_scalar] = STATE(1693),
    [sym__declare_array] = STATE(1693),
    [sym__declare_hash] = STATE(1693),
    [sym_heredoc_content] = STATE(1379),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(4282),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DOLLAR] = ACTIONS(4284),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_AT] = ACTIONS(4286),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_PERCENT2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1380] = {
    [sym_heredoc_content] = STATE(1380),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_RPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2887),
    [anon_sym_and] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [anon_sym_DASH_GT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2887),
    [anon_sym_PLUS_EQ] = ACTIONS(2887),
    [anon_sym_DASH_EQ] = ACTIONS(2887),
    [anon_sym_DOT_EQ] = ACTIONS(2887),
    [anon_sym_STAR_EQ] = ACTIONS(2887),
    [anon_sym_SLASH_EQ] = ACTIONS(2887),
    [anon_sym_PERCENT_EQ] = ACTIONS(2887),
    [anon_sym_x_EQ] = ACTIONS(2887),
    [anon_sym_AMP_EQ] = ACTIONS(2887),
    [anon_sym_PIPE_EQ] = ACTIONS(2887),
    [anon_sym_CARET_EQ] = ACTIONS(2887),
    [anon_sym_LT_LT_EQ] = ACTIONS(2887),
    [anon_sym_GT_GT_EQ] = ACTIONS(2887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2887),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2887),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_GT_GT2] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_x] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2887),
    [anon_sym_BANG_TILDE] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_eq] = ACTIONS(2887),
    [anon_sym_ne] = ACTIONS(2887),
    [anon_sym_LT_EQ_GT] = ACTIONS(2887),
    [anon_sym_cmp] = ACTIONS(2887),
    [anon_sym_TILDE_TILDE] = ACTIONS(2887),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2887),
    [anon_sym_lt] = ACTIONS(2887),
    [anon_sym_le] = ACTIONS(2887),
    [anon_sym_ge] = ACTIONS(2887),
    [anon_sym_gt] = ACTIONS(2887),
    [anon_sym_isa] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_EQ_GT] = ACTIONS(2887),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1381] = {
    [sym_heredoc_content] = STATE(1381),
    [anon_sym_LBRACE] = ACTIONS(3478),
    [anon_sym_RBRACE] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3478),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3478),
    [anon_sym_and] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_RBRACK] = ACTIONS(3478),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3478),
    [anon_sym_PLUS_EQ] = ACTIONS(3478),
    [anon_sym_DASH_EQ] = ACTIONS(3478),
    [anon_sym_DOT_EQ] = ACTIONS(3478),
    [anon_sym_STAR_EQ] = ACTIONS(3478),
    [anon_sym_SLASH_EQ] = ACTIONS(3478),
    [anon_sym_PERCENT_EQ] = ACTIONS(3478),
    [anon_sym_x_EQ] = ACTIONS(3478),
    [anon_sym_AMP_EQ] = ACTIONS(3478),
    [anon_sym_PIPE_EQ] = ACTIONS(3478),
    [anon_sym_CARET_EQ] = ACTIONS(3478),
    [anon_sym_LT_LT_EQ] = ACTIONS(3478),
    [anon_sym_GT_GT_EQ] = ACTIONS(3478),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3478),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3478),
    [anon_sym_DOT_DOT] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_SLASH_SLASH] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_GT_GT2] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3480),
    [anon_sym_x] = ACTIONS(3480),
    [anon_sym_EQ_TILDE] = ACTIONS(3478),
    [anon_sym_BANG_TILDE] = ACTIONS(3478),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_eq] = ACTIONS(3478),
    [anon_sym_ne] = ACTIONS(3478),
    [anon_sym_LT_EQ_GT] = ACTIONS(3478),
    [anon_sym_cmp] = ACTIONS(3478),
    [anon_sym_TILDE_TILDE] = ACTIONS(3478),
    [anon_sym_LT_EQ] = ACTIONS(3480),
    [anon_sym_GT_EQ] = ACTIONS(3478),
    [anon_sym_lt] = ACTIONS(3478),
    [anon_sym_le] = ACTIONS(3478),
    [anon_sym_ge] = ACTIONS(3478),
    [anon_sym_gt] = ACTIONS(3478),
    [anon_sym_isa] = ACTIONS(3478),
    [anon_sym_PLUS_PLUS] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3478),
    [anon_sym_EQ_GT] = ACTIONS(3478),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1382] = {
    [sym_heredoc_content] = STATE(1382),
    [sym__identifier] = ACTIONS(3442),
    [anon_sym_RBRACE] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_RPAREN] = ACTIONS(3444),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3444),
    [anon_sym_and] = ACTIONS(3442),
    [anon_sym_or] = ACTIONS(3442),
    [anon_sym_RBRACK] = ACTIONS(3444),
    [anon_sym_DASH_GT] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3444),
    [anon_sym_PLUS_EQ] = ACTIONS(3444),
    [anon_sym_DASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_EQ] = ACTIONS(3444),
    [anon_sym_STAR_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_PERCENT_EQ] = ACTIONS(3444),
    [anon_sym_x_EQ] = ACTIONS(3444),
    [anon_sym_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_CARET_EQ] = ACTIONS(3444),
    [anon_sym_LT_LT_EQ] = ACTIONS(3444),
    [anon_sym_GT_GT_EQ] = ACTIONS(3444),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_SLASH_SLASH] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_GT_GT2] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_x] = ACTIONS(3442),
    [anon_sym_EQ_TILDE] = ACTIONS(3444),
    [anon_sym_BANG_TILDE] = ACTIONS(3444),
    [anon_sym_EQ_EQ] = ACTIONS(3444),
    [anon_sym_BANG_EQ] = ACTIONS(3444),
    [anon_sym_eq] = ACTIONS(3442),
    [anon_sym_ne] = ACTIONS(3442),
    [anon_sym_LT_EQ_GT] = ACTIONS(3444),
    [anon_sym_cmp] = ACTIONS(3442),
    [anon_sym_TILDE_TILDE] = ACTIONS(3444),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3444),
    [anon_sym_lt] = ACTIONS(3442),
    [anon_sym_le] = ACTIONS(3442),
    [anon_sym_ge] = ACTIONS(3442),
    [anon_sym_gt] = ACTIONS(3442),
    [anon_sym_isa] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_EQ_GT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3442),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(3444),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1383] = {
    [sym_heredoc_content] = STATE(1383),
    [anon_sym_LBRACE] = ACTIONS(3508),
    [anon_sym_RBRACE] = ACTIONS(3508),
    [anon_sym_COLON] = ACTIONS(3508),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym_LPAREN] = ACTIONS(3508),
    [anon_sym_RPAREN] = ACTIONS(3508),
    [anon_sym_COMMA] = ACTIONS(3508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3508),
    [anon_sym_and] = ACTIONS(3508),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_LBRACK] = ACTIONS(3508),
    [anon_sym_RBRACK] = ACTIONS(3508),
    [anon_sym_DASH_GT] = ACTIONS(3508),
    [anon_sym_PERCENT] = ACTIONS(3510),
    [anon_sym_LT] = ACTIONS(3510),
    [anon_sym_GT] = ACTIONS(3510),
    [anon_sym_LT_LT] = ACTIONS(3510),
    [anon_sym_EQ] = ACTIONS(3510),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3508),
    [anon_sym_PLUS_EQ] = ACTIONS(3508),
    [anon_sym_DASH_EQ] = ACTIONS(3508),
    [anon_sym_DOT_EQ] = ACTIONS(3508),
    [anon_sym_STAR_EQ] = ACTIONS(3508),
    [anon_sym_SLASH_EQ] = ACTIONS(3508),
    [anon_sym_PERCENT_EQ] = ACTIONS(3508),
    [anon_sym_x_EQ] = ACTIONS(3508),
    [anon_sym_AMP_EQ] = ACTIONS(3508),
    [anon_sym_PIPE_EQ] = ACTIONS(3508),
    [anon_sym_CARET_EQ] = ACTIONS(3508),
    [anon_sym_LT_LT_EQ] = ACTIONS(3508),
    [anon_sym_GT_GT_EQ] = ACTIONS(3508),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3508),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3508),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3508),
    [anon_sym_DOT_DOT] = ACTIONS(3510),
    [anon_sym_STAR_STAR] = ACTIONS(3510),
    [anon_sym_PIPE_PIPE] = ACTIONS(3510),
    [anon_sym_SLASH_SLASH] = ACTIONS(3510),
    [anon_sym_AMP_AMP] = ACTIONS(3510),
    [anon_sym_PIPE] = ACTIONS(3510),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_GT_GT2] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3510),
    [anon_sym_DASH] = ACTIONS(3510),
    [anon_sym_DOT] = ACTIONS(3510),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_x] = ACTIONS(3510),
    [anon_sym_EQ_TILDE] = ACTIONS(3508),
    [anon_sym_BANG_TILDE] = ACTIONS(3508),
    [anon_sym_EQ_EQ] = ACTIONS(3508),
    [anon_sym_BANG_EQ] = ACTIONS(3508),
    [anon_sym_eq] = ACTIONS(3508),
    [anon_sym_ne] = ACTIONS(3508),
    [anon_sym_LT_EQ_GT] = ACTIONS(3508),
    [anon_sym_cmp] = ACTIONS(3508),
    [anon_sym_TILDE_TILDE] = ACTIONS(3508),
    [anon_sym_LT_EQ] = ACTIONS(3510),
    [anon_sym_GT_EQ] = ACTIONS(3508),
    [anon_sym_lt] = ACTIONS(3508),
    [anon_sym_le] = ACTIONS(3508),
    [anon_sym_ge] = ACTIONS(3508),
    [anon_sym_gt] = ACTIONS(3508),
    [anon_sym_isa] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3508),
    [anon_sym_DASH_DASH] = ACTIONS(3508),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_EQ_GT] = ACTIONS(3508),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1384] = {
    [sym_heredoc_content] = STATE(1384),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__apostrophe] = ACTIONS(4290),
    [sym__quotelike_begin] = ACTIONS(4292),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1385] = {
    [sym_heredoc_content] = STATE(1385),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__apostrophe] = ACTIONS(4294),
    [sym__quotelike_begin] = ACTIONS(4296),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1386] = {
    [sym_heredoc_content] = STATE(1386),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_COLON] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [anon_sym_COMMA] = ACTIONS(2899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2899),
    [anon_sym_and] = ACTIONS(2899),
    [anon_sym_or] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_RBRACK] = ACTIONS(2899),
    [anon_sym_DASH_GT] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2899),
    [anon_sym_PLUS_EQ] = ACTIONS(2899),
    [anon_sym_DASH_EQ] = ACTIONS(2899),
    [anon_sym_DOT_EQ] = ACTIONS(2899),
    [anon_sym_STAR_EQ] = ACTIONS(2899),
    [anon_sym_SLASH_EQ] = ACTIONS(2899),
    [anon_sym_PERCENT_EQ] = ACTIONS(2899),
    [anon_sym_x_EQ] = ACTIONS(2899),
    [anon_sym_AMP_EQ] = ACTIONS(2899),
    [anon_sym_PIPE_EQ] = ACTIONS(2899),
    [anon_sym_CARET_EQ] = ACTIONS(2899),
    [anon_sym_LT_LT_EQ] = ACTIONS(2899),
    [anon_sym_GT_GT_EQ] = ACTIONS(2899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2899),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2899),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_GT_GT2] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_x] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2899),
    [anon_sym_BANG_TILDE] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2899),
    [anon_sym_BANG_EQ] = ACTIONS(2899),
    [anon_sym_eq] = ACTIONS(2899),
    [anon_sym_ne] = ACTIONS(2899),
    [anon_sym_LT_EQ_GT] = ACTIONS(2899),
    [anon_sym_cmp] = ACTIONS(2899),
    [anon_sym_TILDE_TILDE] = ACTIONS(2899),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2899),
    [anon_sym_lt] = ACTIONS(2899),
    [anon_sym_le] = ACTIONS(2899),
    [anon_sym_ge] = ACTIONS(2899),
    [anon_sym_gt] = ACTIONS(2899),
    [anon_sym_isa] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_QMARK] = ACTIONS(2899),
    [anon_sym_EQ_GT] = ACTIONS(2899),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1387] = {
    [sym_heredoc_content] = STATE(1387),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__apostrophe] = ACTIONS(4298),
    [sym__quotelike_begin] = ACTIONS(4300),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1388] = {
    [sym_heredoc_content] = STATE(1388),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_COLON] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_RBRACK] = ACTIONS(2907),
    [anon_sym_DASH_GT] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2907),
    [anon_sym_PLUS_EQ] = ACTIONS(2907),
    [anon_sym_DASH_EQ] = ACTIONS(2907),
    [anon_sym_DOT_EQ] = ACTIONS(2907),
    [anon_sym_STAR_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_PERCENT_EQ] = ACTIONS(2907),
    [anon_sym_x_EQ] = ACTIONS(2907),
    [anon_sym_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_CARET_EQ] = ACTIONS(2907),
    [anon_sym_LT_LT_EQ] = ACTIONS(2907),
    [anon_sym_GT_GT_EQ] = ACTIONS(2907),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_STAR_STAR] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_GT_GT2] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_DOT] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_x] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2907),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_eq] = ACTIONS(2907),
    [anon_sym_ne] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_cmp] = ACTIONS(2907),
    [anon_sym_TILDE_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_lt] = ACTIONS(2907),
    [anon_sym_le] = ACTIONS(2907),
    [anon_sym_ge] = ACTIONS(2907),
    [anon_sym_gt] = ACTIONS(2907),
    [anon_sym_isa] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_EQ_GT] = ACTIONS(2907),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1389] = {
    [sym_heredoc_content] = STATE(1389),
    [anon_sym_LBRACE] = ACTIONS(4302),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(4304),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_and] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_EQ] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_x_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2936),
    [anon_sym_BANG_TILDE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_eq] = ACTIONS(2936),
    [anon_sym_ne] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_cmp] = ACTIONS(2936),
    [anon_sym_TILDE_TILDE] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_lt] = ACTIONS(2936),
    [anon_sym_le] = ACTIONS(2936),
    [anon_sym_ge] = ACTIONS(2936),
    [anon_sym_gt] = ACTIONS(2936),
    [anon_sym_isa] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1390] = {
    [sym_heredoc_content] = STATE(1390),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_COLON] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_RBRACK] = ACTIONS(2921),
    [anon_sym_DASH_GT] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(2919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_DOT_EQ] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_x_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2919),
    [anon_sym_STAR_STAR] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_GT_GT2] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2919),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_x] = ACTIONS(2919),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_eq] = ACTIONS(2921),
    [anon_sym_ne] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_cmp] = ACTIONS(2921),
    [anon_sym_TILDE_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_lt] = ACTIONS(2921),
    [anon_sym_le] = ACTIONS(2921),
    [anon_sym_ge] = ACTIONS(2921),
    [anon_sym_gt] = ACTIONS(2921),
    [anon_sym_isa] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1391] = {
    [sym_heredoc_content] = STATE(1391),
    [anon_sym_LBRACE] = ACTIONS(3528),
    [anon_sym_RBRACE] = ACTIONS(3528),
    [anon_sym_COLON] = ACTIONS(3528),
    [anon_sym_SEMI] = ACTIONS(3528),
    [anon_sym_LPAREN] = ACTIONS(3528),
    [anon_sym_RPAREN] = ACTIONS(3528),
    [anon_sym_COMMA] = ACTIONS(3528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3528),
    [anon_sym_and] = ACTIONS(3528),
    [anon_sym_or] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(3528),
    [anon_sym_RBRACK] = ACTIONS(3528),
    [anon_sym_DASH_GT] = ACTIONS(3528),
    [anon_sym_PERCENT] = ACTIONS(3530),
    [anon_sym_LT] = ACTIONS(3530),
    [anon_sym_GT] = ACTIONS(3530),
    [anon_sym_LT_LT] = ACTIONS(3530),
    [anon_sym_EQ] = ACTIONS(3530),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3528),
    [anon_sym_PLUS_EQ] = ACTIONS(3528),
    [anon_sym_DASH_EQ] = ACTIONS(3528),
    [anon_sym_DOT_EQ] = ACTIONS(3528),
    [anon_sym_STAR_EQ] = ACTIONS(3528),
    [anon_sym_SLASH_EQ] = ACTIONS(3528),
    [anon_sym_PERCENT_EQ] = ACTIONS(3528),
    [anon_sym_x_EQ] = ACTIONS(3528),
    [anon_sym_AMP_EQ] = ACTIONS(3528),
    [anon_sym_PIPE_EQ] = ACTIONS(3528),
    [anon_sym_CARET_EQ] = ACTIONS(3528),
    [anon_sym_LT_LT_EQ] = ACTIONS(3528),
    [anon_sym_GT_GT_EQ] = ACTIONS(3528),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3528),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3528),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3528),
    [anon_sym_DOT_DOT] = ACTIONS(3530),
    [anon_sym_STAR_STAR] = ACTIONS(3530),
    [anon_sym_PIPE_PIPE] = ACTIONS(3530),
    [anon_sym_SLASH_SLASH] = ACTIONS(3530),
    [anon_sym_AMP_AMP] = ACTIONS(3530),
    [anon_sym_PIPE] = ACTIONS(3530),
    [anon_sym_AMP] = ACTIONS(3530),
    [anon_sym_GT_GT2] = ACTIONS(3530),
    [anon_sym_PLUS] = ACTIONS(3530),
    [anon_sym_DASH] = ACTIONS(3530),
    [anon_sym_DOT] = ACTIONS(3530),
    [anon_sym_STAR] = ACTIONS(3530),
    [anon_sym_SLASH] = ACTIONS(3530),
    [anon_sym_x] = ACTIONS(3530),
    [anon_sym_EQ_TILDE] = ACTIONS(3528),
    [anon_sym_BANG_TILDE] = ACTIONS(3528),
    [anon_sym_EQ_EQ] = ACTIONS(3528),
    [anon_sym_BANG_EQ] = ACTIONS(3528),
    [anon_sym_eq] = ACTIONS(3528),
    [anon_sym_ne] = ACTIONS(3528),
    [anon_sym_LT_EQ_GT] = ACTIONS(3528),
    [anon_sym_cmp] = ACTIONS(3528),
    [anon_sym_TILDE_TILDE] = ACTIONS(3528),
    [anon_sym_LT_EQ] = ACTIONS(3530),
    [anon_sym_GT_EQ] = ACTIONS(3528),
    [anon_sym_lt] = ACTIONS(3528),
    [anon_sym_le] = ACTIONS(3528),
    [anon_sym_ge] = ACTIONS(3528),
    [anon_sym_gt] = ACTIONS(3528),
    [anon_sym_isa] = ACTIONS(3528),
    [anon_sym_PLUS_PLUS] = ACTIONS(3528),
    [anon_sym_DASH_DASH] = ACTIONS(3528),
    [anon_sym_QMARK] = ACTIONS(3528),
    [anon_sym_EQ_GT] = ACTIONS(3528),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1392] = {
    [sym_heredoc_content] = STATE(1392),
    [anon_sym_LBRACE] = ACTIONS(3532),
    [anon_sym_RBRACE] = ACTIONS(3532),
    [anon_sym_COLON] = ACTIONS(3532),
    [anon_sym_SEMI] = ACTIONS(3532),
    [anon_sym_LPAREN] = ACTIONS(3532),
    [anon_sym_RPAREN] = ACTIONS(3532),
    [anon_sym_COMMA] = ACTIONS(3532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3532),
    [anon_sym_and] = ACTIONS(3532),
    [anon_sym_or] = ACTIONS(3532),
    [anon_sym_LBRACK] = ACTIONS(3532),
    [anon_sym_RBRACK] = ACTIONS(3532),
    [anon_sym_DASH_GT] = ACTIONS(3532),
    [anon_sym_PERCENT] = ACTIONS(3534),
    [anon_sym_LT] = ACTIONS(3534),
    [anon_sym_GT] = ACTIONS(3534),
    [anon_sym_LT_LT] = ACTIONS(3534),
    [anon_sym_EQ] = ACTIONS(3534),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3532),
    [anon_sym_PLUS_EQ] = ACTIONS(3532),
    [anon_sym_DASH_EQ] = ACTIONS(3532),
    [anon_sym_DOT_EQ] = ACTIONS(3532),
    [anon_sym_STAR_EQ] = ACTIONS(3532),
    [anon_sym_SLASH_EQ] = ACTIONS(3532),
    [anon_sym_PERCENT_EQ] = ACTIONS(3532),
    [anon_sym_x_EQ] = ACTIONS(3532),
    [anon_sym_AMP_EQ] = ACTIONS(3532),
    [anon_sym_PIPE_EQ] = ACTIONS(3532),
    [anon_sym_CARET_EQ] = ACTIONS(3532),
    [anon_sym_LT_LT_EQ] = ACTIONS(3532),
    [anon_sym_GT_GT_EQ] = ACTIONS(3532),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3532),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3532),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3532),
    [anon_sym_DOT_DOT] = ACTIONS(3534),
    [anon_sym_STAR_STAR] = ACTIONS(3534),
    [anon_sym_PIPE_PIPE] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3534),
    [anon_sym_AMP_AMP] = ACTIONS(3534),
    [anon_sym_PIPE] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(3534),
    [anon_sym_GT_GT2] = ACTIONS(3534),
    [anon_sym_PLUS] = ACTIONS(3534),
    [anon_sym_DASH] = ACTIONS(3534),
    [anon_sym_DOT] = ACTIONS(3534),
    [anon_sym_STAR] = ACTIONS(3534),
    [anon_sym_SLASH] = ACTIONS(3534),
    [anon_sym_x] = ACTIONS(3534),
    [anon_sym_EQ_TILDE] = ACTIONS(3532),
    [anon_sym_BANG_TILDE] = ACTIONS(3532),
    [anon_sym_EQ_EQ] = ACTIONS(3532),
    [anon_sym_BANG_EQ] = ACTIONS(3532),
    [anon_sym_eq] = ACTIONS(3532),
    [anon_sym_ne] = ACTIONS(3532),
    [anon_sym_LT_EQ_GT] = ACTIONS(3532),
    [anon_sym_cmp] = ACTIONS(3532),
    [anon_sym_TILDE_TILDE] = ACTIONS(3532),
    [anon_sym_LT_EQ] = ACTIONS(3534),
    [anon_sym_GT_EQ] = ACTIONS(3532),
    [anon_sym_lt] = ACTIONS(3532),
    [anon_sym_le] = ACTIONS(3532),
    [anon_sym_ge] = ACTIONS(3532),
    [anon_sym_gt] = ACTIONS(3532),
    [anon_sym_isa] = ACTIONS(3532),
    [anon_sym_PLUS_PLUS] = ACTIONS(3532),
    [anon_sym_DASH_DASH] = ACTIONS(3532),
    [anon_sym_QMARK] = ACTIONS(3532),
    [anon_sym_EQ_GT] = ACTIONS(3532),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1393] = {
    [sym_heredoc_content] = STATE(1393),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_COLON] = ACTIONS(3458),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_RPAREN] = ACTIONS(3458),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3458),
    [anon_sym_and] = ACTIONS(3458),
    [anon_sym_or] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3458),
    [anon_sym_RBRACK] = ACTIONS(3458),
    [anon_sym_DASH_GT] = ACTIONS(3458),
    [anon_sym_PERCENT] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_LT_LT] = ACTIONS(3460),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3458),
    [anon_sym_PLUS_EQ] = ACTIONS(3458),
    [anon_sym_DASH_EQ] = ACTIONS(3458),
    [anon_sym_DOT_EQ] = ACTIONS(3458),
    [anon_sym_STAR_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_PERCENT_EQ] = ACTIONS(3458),
    [anon_sym_x_EQ] = ACTIONS(3458),
    [anon_sym_AMP_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_CARET_EQ] = ACTIONS(3458),
    [anon_sym_LT_LT_EQ] = ACTIONS(3458),
    [anon_sym_GT_GT_EQ] = ACTIONS(3458),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_DOT_DOT] = ACTIONS(3460),
    [anon_sym_STAR_STAR] = ACTIONS(3460),
    [anon_sym_PIPE_PIPE] = ACTIONS(3460),
    [anon_sym_SLASH_SLASH] = ACTIONS(3460),
    [anon_sym_AMP_AMP] = ACTIONS(3460),
    [anon_sym_PIPE] = ACTIONS(3460),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_GT_GT2] = ACTIONS(3460),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_DOT] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_SLASH] = ACTIONS(3460),
    [anon_sym_x] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3458),
    [anon_sym_BANG_TILDE] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3458),
    [anon_sym_BANG_EQ] = ACTIONS(3458),
    [anon_sym_eq] = ACTIONS(3458),
    [anon_sym_ne] = ACTIONS(3458),
    [anon_sym_LT_EQ_GT] = ACTIONS(3458),
    [anon_sym_cmp] = ACTIONS(3458),
    [anon_sym_TILDE_TILDE] = ACTIONS(3458),
    [anon_sym_LT_EQ] = ACTIONS(3460),
    [anon_sym_GT_EQ] = ACTIONS(3458),
    [anon_sym_lt] = ACTIONS(3458),
    [anon_sym_le] = ACTIONS(3458),
    [anon_sym_ge] = ACTIONS(3458),
    [anon_sym_gt] = ACTIONS(3458),
    [anon_sym_isa] = ACTIONS(3458),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3458),
    [anon_sym_EQ_GT] = ACTIONS(3458),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1394] = {
    [sym_heredoc_content] = STATE(1394),
    [sym__identifier] = ACTIONS(3446),
    [anon_sym_RBRACE] = ACTIONS(3448),
    [anon_sym_COLON] = ACTIONS(3446),
    [anon_sym_SEMI] = ACTIONS(3448),
    [anon_sym_RPAREN] = ACTIONS(3448),
    [anon_sym_COMMA] = ACTIONS(3448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3448),
    [anon_sym_and] = ACTIONS(3446),
    [anon_sym_or] = ACTIONS(3446),
    [anon_sym_RBRACK] = ACTIONS(3448),
    [anon_sym_DASH_GT] = ACTIONS(3448),
    [anon_sym_PERCENT] = ACTIONS(3446),
    [anon_sym_LT] = ACTIONS(3446),
    [anon_sym_GT] = ACTIONS(3446),
    [anon_sym_LT_LT] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(3446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_x_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_DOT] = ACTIONS(3446),
    [anon_sym_STAR_STAR] = ACTIONS(3446),
    [anon_sym_PIPE_PIPE] = ACTIONS(3446),
    [anon_sym_SLASH_SLASH] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_PIPE] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_GT_GT2] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3446),
    [anon_sym_DOT] = ACTIONS(3446),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_SLASH] = ACTIONS(3446),
    [anon_sym_x] = ACTIONS(3446),
    [anon_sym_EQ_TILDE] = ACTIONS(3448),
    [anon_sym_BANG_TILDE] = ACTIONS(3448),
    [anon_sym_EQ_EQ] = ACTIONS(3448),
    [anon_sym_BANG_EQ] = ACTIONS(3448),
    [anon_sym_eq] = ACTIONS(3446),
    [anon_sym_ne] = ACTIONS(3446),
    [anon_sym_LT_EQ_GT] = ACTIONS(3448),
    [anon_sym_cmp] = ACTIONS(3446),
    [anon_sym_TILDE_TILDE] = ACTIONS(3448),
    [anon_sym_LT_EQ] = ACTIONS(3446),
    [anon_sym_GT_EQ] = ACTIONS(3448),
    [anon_sym_lt] = ACTIONS(3446),
    [anon_sym_le] = ACTIONS(3446),
    [anon_sym_ge] = ACTIONS(3446),
    [anon_sym_gt] = ACTIONS(3446),
    [anon_sym_isa] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(3448),
    [anon_sym_EQ_GT] = ACTIONS(3448),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3446),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(4308),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1395] = {
    [sym__decl_variable_list] = STATE(1869),
    [sym__declare_scalar] = STATE(1868),
    [sym__declare_array] = STATE(1868),
    [sym__declare_hash] = STATE(1868),
    [sym_heredoc_content] = STATE(1395),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DOLLAR] = ACTIONS(3631),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_AT] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_PERCENT2] = ACTIONS(3635),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1396] = {
    [sym_heredoc_content] = STATE(1396),
    [anon_sym_LBRACE] = ACTIONS(3496),
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3496),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3496),
    [anon_sym_RPAREN] = ACTIONS(3496),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3496),
    [anon_sym_and] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3496),
    [anon_sym_LBRACK] = ACTIONS(3496),
    [anon_sym_RBRACK] = ACTIONS(3496),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_LT] = ACTIONS(3498),
    [anon_sym_GT] = ACTIONS(3498),
    [anon_sym_LT_LT] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3496),
    [anon_sym_PLUS_EQ] = ACTIONS(3496),
    [anon_sym_DASH_EQ] = ACTIONS(3496),
    [anon_sym_DOT_EQ] = ACTIONS(3496),
    [anon_sym_STAR_EQ] = ACTIONS(3496),
    [anon_sym_SLASH_EQ] = ACTIONS(3496),
    [anon_sym_PERCENT_EQ] = ACTIONS(3496),
    [anon_sym_x_EQ] = ACTIONS(3496),
    [anon_sym_AMP_EQ] = ACTIONS(3496),
    [anon_sym_PIPE_EQ] = ACTIONS(3496),
    [anon_sym_CARET_EQ] = ACTIONS(3496),
    [anon_sym_LT_LT_EQ] = ACTIONS(3496),
    [anon_sym_GT_GT_EQ] = ACTIONS(3496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3496),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3496),
    [anon_sym_DOT_DOT] = ACTIONS(3498),
    [anon_sym_STAR_STAR] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_SLASH_SLASH] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_PIPE] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_GT_GT2] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_SLASH] = ACTIONS(3498),
    [anon_sym_x] = ACTIONS(3498),
    [anon_sym_EQ_TILDE] = ACTIONS(3496),
    [anon_sym_BANG_TILDE] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3496),
    [anon_sym_BANG_EQ] = ACTIONS(3496),
    [anon_sym_eq] = ACTIONS(3496),
    [anon_sym_ne] = ACTIONS(3496),
    [anon_sym_LT_EQ_GT] = ACTIONS(3496),
    [anon_sym_cmp] = ACTIONS(3496),
    [anon_sym_TILDE_TILDE] = ACTIONS(3496),
    [anon_sym_LT_EQ] = ACTIONS(3498),
    [anon_sym_GT_EQ] = ACTIONS(3496),
    [anon_sym_lt] = ACTIONS(3496),
    [anon_sym_le] = ACTIONS(3496),
    [anon_sym_ge] = ACTIONS(3496),
    [anon_sym_gt] = ACTIONS(3496),
    [anon_sym_isa] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(3496),
    [anon_sym_QMARK] = ACTIONS(3496),
    [anon_sym_EQ_GT] = ACTIONS(3496),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1397] = {
    [sym_heredoc_content] = STATE(1397),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_COLON] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2917),
    [anon_sym_and] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_RBRACK] = ACTIONS(2917),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2917),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_x_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2917),
    [anon_sym_BANG_TILDE] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_eq] = ACTIONS(2917),
    [anon_sym_ne] = ACTIONS(2917),
    [anon_sym_LT_EQ_GT] = ACTIONS(2917),
    [anon_sym_cmp] = ACTIONS(2917),
    [anon_sym_TILDE_TILDE] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_lt] = ACTIONS(2917),
    [anon_sym_le] = ACTIONS(2917),
    [anon_sym_ge] = ACTIONS(2917),
    [anon_sym_gt] = ACTIONS(2917),
    [anon_sym_isa] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1398] = {
    [sym_heredoc_content] = STATE(1398),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_RBRACK] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_DOT_EQ] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_x_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2893),
    [anon_sym_STAR_STAR] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_GT_GT2] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_x] = ACTIONS(2893),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_eq] = ACTIONS(2895),
    [anon_sym_ne] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_cmp] = ACTIONS(2895),
    [anon_sym_TILDE_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_lt] = ACTIONS(2895),
    [anon_sym_le] = ACTIONS(2895),
    [anon_sym_ge] = ACTIONS(2895),
    [anon_sym_gt] = ACTIONS(2895),
    [anon_sym_isa] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1399] = {
    [sym_heredoc_content] = STATE(1399),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_COLON] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_RPAREN] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2925),
    [anon_sym_and] = ACTIONS(2925),
    [anon_sym_or] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(2925),
    [anon_sym_DASH_GT] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(2925),
    [anon_sym_DASH_EQ] = ACTIONS(2925),
    [anon_sym_DOT_EQ] = ACTIONS(2925),
    [anon_sym_STAR_EQ] = ACTIONS(2925),
    [anon_sym_SLASH_EQ] = ACTIONS(2925),
    [anon_sym_PERCENT_EQ] = ACTIONS(2925),
    [anon_sym_x_EQ] = ACTIONS(2925),
    [anon_sym_AMP_EQ] = ACTIONS(2925),
    [anon_sym_PIPE_EQ] = ACTIONS(2925),
    [anon_sym_CARET_EQ] = ACTIONS(2925),
    [anon_sym_LT_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_GT_EQ] = ACTIONS(2925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2925),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_GT_GT2] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_x] = ACTIONS(2923),
    [anon_sym_EQ_TILDE] = ACTIONS(2925),
    [anon_sym_BANG_TILDE] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_eq] = ACTIONS(2925),
    [anon_sym_ne] = ACTIONS(2925),
    [anon_sym_LT_EQ_GT] = ACTIONS(2925),
    [anon_sym_cmp] = ACTIONS(2925),
    [anon_sym_TILDE_TILDE] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2925),
    [anon_sym_lt] = ACTIONS(2925),
    [anon_sym_le] = ACTIONS(2925),
    [anon_sym_ge] = ACTIONS(2925),
    [anon_sym_gt] = ACTIONS(2925),
    [anon_sym_isa] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2925),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1400] = {
    [sym_heredoc_content] = STATE(1400),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_COLON] = ACTIONS(3504),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_LPAREN] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_RBRACK] = ACTIONS(3504),
    [anon_sym_DASH_GT] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_LT_LT] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_DOT_EQ] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_x_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_STAR_STAR] = ACTIONS(3506),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_SLASH_SLASH] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_GT_GT2] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_DASH] = ACTIONS(3506),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_STAR] = ACTIONS(3506),
    [anon_sym_SLASH] = ACTIONS(3506),
    [anon_sym_x] = ACTIONS(3506),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3504),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_eq] = ACTIONS(3504),
    [anon_sym_ne] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_cmp] = ACTIONS(3504),
    [anon_sym_TILDE_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_lt] = ACTIONS(3504),
    [anon_sym_le] = ACTIONS(3504),
    [anon_sym_ge] = ACTIONS(3504),
    [anon_sym_gt] = ACTIONS(3504),
    [anon_sym_isa] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3504),
    [anon_sym_DASH_DASH] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_EQ_GT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1401] = {
    [sym_heredoc_content] = STATE(1401),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_RBRACE] = ACTIONS(3536),
    [anon_sym_COLON] = ACTIONS(3536),
    [anon_sym_SEMI] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(3536),
    [anon_sym_RPAREN] = ACTIONS(3536),
    [anon_sym_COMMA] = ACTIONS(3536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3536),
    [anon_sym_and] = ACTIONS(3536),
    [anon_sym_or] = ACTIONS(3536),
    [anon_sym_LBRACK] = ACTIONS(3536),
    [anon_sym_RBRACK] = ACTIONS(3536),
    [anon_sym_DASH_GT] = ACTIONS(3536),
    [anon_sym_PERCENT] = ACTIONS(3538),
    [anon_sym_LT] = ACTIONS(3538),
    [anon_sym_GT] = ACTIONS(3538),
    [anon_sym_LT_LT] = ACTIONS(3538),
    [anon_sym_EQ] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3536),
    [anon_sym_DASH_EQ] = ACTIONS(3536),
    [anon_sym_DOT_EQ] = ACTIONS(3536),
    [anon_sym_STAR_EQ] = ACTIONS(3536),
    [anon_sym_SLASH_EQ] = ACTIONS(3536),
    [anon_sym_PERCENT_EQ] = ACTIONS(3536),
    [anon_sym_x_EQ] = ACTIONS(3536),
    [anon_sym_AMP_EQ] = ACTIONS(3536),
    [anon_sym_PIPE_EQ] = ACTIONS(3536),
    [anon_sym_CARET_EQ] = ACTIONS(3536),
    [anon_sym_LT_LT_EQ] = ACTIONS(3536),
    [anon_sym_GT_GT_EQ] = ACTIONS(3536),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3536),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3536),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3536),
    [anon_sym_DOT_DOT] = ACTIONS(3538),
    [anon_sym_STAR_STAR] = ACTIONS(3538),
    [anon_sym_PIPE_PIPE] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3538),
    [anon_sym_AMP_AMP] = ACTIONS(3538),
    [anon_sym_PIPE] = ACTIONS(3538),
    [anon_sym_AMP] = ACTIONS(3538),
    [anon_sym_GT_GT2] = ACTIONS(3538),
    [anon_sym_PLUS] = ACTIONS(3538),
    [anon_sym_DASH] = ACTIONS(3538),
    [anon_sym_DOT] = ACTIONS(3538),
    [anon_sym_STAR] = ACTIONS(3538),
    [anon_sym_SLASH] = ACTIONS(3538),
    [anon_sym_x] = ACTIONS(3538),
    [anon_sym_EQ_TILDE] = ACTIONS(3536),
    [anon_sym_BANG_TILDE] = ACTIONS(3536),
    [anon_sym_EQ_EQ] = ACTIONS(3536),
    [anon_sym_BANG_EQ] = ACTIONS(3536),
    [anon_sym_eq] = ACTIONS(3536),
    [anon_sym_ne] = ACTIONS(3536),
    [anon_sym_LT_EQ_GT] = ACTIONS(3536),
    [anon_sym_cmp] = ACTIONS(3536),
    [anon_sym_TILDE_TILDE] = ACTIONS(3536),
    [anon_sym_LT_EQ] = ACTIONS(3538),
    [anon_sym_GT_EQ] = ACTIONS(3536),
    [anon_sym_lt] = ACTIONS(3536),
    [anon_sym_le] = ACTIONS(3536),
    [anon_sym_ge] = ACTIONS(3536),
    [anon_sym_gt] = ACTIONS(3536),
    [anon_sym_isa] = ACTIONS(3536),
    [anon_sym_PLUS_PLUS] = ACTIONS(3536),
    [anon_sym_DASH_DASH] = ACTIONS(3536),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_EQ_GT] = ACTIONS(3536),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1402] = {
    [sym_heredoc_content] = STATE(1402),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2891),
    [anon_sym_and] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_RBRACK] = ACTIONS(2891),
    [anon_sym_DASH_GT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2891),
    [anon_sym_PLUS_EQ] = ACTIONS(2891),
    [anon_sym_DASH_EQ] = ACTIONS(2891),
    [anon_sym_DOT_EQ] = ACTIONS(2891),
    [anon_sym_STAR_EQ] = ACTIONS(2891),
    [anon_sym_SLASH_EQ] = ACTIONS(2891),
    [anon_sym_PERCENT_EQ] = ACTIONS(2891),
    [anon_sym_x_EQ] = ACTIONS(2891),
    [anon_sym_AMP_EQ] = ACTIONS(2891),
    [anon_sym_PIPE_EQ] = ACTIONS(2891),
    [anon_sym_CARET_EQ] = ACTIONS(2891),
    [anon_sym_LT_LT_EQ] = ACTIONS(2891),
    [anon_sym_GT_GT_EQ] = ACTIONS(2891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2891),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2891),
    [anon_sym_DOT_DOT] = ACTIONS(2889),
    [anon_sym_STAR_STAR] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_GT_GT2] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_x] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2891),
    [anon_sym_BANG_TILDE] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_eq] = ACTIONS(2891),
    [anon_sym_ne] = ACTIONS(2891),
    [anon_sym_LT_EQ_GT] = ACTIONS(2891),
    [anon_sym_cmp] = ACTIONS(2891),
    [anon_sym_TILDE_TILDE] = ACTIONS(2891),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_lt] = ACTIONS(2891),
    [anon_sym_le] = ACTIONS(2891),
    [anon_sym_ge] = ACTIONS(2891),
    [anon_sym_gt] = ACTIONS(2891),
    [anon_sym_isa] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_EQ_GT] = ACTIONS(2891),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1403] = {
    [sym_heredoc_content] = STATE(1403),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_COLON] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_RBRACK] = ACTIONS(2911),
    [anon_sym_DASH_GT] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2911),
    [anon_sym_DASH_EQ] = ACTIONS(2911),
    [anon_sym_DOT_EQ] = ACTIONS(2911),
    [anon_sym_STAR_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_PERCENT_EQ] = ACTIONS(2911),
    [anon_sym_x_EQ] = ACTIONS(2911),
    [anon_sym_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_CARET_EQ] = ACTIONS(2911),
    [anon_sym_LT_LT_EQ] = ACTIONS(2911),
    [anon_sym_GT_GT_EQ] = ACTIONS(2911),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_GT_GT2] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_x] = ACTIONS(2909),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2911),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_eq] = ACTIONS(2911),
    [anon_sym_ne] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_cmp] = ACTIONS(2911),
    [anon_sym_TILDE_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_lt] = ACTIONS(2911),
    [anon_sym_le] = ACTIONS(2911),
    [anon_sym_ge] = ACTIONS(2911),
    [anon_sym_gt] = ACTIONS(2911),
    [anon_sym_isa] = ACTIONS(2911),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_EQ_GT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1404] = {
    [sym_heredoc_content] = STATE(1404),
    [anon_sym_LBRACE] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_RPAREN] = ACTIONS(3488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3488),
    [anon_sym_and] = ACTIONS(3488),
    [anon_sym_or] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_RBRACK] = ACTIONS(3488),
    [anon_sym_DASH_GT] = ACTIONS(3488),
    [anon_sym_PERCENT] = ACTIONS(3490),
    [anon_sym_LT] = ACTIONS(3490),
    [anon_sym_GT] = ACTIONS(3490),
    [anon_sym_LT_LT] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(3490),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3488),
    [anon_sym_PLUS_EQ] = ACTIONS(3488),
    [anon_sym_DASH_EQ] = ACTIONS(3488),
    [anon_sym_DOT_EQ] = ACTIONS(3488),
    [anon_sym_STAR_EQ] = ACTIONS(3488),
    [anon_sym_SLASH_EQ] = ACTIONS(3488),
    [anon_sym_PERCENT_EQ] = ACTIONS(3488),
    [anon_sym_x_EQ] = ACTIONS(3488),
    [anon_sym_AMP_EQ] = ACTIONS(3488),
    [anon_sym_PIPE_EQ] = ACTIONS(3488),
    [anon_sym_CARET_EQ] = ACTIONS(3488),
    [anon_sym_LT_LT_EQ] = ACTIONS(3488),
    [anon_sym_GT_GT_EQ] = ACTIONS(3488),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3488),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3488),
    [anon_sym_DOT_DOT] = ACTIONS(3490),
    [anon_sym_STAR_STAR] = ACTIONS(3490),
    [anon_sym_PIPE_PIPE] = ACTIONS(3490),
    [anon_sym_SLASH_SLASH] = ACTIONS(3490),
    [anon_sym_AMP_AMP] = ACTIONS(3490),
    [anon_sym_PIPE] = ACTIONS(3490),
    [anon_sym_AMP] = ACTIONS(3490),
    [anon_sym_GT_GT2] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3490),
    [anon_sym_DASH] = ACTIONS(3490),
    [anon_sym_DOT] = ACTIONS(3490),
    [anon_sym_STAR] = ACTIONS(3490),
    [anon_sym_SLASH] = ACTIONS(3490),
    [anon_sym_x] = ACTIONS(3490),
    [anon_sym_EQ_TILDE] = ACTIONS(3488),
    [anon_sym_BANG_TILDE] = ACTIONS(3488),
    [anon_sym_EQ_EQ] = ACTIONS(3488),
    [anon_sym_BANG_EQ] = ACTIONS(3488),
    [anon_sym_eq] = ACTIONS(3488),
    [anon_sym_ne] = ACTIONS(3488),
    [anon_sym_LT_EQ_GT] = ACTIONS(3488),
    [anon_sym_cmp] = ACTIONS(3488),
    [anon_sym_TILDE_TILDE] = ACTIONS(3488),
    [anon_sym_LT_EQ] = ACTIONS(3490),
    [anon_sym_GT_EQ] = ACTIONS(3488),
    [anon_sym_lt] = ACTIONS(3488),
    [anon_sym_le] = ACTIONS(3488),
    [anon_sym_ge] = ACTIONS(3488),
    [anon_sym_gt] = ACTIONS(3488),
    [anon_sym_isa] = ACTIONS(3488),
    [anon_sym_PLUS_PLUS] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_EQ_GT] = ACTIONS(3488),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1405] = {
    [sym__decl_variable_list] = STATE(1727),
    [sym__declare_scalar] = STATE(1726),
    [sym__declare_array] = STATE(1726),
    [sym__declare_hash] = STATE(1726),
    [sym_heredoc_content] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DOLLAR] = ACTIONS(3631),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_AT] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_PERCENT2] = ACTIONS(3635),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1406] = {
    [sym_heredoc_content] = STATE(1406),
    [anon_sym_LBRACE] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3516),
    [anon_sym_COLON] = ACTIONS(3516),
    [anon_sym_SEMI] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3516),
    [anon_sym_RPAREN] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3516),
    [anon_sym_and] = ACTIONS(3516),
    [anon_sym_or] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3516),
    [anon_sym_RBRACK] = ACTIONS(3516),
    [anon_sym_DASH_GT] = ACTIONS(3516),
    [anon_sym_PERCENT] = ACTIONS(3518),
    [anon_sym_LT] = ACTIONS(3518),
    [anon_sym_GT] = ACTIONS(3518),
    [anon_sym_LT_LT] = ACTIONS(3518),
    [anon_sym_EQ] = ACTIONS(3518),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3516),
    [anon_sym_PLUS_EQ] = ACTIONS(3516),
    [anon_sym_DASH_EQ] = ACTIONS(3516),
    [anon_sym_DOT_EQ] = ACTIONS(3516),
    [anon_sym_STAR_EQ] = ACTIONS(3516),
    [anon_sym_SLASH_EQ] = ACTIONS(3516),
    [anon_sym_PERCENT_EQ] = ACTIONS(3516),
    [anon_sym_x_EQ] = ACTIONS(3516),
    [anon_sym_AMP_EQ] = ACTIONS(3516),
    [anon_sym_PIPE_EQ] = ACTIONS(3516),
    [anon_sym_CARET_EQ] = ACTIONS(3516),
    [anon_sym_LT_LT_EQ] = ACTIONS(3516),
    [anon_sym_GT_GT_EQ] = ACTIONS(3516),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3516),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3516),
    [anon_sym_DOT_DOT] = ACTIONS(3518),
    [anon_sym_STAR_STAR] = ACTIONS(3518),
    [anon_sym_PIPE_PIPE] = ACTIONS(3518),
    [anon_sym_SLASH_SLASH] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3518),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_GT_GT2] = ACTIONS(3518),
    [anon_sym_PLUS] = ACTIONS(3518),
    [anon_sym_DASH] = ACTIONS(3518),
    [anon_sym_DOT] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3518),
    [anon_sym_SLASH] = ACTIONS(3518),
    [anon_sym_x] = ACTIONS(3518),
    [anon_sym_EQ_TILDE] = ACTIONS(3516),
    [anon_sym_BANG_TILDE] = ACTIONS(3516),
    [anon_sym_EQ_EQ] = ACTIONS(3516),
    [anon_sym_BANG_EQ] = ACTIONS(3516),
    [anon_sym_eq] = ACTIONS(3516),
    [anon_sym_ne] = ACTIONS(3516),
    [anon_sym_LT_EQ_GT] = ACTIONS(3516),
    [anon_sym_cmp] = ACTIONS(3516),
    [anon_sym_TILDE_TILDE] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(3518),
    [anon_sym_GT_EQ] = ACTIONS(3516),
    [anon_sym_lt] = ACTIONS(3516),
    [anon_sym_le] = ACTIONS(3516),
    [anon_sym_ge] = ACTIONS(3516),
    [anon_sym_gt] = ACTIONS(3516),
    [anon_sym_isa] = ACTIONS(3516),
    [anon_sym_PLUS_PLUS] = ACTIONS(3516),
    [anon_sym_DASH_DASH] = ACTIONS(3516),
    [anon_sym_QMARK] = ACTIONS(3516),
    [anon_sym_EQ_GT] = ACTIONS(3516),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1407] = {
    [sym_heredoc_content] = STATE(1407),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_COLON] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_RPAREN] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2903),
    [anon_sym_and] = ACTIONS(2903),
    [anon_sym_or] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_RBRACK] = ACTIONS(2903),
    [anon_sym_DASH_GT] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2901),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2903),
    [anon_sym_DOT_EQ] = ACTIONS(2903),
    [anon_sym_STAR_EQ] = ACTIONS(2903),
    [anon_sym_SLASH_EQ] = ACTIONS(2903),
    [anon_sym_PERCENT_EQ] = ACTIONS(2903),
    [anon_sym_x_EQ] = ACTIONS(2903),
    [anon_sym_AMP_EQ] = ACTIONS(2903),
    [anon_sym_PIPE_EQ] = ACTIONS(2903),
    [anon_sym_CARET_EQ] = ACTIONS(2903),
    [anon_sym_LT_LT_EQ] = ACTIONS(2903),
    [anon_sym_GT_GT_EQ] = ACTIONS(2903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2903),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2903),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_GT_GT2] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_x] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2903),
    [anon_sym_BANG_TILDE] = ACTIONS(2903),
    [anon_sym_EQ_EQ] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2903),
    [anon_sym_eq] = ACTIONS(2903),
    [anon_sym_ne] = ACTIONS(2903),
    [anon_sym_LT_EQ_GT] = ACTIONS(2903),
    [anon_sym_cmp] = ACTIONS(2903),
    [anon_sym_TILDE_TILDE] = ACTIONS(2903),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2903),
    [anon_sym_lt] = ACTIONS(2903),
    [anon_sym_le] = ACTIONS(2903),
    [anon_sym_ge] = ACTIONS(2903),
    [anon_sym_gt] = ACTIONS(2903),
    [anon_sym_isa] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_QMARK] = ACTIONS(2903),
    [anon_sym_EQ_GT] = ACTIONS(2903),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1408] = {
    [sym_heredoc_content] = STATE(1408),
    [anon_sym_LBRACE] = ACTIONS(3512),
    [anon_sym_RBRACE] = ACTIONS(3512),
    [anon_sym_COLON] = ACTIONS(3512),
    [anon_sym_SEMI] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_RPAREN] = ACTIONS(3512),
    [anon_sym_COMMA] = ACTIONS(3512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3512),
    [anon_sym_and] = ACTIONS(3512),
    [anon_sym_or] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3512),
    [anon_sym_RBRACK] = ACTIONS(3512),
    [anon_sym_DASH_GT] = ACTIONS(3512),
    [anon_sym_PERCENT] = ACTIONS(3514),
    [anon_sym_LT] = ACTIONS(3514),
    [anon_sym_GT] = ACTIONS(3514),
    [anon_sym_LT_LT] = ACTIONS(3514),
    [anon_sym_EQ] = ACTIONS(3514),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_DOT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_x_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_DOT_DOT] = ACTIONS(3514),
    [anon_sym_STAR_STAR] = ACTIONS(3514),
    [anon_sym_PIPE_PIPE] = ACTIONS(3514),
    [anon_sym_SLASH_SLASH] = ACTIONS(3514),
    [anon_sym_AMP_AMP] = ACTIONS(3514),
    [anon_sym_PIPE] = ACTIONS(3514),
    [anon_sym_AMP] = ACTIONS(3514),
    [anon_sym_GT_GT2] = ACTIONS(3514),
    [anon_sym_PLUS] = ACTIONS(3514),
    [anon_sym_DASH] = ACTIONS(3514),
    [anon_sym_DOT] = ACTIONS(3514),
    [anon_sym_STAR] = ACTIONS(3514),
    [anon_sym_SLASH] = ACTIONS(3514),
    [anon_sym_x] = ACTIONS(3514),
    [anon_sym_EQ_TILDE] = ACTIONS(3512),
    [anon_sym_BANG_TILDE] = ACTIONS(3512),
    [anon_sym_EQ_EQ] = ACTIONS(3512),
    [anon_sym_BANG_EQ] = ACTIONS(3512),
    [anon_sym_eq] = ACTIONS(3512),
    [anon_sym_ne] = ACTIONS(3512),
    [anon_sym_LT_EQ_GT] = ACTIONS(3512),
    [anon_sym_cmp] = ACTIONS(3512),
    [anon_sym_TILDE_TILDE] = ACTIONS(3512),
    [anon_sym_LT_EQ] = ACTIONS(3514),
    [anon_sym_GT_EQ] = ACTIONS(3512),
    [anon_sym_lt] = ACTIONS(3512),
    [anon_sym_le] = ACTIONS(3512),
    [anon_sym_ge] = ACTIONS(3512),
    [anon_sym_gt] = ACTIONS(3512),
    [anon_sym_isa] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3512),
    [anon_sym_DASH_DASH] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(3512),
    [anon_sym_EQ_GT] = ACTIONS(3512),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1409] = {
    [sym_heredoc_content] = STATE(1409),
    [anon_sym_LBRACE] = ACTIONS(3524),
    [anon_sym_RBRACE] = ACTIONS(3524),
    [anon_sym_COLON] = ACTIONS(3524),
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(3524),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_COMMA] = ACTIONS(3524),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3524),
    [anon_sym_and] = ACTIONS(3524),
    [anon_sym_or] = ACTIONS(3524),
    [anon_sym_LBRACK] = ACTIONS(3524),
    [anon_sym_RBRACK] = ACTIONS(3524),
    [anon_sym_DASH_GT] = ACTIONS(3524),
    [anon_sym_PERCENT] = ACTIONS(3526),
    [anon_sym_LT] = ACTIONS(3526),
    [anon_sym_GT] = ACTIONS(3526),
    [anon_sym_LT_LT] = ACTIONS(3526),
    [anon_sym_EQ] = ACTIONS(3526),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3524),
    [anon_sym_PLUS_EQ] = ACTIONS(3524),
    [anon_sym_DASH_EQ] = ACTIONS(3524),
    [anon_sym_DOT_EQ] = ACTIONS(3524),
    [anon_sym_STAR_EQ] = ACTIONS(3524),
    [anon_sym_SLASH_EQ] = ACTIONS(3524),
    [anon_sym_PERCENT_EQ] = ACTIONS(3524),
    [anon_sym_x_EQ] = ACTIONS(3524),
    [anon_sym_AMP_EQ] = ACTIONS(3524),
    [anon_sym_PIPE_EQ] = ACTIONS(3524),
    [anon_sym_CARET_EQ] = ACTIONS(3524),
    [anon_sym_LT_LT_EQ] = ACTIONS(3524),
    [anon_sym_GT_GT_EQ] = ACTIONS(3524),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3524),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3524),
    [anon_sym_DOT_DOT] = ACTIONS(3526),
    [anon_sym_STAR_STAR] = ACTIONS(3526),
    [anon_sym_PIPE_PIPE] = ACTIONS(3526),
    [anon_sym_SLASH_SLASH] = ACTIONS(3526),
    [anon_sym_AMP_AMP] = ACTIONS(3526),
    [anon_sym_PIPE] = ACTIONS(3526),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_GT_GT2] = ACTIONS(3526),
    [anon_sym_PLUS] = ACTIONS(3526),
    [anon_sym_DASH] = ACTIONS(3526),
    [anon_sym_DOT] = ACTIONS(3526),
    [anon_sym_STAR] = ACTIONS(3526),
    [anon_sym_SLASH] = ACTIONS(3526),
    [anon_sym_x] = ACTIONS(3526),
    [anon_sym_EQ_TILDE] = ACTIONS(3524),
    [anon_sym_BANG_TILDE] = ACTIONS(3524),
    [anon_sym_EQ_EQ] = ACTIONS(3524),
    [anon_sym_BANG_EQ] = ACTIONS(3524),
    [anon_sym_eq] = ACTIONS(3524),
    [anon_sym_ne] = ACTIONS(3524),
    [anon_sym_LT_EQ_GT] = ACTIONS(3524),
    [anon_sym_cmp] = ACTIONS(3524),
    [anon_sym_TILDE_TILDE] = ACTIONS(3524),
    [anon_sym_LT_EQ] = ACTIONS(3526),
    [anon_sym_GT_EQ] = ACTIONS(3524),
    [anon_sym_lt] = ACTIONS(3524),
    [anon_sym_le] = ACTIONS(3524),
    [anon_sym_ge] = ACTIONS(3524),
    [anon_sym_gt] = ACTIONS(3524),
    [anon_sym_isa] = ACTIONS(3524),
    [anon_sym_PLUS_PLUS] = ACTIONS(3524),
    [anon_sym_DASH_DASH] = ACTIONS(3524),
    [anon_sym_QMARK] = ACTIONS(3524),
    [anon_sym_EQ_GT] = ACTIONS(3524),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1410] = {
    [sym_heredoc_content] = STATE(1410),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_RBRACE] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3492),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3492),
    [anon_sym_RPAREN] = ACTIONS(3492),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3492),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3492),
    [anon_sym_RBRACK] = ACTIONS(3492),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3494),
    [anon_sym_GT] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3492),
    [anon_sym_PLUS_EQ] = ACTIONS(3492),
    [anon_sym_DASH_EQ] = ACTIONS(3492),
    [anon_sym_DOT_EQ] = ACTIONS(3492),
    [anon_sym_STAR_EQ] = ACTIONS(3492),
    [anon_sym_SLASH_EQ] = ACTIONS(3492),
    [anon_sym_PERCENT_EQ] = ACTIONS(3492),
    [anon_sym_x_EQ] = ACTIONS(3492),
    [anon_sym_AMP_EQ] = ACTIONS(3492),
    [anon_sym_PIPE_EQ] = ACTIONS(3492),
    [anon_sym_CARET_EQ] = ACTIONS(3492),
    [anon_sym_LT_LT_EQ] = ACTIONS(3492),
    [anon_sym_GT_GT_EQ] = ACTIONS(3492),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3492),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3492),
    [anon_sym_DOT_DOT] = ACTIONS(3494),
    [anon_sym_STAR_STAR] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_SLASH_SLASH] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_PIPE] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_GT_GT2] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_SLASH] = ACTIONS(3494),
    [anon_sym_x] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3492),
    [anon_sym_BANG_TILDE] = ACTIONS(3492),
    [anon_sym_EQ_EQ] = ACTIONS(3492),
    [anon_sym_BANG_EQ] = ACTIONS(3492),
    [anon_sym_eq] = ACTIONS(3492),
    [anon_sym_ne] = ACTIONS(3492),
    [anon_sym_LT_EQ_GT] = ACTIONS(3492),
    [anon_sym_cmp] = ACTIONS(3492),
    [anon_sym_TILDE_TILDE] = ACTIONS(3492),
    [anon_sym_LT_EQ] = ACTIONS(3494),
    [anon_sym_GT_EQ] = ACTIONS(3492),
    [anon_sym_lt] = ACTIONS(3492),
    [anon_sym_le] = ACTIONS(3492),
    [anon_sym_ge] = ACTIONS(3492),
    [anon_sym_gt] = ACTIONS(3492),
    [anon_sym_isa] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_QMARK] = ACTIONS(3492),
    [anon_sym_EQ_GT] = ACTIONS(3492),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1411] = {
    [sym_heredoc_content] = STATE(1411),
    [anon_sym_LBRACE] = ACTIONS(3474),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3474),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(3474),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3474),
    [anon_sym_and] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_RBRACK] = ACTIONS(3474),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_LT] = ACTIONS(3476),
    [anon_sym_GT] = ACTIONS(3476),
    [anon_sym_LT_LT] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3476),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3474),
    [anon_sym_PLUS_EQ] = ACTIONS(3474),
    [anon_sym_DASH_EQ] = ACTIONS(3474),
    [anon_sym_DOT_EQ] = ACTIONS(3474),
    [anon_sym_STAR_EQ] = ACTIONS(3474),
    [anon_sym_SLASH_EQ] = ACTIONS(3474),
    [anon_sym_PERCENT_EQ] = ACTIONS(3474),
    [anon_sym_x_EQ] = ACTIONS(3474),
    [anon_sym_AMP_EQ] = ACTIONS(3474),
    [anon_sym_PIPE_EQ] = ACTIONS(3474),
    [anon_sym_CARET_EQ] = ACTIONS(3474),
    [anon_sym_LT_LT_EQ] = ACTIONS(3474),
    [anon_sym_GT_GT_EQ] = ACTIONS(3474),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3474),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3474),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3474),
    [anon_sym_DOT_DOT] = ACTIONS(3476),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_SLASH_SLASH] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_PIPE] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_GT_GT2] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_x] = ACTIONS(3476),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [anon_sym_EQ_EQ] = ACTIONS(3474),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_eq] = ACTIONS(3474),
    [anon_sym_ne] = ACTIONS(3474),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_cmp] = ACTIONS(3474),
    [anon_sym_TILDE_TILDE] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3476),
    [anon_sym_GT_EQ] = ACTIONS(3474),
    [anon_sym_lt] = ACTIONS(3474),
    [anon_sym_le] = ACTIONS(3474),
    [anon_sym_ge] = ACTIONS(3474),
    [anon_sym_gt] = ACTIONS(3474),
    [anon_sym_isa] = ACTIONS(3474),
    [anon_sym_PLUS_PLUS] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3474),
    [anon_sym_QMARK] = ACTIONS(3474),
    [anon_sym_EQ_GT] = ACTIONS(3474),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1412] = {
    [sym_heredoc_content] = STATE(1412),
    [anon_sym_LBRACE] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3554),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_SEMI] = ACTIONS(3554),
    [anon_sym_RPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3554),
    [anon_sym_and] = ACTIONS(3554),
    [anon_sym_or] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3552),
    [anon_sym_RBRACK] = ACTIONS(3554),
    [anon_sym_DASH_GT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_GT] = ACTIONS(3556),
    [anon_sym_LT_LT] = ACTIONS(3556),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3554),
    [anon_sym_PLUS_EQ] = ACTIONS(3554),
    [anon_sym_DASH_EQ] = ACTIONS(3554),
    [anon_sym_DOT_EQ] = ACTIONS(3554),
    [anon_sym_STAR_EQ] = ACTIONS(3554),
    [anon_sym_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_PERCENT_EQ] = ACTIONS(3554),
    [anon_sym_x_EQ] = ACTIONS(3554),
    [anon_sym_AMP_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_CARET_EQ] = ACTIONS(3554),
    [anon_sym_LT_LT_EQ] = ACTIONS(3554),
    [anon_sym_GT_GT_EQ] = ACTIONS(3554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_DOT_DOT] = ACTIONS(3556),
    [anon_sym_STAR_STAR] = ACTIONS(3556),
    [anon_sym_PIPE_PIPE] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH] = ACTIONS(3556),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_PIPE] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym_GT_GT2] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3556),
    [anon_sym_DOT] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_SLASH] = ACTIONS(3556),
    [anon_sym_x] = ACTIONS(3556),
    [anon_sym_EQ_TILDE] = ACTIONS(3554),
    [anon_sym_BANG_TILDE] = ACTIONS(3554),
    [anon_sym_EQ_EQ] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_eq] = ACTIONS(3554),
    [anon_sym_ne] = ACTIONS(3554),
    [anon_sym_LT_EQ_GT] = ACTIONS(3554),
    [anon_sym_cmp] = ACTIONS(3554),
    [anon_sym_TILDE_TILDE] = ACTIONS(3554),
    [anon_sym_LT_EQ] = ACTIONS(3556),
    [anon_sym_GT_EQ] = ACTIONS(3554),
    [anon_sym_lt] = ACTIONS(3554),
    [anon_sym_le] = ACTIONS(3554),
    [anon_sym_ge] = ACTIONS(3554),
    [anon_sym_gt] = ACTIONS(3554),
    [anon_sym_isa] = ACTIONS(3554),
    [anon_sym_PLUS_PLUS] = ACTIONS(3554),
    [anon_sym_DASH_DASH] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_EQ_GT] = ACTIONS(3554),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1413] = {
    [sym_heredoc_content] = STATE(1413),
    [aux_sym__term_rightward_repeat1] = STATE(2214),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(4310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_and] = ACTIONS(3645),
    [anon_sym_or] = ACTIONS(3645),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4320),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4322),
    [anon_sym_PLUS_EQ] = ACTIONS(4322),
    [anon_sym_DASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_EQ] = ACTIONS(4322),
    [anon_sym_STAR_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_PERCENT_EQ] = ACTIONS(4322),
    [anon_sym_x_EQ] = ACTIONS(4322),
    [anon_sym_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_CARET_EQ] = ACTIONS(4322),
    [anon_sym_LT_LT_EQ] = ACTIONS(4322),
    [anon_sym_GT_GT_EQ] = ACTIONS(4322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_DOT] = ACTIONS(4324),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4328),
    [anon_sym_SLASH_SLASH] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4310),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3645),
    [anon_sym___END__] = ACTIONS(3645),
    [anon_sym_EOT] = ACTIONS(3645),
    [sym__PERLY_SEMICOLON] = ACTIONS(3645),
    [sym__ctrl_z_hack] = ACTIONS(3645),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1414] = {
    [sym_heredoc_content] = STATE(1414),
    [sym__identifier] = ACTIONS(3500),
    [anon_sym_RBRACE] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3502),
    [anon_sym_and] = ACTIONS(3500),
    [anon_sym_or] = ACTIONS(3500),
    [anon_sym_RBRACK] = ACTIONS(3502),
    [anon_sym_DASH_GT] = ACTIONS(3502),
    [anon_sym_PERCENT] = ACTIONS(3500),
    [anon_sym_LT] = ACTIONS(3500),
    [anon_sym_GT] = ACTIONS(3500),
    [anon_sym_LT_LT] = ACTIONS(3500),
    [anon_sym_EQ] = ACTIONS(3500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3502),
    [anon_sym_PLUS_EQ] = ACTIONS(3502),
    [anon_sym_DASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_EQ] = ACTIONS(3502),
    [anon_sym_STAR_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_PERCENT_EQ] = ACTIONS(3502),
    [anon_sym_x_EQ] = ACTIONS(3502),
    [anon_sym_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_CARET_EQ] = ACTIONS(3502),
    [anon_sym_LT_LT_EQ] = ACTIONS(3502),
    [anon_sym_GT_GT_EQ] = ACTIONS(3502),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_DOT] = ACTIONS(3500),
    [anon_sym_STAR_STAR] = ACTIONS(3500),
    [anon_sym_PIPE_PIPE] = ACTIONS(3500),
    [anon_sym_SLASH_SLASH] = ACTIONS(3500),
    [anon_sym_AMP_AMP] = ACTIONS(3500),
    [anon_sym_PIPE] = ACTIONS(3500),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_GT_GT2] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_DOT] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3500),
    [anon_sym_SLASH] = ACTIONS(3500),
    [anon_sym_x] = ACTIONS(3500),
    [anon_sym_EQ_TILDE] = ACTIONS(3502),
    [anon_sym_BANG_TILDE] = ACTIONS(3502),
    [anon_sym_EQ_EQ] = ACTIONS(3502),
    [anon_sym_BANG_EQ] = ACTIONS(3502),
    [anon_sym_eq] = ACTIONS(3500),
    [anon_sym_ne] = ACTIONS(3500),
    [anon_sym_LT_EQ_GT] = ACTIONS(3502),
    [anon_sym_cmp] = ACTIONS(3500),
    [anon_sym_TILDE_TILDE] = ACTIONS(3502),
    [anon_sym_LT_EQ] = ACTIONS(3500),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [anon_sym_lt] = ACTIONS(3500),
    [anon_sym_le] = ACTIONS(3500),
    [anon_sym_ge] = ACTIONS(3500),
    [anon_sym_gt] = ACTIONS(3500),
    [anon_sym_isa] = ACTIONS(3500),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3502),
    [anon_sym_EQ_GT] = ACTIONS(3502),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3500),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1415] = {
    [sym_heredoc_content] = STATE(1415),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1416] = {
    [sym_heredoc_content] = STATE(1416),
    [anon_sym_LBRACE] = ACTIONS(3558),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_COLON] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2917),
    [anon_sym_and] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(3558),
    [anon_sym_RBRACK] = ACTIONS(2917),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2917),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_x_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2917),
    [anon_sym_BANG_TILDE] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_eq] = ACTIONS(2917),
    [anon_sym_ne] = ACTIONS(2917),
    [anon_sym_LT_EQ_GT] = ACTIONS(2917),
    [anon_sym_cmp] = ACTIONS(2917),
    [anon_sym_TILDE_TILDE] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_lt] = ACTIONS(2917),
    [anon_sym_le] = ACTIONS(2917),
    [anon_sym_ge] = ACTIONS(2917),
    [anon_sym_gt] = ACTIONS(2917),
    [anon_sym_isa] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1417] = {
    [sym_heredoc_content] = STATE(1417),
    [aux_sym__term_rightward_repeat1] = STATE(1426),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_COMMA] = ACTIONS(4352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_and] = ACTIONS(3789),
    [anon_sym_or] = ACTIONS(3789),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4320),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4322),
    [anon_sym_PLUS_EQ] = ACTIONS(4322),
    [anon_sym_DASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_EQ] = ACTIONS(4322),
    [anon_sym_STAR_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_PERCENT_EQ] = ACTIONS(4322),
    [anon_sym_x_EQ] = ACTIONS(4322),
    [anon_sym_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_CARET_EQ] = ACTIONS(4322),
    [anon_sym_LT_LT_EQ] = ACTIONS(4322),
    [anon_sym_GT_GT_EQ] = ACTIONS(4322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_DOT] = ACTIONS(4324),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4328),
    [anon_sym_SLASH_SLASH] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4352),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3789),
    [anon_sym___END__] = ACTIONS(3789),
    [anon_sym_EOT] = ACTIONS(3789),
    [sym__PERLY_SEMICOLON] = ACTIONS(3789),
    [sym__ctrl_z_hack] = ACTIONS(3789),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1418] = {
    [sym_heredoc_content] = STATE(1418),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__quotelike_begin] = ACTIONS(4354),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1419] = {
    [sym_heredoc_content] = STATE(1419),
    [anon_sym_COLON] = ACTIONS(4356),
    [anon_sym_SEMI] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3562),
    [anon_sym_and] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3564),
    [anon_sym_LT] = ACTIONS(3564),
    [anon_sym_GT] = ACTIONS(3564),
    [anon_sym_LT_LT] = ACTIONS(3564),
    [anon_sym_EQ] = ACTIONS(3564),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3562),
    [anon_sym_PLUS_EQ] = ACTIONS(3562),
    [anon_sym_DASH_EQ] = ACTIONS(3562),
    [anon_sym_DOT_EQ] = ACTIONS(3562),
    [anon_sym_STAR_EQ] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(3562),
    [anon_sym_PERCENT_EQ] = ACTIONS(3562),
    [anon_sym_x_EQ] = ACTIONS(3562),
    [anon_sym_AMP_EQ] = ACTIONS(3562),
    [anon_sym_PIPE_EQ] = ACTIONS(3562),
    [anon_sym_CARET_EQ] = ACTIONS(3562),
    [anon_sym_LT_LT_EQ] = ACTIONS(3562),
    [anon_sym_GT_GT_EQ] = ACTIONS(3562),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3562),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(3564),
    [anon_sym_STAR_STAR] = ACTIONS(3564),
    [anon_sym_PIPE_PIPE] = ACTIONS(3564),
    [anon_sym_SLASH_SLASH] = ACTIONS(3564),
    [anon_sym_AMP_AMP] = ACTIONS(3564),
    [anon_sym_PIPE] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_GT_GT2] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(3564),
    [anon_sym_DASH] = ACTIONS(3564),
    [anon_sym_DOT] = ACTIONS(3564),
    [anon_sym_STAR] = ACTIONS(3564),
    [anon_sym_SLASH] = ACTIONS(3564),
    [anon_sym_x] = ACTIONS(3564),
    [anon_sym_EQ_TILDE] = ACTIONS(3562),
    [anon_sym_BANG_TILDE] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_eq] = ACTIONS(3562),
    [anon_sym_ne] = ACTIONS(3562),
    [anon_sym_LT_EQ_GT] = ACTIONS(3562),
    [anon_sym_cmp] = ACTIONS(3562),
    [anon_sym_TILDE_TILDE] = ACTIONS(3562),
    [anon_sym_LT_EQ] = ACTIONS(3564),
    [anon_sym_GT_EQ] = ACTIONS(3562),
    [anon_sym_lt] = ACTIONS(3562),
    [anon_sym_le] = ACTIONS(3562),
    [anon_sym_ge] = ACTIONS(3562),
    [anon_sym_gt] = ACTIONS(3562),
    [anon_sym_isa] = ACTIONS(3562),
    [anon_sym_PLUS_PLUS] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_EQ_GT] = ACTIONS(3562),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3562),
    [anon_sym___END__] = ACTIONS(3562),
    [anon_sym_EOT] = ACTIONS(3562),
    [sym__PERLY_SEMICOLON] = ACTIONS(3562),
    [sym__ctrl_z_hack] = ACTIONS(3562),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1420] = {
    [sym_heredoc_content] = STATE(1420),
    [sym__identifier] = ACTIONS(3520),
    [anon_sym_RBRACE] = ACTIONS(3522),
    [anon_sym_COLON] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_COMMA] = ACTIONS(3522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3522),
    [anon_sym_and] = ACTIONS(3520),
    [anon_sym_or] = ACTIONS(3520),
    [anon_sym_RBRACK] = ACTIONS(3522),
    [anon_sym_DASH_GT] = ACTIONS(3522),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3520),
    [anon_sym_GT] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3522),
    [anon_sym_PLUS_EQ] = ACTIONS(3522),
    [anon_sym_DASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_EQ] = ACTIONS(3522),
    [anon_sym_STAR_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_PERCENT_EQ] = ACTIONS(3522),
    [anon_sym_x_EQ] = ACTIONS(3522),
    [anon_sym_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_CARET_EQ] = ACTIONS(3522),
    [anon_sym_LT_LT_EQ] = ACTIONS(3522),
    [anon_sym_GT_GT_EQ] = ACTIONS(3522),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_DOT] = ACTIONS(3520),
    [anon_sym_STAR_STAR] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_SLASH_SLASH] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_GT_GT2] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3520),
    [anon_sym_x] = ACTIONS(3520),
    [anon_sym_EQ_TILDE] = ACTIONS(3522),
    [anon_sym_BANG_TILDE] = ACTIONS(3522),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_eq] = ACTIONS(3520),
    [anon_sym_ne] = ACTIONS(3520),
    [anon_sym_LT_EQ_GT] = ACTIONS(3522),
    [anon_sym_cmp] = ACTIONS(3520),
    [anon_sym_TILDE_TILDE] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3520),
    [anon_sym_GT_EQ] = ACTIONS(3522),
    [anon_sym_lt] = ACTIONS(3520),
    [anon_sym_le] = ACTIONS(3520),
    [anon_sym_ge] = ACTIONS(3520),
    [anon_sym_gt] = ACTIONS(3520),
    [anon_sym_isa] = ACTIONS(3520),
    [anon_sym_PLUS_PLUS] = ACTIONS(3522),
    [anon_sym_DASH_DASH] = ACTIONS(3522),
    [anon_sym_QMARK] = ACTIONS(3522),
    [anon_sym_EQ_GT] = ACTIONS(3522),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3520),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1421] = {
    [sym_heredoc_content] = STATE(1421),
    [anon_sym_COLON] = ACTIONS(4358),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_COMMA] = ACTIONS(3725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3725),
    [anon_sym_and] = ACTIONS(3725),
    [anon_sym_or] = ACTIONS(3725),
    [anon_sym_DASH_GT] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_EQ] = ACTIONS(3727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3725),
    [anon_sym_PLUS_EQ] = ACTIONS(3725),
    [anon_sym_DASH_EQ] = ACTIONS(3725),
    [anon_sym_DOT_EQ] = ACTIONS(3725),
    [anon_sym_STAR_EQ] = ACTIONS(3725),
    [anon_sym_SLASH_EQ] = ACTIONS(3725),
    [anon_sym_PERCENT_EQ] = ACTIONS(3725),
    [anon_sym_x_EQ] = ACTIONS(3725),
    [anon_sym_AMP_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_EQ] = ACTIONS(3725),
    [anon_sym_CARET_EQ] = ACTIONS(3725),
    [anon_sym_LT_LT_EQ] = ACTIONS(3725),
    [anon_sym_GT_GT_EQ] = ACTIONS(3725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3725),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3725),
    [anon_sym_DOT_DOT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_SLASH_SLASH] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3727),
    [anon_sym_GT_GT2] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_SLASH] = ACTIONS(3727),
    [anon_sym_x] = ACTIONS(3727),
    [anon_sym_EQ_TILDE] = ACTIONS(3725),
    [anon_sym_BANG_TILDE] = ACTIONS(3725),
    [anon_sym_EQ_EQ] = ACTIONS(3725),
    [anon_sym_BANG_EQ] = ACTIONS(3725),
    [anon_sym_eq] = ACTIONS(3725),
    [anon_sym_ne] = ACTIONS(3725),
    [anon_sym_LT_EQ_GT] = ACTIONS(3725),
    [anon_sym_cmp] = ACTIONS(3725),
    [anon_sym_TILDE_TILDE] = ACTIONS(3725),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3725),
    [anon_sym_lt] = ACTIONS(3725),
    [anon_sym_le] = ACTIONS(3725),
    [anon_sym_ge] = ACTIONS(3725),
    [anon_sym_gt] = ACTIONS(3725),
    [anon_sym_isa] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3725),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3725),
    [anon_sym___END__] = ACTIONS(3725),
    [anon_sym_EOT] = ACTIONS(3725),
    [sym__PERLY_SEMICOLON] = ACTIONS(3725),
    [sym__ctrl_z_hack] = ACTIONS(3725),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1422] = {
    [sym_heredoc_content] = STATE(1422),
    [anon_sym_LBRACE] = ACTIONS(3544),
    [anon_sym_RBRACE] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3546),
    [anon_sym_SEMI] = ACTIONS(3546),
    [anon_sym_RPAREN] = ACTIONS(3546),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3546),
    [anon_sym_and] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3546),
    [anon_sym_LBRACK] = ACTIONS(3544),
    [anon_sym_RBRACK] = ACTIONS(3546),
    [anon_sym_DASH_GT] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3548),
    [anon_sym_GT] = ACTIONS(3548),
    [anon_sym_LT_LT] = ACTIONS(3548),
    [anon_sym_EQ] = ACTIONS(3548),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3546),
    [anon_sym_PLUS_EQ] = ACTIONS(3546),
    [anon_sym_DASH_EQ] = ACTIONS(3546),
    [anon_sym_DOT_EQ] = ACTIONS(3546),
    [anon_sym_STAR_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_PERCENT_EQ] = ACTIONS(3546),
    [anon_sym_x_EQ] = ACTIONS(3546),
    [anon_sym_AMP_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_CARET_EQ] = ACTIONS(3546),
    [anon_sym_LT_LT_EQ] = ACTIONS(3546),
    [anon_sym_GT_GT_EQ] = ACTIONS(3546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_DOT_DOT] = ACTIONS(3548),
    [anon_sym_STAR_STAR] = ACTIONS(3548),
    [anon_sym_PIPE_PIPE] = ACTIONS(3548),
    [anon_sym_SLASH_SLASH] = ACTIONS(3548),
    [anon_sym_AMP_AMP] = ACTIONS(3548),
    [anon_sym_PIPE] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_GT_GT2] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_DOT] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_SLASH] = ACTIONS(3548),
    [anon_sym_x] = ACTIONS(3548),
    [anon_sym_EQ_TILDE] = ACTIONS(3546),
    [anon_sym_BANG_TILDE] = ACTIONS(3546),
    [anon_sym_EQ_EQ] = ACTIONS(3546),
    [anon_sym_BANG_EQ] = ACTIONS(3546),
    [anon_sym_eq] = ACTIONS(3546),
    [anon_sym_ne] = ACTIONS(3546),
    [anon_sym_LT_EQ_GT] = ACTIONS(3546),
    [anon_sym_cmp] = ACTIONS(3546),
    [anon_sym_TILDE_TILDE] = ACTIONS(3546),
    [anon_sym_LT_EQ] = ACTIONS(3548),
    [anon_sym_GT_EQ] = ACTIONS(3546),
    [anon_sym_lt] = ACTIONS(3546),
    [anon_sym_le] = ACTIONS(3546),
    [anon_sym_ge] = ACTIONS(3546),
    [anon_sym_gt] = ACTIONS(3546),
    [anon_sym_isa] = ACTIONS(3546),
    [anon_sym_PLUS_PLUS] = ACTIONS(3546),
    [anon_sym_DASH_DASH] = ACTIONS(3546),
    [anon_sym_QMARK] = ACTIONS(3546),
    [anon_sym_EQ_GT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1423] = {
    [sym_heredoc_content] = STATE(1423),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__quotelike_begin] = ACTIONS(4360),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1424] = {
    [sym_heredoc_content] = STATE(1424),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__quotelike_begin] = ACTIONS(4362),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1425] = {
    [sym_heredoc_content] = STATE(1425),
    [aux_sym__term_rightward_repeat1] = STATE(1425),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_and] = ACTIONS(3606),
    [anon_sym_or] = ACTIONS(3606),
    [anon_sym_DASH_GT] = ACTIONS(3606),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_LT_LT] = ACTIONS(3611),
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3606),
    [anon_sym_PLUS_EQ] = ACTIONS(3606),
    [anon_sym_DASH_EQ] = ACTIONS(3606),
    [anon_sym_DOT_EQ] = ACTIONS(3606),
    [anon_sym_STAR_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_PERCENT_EQ] = ACTIONS(3606),
    [anon_sym_x_EQ] = ACTIONS(3606),
    [anon_sym_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_CARET_EQ] = ACTIONS(3606),
    [anon_sym_LT_LT_EQ] = ACTIONS(3606),
    [anon_sym_GT_GT_EQ] = ACTIONS(3606),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_DOT_DOT] = ACTIONS(3611),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(3611),
    [anon_sym_SLASH_SLASH] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_GT_GT2] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_x] = ACTIONS(3611),
    [anon_sym_EQ_TILDE] = ACTIONS(3606),
    [anon_sym_BANG_TILDE] = ACTIONS(3606),
    [anon_sym_EQ_EQ] = ACTIONS(3606),
    [anon_sym_BANG_EQ] = ACTIONS(3606),
    [anon_sym_eq] = ACTIONS(3606),
    [anon_sym_ne] = ACTIONS(3606),
    [anon_sym_LT_EQ_GT] = ACTIONS(3606),
    [anon_sym_cmp] = ACTIONS(3606),
    [anon_sym_TILDE_TILDE] = ACTIONS(3606),
    [anon_sym_LT_EQ] = ACTIONS(3611),
    [anon_sym_GT_EQ] = ACTIONS(3606),
    [anon_sym_lt] = ACTIONS(3606),
    [anon_sym_le] = ACTIONS(3606),
    [anon_sym_ge] = ACTIONS(3606),
    [anon_sym_gt] = ACTIONS(3606),
    [anon_sym_isa] = ACTIONS(3606),
    [anon_sym_PLUS_PLUS] = ACTIONS(3606),
    [anon_sym_DASH_DASH] = ACTIONS(3606),
    [anon_sym_QMARK] = ACTIONS(3606),
    [anon_sym_EQ_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3606),
    [anon_sym___END__] = ACTIONS(3606),
    [anon_sym_EOT] = ACTIONS(3606),
    [sym__PERLY_SEMICOLON] = ACTIONS(3606),
    [sym__ctrl_z_hack] = ACTIONS(3606),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1426] = {
    [sym_heredoc_content] = STATE(1426),
    [aux_sym__term_rightward_repeat1] = STATE(1425),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym_COMMA] = ACTIONS(4367),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3623),
    [anon_sym_and] = ACTIONS(3623),
    [anon_sym_or] = ACTIONS(3623),
    [anon_sym_DASH_GT] = ACTIONS(3623),
    [anon_sym_PERCENT] = ACTIONS(3627),
    [anon_sym_LT] = ACTIONS(3627),
    [anon_sym_GT] = ACTIONS(3627),
    [anon_sym_LT_LT] = ACTIONS(3627),
    [anon_sym_EQ] = ACTIONS(3627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3623),
    [anon_sym_PLUS_EQ] = ACTIONS(3623),
    [anon_sym_DASH_EQ] = ACTIONS(3623),
    [anon_sym_DOT_EQ] = ACTIONS(3623),
    [anon_sym_STAR_EQ] = ACTIONS(3623),
    [anon_sym_SLASH_EQ] = ACTIONS(3623),
    [anon_sym_PERCENT_EQ] = ACTIONS(3623),
    [anon_sym_x_EQ] = ACTIONS(3623),
    [anon_sym_AMP_EQ] = ACTIONS(3623),
    [anon_sym_PIPE_EQ] = ACTIONS(3623),
    [anon_sym_CARET_EQ] = ACTIONS(3623),
    [anon_sym_LT_LT_EQ] = ACTIONS(3623),
    [anon_sym_GT_GT_EQ] = ACTIONS(3623),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3623),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3623),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3623),
    [anon_sym_DOT_DOT] = ACTIONS(3627),
    [anon_sym_STAR_STAR] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3627),
    [anon_sym_SLASH_SLASH] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_PIPE] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_GT_GT2] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DOT] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(3627),
    [anon_sym_x] = ACTIONS(3627),
    [anon_sym_EQ_TILDE] = ACTIONS(3623),
    [anon_sym_BANG_TILDE] = ACTIONS(3623),
    [anon_sym_EQ_EQ] = ACTIONS(3623),
    [anon_sym_BANG_EQ] = ACTIONS(3623),
    [anon_sym_eq] = ACTIONS(3623),
    [anon_sym_ne] = ACTIONS(3623),
    [anon_sym_LT_EQ_GT] = ACTIONS(3623),
    [anon_sym_cmp] = ACTIONS(3623),
    [anon_sym_TILDE_TILDE] = ACTIONS(3623),
    [anon_sym_LT_EQ] = ACTIONS(3627),
    [anon_sym_GT_EQ] = ACTIONS(3623),
    [anon_sym_lt] = ACTIONS(3623),
    [anon_sym_le] = ACTIONS(3623),
    [anon_sym_ge] = ACTIONS(3623),
    [anon_sym_gt] = ACTIONS(3623),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_QMARK] = ACTIONS(3623),
    [anon_sym_EQ_GT] = ACTIONS(4367),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3623),
    [anon_sym___END__] = ACTIONS(3623),
    [anon_sym_EOT] = ACTIONS(3623),
    [sym__PERLY_SEMICOLON] = ACTIONS(3623),
    [sym__ctrl_z_hack] = ACTIONS(3623),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1427] = {
    [sym_heredoc_content] = STATE(1427),
    [sym__identifier] = ACTIONS(3410),
    [anon_sym_RBRACE] = ACTIONS(3408),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym_RPAREN] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_and] = ACTIONS(3410),
    [anon_sym_or] = ACTIONS(3410),
    [anon_sym_RBRACK] = ACTIONS(3408),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3410),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1428] = {
    [sym_heredoc_content] = STATE(1428),
    [anon_sym_RBRACE] = ACTIONS(3452),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(3452),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_RBRACK] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1429] = {
    [sym_attribute] = STATE(1651),
    [sym_attribute_name] = STATE(1620),
    [sym_heredoc_content] = STATE(1429),
    [aux_sym_attrlist_repeat1] = STATE(1470),
    [sym__identifier] = ACTIONS(4369),
    [anon_sym_COLON] = ACTIONS(4371),
    [anon_sym_SEMI] = ACTIONS(3416),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3416),
    [anon_sym_DASH_GT] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(3418),
    [anon_sym_GT] = ACTIONS(3418),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3416),
    [anon_sym_PLUS_EQ] = ACTIONS(3416),
    [anon_sym_DASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_EQ] = ACTIONS(3416),
    [anon_sym_STAR_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_PERCENT_EQ] = ACTIONS(3416),
    [anon_sym_x_EQ] = ACTIONS(3416),
    [anon_sym_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_CARET_EQ] = ACTIONS(3416),
    [anon_sym_LT_LT_EQ] = ACTIONS(3416),
    [anon_sym_GT_GT_EQ] = ACTIONS(3416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_DOT] = ACTIONS(3418),
    [anon_sym_STAR_STAR] = ACTIONS(3418),
    [anon_sym_PIPE_PIPE] = ACTIONS(3418),
    [anon_sym_SLASH_SLASH] = ACTIONS(3418),
    [anon_sym_AMP_AMP] = ACTIONS(3418),
    [anon_sym_PIPE] = ACTIONS(3418),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_GT_GT2] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_DOT] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3418),
    [anon_sym_SLASH] = ACTIONS(3418),
    [anon_sym_x] = ACTIONS(3418),
    [anon_sym_EQ_TILDE] = ACTIONS(3416),
    [anon_sym_BANG_TILDE] = ACTIONS(3416),
    [anon_sym_EQ_EQ] = ACTIONS(3416),
    [anon_sym_BANG_EQ] = ACTIONS(3416),
    [anon_sym_eq] = ACTIONS(3418),
    [anon_sym_ne] = ACTIONS(3418),
    [anon_sym_LT_EQ_GT] = ACTIONS(3416),
    [anon_sym_cmp] = ACTIONS(3418),
    [anon_sym_TILDE_TILDE] = ACTIONS(3416),
    [anon_sym_LT_EQ] = ACTIONS(3418),
    [anon_sym_GT_EQ] = ACTIONS(3416),
    [anon_sym_lt] = ACTIONS(3418),
    [anon_sym_le] = ACTIONS(3418),
    [anon_sym_ge] = ACTIONS(3418),
    [anon_sym_gt] = ACTIONS(3418),
    [anon_sym_isa] = ACTIONS(3418),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3416),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4369),
    [sym__PERLY_SEMICOLON] = ACTIONS(3416),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1430] = {
    [sym_heredoc_content] = STATE(1430),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1431] = {
    [sym_heredoc_content] = STATE(1431),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3921),
    [anon_sym_and] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3921),
    [anon_sym_PLUS_EQ] = ACTIONS(3921),
    [anon_sym_DASH_EQ] = ACTIONS(3921),
    [anon_sym_DOT_EQ] = ACTIONS(3921),
    [anon_sym_STAR_EQ] = ACTIONS(3921),
    [anon_sym_SLASH_EQ] = ACTIONS(3921),
    [anon_sym_PERCENT_EQ] = ACTIONS(3921),
    [anon_sym_x_EQ] = ACTIONS(3921),
    [anon_sym_AMP_EQ] = ACTIONS(3921),
    [anon_sym_PIPE_EQ] = ACTIONS(3921),
    [anon_sym_CARET_EQ] = ACTIONS(3921),
    [anon_sym_LT_LT_EQ] = ACTIONS(3921),
    [anon_sym_GT_GT_EQ] = ACTIONS(3921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3921),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3921),
    [anon_sym_DOT_DOT] = ACTIONS(3923),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_GT_GT2] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DOT] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(3923),
    [anon_sym_SLASH] = ACTIONS(3923),
    [anon_sym_x] = ACTIONS(3923),
    [anon_sym_EQ_TILDE] = ACTIONS(3921),
    [anon_sym_BANG_TILDE] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_eq] = ACTIONS(3921),
    [anon_sym_ne] = ACTIONS(3921),
    [anon_sym_LT_EQ_GT] = ACTIONS(3921),
    [anon_sym_cmp] = ACTIONS(3921),
    [anon_sym_TILDE_TILDE] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3923),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_lt] = ACTIONS(3921),
    [anon_sym_le] = ACTIONS(3921),
    [anon_sym_ge] = ACTIONS(3921),
    [anon_sym_gt] = ACTIONS(3921),
    [anon_sym_isa] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_EQ_GT] = ACTIONS(3921),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3921),
    [anon_sym___END__] = ACTIONS(3921),
    [anon_sym_EOT] = ACTIONS(3921),
    [sym__PERLY_SEMICOLON] = ACTIONS(3921),
    [sym__ctrl_z_hack] = ACTIONS(3921),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1432] = {
    [sym_heredoc_content] = STATE(1432),
    [anon_sym_SEMI] = ACTIONS(4004),
    [anon_sym_COMMA] = ACTIONS(4004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_and] = ACTIONS(4004),
    [anon_sym_or] = ACTIONS(4004),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4320),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4322),
    [anon_sym_PLUS_EQ] = ACTIONS(4322),
    [anon_sym_DASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_EQ] = ACTIONS(4322),
    [anon_sym_STAR_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_PERCENT_EQ] = ACTIONS(4322),
    [anon_sym_x_EQ] = ACTIONS(4322),
    [anon_sym_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_CARET_EQ] = ACTIONS(4322),
    [anon_sym_LT_LT_EQ] = ACTIONS(4322),
    [anon_sym_GT_GT_EQ] = ACTIONS(4322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_DOT] = ACTIONS(4324),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4328),
    [anon_sym_SLASH_SLASH] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4004),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4004),
    [anon_sym___END__] = ACTIONS(4004),
    [anon_sym_EOT] = ACTIONS(4004),
    [sym__PERLY_SEMICOLON] = ACTIONS(4004),
    [sym__ctrl_z_hack] = ACTIONS(4004),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1433] = {
    [sym_heredoc_content] = STATE(1433),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_x_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4064),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_SLASH_SLASH] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_eq] = ACTIONS(4062),
    [anon_sym_ne] = ACTIONS(4062),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_cmp] = ACTIONS(4062),
    [anon_sym_TILDE_TILDE] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_lt] = ACTIONS(4062),
    [anon_sym_le] = ACTIONS(4062),
    [anon_sym_ge] = ACTIONS(4062),
    [anon_sym_gt] = ACTIONS(4062),
    [anon_sym_isa] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4062),
    [anon_sym___END__] = ACTIONS(4062),
    [anon_sym_EOT] = ACTIONS(4062),
    [sym__PERLY_SEMICOLON] = ACTIONS(4062),
    [sym__ctrl_z_hack] = ACTIONS(4062),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1434] = {
    [sym_heredoc_content] = STATE(1434),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_COMMA] = ACTIONS(4066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4066),
    [anon_sym_and] = ACTIONS(4066),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4068),
    [anon_sym_GT] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4066),
    [anon_sym_DASH_EQ] = ACTIONS(4066),
    [anon_sym_DOT_EQ] = ACTIONS(4066),
    [anon_sym_STAR_EQ] = ACTIONS(4066),
    [anon_sym_SLASH_EQ] = ACTIONS(4066),
    [anon_sym_PERCENT_EQ] = ACTIONS(4066),
    [anon_sym_x_EQ] = ACTIONS(4066),
    [anon_sym_AMP_EQ] = ACTIONS(4066),
    [anon_sym_PIPE_EQ] = ACTIONS(4066),
    [anon_sym_CARET_EQ] = ACTIONS(4066),
    [anon_sym_LT_LT_EQ] = ACTIONS(4066),
    [anon_sym_GT_GT_EQ] = ACTIONS(4066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4066),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4066),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_SLASH_SLASH] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4068),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4066),
    [anon_sym_BANG_EQ] = ACTIONS(4066),
    [anon_sym_eq] = ACTIONS(4066),
    [anon_sym_ne] = ACTIONS(4066),
    [anon_sym_LT_EQ_GT] = ACTIONS(4066),
    [anon_sym_cmp] = ACTIONS(4066),
    [anon_sym_TILDE_TILDE] = ACTIONS(4066),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4066),
    [anon_sym_lt] = ACTIONS(4066),
    [anon_sym_le] = ACTIONS(4066),
    [anon_sym_ge] = ACTIONS(4066),
    [anon_sym_gt] = ACTIONS(4066),
    [anon_sym_isa] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4066),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4066),
    [anon_sym___END__] = ACTIONS(4066),
    [anon_sym_EOT] = ACTIONS(4066),
    [sym__PERLY_SEMICOLON] = ACTIONS(4066),
    [sym__ctrl_z_hack] = ACTIONS(4066),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1435] = {
    [sym_heredoc_content] = STATE(1435),
    [anon_sym_SEMI] = ACTIONS(4088),
    [anon_sym_COMMA] = ACTIONS(4088),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4088),
    [anon_sym_and] = ACTIONS(4088),
    [anon_sym_or] = ACTIONS(4088),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4090),
    [anon_sym_GT] = ACTIONS(4090),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4090),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4088),
    [anon_sym_PLUS_EQ] = ACTIONS(4088),
    [anon_sym_DASH_EQ] = ACTIONS(4088),
    [anon_sym_DOT_EQ] = ACTIONS(4088),
    [anon_sym_STAR_EQ] = ACTIONS(4088),
    [anon_sym_SLASH_EQ] = ACTIONS(4088),
    [anon_sym_PERCENT_EQ] = ACTIONS(4088),
    [anon_sym_x_EQ] = ACTIONS(4088),
    [anon_sym_AMP_EQ] = ACTIONS(4088),
    [anon_sym_PIPE_EQ] = ACTIONS(4088),
    [anon_sym_CARET_EQ] = ACTIONS(4088),
    [anon_sym_LT_LT_EQ] = ACTIONS(4088),
    [anon_sym_GT_GT_EQ] = ACTIONS(4088),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4088),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4088),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4090),
    [anon_sym_SLASH_SLASH] = ACTIONS(4090),
    [anon_sym_AMP_AMP] = ACTIONS(4090),
    [anon_sym_PIPE] = ACTIONS(4090),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4088),
    [anon_sym_BANG_EQ] = ACTIONS(4088),
    [anon_sym_eq] = ACTIONS(4088),
    [anon_sym_ne] = ACTIONS(4088),
    [anon_sym_LT_EQ_GT] = ACTIONS(4088),
    [anon_sym_cmp] = ACTIONS(4088),
    [anon_sym_TILDE_TILDE] = ACTIONS(4088),
    [anon_sym_LT_EQ] = ACTIONS(4090),
    [anon_sym_GT_EQ] = ACTIONS(4088),
    [anon_sym_lt] = ACTIONS(4088),
    [anon_sym_le] = ACTIONS(4088),
    [anon_sym_ge] = ACTIONS(4088),
    [anon_sym_gt] = ACTIONS(4088),
    [anon_sym_isa] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_EQ_GT] = ACTIONS(4088),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4088),
    [anon_sym___END__] = ACTIONS(4088),
    [anon_sym_EOT] = ACTIONS(4088),
    [sym__PERLY_SEMICOLON] = ACTIONS(4088),
    [sym__ctrl_z_hack] = ACTIONS(4088),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1436] = {
    [sym_heredoc_content] = STATE(1436),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_and] = ACTIONS(4230),
    [anon_sym_or] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4320),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4322),
    [anon_sym_PLUS_EQ] = ACTIONS(4322),
    [anon_sym_DASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_EQ] = ACTIONS(4322),
    [anon_sym_STAR_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_PERCENT_EQ] = ACTIONS(4322),
    [anon_sym_x_EQ] = ACTIONS(4322),
    [anon_sym_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_CARET_EQ] = ACTIONS(4322),
    [anon_sym_LT_LT_EQ] = ACTIONS(4322),
    [anon_sym_GT_GT_EQ] = ACTIONS(4322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_DOT] = ACTIONS(4324),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4328),
    [anon_sym_SLASH_SLASH] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4230),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4230),
    [anon_sym___END__] = ACTIONS(4230),
    [anon_sym_EOT] = ACTIONS(4230),
    [sym__PERLY_SEMICOLON] = ACTIONS(4230),
    [sym__ctrl_z_hack] = ACTIONS(4230),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1437] = {
    [sym_heredoc_content] = STATE(1437),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_RPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_and] = ACTIONS(3783),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_RBRACK] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3783),
    [anon_sym_LT] = ACTIONS(3783),
    [anon_sym_GT] = ACTIONS(3783),
    [anon_sym_LT_LT] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(3783),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_DOT_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_x_EQ] = ACTIONS(3783),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT] = ACTIONS(3783),
    [anon_sym_STAR_STAR] = ACTIONS(3783),
    [anon_sym_PIPE_PIPE] = ACTIONS(3783),
    [anon_sym_SLASH_SLASH] = ACTIONS(3783),
    [anon_sym_AMP_AMP] = ACTIONS(3783),
    [anon_sym_PIPE] = ACTIONS(3783),
    [anon_sym_AMP] = ACTIONS(3783),
    [anon_sym_GT_GT2] = ACTIONS(3783),
    [anon_sym_PLUS] = ACTIONS(3783),
    [anon_sym_DASH] = ACTIONS(3783),
    [anon_sym_DOT] = ACTIONS(3783),
    [anon_sym_STAR] = ACTIONS(3783),
    [anon_sym_SLASH] = ACTIONS(3783),
    [anon_sym_x] = ACTIONS(3783),
    [anon_sym_EQ_TILDE] = ACTIONS(3781),
    [anon_sym_BANG_TILDE] = ACTIONS(3781),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_eq] = ACTIONS(3781),
    [anon_sym_ne] = ACTIONS(3783),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_cmp] = ACTIONS(3783),
    [anon_sym_TILDE_TILDE] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3783),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_lt] = ACTIONS(3783),
    [anon_sym_le] = ACTIONS(3783),
    [anon_sym_ge] = ACTIONS(3783),
    [anon_sym_gt] = ACTIONS(3783),
    [anon_sym_isa] = ACTIONS(3783),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_EQ_GT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4373),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1438] = {
    [sym_heredoc_content] = STATE(1438),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_DOT_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_x_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_SLASH_SLASH] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4246),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_eq] = ACTIONS(4246),
    [anon_sym_ne] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_cmp] = ACTIONS(4246),
    [anon_sym_TILDE_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_lt] = ACTIONS(4246),
    [anon_sym_le] = ACTIONS(4246),
    [anon_sym_ge] = ACTIONS(4246),
    [anon_sym_gt] = ACTIONS(4246),
    [anon_sym_isa] = ACTIONS(4246),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_EOT] = ACTIONS(4246),
    [sym__PERLY_SEMICOLON] = ACTIONS(4246),
    [sym__ctrl_z_hack] = ACTIONS(4246),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1439] = {
    [sym_heredoc_content] = STATE(1439),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_RPAREN] = ACTIONS(3765),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3765),
    [anon_sym_and] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3765),
    [anon_sym_RBRACK] = ACTIONS(3765),
    [anon_sym_DASH_GT] = ACTIONS(3765),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3767),
    [anon_sym_GT] = ACTIONS(3767),
    [anon_sym_LT_LT] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3767),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3765),
    [anon_sym_PLUS_EQ] = ACTIONS(3765),
    [anon_sym_DASH_EQ] = ACTIONS(3765),
    [anon_sym_DOT_EQ] = ACTIONS(3765),
    [anon_sym_STAR_EQ] = ACTIONS(3765),
    [anon_sym_SLASH_EQ] = ACTIONS(3765),
    [anon_sym_PERCENT_EQ] = ACTIONS(3765),
    [anon_sym_x_EQ] = ACTIONS(3767),
    [anon_sym_AMP_EQ] = ACTIONS(3765),
    [anon_sym_PIPE_EQ] = ACTIONS(3765),
    [anon_sym_CARET_EQ] = ACTIONS(3765),
    [anon_sym_LT_LT_EQ] = ACTIONS(3765),
    [anon_sym_GT_GT_EQ] = ACTIONS(3765),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3765),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3765),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3765),
    [anon_sym_DOT_DOT] = ACTIONS(3767),
    [anon_sym_STAR_STAR] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_SLASH_SLASH] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(3767),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_GT_GT2] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3767),
    [anon_sym_SLASH] = ACTIONS(3767),
    [anon_sym_x] = ACTIONS(3767),
    [anon_sym_EQ_TILDE] = ACTIONS(3765),
    [anon_sym_BANG_TILDE] = ACTIONS(3765),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_eq] = ACTIONS(3765),
    [anon_sym_ne] = ACTIONS(3767),
    [anon_sym_LT_EQ_GT] = ACTIONS(3765),
    [anon_sym_cmp] = ACTIONS(3767),
    [anon_sym_TILDE_TILDE] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3767),
    [anon_sym_GT_EQ] = ACTIONS(3765),
    [anon_sym_lt] = ACTIONS(3767),
    [anon_sym_le] = ACTIONS(3767),
    [anon_sym_ge] = ACTIONS(3767),
    [anon_sym_gt] = ACTIONS(3767),
    [anon_sym_isa] = ACTIONS(3767),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_QMARK] = ACTIONS(3765),
    [anon_sym_EQ_GT] = ACTIONS(3765),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4375),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1440] = {
    [sym_heredoc_content] = STATE(1440),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4216),
    [anon_sym_GT] = ACTIONS(4216),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4216),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_DOT_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_x_EQ] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_DOT_DOT] = ACTIONS(4216),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_SLASH_SLASH] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_PIPE] = ACTIONS(4216),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4214),
    [anon_sym_eq] = ACTIONS(4214),
    [anon_sym_ne] = ACTIONS(4214),
    [anon_sym_LT_EQ_GT] = ACTIONS(4214),
    [anon_sym_cmp] = ACTIONS(4214),
    [anon_sym_TILDE_TILDE] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(4216),
    [anon_sym_GT_EQ] = ACTIONS(4214),
    [anon_sym_lt] = ACTIONS(4214),
    [anon_sym_le] = ACTIONS(4214),
    [anon_sym_ge] = ACTIONS(4214),
    [anon_sym_gt] = ACTIONS(4214),
    [anon_sym_isa] = ACTIONS(4214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4214),
    [anon_sym___END__] = ACTIONS(4214),
    [anon_sym_EOT] = ACTIONS(4214),
    [sym__PERLY_SEMICOLON] = ACTIONS(4214),
    [sym__ctrl_z_hack] = ACTIONS(4214),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1441] = {
    [sym_heredoc_content] = STATE(1441),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_and] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(4377),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_EQ] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_x_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2936),
    [anon_sym_BANG_TILDE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_eq] = ACTIONS(2936),
    [anon_sym_ne] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_cmp] = ACTIONS(2936),
    [anon_sym_TILDE_TILDE] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_lt] = ACTIONS(2936),
    [anon_sym_le] = ACTIONS(2936),
    [anon_sym_ge] = ACTIONS(2936),
    [anon_sym_gt] = ACTIONS(2936),
    [anon_sym_isa] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1442] = {
    [sym_heredoc_content] = STATE(1442),
    [anon_sym_RBRACE] = ACTIONS(3803),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_SEMI] = ACTIONS(3803),
    [anon_sym_RPAREN] = ACTIONS(3803),
    [anon_sym_COMMA] = ACTIONS(3803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3803),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_or] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(4379),
    [anon_sym_RBRACK] = ACTIONS(3803),
    [anon_sym_DASH_GT] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3805),
    [anon_sym_LT_LT] = ACTIONS(3805),
    [anon_sym_EQ] = ACTIONS(3805),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3803),
    [anon_sym_PLUS_EQ] = ACTIONS(3803),
    [anon_sym_DASH_EQ] = ACTIONS(3803),
    [anon_sym_DOT_EQ] = ACTIONS(3803),
    [anon_sym_STAR_EQ] = ACTIONS(3803),
    [anon_sym_SLASH_EQ] = ACTIONS(3803),
    [anon_sym_PERCENT_EQ] = ACTIONS(3803),
    [anon_sym_x_EQ] = ACTIONS(3803),
    [anon_sym_AMP_EQ] = ACTIONS(3803),
    [anon_sym_PIPE_EQ] = ACTIONS(3803),
    [anon_sym_CARET_EQ] = ACTIONS(3803),
    [anon_sym_LT_LT_EQ] = ACTIONS(3803),
    [anon_sym_GT_GT_EQ] = ACTIONS(3803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3803),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3803),
    [anon_sym_DOT_DOT] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_SLASH_SLASH] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3805),
    [anon_sym_GT_GT2] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3805),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_SLASH] = ACTIONS(3805),
    [anon_sym_x] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3803),
    [anon_sym_BANG_TILDE] = ACTIONS(3803),
    [anon_sym_EQ_EQ] = ACTIONS(3803),
    [anon_sym_BANG_EQ] = ACTIONS(3803),
    [anon_sym_eq] = ACTIONS(3803),
    [anon_sym_ne] = ACTIONS(3803),
    [anon_sym_LT_EQ_GT] = ACTIONS(3803),
    [anon_sym_cmp] = ACTIONS(3803),
    [anon_sym_TILDE_TILDE] = ACTIONS(3803),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_GT_EQ] = ACTIONS(3803),
    [anon_sym_lt] = ACTIONS(3803),
    [anon_sym_le] = ACTIONS(3803),
    [anon_sym_ge] = ACTIONS(3803),
    [anon_sym_gt] = ACTIONS(3803),
    [anon_sym_isa] = ACTIONS(3803),
    [anon_sym_PLUS_PLUS] = ACTIONS(3803),
    [anon_sym_DASH_DASH] = ACTIONS(3803),
    [anon_sym_QMARK] = ACTIONS(3803),
    [anon_sym_EQ_GT] = ACTIONS(3803),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1443] = {
    [sym_heredoc_content] = STATE(1443),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4048),
    [anon_sym_and] = ACTIONS(4048),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_DASH_GT] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4048),
    [anon_sym_PLUS_EQ] = ACTIONS(4048),
    [anon_sym_DASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_EQ] = ACTIONS(4048),
    [anon_sym_STAR_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_PERCENT_EQ] = ACTIONS(4048),
    [anon_sym_x_EQ] = ACTIONS(4048),
    [anon_sym_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_CARET_EQ] = ACTIONS(4048),
    [anon_sym_LT_LT_EQ] = ACTIONS(4048),
    [anon_sym_GT_GT_EQ] = ACTIONS(4048),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4052),
    [anon_sym_STAR_STAR] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_SLASH_SLASH] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_GT_GT2] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_x] = ACTIONS(4052),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_EQ_EQ] = ACTIONS(4048),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_eq] = ACTIONS(4048),
    [anon_sym_ne] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_cmp] = ACTIONS(4048),
    [anon_sym_TILDE_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4052),
    [anon_sym_GT_EQ] = ACTIONS(4048),
    [anon_sym_lt] = ACTIONS(4048),
    [anon_sym_le] = ACTIONS(4048),
    [anon_sym_ge] = ACTIONS(4048),
    [anon_sym_gt] = ACTIONS(4048),
    [anon_sym_isa] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4048),
    [anon_sym_DASH_DASH] = ACTIONS(4048),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4381),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4048),
    [anon_sym___END__] = ACTIONS(4048),
    [anon_sym_EOT] = ACTIONS(4048),
    [sym__PERLY_SEMICOLON] = ACTIONS(4048),
    [sym__ctrl_z_hack] = ACTIONS(4048),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1444] = {
    [sym_heredoc_content] = STATE(1444),
    [anon_sym_RBRACE] = ACTIONS(3777),
    [anon_sym_COLON] = ACTIONS(3777),
    [anon_sym_SEMI] = ACTIONS(3777),
    [anon_sym_RPAREN] = ACTIONS(3777),
    [anon_sym_COMMA] = ACTIONS(3777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3777),
    [anon_sym_and] = ACTIONS(3777),
    [anon_sym_or] = ACTIONS(3777),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(3777),
    [anon_sym_DASH_GT] = ACTIONS(3777),
    [anon_sym_PERCENT] = ACTIONS(3779),
    [anon_sym_LT] = ACTIONS(3779),
    [anon_sym_GT] = ACTIONS(3779),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_EQ] = ACTIONS(3779),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3777),
    [anon_sym_PLUS_EQ] = ACTIONS(3777),
    [anon_sym_DASH_EQ] = ACTIONS(3777),
    [anon_sym_DOT_EQ] = ACTIONS(3777),
    [anon_sym_STAR_EQ] = ACTIONS(3777),
    [anon_sym_SLASH_EQ] = ACTIONS(3777),
    [anon_sym_PERCENT_EQ] = ACTIONS(3777),
    [anon_sym_x_EQ] = ACTIONS(3777),
    [anon_sym_AMP_EQ] = ACTIONS(3777),
    [anon_sym_PIPE_EQ] = ACTIONS(3777),
    [anon_sym_CARET_EQ] = ACTIONS(3777),
    [anon_sym_LT_LT_EQ] = ACTIONS(3777),
    [anon_sym_GT_GT_EQ] = ACTIONS(3777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3777),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3777),
    [anon_sym_DOT_DOT] = ACTIONS(3779),
    [anon_sym_STAR_STAR] = ACTIONS(3779),
    [anon_sym_PIPE_PIPE] = ACTIONS(3779),
    [anon_sym_SLASH_SLASH] = ACTIONS(3779),
    [anon_sym_AMP_AMP] = ACTIONS(3779),
    [anon_sym_PIPE] = ACTIONS(3779),
    [anon_sym_AMP] = ACTIONS(3779),
    [anon_sym_GT_GT2] = ACTIONS(3779),
    [anon_sym_PLUS] = ACTIONS(3779),
    [anon_sym_DASH] = ACTIONS(3779),
    [anon_sym_DOT] = ACTIONS(3779),
    [anon_sym_STAR] = ACTIONS(3779),
    [anon_sym_SLASH] = ACTIONS(3779),
    [anon_sym_x] = ACTIONS(3779),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_EQ_EQ] = ACTIONS(3777),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_eq] = ACTIONS(3777),
    [anon_sym_ne] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_cmp] = ACTIONS(3777),
    [anon_sym_TILDE_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3779),
    [anon_sym_GT_EQ] = ACTIONS(3777),
    [anon_sym_lt] = ACTIONS(3777),
    [anon_sym_le] = ACTIONS(3777),
    [anon_sym_ge] = ACTIONS(3777),
    [anon_sym_gt] = ACTIONS(3777),
    [anon_sym_isa] = ACTIONS(3777),
    [anon_sym_PLUS_PLUS] = ACTIONS(3777),
    [anon_sym_DASH_DASH] = ACTIONS(3777),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_EQ_GT] = ACTIONS(3777),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1445] = {
    [sym_heredoc_content] = STATE(1445),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3811),
    [anon_sym_SEMI] = ACTIONS(3811),
    [anon_sym_RPAREN] = ACTIONS(3811),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3811),
    [anon_sym_and] = ACTIONS(3811),
    [anon_sym_or] = ACTIONS(3811),
    [anon_sym_LBRACK] = ACTIONS(3811),
    [anon_sym_RBRACK] = ACTIONS(3811),
    [anon_sym_DASH_GT] = ACTIONS(3811),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_LT] = ACTIONS(3813),
    [anon_sym_GT] = ACTIONS(3813),
    [anon_sym_LT_LT] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3811),
    [anon_sym_PLUS_EQ] = ACTIONS(3811),
    [anon_sym_DASH_EQ] = ACTIONS(3811),
    [anon_sym_DOT_EQ] = ACTIONS(3811),
    [anon_sym_STAR_EQ] = ACTIONS(3811),
    [anon_sym_SLASH_EQ] = ACTIONS(3811),
    [anon_sym_PERCENT_EQ] = ACTIONS(3811),
    [anon_sym_x_EQ] = ACTIONS(3811),
    [anon_sym_AMP_EQ] = ACTIONS(3811),
    [anon_sym_PIPE_EQ] = ACTIONS(3811),
    [anon_sym_CARET_EQ] = ACTIONS(3811),
    [anon_sym_LT_LT_EQ] = ACTIONS(3811),
    [anon_sym_GT_GT_EQ] = ACTIONS(3811),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3811),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3811),
    [anon_sym_DOT_DOT] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_PIPE] = ACTIONS(3813),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_GT_GT2] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_SLASH] = ACTIONS(3813),
    [anon_sym_x] = ACTIONS(3813),
    [anon_sym_EQ_TILDE] = ACTIONS(3811),
    [anon_sym_BANG_TILDE] = ACTIONS(3811),
    [anon_sym_EQ_EQ] = ACTIONS(3811),
    [anon_sym_BANG_EQ] = ACTIONS(3811),
    [anon_sym_eq] = ACTIONS(3811),
    [anon_sym_ne] = ACTIONS(3811),
    [anon_sym_LT_EQ_GT] = ACTIONS(3811),
    [anon_sym_cmp] = ACTIONS(3811),
    [anon_sym_TILDE_TILDE] = ACTIONS(3811),
    [anon_sym_LT_EQ] = ACTIONS(3813),
    [anon_sym_GT_EQ] = ACTIONS(3811),
    [anon_sym_lt] = ACTIONS(3811),
    [anon_sym_le] = ACTIONS(3811),
    [anon_sym_ge] = ACTIONS(3811),
    [anon_sym_gt] = ACTIONS(3811),
    [anon_sym_isa] = ACTIONS(3811),
    [anon_sym_PLUS_PLUS] = ACTIONS(3811),
    [anon_sym_DASH_DASH] = ACTIONS(3811),
    [anon_sym_QMARK] = ACTIONS(3811),
    [anon_sym_EQ_GT] = ACTIONS(3811),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1446] = {
    [sym_heredoc_content] = STATE(1446),
    [anon_sym_RBRACE] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3695),
    [anon_sym_RPAREN] = ACTIONS(3695),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3695),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3695),
    [anon_sym_RBRACK] = ACTIONS(3695),
    [anon_sym_DASH_GT] = ACTIONS(3695),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3695),
    [anon_sym_PLUS_EQ] = ACTIONS(3695),
    [anon_sym_DASH_EQ] = ACTIONS(3695),
    [anon_sym_DOT_EQ] = ACTIONS(3695),
    [anon_sym_STAR_EQ] = ACTIONS(3695),
    [anon_sym_SLASH_EQ] = ACTIONS(3695),
    [anon_sym_PERCENT_EQ] = ACTIONS(3695),
    [anon_sym_x_EQ] = ACTIONS(3697),
    [anon_sym_AMP_EQ] = ACTIONS(3695),
    [anon_sym_PIPE_EQ] = ACTIONS(3695),
    [anon_sym_CARET_EQ] = ACTIONS(3695),
    [anon_sym_LT_LT_EQ] = ACTIONS(3695),
    [anon_sym_GT_GT_EQ] = ACTIONS(3695),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3695),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3695),
    [anon_sym_DOT_DOT] = ACTIONS(3697),
    [anon_sym_STAR_STAR] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_SLASH_SLASH] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_GT_GT2] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_x] = ACTIONS(3697),
    [anon_sym_EQ_TILDE] = ACTIONS(3695),
    [anon_sym_BANG_TILDE] = ACTIONS(3695),
    [anon_sym_EQ_EQ] = ACTIONS(3695),
    [anon_sym_BANG_EQ] = ACTIONS(3695),
    [anon_sym_eq] = ACTIONS(3695),
    [anon_sym_ne] = ACTIONS(3697),
    [anon_sym_LT_EQ_GT] = ACTIONS(3695),
    [anon_sym_cmp] = ACTIONS(3695),
    [anon_sym_TILDE_TILDE] = ACTIONS(3695),
    [anon_sym_LT_EQ] = ACTIONS(3697),
    [anon_sym_GT_EQ] = ACTIONS(3695),
    [anon_sym_lt] = ACTIONS(3697),
    [anon_sym_le] = ACTIONS(3697),
    [anon_sym_ge] = ACTIONS(3695),
    [anon_sym_gt] = ACTIONS(3695),
    [anon_sym_isa] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3695),
    [anon_sym_QMARK] = ACTIONS(3695),
    [anon_sym_EQ_GT] = ACTIONS(3695),
    [sym_comment] = ACTIONS(5),
    [sym_quoted_regexp_modifiers] = ACTIONS(4385),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1447] = {
    [sym_heredoc_content] = STATE(1447),
    [anon_sym_RBRACE] = ACTIONS(3735),
    [anon_sym_COLON] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3735),
    [anon_sym_RPAREN] = ACTIONS(3735),
    [anon_sym_COMMA] = ACTIONS(3735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3735),
    [anon_sym_and] = ACTIONS(3737),
    [anon_sym_or] = ACTIONS(3735),
    [anon_sym_RBRACK] = ACTIONS(3735),
    [anon_sym_DASH_GT] = ACTIONS(3735),
    [anon_sym_PERCENT] = ACTIONS(3737),
    [anon_sym_LT] = ACTIONS(3737),
    [anon_sym_GT] = ACTIONS(3737),
    [anon_sym_LT_LT] = ACTIONS(3737),
    [anon_sym_EQ] = ACTIONS(3737),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3735),
    [anon_sym_PLUS_EQ] = ACTIONS(3735),
    [anon_sym_DASH_EQ] = ACTIONS(3735),
    [anon_sym_DOT_EQ] = ACTIONS(3735),
    [anon_sym_STAR_EQ] = ACTIONS(3735),
    [anon_sym_SLASH_EQ] = ACTIONS(3735),
    [anon_sym_PERCENT_EQ] = ACTIONS(3735),
    [anon_sym_x_EQ] = ACTIONS(3737),
    [anon_sym_AMP_EQ] = ACTIONS(3735),
    [anon_sym_PIPE_EQ] = ACTIONS(3735),
    [anon_sym_CARET_EQ] = ACTIONS(3735),
    [anon_sym_LT_LT_EQ] = ACTIONS(3735),
    [anon_sym_GT_GT_EQ] = ACTIONS(3735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3735),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3735),
    [anon_sym_DOT_DOT] = ACTIONS(3737),
    [anon_sym_STAR_STAR] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(3737),
    [anon_sym_SLASH_SLASH] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_PIPE] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3737),
    [anon_sym_GT_GT2] = ACTIONS(3737),
    [anon_sym_PLUS] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3737),
    [anon_sym_DOT] = ACTIONS(3737),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_SLASH] = ACTIONS(3737),
    [anon_sym_x] = ACTIONS(3737),
    [anon_sym_EQ_TILDE] = ACTIONS(3735),
    [anon_sym_BANG_TILDE] = ACTIONS(3735),
    [anon_sym_EQ_EQ] = ACTIONS(3735),
    [anon_sym_BANG_EQ] = ACTIONS(3735),
    [anon_sym_eq] = ACTIONS(3735),
    [anon_sym_ne] = ACTIONS(3737),
    [anon_sym_LT_EQ_GT] = ACTIONS(3735),
    [anon_sym_cmp] = ACTIONS(3737),
    [anon_sym_TILDE_TILDE] = ACTIONS(3735),
    [anon_sym_LT_EQ] = ACTIONS(3737),
    [anon_sym_GT_EQ] = ACTIONS(3735),
    [anon_sym_lt] = ACTIONS(3737),
    [anon_sym_le] = ACTIONS(3737),
    [anon_sym_ge] = ACTIONS(3737),
    [anon_sym_gt] = ACTIONS(3737),
    [anon_sym_isa] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3735),
    [anon_sym_QMARK] = ACTIONS(3735),
    [anon_sym_EQ_GT] = ACTIONS(3735),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4387),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1448] = {
    [sym_heredoc_content] = STATE(1448),
    [anon_sym_RBRACE] = ACTIONS(3596),
    [anon_sym_COLON] = ACTIONS(3596),
    [anon_sym_SEMI] = ACTIONS(3596),
    [anon_sym_LPAREN] = ACTIONS(3596),
    [anon_sym_RPAREN] = ACTIONS(3596),
    [anon_sym_COMMA] = ACTIONS(3596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_and] = ACTIONS(3596),
    [anon_sym_or] = ACTIONS(3596),
    [anon_sym_RBRACK] = ACTIONS(3596),
    [anon_sym_DASH_GT] = ACTIONS(3596),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_LT] = ACTIONS(3598),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_LT_LT] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3598),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3596),
    [anon_sym_PLUS_EQ] = ACTIONS(3596),
    [anon_sym_DASH_EQ] = ACTIONS(3596),
    [anon_sym_DOT_EQ] = ACTIONS(3596),
    [anon_sym_STAR_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_PERCENT_EQ] = ACTIONS(3596),
    [anon_sym_x_EQ] = ACTIONS(3596),
    [anon_sym_AMP_EQ] = ACTIONS(3596),
    [anon_sym_PIPE_EQ] = ACTIONS(3596),
    [anon_sym_CARET_EQ] = ACTIONS(3596),
    [anon_sym_LT_LT_EQ] = ACTIONS(3596),
    [anon_sym_GT_GT_EQ] = ACTIONS(3596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_DOT_DOT] = ACTIONS(3598),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_SLASH_SLASH] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3598),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_GT_GT2] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_STAR] = ACTIONS(3598),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_x] = ACTIONS(3598),
    [anon_sym_EQ_TILDE] = ACTIONS(3596),
    [anon_sym_BANG_TILDE] = ACTIONS(3596),
    [anon_sym_EQ_EQ] = ACTIONS(3596),
    [anon_sym_BANG_EQ] = ACTIONS(3596),
    [anon_sym_eq] = ACTIONS(3596),
    [anon_sym_ne] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3596),
    [anon_sym_cmp] = ACTIONS(3596),
    [anon_sym_TILDE_TILDE] = ACTIONS(3596),
    [anon_sym_LT_EQ] = ACTIONS(3598),
    [anon_sym_GT_EQ] = ACTIONS(3596),
    [anon_sym_lt] = ACTIONS(3596),
    [anon_sym_le] = ACTIONS(3596),
    [anon_sym_ge] = ACTIONS(3596),
    [anon_sym_gt] = ACTIONS(3596),
    [anon_sym_isa] = ACTIONS(3596),
    [anon_sym_PLUS_PLUS] = ACTIONS(3596),
    [anon_sym_DASH_DASH] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3596),
    [anon_sym_EQ_GT] = ACTIONS(3596),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1449] = {
    [sym_heredoc_content] = STATE(1449),
    [anon_sym_RBRACE] = ACTIONS(3590),
    [anon_sym_COLON] = ACTIONS(3590),
    [anon_sym_SEMI] = ACTIONS(3590),
    [anon_sym_LPAREN] = ACTIONS(4389),
    [anon_sym_RPAREN] = ACTIONS(3590),
    [anon_sym_COMMA] = ACTIONS(3590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3590),
    [anon_sym_and] = ACTIONS(3590),
    [anon_sym_or] = ACTIONS(3590),
    [anon_sym_RBRACK] = ACTIONS(3590),
    [anon_sym_DASH_GT] = ACTIONS(3590),
    [anon_sym_PERCENT] = ACTIONS(3594),
    [anon_sym_LT] = ACTIONS(3594),
    [anon_sym_GT] = ACTIONS(3594),
    [anon_sym_LT_LT] = ACTIONS(3594),
    [anon_sym_EQ] = ACTIONS(3594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3590),
    [anon_sym_PLUS_EQ] = ACTIONS(3590),
    [anon_sym_DASH_EQ] = ACTIONS(3590),
    [anon_sym_DOT_EQ] = ACTIONS(3590),
    [anon_sym_STAR_EQ] = ACTIONS(3590),
    [anon_sym_SLASH_EQ] = ACTIONS(3590),
    [anon_sym_PERCENT_EQ] = ACTIONS(3590),
    [anon_sym_x_EQ] = ACTIONS(3590),
    [anon_sym_AMP_EQ] = ACTIONS(3590),
    [anon_sym_PIPE_EQ] = ACTIONS(3590),
    [anon_sym_CARET_EQ] = ACTIONS(3590),
    [anon_sym_LT_LT_EQ] = ACTIONS(3590),
    [anon_sym_GT_GT_EQ] = ACTIONS(3590),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3590),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3590),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3590),
    [anon_sym_DOT_DOT] = ACTIONS(3594),
    [anon_sym_STAR_STAR] = ACTIONS(3594),
    [anon_sym_PIPE_PIPE] = ACTIONS(3594),
    [anon_sym_SLASH_SLASH] = ACTIONS(3594),
    [anon_sym_AMP_AMP] = ACTIONS(3594),
    [anon_sym_PIPE] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(3594),
    [anon_sym_GT_GT2] = ACTIONS(3594),
    [anon_sym_PLUS] = ACTIONS(3594),
    [anon_sym_DASH] = ACTIONS(3594),
    [anon_sym_DOT] = ACTIONS(3594),
    [anon_sym_STAR] = ACTIONS(3594),
    [anon_sym_SLASH] = ACTIONS(3594),
    [anon_sym_x] = ACTIONS(3594),
    [anon_sym_EQ_TILDE] = ACTIONS(3590),
    [anon_sym_BANG_TILDE] = ACTIONS(3590),
    [anon_sym_EQ_EQ] = ACTIONS(3590),
    [anon_sym_BANG_EQ] = ACTIONS(3590),
    [anon_sym_eq] = ACTIONS(3590),
    [anon_sym_ne] = ACTIONS(3590),
    [anon_sym_LT_EQ_GT] = ACTIONS(3590),
    [anon_sym_cmp] = ACTIONS(3590),
    [anon_sym_TILDE_TILDE] = ACTIONS(3590),
    [anon_sym_LT_EQ] = ACTIONS(3594),
    [anon_sym_GT_EQ] = ACTIONS(3590),
    [anon_sym_lt] = ACTIONS(3590),
    [anon_sym_le] = ACTIONS(3590),
    [anon_sym_ge] = ACTIONS(3590),
    [anon_sym_gt] = ACTIONS(3590),
    [anon_sym_isa] = ACTIONS(3590),
    [anon_sym_PLUS_PLUS] = ACTIONS(3590),
    [anon_sym_DASH_DASH] = ACTIONS(3590),
    [anon_sym_QMARK] = ACTIONS(3590),
    [anon_sym_EQ_GT] = ACTIONS(3590),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1450] = {
    [sym_heredoc_content] = STATE(1450),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_COLON] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3637),
    [anon_sym_RPAREN] = ACTIONS(3637),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3637),
    [anon_sym_and] = ACTIONS(3637),
    [anon_sym_or] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(3637),
    [anon_sym_DASH_GT] = ACTIONS(3637),
    [anon_sym_PERCENT] = ACTIONS(3639),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_LT_LT] = ACTIONS(3639),
    [anon_sym_EQ] = ACTIONS(3639),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3637),
    [anon_sym_PLUS_EQ] = ACTIONS(3637),
    [anon_sym_DASH_EQ] = ACTIONS(3637),
    [anon_sym_DOT_EQ] = ACTIONS(3637),
    [anon_sym_STAR_EQ] = ACTIONS(3637),
    [anon_sym_SLASH_EQ] = ACTIONS(3637),
    [anon_sym_PERCENT_EQ] = ACTIONS(3637),
    [anon_sym_x_EQ] = ACTIONS(3637),
    [anon_sym_AMP_EQ] = ACTIONS(3637),
    [anon_sym_PIPE_EQ] = ACTIONS(3637),
    [anon_sym_CARET_EQ] = ACTIONS(3637),
    [anon_sym_LT_LT_EQ] = ACTIONS(3637),
    [anon_sym_GT_GT_EQ] = ACTIONS(3637),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3637),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3637),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3637),
    [anon_sym_DOT_DOT] = ACTIONS(3639),
    [anon_sym_STAR_STAR] = ACTIONS(3639),
    [anon_sym_PIPE_PIPE] = ACTIONS(3639),
    [anon_sym_SLASH_SLASH] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_GT_GT2] = ACTIONS(3639),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_DOT] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [anon_sym_x] = ACTIONS(3639),
    [anon_sym_EQ_TILDE] = ACTIONS(3637),
    [anon_sym_BANG_TILDE] = ACTIONS(3637),
    [anon_sym_EQ_EQ] = ACTIONS(3637),
    [anon_sym_BANG_EQ] = ACTIONS(3637),
    [anon_sym_eq] = ACTIONS(3637),
    [anon_sym_ne] = ACTIONS(3637),
    [anon_sym_LT_EQ_GT] = ACTIONS(3637),
    [anon_sym_cmp] = ACTIONS(3637),
    [anon_sym_TILDE_TILDE] = ACTIONS(3637),
    [anon_sym_LT_EQ] = ACTIONS(3639),
    [anon_sym_GT_EQ] = ACTIONS(3637),
    [anon_sym_lt] = ACTIONS(3637),
    [anon_sym_le] = ACTIONS(3637),
    [anon_sym_ge] = ACTIONS(3637),
    [anon_sym_gt] = ACTIONS(3637),
    [anon_sym_isa] = ACTIONS(3637),
    [anon_sym_PLUS_PLUS] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3637),
    [anon_sym_QMARK] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(3637),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1451] = {
    [sym_heredoc_content] = STATE(1451),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_DOT_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_x_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3721),
    [anon_sym_STAR_STAR] = ACTIONS(3721),
    [anon_sym_PIPE_PIPE] = ACTIONS(3721),
    [anon_sym_SLASH_SLASH] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_GT_GT2] = ACTIONS(3721),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_x] = ACTIONS(3721),
    [anon_sym_EQ_TILDE] = ACTIONS(3719),
    [anon_sym_BANG_TILDE] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_eq] = ACTIONS(3719),
    [anon_sym_ne] = ACTIONS(3719),
    [anon_sym_LT_EQ_GT] = ACTIONS(3719),
    [anon_sym_cmp] = ACTIONS(3719),
    [anon_sym_TILDE_TILDE] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3721),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_lt] = ACTIONS(3719),
    [anon_sym_le] = ACTIONS(3719),
    [anon_sym_ge] = ACTIONS(3719),
    [anon_sym_gt] = ACTIONS(3719),
    [anon_sym_isa] = ACTIONS(3719),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1452] = {
    [sym_heredoc_content] = STATE(1452),
    [anon_sym_RBRACE] = ACTIONS(3701),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym_RPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3701),
    [anon_sym_and] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(3703),
    [anon_sym_LT_LT] = ACTIONS(3703),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3701),
    [anon_sym_DASH_EQ] = ACTIONS(3701),
    [anon_sym_DOT_EQ] = ACTIONS(3701),
    [anon_sym_STAR_EQ] = ACTIONS(3701),
    [anon_sym_SLASH_EQ] = ACTIONS(3701),
    [anon_sym_PERCENT_EQ] = ACTIONS(3701),
    [anon_sym_x_EQ] = ACTIONS(3703),
    [anon_sym_AMP_EQ] = ACTIONS(3701),
    [anon_sym_PIPE_EQ] = ACTIONS(3701),
    [anon_sym_CARET_EQ] = ACTIONS(3701),
    [anon_sym_LT_LT_EQ] = ACTIONS(3701),
    [anon_sym_GT_GT_EQ] = ACTIONS(3701),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3701),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3701),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_STAR_STAR] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH] = ACTIONS(3703),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_GT_GT2] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3703),
    [anon_sym_SLASH] = ACTIONS(3703),
    [anon_sym_x] = ACTIONS(3703),
    [anon_sym_EQ_TILDE] = ACTIONS(3701),
    [anon_sym_BANG_TILDE] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_eq] = ACTIONS(3701),
    [anon_sym_ne] = ACTIONS(3703),
    [anon_sym_LT_EQ_GT] = ACTIONS(3701),
    [anon_sym_cmp] = ACTIONS(3701),
    [anon_sym_TILDE_TILDE] = ACTIONS(3701),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3701),
    [anon_sym_lt] = ACTIONS(3703),
    [anon_sym_le] = ACTIONS(3703),
    [anon_sym_ge] = ACTIONS(3701),
    [anon_sym_gt] = ACTIONS(3701),
    [anon_sym_isa] = ACTIONS(3703),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_EQ_GT] = ACTIONS(3701),
    [sym_comment] = ACTIONS(5),
    [sym_quoted_regexp_modifiers] = ACTIONS(4391),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1453] = {
    [sym_heredoc_content] = STATE(1453),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4080),
    [anon_sym_and] = ACTIONS(4080),
    [anon_sym_or] = ACTIONS(4080),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4082),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4082),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4080),
    [anon_sym_PLUS_EQ] = ACTIONS(4080),
    [anon_sym_DASH_EQ] = ACTIONS(4080),
    [anon_sym_DOT_EQ] = ACTIONS(4080),
    [anon_sym_STAR_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_PERCENT_EQ] = ACTIONS(4080),
    [anon_sym_x_EQ] = ACTIONS(4080),
    [anon_sym_AMP_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_CARET_EQ] = ACTIONS(4080),
    [anon_sym_LT_LT_EQ] = ACTIONS(4080),
    [anon_sym_GT_GT_EQ] = ACTIONS(4080),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(4082),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_SLASH_SLASH] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4080),
    [anon_sym_BANG_EQ] = ACTIONS(4080),
    [anon_sym_eq] = ACTIONS(4080),
    [anon_sym_ne] = ACTIONS(4080),
    [anon_sym_LT_EQ_GT] = ACTIONS(4080),
    [anon_sym_cmp] = ACTIONS(4080),
    [anon_sym_TILDE_TILDE] = ACTIONS(4080),
    [anon_sym_LT_EQ] = ACTIONS(4082),
    [anon_sym_GT_EQ] = ACTIONS(4080),
    [anon_sym_lt] = ACTIONS(4080),
    [anon_sym_le] = ACTIONS(4080),
    [anon_sym_ge] = ACTIONS(4080),
    [anon_sym_gt] = ACTIONS(4080),
    [anon_sym_isa] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4080),
    [anon_sym_EQ_GT] = ACTIONS(4080),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4080),
    [anon_sym___END__] = ACTIONS(4080),
    [anon_sym_EOT] = ACTIONS(4080),
    [sym__PERLY_SEMICOLON] = ACTIONS(4080),
    [sym__ctrl_z_hack] = ACTIONS(4080),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1454] = {
    [sym_heredoc_content] = STATE(1454),
    [anon_sym_RBRACE] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3600),
    [anon_sym_SEMI] = ACTIONS(3600),
    [anon_sym_RPAREN] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3600),
    [anon_sym_and] = ACTIONS(3602),
    [anon_sym_or] = ACTIONS(3600),
    [anon_sym_RBRACK] = ACTIONS(3600),
    [anon_sym_DASH_GT] = ACTIONS(3600),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_LT_LT] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3600),
    [anon_sym_PLUS_EQ] = ACTIONS(3600),
    [anon_sym_DASH_EQ] = ACTIONS(3600),
    [anon_sym_DOT_EQ] = ACTIONS(3600),
    [anon_sym_STAR_EQ] = ACTIONS(3600),
    [anon_sym_SLASH_EQ] = ACTIONS(3600),
    [anon_sym_PERCENT_EQ] = ACTIONS(3600),
    [anon_sym_x_EQ] = ACTIONS(3602),
    [anon_sym_AMP_EQ] = ACTIONS(3600),
    [anon_sym_PIPE_EQ] = ACTIONS(3600),
    [anon_sym_CARET_EQ] = ACTIONS(3600),
    [anon_sym_LT_LT_EQ] = ACTIONS(3600),
    [anon_sym_GT_GT_EQ] = ACTIONS(3600),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3600),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3600),
    [anon_sym_DOT_DOT] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_SLASH_SLASH] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_GT_GT2] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_STAR] = ACTIONS(3602),
    [anon_sym_SLASH] = ACTIONS(3602),
    [anon_sym_x] = ACTIONS(3602),
    [anon_sym_EQ_TILDE] = ACTIONS(3600),
    [anon_sym_BANG_TILDE] = ACTIONS(3600),
    [anon_sym_EQ_EQ] = ACTIONS(3600),
    [anon_sym_BANG_EQ] = ACTIONS(3600),
    [anon_sym_eq] = ACTIONS(3600),
    [anon_sym_ne] = ACTIONS(3602),
    [anon_sym_LT_EQ_GT] = ACTIONS(3600),
    [anon_sym_cmp] = ACTIONS(3602),
    [anon_sym_TILDE_TILDE] = ACTIONS(3600),
    [anon_sym_LT_EQ] = ACTIONS(3602),
    [anon_sym_GT_EQ] = ACTIONS(3600),
    [anon_sym_lt] = ACTIONS(3602),
    [anon_sym_le] = ACTIONS(3602),
    [anon_sym_ge] = ACTIONS(3602),
    [anon_sym_gt] = ACTIONS(3602),
    [anon_sym_isa] = ACTIONS(3602),
    [anon_sym_PLUS_PLUS] = ACTIONS(3600),
    [anon_sym_DASH_DASH] = ACTIONS(3600),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_GT] = ACTIONS(3600),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4393),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1455] = {
    [sym_heredoc_content] = STATE(1455),
    [anon_sym_RBRACE] = ACTIONS(3566),
    [anon_sym_COLON] = ACTIONS(3566),
    [anon_sym_SEMI] = ACTIONS(3566),
    [anon_sym_RPAREN] = ACTIONS(3566),
    [anon_sym_COMMA] = ACTIONS(3566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3566),
    [anon_sym_and] = ACTIONS(3568),
    [anon_sym_or] = ACTIONS(3568),
    [anon_sym_RBRACK] = ACTIONS(3566),
    [anon_sym_DASH_GT] = ACTIONS(3566),
    [anon_sym_PERCENT] = ACTIONS(3568),
    [anon_sym_LT] = ACTIONS(3568),
    [anon_sym_GT] = ACTIONS(3568),
    [anon_sym_LT_LT] = ACTIONS(3568),
    [anon_sym_EQ] = ACTIONS(3568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3566),
    [anon_sym_PLUS_EQ] = ACTIONS(3566),
    [anon_sym_DASH_EQ] = ACTIONS(3566),
    [anon_sym_DOT_EQ] = ACTIONS(3566),
    [anon_sym_STAR_EQ] = ACTIONS(3566),
    [anon_sym_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_PERCENT_EQ] = ACTIONS(3566),
    [anon_sym_x_EQ] = ACTIONS(3568),
    [anon_sym_AMP_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_CARET_EQ] = ACTIONS(3566),
    [anon_sym_LT_LT_EQ] = ACTIONS(3566),
    [anon_sym_GT_GT_EQ] = ACTIONS(3566),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_DOT_DOT] = ACTIONS(3568),
    [anon_sym_STAR_STAR] = ACTIONS(3568),
    [anon_sym_PIPE_PIPE] = ACTIONS(3568),
    [anon_sym_SLASH_SLASH] = ACTIONS(3568),
    [anon_sym_AMP_AMP] = ACTIONS(3568),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_AMP] = ACTIONS(3568),
    [anon_sym_GT_GT2] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3568),
    [anon_sym_DASH] = ACTIONS(3568),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(3568),
    [anon_sym_SLASH] = ACTIONS(3568),
    [anon_sym_x] = ACTIONS(3568),
    [anon_sym_EQ_TILDE] = ACTIONS(3566),
    [anon_sym_BANG_TILDE] = ACTIONS(3566),
    [anon_sym_EQ_EQ] = ACTIONS(3566),
    [anon_sym_BANG_EQ] = ACTIONS(3566),
    [anon_sym_eq] = ACTIONS(3568),
    [anon_sym_ne] = ACTIONS(3566),
    [anon_sym_LT_EQ_GT] = ACTIONS(3566),
    [anon_sym_cmp] = ACTIONS(3568),
    [anon_sym_TILDE_TILDE] = ACTIONS(3566),
    [anon_sym_LT_EQ] = ACTIONS(3568),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_lt] = ACTIONS(3568),
    [anon_sym_le] = ACTIONS(3568),
    [anon_sym_ge] = ACTIONS(3568),
    [anon_sym_gt] = ACTIONS(3568),
    [anon_sym_isa] = ACTIONS(3568),
    [anon_sym_PLUS_PLUS] = ACTIONS(3566),
    [anon_sym_DASH_DASH] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3566),
    [anon_sym_EQ_GT] = ACTIONS(3566),
    [sym_comment] = ACTIONS(5),
    [sym_substitution_regexp_modifiers] = ACTIONS(4395),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1456] = {
    [sym_heredoc_content] = STATE(1456),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3713),
    [anon_sym_and] = ACTIONS(3713),
    [anon_sym_or] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_DASH_GT] = ACTIONS(3713),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3713),
    [anon_sym_PLUS_EQ] = ACTIONS(3713),
    [anon_sym_DASH_EQ] = ACTIONS(3713),
    [anon_sym_DOT_EQ] = ACTIONS(3713),
    [anon_sym_STAR_EQ] = ACTIONS(3713),
    [anon_sym_SLASH_EQ] = ACTIONS(3713),
    [anon_sym_PERCENT_EQ] = ACTIONS(3713),
    [anon_sym_x_EQ] = ACTIONS(3713),
    [anon_sym_AMP_EQ] = ACTIONS(3713),
    [anon_sym_PIPE_EQ] = ACTIONS(3713),
    [anon_sym_CARET_EQ] = ACTIONS(3713),
    [anon_sym_LT_LT_EQ] = ACTIONS(3713),
    [anon_sym_GT_GT_EQ] = ACTIONS(3713),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3713),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3713),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3713),
    [anon_sym_DOT_DOT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_SLASH_SLASH] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_GT_GT2] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_x] = ACTIONS(3715),
    [anon_sym_EQ_TILDE] = ACTIONS(3713),
    [anon_sym_BANG_TILDE] = ACTIONS(3713),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_eq] = ACTIONS(3713),
    [anon_sym_ne] = ACTIONS(3713),
    [anon_sym_LT_EQ_GT] = ACTIONS(3713),
    [anon_sym_cmp] = ACTIONS(3715),
    [anon_sym_TILDE_TILDE] = ACTIONS(3713),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3713),
    [anon_sym_lt] = ACTIONS(3713),
    [anon_sym_le] = ACTIONS(3713),
    [anon_sym_ge] = ACTIONS(3713),
    [anon_sym_gt] = ACTIONS(3713),
    [anon_sym_isa] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_EQ_GT] = ACTIONS(3713),
    [sym_comment] = ACTIONS(5),
    [sym_transliteration_modifiers] = ACTIONS(4397),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1457] = {
    [sym_heredoc_content] = STATE(1457),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_COMMA] = ACTIONS(3606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_and] = ACTIONS(3606),
    [anon_sym_or] = ACTIONS(3606),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4320),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4322),
    [anon_sym_PLUS_EQ] = ACTIONS(4322),
    [anon_sym_DASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_EQ] = ACTIONS(4322),
    [anon_sym_STAR_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_PERCENT_EQ] = ACTIONS(4322),
    [anon_sym_x_EQ] = ACTIONS(4322),
    [anon_sym_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_CARET_EQ] = ACTIONS(4322),
    [anon_sym_LT_LT_EQ] = ACTIONS(4322),
    [anon_sym_GT_GT_EQ] = ACTIONS(4322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_DOT] = ACTIONS(4324),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4328),
    [anon_sym_SLASH_SLASH] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(3606),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3606),
    [anon_sym___END__] = ACTIONS(3606),
    [anon_sym_EOT] = ACTIONS(3606),
    [sym__PERLY_SEMICOLON] = ACTIONS(3606),
    [sym__ctrl_z_hack] = ACTIONS(3606),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1458] = {
    [sym_heredoc_content] = STATE(1458),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4399),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(4401),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4328),
    [anon_sym_SLASH_SLASH] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1459] = {
    [sym_heredoc_content] = STATE(1459),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1460] = {
    [sym_heredoc_content] = STATE(1460),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3831),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(3833),
    [anon_sym_GT] = ACTIONS(3833),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3833),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3831),
    [anon_sym_PLUS_EQ] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_EQ] = ACTIONS(3831),
    [anon_sym_STAR_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3831),
    [anon_sym_x_EQ] = ACTIONS(3831),
    [anon_sym_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3833),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3833),
    [anon_sym_SLASH_SLASH] = ACTIONS(3833),
    [anon_sym_AMP_AMP] = ACTIONS(3833),
    [anon_sym_PIPE] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(3833),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(3831),
    [anon_sym_BANG_EQ] = ACTIONS(3831),
    [anon_sym_eq] = ACTIONS(3831),
    [anon_sym_ne] = ACTIONS(3831),
    [anon_sym_LT_EQ_GT] = ACTIONS(3831),
    [anon_sym_cmp] = ACTIONS(3831),
    [anon_sym_TILDE_TILDE] = ACTIONS(3831),
    [anon_sym_LT_EQ] = ACTIONS(3833),
    [anon_sym_GT_EQ] = ACTIONS(3831),
    [anon_sym_lt] = ACTIONS(3831),
    [anon_sym_le] = ACTIONS(3831),
    [anon_sym_ge] = ACTIONS(3831),
    [anon_sym_gt] = ACTIONS(3831),
    [anon_sym_isa] = ACTIONS(3831),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3831),
    [anon_sym_EQ_GT] = ACTIONS(3831),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3831),
    [anon_sym___END__] = ACTIONS(3831),
    [anon_sym_EOT] = ACTIONS(3831),
    [sym__PERLY_SEMICOLON] = ACTIONS(3831),
    [sym__ctrl_z_hack] = ACTIONS(3831),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1461] = {
    [sym_heredoc_content] = STATE(1461),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1462] = {
    [sym_heredoc_content] = STATE(1462),
    [anon_sym_RBRACE] = ACTIONS(3795),
    [anon_sym_COLON] = ACTIONS(3795),
    [anon_sym_SEMI] = ACTIONS(3795),
    [anon_sym_RPAREN] = ACTIONS(3795),
    [anon_sym_COMMA] = ACTIONS(3795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3795),
    [anon_sym_and] = ACTIONS(3795),
    [anon_sym_or] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(4379),
    [anon_sym_RBRACK] = ACTIONS(3795),
    [anon_sym_DASH_GT] = ACTIONS(3795),
    [anon_sym_PERCENT] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3797),
    [anon_sym_GT] = ACTIONS(3797),
    [anon_sym_LT_LT] = ACTIONS(3797),
    [anon_sym_EQ] = ACTIONS(3797),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3795),
    [anon_sym_PLUS_EQ] = ACTIONS(3795),
    [anon_sym_DASH_EQ] = ACTIONS(3795),
    [anon_sym_DOT_EQ] = ACTIONS(3795),
    [anon_sym_STAR_EQ] = ACTIONS(3795),
    [anon_sym_SLASH_EQ] = ACTIONS(3795),
    [anon_sym_PERCENT_EQ] = ACTIONS(3795),
    [anon_sym_x_EQ] = ACTIONS(3795),
    [anon_sym_AMP_EQ] = ACTIONS(3795),
    [anon_sym_PIPE_EQ] = ACTIONS(3795),
    [anon_sym_CARET_EQ] = ACTIONS(3795),
    [anon_sym_LT_LT_EQ] = ACTIONS(3795),
    [anon_sym_GT_GT_EQ] = ACTIONS(3795),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3795),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3795),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3795),
    [anon_sym_DOT_DOT] = ACTIONS(3797),
    [anon_sym_STAR_STAR] = ACTIONS(3797),
    [anon_sym_PIPE_PIPE] = ACTIONS(3797),
    [anon_sym_SLASH_SLASH] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(3797),
    [anon_sym_PIPE] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3797),
    [anon_sym_GT_GT2] = ACTIONS(3797),
    [anon_sym_PLUS] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3797),
    [anon_sym_DOT] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_SLASH] = ACTIONS(3797),
    [anon_sym_x] = ACTIONS(3797),
    [anon_sym_EQ_TILDE] = ACTIONS(3795),
    [anon_sym_BANG_TILDE] = ACTIONS(3795),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_eq] = ACTIONS(3795),
    [anon_sym_ne] = ACTIONS(3795),
    [anon_sym_LT_EQ_GT] = ACTIONS(3795),
    [anon_sym_cmp] = ACTIONS(3795),
    [anon_sym_TILDE_TILDE] = ACTIONS(3795),
    [anon_sym_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_EQ] = ACTIONS(3795),
    [anon_sym_lt] = ACTIONS(3795),
    [anon_sym_le] = ACTIONS(3795),
    [anon_sym_ge] = ACTIONS(3795),
    [anon_sym_gt] = ACTIONS(3795),
    [anon_sym_isa] = ACTIONS(3795),
    [anon_sym_PLUS_PLUS] = ACTIONS(3795),
    [anon_sym_DASH_DASH] = ACTIONS(3795),
    [anon_sym_QMARK] = ACTIONS(3795),
    [anon_sym_EQ_GT] = ACTIONS(3795),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1463] = {
    [sym_heredoc_content] = STATE(1463),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym_RPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(4379),
    [anon_sym_RBRACK] = ACTIONS(3759),
    [anon_sym_DASH_GT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [anon_sym_LT] = ACTIONS(3763),
    [anon_sym_GT] = ACTIONS(3763),
    [anon_sym_LT_LT] = ACTIONS(3763),
    [anon_sym_EQ] = ACTIONS(3763),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_DOT_EQ] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_x_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_DOT_DOT] = ACTIONS(3763),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_PIPE_PIPE] = ACTIONS(3763),
    [anon_sym_SLASH_SLASH] = ACTIONS(3763),
    [anon_sym_AMP_AMP] = ACTIONS(3763),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_GT_GT2] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_DOT] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3763),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_x] = ACTIONS(3763),
    [anon_sym_EQ_TILDE] = ACTIONS(3759),
    [anon_sym_BANG_TILDE] = ACTIONS(3759),
    [anon_sym_EQ_EQ] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_eq] = ACTIONS(3759),
    [anon_sym_ne] = ACTIONS(3759),
    [anon_sym_LT_EQ_GT] = ACTIONS(3759),
    [anon_sym_cmp] = ACTIONS(3759),
    [anon_sym_TILDE_TILDE] = ACTIONS(3759),
    [anon_sym_LT_EQ] = ACTIONS(3763),
    [anon_sym_GT_EQ] = ACTIONS(3759),
    [anon_sym_lt] = ACTIONS(3759),
    [anon_sym_le] = ACTIONS(3759),
    [anon_sym_ge] = ACTIONS(3759),
    [anon_sym_gt] = ACTIONS(3759),
    [anon_sym_isa] = ACTIONS(3759),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_EQ_GT] = ACTIONS(3759),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1464] = {
    [sym_heredoc_content] = STATE(1464),
    [anon_sym_RBRACE] = ACTIONS(3578),
    [anon_sym_COLON] = ACTIONS(3578),
    [anon_sym_SEMI] = ACTIONS(3578),
    [anon_sym_RPAREN] = ACTIONS(3578),
    [anon_sym_COMMA] = ACTIONS(3578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3578),
    [anon_sym_and] = ACTIONS(3580),
    [anon_sym_or] = ACTIONS(3580),
    [anon_sym_RBRACK] = ACTIONS(3578),
    [anon_sym_DASH_GT] = ACTIONS(3578),
    [anon_sym_PERCENT] = ACTIONS(3580),
    [anon_sym_LT] = ACTIONS(3580),
    [anon_sym_GT] = ACTIONS(3580),
    [anon_sym_LT_LT] = ACTIONS(3580),
    [anon_sym_EQ] = ACTIONS(3580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3578),
    [anon_sym_PLUS_EQ] = ACTIONS(3578),
    [anon_sym_DASH_EQ] = ACTIONS(3578),
    [anon_sym_DOT_EQ] = ACTIONS(3578),
    [anon_sym_STAR_EQ] = ACTIONS(3578),
    [anon_sym_SLASH_EQ] = ACTIONS(3578),
    [anon_sym_PERCENT_EQ] = ACTIONS(3578),
    [anon_sym_x_EQ] = ACTIONS(3580),
    [anon_sym_AMP_EQ] = ACTIONS(3578),
    [anon_sym_PIPE_EQ] = ACTIONS(3578),
    [anon_sym_CARET_EQ] = ACTIONS(3578),
    [anon_sym_LT_LT_EQ] = ACTIONS(3578),
    [anon_sym_GT_GT_EQ] = ACTIONS(3578),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3578),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3578),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3578),
    [anon_sym_DOT_DOT] = ACTIONS(3580),
    [anon_sym_STAR_STAR] = ACTIONS(3580),
    [anon_sym_PIPE_PIPE] = ACTIONS(3580),
    [anon_sym_SLASH_SLASH] = ACTIONS(3580),
    [anon_sym_AMP_AMP] = ACTIONS(3580),
    [anon_sym_PIPE] = ACTIONS(3580),
    [anon_sym_AMP] = ACTIONS(3580),
    [anon_sym_GT_GT2] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_DOT] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(3580),
    [anon_sym_SLASH] = ACTIONS(3580),
    [anon_sym_x] = ACTIONS(3580),
    [anon_sym_EQ_TILDE] = ACTIONS(3578),
    [anon_sym_BANG_TILDE] = ACTIONS(3578),
    [anon_sym_EQ_EQ] = ACTIONS(3578),
    [anon_sym_BANG_EQ] = ACTIONS(3578),
    [anon_sym_eq] = ACTIONS(3580),
    [anon_sym_ne] = ACTIONS(3578),
    [anon_sym_LT_EQ_GT] = ACTIONS(3578),
    [anon_sym_cmp] = ACTIONS(3580),
    [anon_sym_TILDE_TILDE] = ACTIONS(3578),
    [anon_sym_LT_EQ] = ACTIONS(3580),
    [anon_sym_GT_EQ] = ACTIONS(3578),
    [anon_sym_lt] = ACTIONS(3580),
    [anon_sym_le] = ACTIONS(3580),
    [anon_sym_ge] = ACTIONS(3580),
    [anon_sym_gt] = ACTIONS(3580),
    [anon_sym_isa] = ACTIONS(3580),
    [anon_sym_PLUS_PLUS] = ACTIONS(3578),
    [anon_sym_DASH_DASH] = ACTIONS(3578),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_EQ_GT] = ACTIONS(3578),
    [sym_comment] = ACTIONS(5),
    [sym_substitution_regexp_modifiers] = ACTIONS(4403),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1465] = {
    [sym_heredoc_content] = STATE(1465),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_COLON] = ACTIONS(3749),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3749),
    [anon_sym_and] = ACTIONS(3751),
    [anon_sym_or] = ACTIONS(3751),
    [anon_sym_RBRACK] = ACTIONS(3749),
    [anon_sym_DASH_GT] = ACTIONS(3749),
    [anon_sym_PERCENT] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_GT] = ACTIONS(3751),
    [anon_sym_LT_LT] = ACTIONS(3751),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3749),
    [anon_sym_PLUS_EQ] = ACTIONS(3749),
    [anon_sym_DASH_EQ] = ACTIONS(3749),
    [anon_sym_DOT_EQ] = ACTIONS(3749),
    [anon_sym_STAR_EQ] = ACTIONS(3749),
    [anon_sym_SLASH_EQ] = ACTIONS(3749),
    [anon_sym_PERCENT_EQ] = ACTIONS(3749),
    [anon_sym_x_EQ] = ACTIONS(3751),
    [anon_sym_AMP_EQ] = ACTIONS(3749),
    [anon_sym_PIPE_EQ] = ACTIONS(3749),
    [anon_sym_CARET_EQ] = ACTIONS(3749),
    [anon_sym_LT_LT_EQ] = ACTIONS(3749),
    [anon_sym_GT_GT_EQ] = ACTIONS(3749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3749),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3749),
    [anon_sym_DOT_DOT] = ACTIONS(3751),
    [anon_sym_STAR_STAR] = ACTIONS(3751),
    [anon_sym_PIPE_PIPE] = ACTIONS(3751),
    [anon_sym_SLASH_SLASH] = ACTIONS(3751),
    [anon_sym_AMP_AMP] = ACTIONS(3751),
    [anon_sym_PIPE] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_GT_GT2] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_DOT] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3751),
    [anon_sym_SLASH] = ACTIONS(3751),
    [anon_sym_x] = ACTIONS(3751),
    [anon_sym_EQ_TILDE] = ACTIONS(3749),
    [anon_sym_BANG_TILDE] = ACTIONS(3749),
    [anon_sym_EQ_EQ] = ACTIONS(3749),
    [anon_sym_BANG_EQ] = ACTIONS(3749),
    [anon_sym_eq] = ACTIONS(3751),
    [anon_sym_ne] = ACTIONS(3749),
    [anon_sym_LT_EQ_GT] = ACTIONS(3749),
    [anon_sym_cmp] = ACTIONS(3751),
    [anon_sym_TILDE_TILDE] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(3751),
    [anon_sym_GT_EQ] = ACTIONS(3749),
    [anon_sym_lt] = ACTIONS(3751),
    [anon_sym_le] = ACTIONS(3751),
    [anon_sym_ge] = ACTIONS(3751),
    [anon_sym_gt] = ACTIONS(3751),
    [anon_sym_isa] = ACTIONS(3751),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_QMARK] = ACTIONS(3749),
    [anon_sym_EQ_GT] = ACTIONS(3749),
    [sym_comment] = ACTIONS(5),
    [sym_substitution_regexp_modifiers] = ACTIONS(4405),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1466] = {
    [sym_heredoc_content] = STATE(1466),
    [anon_sym_RBRACE] = ACTIONS(3584),
    [anon_sym_COLON] = ACTIONS(3584),
    [anon_sym_SEMI] = ACTIONS(3584),
    [anon_sym_RPAREN] = ACTIONS(3584),
    [anon_sym_COMMA] = ACTIONS(3584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3584),
    [anon_sym_and] = ACTIONS(3584),
    [anon_sym_or] = ACTIONS(3584),
    [anon_sym_RBRACK] = ACTIONS(3584),
    [anon_sym_DASH_GT] = ACTIONS(3584),
    [anon_sym_PERCENT] = ACTIONS(3586),
    [anon_sym_LT] = ACTIONS(3586),
    [anon_sym_GT] = ACTIONS(3586),
    [anon_sym_LT_LT] = ACTIONS(3586),
    [anon_sym_EQ] = ACTIONS(3586),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3584),
    [anon_sym_PLUS_EQ] = ACTIONS(3584),
    [anon_sym_DASH_EQ] = ACTIONS(3584),
    [anon_sym_DOT_EQ] = ACTIONS(3584),
    [anon_sym_STAR_EQ] = ACTIONS(3584),
    [anon_sym_SLASH_EQ] = ACTIONS(3584),
    [anon_sym_PERCENT_EQ] = ACTIONS(3584),
    [anon_sym_x_EQ] = ACTIONS(3584),
    [anon_sym_AMP_EQ] = ACTIONS(3584),
    [anon_sym_PIPE_EQ] = ACTIONS(3584),
    [anon_sym_CARET_EQ] = ACTIONS(3584),
    [anon_sym_LT_LT_EQ] = ACTIONS(3584),
    [anon_sym_GT_GT_EQ] = ACTIONS(3584),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3584),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3584),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3584),
    [anon_sym_DOT_DOT] = ACTIONS(3586),
    [anon_sym_STAR_STAR] = ACTIONS(3586),
    [anon_sym_PIPE_PIPE] = ACTIONS(3586),
    [anon_sym_SLASH_SLASH] = ACTIONS(3586),
    [anon_sym_AMP_AMP] = ACTIONS(3586),
    [anon_sym_PIPE] = ACTIONS(3586),
    [anon_sym_AMP] = ACTIONS(3586),
    [anon_sym_GT_GT2] = ACTIONS(3586),
    [anon_sym_PLUS] = ACTIONS(3586),
    [anon_sym_DASH] = ACTIONS(3586),
    [anon_sym_DOT] = ACTIONS(3586),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_SLASH] = ACTIONS(3586),
    [anon_sym_x] = ACTIONS(3586),
    [anon_sym_EQ_TILDE] = ACTIONS(3584),
    [anon_sym_BANG_TILDE] = ACTIONS(3584),
    [anon_sym_EQ_EQ] = ACTIONS(3584),
    [anon_sym_BANG_EQ] = ACTIONS(3584),
    [anon_sym_eq] = ACTIONS(3584),
    [anon_sym_ne] = ACTIONS(3584),
    [anon_sym_LT_EQ_GT] = ACTIONS(3584),
    [anon_sym_cmp] = ACTIONS(3586),
    [anon_sym_TILDE_TILDE] = ACTIONS(3584),
    [anon_sym_LT_EQ] = ACTIONS(3586),
    [anon_sym_GT_EQ] = ACTIONS(3584),
    [anon_sym_lt] = ACTIONS(3584),
    [anon_sym_le] = ACTIONS(3584),
    [anon_sym_ge] = ACTIONS(3584),
    [anon_sym_gt] = ACTIONS(3584),
    [anon_sym_isa] = ACTIONS(3584),
    [anon_sym_PLUS_PLUS] = ACTIONS(3584),
    [anon_sym_DASH_DASH] = ACTIONS(3584),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_EQ_GT] = ACTIONS(3584),
    [sym_comment] = ACTIONS(5),
    [sym_transliteration_modifiers] = ACTIONS(4407),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1467] = {
    [sym_heredoc_content] = STATE(1467),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3617),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_and] = ACTIONS(3617),
    [anon_sym_or] = ACTIONS(3617),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3619),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_LT_LT] = ACTIONS(3619),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DOT_EQ] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_x_EQ] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_DOT_DOT] = ACTIONS(3619),
    [anon_sym_STAR_STAR] = ACTIONS(3619),
    [anon_sym_PIPE_PIPE] = ACTIONS(3619),
    [anon_sym_SLASH_SLASH] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_PIPE] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_GT_GT2] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_DOT] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(3619),
    [anon_sym_x] = ACTIONS(3619),
    [anon_sym_EQ_TILDE] = ACTIONS(3617),
    [anon_sym_BANG_TILDE] = ACTIONS(3617),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_eq] = ACTIONS(3617),
    [anon_sym_ne] = ACTIONS(3617),
    [anon_sym_LT_EQ_GT] = ACTIONS(3617),
    [anon_sym_cmp] = ACTIONS(3619),
    [anon_sym_TILDE_TILDE] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_lt] = ACTIONS(3617),
    [anon_sym_le] = ACTIONS(3617),
    [anon_sym_ge] = ACTIONS(3617),
    [anon_sym_gt] = ACTIONS(3617),
    [anon_sym_isa] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [sym_comment] = ACTIONS(5),
    [sym_transliteration_modifiers] = ACTIONS(4409),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1468] = {
    [sym_heredoc_content] = STATE(1468),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_RPAREN] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3707),
    [anon_sym_and] = ACTIONS(3709),
    [anon_sym_or] = ACTIONS(3709),
    [anon_sym_RBRACK] = ACTIONS(3707),
    [anon_sym_DASH_GT] = ACTIONS(3707),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3709),
    [anon_sym_GT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3707),
    [anon_sym_PLUS_EQ] = ACTIONS(3707),
    [anon_sym_DASH_EQ] = ACTIONS(3707),
    [anon_sym_DOT_EQ] = ACTIONS(3707),
    [anon_sym_STAR_EQ] = ACTIONS(3707),
    [anon_sym_SLASH_EQ] = ACTIONS(3707),
    [anon_sym_PERCENT_EQ] = ACTIONS(3707),
    [anon_sym_x_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3707),
    [anon_sym_PIPE_EQ] = ACTIONS(3707),
    [anon_sym_CARET_EQ] = ACTIONS(3707),
    [anon_sym_LT_LT_EQ] = ACTIONS(3707),
    [anon_sym_GT_GT_EQ] = ACTIONS(3707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_SLASH_SLASH] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_GT_GT2] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_SLASH] = ACTIONS(3709),
    [anon_sym_x] = ACTIONS(3709),
    [anon_sym_EQ_TILDE] = ACTIONS(3707),
    [anon_sym_BANG_TILDE] = ACTIONS(3707),
    [anon_sym_EQ_EQ] = ACTIONS(3707),
    [anon_sym_BANG_EQ] = ACTIONS(3707),
    [anon_sym_eq] = ACTIONS(3709),
    [anon_sym_ne] = ACTIONS(3707),
    [anon_sym_LT_EQ_GT] = ACTIONS(3707),
    [anon_sym_cmp] = ACTIONS(3709),
    [anon_sym_TILDE_TILDE] = ACTIONS(3707),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3707),
    [anon_sym_lt] = ACTIONS(3709),
    [anon_sym_le] = ACTIONS(3709),
    [anon_sym_ge] = ACTIONS(3709),
    [anon_sym_gt] = ACTIONS(3709),
    [anon_sym_isa] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_QMARK] = ACTIONS(3707),
    [anon_sym_EQ_GT] = ACTIONS(3707),
    [sym_comment] = ACTIONS(5),
    [sym_substitution_regexp_modifiers] = ACTIONS(4411),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1469] = {
    [sym_heredoc_content] = STATE(1469),
    [anon_sym_RBRACE] = ACTIONS(3771),
    [anon_sym_COLON] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym_RPAREN] = ACTIONS(3771),
    [anon_sym_COMMA] = ACTIONS(3771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3771),
    [anon_sym_and] = ACTIONS(3771),
    [anon_sym_or] = ACTIONS(3771),
    [anon_sym_RBRACK] = ACTIONS(3771),
    [anon_sym_DASH_GT] = ACTIONS(3771),
    [anon_sym_PERCENT] = ACTIONS(3773),
    [anon_sym_LT] = ACTIONS(3773),
    [anon_sym_GT] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(3773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3771),
    [anon_sym_PLUS_EQ] = ACTIONS(3771),
    [anon_sym_DASH_EQ] = ACTIONS(3771),
    [anon_sym_DOT_EQ] = ACTIONS(3771),
    [anon_sym_STAR_EQ] = ACTIONS(3771),
    [anon_sym_SLASH_EQ] = ACTIONS(3771),
    [anon_sym_PERCENT_EQ] = ACTIONS(3771),
    [anon_sym_x_EQ] = ACTIONS(3771),
    [anon_sym_AMP_EQ] = ACTIONS(3771),
    [anon_sym_PIPE_EQ] = ACTIONS(3771),
    [anon_sym_CARET_EQ] = ACTIONS(3771),
    [anon_sym_LT_LT_EQ] = ACTIONS(3771),
    [anon_sym_GT_GT_EQ] = ACTIONS(3771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3771),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_STAR_STAR] = ACTIONS(3773),
    [anon_sym_PIPE_PIPE] = ACTIONS(3773),
    [anon_sym_SLASH_SLASH] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_PIPE] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3773),
    [anon_sym_GT_GT2] = ACTIONS(3773),
    [anon_sym_PLUS] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3773),
    [anon_sym_DOT] = ACTIONS(3773),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_SLASH] = ACTIONS(3773),
    [anon_sym_x] = ACTIONS(3773),
    [anon_sym_EQ_TILDE] = ACTIONS(3771),
    [anon_sym_BANG_TILDE] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3771),
    [anon_sym_BANG_EQ] = ACTIONS(3771),
    [anon_sym_eq] = ACTIONS(3771),
    [anon_sym_ne] = ACTIONS(3771),
    [anon_sym_LT_EQ_GT] = ACTIONS(3771),
    [anon_sym_cmp] = ACTIONS(3773),
    [anon_sym_TILDE_TILDE] = ACTIONS(3771),
    [anon_sym_LT_EQ] = ACTIONS(3773),
    [anon_sym_GT_EQ] = ACTIONS(3771),
    [anon_sym_lt] = ACTIONS(3771),
    [anon_sym_le] = ACTIONS(3771),
    [anon_sym_ge] = ACTIONS(3771),
    [anon_sym_gt] = ACTIONS(3771),
    [anon_sym_isa] = ACTIONS(3771),
    [anon_sym_PLUS_PLUS] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_EQ_GT] = ACTIONS(3771),
    [sym_comment] = ACTIONS(5),
    [sym_transliteration_modifiers] = ACTIONS(4413),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1470] = {
    [sym_attribute] = STATE(1651),
    [sym_attribute_name] = STATE(1620),
    [sym_heredoc_content] = STATE(1470),
    [aux_sym_attrlist_repeat1] = STATE(1474),
    [sym__identifier] = ACTIONS(4369),
    [anon_sym_COLON] = ACTIONS(4371),
    [anon_sym_SEMI] = ACTIONS(3420),
    [anon_sym_COMMA] = ACTIONS(3420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3420),
    [anon_sym_DASH_GT] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3422),
    [anon_sym_GT] = ACTIONS(3422),
    [anon_sym_LT_LT] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3422),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_x_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_DOT] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3422),
    [anon_sym_PIPE_PIPE] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_AMP_AMP] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(3422),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_GT_GT2] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_DASH] = ACTIONS(3422),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_STAR] = ACTIONS(3422),
    [anon_sym_SLASH] = ACTIONS(3422),
    [anon_sym_x] = ACTIONS(3422),
    [anon_sym_EQ_TILDE] = ACTIONS(3420),
    [anon_sym_BANG_TILDE] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3420),
    [anon_sym_BANG_EQ] = ACTIONS(3420),
    [anon_sym_eq] = ACTIONS(3422),
    [anon_sym_ne] = ACTIONS(3422),
    [anon_sym_LT_EQ_GT] = ACTIONS(3420),
    [anon_sym_cmp] = ACTIONS(3422),
    [anon_sym_TILDE_TILDE] = ACTIONS(3420),
    [anon_sym_LT_EQ] = ACTIONS(3422),
    [anon_sym_GT_EQ] = ACTIONS(3420),
    [anon_sym_lt] = ACTIONS(3422),
    [anon_sym_le] = ACTIONS(3422),
    [anon_sym_ge] = ACTIONS(3422),
    [anon_sym_gt] = ACTIONS(3422),
    [anon_sym_isa] = ACTIONS(3422),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_EQ_GT] = ACTIONS(3420),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4369),
    [sym__PERLY_SEMICOLON] = ACTIONS(3420),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1471] = {
    [sym_heredoc_content] = STATE(1471),
    [anon_sym_RBRACE] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym_RPAREN] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3729),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_or] = ACTIONS(3729),
    [anon_sym_RBRACK] = ACTIONS(3729),
    [anon_sym_DASH_GT] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3731),
    [anon_sym_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3731),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3729),
    [anon_sym_PLUS_EQ] = ACTIONS(3729),
    [anon_sym_DASH_EQ] = ACTIONS(3729),
    [anon_sym_DOT_EQ] = ACTIONS(3729),
    [anon_sym_STAR_EQ] = ACTIONS(3729),
    [anon_sym_SLASH_EQ] = ACTIONS(3729),
    [anon_sym_PERCENT_EQ] = ACTIONS(3729),
    [anon_sym_x_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3729),
    [anon_sym_PIPE_EQ] = ACTIONS(3729),
    [anon_sym_CARET_EQ] = ACTIONS(3729),
    [anon_sym_LT_LT_EQ] = ACTIONS(3729),
    [anon_sym_GT_GT_EQ] = ACTIONS(3729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3729),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3729),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3729),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_SLASH_SLASH] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_GT_GT2] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3731),
    [anon_sym_SLASH] = ACTIONS(3731),
    [anon_sym_x] = ACTIONS(3731),
    [anon_sym_EQ_TILDE] = ACTIONS(3729),
    [anon_sym_BANG_TILDE] = ACTIONS(3729),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_eq] = ACTIONS(3729),
    [anon_sym_ne] = ACTIONS(3731),
    [anon_sym_LT_EQ_GT] = ACTIONS(3729),
    [anon_sym_cmp] = ACTIONS(3731),
    [anon_sym_TILDE_TILDE] = ACTIONS(3729),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3729),
    [anon_sym_lt] = ACTIONS(3731),
    [anon_sym_le] = ACTIONS(3731),
    [anon_sym_ge] = ACTIONS(3731),
    [anon_sym_gt] = ACTIONS(3731),
    [anon_sym_isa] = ACTIONS(3731),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_QMARK] = ACTIONS(3729),
    [anon_sym_EQ_GT] = ACTIONS(3729),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4415),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1472] = {
    [sym_heredoc_content] = STATE(1472),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1473] = {
    [sym_heredoc_content] = STATE(1473),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(3823),
    [anon_sym_BANG_TILDE] = ACTIONS(3823),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1474] = {
    [sym_attribute] = STATE(1651),
    [sym_attribute_name] = STATE(1620),
    [sym_heredoc_content] = STATE(1474),
    [aux_sym_attrlist_repeat1] = STATE(1474),
    [sym__identifier] = ACTIONS(4417),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4417),
    [sym__PERLY_SEMICOLON] = ACTIONS(3408),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1475] = {
    [sym_heredoc_content] = STATE(1475),
    [anon_sym_SEMI] = ACTIONS(3835),
    [anon_sym_COMMA] = ACTIONS(3835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_and] = ACTIONS(3835),
    [anon_sym_or] = ACTIONS(3835),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4320),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4322),
    [anon_sym_PLUS_EQ] = ACTIONS(4322),
    [anon_sym_DASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_EQ] = ACTIONS(4322),
    [anon_sym_STAR_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_PERCENT_EQ] = ACTIONS(4322),
    [anon_sym_x_EQ] = ACTIONS(4322),
    [anon_sym_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_CARET_EQ] = ACTIONS(4322),
    [anon_sym_LT_LT_EQ] = ACTIONS(4322),
    [anon_sym_GT_GT_EQ] = ACTIONS(4322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4322),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4322),
    [anon_sym_DOT_DOT] = ACTIONS(4324),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4328),
    [anon_sym_SLASH_SLASH] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(3835),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3835),
    [anon_sym___END__] = ACTIONS(3835),
    [anon_sym_EOT] = ACTIONS(3835),
    [sym__PERLY_SEMICOLON] = ACTIONS(3835),
    [sym__ctrl_z_hack] = ACTIONS(3835),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1476] = {
    [sym_heredoc_content] = STATE(1476),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3831),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3833),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3831),
    [anon_sym_PLUS_EQ] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_EQ] = ACTIONS(3831),
    [anon_sym_STAR_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3831),
    [anon_sym_x_EQ] = ACTIONS(3831),
    [anon_sym_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3833),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3833),
    [anon_sym_SLASH_SLASH] = ACTIONS(3833),
    [anon_sym_AMP_AMP] = ACTIONS(3833),
    [anon_sym_PIPE] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(3833),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(3831),
    [anon_sym_BANG_EQ] = ACTIONS(3831),
    [anon_sym_eq] = ACTIONS(3831),
    [anon_sym_ne] = ACTIONS(3831),
    [anon_sym_LT_EQ_GT] = ACTIONS(3831),
    [anon_sym_cmp] = ACTIONS(3831),
    [anon_sym_TILDE_TILDE] = ACTIONS(3831),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3831),
    [anon_sym_EQ_GT] = ACTIONS(3831),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3831),
    [anon_sym___END__] = ACTIONS(3831),
    [anon_sym_EOT] = ACTIONS(3831),
    [sym__PERLY_SEMICOLON] = ACTIONS(3831),
    [sym__ctrl_z_hack] = ACTIONS(3831),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1477] = {
    [sym_heredoc_content] = STATE(1477),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4154),
    [anon_sym_PLUS_EQ] = ACTIONS(4154),
    [anon_sym_DASH_EQ] = ACTIONS(4154),
    [anon_sym_DOT_EQ] = ACTIONS(4154),
    [anon_sym_STAR_EQ] = ACTIONS(4154),
    [anon_sym_SLASH_EQ] = ACTIONS(4154),
    [anon_sym_PERCENT_EQ] = ACTIONS(4154),
    [anon_sym_x_EQ] = ACTIONS(4154),
    [anon_sym_AMP_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_CARET_EQ] = ACTIONS(4154),
    [anon_sym_LT_LT_EQ] = ACTIONS(4154),
    [anon_sym_GT_GT_EQ] = ACTIONS(4154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4154),
    [anon_sym_DOT_DOT] = ACTIONS(4324),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4328),
    [anon_sym_SLASH_SLASH] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4154),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(4154),
    [anon_sym___END__] = ACTIONS(4154),
    [anon_sym_EOT] = ACTIONS(4154),
    [sym__PERLY_SEMICOLON] = ACTIONS(4154),
    [sym__ctrl_z_hack] = ACTIONS(4154),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1478] = {
    [sym_heredoc_content] = STATE(1478),
    [anon_sym_RBRACE] = ACTIONS(3572),
    [anon_sym_COLON] = ACTIONS(3572),
    [anon_sym_SEMI] = ACTIONS(3572),
    [anon_sym_RPAREN] = ACTIONS(3572),
    [anon_sym_COMMA] = ACTIONS(3572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3572),
    [anon_sym_and] = ACTIONS(3572),
    [anon_sym_or] = ACTIONS(3572),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(3572),
    [anon_sym_DASH_GT] = ACTIONS(3572),
    [anon_sym_PERCENT] = ACTIONS(3576),
    [anon_sym_LT] = ACTIONS(3576),
    [anon_sym_GT] = ACTIONS(3576),
    [anon_sym_LT_LT] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(3576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3572),
    [anon_sym_PLUS_EQ] = ACTIONS(3572),
    [anon_sym_DASH_EQ] = ACTIONS(3572),
    [anon_sym_DOT_EQ] = ACTIONS(3572),
    [anon_sym_STAR_EQ] = ACTIONS(3572),
    [anon_sym_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_PERCENT_EQ] = ACTIONS(3572),
    [anon_sym_x_EQ] = ACTIONS(3572),
    [anon_sym_AMP_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_CARET_EQ] = ACTIONS(3572),
    [anon_sym_LT_LT_EQ] = ACTIONS(3572),
    [anon_sym_GT_GT_EQ] = ACTIONS(3572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_DOT_DOT] = ACTIONS(3576),
    [anon_sym_STAR_STAR] = ACTIONS(3576),
    [anon_sym_PIPE_PIPE] = ACTIONS(3576),
    [anon_sym_SLASH_SLASH] = ACTIONS(3576),
    [anon_sym_AMP_AMP] = ACTIONS(3576),
    [anon_sym_PIPE] = ACTIONS(3576),
    [anon_sym_AMP] = ACTIONS(3576),
    [anon_sym_GT_GT2] = ACTIONS(3576),
    [anon_sym_PLUS] = ACTIONS(3576),
    [anon_sym_DASH] = ACTIONS(3576),
    [anon_sym_DOT] = ACTIONS(3576),
    [anon_sym_STAR] = ACTIONS(3576),
    [anon_sym_SLASH] = ACTIONS(3576),
    [anon_sym_x] = ACTIONS(3576),
    [anon_sym_EQ_TILDE] = ACTIONS(3572),
    [anon_sym_BANG_TILDE] = ACTIONS(3572),
    [anon_sym_EQ_EQ] = ACTIONS(3572),
    [anon_sym_BANG_EQ] = ACTIONS(3572),
    [anon_sym_eq] = ACTIONS(3572),
    [anon_sym_ne] = ACTIONS(3572),
    [anon_sym_LT_EQ_GT] = ACTIONS(3572),
    [anon_sym_cmp] = ACTIONS(3572),
    [anon_sym_TILDE_TILDE] = ACTIONS(3572),
    [anon_sym_LT_EQ] = ACTIONS(3576),
    [anon_sym_GT_EQ] = ACTIONS(3572),
    [anon_sym_lt] = ACTIONS(3572),
    [anon_sym_le] = ACTIONS(3572),
    [anon_sym_ge] = ACTIONS(3572),
    [anon_sym_gt] = ACTIONS(3572),
    [anon_sym_isa] = ACTIONS(3572),
    [anon_sym_PLUS_PLUS] = ACTIONS(3572),
    [anon_sym_DASH_DASH] = ACTIONS(3572),
    [anon_sym_QMARK] = ACTIONS(3572),
    [anon_sym_EQ_GT] = ACTIONS(3572),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1479] = {
    [sym_heredoc_content] = STATE(1479),
    [anon_sym_SEMI] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3885),
    [anon_sym_PLUS_EQ] = ACTIONS(3885),
    [anon_sym_DASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_EQ] = ACTIONS(3885),
    [anon_sym_STAR_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_PERCENT_EQ] = ACTIONS(3885),
    [anon_sym_x_EQ] = ACTIONS(3885),
    [anon_sym_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_CARET_EQ] = ACTIONS(3885),
    [anon_sym_LT_LT_EQ] = ACTIONS(3885),
    [anon_sym_GT_GT_EQ] = ACTIONS(3885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_DOT] = ACTIONS(3887),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3887),
    [anon_sym_SLASH_SLASH] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4425),
    [anon_sym_cmp] = ACTIONS(4425),
    [anon_sym_TILDE_TILDE] = ACTIONS(4425),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_EQ_GT] = ACTIONS(3885),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3885),
    [anon_sym___END__] = ACTIONS(3885),
    [anon_sym_EOT] = ACTIONS(3885),
    [sym__PERLY_SEMICOLON] = ACTIONS(3885),
    [sym__ctrl_z_hack] = ACTIONS(3885),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1480] = {
    [sym_heredoc_content] = STATE(1480),
    [anon_sym_SEMI] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3885),
    [anon_sym_PLUS_EQ] = ACTIONS(3885),
    [anon_sym_DASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_EQ] = ACTIONS(3885),
    [anon_sym_STAR_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_PERCENT_EQ] = ACTIONS(3885),
    [anon_sym_x_EQ] = ACTIONS(3885),
    [anon_sym_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_CARET_EQ] = ACTIONS(3885),
    [anon_sym_LT_LT_EQ] = ACTIONS(3885),
    [anon_sym_GT_GT_EQ] = ACTIONS(3885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_DOT] = ACTIONS(3887),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3887),
    [anon_sym_SLASH_SLASH] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_eq] = ACTIONS(3885),
    [anon_sym_ne] = ACTIONS(3885),
    [anon_sym_LT_EQ_GT] = ACTIONS(3885),
    [anon_sym_cmp] = ACTIONS(3885),
    [anon_sym_TILDE_TILDE] = ACTIONS(3885),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_EQ_GT] = ACTIONS(3885),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3885),
    [anon_sym___END__] = ACTIONS(3885),
    [anon_sym_EOT] = ACTIONS(3885),
    [sym__PERLY_SEMICOLON] = ACTIONS(3885),
    [sym__ctrl_z_hack] = ACTIONS(3885),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1481] = {
    [sym_heredoc_content] = STATE(1481),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(3823),
    [anon_sym_BANG_TILDE] = ACTIONS(3823),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1482] = {
    [sym_heredoc_content] = STATE(1482),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1483] = {
    [sym__PERLY_BRACE_OPEN] = STATE(263),
    [sym_block] = STATE(1846),
    [sym_heredoc_content] = STATE(1483),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_COLON] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym_prototype_or_signature] = ACTIONS(4429),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1484] = {
    [sym__PERLY_BRACE_OPEN] = STATE(263),
    [sym_block] = STATE(1847),
    [sym_heredoc_content] = STATE(1484),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym_prototype_or_signature] = ACTIONS(4433),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1485] = {
    [sym_heredoc_content] = STATE(1485),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1486] = {
    [sym_heredoc_content] = STATE(1486),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1487] = {
    [sym_heredoc_content] = STATE(1487),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4334),
    [anon_sym_GT_GT2] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_x] = ACTIONS(4314),
    [anon_sym_EQ_TILDE] = ACTIONS(4338),
    [anon_sym_BANG_TILDE] = ACTIONS(4338),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_eq] = ACTIONS(4340),
    [anon_sym_ne] = ACTIONS(4340),
    [anon_sym_LT_EQ_GT] = ACTIONS(4342),
    [anon_sym_cmp] = ACTIONS(4342),
    [anon_sym_TILDE_TILDE] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4344),
    [anon_sym_lt] = ACTIONS(4344),
    [anon_sym_le] = ACTIONS(4344),
    [anon_sym_ge] = ACTIONS(4344),
    [anon_sym_gt] = ACTIONS(4344),
    [anon_sym_isa] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [anon_sym___DATA__] = ACTIONS(3823),
    [anon_sym___END__] = ACTIONS(3823),
    [anon_sym_EOT] = ACTIONS(3823),
    [sym__PERLY_SEMICOLON] = ACTIONS(3823),
    [sym__ctrl_z_hack] = ACTIONS(3823),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1488] = {
    [sym_heredoc_content] = STATE(1488),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_COLON] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3877),
    [anon_sym_RPAREN] = ACTIONS(3877),
    [anon_sym_COMMA] = ACTIONS(3877),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3877),
    [anon_sym_and] = ACTIONS(3877),
    [anon_sym_or] = ACTIONS(3877),
    [anon_sym_RBRACK] = ACTIONS(3877),
    [anon_sym_DASH_GT] = ACTIONS(3877),
    [anon_sym_PERCENT] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3877),
    [anon_sym_PLUS_EQ] = ACTIONS(3877),
    [anon_sym_DASH_EQ] = ACTIONS(3877),
    [anon_sym_DOT_EQ] = ACTIONS(3877),
    [anon_sym_STAR_EQ] = ACTIONS(3877),
    [anon_sym_SLASH_EQ] = ACTIONS(3877),
    [anon_sym_PERCENT_EQ] = ACTIONS(3877),
    [anon_sym_x_EQ] = ACTIONS(3877),
    [anon_sym_AMP_EQ] = ACTIONS(3877),
    [anon_sym_PIPE_EQ] = ACTIONS(3877),
    [anon_sym_CARET_EQ] = ACTIONS(3877),
    [anon_sym_LT_LT_EQ] = ACTIONS(3877),
    [anon_sym_GT_GT_EQ] = ACTIONS(3877),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3877),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3877),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3877),
    [anon_sym_DOT_DOT] = ACTIONS(3879),
    [anon_sym_STAR_STAR] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [anon_sym_SLASH_SLASH] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT2] = ACTIONS(3879),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_DOT] = ACTIONS(3879),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_SLASH] = ACTIONS(3879),
    [anon_sym_x] = ACTIONS(3879),
    [anon_sym_EQ_TILDE] = ACTIONS(3877),
    [anon_sym_BANG_TILDE] = ACTIONS(3877),
    [anon_sym_EQ_EQ] = ACTIONS(3877),
    [anon_sym_BANG_EQ] = ACTIONS(3877),
    [anon_sym_eq] = ACTIONS(3877),
    [anon_sym_ne] = ACTIONS(3877),
    [anon_sym_LT_EQ_GT] = ACTIONS(3877),
    [anon_sym_cmp] = ACTIONS(3877),
    [anon_sym_TILDE_TILDE] = ACTIONS(3877),
    [anon_sym_LT_EQ] = ACTIONS(3879),
    [anon_sym_GT_EQ] = ACTIONS(3877),
    [anon_sym_lt] = ACTIONS(3877),
    [anon_sym_le] = ACTIONS(3877),
    [anon_sym_ge] = ACTIONS(3877),
    [anon_sym_gt] = ACTIONS(3877),
    [anon_sym_isa] = ACTIONS(3877),
    [anon_sym_PLUS_PLUS] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3877),
    [anon_sym_QMARK] = ACTIONS(3877),
    [anon_sym_EQ_GT] = ACTIONS(3877),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1489] = {
    [sym_heredoc_content] = STATE(1489),
    [anon_sym_RBRACE] = ACTIONS(3977),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3977),
    [anon_sym_and] = ACTIONS(3977),
    [anon_sym_or] = ACTIONS(3977),
    [anon_sym_RBRACK] = ACTIONS(3977),
    [anon_sym_DASH_GT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3979),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3977),
    [anon_sym_PLUS_EQ] = ACTIONS(3977),
    [anon_sym_DASH_EQ] = ACTIONS(3977),
    [anon_sym_DOT_EQ] = ACTIONS(3977),
    [anon_sym_STAR_EQ] = ACTIONS(3977),
    [anon_sym_SLASH_EQ] = ACTIONS(3977),
    [anon_sym_PERCENT_EQ] = ACTIONS(3977),
    [anon_sym_x_EQ] = ACTIONS(3977),
    [anon_sym_AMP_EQ] = ACTIONS(3977),
    [anon_sym_PIPE_EQ] = ACTIONS(3977),
    [anon_sym_CARET_EQ] = ACTIONS(3977),
    [anon_sym_LT_LT_EQ] = ACTIONS(3977),
    [anon_sym_GT_GT_EQ] = ACTIONS(3977),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3977),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3977),
    [anon_sym_DOT_DOT] = ACTIONS(3979),
    [anon_sym_STAR_STAR] = ACTIONS(3979),
    [anon_sym_PIPE_PIPE] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3979),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_GT_GT2] = ACTIONS(3979),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_x] = ACTIONS(3979),
    [anon_sym_EQ_TILDE] = ACTIONS(3977),
    [anon_sym_BANG_TILDE] = ACTIONS(3977),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_eq] = ACTIONS(3977),
    [anon_sym_ne] = ACTIONS(3977),
    [anon_sym_LT_EQ_GT] = ACTIONS(3977),
    [anon_sym_cmp] = ACTIONS(3977),
    [anon_sym_TILDE_TILDE] = ACTIONS(3977),
    [anon_sym_LT_EQ] = ACTIONS(3979),
    [anon_sym_GT_EQ] = ACTIONS(3977),
    [anon_sym_lt] = ACTIONS(3977),
    [anon_sym_le] = ACTIONS(3977),
    [anon_sym_ge] = ACTIONS(3977),
    [anon_sym_gt] = ACTIONS(3977),
    [anon_sym_isa] = ACTIONS(3977),
    [anon_sym_PLUS_PLUS] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_EQ_GT] = ACTIONS(3977),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1490] = {
    [sym_heredoc_content] = STATE(1490),
    [anon_sym_RBRACE] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4238),
    [anon_sym_SEMI] = ACTIONS(4238),
    [anon_sym_RPAREN] = ACTIONS(4238),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4238),
    [anon_sym_and] = ACTIONS(4238),
    [anon_sym_or] = ACTIONS(4238),
    [anon_sym_RBRACK] = ACTIONS(4238),
    [anon_sym_DASH_GT] = ACTIONS(4238),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_LT] = ACTIONS(4240),
    [anon_sym_GT] = ACTIONS(4240),
    [anon_sym_LT_LT] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4238),
    [anon_sym_PLUS_EQ] = ACTIONS(4238),
    [anon_sym_DASH_EQ] = ACTIONS(4238),
    [anon_sym_DOT_EQ] = ACTIONS(4238),
    [anon_sym_STAR_EQ] = ACTIONS(4238),
    [anon_sym_SLASH_EQ] = ACTIONS(4238),
    [anon_sym_PERCENT_EQ] = ACTIONS(4238),
    [anon_sym_x_EQ] = ACTIONS(4238),
    [anon_sym_AMP_EQ] = ACTIONS(4238),
    [anon_sym_PIPE_EQ] = ACTIONS(4238),
    [anon_sym_CARET_EQ] = ACTIONS(4238),
    [anon_sym_LT_LT_EQ] = ACTIONS(4238),
    [anon_sym_GT_GT_EQ] = ACTIONS(4238),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4238),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4238),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4238),
    [anon_sym_DOT_DOT] = ACTIONS(4240),
    [anon_sym_STAR_STAR] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_SLASH_SLASH] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_GT_GT2] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_SLASH] = ACTIONS(4240),
    [anon_sym_x] = ACTIONS(4240),
    [anon_sym_EQ_TILDE] = ACTIONS(4238),
    [anon_sym_BANG_TILDE] = ACTIONS(4238),
    [anon_sym_EQ_EQ] = ACTIONS(4238),
    [anon_sym_BANG_EQ] = ACTIONS(4238),
    [anon_sym_eq] = ACTIONS(4238),
    [anon_sym_ne] = ACTIONS(4238),
    [anon_sym_LT_EQ_GT] = ACTIONS(4238),
    [anon_sym_cmp] = ACTIONS(4238),
    [anon_sym_TILDE_TILDE] = ACTIONS(4238),
    [anon_sym_LT_EQ] = ACTIONS(4240),
    [anon_sym_GT_EQ] = ACTIONS(4238),
    [anon_sym_lt] = ACTIONS(4238),
    [anon_sym_le] = ACTIONS(4238),
    [anon_sym_ge] = ACTIONS(4238),
    [anon_sym_gt] = ACTIONS(4238),
    [anon_sym_isa] = ACTIONS(4238),
    [anon_sym_PLUS_PLUS] = ACTIONS(4238),
    [anon_sym_DASH_DASH] = ACTIONS(4238),
    [anon_sym_QMARK] = ACTIONS(4238),
    [anon_sym_EQ_GT] = ACTIONS(4238),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1491] = {
    [sym_heredoc_content] = STATE(1491),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4242),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_RBRACK] = ACTIONS(4242),
    [anon_sym_DASH_GT] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_DOT_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_x_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_SLASH_SLASH] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_GT_GT2] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_x] = ACTIONS(4244),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4242),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_eq] = ACTIONS(4242),
    [anon_sym_ne] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_cmp] = ACTIONS(4242),
    [anon_sym_TILDE_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_lt] = ACTIONS(4242),
    [anon_sym_le] = ACTIONS(4242),
    [anon_sym_ge] = ACTIONS(4242),
    [anon_sym_gt] = ACTIONS(4242),
    [anon_sym_isa] = ACTIONS(4242),
    [anon_sym_PLUS_PLUS] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1492] = {
    [sym_heredoc_content] = STATE(1492),
    [anon_sym_RBRACE] = ACTIONS(4254),
    [anon_sym_COLON] = ACTIONS(4254),
    [anon_sym_SEMI] = ACTIONS(4254),
    [anon_sym_RPAREN] = ACTIONS(4254),
    [anon_sym_COMMA] = ACTIONS(4254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4254),
    [anon_sym_and] = ACTIONS(4254),
    [anon_sym_or] = ACTIONS(4254),
    [anon_sym_RBRACK] = ACTIONS(4254),
    [anon_sym_DASH_GT] = ACTIONS(4254),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4256),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4254),
    [anon_sym_PLUS_EQ] = ACTIONS(4254),
    [anon_sym_DASH_EQ] = ACTIONS(4254),
    [anon_sym_DOT_EQ] = ACTIONS(4254),
    [anon_sym_STAR_EQ] = ACTIONS(4254),
    [anon_sym_SLASH_EQ] = ACTIONS(4254),
    [anon_sym_PERCENT_EQ] = ACTIONS(4254),
    [anon_sym_x_EQ] = ACTIONS(4254),
    [anon_sym_AMP_EQ] = ACTIONS(4254),
    [anon_sym_PIPE_EQ] = ACTIONS(4254),
    [anon_sym_CARET_EQ] = ACTIONS(4254),
    [anon_sym_LT_LT_EQ] = ACTIONS(4254),
    [anon_sym_GT_GT_EQ] = ACTIONS(4254),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4254),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4254),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4254),
    [anon_sym_DOT_DOT] = ACTIONS(4256),
    [anon_sym_STAR_STAR] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4256),
    [anon_sym_SLASH_SLASH] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4256),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_GT_GT2] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_x] = ACTIONS(4256),
    [anon_sym_EQ_TILDE] = ACTIONS(4254),
    [anon_sym_BANG_TILDE] = ACTIONS(4254),
    [anon_sym_EQ_EQ] = ACTIONS(4254),
    [anon_sym_BANG_EQ] = ACTIONS(4254),
    [anon_sym_eq] = ACTIONS(4254),
    [anon_sym_ne] = ACTIONS(4254),
    [anon_sym_LT_EQ_GT] = ACTIONS(4254),
    [anon_sym_cmp] = ACTIONS(4254),
    [anon_sym_TILDE_TILDE] = ACTIONS(4254),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4254),
    [anon_sym_lt] = ACTIONS(4254),
    [anon_sym_le] = ACTIONS(4254),
    [anon_sym_ge] = ACTIONS(4254),
    [anon_sym_gt] = ACTIONS(4254),
    [anon_sym_isa] = ACTIONS(4254),
    [anon_sym_PLUS_PLUS] = ACTIONS(4254),
    [anon_sym_DASH_DASH] = ACTIONS(4254),
    [anon_sym_QMARK] = ACTIONS(4254),
    [anon_sym_EQ_GT] = ACTIONS(4254),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1493] = {
    [sym_heredoc_content] = STATE(1493),
    [anon_sym_RBRACE] = ACTIONS(4258),
    [anon_sym_COLON] = ACTIONS(4258),
    [anon_sym_SEMI] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(4258),
    [anon_sym_COMMA] = ACTIONS(4258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4258),
    [anon_sym_and] = ACTIONS(4258),
    [anon_sym_or] = ACTIONS(4258),
    [anon_sym_RBRACK] = ACTIONS(4258),
    [anon_sym_DASH_GT] = ACTIONS(4258),
    [anon_sym_PERCENT] = ACTIONS(4260),
    [anon_sym_LT] = ACTIONS(4260),
    [anon_sym_GT] = ACTIONS(4260),
    [anon_sym_LT_LT] = ACTIONS(4260),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_DOT_EQ] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_x_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_DOT_DOT] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4260),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_SLASH_SLASH] = ACTIONS(4260),
    [anon_sym_AMP_AMP] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_AMP] = ACTIONS(4260),
    [anon_sym_GT_GT2] = ACTIONS(4260),
    [anon_sym_PLUS] = ACTIONS(4260),
    [anon_sym_DASH] = ACTIONS(4260),
    [anon_sym_DOT] = ACTIONS(4260),
    [anon_sym_STAR] = ACTIONS(4260),
    [anon_sym_SLASH] = ACTIONS(4260),
    [anon_sym_x] = ACTIONS(4260),
    [anon_sym_EQ_TILDE] = ACTIONS(4258),
    [anon_sym_BANG_TILDE] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4258),
    [anon_sym_BANG_EQ] = ACTIONS(4258),
    [anon_sym_eq] = ACTIONS(4258),
    [anon_sym_ne] = ACTIONS(4258),
    [anon_sym_LT_EQ_GT] = ACTIONS(4258),
    [anon_sym_cmp] = ACTIONS(4258),
    [anon_sym_TILDE_TILDE] = ACTIONS(4258),
    [anon_sym_LT_EQ] = ACTIONS(4260),
    [anon_sym_GT_EQ] = ACTIONS(4258),
    [anon_sym_lt] = ACTIONS(4258),
    [anon_sym_le] = ACTIONS(4258),
    [anon_sym_ge] = ACTIONS(4258),
    [anon_sym_gt] = ACTIONS(4258),
    [anon_sym_isa] = ACTIONS(4258),
    [anon_sym_PLUS_PLUS] = ACTIONS(4258),
    [anon_sym_DASH_DASH] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_EQ_GT] = ACTIONS(4258),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1494] = {
    [sym_heredoc_content] = STATE(1494),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym_RPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4174),
    [anon_sym_and] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_RBRACK] = ACTIONS(4174),
    [anon_sym_DASH_GT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4176),
    [anon_sym_GT] = ACTIONS(4176),
    [anon_sym_LT_LT] = ACTIONS(4176),
    [anon_sym_EQ] = ACTIONS(4176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4174),
    [anon_sym_PLUS_EQ] = ACTIONS(4174),
    [anon_sym_DASH_EQ] = ACTIONS(4174),
    [anon_sym_DOT_EQ] = ACTIONS(4174),
    [anon_sym_STAR_EQ] = ACTIONS(4174),
    [anon_sym_SLASH_EQ] = ACTIONS(4174),
    [anon_sym_PERCENT_EQ] = ACTIONS(4174),
    [anon_sym_x_EQ] = ACTIONS(4174),
    [anon_sym_AMP_EQ] = ACTIONS(4174),
    [anon_sym_PIPE_EQ] = ACTIONS(4174),
    [anon_sym_CARET_EQ] = ACTIONS(4174),
    [anon_sym_LT_LT_EQ] = ACTIONS(4174),
    [anon_sym_GT_GT_EQ] = ACTIONS(4174),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4174),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4174),
    [anon_sym_DOT_DOT] = ACTIONS(4176),
    [anon_sym_STAR_STAR] = ACTIONS(4176),
    [anon_sym_PIPE_PIPE] = ACTIONS(4176),
    [anon_sym_SLASH_SLASH] = ACTIONS(4176),
    [anon_sym_AMP_AMP] = ACTIONS(4176),
    [anon_sym_PIPE] = ACTIONS(4176),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_GT_GT2] = ACTIONS(4176),
    [anon_sym_PLUS] = ACTIONS(4176),
    [anon_sym_DASH] = ACTIONS(4176),
    [anon_sym_DOT] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(4176),
    [anon_sym_SLASH] = ACTIONS(4176),
    [anon_sym_x] = ACTIONS(4176),
    [anon_sym_EQ_TILDE] = ACTIONS(4174),
    [anon_sym_BANG_TILDE] = ACTIONS(4174),
    [anon_sym_EQ_EQ] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_eq] = ACTIONS(4174),
    [anon_sym_ne] = ACTIONS(4174),
    [anon_sym_LT_EQ_GT] = ACTIONS(4174),
    [anon_sym_cmp] = ACTIONS(4174),
    [anon_sym_TILDE_TILDE] = ACTIONS(4174),
    [anon_sym_LT_EQ] = ACTIONS(4176),
    [anon_sym_GT_EQ] = ACTIONS(4174),
    [anon_sym_lt] = ACTIONS(4174),
    [anon_sym_le] = ACTIONS(4174),
    [anon_sym_ge] = ACTIONS(4174),
    [anon_sym_gt] = ACTIONS(4174),
    [anon_sym_isa] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4174),
    [anon_sym_DASH_DASH] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_EQ_GT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1495] = {
    [sym_heredoc_content] = STATE(1495),
    [anon_sym_RBRACE] = ACTIONS(4130),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_SEMI] = ACTIONS(4130),
    [anon_sym_RPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_RBRACK] = ACTIONS(4130),
    [anon_sym_DASH_GT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4132),
    [anon_sym_GT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(4132),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4130),
    [anon_sym_DASH_EQ] = ACTIONS(4130),
    [anon_sym_DOT_EQ] = ACTIONS(4130),
    [anon_sym_STAR_EQ] = ACTIONS(4130),
    [anon_sym_SLASH_EQ] = ACTIONS(4130),
    [anon_sym_PERCENT_EQ] = ACTIONS(4130),
    [anon_sym_x_EQ] = ACTIONS(4130),
    [anon_sym_AMP_EQ] = ACTIONS(4130),
    [anon_sym_PIPE_EQ] = ACTIONS(4130),
    [anon_sym_CARET_EQ] = ACTIONS(4130),
    [anon_sym_LT_LT_EQ] = ACTIONS(4130),
    [anon_sym_GT_GT_EQ] = ACTIONS(4130),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4130),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_STAR_STAR] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_SLASH_SLASH] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4132),
    [anon_sym_AMP] = ACTIONS(4132),
    [anon_sym_GT_GT2] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4132),
    [anon_sym_DASH] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4132),
    [anon_sym_x] = ACTIONS(4132),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_EQ_EQ] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_eq] = ACTIONS(4130),
    [anon_sym_ne] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_cmp] = ACTIONS(4130),
    [anon_sym_TILDE_TILDE] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4130),
    [anon_sym_lt] = ACTIONS(4130),
    [anon_sym_le] = ACTIONS(4130),
    [anon_sym_ge] = ACTIONS(4130),
    [anon_sym_gt] = ACTIONS(4130),
    [anon_sym_isa] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4130),
    [anon_sym_DASH_DASH] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4130),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1496] = {
    [sym_heredoc_content] = STATE(1496),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_and] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2936),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_EQ] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_x_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2936),
    [anon_sym_BANG_TILDE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_eq] = ACTIONS(2936),
    [anon_sym_ne] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_cmp] = ACTIONS(2936),
    [anon_sym_TILDE_TILDE] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_lt] = ACTIONS(2936),
    [anon_sym_le] = ACTIONS(2936),
    [anon_sym_ge] = ACTIONS(2936),
    [anon_sym_gt] = ACTIONS(2936),
    [anon_sym_isa] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1497] = {
    [sym_heredoc_content] = STATE(1497),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_SEMI] = ACTIONS(4120),
    [anon_sym_RPAREN] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_RBRACK] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4122),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4120),
    [anon_sym_PLUS_EQ] = ACTIONS(4120),
    [anon_sym_DASH_EQ] = ACTIONS(4120),
    [anon_sym_DOT_EQ] = ACTIONS(4120),
    [anon_sym_STAR_EQ] = ACTIONS(4120),
    [anon_sym_SLASH_EQ] = ACTIONS(4120),
    [anon_sym_PERCENT_EQ] = ACTIONS(4120),
    [anon_sym_x_EQ] = ACTIONS(4120),
    [anon_sym_AMP_EQ] = ACTIONS(4120),
    [anon_sym_PIPE_EQ] = ACTIONS(4120),
    [anon_sym_CARET_EQ] = ACTIONS(4120),
    [anon_sym_LT_LT_EQ] = ACTIONS(4120),
    [anon_sym_GT_GT_EQ] = ACTIONS(4120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4120),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_STAR_STAR] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_SLASH_SLASH] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4122),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_GT_GT2] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4122),
    [anon_sym_x] = ACTIONS(4122),
    [anon_sym_EQ_TILDE] = ACTIONS(4120),
    [anon_sym_BANG_TILDE] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_eq] = ACTIONS(4120),
    [anon_sym_ne] = ACTIONS(4120),
    [anon_sym_LT_EQ_GT] = ACTIONS(4120),
    [anon_sym_cmp] = ACTIONS(4120),
    [anon_sym_TILDE_TILDE] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_lt] = ACTIONS(4120),
    [anon_sym_le] = ACTIONS(4120),
    [anon_sym_ge] = ACTIONS(4120),
    [anon_sym_gt] = ACTIONS(4120),
    [anon_sym_isa] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1498] = {
    [sym_heredoc_content] = STATE(1498),
    [anon_sym_RBRACE] = ACTIONS(4112),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_RPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4112),
    [anon_sym_and] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_RBRACK] = ACTIONS(4112),
    [anon_sym_DASH_GT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(4114),
    [anon_sym_GT] = ACTIONS(4114),
    [anon_sym_LT_LT] = ACTIONS(4114),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4112),
    [anon_sym_PLUS_EQ] = ACTIONS(4112),
    [anon_sym_DASH_EQ] = ACTIONS(4112),
    [anon_sym_DOT_EQ] = ACTIONS(4112),
    [anon_sym_STAR_EQ] = ACTIONS(4112),
    [anon_sym_SLASH_EQ] = ACTIONS(4112),
    [anon_sym_PERCENT_EQ] = ACTIONS(4112),
    [anon_sym_x_EQ] = ACTIONS(4112),
    [anon_sym_AMP_EQ] = ACTIONS(4112),
    [anon_sym_PIPE_EQ] = ACTIONS(4112),
    [anon_sym_CARET_EQ] = ACTIONS(4112),
    [anon_sym_LT_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_GT_EQ] = ACTIONS(4112),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4112),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT] = ACTIONS(4114),
    [anon_sym_STAR_STAR] = ACTIONS(4114),
    [anon_sym_PIPE_PIPE] = ACTIONS(4114),
    [anon_sym_SLASH_SLASH] = ACTIONS(4114),
    [anon_sym_AMP_AMP] = ACTIONS(4114),
    [anon_sym_PIPE] = ACTIONS(4114),
    [anon_sym_AMP] = ACTIONS(4114),
    [anon_sym_GT_GT2] = ACTIONS(4114),
    [anon_sym_PLUS] = ACTIONS(4114),
    [anon_sym_DASH] = ACTIONS(4114),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_STAR] = ACTIONS(4114),
    [anon_sym_SLASH] = ACTIONS(4114),
    [anon_sym_x] = ACTIONS(4114),
    [anon_sym_EQ_TILDE] = ACTIONS(4112),
    [anon_sym_BANG_TILDE] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_eq] = ACTIONS(4112),
    [anon_sym_ne] = ACTIONS(4112),
    [anon_sym_LT_EQ_GT] = ACTIONS(4112),
    [anon_sym_cmp] = ACTIONS(4112),
    [anon_sym_TILDE_TILDE] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4114),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_lt] = ACTIONS(4112),
    [anon_sym_le] = ACTIONS(4112),
    [anon_sym_ge] = ACTIONS(4112),
    [anon_sym_gt] = ACTIONS(4112),
    [anon_sym_isa] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_EQ_GT] = ACTIONS(4112),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1499] = {
    [sym_heredoc_content] = STATE(1499),
    [anon_sym_RBRACE] = ACTIONS(4048),
    [anon_sym_COLON] = ACTIONS(4048),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4048),
    [anon_sym_and] = ACTIONS(4048),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_RBRACK] = ACTIONS(4048),
    [anon_sym_DASH_GT] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4048),
    [anon_sym_PLUS_EQ] = ACTIONS(4048),
    [anon_sym_DASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_EQ] = ACTIONS(4048),
    [anon_sym_STAR_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_PERCENT_EQ] = ACTIONS(4048),
    [anon_sym_x_EQ] = ACTIONS(4048),
    [anon_sym_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_CARET_EQ] = ACTIONS(4048),
    [anon_sym_LT_LT_EQ] = ACTIONS(4048),
    [anon_sym_GT_GT_EQ] = ACTIONS(4048),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4052),
    [anon_sym_STAR_STAR] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_SLASH_SLASH] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_GT_GT2] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_x] = ACTIONS(4052),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_EQ_EQ] = ACTIONS(4048),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_eq] = ACTIONS(4048),
    [anon_sym_ne] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_cmp] = ACTIONS(4048),
    [anon_sym_TILDE_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4052),
    [anon_sym_GT_EQ] = ACTIONS(4048),
    [anon_sym_lt] = ACTIONS(4048),
    [anon_sym_le] = ACTIONS(4048),
    [anon_sym_ge] = ACTIONS(4048),
    [anon_sym_gt] = ACTIONS(4048),
    [anon_sym_isa] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4048),
    [anon_sym_DASH_DASH] = ACTIONS(4048),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4048),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1500] = {
    [sym_heredoc_content] = STATE(1500),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_RBRACK] = ACTIONS(4158),
    [anon_sym_DASH_GT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_LT_LT] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4158),
    [anon_sym_PLUS_EQ] = ACTIONS(4158),
    [anon_sym_DASH_EQ] = ACTIONS(4158),
    [anon_sym_DOT_EQ] = ACTIONS(4158),
    [anon_sym_STAR_EQ] = ACTIONS(4158),
    [anon_sym_SLASH_EQ] = ACTIONS(4158),
    [anon_sym_PERCENT_EQ] = ACTIONS(4158),
    [anon_sym_x_EQ] = ACTIONS(4158),
    [anon_sym_AMP_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_CARET_EQ] = ACTIONS(4158),
    [anon_sym_LT_LT_EQ] = ACTIONS(4158),
    [anon_sym_GT_GT_EQ] = ACTIONS(4158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4158),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_STAR_STAR] = ACTIONS(4160),
    [anon_sym_PIPE_PIPE] = ACTIONS(4160),
    [anon_sym_SLASH_SLASH] = ACTIONS(4160),
    [anon_sym_AMP_AMP] = ACTIONS(4160),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_GT_GT2] = ACTIONS(4160),
    [anon_sym_PLUS] = ACTIONS(4160),
    [anon_sym_DASH] = ACTIONS(4160),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_STAR] = ACTIONS(4160),
    [anon_sym_SLASH] = ACTIONS(4160),
    [anon_sym_x] = ACTIONS(4160),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_EQ_EQ] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_eq] = ACTIONS(4158),
    [anon_sym_ne] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_cmp] = ACTIONS(4158),
    [anon_sym_TILDE_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_lt] = ACTIONS(4158),
    [anon_sym_le] = ACTIONS(4158),
    [anon_sym_ge] = ACTIONS(4158),
    [anon_sym_gt] = ACTIONS(4158),
    [anon_sym_isa] = ACTIONS(4158),
    [anon_sym_PLUS_PLUS] = ACTIONS(4158),
    [anon_sym_DASH_DASH] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4158),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1501] = {
    [sym_heredoc_content] = STATE(1501),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4026),
    [anon_sym_EQ] = ACTIONS(4026),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4024),
    [anon_sym_PLUS_EQ] = ACTIONS(4024),
    [anon_sym_DASH_EQ] = ACTIONS(4024),
    [anon_sym_DOT_EQ] = ACTIONS(4024),
    [anon_sym_STAR_EQ] = ACTIONS(4024),
    [anon_sym_SLASH_EQ] = ACTIONS(4024),
    [anon_sym_PERCENT_EQ] = ACTIONS(4024),
    [anon_sym_x_EQ] = ACTIONS(4024),
    [anon_sym_AMP_EQ] = ACTIONS(4024),
    [anon_sym_PIPE_EQ] = ACTIONS(4024),
    [anon_sym_CARET_EQ] = ACTIONS(4024),
    [anon_sym_LT_LT_EQ] = ACTIONS(4024),
    [anon_sym_GT_GT_EQ] = ACTIONS(4024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4024),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4026),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_SLASH_SLASH] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_GT_GT2] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_DOT] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4026),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_x] = ACTIONS(4026),
    [anon_sym_EQ_TILDE] = ACTIONS(4024),
    [anon_sym_BANG_TILDE] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_eq] = ACTIONS(4024),
    [anon_sym_ne] = ACTIONS(4024),
    [anon_sym_LT_EQ_GT] = ACTIONS(4024),
    [anon_sym_cmp] = ACTIONS(4024),
    [anon_sym_TILDE_TILDE] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4026),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_lt] = ACTIONS(4024),
    [anon_sym_le] = ACTIONS(4024),
    [anon_sym_ge] = ACTIONS(4024),
    [anon_sym_gt] = ACTIONS(4024),
    [anon_sym_isa] = ACTIONS(4024),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4024),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1502] = {
    [sym_heredoc_content] = STATE(1502),
    [anon_sym_RBRACE] = ACTIONS(3815),
    [anon_sym_COLON] = ACTIONS(3815),
    [anon_sym_SEMI] = ACTIONS(3815),
    [anon_sym_RPAREN] = ACTIONS(3815),
    [anon_sym_COMMA] = ACTIONS(3815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3815),
    [anon_sym_and] = ACTIONS(3815),
    [anon_sym_or] = ACTIONS(3815),
    [anon_sym_RBRACK] = ACTIONS(3815),
    [anon_sym_DASH_GT] = ACTIONS(3815),
    [anon_sym_PERCENT] = ACTIONS(3817),
    [anon_sym_LT] = ACTIONS(3817),
    [anon_sym_GT] = ACTIONS(3817),
    [anon_sym_LT_LT] = ACTIONS(3817),
    [anon_sym_EQ] = ACTIONS(3817),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3815),
    [anon_sym_PLUS_EQ] = ACTIONS(3815),
    [anon_sym_DASH_EQ] = ACTIONS(3815),
    [anon_sym_DOT_EQ] = ACTIONS(3815),
    [anon_sym_STAR_EQ] = ACTIONS(3815),
    [anon_sym_SLASH_EQ] = ACTIONS(3815),
    [anon_sym_PERCENT_EQ] = ACTIONS(3815),
    [anon_sym_x_EQ] = ACTIONS(3815),
    [anon_sym_AMP_EQ] = ACTIONS(3815),
    [anon_sym_PIPE_EQ] = ACTIONS(3815),
    [anon_sym_CARET_EQ] = ACTIONS(3815),
    [anon_sym_LT_LT_EQ] = ACTIONS(3815),
    [anon_sym_GT_GT_EQ] = ACTIONS(3815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3815),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3815),
    [anon_sym_DOT_DOT] = ACTIONS(3817),
    [anon_sym_STAR_STAR] = ACTIONS(3817),
    [anon_sym_PIPE_PIPE] = ACTIONS(3817),
    [anon_sym_SLASH_SLASH] = ACTIONS(3817),
    [anon_sym_AMP_AMP] = ACTIONS(3817),
    [anon_sym_PIPE] = ACTIONS(3817),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_GT_GT2] = ACTIONS(3817),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_DOT] = ACTIONS(3817),
    [anon_sym_STAR] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3817),
    [anon_sym_x] = ACTIONS(3817),
    [anon_sym_EQ_TILDE] = ACTIONS(3815),
    [anon_sym_BANG_TILDE] = ACTIONS(3815),
    [anon_sym_EQ_EQ] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3815),
    [anon_sym_eq] = ACTIONS(3815),
    [anon_sym_ne] = ACTIONS(3815),
    [anon_sym_LT_EQ_GT] = ACTIONS(3815),
    [anon_sym_cmp] = ACTIONS(3815),
    [anon_sym_TILDE_TILDE] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3815),
    [anon_sym_lt] = ACTIONS(3815),
    [anon_sym_le] = ACTIONS(3815),
    [anon_sym_ge] = ACTIONS(3815),
    [anon_sym_gt] = ACTIONS(3815),
    [anon_sym_isa] = ACTIONS(3815),
    [anon_sym_PLUS_PLUS] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3815),
    [anon_sym_QMARK] = ACTIONS(3815),
    [anon_sym_EQ_GT] = ACTIONS(3815),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1503] = {
    [sym_heredoc_content] = STATE(1503),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_COLON] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_COMMA] = ACTIONS(4012),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4012),
    [anon_sym_and] = ACTIONS(4012),
    [anon_sym_or] = ACTIONS(4012),
    [anon_sym_RBRACK] = ACTIONS(4012),
    [anon_sym_DASH_GT] = ACTIONS(4012),
    [anon_sym_PERCENT] = ACTIONS(4014),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_GT] = ACTIONS(4014),
    [anon_sym_LT_LT] = ACTIONS(4014),
    [anon_sym_EQ] = ACTIONS(4014),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4012),
    [anon_sym_PLUS_EQ] = ACTIONS(4012),
    [anon_sym_DASH_EQ] = ACTIONS(4012),
    [anon_sym_DOT_EQ] = ACTIONS(4012),
    [anon_sym_STAR_EQ] = ACTIONS(4012),
    [anon_sym_SLASH_EQ] = ACTIONS(4012),
    [anon_sym_PERCENT_EQ] = ACTIONS(4012),
    [anon_sym_x_EQ] = ACTIONS(4012),
    [anon_sym_AMP_EQ] = ACTIONS(4012),
    [anon_sym_PIPE_EQ] = ACTIONS(4012),
    [anon_sym_CARET_EQ] = ACTIONS(4012),
    [anon_sym_LT_LT_EQ] = ACTIONS(4012),
    [anon_sym_GT_GT_EQ] = ACTIONS(4012),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4012),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4012),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4012),
    [anon_sym_DOT_DOT] = ACTIONS(4014),
    [anon_sym_STAR_STAR] = ACTIONS(4014),
    [anon_sym_PIPE_PIPE] = ACTIONS(4014),
    [anon_sym_SLASH_SLASH] = ACTIONS(4014),
    [anon_sym_AMP_AMP] = ACTIONS(4014),
    [anon_sym_PIPE] = ACTIONS(4014),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_GT_GT2] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_DOT] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_SLASH] = ACTIONS(4014),
    [anon_sym_x] = ACTIONS(4014),
    [anon_sym_EQ_TILDE] = ACTIONS(4012),
    [anon_sym_BANG_TILDE] = ACTIONS(4012),
    [anon_sym_EQ_EQ] = ACTIONS(4012),
    [anon_sym_BANG_EQ] = ACTIONS(4012),
    [anon_sym_eq] = ACTIONS(4012),
    [anon_sym_ne] = ACTIONS(4012),
    [anon_sym_LT_EQ_GT] = ACTIONS(4012),
    [anon_sym_cmp] = ACTIONS(4012),
    [anon_sym_TILDE_TILDE] = ACTIONS(4012),
    [anon_sym_LT_EQ] = ACTIONS(4014),
    [anon_sym_GT_EQ] = ACTIONS(4012),
    [anon_sym_lt] = ACTIONS(4012),
    [anon_sym_le] = ACTIONS(4012),
    [anon_sym_ge] = ACTIONS(4012),
    [anon_sym_gt] = ACTIONS(4012),
    [anon_sym_isa] = ACTIONS(4012),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_EQ_GT] = ACTIONS(4012),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1504] = {
    [sym_heredoc_content] = STATE(1504),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_COLON] = ACTIONS(3989),
    [anon_sym_SEMI] = ACTIONS(3989),
    [anon_sym_RPAREN] = ACTIONS(3989),
    [anon_sym_COMMA] = ACTIONS(3989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3989),
    [anon_sym_or] = ACTIONS(3989),
    [anon_sym_RBRACK] = ACTIONS(3989),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3989),
    [anon_sym_PLUS_EQ] = ACTIONS(3989),
    [anon_sym_DASH_EQ] = ACTIONS(3989),
    [anon_sym_DOT_EQ] = ACTIONS(3989),
    [anon_sym_STAR_EQ] = ACTIONS(3989),
    [anon_sym_SLASH_EQ] = ACTIONS(3989),
    [anon_sym_PERCENT_EQ] = ACTIONS(3989),
    [anon_sym_x_EQ] = ACTIONS(3989),
    [anon_sym_AMP_EQ] = ACTIONS(3989),
    [anon_sym_PIPE_EQ] = ACTIONS(3989),
    [anon_sym_CARET_EQ] = ACTIONS(3989),
    [anon_sym_LT_LT_EQ] = ACTIONS(3989),
    [anon_sym_GT_GT_EQ] = ACTIONS(3989),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3989),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3989),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_STAR_STAR] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_SLASH_SLASH] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_GT_GT2] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_x] = ACTIONS(3991),
    [anon_sym_EQ_TILDE] = ACTIONS(3989),
    [anon_sym_BANG_TILDE] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_eq] = ACTIONS(3989),
    [anon_sym_ne] = ACTIONS(3989),
    [anon_sym_LT_EQ_GT] = ACTIONS(3989),
    [anon_sym_cmp] = ACTIONS(3989),
    [anon_sym_TILDE_TILDE] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_lt] = ACTIONS(3989),
    [anon_sym_le] = ACTIONS(3989),
    [anon_sym_ge] = ACTIONS(3989),
    [anon_sym_gt] = ACTIONS(3989),
    [anon_sym_isa] = ACTIONS(3989),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_QMARK] = ACTIONS(3989),
    [anon_sym_EQ_GT] = ACTIONS(3989),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1505] = {
    [sym_heredoc_content] = STATE(1505),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_COMMA] = ACTIONS(3985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3985),
    [anon_sym_or] = ACTIONS(3985),
    [anon_sym_RBRACK] = ACTIONS(3985),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3985),
    [anon_sym_PLUS_EQ] = ACTIONS(3985),
    [anon_sym_DASH_EQ] = ACTIONS(3985),
    [anon_sym_DOT_EQ] = ACTIONS(3985),
    [anon_sym_STAR_EQ] = ACTIONS(3985),
    [anon_sym_SLASH_EQ] = ACTIONS(3985),
    [anon_sym_PERCENT_EQ] = ACTIONS(3985),
    [anon_sym_x_EQ] = ACTIONS(3985),
    [anon_sym_AMP_EQ] = ACTIONS(3985),
    [anon_sym_PIPE_EQ] = ACTIONS(3985),
    [anon_sym_CARET_EQ] = ACTIONS(3985),
    [anon_sym_LT_LT_EQ] = ACTIONS(3985),
    [anon_sym_GT_GT_EQ] = ACTIONS(3985),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3985),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3985),
    [anon_sym_DOT_DOT] = ACTIONS(3987),
    [anon_sym_STAR_STAR] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_SLASH_SLASH] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_GT_GT2] = ACTIONS(3987),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3987),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_x] = ACTIONS(3987),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_BANG_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_eq] = ACTIONS(3985),
    [anon_sym_ne] = ACTIONS(3985),
    [anon_sym_LT_EQ_GT] = ACTIONS(3985),
    [anon_sym_cmp] = ACTIONS(3985),
    [anon_sym_TILDE_TILDE] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_lt] = ACTIONS(3985),
    [anon_sym_le] = ACTIONS(3985),
    [anon_sym_ge] = ACTIONS(3985),
    [anon_sym_gt] = ACTIONS(3985),
    [anon_sym_isa] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_QMARK] = ACTIONS(3985),
    [anon_sym_EQ_GT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1506] = {
    [sym_heredoc_content] = STATE(1506),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(4146),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_and] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4146),
    [anon_sym_RBRACK] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4148),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_DOT_EQ] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_x_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_DOT_DOT] = ACTIONS(4148),
    [anon_sym_STAR_STAR] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_SLASH_SLASH] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4148),
    [anon_sym_AMP] = ACTIONS(4148),
    [anon_sym_GT_GT2] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4148),
    [anon_sym_DASH] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4148),
    [anon_sym_x] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4146),
    [anon_sym_BANG_TILDE] = ACTIONS(4146),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_eq] = ACTIONS(4146),
    [anon_sym_ne] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_cmp] = ACTIONS(4146),
    [anon_sym_TILDE_TILDE] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_lt] = ACTIONS(4146),
    [anon_sym_le] = ACTIONS(4146),
    [anon_sym_ge] = ACTIONS(4146),
    [anon_sym_gt] = ACTIONS(4146),
    [anon_sym_isa] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_EQ_GT] = ACTIONS(4146),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1507] = {
    [sym_heredoc_content] = STATE(1507),
    [anon_sym_RBRACE] = ACTIONS(3965),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym_RPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3965),
    [anon_sym_and] = ACTIONS(3965),
    [anon_sym_or] = ACTIONS(3965),
    [anon_sym_RBRACK] = ACTIONS(3965),
    [anon_sym_DASH_GT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3967),
    [anon_sym_LT_LT] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3965),
    [anon_sym_PLUS_EQ] = ACTIONS(3965),
    [anon_sym_DASH_EQ] = ACTIONS(3965),
    [anon_sym_DOT_EQ] = ACTIONS(3965),
    [anon_sym_STAR_EQ] = ACTIONS(3965),
    [anon_sym_SLASH_EQ] = ACTIONS(3965),
    [anon_sym_PERCENT_EQ] = ACTIONS(3965),
    [anon_sym_x_EQ] = ACTIONS(3965),
    [anon_sym_AMP_EQ] = ACTIONS(3965),
    [anon_sym_PIPE_EQ] = ACTIONS(3965),
    [anon_sym_CARET_EQ] = ACTIONS(3965),
    [anon_sym_LT_LT_EQ] = ACTIONS(3965),
    [anon_sym_GT_GT_EQ] = ACTIONS(3965),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3965),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3965),
    [anon_sym_DOT_DOT] = ACTIONS(3967),
    [anon_sym_STAR_STAR] = ACTIONS(3967),
    [anon_sym_PIPE_PIPE] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH] = ACTIONS(3967),
    [anon_sym_AMP_AMP] = ACTIONS(3967),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_GT_GT2] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3967),
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3967),
    [anon_sym_x] = ACTIONS(3967),
    [anon_sym_EQ_TILDE] = ACTIONS(3965),
    [anon_sym_BANG_TILDE] = ACTIONS(3965),
    [anon_sym_EQ_EQ] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_eq] = ACTIONS(3965),
    [anon_sym_ne] = ACTIONS(3965),
    [anon_sym_LT_EQ_GT] = ACTIONS(3965),
    [anon_sym_cmp] = ACTIONS(3965),
    [anon_sym_TILDE_TILDE] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3965),
    [anon_sym_lt] = ACTIONS(3965),
    [anon_sym_le] = ACTIONS(3965),
    [anon_sym_ge] = ACTIONS(3965),
    [anon_sym_gt] = ACTIONS(3965),
    [anon_sym_isa] = ACTIONS(3965),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_EQ_GT] = ACTIONS(3965),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1508] = {
    [sym_heredoc_content] = STATE(1508),
    [anon_sym_RBRACE] = ACTIONS(3867),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_SEMI] = ACTIONS(3867),
    [anon_sym_RPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3867),
    [anon_sym_and] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_RBRACK] = ACTIONS(3867),
    [anon_sym_DASH_GT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3867),
    [anon_sym_PLUS_EQ] = ACTIONS(3867),
    [anon_sym_DASH_EQ] = ACTIONS(3867),
    [anon_sym_DOT_EQ] = ACTIONS(3867),
    [anon_sym_STAR_EQ] = ACTIONS(3867),
    [anon_sym_SLASH_EQ] = ACTIONS(3867),
    [anon_sym_PERCENT_EQ] = ACTIONS(3867),
    [anon_sym_x_EQ] = ACTIONS(3867),
    [anon_sym_AMP_EQ] = ACTIONS(3867),
    [anon_sym_PIPE_EQ] = ACTIONS(3867),
    [anon_sym_CARET_EQ] = ACTIONS(3867),
    [anon_sym_LT_LT_EQ] = ACTIONS(3867),
    [anon_sym_GT_GT_EQ] = ACTIONS(3867),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3867),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3867),
    [anon_sym_DOT_DOT] = ACTIONS(2944),
    [anon_sym_STAR_STAR] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_SLASH_SLASH] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_GT_GT2] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2944),
    [anon_sym_DOT] = ACTIONS(2944),
    [anon_sym_STAR] = ACTIONS(2944),
    [anon_sym_SLASH] = ACTIONS(2944),
    [anon_sym_x] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(3867),
    [anon_sym_BANG_TILDE] = ACTIONS(3867),
    [anon_sym_EQ_EQ] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_eq] = ACTIONS(3867),
    [anon_sym_ne] = ACTIONS(3867),
    [anon_sym_LT_EQ_GT] = ACTIONS(3867),
    [anon_sym_cmp] = ACTIONS(3867),
    [anon_sym_TILDE_TILDE] = ACTIONS(3867),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(3867),
    [anon_sym_lt] = ACTIONS(3867),
    [anon_sym_le] = ACTIONS(3867),
    [anon_sym_ge] = ACTIONS(3867),
    [anon_sym_gt] = ACTIONS(3867),
    [anon_sym_isa] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3867),
    [anon_sym_DASH_DASH] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_EQ_GT] = ACTIONS(3867),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1509] = {
    [sym_heredoc_content] = STATE(1509),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_and] = ACTIONS(3941),
    [anon_sym_or] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_GT] = ACTIONS(3943),
    [anon_sym_LT_LT] = ACTIONS(3943),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DOT_EQ] = ACTIONS(3941),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_x_EQ] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_DOT_DOT] = ACTIONS(3943),
    [anon_sym_STAR_STAR] = ACTIONS(3943),
    [anon_sym_PIPE_PIPE] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3943),
    [anon_sym_AMP_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_GT_GT2] = ACTIONS(3943),
    [anon_sym_PLUS] = ACTIONS(3943),
    [anon_sym_DASH] = ACTIONS(3943),
    [anon_sym_DOT] = ACTIONS(3943),
    [anon_sym_STAR] = ACTIONS(3943),
    [anon_sym_SLASH] = ACTIONS(3943),
    [anon_sym_x] = ACTIONS(3943),
    [anon_sym_EQ_TILDE] = ACTIONS(3941),
    [anon_sym_BANG_TILDE] = ACTIONS(3941),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_eq] = ACTIONS(3941),
    [anon_sym_ne] = ACTIONS(3941),
    [anon_sym_LT_EQ_GT] = ACTIONS(3941),
    [anon_sym_cmp] = ACTIONS(3941),
    [anon_sym_TILDE_TILDE] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3943),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_lt] = ACTIONS(3941),
    [anon_sym_le] = ACTIONS(3941),
    [anon_sym_ge] = ACTIONS(3941),
    [anon_sym_gt] = ACTIONS(3941),
    [anon_sym_isa] = ACTIONS(3941),
    [anon_sym_PLUS_PLUS] = ACTIONS(3941),
    [anon_sym_DASH_DASH] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_EQ_GT] = ACTIONS(3941),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1510] = {
    [sym_heredoc_content] = STATE(1510),
    [anon_sym_RBRACE] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3897),
    [anon_sym_SEMI] = ACTIONS(3897),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3897),
    [anon_sym_and] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3897),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [anon_sym_DASH_GT] = ACTIONS(3897),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3899),
    [anon_sym_GT] = ACTIONS(3899),
    [anon_sym_LT_LT] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3897),
    [anon_sym_PLUS_EQ] = ACTIONS(3897),
    [anon_sym_DASH_EQ] = ACTIONS(3897),
    [anon_sym_DOT_EQ] = ACTIONS(3897),
    [anon_sym_STAR_EQ] = ACTIONS(3897),
    [anon_sym_SLASH_EQ] = ACTIONS(3897),
    [anon_sym_PERCENT_EQ] = ACTIONS(3897),
    [anon_sym_x_EQ] = ACTIONS(3897),
    [anon_sym_AMP_EQ] = ACTIONS(3897),
    [anon_sym_PIPE_EQ] = ACTIONS(3897),
    [anon_sym_CARET_EQ] = ACTIONS(3897),
    [anon_sym_LT_LT_EQ] = ACTIONS(3897),
    [anon_sym_GT_GT_EQ] = ACTIONS(3897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3897),
    [anon_sym_DOT_DOT] = ACTIONS(3899),
    [anon_sym_STAR_STAR] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_SLASH_SLASH] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_GT_GT2] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_SLASH] = ACTIONS(3899),
    [anon_sym_x] = ACTIONS(3899),
    [anon_sym_EQ_TILDE] = ACTIONS(3897),
    [anon_sym_BANG_TILDE] = ACTIONS(3897),
    [anon_sym_EQ_EQ] = ACTIONS(3897),
    [anon_sym_BANG_EQ] = ACTIONS(3897),
    [anon_sym_eq] = ACTIONS(3897),
    [anon_sym_ne] = ACTIONS(3897),
    [anon_sym_LT_EQ_GT] = ACTIONS(3897),
    [anon_sym_cmp] = ACTIONS(3897),
    [anon_sym_TILDE_TILDE] = ACTIONS(3897),
    [anon_sym_LT_EQ] = ACTIONS(3899),
    [anon_sym_GT_EQ] = ACTIONS(3897),
    [anon_sym_lt] = ACTIONS(3897),
    [anon_sym_le] = ACTIONS(3897),
    [anon_sym_ge] = ACTIONS(3897),
    [anon_sym_gt] = ACTIONS(3897),
    [anon_sym_isa] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_QMARK] = ACTIONS(3897),
    [anon_sym_EQ_GT] = ACTIONS(3897),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1511] = {
    [sym_heredoc_content] = STATE(1511),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_RPAREN] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3901),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_PERCENT] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_LT_LT] = ACTIONS(3903),
    [anon_sym_EQ] = ACTIONS(3903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3901),
    [anon_sym_PLUS_EQ] = ACTIONS(3901),
    [anon_sym_DASH_EQ] = ACTIONS(3901),
    [anon_sym_DOT_EQ] = ACTIONS(3901),
    [anon_sym_STAR_EQ] = ACTIONS(3901),
    [anon_sym_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_PERCENT_EQ] = ACTIONS(3901),
    [anon_sym_x_EQ] = ACTIONS(3901),
    [anon_sym_AMP_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_CARET_EQ] = ACTIONS(3901),
    [anon_sym_LT_LT_EQ] = ACTIONS(3901),
    [anon_sym_GT_GT_EQ] = ACTIONS(3901),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_DOT_DOT] = ACTIONS(3903),
    [anon_sym_STAR_STAR] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_SLASH_SLASH] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3903),
    [anon_sym_GT_GT2] = ACTIONS(3903),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_DOT] = ACTIONS(3903),
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_SLASH] = ACTIONS(3903),
    [anon_sym_x] = ACTIONS(3903),
    [anon_sym_EQ_TILDE] = ACTIONS(3901),
    [anon_sym_BANG_TILDE] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_eq] = ACTIONS(3901),
    [anon_sym_ne] = ACTIONS(3901),
    [anon_sym_LT_EQ_GT] = ACTIONS(3901),
    [anon_sym_cmp] = ACTIONS(3901),
    [anon_sym_TILDE_TILDE] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3903),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_lt] = ACTIONS(3901),
    [anon_sym_le] = ACTIONS(3901),
    [anon_sym_ge] = ACTIONS(3901),
    [anon_sym_gt] = ACTIONS(3901),
    [anon_sym_isa] = ACTIONS(3901),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_QMARK] = ACTIONS(3901),
    [anon_sym_EQ_GT] = ACTIONS(3901),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1512] = {
    [sym_heredoc_content] = STATE(1512),
    [anon_sym_RBRACE] = ACTIONS(3799),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3799),
    [anon_sym_RPAREN] = ACTIONS(3799),
    [anon_sym_COMMA] = ACTIONS(3799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3799),
    [anon_sym_and] = ACTIONS(3799),
    [anon_sym_or] = ACTIONS(3799),
    [anon_sym_RBRACK] = ACTIONS(3799),
    [anon_sym_DASH_GT] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(3801),
    [anon_sym_LT] = ACTIONS(3801),
    [anon_sym_GT] = ACTIONS(3801),
    [anon_sym_LT_LT] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(3801),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3799),
    [anon_sym_PLUS_EQ] = ACTIONS(3799),
    [anon_sym_DASH_EQ] = ACTIONS(3799),
    [anon_sym_DOT_EQ] = ACTIONS(3799),
    [anon_sym_STAR_EQ] = ACTIONS(3799),
    [anon_sym_SLASH_EQ] = ACTIONS(3799),
    [anon_sym_PERCENT_EQ] = ACTIONS(3799),
    [anon_sym_x_EQ] = ACTIONS(3799),
    [anon_sym_AMP_EQ] = ACTIONS(3799),
    [anon_sym_PIPE_EQ] = ACTIONS(3799),
    [anon_sym_CARET_EQ] = ACTIONS(3799),
    [anon_sym_LT_LT_EQ] = ACTIONS(3799),
    [anon_sym_GT_GT_EQ] = ACTIONS(3799),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3799),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3799),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3799),
    [anon_sym_DOT_DOT] = ACTIONS(3801),
    [anon_sym_STAR_STAR] = ACTIONS(3801),
    [anon_sym_PIPE_PIPE] = ACTIONS(3801),
    [anon_sym_SLASH_SLASH] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_PIPE] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3801),
    [anon_sym_GT_GT2] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_DOT] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_SLASH] = ACTIONS(3801),
    [anon_sym_x] = ACTIONS(3801),
    [anon_sym_EQ_TILDE] = ACTIONS(3799),
    [anon_sym_BANG_TILDE] = ACTIONS(3799),
    [anon_sym_EQ_EQ] = ACTIONS(3799),
    [anon_sym_BANG_EQ] = ACTIONS(3799),
    [anon_sym_eq] = ACTIONS(3799),
    [anon_sym_ne] = ACTIONS(3799),
    [anon_sym_LT_EQ_GT] = ACTIONS(3799),
    [anon_sym_cmp] = ACTIONS(3799),
    [anon_sym_TILDE_TILDE] = ACTIONS(3799),
    [anon_sym_LT_EQ] = ACTIONS(3801),
    [anon_sym_GT_EQ] = ACTIONS(3799),
    [anon_sym_lt] = ACTIONS(3799),
    [anon_sym_le] = ACTIONS(3799),
    [anon_sym_ge] = ACTIONS(3799),
    [anon_sym_gt] = ACTIONS(3799),
    [anon_sym_isa] = ACTIONS(3799),
    [anon_sym_PLUS_PLUS] = ACTIONS(3799),
    [anon_sym_DASH_DASH] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3799),
    [anon_sym_EQ_GT] = ACTIONS(3799),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1513] = {
    [sym_heredoc_content] = STATE(1513),
    [anon_sym_RBRACE] = ACTIONS(3613),
    [anon_sym_COLON] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_RPAREN] = ACTIONS(3613),
    [anon_sym_COMMA] = ACTIONS(3613),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3613),
    [anon_sym_and] = ACTIONS(3613),
    [anon_sym_or] = ACTIONS(3613),
    [anon_sym_RBRACK] = ACTIONS(3613),
    [anon_sym_DASH_GT] = ACTIONS(3613),
    [anon_sym_PERCENT] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_LT_LT] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3615),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3613),
    [anon_sym_PLUS_EQ] = ACTIONS(3613),
    [anon_sym_DASH_EQ] = ACTIONS(3613),
    [anon_sym_DOT_EQ] = ACTIONS(3613),
    [anon_sym_STAR_EQ] = ACTIONS(3613),
    [anon_sym_SLASH_EQ] = ACTIONS(3613),
    [anon_sym_PERCENT_EQ] = ACTIONS(3613),
    [anon_sym_x_EQ] = ACTIONS(3613),
    [anon_sym_AMP_EQ] = ACTIONS(3613),
    [anon_sym_PIPE_EQ] = ACTIONS(3613),
    [anon_sym_CARET_EQ] = ACTIONS(3613),
    [anon_sym_LT_LT_EQ] = ACTIONS(3613),
    [anon_sym_GT_GT_EQ] = ACTIONS(3613),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3613),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3613),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3613),
    [anon_sym_DOT_DOT] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3615),
    [anon_sym_PIPE_PIPE] = ACTIONS(3615),
    [anon_sym_SLASH_SLASH] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_GT_GT2] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DOT] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_SLASH] = ACTIONS(3615),
    [anon_sym_x] = ACTIONS(3615),
    [anon_sym_EQ_TILDE] = ACTIONS(3613),
    [anon_sym_BANG_TILDE] = ACTIONS(3613),
    [anon_sym_EQ_EQ] = ACTIONS(3613),
    [anon_sym_BANG_EQ] = ACTIONS(3613),
    [anon_sym_eq] = ACTIONS(3613),
    [anon_sym_ne] = ACTIONS(3613),
    [anon_sym_LT_EQ_GT] = ACTIONS(3613),
    [anon_sym_cmp] = ACTIONS(3613),
    [anon_sym_TILDE_TILDE] = ACTIONS(3613),
    [anon_sym_LT_EQ] = ACTIONS(3615),
    [anon_sym_GT_EQ] = ACTIONS(3613),
    [anon_sym_lt] = ACTIONS(3613),
    [anon_sym_le] = ACTIONS(3613),
    [anon_sym_ge] = ACTIONS(3613),
    [anon_sym_gt] = ACTIONS(3613),
    [anon_sym_isa] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_EQ_GT] = ACTIONS(3613),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1514] = {
    [sym_heredoc_content] = STATE(1514),
    [anon_sym_RBRACE] = ACTIONS(3807),
    [anon_sym_COLON] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3807),
    [anon_sym_RPAREN] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3807),
    [anon_sym_and] = ACTIONS(3807),
    [anon_sym_or] = ACTIONS(3807),
    [anon_sym_RBRACK] = ACTIONS(3807),
    [anon_sym_DASH_GT] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(3809),
    [anon_sym_GT] = ACTIONS(3809),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_EQ] = ACTIONS(3809),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3807),
    [anon_sym_PLUS_EQ] = ACTIONS(3807),
    [anon_sym_DASH_EQ] = ACTIONS(3807),
    [anon_sym_DOT_EQ] = ACTIONS(3807),
    [anon_sym_STAR_EQ] = ACTIONS(3807),
    [anon_sym_SLASH_EQ] = ACTIONS(3807),
    [anon_sym_PERCENT_EQ] = ACTIONS(3807),
    [anon_sym_x_EQ] = ACTIONS(3807),
    [anon_sym_AMP_EQ] = ACTIONS(3807),
    [anon_sym_PIPE_EQ] = ACTIONS(3807),
    [anon_sym_CARET_EQ] = ACTIONS(3807),
    [anon_sym_LT_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT_GT_EQ] = ACTIONS(3807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3807),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3809),
    [anon_sym_STAR_STAR] = ACTIONS(3809),
    [anon_sym_PIPE_PIPE] = ACTIONS(3809),
    [anon_sym_SLASH_SLASH] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3809),
    [anon_sym_PIPE] = ACTIONS(3809),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_GT_GT2] = ACTIONS(3809),
    [anon_sym_PLUS] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3809),
    [anon_sym_DOT] = ACTIONS(3809),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_SLASH] = ACTIONS(3809),
    [anon_sym_x] = ACTIONS(3809),
    [anon_sym_EQ_TILDE] = ACTIONS(3807),
    [anon_sym_BANG_TILDE] = ACTIONS(3807),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3807),
    [anon_sym_eq] = ACTIONS(3807),
    [anon_sym_ne] = ACTIONS(3807),
    [anon_sym_LT_EQ_GT] = ACTIONS(3807),
    [anon_sym_cmp] = ACTIONS(3807),
    [anon_sym_TILDE_TILDE] = ACTIONS(3807),
    [anon_sym_LT_EQ] = ACTIONS(3809),
    [anon_sym_GT_EQ] = ACTIONS(3807),
    [anon_sym_lt] = ACTIONS(3807),
    [anon_sym_le] = ACTIONS(3807),
    [anon_sym_ge] = ACTIONS(3807),
    [anon_sym_gt] = ACTIONS(3807),
    [anon_sym_isa] = ACTIONS(3807),
    [anon_sym_PLUS_PLUS] = ACTIONS(3807),
    [anon_sym_DASH_DASH] = ACTIONS(3807),
    [anon_sym_QMARK] = ACTIONS(3807),
    [anon_sym_EQ_GT] = ACTIONS(3807),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1515] = {
    [sym_heredoc_content] = STATE(1515),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_COLON] = ACTIONS(4435),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_RPAREN] = ACTIONS(3725),
    [anon_sym_COMMA] = ACTIONS(3725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3725),
    [anon_sym_and] = ACTIONS(3725),
    [anon_sym_or] = ACTIONS(3725),
    [anon_sym_RBRACK] = ACTIONS(3725),
    [anon_sym_DASH_GT] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_EQ] = ACTIONS(3727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3725),
    [anon_sym_PLUS_EQ] = ACTIONS(3725),
    [anon_sym_DASH_EQ] = ACTIONS(3725),
    [anon_sym_DOT_EQ] = ACTIONS(3725),
    [anon_sym_STAR_EQ] = ACTIONS(3725),
    [anon_sym_SLASH_EQ] = ACTIONS(3725),
    [anon_sym_PERCENT_EQ] = ACTIONS(3725),
    [anon_sym_x_EQ] = ACTIONS(3725),
    [anon_sym_AMP_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_EQ] = ACTIONS(3725),
    [anon_sym_CARET_EQ] = ACTIONS(3725),
    [anon_sym_LT_LT_EQ] = ACTIONS(3725),
    [anon_sym_GT_GT_EQ] = ACTIONS(3725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3725),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3725),
    [anon_sym_DOT_DOT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_SLASH_SLASH] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3727),
    [anon_sym_GT_GT2] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_SLASH] = ACTIONS(3727),
    [anon_sym_x] = ACTIONS(3727),
    [anon_sym_EQ_TILDE] = ACTIONS(3725),
    [anon_sym_BANG_TILDE] = ACTIONS(3725),
    [anon_sym_EQ_EQ] = ACTIONS(3725),
    [anon_sym_BANG_EQ] = ACTIONS(3725),
    [anon_sym_eq] = ACTIONS(3725),
    [anon_sym_ne] = ACTIONS(3725),
    [anon_sym_LT_EQ_GT] = ACTIONS(3725),
    [anon_sym_cmp] = ACTIONS(3725),
    [anon_sym_TILDE_TILDE] = ACTIONS(3725),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3725),
    [anon_sym_lt] = ACTIONS(3725),
    [anon_sym_le] = ACTIONS(3725),
    [anon_sym_ge] = ACTIONS(3725),
    [anon_sym_gt] = ACTIONS(3725),
    [anon_sym_isa] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3725),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1516] = {
    [sym_heredoc_content] = STATE(1516),
    [anon_sym_RBRACE] = ACTIONS(3562),
    [anon_sym_COLON] = ACTIONS(4437),
    [anon_sym_SEMI] = ACTIONS(3562),
    [anon_sym_RPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3562),
    [anon_sym_and] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_RBRACK] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3564),
    [anon_sym_LT] = ACTIONS(3564),
    [anon_sym_GT] = ACTIONS(3564),
    [anon_sym_LT_LT] = ACTIONS(3564),
    [anon_sym_EQ] = ACTIONS(3564),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3562),
    [anon_sym_PLUS_EQ] = ACTIONS(3562),
    [anon_sym_DASH_EQ] = ACTIONS(3562),
    [anon_sym_DOT_EQ] = ACTIONS(3562),
    [anon_sym_STAR_EQ] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(3562),
    [anon_sym_PERCENT_EQ] = ACTIONS(3562),
    [anon_sym_x_EQ] = ACTIONS(3562),
    [anon_sym_AMP_EQ] = ACTIONS(3562),
    [anon_sym_PIPE_EQ] = ACTIONS(3562),
    [anon_sym_CARET_EQ] = ACTIONS(3562),
    [anon_sym_LT_LT_EQ] = ACTIONS(3562),
    [anon_sym_GT_GT_EQ] = ACTIONS(3562),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3562),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(3564),
    [anon_sym_STAR_STAR] = ACTIONS(3564),
    [anon_sym_PIPE_PIPE] = ACTIONS(3564),
    [anon_sym_SLASH_SLASH] = ACTIONS(3564),
    [anon_sym_AMP_AMP] = ACTIONS(3564),
    [anon_sym_PIPE] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_GT_GT2] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(3564),
    [anon_sym_DASH] = ACTIONS(3564),
    [anon_sym_DOT] = ACTIONS(3564),
    [anon_sym_STAR] = ACTIONS(3564),
    [anon_sym_SLASH] = ACTIONS(3564),
    [anon_sym_x] = ACTIONS(3564),
    [anon_sym_EQ_TILDE] = ACTIONS(3562),
    [anon_sym_BANG_TILDE] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_eq] = ACTIONS(3562),
    [anon_sym_ne] = ACTIONS(3562),
    [anon_sym_LT_EQ_GT] = ACTIONS(3562),
    [anon_sym_cmp] = ACTIONS(3562),
    [anon_sym_TILDE_TILDE] = ACTIONS(3562),
    [anon_sym_LT_EQ] = ACTIONS(3564),
    [anon_sym_GT_EQ] = ACTIONS(3562),
    [anon_sym_lt] = ACTIONS(3562),
    [anon_sym_le] = ACTIONS(3562),
    [anon_sym_ge] = ACTIONS(3562),
    [anon_sym_gt] = ACTIONS(3562),
    [anon_sym_isa] = ACTIONS(3562),
    [anon_sym_PLUS_PLUS] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_EQ_GT] = ACTIONS(3562),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1517] = {
    [sym_heredoc_content] = STATE(1517),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_COLON] = ACTIONS(3745),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym_RPAREN] = ACTIONS(3745),
    [anon_sym_COMMA] = ACTIONS(3745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3745),
    [anon_sym_and] = ACTIONS(3745),
    [anon_sym_or] = ACTIONS(3745),
    [anon_sym_RBRACK] = ACTIONS(3745),
    [anon_sym_DASH_GT] = ACTIONS(3745),
    [anon_sym_PERCENT] = ACTIONS(3747),
    [anon_sym_LT] = ACTIONS(3747),
    [anon_sym_GT] = ACTIONS(3747),
    [anon_sym_LT_LT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3747),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3745),
    [anon_sym_PLUS_EQ] = ACTIONS(3745),
    [anon_sym_DASH_EQ] = ACTIONS(3745),
    [anon_sym_DOT_EQ] = ACTIONS(3745),
    [anon_sym_STAR_EQ] = ACTIONS(3745),
    [anon_sym_SLASH_EQ] = ACTIONS(3745),
    [anon_sym_PERCENT_EQ] = ACTIONS(3745),
    [anon_sym_x_EQ] = ACTIONS(3745),
    [anon_sym_AMP_EQ] = ACTIONS(3745),
    [anon_sym_PIPE_EQ] = ACTIONS(3745),
    [anon_sym_CARET_EQ] = ACTIONS(3745),
    [anon_sym_LT_LT_EQ] = ACTIONS(3745),
    [anon_sym_GT_GT_EQ] = ACTIONS(3745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3745),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3745),
    [anon_sym_DOT_DOT] = ACTIONS(3747),
    [anon_sym_STAR_STAR] = ACTIONS(3747),
    [anon_sym_PIPE_PIPE] = ACTIONS(3747),
    [anon_sym_SLASH_SLASH] = ACTIONS(3747),
    [anon_sym_AMP_AMP] = ACTIONS(3747),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_AMP] = ACTIONS(3747),
    [anon_sym_GT_GT2] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3747),
    [anon_sym_SLASH] = ACTIONS(3747),
    [anon_sym_x] = ACTIONS(3747),
    [anon_sym_EQ_TILDE] = ACTIONS(3745),
    [anon_sym_BANG_TILDE] = ACTIONS(3745),
    [anon_sym_EQ_EQ] = ACTIONS(3745),
    [anon_sym_BANG_EQ] = ACTIONS(3745),
    [anon_sym_eq] = ACTIONS(3745),
    [anon_sym_ne] = ACTIONS(3745),
    [anon_sym_LT_EQ_GT] = ACTIONS(3745),
    [anon_sym_cmp] = ACTIONS(3745),
    [anon_sym_TILDE_TILDE] = ACTIONS(3745),
    [anon_sym_LT_EQ] = ACTIONS(3747),
    [anon_sym_GT_EQ] = ACTIONS(3745),
    [anon_sym_lt] = ACTIONS(3745),
    [anon_sym_le] = ACTIONS(3745),
    [anon_sym_ge] = ACTIONS(3745),
    [anon_sym_gt] = ACTIONS(3745),
    [anon_sym_isa] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_EQ_GT] = ACTIONS(3745),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1518] = {
    [sym_heredoc_content] = STATE(1518),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3741),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_RPAREN] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3741),
    [anon_sym_and] = ACTIONS(3741),
    [anon_sym_or] = ACTIONS(3741),
    [anon_sym_RBRACK] = ACTIONS(3741),
    [anon_sym_DASH_GT] = ACTIONS(3741),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_LT] = ACTIONS(3743),
    [anon_sym_GT] = ACTIONS(3743),
    [anon_sym_LT_LT] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3741),
    [anon_sym_PLUS_EQ] = ACTIONS(3741),
    [anon_sym_DASH_EQ] = ACTIONS(3741),
    [anon_sym_DOT_EQ] = ACTIONS(3741),
    [anon_sym_STAR_EQ] = ACTIONS(3741),
    [anon_sym_SLASH_EQ] = ACTIONS(3741),
    [anon_sym_PERCENT_EQ] = ACTIONS(3741),
    [anon_sym_x_EQ] = ACTIONS(3741),
    [anon_sym_AMP_EQ] = ACTIONS(3741),
    [anon_sym_PIPE_EQ] = ACTIONS(3741),
    [anon_sym_CARET_EQ] = ACTIONS(3741),
    [anon_sym_LT_LT_EQ] = ACTIONS(3741),
    [anon_sym_GT_GT_EQ] = ACTIONS(3741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3741),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3741),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3741),
    [anon_sym_DOT_DOT] = ACTIONS(3743),
    [anon_sym_STAR_STAR] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_SLASH_SLASH] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_GT_GT2] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_SLASH] = ACTIONS(3743),
    [anon_sym_x] = ACTIONS(3743),
    [anon_sym_EQ_TILDE] = ACTIONS(3741),
    [anon_sym_BANG_TILDE] = ACTIONS(3741),
    [anon_sym_EQ_EQ] = ACTIONS(3741),
    [anon_sym_BANG_EQ] = ACTIONS(3741),
    [anon_sym_eq] = ACTIONS(3741),
    [anon_sym_ne] = ACTIONS(3741),
    [anon_sym_LT_EQ_GT] = ACTIONS(3741),
    [anon_sym_cmp] = ACTIONS(3741),
    [anon_sym_TILDE_TILDE] = ACTIONS(3741),
    [anon_sym_LT_EQ] = ACTIONS(3743),
    [anon_sym_GT_EQ] = ACTIONS(3741),
    [anon_sym_lt] = ACTIONS(3741),
    [anon_sym_le] = ACTIONS(3741),
    [anon_sym_ge] = ACTIONS(3741),
    [anon_sym_gt] = ACTIONS(3741),
    [anon_sym_isa] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(3741),
    [anon_sym_EQ_GT] = ACTIONS(3741),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1519] = {
    [sym_heredoc_content] = STATE(1519),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4032),
    [anon_sym_and] = ACTIONS(4032),
    [anon_sym_or] = ACTIONS(4032),
    [anon_sym_RBRACK] = ACTIONS(4032),
    [anon_sym_DASH_GT] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(4034),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4032),
    [anon_sym_PLUS_EQ] = ACTIONS(4032),
    [anon_sym_DASH_EQ] = ACTIONS(4032),
    [anon_sym_DOT_EQ] = ACTIONS(4032),
    [anon_sym_STAR_EQ] = ACTIONS(4032),
    [anon_sym_SLASH_EQ] = ACTIONS(4032),
    [anon_sym_PERCENT_EQ] = ACTIONS(4032),
    [anon_sym_x_EQ] = ACTIONS(4032),
    [anon_sym_AMP_EQ] = ACTIONS(4032),
    [anon_sym_PIPE_EQ] = ACTIONS(4032),
    [anon_sym_CARET_EQ] = ACTIONS(4032),
    [anon_sym_LT_LT_EQ] = ACTIONS(4032),
    [anon_sym_GT_GT_EQ] = ACTIONS(4032),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4032),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4032),
    [anon_sym_DOT_DOT] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [anon_sym_SLASH_SLASH] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT2] = ACTIONS(4034),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4034),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_x] = ACTIONS(4034),
    [anon_sym_EQ_TILDE] = ACTIONS(4032),
    [anon_sym_BANG_TILDE] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4032),
    [anon_sym_eq] = ACTIONS(4032),
    [anon_sym_ne] = ACTIONS(4032),
    [anon_sym_LT_EQ_GT] = ACTIONS(4032),
    [anon_sym_cmp] = ACTIONS(4032),
    [anon_sym_TILDE_TILDE] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4034),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_lt] = ACTIONS(4032),
    [anon_sym_le] = ACTIONS(4032),
    [anon_sym_ge] = ACTIONS(4032),
    [anon_sym_gt] = ACTIONS(4032),
    [anon_sym_isa] = ACTIONS(4032),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_QMARK] = ACTIONS(4032),
    [anon_sym_EQ_GT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1520] = {
    [sym_heredoc_content] = STATE(1520),
    [anon_sym_RBRACE] = ACTIONS(4092),
    [anon_sym_COLON] = ACTIONS(4092),
    [anon_sym_SEMI] = ACTIONS(4092),
    [anon_sym_RPAREN] = ACTIONS(4092),
    [anon_sym_COMMA] = ACTIONS(4092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(4092),
    [anon_sym_or] = ACTIONS(4092),
    [anon_sym_RBRACK] = ACTIONS(4092),
    [anon_sym_DASH_GT] = ACTIONS(4092),
    [anon_sym_PERCENT] = ACTIONS(4094),
    [anon_sym_LT] = ACTIONS(4094),
    [anon_sym_GT] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4094),
    [anon_sym_EQ] = ACTIONS(4094),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4092),
    [anon_sym_PLUS_EQ] = ACTIONS(4092),
    [anon_sym_DASH_EQ] = ACTIONS(4092),
    [anon_sym_DOT_EQ] = ACTIONS(4092),
    [anon_sym_STAR_EQ] = ACTIONS(4092),
    [anon_sym_SLASH_EQ] = ACTIONS(4092),
    [anon_sym_PERCENT_EQ] = ACTIONS(4092),
    [anon_sym_x_EQ] = ACTIONS(4092),
    [anon_sym_AMP_EQ] = ACTIONS(4092),
    [anon_sym_PIPE_EQ] = ACTIONS(4092),
    [anon_sym_CARET_EQ] = ACTIONS(4092),
    [anon_sym_LT_LT_EQ] = ACTIONS(4092),
    [anon_sym_GT_GT_EQ] = ACTIONS(4092),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4092),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4092),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(4094),
    [anon_sym_STAR_STAR] = ACTIONS(4094),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_SLASH_SLASH] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_PIPE] = ACTIONS(4094),
    [anon_sym_AMP] = ACTIONS(4094),
    [anon_sym_GT_GT2] = ACTIONS(4094),
    [anon_sym_PLUS] = ACTIONS(4094),
    [anon_sym_DASH] = ACTIONS(4094),
    [anon_sym_DOT] = ACTIONS(4094),
    [anon_sym_STAR] = ACTIONS(4094),
    [anon_sym_SLASH] = ACTIONS(4094),
    [anon_sym_x] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4092),
    [anon_sym_BANG_TILDE] = ACTIONS(4092),
    [anon_sym_EQ_EQ] = ACTIONS(4092),
    [anon_sym_BANG_EQ] = ACTIONS(4092),
    [anon_sym_eq] = ACTIONS(4092),
    [anon_sym_ne] = ACTIONS(4092),
    [anon_sym_LT_EQ_GT] = ACTIONS(4092),
    [anon_sym_cmp] = ACTIONS(4092),
    [anon_sym_TILDE_TILDE] = ACTIONS(4092),
    [anon_sym_LT_EQ] = ACTIONS(4094),
    [anon_sym_GT_EQ] = ACTIONS(4092),
    [anon_sym_lt] = ACTIONS(4092),
    [anon_sym_le] = ACTIONS(4092),
    [anon_sym_ge] = ACTIONS(4092),
    [anon_sym_gt] = ACTIONS(4092),
    [anon_sym_isa] = ACTIONS(4092),
    [anon_sym_PLUS_PLUS] = ACTIONS(4092),
    [anon_sym_DASH_DASH] = ACTIONS(4092),
    [anon_sym_QMARK] = ACTIONS(4092),
    [anon_sym_EQ_GT] = ACTIONS(4092),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1521] = {
    [sym_heredoc_content] = STATE(1521),
    [anon_sym_RBRACE] = ACTIONS(3993),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_SEMI] = ACTIONS(3993),
    [anon_sym_RPAREN] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3993),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_RBRACK] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3995),
    [anon_sym_LT] = ACTIONS(3995),
    [anon_sym_GT] = ACTIONS(3995),
    [anon_sym_LT_LT] = ACTIONS(3995),
    [anon_sym_EQ] = ACTIONS(3995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3993),
    [anon_sym_DASH_EQ] = ACTIONS(3993),
    [anon_sym_DOT_EQ] = ACTIONS(3993),
    [anon_sym_STAR_EQ] = ACTIONS(3993),
    [anon_sym_SLASH_EQ] = ACTIONS(3993),
    [anon_sym_PERCENT_EQ] = ACTIONS(3993),
    [anon_sym_x_EQ] = ACTIONS(3993),
    [anon_sym_AMP_EQ] = ACTIONS(3993),
    [anon_sym_PIPE_EQ] = ACTIONS(3993),
    [anon_sym_CARET_EQ] = ACTIONS(3993),
    [anon_sym_LT_LT_EQ] = ACTIONS(3993),
    [anon_sym_GT_GT_EQ] = ACTIONS(3993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3993),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3995),
    [anon_sym_STAR_STAR] = ACTIONS(3995),
    [anon_sym_PIPE_PIPE] = ACTIONS(3995),
    [anon_sym_SLASH_SLASH] = ACTIONS(3995),
    [anon_sym_AMP_AMP] = ACTIONS(3995),
    [anon_sym_PIPE] = ACTIONS(3995),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_GT_GT2] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_DOT] = ACTIONS(3995),
    [anon_sym_STAR] = ACTIONS(3995),
    [anon_sym_SLASH] = ACTIONS(3995),
    [anon_sym_x] = ACTIONS(3995),
    [anon_sym_EQ_TILDE] = ACTIONS(3993),
    [anon_sym_BANG_TILDE] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3993),
    [anon_sym_BANG_EQ] = ACTIONS(3993),
    [anon_sym_eq] = ACTIONS(3993),
    [anon_sym_ne] = ACTIONS(3993),
    [anon_sym_LT_EQ_GT] = ACTIONS(3993),
    [anon_sym_cmp] = ACTIONS(3993),
    [anon_sym_TILDE_TILDE] = ACTIONS(3993),
    [anon_sym_LT_EQ] = ACTIONS(3995),
    [anon_sym_GT_EQ] = ACTIONS(3993),
    [anon_sym_lt] = ACTIONS(3993),
    [anon_sym_le] = ACTIONS(3993),
    [anon_sym_ge] = ACTIONS(3993),
    [anon_sym_gt] = ACTIONS(3993),
    [anon_sym_isa] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3993),
    [anon_sym_DASH_DASH] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3993),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1522] = {
    [sym_heredoc_content] = STATE(1522),
    [anon_sym_RBRACE] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4084),
    [anon_sym_SEMI] = ACTIONS(4084),
    [anon_sym_RPAREN] = ACTIONS(4084),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4084),
    [anon_sym_and] = ACTIONS(4084),
    [anon_sym_or] = ACTIONS(4084),
    [anon_sym_RBRACK] = ACTIONS(4084),
    [anon_sym_DASH_GT] = ACTIONS(4084),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_LT_LT] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4086),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4084),
    [anon_sym_PLUS_EQ] = ACTIONS(4084),
    [anon_sym_DASH_EQ] = ACTIONS(4084),
    [anon_sym_DOT_EQ] = ACTIONS(4084),
    [anon_sym_STAR_EQ] = ACTIONS(4084),
    [anon_sym_SLASH_EQ] = ACTIONS(4084),
    [anon_sym_PERCENT_EQ] = ACTIONS(4084),
    [anon_sym_x_EQ] = ACTIONS(4084),
    [anon_sym_AMP_EQ] = ACTIONS(4084),
    [anon_sym_PIPE_EQ] = ACTIONS(4084),
    [anon_sym_CARET_EQ] = ACTIONS(4084),
    [anon_sym_LT_LT_EQ] = ACTIONS(4084),
    [anon_sym_GT_GT_EQ] = ACTIONS(4084),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4084),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4084),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4084),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_STAR_STAR] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_SLASH_SLASH] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4086),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_GT_GT2] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_SLASH] = ACTIONS(4086),
    [anon_sym_x] = ACTIONS(4086),
    [anon_sym_EQ_TILDE] = ACTIONS(4084),
    [anon_sym_BANG_TILDE] = ACTIONS(4084),
    [anon_sym_EQ_EQ] = ACTIONS(4084),
    [anon_sym_BANG_EQ] = ACTIONS(4084),
    [anon_sym_eq] = ACTIONS(4084),
    [anon_sym_ne] = ACTIONS(4084),
    [anon_sym_LT_EQ_GT] = ACTIONS(4084),
    [anon_sym_cmp] = ACTIONS(4084),
    [anon_sym_TILDE_TILDE] = ACTIONS(4084),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4084),
    [anon_sym_lt] = ACTIONS(4084),
    [anon_sym_le] = ACTIONS(4084),
    [anon_sym_ge] = ACTIONS(4084),
    [anon_sym_gt] = ACTIONS(4084),
    [anon_sym_isa] = ACTIONS(4084),
    [anon_sym_PLUS_PLUS] = ACTIONS(4084),
    [anon_sym_DASH_DASH] = ACTIONS(4084),
    [anon_sym_QMARK] = ACTIONS(4084),
    [anon_sym_EQ_GT] = ACTIONS(4084),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1523] = {
    [sym_heredoc_content] = STATE(1523),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4058),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_DOT_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_x_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4060),
    [anon_sym_STAR_STAR] = ACTIONS(4060),
    [anon_sym_PIPE_PIPE] = ACTIONS(4060),
    [anon_sym_SLASH_SLASH] = ACTIONS(4060),
    [anon_sym_AMP_AMP] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_GT_GT2] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_x] = ACTIONS(4060),
    [anon_sym_EQ_TILDE] = ACTIONS(4058),
    [anon_sym_BANG_TILDE] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_eq] = ACTIONS(4058),
    [anon_sym_ne] = ACTIONS(4058),
    [anon_sym_LT_EQ_GT] = ACTIONS(4058),
    [anon_sym_cmp] = ACTIONS(4058),
    [anon_sym_TILDE_TILDE] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4060),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_lt] = ACTIONS(4058),
    [anon_sym_le] = ACTIONS(4058),
    [anon_sym_ge] = ACTIONS(4058),
    [anon_sym_gt] = ACTIONS(4058),
    [anon_sym_isa] = ACTIONS(4058),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_QMARK] = ACTIONS(4058),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1524] = {
    [sym_heredoc_content] = STATE(1524),
    [aux_sym__term_rightward_repeat1] = STATE(1528),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_RPAREN] = ACTIONS(3789),
    [anon_sym_COMMA] = ACTIONS(4439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4441),
    [anon_sym_and] = ACTIONS(3789),
    [anon_sym_or] = ACTIONS(3789),
    [anon_sym_RBRACK] = ACTIONS(3789),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4451),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_x_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4455),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4459),
    [anon_sym_SLASH_SLASH] = ACTIONS(4459),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4481),
    [anon_sym_EQ_GT] = ACTIONS(4439),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1525] = {
    [sym_heredoc_content] = STATE(1525),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4044),
    [anon_sym_or] = ACTIONS(4044),
    [anon_sym_RBRACK] = ACTIONS(4044),
    [anon_sym_DASH_GT] = ACTIONS(4044),
    [anon_sym_PERCENT] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_EQ] = ACTIONS(4046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4044),
    [anon_sym_PLUS_EQ] = ACTIONS(4044),
    [anon_sym_DASH_EQ] = ACTIONS(4044),
    [anon_sym_DOT_EQ] = ACTIONS(4044),
    [anon_sym_STAR_EQ] = ACTIONS(4044),
    [anon_sym_SLASH_EQ] = ACTIONS(4044),
    [anon_sym_PERCENT_EQ] = ACTIONS(4044),
    [anon_sym_x_EQ] = ACTIONS(4044),
    [anon_sym_AMP_EQ] = ACTIONS(4044),
    [anon_sym_PIPE_EQ] = ACTIONS(4044),
    [anon_sym_CARET_EQ] = ACTIONS(4044),
    [anon_sym_LT_LT_EQ] = ACTIONS(4044),
    [anon_sym_GT_GT_EQ] = ACTIONS(4044),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4044),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4044),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_STAR_STAR] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_SLASH_SLASH] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_GT_GT2] = ACTIONS(4046),
    [anon_sym_PLUS] = ACTIONS(4046),
    [anon_sym_DASH] = ACTIONS(4046),
    [anon_sym_DOT] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_SLASH] = ACTIONS(4046),
    [anon_sym_x] = ACTIONS(4046),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_BANG_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_eq] = ACTIONS(4044),
    [anon_sym_ne] = ACTIONS(4044),
    [anon_sym_LT_EQ_GT] = ACTIONS(4044),
    [anon_sym_cmp] = ACTIONS(4044),
    [anon_sym_TILDE_TILDE] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4046),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [anon_sym_lt] = ACTIONS(4044),
    [anon_sym_le] = ACTIONS(4044),
    [anon_sym_ge] = ACTIONS(4044),
    [anon_sym_gt] = ACTIONS(4044),
    [anon_sym_isa] = ACTIONS(4044),
    [anon_sym_PLUS_PLUS] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4044),
    [anon_sym_QMARK] = ACTIONS(4044),
    [anon_sym_EQ_GT] = ACTIONS(4044),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1526] = {
    [sym_heredoc_content] = STATE(1526),
    [anon_sym_RBRACE] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4116),
    [anon_sym_SEMI] = ACTIONS(4116),
    [anon_sym_RPAREN] = ACTIONS(4116),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4116),
    [anon_sym_and] = ACTIONS(4116),
    [anon_sym_or] = ACTIONS(4116),
    [anon_sym_RBRACK] = ACTIONS(4116),
    [anon_sym_DASH_GT] = ACTIONS(4116),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4116),
    [anon_sym_PLUS_EQ] = ACTIONS(4116),
    [anon_sym_DASH_EQ] = ACTIONS(4116),
    [anon_sym_DOT_EQ] = ACTIONS(4116),
    [anon_sym_STAR_EQ] = ACTIONS(4116),
    [anon_sym_SLASH_EQ] = ACTIONS(4116),
    [anon_sym_PERCENT_EQ] = ACTIONS(4116),
    [anon_sym_x_EQ] = ACTIONS(4116),
    [anon_sym_AMP_EQ] = ACTIONS(4116),
    [anon_sym_PIPE_EQ] = ACTIONS(4116),
    [anon_sym_CARET_EQ] = ACTIONS(4116),
    [anon_sym_LT_LT_EQ] = ACTIONS(4116),
    [anon_sym_GT_GT_EQ] = ACTIONS(4116),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4116),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4116),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_SLASH_SLASH] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_GT_GT2] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_x] = ACTIONS(4118),
    [anon_sym_EQ_TILDE] = ACTIONS(4116),
    [anon_sym_BANG_TILDE] = ACTIONS(4116),
    [anon_sym_EQ_EQ] = ACTIONS(4116),
    [anon_sym_BANG_EQ] = ACTIONS(4116),
    [anon_sym_eq] = ACTIONS(4116),
    [anon_sym_ne] = ACTIONS(4116),
    [anon_sym_LT_EQ_GT] = ACTIONS(4116),
    [anon_sym_cmp] = ACTIONS(4116),
    [anon_sym_TILDE_TILDE] = ACTIONS(4116),
    [anon_sym_LT_EQ] = ACTIONS(4118),
    [anon_sym_GT_EQ] = ACTIONS(4116),
    [anon_sym_lt] = ACTIONS(4116),
    [anon_sym_le] = ACTIONS(4116),
    [anon_sym_ge] = ACTIONS(4116),
    [anon_sym_gt] = ACTIONS(4116),
    [anon_sym_isa] = ACTIONS(4116),
    [anon_sym_PLUS_PLUS] = ACTIONS(4116),
    [anon_sym_DASH_DASH] = ACTIONS(4116),
    [anon_sym_QMARK] = ACTIONS(4116),
    [anon_sym_EQ_GT] = ACTIONS(4116),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1527] = {
    [sym_heredoc_content] = STATE(1527),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_RBRACK] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_GT] = ACTIONS(3883),
    [anon_sym_LT_LT] = ACTIONS(3883),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3881),
    [anon_sym_PLUS_EQ] = ACTIONS(3881),
    [anon_sym_DASH_EQ] = ACTIONS(3881),
    [anon_sym_DOT_EQ] = ACTIONS(3881),
    [anon_sym_STAR_EQ] = ACTIONS(3881),
    [anon_sym_SLASH_EQ] = ACTIONS(3881),
    [anon_sym_PERCENT_EQ] = ACTIONS(3881),
    [anon_sym_x_EQ] = ACTIONS(3881),
    [anon_sym_AMP_EQ] = ACTIONS(3881),
    [anon_sym_PIPE_EQ] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(3881),
    [anon_sym_LT_LT_EQ] = ACTIONS(3881),
    [anon_sym_GT_GT_EQ] = ACTIONS(3881),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3881),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3881),
    [anon_sym_DOT_DOT] = ACTIONS(3883),
    [anon_sym_STAR_STAR] = ACTIONS(3883),
    [anon_sym_PIPE_PIPE] = ACTIONS(3883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(3883),
    [anon_sym_PIPE] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3883),
    [anon_sym_GT_GT2] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3883),
    [anon_sym_DOT] = ACTIONS(3883),
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_SLASH] = ACTIONS(3883),
    [anon_sym_x] = ACTIONS(3883),
    [anon_sym_EQ_TILDE] = ACTIONS(3881),
    [anon_sym_BANG_TILDE] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_eq] = ACTIONS(3881),
    [anon_sym_ne] = ACTIONS(3881),
    [anon_sym_LT_EQ_GT] = ACTIONS(3881),
    [anon_sym_cmp] = ACTIONS(3881),
    [anon_sym_TILDE_TILDE] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3883),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_lt] = ACTIONS(3881),
    [anon_sym_le] = ACTIONS(3881),
    [anon_sym_ge] = ACTIONS(3881),
    [anon_sym_gt] = ACTIONS(3881),
    [anon_sym_isa] = ACTIONS(3881),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_EQ_GT] = ACTIONS(3881),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1528] = {
    [sym_heredoc_content] = STATE(1528),
    [aux_sym__term_rightward_repeat1] = STATE(1529),
    [anon_sym_RBRACE] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym_RPAREN] = ACTIONS(3623),
    [anon_sym_COMMA] = ACTIONS(4483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3623),
    [anon_sym_and] = ACTIONS(3623),
    [anon_sym_or] = ACTIONS(3623),
    [anon_sym_RBRACK] = ACTIONS(3623),
    [anon_sym_DASH_GT] = ACTIONS(3623),
    [anon_sym_PERCENT] = ACTIONS(3627),
    [anon_sym_LT] = ACTIONS(3627),
    [anon_sym_GT] = ACTIONS(3627),
    [anon_sym_LT_LT] = ACTIONS(3627),
    [anon_sym_EQ] = ACTIONS(3627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3623),
    [anon_sym_PLUS_EQ] = ACTIONS(3623),
    [anon_sym_DASH_EQ] = ACTIONS(3623),
    [anon_sym_DOT_EQ] = ACTIONS(3623),
    [anon_sym_STAR_EQ] = ACTIONS(3623),
    [anon_sym_SLASH_EQ] = ACTIONS(3623),
    [anon_sym_PERCENT_EQ] = ACTIONS(3623),
    [anon_sym_x_EQ] = ACTIONS(3623),
    [anon_sym_AMP_EQ] = ACTIONS(3623),
    [anon_sym_PIPE_EQ] = ACTIONS(3623),
    [anon_sym_CARET_EQ] = ACTIONS(3623),
    [anon_sym_LT_LT_EQ] = ACTIONS(3623),
    [anon_sym_GT_GT_EQ] = ACTIONS(3623),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3623),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3623),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3623),
    [anon_sym_DOT_DOT] = ACTIONS(3627),
    [anon_sym_STAR_STAR] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3627),
    [anon_sym_SLASH_SLASH] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_PIPE] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_GT_GT2] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DOT] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(3627),
    [anon_sym_x] = ACTIONS(3627),
    [anon_sym_EQ_TILDE] = ACTIONS(3623),
    [anon_sym_BANG_TILDE] = ACTIONS(3623),
    [anon_sym_EQ_EQ] = ACTIONS(3623),
    [anon_sym_BANG_EQ] = ACTIONS(3623),
    [anon_sym_eq] = ACTIONS(3623),
    [anon_sym_ne] = ACTIONS(3623),
    [anon_sym_LT_EQ_GT] = ACTIONS(3623),
    [anon_sym_cmp] = ACTIONS(3623),
    [anon_sym_TILDE_TILDE] = ACTIONS(3623),
    [anon_sym_LT_EQ] = ACTIONS(3627),
    [anon_sym_GT_EQ] = ACTIONS(3623),
    [anon_sym_lt] = ACTIONS(3623),
    [anon_sym_le] = ACTIONS(3623),
    [anon_sym_ge] = ACTIONS(3623),
    [anon_sym_gt] = ACTIONS(3623),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_QMARK] = ACTIONS(3623),
    [anon_sym_EQ_GT] = ACTIONS(4483),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1529] = {
    [sym_heredoc_content] = STATE(1529),
    [aux_sym__term_rightward_repeat1] = STATE(1529),
    [anon_sym_RBRACE] = ACTIONS(3606),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_RPAREN] = ACTIONS(3606),
    [anon_sym_COMMA] = ACTIONS(4485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_and] = ACTIONS(3606),
    [anon_sym_or] = ACTIONS(3606),
    [anon_sym_RBRACK] = ACTIONS(3606),
    [anon_sym_DASH_GT] = ACTIONS(3606),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_LT_LT] = ACTIONS(3611),
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3606),
    [anon_sym_PLUS_EQ] = ACTIONS(3606),
    [anon_sym_DASH_EQ] = ACTIONS(3606),
    [anon_sym_DOT_EQ] = ACTIONS(3606),
    [anon_sym_STAR_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_PERCENT_EQ] = ACTIONS(3606),
    [anon_sym_x_EQ] = ACTIONS(3606),
    [anon_sym_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_CARET_EQ] = ACTIONS(3606),
    [anon_sym_LT_LT_EQ] = ACTIONS(3606),
    [anon_sym_GT_GT_EQ] = ACTIONS(3606),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_DOT_DOT] = ACTIONS(3611),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(3611),
    [anon_sym_SLASH_SLASH] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_GT_GT2] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_x] = ACTIONS(3611),
    [anon_sym_EQ_TILDE] = ACTIONS(3606),
    [anon_sym_BANG_TILDE] = ACTIONS(3606),
    [anon_sym_EQ_EQ] = ACTIONS(3606),
    [anon_sym_BANG_EQ] = ACTIONS(3606),
    [anon_sym_eq] = ACTIONS(3606),
    [anon_sym_ne] = ACTIONS(3606),
    [anon_sym_LT_EQ_GT] = ACTIONS(3606),
    [anon_sym_cmp] = ACTIONS(3606),
    [anon_sym_TILDE_TILDE] = ACTIONS(3606),
    [anon_sym_LT_EQ] = ACTIONS(3611),
    [anon_sym_GT_EQ] = ACTIONS(3606),
    [anon_sym_lt] = ACTIONS(3606),
    [anon_sym_le] = ACTIONS(3606),
    [anon_sym_ge] = ACTIONS(3606),
    [anon_sym_gt] = ACTIONS(3606),
    [anon_sym_isa] = ACTIONS(3606),
    [anon_sym_PLUS_PLUS] = ACTIONS(3606),
    [anon_sym_DASH_DASH] = ACTIONS(3606),
    [anon_sym_QMARK] = ACTIONS(3606),
    [anon_sym_EQ_GT] = ACTIONS(4485),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1530] = {
    [sym_attribute] = STATE(1676),
    [sym_attribute_name] = STATE(1648),
    [sym_heredoc_content] = STATE(1530),
    [aux_sym_attrlist_repeat1] = STATE(1530),
    [sym__identifier] = ACTIONS(4488),
    [anon_sym_COLON] = ACTIONS(4491),
    [anon_sym_RPAREN] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4488),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1531] = {
    [sym_heredoc_content] = STATE(1531),
    [anon_sym_RBRACE] = ACTIONS(4138),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4138),
    [anon_sym_RPAREN] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_RBRACK] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4140),
    [anon_sym_GT] = ACTIONS(4140),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4140),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4138),
    [anon_sym_DASH_EQ] = ACTIONS(4138),
    [anon_sym_DOT_EQ] = ACTIONS(4138),
    [anon_sym_STAR_EQ] = ACTIONS(4138),
    [anon_sym_SLASH_EQ] = ACTIONS(4138),
    [anon_sym_PERCENT_EQ] = ACTIONS(4138),
    [anon_sym_x_EQ] = ACTIONS(4138),
    [anon_sym_AMP_EQ] = ACTIONS(4138),
    [anon_sym_PIPE_EQ] = ACTIONS(4138),
    [anon_sym_CARET_EQ] = ACTIONS(4138),
    [anon_sym_LT_LT_EQ] = ACTIONS(4138),
    [anon_sym_GT_GT_EQ] = ACTIONS(4138),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4138),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4138),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_STAR_STAR] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_SLASH_SLASH] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4140),
    [anon_sym_AMP] = ACTIONS(4140),
    [anon_sym_GT_GT2] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4140),
    [anon_sym_DASH] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4140),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4140),
    [anon_sym_x] = ACTIONS(4140),
    [anon_sym_EQ_TILDE] = ACTIONS(4138),
    [anon_sym_BANG_TILDE] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_BANG_EQ] = ACTIONS(4138),
    [anon_sym_eq] = ACTIONS(4138),
    [anon_sym_ne] = ACTIONS(4138),
    [anon_sym_LT_EQ_GT] = ACTIONS(4138),
    [anon_sym_cmp] = ACTIONS(4138),
    [anon_sym_TILDE_TILDE] = ACTIONS(4138),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4138),
    [anon_sym_lt] = ACTIONS(4138),
    [anon_sym_le] = ACTIONS(4138),
    [anon_sym_ge] = ACTIONS(4138),
    [anon_sym_gt] = ACTIONS(4138),
    [anon_sym_isa] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4138),
    [anon_sym_DASH_DASH] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4138),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1532] = {
    [sym_heredoc_content] = STATE(1532),
    [anon_sym_RBRACE] = ACTIONS(3909),
    [anon_sym_COLON] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(3909),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_COMMA] = ACTIONS(3909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3909),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_RBRACK] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_EQ] = ACTIONS(3911),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3909),
    [anon_sym_PLUS_EQ] = ACTIONS(3909),
    [anon_sym_DASH_EQ] = ACTIONS(3909),
    [anon_sym_DOT_EQ] = ACTIONS(3909),
    [anon_sym_STAR_EQ] = ACTIONS(3909),
    [anon_sym_SLASH_EQ] = ACTIONS(3909),
    [anon_sym_PERCENT_EQ] = ACTIONS(3909),
    [anon_sym_x_EQ] = ACTIONS(3909),
    [anon_sym_AMP_EQ] = ACTIONS(3909),
    [anon_sym_PIPE_EQ] = ACTIONS(3909),
    [anon_sym_CARET_EQ] = ACTIONS(3909),
    [anon_sym_LT_LT_EQ] = ACTIONS(3909),
    [anon_sym_GT_GT_EQ] = ACTIONS(3909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3909),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3909),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_STAR_STAR] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_SLASH_SLASH] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3911),
    [anon_sym_GT_GT2] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3911),
    [anon_sym_DASH] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3911),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3911),
    [anon_sym_x] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3909),
    [anon_sym_BANG_TILDE] = ACTIONS(3909),
    [anon_sym_EQ_EQ] = ACTIONS(3909),
    [anon_sym_BANG_EQ] = ACTIONS(3909),
    [anon_sym_eq] = ACTIONS(3909),
    [anon_sym_ne] = ACTIONS(3909),
    [anon_sym_LT_EQ_GT] = ACTIONS(3909),
    [anon_sym_cmp] = ACTIONS(3909),
    [anon_sym_TILDE_TILDE] = ACTIONS(3909),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3909),
    [anon_sym_lt] = ACTIONS(3909),
    [anon_sym_le] = ACTIONS(3909),
    [anon_sym_ge] = ACTIONS(3909),
    [anon_sym_gt] = ACTIONS(3909),
    [anon_sym_isa] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3909),
    [anon_sym_DASH_DASH] = ACTIONS(3909),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_EQ_GT] = ACTIONS(3909),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1533] = {
    [sym_heredoc_content] = STATE(1533),
    [anon_sym_RBRACE] = ACTIONS(3913),
    [anon_sym_COLON] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_RPAREN] = ACTIONS(3913),
    [anon_sym_COMMA] = ACTIONS(3913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3913),
    [anon_sym_and] = ACTIONS(3913),
    [anon_sym_or] = ACTIONS(3913),
    [anon_sym_RBRACK] = ACTIONS(3913),
    [anon_sym_DASH_GT] = ACTIONS(3913),
    [anon_sym_PERCENT] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_LT_LT] = ACTIONS(3915),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3913),
    [anon_sym_PLUS_EQ] = ACTIONS(3913),
    [anon_sym_DASH_EQ] = ACTIONS(3913),
    [anon_sym_DOT_EQ] = ACTIONS(3913),
    [anon_sym_STAR_EQ] = ACTIONS(3913),
    [anon_sym_SLASH_EQ] = ACTIONS(3913),
    [anon_sym_PERCENT_EQ] = ACTIONS(3913),
    [anon_sym_x_EQ] = ACTIONS(3913),
    [anon_sym_AMP_EQ] = ACTIONS(3913),
    [anon_sym_PIPE_EQ] = ACTIONS(3913),
    [anon_sym_CARET_EQ] = ACTIONS(3913),
    [anon_sym_LT_LT_EQ] = ACTIONS(3913),
    [anon_sym_GT_GT_EQ] = ACTIONS(3913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3913),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3915),
    [anon_sym_STAR_STAR] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_SLASH_SLASH] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3915),
    [anon_sym_GT_GT2] = ACTIONS(3915),
    [anon_sym_PLUS] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3915),
    [anon_sym_DOT] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_SLASH] = ACTIONS(3915),
    [anon_sym_x] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3913),
    [anon_sym_BANG_TILDE] = ACTIONS(3913),
    [anon_sym_EQ_EQ] = ACTIONS(3913),
    [anon_sym_BANG_EQ] = ACTIONS(3913),
    [anon_sym_eq] = ACTIONS(3913),
    [anon_sym_ne] = ACTIONS(3913),
    [anon_sym_LT_EQ_GT] = ACTIONS(3913),
    [anon_sym_cmp] = ACTIONS(3913),
    [anon_sym_TILDE_TILDE] = ACTIONS(3913),
    [anon_sym_LT_EQ] = ACTIONS(3915),
    [anon_sym_GT_EQ] = ACTIONS(3913),
    [anon_sym_lt] = ACTIONS(3913),
    [anon_sym_le] = ACTIONS(3913),
    [anon_sym_ge] = ACTIONS(3913),
    [anon_sym_gt] = ACTIONS(3913),
    [anon_sym_isa] = ACTIONS(3913),
    [anon_sym_PLUS_PLUS] = ACTIONS(3913),
    [anon_sym_DASH_DASH] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_EQ_GT] = ACTIONS(3913),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1534] = {
    [sym_heredoc_content] = STATE(1534),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3949),
    [anon_sym_or] = ACTIONS(3949),
    [anon_sym_RBRACK] = ACTIONS(3949),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_GT] = ACTIONS(3951),
    [anon_sym_LT_LT] = ACTIONS(3951),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3949),
    [anon_sym_PLUS_EQ] = ACTIONS(3949),
    [anon_sym_DASH_EQ] = ACTIONS(3949),
    [anon_sym_DOT_EQ] = ACTIONS(3949),
    [anon_sym_STAR_EQ] = ACTIONS(3949),
    [anon_sym_SLASH_EQ] = ACTIONS(3949),
    [anon_sym_PERCENT_EQ] = ACTIONS(3949),
    [anon_sym_x_EQ] = ACTIONS(3949),
    [anon_sym_AMP_EQ] = ACTIONS(3949),
    [anon_sym_PIPE_EQ] = ACTIONS(3949),
    [anon_sym_CARET_EQ] = ACTIONS(3949),
    [anon_sym_LT_LT_EQ] = ACTIONS(3949),
    [anon_sym_GT_GT_EQ] = ACTIONS(3949),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3949),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3949),
    [anon_sym_DOT_DOT] = ACTIONS(3951),
    [anon_sym_STAR_STAR] = ACTIONS(3951),
    [anon_sym_PIPE_PIPE] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_PIPE] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_GT_GT2] = ACTIONS(3951),
    [anon_sym_PLUS] = ACTIONS(3951),
    [anon_sym_DASH] = ACTIONS(3951),
    [anon_sym_DOT] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_SLASH] = ACTIONS(3951),
    [anon_sym_x] = ACTIONS(3951),
    [anon_sym_EQ_TILDE] = ACTIONS(3949),
    [anon_sym_BANG_TILDE] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_eq] = ACTIONS(3949),
    [anon_sym_ne] = ACTIONS(3949),
    [anon_sym_LT_EQ_GT] = ACTIONS(3949),
    [anon_sym_cmp] = ACTIONS(3949),
    [anon_sym_TILDE_TILDE] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3951),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_lt] = ACTIONS(3949),
    [anon_sym_le] = ACTIONS(3949),
    [anon_sym_ge] = ACTIONS(3949),
    [anon_sym_gt] = ACTIONS(3949),
    [anon_sym_isa] = ACTIONS(3949),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_EQ_GT] = ACTIONS(3949),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1535] = {
    [sym_heredoc_content] = STATE(1535),
    [anon_sym_RBRACE] = ACTIONS(3957),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_SEMI] = ACTIONS(3957),
    [anon_sym_RPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3957),
    [anon_sym_and] = ACTIONS(3957),
    [anon_sym_or] = ACTIONS(3957),
    [anon_sym_RBRACK] = ACTIONS(3957),
    [anon_sym_DASH_GT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_GT] = ACTIONS(3959),
    [anon_sym_LT_LT] = ACTIONS(3959),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3957),
    [anon_sym_PLUS_EQ] = ACTIONS(3957),
    [anon_sym_DASH_EQ] = ACTIONS(3957),
    [anon_sym_DOT_EQ] = ACTIONS(3957),
    [anon_sym_STAR_EQ] = ACTIONS(3957),
    [anon_sym_SLASH_EQ] = ACTIONS(3957),
    [anon_sym_PERCENT_EQ] = ACTIONS(3957),
    [anon_sym_x_EQ] = ACTIONS(3957),
    [anon_sym_AMP_EQ] = ACTIONS(3957),
    [anon_sym_PIPE_EQ] = ACTIONS(3957),
    [anon_sym_CARET_EQ] = ACTIONS(3957),
    [anon_sym_LT_LT_EQ] = ACTIONS(3957),
    [anon_sym_GT_GT_EQ] = ACTIONS(3957),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3957),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3957),
    [anon_sym_DOT_DOT] = ACTIONS(3959),
    [anon_sym_STAR_STAR] = ACTIONS(3959),
    [anon_sym_PIPE_PIPE] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH] = ACTIONS(3959),
    [anon_sym_AMP_AMP] = ACTIONS(3959),
    [anon_sym_PIPE] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_GT_GT2] = ACTIONS(3959),
    [anon_sym_PLUS] = ACTIONS(3959),
    [anon_sym_DASH] = ACTIONS(3959),
    [anon_sym_DOT] = ACTIONS(3959),
    [anon_sym_STAR] = ACTIONS(3959),
    [anon_sym_SLASH] = ACTIONS(3959),
    [anon_sym_x] = ACTIONS(3959),
    [anon_sym_EQ_TILDE] = ACTIONS(3957),
    [anon_sym_BANG_TILDE] = ACTIONS(3957),
    [anon_sym_EQ_EQ] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_eq] = ACTIONS(3957),
    [anon_sym_ne] = ACTIONS(3957),
    [anon_sym_LT_EQ_GT] = ACTIONS(3957),
    [anon_sym_cmp] = ACTIONS(3957),
    [anon_sym_TILDE_TILDE] = ACTIONS(3957),
    [anon_sym_LT_EQ] = ACTIONS(3959),
    [anon_sym_GT_EQ] = ACTIONS(3957),
    [anon_sym_lt] = ACTIONS(3957),
    [anon_sym_le] = ACTIONS(3957),
    [anon_sym_ge] = ACTIONS(3957),
    [anon_sym_gt] = ACTIONS(3957),
    [anon_sym_isa] = ACTIONS(3957),
    [anon_sym_PLUS_PLUS] = ACTIONS(3957),
    [anon_sym_DASH_DASH] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_EQ_GT] = ACTIONS(3957),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1536] = {
    [sym_heredoc_content] = STATE(1536),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(4040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4040),
    [anon_sym_and] = ACTIONS(4040),
    [anon_sym_or] = ACTIONS(4040),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_DASH_GT] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4042),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4040),
    [anon_sym_PLUS_EQ] = ACTIONS(4040),
    [anon_sym_DASH_EQ] = ACTIONS(4040),
    [anon_sym_DOT_EQ] = ACTIONS(4040),
    [anon_sym_STAR_EQ] = ACTIONS(4040),
    [anon_sym_SLASH_EQ] = ACTIONS(4040),
    [anon_sym_PERCENT_EQ] = ACTIONS(4040),
    [anon_sym_x_EQ] = ACTIONS(4040),
    [anon_sym_AMP_EQ] = ACTIONS(4040),
    [anon_sym_PIPE_EQ] = ACTIONS(4040),
    [anon_sym_CARET_EQ] = ACTIONS(4040),
    [anon_sym_LT_LT_EQ] = ACTIONS(4040),
    [anon_sym_GT_GT_EQ] = ACTIONS(4040),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4040),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_STAR_STAR] = ACTIONS(4042),
    [anon_sym_PIPE_PIPE] = ACTIONS(4042),
    [anon_sym_SLASH_SLASH] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_GT_GT2] = ACTIONS(4042),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_DOT] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(4042),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_x] = ACTIONS(4042),
    [anon_sym_EQ_TILDE] = ACTIONS(4040),
    [anon_sym_BANG_TILDE] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_eq] = ACTIONS(4040),
    [anon_sym_ne] = ACTIONS(4040),
    [anon_sym_LT_EQ_GT] = ACTIONS(4040),
    [anon_sym_cmp] = ACTIONS(4040),
    [anon_sym_TILDE_TILDE] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4042),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [anon_sym_lt] = ACTIONS(4040),
    [anon_sym_le] = ACTIONS(4040),
    [anon_sym_ge] = ACTIONS(4040),
    [anon_sym_gt] = ACTIONS(4040),
    [anon_sym_isa] = ACTIONS(4040),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1537] = {
    [sym_heredoc_content] = STATE(1537),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4074),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_RBRACK] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_DOT_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_x_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_STAR_STAR] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_SLASH_SLASH] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4076),
    [anon_sym_GT_GT2] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_DASH] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4076),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4076),
    [anon_sym_x] = ACTIONS(4076),
    [anon_sym_EQ_TILDE] = ACTIONS(4074),
    [anon_sym_BANG_TILDE] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_eq] = ACTIONS(4074),
    [anon_sym_ne] = ACTIONS(4074),
    [anon_sym_LT_EQ_GT] = ACTIONS(4074),
    [anon_sym_cmp] = ACTIONS(4074),
    [anon_sym_TILDE_TILDE] = ACTIONS(4074),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4074),
    [anon_sym_lt] = ACTIONS(4074),
    [anon_sym_le] = ACTIONS(4074),
    [anon_sym_ge] = ACTIONS(4074),
    [anon_sym_gt] = ACTIONS(4074),
    [anon_sym_isa] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4074),
    [anon_sym_DASH_DASH] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1538] = {
    [sym_heredoc_content] = STATE(1538),
    [anon_sym_RBRACE] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym_RPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3933),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_RBRACK] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_GT] = ACTIONS(3935),
    [anon_sym_LT_LT] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3933),
    [anon_sym_PLUS_EQ] = ACTIONS(3933),
    [anon_sym_DASH_EQ] = ACTIONS(3933),
    [anon_sym_DOT_EQ] = ACTIONS(3933),
    [anon_sym_STAR_EQ] = ACTIONS(3933),
    [anon_sym_SLASH_EQ] = ACTIONS(3933),
    [anon_sym_PERCENT_EQ] = ACTIONS(3933),
    [anon_sym_x_EQ] = ACTIONS(3933),
    [anon_sym_AMP_EQ] = ACTIONS(3933),
    [anon_sym_PIPE_EQ] = ACTIONS(3933),
    [anon_sym_CARET_EQ] = ACTIONS(3933),
    [anon_sym_LT_LT_EQ] = ACTIONS(3933),
    [anon_sym_GT_GT_EQ] = ACTIONS(3933),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3933),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3933),
    [anon_sym_DOT_DOT] = ACTIONS(3935),
    [anon_sym_STAR_STAR] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_GT_GT2] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_STAR] = ACTIONS(3935),
    [anon_sym_SLASH] = ACTIONS(3935),
    [anon_sym_x] = ACTIONS(3935),
    [anon_sym_EQ_TILDE] = ACTIONS(3933),
    [anon_sym_BANG_TILDE] = ACTIONS(3933),
    [anon_sym_EQ_EQ] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_eq] = ACTIONS(3933),
    [anon_sym_ne] = ACTIONS(3933),
    [anon_sym_LT_EQ_GT] = ACTIONS(3933),
    [anon_sym_cmp] = ACTIONS(3933),
    [anon_sym_TILDE_TILDE] = ACTIONS(3933),
    [anon_sym_LT_EQ] = ACTIONS(3935),
    [anon_sym_GT_EQ] = ACTIONS(3933),
    [anon_sym_lt] = ACTIONS(3933),
    [anon_sym_le] = ACTIONS(3933),
    [anon_sym_ge] = ACTIONS(3933),
    [anon_sym_gt] = ACTIONS(3933),
    [anon_sym_isa] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_EQ_GT] = ACTIONS(3933),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1539] = {
    [sym_heredoc_content] = STATE(1539),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_COLON] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3641),
    [anon_sym_RPAREN] = ACTIONS(3641),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3641),
    [anon_sym_and] = ACTIONS(3641),
    [anon_sym_or] = ACTIONS(3641),
    [anon_sym_RBRACK] = ACTIONS(3641),
    [anon_sym_DASH_GT] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3643),
    [anon_sym_LT] = ACTIONS(3643),
    [anon_sym_GT] = ACTIONS(3643),
    [anon_sym_LT_LT] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(3643),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3641),
    [anon_sym_PLUS_EQ] = ACTIONS(3641),
    [anon_sym_DASH_EQ] = ACTIONS(3641),
    [anon_sym_DOT_EQ] = ACTIONS(3641),
    [anon_sym_STAR_EQ] = ACTIONS(3641),
    [anon_sym_SLASH_EQ] = ACTIONS(3641),
    [anon_sym_PERCENT_EQ] = ACTIONS(3641),
    [anon_sym_x_EQ] = ACTIONS(3641),
    [anon_sym_AMP_EQ] = ACTIONS(3641),
    [anon_sym_PIPE_EQ] = ACTIONS(3641),
    [anon_sym_CARET_EQ] = ACTIONS(3641),
    [anon_sym_LT_LT_EQ] = ACTIONS(3641),
    [anon_sym_GT_GT_EQ] = ACTIONS(3641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3641),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3641),
    [anon_sym_DOT_DOT] = ACTIONS(3643),
    [anon_sym_STAR_STAR] = ACTIONS(3643),
    [anon_sym_PIPE_PIPE] = ACTIONS(3643),
    [anon_sym_SLASH_SLASH] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_PIPE] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_GT_GT2] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3643),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_SLASH] = ACTIONS(3643),
    [anon_sym_x] = ACTIONS(3643),
    [anon_sym_EQ_TILDE] = ACTIONS(3641),
    [anon_sym_BANG_TILDE] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BANG_EQ] = ACTIONS(3641),
    [anon_sym_eq] = ACTIONS(3641),
    [anon_sym_ne] = ACTIONS(3641),
    [anon_sym_LT_EQ_GT] = ACTIONS(3641),
    [anon_sym_cmp] = ACTIONS(3641),
    [anon_sym_TILDE_TILDE] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3643),
    [anon_sym_GT_EQ] = ACTIONS(3641),
    [anon_sym_lt] = ACTIONS(3641),
    [anon_sym_le] = ACTIONS(3641),
    [anon_sym_ge] = ACTIONS(3641),
    [anon_sym_gt] = ACTIONS(3641),
    [anon_sym_isa] = ACTIONS(3641),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_EQ_GT] = ACTIONS(3641),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1540] = {
    [sym_heredoc_content] = STATE(1540),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4218),
    [anon_sym_SEMI] = ACTIONS(4218),
    [anon_sym_RPAREN] = ACTIONS(4218),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(4218),
    [anon_sym_or] = ACTIONS(4218),
    [anon_sym_RBRACK] = ACTIONS(4218),
    [anon_sym_DASH_GT] = ACTIONS(4218),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_LT] = ACTIONS(4220),
    [anon_sym_GT] = ACTIONS(4220),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4220),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4218),
    [anon_sym_PLUS_EQ] = ACTIONS(4218),
    [anon_sym_DASH_EQ] = ACTIONS(4218),
    [anon_sym_DOT_EQ] = ACTIONS(4218),
    [anon_sym_STAR_EQ] = ACTIONS(4218),
    [anon_sym_SLASH_EQ] = ACTIONS(4218),
    [anon_sym_PERCENT_EQ] = ACTIONS(4218),
    [anon_sym_x_EQ] = ACTIONS(4218),
    [anon_sym_AMP_EQ] = ACTIONS(4218),
    [anon_sym_PIPE_EQ] = ACTIONS(4218),
    [anon_sym_CARET_EQ] = ACTIONS(4218),
    [anon_sym_LT_LT_EQ] = ACTIONS(4218),
    [anon_sym_GT_GT_EQ] = ACTIONS(4218),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4218),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4218),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4220),
    [anon_sym_STAR_STAR] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_SLASH_SLASH] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_PIPE] = ACTIONS(4220),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_GT_GT2] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_STAR] = ACTIONS(4220),
    [anon_sym_SLASH] = ACTIONS(4220),
    [anon_sym_x] = ACTIONS(4220),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_EQ_EQ] = ACTIONS(4218),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_eq] = ACTIONS(4218),
    [anon_sym_ne] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_cmp] = ACTIONS(4218),
    [anon_sym_TILDE_TILDE] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4220),
    [anon_sym_GT_EQ] = ACTIONS(4218),
    [anon_sym_lt] = ACTIONS(4218),
    [anon_sym_le] = ACTIONS(4218),
    [anon_sym_ge] = ACTIONS(4218),
    [anon_sym_gt] = ACTIONS(4218),
    [anon_sym_isa] = ACTIONS(4218),
    [anon_sym_PLUS_PLUS] = ACTIONS(4218),
    [anon_sym_DASH_DASH] = ACTIONS(4218),
    [anon_sym_QMARK] = ACTIONS(4218),
    [anon_sym_EQ_GT] = ACTIONS(4218),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1541] = {
    [sym_attribute] = STATE(1676),
    [sym_attribute_name] = STATE(1648),
    [sym_heredoc_content] = STATE(1541),
    [aux_sym_attrlist_repeat1] = STATE(1546),
    [sym__identifier] = ACTIONS(4494),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(3416),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3416),
    [anon_sym_DASH_GT] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(3418),
    [anon_sym_GT] = ACTIONS(3418),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3416),
    [anon_sym_PLUS_EQ] = ACTIONS(3416),
    [anon_sym_DASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_EQ] = ACTIONS(3416),
    [anon_sym_STAR_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_PERCENT_EQ] = ACTIONS(3416),
    [anon_sym_x_EQ] = ACTIONS(3416),
    [anon_sym_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_CARET_EQ] = ACTIONS(3416),
    [anon_sym_LT_LT_EQ] = ACTIONS(3416),
    [anon_sym_GT_GT_EQ] = ACTIONS(3416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_DOT] = ACTIONS(3418),
    [anon_sym_STAR_STAR] = ACTIONS(3418),
    [anon_sym_PIPE_PIPE] = ACTIONS(3418),
    [anon_sym_SLASH_SLASH] = ACTIONS(3418),
    [anon_sym_AMP_AMP] = ACTIONS(3418),
    [anon_sym_PIPE] = ACTIONS(3418),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_GT_GT2] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_DOT] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3418),
    [anon_sym_SLASH] = ACTIONS(3418),
    [anon_sym_x] = ACTIONS(3418),
    [anon_sym_EQ_TILDE] = ACTIONS(3416),
    [anon_sym_BANG_TILDE] = ACTIONS(3416),
    [anon_sym_EQ_EQ] = ACTIONS(3416),
    [anon_sym_BANG_EQ] = ACTIONS(3416),
    [anon_sym_eq] = ACTIONS(3418),
    [anon_sym_ne] = ACTIONS(3418),
    [anon_sym_LT_EQ_GT] = ACTIONS(3416),
    [anon_sym_cmp] = ACTIONS(3418),
    [anon_sym_TILDE_TILDE] = ACTIONS(3416),
    [anon_sym_LT_EQ] = ACTIONS(3418),
    [anon_sym_GT_EQ] = ACTIONS(3416),
    [anon_sym_lt] = ACTIONS(3418),
    [anon_sym_le] = ACTIONS(3418),
    [anon_sym_ge] = ACTIONS(3418),
    [anon_sym_gt] = ACTIONS(3418),
    [anon_sym_isa] = ACTIONS(3418),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3416),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4494),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1542] = {
    [sym_heredoc_content] = STATE(1542),
    [anon_sym_RBRACE] = ACTIONS(4250),
    [anon_sym_COLON] = ACTIONS(4250),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [anon_sym_COMMA] = ACTIONS(4250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4250),
    [anon_sym_and] = ACTIONS(4250),
    [anon_sym_or] = ACTIONS(4250),
    [anon_sym_RBRACK] = ACTIONS(4250),
    [anon_sym_DASH_GT] = ACTIONS(4250),
    [anon_sym_PERCENT] = ACTIONS(4252),
    [anon_sym_LT] = ACTIONS(4252),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_LT_LT] = ACTIONS(4252),
    [anon_sym_EQ] = ACTIONS(4252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4250),
    [anon_sym_PLUS_EQ] = ACTIONS(4250),
    [anon_sym_DASH_EQ] = ACTIONS(4250),
    [anon_sym_DOT_EQ] = ACTIONS(4250),
    [anon_sym_STAR_EQ] = ACTIONS(4250),
    [anon_sym_SLASH_EQ] = ACTIONS(4250),
    [anon_sym_PERCENT_EQ] = ACTIONS(4250),
    [anon_sym_x_EQ] = ACTIONS(4250),
    [anon_sym_AMP_EQ] = ACTIONS(4250),
    [anon_sym_PIPE_EQ] = ACTIONS(4250),
    [anon_sym_CARET_EQ] = ACTIONS(4250),
    [anon_sym_LT_LT_EQ] = ACTIONS(4250),
    [anon_sym_GT_GT_EQ] = ACTIONS(4250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4250),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4250),
    [anon_sym_DOT_DOT] = ACTIONS(4252),
    [anon_sym_STAR_STAR] = ACTIONS(4252),
    [anon_sym_PIPE_PIPE] = ACTIONS(4252),
    [anon_sym_SLASH_SLASH] = ACTIONS(4252),
    [anon_sym_AMP_AMP] = ACTIONS(4252),
    [anon_sym_PIPE] = ACTIONS(4252),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym_GT_GT2] = ACTIONS(4252),
    [anon_sym_PLUS] = ACTIONS(4252),
    [anon_sym_DASH] = ACTIONS(4252),
    [anon_sym_DOT] = ACTIONS(4252),
    [anon_sym_STAR] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4252),
    [anon_sym_x] = ACTIONS(4252),
    [anon_sym_EQ_TILDE] = ACTIONS(4250),
    [anon_sym_BANG_TILDE] = ACTIONS(4250),
    [anon_sym_EQ_EQ] = ACTIONS(4250),
    [anon_sym_BANG_EQ] = ACTIONS(4250),
    [anon_sym_eq] = ACTIONS(4250),
    [anon_sym_ne] = ACTIONS(4250),
    [anon_sym_LT_EQ_GT] = ACTIONS(4250),
    [anon_sym_cmp] = ACTIONS(4250),
    [anon_sym_TILDE_TILDE] = ACTIONS(4250),
    [anon_sym_LT_EQ] = ACTIONS(4252),
    [anon_sym_GT_EQ] = ACTIONS(4250),
    [anon_sym_lt] = ACTIONS(4250),
    [anon_sym_le] = ACTIONS(4250),
    [anon_sym_ge] = ACTIONS(4250),
    [anon_sym_gt] = ACTIONS(4250),
    [anon_sym_isa] = ACTIONS(4250),
    [anon_sym_PLUS_PLUS] = ACTIONS(4250),
    [anon_sym_DASH_DASH] = ACTIONS(4250),
    [anon_sym_QMARK] = ACTIONS(4250),
    [anon_sym_EQ_GT] = ACTIONS(4250),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1543] = {
    [sym_heredoc_content] = STATE(1543),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3889),
    [anon_sym_RPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_RBRACK] = ACTIONS(3889),
    [anon_sym_DASH_GT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_GT] = ACTIONS(3891),
    [anon_sym_LT_LT] = ACTIONS(3891),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3889),
    [anon_sym_PLUS_EQ] = ACTIONS(3889),
    [anon_sym_DASH_EQ] = ACTIONS(3889),
    [anon_sym_DOT_EQ] = ACTIONS(3889),
    [anon_sym_STAR_EQ] = ACTIONS(3889),
    [anon_sym_SLASH_EQ] = ACTIONS(3889),
    [anon_sym_PERCENT_EQ] = ACTIONS(3889),
    [anon_sym_x_EQ] = ACTIONS(3889),
    [anon_sym_AMP_EQ] = ACTIONS(3889),
    [anon_sym_PIPE_EQ] = ACTIONS(3889),
    [anon_sym_CARET_EQ] = ACTIONS(3889),
    [anon_sym_LT_LT_EQ] = ACTIONS(3889),
    [anon_sym_GT_GT_EQ] = ACTIONS(3889),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3889),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3889),
    [anon_sym_DOT_DOT] = ACTIONS(3891),
    [anon_sym_STAR_STAR] = ACTIONS(3891),
    [anon_sym_PIPE_PIPE] = ACTIONS(3891),
    [anon_sym_SLASH_SLASH] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_PIPE] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3891),
    [anon_sym_GT_GT2] = ACTIONS(3891),
    [anon_sym_PLUS] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3891),
    [anon_sym_DOT] = ACTIONS(3891),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_SLASH] = ACTIONS(3891),
    [anon_sym_x] = ACTIONS(3891),
    [anon_sym_EQ_TILDE] = ACTIONS(3889),
    [anon_sym_BANG_TILDE] = ACTIONS(3889),
    [anon_sym_EQ_EQ] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_eq] = ACTIONS(3889),
    [anon_sym_ne] = ACTIONS(3889),
    [anon_sym_LT_EQ_GT] = ACTIONS(3889),
    [anon_sym_cmp] = ACTIONS(3889),
    [anon_sym_TILDE_TILDE] = ACTIONS(3889),
    [anon_sym_LT_EQ] = ACTIONS(3891),
    [anon_sym_GT_EQ] = ACTIONS(3889),
    [anon_sym_lt] = ACTIONS(3889),
    [anon_sym_le] = ACTIONS(3889),
    [anon_sym_ge] = ACTIONS(3889),
    [anon_sym_gt] = ACTIONS(3889),
    [anon_sym_isa] = ACTIONS(3889),
    [anon_sym_PLUS_PLUS] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_EQ_GT] = ACTIONS(3889),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1544] = {
    [sym_heredoc_content] = STATE(1544),
    [anon_sym_RBRACE] = ACTIONS(4142),
    [anon_sym_COLON] = ACTIONS(4142),
    [anon_sym_SEMI] = ACTIONS(4142),
    [anon_sym_RPAREN] = ACTIONS(4142),
    [anon_sym_COMMA] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4142),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_RBRACK] = ACTIONS(4142),
    [anon_sym_DASH_GT] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4144),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4144),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4142),
    [anon_sym_PLUS_EQ] = ACTIONS(4142),
    [anon_sym_DASH_EQ] = ACTIONS(4142),
    [anon_sym_DOT_EQ] = ACTIONS(4142),
    [anon_sym_STAR_EQ] = ACTIONS(4142),
    [anon_sym_SLASH_EQ] = ACTIONS(4142),
    [anon_sym_PERCENT_EQ] = ACTIONS(4142),
    [anon_sym_x_EQ] = ACTIONS(4142),
    [anon_sym_AMP_EQ] = ACTIONS(4142),
    [anon_sym_PIPE_EQ] = ACTIONS(4142),
    [anon_sym_CARET_EQ] = ACTIONS(4142),
    [anon_sym_LT_LT_EQ] = ACTIONS(4142),
    [anon_sym_GT_GT_EQ] = ACTIONS(4142),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4142),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4142),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_STAR_STAR] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_SLASH_SLASH] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4144),
    [anon_sym_AMP] = ACTIONS(4144),
    [anon_sym_GT_GT2] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4144),
    [anon_sym_DASH] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4144),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4144),
    [anon_sym_x] = ACTIONS(4144),
    [anon_sym_EQ_TILDE] = ACTIONS(4142),
    [anon_sym_BANG_TILDE] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4142),
    [anon_sym_BANG_EQ] = ACTIONS(4142),
    [anon_sym_eq] = ACTIONS(4142),
    [anon_sym_ne] = ACTIONS(4142),
    [anon_sym_LT_EQ_GT] = ACTIONS(4142),
    [anon_sym_cmp] = ACTIONS(4142),
    [anon_sym_TILDE_TILDE] = ACTIONS(4142),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_lt] = ACTIONS(4142),
    [anon_sym_le] = ACTIONS(4142),
    [anon_sym_ge] = ACTIONS(4142),
    [anon_sym_gt] = ACTIONS(4142),
    [anon_sym_isa] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4142),
    [anon_sym_DASH_DASH] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4142),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1545] = {
    [sym_heredoc_content] = STATE(1545),
    [anon_sym_RBRACE] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4234),
    [anon_sym_SEMI] = ACTIONS(4234),
    [anon_sym_RPAREN] = ACTIONS(4234),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4234),
    [anon_sym_and] = ACTIONS(4234),
    [anon_sym_or] = ACTIONS(4234),
    [anon_sym_RBRACK] = ACTIONS(4234),
    [anon_sym_DASH_GT] = ACTIONS(4234),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_LT] = ACTIONS(4236),
    [anon_sym_GT] = ACTIONS(4236),
    [anon_sym_LT_LT] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4234),
    [anon_sym_PLUS_EQ] = ACTIONS(4234),
    [anon_sym_DASH_EQ] = ACTIONS(4234),
    [anon_sym_DOT_EQ] = ACTIONS(4234),
    [anon_sym_STAR_EQ] = ACTIONS(4234),
    [anon_sym_SLASH_EQ] = ACTIONS(4234),
    [anon_sym_PERCENT_EQ] = ACTIONS(4234),
    [anon_sym_x_EQ] = ACTIONS(4234),
    [anon_sym_AMP_EQ] = ACTIONS(4234),
    [anon_sym_PIPE_EQ] = ACTIONS(4234),
    [anon_sym_CARET_EQ] = ACTIONS(4234),
    [anon_sym_LT_LT_EQ] = ACTIONS(4234),
    [anon_sym_GT_GT_EQ] = ACTIONS(4234),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4234),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4234),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4234),
    [anon_sym_DOT_DOT] = ACTIONS(4236),
    [anon_sym_STAR_STAR] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_SLASH_SLASH] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_GT_GT2] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_STAR] = ACTIONS(4236),
    [anon_sym_SLASH] = ACTIONS(4236),
    [anon_sym_x] = ACTIONS(4236),
    [anon_sym_EQ_TILDE] = ACTIONS(4234),
    [anon_sym_BANG_TILDE] = ACTIONS(4234),
    [anon_sym_EQ_EQ] = ACTIONS(4234),
    [anon_sym_BANG_EQ] = ACTIONS(4234),
    [anon_sym_eq] = ACTIONS(4234),
    [anon_sym_ne] = ACTIONS(4234),
    [anon_sym_LT_EQ_GT] = ACTIONS(4234),
    [anon_sym_cmp] = ACTIONS(4234),
    [anon_sym_TILDE_TILDE] = ACTIONS(4234),
    [anon_sym_LT_EQ] = ACTIONS(4236),
    [anon_sym_GT_EQ] = ACTIONS(4234),
    [anon_sym_lt] = ACTIONS(4234),
    [anon_sym_le] = ACTIONS(4234),
    [anon_sym_ge] = ACTIONS(4234),
    [anon_sym_gt] = ACTIONS(4234),
    [anon_sym_isa] = ACTIONS(4234),
    [anon_sym_PLUS_PLUS] = ACTIONS(4234),
    [anon_sym_DASH_DASH] = ACTIONS(4234),
    [anon_sym_QMARK] = ACTIONS(4234),
    [anon_sym_EQ_GT] = ACTIONS(4234),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1546] = {
    [sym_attribute] = STATE(1676),
    [sym_attribute_name] = STATE(1648),
    [sym_heredoc_content] = STATE(1546),
    [aux_sym_attrlist_repeat1] = STATE(1530),
    [sym__identifier] = ACTIONS(4494),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(3420),
    [anon_sym_COMMA] = ACTIONS(3420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3420),
    [anon_sym_DASH_GT] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3422),
    [anon_sym_GT] = ACTIONS(3422),
    [anon_sym_LT_LT] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3422),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_x_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_DOT] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3422),
    [anon_sym_PIPE_PIPE] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_AMP_AMP] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(3422),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_GT_GT2] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_DASH] = ACTIONS(3422),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_STAR] = ACTIONS(3422),
    [anon_sym_SLASH] = ACTIONS(3422),
    [anon_sym_x] = ACTIONS(3422),
    [anon_sym_EQ_TILDE] = ACTIONS(3420),
    [anon_sym_BANG_TILDE] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3420),
    [anon_sym_BANG_EQ] = ACTIONS(3420),
    [anon_sym_eq] = ACTIONS(3422),
    [anon_sym_ne] = ACTIONS(3422),
    [anon_sym_LT_EQ_GT] = ACTIONS(3420),
    [anon_sym_cmp] = ACTIONS(3422),
    [anon_sym_TILDE_TILDE] = ACTIONS(3420),
    [anon_sym_LT_EQ] = ACTIONS(3422),
    [anon_sym_GT_EQ] = ACTIONS(3420),
    [anon_sym_lt] = ACTIONS(3422),
    [anon_sym_le] = ACTIONS(3422),
    [anon_sym_ge] = ACTIONS(3422),
    [anon_sym_gt] = ACTIONS(3422),
    [anon_sym_isa] = ACTIONS(3422),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_EQ_GT] = ACTIONS(3420),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4494),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1547] = {
    [sym_heredoc_content] = STATE(1547),
    [anon_sym_RBRACE] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3873),
    [anon_sym_SEMI] = ACTIONS(3873),
    [anon_sym_RPAREN] = ACTIONS(3873),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3873),
    [anon_sym_and] = ACTIONS(3873),
    [anon_sym_or] = ACTIONS(3873),
    [anon_sym_RBRACK] = ACTIONS(3873),
    [anon_sym_DASH_GT] = ACTIONS(3873),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_LT] = ACTIONS(3875),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_LT_LT] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3875),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3873),
    [anon_sym_PLUS_EQ] = ACTIONS(3873),
    [anon_sym_DASH_EQ] = ACTIONS(3873),
    [anon_sym_DOT_EQ] = ACTIONS(3873),
    [anon_sym_STAR_EQ] = ACTIONS(3873),
    [anon_sym_SLASH_EQ] = ACTIONS(3873),
    [anon_sym_PERCENT_EQ] = ACTIONS(3873),
    [anon_sym_x_EQ] = ACTIONS(3873),
    [anon_sym_AMP_EQ] = ACTIONS(3873),
    [anon_sym_PIPE_EQ] = ACTIONS(3873),
    [anon_sym_CARET_EQ] = ACTIONS(3873),
    [anon_sym_LT_LT_EQ] = ACTIONS(3873),
    [anon_sym_GT_GT_EQ] = ACTIONS(3873),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3873),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3873),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3873),
    [anon_sym_DOT_DOT] = ACTIONS(3875),
    [anon_sym_STAR_STAR] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_SLASH_SLASH] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_PIPE] = ACTIONS(3875),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_GT_GT2] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_SLASH] = ACTIONS(3875),
    [anon_sym_x] = ACTIONS(3875),
    [anon_sym_EQ_TILDE] = ACTIONS(3873),
    [anon_sym_BANG_TILDE] = ACTIONS(3873),
    [anon_sym_EQ_EQ] = ACTIONS(3873),
    [anon_sym_BANG_EQ] = ACTIONS(3873),
    [anon_sym_eq] = ACTIONS(3873),
    [anon_sym_ne] = ACTIONS(3873),
    [anon_sym_LT_EQ_GT] = ACTIONS(3873),
    [anon_sym_cmp] = ACTIONS(3873),
    [anon_sym_TILDE_TILDE] = ACTIONS(3873),
    [anon_sym_LT_EQ] = ACTIONS(3875),
    [anon_sym_GT_EQ] = ACTIONS(3873),
    [anon_sym_lt] = ACTIONS(3873),
    [anon_sym_le] = ACTIONS(3873),
    [anon_sym_ge] = ACTIONS(3873),
    [anon_sym_gt] = ACTIONS(3873),
    [anon_sym_isa] = ACTIONS(3873),
    [anon_sym_PLUS_PLUS] = ACTIONS(3873),
    [anon_sym_DASH_DASH] = ACTIONS(3873),
    [anon_sym_QMARK] = ACTIONS(3873),
    [anon_sym_EQ_GT] = ACTIONS(3873),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1548] = {
    [sym_attrlist] = STATE(1801),
    [sym_attribute] = STATE(1429),
    [sym_attribute_name] = STATE(1620),
    [sym_heredoc_content] = STATE(1548),
    [sym__identifier] = ACTIONS(4369),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_COMMA] = ACTIONS(3434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3434),
    [anon_sym_DASH_GT] = ACTIONS(3434),
    [anon_sym_PERCENT] = ACTIONS(3436),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_LT_LT] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3434),
    [anon_sym_DASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_EQ] = ACTIONS(3434),
    [anon_sym_STAR_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_PERCENT_EQ] = ACTIONS(3434),
    [anon_sym_x_EQ] = ACTIONS(3434),
    [anon_sym_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_CARET_EQ] = ACTIONS(3434),
    [anon_sym_LT_LT_EQ] = ACTIONS(3434),
    [anon_sym_GT_GT_EQ] = ACTIONS(3434),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_DOT] = ACTIONS(3436),
    [anon_sym_STAR_STAR] = ACTIONS(3436),
    [anon_sym_PIPE_PIPE] = ACTIONS(3436),
    [anon_sym_SLASH_SLASH] = ACTIONS(3436),
    [anon_sym_AMP_AMP] = ACTIONS(3436),
    [anon_sym_PIPE] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_GT_GT2] = ACTIONS(3436),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_DOT] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3436),
    [anon_sym_SLASH] = ACTIONS(3436),
    [anon_sym_x] = ACTIONS(3436),
    [anon_sym_EQ_TILDE] = ACTIONS(3434),
    [anon_sym_BANG_TILDE] = ACTIONS(3434),
    [anon_sym_EQ_EQ] = ACTIONS(3434),
    [anon_sym_BANG_EQ] = ACTIONS(3434),
    [anon_sym_eq] = ACTIONS(3436),
    [anon_sym_ne] = ACTIONS(3436),
    [anon_sym_LT_EQ_GT] = ACTIONS(3434),
    [anon_sym_cmp] = ACTIONS(3436),
    [anon_sym_TILDE_TILDE] = ACTIONS(3434),
    [anon_sym_LT_EQ] = ACTIONS(3436),
    [anon_sym_GT_EQ] = ACTIONS(3434),
    [anon_sym_lt] = ACTIONS(3436),
    [anon_sym_le] = ACTIONS(3436),
    [anon_sym_ge] = ACTIONS(3436),
    [anon_sym_gt] = ACTIONS(3436),
    [anon_sym_isa] = ACTIONS(3436),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_QMARK] = ACTIONS(3434),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4369),
    [sym__PERLY_SEMICOLON] = ACTIONS(3434),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1549] = {
    [sym_attrlist] = STATE(1802),
    [sym_attribute] = STATE(1429),
    [sym_attribute_name] = STATE(1620),
    [sym_heredoc_content] = STATE(1549),
    [sym__identifier] = ACTIONS(4369),
    [anon_sym_SEMI] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3438),
    [anon_sym_PLUS_EQ] = ACTIONS(3438),
    [anon_sym_DASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_EQ] = ACTIONS(3438),
    [anon_sym_STAR_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_PERCENT_EQ] = ACTIONS(3438),
    [anon_sym_x_EQ] = ACTIONS(3438),
    [anon_sym_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_CARET_EQ] = ACTIONS(3438),
    [anon_sym_LT_LT_EQ] = ACTIONS(3438),
    [anon_sym_GT_GT_EQ] = ACTIONS(3438),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3440),
    [anon_sym_GT_GT2] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_x] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3438),
    [anon_sym_BANG_TILDE] = ACTIONS(3438),
    [anon_sym_EQ_EQ] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_eq] = ACTIONS(3440),
    [anon_sym_ne] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3438),
    [anon_sym_cmp] = ACTIONS(3440),
    [anon_sym_TILDE_TILDE] = ACTIONS(3438),
    [anon_sym_LT_EQ] = ACTIONS(3440),
    [anon_sym_GT_EQ] = ACTIONS(3438),
    [anon_sym_lt] = ACTIONS(3440),
    [anon_sym_le] = ACTIONS(3440),
    [anon_sym_ge] = ACTIONS(3440),
    [anon_sym_gt] = ACTIONS(3440),
    [anon_sym_isa] = ACTIONS(3440),
    [anon_sym_PLUS_PLUS] = ACTIONS(3438),
    [anon_sym_DASH_DASH] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3438),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4369),
    [sym__PERLY_SEMICOLON] = ACTIONS(3438),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1550] = {
    [sym_heredoc_content] = STATE(1550),
    [anon_sym_RBRACE] = ACTIONS(4170),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym_RPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4170),
    [anon_sym_and] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_RBRACK] = ACTIONS(4170),
    [anon_sym_DASH_GT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_GT] = ACTIONS(4172),
    [anon_sym_LT_LT] = ACTIONS(4172),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4170),
    [anon_sym_PLUS_EQ] = ACTIONS(4170),
    [anon_sym_DASH_EQ] = ACTIONS(4170),
    [anon_sym_DOT_EQ] = ACTIONS(4170),
    [anon_sym_STAR_EQ] = ACTIONS(4170),
    [anon_sym_SLASH_EQ] = ACTIONS(4170),
    [anon_sym_PERCENT_EQ] = ACTIONS(4170),
    [anon_sym_x_EQ] = ACTIONS(4170),
    [anon_sym_AMP_EQ] = ACTIONS(4170),
    [anon_sym_PIPE_EQ] = ACTIONS(4170),
    [anon_sym_CARET_EQ] = ACTIONS(4170),
    [anon_sym_LT_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT_GT_EQ] = ACTIONS(4170),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4170),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_STAR_STAR] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_SLASH_SLASH] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_GT_GT2] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4172),
    [anon_sym_DASH] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(4172),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_SLASH] = ACTIONS(4172),
    [anon_sym_x] = ACTIONS(4172),
    [anon_sym_EQ_TILDE] = ACTIONS(4170),
    [anon_sym_BANG_TILDE] = ACTIONS(4170),
    [anon_sym_EQ_EQ] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_eq] = ACTIONS(4170),
    [anon_sym_ne] = ACTIONS(4170),
    [anon_sym_LT_EQ_GT] = ACTIONS(4170),
    [anon_sym_cmp] = ACTIONS(4170),
    [anon_sym_TILDE_TILDE] = ACTIONS(4170),
    [anon_sym_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_EQ] = ACTIONS(4170),
    [anon_sym_lt] = ACTIONS(4170),
    [anon_sym_le] = ACTIONS(4170),
    [anon_sym_ge] = ACTIONS(4170),
    [anon_sym_gt] = ACTIONS(4170),
    [anon_sym_isa] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4170),
    [anon_sym_DASH_DASH] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(4170),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1551] = {
    [sym_heredoc_content] = STATE(1551),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4100),
    [anon_sym_and] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_RBRACK] = ACTIONS(4100),
    [anon_sym_DASH_GT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_LT_LT] = ACTIONS(4102),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4100),
    [anon_sym_PLUS_EQ] = ACTIONS(4100),
    [anon_sym_DASH_EQ] = ACTIONS(4100),
    [anon_sym_DOT_EQ] = ACTIONS(4100),
    [anon_sym_STAR_EQ] = ACTIONS(4100),
    [anon_sym_SLASH_EQ] = ACTIONS(4100),
    [anon_sym_PERCENT_EQ] = ACTIONS(4100),
    [anon_sym_x_EQ] = ACTIONS(4100),
    [anon_sym_AMP_EQ] = ACTIONS(4100),
    [anon_sym_PIPE_EQ] = ACTIONS(4100),
    [anon_sym_CARET_EQ] = ACTIONS(4100),
    [anon_sym_LT_LT_EQ] = ACTIONS(4100),
    [anon_sym_GT_GT_EQ] = ACTIONS(4100),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4100),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4100),
    [anon_sym_DOT_DOT] = ACTIONS(4102),
    [anon_sym_STAR_STAR] = ACTIONS(4102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4102),
    [anon_sym_SLASH_SLASH] = ACTIONS(4102),
    [anon_sym_AMP_AMP] = ACTIONS(4102),
    [anon_sym_PIPE] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_GT_GT2] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4102),
    [anon_sym_SLASH] = ACTIONS(4102),
    [anon_sym_x] = ACTIONS(4102),
    [anon_sym_EQ_TILDE] = ACTIONS(4100),
    [anon_sym_BANG_TILDE] = ACTIONS(4100),
    [anon_sym_EQ_EQ] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_eq] = ACTIONS(4100),
    [anon_sym_ne] = ACTIONS(4100),
    [anon_sym_LT_EQ_GT] = ACTIONS(4100),
    [anon_sym_cmp] = ACTIONS(4100),
    [anon_sym_TILDE_TILDE] = ACTIONS(4100),
    [anon_sym_LT_EQ] = ACTIONS(4102),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_lt] = ACTIONS(4100),
    [anon_sym_le] = ACTIONS(4100),
    [anon_sym_ge] = ACTIONS(4100),
    [anon_sym_gt] = ACTIONS(4100),
    [anon_sym_isa] = ACTIONS(4100),
    [anon_sym_PLUS_PLUS] = ACTIONS(4100),
    [anon_sym_DASH_DASH] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_EQ_GT] = ACTIONS(4100),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1552] = {
    [sym_heredoc_content] = STATE(1552),
    [anon_sym_RBRACE] = ACTIONS(4194),
    [anon_sym_COLON] = ACTIONS(4194),
    [anon_sym_SEMI] = ACTIONS(4194),
    [anon_sym_RPAREN] = ACTIONS(4194),
    [anon_sym_COMMA] = ACTIONS(4194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4194),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_RBRACK] = ACTIONS(4194),
    [anon_sym_DASH_GT] = ACTIONS(4194),
    [anon_sym_PERCENT] = ACTIONS(4196),
    [anon_sym_LT] = ACTIONS(4196),
    [anon_sym_GT] = ACTIONS(4196),
    [anon_sym_LT_LT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(4196),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4194),
    [anon_sym_DASH_EQ] = ACTIONS(4194),
    [anon_sym_DOT_EQ] = ACTIONS(4194),
    [anon_sym_STAR_EQ] = ACTIONS(4194),
    [anon_sym_SLASH_EQ] = ACTIONS(4194),
    [anon_sym_PERCENT_EQ] = ACTIONS(4194),
    [anon_sym_x_EQ] = ACTIONS(4194),
    [anon_sym_AMP_EQ] = ACTIONS(4194),
    [anon_sym_PIPE_EQ] = ACTIONS(4194),
    [anon_sym_CARET_EQ] = ACTIONS(4194),
    [anon_sym_LT_LT_EQ] = ACTIONS(4194),
    [anon_sym_GT_GT_EQ] = ACTIONS(4194),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4194),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4194),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4194),
    [anon_sym_DOT_DOT] = ACTIONS(4196),
    [anon_sym_STAR_STAR] = ACTIONS(4196),
    [anon_sym_PIPE_PIPE] = ACTIONS(4196),
    [anon_sym_SLASH_SLASH] = ACTIONS(4196),
    [anon_sym_AMP_AMP] = ACTIONS(4196),
    [anon_sym_PIPE] = ACTIONS(4196),
    [anon_sym_AMP] = ACTIONS(4196),
    [anon_sym_GT_GT2] = ACTIONS(4196),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_STAR] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4196),
    [anon_sym_x] = ACTIONS(4196),
    [anon_sym_EQ_TILDE] = ACTIONS(4194),
    [anon_sym_BANG_TILDE] = ACTIONS(4194),
    [anon_sym_EQ_EQ] = ACTIONS(4194),
    [anon_sym_BANG_EQ] = ACTIONS(4194),
    [anon_sym_eq] = ACTIONS(4194),
    [anon_sym_ne] = ACTIONS(4194),
    [anon_sym_LT_EQ_GT] = ACTIONS(4194),
    [anon_sym_cmp] = ACTIONS(4194),
    [anon_sym_TILDE_TILDE] = ACTIONS(4194),
    [anon_sym_LT_EQ] = ACTIONS(4196),
    [anon_sym_GT_EQ] = ACTIONS(4194),
    [anon_sym_lt] = ACTIONS(4194),
    [anon_sym_le] = ACTIONS(4194),
    [anon_sym_ge] = ACTIONS(4194),
    [anon_sym_gt] = ACTIONS(4194),
    [anon_sym_isa] = ACTIONS(4194),
    [anon_sym_PLUS_PLUS] = ACTIONS(4194),
    [anon_sym_DASH_DASH] = ACTIONS(4194),
    [anon_sym_QMARK] = ACTIONS(4194),
    [anon_sym_EQ_GT] = ACTIONS(4194),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1553] = {
    [sym_heredoc_content] = STATE(1553),
    [anon_sym_RBRACE] = ACTIONS(4150),
    [anon_sym_COLON] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4150),
    [anon_sym_RPAREN] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4150),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_RBRACK] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_LT] = ACTIONS(4152),
    [anon_sym_GT] = ACTIONS(4152),
    [anon_sym_LT_LT] = ACTIONS(4152),
    [anon_sym_EQ] = ACTIONS(4152),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4150),
    [anon_sym_PLUS_EQ] = ACTIONS(4150),
    [anon_sym_DASH_EQ] = ACTIONS(4150),
    [anon_sym_DOT_EQ] = ACTIONS(4150),
    [anon_sym_STAR_EQ] = ACTIONS(4150),
    [anon_sym_SLASH_EQ] = ACTIONS(4150),
    [anon_sym_PERCENT_EQ] = ACTIONS(4150),
    [anon_sym_x_EQ] = ACTIONS(4150),
    [anon_sym_AMP_EQ] = ACTIONS(4150),
    [anon_sym_PIPE_EQ] = ACTIONS(4150),
    [anon_sym_CARET_EQ] = ACTIONS(4150),
    [anon_sym_LT_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT_GT_EQ] = ACTIONS(4150),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4150),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4152),
    [anon_sym_STAR_STAR] = ACTIONS(4152),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_SLASH_SLASH] = ACTIONS(4152),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4152),
    [anon_sym_AMP] = ACTIONS(4152),
    [anon_sym_GT_GT2] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4152),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_SLASH] = ACTIONS(4152),
    [anon_sym_x] = ACTIONS(4152),
    [anon_sym_EQ_TILDE] = ACTIONS(4150),
    [anon_sym_BANG_TILDE] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4150),
    [anon_sym_eq] = ACTIONS(4150),
    [anon_sym_ne] = ACTIONS(4150),
    [anon_sym_LT_EQ_GT] = ACTIONS(4150),
    [anon_sym_cmp] = ACTIONS(4150),
    [anon_sym_TILDE_TILDE] = ACTIONS(4150),
    [anon_sym_LT_EQ] = ACTIONS(4152),
    [anon_sym_GT_EQ] = ACTIONS(4150),
    [anon_sym_lt] = ACTIONS(4150),
    [anon_sym_le] = ACTIONS(4150),
    [anon_sym_ge] = ACTIONS(4150),
    [anon_sym_gt] = ACTIONS(4150),
    [anon_sym_isa] = ACTIONS(4150),
    [anon_sym_PLUS_PLUS] = ACTIONS(4150),
    [anon_sym_DASH_DASH] = ACTIONS(4150),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4150),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1554] = {
    [sym_heredoc_content] = STATE(1554),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3929),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_RBRACK] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3929),
    [anon_sym_PLUS_EQ] = ACTIONS(3929),
    [anon_sym_DASH_EQ] = ACTIONS(3929),
    [anon_sym_DOT_EQ] = ACTIONS(3929),
    [anon_sym_STAR_EQ] = ACTIONS(3929),
    [anon_sym_SLASH_EQ] = ACTIONS(3929),
    [anon_sym_PERCENT_EQ] = ACTIONS(3929),
    [anon_sym_x_EQ] = ACTIONS(3929),
    [anon_sym_AMP_EQ] = ACTIONS(3929),
    [anon_sym_PIPE_EQ] = ACTIONS(3929),
    [anon_sym_CARET_EQ] = ACTIONS(3929),
    [anon_sym_LT_LT_EQ] = ACTIONS(3929),
    [anon_sym_GT_GT_EQ] = ACTIONS(3929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3929),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3929),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_STAR_STAR] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_GT_GT2] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3931),
    [anon_sym_x] = ACTIONS(3931),
    [anon_sym_EQ_TILDE] = ACTIONS(3929),
    [anon_sym_BANG_TILDE] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_eq] = ACTIONS(3929),
    [anon_sym_ne] = ACTIONS(3929),
    [anon_sym_LT_EQ_GT] = ACTIONS(3929),
    [anon_sym_cmp] = ACTIONS(3929),
    [anon_sym_TILDE_TILDE] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_lt] = ACTIONS(3929),
    [anon_sym_le] = ACTIONS(3929),
    [anon_sym_ge] = ACTIONS(3929),
    [anon_sym_gt] = ACTIONS(3929),
    [anon_sym_isa] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_EQ_GT] = ACTIONS(3929),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1555] = {
    [sym_heredoc_content] = STATE(1555),
    [anon_sym_RBRACE] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3925),
    [anon_sym_and] = ACTIONS(3925),
    [anon_sym_or] = ACTIONS(3925),
    [anon_sym_RBRACK] = ACTIONS(3925),
    [anon_sym_DASH_GT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3925),
    [anon_sym_PLUS_EQ] = ACTIONS(3925),
    [anon_sym_DASH_EQ] = ACTIONS(3925),
    [anon_sym_DOT_EQ] = ACTIONS(3925),
    [anon_sym_STAR_EQ] = ACTIONS(3925),
    [anon_sym_SLASH_EQ] = ACTIONS(3925),
    [anon_sym_PERCENT_EQ] = ACTIONS(3925),
    [anon_sym_x_EQ] = ACTIONS(3925),
    [anon_sym_AMP_EQ] = ACTIONS(3925),
    [anon_sym_PIPE_EQ] = ACTIONS(3925),
    [anon_sym_CARET_EQ] = ACTIONS(3925),
    [anon_sym_LT_LT_EQ] = ACTIONS(3925),
    [anon_sym_GT_GT_EQ] = ACTIONS(3925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3925),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3925),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT2] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3927),
    [anon_sym_x] = ACTIONS(3927),
    [anon_sym_EQ_TILDE] = ACTIONS(3925),
    [anon_sym_BANG_TILDE] = ACTIONS(3925),
    [anon_sym_EQ_EQ] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_eq] = ACTIONS(3925),
    [anon_sym_ne] = ACTIONS(3925),
    [anon_sym_LT_EQ_GT] = ACTIONS(3925),
    [anon_sym_cmp] = ACTIONS(3925),
    [anon_sym_TILDE_TILDE] = ACTIONS(3925),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3925),
    [anon_sym_lt] = ACTIONS(3925),
    [anon_sym_le] = ACTIONS(3925),
    [anon_sym_ge] = ACTIONS(3925),
    [anon_sym_gt] = ACTIONS(3925),
    [anon_sym_isa] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_EQ_GT] = ACTIONS(3925),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1556] = {
    [sym_heredoc_content] = STATE(1556),
    [aux_sym__term_rightward_repeat1] = STATE(2356),
    [anon_sym_RBRACE] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(4498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4441),
    [anon_sym_and] = ACTIONS(3645),
    [anon_sym_or] = ACTIONS(3645),
    [anon_sym_RBRACK] = ACTIONS(3645),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4451),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_x_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4455),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4459),
    [anon_sym_SLASH_SLASH] = ACTIONS(4459),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4481),
    [anon_sym_EQ_GT] = ACTIONS(4498),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1557] = {
    [sym_heredoc_content] = STATE(1557),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [anon_sym_COLON] = ACTIONS(4202),
    [anon_sym_SEMI] = ACTIONS(4202),
    [anon_sym_RPAREN] = ACTIONS(4202),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4202),
    [anon_sym_and] = ACTIONS(4202),
    [anon_sym_or] = ACTIONS(4202),
    [anon_sym_RBRACK] = ACTIONS(4202),
    [anon_sym_DASH_GT] = ACTIONS(4202),
    [anon_sym_PERCENT] = ACTIONS(4204),
    [anon_sym_LT] = ACTIONS(4204),
    [anon_sym_GT] = ACTIONS(4204),
    [anon_sym_LT_LT] = ACTIONS(4204),
    [anon_sym_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4202),
    [anon_sym_PLUS_EQ] = ACTIONS(4202),
    [anon_sym_DASH_EQ] = ACTIONS(4202),
    [anon_sym_DOT_EQ] = ACTIONS(4202),
    [anon_sym_STAR_EQ] = ACTIONS(4202),
    [anon_sym_SLASH_EQ] = ACTIONS(4202),
    [anon_sym_PERCENT_EQ] = ACTIONS(4202),
    [anon_sym_x_EQ] = ACTIONS(4202),
    [anon_sym_AMP_EQ] = ACTIONS(4202),
    [anon_sym_PIPE_EQ] = ACTIONS(4202),
    [anon_sym_CARET_EQ] = ACTIONS(4202),
    [anon_sym_LT_LT_EQ] = ACTIONS(4202),
    [anon_sym_GT_GT_EQ] = ACTIONS(4202),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4202),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4202),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4202),
    [anon_sym_DOT_DOT] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4204),
    [anon_sym_SLASH_SLASH] = ACTIONS(4204),
    [anon_sym_AMP_AMP] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4204),
    [anon_sym_AMP] = ACTIONS(4204),
    [anon_sym_GT_GT2] = ACTIONS(4204),
    [anon_sym_PLUS] = ACTIONS(4204),
    [anon_sym_DASH] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4204),
    [anon_sym_STAR] = ACTIONS(4204),
    [anon_sym_SLASH] = ACTIONS(4204),
    [anon_sym_x] = ACTIONS(4204),
    [anon_sym_EQ_TILDE] = ACTIONS(4202),
    [anon_sym_BANG_TILDE] = ACTIONS(4202),
    [anon_sym_EQ_EQ] = ACTIONS(4202),
    [anon_sym_BANG_EQ] = ACTIONS(4202),
    [anon_sym_eq] = ACTIONS(4202),
    [anon_sym_ne] = ACTIONS(4202),
    [anon_sym_LT_EQ_GT] = ACTIONS(4202),
    [anon_sym_cmp] = ACTIONS(4202),
    [anon_sym_TILDE_TILDE] = ACTIONS(4202),
    [anon_sym_LT_EQ] = ACTIONS(4204),
    [anon_sym_GT_EQ] = ACTIONS(4202),
    [anon_sym_lt] = ACTIONS(4202),
    [anon_sym_le] = ACTIONS(4202),
    [anon_sym_ge] = ACTIONS(4202),
    [anon_sym_gt] = ACTIONS(4202),
    [anon_sym_isa] = ACTIONS(4202),
    [anon_sym_PLUS_PLUS] = ACTIONS(4202),
    [anon_sym_DASH_DASH] = ACTIONS(4202),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_EQ_GT] = ACTIONS(4202),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1558] = {
    [sym_heredoc_content] = STATE(1558),
    [anon_sym_RBRACE] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4226),
    [anon_sym_SEMI] = ACTIONS(4226),
    [anon_sym_RPAREN] = ACTIONS(4226),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4226),
    [anon_sym_and] = ACTIONS(4226),
    [anon_sym_or] = ACTIONS(4226),
    [anon_sym_RBRACK] = ACTIONS(4226),
    [anon_sym_DASH_GT] = ACTIONS(4226),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_LT] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4228),
    [anon_sym_LT_LT] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4228),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4226),
    [anon_sym_PLUS_EQ] = ACTIONS(4226),
    [anon_sym_DASH_EQ] = ACTIONS(4226),
    [anon_sym_DOT_EQ] = ACTIONS(4226),
    [anon_sym_STAR_EQ] = ACTIONS(4226),
    [anon_sym_SLASH_EQ] = ACTIONS(4226),
    [anon_sym_PERCENT_EQ] = ACTIONS(4226),
    [anon_sym_x_EQ] = ACTIONS(4226),
    [anon_sym_AMP_EQ] = ACTIONS(4226),
    [anon_sym_PIPE_EQ] = ACTIONS(4226),
    [anon_sym_CARET_EQ] = ACTIONS(4226),
    [anon_sym_LT_LT_EQ] = ACTIONS(4226),
    [anon_sym_GT_GT_EQ] = ACTIONS(4226),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4226),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4226),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4226),
    [anon_sym_DOT_DOT] = ACTIONS(4228),
    [anon_sym_STAR_STAR] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_SLASH_SLASH] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_PIPE] = ACTIONS(4228),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT_GT2] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_STAR] = ACTIONS(4228),
    [anon_sym_SLASH] = ACTIONS(4228),
    [anon_sym_x] = ACTIONS(4228),
    [anon_sym_EQ_TILDE] = ACTIONS(4226),
    [anon_sym_BANG_TILDE] = ACTIONS(4226),
    [anon_sym_EQ_EQ] = ACTIONS(4226),
    [anon_sym_BANG_EQ] = ACTIONS(4226),
    [anon_sym_eq] = ACTIONS(4226),
    [anon_sym_ne] = ACTIONS(4226),
    [anon_sym_LT_EQ_GT] = ACTIONS(4226),
    [anon_sym_cmp] = ACTIONS(4226),
    [anon_sym_TILDE_TILDE] = ACTIONS(4226),
    [anon_sym_LT_EQ] = ACTIONS(4228),
    [anon_sym_GT_EQ] = ACTIONS(4226),
    [anon_sym_lt] = ACTIONS(4226),
    [anon_sym_le] = ACTIONS(4226),
    [anon_sym_ge] = ACTIONS(4226),
    [anon_sym_gt] = ACTIONS(4226),
    [anon_sym_isa] = ACTIONS(4226),
    [anon_sym_PLUS_PLUS] = ACTIONS(4226),
    [anon_sym_DASH_DASH] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4226),
    [anon_sym_EQ_GT] = ACTIONS(4226),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1559] = {
    [sym_heredoc_content] = STATE(1559),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3847),
    [anon_sym_and] = ACTIONS(3847),
    [anon_sym_or] = ACTIONS(3847),
    [anon_sym_RBRACK] = ACTIONS(3847),
    [anon_sym_DASH_GT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_GT] = ACTIONS(3849),
    [anon_sym_LT_LT] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3847),
    [anon_sym_PLUS_EQ] = ACTIONS(3847),
    [anon_sym_DASH_EQ] = ACTIONS(3847),
    [anon_sym_DOT_EQ] = ACTIONS(3847),
    [anon_sym_STAR_EQ] = ACTIONS(3847),
    [anon_sym_SLASH_EQ] = ACTIONS(3847),
    [anon_sym_PERCENT_EQ] = ACTIONS(3847),
    [anon_sym_x_EQ] = ACTIONS(3847),
    [anon_sym_AMP_EQ] = ACTIONS(3847),
    [anon_sym_PIPE_EQ] = ACTIONS(3847),
    [anon_sym_CARET_EQ] = ACTIONS(3847),
    [anon_sym_LT_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT_GT_EQ] = ACTIONS(3847),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3847),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3847),
    [anon_sym_DOT_DOT] = ACTIONS(3849),
    [anon_sym_STAR_STAR] = ACTIONS(3849),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH] = ACTIONS(3849),
    [anon_sym_AMP_AMP] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3849),
    [anon_sym_GT_GT2] = ACTIONS(3849),
    [anon_sym_PLUS] = ACTIONS(3849),
    [anon_sym_DASH] = ACTIONS(3849),
    [anon_sym_DOT] = ACTIONS(3849),
    [anon_sym_STAR] = ACTIONS(3849),
    [anon_sym_SLASH] = ACTIONS(3849),
    [anon_sym_x] = ACTIONS(3849),
    [anon_sym_EQ_TILDE] = ACTIONS(3847),
    [anon_sym_BANG_TILDE] = ACTIONS(3847),
    [anon_sym_EQ_EQ] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_eq] = ACTIONS(3847),
    [anon_sym_ne] = ACTIONS(3847),
    [anon_sym_LT_EQ_GT] = ACTIONS(3847),
    [anon_sym_cmp] = ACTIONS(3847),
    [anon_sym_TILDE_TILDE] = ACTIONS(3847),
    [anon_sym_LT_EQ] = ACTIONS(3849),
    [anon_sym_GT_EQ] = ACTIONS(3847),
    [anon_sym_lt] = ACTIONS(3847),
    [anon_sym_le] = ACTIONS(3847),
    [anon_sym_ge] = ACTIONS(3847),
    [anon_sym_gt] = ACTIONS(3847),
    [anon_sym_isa] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_EQ_GT] = ACTIONS(3847),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1560] = {
    [sym_heredoc_content] = STATE(1560),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3843),
    [anon_sym_SEMI] = ACTIONS(3843),
    [anon_sym_RPAREN] = ACTIONS(3843),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3843),
    [anon_sym_and] = ACTIONS(3843),
    [anon_sym_or] = ACTIONS(3843),
    [anon_sym_RBRACK] = ACTIONS(3843),
    [anon_sym_DASH_GT] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_LT] = ACTIONS(3845),
    [anon_sym_GT] = ACTIONS(3845),
    [anon_sym_LT_LT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3843),
    [anon_sym_PLUS_EQ] = ACTIONS(3843),
    [anon_sym_DASH_EQ] = ACTIONS(3843),
    [anon_sym_DOT_EQ] = ACTIONS(3843),
    [anon_sym_STAR_EQ] = ACTIONS(3843),
    [anon_sym_SLASH_EQ] = ACTIONS(3843),
    [anon_sym_PERCENT_EQ] = ACTIONS(3843),
    [anon_sym_x_EQ] = ACTIONS(3843),
    [anon_sym_AMP_EQ] = ACTIONS(3843),
    [anon_sym_PIPE_EQ] = ACTIONS(3843),
    [anon_sym_CARET_EQ] = ACTIONS(3843),
    [anon_sym_LT_LT_EQ] = ACTIONS(3843),
    [anon_sym_GT_GT_EQ] = ACTIONS(3843),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3843),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3843),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3843),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_STAR_STAR] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_SLASH_SLASH] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_PIPE] = ACTIONS(3845),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_GT_GT2] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3845),
    [anon_sym_SLASH] = ACTIONS(3845),
    [anon_sym_x] = ACTIONS(3845),
    [anon_sym_EQ_TILDE] = ACTIONS(3843),
    [anon_sym_BANG_TILDE] = ACTIONS(3843),
    [anon_sym_EQ_EQ] = ACTIONS(3843),
    [anon_sym_BANG_EQ] = ACTIONS(3843),
    [anon_sym_eq] = ACTIONS(3843),
    [anon_sym_ne] = ACTIONS(3843),
    [anon_sym_LT_EQ_GT] = ACTIONS(3843),
    [anon_sym_cmp] = ACTIONS(3843),
    [anon_sym_TILDE_TILDE] = ACTIONS(3843),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_GT_EQ] = ACTIONS(3843),
    [anon_sym_lt] = ACTIONS(3843),
    [anon_sym_le] = ACTIONS(3843),
    [anon_sym_ge] = ACTIONS(3843),
    [anon_sym_gt] = ACTIONS(3843),
    [anon_sym_isa] = ACTIONS(3843),
    [anon_sym_PLUS_PLUS] = ACTIONS(3843),
    [anon_sym_DASH_DASH] = ACTIONS(3843),
    [anon_sym_QMARK] = ACTIONS(3843),
    [anon_sym_EQ_GT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1561] = {
    [sym_heredoc_content] = STATE(1561),
    [anon_sym_RBRACE] = ACTIONS(3961),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_SEMI] = ACTIONS(3961),
    [anon_sym_RPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3961),
    [anon_sym_and] = ACTIONS(3961),
    [anon_sym_or] = ACTIONS(3961),
    [anon_sym_RBRACK] = ACTIONS(3961),
    [anon_sym_DASH_GT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_GT] = ACTIONS(3963),
    [anon_sym_LT_LT] = ACTIONS(3963),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3961),
    [anon_sym_PLUS_EQ] = ACTIONS(3961),
    [anon_sym_DASH_EQ] = ACTIONS(3961),
    [anon_sym_DOT_EQ] = ACTIONS(3961),
    [anon_sym_STAR_EQ] = ACTIONS(3961),
    [anon_sym_SLASH_EQ] = ACTIONS(3961),
    [anon_sym_PERCENT_EQ] = ACTIONS(3961),
    [anon_sym_x_EQ] = ACTIONS(3961),
    [anon_sym_AMP_EQ] = ACTIONS(3961),
    [anon_sym_PIPE_EQ] = ACTIONS(3961),
    [anon_sym_CARET_EQ] = ACTIONS(3961),
    [anon_sym_LT_LT_EQ] = ACTIONS(3961),
    [anon_sym_GT_GT_EQ] = ACTIONS(3961),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3961),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3961),
    [anon_sym_DOT_DOT] = ACTIONS(3963),
    [anon_sym_STAR_STAR] = ACTIONS(3963),
    [anon_sym_PIPE_PIPE] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH] = ACTIONS(3963),
    [anon_sym_AMP_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_GT_GT2] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_DOT] = ACTIONS(3963),
    [anon_sym_STAR] = ACTIONS(3963),
    [anon_sym_SLASH] = ACTIONS(3963),
    [anon_sym_x] = ACTIONS(3963),
    [anon_sym_EQ_TILDE] = ACTIONS(3961),
    [anon_sym_BANG_TILDE] = ACTIONS(3961),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_eq] = ACTIONS(3961),
    [anon_sym_ne] = ACTIONS(3961),
    [anon_sym_LT_EQ_GT] = ACTIONS(3961),
    [anon_sym_cmp] = ACTIONS(3961),
    [anon_sym_TILDE_TILDE] = ACTIONS(3961),
    [anon_sym_LT_EQ] = ACTIONS(3963),
    [anon_sym_GT_EQ] = ACTIONS(3961),
    [anon_sym_lt] = ACTIONS(3961),
    [anon_sym_le] = ACTIONS(3961),
    [anon_sym_ge] = ACTIONS(3961),
    [anon_sym_gt] = ACTIONS(3961),
    [anon_sym_isa] = ACTIONS(3961),
    [anon_sym_PLUS_PLUS] = ACTIONS(3961),
    [anon_sym_DASH_DASH] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_EQ_GT] = ACTIONS(3961),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1562] = {
    [sym_heredoc_content] = STATE(1562),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_SEMI] = ACTIONS(3973),
    [anon_sym_RPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3973),
    [anon_sym_and] = ACTIONS(3973),
    [anon_sym_or] = ACTIONS(3973),
    [anon_sym_RBRACK] = ACTIONS(3973),
    [anon_sym_DASH_GT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3973),
    [anon_sym_PLUS_EQ] = ACTIONS(3973),
    [anon_sym_DASH_EQ] = ACTIONS(3973),
    [anon_sym_DOT_EQ] = ACTIONS(3973),
    [anon_sym_STAR_EQ] = ACTIONS(3973),
    [anon_sym_SLASH_EQ] = ACTIONS(3973),
    [anon_sym_PERCENT_EQ] = ACTIONS(3973),
    [anon_sym_x_EQ] = ACTIONS(3973),
    [anon_sym_AMP_EQ] = ACTIONS(3973),
    [anon_sym_PIPE_EQ] = ACTIONS(3973),
    [anon_sym_CARET_EQ] = ACTIONS(3973),
    [anon_sym_LT_LT_EQ] = ACTIONS(3973),
    [anon_sym_GT_GT_EQ] = ACTIONS(3973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3973),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3973),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_STAR_STAR] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3975),
    [anon_sym_GT_GT2] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3975),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_x] = ACTIONS(3975),
    [anon_sym_EQ_TILDE] = ACTIONS(3973),
    [anon_sym_BANG_TILDE] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_eq] = ACTIONS(3973),
    [anon_sym_ne] = ACTIONS(3973),
    [anon_sym_LT_EQ_GT] = ACTIONS(3973),
    [anon_sym_cmp] = ACTIONS(3973),
    [anon_sym_TILDE_TILDE] = ACTIONS(3973),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_lt] = ACTIONS(3973),
    [anon_sym_le] = ACTIONS(3973),
    [anon_sym_ge] = ACTIONS(3973),
    [anon_sym_gt] = ACTIONS(3973),
    [anon_sym_isa] = ACTIONS(3973),
    [anon_sym_PLUS_PLUS] = ACTIONS(3973),
    [anon_sym_DASH_DASH] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_EQ_GT] = ACTIONS(3973),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1563] = {
    [sym_heredoc_content] = STATE(1563),
    [anon_sym_RBRACE] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4206),
    [anon_sym_SEMI] = ACTIONS(4206),
    [anon_sym_RPAREN] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4206),
    [anon_sym_and] = ACTIONS(4206),
    [anon_sym_or] = ACTIONS(4206),
    [anon_sym_RBRACK] = ACTIONS(4206),
    [anon_sym_DASH_GT] = ACTIONS(4206),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(4208),
    [anon_sym_GT] = ACTIONS(4208),
    [anon_sym_LT_LT] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4206),
    [anon_sym_PLUS_EQ] = ACTIONS(4206),
    [anon_sym_DASH_EQ] = ACTIONS(4206),
    [anon_sym_DOT_EQ] = ACTIONS(4206),
    [anon_sym_STAR_EQ] = ACTIONS(4206),
    [anon_sym_SLASH_EQ] = ACTIONS(4206),
    [anon_sym_PERCENT_EQ] = ACTIONS(4206),
    [anon_sym_x_EQ] = ACTIONS(4206),
    [anon_sym_AMP_EQ] = ACTIONS(4206),
    [anon_sym_PIPE_EQ] = ACTIONS(4206),
    [anon_sym_CARET_EQ] = ACTIONS(4206),
    [anon_sym_LT_LT_EQ] = ACTIONS(4206),
    [anon_sym_GT_GT_EQ] = ACTIONS(4206),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4206),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4206),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4206),
    [anon_sym_DOT_DOT] = ACTIONS(4208),
    [anon_sym_STAR_STAR] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_SLASH_SLASH] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_PIPE] = ACTIONS(4208),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_GT_GT2] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_STAR] = ACTIONS(4208),
    [anon_sym_SLASH] = ACTIONS(4208),
    [anon_sym_x] = ACTIONS(4208),
    [anon_sym_EQ_TILDE] = ACTIONS(4206),
    [anon_sym_BANG_TILDE] = ACTIONS(4206),
    [anon_sym_EQ_EQ] = ACTIONS(4206),
    [anon_sym_BANG_EQ] = ACTIONS(4206),
    [anon_sym_eq] = ACTIONS(4206),
    [anon_sym_ne] = ACTIONS(4206),
    [anon_sym_LT_EQ_GT] = ACTIONS(4206),
    [anon_sym_cmp] = ACTIONS(4206),
    [anon_sym_TILDE_TILDE] = ACTIONS(4206),
    [anon_sym_LT_EQ] = ACTIONS(4208),
    [anon_sym_GT_EQ] = ACTIONS(4206),
    [anon_sym_lt] = ACTIONS(4206),
    [anon_sym_le] = ACTIONS(4206),
    [anon_sym_ge] = ACTIONS(4206),
    [anon_sym_gt] = ACTIONS(4206),
    [anon_sym_isa] = ACTIONS(4206),
    [anon_sym_PLUS_PLUS] = ACTIONS(4206),
    [anon_sym_DASH_DASH] = ACTIONS(4206),
    [anon_sym_QMARK] = ACTIONS(4206),
    [anon_sym_EQ_GT] = ACTIONS(4206),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1564] = {
    [sym_heredoc_content] = STATE(1564),
    [anon_sym_RBRACE] = ACTIONS(4182),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_SEMI] = ACTIONS(4182),
    [anon_sym_RPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4182),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_RBRACK] = ACTIONS(4182),
    [anon_sym_DASH_GT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_GT] = ACTIONS(4184),
    [anon_sym_LT_LT] = ACTIONS(4184),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_DOT_EQ] = ACTIONS(4182),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_x_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_DOT_DOT] = ACTIONS(4184),
    [anon_sym_STAR_STAR] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(4184),
    [anon_sym_SLASH_SLASH] = ACTIONS(4184),
    [anon_sym_AMP_AMP] = ACTIONS(4184),
    [anon_sym_PIPE] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_GT_GT2] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4184),
    [anon_sym_x] = ACTIONS(4184),
    [anon_sym_EQ_TILDE] = ACTIONS(4182),
    [anon_sym_BANG_TILDE] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_eq] = ACTIONS(4182),
    [anon_sym_ne] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4182),
    [anon_sym_cmp] = ACTIONS(4182),
    [anon_sym_TILDE_TILDE] = ACTIONS(4182),
    [anon_sym_LT_EQ] = ACTIONS(4184),
    [anon_sym_GT_EQ] = ACTIONS(4182),
    [anon_sym_lt] = ACTIONS(4182),
    [anon_sym_le] = ACTIONS(4182),
    [anon_sym_ge] = ACTIONS(4182),
    [anon_sym_gt] = ACTIONS(4182),
    [anon_sym_isa] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_EQ_GT] = ACTIONS(4182),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1565] = {
    [sym_heredoc_content] = STATE(1565),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4054),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4054),
    [anon_sym_PLUS_EQ] = ACTIONS(4054),
    [anon_sym_DASH_EQ] = ACTIONS(4054),
    [anon_sym_DOT_EQ] = ACTIONS(4054),
    [anon_sym_STAR_EQ] = ACTIONS(4054),
    [anon_sym_SLASH_EQ] = ACTIONS(4054),
    [anon_sym_PERCENT_EQ] = ACTIONS(4054),
    [anon_sym_x_EQ] = ACTIONS(4054),
    [anon_sym_AMP_EQ] = ACTIONS(4054),
    [anon_sym_PIPE_EQ] = ACTIONS(4054),
    [anon_sym_CARET_EQ] = ACTIONS(4054),
    [anon_sym_LT_LT_EQ] = ACTIONS(4054),
    [anon_sym_GT_GT_EQ] = ACTIONS(4054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4054),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4056),
    [anon_sym_SLASH_SLASH] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_GT_GT2] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_x] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4054),
    [anon_sym_BANG_TILDE] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_eq] = ACTIONS(4054),
    [anon_sym_ne] = ACTIONS(4054),
    [anon_sym_LT_EQ_GT] = ACTIONS(4054),
    [anon_sym_cmp] = ACTIONS(4054),
    [anon_sym_TILDE_TILDE] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4056),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_lt] = ACTIONS(4054),
    [anon_sym_le] = ACTIONS(4054),
    [anon_sym_ge] = ACTIONS(4054),
    [anon_sym_gt] = ACTIONS(4054),
    [anon_sym_isa] = ACTIONS(4054),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_EQ_GT] = ACTIONS(4054),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1566] = {
    [sym_heredoc_content] = STATE(1566),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4210),
    [anon_sym_SEMI] = ACTIONS(4210),
    [anon_sym_RPAREN] = ACTIONS(4210),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4210),
    [anon_sym_and] = ACTIONS(4210),
    [anon_sym_or] = ACTIONS(4210),
    [anon_sym_RBRACK] = ACTIONS(4210),
    [anon_sym_DASH_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_LT] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(4212),
    [anon_sym_LT_LT] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4210),
    [anon_sym_PLUS_EQ] = ACTIONS(4210),
    [anon_sym_DASH_EQ] = ACTIONS(4210),
    [anon_sym_DOT_EQ] = ACTIONS(4210),
    [anon_sym_STAR_EQ] = ACTIONS(4210),
    [anon_sym_SLASH_EQ] = ACTIONS(4210),
    [anon_sym_PERCENT_EQ] = ACTIONS(4210),
    [anon_sym_x_EQ] = ACTIONS(4210),
    [anon_sym_AMP_EQ] = ACTIONS(4210),
    [anon_sym_PIPE_EQ] = ACTIONS(4210),
    [anon_sym_CARET_EQ] = ACTIONS(4210),
    [anon_sym_LT_LT_EQ] = ACTIONS(4210),
    [anon_sym_GT_GT_EQ] = ACTIONS(4210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4210),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4210),
    [anon_sym_DOT_DOT] = ACTIONS(4212),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_SLASH_SLASH] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4212),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_GT_GT2] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_STAR] = ACTIONS(4212),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_x] = ACTIONS(4212),
    [anon_sym_EQ_TILDE] = ACTIONS(4210),
    [anon_sym_BANG_TILDE] = ACTIONS(4210),
    [anon_sym_EQ_EQ] = ACTIONS(4210),
    [anon_sym_BANG_EQ] = ACTIONS(4210),
    [anon_sym_eq] = ACTIONS(4210),
    [anon_sym_ne] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4210),
    [anon_sym_cmp] = ACTIONS(4210),
    [anon_sym_TILDE_TILDE] = ACTIONS(4210),
    [anon_sym_LT_EQ] = ACTIONS(4212),
    [anon_sym_GT_EQ] = ACTIONS(4210),
    [anon_sym_lt] = ACTIONS(4210),
    [anon_sym_le] = ACTIONS(4210),
    [anon_sym_ge] = ACTIONS(4210),
    [anon_sym_gt] = ACTIONS(4210),
    [anon_sym_isa] = ACTIONS(4210),
    [anon_sym_PLUS_PLUS] = ACTIONS(4210),
    [anon_sym_DASH_DASH] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4210),
    [anon_sym_EQ_GT] = ACTIONS(4210),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1567] = {
    [sym_heredoc_content] = STATE(1567),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_RPAREN] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4020),
    [anon_sym_and] = ACTIONS(4020),
    [anon_sym_or] = ACTIONS(4020),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_DASH_GT] = ACTIONS(4020),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4022),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4020),
    [anon_sym_PLUS_EQ] = ACTIONS(4020),
    [anon_sym_DASH_EQ] = ACTIONS(4020),
    [anon_sym_DOT_EQ] = ACTIONS(4020),
    [anon_sym_STAR_EQ] = ACTIONS(4020),
    [anon_sym_SLASH_EQ] = ACTIONS(4020),
    [anon_sym_PERCENT_EQ] = ACTIONS(4020),
    [anon_sym_x_EQ] = ACTIONS(4020),
    [anon_sym_AMP_EQ] = ACTIONS(4020),
    [anon_sym_PIPE_EQ] = ACTIONS(4020),
    [anon_sym_CARET_EQ] = ACTIONS(4020),
    [anon_sym_LT_LT_EQ] = ACTIONS(4020),
    [anon_sym_GT_GT_EQ] = ACTIONS(4020),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4020),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4022),
    [anon_sym_STAR_STAR] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_SLASH_SLASH] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_GT_GT2] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4022),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_x] = ACTIONS(4022),
    [anon_sym_EQ_TILDE] = ACTIONS(4020),
    [anon_sym_BANG_TILDE] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4020),
    [anon_sym_eq] = ACTIONS(4020),
    [anon_sym_ne] = ACTIONS(4020),
    [anon_sym_LT_EQ_GT] = ACTIONS(4020),
    [anon_sym_cmp] = ACTIONS(4020),
    [anon_sym_TILDE_TILDE] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4022),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_lt] = ACTIONS(4020),
    [anon_sym_le] = ACTIONS(4020),
    [anon_sym_ge] = ACTIONS(4020),
    [anon_sym_gt] = ACTIONS(4020),
    [anon_sym_isa] = ACTIONS(4020),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_EQ_GT] = ACTIONS(4020),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1568] = {
    [sym_heredoc_content] = STATE(1568),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4016),
    [anon_sym_SEMI] = ACTIONS(4016),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4016),
    [anon_sym_and] = ACTIONS(4016),
    [anon_sym_or] = ACTIONS(4016),
    [anon_sym_RBRACK] = ACTIONS(4016),
    [anon_sym_DASH_GT] = ACTIONS(4016),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4018),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4016),
    [anon_sym_PLUS_EQ] = ACTIONS(4016),
    [anon_sym_DASH_EQ] = ACTIONS(4016),
    [anon_sym_DOT_EQ] = ACTIONS(4016),
    [anon_sym_STAR_EQ] = ACTIONS(4016),
    [anon_sym_SLASH_EQ] = ACTIONS(4016),
    [anon_sym_PERCENT_EQ] = ACTIONS(4016),
    [anon_sym_x_EQ] = ACTIONS(4016),
    [anon_sym_AMP_EQ] = ACTIONS(4016),
    [anon_sym_PIPE_EQ] = ACTIONS(4016),
    [anon_sym_CARET_EQ] = ACTIONS(4016),
    [anon_sym_LT_LT_EQ] = ACTIONS(4016),
    [anon_sym_GT_GT_EQ] = ACTIONS(4016),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4016),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4016),
    [anon_sym_DOT_DOT] = ACTIONS(4018),
    [anon_sym_STAR_STAR] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_SLASH_SLASH] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_GT_GT2] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4018),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_x] = ACTIONS(4018),
    [anon_sym_EQ_TILDE] = ACTIONS(4016),
    [anon_sym_BANG_TILDE] = ACTIONS(4016),
    [anon_sym_EQ_EQ] = ACTIONS(4016),
    [anon_sym_BANG_EQ] = ACTIONS(4016),
    [anon_sym_eq] = ACTIONS(4016),
    [anon_sym_ne] = ACTIONS(4016),
    [anon_sym_LT_EQ_GT] = ACTIONS(4016),
    [anon_sym_cmp] = ACTIONS(4016),
    [anon_sym_TILDE_TILDE] = ACTIONS(4016),
    [anon_sym_LT_EQ] = ACTIONS(4018),
    [anon_sym_GT_EQ] = ACTIONS(4016),
    [anon_sym_lt] = ACTIONS(4016),
    [anon_sym_le] = ACTIONS(4016),
    [anon_sym_ge] = ACTIONS(4016),
    [anon_sym_gt] = ACTIONS(4016),
    [anon_sym_isa] = ACTIONS(4016),
    [anon_sym_PLUS_PLUS] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4016),
    [anon_sym_QMARK] = ACTIONS(4016),
    [anon_sym_EQ_GT] = ACTIONS(4016),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1569] = {
    [sym_heredoc_content] = STATE(1569),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_SEMI] = ACTIONS(3981),
    [anon_sym_RPAREN] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3981),
    [anon_sym_or] = ACTIONS(3981),
    [anon_sym_RBRACK] = ACTIONS(3981),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3983),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3983),
    [anon_sym_EQ] = ACTIONS(3983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3981),
    [anon_sym_PLUS_EQ] = ACTIONS(3981),
    [anon_sym_DASH_EQ] = ACTIONS(3981),
    [anon_sym_DOT_EQ] = ACTIONS(3981),
    [anon_sym_STAR_EQ] = ACTIONS(3981),
    [anon_sym_SLASH_EQ] = ACTIONS(3981),
    [anon_sym_PERCENT_EQ] = ACTIONS(3981),
    [anon_sym_x_EQ] = ACTIONS(3981),
    [anon_sym_AMP_EQ] = ACTIONS(3981),
    [anon_sym_PIPE_EQ] = ACTIONS(3981),
    [anon_sym_CARET_EQ] = ACTIONS(3981),
    [anon_sym_LT_LT_EQ] = ACTIONS(3981),
    [anon_sym_GT_GT_EQ] = ACTIONS(3981),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3981),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3981),
    [anon_sym_DOT_DOT] = ACTIONS(3983),
    [anon_sym_STAR_STAR] = ACTIONS(3983),
    [anon_sym_PIPE_PIPE] = ACTIONS(3983),
    [anon_sym_SLASH_SLASH] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_GT_GT2] = ACTIONS(3983),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3983),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_x] = ACTIONS(3983),
    [anon_sym_EQ_TILDE] = ACTIONS(3981),
    [anon_sym_BANG_TILDE] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_eq] = ACTIONS(3981),
    [anon_sym_ne] = ACTIONS(3981),
    [anon_sym_LT_EQ_GT] = ACTIONS(3981),
    [anon_sym_cmp] = ACTIONS(3981),
    [anon_sym_TILDE_TILDE] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3983),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_lt] = ACTIONS(3981),
    [anon_sym_le] = ACTIONS(3981),
    [anon_sym_ge] = ACTIONS(3981),
    [anon_sym_gt] = ACTIONS(3981),
    [anon_sym_isa] = ACTIONS(3981),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_EQ_GT] = ACTIONS(3981),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1570] = {
    [sym_heredoc_content] = STATE(1570),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_RPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3969),
    [anon_sym_and] = ACTIONS(3969),
    [anon_sym_or] = ACTIONS(3969),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [anon_sym_DASH_GT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_LT_LT] = ACTIONS(3971),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3969),
    [anon_sym_PLUS_EQ] = ACTIONS(3969),
    [anon_sym_DASH_EQ] = ACTIONS(3969),
    [anon_sym_DOT_EQ] = ACTIONS(3969),
    [anon_sym_STAR_EQ] = ACTIONS(3969),
    [anon_sym_SLASH_EQ] = ACTIONS(3969),
    [anon_sym_PERCENT_EQ] = ACTIONS(3969),
    [anon_sym_x_EQ] = ACTIONS(3969),
    [anon_sym_AMP_EQ] = ACTIONS(3969),
    [anon_sym_PIPE_EQ] = ACTIONS(3969),
    [anon_sym_CARET_EQ] = ACTIONS(3969),
    [anon_sym_LT_LT_EQ] = ACTIONS(3969),
    [anon_sym_GT_GT_EQ] = ACTIONS(3969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3969),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3969),
    [anon_sym_DOT_DOT] = ACTIONS(3971),
    [anon_sym_STAR_STAR] = ACTIONS(3971),
    [anon_sym_PIPE_PIPE] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH] = ACTIONS(3971),
    [anon_sym_AMP_AMP] = ACTIONS(3971),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_GT_GT2] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_x] = ACTIONS(3971),
    [anon_sym_EQ_TILDE] = ACTIONS(3969),
    [anon_sym_BANG_TILDE] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_eq] = ACTIONS(3969),
    [anon_sym_ne] = ACTIONS(3969),
    [anon_sym_LT_EQ_GT] = ACTIONS(3969),
    [anon_sym_cmp] = ACTIONS(3969),
    [anon_sym_TILDE_TILDE] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3971),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_lt] = ACTIONS(3969),
    [anon_sym_le] = ACTIONS(3969),
    [anon_sym_ge] = ACTIONS(3969),
    [anon_sym_gt] = ACTIONS(3969),
    [anon_sym_isa] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_EQ_GT] = ACTIONS(3969),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1571] = {
    [sym_heredoc_content] = STATE(1571),
    [anon_sym_RBRACE] = ACTIONS(3953),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym_RPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3953),
    [anon_sym_and] = ACTIONS(3953),
    [anon_sym_or] = ACTIONS(3953),
    [anon_sym_RBRACK] = ACTIONS(3953),
    [anon_sym_DASH_GT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_GT] = ACTIONS(3955),
    [anon_sym_LT_LT] = ACTIONS(3955),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3953),
    [anon_sym_PLUS_EQ] = ACTIONS(3953),
    [anon_sym_DASH_EQ] = ACTIONS(3953),
    [anon_sym_DOT_EQ] = ACTIONS(3953),
    [anon_sym_STAR_EQ] = ACTIONS(3953),
    [anon_sym_SLASH_EQ] = ACTIONS(3953),
    [anon_sym_PERCENT_EQ] = ACTIONS(3953),
    [anon_sym_x_EQ] = ACTIONS(3953),
    [anon_sym_AMP_EQ] = ACTIONS(3953),
    [anon_sym_PIPE_EQ] = ACTIONS(3953),
    [anon_sym_CARET_EQ] = ACTIONS(3953),
    [anon_sym_LT_LT_EQ] = ACTIONS(3953),
    [anon_sym_GT_GT_EQ] = ACTIONS(3953),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3953),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3953),
    [anon_sym_DOT_DOT] = ACTIONS(3955),
    [anon_sym_STAR_STAR] = ACTIONS(3955),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3955),
    [anon_sym_GT_GT2] = ACTIONS(3955),
    [anon_sym_PLUS] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3955),
    [anon_sym_DOT] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_SLASH] = ACTIONS(3955),
    [anon_sym_x] = ACTIONS(3955),
    [anon_sym_EQ_TILDE] = ACTIONS(3953),
    [anon_sym_BANG_TILDE] = ACTIONS(3953),
    [anon_sym_EQ_EQ] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_eq] = ACTIONS(3953),
    [anon_sym_ne] = ACTIONS(3953),
    [anon_sym_LT_EQ_GT] = ACTIONS(3953),
    [anon_sym_cmp] = ACTIONS(3953),
    [anon_sym_TILDE_TILDE] = ACTIONS(3953),
    [anon_sym_LT_EQ] = ACTIONS(3955),
    [anon_sym_GT_EQ] = ACTIONS(3953),
    [anon_sym_lt] = ACTIONS(3953),
    [anon_sym_le] = ACTIONS(3953),
    [anon_sym_ge] = ACTIONS(3953),
    [anon_sym_gt] = ACTIONS(3953),
    [anon_sym_isa] = ACTIONS(3953),
    [anon_sym_PLUS_PLUS] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_EQ_GT] = ACTIONS(3953),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1572] = {
    [sym_heredoc_content] = STATE(1572),
    [anon_sym_RBRACE] = ACTIONS(3937),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym_RPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3937),
    [anon_sym_and] = ACTIONS(3937),
    [anon_sym_or] = ACTIONS(3937),
    [anon_sym_RBRACK] = ACTIONS(3937),
    [anon_sym_DASH_GT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3939),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3937),
    [anon_sym_PLUS_EQ] = ACTIONS(3937),
    [anon_sym_DASH_EQ] = ACTIONS(3937),
    [anon_sym_DOT_EQ] = ACTIONS(3937),
    [anon_sym_STAR_EQ] = ACTIONS(3937),
    [anon_sym_SLASH_EQ] = ACTIONS(3937),
    [anon_sym_PERCENT_EQ] = ACTIONS(3937),
    [anon_sym_x_EQ] = ACTIONS(3937),
    [anon_sym_AMP_EQ] = ACTIONS(3937),
    [anon_sym_PIPE_EQ] = ACTIONS(3937),
    [anon_sym_CARET_EQ] = ACTIONS(3937),
    [anon_sym_LT_LT_EQ] = ACTIONS(3937),
    [anon_sym_GT_GT_EQ] = ACTIONS(3937),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3937),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3937),
    [anon_sym_DOT_DOT] = ACTIONS(3939),
    [anon_sym_STAR_STAR] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3939),
    [anon_sym_GT_GT2] = ACTIONS(3939),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_DASH] = ACTIONS(3939),
    [anon_sym_DOT] = ACTIONS(3939),
    [anon_sym_STAR] = ACTIONS(3939),
    [anon_sym_SLASH] = ACTIONS(3939),
    [anon_sym_x] = ACTIONS(3939),
    [anon_sym_EQ_TILDE] = ACTIONS(3937),
    [anon_sym_BANG_TILDE] = ACTIONS(3937),
    [anon_sym_EQ_EQ] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_eq] = ACTIONS(3937),
    [anon_sym_ne] = ACTIONS(3937),
    [anon_sym_LT_EQ_GT] = ACTIONS(3937),
    [anon_sym_cmp] = ACTIONS(3937),
    [anon_sym_TILDE_TILDE] = ACTIONS(3937),
    [anon_sym_LT_EQ] = ACTIONS(3939),
    [anon_sym_GT_EQ] = ACTIONS(3937),
    [anon_sym_lt] = ACTIONS(3937),
    [anon_sym_le] = ACTIONS(3937),
    [anon_sym_ge] = ACTIONS(3937),
    [anon_sym_gt] = ACTIONS(3937),
    [anon_sym_isa] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3937),
    [anon_sym_DASH_DASH] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_EQ_GT] = ACTIONS(3937),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1573] = {
    [sym_heredoc_content] = STATE(1573),
    [anon_sym_RBRACE] = ACTIONS(3917),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3917),
    [anon_sym_and] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_RBRACK] = ACTIONS(3917),
    [anon_sym_DASH_GT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3917),
    [anon_sym_PLUS_EQ] = ACTIONS(3917),
    [anon_sym_DASH_EQ] = ACTIONS(3917),
    [anon_sym_DOT_EQ] = ACTIONS(3917),
    [anon_sym_STAR_EQ] = ACTIONS(3917),
    [anon_sym_SLASH_EQ] = ACTIONS(3917),
    [anon_sym_PERCENT_EQ] = ACTIONS(3917),
    [anon_sym_x_EQ] = ACTIONS(3917),
    [anon_sym_AMP_EQ] = ACTIONS(3917),
    [anon_sym_PIPE_EQ] = ACTIONS(3917),
    [anon_sym_CARET_EQ] = ACTIONS(3917),
    [anon_sym_LT_LT_EQ] = ACTIONS(3917),
    [anon_sym_GT_GT_EQ] = ACTIONS(3917),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3917),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3917),
    [anon_sym_DOT_DOT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [anon_sym_SLASH_SLASH] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_GT_GT2] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_DOT] = ACTIONS(3919),
    [anon_sym_STAR] = ACTIONS(3919),
    [anon_sym_SLASH] = ACTIONS(3919),
    [anon_sym_x] = ACTIONS(3919),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_BANG_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_eq] = ACTIONS(3917),
    [anon_sym_ne] = ACTIONS(3917),
    [anon_sym_LT_EQ_GT] = ACTIONS(3917),
    [anon_sym_cmp] = ACTIONS(3917),
    [anon_sym_TILDE_TILDE] = ACTIONS(3917),
    [anon_sym_LT_EQ] = ACTIONS(3919),
    [anon_sym_GT_EQ] = ACTIONS(3917),
    [anon_sym_lt] = ACTIONS(3917),
    [anon_sym_le] = ACTIONS(3917),
    [anon_sym_ge] = ACTIONS(3917),
    [anon_sym_gt] = ACTIONS(3917),
    [anon_sym_isa] = ACTIONS(3917),
    [anon_sym_PLUS_PLUS] = ACTIONS(3917),
    [anon_sym_DASH_DASH] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_EQ_GT] = ACTIONS(3917),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1574] = {
    [sym_heredoc_content] = STATE(1574),
    [anon_sym_RBRACE] = ACTIONS(3851),
    [anon_sym_COLON] = ACTIONS(3851),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym_RPAREN] = ACTIONS(3851),
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3851),
    [anon_sym_and] = ACTIONS(3851),
    [anon_sym_or] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3851),
    [anon_sym_DASH_GT] = ACTIONS(3851),
    [anon_sym_PERCENT] = ACTIONS(3853),
    [anon_sym_LT] = ACTIONS(3853),
    [anon_sym_GT] = ACTIONS(3853),
    [anon_sym_LT_LT] = ACTIONS(3853),
    [anon_sym_EQ] = ACTIONS(3853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3851),
    [anon_sym_PLUS_EQ] = ACTIONS(3851),
    [anon_sym_DASH_EQ] = ACTIONS(3851),
    [anon_sym_DOT_EQ] = ACTIONS(3851),
    [anon_sym_STAR_EQ] = ACTIONS(3851),
    [anon_sym_SLASH_EQ] = ACTIONS(3851),
    [anon_sym_PERCENT_EQ] = ACTIONS(3851),
    [anon_sym_x_EQ] = ACTIONS(3851),
    [anon_sym_AMP_EQ] = ACTIONS(3851),
    [anon_sym_PIPE_EQ] = ACTIONS(3851),
    [anon_sym_CARET_EQ] = ACTIONS(3851),
    [anon_sym_LT_LT_EQ] = ACTIONS(3851),
    [anon_sym_GT_GT_EQ] = ACTIONS(3851),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3851),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3851),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3851),
    [anon_sym_DOT_DOT] = ACTIONS(3853),
    [anon_sym_STAR_STAR] = ACTIONS(3853),
    [anon_sym_PIPE_PIPE] = ACTIONS(3853),
    [anon_sym_SLASH_SLASH] = ACTIONS(3853),
    [anon_sym_AMP_AMP] = ACTIONS(3853),
    [anon_sym_PIPE] = ACTIONS(3853),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_GT_GT2] = ACTIONS(3853),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_DOT] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3853),
    [anon_sym_SLASH] = ACTIONS(3853),
    [anon_sym_x] = ACTIONS(3853),
    [anon_sym_EQ_TILDE] = ACTIONS(3851),
    [anon_sym_BANG_TILDE] = ACTIONS(3851),
    [anon_sym_EQ_EQ] = ACTIONS(3851),
    [anon_sym_BANG_EQ] = ACTIONS(3851),
    [anon_sym_eq] = ACTIONS(3851),
    [anon_sym_ne] = ACTIONS(3851),
    [anon_sym_LT_EQ_GT] = ACTIONS(3851),
    [anon_sym_cmp] = ACTIONS(3851),
    [anon_sym_TILDE_TILDE] = ACTIONS(3851),
    [anon_sym_LT_EQ] = ACTIONS(3853),
    [anon_sym_GT_EQ] = ACTIONS(3851),
    [anon_sym_lt] = ACTIONS(3851),
    [anon_sym_le] = ACTIONS(3851),
    [anon_sym_ge] = ACTIONS(3851),
    [anon_sym_gt] = ACTIONS(3851),
    [anon_sym_isa] = ACTIONS(3851),
    [anon_sym_PLUS_PLUS] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3851),
    [anon_sym_QMARK] = ACTIONS(3851),
    [anon_sym_EQ_GT] = ACTIONS(3851),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1575] = {
    [sym_heredoc_content] = STATE(1575),
    [anon_sym_RBRACE] = ACTIONS(3859),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym_RPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3859),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3859),
    [anon_sym_and] = ACTIONS(3859),
    [anon_sym_or] = ACTIONS(3859),
    [anon_sym_RBRACK] = ACTIONS(3859),
    [anon_sym_DASH_GT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_GT] = ACTIONS(3861),
    [anon_sym_LT_LT] = ACTIONS(3861),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3859),
    [anon_sym_PLUS_EQ] = ACTIONS(3859),
    [anon_sym_DASH_EQ] = ACTIONS(3859),
    [anon_sym_DOT_EQ] = ACTIONS(3859),
    [anon_sym_STAR_EQ] = ACTIONS(3859),
    [anon_sym_SLASH_EQ] = ACTIONS(3859),
    [anon_sym_PERCENT_EQ] = ACTIONS(3859),
    [anon_sym_x_EQ] = ACTIONS(3859),
    [anon_sym_AMP_EQ] = ACTIONS(3859),
    [anon_sym_PIPE_EQ] = ACTIONS(3859),
    [anon_sym_CARET_EQ] = ACTIONS(3859),
    [anon_sym_LT_LT_EQ] = ACTIONS(3859),
    [anon_sym_GT_GT_EQ] = ACTIONS(3859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3859),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3859),
    [anon_sym_DOT_DOT] = ACTIONS(3861),
    [anon_sym_STAR_STAR] = ACTIONS(3861),
    [anon_sym_PIPE_PIPE] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH] = ACTIONS(3861),
    [anon_sym_AMP_AMP] = ACTIONS(3861),
    [anon_sym_PIPE] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_GT_GT2] = ACTIONS(3861),
    [anon_sym_PLUS] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3861),
    [anon_sym_DOT] = ACTIONS(3861),
    [anon_sym_STAR] = ACTIONS(3861),
    [anon_sym_SLASH] = ACTIONS(3861),
    [anon_sym_x] = ACTIONS(3861),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_EQ_EQ] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_eq] = ACTIONS(3859),
    [anon_sym_ne] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_cmp] = ACTIONS(3859),
    [anon_sym_TILDE_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3859),
    [anon_sym_lt] = ACTIONS(3859),
    [anon_sym_le] = ACTIONS(3859),
    [anon_sym_ge] = ACTIONS(3859),
    [anon_sym_gt] = ACTIONS(3859),
    [anon_sym_isa] = ACTIONS(3859),
    [anon_sym_PLUS_PLUS] = ACTIONS(3859),
    [anon_sym_DASH_DASH] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_EQ_GT] = ACTIONS(3859),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1576] = {
    [sym_heredoc_content] = STATE(1576),
    [anon_sym_RBRACE] = ACTIONS(3869),
    [anon_sym_COLON] = ACTIONS(3869),
    [anon_sym_SEMI] = ACTIONS(3869),
    [anon_sym_RPAREN] = ACTIONS(3869),
    [anon_sym_COMMA] = ACTIONS(3869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3869),
    [anon_sym_and] = ACTIONS(3869),
    [anon_sym_or] = ACTIONS(3869),
    [anon_sym_RBRACK] = ACTIONS(3869),
    [anon_sym_DASH_GT] = ACTIONS(3869),
    [anon_sym_PERCENT] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3871),
    [anon_sym_GT] = ACTIONS(3871),
    [anon_sym_LT_LT] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(3871),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3869),
    [anon_sym_PLUS_EQ] = ACTIONS(3869),
    [anon_sym_DASH_EQ] = ACTIONS(3869),
    [anon_sym_DOT_EQ] = ACTIONS(3869),
    [anon_sym_STAR_EQ] = ACTIONS(3869),
    [anon_sym_SLASH_EQ] = ACTIONS(3869),
    [anon_sym_PERCENT_EQ] = ACTIONS(3869),
    [anon_sym_x_EQ] = ACTIONS(3869),
    [anon_sym_AMP_EQ] = ACTIONS(3869),
    [anon_sym_PIPE_EQ] = ACTIONS(3869),
    [anon_sym_CARET_EQ] = ACTIONS(3869),
    [anon_sym_LT_LT_EQ] = ACTIONS(3869),
    [anon_sym_GT_GT_EQ] = ACTIONS(3869),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3869),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3869),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3869),
    [anon_sym_DOT_DOT] = ACTIONS(3871),
    [anon_sym_STAR_STAR] = ACTIONS(3871),
    [anon_sym_PIPE_PIPE] = ACTIONS(3871),
    [anon_sym_SLASH_SLASH] = ACTIONS(3871),
    [anon_sym_AMP_AMP] = ACTIONS(3871),
    [anon_sym_PIPE] = ACTIONS(3871),
    [anon_sym_AMP] = ACTIONS(3871),
    [anon_sym_GT_GT2] = ACTIONS(3871),
    [anon_sym_PLUS] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3871),
    [anon_sym_DOT] = ACTIONS(3871),
    [anon_sym_STAR] = ACTIONS(3871),
    [anon_sym_SLASH] = ACTIONS(3871),
    [anon_sym_x] = ACTIONS(3871),
    [anon_sym_EQ_TILDE] = ACTIONS(3869),
    [anon_sym_BANG_TILDE] = ACTIONS(3869),
    [anon_sym_EQ_EQ] = ACTIONS(3869),
    [anon_sym_BANG_EQ] = ACTIONS(3869),
    [anon_sym_eq] = ACTIONS(3869),
    [anon_sym_ne] = ACTIONS(3869),
    [anon_sym_LT_EQ_GT] = ACTIONS(3869),
    [anon_sym_cmp] = ACTIONS(3869),
    [anon_sym_TILDE_TILDE] = ACTIONS(3869),
    [anon_sym_LT_EQ] = ACTIONS(3871),
    [anon_sym_GT_EQ] = ACTIONS(3869),
    [anon_sym_lt] = ACTIONS(3869),
    [anon_sym_le] = ACTIONS(3869),
    [anon_sym_ge] = ACTIONS(3869),
    [anon_sym_gt] = ACTIONS(3869),
    [anon_sym_isa] = ACTIONS(3869),
    [anon_sym_PLUS_PLUS] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(3869),
    [anon_sym_QMARK] = ACTIONS(3869),
    [anon_sym_EQ_GT] = ACTIONS(3869),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1577] = {
    [sym_heredoc_content] = STATE(1577),
    [anon_sym_RBRACE] = ACTIONS(4070),
    [anon_sym_COLON] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_RPAREN] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4070),
    [anon_sym_and] = ACTIONS(4070),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_RBRACK] = ACTIONS(4070),
    [anon_sym_DASH_GT] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4070),
    [anon_sym_PLUS_EQ] = ACTIONS(4070),
    [anon_sym_DASH_EQ] = ACTIONS(4070),
    [anon_sym_DOT_EQ] = ACTIONS(4070),
    [anon_sym_STAR_EQ] = ACTIONS(4070),
    [anon_sym_SLASH_EQ] = ACTIONS(4070),
    [anon_sym_PERCENT_EQ] = ACTIONS(4070),
    [anon_sym_x_EQ] = ACTIONS(4070),
    [anon_sym_AMP_EQ] = ACTIONS(4070),
    [anon_sym_PIPE_EQ] = ACTIONS(4070),
    [anon_sym_CARET_EQ] = ACTIONS(4070),
    [anon_sym_LT_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT_GT_EQ] = ACTIONS(4070),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4070),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_STAR_STAR] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_SLASH_SLASH] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4072),
    [anon_sym_GT_GT2] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4072),
    [anon_sym_DASH] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4072),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4072),
    [anon_sym_x] = ACTIONS(4072),
    [anon_sym_EQ_TILDE] = ACTIONS(4070),
    [anon_sym_BANG_TILDE] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4070),
    [anon_sym_eq] = ACTIONS(4070),
    [anon_sym_ne] = ACTIONS(4070),
    [anon_sym_LT_EQ_GT] = ACTIONS(4070),
    [anon_sym_cmp] = ACTIONS(4070),
    [anon_sym_TILDE_TILDE] = ACTIONS(4070),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4070),
    [anon_sym_lt] = ACTIONS(4070),
    [anon_sym_le] = ACTIONS(4070),
    [anon_sym_ge] = ACTIONS(4070),
    [anon_sym_gt] = ACTIONS(4070),
    [anon_sym_isa] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4070),
    [anon_sym_DASH_DASH] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4070),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1578] = {
    [sym_heredoc_content] = STATE(1578),
    [anon_sym_RBRACE] = ACTIONS(3863),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym_RPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3863),
    [anon_sym_and] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_RBRACK] = ACTIONS(3863),
    [anon_sym_DASH_GT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_LT_LT] = ACTIONS(3865),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3863),
    [anon_sym_PLUS_EQ] = ACTIONS(3863),
    [anon_sym_DASH_EQ] = ACTIONS(3863),
    [anon_sym_DOT_EQ] = ACTIONS(3863),
    [anon_sym_STAR_EQ] = ACTIONS(3863),
    [anon_sym_SLASH_EQ] = ACTIONS(3863),
    [anon_sym_PERCENT_EQ] = ACTIONS(3863),
    [anon_sym_x_EQ] = ACTIONS(3863),
    [anon_sym_AMP_EQ] = ACTIONS(3863),
    [anon_sym_PIPE_EQ] = ACTIONS(3863),
    [anon_sym_CARET_EQ] = ACTIONS(3863),
    [anon_sym_LT_LT_EQ] = ACTIONS(3863),
    [anon_sym_GT_GT_EQ] = ACTIONS(3863),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3863),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3863),
    [anon_sym_DOT_DOT] = ACTIONS(3865),
    [anon_sym_STAR_STAR] = ACTIONS(3865),
    [anon_sym_PIPE_PIPE] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH] = ACTIONS(3865),
    [anon_sym_AMP_AMP] = ACTIONS(3865),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_GT_GT2] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_DOT] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_SLASH] = ACTIONS(3865),
    [anon_sym_x] = ACTIONS(3865),
    [anon_sym_EQ_TILDE] = ACTIONS(3863),
    [anon_sym_BANG_TILDE] = ACTIONS(3863),
    [anon_sym_EQ_EQ] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_eq] = ACTIONS(3863),
    [anon_sym_ne] = ACTIONS(3863),
    [anon_sym_LT_EQ_GT] = ACTIONS(3863),
    [anon_sym_cmp] = ACTIONS(3863),
    [anon_sym_TILDE_TILDE] = ACTIONS(3863),
    [anon_sym_LT_EQ] = ACTIONS(3865),
    [anon_sym_GT_EQ] = ACTIONS(3863),
    [anon_sym_lt] = ACTIONS(3863),
    [anon_sym_le] = ACTIONS(3863),
    [anon_sym_ge] = ACTIONS(3863),
    [anon_sym_gt] = ACTIONS(3863),
    [anon_sym_isa] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3863),
    [anon_sym_DASH_DASH] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_EQ_GT] = ACTIONS(3863),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1579] = {
    [sym_heredoc_content] = STATE(1579),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_COLON] = ACTIONS(3855),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym_RPAREN] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3855),
    [anon_sym_and] = ACTIONS(3855),
    [anon_sym_or] = ACTIONS(3855),
    [anon_sym_RBRACK] = ACTIONS(3855),
    [anon_sym_DASH_GT] = ACTIONS(3855),
    [anon_sym_PERCENT] = ACTIONS(3857),
    [anon_sym_LT] = ACTIONS(3857),
    [anon_sym_GT] = ACTIONS(3857),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_EQ] = ACTIONS(3857),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3855),
    [anon_sym_PLUS_EQ] = ACTIONS(3855),
    [anon_sym_DASH_EQ] = ACTIONS(3855),
    [anon_sym_DOT_EQ] = ACTIONS(3855),
    [anon_sym_STAR_EQ] = ACTIONS(3855),
    [anon_sym_SLASH_EQ] = ACTIONS(3855),
    [anon_sym_PERCENT_EQ] = ACTIONS(3855),
    [anon_sym_x_EQ] = ACTIONS(3855),
    [anon_sym_AMP_EQ] = ACTIONS(3855),
    [anon_sym_PIPE_EQ] = ACTIONS(3855),
    [anon_sym_CARET_EQ] = ACTIONS(3855),
    [anon_sym_LT_LT_EQ] = ACTIONS(3855),
    [anon_sym_GT_GT_EQ] = ACTIONS(3855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3855),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3855),
    [anon_sym_DOT_DOT] = ACTIONS(3857),
    [anon_sym_STAR_STAR] = ACTIONS(3857),
    [anon_sym_PIPE_PIPE] = ACTIONS(3857),
    [anon_sym_SLASH_SLASH] = ACTIONS(3857),
    [anon_sym_AMP_AMP] = ACTIONS(3857),
    [anon_sym_PIPE] = ACTIONS(3857),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_GT_GT2] = ACTIONS(3857),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_DOT] = ACTIONS(3857),
    [anon_sym_STAR] = ACTIONS(3857),
    [anon_sym_SLASH] = ACTIONS(3857),
    [anon_sym_x] = ACTIONS(3857),
    [anon_sym_EQ_TILDE] = ACTIONS(3855),
    [anon_sym_BANG_TILDE] = ACTIONS(3855),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3855),
    [anon_sym_eq] = ACTIONS(3855),
    [anon_sym_ne] = ACTIONS(3855),
    [anon_sym_LT_EQ_GT] = ACTIONS(3855),
    [anon_sym_cmp] = ACTIONS(3855),
    [anon_sym_TILDE_TILDE] = ACTIONS(3855),
    [anon_sym_LT_EQ] = ACTIONS(3857),
    [anon_sym_GT_EQ] = ACTIONS(3855),
    [anon_sym_lt] = ACTIONS(3855),
    [anon_sym_le] = ACTIONS(3855),
    [anon_sym_ge] = ACTIONS(3855),
    [anon_sym_gt] = ACTIONS(3855),
    [anon_sym_isa] = ACTIONS(3855),
    [anon_sym_PLUS_PLUS] = ACTIONS(3855),
    [anon_sym_DASH_DASH] = ACTIONS(3855),
    [anon_sym_QMARK] = ACTIONS(3855),
    [anon_sym_EQ_GT] = ACTIONS(3855),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1580] = {
    [sym_heredoc_content] = STATE(1580),
    [anon_sym_RBRACE] = ACTIONS(4198),
    [anon_sym_COLON] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [anon_sym_COMMA] = ACTIONS(4198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4198),
    [anon_sym_and] = ACTIONS(4198),
    [anon_sym_or] = ACTIONS(4198),
    [anon_sym_RBRACK] = ACTIONS(4198),
    [anon_sym_DASH_GT] = ACTIONS(4198),
    [anon_sym_PERCENT] = ACTIONS(4200),
    [anon_sym_LT] = ACTIONS(4200),
    [anon_sym_GT] = ACTIONS(4200),
    [anon_sym_LT_LT] = ACTIONS(4200),
    [anon_sym_EQ] = ACTIONS(4200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4198),
    [anon_sym_PLUS_EQ] = ACTIONS(4198),
    [anon_sym_DASH_EQ] = ACTIONS(4198),
    [anon_sym_DOT_EQ] = ACTIONS(4198),
    [anon_sym_STAR_EQ] = ACTIONS(4198),
    [anon_sym_SLASH_EQ] = ACTIONS(4198),
    [anon_sym_PERCENT_EQ] = ACTIONS(4198),
    [anon_sym_x_EQ] = ACTIONS(4198),
    [anon_sym_AMP_EQ] = ACTIONS(4198),
    [anon_sym_PIPE_EQ] = ACTIONS(4198),
    [anon_sym_CARET_EQ] = ACTIONS(4198),
    [anon_sym_LT_LT_EQ] = ACTIONS(4198),
    [anon_sym_GT_GT_EQ] = ACTIONS(4198),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4198),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4198),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4198),
    [anon_sym_DOT_DOT] = ACTIONS(4200),
    [anon_sym_STAR_STAR] = ACTIONS(4200),
    [anon_sym_PIPE_PIPE] = ACTIONS(4200),
    [anon_sym_SLASH_SLASH] = ACTIONS(4200),
    [anon_sym_AMP_AMP] = ACTIONS(4200),
    [anon_sym_PIPE] = ACTIONS(4200),
    [anon_sym_AMP] = ACTIONS(4200),
    [anon_sym_GT_GT2] = ACTIONS(4200),
    [anon_sym_PLUS] = ACTIONS(4200),
    [anon_sym_DASH] = ACTIONS(4200),
    [anon_sym_DOT] = ACTIONS(4200),
    [anon_sym_STAR] = ACTIONS(4200),
    [anon_sym_SLASH] = ACTIONS(4200),
    [anon_sym_x] = ACTIONS(4200),
    [anon_sym_EQ_TILDE] = ACTIONS(4198),
    [anon_sym_BANG_TILDE] = ACTIONS(4198),
    [anon_sym_EQ_EQ] = ACTIONS(4198),
    [anon_sym_BANG_EQ] = ACTIONS(4198),
    [anon_sym_eq] = ACTIONS(4198),
    [anon_sym_ne] = ACTIONS(4198),
    [anon_sym_LT_EQ_GT] = ACTIONS(4198),
    [anon_sym_cmp] = ACTIONS(4198),
    [anon_sym_TILDE_TILDE] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(4200),
    [anon_sym_GT_EQ] = ACTIONS(4198),
    [anon_sym_lt] = ACTIONS(4198),
    [anon_sym_le] = ACTIONS(4198),
    [anon_sym_ge] = ACTIONS(4198),
    [anon_sym_gt] = ACTIONS(4198),
    [anon_sym_isa] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_QMARK] = ACTIONS(4198),
    [anon_sym_EQ_GT] = ACTIONS(4198),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1581] = {
    [sym_heredoc_content] = STATE(1581),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_SEMI] = ACTIONS(4190),
    [anon_sym_RPAREN] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(4190),
    [anon_sym_or] = ACTIONS(4190),
    [anon_sym_RBRACK] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_EQ] = ACTIONS(4192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4190),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_DOT_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_x_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_DOT_DOT] = ACTIONS(4192),
    [anon_sym_STAR_STAR] = ACTIONS(4192),
    [anon_sym_PIPE_PIPE] = ACTIONS(4192),
    [anon_sym_SLASH_SLASH] = ACTIONS(4192),
    [anon_sym_AMP_AMP] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_GT_GT2] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_x] = ACTIONS(4192),
    [anon_sym_EQ_TILDE] = ACTIONS(4190),
    [anon_sym_BANG_TILDE] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4190),
    [anon_sym_eq] = ACTIONS(4190),
    [anon_sym_ne] = ACTIONS(4190),
    [anon_sym_LT_EQ_GT] = ACTIONS(4190),
    [anon_sym_cmp] = ACTIONS(4190),
    [anon_sym_TILDE_TILDE] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4192),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_lt] = ACTIONS(4190),
    [anon_sym_le] = ACTIONS(4190),
    [anon_sym_ge] = ACTIONS(4190),
    [anon_sym_gt] = ACTIONS(4190),
    [anon_sym_isa] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_EQ_GT] = ACTIONS(4190),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1582] = {
    [sym_heredoc_content] = STATE(1582),
    [anon_sym_RBRACE] = ACTIONS(4162),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_SEMI] = ACTIONS(4162),
    [anon_sym_RPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4162),
    [anon_sym_and] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_RBRACK] = ACTIONS(4162),
    [anon_sym_DASH_GT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4164),
    [anon_sym_GT] = ACTIONS(4164),
    [anon_sym_LT_LT] = ACTIONS(4164),
    [anon_sym_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4162),
    [anon_sym_PLUS_EQ] = ACTIONS(4162),
    [anon_sym_DASH_EQ] = ACTIONS(4162),
    [anon_sym_DOT_EQ] = ACTIONS(4162),
    [anon_sym_STAR_EQ] = ACTIONS(4162),
    [anon_sym_SLASH_EQ] = ACTIONS(4162),
    [anon_sym_PERCENT_EQ] = ACTIONS(4162),
    [anon_sym_x_EQ] = ACTIONS(4162),
    [anon_sym_AMP_EQ] = ACTIONS(4162),
    [anon_sym_PIPE_EQ] = ACTIONS(4162),
    [anon_sym_CARET_EQ] = ACTIONS(4162),
    [anon_sym_LT_LT_EQ] = ACTIONS(4162),
    [anon_sym_GT_GT_EQ] = ACTIONS(4162),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4162),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4162),
    [anon_sym_DOT_DOT] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4164),
    [anon_sym_SLASH_SLASH] = ACTIONS(4164),
    [anon_sym_AMP_AMP] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_GT_GT2] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_x] = ACTIONS(4164),
    [anon_sym_EQ_TILDE] = ACTIONS(4162),
    [anon_sym_BANG_TILDE] = ACTIONS(4162),
    [anon_sym_EQ_EQ] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_eq] = ACTIONS(4162),
    [anon_sym_ne] = ACTIONS(4162),
    [anon_sym_LT_EQ_GT] = ACTIONS(4162),
    [anon_sym_cmp] = ACTIONS(4162),
    [anon_sym_TILDE_TILDE] = ACTIONS(4162),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4162),
    [anon_sym_lt] = ACTIONS(4162),
    [anon_sym_le] = ACTIONS(4162),
    [anon_sym_ge] = ACTIONS(4162),
    [anon_sym_gt] = ACTIONS(4162),
    [anon_sym_isa] = ACTIONS(4162),
    [anon_sym_PLUS_PLUS] = ACTIONS(4162),
    [anon_sym_DASH_DASH] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_EQ_GT] = ACTIONS(4162),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1583] = {
    [sym_heredoc_content] = STATE(1583),
    [anon_sym_RBRACE] = ACTIONS(3819),
    [anon_sym_COLON] = ACTIONS(3819),
    [anon_sym_SEMI] = ACTIONS(3819),
    [anon_sym_RPAREN] = ACTIONS(3819),
    [anon_sym_COMMA] = ACTIONS(3819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3819),
    [anon_sym_and] = ACTIONS(3819),
    [anon_sym_or] = ACTIONS(3819),
    [anon_sym_RBRACK] = ACTIONS(3819),
    [anon_sym_DASH_GT] = ACTIONS(3819),
    [anon_sym_PERCENT] = ACTIONS(3821),
    [anon_sym_LT] = ACTIONS(3821),
    [anon_sym_GT] = ACTIONS(3821),
    [anon_sym_LT_LT] = ACTIONS(3821),
    [anon_sym_EQ] = ACTIONS(3821),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3819),
    [anon_sym_PLUS_EQ] = ACTIONS(3819),
    [anon_sym_DASH_EQ] = ACTIONS(3819),
    [anon_sym_DOT_EQ] = ACTIONS(3819),
    [anon_sym_STAR_EQ] = ACTIONS(3819),
    [anon_sym_SLASH_EQ] = ACTIONS(3819),
    [anon_sym_PERCENT_EQ] = ACTIONS(3819),
    [anon_sym_x_EQ] = ACTIONS(3819),
    [anon_sym_AMP_EQ] = ACTIONS(3819),
    [anon_sym_PIPE_EQ] = ACTIONS(3819),
    [anon_sym_CARET_EQ] = ACTIONS(3819),
    [anon_sym_LT_LT_EQ] = ACTIONS(3819),
    [anon_sym_GT_GT_EQ] = ACTIONS(3819),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3819),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3819),
    [anon_sym_DOT_DOT] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3821),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_SLASH_SLASH] = ACTIONS(3821),
    [anon_sym_AMP_AMP] = ACTIONS(3821),
    [anon_sym_PIPE] = ACTIONS(3821),
    [anon_sym_AMP] = ACTIONS(3821),
    [anon_sym_GT_GT2] = ACTIONS(3821),
    [anon_sym_PLUS] = ACTIONS(3821),
    [anon_sym_DASH] = ACTIONS(3821),
    [anon_sym_DOT] = ACTIONS(3821),
    [anon_sym_STAR] = ACTIONS(3821),
    [anon_sym_SLASH] = ACTIONS(3821),
    [anon_sym_x] = ACTIONS(3821),
    [anon_sym_EQ_TILDE] = ACTIONS(3819),
    [anon_sym_BANG_TILDE] = ACTIONS(3819),
    [anon_sym_EQ_EQ] = ACTIONS(3819),
    [anon_sym_BANG_EQ] = ACTIONS(3819),
    [anon_sym_eq] = ACTIONS(3819),
    [anon_sym_ne] = ACTIONS(3819),
    [anon_sym_LT_EQ_GT] = ACTIONS(3819),
    [anon_sym_cmp] = ACTIONS(3819),
    [anon_sym_TILDE_TILDE] = ACTIONS(3819),
    [anon_sym_LT_EQ] = ACTIONS(3821),
    [anon_sym_GT_EQ] = ACTIONS(3819),
    [anon_sym_lt] = ACTIONS(3819),
    [anon_sym_le] = ACTIONS(3819),
    [anon_sym_ge] = ACTIONS(3819),
    [anon_sym_gt] = ACTIONS(3819),
    [anon_sym_isa] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3819),
    [anon_sym_DASH_DASH] = ACTIONS(3819),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_EQ_GT] = ACTIONS(3819),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1584] = {
    [sym_heredoc_content] = STATE(1584),
    [anon_sym_RBRACE] = ACTIONS(4104),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_SEMI] = ACTIONS(4104),
    [anon_sym_RPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_RBRACK] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_LT_LT] = ACTIONS(4106),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4104),
    [anon_sym_DASH_EQ] = ACTIONS(4104),
    [anon_sym_DOT_EQ] = ACTIONS(4104),
    [anon_sym_STAR_EQ] = ACTIONS(4104),
    [anon_sym_SLASH_EQ] = ACTIONS(4104),
    [anon_sym_PERCENT_EQ] = ACTIONS(4104),
    [anon_sym_x_EQ] = ACTIONS(4104),
    [anon_sym_AMP_EQ] = ACTIONS(4104),
    [anon_sym_PIPE_EQ] = ACTIONS(4104),
    [anon_sym_CARET_EQ] = ACTIONS(4104),
    [anon_sym_LT_LT_EQ] = ACTIONS(4104),
    [anon_sym_GT_GT_EQ] = ACTIONS(4104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4104),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4104),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_STAR_STAR] = ACTIONS(4106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4106),
    [anon_sym_SLASH_SLASH] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4106),
    [anon_sym_GT_GT2] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_DOT] = ACTIONS(4106),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_SLASH] = ACTIONS(4106),
    [anon_sym_x] = ACTIONS(4106),
    [anon_sym_EQ_TILDE] = ACTIONS(4104),
    [anon_sym_BANG_TILDE] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_eq] = ACTIONS(4104),
    [anon_sym_ne] = ACTIONS(4104),
    [anon_sym_LT_EQ_GT] = ACTIONS(4104),
    [anon_sym_cmp] = ACTIONS(4104),
    [anon_sym_TILDE_TILDE] = ACTIONS(4104),
    [anon_sym_LT_EQ] = ACTIONS(4106),
    [anon_sym_GT_EQ] = ACTIONS(4104),
    [anon_sym_lt] = ACTIONS(4104),
    [anon_sym_le] = ACTIONS(4104),
    [anon_sym_ge] = ACTIONS(4104),
    [anon_sym_gt] = ACTIONS(4104),
    [anon_sym_isa] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4104),
    [anon_sym_DASH_DASH] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_EQ_GT] = ACTIONS(4104),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1585] = {
    [sym_heredoc_content] = STATE(1585),
    [anon_sym_RBRACE] = ACTIONS(4108),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_SEMI] = ACTIONS(4108),
    [anon_sym_RPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_RBRACK] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_GT] = ACTIONS(4110),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4108),
    [anon_sym_DASH_EQ] = ACTIONS(4108),
    [anon_sym_DOT_EQ] = ACTIONS(4108),
    [anon_sym_STAR_EQ] = ACTIONS(4108),
    [anon_sym_SLASH_EQ] = ACTIONS(4108),
    [anon_sym_PERCENT_EQ] = ACTIONS(4108),
    [anon_sym_x_EQ] = ACTIONS(4108),
    [anon_sym_AMP_EQ] = ACTIONS(4108),
    [anon_sym_PIPE_EQ] = ACTIONS(4108),
    [anon_sym_CARET_EQ] = ACTIONS(4108),
    [anon_sym_LT_LT_EQ] = ACTIONS(4108),
    [anon_sym_GT_GT_EQ] = ACTIONS(4108),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4108),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4108),
    [anon_sym_DOT_DOT] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4110),
    [anon_sym_SLASH_SLASH] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_GT_GT2] = ACTIONS(4110),
    [anon_sym_PLUS] = ACTIONS(4110),
    [anon_sym_DASH] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4110),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_x] = ACTIONS(4110),
    [anon_sym_EQ_TILDE] = ACTIONS(4108),
    [anon_sym_BANG_TILDE] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_eq] = ACTIONS(4108),
    [anon_sym_ne] = ACTIONS(4108),
    [anon_sym_LT_EQ_GT] = ACTIONS(4108),
    [anon_sym_cmp] = ACTIONS(4108),
    [anon_sym_TILDE_TILDE] = ACTIONS(4108),
    [anon_sym_LT_EQ] = ACTIONS(4110),
    [anon_sym_GT_EQ] = ACTIONS(4108),
    [anon_sym_lt] = ACTIONS(4108),
    [anon_sym_le] = ACTIONS(4108),
    [anon_sym_ge] = ACTIONS(4108),
    [anon_sym_gt] = ACTIONS(4108),
    [anon_sym_isa] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4108),
    [anon_sym_DASH_DASH] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_EQ_GT] = ACTIONS(4108),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1586] = {
    [sym_heredoc_content] = STATE(1586),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4036),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_RBRACK] = ACTIONS(4036),
    [anon_sym_DASH_GT] = ACTIONS(4036),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(4038),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4036),
    [anon_sym_PLUS_EQ] = ACTIONS(4036),
    [anon_sym_DASH_EQ] = ACTIONS(4036),
    [anon_sym_DOT_EQ] = ACTIONS(4036),
    [anon_sym_STAR_EQ] = ACTIONS(4036),
    [anon_sym_SLASH_EQ] = ACTIONS(4036),
    [anon_sym_PERCENT_EQ] = ACTIONS(4036),
    [anon_sym_x_EQ] = ACTIONS(4036),
    [anon_sym_AMP_EQ] = ACTIONS(4036),
    [anon_sym_PIPE_EQ] = ACTIONS(4036),
    [anon_sym_CARET_EQ] = ACTIONS(4036),
    [anon_sym_LT_LT_EQ] = ACTIONS(4036),
    [anon_sym_GT_GT_EQ] = ACTIONS(4036),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4036),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4036),
    [anon_sym_DOT_DOT] = ACTIONS(4038),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_SLASH_SLASH] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT2] = ACTIONS(4038),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4038),
    [anon_sym_SLASH] = ACTIONS(4038),
    [anon_sym_x] = ACTIONS(4038),
    [anon_sym_EQ_TILDE] = ACTIONS(4036),
    [anon_sym_BANG_TILDE] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_eq] = ACTIONS(4036),
    [anon_sym_ne] = ACTIONS(4036),
    [anon_sym_LT_EQ_GT] = ACTIONS(4036),
    [anon_sym_cmp] = ACTIONS(4036),
    [anon_sym_TILDE_TILDE] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [anon_sym_lt] = ACTIONS(4036),
    [anon_sym_le] = ACTIONS(4036),
    [anon_sym_ge] = ACTIONS(4036),
    [anon_sym_gt] = ACTIONS(4036),
    [anon_sym_isa] = ACTIONS(4036),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_QMARK] = ACTIONS(4036),
    [anon_sym_EQ_GT] = ACTIONS(4036),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1587] = {
    [sym_heredoc_content] = STATE(1587),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_x_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4064),
    [anon_sym_STAR_STAR] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_SLASH_SLASH] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_GT_GT2] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_SLASH] = ACTIONS(4064),
    [anon_sym_x] = ACTIONS(4064),
    [anon_sym_EQ_TILDE] = ACTIONS(4062),
    [anon_sym_BANG_TILDE] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_eq] = ACTIONS(4062),
    [anon_sym_ne] = ACTIONS(4062),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_cmp] = ACTIONS(4062),
    [anon_sym_TILDE_TILDE] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_lt] = ACTIONS(4062),
    [anon_sym_le] = ACTIONS(4062),
    [anon_sym_ge] = ACTIONS(4062),
    [anon_sym_gt] = ACTIONS(4062),
    [anon_sym_isa] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1588] = {
    [sym_heredoc_content] = STATE(1588),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [anon_sym_COLON] = ACTIONS(4134),
    [anon_sym_SEMI] = ACTIONS(4134),
    [anon_sym_RPAREN] = ACTIONS(4134),
    [anon_sym_COMMA] = ACTIONS(4134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4134),
    [anon_sym_and] = ACTIONS(4134),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_RBRACK] = ACTIONS(4134),
    [anon_sym_DASH_GT] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4136),
    [anon_sym_EQ] = ACTIONS(4136),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4134),
    [anon_sym_PLUS_EQ] = ACTIONS(4134),
    [anon_sym_DASH_EQ] = ACTIONS(4134),
    [anon_sym_DOT_EQ] = ACTIONS(4134),
    [anon_sym_STAR_EQ] = ACTIONS(4134),
    [anon_sym_SLASH_EQ] = ACTIONS(4134),
    [anon_sym_PERCENT_EQ] = ACTIONS(4134),
    [anon_sym_x_EQ] = ACTIONS(4134),
    [anon_sym_AMP_EQ] = ACTIONS(4134),
    [anon_sym_PIPE_EQ] = ACTIONS(4134),
    [anon_sym_CARET_EQ] = ACTIONS(4134),
    [anon_sym_LT_LT_EQ] = ACTIONS(4134),
    [anon_sym_GT_GT_EQ] = ACTIONS(4134),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4134),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4134),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4134),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_STAR_STAR] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_SLASH_SLASH] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4136),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT_GT2] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4136),
    [anon_sym_DASH] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_STAR] = ACTIONS(4136),
    [anon_sym_SLASH] = ACTIONS(4136),
    [anon_sym_x] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4134),
    [anon_sym_BANG_TILDE] = ACTIONS(4134),
    [anon_sym_EQ_EQ] = ACTIONS(4134),
    [anon_sym_BANG_EQ] = ACTIONS(4134),
    [anon_sym_eq] = ACTIONS(4134),
    [anon_sym_ne] = ACTIONS(4134),
    [anon_sym_LT_EQ_GT] = ACTIONS(4134),
    [anon_sym_cmp] = ACTIONS(4134),
    [anon_sym_TILDE_TILDE] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4134),
    [anon_sym_lt] = ACTIONS(4134),
    [anon_sym_le] = ACTIONS(4134),
    [anon_sym_ge] = ACTIONS(4134),
    [anon_sym_gt] = ACTIONS(4134),
    [anon_sym_isa] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4134),
    [anon_sym_DASH_DASH] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4134),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1589] = {
    [sym_heredoc_content] = STATE(1589),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_RBRACK] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(4188),
    [anon_sym_GT] = ACTIONS(4188),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4186),
    [anon_sym_PLUS_EQ] = ACTIONS(4186),
    [anon_sym_DASH_EQ] = ACTIONS(4186),
    [anon_sym_DOT_EQ] = ACTIONS(4186),
    [anon_sym_STAR_EQ] = ACTIONS(4186),
    [anon_sym_SLASH_EQ] = ACTIONS(4186),
    [anon_sym_PERCENT_EQ] = ACTIONS(4186),
    [anon_sym_x_EQ] = ACTIONS(4186),
    [anon_sym_AMP_EQ] = ACTIONS(4186),
    [anon_sym_PIPE_EQ] = ACTIONS(4186),
    [anon_sym_CARET_EQ] = ACTIONS(4186),
    [anon_sym_LT_LT_EQ] = ACTIONS(4186),
    [anon_sym_GT_GT_EQ] = ACTIONS(4186),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4186),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4188),
    [anon_sym_STAR_STAR] = ACTIONS(4188),
    [anon_sym_PIPE_PIPE] = ACTIONS(4188),
    [anon_sym_SLASH_SLASH] = ACTIONS(4188),
    [anon_sym_AMP_AMP] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(4188),
    [anon_sym_AMP] = ACTIONS(4188),
    [anon_sym_GT_GT2] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_DOT] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_SLASH] = ACTIONS(4188),
    [anon_sym_x] = ACTIONS(4188),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_eq] = ACTIONS(4186),
    [anon_sym_ne] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_cmp] = ACTIONS(4186),
    [anon_sym_TILDE_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4188),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_lt] = ACTIONS(4186),
    [anon_sym_le] = ACTIONS(4186),
    [anon_sym_ge] = ACTIONS(4186),
    [anon_sym_gt] = ACTIONS(4186),
    [anon_sym_isa] = ACTIONS(4186),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_EQ_GT] = ACTIONS(4186),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1590] = {
    [sym_heredoc_content] = STATE(1590),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(255),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1591] = {
    [sym_heredoc_content] = STATE(1591),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4222),
    [anon_sym_SEMI] = ACTIONS(4222),
    [anon_sym_RPAREN] = ACTIONS(4222),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_and] = ACTIONS(4222),
    [anon_sym_or] = ACTIONS(4222),
    [anon_sym_RBRACK] = ACTIONS(4222),
    [anon_sym_DASH_GT] = ACTIONS(4222),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_LT] = ACTIONS(4224),
    [anon_sym_GT] = ACTIONS(4224),
    [anon_sym_LT_LT] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4222),
    [anon_sym_PLUS_EQ] = ACTIONS(4222),
    [anon_sym_DASH_EQ] = ACTIONS(4222),
    [anon_sym_DOT_EQ] = ACTIONS(4222),
    [anon_sym_STAR_EQ] = ACTIONS(4222),
    [anon_sym_SLASH_EQ] = ACTIONS(4222),
    [anon_sym_PERCENT_EQ] = ACTIONS(4222),
    [anon_sym_x_EQ] = ACTIONS(4222),
    [anon_sym_AMP_EQ] = ACTIONS(4222),
    [anon_sym_PIPE_EQ] = ACTIONS(4222),
    [anon_sym_CARET_EQ] = ACTIONS(4222),
    [anon_sym_LT_LT_EQ] = ACTIONS(4222),
    [anon_sym_GT_GT_EQ] = ACTIONS(4222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4222),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4222),
    [anon_sym_DOT_DOT] = ACTIONS(4224),
    [anon_sym_STAR_STAR] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_SLASH_SLASH] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_PIPE] = ACTIONS(4224),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_GT_GT2] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_STAR] = ACTIONS(4224),
    [anon_sym_SLASH] = ACTIONS(4224),
    [anon_sym_x] = ACTIONS(4224),
    [anon_sym_EQ_TILDE] = ACTIONS(4222),
    [anon_sym_BANG_TILDE] = ACTIONS(4222),
    [anon_sym_EQ_EQ] = ACTIONS(4222),
    [anon_sym_BANG_EQ] = ACTIONS(4222),
    [anon_sym_eq] = ACTIONS(4222),
    [anon_sym_ne] = ACTIONS(4222),
    [anon_sym_LT_EQ_GT] = ACTIONS(4222),
    [anon_sym_cmp] = ACTIONS(4222),
    [anon_sym_TILDE_TILDE] = ACTIONS(4222),
    [anon_sym_LT_EQ] = ACTIONS(4224),
    [anon_sym_GT_EQ] = ACTIONS(4222),
    [anon_sym_lt] = ACTIONS(4222),
    [anon_sym_le] = ACTIONS(4222),
    [anon_sym_ge] = ACTIONS(4222),
    [anon_sym_gt] = ACTIONS(4222),
    [anon_sym_isa] = ACTIONS(4222),
    [anon_sym_PLUS_PLUS] = ACTIONS(4222),
    [anon_sym_DASH_DASH] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4222),
    [anon_sym_EQ_GT] = ACTIONS(4222),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1592] = {
    [sym_heredoc_content] = STATE(1592),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_or] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4178),
    [anon_sym_PLUS_EQ] = ACTIONS(4178),
    [anon_sym_DASH_EQ] = ACTIONS(4178),
    [anon_sym_DOT_EQ] = ACTIONS(4178),
    [anon_sym_STAR_EQ] = ACTIONS(4178),
    [anon_sym_SLASH_EQ] = ACTIONS(4178),
    [anon_sym_PERCENT_EQ] = ACTIONS(4178),
    [anon_sym_x_EQ] = ACTIONS(4178),
    [anon_sym_AMP_EQ] = ACTIONS(4178),
    [anon_sym_PIPE_EQ] = ACTIONS(4178),
    [anon_sym_CARET_EQ] = ACTIONS(4178),
    [anon_sym_LT_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT_GT_EQ] = ACTIONS(4178),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4178),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4178),
    [anon_sym_DOT_DOT] = ACTIONS(4180),
    [anon_sym_STAR_STAR] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_SLASH_SLASH] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_GT_GT2] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_x] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4178),
    [anon_sym_BANG_TILDE] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_eq] = ACTIONS(4178),
    [anon_sym_ne] = ACTIONS(4178),
    [anon_sym_LT_EQ_GT] = ACTIONS(4178),
    [anon_sym_cmp] = ACTIONS(4178),
    [anon_sym_TILDE_TILDE] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4180),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_lt] = ACTIONS(4178),
    [anon_sym_le] = ACTIONS(4178),
    [anon_sym_ge] = ACTIONS(4178),
    [anon_sym_gt] = ACTIONS(4178),
    [anon_sym_isa] = ACTIONS(4178),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4178),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1593] = {
    [sym_heredoc_content] = STATE(1593),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3839),
    [anon_sym_RPAREN] = ACTIONS(3839),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3839),
    [anon_sym_and] = ACTIONS(3839),
    [anon_sym_or] = ACTIONS(3839),
    [anon_sym_RBRACK] = ACTIONS(3839),
    [anon_sym_DASH_GT] = ACTIONS(3839),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3841),
    [anon_sym_GT] = ACTIONS(3841),
    [anon_sym_LT_LT] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3841),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3839),
    [anon_sym_PLUS_EQ] = ACTIONS(3839),
    [anon_sym_DASH_EQ] = ACTIONS(3839),
    [anon_sym_DOT_EQ] = ACTIONS(3839),
    [anon_sym_STAR_EQ] = ACTIONS(3839),
    [anon_sym_SLASH_EQ] = ACTIONS(3839),
    [anon_sym_PERCENT_EQ] = ACTIONS(3839),
    [anon_sym_x_EQ] = ACTIONS(3839),
    [anon_sym_AMP_EQ] = ACTIONS(3839),
    [anon_sym_PIPE_EQ] = ACTIONS(3839),
    [anon_sym_CARET_EQ] = ACTIONS(3839),
    [anon_sym_LT_LT_EQ] = ACTIONS(3839),
    [anon_sym_GT_GT_EQ] = ACTIONS(3839),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3839),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3839),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3839),
    [anon_sym_DOT_DOT] = ACTIONS(3841),
    [anon_sym_STAR_STAR] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_SLASH_SLASH] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_GT_GT2] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_STAR] = ACTIONS(3841),
    [anon_sym_SLASH] = ACTIONS(3841),
    [anon_sym_x] = ACTIONS(3841),
    [anon_sym_EQ_TILDE] = ACTIONS(3839),
    [anon_sym_BANG_TILDE] = ACTIONS(3839),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_eq] = ACTIONS(3839),
    [anon_sym_ne] = ACTIONS(3839),
    [anon_sym_LT_EQ_GT] = ACTIONS(3839),
    [anon_sym_cmp] = ACTIONS(3839),
    [anon_sym_TILDE_TILDE] = ACTIONS(3839),
    [anon_sym_LT_EQ] = ACTIONS(3841),
    [anon_sym_GT_EQ] = ACTIONS(3839),
    [anon_sym_lt] = ACTIONS(3839),
    [anon_sym_le] = ACTIONS(3839),
    [anon_sym_ge] = ACTIONS(3839),
    [anon_sym_gt] = ACTIONS(3839),
    [anon_sym_isa] = ACTIONS(3839),
    [anon_sym_PLUS_PLUS] = ACTIONS(3839),
    [anon_sym_DASH_DASH] = ACTIONS(3839),
    [anon_sym_QMARK] = ACTIONS(3839),
    [anon_sym_EQ_GT] = ACTIONS(3839),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1594] = {
    [sym_heredoc_content] = STATE(1594),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym_RPAREN] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3997),
    [anon_sym_or] = ACTIONS(3997),
    [anon_sym_RBRACK] = ACTIONS(3997),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(3999),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3999),
    [anon_sym_EQ] = ACTIONS(3999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3997),
    [anon_sym_PLUS_EQ] = ACTIONS(3997),
    [anon_sym_DASH_EQ] = ACTIONS(3997),
    [anon_sym_DOT_EQ] = ACTIONS(3997),
    [anon_sym_STAR_EQ] = ACTIONS(3997),
    [anon_sym_SLASH_EQ] = ACTIONS(3997),
    [anon_sym_PERCENT_EQ] = ACTIONS(3997),
    [anon_sym_x_EQ] = ACTIONS(3997),
    [anon_sym_AMP_EQ] = ACTIONS(3997),
    [anon_sym_PIPE_EQ] = ACTIONS(3997),
    [anon_sym_CARET_EQ] = ACTIONS(3997),
    [anon_sym_LT_LT_EQ] = ACTIONS(3997),
    [anon_sym_GT_GT_EQ] = ACTIONS(3997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3997),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3997),
    [anon_sym_DOT_DOT] = ACTIONS(3999),
    [anon_sym_STAR_STAR] = ACTIONS(3999),
    [anon_sym_PIPE_PIPE] = ACTIONS(3999),
    [anon_sym_SLASH_SLASH] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3999),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_GT_GT2] = ACTIONS(3999),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3999),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_x] = ACTIONS(3999),
    [anon_sym_EQ_TILDE] = ACTIONS(3997),
    [anon_sym_BANG_TILDE] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_eq] = ACTIONS(3997),
    [anon_sym_ne] = ACTIONS(3997),
    [anon_sym_LT_EQ_GT] = ACTIONS(3997),
    [anon_sym_cmp] = ACTIONS(3997),
    [anon_sym_TILDE_TILDE] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_lt] = ACTIONS(3997),
    [anon_sym_le] = ACTIONS(3997),
    [anon_sym_ge] = ACTIONS(3997),
    [anon_sym_gt] = ACTIONS(3997),
    [anon_sym_isa] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_QMARK] = ACTIONS(3997),
    [anon_sym_EQ_GT] = ACTIONS(3997),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1595] = {
    [sym_heredoc_content] = STATE(1595),
    [anon_sym_RBRACE] = ACTIONS(4096),
    [anon_sym_COLON] = ACTIONS(4096),
    [anon_sym_SEMI] = ACTIONS(4096),
    [anon_sym_RPAREN] = ACTIONS(4096),
    [anon_sym_COMMA] = ACTIONS(4096),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4096),
    [anon_sym_and] = ACTIONS(4096),
    [anon_sym_or] = ACTIONS(4096),
    [anon_sym_RBRACK] = ACTIONS(4096),
    [anon_sym_DASH_GT] = ACTIONS(4096),
    [anon_sym_PERCENT] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_GT] = ACTIONS(4098),
    [anon_sym_LT_LT] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4096),
    [anon_sym_PLUS_EQ] = ACTIONS(4096),
    [anon_sym_DASH_EQ] = ACTIONS(4096),
    [anon_sym_DOT_EQ] = ACTIONS(4096),
    [anon_sym_STAR_EQ] = ACTIONS(4096),
    [anon_sym_SLASH_EQ] = ACTIONS(4096),
    [anon_sym_PERCENT_EQ] = ACTIONS(4096),
    [anon_sym_x_EQ] = ACTIONS(4096),
    [anon_sym_AMP_EQ] = ACTIONS(4096),
    [anon_sym_PIPE_EQ] = ACTIONS(4096),
    [anon_sym_CARET_EQ] = ACTIONS(4096),
    [anon_sym_LT_LT_EQ] = ACTIONS(4096),
    [anon_sym_GT_GT_EQ] = ACTIONS(4096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4096),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4096),
    [anon_sym_DOT_DOT] = ACTIONS(4098),
    [anon_sym_STAR_STAR] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_SLASH_SLASH] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4098),
    [anon_sym_GT_GT2] = ACTIONS(4098),
    [anon_sym_PLUS] = ACTIONS(4098),
    [anon_sym_DASH] = ACTIONS(4098),
    [anon_sym_DOT] = ACTIONS(4098),
    [anon_sym_STAR] = ACTIONS(4098),
    [anon_sym_SLASH] = ACTIONS(4098),
    [anon_sym_x] = ACTIONS(4098),
    [anon_sym_EQ_TILDE] = ACTIONS(4096),
    [anon_sym_BANG_TILDE] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4096),
    [anon_sym_BANG_EQ] = ACTIONS(4096),
    [anon_sym_eq] = ACTIONS(4096),
    [anon_sym_ne] = ACTIONS(4096),
    [anon_sym_LT_EQ_GT] = ACTIONS(4096),
    [anon_sym_cmp] = ACTIONS(4096),
    [anon_sym_TILDE_TILDE] = ACTIONS(4096),
    [anon_sym_LT_EQ] = ACTIONS(4098),
    [anon_sym_GT_EQ] = ACTIONS(4096),
    [anon_sym_lt] = ACTIONS(4096),
    [anon_sym_le] = ACTIONS(4096),
    [anon_sym_ge] = ACTIONS(4096),
    [anon_sym_gt] = ACTIONS(4096),
    [anon_sym_isa] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_QMARK] = ACTIONS(4096),
    [anon_sym_EQ_GT] = ACTIONS(4096),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1596] = {
    [sym_heredoc_content] = STATE(1596),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_COLON] = ACTIONS(4166),
    [anon_sym_SEMI] = ACTIONS(4166),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [anon_sym_COMMA] = ACTIONS(4166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4166),
    [anon_sym_and] = ACTIONS(4166),
    [anon_sym_or] = ACTIONS(4166),
    [anon_sym_RBRACK] = ACTIONS(4166),
    [anon_sym_DASH_GT] = ACTIONS(4166),
    [anon_sym_PERCENT] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_GT] = ACTIONS(4168),
    [anon_sym_LT_LT] = ACTIONS(4168),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4166),
    [anon_sym_PLUS_EQ] = ACTIONS(4166),
    [anon_sym_DASH_EQ] = ACTIONS(4166),
    [anon_sym_DOT_EQ] = ACTIONS(4166),
    [anon_sym_STAR_EQ] = ACTIONS(4166),
    [anon_sym_SLASH_EQ] = ACTIONS(4166),
    [anon_sym_PERCENT_EQ] = ACTIONS(4166),
    [anon_sym_x_EQ] = ACTIONS(4166),
    [anon_sym_AMP_EQ] = ACTIONS(4166),
    [anon_sym_PIPE_EQ] = ACTIONS(4166),
    [anon_sym_CARET_EQ] = ACTIONS(4166),
    [anon_sym_LT_LT_EQ] = ACTIONS(4166),
    [anon_sym_GT_GT_EQ] = ACTIONS(4166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4166),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4166),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_STAR_STAR] = ACTIONS(4168),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_SLASH_SLASH] = ACTIONS(4168),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_PIPE] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_GT_GT2] = ACTIONS(4168),
    [anon_sym_PLUS] = ACTIONS(4168),
    [anon_sym_DASH] = ACTIONS(4168),
    [anon_sym_DOT] = ACTIONS(4168),
    [anon_sym_STAR] = ACTIONS(4168),
    [anon_sym_SLASH] = ACTIONS(4168),
    [anon_sym_x] = ACTIONS(4168),
    [anon_sym_EQ_TILDE] = ACTIONS(4166),
    [anon_sym_BANG_TILDE] = ACTIONS(4166),
    [anon_sym_EQ_EQ] = ACTIONS(4166),
    [anon_sym_BANG_EQ] = ACTIONS(4166),
    [anon_sym_eq] = ACTIONS(4166),
    [anon_sym_ne] = ACTIONS(4166),
    [anon_sym_LT_EQ_GT] = ACTIONS(4166),
    [anon_sym_cmp] = ACTIONS(4166),
    [anon_sym_TILDE_TILDE] = ACTIONS(4166),
    [anon_sym_LT_EQ] = ACTIONS(4168),
    [anon_sym_GT_EQ] = ACTIONS(4166),
    [anon_sym_lt] = ACTIONS(4166),
    [anon_sym_le] = ACTIONS(4166),
    [anon_sym_ge] = ACTIONS(4166),
    [anon_sym_gt] = ACTIONS(4166),
    [anon_sym_isa] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4166),
    [anon_sym_DASH_DASH] = ACTIONS(4166),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_EQ_GT] = ACTIONS(4166),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1597] = {
    [sym_heredoc_content] = STATE(1597),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_RPAREN] = ACTIONS(3755),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3755),
    [anon_sym_and] = ACTIONS(3755),
    [anon_sym_or] = ACTIONS(3755),
    [anon_sym_RBRACK] = ACTIONS(3755),
    [anon_sym_DASH_GT] = ACTIONS(3755),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_GT] = ACTIONS(3757),
    [anon_sym_LT_LT] = ACTIONS(3757),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3755),
    [anon_sym_PLUS_EQ] = ACTIONS(3755),
    [anon_sym_DASH_EQ] = ACTIONS(3755),
    [anon_sym_DOT_EQ] = ACTIONS(3755),
    [anon_sym_STAR_EQ] = ACTIONS(3755),
    [anon_sym_SLASH_EQ] = ACTIONS(3755),
    [anon_sym_PERCENT_EQ] = ACTIONS(3755),
    [anon_sym_x_EQ] = ACTIONS(3755),
    [anon_sym_AMP_EQ] = ACTIONS(3755),
    [anon_sym_PIPE_EQ] = ACTIONS(3755),
    [anon_sym_CARET_EQ] = ACTIONS(3755),
    [anon_sym_LT_LT_EQ] = ACTIONS(3755),
    [anon_sym_GT_GT_EQ] = ACTIONS(3755),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3755),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3755),
    [anon_sym_DOT_DOT] = ACTIONS(3757),
    [anon_sym_STAR_STAR] = ACTIONS(3757),
    [anon_sym_PIPE_PIPE] = ACTIONS(3757),
    [anon_sym_SLASH_SLASH] = ACTIONS(3757),
    [anon_sym_AMP_AMP] = ACTIONS(3757),
    [anon_sym_PIPE] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_GT_GT2] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_DOT] = ACTIONS(3757),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_SLASH] = ACTIONS(3757),
    [anon_sym_x] = ACTIONS(3757),
    [anon_sym_EQ_TILDE] = ACTIONS(3755),
    [anon_sym_BANG_TILDE] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3755),
    [anon_sym_eq] = ACTIONS(3755),
    [anon_sym_ne] = ACTIONS(3755),
    [anon_sym_LT_EQ_GT] = ACTIONS(3755),
    [anon_sym_cmp] = ACTIONS(3755),
    [anon_sym_TILDE_TILDE] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3757),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_lt] = ACTIONS(3755),
    [anon_sym_le] = ACTIONS(3755),
    [anon_sym_ge] = ACTIONS(3755),
    [anon_sym_gt] = ACTIONS(3755),
    [anon_sym_isa] = ACTIONS(3755),
    [anon_sym_PLUS_PLUS] = ACTIONS(3755),
    [anon_sym_DASH_DASH] = ACTIONS(3755),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_EQ_GT] = ACTIONS(3755),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1598] = {
    [sym_heredoc_content] = STATE(1598),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3893),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3893),
    [anon_sym_and] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_RBRACK] = ACTIONS(3893),
    [anon_sym_DASH_GT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_LT_LT] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3895),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3893),
    [anon_sym_PLUS_EQ] = ACTIONS(3893),
    [anon_sym_DASH_EQ] = ACTIONS(3893),
    [anon_sym_DOT_EQ] = ACTIONS(3893),
    [anon_sym_STAR_EQ] = ACTIONS(3893),
    [anon_sym_SLASH_EQ] = ACTIONS(3893),
    [anon_sym_PERCENT_EQ] = ACTIONS(3893),
    [anon_sym_x_EQ] = ACTIONS(3893),
    [anon_sym_AMP_EQ] = ACTIONS(3893),
    [anon_sym_PIPE_EQ] = ACTIONS(3893),
    [anon_sym_CARET_EQ] = ACTIONS(3893),
    [anon_sym_LT_LT_EQ] = ACTIONS(3893),
    [anon_sym_GT_GT_EQ] = ACTIONS(3893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3893),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3893),
    [anon_sym_DOT_DOT] = ACTIONS(3895),
    [anon_sym_STAR_STAR] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_SLASH_SLASH] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_GT_GT2] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_SLASH] = ACTIONS(3895),
    [anon_sym_x] = ACTIONS(3895),
    [anon_sym_EQ_TILDE] = ACTIONS(3893),
    [anon_sym_BANG_TILDE] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_eq] = ACTIONS(3893),
    [anon_sym_ne] = ACTIONS(3893),
    [anon_sym_LT_EQ_GT] = ACTIONS(3893),
    [anon_sym_cmp] = ACTIONS(3893),
    [anon_sym_TILDE_TILDE] = ACTIONS(3893),
    [anon_sym_LT_EQ] = ACTIONS(3895),
    [anon_sym_GT_EQ] = ACTIONS(3893),
    [anon_sym_lt] = ACTIONS(3893),
    [anon_sym_le] = ACTIONS(3893),
    [anon_sym_ge] = ACTIONS(3893),
    [anon_sym_gt] = ACTIONS(3893),
    [anon_sym_isa] = ACTIONS(3893),
    [anon_sym_PLUS_PLUS] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_EQ_GT] = ACTIONS(3893),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1599] = {
    [sym_heredoc_content] = STATE(1599),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_PERCENT] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4030),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4028),
    [anon_sym_PLUS_EQ] = ACTIONS(4028),
    [anon_sym_DASH_EQ] = ACTIONS(4028),
    [anon_sym_DOT_EQ] = ACTIONS(4028),
    [anon_sym_STAR_EQ] = ACTIONS(4028),
    [anon_sym_SLASH_EQ] = ACTIONS(4028),
    [anon_sym_PERCENT_EQ] = ACTIONS(4028),
    [anon_sym_x_EQ] = ACTIONS(4028),
    [anon_sym_AMP_EQ] = ACTIONS(4028),
    [anon_sym_PIPE_EQ] = ACTIONS(4028),
    [anon_sym_CARET_EQ] = ACTIONS(4028),
    [anon_sym_LT_LT_EQ] = ACTIONS(4028),
    [anon_sym_GT_GT_EQ] = ACTIONS(4028),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4028),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4030),
    [anon_sym_STAR_STAR] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_SLASH_SLASH] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_GT_GT2] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_DOT] = ACTIONS(4030),
    [anon_sym_STAR] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_x] = ACTIONS(4030),
    [anon_sym_EQ_TILDE] = ACTIONS(4028),
    [anon_sym_BANG_TILDE] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_eq] = ACTIONS(4028),
    [anon_sym_ne] = ACTIONS(4028),
    [anon_sym_LT_EQ_GT] = ACTIONS(4028),
    [anon_sym_cmp] = ACTIONS(4028),
    [anon_sym_TILDE_TILDE] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4030),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_lt] = ACTIONS(4028),
    [anon_sym_le] = ACTIONS(4028),
    [anon_sym_ge] = ACTIONS(4028),
    [anon_sym_gt] = ACTIONS(4028),
    [anon_sym_isa] = ACTIONS(4028),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1600] = {
    [sym_heredoc_content] = STATE(1600),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_COLON] = ACTIONS(4008),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(4008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4008),
    [anon_sym_and] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4008),
    [anon_sym_RBRACK] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4008),
    [anon_sym_PERCENT] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_EQ] = ACTIONS(4010),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4008),
    [anon_sym_PLUS_EQ] = ACTIONS(4008),
    [anon_sym_DASH_EQ] = ACTIONS(4008),
    [anon_sym_DOT_EQ] = ACTIONS(4008),
    [anon_sym_STAR_EQ] = ACTIONS(4008),
    [anon_sym_SLASH_EQ] = ACTIONS(4008),
    [anon_sym_PERCENT_EQ] = ACTIONS(4008),
    [anon_sym_x_EQ] = ACTIONS(4008),
    [anon_sym_AMP_EQ] = ACTIONS(4008),
    [anon_sym_PIPE_EQ] = ACTIONS(4008),
    [anon_sym_CARET_EQ] = ACTIONS(4008),
    [anon_sym_LT_LT_EQ] = ACTIONS(4008),
    [anon_sym_GT_GT_EQ] = ACTIONS(4008),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4008),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4008),
    [anon_sym_DOT_DOT] = ACTIONS(4010),
    [anon_sym_STAR_STAR] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [anon_sym_SLASH_SLASH] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_GT_GT2] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_DOT] = ACTIONS(4010),
    [anon_sym_STAR] = ACTIONS(4010),
    [anon_sym_SLASH] = ACTIONS(4010),
    [anon_sym_x] = ACTIONS(4010),
    [anon_sym_EQ_TILDE] = ACTIONS(4008),
    [anon_sym_BANG_TILDE] = ACTIONS(4008),
    [anon_sym_EQ_EQ] = ACTIONS(4008),
    [anon_sym_BANG_EQ] = ACTIONS(4008),
    [anon_sym_eq] = ACTIONS(4008),
    [anon_sym_ne] = ACTIONS(4008),
    [anon_sym_LT_EQ_GT] = ACTIONS(4008),
    [anon_sym_cmp] = ACTIONS(4008),
    [anon_sym_TILDE_TILDE] = ACTIONS(4008),
    [anon_sym_LT_EQ] = ACTIONS(4010),
    [anon_sym_GT_EQ] = ACTIONS(4008),
    [anon_sym_lt] = ACTIONS(4008),
    [anon_sym_le] = ACTIONS(4008),
    [anon_sym_ge] = ACTIONS(4008),
    [anon_sym_gt] = ACTIONS(4008),
    [anon_sym_isa] = ACTIONS(4008),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [anon_sym_QMARK] = ACTIONS(4008),
    [anon_sym_EQ_GT] = ACTIONS(4008),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1601] = {
    [sym_heredoc_content] = STATE(1601),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1602] = {
    [sym_heredoc_content] = STATE(1602),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3885),
    [anon_sym_RPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_RBRACK] = ACTIONS(3885),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3885),
    [anon_sym_PLUS_EQ] = ACTIONS(3885),
    [anon_sym_DASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_EQ] = ACTIONS(3885),
    [anon_sym_STAR_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_PERCENT_EQ] = ACTIONS(3885),
    [anon_sym_x_EQ] = ACTIONS(3885),
    [anon_sym_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_CARET_EQ] = ACTIONS(3885),
    [anon_sym_LT_LT_EQ] = ACTIONS(3885),
    [anon_sym_GT_GT_EQ] = ACTIONS(3885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_DOT] = ACTIONS(3887),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3887),
    [anon_sym_SLASH_SLASH] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4503),
    [anon_sym_cmp] = ACTIONS(4503),
    [anon_sym_TILDE_TILDE] = ACTIONS(4503),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_EQ_GT] = ACTIONS(3885),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1603] = {
    [sym_heredoc_content] = STATE(1603),
    [anon_sym_RBRACE] = ACTIONS(4080),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym_RPAREN] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4080),
    [anon_sym_and] = ACTIONS(4080),
    [anon_sym_or] = ACTIONS(4080),
    [anon_sym_RBRACK] = ACTIONS(4080),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4082),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4082),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4080),
    [anon_sym_PLUS_EQ] = ACTIONS(4080),
    [anon_sym_DASH_EQ] = ACTIONS(4080),
    [anon_sym_DOT_EQ] = ACTIONS(4080),
    [anon_sym_STAR_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_PERCENT_EQ] = ACTIONS(4080),
    [anon_sym_x_EQ] = ACTIONS(4080),
    [anon_sym_AMP_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_CARET_EQ] = ACTIONS(4080),
    [anon_sym_LT_LT_EQ] = ACTIONS(4080),
    [anon_sym_GT_GT_EQ] = ACTIONS(4080),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(4082),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_SLASH_SLASH] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4080),
    [anon_sym_BANG_EQ] = ACTIONS(4080),
    [anon_sym_eq] = ACTIONS(4080),
    [anon_sym_ne] = ACTIONS(4080),
    [anon_sym_LT_EQ_GT] = ACTIONS(4080),
    [anon_sym_cmp] = ACTIONS(4080),
    [anon_sym_TILDE_TILDE] = ACTIONS(4080),
    [anon_sym_LT_EQ] = ACTIONS(4082),
    [anon_sym_GT_EQ] = ACTIONS(4080),
    [anon_sym_lt] = ACTIONS(4080),
    [anon_sym_le] = ACTIONS(4080),
    [anon_sym_ge] = ACTIONS(4080),
    [anon_sym_gt] = ACTIONS(4080),
    [anon_sym_isa] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4080),
    [anon_sym_EQ_GT] = ACTIONS(4080),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1604] = {
    [sym_heredoc_content] = STATE(1604),
    [anon_sym_RBRACE] = ACTIONS(3606),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_RPAREN] = ACTIONS(3606),
    [anon_sym_COMMA] = ACTIONS(3606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4441),
    [anon_sym_and] = ACTIONS(3606),
    [anon_sym_or] = ACTIONS(3606),
    [anon_sym_RBRACK] = ACTIONS(3606),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4451),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_x_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4455),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4459),
    [anon_sym_SLASH_SLASH] = ACTIONS(4459),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4481),
    [anon_sym_EQ_GT] = ACTIONS(3606),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1605] = {
    [sym_heredoc_content] = STATE(1605),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_SEMI] = ACTIONS(4004),
    [anon_sym_RPAREN] = ACTIONS(4004),
    [anon_sym_COMMA] = ACTIONS(4004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4441),
    [anon_sym_and] = ACTIONS(4004),
    [anon_sym_or] = ACTIONS(4004),
    [anon_sym_RBRACK] = ACTIONS(4004),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4451),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_x_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4455),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4459),
    [anon_sym_SLASH_SLASH] = ACTIONS(4459),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4481),
    [anon_sym_EQ_GT] = ACTIONS(4004),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1606] = {
    [sym_heredoc_content] = STATE(1606),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_DOT_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_x_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_SLASH_SLASH] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4246),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_eq] = ACTIONS(4246),
    [anon_sym_ne] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_cmp] = ACTIONS(4246),
    [anon_sym_TILDE_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_lt] = ACTIONS(4246),
    [anon_sym_le] = ACTIONS(4246),
    [anon_sym_ge] = ACTIONS(4246),
    [anon_sym_gt] = ACTIONS(4246),
    [anon_sym_isa] = ACTIONS(4246),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1607] = {
    [sym_heredoc_content] = STATE(1607),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4505),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(4507),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4459),
    [anon_sym_SLASH_SLASH] = ACTIONS(4459),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1608] = {
    [sym_heredoc_content] = STATE(1608),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1609] = {
    [sym_heredoc_content] = STATE(1609),
    [anon_sym_RBRACE] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3831),
    [anon_sym_RBRACK] = ACTIONS(3831),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(3833),
    [anon_sym_GT] = ACTIONS(3833),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3833),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3831),
    [anon_sym_PLUS_EQ] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_EQ] = ACTIONS(3831),
    [anon_sym_STAR_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3831),
    [anon_sym_x_EQ] = ACTIONS(3831),
    [anon_sym_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3833),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3833),
    [anon_sym_SLASH_SLASH] = ACTIONS(3833),
    [anon_sym_AMP_AMP] = ACTIONS(3833),
    [anon_sym_PIPE] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(3833),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(3831),
    [anon_sym_BANG_EQ] = ACTIONS(3831),
    [anon_sym_eq] = ACTIONS(3831),
    [anon_sym_ne] = ACTIONS(3831),
    [anon_sym_LT_EQ_GT] = ACTIONS(3831),
    [anon_sym_cmp] = ACTIONS(3831),
    [anon_sym_TILDE_TILDE] = ACTIONS(3831),
    [anon_sym_LT_EQ] = ACTIONS(3833),
    [anon_sym_GT_EQ] = ACTIONS(3831),
    [anon_sym_lt] = ACTIONS(3831),
    [anon_sym_le] = ACTIONS(3831),
    [anon_sym_ge] = ACTIONS(3831),
    [anon_sym_gt] = ACTIONS(3831),
    [anon_sym_isa] = ACTIONS(3831),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3831),
    [anon_sym_EQ_GT] = ACTIONS(3831),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1610] = {
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1506),
    [sym_heredoc_content] = STATE(1610),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym_prototype_or_signature] = ACTIONS(4270),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1611] = {
    [sym__PERLY_BRACE_OPEN] = STATE(275),
    [sym_block] = STATE(1502),
    [sym_heredoc_content] = STATE(1611),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym_prototype_or_signature] = ACTIONS(4274),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
  },
  [1612] = {
    [sym_heredoc_content] = STATE(1612),
    [anon_sym_RBRACE] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4441),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_RBRACK] = ACTIONS(4154),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4154),
    [anon_sym_PLUS_EQ] = ACTIONS(4154),
    [anon_sym_DASH_EQ] = ACTIONS(4154),
    [anon_sym_DOT_EQ] = ACTIONS(4154),
    [anon_sym_STAR_EQ] = ACTIONS(4154),
    [anon_sym_SLASH_EQ] = ACTIONS(4154),
    [anon_sym_PERCENT_EQ] = ACTIONS(4154),
    [anon_sym_x_EQ] = ACTIONS(4154),
    [anon_sym_AMP_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_CARET_EQ] = ACTIONS(4154),
    [anon_sym_LT_LT_EQ] = ACTIONS(4154),
    [anon_sym_GT_GT_EQ] = ACTIONS(4154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4154),
    [anon_sym_DOT_DOT] = ACTIONS(4455),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4459),
    [anon_sym_SLASH_SLASH] = ACTIONS(4459),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4481),
    [anon_sym_EQ_GT] = ACTIONS(4154),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1613] = {
    [sym_heredoc_content] = STATE(1613),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_RBRACK] = ACTIONS(4214),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4216),
    [anon_sym_GT] = ACTIONS(4216),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4216),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_DOT_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_x_EQ] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_DOT_DOT] = ACTIONS(4216),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_SLASH_SLASH] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_PIPE] = ACTIONS(4216),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4214),
    [anon_sym_eq] = ACTIONS(4214),
    [anon_sym_ne] = ACTIONS(4214),
    [anon_sym_LT_EQ_GT] = ACTIONS(4214),
    [anon_sym_cmp] = ACTIONS(4214),
    [anon_sym_TILDE_TILDE] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(4216),
    [anon_sym_GT_EQ] = ACTIONS(4214),
    [anon_sym_lt] = ACTIONS(4214),
    [anon_sym_le] = ACTIONS(4214),
    [anon_sym_ge] = ACTIONS(4214),
    [anon_sym_gt] = ACTIONS(4214),
    [anon_sym_isa] = ACTIONS(4214),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1614] = {
    [sym_heredoc_content] = STATE(1614),
    [anon_sym_RBRACE] = ACTIONS(3835),
    [anon_sym_SEMI] = ACTIONS(3835),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [anon_sym_COMMA] = ACTIONS(3835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4441),
    [anon_sym_and] = ACTIONS(3835),
    [anon_sym_or] = ACTIONS(3835),
    [anon_sym_RBRACK] = ACTIONS(3835),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4451),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_x_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4455),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4459),
    [anon_sym_SLASH_SLASH] = ACTIONS(4459),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4481),
    [anon_sym_EQ_GT] = ACTIONS(3835),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1615] = {
    [sym_heredoc_content] = STATE(1615),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_x_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4064),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_SLASH_SLASH] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_eq] = ACTIONS(4062),
    [anon_sym_ne] = ACTIONS(4062),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_cmp] = ACTIONS(4062),
    [anon_sym_TILDE_TILDE] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_lt] = ACTIONS(4062),
    [anon_sym_le] = ACTIONS(4062),
    [anon_sym_ge] = ACTIONS(4062),
    [anon_sym_gt] = ACTIONS(4062),
    [anon_sym_isa] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1616] = {
    [sym_attrlist] = STATE(1540),
    [sym_attribute] = STATE(1541),
    [sym_attribute_name] = STATE(1648),
    [sym_heredoc_content] = STATE(1616),
    [sym__identifier] = ACTIONS(4494),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3438),
    [anon_sym_PLUS_EQ] = ACTIONS(3438),
    [anon_sym_DASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_EQ] = ACTIONS(3438),
    [anon_sym_STAR_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_PERCENT_EQ] = ACTIONS(3438),
    [anon_sym_x_EQ] = ACTIONS(3438),
    [anon_sym_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_CARET_EQ] = ACTIONS(3438),
    [anon_sym_LT_LT_EQ] = ACTIONS(3438),
    [anon_sym_GT_GT_EQ] = ACTIONS(3438),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3440),
    [anon_sym_GT_GT2] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_x] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3438),
    [anon_sym_BANG_TILDE] = ACTIONS(3438),
    [anon_sym_EQ_EQ] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_eq] = ACTIONS(3440),
    [anon_sym_ne] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3438),
    [anon_sym_cmp] = ACTIONS(3440),
    [anon_sym_TILDE_TILDE] = ACTIONS(3438),
    [anon_sym_LT_EQ] = ACTIONS(3440),
    [anon_sym_GT_EQ] = ACTIONS(3438),
    [anon_sym_lt] = ACTIONS(3440),
    [anon_sym_le] = ACTIONS(3440),
    [anon_sym_ge] = ACTIONS(3440),
    [anon_sym_gt] = ACTIONS(3440),
    [anon_sym_isa] = ACTIONS(3440),
    [anon_sym_PLUS_PLUS] = ACTIONS(3438),
    [anon_sym_DASH_DASH] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3438),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4494),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1617] = {
    [sym_attrlist] = STATE(1542),
    [sym_attribute] = STATE(1541),
    [sym_attribute_name] = STATE(1648),
    [sym_heredoc_content] = STATE(1617),
    [sym__identifier] = ACTIONS(4494),
    [anon_sym_RPAREN] = ACTIONS(3434),
    [anon_sym_COMMA] = ACTIONS(3434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3434),
    [anon_sym_DASH_GT] = ACTIONS(3434),
    [anon_sym_PERCENT] = ACTIONS(3436),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_LT_LT] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3434),
    [anon_sym_DASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_EQ] = ACTIONS(3434),
    [anon_sym_STAR_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_PERCENT_EQ] = ACTIONS(3434),
    [anon_sym_x_EQ] = ACTIONS(3434),
    [anon_sym_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_CARET_EQ] = ACTIONS(3434),
    [anon_sym_LT_LT_EQ] = ACTIONS(3434),
    [anon_sym_GT_GT_EQ] = ACTIONS(3434),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_DOT_DOT] = ACTIONS(3436),
    [anon_sym_STAR_STAR] = ACTIONS(3436),
    [anon_sym_PIPE_PIPE] = ACTIONS(3436),
    [anon_sym_SLASH_SLASH] = ACTIONS(3436),
    [anon_sym_AMP_AMP] = ACTIONS(3436),
    [anon_sym_PIPE] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_GT_GT2] = ACTIONS(3436),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_DOT] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3436),
    [anon_sym_SLASH] = ACTIONS(3436),
    [anon_sym_x] = ACTIONS(3436),
    [anon_sym_EQ_TILDE] = ACTIONS(3434),
    [anon_sym_BANG_TILDE] = ACTIONS(3434),
    [anon_sym_EQ_EQ] = ACTIONS(3434),
    [anon_sym_BANG_EQ] = ACTIONS(3434),
    [anon_sym_eq] = ACTIONS(3436),
    [anon_sym_ne] = ACTIONS(3436),
    [anon_sym_LT_EQ_GT] = ACTIONS(3434),
    [anon_sym_cmp] = ACTIONS(3436),
    [anon_sym_TILDE_TILDE] = ACTIONS(3434),
    [anon_sym_LT_EQ] = ACTIONS(3436),
    [anon_sym_GT_EQ] = ACTIONS(3434),
    [anon_sym_lt] = ACTIONS(3436),
    [anon_sym_le] = ACTIONS(3436),
    [anon_sym_ge] = ACTIONS(3436),
    [anon_sym_gt] = ACTIONS(3436),
    [anon_sym_isa] = ACTIONS(3436),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_QMARK] = ACTIONS(3434),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4494),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1618] = {
    [sym_heredoc_content] = STATE(1618),
    [sym__identifier] = ACTIONS(3442),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3444),
    [anon_sym_DASH_GT] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3444),
    [anon_sym_PLUS_EQ] = ACTIONS(3444),
    [anon_sym_DASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_EQ] = ACTIONS(3444),
    [anon_sym_STAR_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_PERCENT_EQ] = ACTIONS(3444),
    [anon_sym_x_EQ] = ACTIONS(3444),
    [anon_sym_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_CARET_EQ] = ACTIONS(3444),
    [anon_sym_LT_LT_EQ] = ACTIONS(3444),
    [anon_sym_GT_GT_EQ] = ACTIONS(3444),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_SLASH_SLASH] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_GT_GT2] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_x] = ACTIONS(3442),
    [anon_sym_EQ_TILDE] = ACTIONS(3444),
    [anon_sym_BANG_TILDE] = ACTIONS(3444),
    [anon_sym_EQ_EQ] = ACTIONS(3444),
    [anon_sym_BANG_EQ] = ACTIONS(3444),
    [anon_sym_eq] = ACTIONS(3442),
    [anon_sym_ne] = ACTIONS(3442),
    [anon_sym_LT_EQ_GT] = ACTIONS(3444),
    [anon_sym_cmp] = ACTIONS(3442),
    [anon_sym_TILDE_TILDE] = ACTIONS(3444),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3444),
    [anon_sym_lt] = ACTIONS(3442),
    [anon_sym_le] = ACTIONS(3442),
    [anon_sym_ge] = ACTIONS(3442),
    [anon_sym_gt] = ACTIONS(3442),
    [anon_sym_isa] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_EQ_GT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3442),
    [sym__PERLY_SEMICOLON] = ACTIONS(3444),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(3444),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1619] = {
    [sym_heredoc_content] = STATE(1619),
    [anon_sym_RBRACE] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(4350),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_and] = ACTIONS(3452),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(217),
    [sym__brace_end_zw] = ACTIONS(564),
  },
  [1620] = {
    [sym_heredoc_content] = STATE(1620),
    [sym__identifier] = ACTIONS(3446),
    [anon_sym_COLON] = ACTIONS(3446),
    [anon_sym_SEMI] = ACTIONS(3448),
    [anon_sym_COMMA] = ACTIONS(3448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3448),
    [anon_sym_DASH_GT] = ACTIONS(3448),
    [anon_sym_PERCENT] = ACTIONS(3446),
    [anon_sym_LT] = ACTIONS(3446),
    [anon_sym_GT] = ACTIONS(3446),
    [anon_sym_LT_LT] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(3446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_x_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_DOT] = ACTIONS(3446),
    [anon_sym_STAR_STAR] = ACTIONS(3446),
    [anon_sym_PIPE_PIPE] = ACTIONS(3446),
    [anon_sym_SLASH_SLASH] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_PIPE] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_GT_GT2] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3446),
    [anon_sym_DOT] = ACTIONS(3446),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_SLASH] = ACTIONS(3446),
    [anon_sym_x] = ACTIONS(3446),
    [anon_sym_EQ_TILDE] = ACTIONS(3448),
    [anon_sym_BANG_TILDE] = ACTIONS(3448),
    [anon_sym_EQ_EQ] = ACTIONS(3448),
    [anon_sym_BANG_EQ] = ACTIONS(3448),
    [anon_sym_eq] = ACTIONS(3446),
    [anon_sym_ne] = ACTIONS(3446),
    [anon_sym_LT_EQ_GT] = ACTIONS(3448),
    [anon_sym_cmp] = ACTIONS(3446),
    [anon_sym_TILDE_TILDE] = ACTIONS(3448),
    [anon_sym_LT_EQ] = ACTIONS(3446),
    [anon_sym_GT_EQ] = ACTIONS(3448),
    [anon_sym_lt] = ACTIONS(3446),
    [anon_sym_le] = ACTIONS(3446),
    [anon_sym_ge] = ACTIONS(3446),
    [anon_sym_gt] = ACTIONS(3446),
    [anon_sym_isa] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(3448),
    [anon_sym_EQ_GT] = ACTIONS(3448),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3446),
    [sym__PERLY_SEMICOLON] = ACTIONS(3448),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(4509),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1621] = {
    [sym_heredoc_content] = STATE(1621),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(3823),
    [anon_sym_BANG_TILDE] = ACTIONS(3823),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1622] = {
    [sym_heredoc_content] = STATE(1622),
    [anon_sym_RBRACE] = ACTIONS(4048),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4048),
    [anon_sym_and] = ACTIONS(4048),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_RBRACK] = ACTIONS(4048),
    [anon_sym_DASH_GT] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4048),
    [anon_sym_PLUS_EQ] = ACTIONS(4048),
    [anon_sym_DASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_EQ] = ACTIONS(4048),
    [anon_sym_STAR_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_PERCENT_EQ] = ACTIONS(4048),
    [anon_sym_x_EQ] = ACTIONS(4048),
    [anon_sym_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_CARET_EQ] = ACTIONS(4048),
    [anon_sym_LT_LT_EQ] = ACTIONS(4048),
    [anon_sym_GT_GT_EQ] = ACTIONS(4048),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4048),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4048),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4052),
    [anon_sym_STAR_STAR] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_SLASH_SLASH] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_GT_GT2] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_x] = ACTIONS(4052),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_EQ_EQ] = ACTIONS(4048),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_eq] = ACTIONS(4048),
    [anon_sym_ne] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_cmp] = ACTIONS(4048),
    [anon_sym_TILDE_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4052),
    [anon_sym_GT_EQ] = ACTIONS(4048),
    [anon_sym_lt] = ACTIONS(4048),
    [anon_sym_le] = ACTIONS(4048),
    [anon_sym_ge] = ACTIONS(4048),
    [anon_sym_gt] = ACTIONS(4048),
    [anon_sym_isa] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4048),
    [anon_sym_DASH_DASH] = ACTIONS(4048),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4511),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1623] = {
    [sym_heredoc_content] = STATE(1623),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1624] = {
    [sym_heredoc_content] = STATE(1624),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym_RPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3921),
    [anon_sym_and] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_RBRACK] = ACTIONS(3921),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3921),
    [anon_sym_PLUS_EQ] = ACTIONS(3921),
    [anon_sym_DASH_EQ] = ACTIONS(3921),
    [anon_sym_DOT_EQ] = ACTIONS(3921),
    [anon_sym_STAR_EQ] = ACTIONS(3921),
    [anon_sym_SLASH_EQ] = ACTIONS(3921),
    [anon_sym_PERCENT_EQ] = ACTIONS(3921),
    [anon_sym_x_EQ] = ACTIONS(3921),
    [anon_sym_AMP_EQ] = ACTIONS(3921),
    [anon_sym_PIPE_EQ] = ACTIONS(3921),
    [anon_sym_CARET_EQ] = ACTIONS(3921),
    [anon_sym_LT_LT_EQ] = ACTIONS(3921),
    [anon_sym_GT_GT_EQ] = ACTIONS(3921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3921),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3921),
    [anon_sym_DOT_DOT] = ACTIONS(3923),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_GT_GT2] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DOT] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(3923),
    [anon_sym_SLASH] = ACTIONS(3923),
    [anon_sym_x] = ACTIONS(3923),
    [anon_sym_EQ_TILDE] = ACTIONS(3921),
    [anon_sym_BANG_TILDE] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_eq] = ACTIONS(3921),
    [anon_sym_ne] = ACTIONS(3921),
    [anon_sym_LT_EQ_GT] = ACTIONS(3921),
    [anon_sym_cmp] = ACTIONS(3921),
    [anon_sym_TILDE_TILDE] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3923),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_lt] = ACTIONS(3921),
    [anon_sym_le] = ACTIONS(3921),
    [anon_sym_ge] = ACTIONS(3921),
    [anon_sym_gt] = ACTIONS(3921),
    [anon_sym_isa] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_EQ_GT] = ACTIONS(3921),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1625] = {
    [sym_attribute] = STATE(1676),
    [sym_attribute_name] = STATE(1648),
    [sym_heredoc_content] = STATE(1625),
    [aux_sym_attrlist_repeat1] = STATE(1530),
    [sym__identifier] = ACTIONS(4494),
    [anon_sym_COLON] = ACTIONS(3422),
    [anon_sym_COMMA] = ACTIONS(3420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3420),
    [anon_sym_DASH_GT] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3422),
    [anon_sym_GT] = ACTIONS(3422),
    [anon_sym_LT_LT] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3422),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_x_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_DOT_DOT] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3422),
    [anon_sym_PIPE_PIPE] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_AMP_AMP] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(3422),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_GT_GT2] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_DASH] = ACTIONS(3422),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_STAR] = ACTIONS(3422),
    [anon_sym_SLASH] = ACTIONS(3422),
    [anon_sym_x] = ACTIONS(3422),
    [anon_sym_EQ_TILDE] = ACTIONS(3420),
    [anon_sym_BANG_TILDE] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3420),
    [anon_sym_BANG_EQ] = ACTIONS(3420),
    [anon_sym_eq] = ACTIONS(3422),
    [anon_sym_ne] = ACTIONS(3422),
    [anon_sym_LT_EQ_GT] = ACTIONS(3420),
    [anon_sym_cmp] = ACTIONS(3422),
    [anon_sym_TILDE_TILDE] = ACTIONS(3420),
    [anon_sym_LT_EQ] = ACTIONS(3422),
    [anon_sym_GT_EQ] = ACTIONS(3420),
    [anon_sym_lt] = ACTIONS(3422),
    [anon_sym_le] = ACTIONS(3422),
    [anon_sym_ge] = ACTIONS(3422),
    [anon_sym_gt] = ACTIONS(3422),
    [anon_sym_isa] = ACTIONS(3422),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_EQ_GT] = ACTIONS(3420),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4494),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1626] = {
    [sym_heredoc_content] = STATE(1626),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1627] = {
    [sym_heredoc_content] = STATE(1627),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1628] = {
    [sym_heredoc_content] = STATE(1628),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1629] = {
    [sym_heredoc_content] = STATE(1629),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_COLON] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_DASH_GT] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2901),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2903),
    [anon_sym_DOT_EQ] = ACTIONS(2903),
    [anon_sym_STAR_EQ] = ACTIONS(2903),
    [anon_sym_SLASH_EQ] = ACTIONS(2903),
    [anon_sym_PERCENT_EQ] = ACTIONS(2903),
    [anon_sym_x_EQ] = ACTIONS(2903),
    [anon_sym_AMP_EQ] = ACTIONS(2903),
    [anon_sym_PIPE_EQ] = ACTIONS(2903),
    [anon_sym_CARET_EQ] = ACTIONS(2903),
    [anon_sym_LT_LT_EQ] = ACTIONS(2903),
    [anon_sym_GT_GT_EQ] = ACTIONS(2903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2903),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2903),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_GT_GT2] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_x] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2903),
    [anon_sym_BANG_TILDE] = ACTIONS(2903),
    [anon_sym_EQ_EQ] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2903),
    [anon_sym_eq] = ACTIONS(2903),
    [anon_sym_ne] = ACTIONS(2903),
    [anon_sym_LT_EQ_GT] = ACTIONS(2903),
    [anon_sym_cmp] = ACTIONS(2903),
    [anon_sym_TILDE_TILDE] = ACTIONS(2903),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2903),
    [anon_sym_lt] = ACTIONS(2903),
    [anon_sym_le] = ACTIONS(2903),
    [anon_sym_ge] = ACTIONS(2903),
    [anon_sym_gt] = ACTIONS(2903),
    [anon_sym_isa] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_QMARK] = ACTIONS(2903),
    [anon_sym_EQ_GT] = ACTIONS(2903),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2903),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1630] = {
    [sym_heredoc_content] = STATE(1630),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1631] = {
    [sym_heredoc_content] = STATE(1631),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3823),
    [anon_sym_and] = ACTIONS(3823),
    [anon_sym_or] = ACTIONS(3823),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3823),
    [anon_sym_PLUS_EQ] = ACTIONS(3823),
    [anon_sym_DASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_EQ] = ACTIONS(3823),
    [anon_sym_STAR_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_PERCENT_EQ] = ACTIONS(3823),
    [anon_sym_x_EQ] = ACTIONS(3823),
    [anon_sym_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_CARET_EQ] = ACTIONS(3823),
    [anon_sym_LT_LT_EQ] = ACTIONS(3823),
    [anon_sym_GT_GT_EQ] = ACTIONS(3823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3823),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3827),
    [anon_sym_GT_GT2] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3827),
    [anon_sym_x] = ACTIONS(3827),
    [anon_sym_EQ_TILDE] = ACTIONS(3823),
    [anon_sym_BANG_TILDE] = ACTIONS(3823),
    [anon_sym_EQ_EQ] = ACTIONS(3823),
    [anon_sym_BANG_EQ] = ACTIONS(3823),
    [anon_sym_eq] = ACTIONS(3823),
    [anon_sym_ne] = ACTIONS(3823),
    [anon_sym_LT_EQ_GT] = ACTIONS(3823),
    [anon_sym_cmp] = ACTIONS(3823),
    [anon_sym_TILDE_TILDE] = ACTIONS(3823),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3823),
    [anon_sym_lt] = ACTIONS(3823),
    [anon_sym_le] = ACTIONS(3823),
    [anon_sym_ge] = ACTIONS(3823),
    [anon_sym_gt] = ACTIONS(3823),
    [anon_sym_isa] = ACTIONS(3823),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_EQ_GT] = ACTIONS(3823),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1632] = {
    [sym_attribute] = STATE(1676),
    [sym_attribute_name] = STATE(1648),
    [sym_heredoc_content] = STATE(1632),
    [aux_sym_attrlist_repeat1] = STATE(1625),
    [sym__identifier] = ACTIONS(4494),
    [anon_sym_COLON] = ACTIONS(3418),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3416),
    [anon_sym_DASH_GT] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(3418),
    [anon_sym_GT] = ACTIONS(3418),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3416),
    [anon_sym_PLUS_EQ] = ACTIONS(3416),
    [anon_sym_DASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_EQ] = ACTIONS(3416),
    [anon_sym_STAR_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_PERCENT_EQ] = ACTIONS(3416),
    [anon_sym_x_EQ] = ACTIONS(3416),
    [anon_sym_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_CARET_EQ] = ACTIONS(3416),
    [anon_sym_LT_LT_EQ] = ACTIONS(3416),
    [anon_sym_GT_GT_EQ] = ACTIONS(3416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_DOT_DOT] = ACTIONS(3418),
    [anon_sym_STAR_STAR] = ACTIONS(3418),
    [anon_sym_PIPE_PIPE] = ACTIONS(3418),
    [anon_sym_SLASH_SLASH] = ACTIONS(3418),
    [anon_sym_AMP_AMP] = ACTIONS(3418),
    [anon_sym_PIPE] = ACTIONS(3418),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_GT_GT2] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_DOT] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3418),
    [anon_sym_SLASH] = ACTIONS(3418),
    [anon_sym_x] = ACTIONS(3418),
    [anon_sym_EQ_TILDE] = ACTIONS(3416),
    [anon_sym_BANG_TILDE] = ACTIONS(3416),
    [anon_sym_EQ_EQ] = ACTIONS(3416),
    [anon_sym_BANG_EQ] = ACTIONS(3416),
    [anon_sym_eq] = ACTIONS(3418),
    [anon_sym_ne] = ACTIONS(3418),
    [anon_sym_LT_EQ_GT] = ACTIONS(3416),
    [anon_sym_cmp] = ACTIONS(3418),
    [anon_sym_TILDE_TILDE] = ACTIONS(3416),
    [anon_sym_LT_EQ] = ACTIONS(3418),
    [anon_sym_GT_EQ] = ACTIONS(3416),
    [anon_sym_lt] = ACTIONS(3418),
    [anon_sym_le] = ACTIONS(3418),
    [anon_sym_ge] = ACTIONS(3418),
    [anon_sym_gt] = ACTIONS(3418),
    [anon_sym_isa] = ACTIONS(3418),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3416),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(4494),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1633] = {
    [sym_heredoc_content] = STATE(1633),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3885),
    [anon_sym_RPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_RBRACK] = ACTIONS(3885),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3885),
    [anon_sym_PLUS_EQ] = ACTIONS(3885),
    [anon_sym_DASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_EQ] = ACTIONS(3885),
    [anon_sym_STAR_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_PERCENT_EQ] = ACTIONS(3885),
    [anon_sym_x_EQ] = ACTIONS(3885),
    [anon_sym_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_CARET_EQ] = ACTIONS(3885),
    [anon_sym_LT_LT_EQ] = ACTIONS(3885),
    [anon_sym_GT_GT_EQ] = ACTIONS(3885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3885),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3885),
    [anon_sym_DOT_DOT] = ACTIONS(3887),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3887),
    [anon_sym_SLASH_SLASH] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_eq] = ACTIONS(3885),
    [anon_sym_ne] = ACTIONS(3885),
    [anon_sym_LT_EQ_GT] = ACTIONS(3885),
    [anon_sym_cmp] = ACTIONS(3885),
    [anon_sym_TILDE_TILDE] = ACTIONS(3885),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_EQ_GT] = ACTIONS(3885),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1634] = {
    [sym_heredoc_content] = STATE(1634),
    [anon_sym_RBRACE] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3831),
    [anon_sym_RBRACK] = ACTIONS(3831),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(3833),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3831),
    [anon_sym_PLUS_EQ] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_EQ] = ACTIONS(3831),
    [anon_sym_STAR_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3831),
    [anon_sym_x_EQ] = ACTIONS(3831),
    [anon_sym_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3833),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3833),
    [anon_sym_SLASH_SLASH] = ACTIONS(3833),
    [anon_sym_AMP_AMP] = ACTIONS(3833),
    [anon_sym_PIPE] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(3833),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(3831),
    [anon_sym_BANG_EQ] = ACTIONS(3831),
    [anon_sym_eq] = ACTIONS(3831),
    [anon_sym_ne] = ACTIONS(3831),
    [anon_sym_LT_EQ_GT] = ACTIONS(3831),
    [anon_sym_cmp] = ACTIONS(3831),
    [anon_sym_TILDE_TILDE] = ACTIONS(3831),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4513),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(3831),
    [anon_sym_EQ_GT] = ACTIONS(3831),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1635] = {
    [sym_heredoc_content] = STATE(1635),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4441),
    [anon_sym_and] = ACTIONS(4230),
    [anon_sym_or] = ACTIONS(4230),
    [anon_sym_RBRACK] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4447),
    [anon_sym_GT] = ACTIONS(4447),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4451),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_x_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4455),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4459),
    [anon_sym_SLASH_SLASH] = ACTIONS(4459),
    [anon_sym_AMP_AMP] = ACTIONS(4461),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_eq] = ACTIONS(4471),
    [anon_sym_ne] = ACTIONS(4471),
    [anon_sym_LT_EQ_GT] = ACTIONS(4473),
    [anon_sym_cmp] = ACTIONS(4473),
    [anon_sym_TILDE_TILDE] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4447),
    [anon_sym_GT_EQ] = ACTIONS(4475),
    [anon_sym_lt] = ACTIONS(4475),
    [anon_sym_le] = ACTIONS(4475),
    [anon_sym_ge] = ACTIONS(4475),
    [anon_sym_gt] = ACTIONS(4475),
    [anon_sym_isa] = ACTIONS(4477),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4481),
    [anon_sym_EQ_GT] = ACTIONS(4230),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1636] = {
    [sym_heredoc_content] = STATE(1636),
    [anon_sym_RBRACE] = ACTIONS(4088),
    [anon_sym_SEMI] = ACTIONS(4088),
    [anon_sym_RPAREN] = ACTIONS(4088),
    [anon_sym_COMMA] = ACTIONS(4088),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4088),
    [anon_sym_and] = ACTIONS(4088),
    [anon_sym_or] = ACTIONS(4088),
    [anon_sym_RBRACK] = ACTIONS(4088),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4090),
    [anon_sym_GT] = ACTIONS(4090),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4090),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4088),
    [anon_sym_PLUS_EQ] = ACTIONS(4088),
    [anon_sym_DASH_EQ] = ACTIONS(4088),
    [anon_sym_DOT_EQ] = ACTIONS(4088),
    [anon_sym_STAR_EQ] = ACTIONS(4088),
    [anon_sym_SLASH_EQ] = ACTIONS(4088),
    [anon_sym_PERCENT_EQ] = ACTIONS(4088),
    [anon_sym_x_EQ] = ACTIONS(4088),
    [anon_sym_AMP_EQ] = ACTIONS(4088),
    [anon_sym_PIPE_EQ] = ACTIONS(4088),
    [anon_sym_CARET_EQ] = ACTIONS(4088),
    [anon_sym_LT_LT_EQ] = ACTIONS(4088),
    [anon_sym_GT_GT_EQ] = ACTIONS(4088),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4088),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4088),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4090),
    [anon_sym_SLASH_SLASH] = ACTIONS(4090),
    [anon_sym_AMP_AMP] = ACTIONS(4090),
    [anon_sym_PIPE] = ACTIONS(4090),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4088),
    [anon_sym_BANG_EQ] = ACTIONS(4088),
    [anon_sym_eq] = ACTIONS(4088),
    [anon_sym_ne] = ACTIONS(4088),
    [anon_sym_LT_EQ_GT] = ACTIONS(4088),
    [anon_sym_cmp] = ACTIONS(4088),
    [anon_sym_TILDE_TILDE] = ACTIONS(4088),
    [anon_sym_LT_EQ] = ACTIONS(4090),
    [anon_sym_GT_EQ] = ACTIONS(4088),
    [anon_sym_lt] = ACTIONS(4088),
    [anon_sym_le] = ACTIONS(4088),
    [anon_sym_ge] = ACTIONS(4088),
    [anon_sym_gt] = ACTIONS(4088),
    [anon_sym_isa] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_EQ_GT] = ACTIONS(4088),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1637] = {
    [sym__PERLY_BRACE_OPEN] = STATE(263),
    [sym_block] = STATE(1837),
    [sym_heredoc_content] = STATE(1637),
    [anon_sym_LBRACE2] = ACTIONS(3424),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1638] = {
    [sym_heredoc_content] = STATE(1638),
    [anon_sym_RBRACE] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_RPAREN] = ACTIONS(4066),
    [anon_sym_COMMA] = ACTIONS(4066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4066),
    [anon_sym_and] = ACTIONS(4066),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_RBRACK] = ACTIONS(4066),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(4068),
    [anon_sym_GT] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4066),
    [anon_sym_DASH_EQ] = ACTIONS(4066),
    [anon_sym_DOT_EQ] = ACTIONS(4066),
    [anon_sym_STAR_EQ] = ACTIONS(4066),
    [anon_sym_SLASH_EQ] = ACTIONS(4066),
    [anon_sym_PERCENT_EQ] = ACTIONS(4066),
    [anon_sym_x_EQ] = ACTIONS(4066),
    [anon_sym_AMP_EQ] = ACTIONS(4066),
    [anon_sym_PIPE_EQ] = ACTIONS(4066),
    [anon_sym_CARET_EQ] = ACTIONS(4066),
    [anon_sym_LT_LT_EQ] = ACTIONS(4066),
    [anon_sym_GT_GT_EQ] = ACTIONS(4066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4066),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4066),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_SLASH_SLASH] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4068),
    [anon_sym_GT_GT2] = ACTIONS(4449),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_x] = ACTIONS(4445),
    [anon_sym_EQ_TILDE] = ACTIONS(4469),
    [anon_sym_BANG_TILDE] = ACTIONS(4469),
    [anon_sym_EQ_EQ] = ACTIONS(4066),
    [anon_sym_BANG_EQ] = ACTIONS(4066),
    [anon_sym_eq] = ACTIONS(4066),
    [anon_sym_ne] = ACTIONS(4066),
    [anon_sym_LT_EQ_GT] = ACTIONS(4066),
    [anon_sym_cmp] = ACTIONS(4066),
    [anon_sym_TILDE_TILDE] = ACTIONS(4066),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4066),
    [anon_sym_lt] = ACTIONS(4066),
    [anon_sym_le] = ACTIONS(4066),
    [anon_sym_ge] = ACTIONS(4066),
    [anon_sym_gt] = ACTIONS(4066),
    [anon_sym_isa] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4479),
    [anon_sym_DASH_DASH] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4066),
    [sym_comment] = ACTIONS(5),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1639] = {
    [sym_heredoc_content] = STATE(1639),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_COLON] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_DASH_GT] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2911),
    [anon_sym_DASH_EQ] = ACTIONS(2911),
    [anon_sym_DOT_EQ] = ACTIONS(2911),
    [anon_sym_STAR_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_PERCENT_EQ] = ACTIONS(2911),
    [anon_sym_x_EQ] = ACTIONS(2911),
    [anon_sym_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_CARET_EQ] = ACTIONS(2911),
    [anon_sym_LT_LT_EQ] = ACTIONS(2911),
    [anon_sym_GT_GT_EQ] = ACTIONS(2911),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_GT_GT2] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_x] = ACTIONS(2909),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2911),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_eq] = ACTIONS(2911),
    [anon_sym_ne] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_cmp] = ACTIONS(2911),
    [anon_sym_TILDE_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_lt] = ACTIONS(2911),
    [anon_sym_le] = ACTIONS(2911),
    [anon_sym_ge] = ACTIONS(2911),
    [anon_sym_gt] = ACTIONS(2911),
    [anon_sym_isa] = ACTIONS(2911),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_EQ_GT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2911),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1640] = {
    [sym_heredoc_content] = STATE(1640),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__apostrophe] = ACTIONS(4515),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(4517),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1641] = {
    [sym_heredoc_content] = STATE(1641),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_DASH_GT] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2907),
    [anon_sym_PLUS_EQ] = ACTIONS(2907),
    [anon_sym_DASH_EQ] = ACTIONS(2907),
    [anon_sym_DOT_EQ] = ACTIONS(2907),
    [anon_sym_STAR_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_PERCENT_EQ] = ACTIONS(2907),
    [anon_sym_x_EQ] = ACTIONS(2907),
    [anon_sym_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_CARET_EQ] = ACTIONS(2907),
    [anon_sym_LT_LT_EQ] = ACTIONS(2907),
    [anon_sym_GT_GT_EQ] = ACTIONS(2907),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_STAR_STAR] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_GT_GT2] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_DOT] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_x] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2907),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_eq] = ACTIONS(2907),
    [anon_sym_ne] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_cmp] = ACTIONS(2907),
    [anon_sym_TILDE_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_lt] = ACTIONS(2907),
    [anon_sym_le] = ACTIONS(2907),
    [anon_sym_ge] = ACTIONS(2907),
    [anon_sym_gt] = ACTIONS(2907),
    [anon_sym_isa] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_EQ_GT] = ACTIONS(2907),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2907),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1642] = {
    [sym_heredoc_content] = STATE(1642),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__apostrophe] = ACTIONS(4519),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(4521),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1643] = {
    [sym_heredoc_content] = STATE(1643),
    [sym__identifier] = ACTIONS(3520),
    [anon_sym_COLON] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_COMMA] = ACTIONS(3522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3522),
    [anon_sym_DASH_GT] = ACTIONS(3522),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3520),
    [anon_sym_GT] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3522),
    [anon_sym_PLUS_EQ] = ACTIONS(3522),
    [anon_sym_DASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_EQ] = ACTIONS(3522),
    [anon_sym_STAR_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_PERCENT_EQ] = ACTIONS(3522),
    [anon_sym_x_EQ] = ACTIONS(3522),
    [anon_sym_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_CARET_EQ] = ACTIONS(3522),
    [anon_sym_LT_LT_EQ] = ACTIONS(3522),
    [anon_sym_GT_GT_EQ] = ACTIONS(3522),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_DOT] = ACTIONS(3520),
    [anon_sym_STAR_STAR] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_SLASH_SLASH] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_GT_GT2] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3520),
    [anon_sym_x] = ACTIONS(3520),
    [anon_sym_EQ_TILDE] = ACTIONS(3522),
    [anon_sym_BANG_TILDE] = ACTIONS(3522),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_eq] = ACTIONS(3520),
    [anon_sym_ne] = ACTIONS(3520),
    [anon_sym_LT_EQ_GT] = ACTIONS(3522),
    [anon_sym_cmp] = ACTIONS(3520),
    [anon_sym_TILDE_TILDE] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3520),
    [anon_sym_GT_EQ] = ACTIONS(3522),
    [anon_sym_lt] = ACTIONS(3520),
    [anon_sym_le] = ACTIONS(3520),
    [anon_sym_ge] = ACTIONS(3520),
    [anon_sym_gt] = ACTIONS(3520),
    [anon_sym_isa] = ACTIONS(3520),
    [anon_sym_PLUS_PLUS] = ACTIONS(3522),
    [anon_sym_DASH_DASH] = ACTIONS(3522),
    [anon_sym_QMARK] = ACTIONS(3522),
    [anon_sym_EQ_GT] = ACTIONS(3522),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3520),
    [sym__PERLY_SEMICOLON] = ACTIONS(3522),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1644] = {
    [sym_heredoc_content] = STATE(1644),
    [anon_sym_LBRACE] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_DASH_GT] = ACTIONS(3488),
    [anon_sym_PERCENT] = ACTIONS(3490),
    [anon_sym_LT] = ACTIONS(3490),
    [anon_sym_GT] = ACTIONS(3490),
    [anon_sym_LT_LT] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(3490),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3488),
    [anon_sym_PLUS_EQ] = ACTIONS(3488),
    [anon_sym_DASH_EQ] = ACTIONS(3488),
    [anon_sym_DOT_EQ] = ACTIONS(3488),
    [anon_sym_STAR_EQ] = ACTIONS(3488),
    [anon_sym_SLASH_EQ] = ACTIONS(3488),
    [anon_sym_PERCENT_EQ] = ACTIONS(3488),
    [anon_sym_x_EQ] = ACTIONS(3488),
    [anon_sym_AMP_EQ] = ACTIONS(3488),
    [anon_sym_PIPE_EQ] = ACTIONS(3488),
    [anon_sym_CARET_EQ] = ACTIONS(3488),
    [anon_sym_LT_LT_EQ] = ACTIONS(3488),
    [anon_sym_GT_GT_EQ] = ACTIONS(3488),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3488),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3488),
    [anon_sym_DOT_DOT] = ACTIONS(3490),
    [anon_sym_STAR_STAR] = ACTIONS(3490),
    [anon_sym_PIPE_PIPE] = ACTIONS(3490),
    [anon_sym_SLASH_SLASH] = ACTIONS(3490),
    [anon_sym_AMP_AMP] = ACTIONS(3490),
    [anon_sym_PIPE] = ACTIONS(3490),
    [anon_sym_AMP] = ACTIONS(3490),
    [anon_sym_GT_GT2] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3490),
    [anon_sym_DASH] = ACTIONS(3490),
    [anon_sym_DOT] = ACTIONS(3490),
    [anon_sym_STAR] = ACTIONS(3490),
    [anon_sym_SLASH] = ACTIONS(3490),
    [anon_sym_x] = ACTIONS(3490),
    [anon_sym_EQ_TILDE] = ACTIONS(3488),
    [anon_sym_BANG_TILDE] = ACTIONS(3488),
    [anon_sym_EQ_EQ] = ACTIONS(3488),
    [anon_sym_BANG_EQ] = ACTIONS(3488),
    [anon_sym_eq] = ACTIONS(3488),
    [anon_sym_ne] = ACTIONS(3488),
    [anon_sym_LT_EQ_GT] = ACTIONS(3488),
    [anon_sym_cmp] = ACTIONS(3488),
    [anon_sym_TILDE_TILDE] = ACTIONS(3488),
    [anon_sym_LT_EQ] = ACTIONS(3490),
    [anon_sym_GT_EQ] = ACTIONS(3488),
    [anon_sym_lt] = ACTIONS(3488),
    [anon_sym_le] = ACTIONS(3488),
    [anon_sym_ge] = ACTIONS(3488),
    [anon_sym_gt] = ACTIONS(3488),
    [anon_sym_isa] = ACTIONS(3488),
    [anon_sym_PLUS_PLUS] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_EQ_GT] = ACTIONS(3488),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3488),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1645] = {
    [sym_heredoc_content] = STATE(1645),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3492),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3492),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3494),
    [anon_sym_GT] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3492),
    [anon_sym_PLUS_EQ] = ACTIONS(3492),
    [anon_sym_DASH_EQ] = ACTIONS(3492),
    [anon_sym_DOT_EQ] = ACTIONS(3492),
    [anon_sym_STAR_EQ] = ACTIONS(3492),
    [anon_sym_SLASH_EQ] = ACTIONS(3492),
    [anon_sym_PERCENT_EQ] = ACTIONS(3492),
    [anon_sym_x_EQ] = ACTIONS(3492),
    [anon_sym_AMP_EQ] = ACTIONS(3492),
    [anon_sym_PIPE_EQ] = ACTIONS(3492),
    [anon_sym_CARET_EQ] = ACTIONS(3492),
    [anon_sym_LT_LT_EQ] = ACTIONS(3492),
    [anon_sym_GT_GT_EQ] = ACTIONS(3492),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3492),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3492),
    [anon_sym_DOT_DOT] = ACTIONS(3494),
    [anon_sym_STAR_STAR] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_SLASH_SLASH] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_PIPE] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_GT_GT2] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_SLASH] = ACTIONS(3494),
    [anon_sym_x] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3492),
    [anon_sym_BANG_TILDE] = ACTIONS(3492),
    [anon_sym_EQ_EQ] = ACTIONS(3492),
    [anon_sym_BANG_EQ] = ACTIONS(3492),
    [anon_sym_eq] = ACTIONS(3492),
    [anon_sym_ne] = ACTIONS(3492),
    [anon_sym_LT_EQ_GT] = ACTIONS(3492),
    [anon_sym_cmp] = ACTIONS(3492),
    [anon_sym_TILDE_TILDE] = ACTIONS(3492),
    [anon_sym_LT_EQ] = ACTIONS(3494),
    [anon_sym_GT_EQ] = ACTIONS(3492),
    [anon_sym_lt] = ACTIONS(3492),
    [anon_sym_le] = ACTIONS(3492),
    [anon_sym_ge] = ACTIONS(3492),
    [anon_sym_gt] = ACTIONS(3492),
    [anon_sym_isa] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_QMARK] = ACTIONS(3492),
    [anon_sym_EQ_GT] = ACTIONS(3492),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3492),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1646] = {
    [sym_heredoc_content] = STATE(1646),
    [anon_sym_LBRACE] = ACTIONS(3524),
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(3524),
    [anon_sym_COMMA] = ACTIONS(3524),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3524),
    [anon_sym_LBRACK] = ACTIONS(3524),
    [anon_sym_DASH_GT] = ACTIONS(3524),
    [anon_sym_PERCENT] = ACTIONS(3526),
    [anon_sym_LT] = ACTIONS(3526),
    [anon_sym_GT] = ACTIONS(3526),
    [anon_sym_LT_LT] = ACTIONS(3526),
    [anon_sym_EQ] = ACTIONS(3526),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3524),
    [anon_sym_PLUS_EQ] = ACTIONS(3524),
    [anon_sym_DASH_EQ] = ACTIONS(3524),
    [anon_sym_DOT_EQ] = ACTIONS(3524),
    [anon_sym_STAR_EQ] = ACTIONS(3524),
    [anon_sym_SLASH_EQ] = ACTIONS(3524),
    [anon_sym_PERCENT_EQ] = ACTIONS(3524),
    [anon_sym_x_EQ] = ACTIONS(3524),
    [anon_sym_AMP_EQ] = ACTIONS(3524),
    [anon_sym_PIPE_EQ] = ACTIONS(3524),
    [anon_sym_CARET_EQ] = ACTIONS(3524),
    [anon_sym_LT_LT_EQ] = ACTIONS(3524),
    [anon_sym_GT_GT_EQ] = ACTIONS(3524),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3524),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3524),
    [anon_sym_DOT_DOT] = ACTIONS(3526),
    [anon_sym_STAR_STAR] = ACTIONS(3526),
    [anon_sym_PIPE_PIPE] = ACTIONS(3526),
    [anon_sym_SLASH_SLASH] = ACTIONS(3526),
    [anon_sym_AMP_AMP] = ACTIONS(3526),
    [anon_sym_PIPE] = ACTIONS(3526),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_GT_GT2] = ACTIONS(3526),
    [anon_sym_PLUS] = ACTIONS(3526),
    [anon_sym_DASH] = ACTIONS(3526),
    [anon_sym_DOT] = ACTIONS(3526),
    [anon_sym_STAR] = ACTIONS(3526),
    [anon_sym_SLASH] = ACTIONS(3526),
    [anon_sym_x] = ACTIONS(3526),
    [anon_sym_EQ_TILDE] = ACTIONS(3524),
    [anon_sym_BANG_TILDE] = ACTIONS(3524),
    [anon_sym_EQ_EQ] = ACTIONS(3524),
    [anon_sym_BANG_EQ] = ACTIONS(3524),
    [anon_sym_eq] = ACTIONS(3524),
    [anon_sym_ne] = ACTIONS(3524),
    [anon_sym_LT_EQ_GT] = ACTIONS(3524),
    [anon_sym_cmp] = ACTIONS(3524),
    [anon_sym_TILDE_TILDE] = ACTIONS(3524),
    [anon_sym_LT_EQ] = ACTIONS(3526),
    [anon_sym_GT_EQ] = ACTIONS(3524),
    [anon_sym_lt] = ACTIONS(3524),
    [anon_sym_le] = ACTIONS(3524),
    [anon_sym_ge] = ACTIONS(3524),
    [anon_sym_gt] = ACTIONS(3524),
    [anon_sym_isa] = ACTIONS(3524),
    [anon_sym_PLUS_PLUS] = ACTIONS(3524),
    [anon_sym_DASH_DASH] = ACTIONS(3524),
    [anon_sym_QMARK] = ACTIONS(3524),
    [anon_sym_EQ_GT] = ACTIONS(3524),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3524),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1647] = {
    [sym_heredoc_content] = STATE(1647),
    [anon_sym_LBRACE] = ACTIONS(3512),
    [anon_sym_SEMI] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_COMMA] = ACTIONS(3512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3512),
    [anon_sym_DASH_GT] = ACTIONS(3512),
    [anon_sym_PERCENT] = ACTIONS(3514),
    [anon_sym_LT] = ACTIONS(3514),
    [anon_sym_GT] = ACTIONS(3514),
    [anon_sym_LT_LT] = ACTIONS(3514),
    [anon_sym_EQ] = ACTIONS(3514),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_DOT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_x_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_DOT_DOT] = ACTIONS(3514),
    [anon_sym_STAR_STAR] = ACTIONS(3514),
    [anon_sym_PIPE_PIPE] = ACTIONS(3514),
    [anon_sym_SLASH_SLASH] = ACTIONS(3514),
    [anon_sym_AMP_AMP] = ACTIONS(3514),
    [anon_sym_PIPE] = ACTIONS(3514),
    [anon_sym_AMP] = ACTIONS(3514),
    [anon_sym_GT_GT2] = ACTIONS(3514),
    [anon_sym_PLUS] = ACTIONS(3514),
    [anon_sym_DASH] = ACTIONS(3514),
    [anon_sym_DOT] = ACTIONS(3514),
    [anon_sym_STAR] = ACTIONS(3514),
    [anon_sym_SLASH] = ACTIONS(3514),
    [anon_sym_x] = ACTIONS(3514),
    [anon_sym_EQ_TILDE] = ACTIONS(3512),
    [anon_sym_BANG_TILDE] = ACTIONS(3512),
    [anon_sym_EQ_EQ] = ACTIONS(3512),
    [anon_sym_BANG_EQ] = ACTIONS(3512),
    [anon_sym_eq] = ACTIONS(3512),
    [anon_sym_ne] = ACTIONS(3512),
    [anon_sym_LT_EQ_GT] = ACTIONS(3512),
    [anon_sym_cmp] = ACTIONS(3512),
    [anon_sym_TILDE_TILDE] = ACTIONS(3512),
    [anon_sym_LT_EQ] = ACTIONS(3514),
    [anon_sym_GT_EQ] = ACTIONS(3512),
    [anon_sym_lt] = ACTIONS(3512),
    [anon_sym_le] = ACTIONS(3512),
    [anon_sym_ge] = ACTIONS(3512),
    [anon_sym_gt] = ACTIONS(3512),
    [anon_sym_isa] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3512),
    [anon_sym_DASH_DASH] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(3512),
    [anon_sym_EQ_GT] = ACTIONS(3512),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3512),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1648] = {
    [sym_heredoc_content] = STATE(1648),
    [sym__identifier] = ACTIONS(3446),
    [anon_sym_COLON] = ACTIONS(3446),
    [anon_sym_RPAREN] = ACTIONS(3448),
    [anon_sym_COMMA] = ACTIONS(3448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3448),
    [anon_sym_DASH_GT] = ACTIONS(3448),
    [anon_sym_PERCENT] = ACTIONS(3446),
    [anon_sym_LT] = ACTIONS(3446),
    [anon_sym_GT] = ACTIONS(3446),
    [anon_sym_LT_LT] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(3446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_x_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_DOT_DOT] = ACTIONS(3446),
    [anon_sym_STAR_STAR] = ACTIONS(3446),
    [anon_sym_PIPE_PIPE] = ACTIONS(3446),
    [anon_sym_SLASH_SLASH] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_PIPE] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_GT_GT2] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3446),
    [anon_sym_DOT] = ACTIONS(3446),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_SLASH] = ACTIONS(3446),
    [anon_sym_x] = ACTIONS(3446),
    [anon_sym_EQ_TILDE] = ACTIONS(3448),
    [anon_sym_BANG_TILDE] = ACTIONS(3448),
    [anon_sym_EQ_EQ] = ACTIONS(3448),
    [anon_sym_BANG_EQ] = ACTIONS(3448),
    [anon_sym_eq] = ACTIONS(3446),
    [anon_sym_ne] = ACTIONS(3446),
    [anon_sym_LT_EQ_GT] = ACTIONS(3448),
    [anon_sym_cmp] = ACTIONS(3446),
    [anon_sym_TILDE_TILDE] = ACTIONS(3448),
    [anon_sym_LT_EQ] = ACTIONS(3446),
    [anon_sym_GT_EQ] = ACTIONS(3448),
    [anon_sym_lt] = ACTIONS(3446),
    [anon_sym_le] = ACTIONS(3446),
    [anon_sym_ge] = ACTIONS(3446),
    [anon_sym_gt] = ACTIONS(3446),
    [anon_sym_isa] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(3448),
    [anon_sym_EQ_GT] = ACTIONS(3448),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3446),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(4523),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1649] = {
    [sym_heredoc_content] = STATE(1649),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__apostrophe] = ACTIONS(4525),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(4527),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1650] = {
    [sym_heredoc_content] = STATE(1650),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_DASH_GT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2887),
    [anon_sym_PLUS_EQ] = ACTIONS(2887),
    [anon_sym_DASH_EQ] = ACTIONS(2887),
    [anon_sym_DOT_EQ] = ACTIONS(2887),
    [anon_sym_STAR_EQ] = ACTIONS(2887),
    [anon_sym_SLASH_EQ] = ACTIONS(2887),
    [anon_sym_PERCENT_EQ] = ACTIONS(2887),
    [anon_sym_x_EQ] = ACTIONS(2887),
    [anon_sym_AMP_EQ] = ACTIONS(2887),
    [anon_sym_PIPE_EQ] = ACTIONS(2887),
    [anon_sym_CARET_EQ] = ACTIONS(2887),
    [anon_sym_LT_LT_EQ] = ACTIONS(2887),
    [anon_sym_GT_GT_EQ] = ACTIONS(2887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2887),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2887),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_GT_GT2] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_x] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2887),
    [anon_sym_BANG_TILDE] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_eq] = ACTIONS(2887),
    [anon_sym_ne] = ACTIONS(2887),
    [anon_sym_LT_EQ_GT] = ACTIONS(2887),
    [anon_sym_cmp] = ACTIONS(2887),
    [anon_sym_TILDE_TILDE] = ACTIONS(2887),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2887),
    [anon_sym_lt] = ACTIONS(2887),
    [anon_sym_le] = ACTIONS(2887),
    [anon_sym_ge] = ACTIONS(2887),
    [anon_sym_gt] = ACTIONS(2887),
    [anon_sym_isa] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_EQ_GT] = ACTIONS(2887),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2887),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1651] = {
    [sym_heredoc_content] = STATE(1651),
    [sym__identifier] = ACTIONS(3500),
    [anon_sym_COLON] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3502),
    [anon_sym_DASH_GT] = ACTIONS(3502),
    [anon_sym_PERCENT] = ACTIONS(3500),
    [anon_sym_LT] = ACTIONS(3500),
    [anon_sym_GT] = ACTIONS(3500),
    [anon_sym_LT_LT] = ACTIONS(3500),
    [anon_sym_EQ] = ACTIONS(3500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3502),
    [anon_sym_PLUS_EQ] = ACTIONS(3502),
    [anon_sym_DASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_EQ] = ACTIONS(3502),
    [anon_sym_STAR_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_PERCENT_EQ] = ACTIONS(3502),
    [anon_sym_x_EQ] = ACTIONS(3502),
    [anon_sym_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_CARET_EQ] = ACTIONS(3502),
    [anon_sym_LT_LT_EQ] = ACTIONS(3502),
    [anon_sym_GT_GT_EQ] = ACTIONS(3502),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_DOT] = ACTIONS(3500),
    [anon_sym_STAR_STAR] = ACTIONS(3500),
    [anon_sym_PIPE_PIPE] = ACTIONS(3500),
    [anon_sym_SLASH_SLASH] = ACTIONS(3500),
    [anon_sym_AMP_AMP] = ACTIONS(3500),
    [anon_sym_PIPE] = ACTIONS(3500),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_GT_GT2] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_DOT] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3500),
    [anon_sym_SLASH] = ACTIONS(3500),
    [anon_sym_x] = ACTIONS(3500),
    [anon_sym_EQ_TILDE] = ACTIONS(3502),
    [anon_sym_BANG_TILDE] = ACTIONS(3502),
    [anon_sym_EQ_EQ] = ACTIONS(3502),
    [anon_sym_BANG_EQ] = ACTIONS(3502),
    [anon_sym_eq] = ACTIONS(3500),
    [anon_sym_ne] = ACTIONS(3500),
    [anon_sym_LT_EQ_GT] = ACTIONS(3502),
    [anon_sym_cmp] = ACTIONS(3500),
    [anon_sym_TILDE_TILDE] = ACTIONS(3502),
    [anon_sym_LT_EQ] = ACTIONS(3500),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [anon_sym_lt] = ACTIONS(3500),
    [anon_sym_le] = ACTIONS(3500),
    [anon_sym_ge] = ACTIONS(3500),
    [anon_sym_gt] = ACTIONS(3500),
    [anon_sym_isa] = ACTIONS(3500),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3502),
    [anon_sym_EQ_GT] = ACTIONS(3502),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3500),
    [sym__PERLY_SEMICOLON] = ACTIONS(3502),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1652] = {
    [sym_heredoc_content] = STATE(1652),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_COMMA] = ACTIONS(2899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_DASH_GT] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2899),
    [anon_sym_PLUS_EQ] = ACTIONS(2899),
    [anon_sym_DASH_EQ] = ACTIONS(2899),
    [anon_sym_DOT_EQ] = ACTIONS(2899),
    [anon_sym_STAR_EQ] = ACTIONS(2899),
    [anon_sym_SLASH_EQ] = ACTIONS(2899),
    [anon_sym_PERCENT_EQ] = ACTIONS(2899),
    [anon_sym_x_EQ] = ACTIONS(2899),
    [anon_sym_AMP_EQ] = ACTIONS(2899),
    [anon_sym_PIPE_EQ] = ACTIONS(2899),
    [anon_sym_CARET_EQ] = ACTIONS(2899),
    [anon_sym_LT_LT_EQ] = ACTIONS(2899),
    [anon_sym_GT_GT_EQ] = ACTIONS(2899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2899),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2899),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_GT_GT2] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_x] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2899),
    [anon_sym_BANG_TILDE] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2899),
    [anon_sym_BANG_EQ] = ACTIONS(2899),
    [anon_sym_eq] = ACTIONS(2899),
    [anon_sym_ne] = ACTIONS(2899),
    [anon_sym_LT_EQ_GT] = ACTIONS(2899),
    [anon_sym_cmp] = ACTIONS(2899),
    [anon_sym_TILDE_TILDE] = ACTIONS(2899),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2899),
    [anon_sym_lt] = ACTIONS(2899),
    [anon_sym_le] = ACTIONS(2899),
    [anon_sym_ge] = ACTIONS(2899),
    [anon_sym_gt] = ACTIONS(2899),
    [anon_sym_isa] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_QMARK] = ACTIONS(2899),
    [anon_sym_EQ_GT] = ACTIONS(2899),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2899),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1653] = {
    [sym_heredoc_content] = STATE(1653),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_DOT_EQ] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_x_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2893),
    [anon_sym_STAR_STAR] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_GT_GT2] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_x] = ACTIONS(2893),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_eq] = ACTIONS(2895),
    [anon_sym_ne] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_cmp] = ACTIONS(2895),
    [anon_sym_TILDE_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_lt] = ACTIONS(2895),
    [anon_sym_le] = ACTIONS(2895),
    [anon_sym_ge] = ACTIONS(2895),
    [anon_sym_gt] = ACTIONS(2895),
    [anon_sym_isa] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2895),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1654] = {
    [sym_heredoc_content] = STATE(1654),
    [sym__identifier] = ACTIONS(3442),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_RPAREN] = ACTIONS(3444),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3444),
    [anon_sym_DASH_GT] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3444),
    [anon_sym_PLUS_EQ] = ACTIONS(3444),
    [anon_sym_DASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_EQ] = ACTIONS(3444),
    [anon_sym_STAR_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_PERCENT_EQ] = ACTIONS(3444),
    [anon_sym_x_EQ] = ACTIONS(3444),
    [anon_sym_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_CARET_EQ] = ACTIONS(3444),
    [anon_sym_LT_LT_EQ] = ACTIONS(3444),
    [anon_sym_GT_GT_EQ] = ACTIONS(3444),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3444),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_SLASH_SLASH] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_GT_GT2] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_x] = ACTIONS(3442),
    [anon_sym_EQ_TILDE] = ACTIONS(3444),
    [anon_sym_BANG_TILDE] = ACTIONS(3444),
    [anon_sym_EQ_EQ] = ACTIONS(3444),
    [anon_sym_BANG_EQ] = ACTIONS(3444),
    [anon_sym_eq] = ACTIONS(3442),
    [anon_sym_ne] = ACTIONS(3442),
    [anon_sym_LT_EQ_GT] = ACTIONS(3444),
    [anon_sym_cmp] = ACTIONS(3442),
    [anon_sym_TILDE_TILDE] = ACTIONS(3444),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3444),
    [anon_sym_lt] = ACTIONS(3442),
    [anon_sym_le] = ACTIONS(3442),
    [anon_sym_ge] = ACTIONS(3442),
    [anon_sym_gt] = ACTIONS(3442),
    [anon_sym_isa] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_EQ_GT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3442),
    [sym_pod] = ACTIONS(5),
    [sym__attribute_value_begin] = ACTIONS(3444),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1655] = {
    [sym_heredoc_content] = STATE(1655),
    [anon_sym_LBRACE] = ACTIONS(3474),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3474),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_LT] = ACTIONS(3476),
    [anon_sym_GT] = ACTIONS(3476),
    [anon_sym_LT_LT] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3476),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3474),
    [anon_sym_PLUS_EQ] = ACTIONS(3474),
    [anon_sym_DASH_EQ] = ACTIONS(3474),
    [anon_sym_DOT_EQ] = ACTIONS(3474),
    [anon_sym_STAR_EQ] = ACTIONS(3474),
    [anon_sym_SLASH_EQ] = ACTIONS(3474),
    [anon_sym_PERCENT_EQ] = ACTIONS(3474),
    [anon_sym_x_EQ] = ACTIONS(3474),
    [anon_sym_AMP_EQ] = ACTIONS(3474),
    [anon_sym_PIPE_EQ] = ACTIONS(3474),
    [anon_sym_CARET_EQ] = ACTIONS(3474),
    [anon_sym_LT_LT_EQ] = ACTIONS(3474),
    [anon_sym_GT_GT_EQ] = ACTIONS(3474),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3474),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3474),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3474),
    [anon_sym_DOT_DOT] = ACTIONS(3476),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_SLASH_SLASH] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_PIPE] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_GT_GT2] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_x] = ACTIONS(3476),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [anon_sym_EQ_EQ] = ACTIONS(3474),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_eq] = ACTIONS(3474),
    [anon_sym_ne] = ACTIONS(3474),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_cmp] = ACTIONS(3474),
    [anon_sym_TILDE_TILDE] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3476),
    [anon_sym_GT_EQ] = ACTIONS(3474),
    [anon_sym_lt] = ACTIONS(3474),
    [anon_sym_le] = ACTIONS(3474),
    [anon_sym_ge] = ACTIONS(3474),
    [anon_sym_gt] = ACTIONS(3474),
    [anon_sym_isa] = ACTIONS(3474),
    [anon_sym_PLUS_PLUS] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3474),
    [anon_sym_QMARK] = ACTIONS(3474),
    [anon_sym_EQ_GT] = ACTIONS(3474),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3474),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1656] = {
    [sym_heredoc_content] = STATE(1656),
    [anon_sym_LBRACE] = ACTIONS(4529),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(4531),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_EQ] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_x_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2936),
    [anon_sym_BANG_TILDE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_eq] = ACTIONS(2936),
    [anon_sym_ne] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_cmp] = ACTIONS(2936),
    [anon_sym_TILDE_TILDE] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_lt] = ACTIONS(2936),
    [anon_sym_le] = ACTIONS(2936),
    [anon_sym_ge] = ACTIONS(2936),
    [anon_sym_gt] = ACTIONS(2936),
    [anon_sym_isa] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2936),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1657] = {
    [sym_heredoc_content] = STATE(1657),
    [anon_sym_LBRACE] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3478),
    [anon_sym_PLUS_EQ] = ACTIONS(3478),
    [anon_sym_DASH_EQ] = ACTIONS(3478),
    [anon_sym_DOT_EQ] = ACTIONS(3478),
    [anon_sym_STAR_EQ] = ACTIONS(3478),
    [anon_sym_SLASH_EQ] = ACTIONS(3478),
    [anon_sym_PERCENT_EQ] = ACTIONS(3478),
    [anon_sym_x_EQ] = ACTIONS(3478),
    [anon_sym_AMP_EQ] = ACTIONS(3478),
    [anon_sym_PIPE_EQ] = ACTIONS(3478),
    [anon_sym_CARET_EQ] = ACTIONS(3478),
    [anon_sym_LT_LT_EQ] = ACTIONS(3478),
    [anon_sym_GT_GT_EQ] = ACTIONS(3478),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3478),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3478),
    [anon_sym_DOT_DOT] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_SLASH_SLASH] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_GT_GT2] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3480),
    [anon_sym_x] = ACTIONS(3480),
    [anon_sym_EQ_TILDE] = ACTIONS(3478),
    [anon_sym_BANG_TILDE] = ACTIONS(3478),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_eq] = ACTIONS(3478),
    [anon_sym_ne] = ACTIONS(3478),
    [anon_sym_LT_EQ_GT] = ACTIONS(3478),
    [anon_sym_cmp] = ACTIONS(3478),
    [anon_sym_TILDE_TILDE] = ACTIONS(3478),
    [anon_sym_LT_EQ] = ACTIONS(3480),
    [anon_sym_GT_EQ] = ACTIONS(3478),
    [anon_sym_lt] = ACTIONS(3478),
    [anon_sym_le] = ACTIONS(3478),
    [anon_sym_ge] = ACTIONS(3478),
    [anon_sym_gt] = ACTIONS(3478),
    [anon_sym_isa] = ACTIONS(3478),
    [anon_sym_PLUS_PLUS] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3478),
    [anon_sym_EQ_GT] = ACTIONS(3478),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3478),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1658] = {
    [sym_heredoc_content] = STATE(1658),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2917),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_x_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2917),
    [anon_sym_BANG_TILDE] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_eq] = ACTIONS(2917),
    [anon_sym_ne] = ACTIONS(2917),
    [anon_sym_LT_EQ_GT] = ACTIONS(2917),
    [anon_sym_cmp] = ACTIONS(2917),
    [anon_sym_TILDE_TILDE] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_lt] = ACTIONS(2917),
    [anon_sym_le] = ACTIONS(2917),
    [anon_sym_ge] = ACTIONS(2917),
    [anon_sym_gt] = ACTIONS(2917),
    [anon_sym_isa] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1659] = {
    [sym_heredoc_content] = STATE(1659),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_LPAREN] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_DASH_GT] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_LT_LT] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_DOT_EQ] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_x_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_STAR_STAR] = ACTIONS(3506),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_SLASH_SLASH] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_GT_GT2] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_DASH] = ACTIONS(3506),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_STAR] = ACTIONS(3506),
    [anon_sym_SLASH] = ACTIONS(3506),
    [anon_sym_x] = ACTIONS(3506),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3504),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_eq] = ACTIONS(3504),
    [anon_sym_ne] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_cmp] = ACTIONS(3504),
    [anon_sym_TILDE_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_lt] = ACTIONS(3504),
    [anon_sym_le] = ACTIONS(3504),
    [anon_sym_ge] = ACTIONS(3504),
    [anon_sym_gt] = ACTIONS(3504),
    [anon_sym_isa] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3504),
    [anon_sym_DASH_DASH] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_EQ_GT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3504),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1660] = {
    [sym_heredoc_content] = STATE(1660),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_DASH_GT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2891),
    [anon_sym_PLUS_EQ] = ACTIONS(2891),
    [anon_sym_DASH_EQ] = ACTIONS(2891),
    [anon_sym_DOT_EQ] = ACTIONS(2891),
    [anon_sym_STAR_EQ] = ACTIONS(2891),
    [anon_sym_SLASH_EQ] = ACTIONS(2891),
    [anon_sym_PERCENT_EQ] = ACTIONS(2891),
    [anon_sym_x_EQ] = ACTIONS(2891),
    [anon_sym_AMP_EQ] = ACTIONS(2891),
    [anon_sym_PIPE_EQ] = ACTIONS(2891),
    [anon_sym_CARET_EQ] = ACTIONS(2891),
    [anon_sym_LT_LT_EQ] = ACTIONS(2891),
    [anon_sym_GT_GT_EQ] = ACTIONS(2891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2891),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2891),
    [anon_sym_DOT_DOT] = ACTIONS(2889),
    [anon_sym_STAR_STAR] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_GT_GT2] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_x] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2891),
    [anon_sym_BANG_TILDE] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_eq] = ACTIONS(2891),
    [anon_sym_ne] = ACTIONS(2891),
    [anon_sym_LT_EQ_GT] = ACTIONS(2891),
    [anon_sym_cmp] = ACTIONS(2891),
    [anon_sym_TILDE_TILDE] = ACTIONS(2891),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_lt] = ACTIONS(2891),
    [anon_sym_le] = ACTIONS(2891),
    [anon_sym_ge] = ACTIONS(2891),
    [anon_sym_gt] = ACTIONS(2891),
    [anon_sym_isa] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_EQ_GT] = ACTIONS(2891),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2891),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1661] = {
    [sym_heredoc_content] = STATE(1661),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_SEMI] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(3536),
    [anon_sym_COMMA] = ACTIONS(3536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3536),
    [anon_sym_LBRACK] = ACTIONS(3536),
    [anon_sym_DASH_GT] = ACTIONS(3536),
    [anon_sym_PERCENT] = ACTIONS(3538),
    [anon_sym_LT] = ACTIONS(3538),
    [anon_sym_GT] = ACTIONS(3538),
    [anon_sym_LT_LT] = ACTIONS(3538),
    [anon_sym_EQ] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3536),
    [anon_sym_DASH_EQ] = ACTIONS(3536),
    [anon_sym_DOT_EQ] = ACTIONS(3536),
    [anon_sym_STAR_EQ] = ACTIONS(3536),
    [anon_sym_SLASH_EQ] = ACTIONS(3536),
    [anon_sym_PERCENT_EQ] = ACTIONS(3536),
    [anon_sym_x_EQ] = ACTIONS(3536),
    [anon_sym_AMP_EQ] = ACTIONS(3536),
    [anon_sym_PIPE_EQ] = ACTIONS(3536),
    [anon_sym_CARET_EQ] = ACTIONS(3536),
    [anon_sym_LT_LT_EQ] = ACTIONS(3536),
    [anon_sym_GT_GT_EQ] = ACTIONS(3536),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3536),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3536),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3536),
    [anon_sym_DOT_DOT] = ACTIONS(3538),
    [anon_sym_STAR_STAR] = ACTIONS(3538),
    [anon_sym_PIPE_PIPE] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3538),
    [anon_sym_AMP_AMP] = ACTIONS(3538),
    [anon_sym_PIPE] = ACTIONS(3538),
    [anon_sym_AMP] = ACTIONS(3538),
    [anon_sym_GT_GT2] = ACTIONS(3538),
    [anon_sym_PLUS] = ACTIONS(3538),
    [anon_sym_DASH] = ACTIONS(3538),
    [anon_sym_DOT] = ACTIONS(3538),
    [anon_sym_STAR] = ACTIONS(3538),
    [anon_sym_SLASH] = ACTIONS(3538),
    [anon_sym_x] = ACTIONS(3538),
    [anon_sym_EQ_TILDE] = ACTIONS(3536),
    [anon_sym_BANG_TILDE] = ACTIONS(3536),
    [anon_sym_EQ_EQ] = ACTIONS(3536),
    [anon_sym_BANG_EQ] = ACTIONS(3536),
    [anon_sym_eq] = ACTIONS(3536),
    [anon_sym_ne] = ACTIONS(3536),
    [anon_sym_LT_EQ_GT] = ACTIONS(3536),
    [anon_sym_cmp] = ACTIONS(3536),
    [anon_sym_TILDE_TILDE] = ACTIONS(3536),
    [anon_sym_LT_EQ] = ACTIONS(3538),
    [anon_sym_GT_EQ] = ACTIONS(3536),
    [anon_sym_lt] = ACTIONS(3536),
    [anon_sym_le] = ACTIONS(3536),
    [anon_sym_ge] = ACTIONS(3536),
    [anon_sym_gt] = ACTIONS(3536),
    [anon_sym_isa] = ACTIONS(3536),
    [anon_sym_PLUS_PLUS] = ACTIONS(3536),
    [anon_sym_DASH_DASH] = ACTIONS(3536),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_EQ_GT] = ACTIONS(3536),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3536),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1662] = {
    [sym_heredoc_content] = STATE(1662),
    [anon_sym_LBRACE] = ACTIONS(3496),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3496),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3496),
    [anon_sym_LBRACK] = ACTIONS(3496),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_LT] = ACTIONS(3498),
    [anon_sym_GT] = ACTIONS(3498),
    [anon_sym_LT_LT] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3496),
    [anon_sym_PLUS_EQ] = ACTIONS(3496),
    [anon_sym_DASH_EQ] = ACTIONS(3496),
    [anon_sym_DOT_EQ] = ACTIONS(3496),
    [anon_sym_STAR_EQ] = ACTIONS(3496),
    [anon_sym_SLASH_EQ] = ACTIONS(3496),
    [anon_sym_PERCENT_EQ] = ACTIONS(3496),
    [anon_sym_x_EQ] = ACTIONS(3496),
    [anon_sym_AMP_EQ] = ACTIONS(3496),
    [anon_sym_PIPE_EQ] = ACTIONS(3496),
    [anon_sym_CARET_EQ] = ACTIONS(3496),
    [anon_sym_LT_LT_EQ] = ACTIONS(3496),
    [anon_sym_GT_GT_EQ] = ACTIONS(3496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3496),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3496),
    [anon_sym_DOT_DOT] = ACTIONS(3498),
    [anon_sym_STAR_STAR] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_SLASH_SLASH] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_PIPE] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_GT_GT2] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_SLASH] = ACTIONS(3498),
    [anon_sym_x] = ACTIONS(3498),
    [anon_sym_EQ_TILDE] = ACTIONS(3496),
    [anon_sym_BANG_TILDE] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3496),
    [anon_sym_BANG_EQ] = ACTIONS(3496),
    [anon_sym_eq] = ACTIONS(3496),
    [anon_sym_ne] = ACTIONS(3496),
    [anon_sym_LT_EQ_GT] = ACTIONS(3496),
    [anon_sym_cmp] = ACTIONS(3496),
    [anon_sym_TILDE_TILDE] = ACTIONS(3496),
    [anon_sym_LT_EQ] = ACTIONS(3498),
    [anon_sym_GT_EQ] = ACTIONS(3496),
    [anon_sym_lt] = ACTIONS(3496),
    [anon_sym_le] = ACTIONS(3496),
    [anon_sym_ge] = ACTIONS(3496),
    [anon_sym_gt] = ACTIONS(3496),
    [anon_sym_isa] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(3496),
    [anon_sym_QMARK] = ACTIONS(3496),
    [anon_sym_EQ_GT] = ACTIONS(3496),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3496),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1663] = {
    [sym_heredoc_content] = STATE(1663),
    [anon_sym_LBRACE] = ACTIONS(3508),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym_LPAREN] = ACTIONS(3508),
    [anon_sym_COMMA] = ACTIONS(3508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3508),
    [anon_sym_LBRACK] = ACTIONS(3508),
    [anon_sym_DASH_GT] = ACTIONS(3508),
    [anon_sym_PERCENT] = ACTIONS(3510),
    [anon_sym_LT] = ACTIONS(3510),
    [anon_sym_GT] = ACTIONS(3510),
    [anon_sym_LT_LT] = ACTIONS(3510),
    [anon_sym_EQ] = ACTIONS(3510),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3508),
    [anon_sym_PLUS_EQ] = ACTIONS(3508),
    [anon_sym_DASH_EQ] = ACTIONS(3508),
    [anon_sym_DOT_EQ] = ACTIONS(3508),
    [anon_sym_STAR_EQ] = ACTIONS(3508),
    [anon_sym_SLASH_EQ] = ACTIONS(3508),
    [anon_sym_PERCENT_EQ] = ACTIONS(3508),
    [anon_sym_x_EQ] = ACTIONS(3508),
    [anon_sym_AMP_EQ] = ACTIONS(3508),
    [anon_sym_PIPE_EQ] = ACTIONS(3508),
    [anon_sym_CARET_EQ] = ACTIONS(3508),
    [anon_sym_LT_LT_EQ] = ACTIONS(3508),
    [anon_sym_GT_GT_EQ] = ACTIONS(3508),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3508),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3508),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3508),
    [anon_sym_DOT_DOT] = ACTIONS(3510),
    [anon_sym_STAR_STAR] = ACTIONS(3510),
    [anon_sym_PIPE_PIPE] = ACTIONS(3510),
    [anon_sym_SLASH_SLASH] = ACTIONS(3510),
    [anon_sym_AMP_AMP] = ACTIONS(3510),
    [anon_sym_PIPE] = ACTIONS(3510),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_GT_GT2] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3510),
    [anon_sym_DASH] = ACTIONS(3510),
    [anon_sym_DOT] = ACTIONS(3510),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_x] = ACTIONS(3510),
    [anon_sym_EQ_TILDE] = ACTIONS(3508),
    [anon_sym_BANG_TILDE] = ACTIONS(3508),
    [anon_sym_EQ_EQ] = ACTIONS(3508),
    [anon_sym_BANG_EQ] = ACTIONS(3508),
    [anon_sym_eq] = ACTIONS(3508),
    [anon_sym_ne] = ACTIONS(3508),
    [anon_sym_LT_EQ_GT] = ACTIONS(3508),
    [anon_sym_cmp] = ACTIONS(3508),
    [anon_sym_TILDE_TILDE] = ACTIONS(3508),
    [anon_sym_LT_EQ] = ACTIONS(3510),
    [anon_sym_GT_EQ] = ACTIONS(3508),
    [anon_sym_lt] = ACTIONS(3508),
    [anon_sym_le] = ACTIONS(3508),
    [anon_sym_ge] = ACTIONS(3508),
    [anon_sym_gt] = ACTIONS(3508),
    [anon_sym_isa] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3508),
    [anon_sym_DASH_DASH] = ACTIONS(3508),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_EQ_GT] = ACTIONS(3508),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3508),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1664] = {
    [sym_heredoc_content] = STATE(1664),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_DASH_GT] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(2925),
    [anon_sym_DASH_EQ] = ACTIONS(2925),
    [anon_sym_DOT_EQ] = ACTIONS(2925),
    [anon_sym_STAR_EQ] = ACTIONS(2925),
    [anon_sym_SLASH_EQ] = ACTIONS(2925),
    [anon_sym_PERCENT_EQ] = ACTIONS(2925),
    [anon_sym_x_EQ] = ACTIONS(2925),
    [anon_sym_AMP_EQ] = ACTIONS(2925),
    [anon_sym_PIPE_EQ] = ACTIONS(2925),
    [anon_sym_CARET_EQ] = ACTIONS(2925),
    [anon_sym_LT_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_GT_EQ] = ACTIONS(2925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2925),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_SLASH_SLASH] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_GT_GT2] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_x] = ACTIONS(2923),
    [anon_sym_EQ_TILDE] = ACTIONS(2925),
    [anon_sym_BANG_TILDE] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_eq] = ACTIONS(2925),
    [anon_sym_ne] = ACTIONS(2925),
    [anon_sym_LT_EQ_GT] = ACTIONS(2925),
    [anon_sym_cmp] = ACTIONS(2925),
    [anon_sym_TILDE_TILDE] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2925),
    [anon_sym_lt] = ACTIONS(2925),
    [anon_sym_le] = ACTIONS(2925),
    [anon_sym_ge] = ACTIONS(2925),
    [anon_sym_gt] = ACTIONS(2925),
    [anon_sym_isa] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2925),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2925),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1665] = {
    [sym_heredoc_content] = STATE(1665),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3458),
    [anon_sym_DASH_GT] = ACTIONS(3458),
    [anon_sym_PERCENT] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_LT_LT] = ACTIONS(3460),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3458),
    [anon_sym_PLUS_EQ] = ACTIONS(3458),
    [anon_sym_DASH_EQ] = ACTIONS(3458),
    [anon_sym_DOT_EQ] = ACTIONS(3458),
    [anon_sym_STAR_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_PERCENT_EQ] = ACTIONS(3458),
    [anon_sym_x_EQ] = ACTIONS(3458),
    [anon_sym_AMP_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_CARET_EQ] = ACTIONS(3458),
    [anon_sym_LT_LT_EQ] = ACTIONS(3458),
    [anon_sym_GT_GT_EQ] = ACTIONS(3458),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_DOT_DOT] = ACTIONS(3460),
    [anon_sym_STAR_STAR] = ACTIONS(3460),
    [anon_sym_PIPE_PIPE] = ACTIONS(3460),
    [anon_sym_SLASH_SLASH] = ACTIONS(3460),
    [anon_sym_AMP_AMP] = ACTIONS(3460),
    [anon_sym_PIPE] = ACTIONS(3460),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_GT_GT2] = ACTIONS(3460),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_DOT] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_SLASH] = ACTIONS(3460),
    [anon_sym_x] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3458),
    [anon_sym_BANG_TILDE] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3458),
    [anon_sym_BANG_EQ] = ACTIONS(3458),
    [anon_sym_eq] = ACTIONS(3458),
    [anon_sym_ne] = ACTIONS(3458),
    [anon_sym_LT_EQ_GT] = ACTIONS(3458),
    [anon_sym_cmp] = ACTIONS(3458),
    [anon_sym_TILDE_TILDE] = ACTIONS(3458),
    [anon_sym_LT_EQ] = ACTIONS(3460),
    [anon_sym_GT_EQ] = ACTIONS(3458),
    [anon_sym_lt] = ACTIONS(3458),
    [anon_sym_le] = ACTIONS(3458),
    [anon_sym_ge] = ACTIONS(3458),
    [anon_sym_gt] = ACTIONS(3458),
    [anon_sym_isa] = ACTIONS(3458),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3458),
    [anon_sym_EQ_GT] = ACTIONS(3458),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3458),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1666] = {
    [sym_heredoc_content] = STATE(1666),
    [anon_sym_LBRACE] = ACTIONS(3532),
    [anon_sym_SEMI] = ACTIONS(3532),
    [anon_sym_LPAREN] = ACTIONS(3532),
    [anon_sym_COMMA] = ACTIONS(3532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3532),
    [anon_sym_LBRACK] = ACTIONS(3532),
    [anon_sym_DASH_GT] = ACTIONS(3532),
    [anon_sym_PERCENT] = ACTIONS(3534),
    [anon_sym_LT] = ACTIONS(3534),
    [anon_sym_GT] = ACTIONS(3534),
    [anon_sym_LT_LT] = ACTIONS(3534),
    [anon_sym_EQ] = ACTIONS(3534),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3532),
    [anon_sym_PLUS_EQ] = ACTIONS(3532),
    [anon_sym_DASH_EQ] = ACTIONS(3532),
    [anon_sym_DOT_EQ] = ACTIONS(3532),
    [anon_sym_STAR_EQ] = ACTIONS(3532),
    [anon_sym_SLASH_EQ] = ACTIONS(3532),
    [anon_sym_PERCENT_EQ] = ACTIONS(3532),
    [anon_sym_x_EQ] = ACTIONS(3532),
    [anon_sym_AMP_EQ] = ACTIONS(3532),
    [anon_sym_PIPE_EQ] = ACTIONS(3532),
    [anon_sym_CARET_EQ] = ACTIONS(3532),
    [anon_sym_LT_LT_EQ] = ACTIONS(3532),
    [anon_sym_GT_GT_EQ] = ACTIONS(3532),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3532),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3532),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3532),
    [anon_sym_DOT_DOT] = ACTIONS(3534),
    [anon_sym_STAR_STAR] = ACTIONS(3534),
    [anon_sym_PIPE_PIPE] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3534),
    [anon_sym_AMP_AMP] = ACTIONS(3534),
    [anon_sym_PIPE] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(3534),
    [anon_sym_GT_GT2] = ACTIONS(3534),
    [anon_sym_PLUS] = ACTIONS(3534),
    [anon_sym_DASH] = ACTIONS(3534),
    [anon_sym_DOT] = ACTIONS(3534),
    [anon_sym_STAR] = ACTIONS(3534),
    [anon_sym_SLASH] = ACTIONS(3534),
    [anon_sym_x] = ACTIONS(3534),
    [anon_sym_EQ_TILDE] = ACTIONS(3532),
    [anon_sym_BANG_TILDE] = ACTIONS(3532),
    [anon_sym_EQ_EQ] = ACTIONS(3532),
    [anon_sym_BANG_EQ] = ACTIONS(3532),
    [anon_sym_eq] = ACTIONS(3532),
    [anon_sym_ne] = ACTIONS(3532),
    [anon_sym_LT_EQ_GT] = ACTIONS(3532),
    [anon_sym_cmp] = ACTIONS(3532),
    [anon_sym_TILDE_TILDE] = ACTIONS(3532),
    [anon_sym_LT_EQ] = ACTIONS(3534),
    [anon_sym_GT_EQ] = ACTIONS(3532),
    [anon_sym_lt] = ACTIONS(3532),
    [anon_sym_le] = ACTIONS(3532),
    [anon_sym_ge] = ACTIONS(3532),
    [anon_sym_gt] = ACTIONS(3532),
    [anon_sym_isa] = ACTIONS(3532),
    [anon_sym_PLUS_PLUS] = ACTIONS(3532),
    [anon_sym_DASH_DASH] = ACTIONS(3532),
    [anon_sym_QMARK] = ACTIONS(3532),
    [anon_sym_EQ_GT] = ACTIONS(3532),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3532),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1667] = {
    [sym_heredoc_content] = STATE(1667),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_DASH_GT] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(2919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_DOT_EQ] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_x_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2919),
    [anon_sym_STAR_STAR] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_SLASH_SLASH] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_GT_GT2] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2919),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_x] = ACTIONS(2919),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_eq] = ACTIONS(2921),
    [anon_sym_ne] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_cmp] = ACTIONS(2921),
    [anon_sym_TILDE_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_lt] = ACTIONS(2921),
    [anon_sym_le] = ACTIONS(2921),
    [anon_sym_ge] = ACTIONS(2921),
    [anon_sym_gt] = ACTIONS(2921),
    [anon_sym_isa] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2921),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1668] = {
    [sym_heredoc_content] = STATE(1668),
    [anon_sym_LBRACE] = ACTIONS(3516),
    [anon_sym_SEMI] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3516),
    [anon_sym_DASH_GT] = ACTIONS(3516),
    [anon_sym_PERCENT] = ACTIONS(3518),
    [anon_sym_LT] = ACTIONS(3518),
    [anon_sym_GT] = ACTIONS(3518),
    [anon_sym_LT_LT] = ACTIONS(3518),
    [anon_sym_EQ] = ACTIONS(3518),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3516),
    [anon_sym_PLUS_EQ] = ACTIONS(3516),
    [anon_sym_DASH_EQ] = ACTIONS(3516),
    [anon_sym_DOT_EQ] = ACTIONS(3516),
    [anon_sym_STAR_EQ] = ACTIONS(3516),
    [anon_sym_SLASH_EQ] = ACTIONS(3516),
    [anon_sym_PERCENT_EQ] = ACTIONS(3516),
    [anon_sym_x_EQ] = ACTIONS(3516),
    [anon_sym_AMP_EQ] = ACTIONS(3516),
    [anon_sym_PIPE_EQ] = ACTIONS(3516),
    [anon_sym_CARET_EQ] = ACTIONS(3516),
    [anon_sym_LT_LT_EQ] = ACTIONS(3516),
    [anon_sym_GT_GT_EQ] = ACTIONS(3516),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3516),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3516),
    [anon_sym_DOT_DOT] = ACTIONS(3518),
    [anon_sym_STAR_STAR] = ACTIONS(3518),
    [anon_sym_PIPE_PIPE] = ACTIONS(3518),
    [anon_sym_SLASH_SLASH] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3518),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_GT_GT2] = ACTIONS(3518),
    [anon_sym_PLUS] = ACTIONS(3518),
    [anon_sym_DASH] = ACTIONS(3518),
    [anon_sym_DOT] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3518),
    [anon_sym_SLASH] = ACTIONS(3518),
    [anon_sym_x] = ACTIONS(3518),
    [anon_sym_EQ_TILDE] = ACTIONS(3516),
    [anon_sym_BANG_TILDE] = ACTIONS(3516),
    [anon_sym_EQ_EQ] = ACTIONS(3516),
    [anon_sym_BANG_EQ] = ACTIONS(3516),
    [anon_sym_eq] = ACTIONS(3516),
    [anon_sym_ne] = ACTIONS(3516),
    [anon_sym_LT_EQ_GT] = ACTIONS(3516),
    [anon_sym_cmp] = ACTIONS(3516),
    [anon_sym_TILDE_TILDE] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(3518),
    [anon_sym_GT_EQ] = ACTIONS(3516),
    [anon_sym_lt] = ACTIONS(3516),
    [anon_sym_le] = ACTIONS(3516),
    [anon_sym_ge] = ACTIONS(3516),
    [anon_sym_gt] = ACTIONS(3516),
    [anon_sym_isa] = ACTIONS(3516),
    [anon_sym_PLUS_PLUS] = ACTIONS(3516),
    [anon_sym_DASH_DASH] = ACTIONS(3516),
    [anon_sym_QMARK] = ACTIONS(3516),
    [anon_sym_EQ_GT] = ACTIONS(3516),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3516),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1669] = {
    [sym_heredoc_content] = STATE(1669),
    [anon_sym_LBRACE] = ACTIONS(3528),
    [anon_sym_SEMI] = ACTIONS(3528),
    [anon_sym_LPAREN] = ACTIONS(3528),
    [anon_sym_COMMA] = ACTIONS(3528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(3528),
    [anon_sym_DASH_GT] = ACTIONS(3528),
    [anon_sym_PERCENT] = ACTIONS(3530),
    [anon_sym_LT] = ACTIONS(3530),
    [anon_sym_GT] = ACTIONS(3530),
    [anon_sym_LT_LT] = ACTIONS(3530),
    [anon_sym_EQ] = ACTIONS(3530),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3528),
    [anon_sym_PLUS_EQ] = ACTIONS(3528),
    [anon_sym_DASH_EQ] = ACTIONS(3528),
    [anon_sym_DOT_EQ] = ACTIONS(3528),
    [anon_sym_STAR_EQ] = ACTIONS(3528),
    [anon_sym_SLASH_EQ] = ACTIONS(3528),
    [anon_sym_PERCENT_EQ] = ACTIONS(3528),
    [anon_sym_x_EQ] = ACTIONS(3528),
    [anon_sym_AMP_EQ] = ACTIONS(3528),
    [anon_sym_PIPE_EQ] = ACTIONS(3528),
    [anon_sym_CARET_EQ] = ACTIONS(3528),
    [anon_sym_LT_LT_EQ] = ACTIONS(3528),
    [anon_sym_GT_GT_EQ] = ACTIONS(3528),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3528),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3528),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3528),
    [anon_sym_DOT_DOT] = ACTIONS(3530),
    [anon_sym_STAR_STAR] = ACTIONS(3530),
    [anon_sym_PIPE_PIPE] = ACTIONS(3530),
    [anon_sym_SLASH_SLASH] = ACTIONS(3530),
    [anon_sym_AMP_AMP] = ACTIONS(3530),
    [anon_sym_PIPE] = ACTIONS(3530),
    [anon_sym_AMP] = ACTIONS(3530),
    [anon_sym_GT_GT2] = ACTIONS(3530),
    [anon_sym_PLUS] = ACTIONS(3530),
    [anon_sym_DASH] = ACTIONS(3530),
    [anon_sym_DOT] = ACTIONS(3530),
    [anon_sym_STAR] = ACTIONS(3530),
    [anon_sym_SLASH] = ACTIONS(3530),
    [anon_sym_x] = ACTIONS(3530),
    [anon_sym_EQ_TILDE] = ACTIONS(3528),
    [anon_sym_BANG_TILDE] = ACTIONS(3528),
    [anon_sym_EQ_EQ] = ACTIONS(3528),
    [anon_sym_BANG_EQ] = ACTIONS(3528),
    [anon_sym_eq] = ACTIONS(3528),
    [anon_sym_ne] = ACTIONS(3528),
    [anon_sym_LT_EQ_GT] = ACTIONS(3528),
    [anon_sym_cmp] = ACTIONS(3528),
    [anon_sym_TILDE_TILDE] = ACTIONS(3528),
    [anon_sym_LT_EQ] = ACTIONS(3530),
    [anon_sym_GT_EQ] = ACTIONS(3528),
    [anon_sym_lt] = ACTIONS(3528),
    [anon_sym_le] = ACTIONS(3528),
    [anon_sym_ge] = ACTIONS(3528),
    [anon_sym_gt] = ACTIONS(3528),
    [anon_sym_isa] = ACTIONS(3528),
    [anon_sym_PLUS_PLUS] = ACTIONS(3528),
    [anon_sym_DASH_DASH] = ACTIONS(3528),
    [anon_sym_QMARK] = ACTIONS(3528),
    [anon_sym_EQ_GT] = ACTIONS(3528),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3528),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1670] = {
    [sym_heredoc_content] = STATE(1670),
    [sym__identifier] = ACTIONS(3410),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3410),
    [sym__PERLY_SEMICOLON] = ACTIONS(3408),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1671] = {
    [sym_heredoc_content] = STATE(1671),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(4535),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1672] = {
    [sym_heredoc_content] = STATE(1672),
    [anon_sym_LBRACE] = ACTIONS(3552),
    [anon_sym_SEMI] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3552),
    [anon_sym_DASH_GT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_GT] = ACTIONS(3556),
    [anon_sym_LT_LT] = ACTIONS(3556),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3554),
    [anon_sym_PLUS_EQ] = ACTIONS(3554),
    [anon_sym_DASH_EQ] = ACTIONS(3554),
    [anon_sym_DOT_EQ] = ACTIONS(3554),
    [anon_sym_STAR_EQ] = ACTIONS(3554),
    [anon_sym_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_PERCENT_EQ] = ACTIONS(3554),
    [anon_sym_x_EQ] = ACTIONS(3554),
    [anon_sym_AMP_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_CARET_EQ] = ACTIONS(3554),
    [anon_sym_LT_LT_EQ] = ACTIONS(3554),
    [anon_sym_GT_GT_EQ] = ACTIONS(3554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_DOT_DOT] = ACTIONS(3556),
    [anon_sym_STAR_STAR] = ACTIONS(3556),
    [anon_sym_PIPE_PIPE] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH] = ACTIONS(3556),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_PIPE] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym_GT_GT2] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3556),
    [anon_sym_DOT] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_SLASH] = ACTIONS(3556),
    [anon_sym_x] = ACTIONS(3556),
    [anon_sym_EQ_TILDE] = ACTIONS(3554),
    [anon_sym_BANG_TILDE] = ACTIONS(3554),
    [anon_sym_EQ_EQ] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_eq] = ACTIONS(3554),
    [anon_sym_ne] = ACTIONS(3554),
    [anon_sym_LT_EQ_GT] = ACTIONS(3554),
    [anon_sym_cmp] = ACTIONS(3554),
    [anon_sym_TILDE_TILDE] = ACTIONS(3554),
    [anon_sym_LT_EQ] = ACTIONS(3556),
    [anon_sym_GT_EQ] = ACTIONS(3554),
    [anon_sym_lt] = ACTIONS(3554),
    [anon_sym_le] = ACTIONS(3554),
    [anon_sym_ge] = ACTIONS(3554),
    [anon_sym_gt] = ACTIONS(3554),
    [anon_sym_isa] = ACTIONS(3554),
    [anon_sym_PLUS_PLUS] = ACTIONS(3554),
    [anon_sym_DASH_DASH] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_EQ_GT] = ACTIONS(3554),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3554),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1673] = {
    [sym_heredoc_content] = STATE(1673),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(4537),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DASH_GT] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3452),
    [anon_sym_DASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_EQ] = ACTIONS(3452),
    [anon_sym_STAR_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_PERCENT_EQ] = ACTIONS(3452),
    [anon_sym_x_EQ] = ACTIONS(3452),
    [anon_sym_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_CARET_EQ] = ACTIONS(3452),
    [anon_sym_LT_LT_EQ] = ACTIONS(3452),
    [anon_sym_GT_GT_EQ] = ACTIONS(3452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3452),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3452),
    [anon_sym_DOT_DOT] = ACTIONS(3456),
    [anon_sym_STAR_STAR] = ACTIONS(3456),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_SLASH_SLASH] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_GT_GT2] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_x] = ACTIONS(3456),
    [anon_sym_EQ_TILDE] = ACTIONS(3452),
    [anon_sym_BANG_TILDE] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3452),
    [anon_sym_BANG_EQ] = ACTIONS(3452),
    [anon_sym_eq] = ACTIONS(3452),
    [anon_sym_ne] = ACTIONS(3452),
    [anon_sym_LT_EQ_GT] = ACTIONS(3452),
    [anon_sym_cmp] = ACTIONS(3452),
    [anon_sym_TILDE_TILDE] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3456),
    [anon_sym_GT_EQ] = ACTIONS(3452),
    [anon_sym_lt] = ACTIONS(3452),
    [anon_sym_le] = ACTIONS(3452),
    [anon_sym_ge] = ACTIONS(3452),
    [anon_sym_gt] = ACTIONS(3452),
    [anon_sym_isa] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(3452),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3452),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1674] = {
    [sym_heredoc_content] = STATE(1674),
    [anon_sym_LBRACE] = ACTIONS(3544),
    [anon_sym_SEMI] = ACTIONS(3546),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3546),
    [anon_sym_LBRACK] = ACTIONS(3544),
    [anon_sym_DASH_GT] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3548),
    [anon_sym_GT] = ACTIONS(3548),
    [anon_sym_LT_LT] = ACTIONS(3548),
    [anon_sym_EQ] = ACTIONS(3548),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3546),
    [anon_sym_PLUS_EQ] = ACTIONS(3546),
    [anon_sym_DASH_EQ] = ACTIONS(3546),
    [anon_sym_DOT_EQ] = ACTIONS(3546),
    [anon_sym_STAR_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_PERCENT_EQ] = ACTIONS(3546),
    [anon_sym_x_EQ] = ACTIONS(3546),
    [anon_sym_AMP_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_CARET_EQ] = ACTIONS(3546),
    [anon_sym_LT_LT_EQ] = ACTIONS(3546),
    [anon_sym_GT_GT_EQ] = ACTIONS(3546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_DOT_DOT] = ACTIONS(3548),
    [anon_sym_STAR_STAR] = ACTIONS(3548),
    [anon_sym_PIPE_PIPE] = ACTIONS(3548),
    [anon_sym_SLASH_SLASH] = ACTIONS(3548),
    [anon_sym_AMP_AMP] = ACTIONS(3548),
    [anon_sym_PIPE] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_GT_GT2] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_DOT] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_SLASH] = ACTIONS(3548),
    [anon_sym_x] = ACTIONS(3548),
    [anon_sym_EQ_TILDE] = ACTIONS(3546),
    [anon_sym_BANG_TILDE] = ACTIONS(3546),
    [anon_sym_EQ_EQ] = ACTIONS(3546),
    [anon_sym_BANG_EQ] = ACTIONS(3546),
    [anon_sym_eq] = ACTIONS(3546),
    [anon_sym_ne] = ACTIONS(3546),
    [anon_sym_LT_EQ_GT] = ACTIONS(3546),
    [anon_sym_cmp] = ACTIONS(3546),
    [anon_sym_TILDE_TILDE] = ACTIONS(3546),
    [anon_sym_LT_EQ] = ACTIONS(3548),
    [anon_sym_GT_EQ] = ACTIONS(3546),
    [anon_sym_lt] = ACTIONS(3546),
    [anon_sym_le] = ACTIONS(3546),
    [anon_sym_ge] = ACTIONS(3546),
    [anon_sym_gt] = ACTIONS(3546),
    [anon_sym_isa] = ACTIONS(3546),
    [anon_sym_PLUS_PLUS] = ACTIONS(3546),
    [anon_sym_DASH_DASH] = ACTIONS(3546),
    [anon_sym_QMARK] = ACTIONS(3546),
    [anon_sym_EQ_GT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3546),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1675] = {
    [sym_heredoc_content] = STATE(1675),
    [anon_sym_LBRACE] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(3558),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2917),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_x_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_GT_GT2] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_x] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2917),
    [anon_sym_BANG_TILDE] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_eq] = ACTIONS(2917),
    [anon_sym_ne] = ACTIONS(2917),
    [anon_sym_LT_EQ_GT] = ACTIONS(2917),
    [anon_sym_cmp] = ACTIONS(2917),
    [anon_sym_TILDE_TILDE] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_lt] = ACTIONS(2917),
    [anon_sym_le] = ACTIONS(2917),
    [anon_sym_ge] = ACTIONS(2917),
    [anon_sym_gt] = ACTIONS(2917),
    [anon_sym_isa] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2917),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1676] = {
    [sym_heredoc_content] = STATE(1676),
    [sym__identifier] = ACTIONS(3500),
    [anon_sym_COLON] = ACTIONS(3500),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3502),
    [anon_sym_DASH_GT] = ACTIONS(3502),
    [anon_sym_PERCENT] = ACTIONS(3500),
    [anon_sym_LT] = ACTIONS(3500),
    [anon_sym_GT] = ACTIONS(3500),
    [anon_sym_LT_LT] = ACTIONS(3500),
    [anon_sym_EQ] = ACTIONS(3500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3502),
    [anon_sym_PLUS_EQ] = ACTIONS(3502),
    [anon_sym_DASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_EQ] = ACTIONS(3502),
    [anon_sym_STAR_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_PERCENT_EQ] = ACTIONS(3502),
    [anon_sym_x_EQ] = ACTIONS(3502),
    [anon_sym_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_CARET_EQ] = ACTIONS(3502),
    [anon_sym_LT_LT_EQ] = ACTIONS(3502),
    [anon_sym_GT_GT_EQ] = ACTIONS(3502),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_DOT_DOT] = ACTIONS(3500),
    [anon_sym_STAR_STAR] = ACTIONS(3500),
    [anon_sym_PIPE_PIPE] = ACTIONS(3500),
    [anon_sym_SLASH_SLASH] = ACTIONS(3500),
    [anon_sym_AMP_AMP] = ACTIONS(3500),
    [anon_sym_PIPE] = ACTIONS(3500),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_GT_GT2] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_DOT] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3500),
    [anon_sym_SLASH] = ACTIONS(3500),
    [anon_sym_x] = ACTIONS(3500),
    [anon_sym_EQ_TILDE] = ACTIONS(3502),
    [anon_sym_BANG_TILDE] = ACTIONS(3502),
    [anon_sym_EQ_EQ] = ACTIONS(3502),
    [anon_sym_BANG_EQ] = ACTIONS(3502),
    [anon_sym_eq] = ACTIONS(3500),
    [anon_sym_ne] = ACTIONS(3500),
    [anon_sym_LT_EQ_GT] = ACTIONS(3502),
    [anon_sym_cmp] = ACTIONS(3500),
    [anon_sym_TILDE_TILDE] = ACTIONS(3502),
    [anon_sym_LT_EQ] = ACTIONS(3500),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [anon_sym_lt] = ACTIONS(3500),
    [anon_sym_le] = ACTIONS(3500),
    [anon_sym_ge] = ACTIONS(3500),
    [anon_sym_gt] = ACTIONS(3500),
    [anon_sym_isa] = ACTIONS(3500),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3502),
    [anon_sym_EQ_GT] = ACTIONS(3502),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3500),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1677] = {
    [sym_heredoc_content] = STATE(1677),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(4539),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1678] = {
    [sym_heredoc_content] = STATE(1678),
    [sym__identifier] = ACTIONS(3410),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_RPAREN] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3408),
    [anon_sym_DASH_GT] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_LT_LT] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3408),
    [anon_sym_DASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_EQ] = ACTIONS(3408),
    [anon_sym_STAR_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_PERCENT_EQ] = ACTIONS(3408),
    [anon_sym_x_EQ] = ACTIONS(3408),
    [anon_sym_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_CARET_EQ] = ACTIONS(3408),
    [anon_sym_LT_LT_EQ] = ACTIONS(3408),
    [anon_sym_GT_GT_EQ] = ACTIONS(3408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3408),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3408),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_STAR_STAR] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_SLASH_SLASH] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_GT_GT2] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3410),
    [anon_sym_x] = ACTIONS(3410),
    [anon_sym_EQ_TILDE] = ACTIONS(3408),
    [anon_sym_BANG_TILDE] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3408),
    [anon_sym_BANG_EQ] = ACTIONS(3408),
    [anon_sym_eq] = ACTIONS(3410),
    [anon_sym_ne] = ACTIONS(3410),
    [anon_sym_LT_EQ_GT] = ACTIONS(3408),
    [anon_sym_cmp] = ACTIONS(3410),
    [anon_sym_TILDE_TILDE] = ACTIONS(3408),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3408),
    [anon_sym_lt] = ACTIONS(3410),
    [anon_sym_le] = ACTIONS(3410),
    [anon_sym_ge] = ACTIONS(3410),
    [anon_sym_gt] = ACTIONS(3410),
    [anon_sym_isa] = ACTIONS(3410),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3408),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3410),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1679] = {
    [sym_heredoc_content] = STATE(1679),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym__quotelike_begin] = ACTIONS(4541),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1680] = {
    [sym_heredoc_content] = STATE(1680),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(4537),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1681] = {
    [sym_heredoc_content] = STATE(1681),
    [sym__identifier] = ACTIONS(3520),
    [anon_sym_COLON] = ACTIONS(3520),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_COMMA] = ACTIONS(3522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3522),
    [anon_sym_DASH_GT] = ACTIONS(3522),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3520),
    [anon_sym_GT] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3522),
    [anon_sym_PLUS_EQ] = ACTIONS(3522),
    [anon_sym_DASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_EQ] = ACTIONS(3522),
    [anon_sym_STAR_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_PERCENT_EQ] = ACTIONS(3522),
    [anon_sym_x_EQ] = ACTIONS(3522),
    [anon_sym_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_CARET_EQ] = ACTIONS(3522),
    [anon_sym_LT_LT_EQ] = ACTIONS(3522),
    [anon_sym_GT_GT_EQ] = ACTIONS(3522),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_DOT_DOT] = ACTIONS(3520),
    [anon_sym_STAR_STAR] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_SLASH_SLASH] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_GT_GT2] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3520),
    [anon_sym_x] = ACTIONS(3520),
    [anon_sym_EQ_TILDE] = ACTIONS(3522),
    [anon_sym_BANG_TILDE] = ACTIONS(3522),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_eq] = ACTIONS(3520),
    [anon_sym_ne] = ACTIONS(3520),
    [anon_sym_LT_EQ_GT] = ACTIONS(3522),
    [anon_sym_cmp] = ACTIONS(3520),
    [anon_sym_TILDE_TILDE] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3520),
    [anon_sym_GT_EQ] = ACTIONS(3522),
    [anon_sym_lt] = ACTIONS(3520),
    [anon_sym_le] = ACTIONS(3520),
    [anon_sym_ge] = ACTIONS(3520),
    [anon_sym_gt] = ACTIONS(3520),
    [anon_sym_isa] = ACTIONS(3520),
    [anon_sym_PLUS_PLUS] = ACTIONS(3522),
    [anon_sym_DASH_DASH] = ACTIONS(3522),
    [anon_sym_QMARK] = ACTIONS(3522),
    [anon_sym_EQ_GT] = ACTIONS(3522),
    [sym_comment] = ACTIONS(5),
    [aux_sym__bareword_token1] = ACTIONS(3520),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1682] = {
    [sym_heredoc_content] = STATE(1682),
    [anon_sym_SEMI] = ACTIONS(3572),
    [anon_sym_COMMA] = ACTIONS(3572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3572),
    [anon_sym_LBRACK] = ACTIONS(4543),
    [anon_sym_DASH_GT] = ACTIONS(3572),
    [anon_sym_PERCENT] = ACTIONS(3576),
    [anon_sym_LT] = ACTIONS(3576),
    [anon_sym_GT] = ACTIONS(3576),
    [anon_sym_LT_LT] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(3576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3572),
    [anon_sym_PLUS_EQ] = ACTIONS(3572),
    [anon_sym_DASH_EQ] = ACTIONS(3572),
    [anon_sym_DOT_EQ] = ACTIONS(3572),
    [anon_sym_STAR_EQ] = ACTIONS(3572),
    [anon_sym_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_PERCENT_EQ] = ACTIONS(3572),
    [anon_sym_x_EQ] = ACTIONS(3572),
    [anon_sym_AMP_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_CARET_EQ] = ACTIONS(3572),
    [anon_sym_LT_LT_EQ] = ACTIONS(3572),
    [anon_sym_GT_GT_EQ] = ACTIONS(3572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_DOT_DOT] = ACTIONS(3576),
    [anon_sym_STAR_STAR] = ACTIONS(3576),
    [anon_sym_PIPE_PIPE] = ACTIONS(3576),
    [anon_sym_SLASH_SLASH] = ACTIONS(3576),
    [anon_sym_AMP_AMP] = ACTIONS(3576),
    [anon_sym_PIPE] = ACTIONS(3576),
    [anon_sym_AMP] = ACTIONS(3576),
    [anon_sym_GT_GT2] = ACTIONS(3576),
    [anon_sym_PLUS] = ACTIONS(3576),
    [anon_sym_DASH] = ACTIONS(3576),
    [anon_sym_DOT] = ACTIONS(3576),
    [anon_sym_STAR] = ACTIONS(3576),
    [anon_sym_SLASH] = ACTIONS(3576),
    [anon_sym_x] = ACTIONS(3576),
    [anon_sym_EQ_TILDE] = ACTIONS(3572),
    [anon_sym_BANG_TILDE] = ACTIONS(3572),
    [anon_sym_EQ_EQ] = ACTIONS(3572),
    [anon_sym_BANG_EQ] = ACTIONS(3572),
    [anon_sym_eq] = ACTIONS(3572),
    [anon_sym_ne] = ACTIONS(3572),
    [anon_sym_LT_EQ_GT] = ACTIONS(3572),
    [anon_sym_cmp] = ACTIONS(3572),
    [anon_sym_TILDE_TILDE] = ACTIONS(3572),
    [anon_sym_LT_EQ] = ACTIONS(3576),
    [anon_sym_GT_EQ] = ACTIONS(3572),
    [anon_sym_lt] = ACTIONS(3572),
    [anon_sym_le] = ACTIONS(3572),
    [anon_sym_ge] = ACTIONS(3572),
    [anon_sym_gt] = ACTIONS(3572),
    [anon_sym_isa] = ACTIONS(3572),
    [anon_sym_PLUS_PLUS] = ACTIONS(3572),
    [anon_sym_DASH_DASH] = ACTIONS(3572),
    [anon_sym_QMARK] = ACTIONS(3572),
    [anon_sym_EQ_GT] = ACTIONS(3572),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3572),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1683] = {
    [sym_heredoc_content] = STATE(1683),
    [anon_sym_SEMI] = ACTIONS(3735),
    [anon_sym_COMMA] = ACTIONS(3735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3735),
    [anon_sym_DASH_GT] = ACTIONS(3735),
    [anon_sym_PERCENT] = ACTIONS(3737),
    [anon_sym_LT] = ACTIONS(3737),
    [anon_sym_GT] = ACTIONS(3737),
    [anon_sym_LT_LT] = ACTIONS(3737),
    [anon_sym_EQ] = ACTIONS(3737),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3735),
    [anon_sym_PLUS_EQ] = ACTIONS(3735),
    [anon_sym_DASH_EQ] = ACTIONS(3735),
    [anon_sym_DOT_EQ] = ACTIONS(3735),
    [anon_sym_STAR_EQ] = ACTIONS(3735),
    [anon_sym_SLASH_EQ] = ACTIONS(3735),
    [anon_sym_PERCENT_EQ] = ACTIONS(3735),
    [anon_sym_x_EQ] = ACTIONS(3737),
    [anon_sym_AMP_EQ] = ACTIONS(3735),
    [anon_sym_PIPE_EQ] = ACTIONS(3735),
    [anon_sym_CARET_EQ] = ACTIONS(3735),
    [anon_sym_LT_LT_EQ] = ACTIONS(3735),
    [anon_sym_GT_GT_EQ] = ACTIONS(3735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3735),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3735),
    [anon_sym_DOT_DOT] = ACTIONS(3737),
    [anon_sym_STAR_STAR] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(3737),
    [anon_sym_SLASH_SLASH] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_PIPE] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3737),
    [anon_sym_GT_GT2] = ACTIONS(3737),
    [anon_sym_PLUS] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3737),
    [anon_sym_DOT] = ACTIONS(3737),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_SLASH] = ACTIONS(3737),
    [anon_sym_x] = ACTIONS(3737),
    [anon_sym_EQ_TILDE] = ACTIONS(3735),
    [anon_sym_BANG_TILDE] = ACTIONS(3735),
    [anon_sym_EQ_EQ] = ACTIONS(3735),
    [anon_sym_BANG_EQ] = ACTIONS(3735),
    [anon_sym_eq] = ACTIONS(3735),
    [anon_sym_ne] = ACTIONS(3737),
    [anon_sym_LT_EQ_GT] = ACTIONS(3735),
    [anon_sym_cmp] = ACTIONS(3737),
    [anon_sym_TILDE_TILDE] = ACTIONS(3735),
    [anon_sym_LT_EQ] = ACTIONS(3737),
    [anon_sym_GT_EQ] = ACTIONS(3735),
    [anon_sym_lt] = ACTIONS(3737),
    [anon_sym_le] = ACTIONS(3737),
    [anon_sym_ge] = ACTIONS(3737),
    [anon_sym_gt] = ACTIONS(3737),
    [anon_sym_isa] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3735),
    [anon_sym_QMARK] = ACTIONS(3735),
    [anon_sym_EQ_GT] = ACTIONS(3735),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4545),
    [sym__PERLY_SEMICOLON] = ACTIONS(3735),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1684] = {
    [sym_heredoc_content] = STATE(1684),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3755),
    [anon_sym_DASH_GT] = ACTIONS(3755),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_GT] = ACTIONS(3757),
    [anon_sym_LT_LT] = ACTIONS(3757),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3755),
    [anon_sym_PLUS_EQ] = ACTIONS(3755),
    [anon_sym_DASH_EQ] = ACTIONS(3755),
    [anon_sym_DOT_EQ] = ACTIONS(3755),
    [anon_sym_STAR_EQ] = ACTIONS(3755),
    [anon_sym_SLASH_EQ] = ACTIONS(3755),
    [anon_sym_PERCENT_EQ] = ACTIONS(3755),
    [anon_sym_x_EQ] = ACTIONS(3755),
    [anon_sym_AMP_EQ] = ACTIONS(3755),
    [anon_sym_PIPE_EQ] = ACTIONS(3755),
    [anon_sym_CARET_EQ] = ACTIONS(3755),
    [anon_sym_LT_LT_EQ] = ACTIONS(3755),
    [anon_sym_GT_GT_EQ] = ACTIONS(3755),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3755),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3755),
    [anon_sym_DOT_DOT] = ACTIONS(3757),
    [anon_sym_STAR_STAR] = ACTIONS(3757),
    [anon_sym_PIPE_PIPE] = ACTIONS(3757),
    [anon_sym_SLASH_SLASH] = ACTIONS(3757),
    [anon_sym_AMP_AMP] = ACTIONS(3757),
    [anon_sym_PIPE] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_GT_GT2] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_DOT] = ACTIONS(3757),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_SLASH] = ACTIONS(3757),
    [anon_sym_x] = ACTIONS(3757),
    [anon_sym_EQ_TILDE] = ACTIONS(3755),
    [anon_sym_BANG_TILDE] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3755),
    [anon_sym_eq] = ACTIONS(3755),
    [anon_sym_ne] = ACTIONS(3755),
    [anon_sym_LT_EQ_GT] = ACTIONS(3755),
    [anon_sym_cmp] = ACTIONS(3755),
    [anon_sym_TILDE_TILDE] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3757),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_lt] = ACTIONS(3755),
    [anon_sym_le] = ACTIONS(3755),
    [anon_sym_ge] = ACTIONS(3755),
    [anon_sym_gt] = ACTIONS(3755),
    [anon_sym_isa] = ACTIONS(3755),
    [anon_sym_PLUS_PLUS] = ACTIONS(3755),
    [anon_sym_DASH_DASH] = ACTIONS(3755),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_EQ_GT] = ACTIONS(3755),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3755),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1685] = {
    [sym_heredoc_content] = STATE(1685),
    [aux_sym__term_rightward_repeat1] = STATE(1685),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_COMMA] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_DASH_GT] = ACTIONS(3606),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_LT_LT] = ACTIONS(3611),
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3606),
    [anon_sym_PLUS_EQ] = ACTIONS(3606),
    [anon_sym_DASH_EQ] = ACTIONS(3606),
    [anon_sym_DOT_EQ] = ACTIONS(3606),
    [anon_sym_STAR_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_PERCENT_EQ] = ACTIONS(3606),
    [anon_sym_x_EQ] = ACTIONS(3606),
    [anon_sym_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_CARET_EQ] = ACTIONS(3606),
    [anon_sym_LT_LT_EQ] = ACTIONS(3606),
    [anon_sym_GT_GT_EQ] = ACTIONS(3606),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_DOT_DOT] = ACTIONS(3611),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(3611),
    [anon_sym_SLASH_SLASH] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_GT_GT2] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_x] = ACTIONS(3611),
    [anon_sym_EQ_TILDE] = ACTIONS(3606),
    [anon_sym_BANG_TILDE] = ACTIONS(3606),
    [anon_sym_EQ_EQ] = ACTIONS(3606),
    [anon_sym_BANG_EQ] = ACTIONS(3606),
    [anon_sym_eq] = ACTIONS(3606),
    [anon_sym_ne] = ACTIONS(3606),
    [anon_sym_LT_EQ_GT] = ACTIONS(3606),
    [anon_sym_cmp] = ACTIONS(3606),
    [anon_sym_TILDE_TILDE] = ACTIONS(3606),
    [anon_sym_LT_EQ] = ACTIONS(3611),
    [anon_sym_GT_EQ] = ACTIONS(3606),
    [anon_sym_lt] = ACTIONS(3606),
    [anon_sym_le] = ACTIONS(3606),
    [anon_sym_ge] = ACTIONS(3606),
    [anon_sym_gt] = ACTIONS(3606),
    [anon_sym_isa] = ACTIONS(3606),
    [anon_sym_PLUS_PLUS] = ACTIONS(3606),
    [anon_sym_DASH_DASH] = ACTIONS(3606),
    [anon_sym_QMARK] = ACTIONS(3606),
    [anon_sym_EQ_GT] = ACTIONS(4547),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3606),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1686] = {
    [sym_heredoc_content] = STATE(1686),
    [aux_sym__term_rightward_repeat1] = STATE(1685),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym_COMMA] = ACTIONS(4550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DASH_GT] = ACTIONS(3623),
    [anon_sym_PERCENT] = ACTIONS(3627),
    [anon_sym_LT] = ACTIONS(3627),
    [anon_sym_GT] = ACTIONS(3627),
    [anon_sym_LT_LT] = ACTIONS(3627),
    [anon_sym_EQ] = ACTIONS(3627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3623),
    [anon_sym_PLUS_EQ] = ACTIONS(3623),
    [anon_sym_DASH_EQ] = ACTIONS(3623),
    [anon_sym_DOT_EQ] = ACTIONS(3623),
    [anon_sym_STAR_EQ] = ACTIONS(3623),
    [anon_sym_SLASH_EQ] = ACTIONS(3623),
    [anon_sym_PERCENT_EQ] = ACTIONS(3623),
    [anon_sym_x_EQ] = ACTIONS(3623),
    [anon_sym_AMP_EQ] = ACTIONS(3623),
    [anon_sym_PIPE_EQ] = ACTIONS(3623),
    [anon_sym_CARET_EQ] = ACTIONS(3623),
    [anon_sym_LT_LT_EQ] = ACTIONS(3623),
    [anon_sym_GT_GT_EQ] = ACTIONS(3623),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3623),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3623),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3623),
    [anon_sym_DOT_DOT] = ACTIONS(3627),
    [anon_sym_STAR_STAR] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3627),
    [anon_sym_SLASH_SLASH] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_PIPE] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_GT_GT2] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DOT] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(3627),
    [anon_sym_x] = ACTIONS(3627),
    [anon_sym_EQ_TILDE] = ACTIONS(3623),
    [anon_sym_BANG_TILDE] = ACTIONS(3623),
    [anon_sym_EQ_EQ] = ACTIONS(3623),
    [anon_sym_BANG_EQ] = ACTIONS(3623),
    [anon_sym_eq] = ACTIONS(3623),
    [anon_sym_ne] = ACTIONS(3623),
    [anon_sym_LT_EQ_GT] = ACTIONS(3623),
    [anon_sym_cmp] = ACTIONS(3623),
    [anon_sym_TILDE_TILDE] = ACTIONS(3623),
    [anon_sym_LT_EQ] = ACTIONS(3627),
    [anon_sym_GT_EQ] = ACTIONS(3623),
    [anon_sym_lt] = ACTIONS(3623),
    [anon_sym_le] = ACTIONS(3623),
    [anon_sym_ge] = ACTIONS(3623),
    [anon_sym_gt] = ACTIONS(3623),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_QMARK] = ACTIONS(3623),
    [anon_sym_EQ_GT] = ACTIONS(4550),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3623),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1687] = {
    [sym_heredoc_content] = STATE(1687),
    [anon_sym_SEMI] = ACTIONS(3566),
    [anon_sym_COMMA] = ACTIONS(3566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3566),
    [anon_sym_DASH_GT] = ACTIONS(3566),
    [anon_sym_PERCENT] = ACTIONS(3568),
    [anon_sym_LT] = ACTIONS(3568),
    [anon_sym_GT] = ACTIONS(3568),
    [anon_sym_LT_LT] = ACTIONS(3568),
    [anon_sym_EQ] = ACTIONS(3568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3566),
    [anon_sym_PLUS_EQ] = ACTIONS(3566),
    [anon_sym_DASH_EQ] = ACTIONS(3566),
    [anon_sym_DOT_EQ] = ACTIONS(3566),
    [anon_sym_STAR_EQ] = ACTIONS(3566),
    [anon_sym_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_PERCENT_EQ] = ACTIONS(3566),
    [anon_sym_x_EQ] = ACTIONS(3568),
    [anon_sym_AMP_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_CARET_EQ] = ACTIONS(3566),
    [anon_sym_LT_LT_EQ] = ACTIONS(3566),
    [anon_sym_GT_GT_EQ] = ACTIONS(3566),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_DOT_DOT] = ACTIONS(3568),
    [anon_sym_STAR_STAR] = ACTIONS(3568),
    [anon_sym_PIPE_PIPE] = ACTIONS(3568),
    [anon_sym_SLASH_SLASH] = ACTIONS(3568),
    [anon_sym_AMP_AMP] = ACTIONS(3568),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_AMP] = ACTIONS(3568),
    [anon_sym_GT_GT2] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3568),
    [anon_sym_DASH] = ACTIONS(3568),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(3568),
    [anon_sym_SLASH] = ACTIONS(3568),
    [anon_sym_x] = ACTIONS(3568),
    [anon_sym_EQ_TILDE] = ACTIONS(3566),
    [anon_sym_BANG_TILDE] = ACTIONS(3566),
    [anon_sym_EQ_EQ] = ACTIONS(3566),
    [anon_sym_BANG_EQ] = ACTIONS(3566),
    [anon_sym_eq] = ACTIONS(3568),
    [anon_sym_ne] = ACTIONS(3566),
    [anon_sym_LT_EQ_GT] = ACTIONS(3566),
    [anon_sym_cmp] = ACTIONS(3568),
    [anon_sym_TILDE_TILDE] = ACTIONS(3566),
    [anon_sym_LT_EQ] = ACTIONS(3568),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_lt] = ACTIONS(3568),
    [anon_sym_le] = ACTIONS(3568),
    [anon_sym_ge] = ACTIONS(3568),
    [anon_sym_gt] = ACTIONS(3568),
    [anon_sym_isa] = ACTIONS(3568),
    [anon_sym_PLUS_PLUS] = ACTIONS(3566),
    [anon_sym_DASH_DASH] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3566),
    [anon_sym_EQ_GT] = ACTIONS(3566),
    [sym_comment] = ACTIONS(5),
    [sym_substitution_regexp_modifiers] = ACTIONS(4552),
    [sym__PERLY_SEMICOLON] = ACTIONS(3566),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1688] = {
    [sym_heredoc_content] = STATE(1688),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3749),
    [anon_sym_DASH_GT] = ACTIONS(3749),
    [anon_sym_PERCENT] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_GT] = ACTIONS(3751),
    [anon_sym_LT_LT] = ACTIONS(3751),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3749),
    [anon_sym_PLUS_EQ] = ACTIONS(3749),
    [anon_sym_DASH_EQ] = ACTIONS(3749),
    [anon_sym_DOT_EQ] = ACTIONS(3749),
    [anon_sym_STAR_EQ] = ACTIONS(3749),
    [anon_sym_SLASH_EQ] = ACTIONS(3749),
    [anon_sym_PERCENT_EQ] = ACTIONS(3749),
    [anon_sym_x_EQ] = ACTIONS(3751),
    [anon_sym_AMP_EQ] = ACTIONS(3749),
    [anon_sym_PIPE_EQ] = ACTIONS(3749),
    [anon_sym_CARET_EQ] = ACTIONS(3749),
    [anon_sym_LT_LT_EQ] = ACTIONS(3749),
    [anon_sym_GT_GT_EQ] = ACTIONS(3749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3749),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3749),
    [anon_sym_DOT_DOT] = ACTIONS(3751),
    [anon_sym_STAR_STAR] = ACTIONS(3751),
    [anon_sym_PIPE_PIPE] = ACTIONS(3751),
    [anon_sym_SLASH_SLASH] = ACTIONS(3751),
    [anon_sym_AMP_AMP] = ACTIONS(3751),
    [anon_sym_PIPE] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_GT_GT2] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_DOT] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3751),
    [anon_sym_SLASH] = ACTIONS(3751),
    [anon_sym_x] = ACTIONS(3751),
    [anon_sym_EQ_TILDE] = ACTIONS(3749),
    [anon_sym_BANG_TILDE] = ACTIONS(3749),
    [anon_sym_EQ_EQ] = ACTIONS(3749),
    [anon_sym_BANG_EQ] = ACTIONS(3749),
    [anon_sym_eq] = ACTIONS(3751),
    [anon_sym_ne] = ACTIONS(3749),
    [anon_sym_LT_EQ_GT] = ACTIONS(3749),
    [anon_sym_cmp] = ACTIONS(3751),
    [anon_sym_TILDE_TILDE] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(3751),
    [anon_sym_GT_EQ] = ACTIONS(3749),
    [anon_sym_lt] = ACTIONS(3751),
    [anon_sym_le] = ACTIONS(3751),
    [anon_sym_ge] = ACTIONS(3751),
    [anon_sym_gt] = ACTIONS(3751),
    [anon_sym_isa] = ACTIONS(3751),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_QMARK] = ACTIONS(3749),
    [anon_sym_EQ_GT] = ACTIONS(3749),
    [sym_comment] = ACTIONS(5),
    [sym_substitution_regexp_modifiers] = ACTIONS(4554),
    [sym__PERLY_SEMICOLON] = ACTIONS(3749),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1689] = {
    [sym_heredoc_content] = STATE(1689),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(255),
    [anon_sym_PLUS_EQ] = ACTIONS(255),
    [anon_sym_DASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_EQ] = ACTIONS(255),
    [anon_sym_STAR_EQ] = ACTIONS(255),
    [anon_sym_SLASH_EQ] = ACTIONS(255),
    [anon_sym_PERCENT_EQ] = ACTIONS(255),
    [anon_sym_x_EQ] = ACTIONS(255),
    [anon_sym_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_EQ] = ACTIONS(255),
    [anon_sym_CARET_EQ] = ACTIONS(255),
    [anon_sym_LT_LT_EQ] = ACTIONS(255),
    [anon_sym_GT_GT_EQ] = ACTIONS(255),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(255),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(255),
    [anon_sym_DOT_DOT] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(137),
    [anon_sym_SLASH_SLASH] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_GT_GT2] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [anon_sym_x] = ACTIONS(137),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_BANG_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_BANG_EQ] = ACTIONS(255),
    [anon_sym_eq] = ACTIONS(255),
    [anon_sym_ne] = ACTIONS(255),
    [anon_sym_LT_EQ_GT] = ACTIONS(255),
    [anon_sym_cmp] = ACTIONS(255),
    [anon_sym_TILDE_TILDE] = ACTIONS(255),
    [anon_sym_LT_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(255),
    [anon_sym_lt] = ACTIONS(255),
    [anon_sym_le] = ACTIONS(255),
    [anon_sym_ge] = ACTIONS(255),
    [anon_sym_gt] = ACTIONS(255),
    [anon_sym_isa] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_QMARK] = ACTIONS(255),
    [anon_sym_EQ_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(255),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
    [sym__fat_comma_zw] = ACTIONS(365),
  },
  [1690] = {
    [sym_heredoc_content] = STATE(1690),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_DOT_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_x_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3721),
    [anon_sym_STAR_STAR] = ACTIONS(3721),
    [anon_sym_PIPE_PIPE] = ACTIONS(3721),
    [anon_sym_SLASH_SLASH] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_GT_GT2] = ACTIONS(3721),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_x] = ACTIONS(3721),
    [anon_sym_EQ_TILDE] = ACTIONS(3719),
    [anon_sym_BANG_TILDE] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_eq] = ACTIONS(3719),
    [anon_sym_ne] = ACTIONS(3719),
    [anon_sym_LT_EQ_GT] = ACTIONS(3719),
    [anon_sym_cmp] = ACTIONS(3719),
    [anon_sym_TILDE_TILDE] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3721),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_lt] = ACTIONS(3719),
    [anon_sym_le] = ACTIONS(3719),
    [anon_sym_ge] = ACTIONS(3719),
    [anon_sym_gt] = ACTIONS(3719),
    [anon_sym_isa] = ACTIONS(3719),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3719),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1691] = {
    [sym_heredoc_content] = STATE(1691),
    [anon_sym_COLON] = ACTIONS(3745),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym_COMMA] = ACTIONS(3745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3745),
    [anon_sym_DASH_GT] = ACTIONS(3745),
    [anon_sym_PERCENT] = ACTIONS(3747),
    [anon_sym_LT] = ACTIONS(3747),
    [anon_sym_GT] = ACTIONS(3747),
    [anon_sym_LT_LT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3747),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3745),
    [anon_sym_PLUS_EQ] = ACTIONS(3745),
    [anon_sym_DASH_EQ] = ACTIONS(3745),
    [anon_sym_DOT_EQ] = ACTIONS(3745),
    [anon_sym_STAR_EQ] = ACTIONS(3745),
    [anon_sym_SLASH_EQ] = ACTIONS(3745),
    [anon_sym_PERCENT_EQ] = ACTIONS(3745),
    [anon_sym_x_EQ] = ACTIONS(3745),
    [anon_sym_AMP_EQ] = ACTIONS(3745),
    [anon_sym_PIPE_EQ] = ACTIONS(3745),
    [anon_sym_CARET_EQ] = ACTIONS(3745),
    [anon_sym_LT_LT_EQ] = ACTIONS(3745),
    [anon_sym_GT_GT_EQ] = ACTIONS(3745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3745),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3745),
    [anon_sym_DOT_DOT] = ACTIONS(3747),
    [anon_sym_STAR_STAR] = ACTIONS(3747),
    [anon_sym_PIPE_PIPE] = ACTIONS(3747),
    [anon_sym_SLASH_SLASH] = ACTIONS(3747),
    [anon_sym_AMP_AMP] = ACTIONS(3747),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_AMP] = ACTIONS(3747),
    [anon_sym_GT_GT2] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3747),
    [anon_sym_SLASH] = ACTIONS(3747),
    [anon_sym_x] = ACTIONS(3747),
    [anon_sym_EQ_TILDE] = ACTIONS(3745),
    [anon_sym_BANG_TILDE] = ACTIONS(3745),
    [anon_sym_EQ_EQ] = ACTIONS(3745),
    [anon_sym_BANG_EQ] = ACTIONS(3745),
    [anon_sym_eq] = ACTIONS(3745),
    [anon_sym_ne] = ACTIONS(3745),
    [anon_sym_LT_EQ_GT] = ACTIONS(3745),
    [anon_sym_cmp] = ACTIONS(3745),
    [anon_sym_TILDE_TILDE] = ACTIONS(3745),
    [anon_sym_LT_EQ] = ACTIONS(3747),
    [anon_sym_GT_EQ] = ACTIONS(3745),
    [anon_sym_lt] = ACTIONS(3745),
    [anon_sym_le] = ACTIONS(3745),
    [anon_sym_ge] = ACTIONS(3745),
    [anon_sym_gt] = ACTIONS(3745),
    [anon_sym_isa] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_EQ_GT] = ACTIONS(3745),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3745),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1692] = {
    [sym_heredoc_content] = STATE(1692),
    [anon_sym_SEMI] = ACTIONS(3584),
    [anon_sym_COMMA] = ACTIONS(3584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3584),
    [anon_sym_DASH_GT] = ACTIONS(3584),
    [anon_sym_PERCENT] = ACTIONS(3586),
    [anon_sym_LT] = ACTIONS(3586),
    [anon_sym_GT] = ACTIONS(3586),
    [anon_sym_LT_LT] = ACTIONS(3586),
    [anon_sym_EQ] = ACTIONS(3586),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3584),
    [anon_sym_PLUS_EQ] = ACTIONS(3584),
    [anon_sym_DASH_EQ] = ACTIONS(3584),
    [anon_sym_DOT_EQ] = ACTIONS(3584),
    [anon_sym_STAR_EQ] = ACTIONS(3584),
    [anon_sym_SLASH_EQ] = ACTIONS(3584),
    [anon_sym_PERCENT_EQ] = ACTIONS(3584),
    [anon_sym_x_EQ] = ACTIONS(3584),
    [anon_sym_AMP_EQ] = ACTIONS(3584),
    [anon_sym_PIPE_EQ] = ACTIONS(3584),
    [anon_sym_CARET_EQ] = ACTIONS(3584),
    [anon_sym_LT_LT_EQ] = ACTIONS(3584),
    [anon_sym_GT_GT_EQ] = ACTIONS(3584),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3584),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3584),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3584),
    [anon_sym_DOT_DOT] = ACTIONS(3586),
    [anon_sym_STAR_STAR] = ACTIONS(3586),
    [anon_sym_PIPE_PIPE] = ACTIONS(3586),
    [anon_sym_SLASH_SLASH] = ACTIONS(3586),
    [anon_sym_AMP_AMP] = ACTIONS(3586),
    [anon_sym_PIPE] = ACTIONS(3586),
    [anon_sym_AMP] = ACTIONS(3586),
    [anon_sym_GT_GT2] = ACTIONS(3586),
    [anon_sym_PLUS] = ACTIONS(3586),
    [anon_sym_DASH] = ACTIONS(3586),
    [anon_sym_DOT] = ACTIONS(3586),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_SLASH] = ACTIONS(3586),
    [anon_sym_x] = ACTIONS(3586),
    [anon_sym_EQ_TILDE] = ACTIONS(3584),
    [anon_sym_BANG_TILDE] = ACTIONS(3584),
    [anon_sym_EQ_EQ] = ACTIONS(3584),
    [anon_sym_BANG_EQ] = ACTIONS(3584),
    [anon_sym_eq] = ACTIONS(3584),
    [anon_sym_ne] = ACTIONS(3584),
    [anon_sym_LT_EQ_GT] = ACTIONS(3584),
    [anon_sym_cmp] = ACTIONS(3586),
    [anon_sym_TILDE_TILDE] = ACTIONS(3584),
    [anon_sym_LT_EQ] = ACTIONS(3586),
    [anon_sym_GT_EQ] = ACTIONS(3584),
    [anon_sym_lt] = ACTIONS(3584),
    [anon_sym_le] = ACTIONS(3584),
    [anon_sym_ge] = ACTIONS(3584),
    [anon_sym_gt] = ACTIONS(3584),
    [anon_sym_isa] = ACTIONS(3584),
    [anon_sym_PLUS_PLUS] = ACTIONS(3584),
    [anon_sym_DASH_DASH] = ACTIONS(3584),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_EQ_GT] = ACTIONS(3584),
    [sym_comment] = ACTIONS(5),
    [sym_transliteration_modifiers] = ACTIONS(4556),
    [sym__PERLY_SEMICOLON] = ACTIONS(3584),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1693] = {
    [sym_heredoc_content] = STATE(1693),
    [anon_sym_COLON] = ACTIONS(4558),
    [anon_sym_SEMI] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3564),
    [anon_sym_LT] = ACTIONS(3564),
    [anon_sym_GT] = ACTIONS(3564),
    [anon_sym_LT_LT] = ACTIONS(3564),
    [anon_sym_EQ] = ACTIONS(3564),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3562),
    [anon_sym_PLUS_EQ] = ACTIONS(3562),
    [anon_sym_DASH_EQ] = ACTIONS(3562),
    [anon_sym_DOT_EQ] = ACTIONS(3562),
    [anon_sym_STAR_EQ] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(3562),
    [anon_sym_PERCENT_EQ] = ACTIONS(3562),
    [anon_sym_x_EQ] = ACTIONS(3562),
    [anon_sym_AMP_EQ] = ACTIONS(3562),
    [anon_sym_PIPE_EQ] = ACTIONS(3562),
    [anon_sym_CARET_EQ] = ACTIONS(3562),
    [anon_sym_LT_LT_EQ] = ACTIONS(3562),
    [anon_sym_GT_GT_EQ] = ACTIONS(3562),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3562),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(3564),
    [anon_sym_STAR_STAR] = ACTIONS(3564),
    [anon_sym_PIPE_PIPE] = ACTIONS(3564),
    [anon_sym_SLASH_SLASH] = ACTIONS(3564),
    [anon_sym_AMP_AMP] = ACTIONS(3564),
    [anon_sym_PIPE] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_GT_GT2] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(3564),
    [anon_sym_DASH] = ACTIONS(3564),
    [anon_sym_DOT] = ACTIONS(3564),
    [anon_sym_STAR] = ACTIONS(3564),
    [anon_sym_SLASH] = ACTIONS(3564),
    [anon_sym_x] = ACTIONS(3564),
    [anon_sym_EQ_TILDE] = ACTIONS(3562),
    [anon_sym_BANG_TILDE] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_eq] = ACTIONS(3562),
    [anon_sym_ne] = ACTIONS(3562),
    [anon_sym_LT_EQ_GT] = ACTIONS(3562),
    [anon_sym_cmp] = ACTIONS(3562),
    [anon_sym_TILDE_TILDE] = ACTIONS(3562),
    [anon_sym_LT_EQ] = ACTIONS(3564),
    [anon_sym_GT_EQ] = ACTIONS(3562),
    [anon_sym_lt] = ACTIONS(3562),
    [anon_sym_le] = ACTIONS(3562),
    [anon_sym_ge] = ACTIONS(3562),
    [anon_sym_gt] = ACTIONS(3562),
    [anon_sym_isa] = ACTIONS(3562),
    [anon_sym_PLUS_PLUS] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_EQ_GT] = ACTIONS(3562),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3562),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1694] = {
    [sym_heredoc_content] = STATE(1694),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3619),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_LT_LT] = ACTIONS(3619),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DOT_EQ] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_x_EQ] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_DOT_DOT] = ACTIONS(3619),
    [anon_sym_STAR_STAR] = ACTIONS(3619),
    [anon_sym_PIPE_PIPE] = ACTIONS(3619),
    [anon_sym_SLASH_SLASH] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_PIPE] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_GT_GT2] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_DOT] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(3619),
    [anon_sym_x] = ACTIONS(3619),
    [anon_sym_EQ_TILDE] = ACTIONS(3617),
    [anon_sym_BANG_TILDE] = ACTIONS(3617),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_eq] = ACTIONS(3617),
    [anon_sym_ne] = ACTIONS(3617),
    [anon_sym_LT_EQ_GT] = ACTIONS(3617),
    [anon_sym_cmp] = ACTIONS(3619),
    [anon_sym_TILDE_TILDE] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_lt] = ACTIONS(3617),
    [anon_sym_le] = ACTIONS(3617),
    [anon_sym_ge] = ACTIONS(3617),
    [anon_sym_gt] = ACTIONS(3617),
    [anon_sym_isa] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [sym_comment] = ACTIONS(5),
    [sym_transliteration_modifiers] = ACTIONS(4560),
    [sym__PERLY_SEMICOLON] = ACTIONS(3617),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1695] = {
    [sym_heredoc_content] = STATE(1695),
    [anon_sym_SEMI] = ACTIONS(3777),
    [anon_sym_COMMA] = ACTIONS(3777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3777),
    [anon_sym_LBRACK] = ACTIONS(4543),
    [anon_sym_DASH_GT] = ACTIONS(3777),
    [anon_sym_PERCENT] = ACTIONS(3779),
    [anon_sym_LT] = ACTIONS(3779),
    [anon_sym_GT] = ACTIONS(3779),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_EQ] = ACTIONS(3779),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3777),
    [anon_sym_PLUS_EQ] = ACTIONS(3777),
    [anon_sym_DASH_EQ] = ACTIONS(3777),
    [anon_sym_DOT_EQ] = ACTIONS(3777),
    [anon_sym_STAR_EQ] = ACTIONS(3777),
    [anon_sym_SLASH_EQ] = ACTIONS(3777),
    [anon_sym_PERCENT_EQ] = ACTIONS(3777),
    [anon_sym_x_EQ] = ACTIONS(3777),
    [anon_sym_AMP_EQ] = ACTIONS(3777),
    [anon_sym_PIPE_EQ] = ACTIONS(3777),
    [anon_sym_CARET_EQ] = ACTIONS(3777),
    [anon_sym_LT_LT_EQ] = ACTIONS(3777),
    [anon_sym_GT_GT_EQ] = ACTIONS(3777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3777),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3777),
    [anon_sym_DOT_DOT] = ACTIONS(3779),
    [anon_sym_STAR_STAR] = ACTIONS(3779),
    [anon_sym_PIPE_PIPE] = ACTIONS(3779),
    [anon_sym_SLASH_SLASH] = ACTIONS(3779),
    [anon_sym_AMP_AMP] = ACTIONS(3779),
    [anon_sym_PIPE] = ACTIONS(3779),
    [anon_sym_AMP] = ACTIONS(3779),
    [anon_sym_GT_GT2] = ACTIONS(3779),
    [anon_sym_PLUS] = ACTIONS(3779),
    [anon_sym_DASH] = ACTIONS(3779),
    [anon_sym_DOT] = ACTIONS(3779),
    [anon_sym_STAR] = ACTIONS(3779),
    [anon_sym_SLASH] = ACTIONS(3779),
    [anon_sym_x] = ACTIONS(3779),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_EQ_EQ] = ACTIONS(3777),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_eq] = ACTIONS(3777),
    [anon_sym_ne] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_cmp] = ACTIONS(3777),
    [anon_sym_TILDE_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3779),
    [anon_sym_GT_EQ] = ACTIONS(3777),
    [anon_sym_lt] = ACTIONS(3777),
    [anon_sym_le] = ACTIONS(3777),
    [anon_sym_ge] = ACTIONS(3777),
    [anon_sym_gt] = ACTIONS(3777),
    [anon_sym_isa] = ACTIONS(3777),
    [anon_sym_PLUS_PLUS] = ACTIONS(3777),
    [anon_sym_DASH_DASH] = ACTIONS(3777),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_EQ_GT] = ACTIONS(3777),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3777),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1696] = {
    [sym_heredoc_content] = STATE(1696),
    [anon_sym_SEMI] = ACTIONS(3578),
    [anon_sym_COMMA] = ACTIONS(3578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3578),
    [anon_sym_DASH_GT] = ACTIONS(3578),
    [anon_sym_PERCENT] = ACTIONS(3580),
    [anon_sym_LT] = ACTIONS(3580),
    [anon_sym_GT] = ACTIONS(3580),
    [anon_sym_LT_LT] = ACTIONS(3580),
    [anon_sym_EQ] = ACTIONS(3580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3578),
    [anon_sym_PLUS_EQ] = ACTIONS(3578),
    [anon_sym_DASH_EQ] = ACTIONS(3578),
    [anon_sym_DOT_EQ] = ACTIONS(3578),
    [anon_sym_STAR_EQ] = ACTIONS(3578),
    [anon_sym_SLASH_EQ] = ACTIONS(3578),
    [anon_sym_PERCENT_EQ] = ACTIONS(3578),
    [anon_sym_x_EQ] = ACTIONS(3580),
    [anon_sym_AMP_EQ] = ACTIONS(3578),
    [anon_sym_PIPE_EQ] = ACTIONS(3578),
    [anon_sym_CARET_EQ] = ACTIONS(3578),
    [anon_sym_LT_LT_EQ] = ACTIONS(3578),
    [anon_sym_GT_GT_EQ] = ACTIONS(3578),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3578),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3578),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3578),
    [anon_sym_DOT_DOT] = ACTIONS(3580),
    [anon_sym_STAR_STAR] = ACTIONS(3580),
    [anon_sym_PIPE_PIPE] = ACTIONS(3580),
    [anon_sym_SLASH_SLASH] = ACTIONS(3580),
    [anon_sym_AMP_AMP] = ACTIONS(3580),
    [anon_sym_PIPE] = ACTIONS(3580),
    [anon_sym_AMP] = ACTIONS(3580),
    [anon_sym_GT_GT2] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_DOT] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(3580),
    [anon_sym_SLASH] = ACTIONS(3580),
    [anon_sym_x] = ACTIONS(3580),
    [anon_sym_EQ_TILDE] = ACTIONS(3578),
    [anon_sym_BANG_TILDE] = ACTIONS(3578),
    [anon_sym_EQ_EQ] = ACTIONS(3578),
    [anon_sym_BANG_EQ] = ACTIONS(3578),
    [anon_sym_eq] = ACTIONS(3580),
    [anon_sym_ne] = ACTIONS(3578),
    [anon_sym_LT_EQ_GT] = ACTIONS(3578),
    [anon_sym_cmp] = ACTIONS(3580),
    [anon_sym_TILDE_TILDE] = ACTIONS(3578),
    [anon_sym_LT_EQ] = ACTIONS(3580),
    [anon_sym_GT_EQ] = ACTIONS(3578),
    [anon_sym_lt] = ACTIONS(3580),
    [anon_sym_le] = ACTIONS(3580),
    [anon_sym_ge] = ACTIONS(3580),
    [anon_sym_gt] = ACTIONS(3580),
    [anon_sym_isa] = ACTIONS(3580),
    [anon_sym_PLUS_PLUS] = ACTIONS(3578),
    [anon_sym_DASH_DASH] = ACTIONS(3578),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_EQ_GT] = ACTIONS(3578),
    [sym_comment] = ACTIONS(5),
    [sym_substitution_regexp_modifiers] = ACTIONS(4562),
    [sym__PERLY_SEMICOLON] = ACTIONS(3578),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1697] = {
    [sym_heredoc_content] = STATE(1697),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3765),
    [anon_sym_DASH_GT] = ACTIONS(3765),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3767),
    [anon_sym_GT] = ACTIONS(3767),
    [anon_sym_LT_LT] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3767),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3765),
    [anon_sym_PLUS_EQ] = ACTIONS(3765),
    [anon_sym_DASH_EQ] = ACTIONS(3765),
    [anon_sym_DOT_EQ] = ACTIONS(3765),
    [anon_sym_STAR_EQ] = ACTIONS(3765),
    [anon_sym_SLASH_EQ] = ACTIONS(3765),
    [anon_sym_PERCENT_EQ] = ACTIONS(3765),
    [anon_sym_x_EQ] = ACTIONS(3767),
    [anon_sym_AMP_EQ] = ACTIONS(3765),
    [anon_sym_PIPE_EQ] = ACTIONS(3765),
    [anon_sym_CARET_EQ] = ACTIONS(3765),
    [anon_sym_LT_LT_EQ] = ACTIONS(3765),
    [anon_sym_GT_GT_EQ] = ACTIONS(3765),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3765),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3765),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3765),
    [anon_sym_DOT_DOT] = ACTIONS(3767),
    [anon_sym_STAR_STAR] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_SLASH_SLASH] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(3767),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_GT_GT2] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3767),
    [anon_sym_SLASH] = ACTIONS(3767),
    [anon_sym_x] = ACTIONS(3767),
    [anon_sym_EQ_TILDE] = ACTIONS(3765),
    [anon_sym_BANG_TILDE] = ACTIONS(3765),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_eq] = ACTIONS(3765),
    [anon_sym_ne] = ACTIONS(3767),
    [anon_sym_LT_EQ_GT] = ACTIONS(3765),
    [anon_sym_cmp] = ACTIONS(3767),
    [anon_sym_TILDE_TILDE] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3767),
    [anon_sym_GT_EQ] = ACTIONS(3765),
    [anon_sym_lt] = ACTIONS(3767),
    [anon_sym_le] = ACTIONS(3767),
    [anon_sym_ge] = ACTIONS(3767),
    [anon_sym_gt] = ACTIONS(3767),
    [anon_sym_isa] = ACTIONS(3767),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_QMARK] = ACTIONS(3765),
    [anon_sym_EQ_GT] = ACTIONS(3765),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4564),
    [sym__PERLY_SEMICOLON] = ACTIONS(3765),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1698] = {
    [sym_heredoc_content] = STATE(1698),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3783),
    [anon_sym_LT] = ACTIONS(3783),
    [anon_sym_GT] = ACTIONS(3783),
    [anon_sym_LT_LT] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(3783),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_DOT_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_x_EQ] = ACTIONS(3783),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT] = ACTIONS(3783),
    [anon_sym_STAR_STAR] = ACTIONS(3783),
    [anon_sym_PIPE_PIPE] = ACTIONS(3783),
    [anon_sym_SLASH_SLASH] = ACTIONS(3783),
    [anon_sym_AMP_AMP] = ACTIONS(3783),
    [anon_sym_PIPE] = ACTIONS(3783),
    [anon_sym_AMP] = ACTIONS(3783),
    [anon_sym_GT_GT2] = ACTIONS(3783),
    [anon_sym_PLUS] = ACTIONS(3783),
    [anon_sym_DASH] = ACTIONS(3783),
    [anon_sym_DOT] = ACTIONS(3783),
    [anon_sym_STAR] = ACTIONS(3783),
    [anon_sym_SLASH] = ACTIONS(3783),
    [anon_sym_x] = ACTIONS(3783),
    [anon_sym_EQ_TILDE] = ACTIONS(3781),
    [anon_sym_BANG_TILDE] = ACTIONS(3781),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_eq] = ACTIONS(3781),
    [anon_sym_ne] = ACTIONS(3783),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_cmp] = ACTIONS(3783),
    [anon_sym_TILDE_TILDE] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3783),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_lt] = ACTIONS(3783),
    [anon_sym_le] = ACTIONS(3783),
    [anon_sym_ge] = ACTIONS(3783),
    [anon_sym_gt] = ACTIONS(3783),
    [anon_sym_isa] = ACTIONS(3783),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_EQ_GT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4566),
    [sym__PERLY_SEMICOLON] = ACTIONS(3781),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1699] = {
    [sym_heredoc_content] = STATE(1699),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(4568),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_EQ] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_x_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2929),
    [anon_sym_STAR_STAR] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_GT_GT2] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_x] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2936),
    [anon_sym_BANG_TILDE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_eq] = ACTIONS(2936),
    [anon_sym_ne] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_cmp] = ACTIONS(2936),
    [anon_sym_TILDE_TILDE] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_lt] = ACTIONS(2936),
    [anon_sym_le] = ACTIONS(2936),
    [anon_sym_ge] = ACTIONS(2936),
    [anon_sym_gt] = ACTIONS(2936),
    [anon_sym_isa] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(2936),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1700] = {
    [sym_heredoc_content] = STATE(1700),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3707),
    [anon_sym_DASH_GT] = ACTIONS(3707),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3709),
    [anon_sym_GT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3707),
    [anon_sym_PLUS_EQ] = ACTIONS(3707),
    [anon_sym_DASH_EQ] = ACTIONS(3707),
    [anon_sym_DOT_EQ] = ACTIONS(3707),
    [anon_sym_STAR_EQ] = ACTIONS(3707),
    [anon_sym_SLASH_EQ] = ACTIONS(3707),
    [anon_sym_PERCENT_EQ] = ACTIONS(3707),
    [anon_sym_x_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3707),
    [anon_sym_PIPE_EQ] = ACTIONS(3707),
    [anon_sym_CARET_EQ] = ACTIONS(3707),
    [anon_sym_LT_LT_EQ] = ACTIONS(3707),
    [anon_sym_GT_GT_EQ] = ACTIONS(3707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_SLASH_SLASH] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_GT_GT2] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_SLASH] = ACTIONS(3709),
    [anon_sym_x] = ACTIONS(3709),
    [anon_sym_EQ_TILDE] = ACTIONS(3707),
    [anon_sym_BANG_TILDE] = ACTIONS(3707),
    [anon_sym_EQ_EQ] = ACTIONS(3707),
    [anon_sym_BANG_EQ] = ACTIONS(3707),
    [anon_sym_eq] = ACTIONS(3709),
    [anon_sym_ne] = ACTIONS(3707),
    [anon_sym_LT_EQ_GT] = ACTIONS(3707),
    [anon_sym_cmp] = ACTIONS(3709),
    [anon_sym_TILDE_TILDE] = ACTIONS(3707),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3707),
    [anon_sym_lt] = ACTIONS(3709),
    [anon_sym_le] = ACTIONS(3709),
    [anon_sym_ge] = ACTIONS(3709),
    [anon_sym_gt] = ACTIONS(3709),
    [anon_sym_isa] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_QMARK] = ACTIONS(3707),
    [anon_sym_EQ_GT] = ACTIONS(3707),
    [sym_comment] = ACTIONS(5),
    [sym_substitution_regexp_modifiers] = ACTIONS(4570),
    [sym__PERLY_SEMICOLON] = ACTIONS(3707),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1701] = {
    [sym_heredoc_content] = STATE(1701),
    [anon_sym_SEMI] = ACTIONS(3795),
    [anon_sym_COMMA] = ACTIONS(3795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(4572),
    [anon_sym_DASH_GT] = ACTIONS(3795),
    [anon_sym_PERCENT] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3797),
    [anon_sym_GT] = ACTIONS(3797),
    [anon_sym_LT_LT] = ACTIONS(3797),
    [anon_sym_EQ] = ACTIONS(3797),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3795),
    [anon_sym_PLUS_EQ] = ACTIONS(3795),
    [anon_sym_DASH_EQ] = ACTIONS(3795),
    [anon_sym_DOT_EQ] = ACTIONS(3795),
    [anon_sym_STAR_EQ] = ACTIONS(3795),
    [anon_sym_SLASH_EQ] = ACTIONS(3795),
    [anon_sym_PERCENT_EQ] = ACTIONS(3795),
    [anon_sym_x_EQ] = ACTIONS(3795),
    [anon_sym_AMP_EQ] = ACTIONS(3795),
    [anon_sym_PIPE_EQ] = ACTIONS(3795),
    [anon_sym_CARET_EQ] = ACTIONS(3795),
    [anon_sym_LT_LT_EQ] = ACTIONS(3795),
    [anon_sym_GT_GT_EQ] = ACTIONS(3795),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3795),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3795),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3795),
    [anon_sym_DOT_DOT] = ACTIONS(3797),
    [anon_sym_STAR_STAR] = ACTIONS(3797),
    [anon_sym_PIPE_PIPE] = ACTIONS(3797),
    [anon_sym_SLASH_SLASH] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(3797),
    [anon_sym_PIPE] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3797),
    [anon_sym_GT_GT2] = ACTIONS(3797),
    [anon_sym_PLUS] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3797),
    [anon_sym_DOT] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_SLASH] = ACTIONS(3797),
    [anon_sym_x] = ACTIONS(3797),
    [anon_sym_EQ_TILDE] = ACTIONS(3795),
    [anon_sym_BANG_TILDE] = ACTIONS(3795),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_eq] = ACTIONS(3795),
    [anon_sym_ne] = ACTIONS(3795),
    [anon_sym_LT_EQ_GT] = ACTIONS(3795),
    [anon_sym_cmp] = ACTIONS(3795),
    [anon_sym_TILDE_TILDE] = ACTIONS(3795),
    [anon_sym_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_EQ] = ACTIONS(3795),
    [anon_sym_lt] = ACTIONS(3795),
    [anon_sym_le] = ACTIONS(3795),
    [anon_sym_ge] = ACTIONS(3795),
    [anon_sym_gt] = ACTIONS(3795),
    [anon_sym_isa] = ACTIONS(3795),
    [anon_sym_PLUS_PLUS] = ACTIONS(3795),
    [anon_sym_DASH_DASH] = ACTIONS(3795),
    [anon_sym_QMARK] = ACTIONS(3795),
    [anon_sym_EQ_GT] = ACTIONS(3795),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3795),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1702] = {
    [sym_heredoc_content] = STATE(1702),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym_COMMA] = ACTIONS(3771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3771),
    [anon_sym_DASH_GT] = ACTIONS(3771),
    [anon_sym_PERCENT] = ACTIONS(3773),
    [anon_sym_LT] = ACTIONS(3773),
    [anon_sym_GT] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(3773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3771),
    [anon_sym_PLUS_EQ] = ACTIONS(3771),
    [anon_sym_DASH_EQ] = ACTIONS(3771),
    [anon_sym_DOT_EQ] = ACTIONS(3771),
    [anon_sym_STAR_EQ] = ACTIONS(3771),
    [anon_sym_SLASH_EQ] = ACTIONS(3771),
    [anon_sym_PERCENT_EQ] = ACTIONS(3771),
    [anon_sym_x_EQ] = ACTIONS(3771),
    [anon_sym_AMP_EQ] = ACTIONS(3771),
    [anon_sym_PIPE_EQ] = ACTIONS(3771),
    [anon_sym_CARET_EQ] = ACTIONS(3771),
    [anon_sym_LT_LT_EQ] = ACTIONS(3771),
    [anon_sym_GT_GT_EQ] = ACTIONS(3771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3771),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_STAR_STAR] = ACTIONS(3773),
    [anon_sym_PIPE_PIPE] = ACTIONS(3773),
    [anon_sym_SLASH_SLASH] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_PIPE] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3773),
    [anon_sym_GT_GT2] = ACTIONS(3773),
    [anon_sym_PLUS] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3773),
    [anon_sym_DOT] = ACTIONS(3773),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_SLASH] = ACTIONS(3773),
    [anon_sym_x] = ACTIONS(3773),
    [anon_sym_EQ_TILDE] = ACTIONS(3771),
    [anon_sym_BANG_TILDE] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3771),
    [anon_sym_BANG_EQ] = ACTIONS(3771),
    [anon_sym_eq] = ACTIONS(3771),
    [anon_sym_ne] = ACTIONS(3771),
    [anon_sym_LT_EQ_GT] = ACTIONS(3771),
    [anon_sym_cmp] = ACTIONS(3773),
    [anon_sym_TILDE_TILDE] = ACTIONS(3771),
    [anon_sym_LT_EQ] = ACTIONS(3773),
    [anon_sym_GT_EQ] = ACTIONS(3771),
    [anon_sym_lt] = ACTIONS(3771),
    [anon_sym_le] = ACTIONS(3771),
    [anon_sym_ge] = ACTIONS(3771),
    [anon_sym_gt] = ACTIONS(3771),
    [anon_sym_isa] = ACTIONS(3771),
    [anon_sym_PLUS_PLUS] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_EQ_GT] = ACTIONS(3771),
    [sym_comment] = ACTIONS(5),
    [sym_transliteration_modifiers] = ACTIONS(4574),
    [sym__PERLY_SEMICOLON] = ACTIONS(3771),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1703] = {
    [sym_heredoc_content] = STATE(1703),
    [anon_sym_SEMI] = ACTIONS(3811),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3811),
    [anon_sym_LBRACK] = ACTIONS(3811),
    [anon_sym_DASH_GT] = ACTIONS(3811),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_LT] = ACTIONS(3813),
    [anon_sym_GT] = ACTIONS(3813),
    [anon_sym_LT_LT] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3811),
    [anon_sym_PLUS_EQ] = ACTIONS(3811),
    [anon_sym_DASH_EQ] = ACTIONS(3811),
    [anon_sym_DOT_EQ] = ACTIONS(3811),
    [anon_sym_STAR_EQ] = ACTIONS(3811),
    [anon_sym_SLASH_EQ] = ACTIONS(3811),
    [anon_sym_PERCENT_EQ] = ACTIONS(3811),
    [anon_sym_x_EQ] = ACTIONS(3811),
    [anon_sym_AMP_EQ] = ACTIONS(3811),
    [anon_sym_PIPE_EQ] = ACTIONS(3811),
    [anon_sym_CARET_EQ] = ACTIONS(3811),
    [anon_sym_LT_LT_EQ] = ACTIONS(3811),
    [anon_sym_GT_GT_EQ] = ACTIONS(3811),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3811),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3811),
    [anon_sym_DOT_DOT] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_PIPE] = ACTIONS(3813),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_GT_GT2] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_SLASH] = ACTIONS(3813),
    [anon_sym_x] = ACTIONS(3813),
    [anon_sym_EQ_TILDE] = ACTIONS(3811),
    [anon_sym_BANG_TILDE] = ACTIONS(3811),
    [anon_sym_EQ_EQ] = ACTIONS(3811),
    [anon_sym_BANG_EQ] = ACTIONS(3811),
    [anon_sym_eq] = ACTIONS(3811),
    [anon_sym_ne] = ACTIONS(3811),
    [anon_sym_LT_EQ_GT] = ACTIONS(3811),
    [anon_sym_cmp] = ACTIONS(3811),
    [anon_sym_TILDE_TILDE] = ACTIONS(3811),
    [anon_sym_LT_EQ] = ACTIONS(3813),
    [anon_sym_GT_EQ] = ACTIONS(3811),
    [anon_sym_lt] = ACTIONS(3811),
    [anon_sym_le] = ACTIONS(3811),
    [anon_sym_ge] = ACTIONS(3811),
    [anon_sym_gt] = ACTIONS(3811),
    [anon_sym_isa] = ACTIONS(3811),
    [anon_sym_PLUS_PLUS] = ACTIONS(3811),
    [anon_sym_DASH_DASH] = ACTIONS(3811),
    [anon_sym_QMARK] = ACTIONS(3811),
    [anon_sym_EQ_GT] = ACTIONS(3811),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3811),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1704] = {
    [sym_heredoc_content] = STATE(1704),
    [aux_sym__term_rightward_repeat1] = STATE(2567),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(4576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4578),
    [anon_sym_DASH_GT] = ACTIONS(4580),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4590),
    [anon_sym_PLUS_EQ] = ACTIONS(4590),
    [anon_sym_DASH_EQ] = ACTIONS(4590),
    [anon_sym_DOT_EQ] = ACTIONS(4590),
    [anon_sym_STAR_EQ] = ACTIONS(4590),
    [anon_sym_SLASH_EQ] = ACTIONS(4590),
    [anon_sym_PERCENT_EQ] = ACTIONS(4590),
    [anon_sym_x_EQ] = ACTIONS(4590),
    [anon_sym_AMP_EQ] = ACTIONS(4590),
    [anon_sym_PIPE_EQ] = ACTIONS(4590),
    [anon_sym_CARET_EQ] = ACTIONS(4590),
    [anon_sym_LT_LT_EQ] = ACTIONS(4590),
    [anon_sym_GT_GT_EQ] = ACTIONS(4590),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4590),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4590),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4590),
    [anon_sym_DOT_DOT] = ACTIONS(4592),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_PIPE_PIPE] = ACTIONS(4596),
    [anon_sym_SLASH_SLASH] = ACTIONS(4596),
    [anon_sym_AMP_AMP] = ACTIONS(4598),
    [anon_sym_PIPE] = ACTIONS(4600),
    [anon_sym_AMP] = ACTIONS(4602),
    [anon_sym_GT_GT2] = ACTIONS(4586),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4582),
    [anon_sym_x] = ACTIONS(4582),
    [anon_sym_EQ_TILDE] = ACTIONS(4606),
    [anon_sym_BANG_TILDE] = ACTIONS(4606),
    [anon_sym_EQ_EQ] = ACTIONS(4608),
    [anon_sym_BANG_EQ] = ACTIONS(4608),
    [anon_sym_eq] = ACTIONS(4608),
    [anon_sym_ne] = ACTIONS(4608),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_cmp] = ACTIONS(4610),
    [anon_sym_TILDE_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_lt] = ACTIONS(4612),
    [anon_sym_le] = ACTIONS(4612),
    [anon_sym_ge] = ACTIONS(4612),
    [anon_sym_gt] = ACTIONS(4612),
    [anon_sym_isa] = ACTIONS(4614),
    [anon_sym_PLUS_PLUS] = ACTIONS(4616),
    [anon_sym_DASH_DASH] = ACTIONS(4616),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_EQ_GT] = ACTIONS(4576),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3645),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1705] = {
    [sym_heredoc_content] = STATE(1705),
    [anon_sym_SEMI] = ACTIONS(3803),
    [anon_sym_COMMA] = ACTIONS(3803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(4572),
    [anon_sym_DASH_GT] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3805),
    [anon_sym_LT_LT] = ACTIONS(3805),
    [anon_sym_EQ] = ACTIONS(3805),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3803),
    [anon_sym_PLUS_EQ] = ACTIONS(3803),
    [anon_sym_DASH_EQ] = ACTIONS(3803),
    [anon_sym_DOT_EQ] = ACTIONS(3803),
    [anon_sym_STAR_EQ] = ACTIONS(3803),
    [anon_sym_SLASH_EQ] = ACTIONS(3803),
    [anon_sym_PERCENT_EQ] = ACTIONS(3803),
    [anon_sym_x_EQ] = ACTIONS(3803),
    [anon_sym_AMP_EQ] = ACTIONS(3803),
    [anon_sym_PIPE_EQ] = ACTIONS(3803),
    [anon_sym_CARET_EQ] = ACTIONS(3803),
    [anon_sym_LT_LT_EQ] = ACTIONS(3803),
    [anon_sym_GT_GT_EQ] = ACTIONS(3803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3803),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3803),
    [anon_sym_DOT_DOT] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_SLASH_SLASH] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3805),
    [anon_sym_GT_GT2] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3805),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_SLASH] = ACTIONS(3805),
    [anon_sym_x] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3803),
    [anon_sym_BANG_TILDE] = ACTIONS(3803),
    [anon_sym_EQ_EQ] = ACTIONS(3803),
    [anon_sym_BANG_EQ] = ACTIONS(3803),
    [anon_sym_eq] = ACTIONS(3803),
    [anon_sym_ne] = ACTIONS(3803),
    [anon_sym_LT_EQ_GT] = ACTIONS(3803),
    [anon_sym_cmp] = ACTIONS(3803),
    [anon_sym_TILDE_TILDE] = ACTIONS(3803),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_GT_EQ] = ACTIONS(3803),
    [anon_sym_lt] = ACTIONS(3803),
    [anon_sym_le] = ACTIONS(3803),
    [anon_sym_ge] = ACTIONS(3803),
    [anon_sym_gt] = ACTIONS(3803),
    [anon_sym_isa] = ACTIONS(3803),
    [anon_sym_PLUS_PLUS] = ACTIONS(3803),
    [anon_sym_DASH_DASH] = ACTIONS(3803),
    [anon_sym_QMARK] = ACTIONS(3803),
    [anon_sym_EQ_GT] = ACTIONS(3803),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3803),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1706] = {
    [sym_heredoc_content] = STATE(1706),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3729),
    [anon_sym_DASH_GT] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3731),
    [anon_sym_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3731),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3729),
    [anon_sym_PLUS_EQ] = ACTIONS(3729),
    [anon_sym_DASH_EQ] = ACTIONS(3729),
    [anon_sym_DOT_EQ] = ACTIONS(3729),
    [anon_sym_STAR_EQ] = ACTIONS(3729),
    [anon_sym_SLASH_EQ] = ACTIONS(3729),
    [anon_sym_PERCENT_EQ] = ACTIONS(3729),
    [anon_sym_x_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3729),
    [anon_sym_PIPE_EQ] = ACTIONS(3729),
    [anon_sym_CARET_EQ] = ACTIONS(3729),
    [anon_sym_LT_LT_EQ] = ACTIONS(3729),
    [anon_sym_GT_GT_EQ] = ACTIONS(3729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3729),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3729),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3729),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_SLASH_SLASH] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_GT_GT2] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3731),
    [anon_sym_SLASH] = ACTIONS(3731),
    [anon_sym_x] = ACTIONS(3731),
    [anon_sym_EQ_TILDE] = ACTIONS(3729),
    [anon_sym_BANG_TILDE] = ACTIONS(3729),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_eq] = ACTIONS(3729),
    [anon_sym_ne] = ACTIONS(3731),
    [anon_sym_LT_EQ_GT] = ACTIONS(3729),
    [anon_sym_cmp] = ACTIONS(3731),
    [anon_sym_TILDE_TILDE] = ACTIONS(3729),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3729),
    [anon_sym_lt] = ACTIONS(3731),
    [anon_sym_le] = ACTIONS(3731),
    [anon_sym_ge] = ACTIONS(3731),
    [anon_sym_gt] = ACTIONS(3731),
    [anon_sym_isa] = ACTIONS(3731),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_QMARK] = ACTIONS(3729),
    [anon_sym_EQ_GT] = ACTIONS(3729),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4620),
    [sym__PERLY_SEMICOLON] = ACTIONS(3729),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1707] = {
    [sym_heredoc_content] = STATE(1707),
    [anon_sym_COLON] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3641),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3641),
    [anon_sym_DASH_GT] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3643),
    [anon_sym_LT] = ACTIONS(3643),
    [anon_sym_GT] = ACTIONS(3643),
    [anon_sym_LT_LT] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(3643),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3641),
    [anon_sym_PLUS_EQ] = ACTIONS(3641),
    [anon_sym_DASH_EQ] = ACTIONS(3641),
    [anon_sym_DOT_EQ] = ACTIONS(3641),
    [anon_sym_STAR_EQ] = ACTIONS(3641),
    [anon_sym_SLASH_EQ] = ACTIONS(3641),
    [anon_sym_PERCENT_EQ] = ACTIONS(3641),
    [anon_sym_x_EQ] = ACTIONS(3641),
    [anon_sym_AMP_EQ] = ACTIONS(3641),
    [anon_sym_PIPE_EQ] = ACTIONS(3641),
    [anon_sym_CARET_EQ] = ACTIONS(3641),
    [anon_sym_LT_LT_EQ] = ACTIONS(3641),
    [anon_sym_GT_GT_EQ] = ACTIONS(3641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3641),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3641),
    [anon_sym_DOT_DOT] = ACTIONS(3643),
    [anon_sym_STAR_STAR] = ACTIONS(3643),
    [anon_sym_PIPE_PIPE] = ACTIONS(3643),
    [anon_sym_SLASH_SLASH] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_PIPE] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_GT_GT2] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3643),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_SLASH] = ACTIONS(3643),
    [anon_sym_x] = ACTIONS(3643),
    [anon_sym_EQ_TILDE] = ACTIONS(3641),
    [anon_sym_BANG_TILDE] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BANG_EQ] = ACTIONS(3641),
    [anon_sym_eq] = ACTIONS(3641),
    [anon_sym_ne] = ACTIONS(3641),
    [anon_sym_LT_EQ_GT] = ACTIONS(3641),
    [anon_sym_cmp] = ACTIONS(3641),
    [anon_sym_TILDE_TILDE] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3643),
    [anon_sym_GT_EQ] = ACTIONS(3641),
    [anon_sym_lt] = ACTIONS(3641),
    [anon_sym_le] = ACTIONS(3641),
    [anon_sym_ge] = ACTIONS(3641),
    [anon_sym_gt] = ACTIONS(3641),
    [anon_sym_isa] = ACTIONS(3641),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_EQ_GT] = ACTIONS(3641),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3641),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1708] = {
    [sym_heredoc_content] = STATE(1708),
    [aux_sym__term_rightward_repeat1] = STATE(1686),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_COMMA] = ACTIONS(4622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4578),
    [anon_sym_DASH_GT] = ACTIONS(4580),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4590),
    [anon_sym_PLUS_EQ] = ACTIONS(4590),
    [anon_sym_DASH_EQ] = ACTIONS(4590),
    [anon_sym_DOT_EQ] = ACTIONS(4590),
    [anon_sym_STAR_EQ] = ACTIONS(4590),
    [anon_sym_SLASH_EQ] = ACTIONS(4590),
    [anon_sym_PERCENT_EQ] = ACTIONS(4590),
    [anon_sym_x_EQ] = ACTIONS(4590),
    [anon_sym_AMP_EQ] = ACTIONS(4590),
    [anon_sym_PIPE_EQ] = ACTIONS(4590),
    [anon_sym_CARET_EQ] = ACTIONS(4590),
    [anon_sym_LT_LT_EQ] = ACTIONS(4590),
    [anon_sym_GT_GT_EQ] = ACTIONS(4590),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4590),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4590),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4590),
    [anon_sym_DOT_DOT] = ACTIONS(4592),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_PIPE_PIPE] = ACTIONS(4596),
    [anon_sym_SLASH_SLASH] = ACTIONS(4596),
    [anon_sym_AMP_AMP] = ACTIONS(4598),
    [anon_sym_PIPE] = ACTIONS(4600),
    [anon_sym_AMP] = ACTIONS(4602),
    [anon_sym_GT_GT2] = ACTIONS(4586),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4582),
    [anon_sym_x] = ACTIONS(4582),
    [anon_sym_EQ_TILDE] = ACTIONS(4606),
    [anon_sym_BANG_TILDE] = ACTIONS(4606),
    [anon_sym_EQ_EQ] = ACTIONS(4608),
    [anon_sym_BANG_EQ] = ACTIONS(4608),
    [anon_sym_eq] = ACTIONS(4608),
    [anon_sym_ne] = ACTIONS(4608),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_cmp] = ACTIONS(4610),
    [anon_sym_TILDE_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_lt] = ACTIONS(4612),
    [anon_sym_le] = ACTIONS(4612),
    [anon_sym_ge] = ACTIONS(4612),
    [anon_sym_gt] = ACTIONS(4612),
    [anon_sym_isa] = ACTIONS(4614),
    [anon_sym_PLUS_PLUS] = ACTIONS(4616),
    [anon_sym_DASH_DASH] = ACTIONS(4616),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_EQ_GT] = ACTIONS(4622),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3789),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1709] = {
    [sym_heredoc_content] = STATE(1709),
    [anon_sym_SEMI] = ACTIONS(3596),
    [anon_sym_LPAREN] = ACTIONS(3596),
    [anon_sym_COMMA] = ACTIONS(3596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_DASH_GT] = ACTIONS(3596),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_LT] = ACTIONS(3598),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_LT_LT] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3598),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3596),
    [anon_sym_PLUS_EQ] = ACTIONS(3596),
    [anon_sym_DASH_EQ] = ACTIONS(3596),
    [anon_sym_DOT_EQ] = ACTIONS(3596),
    [anon_sym_STAR_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_PERCENT_EQ] = ACTIONS(3596),
    [anon_sym_x_EQ] = ACTIONS(3596),
    [anon_sym_AMP_EQ] = ACTIONS(3596),
    [anon_sym_PIPE_EQ] = ACTIONS(3596),
    [anon_sym_CARET_EQ] = ACTIONS(3596),
    [anon_sym_LT_LT_EQ] = ACTIONS(3596),
    [anon_sym_GT_GT_EQ] = ACTIONS(3596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_DOT_DOT] = ACTIONS(3598),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_SLASH_SLASH] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3598),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_GT_GT2] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_STAR] = ACTIONS(3598),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_x] = ACTIONS(3598),
    [anon_sym_EQ_TILDE] = ACTIONS(3596),
    [anon_sym_BANG_TILDE] = ACTIONS(3596),
    [anon_sym_EQ_EQ] = ACTIONS(3596),
    [anon_sym_BANG_EQ] = ACTIONS(3596),
    [anon_sym_eq] = ACTIONS(3596),
    [anon_sym_ne] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3596),
    [anon_sym_cmp] = ACTIONS(3596),
    [anon_sym_TILDE_TILDE] = ACTIONS(3596),
    [anon_sym_LT_EQ] = ACTIONS(3598),
    [anon_sym_GT_EQ] = ACTIONS(3596),
    [anon_sym_lt] = ACTIONS(3596),
    [anon_sym_le] = ACTIONS(3596),
    [anon_sym_ge] = ACTIONS(3596),
    [anon_sym_gt] = ACTIONS(3596),
    [anon_sym_isa] = ACTIONS(3596),
    [anon_sym_PLUS_PLUS] = ACTIONS(3596),
    [anon_sym_DASH_DASH] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3596),
    [anon_sym_EQ_GT] = ACTIONS(3596),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3596),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1710] = {
    [sym_heredoc_content] = STATE(1710),
    [anon_sym_SEMI] = ACTIONS(3695),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3695),
    [anon_sym_DASH_GT] = ACTIONS(3695),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3695),
    [anon_sym_PLUS_EQ] = ACTIONS(3695),
    [anon_sym_DASH_EQ] = ACTIONS(3695),
    [anon_sym_DOT_EQ] = ACTIONS(3695),
    [anon_sym_STAR_EQ] = ACTIONS(3695),
    [anon_sym_SLASH_EQ] = ACTIONS(3695),
    [anon_sym_PERCENT_EQ] = ACTIONS(3695),
    [anon_sym_x_EQ] = ACTIONS(3697),
    [anon_sym_AMP_EQ] = ACTIONS(3695),
    [anon_sym_PIPE_EQ] = ACTIONS(3695),
    [anon_sym_CARET_EQ] = ACTIONS(3695),
    [anon_sym_LT_LT_EQ] = ACTIONS(3695),
    [anon_sym_GT_GT_EQ] = ACTIONS(3695),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3695),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3695),
    [anon_sym_DOT_DOT] = ACTIONS(3697),
    [anon_sym_STAR_STAR] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_SLASH_SLASH] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_GT_GT2] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_x] = ACTIONS(3697),
    [anon_sym_EQ_TILDE] = ACTIONS(3695),
    [anon_sym_BANG_TILDE] = ACTIONS(3695),
    [anon_sym_EQ_EQ] = ACTIONS(3695),
    [anon_sym_BANG_EQ] = ACTIONS(3695),
    [anon_sym_eq] = ACTIONS(3695),
    [anon_sym_ne] = ACTIONS(3697),
    [anon_sym_LT_EQ_GT] = ACTIONS(3695),
    [anon_sym_cmp] = ACTIONS(3695),
    [anon_sym_TILDE_TILDE] = ACTIONS(3695),
    [anon_sym_LT_EQ] = ACTIONS(3697),
    [anon_sym_GT_EQ] = ACTIONS(3695),
    [anon_sym_lt] = ACTIONS(3697),
    [anon_sym_le] = ACTIONS(3697),
    [anon_sym_ge] = ACTIONS(3695),
    [anon_sym_gt] = ACTIONS(3695),
    [anon_sym_isa] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3695),
    [anon_sym_QMARK] = ACTIONS(3695),
    [anon_sym_EQ_GT] = ACTIONS(3695),
    [sym_comment] = ACTIONS(5),
    [sym_quoted_regexp_modifiers] = ACTIONS(4624),
    [sym__PERLY_SEMICOLON] = ACTIONS(3695),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1711] = {
    [sym_heredoc_content] = STATE(1711),
    [anon_sym_COLON] = ACTIONS(4626),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_COMMA] = ACTIONS(3725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3725),
    [anon_sym_DASH_GT] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_EQ] = ACTIONS(3727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3725),
    [anon_sym_PLUS_EQ] = ACTIONS(3725),
    [anon_sym_DASH_EQ] = ACTIONS(3725),
    [anon_sym_DOT_EQ] = ACTIONS(3725),
    [anon_sym_STAR_EQ] = ACTIONS(3725),
    [anon_sym_SLASH_EQ] = ACTIONS(3725),
    [anon_sym_PERCENT_EQ] = ACTIONS(3725),
    [anon_sym_x_EQ] = ACTIONS(3725),
    [anon_sym_AMP_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_EQ] = ACTIONS(3725),
    [anon_sym_CARET_EQ] = ACTIONS(3725),
    [anon_sym_LT_LT_EQ] = ACTIONS(3725),
    [anon_sym_GT_GT_EQ] = ACTIONS(3725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3725),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3725),
    [anon_sym_DOT_DOT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_SLASH_SLASH] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3727),
    [anon_sym_GT_GT2] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_SLASH] = ACTIONS(3727),
    [anon_sym_x] = ACTIONS(3727),
    [anon_sym_EQ_TILDE] = ACTIONS(3725),
    [anon_sym_BANG_TILDE] = ACTIONS(3725),
    [anon_sym_EQ_EQ] = ACTIONS(3725),
    [anon_sym_BANG_EQ] = ACTIONS(3725),
    [anon_sym_eq] = ACTIONS(3725),
    [anon_sym_ne] = ACTIONS(3725),
    [anon_sym_LT_EQ_GT] = ACTIONS(3725),
    [anon_sym_cmp] = ACTIONS(3725),
    [anon_sym_TILDE_TILDE] = ACTIONS(3725),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3725),
    [anon_sym_lt] = ACTIONS(3725),
    [anon_sym_le] = ACTIONS(3725),
    [anon_sym_ge] = ACTIONS(3725),
    [anon_sym_gt] = ACTIONS(3725),
    [anon_sym_isa] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3725),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3725),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1712] = {
    [sym_heredoc_content] = STATE(1712),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(3703),
    [anon_sym_LT_LT] = ACTIONS(3703),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3701),
    [anon_sym_DASH_EQ] = ACTIONS(3701),
    [anon_sym_DOT_EQ] = ACTIONS(3701),
    [anon_sym_STAR_EQ] = ACTIONS(3701),
    [anon_sym_SLASH_EQ] = ACTIONS(3701),
    [anon_sym_PERCENT_EQ] = ACTIONS(3701),
    [anon_sym_x_EQ] = ACTIONS(3703),
    [anon_sym_AMP_EQ] = ACTIONS(3701),
    [anon_sym_PIPE_EQ] = ACTIONS(3701),
    [anon_sym_CARET_EQ] = ACTIONS(3701),
    [anon_sym_LT_LT_EQ] = ACTIONS(3701),
    [anon_sym_GT_GT_EQ] = ACTIONS(3701),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3701),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3701),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_STAR_STAR] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH] = ACTIONS(3703),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_GT_GT2] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3703),
    [anon_sym_SLASH] = ACTIONS(3703),
    [anon_sym_x] = ACTIONS(3703),
    [anon_sym_EQ_TILDE] = ACTIONS(3701),
    [anon_sym_BANG_TILDE] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_eq] = ACTIONS(3701),
    [anon_sym_ne] = ACTIONS(3703),
    [anon_sym_LT_EQ_GT] = ACTIONS(3701),
    [anon_sym_cmp] = ACTIONS(3701),
    [anon_sym_TILDE_TILDE] = ACTIONS(3701),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3701),
    [anon_sym_lt] = ACTIONS(3703),
    [anon_sym_le] = ACTIONS(3703),
    [anon_sym_ge] = ACTIONS(3701),
    [anon_sym_gt] = ACTIONS(3701),
    [anon_sym_isa] = ACTIONS(3703),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_EQ_GT] = ACTIONS(3701),
    [sym_comment] = ACTIONS(5),
    [sym_quoted_regexp_modifiers] = ACTIONS(4628),
    [sym__PERLY_SEMICOLON] = ACTIONS(3701),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1713] = {
    [sym_heredoc_content] = STATE(1713),
    [anon_sym_SEMI] = ACTIONS(3590),
    [anon_sym_LPAREN] = ACTIONS(4630),
    [anon_sym_COMMA] = ACTIONS(3590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3590),
    [anon_sym_DASH_GT] = ACTIONS(3590),
    [anon_sym_PERCENT] = ACTIONS(3594),
    [anon_sym_LT] = ACTIONS(3594),
    [anon_sym_GT] = ACTIONS(3594),
    [anon_sym_LT_LT] = ACTIONS(3594),
    [anon_sym_EQ] = ACTIONS(3594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3590),
    [anon_sym_PLUS_EQ] = ACTIONS(3590),
    [anon_sym_DASH_EQ] = ACTIONS(3590),
    [anon_sym_DOT_EQ] = ACTIONS(3590),
    [anon_sym_STAR_EQ] = ACTIONS(3590),
    [anon_sym_SLASH_EQ] = ACTIONS(3590),
    [anon_sym_PERCENT_EQ] = ACTIONS(3590),
    [anon_sym_x_EQ] = ACTIONS(3590),
    [anon_sym_AMP_EQ] = ACTIONS(3590),
    [anon_sym_PIPE_EQ] = ACTIONS(3590),
    [anon_sym_CARET_EQ] = ACTIONS(3590),
    [anon_sym_LT_LT_EQ] = ACTIONS(3590),
    [anon_sym_GT_GT_EQ] = ACTIONS(3590),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3590),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3590),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3590),
    [anon_sym_DOT_DOT] = ACTIONS(3594),
    [anon_sym_STAR_STAR] = ACTIONS(3594),
    [anon_sym_PIPE_PIPE] = ACTIONS(3594),
    [anon_sym_SLASH_SLASH] = ACTIONS(3594),
    [anon_sym_AMP_AMP] = ACTIONS(3594),
    [anon_sym_PIPE] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(3594),
    [anon_sym_GT_GT2] = ACTIONS(3594),
    [anon_sym_PLUS] = ACTIONS(3594),
    [anon_sym_DASH] = ACTIONS(3594),
    [anon_sym_DOT] = ACTIONS(3594),
    [anon_sym_STAR] = ACTIONS(3594),
    [anon_sym_SLASH] = ACTIONS(3594),
    [anon_sym_x] = ACTIONS(3594),
    [anon_sym_EQ_TILDE] = ACTIONS(3590),
    [anon_sym_BANG_TILDE] = ACTIONS(3590),
    [anon_sym_EQ_EQ] = ACTIONS(3590),
    [anon_sym_BANG_EQ] = ACTIONS(3590),
    [anon_sym_eq] = ACTIONS(3590),
    [anon_sym_ne] = ACTIONS(3590),
    [anon_sym_LT_EQ_GT] = ACTIONS(3590),
    [anon_sym_cmp] = ACTIONS(3590),
    [anon_sym_TILDE_TILDE] = ACTIONS(3590),
    [anon_sym_LT_EQ] = ACTIONS(3594),
    [anon_sym_GT_EQ] = ACTIONS(3590),
    [anon_sym_lt] = ACTIONS(3590),
    [anon_sym_le] = ACTIONS(3590),
    [anon_sym_ge] = ACTIONS(3590),
    [anon_sym_gt] = ACTIONS(3590),
    [anon_sym_isa] = ACTIONS(3590),
    [anon_sym_PLUS_PLUS] = ACTIONS(3590),
    [anon_sym_DASH_DASH] = ACTIONS(3590),
    [anon_sym_QMARK] = ACTIONS(3590),
    [anon_sym_EQ_GT] = ACTIONS(3590),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3590),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1714] = {
    [sym_heredoc_content] = STATE(1714),
    [anon_sym_COLON] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DASH_GT] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(3809),
    [anon_sym_GT] = ACTIONS(3809),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_EQ] = ACTIONS(3809),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3807),
    [anon_sym_PLUS_EQ] = ACTIONS(3807),
    [anon_sym_DASH_EQ] = ACTIONS(3807),
    [anon_sym_DOT_EQ] = ACTIONS(3807),
    [anon_sym_STAR_EQ] = ACTIONS(3807),
    [anon_sym_SLASH_EQ] = ACTIONS(3807),
    [anon_sym_PERCENT_EQ] = ACTIONS(3807),
    [anon_sym_x_EQ] = ACTIONS(3807),
    [anon_sym_AMP_EQ] = ACTIONS(3807),
    [anon_sym_PIPE_EQ] = ACTIONS(3807),
    [anon_sym_CARET_EQ] = ACTIONS(3807),
    [anon_sym_LT_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT_GT_EQ] = ACTIONS(3807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3807),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3809),
    [anon_sym_STAR_STAR] = ACTIONS(3809),
    [anon_sym_PIPE_PIPE] = ACTIONS(3809),
    [anon_sym_SLASH_SLASH] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3809),
    [anon_sym_PIPE] = ACTIONS(3809),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_GT_GT2] = ACTIONS(3809),
    [anon_sym_PLUS] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3809),
    [anon_sym_DOT] = ACTIONS(3809),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_SLASH] = ACTIONS(3809),
    [anon_sym_x] = ACTIONS(3809),
    [anon_sym_EQ_TILDE] = ACTIONS(3807),
    [anon_sym_BANG_TILDE] = ACTIONS(3807),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3807),
    [anon_sym_eq] = ACTIONS(3807),
    [anon_sym_ne] = ACTIONS(3807),
    [anon_sym_LT_EQ_GT] = ACTIONS(3807),
    [anon_sym_cmp] = ACTIONS(3807),
    [anon_sym_TILDE_TILDE] = ACTIONS(3807),
    [anon_sym_LT_EQ] = ACTIONS(3809),
    [anon_sym_GT_EQ] = ACTIONS(3807),
    [anon_sym_lt] = ACTIONS(3807),
    [anon_sym_le] = ACTIONS(3807),
    [anon_sym_ge] = ACTIONS(3807),
    [anon_sym_gt] = ACTIONS(3807),
    [anon_sym_isa] = ACTIONS(3807),
    [anon_sym_PLUS_PLUS] = ACTIONS(3807),
    [anon_sym_DASH_DASH] = ACTIONS(3807),
    [anon_sym_QMARK] = ACTIONS(3807),
    [anon_sym_EQ_GT] = ACTIONS(3807),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3807),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1715] = {
    [sym_heredoc_content] = STATE(1715),
    [anon_sym_COLON] = ACTIONS(3741),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3741),
    [anon_sym_DASH_GT] = ACTIONS(3741),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_LT] = ACTIONS(3743),
    [anon_sym_GT] = ACTIONS(3743),
    [anon_sym_LT_LT] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3741),
    [anon_sym_PLUS_EQ] = ACTIONS(3741),
    [anon_sym_DASH_EQ] = ACTIONS(3741),
    [anon_sym_DOT_EQ] = ACTIONS(3741),
    [anon_sym_STAR_EQ] = ACTIONS(3741),
    [anon_sym_SLASH_EQ] = ACTIONS(3741),
    [anon_sym_PERCENT_EQ] = ACTIONS(3741),
    [anon_sym_x_EQ] = ACTIONS(3741),
    [anon_sym_AMP_EQ] = ACTIONS(3741),
    [anon_sym_PIPE_EQ] = ACTIONS(3741),
    [anon_sym_CARET_EQ] = ACTIONS(3741),
    [anon_sym_LT_LT_EQ] = ACTIONS(3741),
    [anon_sym_GT_GT_EQ] = ACTIONS(3741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3741),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3741),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3741),
    [anon_sym_DOT_DOT] = ACTIONS(3743),
    [anon_sym_STAR_STAR] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_SLASH_SLASH] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_GT_GT2] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_SLASH] = ACTIONS(3743),
    [anon_sym_x] = ACTIONS(3743),
    [anon_sym_EQ_TILDE] = ACTIONS(3741),
    [anon_sym_BANG_TILDE] = ACTIONS(3741),
    [anon_sym_EQ_EQ] = ACTIONS(3741),
    [anon_sym_BANG_EQ] = ACTIONS(3741),
    [anon_sym_eq] = ACTIONS(3741),
    [anon_sym_ne] = ACTIONS(3741),
    [anon_sym_LT_EQ_GT] = ACTIONS(3741),
    [anon_sym_cmp] = ACTIONS(3741),
    [anon_sym_TILDE_TILDE] = ACTIONS(3741),
    [anon_sym_LT_EQ] = ACTIONS(3743),
    [anon_sym_GT_EQ] = ACTIONS(3741),
    [anon_sym_lt] = ACTIONS(3741),
    [anon_sym_le] = ACTIONS(3741),
    [anon_sym_ge] = ACTIONS(3741),
    [anon_sym_gt] = ACTIONS(3741),
    [anon_sym_isa] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(3741),
    [anon_sym_EQ_GT] = ACTIONS(3741),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3741),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1716] = {
    [sym_heredoc_content] = STATE(1716),
    [anon_sym_SEMI] = ACTIONS(3637),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(4543),
    [anon_sym_DASH_GT] = ACTIONS(3637),
    [anon_sym_PERCENT] = ACTIONS(3639),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_LT_LT] = ACTIONS(3639),
    [anon_sym_EQ] = ACTIONS(3639),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3637),
    [anon_sym_PLUS_EQ] = ACTIONS(3637),
    [anon_sym_DASH_EQ] = ACTIONS(3637),
    [anon_sym_DOT_EQ] = ACTIONS(3637),
    [anon_sym_STAR_EQ] = ACTIONS(3637),
    [anon_sym_SLASH_EQ] = ACTIONS(3637),
    [anon_sym_PERCENT_EQ] = ACTIONS(3637),
    [anon_sym_x_EQ] = ACTIONS(3637),
    [anon_sym_AMP_EQ] = ACTIONS(3637),
    [anon_sym_PIPE_EQ] = ACTIONS(3637),
    [anon_sym_CARET_EQ] = ACTIONS(3637),
    [anon_sym_LT_LT_EQ] = ACTIONS(3637),
    [anon_sym_GT_GT_EQ] = ACTIONS(3637),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3637),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3637),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3637),
    [anon_sym_DOT_DOT] = ACTIONS(3639),
    [anon_sym_STAR_STAR] = ACTIONS(3639),
    [anon_sym_PIPE_PIPE] = ACTIONS(3639),
    [anon_sym_SLASH_SLASH] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_GT_GT2] = ACTIONS(3639),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_DOT] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [anon_sym_x] = ACTIONS(3639),
    [anon_sym_EQ_TILDE] = ACTIONS(3637),
    [anon_sym_BANG_TILDE] = ACTIONS(3637),
    [anon_sym_EQ_EQ] = ACTIONS(3637),
    [anon_sym_BANG_EQ] = ACTIONS(3637),
    [anon_sym_eq] = ACTIONS(3637),
    [anon_sym_ne] = ACTIONS(3637),
    [anon_sym_LT_EQ_GT] = ACTIONS(3637),
    [anon_sym_cmp] = ACTIONS(3637),
    [anon_sym_TILDE_TILDE] = ACTIONS(3637),
    [anon_sym_LT_EQ] = ACTIONS(3639),
    [anon_sym_GT_EQ] = ACTIONS(3637),
    [anon_sym_lt] = ACTIONS(3637),
    [anon_sym_le] = ACTIONS(3637),
    [anon_sym_ge] = ACTIONS(3637),
    [anon_sym_gt] = ACTIONS(3637),
    [anon_sym_isa] = ACTIONS(3637),
    [anon_sym_PLUS_PLUS] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3637),
    [anon_sym_QMARK] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(3637),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3637),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1717] = {
    [sym_heredoc_content] = STATE(1717),
    [anon_sym_SEMI] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3600),
    [anon_sym_DASH_GT] = ACTIONS(3600),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_LT_LT] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3600),
    [anon_sym_PLUS_EQ] = ACTIONS(3600),
    [anon_sym_DASH_EQ] = ACTIONS(3600),
    [anon_sym_DOT_EQ] = ACTIONS(3600),
    [anon_sym_STAR_EQ] = ACTIONS(3600),
    [anon_sym_SLASH_EQ] = ACTIONS(3600),
    [anon_sym_PERCENT_EQ] = ACTIONS(3600),
    [anon_sym_x_EQ] = ACTIONS(3602),
    [anon_sym_AMP_EQ] = ACTIONS(3600),
    [anon_sym_PIPE_EQ] = ACTIONS(3600),
    [anon_sym_CARET_EQ] = ACTIONS(3600),
    [anon_sym_LT_LT_EQ] = ACTIONS(3600),
    [anon_sym_GT_GT_EQ] = ACTIONS(3600),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3600),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3600),
    [anon_sym_DOT_DOT] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_SLASH_SLASH] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_GT_GT2] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_STAR] = ACTIONS(3602),
    [anon_sym_SLASH] = ACTIONS(3602),
    [anon_sym_x] = ACTIONS(3602),
    [anon_sym_EQ_TILDE] = ACTIONS(3600),
    [anon_sym_BANG_TILDE] = ACTIONS(3600),
    [anon_sym_EQ_EQ] = ACTIONS(3600),
    [anon_sym_BANG_EQ] = ACTIONS(3600),
    [anon_sym_eq] = ACTIONS(3600),
    [anon_sym_ne] = ACTIONS(3602),
    [anon_sym_LT_EQ_GT] = ACTIONS(3600),
    [anon_sym_cmp] = ACTIONS(3602),
    [anon_sym_TILDE_TILDE] = ACTIONS(3600),
    [anon_sym_LT_EQ] = ACTIONS(3602),
    [anon_sym_GT_EQ] = ACTIONS(3600),
    [anon_sym_lt] = ACTIONS(3602),
    [anon_sym_le] = ACTIONS(3602),
    [anon_sym_ge] = ACTIONS(3602),
    [anon_sym_gt] = ACTIONS(3602),
    [anon_sym_isa] = ACTIONS(3602),
    [anon_sym_PLUS_PLUS] = ACTIONS(3600),
    [anon_sym_DASH_DASH] = ACTIONS(3600),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_GT] = ACTIONS(3600),
    [sym_comment] = ACTIONS(5),
    [sym_match_regexp_modifiers] = ACTIONS(4632),
    [sym__PERLY_SEMICOLON] = ACTIONS(3600),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1718] = {
    [sym_heredoc_content] = STATE(1718),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3799),
    [anon_sym_COMMA] = ACTIONS(3799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3799),
    [anon_sym_DASH_GT] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(3801),
    [anon_sym_LT] = ACTIONS(3801),
    [anon_sym_GT] = ACTIONS(3801),
    [anon_sym_LT_LT] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(3801),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3799),
    [anon_sym_PLUS_EQ] = ACTIONS(3799),
    [anon_sym_DASH_EQ] = ACTIONS(3799),
    [anon_sym_DOT_EQ] = ACTIONS(3799),
    [anon_sym_STAR_EQ] = ACTIONS(3799),
    [anon_sym_SLASH_EQ] = ACTIONS(3799),
    [anon_sym_PERCENT_EQ] = ACTIONS(3799),
    [anon_sym_x_EQ] = ACTIONS(3799),
    [anon_sym_AMP_EQ] = ACTIONS(3799),
    [anon_sym_PIPE_EQ] = ACTIONS(3799),
    [anon_sym_CARET_EQ] = ACTIONS(3799),
    [anon_sym_LT_LT_EQ] = ACTIONS(3799),
    [anon_sym_GT_GT_EQ] = ACTIONS(3799),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3799),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3799),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3799),
    [anon_sym_DOT_DOT] = ACTIONS(3801),
    [anon_sym_STAR_STAR] = ACTIONS(3801),
    [anon_sym_PIPE_PIPE] = ACTIONS(3801),
    [anon_sym_SLASH_SLASH] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_PIPE] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3801),
    [anon_sym_GT_GT2] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_DOT] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_SLASH] = ACTIONS(3801),
    [anon_sym_x] = ACTIONS(3801),
    [anon_sym_EQ_TILDE] = ACTIONS(3799),
    [anon_sym_BANG_TILDE] = ACTIONS(3799),
    [anon_sym_EQ_EQ] = ACTIONS(3799),
    [anon_sym_BANG_EQ] = ACTIONS(3799),
    [anon_sym_eq] = ACTIONS(3799),
    [anon_sym_ne] = ACTIONS(3799),
    [anon_sym_LT_EQ_GT] = ACTIONS(3799),
    [anon_sym_cmp] = ACTIONS(3799),
    [anon_sym_TILDE_TILDE] = ACTIONS(3799),
    [anon_sym_LT_EQ] = ACTIONS(3801),
    [anon_sym_GT_EQ] = ACTIONS(3799),
    [anon_sym_lt] = ACTIONS(3799),
    [anon_sym_le] = ACTIONS(3799),
    [anon_sym_ge] = ACTIONS(3799),
    [anon_sym_gt] = ACTIONS(3799),
    [anon_sym_isa] = ACTIONS(3799),
    [anon_sym_PLUS_PLUS] = ACTIONS(3799),
    [anon_sym_DASH_DASH] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3799),
    [anon_sym_EQ_GT] = ACTIONS(3799),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3799),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1719] = {
    [sym_heredoc_content] = STATE(1719),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(4572),
    [anon_sym_DASH_GT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [anon_sym_LT] = ACTIONS(3763),
    [anon_sym_GT] = ACTIONS(3763),
    [anon_sym_LT_LT] = ACTIONS(3763),
    [anon_sym_EQ] = ACTIONS(3763),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_DOT_EQ] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_x_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_DOT_DOT] = ACTIONS(3763),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_PIPE_PIPE] = ACTIONS(3763),
    [anon_sym_SLASH_SLASH] = ACTIONS(3763),
    [anon_sym_AMP_AMP] = ACTIONS(3763),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_GT_GT2] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_DOT] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3763),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_x] = ACTIONS(3763),
    [anon_sym_EQ_TILDE] = ACTIONS(3759),
    [anon_sym_BANG_TILDE] = ACTIONS(3759),
    [anon_sym_EQ_EQ] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_eq] = ACTIONS(3759),
    [anon_sym_ne] = ACTIONS(3759),
    [anon_sym_LT_EQ_GT] = ACTIONS(3759),
    [anon_sym_cmp] = ACTIONS(3759),
    [anon_sym_TILDE_TILDE] = ACTIONS(3759),
    [anon_sym_LT_EQ] = ACTIONS(3763),
    [anon_sym_GT_EQ] = ACTIONS(3759),
    [anon_sym_lt] = ACTIONS(3759),
    [anon_sym_le] = ACTIONS(3759),
    [anon_sym_ge] = ACTIONS(3759),
    [anon_sym_gt] = ACTIONS(3759),
    [anon_sym_isa] = ACTIONS(3759),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_EQ_GT] = ACTIONS(3759),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3759),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1720] = {
    [sym_heredoc_content] = STATE(1720),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3713),
    [anon_sym_DASH_GT] = ACTIONS(3713),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3713),
    [anon_sym_PLUS_EQ] = ACTIONS(3713),
    [anon_sym_DASH_EQ] = ACTIONS(3713),
    [anon_sym_DOT_EQ] = ACTIONS(3713),
    [anon_sym_STAR_EQ] = ACTIONS(3713),
    [anon_sym_SLASH_EQ] = ACTIONS(3713),
    [anon_sym_PERCENT_EQ] = ACTIONS(3713),
    [anon_sym_x_EQ] = ACTIONS(3713),
    [anon_sym_AMP_EQ] = ACTIONS(3713),
    [anon_sym_PIPE_EQ] = ACTIONS(3713),
    [anon_sym_CARET_EQ] = ACTIONS(3713),
    [anon_sym_LT_LT_EQ] = ACTIONS(3713),
    [anon_sym_GT_GT_EQ] = ACTIONS(3713),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3713),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3713),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3713),
    [anon_sym_DOT_DOT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_SLASH_SLASH] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_GT_GT2] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_x] = ACTIONS(3715),
    [anon_sym_EQ_TILDE] = ACTIONS(3713),
    [anon_sym_BANG_TILDE] = ACTIONS(3713),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_eq] = ACTIONS(3713),
    [anon_sym_ne] = ACTIONS(3713),
    [anon_sym_LT_EQ_GT] = ACTIONS(3713),
    [anon_sym_cmp] = ACTIONS(3715),
    [anon_sym_TILDE_TILDE] = ACTIONS(3713),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3713),
    [anon_sym_lt] = ACTIONS(3713),
    [anon_sym_le] = ACTIONS(3713),
    [anon_sym_ge] = ACTIONS(3713),
    [anon_sym_gt] = ACTIONS(3713),
    [anon_sym_isa] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_EQ_GT] = ACTIONS(3713),
    [sym_comment] = ACTIONS(5),
    [sym_transliteration_modifiers] = ACTIONS(4634),
    [sym__PERLY_SEMICOLON] = ACTIONS(3713),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
  [1721] = {
    [sym_heredoc_content] = STATE(1721),
    [anon_sym_COLON] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_COMMA] = ACTIONS(3613),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3613),
    [anon_sym_DASH_GT] = ACTIONS(3613),
    [anon_sym_PERCENT] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_LT_LT] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3615),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3613),
    [anon_sym_PLUS_EQ] = ACTIONS(3613),
    [anon_sym_DASH_EQ] = ACTIONS(3613),
    [anon_sym_DOT_EQ] = ACTIONS(3613),
    [anon_sym_STAR_EQ] = ACTIONS(3613),
    [anon_sym_SLASH_EQ] = ACTIONS(3613),
    [anon_sym_PERCENT_EQ] = ACTIONS(3613),
    [anon_sym_x_EQ] = ACTIONS(3613),
    [anon_sym_AMP_EQ] = ACTIONS(3613),
    [anon_sym_PIPE_EQ] = ACTIONS(3613),
    [anon_sym_CARET_EQ] = ACTIONS(3613),
    [anon_sym_LT_LT_EQ] = ACTIONS(3613),
    [anon_sym_GT_GT_EQ] = ACTIONS(3613),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3613),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3613),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3613),
    [anon_sym_DOT_DOT] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3615),
    [anon_sym_PIPE_PIPE] = ACTIONS(3615),
    [anon_sym_SLASH_SLASH] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_GT_GT2] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DOT] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_SLASH] = ACTIONS(3615),
    [anon_sym_x] = ACTIONS(3615),
    [anon_sym_EQ_TILDE] = ACTIONS(3613),
    [anon_sym_BANG_TILDE] = ACTIONS(3613),
    [anon_sym_EQ_EQ] = ACTIONS(3613),
    [anon_sym_BANG_EQ] = ACTIONS(3613),
    [anon_sym_eq] = ACTIONS(3613),
    [anon_sym_ne] = ACTIONS(3613),
    [anon_sym_LT_EQ_GT] = ACTIONS(3613),
    [anon_sym_cmp] = ACTIONS(3613),
    [anon_sym_TILDE_TILDE] = ACTIONS(3613),
    [anon_sym_LT_EQ] = ACTIONS(3615),
    [anon_sym_GT_EQ] = ACTIONS(3613),
    [anon_sym_lt] = ACTIONS(3613),
    [anon_sym_le] = ACTIONS(3613),
    [anon_sym_ge] = ACTIONS(3613),
    [anon_sym_gt] = ACTIONS(3613),
    [anon_sym_isa] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_EQ_GT] = ACTIONS(3613),
    [sym_comment] = ACTIONS(5),
    [sym__PERLY_SEMICOLON] = ACTIONS(3613),
    [sym_pod] = ACTIONS(5),
    [sym__heredoc_start] = ACTIONS(7),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1722), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4060), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4058), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [75] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4636), 1,
      anon_sym_isa,
    STATE(1723), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3833), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3831), 29,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [170] = 27,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3789), 1,
      anon_sym_RPAREN,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1724), 1,
      sym_heredoc_content,
    STATE(2717), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4638), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [289] = 27,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3789), 1,
      anon_sym_RPAREN,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1725), 1,
      sym_heredoc_content,
    STATE(1745), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4678), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [408] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4680), 1,
      anon_sym_COLON,
    STATE(1726), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3564), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3562), 39,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [485] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4682), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3727), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3725), 39,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [562] = 24,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4156), 1,
      anon_sym_EQ,
    ACTIONS(4578), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    ACTIONS(4618), 1,
      anon_sym_QMARK,
    STATE(1728), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4154), 20,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_GT,
  [675] = 19,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    STATE(1729), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(3827), 5,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 22,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [778] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4614), 1,
      anon_sym_isa,
    STATE(1730), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4684), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 22,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [877] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4614), 1,
      anon_sym_isa,
    STATE(1731), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 29,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [972] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1732), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 37,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1053] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1733), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 15,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_LT_EQ,
    ACTIONS(3823), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1138] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4614), 1,
      anon_sym_isa,
    STATE(1734), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3823), 22,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1237] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    STATE(1735), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 6,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3823), 22,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1338] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1736), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4136), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4134), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1413] = 20,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    STATE(1737), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(3827), 4,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 22,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1518] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1738), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 37,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1599] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4578), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4588), 1,
      anon_sym_EQ,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    ACTIONS(4618), 1,
      anon_sym_QMARK,
    STATE(1739), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(3835), 4,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4590), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [1714] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1740), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_LT_EQ,
    ACTIONS(3823), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1801] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1741), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3833), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(3831), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1890] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1742), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [1973] = 23,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3827), 1,
      anon_sym_EQ,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    ACTIONS(4686), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4688), 1,
      anon_sym_DOT_DOT,
    STATE(1743), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 21,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [2084] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4578), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4588), 1,
      anon_sym_EQ,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    ACTIONS(4618), 1,
      anon_sym_QMARK,
    STATE(1744), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(3606), 4,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4590), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [2199] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1745), 1,
      sym_heredoc_content,
    STATE(1747), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4690), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(3627), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3623), 37,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [2278] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1746), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4082), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4080), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [2367] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4692), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    STATE(1747), 2,
      sym_heredoc_content,
      aux_sym__term_rightward_repeat1,
    ACTIONS(3611), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3606), 37,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [2444] = 27,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3789), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4705), 1,
      anon_sym_EQ,
    ACTIONS(4709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    ACTIONS(4733), 1,
      anon_sym_QMARK,
    STATE(1748), 1,
      sym_heredoc_content,
    STATE(1750), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4695), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4713), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4707), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [2563] = 27,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3789), 1,
      anon_sym_RPAREN,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1749), 1,
      sym_heredoc_content,
    STATE(1753), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4735), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [2682] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1750), 1,
      sym_heredoc_content,
    STATE(1751), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4737), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(3627), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3623), 37,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [2761] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4739), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    STATE(1751), 2,
      sym_heredoc_content,
      aux_sym__term_rightward_repeat1,
    ACTIONS(3611), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3606), 37,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [2838] = 27,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3789), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4705), 1,
      anon_sym_EQ,
    ACTIONS(4709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    ACTIONS(4733), 1,
      anon_sym_QMARK,
    STATE(1752), 1,
      sym_heredoc_content,
    STATE(1754), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4713), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4742), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4707), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [2957] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1747), 1,
      aux_sym__term_rightward_repeat1,
    STATE(1753), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4744), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(3627), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3623), 37,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [3036] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1751), 1,
      aux_sym__term_rightward_repeat1,
    STATE(1754), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4746), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(3627), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3623), 37,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [3115] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1755), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4248), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4246), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3204] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1756), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3963), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3961), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3279] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1757), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3975), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3973), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3354] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1758), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4208), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4206), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3429] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1759), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4184), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4182), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3504] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1760), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4056), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4054), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3579] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1761), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4212), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4210), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3654] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1762), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4022), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4020), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3729] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1763), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4018), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4016), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3804] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1764), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3983), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3981), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3879] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1765), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3971), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3969), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [3954] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1766), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3955), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3953), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4029] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1767), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3939), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3937), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4104] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1768), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3919), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3917), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4179] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1769), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3879), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3877), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4254] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1770), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3871), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3869), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4329] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1771), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3865), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3863), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4404] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1772), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3857), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3855), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4479] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1773), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4200), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4198), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4554] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1774), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4192), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4190), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4629] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1775), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4164), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4162), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4704] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1776), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4038), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4036), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4779] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1777), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3987), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3985), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4854] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1778), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4224), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4222), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [4929] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1779), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3841), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3839), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5004] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1780), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3845), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3843), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5079] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1781), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4098), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4096), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5154] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1782), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3895), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3893), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5229] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1783), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4030), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4028), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5304] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1784), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3979), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3977), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5379] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1785), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4188), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4186), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5454] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1786), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4110), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4108), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5529] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1787), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4106), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4104), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5604] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1788), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3821), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3819), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5679] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1789), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4072), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4070), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5754] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1790), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3861), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3859), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5829] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1791), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3853), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3851), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5904] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1792), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3849), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3847), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [5979] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1793), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4228), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4226), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6054] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1794), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4204), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4202), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6129] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1795), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4152), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4150), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6204] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1796), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4196), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4194), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6279] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1797), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4102), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4100), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6354] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1798), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4172), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4170), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6429] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1799), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3875), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3873), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6504] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1800), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4144), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4142), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6579] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1801), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4252), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4250), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6654] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1802), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4220), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4218), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6729] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1803), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4076), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4074), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6804] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1804), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4042), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4040), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6879] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1805), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3959), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3957), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [6954] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1806), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3951), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3949), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7029] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1807), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3915), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3913), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7104] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1808), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3911), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3909), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7179] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1809), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3883), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3881), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7254] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1810), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4046), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4044), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7329] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1811), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4086), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4084), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7404] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1812), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4094), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4092), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7479] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1813), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4034), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4032), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7554] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1814), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3903), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3901), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7629] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1815), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3943), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3941), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7704] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1816), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3967), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3965), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7779] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1817), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2944), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3867), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7854] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1818), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3991), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3989), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [7929] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1819), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4014), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4012), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8004] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1820), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4026), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4024), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8079] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1821), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4748), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4052), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4048), 38,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [8156] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1822), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4052), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4048), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8231] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1823), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4122), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4120), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8306] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1824), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4176), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4174), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8381] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1825), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4216), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4214), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8470] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1826), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4260), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4258), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8545] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1827), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4256), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4254), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8620] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1828), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4244), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4242), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8695] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1829), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4240), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4238), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8770] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1830), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4236), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4234), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [8845] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4578), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4588), 1,
      anon_sym_EQ,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    ACTIONS(4618), 1,
      anon_sym_QMARK,
    STATE(1831), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4230), 4,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4590), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [8960] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1832), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4118), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4116), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9035] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1833), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4090), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4088), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9124] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1834), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4068), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4066), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9213] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1835), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4064), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4062), 35,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9302] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1836), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4064), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4062), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9377] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1837), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4010), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4008), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9452] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4578), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4588), 1,
      anon_sym_EQ,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP,
    ACTIONS(4614), 1,
      anon_sym_isa,
    ACTIONS(4618), 1,
      anon_sym_QMARK,
    STATE(1838), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4586), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4606), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4584), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4604), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4610), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4004), 4,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4582), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4608), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4612), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4590), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [9567] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    STATE(1839), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3999), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3997), 37,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9646] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1840), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3995), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3993), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9721] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1841), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(137), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(255), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9796] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4580), 1,
      anon_sym_DASH_GT,
    ACTIONS(4594), 1,
      anon_sym_STAR_STAR,
    STATE(1842), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4616), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3923), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3921), 37,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9877] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1843), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3927), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3925), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [9952] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1844), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3931), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3929), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10027] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1845), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3935), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3933), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10102] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1846), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4148), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4146), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10177] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1847), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3817), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3815), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10252] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1848), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4160), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4158), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10327] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1849), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4168), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4166), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10402] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1850), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4180), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4178), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10477] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1851), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4140), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4138), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10552] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1852), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4132), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4130), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10627] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1853), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4114), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4112), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10702] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1854), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3899), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3897), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10777] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1855), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3891), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3889), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10852] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1856), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2929), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(2936), 40,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [10927] = 19,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    STATE(1857), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(3827), 5,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11029] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1858), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 36,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11109] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1859), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_LT_EQ,
    ACTIONS(3823), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11195] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1860), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3833), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(3831), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11283] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1861), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11365] = 23,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3827), 1,
      anon_sym_EQ,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    ACTIONS(4753), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4755), 1,
      anon_sym_DOT_DOT,
    STATE(1862), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4713), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11475] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1863), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4082), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4080), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11563] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1864), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3833), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(3831), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11651] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1865), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11733] = 24,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4156), 1,
      anon_sym_EQ,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1866), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4154), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_GT,
  [11845] = 23,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3827), 1,
      anon_sym_EQ,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4757), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4759), 1,
      anon_sym_DOT_DOT,
    STATE(1867), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [11955] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1868), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3564), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3562), 39,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12029] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1869), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3727), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3725), 39,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12103] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1870), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4761), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4052), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4048), 37,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [12179] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1871), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 36,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12259] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1872), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4082), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4080), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12347] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1873), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 36,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12427] = 20,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    STATE(1874), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(3827), 4,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12531] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4763), 1,
      anon_sym_isa,
    STATE(1875), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3833), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3831), 28,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12625] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    STATE(1876), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 6,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3823), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12725] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1877), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3606), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [12839] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1878), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_LT_EQ,
    ACTIONS(3823), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [12925] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4731), 1,
      anon_sym_isa,
    STATE(1879), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3823), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [13023] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1880), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4765), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4052), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4048), 37,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [13099] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1881), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 15,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_LT_EQ,
    ACTIONS(3823), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [13183] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1882), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4216), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4214), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [13271] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1883), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3835), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [13385] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1884), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 36,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [13465] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4731), 1,
      anon_sym_isa,
    STATE(1885), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 28,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [13559] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4731), 1,
      anon_sym_isa,
    STATE(1886), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4767), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [13657] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1887), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4248), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4246), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [13745] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1888), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4230), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [13859] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1889), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4090), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4088), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [13947] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4769), 1,
      anon_sym_isa,
    STATE(1890), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3833), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3831), 28,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [14041] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1891), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4068), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4066), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [14129] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1892), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4064), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4062), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [14217] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1893), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4004), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [14331] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4674), 1,
      anon_sym_isa,
    STATE(1894), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4771), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [14429] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1895), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3923), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3921), 36,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [14509] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4674), 1,
      anon_sym_isa,
    STATE(1896), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 28,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [14603] = 24,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4156), 1,
      anon_sym_EQ,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    ACTIONS(4733), 1,
      anon_sym_QMARK,
    STATE(1897), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4713), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4154), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_GT,
  [14715] = 20,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    STATE(1898), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(3827), 4,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [14819] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4705), 1,
      anon_sym_EQ,
    ACTIONS(4709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    ACTIONS(4733), 1,
      anon_sym_QMARK,
    STATE(1899), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4713), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3835), 3,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4707), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [14933] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4674), 1,
      anon_sym_isa,
    STATE(1900), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3823), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [15031] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4705), 1,
      anon_sym_EQ,
    ACTIONS(4709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    ACTIONS(4733), 1,
      anon_sym_QMARK,
    STATE(1901), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4713), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4230), 3,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4707), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [15145] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    STATE(1902), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 6,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3823), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [15245] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1903), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4090), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4088), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [15333] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1904), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4068), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4066), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [15421] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4705), 1,
      anon_sym_EQ,
    ACTIONS(4709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    ACTIONS(4733), 1,
      anon_sym_QMARK,
    STATE(1905), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4713), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3606), 3,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4707), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [15535] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1906), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4064), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4062), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [15623] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1907), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4773), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4052), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4048), 37,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [15699] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4705), 1,
      anon_sym_EQ,
    ACTIONS(4709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4717), 1,
      anon_sym_PIPE,
    ACTIONS(4719), 1,
      anon_sym_AMP,
    ACTIONS(4731), 1,
      anon_sym_isa,
    ACTIONS(4733), 1,
      anon_sym_QMARK,
    STATE(1908), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4713), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4004), 3,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4701), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4727), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4725), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4729), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4707), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [15813] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1909), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3923), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3921), 36,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [15893] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1910), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4216), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4214), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [15981] = 19,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    STATE(1911), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(3827), 5,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [16083] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1912), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4775), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4052), 20,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(4048), 37,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
  [16159] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4711), 1,
      anon_sym_STAR_STAR,
    STATE(1913), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4723), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4721), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4699), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4248), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4246), 34,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [16247] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    STATE(1914), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 15,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_LT_EQ,
    ACTIONS(3823), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [16331] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4777), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4785), 1,
      anon_sym_EQ,
    ACTIONS(4789), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4797), 1,
      anon_sym_PIPE,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    ACTIONS(4813), 1,
      anon_sym_QMARK,
    STATE(1915), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4004), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4787), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [16444] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1916), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4068), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4066), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [16531] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1917), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4815), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [16644] = 24,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4156), 1,
      anon_sym_EQ,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4777), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4789), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4797), 1,
      anon_sym_PIPE,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    ACTIONS(4813), 1,
      anon_sym_QMARK,
    STATE(1918), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4154), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [16755] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1919), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4817), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [16868] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4819), 1,
      anon_sym_isa,
    STATE(1920), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3833), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3831), 27,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
  [16961] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4811), 1,
      anon_sym_isa,
    STATE(1921), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4821), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [17058] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1922), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4823), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [17171] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1923), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4825), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [17284] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4811), 1,
      anon_sym_isa,
    STATE(1924), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 27,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
  [17377] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1925), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 35,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [17456] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1926), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 15,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_LT_EQ,
    ACTIONS(3823), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [17539] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4777), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4785), 1,
      anon_sym_EQ,
    ACTIONS(4789), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4797), 1,
      anon_sym_PIPE,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    ACTIONS(4813), 1,
      anon_sym_QMARK,
    STATE(1927), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4246), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4787), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [17652] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4811), 1,
      anon_sym_isa,
    STATE(1928), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3823), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [17749] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1929), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4827), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [17862] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1930), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4829), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [17975] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1931), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4831), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [18088] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    STATE(1932), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 6,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3823), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [18187] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1933), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4833), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [18300] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1934), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4835), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [18413] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4837), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [18526] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1936), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4216), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4214), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [18613] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1937), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4082), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4080), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [18700] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1938), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4248), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4246), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [18787] = 19,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4797), 1,
      anon_sym_PIPE,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    STATE(1939), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(3827), 5,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [18888] = 23,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3827), 1,
      anon_sym_EQ,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4797), 1,
      anon_sym_PIPE,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    ACTIONS(4839), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4841), 1,
      anon_sym_DOT_DOT,
    STATE(1940), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [18997] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1941), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [19078] = 20,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4797), 1,
      anon_sym_PIPE,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    STATE(1942), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(3827), 4,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [19181] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1943), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3833), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(3831), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [19268] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1944), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4064), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4062), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [19355] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1945), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3923), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3921), 35,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [19434] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4777), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4785), 1,
      anon_sym_EQ,
    ACTIONS(4789), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4797), 1,
      anon_sym_PIPE,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    ACTIONS(4813), 1,
      anon_sym_QMARK,
    STATE(1946), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4230), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4787), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [19547] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4640), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4654), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4662), 1,
      anon_sym_AMP,
    ACTIONS(4674), 1,
      anon_sym_isa,
    ACTIONS(4676), 1,
      anon_sym_QMARK,
    STATE(1947), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4646), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4666), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4843), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(4644), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4664), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4670), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4642), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4668), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4672), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4650), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [19660] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1948), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_LT_EQ,
    ACTIONS(3823), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [19745] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4777), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4785), 1,
      anon_sym_EQ,
    ACTIONS(4789), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4797), 1,
      anon_sym_PIPE,
    ACTIONS(4799), 1,
      anon_sym_AMP,
    ACTIONS(4811), 1,
      anon_sym_isa,
    ACTIONS(4813), 1,
      anon_sym_QMARK,
    STATE(1949), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3835), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4781), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4807), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4805), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4809), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4787), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [19858] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1950), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 35,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [19937] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4791), 1,
      anon_sym_STAR_STAR,
    STATE(1951), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4803), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4801), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4779), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4090), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4088), 33,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [20024] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4859), 1,
      anon_sym_isa,
    STATE(1952), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3833), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3831), 26,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
  [20116] = 23,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3827), 1,
      anon_sym_EQ,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4863), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    STATE(1953), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 18,
      anon_sym_COLON,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [20224] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4879), 1,
      anon_sym_COLON,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    STATE(1954), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [20336] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    ACTIONS(4891), 1,
      anon_sym_COLON,
    STATE(1955), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [20448] = 19,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    STATE(1956), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(3827), 5,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 19,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [20548] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4877), 1,
      anon_sym_isa,
    STATE(1957), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4893), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 19,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [20644] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1958), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3833), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(3831), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [20730] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1959), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_LT_EQ,
    ACTIONS(3823), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [20814] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_COLON,
    STATE(1960), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [20926] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    ACTIONS(4897), 1,
      anon_sym_COLON,
    STATE(1961), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [21038] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1962), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4216), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4214), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [21124] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1963), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4248), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4246), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [21210] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    ACTIONS(4899), 1,
      anon_sym_COLON,
    STATE(1964), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [21322] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1965), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 34,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [21400] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3835), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    STATE(1966), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [21512] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1967), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [21592] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4230), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    STATE(1968), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [21704] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1969), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4090), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4088), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [21790] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1970), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4068), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4066), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [21876] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1971), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3923), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3921), 34,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [21954] = 24,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4156), 1,
      anon_sym_EQ,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    STATE(1972), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4154), 17,
      anon_sym_COLON,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [22064] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    ACTIONS(4901), 1,
      anon_sym_COLON,
    STATE(1973), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [22176] = 15,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4877), 1,
      anon_sym_isa,
    STATE(1974), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3887), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3885), 26,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_QMARK,
  [22268] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1975), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3827), 19,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
      anon_sym_LT_EQ,
    ACTIONS(3823), 34,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [22346] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1976), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4082), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4080), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [22432] = 20,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    STATE(1977), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(3827), 4,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3823), 19,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [22534] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1978), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(3827), 15,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_LT_EQ,
    ACTIONS(3823), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [22616] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    ACTIONS(4903), 1,
      anon_sym_COLON,
    STATE(1979), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [22728] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    STATE(1980), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4064), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
    ACTIONS(4062), 32,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
      anon_sym_isa,
      anon_sym_QMARK,
  [22814] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    STATE(1981), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 6,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3823), 19,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [22912] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    ACTIONS(4905), 1,
      anon_sym_COLON,
    STATE(1982), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [23024] = 25,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4004), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4869), 1,
      anon_sym_PIPE,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4877), 1,
      anon_sym_isa,
    ACTIONS(4881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4883), 1,
      anon_sym_EQ,
    ACTIONS(4887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4889), 1,
      anon_sym_QMARK,
    STATE(1983), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4865), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(4885), 16,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
  [23136] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4443), 1,
      anon_sym_DASH_GT,
    ACTIONS(4851), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4877), 1,
      anon_sym_isa,
    STATE(1984), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4479), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4849), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT2,
    ACTIONS(4855), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4847), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(4853), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(4875), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_cmp,
      anon_sym_TILDE_TILDE,
    ACTIONS(4845), 4,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_x,
    ACTIONS(4873), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_eq,
      anon_sym_ne,
    ACTIONS(4857), 5,
      anon_sym_GT_EQ,
      anon_sym_lt,
      anon_sym_le,
      anon_sym_ge,
      anon_sym_gt,
    ACTIONS(3827), 7,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3823), 19,
      anon_sym_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_x_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_QMARK,
  [23232] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4909), 1,
      anon_sym_DOLLAR,
    ACTIONS(4911), 1,
      anon_sym_AT,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    STATE(1985), 1,
      sym_heredoc_content,
    STATE(2001), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2040), 1,
      sym__quotelike_middle,
    STATE(2076), 1,
      sym_scalar,
    STATE(2195), 1,
      sym_array,
    STATE(2196), 1,
      sym__subscripted_interpolations,
    STATE(2199), 1,
      sym__array_element_interpolation,
    STATE(2203), 1,
      sym__hash_element_interpolation,
    STATE(2334), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2263), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2324), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4907), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4915), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23295] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4909), 1,
      anon_sym_DOLLAR,
    ACTIONS(4911), 1,
      anon_sym_AT,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    STATE(1986), 1,
      sym_heredoc_content,
    STATE(2001), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2045), 1,
      sym__quotelike_middle,
    STATE(2076), 1,
      sym_scalar,
    STATE(2195), 1,
      sym_array,
    STATE(2196), 1,
      sym__subscripted_interpolations,
    STATE(2199), 1,
      sym__array_element_interpolation,
    STATE(2203), 1,
      sym__hash_element_interpolation,
    STATE(2334), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2263), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2324), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4907), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4915), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23358] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4909), 1,
      anon_sym_DOLLAR,
    ACTIONS(4911), 1,
      anon_sym_AT,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    STATE(1985), 1,
      aux_sym__interpolated_regexp_content,
    STATE(1987), 1,
      sym_heredoc_content,
    STATE(2028), 1,
      sym__quotelike_middle,
    STATE(2076), 1,
      sym_scalar,
    STATE(2195), 1,
      sym_array,
    STATE(2196), 1,
      sym__subscripted_interpolations,
    STATE(2199), 1,
      sym__array_element_interpolation,
    STATE(2203), 1,
      sym__hash_element_interpolation,
    STATE(2334), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2263), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2324), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4907), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4915), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23421] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4909), 1,
      anon_sym_DOLLAR,
    ACTIONS(4911), 1,
      anon_sym_AT,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    STATE(1988), 1,
      sym_heredoc_content,
    STATE(1989), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2013), 1,
      sym__quotelike_middle,
    STATE(2076), 1,
      sym_scalar,
    STATE(2195), 1,
      sym_array,
    STATE(2196), 1,
      sym__subscripted_interpolations,
    STATE(2199), 1,
      sym__array_element_interpolation,
    STATE(2203), 1,
      sym__hash_element_interpolation,
    STATE(2334), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2263), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2324), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4907), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4915), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23484] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4909), 1,
      anon_sym_DOLLAR,
    ACTIONS(4911), 1,
      anon_sym_AT,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    STATE(1989), 1,
      sym_heredoc_content,
    STATE(2001), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2031), 1,
      sym__quotelike_middle,
    STATE(2076), 1,
      sym_scalar,
    STATE(2195), 1,
      sym_array,
    STATE(2196), 1,
      sym__subscripted_interpolations,
    STATE(2199), 1,
      sym__array_element_interpolation,
    STATE(2203), 1,
      sym__hash_element_interpolation,
    STATE(2334), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2263), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2324), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4907), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4915), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23547] = 18,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4909), 1,
      anon_sym_DOLLAR,
    ACTIONS(4911), 1,
      anon_sym_AT,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    STATE(1986), 1,
      aux_sym__interpolated_regexp_content,
    STATE(1990), 1,
      sym_heredoc_content,
    STATE(2047), 1,
      sym__quotelike_middle,
    STATE(2076), 1,
      sym_scalar,
    STATE(2195), 1,
      sym_array,
    STATE(2196), 1,
      sym__subscripted_interpolations,
    STATE(2199), 1,
      sym__array_element_interpolation,
    STATE(2203), 1,
      sym__hash_element_interpolation,
    STATE(2334), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2263), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2324), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4907), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4915), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23610] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4923), 1,
      sym__quotelike_end,
    STATE(1991), 1,
      sym_heredoc_content,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23670] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4927), 1,
      sym__quotelike_end,
    STATE(1992), 1,
      sym_heredoc_content,
    STATE(2000), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23730] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4929), 1,
      sym__quotelike_end,
    STATE(1993), 1,
      sym_heredoc_content,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23790] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4931), 1,
      sym__quotelike_end,
    STATE(1994), 1,
      sym_heredoc_content,
    STATE(1996), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23850] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4933), 1,
      sym__quotelike_end,
    STATE(1995), 1,
      sym_heredoc_content,
    STATE(1998), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23910] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4935), 1,
      sym__quotelike_end,
    STATE(1996), 1,
      sym_heredoc_content,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [23970] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4937), 1,
      sym__quotelike_end,
    STATE(1991), 1,
      aux_sym__interpolated_regexp_content,
    STATE(1997), 1,
      sym_heredoc_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24030] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4939), 1,
      sym__quotelike_end,
    STATE(1998), 1,
      sym_heredoc_content,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24090] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4941), 1,
      sym__quotelike_end,
    STATE(1999), 1,
      sym_heredoc_content,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24150] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4943), 1,
      sym__quotelike_end,
    STATE(2000), 1,
      sym_heredoc_content,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24210] = 16,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4948), 1,
      anon_sym_DOLLAR,
    ACTIONS(4951), 1,
      anon_sym_AT,
    ACTIONS(4954), 1,
      sym__quotelike_middle_close,
    STATE(2076), 1,
      sym_scalar,
    STATE(2195), 1,
      sym_array,
    STATE(2196), 1,
      sym__subscripted_interpolations,
    STATE(2199), 1,
      sym__array_element_interpolation,
    STATE(2203), 1,
      sym__hash_element_interpolation,
    STATE(2334), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2001), 2,
      aux_sym__interpolated_regexp_content,
      sym_heredoc_content,
    STATE(2263), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2324), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4945), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4956), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24268] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4959), 1,
      sym__quotelike_end,
    STATE(1999), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2002), 1,
      sym_heredoc_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24328] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4961), 1,
      sym__quotelike_end,
    STATE(2003), 1,
      sym_heredoc_content,
    STATE(2005), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24388] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4963), 1,
      sym__quotelike_end,
    STATE(2004), 1,
      sym_heredoc_content,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24448] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4965), 1,
      sym__quotelike_end,
    STATE(2005), 1,
      sym_heredoc_content,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24508] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4967), 1,
      sym__quotelike_end,
    STATE(2006), 1,
      sym_heredoc_content,
    STATE(2010), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24568] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4969), 1,
      sym__quotelike_end,
    STATE(2004), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2007), 1,
      sym_heredoc_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24628] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4971), 1,
      sym__quotelike_end,
    STATE(1993), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2008), 1,
      sym_heredoc_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24688] = 16,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4954), 1,
      sym__quotelike_end,
    ACTIONS(4976), 1,
      anon_sym_DOLLAR,
    ACTIONS(4979), 1,
      anon_sym_AT,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2009), 2,
      aux_sym__interpolated_regexp_content,
      sym_heredoc_content,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4973), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4982), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24746] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4919), 1,
      anon_sym_DOLLAR,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4985), 1,
      sym__quotelike_end,
    STATE(2009), 1,
      aux_sym__interpolated_regexp_content,
    STATE(2010), 1,
      sym_heredoc_content,
    STATE(2090), 1,
      sym_scalar,
    STATE(2205), 1,
      sym_array,
    STATE(2206), 1,
      sym__subscripted_interpolations,
    STATE(2208), 1,
      sym__array_element_interpolation,
    STATE(2209), 1,
      sym__hash_element_interpolation,
    STATE(2267), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2269), 2,
      sym__braced_scalar,
      sym__braced_array,
    STATE(2318), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    ACTIONS(4917), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4925), 4,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
  [24806] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(4993), 1,
      sym__quotelike_end,
    STATE(2011), 1,
      sym_heredoc_content,
    STATE(2022), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [24865] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(4997), 1,
      sym__quotelike_end,
    STATE(2012), 1,
      sym_heredoc_content,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [24924] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(4999), 1,
      sym__quotelike_end,
    STATE(2013), 1,
      sym_heredoc_content,
    STATE(2026), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [24983] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5001), 1,
      sym__quotelike_end,
    STATE(2014), 1,
      sym_heredoc_content,
    STATE(2035), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25042] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5003), 1,
      sym__quotelike_end,
    STATE(2015), 1,
      sym_heredoc_content,
    STATE(2037), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25101] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5005), 1,
      sym__quotelike_end,
    STATE(2016), 1,
      sym_heredoc_content,
    STATE(2032), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25160] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5007), 1,
      sym__quotelike_end,
    STATE(2017), 1,
      sym_heredoc_content,
    STATE(2033), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25219] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5009), 1,
      sym__quotelike_end,
    STATE(2018), 1,
      sym_heredoc_content,
    STATE(2021), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25278] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5011), 1,
      sym__quotelike_end,
    STATE(2019), 1,
      sym_heredoc_content,
    STATE(2039), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25337] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5013), 1,
      sym__quotelike_end,
    STATE(2020), 1,
      sym_heredoc_content,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25396] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5015), 1,
      sym__quotelike_end,
    STATE(2021), 1,
      sym_heredoc_content,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25455] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5017), 1,
      sym__quotelike_end,
    STATE(2022), 1,
      sym_heredoc_content,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25514] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5013), 1,
      sym__quotelike_end,
    STATE(2012), 1,
      aux_sym__interpolated_string_content,
    STATE(2023), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25573] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5017), 1,
      sym__quotelike_end,
    STATE(2024), 1,
      sym_heredoc_content,
    STATE(2041), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25632] = 16,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5022), 1,
      anon_sym_DOLLAR,
    ACTIONS(5025), 1,
      anon_sym_AT,
    ACTIONS(5028), 1,
      sym__quotelike_end,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2025), 2,
      aux_sym__interpolated_string_content,
      sym_heredoc_content,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(5019), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5030), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25689] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5033), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2026), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25748] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5035), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2027), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25807] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5037), 1,
      sym__quotelike_end,
    STATE(2027), 1,
      aux_sym__interpolated_string_content,
    STATE(2028), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25866] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5039), 1,
      sym__quotelike_end,
    STATE(2020), 1,
      aux_sym__interpolated_string_content,
    STATE(2029), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25925] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5041), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2030), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [25984] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5043), 1,
      sym__quotelike_end,
    STATE(2031), 1,
      sym_heredoc_content,
    STATE(2044), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26043] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5011), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2032), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26102] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5001), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2033), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26161] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5045), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2034), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26220] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5047), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2035), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26279] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5049), 1,
      sym__quotelike_end,
    STATE(2034), 1,
      aux_sym__interpolated_string_content,
    STATE(2036), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26338] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5049), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2037), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26397] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5051), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2038), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26456] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5053), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2039), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26515] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5055), 1,
      sym__quotelike_end,
    STATE(2030), 1,
      aux_sym__interpolated_string_content,
    STATE(2040), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26574] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5057), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2041), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26633] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5015), 1,
      sym__quotelike_end,
    STATE(2038), 1,
      aux_sym__interpolated_string_content,
    STATE(2042), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26692] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5059), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2043), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26751] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5061), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2044), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26810] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5063), 1,
      sym__quotelike_end,
    STATE(2045), 1,
      sym_heredoc_content,
    STATE(2046), 1,
      aux_sym__interpolated_string_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26869] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5065), 1,
      sym__quotelike_end,
    STATE(2025), 1,
      aux_sym__interpolated_string_content,
    STATE(2046), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26928] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4989), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_AT,
    ACTIONS(5067), 1,
      sym__quotelike_end,
    STATE(2043), 1,
      aux_sym__interpolated_string_content,
    STATE(2047), 1,
      sym_heredoc_content,
    STATE(2099), 1,
      sym_scalar,
    STATE(2218), 1,
      sym__array_element_interpolation,
    STATE(2224), 1,
      sym__hash_element_interpolation,
    STATE(2241), 1,
      sym__subscripted_interpolations,
    STATE(2250), 1,
      sym_array,
    STATE(2377), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2342), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2375), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(4995), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [26987] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5071), 1,
      anon_sym_DOLLAR,
    ACTIONS(5073), 1,
      anon_sym_AT,
    ACTIONS(5077), 1,
      sym_heredoc_end,
    STATE(2048), 1,
      sym_heredoc_content,
    STATE(2050), 1,
      aux_sym_heredoc_content_repeat1,
    STATE(2119), 1,
      sym_scalar,
    STATE(2326), 1,
      sym_array,
    STATE(2327), 1,
      sym__subscripted_interpolations,
    STATE(2330), 1,
      sym__array_element_interpolation,
    STATE(2332), 1,
      sym__hash_element_interpolation,
    STATE(2415), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5075), 2,
      sym_escape_sequence,
      sym__heredoc_middle,
    STATE(2385), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2419), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(5069), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
  [27045] = 16,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5082), 1,
      anon_sym_DOLLAR,
    ACTIONS(5085), 1,
      anon_sym_AT,
    ACTIONS(5091), 1,
      sym_heredoc_end,
    STATE(2119), 1,
      sym_scalar,
    STATE(2326), 1,
      sym_array,
    STATE(2327), 1,
      sym__subscripted_interpolations,
    STATE(2330), 1,
      sym__array_element_interpolation,
    STATE(2332), 1,
      sym__hash_element_interpolation,
    STATE(2415), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5088), 2,
      sym_escape_sequence,
      sym__heredoc_middle,
    STATE(2049), 2,
      sym_heredoc_content,
      aux_sym_heredoc_content_repeat1,
    STATE(2385), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2419), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(5079), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
  [27101] = 17,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5071), 1,
      anon_sym_DOLLAR,
    ACTIONS(5073), 1,
      anon_sym_AT,
    ACTIONS(5093), 1,
      sym_heredoc_end,
    STATE(2049), 1,
      aux_sym_heredoc_content_repeat1,
    STATE(2050), 1,
      sym_heredoc_content,
    STATE(2119), 1,
      sym_scalar,
    STATE(2326), 1,
      sym_array,
    STATE(2327), 1,
      sym__subscripted_interpolations,
    STATE(2330), 1,
      sym__array_element_interpolation,
    STATE(2332), 1,
      sym__hash_element_interpolation,
    STATE(2415), 1,
      sym__slice_expression_interpolation,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5075), 2,
      sym_escape_sequence,
      sym__heredoc_middle,
    STATE(2385), 2,
      sym__interpolations,
      sym__interpolation_fallbacks,
    STATE(2419), 2,
      sym__braced_scalar,
      sym__braced_array,
    ACTIONS(5069), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
  [27159] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2051), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2885), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2887), 14,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27191] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2052), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2905), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2907), 14,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27223] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5095), 1,
      sym__NONASSOC,
    STATE(2053), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2921), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27257] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3627), 1,
      anon_sym_for,
    STATE(2054), 1,
      sym_heredoc_content,
    STATE(2057), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5097), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(3623), 13,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_foreach,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [27293] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5095), 1,
      sym__NONASSOC,
    STATE(2055), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2891), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27327] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5099), 1,
      sym__NONASSOC,
    STATE(2056), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2891), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27361] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3611), 1,
      anon_sym_for,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5101), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    STATE(2057), 2,
      sym_heredoc_content,
      aux_sym__term_rightward_repeat1,
    ACTIONS(3606), 13,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_foreach,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [27395] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2058), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2885), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2887), 14,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27427] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2059), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2897), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2899), 14,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27459] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2060), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2893), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2895), 14,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27491] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2061), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2905), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2907), 14,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27523] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5099), 1,
      sym__NONASSOC,
    STATE(2062), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2921), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27557] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2063), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2897), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2899), 14,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27589] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2064), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2893), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2895), 14,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27621] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2065), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2897), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2899), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27652] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2066), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2897), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2899), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27683] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2067), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2893), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2895), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27714] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2068), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2893), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2895), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27745] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2069), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2885), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2887), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27776] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5108), 1,
      anon_sym_DOLLAR,
    ACTIONS(5110), 1,
      aux_sym__interpolation_fallbacks_token1,
    ACTIONS(5112), 1,
      aux_sym__ident_special_token1,
    STATE(225), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2070), 1,
      sym_heredoc_content,
    STATE(2083), 1,
      sym__indirob,
    STATE(2138), 1,
      sym__var_indirob_autoquote,
    STATE(2147), 1,
      sym_block,
    STATE(2180), 1,
      sym__var_indirob,
    ACTIONS(5104), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2085), 2,
      sym_scalar,
      sym__ident_special,
    ACTIONS(5114), 3,
      sym__quotelike_end_zw,
      sym__quotelike_end,
      sym__no_interp_whitespace_zw,
  [27829] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5118), 1,
      anon_sym_DOLLAR,
    ACTIONS(5120), 1,
      aux_sym__interpolation_fallbacks_token1,
    ACTIONS(5122), 1,
      aux_sym__ident_special_token1,
    STATE(237), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2071), 1,
      sym_heredoc_content,
    STATE(2115), 1,
      sym__indirob,
    STATE(2226), 1,
      sym__var_indirob_autoquote,
    STATE(2227), 1,
      sym_block,
    STATE(2277), 1,
      sym__var_indirob,
    ACTIONS(5116), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2118), 2,
      sym_scalar,
      sym__ident_special,
    ACTIONS(5124), 3,
      sym__quotelike_end_zw,
      sym__quotelike_end,
      sym__no_interp_whitespace_zw,
  [27882] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5126), 1,
      sym__NONASSOC,
    STATE(2072), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2921), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27915] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2073), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2905), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2907), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27946] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2074), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2913), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2917), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [27977] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2075), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2885), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2887), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28008] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5132), 1,
      anon_sym_LBRACK2,
    ACTIONS(5134), 1,
      anon_sym_DASH_GT_LBRACK,
    ACTIONS(5136), 1,
      anon_sym_LBRACE3,
    ACTIONS(5138), 1,
      anon_sym_DASH_GT_LBRACE,
    ACTIONS(5140), 1,
      anon_sym_DASH_GT_AT_LBRACK,
    ACTIONS(5142), 1,
      anon_sym_DASH_GT_AT_LBRACE,
    STATE(2076), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5130), 7,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
  [28051] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2077), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2893), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2895), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28082] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2078), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2913), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2917), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28113] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2079), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2905), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2907), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28144] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5126), 1,
      sym__NONASSOC,
    STATE(2080), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2891), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28177] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2081), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2909), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2911), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28208] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2082), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2923), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2925), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28239] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2083), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2923), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2925), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28270] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2084), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2891), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28301] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2085), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2891), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28332] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2086), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2901), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2903), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28363] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2087), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2885), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2887), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28394] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2088), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2897), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2899), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28425] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2089), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2901), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2903), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28456] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5144), 1,
      anon_sym_LBRACK2,
    ACTIONS(5146), 1,
      anon_sym_DASH_GT_LBRACK,
    ACTIONS(5148), 1,
      anon_sym_LBRACE3,
    ACTIONS(5150), 1,
      anon_sym_DASH_GT_LBRACE,
    ACTIONS(5152), 1,
      anon_sym_DASH_GT_AT_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_DASH_GT_AT_LBRACE,
    STATE(2090), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5130), 7,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
  [28499] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2091), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2921), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28530] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2092), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2921), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28561] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2093), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2905), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2907), 13,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28592] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5158), 1,
      anon_sym_DOLLAR,
    ACTIONS(5160), 1,
      aux_sym__interpolation_fallbacks_token1,
    ACTIONS(5162), 1,
      aux_sym__ident_special_token1,
    STATE(238), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2082), 1,
      sym__indirob,
    STATE(2094), 1,
      sym_heredoc_content,
    STATE(2146), 1,
      sym_block,
    STATE(2154), 1,
      sym__var_indirob_autoquote,
    STATE(2178), 1,
      sym__var_indirob,
    ACTIONS(5156), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2084), 2,
      sym_scalar,
      sym__ident_special,
    ACTIONS(5164), 3,
      sym__quotelike_end_zw,
      sym__quotelike_end,
      sym__no_interp_whitespace_zw,
  [28645] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5168), 1,
      anon_sym_DOLLAR,
    ACTIONS(5170), 1,
      aux_sym__interpolation_fallbacks_token1,
    ACTIONS(5172), 1,
      aux_sym__ident_special_token1,
    STATE(227), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2095), 1,
      sym_heredoc_content,
    STATE(2113), 1,
      sym__indirob,
    STATE(2168), 1,
      sym__var_indirob_autoquote,
    STATE(2190), 1,
      sym_block,
    STATE(2248), 1,
      sym__var_indirob,
    ACTIONS(5166), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2100), 2,
      sym_scalar,
      sym__ident_special,
    ACTIONS(5174), 3,
      sym__quotelike_end_zw,
      sym__quotelike_end,
      sym__no_interp_whitespace_zw,
  [28698] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2096), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2909), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2911), 13,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28729] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2097), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2905), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2907), 12,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28759] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2098), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2885), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2887), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28789] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5176), 1,
      anon_sym_LBRACK2,
    ACTIONS(5178), 1,
      anon_sym_DASH_GT_LBRACK,
    ACTIONS(5180), 1,
      anon_sym_LBRACE3,
    ACTIONS(5182), 1,
      anon_sym_DASH_GT_LBRACE,
    ACTIONS(5184), 1,
      anon_sym_DASH_GT_AT_LBRACK,
    ACTIONS(5186), 1,
      anon_sym_DASH_GT_AT_LBRACE,
    STATE(2099), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5130), 6,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
  [28831] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2100), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2891), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28861] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2101), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2921), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28891] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2102), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2901), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2903), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28921] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2103), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2905), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2907), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28951] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2104), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2897), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2899), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [28981] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2105), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2913), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2917), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29011] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2106), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2897), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2899), 12,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29041] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2107), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2893), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2895), 12,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29071] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5188), 1,
      sym__NONASSOC,
    STATE(2108), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2891), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29103] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5188), 1,
      sym__NONASSOC,
    STATE(2109), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2921), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29135] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2110), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2909), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2911), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29165] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2111), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2885), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2887), 12,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      sym__NONASSOC,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29195] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2112), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2893), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2895), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29225] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2113), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2923), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2925), 12,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29255] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5192), 1,
      anon_sym_and,
    ACTIONS(5194), 1,
      anon_sym_or,
    ACTIONS(5196), 1,
      anon_sym_for,
    ACTIONS(5198), 1,
      anon_sym_foreach,
    ACTIONS(5204), 1,
      sym__PERLY_SEMICOLON,
    STATE(2114), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5200), 2,
      anon_sym_if,
      anon_sym_unless,
    ACTIONS(5202), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(5190), 5,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [29296] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2115), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2923), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2925), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29325] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5192), 1,
      anon_sym_and,
    ACTIONS(5194), 1,
      anon_sym_or,
    ACTIONS(5196), 1,
      anon_sym_for,
    ACTIONS(5198), 1,
      anon_sym_foreach,
    ACTIONS(5207), 1,
      sym__PERLY_SEMICOLON,
    STATE(2116), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5200), 2,
      anon_sym_if,
      anon_sym_unless,
    ACTIONS(5202), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(5190), 5,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [29366] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2117), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2901), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2903), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29395] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2118), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2891), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29424] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5210), 1,
      anon_sym_LBRACK2,
    ACTIONS(5212), 1,
      anon_sym_DASH_GT_LBRACK,
    ACTIONS(5214), 1,
      anon_sym_LBRACE3,
    ACTIONS(5216), 1,
      anon_sym_DASH_GT_LBRACE,
    ACTIONS(5218), 1,
      anon_sym_DASH_GT_AT_LBRACK,
    ACTIONS(5220), 1,
      anon_sym_DASH_GT_AT_LBRACE,
    STATE(2119), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5130), 5,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
  [29465] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5192), 1,
      anon_sym_and,
    ACTIONS(5194), 1,
      anon_sym_or,
    ACTIONS(5196), 1,
      anon_sym_for,
    ACTIONS(5198), 1,
      anon_sym_foreach,
    STATE(2120), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5200), 2,
      anon_sym_if,
      anon_sym_unless,
    ACTIONS(5202), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(5190), 6,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [29504] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5224), 1,
      anon_sym_for,
    STATE(2121), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5222), 13,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_foreach,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [29533] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2122), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2921), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29562] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2123), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2913), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2917), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29591] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5228), 1,
      anon_sym_for,
    STATE(2124), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5226), 13,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_foreach,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [29620] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5192), 1,
      anon_sym_and,
    ACTIONS(5194), 1,
      anon_sym_or,
    ACTIONS(5196), 1,
      anon_sym_for,
    ACTIONS(5198), 1,
      anon_sym_foreach,
    ACTIONS(5230), 1,
      sym__PERLY_SEMICOLON,
    STATE(2125), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5200), 2,
      anon_sym_if,
      anon_sym_unless,
    ACTIONS(5202), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(5190), 5,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [29661] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5235), 1,
      anon_sym_for,
    STATE(2126), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5233), 13,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_foreach,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [29690] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2127), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2893), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2895), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29719] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5239), 1,
      anon_sym_for,
    STATE(2128), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5237), 13,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_foreach,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [29748] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2129), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2885), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2887), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29777] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2130), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2909), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2911), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29806] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2131), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2905), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2907), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29835] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5192), 1,
      anon_sym_and,
    ACTIONS(5228), 1,
      anon_sym_for,
    STATE(2132), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5226), 12,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_or,
      anon_sym_foreach,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [29866] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2133), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2897), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2899), 11,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT_LBRACK,
      anon_sym_LBRACE3,
      anon_sym_DASH_GT_LBRACE,
      anon_sym_DASH_GT_AT_LBRACK,
      anon_sym_DASH_GT_AT_LBRACE,
  [29895] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5243), 1,
      anon_sym_DOLLAR,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5247), 1,
      sym__dollar_ident_zw,
    STATE(233), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1146), 1,
      sym__indirob,
    STATE(1147), 1,
      sym__var_indirob_autoquote,
    STATE(1176), 1,
      sym__var_indirob,
    STATE(2134), 1,
      sym_heredoc_content,
    ACTIONS(5241), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1183), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [29941] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5168), 1,
      anon_sym_DOLLAR,
    ACTIONS(5172), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5249), 1,
      sym__dollar_ident_zw,
    STATE(232), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2101), 1,
      sym__var_indirob_autoquote,
    STATE(2105), 1,
      sym__var_indirob,
    STATE(2113), 1,
      sym__indirob,
    STATE(2135), 1,
      sym_heredoc_content,
    ACTIONS(5166), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2100), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [29987] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5158), 1,
      anon_sym_DOLLAR,
    ACTIONS(5162), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5251), 1,
      sym__no_interp_whitespace_zw,
    STATE(238), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2056), 1,
      sym_block,
    STATE(2062), 1,
      sym__var_indirob_autoquote,
    STATE(2074), 1,
      sym__var_indirob,
    STATE(2082), 1,
      sym__indirob,
    STATE(2136), 1,
      sym_heredoc_content,
    ACTIONS(5156), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2084), 2,
      sym_scalar,
      sym__ident_special,
  [30035] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5108), 1,
      anon_sym_DOLLAR,
    ACTIONS(5112), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5253), 1,
      sym__dollar_ident_zw,
    STATE(236), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2078), 1,
      sym__var_indirob,
    STATE(2083), 1,
      sym__indirob,
    STATE(2092), 1,
      sym__var_indirob_autoquote,
    STATE(2137), 1,
      sym_heredoc_content,
    ACTIONS(5104), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2085), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30081] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5255), 1,
      sym__NONASSOC,
    STATE(2138), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2921), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [30111] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5259), 1,
      anon_sym_DOLLAR,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5263), 1,
      sym__dollar_ident_zw,
    STATE(240), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1397), 1,
      sym__var_indirob,
    STATE(1399), 1,
      sym__indirob,
    STATE(2139), 1,
      sym_heredoc_content,
    ACTIONS(5257), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1402), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30157] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5267), 1,
      anon_sym_DOLLAR,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5271), 1,
      sym__dollar_ident_zw,
    STATE(235), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1658), 1,
      sym__var_indirob,
    STATE(1664), 1,
      sym__indirob,
    STATE(1667), 1,
      sym__var_indirob_autoquote,
    STATE(2140), 1,
      sym_heredoc_content,
    ACTIONS(5265), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1660), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30203] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5267), 1,
      anon_sym_DOLLAR,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5273), 1,
      anon_sym_STAR,
    STATE(235), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1658), 1,
      sym__var_indirob,
    STATE(1664), 1,
      sym__indirob,
    STATE(1667), 1,
      sym__var_indirob_autoquote,
    STATE(2141), 1,
      sym_heredoc_content,
    ACTIONS(5265), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1660), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30249] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5243), 1,
      anon_sym_DOLLAR,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5275), 1,
      sym__dollar_ident_zw,
    STATE(233), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1146), 1,
      sym__indirob,
    STATE(1147), 1,
      sym__var_indirob_autoquote,
    STATE(1196), 1,
      sym__var_indirob,
    STATE(2142), 1,
      sym_heredoc_content,
    ACTIONS(5241), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1183), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30295] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5108), 1,
      anon_sym_DOLLAR,
    ACTIONS(5112), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5277), 1,
      sym__no_interp_whitespace_zw,
    STATE(225), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2053), 1,
      sym__var_indirob_autoquote,
    STATE(2055), 1,
      sym_block,
    STATE(2078), 1,
      sym__var_indirob,
    STATE(2083), 1,
      sym__indirob,
    STATE(2143), 1,
      sym_heredoc_content,
    ACTIONS(5104), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2085), 2,
      sym_scalar,
      sym__ident_special,
  [30343] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5118), 1,
      anon_sym_DOLLAR,
    ACTIONS(5122), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5279), 1,
      sym__dollar_ident_zw,
    STATE(229), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2115), 1,
      sym__indirob,
    STATE(2122), 1,
      sym__var_indirob_autoquote,
    STATE(2123), 1,
      sym__var_indirob,
    STATE(2144), 1,
      sym_heredoc_content,
    ACTIONS(5116), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2118), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30389] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5158), 1,
      anon_sym_DOLLAR,
    ACTIONS(5162), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5281), 1,
      sym__dollar_ident_zw,
    STATE(234), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2074), 1,
      sym__var_indirob,
    STATE(2082), 1,
      sym__indirob,
    STATE(2091), 1,
      sym__var_indirob_autoquote,
    STATE(2145), 1,
      sym_heredoc_content,
    ACTIONS(5156), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2084), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30435] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5283), 1,
      sym__NONASSOC,
    STATE(2146), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2891), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [30465] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5255), 1,
      sym__NONASSOC,
    STATE(2147), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2891), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [30495] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5287), 1,
      anon_sym_DOLLAR,
    ACTIONS(5289), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5291), 1,
      sym__dollar_ident_zw,
    STATE(239), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(945), 1,
      sym__indirob,
    STATE(952), 1,
      sym__var_indirob,
    STATE(955), 1,
      sym__var_indirob_autoquote,
    STATE(2148), 1,
      sym_heredoc_content,
    ACTIONS(5285), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(944), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30541] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5295), 1,
      anon_sym_DOLLAR,
    ACTIONS(5297), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5299), 1,
      sym__dollar_ident_zw,
    STATE(224), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(910), 1,
      sym__var_indirob_autoquote,
    STATE(911), 1,
      sym__indirob,
    STATE(912), 1,
      sym__var_indirob,
    STATE(2149), 1,
      sym_heredoc_content,
    ACTIONS(5293), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(898), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30587] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5243), 1,
      anon_sym_DOLLAR,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5301), 1,
      anon_sym_STAR,
    STATE(233), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1146), 1,
      sym__indirob,
    STATE(1147), 1,
      sym__var_indirob_autoquote,
    STATE(1176), 1,
      sym__var_indirob,
    STATE(2150), 1,
      sym_heredoc_content,
    ACTIONS(5241), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1183), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30633] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5259), 1,
      anon_sym_DOLLAR,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5303), 1,
      anon_sym_STAR,
    STATE(240), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1397), 1,
      sym__var_indirob,
    STATE(1399), 1,
      sym__indirob,
    STATE(2151), 1,
      sym_heredoc_content,
    ACTIONS(5257), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1402), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30679] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5307), 1,
      anon_sym_DOLLAR,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5311), 1,
      sym__dollar_ident_zw,
    STATE(226), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2152), 1,
      sym_heredoc_content,
    STATE(2646), 1,
      sym__var_indirob,
    STATE(3214), 1,
      sym__var_indirob_autoquote,
    STATE(3236), 1,
      sym__indirob,
    ACTIONS(5305), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2691), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30725] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5311), 1,
      sym__dollar_ident_zw,
    ACTIONS(5313), 1,
      anon_sym_DOLLAR,
    STATE(230), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1399), 1,
      sym__indirob,
    STATE(2153), 1,
      sym_heredoc_content,
    STATE(2646), 1,
      sym__var_indirob,
    ACTIONS(5305), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2691), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30771] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5283), 1,
      sym__NONASSOC,
    STATE(2154), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2921), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [30801] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5317), 1,
      anon_sym_DOLLAR,
    ACTIONS(5319), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5321), 1,
      sym__dollar_ident_zw,
    STATE(228), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(914), 1,
      sym__var_indirob,
    STATE(922), 1,
      sym__var_indirob_autoquote,
    STATE(937), 1,
      sym__indirob,
    STATE(2155), 1,
      sym_heredoc_content,
    ACTIONS(5315), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(924), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30847] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    ACTIONS(5325), 1,
      anon_sym_DOLLAR,
    ACTIONS(5327), 1,
      anon_sym_AT,
    STATE(2156), 1,
      sym_heredoc_content,
    STATE(2166), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2244), 1,
      sym__quotelike_middle,
    STATE(2361), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5323), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5329), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [30886] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5259), 1,
      anon_sym_DOLLAR,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    STATE(240), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1399), 1,
      sym__indirob,
    STATE(1521), 1,
      sym__var_indirob,
    STATE(2157), 1,
      sym_heredoc_content,
    ACTIONS(5257), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1402), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30929] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5267), 1,
      anon_sym_DOLLAR,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    STATE(235), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1664), 1,
      sym__indirob,
    STATE(1667), 1,
      sym__var_indirob_autoquote,
    STATE(1672), 1,
      sym__var_indirob,
    STATE(2158), 1,
      sym_heredoc_content,
    ACTIONS(5265), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1660), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [30972] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    ACTIONS(5325), 1,
      anon_sym_DOLLAR,
    ACTIONS(5327), 1,
      anon_sym_AT,
    STATE(2159), 1,
      sym_heredoc_content,
    STATE(2229), 1,
      sym__quotelike_middle,
    STATE(2239), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2361), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5323), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5329), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [31011] = 14,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5333), 1,
      anon_sym_LBRACE,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5337), 1,
      anon_sym_DOLLAR,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_AT,
    ACTIONS(5343), 1,
      anon_sym_PERCENT,
    ACTIONS(5345), 1,
      anon_sym_AMP,
    ACTIONS(5347), 1,
      anon_sym_STAR,
    STATE(1202), 1,
      sym_method,
    STATE(1203), 1,
      sym_scalar,
    STATE(2160), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5331), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [31056] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5317), 1,
      anon_sym_DOLLAR,
    ACTIONS(5319), 1,
      aux_sym__ident_special_token1,
    STATE(228), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(916), 1,
      sym__var_indirob,
    STATE(922), 1,
      sym__var_indirob_autoquote,
    STATE(937), 1,
      sym__indirob,
    STATE(2161), 1,
      sym_heredoc_content,
    ACTIONS(5315), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(924), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31099] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5259), 1,
      anon_sym_DOLLAR,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    STATE(240), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1399), 1,
      sym__indirob,
    STATE(1422), 1,
      sym__var_indirob,
    STATE(2162), 1,
      sym_heredoc_content,
    ACTIONS(5257), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1402), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31142] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2163), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5349), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5351), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [31169] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5267), 1,
      anon_sym_DOLLAR,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    STATE(235), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1664), 1,
      sym__indirob,
    STATE(1667), 1,
      sym__var_indirob_autoquote,
    STATE(1840), 1,
      sym__var_indirob,
    STATE(2164), 1,
      sym_heredoc_content,
    ACTIONS(5265), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1660), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31212] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2165), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5353), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5355), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [31239] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    ACTIONS(5325), 1,
      anon_sym_DOLLAR,
    ACTIONS(5327), 1,
      anon_sym_AT,
    STATE(2166), 1,
      sym_heredoc_content,
    STATE(2237), 1,
      sym__quotelike_middle,
    STATE(2239), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2361), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5323), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5329), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [31278] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5295), 1,
      anon_sym_DOLLAR,
    ACTIONS(5297), 1,
      aux_sym__ident_special_token1,
    STATE(224), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(908), 1,
      sym__var_indirob,
    STATE(910), 1,
      sym__var_indirob_autoquote,
    STATE(911), 1,
      sym__indirob,
    STATE(2167), 1,
      sym_heredoc_content,
    ACTIONS(5293), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(898), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31321] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5357), 1,
      sym__NONASSOC,
    STATE(2168), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2921), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [31350] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5267), 1,
      anon_sym_DOLLAR,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    STATE(235), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1664), 1,
      sym__indirob,
    STATE(1667), 1,
      sym__var_indirob_autoquote,
    STATE(1675), 1,
      sym__var_indirob,
    STATE(2169), 1,
      sym_heredoc_content,
    ACTIONS(5265), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1660), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31393] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5259), 1,
      anon_sym_DOLLAR,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    STATE(240), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1399), 1,
      sym__indirob,
    STATE(1492), 1,
      sym__var_indirob,
    STATE(2170), 1,
      sym_heredoc_content,
    ACTIONS(5257), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1402), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31436] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    ACTIONS(5325), 1,
      anon_sym_DOLLAR,
    ACTIONS(5327), 1,
      anon_sym_AT,
    STATE(2159), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2171), 1,
      sym_heredoc_content,
    STATE(2211), 1,
      sym__quotelike_middle,
    STATE(2361), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5323), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5329), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [31475] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5287), 1,
      anon_sym_DOLLAR,
    ACTIONS(5289), 1,
      aux_sym__ident_special_token1,
    STATE(239), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(945), 1,
      sym__indirob,
    STATE(955), 1,
      sym__var_indirob_autoquote,
    STATE(958), 1,
      sym__var_indirob,
    STATE(2172), 1,
      sym_heredoc_content,
    ACTIONS(5285), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(944), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31518] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2173), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5361), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [31545] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2174), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5363), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5365), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [31572] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2175), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5363), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5365), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [31599] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5313), 1,
      anon_sym_DOLLAR,
    STATE(230), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1399), 1,
      sym__indirob,
    STATE(2176), 1,
      sym_heredoc_content,
    STATE(2646), 1,
      sym__var_indirob,
    ACTIONS(5305), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2691), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31642] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    ACTIONS(5325), 1,
      anon_sym_DOLLAR,
    ACTIONS(5327), 1,
      anon_sym_AT,
    STATE(2177), 1,
      sym_heredoc_content,
    STATE(2183), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2234), 1,
      sym__quotelike_middle,
    STATE(2361), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5323), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5329), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [31681] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2178), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3556), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(3554), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [31708] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5267), 1,
      anon_sym_DOLLAR,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    STATE(235), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1664), 1,
      sym__indirob,
    STATE(1667), 1,
      sym__var_indirob_autoquote,
    STATE(1674), 1,
      sym__var_indirob,
    STATE(2179), 1,
      sym_heredoc_content,
    ACTIONS(5265), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1660), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31751] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2180), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3556), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(3554), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [31778] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5267), 1,
      anon_sym_DOLLAR,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    STATE(235), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1664), 1,
      sym__indirob,
    STATE(1667), 1,
      sym__var_indirob_autoquote,
    STATE(1827), 1,
      sym__var_indirob,
    STATE(2181), 1,
      sym_heredoc_content,
    ACTIONS(5265), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1660), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31821] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5243), 1,
      anon_sym_DOLLAR,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    STATE(233), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1146), 1,
      sym__indirob,
    STATE(1147), 1,
      sym__var_indirob_autoquote,
    STATE(1362), 1,
      sym__var_indirob,
    STATE(2182), 1,
      sym_heredoc_content,
    ACTIONS(5241), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1183), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31864] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4913), 1,
      sym__quotelike_middle_close,
    ACTIONS(5325), 1,
      anon_sym_DOLLAR,
    ACTIONS(5327), 1,
      anon_sym_AT,
    STATE(2183), 1,
      sym_heredoc_content,
    STATE(2210), 1,
      sym__quotelike_middle,
    STATE(2239), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2361), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5323), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5329), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [31903] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5243), 1,
      anon_sym_DOLLAR,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    STATE(233), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1146), 1,
      sym__indirob,
    STATE(1147), 1,
      sym__var_indirob_autoquote,
    STATE(1193), 1,
      sym__var_indirob,
    STATE(2184), 1,
      sym_heredoc_content,
    ACTIONS(5241), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1183), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [31946] = 14,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(5371), 1,
      anon_sym_LPAREN,
    ACTIONS(5373), 1,
      anon_sym_DOLLAR,
    ACTIONS(5375), 1,
      anon_sym_LBRACK,
    ACTIONS(5377), 1,
      anon_sym_AT,
    ACTIONS(5379), 1,
      anon_sym_PERCENT,
    ACTIONS(5381), 1,
      anon_sym_AMP,
    ACTIONS(5383), 1,
      anon_sym_STAR,
    STATE(1448), 1,
      sym_scalar,
    STATE(1449), 1,
      sym_method,
    STATE(2185), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5367), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [31991] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2186), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5363), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5365), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32018] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5243), 1,
      anon_sym_DOLLAR,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    STATE(233), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1146), 1,
      sym__indirob,
    STATE(1147), 1,
      sym__var_indirob_autoquote,
    STATE(1295), 1,
      sym__var_indirob,
    STATE(2187), 1,
      sym_heredoc_content,
    ACTIONS(5241), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1183), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [32061] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2188), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5349), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5351), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32088] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2189), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5353), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5355), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32115] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5357), 1,
      sym__NONASSOC,
    STATE(2190), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2891), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32144] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2191), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5361), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32171] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2192), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5363), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5365), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32198] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5259), 1,
      anon_sym_DOLLAR,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    STATE(240), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1399), 1,
      sym__indirob,
    STATE(1416), 1,
      sym__var_indirob,
    STATE(2193), 1,
      sym_heredoc_content,
    ACTIONS(5257), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1402), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [32241] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5259), 1,
      anon_sym_DOLLAR,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    STATE(240), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1390), 1,
      sym__var_indirob_autoquote,
    STATE(1399), 1,
      sym__indirob,
    STATE(1412), 1,
      sym__var_indirob,
    STATE(2194), 1,
      sym_heredoc_content,
    ACTIONS(5257), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1402), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [32284] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5385), 1,
      anon_sym_LBRACK2,
    ACTIONS(5387), 1,
      anon_sym_LBRACE3,
    STATE(2195), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5130), 8,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
  [32315] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5389), 1,
      anon_sym_LBRACK2,
    ACTIONS(5391), 1,
      anon_sym_LBRACE3,
    STATE(2196), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5130), 8,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
  [32346] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5168), 1,
      anon_sym_DOLLAR,
    ACTIONS(5172), 1,
      aux_sym__ident_special_token1,
    STATE(227), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2072), 1,
      sym__var_indirob_autoquote,
    STATE(2080), 1,
      sym_block,
    STATE(2105), 1,
      sym__var_indirob,
    STATE(2113), 1,
      sym__indirob,
    STATE(2197), 1,
      sym_heredoc_content,
    ACTIONS(5166), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2100), 2,
      sym_scalar,
      sym__ident_special,
  [32391] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5243), 1,
      anon_sym_DOLLAR,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    STATE(233), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1146), 1,
      sym__indirob,
    STATE(1147), 1,
      sym__var_indirob_autoquote,
    STATE(1195), 1,
      sym__var_indirob,
    STATE(2198), 1,
      sym_heredoc_content,
    ACTIONS(5241), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1183), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [32434] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2199), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5393), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5395), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32461] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5243), 1,
      anon_sym_DOLLAR,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    STATE(233), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1146), 1,
      sym__indirob,
    STATE(1147), 1,
      sym__var_indirob_autoquote,
    STATE(1196), 1,
      sym__var_indirob,
    STATE(2200), 1,
      sym_heredoc_content,
    ACTIONS(5241), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1183), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [32504] = 14,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5399), 1,
      anon_sym_LBRACE,
    ACTIONS(5401), 1,
      anon_sym_LPAREN,
    ACTIONS(5403), 1,
      anon_sym_DOLLAR,
    ACTIONS(5405), 1,
      anon_sym_LBRACK,
    ACTIONS(5407), 1,
      anon_sym_AT,
    ACTIONS(5409), 1,
      anon_sym_PERCENT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5413), 1,
      anon_sym_STAR,
    STATE(1709), 1,
      sym_scalar,
    STATE(1713), 1,
      sym_method,
    STATE(2201), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5397), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [32549] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5106), 1,
      anon_sym_LBRACE2,
    ACTIONS(5118), 1,
      anon_sym_DOLLAR,
    ACTIONS(5122), 1,
      aux_sym__ident_special_token1,
    STATE(237), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2108), 1,
      sym_block,
    STATE(2109), 1,
      sym__var_indirob_autoquote,
    STATE(2115), 1,
      sym__indirob,
    STATE(2123), 1,
      sym__var_indirob,
    STATE(2202), 1,
      sym_heredoc_content,
    ACTIONS(5116), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2118), 2,
      sym_scalar,
      sym__ident_special,
  [32594] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2203), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5415), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5417), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32621] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2204), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5361), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32648] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5419), 1,
      anon_sym_LBRACK2,
    ACTIONS(5421), 1,
      anon_sym_LBRACE3,
    STATE(2205), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5130), 8,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
  [32679] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5423), 1,
      anon_sym_LBRACK2,
    ACTIONS(5425), 1,
      anon_sym_LBRACE3,
    STATE(2206), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5130), 8,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
  [32710] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2207), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5361), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32737] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2208), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5393), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5395), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32764] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2209), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5415), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5417), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32791] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5431), 1,
      sym__quotelike_end,
    STATE(2210), 1,
      sym_heredoc_content,
    STATE(2243), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [32827] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5435), 1,
      sym__quotelike_end,
    STATE(2211), 1,
      sym_heredoc_content,
    STATE(2247), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [32863] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5437), 1,
      anon_sym_RPAREN,
    ACTIONS(5439), 1,
      anon_sym_COMMA,
    ACTIONS(5442), 1,
      anon_sym_DOLLAR,
    ACTIONS(5445), 1,
      anon_sym_AT,
    ACTIONS(5448), 1,
      anon_sym_undef,
    ACTIONS(5451), 1,
      anon_sym_PERCENT2,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2212), 2,
      sym_heredoc_content,
      aux_sym__decl_variable_list_repeat1,
    STATE(3284), 4,
      sym_undef_expression,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [32899] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5454), 1,
      sym__quotelike_end,
    STATE(2213), 1,
      sym_heredoc_content,
    STATE(2249), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [32935] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2214), 1,
      sym_heredoc_content,
    STATE(2225), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5456), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(3623), 8,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [32963] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2215), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5349), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5351), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [32989] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2216), 1,
      sym_heredoc_content,
    STATE(2360), 1,
      sym_attribute,
    STATE(2431), 1,
      sym_attribute_name,
    STATE(2461), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5458), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1081), 2,
      sym_block,
      sym__semicolon,
  [33027] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5460), 1,
      anon_sym_RPAREN,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_DOLLAR,
    ACTIONS(5466), 1,
      anon_sym_AT,
    ACTIONS(5468), 1,
      anon_sym_undef,
    ACTIONS(5470), 1,
      anon_sym_PERCENT2,
    STATE(2212), 1,
      aux_sym__decl_variable_list_repeat1,
    STATE(2217), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(3130), 4,
      sym_undef_expression,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [33065] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2218), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5393), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5395), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [33091] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(15), 1,
      anon_sym_LBRACE2,
    ACTIONS(5307), 1,
      anon_sym_DOLLAR,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5472), 1,
      anon_sym_GT,
    STATE(248), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2219), 1,
      sym_heredoc_content,
    STATE(3164), 1,
      sym__indirob,
    ACTIONS(5305), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2691), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [33131] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_DOLLAR,
    ACTIONS(5466), 1,
      anon_sym_AT,
    ACTIONS(5468), 1,
      anon_sym_undef,
    ACTIONS(5470), 1,
      anon_sym_PERCENT2,
    ACTIONS(5474), 1,
      anon_sym_RPAREN,
    STATE(2212), 1,
      aux_sym__decl_variable_list_repeat1,
    STATE(2220), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(3070), 4,
      sym_undef_expression,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [33169] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_DOLLAR,
    ACTIONS(5466), 1,
      anon_sym_AT,
    ACTIONS(5468), 1,
      anon_sym_undef,
    ACTIONS(5470), 1,
      anon_sym_PERCENT2,
    ACTIONS(5476), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      aux_sym__decl_variable_list_repeat1,
    STATE(2221), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(3123), 4,
      sym_undef_expression,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [33207] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(15), 1,
      anon_sym_LBRACE2,
    ACTIONS(5307), 1,
      anon_sym_DOLLAR,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5478), 1,
      anon_sym_GT,
    STATE(248), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2222), 1,
      sym_heredoc_content,
    STATE(3242), 1,
      sym__indirob,
    ACTIONS(5305), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2691), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [33247] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2223), 1,
      sym_heredoc_content,
    STATE(2360), 1,
      sym_attribute,
    STATE(2431), 1,
      sym_attribute_name,
    STATE(2470), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5458), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1118), 2,
      sym_block,
      sym__semicolon,
  [33285] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2224), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5415), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5417), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [33311] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5480), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    STATE(2225), 2,
      sym_heredoc_content,
      aux_sym__term_rightward_repeat1,
    ACTIONS(3606), 8,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [33337] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5483), 1,
      sym__NONASSOC,
    STATE(2226), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2919), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2921), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [33365] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5483), 1,
      sym__NONASSOC,
    STATE(2227), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2889), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2891), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [33393] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2228), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5361), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [33419] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5485), 1,
      sym__quotelike_end,
    STATE(2229), 1,
      sym_heredoc_content,
    STATE(2236), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [33455] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2230), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5363), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5365), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [33481] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2231), 1,
      sym_heredoc_content,
    STATE(2360), 1,
      sym_attribute,
    STATE(2431), 1,
      sym_attribute_name,
    STATE(2479), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5458), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1003), 2,
      sym_block,
      sym__semicolon,
  [33519] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_DOLLAR,
    ACTIONS(5466), 1,
      anon_sym_AT,
    ACTIONS(5468), 1,
      anon_sym_undef,
    ACTIONS(5470), 1,
      anon_sym_PERCENT2,
    ACTIONS(5487), 1,
      anon_sym_RPAREN,
    STATE(2217), 1,
      aux_sym__decl_variable_list_repeat1,
    STATE(2232), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(3137), 4,
      sym_undef_expression,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [33557] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5489), 1,
      sym__quotelike_end,
    STATE(2233), 1,
      sym_heredoc_content,
    STATE(2249), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [33593] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5491), 1,
      sym__quotelike_end,
    STATE(2213), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2234), 1,
      sym_heredoc_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [33629] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_DOLLAR,
    ACTIONS(5466), 1,
      anon_sym_AT,
    ACTIONS(5468), 1,
      anon_sym_undef,
    ACTIONS(5470), 1,
      anon_sym_PERCENT2,
    ACTIONS(5493), 1,
      anon_sym_RPAREN,
    STATE(2212), 1,
      aux_sym__decl_variable_list_repeat1,
    STATE(2235), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(3140), 4,
      sym_undef_expression,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [33667] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5495), 1,
      sym__quotelike_end,
    STATE(2236), 1,
      sym_heredoc_content,
    STATE(2249), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [33703] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5497), 1,
      sym__quotelike_end,
    STATE(2237), 1,
      sym_heredoc_content,
    STATE(2251), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [33739] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_DOLLAR,
    ACTIONS(5466), 1,
      anon_sym_AT,
    ACTIONS(5468), 1,
      anon_sym_undef,
    ACTIONS(5470), 1,
      anon_sym_PERCENT2,
    ACTIONS(5499), 1,
      anon_sym_RPAREN,
    STATE(2235), 1,
      aux_sym__decl_variable_list_repeat1,
    STATE(2238), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(3080), 4,
      sym_undef_expression,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [33777] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5504), 1,
      anon_sym_DOLLAR,
    ACTIONS(5507), 1,
      anon_sym_AT,
    ACTIONS(5510), 1,
      sym__quotelike_middle_close,
    STATE(2361), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2239), 2,
      aux_sym__interpolated_transliteration_content,
      sym_heredoc_content,
    ACTIONS(5501), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5512), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [33811] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2240), 1,
      sym_heredoc_content,
    STATE(2360), 1,
      sym_attribute,
    STATE(2431), 1,
      sym_attribute_name,
    STATE(2468), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5458), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(1012), 2,
      sym_block,
      sym__semicolon,
  [33849] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5515), 1,
      anon_sym_LBRACK2,
    ACTIONS(5517), 1,
      anon_sym_LBRACE3,
    STATE(2241), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5130), 7,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
  [33879] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2242), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5361), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [33905] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5519), 1,
      sym__quotelike_end,
    STATE(2243), 1,
      sym_heredoc_content,
    STATE(2249), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [33941] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5521), 1,
      sym__quotelike_end,
    STATE(2233), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2244), 1,
      sym_heredoc_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [33977] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2245), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5353), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5355), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [34003] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2246), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5363), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5365), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [34029] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5523), 1,
      sym__quotelike_end,
    STATE(2247), 1,
      sym_heredoc_content,
    STATE(2249), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [34065] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2248), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3556), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(3554), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [34091] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5510), 1,
      sym__quotelike_end,
    ACTIONS(5528), 1,
      anon_sym_DOLLAR,
    ACTIONS(5531), 1,
      anon_sym_AT,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2249), 2,
      aux_sym__interpolated_transliteration_content,
      sym_heredoc_content,
    ACTIONS(5525), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5534), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [34125] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5537), 1,
      anon_sym_LBRACK2,
    ACTIONS(5539), 1,
      anon_sym_LBRACE3,
    STATE(2250), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5130), 7,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
  [34155] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5427), 1,
      anon_sym_DOLLAR,
    ACTIONS(5429), 1,
      anon_sym_AT,
    ACTIONS(5541), 1,
      sym__quotelike_end,
    STATE(2249), 1,
      aux_sym__interpolated_transliteration_content,
    STATE(2251), 1,
      sym_heredoc_content,
    STATE(2336), 1,
      sym__interpolation_fallbacks,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(5433), 3,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [34191] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(15), 1,
      anon_sym_LBRACE2,
    ACTIONS(5307), 1,
      anon_sym_DOLLAR,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5543), 1,
      anon_sym_GT,
    STATE(248), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2252), 1,
      sym_heredoc_content,
    STATE(3149), 1,
      sym__indirob,
    ACTIONS(5305), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2691), 3,
      sym_block,
      sym_scalar,
      sym__ident_special,
  [34231] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2253), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [34270] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2254), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [34309] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2255), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5361), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [34334] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2256), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5549), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [34357] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2257), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5551), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [34380] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2258), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5553), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [34403] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2259), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5555), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [34426] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2260), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [34465] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2261), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [34504] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2262), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [34541] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2263), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5559), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [34564] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2264), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [34603] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2265), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [34642] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2266), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [34679] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2267), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5561), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [34702] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2268), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5363), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5365), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [34727] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2269), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5130), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [34750] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2270), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5563), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [34773] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2271), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [34812] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2272), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [34851] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(3629), 1,
      anon_sym_LPAREN,
    ACTIONS(3631), 1,
      anon_sym_DOLLAR,
    ACTIONS(3633), 1,
      anon_sym_AT,
    ACTIONS(3635), 1,
      anon_sym_PERCENT2,
    STATE(1515), 1,
      sym__decl_variable_list,
    STATE(2273), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1516), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [34888] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2274), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5361), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [34913] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2275), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5353), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5355), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [34938] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2276), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [34975] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2277), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3556), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(3554), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [35000] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2278), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5363), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5365), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [35025] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2279), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5349), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5351), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [35050] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2280), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5549), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35073] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2281), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5565), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35096] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2282), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4954), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35119] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2283), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [35156] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2284), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35195] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2285), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35234] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2286), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [35271] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2287), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35310] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2288), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5553), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35333] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2289), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5551), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35356] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2290), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35395] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2291), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35434] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2292), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [35471] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2293), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [35508] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2294), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35547] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2295), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5555), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35570] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2296), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35609] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2297), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35648] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2298), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [35685] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2299), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5565), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35708] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5567), 1,
      anon_sym_COLON,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2300), 1,
      sym_heredoc_content,
    STATE(2433), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    STATE(1022), 2,
      sym_block,
      sym__semicolon,
  [35743] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2301), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5571), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35766] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2302), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35805] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2303), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5563), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35828] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2304), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5573), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35851] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2305), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [35888] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2306), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5571), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [35911] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2307), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35950] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2308), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [35989] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2309), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36028] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2310), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36067] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2311), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [36104] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2312), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36143] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2313), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36182] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2314), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36221] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5575), 1,
      anon_sym_COLON,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2315), 1,
      sym_heredoc_content,
    STATE(2440), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    STATE(1121), 2,
      sym_block,
      sym__semicolon,
  [36256] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2316), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [36293] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2317), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36332] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2318), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5559), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [36355] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2319), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36394] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2320), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36433] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2321), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [36470] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2322), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4954), 10,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [36493] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2323), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36532] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2324), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5130), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [36555] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2325), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [36592] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5577), 1,
      anon_sym_LBRACK2,
    ACTIONS(5579), 1,
      anon_sym_LBRACE3,
    STATE(2326), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5130), 6,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
  [36621] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5581), 1,
      anon_sym_LBRACK2,
    ACTIONS(5583), 1,
      anon_sym_LBRACE3,
    STATE(2327), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5130), 6,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
  [36650] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2328), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [36687] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2329), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36726] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2330), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5393), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5395), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [36751] = 12,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2331), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [36790] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2332), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5415), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5417), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACK2,
      anon_sym_LBRACE3,
  [36815] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2333), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [36852] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2334), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5561), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [36875] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2335), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5573), 10,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      sym__dollar_in_regexp,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [36898] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2336), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5585), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [36920] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOLLAR,
    ACTIONS(4286), 1,
      anon_sym_AT,
    ACTIONS(4288), 1,
      anon_sym_PERCENT2,
    STATE(1711), 1,
      sym__decl_variable_list,
    STATE(2337), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1693), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [36954] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1421), 1,
      sym__decl_variable_list,
    STATE(2338), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1419), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [36988] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2339), 1,
      sym_heredoc_content,
    STATE(2562), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37024] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2340), 1,
      sym_heredoc_content,
    STATE(2564), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37060] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2341), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5563), 9,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37082] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2342), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5587), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37104] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5591), 1,
      sym_prototype_or_signature,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1509), 1,
      sym_block,
    STATE(2343), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2665), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37140] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5593), 1,
      sym_prototype_or_signature,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1089), 1,
      sym_block,
    STATE(2344), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2692), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37176] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5595), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    STATE(2345), 2,
      sym_heredoc_content,
      aux_sym__term_rightward_repeat1,
    ACTIONS(3606), 6,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
  [37200] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5598), 1,
      sym_prototype_or_signature,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1092), 1,
      sym_block,
    STATE(2346), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2676), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37236] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5600), 1,
      sym_prototype_or_signature,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1282), 1,
      sym_block,
    STATE(2347), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2719), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37272] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5602), 1,
      sym_prototype_or_signature,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1507), 1,
      sym_block,
    STATE(2348), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2664), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37308] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2349), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5573), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37330] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2350), 1,
      sym_heredoc_content,
    STATE(2443), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    STATE(1120), 2,
      sym_block,
      sym__semicolon,
  [37362] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2351), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5563), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37384] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2352), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5571), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37406] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2353), 1,
      sym_heredoc_content,
    STATE(2459), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    STATE(1023), 2,
      sym_block,
      sym__semicolon,
  [37438] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5604), 1,
      sym_prototype_or_signature,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1288), 1,
      sym_block,
    STATE(2354), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2715), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37474] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5606), 1,
      anon_sym_COLON,
    STATE(2355), 1,
      sym_heredoc_content,
    STATE(2374), 1,
      aux_sym_attrlist_repeat1,
    STATE(2431), 1,
      sym_attribute_name,
    STATE(2453), 1,
      sym_attribute,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5458), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    ACTIONS(3420), 3,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_SEMI,
  [37506] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2345), 1,
      aux_sym__term_rightward_repeat1,
    STATE(2356), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5608), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(3623), 6,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
  [37532] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5610), 1,
      sym_prototype_or_signature,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1014), 1,
      sym_block,
    STATE(2357), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2720), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37568] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2358), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5510), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37590] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2359), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5612), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37612] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5606), 1,
      anon_sym_COLON,
    STATE(2355), 1,
      aux_sym_attrlist_repeat1,
    STATE(2360), 1,
      sym_heredoc_content,
    STATE(2431), 1,
      sym_attribute_name,
    STATE(2453), 1,
      sym_attribute,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5458), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    ACTIONS(3416), 3,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_SEMI,
  [37644] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2361), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5585), 9,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37666] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2362), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5565), 9,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37688] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(3629), 1,
      anon_sym_LPAREN,
    ACTIONS(3631), 1,
      anon_sym_DOLLAR,
    ACTIONS(3633), 1,
      anon_sym_AT,
    ACTIONS(3635), 1,
      anon_sym_PERCENT2,
    STATE(1869), 1,
      sym__decl_variable_list,
    STATE(2363), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1868), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [37722] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(3629), 1,
      anon_sym_LPAREN,
    ACTIONS(3631), 1,
      anon_sym_DOLLAR,
    ACTIONS(3633), 1,
      anon_sym_AT,
    ACTIONS(3635), 1,
      anon_sym_PERCENT2,
    STATE(1515), 1,
      sym__decl_variable_list,
    STATE(2364), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1516), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [37756] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2365), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5549), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37778] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2366), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5510), 9,
      sym__quotelike_middle_close,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37800] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2367), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5551), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37822] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2368), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5553), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37844] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3394), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      anon_sym_DOLLAR,
    ACTIONS(3398), 1,
      anon_sym_AT,
    ACTIONS(3400), 1,
      anon_sym_PERCENT2,
    STATE(1218), 1,
      sym__decl_variable_list,
    STATE(2369), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1197), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [37878] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2370), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5565), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37900] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    ACTIONS(5547), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2371), 1,
      sym_heredoc_content,
    STATE(2501), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37936] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    ACTIONS(5557), 1,
      anon_sym_COLON,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2372), 1,
      sym_heredoc_content,
    STATE(2503), 1,
      sym_bareword,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5545), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [37972] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2373), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5555), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [37994] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5617), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_attribute_name,
    STATE(2453), 1,
      sym_attribute,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5614), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2374), 2,
      sym_heredoc_content,
      aux_sym_attrlist_repeat1,
    ACTIONS(3408), 3,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_SEMI,
  [38024] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2375), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5130), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38046] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5620), 1,
      sym_prototype_or_signature,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1815), 1,
      sym_block,
    STATE(2376), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2704), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38082] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2377), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5561), 9,
      sym__quotelike_end,
      sym__qq_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38104] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5622), 1,
      sym_prototype_or_signature,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1816), 1,
      sym_block,
    STATE(2378), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2703), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38140] = 11,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5624), 1,
      sym_prototype_or_signature,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1028), 1,
      sym_block,
    STATE(2379), 1,
      sym_heredoc_content,
    STATE(2424), 1,
      sym_attribute,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2701), 1,
      sym_attrlist,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38176] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(3629), 1,
      anon_sym_LPAREN,
    ACTIONS(3631), 1,
      anon_sym_DOLLAR,
    ACTIONS(3633), 1,
      anon_sym_AT,
    ACTIONS(3635), 1,
      anon_sym_PERCENT2,
    STATE(1727), 1,
      sym__decl_variable_list,
    STATE(2380), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(1726), 3,
      sym__declare_scalar,
      sym__declare_array,
      sym__declare_hash,
  [38210] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2381), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [38243] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2382), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5553), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38264] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5636), 1,
      anon_sym_and,
    ACTIONS(5638), 1,
      anon_sym_or,
    STATE(2383), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5634), 6,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [38289] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2384), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38320] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2385), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5642), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38341] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2386), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [38374] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2387), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5565), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38395] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5636), 1,
      anon_sym_and,
    ACTIONS(5638), 1,
      anon_sym_or,
    STATE(2388), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5644), 6,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [38420] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2389), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [38453] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2390), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [38486] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2391), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38517] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2392), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38548] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5636), 1,
      anon_sym_and,
    STATE(2393), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5226), 7,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym_or,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [38571] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5646), 1,
      anon_sym_COLON,
    STATE(2394), 1,
      sym_heredoc_content,
    STATE(2395), 1,
      aux_sym_attrlist_repeat1,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2483), 1,
      sym_attribute,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3420), 2,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38602] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5651), 1,
      anon_sym_COLON,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2483), 1,
      sym_attribute,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3408), 2,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
    ACTIONS(5648), 2,
      sym__identifier,
      aux_sym__bareword_token1,
    STATE(2395), 2,
      sym_heredoc_content,
      aux_sym_attrlist_repeat1,
  [38631] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2396), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [38664] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5636), 1,
      anon_sym_and,
    ACTIONS(5638), 1,
      anon_sym_or,
    STATE(2397), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5654), 6,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [38689] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2398), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38720] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2399), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [38753] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2400), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [38786] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2401), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38817] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2402), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5571), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38838] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2403), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [38869] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2404), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5555), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38890] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2405), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [38923] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2406), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5656), 2,
      anon_sym___DATA__,
      anon_sym___END__,
    ACTIONS(5658), 2,
      sym__ctrl_z_hack,
      anon_sym_EOT,
    STATE(1100), 2,
      sym__semicolon,
      sym___DATA__,
  [38950] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2407), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5551), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38971] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2408), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5549), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [38992] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2409), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39023] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2410), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [39056] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2411), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39087] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2412), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39118] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2413), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [39151] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2414), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5660), 2,
      anon_sym___DATA__,
      anon_sym___END__,
    ACTIONS(5662), 2,
      sym__ctrl_z_hack,
      anon_sym_EOT,
    STATE(1043), 2,
      sym__semicolon,
      sym___DATA__,
  [39178] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2415), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5561), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [39199] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2416), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [39232] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2417), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5573), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [39253] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2418), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39284] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2419), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5130), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [39305] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2420), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [39338] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2421), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39369] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2422), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39400] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2423), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [39433] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5646), 1,
      anon_sym_COLON,
    STATE(2394), 1,
      aux_sym_attrlist_repeat1,
    STATE(2424), 1,
      sym_heredoc_content,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2483), 1,
      sym_attribute,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3416), 2,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39464] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2425), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [39497] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2426), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39528] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2427), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [39561] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2428), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39592] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    STATE(286), 1,
      sym_package,
    STATE(2429), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39623] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2430), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5563), 8,
      sym_escape_sequence,
      sym__heredoc_middle,
      sym_heredoc_end,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
  [39644] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5664), 1,
      sym__attribute_value_begin,
    STATE(2431), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3446), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
    ACTIONS(3448), 3,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_SEMI,
  [39668] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    ACTIONS(5666), 1,
      anon_sym_LPAREN,
    ACTIONS(5668), 1,
      anon_sym_my,
    STATE(2432), 1,
      sym_heredoc_content,
    STATE(3161), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5670), 2,
      anon_sym_state,
      anon_sym_our,
  [39698] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2433), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    STATE(1004), 2,
      sym_block,
      sym__semicolon,
  [39726] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(5626), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_my,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(2434), 1,
      sym_heredoc_content,
    STATE(3304), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_state,
      anon_sym_our,
  [39756] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(4272), 1,
      anon_sym_COLON,
    ACTIONS(4274), 1,
      sym_prototype_or_signature,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1502), 1,
      sym_block,
    STATE(2435), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [39788] = 10,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(4268), 1,
      anon_sym_COLON,
    ACTIONS(4270), 1,
      sym_prototype_or_signature,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1506), 1,
      sym_block,
    STATE(2436), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [39820] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    STATE(285), 1,
      sym_package,
    STATE(2437), 1,
      sym_heredoc_content,
    STATE(2903), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39848] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    STATE(286), 1,
      sym_package,
    STATE(2438), 1,
      sym_heredoc_content,
    STATE(2898), 1,
      sym__version,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5569), 2,
      sym_version,
      sym_number,
    ACTIONS(5640), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [39876] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2439), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3442), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
    ACTIONS(3444), 4,
      sym__PERLY_SEMICOLON,
      sym__attribute_value_begin,
      anon_sym_LBRACE2,
      anon_sym_SEMI,
  [39898] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5674), 1,
      anon_sym_COLON,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2440), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    STATE(1083), 2,
      sym_block,
      sym__semicolon,
  [39926] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2441), 1,
      sym_heredoc_content,
    STATE(2491), 1,
      sym__quotelike_middle,
    STATE(2602), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [39951] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2442), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5222), 6,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
  [39970] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2443), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    STATE(1080), 2,
      sym_block,
      sym__semicolon,
  [39995] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2444), 1,
      sym_heredoc_content,
    STATE(2493), 1,
      sym__quotelike_middle,
    STATE(2602), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40020] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2445), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5680), 6,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [40039] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2446), 1,
      sym_heredoc_content,
    STATE(2602), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2622), 1,
      sym__quotelike_middle,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40064] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2447), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5226), 6,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
  [40083] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2448), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5190), 6,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [40102] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2441), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2449), 1,
      sym_heredoc_content,
    STATE(2514), 1,
      sym__quotelike_middle,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40127] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2444), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2450), 1,
      sym_heredoc_content,
    STATE(2515), 1,
      sym__quotelike_middle,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40152] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    STATE(2451), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5226), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_RBRACK,
  [40173] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2452), 1,
      sym_heredoc_content,
    STATE(2480), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2595), 1,
      sym__quotelike_middle,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40198] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2453), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3500), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
    ACTIONS(3502), 3,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_SEMI,
  [40219] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3426), 1,
      anon_sym_COLON,
    ACTIONS(3428), 1,
      sym_prototype_or_signature,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1335), 1,
      sym_block,
    STATE(2454), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40248] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2446), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2455), 1,
      sym_heredoc_content,
    STATE(2593), 1,
      sym__quotelike_middle,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40273] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(4431), 1,
      anon_sym_COLON,
    ACTIONS(4433), 1,
      sym_prototype_or_signature,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1847), 1,
      sym_block,
    STATE(2456), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40302] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2457), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5684), 6,
      sym__PERLY_SEMICOLON,
      sym__ctrl_z_hack,
      anon_sym_SEMI,
      anon_sym___DATA__,
      anon_sym___END__,
      anon_sym_EOT,
  [40321] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5686), 1,
      sym__attribute_value_begin,
    STATE(2458), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3448), 2,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
    ACTIONS(3446), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
  [40344] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2459), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    STATE(1001), 2,
      sym_block,
      sym__semicolon,
  [40369] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(4427), 1,
      anon_sym_COLON,
    ACTIONS(4429), 1,
      sym_prototype_or_signature,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1846), 1,
      sym_block,
    STATE(2460), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40398] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2461), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    STATE(1119), 2,
      sym_block,
      sym__semicolon,
  [40423] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2462), 1,
      sym_heredoc_content,
    STATE(2505), 1,
      sym__quotelike_middle,
    STATE(2602), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40448] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2462), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2463), 1,
      sym_heredoc_content,
    STATE(2619), 1,
      sym__quotelike_middle,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40473] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2464), 1,
      sym_heredoc_content,
    STATE(2471), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2624), 1,
      sym__quotelike_middle,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40498] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2465), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3520), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
    ACTIONS(3522), 3,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_SEMI,
  [40519] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2466), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5233), 6,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
  [40538] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2467), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3388), 6,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_COLON,
      anon_sym_SEMI,
      sym_version,
      sym_number,
  [40557] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2468), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    STATE(1036), 2,
      sym_block,
      sym__semicolon,
  [40582] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2469), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3408), 3,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_SEMI,
    ACTIONS(3410), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
  [40603] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2470), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    STATE(1104), 2,
      sym_block,
      sym__semicolon,
  [40628] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2471), 1,
      sym_heredoc_content,
    STATE(2588), 1,
      sym__quotelike_middle,
    STATE(2602), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40653] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2472), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5437), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_undef,
      anon_sym_PERCENT2,
  [40672] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(4268), 1,
      anon_sym_COLON,
    ACTIONS(4270), 1,
      sym_prototype_or_signature,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1506), 1,
      sym_block,
    STATE(2473), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40701] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2474), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3442), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
    ACTIONS(3444), 3,
      sym__attribute_value_begin,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
  [40722] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(4272), 1,
      anon_sym_COLON,
    ACTIONS(4274), 1,
      sym_prototype_or_signature,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1502), 1,
      sym_block,
    STATE(2475), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40751] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2476), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5237), 6,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
  [40770] = 9,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(3430), 1,
      anon_sym_COLON,
    ACTIONS(3432), 1,
      sym_prototype_or_signature,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1238), 1,
      sym_block,
    STATE(2477), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40799] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2478), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5688), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_undef,
      anon_sym_PERCENT2,
  [40818] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(2479), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    STATE(1017), 2,
      sym_block,
      sym__semicolon,
  [40843] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5676), 1,
      sym__quotelike_middle_close,
    STATE(2480), 1,
      sym_heredoc_content,
    STATE(2602), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2625), 1,
      sym__quotelike_middle,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5678), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40868] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2481), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40894] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2482), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40920] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2483), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3502), 2,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
    ACTIONS(3500), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
  [40940] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2484), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [40966] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5495), 1,
      sym__quotelike_end,
    STATE(2485), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [40988] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5065), 1,
      sym__quotelike_end,
    STATE(2486), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41010] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2487), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [41034] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2488), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41060] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2489), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41086] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5523), 1,
      sym__quotelike_end,
    STATE(2490), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41108] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5485), 1,
      sym__quotelike_end,
    STATE(2485), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2491), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41130] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5059), 1,
      sym__quotelike_end,
    STATE(2492), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41152] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5063), 1,
      sym__quotelike_end,
    STATE(2486), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2493), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41174] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5694), 1,
      sym__identifier,
    ACTIONS(5696), 1,
      anon_sym_DOLLAR,
    STATE(1206), 1,
      sym__ident_special,
    STATE(1221), 1,
      sym_varname,
    STATE(2494), 1,
      sym_heredoc_content,
  [41202] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2495), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41228] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5694), 1,
      sym__identifier,
    ACTIONS(5696), 1,
      anon_sym_DOLLAR,
    STATE(1206), 1,
      sym__ident_special,
    STATE(1222), 1,
      sym_varname,
    STATE(2496), 1,
      sym_heredoc_content,
  [41256] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5245), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5694), 1,
      sym__identifier,
    ACTIONS(5696), 1,
      anon_sym_DOLLAR,
    STATE(1206), 1,
      sym__ident_special,
    STATE(1236), 1,
      sym_varname,
    STATE(2497), 1,
      sym_heredoc_content,
  [41284] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2498), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [41308] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2499), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41334] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2500), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41360] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5698), 1,
      anon_sym_COLON,
    ACTIONS(5700), 1,
      sym_prototype_or_signature,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1015), 1,
      sym_block,
    STATE(2501), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41386] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2502), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41412] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5702), 1,
      anon_sym_COLON,
    ACTIONS(5704), 1,
      sym_prototype_or_signature,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1021), 1,
      sym_block,
    STATE(2503), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41438] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2504), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [41462] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5043), 1,
      sym__quotelike_end,
    STATE(2505), 1,
      sym_heredoc_content,
    STATE(2599), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41484] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2506), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41510] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2507), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41536] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5041), 1,
      sym__quotelike_end,
    STATE(2508), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41558] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2509), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41584] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2510), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [41608] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2511), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41634] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2512), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41660] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5170), 1,
      aux_sym__interpolation_fallbacks_token1,
    ACTIONS(5706), 1,
      aux_sym__interpolated_transliteration_content_token1,
    STATE(2513), 1,
      sym_heredoc_content,
    ACTIONS(5174), 3,
      sym__quotelike_end_zw,
      sym__quotelike_end,
      sym__no_interp_whitespace_zw,
  [41684] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5435), 1,
      sym__quotelike_end,
    STATE(2490), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2514), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41706] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5067), 1,
      sym__quotelike_end,
    STATE(2492), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2515), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41728] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2516), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41754] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2517), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41780] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2518), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [41804] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3606), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5708), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    STATE(2519), 2,
      sym_heredoc_content,
      aux_sym__term_rightward_repeat1,
  [41824] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4939), 1,
      sym__quotelike_end,
    STATE(2520), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41846] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4985), 1,
      sym__quotelike_end,
    STATE(2521), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41868] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2522), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [41892] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5057), 1,
      sym__quotelike_end,
    STATE(2523), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41914] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5711), 1,
      sym__quotelike_end,
    STATE(2524), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41936] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5713), 1,
      sym__quotelike_end,
    STATE(2525), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [41958] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2526), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [41984] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2527), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42010] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2528), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [42034] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5715), 1,
      sym__quotelike_end,
    STATE(2529), 1,
      sym_heredoc_content,
    STATE(2537), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42056] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    ACTIONS(5717), 1,
      anon_sym_RPAREN,
    ACTIONS(5719), 1,
      anon_sym_COMMA,
    STATE(2530), 1,
      sym_heredoc_content,
    STATE(2601), 1,
      aux_sym_for_statement_repeat1,
    STATE(3093), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42082] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2531), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42108] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2532), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42134] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2533), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42160] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2534), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42186] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2535), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42212] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4933), 1,
      sym__quotelike_end,
    STATE(2520), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2536), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42234] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5721), 1,
      sym__quotelike_end,
    STATE(2537), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42256] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4967), 1,
      sym__quotelike_end,
    STATE(2521), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2538), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42278] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5017), 1,
      sym__quotelike_end,
    STATE(2523), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2539), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42300] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5723), 1,
      sym__quotelike_end,
    STATE(2524), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2540), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42322] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2541), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42348] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2542), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [42372] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    ACTIONS(5719), 1,
      anon_sym_COMMA,
    ACTIONS(5725), 1,
      anon_sym_RPAREN,
    STATE(2530), 1,
      aux_sym_for_statement_repeat1,
    STATE(2543), 1,
      sym_heredoc_content,
    STATE(3132), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42398] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5727), 1,
      sym__identifier,
    ACTIONS(5729), 1,
      anon_sym_DOLLAR,
    STATE(1513), 1,
      sym__ident_special,
    STATE(1514), 1,
      sym_varname,
    STATE(2544), 1,
      sym_heredoc_content,
  [42426] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5731), 1,
      sym__quotelike_end,
    STATE(2525), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2545), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42448] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5733), 1,
      sym__quotelike_end,
    STATE(2546), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42470] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5727), 1,
      sym__identifier,
    ACTIONS(5729), 1,
      anon_sym_DOLLAR,
    STATE(1513), 1,
      sym__ident_special,
    STATE(1517), 1,
      sym_varname,
    STATE(2547), 1,
      sym_heredoc_content,
  [42498] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2548), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [42522] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2549), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42548] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2550), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42574] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5309), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5727), 1,
      sym__identifier,
    ACTIONS(5729), 1,
      anon_sym_DOLLAR,
    STATE(1513), 1,
      sym__ident_special,
    STATE(1518), 1,
      sym_varname,
    STATE(2551), 1,
      sym_heredoc_content,
  [42602] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5519), 1,
      sym__quotelike_end,
    STATE(2552), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42624] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5721), 1,
      sym__quotelike_end,
    STATE(2553), 1,
      sym_heredoc_content,
    STATE(2578), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42646] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5727), 1,
      sym__identifier,
    ACTIONS(5735), 1,
      anon_sym_DOLLAR,
    STATE(1513), 1,
      sym__ident_special,
    STATE(1518), 1,
      sym_varname,
    STATE(2554), 1,
      sym_heredoc_content,
  [42674] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5727), 1,
      sym__identifier,
    ACTIONS(5735), 1,
      anon_sym_DOLLAR,
    STATE(1513), 1,
      sym__ident_special,
    STATE(1517), 1,
      sym_varname,
    STATE(2555), 1,
      sym_heredoc_content,
  [42702] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2556), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42728] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5261), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5727), 1,
      sym__identifier,
    ACTIONS(5735), 1,
      anon_sym_DOLLAR,
    STATE(1513), 1,
      sym__ident_special,
    STATE(1514), 1,
      sym_varname,
    STATE(2557), 1,
      sym_heredoc_content,
  [42756] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5737), 1,
      sym__quotelike_end,
    STATE(2558), 1,
      sym_heredoc_content,
    STATE(2581), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42778] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5049), 1,
      sym__quotelike_end,
    STATE(2559), 1,
      sym_heredoc_content,
    STATE(2585), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42800] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4961), 1,
      sym__quotelike_end,
    STATE(2560), 1,
      sym_heredoc_content,
    STATE(2591), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42822] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2561), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [42846] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5739), 1,
      anon_sym_COLON,
    ACTIONS(5741), 1,
      sym_prototype_or_signature,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1122), 1,
      sym_block,
    STATE(2562), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42872] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2563), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42898] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5743), 1,
      anon_sym_COLON,
    ACTIONS(5745), 1,
      sym_prototype_or_signature,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1123), 1,
      sym_block,
    STATE(2564), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42924] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5731), 1,
      sym__quotelike_end,
    STATE(2565), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [42946] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2566), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [42972] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2519), 1,
      aux_sym__term_rightward_repeat1,
    STATE(2567), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3623), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
    ACTIONS(5747), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [42994] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2568), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43020] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4937), 1,
      sym__quotelike_end,
    STATE(2569), 1,
      sym_heredoc_content,
    STATE(2592), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43042] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2570), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [43066] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2571), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43092] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2572), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43118] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2573), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43144] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2574), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43170] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2575), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3522), 2,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
    ACTIONS(3520), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
  [43190] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2576), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [43214] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2577), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [43238] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5749), 1,
      sym__quotelike_end,
    STATE(2578), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43260] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2579), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43286] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2580), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43312] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5751), 1,
      sym__quotelike_end,
    STATE(2581), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43334] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    ACTIONS(5719), 1,
      anon_sym_COMMA,
    ACTIONS(5753), 1,
      anon_sym_RPAREN,
    STATE(2582), 1,
      sym_heredoc_content,
    STATE(2601), 1,
      aux_sym_for_statement_repeat1,
    STATE(3067), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43360] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5033), 1,
      sym__quotelike_end,
    STATE(2583), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43382] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2584), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [43406] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5045), 1,
      sym__quotelike_end,
    STATE(2585), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43428] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5755), 1,
      sym__quotelike_end,
    STATE(2565), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2586), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43450] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2587), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43476] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5497), 1,
      sym__quotelike_end,
    STATE(2588), 1,
      sym_heredoc_content,
    STATE(2597), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43498] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2589), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43524] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5489), 1,
      sym__quotelike_end,
    STATE(2590), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43546] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4965), 1,
      sym__quotelike_end,
    STATE(2591), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43568] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4923), 1,
      sym__quotelike_end,
    STATE(2592), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43590] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5037), 1,
      sym__quotelike_end,
    STATE(2593), 1,
      sym_heredoc_content,
    STATE(2623), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43612] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2594), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43638] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5491), 1,
      sym__quotelike_end,
    STATE(2595), 1,
      sym_heredoc_content,
    STATE(2627), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43660] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2596), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43686] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5541), 1,
      sym__quotelike_end,
    STATE(2597), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43708] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2598), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43734] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5061), 1,
      sym__quotelike_end,
    STATE(2599), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43756] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5757), 1,
      sym__identifier,
    ACTIONS(5759), 1,
      anon_sym_DOLLAR,
    STATE(1715), 1,
      sym_varname,
    STATE(1721), 1,
      sym__ident_special,
    STATE(2600), 1,
      sym_heredoc_content,
  [43784] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5761), 1,
      anon_sym_RPAREN,
    ACTIONS(5763), 1,
      anon_sym_COMMA,
    ACTIONS(5766), 1,
      anon_sym_DOLLAR,
    STATE(3158), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2601), 2,
      sym_heredoc_content,
      aux_sym_for_statement_repeat1,
  [43808] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5769), 1,
      sym__quotelike_middle_close,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2602), 2,
      aux_sym__noninterpolated_string_content,
      sym_heredoc_content,
    ACTIONS(5771), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43828] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5774), 1,
      sym__quotelike_end,
    STATE(2603), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43850] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5757), 1,
      sym__identifier,
    ACTIONS(5759), 1,
      anon_sym_DOLLAR,
    STATE(1691), 1,
      sym_varname,
    STATE(1721), 1,
      sym__ident_special,
    STATE(2604), 1,
      sym_heredoc_content,
  [43878] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5269), 1,
      aux_sym__ident_special_token1,
    ACTIONS(5757), 1,
      sym__identifier,
    ACTIONS(5759), 1,
      anon_sym_DOLLAR,
    STATE(1714), 1,
      sym_varname,
    STATE(1721), 1,
      sym__ident_special,
    STATE(2605), 1,
      sym_heredoc_content,
  [43906] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5776), 1,
      sym__quotelike_end,
    STATE(2606), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43928] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5047), 1,
      sym__quotelike_end,
    STATE(2607), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43950] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5733), 1,
      sym__quotelike_end,
    STATE(2603), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2608), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [43972] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2609), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [43998] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1600), 1,
      sym_block,
    STATE(2610), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44024] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5778), 1,
      sym__quotelike_end,
    STATE(2606), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2611), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44046] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4963), 1,
      sym__quotelike_end,
    STATE(2612), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44068] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5001), 1,
      sym__quotelike_end,
    STATE(2607), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2613), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44090] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4941), 1,
      sym__quotelike_end,
    STATE(2614), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44112] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4969), 1,
      sym__quotelike_end,
    STATE(2612), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2615), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44134] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2616), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44160] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2617), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44186] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2618), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [44210] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4999), 1,
      sym__quotelike_end,
    STATE(2583), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2619), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44232] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(4959), 1,
      sym__quotelike_end,
    STATE(2614), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2620), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44254] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2621), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3408), 2,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
    ACTIONS(3410), 3,
      anon_sym_COLON,
      sym__identifier,
      aux_sym__bareword_token1,
  [44274] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5055), 1,
      sym__quotelike_end,
    STATE(2508), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2622), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44296] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5035), 1,
      sym__quotelike_end,
    STATE(2623), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44318] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5521), 1,
      sym__quotelike_end,
    STATE(2590), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2624), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44340] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5431), 1,
      sym__quotelike_end,
    STATE(2552), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2625), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44362] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5780), 1,
      aux_sym__interpolation_fallbacks_token1,
    ACTIONS(5782), 1,
      aux_sym__interpolated_transliteration_content_token1,
    STATE(2626), 1,
      sym_heredoc_content,
    ACTIONS(5784), 3,
      sym__quotelike_end_zw,
      sym__quotelike_end,
      sym__no_interp_whitespace_zw,
  [44386] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5454), 1,
      sym__quotelike_end,
    STATE(2627), 1,
      sym_heredoc_content,
    STATE(2628), 1,
      aux_sym__noninterpolated_string_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44408] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5769), 1,
      sym__quotelike_end,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    STATE(2628), 2,
      aux_sym__noninterpolated_string_content,
      sym_heredoc_content,
    ACTIONS(5786), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44428] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2629), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44454] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5789), 1,
      sym__quotelike_end,
    STATE(2546), 1,
      aux_sym__noninterpolated_string_content,
    STATE(2630), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5690), 3,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44476] = 8,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    ACTIONS(5719), 1,
      anon_sym_COMMA,
    ACTIONS(5791), 1,
      anon_sym_RPAREN,
    STATE(2582), 1,
      aux_sym_for_statement_repeat1,
    STATE(2631), 1,
      sym_heredoc_content,
    STATE(3068), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44502] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2632), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44525] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2633), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2907), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
  [44542] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1620), 1,
      sym_attribute_name,
    STATE(1670), 1,
      sym_attribute,
    STATE(2634), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4369), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [44563] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1369), 1,
      sym_attribute_name,
    STATE(1378), 1,
      sym_attribute,
    STATE(2635), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3945), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [44584] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2636), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44607] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    STATE(2300), 1,
      sym_package,
    STATE(2637), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [44628] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(264), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(961), 1,
      sym_block,
    STATE(2638), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44651] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1298), 1,
      sym_block,
    STATE(2639), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44674] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1039), 1,
      sym_block,
    STATE(2640), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44697] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2641), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44720] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2642), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44743] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2643), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44766] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1648), 1,
      sym_attribute_name,
    STATE(1678), 1,
      sym_attribute,
    STATE(2644), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4494), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [44787] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(271), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1029), 1,
      sym_block,
    STATE(2645), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44810] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2646), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2917), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
  [44827] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2647), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44850] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2648), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44873] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2649), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44896] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1600), 1,
      sym_block,
    STATE(2650), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44919] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1082), 1,
      sym_block,
    STATE(2651), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44942] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2652), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5612), 4,
      sym__quotelike_end,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [44959] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2653), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2911), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
  [44976] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2654), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [44999] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2655), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45022] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2656), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45045] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2657), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5793), 4,
      sym__quotelike_end,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [45062] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(4298), 1,
      sym__apostrophe,
    ACTIONS(4300), 1,
      sym__quotelike_begin,
    STATE(2658), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45085] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(4294), 1,
      sym__apostrophe,
    ACTIONS(4296), 1,
      sym__quotelike_begin,
    STATE(2659), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45108] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2660), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45131] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2661), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45154] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(4290), 1,
      sym__apostrophe,
    ACTIONS(4292), 1,
      sym__quotelike_begin,
    STATE(2662), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45177] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2663), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45200] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5795), 1,
      sym_prototype_or_signature,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1535), 1,
      sym_block,
    STATE(2664), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45223] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5797), 1,
      sym_prototype_or_signature,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1537), 1,
      sym_block,
    STATE(2665), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45246] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5799), 1,
      anon_sym_LPAREN,
    STATE(259), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1047), 1,
      sym_block,
    STATE(2666), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45269] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2667), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45292] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2668), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45315] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5801), 1,
      anon_sym_SEMI,
    ACTIONS(5803), 1,
      anon_sym_RPAREN,
    ACTIONS(5805), 1,
      anon_sym_or,
    STATE(2669), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45338] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2670), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45361] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2431), 1,
      sym_attribute_name,
    STATE(2469), 1,
      sym_attribute,
    STATE(2671), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5458), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [45382] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2672), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45405] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2673), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45428] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2674), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45451] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2675), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45474] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5807), 1,
      sym_prototype_or_signature,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1114), 1,
      sym_block,
    STATE(2676), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45497] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2677), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45520] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2678), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45543] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2679), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45566] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2680), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45589] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5809), 1,
      anon_sym_SEMI,
    ACTIONS(5811), 1,
      anon_sym_RPAREN,
    STATE(2681), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45612] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2682), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45635] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2683), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45658] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2684), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45681] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2685), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45704] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2686), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45727] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2687), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45750] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2688), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45773] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2689), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45796] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2690), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2903), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
  [45813] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2691), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2891), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
  [45830] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5813), 1,
      sym_prototype_or_signature,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1116), 1,
      sym_block,
    STATE(2692), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45853] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1837), 1,
      sym_block,
    STATE(2693), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45876] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2694), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5793), 4,
      sym__quotelike_middle_close,
      sym__q_string_content,
      sym_escape_sequence,
      sym_escaped_delimiter,
  [45893] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2695), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45916] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2696), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45939] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2697), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45962] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2698), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [45985] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2699), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46008] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2700), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46031] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5815), 1,
      sym_prototype_or_signature,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1041), 1,
      sym_block,
    STATE(2701), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46054] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2702), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2946), 4,
      sym__PERLY_SEMICOLON,
      anon_sym_LBRACE2,
      anon_sym_COLON,
      anon_sym_SEMI,
  [46071] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5817), 1,
      sym_prototype_or_signature,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1805), 1,
      sym_block,
    STATE(2703), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46094] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5819), 1,
      sym_prototype_or_signature,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1803), 1,
      sym_block,
    STATE(2704), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46117] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2705), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46140] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2706), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46163] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2707), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46186] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2708), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46209] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2709), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46232] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2710), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46255] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    STATE(2315), 1,
      sym_package,
    STATE(2711), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [46276] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1394), 1,
      sym_attribute_name,
    STATE(1427), 1,
      sym_attribute,
    STATE(2712), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4278), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [46297] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2713), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2899), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
  [46314] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1141), 1,
      sym_attribute_name,
    STATE(1159), 1,
      sym_attribute,
    STATE(2714), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(3412), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [46335] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5821), 1,
      sym_prototype_or_signature,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1286), 1,
      sym_block,
    STATE(2715), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46358] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5823), 1,
      anon_sym_LPAREN,
    STATE(268), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(964), 1,
      sym_block,
    STATE(2716), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46381] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3623), 1,
      anon_sym_RPAREN,
    STATE(2717), 1,
      sym_heredoc_content,
    STATE(2718), 1,
      aux_sym__term_rightward_repeat1,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5825), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [46402] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3606), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5827), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    STATE(2718), 2,
      sym_heredoc_content,
      aux_sym__term_rightward_repeat1,
  [46421] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5830), 1,
      sym_prototype_or_signature,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1316), 1,
      sym_block,
    STATE(2719), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46444] = 7,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    ACTIONS(5832), 1,
      sym_prototype_or_signature,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(987), 1,
      sym_block,
    STATE(2720), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46467] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2458), 1,
      sym_attribute_name,
    STATE(2621), 1,
      sym_attribute,
    STATE(2721), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5589), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [46488] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1013), 1,
      sym_block,
    STATE(2722), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46508] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5834), 1,
      anon_sym_RBRACK,
    STATE(2723), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46528] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5836), 1,
      anon_sym_RBRACK,
    STATE(2724), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46548] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5838), 1,
      anon_sym_RPAREN,
    STATE(2725), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46568] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1046), 1,
      sym_block,
    STATE(2726), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46588] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5840), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46608] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    ACTIONS(5842), 1,
      anon_sym_LPAREN,
    STATE(2728), 1,
      sym_heredoc_content,
    STATE(3305), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46628] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(979), 1,
      sym_block,
    STATE(2729), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46648] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5844), 1,
      anon_sym_RBRACK,
    STATE(2730), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46668] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5846), 1,
      anon_sym_RPAREN,
    STATE(2731), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46688] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5848), 1,
      anon_sym_RBRACK,
    STATE(2732), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46708] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1007), 1,
      sym_block,
    STATE(2733), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46728] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2353), 1,
      sym_package,
    STATE(2734), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [46746] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5850), 1,
      anon_sym_RBRACE,
    STATE(2735), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46766] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5852), 1,
      anon_sym_RBRACK,
    STATE(2736), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46786] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5854), 1,
      anon_sym_RPAREN,
    STATE(2737), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46806] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5856), 1,
      anon_sym_RBRACK,
    STATE(2738), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46826] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5858), 1,
      anon_sym_RBRACE,
    STATE(2739), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46846] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5860), 1,
      anon_sym_RBRACK,
    STATE(2740), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46866] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5862), 1,
      anon_sym_RPAREN,
    STATE(2741), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46886] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1045), 1,
      sym_block,
    STATE(2742), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46906] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1020), 1,
      sym_block,
    STATE(2743), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46926] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5864), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46946] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5866), 1,
      anon_sym_RBRACK,
    STATE(2745), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46966] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(981), 1,
      sym_block,
    STATE(2746), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [46986] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(988), 1,
      sym_block,
    STATE(2747), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47006] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(974), 1,
      sym_block,
    STATE(2748), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47026] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5868), 1,
      anon_sym_RPAREN,
    STATE(2749), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47046] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(992), 1,
      sym_block,
    STATE(2750), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47066] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5870), 1,
      anon_sym_RPAREN,
    STATE(2751), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47086] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5872), 1,
      anon_sym_SEMI,
    STATE(2752), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47106] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(993), 1,
      sym_block,
    STATE(2753), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47126] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1304), 1,
      sym_block,
    STATE(2754), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47146] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(994), 1,
      sym_block,
    STATE(2755), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47166] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(997), 1,
      sym_block,
    STATE(2756), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47186] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5874), 1,
      anon_sym_RPAREN,
    STATE(2757), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47206] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5876), 1,
      anon_sym_RPAREN,
    STATE(2758), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47226] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5878), 1,
      anon_sym_SEMI,
    STATE(2759), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47246] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3470), 1,
      sym__apostrophe,
    ACTIONS(3472), 1,
      sym__quotelike_begin,
    STATE(2760), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47266] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1000), 1,
      sym_block,
    STATE(2761), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47286] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5880), 1,
      anon_sym_RPAREN,
    STATE(2762), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47306] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5882), 1,
      anon_sym_SEMI,
    STATE(2763), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47326] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3466), 1,
      sym__apostrophe,
    ACTIONS(3468), 1,
      sym__quotelike_begin,
    STATE(2764), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47346] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3462), 1,
      sym__apostrophe,
    ACTIONS(3464), 1,
      sym__quotelike_begin,
    STATE(2765), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47366] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2766), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5761), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLAR,
  [47382] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5884), 1,
      anon_sym_RPAREN,
    STATE(2767), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47402] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1002), 1,
      sym_block,
    STATE(2768), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47422] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1024), 1,
      sym_block,
    STATE(2769), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47442] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(986), 1,
      sym_block,
    STATE(2770), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47462] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1038), 1,
      sym_block,
    STATE(2771), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47482] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2772), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47502] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2773), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47522] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5890), 1,
      anon_sym_RPAREN,
    STATE(2774), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47542] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1005), 1,
      sym_block,
    STATE(2775), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47562] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5892), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47582] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5894), 1,
      anon_sym_RPAREN,
    STATE(2777), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47602] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5896), 1,
      anon_sym_RPAREN,
    STATE(2778), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47622] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1028), 1,
      sym_block,
    STATE(2779), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47642] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2780), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47662] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1307), 1,
      sym_block,
    STATE(2781), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47682] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2782), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47702] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1267), 1,
      sym_block,
    STATE(2783), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47722] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5898), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47742] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1014), 1,
      sym_block,
    STATE(2785), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47762] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(977), 1,
      sym_block,
    STATE(2786), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47782] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2787), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47802] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5900), 1,
      anon_sym_RBRACK,
    STATE(2788), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47822] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1030), 1,
      sym_block,
    STATE(2789), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47842] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1284), 1,
      sym_block,
    STATE(2790), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47862] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(959), 1,
      sym_block,
    STATE(2791), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47882] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5902), 1,
      anon_sym_RBRACE,
    STATE(2792), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47902] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5904), 1,
      anon_sym_RBRACK,
    STATE(2793), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47922] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5906), 1,
      anon_sym_RBRACE,
    STATE(2794), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47942] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5908), 1,
      anon_sym_RBRACK,
    STATE(2795), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47962] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5910), 1,
      anon_sym_RBRACE,
    STATE(2796), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [47982] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5912), 1,
      anon_sym_RBRACK,
    STATE(2797), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48002] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5914), 1,
      anon_sym_RBRACK,
    STATE(2798), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48022] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5916), 1,
      anon_sym_RPAREN,
    STATE(2799), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48042] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5918), 1,
      anon_sym_RBRACK,
    STATE(2800), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48062] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5920), 1,
      anon_sym_RBRACK,
    STATE(2801), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48082] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(976), 1,
      sym_block,
    STATE(2802), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48102] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5922), 1,
      anon_sym_RBRACE,
    STATE(2803), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48122] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5924), 1,
      anon_sym_RPAREN,
    STATE(2804), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48142] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5926), 1,
      anon_sym_RPAREN,
    STATE(2805), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48162] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1110), 1,
      sym_block,
    STATE(2806), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48182] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5928), 1,
      anon_sym_RBRACK,
    STATE(2807), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48202] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1006), 1,
      sym_block,
    STATE(2808), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48222] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2809), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48242] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5930), 1,
      anon_sym_RPAREN,
    STATE(2810), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48262] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1034), 1,
      sym_block,
    STATE(2811), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48282] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2812), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48302] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2813), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48322] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5932), 1,
      anon_sym_RPAREN,
    STATE(2814), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48342] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5934), 1,
      anon_sym_RPAREN,
    STATE(2815), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48362] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1008), 1,
      sym_block,
    STATE(2816), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48382] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5936), 1,
      anon_sym_RPAREN,
    STATE(2817), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48402] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5938), 1,
      anon_sym_RBRACK,
    STATE(2818), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48422] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2819), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48442] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2820), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48462] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2821), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48482] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2350), 1,
      sym_package,
    STATE(2822), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5692), 2,
      sym__identifier,
      aux_sym__bareword_token1,
  [48500] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2823), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48520] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2824), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48540] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2825), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48560] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2826), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48580] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2827), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48600] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5940), 1,
      anon_sym_RBRACE,
    STATE(2828), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48620] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5942), 1,
      anon_sym_RBRACK,
    STATE(2829), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48640] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5944), 1,
      anon_sym_RBRACE,
    STATE(2830), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48660] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5946), 1,
      anon_sym_RPAREN,
    STATE(2831), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48680] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5948), 1,
      anon_sym_RPAREN,
    STATE(2832), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48700] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5950), 1,
      anon_sym_RPAREN,
    STATE(2833), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48720] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(4354), 1,
      sym__quotelike_begin,
    STATE(2834), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48740] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5952), 1,
      anon_sym_RBRACK,
    STATE(2835), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48760] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(4298), 1,
      sym__apostrophe,
    ACTIONS(4300), 1,
      sym__quotelike_begin,
    STATE(2836), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48780] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5954), 1,
      anon_sym_RPAREN,
    STATE(2837), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48800] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5956), 1,
      anon_sym_RBRACK,
    STATE(2838), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48820] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5958), 1,
      anon_sym_RPAREN,
    STATE(2839), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48840] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(4294), 1,
      sym__apostrophe,
    ACTIONS(4296), 1,
      sym__quotelike_begin,
    STATE(2840), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48860] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(4290), 1,
      sym__apostrophe,
    ACTIONS(4292), 1,
      sym__quotelike_begin,
    STATE(2841), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48880] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(268), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(968), 1,
      sym_block,
    STATE(2842), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48900] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5960), 1,
      anon_sym_RPAREN,
    STATE(2843), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48920] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1010), 1,
      sym_block,
    STATE(2844), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48940] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1507), 1,
      sym_block,
    STATE(2845), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48960] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2846), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [48980] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5962), 1,
      anon_sym_RBRACK,
    STATE(2847), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49000] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2848), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49020] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1782), 1,
      sym_block,
    STATE(2849), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49040] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1783), 1,
      sym_block,
    STATE(2850), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49060] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5964), 1,
      anon_sym_RBRACE,
    STATE(2851), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49080] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(4360), 1,
      sym__quotelike_begin,
    STATE(2852), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49100] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5966), 1,
      anon_sym_RBRACK,
    STATE(2853), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49120] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5968), 1,
      anon_sym_RBRACE,
    STATE(2854), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49140] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5970), 1,
      anon_sym_RBRACK,
    STATE(2855), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49160] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5972), 1,
      anon_sym_RBRACE,
    STATE(2856), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49180] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5974), 1,
      anon_sym_RBRACK,
    STATE(2857), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49200] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5976), 1,
      anon_sym_RPAREN,
    STATE(2858), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49220] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    ACTIONS(4362), 1,
      sym__quotelike_begin,
    STATE(2859), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49240] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5978), 1,
      anon_sym_RBRACK,
    STATE(2860), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49260] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5980), 1,
      anon_sym_RBRACK,
    STATE(2861), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49280] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5982), 1,
      anon_sym_RBRACK,
    STATE(2862), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49300] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2863), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49320] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2864), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49340] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2865), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49360] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1509), 1,
      sym_block,
    STATE(2866), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49380] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5984), 1,
      anon_sym_LBRACE,
    ACTIONS(5986), 1,
      anon_sym_LBRACK,
    ACTIONS(5988), 1,
      anon_sym_STAR,
    STATE(2867), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49400] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5990), 1,
      anon_sym_LBRACE,
    ACTIONS(5992), 1,
      anon_sym_LBRACK,
    ACTIONS(5994), 1,
      anon_sym_STAR,
    STATE(2868), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49420] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5996), 1,
      anon_sym_RBRACK,
    STATE(2869), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49440] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(5998), 1,
      anon_sym_RBRACE,
    STATE(2870), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49460] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6000), 1,
      anon_sym_RBRACK,
    STATE(2871), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49480] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6002), 1,
      anon_sym_RBRACE,
    STATE(2872), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49500] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6004), 1,
      anon_sym_RPAREN,
    STATE(2873), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49520] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6006), 1,
      anon_sym_RBRACK,
    STATE(2874), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49540] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1042), 1,
      sym_block,
    STATE(2875), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49560] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6008), 1,
      anon_sym_RBRACK,
    STATE(2876), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49580] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6010), 1,
      anon_sym_RPAREN,
    STATE(2877), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49600] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6012), 1,
      anon_sym_SEMI,
    STATE(2878), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49620] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2879), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49640] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2880), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49660] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2881), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49680] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6014), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49700] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1037), 1,
      sym_block,
    STATE(2883), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49720] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(975), 1,
      sym_block,
    STATE(2884), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49740] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2885), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49760] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2886), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49780] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6016), 1,
      anon_sym_RPAREN,
    STATE(2887), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49800] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6018), 1,
      anon_sym_RPAREN,
    STATE(2888), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49820] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1009), 1,
      sym_block,
    STATE(2889), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49840] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1033), 1,
      sym_block,
    STATE(2890), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49860] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6020), 1,
      anon_sym_RPAREN,
    STATE(2891), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49880] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1016), 1,
      sym_block,
    STATE(2892), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49900] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6022), 1,
      anon_sym_RPAREN,
    STATE(2893), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49920] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(973), 1,
      sym_block,
    STATE(2894), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49940] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1804), 1,
      sym_block,
    STATE(2895), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49960] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(984), 1,
      sym_block,
    STATE(2896), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [49980] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1806), 1,
      sym_block,
    STATE(2897), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50000] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1055), 1,
      sym__semicolon,
    STATE(2898), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
  [50018] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2899), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50038] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6024), 1,
      anon_sym_RBRACE,
    STATE(2900), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50058] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2901), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50078] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    ACTIONS(6026), 1,
      anon_sym_LPAREN,
    STATE(2902), 1,
      sym_heredoc_content,
    STATE(3151), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50098] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1025), 1,
      sym__semicolon,
    STATE(2903), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
  [50116] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(972), 1,
      sym_block,
    STATE(2904), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50136] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6028), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50156] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6030), 1,
      anon_sym_RBRACE,
    STATE(2906), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50176] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2907), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50196] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2908), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50216] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2909), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50236] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6032), 1,
      anon_sym_RBRACK,
    STATE(2910), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50256] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6034), 1,
      anon_sym_RPAREN,
    STATE(2911), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50276] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2912), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50296] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2913), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50316] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2914), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50336] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6036), 1,
      anon_sym_RBRACE,
    STATE(2915), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50356] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2916), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50376] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2917), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50396] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2918), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50416] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2919), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50436] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6038), 1,
      anon_sym_RPAREN,
    STATE(2920), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50456] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(971), 1,
      sym_block,
    STATE(2921), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50476] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6040), 1,
      anon_sym_RPAREN,
    STATE(2922), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50496] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1534), 1,
      sym_block,
    STATE(2923), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50516] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2924), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50536] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1815), 1,
      sym_block,
    STATE(2925), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50556] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(263), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1816), 1,
      sym_block,
    STATE(2926), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50576] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1089), 1,
      sym_block,
    STATE(2927), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50596] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(4515), 1,
      sym__apostrophe,
    ACTIONS(4517), 1,
      sym__quotelike_begin,
    STATE(2928), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50616] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(4525), 1,
      sym__apostrophe,
    ACTIONS(4527), 1,
      sym__quotelike_begin,
    STATE(2929), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50636] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(4519), 1,
      sym__apostrophe,
    ACTIONS(4521), 1,
      sym__quotelike_begin,
    STATE(2930), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50656] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1536), 1,
      sym_block,
    STATE(2931), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50676] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1092), 1,
      sym_block,
    STATE(2932), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50696] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6042), 1,
      anon_sym_RPAREN,
    STATE(2933), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50716] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6044), 1,
      anon_sym_RPAREN,
    STATE(2934), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50736] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1095), 1,
      sym_block,
    STATE(2935), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50756] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(2936), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(6046), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLAR,
  [50772] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6048), 1,
      anon_sym_RPAREN,
    STATE(2937), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50792] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2938), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50812] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6050), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50832] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6052), 1,
      anon_sym_RBRACK,
    STATE(2940), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50852] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2941), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50872] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6054), 1,
      anon_sym_LBRACE,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6058), 1,
      anon_sym_STAR,
    STATE(2942), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50892] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2943), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50912] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6060), 1,
      anon_sym_LBRACE,
    ACTIONS(6062), 1,
      anon_sym_LBRACK,
    ACTIONS(6064), 1,
      anon_sym_STAR,
    STATE(2944), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50932] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2945), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50952] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2946), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50972] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2947), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [50992] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6066), 1,
      anon_sym_RPAREN,
    STATE(2948), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51012] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(970), 1,
      sym_block,
    STATE(2949), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51032] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6068), 1,
      anon_sym_RBRACK,
    STATE(2950), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51052] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2951), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51072] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51092] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(960), 1,
      sym_block,
    STATE(2953), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51112] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6070), 1,
      anon_sym_RPAREN,
    STATE(2954), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51132] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1031), 1,
      sym__semicolon,
    STATE(2955), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
  [51150] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2956), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51170] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1091), 1,
      sym_block,
    STATE(2957), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51190] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1088), 1,
      sym_block,
    STATE(2958), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51210] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1085), 1,
      sym_block,
    STATE(2959), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51230] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(967), 1,
      sym_block,
    STATE(2960), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51250] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1078), 1,
      sym_block,
    STATE(2961), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51270] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1103), 1,
      sym_block,
    STATE(2962), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51290] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1053), 1,
      sym_block,
    STATE(2963), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51310] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2964), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51330] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1054), 1,
      sym_block,
    STATE(2965), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51350] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1056), 1,
      sym_block,
    STATE(2966), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51370] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1057), 1,
      sym_block,
    STATE(2967), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51390] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1058), 1,
      sym_block,
    STATE(2968), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51410] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1059), 1,
      sym_block,
    STATE(2969), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51430] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1060), 1,
      sym_block,
    STATE(2970), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51450] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1061), 1,
      sym_block,
    STATE(2971), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51470] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2972), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51490] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1062), 1,
      sym_block,
    STATE(2973), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51510] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1063), 1,
      sym_block,
    STATE(2974), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51530] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1064), 1,
      sym_block,
    STATE(2975), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51550] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1065), 1,
      sym_block,
    STATE(2976), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51570] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1066), 1,
      sym_block,
    STATE(2977), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51590] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(2978), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51610] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(2979), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51630] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(2980), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51650] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6072), 1,
      anon_sym_RBRACE,
    STATE(2981), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51670] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6074), 1,
      anon_sym_RBRACK,
    STATE(2982), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51690] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6076), 1,
      anon_sym_RBRACE,
    STATE(2983), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51710] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(2984), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51730] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(2985), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51750] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6078), 1,
      anon_sym_RBRACK,
    STATE(2986), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51770] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1067), 1,
      sym_block,
    STATE(2987), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51790] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1068), 1,
      sym_block,
    STATE(2988), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51810] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6080), 1,
      anon_sym_RBRACE,
    STATE(2989), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51830] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1069), 1,
      sym_block,
    STATE(2990), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51850] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1070), 1,
      sym_block,
    STATE(2991), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51870] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1071), 1,
      sym_block,
    STATE(2992), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51890] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1072), 1,
      sym_block,
    STATE(2993), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51910] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1073), 1,
      sym_block,
    STATE(2994), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51930] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1074), 1,
      sym_block,
    STATE(2995), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51950] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1075), 1,
      sym_block,
    STATE(2996), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51970] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6082), 1,
      anon_sym_RBRACK,
    STATE(2997), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [51990] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1077), 1,
      sym_block,
    STATE(2998), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52010] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6084), 1,
      anon_sym_RBRACE,
    STATE(2999), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52030] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(259), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1050), 1,
      sym_block,
    STATE(3000), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52050] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6086), 1,
      anon_sym_RBRACK,
    STATE(3001), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52070] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6088), 1,
      anon_sym_LBRACE,
    ACTIONS(6090), 1,
      anon_sym_LBRACK,
    ACTIONS(6092), 1,
      anon_sym_STAR,
    STATE(3002), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52090] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6094), 1,
      anon_sym_RPAREN,
    STATE(3003), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52110] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1288), 1,
      sym_block,
    STATE(3004), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52130] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6096), 1,
      anon_sym_LBRACE,
    ACTIONS(6098), 1,
      anon_sym_LBRACK,
    ACTIONS(6100), 1,
      anon_sym_STAR,
    STATE(3005), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52150] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6102), 1,
      anon_sym_RBRACK,
    STATE(3006), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52170] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6104), 1,
      anon_sym_RPAREN,
    STATE(3007), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52190] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6106), 1,
      anon_sym_RBRACK,
    STATE(3008), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52210] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6108), 1,
      anon_sym_RBRACK,
    STATE(3009), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52230] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6110), 1,
      anon_sym_RBRACE,
    STATE(3010), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52250] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(3011), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52270] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(3012), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52290] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(3013), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52310] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1027), 1,
      sym_block,
    STATE(3014), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52330] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1011), 1,
      sym__semicolon,
    STATE(3015), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2360), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
  [52348] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6112), 1,
      anon_sym_RBRACK,
    STATE(3016), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52368] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(3017), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52388] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(3018), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52408] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6114), 1,
      anon_sym_RBRACK,
    STATE(3019), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52428] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6116), 1,
      anon_sym_RBRACE,
    STATE(3020), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52448] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6118), 1,
      anon_sym_RBRACK,
    STATE(3021), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52468] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1093), 1,
      sym_block,
    STATE(3022), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52488] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1052), 1,
      sym_block,
    STATE(3023), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52508] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3024), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2881), 3,
      sym_prototype_or_signature,
      anon_sym_LBRACE2,
      anon_sym_COLON,
  [52524] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6120), 1,
      anon_sym_RBRACK,
    STATE(3025), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52544] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(3026), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52564] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1097), 1,
      sym_block,
    STATE(3027), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52584] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(3028), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52604] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6122), 1,
      anon_sym_RBRACK,
    STATE(3029), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52624] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1101), 1,
      sym_block,
    STATE(3030), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52644] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1102), 1,
      sym_block,
    STATE(3031), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52664] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(3032), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52684] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6124), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52704] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6126), 1,
      anon_sym_RBRACK,
    STATE(3034), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52724] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6128), 1,
      anon_sym_RPAREN,
    STATE(3035), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52744] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(3036), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52764] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(276), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(978), 1,
      sym_block,
    STATE(3037), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52784] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1106), 1,
      sym_block,
    STATE(3038), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52804] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(965), 1,
      sym_block,
    STATE(3039), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52824] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1112), 1,
      sym_block,
    STATE(3040), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52844] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(3041), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52864] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(3042), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52884] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(3043), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52904] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(3044), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52924] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(3045), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52944] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(3046), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52964] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(3047), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [52984] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(3048), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53004] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(3049), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53024] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6130), 1,
      anon_sym_RPAREN,
    STATE(3050), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53044] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(3051), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53064] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(244), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1282), 1,
      sym_block,
    STATE(3052), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53084] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6132), 1,
      anon_sym_RBRACK,
    STATE(3053), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53104] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6134), 1,
      anon_sym_RBRACK,
    STATE(3054), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53124] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(3055), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53144] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1098), 1,
      sym__semicolon,
    STATE(3056), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
  [53162] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1115), 1,
      sym_block,
    STATE(3057), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53182] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1598), 1,
      sym_block,
    STATE(3058), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53202] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6136), 1,
      anon_sym_RBRACE,
    STATE(3059), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53222] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6138), 1,
      anon_sym_RBRACK,
    STATE(3060), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53242] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(1113), 1,
      sym__semicolon,
    STATE(3061), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(2364), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
  [53260] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(261), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1117), 1,
      sym_block,
    STATE(3062), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53280] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3424), 1,
      anon_sym_LBRACE2,
    STATE(275), 1,
      sym__PERLY_BRACE_OPEN,
    STATE(1599), 1,
      sym_block,
    STATE(3063), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53300] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6140), 1,
      anon_sym_RBRACE,
    STATE(3064), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53320] = 6,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5682), 1,
      anon_sym_and,
    ACTIONS(5805), 1,
      anon_sym_or,
    ACTIONS(6142), 1,
      anon_sym_RBRACK,
    STATE(3065), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53340] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3066), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(6144), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [53355] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6146), 1,
      anon_sym_RPAREN,
    ACTIONS(6148), 1,
      anon_sym_COMMA,
    STATE(3067), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53372] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5753), 1,
      anon_sym_RPAREN,
    ACTIONS(6148), 1,
      anon_sym_COMMA,
    STATE(3068), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53389] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    STATE(3069), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53406] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6150), 1,
      anon_sym_RPAREN,
    ACTIONS(6152), 1,
      anon_sym_COMMA,
    STATE(3070), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53423] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(3071), 1,
      sym_heredoc_content,
    STATE(3305), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53440] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(3072), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53457] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(5888), 1,
      anon_sym_LPAREN,
    STATE(3073), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53474] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6154), 1,
      sym__heredoc_delimiter,
    ACTIONS(6156), 1,
      sym__command_heredoc_delimiter,
    STATE(3074), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53491] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3075), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4825), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [53506] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6158), 1,
      anon_sym_LBRACE,
    ACTIONS(6160), 1,
      anon_sym_LBRACK,
    STATE(3076), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53523] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6162), 1,
      anon_sym_LBRACE,
    ACTIONS(6164), 1,
      anon_sym_LBRACK,
    STATE(3077), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53540] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6166), 1,
      anon_sym_LBRACE,
    ACTIONS(6168), 1,
      anon_sym_LBRACK,
    STATE(3078), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53557] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    STATE(3079), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53574] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5493), 1,
      anon_sym_RPAREN,
    ACTIONS(6152), 1,
      anon_sym_COMMA,
    STATE(3080), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53591] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3081), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4833), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [53606] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(6170), 1,
      aux_sym___DATA___token1,
    STATE(3082), 1,
      sym_heredoc_content,
  [53625] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3540), 1,
      sym__quotelike_begin,
    STATE(3083), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53642] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3542), 1,
      sym__quotelike_begin,
    STATE(3084), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53659] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(3550), 1,
      sym__quotelike_begin,
    STATE(3085), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53676] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6172), 1,
      sym__apostrophe,
    ACTIONS(6174), 1,
      sym__quotelike_begin,
    STATE(3086), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53693] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3087), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4835), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [53708] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6176), 1,
      sym__apostrophe,
    ACTIONS(6178), 1,
      sym__quotelike_begin,
    STATE(3088), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53725] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(4354), 1,
      sym__quotelike_begin,
    STATE(3089), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53742] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    STATE(3090), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53759] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(6180), 1,
      anon_sym_LPAREN,
    STATE(3091), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53776] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(6182), 1,
      anon_sym_LPAREN,
    STATE(3092), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53793] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6148), 1,
      anon_sym_COMMA,
    ACTIONS(6184), 1,
      anon_sym_RPAREN,
    STATE(3093), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53810] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(6188), 1,
      anon_sym_LBRACK,
    STATE(3094), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53827] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6190), 1,
      anon_sym_LBRACE,
    ACTIONS(6192), 1,
      anon_sym_LBRACK,
    STATE(3095), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53844] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6194), 1,
      anon_sym_LBRACE,
    ACTIONS(6196), 1,
      anon_sym_LBRACK,
    STATE(3096), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53861] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3097), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4823), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [53876] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3098), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4843), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [53891] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    STATE(3099), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53908] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6198), 1,
      sym__apostrophe,
    ACTIONS(6200), 1,
      sym__quotelike_begin,
    STATE(3100), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53925] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6202), 1,
      sym__apostrophe,
    ACTIONS(6204), 1,
      sym__quotelike_begin,
    STATE(3101), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53942] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3102), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5233), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
  [53957] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3103), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4827), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [53972] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6206), 1,
      anon_sym_LBRACE,
    ACTIONS(6208), 1,
      anon_sym_LBRACK,
    STATE(3104), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [53989] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    STATE(3105), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54006] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    STATE(3106), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54023] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6210), 1,
      sym__heredoc_delimiter,
    ACTIONS(6212), 1,
      sym__command_heredoc_delimiter,
    STATE(3107), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54040] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6214), 1,
      sym__heredoc_delimiter,
    ACTIONS(6216), 1,
      sym__command_heredoc_delimiter,
    STATE(3108), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54057] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    STATE(3109), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54074] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    STATE(3110), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54091] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3111), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4831), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [54106] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(6220), 1,
      anon_sym_LBRACK,
    STATE(3112), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54123] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3113), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(6222), 2,
      sym__quotelike_begin,
      sym__quotelike_middle_skip,
  [54138] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(564), 1,
      sym__brace_end_zw,
    STATE(3114), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54155] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6224), 1,
      sym__apostrophe,
    ACTIONS(6226), 1,
      sym__quotelike_begin,
    STATE(3115), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54172] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3116), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(6228), 2,
      sym__quotelike_begin,
      sym__quotelike_middle_skip,
  [54187] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6230), 1,
      sym__apostrophe,
    ACTIONS(6232), 1,
      sym__quotelike_begin,
    STATE(3117), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54204] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(4535), 1,
      sym__quotelike_begin,
    STATE(3118), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54221] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3119), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4829), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [54236] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(4541), 1,
      sym__quotelike_begin,
    STATE(3120), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54253] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    STATE(3121), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54270] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6234), 1,
      anon_sym_LBRACE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(3122), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54287] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5474), 1,
      anon_sym_RPAREN,
    ACTIONS(6152), 1,
      anon_sym_COMMA,
    STATE(3123), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54304] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    ACTIONS(4539), 1,
      sym__quotelike_begin,
    STATE(3124), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54321] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    STATE(3125), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54338] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    STATE(3126), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54355] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3127), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4817), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [54370] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    STATE(3128), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54387] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    STATE(3129), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54404] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6152), 1,
      anon_sym_COMMA,
    ACTIONS(6238), 1,
      anon_sym_RPAREN,
    STATE(3130), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54421] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(4362), 1,
      sym__quotelike_begin,
    STATE(3131), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54438] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5717), 1,
      anon_sym_RPAREN,
    ACTIONS(6148), 1,
      anon_sym_COMMA,
    STATE(3132), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54455] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3133), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(5237), 2,
      sym__PERLY_SEMICOLON,
      anon_sym_SEMI,
  [54470] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    STATE(3134), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54487] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3135), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4815), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [54502] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    STATE(3136), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
    ACTIONS(4837), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [54517] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5460), 1,
      anon_sym_RPAREN,
    ACTIONS(6152), 1,
      anon_sym_COMMA,
    STATE(3137), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54534] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    ACTIONS(4360), 1,
      sym__quotelike_begin,
    STATE(3138), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54551] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    STATE(3139), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54568] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6152), 1,
      anon_sym_COMMA,
    ACTIONS(6240), 1,
      anon_sym_RPAREN,
    STATE(3140), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54585] = 5,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5632), 1,
      anon_sym_DOLLAR,
    STATE(3141), 1,
      sym_heredoc_content,
    STATE(3151), 1,
      sym_scalar,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54602] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6242), 1,
      sym_attribute_value,
    STATE(3142), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54616] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(311), 1,
      sym__brace_end_zw,
    STATE(3143), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54630] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6244), 1,
      anon_sym_RBRACE,
    STATE(3144), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54644] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(325), 1,
      sym__brace_end_zw,
    STATE(3145), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54658] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6246), 1,
      sym_attribute_value,
    STATE(3146), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54672] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6248), 1,
      anon_sym_RPAREN,
    STATE(3147), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54686] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6250), 1,
      anon_sym_STAR,
    STATE(3148), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54700] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6252), 1,
      anon_sym_GT,
    STATE(3149), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54714] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6254), 1,
      anon_sym_STAR,
    STATE(3150), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54728] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6256), 1,
      anon_sym_LPAREN,
    STATE(3151), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54742] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(305), 1,
      sym__brace_end_zw,
    STATE(3152), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54756] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6258), 1,
      sym__gobbled_content,
    STATE(3153), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54770] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6260), 1,
      anon_sym_RBRACE,
    STATE(3154), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54784] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3306), 1,
      ts_builtin_sym_end,
    STATE(3155), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54798] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6262), 1,
      sym__gobbled_content,
    STATE(3156), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54812] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(329), 1,
      sym__brace_end_zw,
    STATE(3157), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54826] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6148), 1,
      anon_sym_COMMA,
    STATE(3158), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54840] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6264), 1,
      anon_sym_LPAREN,
    STATE(3159), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54854] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5311), 1,
      sym__dollar_ident_zw,
    STATE(3160), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54868] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6266), 1,
      anon_sym_LPAREN,
    STATE(3161), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54882] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6268), 1,
      sym_attribute_value,
    STATE(3162), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54896] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6270), 1,
      anon_sym_RBRACE,
    STATE(3163), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54910] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6272), 1,
      anon_sym_GT,
    STATE(3164), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6274), 1,
      aux_sym___DATA___token1,
    STATE(3165), 1,
      sym_heredoc_content,
  [54940] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6276), 1,
      sym__gobbled_content,
    STATE(3166), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54954] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(317), 1,
      sym__brace_end_zw,
    STATE(3167), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54968] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6278), 1,
      anon_sym_RBRACE,
    STATE(3168), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54982] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6280), 1,
      anon_sym_RPAREN,
    STATE(3169), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [54996] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(303), 1,
      sym__brace_end_zw,
    STATE(3170), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55010] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6282), 1,
      anon_sym_STAR,
    STATE(3171), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55024] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6284), 1,
      anon_sym_STAR,
    STATE(3172), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55038] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6286), 1,
      anon_sym_RBRACE,
    STATE(3173), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55052] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6288), 1,
      anon_sym_RBRACE,
    STATE(3174), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55066] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6290), 1,
      anon_sym_RBRACE,
    STATE(3175), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6292), 1,
      aux_sym___DATA___token1,
    STATE(3176), 1,
      sym_heredoc_content,
  [55096] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6294), 1,
      sym_attribute_value,
    STATE(3177), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55110] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6296), 1,
      anon_sym_COLON,
    STATE(3178), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55124] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6298), 1,
      anon_sym_STAR,
    STATE(3179), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55138] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6300), 1,
      anon_sym_RBRACE,
    STATE(3180), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55152] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6302), 1,
      anon_sym_RPAREN,
    STATE(3181), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55166] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6304), 1,
      anon_sym_RPAREN,
    STATE(3182), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55180] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6306), 1,
      anon_sym_RBRACE,
    STATE(3183), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55194] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6308), 1,
      ts_builtin_sym_end,
    STATE(3184), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55208] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6310), 1,
      anon_sym_RBRACE,
    STATE(3185), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55222] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6312), 1,
      anon_sym_COLON,
    STATE(3186), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55236] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6314), 1,
      anon_sym_RBRACE,
    STATE(3187), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55250] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6316), 1,
      anon_sym_RPAREN,
    STATE(3188), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55264] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(1513), 1,
      ts_builtin_sym_end,
    STATE(3189), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55278] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6318), 1,
      anon_sym_RBRACE,
    STATE(3190), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55292] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(321), 1,
      sym__brace_end_zw,
    STATE(3191), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55306] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(331), 1,
      sym__brace_end_zw,
    STATE(3192), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55320] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6320), 1,
      sym__ERROR,
    STATE(3193), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55334] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6322), 1,
      sym__ERROR,
    STATE(3194), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55348] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6324), 1,
      sym__ERROR,
    STATE(3195), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55362] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6326), 1,
      anon_sym_GT_GT,
    STATE(3196), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55376] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6328), 1,
      anon_sym_RBRACE,
    STATE(3197), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55390] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5263), 1,
      sym__dollar_ident_zw,
    STATE(3198), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55404] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6330), 1,
      anon_sym_RBRACE,
    STATE(3199), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55418] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6332), 1,
      sym__ERROR,
    STATE(3200), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55432] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6334), 1,
      sym__ERROR,
    STATE(3201), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55446] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5706), 1,
      aux_sym__interpolated_transliteration_content_token1,
    STATE(3202), 1,
      sym_heredoc_content,
  [55462] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(301), 1,
      sym__brace_end_zw,
    STATE(3203), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55476] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6336), 1,
      anon_sym_RPAREN,
    STATE(3204), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55490] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6338), 1,
      anon_sym_RBRACE,
    STATE(3205), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55504] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(307), 1,
      sym__brace_end_zw,
    STATE(3206), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55518] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6340), 1,
      anon_sym_RPAREN,
    STATE(3207), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55532] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6342), 1,
      anon_sym_GT_GT,
    STATE(3208), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55546] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(217), 1,
      sym__fat_comma_zw,
    STATE(3209), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55560] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6344), 1,
      anon_sym_RPAREN,
    STATE(3210), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55574] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(365), 1,
      sym__fat_comma_zw,
    STATE(3211), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55588] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6346), 1,
      sym__gobbled_content,
    STATE(3212), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55602] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6348), 1,
      sym__gobbled_content,
    STATE(3213), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55616] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(2921), 1,
      anon_sym_GT,
    STATE(3214), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55630] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6350), 1,
      anon_sym_RPAREN,
    STATE(3215), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55644] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6352), 1,
      sym_attribute_value,
    STATE(3216), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55658] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6354), 1,
      anon_sym_RPAREN,
    STATE(3217), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55672] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5271), 1,
      sym__dollar_ident_zw,
    STATE(3218), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55686] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6356), 1,
      anon_sym_RBRACE,
    STATE(3219), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55700] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6358), 1,
      anon_sym_RBRACE,
    STATE(3220), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55714] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6360), 1,
      anon_sym_RBRACE,
    STATE(3221), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55728] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(327), 1,
      sym__brace_end_zw,
    STATE(3222), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55742] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6362), 1,
      sym__ERROR,
    STATE(3223), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55756] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    STATE(3224), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55770] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6366), 1,
      anon_sym_RBRACE,
    STATE(3225), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55784] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6368), 1,
      anon_sym_RBRACE,
    STATE(3226), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55798] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6370), 1,
      anon_sym_RBRACE,
    STATE(3227), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55812] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6372), 1,
      anon_sym_RPAREN,
    STATE(3228), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55826] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6030), 1,
      anon_sym_RBRACE,
    STATE(3229), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55840] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6374), 1,
      anon_sym_RBRACE,
    STATE(3230), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55854] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6376), 1,
      anon_sym_RBRACE,
    STATE(3231), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55868] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6378), 1,
      anon_sym_RBRACE,
    STATE(3232), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55882] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6380), 1,
      anon_sym_RPAREN,
    STATE(3233), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55896] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6382), 1,
      anon_sym_RBRACE,
    STATE(3234), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55910] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(3325), 1,
      ts_builtin_sym_end,
    STATE(3235), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55924] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(2925), 1,
      anon_sym_GT,
    STATE(3236), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55938] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6384), 1,
      sym_attribute_value,
    STATE(3237), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55952] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(323), 1,
      sym__brace_end_zw,
    STATE(3238), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55966] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6386), 1,
      anon_sym_RPAREN,
    STATE(3239), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55980] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6388), 1,
      anon_sym_RPAREN,
    STATE(3240), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [55994] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6390), 1,
      anon_sym_LPAREN,
    STATE(3241), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56008] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6392), 1,
      anon_sym_GT,
    STATE(3242), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56022] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6394), 1,
      ts_builtin_sym_end,
    STATE(3243), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56036] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6396), 1,
      anon_sym_LPAREN,
    STATE(3244), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56050] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6398), 1,
      sym__ERROR,
    STATE(3245), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56064] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(313), 1,
      sym__brace_end_zw,
    STATE(3246), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56078] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6400), 1,
      anon_sym_RBRACE,
    STATE(3247), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56092] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6402), 1,
      anon_sym_RBRACE,
    STATE(3248), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56106] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6404), 1,
      anon_sym_LPAREN,
    STATE(3249), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56120] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6406), 1,
      anon_sym_STAR,
    STATE(3250), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56134] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6408), 1,
      anon_sym_RBRACE,
    STATE(3251), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56148] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6410), 1,
      anon_sym_LPAREN,
    STATE(3252), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56162] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6412), 1,
      anon_sym_RPAREN,
    STATE(3253), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56176] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6414), 1,
      sym__ERROR,
    STATE(3254), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56190] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6416), 1,
      anon_sym_RBRACE,
    STATE(3255), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56204] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6418), 1,
      anon_sym_RBRACE,
    STATE(3256), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56218] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(309), 1,
      sym__brace_end_zw,
    STATE(3257), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56232] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6420), 1,
      anon_sym_RBRACE,
    STATE(3258), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56246] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6422), 1,
      sym__ERROR,
    STATE(3259), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56260] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6424), 1,
      anon_sym_RPAREN,
    STATE(3260), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56274] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6426), 1,
      anon_sym_RPAREN,
    STATE(3261), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56288] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6428), 1,
      anon_sym_LPAREN,
    STATE(3262), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56302] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6430), 1,
      anon_sym_RPAREN,
    STATE(3263), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56316] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6432), 1,
      anon_sym_RBRACE,
    STATE(3264), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56330] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6434), 1,
      anon_sym_RBRACE,
    STATE(3265), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56344] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6436), 1,
      anon_sym_RBRACE,
    STATE(3266), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56358] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6438), 1,
      anon_sym_RBRACE,
    STATE(3267), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56372] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6440), 1,
      anon_sym_RBRACE,
    STATE(3268), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56386] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6442), 1,
      anon_sym_GT_GT,
    STATE(3269), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56400] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6444), 1,
      anon_sym_RPAREN,
    STATE(3270), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56414] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6446), 1,
      anon_sym_RBRACE,
    STATE(3271), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56428] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6448), 1,
      anon_sym_RPAREN,
    STATE(3272), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56442] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(257), 1,
      sym__fat_comma_zw,
    STATE(3273), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56456] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6450), 1,
      anon_sym_RBRACE,
    STATE(3274), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56470] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6452), 1,
      anon_sym_RBRACE,
    STATE(3275), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56484] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6454), 1,
      anon_sym_RBRACE,
    STATE(3276), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56498] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6456), 1,
      anon_sym_RBRACE,
    STATE(3277), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56512] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(315), 1,
      sym__brace_end_zw,
    STATE(3278), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_pod,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5782), 1,
      aux_sym__interpolated_transliteration_content_token1,
    STATE(3279), 1,
      sym_heredoc_content,
  [56542] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6458), 1,
      anon_sym_RBRACE,
    STATE(3280), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56556] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6460), 1,
      anon_sym_LPAREN,
    STATE(3281), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56570] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(5247), 1,
      sym__dollar_ident_zw,
    STATE(3282), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56584] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6462), 1,
      anon_sym_RBRACE,
    STATE(3283), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56598] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6152), 1,
      anon_sym_COMMA,
    STATE(3284), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56612] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6464), 1,
      anon_sym_LPAREN,
    STATE(3285), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56626] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6466), 1,
      anon_sym_RBRACE,
    STATE(3286), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56640] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6468), 1,
      anon_sym_LPAREN,
    STATE(3287), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56654] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6470), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56668] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6472), 1,
      anon_sym_LPAREN,
    STATE(3289), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56682] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6474), 1,
      anon_sym_RBRACE,
    STATE(3290), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56696] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6476), 1,
      anon_sym_LPAREN,
    STATE(3291), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56710] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6478), 1,
      anon_sym_RBRACE,
    STATE(3292), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56724] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6480), 1,
      anon_sym_RBRACE,
    STATE(3293), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56738] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6482), 1,
      anon_sym_RBRACE,
    STATE(3294), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56752] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6484), 1,
      anon_sym_RBRACE,
    STATE(3295), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56766] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6486), 1,
      sym__gobbled_content,
    STATE(3296), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56780] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6488), 1,
      anon_sym_RPAREN,
    STATE(3297), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56794] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(2911), 1,
      sym__brace_end_zw,
    STATE(3298), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56808] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(2903), 1,
      sym__brace_end_zw,
    STATE(3299), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56822] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(2887), 1,
      anon_sym_GT,
    STATE(3300), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56836] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6490), 1,
      anon_sym_RBRACE,
    STATE(3301), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56850] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6492), 1,
      anon_sym_RBRACE,
    STATE(3302), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56864] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(2895), 1,
      anon_sym_GT,
    STATE(3303), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56878] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6494), 1,
      anon_sym_LPAREN,
    STATE(3304), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56892] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6496), 1,
      anon_sym_LPAREN,
    STATE(3305), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56906] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6498), 1,
      anon_sym_LPAREN,
    STATE(3306), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56920] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6500), 1,
      anon_sym_LPAREN,
    STATE(3307), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56934] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6502), 1,
      anon_sym_LPAREN,
    STATE(3308), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56948] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6504), 1,
      anon_sym_LPAREN,
    STATE(3309), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56962] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6506), 1,
      sym_attribute_value,
    STATE(3310), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56976] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6508), 1,
      anon_sym_RBRACE,
    STATE(3311), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [56990] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6510), 1,
      anon_sym_RPAREN,
    STATE(3312), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [57004] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6512), 1,
      anon_sym_RBRACE,
    STATE(3313), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [57018] = 4,
    ACTIONS(7), 1,
      sym__heredoc_start,
    ACTIONS(6514), 1,
      anon_sym_RBRACE,
    STATE(3314), 1,
      sym_heredoc_content,
    ACTIONS(5), 2,
      sym_pod,
      sym_comment,
  [57032] = 1,
    ACTIONS(6516), 1,
      ts_builtin_sym_end,
  [57036] = 1,
    ACTIONS(6518), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1722)] = 0,
  [SMALL_STATE(1723)] = 75,
  [SMALL_STATE(1724)] = 170,
  [SMALL_STATE(1725)] = 289,
  [SMALL_STATE(1726)] = 408,
  [SMALL_STATE(1727)] = 485,
  [SMALL_STATE(1728)] = 562,
  [SMALL_STATE(1729)] = 675,
  [SMALL_STATE(1730)] = 778,
  [SMALL_STATE(1731)] = 877,
  [SMALL_STATE(1732)] = 972,
  [SMALL_STATE(1733)] = 1053,
  [SMALL_STATE(1734)] = 1138,
  [SMALL_STATE(1735)] = 1237,
  [SMALL_STATE(1736)] = 1338,
  [SMALL_STATE(1737)] = 1413,
  [SMALL_STATE(1738)] = 1518,
  [SMALL_STATE(1739)] = 1599,
  [SMALL_STATE(1740)] = 1714,
  [SMALL_STATE(1741)] = 1801,
  [SMALL_STATE(1742)] = 1890,
  [SMALL_STATE(1743)] = 1973,
  [SMALL_STATE(1744)] = 2084,
  [SMALL_STATE(1745)] = 2199,
  [SMALL_STATE(1746)] = 2278,
  [SMALL_STATE(1747)] = 2367,
  [SMALL_STATE(1748)] = 2444,
  [SMALL_STATE(1749)] = 2563,
  [SMALL_STATE(1750)] = 2682,
  [SMALL_STATE(1751)] = 2761,
  [SMALL_STATE(1752)] = 2838,
  [SMALL_STATE(1753)] = 2957,
  [SMALL_STATE(1754)] = 3036,
  [SMALL_STATE(1755)] = 3115,
  [SMALL_STATE(1756)] = 3204,
  [SMALL_STATE(1757)] = 3279,
  [SMALL_STATE(1758)] = 3354,
  [SMALL_STATE(1759)] = 3429,
  [SMALL_STATE(1760)] = 3504,
  [SMALL_STATE(1761)] = 3579,
  [SMALL_STATE(1762)] = 3654,
  [SMALL_STATE(1763)] = 3729,
  [SMALL_STATE(1764)] = 3804,
  [SMALL_STATE(1765)] = 3879,
  [SMALL_STATE(1766)] = 3954,
  [SMALL_STATE(1767)] = 4029,
  [SMALL_STATE(1768)] = 4104,
  [SMALL_STATE(1769)] = 4179,
  [SMALL_STATE(1770)] = 4254,
  [SMALL_STATE(1771)] = 4329,
  [SMALL_STATE(1772)] = 4404,
  [SMALL_STATE(1773)] = 4479,
  [SMALL_STATE(1774)] = 4554,
  [SMALL_STATE(1775)] = 4629,
  [SMALL_STATE(1776)] = 4704,
  [SMALL_STATE(1777)] = 4779,
  [SMALL_STATE(1778)] = 4854,
  [SMALL_STATE(1779)] = 4929,
  [SMALL_STATE(1780)] = 5004,
  [SMALL_STATE(1781)] = 5079,
  [SMALL_STATE(1782)] = 5154,
  [SMALL_STATE(1783)] = 5229,
  [SMALL_STATE(1784)] = 5304,
  [SMALL_STATE(1785)] = 5379,
  [SMALL_STATE(1786)] = 5454,
  [SMALL_STATE(1787)] = 5529,
  [SMALL_STATE(1788)] = 5604,
  [SMALL_STATE(1789)] = 5679,
  [SMALL_STATE(1790)] = 5754,
  [SMALL_STATE(1791)] = 5829,
  [SMALL_STATE(1792)] = 5904,
  [SMALL_STATE(1793)] = 5979,
  [SMALL_STATE(1794)] = 6054,
  [SMALL_STATE(1795)] = 6129,
  [SMALL_STATE(1796)] = 6204,
  [SMALL_STATE(1797)] = 6279,
  [SMALL_STATE(1798)] = 6354,
  [SMALL_STATE(1799)] = 6429,
  [SMALL_STATE(1800)] = 6504,
  [SMALL_STATE(1801)] = 6579,
  [SMALL_STATE(1802)] = 6654,
  [SMALL_STATE(1803)] = 6729,
  [SMALL_STATE(1804)] = 6804,
  [SMALL_STATE(1805)] = 6879,
  [SMALL_STATE(1806)] = 6954,
  [SMALL_STATE(1807)] = 7029,
  [SMALL_STATE(1808)] = 7104,
  [SMALL_STATE(1809)] = 7179,
  [SMALL_STATE(1810)] = 7254,
  [SMALL_STATE(1811)] = 7329,
  [SMALL_STATE(1812)] = 7404,
  [SMALL_STATE(1813)] = 7479,
  [SMALL_STATE(1814)] = 7554,
  [SMALL_STATE(1815)] = 7629,
  [SMALL_STATE(1816)] = 7704,
  [SMALL_STATE(1817)] = 7779,
  [SMALL_STATE(1818)] = 7854,
  [SMALL_STATE(1819)] = 7929,
  [SMALL_STATE(1820)] = 8004,
  [SMALL_STATE(1821)] = 8079,
  [SMALL_STATE(1822)] = 8156,
  [SMALL_STATE(1823)] = 8231,
  [SMALL_STATE(1824)] = 8306,
  [SMALL_STATE(1825)] = 8381,
  [SMALL_STATE(1826)] = 8470,
  [SMALL_STATE(1827)] = 8545,
  [SMALL_STATE(1828)] = 8620,
  [SMALL_STATE(1829)] = 8695,
  [SMALL_STATE(1830)] = 8770,
  [SMALL_STATE(1831)] = 8845,
  [SMALL_STATE(1832)] = 8960,
  [SMALL_STATE(1833)] = 9035,
  [SMALL_STATE(1834)] = 9124,
  [SMALL_STATE(1835)] = 9213,
  [SMALL_STATE(1836)] = 9302,
  [SMALL_STATE(1837)] = 9377,
  [SMALL_STATE(1838)] = 9452,
  [SMALL_STATE(1839)] = 9567,
  [SMALL_STATE(1840)] = 9646,
  [SMALL_STATE(1841)] = 9721,
  [SMALL_STATE(1842)] = 9796,
  [SMALL_STATE(1843)] = 9877,
  [SMALL_STATE(1844)] = 9952,
  [SMALL_STATE(1845)] = 10027,
  [SMALL_STATE(1846)] = 10102,
  [SMALL_STATE(1847)] = 10177,
  [SMALL_STATE(1848)] = 10252,
  [SMALL_STATE(1849)] = 10327,
  [SMALL_STATE(1850)] = 10402,
  [SMALL_STATE(1851)] = 10477,
  [SMALL_STATE(1852)] = 10552,
  [SMALL_STATE(1853)] = 10627,
  [SMALL_STATE(1854)] = 10702,
  [SMALL_STATE(1855)] = 10777,
  [SMALL_STATE(1856)] = 10852,
  [SMALL_STATE(1857)] = 10927,
  [SMALL_STATE(1858)] = 11029,
  [SMALL_STATE(1859)] = 11109,
  [SMALL_STATE(1860)] = 11195,
  [SMALL_STATE(1861)] = 11283,
  [SMALL_STATE(1862)] = 11365,
  [SMALL_STATE(1863)] = 11475,
  [SMALL_STATE(1864)] = 11563,
  [SMALL_STATE(1865)] = 11651,
  [SMALL_STATE(1866)] = 11733,
  [SMALL_STATE(1867)] = 11845,
  [SMALL_STATE(1868)] = 11955,
  [SMALL_STATE(1869)] = 12029,
  [SMALL_STATE(1870)] = 12103,
  [SMALL_STATE(1871)] = 12179,
  [SMALL_STATE(1872)] = 12259,
  [SMALL_STATE(1873)] = 12347,
  [SMALL_STATE(1874)] = 12427,
  [SMALL_STATE(1875)] = 12531,
  [SMALL_STATE(1876)] = 12625,
  [SMALL_STATE(1877)] = 12725,
  [SMALL_STATE(1878)] = 12839,
  [SMALL_STATE(1879)] = 12925,
  [SMALL_STATE(1880)] = 13023,
  [SMALL_STATE(1881)] = 13099,
  [SMALL_STATE(1882)] = 13183,
  [SMALL_STATE(1883)] = 13271,
  [SMALL_STATE(1884)] = 13385,
  [SMALL_STATE(1885)] = 13465,
  [SMALL_STATE(1886)] = 13559,
  [SMALL_STATE(1887)] = 13657,
  [SMALL_STATE(1888)] = 13745,
  [SMALL_STATE(1889)] = 13859,
  [SMALL_STATE(1890)] = 13947,
  [SMALL_STATE(1891)] = 14041,
  [SMALL_STATE(1892)] = 14129,
  [SMALL_STATE(1893)] = 14217,
  [SMALL_STATE(1894)] = 14331,
  [SMALL_STATE(1895)] = 14429,
  [SMALL_STATE(1896)] = 14509,
  [SMALL_STATE(1897)] = 14603,
  [SMALL_STATE(1898)] = 14715,
  [SMALL_STATE(1899)] = 14819,
  [SMALL_STATE(1900)] = 14933,
  [SMALL_STATE(1901)] = 15031,
  [SMALL_STATE(1902)] = 15145,
  [SMALL_STATE(1903)] = 15245,
  [SMALL_STATE(1904)] = 15333,
  [SMALL_STATE(1905)] = 15421,
  [SMALL_STATE(1906)] = 15535,
  [SMALL_STATE(1907)] = 15623,
  [SMALL_STATE(1908)] = 15699,
  [SMALL_STATE(1909)] = 15813,
  [SMALL_STATE(1910)] = 15893,
  [SMALL_STATE(1911)] = 15981,
  [SMALL_STATE(1912)] = 16083,
  [SMALL_STATE(1913)] = 16159,
  [SMALL_STATE(1914)] = 16247,
  [SMALL_STATE(1915)] = 16331,
  [SMALL_STATE(1916)] = 16444,
  [SMALL_STATE(1917)] = 16531,
  [SMALL_STATE(1918)] = 16644,
  [SMALL_STATE(1919)] = 16755,
  [SMALL_STATE(1920)] = 16868,
  [SMALL_STATE(1921)] = 16961,
  [SMALL_STATE(1922)] = 17058,
  [SMALL_STATE(1923)] = 17171,
  [SMALL_STATE(1924)] = 17284,
  [SMALL_STATE(1925)] = 17377,
  [SMALL_STATE(1926)] = 17456,
  [SMALL_STATE(1927)] = 17539,
  [SMALL_STATE(1928)] = 17652,
  [SMALL_STATE(1929)] = 17749,
  [SMALL_STATE(1930)] = 17862,
  [SMALL_STATE(1931)] = 17975,
  [SMALL_STATE(1932)] = 18088,
  [SMALL_STATE(1933)] = 18187,
  [SMALL_STATE(1934)] = 18300,
  [SMALL_STATE(1935)] = 18413,
  [SMALL_STATE(1936)] = 18526,
  [SMALL_STATE(1937)] = 18613,
  [SMALL_STATE(1938)] = 18700,
  [SMALL_STATE(1939)] = 18787,
  [SMALL_STATE(1940)] = 18888,
  [SMALL_STATE(1941)] = 18997,
  [SMALL_STATE(1942)] = 19078,
  [SMALL_STATE(1943)] = 19181,
  [SMALL_STATE(1944)] = 19268,
  [SMALL_STATE(1945)] = 19355,
  [SMALL_STATE(1946)] = 19434,
  [SMALL_STATE(1947)] = 19547,
  [SMALL_STATE(1948)] = 19660,
  [SMALL_STATE(1949)] = 19745,
  [SMALL_STATE(1950)] = 19858,
  [SMALL_STATE(1951)] = 19937,
  [SMALL_STATE(1952)] = 20024,
  [SMALL_STATE(1953)] = 20116,
  [SMALL_STATE(1954)] = 20224,
  [SMALL_STATE(1955)] = 20336,
  [SMALL_STATE(1956)] = 20448,
  [SMALL_STATE(1957)] = 20548,
  [SMALL_STATE(1958)] = 20644,
  [SMALL_STATE(1959)] = 20730,
  [SMALL_STATE(1960)] = 20814,
  [SMALL_STATE(1961)] = 20926,
  [SMALL_STATE(1962)] = 21038,
  [SMALL_STATE(1963)] = 21124,
  [SMALL_STATE(1964)] = 21210,
  [SMALL_STATE(1965)] = 21322,
  [SMALL_STATE(1966)] = 21400,
  [SMALL_STATE(1967)] = 21512,
  [SMALL_STATE(1968)] = 21592,
  [SMALL_STATE(1969)] = 21704,
  [SMALL_STATE(1970)] = 21790,
  [SMALL_STATE(1971)] = 21876,
  [SMALL_STATE(1972)] = 21954,
  [SMALL_STATE(1973)] = 22064,
  [SMALL_STATE(1974)] = 22176,
  [SMALL_STATE(1975)] = 22268,
  [SMALL_STATE(1976)] = 22346,
  [SMALL_STATE(1977)] = 22432,
  [SMALL_STATE(1978)] = 22534,
  [SMALL_STATE(1979)] = 22616,
  [SMALL_STATE(1980)] = 22728,
  [SMALL_STATE(1981)] = 22814,
  [SMALL_STATE(1982)] = 22912,
  [SMALL_STATE(1983)] = 23024,
  [SMALL_STATE(1984)] = 23136,
  [SMALL_STATE(1985)] = 23232,
  [SMALL_STATE(1986)] = 23295,
  [SMALL_STATE(1987)] = 23358,
  [SMALL_STATE(1988)] = 23421,
  [SMALL_STATE(1989)] = 23484,
  [SMALL_STATE(1990)] = 23547,
  [SMALL_STATE(1991)] = 23610,
  [SMALL_STATE(1992)] = 23670,
  [SMALL_STATE(1993)] = 23730,
  [SMALL_STATE(1994)] = 23790,
  [SMALL_STATE(1995)] = 23850,
  [SMALL_STATE(1996)] = 23910,
  [SMALL_STATE(1997)] = 23970,
  [SMALL_STATE(1998)] = 24030,
  [SMALL_STATE(1999)] = 24090,
  [SMALL_STATE(2000)] = 24150,
  [SMALL_STATE(2001)] = 24210,
  [SMALL_STATE(2002)] = 24268,
  [SMALL_STATE(2003)] = 24328,
  [SMALL_STATE(2004)] = 24388,
  [SMALL_STATE(2005)] = 24448,
  [SMALL_STATE(2006)] = 24508,
  [SMALL_STATE(2007)] = 24568,
  [SMALL_STATE(2008)] = 24628,
  [SMALL_STATE(2009)] = 24688,
  [SMALL_STATE(2010)] = 24746,
  [SMALL_STATE(2011)] = 24806,
  [SMALL_STATE(2012)] = 24865,
  [SMALL_STATE(2013)] = 24924,
  [SMALL_STATE(2014)] = 24983,
  [SMALL_STATE(2015)] = 25042,
  [SMALL_STATE(2016)] = 25101,
  [SMALL_STATE(2017)] = 25160,
  [SMALL_STATE(2018)] = 25219,
  [SMALL_STATE(2019)] = 25278,
  [SMALL_STATE(2020)] = 25337,
  [SMALL_STATE(2021)] = 25396,
  [SMALL_STATE(2022)] = 25455,
  [SMALL_STATE(2023)] = 25514,
  [SMALL_STATE(2024)] = 25573,
  [SMALL_STATE(2025)] = 25632,
  [SMALL_STATE(2026)] = 25689,
  [SMALL_STATE(2027)] = 25748,
  [SMALL_STATE(2028)] = 25807,
  [SMALL_STATE(2029)] = 25866,
  [SMALL_STATE(2030)] = 25925,
  [SMALL_STATE(2031)] = 25984,
  [SMALL_STATE(2032)] = 26043,
  [SMALL_STATE(2033)] = 26102,
  [SMALL_STATE(2034)] = 26161,
  [SMALL_STATE(2035)] = 26220,
  [SMALL_STATE(2036)] = 26279,
  [SMALL_STATE(2037)] = 26338,
  [SMALL_STATE(2038)] = 26397,
  [SMALL_STATE(2039)] = 26456,
  [SMALL_STATE(2040)] = 26515,
  [SMALL_STATE(2041)] = 26574,
  [SMALL_STATE(2042)] = 26633,
  [SMALL_STATE(2043)] = 26692,
  [SMALL_STATE(2044)] = 26751,
  [SMALL_STATE(2045)] = 26810,
  [SMALL_STATE(2046)] = 26869,
  [SMALL_STATE(2047)] = 26928,
  [SMALL_STATE(2048)] = 26987,
  [SMALL_STATE(2049)] = 27045,
  [SMALL_STATE(2050)] = 27101,
  [SMALL_STATE(2051)] = 27159,
  [SMALL_STATE(2052)] = 27191,
  [SMALL_STATE(2053)] = 27223,
  [SMALL_STATE(2054)] = 27257,
  [SMALL_STATE(2055)] = 27293,
  [SMALL_STATE(2056)] = 27327,
  [SMALL_STATE(2057)] = 27361,
  [SMALL_STATE(2058)] = 27395,
  [SMALL_STATE(2059)] = 27427,
  [SMALL_STATE(2060)] = 27459,
  [SMALL_STATE(2061)] = 27491,
  [SMALL_STATE(2062)] = 27523,
  [SMALL_STATE(2063)] = 27557,
  [SMALL_STATE(2064)] = 27589,
  [SMALL_STATE(2065)] = 27621,
  [SMALL_STATE(2066)] = 27652,
  [SMALL_STATE(2067)] = 27683,
  [SMALL_STATE(2068)] = 27714,
  [SMALL_STATE(2069)] = 27745,
  [SMALL_STATE(2070)] = 27776,
  [SMALL_STATE(2071)] = 27829,
  [SMALL_STATE(2072)] = 27882,
  [SMALL_STATE(2073)] = 27915,
  [SMALL_STATE(2074)] = 27946,
  [SMALL_STATE(2075)] = 27977,
  [SMALL_STATE(2076)] = 28008,
  [SMALL_STATE(2077)] = 28051,
  [SMALL_STATE(2078)] = 28082,
  [SMALL_STATE(2079)] = 28113,
  [SMALL_STATE(2080)] = 28144,
  [SMALL_STATE(2081)] = 28177,
  [SMALL_STATE(2082)] = 28208,
  [SMALL_STATE(2083)] = 28239,
  [SMALL_STATE(2084)] = 28270,
  [SMALL_STATE(2085)] = 28301,
  [SMALL_STATE(2086)] = 28332,
  [SMALL_STATE(2087)] = 28363,
  [SMALL_STATE(2088)] = 28394,
  [SMALL_STATE(2089)] = 28425,
  [SMALL_STATE(2090)] = 28456,
  [SMALL_STATE(2091)] = 28499,
  [SMALL_STATE(2092)] = 28530,
  [SMALL_STATE(2093)] = 28561,
  [SMALL_STATE(2094)] = 28592,
  [SMALL_STATE(2095)] = 28645,
  [SMALL_STATE(2096)] = 28698,
  [SMALL_STATE(2097)] = 28729,
  [SMALL_STATE(2098)] = 28759,
  [SMALL_STATE(2099)] = 28789,
  [SMALL_STATE(2100)] = 28831,
  [SMALL_STATE(2101)] = 28861,
  [SMALL_STATE(2102)] = 28891,
  [SMALL_STATE(2103)] = 28921,
  [SMALL_STATE(2104)] = 28951,
  [SMALL_STATE(2105)] = 28981,
  [SMALL_STATE(2106)] = 29011,
  [SMALL_STATE(2107)] = 29041,
  [SMALL_STATE(2108)] = 29071,
  [SMALL_STATE(2109)] = 29103,
  [SMALL_STATE(2110)] = 29135,
  [SMALL_STATE(2111)] = 29165,
  [SMALL_STATE(2112)] = 29195,
  [SMALL_STATE(2113)] = 29225,
  [SMALL_STATE(2114)] = 29255,
  [SMALL_STATE(2115)] = 29296,
  [SMALL_STATE(2116)] = 29325,
  [SMALL_STATE(2117)] = 29366,
  [SMALL_STATE(2118)] = 29395,
  [SMALL_STATE(2119)] = 29424,
  [SMALL_STATE(2120)] = 29465,
  [SMALL_STATE(2121)] = 29504,
  [SMALL_STATE(2122)] = 29533,
  [SMALL_STATE(2123)] = 29562,
  [SMALL_STATE(2124)] = 29591,
  [SMALL_STATE(2125)] = 29620,
  [SMALL_STATE(2126)] = 29661,
  [SMALL_STATE(2127)] = 29690,
  [SMALL_STATE(2128)] = 29719,
  [SMALL_STATE(2129)] = 29748,
  [SMALL_STATE(2130)] = 29777,
  [SMALL_STATE(2131)] = 29806,
  [SMALL_STATE(2132)] = 29835,
  [SMALL_STATE(2133)] = 29866,
  [SMALL_STATE(2134)] = 29895,
  [SMALL_STATE(2135)] = 29941,
  [SMALL_STATE(2136)] = 29987,
  [SMALL_STATE(2137)] = 30035,
  [SMALL_STATE(2138)] = 30081,
  [SMALL_STATE(2139)] = 30111,
  [SMALL_STATE(2140)] = 30157,
  [SMALL_STATE(2141)] = 30203,
  [SMALL_STATE(2142)] = 30249,
  [SMALL_STATE(2143)] = 30295,
  [SMALL_STATE(2144)] = 30343,
  [SMALL_STATE(2145)] = 30389,
  [SMALL_STATE(2146)] = 30435,
  [SMALL_STATE(2147)] = 30465,
  [SMALL_STATE(2148)] = 30495,
  [SMALL_STATE(2149)] = 30541,
  [SMALL_STATE(2150)] = 30587,
  [SMALL_STATE(2151)] = 30633,
  [SMALL_STATE(2152)] = 30679,
  [SMALL_STATE(2153)] = 30725,
  [SMALL_STATE(2154)] = 30771,
  [SMALL_STATE(2155)] = 30801,
  [SMALL_STATE(2156)] = 30847,
  [SMALL_STATE(2157)] = 30886,
  [SMALL_STATE(2158)] = 30929,
  [SMALL_STATE(2159)] = 30972,
  [SMALL_STATE(2160)] = 31011,
  [SMALL_STATE(2161)] = 31056,
  [SMALL_STATE(2162)] = 31099,
  [SMALL_STATE(2163)] = 31142,
  [SMALL_STATE(2164)] = 31169,
  [SMALL_STATE(2165)] = 31212,
  [SMALL_STATE(2166)] = 31239,
  [SMALL_STATE(2167)] = 31278,
  [SMALL_STATE(2168)] = 31321,
  [SMALL_STATE(2169)] = 31350,
  [SMALL_STATE(2170)] = 31393,
  [SMALL_STATE(2171)] = 31436,
  [SMALL_STATE(2172)] = 31475,
  [SMALL_STATE(2173)] = 31518,
  [SMALL_STATE(2174)] = 31545,
  [SMALL_STATE(2175)] = 31572,
  [SMALL_STATE(2176)] = 31599,
  [SMALL_STATE(2177)] = 31642,
  [SMALL_STATE(2178)] = 31681,
  [SMALL_STATE(2179)] = 31708,
  [SMALL_STATE(2180)] = 31751,
  [SMALL_STATE(2181)] = 31778,
  [SMALL_STATE(2182)] = 31821,
  [SMALL_STATE(2183)] = 31864,
  [SMALL_STATE(2184)] = 31903,
  [SMALL_STATE(2185)] = 31946,
  [SMALL_STATE(2186)] = 31991,
  [SMALL_STATE(2187)] = 32018,
  [SMALL_STATE(2188)] = 32061,
  [SMALL_STATE(2189)] = 32088,
  [SMALL_STATE(2190)] = 32115,
  [SMALL_STATE(2191)] = 32144,
  [SMALL_STATE(2192)] = 32171,
  [SMALL_STATE(2193)] = 32198,
  [SMALL_STATE(2194)] = 32241,
  [SMALL_STATE(2195)] = 32284,
  [SMALL_STATE(2196)] = 32315,
  [SMALL_STATE(2197)] = 32346,
  [SMALL_STATE(2198)] = 32391,
  [SMALL_STATE(2199)] = 32434,
  [SMALL_STATE(2200)] = 32461,
  [SMALL_STATE(2201)] = 32504,
  [SMALL_STATE(2202)] = 32549,
  [SMALL_STATE(2203)] = 32594,
  [SMALL_STATE(2204)] = 32621,
  [SMALL_STATE(2205)] = 32648,
  [SMALL_STATE(2206)] = 32679,
  [SMALL_STATE(2207)] = 32710,
  [SMALL_STATE(2208)] = 32737,
  [SMALL_STATE(2209)] = 32764,
  [SMALL_STATE(2210)] = 32791,
  [SMALL_STATE(2211)] = 32827,
  [SMALL_STATE(2212)] = 32863,
  [SMALL_STATE(2213)] = 32899,
  [SMALL_STATE(2214)] = 32935,
  [SMALL_STATE(2215)] = 32963,
  [SMALL_STATE(2216)] = 32989,
  [SMALL_STATE(2217)] = 33027,
  [SMALL_STATE(2218)] = 33065,
  [SMALL_STATE(2219)] = 33091,
  [SMALL_STATE(2220)] = 33131,
  [SMALL_STATE(2221)] = 33169,
  [SMALL_STATE(2222)] = 33207,
  [SMALL_STATE(2223)] = 33247,
  [SMALL_STATE(2224)] = 33285,
  [SMALL_STATE(2225)] = 33311,
  [SMALL_STATE(2226)] = 33337,
  [SMALL_STATE(2227)] = 33365,
  [SMALL_STATE(2228)] = 33393,
  [SMALL_STATE(2229)] = 33419,
  [SMALL_STATE(2230)] = 33455,
  [SMALL_STATE(2231)] = 33481,
  [SMALL_STATE(2232)] = 33519,
  [SMALL_STATE(2233)] = 33557,
  [SMALL_STATE(2234)] = 33593,
  [SMALL_STATE(2235)] = 33629,
  [SMALL_STATE(2236)] = 33667,
  [SMALL_STATE(2237)] = 33703,
  [SMALL_STATE(2238)] = 33739,
  [SMALL_STATE(2239)] = 33777,
  [SMALL_STATE(2240)] = 33811,
  [SMALL_STATE(2241)] = 33849,
  [SMALL_STATE(2242)] = 33879,
  [SMALL_STATE(2243)] = 33905,
  [SMALL_STATE(2244)] = 33941,
  [SMALL_STATE(2245)] = 33977,
  [SMALL_STATE(2246)] = 34003,
  [SMALL_STATE(2247)] = 34029,
  [SMALL_STATE(2248)] = 34065,
  [SMALL_STATE(2249)] = 34091,
  [SMALL_STATE(2250)] = 34125,
  [SMALL_STATE(2251)] = 34155,
  [SMALL_STATE(2252)] = 34191,
  [SMALL_STATE(2253)] = 34231,
  [SMALL_STATE(2254)] = 34270,
  [SMALL_STATE(2255)] = 34309,
  [SMALL_STATE(2256)] = 34334,
  [SMALL_STATE(2257)] = 34357,
  [SMALL_STATE(2258)] = 34380,
  [SMALL_STATE(2259)] = 34403,
  [SMALL_STATE(2260)] = 34426,
  [SMALL_STATE(2261)] = 34465,
  [SMALL_STATE(2262)] = 34504,
  [SMALL_STATE(2263)] = 34541,
  [SMALL_STATE(2264)] = 34564,
  [SMALL_STATE(2265)] = 34603,
  [SMALL_STATE(2266)] = 34642,
  [SMALL_STATE(2267)] = 34679,
  [SMALL_STATE(2268)] = 34702,
  [SMALL_STATE(2269)] = 34727,
  [SMALL_STATE(2270)] = 34750,
  [SMALL_STATE(2271)] = 34773,
  [SMALL_STATE(2272)] = 34812,
  [SMALL_STATE(2273)] = 34851,
  [SMALL_STATE(2274)] = 34888,
  [SMALL_STATE(2275)] = 34913,
  [SMALL_STATE(2276)] = 34938,
  [SMALL_STATE(2277)] = 34975,
  [SMALL_STATE(2278)] = 35000,
  [SMALL_STATE(2279)] = 35025,
  [SMALL_STATE(2280)] = 35050,
  [SMALL_STATE(2281)] = 35073,
  [SMALL_STATE(2282)] = 35096,
  [SMALL_STATE(2283)] = 35119,
  [SMALL_STATE(2284)] = 35156,
  [SMALL_STATE(2285)] = 35195,
  [SMALL_STATE(2286)] = 35234,
  [SMALL_STATE(2287)] = 35271,
  [SMALL_STATE(2288)] = 35310,
  [SMALL_STATE(2289)] = 35333,
  [SMALL_STATE(2290)] = 35356,
  [SMALL_STATE(2291)] = 35395,
  [SMALL_STATE(2292)] = 35434,
  [SMALL_STATE(2293)] = 35471,
  [SMALL_STATE(2294)] = 35508,
  [SMALL_STATE(2295)] = 35547,
  [SMALL_STATE(2296)] = 35570,
  [SMALL_STATE(2297)] = 35609,
  [SMALL_STATE(2298)] = 35648,
  [SMALL_STATE(2299)] = 35685,
  [SMALL_STATE(2300)] = 35708,
  [SMALL_STATE(2301)] = 35743,
  [SMALL_STATE(2302)] = 35766,
  [SMALL_STATE(2303)] = 35805,
  [SMALL_STATE(2304)] = 35828,
  [SMALL_STATE(2305)] = 35851,
  [SMALL_STATE(2306)] = 35888,
  [SMALL_STATE(2307)] = 35911,
  [SMALL_STATE(2308)] = 35950,
  [SMALL_STATE(2309)] = 35989,
  [SMALL_STATE(2310)] = 36028,
  [SMALL_STATE(2311)] = 36067,
  [SMALL_STATE(2312)] = 36104,
  [SMALL_STATE(2313)] = 36143,
  [SMALL_STATE(2314)] = 36182,
  [SMALL_STATE(2315)] = 36221,
  [SMALL_STATE(2316)] = 36256,
  [SMALL_STATE(2317)] = 36293,
  [SMALL_STATE(2318)] = 36332,
  [SMALL_STATE(2319)] = 36355,
  [SMALL_STATE(2320)] = 36394,
  [SMALL_STATE(2321)] = 36433,
  [SMALL_STATE(2322)] = 36470,
  [SMALL_STATE(2323)] = 36493,
  [SMALL_STATE(2324)] = 36532,
  [SMALL_STATE(2325)] = 36555,
  [SMALL_STATE(2326)] = 36592,
  [SMALL_STATE(2327)] = 36621,
  [SMALL_STATE(2328)] = 36650,
  [SMALL_STATE(2329)] = 36687,
  [SMALL_STATE(2330)] = 36726,
  [SMALL_STATE(2331)] = 36751,
  [SMALL_STATE(2332)] = 36790,
  [SMALL_STATE(2333)] = 36815,
  [SMALL_STATE(2334)] = 36852,
  [SMALL_STATE(2335)] = 36875,
  [SMALL_STATE(2336)] = 36898,
  [SMALL_STATE(2337)] = 36920,
  [SMALL_STATE(2338)] = 36954,
  [SMALL_STATE(2339)] = 36988,
  [SMALL_STATE(2340)] = 37024,
  [SMALL_STATE(2341)] = 37060,
  [SMALL_STATE(2342)] = 37082,
  [SMALL_STATE(2343)] = 37104,
  [SMALL_STATE(2344)] = 37140,
  [SMALL_STATE(2345)] = 37176,
  [SMALL_STATE(2346)] = 37200,
  [SMALL_STATE(2347)] = 37236,
  [SMALL_STATE(2348)] = 37272,
  [SMALL_STATE(2349)] = 37308,
  [SMALL_STATE(2350)] = 37330,
  [SMALL_STATE(2351)] = 37362,
  [SMALL_STATE(2352)] = 37384,
  [SMALL_STATE(2353)] = 37406,
  [SMALL_STATE(2354)] = 37438,
  [SMALL_STATE(2355)] = 37474,
  [SMALL_STATE(2356)] = 37506,
  [SMALL_STATE(2357)] = 37532,
  [SMALL_STATE(2358)] = 37568,
  [SMALL_STATE(2359)] = 37590,
  [SMALL_STATE(2360)] = 37612,
  [SMALL_STATE(2361)] = 37644,
  [SMALL_STATE(2362)] = 37666,
  [SMALL_STATE(2363)] = 37688,
  [SMALL_STATE(2364)] = 37722,
  [SMALL_STATE(2365)] = 37756,
  [SMALL_STATE(2366)] = 37778,
  [SMALL_STATE(2367)] = 37800,
  [SMALL_STATE(2368)] = 37822,
  [SMALL_STATE(2369)] = 37844,
  [SMALL_STATE(2370)] = 37878,
  [SMALL_STATE(2371)] = 37900,
  [SMALL_STATE(2372)] = 37936,
  [SMALL_STATE(2373)] = 37972,
  [SMALL_STATE(2374)] = 37994,
  [SMALL_STATE(2375)] = 38024,
  [SMALL_STATE(2376)] = 38046,
  [SMALL_STATE(2377)] = 38082,
  [SMALL_STATE(2378)] = 38104,
  [SMALL_STATE(2379)] = 38140,
  [SMALL_STATE(2380)] = 38176,
  [SMALL_STATE(2381)] = 38210,
  [SMALL_STATE(2382)] = 38243,
  [SMALL_STATE(2383)] = 38264,
  [SMALL_STATE(2384)] = 38289,
  [SMALL_STATE(2385)] = 38320,
  [SMALL_STATE(2386)] = 38341,
  [SMALL_STATE(2387)] = 38374,
  [SMALL_STATE(2388)] = 38395,
  [SMALL_STATE(2389)] = 38420,
  [SMALL_STATE(2390)] = 38453,
  [SMALL_STATE(2391)] = 38486,
  [SMALL_STATE(2392)] = 38517,
  [SMALL_STATE(2393)] = 38548,
  [SMALL_STATE(2394)] = 38571,
  [SMALL_STATE(2395)] = 38602,
  [SMALL_STATE(2396)] = 38631,
  [SMALL_STATE(2397)] = 38664,
  [SMALL_STATE(2398)] = 38689,
  [SMALL_STATE(2399)] = 38720,
  [SMALL_STATE(2400)] = 38753,
  [SMALL_STATE(2401)] = 38786,
  [SMALL_STATE(2402)] = 38817,
  [SMALL_STATE(2403)] = 38838,
  [SMALL_STATE(2404)] = 38869,
  [SMALL_STATE(2405)] = 38890,
  [SMALL_STATE(2406)] = 38923,
  [SMALL_STATE(2407)] = 38950,
  [SMALL_STATE(2408)] = 38971,
  [SMALL_STATE(2409)] = 38992,
  [SMALL_STATE(2410)] = 39023,
  [SMALL_STATE(2411)] = 39056,
  [SMALL_STATE(2412)] = 39087,
  [SMALL_STATE(2413)] = 39118,
  [SMALL_STATE(2414)] = 39151,
  [SMALL_STATE(2415)] = 39178,
  [SMALL_STATE(2416)] = 39199,
  [SMALL_STATE(2417)] = 39232,
  [SMALL_STATE(2418)] = 39253,
  [SMALL_STATE(2419)] = 39284,
  [SMALL_STATE(2420)] = 39305,
  [SMALL_STATE(2421)] = 39338,
  [SMALL_STATE(2422)] = 39369,
  [SMALL_STATE(2423)] = 39400,
  [SMALL_STATE(2424)] = 39433,
  [SMALL_STATE(2425)] = 39464,
  [SMALL_STATE(2426)] = 39497,
  [SMALL_STATE(2427)] = 39528,
  [SMALL_STATE(2428)] = 39561,
  [SMALL_STATE(2429)] = 39592,
  [SMALL_STATE(2430)] = 39623,
  [SMALL_STATE(2431)] = 39644,
  [SMALL_STATE(2432)] = 39668,
  [SMALL_STATE(2433)] = 39698,
  [SMALL_STATE(2434)] = 39726,
  [SMALL_STATE(2435)] = 39756,
  [SMALL_STATE(2436)] = 39788,
  [SMALL_STATE(2437)] = 39820,
  [SMALL_STATE(2438)] = 39848,
  [SMALL_STATE(2439)] = 39876,
  [SMALL_STATE(2440)] = 39898,
  [SMALL_STATE(2441)] = 39926,
  [SMALL_STATE(2442)] = 39951,
  [SMALL_STATE(2443)] = 39970,
  [SMALL_STATE(2444)] = 39995,
  [SMALL_STATE(2445)] = 40020,
  [SMALL_STATE(2446)] = 40039,
  [SMALL_STATE(2447)] = 40064,
  [SMALL_STATE(2448)] = 40083,
  [SMALL_STATE(2449)] = 40102,
  [SMALL_STATE(2450)] = 40127,
  [SMALL_STATE(2451)] = 40152,
  [SMALL_STATE(2452)] = 40173,
  [SMALL_STATE(2453)] = 40198,
  [SMALL_STATE(2454)] = 40219,
  [SMALL_STATE(2455)] = 40248,
  [SMALL_STATE(2456)] = 40273,
  [SMALL_STATE(2457)] = 40302,
  [SMALL_STATE(2458)] = 40321,
  [SMALL_STATE(2459)] = 40344,
  [SMALL_STATE(2460)] = 40369,
  [SMALL_STATE(2461)] = 40398,
  [SMALL_STATE(2462)] = 40423,
  [SMALL_STATE(2463)] = 40448,
  [SMALL_STATE(2464)] = 40473,
  [SMALL_STATE(2465)] = 40498,
  [SMALL_STATE(2466)] = 40519,
  [SMALL_STATE(2467)] = 40538,
  [SMALL_STATE(2468)] = 40557,
  [SMALL_STATE(2469)] = 40582,
  [SMALL_STATE(2470)] = 40603,
  [SMALL_STATE(2471)] = 40628,
  [SMALL_STATE(2472)] = 40653,
  [SMALL_STATE(2473)] = 40672,
  [SMALL_STATE(2474)] = 40701,
  [SMALL_STATE(2475)] = 40722,
  [SMALL_STATE(2476)] = 40751,
  [SMALL_STATE(2477)] = 40770,
  [SMALL_STATE(2478)] = 40799,
  [SMALL_STATE(2479)] = 40818,
  [SMALL_STATE(2480)] = 40843,
  [SMALL_STATE(2481)] = 40868,
  [SMALL_STATE(2482)] = 40894,
  [SMALL_STATE(2483)] = 40920,
  [SMALL_STATE(2484)] = 40940,
  [SMALL_STATE(2485)] = 40966,
  [SMALL_STATE(2486)] = 40988,
  [SMALL_STATE(2487)] = 41010,
  [SMALL_STATE(2488)] = 41034,
  [SMALL_STATE(2489)] = 41060,
  [SMALL_STATE(2490)] = 41086,
  [SMALL_STATE(2491)] = 41108,
  [SMALL_STATE(2492)] = 41130,
  [SMALL_STATE(2493)] = 41152,
  [SMALL_STATE(2494)] = 41174,
  [SMALL_STATE(2495)] = 41202,
  [SMALL_STATE(2496)] = 41228,
  [SMALL_STATE(2497)] = 41256,
  [SMALL_STATE(2498)] = 41284,
  [SMALL_STATE(2499)] = 41308,
  [SMALL_STATE(2500)] = 41334,
  [SMALL_STATE(2501)] = 41360,
  [SMALL_STATE(2502)] = 41386,
  [SMALL_STATE(2503)] = 41412,
  [SMALL_STATE(2504)] = 41438,
  [SMALL_STATE(2505)] = 41462,
  [SMALL_STATE(2506)] = 41484,
  [SMALL_STATE(2507)] = 41510,
  [SMALL_STATE(2508)] = 41536,
  [SMALL_STATE(2509)] = 41558,
  [SMALL_STATE(2510)] = 41584,
  [SMALL_STATE(2511)] = 41608,
  [SMALL_STATE(2512)] = 41634,
  [SMALL_STATE(2513)] = 41660,
  [SMALL_STATE(2514)] = 41684,
  [SMALL_STATE(2515)] = 41706,
  [SMALL_STATE(2516)] = 41728,
  [SMALL_STATE(2517)] = 41754,
  [SMALL_STATE(2518)] = 41780,
  [SMALL_STATE(2519)] = 41804,
  [SMALL_STATE(2520)] = 41824,
  [SMALL_STATE(2521)] = 41846,
  [SMALL_STATE(2522)] = 41868,
  [SMALL_STATE(2523)] = 41892,
  [SMALL_STATE(2524)] = 41914,
  [SMALL_STATE(2525)] = 41936,
  [SMALL_STATE(2526)] = 41958,
  [SMALL_STATE(2527)] = 41984,
  [SMALL_STATE(2528)] = 42010,
  [SMALL_STATE(2529)] = 42034,
  [SMALL_STATE(2530)] = 42056,
  [SMALL_STATE(2531)] = 42082,
  [SMALL_STATE(2532)] = 42108,
  [SMALL_STATE(2533)] = 42134,
  [SMALL_STATE(2534)] = 42160,
  [SMALL_STATE(2535)] = 42186,
  [SMALL_STATE(2536)] = 42212,
  [SMALL_STATE(2537)] = 42234,
  [SMALL_STATE(2538)] = 42256,
  [SMALL_STATE(2539)] = 42278,
  [SMALL_STATE(2540)] = 42300,
  [SMALL_STATE(2541)] = 42322,
  [SMALL_STATE(2542)] = 42348,
  [SMALL_STATE(2543)] = 42372,
  [SMALL_STATE(2544)] = 42398,
  [SMALL_STATE(2545)] = 42426,
  [SMALL_STATE(2546)] = 42448,
  [SMALL_STATE(2547)] = 42470,
  [SMALL_STATE(2548)] = 42498,
  [SMALL_STATE(2549)] = 42522,
  [SMALL_STATE(2550)] = 42548,
  [SMALL_STATE(2551)] = 42574,
  [SMALL_STATE(2552)] = 42602,
  [SMALL_STATE(2553)] = 42624,
  [SMALL_STATE(2554)] = 42646,
  [SMALL_STATE(2555)] = 42674,
  [SMALL_STATE(2556)] = 42702,
  [SMALL_STATE(2557)] = 42728,
  [SMALL_STATE(2558)] = 42756,
  [SMALL_STATE(2559)] = 42778,
  [SMALL_STATE(2560)] = 42800,
  [SMALL_STATE(2561)] = 42822,
  [SMALL_STATE(2562)] = 42846,
  [SMALL_STATE(2563)] = 42872,
  [SMALL_STATE(2564)] = 42898,
  [SMALL_STATE(2565)] = 42924,
  [SMALL_STATE(2566)] = 42946,
  [SMALL_STATE(2567)] = 42972,
  [SMALL_STATE(2568)] = 42994,
  [SMALL_STATE(2569)] = 43020,
  [SMALL_STATE(2570)] = 43042,
  [SMALL_STATE(2571)] = 43066,
  [SMALL_STATE(2572)] = 43092,
  [SMALL_STATE(2573)] = 43118,
  [SMALL_STATE(2574)] = 43144,
  [SMALL_STATE(2575)] = 43170,
  [SMALL_STATE(2576)] = 43190,
  [SMALL_STATE(2577)] = 43214,
  [SMALL_STATE(2578)] = 43238,
  [SMALL_STATE(2579)] = 43260,
  [SMALL_STATE(2580)] = 43286,
  [SMALL_STATE(2581)] = 43312,
  [SMALL_STATE(2582)] = 43334,
  [SMALL_STATE(2583)] = 43360,
  [SMALL_STATE(2584)] = 43382,
  [SMALL_STATE(2585)] = 43406,
  [SMALL_STATE(2586)] = 43428,
  [SMALL_STATE(2587)] = 43450,
  [SMALL_STATE(2588)] = 43476,
  [SMALL_STATE(2589)] = 43498,
  [SMALL_STATE(2590)] = 43524,
  [SMALL_STATE(2591)] = 43546,
  [SMALL_STATE(2592)] = 43568,
  [SMALL_STATE(2593)] = 43590,
  [SMALL_STATE(2594)] = 43612,
  [SMALL_STATE(2595)] = 43638,
  [SMALL_STATE(2596)] = 43660,
  [SMALL_STATE(2597)] = 43686,
  [SMALL_STATE(2598)] = 43708,
  [SMALL_STATE(2599)] = 43734,
  [SMALL_STATE(2600)] = 43756,
  [SMALL_STATE(2601)] = 43784,
  [SMALL_STATE(2602)] = 43808,
  [SMALL_STATE(2603)] = 43828,
  [SMALL_STATE(2604)] = 43850,
  [SMALL_STATE(2605)] = 43878,
  [SMALL_STATE(2606)] = 43906,
  [SMALL_STATE(2607)] = 43928,
  [SMALL_STATE(2608)] = 43950,
  [SMALL_STATE(2609)] = 43972,
  [SMALL_STATE(2610)] = 43998,
  [SMALL_STATE(2611)] = 44024,
  [SMALL_STATE(2612)] = 44046,
  [SMALL_STATE(2613)] = 44068,
  [SMALL_STATE(2614)] = 44090,
  [SMALL_STATE(2615)] = 44112,
  [SMALL_STATE(2616)] = 44134,
  [SMALL_STATE(2617)] = 44160,
  [SMALL_STATE(2618)] = 44186,
  [SMALL_STATE(2619)] = 44210,
  [SMALL_STATE(2620)] = 44232,
  [SMALL_STATE(2621)] = 44254,
  [SMALL_STATE(2622)] = 44274,
  [SMALL_STATE(2623)] = 44296,
  [SMALL_STATE(2624)] = 44318,
  [SMALL_STATE(2625)] = 44340,
  [SMALL_STATE(2626)] = 44362,
  [SMALL_STATE(2627)] = 44386,
  [SMALL_STATE(2628)] = 44408,
  [SMALL_STATE(2629)] = 44428,
  [SMALL_STATE(2630)] = 44454,
  [SMALL_STATE(2631)] = 44476,
  [SMALL_STATE(2632)] = 44502,
  [SMALL_STATE(2633)] = 44525,
  [SMALL_STATE(2634)] = 44542,
  [SMALL_STATE(2635)] = 44563,
  [SMALL_STATE(2636)] = 44584,
  [SMALL_STATE(2637)] = 44607,
  [SMALL_STATE(2638)] = 44628,
  [SMALL_STATE(2639)] = 44651,
  [SMALL_STATE(2640)] = 44674,
  [SMALL_STATE(2641)] = 44697,
  [SMALL_STATE(2642)] = 44720,
  [SMALL_STATE(2643)] = 44743,
  [SMALL_STATE(2644)] = 44766,
  [SMALL_STATE(2645)] = 44787,
  [SMALL_STATE(2646)] = 44810,
  [SMALL_STATE(2647)] = 44827,
  [SMALL_STATE(2648)] = 44850,
  [SMALL_STATE(2649)] = 44873,
  [SMALL_STATE(2650)] = 44896,
  [SMALL_STATE(2651)] = 44919,
  [SMALL_STATE(2652)] = 44942,
  [SMALL_STATE(2653)] = 44959,
  [SMALL_STATE(2654)] = 44976,
  [SMALL_STATE(2655)] = 44999,
  [SMALL_STATE(2656)] = 45022,
  [SMALL_STATE(2657)] = 45045,
  [SMALL_STATE(2658)] = 45062,
  [SMALL_STATE(2659)] = 45085,
  [SMALL_STATE(2660)] = 45108,
  [SMALL_STATE(2661)] = 45131,
  [SMALL_STATE(2662)] = 45154,
  [SMALL_STATE(2663)] = 45177,
  [SMALL_STATE(2664)] = 45200,
  [SMALL_STATE(2665)] = 45223,
  [SMALL_STATE(2666)] = 45246,
  [SMALL_STATE(2667)] = 45269,
  [SMALL_STATE(2668)] = 45292,
  [SMALL_STATE(2669)] = 45315,
  [SMALL_STATE(2670)] = 45338,
  [SMALL_STATE(2671)] = 45361,
  [SMALL_STATE(2672)] = 45382,
  [SMALL_STATE(2673)] = 45405,
  [SMALL_STATE(2674)] = 45428,
  [SMALL_STATE(2675)] = 45451,
  [SMALL_STATE(2676)] = 45474,
  [SMALL_STATE(2677)] = 45497,
  [SMALL_STATE(2678)] = 45520,
  [SMALL_STATE(2679)] = 45543,
  [SMALL_STATE(2680)] = 45566,
  [SMALL_STATE(2681)] = 45589,
  [SMALL_STATE(2682)] = 45612,
  [SMALL_STATE(2683)] = 45635,
  [SMALL_STATE(2684)] = 45658,
  [SMALL_STATE(2685)] = 45681,
  [SMALL_STATE(2686)] = 45704,
  [SMALL_STATE(2687)] = 45727,
  [SMALL_STATE(2688)] = 45750,
  [SMALL_STATE(2689)] = 45773,
  [SMALL_STATE(2690)] = 45796,
  [SMALL_STATE(2691)] = 45813,
  [SMALL_STATE(2692)] = 45830,
  [SMALL_STATE(2693)] = 45853,
  [SMALL_STATE(2694)] = 45876,
  [SMALL_STATE(2695)] = 45893,
  [SMALL_STATE(2696)] = 45916,
  [SMALL_STATE(2697)] = 45939,
  [SMALL_STATE(2698)] = 45962,
  [SMALL_STATE(2699)] = 45985,
  [SMALL_STATE(2700)] = 46008,
  [SMALL_STATE(2701)] = 46031,
  [SMALL_STATE(2702)] = 46054,
  [SMALL_STATE(2703)] = 46071,
  [SMALL_STATE(2704)] = 46094,
  [SMALL_STATE(2705)] = 46117,
  [SMALL_STATE(2706)] = 46140,
  [SMALL_STATE(2707)] = 46163,
  [SMALL_STATE(2708)] = 46186,
  [SMALL_STATE(2709)] = 46209,
  [SMALL_STATE(2710)] = 46232,
  [SMALL_STATE(2711)] = 46255,
  [SMALL_STATE(2712)] = 46276,
  [SMALL_STATE(2713)] = 46297,
  [SMALL_STATE(2714)] = 46314,
  [SMALL_STATE(2715)] = 46335,
  [SMALL_STATE(2716)] = 46358,
  [SMALL_STATE(2717)] = 46381,
  [SMALL_STATE(2718)] = 46402,
  [SMALL_STATE(2719)] = 46421,
  [SMALL_STATE(2720)] = 46444,
  [SMALL_STATE(2721)] = 46467,
  [SMALL_STATE(2722)] = 46488,
  [SMALL_STATE(2723)] = 46508,
  [SMALL_STATE(2724)] = 46528,
  [SMALL_STATE(2725)] = 46548,
  [SMALL_STATE(2726)] = 46568,
  [SMALL_STATE(2727)] = 46588,
  [SMALL_STATE(2728)] = 46608,
  [SMALL_STATE(2729)] = 46628,
  [SMALL_STATE(2730)] = 46648,
  [SMALL_STATE(2731)] = 46668,
  [SMALL_STATE(2732)] = 46688,
  [SMALL_STATE(2733)] = 46708,
  [SMALL_STATE(2734)] = 46728,
  [SMALL_STATE(2735)] = 46746,
  [SMALL_STATE(2736)] = 46766,
  [SMALL_STATE(2737)] = 46786,
  [SMALL_STATE(2738)] = 46806,
  [SMALL_STATE(2739)] = 46826,
  [SMALL_STATE(2740)] = 46846,
  [SMALL_STATE(2741)] = 46866,
  [SMALL_STATE(2742)] = 46886,
  [SMALL_STATE(2743)] = 46906,
  [SMALL_STATE(2744)] = 46926,
  [SMALL_STATE(2745)] = 46946,
  [SMALL_STATE(2746)] = 46966,
  [SMALL_STATE(2747)] = 46986,
  [SMALL_STATE(2748)] = 47006,
  [SMALL_STATE(2749)] = 47026,
  [SMALL_STATE(2750)] = 47046,
  [SMALL_STATE(2751)] = 47066,
  [SMALL_STATE(2752)] = 47086,
  [SMALL_STATE(2753)] = 47106,
  [SMALL_STATE(2754)] = 47126,
  [SMALL_STATE(2755)] = 47146,
  [SMALL_STATE(2756)] = 47166,
  [SMALL_STATE(2757)] = 47186,
  [SMALL_STATE(2758)] = 47206,
  [SMALL_STATE(2759)] = 47226,
  [SMALL_STATE(2760)] = 47246,
  [SMALL_STATE(2761)] = 47266,
  [SMALL_STATE(2762)] = 47286,
  [SMALL_STATE(2763)] = 47306,
  [SMALL_STATE(2764)] = 47326,
  [SMALL_STATE(2765)] = 47346,
  [SMALL_STATE(2766)] = 47366,
  [SMALL_STATE(2767)] = 47382,
  [SMALL_STATE(2768)] = 47402,
  [SMALL_STATE(2769)] = 47422,
  [SMALL_STATE(2770)] = 47442,
  [SMALL_STATE(2771)] = 47462,
  [SMALL_STATE(2772)] = 47482,
  [SMALL_STATE(2773)] = 47502,
  [SMALL_STATE(2774)] = 47522,
  [SMALL_STATE(2775)] = 47542,
  [SMALL_STATE(2776)] = 47562,
  [SMALL_STATE(2777)] = 47582,
  [SMALL_STATE(2778)] = 47602,
  [SMALL_STATE(2779)] = 47622,
  [SMALL_STATE(2780)] = 47642,
  [SMALL_STATE(2781)] = 47662,
  [SMALL_STATE(2782)] = 47682,
  [SMALL_STATE(2783)] = 47702,
  [SMALL_STATE(2784)] = 47722,
  [SMALL_STATE(2785)] = 47742,
  [SMALL_STATE(2786)] = 47762,
  [SMALL_STATE(2787)] = 47782,
  [SMALL_STATE(2788)] = 47802,
  [SMALL_STATE(2789)] = 47822,
  [SMALL_STATE(2790)] = 47842,
  [SMALL_STATE(2791)] = 47862,
  [SMALL_STATE(2792)] = 47882,
  [SMALL_STATE(2793)] = 47902,
  [SMALL_STATE(2794)] = 47922,
  [SMALL_STATE(2795)] = 47942,
  [SMALL_STATE(2796)] = 47962,
  [SMALL_STATE(2797)] = 47982,
  [SMALL_STATE(2798)] = 48002,
  [SMALL_STATE(2799)] = 48022,
  [SMALL_STATE(2800)] = 48042,
  [SMALL_STATE(2801)] = 48062,
  [SMALL_STATE(2802)] = 48082,
  [SMALL_STATE(2803)] = 48102,
  [SMALL_STATE(2804)] = 48122,
  [SMALL_STATE(2805)] = 48142,
  [SMALL_STATE(2806)] = 48162,
  [SMALL_STATE(2807)] = 48182,
  [SMALL_STATE(2808)] = 48202,
  [SMALL_STATE(2809)] = 48222,
  [SMALL_STATE(2810)] = 48242,
  [SMALL_STATE(2811)] = 48262,
  [SMALL_STATE(2812)] = 48282,
  [SMALL_STATE(2813)] = 48302,
  [SMALL_STATE(2814)] = 48322,
  [SMALL_STATE(2815)] = 48342,
  [SMALL_STATE(2816)] = 48362,
  [SMALL_STATE(2817)] = 48382,
  [SMALL_STATE(2818)] = 48402,
  [SMALL_STATE(2819)] = 48422,
  [SMALL_STATE(2820)] = 48442,
  [SMALL_STATE(2821)] = 48462,
  [SMALL_STATE(2822)] = 48482,
  [SMALL_STATE(2823)] = 48500,
  [SMALL_STATE(2824)] = 48520,
  [SMALL_STATE(2825)] = 48540,
  [SMALL_STATE(2826)] = 48560,
  [SMALL_STATE(2827)] = 48580,
  [SMALL_STATE(2828)] = 48600,
  [SMALL_STATE(2829)] = 48620,
  [SMALL_STATE(2830)] = 48640,
  [SMALL_STATE(2831)] = 48660,
  [SMALL_STATE(2832)] = 48680,
  [SMALL_STATE(2833)] = 48700,
  [SMALL_STATE(2834)] = 48720,
  [SMALL_STATE(2835)] = 48740,
  [SMALL_STATE(2836)] = 48760,
  [SMALL_STATE(2837)] = 48780,
  [SMALL_STATE(2838)] = 48800,
  [SMALL_STATE(2839)] = 48820,
  [SMALL_STATE(2840)] = 48840,
  [SMALL_STATE(2841)] = 48860,
  [SMALL_STATE(2842)] = 48880,
  [SMALL_STATE(2843)] = 48900,
  [SMALL_STATE(2844)] = 48920,
  [SMALL_STATE(2845)] = 48940,
  [SMALL_STATE(2846)] = 48960,
  [SMALL_STATE(2847)] = 48980,
  [SMALL_STATE(2848)] = 49000,
  [SMALL_STATE(2849)] = 49020,
  [SMALL_STATE(2850)] = 49040,
  [SMALL_STATE(2851)] = 49060,
  [SMALL_STATE(2852)] = 49080,
  [SMALL_STATE(2853)] = 49100,
  [SMALL_STATE(2854)] = 49120,
  [SMALL_STATE(2855)] = 49140,
  [SMALL_STATE(2856)] = 49160,
  [SMALL_STATE(2857)] = 49180,
  [SMALL_STATE(2858)] = 49200,
  [SMALL_STATE(2859)] = 49220,
  [SMALL_STATE(2860)] = 49240,
  [SMALL_STATE(2861)] = 49260,
  [SMALL_STATE(2862)] = 49280,
  [SMALL_STATE(2863)] = 49300,
  [SMALL_STATE(2864)] = 49320,
  [SMALL_STATE(2865)] = 49340,
  [SMALL_STATE(2866)] = 49360,
  [SMALL_STATE(2867)] = 49380,
  [SMALL_STATE(2868)] = 49400,
  [SMALL_STATE(2869)] = 49420,
  [SMALL_STATE(2870)] = 49440,
  [SMALL_STATE(2871)] = 49460,
  [SMALL_STATE(2872)] = 49480,
  [SMALL_STATE(2873)] = 49500,
  [SMALL_STATE(2874)] = 49520,
  [SMALL_STATE(2875)] = 49540,
  [SMALL_STATE(2876)] = 49560,
  [SMALL_STATE(2877)] = 49580,
  [SMALL_STATE(2878)] = 49600,
  [SMALL_STATE(2879)] = 49620,
  [SMALL_STATE(2880)] = 49640,
  [SMALL_STATE(2881)] = 49660,
  [SMALL_STATE(2882)] = 49680,
  [SMALL_STATE(2883)] = 49700,
  [SMALL_STATE(2884)] = 49720,
  [SMALL_STATE(2885)] = 49740,
  [SMALL_STATE(2886)] = 49760,
  [SMALL_STATE(2887)] = 49780,
  [SMALL_STATE(2888)] = 49800,
  [SMALL_STATE(2889)] = 49820,
  [SMALL_STATE(2890)] = 49840,
  [SMALL_STATE(2891)] = 49860,
  [SMALL_STATE(2892)] = 49880,
  [SMALL_STATE(2893)] = 49900,
  [SMALL_STATE(2894)] = 49920,
  [SMALL_STATE(2895)] = 49940,
  [SMALL_STATE(2896)] = 49960,
  [SMALL_STATE(2897)] = 49980,
  [SMALL_STATE(2898)] = 50000,
  [SMALL_STATE(2899)] = 50018,
  [SMALL_STATE(2900)] = 50038,
  [SMALL_STATE(2901)] = 50058,
  [SMALL_STATE(2902)] = 50078,
  [SMALL_STATE(2903)] = 50098,
  [SMALL_STATE(2904)] = 50116,
  [SMALL_STATE(2905)] = 50136,
  [SMALL_STATE(2906)] = 50156,
  [SMALL_STATE(2907)] = 50176,
  [SMALL_STATE(2908)] = 50196,
  [SMALL_STATE(2909)] = 50216,
  [SMALL_STATE(2910)] = 50236,
  [SMALL_STATE(2911)] = 50256,
  [SMALL_STATE(2912)] = 50276,
  [SMALL_STATE(2913)] = 50296,
  [SMALL_STATE(2914)] = 50316,
  [SMALL_STATE(2915)] = 50336,
  [SMALL_STATE(2916)] = 50356,
  [SMALL_STATE(2917)] = 50376,
  [SMALL_STATE(2918)] = 50396,
  [SMALL_STATE(2919)] = 50416,
  [SMALL_STATE(2920)] = 50436,
  [SMALL_STATE(2921)] = 50456,
  [SMALL_STATE(2922)] = 50476,
  [SMALL_STATE(2923)] = 50496,
  [SMALL_STATE(2924)] = 50516,
  [SMALL_STATE(2925)] = 50536,
  [SMALL_STATE(2926)] = 50556,
  [SMALL_STATE(2927)] = 50576,
  [SMALL_STATE(2928)] = 50596,
  [SMALL_STATE(2929)] = 50616,
  [SMALL_STATE(2930)] = 50636,
  [SMALL_STATE(2931)] = 50656,
  [SMALL_STATE(2932)] = 50676,
  [SMALL_STATE(2933)] = 50696,
  [SMALL_STATE(2934)] = 50716,
  [SMALL_STATE(2935)] = 50736,
  [SMALL_STATE(2936)] = 50756,
  [SMALL_STATE(2937)] = 50772,
  [SMALL_STATE(2938)] = 50792,
  [SMALL_STATE(2939)] = 50812,
  [SMALL_STATE(2940)] = 50832,
  [SMALL_STATE(2941)] = 50852,
  [SMALL_STATE(2942)] = 50872,
  [SMALL_STATE(2943)] = 50892,
  [SMALL_STATE(2944)] = 50912,
  [SMALL_STATE(2945)] = 50932,
  [SMALL_STATE(2946)] = 50952,
  [SMALL_STATE(2947)] = 50972,
  [SMALL_STATE(2948)] = 50992,
  [SMALL_STATE(2949)] = 51012,
  [SMALL_STATE(2950)] = 51032,
  [SMALL_STATE(2951)] = 51052,
  [SMALL_STATE(2952)] = 51072,
  [SMALL_STATE(2953)] = 51092,
  [SMALL_STATE(2954)] = 51112,
  [SMALL_STATE(2955)] = 51132,
  [SMALL_STATE(2956)] = 51150,
  [SMALL_STATE(2957)] = 51170,
  [SMALL_STATE(2958)] = 51190,
  [SMALL_STATE(2959)] = 51210,
  [SMALL_STATE(2960)] = 51230,
  [SMALL_STATE(2961)] = 51250,
  [SMALL_STATE(2962)] = 51270,
  [SMALL_STATE(2963)] = 51290,
  [SMALL_STATE(2964)] = 51310,
  [SMALL_STATE(2965)] = 51330,
  [SMALL_STATE(2966)] = 51350,
  [SMALL_STATE(2967)] = 51370,
  [SMALL_STATE(2968)] = 51390,
  [SMALL_STATE(2969)] = 51410,
  [SMALL_STATE(2970)] = 51430,
  [SMALL_STATE(2971)] = 51450,
  [SMALL_STATE(2972)] = 51470,
  [SMALL_STATE(2973)] = 51490,
  [SMALL_STATE(2974)] = 51510,
  [SMALL_STATE(2975)] = 51530,
  [SMALL_STATE(2976)] = 51550,
  [SMALL_STATE(2977)] = 51570,
  [SMALL_STATE(2978)] = 51590,
  [SMALL_STATE(2979)] = 51610,
  [SMALL_STATE(2980)] = 51630,
  [SMALL_STATE(2981)] = 51650,
  [SMALL_STATE(2982)] = 51670,
  [SMALL_STATE(2983)] = 51690,
  [SMALL_STATE(2984)] = 51710,
  [SMALL_STATE(2985)] = 51730,
  [SMALL_STATE(2986)] = 51750,
  [SMALL_STATE(2987)] = 51770,
  [SMALL_STATE(2988)] = 51790,
  [SMALL_STATE(2989)] = 51810,
  [SMALL_STATE(2990)] = 51830,
  [SMALL_STATE(2991)] = 51850,
  [SMALL_STATE(2992)] = 51870,
  [SMALL_STATE(2993)] = 51890,
  [SMALL_STATE(2994)] = 51910,
  [SMALL_STATE(2995)] = 51930,
  [SMALL_STATE(2996)] = 51950,
  [SMALL_STATE(2997)] = 51970,
  [SMALL_STATE(2998)] = 51990,
  [SMALL_STATE(2999)] = 52010,
  [SMALL_STATE(3000)] = 52030,
  [SMALL_STATE(3001)] = 52050,
  [SMALL_STATE(3002)] = 52070,
  [SMALL_STATE(3003)] = 52090,
  [SMALL_STATE(3004)] = 52110,
  [SMALL_STATE(3005)] = 52130,
  [SMALL_STATE(3006)] = 52150,
  [SMALL_STATE(3007)] = 52170,
  [SMALL_STATE(3008)] = 52190,
  [SMALL_STATE(3009)] = 52210,
  [SMALL_STATE(3010)] = 52230,
  [SMALL_STATE(3011)] = 52250,
  [SMALL_STATE(3012)] = 52270,
  [SMALL_STATE(3013)] = 52290,
  [SMALL_STATE(3014)] = 52310,
  [SMALL_STATE(3015)] = 52330,
  [SMALL_STATE(3016)] = 52348,
  [SMALL_STATE(3017)] = 52368,
  [SMALL_STATE(3018)] = 52388,
  [SMALL_STATE(3019)] = 52408,
  [SMALL_STATE(3020)] = 52428,
  [SMALL_STATE(3021)] = 52448,
  [SMALL_STATE(3022)] = 52468,
  [SMALL_STATE(3023)] = 52488,
  [SMALL_STATE(3024)] = 52508,
  [SMALL_STATE(3025)] = 52524,
  [SMALL_STATE(3026)] = 52544,
  [SMALL_STATE(3027)] = 52564,
  [SMALL_STATE(3028)] = 52584,
  [SMALL_STATE(3029)] = 52604,
  [SMALL_STATE(3030)] = 52624,
  [SMALL_STATE(3031)] = 52644,
  [SMALL_STATE(3032)] = 52664,
  [SMALL_STATE(3033)] = 52684,
  [SMALL_STATE(3034)] = 52704,
  [SMALL_STATE(3035)] = 52724,
  [SMALL_STATE(3036)] = 52744,
  [SMALL_STATE(3037)] = 52764,
  [SMALL_STATE(3038)] = 52784,
  [SMALL_STATE(3039)] = 52804,
  [SMALL_STATE(3040)] = 52824,
  [SMALL_STATE(3041)] = 52844,
  [SMALL_STATE(3042)] = 52864,
  [SMALL_STATE(3043)] = 52884,
  [SMALL_STATE(3044)] = 52904,
  [SMALL_STATE(3045)] = 52924,
  [SMALL_STATE(3046)] = 52944,
  [SMALL_STATE(3047)] = 52964,
  [SMALL_STATE(3048)] = 52984,
  [SMALL_STATE(3049)] = 53004,
  [SMALL_STATE(3050)] = 53024,
  [SMALL_STATE(3051)] = 53044,
  [SMALL_STATE(3052)] = 53064,
  [SMALL_STATE(3053)] = 53084,
  [SMALL_STATE(3054)] = 53104,
  [SMALL_STATE(3055)] = 53124,
  [SMALL_STATE(3056)] = 53144,
  [SMALL_STATE(3057)] = 53162,
  [SMALL_STATE(3058)] = 53182,
  [SMALL_STATE(3059)] = 53202,
  [SMALL_STATE(3060)] = 53222,
  [SMALL_STATE(3061)] = 53242,
  [SMALL_STATE(3062)] = 53260,
  [SMALL_STATE(3063)] = 53280,
  [SMALL_STATE(3064)] = 53300,
  [SMALL_STATE(3065)] = 53320,
  [SMALL_STATE(3066)] = 53340,
  [SMALL_STATE(3067)] = 53355,
  [SMALL_STATE(3068)] = 53372,
  [SMALL_STATE(3069)] = 53389,
  [SMALL_STATE(3070)] = 53406,
  [SMALL_STATE(3071)] = 53423,
  [SMALL_STATE(3072)] = 53440,
  [SMALL_STATE(3073)] = 53457,
  [SMALL_STATE(3074)] = 53474,
  [SMALL_STATE(3075)] = 53491,
  [SMALL_STATE(3076)] = 53506,
  [SMALL_STATE(3077)] = 53523,
  [SMALL_STATE(3078)] = 53540,
  [SMALL_STATE(3079)] = 53557,
  [SMALL_STATE(3080)] = 53574,
  [SMALL_STATE(3081)] = 53591,
  [SMALL_STATE(3082)] = 53606,
  [SMALL_STATE(3083)] = 53625,
  [SMALL_STATE(3084)] = 53642,
  [SMALL_STATE(3085)] = 53659,
  [SMALL_STATE(3086)] = 53676,
  [SMALL_STATE(3087)] = 53693,
  [SMALL_STATE(3088)] = 53708,
  [SMALL_STATE(3089)] = 53725,
  [SMALL_STATE(3090)] = 53742,
  [SMALL_STATE(3091)] = 53759,
  [SMALL_STATE(3092)] = 53776,
  [SMALL_STATE(3093)] = 53793,
  [SMALL_STATE(3094)] = 53810,
  [SMALL_STATE(3095)] = 53827,
  [SMALL_STATE(3096)] = 53844,
  [SMALL_STATE(3097)] = 53861,
  [SMALL_STATE(3098)] = 53876,
  [SMALL_STATE(3099)] = 53891,
  [SMALL_STATE(3100)] = 53908,
  [SMALL_STATE(3101)] = 53925,
  [SMALL_STATE(3102)] = 53942,
  [SMALL_STATE(3103)] = 53957,
  [SMALL_STATE(3104)] = 53972,
  [SMALL_STATE(3105)] = 53989,
  [SMALL_STATE(3106)] = 54006,
  [SMALL_STATE(3107)] = 54023,
  [SMALL_STATE(3108)] = 54040,
  [SMALL_STATE(3109)] = 54057,
  [SMALL_STATE(3110)] = 54074,
  [SMALL_STATE(3111)] = 54091,
  [SMALL_STATE(3112)] = 54106,
  [SMALL_STATE(3113)] = 54123,
  [SMALL_STATE(3114)] = 54138,
  [SMALL_STATE(3115)] = 54155,
  [SMALL_STATE(3116)] = 54172,
  [SMALL_STATE(3117)] = 54187,
  [SMALL_STATE(3118)] = 54204,
  [SMALL_STATE(3119)] = 54221,
  [SMALL_STATE(3120)] = 54236,
  [SMALL_STATE(3121)] = 54253,
  [SMALL_STATE(3122)] = 54270,
  [SMALL_STATE(3123)] = 54287,
  [SMALL_STATE(3124)] = 54304,
  [SMALL_STATE(3125)] = 54321,
  [SMALL_STATE(3126)] = 54338,
  [SMALL_STATE(3127)] = 54355,
  [SMALL_STATE(3128)] = 54370,
  [SMALL_STATE(3129)] = 54387,
  [SMALL_STATE(3130)] = 54404,
  [SMALL_STATE(3131)] = 54421,
  [SMALL_STATE(3132)] = 54438,
  [SMALL_STATE(3133)] = 54455,
  [SMALL_STATE(3134)] = 54470,
  [SMALL_STATE(3135)] = 54487,
  [SMALL_STATE(3136)] = 54502,
  [SMALL_STATE(3137)] = 54517,
  [SMALL_STATE(3138)] = 54534,
  [SMALL_STATE(3139)] = 54551,
  [SMALL_STATE(3140)] = 54568,
  [SMALL_STATE(3141)] = 54585,
  [SMALL_STATE(3142)] = 54602,
  [SMALL_STATE(3143)] = 54616,
  [SMALL_STATE(3144)] = 54630,
  [SMALL_STATE(3145)] = 54644,
  [SMALL_STATE(3146)] = 54658,
  [SMALL_STATE(3147)] = 54672,
  [SMALL_STATE(3148)] = 54686,
  [SMALL_STATE(3149)] = 54700,
  [SMALL_STATE(3150)] = 54714,
  [SMALL_STATE(3151)] = 54728,
  [SMALL_STATE(3152)] = 54742,
  [SMALL_STATE(3153)] = 54756,
  [SMALL_STATE(3154)] = 54770,
  [SMALL_STATE(3155)] = 54784,
  [SMALL_STATE(3156)] = 54798,
  [SMALL_STATE(3157)] = 54812,
  [SMALL_STATE(3158)] = 54826,
  [SMALL_STATE(3159)] = 54840,
  [SMALL_STATE(3160)] = 54854,
  [SMALL_STATE(3161)] = 54868,
  [SMALL_STATE(3162)] = 54882,
  [SMALL_STATE(3163)] = 54896,
  [SMALL_STATE(3164)] = 54910,
  [SMALL_STATE(3165)] = 54924,
  [SMALL_STATE(3166)] = 54940,
  [SMALL_STATE(3167)] = 54954,
  [SMALL_STATE(3168)] = 54968,
  [SMALL_STATE(3169)] = 54982,
  [SMALL_STATE(3170)] = 54996,
  [SMALL_STATE(3171)] = 55010,
  [SMALL_STATE(3172)] = 55024,
  [SMALL_STATE(3173)] = 55038,
  [SMALL_STATE(3174)] = 55052,
  [SMALL_STATE(3175)] = 55066,
  [SMALL_STATE(3176)] = 55080,
  [SMALL_STATE(3177)] = 55096,
  [SMALL_STATE(3178)] = 55110,
  [SMALL_STATE(3179)] = 55124,
  [SMALL_STATE(3180)] = 55138,
  [SMALL_STATE(3181)] = 55152,
  [SMALL_STATE(3182)] = 55166,
  [SMALL_STATE(3183)] = 55180,
  [SMALL_STATE(3184)] = 55194,
  [SMALL_STATE(3185)] = 55208,
  [SMALL_STATE(3186)] = 55222,
  [SMALL_STATE(3187)] = 55236,
  [SMALL_STATE(3188)] = 55250,
  [SMALL_STATE(3189)] = 55264,
  [SMALL_STATE(3190)] = 55278,
  [SMALL_STATE(3191)] = 55292,
  [SMALL_STATE(3192)] = 55306,
  [SMALL_STATE(3193)] = 55320,
  [SMALL_STATE(3194)] = 55334,
  [SMALL_STATE(3195)] = 55348,
  [SMALL_STATE(3196)] = 55362,
  [SMALL_STATE(3197)] = 55376,
  [SMALL_STATE(3198)] = 55390,
  [SMALL_STATE(3199)] = 55404,
  [SMALL_STATE(3200)] = 55418,
  [SMALL_STATE(3201)] = 55432,
  [SMALL_STATE(3202)] = 55446,
  [SMALL_STATE(3203)] = 55462,
  [SMALL_STATE(3204)] = 55476,
  [SMALL_STATE(3205)] = 55490,
  [SMALL_STATE(3206)] = 55504,
  [SMALL_STATE(3207)] = 55518,
  [SMALL_STATE(3208)] = 55532,
  [SMALL_STATE(3209)] = 55546,
  [SMALL_STATE(3210)] = 55560,
  [SMALL_STATE(3211)] = 55574,
  [SMALL_STATE(3212)] = 55588,
  [SMALL_STATE(3213)] = 55602,
  [SMALL_STATE(3214)] = 55616,
  [SMALL_STATE(3215)] = 55630,
  [SMALL_STATE(3216)] = 55644,
  [SMALL_STATE(3217)] = 55658,
  [SMALL_STATE(3218)] = 55672,
  [SMALL_STATE(3219)] = 55686,
  [SMALL_STATE(3220)] = 55700,
  [SMALL_STATE(3221)] = 55714,
  [SMALL_STATE(3222)] = 55728,
  [SMALL_STATE(3223)] = 55742,
  [SMALL_STATE(3224)] = 55756,
  [SMALL_STATE(3225)] = 55770,
  [SMALL_STATE(3226)] = 55784,
  [SMALL_STATE(3227)] = 55798,
  [SMALL_STATE(3228)] = 55812,
  [SMALL_STATE(3229)] = 55826,
  [SMALL_STATE(3230)] = 55840,
  [SMALL_STATE(3231)] = 55854,
  [SMALL_STATE(3232)] = 55868,
  [SMALL_STATE(3233)] = 55882,
  [SMALL_STATE(3234)] = 55896,
  [SMALL_STATE(3235)] = 55910,
  [SMALL_STATE(3236)] = 55924,
  [SMALL_STATE(3237)] = 55938,
  [SMALL_STATE(3238)] = 55952,
  [SMALL_STATE(3239)] = 55966,
  [SMALL_STATE(3240)] = 55980,
  [SMALL_STATE(3241)] = 55994,
  [SMALL_STATE(3242)] = 56008,
  [SMALL_STATE(3243)] = 56022,
  [SMALL_STATE(3244)] = 56036,
  [SMALL_STATE(3245)] = 56050,
  [SMALL_STATE(3246)] = 56064,
  [SMALL_STATE(3247)] = 56078,
  [SMALL_STATE(3248)] = 56092,
  [SMALL_STATE(3249)] = 56106,
  [SMALL_STATE(3250)] = 56120,
  [SMALL_STATE(3251)] = 56134,
  [SMALL_STATE(3252)] = 56148,
  [SMALL_STATE(3253)] = 56162,
  [SMALL_STATE(3254)] = 56176,
  [SMALL_STATE(3255)] = 56190,
  [SMALL_STATE(3256)] = 56204,
  [SMALL_STATE(3257)] = 56218,
  [SMALL_STATE(3258)] = 56232,
  [SMALL_STATE(3259)] = 56246,
  [SMALL_STATE(3260)] = 56260,
  [SMALL_STATE(3261)] = 56274,
  [SMALL_STATE(3262)] = 56288,
  [SMALL_STATE(3263)] = 56302,
  [SMALL_STATE(3264)] = 56316,
  [SMALL_STATE(3265)] = 56330,
  [SMALL_STATE(3266)] = 56344,
  [SMALL_STATE(3267)] = 56358,
  [SMALL_STATE(3268)] = 56372,
  [SMALL_STATE(3269)] = 56386,
  [SMALL_STATE(3270)] = 56400,
  [SMALL_STATE(3271)] = 56414,
  [SMALL_STATE(3272)] = 56428,
  [SMALL_STATE(3273)] = 56442,
  [SMALL_STATE(3274)] = 56456,
  [SMALL_STATE(3275)] = 56470,
  [SMALL_STATE(3276)] = 56484,
  [SMALL_STATE(3277)] = 56498,
  [SMALL_STATE(3278)] = 56512,
  [SMALL_STATE(3279)] = 56526,
  [SMALL_STATE(3280)] = 56542,
  [SMALL_STATE(3281)] = 56556,
  [SMALL_STATE(3282)] = 56570,
  [SMALL_STATE(3283)] = 56584,
  [SMALL_STATE(3284)] = 56598,
  [SMALL_STATE(3285)] = 56612,
  [SMALL_STATE(3286)] = 56626,
  [SMALL_STATE(3287)] = 56640,
  [SMALL_STATE(3288)] = 56654,
  [SMALL_STATE(3289)] = 56668,
  [SMALL_STATE(3290)] = 56682,
  [SMALL_STATE(3291)] = 56696,
  [SMALL_STATE(3292)] = 56710,
  [SMALL_STATE(3293)] = 56724,
  [SMALL_STATE(3294)] = 56738,
  [SMALL_STATE(3295)] = 56752,
  [SMALL_STATE(3296)] = 56766,
  [SMALL_STATE(3297)] = 56780,
  [SMALL_STATE(3298)] = 56794,
  [SMALL_STATE(3299)] = 56808,
  [SMALL_STATE(3300)] = 56822,
  [SMALL_STATE(3301)] = 56836,
  [SMALL_STATE(3302)] = 56850,
  [SMALL_STATE(3303)] = 56864,
  [SMALL_STATE(3304)] = 56878,
  [SMALL_STATE(3305)] = 56892,
  [SMALL_STATE(3306)] = 56906,
  [SMALL_STATE(3307)] = 56920,
  [SMALL_STATE(3308)] = 56934,
  [SMALL_STATE(3309)] = 56948,
  [SMALL_STATE(3310)] = 56962,
  [SMALL_STATE(3311)] = 56976,
  [SMALL_STATE(3312)] = 56990,
  [SMALL_STATE(3313)] = 57004,
  [SMALL_STATE(3314)] = 57018,
  [SMALL_STATE(3315)] = 57032,
  [SMALL_STATE(3316)] = 57036,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [9] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3296),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3092),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_autoquoted_bareword, 2, 20, 0),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3117),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_autoquoted_bareword, 2, 20, 0),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loopex_expression, 1, 0, 2),
  [299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loopex_expression, 1, 0, 2),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(3273),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(2222),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(3269),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(1219),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(726),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(600),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(2187),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(744),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 1, 0, 0),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3101),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2929),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func1op_call_expression, 2, 0, 18),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func1op_call_expression, 2, 0, 18),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_require_expression, 1, 0, 0),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_expression, 1, 0, 0),
  [463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func1op_call_expression, 1, 0, 1),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func1op_call_expression, 1, 0, 1),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(839),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(589),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(802),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(3209),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(2219),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(3208),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(1471),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(840),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(578),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(2157),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(842),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_autoquoted_bareword, 3, 20, 0),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_autoquoted_bareword, 3, 20, 0),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_undef_expression, 1, 0, 0),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef_expression, 1, 0, 0),
  [576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(3209),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(2219),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(3208),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(1471),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(840),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(578),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(2157),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(842),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(2252),
  [607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(3196),
  [610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(1706),
  [613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(836),
  [616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(576),
  [619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(2164),
  [622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(3211),
  [625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(698),
  [628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0),
  [631] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(3273),
  [635] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(2222),
  [639] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(3269),
  [643] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(1219),
  [647] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(726),
  [651] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(600),
  [655] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(2187),
  [659] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(744),
  [663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0),
  [666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0),
  [669] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(3273),
  [673] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(2222),
  [677] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(3269),
  [681] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(1219),
  [685] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(839),
  [689] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(589),
  [693] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(2187),
  [697] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(802),
  [701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0),
  [704] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(3209),
  [708] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(2219),
  [712] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(3208),
  [716] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(1471),
  [720] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(840),
  [724] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(578),
  [728] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(2157),
  [732] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(842),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [760] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(839),
  [764] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(589),
  [768] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(802),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(3273),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(2222),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(3269),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(1219),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(839),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(589),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(2187),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(802),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(726),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(600),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(744),
  [807] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(726),
  [811] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(600),
  [815] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(744),
  [819] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(3209),
  [823] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(2219),
  [827] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(3208),
  [831] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(1471),
  [835] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(840),
  [839] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(578),
  [843] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(2157),
  [847] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(842),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(804),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(611),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(805),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(813),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(601),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0), SHIFT(720),
  [901] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(2252),
  [905] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(3196),
  [909] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(1706),
  [913] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(836),
  [917] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(576),
  [921] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(2164),
  [925] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(3211),
  [929] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(698),
  [933] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(2252),
  [937] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(3196),
  [941] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(1706),
  [945] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(836),
  [949] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(576),
  [953] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(2164),
  [957] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(3211),
  [961] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(698),
  [965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(2252),
  [968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(3196),
  [971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(1706),
  [974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(836),
  [977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(576),
  [980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(2164),
  [983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(3211),
  [986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(698),
  [989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(804),
  [992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(611),
  [995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(805),
  [998] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(813),
  [1002] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(601),
  [1006] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(720),
  [1010] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(804),
  [1014] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(611),
  [1018] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(805),
  [1022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(813),
  [1025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(601),
  [1028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), SHIFT_REPEAT(720),
  [1031] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(804),
  [1035] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(611),
  [1039] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 2, 0, 0), SHIFT(805),
  [1043] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(813),
  [1047] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(601),
  [1051] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 1, 0, 0), REDUCE(sym__term_rightward, 3, 0, 0), SHIFT(720),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2822),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3090),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2972),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2964),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2956),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2670),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2941),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3139),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2864),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3206),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2688),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2951),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2952),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2825),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2826),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2985),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3099),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3013),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2576),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3129),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2912),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [1511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3079),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2679),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2674),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2673),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2672),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3145),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2661),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2589),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2561),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3047),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2675),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2632),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3170),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2570),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2827),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2649),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [2031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(872),
  [2034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1127),
  [2037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1108),
  [2040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(991),
  [2043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2734),
  [2046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2637),
  [2049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2372),
  [2052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2371),
  [2055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(384),
  [2058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1190),
  [2061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2369),
  [2064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2638),
  [2067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2743),
  [2070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2457),
  [2073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3273),
  [2076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2200),
  [2079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(324),
  [2082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2198),
  [2085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2222),
  [2088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3269),
  [2091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1219),
  [2094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(726),
  [2097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(600),
  [2100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2187),
  [2103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(744),
  [2106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(745),
  [2109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2639),
  [2112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(546),
  [2115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(621),
  [2118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(118),
  [2121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(430),
  [2124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(432),
  [2127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(593),
  [2130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(55),
  [2133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(153),
  [2136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2184),
  [2139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2182),
  [2142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2437),
  [2145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2432),
  [2148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [2151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2640),
  [2154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(117),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [2159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3083),
  [2162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3084),
  [2165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3085),
  [2168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2760),
  [2171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3086),
  [2174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3088),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2764),
  [2180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2765),
  [2183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3091),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3092),
  [2189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(913),
  [2192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1255),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2630),
  [2198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2016),
  [2201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2017),
  [2204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1994),
  [2207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3074),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2711),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3073),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [2240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1107),
  [2243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2822),
  [2246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2711),
  [2249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2340),
  [2252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2339),
  [2255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2645),
  [2258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2806),
  [2261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2438),
  [2264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2434),
  [2267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2651),
  [2270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3073),
  [2273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3072),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [2368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3114),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [2394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [2464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [2468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2883),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [2506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [2512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [2516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2977),
  [2518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [2568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [2570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [2574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [2598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [2626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [2640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [2642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [2646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [2656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [2722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [2768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [2792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [2796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [2816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [2842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [2848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [2870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 1, 0, 0),
  [2872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [2874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bareword, 1, 1, 0),
  [2876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function, 1, 0, 0), REDUCE(sym_bareword, 1, 1, 0),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 1, 0, 0),
  [2881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bareword, 1, 1, 0),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__var_indirob_autoquote, 5, 0, 95),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__var_indirob_autoquote, 5, 0, 95),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__indirob, 1, 0, 0),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__indirob, 1, 0, 0),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__var_indirob_autoquote, 4, 0, 78),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__var_indirob_autoquote, 4, 0, 78),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ident_special, 1, 0, 0),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ident_special, 1, 0, 0),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ident_special, 2, 0, 0),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ident_special, 2, 0, 0),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scalar, 2, 0, 0),
  [2915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_container_variable, 2, 0, 0),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scalar, 2, 0, 0),
  [2919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__var_indirob, 1, 0, 0),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__var_indirob, 1, 0, 0),
  [2923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__var_indirob, 1, 0, 14),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__var_indirob, 1, 0, 14),
  [2927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indirect_object, 1, 0, 0),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term, 1, 0, 0),
  [2931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__term, 1, 0, 0), REDUCE(sym_indirect_object, 1, 0, 0),
  [2934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indirect_object, 1, 0, 0),
  [2936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term, 1, 0, 0),
  [2938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambiguous_function_call_expression, 2, 0, 23),
  [2940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambiguous_function_call_expression, 2, 0, 23),
  [2942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__version, 1, 0, 0),
  [2944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive, 1, 0, 0),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__version, 1, 0, 0),
  [2948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_statement, 5, 0, 86),
  [2950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_statement, 5, 0, 86),
  [2952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_conditional_statement, 5, 0, 86), SHIFT(2921),
  [2955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_conditional_statement, 5, 0, 86), SHIFT(3252),
  [2958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 5, 0, 86),
  [2960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsif, 5, 0, 86),
  [2962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsif, 5, 0, 86), SHIFT(2921),
  [2965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsif, 5, 0, 86), SHIFT(3252),
  [2968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 12),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 12),
  [2972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2771),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 51),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 51),
  [2980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [2982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_conditional_statement, 5, 0, 86), SHIFT(2992),
  [2985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_conditional_statement, 5, 0, 86), SHIFT(3309),
  [2988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsif, 5, 0, 86), SHIFT(2992),
  [2991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsif, 5, 0, 86), SHIFT(3309),
  [2994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, 0, 107),
  [2996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, 0, 107),
  [2998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 134),
  [3002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 134),
  [3004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 134), SHIFT(2896),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 2, 0, 13),
  [3009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 2, 0, 13),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 133),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 133),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 10, 0, 132),
  [3017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 10, 0, 132),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 6, 0, 0),
  [3021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 6, 0, 0),
  [3023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 6, 0, 0), SHIFT(2889),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 10, 0, 131),
  [3028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 10, 0, 131),
  [3030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 10, 0, 130),
  [3032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 10, 0, 130),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 129),
  [3036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 129),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 11, 0, 135),
  [3040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 11, 0, 135),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11, 0, 136),
  [3044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11, 0, 136),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 4, 0, 54),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_statement, 4, 0, 54),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 128),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 128),
  [3054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 128), SHIFT(2729),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 6, 0, 86),
  [3059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsif, 6, 0, 86),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 12, 0, 137),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 12, 0, 137),
  [3065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__PERLY_BRACE_OPEN, 1, 0, 0),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__PERLY_BRACE_OPEN, 1, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 97),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 97),
  [3073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 97), SHIFT(2761),
  [3076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_declaration_statement, 5, 0, 77),
  [3078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine_declaration_statement, 5, 0, 77),
  [3080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 9, 0, 127),
  [3082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 9, 0, 127),
  [3084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 9, 0, 127), SHIFT(3037),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__barestmt, 1, 0, 0),
  [3089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__barestmt, 1, 0, 0),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 9, 0, 126),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 9, 0, 126),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 9, 0, 125),
  [3097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 9, 0, 125),
  [3099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 9, 0, 124),
  [3101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 9, 0, 124),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__barestmt, 1, 0, 3),
  [3105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__barestmt, 1, 0, 3),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [3109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 9, 0, 123),
  [3113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 9, 0, 123),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fullstmt, 1, 0, 0),
  [3117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fullstmt, 1, 0, 0),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_label, 3, 0, 43),
  [3121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_label, 3, 0, 43),
  [3123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 122),
  [3125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 122),
  [3127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_statement, 4, 0, 45),
  [3129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_statement, 4, 0, 45),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 121),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 121),
  [3135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 121), SHIFT(2904),
  [3138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 4, 0, 27),
  [3140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 4, 0, 27),
  [3142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 4, 0, 45),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 4, 0, 45),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 8, 0, 120),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 120),
  [3150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 120), SHIFT(2894),
  [3153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 8, 0, 119),
  [3155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 119),
  [3157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 119), SHIFT(2884),
  [3160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration_statement, 5, 0, 76),
  [3162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration_statement, 5, 0, 76),
  [3164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 8, 0, 118),
  [3166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 118),
  [3168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 118), SHIFT(2802),
  [3171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 8, 0, 117),
  [3173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 117),
  [3175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_statement, 7, 0, 116),
  [3177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_statement, 7, 0, 116),
  [3179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 4, 0, 34),
  [3181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_statement, 4, 0, 34),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 5, 0, 45),
  [3185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 5, 0, 45),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 113),
  [3189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 113),
  [3191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 113), SHIFT(2786),
  [3194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_declaration_statement, 4, 0, 48),
  [3196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine_declaration_statement, 4, 0, 48),
  [3198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration_statement, 3, 0, 30),
  [3200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration_statement, 3, 0, 30),
  [3202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 112),
  [3204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 112),
  [3206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 5, 0, 74),
  [3208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 5, 0, 74),
  [3210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_statement, 6, 0, 86),
  [3212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_statement, 6, 0, 86),
  [3214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__else, 1, 0, 0),
  [3216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__else, 1, 0, 0),
  [3218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2, 0, 13),
  [3220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defer_statement, 2, 0, 13),
  [3222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_declaration_statement, 3, 0, 30),
  [3224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine_declaration_statement, 3, 0, 30),
  [3226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 3, 0, 27),
  [3228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 3, 0, 27),
  [3230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_statement, 3, 0, 27),
  [3232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_statement, 3, 0, 27),
  [3234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_declaration_statement, 5, 0, 76),
  [3236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine_declaration_statement, 5, 0, 76),
  [3238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_version_statement, 3, 0, 35),
  [3240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_version_statement, 3, 0, 35),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 3, 0, 34),
  [3244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_statement, 3, 0, 34),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 80),
  [3248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 80),
  [3250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 80), SHIFT(2892),
  [3253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration_statement, 4, 0, 48),
  [3255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration_statement, 4, 0, 48),
  [3257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [3259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [3261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_statement, 5, 0, 86),
  [3263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_statement, 5, 0, 86),
  [3265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_loop_statement, 5, 0, 86), SHIFT(2844),
  [3268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 5, 0, 54),
  [3270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_statement, 5, 0, 54),
  [3272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 7, 0, 111),
  [3274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 111),
  [3276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 111), SHIFT(2750),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration_statement, 6, 0, 93),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration_statement, 6, 0, 93),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__semicolon, 1, 0, 0),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__semicolon, 1, 0, 0),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 6, 0, 92),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 6, 0, 92),
  [3291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 7, 0, 110),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 110),
  [3295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 110), SHIFT(2753),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 52),
  [3300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 52),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_phaser_statement, 2, 0, 21),
  [3304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_phaser_statement, 2, 0, 21),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___DATA__, 3, 0, 36),
  [3308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___DATA__, 3, 0, 36),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration_statement, 5, 0, 77),
  [3312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration_statement, 5, 0, 77),
  [3314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cstyle_for_statement, 7, 0, 109),
  [3316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 109),
  [3318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 109), SHIFT(2755),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__barestmt, 2, 0, 0),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__barestmt, 2, 0, 0),
  [3325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___DATA__, 2, 0, 7),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___DATA__, 2, 0, 7),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 94),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 94),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_declaration_statement, 6, 0, 93),
  [3335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine_declaration_statement, 6, 0, 93),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2974),
  [3341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 6, 0, 0), SHIFT(2990),
  [3344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 128), SHIFT(2958),
  [3347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 9, 0, 127), SHIFT(2959),
  [3350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 121), SHIFT(2962),
  [3353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 120), SHIFT(2963),
  [3356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 119), SHIFT(2965),
  [3359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 8, 0, 118), SHIFT(2966),
  [3362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 113), SHIFT(2967),
  [3365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 111), SHIFT(2970),
  [3368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 110), SHIFT(2971),
  [3371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_cstyle_for_statement, 7, 0, 109), SHIFT(2973),
  [3374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 134), SHIFT(2957),
  [3377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 97), SHIFT(2975),
  [3380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_loop_statement, 5, 0, 86), SHIFT(2991),
  [3383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 80), SHIFT(2994),
  [3386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package, 1, 0, 0),
  [3388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package, 1, 0, 0),
  [3390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__HASHBRACK, 1, 0, 0),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__HASHBRACK, 1, 0, 0),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [3402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(1139),
  [3405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2714),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0),
  [3410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [3416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attrlist, 1, 0, 0),
  [3418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attrlist, 1, 0, 0),
  [3420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attrlist, 2, 0, 0),
  [3422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attrlist, 2, 0, 0),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 11),
  [3436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, 0, 11),
  [3438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 10),
  [3440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, 0, 10),
  [3442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_name, 1, 0, 0),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_name, 1, 0, 0),
  [3446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 1, 0, 29),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 29),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func0op_call_expression, 1, 0, 1),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [3456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func0op_call_expression, 1, 0, 1),
  [3458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_expression, 4, 0, 61),
  [3460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_expression, 4, 0, 61),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [3474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_slice_expression, 6, 0, 19),
  [3476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_slice_expression, 6, 0, 19),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subscripted, 1, 0, 0),
  [3480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subscripted, 1, 0, 0),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_slice_expression, 4, 0, 67),
  [3490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_slice_expression, 4, 0, 67),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_expression, 5, 0, 89),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_expression, 5, 0, 89),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_expression, 4, 0, 63),
  [3498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_expression, 4, 0, 63),
  [3500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 1, 0, 0),
  [3502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attrlist_repeat1, 1, 0, 0),
  [3504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_coderef_call_expression, 3, 0, 0),
  [3506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_coderef_call_expression, 3, 0, 0),
  [3508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_element_expression, 4, 0, 62),
  [3510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_element_expression, 4, 0, 62),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_element_expression, 5, 0, 87),
  [3514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_element_expression, 5, 0, 87),
  [3516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_slice_expression, 5, 0, 0),
  [3518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_slice_expression, 5, 0, 0),
  [3520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 5, 0, 106),
  [3522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5, 0, 106),
  [3524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_coderef_call_expression, 5, 0, 88),
  [3526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_coderef_call_expression, 5, 0, 88),
  [3528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_element_expression, 4, 0, 59),
  [3530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_element_expression, 4, 0, 59),
  [3532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_coderef_call_expression, 4, 0, 60),
  [3534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_coderef_call_expression, 4, 0, 60),
  [3536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_coderef_call_expression, 4, 0, 0),
  [3538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_coderef_call_expression, 4, 0, 0),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [3544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyval_container_variable, 2, 0, 0),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 2, 0, 0),
  [3548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 2, 0, 0),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [3552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_container_variable, 2, 0, 0),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [3556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [3558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_variable, 2, 0, 0),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [3562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 11),
  [3564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 11),
  [3566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution_regexp, 4, 0, 37),
  [3568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution_regexp, 4, 0, 37),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [3572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stub_expression, 2, 0, 0),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [3576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stub_expression, 2, 0, 0),
  [3578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution_regexp, 5, 0, 58),
  [3580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution_regexp, 5, 0, 58),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transliteration_expression, 5, 0, 85),
  [3586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transliteration_expression, 5, 0, 85),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [3590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_call_expression, 3, 0, 41),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_call_expression, 3, 0, 41),
  [3596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 1, 0, 0),
  [3598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 1, 0, 0),
  [3600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 4, 0, 58),
  [3602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 4, 0, 58),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [3606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0),
  [3608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(149),
  [3611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varname, 1, 0, 0),
  [3615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varname, 1, 0, 0),
  [3617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transliteration_expression, 5, 0, 84),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transliteration_expression, 5, 0, 84),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term_rightward, 2, 0, 0),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term_rightward, 2, 0, 0),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func1op_call_expression, 4, 0, 18),
  [3639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func1op_call_expression, 4, 0, 18),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_variable_list, 3, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__decl_variable_list, 3, 0, 0),
  [3645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__listexpr, 1, 0, 0), REDUCE(sym__term_rightward, 1, 0, 0),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [3674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__listexpr, 1, 0, 0), REDUCE(sym__term_rightward, 1, 0, 0),
  [3695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_regexp, 3, 0, 0),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_regexp, 3, 0, 0),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_regexp, 4, 0, 56),
  [3703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_regexp, 4, 0, 56),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution_regexp, 6, 0, 99),
  [3709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution_regexp, 6, 0, 99),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transliteration_expression, 4, 0, 37),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transliteration_expression, 4, 0, 37),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_word_list, 4, 0, 0),
  [3721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_word_list, 4, 0, 0),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 10),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 10),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 1, 0, 0),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 1, 0, 0),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [3735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 3, 0, 37),
  [3737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 3, 0, 37),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declare_hash, 2, 0, 0),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declare_hash, 2, 0, 0),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declare_array, 2, 0, 0),
  [3747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declare_array, 2, 0, 0),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution_regexp, 5, 0, 84),
  [3751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution_regexp, 5, 0, 84),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [3755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_variable_list, 4, 0, 0),
  [3757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__decl_variable_list, 4, 0, 0),
  [3759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func1op_call_expression, 4, 0, 1),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [3763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func1op_call_expression, 4, 0, 1),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 3, 0, 26),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 3, 0, 26),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transliteration_expression, 6, 0, 102),
  [3773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transliteration_expression, 6, 0, 102),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func1op_call_expression, 3, 0, 1),
  [3779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func1op_call_expression, 3, 0, 1),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 2, 0, 0),
  [3783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 2, 0, 0),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [3789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term_rightward, 1, 0, 0),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [3793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term_rightward, 1, 0, 0),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func1op_call_expression, 5, 0, 18),
  [3797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func1op_call_expression, 5, 0, 18),
  [3799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_variable_list, 2, 0, 0),
  [3801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__decl_variable_list, 2, 0, 0),
  [3803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term, 3, 0, 0),
  [3805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term, 3, 0, 0),
  [3807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declare_scalar, 2, 0, 0),
  [3809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declare_scalar, 2, 0, 0),
  [3811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_word_list, 3, 0, 0),
  [3813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_word_list, 3, 0, 0),
  [3815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_subroutine_expression, 2, 0, 9),
  [3817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_subroutine_expression, 2, 0, 9),
  [3819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_deref_expression, 4, 0, 0),
  [3821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_deref_expression, 4, 0, 0),
  [3823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 38),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [3827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 38),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [3831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_expression, 3, 0, 38),
  [3833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_expression, 3, 0, 38),
  [3835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 38),
  [3837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 38),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 5, 0, 82),
  [3841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 5, 0, 82),
  [3843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_regexp, 5, 0, 81),
  [3845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_regexp, 5, 0, 81),
  [3847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyval_expression, 4, 0, 64),
  [3849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyval_expression, 4, 0, 64),
  [3851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyval_expression, 4, 0, 65),
  [3853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyval_expression, 4, 0, 65),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sort_expression, 6, 0, 96),
  [3857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sort_expression, 6, 0, 96),
  [3859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scalar_deref_expression, 4, 0, 0),
  [3861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scalar_deref_expression, 4, 0, 0),
  [3863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution_regexp, 6, 0, 98),
  [3865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution_regexp, 6, 0, 98),
  [3867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive, 1, 0, 0),
  [3869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution_regexp, 6, 0, 100),
  [3871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution_regexp, 6, 0, 100),
  [3873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 4, 0, 0),
  [3875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 4, 0, 0),
  [3877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transliteration_expression, 6, 0, 101),
  [3879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transliteration_expression, 6, 0, 101),
  [3881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_hash_expression, 3, 0, 0),
  [3883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_hash_expression, 3, 0, 0),
  [3885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equality_expression, 3, 0, 38),
  [3887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equality_expression, 3, 0, 38),
  [3889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__listop, 1, 0, 0),
  [3891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__listop, 1, 0, 0),
  [3893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 5, 0, 75),
  [3895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 5, 0, 75),
  [3897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0),
  [3899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0),
  [3901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func0op_call_expression, 3, 0, 1),
  [3903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func0op_call_expression, 3, 0, 1),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [3909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambiguous_function_call_expression, 3, 0, 42),
  [3911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambiguous_function_call_expression, 3, 0, 42),
  [3913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 4, 0, 44),
  [3915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 4, 0, 44),
  [3917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transliteration_expression, 6, 0, 100),
  [3919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transliteration_expression, 6, 0, 100),
  [3921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 17),
  [3923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 17),
  [3925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 2, 0, 16),
  [3927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 2, 0, 16),
  [3929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readline_expression, 2, 0, 15),
  [3931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readline_expression, 2, 0, 15),
  [3933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_array_expression, 2, 0, 0),
  [3935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_array_expression, 2, 0, 0),
  [3937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 6, 0, 103),
  [3939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 6, 0, 103),
  [3941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 3, 0, 28),
  [3943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 3, 0, 28),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [3949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_subroutine_expression, 4, 0, 46),
  [3951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_subroutine_expression, 4, 0, 46),
  [3953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 6, 0, 71),
  [3955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 6, 0, 71),
  [3957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_subroutine_expression, 4, 0, 47),
  [3959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_subroutine_expression, 4, 0, 47),
  [3961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transliteration_expression, 7, 0, 115),
  [3963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transliteration_expression, 7, 0, 115),
  [3965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_subroutine_expression, 3, 0, 28),
  [3967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_subroutine_expression, 3, 0, 28),
  [3969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 6, 0, 70),
  [3971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 6, 0, 70),
  [3973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution_regexp, 7, 0, 114),
  [3975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution_regexp, 7, 0, 114),
  [3977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambiguous_function_call_expression, 4, 0, 66),
  [3979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambiguous_function_call_expression, 4, 0, 66),
  [3981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyval_expression, 6, 0, 71),
  [3983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyval_expression, 6, 0, 71),
  [3985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 3, 0, 25),
  [3987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 3, 0, 25),
  [3989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_string, 3, 0, 0),
  [3991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_string, 3, 0, 0),
  [3993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glob, 2, 0, 0),
  [3995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glob, 2, 0, 0),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preinc_expression, 2, 0, 17),
  [3999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preinc_expression, 2, 0, 17),
  [4001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_preinc_expression, 2, 0, 17), SHIFT(1329),
  [4004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_refgen_expression, 2, 0, 0),
  [4006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_refgen_expression, 2, 0, 0),
  [4008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_expression, 2, 0, 0),
  [4010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_expression, 2, 0, 0),
  [4012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_literal, 3, 0, 0),
  [4014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_literal, 3, 0, 0),
  [4016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyval_expression, 6, 0, 70),
  [4018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyval_expression, 6, 0, 70),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_call_expression, 6, 0, 104),
  [4022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_call_expression, 6, 0, 104),
  [4024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [4026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [4028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_subroutine_expression, 5, 0, 75),
  [4030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_subroutine_expression, 5, 0, 75),
  [4032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_array_expression, 3, 0, 0),
  [4034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_array_expression, 3, 0, 0),
  [4036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_call_expression, 5, 0, 41),
  [4038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_call_expression, 5, 0, 41),
  [4040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 4, 0, 46),
  [4042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 4, 0, 46),
  [4044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sort_expression, 3, 0, 33),
  [4046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sort_expression, 3, 0, 33),
  [4048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambiguous_function_call_expression, 2, 0, 24),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [4052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambiguous_function_call_expression, 2, 0, 24),
  [4054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_expression, 6, 0, 103),
  [4056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_expression, 6, 0, 103),
  [4058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_grep_expression, 3, 0, 33),
  [4060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_grep_expression, 3, 0, 33),
  [4062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eval_expression, 2, 0, 0),
  [4064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eval_expression, 2, 0, 0),
  [4066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_localization_expression, 2, 0, 0),
  [4068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_localization_expression, 2, 0, 0),
  [4070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_deref_expression, 4, 0, 0),
  [4072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_deref_expression, 4, 0, 0),
  [4074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 4, 0, 47),
  [4076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 4, 0, 47),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [4080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func1op_call_expression, 3, 0, 18),
  [4082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func1op_call_expression, 3, 0, 18),
  [4084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fat_comma_autoquoted_bareword, 3, 2, 32),
  [4086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fat_comma_autoquoted_bareword, 3, 2, 32),
  [4088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_expression, 2, 0, 0),
  [4090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_require_expression, 2, 0, 0),
  [4092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readline_expression, 3, 0, 31),
  [4094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readline_expression, 3, 0, 31),
  [4096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sort_expression, 5, 0, 79),
  [4098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sort_expression, 5, 0, 79),
  [4100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_string, 4, 0, 0),
  [4102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_string, 4, 0, 0),
  [4104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_amper_deref_expression, 4, 0, 0),
  [4106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_amper_deref_expression, 4, 0, 0),
  [4108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glob_deref_expression, 4, 0, 0),
  [4110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glob_deref_expression, 4, 0, 0),
  [4112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [4114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [4116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sort_expression, 2, 0, 19),
  [4118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sort_expression, 2, 0, 19),
  [4120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postinc_expression, 2, 0, 22),
  [4122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postinc_expression, 2, 0, 22),
  [4124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(1370),
  [4127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2635),
  [4130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_literal, 2, 0, 0),
  [4132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_literal, 2, 0, 0),
  [4134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transliteration_expression, 5, 0, 83),
  [4136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transliteration_expression, 5, 0, 83),
  [4138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_string, 2, 0, 0),
  [4140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_string, 2, 0, 0),
  [4142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_grep_expression, 4, 0, 53),
  [4144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_grep_expression, 4, 0, 53),
  [4146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 2, 0, 9),
  [4148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 2, 0, 9),
  [4150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_regexp, 4, 0, 57),
  [4152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_regexp, 4, 0, 57),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 90),
  [4156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 90),
  [4158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fat_comma_autoquoted_bareword, 2, 2, 8),
  [4160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fat_comma_autoquoted_bareword, 2, 2, 8),
  [4162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_expression, 5, 0, 91),
  [4164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call_expression, 5, 0, 91),
  [4166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_heredoc_token, 2, 0, 0),
  [4168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_heredoc_token, 2, 0, 0),
  [4170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_literal, 4, 0, 0),
  [4172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_literal, 4, 0, 0),
  [4174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_hash_expression, 2, 0, 0),
  [4176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_hash_expression, 2, 0, 0),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_token, 2, 0, 0),
  [4180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc_token, 2, 0, 0),
  [4182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_expression, 6, 0, 105),
  [4184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call_expression, 6, 0, 105),
  [4186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_expression, 4, 0, 1),
  [4188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call_expression, 4, 0, 1),
  [4190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tricky_indirob_hashref, 4, 0, 0),
  [4192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tricky_indirob_hashref, 4, 0, 0),
  [4194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_regexp, 4, 0, 55),
  [4196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_regexp, 4, 0, 55),
  [4198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_grep_expression, 6, 0, 96),
  [4200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_grep_expression, 6, 0, 96),
  [4202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, 0, 64),
  [4204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, 0, 64),
  [4206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_grep_expression, 7, 0, 108),
  [4208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_grep_expression, 7, 0, 108),
  [4210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equality_expression, 6, 0, 103),
  [4212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equality_expression, 6, 0, 103),
  [4214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func1op_call_expression, 2, 0, 1),
  [4216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func1op_call_expression, 2, 0, 1),
  [4218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 49),
  [4220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 49),
  [4222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution_regexp, 5, 0, 83),
  [4224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution_regexp, 5, 0, 83),
  [4226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, 0, 65),
  [4228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, 0, 65),
  [4230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__label_arg, 1, 0, 0),
  [4232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__label_arg, 1, 0, 0),
  [4234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_expression, 2, 0, 0),
  [4236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_expression, 2, 0, 0),
  [4238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__label_arg, 1, 0, 20),
  [4240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__label_arg, 1, 0, 20),
  [4242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 2, 0, 0),
  [4244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 2, 0, 0),
  [4246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef_expression, 2, 0, 0),
  [4248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_undef_expression, 2, 0, 0),
  [4250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 50),
  [4252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 50),
  [4254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arraylen, 2, 0, 0),
  [4256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arraylen, 2, 0, 0),
  [4258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loopex_expression, 2, 0, 2),
  [4260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loopex_expression, 2, 0, 2),
  [4262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(1382),
  [4265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2712),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [4314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [4334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [4364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(147),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2634),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [4417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(1618),
  [4420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2634),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [4445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [4447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [4449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [4451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [4455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [4457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [4461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [4463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [4465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [4467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [4485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(135),
  [4488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(1654),
  [4491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2644),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_preinc_expression, 2, 0, 17), SHIFT(1497),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [4547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(181),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [4652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [4654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(195),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [4701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [4703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [4705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [4711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [4713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [4715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [4717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [4719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [4721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [4739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(204),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [4750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_preinc_expression, 2, 0, 17), SHIFT(1823),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [4755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [4781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [4783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [4785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [4793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [4797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [4801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [4841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [4845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [4851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [4853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [4863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [4865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [4867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [4883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [4945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0), SHIFT_REPEAT(2303),
  [4948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0), SHIFT_REPEAT(2143),
  [4951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0), SHIFT_REPEAT(2070),
  [4954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0),
  [4956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0), SHIFT_REPEAT(2263),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [4973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0), SHIFT_REPEAT(2270),
  [4976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0), SHIFT_REPEAT(2136),
  [4979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0), SHIFT_REPEAT(2094),
  [4982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 2, 0, 0), SHIFT_REPEAT(2318),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [5019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_content, 2, 0, 0), SHIFT_REPEAT(2351),
  [5022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_content, 2, 0, 0), SHIFT_REPEAT(2197),
  [5025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_content, 2, 0, 0), SHIFT_REPEAT(2095),
  [5028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_content, 2, 0, 0),
  [5030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_content, 2, 0, 0), SHIFT_REPEAT(2342),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [5079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_content_repeat1, 2, 0, 0), SHIFT_REPEAT(2430),
  [5082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_content_repeat1, 2, 0, 0), SHIFT_REPEAT(2202),
  [5085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_content_repeat1, 2, 0, 0), SHIFT_REPEAT(2071),
  [5088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_content_repeat1, 2, 0, 0), SHIFT_REPEAT(2385),
  [5091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_content_repeat1, 2, 0, 0),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [5101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(319),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [5110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [5112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [5116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [5120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [5128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolations, 1, 0, 0),
  [5130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolations, 1, 0, 0),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [5156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [5168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [5190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [5204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(3185),
  [5207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(3277),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [5222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1, 0, 0),
  [5224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1, 0, 0),
  [5226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lowprec_logical_expression, 3, 0, 38),
  [5228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lowprec_logical_expression, 3, 0, 38),
  [5230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(3288),
  [5233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__listexpr, 1, 0, 0),
  [5235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__listexpr, 1, 0, 0),
  [5237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_expression, 1, 0, 0),
  [5239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_expression, 1, 0, 0),
  [5241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [5243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [5245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [5257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [5259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [5261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [5265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [5267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [5269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [5273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [5287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [5289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [5293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [5295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [5297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [5301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [5303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2691),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [5309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [5313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [5317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [5319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [5349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_element_interpolation, 4, 0, 68),
  [5351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_element_interpolation, 4, 0, 68),
  [5353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_element_interpolation, 4, 0, 69),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_element_interpolation, 4, 0, 69),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [5359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_element_interpolation, 4, 0, 59),
  [5361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_element_interpolation, 4, 0, 59),
  [5363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_element_interpolation, 4, 0, 61),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_element_interpolation, 4, 0, 61),
  [5367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [5393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subscripted_interpolations, 1, 0, 4),
  [5395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subscripted_interpolations, 1, 0, 4),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [5415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subscripted_interpolations, 1, 0, 5),
  [5417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subscripted_interpolations, 1, 0, 5),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [5437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__decl_variable_list_repeat1, 2, 0, 0),
  [5439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__decl_variable_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2478),
  [5442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__decl_variable_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2544),
  [5445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__decl_variable_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2547),
  [5448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__decl_variable_list_repeat1, 2, 0, 0), SHIFT_REPEAT(615),
  [5451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__decl_variable_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2551),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [5478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [5480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(320),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [5501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0), SHIFT_REPEAT(2341),
  [5504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0), SHIFT_REPEAT(3279),
  [5507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0), SHIFT_REPEAT(2626),
  [5510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0),
  [5512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0), SHIFT_REPEAT(2361),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [5525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0), SHIFT_REPEAT(2351),
  [5528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0), SHIFT_REPEAT(3202),
  [5531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0), SHIFT_REPEAT(2513),
  [5534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 2, 0, 0), SHIFT_REPEAT(2336),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [5543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [5545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3024),
  [5547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [5549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_expression_interpolation, 4, 0, 70),
  [5551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_expression_interpolation, 4, 0, 71),
  [5553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_expression_interpolation, 4, 0, 72),
  [5555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_expression_interpolation, 4, 0, 73),
  [5557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [5559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_regexp_content, 1, 0, 0),
  [5561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolations, 1, 0, 6),
  [5563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolation_fallbacks, 1, 0, 0),
  [5565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolation_fallbacks, 2, 0, 0),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [5571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__braced_array, 3, 0, 0),
  [5573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__braced_scalar, 3, 0, 0),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_transliteration_content, 1, 0, 0),
  [5587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_content, 1, 0, 0),
  [5589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2474),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [5595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(330),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2671),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [5612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quotelike_middle, 2, 0, 0),
  [5614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2439),
  [5617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2671),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [5634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_for_expression, 3, 0, 39),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [5640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [5642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_content_repeat1, 1, 0, 0),
  [5644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_conditional_expression, 3, 0, 40),
  [5646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [5648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2474),
  [5651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2721),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_loop_expression, 3, 0, 40),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [5680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_expressions, 1, 0, 0),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [5684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yadayada, 1, 0, 0),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [5688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__decl_variable_list_repeat1, 1, 0, 0),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3282),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [5708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(554),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [5727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [5729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [5735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [5743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [5757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [5759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [5761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0),
  [5763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2936),
  [5766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2176),
  [5769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__noninterpolated_string_content, 2, 0, 0),
  [5771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__noninterpolated_string_content, 2, 0, 0), SHIFT_REPEAT(2694),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [5786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__noninterpolated_string_content, 2, 0, 0), SHIFT_REPEAT(2657),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [5793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__noninterpolated_string_content, 1, 0, 0),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [5827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term_rightward_repeat1, 2, 0, 0), SHIFT_REPEAT(558),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_key, 1, 0, 0),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [6046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 1, 0, 0),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [6144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tricky_hashref, 5, 0, 0),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [6170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3156),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [6308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__brace_autoquoted, 3, 0, 32),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [6370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__brace_autoquoted, 2, 0, 8),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [6394] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [6516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_content, 3, 0, 0),
  [6518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_content, 2, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__apostrophe = 0,
  ts_external_token__double_quote = 1,
  ts_external_token__backtick = 2,
  ts_external_token__search_slash = 3,
  ts_external_token__PERLY_SEMICOLON = 4,
  ts_external_token__PERLY_HEREDOC = 5,
  ts_external_token__ctrl_z_hack = 6,
  ts_external_token__quotelike_begin = 7,
  ts_external_token__quotelike_middle_close = 8,
  ts_external_token__quotelike_middle_skip = 9,
  ts_external_token__quotelike_end_zw = 10,
  ts_external_token__quotelike_end = 11,
  ts_external_token__q_string_content = 12,
  ts_external_token__qq_string_content = 13,
  ts_external_token_escape_sequence = 14,
  ts_external_token_escaped_delimiter = 15,
  ts_external_token__dollar_in_regexp = 16,
  ts_external_token_pod = 17,
  ts_external_token__gobbled_content = 18,
  ts_external_token__attribute_value_begin = 19,
  ts_external_token_attribute_value = 20,
  ts_external_token_prototype_or_signature = 21,
  ts_external_token__heredoc_delimiter = 22,
  ts_external_token__command_heredoc_delimiter = 23,
  ts_external_token__heredoc_start = 24,
  ts_external_token__heredoc_middle = 25,
  ts_external_token_heredoc_end = 26,
  ts_external_token__fat_comma_zw = 27,
  ts_external_token__brace_end_zw = 28,
  ts_external_token__dollar_ident_zw = 29,
  ts_external_token__no_interp_whitespace_zw = 30,
  ts_external_token__NONASSOC = 31,
  ts_external_token__ERROR = 32,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__apostrophe] = sym__apostrophe,
  [ts_external_token__double_quote] = sym__double_quote,
  [ts_external_token__backtick] = sym__backtick,
  [ts_external_token__search_slash] = sym__search_slash,
  [ts_external_token__PERLY_SEMICOLON] = sym__PERLY_SEMICOLON,
  [ts_external_token__PERLY_HEREDOC] = sym__PERLY_HEREDOC,
  [ts_external_token__ctrl_z_hack] = sym__ctrl_z_hack,
  [ts_external_token__quotelike_begin] = sym__quotelike_begin,
  [ts_external_token__quotelike_middle_close] = sym__quotelike_middle_close,
  [ts_external_token__quotelike_middle_skip] = sym__quotelike_middle_skip,
  [ts_external_token__quotelike_end_zw] = sym__quotelike_end_zw,
  [ts_external_token__quotelike_end] = sym__quotelike_end,
  [ts_external_token__q_string_content] = sym__q_string_content,
  [ts_external_token__qq_string_content] = sym__qq_string_content,
  [ts_external_token_escape_sequence] = sym_escape_sequence,
  [ts_external_token_escaped_delimiter] = sym_escaped_delimiter,
  [ts_external_token__dollar_in_regexp] = sym__dollar_in_regexp,
  [ts_external_token_pod] = sym_pod,
  [ts_external_token__gobbled_content] = sym__gobbled_content,
  [ts_external_token__attribute_value_begin] = sym__attribute_value_begin,
  [ts_external_token_attribute_value] = sym_attribute_value,
  [ts_external_token_prototype_or_signature] = sym_prototype_or_signature,
  [ts_external_token__heredoc_delimiter] = sym__heredoc_delimiter,
  [ts_external_token__command_heredoc_delimiter] = sym__command_heredoc_delimiter,
  [ts_external_token__heredoc_start] = sym__heredoc_start,
  [ts_external_token__heredoc_middle] = sym__heredoc_middle,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token__fat_comma_zw] = sym__fat_comma_zw,
  [ts_external_token__brace_end_zw] = sym__brace_end_zw,
  [ts_external_token__dollar_ident_zw] = sym__dollar_ident_zw,
  [ts_external_token__no_interp_whitespace_zw] = sym__no_interp_whitespace_zw,
  [ts_external_token__NONASSOC] = sym__NONASSOC,
  [ts_external_token__ERROR] = sym__ERROR,
};

static const bool ts_external_scanner_states[60][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token__quotelike_middle_close] = true,
    [ts_external_token__quotelike_middle_skip] = true,
    [ts_external_token__quotelike_end_zw] = true,
    [ts_external_token__quotelike_end] = true,
    [ts_external_token__q_string_content] = true,
    [ts_external_token__qq_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token__dollar_in_regexp] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__gobbled_content] = true,
    [ts_external_token__attribute_value_begin] = true,
    [ts_external_token_attribute_value] = true,
    [ts_external_token_prototype_or_signature] = true,
    [ts_external_token__heredoc_delimiter] = true,
    [ts_external_token__command_heredoc_delimiter] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token__fat_comma_zw] = true,
    [ts_external_token__brace_end_zw] = true,
    [ts_external_token__dollar_ident_zw] = true,
    [ts_external_token__no_interp_whitespace_zw] = true,
    [ts_external_token__NONASSOC] = true,
    [ts_external_token__ERROR] = true,
  },
  [2] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [3] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [4] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [5] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [6] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [7] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [8] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [9] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [10] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [11] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__NONASSOC] = true,
  },
  [12] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [13] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__double_quote] = true,
    [ts_external_token__backtick] = true,
    [ts_external_token__search_slash] = true,
    [ts_external_token__PERLY_HEREDOC] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [14] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [15] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [16] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token_prototype_or_signature] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [17] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__attribute_value_begin] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [18] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [19] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [20] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__ctrl_z_hack] = true,
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [21] = {
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [22] = {
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [23] = {
    [ts_external_token_pod] = true,
    [ts_external_token_prototype_or_signature] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [24] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [25] = {
    [ts_external_token_pod] = true,
    [ts_external_token__attribute_value_begin] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [26] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [27] = {
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [28] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [29] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token_pod] = true,
    [ts_external_token_prototype_or_signature] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [30] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__attribute_value_begin] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [31] = {
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [32] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [33] = {
    [ts_external_token__PERLY_SEMICOLON] = true,
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
  },
  [34] = {
    [ts_external_token__quotelike_middle_close] = true,
    [ts_external_token__qq_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token__dollar_in_regexp] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [35] = {
    [ts_external_token__quotelike_end] = true,
    [ts_external_token__qq_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token__dollar_in_regexp] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [36] = {
    [ts_external_token__quotelike_end] = true,
    [ts_external_token__qq_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [37] = {
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [38] = {
    [ts_external_token__quotelike_middle_close] = true,
    [ts_external_token__qq_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token__dollar_in_regexp] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__NONASSOC] = true,
  },
  [39] = {
    [ts_external_token__quotelike_end] = true,
    [ts_external_token__qq_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token__dollar_in_regexp] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__NONASSOC] = true,
  },
  [40] = {
    [ts_external_token__quotelike_end] = true,
    [ts_external_token__qq_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__NONASSOC] = true,
  },
  [41] = {
    [ts_external_token__quotelike_end_zw] = true,
    [ts_external_token__quotelike_end] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__no_interp_whitespace_zw] = true,
  },
  [42] = {
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token__NONASSOC] = true,
  },
  [43] = {
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__dollar_ident_zw] = true,
  },
  [44] = {
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__no_interp_whitespace_zw] = true,
  },
  [45] = {
    [ts_external_token__quotelike_middle_close] = true,
    [ts_external_token__qq_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [46] = {
    [ts_external_token_pod] = true,
    [ts_external_token_prototype_or_signature] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [47] = {
    [ts_external_token_pod] = true,
    [ts_external_token_prototype_or_signature] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [48] = {
    [ts_external_token__quotelike_middle_close] = true,
    [ts_external_token__q_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [49] = {
    [ts_external_token_pod] = true,
    [ts_external_token__attribute_value_begin] = true,
    [ts_external_token_prototype_or_signature] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [50] = {
    [ts_external_token__quotelike_end] = true,
    [ts_external_token__q_string_content] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token_escaped_delimiter] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [51] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [52] = {
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__fat_comma_zw] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [53] = {
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_delimiter] = true,
    [ts_external_token__command_heredoc_delimiter] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [54] = {
    [ts_external_token__apostrophe] = true,
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [55] = {
    [ts_external_token__quotelike_begin] = true,
    [ts_external_token__quotelike_middle_skip] = true,
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [56] = {
    [ts_external_token_pod] = true,
    [ts_external_token_attribute_value] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [57] = {
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__brace_end_zw] = true,
  },
  [58] = {
    [ts_external_token_pod] = true,
    [ts_external_token__gobbled_content] = true,
    [ts_external_token__heredoc_start] = true,
  },
  [59] = {
    [ts_external_token_pod] = true,
    [ts_external_token__heredoc_start] = true,
    [ts_external_token__ERROR] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_perl_external_scanner_create(void);
void tree_sitter_perl_external_scanner_destroy(void *);
bool tree_sitter_perl_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_perl_external_scanner_serialize(void *, char *);
void tree_sitter_perl_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_perl(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_perl_external_scanner_create,
      tree_sitter_perl_external_scanner_destroy,
      tree_sitter_perl_external_scanner_scan,
      tree_sitter_perl_external_scanner_serialize,
      tree_sitter_perl_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
